#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 9178
#define LARGE_STATE_COUNT 2844
#define SYMBOL_COUNT 579
#define ALIAS_COUNT 5
#define TOKEN_COUNT 246
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 53
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 238

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_COLON = 42,
  anon_sym_SEMI = 43,
  anon_sym___extension__ = 44,
  anon_sym_typedef = 45,
  anon_sym_in = 46,
  anon_sym_out = 47,
  anon_sym_inout = 48,
  anon_sym_virtual = 49,
  anon_sym_extern = 50,
  anon_sym___attribute__ = 51,
  anon_sym___attribute = 52,
  anon_sym_using = 53,
  anon_sym_COLON_COLON = 54,
  anon_sym_LBRACK_LBRACK = 55,
  anon_sym_RBRACK_RBRACK = 56,
  anon_sym___declspec = 57,
  anon_sym___based = 58,
  anon_sym___cdecl = 59,
  anon_sym___clrcall = 60,
  anon_sym___stdcall = 61,
  anon_sym___fastcall = 62,
  anon_sym___thiscall = 63,
  anon_sym___vectorcall = 64,
  sym_ms_restrict_modifier = 65,
  sym_ms_unsigned_ptr_modifier = 66,
  sym_ms_signed_ptr_modifier = 67,
  anon_sym__unaligned = 68,
  anon_sym___unaligned = 69,
  anon_sym_LBRACE = 70,
  anon_sym_RBRACE = 71,
  anon_sym_signed = 72,
  anon_sym_unsigned = 73,
  anon_sym_long = 74,
  anon_sym_short = 75,
  anon_sym_LBRACK = 76,
  anon_sym_static = 77,
  anon_sym_RBRACK = 78,
  anon_sym_EQ = 79,
  anon_sym_register = 80,
  anon_sym_inline = 81,
  anon_sym___inline = 82,
  anon_sym___inline__ = 83,
  anon_sym___forceinline = 84,
  anon_sym_thread_local = 85,
  anon_sym___thread = 86,
  anon_sym_const = 87,
  anon_sym_constexpr = 88,
  anon_sym_volatile = 89,
  anon_sym_restrict = 90,
  anon_sym___restrict__ = 91,
  anon_sym__Atomic = 92,
  anon_sym__Noreturn = 93,
  anon_sym_noreturn = 94,
  anon_sym__Nonnull = 95,
  anon_sym_mutable = 96,
  anon_sym_constinit = 97,
  anon_sym_consteval = 98,
  anon_sym_alignas = 99,
  anon_sym__Alignas = 100,
  sym_primitive_type = 101,
  anon_sym_enum = 102,
  anon_sym_class = 103,
  anon_sym_struct = 104,
  anon_sym_union = 105,
  anon_sym_if = 106,
  anon_sym_else = 107,
  anon_sym_switch = 108,
  anon_sym_case = 109,
  anon_sym_default = 110,
  anon_sym_while = 111,
  anon_sym_do = 112,
  anon_sym_for = 113,
  anon_sym_return = 114,
  anon_sym_break = 115,
  anon_sym_continue = 116,
  anon_sym_goto = 117,
  anon_sym___try = 118,
  anon_sym___except = 119,
  anon_sym___finally = 120,
  anon_sym___leave = 121,
  anon_sym_QMARK = 122,
  anon_sym_STAR_EQ = 123,
  anon_sym_SLASH_EQ = 124,
  anon_sym_PERCENT_EQ = 125,
  anon_sym_PLUS_EQ = 126,
  anon_sym_DASH_EQ = 127,
  anon_sym_LT_LT_EQ = 128,
  anon_sym_GT_GT_EQ = 129,
  anon_sym_AMP_EQ = 130,
  anon_sym_CARET_EQ = 131,
  anon_sym_PIPE_EQ = 132,
  anon_sym_and_eq = 133,
  anon_sym_or_eq = 134,
  anon_sym_xor_eq = 135,
  anon_sym_not = 136,
  anon_sym_compl = 137,
  anon_sym_LT_EQ_GT = 138,
  anon_sym_or = 139,
  anon_sym_and = 140,
  anon_sym_bitor = 141,
  anon_sym_xor = 142,
  anon_sym_bitand = 143,
  anon_sym_not_eq = 144,
  anon_sym_DASH_DASH = 145,
  anon_sym_PLUS_PLUS = 146,
  anon_sym_sizeof = 147,
  anon_sym___alignof__ = 148,
  anon_sym___alignof = 149,
  anon_sym__alignof = 150,
  anon_sym_alignof = 151,
  anon_sym__Alignof = 152,
  anon_sym_offsetof = 153,
  anon_sym__Generic = 154,
  anon_sym_asm = 155,
  anon_sym___asm__ = 156,
  anon_sym___asm = 157,
  anon_sym___volatile__ = 158,
  anon_sym_DOT = 159,
  anon_sym_DOT_STAR = 160,
  anon_sym_DASH_GT = 161,
  sym_number_literal = 162,
  anon_sym_L_SQUOTE = 163,
  anon_sym_u_SQUOTE = 164,
  anon_sym_U_SQUOTE = 165,
  anon_sym_u8_SQUOTE = 166,
  anon_sym_SQUOTE = 167,
  aux_sym_char_literal_token1 = 168,
  anon_sym_L_DQUOTE = 169,
  anon_sym_u_DQUOTE = 170,
  anon_sym_U_DQUOTE = 171,
  anon_sym_u8_DQUOTE = 172,
  anon_sym_DQUOTE = 173,
  aux_sym_string_literal_token1 = 174,
  sym_escape_sequence = 175,
  sym_system_lib_string = 176,
  sym_true = 177,
  sym_false = 178,
  anon_sym_NULL = 179,
  anon_sym_nullptr = 180,
  sym_comment = 181,
  sym_auto = 182,
  anon_sym_decltype = 183,
  anon_sym_final = 184,
  anon_sym_override = 185,
  anon_sym_explicit = 186,
  anon_sym_typename = 187,
  anon_sym_export = 188,
  anon_sym_module = 189,
  anon_sym_import = 190,
  anon_sym_private = 191,
  anon_sym_template = 192,
  anon_sym_GT2 = 193,
  anon_sym_operator = 194,
  anon_sym_try = 195,
  anon_sym_delete = 196,
  aux_sym_pure_virtual_clause_token1 = 197,
  anon_sym_friend = 198,
  anon_sym_public = 199,
  anon_sym_protected = 200,
  anon_sym_noexcept = 201,
  anon_sym_throw = 202,
  anon_sym_namespace = 203,
  anon_sym_static_assert = 204,
  anon_sym_concept = 205,
  anon_sym_co_return = 206,
  anon_sym_co_yield = 207,
  anon_sym_catch = 208,
  anon_sym_R_DQUOTE = 209,
  anon_sym_LR_DQUOTE = 210,
  anon_sym_uR_DQUOTE = 211,
  anon_sym_UR_DQUOTE = 212,
  anon_sym_u8R_DQUOTE = 213,
  anon_sym_co_await = 214,
  anon_sym_new = 215,
  anon_sym_requires = 216,
  anon_sym_DASH_GT_STAR = 217,
  anon_sym_LPAREN_RPAREN = 218,
  anon_sym_LBRACK_RBRACK = 219,
  anon_sym_DQUOTE_DQUOTE = 220,
  sym_this = 221,
  sym_literal_suffix = 222,
  anon_sym_discard = 223,
  anon_sym_precise = 224,
  anon_sym_shared = 225,
  anon_sym_groupshared = 226,
  anon_sym_uniform = 227,
  anon_sym_row_major = 228,
  anon_sym_column_major = 229,
  anon_sym_globallycoherent = 230,
  anon_sym_centroid = 231,
  anon_sym_noperspective = 232,
  anon_sym_nointerpolation = 233,
  anon_sym_sample = 234,
  anon_sym_linear = 235,
  anon_sym_snorm = 236,
  anon_sym_unorm = 237,
  anon_sym_point = 238,
  anon_sym_line = 239,
  anon_sym_triangleadj = 240,
  anon_sym_lineadj = 241,
  anon_sym_triangle = 242,
  anon_sym_cbuffer = 243,
  sym_raw_string_delimiter = 244,
  sym_raw_string_content = 245,
  sym_translation_unit = 246,
  sym__top_level_item = 247,
  sym__block_item = 248,
  sym_preproc_include = 249,
  sym_preproc_def = 250,
  sym_preproc_function_def = 251,
  sym_preproc_params = 252,
  sym_preproc_call = 253,
  sym_preproc_if = 254,
  sym_preproc_ifdef = 255,
  sym_preproc_else = 256,
  sym_preproc_elif = 257,
  sym_preproc_elifdef = 258,
  sym_preproc_if_in_field_declaration_list = 259,
  sym_preproc_ifdef_in_field_declaration_list = 260,
  sym_preproc_else_in_field_declaration_list = 261,
  sym_preproc_elif_in_field_declaration_list = 262,
  sym_preproc_elifdef_in_field_declaration_list = 263,
  sym_preproc_if_in_enumerator_list = 264,
  sym_preproc_ifdef_in_enumerator_list = 265,
  sym_preproc_else_in_enumerator_list = 266,
  sym_preproc_elif_in_enumerator_list = 267,
  sym_preproc_elifdef_in_enumerator_list = 268,
  sym_preproc_if_in_enumerator_list_no_comma = 269,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 270,
  sym_preproc_else_in_enumerator_list_no_comma = 271,
  sym_preproc_elif_in_enumerator_list_no_comma = 272,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 273,
  sym__preproc_expression = 274,
  sym_preproc_parenthesized_expression = 275,
  sym_preproc_defined = 276,
  sym_preproc_unary_expression = 277,
  sym_preproc_call_expression = 278,
  sym_preproc_argument_list = 279,
  sym_preproc_binary_expression = 280,
  sym_function_definition = 281,
  sym_declaration = 282,
  sym_type_definition = 283,
  sym__type_definition_type = 284,
  sym__type_definition_declarators = 285,
  sym__declaration_modifiers = 286,
  sym__declaration_specifiers = 287,
  sym_linkage_specification = 288,
  sym_attribute_specifier = 289,
  sym_attribute = 290,
  sym_attribute_declaration = 291,
  sym_ms_declspec_modifier = 292,
  sym_ms_based_modifier = 293,
  sym_ms_call_modifier = 294,
  sym_ms_unaligned_ptr_modifier = 295,
  sym_ms_pointer_modifier = 296,
  sym_declaration_list = 297,
  sym__declarator = 298,
  sym__field_declarator = 299,
  sym__type_declarator = 300,
  sym__abstract_declarator = 301,
  sym_parenthesized_declarator = 302,
  sym_parenthesized_field_declarator = 303,
  sym_parenthesized_type_declarator = 304,
  sym_abstract_parenthesized_declarator = 305,
  sym_attributed_declarator = 306,
  sym_attributed_field_declarator = 307,
  sym_attributed_type_declarator = 308,
  sym_pointer_declarator = 309,
  sym_pointer_field_declarator = 310,
  sym_pointer_type_declarator = 311,
  sym_abstract_pointer_declarator = 312,
  sym_function_declarator = 313,
  sym_function_field_declarator = 314,
  sym_function_type_declarator = 315,
  sym_abstract_function_declarator = 316,
  sym_array_declarator = 317,
  sym_array_field_declarator = 318,
  sym_array_type_declarator = 319,
  sym_abstract_array_declarator = 320,
  sym_init_declarator = 321,
  sym_compound_statement = 322,
  sym_storage_class_specifier = 323,
  sym_type_qualifier = 324,
  sym_alignas_qualifier = 325,
  sym_type_specifier = 326,
  sym_sized_type_specifier = 327,
  sym_enum_specifier = 328,
  sym_enumerator_list = 329,
  sym_struct_specifier = 330,
  sym_union_specifier = 331,
  sym_field_declaration_list = 332,
  sym__field_declaration_list_item = 333,
  sym_field_declaration = 334,
  sym_bitfield_clause = 335,
  sym_enumerator = 336,
  sym_parameter_list = 337,
  sym_parameter_declaration = 338,
  sym_attributed_statement = 339,
  sym_statement = 340,
  sym__top_level_statement = 341,
  sym_labeled_statement = 342,
  sym__top_level_expression_statement = 343,
  sym_expression_statement = 344,
  sym_if_statement = 345,
  sym_else_clause = 346,
  sym_switch_statement = 347,
  sym_case_statement = 348,
  sym_while_statement = 349,
  sym_do_statement = 350,
  sym_for_statement = 351,
  sym__for_statement_body = 352,
  sym_return_statement = 353,
  sym_break_statement = 354,
  sym_continue_statement = 355,
  sym_goto_statement = 356,
  sym_seh_try_statement = 357,
  sym_seh_except_clause = 358,
  sym_seh_finally_clause = 359,
  sym_seh_leave_statement = 360,
  sym_expression = 361,
  sym__string = 362,
  sym_comma_expression = 363,
  sym_conditional_expression = 364,
  sym_assignment_expression = 365,
  sym_pointer_expression = 366,
  sym_unary_expression = 367,
  sym_binary_expression = 368,
  sym_update_expression = 369,
  sym_cast_expression = 370,
  sym_type_descriptor = 371,
  sym_sizeof_expression = 372,
  sym_alignof_expression = 373,
  sym_offsetof_expression = 374,
  sym_generic_expression = 375,
  sym_subscript_expression = 376,
  sym_call_expression = 377,
  sym_gnu_asm_expression = 378,
  sym_gnu_asm_qualifier = 379,
  sym_gnu_asm_output_operand_list = 380,
  sym_gnu_asm_output_operand = 381,
  sym_gnu_asm_input_operand_list = 382,
  sym_gnu_asm_input_operand = 383,
  sym_gnu_asm_clobber_list = 384,
  sym_gnu_asm_goto_list = 385,
  sym_extension_expression = 386,
  sym_argument_list = 387,
  sym_field_expression = 388,
  sym_compound_literal_expression = 389,
  sym_parenthesized_expression = 390,
  sym_initializer_list = 391,
  sym_initializer_pair = 392,
  sym_subscript_designator = 393,
  sym_subscript_range_designator = 394,
  sym_field_designator = 395,
  sym_char_literal = 396,
  sym_concatenated_string = 397,
  sym_string_literal = 398,
  sym_null = 399,
  sym__empty_declaration = 400,
  sym_placeholder_type_specifier = 401,
  sym_decltype_auto = 402,
  sym_decltype = 403,
  sym__class_declaration = 404,
  sym__class_declaration_item = 405,
  sym_class_specifier = 406,
  sym__class_name = 407,
  sym_virtual_specifier = 408,
  sym_explicit_function_specifier = 409,
  sym_base_class_clause = 410,
  sym__enum_base_clause = 411,
  sym_dependent_type = 412,
  sym_module_name = 413,
  sym_module_partition = 414,
  sym_module_declaration = 415,
  sym_export_declaration = 416,
  sym_import_declaration = 417,
  sym_global_module_fragment_declaration = 418,
  sym_private_module_fragment_declaration = 419,
  sym_template_declaration = 420,
  sym_template_instantiation = 421,
  sym_template_parameter_list = 422,
  sym_type_parameter_declaration = 423,
  sym_variadic_type_parameter_declaration = 424,
  sym_optional_type_parameter_declaration = 425,
  sym_template_template_parameter_declaration = 426,
  sym_optional_parameter_declaration = 427,
  sym_variadic_parameter_declaration = 428,
  sym_variadic_declarator = 429,
  sym_variadic_reference_declarator = 430,
  sym_operator_cast = 431,
  sym_field_initializer_list = 432,
  sym_field_initializer = 433,
  sym_inline_method_definition = 434,
  sym__constructor_specifiers = 435,
  sym_operator_cast_definition = 436,
  sym_operator_cast_declaration = 437,
  sym_constructor_try_statement = 438,
  sym_constructor_or_destructor_definition = 439,
  sym_constructor_or_destructor_declaration = 440,
  sym_default_method_clause = 441,
  sym_delete_method_clause = 442,
  sym_pure_virtual_clause = 443,
  sym_friend_declaration = 444,
  sym_access_specifier = 445,
  sym_reference_declarator = 446,
  sym_reference_field_declarator = 447,
  sym_reference_type_declarator = 448,
  sym_abstract_reference_declarator = 449,
  sym_structured_binding_declarator = 450,
  sym_ref_qualifier = 451,
  sym__function_declarator_seq = 452,
  sym__function_attributes_start = 453,
  sym__function_exception_specification = 454,
  sym__function_attributes_end = 455,
  sym__function_postfix = 456,
  sym_trailing_return_type = 457,
  sym_noexcept = 458,
  sym_throw_specifier = 459,
  sym_template_type = 460,
  sym_template_method = 461,
  sym_template_function = 462,
  sym_template_argument_list = 463,
  sym_namespace_definition = 464,
  sym_namespace_alias_definition = 465,
  sym__namespace_specifier = 466,
  sym_nested_namespace_specifier = 467,
  sym_using_declaration = 468,
  sym_alias_declaration = 469,
  sym_static_assert_declaration = 470,
  sym_concept_definition = 471,
  sym_for_range_loop = 472,
  sym__for_range_loop_body = 473,
  sym_init_statement = 474,
  sym_condition_clause = 475,
  sym_condition_declaration = 476,
  sym_co_return_statement = 477,
  sym_co_yield_statement = 478,
  sym_throw_statement = 479,
  sym_try_statement = 480,
  sym_catch_clause = 481,
  sym_raw_string_literal = 482,
  sym_subscript_argument_list = 483,
  sym_co_await_expression = 484,
  sym_new_expression = 485,
  sym_new_declarator = 486,
  sym_delete_expression = 487,
  sym_type_requirement = 488,
  sym_compound_requirement = 489,
  sym__requirement = 490,
  sym_requirement_seq = 491,
  sym_constraint_conjunction = 492,
  sym_constraint_disjunction = 493,
  sym__requirement_clause_constraint = 494,
  sym_requires_clause = 495,
  sym_requires_parameter_list = 496,
  sym_requires_expression = 497,
  sym_lambda_declarator = 498,
  sym_lambda_expression = 499,
  sym_lambda_capture_specifier = 500,
  sym_lambda_default_capture = 501,
  sym__lambda_capture_identifier = 502,
  sym_lambda_capture_initializer = 503,
  sym__lambda_capture = 504,
  sym__fold_operator = 505,
  sym__binary_fold_operator = 506,
  sym__unary_left_fold = 507,
  sym__unary_right_fold = 508,
  sym__binary_fold = 509,
  sym_fold_expression = 510,
  sym_parameter_pack_expansion = 511,
  sym_type_parameter_pack_expansion = 512,
  sym_identifier_parameter_pack_expansion = 513,
  sym_destructor_name = 514,
  sym_dependent_identifier = 515,
  sym_dependent_field_identifier = 516,
  sym_dependent_type_identifier = 517,
  sym__scope_resolution = 518,
  sym_qualified_field_identifier = 519,
  sym_qualified_identifier = 520,
  sym_qualified_type_identifier = 521,
  sym_qualified_operator_cast_identifier = 522,
  sym__assignment_expression_lhs = 523,
  sym_operator_name = 524,
  sym_user_defined_literal = 525,
  sym_semantics = 526,
  sym_discard_statement = 527,
  sym_qualifiers = 528,
  sym_cbuffer_specifier = 529,
  sym_hlsl_attribute = 530,
  aux_sym_translation_unit_repeat1 = 531,
  aux_sym_preproc_params_repeat1 = 532,
  aux_sym_preproc_if_repeat1 = 533,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 534,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 535,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 536,
  aux_sym_preproc_argument_list_repeat1 = 537,
  aux_sym_declaration_repeat1 = 538,
  aux_sym_type_definition_repeat1 = 539,
  aux_sym__type_definition_type_repeat1 = 540,
  aux_sym__type_definition_declarators_repeat1 = 541,
  aux_sym__declaration_specifiers_repeat1 = 542,
  aux_sym_attribute_declaration_repeat1 = 543,
  aux_sym_attributed_declarator_repeat1 = 544,
  aux_sym_pointer_declarator_repeat1 = 545,
  aux_sym_array_declarator_repeat1 = 546,
  aux_sym_sized_type_specifier_repeat1 = 547,
  aux_sym_enumerator_list_repeat1 = 548,
  aux_sym_field_declaration_repeat1 = 549,
  aux_sym_parameter_list_repeat1 = 550,
  aux_sym_case_statement_repeat1 = 551,
  aux_sym_generic_expression_repeat1 = 552,
  aux_sym_gnu_asm_expression_repeat1 = 553,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 554,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 555,
  aux_sym_gnu_asm_clobber_list_repeat1 = 556,
  aux_sym_gnu_asm_goto_list_repeat1 = 557,
  aux_sym_argument_list_repeat1 = 558,
  aux_sym_initializer_list_repeat1 = 559,
  aux_sym_initializer_pair_repeat1 = 560,
  aux_sym_char_literal_repeat1 = 561,
  aux_sym_concatenated_string_repeat1 = 562,
  aux_sym_string_literal_repeat1 = 563,
  aux_sym__class_declaration_repeat1 = 564,
  aux_sym_base_class_clause_repeat1 = 565,
  aux_sym_module_name_repeat1 = 566,
  aux_sym_template_parameter_list_repeat1 = 567,
  aux_sym_field_initializer_list_repeat1 = 568,
  aux_sym_operator_cast_definition_repeat1 = 569,
  aux_sym_constructor_try_statement_repeat1 = 570,
  aux_sym_structured_binding_declarator_repeat1 = 571,
  aux_sym__function_postfix_repeat1 = 572,
  aux_sym_throw_specifier_repeat1 = 573,
  aux_sym_template_argument_list_repeat1 = 574,
  aux_sym_subscript_argument_list_repeat1 = 575,
  aux_sym_requirement_seq_repeat1 = 576,
  aux_sym_requires_parameter_list_repeat1 = 577,
  aux_sym_lambda_capture_specifier_repeat1 = 578,
  alias_sym_field_identifier = 579,
  alias_sym_namespace_identifier = 580,
  alias_sym_simple_requirement = 581,
  alias_sym_statement_identifier = 582,
  alias_sym_type_identifier = 583,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_in] = "in",
  [anon_sym_out] = "out",
  [anon_sym_inout] = "inout",
  [anon_sym_virtual] = "virtual",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym___attribute] = "__attribute",
  [anon_sym_using] = "using",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym__Nonnull] = "_Nonnull",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym___asm] = "__asm",
  [anon_sym___volatile__] = "__volatile__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_export] = "export",
  [anon_sym_module] = "module",
  [anon_sym_import] = "import",
  [anon_sym_private] = "private",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [aux_sym_pure_virtual_clause_token1] = "pure_virtual_clause_token1",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [anon_sym_discard] = "discard",
  [anon_sym_precise] = "precise",
  [anon_sym_shared] = "shared",
  [anon_sym_groupshared] = "groupshared",
  [anon_sym_uniform] = "uniform",
  [anon_sym_row_major] = "row_major",
  [anon_sym_column_major] = "column_major",
  [anon_sym_globallycoherent] = "globallycoherent",
  [anon_sym_centroid] = "centroid",
  [anon_sym_noperspective] = "noperspective",
  [anon_sym_nointerpolation] = "nointerpolation",
  [anon_sym_sample] = "sample",
  [anon_sym_linear] = "linear",
  [anon_sym_snorm] = "snorm",
  [anon_sym_unorm] = "unorm",
  [anon_sym_point] = "point",
  [anon_sym_line] = "line",
  [anon_sym_triangleadj] = "triangleadj",
  [anon_sym_lineadj] = "lineadj",
  [anon_sym_triangle] = "triangle",
  [anon_sym_cbuffer] = "cbuffer",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_extension_expression] = "extension_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_module_name] = "module_name",
  [sym_module_partition] = "module_partition",
  [sym_module_declaration] = "module_declaration",
  [sym_export_declaration] = "export_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_global_module_fragment_declaration] = "global_module_fragment_declaration",
  [sym_private_module_fragment_declaration] = "private_module_fragment_declaration",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_declarator] = "lambda_declarator",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__lambda_capture_identifier] = "_lambda_capture_identifier",
  [sym_lambda_capture_initializer] = "lambda_capture_initializer",
  [sym__lambda_capture] = "_lambda_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_identifier_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [sym_semantics] = "semantics",
  [sym_discard_statement] = "discard_statement",
  [sym_qualifiers] = "qualifiers",
  [sym_cbuffer_specifier] = "cbuffer_specifier",
  [sym_hlsl_attribute] = "hlsl_attribute",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_module_name_repeat1] = "module_name_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_inout] = anon_sym_inout,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym___attribute] = anon_sym___attribute,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym__Nonnull] = anon_sym__Nonnull,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym___asm] = anon_sym___asm,
  [anon_sym___volatile__] = anon_sym___volatile__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [aux_sym_pure_virtual_clause_token1] = aux_sym_pure_virtual_clause_token1,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [anon_sym_discard] = anon_sym_discard,
  [anon_sym_precise] = anon_sym_precise,
  [anon_sym_shared] = anon_sym_shared,
  [anon_sym_groupshared] = anon_sym_groupshared,
  [anon_sym_uniform] = anon_sym_uniform,
  [anon_sym_row_major] = anon_sym_row_major,
  [anon_sym_column_major] = anon_sym_column_major,
  [anon_sym_globallycoherent] = anon_sym_globallycoherent,
  [anon_sym_centroid] = anon_sym_centroid,
  [anon_sym_noperspective] = anon_sym_noperspective,
  [anon_sym_nointerpolation] = anon_sym_nointerpolation,
  [anon_sym_sample] = anon_sym_sample,
  [anon_sym_linear] = anon_sym_linear,
  [anon_sym_snorm] = anon_sym_snorm,
  [anon_sym_unorm] = anon_sym_unorm,
  [anon_sym_point] = anon_sym_point,
  [anon_sym_line] = anon_sym_line,
  [anon_sym_triangleadj] = anon_sym_triangleadj,
  [anon_sym_lineadj] = anon_sym_lineadj,
  [anon_sym_triangle] = anon_sym_triangle,
  [anon_sym_cbuffer] = anon_sym_cbuffer,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_extension_expression] = sym_extension_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_module_name] = sym_module_name,
  [sym_module_partition] = sym_module_partition,
  [sym_module_declaration] = sym_module_declaration,
  [sym_export_declaration] = sym_export_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_global_module_fragment_declaration] = sym_global_module_fragment_declaration,
  [sym_private_module_fragment_declaration] = sym_private_module_fragment_declaration,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_declarator] = sym_lambda_declarator,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__lambda_capture_identifier] = sym__lambda_capture_identifier,
  [sym_lambda_capture_initializer] = sym_lambda_capture_initializer,
  [sym__lambda_capture] = sym__lambda_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_identifier_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [sym_semantics] = sym_semantics,
  [sym_discard_statement] = sym_discard_statement,
  [sym_qualifiers] = sym_qualifiers,
  [sym_cbuffer_specifier] = sym_cbuffer_specifier,
  [sym_hlsl_attribute] = sym_hlsl_attribute,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_module_name_repeat1] = aux_sym_module_name_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inout] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___volatile__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pure_virtual_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_discard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_precise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_groupshared] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uniform] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_row_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_column_major] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_globallycoherent] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_centroid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noperspective] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nointerpolation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sample] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_snorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unorm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_point] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_line] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangleadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lineadj] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_triangle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cbuffer] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_module_name] = {
    .visible = true,
    .named = true,
  },
  [sym_module_partition] = {
    .visible = true,
    .named = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_export_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_global_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_private_module_fragment_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_capture_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture] = {
    .visible = false,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_semantics] = {
    .visible = true,
    .named = true,
  },
  [sym_discard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cbuffer_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hlsl_attribute] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_header = 23,
  field_indices = 24,
  field_initializer = 25,
  field_input_operands = 26,
  field_label = 27,
  field_left = 28,
  field_length = 29,
  field_member = 30,
  field_message = 31,
  field_name = 32,
  field_namespace = 33,
  field_operand = 34,
  field_operator = 35,
  field_output_operands = 36,
  field_parameters = 37,
  field_partition = 38,
  field_path = 39,
  field_pattern = 40,
  field_placement = 41,
  field_prefix = 42,
  field_register = 43,
  field_requirements = 44,
  field_right = 45,
  field_scope = 46,
  field_size = 47,
  field_start = 48,
  field_symbol = 49,
  field_template_parameters = 50,
  field_type = 51,
  field_update = 52,
  field_value = 53,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_header] = "header",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_namespace] = "namespace",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_partition] = "partition",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 2},
  [34] = {.index = 38, .length = 2},
  [35] = {.index = 21, .length = 1},
  [36] = {.index = 40, .length = 1},
  [37] = {.index = 41, .length = 2},
  [38] = {.index = 43, .length = 2},
  [39] = {.index = 45, .length = 1},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 1},
  [55] = {.index = 67, .length = 3},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 1},
  [59] = {.index = 73, .length = 1},
  [60] = {.index = 74, .length = 2},
  [62] = {.index = 55, .length = 2},
  [63] = {.index = 76, .length = 2},
  [64] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [67] = {.index = 82, .length = 2},
  [68] = {.index = 84, .length = 2},
  [69] = {.index = 86, .length = 3},
  [70] = {.index = 89, .length = 2},
  [71] = {.index = 91, .length = 2},
  [72] = {.index = 93, .length = 3},
  [73] = {.index = 93, .length = 3},
  [74] = {.index = 96, .length = 3},
  [75] = {.index = 99, .length = 3},
  [76] = {.index = 102, .length = 3},
  [77] = {.index = 52, .length = 1},
  [78] = {.index = 105, .length = 2},
  [79] = {.index = 107, .length = 2},
  [80] = {.index = 109, .length = 2},
  [81] = {.index = 111, .length = 1},
  [82] = {.index = 112, .length = 2},
  [83] = {.index = 114, .length = 2},
  [84] = {.index = 116, .length = 2},
  [85] = {.index = 118, .length = 3},
  [86] = {.index = 121, .length = 2},
  [87] = {.index = 123, .length = 1},
  [88] = {.index = 124, .length = 2},
  [89] = {.index = 126, .length = 2},
  [90] = {.index = 128, .length = 2},
  [91] = {.index = 130, .length = 2},
  [92] = {.index = 132, .length = 2},
  [93] = {.index = 134, .length = 2},
  [94] = {.index = 136, .length = 2},
  [95] = {.index = 138, .length = 2},
  [96] = {.index = 140, .length = 1},
  [97] = {.index = 138, .length = 2},
  [99] = {.index = 141, .length = 2},
  [100] = {.index = 143, .length = 1},
  [101] = {.index = 143, .length = 1},
  [102] = {.index = 144, .length = 3},
  [104] = {.index = 147, .length = 2},
  [105] = {.index = 149, .length = 2},
  [106] = {.index = 151, .length = 2},
  [107] = {.index = 153, .length = 3},
  [108] = {.index = 156, .length = 1},
  [109] = {.index = 157, .length = 1},
  [110] = {.index = 158, .length = 1},
  [111] = {.index = 159, .length = 1},
  [112] = {.index = 160, .length = 2},
  [114] = {.index = 162, .length = 3},
  [115] = {.index = 165, .length = 3},
  [116] = {.index = 168, .length = 3},
  [117] = {.index = 171, .length = 3},
  [118] = {.index = 174, .length = 2},
  [119] = {.index = 176, .length = 3},
  [120] = {.index = 179, .length = 2},
  [121] = {.index = 181, .length = 3},
  [122] = {.index = 184, .length = 2},
  [123] = {.index = 19, .length = 2},
  [124] = {.index = 38, .length = 2},
  [125] = {.index = 186, .length = 2},
  [126] = {.index = 188, .length = 2},
  [127] = {.index = 190, .length = 4},
  [128] = {.index = 194, .length = 4},
  [129] = {.index = 198, .length = 2},
  [130] = {.index = 200, .length = 3},
  [131] = {.index = 203, .length = 2},
  [132] = {.index = 205, .length = 2},
  [133] = {.index = 207, .length = 1},
  [134] = {.index = 208, .length = 1},
  [135] = {.index = 209, .length = 2},
  [136] = {.index = 211, .length = 2},
  [137] = {.index = 213, .length = 2},
  [138] = {.index = 215, .length = 3},
  [139] = {.index = 218, .length = 3},
  [140] = {.index = 221, .length = 3},
  [141] = {.index = 224, .length = 2},
  [142] = {.index = 226, .length = 2},
  [143] = {.index = 228, .length = 2},
  [144] = {.index = 230, .length = 2},
  [145] = {.index = 230, .length = 2},
  [146] = {.index = 232, .length = 2},
  [147] = {.index = 232, .length = 2},
  [148] = {.index = 234, .length = 2},
  [149] = {.index = 236, .length = 3},
  [150] = {.index = 239, .length = 2},
  [151] = {.index = 241, .length = 2},
  [152] = {.index = 243, .length = 3},
  [153] = {.index = 246, .length = 2},
  [154] = {.index = 248, .length = 3},
  [155] = {.index = 251, .length = 2},
  [156] = {.index = 253, .length = 1},
  [157] = {.index = 254, .length = 2},
  [158] = {.index = 256, .length = 2},
  [159] = {.index = 258, .length = 4},
  [160] = {.index = 262, .length = 5},
  [161] = {.index = 267, .length = 1},
  [162] = {.index = 268, .length = 1},
  [163] = {.index = 269, .length = 2},
  [164] = {.index = 271, .length = 1},
  [165] = {.index = 272, .length = 2},
  [167] = {.index = 274, .length = 1},
  [168] = {.index = 275, .length = 2},
  [169] = {.index = 277, .length = 2},
  [170] = {.index = 11, .length = 1},
  [171] = {.index = 11, .length = 1},
  [172] = {.index = 279, .length = 1},
  [173] = {.index = 280, .length = 1},
  [174] = {.index = 281, .length = 4},
  [175] = {.index = 285, .length = 4},
  [176] = {.index = 289, .length = 1},
  [177] = {.index = 290, .length = 3},
  [178] = {.index = 293, .length = 2},
  [179] = {.index = 295, .length = 3},
  [180] = {.index = 298, .length = 5},
  [181] = {.index = 303, .length = 2},
  [182] = {.index = 305, .length = 3},
  [183] = {.index = 308, .length = 2},
  [184] = {.index = 310, .length = 2},
  [185] = {.index = 312, .length = 1},
  [186] = {.index = 313, .length = 2},
  [187] = {.index = 315, .length = 4},
  [188] = {.index = 319, .length = 2},
  [189] = {.index = 321, .length = 2},
  [190] = {.index = 323, .length = 1},
  [191] = {.index = 324, .length = 2},
  [192] = {.index = 326, .length = 2},
  [193] = {.index = 328, .length = 3},
  [194] = {.index = 331, .length = 4},
  [195] = {.index = 335, .length = 4},
  [196] = {.index = 339, .length = 3},
  [197] = {.index = 342, .length = 2},
  [198] = {.index = 344, .length = 3},
  [199] = {.index = 347, .length = 3},
  [200] = {.index = 350, .length = 2},
  [201] = {.index = 352, .length = 2},
  [202] = {.index = 354, .length = 2},
  [203] = {.index = 356, .length = 2},
  [204] = {.index = 358, .length = 3},
  [205] = {.index = 361, .length = 2},
  [206] = {.index = 363, .length = 2},
  [207] = {.index = 365, .length = 3},
  [208] = {.index = 368, .length = 3},
  [209] = {.index = 371, .length = 5},
  [210] = {.index = 376, .length = 3},
  [211] = {.index = 379, .length = 4},
  [212] = {.index = 383, .length = 3},
  [213] = {.index = 386, .length = 3},
  [214] = {.index = 389, .length = 2},
  [215] = {.index = 391, .length = 2},
  [216] = {.index = 393, .length = 2},
  [217] = {.index = 395, .length = 4},
  [218] = {.index = 399, .length = 5},
  [219] = {.index = 404, .length = 3},
  [220] = {.index = 407, .length = 4},
  [221] = {.index = 411, .length = 2},
  [222] = {.index = 413, .length = 1},
  [223] = {.index = 414, .length = 4},
  [224] = {.index = 418, .length = 3},
  [225] = {.index = 421, .length = 2},
  [226] = {.index = 423, .length = 1},
  [227] = {.index = 424, .length = 5},
  [228] = {.index = 429, .length = 2},
  [229] = {.index = 431, .length = 2},
  [230] = {.index = 65, .length = 1},
  [231] = {.index = 433, .length = 5},
  [232] = {.index = 438, .length = 4},
  [233] = {.index = 442, .length = 2},
  [234] = {.index = 444, .length = 2},
  [235] = {.index = 446, .length = 5},
  [236] = {.index = 451, .length = 2},
  [237] = {.index = 453, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [40] =
    {field_path, 1},
  [41] =
    {field_argument, 1},
    {field_directive, 0},
  [43] =
    {field_declarator, 1},
    {field_type, 0},
  [45] =
    {field_parameters, 0, .inherited = true},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_label, 0},
  [67] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [70] =
    {field_header, 1},
  [71] =
    {field_partition, 1},
  [72] =
    {field_type, 0, .inherited = true},
  [73] =
    {field_parameters, 1},
  [74] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [76] =
    {field_arguments, 2},
    {field_type, 1},
  [78] =
    {field_declarator, 2},
    {field_type, 1},
  [80] =
    {field_placement, 1},
    {field_type, 2},
  [82] =
    {field_parameters, 1},
    {field_requirements, 2},
  [84] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [86] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [89] =
    {field_declarator, 0},
    {field_value, 1},
  [91] =
    {field_body, 2},
    {field_declarator, 0},
  [93] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [96] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [99] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [102] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [105] =
    {field_body, 2},
    {field_declarator, 1},
  [107] =
    {field_name, 1},
    {field_value, 2},
  [109] =
    {field_name, 1},
    {field_parameters, 2},
  [111] =
    {field_condition, 1},
  [112] =
    {field_alternative, 2},
    {field_name, 1},
  [114] =
    {field_declarator, 2},
    {field_type, 0},
  [116] =
    {field_left, 0},
    {field_right, 2},
  [118] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [121] =
    {field_type, 1},
    {field_value, 3},
  [123] =
    {field_declarator, 3},
  [124] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [126] =
    {field_declarator, 0},
    {field_parameters, 1},
  [128] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [130] =
    {field_arguments, 3},
    {field_type, 2},
  [132] =
    {field_declarator, 3},
    {field_type, 2},
  [134] =
    {field_placement, 2},
    {field_type, 3},
  [136] =
    {field_name, 2},
    {field_prefix, 0},
  [138] =
    {field_body, 3},
    {field_name, 2},
  [140] =
    {field_body, 3},
  [141] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [143] =
    {field_base, 1},
  [144] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [147] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [149] =
    {field_body, 2},
    {field_name, 0},
  [151] =
    {field_condition, 2},
    {field_consequence, 3},
  [153] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [156] =
    {field_initializer, 0},
  [157] =
    {field_assembly_code, 2},
  [158] =
    {field_header, 2},
  [159] =
    {field_partition, 2},
  [160] =
    {field_name, 1},
    {field_partition, 2},
  [162] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [165] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [168] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [171] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [174] =
    {field_declarator, 0},
    {field_value, 2},
  [176] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [179] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [181] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [184] =
    {field_declarator, 0},
    {field_size, 2},
  [186] =
    {field_alternative, 3},
    {field_condition, 0},
  [188] =
    {field_declarator, 0},
    {field_default_value, 2},
  [190] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [194] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [198] =
    {field_body, 3},
    {field_declarator, 1},
  [200] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [203] =
    {field_alternative, 3},
    {field_condition, 1},
  [205] =
    {field_alternative, 3},
    {field_name, 1},
  [207] =
    {field_size, 1},
  [208] =
    {field_operator, 0},
  [209] =
    {field_declarator, 3},
    {field_type, 1},
  [211] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [213] =
    {field_name, 1},
    {field_type, 3},
  [215] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [218] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [221] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [224] =
    {field_name, 3},
    {field_namespace, 1},
  [226] =
    {field_body, 3},
    {field_name, 1},
  [228] =
    {field_left, 1},
    {field_right, 3},
  [230] =
    {field_body, 4},
    {field_name, 3},
  [232] =
    {field_designator, 0},
    {field_value, 2},
  [234] =
    {field_name, 0},
    {field_value, 2},
  [236] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [239] =
    {field_body, 3},
    {field_name, 0},
  [241] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [243] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [246] =
    {field_initializer, 1},
    {field_value, 2},
  [248] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [251] =
    {field_body, 1},
    {field_condition, 3},
  [253] =
    {field_update, 2},
  [254] =
    {field_initializer, 0},
    {field_update, 2},
  [256] =
    {field_condition, 1},
    {field_initializer, 0},
  [258] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [262] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [267] =
    {field_value, 3},
  [268] =
    {field_operand, 1},
  [269] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [271] =
    {field_assembly_code, 3},
  [272] =
    {field_name, 2},
    {field_partition, 3},
  [274] =
    {field_default_type, 2},
  [275] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [277] =
    {field_body, 2},
    {field_parameters, 1},
  [279] =
    {field_condition, 2},
  [280] =
    {field_length, 1},
  [281] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [285] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_type, 0, .inherited = true},
  [289] =
    {field_declarator, 4},
  [290] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [293] =
    {field_declarator, 0},
    {field_size, 3},
  [295] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [298] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [303] =
    {field_condition, 3},
    {field_consequence, 4},
  [305] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 2, .inherited = true},
  [308] =
    {field_declarator, 1},
    {field_default_value, 3},
  [310] =
    {field_alternative, 4},
    {field_condition, 1},
  [312] =
    {field_size, 2},
  [313] =
    {field_name, 1},
    {field_type, 4},
  [315] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [319] =
    {field_body, 2},
    {field_filter, 1},
  [321] =
    {field_body, 4},
    {field_name, 2},
  [323] =
    {field_body, 4},
  [324] =
    {field_body, 4},
    {field_name, 1},
  [326] =
    {field_left, 2},
    {field_right, 4},
  [328] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [331] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [335] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [339] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [342] =
    {field_condition, 1},
    {field_update, 3},
  [344] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [347] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [350] =
    {field_initializer, 0},
    {field_update, 3},
  [352] =
    {field_condition, 2},
    {field_initializer, 0},
  [354] =
    {field_member, 4},
    {field_type, 2},
  [356] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [358] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [361] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [363] =
    {field_default_type, 3},
    {field_name, 1},
  [365] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [368] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
  [371] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3},
    {field_declarator, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [376] =
    {field_alternative, 5},
    {field_condition, 3},
    {field_consequence, 4},
  [379] =
    {field_body, 5},
    {field_condition, 3, .inherited = true},
    {field_initializer, 3, .inherited = true},
    {field_update, 3, .inherited = true},
  [383] =
    {field_body, 5},
    {field_declarator, 4},
    {field_type, 2, .inherited = true},
  [386] =
    {field_name, 5},
    {field_namespace, 1},
    {field_prefix, 3},
  [389] =
    {field_body, 5},
    {field_name, 2},
  [391] =
    {field_end, 3},
    {field_start, 1},
  [393] =
    {field_declarator, 1},
    {field_default_value, 2},
  [395] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [399] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [404] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [407] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [411] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [413] =
    {field_register, 1},
  [414] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [418] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [421] =
    {field_condition, 2},
    {field_message, 4},
  [423] =
    {field_delimiter, 1},
  [424] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [429] =
    {field_constraint, 0},
    {field_value, 2},
  [431] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [433] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [438] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [442] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [444] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [446] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [451] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [453] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [34] = {
    [1] = alias_sym_type_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [54] = {
    [0] = alias_sym_statement_identifier,
  },
  [61] = {
    [1] = alias_sym_namespace_identifier,
  },
  [62] = {
    [1] = alias_sym_namespace_identifier,
  },
  [66] = {
    [0] = alias_sym_simple_requirement,
  },
  [72] = {
    [2] = alias_sym_field_identifier,
  },
  [77] = {
    [2] = alias_sym_type_identifier,
  },
  [95] = {
    [2] = alias_sym_namespace_identifier,
  },
  [98] = {
    [1] = alias_sym_field_identifier,
  },
  [101] = {
    [1] = alias_sym_type_identifier,
  },
  [103] = {
    [0] = alias_sym_field_identifier,
  },
  [113] = {
    [1] = alias_sym_type_identifier,
  },
  [123] = {
    [0] = alias_sym_field_identifier,
  },
  [124] = {
    [1] = alias_sym_field_identifier,
  },
  [137] = {
    [1] = alias_sym_type_identifier,
  },
  [144] = {
    [3] = alias_sym_namespace_identifier,
  },
  [146] = {
    [0] = alias_sym_field_identifier,
  },
  [166] = {
    [2] = alias_sym_type_identifier,
  },
  [170] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [171] = {
    [1] = alias_sym_namespace_identifier,
  },
  [175] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [186] = {
    [1] = alias_sym_type_identifier,
  },
  [202] = {
    [4] = alias_sym_field_identifier,
  },
  [206] = {
    [1] = alias_sym_type_identifier,
  },
  [208] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
  [209] = {
    [2] = sym_semantics,
    [3] = sym_semantics,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  sym_expression, 2,
    sym_expression,
    sym_semantics,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 13,
  [20] = 20,
  [21] = 20,
  [22] = 22,
  [23] = 14,
  [24] = 20,
  [25] = 22,
  [26] = 22,
  [27] = 20,
  [28] = 14,
  [29] = 14,
  [30] = 22,
  [31] = 13,
  [32] = 13,
  [33] = 33,
  [34] = 34,
  [35] = 34,
  [36] = 33,
  [37] = 37,
  [38] = 34,
  [39] = 39,
  [40] = 40,
  [41] = 34,
  [42] = 42,
  [43] = 33,
  [44] = 37,
  [45] = 34,
  [46] = 39,
  [47] = 47,
  [48] = 42,
  [49] = 42,
  [50] = 37,
  [51] = 34,
  [52] = 52,
  [53] = 53,
  [54] = 42,
  [55] = 37,
  [56] = 34,
  [57] = 37,
  [58] = 34,
  [59] = 59,
  [60] = 37,
  [61] = 34,
  [62] = 39,
  [63] = 37,
  [64] = 34,
  [65] = 37,
  [66] = 34,
  [67] = 37,
  [68] = 34,
  [69] = 37,
  [70] = 34,
  [71] = 37,
  [72] = 34,
  [73] = 37,
  [74] = 34,
  [75] = 37,
  [76] = 34,
  [77] = 37,
  [78] = 37,
  [79] = 37,
  [80] = 34,
  [81] = 37,
  [82] = 39,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 86,
  [91] = 89,
  [92] = 85,
  [93] = 87,
  [94] = 88,
  [95] = 86,
  [96] = 86,
  [97] = 89,
  [98] = 89,
  [99] = 88,
  [100] = 85,
  [101] = 87,
  [102] = 87,
  [103] = 85,
  [104] = 88,
  [105] = 105,
  [106] = 89,
  [107] = 87,
  [108] = 108,
  [109] = 108,
  [110] = 108,
  [111] = 85,
  [112] = 88,
  [113] = 108,
  [114] = 86,
  [115] = 108,
  [116] = 108,
  [117] = 117,
  [118] = 117,
  [119] = 117,
  [120] = 117,
  [121] = 117,
  [122] = 117,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 124,
  [127] = 124,
  [128] = 124,
  [129] = 129,
  [130] = 124,
  [131] = 131,
  [132] = 131,
  [133] = 131,
  [134] = 131,
  [135] = 131,
  [136] = 131,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 141,
  [150] = 142,
  [151] = 151,
  [152] = 152,
  [153] = 152,
  [154] = 151,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 143,
  [159] = 144,
  [160] = 140,
  [161] = 145,
  [162] = 146,
  [163] = 148,
  [164] = 147,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 165,
  [172] = 143,
  [173] = 144,
  [174] = 140,
  [175] = 145,
  [176] = 146,
  [177] = 148,
  [178] = 147,
  [179] = 166,
  [180] = 156,
  [181] = 167,
  [182] = 169,
  [183] = 170,
  [184] = 141,
  [185] = 157,
  [186] = 170,
  [187] = 141,
  [188] = 142,
  [189] = 142,
  [190] = 190,
  [191] = 155,
  [192] = 192,
  [193] = 168,
  [194] = 138,
  [195] = 139,
  [196] = 196,
  [197] = 197,
  [198] = 151,
  [199] = 199,
  [200] = 152,
  [201] = 151,
  [202] = 152,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 199,
  [231] = 231,
  [232] = 210,
  [233] = 196,
  [234] = 210,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 197,
  [261] = 261,
  [262] = 262,
  [263] = 210,
  [264] = 203,
  [265] = 156,
  [266] = 266,
  [267] = 251,
  [268] = 238,
  [269] = 207,
  [270] = 208,
  [271] = 229,
  [272] = 242,
  [273] = 157,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 231,
  [278] = 213,
  [279] = 214,
  [280] = 168,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 155,
  [286] = 215,
  [287] = 165,
  [288] = 166,
  [289] = 156,
  [290] = 167,
  [291] = 169,
  [292] = 216,
  [293] = 293,
  [294] = 217,
  [295] = 295,
  [296] = 218,
  [297] = 250,
  [298] = 298,
  [299] = 240,
  [300] = 219,
  [301] = 224,
  [302] = 225,
  [303] = 226,
  [304] = 235,
  [305] = 236,
  [306] = 252,
  [307] = 239,
  [308] = 243,
  [309] = 244,
  [310] = 245,
  [311] = 246,
  [312] = 253,
  [313] = 254,
  [314] = 314,
  [315] = 157,
  [316] = 169,
  [317] = 165,
  [318] = 166,
  [319] = 167,
  [320] = 155,
  [321] = 321,
  [322] = 258,
  [323] = 259,
  [324] = 261,
  [325] = 255,
  [326] = 256,
  [327] = 168,
  [328] = 209,
  [329] = 204,
  [330] = 211,
  [331] = 212,
  [332] = 220,
  [333] = 143,
  [334] = 144,
  [335] = 140,
  [336] = 145,
  [337] = 146,
  [338] = 148,
  [339] = 147,
  [340] = 221,
  [341] = 341,
  [342] = 223,
  [343] = 227,
  [344] = 344,
  [345] = 345,
  [346] = 205,
  [347] = 347,
  [348] = 247,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 206,
  [369] = 241,
  [370] = 370,
  [371] = 237,
  [372] = 372,
  [373] = 248,
  [374] = 374,
  [375] = 257,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 262,
  [412] = 412,
  [413] = 249,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 222,
  [420] = 192,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 427,
  [429] = 429,
  [430] = 190,
  [431] = 425,
  [432] = 190,
  [433] = 426,
  [434] = 424,
  [435] = 425,
  [436] = 426,
  [437] = 427,
  [438] = 424,
  [439] = 192,
  [440] = 197,
  [441] = 203,
  [442] = 138,
  [443] = 197,
  [444] = 139,
  [445] = 445,
  [446] = 192,
  [447] = 190,
  [448] = 139,
  [449] = 449,
  [450] = 196,
  [451] = 138,
  [452] = 199,
  [453] = 453,
  [454] = 196,
  [455] = 199,
  [456] = 203,
  [457] = 241,
  [458] = 227,
  [459] = 243,
  [460] = 210,
  [461] = 244,
  [462] = 237,
  [463] = 238,
  [464] = 239,
  [465] = 240,
  [466] = 241,
  [467] = 242,
  [468] = 245,
  [469] = 235,
  [470] = 246,
  [471] = 247,
  [472] = 248,
  [473] = 249,
  [474] = 250,
  [475] = 251,
  [476] = 252,
  [477] = 236,
  [478] = 253,
  [479] = 237,
  [480] = 238,
  [481] = 239,
  [482] = 240,
  [483] = 210,
  [484] = 242,
  [485] = 243,
  [486] = 244,
  [487] = 245,
  [488] = 254,
  [489] = 255,
  [490] = 247,
  [491] = 256,
  [492] = 248,
  [493] = 249,
  [494] = 250,
  [495] = 251,
  [496] = 252,
  [497] = 253,
  [498] = 254,
  [499] = 258,
  [500] = 259,
  [501] = 261,
  [502] = 262,
  [503] = 257,
  [504] = 209,
  [505] = 204,
  [506] = 211,
  [507] = 212,
  [508] = 228,
  [509] = 213,
  [510] = 214,
  [511] = 215,
  [512] = 216,
  [513] = 217,
  [514] = 228,
  [515] = 258,
  [516] = 220,
  [517] = 221,
  [518] = 222,
  [519] = 223,
  [520] = 259,
  [521] = 225,
  [522] = 226,
  [523] = 227,
  [524] = 262,
  [525] = 261,
  [526] = 255,
  [527] = 256,
  [528] = 205,
  [529] = 206,
  [530] = 205,
  [531] = 206,
  [532] = 218,
  [533] = 224,
  [534] = 235,
  [535] = 207,
  [536] = 246,
  [537] = 228,
  [538] = 208,
  [539] = 236,
  [540] = 257,
  [541] = 207,
  [542] = 208,
  [543] = 219,
  [544] = 213,
  [545] = 214,
  [546] = 229,
  [547] = 231,
  [548] = 215,
  [549] = 216,
  [550] = 217,
  [551] = 218,
  [552] = 219,
  [553] = 224,
  [554] = 225,
  [555] = 226,
  [556] = 229,
  [557] = 209,
  [558] = 204,
  [559] = 211,
  [560] = 212,
  [561] = 344,
  [562] = 228,
  [563] = 231,
  [564] = 210,
  [565] = 220,
  [566] = 221,
  [567] = 222,
  [568] = 223,
  [569] = 364,
  [570] = 210,
  [571] = 210,
  [572] = 210,
  [573] = 385,
  [574] = 295,
  [575] = 403,
  [576] = 281,
  [577] = 357,
  [578] = 282,
  [579] = 361,
  [580] = 363,
  [581] = 365,
  [582] = 344,
  [583] = 349,
  [584] = 350,
  [585] = 352,
  [586] = 360,
  [587] = 367,
  [588] = 372,
  [589] = 370,
  [590] = 374,
  [591] = 376,
  [592] = 377,
  [593] = 382,
  [594] = 355,
  [595] = 356,
  [596] = 357,
  [597] = 372,
  [598] = 389,
  [599] = 390,
  [600] = 358,
  [601] = 412,
  [602] = 417,
  [603] = 283,
  [604] = 408,
  [605] = 344,
  [606] = 606,
  [607] = 409,
  [608] = 410,
  [609] = 355,
  [610] = 356,
  [611] = 358,
  [612] = 359,
  [613] = 613,
  [614] = 362,
  [615] = 364,
  [616] = 392,
  [617] = 366,
  [618] = 359,
  [619] = 414,
  [620] = 415,
  [621] = 381,
  [622] = 380,
  [623] = 381,
  [624] = 392,
  [625] = 393,
  [626] = 394,
  [627] = 395,
  [628] = 396,
  [629] = 397,
  [630] = 398,
  [631] = 403,
  [632] = 416,
  [633] = 341,
  [634] = 402,
  [635] = 353,
  [636] = 380,
  [637] = 404,
  [638] = 406,
  [639] = 415,
  [640] = 393,
  [641] = 383,
  [642] = 407,
  [643] = 418,
  [644] = 274,
  [645] = 407,
  [646] = 298,
  [647] = 345,
  [648] = 354,
  [649] = 418,
  [650] = 274,
  [651] = 351,
  [652] = 383,
  [653] = 298,
  [654] = 378,
  [655] = 379,
  [656] = 384,
  [657] = 266,
  [658] = 606,
  [659] = 314,
  [660] = 353,
  [661] = 293,
  [662] = 345,
  [663] = 354,
  [664] = 386,
  [665] = 388,
  [666] = 391,
  [667] = 284,
  [668] = 384,
  [669] = 389,
  [670] = 275,
  [671] = 276,
  [672] = 281,
  [673] = 282,
  [674] = 283,
  [675] = 284,
  [676] = 390,
  [677] = 405,
  [678] = 399,
  [679] = 293,
  [680] = 295,
  [681] = 400,
  [682] = 401,
  [683] = 394,
  [684] = 405,
  [685] = 385,
  [686] = 387,
  [687] = 361,
  [688] = 395,
  [689] = 347,
  [690] = 408,
  [691] = 409,
  [692] = 410,
  [693] = 396,
  [694] = 347,
  [695] = 349,
  [696] = 350,
  [697] = 351,
  [698] = 352,
  [699] = 397,
  [700] = 360,
  [701] = 367,
  [702] = 370,
  [703] = 374,
  [704] = 376,
  [705] = 377,
  [706] = 378,
  [707] = 379,
  [708] = 382,
  [709] = 398,
  [710] = 387,
  [711] = 399,
  [712] = 362,
  [713] = 400,
  [714] = 412,
  [715] = 417,
  [716] = 266,
  [717] = 401,
  [718] = 414,
  [719] = 363,
  [720] = 416,
  [721] = 341,
  [722] = 402,
  [723] = 404,
  [724] = 275,
  [725] = 276,
  [726] = 406,
  [727] = 314,
  [728] = 321,
  [729] = 386,
  [730] = 388,
  [731] = 391,
  [732] = 364,
  [733] = 365,
  [734] = 366,
  [735] = 321,
  [736] = 385,
  [737] = 397,
  [738] = 398,
  [739] = 410,
  [740] = 372,
  [741] = 399,
  [742] = 742,
  [743] = 393,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 283,
  [749] = 281,
  [750] = 394,
  [751] = 347,
  [752] = 400,
  [753] = 395,
  [754] = 754,
  [755] = 284,
  [756] = 401,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 414,
  [764] = 415,
  [765] = 357,
  [766] = 416,
  [767] = 341,
  [768] = 402,
  [769] = 358,
  [770] = 359,
  [771] = 404,
  [772] = 406,
  [773] = 407,
  [774] = 418,
  [775] = 274,
  [776] = 776,
  [777] = 298,
  [778] = 314,
  [779] = 321,
  [780] = 345,
  [781] = 354,
  [782] = 386,
  [783] = 388,
  [784] = 784,
  [785] = 391,
  [786] = 361,
  [787] = 362,
  [788] = 405,
  [789] = 789,
  [790] = 282,
  [791] = 275,
  [792] = 276,
  [793] = 366,
  [794] = 293,
  [795] = 295,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 380,
  [801] = 381,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 363,
  [809] = 349,
  [810] = 350,
  [811] = 351,
  [812] = 352,
  [813] = 390,
  [814] = 360,
  [815] = 367,
  [816] = 383,
  [817] = 817,
  [818] = 370,
  [819] = 374,
  [820] = 376,
  [821] = 377,
  [822] = 378,
  [823] = 379,
  [824] = 353,
  [825] = 825,
  [826] = 396,
  [827] = 382,
  [828] = 384,
  [829] = 829,
  [830] = 387,
  [831] = 266,
  [832] = 408,
  [833] = 392,
  [834] = 403,
  [835] = 409,
  [836] = 389,
  [837] = 412,
  [838] = 355,
  [839] = 365,
  [840] = 356,
  [841] = 417,
  [842] = 842,
  [843] = 843,
  [844] = 843,
  [845] = 843,
  [846] = 842,
  [847] = 843,
  [848] = 848,
  [849] = 843,
  [850] = 842,
  [851] = 843,
  [852] = 843,
  [853] = 842,
  [854] = 842,
  [855] = 843,
  [856] = 842,
  [857] = 842,
  [858] = 843,
  [859] = 842,
  [860] = 843,
  [861] = 843,
  [862] = 842,
  [863] = 613,
  [864] = 842,
  [865] = 842,
  [866] = 842,
  [867] = 843,
  [868] = 613,
  [869] = 842,
  [870] = 843,
  [871] = 843,
  [872] = 842,
  [873] = 873,
  [874] = 843,
  [875] = 842,
  [876] = 876,
  [877] = 876,
  [878] = 878,
  [879] = 876,
  [880] = 878,
  [881] = 878,
  [882] = 878,
  [883] = 876,
  [884] = 884,
  [885] = 884,
  [886] = 886,
  [887] = 884,
  [888] = 886,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 889,
  [897] = 893,
  [898] = 890,
  [899] = 891,
  [900] = 893,
  [901] = 901,
  [902] = 886,
  [903] = 892,
  [904] = 894,
  [905] = 895,
  [906] = 889,
  [907] = 901,
  [908] = 890,
  [909] = 891,
  [910] = 876,
  [911] = 886,
  [912] = 892,
  [913] = 894,
  [914] = 895,
  [915] = 889,
  [916] = 884,
  [917] = 893,
  [918] = 901,
  [919] = 890,
  [920] = 891,
  [921] = 886,
  [922] = 892,
  [923] = 894,
  [924] = 895,
  [925] = 889,
  [926] = 901,
  [927] = 890,
  [928] = 891,
  [929] = 884,
  [930] = 876,
  [931] = 886,
  [932] = 892,
  [933] = 894,
  [934] = 895,
  [935] = 889,
  [936] = 901,
  [937] = 893,
  [938] = 890,
  [939] = 891,
  [940] = 893,
  [941] = 892,
  [942] = 894,
  [943] = 895,
  [944] = 901,
  [945] = 945,
  [946] = 946,
  [947] = 946,
  [948] = 948,
  [949] = 949,
  [950] = 945,
  [951] = 951,
  [952] = 951,
  [953] = 953,
  [954] = 951,
  [955] = 953,
  [956] = 953,
  [957] = 953,
  [958] = 951,
  [959] = 953,
  [960] = 951,
  [961] = 953,
  [962] = 945,
  [963] = 951,
  [964] = 953,
  [965] = 953,
  [966] = 951,
  [967] = 953,
  [968] = 951,
  [969] = 951,
  [970] = 953,
  [971] = 951,
  [972] = 953,
  [973] = 951,
  [974] = 953,
  [975] = 951,
  [976] = 953,
  [977] = 951,
  [978] = 978,
  [979] = 945,
  [980] = 978,
  [981] = 978,
  [982] = 978,
  [983] = 978,
  [984] = 978,
  [985] = 978,
  [986] = 141,
  [987] = 945,
  [988] = 142,
  [989] = 945,
  [990] = 990,
  [991] = 990,
  [992] = 152,
  [993] = 990,
  [994] = 990,
  [995] = 990,
  [996] = 990,
  [997] = 151,
  [998] = 998,
  [999] = 990,
  [1000] = 945,
  [1001] = 156,
  [1002] = 145,
  [1003] = 148,
  [1004] = 169,
  [1005] = 165,
  [1006] = 166,
  [1007] = 167,
  [1008] = 147,
  [1009] = 168,
  [1010] = 140,
  [1011] = 143,
  [1012] = 157,
  [1013] = 144,
  [1014] = 155,
  [1015] = 146,
  [1016] = 1016,
  [1017] = 1016,
  [1018] = 1016,
  [1019] = 1016,
  [1020] = 1016,
  [1021] = 1016,
  [1022] = 1016,
  [1023] = 1016,
  [1024] = 1016,
  [1025] = 1016,
  [1026] = 1016,
  [1027] = 1016,
  [1028] = 1016,
  [1029] = 1016,
  [1030] = 1016,
  [1031] = 1016,
  [1032] = 1016,
  [1033] = 1016,
  [1034] = 1016,
  [1035] = 1016,
  [1036] = 1016,
  [1037] = 1016,
  [1038] = 197,
  [1039] = 196,
  [1040] = 1040,
  [1041] = 139,
  [1042] = 138,
  [1043] = 1043,
  [1044] = 1040,
  [1045] = 203,
  [1046] = 948,
  [1047] = 1047,
  [1048] = 949,
  [1049] = 199,
  [1050] = 221,
  [1051] = 229,
  [1052] = 231,
  [1053] = 247,
  [1054] = 262,
  [1055] = 255,
  [1056] = 243,
  [1057] = 998,
  [1058] = 244,
  [1059] = 248,
  [1060] = 1060,
  [1061] = 207,
  [1062] = 208,
  [1063] = 209,
  [1064] = 204,
  [1065] = 235,
  [1066] = 211,
  [1067] = 212,
  [1068] = 213,
  [1069] = 214,
  [1070] = 205,
  [1071] = 215,
  [1072] = 216,
  [1073] = 217,
  [1074] = 206,
  [1075] = 249,
  [1076] = 256,
  [1077] = 250,
  [1078] = 1060,
  [1079] = 219,
  [1080] = 220,
  [1081] = 242,
  [1082] = 222,
  [1083] = 246,
  [1084] = 261,
  [1085] = 257,
  [1086] = 218,
  [1087] = 225,
  [1088] = 226,
  [1089] = 224,
  [1090] = 227,
  [1091] = 1091,
  [1092] = 251,
  [1093] = 259,
  [1094] = 1091,
  [1095] = 1091,
  [1096] = 236,
  [1097] = 252,
  [1098] = 1091,
  [1099] = 1091,
  [1100] = 1091,
  [1101] = 237,
  [1102] = 1091,
  [1103] = 1091,
  [1104] = 1091,
  [1105] = 1091,
  [1106] = 1091,
  [1107] = 1091,
  [1108] = 238,
  [1109] = 253,
  [1110] = 239,
  [1111] = 254,
  [1112] = 1060,
  [1113] = 240,
  [1114] = 241,
  [1115] = 245,
  [1116] = 1060,
  [1117] = 258,
  [1118] = 223,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 945,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1122,
  [1125] = 1123,
  [1126] = 945,
  [1127] = 1123,
  [1128] = 1123,
  [1129] = 945,
  [1130] = 1122,
  [1131] = 1123,
  [1132] = 1123,
  [1133] = 945,
  [1134] = 945,
  [1135] = 945,
  [1136] = 1136,
  [1137] = 606,
  [1138] = 606,
  [1139] = 606,
  [1140] = 144,
  [1141] = 143,
  [1142] = 140,
  [1143] = 145,
  [1144] = 148,
  [1145] = 147,
  [1146] = 146,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1149,
  [1151] = 1148,
  [1152] = 1148,
  [1153] = 1148,
  [1154] = 1149,
  [1155] = 1148,
  [1156] = 1149,
  [1157] = 1149,
  [1158] = 1149,
  [1159] = 1159,
  [1160] = 1148,
  [1161] = 1148,
  [1162] = 1148,
  [1163] = 1148,
  [1164] = 1148,
  [1165] = 1148,
  [1166] = 1149,
  [1167] = 1149,
  [1168] = 1148,
  [1169] = 1148,
  [1170] = 1149,
  [1171] = 1149,
  [1172] = 1149,
  [1173] = 1149,
  [1174] = 1149,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1182,
  [1183] = 1180,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1180,
  [1187] = 1180,
  [1188] = 1185,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1185,
  [1192] = 1179,
  [1193] = 1182,
  [1194] = 1181,
  [1195] = 1175,
  [1196] = 1190,
  [1197] = 1185,
  [1198] = 143,
  [1199] = 146,
  [1200] = 148,
  [1201] = 145,
  [1202] = 140,
  [1203] = 144,
  [1204] = 147,
  [1205] = 1205,
  [1206] = 606,
  [1207] = 405,
  [1208] = 606,
  [1209] = 1209,
  [1210] = 1209,
  [1211] = 1209,
  [1212] = 1209,
  [1213] = 387,
  [1214] = 1147,
  [1215] = 1147,
  [1216] = 606,
  [1217] = 145,
  [1218] = 1159,
  [1219] = 1147,
  [1220] = 1159,
  [1221] = 147,
  [1222] = 148,
  [1223] = 143,
  [1224] = 146,
  [1225] = 144,
  [1226] = 140,
  [1227] = 1159,
  [1228] = 1228,
  [1229] = 1228,
  [1230] = 140,
  [1231] = 144,
  [1232] = 1159,
  [1233] = 143,
  [1234] = 145,
  [1235] = 146,
  [1236] = 148,
  [1237] = 147,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1239,
  [1241] = 1241,
  [1242] = 1239,
  [1243] = 1239,
  [1244] = 1241,
  [1245] = 1239,
  [1246] = 1241,
  [1247] = 1239,
  [1248] = 1241,
  [1249] = 1241,
  [1250] = 1250,
  [1251] = 1239,
  [1252] = 1239,
  [1253] = 1250,
  [1254] = 1239,
  [1255] = 1250,
  [1256] = 1241,
  [1257] = 1250,
  [1258] = 1241,
  [1259] = 1241,
  [1260] = 1250,
  [1261] = 1241,
  [1262] = 1262,
  [1263] = 1250,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1265,
  [1267] = 1264,
  [1268] = 1265,
  [1269] = 1264,
  [1270] = 1265,
  [1271] = 1265,
  [1272] = 1265,
  [1273] = 1264,
  [1274] = 1264,
  [1275] = 1264,
  [1276] = 1276,
  [1277] = 1277,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1281,
  [1283] = 1159,
  [1284] = 1281,
  [1285] = 1281,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1286,
  [1289] = 1287,
  [1290] = 1287,
  [1291] = 1287,
  [1292] = 1286,
  [1293] = 1286,
  [1294] = 1287,
  [1295] = 1286,
  [1296] = 1286,
  [1297] = 1287,
  [1298] = 1286,
  [1299] = 1287,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1300,
  [1303] = 1300,
  [1304] = 1301,
  [1305] = 1300,
  [1306] = 1300,
  [1307] = 1300,
  [1308] = 1301,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1301,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1309,
  [1315] = 1315,
  [1316] = 1309,
  [1317] = 1315,
  [1318] = 1309,
  [1319] = 1309,
  [1320] = 1309,
  [1321] = 1309,
  [1322] = 1309,
  [1323] = 1301,
  [1324] = 1309,
  [1325] = 1300,
  [1326] = 1315,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1330,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1336,
  [1341] = 1341,
  [1342] = 1330,
  [1343] = 1336,
  [1344] = 1344,
  [1345] = 1336,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1346,
  [1351] = 1351,
  [1352] = 1346,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1346,
  [1356] = 1356,
  [1357] = 1346,
  [1358] = 1358,
  [1359] = 1353,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1346,
  [1364] = 1364,
  [1365] = 1353,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1346,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1353,
  [1372] = 1353,
  [1373] = 1346,
  [1374] = 1364,
  [1375] = 1353,
  [1376] = 1376,
  [1377] = 1346,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1346,
  [1381] = 1353,
  [1382] = 1346,
  [1383] = 1383,
  [1384] = 1353,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1364,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1353,
  [1392] = 1364,
  [1393] = 1346,
  [1394] = 1353,
  [1395] = 1364,
  [1396] = 1346,
  [1397] = 1353,
  [1398] = 1353,
  [1399] = 1364,
  [1400] = 1353,
  [1401] = 1364,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1402,
  [1411] = 1411,
  [1412] = 1402,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1406,
  [1422] = 1422,
  [1423] = 1407,
  [1424] = 1402,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1426,
  [1432] = 1430,
  [1433] = 1433,
  [1434] = 1402,
  [1435] = 1402,
  [1436] = 1411,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1407,
  [1443] = 1437,
  [1444] = 1427,
  [1445] = 1445,
  [1446] = 1416,
  [1447] = 1406,
  [1448] = 1440,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1407,
  [1452] = 1427,
  [1453] = 1416,
  [1454] = 1422,
  [1455] = 1407,
  [1456] = 1402,
  [1457] = 1428,
  [1458] = 1407,
  [1459] = 1159,
  [1460] = 1460,
  [1461] = 1406,
  [1462] = 1462,
  [1463] = 1415,
  [1464] = 1464,
  [1465] = 1407,
  [1466] = 1402,
  [1467] = 1403,
  [1468] = 1407,
  [1469] = 1469,
  [1470] = 1407,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1402,
  [1474] = 1422,
  [1475] = 1419,
  [1476] = 1159,
  [1477] = 1402,
  [1478] = 1460,
  [1479] = 1471,
  [1480] = 1469,
  [1481] = 1449,
  [1482] = 1402,
  [1483] = 1483,
  [1484] = 1416,
  [1485] = 1427,
  [1486] = 1429,
  [1487] = 1422,
  [1488] = 1406,
  [1489] = 1445,
  [1490] = 1427,
  [1491] = 1462,
  [1492] = 1439,
  [1493] = 1427,
  [1494] = 1441,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1464,
  [1498] = 1420,
  [1499] = 1427,
  [1500] = 1414,
  [1501] = 1469,
  [1502] = 1404,
  [1503] = 1425,
  [1504] = 1450,
  [1505] = 1419,
  [1506] = 1418,
  [1507] = 1402,
  [1508] = 1416,
  [1509] = 1495,
  [1510] = 1469,
  [1511] = 1511,
  [1512] = 1496,
  [1513] = 1511,
  [1514] = 1402,
  [1515] = 1405,
  [1516] = 1408,
  [1517] = 1483,
  [1518] = 1407,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1521,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1524,
  [1551] = 1551,
  [1552] = 1519,
  [1553] = 1553,
  [1554] = 1521,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1535,
  [1558] = 1538,
  [1559] = 1539,
  [1560] = 1560,
  [1561] = 1540,
  [1562] = 1533,
  [1563] = 1534,
  [1564] = 1536,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1548,
  [1570] = 1533,
  [1571] = 1534,
  [1572] = 1541,
  [1573] = 1542,
  [1574] = 1556,
  [1575] = 1535,
  [1576] = 1524,
  [1577] = 1536,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1543,
  [1581] = 1544,
  [1582] = 1521,
  [1583] = 1583,
  [1584] = 1545,
  [1585] = 1546,
  [1586] = 1547,
  [1587] = 1538,
  [1588] = 1539,
  [1589] = 1540,
  [1590] = 1541,
  [1591] = 1542,
  [1592] = 1543,
  [1593] = 1544,
  [1594] = 1545,
  [1595] = 1546,
  [1596] = 1547,
  [1597] = 1548,
  [1598] = 1533,
  [1599] = 1534,
  [1600] = 1536,
  [1601] = 1548,
  [1602] = 1548,
  [1603] = 1524,
  [1604] = 1521,
  [1605] = 1536,
  [1606] = 1548,
  [1607] = 1524,
  [1608] = 1524,
  [1609] = 1521,
  [1610] = 139,
  [1611] = 138,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1525,
  [1615] = 1615,
  [1616] = 1523,
  [1617] = 1526,
  [1618] = 1618,
  [1619] = 1533,
  [1620] = 1534,
  [1621] = 1556,
  [1622] = 1535,
  [1623] = 1536,
  [1624] = 1524,
  [1625] = 1538,
  [1626] = 1539,
  [1627] = 1540,
  [1628] = 1541,
  [1629] = 1542,
  [1630] = 1543,
  [1631] = 1544,
  [1632] = 1545,
  [1633] = 1546,
  [1634] = 1547,
  [1635] = 1548,
  [1636] = 1524,
  [1637] = 1637,
  [1638] = 1521,
  [1639] = 1639,
  [1640] = 1535,
  [1641] = 1538,
  [1642] = 1539,
  [1643] = 1540,
  [1644] = 1541,
  [1645] = 1542,
  [1646] = 1543,
  [1647] = 1544,
  [1648] = 1545,
  [1649] = 1546,
  [1650] = 1547,
  [1651] = 1533,
  [1652] = 1534,
  [1653] = 1536,
  [1654] = 1548,
  [1655] = 1524,
  [1656] = 1521,
  [1657] = 1523,
  [1658] = 1526,
  [1659] = 1618,
  [1660] = 1533,
  [1661] = 1534,
  [1662] = 1556,
  [1663] = 1535,
  [1664] = 1536,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1637,
  [1668] = 1538,
  [1669] = 1539,
  [1670] = 1540,
  [1671] = 1525,
  [1672] = 1542,
  [1673] = 1543,
  [1674] = 1544,
  [1675] = 1545,
  [1676] = 1546,
  [1677] = 1547,
  [1678] = 1548,
  [1679] = 1679,
  [1680] = 1524,
  [1681] = 1536,
  [1682] = 1521,
  [1683] = 1535,
  [1684] = 1538,
  [1685] = 1539,
  [1686] = 1540,
  [1687] = 1541,
  [1688] = 1542,
  [1689] = 1543,
  [1690] = 1544,
  [1691] = 1545,
  [1692] = 1546,
  [1693] = 1547,
  [1694] = 1533,
  [1695] = 1534,
  [1696] = 1523,
  [1697] = 1618,
  [1698] = 1521,
  [1699] = 1556,
  [1700] = 1533,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1534,
  [1704] = 1535,
  [1705] = 1538,
  [1706] = 1539,
  [1707] = 1540,
  [1708] = 1541,
  [1709] = 1542,
  [1710] = 1543,
  [1711] = 1544,
  [1712] = 1545,
  [1713] = 1546,
  [1714] = 1547,
  [1715] = 1523,
  [1716] = 1618,
  [1717] = 1717,
  [1718] = 1531,
  [1719] = 1535,
  [1720] = 1538,
  [1721] = 1539,
  [1722] = 1540,
  [1723] = 1541,
  [1724] = 1542,
  [1725] = 1543,
  [1726] = 1544,
  [1727] = 1545,
  [1728] = 1546,
  [1729] = 1547,
  [1730] = 1523,
  [1731] = 1532,
  [1732] = 1618,
  [1733] = 1523,
  [1734] = 1618,
  [1735] = 1679,
  [1736] = 1523,
  [1737] = 1618,
  [1738] = 1523,
  [1739] = 1618,
  [1740] = 1523,
  [1741] = 1618,
  [1742] = 1533,
  [1743] = 1534,
  [1744] = 1701,
  [1745] = 1702,
  [1746] = 1535,
  [1747] = 1536,
  [1748] = 1538,
  [1749] = 1539,
  [1750] = 1540,
  [1751] = 1541,
  [1752] = 1542,
  [1753] = 1543,
  [1754] = 1544,
  [1755] = 1545,
  [1756] = 1546,
  [1757] = 1547,
  [1758] = 1535,
  [1759] = 1548,
  [1760] = 1612,
  [1761] = 1568,
  [1762] = 1578,
  [1763] = 1583,
  [1764] = 1524,
  [1765] = 1613,
  [1766] = 1521,
  [1767] = 1536,
  [1768] = 1519,
  [1769] = 1701,
  [1770] = 1702,
  [1771] = 1612,
  [1772] = 1568,
  [1773] = 1578,
  [1774] = 1583,
  [1775] = 1613,
  [1776] = 1519,
  [1777] = 1701,
  [1778] = 1702,
  [1779] = 1612,
  [1780] = 1568,
  [1781] = 1578,
  [1782] = 1583,
  [1783] = 1613,
  [1784] = 1519,
  [1785] = 1701,
  [1786] = 1702,
  [1787] = 1612,
  [1788] = 1568,
  [1789] = 1578,
  [1790] = 1583,
  [1791] = 1613,
  [1792] = 1519,
  [1793] = 1612,
  [1794] = 1568,
  [1795] = 1578,
  [1796] = 1583,
  [1797] = 1613,
  [1798] = 1612,
  [1799] = 1568,
  [1800] = 1583,
  [1801] = 1613,
  [1802] = 1583,
  [1803] = 1583,
  [1804] = 1523,
  [1805] = 1618,
  [1806] = 1806,
  [1807] = 1533,
  [1808] = 1534,
  [1809] = 1618,
  [1810] = 1549,
  [1811] = 1538,
  [1812] = 1539,
  [1813] = 1540,
  [1814] = 1541,
  [1815] = 1523,
  [1816] = 1618,
  [1817] = 1542,
  [1818] = 1539,
  [1819] = 1543,
  [1820] = 1544,
  [1821] = 1545,
  [1822] = 1546,
  [1823] = 1547,
  [1824] = 1548,
  [1825] = 1549,
  [1826] = 1549,
  [1827] = 1549,
  [1828] = 1549,
  [1829] = 1549,
  [1830] = 1556,
  [1831] = 1535,
  [1832] = 1538,
  [1833] = 1539,
  [1834] = 1540,
  [1835] = 1541,
  [1836] = 1542,
  [1837] = 1543,
  [1838] = 1544,
  [1839] = 1545,
  [1840] = 1546,
  [1841] = 1547,
  [1842] = 1533,
  [1843] = 1534,
  [1844] = 1536,
  [1845] = 1548,
  [1846] = 1524,
  [1847] = 1521,
  [1848] = 1535,
  [1849] = 1536,
  [1850] = 1538,
  [1851] = 1540,
  [1852] = 1541,
  [1853] = 1542,
  [1854] = 1543,
  [1855] = 1544,
  [1856] = 1545,
  [1857] = 1546,
  [1858] = 1547,
  [1859] = 1548,
  [1860] = 1524,
  [1861] = 1521,
  [1862] = 1523,
  [1863] = 1618,
  [1864] = 1533,
  [1865] = 1534,
  [1866] = 1525,
  [1867] = 1525,
  [1868] = 1525,
  [1869] = 1541,
  [1870] = 1870,
  [1871] = 190,
  [1872] = 192,
  [1873] = 1870,
  [1874] = 157,
  [1875] = 168,
  [1876] = 1870,
  [1877] = 1870,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1881,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1884,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1893,
  [1894] = 1894,
  [1895] = 139,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1897,
  [1899] = 1897,
  [1900] = 1900,
  [1901] = 199,
  [1902] = 1897,
  [1903] = 1900,
  [1904] = 228,
  [1905] = 1897,
  [1906] = 228,
  [1907] = 1900,
  [1908] = 138,
  [1909] = 1897,
  [1910] = 1900,
  [1911] = 1897,
  [1912] = 255,
  [1913] = 1913,
  [1914] = 370,
  [1915] = 1915,
  [1916] = 374,
  [1917] = 376,
  [1918] = 1918,
  [1919] = 377,
  [1920] = 1920,
  [1921] = 378,
  [1922] = 379,
  [1923] = 412,
  [1924] = 1924,
  [1925] = 417,
  [1926] = 266,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 396,
  [1934] = 397,
  [1935] = 398,
  [1936] = 403,
  [1937] = 1937,
  [1938] = 415,
  [1939] = 341,
  [1940] = 402,
  [1941] = 404,
  [1942] = 406,
  [1943] = 407,
  [1944] = 418,
  [1945] = 274,
  [1946] = 1946,
  [1947] = 1947,
  [1948] = 298,
  [1949] = 314,
  [1950] = 321,
  [1951] = 1951,
  [1952] = 256,
  [1953] = 257,
  [1954] = 345,
  [1955] = 354,
  [1956] = 205,
  [1957] = 206,
  [1958] = 207,
  [1959] = 1959,
  [1960] = 1960,
  [1961] = 208,
  [1962] = 405,
  [1963] = 218,
  [1964] = 219,
  [1965] = 387,
  [1966] = 224,
  [1967] = 1967,
  [1968] = 351,
  [1969] = 352,
  [1970] = 283,
  [1971] = 284,
  [1972] = 1972,
  [1973] = 1973,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1976,
  [1977] = 1977,
  [1978] = 281,
  [1979] = 344,
  [1980] = 282,
  [1981] = 355,
  [1982] = 356,
  [1983] = 357,
  [1984] = 275,
  [1985] = 358,
  [1986] = 359,
  [1987] = 360,
  [1988] = 362,
  [1989] = 364,
  [1990] = 366,
  [1991] = 276,
  [1992] = 381,
  [1993] = 389,
  [1994] = 390,
  [1995] = 392,
  [1996] = 367,
  [1997] = 1997,
  [1998] = 1998,
  [1999] = 1999,
  [2000] = 2000,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 393,
  [2006] = 394,
  [2007] = 2007,
  [2008] = 395,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 2011,
  [2012] = 168,
  [2013] = 157,
  [2014] = 190,
  [2015] = 192,
  [2016] = 192,
  [2017] = 2017,
  [2018] = 168,
  [2019] = 190,
  [2020] = 157,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2022,
  [2024] = 2024,
  [2025] = 2021,
  [2026] = 2021,
  [2027] = 2021,
  [2028] = 2022,
  [2029] = 2021,
  [2030] = 2021,
  [2031] = 2022,
  [2032] = 2022,
  [2033] = 2022,
  [2034] = 2021,
  [2035] = 2022,
  [2036] = 166,
  [2037] = 2037,
  [2038] = 228,
  [2039] = 155,
  [2040] = 199,
  [2041] = 2037,
  [2042] = 167,
  [2043] = 2037,
  [2044] = 2037,
  [2045] = 228,
  [2046] = 199,
  [2047] = 228,
  [2048] = 228,
  [2049] = 139,
  [2050] = 138,
  [2051] = 165,
  [2052] = 298,
  [2053] = 1951,
  [2054] = 1967,
  [2055] = 1937,
  [2056] = 1946,
  [2057] = 341,
  [2058] = 402,
  [2059] = 404,
  [2060] = 406,
  [2061] = 1947,
  [2062] = 2011,
  [2063] = 314,
  [2064] = 321,
  [2065] = 2007,
  [2066] = 1915,
  [2067] = 1918,
  [2068] = 1920,
  [2069] = 1924,
  [2070] = 2003,
  [2071] = 352,
  [2072] = 1927,
  [2073] = 360,
  [2074] = 367,
  [2075] = 2004,
  [2076] = 1928,
  [2077] = 1929,
  [2078] = 370,
  [2079] = 374,
  [2080] = 376,
  [2081] = 377,
  [2082] = 1930,
  [2083] = 1931,
  [2084] = 1932,
  [2085] = 390,
  [2086] = 344,
  [2087] = 412,
  [2088] = 417,
  [2089] = 2089,
  [2090] = 355,
  [2091] = 275,
  [2092] = 356,
  [2093] = 2001,
  [2094] = 276,
  [2095] = 1959,
  [2096] = 281,
  [2097] = 1960,
  [2098] = 1972,
  [2099] = 1973,
  [2100] = 1913,
  [2101] = 358,
  [2102] = 255,
  [2103] = 359,
  [2104] = 362,
  [2105] = 256,
  [2106] = 364,
  [2107] = 366,
  [2108] = 1974,
  [2109] = 1975,
  [2110] = 381,
  [2111] = 1997,
  [2112] = 392,
  [2113] = 1976,
  [2114] = 393,
  [2115] = 205,
  [2116] = 206,
  [2117] = 394,
  [2118] = 395,
  [2119] = 396,
  [2120] = 397,
  [2121] = 398,
  [2122] = 1998,
  [2123] = 257,
  [2124] = 403,
  [2125] = 1999,
  [2126] = 283,
  [2127] = 1977,
  [2128] = 2000,
  [2129] = 2002,
  [2130] = 218,
  [2131] = 2003,
  [2132] = 2004,
  [2133] = 282,
  [2134] = 415,
  [2135] = 2135,
  [2136] = 1959,
  [2137] = 407,
  [2138] = 224,
  [2139] = 418,
  [2140] = 274,
  [2141] = 344,
  [2142] = 1960,
  [2143] = 355,
  [2144] = 356,
  [2145] = 357,
  [2146] = 345,
  [2147] = 358,
  [2148] = 359,
  [2149] = 354,
  [2150] = 2150,
  [2151] = 362,
  [2152] = 364,
  [2153] = 207,
  [2154] = 208,
  [2155] = 405,
  [2156] = 1972,
  [2157] = 366,
  [2158] = 381,
  [2159] = 1973,
  [2160] = 1974,
  [2161] = 389,
  [2162] = 390,
  [2163] = 392,
  [2164] = 2009,
  [2165] = 2010,
  [2166] = 394,
  [2167] = 395,
  [2168] = 396,
  [2169] = 397,
  [2170] = 398,
  [2171] = 403,
  [2172] = 1913,
  [2173] = 2173,
  [2174] = 275,
  [2175] = 276,
  [2176] = 415,
  [2177] = 1951,
  [2178] = 284,
  [2179] = 341,
  [2180] = 402,
  [2181] = 404,
  [2182] = 406,
  [2183] = 407,
  [2184] = 418,
  [2185] = 274,
  [2186] = 1975,
  [2187] = 1976,
  [2188] = 298,
  [2189] = 1967,
  [2190] = 1937,
  [2191] = 314,
  [2192] = 321,
  [2193] = 345,
  [2194] = 354,
  [2195] = 281,
  [2196] = 282,
  [2197] = 1946,
  [2198] = 351,
  [2199] = 352,
  [2200] = 360,
  [2201] = 367,
  [2202] = 351,
  [2203] = 1947,
  [2204] = 370,
  [2205] = 374,
  [2206] = 376,
  [2207] = 377,
  [2208] = 378,
  [2209] = 379,
  [2210] = 283,
  [2211] = 412,
  [2212] = 417,
  [2213] = 284,
  [2214] = 266,
  [2215] = 2011,
  [2216] = 2007,
  [2217] = 1915,
  [2218] = 1977,
  [2219] = 378,
  [2220] = 379,
  [2221] = 219,
  [2222] = 387,
  [2223] = 1918,
  [2224] = 1920,
  [2225] = 1924,
  [2226] = 1927,
  [2227] = 1928,
  [2228] = 1929,
  [2229] = 1930,
  [2230] = 255,
  [2231] = 256,
  [2232] = 257,
  [2233] = 205,
  [2234] = 206,
  [2235] = 207,
  [2236] = 208,
  [2237] = 405,
  [2238] = 218,
  [2239] = 219,
  [2240] = 387,
  [2241] = 224,
  [2242] = 152,
  [2243] = 266,
  [2244] = 2009,
  [2245] = 151,
  [2246] = 2010,
  [2247] = 1931,
  [2248] = 389,
  [2249] = 1932,
  [2250] = 2001,
  [2251] = 357,
  [2252] = 1997,
  [2253] = 1998,
  [2254] = 1999,
  [2255] = 2000,
  [2256] = 2002,
  [2257] = 393,
  [2258] = 1122,
  [2259] = 948,
  [2260] = 169,
  [2261] = 1312,
  [2262] = 949,
  [2263] = 143,
  [2264] = 2264,
  [2265] = 165,
  [2266] = 166,
  [2267] = 167,
  [2268] = 2268,
  [2269] = 1122,
  [2270] = 155,
  [2271] = 156,
  [2272] = 2272,
  [2273] = 139,
  [2274] = 2274,
  [2275] = 138,
  [2276] = 169,
  [2277] = 2277,
  [2278] = 144,
  [2279] = 140,
  [2280] = 145,
  [2281] = 146,
  [2282] = 148,
  [2283] = 147,
  [2284] = 156,
  [2285] = 2285,
  [2286] = 2286,
  [2287] = 152,
  [2288] = 1122,
  [2289] = 151,
  [2290] = 2274,
  [2291] = 2291,
  [2292] = 1369,
  [2293] = 1385,
  [2294] = 2294,
  [2295] = 2295,
  [2296] = 2296,
  [2297] = 2272,
  [2298] = 2277,
  [2299] = 2277,
  [2300] = 2300,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2272,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 147,
  [2307] = 2307,
  [2308] = 146,
  [2309] = 143,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 148,
  [2313] = 2274,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 140,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 144,
  [2322] = 2322,
  [2323] = 145,
  [2324] = 2324,
  [2325] = 231,
  [2326] = 2326,
  [2327] = 229,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2272,
  [2331] = 2331,
  [2332] = 2329,
  [2333] = 2329,
  [2334] = 2329,
  [2335] = 2329,
  [2336] = 2302,
  [2337] = 2331,
  [2338] = 2331,
  [2339] = 2277,
  [2340] = 2331,
  [2341] = 2329,
  [2342] = 2329,
  [2343] = 2017,
  [2344] = 2302,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2272,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2277,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2363,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2366,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 2374,
  [2375] = 2375,
  [2376] = 2376,
  [2377] = 2377,
  [2378] = 1385,
  [2379] = 2379,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 1312,
  [2383] = 2383,
  [2384] = 2384,
  [2385] = 2385,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 2389,
  [2391] = 1312,
  [2392] = 2389,
  [2393] = 2393,
  [2394] = 2393,
  [2395] = 2389,
  [2396] = 2393,
  [2397] = 2393,
  [2398] = 2393,
  [2399] = 2389,
  [2400] = 2393,
  [2401] = 2393,
  [2402] = 2389,
  [2403] = 2389,
  [2404] = 2404,
  [2405] = 2405,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2277,
  [2410] = 2272,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2419,
  [2420] = 2302,
  [2421] = 2274,
  [2422] = 2422,
  [2423] = 1312,
  [2424] = 2274,
  [2425] = 2302,
  [2426] = 2300,
  [2427] = 1385,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2411,
  [2431] = 1369,
  [2432] = 2432,
  [2433] = 1369,
  [2434] = 2434,
  [2435] = 1312,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 949,
  [2441] = 2422,
  [2442] = 998,
  [2443] = 2438,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 1369,
  [2447] = 2447,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 1385,
  [2451] = 2444,
  [2452] = 2439,
  [2453] = 2444,
  [2454] = 2439,
  [2455] = 2438,
  [2456] = 948,
  [2457] = 2444,
  [2458] = 2439,
  [2459] = 2439,
  [2460] = 2439,
  [2461] = 2439,
  [2462] = 146,
  [2463] = 2296,
  [2464] = 2274,
  [2465] = 144,
  [2466] = 140,
  [2467] = 152,
  [2468] = 145,
  [2469] = 2469,
  [2470] = 2428,
  [2471] = 2376,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 148,
  [2475] = 147,
  [2476] = 2429,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 151,
  [2480] = 143,
  [2481] = 2302,
  [2482] = 156,
  [2483] = 2274,
  [2484] = 2484,
  [2485] = 148,
  [2486] = 1369,
  [2487] = 2487,
  [2488] = 146,
  [2489] = 1369,
  [2490] = 1385,
  [2491] = 2491,
  [2492] = 1385,
  [2493] = 147,
  [2494] = 143,
  [2495] = 2448,
  [2496] = 2445,
  [2497] = 144,
  [2498] = 2498,
  [2499] = 140,
  [2500] = 145,
  [2501] = 2501,
  [2502] = 144,
  [2503] = 140,
  [2504] = 145,
  [2505] = 148,
  [2506] = 146,
  [2507] = 169,
  [2508] = 143,
  [2509] = 147,
  [2510] = 1147,
  [2511] = 2511,
  [2512] = 1159,
  [2513] = 1147,
  [2514] = 2422,
  [2515] = 156,
  [2516] = 1159,
  [2517] = 2478,
  [2518] = 143,
  [2519] = 165,
  [2520] = 166,
  [2521] = 2326,
  [2522] = 2522,
  [2523] = 144,
  [2524] = 140,
  [2525] = 145,
  [2526] = 155,
  [2527] = 2432,
  [2528] = 2434,
  [2529] = 1147,
  [2530] = 167,
  [2531] = 2531,
  [2532] = 2532,
  [2533] = 146,
  [2534] = 2473,
  [2535] = 148,
  [2536] = 1147,
  [2537] = 2324,
  [2538] = 147,
  [2539] = 2301,
  [2540] = 2346,
  [2541] = 2541,
  [2542] = 2272,
  [2543] = 2369,
  [2544] = 2366,
  [2545] = 2373,
  [2546] = 2277,
  [2547] = 2388,
  [2548] = 2383,
  [2549] = 2357,
  [2550] = 2368,
  [2551] = 2386,
  [2552] = 2380,
  [2553] = 2359,
  [2554] = 2469,
  [2555] = 2356,
  [2556] = 2381,
  [2557] = 2272,
  [2558] = 2302,
  [2559] = 2345,
  [2560] = 2379,
  [2561] = 2384,
  [2562] = 2277,
  [2563] = 2363,
  [2564] = 231,
  [2565] = 2385,
  [2566] = 2353,
  [2567] = 2349,
  [2568] = 2301,
  [2569] = 2365,
  [2570] = 2352,
  [2571] = 1147,
  [2572] = 1369,
  [2573] = 2362,
  [2574] = 1159,
  [2575] = 2350,
  [2576] = 1385,
  [2577] = 2377,
  [2578] = 2371,
  [2579] = 2374,
  [2580] = 2375,
  [2581] = 2348,
  [2582] = 2358,
  [2583] = 2387,
  [2584] = 2584,
  [2585] = 2347,
  [2586] = 2360,
  [2587] = 2361,
  [2588] = 2364,
  [2589] = 229,
  [2590] = 2354,
  [2591] = 2422,
  [2592] = 1159,
  [2593] = 2370,
  [2594] = 2017,
  [2595] = 151,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2272,
  [2599] = 2277,
  [2600] = 2600,
  [2601] = 2601,
  [2602] = 152,
  [2603] = 1159,
  [2604] = 1147,
  [2605] = 167,
  [2606] = 2584,
  [2607] = 2305,
  [2608] = 2315,
  [2609] = 2314,
  [2610] = 2316,
  [2611] = 2311,
  [2612] = 2317,
  [2613] = 2319,
  [2614] = 155,
  [2615] = 2541,
  [2616] = 2322,
  [2617] = 2307,
  [2618] = 1159,
  [2619] = 165,
  [2620] = 166,
  [2621] = 2304,
  [2622] = 2320,
  [2623] = 2541,
  [2624] = 169,
  [2625] = 2328,
  [2626] = 2584,
  [2627] = 2627,
  [2628] = 2310,
  [2629] = 2372,
  [2630] = 2498,
  [2631] = 2469,
  [2632] = 2291,
  [2633] = 2302,
  [2634] = 2469,
  [2635] = 2635,
  [2636] = 2274,
  [2637] = 2627,
  [2638] = 156,
  [2639] = 2301,
  [2640] = 2367,
  [2641] = 2635,
  [2642] = 2642,
  [2643] = 2635,
  [2644] = 2644,
  [2645] = 2491,
  [2646] = 2644,
  [2647] = 1147,
  [2648] = 2469,
  [2649] = 2487,
  [2650] = 2302,
  [2651] = 2498,
  [2652] = 2404,
  [2653] = 257,
  [2654] = 1369,
  [2655] = 2655,
  [2656] = 2407,
  [2657] = 2291,
  [2658] = 2469,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 1385,
  [2662] = 2659,
  [2663] = 2659,
  [2664] = 2326,
  [2665] = 2665,
  [2666] = 2469,
  [2667] = 2667,
  [2668] = 2411,
  [2669] = 2412,
  [2670] = 2491,
  [2671] = 2671,
  [2672] = 2272,
  [2673] = 208,
  [2674] = 405,
  [2675] = 1205,
  [2676] = 2448,
  [2677] = 2417,
  [2678] = 2487,
  [2679] = 2445,
  [2680] = 2416,
  [2681] = 2405,
  [2682] = 2408,
  [2683] = 219,
  [2684] = 387,
  [2685] = 2685,
  [2686] = 2346,
  [2687] = 2277,
  [2688] = 2406,
  [2689] = 2413,
  [2690] = 2659,
  [2691] = 2418,
  [2692] = 2419,
  [2693] = 2324,
  [2694] = 2659,
  [2695] = 2695,
  [2696] = 2659,
  [2697] = 2414,
  [2698] = 207,
  [2699] = 2353,
  [2700] = 2359,
  [2701] = 2356,
  [2702] = 2352,
  [2703] = 2373,
  [2704] = 2348,
  [2705] = 2705,
  [2706] = 2469,
  [2707] = 1312,
  [2708] = 2363,
  [2709] = 2362,
  [2710] = 2350,
  [2711] = 2328,
  [2712] = 2712,
  [2713] = 2305,
  [2714] = 2314,
  [2715] = 2374,
  [2716] = 2375,
  [2717] = 2473,
  [2718] = 2718,
  [2719] = 2358,
  [2720] = 2274,
  [2721] = 2322,
  [2722] = 2307,
  [2723] = 2387,
  [2724] = 2385,
  [2725] = 2347,
  [2726] = 2469,
  [2727] = 2354,
  [2728] = 2372,
  [2729] = 2365,
  [2730] = 2369,
  [2731] = 2731,
  [2732] = 2315,
  [2733] = 2317,
  [2734] = 2319,
  [2735] = 2304,
  [2736] = 2320,
  [2737] = 2366,
  [2738] = 2738,
  [2739] = 2388,
  [2740] = 2017,
  [2741] = 2411,
  [2742] = 2305,
  [2743] = 2310,
  [2744] = 2367,
  [2745] = 2314,
  [2746] = 2383,
  [2747] = 2368,
  [2748] = 231,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2322,
  [2753] = 2627,
  [2754] = 2498,
  [2755] = 2755,
  [2756] = 2315,
  [2757] = 2757,
  [2758] = 2316,
  [2759] = 2311,
  [2760] = 2317,
  [2761] = 2319,
  [2762] = 2304,
  [2763] = 2763,
  [2764] = 2357,
  [2765] = 2532,
  [2766] = 2349,
  [2767] = 2361,
  [2768] = 2364,
  [2769] = 2320,
  [2770] = 2370,
  [2771] = 2377,
  [2772] = 2380,
  [2773] = 2310,
  [2774] = 2774,
  [2775] = 2381,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2345,
  [2779] = 2491,
  [2780] = 2371,
  [2781] = 2469,
  [2782] = 2531,
  [2783] = 2360,
  [2784] = 2784,
  [2785] = 2379,
  [2786] = 2786,
  [2787] = 2316,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2384,
  [2791] = 2478,
  [2792] = 1147,
  [2793] = 2311,
  [2794] = 229,
  [2795] = 2487,
  [2796] = 2796,
  [2797] = 2469,
  [2798] = 2386,
  [2799] = 1147,
  [2800] = 2307,
  [2801] = 2408,
  [2802] = 2328,
  [2803] = 2412,
  [2804] = 2448,
  [2805] = 2445,
  [2806] = 2473,
  [2807] = 2478,
  [2808] = 2418,
  [2809] = 2305,
  [2810] = 2541,
  [2811] = 2301,
  [2812] = 2812,
  [2813] = 2813,
  [2814] = 2416,
  [2815] = 2584,
  [2816] = 2816,
  [2817] = 2315,
  [2818] = 2316,
  [2819] = 2311,
  [2820] = 2314,
  [2821] = 2320,
  [2822] = 2417,
  [2823] = 2823,
  [2824] = 2414,
  [2825] = 2407,
  [2826] = 2826,
  [2827] = 2406,
  [2828] = 2419,
  [2829] = 2413,
  [2830] = 2627,
  [2831] = 2531,
  [2832] = 2832,
  [2833] = 2532,
  [2834] = 2319,
  [2835] = 2405,
  [2836] = 2304,
  [2837] = 2404,
  [2838] = 2322,
  [2839] = 2839,
  [2840] = 2307,
  [2841] = 1159,
  [2842] = 2310,
  [2843] = 2317,
  [2844] = 2844,
  [2845] = 2845,
  [2846] = 2846,
  [2847] = 2328,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2302,
  [2851] = 2851,
  [2852] = 2852,
  [2853] = 2853,
  [2854] = 2854,
  [2855] = 2473,
  [2856] = 2301,
  [2857] = 2857,
  [2858] = 2478,
  [2859] = 949,
  [2860] = 2860,
  [2861] = 2445,
  [2862] = 2862,
  [2863] = 2473,
  [2864] = 2864,
  [2865] = 2532,
  [2866] = 2448,
  [2867] = 2487,
  [2868] = 948,
  [2869] = 2869,
  [2870] = 2870,
  [2871] = 2871,
  [2872] = 2872,
  [2873] = 2873,
  [2874] = 2874,
  [2875] = 2498,
  [2876] = 2531,
  [2877] = 2478,
  [2878] = 1159,
  [2879] = 2531,
  [2880] = 2291,
  [2881] = 2532,
  [2882] = 2627,
  [2883] = 2883,
  [2884] = 2491,
  [2885] = 2885,
  [2886] = 1888,
  [2887] = 1889,
  [2888] = 1892,
  [2889] = 2372,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2478,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2367,
  [2896] = 2896,
  [2897] = 2897,
  [2898] = 2898,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 2901,
  [2902] = 2902,
  [2903] = 2903,
  [2904] = 2904,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2907,
  [2908] = 2908,
  [2909] = 2909,
  [2910] = 2291,
  [2911] = 2911,
  [2912] = 2912,
  [2913] = 2913,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2916,
  [2917] = 2917,
  [2918] = 2918,
  [2919] = 2919,
  [2920] = 2920,
  [2921] = 2921,
  [2922] = 1893,
  [2923] = 139,
  [2924] = 2924,
  [2925] = 2448,
  [2926] = 2926,
  [2927] = 2531,
  [2928] = 2928,
  [2929] = 138,
  [2930] = 1891,
  [2931] = 2445,
  [2932] = 2532,
  [2933] = 2933,
  [2934] = 2934,
  [2935] = 2532,
  [2936] = 2936,
  [2937] = 2937,
  [2938] = 2473,
  [2939] = 2939,
  [2940] = 2940,
  [2941] = 2941,
  [2942] = 2478,
  [2943] = 2943,
  [2944] = 2944,
  [2945] = 2945,
  [2946] = 1885,
  [2947] = 1878,
  [2948] = 1886,
  [2949] = 2949,
  [2950] = 1890,
  [2951] = 2951,
  [2952] = 2952,
  [2953] = 2286,
  [2954] = 2473,
  [2955] = 2955,
  [2956] = 2301,
  [2957] = 1880,
  [2958] = 2285,
  [2959] = 2959,
  [2960] = 1887,
  [2961] = 2961,
  [2962] = 2962,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 1881,
  [2966] = 2966,
  [2967] = 2967,
  [2968] = 2968,
  [2969] = 2969,
  [2970] = 2970,
  [2971] = 2971,
  [2972] = 1882,
  [2973] = 1883,
  [2974] = 1884,
  [2975] = 2531,
  [2976] = 2406,
  [2977] = 148,
  [2978] = 147,
  [2979] = 2316,
  [2980] = 2416,
  [2981] = 2411,
  [2982] = 2417,
  [2983] = 143,
  [2984] = 2412,
  [2985] = 2413,
  [2986] = 151,
  [2987] = 2314,
  [2988] = 2418,
  [2989] = 2311,
  [2990] = 2419,
  [2991] = 144,
  [2992] = 2408,
  [2993] = 2414,
  [2994] = 2346,
  [2995] = 2322,
  [2996] = 2307,
  [2997] = 140,
  [2998] = 145,
  [2999] = 2531,
  [3000] = 2326,
  [3001] = 2324,
  [3002] = 169,
  [3003] = 2473,
  [3004] = 2407,
  [3005] = 155,
  [3006] = 2405,
  [3007] = 2305,
  [3008] = 165,
  [3009] = 2315,
  [3010] = 2317,
  [3011] = 2319,
  [3012] = 2304,
  [3013] = 152,
  [3014] = 166,
  [3015] = 2320,
  [3016] = 2532,
  [3017] = 167,
  [3018] = 2627,
  [3019] = 2478,
  [3020] = 2310,
  [3021] = 146,
  [3022] = 2404,
  [3023] = 2364,
  [3024] = 2411,
  [3025] = 2319,
  [3026] = 2304,
  [3027] = 2320,
  [3028] = 2017,
  [3029] = 2445,
  [3030] = 151,
  [3031] = 2962,
  [3032] = 152,
  [3033] = 2380,
  [3034] = 2381,
  [3035] = 2491,
  [3036] = 2363,
  [3037] = 2963,
  [3038] = 2386,
  [3039] = 2359,
  [3040] = 2301,
  [3041] = 2356,
  [3042] = 2498,
  [3043] = 2531,
  [3044] = 2532,
  [3045] = 2371,
  [3046] = 2360,
  [3047] = 2310,
  [3048] = 2291,
  [3049] = 2473,
  [3050] = 2345,
  [3051] = 2379,
  [3052] = 2384,
  [3053] = 151,
  [3054] = 229,
  [3055] = 2478,
  [3056] = 231,
  [3057] = 2370,
  [3058] = 2353,
  [3059] = 2963,
  [3060] = 2349,
  [3061] = 2352,
  [3062] = 2962,
  [3063] = 156,
  [3064] = 155,
  [3065] = 2358,
  [3066] = 2373,
  [3067] = 2348,
  [3068] = 2305,
  [3069] = 2362,
  [3070] = 2350,
  [3071] = 2374,
  [3072] = 2375,
  [3073] = 2448,
  [3074] = 2314,
  [3075] = 2316,
  [3076] = 2365,
  [3077] = 2311,
  [3078] = 2315,
  [3079] = 2317,
  [3080] = 2322,
  [3081] = 2307,
  [3082] = 2387,
  [3083] = 2347,
  [3084] = 2354,
  [3085] = 2366,
  [3086] = 2487,
  [3087] = 2388,
  [3088] = 169,
  [3089] = 2357,
  [3090] = 2377,
  [3091] = 2383,
  [3092] = 165,
  [3093] = 2368,
  [3094] = 166,
  [3095] = 2361,
  [3096] = 2385,
  [3097] = 167,
  [3098] = 2369,
  [3099] = 152,
  [3100] = 2478,
  [3101] = 167,
  [3102] = 2448,
  [3103] = 2473,
  [3104] = 2328,
  [3105] = 155,
  [3106] = 169,
  [3107] = 165,
  [3108] = 156,
  [3109] = 2445,
  [3110] = 2531,
  [3111] = 2532,
  [3112] = 166,
  [3113] = 151,
  [3114] = 145,
  [3115] = 2372,
  [3116] = 146,
  [3117] = 148,
  [3118] = 147,
  [3119] = 155,
  [3120] = 152,
  [3121] = 3121,
  [3122] = 2316,
  [3123] = 2311,
  [3124] = 3124,
  [3125] = 2597,
  [3126] = 156,
  [3127] = 235,
  [3128] = 3121,
  [3129] = 3129,
  [3130] = 2328,
  [3131] = 2411,
  [3132] = 2367,
  [3133] = 140,
  [3134] = 2601,
  [3135] = 3135,
  [3136] = 167,
  [3137] = 2596,
  [3138] = 3138,
  [3139] = 2305,
  [3140] = 2314,
  [3141] = 2600,
  [3142] = 2322,
  [3143] = 2307,
  [3144] = 169,
  [3145] = 165,
  [3146] = 156,
  [3147] = 246,
  [3148] = 166,
  [3149] = 143,
  [3150] = 2315,
  [3151] = 2317,
  [3152] = 2319,
  [3153] = 2304,
  [3154] = 2320,
  [3155] = 3155,
  [3156] = 144,
  [3157] = 2310,
  [3158] = 3158,
  [3159] = 2601,
  [3160] = 3160,
  [3161] = 2532,
  [3162] = 2893,
  [3163] = 3163,
  [3164] = 2966,
  [3165] = 169,
  [3166] = 143,
  [3167] = 3167,
  [3168] = 2967,
  [3169] = 2968,
  [3170] = 3170,
  [3171] = 2969,
  [3172] = 155,
  [3173] = 3173,
  [3174] = 3174,
  [3175] = 144,
  [3176] = 2970,
  [3177] = 2971,
  [3178] = 3178,
  [3179] = 165,
  [3180] = 2448,
  [3181] = 140,
  [3182] = 166,
  [3183] = 145,
  [3184] = 146,
  [3185] = 2891,
  [3186] = 2473,
  [3187] = 2597,
  [3188] = 148,
  [3189] = 2416,
  [3190] = 147,
  [3191] = 2478,
  [3192] = 167,
  [3193] = 3193,
  [3194] = 3194,
  [3195] = 3195,
  [3196] = 2404,
  [3197] = 3197,
  [3198] = 2367,
  [3199] = 2918,
  [3200] = 2406,
  [3201] = 2445,
  [3202] = 2600,
  [3203] = 2372,
  [3204] = 2417,
  [3205] = 3205,
  [3206] = 3206,
  [3207] = 2414,
  [3208] = 3208,
  [3209] = 2915,
  [3210] = 2405,
  [3211] = 2418,
  [3212] = 2413,
  [3213] = 2419,
  [3214] = 2596,
  [3215] = 3215,
  [3216] = 2412,
  [3217] = 3217,
  [3218] = 2531,
  [3219] = 2408,
  [3220] = 2407,
  [3221] = 3221,
  [3222] = 2412,
  [3223] = 2416,
  [3224] = 229,
  [3225] = 2345,
  [3226] = 231,
  [3227] = 2417,
  [3228] = 2404,
  [3229] = 3229,
  [3230] = 2962,
  [3231] = 3121,
  [3232] = 2387,
  [3233] = 2414,
  [3234] = 2357,
  [3235] = 2963,
  [3236] = 2328,
  [3237] = 2418,
  [3238] = 2419,
  [3239] = 2386,
  [3240] = 3121,
  [3241] = 2407,
  [3242] = 156,
  [3243] = 2405,
  [3244] = 1159,
  [3245] = 2408,
  [3246] = 2406,
  [3247] = 2413,
  [3248] = 3248,
  [3249] = 231,
  [3250] = 3221,
  [3251] = 3193,
  [3252] = 2387,
  [3253] = 3121,
  [3254] = 3121,
  [3255] = 3121,
  [3256] = 3174,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 2655,
  [3260] = 3260,
  [3261] = 3257,
  [3262] = 3258,
  [3263] = 205,
  [3264] = 3173,
  [3265] = 2660,
  [3266] = 229,
  [3267] = 3267,
  [3268] = 206,
  [3269] = 2324,
  [3270] = 2372,
  [3271] = 3271,
  [3272] = 3267,
  [3273] = 3257,
  [3274] = 3260,
  [3275] = 3158,
  [3276] = 3208,
  [3277] = 3257,
  [3278] = 3160,
  [3279] = 3260,
  [3280] = 3178,
  [3281] = 3217,
  [3282] = 3206,
  [3283] = 3257,
  [3284] = 2367,
  [3285] = 2326,
  [3286] = 3260,
  [3287] = 2941,
  [3288] = 2671,
  [3289] = 2346,
  [3290] = 1159,
  [3291] = 3205,
  [3292] = 3195,
  [3293] = 2600,
  [3294] = 2386,
  [3295] = 3258,
  [3296] = 2685,
  [3297] = 2601,
  [3298] = 3121,
  [3299] = 3257,
  [3300] = 3267,
  [3301] = 3260,
  [3302] = 3197,
  [3303] = 3271,
  [3304] = 3229,
  [3305] = 1147,
  [3306] = 3258,
  [3307] = 3267,
  [3308] = 3215,
  [3309] = 2667,
  [3310] = 3258,
  [3311] = 3260,
  [3312] = 2357,
  [3313] = 3248,
  [3314] = 2345,
  [3315] = 3194,
  [3316] = 3267,
  [3317] = 1147,
  [3318] = 2597,
  [3319] = 3271,
  [3320] = 3267,
  [3321] = 2596,
  [3322] = 3258,
  [3323] = 218,
  [3324] = 255,
  [3325] = 224,
  [3326] = 3170,
  [3327] = 256,
  [3328] = 3167,
  [3329] = 3163,
  [3330] = 3160,
  [3331] = 2660,
  [3332] = 2750,
  [3333] = 2685,
  [3334] = 2404,
  [3335] = 2384,
  [3336] = 2406,
  [3337] = 2373,
  [3338] = 2362,
  [3339] = 3339,
  [3340] = 2369,
  [3341] = 2350,
  [3342] = 2368,
  [3343] = 2374,
  [3344] = 2375,
  [3345] = 2348,
  [3346] = 2413,
  [3347] = 2407,
  [3348] = 2326,
  [3349] = 2414,
  [3350] = 2627,
  [3351] = 1159,
  [3352] = 2418,
  [3353] = 2419,
  [3354] = 3193,
  [3355] = 2352,
  [3356] = 3121,
  [3357] = 2417,
  [3358] = 3205,
  [3359] = 3194,
  [3360] = 3195,
  [3361] = 3197,
  [3362] = 2324,
  [3363] = 2408,
  [3364] = 2405,
  [3365] = 2388,
  [3366] = 3121,
  [3367] = 2749,
  [3368] = 3339,
  [3369] = 2346,
  [3370] = 1159,
  [3371] = 2383,
  [3372] = 3167,
  [3373] = 2365,
  [3374] = 2370,
  [3375] = 2796,
  [3376] = 3121,
  [3377] = 2385,
  [3378] = 2359,
  [3379] = 3121,
  [3380] = 2349,
  [3381] = 2416,
  [3382] = 2353,
  [3383] = 2655,
  [3384] = 3158,
  [3385] = 2377,
  [3386] = 2347,
  [3387] = 2380,
  [3388] = 2381,
  [3389] = 2757,
  [3390] = 2361,
  [3391] = 2671,
  [3392] = 3206,
  [3393] = 2017,
  [3394] = 2354,
  [3395] = 2366,
  [3396] = 2363,
  [3397] = 1147,
  [3398] = 3339,
  [3399] = 3215,
  [3400] = 2412,
  [3401] = 2667,
  [3402] = 2364,
  [3403] = 2755,
  [3404] = 2751,
  [3405] = 2379,
  [3406] = 3339,
  [3407] = 2356,
  [3408] = 3163,
  [3409] = 3170,
  [3410] = 3174,
  [3411] = 3178,
  [3412] = 3221,
  [3413] = 3208,
  [3414] = 3217,
  [3415] = 2371,
  [3416] = 2358,
  [3417] = 3417,
  [3418] = 3339,
  [3419] = 3173,
  [3420] = 2360,
  [3421] = 3339,
  [3422] = 2350,
  [3423] = 3121,
  [3424] = 2365,
  [3425] = 2832,
  [3426] = 2498,
  [3427] = 3215,
  [3428] = 2796,
  [3429] = 2757,
  [3430] = 2373,
  [3431] = 2385,
  [3432] = 2383,
  [3433] = 2869,
  [3434] = 2348,
  [3435] = 2883,
  [3436] = 2826,
  [3437] = 2749,
  [3438] = 2370,
  [3439] = 2368,
  [3440] = 3193,
  [3441] = 2883,
  [3442] = 3173,
  [3443] = 2388,
  [3444] = 2872,
  [3445] = 3121,
  [3446] = 2870,
  [3447] = 2854,
  [3448] = 3121,
  [3449] = 2750,
  [3450] = 3450,
  [3451] = 2487,
  [3452] = 2844,
  [3453] = 3453,
  [3454] = 2844,
  [3455] = 2361,
  [3456] = 2364,
  [3457] = 3160,
  [3458] = 2017,
  [3459] = 3194,
  [3460] = 2362,
  [3461] = 3206,
  [3462] = 2873,
  [3463] = 2883,
  [3464] = 3163,
  [3465] = 2377,
  [3466] = 2380,
  [3467] = 2381,
  [3468] = 231,
  [3469] = 2301,
  [3470] = 2371,
  [3471] = 2360,
  [3472] = 3170,
  [3473] = 3158,
  [3474] = 3229,
  [3475] = 3174,
  [3476] = 3121,
  [3477] = 2491,
  [3478] = 2347,
  [3479] = 2755,
  [3480] = 2366,
  [3481] = 2374,
  [3482] = 2358,
  [3483] = 3121,
  [3484] = 3248,
  [3485] = 2369,
  [3486] = 2353,
  [3487] = 2813,
  [3488] = 2356,
  [3489] = 3205,
  [3490] = 2864,
  [3491] = 2357,
  [3492] = 2375,
  [3493] = 1159,
  [3494] = 3197,
  [3495] = 2384,
  [3496] = 1147,
  [3497] = 2352,
  [3498] = 2291,
  [3499] = 2883,
  [3500] = 2627,
  [3501] = 3178,
  [3502] = 229,
  [3503] = 2363,
  [3504] = 2883,
  [3505] = 2386,
  [3506] = 2345,
  [3507] = 3221,
  [3508] = 3208,
  [3509] = 3121,
  [3510] = 3217,
  [3511] = 2853,
  [3512] = 2387,
  [3513] = 2349,
  [3514] = 2379,
  [3515] = 2359,
  [3516] = 3167,
  [3517] = 2751,
  [3518] = 3195,
  [3519] = 2354,
  [3520] = 2869,
  [3521] = 1884,
  [3522] = 3522,
  [3523] = 2941,
  [3524] = 1881,
  [3525] = 3525,
  [3526] = 1159,
  [3527] = 3527,
  [3528] = 2955,
  [3529] = 948,
  [3530] = 2291,
  [3531] = 2883,
  [3532] = 1891,
  [3533] = 2891,
  [3534] = 3534,
  [3535] = 949,
  [3536] = 2776,
  [3537] = 1892,
  [3538] = 2941,
  [3539] = 3534,
  [3540] = 1878,
  [3541] = 2324,
  [3542] = 1886,
  [3543] = 2813,
  [3544] = 1893,
  [3545] = 3229,
  [3546] = 1888,
  [3547] = 2883,
  [3548] = 1889,
  [3549] = 138,
  [3550] = 3550,
  [3551] = 2874,
  [3552] = 2826,
  [3553] = 3534,
  [3554] = 2839,
  [3555] = 2883,
  [3556] = 2705,
  [3557] = 2718,
  [3558] = 3534,
  [3559] = 2846,
  [3560] = 3534,
  [3561] = 2854,
  [3562] = 3193,
  [3563] = 3525,
  [3564] = 3534,
  [3565] = 2966,
  [3566] = 2869,
  [3567] = 2870,
  [3568] = 2913,
  [3569] = 3205,
  [3570] = 2853,
  [3571] = 2786,
  [3572] = 2789,
  [3573] = 3534,
  [3574] = 3534,
  [3575] = 2871,
  [3576] = 2967,
  [3577] = 3534,
  [3578] = 2968,
  [3579] = 2738,
  [3580] = 2969,
  [3581] = 2970,
  [3582] = 2774,
  [3583] = 2777,
  [3584] = 2898,
  [3585] = 2971,
  [3586] = 3206,
  [3587] = 2326,
  [3588] = 2784,
  [3589] = 2712,
  [3590] = 3215,
  [3591] = 2955,
  [3592] = 3527,
  [3593] = 3194,
  [3594] = 2873,
  [3595] = 3163,
  [3596] = 3170,
  [3597] = 3174,
  [3598] = 3178,
  [3599] = 3221,
  [3600] = 3208,
  [3601] = 3217,
  [3602] = 2872,
  [3603] = 3195,
  [3604] = 3197,
  [3605] = 2411,
  [3606] = 3527,
  [3607] = 139,
  [3608] = 1885,
  [3609] = 2864,
  [3610] = 1890,
  [3611] = 1887,
  [3612] = 2346,
  [3613] = 2913,
  [3614] = 3160,
  [3615] = 2844,
  [3616] = 3167,
  [3617] = 2854,
  [3618] = 3193,
  [3619] = 2870,
  [3620] = 3205,
  [3621] = 2853,
  [3622] = 3206,
  [3623] = 3215,
  [3624] = 3194,
  [3625] = 2873,
  [3626] = 3163,
  [3627] = 3170,
  [3628] = 3174,
  [3629] = 3178,
  [3630] = 3221,
  [3631] = 3208,
  [3632] = 3217,
  [3633] = 3195,
  [3634] = 3197,
  [3635] = 2864,
  [3636] = 3160,
  [3637] = 3167,
  [3638] = 3158,
  [3639] = 3173,
  [3640] = 3158,
  [3641] = 1882,
  [3642] = 1883,
  [3643] = 2872,
  [3644] = 2832,
  [3645] = 3248,
  [3646] = 2851,
  [3647] = 3173,
  [3648] = 1880,
  [3649] = 2898,
  [3650] = 2788,
  [3651] = 2347,
  [3652] = 1884,
  [3653] = 2906,
  [3654] = 2385,
  [3655] = 2369,
  [3656] = 2883,
  [3657] = 2885,
  [3658] = 2939,
  [3659] = 2944,
  [3660] = 2898,
  [3661] = 2844,
  [3662] = 2900,
  [3663] = 2901,
  [3664] = 2902,
  [3665] = 2757,
  [3666] = 2857,
  [3667] = 2846,
  [3668] = 3248,
  [3669] = 2371,
  [3670] = 1881,
  [3671] = 2893,
  [3672] = 2919,
  [3673] = 2017,
  [3674] = 2928,
  [3675] = 1893,
  [3676] = 2360,
  [3677] = 2903,
  [3678] = 2359,
  [3679] = 2356,
  [3680] = 2786,
  [3681] = 2788,
  [3682] = 2789,
  [3683] = 3121,
  [3684] = 2473,
  [3685] = 2907,
  [3686] = 2532,
  [3687] = 2379,
  [3688] = 3121,
  [3689] = 2384,
  [3690] = 2952,
  [3691] = 2478,
  [3692] = 2370,
  [3693] = 2961,
  [3694] = 2353,
  [3695] = 2894,
  [3696] = 2896,
  [3697] = 2897,
  [3698] = 2349,
  [3699] = 2352,
  [3700] = 2361,
  [3701] = 2364,
  [3702] = 2951,
  [3703] = 2738,
  [3704] = 152,
  [3705] = 2918,
  [3706] = 2909,
  [3707] = 2911,
  [3708] = 2498,
  [3709] = 2358,
  [3710] = 2487,
  [3711] = 2776,
  [3712] = 2912,
  [3713] = 2373,
  [3714] = 2914,
  [3715] = 2916,
  [3716] = 2917,
  [3717] = 2920,
  [3718] = 2921,
  [3719] = 2348,
  [3720] = 2874,
  [3721] = 2755,
  [3722] = 2940,
  [3723] = 1878,
  [3724] = 2941,
  [3725] = 151,
  [3726] = 1886,
  [3727] = 2363,
  [3728] = 3121,
  [3729] = 2905,
  [3730] = 2377,
  [3731] = 2749,
  [3732] = 2883,
  [3733] = 138,
  [3734] = 2955,
  [3735] = 1312,
  [3736] = 2274,
  [3737] = 2750,
  [3738] = 2705,
  [3739] = 2964,
  [3740] = 2718,
  [3741] = 2531,
  [3742] = 2627,
  [3743] = 2949,
  [3744] = 2354,
  [3745] = 139,
  [3746] = 2411,
  [3747] = 2305,
  [3748] = 2314,
  [3749] = 3121,
  [3750] = 2366,
  [3751] = 2851,
  [3752] = 2380,
  [3753] = 2388,
  [3754] = 2322,
  [3755] = 2307,
  [3756] = 2362,
  [3757] = 2350,
  [3758] = 2774,
  [3759] = 2315,
  [3760] = 2317,
  [3761] = 2319,
  [3762] = 2304,
  [3763] = 2320,
  [3764] = 2374,
  [3765] = 2310,
  [3766] = 2316,
  [3767] = 2311,
  [3768] = 2383,
  [3769] = 2368,
  [3770] = 2375,
  [3771] = 2491,
  [3772] = 2777,
  [3773] = 1880,
  [3774] = 2913,
  [3775] = 2285,
  [3776] = 2933,
  [3777] = 2908,
  [3778] = 2365,
  [3779] = 2934,
  [3780] = 2784,
  [3781] = 2712,
  [3782] = 2839,
  [3783] = 2891,
  [3784] = 2959,
  [3785] = 2943,
  [3786] = 2945,
  [3787] = 2381,
  [3788] = 1885,
  [3789] = 3121,
  [3790] = 1890,
  [3791] = 2286,
  [3792] = 1887,
  [3793] = 2926,
  [3794] = 2845,
  [3795] = 2849,
  [3796] = 2862,
  [3797] = 2860,
  [3798] = 948,
  [3799] = 1882,
  [3800] = 3229,
  [3801] = 2924,
  [3802] = 2941,
  [3803] = 2966,
  [3804] = 2936,
  [3805] = 2967,
  [3806] = 2968,
  [3807] = 2904,
  [3808] = 2848,
  [3809] = 1891,
  [3810] = 2969,
  [3811] = 2852,
  [3812] = 2970,
  [3813] = 1892,
  [3814] = 2971,
  [3815] = 2915,
  [3816] = 949,
  [3817] = 1888,
  [3818] = 1889,
  [3819] = 2937,
  [3820] = 1883,
  [3821] = 2871,
  [3822] = 2890,
  [3823] = 2899,
  [3824] = 2883,
  [3825] = 2854,
  [3826] = 2860,
  [3827] = 2473,
  [3828] = 2478,
  [3829] = 2964,
  [3830] = 3173,
  [3831] = 2531,
  [3832] = 2924,
  [3833] = 143,
  [3834] = 2883,
  [3835] = 3835,
  [3836] = 2893,
  [3837] = 3837,
  [3838] = 2908,
  [3839] = 3167,
  [3840] = 3840,
  [3841] = 2901,
  [3842] = 2951,
  [3843] = 2902,
  [3844] = 2940,
  [3845] = 144,
  [3846] = 1878,
  [3847] = 1886,
  [3848] = 3193,
  [3849] = 2532,
  [3850] = 3158,
  [3851] = 2904,
  [3852] = 1885,
  [3853] = 1887,
  [3854] = 2848,
  [3855] = 145,
  [3856] = 2898,
  [3857] = 1888,
  [3858] = 2286,
  [3859] = 1889,
  [3860] = 3194,
  [3861] = 2873,
  [3862] = 2891,
  [3863] = 2941,
  [3864] = 3163,
  [3865] = 2832,
  [3866] = 3866,
  [3867] = 2918,
  [3868] = 3170,
  [3869] = 2896,
  [3870] = 2897,
  [3871] = 2926,
  [3872] = 2936,
  [3873] = 2941,
  [3874] = 2937,
  [3875] = 143,
  [3876] = 3174,
  [3877] = 2928,
  [3878] = 3178,
  [3879] = 2941,
  [3880] = 2903,
  [3881] = 3221,
  [3882] = 144,
  [3883] = 140,
  [3884] = 145,
  [3885] = 2909,
  [3886] = 2911,
  [3887] = 2949,
  [3888] = 146,
  [3889] = 148,
  [3890] = 147,
  [3891] = 3891,
  [3892] = 3208,
  [3893] = 2907,
  [3894] = 139,
  [3895] = 2869,
  [3896] = 2912,
  [3897] = 2870,
  [3898] = 2905,
  [3899] = 2916,
  [3900] = 2933,
  [3901] = 138,
  [3902] = 2917,
  [3903] = 2921,
  [3904] = 140,
  [3905] = 3205,
  [3906] = 3217,
  [3907] = 3195,
  [3908] = 2943,
  [3909] = 2945,
  [3910] = 2934,
  [3911] = 1890,
  [3912] = 2853,
  [3913] = 2913,
  [3914] = 3197,
  [3915] = 1891,
  [3916] = 1892,
  [3917] = 169,
  [3918] = 146,
  [3919] = 2448,
  [3920] = 2845,
  [3921] = 1880,
  [3922] = 2285,
  [3923] = 148,
  [3924] = 3215,
  [3925] = 2959,
  [3926] = 2885,
  [3927] = 1881,
  [3928] = 2966,
  [3929] = 1159,
  [3930] = 2967,
  [3931] = 2968,
  [3932] = 2445,
  [3933] = 2969,
  [3934] = 2939,
  [3935] = 2832,
  [3936] = 2944,
  [3937] = 147,
  [3938] = 2890,
  [3939] = 2849,
  [3940] = 2899,
  [3941] = 2970,
  [3942] = 2906,
  [3943] = 3160,
  [3944] = 2900,
  [3945] = 2864,
  [3946] = 165,
  [3947] = 166,
  [3948] = 2971,
  [3949] = 2955,
  [3950] = 167,
  [3951] = 2915,
  [3952] = 2919,
  [3953] = 2862,
  [3954] = 1893,
  [3955] = 155,
  [3956] = 2952,
  [3957] = 2961,
  [3958] = 2894,
  [3959] = 1882,
  [3960] = 2941,
  [3961] = 1883,
  [3962] = 3206,
  [3963] = 2852,
  [3964] = 1884,
  [3965] = 2914,
  [3966] = 2857,
  [3967] = 2920,
  [3968] = 1159,
  [3969] = 3969,
  [3970] = 3970,
  [3971] = 3450,
  [3972] = 3972,
  [3973] = 3973,
  [3974] = 3974,
  [3975] = 3972,
  [3976] = 3970,
  [3977] = 3972,
  [3978] = 3972,
  [3979] = 3979,
  [3980] = 3972,
  [3981] = 2906,
  [3982] = 3982,
  [3983] = 152,
  [3984] = 2853,
  [3985] = 3985,
  [3986] = 3986,
  [3987] = 3972,
  [3988] = 3988,
  [3989] = 3982,
  [3990] = 3248,
  [3991] = 3979,
  [3992] = 3969,
  [3993] = 3982,
  [3994] = 3974,
  [3995] = 3453,
  [3996] = 2864,
  [3997] = 2869,
  [3998] = 3969,
  [3999] = 3988,
  [4000] = 3974,
  [4001] = 3450,
  [4002] = 2871,
  [4003] = 3979,
  [4004] = 3972,
  [4005] = 3979,
  [4006] = 3969,
  [4007] = 3982,
  [4008] = 3974,
  [4009] = 3979,
  [4010] = 3969,
  [4011] = 3974,
  [4012] = 2961,
  [4013] = 3969,
  [4014] = 3982,
  [4015] = 3974,
  [4016] = 3988,
  [4017] = 2871,
  [4018] = 3969,
  [4019] = 3974,
  [4020] = 3969,
  [4021] = 3972,
  [4022] = 3988,
  [4023] = 3972,
  [4024] = 2870,
  [4025] = 3988,
  [4026] = 4026,
  [4027] = 3982,
  [4028] = 3973,
  [4029] = 4029,
  [4030] = 3453,
  [4031] = 3979,
  [4032] = 3982,
  [4033] = 2908,
  [4034] = 3988,
  [4035] = 3229,
  [4036] = 3972,
  [4037] = 4029,
  [4038] = 3988,
  [4039] = 2531,
  [4040] = 2532,
  [4041] = 3982,
  [4042] = 4042,
  [4043] = 3972,
  [4044] = 3988,
  [4045] = 156,
  [4046] = 3982,
  [4047] = 4026,
  [4048] = 3972,
  [4049] = 3988,
  [4050] = 3972,
  [4051] = 2873,
  [4052] = 3969,
  [4053] = 2473,
  [4054] = 2627,
  [4055] = 3974,
  [4056] = 4026,
  [4057] = 2328,
  [4058] = 3973,
  [4059] = 2854,
  [4060] = 4026,
  [4061] = 3973,
  [4062] = 4026,
  [4063] = 3973,
  [4064] = 151,
  [4065] = 4026,
  [4066] = 3973,
  [4067] = 2912,
  [4068] = 2478,
  [4069] = 3974,
  [4070] = 2890,
  [4071] = 2952,
  [4072] = 2936,
  [4073] = 2940,
  [4074] = 2961,
  [4075] = 2894,
  [4076] = 2896,
  [4077] = 2897,
  [4078] = 2894,
  [4079] = 4079,
  [4080] = 2909,
  [4081] = 2933,
  [4082] = 2911,
  [4083] = 1878,
  [4084] = 1886,
  [4085] = 4079,
  [4086] = 2934,
  [4087] = 2914,
  [4088] = 2916,
  [4089] = 2917,
  [4090] = 2920,
  [4091] = 2921,
  [4092] = 1369,
  [4093] = 4093,
  [4094] = 4079,
  [4095] = 2949,
  [4096] = 2909,
  [4097] = 2911,
  [4098] = 2896,
  [4099] = 2933,
  [4100] = 2934,
  [4101] = 2897,
  [4102] = 2915,
  [4103] = 4079,
  [4104] = 4104,
  [4105] = 2908,
  [4106] = 4079,
  [4107] = 2943,
  [4108] = 2285,
  [4109] = 2945,
  [4110] = 2900,
  [4111] = 1890,
  [4112] = 4079,
  [4113] = 2901,
  [4114] = 2952,
  [4115] = 4079,
  [4116] = 1888,
  [4117] = 2937,
  [4118] = 2902,
  [4119] = 4079,
  [4120] = 1889,
  [4121] = 1891,
  [4122] = 1892,
  [4123] = 2936,
  [4124] = 2951,
  [4125] = 2937,
  [4126] = 2943,
  [4127] = 2940,
  [4128] = 2914,
  [4129] = 2916,
  [4130] = 2890,
  [4131] = 2899,
  [4132] = 2945,
  [4133] = 2918,
  [4134] = 1884,
  [4135] = 4079,
  [4136] = 2917,
  [4137] = 4137,
  [4138] = 2951,
  [4139] = 2906,
  [4140] = 2903,
  [4141] = 4079,
  [4142] = 2903,
  [4143] = 2899,
  [4144] = 2907,
  [4145] = 2448,
  [4146] = 2445,
  [4147] = 139,
  [4148] = 2601,
  [4149] = 2949,
  [4150] = 4079,
  [4151] = 2907,
  [4152] = 4079,
  [4153] = 2900,
  [4154] = 2901,
  [4155] = 4079,
  [4156] = 2902,
  [4157] = 138,
  [4158] = 2597,
  [4159] = 2531,
  [4160] = 2532,
  [4161] = 2600,
  [4162] = 2920,
  [4163] = 1385,
  [4164] = 2921,
  [4165] = 2596,
  [4166] = 2919,
  [4167] = 1885,
  [4168] = 2286,
  [4169] = 1887,
  [4170] = 1880,
  [4171] = 2473,
  [4172] = 2893,
  [4173] = 2959,
  [4174] = 2885,
  [4175] = 3453,
  [4176] = 3450,
  [4177] = 2478,
  [4178] = 2372,
  [4179] = 1881,
  [4180] = 1893,
  [4181] = 2912,
  [4182] = 4079,
  [4183] = 2959,
  [4184] = 2919,
  [4185] = 2367,
  [4186] = 2291,
  [4187] = 4079,
  [4188] = 1882,
  [4189] = 1883,
  [4190] = 2885,
  [4191] = 2404,
  [4192] = 2416,
  [4193] = 3453,
  [4194] = 2417,
  [4195] = 4195,
  [4196] = 3450,
  [4197] = 4195,
  [4198] = 2407,
  [4199] = 2597,
  [4200] = 4200,
  [4201] = 4195,
  [4202] = 4202,
  [4203] = 2601,
  [4204] = 2418,
  [4205] = 2419,
  [4206] = 4200,
  [4207] = 2596,
  [4208] = 4202,
  [4209] = 4202,
  [4210] = 4202,
  [4211] = 4200,
  [4212] = 2531,
  [4213] = 2473,
  [4214] = 2600,
  [4215] = 4195,
  [4216] = 4195,
  [4217] = 4202,
  [4218] = 2478,
  [4219] = 4202,
  [4220] = 2405,
  [4221] = 2408,
  [4222] = 4195,
  [4223] = 2406,
  [4224] = 2413,
  [4225] = 3453,
  [4226] = 3450,
  [4227] = 2412,
  [4228] = 4200,
  [4229] = 2532,
  [4230] = 2414,
  [4231] = 4200,
  [4232] = 4200,
  [4233] = 2272,
  [4234] = 229,
  [4235] = 2749,
  [4236] = 4236,
  [4237] = 2357,
  [4238] = 3450,
  [4239] = 2411,
  [4240] = 2277,
  [4241] = 231,
  [4242] = 151,
  [4243] = 3453,
  [4244] = 4244,
  [4245] = 3450,
  [4246] = 152,
  [4247] = 2757,
  [4248] = 2386,
  [4249] = 4236,
  [4250] = 4250,
  [4251] = 2387,
  [4252] = 4244,
  [4253] = 2345,
  [4254] = 4254,
  [4255] = 3453,
  [4256] = 2750,
  [4257] = 2755,
  [4258] = 4254,
  [4259] = 4259,
  [4260] = 2445,
  [4261] = 2346,
  [4262] = 4262,
  [4263] = 4263,
  [4264] = 4264,
  [4265] = 4259,
  [4266] = 4262,
  [4267] = 4264,
  [4268] = 2326,
  [4269] = 4263,
  [4270] = 4270,
  [4271] = 4264,
  [4272] = 152,
  [4273] = 4259,
  [4274] = 4274,
  [4275] = 4263,
  [4276] = 2324,
  [4277] = 2272,
  [4278] = 3453,
  [4279] = 151,
  [4280] = 4259,
  [4281] = 2277,
  [4282] = 4264,
  [4283] = 4263,
  [4284] = 4262,
  [4285] = 4264,
  [4286] = 4263,
  [4287] = 4287,
  [4288] = 4262,
  [4289] = 4263,
  [4290] = 4262,
  [4291] = 3450,
  [4292] = 4259,
  [4293] = 4259,
  [4294] = 4263,
  [4295] = 4262,
  [4296] = 2448,
  [4297] = 4264,
  [4298] = 4262,
  [4299] = 4299,
  [4300] = 4264,
  [4301] = 4259,
  [4302] = 2350,
  [4303] = 1312,
  [4304] = 2362,
  [4305] = 2600,
  [4306] = 2374,
  [4307] = 2347,
  [4308] = 2354,
  [4309] = 2375,
  [4310] = 2358,
  [4311] = 2385,
  [4312] = 2369,
  [4313] = 2365,
  [4314] = 1312,
  [4315] = 2597,
  [4316] = 2411,
  [4317] = 2361,
  [4318] = 2364,
  [4319] = 2601,
  [4320] = 2366,
  [4321] = 2377,
  [4322] = 2352,
  [4323] = 2381,
  [4324] = 2373,
  [4325] = 4093,
  [4326] = 2371,
  [4327] = 2360,
  [4328] = 2388,
  [4329] = 4104,
  [4330] = 2596,
  [4331] = 2291,
  [4332] = 3453,
  [4333] = 2348,
  [4334] = 4093,
  [4335] = 2359,
  [4336] = 2356,
  [4337] = 4337,
  [4338] = 2383,
  [4339] = 2368,
  [4340] = 2379,
  [4341] = 4104,
  [4342] = 2384,
  [4343] = 3450,
  [4344] = 2363,
  [4345] = 2370,
  [4346] = 2353,
  [4347] = 2349,
  [4348] = 2380,
  [4349] = 2302,
  [4350] = 3453,
  [4351] = 3178,
  [4352] = 3221,
  [4353] = 2600,
  [4354] = 3208,
  [4355] = 3195,
  [4356] = 3197,
  [4357] = 3450,
  [4358] = 2597,
  [4359] = 4359,
  [4360] = 4360,
  [4361] = 3160,
  [4362] = 3167,
  [4363] = 3453,
  [4364] = 3158,
  [4365] = 2596,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4093,
  [4369] = 4104,
  [4370] = 3450,
  [4371] = 3450,
  [4372] = 3173,
  [4373] = 2274,
  [4374] = 4360,
  [4375] = 2291,
  [4376] = 2749,
  [4377] = 2757,
  [4378] = 3193,
  [4379] = 4359,
  [4380] = 4380,
  [4381] = 3206,
  [4382] = 4367,
  [4383] = 2918,
  [4384] = 2411,
  [4385] = 3453,
  [4386] = 2601,
  [4387] = 3215,
  [4388] = 2755,
  [4389] = 2796,
  [4390] = 2750,
  [4391] = 3194,
  [4392] = 4380,
  [4393] = 2893,
  [4394] = 3163,
  [4395] = 3205,
  [4396] = 3170,
  [4397] = 2915,
  [4398] = 3174,
  [4399] = 3217,
  [4400] = 139,
  [4401] = 1886,
  [4402] = 4337,
  [4403] = 4093,
  [4404] = 1890,
  [4405] = 1893,
  [4406] = 4406,
  [4407] = 4104,
  [4408] = 4093,
  [4409] = 2302,
  [4410] = 1888,
  [4411] = 4411,
  [4412] = 1889,
  [4413] = 152,
  [4414] = 4104,
  [4415] = 2277,
  [4416] = 1891,
  [4417] = 2017,
  [4418] = 2285,
  [4419] = 4337,
  [4420] = 4420,
  [4421] = 1892,
  [4422] = 1885,
  [4423] = 4411,
  [4424] = 3453,
  [4425] = 2286,
  [4426] = 3450,
  [4427] = 4406,
  [4428] = 151,
  [4429] = 1887,
  [4430] = 2272,
  [4431] = 3248,
  [4432] = 4406,
  [4433] = 1880,
  [4434] = 2277,
  [4435] = 1878,
  [4436] = 1882,
  [4437] = 2272,
  [4438] = 4420,
  [4439] = 1883,
  [4440] = 3229,
  [4441] = 1884,
  [4442] = 2274,
  [4443] = 1881,
  [4444] = 138,
  [4445] = 4093,
  [4446] = 1385,
  [4447] = 2286,
  [4448] = 1312,
  [4449] = 2305,
  [4450] = 2316,
  [4451] = 152,
  [4452] = 1385,
  [4453] = 2851,
  [4454] = 2846,
  [4455] = 2310,
  [4456] = 4287,
  [4457] = 151,
  [4458] = 4270,
  [4459] = 4287,
  [4460] = 2311,
  [4461] = 4299,
  [4462] = 1369,
  [4463] = 3450,
  [4464] = 4274,
  [4465] = 4270,
  [4466] = 4299,
  [4467] = 3248,
  [4468] = 2315,
  [4469] = 4469,
  [4470] = 2317,
  [4471] = 2874,
  [4472] = 2319,
  [4473] = 2328,
  [4474] = 3453,
  [4475] = 4104,
  [4476] = 4469,
  [4477] = 2322,
  [4478] = 1369,
  [4479] = 3229,
  [4480] = 2304,
  [4481] = 2285,
  [4482] = 4093,
  [4483] = 4104,
  [4484] = 2314,
  [4485] = 2307,
  [4486] = 2320,
  [4487] = 4274,
  [4488] = 3194,
  [4489] = 3158,
  [4490] = 3173,
  [4491] = 3215,
  [4492] = 2291,
  [4493] = 3221,
  [4494] = 3178,
  [4495] = 3163,
  [4496] = 3170,
  [4497] = 3174,
  [4498] = 3178,
  [4499] = 3221,
  [4500] = 4093,
  [4501] = 2291,
  [4502] = 3450,
  [4503] = 3173,
  [4504] = 3208,
  [4505] = 3217,
  [4506] = 3194,
  [4507] = 3195,
  [4508] = 3193,
  [4509] = 3205,
  [4510] = 3163,
  [4511] = 2411,
  [4512] = 2328,
  [4513] = 2305,
  [4514] = 3174,
  [4515] = 2314,
  [4516] = 4516,
  [4517] = 3197,
  [4518] = 2322,
  [4519] = 2307,
  [4520] = 4520,
  [4521] = 4299,
  [4522] = 3208,
  [4523] = 4274,
  [4524] = 2277,
  [4525] = 4270,
  [4526] = 3206,
  [4527] = 3205,
  [4528] = 2315,
  [4529] = 2317,
  [4530] = 2319,
  [4531] = 2304,
  [4532] = 2320,
  [4533] = 2310,
  [4534] = 3195,
  [4535] = 2301,
  [4536] = 2316,
  [4537] = 2311,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 2291,
  [4541] = 3167,
  [4542] = 3215,
  [4543] = 3193,
  [4544] = 3217,
  [4545] = 3197,
  [4546] = 3170,
  [4547] = 3167,
  [4548] = 3206,
  [4549] = 4104,
  [4550] = 3160,
  [4551] = 3158,
  [4552] = 2272,
  [4553] = 3160,
  [4554] = 3453,
  [4555] = 4287,
  [4556] = 4556,
  [4557] = 169,
  [4558] = 2749,
  [4559] = 4559,
  [4560] = 2755,
  [4561] = 4561,
  [4562] = 4562,
  [4563] = 4556,
  [4564] = 4564,
  [4565] = 3229,
  [4566] = 4093,
  [4567] = 4567,
  [4568] = 4567,
  [4569] = 4556,
  [4570] = 2301,
  [4571] = 4567,
  [4572] = 4564,
  [4573] = 4573,
  [4574] = 4574,
  [4575] = 4556,
  [4576] = 4576,
  [4577] = 2302,
  [4578] = 2750,
  [4579] = 4556,
  [4580] = 4559,
  [4581] = 4564,
  [4582] = 4562,
  [4583] = 2411,
  [4584] = 4584,
  [4585] = 4556,
  [4586] = 4556,
  [4587] = 4562,
  [4588] = 4559,
  [4589] = 4567,
  [4590] = 4564,
  [4591] = 2445,
  [4592] = 4562,
  [4593] = 4556,
  [4594] = 4556,
  [4595] = 4556,
  [4596] = 4556,
  [4597] = 4556,
  [4598] = 2302,
  [4599] = 3248,
  [4600] = 4561,
  [4601] = 4567,
  [4602] = 4299,
  [4603] = 4274,
  [4604] = 4287,
  [4605] = 4270,
  [4606] = 4556,
  [4607] = 4556,
  [4608] = 4299,
  [4609] = 4564,
  [4610] = 4556,
  [4611] = 4556,
  [4612] = 4574,
  [4613] = 4567,
  [4614] = 4559,
  [4615] = 4615,
  [4616] = 4274,
  [4617] = 4567,
  [4618] = 4287,
  [4619] = 4270,
  [4620] = 4104,
  [4621] = 4621,
  [4622] = 4559,
  [4623] = 4556,
  [4624] = 2411,
  [4625] = 4562,
  [4626] = 2757,
  [4627] = 143,
  [4628] = 144,
  [4629] = 140,
  [4630] = 145,
  [4631] = 146,
  [4632] = 4632,
  [4633] = 148,
  [4634] = 147,
  [4635] = 4564,
  [4636] = 155,
  [4637] = 4556,
  [4638] = 4556,
  [4639] = 4556,
  [4640] = 4559,
  [4641] = 4562,
  [4642] = 4567,
  [4643] = 4556,
  [4644] = 165,
  [4645] = 166,
  [4646] = 4556,
  [4647] = 4567,
  [4648] = 2448,
  [4649] = 4561,
  [4650] = 167,
  [4651] = 4559,
  [4652] = 4652,
  [4653] = 4653,
  [4654] = 4652,
  [4655] = 4655,
  [4656] = 3197,
  [4657] = 3215,
  [4658] = 2853,
  [4659] = 4659,
  [4660] = 4660,
  [4661] = 4661,
  [4662] = 3174,
  [4663] = 3206,
  [4664] = 3215,
  [4665] = 3194,
  [4666] = 3163,
  [4667] = 3170,
  [4668] = 3174,
  [4669] = 3178,
  [4670] = 3221,
  [4671] = 3208,
  [4672] = 3217,
  [4673] = 3195,
  [4674] = 3197,
  [4675] = 2372,
  [4676] = 3160,
  [4677] = 3167,
  [4678] = 3158,
  [4679] = 3173,
  [4680] = 4680,
  [4681] = 4652,
  [4682] = 4682,
  [4683] = 152,
  [4684] = 4576,
  [4685] = 4685,
  [4686] = 3193,
  [4687] = 4659,
  [4688] = 3205,
  [4689] = 4652,
  [4690] = 4690,
  [4691] = 4691,
  [4692] = 4104,
  [4693] = 4660,
  [4694] = 3195,
  [4695] = 3173,
  [4696] = 3217,
  [4697] = 4104,
  [4698] = 3160,
  [4699] = 4366,
  [4700] = 3167,
  [4701] = 3193,
  [4702] = 4029,
  [4703] = 4659,
  [4704] = 4093,
  [4705] = 4705,
  [4706] = 3167,
  [4707] = 3158,
  [4708] = 4708,
  [4709] = 2870,
  [4710] = 4660,
  [4711] = 3173,
  [4712] = 4270,
  [4713] = 3205,
  [4714] = 4714,
  [4715] = 4660,
  [4716] = 2367,
  [4717] = 4680,
  [4718] = 4718,
  [4719] = 4719,
  [4720] = 3178,
  [4721] = 151,
  [4722] = 4722,
  [4723] = 2854,
  [4724] = 4724,
  [4725] = 2869,
  [4726] = 2448,
  [4727] = 2870,
  [4728] = 4728,
  [4729] = 2853,
  [4730] = 4337,
  [4731] = 4680,
  [4732] = 2854,
  [4733] = 4652,
  [4734] = 4734,
  [4735] = 4719,
  [4736] = 3195,
  [4737] = 4737,
  [4738] = 4652,
  [4739] = 4739,
  [4740] = 2873,
  [4741] = 4652,
  [4742] = 4659,
  [4743] = 4274,
  [4744] = 156,
  [4745] = 4745,
  [4746] = 4746,
  [4747] = 4747,
  [4748] = 4652,
  [4749] = 2864,
  [4750] = 4652,
  [4751] = 4680,
  [4752] = 4274,
  [4753] = 4659,
  [4754] = 4754,
  [4755] = 4755,
  [4756] = 4652,
  [4757] = 2869,
  [4758] = 4287,
  [4759] = 4759,
  [4760] = 3160,
  [4761] = 2301,
  [4762] = 4093,
  [4763] = 1159,
  [4764] = 3206,
  [4765] = 3194,
  [4766] = 2864,
  [4767] = 3525,
  [4768] = 4660,
  [4769] = 4660,
  [4770] = 4680,
  [4771] = 3163,
  [4772] = 3170,
  [4773] = 3205,
  [4774] = 3193,
  [4775] = 3215,
  [4776] = 4287,
  [4777] = 4299,
  [4778] = 4778,
  [4779] = 4779,
  [4780] = 4660,
  [4781] = 4680,
  [4782] = 4652,
  [4783] = 4783,
  [4784] = 4652,
  [4785] = 4785,
  [4786] = 3158,
  [4787] = 3194,
  [4788] = 4299,
  [4789] = 3221,
  [4790] = 4754,
  [4791] = 3208,
  [4792] = 2873,
  [4793] = 3163,
  [4794] = 3170,
  [4795] = 3174,
  [4796] = 3197,
  [4797] = 4718,
  [4798] = 3178,
  [4799] = 2445,
  [4800] = 3206,
  [4801] = 4652,
  [4802] = 3221,
  [4803] = 3208,
  [4804] = 3217,
  [4805] = 2832,
  [4806] = 4270,
  [4807] = 4807,
  [4808] = 2305,
  [4809] = 2314,
  [4810] = 2322,
  [4811] = 2307,
  [4812] = 2372,
  [4813] = 2315,
  [4814] = 2317,
  [4815] = 2319,
  [4816] = 2304,
  [4817] = 2320,
  [4818] = 2367,
  [4819] = 2310,
  [4820] = 4820,
  [4821] = 4821,
  [4822] = 2316,
  [4823] = 2311,
  [4824] = 4824,
  [4825] = 4825,
  [4826] = 4826,
  [4827] = 4827,
  [4828] = 4828,
  [4829] = 2871,
  [4830] = 4821,
  [4831] = 4093,
  [4832] = 4825,
  [4833] = 4833,
  [4834] = 4834,
  [4835] = 4835,
  [4836] = 4104,
  [4837] = 4837,
  [4838] = 4838,
  [4839] = 4839,
  [4840] = 4807,
  [4841] = 4841,
  [4842] = 4842,
  [4843] = 4843,
  [4844] = 4833,
  [4845] = 4845,
  [4846] = 4837,
  [4847] = 4838,
  [4848] = 4839,
  [4849] = 4849,
  [4850] = 4850,
  [4851] = 4851,
  [4852] = 4852,
  [4853] = 4853,
  [4854] = 4826,
  [4855] = 4855,
  [4856] = 4856,
  [4857] = 4834,
  [4858] = 4858,
  [4859] = 4826,
  [4860] = 4835,
  [4861] = 4849,
  [4862] = 4828,
  [4863] = 4850,
  [4864] = 4851,
  [4865] = 4825,
  [4866] = 4852,
  [4867] = 4833,
  [4868] = 4834,
  [4869] = 4835,
  [4870] = 4870,
  [4871] = 4837,
  [4872] = 4807,
  [4873] = 4873,
  [4874] = 2418,
  [4875] = 2419,
  [4876] = 4842,
  [4877] = 2346,
  [4878] = 4838,
  [4879] = 4839,
  [4880] = 4849,
  [4881] = 4852,
  [4882] = 4856,
  [4883] = 4883,
  [4884] = 2405,
  [4885] = 2408,
  [4886] = 2406,
  [4887] = 2413,
  [4888] = 3229,
  [4889] = 4825,
  [4890] = 4833,
  [4891] = 4834,
  [4892] = 4835,
  [4893] = 4893,
  [4894] = 4837,
  [4895] = 4807,
  [4896] = 4842,
  [4897] = 4838,
  [4898] = 4839,
  [4899] = 4849,
  [4900] = 4852,
  [4901] = 4856,
  [4902] = 2412,
  [4903] = 2414,
  [4904] = 2416,
  [4905] = 2417,
  [4906] = 4825,
  [4907] = 4833,
  [4908] = 4834,
  [4909] = 4835,
  [4910] = 4910,
  [4911] = 4837,
  [4912] = 4807,
  [4913] = 4842,
  [4914] = 4838,
  [4915] = 4839,
  [4916] = 4849,
  [4917] = 2404,
  [4918] = 2407,
  [4919] = 4837,
  [4920] = 4807,
  [4921] = 4842,
  [4922] = 4838,
  [4923] = 4839,
  [4924] = 4849,
  [4925] = 4837,
  [4926] = 4807,
  [4927] = 4828,
  [4928] = 4842,
  [4929] = 4838,
  [4930] = 4849,
  [4931] = 4821,
  [4932] = 4837,
  [4933] = 4807,
  [4934] = 4837,
  [4935] = 4807,
  [4936] = 4855,
  [4937] = 4856,
  [4938] = 4837,
  [4939] = 4939,
  [4940] = 4837,
  [4941] = 4837,
  [4942] = 4574,
  [4943] = 4873,
  [4944] = 4944,
  [4945] = 4574,
  [4946] = 4946,
  [4947] = 4947,
  [4948] = 4826,
  [4949] = 4821,
  [4950] = 4826,
  [4951] = 4828,
  [4952] = 4821,
  [4953] = 4826,
  [4954] = 4828,
  [4955] = 4299,
  [4956] = 4274,
  [4957] = 4287,
  [4958] = 4270,
  [4959] = 4873,
  [4960] = 4828,
  [4961] = 4821,
  [4962] = 4826,
  [4963] = 4828,
  [4964] = 4873,
  [4965] = 4842,
  [4966] = 4873,
  [4967] = 4967,
  [4968] = 4873,
  [4969] = 4873,
  [4970] = 4970,
  [4971] = 4971,
  [4972] = 4972,
  [4973] = 3248,
  [4974] = 4821,
  [4975] = 2301,
  [4976] = 4976,
  [4977] = 4977,
  [4978] = 4978,
  [4979] = 4979,
  [4980] = 4843,
  [4981] = 4883,
  [4982] = 4883,
  [4983] = 4883,
  [4984] = 4883,
  [4985] = 4883,
  [4986] = 4574,
  [4987] = 2919,
  [4988] = 4988,
  [4989] = 4989,
  [4990] = 4093,
  [4991] = 2419,
  [4992] = 2952,
  [4993] = 2961,
  [4994] = 2894,
  [4995] = 2896,
  [4996] = 2387,
  [4997] = 2347,
  [4998] = 2354,
  [4999] = 2897,
  [5000] = 2366,
  [5001] = 2388,
  [5002] = 2414,
  [5003] = 2383,
  [5004] = 2368,
  [5005] = 2909,
  [5006] = 5006,
  [5007] = 2385,
  [5008] = 2369,
  [5009] = 4104,
  [5010] = 2373,
  [5011] = 2911,
  [5012] = 2348,
  [5013] = 2914,
  [5014] = 2916,
  [5015] = 2917,
  [5016] = 2920,
  [5017] = 2921,
  [5018] = 2362,
  [5019] = 5019,
  [5020] = 2350,
  [5021] = 2374,
  [5022] = 2375,
  [5023] = 2418,
  [5024] = 2416,
  [5025] = 2417,
  [5026] = 2405,
  [5027] = 2915,
  [5028] = 2408,
  [5029] = 2365,
  [5030] = 2404,
  [5031] = 5031,
  [5032] = 2407,
  [5033] = 2357,
  [5034] = 4274,
  [5035] = 2361,
  [5036] = 2893,
  [5037] = 2364,
  [5038] = 5006,
  [5039] = 2903,
  [5040] = 5040,
  [5041] = 2377,
  [5042] = 2380,
  [5043] = 5031,
  [5044] = 2381,
  [5045] = 5045,
  [5046] = 2918,
  [5047] = 4287,
  [5048] = 2346,
  [5049] = 2371,
  [5050] = 2360,
  [5051] = 229,
  [5052] = 4574,
  [5053] = 5053,
  [5054] = 4574,
  [5055] = 2448,
  [5056] = 2445,
  [5057] = 4989,
  [5058] = 2902,
  [5059] = 231,
  [5060] = 2912,
  [5061] = 2933,
  [5062] = 2934,
  [5063] = 5063,
  [5064] = 5006,
  [5065] = 5031,
  [5066] = 2412,
  [5067] = 5045,
  [5068] = 2943,
  [5069] = 2945,
  [5070] = 2286,
  [5071] = 5006,
  [5072] = 5031,
  [5073] = 5045,
  [5074] = 2406,
  [5075] = 2413,
  [5076] = 5006,
  [5077] = 5031,
  [5078] = 5045,
  [5079] = 4270,
  [5080] = 2890,
  [5081] = 5006,
  [5082] = 5031,
  [5083] = 5045,
  [5084] = 2386,
  [5085] = 5006,
  [5086] = 5031,
  [5087] = 2359,
  [5088] = 2356,
  [5089] = 5045,
  [5090] = 2936,
  [5091] = 2937,
  [5092] = 2899,
  [5093] = 2345,
  [5094] = 2379,
  [5095] = 2949,
  [5096] = 4574,
  [5097] = 2384,
  [5098] = 2285,
  [5099] = 5045,
  [5100] = 2326,
  [5101] = 2959,
  [5102] = 2363,
  [5103] = 2906,
  [5104] = 2885,
  [5105] = 4299,
  [5106] = 2370,
  [5107] = 2353,
  [5108] = 2908,
  [5109] = 5063,
  [5110] = 2324,
  [5111] = 2951,
  [5112] = 2349,
  [5113] = 5113,
  [5114] = 2940,
  [5115] = 2900,
  [5116] = 2352,
  [5117] = 2358,
  [5118] = 2901,
  [5119] = 2907,
  [5120] = 2448,
  [5121] = 5121,
  [5122] = 5122,
  [5123] = 4270,
  [5124] = 2411,
  [5125] = 2363,
  [5126] = 2365,
  [5127] = 2362,
  [5128] = 2017,
  [5129] = 5129,
  [5130] = 2272,
  [5131] = 4244,
  [5132] = 4236,
  [5133] = 2448,
  [5134] = 5134,
  [5135] = 2386,
  [5136] = 2359,
  [5137] = 2356,
  [5138] = 2350,
  [5139] = 2357,
  [5140] = 2374,
  [5141] = 2445,
  [5142] = 2277,
  [5143] = 2345,
  [5144] = 2379,
  [5145] = 5145,
  [5146] = 2384,
  [5147] = 2361,
  [5148] = 2445,
  [5149] = 2364,
  [5150] = 4104,
  [5151] = 229,
  [5152] = 2370,
  [5153] = 4093,
  [5154] = 231,
  [5155] = 2445,
  [5156] = 2353,
  [5157] = 2375,
  [5158] = 2349,
  [5159] = 2352,
  [5160] = 2358,
  [5161] = 4299,
  [5162] = 4274,
  [5163] = 4287,
  [5164] = 4270,
  [5165] = 2377,
  [5166] = 2380,
  [5167] = 2387,
  [5168] = 2347,
  [5169] = 2354,
  [5170] = 4574,
  [5171] = 4574,
  [5172] = 2381,
  [5173] = 2291,
  [5174] = 5121,
  [5175] = 2366,
  [5176] = 2388,
  [5177] = 2383,
  [5178] = 2368,
  [5179] = 2385,
  [5180] = 2369,
  [5181] = 2448,
  [5182] = 2371,
  [5183] = 5122,
  [5184] = 2360,
  [5185] = 4274,
  [5186] = 2348,
  [5187] = 4574,
  [5188] = 4270,
  [5189] = 4574,
  [5190] = 4287,
  [5191] = 4299,
  [5192] = 4274,
  [5193] = 5134,
  [5194] = 2373,
  [5195] = 5195,
  [5196] = 5196,
  [5197] = 5195,
  [5198] = 5195,
  [5199] = 5196,
  [5200] = 5196,
  [5201] = 5195,
  [5202] = 5196,
  [5203] = 5195,
  [5204] = 5196,
  [5205] = 5195,
  [5206] = 5196,
  [5207] = 5195,
  [5208] = 5196,
  [5209] = 5195,
  [5210] = 5063,
  [5211] = 5063,
  [5212] = 5196,
  [5213] = 4989,
  [5214] = 4574,
  [5215] = 4989,
  [5216] = 5196,
  [5217] = 4574,
  [5218] = 4574,
  [5219] = 4274,
  [5220] = 4270,
  [5221] = 2448,
  [5222] = 2445,
  [5223] = 5195,
  [5224] = 5196,
  [5225] = 5195,
  [5226] = 4299,
  [5227] = 5195,
  [5228] = 4574,
  [5229] = 4574,
  [5230] = 4287,
  [5231] = 2372,
  [5232] = 2367,
  [5233] = 4574,
  [5234] = 5196,
  [5235] = 5195,
  [5236] = 2328,
  [5237] = 5196,
  [5238] = 5238,
  [5239] = 4989,
  [5240] = 4274,
  [5241] = 4989,
  [5242] = 5063,
  [5243] = 5063,
  [5244] = 4270,
  [5245] = 5063,
  [5246] = 2372,
  [5247] = 2367,
  [5248] = 4989,
  [5249] = 2300,
  [5250] = 4989,
  [5251] = 4299,
  [5252] = 4287,
  [5253] = 5063,
  [5254] = 4989,
  [5255] = 2411,
  [5256] = 2316,
  [5257] = 2311,
  [5258] = 4270,
  [5259] = 2307,
  [5260] = 5260,
  [5261] = 5261,
  [5262] = 5261,
  [5263] = 5261,
  [5264] = 5063,
  [5265] = 5265,
  [5266] = 4574,
  [5267] = 5267,
  [5268] = 5260,
  [5269] = 5260,
  [5270] = 5261,
  [5271] = 2315,
  [5272] = 4299,
  [5273] = 2317,
  [5274] = 2319,
  [5275] = 2304,
  [5276] = 2320,
  [5277] = 5261,
  [5278] = 2272,
  [5279] = 5261,
  [5280] = 5265,
  [5281] = 5265,
  [5282] = 5265,
  [5283] = 4274,
  [5284] = 4574,
  [5285] = 4287,
  [5286] = 2305,
  [5287] = 5265,
  [5288] = 5265,
  [5289] = 4574,
  [5290] = 5290,
  [5291] = 5265,
  [5292] = 5265,
  [5293] = 5260,
  [5294] = 4989,
  [5295] = 5265,
  [5296] = 2418,
  [5297] = 2419,
  [5298] = 2405,
  [5299] = 2408,
  [5300] = 5265,
  [5301] = 2406,
  [5302] = 2413,
  [5303] = 5265,
  [5304] = 2412,
  [5305] = 5260,
  [5306] = 2414,
  [5307] = 2416,
  [5308] = 2417,
  [5309] = 2310,
  [5310] = 2404,
  [5311] = 2407,
  [5312] = 2302,
  [5313] = 5265,
  [5314] = 2322,
  [5315] = 2314,
  [5316] = 5063,
  [5317] = 2277,
  [5318] = 5261,
  [5319] = 5063,
  [5320] = 4574,
  [5321] = 5260,
  [5322] = 4574,
  [5323] = 5260,
  [5324] = 4989,
  [5325] = 5260,
  [5326] = 5063,
  [5327] = 5260,
  [5328] = 4989,
  [5329] = 5261,
  [5330] = 5261,
  [5331] = 2407,
  [5332] = 5332,
  [5333] = 5333,
  [5334] = 5333,
  [5335] = 5335,
  [5336] = 5336,
  [5337] = 5335,
  [5338] = 5336,
  [5339] = 5333,
  [5340] = 5335,
  [5341] = 5336,
  [5342] = 5333,
  [5343] = 5335,
  [5344] = 5336,
  [5345] = 5336,
  [5346] = 5063,
  [5347] = 2300,
  [5348] = 4989,
  [5349] = 5333,
  [5350] = 5335,
  [5351] = 5336,
  [5352] = 5333,
  [5353] = 5333,
  [5354] = 5335,
  [5355] = 5336,
  [5356] = 5335,
  [5357] = 5357,
  [5358] = 5336,
  [5359] = 5333,
  [5360] = 5335,
  [5361] = 5336,
  [5362] = 5357,
  [5363] = 5333,
  [5364] = 5335,
  [5365] = 5336,
  [5366] = 5333,
  [5367] = 5335,
  [5368] = 5336,
  [5369] = 5333,
  [5370] = 5335,
  [5371] = 5336,
  [5372] = 5063,
  [5373] = 5373,
  [5374] = 5374,
  [5375] = 5375,
  [5376] = 5376,
  [5377] = 5377,
  [5378] = 5378,
  [5379] = 5332,
  [5380] = 5063,
  [5381] = 5381,
  [5382] = 4989,
  [5383] = 5374,
  [5384] = 5375,
  [5385] = 5376,
  [5386] = 5063,
  [5387] = 4989,
  [5388] = 5335,
  [5389] = 5336,
  [5390] = 4989,
  [5391] = 5333,
  [5392] = 5335,
  [5393] = 5336,
  [5394] = 5333,
  [5395] = 5335,
  [5396] = 5336,
  [5397] = 5374,
  [5398] = 5375,
  [5399] = 5376,
  [5400] = 5377,
  [5401] = 5378,
  [5402] = 5332,
  [5403] = 5374,
  [5404] = 5375,
  [5405] = 5376,
  [5406] = 5377,
  [5407] = 5378,
  [5408] = 5332,
  [5409] = 5333,
  [5410] = 5335,
  [5411] = 5374,
  [5412] = 5375,
  [5413] = 5376,
  [5414] = 5377,
  [5415] = 5378,
  [5416] = 5332,
  [5417] = 5374,
  [5418] = 5375,
  [5419] = 5376,
  [5420] = 5377,
  [5421] = 5378,
  [5422] = 5332,
  [5423] = 4989,
  [5424] = 5373,
  [5425] = 5063,
  [5426] = 5374,
  [5427] = 5375,
  [5428] = 5376,
  [5429] = 5377,
  [5430] = 5378,
  [5431] = 5332,
  [5432] = 5063,
  [5433] = 4989,
  [5434] = 2418,
  [5435] = 2419,
  [5436] = 2405,
  [5437] = 2408,
  [5438] = 5333,
  [5439] = 2406,
  [5440] = 2413,
  [5441] = 2412,
  [5442] = 5335,
  [5443] = 2414,
  [5444] = 2416,
  [5445] = 2417,
  [5446] = 2404,
  [5447] = 5336,
  [5448] = 5333,
  [5449] = 5335,
  [5450] = 5336,
  [5451] = 5333,
  [5452] = 5335,
  [5453] = 5336,
  [5454] = 2300,
  [5455] = 5377,
  [5456] = 5378,
  [5457] = 5381,
  [5458] = 5333,
  [5459] = 5459,
  [5460] = 5460,
  [5461] = 5461,
  [5462] = 5461,
  [5463] = 5463,
  [5464] = 5464,
  [5465] = 5464,
  [5466] = 5463,
  [5467] = 5467,
  [5468] = 5463,
  [5469] = 5464,
  [5470] = 5464,
  [5471] = 5460,
  [5472] = 5464,
  [5473] = 5473,
  [5474] = 5460,
  [5475] = 5463,
  [5476] = 5463,
  [5477] = 5461,
  [5478] = 5463,
  [5479] = 5460,
  [5480] = 5464,
  [5481] = 5461,
  [5482] = 5463,
  [5483] = 5463,
  [5484] = 5464,
  [5485] = 5464,
  [5486] = 5467,
  [5487] = 5487,
  [5488] = 5463,
  [5489] = 5464,
  [5490] = 5463,
  [5491] = 5460,
  [5492] = 5464,
  [5493] = 5464,
  [5494] = 5494,
  [5495] = 5467,
  [5496] = 5464,
  [5497] = 5463,
  [5498] = 5464,
  [5499] = 5460,
  [5500] = 5463,
  [5501] = 5463,
  [5502] = 5461,
  [5503] = 5463,
  [5504] = 5467,
  [5505] = 5463,
  [5506] = 5461,
  [5507] = 5507,
  [5508] = 5461,
  [5509] = 5463,
  [5510] = 5464,
  [5511] = 5463,
  [5512] = 5463,
  [5513] = 5464,
  [5514] = 5464,
  [5515] = 5467,
  [5516] = 5460,
  [5517] = 5464,
  [5518] = 5518,
  [5519] = 5461,
  [5520] = 5464,
  [5521] = 5521,
  [5522] = 5463,
  [5523] = 5460,
  [5524] = 5460,
  [5525] = 5461,
  [5526] = 5467,
  [5527] = 5463,
  [5528] = 5528,
  [5529] = 5529,
  [5530] = 5530,
  [5531] = 5531,
  [5532] = 5532,
  [5533] = 5533,
  [5534] = 5532,
  [5535] = 5533,
  [5536] = 5533,
  [5537] = 5530,
  [5538] = 5531,
  [5539] = 5539,
  [5540] = 5540,
  [5541] = 5532,
  [5542] = 5533,
  [5543] = 5530,
  [5544] = 5531,
  [5545] = 5063,
  [5546] = 5539,
  [5547] = 5533,
  [5548] = 5530,
  [5549] = 5531,
  [5550] = 4989,
  [5551] = 5063,
  [5552] = 5539,
  [5553] = 5530,
  [5554] = 5357,
  [5555] = 5063,
  [5556] = 2328,
  [5557] = 4989,
  [5558] = 5539,
  [5559] = 5381,
  [5560] = 5540,
  [5561] = 5063,
  [5562] = 5533,
  [5563] = 4989,
  [5564] = 4989,
  [5565] = 5565,
  [5566] = 5566,
  [5567] = 5530,
  [5568] = 5373,
  [5569] = 5063,
  [5570] = 5531,
  [5571] = 5532,
  [5572] = 5532,
  [5573] = 5531,
  [5574] = 5540,
  [5575] = 5533,
  [5576] = 5530,
  [5577] = 5531,
  [5578] = 5539,
  [5579] = 5539,
  [5580] = 2302,
  [5581] = 5381,
  [5582] = 5582,
  [5583] = 5373,
  [5584] = 4989,
  [5585] = 5357,
  [5586] = 5586,
  [5587] = 5532,
  [5588] = 5540,
  [5589] = 5539,
  [5590] = 5381,
  [5591] = 5373,
  [5592] = 5381,
  [5593] = 5373,
  [5594] = 5357,
  [5595] = 5381,
  [5596] = 2432,
  [5597] = 5373,
  [5598] = 5381,
  [5599] = 5357,
  [5600] = 5357,
  [5601] = 5357,
  [5602] = 5373,
  [5603] = 5603,
  [5604] = 5357,
  [5605] = 5357,
  [5606] = 5373,
  [5607] = 5381,
  [5608] = 5357,
  [5609] = 5357,
  [5610] = 5373,
  [5611] = 5373,
  [5612] = 5381,
  [5613] = 2434,
  [5614] = 5373,
  [5615] = 5381,
  [5616] = 5381,
  [5617] = 5617,
  [5618] = 5617,
  [5619] = 5381,
  [5620] = 5373,
  [5621] = 5373,
  [5622] = 5357,
  [5623] = 5357,
  [5624] = 5381,
  [5625] = 5381,
  [5626] = 5617,
  [5627] = 5373,
  [5628] = 5617,
  [5629] = 5381,
  [5630] = 5381,
  [5631] = 5373,
  [5632] = 5381,
  [5633] = 5357,
  [5634] = 5357,
  [5635] = 5373,
  [5636] = 5357,
  [5637] = 5357,
  [5638] = 5373,
  [5639] = 5639,
  [5640] = 5639,
  [5641] = 2285,
  [5642] = 5639,
  [5643] = 5639,
  [5644] = 5639,
  [5645] = 5639,
  [5646] = 5639,
  [5647] = 2286,
  [5648] = 5373,
  [5649] = 5649,
  [5650] = 5381,
  [5651] = 5357,
  [5652] = 5357,
  [5653] = 5381,
  [5654] = 5357,
  [5655] = 5381,
  [5656] = 5373,
  [5657] = 5373,
  [5658] = 5373,
  [5659] = 5357,
  [5660] = 5649,
  [5661] = 5649,
  [5662] = 5662,
  [5663] = 5381,
  [5664] = 5373,
  [5665] = 5357,
  [5666] = 5381,
  [5667] = 5667,
  [5668] = 5603,
  [5669] = 5603,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5671,
  [5673] = 5673,
  [5674] = 5673,
  [5675] = 5675,
  [5676] = 5675,
  [5677] = 5677,
  [5678] = 5675,
  [5679] = 5671,
  [5680] = 5671,
  [5681] = 5673,
  [5682] = 5673,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5685,
  [5686] = 5670,
  [5687] = 5687,
  [5688] = 5688,
  [5689] = 5675,
  [5690] = 5671,
  [5691] = 5691,
  [5692] = 5673,
  [5693] = 5675,
  [5694] = 5675,
  [5695] = 5695,
  [5696] = 5671,
  [5697] = 5671,
  [5698] = 5673,
  [5699] = 5671,
  [5700] = 5671,
  [5701] = 5673,
  [5702] = 5673,
  [5703] = 5671,
  [5704] = 5673,
  [5705] = 5671,
  [5706] = 5673,
  [5707] = 5677,
  [5708] = 5673,
  [5709] = 5709,
  [5710] = 5675,
  [5711] = 5671,
  [5712] = 5677,
  [5713] = 5603,
  [5714] = 5684,
  [5715] = 5671,
  [5716] = 5673,
  [5717] = 5673,
  [5718] = 5685,
  [5719] = 5687,
  [5720] = 5675,
  [5721] = 5671,
  [5722] = 5673,
  [5723] = 5723,
  [5724] = 5675,
  [5725] = 5671,
  [5726] = 5673,
  [5727] = 5671,
  [5728] = 5673,
  [5729] = 5729,
  [5730] = 5730,
  [5731] = 5729,
  [5732] = 5732,
  [5733] = 5729,
  [5734] = 5730,
  [5735] = 5735,
  [5736] = 5736,
  [5737] = 5737,
  [5738] = 5730,
  [5739] = 5730,
  [5740] = 5729,
  [5741] = 5735,
  [5742] = 5737,
  [5743] = 5732,
  [5744] = 5730,
  [5745] = 5735,
  [5746] = 5736,
  [5747] = 5730,
  [5748] = 5735,
  [5749] = 5729,
  [5750] = 5735,
  [5751] = 5732,
  [5752] = 5729,
  [5753] = 5736,
  [5754] = 5730,
  [5755] = 5755,
  [5756] = 5756,
  [5757] = 5730,
  [5758] = 5735,
  [5759] = 5730,
  [5760] = 5735,
  [5761] = 5729,
  [5762] = 5732,
  [5763] = 5735,
  [5764] = 5736,
  [5765] = 5723,
  [5766] = 5736,
  [5767] = 5736,
  [5768] = 5729,
  [5769] = 5735,
  [5770] = 5732,
  [5771] = 5730,
  [5772] = 5772,
  [5773] = 5735,
  [5774] = 5736,
  [5775] = 5736,
  [5776] = 5736,
  [5777] = 5777,
  [5778] = 5732,
  [5779] = 5729,
  [5780] = 5777,
  [5781] = 5781,
  [5782] = 5732,
  [5783] = 5736,
  [5784] = 5603,
  [5785] = 5730,
  [5786] = 5732,
  [5787] = 5735,
  [5788] = 5730,
  [5789] = 5732,
  [5790] = 5732,
  [5791] = 5736,
  [5792] = 5735,
  [5793] = 5732,
  [5794] = 5732,
  [5795] = 5730,
  [5796] = 5730,
  [5797] = 5735,
  [5798] = 5735,
  [5799] = 5737,
  [5800] = 5729,
  [5801] = 5801,
  [5802] = 5736,
  [5803] = 5772,
  [5804] = 5804,
  [5805] = 5732,
  [5806] = 5736,
  [5807] = 5736,
  [5808] = 5729,
  [5809] = 5732,
  [5810] = 5730,
  [5811] = 5735,
  [5812] = 5736,
  [5813] = 5813,
  [5814] = 5735,
  [5815] = 5729,
  [5816] = 5816,
  [5817] = 5817,
  [5818] = 5777,
  [5819] = 5603,
  [5820] = 5732,
  [5821] = 5730,
  [5822] = 5729,
  [5823] = 5735,
  [5824] = 5729,
  [5825] = 5736,
  [5826] = 5732,
  [5827] = 5729,
  [5828] = 5732,
  [5829] = 5829,
  [5830] = 5729,
  [5831] = 5729,
  [5832] = 5816,
  [5833] = 5730,
  [5834] = 5732,
  [5835] = 5729,
  [5836] = 5772,
  [5837] = 5730,
  [5838] = 5817,
  [5839] = 5735,
  [5840] = 5736,
  [5841] = 5736,
  [5842] = 5842,
  [5843] = 5843,
  [5844] = 5844,
  [5845] = 5845,
  [5846] = 5603,
  [5847] = 5847,
  [5848] = 5843,
  [5849] = 5849,
  [5850] = 5850,
  [5851] = 5851,
  [5852] = 5843,
  [5853] = 5849,
  [5854] = 5854,
  [5855] = 5855,
  [5856] = 5856,
  [5857] = 5857,
  [5858] = 5858,
  [5859] = 5859,
  [5860] = 5843,
  [5861] = 5854,
  [5862] = 5862,
  [5863] = 1890,
  [5864] = 5864,
  [5865] = 5865,
  [5866] = 5850,
  [5867] = 1880,
  [5868] = 5849,
  [5869] = 5869,
  [5870] = 5864,
  [5871] = 5871,
  [5872] = 5843,
  [5873] = 5864,
  [5874] = 138,
  [5875] = 5854,
  [5876] = 5855,
  [5877] = 1891,
  [5878] = 1892,
  [5879] = 5858,
  [5880] = 5880,
  [5881] = 5881,
  [5882] = 5882,
  [5883] = 5883,
  [5884] = 5884,
  [5885] = 5850,
  [5886] = 5850,
  [5887] = 5849,
  [5888] = 5850,
  [5889] = 5854,
  [5890] = 5850,
  [5891] = 5864,
  [5892] = 1885,
  [5893] = 1881,
  [5894] = 5844,
  [5895] = 5895,
  [5896] = 5896,
  [5897] = 2286,
  [5898] = 5845,
  [5899] = 1887,
  [5900] = 5850,
  [5901] = 5901,
  [5902] = 5856,
  [5903] = 5883,
  [5904] = 5849,
  [5905] = 5850,
  [5906] = 5849,
  [5907] = 5864,
  [5908] = 5843,
  [5909] = 5909,
  [5910] = 5910,
  [5911] = 5895,
  [5912] = 5843,
  [5913] = 5859,
  [5914] = 1893,
  [5915] = 5915,
  [5916] = 5854,
  [5917] = 5917,
  [5918] = 5849,
  [5919] = 5919,
  [5920] = 5920,
  [5921] = 5921,
  [5922] = 5864,
  [5923] = 1878,
  [5924] = 5924,
  [5925] = 5854,
  [5926] = 5915,
  [5927] = 5927,
  [5928] = 1882,
  [5929] = 5864,
  [5930] = 5930,
  [5931] = 1886,
  [5932] = 5849,
  [5933] = 5933,
  [5934] = 5871,
  [5935] = 5854,
  [5936] = 5936,
  [5937] = 5937,
  [5938] = 5938,
  [5939] = 5917,
  [5940] = 5940,
  [5941] = 5924,
  [5942] = 5855,
  [5943] = 5871,
  [5944] = 5855,
  [5945] = 5945,
  [5946] = 5854,
  [5947] = 5850,
  [5948] = 5854,
  [5949] = 1883,
  [5950] = 5950,
  [5951] = 5850,
  [5952] = 5854,
  [5953] = 5920,
  [5954] = 5854,
  [5955] = 5854,
  [5956] = 5956,
  [5957] = 5957,
  [5958] = 5843,
  [5959] = 1888,
  [5960] = 5864,
  [5961] = 5961,
  [5962] = 5864,
  [5963] = 5850,
  [5964] = 1889,
  [5965] = 5965,
  [5966] = 5909,
  [5967] = 5967,
  [5968] = 5968,
  [5969] = 5969,
  [5970] = 5864,
  [5971] = 5849,
  [5972] = 5864,
  [5973] = 5864,
  [5974] = 5850,
  [5975] = 5854,
  [5976] = 5976,
  [5977] = 5854,
  [5978] = 5938,
  [5979] = 5869,
  [5980] = 5980,
  [5981] = 1884,
  [5982] = 5850,
  [5983] = 5967,
  [5984] = 5603,
  [5985] = 5864,
  [5986] = 3229,
  [5987] = 5880,
  [5988] = 139,
  [5989] = 5843,
  [5990] = 2285,
  [5991] = 5957,
  [5992] = 1893,
  [5993] = 5993,
  [5994] = 138,
  [5995] = 5995,
  [5996] = 5996,
  [5997] = 5993,
  [5998] = 5998,
  [5999] = 5993,
  [6000] = 6000,
  [6001] = 6001,
  [6002] = 5995,
  [6003] = 6003,
  [6004] = 5896,
  [6005] = 5880,
  [6006] = 5995,
  [6007] = 5933,
  [6008] = 2286,
  [6009] = 6009,
  [6010] = 5880,
  [6011] = 6011,
  [6012] = 5961,
  [6013] = 6013,
  [6014] = 6014,
  [6015] = 6013,
  [6016] = 6016,
  [6017] = 5967,
  [6018] = 5857,
  [6019] = 6019,
  [6020] = 5993,
  [6021] = 5967,
  [6022] = 5996,
  [6023] = 6023,
  [6024] = 6016,
  [6025] = 5995,
  [6026] = 5995,
  [6027] = 6023,
  [6028] = 6016,
  [6029] = 5869,
  [6030] = 6016,
  [6031] = 5993,
  [6032] = 5603,
  [6033] = 6013,
  [6034] = 5909,
  [6035] = 5869,
  [6036] = 5859,
  [6037] = 5993,
  [6038] = 5996,
  [6039] = 6023,
  [6040] = 6040,
  [6041] = 6041,
  [6042] = 6013,
  [6043] = 6016,
  [6044] = 5909,
  [6045] = 5996,
  [6046] = 6046,
  [6047] = 5859,
  [6048] = 2796,
  [6049] = 5919,
  [6050] = 5968,
  [6051] = 6016,
  [6052] = 6046,
  [6053] = 5993,
  [6054] = 5927,
  [6055] = 1880,
  [6056] = 2285,
  [6057] = 1881,
  [6058] = 1882,
  [6059] = 1883,
  [6060] = 1884,
  [6061] = 1878,
  [6062] = 1886,
  [6063] = 5995,
  [6064] = 1888,
  [6065] = 1889,
  [6066] = 5851,
  [6067] = 5901,
  [6068] = 5936,
  [6069] = 5940,
  [6070] = 5976,
  [6071] = 5847,
  [6072] = 5881,
  [6073] = 5882,
  [6074] = 5884,
  [6075] = 5842,
  [6076] = 5910,
  [6077] = 6077,
  [6078] = 1885,
  [6079] = 1890,
  [6080] = 1887,
  [6081] = 1891,
  [6082] = 1892,
  [6083] = 139,
  [6084] = 3229,
  [6085] = 6016,
  [6086] = 6086,
  [6087] = 5670,
  [6088] = 5685,
  [6089] = 6089,
  [6090] = 6089,
  [6091] = 5684,
  [6092] = 5685,
  [6093] = 5670,
  [6094] = 5687,
  [6095] = 5684,
  [6096] = 5685,
  [6097] = 5670,
  [6098] = 5687,
  [6099] = 5684,
  [6100] = 6100,
  [6101] = 5684,
  [6102] = 5687,
  [6103] = 6103,
  [6104] = 6089,
  [6105] = 6105,
  [6106] = 5685,
  [6107] = 6107,
  [6108] = 6086,
  [6109] = 6107,
  [6110] = 6089,
  [6111] = 5603,
  [6112] = 6089,
  [6113] = 6113,
  [6114] = 6089,
  [6115] = 6115,
  [6116] = 6116,
  [6117] = 6117,
  [6118] = 6118,
  [6119] = 5687,
  [6120] = 6120,
  [6121] = 6121,
  [6122] = 6122,
  [6123] = 6123,
  [6124] = 6089,
  [6125] = 5670,
  [6126] = 6126,
  [6127] = 5603,
  [6128] = 6128,
  [6129] = 6129,
  [6130] = 5603,
  [6131] = 5684,
  [6132] = 5684,
  [6133] = 5685,
  [6134] = 5670,
  [6135] = 948,
  [6136] = 5687,
  [6137] = 6003,
  [6138] = 6138,
  [6139] = 6139,
  [6140] = 5685,
  [6141] = 5670,
  [6142] = 5687,
  [6143] = 949,
  [6144] = 6144,
  [6145] = 2491,
  [6146] = 6146,
  [6147] = 6138,
  [6148] = 6138,
  [6149] = 6149,
  [6150] = 6138,
  [6151] = 6001,
  [6152] = 6019,
  [6153] = 6138,
  [6154] = 6149,
  [6155] = 2487,
  [6156] = 6138,
  [6157] = 2498,
  [6158] = 5603,
  [6159] = 5603,
  [6160] = 6160,
  [6161] = 6161,
  [6162] = 5869,
  [6163] = 2286,
  [6164] = 6160,
  [6165] = 6160,
  [6166] = 6166,
  [6167] = 6166,
  [6168] = 6160,
  [6169] = 6169,
  [6170] = 2285,
  [6171] = 6171,
  [6172] = 6172,
  [6173] = 6173,
  [6174] = 6169,
  [6175] = 2685,
  [6176] = 6176,
  [6177] = 6177,
  [6178] = 6178,
  [6179] = 6179,
  [6180] = 6160,
  [6181] = 6181,
  [6182] = 6182,
  [6183] = 6183,
  [6184] = 6184,
  [6185] = 6160,
  [6186] = 6186,
  [6187] = 5684,
  [6188] = 5685,
  [6189] = 5670,
  [6190] = 5687,
  [6191] = 6191,
  [6192] = 6160,
  [6193] = 5684,
  [6194] = 5685,
  [6195] = 5670,
  [6196] = 5687,
  [6197] = 6160,
  [6198] = 6198,
  [6199] = 5909,
  [6200] = 6161,
  [6201] = 6201,
  [6202] = 5869,
  [6203] = 6198,
  [6204] = 6204,
  [6205] = 6205,
  [6206] = 2667,
  [6207] = 6160,
  [6208] = 6201,
  [6209] = 6209,
  [6210] = 5859,
  [6211] = 5967,
  [6212] = 5684,
  [6213] = 5685,
  [6214] = 5670,
  [6215] = 5687,
  [6216] = 5684,
  [6217] = 5685,
  [6218] = 5670,
  [6219] = 5687,
  [6220] = 6172,
  [6221] = 5880,
  [6222] = 6222,
  [6223] = 6160,
  [6224] = 2655,
  [6225] = 5859,
  [6226] = 6173,
  [6227] = 6227,
  [6228] = 6228,
  [6229] = 6181,
  [6230] = 2844,
  [6231] = 6182,
  [6232] = 6186,
  [6233] = 6209,
  [6234] = 6160,
  [6235] = 6160,
  [6236] = 6160,
  [6237] = 2671,
  [6238] = 6160,
  [6239] = 6160,
  [6240] = 6227,
  [6241] = 6160,
  [6242] = 6222,
  [6243] = 6205,
  [6244] = 5967,
  [6245] = 6160,
  [6246] = 6228,
  [6247] = 5880,
  [6248] = 6176,
  [6249] = 6177,
  [6250] = 6178,
  [6251] = 2660,
  [6252] = 6160,
  [6253] = 6179,
  [6254] = 6254,
  [6255] = 6160,
  [6256] = 6256,
  [6257] = 6183,
  [6258] = 6191,
  [6259] = 6256,
  [6260] = 5909,
  [6261] = 6261,
  [6262] = 5869,
  [6263] = 5909,
  [6264] = 5859,
  [6265] = 5880,
  [6266] = 2286,
  [6267] = 5967,
  [6268] = 5869,
  [6269] = 5909,
  [6270] = 5859,
  [6271] = 152,
  [6272] = 5687,
  [6273] = 5670,
  [6274] = 6274,
  [6275] = 5684,
  [6276] = 5670,
  [6277] = 5603,
  [6278] = 2883,
  [6279] = 6279,
  [6280] = 5670,
  [6281] = 6281,
  [6282] = 5684,
  [6283] = 2286,
  [6284] = 6284,
  [6285] = 6285,
  [6286] = 2796,
  [6287] = 6284,
  [6288] = 2627,
  [6289] = 5687,
  [6290] = 6281,
  [6291] = 6291,
  [6292] = 6284,
  [6293] = 5687,
  [6294] = 5684,
  [6295] = 6295,
  [6296] = 6281,
  [6297] = 6297,
  [6298] = 6284,
  [6299] = 6299,
  [6300] = 2913,
  [6301] = 5685,
  [6302] = 6281,
  [6303] = 6284,
  [6304] = 6274,
  [6305] = 5684,
  [6306] = 6281,
  [6307] = 6284,
  [6308] = 6274,
  [6309] = 5685,
  [6310] = 6310,
  [6311] = 5880,
  [6312] = 6284,
  [6313] = 6261,
  [6314] = 5967,
  [6315] = 151,
  [6316] = 6274,
  [6317] = 5869,
  [6318] = 5909,
  [6319] = 5859,
  [6320] = 6320,
  [6321] = 6279,
  [6322] = 6261,
  [6323] = 6323,
  [6324] = 6324,
  [6325] = 6279,
  [6326] = 6326,
  [6327] = 5670,
  [6328] = 6281,
  [6329] = 5687,
  [6330] = 2285,
  [6331] = 6281,
  [6332] = 6332,
  [6333] = 5685,
  [6334] = 5880,
  [6335] = 6261,
  [6336] = 6261,
  [6337] = 6261,
  [6338] = 6261,
  [6339] = 5967,
  [6340] = 2955,
  [6341] = 5869,
  [6342] = 5909,
  [6343] = 6279,
  [6344] = 5859,
  [6345] = 2751,
  [6346] = 5685,
  [6347] = 6279,
  [6348] = 6279,
  [6349] = 2285,
  [6350] = 5880,
  [6351] = 6351,
  [6352] = 5967,
  [6353] = 6353,
  [6354] = 2667,
  [6355] = 6355,
  [6356] = 6356,
  [6357] = 6356,
  [6358] = 2655,
  [6359] = 6356,
  [6360] = 6356,
  [6361] = 6121,
  [6362] = 6120,
  [6363] = 6363,
  [6364] = 6356,
  [6365] = 6355,
  [6366] = 6355,
  [6367] = 6367,
  [6368] = 6356,
  [6369] = 6369,
  [6370] = 6369,
  [6371] = 1159,
  [6372] = 6372,
  [6373] = 2671,
  [6374] = 6356,
  [6375] = 6123,
  [6376] = 6376,
  [6377] = 6377,
  [6378] = 6378,
  [6379] = 6369,
  [6380] = 6380,
  [6381] = 6356,
  [6382] = 6356,
  [6383] = 6115,
  [6384] = 6118,
  [6385] = 6122,
  [6386] = 6120,
  [6387] = 6356,
  [6388] = 6122,
  [6389] = 6116,
  [6390] = 6356,
  [6391] = 6117,
  [6392] = 2898,
  [6393] = 6121,
  [6394] = 6123,
  [6395] = 6355,
  [6396] = 6396,
  [6397] = 6115,
  [6398] = 2532,
  [6399] = 2685,
  [6400] = 5684,
  [6401] = 6369,
  [6402] = 6355,
  [6403] = 6356,
  [6404] = 6355,
  [6405] = 2473,
  [6406] = 6355,
  [6407] = 5685,
  [6408] = 5670,
  [6409] = 5684,
  [6410] = 5687,
  [6411] = 5685,
  [6412] = 6356,
  [6413] = 6413,
  [6414] = 6356,
  [6415] = 5670,
  [6416] = 6369,
  [6417] = 5687,
  [6418] = 2478,
  [6419] = 2660,
  [6420] = 6356,
  [6421] = 6356,
  [6422] = 6369,
  [6423] = 6118,
  [6424] = 6424,
  [6425] = 6356,
  [6426] = 6369,
  [6427] = 6116,
  [6428] = 6117,
  [6429] = 5603,
  [6430] = 6356,
  [6431] = 6431,
  [6432] = 6356,
  [6433] = 2531,
  [6434] = 6356,
  [6435] = 6435,
  [6436] = 6117,
  [6437] = 6118,
  [6438] = 6120,
  [6439] = 5687,
  [6440] = 6440,
  [6441] = 6441,
  [6442] = 6121,
  [6443] = 6443,
  [6444] = 6122,
  [6445] = 6445,
  [6446] = 6123,
  [6447] = 6447,
  [6448] = 6448,
  [6449] = 6448,
  [6450] = 6450,
  [6451] = 6451,
  [6452] = 6448,
  [6453] = 6435,
  [6454] = 6454,
  [6455] = 6451,
  [6456] = 6441,
  [6457] = 6451,
  [6458] = 6458,
  [6459] = 2705,
  [6460] = 2774,
  [6461] = 6461,
  [6462] = 6450,
  [6463] = 2966,
  [6464] = 6448,
  [6465] = 2712,
  [6466] = 2967,
  [6467] = 2968,
  [6468] = 6435,
  [6469] = 2969,
  [6470] = 2970,
  [6471] = 2971,
  [6472] = 6472,
  [6473] = 6435,
  [6474] = 2718,
  [6475] = 6475,
  [6476] = 6448,
  [6477] = 2786,
  [6478] = 6478,
  [6479] = 2788,
  [6480] = 2789,
  [6481] = 6380,
  [6482] = 6372,
  [6483] = 6483,
  [6484] = 5684,
  [6485] = 151,
  [6486] = 6435,
  [6487] = 6448,
  [6488] = 6488,
  [6489] = 6435,
  [6490] = 6490,
  [6491] = 6491,
  [6492] = 2776,
  [6493] = 6448,
  [6494] = 6450,
  [6495] = 6435,
  [6496] = 5684,
  [6497] = 2777,
  [6498] = 6448,
  [6499] = 5670,
  [6500] = 6441,
  [6501] = 6451,
  [6502] = 2751,
  [6503] = 6435,
  [6504] = 6504,
  [6505] = 6448,
  [6506] = 6448,
  [6507] = 2738,
  [6508] = 6508,
  [6509] = 6509,
  [6510] = 5685,
  [6511] = 6451,
  [6512] = 6435,
  [6513] = 6447,
  [6514] = 2891,
  [6515] = 6115,
  [6516] = 2784,
  [6517] = 6517,
  [6518] = 6518,
  [6519] = 6450,
  [6520] = 6116,
  [6521] = 6378,
  [6522] = 6435,
  [6523] = 5670,
  [6524] = 6524,
  [6525] = 5685,
  [6526] = 5687,
  [6527] = 6376,
  [6528] = 6363,
  [6529] = 6529,
  [6530] = 6441,
  [6531] = 2411,
  [6532] = 6532,
  [6533] = 6115,
  [6534] = 6532,
  [6535] = 6532,
  [6536] = 5684,
  [6537] = 5685,
  [6538] = 5670,
  [6539] = 5687,
  [6540] = 6118,
  [6541] = 5684,
  [6542] = 5685,
  [6543] = 5670,
  [6544] = 5687,
  [6545] = 6120,
  [6546] = 6532,
  [6547] = 6547,
  [6548] = 2860,
  [6549] = 6122,
  [6550] = 5684,
  [6551] = 6551,
  [6552] = 6552,
  [6553] = 6532,
  [6554] = 6554,
  [6555] = 6555,
  [6556] = 6556,
  [6557] = 6532,
  [6558] = 6115,
  [6559] = 6532,
  [6560] = 6118,
  [6561] = 6120,
  [6562] = 6122,
  [6563] = 5670,
  [6564] = 6564,
  [6565] = 6532,
  [6566] = 6532,
  [6567] = 6116,
  [6568] = 6117,
  [6569] = 6121,
  [6570] = 6123,
  [6571] = 6571,
  [6572] = 5685,
  [6573] = 6573,
  [6574] = 6532,
  [6575] = 6116,
  [6576] = 6117,
  [6577] = 6121,
  [6578] = 6123,
  [6579] = 6532,
  [6580] = 6532,
  [6581] = 6532,
  [6582] = 6532,
  [6583] = 6583,
  [6584] = 2522,
  [6585] = 5687,
  [6586] = 6532,
  [6587] = 6532,
  [6588] = 6532,
  [6589] = 6589,
  [6590] = 6532,
  [6591] = 6532,
  [6592] = 6532,
  [6593] = 6552,
  [6594] = 6594,
  [6595] = 6595,
  [6596] = 6596,
  [6597] = 144,
  [6598] = 6598,
  [6599] = 6598,
  [6600] = 6600,
  [6601] = 6600,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6596,
  [6605] = 6118,
  [6606] = 6117,
  [6607] = 6596,
  [6608] = 6598,
  [6609] = 6378,
  [6610] = 6602,
  [6611] = 6120,
  [6612] = 6598,
  [6613] = 6613,
  [6614] = 6600,
  [6615] = 6615,
  [6616] = 6122,
  [6617] = 6596,
  [6618] = 6613,
  [6619] = 6115,
  [6620] = 5880,
  [6621] = 6621,
  [6622] = 6598,
  [6623] = 6623,
  [6624] = 6624,
  [6625] = 6621,
  [6626] = 6116,
  [6627] = 6117,
  [6628] = 6596,
  [6629] = 6629,
  [6630] = 6595,
  [6631] = 6121,
  [6632] = 6598,
  [6633] = 6123,
  [6634] = 6629,
  [6635] = 6600,
  [6636] = 6621,
  [6637] = 6637,
  [6638] = 6638,
  [6639] = 6615,
  [6640] = 6640,
  [6641] = 6595,
  [6642] = 6598,
  [6643] = 5967,
  [6644] = 6615,
  [6645] = 6645,
  [6646] = 6646,
  [6647] = 6615,
  [6648] = 6648,
  [6649] = 5869,
  [6650] = 5909,
  [6651] = 6651,
  [6652] = 5859,
  [6653] = 140,
  [6654] = 6613,
  [6655] = 6596,
  [6656] = 6600,
  [6657] = 6657,
  [6658] = 6602,
  [6659] = 6116,
  [6660] = 6660,
  [6661] = 6117,
  [6662] = 6118,
  [6663] = 6120,
  [6664] = 6602,
  [6665] = 6615,
  [6666] = 6629,
  [6667] = 6615,
  [6668] = 6613,
  [6669] = 6613,
  [6670] = 6602,
  [6671] = 6621,
  [6672] = 6629,
  [6673] = 6673,
  [6674] = 6595,
  [6675] = 6615,
  [6676] = 6602,
  [6677] = 6602,
  [6678] = 145,
  [6679] = 2445,
  [6680] = 6121,
  [6681] = 6122,
  [6682] = 6682,
  [6683] = 6363,
  [6684] = 6600,
  [6685] = 6123,
  [6686] = 6686,
  [6687] = 6613,
  [6688] = 146,
  [6689] = 6372,
  [6690] = 6690,
  [6691] = 6621,
  [6692] = 6629,
  [6693] = 6629,
  [6694] = 6376,
  [6695] = 5880,
  [6696] = 2286,
  [6697] = 5967,
  [6698] = 6698,
  [6699] = 5869,
  [6700] = 6700,
  [6701] = 6701,
  [6702] = 6595,
  [6703] = 6596,
  [6704] = 5909,
  [6705] = 5859,
  [6706] = 6380,
  [6707] = 6707,
  [6708] = 6621,
  [6709] = 6621,
  [6710] = 6710,
  [6711] = 6711,
  [6712] = 148,
  [6713] = 2285,
  [6714] = 6595,
  [6715] = 147,
  [6716] = 6600,
  [6717] = 6613,
  [6718] = 6629,
  [6719] = 6116,
  [6720] = 6121,
  [6721] = 6123,
  [6722] = 6595,
  [6723] = 6723,
  [6724] = 6115,
  [6725] = 6725,
  [6726] = 143,
  [6727] = 2448,
  [6728] = 6299,
  [6729] = 6367,
  [6730] = 6730,
  [6731] = 6730,
  [6732] = 6732,
  [6733] = 6733,
  [6734] = 5967,
  [6735] = 6735,
  [6736] = 6730,
  [6737] = 6730,
  [6738] = 6730,
  [6739] = 6730,
  [6740] = 6730,
  [6741] = 6741,
  [6742] = 5869,
  [6743] = 6743,
  [6744] = 6123,
  [6745] = 6730,
  [6746] = 5909,
  [6747] = 5880,
  [6748] = 6730,
  [6749] = 5859,
  [6750] = 6730,
  [6751] = 6730,
  [6752] = 6752,
  [6753] = 6753,
  [6754] = 6115,
  [6755] = 6118,
  [6756] = 6730,
  [6757] = 6120,
  [6758] = 6122,
  [6759] = 6759,
  [6760] = 6730,
  [6761] = 6116,
  [6762] = 6117,
  [6763] = 6121,
  [6764] = 6764,
  [6765] = 6380,
  [6766] = 6766,
  [6767] = 6766,
  [6768] = 6766,
  [6769] = 142,
  [6770] = 6770,
  [6771] = 6363,
  [6772] = 6772,
  [6773] = 6766,
  [6774] = 6766,
  [6775] = 6766,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6766,
  [6779] = 6779,
  [6780] = 6115,
  [6781] = 6123,
  [6782] = 6782,
  [6783] = 6117,
  [6784] = 6776,
  [6785] = 6777,
  [6786] = 6123,
  [6787] = 6116,
  [6788] = 6788,
  [6789] = 6378,
  [6790] = 6766,
  [6791] = 6777,
  [6792] = 6376,
  [6793] = 6766,
  [6794] = 6184,
  [6795] = 6782,
  [6796] = 6776,
  [6797] = 6116,
  [6798] = 6766,
  [6799] = 6777,
  [6800] = 6121,
  [6801] = 6772,
  [6802] = 6766,
  [6803] = 6788,
  [6804] = 6776,
  [6805] = 6776,
  [6806] = 6766,
  [6807] = 6117,
  [6808] = 6118,
  [6809] = 6120,
  [6810] = 6121,
  [6811] = 6782,
  [6812] = 141,
  [6813] = 6121,
  [6814] = 6777,
  [6815] = 6766,
  [6816] = 6816,
  [6817] = 6122,
  [6818] = 6123,
  [6819] = 6117,
  [6820] = 6788,
  [6821] = 6772,
  [6822] = 6766,
  [6823] = 6766,
  [6824] = 6766,
  [6825] = 6777,
  [6826] = 6204,
  [6827] = 6772,
  [6828] = 6372,
  [6829] = 6782,
  [6830] = 6777,
  [6831] = 6776,
  [6832] = 6766,
  [6833] = 6766,
  [6834] = 6766,
  [6835] = 6766,
  [6836] = 6788,
  [6837] = 6776,
  [6838] = 6766,
  [6839] = 6766,
  [6840] = 6766,
  [6841] = 6766,
  [6842] = 6766,
  [6843] = 6116,
  [6844] = 6844,
  [6845] = 6845,
  [6846] = 6323,
  [6847] = 6847,
  [6848] = 6848,
  [6849] = 6115,
  [6850] = 6850,
  [6851] = 6123,
  [6852] = 6852,
  [6853] = 6121,
  [6854] = 6854,
  [6855] = 6855,
  [6856] = 6184,
  [6857] = 6857,
  [6858] = 6845,
  [6859] = 6845,
  [6860] = 6122,
  [6861] = 6326,
  [6862] = 6845,
  [6863] = 6297,
  [6864] = 6845,
  [6865] = 6865,
  [6866] = 6324,
  [6867] = 6867,
  [6868] = 6868,
  [6869] = 6869,
  [6870] = 6870,
  [6871] = 6871,
  [6872] = 6204,
  [6873] = 6873,
  [6874] = 6865,
  [6875] = 6865,
  [6876] = 6876,
  [6877] = 6120,
  [6878] = 6876,
  [6879] = 6879,
  [6880] = 6880,
  [6881] = 6123,
  [6882] = 6882,
  [6883] = 6883,
  [6884] = 6884,
  [6885] = 6115,
  [6886] = 6886,
  [6887] = 6118,
  [6888] = 6120,
  [6889] = 6889,
  [6890] = 6122,
  [6891] = 2883,
  [6892] = 6892,
  [6893] = 6116,
  [6894] = 2671,
  [6895] = 2660,
  [6896] = 2685,
  [6897] = 2667,
  [6898] = 2655,
  [6899] = 6116,
  [6900] = 6117,
  [6901] = 6121,
  [6902] = 6123,
  [6903] = 6121,
  [6904] = 6378,
  [6905] = 6380,
  [6906] = 6906,
  [6907] = 6372,
  [6908] = 6363,
  [6909] = 6376,
  [6910] = 6845,
  [6911] = 6117,
  [6912] = 6912,
  [6913] = 6913,
  [6914] = 6865,
  [6915] = 6116,
  [6916] = 6876,
  [6917] = 6117,
  [6918] = 6118,
  [6919] = 6845,
  [6920] = 6320,
  [6921] = 6876,
  [6922] = 6871,
  [6923] = 6120,
  [6924] = 6116,
  [6925] = 6117,
  [6926] = 6121,
  [6927] = 6123,
  [6928] = 6928,
  [6929] = 6929,
  [6930] = 6928,
  [6931] = 6931,
  [6932] = 6932,
  [6933] = 6931,
  [6934] = 2671,
  [6935] = 2883,
  [6936] = 6928,
  [6937] = 6937,
  [6938] = 2660,
  [6939] = 6939,
  [6940] = 2685,
  [6941] = 6941,
  [6942] = 6932,
  [6943] = 2667,
  [6944] = 6944,
  [6945] = 6937,
  [6946] = 2655,
  [6947] = 6947,
  [6948] = 6948,
  [6949] = 6949,
  [6950] = 6928,
  [6951] = 2751,
  [6952] = 6929,
  [6953] = 6929,
  [6954] = 6932,
  [6955] = 6944,
  [6956] = 6122,
  [6957] = 6937,
  [6958] = 6932,
  [6959] = 6944,
  [6960] = 6937,
  [6961] = 6944,
  [6962] = 6937,
  [6963] = 6944,
  [6964] = 6937,
  [6965] = 6944,
  [6966] = 6966,
  [6967] = 6937,
  [6968] = 6968,
  [6969] = 6944,
  [6970] = 6970,
  [6971] = 6971,
  [6972] = 6929,
  [6973] = 6931,
  [6974] = 6118,
  [6975] = 6948,
  [6976] = 6931,
  [6977] = 6115,
  [6978] = 6978,
  [6979] = 6979,
  [6980] = 6115,
  [6981] = 6981,
  [6982] = 6524,
  [6983] = 6118,
  [6984] = 6120,
  [6985] = 6985,
  [6986] = 6116,
  [6987] = 6987,
  [6988] = 6117,
  [6989] = 2751,
  [6990] = 6990,
  [6991] = 6991,
  [6992] = 6992,
  [6993] = 6993,
  [6994] = 6994,
  [6995] = 6978,
  [6996] = 6996,
  [6997] = 6122,
  [6998] = 6998,
  [6999] = 6985,
  [7000] = 7000,
  [7001] = 7001,
  [7002] = 7002,
  [7003] = 6504,
  [7004] = 6996,
  [7005] = 7000,
  [7006] = 7006,
  [7007] = 7007,
  [7008] = 7006,
  [7009] = 7009,
  [7010] = 7010,
  [7011] = 2883,
  [7012] = 6992,
  [7013] = 6993,
  [7014] = 6121,
  [7015] = 6990,
  [7016] = 6123,
  [7017] = 7017,
  [7018] = 6990,
  [7019] = 6996,
  [7020] = 2883,
  [7021] = 7007,
  [7022] = 7006,
  [7023] = 6978,
  [7024] = 6990,
  [7025] = 6990,
  [7026] = 7026,
  [7027] = 7027,
  [7028] = 6996,
  [7029] = 7029,
  [7030] = 7030,
  [7031] = 6461,
  [7032] = 6990,
  [7033] = 6992,
  [7034] = 7007,
  [7035] = 6993,
  [7036] = 7036,
  [7037] = 6998,
  [7038] = 6985,
  [7039] = 7039,
  [7040] = 7040,
  [7041] = 7041,
  [7042] = 7000,
  [7043] = 7043,
  [7044] = 6996,
  [7045] = 6998,
  [7046] = 6990,
  [7047] = 6996,
  [7048] = 6996,
  [7049] = 7049,
  [7050] = 7050,
  [7051] = 7051,
  [7052] = 7052,
  [7053] = 7053,
  [7054] = 7051,
  [7055] = 7055,
  [7056] = 7052,
  [7057] = 7052,
  [7058] = 7055,
  [7059] = 6117,
  [7060] = 7055,
  [7061] = 7055,
  [7062] = 7062,
  [7063] = 7062,
  [7064] = 7050,
  [7065] = 7052,
  [7066] = 7052,
  [7067] = 6123,
  [7068] = 7068,
  [7069] = 7062,
  [7070] = 2813,
  [7071] = 6204,
  [7072] = 2883,
  [7073] = 7073,
  [7074] = 7074,
  [7075] = 7055,
  [7076] = 7053,
  [7077] = 7077,
  [7078] = 7050,
  [7079] = 7050,
  [7080] = 2285,
  [7081] = 7055,
  [7082] = 7082,
  [7083] = 7083,
  [7084] = 7084,
  [7085] = 6118,
  [7086] = 7050,
  [7087] = 2883,
  [7088] = 7052,
  [7089] = 7051,
  [7090] = 7090,
  [7091] = 6120,
  [7092] = 7062,
  [7093] = 6121,
  [7094] = 6122,
  [7095] = 7095,
  [7096] = 7096,
  [7097] = 7097,
  [7098] = 7052,
  [7099] = 7052,
  [7100] = 7053,
  [7101] = 7101,
  [7102] = 7062,
  [7103] = 7052,
  [7104] = 7050,
  [7105] = 7062,
  [7106] = 7062,
  [7107] = 7107,
  [7108] = 2286,
  [7109] = 7109,
  [7110] = 7110,
  [7111] = 7050,
  [7112] = 6115,
  [7113] = 7055,
  [7114] = 7114,
  [7115] = 7115,
  [7116] = 7114,
  [7117] = 7117,
  [7118] = 7062,
  [7119] = 7050,
  [7120] = 7055,
  [7121] = 7053,
  [7122] = 6116,
  [7123] = 7051,
  [7124] = 7073,
  [7125] = 7050,
  [7126] = 7055,
  [7127] = 7127,
  [7128] = 7128,
  [7129] = 7129,
  [7130] = 7053,
  [7131] = 7062,
  [7132] = 7132,
  [7133] = 7133,
  [7134] = 7134,
  [7135] = 7135,
  [7136] = 7135,
  [7137] = 7137,
  [7138] = 7138,
  [7139] = 7139,
  [7140] = 7139,
  [7141] = 7137,
  [7142] = 7142,
  [7143] = 7143,
  [7144] = 7144,
  [7145] = 7145,
  [7146] = 7144,
  [7147] = 7147,
  [7148] = 7135,
  [7149] = 7139,
  [7150] = 7150,
  [7151] = 7151,
  [7152] = 7152,
  [7153] = 7153,
  [7154] = 7150,
  [7155] = 7151,
  [7156] = 7153,
  [7157] = 7138,
  [7158] = 7138,
  [7159] = 7159,
  [7160] = 7144,
  [7161] = 7151,
  [7162] = 7162,
  [7163] = 7144,
  [7164] = 7138,
  [7165] = 7165,
  [7166] = 7162,
  [7167] = 7132,
  [7168] = 7152,
  [7169] = 7162,
  [7170] = 7170,
  [7171] = 7150,
  [7172] = 7139,
  [7173] = 7153,
  [7174] = 7139,
  [7175] = 7144,
  [7176] = 7145,
  [7177] = 7139,
  [7178] = 7178,
  [7179] = 7179,
  [7180] = 7145,
  [7181] = 7139,
  [7182] = 7138,
  [7183] = 7137,
  [7184] = 7184,
  [7185] = 7159,
  [7186] = 7151,
  [7187] = 7135,
  [7188] = 7188,
  [7189] = 7139,
  [7190] = 7138,
  [7191] = 7139,
  [7192] = 7162,
  [7193] = 7145,
  [7194] = 7194,
  [7195] = 7142,
  [7196] = 7178,
  [7197] = 7135,
  [7198] = 7150,
  [7199] = 7150,
  [7200] = 7139,
  [7201] = 7153,
  [7202] = 7132,
  [7203] = 7147,
  [7204] = 7162,
  [7205] = 7139,
  [7206] = 7132,
  [7207] = 7207,
  [7208] = 7208,
  [7209] = 7145,
  [7210] = 7210,
  [7211] = 7143,
  [7212] = 7178,
  [7213] = 7179,
  [7214] = 7178,
  [7215] = 7179,
  [7216] = 7178,
  [7217] = 7137,
  [7218] = 7159,
  [7219] = 7151,
  [7220] = 7220,
  [7221] = 7162,
  [7222] = 7179,
  [7223] = 7132,
  [7224] = 7135,
  [7225] = 7138,
  [7226] = 7143,
  [7227] = 7138,
  [7228] = 7139,
  [7229] = 7152,
  [7230] = 7162,
  [7231] = 7142,
  [7232] = 7232,
  [7233] = 7147,
  [7234] = 7234,
  [7235] = 7232,
  [7236] = 7178,
  [7237] = 7152,
  [7238] = 7179,
  [7239] = 7239,
  [7240] = 7147,
  [7241] = 7241,
  [7242] = 7242,
  [7243] = 7143,
  [7244] = 7244,
  [7245] = 7139,
  [7246] = 7142,
  [7247] = 7151,
  [7248] = 7248,
  [7249] = 7152,
  [7250] = 7188,
  [7251] = 7134,
  [7252] = 7252,
  [7253] = 7253,
  [7254] = 7145,
  [7255] = 7255,
  [7256] = 7142,
  [7257] = 6204,
  [7258] = 7137,
  [7259] = 7232,
  [7260] = 7260,
  [7261] = 7151,
  [7262] = 7144,
  [7263] = 7138,
  [7264] = 7139,
  [7265] = 7145,
  [7266] = 7145,
  [7267] = 7152,
  [7268] = 7153,
  [7269] = 7159,
  [7270] = 7151,
  [7271] = 7271,
  [7272] = 7272,
  [7273] = 7273,
  [7274] = 7150,
  [7275] = 7137,
  [7276] = 7276,
  [7277] = 7139,
  [7278] = 7278,
  [7279] = 7153,
  [7280] = 7137,
  [7281] = 7159,
  [7282] = 7145,
  [7283] = 7151,
  [7284] = 7132,
  [7285] = 7132,
  [7286] = 7179,
  [7287] = 7137,
  [7288] = 7145,
  [7289] = 7138,
  [7290] = 7145,
  [7291] = 7137,
  [7292] = 7145,
  [7293] = 7143,
  [7294] = 7294,
  [7295] = 7138,
  [7296] = 7296,
  [7297] = 7159,
  [7298] = 7151,
  [7299] = 7184,
  [7300] = 7139,
  [7301] = 7143,
  [7302] = 7147,
  [7303] = 7159,
  [7304] = 7304,
  [7305] = 7188,
  [7306] = 7134,
  [7307] = 7232,
  [7308] = 7145,
  [7309] = 7147,
  [7310] = 7139,
  [7311] = 7151,
  [7312] = 7159,
  [7313] = 7313,
  [7314] = 7159,
  [7315] = 7188,
  [7316] = 7232,
  [7317] = 7317,
  [7318] = 7151,
  [7319] = 7188,
  [7320] = 7232,
  [7321] = 7188,
  [7322] = 7232,
  [7323] = 7323,
  [7324] = 7151,
  [7325] = 7188,
  [7326] = 7232,
  [7327] = 7139,
  [7328] = 7188,
  [7329] = 7232,
  [7330] = 7188,
  [7331] = 7139,
  [7332] = 7137,
  [7333] = 7145,
  [7334] = 2883,
  [7335] = 7138,
  [7336] = 7151,
  [7337] = 7337,
  [7338] = 7137,
  [7339] = 7137,
  [7340] = 7159,
  [7341] = 7341,
  [7342] = 7139,
  [7343] = 7142,
  [7344] = 7184,
  [7345] = 7145,
  [7346] = 7151,
  [7347] = 7152,
  [7348] = 7348,
  [7349] = 7151,
  [7350] = 7159,
  [7351] = 7151,
  [7352] = 7145,
  [7353] = 7139,
  [7354] = 7135,
  [7355] = 7145,
  [7356] = 7145,
  [7357] = 7184,
  [7358] = 7151,
  [7359] = 7143,
  [7360] = 7139,
  [7361] = 7135,
  [7362] = 7135,
  [7363] = 7145,
  [7364] = 7151,
  [7365] = 7144,
  [7366] = 7159,
  [7367] = 7367,
  [7368] = 7368,
  [7369] = 7369,
  [7370] = 7370,
  [7371] = 7371,
  [7372] = 2934,
  [7373] = 7373,
  [7374] = 7374,
  [7375] = 7375,
  [7376] = 7376,
  [7377] = 7377,
  [7378] = 7378,
  [7379] = 7379,
  [7380] = 7373,
  [7381] = 7381,
  [7382] = 7382,
  [7383] = 7383,
  [7384] = 7369,
  [7385] = 7385,
  [7386] = 7386,
  [7387] = 7376,
  [7388] = 7378,
  [7389] = 7385,
  [7390] = 7390,
  [7391] = 203,
  [7392] = 7392,
  [7393] = 7393,
  [7394] = 7394,
  [7395] = 7395,
  [7396] = 7369,
  [7397] = 7397,
  [7398] = 7397,
  [7399] = 7368,
  [7400] = 7400,
  [7401] = 7397,
  [7402] = 7402,
  [7403] = 7370,
  [7404] = 7404,
  [7405] = 7379,
  [7406] = 7406,
  [7407] = 7377,
  [7408] = 7406,
  [7409] = 2896,
  [7410] = 7397,
  [7411] = 7368,
  [7412] = 7370,
  [7413] = 7413,
  [7414] = 7397,
  [7415] = 7385,
  [7416] = 7416,
  [7417] = 7417,
  [7418] = 7418,
  [7419] = 7377,
  [7420] = 7420,
  [7421] = 7376,
  [7422] = 7420,
  [7423] = 7381,
  [7424] = 7424,
  [7425] = 7425,
  [7426] = 7426,
  [7427] = 7427,
  [7428] = 7369,
  [7429] = 7379,
  [7430] = 7378,
  [7431] = 7373,
  [7432] = 7432,
  [7433] = 7433,
  [7434] = 7426,
  [7435] = 7369,
  [7436] = 7379,
  [7437] = 7437,
  [7438] = 7432,
  [7439] = 7406,
  [7440] = 7385,
  [7441] = 7432,
  [7442] = 7373,
  [7443] = 7443,
  [7444] = 7374,
  [7445] = 7445,
  [7446] = 7374,
  [7447] = 7447,
  [7448] = 7373,
  [7449] = 7367,
  [7450] = 7376,
  [7451] = 7420,
  [7452] = 7368,
  [7453] = 7370,
  [7454] = 7395,
  [7455] = 7426,
  [7456] = 7456,
  [7457] = 7457,
  [7458] = 7378,
  [7459] = 7369,
  [7460] = 7460,
  [7461] = 7379,
  [7462] = 7381,
  [7463] = 7463,
  [7464] = 7373,
  [7465] = 7465,
  [7466] = 7466,
  [7467] = 7467,
  [7468] = 2897,
  [7469] = 7469,
  [7470] = 7379,
  [7471] = 7385,
  [7472] = 7472,
  [7473] = 7473,
  [7474] = 7424,
  [7475] = 7445,
  [7476] = 7402,
  [7477] = 7374,
  [7478] = 7377,
  [7479] = 7376,
  [7480] = 7480,
  [7481] = 7481,
  [7482] = 6852,
  [7483] = 7424,
  [7484] = 197,
  [7485] = 7368,
  [7486] = 7370,
  [7487] = 7381,
  [7488] = 7369,
  [7489] = 7489,
  [7490] = 7490,
  [7491] = 7381,
  [7492] = 7492,
  [7493] = 7493,
  [7494] = 7370,
  [7495] = 7495,
  [7496] = 7496,
  [7497] = 7497,
  [7498] = 7473,
  [7499] = 7378,
  [7500] = 7369,
  [7501] = 7370,
  [7502] = 7502,
  [7503] = 7379,
  [7504] = 7370,
  [7505] = 7370,
  [7506] = 7506,
  [7507] = 7373,
  [7508] = 7463,
  [7509] = 7424,
  [7510] = 7374,
  [7511] = 7404,
  [7512] = 7512,
  [7513] = 7513,
  [7514] = 7379,
  [7515] = 7378,
  [7516] = 7516,
  [7517] = 7424,
  [7518] = 7518,
  [7519] = 7369,
  [7520] = 7381,
  [7521] = 7456,
  [7522] = 7522,
  [7523] = 7377,
  [7524] = 7376,
  [7525] = 7525,
  [7526] = 7424,
  [7527] = 7527,
  [7528] = 7528,
  [7529] = 7465,
  [7530] = 7393,
  [7531] = 7406,
  [7532] = 7367,
  [7533] = 7463,
  [7534] = 7534,
  [7535] = 7465,
  [7536] = 7525,
  [7537] = 7467,
  [7538] = 7538,
  [7539] = 7539,
  [7540] = 7540,
  [7541] = 7467,
  [7542] = 7542,
  [7543] = 7466,
  [7544] = 7367,
  [7545] = 7456,
  [7546] = 7463,
  [7547] = 7379,
  [7548] = 7548,
  [7549] = 7542,
  [7550] = 7534,
  [7551] = 7551,
  [7552] = 7552,
  [7553] = 7373,
  [7554] = 7374,
  [7555] = 7542,
  [7556] = 7542,
  [7557] = 7445,
  [7558] = 7558,
  [7559] = 7377,
  [7560] = 7385,
  [7561] = 7376,
  [7562] = 7402,
  [7563] = 7373,
  [7564] = 7424,
  [7565] = 7465,
  [7566] = 7385,
  [7567] = 7473,
  [7568] = 7457,
  [7569] = 7378,
  [7570] = 7570,
  [7571] = 7373,
  [7572] = 7395,
  [7573] = 7456,
  [7574] = 7369,
  [7575] = 7379,
  [7576] = 7576,
  [7577] = 7373,
  [7578] = 7578,
  [7579] = 7579,
  [7580] = 7367,
  [7581] = 7456,
  [7582] = 7467,
  [7583] = 7463,
  [7584] = 7420,
  [7585] = 7585,
  [7586] = 7534,
  [7587] = 7587,
  [7588] = 7367,
  [7589] = 7496,
  [7590] = 7590,
  [7591] = 7591,
  [7592] = 7496,
  [7593] = 7456,
  [7594] = 7594,
  [7595] = 7378,
  [7596] = 7522,
  [7597] = 7378,
  [7598] = 7538,
  [7599] = 7599,
  [7600] = 7426,
  [7601] = 7378,
  [7602] = 7522,
  [7603] = 7385,
  [7604] = 7397,
  [7605] = 7385,
  [7606] = 7606,
  [7607] = 7368,
  [7608] = 7460,
  [7609] = 7609,
  [7610] = 7610,
  [7611] = 7522,
  [7612] = 7378,
  [7613] = 7460,
  [7614] = 7614,
  [7615] = 7369,
  [7616] = 7395,
  [7617] = 7466,
  [7618] = 7369,
  [7619] = 7373,
  [7620] = 7394,
  [7621] = 7621,
  [7622] = 7373,
  [7623] = 7404,
  [7624] = 7395,
  [7625] = 7368,
  [7626] = 7534,
  [7627] = 7627,
  [7628] = 7628,
  [7629] = 7525,
  [7630] = 7385,
  [7631] = 7631,
  [7632] = 7632,
  [7633] = 7496,
  [7634] = 7367,
  [7635] = 7456,
  [7636] = 7636,
  [7637] = 7385,
  [7638] = 2909,
  [7639] = 7525,
  [7640] = 2911,
  [7641] = 7378,
  [7642] = 7473,
  [7643] = 7465,
  [7644] = 2883,
  [7645] = 7397,
  [7646] = 7406,
  [7647] = 7379,
  [7648] = 7648,
  [7649] = 7649,
  [7650] = 7393,
  [7651] = 7538,
  [7652] = 7652,
  [7653] = 7465,
  [7654] = 7654,
  [7655] = 7463,
  [7656] = 7420,
  [7657] = 7657,
  [7658] = 7534,
  [7659] = 196,
  [7660] = 7525,
  [7661] = 7385,
  [7662] = 7432,
  [7663] = 7385,
  [7664] = 7467,
  [7665] = 7542,
  [7666] = 7426,
  [7667] = 7378,
  [7668] = 7369,
  [7669] = 7379,
  [7670] = 7542,
  [7671] = 7373,
  [7672] = 7538,
  [7673] = 7467,
  [7674] = 7394,
  [7675] = 7420,
  [7676] = 7402,
  [7677] = 7385,
  [7678] = 7368,
  [7679] = 7377,
  [7680] = 7680,
  [7681] = 7402,
  [7682] = 7385,
  [7683] = 7370,
  [7684] = 7684,
  [7685] = 7473,
  [7686] = 7467,
  [7687] = 7496,
  [7688] = 7688,
  [7689] = 7689,
  [7690] = 7496,
  [7691] = 7691,
  [7692] = 7627,
  [7693] = 7369,
  [7694] = 7404,
  [7695] = 7378,
  [7696] = 7522,
  [7697] = 7697,
  [7698] = 7369,
  [7699] = 7522,
  [7700] = 7378,
  [7701] = 7701,
  [7702] = 7702,
  [7703] = 7443,
  [7704] = 7463,
  [7705] = 7705,
  [7706] = 7706,
  [7707] = 7707,
  [7708] = 7525,
  [7709] = 7466,
  [7710] = 7420,
  [7711] = 7378,
  [7712] = 7712,
  [7713] = 2916,
  [7714] = 7381,
  [7715] = 7370,
  [7716] = 7716,
  [7717] = 7717,
  [7718] = 7385,
  [7719] = 7542,
  [7720] = 7720,
  [7721] = 7538,
  [7722] = 7525,
  [7723] = 7473,
  [7724] = 7443,
  [7725] = 7725,
  [7726] = 2917,
  [7727] = 7465,
  [7728] = 7457,
  [7729] = 7378,
  [7730] = 7730,
  [7731] = 7378,
  [7732] = 7369,
  [7733] = 7379,
  [7734] = 7373,
  [7735] = 7735,
  [7736] = 7395,
  [7737] = 7467,
  [7738] = 7738,
  [7739] = 7538,
  [7740] = 7379,
  [7741] = 7627,
  [7742] = 7426,
  [7743] = 7743,
  [7744] = 7424,
  [7745] = 7426,
  [7746] = 7746,
  [7747] = 7466,
  [7748] = 7465,
  [7749] = 7385,
  [7750] = 7467,
  [7751] = 7373,
  [7752] = 7393,
  [7753] = 7378,
  [7754] = 7369,
  [7755] = 7379,
  [7756] = 7373,
  [7757] = 7627,
  [7758] = 7525,
  [7759] = 7369,
  [7760] = 7760,
  [7761] = 7496,
  [7762] = 7379,
  [7763] = 7763,
  [7764] = 2921,
  [7765] = 7373,
  [7766] = 7766,
  [7767] = 7538,
  [7768] = 7496,
  [7769] = 2901,
  [7770] = 7385,
  [7771] = 7385,
  [7772] = 2902,
  [7773] = 7522,
  [7774] = 7443,
  [7775] = 7394,
  [7776] = 7378,
  [7777] = 7534,
  [7778] = 7369,
  [7779] = 7379,
  [7780] = 7373,
  [7781] = 7781,
  [7782] = 7369,
  [7783] = 7369,
  [7784] = 7466,
  [7785] = 7432,
  [7786] = 7432,
  [7787] = 7538,
  [7788] = 7379,
  [7789] = 7432,
  [7790] = 7790,
  [7791] = 7791,
  [7792] = 7373,
  [7793] = 7379,
  [7794] = 7379,
  [7795] = 7795,
  [7796] = 7385,
  [7797] = 7466,
  [7798] = 7385,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7378,
  [7802] = 7369,
  [7803] = 7374,
  [7804] = 7379,
  [7805] = 7373,
  [7806] = 7424,
  [7807] = 7370,
  [7808] = 7808,
  [7809] = 7402,
  [7810] = 7406,
  [7811] = 7432,
  [7812] = 7432,
  [7813] = 7373,
  [7814] = 7814,
  [7815] = 7378,
  [7816] = 7816,
  [7817] = 7817,
  [7818] = 7385,
  [7819] = 7465,
  [7820] = 7379,
  [7821] = 7821,
  [7822] = 7821,
  [7823] = 7823,
  [7824] = 7821,
  [7825] = 7825,
  [7826] = 7825,
  [7827] = 7827,
  [7828] = 7825,
  [7829] = 7829,
  [7830] = 7830,
  [7831] = 7831,
  [7832] = 7832,
  [7833] = 7833,
  [7834] = 7834,
  [7835] = 7835,
  [7836] = 7836,
  [7837] = 7821,
  [7838] = 7838,
  [7839] = 7839,
  [7840] = 7840,
  [7841] = 7841,
  [7842] = 7834,
  [7843] = 7843,
  [7844] = 7838,
  [7845] = 7845,
  [7846] = 7846,
  [7847] = 7825,
  [7848] = 7848,
  [7849] = 7849,
  [7850] = 7821,
  [7851] = 7829,
  [7852] = 7852,
  [7853] = 7853,
  [7854] = 7854,
  [7855] = 7855,
  [7856] = 7843,
  [7857] = 7857,
  [7858] = 7858,
  [7859] = 7859,
  [7860] = 7860,
  [7861] = 7861,
  [7862] = 7862,
  [7863] = 7831,
  [7864] = 7864,
  [7865] = 7865,
  [7866] = 7866,
  [7867] = 7859,
  [7868] = 7868,
  [7869] = 7869,
  [7870] = 7834,
  [7871] = 7871,
  [7872] = 7843,
  [7873] = 7857,
  [7874] = 7821,
  [7875] = 7832,
  [7876] = 7876,
  [7877] = 7877,
  [7878] = 7858,
  [7879] = 7879,
  [7880] = 7868,
  [7881] = 7881,
  [7882] = 7882,
  [7883] = 7883,
  [7884] = 7884,
  [7885] = 7885,
  [7886] = 7886,
  [7887] = 7869,
  [7888] = 7832,
  [7889] = 7889,
  [7890] = 7890,
  [7891] = 7885,
  [7892] = 7846,
  [7893] = 7893,
  [7894] = 7841,
  [7895] = 7841,
  [7896] = 7896,
  [7897] = 7897,
  [7898] = 7827,
  [7899] = 7899,
  [7900] = 7890,
  [7901] = 7833,
  [7902] = 7893,
  [7903] = 7897,
  [7904] = 7899,
  [7905] = 7849,
  [7906] = 7896,
  [7907] = 7836,
  [7908] = 7908,
  [7909] = 7841,
  [7910] = 7910,
  [7911] = 7834,
  [7912] = 7825,
  [7913] = 7849,
  [7914] = 7861,
  [7915] = 7829,
  [7916] = 7864,
  [7917] = 7882,
  [7918] = 7910,
  [7919] = 7843,
  [7920] = 7821,
  [7921] = 7921,
  [7922] = 7857,
  [7923] = 7858,
  [7924] = 7849,
  [7925] = 7886,
  [7926] = 7831,
  [7927] = 7927,
  [7928] = 7928,
  [7929] = 7841,
  [7930] = 7829,
  [7931] = 7931,
  [7932] = 7932,
  [7933] = 7933,
  [7934] = 7835,
  [7935] = 7849,
  [7936] = 7843,
  [7937] = 7829,
  [7938] = 7876,
  [7939] = 7846,
  [7940] = 7843,
  [7941] = 7857,
  [7942] = 7858,
  [7943] = 7943,
  [7944] = 7866,
  [7945] = 7831,
  [7946] = 7908,
  [7947] = 7932,
  [7948] = 7866,
  [7949] = 7881,
  [7950] = 7838,
  [7951] = 7951,
  [7952] = 7843,
  [7953] = 7866,
  [7954] = 7821,
  [7955] = 7868,
  [7956] = 7869,
  [7957] = 7890,
  [7958] = 7827,
  [7959] = 7830,
  [7960] = 7821,
  [7961] = 7833,
  [7962] = 7835,
  [7963] = 7963,
  [7964] = 7868,
  [7965] = 7869,
  [7966] = 7883,
  [7967] = 7876,
  [7968] = 7877,
  [7969] = 7857,
  [7970] = 7854,
  [7971] = 7855,
  [7972] = 7972,
  [7973] = 7885,
  [7974] = 7859,
  [7975] = 7858,
  [7976] = 7862,
  [7977] = 7886,
  [7978] = 7864,
  [7979] = 7893,
  [7980] = 7832,
  [7981] = 7861,
  [7982] = 7846,
  [7983] = 7868,
  [7984] = 7876,
  [7985] = 7877,
  [7986] = 7897,
  [7987] = 7869,
  [7988] = 7881,
  [7989] = 7899,
  [7990] = 7838,
  [7991] = 7951,
  [7992] = 7882,
  [7993] = 7821,
  [7994] = 7994,
  [7995] = 7883,
  [7996] = 7884,
  [7997] = 7827,
  [7998] = 7830,
  [7999] = 7999,
  [8000] = 7833,
  [8001] = 7835,
  [8002] = 8002,
  [8003] = 7885,
  [8004] = 7886,
  [8005] = 7854,
  [8006] = 7831,
  [8007] = 7855,
  [8008] = 7841,
  [8009] = 7857,
  [8010] = 7932,
  [8011] = 7859,
  [8012] = 7862,
  [8013] = 7832,
  [8014] = 7836,
  [8015] = 7849,
  [8016] = 7864,
  [8017] = 7843,
  [8018] = 7858,
  [8019] = 7866,
  [8020] = 7845,
  [8021] = 7846,
  [8022] = 7866,
  [8023] = 8023,
  [8024] = 7881,
  [8025] = 7868,
  [8026] = 7951,
  [8027] = 7869,
  [8028] = 7827,
  [8029] = 7830,
  [8030] = 7835,
  [8031] = 8031,
  [8032] = 7833,
  [8033] = 7868,
  [8034] = 7869,
  [8035] = 7876,
  [8036] = 7928,
  [8037] = 7854,
  [8038] = 7855,
  [8039] = 7890,
  [8040] = 7885,
  [8041] = 7859,
  [8042] = 7886,
  [8043] = 7893,
  [8044] = 7897,
  [8045] = 7832,
  [8046] = 7864,
  [8047] = 7899,
  [8048] = 7846,
  [8049] = 7884,
  [8050] = 7951,
  [8051] = 7827,
  [8052] = 8052,
  [8053] = 7951,
  [8054] = 7908,
  [8055] = 8055,
  [8056] = 7866,
  [8057] = 7854,
  [8058] = 7821,
  [8059] = 7855,
  [8060] = 7829,
  [8061] = 7910,
  [8062] = 7859,
  [8063] = 7825,
  [8064] = 7864,
  [8065] = 7841,
  [8066] = 8066,
  [8067] = 7849,
  [8068] = 7951,
  [8069] = 7861,
  [8070] = 7843,
  [8071] = 7951,
  [8072] = 7858,
  [8073] = 7827,
  [8074] = 7845,
  [8075] = 7866,
  [8076] = 7868,
  [8077] = 7869,
  [8078] = 8078,
  [8079] = 7855,
  [8080] = 7859,
  [8081] = 8081,
  [8082] = 7825,
  [8083] = 7861,
  [8084] = 7876,
  [8085] = 7951,
  [8086] = 7827,
  [8087] = 7876,
  [8088] = 7885,
  [8089] = 7886,
  [8090] = 7855,
  [8091] = 7827,
  [8092] = 7846,
  [8093] = 7876,
  [8094] = 7862,
  [8095] = 7827,
  [8096] = 8096,
  [8097] = 7877,
  [8098] = 7834,
  [8099] = 7821,
  [8100] = 7834,
  [8101] = 7821,
  [8102] = 7830,
  [8103] = 8103,
  [8104] = 8104,
  [8105] = 7841,
  [8106] = 8106,
  [8107] = 7843,
  [8108] = 7858,
  [8109] = 7866,
  [8110] = 7868,
  [8111] = 7869,
  [8112] = 7876,
  [8113] = 7885,
  [8114] = 7886,
  [8115] = 8115,
  [8116] = 7846,
  [8117] = 8117,
  [8118] = 7876,
  [8119] = 7846,
  [8120] = 7841,
  [8121] = 7896,
  [8122] = 7882,
  [8123] = 7821,
  [8124] = 7908,
  [8125] = 8125,
  [8126] = 7883,
  [8127] = 8127,
  [8128] = 7862,
  [8129] = 7884,
  [8130] = 7838,
  [8131] = 7843,
  [8132] = 7999,
  [8133] = 7858,
  [8134] = 7877,
  [8135] = 8135,
  [8136] = 7885,
  [8137] = 7876,
  [8138] = 7849,
  [8139] = 7886,
  [8140] = 7846,
  [8141] = 7829,
  [8142] = 7841,
  [8143] = 7855,
  [8144] = 7843,
  [8145] = 7821,
  [8146] = 7857,
  [8147] = 7862,
  [8148] = 7858,
  [8149] = 7833,
  [8150] = 7858,
  [8151] = 7896,
  [8152] = 7832,
  [8153] = 7836,
  [8154] = 7841,
  [8155] = 7821,
  [8156] = 7868,
  [8157] = 7869,
  [8158] = 7831,
  [8159] = 7886,
  [8160] = 7858,
  [8161] = 7866,
  [8162] = 7845,
  [8163] = 7830,
  [8164] = 7846,
  [8165] = 7821,
  [8166] = 7868,
  [8167] = 7869,
  [8168] = 7999,
  [8169] = 7858,
  [8170] = 8170,
  [8171] = 8171,
  [8172] = 7877,
  [8173] = 7821,
  [8174] = 7858,
  [8175] = 7882,
  [8176] = 7876,
  [8177] = 7877,
  [8178] = 8178,
  [8179] = 7821,
  [8180] = 7890,
  [8181] = 8181,
  [8182] = 7893,
  [8183] = 7897,
  [8184] = 7858,
  [8185] = 7899,
  [8186] = 7883,
  [8187] = 7882,
  [8188] = 7883,
  [8189] = 7884,
  [8190] = 8190,
  [8191] = 7885,
  [8192] = 7848,
  [8193] = 7858,
  [8194] = 7886,
  [8195] = 7841,
  [8196] = 7884,
  [8197] = 7868,
  [8198] = 7869,
  [8199] = 7886,
  [8200] = 7999,
  [8201] = 7832,
  [8202] = 7858,
  [8203] = 7896,
  [8204] = 8204,
  [8205] = 7885,
  [8206] = 7846,
  [8207] = 7858,
  [8208] = 7910,
  [8209] = 7932,
  [8210] = 7858,
  [8211] = 8211,
  [8212] = 7890,
  [8213] = 7908,
  [8214] = 7893,
  [8215] = 7897,
  [8216] = 7899,
  [8217] = 8217,
  [8218] = 8218,
  [8219] = 7908,
  [8220] = 7886,
  [8221] = 8221,
  [8222] = 8222,
  [8223] = 7848,
  [8224] = 8224,
  [8225] = 7848,
  [8226] = 8226,
  [8227] = 7848,
  [8228] = 8228,
  [8229] = 7848,
  [8230] = 7881,
  [8231] = 7848,
  [8232] = 7848,
  [8233] = 7848,
  [8234] = 7848,
  [8235] = 7848,
  [8236] = 7848,
  [8237] = 7848,
  [8238] = 7848,
  [8239] = 7848,
  [8240] = 7848,
  [8241] = 7848,
  [8242] = 7838,
  [8243] = 7849,
  [8244] = 7835,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 8247,
  [8248] = 8248,
  [8249] = 8249,
  [8250] = 8250,
  [8251] = 8251,
  [8252] = 8252,
  [8253] = 8253,
  [8254] = 8254,
  [8255] = 8255,
  [8256] = 8256,
  [8257] = 8257,
  [8258] = 8258,
  [8259] = 8259,
  [8260] = 8260,
  [8261] = 8261,
  [8262] = 8262,
  [8263] = 8263,
  [8264] = 8264,
  [8265] = 8265,
  [8266] = 8266,
  [8267] = 8267,
  [8268] = 8268,
  [8269] = 8256,
  [8270] = 8270,
  [8271] = 8253,
  [8272] = 8272,
  [8273] = 8273,
  [8274] = 8274,
  [8275] = 8275,
  [8276] = 8276,
  [8277] = 8275,
  [8278] = 8278,
  [8279] = 8279,
  [8280] = 8280,
  [8281] = 8281,
  [8282] = 8282,
  [8283] = 8283,
  [8284] = 8250,
  [8285] = 8285,
  [8286] = 8278,
  [8287] = 8287,
  [8288] = 8288,
  [8289] = 8289,
  [8290] = 8290,
  [8291] = 8291,
  [8292] = 8292,
  [8293] = 8293,
  [8294] = 8294,
  [8295] = 8295,
  [8296] = 8296,
  [8297] = 8297,
  [8298] = 8291,
  [8299] = 8297,
  [8300] = 8300,
  [8301] = 8292,
  [8302] = 8302,
  [8303] = 8303,
  [8304] = 8304,
  [8305] = 8305,
  [8306] = 8306,
  [8307] = 8307,
  [8308] = 8308,
  [8309] = 8309,
  [8310] = 8310,
  [8311] = 8311,
  [8312] = 8312,
  [8313] = 8313,
  [8314] = 8314,
  [8315] = 8256,
  [8316] = 8316,
  [8317] = 8288,
  [8318] = 8318,
  [8319] = 8319,
  [8320] = 8320,
  [8321] = 8321,
  [8322] = 8322,
  [8323] = 8323,
  [8324] = 8251,
  [8325] = 8273,
  [8326] = 8326,
  [8327] = 8274,
  [8328] = 8279,
  [8329] = 8329,
  [8330] = 8263,
  [8331] = 8281,
  [8332] = 8332,
  [8333] = 8285,
  [8334] = 8334,
  [8335] = 8335,
  [8336] = 8250,
  [8337] = 8337,
  [8338] = 8310,
  [8339] = 8251,
  [8340] = 8263,
  [8341] = 8285,
  [8342] = 8342,
  [8343] = 8310,
  [8344] = 8249,
  [8345] = 8345,
  [8346] = 8346,
  [8347] = 8252,
  [8348] = 8348,
  [8349] = 8349,
  [8350] = 5857,
  [8351] = 8351,
  [8352] = 8352,
  [8353] = 8353,
  [8354] = 8354,
  [8355] = 8355,
  [8356] = 8356,
  [8357] = 8357,
  [8358] = 8262,
  [8359] = 8359,
  [8360] = 8293,
  [8361] = 8361,
  [8362] = 8300,
  [8363] = 8363,
  [8364] = 8355,
  [8365] = 8365,
  [8366] = 8366,
  [8367] = 8367,
  [8368] = 8264,
  [8369] = 8356,
  [8370] = 8370,
  [8371] = 8371,
  [8372] = 8308,
  [8373] = 8373,
  [8374] = 8318,
  [8375] = 8375,
  [8376] = 8376,
  [8377] = 8266,
  [8378] = 8366,
  [8379] = 8267,
  [8380] = 8256,
  [8381] = 8253,
  [8382] = 8257,
  [8383] = 8383,
  [8384] = 8384,
  [8385] = 8385,
  [8386] = 8275,
  [8387] = 8278,
  [8388] = 8388,
  [8389] = 8305,
  [8390] = 8390,
  [8391] = 8247,
  [8392] = 8302,
  [8393] = 8262,
  [8394] = 8394,
  [8395] = 8370,
  [8396] = 8285,
  [8397] = 8303,
  [8398] = 8390,
  [8399] = 8248,
  [8400] = 8318,
  [8401] = 8401,
  [8402] = 8402,
  [8403] = 8314,
  [8404] = 8249,
  [8405] = 8365,
  [8406] = 8252,
  [8407] = 8247,
  [8408] = 8320,
  [8409] = 8409,
  [8410] = 8410,
  [8411] = 8411,
  [8412] = 8373,
  [8413] = 8282,
  [8414] = 8414,
  [8415] = 8290,
  [8416] = 8361,
  [8417] = 8417,
  [8418] = 8418,
  [8419] = 8419,
  [8420] = 8420,
  [8421] = 8384,
  [8422] = 8422,
  [8423] = 8281,
  [8424] = 8342,
  [8425] = 8417,
  [8426] = 8250,
  [8427] = 8310,
  [8428] = 8365,
  [8429] = 8290,
  [8430] = 8430,
  [8431] = 8361,
  [8432] = 8264,
  [8433] = 8266,
  [8434] = 8357,
  [8435] = 8287,
  [8436] = 8287,
  [8437] = 8256,
  [8438] = 8318,
  [8439] = 8363,
  [8440] = 8440,
  [8441] = 8441,
  [8442] = 8249,
  [8443] = 8443,
  [8444] = 8444,
  [8445] = 8355,
  [8446] = 8385,
  [8447] = 8444,
  [8448] = 8448,
  [8449] = 8449,
  [8450] = 8256,
  [8451] = 8388,
  [8452] = 8452,
  [8453] = 8267,
  [8454] = 8319,
  [8455] = 8356,
  [8456] = 8288,
  [8457] = 8247,
  [8458] = 8287,
  [8459] = 8275,
  [8460] = 8278,
  [8461] = 8309,
  [8462] = 8303,
  [8463] = 8248,
  [8464] = 8297,
  [8465] = 8465,
  [8466] = 8282,
  [8467] = 8292,
  [8468] = 8313,
  [8469] = 8320,
  [8470] = 8470,
  [8471] = 8471,
  [8472] = 8290,
  [8473] = 8263,
  [8474] = 8272,
  [8475] = 8326,
  [8476] = 8476,
  [8477] = 8287,
  [8478] = 8478,
  [8479] = 8479,
  [8480] = 8302,
  [8481] = 8390,
  [8482] = 8291,
  [8483] = 8297,
  [8484] = 8342,
  [8485] = 8485,
  [8486] = 8486,
  [8487] = 8300,
  [8488] = 8488,
  [8489] = 8335,
  [8490] = 8313,
  [8491] = 8491,
  [8492] = 8263,
  [8493] = 8357,
  [8494] = 8285,
  [8495] = 8495,
  [8496] = 8310,
  [8497] = 8302,
  [8498] = 8363,
  [8499] = 8499,
  [8500] = 8500,
  [8501] = 8288,
  [8502] = 8502,
  [8503] = 8503,
  [8504] = 8309,
  [8505] = 8505,
  [8506] = 8506,
  [8507] = 8441,
  [8508] = 8264,
  [8509] = 8509,
  [8510] = 8262,
  [8511] = 8511,
  [8512] = 8267,
  [8513] = 8383,
  [8514] = 8329,
  [8515] = 8515,
  [8516] = 8249,
  [8517] = 8290,
  [8518] = 8275,
  [8519] = 8278,
  [8520] = 8365,
  [8521] = 8303,
  [8522] = 8370,
  [8523] = 8523,
  [8524] = 8273,
  [8525] = 8525,
  [8526] = 8388,
  [8527] = 8274,
  [8528] = 8291,
  [8529] = 8279,
  [8530] = 8305,
  [8531] = 8297,
  [8532] = 8281,
  [8533] = 8370,
  [8534] = 8534,
  [8535] = 8390,
  [8536] = 8355,
  [8537] = 8342,
  [8538] = 8346,
  [8539] = 8539,
  [8540] = 8373,
  [8541] = 8300,
  [8542] = 8500,
  [8543] = 8247,
  [8544] = 8291,
  [8545] = 8502,
  [8546] = 8546,
  [8547] = 8547,
  [8548] = 8363,
  [8549] = 8549,
  [8550] = 8290,
  [8551] = 8302,
  [8552] = 8552,
  [8553] = 8356,
  [8554] = 8554,
  [8555] = 8384,
  [8556] = 8556,
  [8557] = 8288,
  [8558] = 8281,
  [8559] = 8559,
  [8560] = 8305,
  [8561] = 8273,
  [8562] = 8274,
  [8563] = 8279,
  [8564] = 8250,
  [8565] = 8275,
  [8566] = 8278,
  [8567] = 8567,
  [8568] = 8281,
  [8569] = 8297,
  [8570] = 8318,
  [8571] = 8355,
  [8572] = 8572,
  [8573] = 8307,
  [8574] = 8342,
  [8575] = 8249,
  [8576] = 8356,
  [8577] = 8357,
  [8578] = 8363,
  [8579] = 8444,
  [8580] = 8580,
  [8581] = 8345,
  [8582] = 8278,
  [8583] = 8256,
  [8584] = 8584,
  [8585] = 8585,
  [8586] = 8586,
  [8587] = 8388,
  [8588] = 8342,
  [8589] = 8320,
  [8590] = 8376,
  [8591] = 8363,
  [8592] = 8592,
  [8593] = 8287,
  [8594] = 8278,
  [8595] = 8247,
  [8596] = 8419,
  [8597] = 8597,
  [8598] = 8297,
  [8599] = 8342,
  [8600] = 8363,
  [8601] = 8278,
  [8602] = 8602,
  [8603] = 8603,
  [8604] = 8363,
  [8605] = 8278,
  [8606] = 8584,
  [8607] = 8300,
  [8608] = 8363,
  [8609] = 8278,
  [8610] = 8363,
  [8611] = 8278,
  [8612] = 8363,
  [8613] = 8278,
  [8614] = 8363,
  [8615] = 8278,
  [8616] = 8363,
  [8617] = 8278,
  [8618] = 8363,
  [8619] = 8278,
  [8620] = 8620,
  [8621] = 8559,
  [8622] = 8622,
  [8623] = 8552,
  [8624] = 8293,
  [8625] = 8332,
  [8626] = 8626,
  [8627] = 8627,
  [8628] = 8262,
  [8629] = 8314,
  [8630] = 8630,
  [8631] = 8294,
  [8632] = 8632,
  [8633] = 8633,
  [8634] = 8634,
  [8635] = 8296,
  [8636] = 8287,
  [8637] = 8251,
  [8638] = 8638,
  [8639] = 8260,
  [8640] = 8313,
  [8641] = 8641,
  [8642] = 8444,
  [8643] = 8313,
  [8644] = 8644,
  [8645] = 8253,
  [8646] = 8646,
  [8647] = 8647,
  [8648] = 8648,
  [8649] = 8649,
  [8650] = 8251,
  [8651] = 8345,
  [8652] = 8263,
  [8653] = 8418,
  [8654] = 8654,
  [8655] = 8506,
  [8656] = 8656,
  [8657] = 8657,
  [8658] = 8285,
  [8659] = 8310,
  [8660] = 8272,
  [8661] = 8661,
  [8662] = 8309,
  [8663] = 2473,
  [8664] = 8365,
  [8665] = 8665,
  [8666] = 8666,
  [8667] = 8272,
  [8668] = 8305,
  [8669] = 8669,
  [8670] = 8264,
  [8671] = 8370,
  [8672] = 8313,
  [8673] = 8390,
  [8674] = 8585,
  [8675] = 8247,
  [8676] = 8676,
  [8677] = 8677,
  [8678] = 8678,
  [8679] = 8262,
  [8680] = 8280,
  [8681] = 8681,
  [8682] = 8682,
  [8683] = 8250,
  [8684] = 8250,
  [8685] = 8685,
  [8686] = 8686,
  [8687] = 8290,
  [8688] = 8281,
  [8689] = 8373,
  [8690] = 8363,
  [8691] = 8384,
  [8692] = 7110,
  [8693] = 8251,
  [8694] = 8249,
  [8695] = 8263,
  [8696] = 8696,
  [8697] = 8258,
  [8698] = 8365,
  [8699] = 8285,
  [8700] = 8256,
  [8701] = 8310,
  [8702] = 8702,
  [8703] = 8703,
  [8704] = 8318,
  [8705] = 8316,
  [8706] = 8706,
  [8707] = 8297,
  [8708] = 8647,
  [8709] = 8709,
  [8710] = 8254,
  [8711] = 8254,
  [8712] = 8712,
  [8713] = 8262,
  [8714] = 8714,
  [8715] = 8272,
  [8716] = 8323,
  [8717] = 8292,
  [8718] = 8525,
  [8719] = 8500,
  [8720] = 8661,
  [8721] = 8502,
  [8722] = 8251,
  [8723] = 8723,
  [8724] = 8444,
  [8725] = 8725,
  [8726] = 8251,
  [8727] = 8727,
  [8728] = 8388,
  [8729] = 8376,
  [8730] = 8251,
  [8731] = 8345,
  [8732] = 8305,
  [8733] = 8733,
  [8734] = 8370,
  [8735] = 8584,
  [8736] = 8249,
  [8737] = 8293,
  [8738] = 8738,
  [8739] = 8252,
  [8740] = 8740,
  [8741] = 8741,
  [8742] = 8349,
  [8743] = 8307,
  [8744] = 8744,
  [8745] = 8294,
  [8746] = 8263,
  [8747] = 8256,
  [8748] = 8305,
  [8749] = 8285,
  [8750] = 8307,
  [8751] = 8297,
  [8752] = 8310,
  [8753] = 8753,
  [8754] = 8370,
  [8755] = 8352,
  [8756] = 8296,
  [8757] = 8757,
  [8758] = 8366,
  [8759] = 8254,
  [8760] = 8760,
  [8761] = 8761,
  [8762] = 8266,
  [8763] = 8383,
  [8764] = 8361,
  [8765] = 8352,
  [8766] = 8766,
  [8767] = 8385,
  [8768] = 8263,
  [8769] = 8769,
  [8770] = 8770,
  [8771] = 8384,
  [8772] = 8772,
  [8773] = 8370,
  [8774] = 8774,
  [8775] = 8775,
  [8776] = 8250,
  [8777] = 8777,
  [8778] = 8500,
  [8779] = 8779,
  [8780] = 8305,
  [8781] = 8376,
  [8782] = 8256,
  [8783] = 8297,
  [8784] = 8307,
  [8785] = 8266,
  [8786] = 8786,
  [8787] = 8256,
  [8788] = 8313,
  [8789] = 8789,
  [8790] = 8790,
  [8791] = 8791,
  [8792] = 8792,
  [8793] = 8500,
  [8794] = 8254,
  [8795] = 8795,
  [8796] = 8502,
  [8797] = 8797,
  [8798] = 8273,
  [8799] = 8799,
  [8800] = 8488,
  [8801] = 8370,
  [8802] = 8366,
  [8803] = 8803,
  [8804] = 8804,
  [8805] = 8805,
  [8806] = 8305,
  [8807] = 8390,
  [8808] = 8247,
  [8809] = 8253,
  [8810] = 8285,
  [8811] = 8307,
  [8812] = 8256,
  [8813] = 8297,
  [8814] = 8814,
  [8815] = 8274,
  [8816] = 8302,
  [8817] = 8817,
  [8818] = 8390,
  [8819] = 8819,
  [8820] = 8251,
  [8821] = 8821,
  [8822] = 8303,
  [8823] = 8304,
  [8824] = 8253,
  [8825] = 8247,
  [8826] = 8248,
  [8827] = 8305,
  [8828] = 8828,
  [8829] = 8829,
  [8830] = 8329,
  [8831] = 8552,
  [8832] = 8626,
  [8833] = 8627,
  [8834] = 8630,
  [8835] = 8361,
  [8836] = 8632,
  [8837] = 8837,
  [8838] = 8282,
  [8839] = 8251,
  [8840] = 8840,
  [8841] = 8290,
  [8842] = 8630,
  [8843] = 8647,
  [8844] = 8844,
  [8845] = 8649,
  [8846] = 8656,
  [8847] = 8769,
  [8848] = 8318,
  [8849] = 8506,
  [8850] = 8656,
  [8851] = 8272,
  [8852] = 8661,
  [8853] = 8373,
  [8854] = 8256,
  [8855] = 8297,
  [8856] = 8420,
  [8857] = 8247,
  [8858] = 8676,
  [8859] = 8370,
  [8860] = 8860,
  [8861] = 8861,
  [8862] = 8258,
  [8863] = 8316,
  [8864] = 8366,
  [8865] = 8865,
  [8866] = 8388,
  [8867] = 8552,
  [8868] = 8626,
  [8869] = 8630,
  [8870] = 8273,
  [8871] = 8632,
  [8872] = 8872,
  [8873] = 8873,
  [8874] = 8647,
  [8875] = 8274,
  [8876] = 8649,
  [8877] = 8279,
  [8878] = 8307,
  [8879] = 8506,
  [8880] = 8656,
  [8881] = 8370,
  [8882] = 8281,
  [8883] = 8676,
  [8884] = 8884,
  [8885] = 8250,
  [8886] = 8310,
  [8887] = 8258,
  [8888] = 8316,
  [8889] = 8889,
  [8890] = 8890,
  [8891] = 8552,
  [8892] = 8626,
  [8893] = 8630,
  [8894] = 8894,
  [8895] = 8632,
  [8896] = 8896,
  [8897] = 8323,
  [8898] = 8647,
  [8899] = 8649,
  [8900] = 8287,
  [8901] = 8256,
  [8902] = 8506,
  [8903] = 8656,
  [8904] = 8904,
  [8905] = 8297,
  [8906] = 8676,
  [8907] = 8907,
  [8908] = 8293,
  [8909] = 8258,
  [8910] = 8316,
  [8911] = 8584,
  [8912] = 8552,
  [8913] = 8626,
  [8914] = 8630,
  [8915] = 8342,
  [8916] = 8632,
  [8917] = 8314,
  [8918] = 5933,
  [8919] = 8649,
  [8920] = 8390,
  [8921] = 8626,
  [8922] = 8506,
  [8923] = 8656,
  [8924] = 8267,
  [8925] = 8279,
  [8926] = 8676,
  [8927] = 8927,
  [8928] = 8928,
  [8929] = 8258,
  [8930] = 8316,
  [8931] = 8370,
  [8932] = 8552,
  [8933] = 8626,
  [8934] = 8320,
  [8935] = 8632,
  [8936] = 8357,
  [8937] = 8937,
  [8938] = 8318,
  [8939] = 8525,
  [8940] = 8506,
  [8941] = 8656,
  [8942] = 8942,
  [8943] = 8256,
  [8944] = 8297,
  [8945] = 8945,
  [8946] = 8258,
  [8947] = 8247,
  [8948] = 8552,
  [8949] = 8626,
  [8950] = 8632,
  [8951] = 8366,
  [8952] = 8656,
  [8953] = 8288,
  [8954] = 8251,
  [8955] = 8258,
  [8956] = 8275,
  [8957] = 8552,
  [8958] = 8626,
  [8959] = 8632,
  [8960] = 8390,
  [8961] = 8656,
  [8962] = 8248,
  [8963] = 8258,
  [8964] = 8552,
  [8965] = 8626,
  [8966] = 8632,
  [8967] = 8656,
  [8968] = 8258,
  [8969] = 8626,
  [8970] = 8656,
  [8971] = 8258,
  [8972] = 8626,
  [8973] = 8656,
  [8974] = 8258,
  [8975] = 8656,
  [8976] = 8258,
  [8977] = 8656,
  [8978] = 8258,
  [8979] = 8656,
  [8980] = 8258,
  [8981] = 8656,
  [8982] = 8258,
  [8983] = 8656,
  [8984] = 8258,
  [8985] = 8985,
  [8986] = 8345,
  [8987] = 8627,
  [8988] = 8865,
  [8989] = 8452,
  [8990] = 8990,
  [8991] = 8247,
  [8992] = 8249,
  [8993] = 8419,
  [8994] = 8252,
  [8995] = 8632,
  [8996] = 8282,
  [8997] = 8495,
  [8998] = 8352,
  [8999] = 8256,
  [9000] = 9000,
  [9001] = 8297,
  [9002] = 8361,
  [9003] = 8661,
  [9004] = 8293,
  [9005] = 9005,
  [9006] = 8272,
  [9007] = 8584,
  [9008] = 8585,
  [9009] = 8829,
  [9010] = 8290,
  [9011] = 8304,
  [9012] = 8744,
  [9013] = 9013,
  [9014] = 8309,
  [9015] = 8294,
  [9016] = 8390,
  [9017] = 8502,
  [9018] = 8266,
  [9019] = 5927,
  [9020] = 9020,
  [9021] = 8266,
  [9022] = 2478,
  [9023] = 8256,
  [9024] = 8359,
  [9025] = 9025,
  [9026] = 8278,
  [9027] = 8363,
  [9028] = 8249,
  [9029] = 9029,
  [9030] = 9030,
  [9031] = 9031,
  [9032] = 9032,
  [9033] = 8282,
  [9034] = 8420,
  [9035] = 8251,
  [9036] = 9036,
  [9037] = 8282,
  [9038] = 9038,
  [9039] = 8411,
  [9040] = 8252,
  [9041] = 8296,
  [9042] = 8250,
  [9043] = 9043,
  [9044] = 8559,
  [9045] = 5896,
  [9046] = 8287,
  [9047] = 8250,
  [9048] = 8247,
  [9049] = 8273,
  [9050] = 8274,
  [9051] = 8279,
  [9052] = 8769,
  [9053] = 8342,
  [9054] = 8288,
  [9055] = 8349,
  [9056] = 8309,
  [9057] = 8495,
  [9058] = 9058,
  [9059] = 8303,
  [9060] = 8252,
  [9061] = 9061,
  [9062] = 8248,
  [9063] = 8627,
  [9064] = 8257,
  [9065] = 8281,
  [9066] = 8291,
  [9067] = 8297,
  [9068] = 9068,
  [9069] = 8300,
  [9070] = 8260,
  [9071] = 8250,
  [9072] = 8250,
  [9073] = 8302,
  [9074] = 8303,
  [9075] = 8627,
  [9076] = 8865,
  [9077] = 8452,
  [9078] = 9078,
  [9079] = 8304,
  [9080] = 9080,
  [9081] = 8661,
  [9082] = 8280,
  [9083] = 8585,
  [9084] = 8829,
  [9085] = 9085,
  [9086] = 8267,
  [9087] = 8649,
  [9088] = 9088,
  [9089] = 8627,
  [9090] = 8865,
  [9091] = 8452,
  [9092] = 8281,
  [9093] = 8254,
  [9094] = 8661,
  [9095] = 8585,
  [9096] = 8829,
  [9097] = 8291,
  [9098] = 8297,
  [9099] = 8352,
  [9100] = 8865,
  [9101] = 8452,
  [9102] = 9102,
  [9103] = 8308,
  [9104] = 8585,
  [9105] = 8829,
  [9106] = 8319,
  [9107] = 8293,
  [9108] = 8865,
  [9109] = 8452,
  [9110] = 8290,
  [9111] = 8488,
  [9112] = 8585,
  [9113] = 8829,
  [9114] = 8326,
  [9115] = 8865,
  [9116] = 8452,
  [9117] = 8254,
  [9118] = 8585,
  [9119] = 8829,
  [9120] = 8320,
  [9121] = 8585,
  [9122] = 8829,
  [9123] = 8411,
  [9124] = 8829,
  [9125] = 8342,
  [9126] = 8829,
  [9127] = 8355,
  [9128] = 8829,
  [9129] = 8356,
  [9130] = 8829,
  [9131] = 8357,
  [9132] = 8829,
  [9133] = 8323,
  [9134] = 8829,
  [9135] = 8264,
  [9136] = 8829,
  [9137] = 9137,
  [9138] = 8829,
  [9139] = 9139,
  [9140] = 8829,
  [9141] = 8904,
  [9142] = 8805,
  [9143] = 8318,
  [9144] = 8904,
  [9145] = 8805,
  [9146] = 8314,
  [9147] = 8904,
  [9148] = 8805,
  [9149] = 8363,
  [9150] = 8904,
  [9151] = 8805,
  [9152] = 8335,
  [9153] = 8904,
  [9154] = 8805,
  [9155] = 8346,
  [9156] = 8805,
  [9157] = 8805,
  [9158] = 8805,
  [9159] = 8805,
  [9160] = 8805,
  [9161] = 8805,
  [9162] = 8805,
  [9163] = 8805,
  [9164] = 8805,
  [9165] = 8805,
  [9166] = 8805,
  [9167] = 9167,
  [9168] = 9168,
  [9169] = 8676,
  [9170] = 8300,
  [9171] = 8420,
  [9172] = 9000,
  [9173] = 9000,
  [9174] = 9000,
  [9175] = 9000,
  [9176] = 9000,
  [9177] = 9177,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328},
  {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a},
  {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644},
  {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909},
  {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1},
  {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8},
  {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c},
  {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf3}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff65, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x11241}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69},
  {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132},
  {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c},
  {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb},
  {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f},
  {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42},
  {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59},
  {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77},
  {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9},
  {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
  {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(343);
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '#', 289,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 347,
        ')', 350,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 413,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 472,
        '\\', 2,
        ']', 474,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(165);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(165);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(210);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(210);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(171);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(171);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(178);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(178);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(168);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(168);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(169);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(169);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(190);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(190);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(179);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(179);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(187);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(187);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(191);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(191);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(181);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(181);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(198);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(198);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(228);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(228);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(244);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(188);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(188);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(204);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(204);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(172);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(172);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(246);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(246);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(245);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(245);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(247);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(248);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(248);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(254);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(254);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(99);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(99);
      if (lookahead == '\r') SKIP(97);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '\n', 352,
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 422,
        '-', 412,
        '/', 431,
        '<', 457,
        '=', 277,
        '>', 448,
      );
      if (lookahead == '\\') SKIP(98);
      if (lookahead == '^') ADVANCE(440);
      if (lookahead == '|') ADVANCE(439);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(180);
      END_STATE();
    case 101:
      if (lookahead == '\n') SKIP(180);
      if (lookahead == '\r') SKIP(100);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(249);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(249);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(236);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(253);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(253);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 109:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(108);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 110:
      if (lookahead == '\n') ADVANCE(345);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '(') ADVANCE(347);
      if (lookahead == '/') ADVANCE(373);
      if (lookahead == '\\') ADVANCE(368);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(267);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(345);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '/') ADVANCE(373);
      if (lookahead == '\\') ADVANCE(368);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(267);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(345);
      if (lookahead == '\r') ADVANCE(113);
      if (lookahead == '(') ADVANCE(408);
      if (lookahead == '/') ADVANCE(258);
      if (lookahead == '\\') SKIP(119);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(255);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(345);
      if (lookahead == '(') ADVANCE(408);
      if (lookahead == '/') ADVANCE(258);
      if (lookahead == '\\') SKIP(119);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(345);
      if (lookahead == '/') ADVANCE(373);
      if (lookahead == '\\') ADVANCE(368);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 115:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead == '\\') ADVANCE(116);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(533);
      if (lookahead != 0) ADVANCE(534);
      END_STATE();
    case 116:
      if (lookahead == '\n') ADVANCE(536);
      if (lookahead == '\r') ADVANCE(535);
      if (lookahead == 'U') ADVANCE(339);
      if (lookahead == 'u') ADVANCE(331);
      if (lookahead == 'x') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(538);
      if (lookahead != 0) ADVANCE(535);
      END_STATE();
    case 117:
      if (lookahead == '\n') SKIP(250);
      if (lookahead == '\'') ADVANCE(520);
      if (lookahead == '/') ADVANCE(523);
      if (lookahead == '\\') ADVANCE(522);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(524);
      if (lookahead != 0) ADVANCE(521);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(255);
      END_STATE();
    case 119:
      if (lookahead == '\n') SKIP(255);
      if (lookahead == '\r') SKIP(118);
      END_STATE();
    case 120:
      if (lookahead == '\n') SKIP(166);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(166);
      if (lookahead == '\r') SKIP(120);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(170);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(170);
      if (lookahead == '\r') SKIP(122);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(201);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(201);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(184);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(184);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(203);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(203);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(217);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(217);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(167);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(167);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(218);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(218);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(199);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(199);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 160:
      if (lookahead == '\n') SKIP(234);
      END_STATE();
    case 161:
      if (lookahead == '\n') SKIP(234);
      if (lookahead == '\r') SKIP(160);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 162:
      if (lookahead == '\n') SKIP(205);
      END_STATE();
    case 163:
      if (lookahead == '\n') SKIP(205);
      if (lookahead == '\r') SKIP(162);
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 164:
      if (lookahead == '\r') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(638);
      if (lookahead != 0) ADVANCE(643);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '#', 289,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 413,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 472,
        '\\', 2,
        ']', 474,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(165);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '#', 298,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 414,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 121,
        ']', 474,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(166);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '#', 298,
        '%', 433,
        '&', 443,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 415,
        '.', 494,
        '/', 431,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 145,
        ']', 474,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 439,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(167);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 413,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 274,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 24,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(168);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 408,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 414,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 274,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 26,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(169);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '%', 433,
        '&', 443,
        '\'', 520,
        '(', 408,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 415,
        '.', 494,
        '/', 431,
        '0', 502,
        ':', 274,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 123,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 439,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(170);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '!', 410,
        '"', 239,
        '%', 434,
        '&', 444,
        '(', 256,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '/', 432,
        ':', 274,
        '<', 454,
        '=', 476,
        '>', 449,
        '[', 286,
        '\\', 20,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '!', 410,
        '"', 239,
        '%', 434,
        '&', 444,
        '(', 256,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '[', 287,
        '\\', 80,
        '^', 441,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '#', 289,
        '&', 443,
        '\'', 520,
        '(', 408,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 318,
        '/', 258,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '>', 447,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 6,
        ']', 288,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 437,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '#', 293,
        '%', 433,
        '&', 443,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 496,
        '/', 431,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 4,
        ']', 474,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 312,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '#', 297,
        '&', 442,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        '-', 416,
        '.', 264,
        '/', 258,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '>', 280,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 10,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '#', 291,
        '&', 443,
        '\'', 520,
        '(', 408,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 318,
        '/', 258,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '>', 278,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 8,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '&', 443,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 496,
        '/', 258,
        '0', 502,
        ':', 274,
        ';', 464,
        '<', 275,
        '=', 475,
        '>', 645,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 12,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '&', 442,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 496,
        '/', 258,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 470,
        '\\', 22,
        ']', 474,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(178);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '&', 442,
        '\'', 520,
        '(', 408,
        '*', 429,
        '+', 425,
        '-', 415,
        '.', 318,
        '/', 258,
        '0', 502,
        ':', 274,
        '<', 453,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 34,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 409,
        '\'', 520,
        '(', 408,
        ')', 350,
        '+', 427,
        '-', 420,
        '.', 318,
        '/', 258,
        '0', 502,
        'L', 564,
        'U', 565,
        '\\', 101,
        'u', 566,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(180);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 48,
        ']', 474,
        '^', 441,
        'u', 554,
        '{', 468,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 64,
        ']', 474,
        '^', 441,
        'u', 554,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 470,
        '\\', 64,
        ']', 474,
        '^', 441,
        'u', 659,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 133,
        ']', 474,
        '^', 440,
        'u', 554,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 470,
        '\\', 133,
        ']', 474,
        '^', 440,
        'u', 659,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(184);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        ':', 463,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 471,
        '\\', 30,
        '^', 441,
        'u', 554,
        '{', 468,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        ':', 274,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 42,
        '^', 441,
        'u', 554,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 72,
        '^', 441,
        'u', 554,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 470,
        '\\', 72,
        '^', 441,
        'u', 659,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(188);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 471,
        '\\', 28,
        '^', 441,
        'u', 554,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(190);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 274,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 46,
        '^', 441,
        'u', 554,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 74,
        '^', 441,
        'u', 554,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 470,
        '\\', 74,
        '^', 441,
        'u', 659,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        'L', 547,
        'R', 549,
        'U', 551,
        '[', 470,
        '\\', 137,
        '^', 440,
        'u', 554,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 276,
        '"', 529,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        'L', 656,
        'R', 657,
        'U', 658,
        '[', 470,
        '\\', 137,
        '^', 440,
        'u', 659,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 276,
        '#', 309,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 463,
        ';', 464,
        '<', 456,
        '=', 476,
        '>', 448,
        '?', 479,
        '[', 471,
        '\\', 36,
        ']', 474,
        '^', 440,
        '{', 468,
        '|', 439,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '0', 646,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 471,
        '\\', 32,
        ']', 474,
        '^', 441,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 50,
        ']', 474,
        '^', 441,
        '{', 468,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(198);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 471,
        '\\', 157,
        ']', 474,
        '^', 441,
        '{', 468,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 44,
        ']', 474,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 127,
        ']', 474,
        '^', 441,
        '{', 468,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 139,
        ']', 474,
        '^', 441,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 139,
        ']', 474,
        '^', 441,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 473,
        '\\', 76,
        ']', 474,
        '^', 441,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(204);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 463,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 163,
        ']', 474,
        '^', 440,
        '{', 468,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 125,
        ']', 474,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 147,
        ']', 474,
        '^', 440,
        '{', 468,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 151,
        ']', 474,
        '^', 440,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 276,
        '#', 298,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 151,
        ']', 474,
        '^', 440,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 276,
        '#', 292,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 422,
        ',', 349,
        '-', 412,
        '/', 431,
        ':', 274,
        ';', 464,
        '<', 457,
        '=', 277,
        '>', 448,
        '[', 471,
        '\\', 18,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '|', 439,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(210);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 471,
        '\\', 38,
        '^', 441,
        '{', 468,
        '|', 438,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        ':', 463,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 58,
        '^', 441,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        ':', 462,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 129,
        '^', 441,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 472,
        '\\', 82,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 52,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 143,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 470,
        '\\', 143,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 417,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 473,
        '\\', 155,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(218);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 463,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 62,
        '^', 441,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ':', 462,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 149,
        '^', 441,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 449,
        '?', 479,
        '[', 472,
        '\\', 84,
        '^', 441,
        '|', 438,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 471,
        '\\', 78,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 56,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 153,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 153,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '(', 408,
        '*', 430,
        '+', 426,
        ',', 349,
        '-', 418,
        '.', 493,
        '/', 432,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        '[', 473,
        '\\', 141,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 276,
        '%', 434,
        '&', 444,
        '*', 430,
        '+', 428,
        ',', 349,
        '-', 421,
        '.', 257,
        '/', 432,
        '<', 455,
        '=', 476,
        '>', 449,
        '\\', 94,
        '^', 441,
        '|', 438,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 463,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 66,
        ']', 474,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(228);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 274,
        ';', 464,
        '<', 456,
        '=', 277,
        '>', 448,
        '?', 479,
        '[', 470,
        '\\', 135,
        ']', 288,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 439,
        '}', 469,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 463,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 159,
        '^', 440,
        '{', 468,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 70,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        ':', 462,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 131,
        '^', 440,
        '{', 468,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 161,
        '^', 440,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '!', 276,
        '%', 433,
        '&', 443,
        '(', 408,
        '*', 429,
        '+', 423,
        ',', 349,
        '-', 419,
        '.', 493,
        '/', 431,
        '<', 456,
        '=', 277,
        '>', 645,
        '?', 479,
        '[', 470,
        '\\', 161,
        '^', 440,
        '|', 439,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(234);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '"', 529,
        '&', 443,
        '(', 408,
        '*', 429,
        '/', 258,
        ':', 274,
        'L', 548,
        'U', 552,
        '[', 471,
        '\\', 54,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 555,
        'v', 615,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '"', 529,
        ')', 350,
        ',', 349,
        '/', 258,
        ':', 462,
        'L', 547,
        'R', 549,
        'U', 551,
        '\\', 105,
        'u', 554,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '"', 529,
        '/', 258,
        ':', 462,
        '<', 282,
        'L', 548,
        'U', 552,
        '\\', 109,
        'u', 556,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 238:
      if (lookahead == '"') ADVANCE(529);
      if (lookahead == '/') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(116);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      END_STATE();
    case 239:
      if (lookahead == '"') ADVANCE(655);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '#', 294,
        '&', 443,
        '(', 408,
        '*', 429,
        ',', 349,
        '-', 281,
        '/', 258,
        ':', 274,
        ';', 464,
        '[', 471,
        '\\', 16,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 312,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '#', 298,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '-', 281,
        '.', 263,
        '/', 258,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        '[', 471,
        '\\', 40,
        ']', 474,
        '{', 468,
        '|', 312,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '#', 290,
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 422,
        ',', 349,
        '-', 281,
        '.', 495,
        '/', 258,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        '[', 471,
        '\\', 14,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 312,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '-', 281,
        '.', 495,
        '/', 258,
        ':', 462,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        '[', 471,
        '\\', 60,
        ']', 474,
        '{', 468,
        '|', 312,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '-', 281,
        '.', 263,
        '/', 258,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        '[', 470,
        '\\', 68,
        '{', 468,
        '|', 312,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '-', 281,
        '.', 263,
        '/', 258,
        ':', 462,
        ';', 464,
        '=', 475,
        '>', 645,
        '[', 470,
        '\\', 88,
        '{', 468,
        '|', 312,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '-', 281,
        '/', 258,
        ':', 462,
        ';', 464,
        '=', 475,
        '>', 645,
        '[', 471,
        '\\', 86,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '/', 258,
        ':', 463,
        ';', 464,
        '<', 453,
        '[', 470,
        '\\', 90,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
        '|', 312,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '&', 443,
        '(', 408,
        ')', 350,
        '*', 429,
        ',', 349,
        '/', 258,
        ':', 462,
        ';', 464,
        '=', 475,
        '>', 645,
        '[', 470,
        '\\', 92,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 610,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        'u', 603,
        'v', 615,
        '{', 468,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 249:
      ADVANCE_MAP(
        '&', 442,
        '*', 429,
        '.', 263,
        '/', 258,
        ':', 274,
        '=', 475,
        '\\', 103,
        ']', 474,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 250:
      if (lookahead == '\'') ADVANCE(520);
      if (lookahead == '/') ADVANCE(258);
      if (lookahead == '\\') ADVANCE(116);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      END_STATE();
    case 251:
      if (lookahead == '\'') ADVANCE(323);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(251);
      END_STATE();
    case 252:
      if (lookahead == '\'') ADVANCE(319);
      if (lookahead == '.') ADVANCE(509);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(252);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '(', 408,
        ')', 350,
        ',', 349,
        '/', 258,
        ':', 462,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        '[', 472,
        '\\', 107,
        ']', 474,
        '{', 468,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '(', 408,
        '/', 258,
        ':', 274,
        'F', 572,
        'T', 576,
        '[', 470,
        '\\', 96,
        'f', 582,
        't', 623,
        '{', 468,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 255:
      if (lookahead == '(') ADVANCE(408);
      if (lookahead == '/') ADVANCE(258);
      if (lookahead == '\\') SKIP(119);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      END_STATE();
    case 256:
      if (lookahead == ')') ADVANCE(653);
      END_STATE();
    case 257:
      if (lookahead == '*') ADVANCE(497);
      END_STATE();
    case 258:
      if (lookahead == '*') ADVANCE(261);
      if (lookahead == '/') ADVANCE(643);
      END_STATE();
    case 259:
      if (lookahead == '*') ADVANCE(652);
      END_STATE();
    case 260:
      if (lookahead == '*') ADVANCE(260);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead != 0) ADVANCE(261);
      END_STATE();
    case 261:
      if (lookahead == '*') ADVANCE(260);
      if (lookahead != 0) ADVANCE(261);
      END_STATE();
    case 262:
      if (lookahead == '*') ADVANCE(260);
      if (lookahead != 0) ADVANCE(366);
      END_STATE();
    case 263:
      if (lookahead == '.') ADVANCE(265);
      END_STATE();
    case 264:
      if (lookahead == '.') ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 265:
      if (lookahead == '.') ADVANCE(348);
      END_STATE();
    case 266:
      if (lookahead == '.') ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(507);
      END_STATE();
    case 267:
      if (lookahead == '/') ADVANCE(373);
      if (lookahead == '\\') ADVANCE(368);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(267);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 268:
      if (lookahead == '1') ADVANCE(272);
      END_STATE();
    case 269:
      if (lookahead == '2') ADVANCE(500);
      END_STATE();
    case 270:
      if (lookahead == '2') ADVANCE(273);
      if (lookahead == '6') ADVANCE(500);
      END_STATE();
    case 271:
      if (lookahead == '4') ADVANCE(500);
      END_STATE();
    case 272:
      if (lookahead == '6') ADVANCE(500);
      END_STATE();
    case 273:
      if (lookahead == '8') ADVANCE(500);
      END_STATE();
    case 274:
      if (lookahead == ':') ADVANCE(465);
      END_STATE();
    case 275:
      if (lookahead == '<') ADVANCE(458);
      if (lookahead == '=') ADVANCE(451);
      END_STATE();
    case 276:
      if (lookahead == '=') ADVANCE(446);
      END_STATE();
    case 277:
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 278:
      if (lookahead == '=') ADVANCE(450);
      if (lookahead == '>') ADVANCE(460);
      END_STATE();
    case 279:
      if (lookahead == '=') ADVANCE(486);
      END_STATE();
    case 280:
      if (lookahead == '>') ADVANCE(279);
      END_STATE();
    case 281:
      if (lookahead == '>') ADVANCE(498);
      END_STATE();
    case 282:
      if (lookahead == '>') ADVANCE(542);
      if (lookahead == '\\') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(282);
      END_STATE();
    case 283:
      if (lookahead == '>') ADVANCE(543);
      if (lookahead == '\\') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(282);
      END_STATE();
    case 284:
      if (lookahead == 'F') ADVANCE(268);
      END_STATE();
    case 285:
      if (lookahead == 'U') ADVANCE(338);
      if (lookahead == 'u') ADVANCE(330);
      END_STATE();
    case 286:
      if (lookahead == '[') ADVANCE(466);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 287:
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 288:
      if (lookahead == ']') ADVANCE(467);
      END_STATE();
    case 289:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'e') ADVANCE(402);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(289);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 290:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'e') ADVANCE(402);
      if (lookahead == 'i') ADVANCE(391);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 291:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'e') ADVANCE(404);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 292:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'e') ADVANCE(404);
      if (lookahead == 'i') ADVANCE(391);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 293:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'i') ADVANCE(390);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(293);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'i') ADVANCE(391);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 295:
      if (lookahead == 'd') ADVANCE(307);
      END_STATE();
    case 296:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 297:
      if (lookahead == 'e') ADVANCE(311);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(297);
      END_STATE();
    case 298:
      if (lookahead == 'e') ADVANCE(310);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(298);
      END_STATE();
    case 299:
      if (lookahead == 'e') ADVANCE(357);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(305);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(306);
      END_STATE();
    case 302:
      if (lookahead == 'f') ADVANCE(268);
      END_STATE();
    case 303:
      if (lookahead == 'f') ADVANCE(353);
      END_STATE();
    case 304:
      if (lookahead == 'f') ADVANCE(359);
      END_STATE();
    case 305:
      if (lookahead == 'f') ADVANCE(361);
      END_STATE();
    case 306:
      if (lookahead == 'f') ADVANCE(363);
      END_STATE();
    case 307:
      if (lookahead == 'i') ADVANCE(303);
      END_STATE();
    case 308:
      if (lookahead == 'i') ADVANCE(304);
      if (lookahead == 's') ADVANCE(299);
      END_STATE();
    case 309:
      if (lookahead == 'i') ADVANCE(391);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(309);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 310:
      if (lookahead == 'l') ADVANCE(308);
      if (lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 311:
      if (lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 312:
      if (lookahead == '|') ADVANCE(435);
      END_STATE();
    case 313:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(320);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(506);
      END_STATE();
    case 314:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(251);
      END_STATE();
    case 315:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(504);
      END_STATE();
    case 316:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(252);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(503);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(252);
      END_STATE();
    case 320:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(506);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(635);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(507);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(251);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(535);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(541);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(321);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(324);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(330);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 334:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(332);
      END_STATE();
    case 335:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(333);
      END_STATE();
    case 336:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(334);
      END_STATE();
    case 337:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(335);
      END_STATE();
    case 338:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(336);
      END_STATE();
    case 339:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(337);
      END_STATE();
    case 340:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(375);
      END_STATE();
    case 341:
      if (eof) ADVANCE(343);
      ADVANCE_MAP(
        '!', 410,
        '"', 529,
        '#', 289,
        '%', 434,
        '&', 444,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 430,
        '+', 424,
        ',', 349,
        '-', 413,
        '.', 494,
        '/', 432,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 454,
        '=', 476,
        '>', 645,
        '?', 479,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 472,
        '\\', 2,
        ']', 474,
        '^', 441,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 438,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 342:
      if (eof) ADVANCE(343);
      ADVANCE_MAP(
        '!', 409,
        '"', 529,
        '#', 293,
        '%', 433,
        '&', 443,
        '\'', 520,
        '(', 408,
        ')', 350,
        '*', 429,
        '+', 425,
        ',', 349,
        '-', 416,
        '.', 496,
        '/', 431,
        '0', 502,
        ':', 463,
        ';', 464,
        '<', 453,
        '=', 475,
        '>', 645,
        'F', 572,
        'L', 546,
        'R', 549,
        'T', 576,
        'U', 550,
        '[', 471,
        '\\', 4,
        ']', 474,
        '^', 440,
        'b', 618,
        'c', 597,
        'd', 614,
        'f', 581,
        'i', 611,
        'm', 583,
        'n', 631,
        'p', 628,
        's', 598,
        't', 623,
        'u', 553,
        'v', 615,
        '{', 468,
        '|', 312,
        '}', 469,
        '~', 411,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(342);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(635);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(386);
      if (lookahead == 'n') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(352);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(300);
      if (lookahead == 'n') ADVANCE(296);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(388);
      if (lookahead == 'n') ADVANCE(381);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(261);
      if (lookahead == '*') ADVANCE(365);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(371);
      if (lookahead != 0) ADVANCE(366);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(261);
      if (lookahead == '*') ADVANCE(365);
      if (lookahead == '/') ADVANCE(262);
      if (lookahead == '\\') ADVANCE(371);
      if (lookahead != 0) ADVANCE(366);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(643);
      if (lookahead == '\r') ADVANCE(637);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(639);
      if (lookahead != 0) ADVANCE(641);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(267);
      if (lookahead == '\r') ADVANCE(369);
      if (lookahead == '/') ADVANCE(340);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(267);
      if (lookahead == '/') ADVANCE(340);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(376);
      if (lookahead == '/') ADVANCE(340);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(374);
      if (lookahead == '*') ADVANCE(365);
      if (lookahead == '/') ADVANCE(262);
      if (lookahead == '\\') ADVANCE(371);
      if (lookahead != 0) ADVANCE(366);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(642);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(639);
      if (lookahead != 0) ADVANCE(641);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(366);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(375);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(365);
      if (lookahead == '/') ADVANCE(262);
      if (lookahead == '\\') ADVANCE(371);
      if (lookahead != 0) ADVANCE(366);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(340);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(375);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(340);
      if (lookahead == '\\') ADVANCE(370);
      if (lookahead != 0) ADVANCE(375);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(385);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(351);
      if (lookahead == 'n') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(354);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(362);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(393);
      if (lookahead == 's') ADVANCE(383);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(400);
      if (lookahead == 'n') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(406);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(407);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(446);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (lookahead == '=') ADVANCE(484);
      if (lookahead == '>') ADVANCE(499);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (lookahead == '=') ADVANCE(484);
      if (lookahead == '>') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (lookahead == '>') ADVANCE(498);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '=') ADVANCE(484);
      if (lookahead == '>') ADVANCE(499);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '=') ADVANCE(484);
      if (lookahead == '>') ADVANCE(498);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(491);
      if (lookahead == '>') ADVANCE(498);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(484);
      if (lookahead == '>') ADVANCE(259);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(492);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(492);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (lookahead == '=') ADVANCE(483);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(492);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(492);
      if (lookahead == '=') ADVANCE(483);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(318);
      if (lookahead == '0') ADVANCE(502);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(483);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(261);
      if (lookahead == '/') ADVANCE(643);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(261);
      if (lookahead == '/') ADVANCE(643);
      if (lookahead == '=') ADVANCE(481);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(482);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(489);
      if (lookahead == '|') ADVANCE(435);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(435);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(488);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(436);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(436);
      if (lookahead == '=') ADVANCE(487);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(450);
      if (lookahead == '>') ADVANCE(460);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(450);
      if (lookahead == '>') ADVANCE(461);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(490);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(459);
      if (lookahead == '=') ADVANCE(452);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(459);
      if (lookahead == '=') ADVANCE(451);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(458);
      if (lookahead == '=') ADVANCE(452);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(458);
      if (lookahead == '=') ADVANCE(451);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(485);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(486);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(465);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(466);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(466);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(654);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(571);
      if (lookahead == '3') ADVANCE(569);
      if (lookahead == '6') ADVANCE(570);
      if (lookahead == '8') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'p') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(497);
      if (lookahead == '.') ADVANCE(265);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(497);
      if (lookahead == '.') ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(265);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(652);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 318,
        'B', 284,
        'b', 302,
        'E', 313,
        'e', 313,
        'F', 508,
        'f', 508,
        'L', 500,
        'l', 500,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 316,
        '.', 509,
        'L', 510,
        'l', 513,
        'B', 315,
        'b', 315,
        'E', 313,
        'e', 313,
        'U', 512,
        'u', 512,
        'X', 266,
        'x', 266,
        'Z', 515,
        'z', 515,
        '8', 252,
        '9', 252,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(503);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 316,
        '.', 509,
        'L', 510,
        'l', 513,
        'E', 313,
        'e', 313,
        'U', 512,
        'u', 512,
        'Z', 515,
        'z', 515,
        '8', 252,
        '9', 252,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(503);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 315,
        'L', 510,
        'l', 513,
        'U', 512,
        'u', 512,
        'Z', 515,
        'z', 515,
        '0', 504,
        '1', 504,
      );
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 317,
        '.', 509,
        'L', 510,
        'l', 513,
        'E', 313,
        'e', 313,
        'U', 512,
        'u', 512,
        'Z', 515,
        'z', 515,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(320);
      if (lookahead == 'B') ADVANCE(284);
      if (lookahead == 'b') ADVANCE(302);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(508);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(500);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(506);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 322,
        '.', 314,
        'L', 510,
        'l', 513,
        'P', 313,
        'p', 313,
        'U', 512,
        'u', 512,
        'Z', 515,
        'z', 515,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(507);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(270);
      if (lookahead == '3') ADVANCE(269);
      if (lookahead == '6') ADVANCE(271);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 284,
        'b', 302,
        'E', 313,
        'e', 313,
        'F', 508,
        'f', 508,
        'L', 500,
        'l', 500,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(501);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(515);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(500);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(500);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(511);
      if (lookahead == 'l') ADVANCE(514);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(500);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(515);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(500);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(500);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(500);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(536);
      if (lookahead == '\r') ADVANCE(535);
      if (lookahead == 'U') ADVANCE(339);
      if (lookahead == 'u') ADVANCE(331);
      if (lookahead == 'x') ADVANCE(325);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(538);
      if (lookahead != 0) ADVANCE(535);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(261);
      if (lookahead == '/') ADVANCE(643);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(116);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(532);
      if (lookahead == '/') ADVANCE(534);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(534);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(531);
      if (lookahead == '/') ADVANCE(534);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(532);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(531);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(532);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(530);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(533);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(534);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(534);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(116);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(535);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(537);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(535);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(539);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(540);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(542);
      if (lookahead == '\\') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(282);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(516);
      if (lookahead == 'R') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == 'R') ADVANCE(557);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '\'') ADVANCE(518);
      if (lookahead == 'R') ADVANCE(558);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == 'R') ADVANCE(558);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '\'') ADVANCE(517);
      if (lookahead == '8') ADVANCE(559);
      if (lookahead == 'R') ADVANCE(562);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '8') ADVANCE(560);
      if (lookahead == 'R') ADVANCE(562);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '8') ADVANCE(561);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '8') ADVANCE(561);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(648);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(650);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == '\'') ADVANCE(519);
      if (lookahead == 'R') ADVANCE(563);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == 'R') ADVANCE(563);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(649);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(516);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(517);
      if (lookahead == '8') ADVANCE(567);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(519);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(571);
      if (lookahead == '3') ADVANCE(569);
      if (lookahead == '6') ADVANCE(570);
      if (lookahead == '8') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'p') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(580);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(575);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(544);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(545);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(577);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(578);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(574);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == '_') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == '_') ADVANCE(626);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(604);
      if (lookahead == 'l') ADVANCE(616);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(604);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(633);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(626);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'a') ADVANCE(608);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'b') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'd') ADVANCE(478);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'd') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(544);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(478);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(545);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'e') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'f') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'f') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'g') ADVANCE(612);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'h') ADVANCE(584);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(634);
      if (lookahead == 's') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(634);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(596);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'i') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(624);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(478);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(601);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(591);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'l') ADVANCE(616);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'n') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'n') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'n') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'o') ADVANCE(630);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'o') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'o') ADVANCE(585);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'o') ADVANCE(605);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'o') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'p') ADVANCE(629);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(477);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'r') ADVANCE(632);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 's') ADVANCE(592);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 't') ADVANCE(477);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 't') ADVANCE(478);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 't') ADVANCE(568);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 't') ADVANCE(621);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 't') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(607);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(590);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'x') ADVANCE(579);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead == 'z') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(643);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(372);
      if (lookahead != 0) ADVANCE(641);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(638);
      if (lookahead != 0) ADVANCE(643);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(642);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(639);
      if (lookahead != 0) ADVANCE(641);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(367);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(641);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(372);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(641);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(372);
      if (lookahead != 0) ADVANCE(641);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(643);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(164);
      if (lookahead != 0) ADVANCE(643);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(aux_sym_pure_virtual_clause_token1);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == 'R') ADVANCE(660);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(647);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(527);
      if (lookahead == 'R') ADVANCE(661);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(526);
      if (lookahead == '8') ADVANCE(662);
      if (lookahead == 'R') ADVANCE(663);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(648);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(650);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(528);
      if (lookahead == 'R') ADVANCE(664);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(649);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(651);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(665);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(635);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'x') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(25);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(26);
      if (lookahead == 'G') ADVANCE(27);
      if (lookahead == 'N') ADVANCE(28);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      if (lookahead == 's') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'b') ADVANCE(39);
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'l') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 'i') ADVANCE(44);
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(48);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      if (lookahead == 'r') ADVANCE(54);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(55);
      if (lookahead == 'm') ADVANCE(56);
      if (lookahead == 'n') ADVANCE(57);
      END_STATE();
    case 12:
      if (lookahead == 'i') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(60);
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'e') ADVANCE(63);
      if (lookahead == 'o') ADVANCE(64);
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'p') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(68);
      if (lookahead == 'u') ADVANCE(69);
      if (lookahead == 'v') ADVANCE(70);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(72);
      if (lookahead == 'u') ADVANCE(73);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(74);
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(76);
      if (lookahead == 'h') ADVANCE(77);
      if (lookahead == 'i') ADVANCE(78);
      if (lookahead == 'n') ADVANCE(79);
      if (lookahead == 't') ADVANCE(80);
      if (lookahead == 'w') ADVANCE(81);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(82);
      if (lookahead == 'h') ADVANCE(83);
      if (lookahead == 'r') ADVANCE(84);
      if (lookahead == 'y') ADVANCE(85);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(86);
      if (lookahead == 's') ADVANCE(87);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(88);
      if (lookahead == 'o') ADVANCE(89);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(90);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 24:
      if (lookahead == 'L') ADVANCE(92);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(93);
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'a', 97,
        'b', 98,
        'c', 99,
        'd', 100,
        'e', 101,
        'f', 102,
        'i', 103,
        'l', 104,
        'r', 105,
        's', 106,
        't', 107,
        'u', 108,
        'v', 109,
      );
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(110);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(111);
      END_STATE();
    case 32:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(113);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 38:
      if (lookahead == 's') ADVANCE(118);
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(120);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(121);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(122);
      END_STATE();
    case 42:
      if (lookahead == '_') ADVANCE(123);
      if (lookahead == 'l') ADVANCE(124);
      if (lookahead == 'm') ADVANCE(125);
      if (lookahead == 'n') ADVANCE(126);
      END_STATE();
    case 43:
      if (lookahead == 'c') ADVANCE(127);
      if (lookahead == 'f') ADVANCE(128);
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 44:
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 46:
      if (lookahead == 's') ADVANCE(131);
      END_STATE();
    case 47:
      if (lookahead == 'u') ADVANCE(132);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(133);
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(135);
      END_STATE();
    case 50:
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(137);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(138);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(139);
      END_STATE();
    case 54:
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 56:
      if (lookahead == 'p') ADVANCE(141);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'l') ADVANCE(142);
      if (lookahead == 'o') ADVANCE(143);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(145);
      END_STATE();
    case 60:
      if (lookahead == 'd') ADVANCE(146);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 62:
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 63:
      if (lookahead == 'w') ADVANCE(149);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(150);
      if (lookahead == 'i') ADVANCE(151);
      if (lookahead == 'p') ADVANCE(152);
      if (lookahead == 'r') ADVANCE(153);
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 66:
      if (lookahead == 'f') ADVANCE(156);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(158);
      END_STATE();
    case 69:
      if (lookahead == 't') ADVANCE(159);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(162);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 73:
      if (lookahead == 'b') ADVANCE(165);
      END_STATE();
    case 74:
      if (lookahead == 'g') ADVANCE(166);
      if (lookahead == 'q') ADVANCE(167);
      if (lookahead == 's') ADVANCE(168);
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 75:
      if (lookahead == 'w') ADVANCE(170);
      END_STATE();
    case 76:
      if (lookahead == 'm') ADVANCE(171);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == 'o') ADVANCE(173);
      END_STATE();
    case 78:
      if (lookahead == 'g') ADVANCE(174);
      if (lookahead == 'z') ADVANCE(175);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(177);
      if (lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 81:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 82:
      if (lookahead == 'm') ADVANCE(180);
      END_STATE();
    case 83:
      if (lookahead == 'i') ADVANCE(181);
      if (lookahead == 'r') ADVANCE(182);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(183);
      if (lookahead == 'y') ADVANCE(184);
      END_STATE();
    case 85:
      if (lookahead == 'p') ADVANCE(185);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(186);
      if (lookahead == 'o') ADVANCE(187);
      if (lookahead == 's') ADVANCE(188);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(191);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 92:
      if (lookahead == 'L') ADVANCE(194);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 94:
      if (lookahead == 'o') ADVANCE(196);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(198);
      if (lookahead == 'r') ADVANCE(199);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(200);
      if (lookahead == 's') ADVANCE(201);
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(203);
      END_STATE();
    case 99:
      if (lookahead == 'd') ADVANCE(204);
      if (lookahead == 'l') ADVANCE(205);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(206);
      END_STATE();
    case 101:
      if (lookahead == 'x') ADVANCE(207);
      END_STATE();
    case 102:
      if (lookahead == 'a') ADVANCE(208);
      if (lookahead == 'i') ADVANCE(209);
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(211);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 106:
      if (lookahead == 'p') ADVANCE(214);
      if (lookahead == 't') ADVANCE(215);
      END_STATE();
    case 107:
      if (lookahead == 'h') ADVANCE(216);
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 108:
      if (lookahead == 'n') ADVANCE(218);
      if (lookahead == 'p') ADVANCE(219);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(220);
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 110:
      if (lookahead == 'i') ADVANCE(222);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(223);
      END_STATE();
    case 112:
      if (lookahead == 'g') ADVANCE(224);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(225);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 115:
      if (lookahead == 'o') ADVANCE(226);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(227);
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 119:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 120:
      if (lookahead == 'f') ADVANCE(232);
      END_STATE();
    case 121:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(234);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(235);
      if (lookahead == 'r') ADVANCE(236);
      if (lookahead == 'y') ADVANCE(237);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(238);
      END_STATE();
    case 125:
      if (lookahead == 'p') ADVANCE(239);
      END_STATE();
    case 126:
      if (lookahead == 'c') ADVANCE(240);
      if (lookahead == 's') ADVANCE(241);
      if (lookahead == 't') ADVANCE(242);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(244);
      if (lookahead == 'i') ADVANCE(245);
      END_STATE();
    case 129:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 130:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(248);
      END_STATE();
    case 132:
      if (lookahead == 'm') ADVANCE(249);
      END_STATE();
    case 133:
      if (lookahead == 'l') ADVANCE(250);
      if (lookahead == 'o') ADVANCE(251);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 135:
      if (lookahead == 'a') ADVANCE(253);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(254);
      END_STATE();
    case 138:
      if (lookahead == 'b') ADVANCE(255);
      END_STATE();
    case 139:
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 140:
      if (lookahead == 'u') ADVANCE(257);
      END_STATE();
    case 141:
      if (lookahead == 'o') ADVANCE(258);
      END_STATE();
    case 142:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(260);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 145:
      if (lookahead == 'g') ADVANCE(262);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(263);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(264);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(265);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 150:
      if (lookahead == 'x') ADVANCE(266);
      END_STATE();
    case 151:
      if (lookahead == 'n') ADVANCE(267);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(270);
      END_STATE();
    case 155:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 156:
      if (lookahead == 's') ADVANCE(272);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(273);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(274);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 160:
      if (lookahead == 'r') ADVANCE(275);
      END_STATE();
    case 161:
      if (lookahead == 'n') ADVANCE(276);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(277);
      END_STATE();
    case 163:
      if (lookahead == 'v') ADVANCE(278);
      END_STATE();
    case 164:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 165:
      if (lookahead == 'l') ADVANCE(280);
      END_STATE();
    case 166:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 167:
      if (lookahead == 'u') ADVANCE(282);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 169:
      if (lookahead == 'u') ADVANCE(284);
      END_STATE();
    case 170:
      if (lookahead == '_') ADVANCE(285);
      END_STATE();
    case 171:
      if (lookahead == 'p') ADVANCE(286);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 175:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 176:
      if (lookahead == 'r') ADVANCE(291);
      END_STATE();
    case 177:
      if (lookahead == 't') ADVANCE(292);
      END_STATE();
    case 178:
      if (lookahead == 'u') ADVANCE(293);
      END_STATE();
    case 179:
      if (lookahead == 't') ADVANCE(294);
      END_STATE();
    case 180:
      if (lookahead == 'p') ADVANCE(295);
      END_STATE();
    case 181:
      if (lookahead == 's') ADVANCE(296);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(297);
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 183:
      if (lookahead == 'a') ADVANCE(299);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 185:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 186:
      if (lookahead == 'f') ADVANCE(301);
      if (lookahead == 'o') ADVANCE(302);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 188:
      if (lookahead == 'i') ADVANCE(304);
      END_STATE();
    case 189:
      if (lookahead == 'n') ADVANCE(305);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 191:
      if (lookahead == 'a') ADVANCE(307);
      END_STATE();
    case 192:
      if (lookahead == 'l') ADVANCE(308);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(309);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 195:
      if (lookahead == 'g') ADVANCE(310);
      END_STATE();
    case 196:
      if (lookahead == 'm') ADVANCE(311);
      END_STATE();
    case 197:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 198:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 200:
      if (lookahead == 'i') ADVANCE(315);
      END_STATE();
    case 201:
      if (lookahead == 'm') ADVANCE(316);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(317);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(318);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 205:
      if (lookahead == 'r') ADVANCE(320);
      END_STATE();
    case 206:
      if (lookahead == 'c') ADVANCE(321);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 't') ADVANCE(323);
      END_STATE();
    case 208:
      if (lookahead == 's') ADVANCE(324);
      END_STATE();
    case 209:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(326);
      END_STATE();
    case 211:
      if (lookahead == 'l') ADVANCE(327);
      END_STATE();
    case 212:
      if (lookahead == 'a') ADVANCE(328);
      END_STATE();
    case 213:
      if (lookahead == 's') ADVANCE(329);
      END_STATE();
    case 214:
      if (lookahead == 't') ADVANCE(330);
      END_STATE();
    case 215:
      if (lookahead == 'd') ADVANCE(331);
      END_STATE();
    case 216:
      if (lookahead == 'i') ADVANCE(332);
      if (lookahead == 'r') ADVANCE(333);
      END_STATE();
    case 217:
      if (lookahead == 'y') ADVANCE(334);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(335);
      END_STATE();
    case 219:
      if (lookahead == 't') ADVANCE(336);
      END_STATE();
    case 220:
      if (lookahead == 'c') ADVANCE(337);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(338);
      END_STATE();
    case 222:
      if (lookahead == 'g') ADVANCE(339);
      END_STATE();
    case 223:
      if (lookahead == 'l') ADVANCE(340);
      END_STATE();
    case 224:
      if (lookahead == 'n') ADVANCE(341);
      END_STATE();
    case 225:
      if (lookahead == 'e') ADVANCE(342);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 227:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 228:
      if (lookahead == 'r') ADVANCE(344);
      END_STATE();
    case 229:
      if (lookahead == 'k') ADVANCE(345);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 231:
      if (lookahead == 'h') ADVANCE(346);
      END_STATE();
    case 232:
      if (lookahead == 'f') ADVANCE(347);
      END_STATE();
    case 233:
      if (lookahead == 'r') ADVANCE(348);
      END_STATE();
    case 234:
      if (lookahead == 's') ADVANCE(349);
      END_STATE();
    case 235:
      if (lookahead == 'w') ADVANCE(350);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 237:
      if (lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 238:
      if (lookahead == 'm') ADVANCE(353);
      END_STATE();
    case 239:
      if (lookahead == 'l') ADVANCE(354);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(356);
      END_STATE();
    case 242:
      if (lookahead == 'i') ADVANCE(357);
      END_STATE();
    case 243:
      if (lookahead == 't') ADVANCE(358);
      END_STATE();
    case 244:
      if (lookahead == 'u') ADVANCE(359);
      END_STATE();
    case 245:
      if (lookahead == 'n') ADVANCE(360);
      END_STATE();
    case 246:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 247:
      if (lookahead == 'a') ADVANCE(362);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(363);
      END_STATE();
    case 251:
      if (lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 252:
      if (lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 253:
      if (lookahead == 'l') ADVANCE(366);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(367);
      END_STATE();
    case 255:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 257:
      if (lookahead == 'p') ADVANCE(369);
      END_STATE();
    case 258:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(371);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(372);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_line);
      if (lookahead == 'a') ADVANCE(373);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 263:
      if (lookahead == 'l') ADVANCE(374);
      END_STATE();
    case 264:
      if (lookahead == 'b') ADVANCE(375);
      END_STATE();
    case 265:
      if (lookahead == 's') ADVANCE(376);
      END_STATE();
    case 266:
      if (lookahead == 'c') ADVANCE(377);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(378);
      END_STATE();
    case 268:
      if (lookahead == 'r') ADVANCE(379);
      END_STATE();
    case 269:
      if (lookahead == 't') ADVANCE(380);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(381);
      END_STATE();
    case 271:
      if (lookahead == 'p') ADVANCE(382);
      END_STATE();
    case 272:
      if (lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 273:
      if (lookahead == 'a') ADVANCE(384);
      END_STATE();
    case 274:
      if (lookahead == 'q') ADVANCE(385);
      END_STATE();
    case 275:
      if (lookahead == 'r') ADVANCE(386);
      END_STATE();
    case 276:
      if (lookahead == 't') ADVANCE(387);
      END_STATE();
    case 277:
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 278:
      if (lookahead == 'a') ADVANCE(389);
      END_STATE();
    case 279:
      if (lookahead == 'e') ADVANCE(390);
      END_STATE();
    case 280:
      if (lookahead == 'i') ADVANCE(391);
      END_STATE();
    case 281:
      if (lookahead == 's') ADVANCE(392);
      END_STATE();
    case 282:
      if (lookahead == 'i') ADVANCE(393);
      END_STATE();
    case 283:
      if (lookahead == 'r') ADVANCE(394);
      END_STATE();
    case 284:
      if (lookahead == 'r') ADVANCE(395);
      END_STATE();
    case 285:
      if (lookahead == 'm') ADVANCE(396);
      END_STATE();
    case 286:
      if (lookahead == 'l') ADVANCE(397);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(398);
      END_STATE();
    case 288:
      if (lookahead == 't') ADVANCE(399);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(400);
      END_STATE();
    case 290:
      if (lookahead == 'o') ADVANCE(401);
      END_STATE();
    case 291:
      if (lookahead == 'm') ADVANCE(402);
      END_STATE();
    case 292:
      if (lookahead == 'i') ADVANCE(403);
      END_STATE();
    case 293:
      if (lookahead == 'c') ADVANCE(404);
      END_STATE();
    case 294:
      if (lookahead == 'c') ADVANCE(405);
      END_STATE();
    case 295:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 297:
      if (lookahead == 'a') ADVANCE(407);
      END_STATE();
    case 298:
      if (lookahead == 'w') ADVANCE(408);
      END_STATE();
    case 299:
      if (lookahead == 'n') ADVANCE(409);
      END_STATE();
    case 300:
      if (lookahead == 'd') ADVANCE(410);
      if (lookahead == 'n') ADVANCE(411);
      END_STATE();
    case 301:
      if (lookahead == 'o') ADVANCE(412);
      END_STATE();
    case 302:
      if (lookahead == 'n') ADVANCE(413);
      END_STATE();
    case 303:
      if (lookahead == 'm') ADVANCE(414);
      END_STATE();
    case 304:
      if (lookahead == 'g') ADVANCE(415);
      END_STATE();
    case 305:
      if (lookahead == 'g') ADVANCE(416);
      END_STATE();
    case 306:
      if (lookahead == 'u') ADVANCE(417);
      END_STATE();
    case 307:
      if (lookahead == 't') ADVANCE(418);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(419);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 310:
      if (lookahead == 'n') ADVANCE(421);
      END_STATE();
    case 311:
      if (lookahead == 'i') ADVANCE(422);
      END_STATE();
    case 312:
      if (lookahead == 'r') ADVANCE(423);
      END_STATE();
    case 313:
      if (lookahead == 'u') ADVANCE(424);
      END_STATE();
    case 314:
      if (lookahead == 't') ADVANCE(425);
      END_STATE();
    case 315:
      if (lookahead == 'g') ADVANCE(426);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym___asm);
      if (lookahead == '_') ADVANCE(427);
      END_STATE();
    case 317:
      if (lookahead == 'r') ADVANCE(428);
      END_STATE();
    case 318:
      if (lookahead == 'e') ADVANCE(429);
      END_STATE();
    case 319:
      if (lookahead == 'c') ADVANCE(430);
      END_STATE();
    case 320:
      if (lookahead == 'c') ADVANCE(431);
      END_STATE();
    case 321:
      if (lookahead == 'l') ADVANCE(432);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 324:
      if (lookahead == 't') ADVANCE(435);
      END_STATE();
    case 325:
      if (lookahead == 'a') ADVANCE(436);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(437);
      END_STATE();
    case 327:
      if (lookahead == 'i') ADVANCE(438);
      END_STATE();
    case 328:
      if (lookahead == 'v') ADVANCE(439);
      END_STATE();
    case 329:
      if (lookahead == 't') ADVANCE(440);
      END_STATE();
    case 330:
      if (lookahead == 'r') ADVANCE(441);
      END_STATE();
    case 331:
      if (lookahead == 'c') ADVANCE(442);
      END_STATE();
    case 332:
      if (lookahead == 's') ADVANCE(443);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(444);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 335:
      if (lookahead == 'l') ADVANCE(445);
      END_STATE();
    case 336:
      if (lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 337:
      if (lookahead == 't') ADVANCE(447);
      END_STATE();
    case 338:
      if (lookahead == 'a') ADVANCE(448);
      END_STATE();
    case 339:
      if (lookahead == 'n') ADVANCE(449);
      END_STATE();
    case 340:
      if (lookahead == 'i') ADVANCE(450);
      END_STATE();
    case 341:
      if (lookahead == 'a') ADVANCE(451);
      if (lookahead == 'o') ADVANCE(452);
      END_STATE();
    case 342:
      if (lookahead == 'q') ADVANCE(453);
      END_STATE();
    case 343:
      if (lookahead == 'd') ADVANCE(454);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(455);
      END_STATE();
    case 348:
      if (lookahead == 'o') ADVANCE(456);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 350:
      if (lookahead == 'a') ADVANCE(457);
      END_STATE();
    case 351:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 353:
      if (lookahead == 'n') ADVANCE(460);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 355:
      if (lookahead == 'p') ADVANCE(461);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(462);
      if (lookahead == 'i') ADVANCE(463);
      END_STATE();
    case 357:
      if (lookahead == 'n') ADVANCE(464);
      END_STATE();
    case 358:
      if (lookahead == 'y') ADVANCE(465);
      END_STATE();
    case 359:
      if (lookahead == 'l') ADVANCE(466);
      END_STATE();
    case 360:
      if (lookahead == 'e') ADVANCE(467);
      END_STATE();
    case 361:
      if (lookahead == 'e') ADVANCE(468);
      END_STATE();
    case 362:
      if (lookahead == 'r') ADVANCE(469);
      END_STATE();
    case 363:
      if (lookahead == 'c') ADVANCE(470);
      END_STATE();
    case 364:
      if (lookahead == 't') ADVANCE(471);
      END_STATE();
    case 365:
      if (lookahead == 'n') ADVANCE(472);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 367:
      if (lookahead == 'd') ADVANCE(473);
      END_STATE();
    case 368:
      if (lookahead == 'l') ADVANCE(474);
      END_STATE();
    case 369:
      if (lookahead == 's') ADVANCE(475);
      END_STATE();
    case 370:
      if (lookahead == 't') ADVANCE(476);
      END_STATE();
    case 371:
      if (lookahead == 'e') ADVANCE(477);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_inout);
      END_STATE();
    case 373:
      if (lookahead == 'd') ADVANCE(478);
      if (lookahead == 'r') ADVANCE(479);
      END_STATE();
    case 374:
      if (lookahead == 'e') ADVANCE(480);
      END_STATE();
    case 375:
      if (lookahead == 'l') ADVANCE(481);
      END_STATE();
    case 376:
      if (lookahead == 'p') ADVANCE(482);
      END_STATE();
    case 377:
      if (lookahead == 'e') ADVANCE(483);
      END_STATE();
    case 378:
      if (lookahead == 'e') ADVANCE(484);
      END_STATE();
    case 379:
      if (lookahead == 's') ADVANCE(485);
      END_STATE();
    case 380:
      if (lookahead == 'u') ADVANCE(486);
      END_STATE();
    case 381:
      if (lookahead == 'q') ADVANCE(487);
      END_STATE();
    case 382:
      if (lookahead == 't') ADVANCE(488);
      END_STATE();
    case 383:
      if (lookahead == 't') ADVANCE(489);
      END_STATE();
    case 384:
      if (lookahead == 't') ADVANCE(490);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 386:
      if (lookahead == 'i') ADVANCE(491);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_point);
      END_STATE();
    case 388:
      if (lookahead == 's') ADVANCE(492);
      END_STATE();
    case 389:
      if (lookahead == 't') ADVANCE(493);
      END_STATE();
    case 390:
      if (lookahead == 'c') ADVANCE(494);
      END_STATE();
    case 391:
      if (lookahead == 'c') ADVANCE(495);
      END_STATE();
    case 392:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 393:
      if (lookahead == 'r') ADVANCE(497);
      END_STATE();
    case 394:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 395:
      if (lookahead == 'n') ADVANCE(499);
      END_STATE();
    case 396:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 397:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 398:
      if (lookahead == 'd') ADVANCE(502);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 400:
      if (lookahead == 'd') ADVANCE(503);
      END_STATE();
    case 401:
      if (lookahead == 'f') ADVANCE(504);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_snorm);
      END_STATE();
    case 403:
      if (lookahead == 'c') ADVANCE(505);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(506);
      END_STATE();
    case 405:
      if (lookahead == 'h') ADVANCE(507);
      END_STATE();
    case 406:
      if (lookahead == 'a') ADVANCE(508);
      END_STATE();
    case 407:
      if (lookahead == 'd') ADVANCE(509);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 409:
      if (lookahead == 'g') ADVANCE(510);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(511);
      END_STATE();
    case 411:
      if (lookahead == 'a') ADVANCE(512);
      END_STATE();
    case 412:
      if (lookahead == 'r') ADVANCE(513);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_unorm);
      END_STATE();
    case 415:
      if (lookahead == 'n') ADVANCE(514);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 417:
      if (lookahead == 'a') ADVANCE(515);
      END_STATE();
    case 418:
      if (lookahead == 'i') ADVANCE(516);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 420:
      if (lookahead == 'q') ADVANCE(517);
      END_STATE();
    case 421:
      if (lookahead == 'a') ADVANCE(518);
      if (lookahead == 'o') ADVANCE(519);
      END_STATE();
    case 422:
      if (lookahead == 'c') ADVANCE(520);
      END_STATE();
    case 423:
      if (lookahead == 'i') ADVANCE(521);
      END_STATE();
    case 424:
      if (lookahead == 'l') ADVANCE(522);
      END_STATE();
    case 425:
      if (lookahead == 'u') ADVANCE(523);
      END_STATE();
    case 426:
      if (lookahead == 'n') ADVANCE(524);
      END_STATE();
    case 427:
      if (lookahead == '_') ADVANCE(525);
      END_STATE();
    case 428:
      if (lookahead == 'i') ADVANCE(526);
      END_STATE();
    case 429:
      if (lookahead == 'd') ADVANCE(527);
      END_STATE();
    case 430:
      if (lookahead == 'l') ADVANCE(528);
      END_STATE();
    case 431:
      if (lookahead == 'a') ADVANCE(529);
      END_STATE();
    case 432:
      if (lookahead == 's') ADVANCE(530);
      END_STATE();
    case 433:
      if (lookahead == 'p') ADVANCE(531);
      END_STATE();
    case 434:
      if (lookahead == 'n') ADVANCE(532);
      END_STATE();
    case 435:
      if (lookahead == 'c') ADVANCE(533);
      END_STATE();
    case 436:
      if (lookahead == 'l') ADVANCE(534);
      END_STATE();
    case 437:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 438:
      if (lookahead == 'n') ADVANCE(536);
      END_STATE();
    case 439:
      if (lookahead == 'e') ADVANCE(537);
      END_STATE();
    case 440:
      if (lookahead == 'r') ADVANCE(538);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 442:
      if (lookahead == 'a') ADVANCE(539);
      END_STATE();
    case 443:
      if (lookahead == 'c') ADVANCE(540);
      END_STATE();
    case 444:
      if (lookahead == 'a') ADVANCE(541);
      END_STATE();
    case 445:
      if (lookahead == 'i') ADVANCE(542);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 447:
      if (lookahead == 'o') ADVANCE(543);
      END_STATE();
    case 448:
      if (lookahead == 't') ADVANCE(544);
      END_STATE();
    case 449:
      if (lookahead == 'o') ADVANCE(545);
      END_STATE();
    case 450:
      if (lookahead == 'g') ADVANCE(546);
      END_STATE();
    case 451:
      if (lookahead == 's') ADVANCE(547);
      END_STATE();
    case 452:
      if (lookahead == 'f') ADVANCE(548);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 455:
      if (lookahead == 'r') ADVANCE(549);
      END_STATE();
    case 456:
      if (lookahead == 'i') ADVANCE(550);
      END_STATE();
    case 457:
      if (lookahead == 'i') ADVANCE(551);
      END_STATE();
    case 458:
      if (lookahead == 'u') ADVANCE(552);
      END_STATE();
    case 459:
      if (lookahead == 'l') ADVANCE(553);
      END_STATE();
    case 460:
      if (lookahead == '_') ADVANCE(554);
      END_STATE();
    case 461:
      if (lookahead == 't') ADVANCE(555);
      END_STATE();
    case 462:
      if (lookahead == 'v') ADVANCE(556);
      if (lookahead == 'x') ADVANCE(557);
      END_STATE();
    case 463:
      if (lookahead == 'n') ADVANCE(558);
      END_STATE();
    case 464:
      if (lookahead == 'u') ADVANCE(559);
      END_STATE();
    case 465:
      if (lookahead == 'p') ADVANCE(560);
      END_STATE();
    case 466:
      if (lookahead == 't') ADVANCE(561);
      END_STATE();
    case 467:
      if (lookahead == 'd') ADVANCE(562);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 469:
      if (lookahead == 'd') ADVANCE(563);
      END_STATE();
    case 470:
      if (lookahead == 'i') ADVANCE(564);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 474:
      if (lookahead == 'l') ADVANCE(565);
      END_STATE();
    case 475:
      if (lookahead == 'h') ADVANCE(566);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 478:
      if (lookahead == 'j') ADVANCE(567);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_linear);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 481:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 482:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 483:
      if (lookahead == 'p') ADVANCE(570);
      END_STATE();
    case 484:
      if (lookahead == 'r') ADVANCE(571);
      END_STATE();
    case 485:
      if (lookahead == 'p') ADVANCE(572);
      END_STATE();
    case 486:
      if (lookahead == 'r') ADVANCE(573);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 488:
      if (lookahead == 'r') ADVANCE(574);
      END_STATE();
    case 489:
      if (lookahead == 'o') ADVANCE(575);
      END_STATE();
    case 490:
      if (lookahead == 'o') ADVANCE(576);
      END_STATE();
    case 491:
      if (lookahead == 'd') ADVANCE(577);
      END_STATE();
    case 492:
      if (lookahead == 'e') ADVANCE(578);
      END_STATE();
    case 493:
      if (lookahead == 'e') ADVANCE(579);
      END_STATE();
    case 494:
      if (lookahead == 't') ADVANCE(580);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 496:
      if (lookahead == 'e') ADVANCE(581);
      END_STATE();
    case 497:
      if (lookahead == 'e') ADVANCE(582);
      END_STATE();
    case 498:
      if (lookahead == 'c') ADVANCE(583);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 500:
      if (lookahead == 'j') ADVANCE(584);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_sample);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(anon_sym_shared);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(585);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 508:
      if (lookahead == 't') ADVANCE(586);
      END_STATE();
    case 509:
      if (lookahead == '_') ADVANCE(587);
      END_STATE();
    case 510:
      if (lookahead == 'l') ADVANCE(588);
      END_STATE();
    case 511:
      if (lookahead == 'f') ADVANCE(589);
      END_STATE();
    case 512:
      if (lookahead == 'm') ADVANCE(590);
      END_STATE();
    case 513:
      if (lookahead == 'm') ADVANCE(591);
      END_STATE();
    case 514:
      if (lookahead == 'e') ADVANCE(592);
      END_STATE();
    case 515:
      if (lookahead == 'l') ADVANCE(593);
      END_STATE();
    case 516:
      if (lookahead == 'l') ADVANCE(594);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 518:
      if (lookahead == 's') ADVANCE(595);
      END_STATE();
    case 519:
      if (lookahead == 'f') ADVANCE(596);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 521:
      if (lookahead == 'c') ADVANCE(597);
      END_STATE();
    case 522:
      if (lookahead == 'l') ADVANCE(598);
      END_STATE();
    case 523:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 524:
      if (lookahead == 'o') ADVANCE(600);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 526:
      if (lookahead == 'b') ADVANCE(601);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 529:
      if (lookahead == 'l') ADVANCE(602);
      END_STATE();
    case 530:
      if (lookahead == 'p') ADVANCE(603);
      END_STATE();
    case 531:
      if (lookahead == 't') ADVANCE(604);
      END_STATE();
    case 532:
      if (lookahead == 's') ADVANCE(605);
      END_STATE();
    case 533:
      if (lookahead == 'a') ADVANCE(606);
      END_STATE();
    case 534:
      if (lookahead == 'l') ADVANCE(607);
      END_STATE();
    case 535:
      if (lookahead == 'i') ADVANCE(608);
      END_STATE();
    case 536:
      if (lookahead == 'e') ADVANCE(609);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 538:
      if (lookahead == 'i') ADVANCE(610);
      END_STATE();
    case 539:
      if (lookahead == 'l') ADVANCE(611);
      END_STATE();
    case 540:
      if (lookahead == 'a') ADVANCE(612);
      END_STATE();
    case 541:
      if (lookahead == 'd') ADVANCE(613);
      END_STATE();
    case 542:
      if (lookahead == 'g') ADVANCE(614);
      END_STATE();
    case 543:
      if (lookahead == 'r') ADVANCE(615);
      END_STATE();
    case 544:
      if (lookahead == 'i') ADVANCE(616);
      END_STATE();
    case 545:
      if (lookahead == 'f') ADVANCE(617);
      END_STATE();
    case 546:
      if (lookahead == 'n') ADVANCE(618);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_cbuffer);
      END_STATE();
    case 550:
      if (lookahead == 'd') ADVANCE(619);
      END_STATE();
    case 551:
      if (lookahead == 't') ADVANCE(620);
      END_STATE();
    case 552:
      if (lookahead == 'r') ADVANCE(621);
      END_STATE();
    case 553:
      if (lookahead == 'd') ADVANCE(622);
      END_STATE();
    case 554:
      if (lookahead == 'm') ADVANCE(623);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 556:
      if (lookahead == 'a') ADVANCE(624);
      END_STATE();
    case 557:
      if (lookahead == 'p') ADVANCE(625);
      END_STATE();
    case 558:
      if (lookahead == 'i') ADVANCE(626);
      END_STATE();
    case 559:
      if (lookahead == 'e') ADVANCE(627);
      END_STATE();
    case 560:
      if (lookahead == 'e') ADVANCE(628);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_discard);
      END_STATE();
    case 564:
      if (lookahead == 't') ADVANCE(629);
      END_STATE();
    case 565:
      if (lookahead == 'y') ADVANCE(630);
      END_STATE();
    case 566:
      if (lookahead == 'a') ADVANCE(631);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_lineadj);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 569:
      if (lookahead == 'c') ADVANCE(632);
      END_STATE();
    case 570:
      if (lookahead == 't') ADVANCE(633);
      END_STATE();
    case 571:
      if (lookahead == 'p') ADVANCE(634);
      END_STATE();
    case 572:
      if (lookahead == 'e') ADVANCE(635);
      END_STATE();
    case 573:
      if (lookahead == 'n') ADVANCE(636);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 575:
      if (lookahead == 'f') ADVANCE(637);
      END_STATE();
    case 576:
      if (lookahead == 'r') ADVANCE(638);
      END_STATE();
    case 577:
      if (lookahead == 'e') ADVANCE(639);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_precise);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 580:
      if (lookahead == 'e') ADVANCE(640);
      END_STATE();
    case 581:
      if (lookahead == 'r') ADVANCE(641);
      END_STATE();
    case 582:
      if (lookahead == 's') ADVANCE(642);
      END_STATE();
    case 583:
      if (lookahead == 't') ADVANCE(643);
      END_STATE();
    case 584:
      if (lookahead == 'o') ADVANCE(644);
      END_STATE();
    case 585:
      if (lookahead == 'a') ADVANCE(645);
      END_STATE();
    case 586:
      if (lookahead == 'e') ADVANCE(646);
      END_STATE();
    case 587:
      if (lookahead == 'l') ADVANCE(647);
      END_STATE();
    case 588:
      if (lookahead == 'e') ADVANCE(648);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 590:
      if (lookahead == 'e') ADVANCE(649);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_uniform);
      END_STATE();
    case 592:
      if (lookahead == 'd') ADVANCE(650);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 594:
      if (lookahead == 'e') ADVANCE(651);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym__Nonnull);
      END_STATE();
    case 599:
      if (lookahead == 'n') ADVANCE(652);
      END_STATE();
    case 600:
      if (lookahead == 'f') ADVANCE(653);
      END_STATE();
    case 601:
      if (lookahead == 'u') ADVANCE(654);
      END_STATE();
    case 602:
      if (lookahead == 'l') ADVANCE(655);
      END_STATE();
    case 603:
      if (lookahead == 'e') ADVANCE(656);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 605:
      if (lookahead == 'i') ADVANCE(657);
      END_STATE();
    case 606:
      if (lookahead == 'l') ADVANCE(658);
      END_STATE();
    case 607:
      if (lookahead == 'y') ADVANCE(659);
      END_STATE();
    case 608:
      if (lookahead == 'n') ADVANCE(660);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(661);
      END_STATE();
    case 610:
      if (lookahead == 'c') ADVANCE(662);
      END_STATE();
    case 611:
      if (lookahead == 'l') ADVANCE(663);
      END_STATE();
    case 612:
      if (lookahead == 'l') ADVANCE(664);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 614:
      if (lookahead == 'n') ADVANCE(665);
      END_STATE();
    case 615:
      if (lookahead == 'c') ADVANCE(666);
      END_STATE();
    case 616:
      if (lookahead == 'l') ADVANCE(667);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 618:
      if (lookahead == 'e') ADVANCE(668);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_centroid);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 621:
      if (lookahead == 'n') ADVANCE(669);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 623:
      if (lookahead == 'a') ADVANCE(670);
      END_STATE();
    case 624:
      if (lookahead == 'l') ADVANCE(671);
      END_STATE();
    case 625:
      if (lookahead == 'r') ADVANCE(672);
      END_STATE();
    case 626:
      if (lookahead == 't') ADVANCE(673);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 630:
      if (lookahead == 'c') ADVANCE(674);
      END_STATE();
    case 631:
      if (lookahead == 'r') ADVANCE(675);
      END_STATE();
    case 632:
      if (lookahead == 'e') ADVANCE(676);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 634:
      if (lookahead == 'o') ADVANCE(677);
      END_STATE();
    case 635:
      if (lookahead == 'c') ADVANCE(678);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 640:
      if (lookahead == 'd') ADVANCE(679);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 644:
      if (lookahead == 'r') ADVANCE(680);
      END_STATE();
    case 645:
      if (lookahead == 's') ADVANCE(681);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 647:
      if (lookahead == 'o') ADVANCE(682);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_triangle);
      if (lookahead == 'a') ADVANCE(683);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(684);
      END_STATE();
    case 654:
      if (lookahead == 't') ADVANCE(685);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 656:
      if (lookahead == 'c') ADVANCE(686);
      END_STATE();
    case 657:
      if (lookahead == 'o') ADVANCE(687);
      END_STATE();
    case 658:
      if (lookahead == 'l') ADVANCE(688);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 660:
      if (lookahead == 'l') ADVANCE(689);
      END_STATE();
    case 661:
      if (lookahead == '_') ADVANCE(690);
      END_STATE();
    case 662:
      if (lookahead == 't') ADVANCE(691);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 664:
      if (lookahead == 'l') ADVANCE(692);
      END_STATE();
    case 665:
      if (lookahead == 'e') ADVANCE(693);
      END_STATE();
    case 666:
      if (lookahead == 'a') ADVANCE(694);
      END_STATE();
    case 667:
      if (lookahead == 'e') ADVANCE(695);
      END_STATE();
    case 668:
      if (lookahead == 'd') ADVANCE(696);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 670:
      if (lookahead == 'j') ADVANCE(697);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 674:
      if (lookahead == 'o') ADVANCE(698);
      END_STATE();
    case 675:
      if (lookahead == 'e') ADVANCE(699);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 677:
      if (lookahead == 'l') ADVANCE(700);
      END_STATE();
    case 678:
      if (lookahead == 't') ADVANCE(701);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(anon_sym_row_major);
      END_STATE();
    case 681:
      if (lookahead == 's') ADVANCE(702);
      END_STATE();
    case 682:
      if (lookahead == 'c') ADVANCE(703);
      END_STATE();
    case 683:
      if (lookahead == 'd') ADVANCE(704);
      END_STATE();
    case 684:
      if (lookahead == '_') ADVANCE(705);
      END_STATE();
    case 685:
      if (lookahead == 'e') ADVANCE(706);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 687:
      if (lookahead == 'n') ADVANCE(707);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 689:
      if (lookahead == 'i') ADVANCE(708);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(709);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 693:
      if (lookahead == 'd') ADVANCE(710);
      END_STATE();
    case 694:
      if (lookahead == 'l') ADVANCE(711);
      END_STATE();
    case 695:
      if (lookahead == '_') ADVANCE(712);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 697:
      if (lookahead == 'o') ADVANCE(713);
      END_STATE();
    case 698:
      if (lookahead == 'h') ADVANCE(714);
      END_STATE();
    case 699:
      if (lookahead == 'd') ADVANCE(715);
      END_STATE();
    case 700:
      if (lookahead == 'a') ADVANCE(716);
      END_STATE();
    case 701:
      if (lookahead == 'i') ADVANCE(717);
      END_STATE();
    case 702:
      if (lookahead == 'e') ADVANCE(718);
      END_STATE();
    case 703:
      if (lookahead == 'a') ADVANCE(719);
      END_STATE();
    case 704:
      if (lookahead == 'j') ADVANCE(720);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(anon_sym___attribute);
      if (lookahead == '_') ADVANCE(721);
      END_STATE();
    case 707:
      if (lookahead == '_') ADVANCE(722);
      END_STATE();
    case 708:
      if (lookahead == 'n') ADVANCE(723);
      END_STATE();
    case 709:
      if (lookahead == '_') ADVANCE(724);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 711:
      if (lookahead == 'l') ADVANCE(725);
      END_STATE();
    case 712:
      if (lookahead == '_') ADVANCE(726);
      END_STATE();
    case 713:
      if (lookahead == 'r') ADVANCE(727);
      END_STATE();
    case 714:
      if (lookahead == 'e') ADVANCE(728);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(anon_sym_groupshared);
      END_STATE();
    case 716:
      if (lookahead == 't') ADVANCE(729);
      END_STATE();
    case 717:
      if (lookahead == 'v') ADVANCE(730);
      END_STATE();
    case 718:
      if (lookahead == 'r') ADVANCE(731);
      END_STATE();
    case 719:
      if (lookahead == 'l') ADVANCE(732);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(anon_sym_triangleadj);
      END_STATE();
    case 721:
      if (lookahead == '_') ADVANCE(733);
      END_STATE();
    case 722:
      if (lookahead == '_') ADVANCE(734);
      END_STATE();
    case 723:
      if (lookahead == 'e') ADVANCE(735);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(anon_sym___volatile__);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(anon_sym_column_major);
      END_STATE();
    case 728:
      if (lookahead == 'r') ADVANCE(736);
      END_STATE();
    case 729:
      if (lookahead == 'i') ADVANCE(737);
      END_STATE();
    case 730:
      if (lookahead == 'e') ADVANCE(738);
      END_STATE();
    case 731:
      if (lookahead == 't') ADVANCE(739);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 736:
      if (lookahead == 'e') ADVANCE(740);
      END_STATE();
    case 737:
      if (lookahead == 'o') ADVANCE(741);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(anon_sym_noperspective);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    case 740:
      if (lookahead == 'n') ADVANCE(742);
      END_STATE();
    case 741:
      if (lookahead == 'n') ADVANCE(743);
      END_STATE();
    case 742:
      if (lookahead == 't') ADVANCE(744);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(anon_sym_nointerpolation);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(anon_sym_globallycoherent);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 342},
  [2] = {.lex_state = 342},
  [3] = {.lex_state = 342},
  [4] = {.lex_state = 342},
  [5] = {.lex_state = 342},
  [6] = {.lex_state = 342},
  [7] = {.lex_state = 342},
  [8] = {.lex_state = 342},
  [9] = {.lex_state = 342},
  [10] = {.lex_state = 342},
  [11] = {.lex_state = 342},
  [12] = {.lex_state = 342},
  [13] = {.lex_state = 173},
  [14] = {.lex_state = 173},
  [15] = {.lex_state = 173},
  [16] = {.lex_state = 173},
  [17] = {.lex_state = 173},
  [18] = {.lex_state = 173},
  [19] = {.lex_state = 173},
  [20] = {.lex_state = 173},
  [21] = {.lex_state = 173},
  [22] = {.lex_state = 173},
  [23] = {.lex_state = 173},
  [24] = {.lex_state = 173},
  [25] = {.lex_state = 173},
  [26] = {.lex_state = 173},
  [27] = {.lex_state = 173},
  [28] = {.lex_state = 173},
  [29] = {.lex_state = 173},
  [30] = {.lex_state = 173},
  [31] = {.lex_state = 173},
  [32] = {.lex_state = 173},
  [33] = {.lex_state = 173},
  [34] = {.lex_state = 342},
  [35] = {.lex_state = 342},
  [36] = {.lex_state = 176},
  [37] = {.lex_state = 342},
  [38] = {.lex_state = 342},
  [39] = {.lex_state = 342},
  [40] = {.lex_state = 176},
  [41] = {.lex_state = 342},
  [42] = {.lex_state = 342},
  [43] = {.lex_state = 342},
  [44] = {.lex_state = 342},
  [45] = {.lex_state = 342},
  [46] = {.lex_state = 342},
  [47] = {.lex_state = 342},
  [48] = {.lex_state = 342},
  [49] = {.lex_state = 342},
  [50] = {.lex_state = 342},
  [51] = {.lex_state = 342},
  [52] = {.lex_state = 342},
  [53] = {.lex_state = 176},
  [54] = {.lex_state = 342},
  [55] = {.lex_state = 342},
  [56] = {.lex_state = 342},
  [57] = {.lex_state = 342},
  [58] = {.lex_state = 342},
  [59] = {.lex_state = 342},
  [60] = {.lex_state = 342},
  [61] = {.lex_state = 342},
  [62] = {.lex_state = 342},
  [63] = {.lex_state = 342},
  [64] = {.lex_state = 342},
  [65] = {.lex_state = 342},
  [66] = {.lex_state = 342},
  [67] = {.lex_state = 342},
  [68] = {.lex_state = 342},
  [69] = {.lex_state = 342},
  [70] = {.lex_state = 342},
  [71] = {.lex_state = 342},
  [72] = {.lex_state = 342},
  [73] = {.lex_state = 342},
  [74] = {.lex_state = 342},
  [75] = {.lex_state = 342},
  [76] = {.lex_state = 342},
  [77] = {.lex_state = 342},
  [78] = {.lex_state = 342},
  [79] = {.lex_state = 342},
  [80] = {.lex_state = 342},
  [81] = {.lex_state = 342},
  [82] = {.lex_state = 342},
  [83] = {.lex_state = 342},
  [84] = {.lex_state = 342},
  [85] = {.lex_state = 173},
  [86] = {.lex_state = 173},
  [87] = {.lex_state = 173},
  [88] = {.lex_state = 173},
  [89] = {.lex_state = 173},
  [90] = {.lex_state = 342},
  [91] = {.lex_state = 342},
  [92] = {.lex_state = 342},
  [93] = {.lex_state = 342},
  [94] = {.lex_state = 342},
  [95] = {.lex_state = 176},
  [96] = {.lex_state = 342},
  [97] = {.lex_state = 176},
  [98] = {.lex_state = 342},
  [99] = {.lex_state = 342},
  [100] = {.lex_state = 342},
  [101] = {.lex_state = 342},
  [102] = {.lex_state = 176},
  [103] = {.lex_state = 176},
  [104] = {.lex_state = 176},
  [105] = {.lex_state = 175},
  [106] = {.lex_state = 175},
  [107] = {.lex_state = 175},
  [108] = {.lex_state = 175},
  [109] = {.lex_state = 175},
  [110] = {.lex_state = 175},
  [111] = {.lex_state = 175},
  [112] = {.lex_state = 175},
  [113] = {.lex_state = 175},
  [114] = {.lex_state = 175},
  [115] = {.lex_state = 175},
  [116] = {.lex_state = 175},
  [117] = {.lex_state = 175},
  [118] = {.lex_state = 175},
  [119] = {.lex_state = 175},
  [120] = {.lex_state = 175},
  [121] = {.lex_state = 175},
  [122] = {.lex_state = 175},
  [123] = {.lex_state = 175},
  [124] = {.lex_state = 175},
  [125] = {.lex_state = 175},
  [126] = {.lex_state = 175},
  [127] = {.lex_state = 175},
  [128] = {.lex_state = 175},
  [129] = {.lex_state = 175},
  [130] = {.lex_state = 175},
  [131] = {.lex_state = 175},
  [132] = {.lex_state = 175},
  [133] = {.lex_state = 175},
  [134] = {.lex_state = 175},
  [135] = {.lex_state = 175},
  [136] = {.lex_state = 175},
  [137] = {.lex_state = 175},
  [138] = {.lex_state = 342},
  [139] = {.lex_state = 342},
  [140] = {.lex_state = 342},
  [141] = {.lex_state = 173},
  [142] = {.lex_state = 173},
  [143] = {.lex_state = 342},
  [144] = {.lex_state = 342},
  [145] = {.lex_state = 342},
  [146] = {.lex_state = 342},
  [147] = {.lex_state = 342},
  [148] = {.lex_state = 342},
  [149] = {.lex_state = 342},
  [150] = {.lex_state = 342},
  [151] = {.lex_state = 173},
  [152] = {.lex_state = 173},
  [153] = {.lex_state = 342},
  [154] = {.lex_state = 342},
  [155] = {.lex_state = 173},
  [156] = {.lex_state = 173},
  [157] = {.lex_state = 173},
  [158] = {.lex_state = 173},
  [159] = {.lex_state = 173},
  [160] = {.lex_state = 173},
  [161] = {.lex_state = 173},
  [162] = {.lex_state = 173},
  [163] = {.lex_state = 173},
  [164] = {.lex_state = 173},
  [165] = {.lex_state = 173},
  [166] = {.lex_state = 173},
  [167] = {.lex_state = 173},
  [168] = {.lex_state = 173},
  [169] = {.lex_state = 173},
  [170] = {.lex_state = 177},
  [171] = {.lex_state = 342},
  [172] = {.lex_state = 342},
  [173] = {.lex_state = 342},
  [174] = {.lex_state = 342},
  [175] = {.lex_state = 342},
  [176] = {.lex_state = 342},
  [177] = {.lex_state = 342},
  [178] = {.lex_state = 342},
  [179] = {.lex_state = 342},
  [180] = {.lex_state = 342},
  [181] = {.lex_state = 342},
  [182] = {.lex_state = 342},
  [183] = {.lex_state = 177},
  [184] = {.lex_state = 176},
  [185] = {.lex_state = 342},
  [186] = {.lex_state = 177},
  [187] = {.lex_state = 342},
  [188] = {.lex_state = 176},
  [189] = {.lex_state = 342},
  [190] = {.lex_state = 173},
  [191] = {.lex_state = 342},
  [192] = {.lex_state = 173},
  [193] = {.lex_state = 342},
  [194] = {.lex_state = 173},
  [195] = {.lex_state = 173},
  [196] = {.lex_state = 173},
  [197] = {.lex_state = 173},
  [198] = {.lex_state = 342},
  [199] = {.lex_state = 173},
  [200] = {.lex_state = 176},
  [201] = {.lex_state = 176},
  [202] = {.lex_state = 342},
  [203] = {.lex_state = 173},
  [204] = {.lex_state = 173},
  [205] = {.lex_state = 173},
  [206] = {.lex_state = 173},
  [207] = {.lex_state = 173},
  [208] = {.lex_state = 173},
  [209] = {.lex_state = 173},
  [210] = {.lex_state = 342},
  [211] = {.lex_state = 173},
  [212] = {.lex_state = 173},
  [213] = {.lex_state = 173},
  [214] = {.lex_state = 173},
  [215] = {.lex_state = 173},
  [216] = {.lex_state = 173},
  [217] = {.lex_state = 173},
  [218] = {.lex_state = 173},
  [219] = {.lex_state = 173},
  [220] = {.lex_state = 173},
  [221] = {.lex_state = 173},
  [222] = {.lex_state = 173},
  [223] = {.lex_state = 173},
  [224] = {.lex_state = 173},
  [225] = {.lex_state = 173},
  [226] = {.lex_state = 173},
  [227] = {.lex_state = 173},
  [228] = {.lex_state = 173},
  [229] = {.lex_state = 173},
  [230] = {.lex_state = 342},
  [231] = {.lex_state = 173},
  [232] = {.lex_state = 342},
  [233] = {.lex_state = 342},
  [234] = {.lex_state = 342},
  [235] = {.lex_state = 173},
  [236] = {.lex_state = 173},
  [237] = {.lex_state = 173},
  [238] = {.lex_state = 173},
  [239] = {.lex_state = 173},
  [240] = {.lex_state = 173},
  [241] = {.lex_state = 173},
  [242] = {.lex_state = 173},
  [243] = {.lex_state = 173},
  [244] = {.lex_state = 173},
  [245] = {.lex_state = 173},
  [246] = {.lex_state = 173},
  [247] = {.lex_state = 173},
  [248] = {.lex_state = 173},
  [249] = {.lex_state = 173},
  [250] = {.lex_state = 173},
  [251] = {.lex_state = 173},
  [252] = {.lex_state = 173},
  [253] = {.lex_state = 173},
  [254] = {.lex_state = 173},
  [255] = {.lex_state = 173},
  [256] = {.lex_state = 173},
  [257] = {.lex_state = 173},
  [258] = {.lex_state = 173},
  [259] = {.lex_state = 173},
  [260] = {.lex_state = 342},
  [261] = {.lex_state = 173},
  [262] = {.lex_state = 173},
  [263] = {.lex_state = 342},
  [264] = {.lex_state = 342},
  [265] = {.lex_state = 176},
  [266] = {.lex_state = 173},
  [267] = {.lex_state = 342},
  [268] = {.lex_state = 342},
  [269] = {.lex_state = 342},
  [270] = {.lex_state = 342},
  [271] = {.lex_state = 342},
  [272] = {.lex_state = 342},
  [273] = {.lex_state = 176},
  [274] = {.lex_state = 173},
  [275] = {.lex_state = 173},
  [276] = {.lex_state = 173},
  [277] = {.lex_state = 342},
  [278] = {.lex_state = 342},
  [279] = {.lex_state = 342},
  [280] = {.lex_state = 176},
  [281] = {.lex_state = 173},
  [282] = {.lex_state = 173},
  [283] = {.lex_state = 173},
  [284] = {.lex_state = 173},
  [285] = {.lex_state = 342},
  [286] = {.lex_state = 342},
  [287] = {.lex_state = 342},
  [288] = {.lex_state = 342},
  [289] = {.lex_state = 342},
  [290] = {.lex_state = 342},
  [291] = {.lex_state = 342},
  [292] = {.lex_state = 342},
  [293] = {.lex_state = 173},
  [294] = {.lex_state = 342},
  [295] = {.lex_state = 173},
  [296] = {.lex_state = 342},
  [297] = {.lex_state = 342},
  [298] = {.lex_state = 173},
  [299] = {.lex_state = 342},
  [300] = {.lex_state = 342},
  [301] = {.lex_state = 342},
  [302] = {.lex_state = 342},
  [303] = {.lex_state = 342},
  [304] = {.lex_state = 342},
  [305] = {.lex_state = 342},
  [306] = {.lex_state = 342},
  [307] = {.lex_state = 342},
  [308] = {.lex_state = 342},
  [309] = {.lex_state = 342},
  [310] = {.lex_state = 342},
  [311] = {.lex_state = 342},
  [312] = {.lex_state = 342},
  [313] = {.lex_state = 342},
  [314] = {.lex_state = 173},
  [315] = {.lex_state = 342},
  [316] = {.lex_state = 176},
  [317] = {.lex_state = 176},
  [318] = {.lex_state = 176},
  [319] = {.lex_state = 176},
  [320] = {.lex_state = 176},
  [321] = {.lex_state = 173},
  [322] = {.lex_state = 342},
  [323] = {.lex_state = 342},
  [324] = {.lex_state = 342},
  [325] = {.lex_state = 342},
  [326] = {.lex_state = 342},
  [327] = {.lex_state = 342},
  [328] = {.lex_state = 342},
  [329] = {.lex_state = 342},
  [330] = {.lex_state = 342},
  [331] = {.lex_state = 342},
  [332] = {.lex_state = 342},
  [333] = {.lex_state = 176},
  [334] = {.lex_state = 176},
  [335] = {.lex_state = 176},
  [336] = {.lex_state = 176},
  [337] = {.lex_state = 176},
  [338] = {.lex_state = 176},
  [339] = {.lex_state = 176},
  [340] = {.lex_state = 342},
  [341] = {.lex_state = 173},
  [342] = {.lex_state = 342},
  [343] = {.lex_state = 342},
  [344] = {.lex_state = 173},
  [345] = {.lex_state = 173},
  [346] = {.lex_state = 342},
  [347] = {.lex_state = 173},
  [348] = {.lex_state = 342},
  [349] = {.lex_state = 173},
  [350] = {.lex_state = 173},
  [351] = {.lex_state = 173},
  [352] = {.lex_state = 173},
  [353] = {.lex_state = 173},
  [354] = {.lex_state = 173},
  [355] = {.lex_state = 173},
  [356] = {.lex_state = 173},
  [357] = {.lex_state = 173},
  [358] = {.lex_state = 173},
  [359] = {.lex_state = 173},
  [360] = {.lex_state = 173},
  [361] = {.lex_state = 173},
  [362] = {.lex_state = 173},
  [363] = {.lex_state = 173},
  [364] = {.lex_state = 173},
  [365] = {.lex_state = 173},
  [366] = {.lex_state = 173},
  [367] = {.lex_state = 173},
  [368] = {.lex_state = 342},
  [369] = {.lex_state = 342},
  [370] = {.lex_state = 173},
  [371] = {.lex_state = 342},
  [372] = {.lex_state = 173},
  [373] = {.lex_state = 342},
  [374] = {.lex_state = 173},
  [375] = {.lex_state = 342},
  [376] = {.lex_state = 173},
  [377] = {.lex_state = 173},
  [378] = {.lex_state = 173},
  [379] = {.lex_state = 173},
  [380] = {.lex_state = 173},
  [381] = {.lex_state = 173},
  [382] = {.lex_state = 173},
  [383] = {.lex_state = 173},
  [384] = {.lex_state = 173},
  [385] = {.lex_state = 173},
  [386] = {.lex_state = 173},
  [387] = {.lex_state = 173},
  [388] = {.lex_state = 173},
  [389] = {.lex_state = 173},
  [390] = {.lex_state = 173},
  [391] = {.lex_state = 173},
  [392] = {.lex_state = 173},
  [393] = {.lex_state = 173},
  [394] = {.lex_state = 173},
  [395] = {.lex_state = 173},
  [396] = {.lex_state = 173},
  [397] = {.lex_state = 173},
  [398] = {.lex_state = 173},
  [399] = {.lex_state = 173},
  [400] = {.lex_state = 173},
  [401] = {.lex_state = 173},
  [402] = {.lex_state = 173},
  [403] = {.lex_state = 173},
  [404] = {.lex_state = 173},
  [405] = {.lex_state = 173},
  [406] = {.lex_state = 173},
  [407] = {.lex_state = 173},
  [408] = {.lex_state = 173},
  [409] = {.lex_state = 173},
  [410] = {.lex_state = 173},
  [411] = {.lex_state = 342},
  [412] = {.lex_state = 173},
  [413] = {.lex_state = 342},
  [414] = {.lex_state = 173},
  [415] = {.lex_state = 173},
  [416] = {.lex_state = 173},
  [417] = {.lex_state = 173},
  [418] = {.lex_state = 173},
  [419] = {.lex_state = 342},
  [420] = {.lex_state = 176},
  [421] = {.lex_state = 242},
  [422] = {.lex_state = 242},
  [423] = {.lex_state = 242},
  [424] = {.lex_state = 242},
  [425] = {.lex_state = 242},
  [426] = {.lex_state = 242},
  [427] = {.lex_state = 242},
  [428] = {.lex_state = 242},
  [429] = {.lex_state = 242},
  [430] = {.lex_state = 176},
  [431] = {.lex_state = 242},
  [432] = {.lex_state = 342},
  [433] = {.lex_state = 242},
  [434] = {.lex_state = 242},
  [435] = {.lex_state = 242},
  [436] = {.lex_state = 242},
  [437] = {.lex_state = 242},
  [438] = {.lex_state = 242},
  [439] = {.lex_state = 342},
  [440] = {.lex_state = 342},
  [441] = {.lex_state = 176},
  [442] = {.lex_state = 342},
  [443] = {.lex_state = 176},
  [444] = {.lex_state = 176},
  [445] = {.lex_state = 175},
  [446] = {.lex_state = 342},
  [447] = {.lex_state = 342},
  [448] = {.lex_state = 342},
  [449] = {.lex_state = 175},
  [450] = {.lex_state = 342},
  [451] = {.lex_state = 176},
  [452] = {.lex_state = 342},
  [453] = {.lex_state = 175},
  [454] = {.lex_state = 176},
  [455] = {.lex_state = 176},
  [456] = {.lex_state = 342},
  [457] = {.lex_state = 176},
  [458] = {.lex_state = 342},
  [459] = {.lex_state = 342},
  [460] = {.lex_state = 175},
  [461] = {.lex_state = 342},
  [462] = {.lex_state = 342},
  [463] = {.lex_state = 342},
  [464] = {.lex_state = 342},
  [465] = {.lex_state = 342},
  [466] = {.lex_state = 342},
  [467] = {.lex_state = 342},
  [468] = {.lex_state = 342},
  [469] = {.lex_state = 342},
  [470] = {.lex_state = 342},
  [471] = {.lex_state = 342},
  [472] = {.lex_state = 342},
  [473] = {.lex_state = 342},
  [474] = {.lex_state = 342},
  [475] = {.lex_state = 342},
  [476] = {.lex_state = 342},
  [477] = {.lex_state = 176},
  [478] = {.lex_state = 342},
  [479] = {.lex_state = 176},
  [480] = {.lex_state = 176},
  [481] = {.lex_state = 176},
  [482] = {.lex_state = 176},
  [483] = {.lex_state = 175},
  [484] = {.lex_state = 176},
  [485] = {.lex_state = 176},
  [486] = {.lex_state = 176},
  [487] = {.lex_state = 176},
  [488] = {.lex_state = 342},
  [489] = {.lex_state = 342},
  [490] = {.lex_state = 176},
  [491] = {.lex_state = 342},
  [492] = {.lex_state = 176},
  [493] = {.lex_state = 176},
  [494] = {.lex_state = 176},
  [495] = {.lex_state = 176},
  [496] = {.lex_state = 176},
  [497] = {.lex_state = 176},
  [498] = {.lex_state = 176},
  [499] = {.lex_state = 176},
  [500] = {.lex_state = 176},
  [501] = {.lex_state = 176},
  [502] = {.lex_state = 176},
  [503] = {.lex_state = 342},
  [504] = {.lex_state = 176},
  [505] = {.lex_state = 176},
  [506] = {.lex_state = 176},
  [507] = {.lex_state = 176},
  [508] = {.lex_state = 342},
  [509] = {.lex_state = 176},
  [510] = {.lex_state = 176},
  [511] = {.lex_state = 176},
  [512] = {.lex_state = 176},
  [513] = {.lex_state = 176},
  [514] = {.lex_state = 342},
  [515] = {.lex_state = 342},
  [516] = {.lex_state = 176},
  [517] = {.lex_state = 176},
  [518] = {.lex_state = 176},
  [519] = {.lex_state = 176},
  [520] = {.lex_state = 342},
  [521] = {.lex_state = 176},
  [522] = {.lex_state = 176},
  [523] = {.lex_state = 176},
  [524] = {.lex_state = 342},
  [525] = {.lex_state = 342},
  [526] = {.lex_state = 176},
  [527] = {.lex_state = 176},
  [528] = {.lex_state = 342},
  [529] = {.lex_state = 342},
  [530] = {.lex_state = 176},
  [531] = {.lex_state = 176},
  [532] = {.lex_state = 176},
  [533] = {.lex_state = 176},
  [534] = {.lex_state = 176},
  [535] = {.lex_state = 342},
  [536] = {.lex_state = 176},
  [537] = {.lex_state = 176},
  [538] = {.lex_state = 342},
  [539] = {.lex_state = 342},
  [540] = {.lex_state = 176},
  [541] = {.lex_state = 176},
  [542] = {.lex_state = 176},
  [543] = {.lex_state = 176},
  [544] = {.lex_state = 342},
  [545] = {.lex_state = 342},
  [546] = {.lex_state = 176},
  [547] = {.lex_state = 176},
  [548] = {.lex_state = 342},
  [549] = {.lex_state = 342},
  [550] = {.lex_state = 342},
  [551] = {.lex_state = 342},
  [552] = {.lex_state = 342},
  [553] = {.lex_state = 342},
  [554] = {.lex_state = 342},
  [555] = {.lex_state = 342},
  [556] = {.lex_state = 342},
  [557] = {.lex_state = 342},
  [558] = {.lex_state = 342},
  [559] = {.lex_state = 342},
  [560] = {.lex_state = 342},
  [561] = {.lex_state = 342},
  [562] = {.lex_state = 342},
  [563] = {.lex_state = 342},
  [564] = {.lex_state = 175},
  [565] = {.lex_state = 342},
  [566] = {.lex_state = 342},
  [567] = {.lex_state = 342},
  [568] = {.lex_state = 342},
  [569] = {.lex_state = 342},
  [570] = {.lex_state = 175},
  [571] = {.lex_state = 175},
  [572] = {.lex_state = 175},
  [573] = {.lex_state = 176},
  [574] = {.lex_state = 176},
  [575] = {.lex_state = 342},
  [576] = {.lex_state = 342},
  [577] = {.lex_state = 176},
  [578] = {.lex_state = 342},
  [579] = {.lex_state = 176},
  [580] = {.lex_state = 176},
  [581] = {.lex_state = 176},
  [582] = {.lex_state = 342},
  [583] = {.lex_state = 176},
  [584] = {.lex_state = 176},
  [585] = {.lex_state = 176},
  [586] = {.lex_state = 176},
  [587] = {.lex_state = 176},
  [588] = {.lex_state = 342},
  [589] = {.lex_state = 176},
  [590] = {.lex_state = 176},
  [591] = {.lex_state = 176},
  [592] = {.lex_state = 176},
  [593] = {.lex_state = 176},
  [594] = {.lex_state = 342},
  [595] = {.lex_state = 342},
  [596] = {.lex_state = 342},
  [597] = {.lex_state = 176},
  [598] = {.lex_state = 342},
  [599] = {.lex_state = 342},
  [600] = {.lex_state = 342},
  [601] = {.lex_state = 176},
  [602] = {.lex_state = 176},
  [603] = {.lex_state = 342},
  [604] = {.lex_state = 342},
  [605] = {.lex_state = 176},
  [606] = {.lex_state = 175},
  [607] = {.lex_state = 342},
  [608] = {.lex_state = 342},
  [609] = {.lex_state = 176},
  [610] = {.lex_state = 176},
  [611] = {.lex_state = 176},
  [612] = {.lex_state = 176},
  [613] = {.lex_state = 242},
  [614] = {.lex_state = 176},
  [615] = {.lex_state = 176},
  [616] = {.lex_state = 342},
  [617] = {.lex_state = 176},
  [618] = {.lex_state = 342},
  [619] = {.lex_state = 342},
  [620] = {.lex_state = 342},
  [621] = {.lex_state = 176},
  [622] = {.lex_state = 342},
  [623] = {.lex_state = 342},
  [624] = {.lex_state = 176},
  [625] = {.lex_state = 176},
  [626] = {.lex_state = 176},
  [627] = {.lex_state = 176},
  [628] = {.lex_state = 176},
  [629] = {.lex_state = 176},
  [630] = {.lex_state = 176},
  [631] = {.lex_state = 176},
  [632] = {.lex_state = 342},
  [633] = {.lex_state = 342},
  [634] = {.lex_state = 342},
  [635] = {.lex_state = 342},
  [636] = {.lex_state = 176},
  [637] = {.lex_state = 342},
  [638] = {.lex_state = 342},
  [639] = {.lex_state = 176},
  [640] = {.lex_state = 342},
  [641] = {.lex_state = 342},
  [642] = {.lex_state = 176},
  [643] = {.lex_state = 176},
  [644] = {.lex_state = 176},
  [645] = {.lex_state = 342},
  [646] = {.lex_state = 176},
  [647] = {.lex_state = 176},
  [648] = {.lex_state = 176},
  [649] = {.lex_state = 342},
  [650] = {.lex_state = 342},
  [651] = {.lex_state = 176},
  [652] = {.lex_state = 176},
  [653] = {.lex_state = 342},
  [654] = {.lex_state = 176},
  [655] = {.lex_state = 176},
  [656] = {.lex_state = 176},
  [657] = {.lex_state = 176},
  [658] = {.lex_state = 175},
  [659] = {.lex_state = 342},
  [660] = {.lex_state = 176},
  [661] = {.lex_state = 176},
  [662] = {.lex_state = 342},
  [663] = {.lex_state = 342},
  [664] = {.lex_state = 342},
  [665] = {.lex_state = 342},
  [666] = {.lex_state = 342},
  [667] = {.lex_state = 342},
  [668] = {.lex_state = 342},
  [669] = {.lex_state = 176},
  [670] = {.lex_state = 176},
  [671] = {.lex_state = 176},
  [672] = {.lex_state = 176},
  [673] = {.lex_state = 176},
  [674] = {.lex_state = 176},
  [675] = {.lex_state = 176},
  [676] = {.lex_state = 176},
  [677] = {.lex_state = 342},
  [678] = {.lex_state = 176},
  [679] = {.lex_state = 342},
  [680] = {.lex_state = 342},
  [681] = {.lex_state = 176},
  [682] = {.lex_state = 176},
  [683] = {.lex_state = 342},
  [684] = {.lex_state = 176},
  [685] = {.lex_state = 342},
  [686] = {.lex_state = 176},
  [687] = {.lex_state = 342},
  [688] = {.lex_state = 342},
  [689] = {.lex_state = 176},
  [690] = {.lex_state = 176},
  [691] = {.lex_state = 176},
  [692] = {.lex_state = 176},
  [693] = {.lex_state = 342},
  [694] = {.lex_state = 342},
  [695] = {.lex_state = 342},
  [696] = {.lex_state = 342},
  [697] = {.lex_state = 342},
  [698] = {.lex_state = 342},
  [699] = {.lex_state = 342},
  [700] = {.lex_state = 342},
  [701] = {.lex_state = 342},
  [702] = {.lex_state = 342},
  [703] = {.lex_state = 342},
  [704] = {.lex_state = 342},
  [705] = {.lex_state = 342},
  [706] = {.lex_state = 342},
  [707] = {.lex_state = 342},
  [708] = {.lex_state = 342},
  [709] = {.lex_state = 342},
  [710] = {.lex_state = 342},
  [711] = {.lex_state = 342},
  [712] = {.lex_state = 342},
  [713] = {.lex_state = 342},
  [714] = {.lex_state = 342},
  [715] = {.lex_state = 342},
  [716] = {.lex_state = 342},
  [717] = {.lex_state = 342},
  [718] = {.lex_state = 176},
  [719] = {.lex_state = 342},
  [720] = {.lex_state = 176},
  [721] = {.lex_state = 176},
  [722] = {.lex_state = 176},
  [723] = {.lex_state = 176},
  [724] = {.lex_state = 342},
  [725] = {.lex_state = 342},
  [726] = {.lex_state = 176},
  [727] = {.lex_state = 176},
  [728] = {.lex_state = 176},
  [729] = {.lex_state = 176},
  [730] = {.lex_state = 176},
  [731] = {.lex_state = 176},
  [732] = {.lex_state = 342},
  [733] = {.lex_state = 342},
  [734] = {.lex_state = 342},
  [735] = {.lex_state = 342},
  [736] = {.lex_state = 342},
  [737] = {.lex_state = 342},
  [738] = {.lex_state = 342},
  [739] = {.lex_state = 342},
  [740] = {.lex_state = 342},
  [741] = {.lex_state = 342},
  [742] = {.lex_state = 342},
  [743] = {.lex_state = 342},
  [744] = {.lex_state = 342},
  [745] = {.lex_state = 342},
  [746] = {.lex_state = 342},
  [747] = {.lex_state = 342},
  [748] = {.lex_state = 342},
  [749] = {.lex_state = 342},
  [750] = {.lex_state = 342},
  [751] = {.lex_state = 342},
  [752] = {.lex_state = 342},
  [753] = {.lex_state = 342},
  [754] = {.lex_state = 342},
  [755] = {.lex_state = 342},
  [756] = {.lex_state = 342},
  [757] = {.lex_state = 342},
  [758] = {.lex_state = 342},
  [759] = {.lex_state = 342},
  [760] = {.lex_state = 342},
  [761] = {.lex_state = 342},
  [762] = {.lex_state = 342},
  [763] = {.lex_state = 342},
  [764] = {.lex_state = 342},
  [765] = {.lex_state = 342},
  [766] = {.lex_state = 342},
  [767] = {.lex_state = 342},
  [768] = {.lex_state = 342},
  [769] = {.lex_state = 342},
  [770] = {.lex_state = 342},
  [771] = {.lex_state = 342},
  [772] = {.lex_state = 342},
  [773] = {.lex_state = 342},
  [774] = {.lex_state = 342},
  [775] = {.lex_state = 342},
  [776] = {.lex_state = 342},
  [777] = {.lex_state = 342},
  [778] = {.lex_state = 342},
  [779] = {.lex_state = 342},
  [780] = {.lex_state = 342},
  [781] = {.lex_state = 342},
  [782] = {.lex_state = 342},
  [783] = {.lex_state = 342},
  [784] = {.lex_state = 342},
  [785] = {.lex_state = 342},
  [786] = {.lex_state = 342},
  [787] = {.lex_state = 342},
  [788] = {.lex_state = 342},
  [789] = {.lex_state = 342},
  [790] = {.lex_state = 342},
  [791] = {.lex_state = 342},
  [792] = {.lex_state = 342},
  [793] = {.lex_state = 342},
  [794] = {.lex_state = 342},
  [795] = {.lex_state = 342},
  [796] = {.lex_state = 342},
  [797] = {.lex_state = 342},
  [798] = {.lex_state = 342},
  [799] = {.lex_state = 342},
  [800] = {.lex_state = 342},
  [801] = {.lex_state = 342},
  [802] = {.lex_state = 342},
  [803] = {.lex_state = 342},
  [804] = {.lex_state = 342},
  [805] = {.lex_state = 342},
  [806] = {.lex_state = 342},
  [807] = {.lex_state = 342},
  [808] = {.lex_state = 342},
  [809] = {.lex_state = 342},
  [810] = {.lex_state = 342},
  [811] = {.lex_state = 342},
  [812] = {.lex_state = 342},
  [813] = {.lex_state = 342},
  [814] = {.lex_state = 342},
  [815] = {.lex_state = 342},
  [816] = {.lex_state = 342},
  [817] = {.lex_state = 342},
  [818] = {.lex_state = 342},
  [819] = {.lex_state = 342},
  [820] = {.lex_state = 342},
  [821] = {.lex_state = 342},
  [822] = {.lex_state = 342},
  [823] = {.lex_state = 342},
  [824] = {.lex_state = 342},
  [825] = {.lex_state = 342},
  [826] = {.lex_state = 342},
  [827] = {.lex_state = 342},
  [828] = {.lex_state = 342},
  [829] = {.lex_state = 342},
  [830] = {.lex_state = 342},
  [831] = {.lex_state = 342},
  [832] = {.lex_state = 342},
  [833] = {.lex_state = 342},
  [834] = {.lex_state = 342},
  [835] = {.lex_state = 342},
  [836] = {.lex_state = 342},
  [837] = {.lex_state = 342},
  [838] = {.lex_state = 342},
  [839] = {.lex_state = 342},
  [840] = {.lex_state = 342},
  [841] = {.lex_state = 342},
  [842] = {.lex_state = 240},
  [843] = {.lex_state = 240},
  [844] = {.lex_state = 240},
  [845] = {.lex_state = 240},
  [846] = {.lex_state = 240},
  [847] = {.lex_state = 240},
  [848] = {.lex_state = 210},
  [849] = {.lex_state = 240},
  [850] = {.lex_state = 240},
  [851] = {.lex_state = 240},
  [852] = {.lex_state = 240},
  [853] = {.lex_state = 240},
  [854] = {.lex_state = 240},
  [855] = {.lex_state = 240},
  [856] = {.lex_state = 240},
  [857] = {.lex_state = 240},
  [858] = {.lex_state = 240},
  [859] = {.lex_state = 240},
  [860] = {.lex_state = 240},
  [861] = {.lex_state = 240},
  [862] = {.lex_state = 240},
  [863] = {.lex_state = 210},
  [864] = {.lex_state = 240},
  [865] = {.lex_state = 240},
  [866] = {.lex_state = 240},
  [867] = {.lex_state = 240},
  [868] = {.lex_state = 240},
  [869] = {.lex_state = 240},
  [870] = {.lex_state = 240},
  [871] = {.lex_state = 240},
  [872] = {.lex_state = 240},
  [873] = {.lex_state = 210},
  [874] = {.lex_state = 240},
  [875] = {.lex_state = 240},
  [876] = {.lex_state = 175},
  [877] = {.lex_state = 175},
  [878] = {.lex_state = 175},
  [879] = {.lex_state = 175},
  [880] = {.lex_state = 175},
  [881] = {.lex_state = 175},
  [882] = {.lex_state = 175},
  [883] = {.lex_state = 175},
  [884] = {.lex_state = 175},
  [885] = {.lex_state = 175},
  [886] = {.lex_state = 175},
  [887] = {.lex_state = 175},
  [888] = {.lex_state = 175},
  [889] = {.lex_state = 175},
  [890] = {.lex_state = 175},
  [891] = {.lex_state = 175},
  [892] = {.lex_state = 175},
  [893] = {.lex_state = 175},
  [894] = {.lex_state = 175},
  [895] = {.lex_state = 175},
  [896] = {.lex_state = 175},
  [897] = {.lex_state = 175},
  [898] = {.lex_state = 175},
  [899] = {.lex_state = 175},
  [900] = {.lex_state = 175},
  [901] = {.lex_state = 175},
  [902] = {.lex_state = 175},
  [903] = {.lex_state = 175},
  [904] = {.lex_state = 175},
  [905] = {.lex_state = 175},
  [906] = {.lex_state = 175},
  [907] = {.lex_state = 175},
  [908] = {.lex_state = 175},
  [909] = {.lex_state = 175},
  [910] = {.lex_state = 175},
  [911] = {.lex_state = 175},
  [912] = {.lex_state = 175},
  [913] = {.lex_state = 175},
  [914] = {.lex_state = 175},
  [915] = {.lex_state = 175},
  [916] = {.lex_state = 175},
  [917] = {.lex_state = 175},
  [918] = {.lex_state = 175},
  [919] = {.lex_state = 175},
  [920] = {.lex_state = 175},
  [921] = {.lex_state = 175},
  [922] = {.lex_state = 175},
  [923] = {.lex_state = 175},
  [924] = {.lex_state = 175},
  [925] = {.lex_state = 175},
  [926] = {.lex_state = 175},
  [927] = {.lex_state = 175},
  [928] = {.lex_state = 175},
  [929] = {.lex_state = 175},
  [930] = {.lex_state = 175},
  [931] = {.lex_state = 175},
  [932] = {.lex_state = 175},
  [933] = {.lex_state = 175},
  [934] = {.lex_state = 175},
  [935] = {.lex_state = 175},
  [936] = {.lex_state = 175},
  [937] = {.lex_state = 175},
  [938] = {.lex_state = 175},
  [939] = {.lex_state = 175},
  [940] = {.lex_state = 175},
  [941] = {.lex_state = 175},
  [942] = {.lex_state = 175},
  [943] = {.lex_state = 175},
  [944] = {.lex_state = 175},
  [945] = {.lex_state = 166},
  [946] = {.lex_state = 171},
  [947] = {.lex_state = 171},
  [948] = {.lex_state = 342},
  [949] = {.lex_state = 342},
  [950] = {.lex_state = 166},
  [951] = {.lex_state = 178},
  [952] = {.lex_state = 178},
  [953] = {.lex_state = 178},
  [954] = {.lex_state = 178},
  [955] = {.lex_state = 178},
  [956] = {.lex_state = 178},
  [957] = {.lex_state = 178},
  [958] = {.lex_state = 178},
  [959] = {.lex_state = 178},
  [960] = {.lex_state = 178},
  [961] = {.lex_state = 178},
  [962] = {.lex_state = 166},
  [963] = {.lex_state = 178},
  [964] = {.lex_state = 178},
  [965] = {.lex_state = 178},
  [966] = {.lex_state = 178},
  [967] = {.lex_state = 178},
  [968] = {.lex_state = 178},
  [969] = {.lex_state = 178},
  [970] = {.lex_state = 178},
  [971] = {.lex_state = 178},
  [972] = {.lex_state = 178},
  [973] = {.lex_state = 178},
  [974] = {.lex_state = 178},
  [975] = {.lex_state = 178},
  [976] = {.lex_state = 178},
  [977] = {.lex_state = 178},
  [978] = {.lex_state = 242},
  [979] = {.lex_state = 168},
  [980] = {.lex_state = 242},
  [981] = {.lex_state = 242},
  [982] = {.lex_state = 242},
  [983] = {.lex_state = 242},
  [984] = {.lex_state = 242},
  [985] = {.lex_state = 242},
  [986] = {.lex_state = 175},
  [987] = {.lex_state = 166},
  [988] = {.lex_state = 175},
  [989] = {.lex_state = 169},
  [990] = {.lex_state = 242},
  [991] = {.lex_state = 242},
  [992] = {.lex_state = 175},
  [993] = {.lex_state = 242},
  [994] = {.lex_state = 242},
  [995] = {.lex_state = 242},
  [996] = {.lex_state = 242},
  [997] = {.lex_state = 175},
  [998] = {.lex_state = 342},
  [999] = {.lex_state = 242},
  [1000] = {.lex_state = 168},
  [1001] = {.lex_state = 175},
  [1002] = {.lex_state = 175},
  [1003] = {.lex_state = 175},
  [1004] = {.lex_state = 175},
  [1005] = {.lex_state = 175},
  [1006] = {.lex_state = 175},
  [1007] = {.lex_state = 175},
  [1008] = {.lex_state = 175},
  [1009] = {.lex_state = 175},
  [1010] = {.lex_state = 175},
  [1011] = {.lex_state = 175},
  [1012] = {.lex_state = 175},
  [1013] = {.lex_state = 175},
  [1014] = {.lex_state = 175},
  [1015] = {.lex_state = 175},
  [1016] = {.lex_state = 178},
  [1017] = {.lex_state = 178},
  [1018] = {.lex_state = 178},
  [1019] = {.lex_state = 178},
  [1020] = {.lex_state = 178},
  [1021] = {.lex_state = 178},
  [1022] = {.lex_state = 178},
  [1023] = {.lex_state = 178},
  [1024] = {.lex_state = 178},
  [1025] = {.lex_state = 178},
  [1026] = {.lex_state = 178},
  [1027] = {.lex_state = 178},
  [1028] = {.lex_state = 178},
  [1029] = {.lex_state = 178},
  [1030] = {.lex_state = 178},
  [1031] = {.lex_state = 178},
  [1032] = {.lex_state = 178},
  [1033] = {.lex_state = 178},
  [1034] = {.lex_state = 178},
  [1035] = {.lex_state = 178},
  [1036] = {.lex_state = 178},
  [1037] = {.lex_state = 178},
  [1038] = {.lex_state = 175},
  [1039] = {.lex_state = 175},
  [1040] = {.lex_state = 177},
  [1041] = {.lex_state = 175},
  [1042] = {.lex_state = 175},
  [1043] = {.lex_state = 190},
  [1044] = {.lex_state = 177},
  [1045] = {.lex_state = 175},
  [1046] = {.lex_state = 175},
  [1047] = {.lex_state = 178},
  [1048] = {.lex_state = 175},
  [1049] = {.lex_state = 175},
  [1050] = {.lex_state = 175},
  [1051] = {.lex_state = 175},
  [1052] = {.lex_state = 175},
  [1053] = {.lex_state = 175},
  [1054] = {.lex_state = 175},
  [1055] = {.lex_state = 175},
  [1056] = {.lex_state = 175},
  [1057] = {.lex_state = 175},
  [1058] = {.lex_state = 175},
  [1059] = {.lex_state = 175},
  [1060] = {.lex_state = 190},
  [1061] = {.lex_state = 175},
  [1062] = {.lex_state = 175},
  [1063] = {.lex_state = 175},
  [1064] = {.lex_state = 175},
  [1065] = {.lex_state = 175},
  [1066] = {.lex_state = 175},
  [1067] = {.lex_state = 175},
  [1068] = {.lex_state = 175},
  [1069] = {.lex_state = 175},
  [1070] = {.lex_state = 175},
  [1071] = {.lex_state = 175},
  [1072] = {.lex_state = 175},
  [1073] = {.lex_state = 175},
  [1074] = {.lex_state = 175},
  [1075] = {.lex_state = 175},
  [1076] = {.lex_state = 175},
  [1077] = {.lex_state = 175},
  [1078] = {.lex_state = 190},
  [1079] = {.lex_state = 175},
  [1080] = {.lex_state = 175},
  [1081] = {.lex_state = 175},
  [1082] = {.lex_state = 175},
  [1083] = {.lex_state = 175},
  [1084] = {.lex_state = 175},
  [1085] = {.lex_state = 175},
  [1086] = {.lex_state = 175},
  [1087] = {.lex_state = 175},
  [1088] = {.lex_state = 175},
  [1089] = {.lex_state = 175},
  [1090] = {.lex_state = 175},
  [1091] = {.lex_state = 178},
  [1092] = {.lex_state = 175},
  [1093] = {.lex_state = 175},
  [1094] = {.lex_state = 178},
  [1095] = {.lex_state = 178},
  [1096] = {.lex_state = 175},
  [1097] = {.lex_state = 175},
  [1098] = {.lex_state = 178},
  [1099] = {.lex_state = 178},
  [1100] = {.lex_state = 178},
  [1101] = {.lex_state = 175},
  [1102] = {.lex_state = 178},
  [1103] = {.lex_state = 178},
  [1104] = {.lex_state = 178},
  [1105] = {.lex_state = 178},
  [1106] = {.lex_state = 178},
  [1107] = {.lex_state = 178},
  [1108] = {.lex_state = 175},
  [1109] = {.lex_state = 175},
  [1110] = {.lex_state = 175},
  [1111] = {.lex_state = 175},
  [1112] = {.lex_state = 190},
  [1113] = {.lex_state = 175},
  [1114] = {.lex_state = 175},
  [1115] = {.lex_state = 175},
  [1116] = {.lex_state = 190},
  [1117] = {.lex_state = 175},
  [1118] = {.lex_state = 175},
  [1119] = {.lex_state = 190},
  [1120] = {.lex_state = 242},
  [1121] = {.lex_state = 167},
  [1122] = {.lex_state = 186},
  [1123] = {.lex_state = 190},
  [1124] = {.lex_state = 190},
  [1125] = {.lex_state = 190},
  [1126] = {.lex_state = 167},
  [1127] = {.lex_state = 190},
  [1128] = {.lex_state = 190},
  [1129] = {.lex_state = 167},
  [1130] = {.lex_state = 190},
  [1131] = {.lex_state = 190},
  [1132] = {.lex_state = 190},
  [1133] = {.lex_state = 167},
  [1134] = {.lex_state = 167},
  [1135] = {.lex_state = 170},
  [1136] = {.lex_state = 167},
  [1137] = {.lex_state = 178},
  [1138] = {.lex_state = 178},
  [1139] = {.lex_state = 178},
  [1140] = {.lex_state = 197},
  [1141] = {.lex_state = 197},
  [1142] = {.lex_state = 197},
  [1143] = {.lex_state = 197},
  [1144] = {.lex_state = 197},
  [1145] = {.lex_state = 197},
  [1146] = {.lex_state = 197},
  [1147] = {.lex_state = 197},
  [1148] = {.lex_state = 179},
  [1149] = {.lex_state = 179},
  [1150] = {.lex_state = 179},
  [1151] = {.lex_state = 179},
  [1152] = {.lex_state = 179},
  [1153] = {.lex_state = 179},
  [1154] = {.lex_state = 179},
  [1155] = {.lex_state = 179},
  [1156] = {.lex_state = 179},
  [1157] = {.lex_state = 179},
  [1158] = {.lex_state = 179},
  [1159] = {.lex_state = 197},
  [1160] = {.lex_state = 179},
  [1161] = {.lex_state = 179},
  [1162] = {.lex_state = 179},
  [1163] = {.lex_state = 179},
  [1164] = {.lex_state = 179},
  [1165] = {.lex_state = 179},
  [1166] = {.lex_state = 179},
  [1167] = {.lex_state = 179},
  [1168] = {.lex_state = 179},
  [1169] = {.lex_state = 179},
  [1170] = {.lex_state = 179},
  [1171] = {.lex_state = 179},
  [1172] = {.lex_state = 179},
  [1173] = {.lex_state = 179},
  [1174] = {.lex_state = 179},
  [1175] = {.lex_state = 178},
  [1176] = {.lex_state = 178},
  [1177] = {.lex_state = 178},
  [1178] = {.lex_state = 178},
  [1179] = {.lex_state = 178},
  [1180] = {.lex_state = 178},
  [1181] = {.lex_state = 242},
  [1182] = {.lex_state = 178},
  [1183] = {.lex_state = 178},
  [1184] = {.lex_state = 178},
  [1185] = {.lex_state = 178},
  [1186] = {.lex_state = 178},
  [1187] = {.lex_state = 178},
  [1188] = {.lex_state = 178},
  [1189] = {.lex_state = 178},
  [1190] = {.lex_state = 178},
  [1191] = {.lex_state = 178},
  [1192] = {.lex_state = 178},
  [1193] = {.lex_state = 178},
  [1194] = {.lex_state = 242},
  [1195] = {.lex_state = 178},
  [1196] = {.lex_state = 178},
  [1197] = {.lex_state = 178},
  [1198] = {.lex_state = 196},
  [1199] = {.lex_state = 196},
  [1200] = {.lex_state = 196},
  [1201] = {.lex_state = 196},
  [1202] = {.lex_state = 196},
  [1203] = {.lex_state = 196},
  [1204] = {.lex_state = 196},
  [1205] = {.lex_state = 175},
  [1206] = {.lex_state = 177},
  [1207] = {.lex_state = 175},
  [1208] = {.lex_state = 177},
  [1209] = {.lex_state = 242},
  [1210] = {.lex_state = 242},
  [1211] = {.lex_state = 242},
  [1212] = {.lex_state = 242},
  [1213] = {.lex_state = 175},
  [1214] = {.lex_state = 211},
  [1215] = {.lex_state = 197},
  [1216] = {.lex_state = 178},
  [1217] = {.lex_state = 211},
  [1218] = {.lex_state = 197},
  [1219] = {.lex_state = 197},
  [1220] = {.lex_state = 211},
  [1221] = {.lex_state = 211},
  [1222] = {.lex_state = 211},
  [1223] = {.lex_state = 211},
  [1224] = {.lex_state = 211},
  [1225] = {.lex_state = 211},
  [1226] = {.lex_state = 211},
  [1227] = {.lex_state = 197},
  [1228] = {.lex_state = 177},
  [1229] = {.lex_state = 177},
  [1230] = {.lex_state = 211},
  [1231] = {.lex_state = 211},
  [1232] = {.lex_state = 211},
  [1233] = {.lex_state = 211},
  [1234] = {.lex_state = 211},
  [1235] = {.lex_state = 211},
  [1236] = {.lex_state = 211},
  [1237] = {.lex_state = 211},
  [1238] = {.lex_state = 178},
  [1239] = {.lex_state = 178},
  [1240] = {.lex_state = 178},
  [1241] = {.lex_state = 178},
  [1242] = {.lex_state = 178},
  [1243] = {.lex_state = 178},
  [1244] = {.lex_state = 178},
  [1245] = {.lex_state = 178},
  [1246] = {.lex_state = 178},
  [1247] = {.lex_state = 178},
  [1248] = {.lex_state = 178},
  [1249] = {.lex_state = 178},
  [1250] = {.lex_state = 178},
  [1251] = {.lex_state = 178},
  [1252] = {.lex_state = 178},
  [1253] = {.lex_state = 178},
  [1254] = {.lex_state = 178},
  [1255] = {.lex_state = 178},
  [1256] = {.lex_state = 178},
  [1257] = {.lex_state = 178},
  [1258] = {.lex_state = 178},
  [1259] = {.lex_state = 178},
  [1260] = {.lex_state = 178},
  [1261] = {.lex_state = 178},
  [1262] = {.lex_state = 178},
  [1263] = {.lex_state = 178},
  [1264] = {.lex_state = 178},
  [1265] = {.lex_state = 178},
  [1266] = {.lex_state = 178},
  [1267] = {.lex_state = 178},
  [1268] = {.lex_state = 178},
  [1269] = {.lex_state = 178},
  [1270] = {.lex_state = 178},
  [1271] = {.lex_state = 178},
  [1272] = {.lex_state = 178},
  [1273] = {.lex_state = 178},
  [1274] = {.lex_state = 178},
  [1275] = {.lex_state = 178},
  [1276] = {.lex_state = 178},
  [1277] = {.lex_state = 178},
  [1278] = {.lex_state = 178},
  [1279] = {.lex_state = 178},
  [1280] = {.lex_state = 178},
  [1281] = {.lex_state = 242},
  [1282] = {.lex_state = 242},
  [1283] = {.lex_state = 196},
  [1284] = {.lex_state = 242},
  [1285] = {.lex_state = 242},
  [1286] = {.lex_state = 242},
  [1287] = {.lex_state = 242},
  [1288] = {.lex_state = 242},
  [1289] = {.lex_state = 242},
  [1290] = {.lex_state = 242},
  [1291] = {.lex_state = 242},
  [1292] = {.lex_state = 242},
  [1293] = {.lex_state = 242},
  [1294] = {.lex_state = 242},
  [1295] = {.lex_state = 242},
  [1296] = {.lex_state = 242},
  [1297] = {.lex_state = 242},
  [1298] = {.lex_state = 242},
  [1299] = {.lex_state = 242},
  [1300] = {.lex_state = 178},
  [1301] = {.lex_state = 178},
  [1302] = {.lex_state = 178},
  [1303] = {.lex_state = 178},
  [1304] = {.lex_state = 178},
  [1305] = {.lex_state = 178},
  [1306] = {.lex_state = 178},
  [1307] = {.lex_state = 178},
  [1308] = {.lex_state = 178},
  [1309] = {.lex_state = 178},
  [1310] = {.lex_state = 178},
  [1311] = {.lex_state = 178},
  [1312] = {.lex_state = 242},
  [1313] = {.lex_state = 178},
  [1314] = {.lex_state = 178},
  [1315] = {.lex_state = 178},
  [1316] = {.lex_state = 178},
  [1317] = {.lex_state = 178},
  [1318] = {.lex_state = 178},
  [1319] = {.lex_state = 178},
  [1320] = {.lex_state = 178},
  [1321] = {.lex_state = 178},
  [1322] = {.lex_state = 178},
  [1323] = {.lex_state = 178},
  [1324] = {.lex_state = 178},
  [1325] = {.lex_state = 178},
  [1326] = {.lex_state = 178},
  [1327] = {.lex_state = 178},
  [1328] = {.lex_state = 178},
  [1329] = {.lex_state = 178},
  [1330] = {.lex_state = 178},
  [1331] = {.lex_state = 178},
  [1332] = {.lex_state = 178},
  [1333] = {.lex_state = 178},
  [1334] = {.lex_state = 178},
  [1335] = {.lex_state = 178},
  [1336] = {.lex_state = 242},
  [1337] = {.lex_state = 178},
  [1338] = {.lex_state = 178},
  [1339] = {.lex_state = 178},
  [1340] = {.lex_state = 242},
  [1341] = {.lex_state = 178},
  [1342] = {.lex_state = 178},
  [1343] = {.lex_state = 242},
  [1344] = {.lex_state = 178},
  [1345] = {.lex_state = 242},
  [1346] = {.lex_state = 178},
  [1347] = {.lex_state = 178},
  [1348] = {.lex_state = 178},
  [1349] = {.lex_state = 178},
  [1350] = {.lex_state = 178},
  [1351] = {.lex_state = 178},
  [1352] = {.lex_state = 178},
  [1353] = {.lex_state = 178},
  [1354] = {.lex_state = 178},
  [1355] = {.lex_state = 178},
  [1356] = {.lex_state = 178},
  [1357] = {.lex_state = 178},
  [1358] = {.lex_state = 178},
  [1359] = {.lex_state = 178},
  [1360] = {.lex_state = 178},
  [1361] = {.lex_state = 178},
  [1362] = {.lex_state = 178},
  [1363] = {.lex_state = 178},
  [1364] = {.lex_state = 178},
  [1365] = {.lex_state = 178},
  [1366] = {.lex_state = 178},
  [1367] = {.lex_state = 242},
  [1368] = {.lex_state = 178},
  [1369] = {.lex_state = 242},
  [1370] = {.lex_state = 178},
  [1371] = {.lex_state = 178},
  [1372] = {.lex_state = 178},
  [1373] = {.lex_state = 178},
  [1374] = {.lex_state = 178},
  [1375] = {.lex_state = 178},
  [1376] = {.lex_state = 178},
  [1377] = {.lex_state = 178},
  [1378] = {.lex_state = 178},
  [1379] = {.lex_state = 178},
  [1380] = {.lex_state = 178},
  [1381] = {.lex_state = 178},
  [1382] = {.lex_state = 178},
  [1383] = {.lex_state = 178},
  [1384] = {.lex_state = 178},
  [1385] = {.lex_state = 242},
  [1386] = {.lex_state = 178},
  [1387] = {.lex_state = 178},
  [1388] = {.lex_state = 178},
  [1389] = {.lex_state = 178},
  [1390] = {.lex_state = 178},
  [1391] = {.lex_state = 178},
  [1392] = {.lex_state = 178},
  [1393] = {.lex_state = 178},
  [1394] = {.lex_state = 178},
  [1395] = {.lex_state = 178},
  [1396] = {.lex_state = 178},
  [1397] = {.lex_state = 178},
  [1398] = {.lex_state = 178},
  [1399] = {.lex_state = 178},
  [1400] = {.lex_state = 178},
  [1401] = {.lex_state = 178},
  [1402] = {.lex_state = 178},
  [1403] = {.lex_state = 178},
  [1404] = {.lex_state = 178},
  [1405] = {.lex_state = 178},
  [1406] = {.lex_state = 178},
  [1407] = {.lex_state = 178},
  [1408] = {.lex_state = 178},
  [1409] = {.lex_state = 242},
  [1410] = {.lex_state = 178},
  [1411] = {.lex_state = 178},
  [1412] = {.lex_state = 178},
  [1413] = {.lex_state = 178},
  [1414] = {.lex_state = 178},
  [1415] = {.lex_state = 178},
  [1416] = {.lex_state = 178},
  [1417] = {.lex_state = 178},
  [1418] = {.lex_state = 178},
  [1419] = {.lex_state = 178},
  [1420] = {.lex_state = 178},
  [1421] = {.lex_state = 178},
  [1422] = {.lex_state = 178},
  [1423] = {.lex_state = 178},
  [1424] = {.lex_state = 178},
  [1425] = {.lex_state = 178},
  [1426] = {.lex_state = 178},
  [1427] = {.lex_state = 242},
  [1428] = {.lex_state = 178},
  [1429] = {.lex_state = 178},
  [1430] = {.lex_state = 178},
  [1431] = {.lex_state = 178},
  [1432] = {.lex_state = 178},
  [1433] = {.lex_state = 178},
  [1434] = {.lex_state = 178},
  [1435] = {.lex_state = 178},
  [1436] = {.lex_state = 178},
  [1437] = {.lex_state = 178},
  [1438] = {.lex_state = 178},
  [1439] = {.lex_state = 178},
  [1440] = {.lex_state = 178},
  [1441] = {.lex_state = 178},
  [1442] = {.lex_state = 178},
  [1443] = {.lex_state = 178},
  [1444] = {.lex_state = 242},
  [1445] = {.lex_state = 178},
  [1446] = {.lex_state = 178},
  [1447] = {.lex_state = 178},
  [1448] = {.lex_state = 178},
  [1449] = {.lex_state = 178},
  [1450] = {.lex_state = 178},
  [1451] = {.lex_state = 178},
  [1452] = {.lex_state = 242},
  [1453] = {.lex_state = 178},
  [1454] = {.lex_state = 178},
  [1455] = {.lex_state = 178},
  [1456] = {.lex_state = 178},
  [1457] = {.lex_state = 178},
  [1458] = {.lex_state = 178},
  [1459] = {.lex_state = 196},
  [1460] = {.lex_state = 178},
  [1461] = {.lex_state = 178},
  [1462] = {.lex_state = 178},
  [1463] = {.lex_state = 178},
  [1464] = {.lex_state = 178},
  [1465] = {.lex_state = 178},
  [1466] = {.lex_state = 178},
  [1467] = {.lex_state = 178},
  [1468] = {.lex_state = 178},
  [1469] = {.lex_state = 178},
  [1470] = {.lex_state = 178},
  [1471] = {.lex_state = 178},
  [1472] = {.lex_state = 178},
  [1473] = {.lex_state = 178},
  [1474] = {.lex_state = 178},
  [1475] = {.lex_state = 178},
  [1476] = {.lex_state = 196},
  [1477] = {.lex_state = 178},
  [1478] = {.lex_state = 178},
  [1479] = {.lex_state = 178},
  [1480] = {.lex_state = 178},
  [1481] = {.lex_state = 178},
  [1482] = {.lex_state = 178},
  [1483] = {.lex_state = 178},
  [1484] = {.lex_state = 178},
  [1485] = {.lex_state = 242},
  [1486] = {.lex_state = 178},
  [1487] = {.lex_state = 178},
  [1488] = {.lex_state = 178},
  [1489] = {.lex_state = 178},
  [1490] = {.lex_state = 242},
  [1491] = {.lex_state = 178},
  [1492] = {.lex_state = 178},
  [1493] = {.lex_state = 242},
  [1494] = {.lex_state = 178},
  [1495] = {.lex_state = 178},
  [1496] = {.lex_state = 178},
  [1497] = {.lex_state = 178},
  [1498] = {.lex_state = 178},
  [1499] = {.lex_state = 242},
  [1500] = {.lex_state = 178},
  [1501] = {.lex_state = 178},
  [1502] = {.lex_state = 178},
  [1503] = {.lex_state = 178},
  [1504] = {.lex_state = 178},
  [1505] = {.lex_state = 178},
  [1506] = {.lex_state = 178},
  [1507] = {.lex_state = 178},
  [1508] = {.lex_state = 178},
  [1509] = {.lex_state = 178},
  [1510] = {.lex_state = 178},
  [1511] = {.lex_state = 178},
  [1512] = {.lex_state = 178},
  [1513] = {.lex_state = 178},
  [1514] = {.lex_state = 178},
  [1515] = {.lex_state = 178},
  [1516] = {.lex_state = 178},
  [1517] = {.lex_state = 178},
  [1518] = {.lex_state = 178},
  [1519] = {.lex_state = 178},
  [1520] = {.lex_state = 178},
  [1521] = {.lex_state = 178},
  [1522] = {.lex_state = 178},
  [1523] = {.lex_state = 178},
  [1524] = {.lex_state = 178},
  [1525] = {.lex_state = 178},
  [1526] = {.lex_state = 178},
  [1527] = {.lex_state = 178},
  [1528] = {.lex_state = 178},
  [1529] = {.lex_state = 178},
  [1530] = {.lex_state = 178},
  [1531] = {.lex_state = 178},
  [1532] = {.lex_state = 178},
  [1533] = {.lex_state = 178},
  [1534] = {.lex_state = 178},
  [1535] = {.lex_state = 178},
  [1536] = {.lex_state = 178},
  [1537] = {.lex_state = 178},
  [1538] = {.lex_state = 178},
  [1539] = {.lex_state = 178},
  [1540] = {.lex_state = 178},
  [1541] = {.lex_state = 178},
  [1542] = {.lex_state = 178},
  [1543] = {.lex_state = 178},
  [1544] = {.lex_state = 178},
  [1545] = {.lex_state = 178},
  [1546] = {.lex_state = 178},
  [1547] = {.lex_state = 178},
  [1548] = {.lex_state = 178},
  [1549] = {.lex_state = 178},
  [1550] = {.lex_state = 178},
  [1551] = {.lex_state = 178},
  [1552] = {.lex_state = 178},
  [1553] = {.lex_state = 178},
  [1554] = {.lex_state = 178},
  [1555] = {.lex_state = 178},
  [1556] = {.lex_state = 178},
  [1557] = {.lex_state = 178},
  [1558] = {.lex_state = 178},
  [1559] = {.lex_state = 178},
  [1560] = {.lex_state = 178},
  [1561] = {.lex_state = 178},
  [1562] = {.lex_state = 178},
  [1563] = {.lex_state = 178},
  [1564] = {.lex_state = 178},
  [1565] = {.lex_state = 178},
  [1566] = {.lex_state = 178},
  [1567] = {.lex_state = 178},
  [1568] = {.lex_state = 178},
  [1569] = {.lex_state = 178},
  [1570] = {.lex_state = 178},
  [1571] = {.lex_state = 178},
  [1572] = {.lex_state = 178},
  [1573] = {.lex_state = 178},
  [1574] = {.lex_state = 178},
  [1575] = {.lex_state = 178},
  [1576] = {.lex_state = 178},
  [1577] = {.lex_state = 178},
  [1578] = {.lex_state = 178},
  [1579] = {.lex_state = 178},
  [1580] = {.lex_state = 178},
  [1581] = {.lex_state = 178},
  [1582] = {.lex_state = 178},
  [1583] = {.lex_state = 178},
  [1584] = {.lex_state = 178},
  [1585] = {.lex_state = 178},
  [1586] = {.lex_state = 178},
  [1587] = {.lex_state = 178},
  [1588] = {.lex_state = 178},
  [1589] = {.lex_state = 178},
  [1590] = {.lex_state = 178},
  [1591] = {.lex_state = 178},
  [1592] = {.lex_state = 178},
  [1593] = {.lex_state = 178},
  [1594] = {.lex_state = 178},
  [1595] = {.lex_state = 178},
  [1596] = {.lex_state = 178},
  [1597] = {.lex_state = 178},
  [1598] = {.lex_state = 178},
  [1599] = {.lex_state = 178},
  [1600] = {.lex_state = 178},
  [1601] = {.lex_state = 178},
  [1602] = {.lex_state = 178},
  [1603] = {.lex_state = 178},
  [1604] = {.lex_state = 178},
  [1605] = {.lex_state = 178},
  [1606] = {.lex_state = 178},
  [1607] = {.lex_state = 178},
  [1608] = {.lex_state = 178},
  [1609] = {.lex_state = 178},
  [1610] = {.lex_state = 240},
  [1611] = {.lex_state = 240},
  [1612] = {.lex_state = 178},
  [1613] = {.lex_state = 178},
  [1614] = {.lex_state = 178},
  [1615] = {.lex_state = 178},
  [1616] = {.lex_state = 178},
  [1617] = {.lex_state = 178},
  [1618] = {.lex_state = 178},
  [1619] = {.lex_state = 178},
  [1620] = {.lex_state = 178},
  [1621] = {.lex_state = 178},
  [1622] = {.lex_state = 178},
  [1623] = {.lex_state = 178},
  [1624] = {.lex_state = 178},
  [1625] = {.lex_state = 178},
  [1626] = {.lex_state = 178},
  [1627] = {.lex_state = 178},
  [1628] = {.lex_state = 178},
  [1629] = {.lex_state = 178},
  [1630] = {.lex_state = 178},
  [1631] = {.lex_state = 178},
  [1632] = {.lex_state = 178},
  [1633] = {.lex_state = 178},
  [1634] = {.lex_state = 178},
  [1635] = {.lex_state = 178},
  [1636] = {.lex_state = 178},
  [1637] = {.lex_state = 178},
  [1638] = {.lex_state = 178},
  [1639] = {.lex_state = 178},
  [1640] = {.lex_state = 178},
  [1641] = {.lex_state = 178},
  [1642] = {.lex_state = 178},
  [1643] = {.lex_state = 178},
  [1644] = {.lex_state = 178},
  [1645] = {.lex_state = 178},
  [1646] = {.lex_state = 178},
  [1647] = {.lex_state = 178},
  [1648] = {.lex_state = 178},
  [1649] = {.lex_state = 178},
  [1650] = {.lex_state = 178},
  [1651] = {.lex_state = 178},
  [1652] = {.lex_state = 178},
  [1653] = {.lex_state = 178},
  [1654] = {.lex_state = 178},
  [1655] = {.lex_state = 178},
  [1656] = {.lex_state = 178},
  [1657] = {.lex_state = 178},
  [1658] = {.lex_state = 178},
  [1659] = {.lex_state = 178},
  [1660] = {.lex_state = 178},
  [1661] = {.lex_state = 178},
  [1662] = {.lex_state = 178},
  [1663] = {.lex_state = 178},
  [1664] = {.lex_state = 178},
  [1665] = {.lex_state = 178},
  [1666] = {.lex_state = 178},
  [1667] = {.lex_state = 178},
  [1668] = {.lex_state = 178},
  [1669] = {.lex_state = 178},
  [1670] = {.lex_state = 178},
  [1671] = {.lex_state = 178},
  [1672] = {.lex_state = 178},
  [1673] = {.lex_state = 178},
  [1674] = {.lex_state = 178},
  [1675] = {.lex_state = 178},
  [1676] = {.lex_state = 178},
  [1677] = {.lex_state = 178},
  [1678] = {.lex_state = 178},
  [1679] = {.lex_state = 178},
  [1680] = {.lex_state = 178},
  [1681] = {.lex_state = 178},
  [1682] = {.lex_state = 178},
  [1683] = {.lex_state = 178},
  [1684] = {.lex_state = 178},
  [1685] = {.lex_state = 178},
  [1686] = {.lex_state = 178},
  [1687] = {.lex_state = 178},
  [1688] = {.lex_state = 178},
  [1689] = {.lex_state = 178},
  [1690] = {.lex_state = 178},
  [1691] = {.lex_state = 178},
  [1692] = {.lex_state = 178},
  [1693] = {.lex_state = 178},
  [1694] = {.lex_state = 178},
  [1695] = {.lex_state = 178},
  [1696] = {.lex_state = 178},
  [1697] = {.lex_state = 178},
  [1698] = {.lex_state = 178},
  [1699] = {.lex_state = 178},
  [1700] = {.lex_state = 178},
  [1701] = {.lex_state = 178},
  [1702] = {.lex_state = 178},
  [1703] = {.lex_state = 178},
  [1704] = {.lex_state = 178},
  [1705] = {.lex_state = 178},
  [1706] = {.lex_state = 178},
  [1707] = {.lex_state = 178},
  [1708] = {.lex_state = 178},
  [1709] = {.lex_state = 178},
  [1710] = {.lex_state = 178},
  [1711] = {.lex_state = 178},
  [1712] = {.lex_state = 178},
  [1713] = {.lex_state = 178},
  [1714] = {.lex_state = 178},
  [1715] = {.lex_state = 178},
  [1716] = {.lex_state = 178},
  [1717] = {.lex_state = 178},
  [1718] = {.lex_state = 178},
  [1719] = {.lex_state = 178},
  [1720] = {.lex_state = 178},
  [1721] = {.lex_state = 178},
  [1722] = {.lex_state = 178},
  [1723] = {.lex_state = 178},
  [1724] = {.lex_state = 178},
  [1725] = {.lex_state = 178},
  [1726] = {.lex_state = 178},
  [1727] = {.lex_state = 178},
  [1728] = {.lex_state = 178},
  [1729] = {.lex_state = 178},
  [1730] = {.lex_state = 178},
  [1731] = {.lex_state = 178},
  [1732] = {.lex_state = 178},
  [1733] = {.lex_state = 178},
  [1734] = {.lex_state = 178},
  [1735] = {.lex_state = 178},
  [1736] = {.lex_state = 178},
  [1737] = {.lex_state = 178},
  [1738] = {.lex_state = 178},
  [1739] = {.lex_state = 178},
  [1740] = {.lex_state = 178},
  [1741] = {.lex_state = 178},
  [1742] = {.lex_state = 178},
  [1743] = {.lex_state = 178},
  [1744] = {.lex_state = 178},
  [1745] = {.lex_state = 178},
  [1746] = {.lex_state = 178},
  [1747] = {.lex_state = 178},
  [1748] = {.lex_state = 178},
  [1749] = {.lex_state = 178},
  [1750] = {.lex_state = 178},
  [1751] = {.lex_state = 178},
  [1752] = {.lex_state = 178},
  [1753] = {.lex_state = 178},
  [1754] = {.lex_state = 178},
  [1755] = {.lex_state = 178},
  [1756] = {.lex_state = 178},
  [1757] = {.lex_state = 178},
  [1758] = {.lex_state = 178},
  [1759] = {.lex_state = 178},
  [1760] = {.lex_state = 178},
  [1761] = {.lex_state = 178},
  [1762] = {.lex_state = 178},
  [1763] = {.lex_state = 178},
  [1764] = {.lex_state = 178},
  [1765] = {.lex_state = 178},
  [1766] = {.lex_state = 178},
  [1767] = {.lex_state = 178},
  [1768] = {.lex_state = 178},
  [1769] = {.lex_state = 178},
  [1770] = {.lex_state = 178},
  [1771] = {.lex_state = 178},
  [1772] = {.lex_state = 178},
  [1773] = {.lex_state = 178},
  [1774] = {.lex_state = 178},
  [1775] = {.lex_state = 178},
  [1776] = {.lex_state = 178},
  [1777] = {.lex_state = 178},
  [1778] = {.lex_state = 178},
  [1779] = {.lex_state = 178},
  [1780] = {.lex_state = 178},
  [1781] = {.lex_state = 178},
  [1782] = {.lex_state = 178},
  [1783] = {.lex_state = 178},
  [1784] = {.lex_state = 178},
  [1785] = {.lex_state = 178},
  [1786] = {.lex_state = 178},
  [1787] = {.lex_state = 178},
  [1788] = {.lex_state = 178},
  [1789] = {.lex_state = 178},
  [1790] = {.lex_state = 178},
  [1791] = {.lex_state = 178},
  [1792] = {.lex_state = 178},
  [1793] = {.lex_state = 178},
  [1794] = {.lex_state = 178},
  [1795] = {.lex_state = 178},
  [1796] = {.lex_state = 178},
  [1797] = {.lex_state = 178},
  [1798] = {.lex_state = 178},
  [1799] = {.lex_state = 178},
  [1800] = {.lex_state = 178},
  [1801] = {.lex_state = 178},
  [1802] = {.lex_state = 178},
  [1803] = {.lex_state = 178},
  [1804] = {.lex_state = 178},
  [1805] = {.lex_state = 178},
  [1806] = {.lex_state = 178},
  [1807] = {.lex_state = 178},
  [1808] = {.lex_state = 178},
  [1809] = {.lex_state = 178},
  [1810] = {.lex_state = 178},
  [1811] = {.lex_state = 178},
  [1812] = {.lex_state = 178},
  [1813] = {.lex_state = 178},
  [1814] = {.lex_state = 178},
  [1815] = {.lex_state = 178},
  [1816] = {.lex_state = 178},
  [1817] = {.lex_state = 178},
  [1818] = {.lex_state = 178},
  [1819] = {.lex_state = 178},
  [1820] = {.lex_state = 178},
  [1821] = {.lex_state = 178},
  [1822] = {.lex_state = 178},
  [1823] = {.lex_state = 178},
  [1824] = {.lex_state = 178},
  [1825] = {.lex_state = 178},
  [1826] = {.lex_state = 178},
  [1827] = {.lex_state = 178},
  [1828] = {.lex_state = 178},
  [1829] = {.lex_state = 178},
  [1830] = {.lex_state = 178},
  [1831] = {.lex_state = 178},
  [1832] = {.lex_state = 178},
  [1833] = {.lex_state = 178},
  [1834] = {.lex_state = 178},
  [1835] = {.lex_state = 178},
  [1836] = {.lex_state = 178},
  [1837] = {.lex_state = 178},
  [1838] = {.lex_state = 178},
  [1839] = {.lex_state = 178},
  [1840] = {.lex_state = 178},
  [1841] = {.lex_state = 178},
  [1842] = {.lex_state = 178},
  [1843] = {.lex_state = 178},
  [1844] = {.lex_state = 178},
  [1845] = {.lex_state = 178},
  [1846] = {.lex_state = 178},
  [1847] = {.lex_state = 178},
  [1848] = {.lex_state = 178},
  [1849] = {.lex_state = 178},
  [1850] = {.lex_state = 178},
  [1851] = {.lex_state = 178},
  [1852] = {.lex_state = 178},
  [1853] = {.lex_state = 178},
  [1854] = {.lex_state = 178},
  [1855] = {.lex_state = 178},
  [1856] = {.lex_state = 178},
  [1857] = {.lex_state = 178},
  [1858] = {.lex_state = 178},
  [1859] = {.lex_state = 178},
  [1860] = {.lex_state = 178},
  [1861] = {.lex_state = 178},
  [1862] = {.lex_state = 178},
  [1863] = {.lex_state = 178},
  [1864] = {.lex_state = 178},
  [1865] = {.lex_state = 178},
  [1866] = {.lex_state = 178},
  [1867] = {.lex_state = 178},
  [1868] = {.lex_state = 178},
  [1869] = {.lex_state = 178},
  [1870] = {.lex_state = 242},
  [1871] = {.lex_state = 242},
  [1872] = {.lex_state = 242},
  [1873] = {.lex_state = 242},
  [1874] = {.lex_state = 242},
  [1875] = {.lex_state = 242},
  [1876] = {.lex_state = 242},
  [1877] = {.lex_state = 242},
  [1878] = {.lex_state = 242},
  [1879] = {.lex_state = 242},
  [1880] = {.lex_state = 242},
  [1881] = {.lex_state = 242},
  [1882] = {.lex_state = 242},
  [1883] = {.lex_state = 242},
  [1884] = {.lex_state = 242},
  [1885] = {.lex_state = 242},
  [1886] = {.lex_state = 242},
  [1887] = {.lex_state = 242},
  [1888] = {.lex_state = 242},
  [1889] = {.lex_state = 242},
  [1890] = {.lex_state = 242},
  [1891] = {.lex_state = 242},
  [1892] = {.lex_state = 242},
  [1893] = {.lex_state = 242},
  [1894] = {.lex_state = 242},
  [1895] = {.lex_state = 242},
  [1896] = {.lex_state = 242},
  [1897] = {.lex_state = 196},
  [1898] = {.lex_state = 196},
  [1899] = {.lex_state = 196},
  [1900] = {.lex_state = 196},
  [1901] = {.lex_state = 242},
  [1902] = {.lex_state = 196},
  [1903] = {.lex_state = 196},
  [1904] = {.lex_state = 242},
  [1905] = {.lex_state = 196},
  [1906] = {.lex_state = 242},
  [1907] = {.lex_state = 196},
  [1908] = {.lex_state = 242},
  [1909] = {.lex_state = 196},
  [1910] = {.lex_state = 196},
  [1911] = {.lex_state = 196},
  [1912] = {.lex_state = 242},
  [1913] = {.lex_state = 242},
  [1914] = {.lex_state = 242},
  [1915] = {.lex_state = 242},
  [1916] = {.lex_state = 242},
  [1917] = {.lex_state = 242},
  [1918] = {.lex_state = 242},
  [1919] = {.lex_state = 242},
  [1920] = {.lex_state = 242},
  [1921] = {.lex_state = 242},
  [1922] = {.lex_state = 242},
  [1923] = {.lex_state = 242},
  [1924] = {.lex_state = 242},
  [1925] = {.lex_state = 242},
  [1926] = {.lex_state = 242},
  [1927] = {.lex_state = 242},
  [1928] = {.lex_state = 242},
  [1929] = {.lex_state = 242},
  [1930] = {.lex_state = 242},
  [1931] = {.lex_state = 242},
  [1932] = {.lex_state = 242},
  [1933] = {.lex_state = 242},
  [1934] = {.lex_state = 242},
  [1935] = {.lex_state = 242},
  [1936] = {.lex_state = 242},
  [1937] = {.lex_state = 242},
  [1938] = {.lex_state = 242},
  [1939] = {.lex_state = 242},
  [1940] = {.lex_state = 242},
  [1941] = {.lex_state = 242},
  [1942] = {.lex_state = 242},
  [1943] = {.lex_state = 242},
  [1944] = {.lex_state = 242},
  [1945] = {.lex_state = 242},
  [1946] = {.lex_state = 242},
  [1947] = {.lex_state = 242},
  [1948] = {.lex_state = 242},
  [1949] = {.lex_state = 242},
  [1950] = {.lex_state = 242},
  [1951] = {.lex_state = 242},
  [1952] = {.lex_state = 242},
  [1953] = {.lex_state = 242},
  [1954] = {.lex_state = 242},
  [1955] = {.lex_state = 242},
  [1956] = {.lex_state = 242},
  [1957] = {.lex_state = 242},
  [1958] = {.lex_state = 242},
  [1959] = {.lex_state = 242},
  [1960] = {.lex_state = 242},
  [1961] = {.lex_state = 242},
  [1962] = {.lex_state = 242},
  [1963] = {.lex_state = 242},
  [1964] = {.lex_state = 242},
  [1965] = {.lex_state = 242},
  [1966] = {.lex_state = 242},
  [1967] = {.lex_state = 242},
  [1968] = {.lex_state = 242},
  [1969] = {.lex_state = 242},
  [1970] = {.lex_state = 242},
  [1971] = {.lex_state = 242},
  [1972] = {.lex_state = 242},
  [1973] = {.lex_state = 242},
  [1974] = {.lex_state = 242},
  [1975] = {.lex_state = 242},
  [1976] = {.lex_state = 242},
  [1977] = {.lex_state = 242},
  [1978] = {.lex_state = 242},
  [1979] = {.lex_state = 242},
  [1980] = {.lex_state = 242},
  [1981] = {.lex_state = 242},
  [1982] = {.lex_state = 242},
  [1983] = {.lex_state = 242},
  [1984] = {.lex_state = 242},
  [1985] = {.lex_state = 242},
  [1986] = {.lex_state = 242},
  [1987] = {.lex_state = 242},
  [1988] = {.lex_state = 242},
  [1989] = {.lex_state = 242},
  [1990] = {.lex_state = 242},
  [1991] = {.lex_state = 242},
  [1992] = {.lex_state = 242},
  [1993] = {.lex_state = 242},
  [1994] = {.lex_state = 242},
  [1995] = {.lex_state = 242},
  [1996] = {.lex_state = 242},
  [1997] = {.lex_state = 242},
  [1998] = {.lex_state = 242},
  [1999] = {.lex_state = 242},
  [2000] = {.lex_state = 242},
  [2001] = {.lex_state = 242},
  [2002] = {.lex_state = 242},
  [2003] = {.lex_state = 242},
  [2004] = {.lex_state = 242},
  [2005] = {.lex_state = 242},
  [2006] = {.lex_state = 242},
  [2007] = {.lex_state = 242},
  [2008] = {.lex_state = 242},
  [2009] = {.lex_state = 242},
  [2010] = {.lex_state = 242},
  [2011] = {.lex_state = 242},
  [2012] = {.lex_state = 210},
  [2013] = {.lex_state = 210},
  [2014] = {.lex_state = 240},
  [2015] = {.lex_state = 210},
  [2016] = {.lex_state = 240},
  [2017] = {.lex_state = 242},
  [2018] = {.lex_state = 240},
  [2019] = {.lex_state = 210},
  [2020] = {.lex_state = 240},
  [2021] = {.lex_state = 242},
  [2022] = {.lex_state = 242},
  [2023] = {.lex_state = 242},
  [2024] = {.lex_state = 242},
  [2025] = {.lex_state = 242},
  [2026] = {.lex_state = 242},
  [2027] = {.lex_state = 242},
  [2028] = {.lex_state = 242},
  [2029] = {.lex_state = 242},
  [2030] = {.lex_state = 242},
  [2031] = {.lex_state = 242},
  [2032] = {.lex_state = 242},
  [2033] = {.lex_state = 242},
  [2034] = {.lex_state = 242},
  [2035] = {.lex_state = 242},
  [2036] = {.lex_state = 241},
  [2037] = {.lex_state = 242},
  [2038] = {.lex_state = 240},
  [2039] = {.lex_state = 241},
  [2040] = {.lex_state = 240},
  [2041] = {.lex_state = 242},
  [2042] = {.lex_state = 241},
  [2043] = {.lex_state = 242},
  [2044] = {.lex_state = 242},
  [2045] = {.lex_state = 240},
  [2046] = {.lex_state = 210},
  [2047] = {.lex_state = 210},
  [2048] = {.lex_state = 210},
  [2049] = {.lex_state = 210},
  [2050] = {.lex_state = 210},
  [2051] = {.lex_state = 241},
  [2052] = {.lex_state = 240},
  [2053] = {.lex_state = 210},
  [2054] = {.lex_state = 210},
  [2055] = {.lex_state = 210},
  [2056] = {.lex_state = 210},
  [2057] = {.lex_state = 240},
  [2058] = {.lex_state = 240},
  [2059] = {.lex_state = 240},
  [2060] = {.lex_state = 240},
  [2061] = {.lex_state = 210},
  [2062] = {.lex_state = 210},
  [2063] = {.lex_state = 240},
  [2064] = {.lex_state = 240},
  [2065] = {.lex_state = 210},
  [2066] = {.lex_state = 210},
  [2067] = {.lex_state = 210},
  [2068] = {.lex_state = 210},
  [2069] = {.lex_state = 210},
  [2070] = {.lex_state = 210},
  [2071] = {.lex_state = 240},
  [2072] = {.lex_state = 210},
  [2073] = {.lex_state = 240},
  [2074] = {.lex_state = 240},
  [2075] = {.lex_state = 210},
  [2076] = {.lex_state = 210},
  [2077] = {.lex_state = 210},
  [2078] = {.lex_state = 240},
  [2079] = {.lex_state = 240},
  [2080] = {.lex_state = 240},
  [2081] = {.lex_state = 240},
  [2082] = {.lex_state = 210},
  [2083] = {.lex_state = 210},
  [2084] = {.lex_state = 210},
  [2085] = {.lex_state = 240},
  [2086] = {.lex_state = 240},
  [2087] = {.lex_state = 240},
  [2088] = {.lex_state = 240},
  [2089] = {.lex_state = 186},
  [2090] = {.lex_state = 240},
  [2091] = {.lex_state = 240},
  [2092] = {.lex_state = 240},
  [2093] = {.lex_state = 240},
  [2094] = {.lex_state = 240},
  [2095] = {.lex_state = 240},
  [2096] = {.lex_state = 240},
  [2097] = {.lex_state = 240},
  [2098] = {.lex_state = 240},
  [2099] = {.lex_state = 240},
  [2100] = {.lex_state = 240},
  [2101] = {.lex_state = 240},
  [2102] = {.lex_state = 240},
  [2103] = {.lex_state = 240},
  [2104] = {.lex_state = 240},
  [2105] = {.lex_state = 240},
  [2106] = {.lex_state = 240},
  [2107] = {.lex_state = 240},
  [2108] = {.lex_state = 240},
  [2109] = {.lex_state = 240},
  [2110] = {.lex_state = 240},
  [2111] = {.lex_state = 240},
  [2112] = {.lex_state = 240},
  [2113] = {.lex_state = 240},
  [2114] = {.lex_state = 240},
  [2115] = {.lex_state = 240},
  [2116] = {.lex_state = 240},
  [2117] = {.lex_state = 240},
  [2118] = {.lex_state = 240},
  [2119] = {.lex_state = 240},
  [2120] = {.lex_state = 240},
  [2121] = {.lex_state = 240},
  [2122] = {.lex_state = 240},
  [2123] = {.lex_state = 240},
  [2124] = {.lex_state = 240},
  [2125] = {.lex_state = 240},
  [2126] = {.lex_state = 240},
  [2127] = {.lex_state = 240},
  [2128] = {.lex_state = 240},
  [2129] = {.lex_state = 240},
  [2130] = {.lex_state = 240},
  [2131] = {.lex_state = 240},
  [2132] = {.lex_state = 240},
  [2133] = {.lex_state = 240},
  [2134] = {.lex_state = 240},
  [2135] = {.lex_state = 242},
  [2136] = {.lex_state = 210},
  [2137] = {.lex_state = 240},
  [2138] = {.lex_state = 240},
  [2139] = {.lex_state = 240},
  [2140] = {.lex_state = 240},
  [2141] = {.lex_state = 210},
  [2142] = {.lex_state = 210},
  [2143] = {.lex_state = 210},
  [2144] = {.lex_state = 210},
  [2145] = {.lex_state = 210},
  [2146] = {.lex_state = 240},
  [2147] = {.lex_state = 210},
  [2148] = {.lex_state = 210},
  [2149] = {.lex_state = 240},
  [2150] = {.lex_state = 242},
  [2151] = {.lex_state = 210},
  [2152] = {.lex_state = 210},
  [2153] = {.lex_state = 240},
  [2154] = {.lex_state = 240},
  [2155] = {.lex_state = 240},
  [2156] = {.lex_state = 210},
  [2157] = {.lex_state = 210},
  [2158] = {.lex_state = 210},
  [2159] = {.lex_state = 210},
  [2160] = {.lex_state = 210},
  [2161] = {.lex_state = 210},
  [2162] = {.lex_state = 210},
  [2163] = {.lex_state = 210},
  [2164] = {.lex_state = 240},
  [2165] = {.lex_state = 240},
  [2166] = {.lex_state = 210},
  [2167] = {.lex_state = 210},
  [2168] = {.lex_state = 210},
  [2169] = {.lex_state = 210},
  [2170] = {.lex_state = 210},
  [2171] = {.lex_state = 210},
  [2172] = {.lex_state = 210},
  [2173] = {.lex_state = 242},
  [2174] = {.lex_state = 210},
  [2175] = {.lex_state = 210},
  [2176] = {.lex_state = 210},
  [2177] = {.lex_state = 240},
  [2178] = {.lex_state = 240},
  [2179] = {.lex_state = 210},
  [2180] = {.lex_state = 210},
  [2181] = {.lex_state = 210},
  [2182] = {.lex_state = 210},
  [2183] = {.lex_state = 210},
  [2184] = {.lex_state = 210},
  [2185] = {.lex_state = 210},
  [2186] = {.lex_state = 210},
  [2187] = {.lex_state = 210},
  [2188] = {.lex_state = 210},
  [2189] = {.lex_state = 240},
  [2190] = {.lex_state = 240},
  [2191] = {.lex_state = 210},
  [2192] = {.lex_state = 210},
  [2193] = {.lex_state = 210},
  [2194] = {.lex_state = 210},
  [2195] = {.lex_state = 210},
  [2196] = {.lex_state = 210},
  [2197] = {.lex_state = 240},
  [2198] = {.lex_state = 210},
  [2199] = {.lex_state = 210},
  [2200] = {.lex_state = 210},
  [2201] = {.lex_state = 210},
  [2202] = {.lex_state = 240},
  [2203] = {.lex_state = 240},
  [2204] = {.lex_state = 210},
  [2205] = {.lex_state = 210},
  [2206] = {.lex_state = 210},
  [2207] = {.lex_state = 210},
  [2208] = {.lex_state = 210},
  [2209] = {.lex_state = 210},
  [2210] = {.lex_state = 210},
  [2211] = {.lex_state = 210},
  [2212] = {.lex_state = 210},
  [2213] = {.lex_state = 210},
  [2214] = {.lex_state = 210},
  [2215] = {.lex_state = 240},
  [2216] = {.lex_state = 240},
  [2217] = {.lex_state = 240},
  [2218] = {.lex_state = 210},
  [2219] = {.lex_state = 240},
  [2220] = {.lex_state = 240},
  [2221] = {.lex_state = 240},
  [2222] = {.lex_state = 240},
  [2223] = {.lex_state = 240},
  [2224] = {.lex_state = 240},
  [2225] = {.lex_state = 240},
  [2226] = {.lex_state = 240},
  [2227] = {.lex_state = 240},
  [2228] = {.lex_state = 240},
  [2229] = {.lex_state = 240},
  [2230] = {.lex_state = 210},
  [2231] = {.lex_state = 210},
  [2232] = {.lex_state = 210},
  [2233] = {.lex_state = 210},
  [2234] = {.lex_state = 210},
  [2235] = {.lex_state = 210},
  [2236] = {.lex_state = 210},
  [2237] = {.lex_state = 210},
  [2238] = {.lex_state = 210},
  [2239] = {.lex_state = 210},
  [2240] = {.lex_state = 210},
  [2241] = {.lex_state = 210},
  [2242] = {.lex_state = 242},
  [2243] = {.lex_state = 240},
  [2244] = {.lex_state = 210},
  [2245] = {.lex_state = 242},
  [2246] = {.lex_state = 210},
  [2247] = {.lex_state = 240},
  [2248] = {.lex_state = 240},
  [2249] = {.lex_state = 240},
  [2250] = {.lex_state = 210},
  [2251] = {.lex_state = 240},
  [2252] = {.lex_state = 210},
  [2253] = {.lex_state = 210},
  [2254] = {.lex_state = 210},
  [2255] = {.lex_state = 210},
  [2256] = {.lex_state = 210},
  [2257] = {.lex_state = 210},
  [2258] = {.lex_state = 187},
  [2259] = {.lex_state = 241},
  [2260] = {.lex_state = 241},
  [2261] = {.lex_state = 200},
  [2262] = {.lex_state = 241},
  [2263] = {.lex_state = 242},
  [2264] = {.lex_state = 241},
  [2265] = {.lex_state = 242},
  [2266] = {.lex_state = 242},
  [2267] = {.lex_state = 242},
  [2268] = {.lex_state = 241},
  [2269] = {.lex_state = 191},
  [2270] = {.lex_state = 242},
  [2271] = {.lex_state = 242},
  [2272] = {.lex_state = 242},
  [2273] = {.lex_state = 242},
  [2274] = {.lex_state = 242},
  [2275] = {.lex_state = 242},
  [2276] = {.lex_state = 242},
  [2277] = {.lex_state = 242},
  [2278] = {.lex_state = 242},
  [2279] = {.lex_state = 242},
  [2280] = {.lex_state = 242},
  [2281] = {.lex_state = 242},
  [2282] = {.lex_state = 242},
  [2283] = {.lex_state = 242},
  [2284] = {.lex_state = 241},
  [2285] = {.lex_state = 242},
  [2286] = {.lex_state = 242},
  [2287] = {.lex_state = 241},
  [2288] = {.lex_state = 181},
  [2289] = {.lex_state = 241},
  [2290] = {.lex_state = 200},
  [2291] = {.lex_state = 241},
  [2292] = {.lex_state = 200},
  [2293] = {.lex_state = 200},
  [2294] = {.lex_state = 241},
  [2295] = {.lex_state = 241},
  [2296] = {.lex_state = 241},
  [2297] = {.lex_state = 200},
  [2298] = {.lex_state = 200},
  [2299] = {.lex_state = 200},
  [2300] = {.lex_state = 241},
  [2301] = {.lex_state = 241},
  [2302] = {.lex_state = 242},
  [2303] = {.lex_state = 200},
  [2304] = {.lex_state = 241},
  [2305] = {.lex_state = 241},
  [2306] = {.lex_state = 198},
  [2307] = {.lex_state = 241},
  [2308] = {.lex_state = 198},
  [2309] = {.lex_state = 198},
  [2310] = {.lex_state = 241},
  [2311] = {.lex_state = 241},
  [2312] = {.lex_state = 198},
  [2313] = {.lex_state = 241},
  [2314] = {.lex_state = 241},
  [2315] = {.lex_state = 241},
  [2316] = {.lex_state = 241},
  [2317] = {.lex_state = 241},
  [2318] = {.lex_state = 198},
  [2319] = {.lex_state = 241},
  [2320] = {.lex_state = 241},
  [2321] = {.lex_state = 198},
  [2322] = {.lex_state = 241},
  [2323] = {.lex_state = 198},
  [2324] = {.lex_state = 241},
  [2325] = {.lex_state = 241},
  [2326] = {.lex_state = 241},
  [2327] = {.lex_state = 241},
  [2328] = {.lex_state = 241},
  [2329] = {.lex_state = 196},
  [2330] = {.lex_state = 215},
  [2331] = {.lex_state = 235},
  [2332] = {.lex_state = 196},
  [2333] = {.lex_state = 196},
  [2334] = {.lex_state = 196},
  [2335] = {.lex_state = 196},
  [2336] = {.lex_state = 200},
  [2337] = {.lex_state = 235},
  [2338] = {.lex_state = 235},
  [2339] = {.lex_state = 215},
  [2340] = {.lex_state = 235},
  [2341] = {.lex_state = 196},
  [2342] = {.lex_state = 196},
  [2343] = {.lex_state = 241},
  [2344] = {.lex_state = 200},
  [2345] = {.lex_state = 241},
  [2346] = {.lex_state = 241},
  [2347] = {.lex_state = 241},
  [2348] = {.lex_state = 241},
  [2349] = {.lex_state = 241},
  [2350] = {.lex_state = 241},
  [2351] = {.lex_state = 223},
  [2352] = {.lex_state = 241},
  [2353] = {.lex_state = 241},
  [2354] = {.lex_state = 241},
  [2355] = {.lex_state = 223},
  [2356] = {.lex_state = 241},
  [2357] = {.lex_state = 241},
  [2358] = {.lex_state = 241},
  [2359] = {.lex_state = 241},
  [2360] = {.lex_state = 241},
  [2361] = {.lex_state = 241},
  [2362] = {.lex_state = 241},
  [2363] = {.lex_state = 241},
  [2364] = {.lex_state = 241},
  [2365] = {.lex_state = 241},
  [2366] = {.lex_state = 241},
  [2367] = {.lex_state = 241},
  [2368] = {.lex_state = 241},
  [2369] = {.lex_state = 241},
  [2370] = {.lex_state = 241},
  [2371] = {.lex_state = 241},
  [2372] = {.lex_state = 241},
  [2373] = {.lex_state = 241},
  [2374] = {.lex_state = 241},
  [2375] = {.lex_state = 241},
  [2376] = {.lex_state = 241},
  [2377] = {.lex_state = 241},
  [2378] = {.lex_state = 241},
  [2379] = {.lex_state = 241},
  [2380] = {.lex_state = 241},
  [2381] = {.lex_state = 241},
  [2382] = {.lex_state = 215},
  [2383] = {.lex_state = 241},
  [2384] = {.lex_state = 241},
  [2385] = {.lex_state = 241},
  [2386] = {.lex_state = 241},
  [2387] = {.lex_state = 241},
  [2388] = {.lex_state = 241},
  [2389] = {.lex_state = 196},
  [2390] = {.lex_state = 196},
  [2391] = {.lex_state = 223},
  [2392] = {.lex_state = 196},
  [2393] = {.lex_state = 196},
  [2394] = {.lex_state = 196},
  [2395] = {.lex_state = 196},
  [2396] = {.lex_state = 196},
  [2397] = {.lex_state = 196},
  [2398] = {.lex_state = 196},
  [2399] = {.lex_state = 196},
  [2400] = {.lex_state = 196},
  [2401] = {.lex_state = 196},
  [2402] = {.lex_state = 196},
  [2403] = {.lex_state = 196},
  [2404] = {.lex_state = 241},
  [2405] = {.lex_state = 241},
  [2406] = {.lex_state = 241},
  [2407] = {.lex_state = 241},
  [2408] = {.lex_state = 241},
  [2409] = {.lex_state = 215},
  [2410] = {.lex_state = 215},
  [2411] = {.lex_state = 241},
  [2412] = {.lex_state = 241},
  [2413] = {.lex_state = 241},
  [2414] = {.lex_state = 241},
  [2415] = {.lex_state = 241},
  [2416] = {.lex_state = 241},
  [2417] = {.lex_state = 241},
  [2418] = {.lex_state = 241},
  [2419] = {.lex_state = 241},
  [2420] = {.lex_state = 215},
  [2421] = {.lex_state = 215},
  [2422] = {.lex_state = 241},
  [2423] = {.lex_state = 215},
  [2424] = {.lex_state = 223},
  [2425] = {.lex_state = 223},
  [2426] = {.lex_state = 241},
  [2427] = {.lex_state = 215},
  [2428] = {.lex_state = 241},
  [2429] = {.lex_state = 241},
  [2430] = {.lex_state = 241},
  [2431] = {.lex_state = 241},
  [2432] = {.lex_state = 241},
  [2433] = {.lex_state = 215},
  [2434] = {.lex_state = 241},
  [2435] = {.lex_state = 206},
  [2436] = {.lex_state = 242},
  [2437] = {.lex_state = 175},
  [2438] = {.lex_state = 242},
  [2439] = {.lex_state = 242},
  [2440] = {.lex_state = 242},
  [2441] = {.lex_state = 241},
  [2442] = {.lex_state = 242},
  [2443] = {.lex_state = 242},
  [2444] = {.lex_state = 242},
  [2445] = {.lex_state = 196},
  [2446] = {.lex_state = 223},
  [2447] = {.lex_state = 175},
  [2448] = {.lex_state = 196},
  [2449] = {.lex_state = 241},
  [2450] = {.lex_state = 223},
  [2451] = {.lex_state = 242},
  [2452] = {.lex_state = 242},
  [2453] = {.lex_state = 242},
  [2454] = {.lex_state = 242},
  [2455] = {.lex_state = 242},
  [2456] = {.lex_state = 242},
  [2457] = {.lex_state = 242},
  [2458] = {.lex_state = 242},
  [2459] = {.lex_state = 242},
  [2460] = {.lex_state = 242},
  [2461] = {.lex_state = 242},
  [2462] = {.lex_state = 212},
  [2463] = {.lex_state = 242},
  [2464] = {.lex_state = 206},
  [2465] = {.lex_state = 212},
  [2466] = {.lex_state = 212},
  [2467] = {.lex_state = 241},
  [2468] = {.lex_state = 212},
  [2469] = {.lex_state = 181},
  [2470] = {.lex_state = 242},
  [2471] = {.lex_state = 242},
  [2472] = {.lex_state = 196},
  [2473] = {.lex_state = 242},
  [2474] = {.lex_state = 212},
  [2475] = {.lex_state = 212},
  [2476] = {.lex_state = 242},
  [2477] = {.lex_state = 242},
  [2478] = {.lex_state = 242},
  [2479] = {.lex_state = 241},
  [2480] = {.lex_state = 212},
  [2481] = {.lex_state = 215},
  [2482] = {.lex_state = 243},
  [2483] = {.lex_state = 215},
  [2484] = {.lex_state = 241},
  [2485] = {.lex_state = 219},
  [2486] = {.lex_state = 206},
  [2487] = {.lex_state = 183},
  [2488] = {.lex_state = 219},
  [2489] = {.lex_state = 215},
  [2490] = {.lex_state = 206},
  [2491] = {.lex_state = 183},
  [2492] = {.lex_state = 215},
  [2493] = {.lex_state = 219},
  [2494] = {.lex_state = 219},
  [2495] = {.lex_state = 241},
  [2496] = {.lex_state = 241},
  [2497] = {.lex_state = 219},
  [2498] = {.lex_state = 183},
  [2499] = {.lex_state = 219},
  [2500] = {.lex_state = 219},
  [2501] = {.lex_state = 242},
  [2502] = {.lex_state = 241},
  [2503] = {.lex_state = 241},
  [2504] = {.lex_state = 241},
  [2505] = {.lex_state = 241},
  [2506] = {.lex_state = 241},
  [2507] = {.lex_state = 228},
  [2508] = {.lex_state = 241},
  [2509] = {.lex_state = 241},
  [2510] = {.lex_state = 241},
  [2511] = {.lex_state = 178},
  [2512] = {.lex_state = 211},
  [2513] = {.lex_state = 211},
  [2514] = {.lex_state = 241},
  [2515] = {.lex_state = 206},
  [2516] = {.lex_state = 196},
  [2517] = {.lex_state = 183},
  [2518] = {.lex_state = 228},
  [2519] = {.lex_state = 228},
  [2520] = {.lex_state = 228},
  [2521] = {.lex_state = 228},
  [2522] = {.lex_state = 242},
  [2523] = {.lex_state = 228},
  [2524] = {.lex_state = 228},
  [2525] = {.lex_state = 228},
  [2526] = {.lex_state = 228},
  [2527] = {.lex_state = 196},
  [2528] = {.lex_state = 196},
  [2529] = {.lex_state = 241},
  [2530] = {.lex_state = 228},
  [2531] = {.lex_state = 183},
  [2532] = {.lex_state = 183},
  [2533] = {.lex_state = 228},
  [2534] = {.lex_state = 183},
  [2535] = {.lex_state = 228},
  [2536] = {.lex_state = 212},
  [2537] = {.lex_state = 228},
  [2538] = {.lex_state = 228},
  [2539] = {.lex_state = 201},
  [2540] = {.lex_state = 206},
  [2541] = {.lex_state = 244},
  [2542] = {.lex_state = 206},
  [2543] = {.lex_state = 206},
  [2544] = {.lex_state = 206},
  [2545] = {.lex_state = 206},
  [2546] = {.lex_state = 206},
  [2547] = {.lex_state = 206},
  [2548] = {.lex_state = 206},
  [2549] = {.lex_state = 206},
  [2550] = {.lex_state = 206},
  [2551] = {.lex_state = 206},
  [2552] = {.lex_state = 206},
  [2553] = {.lex_state = 206},
  [2554] = {.lex_state = 181},
  [2555] = {.lex_state = 206},
  [2556] = {.lex_state = 206},
  [2557] = {.lex_state = 206},
  [2558] = {.lex_state = 242},
  [2559] = {.lex_state = 206},
  [2560] = {.lex_state = 206},
  [2561] = {.lex_state = 206},
  [2562] = {.lex_state = 206},
  [2563] = {.lex_state = 206},
  [2564] = {.lex_state = 206},
  [2565] = {.lex_state = 206},
  [2566] = {.lex_state = 206},
  [2567] = {.lex_state = 206},
  [2568] = {.lex_state = 243},
  [2569] = {.lex_state = 206},
  [2570] = {.lex_state = 206},
  [2571] = {.lex_state = 219},
  [2572] = {.lex_state = 178},
  [2573] = {.lex_state = 206},
  [2574] = {.lex_state = 212},
  [2575] = {.lex_state = 206},
  [2576] = {.lex_state = 178},
  [2577] = {.lex_state = 206},
  [2578] = {.lex_state = 206},
  [2579] = {.lex_state = 206},
  [2580] = {.lex_state = 206},
  [2581] = {.lex_state = 206},
  [2582] = {.lex_state = 206},
  [2583] = {.lex_state = 206},
  [2584] = {.lex_state = 244},
  [2585] = {.lex_state = 206},
  [2586] = {.lex_state = 206},
  [2587] = {.lex_state = 206},
  [2588] = {.lex_state = 206},
  [2589] = {.lex_state = 206},
  [2590] = {.lex_state = 206},
  [2591] = {.lex_state = 241},
  [2592] = {.lex_state = 241},
  [2593] = {.lex_state = 206},
  [2594] = {.lex_state = 207},
  [2595] = {.lex_state = 198},
  [2596] = {.lex_state = 201},
  [2597] = {.lex_state = 201},
  [2598] = {.lex_state = 242},
  [2599] = {.lex_state = 242},
  [2600] = {.lex_state = 201},
  [2601] = {.lex_state = 201},
  [2602] = {.lex_state = 198},
  [2603] = {.lex_state = 219},
  [2604] = {.lex_state = 198},
  [2605] = {.lex_state = 198},
  [2606] = {.lex_state = 244},
  [2607] = {.lex_state = 207},
  [2608] = {.lex_state = 207},
  [2609] = {.lex_state = 207},
  [2610] = {.lex_state = 207},
  [2611] = {.lex_state = 207},
  [2612] = {.lex_state = 207},
  [2613] = {.lex_state = 207},
  [2614] = {.lex_state = 198},
  [2615] = {.lex_state = 244},
  [2616] = {.lex_state = 207},
  [2617] = {.lex_state = 207},
  [2618] = {.lex_state = 198},
  [2619] = {.lex_state = 198},
  [2620] = {.lex_state = 198},
  [2621] = {.lex_state = 207},
  [2622] = {.lex_state = 207},
  [2623] = {.lex_state = 244},
  [2624] = {.lex_state = 198},
  [2625] = {.lex_state = 207},
  [2626] = {.lex_state = 244},
  [2627] = {.lex_state = 183},
  [2628] = {.lex_state = 207},
  [2629] = {.lex_state = 201},
  [2630] = {.lex_state = 183},
  [2631] = {.lex_state = 181},
  [2632] = {.lex_state = 198},
  [2633] = {.lex_state = 206},
  [2634] = {.lex_state = 181},
  [2635] = {.lex_state = 190},
  [2636] = {.lex_state = 231},
  [2637] = {.lex_state = 183},
  [2638] = {.lex_state = 201},
  [2639] = {.lex_state = 207},
  [2640] = {.lex_state = 201},
  [2641] = {.lex_state = 190},
  [2642] = {.lex_state = 181},
  [2643] = {.lex_state = 186},
  [2644] = {.lex_state = 186},
  [2645] = {.lex_state = 183},
  [2646] = {.lex_state = 190},
  [2647] = {.lex_state = 241},
  [2648] = {.lex_state = 181},
  [2649] = {.lex_state = 183},
  [2650] = {.lex_state = 206},
  [2651] = {.lex_state = 189},
  [2652] = {.lex_state = 201},
  [2653] = {.lex_state = 242},
  [2654] = {.lex_state = 231},
  [2655] = {.lex_state = 199},
  [2656] = {.lex_state = 201},
  [2657] = {.lex_state = 198},
  [2658] = {.lex_state = 187},
  [2659] = {.lex_state = 181},
  [2660] = {.lex_state = 199},
  [2661] = {.lex_state = 231},
  [2662] = {.lex_state = 181},
  [2663] = {.lex_state = 181},
  [2664] = {.lex_state = 198},
  [2665] = {.lex_state = 181},
  [2666] = {.lex_state = 187},
  [2667] = {.lex_state = 199},
  [2668] = {.lex_state = 198},
  [2669] = {.lex_state = 201},
  [2670] = {.lex_state = 189},
  [2671] = {.lex_state = 199},
  [2672] = {.lex_state = 231},
  [2673] = {.lex_state = 242},
  [2674] = {.lex_state = 242},
  [2675] = {.lex_state = 242},
  [2676] = {.lex_state = 243},
  [2677] = {.lex_state = 201},
  [2678] = {.lex_state = 189},
  [2679] = {.lex_state = 243},
  [2680] = {.lex_state = 201},
  [2681] = {.lex_state = 201},
  [2682] = {.lex_state = 201},
  [2683] = {.lex_state = 242},
  [2684] = {.lex_state = 242},
  [2685] = {.lex_state = 199},
  [2686] = {.lex_state = 201},
  [2687] = {.lex_state = 231},
  [2688] = {.lex_state = 201},
  [2689] = {.lex_state = 201},
  [2690] = {.lex_state = 181},
  [2691] = {.lex_state = 201},
  [2692] = {.lex_state = 201},
  [2693] = {.lex_state = 198},
  [2694] = {.lex_state = 181},
  [2695] = {.lex_state = 181},
  [2696] = {.lex_state = 181},
  [2697] = {.lex_state = 201},
  [2698] = {.lex_state = 242},
  [2699] = {.lex_state = 201},
  [2700] = {.lex_state = 201},
  [2701] = {.lex_state = 201},
  [2702] = {.lex_state = 201},
  [2703] = {.lex_state = 201},
  [2704] = {.lex_state = 201},
  [2705] = {.lex_state = 199},
  [2706] = {.lex_state = 191},
  [2707] = {.lex_state = 231},
  [2708] = {.lex_state = 201},
  [2709] = {.lex_state = 201},
  [2710] = {.lex_state = 201},
  [2711] = {.lex_state = 232},
  [2712] = {.lex_state = 199},
  [2713] = {.lex_state = 232},
  [2714] = {.lex_state = 232},
  [2715] = {.lex_state = 201},
  [2716] = {.lex_state = 201},
  [2717] = {.lex_state = 183},
  [2718] = {.lex_state = 199},
  [2719] = {.lex_state = 201},
  [2720] = {.lex_state = 198},
  [2721] = {.lex_state = 232},
  [2722] = {.lex_state = 232},
  [2723] = {.lex_state = 201},
  [2724] = {.lex_state = 201},
  [2725] = {.lex_state = 201},
  [2726] = {.lex_state = 191},
  [2727] = {.lex_state = 201},
  [2728] = {.lex_state = 207},
  [2729] = {.lex_state = 201},
  [2730] = {.lex_state = 201},
  [2731] = {.lex_state = 181},
  [2732] = {.lex_state = 232},
  [2733] = {.lex_state = 232},
  [2734] = {.lex_state = 232},
  [2735] = {.lex_state = 232},
  [2736] = {.lex_state = 232},
  [2737] = {.lex_state = 201},
  [2738] = {.lex_state = 199},
  [2739] = {.lex_state = 201},
  [2740] = {.lex_state = 201},
  [2741] = {.lex_state = 198},
  [2742] = {.lex_state = 198},
  [2743] = {.lex_state = 232},
  [2744] = {.lex_state = 207},
  [2745] = {.lex_state = 198},
  [2746] = {.lex_state = 201},
  [2747] = {.lex_state = 201},
  [2748] = {.lex_state = 201},
  [2749] = {.lex_state = 201},
  [2750] = {.lex_state = 201},
  [2751] = {.lex_state = 199},
  [2752] = {.lex_state = 198},
  [2753] = {.lex_state = 183},
  [2754] = {.lex_state = 193},
  [2755] = {.lex_state = 201},
  [2756] = {.lex_state = 198},
  [2757] = {.lex_state = 201},
  [2758] = {.lex_state = 232},
  [2759] = {.lex_state = 232},
  [2760] = {.lex_state = 198},
  [2761] = {.lex_state = 198},
  [2762] = {.lex_state = 198},
  [2763] = {.lex_state = 181},
  [2764] = {.lex_state = 201},
  [2765] = {.lex_state = 183},
  [2766] = {.lex_state = 201},
  [2767] = {.lex_state = 201},
  [2768] = {.lex_state = 201},
  [2769] = {.lex_state = 198},
  [2770] = {.lex_state = 201},
  [2771] = {.lex_state = 201},
  [2772] = {.lex_state = 201},
  [2773] = {.lex_state = 198},
  [2774] = {.lex_state = 199},
  [2775] = {.lex_state = 201},
  [2776] = {.lex_state = 199},
  [2777] = {.lex_state = 199},
  [2778] = {.lex_state = 201},
  [2779] = {.lex_state = 193},
  [2780] = {.lex_state = 201},
  [2781] = {.lex_state = 181},
  [2782] = {.lex_state = 183},
  [2783] = {.lex_state = 201},
  [2784] = {.lex_state = 199},
  [2785] = {.lex_state = 201},
  [2786] = {.lex_state = 199},
  [2787] = {.lex_state = 198},
  [2788] = {.lex_state = 199},
  [2789] = {.lex_state = 199},
  [2790] = {.lex_state = 201},
  [2791] = {.lex_state = 183},
  [2792] = {.lex_state = 198},
  [2793] = {.lex_state = 198},
  [2794] = {.lex_state = 201},
  [2795] = {.lex_state = 193},
  [2796] = {.lex_state = 199},
  [2797] = {.lex_state = 181},
  [2798] = {.lex_state = 201},
  [2799] = {.lex_state = 241},
  [2800] = {.lex_state = 198},
  [2801] = {.lex_state = 207},
  [2802] = {.lex_state = 201},
  [2803] = {.lex_state = 207},
  [2804] = {.lex_state = 201},
  [2805] = {.lex_state = 201},
  [2806] = {.lex_state = 183},
  [2807] = {.lex_state = 183},
  [2808] = {.lex_state = 207},
  [2809] = {.lex_state = 201},
  [2810] = {.lex_state = 244},
  [2811] = {.lex_state = 232},
  [2812] = {.lex_state = 196},
  [2813] = {.lex_state = 198},
  [2814] = {.lex_state = 207},
  [2815] = {.lex_state = 244},
  [2816] = {.lex_state = 196},
  [2817] = {.lex_state = 201},
  [2818] = {.lex_state = 201},
  [2819] = {.lex_state = 201},
  [2820] = {.lex_state = 201},
  [2821] = {.lex_state = 201},
  [2822] = {.lex_state = 207},
  [2823] = {.lex_state = 196},
  [2824] = {.lex_state = 207},
  [2825] = {.lex_state = 207},
  [2826] = {.lex_state = 198},
  [2827] = {.lex_state = 207},
  [2828] = {.lex_state = 207},
  [2829] = {.lex_state = 207},
  [2830] = {.lex_state = 189},
  [2831] = {.lex_state = 183},
  [2832] = {.lex_state = 201},
  [2833] = {.lex_state = 183},
  [2834] = {.lex_state = 201},
  [2835] = {.lex_state = 207},
  [2836] = {.lex_state = 201},
  [2837] = {.lex_state = 207},
  [2838] = {.lex_state = 201},
  [2839] = {.lex_state = 198},
  [2840] = {.lex_state = 201},
  [2841] = {.lex_state = 198},
  [2842] = {.lex_state = 201},
  [2843] = {.lex_state = 201},
  [2844] = {.lex_state = 204},
  [2845] = {.lex_state = 201},
  [2846] = {.lex_state = 199},
  [2847] = {.lex_state = 198},
  [2848] = {.lex_state = 201},
  [2849] = {.lex_state = 201},
  [2850] = {.lex_state = 231},
  [2851] = {.lex_state = 199},
  [2852] = {.lex_state = 201},
  [2853] = {.lex_state = 198},
  [2854] = {.lex_state = 198},
  [2855] = {.lex_state = 189},
  [2856] = {.lex_state = 213},
  [2857] = {.lex_state = 201},
  [2858] = {.lex_state = 183},
  [2859] = {.lex_state = 199},
  [2860] = {.lex_state = 201},
  [2861] = {.lex_state = 243},
  [2862] = {.lex_state = 201},
  [2863] = {.lex_state = 183},
  [2864] = {.lex_state = 198},
  [2865] = {.lex_state = 189},
  [2866] = {.lex_state = 243},
  [2867] = {.lex_state = 189},
  [2868] = {.lex_state = 199},
  [2869] = {.lex_state = 198},
  [2870] = {.lex_state = 198},
  [2871] = {.lex_state = 201},
  [2872] = {.lex_state = 198},
  [2873] = {.lex_state = 198},
  [2874] = {.lex_state = 199},
  [2875] = {.lex_state = 189},
  [2876] = {.lex_state = 183},
  [2877] = {.lex_state = 189},
  [2878] = {.lex_state = 196},
  [2879] = {.lex_state = 189},
  [2880] = {.lex_state = 212},
  [2881] = {.lex_state = 183},
  [2882] = {.lex_state = 193},
  [2883] = {.lex_state = 201},
  [2884] = {.lex_state = 189},
  [2885] = {.lex_state = 201},
  [2886] = {.lex_state = 201},
  [2887] = {.lex_state = 201},
  [2888] = {.lex_state = 201},
  [2889] = {.lex_state = 232},
  [2890] = {.lex_state = 201},
  [2891] = {.lex_state = 201},
  [2892] = {.lex_state = 189},
  [2893] = {.lex_state = 201},
  [2894] = {.lex_state = 201},
  [2895] = {.lex_state = 232},
  [2896] = {.lex_state = 201},
  [2897] = {.lex_state = 201},
  [2898] = {.lex_state = 201},
  [2899] = {.lex_state = 201},
  [2900] = {.lex_state = 201},
  [2901] = {.lex_state = 201},
  [2902] = {.lex_state = 201},
  [2903] = {.lex_state = 201},
  [2904] = {.lex_state = 201},
  [2905] = {.lex_state = 201},
  [2906] = {.lex_state = 201},
  [2907] = {.lex_state = 201},
  [2908] = {.lex_state = 201},
  [2909] = {.lex_state = 201},
  [2910] = {.lex_state = 219},
  [2911] = {.lex_state = 201},
  [2912] = {.lex_state = 201},
  [2913] = {.lex_state = 201},
  [2914] = {.lex_state = 201},
  [2915] = {.lex_state = 201},
  [2916] = {.lex_state = 201},
  [2917] = {.lex_state = 201},
  [2918] = {.lex_state = 201},
  [2919] = {.lex_state = 201},
  [2920] = {.lex_state = 201},
  [2921] = {.lex_state = 201},
  [2922] = {.lex_state = 201},
  [2923] = {.lex_state = 201},
  [2924] = {.lex_state = 201},
  [2925] = {.lex_state = 201},
  [2926] = {.lex_state = 201},
  [2927] = {.lex_state = 189},
  [2928] = {.lex_state = 201},
  [2929] = {.lex_state = 201},
  [2930] = {.lex_state = 201},
  [2931] = {.lex_state = 201},
  [2932] = {.lex_state = 193},
  [2933] = {.lex_state = 201},
  [2934] = {.lex_state = 201},
  [2935] = {.lex_state = 189},
  [2936] = {.lex_state = 201},
  [2937] = {.lex_state = 201},
  [2938] = {.lex_state = 193},
  [2939] = {.lex_state = 201},
  [2940] = {.lex_state = 201},
  [2941] = {.lex_state = 201},
  [2942] = {.lex_state = 193},
  [2943] = {.lex_state = 201},
  [2944] = {.lex_state = 201},
  [2945] = {.lex_state = 201},
  [2946] = {.lex_state = 201},
  [2947] = {.lex_state = 201},
  [2948] = {.lex_state = 201},
  [2949] = {.lex_state = 201},
  [2950] = {.lex_state = 201},
  [2951] = {.lex_state = 201},
  [2952] = {.lex_state = 201},
  [2953] = {.lex_state = 201},
  [2954] = {.lex_state = 189},
  [2955] = {.lex_state = 201},
  [2956] = {.lex_state = 220},
  [2957] = {.lex_state = 201},
  [2958] = {.lex_state = 201},
  [2959] = {.lex_state = 201},
  [2960] = {.lex_state = 201},
  [2961] = {.lex_state = 201},
  [2962] = {.lex_state = 244},
  [2963] = {.lex_state = 244},
  [2964] = {.lex_state = 201},
  [2965] = {.lex_state = 201},
  [2966] = {.lex_state = 201},
  [2967] = {.lex_state = 201},
  [2968] = {.lex_state = 201},
  [2969] = {.lex_state = 201},
  [2970] = {.lex_state = 201},
  [2971] = {.lex_state = 201},
  [2972] = {.lex_state = 201},
  [2973] = {.lex_state = 201},
  [2974] = {.lex_state = 201},
  [2975] = {.lex_state = 193},
  [2976] = {.lex_state = 232},
  [2977] = {.lex_state = 230},
  [2978] = {.lex_state = 230},
  [2979] = {.lex_state = 212},
  [2980] = {.lex_state = 232},
  [2981] = {.lex_state = 212},
  [2982] = {.lex_state = 232},
  [2983] = {.lex_state = 230},
  [2984] = {.lex_state = 232},
  [2985] = {.lex_state = 232},
  [2986] = {.lex_state = 212},
  [2987] = {.lex_state = 212},
  [2988] = {.lex_state = 232},
  [2989] = {.lex_state = 212},
  [2990] = {.lex_state = 232},
  [2991] = {.lex_state = 230},
  [2992] = {.lex_state = 232},
  [2993] = {.lex_state = 232},
  [2994] = {.lex_state = 232},
  [2995] = {.lex_state = 212},
  [2996] = {.lex_state = 212},
  [2997] = {.lex_state = 230},
  [2998] = {.lex_state = 230},
  [2999] = {.lex_state = 193},
  [3000] = {.lex_state = 230},
  [3001] = {.lex_state = 230},
  [3002] = {.lex_state = 230},
  [3003] = {.lex_state = 193},
  [3004] = {.lex_state = 232},
  [3005] = {.lex_state = 230},
  [3006] = {.lex_state = 232},
  [3007] = {.lex_state = 212},
  [3008] = {.lex_state = 230},
  [3009] = {.lex_state = 212},
  [3010] = {.lex_state = 212},
  [3011] = {.lex_state = 212},
  [3012] = {.lex_state = 212},
  [3013] = {.lex_state = 212},
  [3014] = {.lex_state = 230},
  [3015] = {.lex_state = 212},
  [3016] = {.lex_state = 193},
  [3017] = {.lex_state = 230},
  [3018] = {.lex_state = 189},
  [3019] = {.lex_state = 193},
  [3020] = {.lex_state = 212},
  [3021] = {.lex_state = 230},
  [3022] = {.lex_state = 232},
  [3023] = {.lex_state = 232},
  [3024] = {.lex_state = 219},
  [3025] = {.lex_state = 219},
  [3026] = {.lex_state = 219},
  [3027] = {.lex_state = 219},
  [3028] = {.lex_state = 232},
  [3029] = {.lex_state = 213},
  [3030] = {.lex_state = 178},
  [3031] = {.lex_state = 244},
  [3032] = {.lex_state = 178},
  [3033] = {.lex_state = 232},
  [3034] = {.lex_state = 232},
  [3035] = {.lex_state = 185},
  [3036] = {.lex_state = 232},
  [3037] = {.lex_state = 244},
  [3038] = {.lex_state = 232},
  [3039] = {.lex_state = 232},
  [3040] = {.lex_state = 213},
  [3041] = {.lex_state = 232},
  [3042] = {.lex_state = 185},
  [3043] = {.lex_state = 189},
  [3044] = {.lex_state = 189},
  [3045] = {.lex_state = 232},
  [3046] = {.lex_state = 232},
  [3047] = {.lex_state = 219},
  [3048] = {.lex_state = 212},
  [3049] = {.lex_state = 189},
  [3050] = {.lex_state = 232},
  [3051] = {.lex_state = 232},
  [3052] = {.lex_state = 232},
  [3053] = {.lex_state = 219},
  [3054] = {.lex_state = 232},
  [3055] = {.lex_state = 189},
  [3056] = {.lex_state = 232},
  [3057] = {.lex_state = 232},
  [3058] = {.lex_state = 232},
  [3059] = {.lex_state = 244},
  [3060] = {.lex_state = 232},
  [3061] = {.lex_state = 232},
  [3062] = {.lex_state = 244},
  [3063] = {.lex_state = 232},
  [3064] = {.lex_state = 212},
  [3065] = {.lex_state = 232},
  [3066] = {.lex_state = 232},
  [3067] = {.lex_state = 232},
  [3068] = {.lex_state = 219},
  [3069] = {.lex_state = 232},
  [3070] = {.lex_state = 232},
  [3071] = {.lex_state = 232},
  [3072] = {.lex_state = 232},
  [3073] = {.lex_state = 213},
  [3074] = {.lex_state = 219},
  [3075] = {.lex_state = 219},
  [3076] = {.lex_state = 232},
  [3077] = {.lex_state = 219},
  [3078] = {.lex_state = 219},
  [3079] = {.lex_state = 219},
  [3080] = {.lex_state = 219},
  [3081] = {.lex_state = 219},
  [3082] = {.lex_state = 232},
  [3083] = {.lex_state = 232},
  [3084] = {.lex_state = 232},
  [3085] = {.lex_state = 232},
  [3086] = {.lex_state = 185},
  [3087] = {.lex_state = 232},
  [3088] = {.lex_state = 212},
  [3089] = {.lex_state = 232},
  [3090] = {.lex_state = 232},
  [3091] = {.lex_state = 232},
  [3092] = {.lex_state = 212},
  [3093] = {.lex_state = 232},
  [3094] = {.lex_state = 212},
  [3095] = {.lex_state = 232},
  [3096] = {.lex_state = 232},
  [3097] = {.lex_state = 212},
  [3098] = {.lex_state = 232},
  [3099] = {.lex_state = 219},
  [3100] = {.lex_state = 189},
  [3101] = {.lex_state = 219},
  [3102] = {.lex_state = 220},
  [3103] = {.lex_state = 189},
  [3104] = {.lex_state = 212},
  [3105] = {.lex_state = 219},
  [3106] = {.lex_state = 219},
  [3107] = {.lex_state = 219},
  [3108] = {.lex_state = 213},
  [3109] = {.lex_state = 220},
  [3110] = {.lex_state = 189},
  [3111] = {.lex_state = 189},
  [3112] = {.lex_state = 219},
  [3113] = {.lex_state = 212},
  [3114] = {.lex_state = 178},
  [3115] = {.lex_state = 212},
  [3116] = {.lex_state = 178},
  [3117] = {.lex_state = 178},
  [3118] = {.lex_state = 178},
  [3119] = {.lex_state = 178},
  [3120] = {.lex_state = 212},
  [3121] = {.lex_state = 243},
  [3122] = {.lex_state = 212},
  [3123] = {.lex_state = 212},
  [3124] = {.lex_state = 178},
  [3125] = {.lex_state = 212},
  [3126] = {.lex_state = 178},
  [3127] = {.lex_state = 178},
  [3128] = {.lex_state = 243},
  [3129] = {.lex_state = 178},
  [3130] = {.lex_state = 219},
  [3131] = {.lex_state = 212},
  [3132] = {.lex_state = 212},
  [3133] = {.lex_state = 178},
  [3134] = {.lex_state = 212},
  [3135] = {.lex_state = 178},
  [3136] = {.lex_state = 178},
  [3137] = {.lex_state = 212},
  [3138] = {.lex_state = 178},
  [3139] = {.lex_state = 212},
  [3140] = {.lex_state = 212},
  [3141] = {.lex_state = 212},
  [3142] = {.lex_state = 212},
  [3143] = {.lex_state = 212},
  [3144] = {.lex_state = 178},
  [3145] = {.lex_state = 178},
  [3146] = {.lex_state = 220},
  [3147] = {.lex_state = 178},
  [3148] = {.lex_state = 178},
  [3149] = {.lex_state = 178},
  [3150] = {.lex_state = 212},
  [3151] = {.lex_state = 212},
  [3152] = {.lex_state = 212},
  [3153] = {.lex_state = 212},
  [3154] = {.lex_state = 212},
  [3155] = {.lex_state = 178},
  [3156] = {.lex_state = 178},
  [3157] = {.lex_state = 212},
  [3158] = {.lex_state = 198},
  [3159] = {.lex_state = 219},
  [3160] = {.lex_state = 198},
  [3161] = {.lex_state = 185},
  [3162] = {.lex_state = 229},
  [3163] = {.lex_state = 198},
  [3164] = {.lex_state = 199},
  [3165] = {.lex_state = 212},
  [3166] = {.lex_state = 212},
  [3167] = {.lex_state = 198},
  [3168] = {.lex_state = 199},
  [3169] = {.lex_state = 199},
  [3170] = {.lex_state = 198},
  [3171] = {.lex_state = 199},
  [3172] = {.lex_state = 212},
  [3173] = {.lex_state = 198},
  [3174] = {.lex_state = 198},
  [3175] = {.lex_state = 212},
  [3176] = {.lex_state = 199},
  [3177] = {.lex_state = 199},
  [3178] = {.lex_state = 198},
  [3179] = {.lex_state = 212},
  [3180] = {.lex_state = 213},
  [3181] = {.lex_state = 212},
  [3182] = {.lex_state = 212},
  [3183] = {.lex_state = 212},
  [3184] = {.lex_state = 212},
  [3185] = {.lex_state = 199},
  [3186] = {.lex_state = 185},
  [3187] = {.lex_state = 219},
  [3188] = {.lex_state = 212},
  [3189] = {.lex_state = 212},
  [3190] = {.lex_state = 212},
  [3191] = {.lex_state = 185},
  [3192] = {.lex_state = 212},
  [3193] = {.lex_state = 198},
  [3194] = {.lex_state = 198},
  [3195] = {.lex_state = 198},
  [3196] = {.lex_state = 212},
  [3197] = {.lex_state = 198},
  [3198] = {.lex_state = 219},
  [3199] = {.lex_state = 229},
  [3200] = {.lex_state = 212},
  [3201] = {.lex_state = 213},
  [3202] = {.lex_state = 219},
  [3203] = {.lex_state = 219},
  [3204] = {.lex_state = 212},
  [3205] = {.lex_state = 198},
  [3206] = {.lex_state = 198},
  [3207] = {.lex_state = 212},
  [3208] = {.lex_state = 198},
  [3209] = {.lex_state = 229},
  [3210] = {.lex_state = 212},
  [3211] = {.lex_state = 212},
  [3212] = {.lex_state = 212},
  [3213] = {.lex_state = 212},
  [3214] = {.lex_state = 219},
  [3215] = {.lex_state = 198},
  [3216] = {.lex_state = 212},
  [3217] = {.lex_state = 198},
  [3218] = {.lex_state = 185},
  [3219] = {.lex_state = 212},
  [3220] = {.lex_state = 212},
  [3221] = {.lex_state = 198},
  [3222] = {.lex_state = 219},
  [3223] = {.lex_state = 219},
  [3224] = {.lex_state = 212},
  [3225] = {.lex_state = 212},
  [3226] = {.lex_state = 212},
  [3227] = {.lex_state = 219},
  [3228] = {.lex_state = 219},
  [3229] = {.lex_state = 202},
  [3230] = {.lex_state = 244},
  [3231] = {.lex_state = 243},
  [3232] = {.lex_state = 212},
  [3233] = {.lex_state = 219},
  [3234] = {.lex_state = 212},
  [3235] = {.lex_state = 244},
  [3236] = {.lex_state = 212},
  [3237] = {.lex_state = 219},
  [3238] = {.lex_state = 219},
  [3239] = {.lex_state = 212},
  [3240] = {.lex_state = 243},
  [3241] = {.lex_state = 219},
  [3242] = {.lex_state = 213},
  [3243] = {.lex_state = 219},
  [3244] = {.lex_state = 197},
  [3245] = {.lex_state = 219},
  [3246] = {.lex_state = 219},
  [3247] = {.lex_state = 219},
  [3248] = {.lex_state = 202},
  [3249] = {.lex_state = 219},
  [3250] = {.lex_state = 198},
  [3251] = {.lex_state = 198},
  [3252] = {.lex_state = 219},
  [3253] = {.lex_state = 243},
  [3254] = {.lex_state = 243},
  [3255] = {.lex_state = 243},
  [3256] = {.lex_state = 198},
  [3257] = {.lex_state = 244},
  [3258] = {.lex_state = 244},
  [3259] = {.lex_state = 211},
  [3260] = {.lex_state = 244},
  [3261] = {.lex_state = 244},
  [3262] = {.lex_state = 244},
  [3263] = {.lex_state = 178},
  [3264] = {.lex_state = 198},
  [3265] = {.lex_state = 211},
  [3266] = {.lex_state = 219},
  [3267] = {.lex_state = 244},
  [3268] = {.lex_state = 178},
  [3269] = {.lex_state = 212},
  [3270] = {.lex_state = 212},
  [3271] = {.lex_state = 212},
  [3272] = {.lex_state = 244},
  [3273] = {.lex_state = 244},
  [3274] = {.lex_state = 244},
  [3275] = {.lex_state = 198},
  [3276] = {.lex_state = 198},
  [3277] = {.lex_state = 244},
  [3278] = {.lex_state = 198},
  [3279] = {.lex_state = 244},
  [3280] = {.lex_state = 198},
  [3281] = {.lex_state = 198},
  [3282] = {.lex_state = 198},
  [3283] = {.lex_state = 244},
  [3284] = {.lex_state = 212},
  [3285] = {.lex_state = 212},
  [3286] = {.lex_state = 244},
  [3287] = {.lex_state = 198},
  [3288] = {.lex_state = 211},
  [3289] = {.lex_state = 212},
  [3290] = {.lex_state = 230},
  [3291] = {.lex_state = 198},
  [3292] = {.lex_state = 198},
  [3293] = {.lex_state = 212},
  [3294] = {.lex_state = 219},
  [3295] = {.lex_state = 244},
  [3296] = {.lex_state = 211},
  [3297] = {.lex_state = 212},
  [3298] = {.lex_state = 243},
  [3299] = {.lex_state = 244},
  [3300] = {.lex_state = 244},
  [3301] = {.lex_state = 244},
  [3302] = {.lex_state = 198},
  [3303] = {.lex_state = 212},
  [3304] = {.lex_state = 202},
  [3305] = {.lex_state = 211},
  [3306] = {.lex_state = 244},
  [3307] = {.lex_state = 244},
  [3308] = {.lex_state = 198},
  [3309] = {.lex_state = 211},
  [3310] = {.lex_state = 244},
  [3311] = {.lex_state = 244},
  [3312] = {.lex_state = 219},
  [3313] = {.lex_state = 202},
  [3314] = {.lex_state = 219},
  [3315] = {.lex_state = 198},
  [3316] = {.lex_state = 244},
  [3317] = {.lex_state = 197},
  [3318] = {.lex_state = 212},
  [3319] = {.lex_state = 212},
  [3320] = {.lex_state = 244},
  [3321] = {.lex_state = 212},
  [3322] = {.lex_state = 244},
  [3323] = {.lex_state = 178},
  [3324] = {.lex_state = 178},
  [3325] = {.lex_state = 178},
  [3326] = {.lex_state = 198},
  [3327] = {.lex_state = 178},
  [3328] = {.lex_state = 198},
  [3329] = {.lex_state = 198},
  [3330] = {.lex_state = 198},
  [3331] = {.lex_state = 222},
  [3332] = {.lex_state = 212},
  [3333] = {.lex_state = 222},
  [3334] = {.lex_state = 212},
  [3335] = {.lex_state = 212},
  [3336] = {.lex_state = 212},
  [3337] = {.lex_state = 212},
  [3338] = {.lex_state = 212},
  [3339] = {.lex_state = 172},
  [3340] = {.lex_state = 212},
  [3341] = {.lex_state = 212},
  [3342] = {.lex_state = 212},
  [3343] = {.lex_state = 212},
  [3344] = {.lex_state = 212},
  [3345] = {.lex_state = 212},
  [3346] = {.lex_state = 212},
  [3347] = {.lex_state = 212},
  [3348] = {.lex_state = 219},
  [3349] = {.lex_state = 212},
  [3350] = {.lex_state = 185},
  [3351] = {.lex_state = 211},
  [3352] = {.lex_state = 212},
  [3353] = {.lex_state = 212},
  [3354] = {.lex_state = 198},
  [3355] = {.lex_state = 212},
  [3356] = {.lex_state = 196},
  [3357] = {.lex_state = 212},
  [3358] = {.lex_state = 198},
  [3359] = {.lex_state = 198},
  [3360] = {.lex_state = 198},
  [3361] = {.lex_state = 198},
  [3362] = {.lex_state = 219},
  [3363] = {.lex_state = 212},
  [3364] = {.lex_state = 212},
  [3365] = {.lex_state = 212},
  [3366] = {.lex_state = 241},
  [3367] = {.lex_state = 212},
  [3368] = {.lex_state = 172},
  [3369] = {.lex_state = 219},
  [3370] = {.lex_state = 205},
  [3371] = {.lex_state = 212},
  [3372] = {.lex_state = 198},
  [3373] = {.lex_state = 212},
  [3374] = {.lex_state = 212},
  [3375] = {.lex_state = 211},
  [3376] = {.lex_state = 196},
  [3377] = {.lex_state = 212},
  [3378] = {.lex_state = 212},
  [3379] = {.lex_state = 241},
  [3380] = {.lex_state = 212},
  [3381] = {.lex_state = 212},
  [3382] = {.lex_state = 212},
  [3383] = {.lex_state = 222},
  [3384] = {.lex_state = 198},
  [3385] = {.lex_state = 212},
  [3386] = {.lex_state = 212},
  [3387] = {.lex_state = 212},
  [3388] = {.lex_state = 212},
  [3389] = {.lex_state = 212},
  [3390] = {.lex_state = 212},
  [3391] = {.lex_state = 222},
  [3392] = {.lex_state = 198},
  [3393] = {.lex_state = 212},
  [3394] = {.lex_state = 212},
  [3395] = {.lex_state = 212},
  [3396] = {.lex_state = 212},
  [3397] = {.lex_state = 212},
  [3398] = {.lex_state = 172},
  [3399] = {.lex_state = 198},
  [3400] = {.lex_state = 212},
  [3401] = {.lex_state = 222},
  [3402] = {.lex_state = 212},
  [3403] = {.lex_state = 212},
  [3404] = {.lex_state = 211},
  [3405] = {.lex_state = 212},
  [3406] = {.lex_state = 172},
  [3407] = {.lex_state = 212},
  [3408] = {.lex_state = 198},
  [3409] = {.lex_state = 198},
  [3410] = {.lex_state = 198},
  [3411] = {.lex_state = 198},
  [3412] = {.lex_state = 198},
  [3413] = {.lex_state = 198},
  [3414] = {.lex_state = 198},
  [3415] = {.lex_state = 212},
  [3416] = {.lex_state = 212},
  [3417] = {.lex_state = 178},
  [3418] = {.lex_state = 172},
  [3419] = {.lex_state = 198},
  [3420] = {.lex_state = 212},
  [3421] = {.lex_state = 172},
  [3422] = {.lex_state = 219},
  [3423] = {.lex_state = 243},
  [3424] = {.lex_state = 219},
  [3425] = {.lex_state = 212},
  [3426] = {.lex_state = 185},
  [3427] = {.lex_state = 212},
  [3428] = {.lex_state = 222},
  [3429] = {.lex_state = 219},
  [3430] = {.lex_state = 219},
  [3431] = {.lex_state = 219},
  [3432] = {.lex_state = 219},
  [3433] = {.lex_state = 212},
  [3434] = {.lex_state = 219},
  [3435] = {.lex_state = 197},
  [3436] = {.lex_state = 212},
  [3437] = {.lex_state = 219},
  [3438] = {.lex_state = 219},
  [3439] = {.lex_state = 219},
  [3440] = {.lex_state = 212},
  [3441] = {.lex_state = 211},
  [3442] = {.lex_state = 212},
  [3443] = {.lex_state = 219},
  [3444] = {.lex_state = 212},
  [3445] = {.lex_state = 243},
  [3446] = {.lex_state = 212},
  [3447] = {.lex_state = 212},
  [3448] = {.lex_state = 243},
  [3449] = {.lex_state = 219},
  [3450] = {.lex_state = 243},
  [3451] = {.lex_state = 185},
  [3452] = {.lex_state = 214},
  [3453] = {.lex_state = 243},
  [3454] = {.lex_state = 221},
  [3455] = {.lex_state = 219},
  [3456] = {.lex_state = 219},
  [3457] = {.lex_state = 212},
  [3458] = {.lex_state = 219},
  [3459] = {.lex_state = 212},
  [3460] = {.lex_state = 219},
  [3461] = {.lex_state = 212},
  [3462] = {.lex_state = 212},
  [3463] = {.lex_state = 197},
  [3464] = {.lex_state = 212},
  [3465] = {.lex_state = 219},
  [3466] = {.lex_state = 219},
  [3467] = {.lex_state = 219},
  [3468] = {.lex_state = 212},
  [3469] = {.lex_state = 207},
  [3470] = {.lex_state = 219},
  [3471] = {.lex_state = 219},
  [3472] = {.lex_state = 212},
  [3473] = {.lex_state = 212},
  [3474] = {.lex_state = 202},
  [3475] = {.lex_state = 212},
  [3476] = {.lex_state = 241},
  [3477] = {.lex_state = 185},
  [3478] = {.lex_state = 219},
  [3479] = {.lex_state = 219},
  [3480] = {.lex_state = 219},
  [3481] = {.lex_state = 219},
  [3482] = {.lex_state = 219},
  [3483] = {.lex_state = 241},
  [3484] = {.lex_state = 202},
  [3485] = {.lex_state = 219},
  [3486] = {.lex_state = 219},
  [3487] = {.lex_state = 212},
  [3488] = {.lex_state = 219},
  [3489] = {.lex_state = 212},
  [3490] = {.lex_state = 212},
  [3491] = {.lex_state = 212},
  [3492] = {.lex_state = 219},
  [3493] = {.lex_state = 212},
  [3494] = {.lex_state = 212},
  [3495] = {.lex_state = 219},
  [3496] = {.lex_state = 219},
  [3497] = {.lex_state = 219},
  [3498] = {.lex_state = 205},
  [3499] = {.lex_state = 211},
  [3500] = {.lex_state = 185},
  [3501] = {.lex_state = 212},
  [3502] = {.lex_state = 212},
  [3503] = {.lex_state = 219},
  [3504] = {.lex_state = 198},
  [3505] = {.lex_state = 212},
  [3506] = {.lex_state = 212},
  [3507] = {.lex_state = 212},
  [3508] = {.lex_state = 212},
  [3509] = {.lex_state = 243},
  [3510] = {.lex_state = 212},
  [3511] = {.lex_state = 212},
  [3512] = {.lex_state = 212},
  [3513] = {.lex_state = 219},
  [3514] = {.lex_state = 219},
  [3515] = {.lex_state = 219},
  [3516] = {.lex_state = 212},
  [3517] = {.lex_state = 222},
  [3518] = {.lex_state = 212},
  [3519] = {.lex_state = 219},
  [3520] = {.lex_state = 201},
  [3521] = {.lex_state = 207},
  [3522] = {.lex_state = 198},
  [3523] = {.lex_state = 198},
  [3524] = {.lex_state = 207},
  [3525] = {.lex_state = 197},
  [3526] = {.lex_state = 219},
  [3527] = {.lex_state = 197},
  [3528] = {.lex_state = 197},
  [3529] = {.lex_state = 211},
  [3530] = {.lex_state = 205},
  [3531] = {.lex_state = 212},
  [3532] = {.lex_state = 207},
  [3533] = {.lex_state = 211},
  [3534] = {.lex_state = 212},
  [3535] = {.lex_state = 211},
  [3536] = {.lex_state = 211},
  [3537] = {.lex_state = 207},
  [3538] = {.lex_state = 198},
  [3539] = {.lex_state = 212},
  [3540] = {.lex_state = 207},
  [3541] = {.lex_state = 212},
  [3542] = {.lex_state = 207},
  [3543] = {.lex_state = 219},
  [3544] = {.lex_state = 207},
  [3545] = {.lex_state = 216},
  [3546] = {.lex_state = 207},
  [3547] = {.lex_state = 212},
  [3548] = {.lex_state = 207},
  [3549] = {.lex_state = 207},
  [3550] = {.lex_state = 198},
  [3551] = {.lex_state = 211},
  [3552] = {.lex_state = 219},
  [3553] = {.lex_state = 212},
  [3554] = {.lex_state = 212},
  [3555] = {.lex_state = 212},
  [3556] = {.lex_state = 211},
  [3557] = {.lex_state = 211},
  [3558] = {.lex_state = 212},
  [3559] = {.lex_state = 211},
  [3560] = {.lex_state = 212},
  [3561] = {.lex_state = 219},
  [3562] = {.lex_state = 219},
  [3563] = {.lex_state = 211},
  [3564] = {.lex_state = 212},
  [3565] = {.lex_state = 211},
  [3566] = {.lex_state = 219},
  [3567] = {.lex_state = 219},
  [3568] = {.lex_state = 211},
  [3569] = {.lex_state = 219},
  [3570] = {.lex_state = 219},
  [3571] = {.lex_state = 211},
  [3572] = {.lex_state = 211},
  [3573] = {.lex_state = 212},
  [3574] = {.lex_state = 212},
  [3575] = {.lex_state = 212},
  [3576] = {.lex_state = 211},
  [3577] = {.lex_state = 212},
  [3578] = {.lex_state = 211},
  [3579] = {.lex_state = 211},
  [3580] = {.lex_state = 211},
  [3581] = {.lex_state = 211},
  [3582] = {.lex_state = 211},
  [3583] = {.lex_state = 211},
  [3584] = {.lex_state = 211},
  [3585] = {.lex_state = 211},
  [3586] = {.lex_state = 219},
  [3587] = {.lex_state = 212},
  [3588] = {.lex_state = 211},
  [3589] = {.lex_state = 211},
  [3590] = {.lex_state = 219},
  [3591] = {.lex_state = 211},
  [3592] = {.lex_state = 197},
  [3593] = {.lex_state = 219},
  [3594] = {.lex_state = 219},
  [3595] = {.lex_state = 219},
  [3596] = {.lex_state = 219},
  [3597] = {.lex_state = 219},
  [3598] = {.lex_state = 219},
  [3599] = {.lex_state = 219},
  [3600] = {.lex_state = 219},
  [3601] = {.lex_state = 219},
  [3602] = {.lex_state = 219},
  [3603] = {.lex_state = 219},
  [3604] = {.lex_state = 219},
  [3605] = {.lex_state = 205},
  [3606] = {.lex_state = 211},
  [3607] = {.lex_state = 207},
  [3608] = {.lex_state = 207},
  [3609] = {.lex_state = 219},
  [3610] = {.lex_state = 207},
  [3611] = {.lex_state = 207},
  [3612] = {.lex_state = 212},
  [3613] = {.lex_state = 197},
  [3614] = {.lex_state = 219},
  [3615] = {.lex_state = 218},
  [3616] = {.lex_state = 219},
  [3617] = {.lex_state = 201},
  [3618] = {.lex_state = 201},
  [3619] = {.lex_state = 201},
  [3620] = {.lex_state = 201},
  [3621] = {.lex_state = 201},
  [3622] = {.lex_state = 201},
  [3623] = {.lex_state = 201},
  [3624] = {.lex_state = 201},
  [3625] = {.lex_state = 201},
  [3626] = {.lex_state = 201},
  [3627] = {.lex_state = 201},
  [3628] = {.lex_state = 201},
  [3629] = {.lex_state = 201},
  [3630] = {.lex_state = 201},
  [3631] = {.lex_state = 201},
  [3632] = {.lex_state = 201},
  [3633] = {.lex_state = 201},
  [3634] = {.lex_state = 201},
  [3635] = {.lex_state = 201},
  [3636] = {.lex_state = 201},
  [3637] = {.lex_state = 201},
  [3638] = {.lex_state = 201},
  [3639] = {.lex_state = 201},
  [3640] = {.lex_state = 219},
  [3641] = {.lex_state = 207},
  [3642] = {.lex_state = 207},
  [3643] = {.lex_state = 201},
  [3644] = {.lex_state = 219},
  [3645] = {.lex_state = 216},
  [3646] = {.lex_state = 211},
  [3647] = {.lex_state = 219},
  [3648] = {.lex_state = 207},
  [3649] = {.lex_state = 197},
  [3650] = {.lex_state = 211},
  [3651] = {.lex_state = 212},
  [3652] = {.lex_state = 212},
  [3653] = {.lex_state = 212},
  [3654] = {.lex_state = 212},
  [3655] = {.lex_state = 212},
  [3656] = {.lex_state = 198},
  [3657] = {.lex_state = 212},
  [3658] = {.lex_state = 212},
  [3659] = {.lex_state = 212},
  [3660] = {.lex_state = 212},
  [3661] = {.lex_state = 226},
  [3662] = {.lex_state = 212},
  [3663] = {.lex_state = 212},
  [3664] = {.lex_state = 212},
  [3665] = {.lex_state = 212},
  [3666] = {.lex_state = 212},
  [3667] = {.lex_state = 222},
  [3668] = {.lex_state = 224},
  [3669] = {.lex_state = 212},
  [3670] = {.lex_state = 212},
  [3671] = {.lex_state = 212},
  [3672] = {.lex_state = 212},
  [3673] = {.lex_state = 212},
  [3674] = {.lex_state = 212},
  [3675] = {.lex_state = 212},
  [3676] = {.lex_state = 212},
  [3677] = {.lex_state = 212},
  [3678] = {.lex_state = 212},
  [3679] = {.lex_state = 212},
  [3680] = {.lex_state = 222},
  [3681] = {.lex_state = 222},
  [3682] = {.lex_state = 222},
  [3683] = {.lex_state = 243},
  [3684] = {.lex_state = 185},
  [3685] = {.lex_state = 212},
  [3686] = {.lex_state = 185},
  [3687] = {.lex_state = 212},
  [3688] = {.lex_state = 196},
  [3689] = {.lex_state = 212},
  [3690] = {.lex_state = 212},
  [3691] = {.lex_state = 185},
  [3692] = {.lex_state = 212},
  [3693] = {.lex_state = 212},
  [3694] = {.lex_state = 212},
  [3695] = {.lex_state = 212},
  [3696] = {.lex_state = 212},
  [3697] = {.lex_state = 212},
  [3698] = {.lex_state = 212},
  [3699] = {.lex_state = 212},
  [3700] = {.lex_state = 212},
  [3701] = {.lex_state = 212},
  [3702] = {.lex_state = 212},
  [3703] = {.lex_state = 222},
  [3704] = {.lex_state = 205},
  [3705] = {.lex_state = 212},
  [3706] = {.lex_state = 212},
  [3707] = {.lex_state = 212},
  [3708] = {.lex_state = 195},
  [3709] = {.lex_state = 212},
  [3710] = {.lex_state = 195},
  [3711] = {.lex_state = 222},
  [3712] = {.lex_state = 212},
  [3713] = {.lex_state = 212},
  [3714] = {.lex_state = 212},
  [3715] = {.lex_state = 212},
  [3716] = {.lex_state = 212},
  [3717] = {.lex_state = 212},
  [3718] = {.lex_state = 212},
  [3719] = {.lex_state = 212},
  [3720] = {.lex_state = 222},
  [3721] = {.lex_state = 212},
  [3722] = {.lex_state = 212},
  [3723] = {.lex_state = 212},
  [3724] = {.lex_state = 212},
  [3725] = {.lex_state = 205},
  [3726] = {.lex_state = 212},
  [3727] = {.lex_state = 212},
  [3728] = {.lex_state = 196},
  [3729] = {.lex_state = 212},
  [3730] = {.lex_state = 212},
  [3731] = {.lex_state = 212},
  [3732] = {.lex_state = 219},
  [3733] = {.lex_state = 212},
  [3734] = {.lex_state = 212},
  [3735] = {.lex_state = 246},
  [3736] = {.lex_state = 207},
  [3737] = {.lex_state = 212},
  [3738] = {.lex_state = 222},
  [3739] = {.lex_state = 212},
  [3740] = {.lex_state = 222},
  [3741] = {.lex_state = 185},
  [3742] = {.lex_state = 185},
  [3743] = {.lex_state = 212},
  [3744] = {.lex_state = 212},
  [3745] = {.lex_state = 212},
  [3746] = {.lex_state = 205},
  [3747] = {.lex_state = 207},
  [3748] = {.lex_state = 207},
  [3749] = {.lex_state = 243},
  [3750] = {.lex_state = 212},
  [3751] = {.lex_state = 222},
  [3752] = {.lex_state = 212},
  [3753] = {.lex_state = 212},
  [3754] = {.lex_state = 207},
  [3755] = {.lex_state = 207},
  [3756] = {.lex_state = 212},
  [3757] = {.lex_state = 212},
  [3758] = {.lex_state = 222},
  [3759] = {.lex_state = 207},
  [3760] = {.lex_state = 207},
  [3761] = {.lex_state = 207},
  [3762] = {.lex_state = 207},
  [3763] = {.lex_state = 207},
  [3764] = {.lex_state = 212},
  [3765] = {.lex_state = 207},
  [3766] = {.lex_state = 207},
  [3767] = {.lex_state = 207},
  [3768] = {.lex_state = 212},
  [3769] = {.lex_state = 212},
  [3770] = {.lex_state = 212},
  [3771] = {.lex_state = 195},
  [3772] = {.lex_state = 222},
  [3773] = {.lex_state = 212},
  [3774] = {.lex_state = 212},
  [3775] = {.lex_state = 212},
  [3776] = {.lex_state = 212},
  [3777] = {.lex_state = 212},
  [3778] = {.lex_state = 212},
  [3779] = {.lex_state = 212},
  [3780] = {.lex_state = 222},
  [3781] = {.lex_state = 222},
  [3782] = {.lex_state = 219},
  [3783] = {.lex_state = 212},
  [3784] = {.lex_state = 212},
  [3785] = {.lex_state = 212},
  [3786] = {.lex_state = 212},
  [3787] = {.lex_state = 212},
  [3788] = {.lex_state = 212},
  [3789] = {.lex_state = 196},
  [3790] = {.lex_state = 212},
  [3791] = {.lex_state = 212},
  [3792] = {.lex_state = 212},
  [3793] = {.lex_state = 212},
  [3794] = {.lex_state = 212},
  [3795] = {.lex_state = 212},
  [3796] = {.lex_state = 212},
  [3797] = {.lex_state = 212},
  [3798] = {.lex_state = 222},
  [3799] = {.lex_state = 212},
  [3800] = {.lex_state = 224},
  [3801] = {.lex_state = 212},
  [3802] = {.lex_state = 212},
  [3803] = {.lex_state = 212},
  [3804] = {.lex_state = 212},
  [3805] = {.lex_state = 212},
  [3806] = {.lex_state = 212},
  [3807] = {.lex_state = 212},
  [3808] = {.lex_state = 212},
  [3809] = {.lex_state = 212},
  [3810] = {.lex_state = 212},
  [3811] = {.lex_state = 212},
  [3812] = {.lex_state = 212},
  [3813] = {.lex_state = 212},
  [3814] = {.lex_state = 212},
  [3815] = {.lex_state = 212},
  [3816] = {.lex_state = 222},
  [3817] = {.lex_state = 212},
  [3818] = {.lex_state = 212},
  [3819] = {.lex_state = 212},
  [3820] = {.lex_state = 212},
  [3821] = {.lex_state = 219},
  [3822] = {.lex_state = 212},
  [3823] = {.lex_state = 212},
  [3824] = {.lex_state = 219},
  [3825] = {.lex_state = 212},
  [3826] = {.lex_state = 219},
  [3827] = {.lex_state = 185},
  [3828] = {.lex_state = 185},
  [3829] = {.lex_state = 219},
  [3830] = {.lex_state = 212},
  [3831] = {.lex_state = 185},
  [3832] = {.lex_state = 219},
  [3833] = {.lex_state = 205},
  [3834] = {.lex_state = 198},
  [3835] = {.lex_state = 242},
  [3836] = {.lex_state = 219},
  [3837] = {.lex_state = 198},
  [3838] = {.lex_state = 219},
  [3839] = {.lex_state = 212},
  [3840] = {.lex_state = 198},
  [3841] = {.lex_state = 219},
  [3842] = {.lex_state = 219},
  [3843] = {.lex_state = 219},
  [3844] = {.lex_state = 219},
  [3845] = {.lex_state = 205},
  [3846] = {.lex_state = 219},
  [3847] = {.lex_state = 219},
  [3848] = {.lex_state = 212},
  [3849] = {.lex_state = 185},
  [3850] = {.lex_state = 212},
  [3851] = {.lex_state = 219},
  [3852] = {.lex_state = 219},
  [3853] = {.lex_state = 219},
  [3854] = {.lex_state = 219},
  [3855] = {.lex_state = 205},
  [3856] = {.lex_state = 219},
  [3857] = {.lex_state = 219},
  [3858] = {.lex_state = 219},
  [3859] = {.lex_state = 219},
  [3860] = {.lex_state = 212},
  [3861] = {.lex_state = 212},
  [3862] = {.lex_state = 219},
  [3863] = {.lex_state = 198},
  [3864] = {.lex_state = 212},
  [3865] = {.lex_state = 207},
  [3866] = {.lex_state = 198},
  [3867] = {.lex_state = 219},
  [3868] = {.lex_state = 212},
  [3869] = {.lex_state = 219},
  [3870] = {.lex_state = 219},
  [3871] = {.lex_state = 219},
  [3872] = {.lex_state = 219},
  [3873] = {.lex_state = 219},
  [3874] = {.lex_state = 219},
  [3875] = {.lex_state = 201},
  [3876] = {.lex_state = 212},
  [3877] = {.lex_state = 219},
  [3878] = {.lex_state = 212},
  [3879] = {.lex_state = 219},
  [3880] = {.lex_state = 219},
  [3881] = {.lex_state = 212},
  [3882] = {.lex_state = 201},
  [3883] = {.lex_state = 201},
  [3884] = {.lex_state = 201},
  [3885] = {.lex_state = 219},
  [3886] = {.lex_state = 219},
  [3887] = {.lex_state = 219},
  [3888] = {.lex_state = 201},
  [3889] = {.lex_state = 201},
  [3890] = {.lex_state = 201},
  [3891] = {.lex_state = 197},
  [3892] = {.lex_state = 212},
  [3893] = {.lex_state = 219},
  [3894] = {.lex_state = 219},
  [3895] = {.lex_state = 212},
  [3896] = {.lex_state = 219},
  [3897] = {.lex_state = 212},
  [3898] = {.lex_state = 219},
  [3899] = {.lex_state = 219},
  [3900] = {.lex_state = 219},
  [3901] = {.lex_state = 219},
  [3902] = {.lex_state = 219},
  [3903] = {.lex_state = 219},
  [3904] = {.lex_state = 205},
  [3905] = {.lex_state = 212},
  [3906] = {.lex_state = 212},
  [3907] = {.lex_state = 212},
  [3908] = {.lex_state = 219},
  [3909] = {.lex_state = 219},
  [3910] = {.lex_state = 219},
  [3911] = {.lex_state = 219},
  [3912] = {.lex_state = 212},
  [3913] = {.lex_state = 219},
  [3914] = {.lex_state = 212},
  [3915] = {.lex_state = 219},
  [3916] = {.lex_state = 219},
  [3917] = {.lex_state = 205},
  [3918] = {.lex_state = 205},
  [3919] = {.lex_state = 207},
  [3920] = {.lex_state = 219},
  [3921] = {.lex_state = 219},
  [3922] = {.lex_state = 219},
  [3923] = {.lex_state = 205},
  [3924] = {.lex_state = 212},
  [3925] = {.lex_state = 219},
  [3926] = {.lex_state = 219},
  [3927] = {.lex_state = 219},
  [3928] = {.lex_state = 219},
  [3929] = {.lex_state = 212},
  [3930] = {.lex_state = 219},
  [3931] = {.lex_state = 219},
  [3932] = {.lex_state = 207},
  [3933] = {.lex_state = 219},
  [3934] = {.lex_state = 219},
  [3935] = {.lex_state = 212},
  [3936] = {.lex_state = 219},
  [3937] = {.lex_state = 205},
  [3938] = {.lex_state = 219},
  [3939] = {.lex_state = 219},
  [3940] = {.lex_state = 219},
  [3941] = {.lex_state = 219},
  [3942] = {.lex_state = 219},
  [3943] = {.lex_state = 212},
  [3944] = {.lex_state = 219},
  [3945] = {.lex_state = 212},
  [3946] = {.lex_state = 205},
  [3947] = {.lex_state = 205},
  [3948] = {.lex_state = 219},
  [3949] = {.lex_state = 219},
  [3950] = {.lex_state = 205},
  [3951] = {.lex_state = 219},
  [3952] = {.lex_state = 219},
  [3953] = {.lex_state = 219},
  [3954] = {.lex_state = 219},
  [3955] = {.lex_state = 205},
  [3956] = {.lex_state = 219},
  [3957] = {.lex_state = 219},
  [3958] = {.lex_state = 219},
  [3959] = {.lex_state = 219},
  [3960] = {.lex_state = 201},
  [3961] = {.lex_state = 219},
  [3962] = {.lex_state = 212},
  [3963] = {.lex_state = 219},
  [3964] = {.lex_state = 219},
  [3965] = {.lex_state = 219},
  [3966] = {.lex_state = 219},
  [3967] = {.lex_state = 219},
  [3968] = {.lex_state = 205},
  [3969] = {.lex_state = 242},
  [3970] = {.lex_state = 244},
  [3971] = {.lex_state = 243},
  [3972] = {.lex_state = 242},
  [3973] = {.lex_state = 242},
  [3974] = {.lex_state = 242},
  [3975] = {.lex_state = 242},
  [3976] = {.lex_state = 244},
  [3977] = {.lex_state = 242},
  [3978] = {.lex_state = 242},
  [3979] = {.lex_state = 242},
  [3980] = {.lex_state = 242},
  [3981] = {.lex_state = 207},
  [3982] = {.lex_state = 242},
  [3983] = {.lex_state = 205},
  [3984] = {.lex_state = 207},
  [3985] = {.lex_state = 198},
  [3986] = {.lex_state = 242},
  [3987] = {.lex_state = 242},
  [3988] = {.lex_state = 242},
  [3989] = {.lex_state = 242},
  [3990] = {.lex_state = 216},
  [3991] = {.lex_state = 242},
  [3992] = {.lex_state = 242},
  [3993] = {.lex_state = 242},
  [3994] = {.lex_state = 242},
  [3995] = {.lex_state = 245},
  [3996] = {.lex_state = 207},
  [3997] = {.lex_state = 207},
  [3998] = {.lex_state = 242},
  [3999] = {.lex_state = 242},
  [4000] = {.lex_state = 242},
  [4001] = {.lex_state = 245},
  [4002] = {.lex_state = 212},
  [4003] = {.lex_state = 242},
  [4004] = {.lex_state = 242},
  [4005] = {.lex_state = 242},
  [4006] = {.lex_state = 242},
  [4007] = {.lex_state = 242},
  [4008] = {.lex_state = 242},
  [4009] = {.lex_state = 242},
  [4010] = {.lex_state = 242},
  [4011] = {.lex_state = 242},
  [4012] = {.lex_state = 207},
  [4013] = {.lex_state = 242},
  [4014] = {.lex_state = 242},
  [4015] = {.lex_state = 242},
  [4016] = {.lex_state = 242},
  [4017] = {.lex_state = 207},
  [4018] = {.lex_state = 242},
  [4019] = {.lex_state = 242},
  [4020] = {.lex_state = 242},
  [4021] = {.lex_state = 242},
  [4022] = {.lex_state = 242},
  [4023] = {.lex_state = 242},
  [4024] = {.lex_state = 207},
  [4025] = {.lex_state = 242},
  [4026] = {.lex_state = 242},
  [4027] = {.lex_state = 242},
  [4028] = {.lex_state = 242},
  [4029] = {.lex_state = 244},
  [4030] = {.lex_state = 243},
  [4031] = {.lex_state = 242},
  [4032] = {.lex_state = 242},
  [4033] = {.lex_state = 207},
  [4034] = {.lex_state = 242},
  [4035] = {.lex_state = 216},
  [4036] = {.lex_state = 242},
  [4037] = {.lex_state = 246},
  [4038] = {.lex_state = 242},
  [4039] = {.lex_state = 185},
  [4040] = {.lex_state = 185},
  [4041] = {.lex_state = 242},
  [4042] = {.lex_state = 242},
  [4043] = {.lex_state = 242},
  [4044] = {.lex_state = 242},
  [4045] = {.lex_state = 207},
  [4046] = {.lex_state = 242},
  [4047] = {.lex_state = 242},
  [4048] = {.lex_state = 242},
  [4049] = {.lex_state = 242},
  [4050] = {.lex_state = 242},
  [4051] = {.lex_state = 207},
  [4052] = {.lex_state = 242},
  [4053] = {.lex_state = 185},
  [4054] = {.lex_state = 195},
  [4055] = {.lex_state = 242},
  [4056] = {.lex_state = 242},
  [4057] = {.lex_state = 207},
  [4058] = {.lex_state = 242},
  [4059] = {.lex_state = 207},
  [4060] = {.lex_state = 242},
  [4061] = {.lex_state = 242},
  [4062] = {.lex_state = 242},
  [4063] = {.lex_state = 242},
  [4064] = {.lex_state = 205},
  [4065] = {.lex_state = 242},
  [4066] = {.lex_state = 242},
  [4067] = {.lex_state = 207},
  [4068] = {.lex_state = 185},
  [4069] = {.lex_state = 242},
  [4070] = {.lex_state = 207},
  [4071] = {.lex_state = 212},
  [4072] = {.lex_state = 207},
  [4073] = {.lex_state = 212},
  [4074] = {.lex_state = 212},
  [4075] = {.lex_state = 212},
  [4076] = {.lex_state = 212},
  [4077] = {.lex_state = 212},
  [4078] = {.lex_state = 207},
  [4079] = {.lex_state = 242},
  [4080] = {.lex_state = 212},
  [4081] = {.lex_state = 207},
  [4082] = {.lex_state = 212},
  [4083] = {.lex_state = 212},
  [4084] = {.lex_state = 212},
  [4085] = {.lex_state = 242},
  [4086] = {.lex_state = 207},
  [4087] = {.lex_state = 212},
  [4088] = {.lex_state = 212},
  [4089] = {.lex_state = 212},
  [4090] = {.lex_state = 212},
  [4091] = {.lex_state = 212},
  [4092] = {.lex_state = 246},
  [4093] = {.lex_state = 243},
  [4094] = {.lex_state = 242},
  [4095] = {.lex_state = 207},
  [4096] = {.lex_state = 207},
  [4097] = {.lex_state = 207},
  [4098] = {.lex_state = 207},
  [4099] = {.lex_state = 212},
  [4100] = {.lex_state = 212},
  [4101] = {.lex_state = 207},
  [4102] = {.lex_state = 212},
  [4103] = {.lex_state = 242},
  [4104] = {.lex_state = 243},
  [4105] = {.lex_state = 212},
  [4106] = {.lex_state = 242},
  [4107] = {.lex_state = 212},
  [4108] = {.lex_state = 212},
  [4109] = {.lex_state = 212},
  [4110] = {.lex_state = 207},
  [4111] = {.lex_state = 212},
  [4112] = {.lex_state = 242},
  [4113] = {.lex_state = 207},
  [4114] = {.lex_state = 207},
  [4115] = {.lex_state = 242},
  [4116] = {.lex_state = 212},
  [4117] = {.lex_state = 207},
  [4118] = {.lex_state = 207},
  [4119] = {.lex_state = 242},
  [4120] = {.lex_state = 212},
  [4121] = {.lex_state = 212},
  [4122] = {.lex_state = 212},
  [4123] = {.lex_state = 212},
  [4124] = {.lex_state = 207},
  [4125] = {.lex_state = 212},
  [4126] = {.lex_state = 207},
  [4127] = {.lex_state = 207},
  [4128] = {.lex_state = 207},
  [4129] = {.lex_state = 207},
  [4130] = {.lex_state = 212},
  [4131] = {.lex_state = 212},
  [4132] = {.lex_state = 207},
  [4133] = {.lex_state = 212},
  [4134] = {.lex_state = 212},
  [4135] = {.lex_state = 242},
  [4136] = {.lex_state = 207},
  [4137] = {.lex_state = 242},
  [4138] = {.lex_state = 212},
  [4139] = {.lex_state = 212},
  [4140] = {.lex_state = 212},
  [4141] = {.lex_state = 242},
  [4142] = {.lex_state = 207},
  [4143] = {.lex_state = 207},
  [4144] = {.lex_state = 212},
  [4145] = {.lex_state = 207},
  [4146] = {.lex_state = 207},
  [4147] = {.lex_state = 212},
  [4148] = {.lex_state = 207},
  [4149] = {.lex_state = 212},
  [4150] = {.lex_state = 242},
  [4151] = {.lex_state = 207},
  [4152] = {.lex_state = 242},
  [4153] = {.lex_state = 212},
  [4154] = {.lex_state = 212},
  [4155] = {.lex_state = 242},
  [4156] = {.lex_state = 212},
  [4157] = {.lex_state = 212},
  [4158] = {.lex_state = 207},
  [4159] = {.lex_state = 195},
  [4160] = {.lex_state = 195},
  [4161] = {.lex_state = 207},
  [4162] = {.lex_state = 207},
  [4163] = {.lex_state = 246},
  [4164] = {.lex_state = 207},
  [4165] = {.lex_state = 207},
  [4166] = {.lex_state = 212},
  [4167] = {.lex_state = 212},
  [4168] = {.lex_state = 212},
  [4169] = {.lex_state = 212},
  [4170] = {.lex_state = 212},
  [4171] = {.lex_state = 195},
  [4172] = {.lex_state = 212},
  [4173] = {.lex_state = 212},
  [4174] = {.lex_state = 212},
  [4175] = {.lex_state = 243},
  [4176] = {.lex_state = 243},
  [4177] = {.lex_state = 195},
  [4178] = {.lex_state = 207},
  [4179] = {.lex_state = 212},
  [4180] = {.lex_state = 212},
  [4181] = {.lex_state = 212},
  [4182] = {.lex_state = 242},
  [4183] = {.lex_state = 207},
  [4184] = {.lex_state = 207},
  [4185] = {.lex_state = 207},
  [4186] = {.lex_state = 230},
  [4187] = {.lex_state = 242},
  [4188] = {.lex_state = 212},
  [4189] = {.lex_state = 212},
  [4190] = {.lex_state = 207},
  [4191] = {.lex_state = 207},
  [4192] = {.lex_state = 207},
  [4193] = {.lex_state = 232},
  [4194] = {.lex_state = 207},
  [4195] = {.lex_state = 244},
  [4196] = {.lex_state = 232},
  [4197] = {.lex_state = 244},
  [4198] = {.lex_state = 207},
  [4199] = {.lex_state = 207},
  [4200] = {.lex_state = 244},
  [4201] = {.lex_state = 244},
  [4202] = {.lex_state = 244},
  [4203] = {.lex_state = 207},
  [4204] = {.lex_state = 207},
  [4205] = {.lex_state = 207},
  [4206] = {.lex_state = 244},
  [4207] = {.lex_state = 207},
  [4208] = {.lex_state = 244},
  [4209] = {.lex_state = 244},
  [4210] = {.lex_state = 244},
  [4211] = {.lex_state = 244},
  [4212] = {.lex_state = 195},
  [4213] = {.lex_state = 195},
  [4214] = {.lex_state = 207},
  [4215] = {.lex_state = 244},
  [4216] = {.lex_state = 244},
  [4217] = {.lex_state = 244},
  [4218] = {.lex_state = 195},
  [4219] = {.lex_state = 244},
  [4220] = {.lex_state = 207},
  [4221] = {.lex_state = 207},
  [4222] = {.lex_state = 244},
  [4223] = {.lex_state = 207},
  [4224] = {.lex_state = 207},
  [4225] = {.lex_state = 207},
  [4226] = {.lex_state = 207},
  [4227] = {.lex_state = 207},
  [4228] = {.lex_state = 244},
  [4229] = {.lex_state = 195},
  [4230] = {.lex_state = 207},
  [4231] = {.lex_state = 244},
  [4232] = {.lex_state = 244},
  [4233] = {.lex_state = 246},
  [4234] = {.lex_state = 207},
  [4235] = {.lex_state = 207},
  [4236] = {.lex_state = 246},
  [4237] = {.lex_state = 207},
  [4238] = {.lex_state = 244},
  [4239] = {.lex_state = 230},
  [4240] = {.lex_state = 246},
  [4241] = {.lex_state = 207},
  [4242] = {.lex_state = 230},
  [4243] = {.lex_state = 244},
  [4244] = {.lex_state = 244},
  [4245] = {.lex_state = 244},
  [4246] = {.lex_state = 230},
  [4247] = {.lex_state = 207},
  [4248] = {.lex_state = 207},
  [4249] = {.lex_state = 244},
  [4250] = {.lex_state = 244},
  [4251] = {.lex_state = 207},
  [4252] = {.lex_state = 246},
  [4253] = {.lex_state = 207},
  [4254] = {.lex_state = 243},
  [4255] = {.lex_state = 244},
  [4256] = {.lex_state = 207},
  [4257] = {.lex_state = 207},
  [4258] = {.lex_state = 241},
  [4259] = {.lex_state = 242},
  [4260] = {.lex_state = 232},
  [4261] = {.lex_state = 207},
  [4262] = {.lex_state = 242},
  [4263] = {.lex_state = 242},
  [4264] = {.lex_state = 242},
  [4265] = {.lex_state = 242},
  [4266] = {.lex_state = 242},
  [4267] = {.lex_state = 242},
  [4268] = {.lex_state = 205},
  [4269] = {.lex_state = 242},
  [4270] = {.lex_state = 243},
  [4271] = {.lex_state = 242},
  [4272] = {.lex_state = 247},
  [4273] = {.lex_state = 242},
  [4274] = {.lex_state = 243},
  [4275] = {.lex_state = 242},
  [4276] = {.lex_state = 205},
  [4277] = {.lex_state = 248},
  [4278] = {.lex_state = 244},
  [4279] = {.lex_state = 247},
  [4280] = {.lex_state = 242},
  [4281] = {.lex_state = 248},
  [4282] = {.lex_state = 242},
  [4283] = {.lex_state = 242},
  [4284] = {.lex_state = 242},
  [4285] = {.lex_state = 242},
  [4286] = {.lex_state = 242},
  [4287] = {.lex_state = 243},
  [4288] = {.lex_state = 242},
  [4289] = {.lex_state = 242},
  [4290] = {.lex_state = 242},
  [4291] = {.lex_state = 244},
  [4292] = {.lex_state = 242},
  [4293] = {.lex_state = 242},
  [4294] = {.lex_state = 242},
  [4295] = {.lex_state = 242},
  [4296] = {.lex_state = 232},
  [4297] = {.lex_state = 242},
  [4298] = {.lex_state = 242},
  [4299] = {.lex_state = 243},
  [4300] = {.lex_state = 242},
  [4301] = {.lex_state = 242},
  [4302] = {.lex_state = 207},
  [4303] = {.lex_state = 244},
  [4304] = {.lex_state = 207},
  [4305] = {.lex_state = 207},
  [4306] = {.lex_state = 207},
  [4307] = {.lex_state = 207},
  [4308] = {.lex_state = 207},
  [4309] = {.lex_state = 207},
  [4310] = {.lex_state = 207},
  [4311] = {.lex_state = 207},
  [4312] = {.lex_state = 207},
  [4313] = {.lex_state = 207},
  [4314] = {.lex_state = 248},
  [4315] = {.lex_state = 207},
  [4316] = {.lex_state = 241},
  [4317] = {.lex_state = 207},
  [4318] = {.lex_state = 207},
  [4319] = {.lex_state = 207},
  [4320] = {.lex_state = 207},
  [4321] = {.lex_state = 207},
  [4322] = {.lex_state = 207},
  [4323] = {.lex_state = 207},
  [4324] = {.lex_state = 207},
  [4325] = {.lex_state = 245},
  [4326] = {.lex_state = 207},
  [4327] = {.lex_state = 207},
  [4328] = {.lex_state = 207},
  [4329] = {.lex_state = 245},
  [4330] = {.lex_state = 207},
  [4331] = {.lex_state = 241},
  [4332] = {.lex_state = 196},
  [4333] = {.lex_state = 207},
  [4334] = {.lex_state = 243},
  [4335] = {.lex_state = 207},
  [4336] = {.lex_state = 207},
  [4337] = {.lex_state = 244},
  [4338] = {.lex_state = 207},
  [4339] = {.lex_state = 207},
  [4340] = {.lex_state = 207},
  [4341] = {.lex_state = 243},
  [4342] = {.lex_state = 207},
  [4343] = {.lex_state = 196},
  [4344] = {.lex_state = 207},
  [4345] = {.lex_state = 207},
  [4346] = {.lex_state = 207},
  [4347] = {.lex_state = 207},
  [4348] = {.lex_state = 207},
  [4349] = {.lex_state = 246},
  [4350] = {.lex_state = 207},
  [4351] = {.lex_state = 207},
  [4352] = {.lex_state = 207},
  [4353] = {.lex_state = 232},
  [4354] = {.lex_state = 207},
  [4355] = {.lex_state = 207},
  [4356] = {.lex_state = 207},
  [4357] = {.lex_state = 207},
  [4358] = {.lex_state = 232},
  [4359] = {.lex_state = 196},
  [4360] = {.lex_state = 196},
  [4361] = {.lex_state = 207},
  [4362] = {.lex_state = 207},
  [4363] = {.lex_state = 244},
  [4364] = {.lex_state = 207},
  [4365] = {.lex_state = 232},
  [4366] = {.lex_state = 207},
  [4367] = {.lex_state = 196},
  [4368] = {.lex_state = 243},
  [4369] = {.lex_state = 243},
  [4370] = {.lex_state = 244},
  [4371] = {.lex_state = 244},
  [4372] = {.lex_state = 207},
  [4373] = {.lex_state = 246},
  [4374] = {.lex_state = 196},
  [4375] = {.lex_state = 244},
  [4376] = {.lex_state = 207},
  [4377] = {.lex_state = 207},
  [4378] = {.lex_state = 207},
  [4379] = {.lex_state = 196},
  [4380] = {.lex_state = 196},
  [4381] = {.lex_state = 207},
  [4382] = {.lex_state = 196},
  [4383] = {.lex_state = 207},
  [4384] = {.lex_state = 244},
  [4385] = {.lex_state = 244},
  [4386] = {.lex_state = 232},
  [4387] = {.lex_state = 207},
  [4388] = {.lex_state = 207},
  [4389] = {.lex_state = 241},
  [4390] = {.lex_state = 207},
  [4391] = {.lex_state = 207},
  [4392] = {.lex_state = 196},
  [4393] = {.lex_state = 207},
  [4394] = {.lex_state = 207},
  [4395] = {.lex_state = 207},
  [4396] = {.lex_state = 207},
  [4397] = {.lex_state = 207},
  [4398] = {.lex_state = 207},
  [4399] = {.lex_state = 207},
  [4400] = {.lex_state = 232},
  [4401] = {.lex_state = 232},
  [4402] = {.lex_state = 244},
  [4403] = {.lex_state = 207},
  [4404] = {.lex_state = 232},
  [4405] = {.lex_state = 232},
  [4406] = {.lex_state = 207},
  [4407] = {.lex_state = 207},
  [4408] = {.lex_state = 232},
  [4409] = {.lex_state = 248},
  [4410] = {.lex_state = 232},
  [4411] = {.lex_state = 241},
  [4412] = {.lex_state = 232},
  [4413] = {.lex_state = 241},
  [4414] = {.lex_state = 232},
  [4415] = {.lex_state = 231},
  [4416] = {.lex_state = 232},
  [4417] = {.lex_state = 243},
  [4418] = {.lex_state = 207},
  [4419] = {.lex_state = 244},
  [4420] = {.lex_state = 241},
  [4421] = {.lex_state = 232},
  [4422] = {.lex_state = 232},
  [4423] = {.lex_state = 243},
  [4424] = {.lex_state = 244},
  [4425] = {.lex_state = 207},
  [4426] = {.lex_state = 244},
  [4427] = {.lex_state = 207},
  [4428] = {.lex_state = 241},
  [4429] = {.lex_state = 232},
  [4430] = {.lex_state = 231},
  [4431] = {.lex_state = 208},
  [4432] = {.lex_state = 207},
  [4433] = {.lex_state = 232},
  [4434] = {.lex_state = 206},
  [4435] = {.lex_state = 232},
  [4436] = {.lex_state = 232},
  [4437] = {.lex_state = 206},
  [4438] = {.lex_state = 243},
  [4439] = {.lex_state = 232},
  [4440] = {.lex_state = 208},
  [4441] = {.lex_state = 232},
  [4442] = {.lex_state = 248},
  [4443] = {.lex_state = 232},
  [4444] = {.lex_state = 232},
  [4445] = {.lex_state = 244},
  [4446] = {.lex_state = 244},
  [4447] = {.lex_state = 207},
  [4448] = {.lex_state = 231},
  [4449] = {.lex_state = 243},
  [4450] = {.lex_state = 243},
  [4451] = {.lex_state = 244},
  [4452] = {.lex_state = 248},
  [4453] = {.lex_state = 243},
  [4454] = {.lex_state = 243},
  [4455] = {.lex_state = 243},
  [4456] = {.lex_state = 245},
  [4457] = {.lex_state = 244},
  [4458] = {.lex_state = 243},
  [4459] = {.lex_state = 243},
  [4460] = {.lex_state = 243},
  [4461] = {.lex_state = 245},
  [4462] = {.lex_state = 248},
  [4463] = {.lex_state = 244},
  [4464] = {.lex_state = 245},
  [4465] = {.lex_state = 245},
  [4466] = {.lex_state = 243},
  [4467] = {.lex_state = 208},
  [4468] = {.lex_state = 243},
  [4469] = {.lex_state = 241},
  [4470] = {.lex_state = 243},
  [4471] = {.lex_state = 243},
  [4472] = {.lex_state = 243},
  [4473] = {.lex_state = 243},
  [4474] = {.lex_state = 244},
  [4475] = {.lex_state = 244},
  [4476] = {.lex_state = 243},
  [4477] = {.lex_state = 243},
  [4478] = {.lex_state = 244},
  [4479] = {.lex_state = 208},
  [4480] = {.lex_state = 243},
  [4481] = {.lex_state = 207},
  [4482] = {.lex_state = 244},
  [4483] = {.lex_state = 244},
  [4484] = {.lex_state = 243},
  [4485] = {.lex_state = 243},
  [4486] = {.lex_state = 243},
  [4487] = {.lex_state = 243},
  [4488] = {.lex_state = 207},
  [4489] = {.lex_state = 207},
  [4490] = {.lex_state = 207},
  [4491] = {.lex_state = 207},
  [4492] = {.lex_state = 241},
  [4493] = {.lex_state = 207},
  [4494] = {.lex_state = 207},
  [4495] = {.lex_state = 207},
  [4496] = {.lex_state = 207},
  [4497] = {.lex_state = 207},
  [4498] = {.lex_state = 207},
  [4499] = {.lex_state = 207},
  [4500] = {.lex_state = 244},
  [4501] = {.lex_state = 244},
  [4502] = {.lex_state = 207},
  [4503] = {.lex_state = 207},
  [4504] = {.lex_state = 207},
  [4505] = {.lex_state = 207},
  [4506] = {.lex_state = 207},
  [4507] = {.lex_state = 207},
  [4508] = {.lex_state = 207},
  [4509] = {.lex_state = 207},
  [4510] = {.lex_state = 207},
  [4511] = {.lex_state = 244},
  [4512] = {.lex_state = 245},
  [4513] = {.lex_state = 245},
  [4514] = {.lex_state = 207},
  [4515] = {.lex_state = 245},
  [4516] = {.lex_state = 207},
  [4517] = {.lex_state = 207},
  [4518] = {.lex_state = 245},
  [4519] = {.lex_state = 245},
  [4520] = {.lex_state = 207},
  [4521] = {.lex_state = 243},
  [4522] = {.lex_state = 207},
  [4523] = {.lex_state = 243},
  [4524] = {.lex_state = 242},
  [4525] = {.lex_state = 243},
  [4526] = {.lex_state = 207},
  [4527] = {.lex_state = 207},
  [4528] = {.lex_state = 245},
  [4529] = {.lex_state = 245},
  [4530] = {.lex_state = 245},
  [4531] = {.lex_state = 245},
  [4532] = {.lex_state = 245},
  [4533] = {.lex_state = 245},
  [4534] = {.lex_state = 207},
  [4535] = {.lex_state = 243},
  [4536] = {.lex_state = 245},
  [4537] = {.lex_state = 245},
  [4538] = {.lex_state = 207},
  [4539] = {.lex_state = 207},
  [4540] = {.lex_state = 244},
  [4541] = {.lex_state = 207},
  [4542] = {.lex_state = 207},
  [4543] = {.lex_state = 207},
  [4544] = {.lex_state = 207},
  [4545] = {.lex_state = 207},
  [4546] = {.lex_state = 207},
  [4547] = {.lex_state = 207},
  [4548] = {.lex_state = 207},
  [4549] = {.lex_state = 244},
  [4550] = {.lex_state = 207},
  [4551] = {.lex_state = 207},
  [4552] = {.lex_state = 242},
  [4553] = {.lex_state = 207},
  [4554] = {.lex_state = 207},
  [4555] = {.lex_state = 243},
  [4556] = {.lex_state = 232},
  [4557] = {.lex_state = 244},
  [4558] = {.lex_state = 232},
  [4559] = {.lex_state = 207},
  [4560] = {.lex_state = 232},
  [4561] = {.lex_state = 207},
  [4562] = {.lex_state = 207},
  [4563] = {.lex_state = 232},
  [4564] = {.lex_state = 207},
  [4565] = {.lex_state = 208},
  [4566] = {.lex_state = 196},
  [4567] = {.lex_state = 207},
  [4568] = {.lex_state = 207},
  [4569] = {.lex_state = 232},
  [4570] = {.lex_state = 245},
  [4571] = {.lex_state = 207},
  [4572] = {.lex_state = 207},
  [4573] = {.lex_state = 227},
  [4574] = {.lex_state = 243},
  [4575] = {.lex_state = 232},
  [4576] = {.lex_state = 207},
  [4577] = {.lex_state = 231},
  [4578] = {.lex_state = 232},
  [4579] = {.lex_state = 232},
  [4580] = {.lex_state = 207},
  [4581] = {.lex_state = 207},
  [4582] = {.lex_state = 207},
  [4583] = {.lex_state = 241},
  [4584] = {.lex_state = 207},
  [4585] = {.lex_state = 232},
  [4586] = {.lex_state = 232},
  [4587] = {.lex_state = 207},
  [4588] = {.lex_state = 207},
  [4589] = {.lex_state = 207},
  [4590] = {.lex_state = 207},
  [4591] = {.lex_state = 243},
  [4592] = {.lex_state = 207},
  [4593] = {.lex_state = 232},
  [4594] = {.lex_state = 232},
  [4595] = {.lex_state = 232},
  [4596] = {.lex_state = 232},
  [4597] = {.lex_state = 232},
  [4598] = {.lex_state = 206},
  [4599] = {.lex_state = 208},
  [4600] = {.lex_state = 207},
  [4601] = {.lex_state = 207},
  [4602] = {.lex_state = 207},
  [4603] = {.lex_state = 207},
  [4604] = {.lex_state = 207},
  [4605] = {.lex_state = 207},
  [4606] = {.lex_state = 232},
  [4607] = {.lex_state = 232},
  [4608] = {.lex_state = 232},
  [4609] = {.lex_state = 207},
  [4610] = {.lex_state = 232},
  [4611] = {.lex_state = 232},
  [4612] = {.lex_state = 243},
  [4613] = {.lex_state = 207},
  [4614] = {.lex_state = 207},
  [4615] = {.lex_state = 207},
  [4616] = {.lex_state = 232},
  [4617] = {.lex_state = 207},
  [4618] = {.lex_state = 232},
  [4619] = {.lex_state = 232},
  [4620] = {.lex_state = 196},
  [4621] = {.lex_state = 207},
  [4622] = {.lex_state = 207},
  [4623] = {.lex_state = 232},
  [4624] = {.lex_state = 244},
  [4625] = {.lex_state = 207},
  [4626] = {.lex_state = 232},
  [4627] = {.lex_state = 244},
  [4628] = {.lex_state = 244},
  [4629] = {.lex_state = 244},
  [4630] = {.lex_state = 244},
  [4631] = {.lex_state = 244},
  [4632] = {.lex_state = 207},
  [4633] = {.lex_state = 244},
  [4634] = {.lex_state = 244},
  [4635] = {.lex_state = 207},
  [4636] = {.lex_state = 244},
  [4637] = {.lex_state = 232},
  [4638] = {.lex_state = 232},
  [4639] = {.lex_state = 232},
  [4640] = {.lex_state = 207},
  [4641] = {.lex_state = 207},
  [4642] = {.lex_state = 207},
  [4643] = {.lex_state = 232},
  [4644] = {.lex_state = 244},
  [4645] = {.lex_state = 244},
  [4646] = {.lex_state = 232},
  [4647] = {.lex_state = 207},
  [4648] = {.lex_state = 243},
  [4649] = {.lex_state = 207},
  [4650] = {.lex_state = 244},
  [4651] = {.lex_state = 207},
  [4652] = {.lex_state = 207},
  [4653] = {.lex_state = 207},
  [4654] = {.lex_state = 207},
  [4655] = {.lex_state = 207},
  [4656] = {.lex_state = 207},
  [4657] = {.lex_state = 232},
  [4658] = {.lex_state = 232},
  [4659] = {.lex_state = 207},
  [4660] = {.lex_state = 207},
  [4661] = {.lex_state = 207},
  [4662] = {.lex_state = 232},
  [4663] = {.lex_state = 207},
  [4664] = {.lex_state = 207},
  [4665] = {.lex_state = 207},
  [4666] = {.lex_state = 207},
  [4667] = {.lex_state = 207},
  [4668] = {.lex_state = 207},
  [4669] = {.lex_state = 207},
  [4670] = {.lex_state = 207},
  [4671] = {.lex_state = 207},
  [4672] = {.lex_state = 207},
  [4673] = {.lex_state = 207},
  [4674] = {.lex_state = 207},
  [4675] = {.lex_state = 243},
  [4676] = {.lex_state = 207},
  [4677] = {.lex_state = 207},
  [4678] = {.lex_state = 207},
  [4679] = {.lex_state = 207},
  [4680] = {.lex_state = 207},
  [4681] = {.lex_state = 207},
  [4682] = {.lex_state = 207},
  [4683] = {.lex_state = 244},
  [4684] = {.lex_state = 207},
  [4685] = {.lex_state = 207},
  [4686] = {.lex_state = 207},
  [4687] = {.lex_state = 207},
  [4688] = {.lex_state = 207},
  [4689] = {.lex_state = 207},
  [4690] = {.lex_state = 207},
  [4691] = {.lex_state = 207},
  [4692] = {.lex_state = 244},
  [4693] = {.lex_state = 207},
  [4694] = {.lex_state = 232},
  [4695] = {.lex_state = 232},
  [4696] = {.lex_state = 232},
  [4697] = {.lex_state = 207},
  [4698] = {.lex_state = 207},
  [4699] = {.lex_state = 207},
  [4700] = {.lex_state = 207},
  [4701] = {.lex_state = 207},
  [4702] = {.lex_state = 245},
  [4703] = {.lex_state = 207},
  [4704] = {.lex_state = 244},
  [4705] = {.lex_state = 207},
  [4706] = {.lex_state = 232},
  [4707] = {.lex_state = 207},
  [4708] = {.lex_state = 207},
  [4709] = {.lex_state = 232},
  [4710] = {.lex_state = 207},
  [4711] = {.lex_state = 207},
  [4712] = {.lex_state = 244},
  [4713] = {.lex_state = 207},
  [4714] = {.lex_state = 207},
  [4715] = {.lex_state = 207},
  [4716] = {.lex_state = 243},
  [4717] = {.lex_state = 207},
  [4718] = {.lex_state = 207},
  [4719] = {.lex_state = 207},
  [4720] = {.lex_state = 232},
  [4721] = {.lex_state = 244},
  [4722] = {.lex_state = 207},
  [4723] = {.lex_state = 207},
  [4724] = {.lex_state = 207},
  [4725] = {.lex_state = 207},
  [4726] = {.lex_state = 245},
  [4727] = {.lex_state = 207},
  [4728] = {.lex_state = 207},
  [4729] = {.lex_state = 207},
  [4730] = {.lex_state = 244},
  [4731] = {.lex_state = 207},
  [4732] = {.lex_state = 232},
  [4733] = {.lex_state = 207},
  [4734] = {.lex_state = 207},
  [4735] = {.lex_state = 232},
  [4736] = {.lex_state = 207},
  [4737] = {.lex_state = 207},
  [4738] = {.lex_state = 207},
  [4739] = {.lex_state = 207},
  [4740] = {.lex_state = 207},
  [4741] = {.lex_state = 207},
  [4742] = {.lex_state = 207},
  [4743] = {.lex_state = 244},
  [4744] = {.lex_state = 245},
  [4745] = {.lex_state = 207},
  [4746] = {.lex_state = 232},
  [4747] = {.lex_state = 207},
  [4748] = {.lex_state = 207},
  [4749] = {.lex_state = 207},
  [4750] = {.lex_state = 207},
  [4751] = {.lex_state = 207},
  [4752] = {.lex_state = 244},
  [4753] = {.lex_state = 207},
  [4754] = {.lex_state = 232},
  [4755] = {.lex_state = 207},
  [4756] = {.lex_state = 207},
  [4757] = {.lex_state = 232},
  [4758] = {.lex_state = 244},
  [4759] = {.lex_state = 207},
  [4760] = {.lex_state = 232},
  [4761] = {.lex_state = 206},
  [4762] = {.lex_state = 207},
  [4763] = {.lex_state = 230},
  [4764] = {.lex_state = 207},
  [4765] = {.lex_state = 232},
  [4766] = {.lex_state = 232},
  [4767] = {.lex_state = 196},
  [4768] = {.lex_state = 207},
  [4769] = {.lex_state = 207},
  [4770] = {.lex_state = 207},
  [4771] = {.lex_state = 232},
  [4772] = {.lex_state = 232},
  [4773] = {.lex_state = 232},
  [4774] = {.lex_state = 232},
  [4775] = {.lex_state = 207},
  [4776] = {.lex_state = 244},
  [4777] = {.lex_state = 244},
  [4778] = {.lex_state = 207},
  [4779] = {.lex_state = 207},
  [4780] = {.lex_state = 207},
  [4781] = {.lex_state = 207},
  [4782] = {.lex_state = 207},
  [4783] = {.lex_state = 207},
  [4784] = {.lex_state = 207},
  [4785] = {.lex_state = 207},
  [4786] = {.lex_state = 232},
  [4787] = {.lex_state = 207},
  [4788] = {.lex_state = 244},
  [4789] = {.lex_state = 232},
  [4790] = {.lex_state = 207},
  [4791] = {.lex_state = 232},
  [4792] = {.lex_state = 232},
  [4793] = {.lex_state = 207},
  [4794] = {.lex_state = 207},
  [4795] = {.lex_state = 207},
  [4796] = {.lex_state = 232},
  [4797] = {.lex_state = 232},
  [4798] = {.lex_state = 207},
  [4799] = {.lex_state = 245},
  [4800] = {.lex_state = 232},
  [4801] = {.lex_state = 207},
  [4802] = {.lex_state = 207},
  [4803] = {.lex_state = 207},
  [4804] = {.lex_state = 207},
  [4805] = {.lex_state = 232},
  [4806] = {.lex_state = 244},
  [4807] = {.lex_state = 207},
  [4808] = {.lex_state = 241},
  [4809] = {.lex_state = 241},
  [4810] = {.lex_state = 241},
  [4811] = {.lex_state = 241},
  [4812] = {.lex_state = 245},
  [4813] = {.lex_state = 241},
  [4814] = {.lex_state = 241},
  [4815] = {.lex_state = 241},
  [4816] = {.lex_state = 241},
  [4817] = {.lex_state = 241},
  [4818] = {.lex_state = 245},
  [4819] = {.lex_state = 241},
  [4820] = {.lex_state = 207},
  [4821] = {.lex_state = 242},
  [4822] = {.lex_state = 241},
  [4823] = {.lex_state = 241},
  [4824] = {.lex_state = 207},
  [4825] = {.lex_state = 207},
  [4826] = {.lex_state = 242},
  [4827] = {.lex_state = 207},
  [4828] = {.lex_state = 242},
  [4829] = {.lex_state = 232},
  [4830] = {.lex_state = 242},
  [4831] = {.lex_state = 244},
  [4832] = {.lex_state = 207},
  [4833] = {.lex_state = 207},
  [4834] = {.lex_state = 207},
  [4835] = {.lex_state = 207},
  [4836] = {.lex_state = 244},
  [4837] = {.lex_state = 207},
  [4838] = {.lex_state = 207},
  [4839] = {.lex_state = 207},
  [4840] = {.lex_state = 207},
  [4841] = {.lex_state = 207},
  [4842] = {.lex_state = 207},
  [4843] = {.lex_state = 207},
  [4844] = {.lex_state = 207},
  [4845] = {.lex_state = 243},
  [4846] = {.lex_state = 207},
  [4847] = {.lex_state = 207},
  [4848] = {.lex_state = 207},
  [4849] = {.lex_state = 207},
  [4850] = {.lex_state = 207},
  [4851] = {.lex_state = 207},
  [4852] = {.lex_state = 207},
  [4853] = {.lex_state = 207},
  [4854] = {.lex_state = 242},
  [4855] = {.lex_state = 207},
  [4856] = {.lex_state = 207},
  [4857] = {.lex_state = 207},
  [4858] = {.lex_state = 207},
  [4859] = {.lex_state = 242},
  [4860] = {.lex_state = 207},
  [4861] = {.lex_state = 207},
  [4862] = {.lex_state = 242},
  [4863] = {.lex_state = 207},
  [4864] = {.lex_state = 207},
  [4865] = {.lex_state = 207},
  [4866] = {.lex_state = 207},
  [4867] = {.lex_state = 207},
  [4868] = {.lex_state = 207},
  [4869] = {.lex_state = 207},
  [4870] = {.lex_state = 207},
  [4871] = {.lex_state = 207},
  [4872] = {.lex_state = 207},
  [4873] = {.lex_state = 244},
  [4874] = {.lex_state = 243},
  [4875] = {.lex_state = 243},
  [4876] = {.lex_state = 207},
  [4877] = {.lex_state = 243},
  [4878] = {.lex_state = 207},
  [4879] = {.lex_state = 207},
  [4880] = {.lex_state = 207},
  [4881] = {.lex_state = 207},
  [4882] = {.lex_state = 207},
  [4883] = {.lex_state = 207},
  [4884] = {.lex_state = 243},
  [4885] = {.lex_state = 243},
  [4886] = {.lex_state = 243},
  [4887] = {.lex_state = 243},
  [4888] = {.lex_state = 233},
  [4889] = {.lex_state = 207},
  [4890] = {.lex_state = 207},
  [4891] = {.lex_state = 207},
  [4892] = {.lex_state = 207},
  [4893] = {.lex_state = 207},
  [4894] = {.lex_state = 207},
  [4895] = {.lex_state = 207},
  [4896] = {.lex_state = 207},
  [4897] = {.lex_state = 207},
  [4898] = {.lex_state = 207},
  [4899] = {.lex_state = 207},
  [4900] = {.lex_state = 207},
  [4901] = {.lex_state = 207},
  [4902] = {.lex_state = 243},
  [4903] = {.lex_state = 243},
  [4904] = {.lex_state = 243},
  [4905] = {.lex_state = 243},
  [4906] = {.lex_state = 207},
  [4907] = {.lex_state = 207},
  [4908] = {.lex_state = 207},
  [4909] = {.lex_state = 207},
  [4910] = {.lex_state = 244},
  [4911] = {.lex_state = 207},
  [4912] = {.lex_state = 207},
  [4913] = {.lex_state = 207},
  [4914] = {.lex_state = 207},
  [4915] = {.lex_state = 207},
  [4916] = {.lex_state = 207},
  [4917] = {.lex_state = 243},
  [4918] = {.lex_state = 243},
  [4919] = {.lex_state = 207},
  [4920] = {.lex_state = 207},
  [4921] = {.lex_state = 207},
  [4922] = {.lex_state = 207},
  [4923] = {.lex_state = 207},
  [4924] = {.lex_state = 207},
  [4925] = {.lex_state = 207},
  [4926] = {.lex_state = 207},
  [4927] = {.lex_state = 242},
  [4928] = {.lex_state = 207},
  [4929] = {.lex_state = 207},
  [4930] = {.lex_state = 207},
  [4931] = {.lex_state = 242},
  [4932] = {.lex_state = 207},
  [4933] = {.lex_state = 207},
  [4934] = {.lex_state = 207},
  [4935] = {.lex_state = 207},
  [4936] = {.lex_state = 207},
  [4937] = {.lex_state = 207},
  [4938] = {.lex_state = 207},
  [4939] = {.lex_state = 207},
  [4940] = {.lex_state = 207},
  [4941] = {.lex_state = 207},
  [4942] = {.lex_state = 243},
  [4943] = {.lex_state = 244},
  [4944] = {.lex_state = 207},
  [4945] = {.lex_state = 243},
  [4946] = {.lex_state = 207},
  [4947] = {.lex_state = 207},
  [4948] = {.lex_state = 242},
  [4949] = {.lex_state = 242},
  [4950] = {.lex_state = 242},
  [4951] = {.lex_state = 242},
  [4952] = {.lex_state = 242},
  [4953] = {.lex_state = 242},
  [4954] = {.lex_state = 242},
  [4955] = {.lex_state = 244},
  [4956] = {.lex_state = 244},
  [4957] = {.lex_state = 244},
  [4958] = {.lex_state = 244},
  [4959] = {.lex_state = 244},
  [4960] = {.lex_state = 242},
  [4961] = {.lex_state = 242},
  [4962] = {.lex_state = 242},
  [4963] = {.lex_state = 242},
  [4964] = {.lex_state = 244},
  [4965] = {.lex_state = 207},
  [4966] = {.lex_state = 244},
  [4967] = {.lex_state = 207},
  [4968] = {.lex_state = 244},
  [4969] = {.lex_state = 244},
  [4970] = {.lex_state = 207},
  [4971] = {.lex_state = 207},
  [4972] = {.lex_state = 207},
  [4973] = {.lex_state = 233},
  [4974] = {.lex_state = 242},
  [4975] = {.lex_state = 243},
  [4976] = {.lex_state = 207},
  [4977] = {.lex_state = 207},
  [4978] = {.lex_state = 207},
  [4979] = {.lex_state = 207},
  [4980] = {.lex_state = 207},
  [4981] = {.lex_state = 207},
  [4982] = {.lex_state = 207},
  [4983] = {.lex_state = 207},
  [4984] = {.lex_state = 207},
  [4985] = {.lex_state = 207},
  [4986] = {.lex_state = 243},
  [4987] = {.lex_state = 232},
  [4988] = {.lex_state = 244},
  [4989] = {.lex_state = 243},
  [4990] = {.lex_state = 244},
  [4991] = {.lex_state = 245},
  [4992] = {.lex_state = 232},
  [4993] = {.lex_state = 232},
  [4994] = {.lex_state = 232},
  [4995] = {.lex_state = 232},
  [4996] = {.lex_state = 243},
  [4997] = {.lex_state = 243},
  [4998] = {.lex_state = 243},
  [4999] = {.lex_state = 232},
  [5000] = {.lex_state = 243},
  [5001] = {.lex_state = 243},
  [5002] = {.lex_state = 245},
  [5003] = {.lex_state = 243},
  [5004] = {.lex_state = 243},
  [5005] = {.lex_state = 232},
  [5006] = {.lex_state = 244},
  [5007] = {.lex_state = 243},
  [5008] = {.lex_state = 243},
  [5009] = {.lex_state = 244},
  [5010] = {.lex_state = 243},
  [5011] = {.lex_state = 232},
  [5012] = {.lex_state = 243},
  [5013] = {.lex_state = 232},
  [5014] = {.lex_state = 232},
  [5015] = {.lex_state = 232},
  [5016] = {.lex_state = 232},
  [5017] = {.lex_state = 232},
  [5018] = {.lex_state = 243},
  [5019] = {.lex_state = 207},
  [5020] = {.lex_state = 243},
  [5021] = {.lex_state = 243},
  [5022] = {.lex_state = 243},
  [5023] = {.lex_state = 245},
  [5024] = {.lex_state = 245},
  [5025] = {.lex_state = 245},
  [5026] = {.lex_state = 245},
  [5027] = {.lex_state = 232},
  [5028] = {.lex_state = 245},
  [5029] = {.lex_state = 243},
  [5030] = {.lex_state = 245},
  [5031] = {.lex_state = 244},
  [5032] = {.lex_state = 245},
  [5033] = {.lex_state = 243},
  [5034] = {.lex_state = 196},
  [5035] = {.lex_state = 243},
  [5036] = {.lex_state = 232},
  [5037] = {.lex_state = 243},
  [5038] = {.lex_state = 244},
  [5039] = {.lex_state = 232},
  [5040] = {.lex_state = 207},
  [5041] = {.lex_state = 243},
  [5042] = {.lex_state = 243},
  [5043] = {.lex_state = 244},
  [5044] = {.lex_state = 243},
  [5045] = {.lex_state = 244},
  [5046] = {.lex_state = 232},
  [5047] = {.lex_state = 196},
  [5048] = {.lex_state = 245},
  [5049] = {.lex_state = 243},
  [5050] = {.lex_state = 243},
  [5051] = {.lex_state = 243},
  [5052] = {.lex_state = 243},
  [5053] = {.lex_state = 196},
  [5054] = {.lex_state = 243},
  [5055] = {.lex_state = 243},
  [5056] = {.lex_state = 243},
  [5057] = {.lex_state = 243},
  [5058] = {.lex_state = 232},
  [5059] = {.lex_state = 243},
  [5060] = {.lex_state = 232},
  [5061] = {.lex_state = 232},
  [5062] = {.lex_state = 232},
  [5063] = {.lex_state = 243},
  [5064] = {.lex_state = 244},
  [5065] = {.lex_state = 244},
  [5066] = {.lex_state = 245},
  [5067] = {.lex_state = 244},
  [5068] = {.lex_state = 232},
  [5069] = {.lex_state = 232},
  [5070] = {.lex_state = 232},
  [5071] = {.lex_state = 244},
  [5072] = {.lex_state = 244},
  [5073] = {.lex_state = 244},
  [5074] = {.lex_state = 245},
  [5075] = {.lex_state = 245},
  [5076] = {.lex_state = 244},
  [5077] = {.lex_state = 244},
  [5078] = {.lex_state = 244},
  [5079] = {.lex_state = 196},
  [5080] = {.lex_state = 232},
  [5081] = {.lex_state = 244},
  [5082] = {.lex_state = 244},
  [5083] = {.lex_state = 244},
  [5084] = {.lex_state = 243},
  [5085] = {.lex_state = 244},
  [5086] = {.lex_state = 244},
  [5087] = {.lex_state = 243},
  [5088] = {.lex_state = 243},
  [5089] = {.lex_state = 244},
  [5090] = {.lex_state = 232},
  [5091] = {.lex_state = 232},
  [5092] = {.lex_state = 232},
  [5093] = {.lex_state = 243},
  [5094] = {.lex_state = 243},
  [5095] = {.lex_state = 232},
  [5096] = {.lex_state = 243},
  [5097] = {.lex_state = 243},
  [5098] = {.lex_state = 232},
  [5099] = {.lex_state = 244},
  [5100] = {.lex_state = 244},
  [5101] = {.lex_state = 232},
  [5102] = {.lex_state = 243},
  [5103] = {.lex_state = 232},
  [5104] = {.lex_state = 232},
  [5105] = {.lex_state = 196},
  [5106] = {.lex_state = 243},
  [5107] = {.lex_state = 243},
  [5108] = {.lex_state = 232},
  [5109] = {.lex_state = 243},
  [5110] = {.lex_state = 244},
  [5111] = {.lex_state = 232},
  [5112] = {.lex_state = 243},
  [5113] = {.lex_state = 208},
  [5114] = {.lex_state = 232},
  [5115] = {.lex_state = 232},
  [5116] = {.lex_state = 243},
  [5117] = {.lex_state = 243},
  [5118] = {.lex_state = 232},
  [5119] = {.lex_state = 232},
  [5120] = {.lex_state = 207},
  [5121] = {.lex_state = 196},
  [5122] = {.lex_state = 196},
  [5123] = {.lex_state = 244},
  [5124] = {.lex_state = 241},
  [5125] = {.lex_state = 245},
  [5126] = {.lex_state = 245},
  [5127] = {.lex_state = 245},
  [5128] = {.lex_state = 245},
  [5129] = {.lex_state = 207},
  [5130] = {.lex_state = 242},
  [5131] = {.lex_state = 245},
  [5132] = {.lex_state = 245},
  [5133] = {.lex_state = 206},
  [5134] = {.lex_state = 196},
  [5135] = {.lex_state = 245},
  [5136] = {.lex_state = 245},
  [5137] = {.lex_state = 245},
  [5138] = {.lex_state = 245},
  [5139] = {.lex_state = 245},
  [5140] = {.lex_state = 245},
  [5141] = {.lex_state = 232},
  [5142] = {.lex_state = 242},
  [5143] = {.lex_state = 245},
  [5144] = {.lex_state = 245},
  [5145] = {.lex_state = 241},
  [5146] = {.lex_state = 245},
  [5147] = {.lex_state = 245},
  [5148] = {.lex_state = 207},
  [5149] = {.lex_state = 245},
  [5150] = {.lex_state = 207},
  [5151] = {.lex_state = 245},
  [5152] = {.lex_state = 245},
  [5153] = {.lex_state = 207},
  [5154] = {.lex_state = 245},
  [5155] = {.lex_state = 206},
  [5156] = {.lex_state = 245},
  [5157] = {.lex_state = 245},
  [5158] = {.lex_state = 245},
  [5159] = {.lex_state = 245},
  [5160] = {.lex_state = 245},
  [5161] = {.lex_state = 207},
  [5162] = {.lex_state = 207},
  [5163] = {.lex_state = 207},
  [5164] = {.lex_state = 207},
  [5165] = {.lex_state = 245},
  [5166] = {.lex_state = 245},
  [5167] = {.lex_state = 245},
  [5168] = {.lex_state = 245},
  [5169] = {.lex_state = 245},
  [5170] = {.lex_state = 241},
  [5171] = {.lex_state = 196},
  [5172] = {.lex_state = 245},
  [5173] = {.lex_state = 242},
  [5174] = {.lex_state = 196},
  [5175] = {.lex_state = 245},
  [5176] = {.lex_state = 245},
  [5177] = {.lex_state = 245},
  [5178] = {.lex_state = 245},
  [5179] = {.lex_state = 245},
  [5180] = {.lex_state = 245},
  [5181] = {.lex_state = 232},
  [5182] = {.lex_state = 245},
  [5183] = {.lex_state = 196},
  [5184] = {.lex_state = 245},
  [5185] = {.lex_state = 244},
  [5186] = {.lex_state = 245},
  [5187] = {.lex_state = 241},
  [5188] = {.lex_state = 244},
  [5189] = {.lex_state = 196},
  [5190] = {.lex_state = 244},
  [5191] = {.lex_state = 244},
  [5192] = {.lex_state = 244},
  [5193] = {.lex_state = 196},
  [5194] = {.lex_state = 245},
  [5195] = {.lex_state = 197},
  [5196] = {.lex_state = 241},
  [5197] = {.lex_state = 197},
  [5198] = {.lex_state = 197},
  [5199] = {.lex_state = 241},
  [5200] = {.lex_state = 241},
  [5201] = {.lex_state = 197},
  [5202] = {.lex_state = 241},
  [5203] = {.lex_state = 197},
  [5204] = {.lex_state = 241},
  [5205] = {.lex_state = 197},
  [5206] = {.lex_state = 241},
  [5207] = {.lex_state = 197},
  [5208] = {.lex_state = 241},
  [5209] = {.lex_state = 197},
  [5210] = {.lex_state = 243},
  [5211] = {.lex_state = 243},
  [5212] = {.lex_state = 241},
  [5213] = {.lex_state = 243},
  [5214] = {.lex_state = 241},
  [5215] = {.lex_state = 243},
  [5216] = {.lex_state = 241},
  [5217] = {.lex_state = 243},
  [5218] = {.lex_state = 241},
  [5219] = {.lex_state = 244},
  [5220] = {.lex_state = 244},
  [5221] = {.lex_state = 243},
  [5222] = {.lex_state = 243},
  [5223] = {.lex_state = 197},
  [5224] = {.lex_state = 241},
  [5225] = {.lex_state = 197},
  [5226] = {.lex_state = 244},
  [5227] = {.lex_state = 197},
  [5228] = {.lex_state = 243},
  [5229] = {.lex_state = 243},
  [5230] = {.lex_state = 244},
  [5231] = {.lex_state = 241},
  [5232] = {.lex_state = 241},
  [5233] = {.lex_state = 243},
  [5234] = {.lex_state = 241},
  [5235] = {.lex_state = 197},
  [5236] = {.lex_state = 241},
  [5237] = {.lex_state = 241},
  [5238] = {.lex_state = 242},
  [5239] = {.lex_state = 243},
  [5240] = {.lex_state = 244},
  [5241] = {.lex_state = 243},
  [5242] = {.lex_state = 243},
  [5243] = {.lex_state = 243},
  [5244] = {.lex_state = 244},
  [5245] = {.lex_state = 243},
  [5246] = {.lex_state = 242},
  [5247] = {.lex_state = 242},
  [5248] = {.lex_state = 243},
  [5249] = {.lex_state = 244},
  [5250] = {.lex_state = 243},
  [5251] = {.lex_state = 244},
  [5252] = {.lex_state = 244},
  [5253] = {.lex_state = 243},
  [5254] = {.lex_state = 197},
  [5255] = {.lex_state = 242},
  [5256] = {.lex_state = 242},
  [5257] = {.lex_state = 242},
  [5258] = {.lex_state = 207},
  [5259] = {.lex_state = 242},
  [5260] = {.lex_state = 242},
  [5261] = {.lex_state = 242},
  [5262] = {.lex_state = 242},
  [5263] = {.lex_state = 242},
  [5264] = {.lex_state = 197},
  [5265] = {.lex_state = 197},
  [5266] = {.lex_state = 243},
  [5267] = {.lex_state = 242},
  [5268] = {.lex_state = 242},
  [5269] = {.lex_state = 242},
  [5270] = {.lex_state = 242},
  [5271] = {.lex_state = 242},
  [5272] = {.lex_state = 207},
  [5273] = {.lex_state = 242},
  [5274] = {.lex_state = 242},
  [5275] = {.lex_state = 242},
  [5276] = {.lex_state = 242},
  [5277] = {.lex_state = 242},
  [5278] = {.lex_state = 242},
  [5279] = {.lex_state = 242},
  [5280] = {.lex_state = 197},
  [5281] = {.lex_state = 197},
  [5282] = {.lex_state = 197},
  [5283] = {.lex_state = 207},
  [5284] = {.lex_state = 243},
  [5285] = {.lex_state = 207},
  [5286] = {.lex_state = 242},
  [5287] = {.lex_state = 197},
  [5288] = {.lex_state = 197},
  [5289] = {.lex_state = 196},
  [5290] = {.lex_state = 242},
  [5291] = {.lex_state = 197},
  [5292] = {.lex_state = 197},
  [5293] = {.lex_state = 242},
  [5294] = {.lex_state = 241},
  [5295] = {.lex_state = 197},
  [5296] = {.lex_state = 241},
  [5297] = {.lex_state = 241},
  [5298] = {.lex_state = 241},
  [5299] = {.lex_state = 241},
  [5300] = {.lex_state = 197},
  [5301] = {.lex_state = 241},
  [5302] = {.lex_state = 241},
  [5303] = {.lex_state = 197},
  [5304] = {.lex_state = 241},
  [5305] = {.lex_state = 242},
  [5306] = {.lex_state = 241},
  [5307] = {.lex_state = 241},
  [5308] = {.lex_state = 241},
  [5309] = {.lex_state = 242},
  [5310] = {.lex_state = 241},
  [5311] = {.lex_state = 241},
  [5312] = {.lex_state = 242},
  [5313] = {.lex_state = 197},
  [5314] = {.lex_state = 242},
  [5315] = {.lex_state = 242},
  [5316] = {.lex_state = 241},
  [5317] = {.lex_state = 242},
  [5318] = {.lex_state = 242},
  [5319] = {.lex_state = 197},
  [5320] = {.lex_state = 196},
  [5321] = {.lex_state = 242},
  [5322] = {.lex_state = 196},
  [5323] = {.lex_state = 242},
  [5324] = {.lex_state = 197},
  [5325] = {.lex_state = 242},
  [5326] = {.lex_state = 241},
  [5327] = {.lex_state = 242},
  [5328] = {.lex_state = 241},
  [5329] = {.lex_state = 242},
  [5330] = {.lex_state = 242},
  [5331] = {.lex_state = 242},
  [5332] = {.lex_state = 197},
  [5333] = {.lex_state = 197},
  [5334] = {.lex_state = 197},
  [5335] = {.lex_state = 197},
  [5336] = {.lex_state = 197},
  [5337] = {.lex_state = 197},
  [5338] = {.lex_state = 197},
  [5339] = {.lex_state = 197},
  [5340] = {.lex_state = 197},
  [5341] = {.lex_state = 197},
  [5342] = {.lex_state = 197},
  [5343] = {.lex_state = 197},
  [5344] = {.lex_state = 197},
  [5345] = {.lex_state = 197},
  [5346] = {.lex_state = 243},
  [5347] = {.lex_state = 244},
  [5348] = {.lex_state = 243},
  [5349] = {.lex_state = 197},
  [5350] = {.lex_state = 197},
  [5351] = {.lex_state = 197},
  [5352] = {.lex_state = 197},
  [5353] = {.lex_state = 197},
  [5354] = {.lex_state = 197},
  [5355] = {.lex_state = 197},
  [5356] = {.lex_state = 197},
  [5357] = {.lex_state = 243},
  [5358] = {.lex_state = 197},
  [5359] = {.lex_state = 197},
  [5360] = {.lex_state = 197},
  [5361] = {.lex_state = 197},
  [5362] = {.lex_state = 243},
  [5363] = {.lex_state = 197},
  [5364] = {.lex_state = 197},
  [5365] = {.lex_state = 197},
  [5366] = {.lex_state = 197},
  [5367] = {.lex_state = 197},
  [5368] = {.lex_state = 197},
  [5369] = {.lex_state = 197},
  [5370] = {.lex_state = 197},
  [5371] = {.lex_state = 197},
  [5372] = {.lex_state = 243},
  [5373] = {.lex_state = 243},
  [5374] = {.lex_state = 197},
  [5375] = {.lex_state = 197},
  [5376] = {.lex_state = 197},
  [5377] = {.lex_state = 197},
  [5378] = {.lex_state = 197},
  [5379] = {.lex_state = 197},
  [5380] = {.lex_state = 241},
  [5381] = {.lex_state = 243},
  [5382] = {.lex_state = 241},
  [5383] = {.lex_state = 197},
  [5384] = {.lex_state = 197},
  [5385] = {.lex_state = 197},
  [5386] = {.lex_state = 241},
  [5387] = {.lex_state = 241},
  [5388] = {.lex_state = 197},
  [5389] = {.lex_state = 197},
  [5390] = {.lex_state = 243},
  [5391] = {.lex_state = 197},
  [5392] = {.lex_state = 197},
  [5393] = {.lex_state = 197},
  [5394] = {.lex_state = 197},
  [5395] = {.lex_state = 197},
  [5396] = {.lex_state = 197},
  [5397] = {.lex_state = 197},
  [5398] = {.lex_state = 197},
  [5399] = {.lex_state = 197},
  [5400] = {.lex_state = 197},
  [5401] = {.lex_state = 197},
  [5402] = {.lex_state = 197},
  [5403] = {.lex_state = 197},
  [5404] = {.lex_state = 197},
  [5405] = {.lex_state = 197},
  [5406] = {.lex_state = 197},
  [5407] = {.lex_state = 197},
  [5408] = {.lex_state = 197},
  [5409] = {.lex_state = 197},
  [5410] = {.lex_state = 197},
  [5411] = {.lex_state = 197},
  [5412] = {.lex_state = 197},
  [5413] = {.lex_state = 197},
  [5414] = {.lex_state = 197},
  [5415] = {.lex_state = 197},
  [5416] = {.lex_state = 197},
  [5417] = {.lex_state = 197},
  [5418] = {.lex_state = 197},
  [5419] = {.lex_state = 197},
  [5420] = {.lex_state = 197},
  [5421] = {.lex_state = 197},
  [5422] = {.lex_state = 197},
  [5423] = {.lex_state = 243},
  [5424] = {.lex_state = 243},
  [5425] = {.lex_state = 243},
  [5426] = {.lex_state = 197},
  [5427] = {.lex_state = 197},
  [5428] = {.lex_state = 197},
  [5429] = {.lex_state = 197},
  [5430] = {.lex_state = 197},
  [5431] = {.lex_state = 197},
  [5432] = {.lex_state = 243},
  [5433] = {.lex_state = 243},
  [5434] = {.lex_state = 242},
  [5435] = {.lex_state = 242},
  [5436] = {.lex_state = 242},
  [5437] = {.lex_state = 242},
  [5438] = {.lex_state = 197},
  [5439] = {.lex_state = 242},
  [5440] = {.lex_state = 242},
  [5441] = {.lex_state = 242},
  [5442] = {.lex_state = 197},
  [5443] = {.lex_state = 242},
  [5444] = {.lex_state = 242},
  [5445] = {.lex_state = 242},
  [5446] = {.lex_state = 242},
  [5447] = {.lex_state = 197},
  [5448] = {.lex_state = 197},
  [5449] = {.lex_state = 197},
  [5450] = {.lex_state = 197},
  [5451] = {.lex_state = 197},
  [5452] = {.lex_state = 197},
  [5453] = {.lex_state = 197},
  [5454] = {.lex_state = 244},
  [5455] = {.lex_state = 197},
  [5456] = {.lex_state = 197},
  [5457] = {.lex_state = 243},
  [5458] = {.lex_state = 197},
  [5459] = {.lex_state = 244},
  [5460] = {.lex_state = 242},
  [5461] = {.lex_state = 242},
  [5462] = {.lex_state = 242},
  [5463] = {.lex_state = 242},
  [5464] = {.lex_state = 197},
  [5465] = {.lex_state = 197},
  [5466] = {.lex_state = 242},
  [5467] = {.lex_state = 244},
  [5468] = {.lex_state = 242},
  [5469] = {.lex_state = 197},
  [5470] = {.lex_state = 197},
  [5471] = {.lex_state = 242},
  [5472] = {.lex_state = 197},
  [5473] = {.lex_state = 242},
  [5474] = {.lex_state = 242},
  [5475] = {.lex_state = 242},
  [5476] = {.lex_state = 242},
  [5477] = {.lex_state = 242},
  [5478] = {.lex_state = 242},
  [5479] = {.lex_state = 242},
  [5480] = {.lex_state = 197},
  [5481] = {.lex_state = 242},
  [5482] = {.lex_state = 242},
  [5483] = {.lex_state = 242},
  [5484] = {.lex_state = 197},
  [5485] = {.lex_state = 197},
  [5486] = {.lex_state = 244},
  [5487] = {.lex_state = 197},
  [5488] = {.lex_state = 242},
  [5489] = {.lex_state = 197},
  [5490] = {.lex_state = 242},
  [5491] = {.lex_state = 242},
  [5492] = {.lex_state = 197},
  [5493] = {.lex_state = 197},
  [5494] = {.lex_state = 197},
  [5495] = {.lex_state = 244},
  [5496] = {.lex_state = 197},
  [5497] = {.lex_state = 242},
  [5498] = {.lex_state = 197},
  [5499] = {.lex_state = 242},
  [5500] = {.lex_state = 242},
  [5501] = {.lex_state = 242},
  [5502] = {.lex_state = 242},
  [5503] = {.lex_state = 242},
  [5504] = {.lex_state = 244},
  [5505] = {.lex_state = 242},
  [5506] = {.lex_state = 242},
  [5507] = {.lex_state = 242},
  [5508] = {.lex_state = 242},
  [5509] = {.lex_state = 242},
  [5510] = {.lex_state = 197},
  [5511] = {.lex_state = 242},
  [5512] = {.lex_state = 242},
  [5513] = {.lex_state = 197},
  [5514] = {.lex_state = 197},
  [5515] = {.lex_state = 244},
  [5516] = {.lex_state = 242},
  [5517] = {.lex_state = 197},
  [5518] = {.lex_state = 197},
  [5519] = {.lex_state = 242},
  [5520] = {.lex_state = 197},
  [5521] = {.lex_state = 244},
  [5522] = {.lex_state = 242},
  [5523] = {.lex_state = 242},
  [5524] = {.lex_state = 242},
  [5525] = {.lex_state = 242},
  [5526] = {.lex_state = 244},
  [5527] = {.lex_state = 242},
  [5528] = {.lex_state = 244},
  [5529] = {.lex_state = 242},
  [5530] = {.lex_state = 244},
  [5531] = {.lex_state = 244},
  [5532] = {.lex_state = 244},
  [5533] = {.lex_state = 244},
  [5534] = {.lex_state = 244},
  [5535] = {.lex_state = 244},
  [5536] = {.lex_state = 244},
  [5537] = {.lex_state = 244},
  [5538] = {.lex_state = 244},
  [5539] = {.lex_state = 244},
  [5540] = {.lex_state = 244},
  [5541] = {.lex_state = 244},
  [5542] = {.lex_state = 244},
  [5543] = {.lex_state = 244},
  [5544] = {.lex_state = 244},
  [5545] = {.lex_state = 197},
  [5546] = {.lex_state = 244},
  [5547] = {.lex_state = 244},
  [5548] = {.lex_state = 244},
  [5549] = {.lex_state = 244},
  [5550] = {.lex_state = 197},
  [5551] = {.lex_state = 243},
  [5552] = {.lex_state = 244},
  [5553] = {.lex_state = 244},
  [5554] = {.lex_state = 243},
  [5555] = {.lex_state = 197},
  [5556] = {.lex_state = 242},
  [5557] = {.lex_state = 197},
  [5558] = {.lex_state = 244},
  [5559] = {.lex_state = 243},
  [5560] = {.lex_state = 244},
  [5561] = {.lex_state = 243},
  [5562] = {.lex_state = 244},
  [5563] = {.lex_state = 197},
  [5564] = {.lex_state = 243},
  [5565] = {.lex_state = 244},
  [5566] = {.lex_state = 242},
  [5567] = {.lex_state = 244},
  [5568] = {.lex_state = 243},
  [5569] = {.lex_state = 197},
  [5570] = {.lex_state = 244},
  [5571] = {.lex_state = 244},
  [5572] = {.lex_state = 244},
  [5573] = {.lex_state = 244},
  [5574] = {.lex_state = 244},
  [5575] = {.lex_state = 244},
  [5576] = {.lex_state = 244},
  [5577] = {.lex_state = 244},
  [5578] = {.lex_state = 244},
  [5579] = {.lex_state = 244},
  [5580] = {.lex_state = 242},
  [5581] = {.lex_state = 243},
  [5582] = {.lex_state = 244},
  [5583] = {.lex_state = 243},
  [5584] = {.lex_state = 243},
  [5585] = {.lex_state = 243},
  [5586] = {.lex_state = 244},
  [5587] = {.lex_state = 244},
  [5588] = {.lex_state = 244},
  [5589] = {.lex_state = 244},
  [5590] = {.lex_state = 243},
  [5591] = {.lex_state = 243},
  [5592] = {.lex_state = 243},
  [5593] = {.lex_state = 243},
  [5594] = {.lex_state = 243},
  [5595] = {.lex_state = 243},
  [5596] = {.lex_state = 244},
  [5597] = {.lex_state = 243},
  [5598] = {.lex_state = 243},
  [5599] = {.lex_state = 243},
  [5600] = {.lex_state = 243},
  [5601] = {.lex_state = 243},
  [5602] = {.lex_state = 243},
  [5603] = {.lex_state = 243},
  [5604] = {.lex_state = 197},
  [5605] = {.lex_state = 241},
  [5606] = {.lex_state = 197},
  [5607] = {.lex_state = 241},
  [5608] = {.lex_state = 241},
  [5609] = {.lex_state = 197},
  [5610] = {.lex_state = 241},
  [5611] = {.lex_state = 241},
  [5612] = {.lex_state = 197},
  [5613] = {.lex_state = 244},
  [5614] = {.lex_state = 197},
  [5615] = {.lex_state = 197},
  [5616] = {.lex_state = 241},
  [5617] = {.lex_state = 242},
  [5618] = {.lex_state = 242},
  [5619] = {.lex_state = 241},
  [5620] = {.lex_state = 243},
  [5621] = {.lex_state = 241},
  [5622] = {.lex_state = 243},
  [5623] = {.lex_state = 243},
  [5624] = {.lex_state = 243},
  [5625] = {.lex_state = 241},
  [5626] = {.lex_state = 242},
  [5627] = {.lex_state = 243},
  [5628] = {.lex_state = 242},
  [5629] = {.lex_state = 243},
  [5630] = {.lex_state = 243},
  [5631] = {.lex_state = 243},
  [5632] = {.lex_state = 243},
  [5633] = {.lex_state = 241},
  [5634] = {.lex_state = 243},
  [5635] = {.lex_state = 243},
  [5636] = {.lex_state = 241},
  [5637] = {.lex_state = 243},
  [5638] = {.lex_state = 241},
  [5639] = {.lex_state = 254},
  [5640] = {.lex_state = 254},
  [5641] = {.lex_state = 197},
  [5642] = {.lex_state = 254},
  [5643] = {.lex_state = 254},
  [5644] = {.lex_state = 254},
  [5645] = {.lex_state = 254},
  [5646] = {.lex_state = 254},
  [5647] = {.lex_state = 197},
  [5648] = {.lex_state = 197},
  [5649] = {.lex_state = 243},
  [5650] = {.lex_state = 243},
  [5651] = {.lex_state = 243},
  [5652] = {.lex_state = 243},
  [5653] = {.lex_state = 197},
  [5654] = {.lex_state = 197},
  [5655] = {.lex_state = 243},
  [5656] = {.lex_state = 243},
  [5657] = {.lex_state = 243},
  [5658] = {.lex_state = 197},
  [5659] = {.lex_state = 197},
  [5660] = {.lex_state = 243},
  [5661] = {.lex_state = 243},
  [5662] = {.lex_state = 196},
  [5663] = {.lex_state = 197},
  [5664] = {.lex_state = 197},
  [5665] = {.lex_state = 197},
  [5666] = {.lex_state = 197},
  [5667] = {.lex_state = 243},
  [5668] = {.lex_state = 243},
  [5669] = {.lex_state = 245},
  [5670] = {.lex_state = 243},
  [5671] = {.lex_state = 254},
  [5672] = {.lex_state = 254},
  [5673] = {.lex_state = 254},
  [5674] = {.lex_state = 254},
  [5675] = {.lex_state = 254},
  [5676] = {.lex_state = 254},
  [5677] = {.lex_state = 196},
  [5678] = {.lex_state = 254},
  [5679] = {.lex_state = 254},
  [5680] = {.lex_state = 254},
  [5681] = {.lex_state = 254},
  [5682] = {.lex_state = 254},
  [5683] = {.lex_state = 241},
  [5684] = {.lex_state = 243},
  [5685] = {.lex_state = 243},
  [5686] = {.lex_state = 243},
  [5687] = {.lex_state = 243},
  [5688] = {.lex_state = 241},
  [5689] = {.lex_state = 254},
  [5690] = {.lex_state = 254},
  [5691] = {.lex_state = 241},
  [5692] = {.lex_state = 254},
  [5693] = {.lex_state = 254},
  [5694] = {.lex_state = 254},
  [5695] = {.lex_state = 241},
  [5696] = {.lex_state = 254},
  [5697] = {.lex_state = 254},
  [5698] = {.lex_state = 254},
  [5699] = {.lex_state = 254},
  [5700] = {.lex_state = 254},
  [5701] = {.lex_state = 254},
  [5702] = {.lex_state = 254},
  [5703] = {.lex_state = 254},
  [5704] = {.lex_state = 254},
  [5705] = {.lex_state = 254},
  [5706] = {.lex_state = 254},
  [5707] = {.lex_state = 196},
  [5708] = {.lex_state = 254},
  [5709] = {.lex_state = 241},
  [5710] = {.lex_state = 254},
  [5711] = {.lex_state = 254},
  [5712] = {.lex_state = 196},
  [5713] = {.lex_state = 243},
  [5714] = {.lex_state = 243},
  [5715] = {.lex_state = 254},
  [5716] = {.lex_state = 254},
  [5717] = {.lex_state = 254},
  [5718] = {.lex_state = 243},
  [5719] = {.lex_state = 243},
  [5720] = {.lex_state = 254},
  [5721] = {.lex_state = 254},
  [5722] = {.lex_state = 254},
  [5723] = {.lex_state = 210},
  [5724] = {.lex_state = 254},
  [5725] = {.lex_state = 254},
  [5726] = {.lex_state = 254},
  [5727] = {.lex_state = 254},
  [5728] = {.lex_state = 254},
  [5729] = {.lex_state = 197},
  [5730] = {.lex_state = 197},
  [5731] = {.lex_state = 197},
  [5732] = {.lex_state = 197},
  [5733] = {.lex_state = 197},
  [5734] = {.lex_state = 197},
  [5735] = {.lex_state = 197},
  [5736] = {.lex_state = 197},
  [5737] = {.lex_state = 196},
  [5738] = {.lex_state = 197},
  [5739] = {.lex_state = 197},
  [5740] = {.lex_state = 197},
  [5741] = {.lex_state = 197},
  [5742] = {.lex_state = 196},
  [5743] = {.lex_state = 197},
  [5744] = {.lex_state = 197},
  [5745] = {.lex_state = 197},
  [5746] = {.lex_state = 197},
  [5747] = {.lex_state = 197},
  [5748] = {.lex_state = 197},
  [5749] = {.lex_state = 197},
  [5750] = {.lex_state = 197},
  [5751] = {.lex_state = 197},
  [5752] = {.lex_state = 197},
  [5753] = {.lex_state = 197},
  [5754] = {.lex_state = 197},
  [5755] = {.lex_state = 243},
  [5756] = {.lex_state = 196},
  [5757] = {.lex_state = 197},
  [5758] = {.lex_state = 197},
  [5759] = {.lex_state = 197},
  [5760] = {.lex_state = 197},
  [5761] = {.lex_state = 197},
  [5762] = {.lex_state = 197},
  [5763] = {.lex_state = 197},
  [5764] = {.lex_state = 197},
  [5765] = {.lex_state = 99},
  [5766] = {.lex_state = 197},
  [5767] = {.lex_state = 197},
  [5768] = {.lex_state = 197},
  [5769] = {.lex_state = 197},
  [5770] = {.lex_state = 197},
  [5771] = {.lex_state = 197},
  [5772] = {.lex_state = 180},
  [5773] = {.lex_state = 197},
  [5774] = {.lex_state = 197},
  [5775] = {.lex_state = 197},
  [5776] = {.lex_state = 197},
  [5777] = {.lex_state = 210},
  [5778] = {.lex_state = 197},
  [5779] = {.lex_state = 197},
  [5780] = {.lex_state = 210},
  [5781] = {.lex_state = 243},
  [5782] = {.lex_state = 197},
  [5783] = {.lex_state = 197},
  [5784] = {.lex_state = 207},
  [5785] = {.lex_state = 197},
  [5786] = {.lex_state = 197},
  [5787] = {.lex_state = 197},
  [5788] = {.lex_state = 197},
  [5789] = {.lex_state = 197},
  [5790] = {.lex_state = 197},
  [5791] = {.lex_state = 197},
  [5792] = {.lex_state = 197},
  [5793] = {.lex_state = 197},
  [5794] = {.lex_state = 197},
  [5795] = {.lex_state = 197},
  [5796] = {.lex_state = 197},
  [5797] = {.lex_state = 197},
  [5798] = {.lex_state = 197},
  [5799] = {.lex_state = 196},
  [5800] = {.lex_state = 197},
  [5801] = {.lex_state = 243},
  [5802] = {.lex_state = 197},
  [5803] = {.lex_state = 180},
  [5804] = {.lex_state = 243},
  [5805] = {.lex_state = 197},
  [5806] = {.lex_state = 197},
  [5807] = {.lex_state = 197},
  [5808] = {.lex_state = 197},
  [5809] = {.lex_state = 197},
  [5810] = {.lex_state = 197},
  [5811] = {.lex_state = 197},
  [5812] = {.lex_state = 197},
  [5813] = {.lex_state = 243},
  [5814] = {.lex_state = 197},
  [5815] = {.lex_state = 197},
  [5816] = {.lex_state = 241},
  [5817] = {.lex_state = 241},
  [5818] = {.lex_state = 210},
  [5819] = {.lex_state = 232},
  [5820] = {.lex_state = 197},
  [5821] = {.lex_state = 197},
  [5822] = {.lex_state = 197},
  [5823] = {.lex_state = 197},
  [5824] = {.lex_state = 197},
  [5825] = {.lex_state = 197},
  [5826] = {.lex_state = 197},
  [5827] = {.lex_state = 197},
  [5828] = {.lex_state = 197},
  [5829] = {.lex_state = 243},
  [5830] = {.lex_state = 197},
  [5831] = {.lex_state = 197},
  [5832] = {.lex_state = 243},
  [5833] = {.lex_state = 197},
  [5834] = {.lex_state = 197},
  [5835] = {.lex_state = 197},
  [5836] = {.lex_state = 180},
  [5837] = {.lex_state = 197},
  [5838] = {.lex_state = 243},
  [5839] = {.lex_state = 197},
  [5840] = {.lex_state = 197},
  [5841] = {.lex_state = 197},
  [5842] = {.lex_state = 210},
  [5843] = {.lex_state = 242},
  [5844] = {.lex_state = 180},
  [5845] = {.lex_state = 180},
  [5846] = {.lex_state = 244},
  [5847] = {.lex_state = 210},
  [5848] = {.lex_state = 242},
  [5849] = {.lex_state = 242},
  [5850] = {.lex_state = 249},
  [5851] = {.lex_state = 210},
  [5852] = {.lex_state = 242},
  [5853] = {.lex_state = 242},
  [5854] = {.lex_state = 196},
  [5855] = {.lex_state = 180},
  [5856] = {.lex_state = 180},
  [5857] = {.lex_state = 210},
  [5858] = {.lex_state = 180},
  [5859] = {.lex_state = 243},
  [5860] = {.lex_state = 242},
  [5861] = {.lex_state = 196},
  [5862] = {.lex_state = 180},
  [5863] = {.lex_state = 243},
  [5864] = {.lex_state = 249},
  [5865] = {.lex_state = 180},
  [5866] = {.lex_state = 249},
  [5867] = {.lex_state = 243},
  [5868] = {.lex_state = 242},
  [5869] = {.lex_state = 243},
  [5870] = {.lex_state = 249},
  [5871] = {.lex_state = 180},
  [5872] = {.lex_state = 242},
  [5873] = {.lex_state = 249},
  [5874] = {.lex_state = 243},
  [5875] = {.lex_state = 196},
  [5876] = {.lex_state = 180},
  [5877] = {.lex_state = 243},
  [5878] = {.lex_state = 243},
  [5879] = {.lex_state = 180},
  [5880] = {.lex_state = 243},
  [5881] = {.lex_state = 210},
  [5882] = {.lex_state = 210},
  [5883] = {.lex_state = 180},
  [5884] = {.lex_state = 210},
  [5885] = {.lex_state = 249},
  [5886] = {.lex_state = 249},
  [5887] = {.lex_state = 242},
  [5888] = {.lex_state = 249},
  [5889] = {.lex_state = 196},
  [5890] = {.lex_state = 249},
  [5891] = {.lex_state = 249},
  [5892] = {.lex_state = 243},
  [5893] = {.lex_state = 243},
  [5894] = {.lex_state = 180},
  [5895] = {.lex_state = 180},
  [5896] = {.lex_state = 210},
  [5897] = {.lex_state = 243},
  [5898] = {.lex_state = 180},
  [5899] = {.lex_state = 243},
  [5900] = {.lex_state = 249},
  [5901] = {.lex_state = 210},
  [5902] = {.lex_state = 180},
  [5903] = {.lex_state = 180},
  [5904] = {.lex_state = 242},
  [5905] = {.lex_state = 249},
  [5906] = {.lex_state = 242},
  [5907] = {.lex_state = 249},
  [5908] = {.lex_state = 242},
  [5909] = {.lex_state = 243},
  [5910] = {.lex_state = 210},
  [5911] = {.lex_state = 180},
  [5912] = {.lex_state = 242},
  [5913] = {.lex_state = 243},
  [5914] = {.lex_state = 243},
  [5915] = {.lex_state = 180},
  [5916] = {.lex_state = 196},
  [5917] = {.lex_state = 180},
  [5918] = {.lex_state = 242},
  [5919] = {.lex_state = 210},
  [5920] = {.lex_state = 180},
  [5921] = {.lex_state = 180},
  [5922] = {.lex_state = 249},
  [5923] = {.lex_state = 243},
  [5924] = {.lex_state = 180},
  [5925] = {.lex_state = 196},
  [5926] = {.lex_state = 180},
  [5927] = {.lex_state = 210},
  [5928] = {.lex_state = 243},
  [5929] = {.lex_state = 249},
  [5930] = {.lex_state = 180},
  [5931] = {.lex_state = 243},
  [5932] = {.lex_state = 242},
  [5933] = {.lex_state = 210},
  [5934] = {.lex_state = 180},
  [5935] = {.lex_state = 196},
  [5936] = {.lex_state = 210},
  [5937] = {.lex_state = 249},
  [5938] = {.lex_state = 180},
  [5939] = {.lex_state = 180},
  [5940] = {.lex_state = 210},
  [5941] = {.lex_state = 180},
  [5942] = {.lex_state = 180},
  [5943] = {.lex_state = 180},
  [5944] = {.lex_state = 180},
  [5945] = {.lex_state = 180},
  [5946] = {.lex_state = 196},
  [5947] = {.lex_state = 249},
  [5948] = {.lex_state = 196},
  [5949] = {.lex_state = 243},
  [5950] = {.lex_state = 249},
  [5951] = {.lex_state = 249},
  [5952] = {.lex_state = 196},
  [5953] = {.lex_state = 180},
  [5954] = {.lex_state = 196},
  [5955] = {.lex_state = 196},
  [5956] = {.lex_state = 210},
  [5957] = {.lex_state = 180},
  [5958] = {.lex_state = 242},
  [5959] = {.lex_state = 243},
  [5960] = {.lex_state = 249},
  [5961] = {.lex_state = 210},
  [5962] = {.lex_state = 249},
  [5963] = {.lex_state = 249},
  [5964] = {.lex_state = 243},
  [5965] = {.lex_state = 180},
  [5966] = {.lex_state = 243},
  [5967] = {.lex_state = 243},
  [5968] = {.lex_state = 210},
  [5969] = {.lex_state = 180},
  [5970] = {.lex_state = 249},
  [5971] = {.lex_state = 242},
  [5972] = {.lex_state = 249},
  [5973] = {.lex_state = 249},
  [5974] = {.lex_state = 249},
  [5975] = {.lex_state = 196},
  [5976] = {.lex_state = 210},
  [5977] = {.lex_state = 196},
  [5978] = {.lex_state = 180},
  [5979] = {.lex_state = 243},
  [5980] = {.lex_state = 180},
  [5981] = {.lex_state = 243},
  [5982] = {.lex_state = 249},
  [5983] = {.lex_state = 243},
  [5984] = {.lex_state = 244},
  [5985] = {.lex_state = 249},
  [5986] = {.lex_state = 210},
  [5987] = {.lex_state = 243},
  [5988] = {.lex_state = 243},
  [5989] = {.lex_state = 242},
  [5990] = {.lex_state = 243},
  [5991] = {.lex_state = 180},
  [5992] = {.lex_state = 245},
  [5993] = {.lex_state = 242},
  [5994] = {.lex_state = 245},
  [5995] = {.lex_state = 197},
  [5996] = {.lex_state = 242},
  [5997] = {.lex_state = 242},
  [5998] = {.lex_state = 242},
  [5999] = {.lex_state = 242},
  [6000] = {.lex_state = 99},
  [6001] = {.lex_state = 243},
  [6002] = {.lex_state = 197},
  [6003] = {.lex_state = 243},
  [6004] = {.lex_state = 99},
  [6005] = {.lex_state = 245},
  [6006] = {.lex_state = 197},
  [6007] = {.lex_state = 99},
  [6008] = {.lex_state = 245},
  [6009] = {.lex_state = 99},
  [6010] = {.lex_state = 245},
  [6011] = {.lex_state = 99},
  [6012] = {.lex_state = 99},
  [6013] = {.lex_state = 99},
  [6014] = {.lex_state = 99},
  [6015] = {.lex_state = 99},
  [6016] = {.lex_state = 196},
  [6017] = {.lex_state = 245},
  [6018] = {.lex_state = 99},
  [6019] = {.lex_state = 243},
  [6020] = {.lex_state = 242},
  [6021] = {.lex_state = 245},
  [6022] = {.lex_state = 242},
  [6023] = {.lex_state = 99},
  [6024] = {.lex_state = 196},
  [6025] = {.lex_state = 197},
  [6026] = {.lex_state = 197},
  [6027] = {.lex_state = 99},
  [6028] = {.lex_state = 196},
  [6029] = {.lex_state = 245},
  [6030] = {.lex_state = 196},
  [6031] = {.lex_state = 242},
  [6032] = {.lex_state = 244},
  [6033] = {.lex_state = 99},
  [6034] = {.lex_state = 245},
  [6035] = {.lex_state = 245},
  [6036] = {.lex_state = 245},
  [6037] = {.lex_state = 242},
  [6038] = {.lex_state = 242},
  [6039] = {.lex_state = 99},
  [6040] = {.lex_state = 99},
  [6041] = {.lex_state = 99},
  [6042] = {.lex_state = 99},
  [6043] = {.lex_state = 196},
  [6044] = {.lex_state = 245},
  [6045] = {.lex_state = 242},
  [6046] = {.lex_state = 210},
  [6047] = {.lex_state = 245},
  [6048] = {.lex_state = 243},
  [6049] = {.lex_state = 99},
  [6050] = {.lex_state = 99},
  [6051] = {.lex_state = 196},
  [6052] = {.lex_state = 210},
  [6053] = {.lex_state = 242},
  [6054] = {.lex_state = 99},
  [6055] = {.lex_state = 245},
  [6056] = {.lex_state = 245},
  [6057] = {.lex_state = 245},
  [6058] = {.lex_state = 245},
  [6059] = {.lex_state = 245},
  [6060] = {.lex_state = 245},
  [6061] = {.lex_state = 245},
  [6062] = {.lex_state = 245},
  [6063] = {.lex_state = 197},
  [6064] = {.lex_state = 245},
  [6065] = {.lex_state = 245},
  [6066] = {.lex_state = 99},
  [6067] = {.lex_state = 99},
  [6068] = {.lex_state = 99},
  [6069] = {.lex_state = 99},
  [6070] = {.lex_state = 99},
  [6071] = {.lex_state = 99},
  [6072] = {.lex_state = 99},
  [6073] = {.lex_state = 99},
  [6074] = {.lex_state = 99},
  [6075] = {.lex_state = 99},
  [6076] = {.lex_state = 99},
  [6077] = {.lex_state = 99},
  [6078] = {.lex_state = 245},
  [6079] = {.lex_state = 245},
  [6080] = {.lex_state = 245},
  [6081] = {.lex_state = 245},
  [6082] = {.lex_state = 245},
  [6083] = {.lex_state = 245},
  [6084] = {.lex_state = 99},
  [6085] = {.lex_state = 196},
  [6086] = {.lex_state = 243},
  [6087] = {.lex_state = 243},
  [6088] = {.lex_state = 243},
  [6089] = {.lex_state = 243},
  [6090] = {.lex_state = 243},
  [6091] = {.lex_state = 245},
  [6092] = {.lex_state = 245},
  [6093] = {.lex_state = 245},
  [6094] = {.lex_state = 245},
  [6095] = {.lex_state = 245},
  [6096] = {.lex_state = 245},
  [6097] = {.lex_state = 245},
  [6098] = {.lex_state = 245},
  [6099] = {.lex_state = 243},
  [6100] = {.lex_state = 197},
  [6101] = {.lex_state = 243},
  [6102] = {.lex_state = 243},
  [6103] = {.lex_state = 197},
  [6104] = {.lex_state = 243},
  [6105] = {.lex_state = 197},
  [6106] = {.lex_state = 243},
  [6107] = {.lex_state = 243},
  [6108] = {.lex_state = 245},
  [6109] = {.lex_state = 245},
  [6110] = {.lex_state = 243},
  [6111] = {.lex_state = 196},
  [6112] = {.lex_state = 243},
  [6113] = {.lex_state = 197},
  [6114] = {.lex_state = 243},
  [6115] = {.lex_state = 243},
  [6116] = {.lex_state = 243},
  [6117] = {.lex_state = 243},
  [6118] = {.lex_state = 243},
  [6119] = {.lex_state = 243},
  [6120] = {.lex_state = 243},
  [6121] = {.lex_state = 243},
  [6122] = {.lex_state = 243},
  [6123] = {.lex_state = 243},
  [6124] = {.lex_state = 243},
  [6125] = {.lex_state = 243},
  [6126] = {.lex_state = 236},
  [6127] = {.lex_state = 207},
  [6128] = {.lex_state = 249},
  [6129] = {.lex_state = 249},
  [6130] = {.lex_state = 244},
  [6131] = {.lex_state = 243},
  [6132] = {.lex_state = 243},
  [6133] = {.lex_state = 243},
  [6134] = {.lex_state = 243},
  [6135] = {.lex_state = 243},
  [6136] = {.lex_state = 243},
  [6137] = {.lex_state = 241},
  [6138] = {.lex_state = 197},
  [6139] = {.lex_state = 197},
  [6140] = {.lex_state = 243},
  [6141] = {.lex_state = 243},
  [6142] = {.lex_state = 243},
  [6143] = {.lex_state = 243},
  [6144] = {.lex_state = 196},
  [6145] = {.lex_state = 236},
  [6146] = {.lex_state = 196},
  [6147] = {.lex_state = 197},
  [6148] = {.lex_state = 197},
  [6149] = {.lex_state = 196},
  [6150] = {.lex_state = 197},
  [6151] = {.lex_state = 241},
  [6152] = {.lex_state = 241},
  [6153] = {.lex_state = 197},
  [6154] = {.lex_state = 196},
  [6155] = {.lex_state = 236},
  [6156] = {.lex_state = 197},
  [6157] = {.lex_state = 236},
  [6158] = {.lex_state = 177},
  [6159] = {.lex_state = 177},
  [6160] = {.lex_state = 242},
  [6161] = {.lex_state = 245},
  [6162] = {.lex_state = 201},
  [6163] = {.lex_state = 201},
  [6164] = {.lex_state = 242},
  [6165] = {.lex_state = 242},
  [6166] = {.lex_state = 245},
  [6167] = {.lex_state = 243},
  [6168] = {.lex_state = 242},
  [6169] = {.lex_state = 243},
  [6170] = {.lex_state = 201},
  [6171] = {.lex_state = 243},
  [6172] = {.lex_state = 243},
  [6173] = {.lex_state = 245},
  [6174] = {.lex_state = 245},
  [6175] = {.lex_state = 243},
  [6176] = {.lex_state = 243},
  [6177] = {.lex_state = 243},
  [6178] = {.lex_state = 243},
  [6179] = {.lex_state = 243},
  [6180] = {.lex_state = 242},
  [6181] = {.lex_state = 245},
  [6182] = {.lex_state = 245},
  [6183] = {.lex_state = 243},
  [6184] = {.lex_state = 241},
  [6185] = {.lex_state = 242},
  [6186] = {.lex_state = 245},
  [6187] = {.lex_state = 201},
  [6188] = {.lex_state = 201},
  [6189] = {.lex_state = 201},
  [6190] = {.lex_state = 201},
  [6191] = {.lex_state = 243},
  [6192] = {.lex_state = 242},
  [6193] = {.lex_state = 201},
  [6194] = {.lex_state = 201},
  [6195] = {.lex_state = 201},
  [6196] = {.lex_state = 201},
  [6197] = {.lex_state = 242},
  [6198] = {.lex_state = 245},
  [6199] = {.lex_state = 201},
  [6200] = {.lex_state = 243},
  [6201] = {.lex_state = 243},
  [6202] = {.lex_state = 201},
  [6203] = {.lex_state = 243},
  [6204] = {.lex_state = 241},
  [6205] = {.lex_state = 243},
  [6206] = {.lex_state = 243},
  [6207] = {.lex_state = 242},
  [6208] = {.lex_state = 245},
  [6209] = {.lex_state = 245},
  [6210] = {.lex_state = 201},
  [6211] = {.lex_state = 201},
  [6212] = {.lex_state = 232},
  [6213] = {.lex_state = 232},
  [6214] = {.lex_state = 232},
  [6215] = {.lex_state = 232},
  [6216] = {.lex_state = 232},
  [6217] = {.lex_state = 232},
  [6218] = {.lex_state = 232},
  [6219] = {.lex_state = 232},
  [6220] = {.lex_state = 245},
  [6221] = {.lex_state = 201},
  [6222] = {.lex_state = 245},
  [6223] = {.lex_state = 242},
  [6224] = {.lex_state = 243},
  [6225] = {.lex_state = 201},
  [6226] = {.lex_state = 243},
  [6227] = {.lex_state = 243},
  [6228] = {.lex_state = 243},
  [6229] = {.lex_state = 243},
  [6230] = {.lex_state = 253},
  [6231] = {.lex_state = 243},
  [6232] = {.lex_state = 243},
  [6233] = {.lex_state = 243},
  [6234] = {.lex_state = 242},
  [6235] = {.lex_state = 242},
  [6236] = {.lex_state = 242},
  [6237] = {.lex_state = 243},
  [6238] = {.lex_state = 242},
  [6239] = {.lex_state = 242},
  [6240] = {.lex_state = 245},
  [6241] = {.lex_state = 242},
  [6242] = {.lex_state = 243},
  [6243] = {.lex_state = 245},
  [6244] = {.lex_state = 201},
  [6245] = {.lex_state = 242},
  [6246] = {.lex_state = 243},
  [6247] = {.lex_state = 201},
  [6248] = {.lex_state = 245},
  [6249] = {.lex_state = 245},
  [6250] = {.lex_state = 245},
  [6251] = {.lex_state = 243},
  [6252] = {.lex_state = 242},
  [6253] = {.lex_state = 245},
  [6254] = {.lex_state = 197},
  [6255] = {.lex_state = 242},
  [6256] = {.lex_state = 243},
  [6257] = {.lex_state = 245},
  [6258] = {.lex_state = 245},
  [6259] = {.lex_state = 245},
  [6260] = {.lex_state = 201},
  [6261] = {.lex_state = 190},
  [6262] = {.lex_state = 243},
  [6263] = {.lex_state = 243},
  [6264] = {.lex_state = 243},
  [6265] = {.lex_state = 232},
  [6266] = {.lex_state = 243},
  [6267] = {.lex_state = 232},
  [6268] = {.lex_state = 232},
  [6269] = {.lex_state = 232},
  [6270] = {.lex_state = 232},
  [6271] = {.lex_state = 241},
  [6272] = {.lex_state = 198},
  [6273] = {.lex_state = 198},
  [6274] = {.lex_state = 197},
  [6275] = {.lex_state = 198},
  [6276] = {.lex_state = 198},
  [6277] = {.lex_state = 244},
  [6278] = {.lex_state = 243},
  [6279] = {.lex_state = 243},
  [6280] = {.lex_state = 244},
  [6281] = {.lex_state = 190},
  [6282] = {.lex_state = 198},
  [6283] = {.lex_state = 232},
  [6284] = {.lex_state = 190},
  [6285] = {.lex_state = 197},
  [6286] = {.lex_state = 241},
  [6287] = {.lex_state = 190},
  [6288] = {.lex_state = 183},
  [6289] = {.lex_state = 198},
  [6290] = {.lex_state = 190},
  [6291] = {.lex_state = 197},
  [6292] = {.lex_state = 190},
  [6293] = {.lex_state = 244},
  [6294] = {.lex_state = 244},
  [6295] = {.lex_state = 243},
  [6296] = {.lex_state = 190},
  [6297] = {.lex_state = 243},
  [6298] = {.lex_state = 190},
  [6299] = {.lex_state = 243},
  [6300] = {.lex_state = 243},
  [6301] = {.lex_state = 244},
  [6302] = {.lex_state = 190},
  [6303] = {.lex_state = 190},
  [6304] = {.lex_state = 197},
  [6305] = {.lex_state = 244},
  [6306] = {.lex_state = 190},
  [6307] = {.lex_state = 190},
  [6308] = {.lex_state = 197},
  [6309] = {.lex_state = 244},
  [6310] = {.lex_state = 243},
  [6311] = {.lex_state = 243},
  [6312] = {.lex_state = 190},
  [6313] = {.lex_state = 190},
  [6314] = {.lex_state = 243},
  [6315] = {.lex_state = 241},
  [6316] = {.lex_state = 197},
  [6317] = {.lex_state = 243},
  [6318] = {.lex_state = 243},
  [6319] = {.lex_state = 243},
  [6320] = {.lex_state = 243},
  [6321] = {.lex_state = 243},
  [6322] = {.lex_state = 190},
  [6323] = {.lex_state = 243},
  [6324] = {.lex_state = 243},
  [6325] = {.lex_state = 243},
  [6326] = {.lex_state = 243},
  [6327] = {.lex_state = 244},
  [6328] = {.lex_state = 190},
  [6329] = {.lex_state = 244},
  [6330] = {.lex_state = 243},
  [6331] = {.lex_state = 190},
  [6332] = {.lex_state = 190},
  [6333] = {.lex_state = 198},
  [6334] = {.lex_state = 232},
  [6335] = {.lex_state = 190},
  [6336] = {.lex_state = 190},
  [6337] = {.lex_state = 190},
  [6338] = {.lex_state = 190},
  [6339] = {.lex_state = 232},
  [6340] = {.lex_state = 243},
  [6341] = {.lex_state = 232},
  [6342] = {.lex_state = 232},
  [6343] = {.lex_state = 243},
  [6344] = {.lex_state = 232},
  [6345] = {.lex_state = 243},
  [6346] = {.lex_state = 198},
  [6347] = {.lex_state = 243},
  [6348] = {.lex_state = 243},
  [6349] = {.lex_state = 232},
  [6350] = {.lex_state = 243},
  [6351] = {.lex_state = 197},
  [6352] = {.lex_state = 243},
  [6353] = {.lex_state = 197},
  [6354] = {.lex_state = 197},
  [6355] = {.lex_state = 243},
  [6356] = {.lex_state = 197},
  [6357] = {.lex_state = 197},
  [6358] = {.lex_state = 197},
  [6359] = {.lex_state = 197},
  [6360] = {.lex_state = 197},
  [6361] = {.lex_state = 243},
  [6362] = {.lex_state = 243},
  [6363] = {.lex_state = 243},
  [6364] = {.lex_state = 197},
  [6365] = {.lex_state = 243},
  [6366] = {.lex_state = 243},
  [6367] = {.lex_state = 243},
  [6368] = {.lex_state = 197},
  [6369] = {.lex_state = 243},
  [6370] = {.lex_state = 243},
  [6371] = {.lex_state = 241},
  [6372] = {.lex_state = 243},
  [6373] = {.lex_state = 197},
  [6374] = {.lex_state = 197},
  [6375] = {.lex_state = 243},
  [6376] = {.lex_state = 243},
  [6377] = {.lex_state = 197},
  [6378] = {.lex_state = 243},
  [6379] = {.lex_state = 243},
  [6380] = {.lex_state = 243},
  [6381] = {.lex_state = 197},
  [6382] = {.lex_state = 197},
  [6383] = {.lex_state = 245},
  [6384] = {.lex_state = 245},
  [6385] = {.lex_state = 243},
  [6386] = {.lex_state = 245},
  [6387] = {.lex_state = 197},
  [6388] = {.lex_state = 245},
  [6389] = {.lex_state = 245},
  [6390] = {.lex_state = 197},
  [6391] = {.lex_state = 245},
  [6392] = {.lex_state = 243},
  [6393] = {.lex_state = 245},
  [6394] = {.lex_state = 245},
  [6395] = {.lex_state = 243},
  [6396] = {.lex_state = 197},
  [6397] = {.lex_state = 243},
  [6398] = {.lex_state = 236},
  [6399] = {.lex_state = 197},
  [6400] = {.lex_state = 219},
  [6401] = {.lex_state = 243},
  [6402] = {.lex_state = 243},
  [6403] = {.lex_state = 197},
  [6404] = {.lex_state = 243},
  [6405] = {.lex_state = 236},
  [6406] = {.lex_state = 243},
  [6407] = {.lex_state = 219},
  [6408] = {.lex_state = 219},
  [6409] = {.lex_state = 219},
  [6410] = {.lex_state = 219},
  [6411] = {.lex_state = 219},
  [6412] = {.lex_state = 197},
  [6413] = {.lex_state = 243},
  [6414] = {.lex_state = 197},
  [6415] = {.lex_state = 219},
  [6416] = {.lex_state = 243},
  [6417] = {.lex_state = 219},
  [6418] = {.lex_state = 236},
  [6419] = {.lex_state = 197},
  [6420] = {.lex_state = 197},
  [6421] = {.lex_state = 197},
  [6422] = {.lex_state = 243},
  [6423] = {.lex_state = 243},
  [6424] = {.lex_state = 197},
  [6425] = {.lex_state = 197},
  [6426] = {.lex_state = 243},
  [6427] = {.lex_state = 243},
  [6428] = {.lex_state = 243},
  [6429] = {.lex_state = 206},
  [6430] = {.lex_state = 197},
  [6431] = {.lex_state = 197},
  [6432] = {.lex_state = 197},
  [6433] = {.lex_state = 236},
  [6434] = {.lex_state = 197},
  [6435] = {.lex_state = 196},
  [6436] = {.lex_state = 243},
  [6437] = {.lex_state = 243},
  [6438] = {.lex_state = 243},
  [6439] = {.lex_state = 197},
  [6440] = {.lex_state = 243},
  [6441] = {.lex_state = 243},
  [6442] = {.lex_state = 243},
  [6443] = {.lex_state = 197},
  [6444] = {.lex_state = 243},
  [6445] = {.lex_state = 243},
  [6446] = {.lex_state = 243},
  [6447] = {.lex_state = 177},
  [6448] = {.lex_state = 196},
  [6449] = {.lex_state = 196},
  [6450] = {.lex_state = 243},
  [6451] = {.lex_state = 197},
  [6452] = {.lex_state = 196},
  [6453] = {.lex_state = 196},
  [6454] = {.lex_state = 243},
  [6455] = {.lex_state = 197},
  [6456] = {.lex_state = 243},
  [6457] = {.lex_state = 197},
  [6458] = {.lex_state = 243},
  [6459] = {.lex_state = 243},
  [6460] = {.lex_state = 243},
  [6461] = {.lex_state = 243},
  [6462] = {.lex_state = 243},
  [6463] = {.lex_state = 243},
  [6464] = {.lex_state = 196},
  [6465] = {.lex_state = 243},
  [6466] = {.lex_state = 243},
  [6467] = {.lex_state = 243},
  [6468] = {.lex_state = 196},
  [6469] = {.lex_state = 243},
  [6470] = {.lex_state = 243},
  [6471] = {.lex_state = 243},
  [6472] = {.lex_state = 197},
  [6473] = {.lex_state = 196},
  [6474] = {.lex_state = 243},
  [6475] = {.lex_state = 243},
  [6476] = {.lex_state = 196},
  [6477] = {.lex_state = 243},
  [6478] = {.lex_state = 243},
  [6479] = {.lex_state = 243},
  [6480] = {.lex_state = 243},
  [6481] = {.lex_state = 243},
  [6482] = {.lex_state = 243},
  [6483] = {.lex_state = 243},
  [6484] = {.lex_state = 197},
  [6485] = {.lex_state = 241},
  [6486] = {.lex_state = 196},
  [6487] = {.lex_state = 196},
  [6488] = {.lex_state = 197},
  [6489] = {.lex_state = 196},
  [6490] = {.lex_state = 197},
  [6491] = {.lex_state = 197},
  [6492] = {.lex_state = 243},
  [6493] = {.lex_state = 196},
  [6494] = {.lex_state = 243},
  [6495] = {.lex_state = 196},
  [6496] = {.lex_state = 197},
  [6497] = {.lex_state = 243},
  [6498] = {.lex_state = 196},
  [6499] = {.lex_state = 197},
  [6500] = {.lex_state = 243},
  [6501] = {.lex_state = 197},
  [6502] = {.lex_state = 197},
  [6503] = {.lex_state = 196},
  [6504] = {.lex_state = 243},
  [6505] = {.lex_state = 196},
  [6506] = {.lex_state = 196},
  [6507] = {.lex_state = 243},
  [6508] = {.lex_state = 243},
  [6509] = {.lex_state = 243},
  [6510] = {.lex_state = 197},
  [6511] = {.lex_state = 197},
  [6512] = {.lex_state = 196},
  [6513] = {.lex_state = 177},
  [6514] = {.lex_state = 243},
  [6515] = {.lex_state = 243},
  [6516] = {.lex_state = 243},
  [6517] = {.lex_state = 243},
  [6518] = {.lex_state = 177},
  [6519] = {.lex_state = 243},
  [6520] = {.lex_state = 243},
  [6521] = {.lex_state = 243},
  [6522] = {.lex_state = 196},
  [6523] = {.lex_state = 197},
  [6524] = {.lex_state = 243},
  [6525] = {.lex_state = 197},
  [6526] = {.lex_state = 197},
  [6527] = {.lex_state = 243},
  [6528] = {.lex_state = 243},
  [6529] = {.lex_state = 243},
  [6530] = {.lex_state = 243},
  [6531] = {.lex_state = 241},
  [6532] = {.lex_state = 197},
  [6533] = {.lex_state = 232},
  [6534] = {.lex_state = 197},
  [6535] = {.lex_state = 197},
  [6536] = {.lex_state = 201},
  [6537] = {.lex_state = 201},
  [6538] = {.lex_state = 201},
  [6539] = {.lex_state = 201},
  [6540] = {.lex_state = 232},
  [6541] = {.lex_state = 201},
  [6542] = {.lex_state = 201},
  [6543] = {.lex_state = 201},
  [6544] = {.lex_state = 201},
  [6545] = {.lex_state = 232},
  [6546] = {.lex_state = 197},
  [6547] = {.lex_state = 243},
  [6548] = {.lex_state = 243},
  [6549] = {.lex_state = 232},
  [6550] = {.lex_state = 198},
  [6551] = {.lex_state = 243},
  [6552] = {.lex_state = 201},
  [6553] = {.lex_state = 197},
  [6554] = {.lex_state = 243},
  [6555] = {.lex_state = 243},
  [6556] = {.lex_state = 243},
  [6557] = {.lex_state = 197},
  [6558] = {.lex_state = 201},
  [6559] = {.lex_state = 197},
  [6560] = {.lex_state = 201},
  [6561] = {.lex_state = 201},
  [6562] = {.lex_state = 201},
  [6563] = {.lex_state = 198},
  [6564] = {.lex_state = 0},
  [6565] = {.lex_state = 197},
  [6566] = {.lex_state = 197},
  [6567] = {.lex_state = 232},
  [6568] = {.lex_state = 232},
  [6569] = {.lex_state = 232},
  [6570] = {.lex_state = 232},
  [6571] = {.lex_state = 243},
  [6572] = {.lex_state = 198},
  [6573] = {.lex_state = 243},
  [6574] = {.lex_state = 197},
  [6575] = {.lex_state = 201},
  [6576] = {.lex_state = 201},
  [6577] = {.lex_state = 201},
  [6578] = {.lex_state = 201},
  [6579] = {.lex_state = 197},
  [6580] = {.lex_state = 197},
  [6581] = {.lex_state = 197},
  [6582] = {.lex_state = 197},
  [6583] = {.lex_state = 243},
  [6584] = {.lex_state = 244},
  [6585] = {.lex_state = 198},
  [6586] = {.lex_state = 197},
  [6587] = {.lex_state = 197},
  [6588] = {.lex_state = 197},
  [6589] = {.lex_state = 243},
  [6590] = {.lex_state = 197},
  [6591] = {.lex_state = 197},
  [6592] = {.lex_state = 197},
  [6593] = {.lex_state = 232},
  [6594] = {.lex_state = 197},
  [6595] = {.lex_state = 197},
  [6596] = {.lex_state = 197},
  [6597] = {.lex_state = 243},
  [6598] = {.lex_state = 197},
  [6599] = {.lex_state = 197},
  [6600] = {.lex_state = 197},
  [6601] = {.lex_state = 197},
  [6602] = {.lex_state = 197},
  [6603] = {.lex_state = 196},
  [6604] = {.lex_state = 197},
  [6605] = {.lex_state = 198},
  [6606] = {.lex_state = 245},
  [6607] = {.lex_state = 197},
  [6608] = {.lex_state = 197},
  [6609] = {.lex_state = 197},
  [6610] = {.lex_state = 197},
  [6611] = {.lex_state = 198},
  [6612] = {.lex_state = 197},
  [6613] = {.lex_state = 197},
  [6614] = {.lex_state = 197},
  [6615] = {.lex_state = 197},
  [6616] = {.lex_state = 198},
  [6617] = {.lex_state = 197},
  [6618] = {.lex_state = 197},
  [6619] = {.lex_state = 244},
  [6620] = {.lex_state = 197},
  [6621] = {.lex_state = 197},
  [6622] = {.lex_state = 197},
  [6623] = {.lex_state = 197},
  [6624] = {.lex_state = 197},
  [6625] = {.lex_state = 197},
  [6626] = {.lex_state = 244},
  [6627] = {.lex_state = 244},
  [6628] = {.lex_state = 197},
  [6629] = {.lex_state = 197},
  [6630] = {.lex_state = 197},
  [6631] = {.lex_state = 244},
  [6632] = {.lex_state = 197},
  [6633] = {.lex_state = 244},
  [6634] = {.lex_state = 197},
  [6635] = {.lex_state = 197},
  [6636] = {.lex_state = 197},
  [6637] = {.lex_state = 197},
  [6638] = {.lex_state = 197},
  [6639] = {.lex_state = 197},
  [6640] = {.lex_state = 197},
  [6641] = {.lex_state = 197},
  [6642] = {.lex_state = 197},
  [6643] = {.lex_state = 197},
  [6644] = {.lex_state = 197},
  [6645] = {.lex_state = 197},
  [6646] = {.lex_state = 197},
  [6647] = {.lex_state = 197},
  [6648] = {.lex_state = 197},
  [6649] = {.lex_state = 197},
  [6650] = {.lex_state = 197},
  [6651] = {.lex_state = 197},
  [6652] = {.lex_state = 197},
  [6653] = {.lex_state = 243},
  [6654] = {.lex_state = 197},
  [6655] = {.lex_state = 197},
  [6656] = {.lex_state = 197},
  [6657] = {.lex_state = 197},
  [6658] = {.lex_state = 197},
  [6659] = {.lex_state = 198},
  [6660] = {.lex_state = 197},
  [6661] = {.lex_state = 198},
  [6662] = {.lex_state = 244},
  [6663] = {.lex_state = 244},
  [6664] = {.lex_state = 197},
  [6665] = {.lex_state = 197},
  [6666] = {.lex_state = 197},
  [6667] = {.lex_state = 197},
  [6668] = {.lex_state = 197},
  [6669] = {.lex_state = 197},
  [6670] = {.lex_state = 197},
  [6671] = {.lex_state = 197},
  [6672] = {.lex_state = 197},
  [6673] = {.lex_state = 237},
  [6674] = {.lex_state = 197},
  [6675] = {.lex_state = 197},
  [6676] = {.lex_state = 197},
  [6677] = {.lex_state = 197},
  [6678] = {.lex_state = 243},
  [6679] = {.lex_state = 243},
  [6680] = {.lex_state = 198},
  [6681] = {.lex_state = 244},
  [6682] = {.lex_state = 197},
  [6683] = {.lex_state = 197},
  [6684] = {.lex_state = 197},
  [6685] = {.lex_state = 198},
  [6686] = {.lex_state = 197},
  [6687] = {.lex_state = 197},
  [6688] = {.lex_state = 243},
  [6689] = {.lex_state = 197},
  [6690] = {.lex_state = 197},
  [6691] = {.lex_state = 197},
  [6692] = {.lex_state = 197},
  [6693] = {.lex_state = 197},
  [6694] = {.lex_state = 197},
  [6695] = {.lex_state = 197},
  [6696] = {.lex_state = 197},
  [6697] = {.lex_state = 197},
  [6698] = {.lex_state = 197},
  [6699] = {.lex_state = 197},
  [6700] = {.lex_state = 197},
  [6701] = {.lex_state = 197},
  [6702] = {.lex_state = 197},
  [6703] = {.lex_state = 197},
  [6704] = {.lex_state = 197},
  [6705] = {.lex_state = 197},
  [6706] = {.lex_state = 197},
  [6707] = {.lex_state = 197},
  [6708] = {.lex_state = 197},
  [6709] = {.lex_state = 197},
  [6710] = {.lex_state = 237},
  [6711] = {.lex_state = 197},
  [6712] = {.lex_state = 243},
  [6713] = {.lex_state = 197},
  [6714] = {.lex_state = 197},
  [6715] = {.lex_state = 243},
  [6716] = {.lex_state = 197},
  [6717] = {.lex_state = 197},
  [6718] = {.lex_state = 197},
  [6719] = {.lex_state = 245},
  [6720] = {.lex_state = 245},
  [6721] = {.lex_state = 245},
  [6722] = {.lex_state = 197},
  [6723] = {.lex_state = 197},
  [6724] = {.lex_state = 198},
  [6725] = {.lex_state = 197},
  [6726] = {.lex_state = 243},
  [6727] = {.lex_state = 243},
  [6728] = {.lex_state = 241},
  [6729] = {.lex_state = 243},
  [6730] = {.lex_state = 196},
  [6731] = {.lex_state = 196},
  [6732] = {.lex_state = 183},
  [6733] = {.lex_state = 197},
  [6734] = {.lex_state = 198},
  [6735] = {.lex_state = 183},
  [6736] = {.lex_state = 196},
  [6737] = {.lex_state = 196},
  [6738] = {.lex_state = 196},
  [6739] = {.lex_state = 196},
  [6740] = {.lex_state = 196},
  [6741] = {.lex_state = 197},
  [6742] = {.lex_state = 198},
  [6743] = {.lex_state = 197},
  [6744] = {.lex_state = 219},
  [6745] = {.lex_state = 196},
  [6746] = {.lex_state = 198},
  [6747] = {.lex_state = 198},
  [6748] = {.lex_state = 196},
  [6749] = {.lex_state = 198},
  [6750] = {.lex_state = 196},
  [6751] = {.lex_state = 196},
  [6752] = {.lex_state = 197},
  [6753] = {.lex_state = 197},
  [6754] = {.lex_state = 219},
  [6755] = {.lex_state = 219},
  [6756] = {.lex_state = 196},
  [6757] = {.lex_state = 219},
  [6758] = {.lex_state = 219},
  [6759] = {.lex_state = 197},
  [6760] = {.lex_state = 196},
  [6761] = {.lex_state = 219},
  [6762] = {.lex_state = 219},
  [6763] = {.lex_state = 219},
  [6764] = {.lex_state = 342},
  [6765] = {.lex_state = 342},
  [6766] = {.lex_state = 197},
  [6767] = {.lex_state = 197},
  [6768] = {.lex_state = 197},
  [6769] = {.lex_state = 243},
  [6770] = {.lex_state = 243},
  [6771] = {.lex_state = 342},
  [6772] = {.lex_state = 197},
  [6773] = {.lex_state = 197},
  [6774] = {.lex_state = 197},
  [6775] = {.lex_state = 197},
  [6776] = {.lex_state = 197},
  [6777] = {.lex_state = 197},
  [6778] = {.lex_state = 197},
  [6779] = {.lex_state = 243},
  [6780] = {.lex_state = 197},
  [6781] = {.lex_state = 201},
  [6782] = {.lex_state = 237},
  [6783] = {.lex_state = 201},
  [6784] = {.lex_state = 197},
  [6785] = {.lex_state = 197},
  [6786] = {.lex_state = 232},
  [6787] = {.lex_state = 232},
  [6788] = {.lex_state = 197},
  [6789] = {.lex_state = 342},
  [6790] = {.lex_state = 197},
  [6791] = {.lex_state = 197},
  [6792] = {.lex_state = 342},
  [6793] = {.lex_state = 197},
  [6794] = {.lex_state = 342},
  [6795] = {.lex_state = 237},
  [6796] = {.lex_state = 197},
  [6797] = {.lex_state = 197},
  [6798] = {.lex_state = 197},
  [6799] = {.lex_state = 197},
  [6800] = {.lex_state = 201},
  [6801] = {.lex_state = 197},
  [6802] = {.lex_state = 197},
  [6803] = {.lex_state = 197},
  [6804] = {.lex_state = 197},
  [6805] = {.lex_state = 197},
  [6806] = {.lex_state = 197},
  [6807] = {.lex_state = 197},
  [6808] = {.lex_state = 197},
  [6809] = {.lex_state = 197},
  [6810] = {.lex_state = 197},
  [6811] = {.lex_state = 237},
  [6812] = {.lex_state = 243},
  [6813] = {.lex_state = 232},
  [6814] = {.lex_state = 197},
  [6815] = {.lex_state = 197},
  [6816] = {.lex_state = 243},
  [6817] = {.lex_state = 197},
  [6818] = {.lex_state = 197},
  [6819] = {.lex_state = 232},
  [6820] = {.lex_state = 197},
  [6821] = {.lex_state = 197},
  [6822] = {.lex_state = 197},
  [6823] = {.lex_state = 197},
  [6824] = {.lex_state = 197},
  [6825] = {.lex_state = 197},
  [6826] = {.lex_state = 342},
  [6827] = {.lex_state = 197},
  [6828] = {.lex_state = 342},
  [6829] = {.lex_state = 237},
  [6830] = {.lex_state = 197},
  [6831] = {.lex_state = 197},
  [6832] = {.lex_state = 197},
  [6833] = {.lex_state = 197},
  [6834] = {.lex_state = 197},
  [6835] = {.lex_state = 197},
  [6836] = {.lex_state = 197},
  [6837] = {.lex_state = 197},
  [6838] = {.lex_state = 197},
  [6839] = {.lex_state = 197},
  [6840] = {.lex_state = 197},
  [6841] = {.lex_state = 197},
  [6842] = {.lex_state = 197},
  [6843] = {.lex_state = 201},
  [6844] = {.lex_state = 342},
  [6845] = {.lex_state = 342},
  [6846] = {.lex_state = 342},
  [6847] = {.lex_state = 197},
  [6848] = {.lex_state = 243},
  [6849] = {.lex_state = 177},
  [6850] = {.lex_state = 342},
  [6851] = {.lex_state = 244},
  [6852] = {.lex_state = 241},
  [6853] = {.lex_state = 177},
  [6854] = {.lex_state = 342},
  [6855] = {.lex_state = 196},
  [6856] = {.lex_state = 241},
  [6857] = {.lex_state = 177},
  [6858] = {.lex_state = 342},
  [6859] = {.lex_state = 342},
  [6860] = {.lex_state = 177},
  [6861] = {.lex_state = 342},
  [6862] = {.lex_state = 342},
  [6863] = {.lex_state = 342},
  [6864] = {.lex_state = 342},
  [6865] = {.lex_state = 342},
  [6866] = {.lex_state = 342},
  [6867] = {.lex_state = 197},
  [6868] = {.lex_state = 197},
  [6869] = {.lex_state = 197},
  [6870] = {.lex_state = 244},
  [6871] = {.lex_state = 245},
  [6872] = {.lex_state = 241},
  [6873] = {.lex_state = 197},
  [6874] = {.lex_state = 342},
  [6875] = {.lex_state = 342},
  [6876] = {.lex_state = 342},
  [6877] = {.lex_state = 177},
  [6878] = {.lex_state = 342},
  [6879] = {.lex_state = 197},
  [6880] = {.lex_state = 197},
  [6881] = {.lex_state = 177},
  [6882] = {.lex_state = 197},
  [6883] = {.lex_state = 197},
  [6884] = {.lex_state = 197},
  [6885] = {.lex_state = 201},
  [6886] = {.lex_state = 197},
  [6887] = {.lex_state = 201},
  [6888] = {.lex_state = 201},
  [6889] = {.lex_state = 177},
  [6890] = {.lex_state = 201},
  [6891] = {.lex_state = 243},
  [6892] = {.lex_state = 197},
  [6893] = {.lex_state = 244},
  [6894] = {.lex_state = 342},
  [6895] = {.lex_state = 342},
  [6896] = {.lex_state = 342},
  [6897] = {.lex_state = 342},
  [6898] = {.lex_state = 342},
  [6899] = {.lex_state = 201},
  [6900] = {.lex_state = 201},
  [6901] = {.lex_state = 201},
  [6902] = {.lex_state = 201},
  [6903] = {.lex_state = 244},
  [6904] = {.lex_state = 243},
  [6905] = {.lex_state = 243},
  [6906] = {.lex_state = 196},
  [6907] = {.lex_state = 243},
  [6908] = {.lex_state = 243},
  [6909] = {.lex_state = 243},
  [6910] = {.lex_state = 342},
  [6911] = {.lex_state = 244},
  [6912] = {.lex_state = 342},
  [6913] = {.lex_state = 342},
  [6914] = {.lex_state = 342},
  [6915] = {.lex_state = 177},
  [6916] = {.lex_state = 342},
  [6917] = {.lex_state = 177},
  [6918] = {.lex_state = 177},
  [6919] = {.lex_state = 342},
  [6920] = {.lex_state = 342},
  [6921] = {.lex_state = 342},
  [6922] = {.lex_state = 245},
  [6923] = {.lex_state = 177},
  [6924] = {.lex_state = 177},
  [6925] = {.lex_state = 177},
  [6926] = {.lex_state = 177},
  [6927] = {.lex_state = 177},
  [6928] = {.lex_state = 342},
  [6929] = {.lex_state = 197},
  [6930] = {.lex_state = 342},
  [6931] = {.lex_state = 197},
  [6932] = {.lex_state = 342},
  [6933] = {.lex_state = 197},
  [6934] = {.lex_state = 243},
  [6935] = {.lex_state = 241},
  [6936] = {.lex_state = 342},
  [6937] = {.lex_state = 197},
  [6938] = {.lex_state = 243},
  [6939] = {.lex_state = 197},
  [6940] = {.lex_state = 243},
  [6941] = {.lex_state = 342},
  [6942] = {.lex_state = 342},
  [6943] = {.lex_state = 243},
  [6944] = {.lex_state = 197},
  [6945] = {.lex_state = 197},
  [6946] = {.lex_state = 243},
  [6947] = {.lex_state = 342},
  [6948] = {.lex_state = 197},
  [6949] = {.lex_state = 197},
  [6950] = {.lex_state = 342},
  [6951] = {.lex_state = 342},
  [6952] = {.lex_state = 197},
  [6953] = {.lex_state = 197},
  [6954] = {.lex_state = 342},
  [6955] = {.lex_state = 197},
  [6956] = {.lex_state = 177},
  [6957] = {.lex_state = 197},
  [6958] = {.lex_state = 342},
  [6959] = {.lex_state = 197},
  [6960] = {.lex_state = 197},
  [6961] = {.lex_state = 197},
  [6962] = {.lex_state = 197},
  [6963] = {.lex_state = 197},
  [6964] = {.lex_state = 197},
  [6965] = {.lex_state = 197},
  [6966] = {.lex_state = 177},
  [6967] = {.lex_state = 197},
  [6968] = {.lex_state = 342},
  [6969] = {.lex_state = 197},
  [6970] = {.lex_state = 177},
  [6971] = {.lex_state = 342},
  [6972] = {.lex_state = 197},
  [6973] = {.lex_state = 197},
  [6974] = {.lex_state = 177},
  [6975] = {.lex_state = 197},
  [6976] = {.lex_state = 197},
  [6977] = {.lex_state = 177},
  [6978] = {.lex_state = 197},
  [6979] = {.lex_state = 196},
  [6980] = {.lex_state = 198},
  [6981] = {.lex_state = 242},
  [6982] = {.lex_state = 342},
  [6983] = {.lex_state = 198},
  [6984] = {.lex_state = 198},
  [6985] = {.lex_state = 197},
  [6986] = {.lex_state = 198},
  [6987] = {.lex_state = 242},
  [6988] = {.lex_state = 198},
  [6989] = {.lex_state = 243},
  [6990] = {.lex_state = 241},
  [6991] = {.lex_state = 242},
  [6992] = {.lex_state = 197},
  [6993] = {.lex_state = 197},
  [6994] = {.lex_state = 242},
  [6995] = {.lex_state = 197},
  [6996] = {.lex_state = 241},
  [6997] = {.lex_state = 198},
  [6998] = {.lex_state = 197},
  [6999] = {.lex_state = 197},
  [7000] = {.lex_state = 197},
  [7001] = {.lex_state = 0},
  [7002] = {.lex_state = 196},
  [7003] = {.lex_state = 342},
  [7004] = {.lex_state = 241},
  [7005] = {.lex_state = 197},
  [7006] = {.lex_state = 197},
  [7007] = {.lex_state = 197},
  [7008] = {.lex_state = 197},
  [7009] = {.lex_state = 242},
  [7010] = {.lex_state = 196},
  [7011] = {.lex_state = 342},
  [7012] = {.lex_state = 197},
  [7013] = {.lex_state = 197},
  [7014] = {.lex_state = 198},
  [7015] = {.lex_state = 241},
  [7016] = {.lex_state = 198},
  [7017] = {.lex_state = 196},
  [7018] = {.lex_state = 241},
  [7019] = {.lex_state = 241},
  [7020] = {.lex_state = 342},
  [7021] = {.lex_state = 197},
  [7022] = {.lex_state = 197},
  [7023] = {.lex_state = 197},
  [7024] = {.lex_state = 241},
  [7025] = {.lex_state = 241},
  [7026] = {.lex_state = 0},
  [7027] = {.lex_state = 196},
  [7028] = {.lex_state = 241},
  [7029] = {.lex_state = 196},
  [7030] = {.lex_state = 196},
  [7031] = {.lex_state = 342},
  [7032] = {.lex_state = 241},
  [7033] = {.lex_state = 197},
  [7034] = {.lex_state = 197},
  [7035] = {.lex_state = 197},
  [7036] = {.lex_state = 196},
  [7037] = {.lex_state = 197},
  [7038] = {.lex_state = 197},
  [7039] = {.lex_state = 197},
  [7040] = {.lex_state = 196},
  [7041] = {.lex_state = 196},
  [7042] = {.lex_state = 197},
  [7043] = {.lex_state = 196},
  [7044] = {.lex_state = 241},
  [7045] = {.lex_state = 197},
  [7046] = {.lex_state = 241},
  [7047] = {.lex_state = 241},
  [7048] = {.lex_state = 241},
  [7049] = {.lex_state = 242},
  [7050] = {.lex_state = 197},
  [7051] = {.lex_state = 197},
  [7052] = {.lex_state = 197},
  [7053] = {.lex_state = 197},
  [7054] = {.lex_state = 197},
  [7055] = {.lex_state = 197},
  [7056] = {.lex_state = 197},
  [7057] = {.lex_state = 197},
  [7058] = {.lex_state = 197},
  [7059] = {.lex_state = 200},
  [7060] = {.lex_state = 197},
  [7061] = {.lex_state = 197},
  [7062] = {.lex_state = 197},
  [7063] = {.lex_state = 197},
  [7064] = {.lex_state = 197},
  [7065] = {.lex_state = 197},
  [7066] = {.lex_state = 197},
  [7067] = {.lex_state = 200},
  [7068] = {.lex_state = 243},
  [7069] = {.lex_state = 197},
  [7070] = {.lex_state = 342},
  [7071] = {.lex_state = 342},
  [7072] = {.lex_state = 342},
  [7073] = {.lex_state = 177},
  [7074] = {.lex_state = 241},
  [7075] = {.lex_state = 197},
  [7076] = {.lex_state = 197},
  [7077] = {.lex_state = 241},
  [7078] = {.lex_state = 197},
  [7079] = {.lex_state = 197},
  [7080] = {.lex_state = 197},
  [7081] = {.lex_state = 197},
  [7082] = {.lex_state = 197},
  [7083] = {.lex_state = 197},
  [7084] = {.lex_state = 197},
  [7085] = {.lex_state = 200},
  [7086] = {.lex_state = 197},
  [7087] = {.lex_state = 342},
  [7088] = {.lex_state = 197},
  [7089] = {.lex_state = 197},
  [7090] = {.lex_state = 173},
  [7091] = {.lex_state = 200},
  [7092] = {.lex_state = 197},
  [7093] = {.lex_state = 200},
  [7094] = {.lex_state = 200},
  [7095] = {.lex_state = 243},
  [7096] = {.lex_state = 197},
  [7097] = {.lex_state = 243},
  [7098] = {.lex_state = 197},
  [7099] = {.lex_state = 197},
  [7100] = {.lex_state = 197},
  [7101] = {.lex_state = 197},
  [7102] = {.lex_state = 197},
  [7103] = {.lex_state = 197},
  [7104] = {.lex_state = 197},
  [7105] = {.lex_state = 197},
  [7106] = {.lex_state = 197},
  [7107] = {.lex_state = 243},
  [7108] = {.lex_state = 197},
  [7109] = {.lex_state = 241},
  [7110] = {.lex_state = 197},
  [7111] = {.lex_state = 197},
  [7112] = {.lex_state = 200},
  [7113] = {.lex_state = 197},
  [7114] = {.lex_state = 177},
  [7115] = {.lex_state = 197},
  [7116] = {.lex_state = 177},
  [7117] = {.lex_state = 197},
  [7118] = {.lex_state = 197},
  [7119] = {.lex_state = 197},
  [7120] = {.lex_state = 197},
  [7121] = {.lex_state = 197},
  [7122] = {.lex_state = 200},
  [7123] = {.lex_state = 197},
  [7124] = {.lex_state = 177},
  [7125] = {.lex_state = 197},
  [7126] = {.lex_state = 197},
  [7127] = {.lex_state = 173},
  [7128] = {.lex_state = 197},
  [7129] = {.lex_state = 243},
  [7130] = {.lex_state = 197},
  [7131] = {.lex_state = 197},
  [7132] = {.lex_state = 241},
  [7133] = {.lex_state = 243},
  [7134] = {.lex_state = 197},
  [7135] = {.lex_state = 342},
  [7136] = {.lex_state = 342},
  [7137] = {.lex_state = 200},
  [7138] = {.lex_state = 200},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 0},
  [7141] = {.lex_state = 200},
  [7142] = {.lex_state = 200},
  [7143] = {.lex_state = 110},
  [7144] = {.lex_state = 342},
  [7145] = {.lex_state = 115},
  [7146] = {.lex_state = 342},
  [7147] = {.lex_state = 342},
  [7148] = {.lex_state = 342},
  [7149] = {.lex_state = 0},
  [7150] = {.lex_state = 197},
  [7151] = {.lex_state = 115},
  [7152] = {.lex_state = 342},
  [7153] = {.lex_state = 200},
  [7154] = {.lex_state = 197},
  [7155] = {.lex_state = 115},
  [7156] = {.lex_state = 200},
  [7157] = {.lex_state = 200},
  [7158] = {.lex_state = 200},
  [7159] = {.lex_state = 117},
  [7160] = {.lex_state = 342},
  [7161] = {.lex_state = 115},
  [7162] = {.lex_state = 200},
  [7163] = {.lex_state = 342},
  [7164] = {.lex_state = 200},
  [7165] = {.lex_state = 173},
  [7166] = {.lex_state = 200},
  [7167] = {.lex_state = 241},
  [7168] = {.lex_state = 342},
  [7169] = {.lex_state = 200},
  [7170] = {.lex_state = 241},
  [7171] = {.lex_state = 197},
  [7172] = {.lex_state = 0},
  [7173] = {.lex_state = 200},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 342},
  [7176] = {.lex_state = 115},
  [7177] = {.lex_state = 0},
  [7178] = {.lex_state = 200},
  [7179] = {.lex_state = 200},
  [7180] = {.lex_state = 115},
  [7181] = {.lex_state = 0},
  [7182] = {.lex_state = 200},
  [7183] = {.lex_state = 200},
  [7184] = {.lex_state = 342},
  [7185] = {.lex_state = 117},
  [7186] = {.lex_state = 115},
  [7187] = {.lex_state = 342},
  [7188] = {.lex_state = 342},
  [7189] = {.lex_state = 0},
  [7190] = {.lex_state = 200},
  [7191] = {.lex_state = 0},
  [7192] = {.lex_state = 200},
  [7193] = {.lex_state = 115},
  [7194] = {.lex_state = 241},
  [7195] = {.lex_state = 200},
  [7196] = {.lex_state = 200},
  [7197] = {.lex_state = 342},
  [7198] = {.lex_state = 197},
  [7199] = {.lex_state = 197},
  [7200] = {.lex_state = 0},
  [7201] = {.lex_state = 200},
  [7202] = {.lex_state = 241},
  [7203] = {.lex_state = 342},
  [7204] = {.lex_state = 200},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 241},
  [7207] = {.lex_state = 197},
  [7208] = {.lex_state = 197},
  [7209] = {.lex_state = 115},
  [7210] = {.lex_state = 0},
  [7211] = {.lex_state = 110},
  [7212] = {.lex_state = 200},
  [7213] = {.lex_state = 200},
  [7214] = {.lex_state = 200},
  [7215] = {.lex_state = 200},
  [7216] = {.lex_state = 200},
  [7217] = {.lex_state = 200},
  [7218] = {.lex_state = 117},
  [7219] = {.lex_state = 115},
  [7220] = {.lex_state = 342},
  [7221] = {.lex_state = 200},
  [7222] = {.lex_state = 200},
  [7223] = {.lex_state = 241},
  [7224] = {.lex_state = 342},
  [7225] = {.lex_state = 200},
  [7226] = {.lex_state = 110},
  [7227] = {.lex_state = 200},
  [7228] = {.lex_state = 0},
  [7229] = {.lex_state = 342},
  [7230] = {.lex_state = 200},
  [7231] = {.lex_state = 200},
  [7232] = {.lex_state = 342},
  [7233] = {.lex_state = 342},
  [7234] = {.lex_state = 0},
  [7235] = {.lex_state = 342},
  [7236] = {.lex_state = 200},
  [7237] = {.lex_state = 342},
  [7238] = {.lex_state = 200},
  [7239] = {.lex_state = 200},
  [7240] = {.lex_state = 342},
  [7241] = {.lex_state = 200},
  [7242] = {.lex_state = 200},
  [7243] = {.lex_state = 110},
  [7244] = {.lex_state = 200},
  [7245] = {.lex_state = 0},
  [7246] = {.lex_state = 200},
  [7247] = {.lex_state = 115},
  [7248] = {.lex_state = 200},
  [7249] = {.lex_state = 342},
  [7250] = {.lex_state = 342},
  [7251] = {.lex_state = 197},
  [7252] = {.lex_state = 173},
  [7253] = {.lex_state = 200},
  [7254] = {.lex_state = 115},
  [7255] = {.lex_state = 241},
  [7256] = {.lex_state = 200},
  [7257] = {.lex_state = 342},
  [7258] = {.lex_state = 200},
  [7259] = {.lex_state = 342},
  [7260] = {.lex_state = 197},
  [7261] = {.lex_state = 115},
  [7262] = {.lex_state = 342},
  [7263] = {.lex_state = 200},
  [7264] = {.lex_state = 0},
  [7265] = {.lex_state = 115},
  [7266] = {.lex_state = 115},
  [7267] = {.lex_state = 342},
  [7268] = {.lex_state = 200},
  [7269] = {.lex_state = 117},
  [7270] = {.lex_state = 115},
  [7271] = {.lex_state = 117},
  [7272] = {.lex_state = 197},
  [7273] = {.lex_state = 241},
  [7274] = {.lex_state = 197},
  [7275] = {.lex_state = 200},
  [7276] = {.lex_state = 197},
  [7277] = {.lex_state = 0},
  [7278] = {.lex_state = 115},
  [7279] = {.lex_state = 200},
  [7280] = {.lex_state = 200},
  [7281] = {.lex_state = 117},
  [7282] = {.lex_state = 115},
  [7283] = {.lex_state = 115},
  [7284] = {.lex_state = 241},
  [7285] = {.lex_state = 241},
  [7286] = {.lex_state = 200},
  [7287] = {.lex_state = 200},
  [7288] = {.lex_state = 115},
  [7289] = {.lex_state = 200},
  [7290] = {.lex_state = 115},
  [7291] = {.lex_state = 200},
  [7292] = {.lex_state = 115},
  [7293] = {.lex_state = 110},
  [7294] = {.lex_state = 200},
  [7295] = {.lex_state = 200},
  [7296] = {.lex_state = 200},
  [7297] = {.lex_state = 117},
  [7298] = {.lex_state = 115},
  [7299] = {.lex_state = 342},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 110},
  [7302] = {.lex_state = 342},
  [7303] = {.lex_state = 117},
  [7304] = {.lex_state = 243},
  [7305] = {.lex_state = 342},
  [7306] = {.lex_state = 197},
  [7307] = {.lex_state = 342},
  [7308] = {.lex_state = 115},
  [7309] = {.lex_state = 342},
  [7310] = {.lex_state = 0},
  [7311] = {.lex_state = 115},
  [7312] = {.lex_state = 117},
  [7313] = {.lex_state = 200},
  [7314] = {.lex_state = 117},
  [7315] = {.lex_state = 342},
  [7316] = {.lex_state = 342},
  [7317] = {.lex_state = 197},
  [7318] = {.lex_state = 115},
  [7319] = {.lex_state = 342},
  [7320] = {.lex_state = 342},
  [7321] = {.lex_state = 342},
  [7322] = {.lex_state = 342},
  [7323] = {.lex_state = 197},
  [7324] = {.lex_state = 115},
  [7325] = {.lex_state = 342},
  [7326] = {.lex_state = 342},
  [7327] = {.lex_state = 0},
  [7328] = {.lex_state = 342},
  [7329] = {.lex_state = 342},
  [7330] = {.lex_state = 342},
  [7331] = {.lex_state = 0},
  [7332] = {.lex_state = 200},
  [7333] = {.lex_state = 115},
  [7334] = {.lex_state = 342},
  [7335] = {.lex_state = 200},
  [7336] = {.lex_state = 115},
  [7337] = {.lex_state = 0},
  [7338] = {.lex_state = 200},
  [7339] = {.lex_state = 200},
  [7340] = {.lex_state = 117},
  [7341] = {.lex_state = 197},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 200},
  [7344] = {.lex_state = 342},
  [7345] = {.lex_state = 115},
  [7346] = {.lex_state = 115},
  [7347] = {.lex_state = 342},
  [7348] = {.lex_state = 0},
  [7349] = {.lex_state = 115},
  [7350] = {.lex_state = 117},
  [7351] = {.lex_state = 115},
  [7352] = {.lex_state = 115},
  [7353] = {.lex_state = 0},
  [7354] = {.lex_state = 342},
  [7355] = {.lex_state = 115},
  [7356] = {.lex_state = 115},
  [7357] = {.lex_state = 342},
  [7358] = {.lex_state = 115},
  [7359] = {.lex_state = 110},
  [7360] = {.lex_state = 0},
  [7361] = {.lex_state = 342},
  [7362] = {.lex_state = 342},
  [7363] = {.lex_state = 115},
  [7364] = {.lex_state = 115},
  [7365] = {.lex_state = 342},
  [7366] = {.lex_state = 117},
  [7367] = {.lex_state = 200},
  [7368] = {.lex_state = 197},
  [7369] = {.lex_state = 0},
  [7370] = {.lex_state = 117},
  [7371] = {.lex_state = 0},
  [7372] = {.lex_state = 197},
  [7373] = {.lex_state = 0},
  [7374] = {.lex_state = 197},
  [7375] = {.lex_state = 0},
  [7376] = {.lex_state = 200},
  [7377] = {.lex_state = 200},
  [7378] = {.lex_state = 0},
  [7379] = {.lex_state = 0},
  [7380] = {.lex_state = 0},
  [7381] = {.lex_state = 197},
  [7382] = {.lex_state = 242},
  [7383] = {.lex_state = 0},
  [7384] = {.lex_state = 0},
  [7385] = {.lex_state = 197},
  [7386] = {.lex_state = 0},
  [7387] = {.lex_state = 200},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 197},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 197},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 112},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 0},
  [7396] = {.lex_state = 0},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 197},
  [7400] = {.lex_state = 197},
  [7401] = {.lex_state = 0},
  [7402] = {.lex_state = 197},
  [7403] = {.lex_state = 117},
  [7404] = {.lex_state = 0},
  [7405] = {.lex_state = 0},
  [7406] = {.lex_state = 0},
  [7407] = {.lex_state = 200},
  [7408] = {.lex_state = 0},
  [7409] = {.lex_state = 197},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 197},
  [7412] = {.lex_state = 117},
  [7413] = {.lex_state = 197},
  [7414] = {.lex_state = 0},
  [7415] = {.lex_state = 197},
  [7416] = {.lex_state = 0},
  [7417] = {.lex_state = 0},
  [7418] = {.lex_state = 0},
  [7419] = {.lex_state = 200},
  [7420] = {.lex_state = 200},
  [7421] = {.lex_state = 200},
  [7422] = {.lex_state = 200},
  [7423] = {.lex_state = 197},
  [7424] = {.lex_state = 0},
  [7425] = {.lex_state = 197},
  [7426] = {.lex_state = 200},
  [7427] = {.lex_state = 0},
  [7428] = {.lex_state = 0},
  [7429] = {.lex_state = 0},
  [7430] = {.lex_state = 0},
  [7431] = {.lex_state = 0},
  [7432] = {.lex_state = 0},
  [7433] = {.lex_state = 0},
  [7434] = {.lex_state = 200},
  [7435] = {.lex_state = 0},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 0},
  [7438] = {.lex_state = 0},
  [7439] = {.lex_state = 0},
  [7440] = {.lex_state = 197},
  [7441] = {.lex_state = 0},
  [7442] = {.lex_state = 0},
  [7443] = {.lex_state = 0},
  [7444] = {.lex_state = 197},
  [7445] = {.lex_state = 0},
  [7446] = {.lex_state = 197},
  [7447] = {.lex_state = 0},
  [7448] = {.lex_state = 0},
  [7449] = {.lex_state = 200},
  [7450] = {.lex_state = 200},
  [7451] = {.lex_state = 200},
  [7452] = {.lex_state = 197},
  [7453] = {.lex_state = 117},
  [7454] = {.lex_state = 0},
  [7455] = {.lex_state = 200},
  [7456] = {.lex_state = 200},
  [7457] = {.lex_state = 0},
  [7458] = {.lex_state = 0},
  [7459] = {.lex_state = 0},
  [7460] = {.lex_state = 0},
  [7461] = {.lex_state = 0},
  [7462] = {.lex_state = 197},
  [7463] = {.lex_state = 200},
  [7464] = {.lex_state = 0},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 197},
  [7467] = {.lex_state = 0},
  [7468] = {.lex_state = 197},
  [7469] = {.lex_state = 197},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 197},
  [7472] = {.lex_state = 0},
  [7473] = {.lex_state = 197},
  [7474] = {.lex_state = 0},
  [7475] = {.lex_state = 0},
  [7476] = {.lex_state = 197},
  [7477] = {.lex_state = 197},
  [7478] = {.lex_state = 200},
  [7479] = {.lex_state = 200},
  [7480] = {.lex_state = 0},
  [7481] = {.lex_state = 0},
  [7482] = {.lex_state = 342},
  [7483] = {.lex_state = 0},
  [7484] = {.lex_state = 197},
  [7485] = {.lex_state = 197},
  [7486] = {.lex_state = 117},
  [7487] = {.lex_state = 197},
  [7488] = {.lex_state = 0},
  [7489] = {.lex_state = 177},
  [7490] = {.lex_state = 200},
  [7491] = {.lex_state = 197},
  [7492] = {.lex_state = 197},
  [7493] = {.lex_state = 0},
  [7494] = {.lex_state = 117},
  [7495] = {.lex_state = 0},
  [7496] = {.lex_state = 173},
  [7497] = {.lex_state = 197},
  [7498] = {.lex_state = 197},
  [7499] = {.lex_state = 0},
  [7500] = {.lex_state = 0},
  [7501] = {.lex_state = 117},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 0},
  [7504] = {.lex_state = 117},
  [7505] = {.lex_state = 117},
  [7506] = {.lex_state = 0},
  [7507] = {.lex_state = 0},
  [7508] = {.lex_state = 200},
  [7509] = {.lex_state = 0},
  [7510] = {.lex_state = 197},
  [7511] = {.lex_state = 0},
  [7512] = {.lex_state = 241},
  [7513] = {.lex_state = 0},
  [7514] = {.lex_state = 0},
  [7515] = {.lex_state = 0},
  [7516] = {.lex_state = 0},
  [7517] = {.lex_state = 0},
  [7518] = {.lex_state = 197},
  [7519] = {.lex_state = 0},
  [7520] = {.lex_state = 197},
  [7521] = {.lex_state = 200},
  [7522] = {.lex_state = 0},
  [7523] = {.lex_state = 200},
  [7524] = {.lex_state = 200},
  [7525] = {.lex_state = 173},
  [7526] = {.lex_state = 0},
  [7527] = {.lex_state = 0},
  [7528] = {.lex_state = 0},
  [7529] = {.lex_state = 0},
  [7530] = {.lex_state = 112},
  [7531] = {.lex_state = 0},
  [7532] = {.lex_state = 200},
  [7533] = {.lex_state = 200},
  [7534] = {.lex_state = 0},
  [7535] = {.lex_state = 0},
  [7536] = {.lex_state = 173},
  [7537] = {.lex_state = 0},
  [7538] = {.lex_state = 197},
  [7539] = {.lex_state = 0},
  [7540] = {.lex_state = 177},
  [7541] = {.lex_state = 0},
  [7542] = {.lex_state = 200},
  [7543] = {.lex_state = 197},
  [7544] = {.lex_state = 200},
  [7545] = {.lex_state = 200},
  [7546] = {.lex_state = 200},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 200},
  [7550] = {.lex_state = 0},
  [7551] = {.lex_state = 0},
  [7552] = {.lex_state = 0},
  [7553] = {.lex_state = 0},
  [7554] = {.lex_state = 197},
  [7555] = {.lex_state = 200},
  [7556] = {.lex_state = 200},
  [7557] = {.lex_state = 0},
  [7558] = {.lex_state = 0},
  [7559] = {.lex_state = 200},
  [7560] = {.lex_state = 197},
  [7561] = {.lex_state = 200},
  [7562] = {.lex_state = 197},
  [7563] = {.lex_state = 0},
  [7564] = {.lex_state = 0},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 197},
  [7567] = {.lex_state = 197},
  [7568] = {.lex_state = 0},
  [7569] = {.lex_state = 0},
  [7570] = {.lex_state = 197},
  [7571] = {.lex_state = 0},
  [7572] = {.lex_state = 0},
  [7573] = {.lex_state = 200},
  [7574] = {.lex_state = 0},
  [7575] = {.lex_state = 0},
  [7576] = {.lex_state = 0},
  [7577] = {.lex_state = 0},
  [7578] = {.lex_state = 173},
  [7579] = {.lex_state = 0},
  [7580] = {.lex_state = 200},
  [7581] = {.lex_state = 200},
  [7582] = {.lex_state = 0},
  [7583] = {.lex_state = 200},
  [7584] = {.lex_state = 200},
  [7585] = {.lex_state = 0},
  [7586] = {.lex_state = 0},
  [7587] = {.lex_state = 0},
  [7588] = {.lex_state = 200},
  [7589] = {.lex_state = 173},
  [7590] = {.lex_state = 0},
  [7591] = {.lex_state = 0},
  [7592] = {.lex_state = 173},
  [7593] = {.lex_state = 200},
  [7594] = {.lex_state = 0},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 0},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 197},
  [7599] = {.lex_state = 0},
  [7600] = {.lex_state = 200},
  [7601] = {.lex_state = 0},
  [7602] = {.lex_state = 0},
  [7603] = {.lex_state = 197},
  [7604] = {.lex_state = 0},
  [7605] = {.lex_state = 197},
  [7606] = {.lex_state = 0},
  [7607] = {.lex_state = 197},
  [7608] = {.lex_state = 0},
  [7609] = {.lex_state = 177},
  [7610] = {.lex_state = 197},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 0},
  [7613] = {.lex_state = 0},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 0},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 197},
  [7618] = {.lex_state = 0},
  [7619] = {.lex_state = 0},
  [7620] = {.lex_state = 0},
  [7621] = {.lex_state = 0},
  [7622] = {.lex_state = 0},
  [7623] = {.lex_state = 0},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 197},
  [7626] = {.lex_state = 0},
  [7627] = {.lex_state = 0},
  [7628] = {.lex_state = 200},
  [7629] = {.lex_state = 173},
  [7630] = {.lex_state = 197},
  [7631] = {.lex_state = 342},
  [7632] = {.lex_state = 0},
  [7633] = {.lex_state = 173},
  [7634] = {.lex_state = 200},
  [7635] = {.lex_state = 200},
  [7636] = {.lex_state = 0},
  [7637] = {.lex_state = 197},
  [7638] = {.lex_state = 197},
  [7639] = {.lex_state = 173},
  [7640] = {.lex_state = 197},
  [7641] = {.lex_state = 0},
  [7642] = {.lex_state = 197},
  [7643] = {.lex_state = 0},
  [7644] = {.lex_state = 342},
  [7645] = {.lex_state = 0},
  [7646] = {.lex_state = 0},
  [7647] = {.lex_state = 0},
  [7648] = {.lex_state = 0},
  [7649] = {.lex_state = 0},
  [7650] = {.lex_state = 112},
  [7651] = {.lex_state = 197},
  [7652] = {.lex_state = 200},
  [7653] = {.lex_state = 0},
  [7654] = {.lex_state = 0},
  [7655] = {.lex_state = 200},
  [7656] = {.lex_state = 200},
  [7657] = {.lex_state = 0},
  [7658] = {.lex_state = 0},
  [7659] = {.lex_state = 197},
  [7660] = {.lex_state = 173},
  [7661] = {.lex_state = 197},
  [7662] = {.lex_state = 0},
  [7663] = {.lex_state = 197},
  [7664] = {.lex_state = 0},
  [7665] = {.lex_state = 200},
  [7666] = {.lex_state = 200},
  [7667] = {.lex_state = 0},
  [7668] = {.lex_state = 0},
  [7669] = {.lex_state = 0},
  [7670] = {.lex_state = 200},
  [7671] = {.lex_state = 0},
  [7672] = {.lex_state = 197},
  [7673] = {.lex_state = 0},
  [7674] = {.lex_state = 0},
  [7675] = {.lex_state = 200},
  [7676] = {.lex_state = 197},
  [7677] = {.lex_state = 197},
  [7678] = {.lex_state = 197},
  [7679] = {.lex_state = 200},
  [7680] = {.lex_state = 0},
  [7681] = {.lex_state = 197},
  [7682] = {.lex_state = 197},
  [7683] = {.lex_state = 117},
  [7684] = {.lex_state = 0},
  [7685] = {.lex_state = 197},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 173},
  [7688] = {.lex_state = 200},
  [7689] = {.lex_state = 200},
  [7690] = {.lex_state = 173},
  [7691] = {.lex_state = 0},
  [7692] = {.lex_state = 0},
  [7693] = {.lex_state = 0},
  [7694] = {.lex_state = 0},
  [7695] = {.lex_state = 0},
  [7696] = {.lex_state = 0},
  [7697] = {.lex_state = 0},
  [7698] = {.lex_state = 0},
  [7699] = {.lex_state = 0},
  [7700] = {.lex_state = 0},
  [7701] = {.lex_state = 0},
  [7702] = {.lex_state = 0},
  [7703] = {.lex_state = 0},
  [7704] = {.lex_state = 200},
  [7705] = {.lex_state = 0},
  [7706] = {.lex_state = 0},
  [7707] = {.lex_state = 200},
  [7708] = {.lex_state = 173},
  [7709] = {.lex_state = 197},
  [7710] = {.lex_state = 200},
  [7711] = {.lex_state = 0},
  [7712] = {.lex_state = 200},
  [7713] = {.lex_state = 197},
  [7714] = {.lex_state = 197},
  [7715] = {.lex_state = 117},
  [7716] = {.lex_state = 0},
  [7717] = {.lex_state = 0},
  [7718] = {.lex_state = 197},
  [7719] = {.lex_state = 200},
  [7720] = {.lex_state = 0},
  [7721] = {.lex_state = 197},
  [7722] = {.lex_state = 173},
  [7723] = {.lex_state = 197},
  [7724] = {.lex_state = 0},
  [7725] = {.lex_state = 0},
  [7726] = {.lex_state = 197},
  [7727] = {.lex_state = 0},
  [7728] = {.lex_state = 0},
  [7729] = {.lex_state = 0},
  [7730] = {.lex_state = 0},
  [7731] = {.lex_state = 0},
  [7732] = {.lex_state = 0},
  [7733] = {.lex_state = 0},
  [7734] = {.lex_state = 0},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 0},
  [7737] = {.lex_state = 0},
  [7738] = {.lex_state = 0},
  [7739] = {.lex_state = 197},
  [7740] = {.lex_state = 0},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 200},
  [7743] = {.lex_state = 0},
  [7744] = {.lex_state = 0},
  [7745] = {.lex_state = 200},
  [7746] = {.lex_state = 0},
  [7747] = {.lex_state = 197},
  [7748] = {.lex_state = 0},
  [7749] = {.lex_state = 197},
  [7750] = {.lex_state = 0},
  [7751] = {.lex_state = 0},
  [7752] = {.lex_state = 112},
  [7753] = {.lex_state = 0},
  [7754] = {.lex_state = 0},
  [7755] = {.lex_state = 0},
  [7756] = {.lex_state = 0},
  [7757] = {.lex_state = 0},
  [7758] = {.lex_state = 173},
  [7759] = {.lex_state = 0},
  [7760] = {.lex_state = 0},
  [7761] = {.lex_state = 173},
  [7762] = {.lex_state = 0},
  [7763] = {.lex_state = 0},
  [7764] = {.lex_state = 197},
  [7765] = {.lex_state = 0},
  [7766] = {.lex_state = 0},
  [7767] = {.lex_state = 197},
  [7768] = {.lex_state = 173},
  [7769] = {.lex_state = 197},
  [7770] = {.lex_state = 197},
  [7771] = {.lex_state = 197},
  [7772] = {.lex_state = 197},
  [7773] = {.lex_state = 0},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 0},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 0},
  [7780] = {.lex_state = 0},
  [7781] = {.lex_state = 0},
  [7782] = {.lex_state = 0},
  [7783] = {.lex_state = 0},
  [7784] = {.lex_state = 197},
  [7785] = {.lex_state = 0},
  [7786] = {.lex_state = 0},
  [7787] = {.lex_state = 197},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 0},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 0},
  [7792] = {.lex_state = 0},
  [7793] = {.lex_state = 0},
  [7794] = {.lex_state = 0},
  [7795] = {.lex_state = 0},
  [7796] = {.lex_state = 197},
  [7797] = {.lex_state = 197},
  [7798] = {.lex_state = 197},
  [7799] = {.lex_state = 0},
  [7800] = {.lex_state = 0},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 0},
  [7803] = {.lex_state = 197},
  [7804] = {.lex_state = 0},
  [7805] = {.lex_state = 0},
  [7806] = {.lex_state = 0},
  [7807] = {.lex_state = 117},
  [7808] = {.lex_state = 200},
  [7809] = {.lex_state = 197},
  [7810] = {.lex_state = 0},
  [7811] = {.lex_state = 0},
  [7812] = {.lex_state = 0},
  [7813] = {.lex_state = 0},
  [7814] = {.lex_state = 0},
  [7815] = {.lex_state = 0},
  [7816] = {.lex_state = 197},
  [7817] = {.lex_state = 0},
  [7818] = {.lex_state = 197},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 0},
  [7821] = {.lex_state = 197},
  [7822] = {.lex_state = 197},
  [7823] = {.lex_state = 197},
  [7824] = {.lex_state = 197},
  [7825] = {.lex_state = 111},
  [7826] = {.lex_state = 111},
  [7827] = {.lex_state = 342},
  [7828] = {.lex_state = 111},
  [7829] = {.lex_state = 0},
  [7830] = {.lex_state = 0},
  [7831] = {.lex_state = 0},
  [7832] = {.lex_state = 0},
  [7833] = {.lex_state = 342},
  [7834] = {.lex_state = 0},
  [7835] = {.lex_state = 197},
  [7836] = {.lex_state = 0},
  [7837] = {.lex_state = 197},
  [7838] = {.lex_state = 342},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 173},
  [7841] = {.lex_state = 0},
  [7842] = {.lex_state = 0},
  [7843] = {.lex_state = 0},
  [7844] = {.lex_state = 342},
  [7845] = {.lex_state = 342},
  [7846] = {.lex_state = 0},
  [7847] = {.lex_state = 111},
  [7848] = {.lex_state = 342, .external_lex_state = 2},
  [7849] = {.lex_state = 0},
  [7850] = {.lex_state = 197},
  [7851] = {.lex_state = 0},
  [7852] = {.lex_state = 0},
  [7853] = {.lex_state = 0},
  [7854] = {.lex_state = 342},
  [7855] = {.lex_state = 342},
  [7856] = {.lex_state = 0},
  [7857] = {.lex_state = 111},
  [7858] = {.lex_state = 342},
  [7859] = {.lex_state = 0},
  [7860] = {.lex_state = 0},
  [7861] = {.lex_state = 342},
  [7862] = {.lex_state = 342},
  [7863] = {.lex_state = 0},
  [7864] = {.lex_state = 342},
  [7865] = {.lex_state = 0},
  [7866] = {.lex_state = 0},
  [7867] = {.lex_state = 0},
  [7868] = {.lex_state = 0},
  [7869] = {.lex_state = 0},
  [7870] = {.lex_state = 0},
  [7871] = {.lex_state = 0},
  [7872] = {.lex_state = 0},
  [7873] = {.lex_state = 111},
  [7874] = {.lex_state = 197},
  [7875] = {.lex_state = 0},
  [7876] = {.lex_state = 0},
  [7877] = {.lex_state = 0},
  [7878] = {.lex_state = 342},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 342},
  [7882] = {.lex_state = 0},
  [7883] = {.lex_state = 0},
  [7884] = {.lex_state = 0},
  [7885] = {.lex_state = 0},
  [7886] = {.lex_state = 0},
  [7887] = {.lex_state = 0},
  [7888] = {.lex_state = 0},
  [7889] = {.lex_state = 0},
  [7890] = {.lex_state = 0},
  [7891] = {.lex_state = 0},
  [7892] = {.lex_state = 0},
  [7893] = {.lex_state = 0},
  [7894] = {.lex_state = 0},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 0},
  [7897] = {.lex_state = 0},
  [7898] = {.lex_state = 342},
  [7899] = {.lex_state = 0},
  [7900] = {.lex_state = 0},
  [7901] = {.lex_state = 342},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 0},
  [7904] = {.lex_state = 0},
  [7905] = {.lex_state = 0},
  [7906] = {.lex_state = 0},
  [7907] = {.lex_state = 0},
  [7908] = {.lex_state = 0},
  [7909] = {.lex_state = 0},
  [7910] = {.lex_state = 0},
  [7911] = {.lex_state = 0},
  [7912] = {.lex_state = 111},
  [7913] = {.lex_state = 0},
  [7914] = {.lex_state = 342},
  [7915] = {.lex_state = 0},
  [7916] = {.lex_state = 342},
  [7917] = {.lex_state = 0},
  [7918] = {.lex_state = 0},
  [7919] = {.lex_state = 0},
  [7920] = {.lex_state = 197},
  [7921] = {.lex_state = 0},
  [7922] = {.lex_state = 111},
  [7923] = {.lex_state = 342},
  [7924] = {.lex_state = 0},
  [7925] = {.lex_state = 0},
  [7926] = {.lex_state = 0},
  [7927] = {.lex_state = 0},
  [7928] = {.lex_state = 197},
  [7929] = {.lex_state = 0},
  [7930] = {.lex_state = 0},
  [7931] = {.lex_state = 0},
  [7932] = {.lex_state = 0},
  [7933] = {.lex_state = 173},
  [7934] = {.lex_state = 197},
  [7935] = {.lex_state = 0},
  [7936] = {.lex_state = 0},
  [7937] = {.lex_state = 0},
  [7938] = {.lex_state = 0},
  [7939] = {.lex_state = 0},
  [7940] = {.lex_state = 0},
  [7941] = {.lex_state = 111},
  [7942] = {.lex_state = 342},
  [7943] = {.lex_state = 0},
  [7944] = {.lex_state = 0},
  [7945] = {.lex_state = 0},
  [7946] = {.lex_state = 0},
  [7947] = {.lex_state = 0},
  [7948] = {.lex_state = 0},
  [7949] = {.lex_state = 342},
  [7950] = {.lex_state = 342},
  [7951] = {.lex_state = 0},
  [7952] = {.lex_state = 0},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 197},
  [7955] = {.lex_state = 0},
  [7956] = {.lex_state = 0},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 342},
  [7959] = {.lex_state = 0},
  [7960] = {.lex_state = 197},
  [7961] = {.lex_state = 342},
  [7962] = {.lex_state = 197},
  [7963] = {.lex_state = 342},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 0},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 0},
  [7969] = {.lex_state = 111},
  [7970] = {.lex_state = 342},
  [7971] = {.lex_state = 342},
  [7972] = {.lex_state = 0},
  [7973] = {.lex_state = 0},
  [7974] = {.lex_state = 0},
  [7975] = {.lex_state = 342},
  [7976] = {.lex_state = 342},
  [7977] = {.lex_state = 0},
  [7978] = {.lex_state = 342},
  [7979] = {.lex_state = 0},
  [7980] = {.lex_state = 0},
  [7981] = {.lex_state = 342},
  [7982] = {.lex_state = 0},
  [7983] = {.lex_state = 0},
  [7984] = {.lex_state = 0},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 0},
  [7987] = {.lex_state = 0},
  [7988] = {.lex_state = 342},
  [7989] = {.lex_state = 0},
  [7990] = {.lex_state = 342},
  [7991] = {.lex_state = 0},
  [7992] = {.lex_state = 0},
  [7993] = {.lex_state = 197},
  [7994] = {.lex_state = 173},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 0},
  [7997] = {.lex_state = 342},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 0},
  [8000] = {.lex_state = 342},
  [8001] = {.lex_state = 197},
  [8002] = {.lex_state = 0},
  [8003] = {.lex_state = 0},
  [8004] = {.lex_state = 0},
  [8005] = {.lex_state = 342},
  [8006] = {.lex_state = 0},
  [8007] = {.lex_state = 342},
  [8008] = {.lex_state = 0},
  [8009] = {.lex_state = 111},
  [8010] = {.lex_state = 0},
  [8011] = {.lex_state = 0},
  [8012] = {.lex_state = 342},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 0},
  [8015] = {.lex_state = 0},
  [8016] = {.lex_state = 342},
  [8017] = {.lex_state = 0},
  [8018] = {.lex_state = 342},
  [8019] = {.lex_state = 0},
  [8020] = {.lex_state = 342},
  [8021] = {.lex_state = 0},
  [8022] = {.lex_state = 0},
  [8023] = {.lex_state = 0},
  [8024] = {.lex_state = 342},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 0},
  [8027] = {.lex_state = 0},
  [8028] = {.lex_state = 342},
  [8029] = {.lex_state = 0},
  [8030] = {.lex_state = 197},
  [8031] = {.lex_state = 111},
  [8032] = {.lex_state = 342},
  [8033] = {.lex_state = 0},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 0},
  [8036] = {.lex_state = 197},
  [8037] = {.lex_state = 342},
  [8038] = {.lex_state = 342},
  [8039] = {.lex_state = 0},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 0},
  [8043] = {.lex_state = 0},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 0},
  [8046] = {.lex_state = 342},
  [8047] = {.lex_state = 0},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 0},
  [8050] = {.lex_state = 0},
  [8051] = {.lex_state = 342},
  [8052] = {.lex_state = 0},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 342},
  [8058] = {.lex_state = 197},
  [8059] = {.lex_state = 342},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 0},
  [8062] = {.lex_state = 0},
  [8063] = {.lex_state = 111},
  [8064] = {.lex_state = 342},
  [8065] = {.lex_state = 0},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 342},
  [8070] = {.lex_state = 0},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 342},
  [8073] = {.lex_state = 342},
  [8074] = {.lex_state = 342},
  [8075] = {.lex_state = 0},
  [8076] = {.lex_state = 0},
  [8077] = {.lex_state = 0},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 342},
  [8080] = {.lex_state = 0},
  [8081] = {.lex_state = 0},
  [8082] = {.lex_state = 111},
  [8083] = {.lex_state = 342},
  [8084] = {.lex_state = 0},
  [8085] = {.lex_state = 0},
  [8086] = {.lex_state = 342},
  [8087] = {.lex_state = 0},
  [8088] = {.lex_state = 0},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 342},
  [8091] = {.lex_state = 342},
  [8092] = {.lex_state = 0},
  [8093] = {.lex_state = 0},
  [8094] = {.lex_state = 342},
  [8095] = {.lex_state = 342},
  [8096] = {.lex_state = 197},
  [8097] = {.lex_state = 0},
  [8098] = {.lex_state = 0},
  [8099] = {.lex_state = 197},
  [8100] = {.lex_state = 0},
  [8101] = {.lex_state = 197},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 173},
  [8104] = {.lex_state = 173},
  [8105] = {.lex_state = 0},
  [8106] = {.lex_state = 0},
  [8107] = {.lex_state = 0},
  [8108] = {.lex_state = 342},
  [8109] = {.lex_state = 0},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 0},
  [8112] = {.lex_state = 0},
  [8113] = {.lex_state = 0},
  [8114] = {.lex_state = 0},
  [8115] = {.lex_state = 0},
  [8116] = {.lex_state = 0},
  [8117] = {.lex_state = 0},
  [8118] = {.lex_state = 0},
  [8119] = {.lex_state = 0},
  [8120] = {.lex_state = 0},
  [8121] = {.lex_state = 0},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 197},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 0},
  [8128] = {.lex_state = 342},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 342},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 0},
  [8133] = {.lex_state = 342},
  [8134] = {.lex_state = 0},
  [8135] = {.lex_state = 197},
  [8136] = {.lex_state = 0},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 0},
  [8139] = {.lex_state = 0},
  [8140] = {.lex_state = 0},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 0},
  [8143] = {.lex_state = 342},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 197},
  [8146] = {.lex_state = 111},
  [8147] = {.lex_state = 342},
  [8148] = {.lex_state = 342},
  [8149] = {.lex_state = 342},
  [8150] = {.lex_state = 342},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 0},
  [8153] = {.lex_state = 0},
  [8154] = {.lex_state = 0},
  [8155] = {.lex_state = 197},
  [8156] = {.lex_state = 0},
  [8157] = {.lex_state = 0},
  [8158] = {.lex_state = 0},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 342},
  [8161] = {.lex_state = 0},
  [8162] = {.lex_state = 342},
  [8163] = {.lex_state = 0},
  [8164] = {.lex_state = 0},
  [8165] = {.lex_state = 197},
  [8166] = {.lex_state = 0},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 342},
  [8170] = {.lex_state = 0},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 0},
  [8173] = {.lex_state = 197},
  [8174] = {.lex_state = 342},
  [8175] = {.lex_state = 0},
  [8176] = {.lex_state = 0},
  [8177] = {.lex_state = 0},
  [8178] = {.lex_state = 0},
  [8179] = {.lex_state = 197},
  [8180] = {.lex_state = 0},
  [8181] = {.lex_state = 0},
  [8182] = {.lex_state = 0},
  [8183] = {.lex_state = 0},
  [8184] = {.lex_state = 342},
  [8185] = {.lex_state = 0},
  [8186] = {.lex_state = 0},
  [8187] = {.lex_state = 0},
  [8188] = {.lex_state = 0},
  [8189] = {.lex_state = 0},
  [8190] = {.lex_state = 111},
  [8191] = {.lex_state = 0},
  [8192] = {.lex_state = 342, .external_lex_state = 2},
  [8193] = {.lex_state = 342},
  [8194] = {.lex_state = 0},
  [8195] = {.lex_state = 0},
  [8196] = {.lex_state = 0},
  [8197] = {.lex_state = 0},
  [8198] = {.lex_state = 0},
  [8199] = {.lex_state = 0},
  [8200] = {.lex_state = 0},
  [8201] = {.lex_state = 0},
  [8202] = {.lex_state = 342},
  [8203] = {.lex_state = 0},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 0},
  [8206] = {.lex_state = 0},
  [8207] = {.lex_state = 342},
  [8208] = {.lex_state = 0},
  [8209] = {.lex_state = 0},
  [8210] = {.lex_state = 342},
  [8211] = {.lex_state = 0},
  [8212] = {.lex_state = 0},
  [8213] = {.lex_state = 0},
  [8214] = {.lex_state = 0},
  [8215] = {.lex_state = 0},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 197},
  [8219] = {.lex_state = 0},
  [8220] = {.lex_state = 0},
  [8221] = {.lex_state = 0},
  [8222] = {.lex_state = 111},
  [8223] = {.lex_state = 342, .external_lex_state = 2},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 342, .external_lex_state = 2},
  [8226] = {.lex_state = 0},
  [8227] = {.lex_state = 342, .external_lex_state = 2},
  [8228] = {.lex_state = 0},
  [8229] = {.lex_state = 342, .external_lex_state = 2},
  [8230] = {.lex_state = 342},
  [8231] = {.lex_state = 342, .external_lex_state = 2},
  [8232] = {.lex_state = 342, .external_lex_state = 2},
  [8233] = {.lex_state = 342, .external_lex_state = 2},
  [8234] = {.lex_state = 342, .external_lex_state = 2},
  [8235] = {.lex_state = 342, .external_lex_state = 2},
  [8236] = {.lex_state = 342, .external_lex_state = 2},
  [8237] = {.lex_state = 342, .external_lex_state = 2},
  [8238] = {.lex_state = 342, .external_lex_state = 2},
  [8239] = {.lex_state = 342, .external_lex_state = 2},
  [8240] = {.lex_state = 342, .external_lex_state = 2},
  [8241] = {.lex_state = 342, .external_lex_state = 2},
  [8242] = {.lex_state = 342},
  [8243] = {.lex_state = 0},
  [8244] = {.lex_state = 197},
  [8245] = {.lex_state = 0},
  [8246] = {.lex_state = 0},
  [8247] = {.lex_state = 0},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 200},
  [8251] = {.lex_state = 0},
  [8252] = {.lex_state = 0},
  [8253] = {.lex_state = 0},
  [8254] = {.lex_state = 112},
  [8255] = {.lex_state = 175},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 0},
  [8261] = {.lex_state = 175},
  [8262] = {.lex_state = 0},
  [8263] = {.lex_state = 0},
  [8264] = {.lex_state = 197},
  [8265] = {.lex_state = 175},
  [8266] = {.lex_state = 0},
  [8267] = {.lex_state = 197},
  [8268] = {.lex_state = 197},
  [8269] = {.lex_state = 0},
  [8270] = {.lex_state = 175},
  [8271] = {.lex_state = 0},
  [8272] = {.lex_state = 342},
  [8273] = {.lex_state = 0},
  [8274] = {.lex_state = 0},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 175},
  [8277] = {.lex_state = 0},
  [8278] = {.lex_state = 0, .external_lex_state = 2},
  [8279] = {.lex_state = 0},
  [8280] = {.lex_state = 0},
  [8281] = {.lex_state = 197},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 200},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 0, .external_lex_state = 2},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 0},
  [8289] = {.lex_state = 197},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 112},
  [8293] = {.lex_state = 112},
  [8294] = {.lex_state = 175},
  [8295] = {.lex_state = 0},
  [8296] = {.lex_state = 175},
  [8297] = {.lex_state = 0},
  [8298] = {.lex_state = 0},
  [8299] = {.lex_state = 0},
  [8300] = {.lex_state = 0},
  [8301] = {.lex_state = 112},
  [8302] = {.lex_state = 0},
  [8303] = {.lex_state = 197},
  [8304] = {.lex_state = 197},
  [8305] = {.lex_state = 0},
  [8306] = {.lex_state = 197},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 175},
  [8309] = {.lex_state = 0},
  [8310] = {.lex_state = 0},
  [8311] = {.lex_state = 342},
  [8312] = {.lex_state = 197},
  [8313] = {.lex_state = 112},
  [8314] = {.lex_state = 197},
  [8315] = {.lex_state = 0},
  [8316] = {.lex_state = 200},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 0},
  [8319] = {.lex_state = 0},
  [8320] = {.lex_state = 342},
  [8321] = {.lex_state = 0},
  [8322] = {.lex_state = 197},
  [8323] = {.lex_state = 175},
  [8324] = {.lex_state = 0},
  [8325] = {.lex_state = 0},
  [8326] = {.lex_state = 0},
  [8327] = {.lex_state = 0},
  [8328] = {.lex_state = 0},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 0},
  [8331] = {.lex_state = 197},
  [8332] = {.lex_state = 342},
  [8333] = {.lex_state = 0},
  [8334] = {.lex_state = 197},
  [8335] = {.lex_state = 0},
  [8336] = {.lex_state = 200},
  [8337] = {.lex_state = 242},
  [8338] = {.lex_state = 0},
  [8339] = {.lex_state = 0},
  [8340] = {.lex_state = 0},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 342},
  [8343] = {.lex_state = 0},
  [8344] = {.lex_state = 0},
  [8345] = {.lex_state = 0},
  [8346] = {.lex_state = 0},
  [8347] = {.lex_state = 0},
  [8348] = {.lex_state = 175},
  [8349] = {.lex_state = 0},
  [8350] = {.lex_state = 112},
  [8351] = {.lex_state = 342},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 342},
  [8355] = {.lex_state = 0},
  [8356] = {.lex_state = 0},
  [8357] = {.lex_state = 197},
  [8358] = {.lex_state = 0},
  [8359] = {.lex_state = 342},
  [8360] = {.lex_state = 112},
  [8361] = {.lex_state = 0},
  [8362] = {.lex_state = 0},
  [8363] = {.lex_state = 0},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 0},
  [8366] = {.lex_state = 0},
  [8367] = {.lex_state = 0},
  [8368] = {.lex_state = 197},
  [8369] = {.lex_state = 0},
  [8370] = {.lex_state = 0},
  [8371] = {.lex_state = 197},
  [8372] = {.lex_state = 175},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 0},
  [8375] = {.lex_state = 197},
  [8376] = {.lex_state = 0},
  [8377] = {.lex_state = 0},
  [8378] = {.lex_state = 0},
  [8379] = {.lex_state = 197},
  [8380] = {.lex_state = 0},
  [8381] = {.lex_state = 0},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 0},
  [8384] = {.lex_state = 0},
  [8385] = {.lex_state = 0},
  [8386] = {.lex_state = 0},
  [8387] = {.lex_state = 0, .external_lex_state = 2},
  [8388] = {.lex_state = 197},
  [8389] = {.lex_state = 0},
  [8390] = {.lex_state = 0},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 0},
  [8393] = {.lex_state = 0},
  [8394] = {.lex_state = 197},
  [8395] = {.lex_state = 0},
  [8396] = {.lex_state = 0},
  [8397] = {.lex_state = 197},
  [8398] = {.lex_state = 0},
  [8399] = {.lex_state = 0},
  [8400] = {.lex_state = 0},
  [8401] = {.lex_state = 197},
  [8402] = {.lex_state = 0},
  [8403] = {.lex_state = 197},
  [8404] = {.lex_state = 0},
  [8405] = {.lex_state = 0},
  [8406] = {.lex_state = 0},
  [8407] = {.lex_state = 0},
  [8408] = {.lex_state = 342},
  [8409] = {.lex_state = 175},
  [8410] = {.lex_state = 0},
  [8411] = {.lex_state = 200},
  [8412] = {.lex_state = 0},
  [8413] = {.lex_state = 0},
  [8414] = {.lex_state = 342},
  [8415] = {.lex_state = 0},
  [8416] = {.lex_state = 0},
  [8417] = {.lex_state = 197},
  [8418] = {.lex_state = 0},
  [8419] = {.lex_state = 0},
  [8420] = {.lex_state = 175},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 197},
  [8423] = {.lex_state = 197},
  [8424] = {.lex_state = 342},
  [8425] = {.lex_state = 197},
  [8426] = {.lex_state = 200},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 0},
  [8430] = {.lex_state = 0},
  [8431] = {.lex_state = 0},
  [8432] = {.lex_state = 197},
  [8433] = {.lex_state = 0},
  [8434] = {.lex_state = 197},
  [8435] = {.lex_state = 0},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 0},
  [8438] = {.lex_state = 0},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 0},
  [8441] = {.lex_state = 197},
  [8442] = {.lex_state = 0},
  [8443] = {.lex_state = 197},
  [8444] = {.lex_state = 200},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 0},
  [8447] = {.lex_state = 200},
  [8448] = {.lex_state = 0},
  [8449] = {.lex_state = 197},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 197},
  [8452] = {.lex_state = 197},
  [8453] = {.lex_state = 197},
  [8454] = {.lex_state = 0},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 0},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 0},
  [8459] = {.lex_state = 0},
  [8460] = {.lex_state = 0, .external_lex_state = 2},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 197},
  [8463] = {.lex_state = 0},
  [8464] = {.lex_state = 0},
  [8465] = {.lex_state = 173},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 112},
  [8468] = {.lex_state = 112},
  [8469] = {.lex_state = 342},
  [8470] = {.lex_state = 342},
  [8471] = {.lex_state = 0},
  [8472] = {.lex_state = 0},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 342},
  [8475] = {.lex_state = 0},
  [8476] = {.lex_state = 200},
  [8477] = {.lex_state = 0},
  [8478] = {.lex_state = 175},
  [8479] = {.lex_state = 197},
  [8480] = {.lex_state = 0},
  [8481] = {.lex_state = 0},
  [8482] = {.lex_state = 0},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 342},
  [8485] = {.lex_state = 175},
  [8486] = {.lex_state = 0},
  [8487] = {.lex_state = 0},
  [8488] = {.lex_state = 197},
  [8489] = {.lex_state = 0},
  [8490] = {.lex_state = 112},
  [8491] = {.lex_state = 0},
  [8492] = {.lex_state = 0},
  [8493] = {.lex_state = 197},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 175},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 0},
  [8499] = {.lex_state = 0},
  [8500] = {.lex_state = 0},
  [8501] = {.lex_state = 0},
  [8502] = {.lex_state = 0},
  [8503] = {.lex_state = 0},
  [8504] = {.lex_state = 0},
  [8505] = {.lex_state = 176},
  [8506] = {.lex_state = 342},
  [8507] = {.lex_state = 197},
  [8508] = {.lex_state = 197},
  [8509] = {.lex_state = 0},
  [8510] = {.lex_state = 0},
  [8511] = {.lex_state = 176},
  [8512] = {.lex_state = 197},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 0},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 0, .external_lex_state = 2},
  [8520] = {.lex_state = 0},
  [8521] = {.lex_state = 197},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 197},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 175},
  [8526] = {.lex_state = 197},
  [8527] = {.lex_state = 0},
  [8528] = {.lex_state = 0},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 0},
  [8532] = {.lex_state = 197},
  [8533] = {.lex_state = 0},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 0},
  [8537] = {.lex_state = 342},
  [8538] = {.lex_state = 0},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 0},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 0},
  [8544] = {.lex_state = 0},
  [8545] = {.lex_state = 0},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 0},
  [8548] = {.lex_state = 0},
  [8549] = {.lex_state = 0},
  [8550] = {.lex_state = 0},
  [8551] = {.lex_state = 0},
  [8552] = {.lex_state = 342},
  [8553] = {.lex_state = 0},
  [8554] = {.lex_state = 342},
  [8555] = {.lex_state = 0},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 0},
  [8558] = {.lex_state = 197},
  [8559] = {.lex_state = 0},
  [8560] = {.lex_state = 0},
  [8561] = {.lex_state = 0},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 0},
  [8564] = {.lex_state = 200},
  [8565] = {.lex_state = 0},
  [8566] = {.lex_state = 0, .external_lex_state = 2},
  [8567] = {.lex_state = 342},
  [8568] = {.lex_state = 197},
  [8569] = {.lex_state = 0},
  [8570] = {.lex_state = 0},
  [8571] = {.lex_state = 0},
  [8572] = {.lex_state = 177},
  [8573] = {.lex_state = 0},
  [8574] = {.lex_state = 342},
  [8575] = {.lex_state = 0},
  [8576] = {.lex_state = 0},
  [8577] = {.lex_state = 197},
  [8578] = {.lex_state = 0},
  [8579] = {.lex_state = 200},
  [8580] = {.lex_state = 0},
  [8581] = {.lex_state = 0},
  [8582] = {.lex_state = 0, .external_lex_state = 2},
  [8583] = {.lex_state = 0},
  [8584] = {.lex_state = 0},
  [8585] = {.lex_state = 197},
  [8586] = {.lex_state = 0},
  [8587] = {.lex_state = 197},
  [8588] = {.lex_state = 342},
  [8589] = {.lex_state = 342},
  [8590] = {.lex_state = 0},
  [8591] = {.lex_state = 0},
  [8592] = {.lex_state = 0},
  [8593] = {.lex_state = 0},
  [8594] = {.lex_state = 0, .external_lex_state = 2},
  [8595] = {.lex_state = 0},
  [8596] = {.lex_state = 0},
  [8597] = {.lex_state = 342},
  [8598] = {.lex_state = 0},
  [8599] = {.lex_state = 342},
  [8600] = {.lex_state = 0},
  [8601] = {.lex_state = 0, .external_lex_state = 2},
  [8602] = {.lex_state = 0},
  [8603] = {.lex_state = 0},
  [8604] = {.lex_state = 0},
  [8605] = {.lex_state = 0, .external_lex_state = 2},
  [8606] = {.lex_state = 0},
  [8607] = {.lex_state = 0},
  [8608] = {.lex_state = 0},
  [8609] = {.lex_state = 0, .external_lex_state = 2},
  [8610] = {.lex_state = 0},
  [8611] = {.lex_state = 0, .external_lex_state = 2},
  [8612] = {.lex_state = 0},
  [8613] = {.lex_state = 0, .external_lex_state = 2},
  [8614] = {.lex_state = 0},
  [8615] = {.lex_state = 0, .external_lex_state = 2},
  [8616] = {.lex_state = 0},
  [8617] = {.lex_state = 0, .external_lex_state = 2},
  [8618] = {.lex_state = 0},
  [8619] = {.lex_state = 0, .external_lex_state = 2},
  [8620] = {.lex_state = 197},
  [8621] = {.lex_state = 0},
  [8622] = {.lex_state = 0},
  [8623] = {.lex_state = 342},
  [8624] = {.lex_state = 112},
  [8625] = {.lex_state = 342},
  [8626] = {.lex_state = 342},
  [8627] = {.lex_state = 342},
  [8628] = {.lex_state = 0},
  [8629] = {.lex_state = 197},
  [8630] = {.lex_state = 342},
  [8631] = {.lex_state = 175},
  [8632] = {.lex_state = 342},
  [8633] = {.lex_state = 0},
  [8634] = {.lex_state = 0},
  [8635] = {.lex_state = 175},
  [8636] = {.lex_state = 0},
  [8637] = {.lex_state = 0},
  [8638] = {.lex_state = 0},
  [8639] = {.lex_state = 0},
  [8640] = {.lex_state = 112},
  [8641] = {.lex_state = 0},
  [8642] = {.lex_state = 200},
  [8643] = {.lex_state = 112},
  [8644] = {.lex_state = 0},
  [8645] = {.lex_state = 0},
  [8646] = {.lex_state = 197},
  [8647] = {.lex_state = 197},
  [8648] = {.lex_state = 0},
  [8649] = {.lex_state = 342},
  [8650] = {.lex_state = 0},
  [8651] = {.lex_state = 0},
  [8652] = {.lex_state = 0},
  [8653] = {.lex_state = 0},
  [8654] = {.lex_state = 0},
  [8655] = {.lex_state = 342},
  [8656] = {.lex_state = 0, .external_lex_state = 3},
  [8657] = {.lex_state = 175},
  [8658] = {.lex_state = 0},
  [8659] = {.lex_state = 0},
  [8660] = {.lex_state = 342},
  [8661] = {.lex_state = 342},
  [8662] = {.lex_state = 0},
  [8663] = {.lex_state = 112},
  [8664] = {.lex_state = 0},
  [8665] = {.lex_state = 0},
  [8666] = {.lex_state = 0},
  [8667] = {.lex_state = 342},
  [8668] = {.lex_state = 0},
  [8669] = {.lex_state = 0},
  [8670] = {.lex_state = 197},
  [8671] = {.lex_state = 0},
  [8672] = {.lex_state = 112},
  [8673] = {.lex_state = 0},
  [8674] = {.lex_state = 197},
  [8675] = {.lex_state = 0},
  [8676] = {.lex_state = 0},
  [8677] = {.lex_state = 0},
  [8678] = {.lex_state = 0},
  [8679] = {.lex_state = 0},
  [8680] = {.lex_state = 0},
  [8681] = {.lex_state = 0},
  [8682] = {.lex_state = 0},
  [8683] = {.lex_state = 200},
  [8684] = {.lex_state = 200},
  [8685] = {.lex_state = 342},
  [8686] = {.lex_state = 175},
  [8687] = {.lex_state = 0},
  [8688] = {.lex_state = 197},
  [8689] = {.lex_state = 0},
  [8690] = {.lex_state = 0},
  [8691] = {.lex_state = 0},
  [8692] = {.lex_state = 200},
  [8693] = {.lex_state = 0},
  [8694] = {.lex_state = 0},
  [8695] = {.lex_state = 0},
  [8696] = {.lex_state = 342},
  [8697] = {.lex_state = 0},
  [8698] = {.lex_state = 0},
  [8699] = {.lex_state = 0},
  [8700] = {.lex_state = 0},
  [8701] = {.lex_state = 0},
  [8702] = {.lex_state = 175},
  [8703] = {.lex_state = 0},
  [8704] = {.lex_state = 0},
  [8705] = {.lex_state = 200},
  [8706] = {.lex_state = 175},
  [8707] = {.lex_state = 0},
  [8708] = {.lex_state = 197},
  [8709] = {.lex_state = 177},
  [8710] = {.lex_state = 112},
  [8711] = {.lex_state = 112},
  [8712] = {.lex_state = 197},
  [8713] = {.lex_state = 0},
  [8714] = {.lex_state = 0},
  [8715] = {.lex_state = 342},
  [8716] = {.lex_state = 175},
  [8717] = {.lex_state = 112},
  [8718] = {.lex_state = 175},
  [8719] = {.lex_state = 0},
  [8720] = {.lex_state = 342},
  [8721] = {.lex_state = 0},
  [8722] = {.lex_state = 0},
  [8723] = {.lex_state = 0},
  [8724] = {.lex_state = 200},
  [8725] = {.lex_state = 0},
  [8726] = {.lex_state = 0},
  [8727] = {.lex_state = 175},
  [8728] = {.lex_state = 197},
  [8729] = {.lex_state = 0},
  [8730] = {.lex_state = 0},
  [8731] = {.lex_state = 0},
  [8732] = {.lex_state = 0},
  [8733] = {.lex_state = 0},
  [8734] = {.lex_state = 0},
  [8735] = {.lex_state = 0},
  [8736] = {.lex_state = 0},
  [8737] = {.lex_state = 112},
  [8738] = {.lex_state = 197},
  [8739] = {.lex_state = 0},
  [8740] = {.lex_state = 0},
  [8741] = {.lex_state = 175},
  [8742] = {.lex_state = 0},
  [8743] = {.lex_state = 0},
  [8744] = {.lex_state = 0},
  [8745] = {.lex_state = 175},
  [8746] = {.lex_state = 0},
  [8747] = {.lex_state = 0},
  [8748] = {.lex_state = 0},
  [8749] = {.lex_state = 0},
  [8750] = {.lex_state = 0},
  [8751] = {.lex_state = 0},
  [8752] = {.lex_state = 0},
  [8753] = {.lex_state = 175},
  [8754] = {.lex_state = 0},
  [8755] = {.lex_state = 0},
  [8756] = {.lex_state = 175},
  [8757] = {.lex_state = 175},
  [8758] = {.lex_state = 0},
  [8759] = {.lex_state = 112},
  [8760] = {.lex_state = 0},
  [8761] = {.lex_state = 0},
  [8762] = {.lex_state = 0},
  [8763] = {.lex_state = 0},
  [8764] = {.lex_state = 0},
  [8765] = {.lex_state = 0},
  [8766] = {.lex_state = 0},
  [8767] = {.lex_state = 0},
  [8768] = {.lex_state = 0},
  [8769] = {.lex_state = 175},
  [8770] = {.lex_state = 0},
  [8771] = {.lex_state = 0},
  [8772] = {.lex_state = 0},
  [8773] = {.lex_state = 0},
  [8774] = {.lex_state = 175},
  [8775] = {.lex_state = 0},
  [8776] = {.lex_state = 200},
  [8777] = {.lex_state = 342},
  [8778] = {.lex_state = 0},
  [8779] = {.lex_state = 0},
  [8780] = {.lex_state = 0},
  [8781] = {.lex_state = 0},
  [8782] = {.lex_state = 0},
  [8783] = {.lex_state = 0},
  [8784] = {.lex_state = 0},
  [8785] = {.lex_state = 0},
  [8786] = {.lex_state = 0},
  [8787] = {.lex_state = 0},
  [8788] = {.lex_state = 112},
  [8789] = {.lex_state = 0},
  [8790] = {.lex_state = 0},
  [8791] = {.lex_state = 197},
  [8792] = {.lex_state = 0},
  [8793] = {.lex_state = 0},
  [8794] = {.lex_state = 112},
  [8795] = {.lex_state = 197},
  [8796] = {.lex_state = 0},
  [8797] = {.lex_state = 0},
  [8798] = {.lex_state = 0},
  [8799] = {.lex_state = 0},
  [8800] = {.lex_state = 197},
  [8801] = {.lex_state = 0},
  [8802] = {.lex_state = 0},
  [8803] = {.lex_state = 0},
  [8804] = {.lex_state = 0},
  [8805] = {.lex_state = 342},
  [8806] = {.lex_state = 0},
  [8807] = {.lex_state = 0},
  [8808] = {.lex_state = 0},
  [8809] = {.lex_state = 0},
  [8810] = {.lex_state = 0},
  [8811] = {.lex_state = 0},
  [8812] = {.lex_state = 0},
  [8813] = {.lex_state = 0},
  [8814] = {.lex_state = 0},
  [8815] = {.lex_state = 0},
  [8816] = {.lex_state = 0},
  [8817] = {.lex_state = 197},
  [8818] = {.lex_state = 0},
  [8819] = {.lex_state = 0},
  [8820] = {.lex_state = 0},
  [8821] = {.lex_state = 175},
  [8822] = {.lex_state = 197},
  [8823] = {.lex_state = 197},
  [8824] = {.lex_state = 0},
  [8825] = {.lex_state = 0},
  [8826] = {.lex_state = 0},
  [8827] = {.lex_state = 0},
  [8828] = {.lex_state = 175},
  [8829] = {.lex_state = 0, .external_lex_state = 3},
  [8830] = {.lex_state = 0},
  [8831] = {.lex_state = 342},
  [8832] = {.lex_state = 342},
  [8833] = {.lex_state = 342},
  [8834] = {.lex_state = 342},
  [8835] = {.lex_state = 0},
  [8836] = {.lex_state = 342},
  [8837] = {.lex_state = 0},
  [8838] = {.lex_state = 0},
  [8839] = {.lex_state = 0},
  [8840] = {.lex_state = 175},
  [8841] = {.lex_state = 0},
  [8842] = {.lex_state = 342},
  [8843] = {.lex_state = 197},
  [8844] = {.lex_state = 200},
  [8845] = {.lex_state = 342},
  [8846] = {.lex_state = 0, .external_lex_state = 3},
  [8847] = {.lex_state = 175},
  [8848] = {.lex_state = 0},
  [8849] = {.lex_state = 342},
  [8850] = {.lex_state = 0, .external_lex_state = 3},
  [8851] = {.lex_state = 342},
  [8852] = {.lex_state = 342},
  [8853] = {.lex_state = 0},
  [8854] = {.lex_state = 0},
  [8855] = {.lex_state = 0},
  [8856] = {.lex_state = 175},
  [8857] = {.lex_state = 0},
  [8858] = {.lex_state = 0},
  [8859] = {.lex_state = 0},
  [8860] = {.lex_state = 0},
  [8861] = {.lex_state = 0},
  [8862] = {.lex_state = 0},
  [8863] = {.lex_state = 200},
  [8864] = {.lex_state = 0},
  [8865] = {.lex_state = 342},
  [8866] = {.lex_state = 197},
  [8867] = {.lex_state = 342},
  [8868] = {.lex_state = 342},
  [8869] = {.lex_state = 342},
  [8870] = {.lex_state = 0},
  [8871] = {.lex_state = 342},
  [8872] = {.lex_state = 342},
  [8873] = {.lex_state = 197},
  [8874] = {.lex_state = 197},
  [8875] = {.lex_state = 0},
  [8876] = {.lex_state = 342},
  [8877] = {.lex_state = 0},
  [8878] = {.lex_state = 0},
  [8879] = {.lex_state = 342},
  [8880] = {.lex_state = 0, .external_lex_state = 3},
  [8881] = {.lex_state = 0},
  [8882] = {.lex_state = 197},
  [8883] = {.lex_state = 0},
  [8884] = {.lex_state = 197},
  [8885] = {.lex_state = 200},
  [8886] = {.lex_state = 0},
  [8887] = {.lex_state = 0},
  [8888] = {.lex_state = 200},
  [8889] = {.lex_state = 197},
  [8890] = {.lex_state = 0},
  [8891] = {.lex_state = 342},
  [8892] = {.lex_state = 342},
  [8893] = {.lex_state = 342},
  [8894] = {.lex_state = 0},
  [8895] = {.lex_state = 342},
  [8896] = {.lex_state = 197},
  [8897] = {.lex_state = 175},
  [8898] = {.lex_state = 197},
  [8899] = {.lex_state = 342},
  [8900] = {.lex_state = 0},
  [8901] = {.lex_state = 0},
  [8902] = {.lex_state = 342},
  [8903] = {.lex_state = 0, .external_lex_state = 3},
  [8904] = {.lex_state = 342},
  [8905] = {.lex_state = 0},
  [8906] = {.lex_state = 0},
  [8907] = {.lex_state = 0},
  [8908] = {.lex_state = 112},
  [8909] = {.lex_state = 0},
  [8910] = {.lex_state = 200},
  [8911] = {.lex_state = 0},
  [8912] = {.lex_state = 342},
  [8913] = {.lex_state = 342},
  [8914] = {.lex_state = 342},
  [8915] = {.lex_state = 342},
  [8916] = {.lex_state = 342},
  [8917] = {.lex_state = 197},
  [8918] = {.lex_state = 112},
  [8919] = {.lex_state = 342},
  [8920] = {.lex_state = 0},
  [8921] = {.lex_state = 342},
  [8922] = {.lex_state = 342},
  [8923] = {.lex_state = 0, .external_lex_state = 3},
  [8924] = {.lex_state = 197},
  [8925] = {.lex_state = 0},
  [8926] = {.lex_state = 0},
  [8927] = {.lex_state = 175},
  [8928] = {.lex_state = 0},
  [8929] = {.lex_state = 0},
  [8930] = {.lex_state = 200},
  [8931] = {.lex_state = 0},
  [8932] = {.lex_state = 342},
  [8933] = {.lex_state = 342},
  [8934] = {.lex_state = 342},
  [8935] = {.lex_state = 342},
  [8936] = {.lex_state = 197},
  [8937] = {.lex_state = 0},
  [8938] = {.lex_state = 0},
  [8939] = {.lex_state = 175},
  [8940] = {.lex_state = 342},
  [8941] = {.lex_state = 0, .external_lex_state = 3},
  [8942] = {.lex_state = 0},
  [8943] = {.lex_state = 0},
  [8944] = {.lex_state = 0},
  [8945] = {.lex_state = 0},
  [8946] = {.lex_state = 0},
  [8947] = {.lex_state = 0},
  [8948] = {.lex_state = 342},
  [8949] = {.lex_state = 342},
  [8950] = {.lex_state = 342},
  [8951] = {.lex_state = 0},
  [8952] = {.lex_state = 0, .external_lex_state = 3},
  [8953] = {.lex_state = 0},
  [8954] = {.lex_state = 0},
  [8955] = {.lex_state = 0},
  [8956] = {.lex_state = 0},
  [8957] = {.lex_state = 342},
  [8958] = {.lex_state = 342},
  [8959] = {.lex_state = 342},
  [8960] = {.lex_state = 0},
  [8961] = {.lex_state = 0, .external_lex_state = 3},
  [8962] = {.lex_state = 0},
  [8963] = {.lex_state = 0},
  [8964] = {.lex_state = 342},
  [8965] = {.lex_state = 342},
  [8966] = {.lex_state = 342},
  [8967] = {.lex_state = 0, .external_lex_state = 3},
  [8968] = {.lex_state = 0},
  [8969] = {.lex_state = 342},
  [8970] = {.lex_state = 0, .external_lex_state = 3},
  [8971] = {.lex_state = 0},
  [8972] = {.lex_state = 342},
  [8973] = {.lex_state = 0, .external_lex_state = 3},
  [8974] = {.lex_state = 0},
  [8975] = {.lex_state = 0, .external_lex_state = 3},
  [8976] = {.lex_state = 0},
  [8977] = {.lex_state = 0, .external_lex_state = 3},
  [8978] = {.lex_state = 0},
  [8979] = {.lex_state = 0, .external_lex_state = 3},
  [8980] = {.lex_state = 0},
  [8981] = {.lex_state = 0, .external_lex_state = 3},
  [8982] = {.lex_state = 0},
  [8983] = {.lex_state = 0, .external_lex_state = 3},
  [8984] = {.lex_state = 0},
  [8985] = {.lex_state = 0},
  [8986] = {.lex_state = 0},
  [8987] = {.lex_state = 342},
  [8988] = {.lex_state = 342},
  [8989] = {.lex_state = 197},
  [8990] = {.lex_state = 342},
  [8991] = {.lex_state = 0},
  [8992] = {.lex_state = 0},
  [8993] = {.lex_state = 0},
  [8994] = {.lex_state = 0},
  [8995] = {.lex_state = 342},
  [8996] = {.lex_state = 0},
  [8997] = {.lex_state = 175},
  [8998] = {.lex_state = 0},
  [8999] = {.lex_state = 0},
  [9000] = {.lex_state = 342},
  [9001] = {.lex_state = 0},
  [9002] = {.lex_state = 0},
  [9003] = {.lex_state = 342},
  [9004] = {.lex_state = 112},
  [9005] = {.lex_state = 0},
  [9006] = {.lex_state = 342},
  [9007] = {.lex_state = 0},
  [9008] = {.lex_state = 197},
  [9009] = {.lex_state = 0, .external_lex_state = 3},
  [9010] = {.lex_state = 0},
  [9011] = {.lex_state = 197},
  [9012] = {.lex_state = 0},
  [9013] = {.lex_state = 197},
  [9014] = {.lex_state = 0},
  [9015] = {.lex_state = 175},
  [9016] = {.lex_state = 0},
  [9017] = {.lex_state = 0},
  [9018] = {.lex_state = 0},
  [9019] = {.lex_state = 112},
  [9020] = {.lex_state = 197},
  [9021] = {.lex_state = 0},
  [9022] = {.lex_state = 112},
  [9023] = {.lex_state = 0},
  [9024] = {.lex_state = 342},
  [9025] = {.lex_state = 342},
  [9026] = {.lex_state = 0, .external_lex_state = 2},
  [9027] = {.lex_state = 0},
  [9028] = {.lex_state = 0},
  [9029] = {.lex_state = 175},
  [9030] = {.lex_state = 197},
  [9031] = {.lex_state = 173},
  [9032] = {.lex_state = 0},
  [9033] = {.lex_state = 0},
  [9034] = {.lex_state = 175},
  [9035] = {.lex_state = 0},
  [9036] = {.lex_state = 0},
  [9037] = {.lex_state = 0},
  [9038] = {.lex_state = 0},
  [9039] = {.lex_state = 200},
  [9040] = {.lex_state = 0},
  [9041] = {.lex_state = 175},
  [9042] = {.lex_state = 200},
  [9043] = {.lex_state = 175},
  [9044] = {.lex_state = 0},
  [9045] = {.lex_state = 112},
  [9046] = {.lex_state = 0},
  [9047] = {.lex_state = 200},
  [9048] = {.lex_state = 0},
  [9049] = {.lex_state = 0},
  [9050] = {.lex_state = 0},
  [9051] = {.lex_state = 0},
  [9052] = {.lex_state = 175},
  [9053] = {.lex_state = 342},
  [9054] = {.lex_state = 0},
  [9055] = {.lex_state = 0},
  [9056] = {.lex_state = 0},
  [9057] = {.lex_state = 175},
  [9058] = {.lex_state = 175},
  [9059] = {.lex_state = 197},
  [9060] = {.lex_state = 0},
  [9061] = {.lex_state = 342},
  [9062] = {.lex_state = 0},
  [9063] = {.lex_state = 342},
  [9064] = {.lex_state = 0},
  [9065] = {.lex_state = 197},
  [9066] = {.lex_state = 0},
  [9067] = {.lex_state = 0},
  [9068] = {.lex_state = 0},
  [9069] = {.lex_state = 0},
  [9070] = {.lex_state = 0},
  [9071] = {.lex_state = 200},
  [9072] = {.lex_state = 200},
  [9073] = {.lex_state = 0},
  [9074] = {.lex_state = 197},
  [9075] = {.lex_state = 342},
  [9076] = {.lex_state = 342},
  [9077] = {.lex_state = 197},
  [9078] = {.lex_state = 0},
  [9079] = {.lex_state = 197},
  [9080] = {.lex_state = 0},
  [9081] = {.lex_state = 342},
  [9082] = {.lex_state = 0},
  [9083] = {.lex_state = 197},
  [9084] = {.lex_state = 0, .external_lex_state = 3},
  [9085] = {.lex_state = 0},
  [9086] = {.lex_state = 197},
  [9087] = {.lex_state = 342},
  [9088] = {.lex_state = 0},
  [9089] = {.lex_state = 342},
  [9090] = {.lex_state = 342},
  [9091] = {.lex_state = 197},
  [9092] = {.lex_state = 197},
  [9093] = {.lex_state = 112},
  [9094] = {.lex_state = 342},
  [9095] = {.lex_state = 197},
  [9096] = {.lex_state = 0, .external_lex_state = 3},
  [9097] = {.lex_state = 0},
  [9098] = {.lex_state = 0},
  [9099] = {.lex_state = 0},
  [9100] = {.lex_state = 342},
  [9101] = {.lex_state = 197},
  [9102] = {.lex_state = 0},
  [9103] = {.lex_state = 175},
  [9104] = {.lex_state = 197},
  [9105] = {.lex_state = 0, .external_lex_state = 3},
  [9106] = {.lex_state = 0},
  [9107] = {.lex_state = 112},
  [9108] = {.lex_state = 342},
  [9109] = {.lex_state = 197},
  [9110] = {.lex_state = 0},
  [9111] = {.lex_state = 197},
  [9112] = {.lex_state = 197},
  [9113] = {.lex_state = 0, .external_lex_state = 3},
  [9114] = {.lex_state = 0},
  [9115] = {.lex_state = 342},
  [9116] = {.lex_state = 197},
  [9117] = {.lex_state = 112},
  [9118] = {.lex_state = 197},
  [9119] = {.lex_state = 0, .external_lex_state = 3},
  [9120] = {.lex_state = 342},
  [9121] = {.lex_state = 197},
  [9122] = {.lex_state = 0, .external_lex_state = 3},
  [9123] = {.lex_state = 200},
  [9124] = {.lex_state = 0, .external_lex_state = 3},
  [9125] = {.lex_state = 342},
  [9126] = {.lex_state = 0, .external_lex_state = 3},
  [9127] = {.lex_state = 0},
  [9128] = {.lex_state = 0, .external_lex_state = 3},
  [9129] = {.lex_state = 0},
  [9130] = {.lex_state = 0, .external_lex_state = 3},
  [9131] = {.lex_state = 197},
  [9132] = {.lex_state = 0, .external_lex_state = 3},
  [9133] = {.lex_state = 175},
  [9134] = {.lex_state = 0, .external_lex_state = 3},
  [9135] = {.lex_state = 197},
  [9136] = {.lex_state = 0, .external_lex_state = 3},
  [9137] = {.lex_state = 0},
  [9138] = {.lex_state = 0, .external_lex_state = 3},
  [9139] = {.lex_state = 197},
  [9140] = {.lex_state = 0, .external_lex_state = 3},
  [9141] = {.lex_state = 342},
  [9142] = {.lex_state = 342},
  [9143] = {.lex_state = 0},
  [9144] = {.lex_state = 342},
  [9145] = {.lex_state = 342},
  [9146] = {.lex_state = 197},
  [9147] = {.lex_state = 342},
  [9148] = {.lex_state = 342},
  [9149] = {.lex_state = 0},
  [9150] = {.lex_state = 342},
  [9151] = {.lex_state = 342},
  [9152] = {.lex_state = 0},
  [9153] = {.lex_state = 342},
  [9154] = {.lex_state = 342},
  [9155] = {.lex_state = 0},
  [9156] = {.lex_state = 342},
  [9157] = {.lex_state = 342},
  [9158] = {.lex_state = 342},
  [9159] = {.lex_state = 342},
  [9160] = {.lex_state = 342},
  [9161] = {.lex_state = 342},
  [9162] = {.lex_state = 342},
  [9163] = {.lex_state = 342},
  [9164] = {.lex_state = 342},
  [9165] = {.lex_state = 342},
  [9166] = {.lex_state = 342},
  [9167] = {.lex_state = 210},
  [9168] = {.lex_state = 0},
  [9169] = {.lex_state = 0},
  [9170] = {.lex_state = 0},
  [9171] = {.lex_state = 175},
  [9172] = {.lex_state = 342},
  [9173] = {.lex_state = 342},
  [9174] = {.lex_state = 342},
  [9175] = {.lex_state = 342},
  [9176] = {.lex_state = 342},
  [9177] = {.lex_state = 175},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_inout] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym___attribute] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym__Nonnull] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym___asm] = ACTIONS(1),
    [anon_sym___volatile__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [anon_sym_discard] = ACTIONS(1),
    [anon_sym_precise] = ACTIONS(1),
    [anon_sym_shared] = ACTIONS(1),
    [anon_sym_groupshared] = ACTIONS(1),
    [anon_sym_uniform] = ACTIONS(1),
    [anon_sym_row_major] = ACTIONS(1),
    [anon_sym_column_major] = ACTIONS(1),
    [anon_sym_globallycoherent] = ACTIONS(1),
    [anon_sym_centroid] = ACTIONS(1),
    [anon_sym_noperspective] = ACTIONS(1),
    [anon_sym_nointerpolation] = ACTIONS(1),
    [anon_sym_sample] = ACTIONS(1),
    [anon_sym_linear] = ACTIONS(1),
    [anon_sym_snorm] = ACTIONS(1),
    [anon_sym_unorm] = ACTIONS(1),
    [anon_sym_point] = ACTIONS(1),
    [anon_sym_line] = ACTIONS(1),
    [anon_sym_triangleadj] = ACTIONS(1),
    [anon_sym_lineadj] = ACTIONS(1),
    [anon_sym_triangle] = ACTIONS(1),
    [anon_sym_cbuffer] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(8448),
    [sym__top_level_item] = STATE(84),
    [sym_preproc_include] = STATE(84),
    [sym_preproc_def] = STATE(84),
    [sym_preproc_function_def] = STATE(84),
    [sym_preproc_call] = STATE(84),
    [sym_preproc_if] = STATE(84),
    [sym_preproc_ifdef] = STATE(84),
    [sym_function_definition] = STATE(84),
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_linkage_specification] = STATE(84),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6500),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(776),
    [sym__top_level_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym__top_level_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_case_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_expression] = STATE(5019),
    [sym__string] = STATE(5113),
    [sym_conditional_expression] = STATE(5129),
    [sym_assignment_expression] = STATE(5129),
    [sym_pointer_expression] = STATE(3985),
    [sym_unary_expression] = STATE(5129),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(5129),
    [sym_cast_expression] = STATE(5129),
    [sym_sizeof_expression] = STATE(5129),
    [sym_alignof_expression] = STATE(5129),
    [sym_offsetof_expression] = STATE(5129),
    [sym_generic_expression] = STATE(5129),
    [sym_subscript_expression] = STATE(3985),
    [sym_call_expression] = STATE(3985),
    [sym_gnu_asm_expression] = STATE(5129),
    [sym_extension_expression] = STATE(5129),
    [sym_field_expression] = STATE(3985),
    [sym_compound_literal_expression] = STATE(5129),
    [sym_parenthesized_expression] = STATE(3985),
    [sym_char_literal] = STATE(5113),
    [sym_concatenated_string] = STATE(5113),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(5129),
    [sym__empty_declaration] = STATE(84),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1910),
    [sym_dependent_type] = STATE(2348),
    [sym_module_declaration] = STATE(84),
    [sym_export_declaration] = STATE(84),
    [sym_import_declaration] = STATE(84),
    [sym_global_module_fragment_declaration] = STATE(84),
    [sym_private_module_fragment_declaration] = STATE(84),
    [sym_template_declaration] = STATE(84),
    [sym_template_instantiation] = STATE(84),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1910),
    [sym_operator_cast_definition] = STATE(84),
    [sym_operator_cast_declaration] = STATE(84),
    [sym_constructor_or_destructor_definition] = STATE(84),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(5053),
    [sym_namespace_definition] = STATE(84),
    [sym_namespace_alias_definition] = STATE(84),
    [sym_using_declaration] = STATE(84),
    [sym_alias_declaration] = STATE(84),
    [sym_static_assert_declaration] = STATE(84),
    [sym_concept_definition] = STATE(84),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(5129),
    [sym_new_expression] = STATE(5129),
    [sym_delete_expression] = STATE(5129),
    [sym_requires_clause] = STATE(5129),
    [sym_requires_expression] = STATE(5129),
    [sym_lambda_expression] = STATE(5129),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(5129),
    [sym_parameter_pack_expansion] = STATE(5129),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3891),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3985),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1336),
    [aux_sym_translation_unit_repeat1] = STATE(84),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(880),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1910),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(195),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [3] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [4] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [5] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [6] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [7] = {
    [sym__block_item] = STATE(64),
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(64),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [8] = {
    [sym__block_item] = STATE(51),
    [sym_preproc_include] = STATE(51),
    [sym_preproc_def] = STATE(51),
    [sym_preproc_function_def] = STATE(51),
    [sym_preproc_call] = STATE(51),
    [sym_preproc_if] = STATE(51),
    [sym_preproc_ifdef] = STATE(51),
    [sym_function_definition] = STATE(51),
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(51),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(51),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(51),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(51),
    [sym_template_instantiation] = STATE(51),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(51),
    [sym_operator_cast_declaration] = STATE(51),
    [sym_constructor_or_destructor_definition] = STATE(51),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(51),
    [sym_namespace_alias_definition] = STATE(51),
    [sym_using_declaration] = STATE(51),
    [sym_alias_declaration] = STATE(51),
    [sym_static_assert_declaration] = STATE(51),
    [sym_concept_definition] = STATE(51),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [9] = {
    [sym__block_item] = STATE(64),
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(64),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [10] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [11] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [12] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(169),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(175),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [13] = {
    [sym__block_item] = STATE(14),
    [sym_preproc_include] = STATE(14),
    [sym_preproc_def] = STATE(14),
    [sym_preproc_function_def] = STATE(14),
    [sym_preproc_call] = STATE(14),
    [sym_preproc_if] = STATE(14),
    [sym_preproc_ifdef] = STATE(14),
    [sym_preproc_else] = STATE(9015),
    [sym_preproc_elif] = STATE(9015),
    [sym_preproc_elifdef] = STATE(9015),
    [sym_function_definition] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_type_definition] = STATE(14),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(14),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(14),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(14),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(14),
    [sym_template_instantiation] = STATE(14),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(14),
    [sym_operator_cast_declaration] = STATE(14),
    [sym_constructor_or_destructor_definition] = STATE(14),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(14),
    [sym_namespace_alias_definition] = STATE(14),
    [sym_using_declaration] = STATE(14),
    [sym_alias_declaration] = STATE(14),
    [sym_static_assert_declaration] = STATE(14),
    [sym_concept_definition] = STATE(14),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(14),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(281),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [14] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(9171),
    [sym_preproc_elif] = STATE(9171),
    [sym_preproc_elifdef] = STATE(9171),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [15] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(8265),
    [sym_preproc_elif] = STATE(8265),
    [sym_preproc_elifdef] = STATE(8265),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [16] = {
    [sym__block_item] = STATE(18),
    [sym_preproc_include] = STATE(18),
    [sym_preproc_def] = STATE(18),
    [sym_preproc_function_def] = STATE(18),
    [sym_preproc_call] = STATE(18),
    [sym_preproc_if] = STATE(18),
    [sym_preproc_ifdef] = STATE(18),
    [sym_preproc_else] = STATE(8478),
    [sym_preproc_elif] = STATE(8478),
    [sym_preproc_elifdef] = STATE(8478),
    [sym_function_definition] = STATE(18),
    [sym_declaration] = STATE(18),
    [sym_type_definition] = STATE(18),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(18),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(18),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(18),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(18),
    [sym_template_instantiation] = STATE(18),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(18),
    [sym_operator_cast_declaration] = STATE(18),
    [sym_constructor_or_destructor_definition] = STATE(18),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(18),
    [sym_namespace_alias_definition] = STATE(18),
    [sym_using_declaration] = STATE(18),
    [sym_alias_declaration] = STATE(18),
    [sym_static_assert_declaration] = STATE(18),
    [sym_concept_definition] = STATE(18),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(18),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [17] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8485),
    [sym_preproc_elif] = STATE(8485),
    [sym_preproc_elifdef] = STATE(8485),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [18] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(9058),
    [sym_preproc_elif] = STATE(9058),
    [sym_preproc_elifdef] = STATE(9058),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [19] = {
    [sym__block_item] = STATE(23),
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(8745),
    [sym_preproc_elif] = STATE(8745),
    [sym_preproc_elifdef] = STATE(8745),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(23),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(23),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(23),
    [sym_template_instantiation] = STATE(23),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(23),
    [sym_operator_cast_declaration] = STATE(23),
    [sym_constructor_or_destructor_definition] = STATE(23),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(23),
    [sym_namespace_alias_definition] = STATE(23),
    [sym_using_declaration] = STATE(23),
    [sym_alias_declaration] = STATE(23),
    [sym_static_assert_declaration] = STATE(23),
    [sym_concept_definition] = STATE(23),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [20] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(8323),
    [sym_preproc_elif] = STATE(8323),
    [sym_preproc_elifdef] = STATE(8323),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(22),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(22),
    [sym_template_instantiation] = STATE(22),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(22),
    [sym_operator_cast_declaration] = STATE(22),
    [sym_constructor_or_destructor_definition] = STATE(22),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(22),
    [sym_namespace_alias_definition] = STATE(22),
    [sym_using_declaration] = STATE(22),
    [sym_alias_declaration] = STATE(22),
    [sym_static_assert_declaration] = STATE(22),
    [sym_concept_definition] = STATE(22),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [21] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_preproc_else] = STATE(8897),
    [sym_preproc_elif] = STATE(8897),
    [sym_preproc_elifdef] = STATE(8897),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [22] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8756),
    [sym_preproc_elif] = STATE(8756),
    [sym_preproc_elifdef] = STATE(8756),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [23] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(9034),
    [sym_preproc_elif] = STATE(9034),
    [sym_preproc_elifdef] = STATE(9034),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [24] = {
    [sym__block_item] = STATE(25),
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(9133),
    [sym_preproc_elif] = STATE(9133),
    [sym_preproc_elifdef] = STATE(9133),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(25),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [25] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8635),
    [sym_preproc_elif] = STATE(8635),
    [sym_preproc_elifdef] = STATE(8635),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(375),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [26] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8296),
    [sym_preproc_elif] = STATE(8296),
    [sym_preproc_elifdef] = STATE(8296),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(377),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [27] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_preproc_else] = STATE(8716),
    [sym_preproc_elif] = STATE(8716),
    [sym_preproc_elifdef] = STATE(8716),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(26),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(26),
    [sym_template_instantiation] = STATE(26),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(26),
    [sym_operator_cast_declaration] = STATE(26),
    [sym_constructor_or_destructor_definition] = STATE(26),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(26),
    [sym_namespace_alias_definition] = STATE(26),
    [sym_using_declaration] = STATE(26),
    [sym_alias_declaration] = STATE(26),
    [sym_static_assert_declaration] = STATE(26),
    [sym_concept_definition] = STATE(26),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(379),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [28] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8420),
    [sym_preproc_elif] = STATE(8420),
    [sym_preproc_elifdef] = STATE(8420),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(381),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [29] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8856),
    [sym_preproc_elif] = STATE(8856),
    [sym_preproc_elifdef] = STATE(8856),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(383),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [30] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(9041),
    [sym_preproc_elif] = STATE(9041),
    [sym_preproc_elifdef] = STATE(9041),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(385),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [31] = {
    [sym__block_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_preproc_else] = STATE(8294),
    [sym_preproc_elif] = STATE(8294),
    [sym_preproc_elifdef] = STATE(8294),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(28),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [32] = {
    [sym__block_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_preproc_else] = STATE(8631),
    [sym_preproc_elif] = STATE(8631),
    [sym_preproc_elifdef] = STATE(8631),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(29),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(29),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(29),
    [sym_template_instantiation] = STATE(29),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(29),
    [sym_operator_cast_declaration] = STATE(29),
    [sym_constructor_or_destructor_definition] = STATE(29),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_alias_definition] = STATE(29),
    [sym_using_declaration] = STATE(29),
    [sym_alias_declaration] = STATE(29),
    [sym_static_assert_declaration] = STATE(29),
    [sym_concept_definition] = STATE(29),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(273),
    [aux_sym_preproc_include_token1] = ACTIONS(275),
    [aux_sym_preproc_def_token1] = ACTIONS(277),
    [aux_sym_preproc_if_token1] = ACTIONS(279),
    [aux_sym_preproc_if_token2] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(283),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(283),
    [aux_sym_preproc_else_token1] = ACTIONS(285),
    [aux_sym_preproc_elif_token1] = ACTIONS(287),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(289),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(289),
    [sym_preproc_directive] = ACTIONS(291),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(295),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(299),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(305),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(333),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(339),
    [anon_sym_static_assert] = ACTIONS(341),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [33] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6530),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(347),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1903),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1903),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(1340),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1903),
    [sym_identifier] = ACTIONS(391),
    [aux_sym_preproc_include_token1] = ACTIONS(394),
    [aux_sym_preproc_def_token1] = ACTIONS(397),
    [aux_sym_preproc_if_token1] = ACTIONS(400),
    [aux_sym_preproc_if_token2] = ACTIONS(403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(405),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(405),
    [aux_sym_preproc_else_token1] = ACTIONS(403),
    [aux_sym_preproc_elif_token1] = ACTIONS(403),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(403),
    [sym_preproc_directive] = ACTIONS(408),
    [anon_sym_LPAREN2] = ACTIONS(411),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(420),
    [anon_sym_PLUS] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym___extension__] = ACTIONS(435),
    [anon_sym_typedef] = ACTIONS(438),
    [anon_sym_in] = ACTIONS(441),
    [anon_sym_out] = ACTIONS(441),
    [anon_sym_inout] = ACTIONS(441),
    [anon_sym_virtual] = ACTIONS(441),
    [anon_sym_extern] = ACTIONS(444),
    [anon_sym___attribute__] = ACTIONS(447),
    [anon_sym___attribute] = ACTIONS(447),
    [anon_sym_using] = ACTIONS(450),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(456),
    [anon_sym___declspec] = ACTIONS(459),
    [anon_sym___based] = ACTIONS(462),
    [anon_sym___cdecl] = ACTIONS(465),
    [anon_sym___clrcall] = ACTIONS(465),
    [anon_sym___stdcall] = ACTIONS(465),
    [anon_sym___fastcall] = ACTIONS(465),
    [anon_sym___thiscall] = ACTIONS(465),
    [anon_sym___vectorcall] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(468),
    [anon_sym_signed] = ACTIONS(471),
    [anon_sym_unsigned] = ACTIONS(471),
    [anon_sym_long] = ACTIONS(471),
    [anon_sym_short] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(480),
    [anon_sym___inline] = ACTIONS(477),
    [anon_sym___inline__] = ACTIONS(477),
    [anon_sym___forceinline] = ACTIONS(477),
    [anon_sym_thread_local] = ACTIONS(477),
    [anon_sym___thread] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_constexpr] = ACTIONS(483),
    [anon_sym_volatile] = ACTIONS(483),
    [anon_sym_restrict] = ACTIONS(483),
    [anon_sym___restrict__] = ACTIONS(483),
    [anon_sym__Atomic] = ACTIONS(483),
    [anon_sym__Noreturn] = ACTIONS(483),
    [anon_sym_noreturn] = ACTIONS(483),
    [anon_sym__Nonnull] = ACTIONS(483),
    [anon_sym_mutable] = ACTIONS(483),
    [anon_sym_constinit] = ACTIONS(483),
    [anon_sym_consteval] = ACTIONS(483),
    [anon_sym_alignas] = ACTIONS(486),
    [anon_sym__Alignas] = ACTIONS(486),
    [sym_primitive_type] = ACTIONS(489),
    [anon_sym_enum] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(498),
    [anon_sym_union] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(504),
    [anon_sym_switch] = ACTIONS(507),
    [anon_sym_case] = ACTIONS(510),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_while] = ACTIONS(516),
    [anon_sym_do] = ACTIONS(519),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_return] = ACTIONS(525),
    [anon_sym_break] = ACTIONS(528),
    [anon_sym_continue] = ACTIONS(531),
    [anon_sym_goto] = ACTIONS(534),
    [anon_sym___try] = ACTIONS(537),
    [anon_sym___leave] = ACTIONS(540),
    [anon_sym_not] = ACTIONS(420),
    [anon_sym_compl] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_sizeof] = ACTIONS(546),
    [anon_sym___alignof__] = ACTIONS(549),
    [anon_sym___alignof] = ACTIONS(549),
    [anon_sym__alignof] = ACTIONS(549),
    [anon_sym_alignof] = ACTIONS(549),
    [anon_sym__Alignof] = ACTIONS(549),
    [anon_sym_offsetof] = ACTIONS(552),
    [anon_sym__Generic] = ACTIONS(555),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym___asm__] = ACTIONS(558),
    [anon_sym___asm] = ACTIONS(558),
    [sym_number_literal] = ACTIONS(561),
    [anon_sym_L_SQUOTE] = ACTIONS(564),
    [anon_sym_u_SQUOTE] = ACTIONS(564),
    [anon_sym_U_SQUOTE] = ACTIONS(564),
    [anon_sym_u8_SQUOTE] = ACTIONS(564),
    [anon_sym_SQUOTE] = ACTIONS(564),
    [anon_sym_L_DQUOTE] = ACTIONS(567),
    [anon_sym_u_DQUOTE] = ACTIONS(567),
    [anon_sym_U_DQUOTE] = ACTIONS(567),
    [anon_sym_u8_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(567),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [anon_sym_NULL] = ACTIONS(573),
    [anon_sym_nullptr] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(576),
    [anon_sym_decltype] = ACTIONS(579),
    [anon_sym_explicit] = ACTIONS(582),
    [anon_sym_typename] = ACTIONS(585),
    [anon_sym_template] = ACTIONS(588),
    [anon_sym_operator] = ACTIONS(591),
    [anon_sym_try] = ACTIONS(594),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_throw] = ACTIONS(600),
    [anon_sym_namespace] = ACTIONS(603),
    [anon_sym_static_assert] = ACTIONS(606),
    [anon_sym_concept] = ACTIONS(609),
    [anon_sym_co_return] = ACTIONS(612),
    [anon_sym_co_yield] = ACTIONS(615),
    [anon_sym_R_DQUOTE] = ACTIONS(618),
    [anon_sym_LR_DQUOTE] = ACTIONS(618),
    [anon_sym_uR_DQUOTE] = ACTIONS(618),
    [anon_sym_UR_DQUOTE] = ACTIONS(618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(618),
    [anon_sym_co_await] = ACTIONS(621),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_requires] = ACTIONS(627),
    [sym_this] = ACTIONS(570),
    [anon_sym_discard] = ACTIONS(630),
    [anon_sym_precise] = ACTIONS(633),
    [anon_sym_shared] = ACTIONS(633),
    [anon_sym_groupshared] = ACTIONS(633),
    [anon_sym_uniform] = ACTIONS(633),
    [anon_sym_row_major] = ACTIONS(633),
    [anon_sym_column_major] = ACTIONS(633),
    [anon_sym_globallycoherent] = ACTIONS(633),
    [anon_sym_centroid] = ACTIONS(633),
    [anon_sym_noperspective] = ACTIONS(633),
    [anon_sym_nointerpolation] = ACTIONS(633),
    [anon_sym_sample] = ACTIONS(633),
    [anon_sym_linear] = ACTIONS(633),
    [anon_sym_snorm] = ACTIONS(633),
    [anon_sym_unorm] = ACTIONS(633),
    [anon_sym_point] = ACTIONS(633),
    [anon_sym_line] = ACTIONS(633),
    [anon_sym_triangleadj] = ACTIONS(633),
    [anon_sym_lineadj] = ACTIONS(633),
    [anon_sym_triangle] = ACTIONS(633),
    [anon_sym_cbuffer] = ACTIONS(636),
  },
  [34] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [35] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [36] = {
    [sym__block_item] = STATE(36),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2032),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6456),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(477),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2342),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(689),
    [sym_statement] = STATE(36),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(1343),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(881),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(647),
    [aux_sym_preproc_include_token1] = ACTIONS(650),
    [aux_sym_preproc_def_token1] = ACTIONS(653),
    [aux_sym_preproc_if_token1] = ACTIONS(656),
    [aux_sym_preproc_if_token2] = ACTIONS(403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(659),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(659),
    [sym_preproc_directive] = ACTIONS(662),
    [anon_sym_LPAREN2] = ACTIONS(411),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(420),
    [anon_sym_PLUS] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym___extension__] = ACTIONS(668),
    [anon_sym_typedef] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(441),
    [anon_sym_out] = ACTIONS(441),
    [anon_sym_inout] = ACTIONS(441),
    [anon_sym_virtual] = ACTIONS(441),
    [anon_sym_extern] = ACTIONS(674),
    [anon_sym___attribute__] = ACTIONS(447),
    [anon_sym___attribute] = ACTIONS(447),
    [anon_sym_using] = ACTIONS(677),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(456),
    [anon_sym___declspec] = ACTIONS(459),
    [anon_sym___based] = ACTIONS(462),
    [anon_sym___cdecl] = ACTIONS(465),
    [anon_sym___clrcall] = ACTIONS(465),
    [anon_sym___stdcall] = ACTIONS(465),
    [anon_sym___fastcall] = ACTIONS(465),
    [anon_sym___thiscall] = ACTIONS(465),
    [anon_sym___vectorcall] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(680),
    [anon_sym_signed] = ACTIONS(471),
    [anon_sym_unsigned] = ACTIONS(471),
    [anon_sym_long] = ACTIONS(471),
    [anon_sym_short] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(683),
    [anon_sym___inline] = ACTIONS(477),
    [anon_sym___inline__] = ACTIONS(477),
    [anon_sym___forceinline] = ACTIONS(477),
    [anon_sym_thread_local] = ACTIONS(477),
    [anon_sym___thread] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_constexpr] = ACTIONS(483),
    [anon_sym_volatile] = ACTIONS(483),
    [anon_sym_restrict] = ACTIONS(483),
    [anon_sym___restrict__] = ACTIONS(483),
    [anon_sym__Atomic] = ACTIONS(483),
    [anon_sym__Noreturn] = ACTIONS(483),
    [anon_sym_noreturn] = ACTIONS(483),
    [anon_sym__Nonnull] = ACTIONS(483),
    [anon_sym_mutable] = ACTIONS(483),
    [anon_sym_constinit] = ACTIONS(483),
    [anon_sym_consteval] = ACTIONS(483),
    [anon_sym_alignas] = ACTIONS(486),
    [anon_sym__Alignas] = ACTIONS(486),
    [sym_primitive_type] = ACTIONS(489),
    [anon_sym_enum] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(498),
    [anon_sym_union] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(686),
    [anon_sym_switch] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(692),
    [anon_sym_default] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(698),
    [anon_sym_do] = ACTIONS(701),
    [anon_sym_for] = ACTIONS(704),
    [anon_sym_return] = ACTIONS(707),
    [anon_sym_break] = ACTIONS(710),
    [anon_sym_continue] = ACTIONS(713),
    [anon_sym_goto] = ACTIONS(716),
    [anon_sym___try] = ACTIONS(719),
    [anon_sym___leave] = ACTIONS(722),
    [anon_sym_not] = ACTIONS(420),
    [anon_sym_compl] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_sizeof] = ACTIONS(546),
    [anon_sym___alignof__] = ACTIONS(549),
    [anon_sym___alignof] = ACTIONS(549),
    [anon_sym__alignof] = ACTIONS(549),
    [anon_sym_alignof] = ACTIONS(549),
    [anon_sym__Alignof] = ACTIONS(549),
    [anon_sym_offsetof] = ACTIONS(552),
    [anon_sym__Generic] = ACTIONS(555),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym___asm__] = ACTIONS(558),
    [anon_sym___asm] = ACTIONS(558),
    [sym_number_literal] = ACTIONS(561),
    [anon_sym_L_SQUOTE] = ACTIONS(564),
    [anon_sym_u_SQUOTE] = ACTIONS(564),
    [anon_sym_U_SQUOTE] = ACTIONS(564),
    [anon_sym_u8_SQUOTE] = ACTIONS(564),
    [anon_sym_SQUOTE] = ACTIONS(564),
    [anon_sym_L_DQUOTE] = ACTIONS(567),
    [anon_sym_u_DQUOTE] = ACTIONS(567),
    [anon_sym_U_DQUOTE] = ACTIONS(567),
    [anon_sym_u8_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(567),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [anon_sym_NULL] = ACTIONS(573),
    [anon_sym_nullptr] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(576),
    [anon_sym_decltype] = ACTIONS(579),
    [anon_sym_explicit] = ACTIONS(582),
    [anon_sym_typename] = ACTIONS(585),
    [anon_sym_template] = ACTIONS(725),
    [anon_sym_operator] = ACTIONS(591),
    [anon_sym_try] = ACTIONS(728),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_throw] = ACTIONS(731),
    [anon_sym_namespace] = ACTIONS(734),
    [anon_sym_static_assert] = ACTIONS(737),
    [anon_sym_concept] = ACTIONS(740),
    [anon_sym_co_return] = ACTIONS(743),
    [anon_sym_co_yield] = ACTIONS(746),
    [anon_sym_R_DQUOTE] = ACTIONS(618),
    [anon_sym_LR_DQUOTE] = ACTIONS(618),
    [anon_sym_uR_DQUOTE] = ACTIONS(618),
    [anon_sym_UR_DQUOTE] = ACTIONS(618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(618),
    [anon_sym_co_await] = ACTIONS(621),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_requires] = ACTIONS(627),
    [sym_this] = ACTIONS(570),
    [anon_sym_discard] = ACTIONS(749),
    [anon_sym_precise] = ACTIONS(633),
    [anon_sym_shared] = ACTIONS(633),
    [anon_sym_groupshared] = ACTIONS(633),
    [anon_sym_uniform] = ACTIONS(633),
    [anon_sym_row_major] = ACTIONS(633),
    [anon_sym_column_major] = ACTIONS(633),
    [anon_sym_globallycoherent] = ACTIONS(633),
    [anon_sym_centroid] = ACTIONS(633),
    [anon_sym_noperspective] = ACTIONS(633),
    [anon_sym_nointerpolation] = ACTIONS(633),
    [anon_sym_sample] = ACTIONS(633),
    [anon_sym_linear] = ACTIONS(633),
    [anon_sym_snorm] = ACTIONS(633),
    [anon_sym_unorm] = ACTIONS(633),
    [anon_sym_point] = ACTIONS(633),
    [anon_sym_line] = ACTIONS(633),
    [anon_sym_triangleadj] = ACTIONS(633),
    [anon_sym_lineadj] = ACTIONS(633),
    [anon_sym_triangle] = ACTIONS(633),
    [anon_sym_cbuffer] = ACTIONS(752),
  },
  [37] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [38] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(757),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [39] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [40] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2032),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6456),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(477),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2342),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(689),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(1343),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(881),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(761),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(765),
    [aux_sym_preproc_if_token1] = ACTIONS(767),
    [aux_sym_preproc_if_token2] = ACTIONS(769),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(771),
    [sym_preproc_directive] = ACTIONS(773),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(777),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(781),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(787),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(815),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(821),
    [anon_sym_static_assert] = ACTIONS(823),
    [anon_sym_concept] = ACTIONS(825),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [41] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [42] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [43] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(839),
    [aux_sym_preproc_include_token1] = ACTIONS(842),
    [aux_sym_preproc_def_token1] = ACTIONS(845),
    [aux_sym_preproc_if_token1] = ACTIONS(848),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(851),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(851),
    [sym_preproc_directive] = ACTIONS(854),
    [anon_sym_LPAREN2] = ACTIONS(411),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(420),
    [anon_sym_PLUS] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(426),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym___extension__] = ACTIONS(860),
    [anon_sym_typedef] = ACTIONS(863),
    [anon_sym_in] = ACTIONS(441),
    [anon_sym_out] = ACTIONS(441),
    [anon_sym_inout] = ACTIONS(441),
    [anon_sym_virtual] = ACTIONS(441),
    [anon_sym_extern] = ACTIONS(866),
    [anon_sym___attribute__] = ACTIONS(447),
    [anon_sym___attribute] = ACTIONS(447),
    [anon_sym_using] = ACTIONS(869),
    [anon_sym_COLON_COLON] = ACTIONS(453),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(456),
    [anon_sym___declspec] = ACTIONS(459),
    [anon_sym___based] = ACTIONS(462),
    [anon_sym___cdecl] = ACTIONS(465),
    [anon_sym___clrcall] = ACTIONS(465),
    [anon_sym___stdcall] = ACTIONS(465),
    [anon_sym___fastcall] = ACTIONS(465),
    [anon_sym___thiscall] = ACTIONS(465),
    [anon_sym___vectorcall] = ACTIONS(465),
    [anon_sym_LBRACE] = ACTIONS(872),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym_signed] = ACTIONS(471),
    [anon_sym_unsigned] = ACTIONS(471),
    [anon_sym_long] = ACTIONS(471),
    [anon_sym_short] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_static] = ACTIONS(477),
    [anon_sym_register] = ACTIONS(477),
    [anon_sym_inline] = ACTIONS(877),
    [anon_sym___inline] = ACTIONS(477),
    [anon_sym___inline__] = ACTIONS(477),
    [anon_sym___forceinline] = ACTIONS(477),
    [anon_sym_thread_local] = ACTIONS(477),
    [anon_sym___thread] = ACTIONS(477),
    [anon_sym_const] = ACTIONS(483),
    [anon_sym_constexpr] = ACTIONS(483),
    [anon_sym_volatile] = ACTIONS(483),
    [anon_sym_restrict] = ACTIONS(483),
    [anon_sym___restrict__] = ACTIONS(483),
    [anon_sym__Atomic] = ACTIONS(483),
    [anon_sym__Noreturn] = ACTIONS(483),
    [anon_sym_noreturn] = ACTIONS(483),
    [anon_sym__Nonnull] = ACTIONS(483),
    [anon_sym_mutable] = ACTIONS(483),
    [anon_sym_constinit] = ACTIONS(483),
    [anon_sym_consteval] = ACTIONS(483),
    [anon_sym_alignas] = ACTIONS(486),
    [anon_sym__Alignas] = ACTIONS(486),
    [sym_primitive_type] = ACTIONS(489),
    [anon_sym_enum] = ACTIONS(492),
    [anon_sym_class] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(498),
    [anon_sym_union] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(880),
    [anon_sym_switch] = ACTIONS(883),
    [anon_sym_case] = ACTIONS(886),
    [anon_sym_default] = ACTIONS(889),
    [anon_sym_while] = ACTIONS(892),
    [anon_sym_do] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(898),
    [anon_sym_return] = ACTIONS(901),
    [anon_sym_break] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(907),
    [anon_sym_goto] = ACTIONS(910),
    [anon_sym___try] = ACTIONS(913),
    [anon_sym___leave] = ACTIONS(916),
    [anon_sym_not] = ACTIONS(420),
    [anon_sym_compl] = ACTIONS(420),
    [anon_sym_DASH_DASH] = ACTIONS(543),
    [anon_sym_PLUS_PLUS] = ACTIONS(543),
    [anon_sym_sizeof] = ACTIONS(546),
    [anon_sym___alignof__] = ACTIONS(549),
    [anon_sym___alignof] = ACTIONS(549),
    [anon_sym__alignof] = ACTIONS(549),
    [anon_sym_alignof] = ACTIONS(549),
    [anon_sym__Alignof] = ACTIONS(549),
    [anon_sym_offsetof] = ACTIONS(552),
    [anon_sym__Generic] = ACTIONS(555),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym___asm__] = ACTIONS(558),
    [anon_sym___asm] = ACTIONS(558),
    [sym_number_literal] = ACTIONS(561),
    [anon_sym_L_SQUOTE] = ACTIONS(564),
    [anon_sym_u_SQUOTE] = ACTIONS(564),
    [anon_sym_U_SQUOTE] = ACTIONS(564),
    [anon_sym_u8_SQUOTE] = ACTIONS(564),
    [anon_sym_SQUOTE] = ACTIONS(564),
    [anon_sym_L_DQUOTE] = ACTIONS(567),
    [anon_sym_u_DQUOTE] = ACTIONS(567),
    [anon_sym_U_DQUOTE] = ACTIONS(567),
    [anon_sym_u8_DQUOTE] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(567),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [anon_sym_NULL] = ACTIONS(573),
    [anon_sym_nullptr] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(576),
    [anon_sym_decltype] = ACTIONS(579),
    [anon_sym_explicit] = ACTIONS(582),
    [anon_sym_typename] = ACTIONS(585),
    [anon_sym_template] = ACTIONS(919),
    [anon_sym_operator] = ACTIONS(591),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_delete] = ACTIONS(597),
    [anon_sym_throw] = ACTIONS(925),
    [anon_sym_namespace] = ACTIONS(928),
    [anon_sym_static_assert] = ACTIONS(931),
    [anon_sym_concept] = ACTIONS(934),
    [anon_sym_co_return] = ACTIONS(937),
    [anon_sym_co_yield] = ACTIONS(940),
    [anon_sym_R_DQUOTE] = ACTIONS(618),
    [anon_sym_LR_DQUOTE] = ACTIONS(618),
    [anon_sym_uR_DQUOTE] = ACTIONS(618),
    [anon_sym_UR_DQUOTE] = ACTIONS(618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(618),
    [anon_sym_co_await] = ACTIONS(621),
    [anon_sym_new] = ACTIONS(624),
    [anon_sym_requires] = ACTIONS(627),
    [sym_this] = ACTIONS(570),
    [anon_sym_discard] = ACTIONS(943),
    [anon_sym_precise] = ACTIONS(633),
    [anon_sym_shared] = ACTIONS(633),
    [anon_sym_groupshared] = ACTIONS(633),
    [anon_sym_uniform] = ACTIONS(633),
    [anon_sym_row_major] = ACTIONS(633),
    [anon_sym_column_major] = ACTIONS(633),
    [anon_sym_globallycoherent] = ACTIONS(633),
    [anon_sym_centroid] = ACTIONS(633),
    [anon_sym_noperspective] = ACTIONS(633),
    [anon_sym_nointerpolation] = ACTIONS(633),
    [anon_sym_sample] = ACTIONS(633),
    [anon_sym_linear] = ACTIONS(633),
    [anon_sym_snorm] = ACTIONS(633),
    [anon_sym_unorm] = ACTIONS(633),
    [anon_sym_point] = ACTIONS(633),
    [anon_sym_line] = ACTIONS(633),
    [anon_sym_triangleadj] = ACTIONS(633),
    [anon_sym_lineadj] = ACTIONS(633),
    [anon_sym_triangle] = ACTIONS(633),
    [anon_sym_cbuffer] = ACTIONS(946),
  },
  [44] = {
    [sym__block_item] = STATE(45),
    [sym_preproc_include] = STATE(45),
    [sym_preproc_def] = STATE(45),
    [sym_preproc_function_def] = STATE(45),
    [sym_preproc_call] = STATE(45),
    [sym_preproc_if] = STATE(45),
    [sym_preproc_ifdef] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(45),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(45),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(45),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(45),
    [sym_template_instantiation] = STATE(45),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(45),
    [sym_operator_cast_declaration] = STATE(45),
    [sym_constructor_or_destructor_definition] = STATE(45),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(45),
    [sym_namespace_alias_definition] = STATE(45),
    [sym_using_declaration] = STATE(45),
    [sym_alias_declaration] = STATE(45),
    [sym_static_assert_declaration] = STATE(45),
    [sym_concept_definition] = STATE(45),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(45),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [45] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [46] = {
    [sym__block_item] = STATE(48),
    [sym_preproc_include] = STATE(48),
    [sym_preproc_def] = STATE(48),
    [sym_preproc_function_def] = STATE(48),
    [sym_preproc_call] = STATE(48),
    [sym_preproc_if] = STATE(48),
    [sym_preproc_ifdef] = STATE(48),
    [sym_function_definition] = STATE(48),
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(48),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(48),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(48),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(48),
    [sym_template_instantiation] = STATE(48),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(48),
    [sym_operator_cast_declaration] = STATE(48),
    [sym_constructor_or_destructor_definition] = STATE(48),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(48),
    [sym_namespace_alias_definition] = STATE(48),
    [sym_using_declaration] = STATE(48),
    [sym_alias_declaration] = STATE(48),
    [sym_static_assert_declaration] = STATE(48),
    [sym_concept_definition] = STATE(48),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(48),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [47] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [48] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [49] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [50] = {
    [sym__block_item] = STATE(51),
    [sym_preproc_include] = STATE(51),
    [sym_preproc_def] = STATE(51),
    [sym_preproc_function_def] = STATE(51),
    [sym_preproc_call] = STATE(51),
    [sym_preproc_if] = STATE(51),
    [sym_preproc_ifdef] = STATE(51),
    [sym_function_definition] = STATE(51),
    [sym_declaration] = STATE(51),
    [sym_type_definition] = STATE(51),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(51),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(51),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(51),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(51),
    [sym_template_instantiation] = STATE(51),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(51),
    [sym_operator_cast_declaration] = STATE(51),
    [sym_constructor_or_destructor_definition] = STATE(51),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(51),
    [sym_namespace_alias_definition] = STATE(51),
    [sym_using_declaration] = STATE(51),
    [sym_alias_declaration] = STATE(51),
    [sym_static_assert_declaration] = STATE(51),
    [sym_concept_definition] = STATE(51),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(51),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [51] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [52] = {
    [sym__block_item] = STATE(817),
    [sym_preproc_include] = STATE(817),
    [sym_preproc_def] = STATE(817),
    [sym_preproc_function_def] = STATE(817),
    [sym_preproc_call] = STATE(817),
    [sym_preproc_if] = STATE(817),
    [sym_preproc_ifdef] = STATE(817),
    [sym_function_definition] = STATE(817),
    [sym_declaration] = STATE(817),
    [sym_type_definition] = STATE(817),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_linkage_specification] = STATE(817),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6500),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(305),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(751),
    [sym_statement] = STATE(817),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(817),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1910),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(817),
    [sym_template_instantiation] = STATE(817),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1910),
    [sym_operator_cast_definition] = STATE(817),
    [sym_operator_cast_declaration] = STATE(817),
    [sym_constructor_or_destructor_definition] = STATE(817),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(817),
    [sym_namespace_alias_definition] = STATE(817),
    [sym_using_declaration] = STATE(817),
    [sym_alias_declaration] = STATE(817),
    [sym_static_assert_declaration] = STATE(817),
    [sym_concept_definition] = STATE(817),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(1336),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(880),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1910),
    [sym_identifier] = ACTIONS(965),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(975),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [53] = {
    [sym__block_item] = STATE(36),
    [sym_preproc_include] = STATE(36),
    [sym_preproc_def] = STATE(36),
    [sym_preproc_function_def] = STATE(36),
    [sym_preproc_call] = STATE(36),
    [sym_preproc_if] = STATE(36),
    [sym_preproc_ifdef] = STATE(36),
    [sym_function_definition] = STATE(36),
    [sym_declaration] = STATE(36),
    [sym_type_definition] = STATE(36),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_linkage_specification] = STATE(36),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2032),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6456),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(477),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2342),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(689),
    [sym_statement] = STATE(36),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(36),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1900),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(36),
    [sym_template_instantiation] = STATE(36),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(1900),
    [sym_operator_cast_definition] = STATE(36),
    [sym_operator_cast_declaration] = STATE(36),
    [sym_constructor_or_destructor_definition] = STATE(36),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(36),
    [sym_namespace_alias_definition] = STATE(36),
    [sym_using_declaration] = STATE(36),
    [sym_alias_declaration] = STATE(36),
    [sym_static_assert_declaration] = STATE(36),
    [sym_concept_definition] = STATE(36),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(1343),
    [aux_sym_preproc_if_repeat1] = STATE(36),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(881),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1900),
    [sym_identifier] = ACTIONS(761),
    [aux_sym_preproc_include_token1] = ACTIONS(763),
    [aux_sym_preproc_def_token1] = ACTIONS(765),
    [aux_sym_preproc_if_token1] = ACTIONS(767),
    [aux_sym_preproc_if_token2] = ACTIONS(983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(771),
    [sym_preproc_directive] = ACTIONS(773),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(777),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(781),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(783),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(787),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(815),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(821),
    [anon_sym_static_assert] = ACTIONS(823),
    [anon_sym_concept] = ACTIONS(825),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [54] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [55] = {
    [sym__block_item] = STATE(56),
    [sym_preproc_include] = STATE(56),
    [sym_preproc_def] = STATE(56),
    [sym_preproc_function_def] = STATE(56),
    [sym_preproc_call] = STATE(56),
    [sym_preproc_if] = STATE(56),
    [sym_preproc_ifdef] = STATE(56),
    [sym_function_definition] = STATE(56),
    [sym_declaration] = STATE(56),
    [sym_type_definition] = STATE(56),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(56),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(56),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(56),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(56),
    [sym_template_instantiation] = STATE(56),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(56),
    [sym_operator_cast_declaration] = STATE(56),
    [sym_constructor_or_destructor_definition] = STATE(56),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(56),
    [sym_namespace_alias_definition] = STATE(56),
    [sym_using_declaration] = STATE(56),
    [sym_alias_declaration] = STATE(56),
    [sym_static_assert_declaration] = STATE(56),
    [sym_concept_definition] = STATE(56),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(56),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [56] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [57] = {
    [sym__block_item] = STATE(58),
    [sym_preproc_include] = STATE(58),
    [sym_preproc_def] = STATE(58),
    [sym_preproc_function_def] = STATE(58),
    [sym_preproc_call] = STATE(58),
    [sym_preproc_if] = STATE(58),
    [sym_preproc_ifdef] = STATE(58),
    [sym_function_definition] = STATE(58),
    [sym_declaration] = STATE(58),
    [sym_type_definition] = STATE(58),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(58),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(58),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(58),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(58),
    [sym_template_instantiation] = STATE(58),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(58),
    [sym_operator_cast_declaration] = STATE(58),
    [sym_constructor_or_destructor_definition] = STATE(58),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(58),
    [sym_namespace_alias_definition] = STATE(58),
    [sym_using_declaration] = STATE(58),
    [sym_alias_declaration] = STATE(58),
    [sym_static_assert_declaration] = STATE(58),
    [sym_concept_definition] = STATE(58),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(58),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [58] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [59] = {
    [sym__block_item] = STATE(47),
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(47),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(47),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(47),
    [sym_template_instantiation] = STATE(47),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(47),
    [sym_operator_cast_declaration] = STATE(47),
    [sym_constructor_or_destructor_definition] = STATE(47),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(47),
    [sym_namespace_alias_definition] = STATE(47),
    [sym_using_declaration] = STATE(47),
    [sym_alias_declaration] = STATE(47),
    [sym_static_assert_declaration] = STATE(47),
    [sym_concept_definition] = STATE(47),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [60] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [61] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [62] = {
    [sym__block_item] = STATE(49),
    [sym_preproc_include] = STATE(49),
    [sym_preproc_def] = STATE(49),
    [sym_preproc_function_def] = STATE(49),
    [sym_preproc_call] = STATE(49),
    [sym_preproc_if] = STATE(49),
    [sym_preproc_ifdef] = STATE(49),
    [sym_function_definition] = STATE(49),
    [sym_declaration] = STATE(49),
    [sym_type_definition] = STATE(49),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(49),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(49),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(49),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(49),
    [sym_template_instantiation] = STATE(49),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(49),
    [sym_operator_cast_declaration] = STATE(49),
    [sym_constructor_or_destructor_definition] = STATE(49),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(49),
    [sym_namespace_alias_definition] = STATE(49),
    [sym_using_declaration] = STATE(49),
    [sym_alias_declaration] = STATE(49),
    [sym_static_assert_declaration] = STATE(49),
    [sym_concept_definition] = STATE(49),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(49),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [63] = {
    [sym__block_item] = STATE(64),
    [sym_preproc_include] = STATE(64),
    [sym_preproc_def] = STATE(64),
    [sym_preproc_function_def] = STATE(64),
    [sym_preproc_call] = STATE(64),
    [sym_preproc_if] = STATE(64),
    [sym_preproc_ifdef] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_declaration] = STATE(64),
    [sym_type_definition] = STATE(64),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(64),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(64),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(64),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(64),
    [sym_template_instantiation] = STATE(64),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(64),
    [sym_operator_cast_declaration] = STATE(64),
    [sym_constructor_or_destructor_definition] = STATE(64),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(64),
    [sym_namespace_alias_definition] = STATE(64),
    [sym_using_declaration] = STATE(64),
    [sym_alias_declaration] = STATE(64),
    [sym_static_assert_declaration] = STATE(64),
    [sym_concept_definition] = STATE(64),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(64),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [64] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [65] = {
    [sym__block_item] = STATE(66),
    [sym_preproc_include] = STATE(66),
    [sym_preproc_def] = STATE(66),
    [sym_preproc_function_def] = STATE(66),
    [sym_preproc_call] = STATE(66),
    [sym_preproc_if] = STATE(66),
    [sym_preproc_ifdef] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_declaration] = STATE(66),
    [sym_type_definition] = STATE(66),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(66),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(66),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(66),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(66),
    [sym_template_instantiation] = STATE(66),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(66),
    [sym_operator_cast_declaration] = STATE(66),
    [sym_constructor_or_destructor_definition] = STATE(66),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(66),
    [sym_namespace_alias_definition] = STATE(66),
    [sym_using_declaration] = STATE(66),
    [sym_alias_declaration] = STATE(66),
    [sym_static_assert_declaration] = STATE(66),
    [sym_concept_definition] = STATE(66),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(66),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [66] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [67] = {
    [sym__block_item] = STATE(68),
    [sym_preproc_include] = STATE(68),
    [sym_preproc_def] = STATE(68),
    [sym_preproc_function_def] = STATE(68),
    [sym_preproc_call] = STATE(68),
    [sym_preproc_if] = STATE(68),
    [sym_preproc_ifdef] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_declaration] = STATE(68),
    [sym_type_definition] = STATE(68),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(68),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(68),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(68),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(68),
    [sym_template_instantiation] = STATE(68),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(68),
    [sym_operator_cast_declaration] = STATE(68),
    [sym_constructor_or_destructor_definition] = STATE(68),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(68),
    [sym_namespace_alias_definition] = STATE(68),
    [sym_using_declaration] = STATE(68),
    [sym_alias_declaration] = STATE(68),
    [sym_static_assert_declaration] = STATE(68),
    [sym_concept_definition] = STATE(68),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(68),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [68] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1013),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [69] = {
    [sym__block_item] = STATE(70),
    [sym_preproc_include] = STATE(70),
    [sym_preproc_def] = STATE(70),
    [sym_preproc_function_def] = STATE(70),
    [sym_preproc_call] = STATE(70),
    [sym_preproc_if] = STATE(70),
    [sym_preproc_ifdef] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_declaration] = STATE(70),
    [sym_type_definition] = STATE(70),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(70),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(70),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(70),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(70),
    [sym_template_instantiation] = STATE(70),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(70),
    [sym_operator_cast_declaration] = STATE(70),
    [sym_constructor_or_destructor_definition] = STATE(70),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(70),
    [sym_namespace_alias_definition] = STATE(70),
    [sym_using_declaration] = STATE(70),
    [sym_alias_declaration] = STATE(70),
    [sym_static_assert_declaration] = STATE(70),
    [sym_concept_definition] = STATE(70),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(70),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [70] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [71] = {
    [sym__block_item] = STATE(72),
    [sym_preproc_include] = STATE(72),
    [sym_preproc_def] = STATE(72),
    [sym_preproc_function_def] = STATE(72),
    [sym_preproc_call] = STATE(72),
    [sym_preproc_if] = STATE(72),
    [sym_preproc_ifdef] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_declaration] = STATE(72),
    [sym_type_definition] = STATE(72),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(72),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(72),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(72),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(72),
    [sym_template_instantiation] = STATE(72),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(72),
    [sym_operator_cast_declaration] = STATE(72),
    [sym_constructor_or_destructor_definition] = STATE(72),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(72),
    [sym_namespace_alias_definition] = STATE(72),
    [sym_using_declaration] = STATE(72),
    [sym_alias_declaration] = STATE(72),
    [sym_static_assert_declaration] = STATE(72),
    [sym_concept_definition] = STATE(72),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(72),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [72] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [73] = {
    [sym__block_item] = STATE(74),
    [sym_preproc_include] = STATE(74),
    [sym_preproc_def] = STATE(74),
    [sym_preproc_function_def] = STATE(74),
    [sym_preproc_call] = STATE(74),
    [sym_preproc_if] = STATE(74),
    [sym_preproc_ifdef] = STATE(74),
    [sym_function_definition] = STATE(74),
    [sym_declaration] = STATE(74),
    [sym_type_definition] = STATE(74),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(74),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(74),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(74),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(74),
    [sym_template_instantiation] = STATE(74),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(74),
    [sym_operator_cast_declaration] = STATE(74),
    [sym_constructor_or_destructor_definition] = STATE(74),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(74),
    [sym_namespace_alias_definition] = STATE(74),
    [sym_using_declaration] = STATE(74),
    [sym_alias_declaration] = STATE(74),
    [sym_static_assert_declaration] = STATE(74),
    [sym_concept_definition] = STATE(74),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(74),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [74] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [75] = {
    [sym__block_item] = STATE(76),
    [sym_preproc_include] = STATE(76),
    [sym_preproc_def] = STATE(76),
    [sym_preproc_function_def] = STATE(76),
    [sym_preproc_call] = STATE(76),
    [sym_preproc_if] = STATE(76),
    [sym_preproc_ifdef] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_declaration] = STATE(76),
    [sym_type_definition] = STATE(76),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(76),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(76),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(76),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(76),
    [sym_template_instantiation] = STATE(76),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(76),
    [sym_operator_cast_declaration] = STATE(76),
    [sym_constructor_or_destructor_definition] = STATE(76),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(76),
    [sym_namespace_alias_definition] = STATE(76),
    [sym_using_declaration] = STATE(76),
    [sym_alias_declaration] = STATE(76),
    [sym_static_assert_declaration] = STATE(76),
    [sym_concept_definition] = STATE(76),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(76),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [76] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [77] = {
    [sym__block_item] = STATE(34),
    [sym_preproc_include] = STATE(34),
    [sym_preproc_def] = STATE(34),
    [sym_preproc_function_def] = STATE(34),
    [sym_preproc_call] = STATE(34),
    [sym_preproc_if] = STATE(34),
    [sym_preproc_ifdef] = STATE(34),
    [sym_function_definition] = STATE(34),
    [sym_declaration] = STATE(34),
    [sym_type_definition] = STATE(34),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(34),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(34),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(34),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(34),
    [sym_template_instantiation] = STATE(34),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(34),
    [sym_operator_cast_declaration] = STATE(34),
    [sym_constructor_or_destructor_definition] = STATE(34),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(34),
    [sym_namespace_alias_definition] = STATE(34),
    [sym_using_declaration] = STATE(34),
    [sym_alias_declaration] = STATE(34),
    [sym_static_assert_declaration] = STATE(34),
    [sym_concept_definition] = STATE(34),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(34),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [78] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [79] = {
    [sym__block_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(80),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1035),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [80] = {
    [sym__block_item] = STATE(43),
    [sym_preproc_include] = STATE(43),
    [sym_preproc_def] = STATE(43),
    [sym_preproc_function_def] = STATE(43),
    [sym_preproc_call] = STATE(43),
    [sym_preproc_if] = STATE(43),
    [sym_preproc_ifdef] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_declaration] = STATE(43),
    [sym_type_definition] = STATE(43),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(43),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(43),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(43),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(43),
    [sym_template_instantiation] = STATE(43),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(43),
    [sym_operator_cast_declaration] = STATE(43),
    [sym_constructor_or_destructor_definition] = STATE(43),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(43),
    [sym_namespace_alias_definition] = STATE(43),
    [sym_using_declaration] = STATE(43),
    [sym_alias_declaration] = STATE(43),
    [sym_static_assert_declaration] = STATE(43),
    [sym_concept_definition] = STATE(43),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(43),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [81] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [82] = {
    [sym__block_item] = STATE(54),
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6441),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(694),
    [sym_statement] = STATE(54),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1907),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1907),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4767),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3592),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2477),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(1345),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1907),
    [sym_identifier] = ACTIONS(639),
    [aux_sym_preproc_include_token1] = ACTIONS(171),
    [aux_sym_preproc_def_token1] = ACTIONS(173),
    [aux_sym_preproc_if_token1] = ACTIONS(177),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(179),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(179),
    [sym_preproc_directive] = ACTIONS(181),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(185),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(189),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(191),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(199),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(233),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(239),
    [anon_sym_static_assert] = ACTIONS(241),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [83] = {
    [sym__top_level_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6500),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(776),
    [sym__top_level_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym__top_level_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_case_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_expression] = STATE(5019),
    [sym__string] = STATE(5113),
    [sym_conditional_expression] = STATE(5129),
    [sym_assignment_expression] = STATE(5129),
    [sym_pointer_expression] = STATE(3985),
    [sym_unary_expression] = STATE(5129),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(5129),
    [sym_cast_expression] = STATE(5129),
    [sym_sizeof_expression] = STATE(5129),
    [sym_alignof_expression] = STATE(5129),
    [sym_offsetof_expression] = STATE(5129),
    [sym_generic_expression] = STATE(5129),
    [sym_subscript_expression] = STATE(3985),
    [sym_call_expression] = STATE(3985),
    [sym_gnu_asm_expression] = STATE(5129),
    [sym_extension_expression] = STATE(5129),
    [sym_field_expression] = STATE(3985),
    [sym_compound_literal_expression] = STATE(5129),
    [sym_parenthesized_expression] = STATE(3985),
    [sym_char_literal] = STATE(5113),
    [sym_concatenated_string] = STATE(5113),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(5129),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1910),
    [sym_dependent_type] = STATE(2348),
    [sym_module_declaration] = STATE(83),
    [sym_export_declaration] = STATE(83),
    [sym_import_declaration] = STATE(83),
    [sym_global_module_fragment_declaration] = STATE(83),
    [sym_private_module_fragment_declaration] = STATE(83),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1910),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(5053),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(5129),
    [sym_new_expression] = STATE(5129),
    [sym_delete_expression] = STATE(5129),
    [sym_requires_clause] = STATE(5129),
    [sym_requires_expression] = STATE(5129),
    [sym_lambda_expression] = STATE(5129),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(5129),
    [sym_parameter_pack_expansion] = STATE(5129),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3891),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3985),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1336),
    [aux_sym_translation_unit_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(880),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1910),
    [ts_builtin_sym_end] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(1045),
    [aux_sym_preproc_include_token1] = ACTIONS(1048),
    [aux_sym_preproc_def_token1] = ACTIONS(1051),
    [aux_sym_preproc_if_token1] = ACTIONS(1054),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1057),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1057),
    [sym_preproc_directive] = ACTIONS(1060),
    [anon_sym_LPAREN2] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1066),
    [anon_sym_TILDE] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1072),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_AMP_AMP] = ACTIONS(1078),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_SEMI] = ACTIONS(1084),
    [anon_sym___extension__] = ACTIONS(1087),
    [anon_sym_typedef] = ACTIONS(1090),
    [anon_sym_in] = ACTIONS(1093),
    [anon_sym_out] = ACTIONS(1093),
    [anon_sym_inout] = ACTIONS(1093),
    [anon_sym_virtual] = ACTIONS(1093),
    [anon_sym_extern] = ACTIONS(1096),
    [anon_sym___attribute__] = ACTIONS(1099),
    [anon_sym___attribute] = ACTIONS(1099),
    [anon_sym_using] = ACTIONS(1102),
    [anon_sym_COLON_COLON] = ACTIONS(1105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1108),
    [anon_sym___declspec] = ACTIONS(1111),
    [anon_sym___based] = ACTIONS(1114),
    [anon_sym___cdecl] = ACTIONS(1117),
    [anon_sym___clrcall] = ACTIONS(1117),
    [anon_sym___stdcall] = ACTIONS(1117),
    [anon_sym___fastcall] = ACTIONS(1117),
    [anon_sym___thiscall] = ACTIONS(1117),
    [anon_sym___vectorcall] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_signed] = ACTIONS(1123),
    [anon_sym_unsigned] = ACTIONS(1123),
    [anon_sym_long] = ACTIONS(1123),
    [anon_sym_short] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_static] = ACTIONS(1129),
    [anon_sym_register] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1132),
    [anon_sym___inline] = ACTIONS(1129),
    [anon_sym___inline__] = ACTIONS(1129),
    [anon_sym___forceinline] = ACTIONS(1129),
    [anon_sym_thread_local] = ACTIONS(1129),
    [anon_sym___thread] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1135),
    [anon_sym_constexpr] = ACTIONS(1135),
    [anon_sym_volatile] = ACTIONS(1135),
    [anon_sym_restrict] = ACTIONS(1135),
    [anon_sym___restrict__] = ACTIONS(1135),
    [anon_sym__Atomic] = ACTIONS(1135),
    [anon_sym__Noreturn] = ACTIONS(1135),
    [anon_sym_noreturn] = ACTIONS(1135),
    [anon_sym__Nonnull] = ACTIONS(1135),
    [anon_sym_mutable] = ACTIONS(1135),
    [anon_sym_constinit] = ACTIONS(1135),
    [anon_sym_consteval] = ACTIONS(1135),
    [anon_sym_alignas] = ACTIONS(1138),
    [anon_sym__Alignas] = ACTIONS(1138),
    [sym_primitive_type] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1147),
    [anon_sym_struct] = ACTIONS(1150),
    [anon_sym_union] = ACTIONS(1153),
    [anon_sym_if] = ACTIONS(1156),
    [anon_sym_switch] = ACTIONS(1159),
    [anon_sym_case] = ACTIONS(1162),
    [anon_sym_default] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1168),
    [anon_sym_do] = ACTIONS(1171),
    [anon_sym_for] = ACTIONS(1174),
    [anon_sym_return] = ACTIONS(1177),
    [anon_sym_break] = ACTIONS(1180),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_goto] = ACTIONS(1186),
    [anon_sym_not] = ACTIONS(1072),
    [anon_sym_compl] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1189),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_sizeof] = ACTIONS(1192),
    [anon_sym___alignof__] = ACTIONS(1195),
    [anon_sym___alignof] = ACTIONS(1195),
    [anon_sym__alignof] = ACTIONS(1195),
    [anon_sym_alignof] = ACTIONS(1195),
    [anon_sym__Alignof] = ACTIONS(1195),
    [anon_sym_offsetof] = ACTIONS(1198),
    [anon_sym__Generic] = ACTIONS(1201),
    [anon_sym_asm] = ACTIONS(1204),
    [anon_sym___asm__] = ACTIONS(1204),
    [anon_sym___asm] = ACTIONS(1204),
    [sym_number_literal] = ACTIONS(1207),
    [anon_sym_L_SQUOTE] = ACTIONS(1210),
    [anon_sym_u_SQUOTE] = ACTIONS(1210),
    [anon_sym_U_SQUOTE] = ACTIONS(1210),
    [anon_sym_u8_SQUOTE] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(1210),
    [anon_sym_L_DQUOTE] = ACTIONS(1213),
    [anon_sym_u_DQUOTE] = ACTIONS(1213),
    [anon_sym_U_DQUOTE] = ACTIONS(1213),
    [anon_sym_u8_DQUOTE] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [sym_true] = ACTIONS(1216),
    [sym_false] = ACTIONS(1216),
    [anon_sym_NULL] = ACTIONS(1219),
    [anon_sym_nullptr] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1222),
    [anon_sym_decltype] = ACTIONS(1225),
    [anon_sym_explicit] = ACTIONS(1228),
    [anon_sym_typename] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1234),
    [anon_sym_module] = ACTIONS(1237),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_template] = ACTIONS(1243),
    [anon_sym_operator] = ACTIONS(1246),
    [anon_sym_try] = ACTIONS(1249),
    [anon_sym_delete] = ACTIONS(1252),
    [anon_sym_throw] = ACTIONS(1255),
    [anon_sym_namespace] = ACTIONS(1258),
    [anon_sym_static_assert] = ACTIONS(1261),
    [anon_sym_concept] = ACTIONS(1264),
    [anon_sym_co_return] = ACTIONS(1267),
    [anon_sym_co_yield] = ACTIONS(1270),
    [anon_sym_R_DQUOTE] = ACTIONS(1273),
    [anon_sym_LR_DQUOTE] = ACTIONS(1273),
    [anon_sym_uR_DQUOTE] = ACTIONS(1273),
    [anon_sym_UR_DQUOTE] = ACTIONS(1273),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1273),
    [anon_sym_co_await] = ACTIONS(1276),
    [anon_sym_new] = ACTIONS(1279),
    [anon_sym_requires] = ACTIONS(1282),
    [sym_this] = ACTIONS(1216),
    [anon_sym_precise] = ACTIONS(1285),
    [anon_sym_shared] = ACTIONS(1285),
    [anon_sym_groupshared] = ACTIONS(1285),
    [anon_sym_uniform] = ACTIONS(1285),
    [anon_sym_row_major] = ACTIONS(1285),
    [anon_sym_column_major] = ACTIONS(1285),
    [anon_sym_globallycoherent] = ACTIONS(1285),
    [anon_sym_centroid] = ACTIONS(1285),
    [anon_sym_noperspective] = ACTIONS(1285),
    [anon_sym_nointerpolation] = ACTIONS(1285),
    [anon_sym_sample] = ACTIONS(1285),
    [anon_sym_linear] = ACTIONS(1285),
    [anon_sym_snorm] = ACTIONS(1285),
    [anon_sym_unorm] = ACTIONS(1285),
    [anon_sym_point] = ACTIONS(1285),
    [anon_sym_line] = ACTIONS(1285),
    [anon_sym_triangleadj] = ACTIONS(1285),
    [anon_sym_lineadj] = ACTIONS(1285),
    [anon_sym_triangle] = ACTIONS(1285),
  },
  [84] = {
    [sym__top_level_item] = STATE(83),
    [sym_preproc_include] = STATE(83),
    [sym_preproc_def] = STATE(83),
    [sym_preproc_function_def] = STATE(83),
    [sym_preproc_call] = STATE(83),
    [sym_preproc_if] = STATE(83),
    [sym_preproc_ifdef] = STATE(83),
    [sym_function_definition] = STATE(83),
    [sym_declaration] = STATE(83),
    [sym_type_definition] = STATE(83),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_linkage_specification] = STATE(83),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(998),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6500),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(83),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(776),
    [sym__top_level_statement] = STATE(83),
    [sym_labeled_statement] = STATE(83),
    [sym__top_level_expression_statement] = STATE(83),
    [sym_if_statement] = STATE(83),
    [sym_switch_statement] = STATE(83),
    [sym_case_statement] = STATE(83),
    [sym_while_statement] = STATE(83),
    [sym_do_statement] = STATE(83),
    [sym_for_statement] = STATE(83),
    [sym_return_statement] = STATE(83),
    [sym_break_statement] = STATE(83),
    [sym_continue_statement] = STATE(83),
    [sym_goto_statement] = STATE(83),
    [sym_expression] = STATE(5019),
    [sym__string] = STATE(5113),
    [sym_conditional_expression] = STATE(5129),
    [sym_assignment_expression] = STATE(5129),
    [sym_pointer_expression] = STATE(3985),
    [sym_unary_expression] = STATE(5129),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(5129),
    [sym_cast_expression] = STATE(5129),
    [sym_sizeof_expression] = STATE(5129),
    [sym_alignof_expression] = STATE(5129),
    [sym_offsetof_expression] = STATE(5129),
    [sym_generic_expression] = STATE(5129),
    [sym_subscript_expression] = STATE(3985),
    [sym_call_expression] = STATE(3985),
    [sym_gnu_asm_expression] = STATE(5129),
    [sym_extension_expression] = STATE(5129),
    [sym_field_expression] = STATE(3985),
    [sym_compound_literal_expression] = STATE(5129),
    [sym_parenthesized_expression] = STATE(3985),
    [sym_char_literal] = STATE(5113),
    [sym_concatenated_string] = STATE(5113),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(5129),
    [sym__empty_declaration] = STATE(83),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_explicit_function_specifier] = STATE(1910),
    [sym_dependent_type] = STATE(2348),
    [sym_module_declaration] = STATE(83),
    [sym_export_declaration] = STATE(83),
    [sym_import_declaration] = STATE(83),
    [sym_global_module_fragment_declaration] = STATE(83),
    [sym_private_module_fragment_declaration] = STATE(83),
    [sym_template_declaration] = STATE(83),
    [sym_template_instantiation] = STATE(83),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1910),
    [sym_operator_cast_definition] = STATE(83),
    [sym_operator_cast_declaration] = STATE(83),
    [sym_constructor_or_destructor_definition] = STATE(83),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(5053),
    [sym_namespace_definition] = STATE(83),
    [sym_namespace_alias_definition] = STATE(83),
    [sym_using_declaration] = STATE(83),
    [sym_alias_declaration] = STATE(83),
    [sym_static_assert_declaration] = STATE(83),
    [sym_concept_definition] = STATE(83),
    [sym_for_range_loop] = STATE(83),
    [sym_co_return_statement] = STATE(83),
    [sym_co_yield_statement] = STATE(83),
    [sym_throw_statement] = STATE(83),
    [sym_try_statement] = STATE(83),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(5129),
    [sym_new_expression] = STATE(5129),
    [sym_delete_expression] = STATE(5129),
    [sym_requires_clause] = STATE(5129),
    [sym_requires_expression] = STATE(5129),
    [sym_lambda_expression] = STATE(5129),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(5129),
    [sym_parameter_pack_expansion] = STATE(5129),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5677),
    [sym_qualified_identifier] = STATE(3891),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3985),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1336),
    [aux_sym_translation_unit_repeat1] = STATE(83),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(880),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1910),
    [ts_builtin_sym_end] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(49),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(65),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(115),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(121),
    [sym_false] = ACTIONS(121),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(133),
    [anon_sym_module] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(137),
    [anon_sym_template] = ACTIONS(139),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(149),
    [anon_sym_static_assert] = ACTIONS(151),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(121),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [85] = {
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(86),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(86),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(1290),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token2] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [aux_sym_preproc_else_token1] = ACTIONS(1292),
    [aux_sym_preproc_elif_token1] = ACTIONS(1292),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1292),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1292),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(1292),
    [anon_sym_static_assert] = ACTIONS(1292),
    [anon_sym_concept] = ACTIONS(1292),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [86] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(89),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(89),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1290),
    [aux_sym_preproc_include_token1] = ACTIONS(1312),
    [aux_sym_preproc_def_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token2] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1312),
    [aux_sym_preproc_else_token1] = ACTIONS(1312),
    [aux_sym_preproc_elif_token1] = ACTIONS(1312),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1312),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1312),
    [sym_preproc_directive] = ACTIONS(1312),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1312),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1312),
    [anon_sym___cdecl] = ACTIONS(1312),
    [anon_sym___clrcall] = ACTIONS(1312),
    [anon_sym___stdcall] = ACTIONS(1312),
    [anon_sym___fastcall] = ACTIONS(1312),
    [anon_sym___thiscall] = ACTIONS(1312),
    [anon_sym___vectorcall] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1312),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(1312),
    [anon_sym_static_assert] = ACTIONS(1312),
    [anon_sym_concept] = ACTIONS(1312),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [87] = {
    [sym_declaration] = STATE(88),
    [sym_type_definition] = STATE(88),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(88),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(88),
    [sym_labeled_statement] = STATE(88),
    [sym_expression_statement] = STATE(88),
    [sym_if_statement] = STATE(88),
    [sym_switch_statement] = STATE(88),
    [sym_while_statement] = STATE(88),
    [sym_do_statement] = STATE(88),
    [sym_for_statement] = STATE(88),
    [sym_return_statement] = STATE(88),
    [sym_break_statement] = STATE(88),
    [sym_continue_statement] = STATE(88),
    [sym_goto_statement] = STATE(88),
    [sym_seh_try_statement] = STATE(88),
    [sym_seh_leave_statement] = STATE(88),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(88),
    [sym_co_return_statement] = STATE(88),
    [sym_co_yield_statement] = STATE(88),
    [sym_throw_statement] = STATE(88),
    [sym_try_statement] = STATE(88),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(88),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(88),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(88),
    [sym_identifier] = ACTIONS(1290),
    [aux_sym_preproc_include_token1] = ACTIONS(1316),
    [aux_sym_preproc_def_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token2] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1316),
    [aux_sym_preproc_else_token1] = ACTIONS(1316),
    [aux_sym_preproc_elif_token1] = ACTIONS(1316),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1316),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1316),
    [sym_preproc_directive] = ACTIONS(1316),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1316),
    [anon_sym___cdecl] = ACTIONS(1316),
    [anon_sym___clrcall] = ACTIONS(1316),
    [anon_sym___stdcall] = ACTIONS(1316),
    [anon_sym___fastcall] = ACTIONS(1316),
    [anon_sym___thiscall] = ACTIONS(1316),
    [anon_sym___vectorcall] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1316),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(1316),
    [anon_sym_static_assert] = ACTIONS(1316),
    [anon_sym_concept] = ACTIONS(1316),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [88] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(89),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(89),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1290),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token2] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [aux_sym_preproc_else_token1] = ACTIONS(1320),
    [aux_sym_preproc_elif_token1] = ACTIONS(1320),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(1302),
    [anon_sym_typedef] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1320),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1320),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_static_assert] = ACTIONS(1320),
    [anon_sym_concept] = ACTIONS(1320),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [89] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(89),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(89),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [sym_identifier] = ACTIONS(1324),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token2] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [aux_sym_preproc_else_token1] = ACTIONS(1327),
    [aux_sym_preproc_elif_token1] = ACTIONS(1327),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym___extension__] = ACTIONS(1349),
    [anon_sym_typedef] = ACTIONS(1352),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_virtual] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym___attribute] = ACTIONS(1361),
    [anon_sym_using] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___based] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_signed] = ACTIONS(1376),
    [anon_sym_unsigned] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [anon_sym__Nonnull] = ACTIONS(1382),
    [anon_sym_mutable] = ACTIONS(1382),
    [anon_sym_constinit] = ACTIONS(1382),
    [anon_sym_consteval] = ACTIONS(1382),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_class] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1406),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1424),
    [anon_sym_goto] = ACTIONS(1427),
    [anon_sym___try] = ACTIONS(1430),
    [anon_sym___leave] = ACTIONS(1433),
    [anon_sym_not] = ACTIONS(1335),
    [anon_sym_compl] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1448),
    [anon_sym_asm] = ACTIONS(1451),
    [anon_sym___asm__] = ACTIONS(1451),
    [anon_sym___asm] = ACTIONS(1451),
    [sym_number_literal] = ACTIONS(1454),
    [anon_sym_L_SQUOTE] = ACTIONS(1457),
    [anon_sym_u_SQUOTE] = ACTIONS(1457),
    [anon_sym_U_SQUOTE] = ACTIONS(1457),
    [anon_sym_u8_SQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1469),
    [anon_sym_decltype] = ACTIONS(1472),
    [anon_sym_explicit] = ACTIONS(1327),
    [anon_sym_typename] = ACTIONS(1475),
    [anon_sym_template] = ACTIONS(1478),
    [anon_sym_operator] = ACTIONS(1327),
    [anon_sym_try] = ACTIONS(1481),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1327),
    [anon_sym_static_assert] = ACTIONS(1327),
    [anon_sym_concept] = ACTIONS(1327),
    [anon_sym_co_return] = ACTIONS(1490),
    [anon_sym_co_yield] = ACTIONS(1493),
    [anon_sym_R_DQUOTE] = ACTIONS(1496),
    [anon_sym_LR_DQUOTE] = ACTIONS(1496),
    [anon_sym_uR_DQUOTE] = ACTIONS(1496),
    [anon_sym_UR_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1496),
    [anon_sym_co_await] = ACTIONS(1499),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_requires] = ACTIONS(1505),
    [sym_this] = ACTIONS(1463),
    [anon_sym_discard] = ACTIONS(1508),
    [anon_sym_precise] = ACTIONS(1511),
    [anon_sym_shared] = ACTIONS(1511),
    [anon_sym_groupshared] = ACTIONS(1511),
    [anon_sym_uniform] = ACTIONS(1511),
    [anon_sym_row_major] = ACTIONS(1511),
    [anon_sym_column_major] = ACTIONS(1511),
    [anon_sym_globallycoherent] = ACTIONS(1511),
    [anon_sym_centroid] = ACTIONS(1511),
    [anon_sym_noperspective] = ACTIONS(1511),
    [anon_sym_nointerpolation] = ACTIONS(1511),
    [anon_sym_sample] = ACTIONS(1511),
    [anon_sym_linear] = ACTIONS(1511),
    [anon_sym_snorm] = ACTIONS(1511),
    [anon_sym_unorm] = ACTIONS(1511),
    [anon_sym_point] = ACTIONS(1511),
    [anon_sym_line] = ACTIONS(1511),
    [anon_sym_triangleadj] = ACTIONS(1511),
    [anon_sym_lineadj] = ACTIONS(1511),
    [anon_sym_triangle] = ACTIONS(1511),
    [anon_sym_cbuffer] = ACTIONS(1514),
  },
  [90] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(1314),
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1312),
    [aux_sym_preproc_def_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1312),
    [sym_preproc_directive] = ACTIONS(1312),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1312),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1312),
    [anon_sym___cdecl] = ACTIONS(1312),
    [anon_sym___clrcall] = ACTIONS(1312),
    [anon_sym___stdcall] = ACTIONS(1312),
    [anon_sym___fastcall] = ACTIONS(1312),
    [anon_sym___thiscall] = ACTIONS(1312),
    [anon_sym___vectorcall] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1312),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1312),
    [anon_sym_module] = ACTIONS(1312),
    [anon_sym_import] = ACTIONS(1312),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1312),
    [anon_sym_static_assert] = ACTIONS(1312),
    [anon_sym_concept] = ACTIONS(1312),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [91] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(1341),
    [sym_identifier] = ACTIONS(1521),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1524),
    [anon_sym___extension__] = ACTIONS(1527),
    [anon_sym_typedef] = ACTIONS(1530),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_virtual] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym___attribute] = ACTIONS(1361),
    [anon_sym_using] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___based] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_signed] = ACTIONS(1376),
    [anon_sym_unsigned] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [anon_sym__Nonnull] = ACTIONS(1382),
    [anon_sym_mutable] = ACTIONS(1382),
    [anon_sym_constinit] = ACTIONS(1382),
    [anon_sym_consteval] = ACTIONS(1382),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_class] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1536),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1539),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1542),
    [anon_sym_do] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1554),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_goto] = ACTIONS(1560),
    [anon_sym___try] = ACTIONS(1563),
    [anon_sym___leave] = ACTIONS(1566),
    [anon_sym_not] = ACTIONS(1335),
    [anon_sym_compl] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1448),
    [anon_sym_asm] = ACTIONS(1451),
    [anon_sym___asm__] = ACTIONS(1451),
    [anon_sym___asm] = ACTIONS(1451),
    [sym_number_literal] = ACTIONS(1454),
    [anon_sym_L_SQUOTE] = ACTIONS(1457),
    [anon_sym_u_SQUOTE] = ACTIONS(1457),
    [anon_sym_U_SQUOTE] = ACTIONS(1457),
    [anon_sym_u8_SQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1469),
    [anon_sym_decltype] = ACTIONS(1472),
    [anon_sym_explicit] = ACTIONS(1327),
    [anon_sym_typename] = ACTIONS(1475),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_module] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1327),
    [anon_sym_template] = ACTIONS(1478),
    [anon_sym_operator] = ACTIONS(1327),
    [anon_sym_try] = ACTIONS(1569),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1572),
    [anon_sym_namespace] = ACTIONS(1327),
    [anon_sym_static_assert] = ACTIONS(1327),
    [anon_sym_concept] = ACTIONS(1327),
    [anon_sym_co_return] = ACTIONS(1575),
    [anon_sym_co_yield] = ACTIONS(1578),
    [anon_sym_R_DQUOTE] = ACTIONS(1496),
    [anon_sym_LR_DQUOTE] = ACTIONS(1496),
    [anon_sym_uR_DQUOTE] = ACTIONS(1496),
    [anon_sym_UR_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1496),
    [anon_sym_co_await] = ACTIONS(1499),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_requires] = ACTIONS(1505),
    [sym_this] = ACTIONS(1463),
    [anon_sym_discard] = ACTIONS(1581),
    [anon_sym_precise] = ACTIONS(1511),
    [anon_sym_shared] = ACTIONS(1511),
    [anon_sym_groupshared] = ACTIONS(1511),
    [anon_sym_uniform] = ACTIONS(1511),
    [anon_sym_row_major] = ACTIONS(1511),
    [anon_sym_column_major] = ACTIONS(1511),
    [anon_sym_globallycoherent] = ACTIONS(1511),
    [anon_sym_centroid] = ACTIONS(1511),
    [anon_sym_noperspective] = ACTIONS(1511),
    [anon_sym_nointerpolation] = ACTIONS(1511),
    [anon_sym_sample] = ACTIONS(1511),
    [anon_sym_linear] = ACTIONS(1511),
    [anon_sym_snorm] = ACTIONS(1511),
    [anon_sym_unorm] = ACTIONS(1511),
    [anon_sym_point] = ACTIONS(1511),
    [anon_sym_line] = ACTIONS(1511),
    [anon_sym_triangleadj] = ACTIONS(1511),
    [anon_sym_lineadj] = ACTIONS(1511),
    [anon_sym_triangle] = ACTIONS(1511),
    [anon_sym_cbuffer] = ACTIONS(1584),
  },
  [92] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(90),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(90),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [ts_builtin_sym_end] = ACTIONS(1298),
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1292),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1292),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1292),
    [anon_sym_import] = ACTIONS(1292),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1292),
    [anon_sym_static_assert] = ACTIONS(1292),
    [anon_sym_concept] = ACTIONS(1292),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [93] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(94),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(94),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [ts_builtin_sym_end] = ACTIONS(1318),
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1316),
    [aux_sym_preproc_def_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1316),
    [sym_preproc_directive] = ACTIONS(1316),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1316),
    [anon_sym___cdecl] = ACTIONS(1316),
    [anon_sym___clrcall] = ACTIONS(1316),
    [anon_sym___stdcall] = ACTIONS(1316),
    [anon_sym___fastcall] = ACTIONS(1316),
    [anon_sym___thiscall] = ACTIONS(1316),
    [anon_sym___vectorcall] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1316),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1316),
    [anon_sym_module] = ACTIONS(1316),
    [anon_sym_import] = ACTIONS(1316),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1316),
    [anon_sym_static_assert] = ACTIONS(1316),
    [anon_sym_concept] = ACTIONS(1316),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [94] = {
    [sym_declaration] = STATE(91),
    [sym_type_definition] = STATE(91),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(91),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(91),
    [sym_labeled_statement] = STATE(91),
    [sym_expression_statement] = STATE(91),
    [sym_if_statement] = STATE(91),
    [sym_switch_statement] = STATE(91),
    [sym_while_statement] = STATE(91),
    [sym_do_statement] = STATE(91),
    [sym_for_statement] = STATE(91),
    [sym_return_statement] = STATE(91),
    [sym_break_statement] = STATE(91),
    [sym_continue_statement] = STATE(91),
    [sym_goto_statement] = STATE(91),
    [sym_seh_try_statement] = STATE(91),
    [sym_seh_leave_statement] = STATE(91),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(91),
    [sym_co_return_statement] = STATE(91),
    [sym_co_yield_statement] = STATE(91),
    [sym_throw_statement] = STATE(91),
    [sym_try_statement] = STATE(91),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(91),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(91),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(91),
    [ts_builtin_sym_end] = ACTIONS(1322),
    [sym_identifier] = ACTIONS(1517),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(1519),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1320),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1320),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_export] = ACTIONS(1320),
    [anon_sym_module] = ACTIONS(1320),
    [anon_sym_import] = ACTIONS(1320),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_static_assert] = ACTIONS(1320),
    [anon_sym_concept] = ACTIONS(1320),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [95] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1587),
    [aux_sym_preproc_include_token1] = ACTIONS(1312),
    [aux_sym_preproc_def_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token2] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1312),
    [sym_preproc_directive] = ACTIONS(1312),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(1589),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1312),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1312),
    [anon_sym___cdecl] = ACTIONS(1312),
    [anon_sym___clrcall] = ACTIONS(1312),
    [anon_sym___stdcall] = ACTIONS(1312),
    [anon_sym___fastcall] = ACTIONS(1312),
    [anon_sym___thiscall] = ACTIONS(1312),
    [anon_sym___vectorcall] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1312),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(1312),
    [anon_sym_static_assert] = ACTIONS(1312),
    [anon_sym_concept] = ACTIONS(1312),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [96] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(98),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(98),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1591),
    [aux_sym_preproc_include_token1] = ACTIONS(1312),
    [aux_sym_preproc_def_token1] = ACTIONS(1312),
    [aux_sym_preproc_if_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1312),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1312),
    [sym_preproc_directive] = ACTIONS(1312),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1312),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1312),
    [anon_sym___cdecl] = ACTIONS(1312),
    [anon_sym___clrcall] = ACTIONS(1312),
    [anon_sym___stdcall] = ACTIONS(1312),
    [anon_sym___fastcall] = ACTIONS(1312),
    [anon_sym___thiscall] = ACTIONS(1312),
    [anon_sym___vectorcall] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(1312),
    [anon_sym_default] = ACTIONS(1312),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1312),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1312),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(1312),
    [anon_sym_static_assert] = ACTIONS(1312),
    [anon_sym_concept] = ACTIONS(1312),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [97] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1595),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token2] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1598),
    [anon_sym___extension__] = ACTIONS(1601),
    [anon_sym_typedef] = ACTIONS(1604),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_virtual] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym___attribute] = ACTIONS(1361),
    [anon_sym_using] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___based] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1607),
    [anon_sym_signed] = ACTIONS(1376),
    [anon_sym_unsigned] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [anon_sym__Nonnull] = ACTIONS(1382),
    [anon_sym_mutable] = ACTIONS(1382),
    [anon_sym_constinit] = ACTIONS(1382),
    [anon_sym_consteval] = ACTIONS(1382),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_class] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1613),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1616),
    [anon_sym_do] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1622),
    [anon_sym_return] = ACTIONS(1625),
    [anon_sym_break] = ACTIONS(1628),
    [anon_sym_continue] = ACTIONS(1631),
    [anon_sym_goto] = ACTIONS(1634),
    [anon_sym___try] = ACTIONS(1637),
    [anon_sym___leave] = ACTIONS(1640),
    [anon_sym_not] = ACTIONS(1335),
    [anon_sym_compl] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1448),
    [anon_sym_asm] = ACTIONS(1451),
    [anon_sym___asm__] = ACTIONS(1451),
    [anon_sym___asm] = ACTIONS(1451),
    [sym_number_literal] = ACTIONS(1454),
    [anon_sym_L_SQUOTE] = ACTIONS(1457),
    [anon_sym_u_SQUOTE] = ACTIONS(1457),
    [anon_sym_U_SQUOTE] = ACTIONS(1457),
    [anon_sym_u8_SQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1469),
    [anon_sym_decltype] = ACTIONS(1472),
    [anon_sym_explicit] = ACTIONS(1327),
    [anon_sym_typename] = ACTIONS(1475),
    [anon_sym_template] = ACTIONS(1478),
    [anon_sym_operator] = ACTIONS(1327),
    [anon_sym_try] = ACTIONS(1643),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1646),
    [anon_sym_namespace] = ACTIONS(1327),
    [anon_sym_static_assert] = ACTIONS(1327),
    [anon_sym_concept] = ACTIONS(1327),
    [anon_sym_co_return] = ACTIONS(1649),
    [anon_sym_co_yield] = ACTIONS(1652),
    [anon_sym_R_DQUOTE] = ACTIONS(1496),
    [anon_sym_LR_DQUOTE] = ACTIONS(1496),
    [anon_sym_uR_DQUOTE] = ACTIONS(1496),
    [anon_sym_UR_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1496),
    [anon_sym_co_await] = ACTIONS(1499),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_requires] = ACTIONS(1505),
    [sym_this] = ACTIONS(1463),
    [anon_sym_discard] = ACTIONS(1655),
    [anon_sym_precise] = ACTIONS(1511),
    [anon_sym_shared] = ACTIONS(1511),
    [anon_sym_groupshared] = ACTIONS(1511),
    [anon_sym_uniform] = ACTIONS(1511),
    [anon_sym_row_major] = ACTIONS(1511),
    [anon_sym_column_major] = ACTIONS(1511),
    [anon_sym_globallycoherent] = ACTIONS(1511),
    [anon_sym_centroid] = ACTIONS(1511),
    [anon_sym_noperspective] = ACTIONS(1511),
    [anon_sym_nointerpolation] = ACTIONS(1511),
    [anon_sym_sample] = ACTIONS(1511),
    [anon_sym_linear] = ACTIONS(1511),
    [anon_sym_snorm] = ACTIONS(1511),
    [anon_sym_unorm] = ACTIONS(1511),
    [anon_sym_point] = ACTIONS(1511),
    [anon_sym_line] = ACTIONS(1511),
    [anon_sym_triangleadj] = ACTIONS(1511),
    [anon_sym_lineadj] = ACTIONS(1511),
    [anon_sym_triangle] = ACTIONS(1511),
    [anon_sym_cbuffer] = ACTIONS(1658),
  },
  [98] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(98),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(98),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1661),
    [aux_sym_preproc_include_token1] = ACTIONS(1327),
    [aux_sym_preproc_def_token1] = ACTIONS(1327),
    [aux_sym_preproc_if_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1327),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1327),
    [sym_preproc_directive] = ACTIONS(1327),
    [anon_sym_LPAREN2] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_AMP_AMP] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1664),
    [anon_sym___extension__] = ACTIONS(1667),
    [anon_sym_typedef] = ACTIONS(1670),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_virtual] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym___attribute] = ACTIONS(1361),
    [anon_sym_using] = ACTIONS(1327),
    [anon_sym_COLON_COLON] = ACTIONS(1364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym___based] = ACTIONS(1327),
    [anon_sym___cdecl] = ACTIONS(1327),
    [anon_sym___clrcall] = ACTIONS(1327),
    [anon_sym___stdcall] = ACTIONS(1327),
    [anon_sym___fastcall] = ACTIONS(1327),
    [anon_sym___thiscall] = ACTIONS(1327),
    [anon_sym___vectorcall] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1673),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_signed] = ACTIONS(1376),
    [anon_sym_unsigned] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [anon_sym__Nonnull] = ACTIONS(1382),
    [anon_sym_mutable] = ACTIONS(1382),
    [anon_sym_constinit] = ACTIONS(1382),
    [anon_sym_consteval] = ACTIONS(1382),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_class] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1676),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1679),
    [anon_sym_case] = ACTIONS(1327),
    [anon_sym_default] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1682),
    [anon_sym_do] = ACTIONS(1685),
    [anon_sym_for] = ACTIONS(1688),
    [anon_sym_return] = ACTIONS(1691),
    [anon_sym_break] = ACTIONS(1694),
    [anon_sym_continue] = ACTIONS(1697),
    [anon_sym_goto] = ACTIONS(1700),
    [anon_sym___try] = ACTIONS(1703),
    [anon_sym___leave] = ACTIONS(1706),
    [anon_sym_not] = ACTIONS(1335),
    [anon_sym_compl] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1448),
    [anon_sym_asm] = ACTIONS(1451),
    [anon_sym___asm__] = ACTIONS(1451),
    [anon_sym___asm] = ACTIONS(1451),
    [sym_number_literal] = ACTIONS(1454),
    [anon_sym_L_SQUOTE] = ACTIONS(1457),
    [anon_sym_u_SQUOTE] = ACTIONS(1457),
    [anon_sym_U_SQUOTE] = ACTIONS(1457),
    [anon_sym_u8_SQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1469),
    [anon_sym_decltype] = ACTIONS(1472),
    [anon_sym_explicit] = ACTIONS(1327),
    [anon_sym_typename] = ACTIONS(1475),
    [anon_sym_template] = ACTIONS(1478),
    [anon_sym_operator] = ACTIONS(1327),
    [anon_sym_try] = ACTIONS(1709),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1712),
    [anon_sym_namespace] = ACTIONS(1327),
    [anon_sym_static_assert] = ACTIONS(1327),
    [anon_sym_concept] = ACTIONS(1327),
    [anon_sym_co_return] = ACTIONS(1715),
    [anon_sym_co_yield] = ACTIONS(1718),
    [anon_sym_R_DQUOTE] = ACTIONS(1496),
    [anon_sym_LR_DQUOTE] = ACTIONS(1496),
    [anon_sym_uR_DQUOTE] = ACTIONS(1496),
    [anon_sym_UR_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1496),
    [anon_sym_co_await] = ACTIONS(1499),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_requires] = ACTIONS(1505),
    [sym_this] = ACTIONS(1463),
    [anon_sym_discard] = ACTIONS(1721),
    [anon_sym_precise] = ACTIONS(1511),
    [anon_sym_shared] = ACTIONS(1511),
    [anon_sym_groupshared] = ACTIONS(1511),
    [anon_sym_uniform] = ACTIONS(1511),
    [anon_sym_row_major] = ACTIONS(1511),
    [anon_sym_column_major] = ACTIONS(1511),
    [anon_sym_globallycoherent] = ACTIONS(1511),
    [anon_sym_centroid] = ACTIONS(1511),
    [anon_sym_noperspective] = ACTIONS(1511),
    [anon_sym_nointerpolation] = ACTIONS(1511),
    [anon_sym_sample] = ACTIONS(1511),
    [anon_sym_linear] = ACTIONS(1511),
    [anon_sym_snorm] = ACTIONS(1511),
    [anon_sym_unorm] = ACTIONS(1511),
    [anon_sym_point] = ACTIONS(1511),
    [anon_sym_line] = ACTIONS(1511),
    [anon_sym_triangleadj] = ACTIONS(1511),
    [anon_sym_lineadj] = ACTIONS(1511),
    [anon_sym_triangle] = ACTIONS(1511),
    [anon_sym_cbuffer] = ACTIONS(1724),
  },
  [99] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(98),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(98),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1591),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1320),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1322),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1320),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_static_assert] = ACTIONS(1320),
    [anon_sym_concept] = ACTIONS(1320),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [100] = {
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(96),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(96),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(96),
    [sym_identifier] = ACTIONS(1591),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1292),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1298),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1292),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(1292),
    [anon_sym_static_assert] = ACTIONS(1292),
    [anon_sym_concept] = ACTIONS(1292),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [101] = {
    [sym_declaration] = STATE(99),
    [sym_type_definition] = STATE(99),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(99),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(99),
    [sym_labeled_statement] = STATE(99),
    [sym_expression_statement] = STATE(99),
    [sym_if_statement] = STATE(99),
    [sym_switch_statement] = STATE(99),
    [sym_while_statement] = STATE(99),
    [sym_do_statement] = STATE(99),
    [sym_for_statement] = STATE(99),
    [sym_return_statement] = STATE(99),
    [sym_break_statement] = STATE(99),
    [sym_continue_statement] = STATE(99),
    [sym_goto_statement] = STATE(99),
    [sym_seh_try_statement] = STATE(99),
    [sym_seh_leave_statement] = STATE(99),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(99),
    [sym_co_return_statement] = STATE(99),
    [sym_co_yield_statement] = STATE(99),
    [sym_throw_statement] = STATE(99),
    [sym_try_statement] = STATE(99),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(99),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(99),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(1591),
    [aux_sym_preproc_include_token1] = ACTIONS(1316),
    [aux_sym_preproc_def_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1316),
    [sym_preproc_directive] = ACTIONS(1316),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1593),
    [anon_sym_typedef] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1316),
    [anon_sym___cdecl] = ACTIONS(1316),
    [anon_sym___clrcall] = ACTIONS(1316),
    [anon_sym___stdcall] = ACTIONS(1316),
    [anon_sym___fastcall] = ACTIONS(1316),
    [anon_sym___thiscall] = ACTIONS(1316),
    [anon_sym___vectorcall] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(1318),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1316),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_namespace] = ACTIONS(1316),
    [anon_sym_static_assert] = ACTIONS(1316),
    [anon_sym_concept] = ACTIONS(1316),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [102] = {
    [sym_declaration] = STATE(104),
    [sym_type_definition] = STATE(104),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(104),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(104),
    [sym_labeled_statement] = STATE(104),
    [sym_expression_statement] = STATE(104),
    [sym_if_statement] = STATE(104),
    [sym_switch_statement] = STATE(104),
    [sym_while_statement] = STATE(104),
    [sym_do_statement] = STATE(104),
    [sym_for_statement] = STATE(104),
    [sym_return_statement] = STATE(104),
    [sym_break_statement] = STATE(104),
    [sym_continue_statement] = STATE(104),
    [sym_goto_statement] = STATE(104),
    [sym_seh_try_statement] = STATE(104),
    [sym_seh_leave_statement] = STATE(104),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(104),
    [sym_co_return_statement] = STATE(104),
    [sym_co_yield_statement] = STATE(104),
    [sym_throw_statement] = STATE(104),
    [sym_try_statement] = STATE(104),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(104),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(104),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(104),
    [sym_identifier] = ACTIONS(1587),
    [aux_sym_preproc_include_token1] = ACTIONS(1316),
    [aux_sym_preproc_def_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token1] = ACTIONS(1316),
    [aux_sym_preproc_if_token2] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1316),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1316),
    [sym_preproc_directive] = ACTIONS(1316),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1318),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(1589),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1316),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1316),
    [anon_sym___cdecl] = ACTIONS(1316),
    [anon_sym___clrcall] = ACTIONS(1316),
    [anon_sym___stdcall] = ACTIONS(1316),
    [anon_sym___fastcall] = ACTIONS(1316),
    [anon_sym___thiscall] = ACTIONS(1316),
    [anon_sym___vectorcall] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1316),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1316),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(1316),
    [anon_sym_static_assert] = ACTIONS(1316),
    [anon_sym_concept] = ACTIONS(1316),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [103] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(95),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(95),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1587),
    [aux_sym_preproc_include_token1] = ACTIONS(1292),
    [aux_sym_preproc_def_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token1] = ACTIONS(1292),
    [aux_sym_preproc_if_token2] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1292),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1292),
    [sym_preproc_directive] = ACTIONS(1292),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1298),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(1589),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1292),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1292),
    [anon_sym___cdecl] = ACTIONS(1292),
    [anon_sym___clrcall] = ACTIONS(1292),
    [anon_sym___stdcall] = ACTIONS(1292),
    [anon_sym___fastcall] = ACTIONS(1292),
    [anon_sym___thiscall] = ACTIONS(1292),
    [anon_sym___vectorcall] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1292),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1292),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(1292),
    [anon_sym_static_assert] = ACTIONS(1292),
    [anon_sym_concept] = ACTIONS(1292),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [104] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(97),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(97),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1587),
    [aux_sym_preproc_include_token1] = ACTIONS(1320),
    [aux_sym_preproc_def_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token1] = ACTIONS(1320),
    [aux_sym_preproc_if_token2] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1320),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1320),
    [sym_preproc_directive] = ACTIONS(1320),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1322),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(1589),
    [anon_sym_typedef] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1320),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(1320),
    [anon_sym___cdecl] = ACTIONS(1320),
    [anon_sym___clrcall] = ACTIONS(1320),
    [anon_sym___stdcall] = ACTIONS(1320),
    [anon_sym___fastcall] = ACTIONS(1320),
    [anon_sym___thiscall] = ACTIONS(1320),
    [anon_sym___vectorcall] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(1320),
    [anon_sym_default] = ACTIONS(1320),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(1320),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(1320),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_namespace] = ACTIONS(1320),
    [anon_sym_static_assert] = ACTIONS(1320),
    [anon_sym_concept] = ACTIONS(1320),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [105] = {
    [sym_declaration] = STATE(475),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(475),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4621),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8066),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(193),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [106] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(106),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(106),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_LPAREN2] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1332),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1338),
    [anon_sym_SEMI] = ACTIONS(1732),
    [anon_sym___extension__] = ACTIONS(1735),
    [anon_sym_typedef] = ACTIONS(1738),
    [anon_sym_in] = ACTIONS(1355),
    [anon_sym_out] = ACTIONS(1355),
    [anon_sym_inout] = ACTIONS(1355),
    [anon_sym_virtual] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1358),
    [anon_sym___attribute__] = ACTIONS(1361),
    [anon_sym___attribute] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1367),
    [anon_sym___declspec] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(1741),
    [anon_sym_signed] = ACTIONS(1376),
    [anon_sym_unsigned] = ACTIONS(1376),
    [anon_sym_long] = ACTIONS(1376),
    [anon_sym_short] = ACTIONS(1376),
    [anon_sym_LBRACK] = ACTIONS(1379),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_register] = ACTIONS(1358),
    [anon_sym_inline] = ACTIONS(1358),
    [anon_sym___inline] = ACTIONS(1358),
    [anon_sym___inline__] = ACTIONS(1358),
    [anon_sym___forceinline] = ACTIONS(1358),
    [anon_sym_thread_local] = ACTIONS(1358),
    [anon_sym___thread] = ACTIONS(1358),
    [anon_sym_const] = ACTIONS(1382),
    [anon_sym_constexpr] = ACTIONS(1382),
    [anon_sym_volatile] = ACTIONS(1382),
    [anon_sym_restrict] = ACTIONS(1382),
    [anon_sym___restrict__] = ACTIONS(1382),
    [anon_sym__Atomic] = ACTIONS(1382),
    [anon_sym__Noreturn] = ACTIONS(1382),
    [anon_sym_noreturn] = ACTIONS(1382),
    [anon_sym__Nonnull] = ACTIONS(1382),
    [anon_sym_mutable] = ACTIONS(1382),
    [anon_sym_constinit] = ACTIONS(1382),
    [anon_sym_consteval] = ACTIONS(1382),
    [anon_sym_alignas] = ACTIONS(1385),
    [anon_sym__Alignas] = ACTIONS(1385),
    [sym_primitive_type] = ACTIONS(1388),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_class] = ACTIONS(1394),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1400),
    [anon_sym_if] = ACTIONS(1744),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_switch] = ACTIONS(1747),
    [anon_sym_while] = ACTIONS(1750),
    [anon_sym_do] = ACTIONS(1753),
    [anon_sym_for] = ACTIONS(1756),
    [anon_sym_return] = ACTIONS(1759),
    [anon_sym_break] = ACTIONS(1762),
    [anon_sym_continue] = ACTIONS(1765),
    [anon_sym_goto] = ACTIONS(1768),
    [anon_sym___try] = ACTIONS(1771),
    [anon_sym___leave] = ACTIONS(1774),
    [anon_sym_not] = ACTIONS(1335),
    [anon_sym_compl] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_sizeof] = ACTIONS(1439),
    [anon_sym___alignof__] = ACTIONS(1442),
    [anon_sym___alignof] = ACTIONS(1442),
    [anon_sym__alignof] = ACTIONS(1442),
    [anon_sym_alignof] = ACTIONS(1442),
    [anon_sym__Alignof] = ACTIONS(1442),
    [anon_sym_offsetof] = ACTIONS(1445),
    [anon_sym__Generic] = ACTIONS(1448),
    [anon_sym_asm] = ACTIONS(1451),
    [anon_sym___asm__] = ACTIONS(1451),
    [anon_sym___asm] = ACTIONS(1451),
    [sym_number_literal] = ACTIONS(1454),
    [anon_sym_L_SQUOTE] = ACTIONS(1457),
    [anon_sym_u_SQUOTE] = ACTIONS(1457),
    [anon_sym_U_SQUOTE] = ACTIONS(1457),
    [anon_sym_u8_SQUOTE] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_L_DQUOTE] = ACTIONS(1460),
    [anon_sym_u_DQUOTE] = ACTIONS(1460),
    [anon_sym_U_DQUOTE] = ACTIONS(1460),
    [anon_sym_u8_DQUOTE] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(1460),
    [sym_true] = ACTIONS(1463),
    [sym_false] = ACTIONS(1463),
    [anon_sym_NULL] = ACTIONS(1466),
    [anon_sym_nullptr] = ACTIONS(1466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1469),
    [anon_sym_decltype] = ACTIONS(1472),
    [anon_sym_typename] = ACTIONS(1475),
    [anon_sym_template] = ACTIONS(1478),
    [anon_sym_try] = ACTIONS(1777),
    [anon_sym_delete] = ACTIONS(1484),
    [anon_sym_throw] = ACTIONS(1780),
    [anon_sym_co_return] = ACTIONS(1783),
    [anon_sym_co_yield] = ACTIONS(1786),
    [anon_sym_R_DQUOTE] = ACTIONS(1496),
    [anon_sym_LR_DQUOTE] = ACTIONS(1496),
    [anon_sym_uR_DQUOTE] = ACTIONS(1496),
    [anon_sym_UR_DQUOTE] = ACTIONS(1496),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1496),
    [anon_sym_co_await] = ACTIONS(1499),
    [anon_sym_new] = ACTIONS(1502),
    [anon_sym_requires] = ACTIONS(1505),
    [sym_this] = ACTIONS(1463),
    [anon_sym_discard] = ACTIONS(1789),
    [anon_sym_precise] = ACTIONS(1511),
    [anon_sym_shared] = ACTIONS(1511),
    [anon_sym_groupshared] = ACTIONS(1511),
    [anon_sym_uniform] = ACTIONS(1511),
    [anon_sym_row_major] = ACTIONS(1511),
    [anon_sym_column_major] = ACTIONS(1511),
    [anon_sym_globallycoherent] = ACTIONS(1511),
    [anon_sym_centroid] = ACTIONS(1511),
    [anon_sym_noperspective] = ACTIONS(1511),
    [anon_sym_nointerpolation] = ACTIONS(1511),
    [anon_sym_sample] = ACTIONS(1511),
    [anon_sym_linear] = ACTIONS(1511),
    [anon_sym_snorm] = ACTIONS(1511),
    [anon_sym_unorm] = ACTIONS(1511),
    [anon_sym_point] = ACTIONS(1511),
    [anon_sym_line] = ACTIONS(1511),
    [anon_sym_triangleadj] = ACTIONS(1511),
    [anon_sym_lineadj] = ACTIONS(1511),
    [anon_sym_triangle] = ACTIONS(1511),
    [anon_sym_cbuffer] = ACTIONS(1792),
  },
  [107] = {
    [sym_declaration] = STATE(112),
    [sym_type_definition] = STATE(112),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(112),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(112),
    [sym_labeled_statement] = STATE(112),
    [sym_expression_statement] = STATE(112),
    [sym_if_statement] = STATE(112),
    [sym_switch_statement] = STATE(112),
    [sym_while_statement] = STATE(112),
    [sym_do_statement] = STATE(112),
    [sym_for_statement] = STATE(112),
    [sym_return_statement] = STATE(112),
    [sym_break_statement] = STATE(112),
    [sym_continue_statement] = STATE(112),
    [sym_goto_statement] = STATE(112),
    [sym_seh_try_statement] = STATE(112),
    [sym_seh_leave_statement] = STATE(112),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(112),
    [sym_co_return_statement] = STATE(112),
    [sym_co_yield_statement] = STATE(112),
    [sym_throw_statement] = STATE(112),
    [sym_try_statement] = STATE(112),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(112),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(112),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(112),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1801),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [108] = {
    [sym_declaration] = STATE(251),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5486),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(236),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(251),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [109] = {
    [sym_declaration] = STATE(475),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5495),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(475),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [110] = {
    [sym_declaration] = STATE(495),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5526),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(477),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(495),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1587),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [111] = {
    [sym_declaration] = STATE(114),
    [sym_type_definition] = STATE(114),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(114),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(114),
    [sym_labeled_statement] = STATE(114),
    [sym_expression_statement] = STATE(114),
    [sym_if_statement] = STATE(114),
    [sym_switch_statement] = STATE(114),
    [sym_while_statement] = STATE(114),
    [sym_do_statement] = STATE(114),
    [sym_for_statement] = STATE(114),
    [sym_return_statement] = STATE(114),
    [sym_break_statement] = STATE(114),
    [sym_continue_statement] = STATE(114),
    [sym_goto_statement] = STATE(114),
    [sym_seh_try_statement] = STATE(114),
    [sym_seh_leave_statement] = STATE(114),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(114),
    [sym_co_return_statement] = STATE(114),
    [sym_co_yield_statement] = STATE(114),
    [sym_throw_statement] = STATE(114),
    [sym_try_statement] = STATE(114),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(114),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(114),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(114),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1801),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [112] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(106),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(106),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1801),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1320),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [113] = {
    [sym_declaration] = STATE(267),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(539),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(267),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [114] = {
    [sym_declaration] = STATE(106),
    [sym_type_definition] = STATE(106),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(106),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(106),
    [sym_labeled_statement] = STATE(106),
    [sym_expression_statement] = STATE(106),
    [sym_if_statement] = STATE(106),
    [sym_switch_statement] = STATE(106),
    [sym_while_statement] = STATE(106),
    [sym_do_statement] = STATE(106),
    [sym_for_statement] = STATE(106),
    [sym_return_statement] = STATE(106),
    [sym_break_statement] = STATE(106),
    [sym_continue_statement] = STATE(106),
    [sym_goto_statement] = STATE(106),
    [sym_seh_try_statement] = STATE(106),
    [sym_seh_leave_statement] = STATE(106),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(106),
    [sym_co_return_statement] = STATE(106),
    [sym_co_yield_statement] = STATE(106),
    [sym_throw_statement] = STATE(106),
    [sym_try_statement] = STATE(106),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(106),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(106),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_case_statement_repeat1] = STATE(106),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1801),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_else] = ACTIONS(1312),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [115] = {
    [sym_declaration] = STATE(1092),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5515),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(1096),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1092),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [116] = {
    [sym_declaration] = STATE(267),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5504),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(1057),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_compound_statement] = STATE(305),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(267),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_qualifiers] = STATE(2043),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1517),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [117] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(8364),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(8369),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [118] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(8445),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(8455),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [119] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(8536),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(8553),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [120] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(8571),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(8576),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [121] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(9127),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(9129),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [122] = {
    [sym_declaration] = STATE(449),
    [sym_type_definition] = STATE(2675),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5521),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(2675),
    [sym__for_statement_body] = STATE(8355),
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8546),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(2675),
    [sym__for_range_loop_body] = STATE(8356),
    [sym_init_statement] = STATE(2024),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym___extension__] = ACTIONS(1859),
    [anon_sym_typedef] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [123] = {
    [sym_declaration] = STATE(1205),
    [sym_type_definition] = STATE(1205),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5459),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression_statement] = STATE(1205),
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(7931),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_alias_declaration] = STATE(1205),
    [sym_init_statement] = STATE(137),
    [sym_condition_declaration] = STATE(8799),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(1799),
    [anon_sym_typedef] = ACTIONS(1801),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(1869),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [124] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3558),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8330),
    [sym__unary_right_fold] = STATE(8333),
    [sym__binary_fold] = STATE(8338),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [125] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3574),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8768),
    [sym__unary_right_fold] = STATE(8810),
    [sym__binary_fold] = STATE(8886),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [126] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3534),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8263),
    [sym__unary_right_fold] = STATE(8285),
    [sym__binary_fold] = STATE(8310),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [127] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3553),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [128] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3564),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8652),
    [sym__unary_right_fold] = STATE(8658),
    [sym__binary_fold] = STATE(8659),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [129] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_compound_statement] = STATE(7611),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7627),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7611),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7627),
    [sym_variadic_parameter_declaration] = STATE(7627),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5952),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(1939),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [130] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_expression] = STATE(3539),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8098),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5889),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3724),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(1885),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [131] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8381),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [132] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8809),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [133] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8271),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [134] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8645),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [135] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8824),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [136] = {
    [sym_declaration] = STATE(1366),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5467),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__for_statement_body] = STATE(8253),
    [sym_expression] = STATE(4778),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8861),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [137] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5586),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_expression] = STATE(4747),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8503),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2432),
    [sym_template_function] = STATE(4117),
    [sym_condition_declaration] = STATE(8503),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5916),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(2434),
    [sym_user_defined_literal] = STATE(3523),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(71),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_include_token1] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym___cdecl] = ACTIONS(1947),
    [anon_sym___clrcall] = ACTIONS(1947),
    [anon_sym___stdcall] = ACTIONS(1947),
    [anon_sym___fastcall] = ACTIONS(1947),
    [anon_sym___thiscall] = ACTIONS(1947),
    [anon_sym___vectorcall] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___except] = ACTIONS(1947),
    [anon_sym___finally] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_not] = ACTIONS(1947),
    [anon_sym_compl] = ACTIONS(1947),
    [anon_sym_or] = ACTIONS(1947),
    [anon_sym_and] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [anon_sym___asm] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1945),
    [anon_sym_L_SQUOTE] = ACTIONS(1945),
    [anon_sym_u_SQUOTE] = ACTIONS(1945),
    [anon_sym_U_SQUOTE] = ACTIONS(1945),
    [anon_sym_u8_SQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_final] = ACTIONS(1947),
    [anon_sym_override] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_export] = ACTIONS(1947),
    [anon_sym_module] = ACTIONS(1947),
    [anon_sym_import] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_concept] = ACTIONS(1947),
    [anon_sym_co_return] = ACTIONS(1947),
    [anon_sym_co_yield] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1945),
    [anon_sym_LR_DQUOTE] = ACTIONS(1945),
    [anon_sym_uR_DQUOTE] = ACTIONS(1945),
    [anon_sym_UR_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1945),
    [anon_sym_co_await] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_requires] = ACTIONS(1947),
    [sym_this] = ACTIONS(1947),
    [anon_sym_discard] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
    [anon_sym_cbuffer] = ACTIONS(1947),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_RPAREN] = ACTIONS(1949),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_PIPE_PIPE] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___except] = ACTIONS(1951),
    [anon_sym___finally] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_or] = ACTIONS(1951),
    [anon_sym_and] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_final] = ACTIONS(1951),
    [anon_sym_override] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_import] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [140] = {
    [sym_identifier] = ACTIONS(1953),
    [aux_sym_preproc_include_token1] = ACTIONS(1953),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [aux_sym_preproc_if_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1953),
    [sym_preproc_directive] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_typedef] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_using] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1955),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_goto] = ACTIONS(1953),
    [anon_sym___try] = ACTIONS(1953),
    [anon_sym___leave] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1953),
    [anon_sym_compl] = ACTIONS(1953),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1953),
    [anon_sym___alignof__] = ACTIONS(1953),
    [anon_sym___alignof] = ACTIONS(1953),
    [anon_sym__alignof] = ACTIONS(1953),
    [anon_sym_alignof] = ACTIONS(1953),
    [anon_sym__Alignof] = ACTIONS(1953),
    [anon_sym_offsetof] = ACTIONS(1953),
    [anon_sym__Generic] = ACTIONS(1953),
    [anon_sym_asm] = ACTIONS(1953),
    [anon_sym___asm__] = ACTIONS(1953),
    [anon_sym___asm] = ACTIONS(1953),
    [sym_number_literal] = ACTIONS(1955),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [anon_sym_NULL] = ACTIONS(1953),
    [anon_sym_nullptr] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_explicit] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_GT2] = ACTIONS(1955),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_static_assert] = ACTIONS(1953),
    [anon_sym_concept] = ACTIONS(1953),
    [anon_sym_co_return] = ACTIONS(1953),
    [anon_sym_co_yield] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [sym_this] = ACTIONS(1953),
    [anon_sym_discard] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
    [anon_sym_cbuffer] = ACTIONS(1953),
  },
  [141] = {
    [sym_field_declaration_list] = STATE(261),
    [sym_virtual_specifier] = STATE(7238),
    [sym_base_class_clause] = STATE(7996),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [aux_sym_preproc_else_token1] = ACTIONS(1957),
    [aux_sym_preproc_elif_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_inout] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym___attribute] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1963),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym__Nonnull] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym__Alignas] = ACTIONS(1957),
    [sym_primitive_type] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [anon_sym___asm] = ACTIONS(1957),
    [sym_number_literal] = ACTIONS(1959),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
    [anon_sym_discard] = ACTIONS(1957),
    [anon_sym_precise] = ACTIONS(1957),
    [anon_sym_shared] = ACTIONS(1957),
    [anon_sym_groupshared] = ACTIONS(1957),
    [anon_sym_uniform] = ACTIONS(1957),
    [anon_sym_row_major] = ACTIONS(1957),
    [anon_sym_column_major] = ACTIONS(1957),
    [anon_sym_globallycoherent] = ACTIONS(1957),
    [anon_sym_centroid] = ACTIONS(1957),
    [anon_sym_noperspective] = ACTIONS(1957),
    [anon_sym_nointerpolation] = ACTIONS(1957),
    [anon_sym_sample] = ACTIONS(1957),
    [anon_sym_linear] = ACTIONS(1957),
    [anon_sym_snorm] = ACTIONS(1957),
    [anon_sym_unorm] = ACTIONS(1957),
    [anon_sym_point] = ACTIONS(1957),
    [anon_sym_line] = ACTIONS(1957),
    [anon_sym_triangleadj] = ACTIONS(1957),
    [anon_sym_lineadj] = ACTIONS(1957),
    [anon_sym_triangle] = ACTIONS(1957),
    [anon_sym_cbuffer] = ACTIONS(1957),
  },
  [142] = {
    [sym_field_declaration_list] = STATE(204),
    [sym_virtual_specifier] = STATE(7195),
    [sym_base_class_clause] = STATE(8043),
    [sym_identifier] = ACTIONS(1967),
    [aux_sym_preproc_include_token1] = ACTIONS(1967),
    [aux_sym_preproc_def_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token2] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1967),
    [aux_sym_preproc_else_token1] = ACTIONS(1967),
    [aux_sym_preproc_elif_token1] = ACTIONS(1967),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1967),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1967),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_typedef] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1967),
    [anon_sym_inout] = ACTIONS(1967),
    [anon_sym_virtual] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym___attribute] = ACTIONS(1967),
    [anon_sym_using] = ACTIONS(1967),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1969),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1963),
    [anon_sym_signed] = ACTIONS(1967),
    [anon_sym_unsigned] = ACTIONS(1967),
    [anon_sym_long] = ACTIONS(1967),
    [anon_sym_short] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym__Nonnull] = ACTIONS(1967),
    [anon_sym_mutable] = ACTIONS(1967),
    [anon_sym_constinit] = ACTIONS(1967),
    [anon_sym_consteval] = ACTIONS(1967),
    [anon_sym_alignas] = ACTIONS(1967),
    [anon_sym__Alignas] = ACTIONS(1967),
    [sym_primitive_type] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1967),
    [anon_sym___try] = ACTIONS(1967),
    [anon_sym___leave] = ACTIONS(1967),
    [anon_sym_not] = ACTIONS(1967),
    [anon_sym_compl] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(1967),
    [anon_sym___alignof__] = ACTIONS(1967),
    [anon_sym___alignof] = ACTIONS(1967),
    [anon_sym__alignof] = ACTIONS(1967),
    [anon_sym_alignof] = ACTIONS(1967),
    [anon_sym__Alignof] = ACTIONS(1967),
    [anon_sym_offsetof] = ACTIONS(1967),
    [anon_sym__Generic] = ACTIONS(1967),
    [anon_sym_asm] = ACTIONS(1967),
    [anon_sym___asm__] = ACTIONS(1967),
    [anon_sym___asm] = ACTIONS(1967),
    [sym_number_literal] = ACTIONS(1969),
    [anon_sym_L_SQUOTE] = ACTIONS(1969),
    [anon_sym_u_SQUOTE] = ACTIONS(1969),
    [anon_sym_U_SQUOTE] = ACTIONS(1969),
    [anon_sym_u8_SQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(1969),
    [anon_sym_u_DQUOTE] = ACTIONS(1969),
    [anon_sym_U_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8_DQUOTE] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [anon_sym_NULL] = ACTIONS(1967),
    [anon_sym_nullptr] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1967),
    [anon_sym_decltype] = ACTIONS(1967),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1967),
    [anon_sym_typename] = ACTIONS(1967),
    [anon_sym_template] = ACTIONS(1967),
    [anon_sym_operator] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_static_assert] = ACTIONS(1967),
    [anon_sym_concept] = ACTIONS(1967),
    [anon_sym_co_return] = ACTIONS(1967),
    [anon_sym_co_yield] = ACTIONS(1967),
    [anon_sym_R_DQUOTE] = ACTIONS(1969),
    [anon_sym_LR_DQUOTE] = ACTIONS(1969),
    [anon_sym_uR_DQUOTE] = ACTIONS(1969),
    [anon_sym_UR_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1969),
    [anon_sym_co_await] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_requires] = ACTIONS(1967),
    [sym_this] = ACTIONS(1967),
    [anon_sym_discard] = ACTIONS(1967),
    [anon_sym_precise] = ACTIONS(1967),
    [anon_sym_shared] = ACTIONS(1967),
    [anon_sym_groupshared] = ACTIONS(1967),
    [anon_sym_uniform] = ACTIONS(1967),
    [anon_sym_row_major] = ACTIONS(1967),
    [anon_sym_column_major] = ACTIONS(1967),
    [anon_sym_globallycoherent] = ACTIONS(1967),
    [anon_sym_centroid] = ACTIONS(1967),
    [anon_sym_noperspective] = ACTIONS(1967),
    [anon_sym_nointerpolation] = ACTIONS(1967),
    [anon_sym_sample] = ACTIONS(1967),
    [anon_sym_linear] = ACTIONS(1967),
    [anon_sym_snorm] = ACTIONS(1967),
    [anon_sym_unorm] = ACTIONS(1967),
    [anon_sym_point] = ACTIONS(1967),
    [anon_sym_line] = ACTIONS(1967),
    [anon_sym_triangleadj] = ACTIONS(1967),
    [anon_sym_lineadj] = ACTIONS(1967),
    [anon_sym_triangle] = ACTIONS(1967),
    [anon_sym_cbuffer] = ACTIONS(1967),
  },
  [143] = {
    [sym_identifier] = ACTIONS(1971),
    [aux_sym_preproc_include_token1] = ACTIONS(1971),
    [aux_sym_preproc_def_token1] = ACTIONS(1971),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [aux_sym_preproc_if_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1971),
    [sym_preproc_directive] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_typedef] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_using] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1973),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_goto] = ACTIONS(1971),
    [anon_sym___try] = ACTIONS(1971),
    [anon_sym___leave] = ACTIONS(1971),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_sizeof] = ACTIONS(1971),
    [anon_sym___alignof__] = ACTIONS(1971),
    [anon_sym___alignof] = ACTIONS(1971),
    [anon_sym__alignof] = ACTIONS(1971),
    [anon_sym_alignof] = ACTIONS(1971),
    [anon_sym__Alignof] = ACTIONS(1971),
    [anon_sym_offsetof] = ACTIONS(1971),
    [anon_sym__Generic] = ACTIONS(1971),
    [anon_sym_asm] = ACTIONS(1971),
    [anon_sym___asm__] = ACTIONS(1971),
    [anon_sym___asm] = ACTIONS(1971),
    [sym_number_literal] = ACTIONS(1973),
    [anon_sym_L_SQUOTE] = ACTIONS(1973),
    [anon_sym_u_SQUOTE] = ACTIONS(1973),
    [anon_sym_U_SQUOTE] = ACTIONS(1973),
    [anon_sym_u8_SQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [anon_sym_L_DQUOTE] = ACTIONS(1973),
    [anon_sym_u_DQUOTE] = ACTIONS(1973),
    [anon_sym_U_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8_DQUOTE] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [anon_sym_NULL] = ACTIONS(1971),
    [anon_sym_nullptr] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_explicit] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_GT2] = ACTIONS(1973),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_static_assert] = ACTIONS(1971),
    [anon_sym_concept] = ACTIONS(1971),
    [anon_sym_co_return] = ACTIONS(1971),
    [anon_sym_co_yield] = ACTIONS(1971),
    [anon_sym_R_DQUOTE] = ACTIONS(1973),
    [anon_sym_LR_DQUOTE] = ACTIONS(1973),
    [anon_sym_uR_DQUOTE] = ACTIONS(1973),
    [anon_sym_UR_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1973),
    [anon_sym_co_await] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [sym_this] = ACTIONS(1971),
    [anon_sym_discard] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
    [anon_sym_cbuffer] = ACTIONS(1971),
  },
  [144] = {
    [sym_identifier] = ACTIONS(1975),
    [aux_sym_preproc_include_token1] = ACTIONS(1975),
    [aux_sym_preproc_def_token1] = ACTIONS(1975),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [aux_sym_preproc_if_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1975),
    [sym_preproc_directive] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_typedef] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_using] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1977),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1975),
    [anon_sym___try] = ACTIONS(1975),
    [anon_sym___leave] = ACTIONS(1975),
    [anon_sym_not] = ACTIONS(1975),
    [anon_sym_compl] = ACTIONS(1975),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_sizeof] = ACTIONS(1975),
    [anon_sym___alignof__] = ACTIONS(1975),
    [anon_sym___alignof] = ACTIONS(1975),
    [anon_sym__alignof] = ACTIONS(1975),
    [anon_sym_alignof] = ACTIONS(1975),
    [anon_sym__Alignof] = ACTIONS(1975),
    [anon_sym_offsetof] = ACTIONS(1975),
    [anon_sym__Generic] = ACTIONS(1975),
    [anon_sym_asm] = ACTIONS(1975),
    [anon_sym___asm__] = ACTIONS(1975),
    [anon_sym___asm] = ACTIONS(1975),
    [sym_number_literal] = ACTIONS(1977),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1977),
    [anon_sym_u_DQUOTE] = ACTIONS(1977),
    [anon_sym_U_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [anon_sym_NULL] = ACTIONS(1975),
    [anon_sym_nullptr] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_explicit] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_GT2] = ACTIONS(1977),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_static_assert] = ACTIONS(1975),
    [anon_sym_concept] = ACTIONS(1975),
    [anon_sym_co_return] = ACTIONS(1975),
    [anon_sym_co_yield] = ACTIONS(1975),
    [anon_sym_R_DQUOTE] = ACTIONS(1977),
    [anon_sym_LR_DQUOTE] = ACTIONS(1977),
    [anon_sym_uR_DQUOTE] = ACTIONS(1977),
    [anon_sym_UR_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1977),
    [anon_sym_co_await] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [sym_this] = ACTIONS(1975),
    [anon_sym_discard] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
    [anon_sym_cbuffer] = ACTIONS(1975),
  },
  [145] = {
    [sym_identifier] = ACTIONS(1979),
    [aux_sym_preproc_include_token1] = ACTIONS(1979),
    [aux_sym_preproc_def_token1] = ACTIONS(1979),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [aux_sym_preproc_if_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1979),
    [sym_preproc_directive] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_typedef] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym___try] = ACTIONS(1979),
    [anon_sym___leave] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1979),
    [anon_sym_compl] = ACTIONS(1979),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym___alignof__] = ACTIONS(1979),
    [anon_sym___alignof] = ACTIONS(1979),
    [anon_sym__alignof] = ACTIONS(1979),
    [anon_sym_alignof] = ACTIONS(1979),
    [anon_sym__Alignof] = ACTIONS(1979),
    [anon_sym_offsetof] = ACTIONS(1979),
    [anon_sym__Generic] = ACTIONS(1979),
    [anon_sym_asm] = ACTIONS(1979),
    [anon_sym___asm__] = ACTIONS(1979),
    [anon_sym___asm] = ACTIONS(1979),
    [sym_number_literal] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1981),
    [anon_sym_u_SQUOTE] = ACTIONS(1981),
    [anon_sym_U_SQUOTE] = ACTIONS(1981),
    [anon_sym_u8_SQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [anon_sym_L_DQUOTE] = ACTIONS(1981),
    [anon_sym_u_DQUOTE] = ACTIONS(1981),
    [anon_sym_U_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [anon_sym_NULL] = ACTIONS(1979),
    [anon_sym_nullptr] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_GT2] = ACTIONS(1981),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_static_assert] = ACTIONS(1979),
    [anon_sym_concept] = ACTIONS(1979),
    [anon_sym_co_return] = ACTIONS(1979),
    [anon_sym_co_yield] = ACTIONS(1979),
    [anon_sym_R_DQUOTE] = ACTIONS(1981),
    [anon_sym_LR_DQUOTE] = ACTIONS(1981),
    [anon_sym_uR_DQUOTE] = ACTIONS(1981),
    [anon_sym_UR_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1981),
    [anon_sym_co_await] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [sym_this] = ACTIONS(1979),
    [anon_sym_discard] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
    [anon_sym_cbuffer] = ACTIONS(1979),
  },
  [146] = {
    [sym_identifier] = ACTIONS(1983),
    [aux_sym_preproc_include_token1] = ACTIONS(1983),
    [aux_sym_preproc_def_token1] = ACTIONS(1983),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [aux_sym_preproc_if_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1983),
    [sym_preproc_directive] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_using] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_goto] = ACTIONS(1983),
    [anon_sym___try] = ACTIONS(1983),
    [anon_sym___leave] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1983),
    [anon_sym_compl] = ACTIONS(1983),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_sizeof] = ACTIONS(1983),
    [anon_sym___alignof__] = ACTIONS(1983),
    [anon_sym___alignof] = ACTIONS(1983),
    [anon_sym__alignof] = ACTIONS(1983),
    [anon_sym_alignof] = ACTIONS(1983),
    [anon_sym__Alignof] = ACTIONS(1983),
    [anon_sym_offsetof] = ACTIONS(1983),
    [anon_sym__Generic] = ACTIONS(1983),
    [anon_sym_asm] = ACTIONS(1983),
    [anon_sym___asm__] = ACTIONS(1983),
    [anon_sym___asm] = ACTIONS(1983),
    [sym_number_literal] = ACTIONS(1985),
    [anon_sym_L_SQUOTE] = ACTIONS(1985),
    [anon_sym_u_SQUOTE] = ACTIONS(1985),
    [anon_sym_U_SQUOTE] = ACTIONS(1985),
    [anon_sym_u8_SQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [anon_sym_NULL] = ACTIONS(1983),
    [anon_sym_nullptr] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_GT2] = ACTIONS(1985),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_static_assert] = ACTIONS(1983),
    [anon_sym_concept] = ACTIONS(1983),
    [anon_sym_co_return] = ACTIONS(1983),
    [anon_sym_co_yield] = ACTIONS(1983),
    [anon_sym_R_DQUOTE] = ACTIONS(1985),
    [anon_sym_LR_DQUOTE] = ACTIONS(1985),
    [anon_sym_uR_DQUOTE] = ACTIONS(1985),
    [anon_sym_UR_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1985),
    [anon_sym_co_await] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [sym_this] = ACTIONS(1983),
    [anon_sym_discard] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
    [anon_sym_cbuffer] = ACTIONS(1983),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1987),
    [aux_sym_preproc_include_token1] = ACTIONS(1987),
    [aux_sym_preproc_def_token1] = ACTIONS(1987),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [aux_sym_preproc_if_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1987),
    [sym_preproc_directive] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_typedef] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_using] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1989),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_goto] = ACTIONS(1987),
    [anon_sym___try] = ACTIONS(1987),
    [anon_sym___leave] = ACTIONS(1987),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_compl] = ACTIONS(1987),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_sizeof] = ACTIONS(1987),
    [anon_sym___alignof__] = ACTIONS(1987),
    [anon_sym___alignof] = ACTIONS(1987),
    [anon_sym__alignof] = ACTIONS(1987),
    [anon_sym_alignof] = ACTIONS(1987),
    [anon_sym__Alignof] = ACTIONS(1987),
    [anon_sym_offsetof] = ACTIONS(1987),
    [anon_sym__Generic] = ACTIONS(1987),
    [anon_sym_asm] = ACTIONS(1987),
    [anon_sym___asm__] = ACTIONS(1987),
    [anon_sym___asm] = ACTIONS(1987),
    [sym_number_literal] = ACTIONS(1989),
    [anon_sym_L_SQUOTE] = ACTIONS(1989),
    [anon_sym_u_SQUOTE] = ACTIONS(1989),
    [anon_sym_U_SQUOTE] = ACTIONS(1989),
    [anon_sym_u8_SQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [anon_sym_L_DQUOTE] = ACTIONS(1989),
    [anon_sym_u_DQUOTE] = ACTIONS(1989),
    [anon_sym_U_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8_DQUOTE] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [anon_sym_NULL] = ACTIONS(1987),
    [anon_sym_nullptr] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_GT2] = ACTIONS(1989),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_static_assert] = ACTIONS(1987),
    [anon_sym_concept] = ACTIONS(1987),
    [anon_sym_co_return] = ACTIONS(1987),
    [anon_sym_co_yield] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [sym_this] = ACTIONS(1987),
    [anon_sym_discard] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
    [anon_sym_cbuffer] = ACTIONS(1987),
  },
  [148] = {
    [sym_identifier] = ACTIONS(1991),
    [aux_sym_preproc_include_token1] = ACTIONS(1991),
    [aux_sym_preproc_def_token1] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [aux_sym_preproc_if_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1991),
    [sym_preproc_directive] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_typedef] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_using] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_goto] = ACTIONS(1991),
    [anon_sym___try] = ACTIONS(1991),
    [anon_sym___leave] = ACTIONS(1991),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_sizeof] = ACTIONS(1991),
    [anon_sym___alignof__] = ACTIONS(1991),
    [anon_sym___alignof] = ACTIONS(1991),
    [anon_sym__alignof] = ACTIONS(1991),
    [anon_sym_alignof] = ACTIONS(1991),
    [anon_sym__Alignof] = ACTIONS(1991),
    [anon_sym_offsetof] = ACTIONS(1991),
    [anon_sym__Generic] = ACTIONS(1991),
    [anon_sym_asm] = ACTIONS(1991),
    [anon_sym___asm__] = ACTIONS(1991),
    [anon_sym___asm] = ACTIONS(1991),
    [sym_number_literal] = ACTIONS(1993),
    [anon_sym_L_SQUOTE] = ACTIONS(1993),
    [anon_sym_u_SQUOTE] = ACTIONS(1993),
    [anon_sym_U_SQUOTE] = ACTIONS(1993),
    [anon_sym_u8_SQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_L_DQUOTE] = ACTIONS(1993),
    [anon_sym_u_DQUOTE] = ACTIONS(1993),
    [anon_sym_U_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [anon_sym_NULL] = ACTIONS(1991),
    [anon_sym_nullptr] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_explicit] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_GT2] = ACTIONS(1993),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_static_assert] = ACTIONS(1991),
    [anon_sym_concept] = ACTIONS(1991),
    [anon_sym_co_return] = ACTIONS(1991),
    [anon_sym_co_yield] = ACTIONS(1991),
    [anon_sym_R_DQUOTE] = ACTIONS(1993),
    [anon_sym_LR_DQUOTE] = ACTIONS(1993),
    [anon_sym_uR_DQUOTE] = ACTIONS(1993),
    [anon_sym_UR_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1993),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [sym_this] = ACTIONS(1991),
    [anon_sym_discard] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
    [anon_sym_cbuffer] = ACTIONS(1991),
  },
  [149] = {
    [sym_field_declaration_list] = STATE(324),
    [sym_virtual_specifier] = STATE(7215),
    [sym_base_class_clause] = STATE(8129),
    [ts_builtin_sym_end] = ACTIONS(1959),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_inout] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym___attribute] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym__Nonnull] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym__Alignas] = ACTIONS(1957),
    [sym_primitive_type] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [anon_sym___asm] = ACTIONS(1957),
    [sym_number_literal] = ACTIONS(1959),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_export] = ACTIONS(1957),
    [anon_sym_module] = ACTIONS(1957),
    [anon_sym_import] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
    [anon_sym_discard] = ACTIONS(1957),
    [anon_sym_precise] = ACTIONS(1957),
    [anon_sym_shared] = ACTIONS(1957),
    [anon_sym_groupshared] = ACTIONS(1957),
    [anon_sym_uniform] = ACTIONS(1957),
    [anon_sym_row_major] = ACTIONS(1957),
    [anon_sym_column_major] = ACTIONS(1957),
    [anon_sym_globallycoherent] = ACTIONS(1957),
    [anon_sym_centroid] = ACTIONS(1957),
    [anon_sym_noperspective] = ACTIONS(1957),
    [anon_sym_nointerpolation] = ACTIONS(1957),
    [anon_sym_sample] = ACTIONS(1957),
    [anon_sym_linear] = ACTIONS(1957),
    [anon_sym_snorm] = ACTIONS(1957),
    [anon_sym_unorm] = ACTIONS(1957),
    [anon_sym_point] = ACTIONS(1957),
    [anon_sym_line] = ACTIONS(1957),
    [anon_sym_triangleadj] = ACTIONS(1957),
    [anon_sym_lineadj] = ACTIONS(1957),
    [anon_sym_triangle] = ACTIONS(1957),
    [anon_sym_cbuffer] = ACTIONS(1957),
  },
  [150] = {
    [sym_field_declaration_list] = STATE(329),
    [sym_virtual_specifier] = STATE(7231),
    [sym_base_class_clause] = STATE(8182),
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1967),
    [aux_sym_preproc_include_token1] = ACTIONS(1967),
    [aux_sym_preproc_def_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1967),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_typedef] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1967),
    [anon_sym_inout] = ACTIONS(1967),
    [anon_sym_virtual] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym___attribute] = ACTIONS(1967),
    [anon_sym_using] = ACTIONS(1967),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1969),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(1995),
    [anon_sym_signed] = ACTIONS(1967),
    [anon_sym_unsigned] = ACTIONS(1967),
    [anon_sym_long] = ACTIONS(1967),
    [anon_sym_short] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym__Nonnull] = ACTIONS(1967),
    [anon_sym_mutable] = ACTIONS(1967),
    [anon_sym_constinit] = ACTIONS(1967),
    [anon_sym_consteval] = ACTIONS(1967),
    [anon_sym_alignas] = ACTIONS(1967),
    [anon_sym__Alignas] = ACTIONS(1967),
    [sym_primitive_type] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1967),
    [anon_sym___try] = ACTIONS(1967),
    [anon_sym___leave] = ACTIONS(1967),
    [anon_sym_not] = ACTIONS(1967),
    [anon_sym_compl] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(1967),
    [anon_sym___alignof__] = ACTIONS(1967),
    [anon_sym___alignof] = ACTIONS(1967),
    [anon_sym__alignof] = ACTIONS(1967),
    [anon_sym_alignof] = ACTIONS(1967),
    [anon_sym__Alignof] = ACTIONS(1967),
    [anon_sym_offsetof] = ACTIONS(1967),
    [anon_sym__Generic] = ACTIONS(1967),
    [anon_sym_asm] = ACTIONS(1967),
    [anon_sym___asm__] = ACTIONS(1967),
    [anon_sym___asm] = ACTIONS(1967),
    [sym_number_literal] = ACTIONS(1969),
    [anon_sym_L_SQUOTE] = ACTIONS(1969),
    [anon_sym_u_SQUOTE] = ACTIONS(1969),
    [anon_sym_U_SQUOTE] = ACTIONS(1969),
    [anon_sym_u8_SQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(1969),
    [anon_sym_u_DQUOTE] = ACTIONS(1969),
    [anon_sym_U_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8_DQUOTE] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [anon_sym_NULL] = ACTIONS(1967),
    [anon_sym_nullptr] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1967),
    [anon_sym_decltype] = ACTIONS(1967),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1967),
    [anon_sym_typename] = ACTIONS(1967),
    [anon_sym_export] = ACTIONS(1967),
    [anon_sym_module] = ACTIONS(1967),
    [anon_sym_import] = ACTIONS(1967),
    [anon_sym_template] = ACTIONS(1967),
    [anon_sym_operator] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_static_assert] = ACTIONS(1967),
    [anon_sym_concept] = ACTIONS(1967),
    [anon_sym_co_return] = ACTIONS(1967),
    [anon_sym_co_yield] = ACTIONS(1967),
    [anon_sym_R_DQUOTE] = ACTIONS(1969),
    [anon_sym_LR_DQUOTE] = ACTIONS(1969),
    [anon_sym_uR_DQUOTE] = ACTIONS(1969),
    [anon_sym_UR_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1969),
    [anon_sym_co_await] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_requires] = ACTIONS(1967),
    [sym_this] = ACTIONS(1967),
    [anon_sym_discard] = ACTIONS(1967),
    [anon_sym_precise] = ACTIONS(1967),
    [anon_sym_shared] = ACTIONS(1967),
    [anon_sym_groupshared] = ACTIONS(1967),
    [anon_sym_uniform] = ACTIONS(1967),
    [anon_sym_row_major] = ACTIONS(1967),
    [anon_sym_column_major] = ACTIONS(1967),
    [anon_sym_globallycoherent] = ACTIONS(1967),
    [anon_sym_centroid] = ACTIONS(1967),
    [anon_sym_noperspective] = ACTIONS(1967),
    [anon_sym_nointerpolation] = ACTIONS(1967),
    [anon_sym_sample] = ACTIONS(1967),
    [anon_sym_linear] = ACTIONS(1967),
    [anon_sym_snorm] = ACTIONS(1967),
    [anon_sym_unorm] = ACTIONS(1967),
    [anon_sym_point] = ACTIONS(1967),
    [anon_sym_line] = ACTIONS(1967),
    [anon_sym_triangleadj] = ACTIONS(1967),
    [anon_sym_lineadj] = ACTIONS(1967),
    [anon_sym_triangle] = ACTIONS(1967),
    [anon_sym_cbuffer] = ACTIONS(1967),
  },
  [151] = {
    [sym_template_argument_list] = STATE(169),
    [sym_identifier] = ACTIONS(1997),
    [aux_sym_preproc_include_token1] = ACTIONS(1997),
    [aux_sym_preproc_def_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token2] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1997),
    [aux_sym_preproc_else_token1] = ACTIONS(1997),
    [aux_sym_preproc_elif_token1] = ACTIONS(1997),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1997),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1997),
    [sym_preproc_directive] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_using] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1997),
    [anon_sym_compl] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [anon_sym___asm] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1999),
    [anon_sym_L_SQUOTE] = ACTIONS(1999),
    [anon_sym_u_SQUOTE] = ACTIONS(1999),
    [anon_sym_U_SQUOTE] = ACTIONS(1999),
    [anon_sym_u8_SQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_L_DQUOTE] = ACTIONS(1999),
    [anon_sym_u_DQUOTE] = ACTIONS(1999),
    [anon_sym_U_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8_DQUOTE] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_explicit] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_static_assert] = ACTIONS(1997),
    [anon_sym_concept] = ACTIONS(1997),
    [anon_sym_co_return] = ACTIONS(1997),
    [anon_sym_co_yield] = ACTIONS(1997),
    [anon_sym_R_DQUOTE] = ACTIONS(1999),
    [anon_sym_LR_DQUOTE] = ACTIONS(1999),
    [anon_sym_uR_DQUOTE] = ACTIONS(1999),
    [anon_sym_UR_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1999),
    [anon_sym_co_await] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [sym_this] = ACTIONS(1997),
    [anon_sym_discard] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
    [anon_sym_cbuffer] = ACTIONS(1997),
  },
  [152] = {
    [sym_template_argument_list] = STATE(169),
    [sym_identifier] = ACTIONS(2005),
    [aux_sym_preproc_include_token1] = ACTIONS(2005),
    [aux_sym_preproc_def_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token2] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2005),
    [aux_sym_preproc_else_token1] = ACTIONS(2005),
    [aux_sym_preproc_elif_token1] = ACTIONS(2005),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2005),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2005),
    [sym_preproc_directive] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_typedef] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_using] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_goto] = ACTIONS(2005),
    [anon_sym___try] = ACTIONS(2005),
    [anon_sym___leave] = ACTIONS(2005),
    [anon_sym_not] = ACTIONS(2005),
    [anon_sym_compl] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_sizeof] = ACTIONS(2005),
    [anon_sym___alignof__] = ACTIONS(2005),
    [anon_sym___alignof] = ACTIONS(2005),
    [anon_sym__alignof] = ACTIONS(2005),
    [anon_sym_alignof] = ACTIONS(2005),
    [anon_sym__Alignof] = ACTIONS(2005),
    [anon_sym_offsetof] = ACTIONS(2005),
    [anon_sym__Generic] = ACTIONS(2005),
    [anon_sym_asm] = ACTIONS(2005),
    [anon_sym___asm__] = ACTIONS(2005),
    [anon_sym___asm] = ACTIONS(2005),
    [sym_number_literal] = ACTIONS(2007),
    [anon_sym_L_SQUOTE] = ACTIONS(2007),
    [anon_sym_u_SQUOTE] = ACTIONS(2007),
    [anon_sym_U_SQUOTE] = ACTIONS(2007),
    [anon_sym_u8_SQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_L_DQUOTE] = ACTIONS(2007),
    [anon_sym_u_DQUOTE] = ACTIONS(2007),
    [anon_sym_U_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8_DQUOTE] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [anon_sym_NULL] = ACTIONS(2005),
    [anon_sym_nullptr] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_explicit] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_static_assert] = ACTIONS(2005),
    [anon_sym_concept] = ACTIONS(2005),
    [anon_sym_co_return] = ACTIONS(2005),
    [anon_sym_co_yield] = ACTIONS(2005),
    [anon_sym_R_DQUOTE] = ACTIONS(2007),
    [anon_sym_LR_DQUOTE] = ACTIONS(2007),
    [anon_sym_uR_DQUOTE] = ACTIONS(2007),
    [anon_sym_UR_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2007),
    [anon_sym_co_await] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [sym_this] = ACTIONS(2005),
    [anon_sym_discard] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
    [anon_sym_cbuffer] = ACTIONS(2005),
  },
  [153] = {
    [sym_template_argument_list] = STATE(182),
    [ts_builtin_sym_end] = ACTIONS(2007),
    [sym_identifier] = ACTIONS(2005),
    [aux_sym_preproc_include_token1] = ACTIONS(2005),
    [aux_sym_preproc_def_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2005),
    [sym_preproc_directive] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_typedef] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_using] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_goto] = ACTIONS(2005),
    [anon_sym___try] = ACTIONS(2005),
    [anon_sym___leave] = ACTIONS(2005),
    [anon_sym_not] = ACTIONS(2005),
    [anon_sym_compl] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_sizeof] = ACTIONS(2005),
    [anon_sym___alignof__] = ACTIONS(2005),
    [anon_sym___alignof] = ACTIONS(2005),
    [anon_sym__alignof] = ACTIONS(2005),
    [anon_sym_alignof] = ACTIONS(2005),
    [anon_sym__Alignof] = ACTIONS(2005),
    [anon_sym_offsetof] = ACTIONS(2005),
    [anon_sym__Generic] = ACTIONS(2005),
    [anon_sym_asm] = ACTIONS(2005),
    [anon_sym___asm__] = ACTIONS(2005),
    [anon_sym___asm] = ACTIONS(2005),
    [sym_number_literal] = ACTIONS(2007),
    [anon_sym_L_SQUOTE] = ACTIONS(2007),
    [anon_sym_u_SQUOTE] = ACTIONS(2007),
    [anon_sym_U_SQUOTE] = ACTIONS(2007),
    [anon_sym_u8_SQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_L_DQUOTE] = ACTIONS(2007),
    [anon_sym_u_DQUOTE] = ACTIONS(2007),
    [anon_sym_U_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8_DQUOTE] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [anon_sym_NULL] = ACTIONS(2005),
    [anon_sym_nullptr] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_explicit] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_export] = ACTIONS(2005),
    [anon_sym_module] = ACTIONS(2005),
    [anon_sym_import] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_static_assert] = ACTIONS(2005),
    [anon_sym_concept] = ACTIONS(2005),
    [anon_sym_co_return] = ACTIONS(2005),
    [anon_sym_co_yield] = ACTIONS(2005),
    [anon_sym_R_DQUOTE] = ACTIONS(2007),
    [anon_sym_LR_DQUOTE] = ACTIONS(2007),
    [anon_sym_uR_DQUOTE] = ACTIONS(2007),
    [anon_sym_UR_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2007),
    [anon_sym_co_await] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [sym_this] = ACTIONS(2005),
    [anon_sym_discard] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
    [anon_sym_cbuffer] = ACTIONS(2005),
  },
  [154] = {
    [sym_template_argument_list] = STATE(182),
    [ts_builtin_sym_end] = ACTIONS(1999),
    [sym_identifier] = ACTIONS(1997),
    [aux_sym_preproc_include_token1] = ACTIONS(1997),
    [aux_sym_preproc_def_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1997),
    [sym_preproc_directive] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_using] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1997),
    [anon_sym_compl] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [anon_sym___asm] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1999),
    [anon_sym_L_SQUOTE] = ACTIONS(1999),
    [anon_sym_u_SQUOTE] = ACTIONS(1999),
    [anon_sym_U_SQUOTE] = ACTIONS(1999),
    [anon_sym_u8_SQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_L_DQUOTE] = ACTIONS(1999),
    [anon_sym_u_DQUOTE] = ACTIONS(1999),
    [anon_sym_U_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8_DQUOTE] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_explicit] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_export] = ACTIONS(1997),
    [anon_sym_module] = ACTIONS(1997),
    [anon_sym_import] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_static_assert] = ACTIONS(1997),
    [anon_sym_concept] = ACTIONS(1997),
    [anon_sym_co_return] = ACTIONS(1997),
    [anon_sym_co_yield] = ACTIONS(1997),
    [anon_sym_R_DQUOTE] = ACTIONS(1999),
    [anon_sym_LR_DQUOTE] = ACTIONS(1999),
    [anon_sym_uR_DQUOTE] = ACTIONS(1999),
    [anon_sym_UR_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1999),
    [anon_sym_co_await] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [sym_this] = ACTIONS(1997),
    [anon_sym_discard] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
    [anon_sym_cbuffer] = ACTIONS(1997),
  },
  [155] = {
    [sym_identifier] = ACTIONS(2011),
    [aux_sym_preproc_include_token1] = ACTIONS(2011),
    [aux_sym_preproc_def_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token2] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2011),
    [aux_sym_preproc_else_token1] = ACTIONS(2011),
    [aux_sym_preproc_elif_token1] = ACTIONS(2011),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2011),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2011),
    [sym_preproc_directive] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_using] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_goto] = ACTIONS(2011),
    [anon_sym___try] = ACTIONS(2011),
    [anon_sym___leave] = ACTIONS(2011),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_compl] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2011),
    [anon_sym___alignof__] = ACTIONS(2011),
    [anon_sym___alignof] = ACTIONS(2011),
    [anon_sym__alignof] = ACTIONS(2011),
    [anon_sym_alignof] = ACTIONS(2011),
    [anon_sym__Alignof] = ACTIONS(2011),
    [anon_sym_offsetof] = ACTIONS(2011),
    [anon_sym__Generic] = ACTIONS(2011),
    [anon_sym_asm] = ACTIONS(2011),
    [anon_sym___asm__] = ACTIONS(2011),
    [anon_sym___asm] = ACTIONS(2011),
    [sym_number_literal] = ACTIONS(2013),
    [anon_sym_L_SQUOTE] = ACTIONS(2013),
    [anon_sym_u_SQUOTE] = ACTIONS(2013),
    [anon_sym_U_SQUOTE] = ACTIONS(2013),
    [anon_sym_u8_SQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [anon_sym_L_DQUOTE] = ACTIONS(2013),
    [anon_sym_u_DQUOTE] = ACTIONS(2013),
    [anon_sym_U_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8_DQUOTE] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [anon_sym_NULL] = ACTIONS(2011),
    [anon_sym_nullptr] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_explicit] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_static_assert] = ACTIONS(2011),
    [anon_sym_concept] = ACTIONS(2011),
    [anon_sym_co_return] = ACTIONS(2011),
    [anon_sym_co_yield] = ACTIONS(2011),
    [anon_sym_R_DQUOTE] = ACTIONS(2013),
    [anon_sym_LR_DQUOTE] = ACTIONS(2013),
    [anon_sym_uR_DQUOTE] = ACTIONS(2013),
    [anon_sym_UR_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2013),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [sym_this] = ACTIONS(2011),
    [anon_sym_discard] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
    [anon_sym_cbuffer] = ACTIONS(2011),
  },
  [156] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [aux_sym_preproc_else_token1] = ACTIONS(2017),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [157] = {
    [sym_catch_clause] = STATE(168),
    [aux_sym_constructor_try_statement_repeat1] = STATE(168),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_include_token1] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token2] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [aux_sym_preproc_else_token1] = ACTIONS(2021),
    [aux_sym_preproc_elif_token1] = ACTIONS(2021),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym___cdecl] = ACTIONS(2021),
    [anon_sym___clrcall] = ACTIONS(2021),
    [anon_sym___stdcall] = ACTIONS(2021),
    [anon_sym___fastcall] = ACTIONS(2021),
    [anon_sym___thiscall] = ACTIONS(2021),
    [anon_sym___vectorcall] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_goto] = ACTIONS(2021),
    [anon_sym___try] = ACTIONS(2021),
    [anon_sym___leave] = ACTIONS(2021),
    [anon_sym_not] = ACTIONS(2021),
    [anon_sym_compl] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2021),
    [anon_sym___alignof__] = ACTIONS(2021),
    [anon_sym___alignof] = ACTIONS(2021),
    [anon_sym__alignof] = ACTIONS(2021),
    [anon_sym_alignof] = ACTIONS(2021),
    [anon_sym__Alignof] = ACTIONS(2021),
    [anon_sym_offsetof] = ACTIONS(2021),
    [anon_sym__Generic] = ACTIONS(2021),
    [anon_sym_asm] = ACTIONS(2021),
    [anon_sym___asm__] = ACTIONS(2021),
    [anon_sym___asm] = ACTIONS(2021),
    [sym_number_literal] = ACTIONS(2023),
    [anon_sym_L_SQUOTE] = ACTIONS(2023),
    [anon_sym_u_SQUOTE] = ACTIONS(2023),
    [anon_sym_U_SQUOTE] = ACTIONS(2023),
    [anon_sym_u8_SQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_L_DQUOTE] = ACTIONS(2023),
    [anon_sym_u_DQUOTE] = ACTIONS(2023),
    [anon_sym_U_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8_DQUOTE] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [anon_sym_NULL] = ACTIONS(2021),
    [anon_sym_nullptr] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_concept] = ACTIONS(2021),
    [anon_sym_co_return] = ACTIONS(2021),
    [anon_sym_co_yield] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(2025),
    [anon_sym_R_DQUOTE] = ACTIONS(2023),
    [anon_sym_LR_DQUOTE] = ACTIONS(2023),
    [anon_sym_uR_DQUOTE] = ACTIONS(2023),
    [anon_sym_UR_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2023),
    [anon_sym_co_await] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_requires] = ACTIONS(2021),
    [sym_this] = ACTIONS(2021),
    [anon_sym_discard] = ACTIONS(2021),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
    [anon_sym_cbuffer] = ACTIONS(2021),
  },
  [158] = {
    [sym_identifier] = ACTIONS(1971),
    [aux_sym_preproc_include_token1] = ACTIONS(1971),
    [aux_sym_preproc_def_token1] = ACTIONS(1971),
    [aux_sym_preproc_if_token1] = ACTIONS(1971),
    [aux_sym_preproc_if_token2] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1971),
    [aux_sym_preproc_else_token1] = ACTIONS(1971),
    [aux_sym_preproc_elif_token1] = ACTIONS(1971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1971),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1971),
    [sym_preproc_directive] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_typedef] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_using] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_goto] = ACTIONS(1971),
    [anon_sym___try] = ACTIONS(1971),
    [anon_sym___leave] = ACTIONS(1971),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_sizeof] = ACTIONS(1971),
    [anon_sym___alignof__] = ACTIONS(1971),
    [anon_sym___alignof] = ACTIONS(1971),
    [anon_sym__alignof] = ACTIONS(1971),
    [anon_sym_alignof] = ACTIONS(1971),
    [anon_sym__Alignof] = ACTIONS(1971),
    [anon_sym_offsetof] = ACTIONS(1971),
    [anon_sym__Generic] = ACTIONS(1971),
    [anon_sym_asm] = ACTIONS(1971),
    [anon_sym___asm__] = ACTIONS(1971),
    [anon_sym___asm] = ACTIONS(1971),
    [sym_number_literal] = ACTIONS(1973),
    [anon_sym_L_SQUOTE] = ACTIONS(1973),
    [anon_sym_u_SQUOTE] = ACTIONS(1973),
    [anon_sym_U_SQUOTE] = ACTIONS(1973),
    [anon_sym_u8_SQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [anon_sym_L_DQUOTE] = ACTIONS(1973),
    [anon_sym_u_DQUOTE] = ACTIONS(1973),
    [anon_sym_U_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8_DQUOTE] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [anon_sym_NULL] = ACTIONS(1971),
    [anon_sym_nullptr] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_explicit] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_static_assert] = ACTIONS(1971),
    [anon_sym_concept] = ACTIONS(1971),
    [anon_sym_co_return] = ACTIONS(1971),
    [anon_sym_co_yield] = ACTIONS(1971),
    [anon_sym_R_DQUOTE] = ACTIONS(1973),
    [anon_sym_LR_DQUOTE] = ACTIONS(1973),
    [anon_sym_uR_DQUOTE] = ACTIONS(1973),
    [anon_sym_UR_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1973),
    [anon_sym_co_await] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [sym_this] = ACTIONS(1971),
    [anon_sym_discard] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
    [anon_sym_cbuffer] = ACTIONS(1971),
  },
  [159] = {
    [sym_identifier] = ACTIONS(1975),
    [aux_sym_preproc_include_token1] = ACTIONS(1975),
    [aux_sym_preproc_def_token1] = ACTIONS(1975),
    [aux_sym_preproc_if_token1] = ACTIONS(1975),
    [aux_sym_preproc_if_token2] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1975),
    [aux_sym_preproc_else_token1] = ACTIONS(1975),
    [aux_sym_preproc_elif_token1] = ACTIONS(1975),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1975),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1975),
    [sym_preproc_directive] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_typedef] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_using] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1975),
    [anon_sym___try] = ACTIONS(1975),
    [anon_sym___leave] = ACTIONS(1975),
    [anon_sym_not] = ACTIONS(1975),
    [anon_sym_compl] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_sizeof] = ACTIONS(1975),
    [anon_sym___alignof__] = ACTIONS(1975),
    [anon_sym___alignof] = ACTIONS(1975),
    [anon_sym__alignof] = ACTIONS(1975),
    [anon_sym_alignof] = ACTIONS(1975),
    [anon_sym__Alignof] = ACTIONS(1975),
    [anon_sym_offsetof] = ACTIONS(1975),
    [anon_sym__Generic] = ACTIONS(1975),
    [anon_sym_asm] = ACTIONS(1975),
    [anon_sym___asm__] = ACTIONS(1975),
    [anon_sym___asm] = ACTIONS(1975),
    [sym_number_literal] = ACTIONS(1977),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1977),
    [anon_sym_u_DQUOTE] = ACTIONS(1977),
    [anon_sym_U_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [anon_sym_NULL] = ACTIONS(1975),
    [anon_sym_nullptr] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_explicit] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_static_assert] = ACTIONS(1975),
    [anon_sym_concept] = ACTIONS(1975),
    [anon_sym_co_return] = ACTIONS(1975),
    [anon_sym_co_yield] = ACTIONS(1975),
    [anon_sym_R_DQUOTE] = ACTIONS(1977),
    [anon_sym_LR_DQUOTE] = ACTIONS(1977),
    [anon_sym_uR_DQUOTE] = ACTIONS(1977),
    [anon_sym_UR_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1977),
    [anon_sym_co_await] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [sym_this] = ACTIONS(1975),
    [anon_sym_discard] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
    [anon_sym_cbuffer] = ACTIONS(1975),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1953),
    [aux_sym_preproc_include_token1] = ACTIONS(1953),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token2] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1953),
    [aux_sym_preproc_else_token1] = ACTIONS(1953),
    [aux_sym_preproc_elif_token1] = ACTIONS(1953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1953),
    [sym_preproc_directive] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_typedef] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_using] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_goto] = ACTIONS(1953),
    [anon_sym___try] = ACTIONS(1953),
    [anon_sym___leave] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1953),
    [anon_sym_compl] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1953),
    [anon_sym___alignof__] = ACTIONS(1953),
    [anon_sym___alignof] = ACTIONS(1953),
    [anon_sym__alignof] = ACTIONS(1953),
    [anon_sym_alignof] = ACTIONS(1953),
    [anon_sym__Alignof] = ACTIONS(1953),
    [anon_sym_offsetof] = ACTIONS(1953),
    [anon_sym__Generic] = ACTIONS(1953),
    [anon_sym_asm] = ACTIONS(1953),
    [anon_sym___asm__] = ACTIONS(1953),
    [anon_sym___asm] = ACTIONS(1953),
    [sym_number_literal] = ACTIONS(1955),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [anon_sym_NULL] = ACTIONS(1953),
    [anon_sym_nullptr] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_explicit] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_static_assert] = ACTIONS(1953),
    [anon_sym_concept] = ACTIONS(1953),
    [anon_sym_co_return] = ACTIONS(1953),
    [anon_sym_co_yield] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [sym_this] = ACTIONS(1953),
    [anon_sym_discard] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
    [anon_sym_cbuffer] = ACTIONS(1953),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1979),
    [aux_sym_preproc_include_token1] = ACTIONS(1979),
    [aux_sym_preproc_def_token1] = ACTIONS(1979),
    [aux_sym_preproc_if_token1] = ACTIONS(1979),
    [aux_sym_preproc_if_token2] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1979),
    [aux_sym_preproc_else_token1] = ACTIONS(1979),
    [aux_sym_preproc_elif_token1] = ACTIONS(1979),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1979),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1979),
    [sym_preproc_directive] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_typedef] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym___try] = ACTIONS(1979),
    [anon_sym___leave] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1979),
    [anon_sym_compl] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym___alignof__] = ACTIONS(1979),
    [anon_sym___alignof] = ACTIONS(1979),
    [anon_sym__alignof] = ACTIONS(1979),
    [anon_sym_alignof] = ACTIONS(1979),
    [anon_sym__Alignof] = ACTIONS(1979),
    [anon_sym_offsetof] = ACTIONS(1979),
    [anon_sym__Generic] = ACTIONS(1979),
    [anon_sym_asm] = ACTIONS(1979),
    [anon_sym___asm__] = ACTIONS(1979),
    [anon_sym___asm] = ACTIONS(1979),
    [sym_number_literal] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1981),
    [anon_sym_u_SQUOTE] = ACTIONS(1981),
    [anon_sym_U_SQUOTE] = ACTIONS(1981),
    [anon_sym_u8_SQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [anon_sym_L_DQUOTE] = ACTIONS(1981),
    [anon_sym_u_DQUOTE] = ACTIONS(1981),
    [anon_sym_U_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [anon_sym_NULL] = ACTIONS(1979),
    [anon_sym_nullptr] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_static_assert] = ACTIONS(1979),
    [anon_sym_concept] = ACTIONS(1979),
    [anon_sym_co_return] = ACTIONS(1979),
    [anon_sym_co_yield] = ACTIONS(1979),
    [anon_sym_R_DQUOTE] = ACTIONS(1981),
    [anon_sym_LR_DQUOTE] = ACTIONS(1981),
    [anon_sym_uR_DQUOTE] = ACTIONS(1981),
    [anon_sym_UR_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1981),
    [anon_sym_co_await] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [sym_this] = ACTIONS(1979),
    [anon_sym_discard] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
    [anon_sym_cbuffer] = ACTIONS(1979),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1983),
    [aux_sym_preproc_include_token1] = ACTIONS(1983),
    [aux_sym_preproc_def_token1] = ACTIONS(1983),
    [aux_sym_preproc_if_token1] = ACTIONS(1983),
    [aux_sym_preproc_if_token2] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1983),
    [aux_sym_preproc_else_token1] = ACTIONS(1983),
    [aux_sym_preproc_elif_token1] = ACTIONS(1983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1983),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1983),
    [sym_preproc_directive] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_using] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_goto] = ACTIONS(1983),
    [anon_sym___try] = ACTIONS(1983),
    [anon_sym___leave] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1983),
    [anon_sym_compl] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_sizeof] = ACTIONS(1983),
    [anon_sym___alignof__] = ACTIONS(1983),
    [anon_sym___alignof] = ACTIONS(1983),
    [anon_sym__alignof] = ACTIONS(1983),
    [anon_sym_alignof] = ACTIONS(1983),
    [anon_sym__Alignof] = ACTIONS(1983),
    [anon_sym_offsetof] = ACTIONS(1983),
    [anon_sym__Generic] = ACTIONS(1983),
    [anon_sym_asm] = ACTIONS(1983),
    [anon_sym___asm__] = ACTIONS(1983),
    [anon_sym___asm] = ACTIONS(1983),
    [sym_number_literal] = ACTIONS(1985),
    [anon_sym_L_SQUOTE] = ACTIONS(1985),
    [anon_sym_u_SQUOTE] = ACTIONS(1985),
    [anon_sym_U_SQUOTE] = ACTIONS(1985),
    [anon_sym_u8_SQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [anon_sym_NULL] = ACTIONS(1983),
    [anon_sym_nullptr] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_static_assert] = ACTIONS(1983),
    [anon_sym_concept] = ACTIONS(1983),
    [anon_sym_co_return] = ACTIONS(1983),
    [anon_sym_co_yield] = ACTIONS(1983),
    [anon_sym_R_DQUOTE] = ACTIONS(1985),
    [anon_sym_LR_DQUOTE] = ACTIONS(1985),
    [anon_sym_uR_DQUOTE] = ACTIONS(1985),
    [anon_sym_UR_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1985),
    [anon_sym_co_await] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [sym_this] = ACTIONS(1983),
    [anon_sym_discard] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
    [anon_sym_cbuffer] = ACTIONS(1983),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1991),
    [aux_sym_preproc_include_token1] = ACTIONS(1991),
    [aux_sym_preproc_def_token1] = ACTIONS(1991),
    [aux_sym_preproc_if_token1] = ACTIONS(1991),
    [aux_sym_preproc_if_token2] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1991),
    [aux_sym_preproc_else_token1] = ACTIONS(1991),
    [aux_sym_preproc_elif_token1] = ACTIONS(1991),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1991),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1991),
    [sym_preproc_directive] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_typedef] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_using] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_goto] = ACTIONS(1991),
    [anon_sym___try] = ACTIONS(1991),
    [anon_sym___leave] = ACTIONS(1991),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_sizeof] = ACTIONS(1991),
    [anon_sym___alignof__] = ACTIONS(1991),
    [anon_sym___alignof] = ACTIONS(1991),
    [anon_sym__alignof] = ACTIONS(1991),
    [anon_sym_alignof] = ACTIONS(1991),
    [anon_sym__Alignof] = ACTIONS(1991),
    [anon_sym_offsetof] = ACTIONS(1991),
    [anon_sym__Generic] = ACTIONS(1991),
    [anon_sym_asm] = ACTIONS(1991),
    [anon_sym___asm__] = ACTIONS(1991),
    [anon_sym___asm] = ACTIONS(1991),
    [sym_number_literal] = ACTIONS(1993),
    [anon_sym_L_SQUOTE] = ACTIONS(1993),
    [anon_sym_u_SQUOTE] = ACTIONS(1993),
    [anon_sym_U_SQUOTE] = ACTIONS(1993),
    [anon_sym_u8_SQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_L_DQUOTE] = ACTIONS(1993),
    [anon_sym_u_DQUOTE] = ACTIONS(1993),
    [anon_sym_U_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [anon_sym_NULL] = ACTIONS(1991),
    [anon_sym_nullptr] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_explicit] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_static_assert] = ACTIONS(1991),
    [anon_sym_concept] = ACTIONS(1991),
    [anon_sym_co_return] = ACTIONS(1991),
    [anon_sym_co_yield] = ACTIONS(1991),
    [anon_sym_R_DQUOTE] = ACTIONS(1993),
    [anon_sym_LR_DQUOTE] = ACTIONS(1993),
    [anon_sym_uR_DQUOTE] = ACTIONS(1993),
    [anon_sym_UR_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1993),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [sym_this] = ACTIONS(1991),
    [anon_sym_discard] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
    [anon_sym_cbuffer] = ACTIONS(1991),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1987),
    [aux_sym_preproc_include_token1] = ACTIONS(1987),
    [aux_sym_preproc_def_token1] = ACTIONS(1987),
    [aux_sym_preproc_if_token1] = ACTIONS(1987),
    [aux_sym_preproc_if_token2] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1987),
    [aux_sym_preproc_else_token1] = ACTIONS(1987),
    [aux_sym_preproc_elif_token1] = ACTIONS(1987),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1987),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1987),
    [sym_preproc_directive] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_typedef] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_using] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_goto] = ACTIONS(1987),
    [anon_sym___try] = ACTIONS(1987),
    [anon_sym___leave] = ACTIONS(1987),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_compl] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_sizeof] = ACTIONS(1987),
    [anon_sym___alignof__] = ACTIONS(1987),
    [anon_sym___alignof] = ACTIONS(1987),
    [anon_sym__alignof] = ACTIONS(1987),
    [anon_sym_alignof] = ACTIONS(1987),
    [anon_sym__Alignof] = ACTIONS(1987),
    [anon_sym_offsetof] = ACTIONS(1987),
    [anon_sym__Generic] = ACTIONS(1987),
    [anon_sym_asm] = ACTIONS(1987),
    [anon_sym___asm__] = ACTIONS(1987),
    [anon_sym___asm] = ACTIONS(1987),
    [sym_number_literal] = ACTIONS(1989),
    [anon_sym_L_SQUOTE] = ACTIONS(1989),
    [anon_sym_u_SQUOTE] = ACTIONS(1989),
    [anon_sym_U_SQUOTE] = ACTIONS(1989),
    [anon_sym_u8_SQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [anon_sym_L_DQUOTE] = ACTIONS(1989),
    [anon_sym_u_DQUOTE] = ACTIONS(1989),
    [anon_sym_U_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8_DQUOTE] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [anon_sym_NULL] = ACTIONS(1987),
    [anon_sym_nullptr] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_static_assert] = ACTIONS(1987),
    [anon_sym_concept] = ACTIONS(1987),
    [anon_sym_co_return] = ACTIONS(1987),
    [anon_sym_co_yield] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [sym_this] = ACTIONS(1987),
    [anon_sym_discard] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
    [anon_sym_cbuffer] = ACTIONS(1987),
  },
  [165] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [aux_sym_preproc_else_token1] = ACTIONS(2017),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [166] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [aux_sym_preproc_else_token1] = ACTIONS(2017),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [167] = {
    [sym_identifier] = ACTIONS(2027),
    [aux_sym_preproc_include_token1] = ACTIONS(2027),
    [aux_sym_preproc_def_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token2] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2027),
    [aux_sym_preproc_else_token1] = ACTIONS(2027),
    [aux_sym_preproc_elif_token1] = ACTIONS(2027),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2027),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2027),
    [sym_preproc_directive] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_typedef] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_using] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym___try] = ACTIONS(2027),
    [anon_sym___leave] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2027),
    [anon_sym_compl] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym___alignof__] = ACTIONS(2027),
    [anon_sym___alignof] = ACTIONS(2027),
    [anon_sym__alignof] = ACTIONS(2027),
    [anon_sym_alignof] = ACTIONS(2027),
    [anon_sym__Alignof] = ACTIONS(2027),
    [anon_sym_offsetof] = ACTIONS(2027),
    [anon_sym__Generic] = ACTIONS(2027),
    [anon_sym_asm] = ACTIONS(2027),
    [anon_sym___asm__] = ACTIONS(2027),
    [anon_sym___asm] = ACTIONS(2027),
    [sym_number_literal] = ACTIONS(2029),
    [anon_sym_L_SQUOTE] = ACTIONS(2029),
    [anon_sym_u_SQUOTE] = ACTIONS(2029),
    [anon_sym_U_SQUOTE] = ACTIONS(2029),
    [anon_sym_u8_SQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [anon_sym_L_DQUOTE] = ACTIONS(2029),
    [anon_sym_u_DQUOTE] = ACTIONS(2029),
    [anon_sym_U_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8_DQUOTE] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [anon_sym_NULL] = ACTIONS(2027),
    [anon_sym_nullptr] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_explicit] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_static_assert] = ACTIONS(2027),
    [anon_sym_concept] = ACTIONS(2027),
    [anon_sym_co_return] = ACTIONS(2027),
    [anon_sym_co_yield] = ACTIONS(2027),
    [anon_sym_R_DQUOTE] = ACTIONS(2029),
    [anon_sym_LR_DQUOTE] = ACTIONS(2029),
    [anon_sym_uR_DQUOTE] = ACTIONS(2029),
    [anon_sym_UR_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2029),
    [anon_sym_co_await] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [sym_this] = ACTIONS(2027),
    [anon_sym_discard] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
    [anon_sym_cbuffer] = ACTIONS(2027),
  },
  [168] = {
    [sym_catch_clause] = STATE(168),
    [aux_sym_constructor_try_statement_repeat1] = STATE(168),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_include_token1] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token2] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [aux_sym_preproc_else_token1] = ACTIONS(2031),
    [aux_sym_preproc_elif_token1] = ACTIONS(2031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym___cdecl] = ACTIONS(2031),
    [anon_sym___clrcall] = ACTIONS(2031),
    [anon_sym___stdcall] = ACTIONS(2031),
    [anon_sym___fastcall] = ACTIONS(2031),
    [anon_sym___thiscall] = ACTIONS(2031),
    [anon_sym___vectorcall] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2031),
    [anon_sym___leave] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2031),
    [anon_sym_compl] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2031),
    [anon_sym___alignof] = ACTIONS(2031),
    [anon_sym__alignof] = ACTIONS(2031),
    [anon_sym_alignof] = ACTIONS(2031),
    [anon_sym__Alignof] = ACTIONS(2031),
    [anon_sym_offsetof] = ACTIONS(2031),
    [anon_sym__Generic] = ACTIONS(2031),
    [anon_sym_asm] = ACTIONS(2031),
    [anon_sym___asm__] = ACTIONS(2031),
    [anon_sym___asm] = ACTIONS(2031),
    [sym_number_literal] = ACTIONS(2033),
    [anon_sym_L_SQUOTE] = ACTIONS(2033),
    [anon_sym_u_SQUOTE] = ACTIONS(2033),
    [anon_sym_U_SQUOTE] = ACTIONS(2033),
    [anon_sym_u8_SQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [anon_sym_L_DQUOTE] = ACTIONS(2033),
    [anon_sym_u_DQUOTE] = ACTIONS(2033),
    [anon_sym_U_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8_DQUOTE] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [anon_sym_NULL] = ACTIONS(2031),
    [anon_sym_nullptr] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_concept] = ACTIONS(2031),
    [anon_sym_co_return] = ACTIONS(2031),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(2035),
    [anon_sym_R_DQUOTE] = ACTIONS(2033),
    [anon_sym_LR_DQUOTE] = ACTIONS(2033),
    [anon_sym_uR_DQUOTE] = ACTIONS(2033),
    [anon_sym_UR_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2033),
    [anon_sym_co_await] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_requires] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [anon_sym_discard] = ACTIONS(2031),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
    [anon_sym_cbuffer] = ACTIONS(2031),
  },
  [169] = {
    [sym_identifier] = ACTIONS(2038),
    [aux_sym_preproc_include_token1] = ACTIONS(2038),
    [aux_sym_preproc_def_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token2] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2038),
    [aux_sym_preproc_else_token1] = ACTIONS(2038),
    [aux_sym_preproc_elif_token1] = ACTIONS(2038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2038),
    [sym_preproc_directive] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_goto] = ACTIONS(2038),
    [anon_sym___try] = ACTIONS(2038),
    [anon_sym___leave] = ACTIONS(2038),
    [anon_sym_not] = ACTIONS(2038),
    [anon_sym_compl] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_sizeof] = ACTIONS(2038),
    [anon_sym___alignof__] = ACTIONS(2038),
    [anon_sym___alignof] = ACTIONS(2038),
    [anon_sym__alignof] = ACTIONS(2038),
    [anon_sym_alignof] = ACTIONS(2038),
    [anon_sym__Alignof] = ACTIONS(2038),
    [anon_sym_offsetof] = ACTIONS(2038),
    [anon_sym__Generic] = ACTIONS(2038),
    [anon_sym_asm] = ACTIONS(2038),
    [anon_sym___asm__] = ACTIONS(2038),
    [anon_sym___asm] = ACTIONS(2038),
    [sym_number_literal] = ACTIONS(2040),
    [anon_sym_L_SQUOTE] = ACTIONS(2040),
    [anon_sym_u_SQUOTE] = ACTIONS(2040),
    [anon_sym_U_SQUOTE] = ACTIONS(2040),
    [anon_sym_u8_SQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_L_DQUOTE] = ACTIONS(2040),
    [anon_sym_u_DQUOTE] = ACTIONS(2040),
    [anon_sym_U_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8_DQUOTE] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [anon_sym_NULL] = ACTIONS(2038),
    [anon_sym_nullptr] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2038),
    [anon_sym_static_assert] = ACTIONS(2038),
    [anon_sym_concept] = ACTIONS(2038),
    [anon_sym_co_return] = ACTIONS(2038),
    [anon_sym_co_yield] = ACTIONS(2038),
    [anon_sym_R_DQUOTE] = ACTIONS(2040),
    [anon_sym_LR_DQUOTE] = ACTIONS(2040),
    [anon_sym_uR_DQUOTE] = ACTIONS(2040),
    [anon_sym_UR_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2040),
    [anon_sym_co_await] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [sym_this] = ACTIONS(2038),
    [anon_sym_discard] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
    [anon_sym_cbuffer] = ACTIONS(2038),
  },
  [170] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(5565),
    [sym__declarator] = STATE(6854),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8726),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3563),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5875),
    [sym_qualified_identifier] = STATE(3606),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2017),
    [anon_sym_module] = ACTIONS(2017),
    [anon_sym_import] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1971),
    [aux_sym_preproc_include_token1] = ACTIONS(1971),
    [aux_sym_preproc_def_token1] = ACTIONS(1971),
    [aux_sym_preproc_if_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1971),
    [sym_preproc_directive] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_typedef] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_using] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_goto] = ACTIONS(1971),
    [anon_sym___try] = ACTIONS(1971),
    [anon_sym___leave] = ACTIONS(1971),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_sizeof] = ACTIONS(1971),
    [anon_sym___alignof__] = ACTIONS(1971),
    [anon_sym___alignof] = ACTIONS(1971),
    [anon_sym__alignof] = ACTIONS(1971),
    [anon_sym_alignof] = ACTIONS(1971),
    [anon_sym__Alignof] = ACTIONS(1971),
    [anon_sym_offsetof] = ACTIONS(1971),
    [anon_sym__Generic] = ACTIONS(1971),
    [anon_sym_asm] = ACTIONS(1971),
    [anon_sym___asm__] = ACTIONS(1971),
    [anon_sym___asm] = ACTIONS(1971),
    [sym_number_literal] = ACTIONS(1973),
    [anon_sym_L_SQUOTE] = ACTIONS(1973),
    [anon_sym_u_SQUOTE] = ACTIONS(1973),
    [anon_sym_U_SQUOTE] = ACTIONS(1973),
    [anon_sym_u8_SQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [anon_sym_L_DQUOTE] = ACTIONS(1973),
    [anon_sym_u_DQUOTE] = ACTIONS(1973),
    [anon_sym_U_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8_DQUOTE] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [anon_sym_NULL] = ACTIONS(1971),
    [anon_sym_nullptr] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_explicit] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_import] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_static_assert] = ACTIONS(1971),
    [anon_sym_concept] = ACTIONS(1971),
    [anon_sym_co_return] = ACTIONS(1971),
    [anon_sym_co_yield] = ACTIONS(1971),
    [anon_sym_R_DQUOTE] = ACTIONS(1973),
    [anon_sym_LR_DQUOTE] = ACTIONS(1973),
    [anon_sym_uR_DQUOTE] = ACTIONS(1973),
    [anon_sym_UR_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1973),
    [anon_sym_co_await] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [sym_this] = ACTIONS(1971),
    [anon_sym_discard] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
    [anon_sym_cbuffer] = ACTIONS(1971),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1975),
    [aux_sym_preproc_include_token1] = ACTIONS(1975),
    [aux_sym_preproc_def_token1] = ACTIONS(1975),
    [aux_sym_preproc_if_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1975),
    [sym_preproc_directive] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_typedef] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_using] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1975),
    [anon_sym___try] = ACTIONS(1975),
    [anon_sym___leave] = ACTIONS(1975),
    [anon_sym_not] = ACTIONS(1975),
    [anon_sym_compl] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_sizeof] = ACTIONS(1975),
    [anon_sym___alignof__] = ACTIONS(1975),
    [anon_sym___alignof] = ACTIONS(1975),
    [anon_sym__alignof] = ACTIONS(1975),
    [anon_sym_alignof] = ACTIONS(1975),
    [anon_sym__Alignof] = ACTIONS(1975),
    [anon_sym_offsetof] = ACTIONS(1975),
    [anon_sym__Generic] = ACTIONS(1975),
    [anon_sym_asm] = ACTIONS(1975),
    [anon_sym___asm__] = ACTIONS(1975),
    [anon_sym___asm] = ACTIONS(1975),
    [sym_number_literal] = ACTIONS(1977),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1977),
    [anon_sym_u_DQUOTE] = ACTIONS(1977),
    [anon_sym_U_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [anon_sym_NULL] = ACTIONS(1975),
    [anon_sym_nullptr] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_explicit] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_export] = ACTIONS(1975),
    [anon_sym_module] = ACTIONS(1975),
    [anon_sym_import] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_static_assert] = ACTIONS(1975),
    [anon_sym_concept] = ACTIONS(1975),
    [anon_sym_co_return] = ACTIONS(1975),
    [anon_sym_co_yield] = ACTIONS(1975),
    [anon_sym_R_DQUOTE] = ACTIONS(1977),
    [anon_sym_LR_DQUOTE] = ACTIONS(1977),
    [anon_sym_uR_DQUOTE] = ACTIONS(1977),
    [anon_sym_UR_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1977),
    [anon_sym_co_await] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [sym_this] = ACTIONS(1975),
    [anon_sym_discard] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
    [anon_sym_cbuffer] = ACTIONS(1975),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(1955),
    [sym_identifier] = ACTIONS(1953),
    [aux_sym_preproc_include_token1] = ACTIONS(1953),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1953),
    [sym_preproc_directive] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_typedef] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_using] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_goto] = ACTIONS(1953),
    [anon_sym___try] = ACTIONS(1953),
    [anon_sym___leave] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1953),
    [anon_sym_compl] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1953),
    [anon_sym___alignof__] = ACTIONS(1953),
    [anon_sym___alignof] = ACTIONS(1953),
    [anon_sym__alignof] = ACTIONS(1953),
    [anon_sym_alignof] = ACTIONS(1953),
    [anon_sym__Alignof] = ACTIONS(1953),
    [anon_sym_offsetof] = ACTIONS(1953),
    [anon_sym__Generic] = ACTIONS(1953),
    [anon_sym_asm] = ACTIONS(1953),
    [anon_sym___asm__] = ACTIONS(1953),
    [anon_sym___asm] = ACTIONS(1953),
    [sym_number_literal] = ACTIONS(1955),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [anon_sym_NULL] = ACTIONS(1953),
    [anon_sym_nullptr] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_explicit] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_export] = ACTIONS(1953),
    [anon_sym_module] = ACTIONS(1953),
    [anon_sym_import] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_static_assert] = ACTIONS(1953),
    [anon_sym_concept] = ACTIONS(1953),
    [anon_sym_co_return] = ACTIONS(1953),
    [anon_sym_co_yield] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [sym_this] = ACTIONS(1953),
    [anon_sym_discard] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
    [anon_sym_cbuffer] = ACTIONS(1953),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1979),
    [aux_sym_preproc_include_token1] = ACTIONS(1979),
    [aux_sym_preproc_def_token1] = ACTIONS(1979),
    [aux_sym_preproc_if_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1979),
    [sym_preproc_directive] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_typedef] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym___try] = ACTIONS(1979),
    [anon_sym___leave] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1979),
    [anon_sym_compl] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym___alignof__] = ACTIONS(1979),
    [anon_sym___alignof] = ACTIONS(1979),
    [anon_sym__alignof] = ACTIONS(1979),
    [anon_sym_alignof] = ACTIONS(1979),
    [anon_sym__Alignof] = ACTIONS(1979),
    [anon_sym_offsetof] = ACTIONS(1979),
    [anon_sym__Generic] = ACTIONS(1979),
    [anon_sym_asm] = ACTIONS(1979),
    [anon_sym___asm__] = ACTIONS(1979),
    [anon_sym___asm] = ACTIONS(1979),
    [sym_number_literal] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1981),
    [anon_sym_u_SQUOTE] = ACTIONS(1981),
    [anon_sym_U_SQUOTE] = ACTIONS(1981),
    [anon_sym_u8_SQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [anon_sym_L_DQUOTE] = ACTIONS(1981),
    [anon_sym_u_DQUOTE] = ACTIONS(1981),
    [anon_sym_U_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [anon_sym_NULL] = ACTIONS(1979),
    [anon_sym_nullptr] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_export] = ACTIONS(1979),
    [anon_sym_module] = ACTIONS(1979),
    [anon_sym_import] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_static_assert] = ACTIONS(1979),
    [anon_sym_concept] = ACTIONS(1979),
    [anon_sym_co_return] = ACTIONS(1979),
    [anon_sym_co_yield] = ACTIONS(1979),
    [anon_sym_R_DQUOTE] = ACTIONS(1981),
    [anon_sym_LR_DQUOTE] = ACTIONS(1981),
    [anon_sym_uR_DQUOTE] = ACTIONS(1981),
    [anon_sym_UR_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1981),
    [anon_sym_co_await] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [sym_this] = ACTIONS(1979),
    [anon_sym_discard] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
    [anon_sym_cbuffer] = ACTIONS(1979),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1983),
    [aux_sym_preproc_include_token1] = ACTIONS(1983),
    [aux_sym_preproc_def_token1] = ACTIONS(1983),
    [aux_sym_preproc_if_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1983),
    [sym_preproc_directive] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_using] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_goto] = ACTIONS(1983),
    [anon_sym___try] = ACTIONS(1983),
    [anon_sym___leave] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1983),
    [anon_sym_compl] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_sizeof] = ACTIONS(1983),
    [anon_sym___alignof__] = ACTIONS(1983),
    [anon_sym___alignof] = ACTIONS(1983),
    [anon_sym__alignof] = ACTIONS(1983),
    [anon_sym_alignof] = ACTIONS(1983),
    [anon_sym__Alignof] = ACTIONS(1983),
    [anon_sym_offsetof] = ACTIONS(1983),
    [anon_sym__Generic] = ACTIONS(1983),
    [anon_sym_asm] = ACTIONS(1983),
    [anon_sym___asm__] = ACTIONS(1983),
    [anon_sym___asm] = ACTIONS(1983),
    [sym_number_literal] = ACTIONS(1985),
    [anon_sym_L_SQUOTE] = ACTIONS(1985),
    [anon_sym_u_SQUOTE] = ACTIONS(1985),
    [anon_sym_U_SQUOTE] = ACTIONS(1985),
    [anon_sym_u8_SQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [anon_sym_NULL] = ACTIONS(1983),
    [anon_sym_nullptr] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_export] = ACTIONS(1983),
    [anon_sym_module] = ACTIONS(1983),
    [anon_sym_import] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_static_assert] = ACTIONS(1983),
    [anon_sym_concept] = ACTIONS(1983),
    [anon_sym_co_return] = ACTIONS(1983),
    [anon_sym_co_yield] = ACTIONS(1983),
    [anon_sym_R_DQUOTE] = ACTIONS(1985),
    [anon_sym_LR_DQUOTE] = ACTIONS(1985),
    [anon_sym_uR_DQUOTE] = ACTIONS(1985),
    [anon_sym_UR_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1985),
    [anon_sym_co_await] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [sym_this] = ACTIONS(1983),
    [anon_sym_discard] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
    [anon_sym_cbuffer] = ACTIONS(1983),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1991),
    [aux_sym_preproc_include_token1] = ACTIONS(1991),
    [aux_sym_preproc_def_token1] = ACTIONS(1991),
    [aux_sym_preproc_if_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1991),
    [sym_preproc_directive] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_typedef] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_using] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_goto] = ACTIONS(1991),
    [anon_sym___try] = ACTIONS(1991),
    [anon_sym___leave] = ACTIONS(1991),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_sizeof] = ACTIONS(1991),
    [anon_sym___alignof__] = ACTIONS(1991),
    [anon_sym___alignof] = ACTIONS(1991),
    [anon_sym__alignof] = ACTIONS(1991),
    [anon_sym_alignof] = ACTIONS(1991),
    [anon_sym__Alignof] = ACTIONS(1991),
    [anon_sym_offsetof] = ACTIONS(1991),
    [anon_sym__Generic] = ACTIONS(1991),
    [anon_sym_asm] = ACTIONS(1991),
    [anon_sym___asm__] = ACTIONS(1991),
    [anon_sym___asm] = ACTIONS(1991),
    [sym_number_literal] = ACTIONS(1993),
    [anon_sym_L_SQUOTE] = ACTIONS(1993),
    [anon_sym_u_SQUOTE] = ACTIONS(1993),
    [anon_sym_U_SQUOTE] = ACTIONS(1993),
    [anon_sym_u8_SQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_L_DQUOTE] = ACTIONS(1993),
    [anon_sym_u_DQUOTE] = ACTIONS(1993),
    [anon_sym_U_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [anon_sym_NULL] = ACTIONS(1991),
    [anon_sym_nullptr] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_explicit] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_export] = ACTIONS(1991),
    [anon_sym_module] = ACTIONS(1991),
    [anon_sym_import] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_static_assert] = ACTIONS(1991),
    [anon_sym_concept] = ACTIONS(1991),
    [anon_sym_co_return] = ACTIONS(1991),
    [anon_sym_co_yield] = ACTIONS(1991),
    [anon_sym_R_DQUOTE] = ACTIONS(1993),
    [anon_sym_LR_DQUOTE] = ACTIONS(1993),
    [anon_sym_uR_DQUOTE] = ACTIONS(1993),
    [anon_sym_UR_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1993),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [sym_this] = ACTIONS(1991),
    [anon_sym_discard] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
    [anon_sym_cbuffer] = ACTIONS(1991),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1987),
    [aux_sym_preproc_include_token1] = ACTIONS(1987),
    [aux_sym_preproc_def_token1] = ACTIONS(1987),
    [aux_sym_preproc_if_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1987),
    [sym_preproc_directive] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_typedef] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_using] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_goto] = ACTIONS(1987),
    [anon_sym___try] = ACTIONS(1987),
    [anon_sym___leave] = ACTIONS(1987),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_compl] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_sizeof] = ACTIONS(1987),
    [anon_sym___alignof__] = ACTIONS(1987),
    [anon_sym___alignof] = ACTIONS(1987),
    [anon_sym__alignof] = ACTIONS(1987),
    [anon_sym_alignof] = ACTIONS(1987),
    [anon_sym__Alignof] = ACTIONS(1987),
    [anon_sym_offsetof] = ACTIONS(1987),
    [anon_sym__Generic] = ACTIONS(1987),
    [anon_sym_asm] = ACTIONS(1987),
    [anon_sym___asm__] = ACTIONS(1987),
    [anon_sym___asm] = ACTIONS(1987),
    [sym_number_literal] = ACTIONS(1989),
    [anon_sym_L_SQUOTE] = ACTIONS(1989),
    [anon_sym_u_SQUOTE] = ACTIONS(1989),
    [anon_sym_U_SQUOTE] = ACTIONS(1989),
    [anon_sym_u8_SQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [anon_sym_L_DQUOTE] = ACTIONS(1989),
    [anon_sym_u_DQUOTE] = ACTIONS(1989),
    [anon_sym_U_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8_DQUOTE] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [anon_sym_NULL] = ACTIONS(1987),
    [anon_sym_nullptr] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_export] = ACTIONS(1987),
    [anon_sym_module] = ACTIONS(1987),
    [anon_sym_import] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_static_assert] = ACTIONS(1987),
    [anon_sym_concept] = ACTIONS(1987),
    [anon_sym_co_return] = ACTIONS(1987),
    [anon_sym_co_yield] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [sym_this] = ACTIONS(1987),
    [anon_sym_discard] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
    [anon_sym_cbuffer] = ACTIONS(1987),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2017),
    [anon_sym_module] = ACTIONS(2017),
    [anon_sym_import] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_export] = ACTIONS(2017),
    [anon_sym_module] = ACTIONS(2017),
    [anon_sym_import] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2027),
    [aux_sym_preproc_include_token1] = ACTIONS(2027),
    [aux_sym_preproc_def_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2027),
    [sym_preproc_directive] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_typedef] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_using] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym___try] = ACTIONS(2027),
    [anon_sym___leave] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2027),
    [anon_sym_compl] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym___alignof__] = ACTIONS(2027),
    [anon_sym___alignof] = ACTIONS(2027),
    [anon_sym__alignof] = ACTIONS(2027),
    [anon_sym_alignof] = ACTIONS(2027),
    [anon_sym__Alignof] = ACTIONS(2027),
    [anon_sym_offsetof] = ACTIONS(2027),
    [anon_sym__Generic] = ACTIONS(2027),
    [anon_sym_asm] = ACTIONS(2027),
    [anon_sym___asm__] = ACTIONS(2027),
    [anon_sym___asm] = ACTIONS(2027),
    [sym_number_literal] = ACTIONS(2029),
    [anon_sym_L_SQUOTE] = ACTIONS(2029),
    [anon_sym_u_SQUOTE] = ACTIONS(2029),
    [anon_sym_U_SQUOTE] = ACTIONS(2029),
    [anon_sym_u8_SQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [anon_sym_L_DQUOTE] = ACTIONS(2029),
    [anon_sym_u_DQUOTE] = ACTIONS(2029),
    [anon_sym_U_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8_DQUOTE] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [anon_sym_NULL] = ACTIONS(2027),
    [anon_sym_nullptr] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_explicit] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_export] = ACTIONS(2027),
    [anon_sym_module] = ACTIONS(2027),
    [anon_sym_import] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_static_assert] = ACTIONS(2027),
    [anon_sym_concept] = ACTIONS(2027),
    [anon_sym_co_return] = ACTIONS(2027),
    [anon_sym_co_yield] = ACTIONS(2027),
    [anon_sym_R_DQUOTE] = ACTIONS(2029),
    [anon_sym_LR_DQUOTE] = ACTIONS(2029),
    [anon_sym_uR_DQUOTE] = ACTIONS(2029),
    [anon_sym_UR_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2029),
    [anon_sym_co_await] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [sym_this] = ACTIONS(2027),
    [anon_sym_discard] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
    [anon_sym_cbuffer] = ACTIONS(2027),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(2040),
    [sym_identifier] = ACTIONS(2038),
    [aux_sym_preproc_include_token1] = ACTIONS(2038),
    [aux_sym_preproc_def_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2038),
    [sym_preproc_directive] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_goto] = ACTIONS(2038),
    [anon_sym___try] = ACTIONS(2038),
    [anon_sym___leave] = ACTIONS(2038),
    [anon_sym_not] = ACTIONS(2038),
    [anon_sym_compl] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_sizeof] = ACTIONS(2038),
    [anon_sym___alignof__] = ACTIONS(2038),
    [anon_sym___alignof] = ACTIONS(2038),
    [anon_sym__alignof] = ACTIONS(2038),
    [anon_sym_alignof] = ACTIONS(2038),
    [anon_sym__Alignof] = ACTIONS(2038),
    [anon_sym_offsetof] = ACTIONS(2038),
    [anon_sym__Generic] = ACTIONS(2038),
    [anon_sym_asm] = ACTIONS(2038),
    [anon_sym___asm__] = ACTIONS(2038),
    [anon_sym___asm] = ACTIONS(2038),
    [sym_number_literal] = ACTIONS(2040),
    [anon_sym_L_SQUOTE] = ACTIONS(2040),
    [anon_sym_u_SQUOTE] = ACTIONS(2040),
    [anon_sym_U_SQUOTE] = ACTIONS(2040),
    [anon_sym_u8_SQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_L_DQUOTE] = ACTIONS(2040),
    [anon_sym_u_DQUOTE] = ACTIONS(2040),
    [anon_sym_U_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8_DQUOTE] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [anon_sym_NULL] = ACTIONS(2038),
    [anon_sym_nullptr] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_export] = ACTIONS(2038),
    [anon_sym_module] = ACTIONS(2038),
    [anon_sym_import] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2038),
    [anon_sym_static_assert] = ACTIONS(2038),
    [anon_sym_concept] = ACTIONS(2038),
    [anon_sym_co_return] = ACTIONS(2038),
    [anon_sym_co_yield] = ACTIONS(2038),
    [anon_sym_R_DQUOTE] = ACTIONS(2040),
    [anon_sym_LR_DQUOTE] = ACTIONS(2040),
    [anon_sym_uR_DQUOTE] = ACTIONS(2040),
    [anon_sym_UR_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2040),
    [anon_sym_co_await] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [sym_this] = ACTIONS(2038),
    [anon_sym_discard] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
    [anon_sym_cbuffer] = ACTIONS(2038),
  },
  [183] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(5565),
    [sym__declarator] = STATE(6854),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8820),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3563),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5875),
    [sym_qualified_identifier] = STATE(3606),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [184] = {
    [sym_field_declaration_list] = STATE(501),
    [sym_virtual_specifier] = STATE(7222),
    [sym_base_class_clause] = STATE(8189),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token2] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_inout] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym___attribute] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym__Nonnull] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym__Alignas] = ACTIONS(1957),
    [sym_primitive_type] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [anon_sym___asm] = ACTIONS(1957),
    [sym_number_literal] = ACTIONS(1959),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
    [anon_sym_discard] = ACTIONS(1957),
    [anon_sym_precise] = ACTIONS(1957),
    [anon_sym_shared] = ACTIONS(1957),
    [anon_sym_groupshared] = ACTIONS(1957),
    [anon_sym_uniform] = ACTIONS(1957),
    [anon_sym_row_major] = ACTIONS(1957),
    [anon_sym_column_major] = ACTIONS(1957),
    [anon_sym_globallycoherent] = ACTIONS(1957),
    [anon_sym_centroid] = ACTIONS(1957),
    [anon_sym_noperspective] = ACTIONS(1957),
    [anon_sym_nointerpolation] = ACTIONS(1957),
    [anon_sym_sample] = ACTIONS(1957),
    [anon_sym_linear] = ACTIONS(1957),
    [anon_sym_snorm] = ACTIONS(1957),
    [anon_sym_unorm] = ACTIONS(1957),
    [anon_sym_point] = ACTIONS(1957),
    [anon_sym_line] = ACTIONS(1957),
    [anon_sym_triangleadj] = ACTIONS(1957),
    [anon_sym_lineadj] = ACTIONS(1957),
    [anon_sym_triangle] = ACTIONS(1957),
    [anon_sym_cbuffer] = ACTIONS(1957),
  },
  [185] = {
    [sym_catch_clause] = STATE(193),
    [aux_sym_constructor_try_statement_repeat1] = STATE(193),
    [ts_builtin_sym_end] = ACTIONS(2023),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_include_token1] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym___cdecl] = ACTIONS(2021),
    [anon_sym___clrcall] = ACTIONS(2021),
    [anon_sym___stdcall] = ACTIONS(2021),
    [anon_sym___fastcall] = ACTIONS(2021),
    [anon_sym___thiscall] = ACTIONS(2021),
    [anon_sym___vectorcall] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_goto] = ACTIONS(2021),
    [anon_sym___try] = ACTIONS(2021),
    [anon_sym___leave] = ACTIONS(2021),
    [anon_sym_not] = ACTIONS(2021),
    [anon_sym_compl] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2021),
    [anon_sym___alignof__] = ACTIONS(2021),
    [anon_sym___alignof] = ACTIONS(2021),
    [anon_sym__alignof] = ACTIONS(2021),
    [anon_sym_alignof] = ACTIONS(2021),
    [anon_sym__Alignof] = ACTIONS(2021),
    [anon_sym_offsetof] = ACTIONS(2021),
    [anon_sym__Generic] = ACTIONS(2021),
    [anon_sym_asm] = ACTIONS(2021),
    [anon_sym___asm__] = ACTIONS(2021),
    [anon_sym___asm] = ACTIONS(2021),
    [sym_number_literal] = ACTIONS(2023),
    [anon_sym_L_SQUOTE] = ACTIONS(2023),
    [anon_sym_u_SQUOTE] = ACTIONS(2023),
    [anon_sym_U_SQUOTE] = ACTIONS(2023),
    [anon_sym_u8_SQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_L_DQUOTE] = ACTIONS(2023),
    [anon_sym_u_DQUOTE] = ACTIONS(2023),
    [anon_sym_U_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8_DQUOTE] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [anon_sym_NULL] = ACTIONS(2021),
    [anon_sym_nullptr] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_export] = ACTIONS(2021),
    [anon_sym_module] = ACTIONS(2021),
    [anon_sym_import] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_concept] = ACTIONS(2021),
    [anon_sym_co_return] = ACTIONS(2021),
    [anon_sym_co_yield] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(2118),
    [anon_sym_R_DQUOTE] = ACTIONS(2023),
    [anon_sym_LR_DQUOTE] = ACTIONS(2023),
    [anon_sym_uR_DQUOTE] = ACTIONS(2023),
    [anon_sym_UR_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2023),
    [anon_sym_co_await] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_requires] = ACTIONS(2021),
    [sym_this] = ACTIONS(2021),
    [anon_sym_discard] = ACTIONS(2021),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
    [anon_sym_cbuffer] = ACTIONS(2021),
  },
  [186] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(5565),
    [sym__declarator] = STATE(6854),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_compound_statement] = STATE(9044),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3303),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8251),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3563),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8263),
    [sym__unary_right_fold] = STATE(8285),
    [sym__binary_fold] = STATE(8310),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5875),
    [sym_qualified_identifier] = STATE(3606),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8329),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(2042),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [187] = {
    [sym_field_declaration_list] = STATE(525),
    [sym_virtual_specifier] = STATE(7286),
    [sym_base_class_clause] = STATE(8049),
    [sym_identifier] = ACTIONS(1957),
    [aux_sym_preproc_include_token1] = ACTIONS(1957),
    [aux_sym_preproc_def_token1] = ACTIONS(1957),
    [aux_sym_preproc_if_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1957),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1957),
    [sym_preproc_directive] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP_AMP] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_inout] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym___attribute] = ACTIONS(1957),
    [anon_sym_using] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym___based] = ACTIONS(1957),
    [anon_sym___cdecl] = ACTIONS(1957),
    [anon_sym___clrcall] = ACTIONS(1957),
    [anon_sym___stdcall] = ACTIONS(1957),
    [anon_sym___fastcall] = ACTIONS(1957),
    [anon_sym___thiscall] = ACTIONS(1957),
    [anon_sym___vectorcall] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_RBRACE] = ACTIONS(1959),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym__Nonnull] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym__Alignas] = ACTIONS(1957),
    [sym_primitive_type] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_case] = ACTIONS(1957),
    [anon_sym_default] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [anon_sym___asm] = ACTIONS(1957),
    [sym_number_literal] = ACTIONS(1959),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1957),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_operator] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_namespace] = ACTIONS(1957),
    [anon_sym_static_assert] = ACTIONS(1957),
    [anon_sym_concept] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
    [anon_sym_discard] = ACTIONS(1957),
    [anon_sym_precise] = ACTIONS(1957),
    [anon_sym_shared] = ACTIONS(1957),
    [anon_sym_groupshared] = ACTIONS(1957),
    [anon_sym_uniform] = ACTIONS(1957),
    [anon_sym_row_major] = ACTIONS(1957),
    [anon_sym_column_major] = ACTIONS(1957),
    [anon_sym_globallycoherent] = ACTIONS(1957),
    [anon_sym_centroid] = ACTIONS(1957),
    [anon_sym_noperspective] = ACTIONS(1957),
    [anon_sym_nointerpolation] = ACTIONS(1957),
    [anon_sym_sample] = ACTIONS(1957),
    [anon_sym_linear] = ACTIONS(1957),
    [anon_sym_snorm] = ACTIONS(1957),
    [anon_sym_unorm] = ACTIONS(1957),
    [anon_sym_point] = ACTIONS(1957),
    [anon_sym_line] = ACTIONS(1957),
    [anon_sym_triangleadj] = ACTIONS(1957),
    [anon_sym_lineadj] = ACTIONS(1957),
    [anon_sym_triangle] = ACTIONS(1957),
    [anon_sym_cbuffer] = ACTIONS(1957),
  },
  [188] = {
    [sym_field_declaration_list] = STATE(505),
    [sym_virtual_specifier] = STATE(7256),
    [sym_base_class_clause] = STATE(8214),
    [sym_identifier] = ACTIONS(1967),
    [aux_sym_preproc_include_token1] = ACTIONS(1967),
    [aux_sym_preproc_def_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token2] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1967),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_typedef] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1967),
    [anon_sym_inout] = ACTIONS(1967),
    [anon_sym_virtual] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym___attribute] = ACTIONS(1967),
    [anon_sym_using] = ACTIONS(1967),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1969),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [anon_sym_signed] = ACTIONS(1967),
    [anon_sym_unsigned] = ACTIONS(1967),
    [anon_sym_long] = ACTIONS(1967),
    [anon_sym_short] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym__Nonnull] = ACTIONS(1967),
    [anon_sym_mutable] = ACTIONS(1967),
    [anon_sym_constinit] = ACTIONS(1967),
    [anon_sym_consteval] = ACTIONS(1967),
    [anon_sym_alignas] = ACTIONS(1967),
    [anon_sym__Alignas] = ACTIONS(1967),
    [sym_primitive_type] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1967),
    [anon_sym___try] = ACTIONS(1967),
    [anon_sym___leave] = ACTIONS(1967),
    [anon_sym_not] = ACTIONS(1967),
    [anon_sym_compl] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(1967),
    [anon_sym___alignof__] = ACTIONS(1967),
    [anon_sym___alignof] = ACTIONS(1967),
    [anon_sym__alignof] = ACTIONS(1967),
    [anon_sym_alignof] = ACTIONS(1967),
    [anon_sym__Alignof] = ACTIONS(1967),
    [anon_sym_offsetof] = ACTIONS(1967),
    [anon_sym__Generic] = ACTIONS(1967),
    [anon_sym_asm] = ACTIONS(1967),
    [anon_sym___asm__] = ACTIONS(1967),
    [anon_sym___asm] = ACTIONS(1967),
    [sym_number_literal] = ACTIONS(1969),
    [anon_sym_L_SQUOTE] = ACTIONS(1969),
    [anon_sym_u_SQUOTE] = ACTIONS(1969),
    [anon_sym_U_SQUOTE] = ACTIONS(1969),
    [anon_sym_u8_SQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(1969),
    [anon_sym_u_DQUOTE] = ACTIONS(1969),
    [anon_sym_U_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8_DQUOTE] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [anon_sym_NULL] = ACTIONS(1967),
    [anon_sym_nullptr] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1967),
    [anon_sym_decltype] = ACTIONS(1967),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1967),
    [anon_sym_typename] = ACTIONS(1967),
    [anon_sym_template] = ACTIONS(1967),
    [anon_sym_operator] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_static_assert] = ACTIONS(1967),
    [anon_sym_concept] = ACTIONS(1967),
    [anon_sym_co_return] = ACTIONS(1967),
    [anon_sym_co_yield] = ACTIONS(1967),
    [anon_sym_R_DQUOTE] = ACTIONS(1969),
    [anon_sym_LR_DQUOTE] = ACTIONS(1969),
    [anon_sym_uR_DQUOTE] = ACTIONS(1969),
    [anon_sym_UR_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1969),
    [anon_sym_co_await] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_requires] = ACTIONS(1967),
    [sym_this] = ACTIONS(1967),
    [anon_sym_discard] = ACTIONS(1967),
    [anon_sym_precise] = ACTIONS(1967),
    [anon_sym_shared] = ACTIONS(1967),
    [anon_sym_groupshared] = ACTIONS(1967),
    [anon_sym_uniform] = ACTIONS(1967),
    [anon_sym_row_major] = ACTIONS(1967),
    [anon_sym_column_major] = ACTIONS(1967),
    [anon_sym_globallycoherent] = ACTIONS(1967),
    [anon_sym_centroid] = ACTIONS(1967),
    [anon_sym_noperspective] = ACTIONS(1967),
    [anon_sym_nointerpolation] = ACTIONS(1967),
    [anon_sym_sample] = ACTIONS(1967),
    [anon_sym_linear] = ACTIONS(1967),
    [anon_sym_snorm] = ACTIONS(1967),
    [anon_sym_unorm] = ACTIONS(1967),
    [anon_sym_point] = ACTIONS(1967),
    [anon_sym_line] = ACTIONS(1967),
    [anon_sym_triangleadj] = ACTIONS(1967),
    [anon_sym_lineadj] = ACTIONS(1967),
    [anon_sym_triangle] = ACTIONS(1967),
    [anon_sym_cbuffer] = ACTIONS(1967),
  },
  [189] = {
    [sym_field_declaration_list] = STATE(558),
    [sym_virtual_specifier] = STATE(7142),
    [sym_base_class_clause] = STATE(7979),
    [sym_identifier] = ACTIONS(1967),
    [aux_sym_preproc_include_token1] = ACTIONS(1967),
    [aux_sym_preproc_def_token1] = ACTIONS(1967),
    [aux_sym_preproc_if_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1967),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1967),
    [sym_preproc_directive] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_AMP_AMP] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1967),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_typedef] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1967),
    [anon_sym_inout] = ACTIONS(1967),
    [anon_sym_virtual] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym___attribute] = ACTIONS(1967),
    [anon_sym_using] = ACTIONS(1967),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1969),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym___based] = ACTIONS(1967),
    [anon_sym___cdecl] = ACTIONS(1967),
    [anon_sym___clrcall] = ACTIONS(1967),
    [anon_sym___stdcall] = ACTIONS(1967),
    [anon_sym___fastcall] = ACTIONS(1967),
    [anon_sym___thiscall] = ACTIONS(1967),
    [anon_sym___vectorcall] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_signed] = ACTIONS(1967),
    [anon_sym_unsigned] = ACTIONS(1967),
    [anon_sym_long] = ACTIONS(1967),
    [anon_sym_short] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym__Nonnull] = ACTIONS(1967),
    [anon_sym_mutable] = ACTIONS(1967),
    [anon_sym_constinit] = ACTIONS(1967),
    [anon_sym_consteval] = ACTIONS(1967),
    [anon_sym_alignas] = ACTIONS(1967),
    [anon_sym__Alignas] = ACTIONS(1967),
    [sym_primitive_type] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_case] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1967),
    [anon_sym___try] = ACTIONS(1967),
    [anon_sym___leave] = ACTIONS(1967),
    [anon_sym_not] = ACTIONS(1967),
    [anon_sym_compl] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(1967),
    [anon_sym___alignof__] = ACTIONS(1967),
    [anon_sym___alignof] = ACTIONS(1967),
    [anon_sym__alignof] = ACTIONS(1967),
    [anon_sym_alignof] = ACTIONS(1967),
    [anon_sym__Alignof] = ACTIONS(1967),
    [anon_sym_offsetof] = ACTIONS(1967),
    [anon_sym__Generic] = ACTIONS(1967),
    [anon_sym_asm] = ACTIONS(1967),
    [anon_sym___asm__] = ACTIONS(1967),
    [anon_sym___asm] = ACTIONS(1967),
    [sym_number_literal] = ACTIONS(1969),
    [anon_sym_L_SQUOTE] = ACTIONS(1969),
    [anon_sym_u_SQUOTE] = ACTIONS(1969),
    [anon_sym_U_SQUOTE] = ACTIONS(1969),
    [anon_sym_u8_SQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(1969),
    [anon_sym_u_DQUOTE] = ACTIONS(1969),
    [anon_sym_U_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8_DQUOTE] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [anon_sym_NULL] = ACTIONS(1967),
    [anon_sym_nullptr] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1967),
    [anon_sym_decltype] = ACTIONS(1967),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_explicit] = ACTIONS(1967),
    [anon_sym_typename] = ACTIONS(1967),
    [anon_sym_template] = ACTIONS(1967),
    [anon_sym_operator] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_namespace] = ACTIONS(1967),
    [anon_sym_static_assert] = ACTIONS(1967),
    [anon_sym_concept] = ACTIONS(1967),
    [anon_sym_co_return] = ACTIONS(1967),
    [anon_sym_co_yield] = ACTIONS(1967),
    [anon_sym_R_DQUOTE] = ACTIONS(1969),
    [anon_sym_LR_DQUOTE] = ACTIONS(1969),
    [anon_sym_uR_DQUOTE] = ACTIONS(1969),
    [anon_sym_UR_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1969),
    [anon_sym_co_await] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_requires] = ACTIONS(1967),
    [sym_this] = ACTIONS(1967),
    [anon_sym_discard] = ACTIONS(1967),
    [anon_sym_precise] = ACTIONS(1967),
    [anon_sym_shared] = ACTIONS(1967),
    [anon_sym_groupshared] = ACTIONS(1967),
    [anon_sym_uniform] = ACTIONS(1967),
    [anon_sym_row_major] = ACTIONS(1967),
    [anon_sym_column_major] = ACTIONS(1967),
    [anon_sym_globallycoherent] = ACTIONS(1967),
    [anon_sym_centroid] = ACTIONS(1967),
    [anon_sym_noperspective] = ACTIONS(1967),
    [anon_sym_nointerpolation] = ACTIONS(1967),
    [anon_sym_sample] = ACTIONS(1967),
    [anon_sym_linear] = ACTIONS(1967),
    [anon_sym_snorm] = ACTIONS(1967),
    [anon_sym_unorm] = ACTIONS(1967),
    [anon_sym_point] = ACTIONS(1967),
    [anon_sym_line] = ACTIONS(1967),
    [anon_sym_triangleadj] = ACTIONS(1967),
    [anon_sym_lineadj] = ACTIONS(1967),
    [anon_sym_triangle] = ACTIONS(1967),
    [anon_sym_cbuffer] = ACTIONS(1967),
  },
  [190] = {
    [sym_catch_clause] = STATE(168),
    [aux_sym_constructor_try_statement_repeat1] = STATE(168),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_include_token1] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token2] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [aux_sym_preproc_else_token1] = ACTIONS(2122),
    [aux_sym_preproc_elif_token1] = ACTIONS(2122),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym___cdecl] = ACTIONS(2122),
    [anon_sym___clrcall] = ACTIONS(2122),
    [anon_sym___stdcall] = ACTIONS(2122),
    [anon_sym___fastcall] = ACTIONS(2122),
    [anon_sym___thiscall] = ACTIONS(2122),
    [anon_sym___vectorcall] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_goto] = ACTIONS(2122),
    [anon_sym___try] = ACTIONS(2122),
    [anon_sym___leave] = ACTIONS(2122),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_compl] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_sizeof] = ACTIONS(2122),
    [anon_sym___alignof__] = ACTIONS(2122),
    [anon_sym___alignof] = ACTIONS(2122),
    [anon_sym__alignof] = ACTIONS(2122),
    [anon_sym_alignof] = ACTIONS(2122),
    [anon_sym__Alignof] = ACTIONS(2122),
    [anon_sym_offsetof] = ACTIONS(2122),
    [anon_sym__Generic] = ACTIONS(2122),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2124),
    [anon_sym_L_SQUOTE] = ACTIONS(2124),
    [anon_sym_u_SQUOTE] = ACTIONS(2124),
    [anon_sym_U_SQUOTE] = ACTIONS(2124),
    [anon_sym_u8_SQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_L_DQUOTE] = ACTIONS(2124),
    [anon_sym_u_DQUOTE] = ACTIONS(2124),
    [anon_sym_U_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8_DQUOTE] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [anon_sym_NULL] = ACTIONS(2122),
    [anon_sym_nullptr] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_concept] = ACTIONS(2122),
    [anon_sym_co_return] = ACTIONS(2122),
    [anon_sym_co_yield] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(2025),
    [anon_sym_R_DQUOTE] = ACTIONS(2124),
    [anon_sym_LR_DQUOTE] = ACTIONS(2124),
    [anon_sym_uR_DQUOTE] = ACTIONS(2124),
    [anon_sym_UR_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2124),
    [anon_sym_co_await] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_requires] = ACTIONS(2122),
    [sym_this] = ACTIONS(2122),
    [anon_sym_discard] = ACTIONS(2122),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
    [anon_sym_cbuffer] = ACTIONS(2122),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(2013),
    [sym_identifier] = ACTIONS(2011),
    [aux_sym_preproc_include_token1] = ACTIONS(2011),
    [aux_sym_preproc_def_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2011),
    [sym_preproc_directive] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_using] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_goto] = ACTIONS(2011),
    [anon_sym___try] = ACTIONS(2011),
    [anon_sym___leave] = ACTIONS(2011),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_compl] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2011),
    [anon_sym___alignof__] = ACTIONS(2011),
    [anon_sym___alignof] = ACTIONS(2011),
    [anon_sym__alignof] = ACTIONS(2011),
    [anon_sym_alignof] = ACTIONS(2011),
    [anon_sym__Alignof] = ACTIONS(2011),
    [anon_sym_offsetof] = ACTIONS(2011),
    [anon_sym__Generic] = ACTIONS(2011),
    [anon_sym_asm] = ACTIONS(2011),
    [anon_sym___asm__] = ACTIONS(2011),
    [anon_sym___asm] = ACTIONS(2011),
    [sym_number_literal] = ACTIONS(2013),
    [anon_sym_L_SQUOTE] = ACTIONS(2013),
    [anon_sym_u_SQUOTE] = ACTIONS(2013),
    [anon_sym_U_SQUOTE] = ACTIONS(2013),
    [anon_sym_u8_SQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [anon_sym_L_DQUOTE] = ACTIONS(2013),
    [anon_sym_u_DQUOTE] = ACTIONS(2013),
    [anon_sym_U_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8_DQUOTE] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [anon_sym_NULL] = ACTIONS(2011),
    [anon_sym_nullptr] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_explicit] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_export] = ACTIONS(2011),
    [anon_sym_module] = ACTIONS(2011),
    [anon_sym_import] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_static_assert] = ACTIONS(2011),
    [anon_sym_concept] = ACTIONS(2011),
    [anon_sym_co_return] = ACTIONS(2011),
    [anon_sym_co_yield] = ACTIONS(2011),
    [anon_sym_R_DQUOTE] = ACTIONS(2013),
    [anon_sym_LR_DQUOTE] = ACTIONS(2013),
    [anon_sym_uR_DQUOTE] = ACTIONS(2013),
    [anon_sym_UR_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2013),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [sym_this] = ACTIONS(2011),
    [anon_sym_discard] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
    [anon_sym_cbuffer] = ACTIONS(2011),
  },
  [192] = {
    [sym_catch_clause] = STATE(168),
    [aux_sym_constructor_try_statement_repeat1] = STATE(168),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_include_token1] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token2] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [aux_sym_preproc_else_token1] = ACTIONS(2126),
    [aux_sym_preproc_elif_token1] = ACTIONS(2126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym___cdecl] = ACTIONS(2126),
    [anon_sym___clrcall] = ACTIONS(2126),
    [anon_sym___stdcall] = ACTIONS(2126),
    [anon_sym___fastcall] = ACTIONS(2126),
    [anon_sym___thiscall] = ACTIONS(2126),
    [anon_sym___vectorcall] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_goto] = ACTIONS(2126),
    [anon_sym___try] = ACTIONS(2126),
    [anon_sym___leave] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2126),
    [anon_sym_compl] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_sizeof] = ACTIONS(2126),
    [anon_sym___alignof__] = ACTIONS(2126),
    [anon_sym___alignof] = ACTIONS(2126),
    [anon_sym__alignof] = ACTIONS(2126),
    [anon_sym_alignof] = ACTIONS(2126),
    [anon_sym__Alignof] = ACTIONS(2126),
    [anon_sym_offsetof] = ACTIONS(2126),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2126),
    [anon_sym___asm__] = ACTIONS(2126),
    [anon_sym___asm] = ACTIONS(2126),
    [sym_number_literal] = ACTIONS(2128),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2128),
    [anon_sym_u_DQUOTE] = ACTIONS(2128),
    [anon_sym_U_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8_DQUOTE] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [anon_sym_NULL] = ACTIONS(2126),
    [anon_sym_nullptr] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_concept] = ACTIONS(2126),
    [anon_sym_co_return] = ACTIONS(2126),
    [anon_sym_co_yield] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(2025),
    [anon_sym_R_DQUOTE] = ACTIONS(2128),
    [anon_sym_LR_DQUOTE] = ACTIONS(2128),
    [anon_sym_uR_DQUOTE] = ACTIONS(2128),
    [anon_sym_UR_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2128),
    [anon_sym_co_await] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_requires] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [anon_sym_discard] = ACTIONS(2126),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
    [anon_sym_cbuffer] = ACTIONS(2126),
  },
  [193] = {
    [sym_catch_clause] = STATE(193),
    [aux_sym_constructor_try_statement_repeat1] = STATE(193),
    [ts_builtin_sym_end] = ACTIONS(2033),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_include_token1] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym___cdecl] = ACTIONS(2031),
    [anon_sym___clrcall] = ACTIONS(2031),
    [anon_sym___stdcall] = ACTIONS(2031),
    [anon_sym___fastcall] = ACTIONS(2031),
    [anon_sym___thiscall] = ACTIONS(2031),
    [anon_sym___vectorcall] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2031),
    [anon_sym___leave] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2031),
    [anon_sym_compl] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2031),
    [anon_sym___alignof] = ACTIONS(2031),
    [anon_sym__alignof] = ACTIONS(2031),
    [anon_sym_alignof] = ACTIONS(2031),
    [anon_sym__Alignof] = ACTIONS(2031),
    [anon_sym_offsetof] = ACTIONS(2031),
    [anon_sym__Generic] = ACTIONS(2031),
    [anon_sym_asm] = ACTIONS(2031),
    [anon_sym___asm__] = ACTIONS(2031),
    [anon_sym___asm] = ACTIONS(2031),
    [sym_number_literal] = ACTIONS(2033),
    [anon_sym_L_SQUOTE] = ACTIONS(2033),
    [anon_sym_u_SQUOTE] = ACTIONS(2033),
    [anon_sym_U_SQUOTE] = ACTIONS(2033),
    [anon_sym_u8_SQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [anon_sym_L_DQUOTE] = ACTIONS(2033),
    [anon_sym_u_DQUOTE] = ACTIONS(2033),
    [anon_sym_U_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8_DQUOTE] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [anon_sym_NULL] = ACTIONS(2031),
    [anon_sym_nullptr] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_export] = ACTIONS(2031),
    [anon_sym_module] = ACTIONS(2031),
    [anon_sym_import] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_concept] = ACTIONS(2031),
    [anon_sym_co_return] = ACTIONS(2031),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(2130),
    [anon_sym_R_DQUOTE] = ACTIONS(2033),
    [anon_sym_LR_DQUOTE] = ACTIONS(2033),
    [anon_sym_uR_DQUOTE] = ACTIONS(2033),
    [anon_sym_UR_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2033),
    [anon_sym_co_await] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_requires] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [anon_sym_discard] = ACTIONS(2031),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
    [anon_sym_cbuffer] = ACTIONS(2031),
  },
  [194] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_include_token1] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token2] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [aux_sym_preproc_else_token1] = ACTIONS(1947),
    [aux_sym_preproc_elif_token1] = ACTIONS(1947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym___cdecl] = ACTIONS(1947),
    [anon_sym___clrcall] = ACTIONS(1947),
    [anon_sym___stdcall] = ACTIONS(1947),
    [anon_sym___fastcall] = ACTIONS(1947),
    [anon_sym___thiscall] = ACTIONS(1947),
    [anon_sym___vectorcall] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_not] = ACTIONS(1947),
    [anon_sym_compl] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [anon_sym___asm] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1945),
    [anon_sym_L_SQUOTE] = ACTIONS(1945),
    [anon_sym_u_SQUOTE] = ACTIONS(1945),
    [anon_sym_U_SQUOTE] = ACTIONS(1945),
    [anon_sym_u8_SQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_concept] = ACTIONS(1947),
    [anon_sym_co_return] = ACTIONS(1947),
    [anon_sym_co_yield] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1945),
    [anon_sym_LR_DQUOTE] = ACTIONS(1945),
    [anon_sym_uR_DQUOTE] = ACTIONS(1945),
    [anon_sym_UR_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1945),
    [anon_sym_co_await] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_requires] = ACTIONS(1947),
    [sym_this] = ACTIONS(1947),
    [anon_sym_discard] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
    [anon_sym_cbuffer] = ACTIONS(1947),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [aux_sym_preproc_else_token1] = ACTIONS(1951),
    [aux_sym_preproc_elif_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [196] = {
    [sym_else_clause] = STATE(262),
    [sym_identifier] = ACTIONS(2133),
    [aux_sym_preproc_include_token1] = ACTIONS(2133),
    [aux_sym_preproc_def_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token2] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2133),
    [aux_sym_preproc_else_token1] = ACTIONS(2133),
    [aux_sym_preproc_elif_token1] = ACTIONS(2133),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2133),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2133),
    [sym_preproc_directive] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym___extension__] = ACTIONS(2133),
    [anon_sym_typedef] = ACTIONS(2133),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_out] = ACTIONS(2133),
    [anon_sym_inout] = ACTIONS(2133),
    [anon_sym_virtual] = ACTIONS(2133),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym___attribute__] = ACTIONS(2133),
    [anon_sym___attribute] = ACTIONS(2133),
    [anon_sym_using] = ACTIONS(2133),
    [anon_sym_COLON_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2135),
    [anon_sym___declspec] = ACTIONS(2133),
    [anon_sym___based] = ACTIONS(2133),
    [anon_sym___cdecl] = ACTIONS(2133),
    [anon_sym___clrcall] = ACTIONS(2133),
    [anon_sym___stdcall] = ACTIONS(2133),
    [anon_sym___fastcall] = ACTIONS(2133),
    [anon_sym___thiscall] = ACTIONS(2133),
    [anon_sym___vectorcall] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_signed] = ACTIONS(2133),
    [anon_sym_unsigned] = ACTIONS(2133),
    [anon_sym_long] = ACTIONS(2133),
    [anon_sym_short] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym___inline] = ACTIONS(2133),
    [anon_sym___inline__] = ACTIONS(2133),
    [anon_sym___forceinline] = ACTIONS(2133),
    [anon_sym_thread_local] = ACTIONS(2133),
    [anon_sym___thread] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_constexpr] = ACTIONS(2133),
    [anon_sym_volatile] = ACTIONS(2133),
    [anon_sym_restrict] = ACTIONS(2133),
    [anon_sym___restrict__] = ACTIONS(2133),
    [anon_sym__Atomic] = ACTIONS(2133),
    [anon_sym__Noreturn] = ACTIONS(2133),
    [anon_sym_noreturn] = ACTIONS(2133),
    [anon_sym__Nonnull] = ACTIONS(2133),
    [anon_sym_mutable] = ACTIONS(2133),
    [anon_sym_constinit] = ACTIONS(2133),
    [anon_sym_consteval] = ACTIONS(2133),
    [anon_sym_alignas] = ACTIONS(2133),
    [anon_sym__Alignas] = ACTIONS(2133),
    [sym_primitive_type] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2133),
    [anon_sym_union] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_goto] = ACTIONS(2133),
    [anon_sym___try] = ACTIONS(2133),
    [anon_sym___leave] = ACTIONS(2133),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_compl] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_sizeof] = ACTIONS(2133),
    [anon_sym___alignof__] = ACTIONS(2133),
    [anon_sym___alignof] = ACTIONS(2133),
    [anon_sym__alignof] = ACTIONS(2133),
    [anon_sym_alignof] = ACTIONS(2133),
    [anon_sym__Alignof] = ACTIONS(2133),
    [anon_sym_offsetof] = ACTIONS(2133),
    [anon_sym__Generic] = ACTIONS(2133),
    [anon_sym_asm] = ACTIONS(2133),
    [anon_sym___asm__] = ACTIONS(2133),
    [anon_sym___asm] = ACTIONS(2133),
    [sym_number_literal] = ACTIONS(2135),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2135),
    [anon_sym_u_DQUOTE] = ACTIONS(2135),
    [anon_sym_U_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [anon_sym_NULL] = ACTIONS(2133),
    [anon_sym_nullptr] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2133),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_explicit] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2133),
    [anon_sym_template] = ACTIONS(2133),
    [anon_sym_operator] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_static_assert] = ACTIONS(2133),
    [anon_sym_concept] = ACTIONS(2133),
    [anon_sym_co_return] = ACTIONS(2133),
    [anon_sym_co_yield] = ACTIONS(2133),
    [anon_sym_R_DQUOTE] = ACTIONS(2135),
    [anon_sym_LR_DQUOTE] = ACTIONS(2135),
    [anon_sym_uR_DQUOTE] = ACTIONS(2135),
    [anon_sym_UR_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2135),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_requires] = ACTIONS(2133),
    [sym_this] = ACTIONS(2133),
    [anon_sym_discard] = ACTIONS(2133),
    [anon_sym_precise] = ACTIONS(2133),
    [anon_sym_shared] = ACTIONS(2133),
    [anon_sym_groupshared] = ACTIONS(2133),
    [anon_sym_uniform] = ACTIONS(2133),
    [anon_sym_row_major] = ACTIONS(2133),
    [anon_sym_column_major] = ACTIONS(2133),
    [anon_sym_globallycoherent] = ACTIONS(2133),
    [anon_sym_centroid] = ACTIONS(2133),
    [anon_sym_noperspective] = ACTIONS(2133),
    [anon_sym_nointerpolation] = ACTIONS(2133),
    [anon_sym_sample] = ACTIONS(2133),
    [anon_sym_linear] = ACTIONS(2133),
    [anon_sym_snorm] = ACTIONS(2133),
    [anon_sym_unorm] = ACTIONS(2133),
    [anon_sym_point] = ACTIONS(2133),
    [anon_sym_line] = ACTIONS(2133),
    [anon_sym_triangleadj] = ACTIONS(2133),
    [anon_sym_lineadj] = ACTIONS(2133),
    [anon_sym_triangle] = ACTIONS(2133),
    [anon_sym_cbuffer] = ACTIONS(2133),
  },
  [197] = {
    [sym_else_clause] = STATE(213),
    [sym_identifier] = ACTIONS(2139),
    [aux_sym_preproc_include_token1] = ACTIONS(2139),
    [aux_sym_preproc_def_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token2] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2139),
    [aux_sym_preproc_else_token1] = ACTIONS(2139),
    [aux_sym_preproc_elif_token1] = ACTIONS(2139),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2139),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2139),
    [sym_preproc_directive] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_typedef] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_out] = ACTIONS(2139),
    [anon_sym_inout] = ACTIONS(2139),
    [anon_sym_virtual] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym___attribute] = ACTIONS(2139),
    [anon_sym_using] = ACTIONS(2139),
    [anon_sym_COLON_COLON] = ACTIONS(2141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2141),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_signed] = ACTIONS(2139),
    [anon_sym_unsigned] = ACTIONS(2139),
    [anon_sym_long] = ACTIONS(2139),
    [anon_sym_short] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym__Nonnull] = ACTIONS(2139),
    [anon_sym_mutable] = ACTIONS(2139),
    [anon_sym_constinit] = ACTIONS(2139),
    [anon_sym_consteval] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [sym_primitive_type] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_struct] = ACTIONS(2139),
    [anon_sym_union] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_goto] = ACTIONS(2139),
    [anon_sym___try] = ACTIONS(2139),
    [anon_sym___leave] = ACTIONS(2139),
    [anon_sym_not] = ACTIONS(2139),
    [anon_sym_compl] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_sizeof] = ACTIONS(2139),
    [anon_sym___alignof__] = ACTIONS(2139),
    [anon_sym___alignof] = ACTIONS(2139),
    [anon_sym__alignof] = ACTIONS(2139),
    [anon_sym_alignof] = ACTIONS(2139),
    [anon_sym__Alignof] = ACTIONS(2139),
    [anon_sym_offsetof] = ACTIONS(2139),
    [anon_sym__Generic] = ACTIONS(2139),
    [anon_sym_asm] = ACTIONS(2139),
    [anon_sym___asm__] = ACTIONS(2139),
    [anon_sym___asm] = ACTIONS(2139),
    [sym_number_literal] = ACTIONS(2141),
    [anon_sym_L_SQUOTE] = ACTIONS(2141),
    [anon_sym_u_SQUOTE] = ACTIONS(2141),
    [anon_sym_U_SQUOTE] = ACTIONS(2141),
    [anon_sym_u8_SQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(2141),
    [anon_sym_u_DQUOTE] = ACTIONS(2141),
    [anon_sym_U_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8_DQUOTE] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [anon_sym_NULL] = ACTIONS(2139),
    [anon_sym_nullptr] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2139),
    [anon_sym_decltype] = ACTIONS(2139),
    [anon_sym_explicit] = ACTIONS(2139),
    [anon_sym_typename] = ACTIONS(2139),
    [anon_sym_template] = ACTIONS(2139),
    [anon_sym_operator] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_static_assert] = ACTIONS(2139),
    [anon_sym_concept] = ACTIONS(2139),
    [anon_sym_co_return] = ACTIONS(2139),
    [anon_sym_co_yield] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2139),
    [anon_sym_discard] = ACTIONS(2139),
    [anon_sym_precise] = ACTIONS(2139),
    [anon_sym_shared] = ACTIONS(2139),
    [anon_sym_groupshared] = ACTIONS(2139),
    [anon_sym_uniform] = ACTIONS(2139),
    [anon_sym_row_major] = ACTIONS(2139),
    [anon_sym_column_major] = ACTIONS(2139),
    [anon_sym_globallycoherent] = ACTIONS(2139),
    [anon_sym_centroid] = ACTIONS(2139),
    [anon_sym_noperspective] = ACTIONS(2139),
    [anon_sym_nointerpolation] = ACTIONS(2139),
    [anon_sym_sample] = ACTIONS(2139),
    [anon_sym_linear] = ACTIONS(2139),
    [anon_sym_snorm] = ACTIONS(2139),
    [anon_sym_unorm] = ACTIONS(2139),
    [anon_sym_point] = ACTIONS(2139),
    [anon_sym_line] = ACTIONS(2139),
    [anon_sym_triangleadj] = ACTIONS(2139),
    [anon_sym_lineadj] = ACTIONS(2139),
    [anon_sym_triangle] = ACTIONS(2139),
    [anon_sym_cbuffer] = ACTIONS(2139),
  },
  [198] = {
    [sym_template_argument_list] = STATE(291),
    [sym_identifier] = ACTIONS(1997),
    [aux_sym_preproc_include_token1] = ACTIONS(1997),
    [aux_sym_preproc_def_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1997),
    [sym_preproc_directive] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_using] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1997),
    [anon_sym_compl] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [anon_sym___asm] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1999),
    [anon_sym_L_SQUOTE] = ACTIONS(1999),
    [anon_sym_u_SQUOTE] = ACTIONS(1999),
    [anon_sym_U_SQUOTE] = ACTIONS(1999),
    [anon_sym_u8_SQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_L_DQUOTE] = ACTIONS(1999),
    [anon_sym_u_DQUOTE] = ACTIONS(1999),
    [anon_sym_U_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8_DQUOTE] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_explicit] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_static_assert] = ACTIONS(1997),
    [anon_sym_concept] = ACTIONS(1997),
    [anon_sym_co_return] = ACTIONS(1997),
    [anon_sym_co_yield] = ACTIONS(1997),
    [anon_sym_R_DQUOTE] = ACTIONS(1999),
    [anon_sym_LR_DQUOTE] = ACTIONS(1999),
    [anon_sym_uR_DQUOTE] = ACTIONS(1999),
    [anon_sym_UR_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1999),
    [anon_sym_co_await] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [sym_this] = ACTIONS(1997),
    [anon_sym_discard] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
    [anon_sym_cbuffer] = ACTIONS(1997),
  },
  [199] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_include_token1] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token2] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [aux_sym_preproc_else_token1] = ACTIONS(2145),
    [aux_sym_preproc_elif_token1] = ACTIONS(2145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym___cdecl] = ACTIONS(2145),
    [anon_sym___clrcall] = ACTIONS(2145),
    [anon_sym___stdcall] = ACTIONS(2145),
    [anon_sym___fastcall] = ACTIONS(2145),
    [anon_sym___thiscall] = ACTIONS(2145),
    [anon_sym___vectorcall] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_goto] = ACTIONS(2145),
    [anon_sym___try] = ACTIONS(2145),
    [anon_sym___leave] = ACTIONS(2145),
    [anon_sym_not] = ACTIONS(2145),
    [anon_sym_compl] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2145),
    [anon_sym___alignof__] = ACTIONS(2145),
    [anon_sym___alignof] = ACTIONS(2145),
    [anon_sym__alignof] = ACTIONS(2145),
    [anon_sym_alignof] = ACTIONS(2145),
    [anon_sym__Alignof] = ACTIONS(2145),
    [anon_sym_offsetof] = ACTIONS(2145),
    [anon_sym__Generic] = ACTIONS(2145),
    [anon_sym_asm] = ACTIONS(2145),
    [anon_sym___asm__] = ACTIONS(2145),
    [anon_sym___asm] = ACTIONS(2145),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [anon_sym_NULL] = ACTIONS(2145),
    [anon_sym_nullptr] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_concept] = ACTIONS(2145),
    [anon_sym_co_return] = ACTIONS(2145),
    [anon_sym_co_yield] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_R_DQUOTE] = ACTIONS(2147),
    [anon_sym_LR_DQUOTE] = ACTIONS(2147),
    [anon_sym_uR_DQUOTE] = ACTIONS(2147),
    [anon_sym_UR_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2147),
    [anon_sym_co_await] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_discard] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
    [anon_sym_cbuffer] = ACTIONS(2145),
  },
  [200] = {
    [sym_template_argument_list] = STATE(316),
    [sym_identifier] = ACTIONS(2005),
    [aux_sym_preproc_include_token1] = ACTIONS(2005),
    [aux_sym_preproc_def_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token2] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2005),
    [sym_preproc_directive] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_typedef] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_using] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_goto] = ACTIONS(2005),
    [anon_sym___try] = ACTIONS(2005),
    [anon_sym___leave] = ACTIONS(2005),
    [anon_sym_not] = ACTIONS(2005),
    [anon_sym_compl] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_sizeof] = ACTIONS(2005),
    [anon_sym___alignof__] = ACTIONS(2005),
    [anon_sym___alignof] = ACTIONS(2005),
    [anon_sym__alignof] = ACTIONS(2005),
    [anon_sym_alignof] = ACTIONS(2005),
    [anon_sym__Alignof] = ACTIONS(2005),
    [anon_sym_offsetof] = ACTIONS(2005),
    [anon_sym__Generic] = ACTIONS(2005),
    [anon_sym_asm] = ACTIONS(2005),
    [anon_sym___asm__] = ACTIONS(2005),
    [anon_sym___asm] = ACTIONS(2005),
    [sym_number_literal] = ACTIONS(2007),
    [anon_sym_L_SQUOTE] = ACTIONS(2007),
    [anon_sym_u_SQUOTE] = ACTIONS(2007),
    [anon_sym_U_SQUOTE] = ACTIONS(2007),
    [anon_sym_u8_SQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_L_DQUOTE] = ACTIONS(2007),
    [anon_sym_u_DQUOTE] = ACTIONS(2007),
    [anon_sym_U_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8_DQUOTE] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [anon_sym_NULL] = ACTIONS(2005),
    [anon_sym_nullptr] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_explicit] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_static_assert] = ACTIONS(2005),
    [anon_sym_concept] = ACTIONS(2005),
    [anon_sym_co_return] = ACTIONS(2005),
    [anon_sym_co_yield] = ACTIONS(2005),
    [anon_sym_R_DQUOTE] = ACTIONS(2007),
    [anon_sym_LR_DQUOTE] = ACTIONS(2007),
    [anon_sym_uR_DQUOTE] = ACTIONS(2007),
    [anon_sym_UR_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2007),
    [anon_sym_co_await] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [sym_this] = ACTIONS(2005),
    [anon_sym_discard] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
    [anon_sym_cbuffer] = ACTIONS(2005),
  },
  [201] = {
    [sym_template_argument_list] = STATE(316),
    [sym_identifier] = ACTIONS(1997),
    [aux_sym_preproc_include_token1] = ACTIONS(1997),
    [aux_sym_preproc_def_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token1] = ACTIONS(1997),
    [aux_sym_preproc_if_token2] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1997),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1997),
    [sym_preproc_directive] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(2149),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_using] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_case] = ACTIONS(1997),
    [anon_sym_default] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1997),
    [anon_sym_compl] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [anon_sym___asm] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1999),
    [anon_sym_L_SQUOTE] = ACTIONS(1999),
    [anon_sym_u_SQUOTE] = ACTIONS(1999),
    [anon_sym_U_SQUOTE] = ACTIONS(1999),
    [anon_sym_u8_SQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_L_DQUOTE] = ACTIONS(1999),
    [anon_sym_u_DQUOTE] = ACTIONS(1999),
    [anon_sym_U_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8_DQUOTE] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_explicit] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_namespace] = ACTIONS(1997),
    [anon_sym_static_assert] = ACTIONS(1997),
    [anon_sym_concept] = ACTIONS(1997),
    [anon_sym_co_return] = ACTIONS(1997),
    [anon_sym_co_yield] = ACTIONS(1997),
    [anon_sym_R_DQUOTE] = ACTIONS(1999),
    [anon_sym_LR_DQUOTE] = ACTIONS(1999),
    [anon_sym_uR_DQUOTE] = ACTIONS(1999),
    [anon_sym_UR_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1999),
    [anon_sym_co_await] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [sym_this] = ACTIONS(1997),
    [anon_sym_discard] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
    [anon_sym_cbuffer] = ACTIONS(1997),
  },
  [202] = {
    [sym_template_argument_list] = STATE(291),
    [sym_identifier] = ACTIONS(2005),
    [aux_sym_preproc_include_token1] = ACTIONS(2005),
    [aux_sym_preproc_def_token1] = ACTIONS(2005),
    [aux_sym_preproc_if_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2005),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2005),
    [sym_preproc_directive] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_typedef] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_using] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2005),
    [anon_sym_default] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_goto] = ACTIONS(2005),
    [anon_sym___try] = ACTIONS(2005),
    [anon_sym___leave] = ACTIONS(2005),
    [anon_sym_not] = ACTIONS(2005),
    [anon_sym_compl] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_sizeof] = ACTIONS(2005),
    [anon_sym___alignof__] = ACTIONS(2005),
    [anon_sym___alignof] = ACTIONS(2005),
    [anon_sym__alignof] = ACTIONS(2005),
    [anon_sym_alignof] = ACTIONS(2005),
    [anon_sym__Alignof] = ACTIONS(2005),
    [anon_sym_offsetof] = ACTIONS(2005),
    [anon_sym__Generic] = ACTIONS(2005),
    [anon_sym_asm] = ACTIONS(2005),
    [anon_sym___asm__] = ACTIONS(2005),
    [anon_sym___asm] = ACTIONS(2005),
    [sym_number_literal] = ACTIONS(2007),
    [anon_sym_L_SQUOTE] = ACTIONS(2007),
    [anon_sym_u_SQUOTE] = ACTIONS(2007),
    [anon_sym_U_SQUOTE] = ACTIONS(2007),
    [anon_sym_u8_SQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_L_DQUOTE] = ACTIONS(2007),
    [anon_sym_u_DQUOTE] = ACTIONS(2007),
    [anon_sym_U_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8_DQUOTE] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [anon_sym_NULL] = ACTIONS(2005),
    [anon_sym_nullptr] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_explicit] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_namespace] = ACTIONS(2005),
    [anon_sym_static_assert] = ACTIONS(2005),
    [anon_sym_concept] = ACTIONS(2005),
    [anon_sym_co_return] = ACTIONS(2005),
    [anon_sym_co_yield] = ACTIONS(2005),
    [anon_sym_R_DQUOTE] = ACTIONS(2007),
    [anon_sym_LR_DQUOTE] = ACTIONS(2007),
    [anon_sym_uR_DQUOTE] = ACTIONS(2007),
    [anon_sym_UR_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2007),
    [anon_sym_co_await] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [sym_this] = ACTIONS(2005),
    [anon_sym_discard] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
    [anon_sym_cbuffer] = ACTIONS(2005),
  },
  [203] = {
    [sym_else_clause] = STATE(225),
    [sym_identifier] = ACTIONS(2151),
    [aux_sym_preproc_include_token1] = ACTIONS(2151),
    [aux_sym_preproc_def_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2151),
    [aux_sym_preproc_else_token1] = ACTIONS(2151),
    [aux_sym_preproc_elif_token1] = ACTIONS(2151),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2151),
    [sym_preproc_directive] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AMP_AMP] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_typedef] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_out] = ACTIONS(2151),
    [anon_sym_inout] = ACTIONS(2151),
    [anon_sym_virtual] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym___attribute] = ACTIONS(2151),
    [anon_sym_using] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym___based] = ACTIONS(2151),
    [anon_sym___cdecl] = ACTIONS(2151),
    [anon_sym___clrcall] = ACTIONS(2151),
    [anon_sym___stdcall] = ACTIONS(2151),
    [anon_sym___fastcall] = ACTIONS(2151),
    [anon_sym___thiscall] = ACTIONS(2151),
    [anon_sym___vectorcall] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [anon_sym__Nonnull] = ACTIONS(2151),
    [anon_sym_mutable] = ACTIONS(2151),
    [anon_sym_constinit] = ACTIONS(2151),
    [anon_sym_consteval] = ACTIONS(2151),
    [anon_sym_alignas] = ACTIONS(2151),
    [anon_sym__Alignas] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2137),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_goto] = ACTIONS(2151),
    [anon_sym___try] = ACTIONS(2151),
    [anon_sym___leave] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_compl] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_sizeof] = ACTIONS(2151),
    [anon_sym___alignof__] = ACTIONS(2151),
    [anon_sym___alignof] = ACTIONS(2151),
    [anon_sym__alignof] = ACTIONS(2151),
    [anon_sym_alignof] = ACTIONS(2151),
    [anon_sym__Alignof] = ACTIONS(2151),
    [anon_sym_offsetof] = ACTIONS(2151),
    [anon_sym__Generic] = ACTIONS(2151),
    [anon_sym_asm] = ACTIONS(2151),
    [anon_sym___asm__] = ACTIONS(2151),
    [anon_sym___asm] = ACTIONS(2151),
    [sym_number_literal] = ACTIONS(2153),
    [anon_sym_L_SQUOTE] = ACTIONS(2153),
    [anon_sym_u_SQUOTE] = ACTIONS(2153),
    [anon_sym_U_SQUOTE] = ACTIONS(2153),
    [anon_sym_u8_SQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [anon_sym_L_DQUOTE] = ACTIONS(2153),
    [anon_sym_u_DQUOTE] = ACTIONS(2153),
    [anon_sym_U_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8_DQUOTE] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [anon_sym_NULL] = ACTIONS(2151),
    [anon_sym_nullptr] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2151),
    [anon_sym_decltype] = ACTIONS(2151),
    [anon_sym_explicit] = ACTIONS(2151),
    [anon_sym_typename] = ACTIONS(2151),
    [anon_sym_template] = ACTIONS(2151),
    [anon_sym_operator] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_static_assert] = ACTIONS(2151),
    [anon_sym_concept] = ACTIONS(2151),
    [anon_sym_co_return] = ACTIONS(2151),
    [anon_sym_co_yield] = ACTIONS(2151),
    [anon_sym_R_DQUOTE] = ACTIONS(2153),
    [anon_sym_LR_DQUOTE] = ACTIONS(2153),
    [anon_sym_uR_DQUOTE] = ACTIONS(2153),
    [anon_sym_UR_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2153),
    [anon_sym_co_await] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_requires] = ACTIONS(2151),
    [sym_this] = ACTIONS(2151),
    [anon_sym_discard] = ACTIONS(2151),
    [anon_sym_precise] = ACTIONS(2151),
    [anon_sym_shared] = ACTIONS(2151),
    [anon_sym_groupshared] = ACTIONS(2151),
    [anon_sym_uniform] = ACTIONS(2151),
    [anon_sym_row_major] = ACTIONS(2151),
    [anon_sym_column_major] = ACTIONS(2151),
    [anon_sym_globallycoherent] = ACTIONS(2151),
    [anon_sym_centroid] = ACTIONS(2151),
    [anon_sym_noperspective] = ACTIONS(2151),
    [anon_sym_nointerpolation] = ACTIONS(2151),
    [anon_sym_sample] = ACTIONS(2151),
    [anon_sym_linear] = ACTIONS(2151),
    [anon_sym_snorm] = ACTIONS(2151),
    [anon_sym_unorm] = ACTIONS(2151),
    [anon_sym_point] = ACTIONS(2151),
    [anon_sym_line] = ACTIONS(2151),
    [anon_sym_triangleadj] = ACTIONS(2151),
    [anon_sym_lineadj] = ACTIONS(2151),
    [anon_sym_triangle] = ACTIONS(2151),
    [anon_sym_cbuffer] = ACTIONS(2151),
  },
  [204] = {
    [sym_identifier] = ACTIONS(2155),
    [aux_sym_preproc_include_token1] = ACTIONS(2155),
    [aux_sym_preproc_def_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token2] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2155),
    [aux_sym_preproc_else_token1] = ACTIONS(2155),
    [aux_sym_preproc_elif_token1] = ACTIONS(2155),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2155),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2155),
    [sym_preproc_directive] = ACTIONS(2155),
    [anon_sym_LPAREN2] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym___extension__] = ACTIONS(2155),
    [anon_sym_typedef] = ACTIONS(2155),
    [anon_sym_in] = ACTIONS(2155),
    [anon_sym_out] = ACTIONS(2155),
    [anon_sym_inout] = ACTIONS(2155),
    [anon_sym_virtual] = ACTIONS(2155),
    [anon_sym_extern] = ACTIONS(2155),
    [anon_sym___attribute__] = ACTIONS(2155),
    [anon_sym___attribute] = ACTIONS(2155),
    [anon_sym_using] = ACTIONS(2155),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2157),
    [anon_sym___declspec] = ACTIONS(2155),
    [anon_sym___based] = ACTIONS(2155),
    [anon_sym___cdecl] = ACTIONS(2155),
    [anon_sym___clrcall] = ACTIONS(2155),
    [anon_sym___stdcall] = ACTIONS(2155),
    [anon_sym___fastcall] = ACTIONS(2155),
    [anon_sym___thiscall] = ACTIONS(2155),
    [anon_sym___vectorcall] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_signed] = ACTIONS(2155),
    [anon_sym_unsigned] = ACTIONS(2155),
    [anon_sym_long] = ACTIONS(2155),
    [anon_sym_short] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_register] = ACTIONS(2155),
    [anon_sym_inline] = ACTIONS(2155),
    [anon_sym___inline] = ACTIONS(2155),
    [anon_sym___inline__] = ACTIONS(2155),
    [anon_sym___forceinline] = ACTIONS(2155),
    [anon_sym_thread_local] = ACTIONS(2155),
    [anon_sym___thread] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_constexpr] = ACTIONS(2155),
    [anon_sym_volatile] = ACTIONS(2155),
    [anon_sym_restrict] = ACTIONS(2155),
    [anon_sym___restrict__] = ACTIONS(2155),
    [anon_sym__Atomic] = ACTIONS(2155),
    [anon_sym__Noreturn] = ACTIONS(2155),
    [anon_sym_noreturn] = ACTIONS(2155),
    [anon_sym__Nonnull] = ACTIONS(2155),
    [anon_sym_mutable] = ACTIONS(2155),
    [anon_sym_constinit] = ACTIONS(2155),
    [anon_sym_consteval] = ACTIONS(2155),
    [anon_sym_alignas] = ACTIONS(2155),
    [anon_sym__Alignas] = ACTIONS(2155),
    [sym_primitive_type] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_struct] = ACTIONS(2155),
    [anon_sym_union] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2155),
    [anon_sym_default] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_goto] = ACTIONS(2155),
    [anon_sym___try] = ACTIONS(2155),
    [anon_sym___leave] = ACTIONS(2155),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_compl] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_sizeof] = ACTIONS(2155),
    [anon_sym___alignof__] = ACTIONS(2155),
    [anon_sym___alignof] = ACTIONS(2155),
    [anon_sym__alignof] = ACTIONS(2155),
    [anon_sym_alignof] = ACTIONS(2155),
    [anon_sym__Alignof] = ACTIONS(2155),
    [anon_sym_offsetof] = ACTIONS(2155),
    [anon_sym__Generic] = ACTIONS(2155),
    [anon_sym_asm] = ACTIONS(2155),
    [anon_sym___asm__] = ACTIONS(2155),
    [anon_sym___asm] = ACTIONS(2155),
    [sym_number_literal] = ACTIONS(2157),
    [anon_sym_L_SQUOTE] = ACTIONS(2157),
    [anon_sym_u_SQUOTE] = ACTIONS(2157),
    [anon_sym_U_SQUOTE] = ACTIONS(2157),
    [anon_sym_u8_SQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [anon_sym_L_DQUOTE] = ACTIONS(2157),
    [anon_sym_u_DQUOTE] = ACTIONS(2157),
    [anon_sym_U_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8_DQUOTE] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [anon_sym_NULL] = ACTIONS(2155),
    [anon_sym_nullptr] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2155),
    [anon_sym_decltype] = ACTIONS(2155),
    [anon_sym_explicit] = ACTIONS(2155),
    [anon_sym_typename] = ACTIONS(2155),
    [anon_sym_template] = ACTIONS(2155),
    [anon_sym_operator] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_static_assert] = ACTIONS(2155),
    [anon_sym_concept] = ACTIONS(2155),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2155),
    [anon_sym_R_DQUOTE] = ACTIONS(2157),
    [anon_sym_LR_DQUOTE] = ACTIONS(2157),
    [anon_sym_uR_DQUOTE] = ACTIONS(2157),
    [anon_sym_UR_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2157),
    [anon_sym_co_await] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_requires] = ACTIONS(2155),
    [sym_this] = ACTIONS(2155),
    [anon_sym_discard] = ACTIONS(2155),
    [anon_sym_precise] = ACTIONS(2155),
    [anon_sym_shared] = ACTIONS(2155),
    [anon_sym_groupshared] = ACTIONS(2155),
    [anon_sym_uniform] = ACTIONS(2155),
    [anon_sym_row_major] = ACTIONS(2155),
    [anon_sym_column_major] = ACTIONS(2155),
    [anon_sym_globallycoherent] = ACTIONS(2155),
    [anon_sym_centroid] = ACTIONS(2155),
    [anon_sym_noperspective] = ACTIONS(2155),
    [anon_sym_nointerpolation] = ACTIONS(2155),
    [anon_sym_sample] = ACTIONS(2155),
    [anon_sym_linear] = ACTIONS(2155),
    [anon_sym_snorm] = ACTIONS(2155),
    [anon_sym_unorm] = ACTIONS(2155),
    [anon_sym_point] = ACTIONS(2155),
    [anon_sym_line] = ACTIONS(2155),
    [anon_sym_triangleadj] = ACTIONS(2155),
    [anon_sym_lineadj] = ACTIONS(2155),
    [anon_sym_triangle] = ACTIONS(2155),
    [anon_sym_cbuffer] = ACTIONS(2155),
  },
  [205] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [aux_sym_preproc_else_token1] = ACTIONS(2159),
    [aux_sym_preproc_elif_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [206] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [aux_sym_preproc_else_token1] = ACTIONS(2159),
    [aux_sym_preproc_elif_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [207] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_include_token1] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token2] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [aux_sym_preproc_else_token1] = ACTIONS(2163),
    [aux_sym_preproc_elif_token1] = ACTIONS(2163),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym___cdecl] = ACTIONS(2163),
    [anon_sym___clrcall] = ACTIONS(2163),
    [anon_sym___stdcall] = ACTIONS(2163),
    [anon_sym___fastcall] = ACTIONS(2163),
    [anon_sym___thiscall] = ACTIONS(2163),
    [anon_sym___vectorcall] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_goto] = ACTIONS(2163),
    [anon_sym___try] = ACTIONS(2163),
    [anon_sym___leave] = ACTIONS(2163),
    [anon_sym_not] = ACTIONS(2163),
    [anon_sym_compl] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_sizeof] = ACTIONS(2163),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2163),
    [anon_sym__Generic] = ACTIONS(2163),
    [anon_sym_asm] = ACTIONS(2163),
    [anon_sym___asm__] = ACTIONS(2163),
    [anon_sym___asm] = ACTIONS(2163),
    [sym_number_literal] = ACTIONS(2165),
    [anon_sym_L_SQUOTE] = ACTIONS(2165),
    [anon_sym_u_SQUOTE] = ACTIONS(2165),
    [anon_sym_U_SQUOTE] = ACTIONS(2165),
    [anon_sym_u8_SQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [anon_sym_L_DQUOTE] = ACTIONS(2165),
    [anon_sym_u_DQUOTE] = ACTIONS(2165),
    [anon_sym_U_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8_DQUOTE] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [anon_sym_NULL] = ACTIONS(2163),
    [anon_sym_nullptr] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_concept] = ACTIONS(2163),
    [anon_sym_co_return] = ACTIONS(2163),
    [anon_sym_co_yield] = ACTIONS(2163),
    [anon_sym_R_DQUOTE] = ACTIONS(2165),
    [anon_sym_LR_DQUOTE] = ACTIONS(2165),
    [anon_sym_uR_DQUOTE] = ACTIONS(2165),
    [anon_sym_UR_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2165),
    [anon_sym_co_await] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_requires] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [anon_sym_discard] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
    [anon_sym_cbuffer] = ACTIONS(2163),
  },
  [208] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_include_token1] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token2] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [aux_sym_preproc_else_token1] = ACTIONS(2167),
    [aux_sym_preproc_elif_token1] = ACTIONS(2167),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym___cdecl] = ACTIONS(2167),
    [anon_sym___clrcall] = ACTIONS(2167),
    [anon_sym___stdcall] = ACTIONS(2167),
    [anon_sym___fastcall] = ACTIONS(2167),
    [anon_sym___thiscall] = ACTIONS(2167),
    [anon_sym___vectorcall] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_goto] = ACTIONS(2167),
    [anon_sym___try] = ACTIONS(2167),
    [anon_sym___leave] = ACTIONS(2167),
    [anon_sym_not] = ACTIONS(2167),
    [anon_sym_compl] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2167),
    [anon_sym___alignof__] = ACTIONS(2167),
    [anon_sym___alignof] = ACTIONS(2167),
    [anon_sym__alignof] = ACTIONS(2167),
    [anon_sym_alignof] = ACTIONS(2167),
    [anon_sym__Alignof] = ACTIONS(2167),
    [anon_sym_offsetof] = ACTIONS(2167),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2167),
    [anon_sym___asm__] = ACTIONS(2167),
    [anon_sym___asm] = ACTIONS(2167),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [anon_sym_NULL] = ACTIONS(2167),
    [anon_sym_nullptr] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_concept] = ACTIONS(2167),
    [anon_sym_co_return] = ACTIONS(2167),
    [anon_sym_co_yield] = ACTIONS(2167),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [anon_sym_discard] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
    [anon_sym_cbuffer] = ACTIONS(2167),
  },
  [209] = {
    [sym_identifier] = ACTIONS(2171),
    [aux_sym_preproc_include_token1] = ACTIONS(2171),
    [aux_sym_preproc_def_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token2] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2171),
    [aux_sym_preproc_else_token1] = ACTIONS(2171),
    [aux_sym_preproc_elif_token1] = ACTIONS(2171),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2171),
    [sym_preproc_directive] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2171),
    [anon_sym_typedef] = ACTIONS(2171),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_out] = ACTIONS(2171),
    [anon_sym_inout] = ACTIONS(2171),
    [anon_sym_virtual] = ACTIONS(2171),
    [anon_sym_extern] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2171),
    [anon_sym___attribute] = ACTIONS(2171),
    [anon_sym_using] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2171),
    [anon_sym___based] = ACTIONS(2171),
    [anon_sym___cdecl] = ACTIONS(2171),
    [anon_sym___clrcall] = ACTIONS(2171),
    [anon_sym___stdcall] = ACTIONS(2171),
    [anon_sym___fastcall] = ACTIONS(2171),
    [anon_sym___thiscall] = ACTIONS(2171),
    [anon_sym___vectorcall] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_signed] = ACTIONS(2171),
    [anon_sym_unsigned] = ACTIONS(2171),
    [anon_sym_long] = ACTIONS(2171),
    [anon_sym_short] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_register] = ACTIONS(2171),
    [anon_sym_inline] = ACTIONS(2171),
    [anon_sym___inline] = ACTIONS(2171),
    [anon_sym___inline__] = ACTIONS(2171),
    [anon_sym___forceinline] = ACTIONS(2171),
    [anon_sym_thread_local] = ACTIONS(2171),
    [anon_sym___thread] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_constexpr] = ACTIONS(2171),
    [anon_sym_volatile] = ACTIONS(2171),
    [anon_sym_restrict] = ACTIONS(2171),
    [anon_sym___restrict__] = ACTIONS(2171),
    [anon_sym__Atomic] = ACTIONS(2171),
    [anon_sym__Noreturn] = ACTIONS(2171),
    [anon_sym_noreturn] = ACTIONS(2171),
    [anon_sym__Nonnull] = ACTIONS(2171),
    [anon_sym_mutable] = ACTIONS(2171),
    [anon_sym_constinit] = ACTIONS(2171),
    [anon_sym_consteval] = ACTIONS(2171),
    [anon_sym_alignas] = ACTIONS(2171),
    [anon_sym__Alignas] = ACTIONS(2171),
    [sym_primitive_type] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_struct] = ACTIONS(2171),
    [anon_sym_union] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2171),
    [anon_sym_default] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_goto] = ACTIONS(2171),
    [anon_sym___try] = ACTIONS(2171),
    [anon_sym___leave] = ACTIONS(2171),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_compl] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2171),
    [anon_sym___alignof__] = ACTIONS(2171),
    [anon_sym___alignof] = ACTIONS(2171),
    [anon_sym__alignof] = ACTIONS(2171),
    [anon_sym_alignof] = ACTIONS(2171),
    [anon_sym__Alignof] = ACTIONS(2171),
    [anon_sym_offsetof] = ACTIONS(2171),
    [anon_sym__Generic] = ACTIONS(2171),
    [anon_sym_asm] = ACTIONS(2171),
    [anon_sym___asm__] = ACTIONS(2171),
    [anon_sym___asm] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2173),
    [anon_sym_u_SQUOTE] = ACTIONS(2173),
    [anon_sym_U_SQUOTE] = ACTIONS(2173),
    [anon_sym_u8_SQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_L_DQUOTE] = ACTIONS(2173),
    [anon_sym_u_DQUOTE] = ACTIONS(2173),
    [anon_sym_U_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8_DQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [anon_sym_NULL] = ACTIONS(2171),
    [anon_sym_nullptr] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2171),
    [anon_sym_decltype] = ACTIONS(2171),
    [anon_sym_explicit] = ACTIONS(2171),
    [anon_sym_typename] = ACTIONS(2171),
    [anon_sym_template] = ACTIONS(2171),
    [anon_sym_operator] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_static_assert] = ACTIONS(2171),
    [anon_sym_concept] = ACTIONS(2171),
    [anon_sym_co_return] = ACTIONS(2171),
    [anon_sym_co_yield] = ACTIONS(2171),
    [anon_sym_R_DQUOTE] = ACTIONS(2173),
    [anon_sym_LR_DQUOTE] = ACTIONS(2173),
    [anon_sym_uR_DQUOTE] = ACTIONS(2173),
    [anon_sym_UR_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2173),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_requires] = ACTIONS(2171),
    [sym_this] = ACTIONS(2171),
    [anon_sym_discard] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2171),
    [anon_sym_shared] = ACTIONS(2171),
    [anon_sym_groupshared] = ACTIONS(2171),
    [anon_sym_uniform] = ACTIONS(2171),
    [anon_sym_row_major] = ACTIONS(2171),
    [anon_sym_column_major] = ACTIONS(2171),
    [anon_sym_globallycoherent] = ACTIONS(2171),
    [anon_sym_centroid] = ACTIONS(2171),
    [anon_sym_noperspective] = ACTIONS(2171),
    [anon_sym_nointerpolation] = ACTIONS(2171),
    [anon_sym_sample] = ACTIONS(2171),
    [anon_sym_linear] = ACTIONS(2171),
    [anon_sym_snorm] = ACTIONS(2171),
    [anon_sym_unorm] = ACTIONS(2171),
    [anon_sym_point] = ACTIONS(2171),
    [anon_sym_line] = ACTIONS(2171),
    [anon_sym_triangleadj] = ACTIONS(2171),
    [anon_sym_lineadj] = ACTIONS(2171),
    [anon_sym_triangle] = ACTIONS(2171),
    [anon_sym_cbuffer] = ACTIONS(2171),
  },
  [210] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [211] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_include_token1] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token2] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [aux_sym_preproc_else_token1] = ACTIONS(2214),
    [aux_sym_preproc_elif_token1] = ACTIONS(2214),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_AMP_AMP] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_virtual] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym___attribute] = ACTIONS(2214),
    [anon_sym_using] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym___based] = ACTIONS(2214),
    [anon_sym___cdecl] = ACTIONS(2214),
    [anon_sym___clrcall] = ACTIONS(2214),
    [anon_sym___stdcall] = ACTIONS(2214),
    [anon_sym___fastcall] = ACTIONS(2214),
    [anon_sym___thiscall] = ACTIONS(2214),
    [anon_sym___vectorcall] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym__Nonnull] = ACTIONS(2214),
    [anon_sym_mutable] = ACTIONS(2214),
    [anon_sym_constinit] = ACTIONS(2214),
    [anon_sym_consteval] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_goto] = ACTIONS(2214),
    [anon_sym___try] = ACTIONS(2214),
    [anon_sym___leave] = ACTIONS(2214),
    [anon_sym_not] = ACTIONS(2214),
    [anon_sym_compl] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2214),
    [anon_sym___alignof__] = ACTIONS(2214),
    [anon_sym___alignof] = ACTIONS(2214),
    [anon_sym__alignof] = ACTIONS(2214),
    [anon_sym_alignof] = ACTIONS(2214),
    [anon_sym__Alignof] = ACTIONS(2214),
    [anon_sym_offsetof] = ACTIONS(2214),
    [anon_sym__Generic] = ACTIONS(2214),
    [anon_sym_asm] = ACTIONS(2214),
    [anon_sym___asm__] = ACTIONS(2214),
    [anon_sym___asm] = ACTIONS(2214),
    [sym_number_literal] = ACTIONS(2216),
    [anon_sym_L_SQUOTE] = ACTIONS(2216),
    [anon_sym_u_SQUOTE] = ACTIONS(2216),
    [anon_sym_U_SQUOTE] = ACTIONS(2216),
    [anon_sym_u8_SQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_L_DQUOTE] = ACTIONS(2216),
    [anon_sym_u_DQUOTE] = ACTIONS(2216),
    [anon_sym_U_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8_DQUOTE] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [anon_sym_NULL] = ACTIONS(2214),
    [anon_sym_nullptr] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2214),
    [anon_sym_decltype] = ACTIONS(2214),
    [anon_sym_explicit] = ACTIONS(2214),
    [anon_sym_typename] = ACTIONS(2214),
    [anon_sym_template] = ACTIONS(2214),
    [anon_sym_operator] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_static_assert] = ACTIONS(2214),
    [anon_sym_concept] = ACTIONS(2214),
    [anon_sym_co_return] = ACTIONS(2214),
    [anon_sym_co_yield] = ACTIONS(2214),
    [anon_sym_R_DQUOTE] = ACTIONS(2216),
    [anon_sym_LR_DQUOTE] = ACTIONS(2216),
    [anon_sym_uR_DQUOTE] = ACTIONS(2216),
    [anon_sym_UR_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2216),
    [anon_sym_co_await] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_requires] = ACTIONS(2214),
    [sym_this] = ACTIONS(2214),
    [anon_sym_discard] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_groupshared] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_row_major] = ACTIONS(2214),
    [anon_sym_column_major] = ACTIONS(2214),
    [anon_sym_globallycoherent] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym_nointerpolation] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_linear] = ACTIONS(2214),
    [anon_sym_snorm] = ACTIONS(2214),
    [anon_sym_unorm] = ACTIONS(2214),
    [anon_sym_point] = ACTIONS(2214),
    [anon_sym_line] = ACTIONS(2214),
    [anon_sym_triangleadj] = ACTIONS(2214),
    [anon_sym_lineadj] = ACTIONS(2214),
    [anon_sym_triangle] = ACTIONS(2214),
    [anon_sym_cbuffer] = ACTIONS(2214),
  },
  [212] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_include_token1] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token2] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [aux_sym_preproc_else_token1] = ACTIONS(2218),
    [aux_sym_preproc_elif_token1] = ACTIONS(2218),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AMP_AMP] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_typedef] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_virtual] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym___attribute] = ACTIONS(2218),
    [anon_sym_using] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym___based] = ACTIONS(2218),
    [anon_sym___cdecl] = ACTIONS(2218),
    [anon_sym___clrcall] = ACTIONS(2218),
    [anon_sym___stdcall] = ACTIONS(2218),
    [anon_sym___fastcall] = ACTIONS(2218),
    [anon_sym___thiscall] = ACTIONS(2218),
    [anon_sym___vectorcall] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym__Nonnull] = ACTIONS(2218),
    [anon_sym_mutable] = ACTIONS(2218),
    [anon_sym_constinit] = ACTIONS(2218),
    [anon_sym_consteval] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_goto] = ACTIONS(2218),
    [anon_sym___try] = ACTIONS(2218),
    [anon_sym___leave] = ACTIONS(2218),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_compl] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2218),
    [anon_sym___alignof__] = ACTIONS(2218),
    [anon_sym___alignof] = ACTIONS(2218),
    [anon_sym__alignof] = ACTIONS(2218),
    [anon_sym_alignof] = ACTIONS(2218),
    [anon_sym__Alignof] = ACTIONS(2218),
    [anon_sym_offsetof] = ACTIONS(2218),
    [anon_sym__Generic] = ACTIONS(2218),
    [anon_sym_asm] = ACTIONS(2218),
    [anon_sym___asm__] = ACTIONS(2218),
    [anon_sym___asm] = ACTIONS(2218),
    [sym_number_literal] = ACTIONS(2220),
    [anon_sym_L_SQUOTE] = ACTIONS(2220),
    [anon_sym_u_SQUOTE] = ACTIONS(2220),
    [anon_sym_U_SQUOTE] = ACTIONS(2220),
    [anon_sym_u8_SQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_L_DQUOTE] = ACTIONS(2220),
    [anon_sym_u_DQUOTE] = ACTIONS(2220),
    [anon_sym_U_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8_DQUOTE] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [anon_sym_NULL] = ACTIONS(2218),
    [anon_sym_nullptr] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2218),
    [anon_sym_decltype] = ACTIONS(2218),
    [anon_sym_explicit] = ACTIONS(2218),
    [anon_sym_typename] = ACTIONS(2218),
    [anon_sym_template] = ACTIONS(2218),
    [anon_sym_operator] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_namespace] = ACTIONS(2218),
    [anon_sym_static_assert] = ACTIONS(2218),
    [anon_sym_concept] = ACTIONS(2218),
    [anon_sym_co_return] = ACTIONS(2218),
    [anon_sym_co_yield] = ACTIONS(2218),
    [anon_sym_R_DQUOTE] = ACTIONS(2220),
    [anon_sym_LR_DQUOTE] = ACTIONS(2220),
    [anon_sym_uR_DQUOTE] = ACTIONS(2220),
    [anon_sym_UR_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2220),
    [anon_sym_co_await] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_requires] = ACTIONS(2218),
    [sym_this] = ACTIONS(2218),
    [anon_sym_discard] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_groupshared] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_row_major] = ACTIONS(2218),
    [anon_sym_column_major] = ACTIONS(2218),
    [anon_sym_globallycoherent] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym_nointerpolation] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_linear] = ACTIONS(2218),
    [anon_sym_snorm] = ACTIONS(2218),
    [anon_sym_unorm] = ACTIONS(2218),
    [anon_sym_point] = ACTIONS(2218),
    [anon_sym_line] = ACTIONS(2218),
    [anon_sym_triangleadj] = ACTIONS(2218),
    [anon_sym_lineadj] = ACTIONS(2218),
    [anon_sym_triangle] = ACTIONS(2218),
    [anon_sym_cbuffer] = ACTIONS(2218),
  },
  [213] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [aux_sym_preproc_else_token1] = ACTIONS(2222),
    [aux_sym_preproc_elif_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2224),
    [anon_sym_L_SQUOTE] = ACTIONS(2224),
    [anon_sym_u_SQUOTE] = ACTIONS(2224),
    [anon_sym_U_SQUOTE] = ACTIONS(2224),
    [anon_sym_u8_SQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_L_DQUOTE] = ACTIONS(2224),
    [anon_sym_u_DQUOTE] = ACTIONS(2224),
    [anon_sym_U_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8_DQUOTE] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2224),
    [anon_sym_LR_DQUOTE] = ACTIONS(2224),
    [anon_sym_uR_DQUOTE] = ACTIONS(2224),
    [anon_sym_UR_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2224),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
  },
  [214] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_include_token1] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token2] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [aux_sym_preproc_else_token1] = ACTIONS(2226),
    [aux_sym_preproc_elif_token1] = ACTIONS(2226),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_typedef] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_virtual] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym___attribute] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym___based] = ACTIONS(2226),
    [anon_sym___cdecl] = ACTIONS(2226),
    [anon_sym___clrcall] = ACTIONS(2226),
    [anon_sym___stdcall] = ACTIONS(2226),
    [anon_sym___fastcall] = ACTIONS(2226),
    [anon_sym___thiscall] = ACTIONS(2226),
    [anon_sym___vectorcall] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym__Nonnull] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_goto] = ACTIONS(2226),
    [anon_sym___try] = ACTIONS(2226),
    [anon_sym___leave] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2226),
    [anon_sym_compl] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2226),
    [anon_sym___alignof__] = ACTIONS(2226),
    [anon_sym___alignof] = ACTIONS(2226),
    [anon_sym__alignof] = ACTIONS(2226),
    [anon_sym_alignof] = ACTIONS(2226),
    [anon_sym__Alignof] = ACTIONS(2226),
    [anon_sym_offsetof] = ACTIONS(2226),
    [anon_sym__Generic] = ACTIONS(2226),
    [anon_sym_asm] = ACTIONS(2226),
    [anon_sym___asm__] = ACTIONS(2226),
    [anon_sym___asm] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2228),
    [anon_sym_L_SQUOTE] = ACTIONS(2228),
    [anon_sym_u_SQUOTE] = ACTIONS(2228),
    [anon_sym_U_SQUOTE] = ACTIONS(2228),
    [anon_sym_u8_SQUOTE] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_L_DQUOTE] = ACTIONS(2228),
    [anon_sym_u_DQUOTE] = ACTIONS(2228),
    [anon_sym_U_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [anon_sym_NULL] = ACTIONS(2226),
    [anon_sym_nullptr] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2226),
    [anon_sym_decltype] = ACTIONS(2226),
    [anon_sym_explicit] = ACTIONS(2226),
    [anon_sym_typename] = ACTIONS(2226),
    [anon_sym_template] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_static_assert] = ACTIONS(2226),
    [anon_sym_concept] = ACTIONS(2226),
    [anon_sym_co_return] = ACTIONS(2226),
    [anon_sym_co_yield] = ACTIONS(2226),
    [anon_sym_R_DQUOTE] = ACTIONS(2228),
    [anon_sym_LR_DQUOTE] = ACTIONS(2228),
    [anon_sym_uR_DQUOTE] = ACTIONS(2228),
    [anon_sym_UR_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2228),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [anon_sym_discard] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_groupshared] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_row_major] = ACTIONS(2226),
    [anon_sym_column_major] = ACTIONS(2226),
    [anon_sym_globallycoherent] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym_nointerpolation] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_linear] = ACTIONS(2226),
    [anon_sym_snorm] = ACTIONS(2226),
    [anon_sym_unorm] = ACTIONS(2226),
    [anon_sym_point] = ACTIONS(2226),
    [anon_sym_line] = ACTIONS(2226),
    [anon_sym_triangleadj] = ACTIONS(2226),
    [anon_sym_lineadj] = ACTIONS(2226),
    [anon_sym_triangle] = ACTIONS(2226),
    [anon_sym_cbuffer] = ACTIONS(2226),
  },
  [215] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_include_token1] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token2] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [aux_sym_preproc_else_token1] = ACTIONS(2230),
    [aux_sym_preproc_elif_token1] = ACTIONS(2230),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AMP_AMP] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_typedef] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_virtual] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym___attribute] = ACTIONS(2230),
    [anon_sym_using] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym___based] = ACTIONS(2230),
    [anon_sym___cdecl] = ACTIONS(2230),
    [anon_sym___clrcall] = ACTIONS(2230),
    [anon_sym___stdcall] = ACTIONS(2230),
    [anon_sym___fastcall] = ACTIONS(2230),
    [anon_sym___thiscall] = ACTIONS(2230),
    [anon_sym___vectorcall] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym__Nonnull] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_class] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2230),
    [anon_sym_switch] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_goto] = ACTIONS(2230),
    [anon_sym___try] = ACTIONS(2230),
    [anon_sym___leave] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2232),
    [anon_sym_sizeof] = ACTIONS(2230),
    [anon_sym___alignof__] = ACTIONS(2230),
    [anon_sym___alignof] = ACTIONS(2230),
    [anon_sym__alignof] = ACTIONS(2230),
    [anon_sym_alignof] = ACTIONS(2230),
    [anon_sym__Alignof] = ACTIONS(2230),
    [anon_sym_offsetof] = ACTIONS(2230),
    [anon_sym__Generic] = ACTIONS(2230),
    [anon_sym_asm] = ACTIONS(2230),
    [anon_sym___asm__] = ACTIONS(2230),
    [anon_sym___asm] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2232),
    [anon_sym_L_SQUOTE] = ACTIONS(2232),
    [anon_sym_u_SQUOTE] = ACTIONS(2232),
    [anon_sym_U_SQUOTE] = ACTIONS(2232),
    [anon_sym_u8_SQUOTE] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_L_DQUOTE] = ACTIONS(2232),
    [anon_sym_u_DQUOTE] = ACTIONS(2232),
    [anon_sym_U_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8_DQUOTE] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [sym_true] = ACTIONS(2230),
    [sym_false] = ACTIONS(2230),
    [anon_sym_NULL] = ACTIONS(2230),
    [anon_sym_nullptr] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2230),
    [anon_sym_decltype] = ACTIONS(2230),
    [anon_sym_explicit] = ACTIONS(2230),
    [anon_sym_typename] = ACTIONS(2230),
    [anon_sym_template] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_delete] = ACTIONS(2230),
    [anon_sym_throw] = ACTIONS(2230),
    [anon_sym_namespace] = ACTIONS(2230),
    [anon_sym_static_assert] = ACTIONS(2230),
    [anon_sym_concept] = ACTIONS(2230),
    [anon_sym_co_return] = ACTIONS(2230),
    [anon_sym_co_yield] = ACTIONS(2230),
    [anon_sym_R_DQUOTE] = ACTIONS(2232),
    [anon_sym_LR_DQUOTE] = ACTIONS(2232),
    [anon_sym_uR_DQUOTE] = ACTIONS(2232),
    [anon_sym_UR_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2232),
    [anon_sym_co_await] = ACTIONS(2230),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2230),
    [sym_this] = ACTIONS(2230),
    [anon_sym_discard] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_groupshared] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_row_major] = ACTIONS(2230),
    [anon_sym_column_major] = ACTIONS(2230),
    [anon_sym_globallycoherent] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym_nointerpolation] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_linear] = ACTIONS(2230),
    [anon_sym_snorm] = ACTIONS(2230),
    [anon_sym_unorm] = ACTIONS(2230),
    [anon_sym_point] = ACTIONS(2230),
    [anon_sym_line] = ACTIONS(2230),
    [anon_sym_triangleadj] = ACTIONS(2230),
    [anon_sym_lineadj] = ACTIONS(2230),
    [anon_sym_triangle] = ACTIONS(2230),
    [anon_sym_cbuffer] = ACTIONS(2230),
  },
  [216] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_include_token1] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token2] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [aux_sym_preproc_else_token1] = ACTIONS(2234),
    [aux_sym_preproc_elif_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_typedef] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_virtual] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym___based] = ACTIONS(2234),
    [anon_sym___cdecl] = ACTIONS(2234),
    [anon_sym___clrcall] = ACTIONS(2234),
    [anon_sym___stdcall] = ACTIONS(2234),
    [anon_sym___fastcall] = ACTIONS(2234),
    [anon_sym___thiscall] = ACTIONS(2234),
    [anon_sym___vectorcall] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym__Nonnull] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_goto] = ACTIONS(2234),
    [anon_sym___try] = ACTIONS(2234),
    [anon_sym___leave] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2234),
    [anon_sym_compl] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2236),
    [anon_sym_sizeof] = ACTIONS(2234),
    [anon_sym___alignof__] = ACTIONS(2234),
    [anon_sym___alignof] = ACTIONS(2234),
    [anon_sym__alignof] = ACTIONS(2234),
    [anon_sym_alignof] = ACTIONS(2234),
    [anon_sym__Alignof] = ACTIONS(2234),
    [anon_sym_offsetof] = ACTIONS(2234),
    [anon_sym__Generic] = ACTIONS(2234),
    [anon_sym_asm] = ACTIONS(2234),
    [anon_sym___asm__] = ACTIONS(2234),
    [anon_sym___asm] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2236),
    [anon_sym_L_SQUOTE] = ACTIONS(2236),
    [anon_sym_u_SQUOTE] = ACTIONS(2236),
    [anon_sym_U_SQUOTE] = ACTIONS(2236),
    [anon_sym_u8_SQUOTE] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_L_DQUOTE] = ACTIONS(2236),
    [anon_sym_u_DQUOTE] = ACTIONS(2236),
    [anon_sym_U_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8_DQUOTE] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2236),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [anon_sym_NULL] = ACTIONS(2234),
    [anon_sym_nullptr] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2234),
    [anon_sym_decltype] = ACTIONS(2234),
    [anon_sym_explicit] = ACTIONS(2234),
    [anon_sym_typename] = ACTIONS(2234),
    [anon_sym_template] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_static_assert] = ACTIONS(2234),
    [anon_sym_concept] = ACTIONS(2234),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2236),
    [anon_sym_LR_DQUOTE] = ACTIONS(2236),
    [anon_sym_uR_DQUOTE] = ACTIONS(2236),
    [anon_sym_UR_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2236),
    [anon_sym_co_await] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [anon_sym_discard] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_groupshared] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_row_major] = ACTIONS(2234),
    [anon_sym_column_major] = ACTIONS(2234),
    [anon_sym_globallycoherent] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym_nointerpolation] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_linear] = ACTIONS(2234),
    [anon_sym_snorm] = ACTIONS(2234),
    [anon_sym_unorm] = ACTIONS(2234),
    [anon_sym_point] = ACTIONS(2234),
    [anon_sym_line] = ACTIONS(2234),
    [anon_sym_triangleadj] = ACTIONS(2234),
    [anon_sym_lineadj] = ACTIONS(2234),
    [anon_sym_triangle] = ACTIONS(2234),
    [anon_sym_cbuffer] = ACTIONS(2234),
  },
  [217] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_include_token1] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token2] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [aux_sym_preproc_else_token1] = ACTIONS(2238),
    [aux_sym_preproc_elif_token1] = ACTIONS(2238),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_AMP_AMP] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_typedef] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_virtual] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym___attribute] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym___based] = ACTIONS(2238),
    [anon_sym___cdecl] = ACTIONS(2238),
    [anon_sym___clrcall] = ACTIONS(2238),
    [anon_sym___stdcall] = ACTIONS(2238),
    [anon_sym___fastcall] = ACTIONS(2238),
    [anon_sym___thiscall] = ACTIONS(2238),
    [anon_sym___vectorcall] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym__Nonnull] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_do] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2238),
    [anon_sym___try] = ACTIONS(2238),
    [anon_sym___leave] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2238),
    [anon_sym_compl] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2238),
    [anon_sym___alignof] = ACTIONS(2238),
    [anon_sym__alignof] = ACTIONS(2238),
    [anon_sym_alignof] = ACTIONS(2238),
    [anon_sym__Alignof] = ACTIONS(2238),
    [anon_sym_offsetof] = ACTIONS(2238),
    [anon_sym__Generic] = ACTIONS(2238),
    [anon_sym_asm] = ACTIONS(2238),
    [anon_sym___asm__] = ACTIONS(2238),
    [anon_sym___asm] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2240),
    [anon_sym_L_SQUOTE] = ACTIONS(2240),
    [anon_sym_u_SQUOTE] = ACTIONS(2240),
    [anon_sym_U_SQUOTE] = ACTIONS(2240),
    [anon_sym_u8_SQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_L_DQUOTE] = ACTIONS(2240),
    [anon_sym_u_DQUOTE] = ACTIONS(2240),
    [anon_sym_U_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [anon_sym_NULL] = ACTIONS(2238),
    [anon_sym_nullptr] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2238),
    [anon_sym_decltype] = ACTIONS(2238),
    [anon_sym_explicit] = ACTIONS(2238),
    [anon_sym_typename] = ACTIONS(2238),
    [anon_sym_template] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [anon_sym_delete] = ACTIONS(2238),
    [anon_sym_throw] = ACTIONS(2238),
    [anon_sym_namespace] = ACTIONS(2238),
    [anon_sym_static_assert] = ACTIONS(2238),
    [anon_sym_concept] = ACTIONS(2238),
    [anon_sym_co_return] = ACTIONS(2238),
    [anon_sym_co_yield] = ACTIONS(2238),
    [anon_sym_R_DQUOTE] = ACTIONS(2240),
    [anon_sym_LR_DQUOTE] = ACTIONS(2240),
    [anon_sym_uR_DQUOTE] = ACTIONS(2240),
    [anon_sym_UR_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2240),
    [anon_sym_co_await] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2238),
    [sym_this] = ACTIONS(2238),
    [anon_sym_discard] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_groupshared] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_row_major] = ACTIONS(2238),
    [anon_sym_column_major] = ACTIONS(2238),
    [anon_sym_globallycoherent] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym_nointerpolation] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_linear] = ACTIONS(2238),
    [anon_sym_snorm] = ACTIONS(2238),
    [anon_sym_unorm] = ACTIONS(2238),
    [anon_sym_point] = ACTIONS(2238),
    [anon_sym_line] = ACTIONS(2238),
    [anon_sym_triangleadj] = ACTIONS(2238),
    [anon_sym_lineadj] = ACTIONS(2238),
    [anon_sym_triangle] = ACTIONS(2238),
    [anon_sym_cbuffer] = ACTIONS(2238),
  },
  [218] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_include_token1] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [aux_sym_preproc_else_token1] = ACTIONS(2242),
    [aux_sym_preproc_elif_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym___cdecl] = ACTIONS(2242),
    [anon_sym___clrcall] = ACTIONS(2242),
    [anon_sym___stdcall] = ACTIONS(2242),
    [anon_sym___fastcall] = ACTIONS(2242),
    [anon_sym___thiscall] = ACTIONS(2242),
    [anon_sym___vectorcall] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_goto] = ACTIONS(2242),
    [anon_sym___try] = ACTIONS(2242),
    [anon_sym___leave] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_compl] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2244),
    [anon_sym_sizeof] = ACTIONS(2242),
    [anon_sym___alignof__] = ACTIONS(2242),
    [anon_sym___alignof] = ACTIONS(2242),
    [anon_sym__alignof] = ACTIONS(2242),
    [anon_sym_alignof] = ACTIONS(2242),
    [anon_sym__Alignof] = ACTIONS(2242),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2242),
    [anon_sym_asm] = ACTIONS(2242),
    [anon_sym___asm__] = ACTIONS(2242),
    [anon_sym___asm] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2244),
    [anon_sym_L_SQUOTE] = ACTIONS(2244),
    [anon_sym_u_SQUOTE] = ACTIONS(2244),
    [anon_sym_U_SQUOTE] = ACTIONS(2244),
    [anon_sym_u8_SQUOTE] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_L_DQUOTE] = ACTIONS(2244),
    [anon_sym_u_DQUOTE] = ACTIONS(2244),
    [anon_sym_U_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2244),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [anon_sym_NULL] = ACTIONS(2242),
    [anon_sym_nullptr] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_concept] = ACTIONS(2242),
    [anon_sym_co_return] = ACTIONS(2242),
    [anon_sym_co_yield] = ACTIONS(2242),
    [anon_sym_R_DQUOTE] = ACTIONS(2244),
    [anon_sym_LR_DQUOTE] = ACTIONS(2244),
    [anon_sym_uR_DQUOTE] = ACTIONS(2244),
    [anon_sym_UR_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2244),
    [anon_sym_co_await] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [anon_sym_discard] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
    [anon_sym_cbuffer] = ACTIONS(2242),
  },
  [219] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_include_token1] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [aux_sym_preproc_else_token1] = ACTIONS(2246),
    [aux_sym_preproc_elif_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym___cdecl] = ACTIONS(2246),
    [anon_sym___clrcall] = ACTIONS(2246),
    [anon_sym___stdcall] = ACTIONS(2246),
    [anon_sym___fastcall] = ACTIONS(2246),
    [anon_sym___thiscall] = ACTIONS(2246),
    [anon_sym___vectorcall] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2246),
    [anon_sym_switch] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_goto] = ACTIONS(2246),
    [anon_sym___try] = ACTIONS(2246),
    [anon_sym___leave] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_compl] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_sizeof] = ACTIONS(2246),
    [anon_sym___alignof__] = ACTIONS(2246),
    [anon_sym___alignof] = ACTIONS(2246),
    [anon_sym__alignof] = ACTIONS(2246),
    [anon_sym_alignof] = ACTIONS(2246),
    [anon_sym__Alignof] = ACTIONS(2246),
    [anon_sym_offsetof] = ACTIONS(2246),
    [anon_sym__Generic] = ACTIONS(2246),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym___asm] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2248),
    [anon_sym_L_SQUOTE] = ACTIONS(2248),
    [anon_sym_u_SQUOTE] = ACTIONS(2248),
    [anon_sym_U_SQUOTE] = ACTIONS(2248),
    [anon_sym_u8_SQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_L_DQUOTE] = ACTIONS(2248),
    [anon_sym_u_DQUOTE] = ACTIONS(2248),
    [anon_sym_U_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [anon_sym_NULL] = ACTIONS(2246),
    [anon_sym_nullptr] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_delete] = ACTIONS(2246),
    [anon_sym_throw] = ACTIONS(2246),
    [anon_sym_namespace] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_concept] = ACTIONS(2246),
    [anon_sym_co_return] = ACTIONS(2246),
    [anon_sym_co_yield] = ACTIONS(2246),
    [anon_sym_R_DQUOTE] = ACTIONS(2248),
    [anon_sym_LR_DQUOTE] = ACTIONS(2248),
    [anon_sym_uR_DQUOTE] = ACTIONS(2248),
    [anon_sym_UR_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2248),
    [anon_sym_co_await] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2246),
    [sym_this] = ACTIONS(2246),
    [anon_sym_discard] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
    [anon_sym_cbuffer] = ACTIONS(2246),
  },
  [220] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_include_token1] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [aux_sym_preproc_else_token1] = ACTIONS(2250),
    [aux_sym_preproc_elif_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_typedef] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_virtual] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym___attribute] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2250),
    [anon_sym___cdecl] = ACTIONS(2250),
    [anon_sym___clrcall] = ACTIONS(2250),
    [anon_sym___stdcall] = ACTIONS(2250),
    [anon_sym___fastcall] = ACTIONS(2250),
    [anon_sym___thiscall] = ACTIONS(2250),
    [anon_sym___vectorcall] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_goto] = ACTIONS(2250),
    [anon_sym___try] = ACTIONS(2250),
    [anon_sym___leave] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2250),
    [anon_sym_compl] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2250),
    [anon_sym___alignof__] = ACTIONS(2250),
    [anon_sym___alignof] = ACTIONS(2250),
    [anon_sym__alignof] = ACTIONS(2250),
    [anon_sym_alignof] = ACTIONS(2250),
    [anon_sym__Alignof] = ACTIONS(2250),
    [anon_sym_offsetof] = ACTIONS(2250),
    [anon_sym__Generic] = ACTIONS(2250),
    [anon_sym_asm] = ACTIONS(2250),
    [anon_sym___asm__] = ACTIONS(2250),
    [anon_sym___asm] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2252),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2252),
    [anon_sym_u_DQUOTE] = ACTIONS(2252),
    [anon_sym_U_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [anon_sym_NULL] = ACTIONS(2250),
    [anon_sym_nullptr] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2250),
    [anon_sym_decltype] = ACTIONS(2250),
    [anon_sym_explicit] = ACTIONS(2250),
    [anon_sym_typename] = ACTIONS(2250),
    [anon_sym_template] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_static_assert] = ACTIONS(2250),
    [anon_sym_concept] = ACTIONS(2250),
    [anon_sym_co_return] = ACTIONS(2250),
    [anon_sym_co_yield] = ACTIONS(2250),
    [anon_sym_R_DQUOTE] = ACTIONS(2252),
    [anon_sym_LR_DQUOTE] = ACTIONS(2252),
    [anon_sym_uR_DQUOTE] = ACTIONS(2252),
    [anon_sym_UR_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2252),
    [anon_sym_co_await] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [anon_sym_discard] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_groupshared] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_row_major] = ACTIONS(2250),
    [anon_sym_column_major] = ACTIONS(2250),
    [anon_sym_globallycoherent] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym_nointerpolation] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_linear] = ACTIONS(2250),
    [anon_sym_snorm] = ACTIONS(2250),
    [anon_sym_unorm] = ACTIONS(2250),
    [anon_sym_point] = ACTIONS(2250),
    [anon_sym_line] = ACTIONS(2250),
    [anon_sym_triangleadj] = ACTIONS(2250),
    [anon_sym_lineadj] = ACTIONS(2250),
    [anon_sym_triangle] = ACTIONS(2250),
    [anon_sym_cbuffer] = ACTIONS(2250),
  },
  [221] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_include_token1] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token2] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [aux_sym_preproc_else_token1] = ACTIONS(2254),
    [aux_sym_preproc_elif_token1] = ACTIONS(2254),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_typedef] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_virtual] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym___attribute] = ACTIONS(2254),
    [anon_sym_using] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym___based] = ACTIONS(2254),
    [anon_sym___cdecl] = ACTIONS(2254),
    [anon_sym___clrcall] = ACTIONS(2254),
    [anon_sym___stdcall] = ACTIONS(2254),
    [anon_sym___fastcall] = ACTIONS(2254),
    [anon_sym___thiscall] = ACTIONS(2254),
    [anon_sym___vectorcall] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym__Nonnull] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_class] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2254),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_do] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2254),
    [anon_sym___try] = ACTIONS(2254),
    [anon_sym___leave] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_compl] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2254),
    [anon_sym___alignof__] = ACTIONS(2254),
    [anon_sym___alignof] = ACTIONS(2254),
    [anon_sym__alignof] = ACTIONS(2254),
    [anon_sym_alignof] = ACTIONS(2254),
    [anon_sym__Alignof] = ACTIONS(2254),
    [anon_sym_offsetof] = ACTIONS(2254),
    [anon_sym__Generic] = ACTIONS(2254),
    [anon_sym_asm] = ACTIONS(2254),
    [anon_sym___asm__] = ACTIONS(2254),
    [anon_sym___asm] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_L_SQUOTE] = ACTIONS(2256),
    [anon_sym_u_SQUOTE] = ACTIONS(2256),
    [anon_sym_U_SQUOTE] = ACTIONS(2256),
    [anon_sym_u8_SQUOTE] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_L_DQUOTE] = ACTIONS(2256),
    [anon_sym_u_DQUOTE] = ACTIONS(2256),
    [anon_sym_U_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8_DQUOTE] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2256),
    [sym_true] = ACTIONS(2254),
    [sym_false] = ACTIONS(2254),
    [anon_sym_NULL] = ACTIONS(2254),
    [anon_sym_nullptr] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2254),
    [anon_sym_decltype] = ACTIONS(2254),
    [anon_sym_explicit] = ACTIONS(2254),
    [anon_sym_typename] = ACTIONS(2254),
    [anon_sym_template] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [anon_sym_delete] = ACTIONS(2254),
    [anon_sym_throw] = ACTIONS(2254),
    [anon_sym_namespace] = ACTIONS(2254),
    [anon_sym_static_assert] = ACTIONS(2254),
    [anon_sym_concept] = ACTIONS(2254),
    [anon_sym_co_return] = ACTIONS(2254),
    [anon_sym_co_yield] = ACTIONS(2254),
    [anon_sym_R_DQUOTE] = ACTIONS(2256),
    [anon_sym_LR_DQUOTE] = ACTIONS(2256),
    [anon_sym_uR_DQUOTE] = ACTIONS(2256),
    [anon_sym_UR_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2256),
    [anon_sym_co_await] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2254),
    [sym_this] = ACTIONS(2254),
    [anon_sym_discard] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_groupshared] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_row_major] = ACTIONS(2254),
    [anon_sym_column_major] = ACTIONS(2254),
    [anon_sym_globallycoherent] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym_nointerpolation] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_linear] = ACTIONS(2254),
    [anon_sym_snorm] = ACTIONS(2254),
    [anon_sym_unorm] = ACTIONS(2254),
    [anon_sym_point] = ACTIONS(2254),
    [anon_sym_line] = ACTIONS(2254),
    [anon_sym_triangleadj] = ACTIONS(2254),
    [anon_sym_lineadj] = ACTIONS(2254),
    [anon_sym_triangle] = ACTIONS(2254),
    [anon_sym_cbuffer] = ACTIONS(2254),
  },
  [222] = {
    [sym_identifier] = ACTIONS(2258),
    [aux_sym_preproc_include_token1] = ACTIONS(2258),
    [aux_sym_preproc_def_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2258),
    [aux_sym_preproc_else_token1] = ACTIONS(2258),
    [aux_sym_preproc_elif_token1] = ACTIONS(2258),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2258),
    [sym_preproc_directive] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym_typedef] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2258),
    [anon_sym_out] = ACTIONS(2258),
    [anon_sym_inout] = ACTIONS(2258),
    [anon_sym_virtual] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym___attribute] = ACTIONS(2258),
    [anon_sym_using] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2260),
    [anon_sym___declspec] = ACTIONS(2258),
    [anon_sym___based] = ACTIONS(2258),
    [anon_sym___cdecl] = ACTIONS(2258),
    [anon_sym___clrcall] = ACTIONS(2258),
    [anon_sym___stdcall] = ACTIONS(2258),
    [anon_sym___fastcall] = ACTIONS(2258),
    [anon_sym___thiscall] = ACTIONS(2258),
    [anon_sym___vectorcall] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2258),
    [anon_sym_unsigned] = ACTIONS(2258),
    [anon_sym_long] = ACTIONS(2258),
    [anon_sym_short] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2258),
    [anon_sym_inline] = ACTIONS(2258),
    [anon_sym___inline] = ACTIONS(2258),
    [anon_sym___inline__] = ACTIONS(2258),
    [anon_sym___forceinline] = ACTIONS(2258),
    [anon_sym_thread_local] = ACTIONS(2258),
    [anon_sym___thread] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym__Nonnull] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [sym_primitive_type] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_class] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2258),
    [anon_sym_switch] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_do] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_goto] = ACTIONS(2258),
    [anon_sym___try] = ACTIONS(2258),
    [anon_sym___leave] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2258),
    [anon_sym_compl] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2258),
    [anon_sym___alignof__] = ACTIONS(2258),
    [anon_sym___alignof] = ACTIONS(2258),
    [anon_sym__alignof] = ACTIONS(2258),
    [anon_sym_alignof] = ACTIONS(2258),
    [anon_sym__Alignof] = ACTIONS(2258),
    [anon_sym_offsetof] = ACTIONS(2258),
    [anon_sym__Generic] = ACTIONS(2258),
    [anon_sym_asm] = ACTIONS(2258),
    [anon_sym___asm__] = ACTIONS(2258),
    [anon_sym___asm] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2260),
    [anon_sym_L_SQUOTE] = ACTIONS(2260),
    [anon_sym_u_SQUOTE] = ACTIONS(2260),
    [anon_sym_U_SQUOTE] = ACTIONS(2260),
    [anon_sym_u8_SQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_L_DQUOTE] = ACTIONS(2260),
    [anon_sym_u_DQUOTE] = ACTIONS(2260),
    [anon_sym_U_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8_DQUOTE] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2258),
    [anon_sym_decltype] = ACTIONS(2258),
    [anon_sym_explicit] = ACTIONS(2258),
    [anon_sym_typename] = ACTIONS(2258),
    [anon_sym_template] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [anon_sym_delete] = ACTIONS(2258),
    [anon_sym_throw] = ACTIONS(2258),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_static_assert] = ACTIONS(2258),
    [anon_sym_concept] = ACTIONS(2258),
    [anon_sym_co_return] = ACTIONS(2258),
    [anon_sym_co_yield] = ACTIONS(2258),
    [anon_sym_R_DQUOTE] = ACTIONS(2260),
    [anon_sym_LR_DQUOTE] = ACTIONS(2260),
    [anon_sym_uR_DQUOTE] = ACTIONS(2260),
    [anon_sym_UR_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2260),
    [anon_sym_co_await] = ACTIONS(2258),
    [anon_sym_new] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2258),
    [sym_this] = ACTIONS(2258),
    [anon_sym_discard] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2258),
    [anon_sym_shared] = ACTIONS(2258),
    [anon_sym_groupshared] = ACTIONS(2258),
    [anon_sym_uniform] = ACTIONS(2258),
    [anon_sym_row_major] = ACTIONS(2258),
    [anon_sym_column_major] = ACTIONS(2258),
    [anon_sym_globallycoherent] = ACTIONS(2258),
    [anon_sym_centroid] = ACTIONS(2258),
    [anon_sym_noperspective] = ACTIONS(2258),
    [anon_sym_nointerpolation] = ACTIONS(2258),
    [anon_sym_sample] = ACTIONS(2258),
    [anon_sym_linear] = ACTIONS(2258),
    [anon_sym_snorm] = ACTIONS(2258),
    [anon_sym_unorm] = ACTIONS(2258),
    [anon_sym_point] = ACTIONS(2258),
    [anon_sym_line] = ACTIONS(2258),
    [anon_sym_triangleadj] = ACTIONS(2258),
    [anon_sym_lineadj] = ACTIONS(2258),
    [anon_sym_triangle] = ACTIONS(2258),
    [anon_sym_cbuffer] = ACTIONS(2258),
  },
  [223] = {
    [sym_identifier] = ACTIONS(2262),
    [aux_sym_preproc_include_token1] = ACTIONS(2262),
    [aux_sym_preproc_def_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token2] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [aux_sym_preproc_else_token1] = ACTIONS(2262),
    [aux_sym_preproc_elif_token1] = ACTIONS(2262),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2262),
    [sym_preproc_directive] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym_typedef] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2262),
    [anon_sym_out] = ACTIONS(2262),
    [anon_sym_inout] = ACTIONS(2262),
    [anon_sym_virtual] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2262),
    [anon_sym_using] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2264),
    [anon_sym___declspec] = ACTIONS(2262),
    [anon_sym___based] = ACTIONS(2262),
    [anon_sym___cdecl] = ACTIONS(2262),
    [anon_sym___clrcall] = ACTIONS(2262),
    [anon_sym___stdcall] = ACTIONS(2262),
    [anon_sym___fastcall] = ACTIONS(2262),
    [anon_sym___thiscall] = ACTIONS(2262),
    [anon_sym___vectorcall] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2262),
    [anon_sym_unsigned] = ACTIONS(2262),
    [anon_sym_long] = ACTIONS(2262),
    [anon_sym_short] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2262),
    [anon_sym_inline] = ACTIONS(2262),
    [anon_sym___inline] = ACTIONS(2262),
    [anon_sym___inline__] = ACTIONS(2262),
    [anon_sym___forceinline] = ACTIONS(2262),
    [anon_sym_thread_local] = ACTIONS(2262),
    [anon_sym___thread] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [sym_primitive_type] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_class] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2262),
    [anon_sym_default] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_goto] = ACTIONS(2262),
    [anon_sym___try] = ACTIONS(2262),
    [anon_sym___leave] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2262),
    [anon_sym_compl] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2262),
    [anon_sym___alignof__] = ACTIONS(2262),
    [anon_sym___alignof] = ACTIONS(2262),
    [anon_sym__alignof] = ACTIONS(2262),
    [anon_sym_alignof] = ACTIONS(2262),
    [anon_sym__Alignof] = ACTIONS(2262),
    [anon_sym_offsetof] = ACTIONS(2262),
    [anon_sym__Generic] = ACTIONS(2262),
    [anon_sym_asm] = ACTIONS(2262),
    [anon_sym___asm__] = ACTIONS(2262),
    [anon_sym___asm] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2264),
    [anon_sym_L_SQUOTE] = ACTIONS(2264),
    [anon_sym_u_SQUOTE] = ACTIONS(2264),
    [anon_sym_U_SQUOTE] = ACTIONS(2264),
    [anon_sym_u8_SQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_L_DQUOTE] = ACTIONS(2264),
    [anon_sym_u_DQUOTE] = ACTIONS(2264),
    [anon_sym_U_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8_DQUOTE] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [anon_sym_NULL] = ACTIONS(2262),
    [anon_sym_nullptr] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2262),
    [anon_sym_decltype] = ACTIONS(2262),
    [anon_sym_explicit] = ACTIONS(2262),
    [anon_sym_typename] = ACTIONS(2262),
    [anon_sym_template] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [anon_sym_delete] = ACTIONS(2262),
    [anon_sym_throw] = ACTIONS(2262),
    [anon_sym_namespace] = ACTIONS(2262),
    [anon_sym_static_assert] = ACTIONS(2262),
    [anon_sym_concept] = ACTIONS(2262),
    [anon_sym_co_return] = ACTIONS(2262),
    [anon_sym_co_yield] = ACTIONS(2262),
    [anon_sym_R_DQUOTE] = ACTIONS(2264),
    [anon_sym_LR_DQUOTE] = ACTIONS(2264),
    [anon_sym_uR_DQUOTE] = ACTIONS(2264),
    [anon_sym_UR_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2264),
    [anon_sym_co_await] = ACTIONS(2262),
    [anon_sym_new] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2262),
    [sym_this] = ACTIONS(2262),
    [anon_sym_discard] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2262),
    [anon_sym_shared] = ACTIONS(2262),
    [anon_sym_groupshared] = ACTIONS(2262),
    [anon_sym_uniform] = ACTIONS(2262),
    [anon_sym_row_major] = ACTIONS(2262),
    [anon_sym_column_major] = ACTIONS(2262),
    [anon_sym_globallycoherent] = ACTIONS(2262),
    [anon_sym_centroid] = ACTIONS(2262),
    [anon_sym_noperspective] = ACTIONS(2262),
    [anon_sym_nointerpolation] = ACTIONS(2262),
    [anon_sym_sample] = ACTIONS(2262),
    [anon_sym_linear] = ACTIONS(2262),
    [anon_sym_snorm] = ACTIONS(2262),
    [anon_sym_unorm] = ACTIONS(2262),
    [anon_sym_point] = ACTIONS(2262),
    [anon_sym_line] = ACTIONS(2262),
    [anon_sym_triangleadj] = ACTIONS(2262),
    [anon_sym_lineadj] = ACTIONS(2262),
    [anon_sym_triangle] = ACTIONS(2262),
    [anon_sym_cbuffer] = ACTIONS(2262),
  },
  [224] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_include_token1] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [aux_sym_preproc_else_token1] = ACTIONS(2266),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym___cdecl] = ACTIONS(2266),
    [anon_sym___clrcall] = ACTIONS(2266),
    [anon_sym___stdcall] = ACTIONS(2266),
    [anon_sym___fastcall] = ACTIONS(2266),
    [anon_sym___thiscall] = ACTIONS(2266),
    [anon_sym___vectorcall] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [anon_sym_switch] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_do] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_goto] = ACTIONS(2266),
    [anon_sym___try] = ACTIONS(2266),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2266),
    [anon_sym_compl] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2266),
    [anon_sym___alignof__] = ACTIONS(2266),
    [anon_sym___alignof] = ACTIONS(2266),
    [anon_sym__alignof] = ACTIONS(2266),
    [anon_sym_alignof] = ACTIONS(2266),
    [anon_sym__Alignof] = ACTIONS(2266),
    [anon_sym_offsetof] = ACTIONS(2266),
    [anon_sym__Generic] = ACTIONS(2266),
    [anon_sym_asm] = ACTIONS(2266),
    [anon_sym___asm__] = ACTIONS(2266),
    [anon_sym___asm] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2268),
    [anon_sym_L_SQUOTE] = ACTIONS(2268),
    [anon_sym_u_SQUOTE] = ACTIONS(2268),
    [anon_sym_U_SQUOTE] = ACTIONS(2268),
    [anon_sym_u8_SQUOTE] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_L_DQUOTE] = ACTIONS(2268),
    [anon_sym_u_DQUOTE] = ACTIONS(2268),
    [anon_sym_U_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8_DQUOTE] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [anon_sym_NULL] = ACTIONS(2266),
    [anon_sym_nullptr] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [anon_sym_delete] = ACTIONS(2266),
    [anon_sym_throw] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_concept] = ACTIONS(2266),
    [anon_sym_co_return] = ACTIONS(2266),
    [anon_sym_co_yield] = ACTIONS(2266),
    [anon_sym_R_DQUOTE] = ACTIONS(2268),
    [anon_sym_LR_DQUOTE] = ACTIONS(2268),
    [anon_sym_uR_DQUOTE] = ACTIONS(2268),
    [anon_sym_UR_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2268),
    [anon_sym_co_await] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2266),
    [sym_this] = ACTIONS(2266),
    [anon_sym_discard] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
    [anon_sym_cbuffer] = ACTIONS(2266),
  },
  [225] = {
    [sym_identifier] = ACTIONS(2270),
    [aux_sym_preproc_include_token1] = ACTIONS(2270),
    [aux_sym_preproc_def_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token2] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2270),
    [aux_sym_preproc_else_token1] = ACTIONS(2270),
    [aux_sym_preproc_elif_token1] = ACTIONS(2270),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2270),
    [sym_preproc_directive] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_typedef] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_virtual] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2270),
    [anon_sym_using] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym___based] = ACTIONS(2270),
    [anon_sym___cdecl] = ACTIONS(2270),
    [anon_sym___clrcall] = ACTIONS(2270),
    [anon_sym___stdcall] = ACTIONS(2270),
    [anon_sym___fastcall] = ACTIONS(2270),
    [anon_sym___thiscall] = ACTIONS(2270),
    [anon_sym___vectorcall] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_class] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_switch] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2270),
    [anon_sym_default] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_do] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_goto] = ACTIONS(2270),
    [anon_sym___try] = ACTIONS(2270),
    [anon_sym___leave] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_compl] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2270),
    [anon_sym___alignof__] = ACTIONS(2270),
    [anon_sym___alignof] = ACTIONS(2270),
    [anon_sym__alignof] = ACTIONS(2270),
    [anon_sym_alignof] = ACTIONS(2270),
    [anon_sym__Alignof] = ACTIONS(2270),
    [anon_sym_offsetof] = ACTIONS(2270),
    [anon_sym__Generic] = ACTIONS(2270),
    [anon_sym_asm] = ACTIONS(2270),
    [anon_sym___asm__] = ACTIONS(2270),
    [anon_sym___asm] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2272),
    [anon_sym_L_SQUOTE] = ACTIONS(2272),
    [anon_sym_u_SQUOTE] = ACTIONS(2272),
    [anon_sym_U_SQUOTE] = ACTIONS(2272),
    [anon_sym_u8_SQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_L_DQUOTE] = ACTIONS(2272),
    [anon_sym_u_DQUOTE] = ACTIONS(2272),
    [anon_sym_U_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8_DQUOTE] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [anon_sym_NULL] = ACTIONS(2270),
    [anon_sym_nullptr] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2270),
    [anon_sym_decltype] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_typename] = ACTIONS(2270),
    [anon_sym_template] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [anon_sym_delete] = ACTIONS(2270),
    [anon_sym_throw] = ACTIONS(2270),
    [anon_sym_namespace] = ACTIONS(2270),
    [anon_sym_static_assert] = ACTIONS(2270),
    [anon_sym_concept] = ACTIONS(2270),
    [anon_sym_co_return] = ACTIONS(2270),
    [anon_sym_co_yield] = ACTIONS(2270),
    [anon_sym_R_DQUOTE] = ACTIONS(2272),
    [anon_sym_LR_DQUOTE] = ACTIONS(2272),
    [anon_sym_uR_DQUOTE] = ACTIONS(2272),
    [anon_sym_UR_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2272),
    [anon_sym_co_await] = ACTIONS(2270),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2270),
    [sym_this] = ACTIONS(2270),
    [anon_sym_discard] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_groupshared] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_row_major] = ACTIONS(2270),
    [anon_sym_column_major] = ACTIONS(2270),
    [anon_sym_globallycoherent] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym_nointerpolation] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_linear] = ACTIONS(2270),
    [anon_sym_snorm] = ACTIONS(2270),
    [anon_sym_unorm] = ACTIONS(2270),
    [anon_sym_point] = ACTIONS(2270),
    [anon_sym_line] = ACTIONS(2270),
    [anon_sym_triangleadj] = ACTIONS(2270),
    [anon_sym_lineadj] = ACTIONS(2270),
    [anon_sym_triangle] = ACTIONS(2270),
    [anon_sym_cbuffer] = ACTIONS(2270),
  },
  [226] = {
    [sym_identifier] = ACTIONS(2274),
    [aux_sym_preproc_include_token1] = ACTIONS(2274),
    [aux_sym_preproc_def_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token2] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2274),
    [aux_sym_preproc_else_token1] = ACTIONS(2274),
    [aux_sym_preproc_elif_token1] = ACTIONS(2274),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2274),
    [sym_preproc_directive] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_AMP_AMP] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_typedef] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_virtual] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2274),
    [anon_sym_using] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym___based] = ACTIONS(2274),
    [anon_sym___cdecl] = ACTIONS(2274),
    [anon_sym___clrcall] = ACTIONS(2274),
    [anon_sym___stdcall] = ACTIONS(2274),
    [anon_sym___fastcall] = ACTIONS(2274),
    [anon_sym___thiscall] = ACTIONS(2274),
    [anon_sym___vectorcall] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_class] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2274),
    [anon_sym_switch] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_do] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_goto] = ACTIONS(2274),
    [anon_sym___try] = ACTIONS(2274),
    [anon_sym___leave] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2274),
    [anon_sym_compl] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2274),
    [anon_sym___alignof__] = ACTIONS(2274),
    [anon_sym___alignof] = ACTIONS(2274),
    [anon_sym__alignof] = ACTIONS(2274),
    [anon_sym_alignof] = ACTIONS(2274),
    [anon_sym__Alignof] = ACTIONS(2274),
    [anon_sym_offsetof] = ACTIONS(2274),
    [anon_sym__Generic] = ACTIONS(2274),
    [anon_sym_asm] = ACTIONS(2274),
    [anon_sym___asm__] = ACTIONS(2274),
    [anon_sym___asm] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_L_SQUOTE] = ACTIONS(2276),
    [anon_sym_u_SQUOTE] = ACTIONS(2276),
    [anon_sym_U_SQUOTE] = ACTIONS(2276),
    [anon_sym_u8_SQUOTE] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_L_DQUOTE] = ACTIONS(2276),
    [anon_sym_u_DQUOTE] = ACTIONS(2276),
    [anon_sym_U_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8_DQUOTE] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(2276),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [anon_sym_NULL] = ACTIONS(2274),
    [anon_sym_nullptr] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2274),
    [anon_sym_decltype] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_typename] = ACTIONS(2274),
    [anon_sym_template] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [anon_sym_delete] = ACTIONS(2274),
    [anon_sym_throw] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2274),
    [anon_sym_static_assert] = ACTIONS(2274),
    [anon_sym_concept] = ACTIONS(2274),
    [anon_sym_co_return] = ACTIONS(2274),
    [anon_sym_co_yield] = ACTIONS(2274),
    [anon_sym_R_DQUOTE] = ACTIONS(2276),
    [anon_sym_LR_DQUOTE] = ACTIONS(2276),
    [anon_sym_uR_DQUOTE] = ACTIONS(2276),
    [anon_sym_UR_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2276),
    [anon_sym_co_await] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2274),
    [sym_this] = ACTIONS(2274),
    [anon_sym_discard] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_groupshared] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_row_major] = ACTIONS(2274),
    [anon_sym_column_major] = ACTIONS(2274),
    [anon_sym_globallycoherent] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym_nointerpolation] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_linear] = ACTIONS(2274),
    [anon_sym_snorm] = ACTIONS(2274),
    [anon_sym_unorm] = ACTIONS(2274),
    [anon_sym_point] = ACTIONS(2274),
    [anon_sym_line] = ACTIONS(2274),
    [anon_sym_triangleadj] = ACTIONS(2274),
    [anon_sym_lineadj] = ACTIONS(2274),
    [anon_sym_triangle] = ACTIONS(2274),
    [anon_sym_cbuffer] = ACTIONS(2274),
  },
  [227] = {
    [sym_identifier] = ACTIONS(2278),
    [aux_sym_preproc_include_token1] = ACTIONS(2278),
    [aux_sym_preproc_def_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token2] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2278),
    [aux_sym_preproc_else_token1] = ACTIONS(2278),
    [aux_sym_preproc_elif_token1] = ACTIONS(2278),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2278),
    [sym_preproc_directive] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_PLUS] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym_typedef] = ACTIONS(2278),
    [anon_sym_in] = ACTIONS(2278),
    [anon_sym_out] = ACTIONS(2278),
    [anon_sym_inout] = ACTIONS(2278),
    [anon_sym_virtual] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2278),
    [anon_sym_using] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2280),
    [anon_sym___declspec] = ACTIONS(2278),
    [anon_sym___based] = ACTIONS(2278),
    [anon_sym___cdecl] = ACTIONS(2278),
    [anon_sym___clrcall] = ACTIONS(2278),
    [anon_sym___stdcall] = ACTIONS(2278),
    [anon_sym___fastcall] = ACTIONS(2278),
    [anon_sym___thiscall] = ACTIONS(2278),
    [anon_sym___vectorcall] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2278),
    [anon_sym_unsigned] = ACTIONS(2278),
    [anon_sym_long] = ACTIONS(2278),
    [anon_sym_short] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2278),
    [anon_sym_inline] = ACTIONS(2278),
    [anon_sym___inline] = ACTIONS(2278),
    [anon_sym___inline__] = ACTIONS(2278),
    [anon_sym___forceinline] = ACTIONS(2278),
    [anon_sym_thread_local] = ACTIONS(2278),
    [anon_sym___thread] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [sym_primitive_type] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_class] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2278),
    [anon_sym_default] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_do] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_goto] = ACTIONS(2278),
    [anon_sym___try] = ACTIONS(2278),
    [anon_sym___leave] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2278),
    [anon_sym_compl] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2278),
    [anon_sym___alignof__] = ACTIONS(2278),
    [anon_sym___alignof] = ACTIONS(2278),
    [anon_sym__alignof] = ACTIONS(2278),
    [anon_sym_alignof] = ACTIONS(2278),
    [anon_sym__Alignof] = ACTIONS(2278),
    [anon_sym_offsetof] = ACTIONS(2278),
    [anon_sym__Generic] = ACTIONS(2278),
    [anon_sym_asm] = ACTIONS(2278),
    [anon_sym___asm__] = ACTIONS(2278),
    [anon_sym___asm] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2280),
    [anon_sym_L_SQUOTE] = ACTIONS(2280),
    [anon_sym_u_SQUOTE] = ACTIONS(2280),
    [anon_sym_U_SQUOTE] = ACTIONS(2280),
    [anon_sym_u8_SQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_L_DQUOTE] = ACTIONS(2280),
    [anon_sym_u_DQUOTE] = ACTIONS(2280),
    [anon_sym_U_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8_DQUOTE] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [anon_sym_NULL] = ACTIONS(2278),
    [anon_sym_nullptr] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2278),
    [anon_sym_decltype] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_typename] = ACTIONS(2278),
    [anon_sym_template] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [anon_sym_delete] = ACTIONS(2278),
    [anon_sym_throw] = ACTIONS(2278),
    [anon_sym_namespace] = ACTIONS(2278),
    [anon_sym_static_assert] = ACTIONS(2278),
    [anon_sym_concept] = ACTIONS(2278),
    [anon_sym_co_return] = ACTIONS(2278),
    [anon_sym_co_yield] = ACTIONS(2278),
    [anon_sym_R_DQUOTE] = ACTIONS(2280),
    [anon_sym_LR_DQUOTE] = ACTIONS(2280),
    [anon_sym_uR_DQUOTE] = ACTIONS(2280),
    [anon_sym_UR_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2280),
    [anon_sym_co_await] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2278),
    [sym_this] = ACTIONS(2278),
    [anon_sym_discard] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2278),
    [anon_sym_shared] = ACTIONS(2278),
    [anon_sym_groupshared] = ACTIONS(2278),
    [anon_sym_uniform] = ACTIONS(2278),
    [anon_sym_row_major] = ACTIONS(2278),
    [anon_sym_column_major] = ACTIONS(2278),
    [anon_sym_globallycoherent] = ACTIONS(2278),
    [anon_sym_centroid] = ACTIONS(2278),
    [anon_sym_noperspective] = ACTIONS(2278),
    [anon_sym_nointerpolation] = ACTIONS(2278),
    [anon_sym_sample] = ACTIONS(2278),
    [anon_sym_linear] = ACTIONS(2278),
    [anon_sym_snorm] = ACTIONS(2278),
    [anon_sym_unorm] = ACTIONS(2278),
    [anon_sym_point] = ACTIONS(2278),
    [anon_sym_line] = ACTIONS(2278),
    [anon_sym_triangleadj] = ACTIONS(2278),
    [anon_sym_lineadj] = ACTIONS(2278),
    [anon_sym_triangle] = ACTIONS(2278),
    [anon_sym_cbuffer] = ACTIONS(2278),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [aux_sym_preproc_else_token1] = ACTIONS(1951),
    [aux_sym_preproc_elif_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [229] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [aux_sym_preproc_else_token1] = ACTIONS(2284),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
  },
  [230] = {
    [ts_builtin_sym_end] = ACTIONS(2147),
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_include_token1] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym___cdecl] = ACTIONS(2145),
    [anon_sym___clrcall] = ACTIONS(2145),
    [anon_sym___stdcall] = ACTIONS(2145),
    [anon_sym___fastcall] = ACTIONS(2145),
    [anon_sym___thiscall] = ACTIONS(2145),
    [anon_sym___vectorcall] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_goto] = ACTIONS(2145),
    [anon_sym___try] = ACTIONS(2145),
    [anon_sym___leave] = ACTIONS(2145),
    [anon_sym_not] = ACTIONS(2145),
    [anon_sym_compl] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2145),
    [anon_sym___alignof__] = ACTIONS(2145),
    [anon_sym___alignof] = ACTIONS(2145),
    [anon_sym__alignof] = ACTIONS(2145),
    [anon_sym_alignof] = ACTIONS(2145),
    [anon_sym__Alignof] = ACTIONS(2145),
    [anon_sym_offsetof] = ACTIONS(2145),
    [anon_sym__Generic] = ACTIONS(2145),
    [anon_sym_asm] = ACTIONS(2145),
    [anon_sym___asm__] = ACTIONS(2145),
    [anon_sym___asm] = ACTIONS(2145),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [anon_sym_NULL] = ACTIONS(2145),
    [anon_sym_nullptr] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_export] = ACTIONS(2145),
    [anon_sym_module] = ACTIONS(2145),
    [anon_sym_import] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_concept] = ACTIONS(2145),
    [anon_sym_co_return] = ACTIONS(2145),
    [anon_sym_co_yield] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_R_DQUOTE] = ACTIONS(2147),
    [anon_sym_LR_DQUOTE] = ACTIONS(2147),
    [anon_sym_uR_DQUOTE] = ACTIONS(2147),
    [anon_sym_UR_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2147),
    [anon_sym_co_await] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_discard] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
    [anon_sym_cbuffer] = ACTIONS(2145),
  },
  [231] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [aux_sym_preproc_else_token1] = ACTIONS(2288),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
  },
  [232] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [233] = {
    [sym_else_clause] = STATE(411),
    [ts_builtin_sym_end] = ACTIONS(2135),
    [sym_identifier] = ACTIONS(2133),
    [aux_sym_preproc_include_token1] = ACTIONS(2133),
    [aux_sym_preproc_def_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2133),
    [sym_preproc_directive] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym___extension__] = ACTIONS(2133),
    [anon_sym_typedef] = ACTIONS(2133),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_out] = ACTIONS(2133),
    [anon_sym_inout] = ACTIONS(2133),
    [anon_sym_virtual] = ACTIONS(2133),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym___attribute__] = ACTIONS(2133),
    [anon_sym___attribute] = ACTIONS(2133),
    [anon_sym_using] = ACTIONS(2133),
    [anon_sym_COLON_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2135),
    [anon_sym___declspec] = ACTIONS(2133),
    [anon_sym___based] = ACTIONS(2133),
    [anon_sym___cdecl] = ACTIONS(2133),
    [anon_sym___clrcall] = ACTIONS(2133),
    [anon_sym___stdcall] = ACTIONS(2133),
    [anon_sym___fastcall] = ACTIONS(2133),
    [anon_sym___thiscall] = ACTIONS(2133),
    [anon_sym___vectorcall] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_signed] = ACTIONS(2133),
    [anon_sym_unsigned] = ACTIONS(2133),
    [anon_sym_long] = ACTIONS(2133),
    [anon_sym_short] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym___inline] = ACTIONS(2133),
    [anon_sym___inline__] = ACTIONS(2133),
    [anon_sym___forceinline] = ACTIONS(2133),
    [anon_sym_thread_local] = ACTIONS(2133),
    [anon_sym___thread] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_constexpr] = ACTIONS(2133),
    [anon_sym_volatile] = ACTIONS(2133),
    [anon_sym_restrict] = ACTIONS(2133),
    [anon_sym___restrict__] = ACTIONS(2133),
    [anon_sym__Atomic] = ACTIONS(2133),
    [anon_sym__Noreturn] = ACTIONS(2133),
    [anon_sym_noreturn] = ACTIONS(2133),
    [anon_sym__Nonnull] = ACTIONS(2133),
    [anon_sym_mutable] = ACTIONS(2133),
    [anon_sym_constinit] = ACTIONS(2133),
    [anon_sym_consteval] = ACTIONS(2133),
    [anon_sym_alignas] = ACTIONS(2133),
    [anon_sym__Alignas] = ACTIONS(2133),
    [sym_primitive_type] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2133),
    [anon_sym_union] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2294),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_goto] = ACTIONS(2133),
    [anon_sym___try] = ACTIONS(2133),
    [anon_sym___leave] = ACTIONS(2133),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_compl] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_sizeof] = ACTIONS(2133),
    [anon_sym___alignof__] = ACTIONS(2133),
    [anon_sym___alignof] = ACTIONS(2133),
    [anon_sym__alignof] = ACTIONS(2133),
    [anon_sym_alignof] = ACTIONS(2133),
    [anon_sym__Alignof] = ACTIONS(2133),
    [anon_sym_offsetof] = ACTIONS(2133),
    [anon_sym__Generic] = ACTIONS(2133),
    [anon_sym_asm] = ACTIONS(2133),
    [anon_sym___asm__] = ACTIONS(2133),
    [anon_sym___asm] = ACTIONS(2133),
    [sym_number_literal] = ACTIONS(2135),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2135),
    [anon_sym_u_DQUOTE] = ACTIONS(2135),
    [anon_sym_U_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [anon_sym_NULL] = ACTIONS(2133),
    [anon_sym_nullptr] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2133),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_explicit] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2133),
    [anon_sym_export] = ACTIONS(2133),
    [anon_sym_module] = ACTIONS(2133),
    [anon_sym_import] = ACTIONS(2133),
    [anon_sym_template] = ACTIONS(2133),
    [anon_sym_operator] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_static_assert] = ACTIONS(2133),
    [anon_sym_concept] = ACTIONS(2133),
    [anon_sym_co_return] = ACTIONS(2133),
    [anon_sym_co_yield] = ACTIONS(2133),
    [anon_sym_R_DQUOTE] = ACTIONS(2135),
    [anon_sym_LR_DQUOTE] = ACTIONS(2135),
    [anon_sym_uR_DQUOTE] = ACTIONS(2135),
    [anon_sym_UR_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2135),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_requires] = ACTIONS(2133),
    [sym_this] = ACTIONS(2133),
    [anon_sym_discard] = ACTIONS(2133),
    [anon_sym_precise] = ACTIONS(2133),
    [anon_sym_shared] = ACTIONS(2133),
    [anon_sym_groupshared] = ACTIONS(2133),
    [anon_sym_uniform] = ACTIONS(2133),
    [anon_sym_row_major] = ACTIONS(2133),
    [anon_sym_column_major] = ACTIONS(2133),
    [anon_sym_globallycoherent] = ACTIONS(2133),
    [anon_sym_centroid] = ACTIONS(2133),
    [anon_sym_noperspective] = ACTIONS(2133),
    [anon_sym_nointerpolation] = ACTIONS(2133),
    [anon_sym_sample] = ACTIONS(2133),
    [anon_sym_linear] = ACTIONS(2133),
    [anon_sym_snorm] = ACTIONS(2133),
    [anon_sym_unorm] = ACTIONS(2133),
    [anon_sym_point] = ACTIONS(2133),
    [anon_sym_line] = ACTIONS(2133),
    [anon_sym_triangleadj] = ACTIONS(2133),
    [anon_sym_lineadj] = ACTIONS(2133),
    [anon_sym_triangle] = ACTIONS(2133),
    [anon_sym_cbuffer] = ACTIONS(2133),
  },
  [234] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [235] = {
    [sym_identifier] = ACTIONS(2298),
    [aux_sym_preproc_include_token1] = ACTIONS(2298),
    [aux_sym_preproc_def_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token2] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2298),
    [aux_sym_preproc_else_token1] = ACTIONS(2298),
    [aux_sym_preproc_elif_token1] = ACTIONS(2298),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_using] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym___based] = ACTIONS(2298),
    [anon_sym___cdecl] = ACTIONS(2298),
    [anon_sym___clrcall] = ACTIONS(2298),
    [anon_sym___stdcall] = ACTIONS(2298),
    [anon_sym___fastcall] = ACTIONS(2298),
    [anon_sym___thiscall] = ACTIONS(2298),
    [anon_sym___vectorcall] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym___try] = ACTIONS(2298),
    [anon_sym___leave] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2298),
    [anon_sym_compl] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2298),
    [anon_sym___alignof__] = ACTIONS(2298),
    [anon_sym___alignof] = ACTIONS(2298),
    [anon_sym__alignof] = ACTIONS(2298),
    [anon_sym_alignof] = ACTIONS(2298),
    [anon_sym__Alignof] = ACTIONS(2298),
    [anon_sym_offsetof] = ACTIONS(2298),
    [anon_sym__Generic] = ACTIONS(2298),
    [anon_sym_asm] = ACTIONS(2298),
    [anon_sym___asm__] = ACTIONS(2298),
    [anon_sym___asm] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2300),
    [anon_sym_L_SQUOTE] = ACTIONS(2300),
    [anon_sym_u_SQUOTE] = ACTIONS(2300),
    [anon_sym_U_SQUOTE] = ACTIONS(2300),
    [anon_sym_u8_SQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_L_DQUOTE] = ACTIONS(2300),
    [anon_sym_u_DQUOTE] = ACTIONS(2300),
    [anon_sym_U_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8_DQUOTE] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [anon_sym_NULL] = ACTIONS(2298),
    [anon_sym_nullptr] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2298),
    [anon_sym_explicit] = ACTIONS(2298),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_namespace] = ACTIONS(2298),
    [anon_sym_static_assert] = ACTIONS(2298),
    [anon_sym_concept] = ACTIONS(2298),
    [anon_sym_co_return] = ACTIONS(2298),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2300),
    [anon_sym_LR_DQUOTE] = ACTIONS(2300),
    [anon_sym_uR_DQUOTE] = ACTIONS(2300),
    [anon_sym_UR_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2300),
    [anon_sym_co_await] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_discard] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
    [anon_sym_cbuffer] = ACTIONS(2298),
  },
  [236] = {
    [sym_identifier] = ACTIONS(2302),
    [aux_sym_preproc_include_token1] = ACTIONS(2302),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token2] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2302),
    [aux_sym_preproc_else_token1] = ACTIONS(2302),
    [aux_sym_preproc_elif_token1] = ACTIONS(2302),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2302),
    [sym_preproc_directive] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_PLUS] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym_typedef] = ACTIONS(2302),
    [anon_sym_in] = ACTIONS(2302),
    [anon_sym_out] = ACTIONS(2302),
    [anon_sym_inout] = ACTIONS(2302),
    [anon_sym_virtual] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2302),
    [anon_sym_using] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2304),
    [anon_sym___declspec] = ACTIONS(2302),
    [anon_sym___based] = ACTIONS(2302),
    [anon_sym___cdecl] = ACTIONS(2302),
    [anon_sym___clrcall] = ACTIONS(2302),
    [anon_sym___stdcall] = ACTIONS(2302),
    [anon_sym___fastcall] = ACTIONS(2302),
    [anon_sym___thiscall] = ACTIONS(2302),
    [anon_sym___vectorcall] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2302),
    [anon_sym_unsigned] = ACTIONS(2302),
    [anon_sym_long] = ACTIONS(2302),
    [anon_sym_short] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2302),
    [anon_sym_inline] = ACTIONS(2302),
    [anon_sym___inline] = ACTIONS(2302),
    [anon_sym___inline__] = ACTIONS(2302),
    [anon_sym___forceinline] = ACTIONS(2302),
    [anon_sym_thread_local] = ACTIONS(2302),
    [anon_sym___thread] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [sym_primitive_type] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_class] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2302),
    [anon_sym_default] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_goto] = ACTIONS(2302),
    [anon_sym___try] = ACTIONS(2302),
    [anon_sym___leave] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2302),
    [anon_sym_compl] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2302),
    [anon_sym___alignof__] = ACTIONS(2302),
    [anon_sym___alignof] = ACTIONS(2302),
    [anon_sym__alignof] = ACTIONS(2302),
    [anon_sym_alignof] = ACTIONS(2302),
    [anon_sym__Alignof] = ACTIONS(2302),
    [anon_sym_offsetof] = ACTIONS(2302),
    [anon_sym__Generic] = ACTIONS(2302),
    [anon_sym_asm] = ACTIONS(2302),
    [anon_sym___asm__] = ACTIONS(2302),
    [anon_sym___asm] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2304),
    [anon_sym_L_SQUOTE] = ACTIONS(2304),
    [anon_sym_u_SQUOTE] = ACTIONS(2304),
    [anon_sym_U_SQUOTE] = ACTIONS(2304),
    [anon_sym_u8_SQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_L_DQUOTE] = ACTIONS(2304),
    [anon_sym_u_DQUOTE] = ACTIONS(2304),
    [anon_sym_U_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8_DQUOTE] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [anon_sym_NULL] = ACTIONS(2302),
    [anon_sym_nullptr] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2302),
    [anon_sym_decltype] = ACTIONS(2302),
    [anon_sym_explicit] = ACTIONS(2302),
    [anon_sym_typename] = ACTIONS(2302),
    [anon_sym_template] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [anon_sym_delete] = ACTIONS(2302),
    [anon_sym_throw] = ACTIONS(2302),
    [anon_sym_namespace] = ACTIONS(2302),
    [anon_sym_static_assert] = ACTIONS(2302),
    [anon_sym_concept] = ACTIONS(2302),
    [anon_sym_co_return] = ACTIONS(2302),
    [anon_sym_co_yield] = ACTIONS(2302),
    [anon_sym_R_DQUOTE] = ACTIONS(2304),
    [anon_sym_LR_DQUOTE] = ACTIONS(2304),
    [anon_sym_uR_DQUOTE] = ACTIONS(2304),
    [anon_sym_UR_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2304),
    [anon_sym_co_await] = ACTIONS(2302),
    [anon_sym_new] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2302),
    [sym_this] = ACTIONS(2302),
    [anon_sym_discard] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2302),
    [anon_sym_shared] = ACTIONS(2302),
    [anon_sym_groupshared] = ACTIONS(2302),
    [anon_sym_uniform] = ACTIONS(2302),
    [anon_sym_row_major] = ACTIONS(2302),
    [anon_sym_column_major] = ACTIONS(2302),
    [anon_sym_globallycoherent] = ACTIONS(2302),
    [anon_sym_centroid] = ACTIONS(2302),
    [anon_sym_noperspective] = ACTIONS(2302),
    [anon_sym_nointerpolation] = ACTIONS(2302),
    [anon_sym_sample] = ACTIONS(2302),
    [anon_sym_linear] = ACTIONS(2302),
    [anon_sym_snorm] = ACTIONS(2302),
    [anon_sym_unorm] = ACTIONS(2302),
    [anon_sym_point] = ACTIONS(2302),
    [anon_sym_line] = ACTIONS(2302),
    [anon_sym_triangleadj] = ACTIONS(2302),
    [anon_sym_lineadj] = ACTIONS(2302),
    [anon_sym_triangle] = ACTIONS(2302),
    [anon_sym_cbuffer] = ACTIONS(2302),
  },
  [237] = {
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_preproc_include_token1] = ACTIONS(2306),
    [aux_sym_preproc_def_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token2] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2306),
    [aux_sym_preproc_else_token1] = ACTIONS(2306),
    [aux_sym_preproc_elif_token1] = ACTIONS(2306),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2306),
    [sym_preproc_directive] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym_typedef] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_out] = ACTIONS(2306),
    [anon_sym_inout] = ACTIONS(2306),
    [anon_sym_virtual] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2306),
    [anon_sym_using] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2308),
    [anon_sym___declspec] = ACTIONS(2306),
    [anon_sym___based] = ACTIONS(2306),
    [anon_sym___cdecl] = ACTIONS(2306),
    [anon_sym___clrcall] = ACTIONS(2306),
    [anon_sym___stdcall] = ACTIONS(2306),
    [anon_sym___fastcall] = ACTIONS(2306),
    [anon_sym___thiscall] = ACTIONS(2306),
    [anon_sym___vectorcall] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym___inline] = ACTIONS(2306),
    [anon_sym___inline__] = ACTIONS(2306),
    [anon_sym___forceinline] = ACTIONS(2306),
    [anon_sym_thread_local] = ACTIONS(2306),
    [anon_sym___thread] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_class] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2306),
    [anon_sym_default] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_goto] = ACTIONS(2306),
    [anon_sym___try] = ACTIONS(2306),
    [anon_sym___leave] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2306),
    [anon_sym_compl] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2306),
    [anon_sym___alignof__] = ACTIONS(2306),
    [anon_sym___alignof] = ACTIONS(2306),
    [anon_sym__alignof] = ACTIONS(2306),
    [anon_sym_alignof] = ACTIONS(2306),
    [anon_sym__Alignof] = ACTIONS(2306),
    [anon_sym_offsetof] = ACTIONS(2306),
    [anon_sym__Generic] = ACTIONS(2306),
    [anon_sym_asm] = ACTIONS(2306),
    [anon_sym___asm__] = ACTIONS(2306),
    [anon_sym___asm] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2308),
    [anon_sym_L_SQUOTE] = ACTIONS(2308),
    [anon_sym_u_SQUOTE] = ACTIONS(2308),
    [anon_sym_U_SQUOTE] = ACTIONS(2308),
    [anon_sym_u8_SQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_L_DQUOTE] = ACTIONS(2308),
    [anon_sym_u_DQUOTE] = ACTIONS(2308),
    [anon_sym_U_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8_DQUOTE] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [anon_sym_NULL] = ACTIONS(2306),
    [anon_sym_nullptr] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2306),
    [anon_sym_decltype] = ACTIONS(2306),
    [anon_sym_explicit] = ACTIONS(2306),
    [anon_sym_typename] = ACTIONS(2306),
    [anon_sym_template] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [anon_sym_delete] = ACTIONS(2306),
    [anon_sym_throw] = ACTIONS(2306),
    [anon_sym_namespace] = ACTIONS(2306),
    [anon_sym_static_assert] = ACTIONS(2306),
    [anon_sym_concept] = ACTIONS(2306),
    [anon_sym_co_return] = ACTIONS(2306),
    [anon_sym_co_yield] = ACTIONS(2306),
    [anon_sym_R_DQUOTE] = ACTIONS(2308),
    [anon_sym_LR_DQUOTE] = ACTIONS(2308),
    [anon_sym_uR_DQUOTE] = ACTIONS(2308),
    [anon_sym_UR_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2308),
    [anon_sym_co_await] = ACTIONS(2306),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2306),
    [sym_this] = ACTIONS(2306),
    [anon_sym_discard] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2306),
    [anon_sym_shared] = ACTIONS(2306),
    [anon_sym_groupshared] = ACTIONS(2306),
    [anon_sym_uniform] = ACTIONS(2306),
    [anon_sym_row_major] = ACTIONS(2306),
    [anon_sym_column_major] = ACTIONS(2306),
    [anon_sym_globallycoherent] = ACTIONS(2306),
    [anon_sym_centroid] = ACTIONS(2306),
    [anon_sym_noperspective] = ACTIONS(2306),
    [anon_sym_nointerpolation] = ACTIONS(2306),
    [anon_sym_sample] = ACTIONS(2306),
    [anon_sym_linear] = ACTIONS(2306),
    [anon_sym_snorm] = ACTIONS(2306),
    [anon_sym_unorm] = ACTIONS(2306),
    [anon_sym_point] = ACTIONS(2306),
    [anon_sym_line] = ACTIONS(2306),
    [anon_sym_triangleadj] = ACTIONS(2306),
    [anon_sym_lineadj] = ACTIONS(2306),
    [anon_sym_triangle] = ACTIONS(2306),
    [anon_sym_cbuffer] = ACTIONS(2306),
  },
  [238] = {
    [sym_identifier] = ACTIONS(2310),
    [aux_sym_preproc_include_token1] = ACTIONS(2310),
    [aux_sym_preproc_def_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token2] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2310),
    [aux_sym_preproc_else_token1] = ACTIONS(2310),
    [aux_sym_preproc_elif_token1] = ACTIONS(2310),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2310),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym_typedef] = ACTIONS(2310),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_out] = ACTIONS(2310),
    [anon_sym_inout] = ACTIONS(2310),
    [anon_sym_virtual] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2310),
    [anon_sym_using] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2312),
    [anon_sym___declspec] = ACTIONS(2310),
    [anon_sym___based] = ACTIONS(2310),
    [anon_sym___cdecl] = ACTIONS(2310),
    [anon_sym___clrcall] = ACTIONS(2310),
    [anon_sym___stdcall] = ACTIONS(2310),
    [anon_sym___fastcall] = ACTIONS(2310),
    [anon_sym___thiscall] = ACTIONS(2310),
    [anon_sym___vectorcall] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2310),
    [anon_sym_unsigned] = ACTIONS(2310),
    [anon_sym_long] = ACTIONS(2310),
    [anon_sym_short] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2310),
    [anon_sym_inline] = ACTIONS(2310),
    [anon_sym___inline] = ACTIONS(2310),
    [anon_sym___inline__] = ACTIONS(2310),
    [anon_sym___forceinline] = ACTIONS(2310),
    [anon_sym_thread_local] = ACTIONS(2310),
    [anon_sym___thread] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [sym_primitive_type] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_class] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2310),
    [anon_sym_switch] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_goto] = ACTIONS(2310),
    [anon_sym___try] = ACTIONS(2310),
    [anon_sym___leave] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_compl] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2310),
    [anon_sym___alignof__] = ACTIONS(2310),
    [anon_sym___alignof] = ACTIONS(2310),
    [anon_sym__alignof] = ACTIONS(2310),
    [anon_sym_alignof] = ACTIONS(2310),
    [anon_sym__Alignof] = ACTIONS(2310),
    [anon_sym_offsetof] = ACTIONS(2310),
    [anon_sym__Generic] = ACTIONS(2310),
    [anon_sym_asm] = ACTIONS(2310),
    [anon_sym___asm__] = ACTIONS(2310),
    [anon_sym___asm] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2312),
    [anon_sym_L_SQUOTE] = ACTIONS(2312),
    [anon_sym_u_SQUOTE] = ACTIONS(2312),
    [anon_sym_U_SQUOTE] = ACTIONS(2312),
    [anon_sym_u8_SQUOTE] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_L_DQUOTE] = ACTIONS(2312),
    [anon_sym_u_DQUOTE] = ACTIONS(2312),
    [anon_sym_U_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [anon_sym_NULL] = ACTIONS(2310),
    [anon_sym_nullptr] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2310),
    [anon_sym_decltype] = ACTIONS(2310),
    [anon_sym_explicit] = ACTIONS(2310),
    [anon_sym_typename] = ACTIONS(2310),
    [anon_sym_template] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [anon_sym_delete] = ACTIONS(2310),
    [anon_sym_throw] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2310),
    [anon_sym_static_assert] = ACTIONS(2310),
    [anon_sym_concept] = ACTIONS(2310),
    [anon_sym_co_return] = ACTIONS(2310),
    [anon_sym_co_yield] = ACTIONS(2310),
    [anon_sym_R_DQUOTE] = ACTIONS(2312),
    [anon_sym_LR_DQUOTE] = ACTIONS(2312),
    [anon_sym_uR_DQUOTE] = ACTIONS(2312),
    [anon_sym_UR_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2312),
    [anon_sym_co_await] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2310),
    [sym_this] = ACTIONS(2310),
    [anon_sym_discard] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2310),
    [anon_sym_shared] = ACTIONS(2310),
    [anon_sym_groupshared] = ACTIONS(2310),
    [anon_sym_uniform] = ACTIONS(2310),
    [anon_sym_row_major] = ACTIONS(2310),
    [anon_sym_column_major] = ACTIONS(2310),
    [anon_sym_globallycoherent] = ACTIONS(2310),
    [anon_sym_centroid] = ACTIONS(2310),
    [anon_sym_noperspective] = ACTIONS(2310),
    [anon_sym_nointerpolation] = ACTIONS(2310),
    [anon_sym_sample] = ACTIONS(2310),
    [anon_sym_linear] = ACTIONS(2310),
    [anon_sym_snorm] = ACTIONS(2310),
    [anon_sym_unorm] = ACTIONS(2310),
    [anon_sym_point] = ACTIONS(2310),
    [anon_sym_line] = ACTIONS(2310),
    [anon_sym_triangleadj] = ACTIONS(2310),
    [anon_sym_lineadj] = ACTIONS(2310),
    [anon_sym_triangle] = ACTIONS(2310),
    [anon_sym_cbuffer] = ACTIONS(2310),
  },
  [239] = {
    [sym_identifier] = ACTIONS(2314),
    [aux_sym_preproc_include_token1] = ACTIONS(2314),
    [aux_sym_preproc_def_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token2] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2314),
    [aux_sym_preproc_else_token1] = ACTIONS(2314),
    [aux_sym_preproc_elif_token1] = ACTIONS(2314),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2314),
    [sym_preproc_directive] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP_AMP] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym_typedef] = ACTIONS(2314),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_out] = ACTIONS(2314),
    [anon_sym_inout] = ACTIONS(2314),
    [anon_sym_virtual] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2316),
    [anon_sym___declspec] = ACTIONS(2314),
    [anon_sym___based] = ACTIONS(2314),
    [anon_sym___cdecl] = ACTIONS(2314),
    [anon_sym___clrcall] = ACTIONS(2314),
    [anon_sym___stdcall] = ACTIONS(2314),
    [anon_sym___fastcall] = ACTIONS(2314),
    [anon_sym___thiscall] = ACTIONS(2314),
    [anon_sym___vectorcall] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_signed] = ACTIONS(2314),
    [anon_sym_unsigned] = ACTIONS(2314),
    [anon_sym_long] = ACTIONS(2314),
    [anon_sym_short] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym___inline] = ACTIONS(2314),
    [anon_sym___inline__] = ACTIONS(2314),
    [anon_sym___forceinline] = ACTIONS(2314),
    [anon_sym_thread_local] = ACTIONS(2314),
    [anon_sym___thread] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [sym_primitive_type] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_goto] = ACTIONS(2314),
    [anon_sym___try] = ACTIONS(2314),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_compl] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2314),
    [anon_sym___alignof__] = ACTIONS(2314),
    [anon_sym___alignof] = ACTIONS(2314),
    [anon_sym__alignof] = ACTIONS(2314),
    [anon_sym_alignof] = ACTIONS(2314),
    [anon_sym__Alignof] = ACTIONS(2314),
    [anon_sym_offsetof] = ACTIONS(2314),
    [anon_sym__Generic] = ACTIONS(2314),
    [anon_sym_asm] = ACTIONS(2314),
    [anon_sym___asm__] = ACTIONS(2314),
    [anon_sym___asm] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_L_SQUOTE] = ACTIONS(2316),
    [anon_sym_u_SQUOTE] = ACTIONS(2316),
    [anon_sym_U_SQUOTE] = ACTIONS(2316),
    [anon_sym_u8_SQUOTE] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_L_DQUOTE] = ACTIONS(2316),
    [anon_sym_u_DQUOTE] = ACTIONS(2316),
    [anon_sym_U_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8_DQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [anon_sym_NULL] = ACTIONS(2314),
    [anon_sym_nullptr] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2314),
    [anon_sym_decltype] = ACTIONS(2314),
    [anon_sym_explicit] = ACTIONS(2314),
    [anon_sym_typename] = ACTIONS(2314),
    [anon_sym_template] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_namespace] = ACTIONS(2314),
    [anon_sym_static_assert] = ACTIONS(2314),
    [anon_sym_concept] = ACTIONS(2314),
    [anon_sym_co_return] = ACTIONS(2314),
    [anon_sym_co_yield] = ACTIONS(2314),
    [anon_sym_R_DQUOTE] = ACTIONS(2316),
    [anon_sym_LR_DQUOTE] = ACTIONS(2316),
    [anon_sym_uR_DQUOTE] = ACTIONS(2316),
    [anon_sym_UR_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2316),
    [anon_sym_co_await] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_discard] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2314),
    [anon_sym_shared] = ACTIONS(2314),
    [anon_sym_groupshared] = ACTIONS(2314),
    [anon_sym_uniform] = ACTIONS(2314),
    [anon_sym_row_major] = ACTIONS(2314),
    [anon_sym_column_major] = ACTIONS(2314),
    [anon_sym_globallycoherent] = ACTIONS(2314),
    [anon_sym_centroid] = ACTIONS(2314),
    [anon_sym_noperspective] = ACTIONS(2314),
    [anon_sym_nointerpolation] = ACTIONS(2314),
    [anon_sym_sample] = ACTIONS(2314),
    [anon_sym_linear] = ACTIONS(2314),
    [anon_sym_snorm] = ACTIONS(2314),
    [anon_sym_unorm] = ACTIONS(2314),
    [anon_sym_point] = ACTIONS(2314),
    [anon_sym_line] = ACTIONS(2314),
    [anon_sym_triangleadj] = ACTIONS(2314),
    [anon_sym_lineadj] = ACTIONS(2314),
    [anon_sym_triangle] = ACTIONS(2314),
    [anon_sym_cbuffer] = ACTIONS(2314),
  },
  [240] = {
    [sym_identifier] = ACTIONS(2318),
    [aux_sym_preproc_include_token1] = ACTIONS(2318),
    [aux_sym_preproc_def_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token2] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2318),
    [aux_sym_preproc_else_token1] = ACTIONS(2318),
    [aux_sym_preproc_elif_token1] = ACTIONS(2318),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2318),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_LPAREN2] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_AMP_AMP] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym___extension__] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_in] = ACTIONS(2318),
    [anon_sym_out] = ACTIONS(2318),
    [anon_sym_inout] = ACTIONS(2318),
    [anon_sym_virtual] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym___attribute__] = ACTIONS(2318),
    [anon_sym___attribute] = ACTIONS(2318),
    [anon_sym_using] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2320),
    [anon_sym___declspec] = ACTIONS(2318),
    [anon_sym___based] = ACTIONS(2318),
    [anon_sym___cdecl] = ACTIONS(2318),
    [anon_sym___clrcall] = ACTIONS(2318),
    [anon_sym___stdcall] = ACTIONS(2318),
    [anon_sym___fastcall] = ACTIONS(2318),
    [anon_sym___thiscall] = ACTIONS(2318),
    [anon_sym___vectorcall] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_signed] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym___inline] = ACTIONS(2318),
    [anon_sym___inline__] = ACTIONS(2318),
    [anon_sym___forceinline] = ACTIONS(2318),
    [anon_sym_thread_local] = ACTIONS(2318),
    [anon_sym___thread] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_constexpr] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym___restrict__] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym__Noreturn] = ACTIONS(2318),
    [anon_sym_noreturn] = ACTIONS(2318),
    [anon_sym__Nonnull] = ACTIONS(2318),
    [anon_sym_mutable] = ACTIONS(2318),
    [anon_sym_constinit] = ACTIONS(2318),
    [anon_sym_consteval] = ACTIONS(2318),
    [anon_sym_alignas] = ACTIONS(2318),
    [anon_sym__Alignas] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_class] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym___try] = ACTIONS(2318),
    [anon_sym___leave] = ACTIONS(2318),
    [anon_sym_not] = ACTIONS(2318),
    [anon_sym_compl] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2318),
    [anon_sym___alignof__] = ACTIONS(2318),
    [anon_sym___alignof] = ACTIONS(2318),
    [anon_sym__alignof] = ACTIONS(2318),
    [anon_sym_alignof] = ACTIONS(2318),
    [anon_sym__Alignof] = ACTIONS(2318),
    [anon_sym_offsetof] = ACTIONS(2318),
    [anon_sym__Generic] = ACTIONS(2318),
    [anon_sym_asm] = ACTIONS(2318),
    [anon_sym___asm__] = ACTIONS(2318),
    [anon_sym___asm] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2320),
    [anon_sym_L_SQUOTE] = ACTIONS(2320),
    [anon_sym_u_SQUOTE] = ACTIONS(2320),
    [anon_sym_U_SQUOTE] = ACTIONS(2320),
    [anon_sym_u8_SQUOTE] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_L_DQUOTE] = ACTIONS(2320),
    [anon_sym_u_DQUOTE] = ACTIONS(2320),
    [anon_sym_U_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8_DQUOTE] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(2320),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [anon_sym_NULL] = ACTIONS(2318),
    [anon_sym_nullptr] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2318),
    [anon_sym_decltype] = ACTIONS(2318),
    [anon_sym_explicit] = ACTIONS(2318),
    [anon_sym_typename] = ACTIONS(2318),
    [anon_sym_template] = ACTIONS(2318),
    [anon_sym_operator] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [anon_sym_delete] = ACTIONS(2318),
    [anon_sym_throw] = ACTIONS(2318),
    [anon_sym_namespace] = ACTIONS(2318),
    [anon_sym_static_assert] = ACTIONS(2318),
    [anon_sym_concept] = ACTIONS(2318),
    [anon_sym_co_return] = ACTIONS(2318),
    [anon_sym_co_yield] = ACTIONS(2318),
    [anon_sym_R_DQUOTE] = ACTIONS(2320),
    [anon_sym_LR_DQUOTE] = ACTIONS(2320),
    [anon_sym_uR_DQUOTE] = ACTIONS(2320),
    [anon_sym_UR_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2320),
    [anon_sym_co_await] = ACTIONS(2318),
    [anon_sym_new] = ACTIONS(2318),
    [anon_sym_requires] = ACTIONS(2318),
    [sym_this] = ACTIONS(2318),
    [anon_sym_discard] = ACTIONS(2318),
    [anon_sym_precise] = ACTIONS(2318),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_groupshared] = ACTIONS(2318),
    [anon_sym_uniform] = ACTIONS(2318),
    [anon_sym_row_major] = ACTIONS(2318),
    [anon_sym_column_major] = ACTIONS(2318),
    [anon_sym_globallycoherent] = ACTIONS(2318),
    [anon_sym_centroid] = ACTIONS(2318),
    [anon_sym_noperspective] = ACTIONS(2318),
    [anon_sym_nointerpolation] = ACTIONS(2318),
    [anon_sym_sample] = ACTIONS(2318),
    [anon_sym_linear] = ACTIONS(2318),
    [anon_sym_snorm] = ACTIONS(2318),
    [anon_sym_unorm] = ACTIONS(2318),
    [anon_sym_point] = ACTIONS(2318),
    [anon_sym_line] = ACTIONS(2318),
    [anon_sym_triangleadj] = ACTIONS(2318),
    [anon_sym_lineadj] = ACTIONS(2318),
    [anon_sym_triangle] = ACTIONS(2318),
    [anon_sym_cbuffer] = ACTIONS(2318),
  },
  [241] = {
    [sym_identifier] = ACTIONS(2322),
    [aux_sym_preproc_include_token1] = ACTIONS(2322),
    [aux_sym_preproc_def_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token2] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2322),
    [aux_sym_preproc_else_token1] = ACTIONS(2322),
    [aux_sym_preproc_elif_token1] = ACTIONS(2322),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2322),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2322),
    [sym_preproc_directive] = ACTIONS(2322),
    [anon_sym_LPAREN2] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym___extension__] = ACTIONS(2322),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(2322),
    [anon_sym_out] = ACTIONS(2322),
    [anon_sym_inout] = ACTIONS(2322),
    [anon_sym_virtual] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym___attribute__] = ACTIONS(2322),
    [anon_sym___attribute] = ACTIONS(2322),
    [anon_sym_using] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2324),
    [anon_sym___declspec] = ACTIONS(2322),
    [anon_sym___based] = ACTIONS(2322),
    [anon_sym___cdecl] = ACTIONS(2322),
    [anon_sym___clrcall] = ACTIONS(2322),
    [anon_sym___stdcall] = ACTIONS(2322),
    [anon_sym___fastcall] = ACTIONS(2322),
    [anon_sym___thiscall] = ACTIONS(2322),
    [anon_sym___vectorcall] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_signed] = ACTIONS(2322),
    [anon_sym_unsigned] = ACTIONS(2322),
    [anon_sym_long] = ACTIONS(2322),
    [anon_sym_short] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_register] = ACTIONS(2322),
    [anon_sym_inline] = ACTIONS(2322),
    [anon_sym___inline] = ACTIONS(2322),
    [anon_sym___inline__] = ACTIONS(2322),
    [anon_sym___forceinline] = ACTIONS(2322),
    [anon_sym_thread_local] = ACTIONS(2322),
    [anon_sym___thread] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_constexpr] = ACTIONS(2322),
    [anon_sym_volatile] = ACTIONS(2322),
    [anon_sym_restrict] = ACTIONS(2322),
    [anon_sym___restrict__] = ACTIONS(2322),
    [anon_sym__Atomic] = ACTIONS(2322),
    [anon_sym__Noreturn] = ACTIONS(2322),
    [anon_sym_noreturn] = ACTIONS(2322),
    [anon_sym__Nonnull] = ACTIONS(2322),
    [anon_sym_mutable] = ACTIONS(2322),
    [anon_sym_constinit] = ACTIONS(2322),
    [anon_sym_consteval] = ACTIONS(2322),
    [anon_sym_alignas] = ACTIONS(2322),
    [anon_sym__Alignas] = ACTIONS(2322),
    [sym_primitive_type] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_class] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2322),
    [anon_sym_switch] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2322),
    [anon_sym_default] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_goto] = ACTIONS(2322),
    [anon_sym___try] = ACTIONS(2322),
    [anon_sym___leave] = ACTIONS(2322),
    [anon_sym_not] = ACTIONS(2322),
    [anon_sym_compl] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2322),
    [anon_sym___alignof__] = ACTIONS(2322),
    [anon_sym___alignof] = ACTIONS(2322),
    [anon_sym__alignof] = ACTIONS(2322),
    [anon_sym_alignof] = ACTIONS(2322),
    [anon_sym__Alignof] = ACTIONS(2322),
    [anon_sym_offsetof] = ACTIONS(2322),
    [anon_sym__Generic] = ACTIONS(2322),
    [anon_sym_asm] = ACTIONS(2322),
    [anon_sym___asm__] = ACTIONS(2322),
    [anon_sym___asm] = ACTIONS(2322),
    [sym_number_literal] = ACTIONS(2324),
    [anon_sym_L_SQUOTE] = ACTIONS(2324),
    [anon_sym_u_SQUOTE] = ACTIONS(2324),
    [anon_sym_U_SQUOTE] = ACTIONS(2324),
    [anon_sym_u8_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_L_DQUOTE] = ACTIONS(2324),
    [anon_sym_u_DQUOTE] = ACTIONS(2324),
    [anon_sym_U_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8_DQUOTE] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [anon_sym_NULL] = ACTIONS(2322),
    [anon_sym_nullptr] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2322),
    [anon_sym_decltype] = ACTIONS(2322),
    [anon_sym_explicit] = ACTIONS(2322),
    [anon_sym_typename] = ACTIONS(2322),
    [anon_sym_template] = ACTIONS(2322),
    [anon_sym_operator] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [anon_sym_delete] = ACTIONS(2322),
    [anon_sym_throw] = ACTIONS(2322),
    [anon_sym_namespace] = ACTIONS(2322),
    [anon_sym_static_assert] = ACTIONS(2322),
    [anon_sym_concept] = ACTIONS(2322),
    [anon_sym_co_return] = ACTIONS(2322),
    [anon_sym_co_yield] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(2324),
    [anon_sym_LR_DQUOTE] = ACTIONS(2324),
    [anon_sym_uR_DQUOTE] = ACTIONS(2324),
    [anon_sym_UR_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2324),
    [anon_sym_co_await] = ACTIONS(2322),
    [anon_sym_new] = ACTIONS(2322),
    [anon_sym_requires] = ACTIONS(2322),
    [sym_this] = ACTIONS(2322),
    [anon_sym_discard] = ACTIONS(2322),
    [anon_sym_precise] = ACTIONS(2322),
    [anon_sym_shared] = ACTIONS(2322),
    [anon_sym_groupshared] = ACTIONS(2322),
    [anon_sym_uniform] = ACTIONS(2322),
    [anon_sym_row_major] = ACTIONS(2322),
    [anon_sym_column_major] = ACTIONS(2322),
    [anon_sym_globallycoherent] = ACTIONS(2322),
    [anon_sym_centroid] = ACTIONS(2322),
    [anon_sym_noperspective] = ACTIONS(2322),
    [anon_sym_nointerpolation] = ACTIONS(2322),
    [anon_sym_sample] = ACTIONS(2322),
    [anon_sym_linear] = ACTIONS(2322),
    [anon_sym_snorm] = ACTIONS(2322),
    [anon_sym_unorm] = ACTIONS(2322),
    [anon_sym_point] = ACTIONS(2322),
    [anon_sym_line] = ACTIONS(2322),
    [anon_sym_triangleadj] = ACTIONS(2322),
    [anon_sym_lineadj] = ACTIONS(2322),
    [anon_sym_triangle] = ACTIONS(2322),
    [anon_sym_cbuffer] = ACTIONS(2322),
  },
  [242] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token2] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [aux_sym_preproc_else_token1] = ACTIONS(2326),
    [aux_sym_preproc_elif_token1] = ACTIONS(2326),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_out] = ACTIONS(2326),
    [anon_sym_inout] = ACTIONS(2326),
    [anon_sym_virtual] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym___attribute] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym__Nonnull] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [anon_sym___asm] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym_discard] = ACTIONS(2326),
    [anon_sym_precise] = ACTIONS(2326),
    [anon_sym_shared] = ACTIONS(2326),
    [anon_sym_groupshared] = ACTIONS(2326),
    [anon_sym_uniform] = ACTIONS(2326),
    [anon_sym_row_major] = ACTIONS(2326),
    [anon_sym_column_major] = ACTIONS(2326),
    [anon_sym_globallycoherent] = ACTIONS(2326),
    [anon_sym_centroid] = ACTIONS(2326),
    [anon_sym_noperspective] = ACTIONS(2326),
    [anon_sym_nointerpolation] = ACTIONS(2326),
    [anon_sym_sample] = ACTIONS(2326),
    [anon_sym_linear] = ACTIONS(2326),
    [anon_sym_snorm] = ACTIONS(2326),
    [anon_sym_unorm] = ACTIONS(2326),
    [anon_sym_point] = ACTIONS(2326),
    [anon_sym_line] = ACTIONS(2326),
    [anon_sym_triangleadj] = ACTIONS(2326),
    [anon_sym_lineadj] = ACTIONS(2326),
    [anon_sym_triangle] = ACTIONS(2326),
    [anon_sym_cbuffer] = ACTIONS(2326),
  },
  [243] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token2] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [aux_sym_preproc_else_token1] = ACTIONS(2330),
    [aux_sym_preproc_elif_token1] = ACTIONS(2330),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_out] = ACTIONS(2330),
    [anon_sym_inout] = ACTIONS(2330),
    [anon_sym_virtual] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym___attribute] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym__Nonnull] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [anon_sym___asm] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym_discard] = ACTIONS(2330),
    [anon_sym_precise] = ACTIONS(2330),
    [anon_sym_shared] = ACTIONS(2330),
    [anon_sym_groupshared] = ACTIONS(2330),
    [anon_sym_uniform] = ACTIONS(2330),
    [anon_sym_row_major] = ACTIONS(2330),
    [anon_sym_column_major] = ACTIONS(2330),
    [anon_sym_globallycoherent] = ACTIONS(2330),
    [anon_sym_centroid] = ACTIONS(2330),
    [anon_sym_noperspective] = ACTIONS(2330),
    [anon_sym_nointerpolation] = ACTIONS(2330),
    [anon_sym_sample] = ACTIONS(2330),
    [anon_sym_linear] = ACTIONS(2330),
    [anon_sym_snorm] = ACTIONS(2330),
    [anon_sym_unorm] = ACTIONS(2330),
    [anon_sym_point] = ACTIONS(2330),
    [anon_sym_line] = ACTIONS(2330),
    [anon_sym_triangleadj] = ACTIONS(2330),
    [anon_sym_lineadj] = ACTIONS(2330),
    [anon_sym_triangle] = ACTIONS(2330),
    [anon_sym_cbuffer] = ACTIONS(2330),
  },
  [244] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token2] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [aux_sym_preproc_else_token1] = ACTIONS(2334),
    [aux_sym_preproc_elif_token1] = ACTIONS(2334),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym_in] = ACTIONS(2334),
    [anon_sym_out] = ACTIONS(2334),
    [anon_sym_inout] = ACTIONS(2334),
    [anon_sym_virtual] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym___attribute] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym__Nonnull] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [anon_sym___asm] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym_discard] = ACTIONS(2334),
    [anon_sym_precise] = ACTIONS(2334),
    [anon_sym_shared] = ACTIONS(2334),
    [anon_sym_groupshared] = ACTIONS(2334),
    [anon_sym_uniform] = ACTIONS(2334),
    [anon_sym_row_major] = ACTIONS(2334),
    [anon_sym_column_major] = ACTIONS(2334),
    [anon_sym_globallycoherent] = ACTIONS(2334),
    [anon_sym_centroid] = ACTIONS(2334),
    [anon_sym_noperspective] = ACTIONS(2334),
    [anon_sym_nointerpolation] = ACTIONS(2334),
    [anon_sym_sample] = ACTIONS(2334),
    [anon_sym_linear] = ACTIONS(2334),
    [anon_sym_snorm] = ACTIONS(2334),
    [anon_sym_unorm] = ACTIONS(2334),
    [anon_sym_point] = ACTIONS(2334),
    [anon_sym_line] = ACTIONS(2334),
    [anon_sym_triangleadj] = ACTIONS(2334),
    [anon_sym_lineadj] = ACTIONS(2334),
    [anon_sym_triangle] = ACTIONS(2334),
    [anon_sym_cbuffer] = ACTIONS(2334),
  },
  [245] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token2] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [aux_sym_preproc_else_token1] = ACTIONS(2338),
    [aux_sym_preproc_elif_token1] = ACTIONS(2338),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2338),
    [anon_sym_out] = ACTIONS(2338),
    [anon_sym_inout] = ACTIONS(2338),
    [anon_sym_virtual] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym___attribute] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym__Nonnull] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [anon_sym___asm] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym_discard] = ACTIONS(2338),
    [anon_sym_precise] = ACTIONS(2338),
    [anon_sym_shared] = ACTIONS(2338),
    [anon_sym_groupshared] = ACTIONS(2338),
    [anon_sym_uniform] = ACTIONS(2338),
    [anon_sym_row_major] = ACTIONS(2338),
    [anon_sym_column_major] = ACTIONS(2338),
    [anon_sym_globallycoherent] = ACTIONS(2338),
    [anon_sym_centroid] = ACTIONS(2338),
    [anon_sym_noperspective] = ACTIONS(2338),
    [anon_sym_nointerpolation] = ACTIONS(2338),
    [anon_sym_sample] = ACTIONS(2338),
    [anon_sym_linear] = ACTIONS(2338),
    [anon_sym_snorm] = ACTIONS(2338),
    [anon_sym_unorm] = ACTIONS(2338),
    [anon_sym_point] = ACTIONS(2338),
    [anon_sym_line] = ACTIONS(2338),
    [anon_sym_triangleadj] = ACTIONS(2338),
    [anon_sym_lineadj] = ACTIONS(2338),
    [anon_sym_triangle] = ACTIONS(2338),
    [anon_sym_cbuffer] = ACTIONS(2338),
  },
  [246] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [aux_sym_preproc_else_token1] = ACTIONS(2342),
    [aux_sym_preproc_elif_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [anon_sym___asm] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_discard] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
    [anon_sym_cbuffer] = ACTIONS(2342),
  },
  [247] = {
    [sym_identifier] = ACTIONS(2346),
    [aux_sym_preproc_include_token1] = ACTIONS(2346),
    [aux_sym_preproc_def_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token2] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2346),
    [aux_sym_preproc_else_token1] = ACTIONS(2346),
    [aux_sym_preproc_elif_token1] = ACTIONS(2346),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2346),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2346),
    [sym_preproc_directive] = ACTIONS(2346),
    [anon_sym_LPAREN2] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_typedef] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_out] = ACTIONS(2346),
    [anon_sym_inout] = ACTIONS(2346),
    [anon_sym_virtual] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym___attribute__] = ACTIONS(2346),
    [anon_sym___attribute] = ACTIONS(2346),
    [anon_sym_using] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2346),
    [anon_sym___based] = ACTIONS(2346),
    [anon_sym___cdecl] = ACTIONS(2346),
    [anon_sym___clrcall] = ACTIONS(2346),
    [anon_sym___stdcall] = ACTIONS(2346),
    [anon_sym___fastcall] = ACTIONS(2346),
    [anon_sym___thiscall] = ACTIONS(2346),
    [anon_sym___vectorcall] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_signed] = ACTIONS(2346),
    [anon_sym_unsigned] = ACTIONS(2346),
    [anon_sym_long] = ACTIONS(2346),
    [anon_sym_short] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_register] = ACTIONS(2346),
    [anon_sym_inline] = ACTIONS(2346),
    [anon_sym___inline] = ACTIONS(2346),
    [anon_sym___inline__] = ACTIONS(2346),
    [anon_sym___forceinline] = ACTIONS(2346),
    [anon_sym_thread_local] = ACTIONS(2346),
    [anon_sym___thread] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_constexpr] = ACTIONS(2346),
    [anon_sym_volatile] = ACTIONS(2346),
    [anon_sym_restrict] = ACTIONS(2346),
    [anon_sym___restrict__] = ACTIONS(2346),
    [anon_sym__Atomic] = ACTIONS(2346),
    [anon_sym__Noreturn] = ACTIONS(2346),
    [anon_sym_noreturn] = ACTIONS(2346),
    [anon_sym__Nonnull] = ACTIONS(2346),
    [anon_sym_mutable] = ACTIONS(2346),
    [anon_sym_constinit] = ACTIONS(2346),
    [anon_sym_consteval] = ACTIONS(2346),
    [anon_sym_alignas] = ACTIONS(2346),
    [anon_sym__Alignas] = ACTIONS(2346),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_goto] = ACTIONS(2346),
    [anon_sym___try] = ACTIONS(2346),
    [anon_sym___leave] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2346),
    [anon_sym_compl] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2346),
    [anon_sym___alignof__] = ACTIONS(2346),
    [anon_sym___alignof] = ACTIONS(2346),
    [anon_sym__alignof] = ACTIONS(2346),
    [anon_sym_alignof] = ACTIONS(2346),
    [anon_sym__Alignof] = ACTIONS(2346),
    [anon_sym_offsetof] = ACTIONS(2346),
    [anon_sym__Generic] = ACTIONS(2346),
    [anon_sym_asm] = ACTIONS(2346),
    [anon_sym___asm__] = ACTIONS(2346),
    [anon_sym___asm] = ACTIONS(2346),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_L_SQUOTE] = ACTIONS(2348),
    [anon_sym_u_SQUOTE] = ACTIONS(2348),
    [anon_sym_U_SQUOTE] = ACTIONS(2348),
    [anon_sym_u8_SQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_L_DQUOTE] = ACTIONS(2348),
    [anon_sym_u_DQUOTE] = ACTIONS(2348),
    [anon_sym_U_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8_DQUOTE] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [anon_sym_NULL] = ACTIONS(2346),
    [anon_sym_nullptr] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_decltype] = ACTIONS(2346),
    [anon_sym_explicit] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2346),
    [anon_sym_template] = ACTIONS(2346),
    [anon_sym_operator] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_static_assert] = ACTIONS(2346),
    [anon_sym_concept] = ACTIONS(2346),
    [anon_sym_co_return] = ACTIONS(2346),
    [anon_sym_co_yield] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(2348),
    [anon_sym_LR_DQUOTE] = ACTIONS(2348),
    [anon_sym_uR_DQUOTE] = ACTIONS(2348),
    [anon_sym_UR_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2348),
    [anon_sym_co_await] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_requires] = ACTIONS(2346),
    [sym_this] = ACTIONS(2346),
    [anon_sym_discard] = ACTIONS(2346),
    [anon_sym_precise] = ACTIONS(2346),
    [anon_sym_shared] = ACTIONS(2346),
    [anon_sym_groupshared] = ACTIONS(2346),
    [anon_sym_uniform] = ACTIONS(2346),
    [anon_sym_row_major] = ACTIONS(2346),
    [anon_sym_column_major] = ACTIONS(2346),
    [anon_sym_globallycoherent] = ACTIONS(2346),
    [anon_sym_centroid] = ACTIONS(2346),
    [anon_sym_noperspective] = ACTIONS(2346),
    [anon_sym_nointerpolation] = ACTIONS(2346),
    [anon_sym_sample] = ACTIONS(2346),
    [anon_sym_linear] = ACTIONS(2346),
    [anon_sym_snorm] = ACTIONS(2346),
    [anon_sym_unorm] = ACTIONS(2346),
    [anon_sym_point] = ACTIONS(2346),
    [anon_sym_line] = ACTIONS(2346),
    [anon_sym_triangleadj] = ACTIONS(2346),
    [anon_sym_lineadj] = ACTIONS(2346),
    [anon_sym_triangle] = ACTIONS(2346),
    [anon_sym_cbuffer] = ACTIONS(2346),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2350),
    [aux_sym_preproc_include_token1] = ACTIONS(2350),
    [aux_sym_preproc_def_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token2] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2350),
    [aux_sym_preproc_else_token1] = ACTIONS(2350),
    [aux_sym_preproc_elif_token1] = ACTIONS(2350),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2350),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2350),
    [sym_preproc_directive] = ACTIONS(2350),
    [anon_sym_LPAREN2] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2350),
    [anon_sym_typedef] = ACTIONS(2350),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_out] = ACTIONS(2350),
    [anon_sym_inout] = ACTIONS(2350),
    [anon_sym_virtual] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym___attribute__] = ACTIONS(2350),
    [anon_sym___attribute] = ACTIONS(2350),
    [anon_sym_using] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2352),
    [anon_sym___declspec] = ACTIONS(2350),
    [anon_sym___based] = ACTIONS(2350),
    [anon_sym___cdecl] = ACTIONS(2350),
    [anon_sym___clrcall] = ACTIONS(2350),
    [anon_sym___stdcall] = ACTIONS(2350),
    [anon_sym___fastcall] = ACTIONS(2350),
    [anon_sym___thiscall] = ACTIONS(2350),
    [anon_sym___vectorcall] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_signed] = ACTIONS(2350),
    [anon_sym_unsigned] = ACTIONS(2350),
    [anon_sym_long] = ACTIONS(2350),
    [anon_sym_short] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_register] = ACTIONS(2350),
    [anon_sym_inline] = ACTIONS(2350),
    [anon_sym___inline] = ACTIONS(2350),
    [anon_sym___inline__] = ACTIONS(2350),
    [anon_sym___forceinline] = ACTIONS(2350),
    [anon_sym_thread_local] = ACTIONS(2350),
    [anon_sym___thread] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym___restrict__] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym__Noreturn] = ACTIONS(2350),
    [anon_sym_noreturn] = ACTIONS(2350),
    [anon_sym__Nonnull] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_constinit] = ACTIONS(2350),
    [anon_sym_consteval] = ACTIONS(2350),
    [anon_sym_alignas] = ACTIONS(2350),
    [anon_sym__Alignas] = ACTIONS(2350),
    [sym_primitive_type] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_goto] = ACTIONS(2350),
    [anon_sym___try] = ACTIONS(2350),
    [anon_sym___leave] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2350),
    [anon_sym_compl] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2350),
    [anon_sym___alignof__] = ACTIONS(2350),
    [anon_sym___alignof] = ACTIONS(2350),
    [anon_sym__alignof] = ACTIONS(2350),
    [anon_sym_alignof] = ACTIONS(2350),
    [anon_sym__Alignof] = ACTIONS(2350),
    [anon_sym_offsetof] = ACTIONS(2350),
    [anon_sym__Generic] = ACTIONS(2350),
    [anon_sym_asm] = ACTIONS(2350),
    [anon_sym___asm__] = ACTIONS(2350),
    [anon_sym___asm] = ACTIONS(2350),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_L_SQUOTE] = ACTIONS(2352),
    [anon_sym_u_SQUOTE] = ACTIONS(2352),
    [anon_sym_U_SQUOTE] = ACTIONS(2352),
    [anon_sym_u8_SQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_L_DQUOTE] = ACTIONS(2352),
    [anon_sym_u_DQUOTE] = ACTIONS(2352),
    [anon_sym_U_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8_DQUOTE] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [anon_sym_NULL] = ACTIONS(2350),
    [anon_sym_nullptr] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2350),
    [anon_sym_decltype] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_typename] = ACTIONS(2350),
    [anon_sym_template] = ACTIONS(2350),
    [anon_sym_operator] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_static_assert] = ACTIONS(2350),
    [anon_sym_concept] = ACTIONS(2350),
    [anon_sym_co_return] = ACTIONS(2350),
    [anon_sym_co_yield] = ACTIONS(2350),
    [anon_sym_R_DQUOTE] = ACTIONS(2352),
    [anon_sym_LR_DQUOTE] = ACTIONS(2352),
    [anon_sym_uR_DQUOTE] = ACTIONS(2352),
    [anon_sym_UR_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2352),
    [anon_sym_co_await] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_requires] = ACTIONS(2350),
    [sym_this] = ACTIONS(2350),
    [anon_sym_discard] = ACTIONS(2350),
    [anon_sym_precise] = ACTIONS(2350),
    [anon_sym_shared] = ACTIONS(2350),
    [anon_sym_groupshared] = ACTIONS(2350),
    [anon_sym_uniform] = ACTIONS(2350),
    [anon_sym_row_major] = ACTIONS(2350),
    [anon_sym_column_major] = ACTIONS(2350),
    [anon_sym_globallycoherent] = ACTIONS(2350),
    [anon_sym_centroid] = ACTIONS(2350),
    [anon_sym_noperspective] = ACTIONS(2350),
    [anon_sym_nointerpolation] = ACTIONS(2350),
    [anon_sym_sample] = ACTIONS(2350),
    [anon_sym_linear] = ACTIONS(2350),
    [anon_sym_snorm] = ACTIONS(2350),
    [anon_sym_unorm] = ACTIONS(2350),
    [anon_sym_point] = ACTIONS(2350),
    [anon_sym_line] = ACTIONS(2350),
    [anon_sym_triangleadj] = ACTIONS(2350),
    [anon_sym_lineadj] = ACTIONS(2350),
    [anon_sym_triangle] = ACTIONS(2350),
    [anon_sym_cbuffer] = ACTIONS(2350),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2354),
    [aux_sym_preproc_include_token1] = ACTIONS(2354),
    [aux_sym_preproc_def_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token2] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2354),
    [aux_sym_preproc_else_token1] = ACTIONS(2354),
    [aux_sym_preproc_elif_token1] = ACTIONS(2354),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2354),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2354),
    [sym_preproc_directive] = ACTIONS(2354),
    [anon_sym_LPAREN2] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_AMP_AMP] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2354),
    [anon_sym_typedef] = ACTIONS(2354),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_out] = ACTIONS(2354),
    [anon_sym_inout] = ACTIONS(2354),
    [anon_sym_virtual] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym___attribute__] = ACTIONS(2354),
    [anon_sym___attribute] = ACTIONS(2354),
    [anon_sym_using] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2356),
    [anon_sym___declspec] = ACTIONS(2354),
    [anon_sym___based] = ACTIONS(2354),
    [anon_sym___cdecl] = ACTIONS(2354),
    [anon_sym___clrcall] = ACTIONS(2354),
    [anon_sym___stdcall] = ACTIONS(2354),
    [anon_sym___fastcall] = ACTIONS(2354),
    [anon_sym___thiscall] = ACTIONS(2354),
    [anon_sym___vectorcall] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_register] = ACTIONS(2354),
    [anon_sym_inline] = ACTIONS(2354),
    [anon_sym___inline] = ACTIONS(2354),
    [anon_sym___inline__] = ACTIONS(2354),
    [anon_sym___forceinline] = ACTIONS(2354),
    [anon_sym_thread_local] = ACTIONS(2354),
    [anon_sym___thread] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_constexpr] = ACTIONS(2354),
    [anon_sym_volatile] = ACTIONS(2354),
    [anon_sym_restrict] = ACTIONS(2354),
    [anon_sym___restrict__] = ACTIONS(2354),
    [anon_sym__Atomic] = ACTIONS(2354),
    [anon_sym__Noreturn] = ACTIONS(2354),
    [anon_sym_noreturn] = ACTIONS(2354),
    [anon_sym__Nonnull] = ACTIONS(2354),
    [anon_sym_mutable] = ACTIONS(2354),
    [anon_sym_constinit] = ACTIONS(2354),
    [anon_sym_consteval] = ACTIONS(2354),
    [anon_sym_alignas] = ACTIONS(2354),
    [anon_sym__Alignas] = ACTIONS(2354),
    [sym_primitive_type] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_goto] = ACTIONS(2354),
    [anon_sym___try] = ACTIONS(2354),
    [anon_sym___leave] = ACTIONS(2354),
    [anon_sym_not] = ACTIONS(2354),
    [anon_sym_compl] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2354),
    [anon_sym___alignof__] = ACTIONS(2354),
    [anon_sym___alignof] = ACTIONS(2354),
    [anon_sym__alignof] = ACTIONS(2354),
    [anon_sym_alignof] = ACTIONS(2354),
    [anon_sym__Alignof] = ACTIONS(2354),
    [anon_sym_offsetof] = ACTIONS(2354),
    [anon_sym__Generic] = ACTIONS(2354),
    [anon_sym_asm] = ACTIONS(2354),
    [anon_sym___asm__] = ACTIONS(2354),
    [anon_sym___asm] = ACTIONS(2354),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_L_SQUOTE] = ACTIONS(2356),
    [anon_sym_u_SQUOTE] = ACTIONS(2356),
    [anon_sym_U_SQUOTE] = ACTIONS(2356),
    [anon_sym_u8_SQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_L_DQUOTE] = ACTIONS(2356),
    [anon_sym_u_DQUOTE] = ACTIONS(2356),
    [anon_sym_U_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8_DQUOTE] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [anon_sym_NULL] = ACTIONS(2354),
    [anon_sym_nullptr] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2354),
    [anon_sym_decltype] = ACTIONS(2354),
    [anon_sym_explicit] = ACTIONS(2354),
    [anon_sym_typename] = ACTIONS(2354),
    [anon_sym_template] = ACTIONS(2354),
    [anon_sym_operator] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_static_assert] = ACTIONS(2354),
    [anon_sym_concept] = ACTIONS(2354),
    [anon_sym_co_return] = ACTIONS(2354),
    [anon_sym_co_yield] = ACTIONS(2354),
    [anon_sym_R_DQUOTE] = ACTIONS(2356),
    [anon_sym_LR_DQUOTE] = ACTIONS(2356),
    [anon_sym_uR_DQUOTE] = ACTIONS(2356),
    [anon_sym_UR_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2356),
    [anon_sym_co_await] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_requires] = ACTIONS(2354),
    [sym_this] = ACTIONS(2354),
    [anon_sym_discard] = ACTIONS(2354),
    [anon_sym_precise] = ACTIONS(2354),
    [anon_sym_shared] = ACTIONS(2354),
    [anon_sym_groupshared] = ACTIONS(2354),
    [anon_sym_uniform] = ACTIONS(2354),
    [anon_sym_row_major] = ACTIONS(2354),
    [anon_sym_column_major] = ACTIONS(2354),
    [anon_sym_globallycoherent] = ACTIONS(2354),
    [anon_sym_centroid] = ACTIONS(2354),
    [anon_sym_noperspective] = ACTIONS(2354),
    [anon_sym_nointerpolation] = ACTIONS(2354),
    [anon_sym_sample] = ACTIONS(2354),
    [anon_sym_linear] = ACTIONS(2354),
    [anon_sym_snorm] = ACTIONS(2354),
    [anon_sym_unorm] = ACTIONS(2354),
    [anon_sym_point] = ACTIONS(2354),
    [anon_sym_line] = ACTIONS(2354),
    [anon_sym_triangleadj] = ACTIONS(2354),
    [anon_sym_lineadj] = ACTIONS(2354),
    [anon_sym_triangle] = ACTIONS(2354),
    [anon_sym_cbuffer] = ACTIONS(2354),
  },
  [250] = {
    [sym_identifier] = ACTIONS(2358),
    [aux_sym_preproc_include_token1] = ACTIONS(2358),
    [aux_sym_preproc_def_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token2] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2358),
    [aux_sym_preproc_else_token1] = ACTIONS(2358),
    [aux_sym_preproc_elif_token1] = ACTIONS(2358),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2358),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2358),
    [sym_preproc_directive] = ACTIONS(2358),
    [anon_sym_LPAREN2] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_AMP_AMP] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym___extension__] = ACTIONS(2358),
    [anon_sym_typedef] = ACTIONS(2358),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_out] = ACTIONS(2358),
    [anon_sym_inout] = ACTIONS(2358),
    [anon_sym_virtual] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym___attribute__] = ACTIONS(2358),
    [anon_sym___attribute] = ACTIONS(2358),
    [anon_sym_using] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(2358),
    [anon_sym___based] = ACTIONS(2358),
    [anon_sym___cdecl] = ACTIONS(2358),
    [anon_sym___clrcall] = ACTIONS(2358),
    [anon_sym___stdcall] = ACTIONS(2358),
    [anon_sym___fastcall] = ACTIONS(2358),
    [anon_sym___thiscall] = ACTIONS(2358),
    [anon_sym___vectorcall] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_signed] = ACTIONS(2358),
    [anon_sym_unsigned] = ACTIONS(2358),
    [anon_sym_long] = ACTIONS(2358),
    [anon_sym_short] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_register] = ACTIONS(2358),
    [anon_sym_inline] = ACTIONS(2358),
    [anon_sym___inline] = ACTIONS(2358),
    [anon_sym___inline__] = ACTIONS(2358),
    [anon_sym___forceinline] = ACTIONS(2358),
    [anon_sym_thread_local] = ACTIONS(2358),
    [anon_sym___thread] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_constexpr] = ACTIONS(2358),
    [anon_sym_volatile] = ACTIONS(2358),
    [anon_sym_restrict] = ACTIONS(2358),
    [anon_sym___restrict__] = ACTIONS(2358),
    [anon_sym__Atomic] = ACTIONS(2358),
    [anon_sym__Noreturn] = ACTIONS(2358),
    [anon_sym_noreturn] = ACTIONS(2358),
    [anon_sym__Nonnull] = ACTIONS(2358),
    [anon_sym_mutable] = ACTIONS(2358),
    [anon_sym_constinit] = ACTIONS(2358),
    [anon_sym_consteval] = ACTIONS(2358),
    [anon_sym_alignas] = ACTIONS(2358),
    [anon_sym__Alignas] = ACTIONS(2358),
    [sym_primitive_type] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_goto] = ACTIONS(2358),
    [anon_sym___try] = ACTIONS(2358),
    [anon_sym___leave] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_compl] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2358),
    [anon_sym___alignof__] = ACTIONS(2358),
    [anon_sym___alignof] = ACTIONS(2358),
    [anon_sym__alignof] = ACTIONS(2358),
    [anon_sym_alignof] = ACTIONS(2358),
    [anon_sym__Alignof] = ACTIONS(2358),
    [anon_sym_offsetof] = ACTIONS(2358),
    [anon_sym__Generic] = ACTIONS(2358),
    [anon_sym_asm] = ACTIONS(2358),
    [anon_sym___asm__] = ACTIONS(2358),
    [anon_sym___asm] = ACTIONS(2358),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_L_SQUOTE] = ACTIONS(2360),
    [anon_sym_u_SQUOTE] = ACTIONS(2360),
    [anon_sym_U_SQUOTE] = ACTIONS(2360),
    [anon_sym_u8_SQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_L_DQUOTE] = ACTIONS(2360),
    [anon_sym_u_DQUOTE] = ACTIONS(2360),
    [anon_sym_U_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8_DQUOTE] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [anon_sym_NULL] = ACTIONS(2358),
    [anon_sym_nullptr] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2358),
    [anon_sym_decltype] = ACTIONS(2358),
    [anon_sym_explicit] = ACTIONS(2358),
    [anon_sym_typename] = ACTIONS(2358),
    [anon_sym_template] = ACTIONS(2358),
    [anon_sym_operator] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2358),
    [anon_sym_static_assert] = ACTIONS(2358),
    [anon_sym_concept] = ACTIONS(2358),
    [anon_sym_co_return] = ACTIONS(2358),
    [anon_sym_co_yield] = ACTIONS(2358),
    [anon_sym_R_DQUOTE] = ACTIONS(2360),
    [anon_sym_LR_DQUOTE] = ACTIONS(2360),
    [anon_sym_uR_DQUOTE] = ACTIONS(2360),
    [anon_sym_UR_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2360),
    [anon_sym_co_await] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_requires] = ACTIONS(2358),
    [sym_this] = ACTIONS(2358),
    [anon_sym_discard] = ACTIONS(2358),
    [anon_sym_precise] = ACTIONS(2358),
    [anon_sym_shared] = ACTIONS(2358),
    [anon_sym_groupshared] = ACTIONS(2358),
    [anon_sym_uniform] = ACTIONS(2358),
    [anon_sym_row_major] = ACTIONS(2358),
    [anon_sym_column_major] = ACTIONS(2358),
    [anon_sym_globallycoherent] = ACTIONS(2358),
    [anon_sym_centroid] = ACTIONS(2358),
    [anon_sym_noperspective] = ACTIONS(2358),
    [anon_sym_nointerpolation] = ACTIONS(2358),
    [anon_sym_sample] = ACTIONS(2358),
    [anon_sym_linear] = ACTIONS(2358),
    [anon_sym_snorm] = ACTIONS(2358),
    [anon_sym_unorm] = ACTIONS(2358),
    [anon_sym_point] = ACTIONS(2358),
    [anon_sym_line] = ACTIONS(2358),
    [anon_sym_triangleadj] = ACTIONS(2358),
    [anon_sym_lineadj] = ACTIONS(2358),
    [anon_sym_triangle] = ACTIONS(2358),
    [anon_sym_cbuffer] = ACTIONS(2358),
  },
  [251] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token2] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [aux_sym_preproc_else_token1] = ACTIONS(2362),
    [aux_sym_preproc_elif_token1] = ACTIONS(2362),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_out] = ACTIONS(2362),
    [anon_sym_inout] = ACTIONS(2362),
    [anon_sym_virtual] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym___attribute] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym__Nonnull] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [anon_sym___asm] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_discard] = ACTIONS(2362),
    [anon_sym_precise] = ACTIONS(2362),
    [anon_sym_shared] = ACTIONS(2362),
    [anon_sym_groupshared] = ACTIONS(2362),
    [anon_sym_uniform] = ACTIONS(2362),
    [anon_sym_row_major] = ACTIONS(2362),
    [anon_sym_column_major] = ACTIONS(2362),
    [anon_sym_globallycoherent] = ACTIONS(2362),
    [anon_sym_centroid] = ACTIONS(2362),
    [anon_sym_noperspective] = ACTIONS(2362),
    [anon_sym_nointerpolation] = ACTIONS(2362),
    [anon_sym_sample] = ACTIONS(2362),
    [anon_sym_linear] = ACTIONS(2362),
    [anon_sym_snorm] = ACTIONS(2362),
    [anon_sym_unorm] = ACTIONS(2362),
    [anon_sym_point] = ACTIONS(2362),
    [anon_sym_line] = ACTIONS(2362),
    [anon_sym_triangleadj] = ACTIONS(2362),
    [anon_sym_lineadj] = ACTIONS(2362),
    [anon_sym_triangle] = ACTIONS(2362),
    [anon_sym_cbuffer] = ACTIONS(2362),
  },
  [252] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [aux_sym_preproc_else_token1] = ACTIONS(2366),
    [aux_sym_preproc_elif_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym_in] = ACTIONS(2366),
    [anon_sym_out] = ACTIONS(2366),
    [anon_sym_inout] = ACTIONS(2366),
    [anon_sym_virtual] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym___attribute] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym__Nonnull] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [anon_sym___asm] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_discard] = ACTIONS(2366),
    [anon_sym_precise] = ACTIONS(2366),
    [anon_sym_shared] = ACTIONS(2366),
    [anon_sym_groupshared] = ACTIONS(2366),
    [anon_sym_uniform] = ACTIONS(2366),
    [anon_sym_row_major] = ACTIONS(2366),
    [anon_sym_column_major] = ACTIONS(2366),
    [anon_sym_globallycoherent] = ACTIONS(2366),
    [anon_sym_centroid] = ACTIONS(2366),
    [anon_sym_noperspective] = ACTIONS(2366),
    [anon_sym_nointerpolation] = ACTIONS(2366),
    [anon_sym_sample] = ACTIONS(2366),
    [anon_sym_linear] = ACTIONS(2366),
    [anon_sym_snorm] = ACTIONS(2366),
    [anon_sym_unorm] = ACTIONS(2366),
    [anon_sym_point] = ACTIONS(2366),
    [anon_sym_line] = ACTIONS(2366),
    [anon_sym_triangleadj] = ACTIONS(2366),
    [anon_sym_lineadj] = ACTIONS(2366),
    [anon_sym_triangle] = ACTIONS(2366),
    [anon_sym_cbuffer] = ACTIONS(2366),
  },
  [253] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [aux_sym_preproc_else_token1] = ACTIONS(2370),
    [aux_sym_preproc_elif_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym_in] = ACTIONS(2370),
    [anon_sym_out] = ACTIONS(2370),
    [anon_sym_inout] = ACTIONS(2370),
    [anon_sym_virtual] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym___attribute] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym__Nonnull] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [anon_sym___asm] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym_discard] = ACTIONS(2370),
    [anon_sym_precise] = ACTIONS(2370),
    [anon_sym_shared] = ACTIONS(2370),
    [anon_sym_groupshared] = ACTIONS(2370),
    [anon_sym_uniform] = ACTIONS(2370),
    [anon_sym_row_major] = ACTIONS(2370),
    [anon_sym_column_major] = ACTIONS(2370),
    [anon_sym_globallycoherent] = ACTIONS(2370),
    [anon_sym_centroid] = ACTIONS(2370),
    [anon_sym_noperspective] = ACTIONS(2370),
    [anon_sym_nointerpolation] = ACTIONS(2370),
    [anon_sym_sample] = ACTIONS(2370),
    [anon_sym_linear] = ACTIONS(2370),
    [anon_sym_snorm] = ACTIONS(2370),
    [anon_sym_unorm] = ACTIONS(2370),
    [anon_sym_point] = ACTIONS(2370),
    [anon_sym_line] = ACTIONS(2370),
    [anon_sym_triangleadj] = ACTIONS(2370),
    [anon_sym_lineadj] = ACTIONS(2370),
    [anon_sym_triangle] = ACTIONS(2370),
    [anon_sym_cbuffer] = ACTIONS(2370),
  },
  [254] = {
    [sym_identifier] = ACTIONS(2374),
    [aux_sym_preproc_include_token1] = ACTIONS(2374),
    [aux_sym_preproc_def_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token2] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2374),
    [aux_sym_preproc_else_token1] = ACTIONS(2374),
    [aux_sym_preproc_elif_token1] = ACTIONS(2374),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2374),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_LPAREN2] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_out] = ACTIONS(2374),
    [anon_sym_inout] = ACTIONS(2374),
    [anon_sym_virtual] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym___attribute__] = ACTIONS(2374),
    [anon_sym___attribute] = ACTIONS(2374),
    [anon_sym_using] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2376),
    [anon_sym___declspec] = ACTIONS(2374),
    [anon_sym___based] = ACTIONS(2374),
    [anon_sym___cdecl] = ACTIONS(2374),
    [anon_sym___clrcall] = ACTIONS(2374),
    [anon_sym___stdcall] = ACTIONS(2374),
    [anon_sym___fastcall] = ACTIONS(2374),
    [anon_sym___thiscall] = ACTIONS(2374),
    [anon_sym___vectorcall] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_signed] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym___inline] = ACTIONS(2374),
    [anon_sym___inline__] = ACTIONS(2374),
    [anon_sym___forceinline] = ACTIONS(2374),
    [anon_sym_thread_local] = ACTIONS(2374),
    [anon_sym___thread] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_constexpr] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym___restrict__] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym__Noreturn] = ACTIONS(2374),
    [anon_sym_noreturn] = ACTIONS(2374),
    [anon_sym__Nonnull] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2374),
    [anon_sym_constinit] = ACTIONS(2374),
    [anon_sym_consteval] = ACTIONS(2374),
    [anon_sym_alignas] = ACTIONS(2374),
    [anon_sym__Alignas] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym___try] = ACTIONS(2374),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2374),
    [anon_sym_compl] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2374),
    [anon_sym___alignof__] = ACTIONS(2374),
    [anon_sym___alignof] = ACTIONS(2374),
    [anon_sym__alignof] = ACTIONS(2374),
    [anon_sym_alignof] = ACTIONS(2374),
    [anon_sym__Alignof] = ACTIONS(2374),
    [anon_sym_offsetof] = ACTIONS(2374),
    [anon_sym__Generic] = ACTIONS(2374),
    [anon_sym_asm] = ACTIONS(2374),
    [anon_sym___asm__] = ACTIONS(2374),
    [anon_sym___asm] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2376),
    [anon_sym_u_DQUOTE] = ACTIONS(2376),
    [anon_sym_U_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8_DQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [anon_sym_NULL] = ACTIONS(2374),
    [anon_sym_nullptr] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2374),
    [anon_sym_decltype] = ACTIONS(2374),
    [anon_sym_explicit] = ACTIONS(2374),
    [anon_sym_typename] = ACTIONS(2374),
    [anon_sym_template] = ACTIONS(2374),
    [anon_sym_operator] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_namespace] = ACTIONS(2374),
    [anon_sym_static_assert] = ACTIONS(2374),
    [anon_sym_concept] = ACTIONS(2374),
    [anon_sym_co_return] = ACTIONS(2374),
    [anon_sym_co_yield] = ACTIONS(2374),
    [anon_sym_R_DQUOTE] = ACTIONS(2376),
    [anon_sym_LR_DQUOTE] = ACTIONS(2376),
    [anon_sym_uR_DQUOTE] = ACTIONS(2376),
    [anon_sym_UR_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2376),
    [anon_sym_co_await] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_requires] = ACTIONS(2374),
    [sym_this] = ACTIONS(2374),
    [anon_sym_discard] = ACTIONS(2374),
    [anon_sym_precise] = ACTIONS(2374),
    [anon_sym_shared] = ACTIONS(2374),
    [anon_sym_groupshared] = ACTIONS(2374),
    [anon_sym_uniform] = ACTIONS(2374),
    [anon_sym_row_major] = ACTIONS(2374),
    [anon_sym_column_major] = ACTIONS(2374),
    [anon_sym_globallycoherent] = ACTIONS(2374),
    [anon_sym_centroid] = ACTIONS(2374),
    [anon_sym_noperspective] = ACTIONS(2374),
    [anon_sym_nointerpolation] = ACTIONS(2374),
    [anon_sym_sample] = ACTIONS(2374),
    [anon_sym_linear] = ACTIONS(2374),
    [anon_sym_snorm] = ACTIONS(2374),
    [anon_sym_unorm] = ACTIONS(2374),
    [anon_sym_point] = ACTIONS(2374),
    [anon_sym_line] = ACTIONS(2374),
    [anon_sym_triangleadj] = ACTIONS(2374),
    [anon_sym_lineadj] = ACTIONS(2374),
    [anon_sym_triangle] = ACTIONS(2374),
    [anon_sym_cbuffer] = ACTIONS(2374),
  },
  [255] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [aux_sym_preproc_else_token1] = ACTIONS(2378),
    [aux_sym_preproc_elif_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [256] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [aux_sym_preproc_else_token1] = ACTIONS(2378),
    [aux_sym_preproc_elif_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [257] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_include_token1] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token2] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [aux_sym_preproc_else_token1] = ACTIONS(2382),
    [aux_sym_preproc_elif_token1] = ACTIONS(2382),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym___cdecl] = ACTIONS(2382),
    [anon_sym___clrcall] = ACTIONS(2382),
    [anon_sym___stdcall] = ACTIONS(2382),
    [anon_sym___fastcall] = ACTIONS(2382),
    [anon_sym___thiscall] = ACTIONS(2382),
    [anon_sym___vectorcall] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2382),
    [anon_sym___leave] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2382),
    [anon_sym_compl] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2382),
    [anon_sym___alignof__] = ACTIONS(2382),
    [anon_sym___alignof] = ACTIONS(2382),
    [anon_sym__alignof] = ACTIONS(2382),
    [anon_sym_alignof] = ACTIONS(2382),
    [anon_sym__Alignof] = ACTIONS(2382),
    [anon_sym_offsetof] = ACTIONS(2382),
    [anon_sym__Generic] = ACTIONS(2382),
    [anon_sym_asm] = ACTIONS(2382),
    [anon_sym___asm__] = ACTIONS(2382),
    [anon_sym___asm] = ACTIONS(2382),
    [sym_number_literal] = ACTIONS(2384),
    [anon_sym_L_SQUOTE] = ACTIONS(2384),
    [anon_sym_u_SQUOTE] = ACTIONS(2384),
    [anon_sym_U_SQUOTE] = ACTIONS(2384),
    [anon_sym_u8_SQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_L_DQUOTE] = ACTIONS(2384),
    [anon_sym_u_DQUOTE] = ACTIONS(2384),
    [anon_sym_U_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8_DQUOTE] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_concept] = ACTIONS(2382),
    [anon_sym_co_return] = ACTIONS(2382),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2384),
    [anon_sym_LR_DQUOTE] = ACTIONS(2384),
    [anon_sym_uR_DQUOTE] = ACTIONS(2384),
    [anon_sym_UR_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2384),
    [anon_sym_co_await] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_requires] = ACTIONS(2382),
    [sym_this] = ACTIONS(2382),
    [anon_sym_discard] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
    [anon_sym_cbuffer] = ACTIONS(2382),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2386),
    [aux_sym_preproc_include_token1] = ACTIONS(2386),
    [aux_sym_preproc_def_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token2] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2386),
    [aux_sym_preproc_else_token1] = ACTIONS(2386),
    [aux_sym_preproc_elif_token1] = ACTIONS(2386),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2386),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2386),
    [sym_preproc_directive] = ACTIONS(2386),
    [anon_sym_LPAREN2] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2386),
    [anon_sym_typedef] = ACTIONS(2386),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_out] = ACTIONS(2386),
    [anon_sym_inout] = ACTIONS(2386),
    [anon_sym_virtual] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym___attribute__] = ACTIONS(2386),
    [anon_sym___attribute] = ACTIONS(2386),
    [anon_sym_using] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2388),
    [anon_sym___declspec] = ACTIONS(2386),
    [anon_sym___based] = ACTIONS(2386),
    [anon_sym___cdecl] = ACTIONS(2386),
    [anon_sym___clrcall] = ACTIONS(2386),
    [anon_sym___stdcall] = ACTIONS(2386),
    [anon_sym___fastcall] = ACTIONS(2386),
    [anon_sym___thiscall] = ACTIONS(2386),
    [anon_sym___vectorcall] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2386),
    [anon_sym_unsigned] = ACTIONS(2386),
    [anon_sym_long] = ACTIONS(2386),
    [anon_sym_short] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_register] = ACTIONS(2386),
    [anon_sym_inline] = ACTIONS(2386),
    [anon_sym___inline] = ACTIONS(2386),
    [anon_sym___inline__] = ACTIONS(2386),
    [anon_sym___forceinline] = ACTIONS(2386),
    [anon_sym_thread_local] = ACTIONS(2386),
    [anon_sym___thread] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_constexpr] = ACTIONS(2386),
    [anon_sym_volatile] = ACTIONS(2386),
    [anon_sym_restrict] = ACTIONS(2386),
    [anon_sym___restrict__] = ACTIONS(2386),
    [anon_sym__Atomic] = ACTIONS(2386),
    [anon_sym__Noreturn] = ACTIONS(2386),
    [anon_sym_noreturn] = ACTIONS(2386),
    [anon_sym__Nonnull] = ACTIONS(2386),
    [anon_sym_mutable] = ACTIONS(2386),
    [anon_sym_constinit] = ACTIONS(2386),
    [anon_sym_consteval] = ACTIONS(2386),
    [anon_sym_alignas] = ACTIONS(2386),
    [anon_sym__Alignas] = ACTIONS(2386),
    [sym_primitive_type] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_goto] = ACTIONS(2386),
    [anon_sym___try] = ACTIONS(2386),
    [anon_sym___leave] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_compl] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2386),
    [anon_sym___alignof__] = ACTIONS(2386),
    [anon_sym___alignof] = ACTIONS(2386),
    [anon_sym__alignof] = ACTIONS(2386),
    [anon_sym_alignof] = ACTIONS(2386),
    [anon_sym__Alignof] = ACTIONS(2386),
    [anon_sym_offsetof] = ACTIONS(2386),
    [anon_sym__Generic] = ACTIONS(2386),
    [anon_sym_asm] = ACTIONS(2386),
    [anon_sym___asm__] = ACTIONS(2386),
    [anon_sym___asm] = ACTIONS(2386),
    [sym_number_literal] = ACTIONS(2388),
    [anon_sym_L_SQUOTE] = ACTIONS(2388),
    [anon_sym_u_SQUOTE] = ACTIONS(2388),
    [anon_sym_U_SQUOTE] = ACTIONS(2388),
    [anon_sym_u8_SQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_L_DQUOTE] = ACTIONS(2388),
    [anon_sym_u_DQUOTE] = ACTIONS(2388),
    [anon_sym_U_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8_DQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [anon_sym_NULL] = ACTIONS(2386),
    [anon_sym_nullptr] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2386),
    [anon_sym_decltype] = ACTIONS(2386),
    [anon_sym_explicit] = ACTIONS(2386),
    [anon_sym_typename] = ACTIONS(2386),
    [anon_sym_template] = ACTIONS(2386),
    [anon_sym_operator] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_static_assert] = ACTIONS(2386),
    [anon_sym_concept] = ACTIONS(2386),
    [anon_sym_co_return] = ACTIONS(2386),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_requires] = ACTIONS(2386),
    [sym_this] = ACTIONS(2386),
    [anon_sym_discard] = ACTIONS(2386),
    [anon_sym_precise] = ACTIONS(2386),
    [anon_sym_shared] = ACTIONS(2386),
    [anon_sym_groupshared] = ACTIONS(2386),
    [anon_sym_uniform] = ACTIONS(2386),
    [anon_sym_row_major] = ACTIONS(2386),
    [anon_sym_column_major] = ACTIONS(2386),
    [anon_sym_globallycoherent] = ACTIONS(2386),
    [anon_sym_centroid] = ACTIONS(2386),
    [anon_sym_noperspective] = ACTIONS(2386),
    [anon_sym_nointerpolation] = ACTIONS(2386),
    [anon_sym_sample] = ACTIONS(2386),
    [anon_sym_linear] = ACTIONS(2386),
    [anon_sym_snorm] = ACTIONS(2386),
    [anon_sym_unorm] = ACTIONS(2386),
    [anon_sym_point] = ACTIONS(2386),
    [anon_sym_line] = ACTIONS(2386),
    [anon_sym_triangleadj] = ACTIONS(2386),
    [anon_sym_lineadj] = ACTIONS(2386),
    [anon_sym_triangle] = ACTIONS(2386),
    [anon_sym_cbuffer] = ACTIONS(2386),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2390),
    [aux_sym_preproc_include_token1] = ACTIONS(2390),
    [aux_sym_preproc_def_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token2] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2390),
    [aux_sym_preproc_else_token1] = ACTIONS(2390),
    [aux_sym_preproc_elif_token1] = ACTIONS(2390),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2390),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2390),
    [sym_preproc_directive] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2390),
    [anon_sym_typedef] = ACTIONS(2390),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_out] = ACTIONS(2390),
    [anon_sym_inout] = ACTIONS(2390),
    [anon_sym_virtual] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym___attribute__] = ACTIONS(2390),
    [anon_sym___attribute] = ACTIONS(2390),
    [anon_sym_using] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2392),
    [anon_sym___declspec] = ACTIONS(2390),
    [anon_sym___based] = ACTIONS(2390),
    [anon_sym___cdecl] = ACTIONS(2390),
    [anon_sym___clrcall] = ACTIONS(2390),
    [anon_sym___stdcall] = ACTIONS(2390),
    [anon_sym___fastcall] = ACTIONS(2390),
    [anon_sym___thiscall] = ACTIONS(2390),
    [anon_sym___vectorcall] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2390),
    [anon_sym_unsigned] = ACTIONS(2390),
    [anon_sym_long] = ACTIONS(2390),
    [anon_sym_short] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_register] = ACTIONS(2390),
    [anon_sym_inline] = ACTIONS(2390),
    [anon_sym___inline] = ACTIONS(2390),
    [anon_sym___inline__] = ACTIONS(2390),
    [anon_sym___forceinline] = ACTIONS(2390),
    [anon_sym_thread_local] = ACTIONS(2390),
    [anon_sym___thread] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_constexpr] = ACTIONS(2390),
    [anon_sym_volatile] = ACTIONS(2390),
    [anon_sym_restrict] = ACTIONS(2390),
    [anon_sym___restrict__] = ACTIONS(2390),
    [anon_sym__Atomic] = ACTIONS(2390),
    [anon_sym__Noreturn] = ACTIONS(2390),
    [anon_sym_noreturn] = ACTIONS(2390),
    [anon_sym__Nonnull] = ACTIONS(2390),
    [anon_sym_mutable] = ACTIONS(2390),
    [anon_sym_constinit] = ACTIONS(2390),
    [anon_sym_consteval] = ACTIONS(2390),
    [anon_sym_alignas] = ACTIONS(2390),
    [anon_sym__Alignas] = ACTIONS(2390),
    [sym_primitive_type] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2390),
    [anon_sym___leave] = ACTIONS(2390),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_compl] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2390),
    [anon_sym___alignof__] = ACTIONS(2390),
    [anon_sym___alignof] = ACTIONS(2390),
    [anon_sym__alignof] = ACTIONS(2390),
    [anon_sym_alignof] = ACTIONS(2390),
    [anon_sym__Alignof] = ACTIONS(2390),
    [anon_sym_offsetof] = ACTIONS(2390),
    [anon_sym__Generic] = ACTIONS(2390),
    [anon_sym_asm] = ACTIONS(2390),
    [anon_sym___asm__] = ACTIONS(2390),
    [anon_sym___asm] = ACTIONS(2390),
    [sym_number_literal] = ACTIONS(2392),
    [anon_sym_L_SQUOTE] = ACTIONS(2392),
    [anon_sym_u_SQUOTE] = ACTIONS(2392),
    [anon_sym_U_SQUOTE] = ACTIONS(2392),
    [anon_sym_u8_SQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_L_DQUOTE] = ACTIONS(2392),
    [anon_sym_u_DQUOTE] = ACTIONS(2392),
    [anon_sym_U_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [anon_sym_NULL] = ACTIONS(2390),
    [anon_sym_nullptr] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2390),
    [anon_sym_decltype] = ACTIONS(2390),
    [anon_sym_explicit] = ACTIONS(2390),
    [anon_sym_typename] = ACTIONS(2390),
    [anon_sym_template] = ACTIONS(2390),
    [anon_sym_operator] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_static_assert] = ACTIONS(2390),
    [anon_sym_concept] = ACTIONS(2390),
    [anon_sym_co_return] = ACTIONS(2390),
    [anon_sym_co_yield] = ACTIONS(2390),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_LR_DQUOTE] = ACTIONS(2392),
    [anon_sym_uR_DQUOTE] = ACTIONS(2392),
    [anon_sym_UR_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2392),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_requires] = ACTIONS(2390),
    [sym_this] = ACTIONS(2390),
    [anon_sym_discard] = ACTIONS(2390),
    [anon_sym_precise] = ACTIONS(2390),
    [anon_sym_shared] = ACTIONS(2390),
    [anon_sym_groupshared] = ACTIONS(2390),
    [anon_sym_uniform] = ACTIONS(2390),
    [anon_sym_row_major] = ACTIONS(2390),
    [anon_sym_column_major] = ACTIONS(2390),
    [anon_sym_globallycoherent] = ACTIONS(2390),
    [anon_sym_centroid] = ACTIONS(2390),
    [anon_sym_noperspective] = ACTIONS(2390),
    [anon_sym_nointerpolation] = ACTIONS(2390),
    [anon_sym_sample] = ACTIONS(2390),
    [anon_sym_linear] = ACTIONS(2390),
    [anon_sym_snorm] = ACTIONS(2390),
    [anon_sym_unorm] = ACTIONS(2390),
    [anon_sym_point] = ACTIONS(2390),
    [anon_sym_line] = ACTIONS(2390),
    [anon_sym_triangleadj] = ACTIONS(2390),
    [anon_sym_lineadj] = ACTIONS(2390),
    [anon_sym_triangle] = ACTIONS(2390),
    [anon_sym_cbuffer] = ACTIONS(2390),
  },
  [260] = {
    [sym_else_clause] = STATE(278),
    [ts_builtin_sym_end] = ACTIONS(2141),
    [sym_identifier] = ACTIONS(2139),
    [aux_sym_preproc_include_token1] = ACTIONS(2139),
    [aux_sym_preproc_def_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2139),
    [sym_preproc_directive] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_typedef] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_out] = ACTIONS(2139),
    [anon_sym_inout] = ACTIONS(2139),
    [anon_sym_virtual] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym___attribute] = ACTIONS(2139),
    [anon_sym_using] = ACTIONS(2139),
    [anon_sym_COLON_COLON] = ACTIONS(2141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2141),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_signed] = ACTIONS(2139),
    [anon_sym_unsigned] = ACTIONS(2139),
    [anon_sym_long] = ACTIONS(2139),
    [anon_sym_short] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym__Nonnull] = ACTIONS(2139),
    [anon_sym_mutable] = ACTIONS(2139),
    [anon_sym_constinit] = ACTIONS(2139),
    [anon_sym_consteval] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [sym_primitive_type] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_struct] = ACTIONS(2139),
    [anon_sym_union] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2294),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_goto] = ACTIONS(2139),
    [anon_sym___try] = ACTIONS(2139),
    [anon_sym___leave] = ACTIONS(2139),
    [anon_sym_not] = ACTIONS(2139),
    [anon_sym_compl] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_sizeof] = ACTIONS(2139),
    [anon_sym___alignof__] = ACTIONS(2139),
    [anon_sym___alignof] = ACTIONS(2139),
    [anon_sym__alignof] = ACTIONS(2139),
    [anon_sym_alignof] = ACTIONS(2139),
    [anon_sym__Alignof] = ACTIONS(2139),
    [anon_sym_offsetof] = ACTIONS(2139),
    [anon_sym__Generic] = ACTIONS(2139),
    [anon_sym_asm] = ACTIONS(2139),
    [anon_sym___asm__] = ACTIONS(2139),
    [anon_sym___asm] = ACTIONS(2139),
    [sym_number_literal] = ACTIONS(2141),
    [anon_sym_L_SQUOTE] = ACTIONS(2141),
    [anon_sym_u_SQUOTE] = ACTIONS(2141),
    [anon_sym_U_SQUOTE] = ACTIONS(2141),
    [anon_sym_u8_SQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(2141),
    [anon_sym_u_DQUOTE] = ACTIONS(2141),
    [anon_sym_U_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8_DQUOTE] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [anon_sym_NULL] = ACTIONS(2139),
    [anon_sym_nullptr] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2139),
    [anon_sym_decltype] = ACTIONS(2139),
    [anon_sym_explicit] = ACTIONS(2139),
    [anon_sym_typename] = ACTIONS(2139),
    [anon_sym_export] = ACTIONS(2139),
    [anon_sym_module] = ACTIONS(2139),
    [anon_sym_import] = ACTIONS(2139),
    [anon_sym_template] = ACTIONS(2139),
    [anon_sym_operator] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_static_assert] = ACTIONS(2139),
    [anon_sym_concept] = ACTIONS(2139),
    [anon_sym_co_return] = ACTIONS(2139),
    [anon_sym_co_yield] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2139),
    [anon_sym_discard] = ACTIONS(2139),
    [anon_sym_precise] = ACTIONS(2139),
    [anon_sym_shared] = ACTIONS(2139),
    [anon_sym_groupshared] = ACTIONS(2139),
    [anon_sym_uniform] = ACTIONS(2139),
    [anon_sym_row_major] = ACTIONS(2139),
    [anon_sym_column_major] = ACTIONS(2139),
    [anon_sym_globallycoherent] = ACTIONS(2139),
    [anon_sym_centroid] = ACTIONS(2139),
    [anon_sym_noperspective] = ACTIONS(2139),
    [anon_sym_nointerpolation] = ACTIONS(2139),
    [anon_sym_sample] = ACTIONS(2139),
    [anon_sym_linear] = ACTIONS(2139),
    [anon_sym_snorm] = ACTIONS(2139),
    [anon_sym_unorm] = ACTIONS(2139),
    [anon_sym_point] = ACTIONS(2139),
    [anon_sym_line] = ACTIONS(2139),
    [anon_sym_triangleadj] = ACTIONS(2139),
    [anon_sym_lineadj] = ACTIONS(2139),
    [anon_sym_triangle] = ACTIONS(2139),
    [anon_sym_cbuffer] = ACTIONS(2139),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2394),
    [aux_sym_preproc_include_token1] = ACTIONS(2394),
    [aux_sym_preproc_def_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token2] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2394),
    [aux_sym_preproc_else_token1] = ACTIONS(2394),
    [aux_sym_preproc_elif_token1] = ACTIONS(2394),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2394),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2394),
    [sym_preproc_directive] = ACTIONS(2394),
    [anon_sym_LPAREN2] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2394),
    [anon_sym_typedef] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_out] = ACTIONS(2394),
    [anon_sym_inout] = ACTIONS(2394),
    [anon_sym_virtual] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym___attribute__] = ACTIONS(2394),
    [anon_sym___attribute] = ACTIONS(2394),
    [anon_sym_using] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2396),
    [anon_sym___declspec] = ACTIONS(2394),
    [anon_sym___based] = ACTIONS(2394),
    [anon_sym___cdecl] = ACTIONS(2394),
    [anon_sym___clrcall] = ACTIONS(2394),
    [anon_sym___stdcall] = ACTIONS(2394),
    [anon_sym___fastcall] = ACTIONS(2394),
    [anon_sym___thiscall] = ACTIONS(2394),
    [anon_sym___vectorcall] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2394),
    [anon_sym_unsigned] = ACTIONS(2394),
    [anon_sym_long] = ACTIONS(2394),
    [anon_sym_short] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_register] = ACTIONS(2394),
    [anon_sym_inline] = ACTIONS(2394),
    [anon_sym___inline] = ACTIONS(2394),
    [anon_sym___inline__] = ACTIONS(2394),
    [anon_sym___forceinline] = ACTIONS(2394),
    [anon_sym_thread_local] = ACTIONS(2394),
    [anon_sym___thread] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_constexpr] = ACTIONS(2394),
    [anon_sym_volatile] = ACTIONS(2394),
    [anon_sym_restrict] = ACTIONS(2394),
    [anon_sym___restrict__] = ACTIONS(2394),
    [anon_sym__Atomic] = ACTIONS(2394),
    [anon_sym__Noreturn] = ACTIONS(2394),
    [anon_sym_noreturn] = ACTIONS(2394),
    [anon_sym__Nonnull] = ACTIONS(2394),
    [anon_sym_mutable] = ACTIONS(2394),
    [anon_sym_constinit] = ACTIONS(2394),
    [anon_sym_consteval] = ACTIONS(2394),
    [anon_sym_alignas] = ACTIONS(2394),
    [anon_sym__Alignas] = ACTIONS(2394),
    [sym_primitive_type] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_goto] = ACTIONS(2394),
    [anon_sym___try] = ACTIONS(2394),
    [anon_sym___leave] = ACTIONS(2394),
    [anon_sym_not] = ACTIONS(2394),
    [anon_sym_compl] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2394),
    [anon_sym___alignof] = ACTIONS(2394),
    [anon_sym__alignof] = ACTIONS(2394),
    [anon_sym_alignof] = ACTIONS(2394),
    [anon_sym__Alignof] = ACTIONS(2394),
    [anon_sym_offsetof] = ACTIONS(2394),
    [anon_sym__Generic] = ACTIONS(2394),
    [anon_sym_asm] = ACTIONS(2394),
    [anon_sym___asm__] = ACTIONS(2394),
    [anon_sym___asm] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2396),
    [anon_sym_L_SQUOTE] = ACTIONS(2396),
    [anon_sym_u_SQUOTE] = ACTIONS(2396),
    [anon_sym_U_SQUOTE] = ACTIONS(2396),
    [anon_sym_u8_SQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_L_DQUOTE] = ACTIONS(2396),
    [anon_sym_u_DQUOTE] = ACTIONS(2396),
    [anon_sym_U_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8_DQUOTE] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [anon_sym_NULL] = ACTIONS(2394),
    [anon_sym_nullptr] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2394),
    [anon_sym_decltype] = ACTIONS(2394),
    [anon_sym_explicit] = ACTIONS(2394),
    [anon_sym_typename] = ACTIONS(2394),
    [anon_sym_template] = ACTIONS(2394),
    [anon_sym_operator] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_static_assert] = ACTIONS(2394),
    [anon_sym_concept] = ACTIONS(2394),
    [anon_sym_co_return] = ACTIONS(2394),
    [anon_sym_co_yield] = ACTIONS(2394),
    [anon_sym_R_DQUOTE] = ACTIONS(2396),
    [anon_sym_LR_DQUOTE] = ACTIONS(2396),
    [anon_sym_uR_DQUOTE] = ACTIONS(2396),
    [anon_sym_UR_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2396),
    [anon_sym_co_await] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2394),
    [anon_sym_discard] = ACTIONS(2394),
    [anon_sym_precise] = ACTIONS(2394),
    [anon_sym_shared] = ACTIONS(2394),
    [anon_sym_groupshared] = ACTIONS(2394),
    [anon_sym_uniform] = ACTIONS(2394),
    [anon_sym_row_major] = ACTIONS(2394),
    [anon_sym_column_major] = ACTIONS(2394),
    [anon_sym_globallycoherent] = ACTIONS(2394),
    [anon_sym_centroid] = ACTIONS(2394),
    [anon_sym_noperspective] = ACTIONS(2394),
    [anon_sym_nointerpolation] = ACTIONS(2394),
    [anon_sym_sample] = ACTIONS(2394),
    [anon_sym_linear] = ACTIONS(2394),
    [anon_sym_snorm] = ACTIONS(2394),
    [anon_sym_unorm] = ACTIONS(2394),
    [anon_sym_point] = ACTIONS(2394),
    [anon_sym_line] = ACTIONS(2394),
    [anon_sym_triangleadj] = ACTIONS(2394),
    [anon_sym_lineadj] = ACTIONS(2394),
    [anon_sym_triangle] = ACTIONS(2394),
    [anon_sym_cbuffer] = ACTIONS(2394),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2398),
    [aux_sym_preproc_include_token1] = ACTIONS(2398),
    [aux_sym_preproc_def_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token2] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2398),
    [aux_sym_preproc_else_token1] = ACTIONS(2398),
    [aux_sym_preproc_elif_token1] = ACTIONS(2398),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2398),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2398),
    [sym_preproc_directive] = ACTIONS(2398),
    [anon_sym_LPAREN2] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2398),
    [anon_sym_typedef] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_out] = ACTIONS(2398),
    [anon_sym_inout] = ACTIONS(2398),
    [anon_sym_virtual] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym___attribute__] = ACTIONS(2398),
    [anon_sym___attribute] = ACTIONS(2398),
    [anon_sym_using] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2400),
    [anon_sym___declspec] = ACTIONS(2398),
    [anon_sym___based] = ACTIONS(2398),
    [anon_sym___cdecl] = ACTIONS(2398),
    [anon_sym___clrcall] = ACTIONS(2398),
    [anon_sym___stdcall] = ACTIONS(2398),
    [anon_sym___fastcall] = ACTIONS(2398),
    [anon_sym___thiscall] = ACTIONS(2398),
    [anon_sym___vectorcall] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_signed] = ACTIONS(2398),
    [anon_sym_unsigned] = ACTIONS(2398),
    [anon_sym_long] = ACTIONS(2398),
    [anon_sym_short] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_register] = ACTIONS(2398),
    [anon_sym_inline] = ACTIONS(2398),
    [anon_sym___inline] = ACTIONS(2398),
    [anon_sym___inline__] = ACTIONS(2398),
    [anon_sym___forceinline] = ACTIONS(2398),
    [anon_sym_thread_local] = ACTIONS(2398),
    [anon_sym___thread] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_constexpr] = ACTIONS(2398),
    [anon_sym_volatile] = ACTIONS(2398),
    [anon_sym_restrict] = ACTIONS(2398),
    [anon_sym___restrict__] = ACTIONS(2398),
    [anon_sym__Atomic] = ACTIONS(2398),
    [anon_sym__Noreturn] = ACTIONS(2398),
    [anon_sym_noreturn] = ACTIONS(2398),
    [anon_sym__Nonnull] = ACTIONS(2398),
    [anon_sym_mutable] = ACTIONS(2398),
    [anon_sym_constinit] = ACTIONS(2398),
    [anon_sym_consteval] = ACTIONS(2398),
    [anon_sym_alignas] = ACTIONS(2398),
    [anon_sym__Alignas] = ACTIONS(2398),
    [sym_primitive_type] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_goto] = ACTIONS(2398),
    [anon_sym___try] = ACTIONS(2398),
    [anon_sym___leave] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2398),
    [anon_sym_compl] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_sizeof] = ACTIONS(2398),
    [anon_sym___alignof__] = ACTIONS(2398),
    [anon_sym___alignof] = ACTIONS(2398),
    [anon_sym__alignof] = ACTIONS(2398),
    [anon_sym_alignof] = ACTIONS(2398),
    [anon_sym__Alignof] = ACTIONS(2398),
    [anon_sym_offsetof] = ACTIONS(2398),
    [anon_sym__Generic] = ACTIONS(2398),
    [anon_sym_asm] = ACTIONS(2398),
    [anon_sym___asm__] = ACTIONS(2398),
    [anon_sym___asm] = ACTIONS(2398),
    [sym_number_literal] = ACTIONS(2400),
    [anon_sym_L_SQUOTE] = ACTIONS(2400),
    [anon_sym_u_SQUOTE] = ACTIONS(2400),
    [anon_sym_U_SQUOTE] = ACTIONS(2400),
    [anon_sym_u8_SQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_L_DQUOTE] = ACTIONS(2400),
    [anon_sym_u_DQUOTE] = ACTIONS(2400),
    [anon_sym_U_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [anon_sym_NULL] = ACTIONS(2398),
    [anon_sym_nullptr] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2398),
    [anon_sym_decltype] = ACTIONS(2398),
    [anon_sym_explicit] = ACTIONS(2398),
    [anon_sym_typename] = ACTIONS(2398),
    [anon_sym_template] = ACTIONS(2398),
    [anon_sym_operator] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_static_assert] = ACTIONS(2398),
    [anon_sym_concept] = ACTIONS(2398),
    [anon_sym_co_return] = ACTIONS(2398),
    [anon_sym_co_yield] = ACTIONS(2398),
    [anon_sym_R_DQUOTE] = ACTIONS(2400),
    [anon_sym_LR_DQUOTE] = ACTIONS(2400),
    [anon_sym_uR_DQUOTE] = ACTIONS(2400),
    [anon_sym_UR_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2400),
    [anon_sym_co_await] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_requires] = ACTIONS(2398),
    [sym_this] = ACTIONS(2398),
    [anon_sym_discard] = ACTIONS(2398),
    [anon_sym_precise] = ACTIONS(2398),
    [anon_sym_shared] = ACTIONS(2398),
    [anon_sym_groupshared] = ACTIONS(2398),
    [anon_sym_uniform] = ACTIONS(2398),
    [anon_sym_row_major] = ACTIONS(2398),
    [anon_sym_column_major] = ACTIONS(2398),
    [anon_sym_globallycoherent] = ACTIONS(2398),
    [anon_sym_centroid] = ACTIONS(2398),
    [anon_sym_noperspective] = ACTIONS(2398),
    [anon_sym_nointerpolation] = ACTIONS(2398),
    [anon_sym_sample] = ACTIONS(2398),
    [anon_sym_linear] = ACTIONS(2398),
    [anon_sym_snorm] = ACTIONS(2398),
    [anon_sym_unorm] = ACTIONS(2398),
    [anon_sym_point] = ACTIONS(2398),
    [anon_sym_line] = ACTIONS(2398),
    [anon_sym_triangleadj] = ACTIONS(2398),
    [anon_sym_lineadj] = ACTIONS(2398),
    [anon_sym_triangle] = ACTIONS(2398),
    [anon_sym_cbuffer] = ACTIONS(2398),
  },
  [263] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(2178),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2181),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [264] = {
    [sym_else_clause] = STATE(302),
    [ts_builtin_sym_end] = ACTIONS(2153),
    [sym_identifier] = ACTIONS(2151),
    [aux_sym_preproc_include_token1] = ACTIONS(2151),
    [aux_sym_preproc_def_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2151),
    [sym_preproc_directive] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AMP_AMP] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_typedef] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_out] = ACTIONS(2151),
    [anon_sym_inout] = ACTIONS(2151),
    [anon_sym_virtual] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym___attribute] = ACTIONS(2151),
    [anon_sym_using] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym___based] = ACTIONS(2151),
    [anon_sym___cdecl] = ACTIONS(2151),
    [anon_sym___clrcall] = ACTIONS(2151),
    [anon_sym___stdcall] = ACTIONS(2151),
    [anon_sym___fastcall] = ACTIONS(2151),
    [anon_sym___thiscall] = ACTIONS(2151),
    [anon_sym___vectorcall] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [anon_sym__Nonnull] = ACTIONS(2151),
    [anon_sym_mutable] = ACTIONS(2151),
    [anon_sym_constinit] = ACTIONS(2151),
    [anon_sym_consteval] = ACTIONS(2151),
    [anon_sym_alignas] = ACTIONS(2151),
    [anon_sym__Alignas] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2294),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_goto] = ACTIONS(2151),
    [anon_sym___try] = ACTIONS(2151),
    [anon_sym___leave] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_compl] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_sizeof] = ACTIONS(2151),
    [anon_sym___alignof__] = ACTIONS(2151),
    [anon_sym___alignof] = ACTIONS(2151),
    [anon_sym__alignof] = ACTIONS(2151),
    [anon_sym_alignof] = ACTIONS(2151),
    [anon_sym__Alignof] = ACTIONS(2151),
    [anon_sym_offsetof] = ACTIONS(2151),
    [anon_sym__Generic] = ACTIONS(2151),
    [anon_sym_asm] = ACTIONS(2151),
    [anon_sym___asm__] = ACTIONS(2151),
    [anon_sym___asm] = ACTIONS(2151),
    [sym_number_literal] = ACTIONS(2153),
    [anon_sym_L_SQUOTE] = ACTIONS(2153),
    [anon_sym_u_SQUOTE] = ACTIONS(2153),
    [anon_sym_U_SQUOTE] = ACTIONS(2153),
    [anon_sym_u8_SQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [anon_sym_L_DQUOTE] = ACTIONS(2153),
    [anon_sym_u_DQUOTE] = ACTIONS(2153),
    [anon_sym_U_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8_DQUOTE] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [anon_sym_NULL] = ACTIONS(2151),
    [anon_sym_nullptr] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2151),
    [anon_sym_decltype] = ACTIONS(2151),
    [anon_sym_explicit] = ACTIONS(2151),
    [anon_sym_typename] = ACTIONS(2151),
    [anon_sym_export] = ACTIONS(2151),
    [anon_sym_module] = ACTIONS(2151),
    [anon_sym_import] = ACTIONS(2151),
    [anon_sym_template] = ACTIONS(2151),
    [anon_sym_operator] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_static_assert] = ACTIONS(2151),
    [anon_sym_concept] = ACTIONS(2151),
    [anon_sym_co_return] = ACTIONS(2151),
    [anon_sym_co_yield] = ACTIONS(2151),
    [anon_sym_R_DQUOTE] = ACTIONS(2153),
    [anon_sym_LR_DQUOTE] = ACTIONS(2153),
    [anon_sym_uR_DQUOTE] = ACTIONS(2153),
    [anon_sym_UR_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2153),
    [anon_sym_co_await] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_requires] = ACTIONS(2151),
    [sym_this] = ACTIONS(2151),
    [anon_sym_discard] = ACTIONS(2151),
    [anon_sym_precise] = ACTIONS(2151),
    [anon_sym_shared] = ACTIONS(2151),
    [anon_sym_groupshared] = ACTIONS(2151),
    [anon_sym_uniform] = ACTIONS(2151),
    [anon_sym_row_major] = ACTIONS(2151),
    [anon_sym_column_major] = ACTIONS(2151),
    [anon_sym_globallycoherent] = ACTIONS(2151),
    [anon_sym_centroid] = ACTIONS(2151),
    [anon_sym_noperspective] = ACTIONS(2151),
    [anon_sym_nointerpolation] = ACTIONS(2151),
    [anon_sym_sample] = ACTIONS(2151),
    [anon_sym_linear] = ACTIONS(2151),
    [anon_sym_snorm] = ACTIONS(2151),
    [anon_sym_unorm] = ACTIONS(2151),
    [anon_sym_point] = ACTIONS(2151),
    [anon_sym_line] = ACTIONS(2151),
    [anon_sym_triangleadj] = ACTIONS(2151),
    [anon_sym_lineadj] = ACTIONS(2151),
    [anon_sym_triangle] = ACTIONS(2151),
    [anon_sym_cbuffer] = ACTIONS(2151),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [aux_sym_preproc_else_token1] = ACTIONS(2404),
    [aux_sym_preproc_elif_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2406),
    [anon_sym_L_SQUOTE] = ACTIONS(2406),
    [anon_sym_u_SQUOTE] = ACTIONS(2406),
    [anon_sym_U_SQUOTE] = ACTIONS(2406),
    [anon_sym_u8_SQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_L_DQUOTE] = ACTIONS(2406),
    [anon_sym_u_DQUOTE] = ACTIONS(2406),
    [anon_sym_U_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8_DQUOTE] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2406),
    [anon_sym_LR_DQUOTE] = ACTIONS(2406),
    [anon_sym_uR_DQUOTE] = ACTIONS(2406),
    [anon_sym_UR_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2406),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(2364),
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_out] = ACTIONS(2362),
    [anon_sym_inout] = ACTIONS(2362),
    [anon_sym_virtual] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym___attribute] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym__Nonnull] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [anon_sym___asm] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_export] = ACTIONS(2362),
    [anon_sym_module] = ACTIONS(2362),
    [anon_sym_import] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_discard] = ACTIONS(2362),
    [anon_sym_precise] = ACTIONS(2362),
    [anon_sym_shared] = ACTIONS(2362),
    [anon_sym_groupshared] = ACTIONS(2362),
    [anon_sym_uniform] = ACTIONS(2362),
    [anon_sym_row_major] = ACTIONS(2362),
    [anon_sym_column_major] = ACTIONS(2362),
    [anon_sym_globallycoherent] = ACTIONS(2362),
    [anon_sym_centroid] = ACTIONS(2362),
    [anon_sym_noperspective] = ACTIONS(2362),
    [anon_sym_nointerpolation] = ACTIONS(2362),
    [anon_sym_sample] = ACTIONS(2362),
    [anon_sym_linear] = ACTIONS(2362),
    [anon_sym_snorm] = ACTIONS(2362),
    [anon_sym_unorm] = ACTIONS(2362),
    [anon_sym_point] = ACTIONS(2362),
    [anon_sym_line] = ACTIONS(2362),
    [anon_sym_triangleadj] = ACTIONS(2362),
    [anon_sym_lineadj] = ACTIONS(2362),
    [anon_sym_triangle] = ACTIONS(2362),
    [anon_sym_cbuffer] = ACTIONS(2362),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(2312),
    [sym_identifier] = ACTIONS(2310),
    [aux_sym_preproc_include_token1] = ACTIONS(2310),
    [aux_sym_preproc_def_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2310),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym_typedef] = ACTIONS(2310),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_out] = ACTIONS(2310),
    [anon_sym_inout] = ACTIONS(2310),
    [anon_sym_virtual] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2310),
    [anon_sym_using] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2312),
    [anon_sym___declspec] = ACTIONS(2310),
    [anon_sym___based] = ACTIONS(2310),
    [anon_sym___cdecl] = ACTIONS(2310),
    [anon_sym___clrcall] = ACTIONS(2310),
    [anon_sym___stdcall] = ACTIONS(2310),
    [anon_sym___fastcall] = ACTIONS(2310),
    [anon_sym___thiscall] = ACTIONS(2310),
    [anon_sym___vectorcall] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2310),
    [anon_sym_unsigned] = ACTIONS(2310),
    [anon_sym_long] = ACTIONS(2310),
    [anon_sym_short] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2310),
    [anon_sym_inline] = ACTIONS(2310),
    [anon_sym___inline] = ACTIONS(2310),
    [anon_sym___inline__] = ACTIONS(2310),
    [anon_sym___forceinline] = ACTIONS(2310),
    [anon_sym_thread_local] = ACTIONS(2310),
    [anon_sym___thread] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [sym_primitive_type] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_class] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2310),
    [anon_sym_switch] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_goto] = ACTIONS(2310),
    [anon_sym___try] = ACTIONS(2310),
    [anon_sym___leave] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_compl] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2310),
    [anon_sym___alignof__] = ACTIONS(2310),
    [anon_sym___alignof] = ACTIONS(2310),
    [anon_sym__alignof] = ACTIONS(2310),
    [anon_sym_alignof] = ACTIONS(2310),
    [anon_sym__Alignof] = ACTIONS(2310),
    [anon_sym_offsetof] = ACTIONS(2310),
    [anon_sym__Generic] = ACTIONS(2310),
    [anon_sym_asm] = ACTIONS(2310),
    [anon_sym___asm__] = ACTIONS(2310),
    [anon_sym___asm] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2312),
    [anon_sym_L_SQUOTE] = ACTIONS(2312),
    [anon_sym_u_SQUOTE] = ACTIONS(2312),
    [anon_sym_U_SQUOTE] = ACTIONS(2312),
    [anon_sym_u8_SQUOTE] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_L_DQUOTE] = ACTIONS(2312),
    [anon_sym_u_DQUOTE] = ACTIONS(2312),
    [anon_sym_U_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [anon_sym_NULL] = ACTIONS(2310),
    [anon_sym_nullptr] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2310),
    [anon_sym_decltype] = ACTIONS(2310),
    [anon_sym_explicit] = ACTIONS(2310),
    [anon_sym_typename] = ACTIONS(2310),
    [anon_sym_export] = ACTIONS(2310),
    [anon_sym_module] = ACTIONS(2310),
    [anon_sym_import] = ACTIONS(2310),
    [anon_sym_template] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [anon_sym_delete] = ACTIONS(2310),
    [anon_sym_throw] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2310),
    [anon_sym_static_assert] = ACTIONS(2310),
    [anon_sym_concept] = ACTIONS(2310),
    [anon_sym_co_return] = ACTIONS(2310),
    [anon_sym_co_yield] = ACTIONS(2310),
    [anon_sym_R_DQUOTE] = ACTIONS(2312),
    [anon_sym_LR_DQUOTE] = ACTIONS(2312),
    [anon_sym_uR_DQUOTE] = ACTIONS(2312),
    [anon_sym_UR_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2312),
    [anon_sym_co_await] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2310),
    [sym_this] = ACTIONS(2310),
    [anon_sym_discard] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2310),
    [anon_sym_shared] = ACTIONS(2310),
    [anon_sym_groupshared] = ACTIONS(2310),
    [anon_sym_uniform] = ACTIONS(2310),
    [anon_sym_row_major] = ACTIONS(2310),
    [anon_sym_column_major] = ACTIONS(2310),
    [anon_sym_globallycoherent] = ACTIONS(2310),
    [anon_sym_centroid] = ACTIONS(2310),
    [anon_sym_noperspective] = ACTIONS(2310),
    [anon_sym_nointerpolation] = ACTIONS(2310),
    [anon_sym_sample] = ACTIONS(2310),
    [anon_sym_linear] = ACTIONS(2310),
    [anon_sym_snorm] = ACTIONS(2310),
    [anon_sym_unorm] = ACTIONS(2310),
    [anon_sym_point] = ACTIONS(2310),
    [anon_sym_line] = ACTIONS(2310),
    [anon_sym_triangleadj] = ACTIONS(2310),
    [anon_sym_lineadj] = ACTIONS(2310),
    [anon_sym_triangle] = ACTIONS(2310),
    [anon_sym_cbuffer] = ACTIONS(2310),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_include_token1] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym___cdecl] = ACTIONS(2163),
    [anon_sym___clrcall] = ACTIONS(2163),
    [anon_sym___stdcall] = ACTIONS(2163),
    [anon_sym___fastcall] = ACTIONS(2163),
    [anon_sym___thiscall] = ACTIONS(2163),
    [anon_sym___vectorcall] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_goto] = ACTIONS(2163),
    [anon_sym___try] = ACTIONS(2163),
    [anon_sym___leave] = ACTIONS(2163),
    [anon_sym_not] = ACTIONS(2163),
    [anon_sym_compl] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_sizeof] = ACTIONS(2163),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2163),
    [anon_sym__Generic] = ACTIONS(2163),
    [anon_sym_asm] = ACTIONS(2163),
    [anon_sym___asm__] = ACTIONS(2163),
    [anon_sym___asm] = ACTIONS(2163),
    [sym_number_literal] = ACTIONS(2165),
    [anon_sym_L_SQUOTE] = ACTIONS(2165),
    [anon_sym_u_SQUOTE] = ACTIONS(2165),
    [anon_sym_U_SQUOTE] = ACTIONS(2165),
    [anon_sym_u8_SQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [anon_sym_L_DQUOTE] = ACTIONS(2165),
    [anon_sym_u_DQUOTE] = ACTIONS(2165),
    [anon_sym_U_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8_DQUOTE] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [anon_sym_NULL] = ACTIONS(2163),
    [anon_sym_nullptr] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_export] = ACTIONS(2163),
    [anon_sym_module] = ACTIONS(2163),
    [anon_sym_import] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_concept] = ACTIONS(2163),
    [anon_sym_co_return] = ACTIONS(2163),
    [anon_sym_co_yield] = ACTIONS(2163),
    [anon_sym_R_DQUOTE] = ACTIONS(2165),
    [anon_sym_LR_DQUOTE] = ACTIONS(2165),
    [anon_sym_uR_DQUOTE] = ACTIONS(2165),
    [anon_sym_UR_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2165),
    [anon_sym_co_await] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_requires] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [anon_sym_discard] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
    [anon_sym_cbuffer] = ACTIONS(2163),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(2169),
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_include_token1] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym___cdecl] = ACTIONS(2167),
    [anon_sym___clrcall] = ACTIONS(2167),
    [anon_sym___stdcall] = ACTIONS(2167),
    [anon_sym___fastcall] = ACTIONS(2167),
    [anon_sym___thiscall] = ACTIONS(2167),
    [anon_sym___vectorcall] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_goto] = ACTIONS(2167),
    [anon_sym___try] = ACTIONS(2167),
    [anon_sym___leave] = ACTIONS(2167),
    [anon_sym_not] = ACTIONS(2167),
    [anon_sym_compl] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2167),
    [anon_sym___alignof__] = ACTIONS(2167),
    [anon_sym___alignof] = ACTIONS(2167),
    [anon_sym__alignof] = ACTIONS(2167),
    [anon_sym_alignof] = ACTIONS(2167),
    [anon_sym__Alignof] = ACTIONS(2167),
    [anon_sym_offsetof] = ACTIONS(2167),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2167),
    [anon_sym___asm__] = ACTIONS(2167),
    [anon_sym___asm] = ACTIONS(2167),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [anon_sym_NULL] = ACTIONS(2167),
    [anon_sym_nullptr] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_export] = ACTIONS(2167),
    [anon_sym_module] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_concept] = ACTIONS(2167),
    [anon_sym_co_return] = ACTIONS(2167),
    [anon_sym_co_yield] = ACTIONS(2167),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [anon_sym_discard] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
    [anon_sym_cbuffer] = ACTIONS(2167),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_export] = ACTIONS(2284),
    [anon_sym_module] = ACTIONS(2284),
    [anon_sym_import] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
  },
  [272] = {
    [ts_builtin_sym_end] = ACTIONS(2328),
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_out] = ACTIONS(2326),
    [anon_sym_inout] = ACTIONS(2326),
    [anon_sym_virtual] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym___attribute] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym__Nonnull] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [anon_sym___asm] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_export] = ACTIONS(2326),
    [anon_sym_module] = ACTIONS(2326),
    [anon_sym_import] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym_discard] = ACTIONS(2326),
    [anon_sym_precise] = ACTIONS(2326),
    [anon_sym_shared] = ACTIONS(2326),
    [anon_sym_groupshared] = ACTIONS(2326),
    [anon_sym_uniform] = ACTIONS(2326),
    [anon_sym_row_major] = ACTIONS(2326),
    [anon_sym_column_major] = ACTIONS(2326),
    [anon_sym_globallycoherent] = ACTIONS(2326),
    [anon_sym_centroid] = ACTIONS(2326),
    [anon_sym_noperspective] = ACTIONS(2326),
    [anon_sym_nointerpolation] = ACTIONS(2326),
    [anon_sym_sample] = ACTIONS(2326),
    [anon_sym_linear] = ACTIONS(2326),
    [anon_sym_snorm] = ACTIONS(2326),
    [anon_sym_unorm] = ACTIONS(2326),
    [anon_sym_point] = ACTIONS(2326),
    [anon_sym_line] = ACTIONS(2326),
    [anon_sym_triangleadj] = ACTIONS(2326),
    [anon_sym_lineadj] = ACTIONS(2326),
    [anon_sym_triangle] = ACTIONS(2326),
    [anon_sym_cbuffer] = ACTIONS(2326),
  },
  [273] = {
    [sym_catch_clause] = STATE(280),
    [aux_sym_constructor_try_statement_repeat1] = STATE(280),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_include_token1] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token2] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym___cdecl] = ACTIONS(2021),
    [anon_sym___clrcall] = ACTIONS(2021),
    [anon_sym___stdcall] = ACTIONS(2021),
    [anon_sym___fastcall] = ACTIONS(2021),
    [anon_sym___thiscall] = ACTIONS(2021),
    [anon_sym___vectorcall] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_goto] = ACTIONS(2021),
    [anon_sym___try] = ACTIONS(2021),
    [anon_sym___leave] = ACTIONS(2021),
    [anon_sym_not] = ACTIONS(2021),
    [anon_sym_compl] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2021),
    [anon_sym___alignof__] = ACTIONS(2021),
    [anon_sym___alignof] = ACTIONS(2021),
    [anon_sym__alignof] = ACTIONS(2021),
    [anon_sym_alignof] = ACTIONS(2021),
    [anon_sym__Alignof] = ACTIONS(2021),
    [anon_sym_offsetof] = ACTIONS(2021),
    [anon_sym__Generic] = ACTIONS(2021),
    [anon_sym_asm] = ACTIONS(2021),
    [anon_sym___asm__] = ACTIONS(2021),
    [anon_sym___asm] = ACTIONS(2021),
    [sym_number_literal] = ACTIONS(2023),
    [anon_sym_L_SQUOTE] = ACTIONS(2023),
    [anon_sym_u_SQUOTE] = ACTIONS(2023),
    [anon_sym_U_SQUOTE] = ACTIONS(2023),
    [anon_sym_u8_SQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_L_DQUOTE] = ACTIONS(2023),
    [anon_sym_u_DQUOTE] = ACTIONS(2023),
    [anon_sym_U_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8_DQUOTE] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [anon_sym_NULL] = ACTIONS(2021),
    [anon_sym_nullptr] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_concept] = ACTIONS(2021),
    [anon_sym_co_return] = ACTIONS(2021),
    [anon_sym_co_yield] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(2408),
    [anon_sym_R_DQUOTE] = ACTIONS(2023),
    [anon_sym_LR_DQUOTE] = ACTIONS(2023),
    [anon_sym_uR_DQUOTE] = ACTIONS(2023),
    [anon_sym_UR_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2023),
    [anon_sym_co_await] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_requires] = ACTIONS(2021),
    [sym_this] = ACTIONS(2021),
    [anon_sym_discard] = ACTIONS(2021),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
    [anon_sym_cbuffer] = ACTIONS(2021),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [aux_sym_preproc_else_token1] = ACTIONS(2410),
    [aux_sym_preproc_elif_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [aux_sym_preproc_else_token1] = ACTIONS(2414),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [aux_sym_preproc_else_token1] = ACTIONS(2418),
    [aux_sym_preproc_elif_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_export] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(2288),
    [anon_sym_import] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(2224),
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2224),
    [anon_sym_L_SQUOTE] = ACTIONS(2224),
    [anon_sym_u_SQUOTE] = ACTIONS(2224),
    [anon_sym_U_SQUOTE] = ACTIONS(2224),
    [anon_sym_u8_SQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_L_DQUOTE] = ACTIONS(2224),
    [anon_sym_u_DQUOTE] = ACTIONS(2224),
    [anon_sym_U_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8_DQUOTE] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_export] = ACTIONS(2222),
    [anon_sym_module] = ACTIONS(2222),
    [anon_sym_import] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2224),
    [anon_sym_LR_DQUOTE] = ACTIONS(2224),
    [anon_sym_uR_DQUOTE] = ACTIONS(2224),
    [anon_sym_UR_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2224),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(2228),
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_include_token1] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_typedef] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_virtual] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym___attribute] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym___based] = ACTIONS(2226),
    [anon_sym___cdecl] = ACTIONS(2226),
    [anon_sym___clrcall] = ACTIONS(2226),
    [anon_sym___stdcall] = ACTIONS(2226),
    [anon_sym___fastcall] = ACTIONS(2226),
    [anon_sym___thiscall] = ACTIONS(2226),
    [anon_sym___vectorcall] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym__Nonnull] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_goto] = ACTIONS(2226),
    [anon_sym___try] = ACTIONS(2226),
    [anon_sym___leave] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2226),
    [anon_sym_compl] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2226),
    [anon_sym___alignof__] = ACTIONS(2226),
    [anon_sym___alignof] = ACTIONS(2226),
    [anon_sym__alignof] = ACTIONS(2226),
    [anon_sym_alignof] = ACTIONS(2226),
    [anon_sym__Alignof] = ACTIONS(2226),
    [anon_sym_offsetof] = ACTIONS(2226),
    [anon_sym__Generic] = ACTIONS(2226),
    [anon_sym_asm] = ACTIONS(2226),
    [anon_sym___asm__] = ACTIONS(2226),
    [anon_sym___asm] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2228),
    [anon_sym_L_SQUOTE] = ACTIONS(2228),
    [anon_sym_u_SQUOTE] = ACTIONS(2228),
    [anon_sym_U_SQUOTE] = ACTIONS(2228),
    [anon_sym_u8_SQUOTE] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_L_DQUOTE] = ACTIONS(2228),
    [anon_sym_u_DQUOTE] = ACTIONS(2228),
    [anon_sym_U_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [anon_sym_NULL] = ACTIONS(2226),
    [anon_sym_nullptr] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2226),
    [anon_sym_decltype] = ACTIONS(2226),
    [anon_sym_explicit] = ACTIONS(2226),
    [anon_sym_typename] = ACTIONS(2226),
    [anon_sym_export] = ACTIONS(2226),
    [anon_sym_module] = ACTIONS(2226),
    [anon_sym_import] = ACTIONS(2226),
    [anon_sym_template] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_static_assert] = ACTIONS(2226),
    [anon_sym_concept] = ACTIONS(2226),
    [anon_sym_co_return] = ACTIONS(2226),
    [anon_sym_co_yield] = ACTIONS(2226),
    [anon_sym_R_DQUOTE] = ACTIONS(2228),
    [anon_sym_LR_DQUOTE] = ACTIONS(2228),
    [anon_sym_uR_DQUOTE] = ACTIONS(2228),
    [anon_sym_UR_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2228),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [anon_sym_discard] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_groupshared] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_row_major] = ACTIONS(2226),
    [anon_sym_column_major] = ACTIONS(2226),
    [anon_sym_globallycoherent] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym_nointerpolation] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_linear] = ACTIONS(2226),
    [anon_sym_snorm] = ACTIONS(2226),
    [anon_sym_unorm] = ACTIONS(2226),
    [anon_sym_point] = ACTIONS(2226),
    [anon_sym_line] = ACTIONS(2226),
    [anon_sym_triangleadj] = ACTIONS(2226),
    [anon_sym_lineadj] = ACTIONS(2226),
    [anon_sym_triangle] = ACTIONS(2226),
    [anon_sym_cbuffer] = ACTIONS(2226),
  },
  [280] = {
    [sym_catch_clause] = STATE(280),
    [aux_sym_constructor_try_statement_repeat1] = STATE(280),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_include_token1] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token2] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym___cdecl] = ACTIONS(2031),
    [anon_sym___clrcall] = ACTIONS(2031),
    [anon_sym___stdcall] = ACTIONS(2031),
    [anon_sym___fastcall] = ACTIONS(2031),
    [anon_sym___thiscall] = ACTIONS(2031),
    [anon_sym___vectorcall] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2031),
    [anon_sym___leave] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2031),
    [anon_sym_compl] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2031),
    [anon_sym___alignof] = ACTIONS(2031),
    [anon_sym__alignof] = ACTIONS(2031),
    [anon_sym_alignof] = ACTIONS(2031),
    [anon_sym__Alignof] = ACTIONS(2031),
    [anon_sym_offsetof] = ACTIONS(2031),
    [anon_sym__Generic] = ACTIONS(2031),
    [anon_sym_asm] = ACTIONS(2031),
    [anon_sym___asm__] = ACTIONS(2031),
    [anon_sym___asm] = ACTIONS(2031),
    [sym_number_literal] = ACTIONS(2033),
    [anon_sym_L_SQUOTE] = ACTIONS(2033),
    [anon_sym_u_SQUOTE] = ACTIONS(2033),
    [anon_sym_U_SQUOTE] = ACTIONS(2033),
    [anon_sym_u8_SQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [anon_sym_L_DQUOTE] = ACTIONS(2033),
    [anon_sym_u_DQUOTE] = ACTIONS(2033),
    [anon_sym_U_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8_DQUOTE] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [anon_sym_NULL] = ACTIONS(2031),
    [anon_sym_nullptr] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_concept] = ACTIONS(2031),
    [anon_sym_co_return] = ACTIONS(2031),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(2422),
    [anon_sym_R_DQUOTE] = ACTIONS(2033),
    [anon_sym_LR_DQUOTE] = ACTIONS(2033),
    [anon_sym_uR_DQUOTE] = ACTIONS(2033),
    [anon_sym_UR_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2033),
    [anon_sym_co_await] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_requires] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [anon_sym_discard] = ACTIONS(2031),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
    [anon_sym_cbuffer] = ACTIONS(2031),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_include_token1] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token2] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [aux_sym_preproc_else_token1] = ACTIONS(2425),
    [aux_sym_preproc_elif_token1] = ACTIONS(2425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym___cdecl] = ACTIONS(2425),
    [anon_sym___clrcall] = ACTIONS(2425),
    [anon_sym___stdcall] = ACTIONS(2425),
    [anon_sym___fastcall] = ACTIONS(2425),
    [anon_sym___thiscall] = ACTIONS(2425),
    [anon_sym___vectorcall] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_goto] = ACTIONS(2425),
    [anon_sym___try] = ACTIONS(2425),
    [anon_sym___leave] = ACTIONS(2425),
    [anon_sym_not] = ACTIONS(2425),
    [anon_sym_compl] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_sizeof] = ACTIONS(2425),
    [anon_sym___alignof__] = ACTIONS(2425),
    [anon_sym___alignof] = ACTIONS(2425),
    [anon_sym__alignof] = ACTIONS(2425),
    [anon_sym_alignof] = ACTIONS(2425),
    [anon_sym__Alignof] = ACTIONS(2425),
    [anon_sym_offsetof] = ACTIONS(2425),
    [anon_sym__Generic] = ACTIONS(2425),
    [anon_sym_asm] = ACTIONS(2425),
    [anon_sym___asm__] = ACTIONS(2425),
    [anon_sym___asm] = ACTIONS(2425),
    [sym_number_literal] = ACTIONS(2427),
    [anon_sym_L_SQUOTE] = ACTIONS(2427),
    [anon_sym_u_SQUOTE] = ACTIONS(2427),
    [anon_sym_U_SQUOTE] = ACTIONS(2427),
    [anon_sym_u8_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_L_DQUOTE] = ACTIONS(2427),
    [anon_sym_u_DQUOTE] = ACTIONS(2427),
    [anon_sym_U_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8_DQUOTE] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [anon_sym_NULL] = ACTIONS(2425),
    [anon_sym_nullptr] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_concept] = ACTIONS(2425),
    [anon_sym_co_return] = ACTIONS(2425),
    [anon_sym_co_yield] = ACTIONS(2425),
    [anon_sym_R_DQUOTE] = ACTIONS(2427),
    [anon_sym_LR_DQUOTE] = ACTIONS(2427),
    [anon_sym_uR_DQUOTE] = ACTIONS(2427),
    [anon_sym_UR_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2427),
    [anon_sym_co_await] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_requires] = ACTIONS(2425),
    [sym_this] = ACTIONS(2425),
    [anon_sym_discard] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
    [anon_sym_cbuffer] = ACTIONS(2425),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_include_token1] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token2] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [aux_sym_preproc_else_token1] = ACTIONS(2429),
    [aux_sym_preproc_elif_token1] = ACTIONS(2429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym___cdecl] = ACTIONS(2429),
    [anon_sym___clrcall] = ACTIONS(2429),
    [anon_sym___stdcall] = ACTIONS(2429),
    [anon_sym___fastcall] = ACTIONS(2429),
    [anon_sym___thiscall] = ACTIONS(2429),
    [anon_sym___vectorcall] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym___try] = ACTIONS(2429),
    [anon_sym___leave] = ACTIONS(2429),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_compl] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_sizeof] = ACTIONS(2429),
    [anon_sym___alignof__] = ACTIONS(2429),
    [anon_sym___alignof] = ACTIONS(2429),
    [anon_sym__alignof] = ACTIONS(2429),
    [anon_sym_alignof] = ACTIONS(2429),
    [anon_sym__Alignof] = ACTIONS(2429),
    [anon_sym_offsetof] = ACTIONS(2429),
    [anon_sym__Generic] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym___asm__] = ACTIONS(2429),
    [anon_sym___asm] = ACTIONS(2429),
    [sym_number_literal] = ACTIONS(2431),
    [anon_sym_L_SQUOTE] = ACTIONS(2431),
    [anon_sym_u_SQUOTE] = ACTIONS(2431),
    [anon_sym_U_SQUOTE] = ACTIONS(2431),
    [anon_sym_u8_SQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [anon_sym_L_DQUOTE] = ACTIONS(2431),
    [anon_sym_u_DQUOTE] = ACTIONS(2431),
    [anon_sym_U_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8_DQUOTE] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [anon_sym_NULL] = ACTIONS(2429),
    [anon_sym_nullptr] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_concept] = ACTIONS(2429),
    [anon_sym_co_return] = ACTIONS(2429),
    [anon_sym_co_yield] = ACTIONS(2429),
    [anon_sym_R_DQUOTE] = ACTIONS(2431),
    [anon_sym_LR_DQUOTE] = ACTIONS(2431),
    [anon_sym_uR_DQUOTE] = ACTIONS(2431),
    [anon_sym_UR_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2431),
    [anon_sym_co_await] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_requires] = ACTIONS(2429),
    [sym_this] = ACTIONS(2429),
    [anon_sym_discard] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
    [anon_sym_cbuffer] = ACTIONS(2429),
  },
  [283] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_include_token1] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token2] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [aux_sym_preproc_else_token1] = ACTIONS(2433),
    [aux_sym_preproc_elif_token1] = ACTIONS(2433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym___cdecl] = ACTIONS(2433),
    [anon_sym___clrcall] = ACTIONS(2433),
    [anon_sym___stdcall] = ACTIONS(2433),
    [anon_sym___fastcall] = ACTIONS(2433),
    [anon_sym___thiscall] = ACTIONS(2433),
    [anon_sym___vectorcall] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_goto] = ACTIONS(2433),
    [anon_sym___try] = ACTIONS(2433),
    [anon_sym___leave] = ACTIONS(2433),
    [anon_sym_not] = ACTIONS(2433),
    [anon_sym_compl] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_sizeof] = ACTIONS(2433),
    [anon_sym___alignof__] = ACTIONS(2433),
    [anon_sym___alignof] = ACTIONS(2433),
    [anon_sym__alignof] = ACTIONS(2433),
    [anon_sym_alignof] = ACTIONS(2433),
    [anon_sym__Alignof] = ACTIONS(2433),
    [anon_sym_offsetof] = ACTIONS(2433),
    [anon_sym__Generic] = ACTIONS(2433),
    [anon_sym_asm] = ACTIONS(2433),
    [anon_sym___asm__] = ACTIONS(2433),
    [anon_sym___asm] = ACTIONS(2433),
    [sym_number_literal] = ACTIONS(2435),
    [anon_sym_L_SQUOTE] = ACTIONS(2435),
    [anon_sym_u_SQUOTE] = ACTIONS(2435),
    [anon_sym_U_SQUOTE] = ACTIONS(2435),
    [anon_sym_u8_SQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_L_DQUOTE] = ACTIONS(2435),
    [anon_sym_u_DQUOTE] = ACTIONS(2435),
    [anon_sym_U_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8_DQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [anon_sym_NULL] = ACTIONS(2433),
    [anon_sym_nullptr] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_concept] = ACTIONS(2433),
    [anon_sym_co_return] = ACTIONS(2433),
    [anon_sym_co_yield] = ACTIONS(2433),
    [anon_sym_R_DQUOTE] = ACTIONS(2435),
    [anon_sym_LR_DQUOTE] = ACTIONS(2435),
    [anon_sym_uR_DQUOTE] = ACTIONS(2435),
    [anon_sym_UR_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2435),
    [anon_sym_co_await] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_requires] = ACTIONS(2433),
    [sym_this] = ACTIONS(2433),
    [anon_sym_discard] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
    [anon_sym_cbuffer] = ACTIONS(2433),
  },
  [284] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_include_token1] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token2] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [aux_sym_preproc_else_token1] = ACTIONS(2437),
    [aux_sym_preproc_elif_token1] = ACTIONS(2437),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym___cdecl] = ACTIONS(2437),
    [anon_sym___clrcall] = ACTIONS(2437),
    [anon_sym___stdcall] = ACTIONS(2437),
    [anon_sym___fastcall] = ACTIONS(2437),
    [anon_sym___thiscall] = ACTIONS(2437),
    [anon_sym___vectorcall] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_goto] = ACTIONS(2437),
    [anon_sym___try] = ACTIONS(2437),
    [anon_sym___leave] = ACTIONS(2437),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_compl] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_sizeof] = ACTIONS(2437),
    [anon_sym___alignof__] = ACTIONS(2437),
    [anon_sym___alignof] = ACTIONS(2437),
    [anon_sym__alignof] = ACTIONS(2437),
    [anon_sym_alignof] = ACTIONS(2437),
    [anon_sym__Alignof] = ACTIONS(2437),
    [anon_sym_offsetof] = ACTIONS(2437),
    [anon_sym__Generic] = ACTIONS(2437),
    [anon_sym_asm] = ACTIONS(2437),
    [anon_sym___asm__] = ACTIONS(2437),
    [anon_sym___asm] = ACTIONS(2437),
    [sym_number_literal] = ACTIONS(2439),
    [anon_sym_L_SQUOTE] = ACTIONS(2439),
    [anon_sym_u_SQUOTE] = ACTIONS(2439),
    [anon_sym_U_SQUOTE] = ACTIONS(2439),
    [anon_sym_u8_SQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_L_DQUOTE] = ACTIONS(2439),
    [anon_sym_u_DQUOTE] = ACTIONS(2439),
    [anon_sym_U_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8_DQUOTE] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [anon_sym_NULL] = ACTIONS(2437),
    [anon_sym_nullptr] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_concept] = ACTIONS(2437),
    [anon_sym_co_return] = ACTIONS(2437),
    [anon_sym_co_yield] = ACTIONS(2437),
    [anon_sym_R_DQUOTE] = ACTIONS(2439),
    [anon_sym_LR_DQUOTE] = ACTIONS(2439),
    [anon_sym_uR_DQUOTE] = ACTIONS(2439),
    [anon_sym_UR_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2439),
    [anon_sym_co_await] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_requires] = ACTIONS(2437),
    [sym_this] = ACTIONS(2437),
    [anon_sym_discard] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
    [anon_sym_cbuffer] = ACTIONS(2437),
  },
  [285] = {
    [sym_identifier] = ACTIONS(2011),
    [aux_sym_preproc_include_token1] = ACTIONS(2011),
    [aux_sym_preproc_def_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2011),
    [sym_preproc_directive] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_using] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_goto] = ACTIONS(2011),
    [anon_sym___try] = ACTIONS(2011),
    [anon_sym___leave] = ACTIONS(2011),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_compl] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2011),
    [anon_sym___alignof__] = ACTIONS(2011),
    [anon_sym___alignof] = ACTIONS(2011),
    [anon_sym__alignof] = ACTIONS(2011),
    [anon_sym_alignof] = ACTIONS(2011),
    [anon_sym__Alignof] = ACTIONS(2011),
    [anon_sym_offsetof] = ACTIONS(2011),
    [anon_sym__Generic] = ACTIONS(2011),
    [anon_sym_asm] = ACTIONS(2011),
    [anon_sym___asm__] = ACTIONS(2011),
    [anon_sym___asm] = ACTIONS(2011),
    [sym_number_literal] = ACTIONS(2013),
    [anon_sym_L_SQUOTE] = ACTIONS(2013),
    [anon_sym_u_SQUOTE] = ACTIONS(2013),
    [anon_sym_U_SQUOTE] = ACTIONS(2013),
    [anon_sym_u8_SQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [anon_sym_L_DQUOTE] = ACTIONS(2013),
    [anon_sym_u_DQUOTE] = ACTIONS(2013),
    [anon_sym_U_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8_DQUOTE] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [anon_sym_NULL] = ACTIONS(2011),
    [anon_sym_nullptr] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_explicit] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_static_assert] = ACTIONS(2011),
    [anon_sym_concept] = ACTIONS(2011),
    [anon_sym_co_return] = ACTIONS(2011),
    [anon_sym_co_yield] = ACTIONS(2011),
    [anon_sym_R_DQUOTE] = ACTIONS(2013),
    [anon_sym_LR_DQUOTE] = ACTIONS(2013),
    [anon_sym_uR_DQUOTE] = ACTIONS(2013),
    [anon_sym_UR_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2013),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [sym_this] = ACTIONS(2011),
    [anon_sym_discard] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
    [anon_sym_cbuffer] = ACTIONS(2011),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(2232),
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_include_token1] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AMP_AMP] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_typedef] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_virtual] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym___attribute] = ACTIONS(2230),
    [anon_sym_using] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym___based] = ACTIONS(2230),
    [anon_sym___cdecl] = ACTIONS(2230),
    [anon_sym___clrcall] = ACTIONS(2230),
    [anon_sym___stdcall] = ACTIONS(2230),
    [anon_sym___fastcall] = ACTIONS(2230),
    [anon_sym___thiscall] = ACTIONS(2230),
    [anon_sym___vectorcall] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym__Nonnull] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_class] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2230),
    [anon_sym_switch] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_goto] = ACTIONS(2230),
    [anon_sym___try] = ACTIONS(2230),
    [anon_sym___leave] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2232),
    [anon_sym_sizeof] = ACTIONS(2230),
    [anon_sym___alignof__] = ACTIONS(2230),
    [anon_sym___alignof] = ACTIONS(2230),
    [anon_sym__alignof] = ACTIONS(2230),
    [anon_sym_alignof] = ACTIONS(2230),
    [anon_sym__Alignof] = ACTIONS(2230),
    [anon_sym_offsetof] = ACTIONS(2230),
    [anon_sym__Generic] = ACTIONS(2230),
    [anon_sym_asm] = ACTIONS(2230),
    [anon_sym___asm__] = ACTIONS(2230),
    [anon_sym___asm] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2232),
    [anon_sym_L_SQUOTE] = ACTIONS(2232),
    [anon_sym_u_SQUOTE] = ACTIONS(2232),
    [anon_sym_U_SQUOTE] = ACTIONS(2232),
    [anon_sym_u8_SQUOTE] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_L_DQUOTE] = ACTIONS(2232),
    [anon_sym_u_DQUOTE] = ACTIONS(2232),
    [anon_sym_U_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8_DQUOTE] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [sym_true] = ACTIONS(2230),
    [sym_false] = ACTIONS(2230),
    [anon_sym_NULL] = ACTIONS(2230),
    [anon_sym_nullptr] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2230),
    [anon_sym_decltype] = ACTIONS(2230),
    [anon_sym_explicit] = ACTIONS(2230),
    [anon_sym_typename] = ACTIONS(2230),
    [anon_sym_export] = ACTIONS(2230),
    [anon_sym_module] = ACTIONS(2230),
    [anon_sym_import] = ACTIONS(2230),
    [anon_sym_template] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_delete] = ACTIONS(2230),
    [anon_sym_throw] = ACTIONS(2230),
    [anon_sym_namespace] = ACTIONS(2230),
    [anon_sym_static_assert] = ACTIONS(2230),
    [anon_sym_concept] = ACTIONS(2230),
    [anon_sym_co_return] = ACTIONS(2230),
    [anon_sym_co_yield] = ACTIONS(2230),
    [anon_sym_R_DQUOTE] = ACTIONS(2232),
    [anon_sym_LR_DQUOTE] = ACTIONS(2232),
    [anon_sym_uR_DQUOTE] = ACTIONS(2232),
    [anon_sym_UR_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2232),
    [anon_sym_co_await] = ACTIONS(2230),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2230),
    [sym_this] = ACTIONS(2230),
    [anon_sym_discard] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_groupshared] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_row_major] = ACTIONS(2230),
    [anon_sym_column_major] = ACTIONS(2230),
    [anon_sym_globallycoherent] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym_nointerpolation] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_linear] = ACTIONS(2230),
    [anon_sym_snorm] = ACTIONS(2230),
    [anon_sym_unorm] = ACTIONS(2230),
    [anon_sym_point] = ACTIONS(2230),
    [anon_sym_line] = ACTIONS(2230),
    [anon_sym_triangleadj] = ACTIONS(2230),
    [anon_sym_lineadj] = ACTIONS(2230),
    [anon_sym_triangle] = ACTIONS(2230),
    [anon_sym_cbuffer] = ACTIONS(2230),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [289] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [290] = {
    [sym_identifier] = ACTIONS(2027),
    [aux_sym_preproc_include_token1] = ACTIONS(2027),
    [aux_sym_preproc_def_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2027),
    [sym_preproc_directive] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_typedef] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_using] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym___try] = ACTIONS(2027),
    [anon_sym___leave] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2027),
    [anon_sym_compl] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym___alignof__] = ACTIONS(2027),
    [anon_sym___alignof] = ACTIONS(2027),
    [anon_sym__alignof] = ACTIONS(2027),
    [anon_sym_alignof] = ACTIONS(2027),
    [anon_sym__Alignof] = ACTIONS(2027),
    [anon_sym_offsetof] = ACTIONS(2027),
    [anon_sym__Generic] = ACTIONS(2027),
    [anon_sym_asm] = ACTIONS(2027),
    [anon_sym___asm__] = ACTIONS(2027),
    [anon_sym___asm] = ACTIONS(2027),
    [sym_number_literal] = ACTIONS(2029),
    [anon_sym_L_SQUOTE] = ACTIONS(2029),
    [anon_sym_u_SQUOTE] = ACTIONS(2029),
    [anon_sym_U_SQUOTE] = ACTIONS(2029),
    [anon_sym_u8_SQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [anon_sym_L_DQUOTE] = ACTIONS(2029),
    [anon_sym_u_DQUOTE] = ACTIONS(2029),
    [anon_sym_U_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8_DQUOTE] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [anon_sym_NULL] = ACTIONS(2027),
    [anon_sym_nullptr] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_explicit] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_static_assert] = ACTIONS(2027),
    [anon_sym_concept] = ACTIONS(2027),
    [anon_sym_co_return] = ACTIONS(2027),
    [anon_sym_co_yield] = ACTIONS(2027),
    [anon_sym_R_DQUOTE] = ACTIONS(2029),
    [anon_sym_LR_DQUOTE] = ACTIONS(2029),
    [anon_sym_uR_DQUOTE] = ACTIONS(2029),
    [anon_sym_UR_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2029),
    [anon_sym_co_await] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [sym_this] = ACTIONS(2027),
    [anon_sym_discard] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
    [anon_sym_cbuffer] = ACTIONS(2027),
  },
  [291] = {
    [sym_identifier] = ACTIONS(2038),
    [aux_sym_preproc_include_token1] = ACTIONS(2038),
    [aux_sym_preproc_def_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2038),
    [sym_preproc_directive] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_goto] = ACTIONS(2038),
    [anon_sym___try] = ACTIONS(2038),
    [anon_sym___leave] = ACTIONS(2038),
    [anon_sym_not] = ACTIONS(2038),
    [anon_sym_compl] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_sizeof] = ACTIONS(2038),
    [anon_sym___alignof__] = ACTIONS(2038),
    [anon_sym___alignof] = ACTIONS(2038),
    [anon_sym__alignof] = ACTIONS(2038),
    [anon_sym_alignof] = ACTIONS(2038),
    [anon_sym__Alignof] = ACTIONS(2038),
    [anon_sym_offsetof] = ACTIONS(2038),
    [anon_sym__Generic] = ACTIONS(2038),
    [anon_sym_asm] = ACTIONS(2038),
    [anon_sym___asm__] = ACTIONS(2038),
    [anon_sym___asm] = ACTIONS(2038),
    [sym_number_literal] = ACTIONS(2040),
    [anon_sym_L_SQUOTE] = ACTIONS(2040),
    [anon_sym_u_SQUOTE] = ACTIONS(2040),
    [anon_sym_U_SQUOTE] = ACTIONS(2040),
    [anon_sym_u8_SQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_L_DQUOTE] = ACTIONS(2040),
    [anon_sym_u_DQUOTE] = ACTIONS(2040),
    [anon_sym_U_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8_DQUOTE] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [anon_sym_NULL] = ACTIONS(2038),
    [anon_sym_nullptr] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2038),
    [anon_sym_static_assert] = ACTIONS(2038),
    [anon_sym_concept] = ACTIONS(2038),
    [anon_sym_co_return] = ACTIONS(2038),
    [anon_sym_co_yield] = ACTIONS(2038),
    [anon_sym_R_DQUOTE] = ACTIONS(2040),
    [anon_sym_LR_DQUOTE] = ACTIONS(2040),
    [anon_sym_uR_DQUOTE] = ACTIONS(2040),
    [anon_sym_UR_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2040),
    [anon_sym_co_await] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [sym_this] = ACTIONS(2038),
    [anon_sym_discard] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
    [anon_sym_cbuffer] = ACTIONS(2038),
  },
  [292] = {
    [ts_builtin_sym_end] = ACTIONS(2236),
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_include_token1] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_typedef] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_virtual] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym___based] = ACTIONS(2234),
    [anon_sym___cdecl] = ACTIONS(2234),
    [anon_sym___clrcall] = ACTIONS(2234),
    [anon_sym___stdcall] = ACTIONS(2234),
    [anon_sym___fastcall] = ACTIONS(2234),
    [anon_sym___thiscall] = ACTIONS(2234),
    [anon_sym___vectorcall] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym__Nonnull] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_goto] = ACTIONS(2234),
    [anon_sym___try] = ACTIONS(2234),
    [anon_sym___leave] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2234),
    [anon_sym_compl] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2236),
    [anon_sym_sizeof] = ACTIONS(2234),
    [anon_sym___alignof__] = ACTIONS(2234),
    [anon_sym___alignof] = ACTIONS(2234),
    [anon_sym__alignof] = ACTIONS(2234),
    [anon_sym_alignof] = ACTIONS(2234),
    [anon_sym__Alignof] = ACTIONS(2234),
    [anon_sym_offsetof] = ACTIONS(2234),
    [anon_sym__Generic] = ACTIONS(2234),
    [anon_sym_asm] = ACTIONS(2234),
    [anon_sym___asm__] = ACTIONS(2234),
    [anon_sym___asm] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2236),
    [anon_sym_L_SQUOTE] = ACTIONS(2236),
    [anon_sym_u_SQUOTE] = ACTIONS(2236),
    [anon_sym_U_SQUOTE] = ACTIONS(2236),
    [anon_sym_u8_SQUOTE] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_L_DQUOTE] = ACTIONS(2236),
    [anon_sym_u_DQUOTE] = ACTIONS(2236),
    [anon_sym_U_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8_DQUOTE] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2236),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [anon_sym_NULL] = ACTIONS(2234),
    [anon_sym_nullptr] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2234),
    [anon_sym_decltype] = ACTIONS(2234),
    [anon_sym_explicit] = ACTIONS(2234),
    [anon_sym_typename] = ACTIONS(2234),
    [anon_sym_export] = ACTIONS(2234),
    [anon_sym_module] = ACTIONS(2234),
    [anon_sym_import] = ACTIONS(2234),
    [anon_sym_template] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_static_assert] = ACTIONS(2234),
    [anon_sym_concept] = ACTIONS(2234),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2236),
    [anon_sym_LR_DQUOTE] = ACTIONS(2236),
    [anon_sym_uR_DQUOTE] = ACTIONS(2236),
    [anon_sym_UR_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2236),
    [anon_sym_co_await] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [anon_sym_discard] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_groupshared] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_row_major] = ACTIONS(2234),
    [anon_sym_column_major] = ACTIONS(2234),
    [anon_sym_globallycoherent] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym_nointerpolation] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_linear] = ACTIONS(2234),
    [anon_sym_snorm] = ACTIONS(2234),
    [anon_sym_unorm] = ACTIONS(2234),
    [anon_sym_point] = ACTIONS(2234),
    [anon_sym_line] = ACTIONS(2234),
    [anon_sym_triangleadj] = ACTIONS(2234),
    [anon_sym_lineadj] = ACTIONS(2234),
    [anon_sym_triangle] = ACTIONS(2234),
    [anon_sym_cbuffer] = ACTIONS(2234),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2441),
    [aux_sym_preproc_include_token1] = ACTIONS(2441),
    [aux_sym_preproc_def_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token2] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2441),
    [aux_sym_preproc_else_token1] = ACTIONS(2441),
    [aux_sym_preproc_elif_token1] = ACTIONS(2441),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2441),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2441),
    [sym_preproc_directive] = ACTIONS(2441),
    [anon_sym_LPAREN2] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym___extension__] = ACTIONS(2441),
    [anon_sym_typedef] = ACTIONS(2441),
    [anon_sym_in] = ACTIONS(2441),
    [anon_sym_out] = ACTIONS(2441),
    [anon_sym_inout] = ACTIONS(2441),
    [anon_sym_virtual] = ACTIONS(2441),
    [anon_sym_extern] = ACTIONS(2441),
    [anon_sym___attribute__] = ACTIONS(2441),
    [anon_sym___attribute] = ACTIONS(2441),
    [anon_sym_using] = ACTIONS(2441),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2443),
    [anon_sym___declspec] = ACTIONS(2441),
    [anon_sym___based] = ACTIONS(2441),
    [anon_sym___cdecl] = ACTIONS(2441),
    [anon_sym___clrcall] = ACTIONS(2441),
    [anon_sym___stdcall] = ACTIONS(2441),
    [anon_sym___fastcall] = ACTIONS(2441),
    [anon_sym___thiscall] = ACTIONS(2441),
    [anon_sym___vectorcall] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_signed] = ACTIONS(2441),
    [anon_sym_unsigned] = ACTIONS(2441),
    [anon_sym_long] = ACTIONS(2441),
    [anon_sym_short] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_register] = ACTIONS(2441),
    [anon_sym_inline] = ACTIONS(2441),
    [anon_sym___inline] = ACTIONS(2441),
    [anon_sym___inline__] = ACTIONS(2441),
    [anon_sym___forceinline] = ACTIONS(2441),
    [anon_sym_thread_local] = ACTIONS(2441),
    [anon_sym___thread] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_constexpr] = ACTIONS(2441),
    [anon_sym_volatile] = ACTIONS(2441),
    [anon_sym_restrict] = ACTIONS(2441),
    [anon_sym___restrict__] = ACTIONS(2441),
    [anon_sym__Atomic] = ACTIONS(2441),
    [anon_sym__Noreturn] = ACTIONS(2441),
    [anon_sym_noreturn] = ACTIONS(2441),
    [anon_sym__Nonnull] = ACTIONS(2441),
    [anon_sym_mutable] = ACTIONS(2441),
    [anon_sym_constinit] = ACTIONS(2441),
    [anon_sym_consteval] = ACTIONS(2441),
    [anon_sym_alignas] = ACTIONS(2441),
    [anon_sym__Alignas] = ACTIONS(2441),
    [sym_primitive_type] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_struct] = ACTIONS(2441),
    [anon_sym_union] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_goto] = ACTIONS(2441),
    [anon_sym___try] = ACTIONS(2441),
    [anon_sym___leave] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2441),
    [anon_sym_compl] = ACTIONS(2441),
    [anon_sym_DASH_DASH] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_sizeof] = ACTIONS(2441),
    [anon_sym___alignof__] = ACTIONS(2441),
    [anon_sym___alignof] = ACTIONS(2441),
    [anon_sym__alignof] = ACTIONS(2441),
    [anon_sym_alignof] = ACTIONS(2441),
    [anon_sym__Alignof] = ACTIONS(2441),
    [anon_sym_offsetof] = ACTIONS(2441),
    [anon_sym__Generic] = ACTIONS(2441),
    [anon_sym_asm] = ACTIONS(2441),
    [anon_sym___asm__] = ACTIONS(2441),
    [anon_sym___asm] = ACTIONS(2441),
    [sym_number_literal] = ACTIONS(2443),
    [anon_sym_L_SQUOTE] = ACTIONS(2443),
    [anon_sym_u_SQUOTE] = ACTIONS(2443),
    [anon_sym_U_SQUOTE] = ACTIONS(2443),
    [anon_sym_u8_SQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_L_DQUOTE] = ACTIONS(2443),
    [anon_sym_u_DQUOTE] = ACTIONS(2443),
    [anon_sym_U_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8_DQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [anon_sym_NULL] = ACTIONS(2441),
    [anon_sym_nullptr] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2441),
    [anon_sym_decltype] = ACTIONS(2441),
    [anon_sym_explicit] = ACTIONS(2441),
    [anon_sym_typename] = ACTIONS(2441),
    [anon_sym_template] = ACTIONS(2441),
    [anon_sym_operator] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_static_assert] = ACTIONS(2441),
    [anon_sym_concept] = ACTIONS(2441),
    [anon_sym_co_return] = ACTIONS(2441),
    [anon_sym_co_yield] = ACTIONS(2441),
    [anon_sym_R_DQUOTE] = ACTIONS(2443),
    [anon_sym_LR_DQUOTE] = ACTIONS(2443),
    [anon_sym_uR_DQUOTE] = ACTIONS(2443),
    [anon_sym_UR_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2443),
    [anon_sym_co_await] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_requires] = ACTIONS(2441),
    [sym_this] = ACTIONS(2441),
    [anon_sym_discard] = ACTIONS(2441),
    [anon_sym_precise] = ACTIONS(2441),
    [anon_sym_shared] = ACTIONS(2441),
    [anon_sym_groupshared] = ACTIONS(2441),
    [anon_sym_uniform] = ACTIONS(2441),
    [anon_sym_row_major] = ACTIONS(2441),
    [anon_sym_column_major] = ACTIONS(2441),
    [anon_sym_globallycoherent] = ACTIONS(2441),
    [anon_sym_centroid] = ACTIONS(2441),
    [anon_sym_noperspective] = ACTIONS(2441),
    [anon_sym_nointerpolation] = ACTIONS(2441),
    [anon_sym_sample] = ACTIONS(2441),
    [anon_sym_linear] = ACTIONS(2441),
    [anon_sym_snorm] = ACTIONS(2441),
    [anon_sym_unorm] = ACTIONS(2441),
    [anon_sym_point] = ACTIONS(2441),
    [anon_sym_line] = ACTIONS(2441),
    [anon_sym_triangleadj] = ACTIONS(2441),
    [anon_sym_lineadj] = ACTIONS(2441),
    [anon_sym_triangle] = ACTIONS(2441),
    [anon_sym_cbuffer] = ACTIONS(2441),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(2240),
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_include_token1] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_AMP_AMP] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_typedef] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_virtual] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym___attribute] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym___based] = ACTIONS(2238),
    [anon_sym___cdecl] = ACTIONS(2238),
    [anon_sym___clrcall] = ACTIONS(2238),
    [anon_sym___stdcall] = ACTIONS(2238),
    [anon_sym___fastcall] = ACTIONS(2238),
    [anon_sym___thiscall] = ACTIONS(2238),
    [anon_sym___vectorcall] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym__Nonnull] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_do] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2238),
    [anon_sym___try] = ACTIONS(2238),
    [anon_sym___leave] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2238),
    [anon_sym_compl] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2238),
    [anon_sym___alignof] = ACTIONS(2238),
    [anon_sym__alignof] = ACTIONS(2238),
    [anon_sym_alignof] = ACTIONS(2238),
    [anon_sym__Alignof] = ACTIONS(2238),
    [anon_sym_offsetof] = ACTIONS(2238),
    [anon_sym__Generic] = ACTIONS(2238),
    [anon_sym_asm] = ACTIONS(2238),
    [anon_sym___asm__] = ACTIONS(2238),
    [anon_sym___asm] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2240),
    [anon_sym_L_SQUOTE] = ACTIONS(2240),
    [anon_sym_u_SQUOTE] = ACTIONS(2240),
    [anon_sym_U_SQUOTE] = ACTIONS(2240),
    [anon_sym_u8_SQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_L_DQUOTE] = ACTIONS(2240),
    [anon_sym_u_DQUOTE] = ACTIONS(2240),
    [anon_sym_U_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [anon_sym_NULL] = ACTIONS(2238),
    [anon_sym_nullptr] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2238),
    [anon_sym_decltype] = ACTIONS(2238),
    [anon_sym_explicit] = ACTIONS(2238),
    [anon_sym_typename] = ACTIONS(2238),
    [anon_sym_export] = ACTIONS(2238),
    [anon_sym_module] = ACTIONS(2238),
    [anon_sym_import] = ACTIONS(2238),
    [anon_sym_template] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [anon_sym_delete] = ACTIONS(2238),
    [anon_sym_throw] = ACTIONS(2238),
    [anon_sym_namespace] = ACTIONS(2238),
    [anon_sym_static_assert] = ACTIONS(2238),
    [anon_sym_concept] = ACTIONS(2238),
    [anon_sym_co_return] = ACTIONS(2238),
    [anon_sym_co_yield] = ACTIONS(2238),
    [anon_sym_R_DQUOTE] = ACTIONS(2240),
    [anon_sym_LR_DQUOTE] = ACTIONS(2240),
    [anon_sym_uR_DQUOTE] = ACTIONS(2240),
    [anon_sym_UR_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2240),
    [anon_sym_co_await] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2238),
    [sym_this] = ACTIONS(2238),
    [anon_sym_discard] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_groupshared] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_row_major] = ACTIONS(2238),
    [anon_sym_column_major] = ACTIONS(2238),
    [anon_sym_globallycoherent] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym_nointerpolation] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_linear] = ACTIONS(2238),
    [anon_sym_snorm] = ACTIONS(2238),
    [anon_sym_unorm] = ACTIONS(2238),
    [anon_sym_point] = ACTIONS(2238),
    [anon_sym_line] = ACTIONS(2238),
    [anon_sym_triangleadj] = ACTIONS(2238),
    [anon_sym_lineadj] = ACTIONS(2238),
    [anon_sym_triangle] = ACTIONS(2238),
    [anon_sym_cbuffer] = ACTIONS(2238),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2445),
    [aux_sym_preproc_include_token1] = ACTIONS(2445),
    [aux_sym_preproc_def_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token2] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2445),
    [aux_sym_preproc_else_token1] = ACTIONS(2445),
    [aux_sym_preproc_elif_token1] = ACTIONS(2445),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_LPAREN2] = ACTIONS(2447),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(2447),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym___extension__] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_out] = ACTIONS(2445),
    [anon_sym_inout] = ACTIONS(2445),
    [anon_sym_virtual] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym___attribute__] = ACTIONS(2445),
    [anon_sym___attribute] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2447),
    [anon_sym___declspec] = ACTIONS(2445),
    [anon_sym___based] = ACTIONS(2445),
    [anon_sym___cdecl] = ACTIONS(2445),
    [anon_sym___clrcall] = ACTIONS(2445),
    [anon_sym___stdcall] = ACTIONS(2445),
    [anon_sym___fastcall] = ACTIONS(2445),
    [anon_sym___thiscall] = ACTIONS(2445),
    [anon_sym___vectorcall] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_signed] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym___inline] = ACTIONS(2445),
    [anon_sym___inline__] = ACTIONS(2445),
    [anon_sym___forceinline] = ACTIONS(2445),
    [anon_sym_thread_local] = ACTIONS(2445),
    [anon_sym___thread] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym___restrict__] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym__Noreturn] = ACTIONS(2445),
    [anon_sym_noreturn] = ACTIONS(2445),
    [anon_sym__Nonnull] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_constinit] = ACTIONS(2445),
    [anon_sym_consteval] = ACTIONS(2445),
    [anon_sym_alignas] = ACTIONS(2445),
    [anon_sym__Alignas] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym___try] = ACTIONS(2445),
    [anon_sym___leave] = ACTIONS(2445),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_compl] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_sizeof] = ACTIONS(2445),
    [anon_sym___alignof__] = ACTIONS(2445),
    [anon_sym___alignof] = ACTIONS(2445),
    [anon_sym__alignof] = ACTIONS(2445),
    [anon_sym_alignof] = ACTIONS(2445),
    [anon_sym__Alignof] = ACTIONS(2445),
    [anon_sym_offsetof] = ACTIONS(2445),
    [anon_sym__Generic] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym___asm__] = ACTIONS(2445),
    [anon_sym___asm] = ACTIONS(2445),
    [sym_number_literal] = ACTIONS(2447),
    [anon_sym_L_SQUOTE] = ACTIONS(2447),
    [anon_sym_u_SQUOTE] = ACTIONS(2447),
    [anon_sym_U_SQUOTE] = ACTIONS(2447),
    [anon_sym_u8_SQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [anon_sym_L_DQUOTE] = ACTIONS(2447),
    [anon_sym_u_DQUOTE] = ACTIONS(2447),
    [anon_sym_U_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8_DQUOTE] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [anon_sym_NULL] = ACTIONS(2445),
    [anon_sym_nullptr] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_decltype] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_operator] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_static_assert] = ACTIONS(2445),
    [anon_sym_concept] = ACTIONS(2445),
    [anon_sym_co_return] = ACTIONS(2445),
    [anon_sym_co_yield] = ACTIONS(2445),
    [anon_sym_R_DQUOTE] = ACTIONS(2447),
    [anon_sym_LR_DQUOTE] = ACTIONS(2447),
    [anon_sym_uR_DQUOTE] = ACTIONS(2447),
    [anon_sym_UR_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2447),
    [anon_sym_co_await] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_requires] = ACTIONS(2445),
    [sym_this] = ACTIONS(2445),
    [anon_sym_discard] = ACTIONS(2445),
    [anon_sym_precise] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_groupshared] = ACTIONS(2445),
    [anon_sym_uniform] = ACTIONS(2445),
    [anon_sym_row_major] = ACTIONS(2445),
    [anon_sym_column_major] = ACTIONS(2445),
    [anon_sym_globallycoherent] = ACTIONS(2445),
    [anon_sym_centroid] = ACTIONS(2445),
    [anon_sym_noperspective] = ACTIONS(2445),
    [anon_sym_nointerpolation] = ACTIONS(2445),
    [anon_sym_sample] = ACTIONS(2445),
    [anon_sym_linear] = ACTIONS(2445),
    [anon_sym_snorm] = ACTIONS(2445),
    [anon_sym_unorm] = ACTIONS(2445),
    [anon_sym_point] = ACTIONS(2445),
    [anon_sym_line] = ACTIONS(2445),
    [anon_sym_triangleadj] = ACTIONS(2445),
    [anon_sym_lineadj] = ACTIONS(2445),
    [anon_sym_triangle] = ACTIONS(2445),
    [anon_sym_cbuffer] = ACTIONS(2445),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(2244),
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_include_token1] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym___cdecl] = ACTIONS(2242),
    [anon_sym___clrcall] = ACTIONS(2242),
    [anon_sym___stdcall] = ACTIONS(2242),
    [anon_sym___fastcall] = ACTIONS(2242),
    [anon_sym___thiscall] = ACTIONS(2242),
    [anon_sym___vectorcall] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_goto] = ACTIONS(2242),
    [anon_sym___try] = ACTIONS(2242),
    [anon_sym___leave] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_compl] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2244),
    [anon_sym_sizeof] = ACTIONS(2242),
    [anon_sym___alignof__] = ACTIONS(2242),
    [anon_sym___alignof] = ACTIONS(2242),
    [anon_sym__alignof] = ACTIONS(2242),
    [anon_sym_alignof] = ACTIONS(2242),
    [anon_sym__Alignof] = ACTIONS(2242),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2242),
    [anon_sym_asm] = ACTIONS(2242),
    [anon_sym___asm__] = ACTIONS(2242),
    [anon_sym___asm] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2244),
    [anon_sym_L_SQUOTE] = ACTIONS(2244),
    [anon_sym_u_SQUOTE] = ACTIONS(2244),
    [anon_sym_U_SQUOTE] = ACTIONS(2244),
    [anon_sym_u8_SQUOTE] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_L_DQUOTE] = ACTIONS(2244),
    [anon_sym_u_DQUOTE] = ACTIONS(2244),
    [anon_sym_U_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2244),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [anon_sym_NULL] = ACTIONS(2242),
    [anon_sym_nullptr] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_export] = ACTIONS(2242),
    [anon_sym_module] = ACTIONS(2242),
    [anon_sym_import] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_concept] = ACTIONS(2242),
    [anon_sym_co_return] = ACTIONS(2242),
    [anon_sym_co_yield] = ACTIONS(2242),
    [anon_sym_R_DQUOTE] = ACTIONS(2244),
    [anon_sym_LR_DQUOTE] = ACTIONS(2244),
    [anon_sym_uR_DQUOTE] = ACTIONS(2244),
    [anon_sym_UR_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2244),
    [anon_sym_co_await] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [anon_sym_discard] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
    [anon_sym_cbuffer] = ACTIONS(2242),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(2360),
    [sym_identifier] = ACTIONS(2358),
    [aux_sym_preproc_include_token1] = ACTIONS(2358),
    [aux_sym_preproc_def_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2358),
    [sym_preproc_directive] = ACTIONS(2358),
    [anon_sym_LPAREN2] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_AMP_AMP] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym___extension__] = ACTIONS(2358),
    [anon_sym_typedef] = ACTIONS(2358),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_out] = ACTIONS(2358),
    [anon_sym_inout] = ACTIONS(2358),
    [anon_sym_virtual] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym___attribute__] = ACTIONS(2358),
    [anon_sym___attribute] = ACTIONS(2358),
    [anon_sym_using] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(2358),
    [anon_sym___based] = ACTIONS(2358),
    [anon_sym___cdecl] = ACTIONS(2358),
    [anon_sym___clrcall] = ACTIONS(2358),
    [anon_sym___stdcall] = ACTIONS(2358),
    [anon_sym___fastcall] = ACTIONS(2358),
    [anon_sym___thiscall] = ACTIONS(2358),
    [anon_sym___vectorcall] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_signed] = ACTIONS(2358),
    [anon_sym_unsigned] = ACTIONS(2358),
    [anon_sym_long] = ACTIONS(2358),
    [anon_sym_short] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_register] = ACTIONS(2358),
    [anon_sym_inline] = ACTIONS(2358),
    [anon_sym___inline] = ACTIONS(2358),
    [anon_sym___inline__] = ACTIONS(2358),
    [anon_sym___forceinline] = ACTIONS(2358),
    [anon_sym_thread_local] = ACTIONS(2358),
    [anon_sym___thread] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_constexpr] = ACTIONS(2358),
    [anon_sym_volatile] = ACTIONS(2358),
    [anon_sym_restrict] = ACTIONS(2358),
    [anon_sym___restrict__] = ACTIONS(2358),
    [anon_sym__Atomic] = ACTIONS(2358),
    [anon_sym__Noreturn] = ACTIONS(2358),
    [anon_sym_noreturn] = ACTIONS(2358),
    [anon_sym__Nonnull] = ACTIONS(2358),
    [anon_sym_mutable] = ACTIONS(2358),
    [anon_sym_constinit] = ACTIONS(2358),
    [anon_sym_consteval] = ACTIONS(2358),
    [anon_sym_alignas] = ACTIONS(2358),
    [anon_sym__Alignas] = ACTIONS(2358),
    [sym_primitive_type] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_goto] = ACTIONS(2358),
    [anon_sym___try] = ACTIONS(2358),
    [anon_sym___leave] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_compl] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2358),
    [anon_sym___alignof__] = ACTIONS(2358),
    [anon_sym___alignof] = ACTIONS(2358),
    [anon_sym__alignof] = ACTIONS(2358),
    [anon_sym_alignof] = ACTIONS(2358),
    [anon_sym__Alignof] = ACTIONS(2358),
    [anon_sym_offsetof] = ACTIONS(2358),
    [anon_sym__Generic] = ACTIONS(2358),
    [anon_sym_asm] = ACTIONS(2358),
    [anon_sym___asm__] = ACTIONS(2358),
    [anon_sym___asm] = ACTIONS(2358),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_L_SQUOTE] = ACTIONS(2360),
    [anon_sym_u_SQUOTE] = ACTIONS(2360),
    [anon_sym_U_SQUOTE] = ACTIONS(2360),
    [anon_sym_u8_SQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_L_DQUOTE] = ACTIONS(2360),
    [anon_sym_u_DQUOTE] = ACTIONS(2360),
    [anon_sym_U_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8_DQUOTE] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [anon_sym_NULL] = ACTIONS(2358),
    [anon_sym_nullptr] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2358),
    [anon_sym_decltype] = ACTIONS(2358),
    [anon_sym_explicit] = ACTIONS(2358),
    [anon_sym_typename] = ACTIONS(2358),
    [anon_sym_export] = ACTIONS(2358),
    [anon_sym_module] = ACTIONS(2358),
    [anon_sym_import] = ACTIONS(2358),
    [anon_sym_template] = ACTIONS(2358),
    [anon_sym_operator] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2358),
    [anon_sym_static_assert] = ACTIONS(2358),
    [anon_sym_concept] = ACTIONS(2358),
    [anon_sym_co_return] = ACTIONS(2358),
    [anon_sym_co_yield] = ACTIONS(2358),
    [anon_sym_R_DQUOTE] = ACTIONS(2360),
    [anon_sym_LR_DQUOTE] = ACTIONS(2360),
    [anon_sym_uR_DQUOTE] = ACTIONS(2360),
    [anon_sym_UR_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2360),
    [anon_sym_co_await] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_requires] = ACTIONS(2358),
    [sym_this] = ACTIONS(2358),
    [anon_sym_discard] = ACTIONS(2358),
    [anon_sym_precise] = ACTIONS(2358),
    [anon_sym_shared] = ACTIONS(2358),
    [anon_sym_groupshared] = ACTIONS(2358),
    [anon_sym_uniform] = ACTIONS(2358),
    [anon_sym_row_major] = ACTIONS(2358),
    [anon_sym_column_major] = ACTIONS(2358),
    [anon_sym_globallycoherent] = ACTIONS(2358),
    [anon_sym_centroid] = ACTIONS(2358),
    [anon_sym_noperspective] = ACTIONS(2358),
    [anon_sym_nointerpolation] = ACTIONS(2358),
    [anon_sym_sample] = ACTIONS(2358),
    [anon_sym_linear] = ACTIONS(2358),
    [anon_sym_snorm] = ACTIONS(2358),
    [anon_sym_unorm] = ACTIONS(2358),
    [anon_sym_point] = ACTIONS(2358),
    [anon_sym_line] = ACTIONS(2358),
    [anon_sym_triangleadj] = ACTIONS(2358),
    [anon_sym_lineadj] = ACTIONS(2358),
    [anon_sym_triangle] = ACTIONS(2358),
    [anon_sym_cbuffer] = ACTIONS(2358),
  },
  [298] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_include_token1] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token2] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [aux_sym_preproc_else_token1] = ACTIONS(2449),
    [aux_sym_preproc_elif_token1] = ACTIONS(2449),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym___cdecl] = ACTIONS(2449),
    [anon_sym___clrcall] = ACTIONS(2449),
    [anon_sym___stdcall] = ACTIONS(2449),
    [anon_sym___fastcall] = ACTIONS(2449),
    [anon_sym___thiscall] = ACTIONS(2449),
    [anon_sym___vectorcall] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_goto] = ACTIONS(2449),
    [anon_sym___try] = ACTIONS(2449),
    [anon_sym___leave] = ACTIONS(2449),
    [anon_sym_not] = ACTIONS(2449),
    [anon_sym_compl] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_sizeof] = ACTIONS(2449),
    [anon_sym___alignof__] = ACTIONS(2449),
    [anon_sym___alignof] = ACTIONS(2449),
    [anon_sym__alignof] = ACTIONS(2449),
    [anon_sym_alignof] = ACTIONS(2449),
    [anon_sym__Alignof] = ACTIONS(2449),
    [anon_sym_offsetof] = ACTIONS(2449),
    [anon_sym__Generic] = ACTIONS(2449),
    [anon_sym_asm] = ACTIONS(2449),
    [anon_sym___asm__] = ACTIONS(2449),
    [anon_sym___asm] = ACTIONS(2449),
    [sym_number_literal] = ACTIONS(2451),
    [anon_sym_L_SQUOTE] = ACTIONS(2451),
    [anon_sym_u_SQUOTE] = ACTIONS(2451),
    [anon_sym_U_SQUOTE] = ACTIONS(2451),
    [anon_sym_u8_SQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_L_DQUOTE] = ACTIONS(2451),
    [anon_sym_u_DQUOTE] = ACTIONS(2451),
    [anon_sym_U_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8_DQUOTE] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [anon_sym_NULL] = ACTIONS(2449),
    [anon_sym_nullptr] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_concept] = ACTIONS(2449),
    [anon_sym_co_return] = ACTIONS(2449),
    [anon_sym_co_yield] = ACTIONS(2449),
    [anon_sym_R_DQUOTE] = ACTIONS(2451),
    [anon_sym_LR_DQUOTE] = ACTIONS(2451),
    [anon_sym_uR_DQUOTE] = ACTIONS(2451),
    [anon_sym_UR_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2451),
    [anon_sym_co_await] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_requires] = ACTIONS(2449),
    [sym_this] = ACTIONS(2449),
    [anon_sym_discard] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
    [anon_sym_cbuffer] = ACTIONS(2449),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(2320),
    [sym_identifier] = ACTIONS(2318),
    [aux_sym_preproc_include_token1] = ACTIONS(2318),
    [aux_sym_preproc_def_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_LPAREN2] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_AMP_AMP] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym___extension__] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_in] = ACTIONS(2318),
    [anon_sym_out] = ACTIONS(2318),
    [anon_sym_inout] = ACTIONS(2318),
    [anon_sym_virtual] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym___attribute__] = ACTIONS(2318),
    [anon_sym___attribute] = ACTIONS(2318),
    [anon_sym_using] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2320),
    [anon_sym___declspec] = ACTIONS(2318),
    [anon_sym___based] = ACTIONS(2318),
    [anon_sym___cdecl] = ACTIONS(2318),
    [anon_sym___clrcall] = ACTIONS(2318),
    [anon_sym___stdcall] = ACTIONS(2318),
    [anon_sym___fastcall] = ACTIONS(2318),
    [anon_sym___thiscall] = ACTIONS(2318),
    [anon_sym___vectorcall] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_signed] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym___inline] = ACTIONS(2318),
    [anon_sym___inline__] = ACTIONS(2318),
    [anon_sym___forceinline] = ACTIONS(2318),
    [anon_sym_thread_local] = ACTIONS(2318),
    [anon_sym___thread] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_constexpr] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym___restrict__] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym__Noreturn] = ACTIONS(2318),
    [anon_sym_noreturn] = ACTIONS(2318),
    [anon_sym__Nonnull] = ACTIONS(2318),
    [anon_sym_mutable] = ACTIONS(2318),
    [anon_sym_constinit] = ACTIONS(2318),
    [anon_sym_consteval] = ACTIONS(2318),
    [anon_sym_alignas] = ACTIONS(2318),
    [anon_sym__Alignas] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_class] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym___try] = ACTIONS(2318),
    [anon_sym___leave] = ACTIONS(2318),
    [anon_sym_not] = ACTIONS(2318),
    [anon_sym_compl] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2318),
    [anon_sym___alignof__] = ACTIONS(2318),
    [anon_sym___alignof] = ACTIONS(2318),
    [anon_sym__alignof] = ACTIONS(2318),
    [anon_sym_alignof] = ACTIONS(2318),
    [anon_sym__Alignof] = ACTIONS(2318),
    [anon_sym_offsetof] = ACTIONS(2318),
    [anon_sym__Generic] = ACTIONS(2318),
    [anon_sym_asm] = ACTIONS(2318),
    [anon_sym___asm__] = ACTIONS(2318),
    [anon_sym___asm] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2320),
    [anon_sym_L_SQUOTE] = ACTIONS(2320),
    [anon_sym_u_SQUOTE] = ACTIONS(2320),
    [anon_sym_U_SQUOTE] = ACTIONS(2320),
    [anon_sym_u8_SQUOTE] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_L_DQUOTE] = ACTIONS(2320),
    [anon_sym_u_DQUOTE] = ACTIONS(2320),
    [anon_sym_U_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8_DQUOTE] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(2320),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [anon_sym_NULL] = ACTIONS(2318),
    [anon_sym_nullptr] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2318),
    [anon_sym_decltype] = ACTIONS(2318),
    [anon_sym_explicit] = ACTIONS(2318),
    [anon_sym_typename] = ACTIONS(2318),
    [anon_sym_export] = ACTIONS(2318),
    [anon_sym_module] = ACTIONS(2318),
    [anon_sym_import] = ACTIONS(2318),
    [anon_sym_template] = ACTIONS(2318),
    [anon_sym_operator] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [anon_sym_delete] = ACTIONS(2318),
    [anon_sym_throw] = ACTIONS(2318),
    [anon_sym_namespace] = ACTIONS(2318),
    [anon_sym_static_assert] = ACTIONS(2318),
    [anon_sym_concept] = ACTIONS(2318),
    [anon_sym_co_return] = ACTIONS(2318),
    [anon_sym_co_yield] = ACTIONS(2318),
    [anon_sym_R_DQUOTE] = ACTIONS(2320),
    [anon_sym_LR_DQUOTE] = ACTIONS(2320),
    [anon_sym_uR_DQUOTE] = ACTIONS(2320),
    [anon_sym_UR_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2320),
    [anon_sym_co_await] = ACTIONS(2318),
    [anon_sym_new] = ACTIONS(2318),
    [anon_sym_requires] = ACTIONS(2318),
    [sym_this] = ACTIONS(2318),
    [anon_sym_discard] = ACTIONS(2318),
    [anon_sym_precise] = ACTIONS(2318),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_groupshared] = ACTIONS(2318),
    [anon_sym_uniform] = ACTIONS(2318),
    [anon_sym_row_major] = ACTIONS(2318),
    [anon_sym_column_major] = ACTIONS(2318),
    [anon_sym_globallycoherent] = ACTIONS(2318),
    [anon_sym_centroid] = ACTIONS(2318),
    [anon_sym_noperspective] = ACTIONS(2318),
    [anon_sym_nointerpolation] = ACTIONS(2318),
    [anon_sym_sample] = ACTIONS(2318),
    [anon_sym_linear] = ACTIONS(2318),
    [anon_sym_snorm] = ACTIONS(2318),
    [anon_sym_unorm] = ACTIONS(2318),
    [anon_sym_point] = ACTIONS(2318),
    [anon_sym_line] = ACTIONS(2318),
    [anon_sym_triangleadj] = ACTIONS(2318),
    [anon_sym_lineadj] = ACTIONS(2318),
    [anon_sym_triangle] = ACTIONS(2318),
    [anon_sym_cbuffer] = ACTIONS(2318),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(2248),
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_include_token1] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym___cdecl] = ACTIONS(2246),
    [anon_sym___clrcall] = ACTIONS(2246),
    [anon_sym___stdcall] = ACTIONS(2246),
    [anon_sym___fastcall] = ACTIONS(2246),
    [anon_sym___thiscall] = ACTIONS(2246),
    [anon_sym___vectorcall] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2246),
    [anon_sym_switch] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_goto] = ACTIONS(2246),
    [anon_sym___try] = ACTIONS(2246),
    [anon_sym___leave] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_compl] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_sizeof] = ACTIONS(2246),
    [anon_sym___alignof__] = ACTIONS(2246),
    [anon_sym___alignof] = ACTIONS(2246),
    [anon_sym__alignof] = ACTIONS(2246),
    [anon_sym_alignof] = ACTIONS(2246),
    [anon_sym__Alignof] = ACTIONS(2246),
    [anon_sym_offsetof] = ACTIONS(2246),
    [anon_sym__Generic] = ACTIONS(2246),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym___asm] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2248),
    [anon_sym_L_SQUOTE] = ACTIONS(2248),
    [anon_sym_u_SQUOTE] = ACTIONS(2248),
    [anon_sym_U_SQUOTE] = ACTIONS(2248),
    [anon_sym_u8_SQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_L_DQUOTE] = ACTIONS(2248),
    [anon_sym_u_DQUOTE] = ACTIONS(2248),
    [anon_sym_U_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [anon_sym_NULL] = ACTIONS(2246),
    [anon_sym_nullptr] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_export] = ACTIONS(2246),
    [anon_sym_module] = ACTIONS(2246),
    [anon_sym_import] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_delete] = ACTIONS(2246),
    [anon_sym_throw] = ACTIONS(2246),
    [anon_sym_namespace] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_concept] = ACTIONS(2246),
    [anon_sym_co_return] = ACTIONS(2246),
    [anon_sym_co_yield] = ACTIONS(2246),
    [anon_sym_R_DQUOTE] = ACTIONS(2248),
    [anon_sym_LR_DQUOTE] = ACTIONS(2248),
    [anon_sym_uR_DQUOTE] = ACTIONS(2248),
    [anon_sym_UR_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2248),
    [anon_sym_co_await] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2246),
    [sym_this] = ACTIONS(2246),
    [anon_sym_discard] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
    [anon_sym_cbuffer] = ACTIONS(2246),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(2268),
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_include_token1] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym___cdecl] = ACTIONS(2266),
    [anon_sym___clrcall] = ACTIONS(2266),
    [anon_sym___stdcall] = ACTIONS(2266),
    [anon_sym___fastcall] = ACTIONS(2266),
    [anon_sym___thiscall] = ACTIONS(2266),
    [anon_sym___vectorcall] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [anon_sym_switch] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_do] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_goto] = ACTIONS(2266),
    [anon_sym___try] = ACTIONS(2266),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2266),
    [anon_sym_compl] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2266),
    [anon_sym___alignof__] = ACTIONS(2266),
    [anon_sym___alignof] = ACTIONS(2266),
    [anon_sym__alignof] = ACTIONS(2266),
    [anon_sym_alignof] = ACTIONS(2266),
    [anon_sym__Alignof] = ACTIONS(2266),
    [anon_sym_offsetof] = ACTIONS(2266),
    [anon_sym__Generic] = ACTIONS(2266),
    [anon_sym_asm] = ACTIONS(2266),
    [anon_sym___asm__] = ACTIONS(2266),
    [anon_sym___asm] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2268),
    [anon_sym_L_SQUOTE] = ACTIONS(2268),
    [anon_sym_u_SQUOTE] = ACTIONS(2268),
    [anon_sym_U_SQUOTE] = ACTIONS(2268),
    [anon_sym_u8_SQUOTE] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_L_DQUOTE] = ACTIONS(2268),
    [anon_sym_u_DQUOTE] = ACTIONS(2268),
    [anon_sym_U_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8_DQUOTE] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [anon_sym_NULL] = ACTIONS(2266),
    [anon_sym_nullptr] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_export] = ACTIONS(2266),
    [anon_sym_module] = ACTIONS(2266),
    [anon_sym_import] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [anon_sym_delete] = ACTIONS(2266),
    [anon_sym_throw] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_concept] = ACTIONS(2266),
    [anon_sym_co_return] = ACTIONS(2266),
    [anon_sym_co_yield] = ACTIONS(2266),
    [anon_sym_R_DQUOTE] = ACTIONS(2268),
    [anon_sym_LR_DQUOTE] = ACTIONS(2268),
    [anon_sym_uR_DQUOTE] = ACTIONS(2268),
    [anon_sym_UR_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2268),
    [anon_sym_co_await] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2266),
    [sym_this] = ACTIONS(2266),
    [anon_sym_discard] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
    [anon_sym_cbuffer] = ACTIONS(2266),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(2272),
    [sym_identifier] = ACTIONS(2270),
    [aux_sym_preproc_include_token1] = ACTIONS(2270),
    [aux_sym_preproc_def_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2270),
    [sym_preproc_directive] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_typedef] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_virtual] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2270),
    [anon_sym_using] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym___based] = ACTIONS(2270),
    [anon_sym___cdecl] = ACTIONS(2270),
    [anon_sym___clrcall] = ACTIONS(2270),
    [anon_sym___stdcall] = ACTIONS(2270),
    [anon_sym___fastcall] = ACTIONS(2270),
    [anon_sym___thiscall] = ACTIONS(2270),
    [anon_sym___vectorcall] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_class] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_switch] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2270),
    [anon_sym_default] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_do] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_goto] = ACTIONS(2270),
    [anon_sym___try] = ACTIONS(2270),
    [anon_sym___leave] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_compl] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2270),
    [anon_sym___alignof__] = ACTIONS(2270),
    [anon_sym___alignof] = ACTIONS(2270),
    [anon_sym__alignof] = ACTIONS(2270),
    [anon_sym_alignof] = ACTIONS(2270),
    [anon_sym__Alignof] = ACTIONS(2270),
    [anon_sym_offsetof] = ACTIONS(2270),
    [anon_sym__Generic] = ACTIONS(2270),
    [anon_sym_asm] = ACTIONS(2270),
    [anon_sym___asm__] = ACTIONS(2270),
    [anon_sym___asm] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2272),
    [anon_sym_L_SQUOTE] = ACTIONS(2272),
    [anon_sym_u_SQUOTE] = ACTIONS(2272),
    [anon_sym_U_SQUOTE] = ACTIONS(2272),
    [anon_sym_u8_SQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_L_DQUOTE] = ACTIONS(2272),
    [anon_sym_u_DQUOTE] = ACTIONS(2272),
    [anon_sym_U_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8_DQUOTE] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [anon_sym_NULL] = ACTIONS(2270),
    [anon_sym_nullptr] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2270),
    [anon_sym_decltype] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_typename] = ACTIONS(2270),
    [anon_sym_export] = ACTIONS(2270),
    [anon_sym_module] = ACTIONS(2270),
    [anon_sym_import] = ACTIONS(2270),
    [anon_sym_template] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [anon_sym_delete] = ACTIONS(2270),
    [anon_sym_throw] = ACTIONS(2270),
    [anon_sym_namespace] = ACTIONS(2270),
    [anon_sym_static_assert] = ACTIONS(2270),
    [anon_sym_concept] = ACTIONS(2270),
    [anon_sym_co_return] = ACTIONS(2270),
    [anon_sym_co_yield] = ACTIONS(2270),
    [anon_sym_R_DQUOTE] = ACTIONS(2272),
    [anon_sym_LR_DQUOTE] = ACTIONS(2272),
    [anon_sym_uR_DQUOTE] = ACTIONS(2272),
    [anon_sym_UR_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2272),
    [anon_sym_co_await] = ACTIONS(2270),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2270),
    [sym_this] = ACTIONS(2270),
    [anon_sym_discard] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_groupshared] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_row_major] = ACTIONS(2270),
    [anon_sym_column_major] = ACTIONS(2270),
    [anon_sym_globallycoherent] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym_nointerpolation] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_linear] = ACTIONS(2270),
    [anon_sym_snorm] = ACTIONS(2270),
    [anon_sym_unorm] = ACTIONS(2270),
    [anon_sym_point] = ACTIONS(2270),
    [anon_sym_line] = ACTIONS(2270),
    [anon_sym_triangleadj] = ACTIONS(2270),
    [anon_sym_lineadj] = ACTIONS(2270),
    [anon_sym_triangle] = ACTIONS(2270),
    [anon_sym_cbuffer] = ACTIONS(2270),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(2276),
    [sym_identifier] = ACTIONS(2274),
    [aux_sym_preproc_include_token1] = ACTIONS(2274),
    [aux_sym_preproc_def_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2274),
    [sym_preproc_directive] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_AMP_AMP] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_typedef] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_virtual] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2274),
    [anon_sym_using] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym___based] = ACTIONS(2274),
    [anon_sym___cdecl] = ACTIONS(2274),
    [anon_sym___clrcall] = ACTIONS(2274),
    [anon_sym___stdcall] = ACTIONS(2274),
    [anon_sym___fastcall] = ACTIONS(2274),
    [anon_sym___thiscall] = ACTIONS(2274),
    [anon_sym___vectorcall] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_class] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2274),
    [anon_sym_switch] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_do] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_goto] = ACTIONS(2274),
    [anon_sym___try] = ACTIONS(2274),
    [anon_sym___leave] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2274),
    [anon_sym_compl] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2274),
    [anon_sym___alignof__] = ACTIONS(2274),
    [anon_sym___alignof] = ACTIONS(2274),
    [anon_sym__alignof] = ACTIONS(2274),
    [anon_sym_alignof] = ACTIONS(2274),
    [anon_sym__Alignof] = ACTIONS(2274),
    [anon_sym_offsetof] = ACTIONS(2274),
    [anon_sym__Generic] = ACTIONS(2274),
    [anon_sym_asm] = ACTIONS(2274),
    [anon_sym___asm__] = ACTIONS(2274),
    [anon_sym___asm] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_L_SQUOTE] = ACTIONS(2276),
    [anon_sym_u_SQUOTE] = ACTIONS(2276),
    [anon_sym_U_SQUOTE] = ACTIONS(2276),
    [anon_sym_u8_SQUOTE] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_L_DQUOTE] = ACTIONS(2276),
    [anon_sym_u_DQUOTE] = ACTIONS(2276),
    [anon_sym_U_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8_DQUOTE] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(2276),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [anon_sym_NULL] = ACTIONS(2274),
    [anon_sym_nullptr] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2274),
    [anon_sym_decltype] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_typename] = ACTIONS(2274),
    [anon_sym_export] = ACTIONS(2274),
    [anon_sym_module] = ACTIONS(2274),
    [anon_sym_import] = ACTIONS(2274),
    [anon_sym_template] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [anon_sym_delete] = ACTIONS(2274),
    [anon_sym_throw] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2274),
    [anon_sym_static_assert] = ACTIONS(2274),
    [anon_sym_concept] = ACTIONS(2274),
    [anon_sym_co_return] = ACTIONS(2274),
    [anon_sym_co_yield] = ACTIONS(2274),
    [anon_sym_R_DQUOTE] = ACTIONS(2276),
    [anon_sym_LR_DQUOTE] = ACTIONS(2276),
    [anon_sym_uR_DQUOTE] = ACTIONS(2276),
    [anon_sym_UR_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2276),
    [anon_sym_co_await] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2274),
    [sym_this] = ACTIONS(2274),
    [anon_sym_discard] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_groupshared] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_row_major] = ACTIONS(2274),
    [anon_sym_column_major] = ACTIONS(2274),
    [anon_sym_globallycoherent] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym_nointerpolation] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_linear] = ACTIONS(2274),
    [anon_sym_snorm] = ACTIONS(2274),
    [anon_sym_unorm] = ACTIONS(2274),
    [anon_sym_point] = ACTIONS(2274),
    [anon_sym_line] = ACTIONS(2274),
    [anon_sym_triangleadj] = ACTIONS(2274),
    [anon_sym_lineadj] = ACTIONS(2274),
    [anon_sym_triangle] = ACTIONS(2274),
    [anon_sym_cbuffer] = ACTIONS(2274),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(2300),
    [sym_identifier] = ACTIONS(2298),
    [aux_sym_preproc_include_token1] = ACTIONS(2298),
    [aux_sym_preproc_def_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_using] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym___based] = ACTIONS(2298),
    [anon_sym___cdecl] = ACTIONS(2298),
    [anon_sym___clrcall] = ACTIONS(2298),
    [anon_sym___stdcall] = ACTIONS(2298),
    [anon_sym___fastcall] = ACTIONS(2298),
    [anon_sym___thiscall] = ACTIONS(2298),
    [anon_sym___vectorcall] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym___try] = ACTIONS(2298),
    [anon_sym___leave] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2298),
    [anon_sym_compl] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2298),
    [anon_sym___alignof__] = ACTIONS(2298),
    [anon_sym___alignof] = ACTIONS(2298),
    [anon_sym__alignof] = ACTIONS(2298),
    [anon_sym_alignof] = ACTIONS(2298),
    [anon_sym__Alignof] = ACTIONS(2298),
    [anon_sym_offsetof] = ACTIONS(2298),
    [anon_sym__Generic] = ACTIONS(2298),
    [anon_sym_asm] = ACTIONS(2298),
    [anon_sym___asm__] = ACTIONS(2298),
    [anon_sym___asm] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2300),
    [anon_sym_L_SQUOTE] = ACTIONS(2300),
    [anon_sym_u_SQUOTE] = ACTIONS(2300),
    [anon_sym_U_SQUOTE] = ACTIONS(2300),
    [anon_sym_u8_SQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_L_DQUOTE] = ACTIONS(2300),
    [anon_sym_u_DQUOTE] = ACTIONS(2300),
    [anon_sym_U_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8_DQUOTE] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [anon_sym_NULL] = ACTIONS(2298),
    [anon_sym_nullptr] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2298),
    [anon_sym_explicit] = ACTIONS(2298),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_export] = ACTIONS(2298),
    [anon_sym_module] = ACTIONS(2298),
    [anon_sym_import] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_namespace] = ACTIONS(2298),
    [anon_sym_static_assert] = ACTIONS(2298),
    [anon_sym_concept] = ACTIONS(2298),
    [anon_sym_co_return] = ACTIONS(2298),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2300),
    [anon_sym_LR_DQUOTE] = ACTIONS(2300),
    [anon_sym_uR_DQUOTE] = ACTIONS(2300),
    [anon_sym_UR_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2300),
    [anon_sym_co_await] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_discard] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
    [anon_sym_cbuffer] = ACTIONS(2298),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(2304),
    [sym_identifier] = ACTIONS(2302),
    [aux_sym_preproc_include_token1] = ACTIONS(2302),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2302),
    [sym_preproc_directive] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_PLUS] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym_typedef] = ACTIONS(2302),
    [anon_sym_in] = ACTIONS(2302),
    [anon_sym_out] = ACTIONS(2302),
    [anon_sym_inout] = ACTIONS(2302),
    [anon_sym_virtual] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2302),
    [anon_sym_using] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2304),
    [anon_sym___declspec] = ACTIONS(2302),
    [anon_sym___based] = ACTIONS(2302),
    [anon_sym___cdecl] = ACTIONS(2302),
    [anon_sym___clrcall] = ACTIONS(2302),
    [anon_sym___stdcall] = ACTIONS(2302),
    [anon_sym___fastcall] = ACTIONS(2302),
    [anon_sym___thiscall] = ACTIONS(2302),
    [anon_sym___vectorcall] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2302),
    [anon_sym_unsigned] = ACTIONS(2302),
    [anon_sym_long] = ACTIONS(2302),
    [anon_sym_short] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2302),
    [anon_sym_inline] = ACTIONS(2302),
    [anon_sym___inline] = ACTIONS(2302),
    [anon_sym___inline__] = ACTIONS(2302),
    [anon_sym___forceinline] = ACTIONS(2302),
    [anon_sym_thread_local] = ACTIONS(2302),
    [anon_sym___thread] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [sym_primitive_type] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_class] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2302),
    [anon_sym_default] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_goto] = ACTIONS(2302),
    [anon_sym___try] = ACTIONS(2302),
    [anon_sym___leave] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2302),
    [anon_sym_compl] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2302),
    [anon_sym___alignof__] = ACTIONS(2302),
    [anon_sym___alignof] = ACTIONS(2302),
    [anon_sym__alignof] = ACTIONS(2302),
    [anon_sym_alignof] = ACTIONS(2302),
    [anon_sym__Alignof] = ACTIONS(2302),
    [anon_sym_offsetof] = ACTIONS(2302),
    [anon_sym__Generic] = ACTIONS(2302),
    [anon_sym_asm] = ACTIONS(2302),
    [anon_sym___asm__] = ACTIONS(2302),
    [anon_sym___asm] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2304),
    [anon_sym_L_SQUOTE] = ACTIONS(2304),
    [anon_sym_u_SQUOTE] = ACTIONS(2304),
    [anon_sym_U_SQUOTE] = ACTIONS(2304),
    [anon_sym_u8_SQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_L_DQUOTE] = ACTIONS(2304),
    [anon_sym_u_DQUOTE] = ACTIONS(2304),
    [anon_sym_U_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8_DQUOTE] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [anon_sym_NULL] = ACTIONS(2302),
    [anon_sym_nullptr] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2302),
    [anon_sym_decltype] = ACTIONS(2302),
    [anon_sym_explicit] = ACTIONS(2302),
    [anon_sym_typename] = ACTIONS(2302),
    [anon_sym_export] = ACTIONS(2302),
    [anon_sym_module] = ACTIONS(2302),
    [anon_sym_import] = ACTIONS(2302),
    [anon_sym_template] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [anon_sym_delete] = ACTIONS(2302),
    [anon_sym_throw] = ACTIONS(2302),
    [anon_sym_namespace] = ACTIONS(2302),
    [anon_sym_static_assert] = ACTIONS(2302),
    [anon_sym_concept] = ACTIONS(2302),
    [anon_sym_co_return] = ACTIONS(2302),
    [anon_sym_co_yield] = ACTIONS(2302),
    [anon_sym_R_DQUOTE] = ACTIONS(2304),
    [anon_sym_LR_DQUOTE] = ACTIONS(2304),
    [anon_sym_uR_DQUOTE] = ACTIONS(2304),
    [anon_sym_UR_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2304),
    [anon_sym_co_await] = ACTIONS(2302),
    [anon_sym_new] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2302),
    [sym_this] = ACTIONS(2302),
    [anon_sym_discard] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2302),
    [anon_sym_shared] = ACTIONS(2302),
    [anon_sym_groupshared] = ACTIONS(2302),
    [anon_sym_uniform] = ACTIONS(2302),
    [anon_sym_row_major] = ACTIONS(2302),
    [anon_sym_column_major] = ACTIONS(2302),
    [anon_sym_globallycoherent] = ACTIONS(2302),
    [anon_sym_centroid] = ACTIONS(2302),
    [anon_sym_noperspective] = ACTIONS(2302),
    [anon_sym_nointerpolation] = ACTIONS(2302),
    [anon_sym_sample] = ACTIONS(2302),
    [anon_sym_linear] = ACTIONS(2302),
    [anon_sym_snorm] = ACTIONS(2302),
    [anon_sym_unorm] = ACTIONS(2302),
    [anon_sym_point] = ACTIONS(2302),
    [anon_sym_line] = ACTIONS(2302),
    [anon_sym_triangleadj] = ACTIONS(2302),
    [anon_sym_lineadj] = ACTIONS(2302),
    [anon_sym_triangle] = ACTIONS(2302),
    [anon_sym_cbuffer] = ACTIONS(2302),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(2368),
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym_in] = ACTIONS(2366),
    [anon_sym_out] = ACTIONS(2366),
    [anon_sym_inout] = ACTIONS(2366),
    [anon_sym_virtual] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym___attribute] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym__Nonnull] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [anon_sym___asm] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_export] = ACTIONS(2366),
    [anon_sym_module] = ACTIONS(2366),
    [anon_sym_import] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_discard] = ACTIONS(2366),
    [anon_sym_precise] = ACTIONS(2366),
    [anon_sym_shared] = ACTIONS(2366),
    [anon_sym_groupshared] = ACTIONS(2366),
    [anon_sym_uniform] = ACTIONS(2366),
    [anon_sym_row_major] = ACTIONS(2366),
    [anon_sym_column_major] = ACTIONS(2366),
    [anon_sym_globallycoherent] = ACTIONS(2366),
    [anon_sym_centroid] = ACTIONS(2366),
    [anon_sym_noperspective] = ACTIONS(2366),
    [anon_sym_nointerpolation] = ACTIONS(2366),
    [anon_sym_sample] = ACTIONS(2366),
    [anon_sym_linear] = ACTIONS(2366),
    [anon_sym_snorm] = ACTIONS(2366),
    [anon_sym_unorm] = ACTIONS(2366),
    [anon_sym_point] = ACTIONS(2366),
    [anon_sym_line] = ACTIONS(2366),
    [anon_sym_triangleadj] = ACTIONS(2366),
    [anon_sym_lineadj] = ACTIONS(2366),
    [anon_sym_triangle] = ACTIONS(2366),
    [anon_sym_cbuffer] = ACTIONS(2366),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(2316),
    [sym_identifier] = ACTIONS(2314),
    [aux_sym_preproc_include_token1] = ACTIONS(2314),
    [aux_sym_preproc_def_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2314),
    [sym_preproc_directive] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP_AMP] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym_typedef] = ACTIONS(2314),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_out] = ACTIONS(2314),
    [anon_sym_inout] = ACTIONS(2314),
    [anon_sym_virtual] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2316),
    [anon_sym___declspec] = ACTIONS(2314),
    [anon_sym___based] = ACTIONS(2314),
    [anon_sym___cdecl] = ACTIONS(2314),
    [anon_sym___clrcall] = ACTIONS(2314),
    [anon_sym___stdcall] = ACTIONS(2314),
    [anon_sym___fastcall] = ACTIONS(2314),
    [anon_sym___thiscall] = ACTIONS(2314),
    [anon_sym___vectorcall] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_signed] = ACTIONS(2314),
    [anon_sym_unsigned] = ACTIONS(2314),
    [anon_sym_long] = ACTIONS(2314),
    [anon_sym_short] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym___inline] = ACTIONS(2314),
    [anon_sym___inline__] = ACTIONS(2314),
    [anon_sym___forceinline] = ACTIONS(2314),
    [anon_sym_thread_local] = ACTIONS(2314),
    [anon_sym___thread] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [sym_primitive_type] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_goto] = ACTIONS(2314),
    [anon_sym___try] = ACTIONS(2314),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_compl] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2314),
    [anon_sym___alignof__] = ACTIONS(2314),
    [anon_sym___alignof] = ACTIONS(2314),
    [anon_sym__alignof] = ACTIONS(2314),
    [anon_sym_alignof] = ACTIONS(2314),
    [anon_sym__Alignof] = ACTIONS(2314),
    [anon_sym_offsetof] = ACTIONS(2314),
    [anon_sym__Generic] = ACTIONS(2314),
    [anon_sym_asm] = ACTIONS(2314),
    [anon_sym___asm__] = ACTIONS(2314),
    [anon_sym___asm] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_L_SQUOTE] = ACTIONS(2316),
    [anon_sym_u_SQUOTE] = ACTIONS(2316),
    [anon_sym_U_SQUOTE] = ACTIONS(2316),
    [anon_sym_u8_SQUOTE] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_L_DQUOTE] = ACTIONS(2316),
    [anon_sym_u_DQUOTE] = ACTIONS(2316),
    [anon_sym_U_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8_DQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [anon_sym_NULL] = ACTIONS(2314),
    [anon_sym_nullptr] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2314),
    [anon_sym_decltype] = ACTIONS(2314),
    [anon_sym_explicit] = ACTIONS(2314),
    [anon_sym_typename] = ACTIONS(2314),
    [anon_sym_export] = ACTIONS(2314),
    [anon_sym_module] = ACTIONS(2314),
    [anon_sym_import] = ACTIONS(2314),
    [anon_sym_template] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_namespace] = ACTIONS(2314),
    [anon_sym_static_assert] = ACTIONS(2314),
    [anon_sym_concept] = ACTIONS(2314),
    [anon_sym_co_return] = ACTIONS(2314),
    [anon_sym_co_yield] = ACTIONS(2314),
    [anon_sym_R_DQUOTE] = ACTIONS(2316),
    [anon_sym_LR_DQUOTE] = ACTIONS(2316),
    [anon_sym_uR_DQUOTE] = ACTIONS(2316),
    [anon_sym_UR_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2316),
    [anon_sym_co_await] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_discard] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2314),
    [anon_sym_shared] = ACTIONS(2314),
    [anon_sym_groupshared] = ACTIONS(2314),
    [anon_sym_uniform] = ACTIONS(2314),
    [anon_sym_row_major] = ACTIONS(2314),
    [anon_sym_column_major] = ACTIONS(2314),
    [anon_sym_globallycoherent] = ACTIONS(2314),
    [anon_sym_centroid] = ACTIONS(2314),
    [anon_sym_noperspective] = ACTIONS(2314),
    [anon_sym_nointerpolation] = ACTIONS(2314),
    [anon_sym_sample] = ACTIONS(2314),
    [anon_sym_linear] = ACTIONS(2314),
    [anon_sym_snorm] = ACTIONS(2314),
    [anon_sym_unorm] = ACTIONS(2314),
    [anon_sym_point] = ACTIONS(2314),
    [anon_sym_line] = ACTIONS(2314),
    [anon_sym_triangleadj] = ACTIONS(2314),
    [anon_sym_lineadj] = ACTIONS(2314),
    [anon_sym_triangle] = ACTIONS(2314),
    [anon_sym_cbuffer] = ACTIONS(2314),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(2332),
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_out] = ACTIONS(2330),
    [anon_sym_inout] = ACTIONS(2330),
    [anon_sym_virtual] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym___attribute] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym__Nonnull] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [anon_sym___asm] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_export] = ACTIONS(2330),
    [anon_sym_module] = ACTIONS(2330),
    [anon_sym_import] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym_discard] = ACTIONS(2330),
    [anon_sym_precise] = ACTIONS(2330),
    [anon_sym_shared] = ACTIONS(2330),
    [anon_sym_groupshared] = ACTIONS(2330),
    [anon_sym_uniform] = ACTIONS(2330),
    [anon_sym_row_major] = ACTIONS(2330),
    [anon_sym_column_major] = ACTIONS(2330),
    [anon_sym_globallycoherent] = ACTIONS(2330),
    [anon_sym_centroid] = ACTIONS(2330),
    [anon_sym_noperspective] = ACTIONS(2330),
    [anon_sym_nointerpolation] = ACTIONS(2330),
    [anon_sym_sample] = ACTIONS(2330),
    [anon_sym_linear] = ACTIONS(2330),
    [anon_sym_snorm] = ACTIONS(2330),
    [anon_sym_unorm] = ACTIONS(2330),
    [anon_sym_point] = ACTIONS(2330),
    [anon_sym_line] = ACTIONS(2330),
    [anon_sym_triangleadj] = ACTIONS(2330),
    [anon_sym_lineadj] = ACTIONS(2330),
    [anon_sym_triangle] = ACTIONS(2330),
    [anon_sym_cbuffer] = ACTIONS(2330),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(2336),
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym_in] = ACTIONS(2334),
    [anon_sym_out] = ACTIONS(2334),
    [anon_sym_inout] = ACTIONS(2334),
    [anon_sym_virtual] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym___attribute] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym__Nonnull] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [anon_sym___asm] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_export] = ACTIONS(2334),
    [anon_sym_module] = ACTIONS(2334),
    [anon_sym_import] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym_discard] = ACTIONS(2334),
    [anon_sym_precise] = ACTIONS(2334),
    [anon_sym_shared] = ACTIONS(2334),
    [anon_sym_groupshared] = ACTIONS(2334),
    [anon_sym_uniform] = ACTIONS(2334),
    [anon_sym_row_major] = ACTIONS(2334),
    [anon_sym_column_major] = ACTIONS(2334),
    [anon_sym_globallycoherent] = ACTIONS(2334),
    [anon_sym_centroid] = ACTIONS(2334),
    [anon_sym_noperspective] = ACTIONS(2334),
    [anon_sym_nointerpolation] = ACTIONS(2334),
    [anon_sym_sample] = ACTIONS(2334),
    [anon_sym_linear] = ACTIONS(2334),
    [anon_sym_snorm] = ACTIONS(2334),
    [anon_sym_unorm] = ACTIONS(2334),
    [anon_sym_point] = ACTIONS(2334),
    [anon_sym_line] = ACTIONS(2334),
    [anon_sym_triangleadj] = ACTIONS(2334),
    [anon_sym_lineadj] = ACTIONS(2334),
    [anon_sym_triangle] = ACTIONS(2334),
    [anon_sym_cbuffer] = ACTIONS(2334),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2338),
    [anon_sym_out] = ACTIONS(2338),
    [anon_sym_inout] = ACTIONS(2338),
    [anon_sym_virtual] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym___attribute] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym__Nonnull] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [anon_sym___asm] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_export] = ACTIONS(2338),
    [anon_sym_module] = ACTIONS(2338),
    [anon_sym_import] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym_discard] = ACTIONS(2338),
    [anon_sym_precise] = ACTIONS(2338),
    [anon_sym_shared] = ACTIONS(2338),
    [anon_sym_groupshared] = ACTIONS(2338),
    [anon_sym_uniform] = ACTIONS(2338),
    [anon_sym_row_major] = ACTIONS(2338),
    [anon_sym_column_major] = ACTIONS(2338),
    [anon_sym_globallycoherent] = ACTIONS(2338),
    [anon_sym_centroid] = ACTIONS(2338),
    [anon_sym_noperspective] = ACTIONS(2338),
    [anon_sym_nointerpolation] = ACTIONS(2338),
    [anon_sym_sample] = ACTIONS(2338),
    [anon_sym_linear] = ACTIONS(2338),
    [anon_sym_snorm] = ACTIONS(2338),
    [anon_sym_unorm] = ACTIONS(2338),
    [anon_sym_point] = ACTIONS(2338),
    [anon_sym_line] = ACTIONS(2338),
    [anon_sym_triangleadj] = ACTIONS(2338),
    [anon_sym_lineadj] = ACTIONS(2338),
    [anon_sym_triangle] = ACTIONS(2338),
    [anon_sym_cbuffer] = ACTIONS(2338),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(2344),
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [anon_sym___asm] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_export] = ACTIONS(2342),
    [anon_sym_module] = ACTIONS(2342),
    [anon_sym_import] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_discard] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
    [anon_sym_cbuffer] = ACTIONS(2342),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(2372),
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym_in] = ACTIONS(2370),
    [anon_sym_out] = ACTIONS(2370),
    [anon_sym_inout] = ACTIONS(2370),
    [anon_sym_virtual] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym___attribute] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym__Nonnull] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [anon_sym___asm] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_export] = ACTIONS(2370),
    [anon_sym_module] = ACTIONS(2370),
    [anon_sym_import] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym_discard] = ACTIONS(2370),
    [anon_sym_precise] = ACTIONS(2370),
    [anon_sym_shared] = ACTIONS(2370),
    [anon_sym_groupshared] = ACTIONS(2370),
    [anon_sym_uniform] = ACTIONS(2370),
    [anon_sym_row_major] = ACTIONS(2370),
    [anon_sym_column_major] = ACTIONS(2370),
    [anon_sym_globallycoherent] = ACTIONS(2370),
    [anon_sym_centroid] = ACTIONS(2370),
    [anon_sym_noperspective] = ACTIONS(2370),
    [anon_sym_nointerpolation] = ACTIONS(2370),
    [anon_sym_sample] = ACTIONS(2370),
    [anon_sym_linear] = ACTIONS(2370),
    [anon_sym_snorm] = ACTIONS(2370),
    [anon_sym_unorm] = ACTIONS(2370),
    [anon_sym_point] = ACTIONS(2370),
    [anon_sym_line] = ACTIONS(2370),
    [anon_sym_triangleadj] = ACTIONS(2370),
    [anon_sym_lineadj] = ACTIONS(2370),
    [anon_sym_triangle] = ACTIONS(2370),
    [anon_sym_cbuffer] = ACTIONS(2370),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(2376),
    [sym_identifier] = ACTIONS(2374),
    [aux_sym_preproc_include_token1] = ACTIONS(2374),
    [aux_sym_preproc_def_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_LPAREN2] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_out] = ACTIONS(2374),
    [anon_sym_inout] = ACTIONS(2374),
    [anon_sym_virtual] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym___attribute__] = ACTIONS(2374),
    [anon_sym___attribute] = ACTIONS(2374),
    [anon_sym_using] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2376),
    [anon_sym___declspec] = ACTIONS(2374),
    [anon_sym___based] = ACTIONS(2374),
    [anon_sym___cdecl] = ACTIONS(2374),
    [anon_sym___clrcall] = ACTIONS(2374),
    [anon_sym___stdcall] = ACTIONS(2374),
    [anon_sym___fastcall] = ACTIONS(2374),
    [anon_sym___thiscall] = ACTIONS(2374),
    [anon_sym___vectorcall] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_signed] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym___inline] = ACTIONS(2374),
    [anon_sym___inline__] = ACTIONS(2374),
    [anon_sym___forceinline] = ACTIONS(2374),
    [anon_sym_thread_local] = ACTIONS(2374),
    [anon_sym___thread] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_constexpr] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym___restrict__] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym__Noreturn] = ACTIONS(2374),
    [anon_sym_noreturn] = ACTIONS(2374),
    [anon_sym__Nonnull] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2374),
    [anon_sym_constinit] = ACTIONS(2374),
    [anon_sym_consteval] = ACTIONS(2374),
    [anon_sym_alignas] = ACTIONS(2374),
    [anon_sym__Alignas] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym___try] = ACTIONS(2374),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2374),
    [anon_sym_compl] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2374),
    [anon_sym___alignof__] = ACTIONS(2374),
    [anon_sym___alignof] = ACTIONS(2374),
    [anon_sym__alignof] = ACTIONS(2374),
    [anon_sym_alignof] = ACTIONS(2374),
    [anon_sym__Alignof] = ACTIONS(2374),
    [anon_sym_offsetof] = ACTIONS(2374),
    [anon_sym__Generic] = ACTIONS(2374),
    [anon_sym_asm] = ACTIONS(2374),
    [anon_sym___asm__] = ACTIONS(2374),
    [anon_sym___asm] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2376),
    [anon_sym_u_DQUOTE] = ACTIONS(2376),
    [anon_sym_U_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8_DQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [anon_sym_NULL] = ACTIONS(2374),
    [anon_sym_nullptr] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2374),
    [anon_sym_decltype] = ACTIONS(2374),
    [anon_sym_explicit] = ACTIONS(2374),
    [anon_sym_typename] = ACTIONS(2374),
    [anon_sym_export] = ACTIONS(2374),
    [anon_sym_module] = ACTIONS(2374),
    [anon_sym_import] = ACTIONS(2374),
    [anon_sym_template] = ACTIONS(2374),
    [anon_sym_operator] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_namespace] = ACTIONS(2374),
    [anon_sym_static_assert] = ACTIONS(2374),
    [anon_sym_concept] = ACTIONS(2374),
    [anon_sym_co_return] = ACTIONS(2374),
    [anon_sym_co_yield] = ACTIONS(2374),
    [anon_sym_R_DQUOTE] = ACTIONS(2376),
    [anon_sym_LR_DQUOTE] = ACTIONS(2376),
    [anon_sym_uR_DQUOTE] = ACTIONS(2376),
    [anon_sym_UR_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2376),
    [anon_sym_co_await] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_requires] = ACTIONS(2374),
    [sym_this] = ACTIONS(2374),
    [anon_sym_discard] = ACTIONS(2374),
    [anon_sym_precise] = ACTIONS(2374),
    [anon_sym_shared] = ACTIONS(2374),
    [anon_sym_groupshared] = ACTIONS(2374),
    [anon_sym_uniform] = ACTIONS(2374),
    [anon_sym_row_major] = ACTIONS(2374),
    [anon_sym_column_major] = ACTIONS(2374),
    [anon_sym_globallycoherent] = ACTIONS(2374),
    [anon_sym_centroid] = ACTIONS(2374),
    [anon_sym_noperspective] = ACTIONS(2374),
    [anon_sym_nointerpolation] = ACTIONS(2374),
    [anon_sym_sample] = ACTIONS(2374),
    [anon_sym_linear] = ACTIONS(2374),
    [anon_sym_snorm] = ACTIONS(2374),
    [anon_sym_unorm] = ACTIONS(2374),
    [anon_sym_point] = ACTIONS(2374),
    [anon_sym_line] = ACTIONS(2374),
    [anon_sym_triangleadj] = ACTIONS(2374),
    [anon_sym_lineadj] = ACTIONS(2374),
    [anon_sym_triangle] = ACTIONS(2374),
    [anon_sym_cbuffer] = ACTIONS(2374),
  },
  [314] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [315] = {
    [sym_catch_clause] = STATE(327),
    [aux_sym_constructor_try_statement_repeat1] = STATE(327),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_include_token1] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym___cdecl] = ACTIONS(2021),
    [anon_sym___clrcall] = ACTIONS(2021),
    [anon_sym___stdcall] = ACTIONS(2021),
    [anon_sym___fastcall] = ACTIONS(2021),
    [anon_sym___thiscall] = ACTIONS(2021),
    [anon_sym___vectorcall] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_case] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_goto] = ACTIONS(2021),
    [anon_sym___try] = ACTIONS(2021),
    [anon_sym___leave] = ACTIONS(2021),
    [anon_sym_not] = ACTIONS(2021),
    [anon_sym_compl] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2021),
    [anon_sym___alignof__] = ACTIONS(2021),
    [anon_sym___alignof] = ACTIONS(2021),
    [anon_sym__alignof] = ACTIONS(2021),
    [anon_sym_alignof] = ACTIONS(2021),
    [anon_sym__Alignof] = ACTIONS(2021),
    [anon_sym_offsetof] = ACTIONS(2021),
    [anon_sym__Generic] = ACTIONS(2021),
    [anon_sym_asm] = ACTIONS(2021),
    [anon_sym___asm__] = ACTIONS(2021),
    [anon_sym___asm] = ACTIONS(2021),
    [sym_number_literal] = ACTIONS(2023),
    [anon_sym_L_SQUOTE] = ACTIONS(2023),
    [anon_sym_u_SQUOTE] = ACTIONS(2023),
    [anon_sym_U_SQUOTE] = ACTIONS(2023),
    [anon_sym_u8_SQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_L_DQUOTE] = ACTIONS(2023),
    [anon_sym_u_DQUOTE] = ACTIONS(2023),
    [anon_sym_U_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8_DQUOTE] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [anon_sym_NULL] = ACTIONS(2021),
    [anon_sym_nullptr] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_namespace] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_concept] = ACTIONS(2021),
    [anon_sym_co_return] = ACTIONS(2021),
    [anon_sym_co_yield] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2023),
    [anon_sym_LR_DQUOTE] = ACTIONS(2023),
    [anon_sym_uR_DQUOTE] = ACTIONS(2023),
    [anon_sym_UR_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2023),
    [anon_sym_co_await] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_requires] = ACTIONS(2021),
    [sym_this] = ACTIONS(2021),
    [anon_sym_discard] = ACTIONS(2021),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
    [anon_sym_cbuffer] = ACTIONS(2021),
  },
  [316] = {
    [sym_identifier] = ACTIONS(2038),
    [aux_sym_preproc_include_token1] = ACTIONS(2038),
    [aux_sym_preproc_def_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token1] = ACTIONS(2038),
    [aux_sym_preproc_if_token2] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2038),
    [sym_preproc_directive] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_case] = ACTIONS(2038),
    [anon_sym_default] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_goto] = ACTIONS(2038),
    [anon_sym___try] = ACTIONS(2038),
    [anon_sym___leave] = ACTIONS(2038),
    [anon_sym_not] = ACTIONS(2038),
    [anon_sym_compl] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_sizeof] = ACTIONS(2038),
    [anon_sym___alignof__] = ACTIONS(2038),
    [anon_sym___alignof] = ACTIONS(2038),
    [anon_sym__alignof] = ACTIONS(2038),
    [anon_sym_alignof] = ACTIONS(2038),
    [anon_sym__Alignof] = ACTIONS(2038),
    [anon_sym_offsetof] = ACTIONS(2038),
    [anon_sym__Generic] = ACTIONS(2038),
    [anon_sym_asm] = ACTIONS(2038),
    [anon_sym___asm__] = ACTIONS(2038),
    [anon_sym___asm] = ACTIONS(2038),
    [sym_number_literal] = ACTIONS(2040),
    [anon_sym_L_SQUOTE] = ACTIONS(2040),
    [anon_sym_u_SQUOTE] = ACTIONS(2040),
    [anon_sym_U_SQUOTE] = ACTIONS(2040),
    [anon_sym_u8_SQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_L_DQUOTE] = ACTIONS(2040),
    [anon_sym_u_DQUOTE] = ACTIONS(2040),
    [anon_sym_U_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8_DQUOTE] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [anon_sym_NULL] = ACTIONS(2038),
    [anon_sym_nullptr] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_namespace] = ACTIONS(2038),
    [anon_sym_static_assert] = ACTIONS(2038),
    [anon_sym_concept] = ACTIONS(2038),
    [anon_sym_co_return] = ACTIONS(2038),
    [anon_sym_co_yield] = ACTIONS(2038),
    [anon_sym_R_DQUOTE] = ACTIONS(2040),
    [anon_sym_LR_DQUOTE] = ACTIONS(2040),
    [anon_sym_uR_DQUOTE] = ACTIONS(2040),
    [anon_sym_UR_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2040),
    [anon_sym_co_await] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [sym_this] = ACTIONS(2038),
    [anon_sym_discard] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
    [anon_sym_cbuffer] = ACTIONS(2038),
  },
  [317] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [318] = {
    [sym_identifier] = ACTIONS(2017),
    [aux_sym_preproc_include_token1] = ACTIONS(2017),
    [aux_sym_preproc_def_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token1] = ACTIONS(2017),
    [aux_sym_preproc_if_token2] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2017),
    [sym_preproc_directive] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_case] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_namespace] = ACTIONS(2017),
    [anon_sym_static_assert] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [319] = {
    [sym_identifier] = ACTIONS(2027),
    [aux_sym_preproc_include_token1] = ACTIONS(2027),
    [aux_sym_preproc_def_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token1] = ACTIONS(2027),
    [aux_sym_preproc_if_token2] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2027),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2027),
    [sym_preproc_directive] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_typedef] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_using] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_case] = ACTIONS(2027),
    [anon_sym_default] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym___try] = ACTIONS(2027),
    [anon_sym___leave] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2027),
    [anon_sym_compl] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym___alignof__] = ACTIONS(2027),
    [anon_sym___alignof] = ACTIONS(2027),
    [anon_sym__alignof] = ACTIONS(2027),
    [anon_sym_alignof] = ACTIONS(2027),
    [anon_sym__Alignof] = ACTIONS(2027),
    [anon_sym_offsetof] = ACTIONS(2027),
    [anon_sym__Generic] = ACTIONS(2027),
    [anon_sym_asm] = ACTIONS(2027),
    [anon_sym___asm__] = ACTIONS(2027),
    [anon_sym___asm] = ACTIONS(2027),
    [sym_number_literal] = ACTIONS(2029),
    [anon_sym_L_SQUOTE] = ACTIONS(2029),
    [anon_sym_u_SQUOTE] = ACTIONS(2029),
    [anon_sym_U_SQUOTE] = ACTIONS(2029),
    [anon_sym_u8_SQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [anon_sym_L_DQUOTE] = ACTIONS(2029),
    [anon_sym_u_DQUOTE] = ACTIONS(2029),
    [anon_sym_U_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8_DQUOTE] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [anon_sym_NULL] = ACTIONS(2027),
    [anon_sym_nullptr] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_explicit] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_namespace] = ACTIONS(2027),
    [anon_sym_static_assert] = ACTIONS(2027),
    [anon_sym_concept] = ACTIONS(2027),
    [anon_sym_co_return] = ACTIONS(2027),
    [anon_sym_co_yield] = ACTIONS(2027),
    [anon_sym_R_DQUOTE] = ACTIONS(2029),
    [anon_sym_LR_DQUOTE] = ACTIONS(2029),
    [anon_sym_uR_DQUOTE] = ACTIONS(2029),
    [anon_sym_UR_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2029),
    [anon_sym_co_await] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [sym_this] = ACTIONS(2027),
    [anon_sym_discard] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
    [anon_sym_cbuffer] = ACTIONS(2027),
  },
  [320] = {
    [sym_identifier] = ACTIONS(2011),
    [aux_sym_preproc_include_token1] = ACTIONS(2011),
    [aux_sym_preproc_def_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token1] = ACTIONS(2011),
    [aux_sym_preproc_if_token2] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2011),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2011),
    [sym_preproc_directive] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_using] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_case] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_goto] = ACTIONS(2011),
    [anon_sym___try] = ACTIONS(2011),
    [anon_sym___leave] = ACTIONS(2011),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_compl] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2011),
    [anon_sym___alignof__] = ACTIONS(2011),
    [anon_sym___alignof] = ACTIONS(2011),
    [anon_sym__alignof] = ACTIONS(2011),
    [anon_sym_alignof] = ACTIONS(2011),
    [anon_sym__Alignof] = ACTIONS(2011),
    [anon_sym_offsetof] = ACTIONS(2011),
    [anon_sym__Generic] = ACTIONS(2011),
    [anon_sym_asm] = ACTIONS(2011),
    [anon_sym___asm__] = ACTIONS(2011),
    [anon_sym___asm] = ACTIONS(2011),
    [sym_number_literal] = ACTIONS(2013),
    [anon_sym_L_SQUOTE] = ACTIONS(2013),
    [anon_sym_u_SQUOTE] = ACTIONS(2013),
    [anon_sym_U_SQUOTE] = ACTIONS(2013),
    [anon_sym_u8_SQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [anon_sym_L_DQUOTE] = ACTIONS(2013),
    [anon_sym_u_DQUOTE] = ACTIONS(2013),
    [anon_sym_U_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8_DQUOTE] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [anon_sym_NULL] = ACTIONS(2011),
    [anon_sym_nullptr] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_explicit] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_namespace] = ACTIONS(2011),
    [anon_sym_static_assert] = ACTIONS(2011),
    [anon_sym_concept] = ACTIONS(2011),
    [anon_sym_co_return] = ACTIONS(2011),
    [anon_sym_co_yield] = ACTIONS(2011),
    [anon_sym_R_DQUOTE] = ACTIONS(2013),
    [anon_sym_LR_DQUOTE] = ACTIONS(2013),
    [anon_sym_uR_DQUOTE] = ACTIONS(2013),
    [anon_sym_UR_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2013),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [sym_this] = ACTIONS(2011),
    [anon_sym_discard] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
    [anon_sym_cbuffer] = ACTIONS(2011),
  },
  [321] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(2388),
    [sym_identifier] = ACTIONS(2386),
    [aux_sym_preproc_include_token1] = ACTIONS(2386),
    [aux_sym_preproc_def_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2386),
    [sym_preproc_directive] = ACTIONS(2386),
    [anon_sym_LPAREN2] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2386),
    [anon_sym_typedef] = ACTIONS(2386),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_out] = ACTIONS(2386),
    [anon_sym_inout] = ACTIONS(2386),
    [anon_sym_virtual] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym___attribute__] = ACTIONS(2386),
    [anon_sym___attribute] = ACTIONS(2386),
    [anon_sym_using] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2388),
    [anon_sym___declspec] = ACTIONS(2386),
    [anon_sym___based] = ACTIONS(2386),
    [anon_sym___cdecl] = ACTIONS(2386),
    [anon_sym___clrcall] = ACTIONS(2386),
    [anon_sym___stdcall] = ACTIONS(2386),
    [anon_sym___fastcall] = ACTIONS(2386),
    [anon_sym___thiscall] = ACTIONS(2386),
    [anon_sym___vectorcall] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2386),
    [anon_sym_unsigned] = ACTIONS(2386),
    [anon_sym_long] = ACTIONS(2386),
    [anon_sym_short] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_register] = ACTIONS(2386),
    [anon_sym_inline] = ACTIONS(2386),
    [anon_sym___inline] = ACTIONS(2386),
    [anon_sym___inline__] = ACTIONS(2386),
    [anon_sym___forceinline] = ACTIONS(2386),
    [anon_sym_thread_local] = ACTIONS(2386),
    [anon_sym___thread] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_constexpr] = ACTIONS(2386),
    [anon_sym_volatile] = ACTIONS(2386),
    [anon_sym_restrict] = ACTIONS(2386),
    [anon_sym___restrict__] = ACTIONS(2386),
    [anon_sym__Atomic] = ACTIONS(2386),
    [anon_sym__Noreturn] = ACTIONS(2386),
    [anon_sym_noreturn] = ACTIONS(2386),
    [anon_sym__Nonnull] = ACTIONS(2386),
    [anon_sym_mutable] = ACTIONS(2386),
    [anon_sym_constinit] = ACTIONS(2386),
    [anon_sym_consteval] = ACTIONS(2386),
    [anon_sym_alignas] = ACTIONS(2386),
    [anon_sym__Alignas] = ACTIONS(2386),
    [sym_primitive_type] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_goto] = ACTIONS(2386),
    [anon_sym___try] = ACTIONS(2386),
    [anon_sym___leave] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_compl] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2386),
    [anon_sym___alignof__] = ACTIONS(2386),
    [anon_sym___alignof] = ACTIONS(2386),
    [anon_sym__alignof] = ACTIONS(2386),
    [anon_sym_alignof] = ACTIONS(2386),
    [anon_sym__Alignof] = ACTIONS(2386),
    [anon_sym_offsetof] = ACTIONS(2386),
    [anon_sym__Generic] = ACTIONS(2386),
    [anon_sym_asm] = ACTIONS(2386),
    [anon_sym___asm__] = ACTIONS(2386),
    [anon_sym___asm] = ACTIONS(2386),
    [sym_number_literal] = ACTIONS(2388),
    [anon_sym_L_SQUOTE] = ACTIONS(2388),
    [anon_sym_u_SQUOTE] = ACTIONS(2388),
    [anon_sym_U_SQUOTE] = ACTIONS(2388),
    [anon_sym_u8_SQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_L_DQUOTE] = ACTIONS(2388),
    [anon_sym_u_DQUOTE] = ACTIONS(2388),
    [anon_sym_U_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8_DQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [anon_sym_NULL] = ACTIONS(2386),
    [anon_sym_nullptr] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2386),
    [anon_sym_decltype] = ACTIONS(2386),
    [anon_sym_explicit] = ACTIONS(2386),
    [anon_sym_typename] = ACTIONS(2386),
    [anon_sym_export] = ACTIONS(2386),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_import] = ACTIONS(2386),
    [anon_sym_template] = ACTIONS(2386),
    [anon_sym_operator] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_static_assert] = ACTIONS(2386),
    [anon_sym_concept] = ACTIONS(2386),
    [anon_sym_co_return] = ACTIONS(2386),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_requires] = ACTIONS(2386),
    [sym_this] = ACTIONS(2386),
    [anon_sym_discard] = ACTIONS(2386),
    [anon_sym_precise] = ACTIONS(2386),
    [anon_sym_shared] = ACTIONS(2386),
    [anon_sym_groupshared] = ACTIONS(2386),
    [anon_sym_uniform] = ACTIONS(2386),
    [anon_sym_row_major] = ACTIONS(2386),
    [anon_sym_column_major] = ACTIONS(2386),
    [anon_sym_globallycoherent] = ACTIONS(2386),
    [anon_sym_centroid] = ACTIONS(2386),
    [anon_sym_noperspective] = ACTIONS(2386),
    [anon_sym_nointerpolation] = ACTIONS(2386),
    [anon_sym_sample] = ACTIONS(2386),
    [anon_sym_linear] = ACTIONS(2386),
    [anon_sym_snorm] = ACTIONS(2386),
    [anon_sym_unorm] = ACTIONS(2386),
    [anon_sym_point] = ACTIONS(2386),
    [anon_sym_line] = ACTIONS(2386),
    [anon_sym_triangleadj] = ACTIONS(2386),
    [anon_sym_lineadj] = ACTIONS(2386),
    [anon_sym_triangle] = ACTIONS(2386),
    [anon_sym_cbuffer] = ACTIONS(2386),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(2392),
    [sym_identifier] = ACTIONS(2390),
    [aux_sym_preproc_include_token1] = ACTIONS(2390),
    [aux_sym_preproc_def_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2390),
    [sym_preproc_directive] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2390),
    [anon_sym_typedef] = ACTIONS(2390),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_out] = ACTIONS(2390),
    [anon_sym_inout] = ACTIONS(2390),
    [anon_sym_virtual] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym___attribute__] = ACTIONS(2390),
    [anon_sym___attribute] = ACTIONS(2390),
    [anon_sym_using] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2392),
    [anon_sym___declspec] = ACTIONS(2390),
    [anon_sym___based] = ACTIONS(2390),
    [anon_sym___cdecl] = ACTIONS(2390),
    [anon_sym___clrcall] = ACTIONS(2390),
    [anon_sym___stdcall] = ACTIONS(2390),
    [anon_sym___fastcall] = ACTIONS(2390),
    [anon_sym___thiscall] = ACTIONS(2390),
    [anon_sym___vectorcall] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2390),
    [anon_sym_unsigned] = ACTIONS(2390),
    [anon_sym_long] = ACTIONS(2390),
    [anon_sym_short] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_register] = ACTIONS(2390),
    [anon_sym_inline] = ACTIONS(2390),
    [anon_sym___inline] = ACTIONS(2390),
    [anon_sym___inline__] = ACTIONS(2390),
    [anon_sym___forceinline] = ACTIONS(2390),
    [anon_sym_thread_local] = ACTIONS(2390),
    [anon_sym___thread] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_constexpr] = ACTIONS(2390),
    [anon_sym_volatile] = ACTIONS(2390),
    [anon_sym_restrict] = ACTIONS(2390),
    [anon_sym___restrict__] = ACTIONS(2390),
    [anon_sym__Atomic] = ACTIONS(2390),
    [anon_sym__Noreturn] = ACTIONS(2390),
    [anon_sym_noreturn] = ACTIONS(2390),
    [anon_sym__Nonnull] = ACTIONS(2390),
    [anon_sym_mutable] = ACTIONS(2390),
    [anon_sym_constinit] = ACTIONS(2390),
    [anon_sym_consteval] = ACTIONS(2390),
    [anon_sym_alignas] = ACTIONS(2390),
    [anon_sym__Alignas] = ACTIONS(2390),
    [sym_primitive_type] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2390),
    [anon_sym___leave] = ACTIONS(2390),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_compl] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2390),
    [anon_sym___alignof__] = ACTIONS(2390),
    [anon_sym___alignof] = ACTIONS(2390),
    [anon_sym__alignof] = ACTIONS(2390),
    [anon_sym_alignof] = ACTIONS(2390),
    [anon_sym__Alignof] = ACTIONS(2390),
    [anon_sym_offsetof] = ACTIONS(2390),
    [anon_sym__Generic] = ACTIONS(2390),
    [anon_sym_asm] = ACTIONS(2390),
    [anon_sym___asm__] = ACTIONS(2390),
    [anon_sym___asm] = ACTIONS(2390),
    [sym_number_literal] = ACTIONS(2392),
    [anon_sym_L_SQUOTE] = ACTIONS(2392),
    [anon_sym_u_SQUOTE] = ACTIONS(2392),
    [anon_sym_U_SQUOTE] = ACTIONS(2392),
    [anon_sym_u8_SQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_L_DQUOTE] = ACTIONS(2392),
    [anon_sym_u_DQUOTE] = ACTIONS(2392),
    [anon_sym_U_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [anon_sym_NULL] = ACTIONS(2390),
    [anon_sym_nullptr] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2390),
    [anon_sym_decltype] = ACTIONS(2390),
    [anon_sym_explicit] = ACTIONS(2390),
    [anon_sym_typename] = ACTIONS(2390),
    [anon_sym_export] = ACTIONS(2390),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_template] = ACTIONS(2390),
    [anon_sym_operator] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_static_assert] = ACTIONS(2390),
    [anon_sym_concept] = ACTIONS(2390),
    [anon_sym_co_return] = ACTIONS(2390),
    [anon_sym_co_yield] = ACTIONS(2390),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_LR_DQUOTE] = ACTIONS(2392),
    [anon_sym_uR_DQUOTE] = ACTIONS(2392),
    [anon_sym_UR_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2392),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_requires] = ACTIONS(2390),
    [sym_this] = ACTIONS(2390),
    [anon_sym_discard] = ACTIONS(2390),
    [anon_sym_precise] = ACTIONS(2390),
    [anon_sym_shared] = ACTIONS(2390),
    [anon_sym_groupshared] = ACTIONS(2390),
    [anon_sym_uniform] = ACTIONS(2390),
    [anon_sym_row_major] = ACTIONS(2390),
    [anon_sym_column_major] = ACTIONS(2390),
    [anon_sym_globallycoherent] = ACTIONS(2390),
    [anon_sym_centroid] = ACTIONS(2390),
    [anon_sym_noperspective] = ACTIONS(2390),
    [anon_sym_nointerpolation] = ACTIONS(2390),
    [anon_sym_sample] = ACTIONS(2390),
    [anon_sym_linear] = ACTIONS(2390),
    [anon_sym_snorm] = ACTIONS(2390),
    [anon_sym_unorm] = ACTIONS(2390),
    [anon_sym_point] = ACTIONS(2390),
    [anon_sym_line] = ACTIONS(2390),
    [anon_sym_triangleadj] = ACTIONS(2390),
    [anon_sym_lineadj] = ACTIONS(2390),
    [anon_sym_triangle] = ACTIONS(2390),
    [anon_sym_cbuffer] = ACTIONS(2390),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(2396),
    [sym_identifier] = ACTIONS(2394),
    [aux_sym_preproc_include_token1] = ACTIONS(2394),
    [aux_sym_preproc_def_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2394),
    [sym_preproc_directive] = ACTIONS(2394),
    [anon_sym_LPAREN2] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2394),
    [anon_sym_typedef] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_out] = ACTIONS(2394),
    [anon_sym_inout] = ACTIONS(2394),
    [anon_sym_virtual] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym___attribute__] = ACTIONS(2394),
    [anon_sym___attribute] = ACTIONS(2394),
    [anon_sym_using] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2396),
    [anon_sym___declspec] = ACTIONS(2394),
    [anon_sym___based] = ACTIONS(2394),
    [anon_sym___cdecl] = ACTIONS(2394),
    [anon_sym___clrcall] = ACTIONS(2394),
    [anon_sym___stdcall] = ACTIONS(2394),
    [anon_sym___fastcall] = ACTIONS(2394),
    [anon_sym___thiscall] = ACTIONS(2394),
    [anon_sym___vectorcall] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2394),
    [anon_sym_unsigned] = ACTIONS(2394),
    [anon_sym_long] = ACTIONS(2394),
    [anon_sym_short] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_register] = ACTIONS(2394),
    [anon_sym_inline] = ACTIONS(2394),
    [anon_sym___inline] = ACTIONS(2394),
    [anon_sym___inline__] = ACTIONS(2394),
    [anon_sym___forceinline] = ACTIONS(2394),
    [anon_sym_thread_local] = ACTIONS(2394),
    [anon_sym___thread] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_constexpr] = ACTIONS(2394),
    [anon_sym_volatile] = ACTIONS(2394),
    [anon_sym_restrict] = ACTIONS(2394),
    [anon_sym___restrict__] = ACTIONS(2394),
    [anon_sym__Atomic] = ACTIONS(2394),
    [anon_sym__Noreturn] = ACTIONS(2394),
    [anon_sym_noreturn] = ACTIONS(2394),
    [anon_sym__Nonnull] = ACTIONS(2394),
    [anon_sym_mutable] = ACTIONS(2394),
    [anon_sym_constinit] = ACTIONS(2394),
    [anon_sym_consteval] = ACTIONS(2394),
    [anon_sym_alignas] = ACTIONS(2394),
    [anon_sym__Alignas] = ACTIONS(2394),
    [sym_primitive_type] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_goto] = ACTIONS(2394),
    [anon_sym___try] = ACTIONS(2394),
    [anon_sym___leave] = ACTIONS(2394),
    [anon_sym_not] = ACTIONS(2394),
    [anon_sym_compl] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2394),
    [anon_sym___alignof] = ACTIONS(2394),
    [anon_sym__alignof] = ACTIONS(2394),
    [anon_sym_alignof] = ACTIONS(2394),
    [anon_sym__Alignof] = ACTIONS(2394),
    [anon_sym_offsetof] = ACTIONS(2394),
    [anon_sym__Generic] = ACTIONS(2394),
    [anon_sym_asm] = ACTIONS(2394),
    [anon_sym___asm__] = ACTIONS(2394),
    [anon_sym___asm] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2396),
    [anon_sym_L_SQUOTE] = ACTIONS(2396),
    [anon_sym_u_SQUOTE] = ACTIONS(2396),
    [anon_sym_U_SQUOTE] = ACTIONS(2396),
    [anon_sym_u8_SQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_L_DQUOTE] = ACTIONS(2396),
    [anon_sym_u_DQUOTE] = ACTIONS(2396),
    [anon_sym_U_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8_DQUOTE] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [anon_sym_NULL] = ACTIONS(2394),
    [anon_sym_nullptr] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2394),
    [anon_sym_decltype] = ACTIONS(2394),
    [anon_sym_explicit] = ACTIONS(2394),
    [anon_sym_typename] = ACTIONS(2394),
    [anon_sym_export] = ACTIONS(2394),
    [anon_sym_module] = ACTIONS(2394),
    [anon_sym_import] = ACTIONS(2394),
    [anon_sym_template] = ACTIONS(2394),
    [anon_sym_operator] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_static_assert] = ACTIONS(2394),
    [anon_sym_concept] = ACTIONS(2394),
    [anon_sym_co_return] = ACTIONS(2394),
    [anon_sym_co_yield] = ACTIONS(2394),
    [anon_sym_R_DQUOTE] = ACTIONS(2396),
    [anon_sym_LR_DQUOTE] = ACTIONS(2396),
    [anon_sym_uR_DQUOTE] = ACTIONS(2396),
    [anon_sym_UR_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2396),
    [anon_sym_co_await] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2394),
    [anon_sym_discard] = ACTIONS(2394),
    [anon_sym_precise] = ACTIONS(2394),
    [anon_sym_shared] = ACTIONS(2394),
    [anon_sym_groupshared] = ACTIONS(2394),
    [anon_sym_uniform] = ACTIONS(2394),
    [anon_sym_row_major] = ACTIONS(2394),
    [anon_sym_column_major] = ACTIONS(2394),
    [anon_sym_globallycoherent] = ACTIONS(2394),
    [anon_sym_centroid] = ACTIONS(2394),
    [anon_sym_noperspective] = ACTIONS(2394),
    [anon_sym_nointerpolation] = ACTIONS(2394),
    [anon_sym_sample] = ACTIONS(2394),
    [anon_sym_linear] = ACTIONS(2394),
    [anon_sym_snorm] = ACTIONS(2394),
    [anon_sym_unorm] = ACTIONS(2394),
    [anon_sym_point] = ACTIONS(2394),
    [anon_sym_line] = ACTIONS(2394),
    [anon_sym_triangleadj] = ACTIONS(2394),
    [anon_sym_lineadj] = ACTIONS(2394),
    [anon_sym_triangle] = ACTIONS(2394),
    [anon_sym_cbuffer] = ACTIONS(2394),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_export] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2378),
    [anon_sym_import] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(2380),
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_export] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2378),
    [anon_sym_import] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [327] = {
    [sym_catch_clause] = STATE(327),
    [aux_sym_constructor_try_statement_repeat1] = STATE(327),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_include_token1] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym___cdecl] = ACTIONS(2031),
    [anon_sym___clrcall] = ACTIONS(2031),
    [anon_sym___stdcall] = ACTIONS(2031),
    [anon_sym___fastcall] = ACTIONS(2031),
    [anon_sym___thiscall] = ACTIONS(2031),
    [anon_sym___vectorcall] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_case] = ACTIONS(2031),
    [anon_sym_default] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2031),
    [anon_sym___leave] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2031),
    [anon_sym_compl] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2031),
    [anon_sym___alignof] = ACTIONS(2031),
    [anon_sym__alignof] = ACTIONS(2031),
    [anon_sym_alignof] = ACTIONS(2031),
    [anon_sym__Alignof] = ACTIONS(2031),
    [anon_sym_offsetof] = ACTIONS(2031),
    [anon_sym__Generic] = ACTIONS(2031),
    [anon_sym_asm] = ACTIONS(2031),
    [anon_sym___asm__] = ACTIONS(2031),
    [anon_sym___asm] = ACTIONS(2031),
    [sym_number_literal] = ACTIONS(2033),
    [anon_sym_L_SQUOTE] = ACTIONS(2033),
    [anon_sym_u_SQUOTE] = ACTIONS(2033),
    [anon_sym_U_SQUOTE] = ACTIONS(2033),
    [anon_sym_u8_SQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [anon_sym_L_DQUOTE] = ACTIONS(2033),
    [anon_sym_u_DQUOTE] = ACTIONS(2033),
    [anon_sym_U_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8_DQUOTE] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [anon_sym_NULL] = ACTIONS(2031),
    [anon_sym_nullptr] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_namespace] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_concept] = ACTIONS(2031),
    [anon_sym_co_return] = ACTIONS(2031),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(2459),
    [anon_sym_R_DQUOTE] = ACTIONS(2033),
    [anon_sym_LR_DQUOTE] = ACTIONS(2033),
    [anon_sym_uR_DQUOTE] = ACTIONS(2033),
    [anon_sym_UR_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2033),
    [anon_sym_co_await] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_requires] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [anon_sym_discard] = ACTIONS(2031),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
    [anon_sym_cbuffer] = ACTIONS(2031),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(2173),
    [sym_identifier] = ACTIONS(2171),
    [aux_sym_preproc_include_token1] = ACTIONS(2171),
    [aux_sym_preproc_def_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2171),
    [sym_preproc_directive] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2171),
    [anon_sym_typedef] = ACTIONS(2171),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_out] = ACTIONS(2171),
    [anon_sym_inout] = ACTIONS(2171),
    [anon_sym_virtual] = ACTIONS(2171),
    [anon_sym_extern] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2171),
    [anon_sym___attribute] = ACTIONS(2171),
    [anon_sym_using] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2171),
    [anon_sym___based] = ACTIONS(2171),
    [anon_sym___cdecl] = ACTIONS(2171),
    [anon_sym___clrcall] = ACTIONS(2171),
    [anon_sym___stdcall] = ACTIONS(2171),
    [anon_sym___fastcall] = ACTIONS(2171),
    [anon_sym___thiscall] = ACTIONS(2171),
    [anon_sym___vectorcall] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_signed] = ACTIONS(2171),
    [anon_sym_unsigned] = ACTIONS(2171),
    [anon_sym_long] = ACTIONS(2171),
    [anon_sym_short] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_register] = ACTIONS(2171),
    [anon_sym_inline] = ACTIONS(2171),
    [anon_sym___inline] = ACTIONS(2171),
    [anon_sym___inline__] = ACTIONS(2171),
    [anon_sym___forceinline] = ACTIONS(2171),
    [anon_sym_thread_local] = ACTIONS(2171),
    [anon_sym___thread] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_constexpr] = ACTIONS(2171),
    [anon_sym_volatile] = ACTIONS(2171),
    [anon_sym_restrict] = ACTIONS(2171),
    [anon_sym___restrict__] = ACTIONS(2171),
    [anon_sym__Atomic] = ACTIONS(2171),
    [anon_sym__Noreturn] = ACTIONS(2171),
    [anon_sym_noreturn] = ACTIONS(2171),
    [anon_sym__Nonnull] = ACTIONS(2171),
    [anon_sym_mutable] = ACTIONS(2171),
    [anon_sym_constinit] = ACTIONS(2171),
    [anon_sym_consteval] = ACTIONS(2171),
    [anon_sym_alignas] = ACTIONS(2171),
    [anon_sym__Alignas] = ACTIONS(2171),
    [sym_primitive_type] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_struct] = ACTIONS(2171),
    [anon_sym_union] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2171),
    [anon_sym_default] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_goto] = ACTIONS(2171),
    [anon_sym___try] = ACTIONS(2171),
    [anon_sym___leave] = ACTIONS(2171),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_compl] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2171),
    [anon_sym___alignof__] = ACTIONS(2171),
    [anon_sym___alignof] = ACTIONS(2171),
    [anon_sym__alignof] = ACTIONS(2171),
    [anon_sym_alignof] = ACTIONS(2171),
    [anon_sym__Alignof] = ACTIONS(2171),
    [anon_sym_offsetof] = ACTIONS(2171),
    [anon_sym__Generic] = ACTIONS(2171),
    [anon_sym_asm] = ACTIONS(2171),
    [anon_sym___asm__] = ACTIONS(2171),
    [anon_sym___asm] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2173),
    [anon_sym_u_SQUOTE] = ACTIONS(2173),
    [anon_sym_U_SQUOTE] = ACTIONS(2173),
    [anon_sym_u8_SQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_L_DQUOTE] = ACTIONS(2173),
    [anon_sym_u_DQUOTE] = ACTIONS(2173),
    [anon_sym_U_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8_DQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [anon_sym_NULL] = ACTIONS(2171),
    [anon_sym_nullptr] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2171),
    [anon_sym_decltype] = ACTIONS(2171),
    [anon_sym_explicit] = ACTIONS(2171),
    [anon_sym_typename] = ACTIONS(2171),
    [anon_sym_export] = ACTIONS(2171),
    [anon_sym_module] = ACTIONS(2171),
    [anon_sym_import] = ACTIONS(2171),
    [anon_sym_template] = ACTIONS(2171),
    [anon_sym_operator] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_static_assert] = ACTIONS(2171),
    [anon_sym_concept] = ACTIONS(2171),
    [anon_sym_co_return] = ACTIONS(2171),
    [anon_sym_co_yield] = ACTIONS(2171),
    [anon_sym_R_DQUOTE] = ACTIONS(2173),
    [anon_sym_LR_DQUOTE] = ACTIONS(2173),
    [anon_sym_uR_DQUOTE] = ACTIONS(2173),
    [anon_sym_UR_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2173),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_requires] = ACTIONS(2171),
    [sym_this] = ACTIONS(2171),
    [anon_sym_discard] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2171),
    [anon_sym_shared] = ACTIONS(2171),
    [anon_sym_groupshared] = ACTIONS(2171),
    [anon_sym_uniform] = ACTIONS(2171),
    [anon_sym_row_major] = ACTIONS(2171),
    [anon_sym_column_major] = ACTIONS(2171),
    [anon_sym_globallycoherent] = ACTIONS(2171),
    [anon_sym_centroid] = ACTIONS(2171),
    [anon_sym_noperspective] = ACTIONS(2171),
    [anon_sym_nointerpolation] = ACTIONS(2171),
    [anon_sym_sample] = ACTIONS(2171),
    [anon_sym_linear] = ACTIONS(2171),
    [anon_sym_snorm] = ACTIONS(2171),
    [anon_sym_unorm] = ACTIONS(2171),
    [anon_sym_point] = ACTIONS(2171),
    [anon_sym_line] = ACTIONS(2171),
    [anon_sym_triangleadj] = ACTIONS(2171),
    [anon_sym_lineadj] = ACTIONS(2171),
    [anon_sym_triangle] = ACTIONS(2171),
    [anon_sym_cbuffer] = ACTIONS(2171),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(2157),
    [sym_identifier] = ACTIONS(2155),
    [aux_sym_preproc_include_token1] = ACTIONS(2155),
    [aux_sym_preproc_def_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2155),
    [sym_preproc_directive] = ACTIONS(2155),
    [anon_sym_LPAREN2] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym___extension__] = ACTIONS(2155),
    [anon_sym_typedef] = ACTIONS(2155),
    [anon_sym_in] = ACTIONS(2155),
    [anon_sym_out] = ACTIONS(2155),
    [anon_sym_inout] = ACTIONS(2155),
    [anon_sym_virtual] = ACTIONS(2155),
    [anon_sym_extern] = ACTIONS(2155),
    [anon_sym___attribute__] = ACTIONS(2155),
    [anon_sym___attribute] = ACTIONS(2155),
    [anon_sym_using] = ACTIONS(2155),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2157),
    [anon_sym___declspec] = ACTIONS(2155),
    [anon_sym___based] = ACTIONS(2155),
    [anon_sym___cdecl] = ACTIONS(2155),
    [anon_sym___clrcall] = ACTIONS(2155),
    [anon_sym___stdcall] = ACTIONS(2155),
    [anon_sym___fastcall] = ACTIONS(2155),
    [anon_sym___thiscall] = ACTIONS(2155),
    [anon_sym___vectorcall] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_signed] = ACTIONS(2155),
    [anon_sym_unsigned] = ACTIONS(2155),
    [anon_sym_long] = ACTIONS(2155),
    [anon_sym_short] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_register] = ACTIONS(2155),
    [anon_sym_inline] = ACTIONS(2155),
    [anon_sym___inline] = ACTIONS(2155),
    [anon_sym___inline__] = ACTIONS(2155),
    [anon_sym___forceinline] = ACTIONS(2155),
    [anon_sym_thread_local] = ACTIONS(2155),
    [anon_sym___thread] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_constexpr] = ACTIONS(2155),
    [anon_sym_volatile] = ACTIONS(2155),
    [anon_sym_restrict] = ACTIONS(2155),
    [anon_sym___restrict__] = ACTIONS(2155),
    [anon_sym__Atomic] = ACTIONS(2155),
    [anon_sym__Noreturn] = ACTIONS(2155),
    [anon_sym_noreturn] = ACTIONS(2155),
    [anon_sym__Nonnull] = ACTIONS(2155),
    [anon_sym_mutable] = ACTIONS(2155),
    [anon_sym_constinit] = ACTIONS(2155),
    [anon_sym_consteval] = ACTIONS(2155),
    [anon_sym_alignas] = ACTIONS(2155),
    [anon_sym__Alignas] = ACTIONS(2155),
    [sym_primitive_type] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_struct] = ACTIONS(2155),
    [anon_sym_union] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2155),
    [anon_sym_default] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_goto] = ACTIONS(2155),
    [anon_sym___try] = ACTIONS(2155),
    [anon_sym___leave] = ACTIONS(2155),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_compl] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_sizeof] = ACTIONS(2155),
    [anon_sym___alignof__] = ACTIONS(2155),
    [anon_sym___alignof] = ACTIONS(2155),
    [anon_sym__alignof] = ACTIONS(2155),
    [anon_sym_alignof] = ACTIONS(2155),
    [anon_sym__Alignof] = ACTIONS(2155),
    [anon_sym_offsetof] = ACTIONS(2155),
    [anon_sym__Generic] = ACTIONS(2155),
    [anon_sym_asm] = ACTIONS(2155),
    [anon_sym___asm__] = ACTIONS(2155),
    [anon_sym___asm] = ACTIONS(2155),
    [sym_number_literal] = ACTIONS(2157),
    [anon_sym_L_SQUOTE] = ACTIONS(2157),
    [anon_sym_u_SQUOTE] = ACTIONS(2157),
    [anon_sym_U_SQUOTE] = ACTIONS(2157),
    [anon_sym_u8_SQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [anon_sym_L_DQUOTE] = ACTIONS(2157),
    [anon_sym_u_DQUOTE] = ACTIONS(2157),
    [anon_sym_U_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8_DQUOTE] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [anon_sym_NULL] = ACTIONS(2155),
    [anon_sym_nullptr] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2155),
    [anon_sym_decltype] = ACTIONS(2155),
    [anon_sym_explicit] = ACTIONS(2155),
    [anon_sym_typename] = ACTIONS(2155),
    [anon_sym_export] = ACTIONS(2155),
    [anon_sym_module] = ACTIONS(2155),
    [anon_sym_import] = ACTIONS(2155),
    [anon_sym_template] = ACTIONS(2155),
    [anon_sym_operator] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_static_assert] = ACTIONS(2155),
    [anon_sym_concept] = ACTIONS(2155),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2155),
    [anon_sym_R_DQUOTE] = ACTIONS(2157),
    [anon_sym_LR_DQUOTE] = ACTIONS(2157),
    [anon_sym_uR_DQUOTE] = ACTIONS(2157),
    [anon_sym_UR_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2157),
    [anon_sym_co_await] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_requires] = ACTIONS(2155),
    [sym_this] = ACTIONS(2155),
    [anon_sym_discard] = ACTIONS(2155),
    [anon_sym_precise] = ACTIONS(2155),
    [anon_sym_shared] = ACTIONS(2155),
    [anon_sym_groupshared] = ACTIONS(2155),
    [anon_sym_uniform] = ACTIONS(2155),
    [anon_sym_row_major] = ACTIONS(2155),
    [anon_sym_column_major] = ACTIONS(2155),
    [anon_sym_globallycoherent] = ACTIONS(2155),
    [anon_sym_centroid] = ACTIONS(2155),
    [anon_sym_noperspective] = ACTIONS(2155),
    [anon_sym_nointerpolation] = ACTIONS(2155),
    [anon_sym_sample] = ACTIONS(2155),
    [anon_sym_linear] = ACTIONS(2155),
    [anon_sym_snorm] = ACTIONS(2155),
    [anon_sym_unorm] = ACTIONS(2155),
    [anon_sym_point] = ACTIONS(2155),
    [anon_sym_line] = ACTIONS(2155),
    [anon_sym_triangleadj] = ACTIONS(2155),
    [anon_sym_lineadj] = ACTIONS(2155),
    [anon_sym_triangle] = ACTIONS(2155),
    [anon_sym_cbuffer] = ACTIONS(2155),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(2216),
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_include_token1] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_AMP_AMP] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_virtual] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym___attribute] = ACTIONS(2214),
    [anon_sym_using] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym___based] = ACTIONS(2214),
    [anon_sym___cdecl] = ACTIONS(2214),
    [anon_sym___clrcall] = ACTIONS(2214),
    [anon_sym___stdcall] = ACTIONS(2214),
    [anon_sym___fastcall] = ACTIONS(2214),
    [anon_sym___thiscall] = ACTIONS(2214),
    [anon_sym___vectorcall] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym__Nonnull] = ACTIONS(2214),
    [anon_sym_mutable] = ACTIONS(2214),
    [anon_sym_constinit] = ACTIONS(2214),
    [anon_sym_consteval] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_goto] = ACTIONS(2214),
    [anon_sym___try] = ACTIONS(2214),
    [anon_sym___leave] = ACTIONS(2214),
    [anon_sym_not] = ACTIONS(2214),
    [anon_sym_compl] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2214),
    [anon_sym___alignof__] = ACTIONS(2214),
    [anon_sym___alignof] = ACTIONS(2214),
    [anon_sym__alignof] = ACTIONS(2214),
    [anon_sym_alignof] = ACTIONS(2214),
    [anon_sym__Alignof] = ACTIONS(2214),
    [anon_sym_offsetof] = ACTIONS(2214),
    [anon_sym__Generic] = ACTIONS(2214),
    [anon_sym_asm] = ACTIONS(2214),
    [anon_sym___asm__] = ACTIONS(2214),
    [anon_sym___asm] = ACTIONS(2214),
    [sym_number_literal] = ACTIONS(2216),
    [anon_sym_L_SQUOTE] = ACTIONS(2216),
    [anon_sym_u_SQUOTE] = ACTIONS(2216),
    [anon_sym_U_SQUOTE] = ACTIONS(2216),
    [anon_sym_u8_SQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_L_DQUOTE] = ACTIONS(2216),
    [anon_sym_u_DQUOTE] = ACTIONS(2216),
    [anon_sym_U_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8_DQUOTE] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [anon_sym_NULL] = ACTIONS(2214),
    [anon_sym_nullptr] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2214),
    [anon_sym_decltype] = ACTIONS(2214),
    [anon_sym_explicit] = ACTIONS(2214),
    [anon_sym_typename] = ACTIONS(2214),
    [anon_sym_export] = ACTIONS(2214),
    [anon_sym_module] = ACTIONS(2214),
    [anon_sym_import] = ACTIONS(2214),
    [anon_sym_template] = ACTIONS(2214),
    [anon_sym_operator] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_static_assert] = ACTIONS(2214),
    [anon_sym_concept] = ACTIONS(2214),
    [anon_sym_co_return] = ACTIONS(2214),
    [anon_sym_co_yield] = ACTIONS(2214),
    [anon_sym_R_DQUOTE] = ACTIONS(2216),
    [anon_sym_LR_DQUOTE] = ACTIONS(2216),
    [anon_sym_uR_DQUOTE] = ACTIONS(2216),
    [anon_sym_UR_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2216),
    [anon_sym_co_await] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_requires] = ACTIONS(2214),
    [sym_this] = ACTIONS(2214),
    [anon_sym_discard] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_groupshared] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_row_major] = ACTIONS(2214),
    [anon_sym_column_major] = ACTIONS(2214),
    [anon_sym_globallycoherent] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym_nointerpolation] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_linear] = ACTIONS(2214),
    [anon_sym_snorm] = ACTIONS(2214),
    [anon_sym_unorm] = ACTIONS(2214),
    [anon_sym_point] = ACTIONS(2214),
    [anon_sym_line] = ACTIONS(2214),
    [anon_sym_triangleadj] = ACTIONS(2214),
    [anon_sym_lineadj] = ACTIONS(2214),
    [anon_sym_triangle] = ACTIONS(2214),
    [anon_sym_cbuffer] = ACTIONS(2214),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(2220),
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_include_token1] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AMP_AMP] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_typedef] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_virtual] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym___attribute] = ACTIONS(2218),
    [anon_sym_using] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym___based] = ACTIONS(2218),
    [anon_sym___cdecl] = ACTIONS(2218),
    [anon_sym___clrcall] = ACTIONS(2218),
    [anon_sym___stdcall] = ACTIONS(2218),
    [anon_sym___fastcall] = ACTIONS(2218),
    [anon_sym___thiscall] = ACTIONS(2218),
    [anon_sym___vectorcall] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym__Nonnull] = ACTIONS(2218),
    [anon_sym_mutable] = ACTIONS(2218),
    [anon_sym_constinit] = ACTIONS(2218),
    [anon_sym_consteval] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_goto] = ACTIONS(2218),
    [anon_sym___try] = ACTIONS(2218),
    [anon_sym___leave] = ACTIONS(2218),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_compl] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2218),
    [anon_sym___alignof__] = ACTIONS(2218),
    [anon_sym___alignof] = ACTIONS(2218),
    [anon_sym__alignof] = ACTIONS(2218),
    [anon_sym_alignof] = ACTIONS(2218),
    [anon_sym__Alignof] = ACTIONS(2218),
    [anon_sym_offsetof] = ACTIONS(2218),
    [anon_sym__Generic] = ACTIONS(2218),
    [anon_sym_asm] = ACTIONS(2218),
    [anon_sym___asm__] = ACTIONS(2218),
    [anon_sym___asm] = ACTIONS(2218),
    [sym_number_literal] = ACTIONS(2220),
    [anon_sym_L_SQUOTE] = ACTIONS(2220),
    [anon_sym_u_SQUOTE] = ACTIONS(2220),
    [anon_sym_U_SQUOTE] = ACTIONS(2220),
    [anon_sym_u8_SQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_L_DQUOTE] = ACTIONS(2220),
    [anon_sym_u_DQUOTE] = ACTIONS(2220),
    [anon_sym_U_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8_DQUOTE] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [anon_sym_NULL] = ACTIONS(2218),
    [anon_sym_nullptr] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2218),
    [anon_sym_decltype] = ACTIONS(2218),
    [anon_sym_explicit] = ACTIONS(2218),
    [anon_sym_typename] = ACTIONS(2218),
    [anon_sym_export] = ACTIONS(2218),
    [anon_sym_module] = ACTIONS(2218),
    [anon_sym_import] = ACTIONS(2218),
    [anon_sym_template] = ACTIONS(2218),
    [anon_sym_operator] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_namespace] = ACTIONS(2218),
    [anon_sym_static_assert] = ACTIONS(2218),
    [anon_sym_concept] = ACTIONS(2218),
    [anon_sym_co_return] = ACTIONS(2218),
    [anon_sym_co_yield] = ACTIONS(2218),
    [anon_sym_R_DQUOTE] = ACTIONS(2220),
    [anon_sym_LR_DQUOTE] = ACTIONS(2220),
    [anon_sym_uR_DQUOTE] = ACTIONS(2220),
    [anon_sym_UR_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2220),
    [anon_sym_co_await] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_requires] = ACTIONS(2218),
    [sym_this] = ACTIONS(2218),
    [anon_sym_discard] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_groupshared] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_row_major] = ACTIONS(2218),
    [anon_sym_column_major] = ACTIONS(2218),
    [anon_sym_globallycoherent] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym_nointerpolation] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_linear] = ACTIONS(2218),
    [anon_sym_snorm] = ACTIONS(2218),
    [anon_sym_unorm] = ACTIONS(2218),
    [anon_sym_point] = ACTIONS(2218),
    [anon_sym_line] = ACTIONS(2218),
    [anon_sym_triangleadj] = ACTIONS(2218),
    [anon_sym_lineadj] = ACTIONS(2218),
    [anon_sym_triangle] = ACTIONS(2218),
    [anon_sym_cbuffer] = ACTIONS(2218),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_include_token1] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_typedef] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_virtual] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym___attribute] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2250),
    [anon_sym___cdecl] = ACTIONS(2250),
    [anon_sym___clrcall] = ACTIONS(2250),
    [anon_sym___stdcall] = ACTIONS(2250),
    [anon_sym___fastcall] = ACTIONS(2250),
    [anon_sym___thiscall] = ACTIONS(2250),
    [anon_sym___vectorcall] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_goto] = ACTIONS(2250),
    [anon_sym___try] = ACTIONS(2250),
    [anon_sym___leave] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2250),
    [anon_sym_compl] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2250),
    [anon_sym___alignof__] = ACTIONS(2250),
    [anon_sym___alignof] = ACTIONS(2250),
    [anon_sym__alignof] = ACTIONS(2250),
    [anon_sym_alignof] = ACTIONS(2250),
    [anon_sym__Alignof] = ACTIONS(2250),
    [anon_sym_offsetof] = ACTIONS(2250),
    [anon_sym__Generic] = ACTIONS(2250),
    [anon_sym_asm] = ACTIONS(2250),
    [anon_sym___asm__] = ACTIONS(2250),
    [anon_sym___asm] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2252),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2252),
    [anon_sym_u_DQUOTE] = ACTIONS(2252),
    [anon_sym_U_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [anon_sym_NULL] = ACTIONS(2250),
    [anon_sym_nullptr] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2250),
    [anon_sym_decltype] = ACTIONS(2250),
    [anon_sym_explicit] = ACTIONS(2250),
    [anon_sym_typename] = ACTIONS(2250),
    [anon_sym_export] = ACTIONS(2250),
    [anon_sym_module] = ACTIONS(2250),
    [anon_sym_import] = ACTIONS(2250),
    [anon_sym_template] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_static_assert] = ACTIONS(2250),
    [anon_sym_concept] = ACTIONS(2250),
    [anon_sym_co_return] = ACTIONS(2250),
    [anon_sym_co_yield] = ACTIONS(2250),
    [anon_sym_R_DQUOTE] = ACTIONS(2252),
    [anon_sym_LR_DQUOTE] = ACTIONS(2252),
    [anon_sym_uR_DQUOTE] = ACTIONS(2252),
    [anon_sym_UR_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2252),
    [anon_sym_co_await] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [anon_sym_discard] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_groupshared] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_row_major] = ACTIONS(2250),
    [anon_sym_column_major] = ACTIONS(2250),
    [anon_sym_globallycoherent] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym_nointerpolation] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_linear] = ACTIONS(2250),
    [anon_sym_snorm] = ACTIONS(2250),
    [anon_sym_unorm] = ACTIONS(2250),
    [anon_sym_point] = ACTIONS(2250),
    [anon_sym_line] = ACTIONS(2250),
    [anon_sym_triangleadj] = ACTIONS(2250),
    [anon_sym_lineadj] = ACTIONS(2250),
    [anon_sym_triangle] = ACTIONS(2250),
    [anon_sym_cbuffer] = ACTIONS(2250),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1971),
    [aux_sym_preproc_include_token1] = ACTIONS(1971),
    [aux_sym_preproc_def_token1] = ACTIONS(1971),
    [aux_sym_preproc_if_token1] = ACTIONS(1971),
    [aux_sym_preproc_if_token2] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1971),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1971),
    [sym_preproc_directive] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_typedef] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_using] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_case] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_goto] = ACTIONS(1971),
    [anon_sym___try] = ACTIONS(1971),
    [anon_sym___leave] = ACTIONS(1971),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_sizeof] = ACTIONS(1971),
    [anon_sym___alignof__] = ACTIONS(1971),
    [anon_sym___alignof] = ACTIONS(1971),
    [anon_sym__alignof] = ACTIONS(1971),
    [anon_sym_alignof] = ACTIONS(1971),
    [anon_sym__Alignof] = ACTIONS(1971),
    [anon_sym_offsetof] = ACTIONS(1971),
    [anon_sym__Generic] = ACTIONS(1971),
    [anon_sym_asm] = ACTIONS(1971),
    [anon_sym___asm__] = ACTIONS(1971),
    [anon_sym___asm] = ACTIONS(1971),
    [sym_number_literal] = ACTIONS(1973),
    [anon_sym_L_SQUOTE] = ACTIONS(1973),
    [anon_sym_u_SQUOTE] = ACTIONS(1973),
    [anon_sym_U_SQUOTE] = ACTIONS(1973),
    [anon_sym_u8_SQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [anon_sym_L_DQUOTE] = ACTIONS(1973),
    [anon_sym_u_DQUOTE] = ACTIONS(1973),
    [anon_sym_U_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8_DQUOTE] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [anon_sym_NULL] = ACTIONS(1971),
    [anon_sym_nullptr] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_explicit] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1971),
    [anon_sym_static_assert] = ACTIONS(1971),
    [anon_sym_concept] = ACTIONS(1971),
    [anon_sym_co_return] = ACTIONS(1971),
    [anon_sym_co_yield] = ACTIONS(1971),
    [anon_sym_R_DQUOTE] = ACTIONS(1973),
    [anon_sym_LR_DQUOTE] = ACTIONS(1973),
    [anon_sym_uR_DQUOTE] = ACTIONS(1973),
    [anon_sym_UR_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1973),
    [anon_sym_co_await] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [sym_this] = ACTIONS(1971),
    [anon_sym_discard] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
    [anon_sym_cbuffer] = ACTIONS(1971),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1975),
    [aux_sym_preproc_include_token1] = ACTIONS(1975),
    [aux_sym_preproc_def_token1] = ACTIONS(1975),
    [aux_sym_preproc_if_token1] = ACTIONS(1975),
    [aux_sym_preproc_if_token2] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1975),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1975),
    [sym_preproc_directive] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_typedef] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_using] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_case] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1975),
    [anon_sym___try] = ACTIONS(1975),
    [anon_sym___leave] = ACTIONS(1975),
    [anon_sym_not] = ACTIONS(1975),
    [anon_sym_compl] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_sizeof] = ACTIONS(1975),
    [anon_sym___alignof__] = ACTIONS(1975),
    [anon_sym___alignof] = ACTIONS(1975),
    [anon_sym__alignof] = ACTIONS(1975),
    [anon_sym_alignof] = ACTIONS(1975),
    [anon_sym__Alignof] = ACTIONS(1975),
    [anon_sym_offsetof] = ACTIONS(1975),
    [anon_sym__Generic] = ACTIONS(1975),
    [anon_sym_asm] = ACTIONS(1975),
    [anon_sym___asm__] = ACTIONS(1975),
    [anon_sym___asm] = ACTIONS(1975),
    [sym_number_literal] = ACTIONS(1977),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1977),
    [anon_sym_u_DQUOTE] = ACTIONS(1977),
    [anon_sym_U_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [anon_sym_NULL] = ACTIONS(1975),
    [anon_sym_nullptr] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_explicit] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_namespace] = ACTIONS(1975),
    [anon_sym_static_assert] = ACTIONS(1975),
    [anon_sym_concept] = ACTIONS(1975),
    [anon_sym_co_return] = ACTIONS(1975),
    [anon_sym_co_yield] = ACTIONS(1975),
    [anon_sym_R_DQUOTE] = ACTIONS(1977),
    [anon_sym_LR_DQUOTE] = ACTIONS(1977),
    [anon_sym_uR_DQUOTE] = ACTIONS(1977),
    [anon_sym_UR_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1977),
    [anon_sym_co_await] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [sym_this] = ACTIONS(1975),
    [anon_sym_discard] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
    [anon_sym_cbuffer] = ACTIONS(1975),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1953),
    [aux_sym_preproc_include_token1] = ACTIONS(1953),
    [aux_sym_preproc_def_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token1] = ACTIONS(1953),
    [aux_sym_preproc_if_token2] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1953),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1953),
    [sym_preproc_directive] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_typedef] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_using] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_case] = ACTIONS(1953),
    [anon_sym_default] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_goto] = ACTIONS(1953),
    [anon_sym___try] = ACTIONS(1953),
    [anon_sym___leave] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1953),
    [anon_sym_compl] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1953),
    [anon_sym___alignof__] = ACTIONS(1953),
    [anon_sym___alignof] = ACTIONS(1953),
    [anon_sym__alignof] = ACTIONS(1953),
    [anon_sym_alignof] = ACTIONS(1953),
    [anon_sym__Alignof] = ACTIONS(1953),
    [anon_sym_offsetof] = ACTIONS(1953),
    [anon_sym__Generic] = ACTIONS(1953),
    [anon_sym_asm] = ACTIONS(1953),
    [anon_sym___asm__] = ACTIONS(1953),
    [anon_sym___asm] = ACTIONS(1953),
    [sym_number_literal] = ACTIONS(1955),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [anon_sym_NULL] = ACTIONS(1953),
    [anon_sym_nullptr] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_explicit] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_namespace] = ACTIONS(1953),
    [anon_sym_static_assert] = ACTIONS(1953),
    [anon_sym_concept] = ACTIONS(1953),
    [anon_sym_co_return] = ACTIONS(1953),
    [anon_sym_co_yield] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [sym_this] = ACTIONS(1953),
    [anon_sym_discard] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
    [anon_sym_cbuffer] = ACTIONS(1953),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1979),
    [aux_sym_preproc_include_token1] = ACTIONS(1979),
    [aux_sym_preproc_def_token1] = ACTIONS(1979),
    [aux_sym_preproc_if_token1] = ACTIONS(1979),
    [aux_sym_preproc_if_token2] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1979),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1979),
    [sym_preproc_directive] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_typedef] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym___try] = ACTIONS(1979),
    [anon_sym___leave] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1979),
    [anon_sym_compl] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym___alignof__] = ACTIONS(1979),
    [anon_sym___alignof] = ACTIONS(1979),
    [anon_sym__alignof] = ACTIONS(1979),
    [anon_sym_alignof] = ACTIONS(1979),
    [anon_sym__Alignof] = ACTIONS(1979),
    [anon_sym_offsetof] = ACTIONS(1979),
    [anon_sym__Generic] = ACTIONS(1979),
    [anon_sym_asm] = ACTIONS(1979),
    [anon_sym___asm__] = ACTIONS(1979),
    [anon_sym___asm] = ACTIONS(1979),
    [sym_number_literal] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1981),
    [anon_sym_u_SQUOTE] = ACTIONS(1981),
    [anon_sym_U_SQUOTE] = ACTIONS(1981),
    [anon_sym_u8_SQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [anon_sym_L_DQUOTE] = ACTIONS(1981),
    [anon_sym_u_DQUOTE] = ACTIONS(1981),
    [anon_sym_U_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [anon_sym_NULL] = ACTIONS(1979),
    [anon_sym_nullptr] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_static_assert] = ACTIONS(1979),
    [anon_sym_concept] = ACTIONS(1979),
    [anon_sym_co_return] = ACTIONS(1979),
    [anon_sym_co_yield] = ACTIONS(1979),
    [anon_sym_R_DQUOTE] = ACTIONS(1981),
    [anon_sym_LR_DQUOTE] = ACTIONS(1981),
    [anon_sym_uR_DQUOTE] = ACTIONS(1981),
    [anon_sym_UR_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1981),
    [anon_sym_co_await] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [sym_this] = ACTIONS(1979),
    [anon_sym_discard] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
    [anon_sym_cbuffer] = ACTIONS(1979),
  },
  [337] = {
    [sym_identifier] = ACTIONS(1983),
    [aux_sym_preproc_include_token1] = ACTIONS(1983),
    [aux_sym_preproc_def_token1] = ACTIONS(1983),
    [aux_sym_preproc_if_token1] = ACTIONS(1983),
    [aux_sym_preproc_if_token2] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1983),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1983),
    [sym_preproc_directive] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_using] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_case] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_goto] = ACTIONS(1983),
    [anon_sym___try] = ACTIONS(1983),
    [anon_sym___leave] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1983),
    [anon_sym_compl] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_sizeof] = ACTIONS(1983),
    [anon_sym___alignof__] = ACTIONS(1983),
    [anon_sym___alignof] = ACTIONS(1983),
    [anon_sym__alignof] = ACTIONS(1983),
    [anon_sym_alignof] = ACTIONS(1983),
    [anon_sym__Alignof] = ACTIONS(1983),
    [anon_sym_offsetof] = ACTIONS(1983),
    [anon_sym__Generic] = ACTIONS(1983),
    [anon_sym_asm] = ACTIONS(1983),
    [anon_sym___asm__] = ACTIONS(1983),
    [anon_sym___asm] = ACTIONS(1983),
    [sym_number_literal] = ACTIONS(1985),
    [anon_sym_L_SQUOTE] = ACTIONS(1985),
    [anon_sym_u_SQUOTE] = ACTIONS(1985),
    [anon_sym_U_SQUOTE] = ACTIONS(1985),
    [anon_sym_u8_SQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [anon_sym_NULL] = ACTIONS(1983),
    [anon_sym_nullptr] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_namespace] = ACTIONS(1983),
    [anon_sym_static_assert] = ACTIONS(1983),
    [anon_sym_concept] = ACTIONS(1983),
    [anon_sym_co_return] = ACTIONS(1983),
    [anon_sym_co_yield] = ACTIONS(1983),
    [anon_sym_R_DQUOTE] = ACTIONS(1985),
    [anon_sym_LR_DQUOTE] = ACTIONS(1985),
    [anon_sym_uR_DQUOTE] = ACTIONS(1985),
    [anon_sym_UR_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1985),
    [anon_sym_co_await] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [sym_this] = ACTIONS(1983),
    [anon_sym_discard] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
    [anon_sym_cbuffer] = ACTIONS(1983),
  },
  [338] = {
    [sym_identifier] = ACTIONS(1991),
    [aux_sym_preproc_include_token1] = ACTIONS(1991),
    [aux_sym_preproc_def_token1] = ACTIONS(1991),
    [aux_sym_preproc_if_token1] = ACTIONS(1991),
    [aux_sym_preproc_if_token2] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1991),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1991),
    [sym_preproc_directive] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_typedef] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_using] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_case] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_goto] = ACTIONS(1991),
    [anon_sym___try] = ACTIONS(1991),
    [anon_sym___leave] = ACTIONS(1991),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_sizeof] = ACTIONS(1991),
    [anon_sym___alignof__] = ACTIONS(1991),
    [anon_sym___alignof] = ACTIONS(1991),
    [anon_sym__alignof] = ACTIONS(1991),
    [anon_sym_alignof] = ACTIONS(1991),
    [anon_sym__Alignof] = ACTIONS(1991),
    [anon_sym_offsetof] = ACTIONS(1991),
    [anon_sym__Generic] = ACTIONS(1991),
    [anon_sym_asm] = ACTIONS(1991),
    [anon_sym___asm__] = ACTIONS(1991),
    [anon_sym___asm] = ACTIONS(1991),
    [sym_number_literal] = ACTIONS(1993),
    [anon_sym_L_SQUOTE] = ACTIONS(1993),
    [anon_sym_u_SQUOTE] = ACTIONS(1993),
    [anon_sym_U_SQUOTE] = ACTIONS(1993),
    [anon_sym_u8_SQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_L_DQUOTE] = ACTIONS(1993),
    [anon_sym_u_DQUOTE] = ACTIONS(1993),
    [anon_sym_U_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [anon_sym_NULL] = ACTIONS(1991),
    [anon_sym_nullptr] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_explicit] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_namespace] = ACTIONS(1991),
    [anon_sym_static_assert] = ACTIONS(1991),
    [anon_sym_concept] = ACTIONS(1991),
    [anon_sym_co_return] = ACTIONS(1991),
    [anon_sym_co_yield] = ACTIONS(1991),
    [anon_sym_R_DQUOTE] = ACTIONS(1993),
    [anon_sym_LR_DQUOTE] = ACTIONS(1993),
    [anon_sym_uR_DQUOTE] = ACTIONS(1993),
    [anon_sym_UR_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1993),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [sym_this] = ACTIONS(1991),
    [anon_sym_discard] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
    [anon_sym_cbuffer] = ACTIONS(1991),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1987),
    [aux_sym_preproc_include_token1] = ACTIONS(1987),
    [aux_sym_preproc_def_token1] = ACTIONS(1987),
    [aux_sym_preproc_if_token1] = ACTIONS(1987),
    [aux_sym_preproc_if_token2] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1987),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1987),
    [sym_preproc_directive] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_typedef] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_using] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_case] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_goto] = ACTIONS(1987),
    [anon_sym___try] = ACTIONS(1987),
    [anon_sym___leave] = ACTIONS(1987),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_compl] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_sizeof] = ACTIONS(1987),
    [anon_sym___alignof__] = ACTIONS(1987),
    [anon_sym___alignof] = ACTIONS(1987),
    [anon_sym__alignof] = ACTIONS(1987),
    [anon_sym_alignof] = ACTIONS(1987),
    [anon_sym__Alignof] = ACTIONS(1987),
    [anon_sym_offsetof] = ACTIONS(1987),
    [anon_sym__Generic] = ACTIONS(1987),
    [anon_sym_asm] = ACTIONS(1987),
    [anon_sym___asm__] = ACTIONS(1987),
    [anon_sym___asm] = ACTIONS(1987),
    [sym_number_literal] = ACTIONS(1989),
    [anon_sym_L_SQUOTE] = ACTIONS(1989),
    [anon_sym_u_SQUOTE] = ACTIONS(1989),
    [anon_sym_U_SQUOTE] = ACTIONS(1989),
    [anon_sym_u8_SQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [anon_sym_L_DQUOTE] = ACTIONS(1989),
    [anon_sym_u_DQUOTE] = ACTIONS(1989),
    [anon_sym_U_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8_DQUOTE] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [anon_sym_NULL] = ACTIONS(1987),
    [anon_sym_nullptr] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_namespace] = ACTIONS(1987),
    [anon_sym_static_assert] = ACTIONS(1987),
    [anon_sym_concept] = ACTIONS(1987),
    [anon_sym_co_return] = ACTIONS(1987),
    [anon_sym_co_yield] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [sym_this] = ACTIONS(1987),
    [anon_sym_discard] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
    [anon_sym_cbuffer] = ACTIONS(1987),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(2256),
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_include_token1] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_typedef] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_virtual] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym___attribute] = ACTIONS(2254),
    [anon_sym_using] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym___based] = ACTIONS(2254),
    [anon_sym___cdecl] = ACTIONS(2254),
    [anon_sym___clrcall] = ACTIONS(2254),
    [anon_sym___stdcall] = ACTIONS(2254),
    [anon_sym___fastcall] = ACTIONS(2254),
    [anon_sym___thiscall] = ACTIONS(2254),
    [anon_sym___vectorcall] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym__Nonnull] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_class] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2254),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_do] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2254),
    [anon_sym___try] = ACTIONS(2254),
    [anon_sym___leave] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_compl] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2254),
    [anon_sym___alignof__] = ACTIONS(2254),
    [anon_sym___alignof] = ACTIONS(2254),
    [anon_sym__alignof] = ACTIONS(2254),
    [anon_sym_alignof] = ACTIONS(2254),
    [anon_sym__Alignof] = ACTIONS(2254),
    [anon_sym_offsetof] = ACTIONS(2254),
    [anon_sym__Generic] = ACTIONS(2254),
    [anon_sym_asm] = ACTIONS(2254),
    [anon_sym___asm__] = ACTIONS(2254),
    [anon_sym___asm] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_L_SQUOTE] = ACTIONS(2256),
    [anon_sym_u_SQUOTE] = ACTIONS(2256),
    [anon_sym_U_SQUOTE] = ACTIONS(2256),
    [anon_sym_u8_SQUOTE] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_L_DQUOTE] = ACTIONS(2256),
    [anon_sym_u_DQUOTE] = ACTIONS(2256),
    [anon_sym_U_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8_DQUOTE] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2256),
    [sym_true] = ACTIONS(2254),
    [sym_false] = ACTIONS(2254),
    [anon_sym_NULL] = ACTIONS(2254),
    [anon_sym_nullptr] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2254),
    [anon_sym_decltype] = ACTIONS(2254),
    [anon_sym_explicit] = ACTIONS(2254),
    [anon_sym_typename] = ACTIONS(2254),
    [anon_sym_export] = ACTIONS(2254),
    [anon_sym_module] = ACTIONS(2254),
    [anon_sym_import] = ACTIONS(2254),
    [anon_sym_template] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [anon_sym_delete] = ACTIONS(2254),
    [anon_sym_throw] = ACTIONS(2254),
    [anon_sym_namespace] = ACTIONS(2254),
    [anon_sym_static_assert] = ACTIONS(2254),
    [anon_sym_concept] = ACTIONS(2254),
    [anon_sym_co_return] = ACTIONS(2254),
    [anon_sym_co_yield] = ACTIONS(2254),
    [anon_sym_R_DQUOTE] = ACTIONS(2256),
    [anon_sym_LR_DQUOTE] = ACTIONS(2256),
    [anon_sym_uR_DQUOTE] = ACTIONS(2256),
    [anon_sym_UR_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2256),
    [anon_sym_co_await] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2254),
    [sym_this] = ACTIONS(2254),
    [anon_sym_discard] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_groupshared] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_row_major] = ACTIONS(2254),
    [anon_sym_column_major] = ACTIONS(2254),
    [anon_sym_globallycoherent] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym_nointerpolation] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_linear] = ACTIONS(2254),
    [anon_sym_snorm] = ACTIONS(2254),
    [anon_sym_unorm] = ACTIONS(2254),
    [anon_sym_point] = ACTIONS(2254),
    [anon_sym_line] = ACTIONS(2254),
    [anon_sym_triangleadj] = ACTIONS(2254),
    [anon_sym_lineadj] = ACTIONS(2254),
    [anon_sym_triangle] = ACTIONS(2254),
    [anon_sym_cbuffer] = ACTIONS(2254),
  },
  [341] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [aux_sym_preproc_else_token1] = ACTIONS(2462),
    [aux_sym_preproc_elif_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(2264),
    [sym_identifier] = ACTIONS(2262),
    [aux_sym_preproc_include_token1] = ACTIONS(2262),
    [aux_sym_preproc_def_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [sym_preproc_directive] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym_typedef] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2262),
    [anon_sym_out] = ACTIONS(2262),
    [anon_sym_inout] = ACTIONS(2262),
    [anon_sym_virtual] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2262),
    [anon_sym_using] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2264),
    [anon_sym___declspec] = ACTIONS(2262),
    [anon_sym___based] = ACTIONS(2262),
    [anon_sym___cdecl] = ACTIONS(2262),
    [anon_sym___clrcall] = ACTIONS(2262),
    [anon_sym___stdcall] = ACTIONS(2262),
    [anon_sym___fastcall] = ACTIONS(2262),
    [anon_sym___thiscall] = ACTIONS(2262),
    [anon_sym___vectorcall] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2262),
    [anon_sym_unsigned] = ACTIONS(2262),
    [anon_sym_long] = ACTIONS(2262),
    [anon_sym_short] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2262),
    [anon_sym_inline] = ACTIONS(2262),
    [anon_sym___inline] = ACTIONS(2262),
    [anon_sym___inline__] = ACTIONS(2262),
    [anon_sym___forceinline] = ACTIONS(2262),
    [anon_sym_thread_local] = ACTIONS(2262),
    [anon_sym___thread] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [sym_primitive_type] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_class] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2262),
    [anon_sym_default] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_goto] = ACTIONS(2262),
    [anon_sym___try] = ACTIONS(2262),
    [anon_sym___leave] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2262),
    [anon_sym_compl] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2262),
    [anon_sym___alignof__] = ACTIONS(2262),
    [anon_sym___alignof] = ACTIONS(2262),
    [anon_sym__alignof] = ACTIONS(2262),
    [anon_sym_alignof] = ACTIONS(2262),
    [anon_sym__Alignof] = ACTIONS(2262),
    [anon_sym_offsetof] = ACTIONS(2262),
    [anon_sym__Generic] = ACTIONS(2262),
    [anon_sym_asm] = ACTIONS(2262),
    [anon_sym___asm__] = ACTIONS(2262),
    [anon_sym___asm] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2264),
    [anon_sym_L_SQUOTE] = ACTIONS(2264),
    [anon_sym_u_SQUOTE] = ACTIONS(2264),
    [anon_sym_U_SQUOTE] = ACTIONS(2264),
    [anon_sym_u8_SQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_L_DQUOTE] = ACTIONS(2264),
    [anon_sym_u_DQUOTE] = ACTIONS(2264),
    [anon_sym_U_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8_DQUOTE] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [anon_sym_NULL] = ACTIONS(2262),
    [anon_sym_nullptr] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2262),
    [anon_sym_decltype] = ACTIONS(2262),
    [anon_sym_explicit] = ACTIONS(2262),
    [anon_sym_typename] = ACTIONS(2262),
    [anon_sym_export] = ACTIONS(2262),
    [anon_sym_module] = ACTIONS(2262),
    [anon_sym_import] = ACTIONS(2262),
    [anon_sym_template] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [anon_sym_delete] = ACTIONS(2262),
    [anon_sym_throw] = ACTIONS(2262),
    [anon_sym_namespace] = ACTIONS(2262),
    [anon_sym_static_assert] = ACTIONS(2262),
    [anon_sym_concept] = ACTIONS(2262),
    [anon_sym_co_return] = ACTIONS(2262),
    [anon_sym_co_yield] = ACTIONS(2262),
    [anon_sym_R_DQUOTE] = ACTIONS(2264),
    [anon_sym_LR_DQUOTE] = ACTIONS(2264),
    [anon_sym_uR_DQUOTE] = ACTIONS(2264),
    [anon_sym_UR_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2264),
    [anon_sym_co_await] = ACTIONS(2262),
    [anon_sym_new] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2262),
    [sym_this] = ACTIONS(2262),
    [anon_sym_discard] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2262),
    [anon_sym_shared] = ACTIONS(2262),
    [anon_sym_groupshared] = ACTIONS(2262),
    [anon_sym_uniform] = ACTIONS(2262),
    [anon_sym_row_major] = ACTIONS(2262),
    [anon_sym_column_major] = ACTIONS(2262),
    [anon_sym_globallycoherent] = ACTIONS(2262),
    [anon_sym_centroid] = ACTIONS(2262),
    [anon_sym_noperspective] = ACTIONS(2262),
    [anon_sym_nointerpolation] = ACTIONS(2262),
    [anon_sym_sample] = ACTIONS(2262),
    [anon_sym_linear] = ACTIONS(2262),
    [anon_sym_snorm] = ACTIONS(2262),
    [anon_sym_unorm] = ACTIONS(2262),
    [anon_sym_point] = ACTIONS(2262),
    [anon_sym_line] = ACTIONS(2262),
    [anon_sym_triangleadj] = ACTIONS(2262),
    [anon_sym_lineadj] = ACTIONS(2262),
    [anon_sym_triangle] = ACTIONS(2262),
    [anon_sym_cbuffer] = ACTIONS(2262),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(2280),
    [sym_identifier] = ACTIONS(2278),
    [aux_sym_preproc_include_token1] = ACTIONS(2278),
    [aux_sym_preproc_def_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2278),
    [sym_preproc_directive] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_PLUS] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym_typedef] = ACTIONS(2278),
    [anon_sym_in] = ACTIONS(2278),
    [anon_sym_out] = ACTIONS(2278),
    [anon_sym_inout] = ACTIONS(2278),
    [anon_sym_virtual] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2278),
    [anon_sym_using] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2280),
    [anon_sym___declspec] = ACTIONS(2278),
    [anon_sym___based] = ACTIONS(2278),
    [anon_sym___cdecl] = ACTIONS(2278),
    [anon_sym___clrcall] = ACTIONS(2278),
    [anon_sym___stdcall] = ACTIONS(2278),
    [anon_sym___fastcall] = ACTIONS(2278),
    [anon_sym___thiscall] = ACTIONS(2278),
    [anon_sym___vectorcall] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2278),
    [anon_sym_unsigned] = ACTIONS(2278),
    [anon_sym_long] = ACTIONS(2278),
    [anon_sym_short] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2278),
    [anon_sym_inline] = ACTIONS(2278),
    [anon_sym___inline] = ACTIONS(2278),
    [anon_sym___inline__] = ACTIONS(2278),
    [anon_sym___forceinline] = ACTIONS(2278),
    [anon_sym_thread_local] = ACTIONS(2278),
    [anon_sym___thread] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [sym_primitive_type] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_class] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2278),
    [anon_sym_default] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_do] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_goto] = ACTIONS(2278),
    [anon_sym___try] = ACTIONS(2278),
    [anon_sym___leave] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2278),
    [anon_sym_compl] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2278),
    [anon_sym___alignof__] = ACTIONS(2278),
    [anon_sym___alignof] = ACTIONS(2278),
    [anon_sym__alignof] = ACTIONS(2278),
    [anon_sym_alignof] = ACTIONS(2278),
    [anon_sym__Alignof] = ACTIONS(2278),
    [anon_sym_offsetof] = ACTIONS(2278),
    [anon_sym__Generic] = ACTIONS(2278),
    [anon_sym_asm] = ACTIONS(2278),
    [anon_sym___asm__] = ACTIONS(2278),
    [anon_sym___asm] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2280),
    [anon_sym_L_SQUOTE] = ACTIONS(2280),
    [anon_sym_u_SQUOTE] = ACTIONS(2280),
    [anon_sym_U_SQUOTE] = ACTIONS(2280),
    [anon_sym_u8_SQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_L_DQUOTE] = ACTIONS(2280),
    [anon_sym_u_DQUOTE] = ACTIONS(2280),
    [anon_sym_U_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8_DQUOTE] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [anon_sym_NULL] = ACTIONS(2278),
    [anon_sym_nullptr] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2278),
    [anon_sym_decltype] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_typename] = ACTIONS(2278),
    [anon_sym_export] = ACTIONS(2278),
    [anon_sym_module] = ACTIONS(2278),
    [anon_sym_import] = ACTIONS(2278),
    [anon_sym_template] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [anon_sym_delete] = ACTIONS(2278),
    [anon_sym_throw] = ACTIONS(2278),
    [anon_sym_namespace] = ACTIONS(2278),
    [anon_sym_static_assert] = ACTIONS(2278),
    [anon_sym_concept] = ACTIONS(2278),
    [anon_sym_co_return] = ACTIONS(2278),
    [anon_sym_co_yield] = ACTIONS(2278),
    [anon_sym_R_DQUOTE] = ACTIONS(2280),
    [anon_sym_LR_DQUOTE] = ACTIONS(2280),
    [anon_sym_uR_DQUOTE] = ACTIONS(2280),
    [anon_sym_UR_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2280),
    [anon_sym_co_await] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2278),
    [sym_this] = ACTIONS(2278),
    [anon_sym_discard] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2278),
    [anon_sym_shared] = ACTIONS(2278),
    [anon_sym_groupshared] = ACTIONS(2278),
    [anon_sym_uniform] = ACTIONS(2278),
    [anon_sym_row_major] = ACTIONS(2278),
    [anon_sym_column_major] = ACTIONS(2278),
    [anon_sym_globallycoherent] = ACTIONS(2278),
    [anon_sym_centroid] = ACTIONS(2278),
    [anon_sym_noperspective] = ACTIONS(2278),
    [anon_sym_nointerpolation] = ACTIONS(2278),
    [anon_sym_sample] = ACTIONS(2278),
    [anon_sym_linear] = ACTIONS(2278),
    [anon_sym_snorm] = ACTIONS(2278),
    [anon_sym_unorm] = ACTIONS(2278),
    [anon_sym_point] = ACTIONS(2278),
    [anon_sym_line] = ACTIONS(2278),
    [anon_sym_triangleadj] = ACTIONS(2278),
    [anon_sym_lineadj] = ACTIONS(2278),
    [anon_sym_triangle] = ACTIONS(2278),
    [anon_sym_cbuffer] = ACTIONS(2278),
  },
  [344] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_include_token1] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token2] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [aux_sym_preproc_else_token1] = ACTIONS(2466),
    [aux_sym_preproc_elif_token1] = ACTIONS(2466),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym___cdecl] = ACTIONS(2466),
    [anon_sym___clrcall] = ACTIONS(2466),
    [anon_sym___stdcall] = ACTIONS(2466),
    [anon_sym___fastcall] = ACTIONS(2466),
    [anon_sym___thiscall] = ACTIONS(2466),
    [anon_sym___vectorcall] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym___try] = ACTIONS(2466),
    [anon_sym___leave] = ACTIONS(2466),
    [anon_sym_not] = ACTIONS(2466),
    [anon_sym_compl] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym___alignof__] = ACTIONS(2466),
    [anon_sym___alignof] = ACTIONS(2466),
    [anon_sym__alignof] = ACTIONS(2466),
    [anon_sym_alignof] = ACTIONS(2466),
    [anon_sym__Alignof] = ACTIONS(2466),
    [anon_sym_offsetof] = ACTIONS(2466),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2466),
    [anon_sym___asm__] = ACTIONS(2466),
    [anon_sym___asm] = ACTIONS(2466),
    [sym_number_literal] = ACTIONS(2468),
    [anon_sym_L_SQUOTE] = ACTIONS(2468),
    [anon_sym_u_SQUOTE] = ACTIONS(2468),
    [anon_sym_U_SQUOTE] = ACTIONS(2468),
    [anon_sym_u8_SQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_L_DQUOTE] = ACTIONS(2468),
    [anon_sym_u_DQUOTE] = ACTIONS(2468),
    [anon_sym_U_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [anon_sym_NULL] = ACTIONS(2466),
    [anon_sym_nullptr] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_concept] = ACTIONS(2466),
    [anon_sym_co_return] = ACTIONS(2466),
    [anon_sym_co_yield] = ACTIONS(2466),
    [anon_sym_R_DQUOTE] = ACTIONS(2468),
    [anon_sym_LR_DQUOTE] = ACTIONS(2468),
    [anon_sym_uR_DQUOTE] = ACTIONS(2468),
    [anon_sym_UR_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2468),
    [anon_sym_co_await] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_requires] = ACTIONS(2466),
    [sym_this] = ACTIONS(2466),
    [anon_sym_discard] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
    [anon_sym_cbuffer] = ACTIONS(2466),
  },
  [345] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_include_token1] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token2] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [aux_sym_preproc_else_token1] = ACTIONS(2470),
    [aux_sym_preproc_elif_token1] = ACTIONS(2470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym___cdecl] = ACTIONS(2470),
    [anon_sym___clrcall] = ACTIONS(2470),
    [anon_sym___stdcall] = ACTIONS(2470),
    [anon_sym___fastcall] = ACTIONS(2470),
    [anon_sym___thiscall] = ACTIONS(2470),
    [anon_sym___vectorcall] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym___try] = ACTIONS(2470),
    [anon_sym___leave] = ACTIONS(2470),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_compl] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym___alignof__] = ACTIONS(2470),
    [anon_sym___alignof] = ACTIONS(2470),
    [anon_sym__alignof] = ACTIONS(2470),
    [anon_sym_alignof] = ACTIONS(2470),
    [anon_sym__Alignof] = ACTIONS(2470),
    [anon_sym_offsetof] = ACTIONS(2470),
    [anon_sym__Generic] = ACTIONS(2470),
    [anon_sym_asm] = ACTIONS(2470),
    [anon_sym___asm__] = ACTIONS(2470),
    [anon_sym___asm] = ACTIONS(2470),
    [sym_number_literal] = ACTIONS(2472),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2472),
    [anon_sym_u_DQUOTE] = ACTIONS(2472),
    [anon_sym_U_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [anon_sym_NULL] = ACTIONS(2470),
    [anon_sym_nullptr] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_concept] = ACTIONS(2470),
    [anon_sym_co_return] = ACTIONS(2470),
    [anon_sym_co_yield] = ACTIONS(2470),
    [anon_sym_R_DQUOTE] = ACTIONS(2472),
    [anon_sym_LR_DQUOTE] = ACTIONS(2472),
    [anon_sym_uR_DQUOTE] = ACTIONS(2472),
    [anon_sym_UR_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2472),
    [anon_sym_co_await] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_requires] = ACTIONS(2470),
    [sym_this] = ACTIONS(2470),
    [anon_sym_discard] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
    [anon_sym_cbuffer] = ACTIONS(2470),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(2161),
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_export] = ACTIONS(2159),
    [anon_sym_module] = ACTIONS(2159),
    [anon_sym_import] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [347] = {
    [sym_identifier] = ACTIONS(2474),
    [aux_sym_preproc_include_token1] = ACTIONS(2474),
    [aux_sym_preproc_def_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token2] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2474),
    [aux_sym_preproc_else_token1] = ACTIONS(2474),
    [aux_sym_preproc_elif_token1] = ACTIONS(2474),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2474),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2474),
    [sym_preproc_directive] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2474),
    [anon_sym_typedef] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_out] = ACTIONS(2474),
    [anon_sym_inout] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym___attribute__] = ACTIONS(2474),
    [anon_sym___attribute] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2474),
    [anon_sym___based] = ACTIONS(2474),
    [anon_sym___cdecl] = ACTIONS(2474),
    [anon_sym___clrcall] = ACTIONS(2474),
    [anon_sym___stdcall] = ACTIONS(2474),
    [anon_sym___fastcall] = ACTIONS(2474),
    [anon_sym___thiscall] = ACTIONS(2474),
    [anon_sym___vectorcall] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2474),
    [anon_sym_unsigned] = ACTIONS(2474),
    [anon_sym_long] = ACTIONS(2474),
    [anon_sym_short] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_register] = ACTIONS(2474),
    [anon_sym_inline] = ACTIONS(2474),
    [anon_sym___inline] = ACTIONS(2474),
    [anon_sym___inline__] = ACTIONS(2474),
    [anon_sym___forceinline] = ACTIONS(2474),
    [anon_sym_thread_local] = ACTIONS(2474),
    [anon_sym___thread] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_constexpr] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_restrict] = ACTIONS(2474),
    [anon_sym___restrict__] = ACTIONS(2474),
    [anon_sym__Atomic] = ACTIONS(2474),
    [anon_sym__Noreturn] = ACTIONS(2474),
    [anon_sym_noreturn] = ACTIONS(2474),
    [anon_sym__Nonnull] = ACTIONS(2474),
    [anon_sym_mutable] = ACTIONS(2474),
    [anon_sym_constinit] = ACTIONS(2474),
    [anon_sym_consteval] = ACTIONS(2474),
    [anon_sym_alignas] = ACTIONS(2474),
    [anon_sym__Alignas] = ACTIONS(2474),
    [sym_primitive_type] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym___try] = ACTIONS(2474),
    [anon_sym___leave] = ACTIONS(2474),
    [anon_sym_not] = ACTIONS(2474),
    [anon_sym_compl] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym___alignof__] = ACTIONS(2474),
    [anon_sym___alignof] = ACTIONS(2474),
    [anon_sym__alignof] = ACTIONS(2474),
    [anon_sym_alignof] = ACTIONS(2474),
    [anon_sym__Alignof] = ACTIONS(2474),
    [anon_sym_offsetof] = ACTIONS(2474),
    [anon_sym__Generic] = ACTIONS(2474),
    [anon_sym_asm] = ACTIONS(2474),
    [anon_sym___asm__] = ACTIONS(2474),
    [anon_sym___asm] = ACTIONS(2474),
    [sym_number_literal] = ACTIONS(2477),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [anon_sym_NULL] = ACTIONS(2474),
    [anon_sym_nullptr] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2474),
    [anon_sym_decltype] = ACTIONS(2474),
    [anon_sym_explicit] = ACTIONS(2474),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_template] = ACTIONS(2474),
    [anon_sym_operator] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_static_assert] = ACTIONS(2474),
    [anon_sym_concept] = ACTIONS(2474),
    [anon_sym_co_return] = ACTIONS(2474),
    [anon_sym_co_yield] = ACTIONS(2474),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_requires] = ACTIONS(2474),
    [sym_this] = ACTIONS(2474),
    [anon_sym_discard] = ACTIONS(2474),
    [anon_sym_precise] = ACTIONS(2474),
    [anon_sym_shared] = ACTIONS(2474),
    [anon_sym_groupshared] = ACTIONS(2474),
    [anon_sym_uniform] = ACTIONS(2474),
    [anon_sym_row_major] = ACTIONS(2474),
    [anon_sym_column_major] = ACTIONS(2474),
    [anon_sym_globallycoherent] = ACTIONS(2474),
    [anon_sym_centroid] = ACTIONS(2474),
    [anon_sym_noperspective] = ACTIONS(2474),
    [anon_sym_nointerpolation] = ACTIONS(2474),
    [anon_sym_sample] = ACTIONS(2474),
    [anon_sym_linear] = ACTIONS(2474),
    [anon_sym_snorm] = ACTIONS(2474),
    [anon_sym_unorm] = ACTIONS(2474),
    [anon_sym_point] = ACTIONS(2474),
    [anon_sym_line] = ACTIONS(2474),
    [anon_sym_triangleadj] = ACTIONS(2474),
    [anon_sym_lineadj] = ACTIONS(2474),
    [anon_sym_triangle] = ACTIONS(2474),
    [anon_sym_cbuffer] = ACTIONS(2474),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2346),
    [aux_sym_preproc_include_token1] = ACTIONS(2346),
    [aux_sym_preproc_def_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2346),
    [sym_preproc_directive] = ACTIONS(2346),
    [anon_sym_LPAREN2] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_typedef] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_out] = ACTIONS(2346),
    [anon_sym_inout] = ACTIONS(2346),
    [anon_sym_virtual] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym___attribute__] = ACTIONS(2346),
    [anon_sym___attribute] = ACTIONS(2346),
    [anon_sym_using] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2346),
    [anon_sym___based] = ACTIONS(2346),
    [anon_sym___cdecl] = ACTIONS(2346),
    [anon_sym___clrcall] = ACTIONS(2346),
    [anon_sym___stdcall] = ACTIONS(2346),
    [anon_sym___fastcall] = ACTIONS(2346),
    [anon_sym___thiscall] = ACTIONS(2346),
    [anon_sym___vectorcall] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_signed] = ACTIONS(2346),
    [anon_sym_unsigned] = ACTIONS(2346),
    [anon_sym_long] = ACTIONS(2346),
    [anon_sym_short] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_register] = ACTIONS(2346),
    [anon_sym_inline] = ACTIONS(2346),
    [anon_sym___inline] = ACTIONS(2346),
    [anon_sym___inline__] = ACTIONS(2346),
    [anon_sym___forceinline] = ACTIONS(2346),
    [anon_sym_thread_local] = ACTIONS(2346),
    [anon_sym___thread] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_constexpr] = ACTIONS(2346),
    [anon_sym_volatile] = ACTIONS(2346),
    [anon_sym_restrict] = ACTIONS(2346),
    [anon_sym___restrict__] = ACTIONS(2346),
    [anon_sym__Atomic] = ACTIONS(2346),
    [anon_sym__Noreturn] = ACTIONS(2346),
    [anon_sym_noreturn] = ACTIONS(2346),
    [anon_sym__Nonnull] = ACTIONS(2346),
    [anon_sym_mutable] = ACTIONS(2346),
    [anon_sym_constinit] = ACTIONS(2346),
    [anon_sym_consteval] = ACTIONS(2346),
    [anon_sym_alignas] = ACTIONS(2346),
    [anon_sym__Alignas] = ACTIONS(2346),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_goto] = ACTIONS(2346),
    [anon_sym___try] = ACTIONS(2346),
    [anon_sym___leave] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2346),
    [anon_sym_compl] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2346),
    [anon_sym___alignof__] = ACTIONS(2346),
    [anon_sym___alignof] = ACTIONS(2346),
    [anon_sym__alignof] = ACTIONS(2346),
    [anon_sym_alignof] = ACTIONS(2346),
    [anon_sym__Alignof] = ACTIONS(2346),
    [anon_sym_offsetof] = ACTIONS(2346),
    [anon_sym__Generic] = ACTIONS(2346),
    [anon_sym_asm] = ACTIONS(2346),
    [anon_sym___asm__] = ACTIONS(2346),
    [anon_sym___asm] = ACTIONS(2346),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_L_SQUOTE] = ACTIONS(2348),
    [anon_sym_u_SQUOTE] = ACTIONS(2348),
    [anon_sym_U_SQUOTE] = ACTIONS(2348),
    [anon_sym_u8_SQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_L_DQUOTE] = ACTIONS(2348),
    [anon_sym_u_DQUOTE] = ACTIONS(2348),
    [anon_sym_U_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8_DQUOTE] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [anon_sym_NULL] = ACTIONS(2346),
    [anon_sym_nullptr] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_decltype] = ACTIONS(2346),
    [anon_sym_explicit] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2346),
    [anon_sym_export] = ACTIONS(2346),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_import] = ACTIONS(2346),
    [anon_sym_template] = ACTIONS(2346),
    [anon_sym_operator] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_static_assert] = ACTIONS(2346),
    [anon_sym_concept] = ACTIONS(2346),
    [anon_sym_co_return] = ACTIONS(2346),
    [anon_sym_co_yield] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(2348),
    [anon_sym_LR_DQUOTE] = ACTIONS(2348),
    [anon_sym_uR_DQUOTE] = ACTIONS(2348),
    [anon_sym_UR_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2348),
    [anon_sym_co_await] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_requires] = ACTIONS(2346),
    [sym_this] = ACTIONS(2346),
    [anon_sym_discard] = ACTIONS(2346),
    [anon_sym_precise] = ACTIONS(2346),
    [anon_sym_shared] = ACTIONS(2346),
    [anon_sym_groupshared] = ACTIONS(2346),
    [anon_sym_uniform] = ACTIONS(2346),
    [anon_sym_row_major] = ACTIONS(2346),
    [anon_sym_column_major] = ACTIONS(2346),
    [anon_sym_globallycoherent] = ACTIONS(2346),
    [anon_sym_centroid] = ACTIONS(2346),
    [anon_sym_noperspective] = ACTIONS(2346),
    [anon_sym_nointerpolation] = ACTIONS(2346),
    [anon_sym_sample] = ACTIONS(2346),
    [anon_sym_linear] = ACTIONS(2346),
    [anon_sym_snorm] = ACTIONS(2346),
    [anon_sym_unorm] = ACTIONS(2346),
    [anon_sym_point] = ACTIONS(2346),
    [anon_sym_line] = ACTIONS(2346),
    [anon_sym_triangleadj] = ACTIONS(2346),
    [anon_sym_lineadj] = ACTIONS(2346),
    [anon_sym_triangle] = ACTIONS(2346),
    [anon_sym_cbuffer] = ACTIONS(2346),
  },
  [349] = {
    [sym_identifier] = ACTIONS(2480),
    [aux_sym_preproc_include_token1] = ACTIONS(2480),
    [aux_sym_preproc_def_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token2] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2480),
    [aux_sym_preproc_else_token1] = ACTIONS(2480),
    [aux_sym_preproc_elif_token1] = ACTIONS(2480),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2480),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_LPAREN2] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_out] = ACTIONS(2480),
    [anon_sym_inout] = ACTIONS(2480),
    [anon_sym_virtual] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym___attribute__] = ACTIONS(2480),
    [anon_sym___attribute] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2482),
    [anon_sym___declspec] = ACTIONS(2480),
    [anon_sym___based] = ACTIONS(2480),
    [anon_sym___cdecl] = ACTIONS(2480),
    [anon_sym___clrcall] = ACTIONS(2480),
    [anon_sym___stdcall] = ACTIONS(2480),
    [anon_sym___fastcall] = ACTIONS(2480),
    [anon_sym___thiscall] = ACTIONS(2480),
    [anon_sym___vectorcall] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym___inline] = ACTIONS(2480),
    [anon_sym___inline__] = ACTIONS(2480),
    [anon_sym___forceinline] = ACTIONS(2480),
    [anon_sym_thread_local] = ACTIONS(2480),
    [anon_sym___thread] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym___restrict__] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym__Noreturn] = ACTIONS(2480),
    [anon_sym_noreturn] = ACTIONS(2480),
    [anon_sym__Nonnull] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_constinit] = ACTIONS(2480),
    [anon_sym_consteval] = ACTIONS(2480),
    [anon_sym_alignas] = ACTIONS(2480),
    [anon_sym__Alignas] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym___try] = ACTIONS(2480),
    [anon_sym___leave] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2480),
    [anon_sym_compl] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2480),
    [anon_sym___alignof__] = ACTIONS(2480),
    [anon_sym___alignof] = ACTIONS(2480),
    [anon_sym__alignof] = ACTIONS(2480),
    [anon_sym_alignof] = ACTIONS(2480),
    [anon_sym__Alignof] = ACTIONS(2480),
    [anon_sym_offsetof] = ACTIONS(2480),
    [anon_sym__Generic] = ACTIONS(2480),
    [anon_sym_asm] = ACTIONS(2480),
    [anon_sym___asm__] = ACTIONS(2480),
    [anon_sym___asm] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2482),
    [anon_sym_u_SQUOTE] = ACTIONS(2482),
    [anon_sym_U_SQUOTE] = ACTIONS(2482),
    [anon_sym_u8_SQUOTE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_L_DQUOTE] = ACTIONS(2482),
    [anon_sym_u_DQUOTE] = ACTIONS(2482),
    [anon_sym_U_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8_DQUOTE] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [anon_sym_NULL] = ACTIONS(2480),
    [anon_sym_nullptr] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_decltype] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_operator] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_throw] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_static_assert] = ACTIONS(2480),
    [anon_sym_concept] = ACTIONS(2480),
    [anon_sym_co_return] = ACTIONS(2480),
    [anon_sym_co_yield] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_requires] = ACTIONS(2480),
    [sym_this] = ACTIONS(2480),
    [anon_sym_discard] = ACTIONS(2480),
    [anon_sym_precise] = ACTIONS(2480),
    [anon_sym_shared] = ACTIONS(2480),
    [anon_sym_groupshared] = ACTIONS(2480),
    [anon_sym_uniform] = ACTIONS(2480),
    [anon_sym_row_major] = ACTIONS(2480),
    [anon_sym_column_major] = ACTIONS(2480),
    [anon_sym_globallycoherent] = ACTIONS(2480),
    [anon_sym_centroid] = ACTIONS(2480),
    [anon_sym_noperspective] = ACTIONS(2480),
    [anon_sym_nointerpolation] = ACTIONS(2480),
    [anon_sym_sample] = ACTIONS(2480),
    [anon_sym_linear] = ACTIONS(2480),
    [anon_sym_snorm] = ACTIONS(2480),
    [anon_sym_unorm] = ACTIONS(2480),
    [anon_sym_point] = ACTIONS(2480),
    [anon_sym_line] = ACTIONS(2480),
    [anon_sym_triangleadj] = ACTIONS(2480),
    [anon_sym_lineadj] = ACTIONS(2480),
    [anon_sym_triangle] = ACTIONS(2480),
    [anon_sym_cbuffer] = ACTIONS(2480),
  },
  [350] = {
    [sym_identifier] = ACTIONS(2484),
    [aux_sym_preproc_include_token1] = ACTIONS(2484),
    [aux_sym_preproc_def_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token2] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2484),
    [aux_sym_preproc_else_token1] = ACTIONS(2484),
    [aux_sym_preproc_elif_token1] = ACTIONS(2484),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2484),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2484),
    [sym_preproc_directive] = ACTIONS(2484),
    [anon_sym_LPAREN2] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym___extension__] = ACTIONS(2484),
    [anon_sym_typedef] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_out] = ACTIONS(2484),
    [anon_sym_inout] = ACTIONS(2484),
    [anon_sym_virtual] = ACTIONS(2484),
    [anon_sym_extern] = ACTIONS(2484),
    [anon_sym___attribute__] = ACTIONS(2484),
    [anon_sym___attribute] = ACTIONS(2484),
    [anon_sym_using] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2486),
    [anon_sym___declspec] = ACTIONS(2484),
    [anon_sym___based] = ACTIONS(2484),
    [anon_sym___cdecl] = ACTIONS(2484),
    [anon_sym___clrcall] = ACTIONS(2484),
    [anon_sym___stdcall] = ACTIONS(2484),
    [anon_sym___fastcall] = ACTIONS(2484),
    [anon_sym___thiscall] = ACTIONS(2484),
    [anon_sym___vectorcall] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_signed] = ACTIONS(2484),
    [anon_sym_unsigned] = ACTIONS(2484),
    [anon_sym_long] = ACTIONS(2484),
    [anon_sym_short] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_register] = ACTIONS(2484),
    [anon_sym_inline] = ACTIONS(2484),
    [anon_sym___inline] = ACTIONS(2484),
    [anon_sym___inline__] = ACTIONS(2484),
    [anon_sym___forceinline] = ACTIONS(2484),
    [anon_sym_thread_local] = ACTIONS(2484),
    [anon_sym___thread] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_constexpr] = ACTIONS(2484),
    [anon_sym_volatile] = ACTIONS(2484),
    [anon_sym_restrict] = ACTIONS(2484),
    [anon_sym___restrict__] = ACTIONS(2484),
    [anon_sym__Atomic] = ACTIONS(2484),
    [anon_sym__Noreturn] = ACTIONS(2484),
    [anon_sym_noreturn] = ACTIONS(2484),
    [anon_sym__Nonnull] = ACTIONS(2484),
    [anon_sym_mutable] = ACTIONS(2484),
    [anon_sym_constinit] = ACTIONS(2484),
    [anon_sym_consteval] = ACTIONS(2484),
    [anon_sym_alignas] = ACTIONS(2484),
    [anon_sym__Alignas] = ACTIONS(2484),
    [sym_primitive_type] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_struct] = ACTIONS(2484),
    [anon_sym_union] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_goto] = ACTIONS(2484),
    [anon_sym___try] = ACTIONS(2484),
    [anon_sym___leave] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2484),
    [anon_sym_compl] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2484),
    [anon_sym___alignof__] = ACTIONS(2484),
    [anon_sym___alignof] = ACTIONS(2484),
    [anon_sym__alignof] = ACTIONS(2484),
    [anon_sym_alignof] = ACTIONS(2484),
    [anon_sym__Alignof] = ACTIONS(2484),
    [anon_sym_offsetof] = ACTIONS(2484),
    [anon_sym__Generic] = ACTIONS(2484),
    [anon_sym_asm] = ACTIONS(2484),
    [anon_sym___asm__] = ACTIONS(2484),
    [anon_sym___asm] = ACTIONS(2484),
    [sym_number_literal] = ACTIONS(2486),
    [anon_sym_L_SQUOTE] = ACTIONS(2486),
    [anon_sym_u_SQUOTE] = ACTIONS(2486),
    [anon_sym_U_SQUOTE] = ACTIONS(2486),
    [anon_sym_u8_SQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_L_DQUOTE] = ACTIONS(2486),
    [anon_sym_u_DQUOTE] = ACTIONS(2486),
    [anon_sym_U_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8_DQUOTE] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [anon_sym_NULL] = ACTIONS(2484),
    [anon_sym_nullptr] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2484),
    [anon_sym_decltype] = ACTIONS(2484),
    [anon_sym_explicit] = ACTIONS(2484),
    [anon_sym_typename] = ACTIONS(2484),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_static_assert] = ACTIONS(2484),
    [anon_sym_concept] = ACTIONS(2484),
    [anon_sym_co_return] = ACTIONS(2484),
    [anon_sym_co_yield] = ACTIONS(2484),
    [anon_sym_R_DQUOTE] = ACTIONS(2486),
    [anon_sym_LR_DQUOTE] = ACTIONS(2486),
    [anon_sym_uR_DQUOTE] = ACTIONS(2486),
    [anon_sym_UR_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2486),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2484),
    [anon_sym_requires] = ACTIONS(2484),
    [sym_this] = ACTIONS(2484),
    [anon_sym_discard] = ACTIONS(2484),
    [anon_sym_precise] = ACTIONS(2484),
    [anon_sym_shared] = ACTIONS(2484),
    [anon_sym_groupshared] = ACTIONS(2484),
    [anon_sym_uniform] = ACTIONS(2484),
    [anon_sym_row_major] = ACTIONS(2484),
    [anon_sym_column_major] = ACTIONS(2484),
    [anon_sym_globallycoherent] = ACTIONS(2484),
    [anon_sym_centroid] = ACTIONS(2484),
    [anon_sym_noperspective] = ACTIONS(2484),
    [anon_sym_nointerpolation] = ACTIONS(2484),
    [anon_sym_sample] = ACTIONS(2484),
    [anon_sym_linear] = ACTIONS(2484),
    [anon_sym_snorm] = ACTIONS(2484),
    [anon_sym_unorm] = ACTIONS(2484),
    [anon_sym_point] = ACTIONS(2484),
    [anon_sym_line] = ACTIONS(2484),
    [anon_sym_triangleadj] = ACTIONS(2484),
    [anon_sym_lineadj] = ACTIONS(2484),
    [anon_sym_triangle] = ACTIONS(2484),
    [anon_sym_cbuffer] = ACTIONS(2484),
  },
  [351] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [aux_sym_preproc_else_token1] = ACTIONS(2488),
    [aux_sym_preproc_elif_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [anon_sym___asm] = ACTIONS(2488),
    [sym_number_literal] = ACTIONS(2490),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
    [anon_sym_discard] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
    [anon_sym_cbuffer] = ACTIONS(2488),
  },
  [352] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [aux_sym_preproc_else_token1] = ACTIONS(2492),
    [aux_sym_preproc_elif_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [anon_sym___asm] = ACTIONS(2492),
    [sym_number_literal] = ACTIONS(2494),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
    [anon_sym_discard] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
    [anon_sym_cbuffer] = ACTIONS(2492),
  },
  [353] = {
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token2] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [aux_sym_preproc_else_token1] = ACTIONS(2496),
    [aux_sym_preproc_elif_token1] = ACTIONS(2496),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_out] = ACTIONS(2496),
    [anon_sym_inout] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym___attribute] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym__Nonnull] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym__Alignas] = ACTIONS(2496),
    [sym_primitive_type] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [anon_sym___asm] = ACTIONS(2496),
    [sym_number_literal] = ACTIONS(2498),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
    [anon_sym_discard] = ACTIONS(2496),
    [anon_sym_precise] = ACTIONS(2496),
    [anon_sym_shared] = ACTIONS(2496),
    [anon_sym_groupshared] = ACTIONS(2496),
    [anon_sym_uniform] = ACTIONS(2496),
    [anon_sym_row_major] = ACTIONS(2496),
    [anon_sym_column_major] = ACTIONS(2496),
    [anon_sym_globallycoherent] = ACTIONS(2496),
    [anon_sym_centroid] = ACTIONS(2496),
    [anon_sym_noperspective] = ACTIONS(2496),
    [anon_sym_nointerpolation] = ACTIONS(2496),
    [anon_sym_sample] = ACTIONS(2496),
    [anon_sym_linear] = ACTIONS(2496),
    [anon_sym_snorm] = ACTIONS(2496),
    [anon_sym_unorm] = ACTIONS(2496),
    [anon_sym_point] = ACTIONS(2496),
    [anon_sym_line] = ACTIONS(2496),
    [anon_sym_triangleadj] = ACTIONS(2496),
    [anon_sym_lineadj] = ACTIONS(2496),
    [anon_sym_triangle] = ACTIONS(2496),
    [anon_sym_cbuffer] = ACTIONS(2496),
  },
  [354] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [anon_sym___asm] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym_discard] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
    [anon_sym_cbuffer] = ACTIONS(2500),
  },
  [355] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [aux_sym_preproc_else_token1] = ACTIONS(2504),
    [aux_sym_preproc_elif_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [anon_sym___asm] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym_discard] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
    [anon_sym_cbuffer] = ACTIONS(2504),
  },
  [356] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_include_token1] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token2] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [aux_sym_preproc_else_token1] = ACTIONS(2508),
    [aux_sym_preproc_elif_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym___cdecl] = ACTIONS(2508),
    [anon_sym___clrcall] = ACTIONS(2508),
    [anon_sym___stdcall] = ACTIONS(2508),
    [anon_sym___fastcall] = ACTIONS(2508),
    [anon_sym___thiscall] = ACTIONS(2508),
    [anon_sym___vectorcall] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_goto] = ACTIONS(2508),
    [anon_sym___try] = ACTIONS(2508),
    [anon_sym___leave] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2508),
    [anon_sym_compl] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2508),
    [anon_sym___alignof__] = ACTIONS(2508),
    [anon_sym___alignof] = ACTIONS(2508),
    [anon_sym__alignof] = ACTIONS(2508),
    [anon_sym_alignof] = ACTIONS(2508),
    [anon_sym__Alignof] = ACTIONS(2508),
    [anon_sym_offsetof] = ACTIONS(2508),
    [anon_sym__Generic] = ACTIONS(2508),
    [anon_sym_asm] = ACTIONS(2508),
    [anon_sym___asm__] = ACTIONS(2508),
    [anon_sym___asm] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(2510),
    [anon_sym_L_SQUOTE] = ACTIONS(2510),
    [anon_sym_u_SQUOTE] = ACTIONS(2510),
    [anon_sym_U_SQUOTE] = ACTIONS(2510),
    [anon_sym_u8_SQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_L_DQUOTE] = ACTIONS(2510),
    [anon_sym_u_DQUOTE] = ACTIONS(2510),
    [anon_sym_U_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [anon_sym_NULL] = ACTIONS(2508),
    [anon_sym_nullptr] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_concept] = ACTIONS(2508),
    [anon_sym_co_return] = ACTIONS(2508),
    [anon_sym_co_yield] = ACTIONS(2508),
    [anon_sym_R_DQUOTE] = ACTIONS(2510),
    [anon_sym_LR_DQUOTE] = ACTIONS(2510),
    [anon_sym_uR_DQUOTE] = ACTIONS(2510),
    [anon_sym_UR_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2510),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_requires] = ACTIONS(2508),
    [sym_this] = ACTIONS(2508),
    [anon_sym_discard] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
    [anon_sym_cbuffer] = ACTIONS(2508),
  },
  [357] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_include_token1] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token2] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [aux_sym_preproc_else_token1] = ACTIONS(2512),
    [aux_sym_preproc_elif_token1] = ACTIONS(2512),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym___cdecl] = ACTIONS(2512),
    [anon_sym___clrcall] = ACTIONS(2512),
    [anon_sym___stdcall] = ACTIONS(2512),
    [anon_sym___fastcall] = ACTIONS(2512),
    [anon_sym___thiscall] = ACTIONS(2512),
    [anon_sym___vectorcall] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_goto] = ACTIONS(2512),
    [anon_sym___try] = ACTIONS(2512),
    [anon_sym___leave] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2512),
    [anon_sym___alignof__] = ACTIONS(2512),
    [anon_sym___alignof] = ACTIONS(2512),
    [anon_sym__alignof] = ACTIONS(2512),
    [anon_sym_alignof] = ACTIONS(2512),
    [anon_sym__Alignof] = ACTIONS(2512),
    [anon_sym_offsetof] = ACTIONS(2512),
    [anon_sym__Generic] = ACTIONS(2512),
    [anon_sym_asm] = ACTIONS(2512),
    [anon_sym___asm__] = ACTIONS(2512),
    [anon_sym___asm] = ACTIONS(2512),
    [sym_number_literal] = ACTIONS(2514),
    [anon_sym_L_SQUOTE] = ACTIONS(2514),
    [anon_sym_u_SQUOTE] = ACTIONS(2514),
    [anon_sym_U_SQUOTE] = ACTIONS(2514),
    [anon_sym_u8_SQUOTE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_L_DQUOTE] = ACTIONS(2514),
    [anon_sym_u_DQUOTE] = ACTIONS(2514),
    [anon_sym_U_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [anon_sym_NULL] = ACTIONS(2512),
    [anon_sym_nullptr] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_concept] = ACTIONS(2512),
    [anon_sym_co_return] = ACTIONS(2512),
    [anon_sym_co_yield] = ACTIONS(2512),
    [anon_sym_R_DQUOTE] = ACTIONS(2514),
    [anon_sym_LR_DQUOTE] = ACTIONS(2514),
    [anon_sym_uR_DQUOTE] = ACTIONS(2514),
    [anon_sym_UR_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2514),
    [anon_sym_co_await] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_requires] = ACTIONS(2512),
    [sym_this] = ACTIONS(2512),
    [anon_sym_discard] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
    [anon_sym_cbuffer] = ACTIONS(2512),
  },
  [358] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_include_token1] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token2] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [aux_sym_preproc_else_token1] = ACTIONS(2516),
    [aux_sym_preproc_elif_token1] = ACTIONS(2516),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym___cdecl] = ACTIONS(2516),
    [anon_sym___clrcall] = ACTIONS(2516),
    [anon_sym___stdcall] = ACTIONS(2516),
    [anon_sym___fastcall] = ACTIONS(2516),
    [anon_sym___thiscall] = ACTIONS(2516),
    [anon_sym___vectorcall] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_switch] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_do] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_goto] = ACTIONS(2516),
    [anon_sym___try] = ACTIONS(2516),
    [anon_sym___leave] = ACTIONS(2516),
    [anon_sym_not] = ACTIONS(2516),
    [anon_sym_compl] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2516),
    [anon_sym___alignof__] = ACTIONS(2516),
    [anon_sym___alignof] = ACTIONS(2516),
    [anon_sym__alignof] = ACTIONS(2516),
    [anon_sym_alignof] = ACTIONS(2516),
    [anon_sym__Alignof] = ACTIONS(2516),
    [anon_sym_offsetof] = ACTIONS(2516),
    [anon_sym__Generic] = ACTIONS(2516),
    [anon_sym_asm] = ACTIONS(2516),
    [anon_sym___asm__] = ACTIONS(2516),
    [anon_sym___asm] = ACTIONS(2516),
    [sym_number_literal] = ACTIONS(2518),
    [anon_sym_L_SQUOTE] = ACTIONS(2518),
    [anon_sym_u_SQUOTE] = ACTIONS(2518),
    [anon_sym_U_SQUOTE] = ACTIONS(2518),
    [anon_sym_u8_SQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_L_DQUOTE] = ACTIONS(2518),
    [anon_sym_u_DQUOTE] = ACTIONS(2518),
    [anon_sym_U_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [anon_sym_NULL] = ACTIONS(2516),
    [anon_sym_nullptr] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [anon_sym_delete] = ACTIONS(2516),
    [anon_sym_throw] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_concept] = ACTIONS(2516),
    [anon_sym_co_return] = ACTIONS(2516),
    [anon_sym_co_yield] = ACTIONS(2516),
    [anon_sym_R_DQUOTE] = ACTIONS(2518),
    [anon_sym_LR_DQUOTE] = ACTIONS(2518),
    [anon_sym_uR_DQUOTE] = ACTIONS(2518),
    [anon_sym_UR_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2518),
    [anon_sym_co_await] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2516),
    [anon_sym_requires] = ACTIONS(2516),
    [sym_this] = ACTIONS(2516),
    [anon_sym_discard] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
    [anon_sym_cbuffer] = ACTIONS(2516),
  },
  [359] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_include_token1] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token2] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [aux_sym_preproc_else_token1] = ACTIONS(2520),
    [aux_sym_preproc_elif_token1] = ACTIONS(2520),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym___cdecl] = ACTIONS(2520),
    [anon_sym___clrcall] = ACTIONS(2520),
    [anon_sym___stdcall] = ACTIONS(2520),
    [anon_sym___fastcall] = ACTIONS(2520),
    [anon_sym___thiscall] = ACTIONS(2520),
    [anon_sym___vectorcall] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_switch] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_do] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_goto] = ACTIONS(2520),
    [anon_sym___try] = ACTIONS(2520),
    [anon_sym___leave] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2520),
    [anon_sym_compl] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2520),
    [anon_sym___alignof__] = ACTIONS(2520),
    [anon_sym___alignof] = ACTIONS(2520),
    [anon_sym__alignof] = ACTIONS(2520),
    [anon_sym_alignof] = ACTIONS(2520),
    [anon_sym__Alignof] = ACTIONS(2520),
    [anon_sym_offsetof] = ACTIONS(2520),
    [anon_sym__Generic] = ACTIONS(2520),
    [anon_sym_asm] = ACTIONS(2520),
    [anon_sym___asm__] = ACTIONS(2520),
    [anon_sym___asm] = ACTIONS(2520),
    [sym_number_literal] = ACTIONS(2522),
    [anon_sym_L_SQUOTE] = ACTIONS(2522),
    [anon_sym_u_SQUOTE] = ACTIONS(2522),
    [anon_sym_U_SQUOTE] = ACTIONS(2522),
    [anon_sym_u8_SQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_L_DQUOTE] = ACTIONS(2522),
    [anon_sym_u_DQUOTE] = ACTIONS(2522),
    [anon_sym_U_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8_DQUOTE] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [anon_sym_NULL] = ACTIONS(2520),
    [anon_sym_nullptr] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(2520),
    [anon_sym_throw] = ACTIONS(2520),
    [anon_sym_namespace] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_concept] = ACTIONS(2520),
    [anon_sym_co_return] = ACTIONS(2520),
    [anon_sym_co_yield] = ACTIONS(2520),
    [anon_sym_R_DQUOTE] = ACTIONS(2522),
    [anon_sym_LR_DQUOTE] = ACTIONS(2522),
    [anon_sym_uR_DQUOTE] = ACTIONS(2522),
    [anon_sym_UR_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2522),
    [anon_sym_co_await] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_requires] = ACTIONS(2520),
    [sym_this] = ACTIONS(2520),
    [anon_sym_discard] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
    [anon_sym_cbuffer] = ACTIONS(2520),
  },
  [360] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [361] = {
    [sym_identifier] = ACTIONS(2528),
    [aux_sym_preproc_include_token1] = ACTIONS(2528),
    [aux_sym_preproc_def_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token2] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2528),
    [aux_sym_preproc_else_token1] = ACTIONS(2528),
    [aux_sym_preproc_elif_token1] = ACTIONS(2528),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2528),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2528),
    [sym_preproc_directive] = ACTIONS(2528),
    [anon_sym_LPAREN2] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym___extension__] = ACTIONS(2528),
    [anon_sym_typedef] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2528),
    [anon_sym_out] = ACTIONS(2528),
    [anon_sym_inout] = ACTIONS(2528),
    [anon_sym_virtual] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym___attribute__] = ACTIONS(2528),
    [anon_sym___attribute] = ACTIONS(2528),
    [anon_sym_using] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2530),
    [anon_sym___declspec] = ACTIONS(2528),
    [anon_sym___based] = ACTIONS(2528),
    [anon_sym___cdecl] = ACTIONS(2528),
    [anon_sym___clrcall] = ACTIONS(2528),
    [anon_sym___stdcall] = ACTIONS(2528),
    [anon_sym___fastcall] = ACTIONS(2528),
    [anon_sym___thiscall] = ACTIONS(2528),
    [anon_sym___vectorcall] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_signed] = ACTIONS(2528),
    [anon_sym_unsigned] = ACTIONS(2528),
    [anon_sym_long] = ACTIONS(2528),
    [anon_sym_short] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_register] = ACTIONS(2528),
    [anon_sym_inline] = ACTIONS(2528),
    [anon_sym___inline] = ACTIONS(2528),
    [anon_sym___inline__] = ACTIONS(2528),
    [anon_sym___forceinline] = ACTIONS(2528),
    [anon_sym_thread_local] = ACTIONS(2528),
    [anon_sym___thread] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_constexpr] = ACTIONS(2528),
    [anon_sym_volatile] = ACTIONS(2528),
    [anon_sym_restrict] = ACTIONS(2528),
    [anon_sym___restrict__] = ACTIONS(2528),
    [anon_sym__Atomic] = ACTIONS(2528),
    [anon_sym__Noreturn] = ACTIONS(2528),
    [anon_sym_noreturn] = ACTIONS(2528),
    [anon_sym__Nonnull] = ACTIONS(2528),
    [anon_sym_mutable] = ACTIONS(2528),
    [anon_sym_constinit] = ACTIONS(2528),
    [anon_sym_consteval] = ACTIONS(2528),
    [anon_sym_alignas] = ACTIONS(2528),
    [anon_sym__Alignas] = ACTIONS(2528),
    [sym_primitive_type] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_goto] = ACTIONS(2528),
    [anon_sym___try] = ACTIONS(2528),
    [anon_sym___leave] = ACTIONS(2528),
    [anon_sym_not] = ACTIONS(2528),
    [anon_sym_compl] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2528),
    [anon_sym___alignof__] = ACTIONS(2528),
    [anon_sym___alignof] = ACTIONS(2528),
    [anon_sym__alignof] = ACTIONS(2528),
    [anon_sym_alignof] = ACTIONS(2528),
    [anon_sym__Alignof] = ACTIONS(2528),
    [anon_sym_offsetof] = ACTIONS(2528),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2528),
    [anon_sym___asm__] = ACTIONS(2528),
    [anon_sym___asm] = ACTIONS(2528),
    [sym_number_literal] = ACTIONS(2530),
    [anon_sym_L_SQUOTE] = ACTIONS(2530),
    [anon_sym_u_SQUOTE] = ACTIONS(2530),
    [anon_sym_U_SQUOTE] = ACTIONS(2530),
    [anon_sym_u8_SQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_L_DQUOTE] = ACTIONS(2530),
    [anon_sym_u_DQUOTE] = ACTIONS(2530),
    [anon_sym_U_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8_DQUOTE] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [anon_sym_NULL] = ACTIONS(2528),
    [anon_sym_nullptr] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2528),
    [anon_sym_decltype] = ACTIONS(2528),
    [anon_sym_explicit] = ACTIONS(2528),
    [anon_sym_typename] = ACTIONS(2528),
    [anon_sym_template] = ACTIONS(2528),
    [anon_sym_operator] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_static_assert] = ACTIONS(2528),
    [anon_sym_concept] = ACTIONS(2528),
    [anon_sym_co_return] = ACTIONS(2528),
    [anon_sym_co_yield] = ACTIONS(2528),
    [anon_sym_R_DQUOTE] = ACTIONS(2530),
    [anon_sym_LR_DQUOTE] = ACTIONS(2530),
    [anon_sym_uR_DQUOTE] = ACTIONS(2530),
    [anon_sym_UR_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2530),
    [anon_sym_co_await] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_requires] = ACTIONS(2528),
    [sym_this] = ACTIONS(2528),
    [anon_sym_discard] = ACTIONS(2528),
    [anon_sym_precise] = ACTIONS(2528),
    [anon_sym_shared] = ACTIONS(2528),
    [anon_sym_groupshared] = ACTIONS(2528),
    [anon_sym_uniform] = ACTIONS(2528),
    [anon_sym_row_major] = ACTIONS(2528),
    [anon_sym_column_major] = ACTIONS(2528),
    [anon_sym_globallycoherent] = ACTIONS(2528),
    [anon_sym_centroid] = ACTIONS(2528),
    [anon_sym_noperspective] = ACTIONS(2528),
    [anon_sym_nointerpolation] = ACTIONS(2528),
    [anon_sym_sample] = ACTIONS(2528),
    [anon_sym_linear] = ACTIONS(2528),
    [anon_sym_snorm] = ACTIONS(2528),
    [anon_sym_unorm] = ACTIONS(2528),
    [anon_sym_point] = ACTIONS(2528),
    [anon_sym_line] = ACTIONS(2528),
    [anon_sym_triangleadj] = ACTIONS(2528),
    [anon_sym_lineadj] = ACTIONS(2528),
    [anon_sym_triangle] = ACTIONS(2528),
    [anon_sym_cbuffer] = ACTIONS(2528),
  },
  [362] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_include_token1] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token2] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [aux_sym_preproc_else_token1] = ACTIONS(2532),
    [aux_sym_preproc_elif_token1] = ACTIONS(2532),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym___cdecl] = ACTIONS(2532),
    [anon_sym___clrcall] = ACTIONS(2532),
    [anon_sym___stdcall] = ACTIONS(2532),
    [anon_sym___fastcall] = ACTIONS(2532),
    [anon_sym___thiscall] = ACTIONS(2532),
    [anon_sym___vectorcall] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_goto] = ACTIONS(2532),
    [anon_sym___try] = ACTIONS(2532),
    [anon_sym___leave] = ACTIONS(2532),
    [anon_sym_not] = ACTIONS(2532),
    [anon_sym_compl] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2532),
    [anon_sym___alignof__] = ACTIONS(2532),
    [anon_sym___alignof] = ACTIONS(2532),
    [anon_sym__alignof] = ACTIONS(2532),
    [anon_sym_alignof] = ACTIONS(2532),
    [anon_sym__Alignof] = ACTIONS(2532),
    [anon_sym_offsetof] = ACTIONS(2532),
    [anon_sym__Generic] = ACTIONS(2532),
    [anon_sym_asm] = ACTIONS(2532),
    [anon_sym___asm__] = ACTIONS(2532),
    [anon_sym___asm] = ACTIONS(2532),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [anon_sym_NULL] = ACTIONS(2532),
    [anon_sym_nullptr] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_concept] = ACTIONS(2532),
    [anon_sym_co_return] = ACTIONS(2532),
    [anon_sym_co_yield] = ACTIONS(2532),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_requires] = ACTIONS(2532),
    [sym_this] = ACTIONS(2532),
    [anon_sym_discard] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
    [anon_sym_cbuffer] = ACTIONS(2532),
  },
  [363] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token2] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [aux_sym_preproc_else_token1] = ACTIONS(2536),
    [aux_sym_preproc_elif_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2538),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2538),
    [anon_sym_L_SQUOTE] = ACTIONS(2538),
    [anon_sym_u_SQUOTE] = ACTIONS(2538),
    [anon_sym_U_SQUOTE] = ACTIONS(2538),
    [anon_sym_u8_SQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_L_DQUOTE] = ACTIONS(2538),
    [anon_sym_u_DQUOTE] = ACTIONS(2538),
    [anon_sym_U_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8_DQUOTE] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2538),
    [anon_sym_LR_DQUOTE] = ACTIONS(2538),
    [anon_sym_uR_DQUOTE] = ACTIONS(2538),
    [anon_sym_UR_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2538),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
  },
  [364] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_include_token1] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token2] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [aux_sym_preproc_else_token1] = ACTIONS(2540),
    [aux_sym_preproc_elif_token1] = ACTIONS(2540),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym___cdecl] = ACTIONS(2540),
    [anon_sym___clrcall] = ACTIONS(2540),
    [anon_sym___stdcall] = ACTIONS(2540),
    [anon_sym___fastcall] = ACTIONS(2540),
    [anon_sym___thiscall] = ACTIONS(2540),
    [anon_sym___vectorcall] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_goto] = ACTIONS(2540),
    [anon_sym___try] = ACTIONS(2540),
    [anon_sym___leave] = ACTIONS(2540),
    [anon_sym_not] = ACTIONS(2540),
    [anon_sym_compl] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2540),
    [anon_sym___alignof__] = ACTIONS(2540),
    [anon_sym___alignof] = ACTIONS(2540),
    [anon_sym__alignof] = ACTIONS(2540),
    [anon_sym_alignof] = ACTIONS(2540),
    [anon_sym__Alignof] = ACTIONS(2540),
    [anon_sym_offsetof] = ACTIONS(2540),
    [anon_sym__Generic] = ACTIONS(2540),
    [anon_sym_asm] = ACTIONS(2540),
    [anon_sym___asm__] = ACTIONS(2540),
    [anon_sym___asm] = ACTIONS(2540),
    [sym_number_literal] = ACTIONS(2542),
    [anon_sym_L_SQUOTE] = ACTIONS(2542),
    [anon_sym_u_SQUOTE] = ACTIONS(2542),
    [anon_sym_U_SQUOTE] = ACTIONS(2542),
    [anon_sym_u8_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_L_DQUOTE] = ACTIONS(2542),
    [anon_sym_u_DQUOTE] = ACTIONS(2542),
    [anon_sym_U_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8_DQUOTE] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2542),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_concept] = ACTIONS(2540),
    [anon_sym_co_return] = ACTIONS(2540),
    [anon_sym_co_yield] = ACTIONS(2540),
    [anon_sym_R_DQUOTE] = ACTIONS(2542),
    [anon_sym_LR_DQUOTE] = ACTIONS(2542),
    [anon_sym_uR_DQUOTE] = ACTIONS(2542),
    [anon_sym_UR_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2542),
    [anon_sym_co_await] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_requires] = ACTIONS(2540),
    [sym_this] = ACTIONS(2540),
    [anon_sym_discard] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
    [anon_sym_cbuffer] = ACTIONS(2540),
  },
  [365] = {
    [sym_identifier] = ACTIONS(2544),
    [aux_sym_preproc_include_token1] = ACTIONS(2544),
    [aux_sym_preproc_def_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token2] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2544),
    [aux_sym_preproc_else_token1] = ACTIONS(2544),
    [aux_sym_preproc_elif_token1] = ACTIONS(2544),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2544),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2544),
    [sym_preproc_directive] = ACTIONS(2544),
    [anon_sym_LPAREN2] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym___extension__] = ACTIONS(2544),
    [anon_sym_typedef] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2544),
    [anon_sym_out] = ACTIONS(2544),
    [anon_sym_inout] = ACTIONS(2544),
    [anon_sym_virtual] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym___attribute__] = ACTIONS(2544),
    [anon_sym___attribute] = ACTIONS(2544),
    [anon_sym_using] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2546),
    [anon_sym___declspec] = ACTIONS(2544),
    [anon_sym___based] = ACTIONS(2544),
    [anon_sym___cdecl] = ACTIONS(2544),
    [anon_sym___clrcall] = ACTIONS(2544),
    [anon_sym___stdcall] = ACTIONS(2544),
    [anon_sym___fastcall] = ACTIONS(2544),
    [anon_sym___thiscall] = ACTIONS(2544),
    [anon_sym___vectorcall] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_signed] = ACTIONS(2544),
    [anon_sym_unsigned] = ACTIONS(2544),
    [anon_sym_long] = ACTIONS(2544),
    [anon_sym_short] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_register] = ACTIONS(2544),
    [anon_sym_inline] = ACTIONS(2544),
    [anon_sym___inline] = ACTIONS(2544),
    [anon_sym___inline__] = ACTIONS(2544),
    [anon_sym___forceinline] = ACTIONS(2544),
    [anon_sym_thread_local] = ACTIONS(2544),
    [anon_sym___thread] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_constexpr] = ACTIONS(2544),
    [anon_sym_volatile] = ACTIONS(2544),
    [anon_sym_restrict] = ACTIONS(2544),
    [anon_sym___restrict__] = ACTIONS(2544),
    [anon_sym__Atomic] = ACTIONS(2544),
    [anon_sym__Noreturn] = ACTIONS(2544),
    [anon_sym_noreturn] = ACTIONS(2544),
    [anon_sym__Nonnull] = ACTIONS(2544),
    [anon_sym_mutable] = ACTIONS(2544),
    [anon_sym_constinit] = ACTIONS(2544),
    [anon_sym_consteval] = ACTIONS(2544),
    [anon_sym_alignas] = ACTIONS(2544),
    [anon_sym__Alignas] = ACTIONS(2544),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_goto] = ACTIONS(2544),
    [anon_sym___try] = ACTIONS(2544),
    [anon_sym___leave] = ACTIONS(2544),
    [anon_sym_not] = ACTIONS(2544),
    [anon_sym_compl] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_sizeof] = ACTIONS(2544),
    [anon_sym___alignof__] = ACTIONS(2544),
    [anon_sym___alignof] = ACTIONS(2544),
    [anon_sym__alignof] = ACTIONS(2544),
    [anon_sym_alignof] = ACTIONS(2544),
    [anon_sym__Alignof] = ACTIONS(2544),
    [anon_sym_offsetof] = ACTIONS(2544),
    [anon_sym__Generic] = ACTIONS(2544),
    [anon_sym_asm] = ACTIONS(2544),
    [anon_sym___asm__] = ACTIONS(2544),
    [anon_sym___asm] = ACTIONS(2544),
    [sym_number_literal] = ACTIONS(2546),
    [anon_sym_L_SQUOTE] = ACTIONS(2546),
    [anon_sym_u_SQUOTE] = ACTIONS(2546),
    [anon_sym_U_SQUOTE] = ACTIONS(2546),
    [anon_sym_u8_SQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_L_DQUOTE] = ACTIONS(2546),
    [anon_sym_u_DQUOTE] = ACTIONS(2546),
    [anon_sym_U_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8_DQUOTE] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [anon_sym_NULL] = ACTIONS(2544),
    [anon_sym_nullptr] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2544),
    [anon_sym_decltype] = ACTIONS(2544),
    [anon_sym_explicit] = ACTIONS(2544),
    [anon_sym_typename] = ACTIONS(2544),
    [anon_sym_template] = ACTIONS(2544),
    [anon_sym_operator] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_static_assert] = ACTIONS(2544),
    [anon_sym_concept] = ACTIONS(2544),
    [anon_sym_co_return] = ACTIONS(2544),
    [anon_sym_co_yield] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_requires] = ACTIONS(2544),
    [sym_this] = ACTIONS(2544),
    [anon_sym_discard] = ACTIONS(2544),
    [anon_sym_precise] = ACTIONS(2544),
    [anon_sym_shared] = ACTIONS(2544),
    [anon_sym_groupshared] = ACTIONS(2544),
    [anon_sym_uniform] = ACTIONS(2544),
    [anon_sym_row_major] = ACTIONS(2544),
    [anon_sym_column_major] = ACTIONS(2544),
    [anon_sym_globallycoherent] = ACTIONS(2544),
    [anon_sym_centroid] = ACTIONS(2544),
    [anon_sym_noperspective] = ACTIONS(2544),
    [anon_sym_nointerpolation] = ACTIONS(2544),
    [anon_sym_sample] = ACTIONS(2544),
    [anon_sym_linear] = ACTIONS(2544),
    [anon_sym_snorm] = ACTIONS(2544),
    [anon_sym_unorm] = ACTIONS(2544),
    [anon_sym_point] = ACTIONS(2544),
    [anon_sym_line] = ACTIONS(2544),
    [anon_sym_triangleadj] = ACTIONS(2544),
    [anon_sym_lineadj] = ACTIONS(2544),
    [anon_sym_triangle] = ACTIONS(2544),
    [anon_sym_cbuffer] = ACTIONS(2544),
  },
  [366] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_include_token1] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token2] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [aux_sym_preproc_else_token1] = ACTIONS(2548),
    [aux_sym_preproc_elif_token1] = ACTIONS(2548),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym___cdecl] = ACTIONS(2548),
    [anon_sym___clrcall] = ACTIONS(2548),
    [anon_sym___stdcall] = ACTIONS(2548),
    [anon_sym___fastcall] = ACTIONS(2548),
    [anon_sym___thiscall] = ACTIONS(2548),
    [anon_sym___vectorcall] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_switch] = ACTIONS(2548),
    [anon_sym_case] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_do] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_goto] = ACTIONS(2548),
    [anon_sym___try] = ACTIONS(2548),
    [anon_sym___leave] = ACTIONS(2548),
    [anon_sym_not] = ACTIONS(2548),
    [anon_sym_compl] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2548),
    [anon_sym___alignof__] = ACTIONS(2548),
    [anon_sym___alignof] = ACTIONS(2548),
    [anon_sym__alignof] = ACTIONS(2548),
    [anon_sym_alignof] = ACTIONS(2548),
    [anon_sym__Alignof] = ACTIONS(2548),
    [anon_sym_offsetof] = ACTIONS(2548),
    [anon_sym__Generic] = ACTIONS(2548),
    [anon_sym_asm] = ACTIONS(2548),
    [anon_sym___asm__] = ACTIONS(2548),
    [anon_sym___asm] = ACTIONS(2548),
    [sym_number_literal] = ACTIONS(2550),
    [anon_sym_L_SQUOTE] = ACTIONS(2550),
    [anon_sym_u_SQUOTE] = ACTIONS(2550),
    [anon_sym_U_SQUOTE] = ACTIONS(2550),
    [anon_sym_u8_SQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_L_DQUOTE] = ACTIONS(2550),
    [anon_sym_u_DQUOTE] = ACTIONS(2550),
    [anon_sym_U_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8_DQUOTE] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [anon_sym_NULL] = ACTIONS(2548),
    [anon_sym_nullptr] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [anon_sym_delete] = ACTIONS(2548),
    [anon_sym_throw] = ACTIONS(2548),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_concept] = ACTIONS(2548),
    [anon_sym_co_return] = ACTIONS(2548),
    [anon_sym_co_yield] = ACTIONS(2548),
    [anon_sym_R_DQUOTE] = ACTIONS(2550),
    [anon_sym_LR_DQUOTE] = ACTIONS(2550),
    [anon_sym_uR_DQUOTE] = ACTIONS(2550),
    [anon_sym_UR_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2550),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_requires] = ACTIONS(2548),
    [sym_this] = ACTIONS(2548),
    [anon_sym_discard] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
    [anon_sym_cbuffer] = ACTIONS(2548),
  },
  [367] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(2161),
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_export] = ACTIONS(2159),
    [anon_sym_module] = ACTIONS(2159),
    [anon_sym_import] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2322),
    [aux_sym_preproc_include_token1] = ACTIONS(2322),
    [aux_sym_preproc_def_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2322),
    [sym_preproc_directive] = ACTIONS(2322),
    [anon_sym_LPAREN2] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym___extension__] = ACTIONS(2322),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(2322),
    [anon_sym_out] = ACTIONS(2322),
    [anon_sym_inout] = ACTIONS(2322),
    [anon_sym_virtual] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym___attribute__] = ACTIONS(2322),
    [anon_sym___attribute] = ACTIONS(2322),
    [anon_sym_using] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2324),
    [anon_sym___declspec] = ACTIONS(2322),
    [anon_sym___based] = ACTIONS(2322),
    [anon_sym___cdecl] = ACTIONS(2322),
    [anon_sym___clrcall] = ACTIONS(2322),
    [anon_sym___stdcall] = ACTIONS(2322),
    [anon_sym___fastcall] = ACTIONS(2322),
    [anon_sym___thiscall] = ACTIONS(2322),
    [anon_sym___vectorcall] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_signed] = ACTIONS(2322),
    [anon_sym_unsigned] = ACTIONS(2322),
    [anon_sym_long] = ACTIONS(2322),
    [anon_sym_short] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_register] = ACTIONS(2322),
    [anon_sym_inline] = ACTIONS(2322),
    [anon_sym___inline] = ACTIONS(2322),
    [anon_sym___inline__] = ACTIONS(2322),
    [anon_sym___forceinline] = ACTIONS(2322),
    [anon_sym_thread_local] = ACTIONS(2322),
    [anon_sym___thread] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_constexpr] = ACTIONS(2322),
    [anon_sym_volatile] = ACTIONS(2322),
    [anon_sym_restrict] = ACTIONS(2322),
    [anon_sym___restrict__] = ACTIONS(2322),
    [anon_sym__Atomic] = ACTIONS(2322),
    [anon_sym__Noreturn] = ACTIONS(2322),
    [anon_sym_noreturn] = ACTIONS(2322),
    [anon_sym__Nonnull] = ACTIONS(2322),
    [anon_sym_mutable] = ACTIONS(2322),
    [anon_sym_constinit] = ACTIONS(2322),
    [anon_sym_consteval] = ACTIONS(2322),
    [anon_sym_alignas] = ACTIONS(2322),
    [anon_sym__Alignas] = ACTIONS(2322),
    [sym_primitive_type] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_class] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2322),
    [anon_sym_switch] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2322),
    [anon_sym_default] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_goto] = ACTIONS(2322),
    [anon_sym___try] = ACTIONS(2322),
    [anon_sym___leave] = ACTIONS(2322),
    [anon_sym_not] = ACTIONS(2322),
    [anon_sym_compl] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2322),
    [anon_sym___alignof__] = ACTIONS(2322),
    [anon_sym___alignof] = ACTIONS(2322),
    [anon_sym__alignof] = ACTIONS(2322),
    [anon_sym_alignof] = ACTIONS(2322),
    [anon_sym__Alignof] = ACTIONS(2322),
    [anon_sym_offsetof] = ACTIONS(2322),
    [anon_sym__Generic] = ACTIONS(2322),
    [anon_sym_asm] = ACTIONS(2322),
    [anon_sym___asm__] = ACTIONS(2322),
    [anon_sym___asm] = ACTIONS(2322),
    [sym_number_literal] = ACTIONS(2324),
    [anon_sym_L_SQUOTE] = ACTIONS(2324),
    [anon_sym_u_SQUOTE] = ACTIONS(2324),
    [anon_sym_U_SQUOTE] = ACTIONS(2324),
    [anon_sym_u8_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_L_DQUOTE] = ACTIONS(2324),
    [anon_sym_u_DQUOTE] = ACTIONS(2324),
    [anon_sym_U_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8_DQUOTE] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [anon_sym_NULL] = ACTIONS(2322),
    [anon_sym_nullptr] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2322),
    [anon_sym_decltype] = ACTIONS(2322),
    [anon_sym_explicit] = ACTIONS(2322),
    [anon_sym_typename] = ACTIONS(2322),
    [anon_sym_export] = ACTIONS(2322),
    [anon_sym_module] = ACTIONS(2322),
    [anon_sym_import] = ACTIONS(2322),
    [anon_sym_template] = ACTIONS(2322),
    [anon_sym_operator] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [anon_sym_delete] = ACTIONS(2322),
    [anon_sym_throw] = ACTIONS(2322),
    [anon_sym_namespace] = ACTIONS(2322),
    [anon_sym_static_assert] = ACTIONS(2322),
    [anon_sym_concept] = ACTIONS(2322),
    [anon_sym_co_return] = ACTIONS(2322),
    [anon_sym_co_yield] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(2324),
    [anon_sym_LR_DQUOTE] = ACTIONS(2324),
    [anon_sym_uR_DQUOTE] = ACTIONS(2324),
    [anon_sym_UR_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2324),
    [anon_sym_co_await] = ACTIONS(2322),
    [anon_sym_new] = ACTIONS(2322),
    [anon_sym_requires] = ACTIONS(2322),
    [sym_this] = ACTIONS(2322),
    [anon_sym_discard] = ACTIONS(2322),
    [anon_sym_precise] = ACTIONS(2322),
    [anon_sym_shared] = ACTIONS(2322),
    [anon_sym_groupshared] = ACTIONS(2322),
    [anon_sym_uniform] = ACTIONS(2322),
    [anon_sym_row_major] = ACTIONS(2322),
    [anon_sym_column_major] = ACTIONS(2322),
    [anon_sym_globallycoherent] = ACTIONS(2322),
    [anon_sym_centroid] = ACTIONS(2322),
    [anon_sym_noperspective] = ACTIONS(2322),
    [anon_sym_nointerpolation] = ACTIONS(2322),
    [anon_sym_sample] = ACTIONS(2322),
    [anon_sym_linear] = ACTIONS(2322),
    [anon_sym_snorm] = ACTIONS(2322),
    [anon_sym_unorm] = ACTIONS(2322),
    [anon_sym_point] = ACTIONS(2322),
    [anon_sym_line] = ACTIONS(2322),
    [anon_sym_triangleadj] = ACTIONS(2322),
    [anon_sym_lineadj] = ACTIONS(2322),
    [anon_sym_triangle] = ACTIONS(2322),
    [anon_sym_cbuffer] = ACTIONS(2322),
  },
  [370] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [371] = {
    [ts_builtin_sym_end] = ACTIONS(2308),
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_preproc_include_token1] = ACTIONS(2306),
    [aux_sym_preproc_def_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2306),
    [sym_preproc_directive] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym_typedef] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_out] = ACTIONS(2306),
    [anon_sym_inout] = ACTIONS(2306),
    [anon_sym_virtual] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2306),
    [anon_sym_using] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2308),
    [anon_sym___declspec] = ACTIONS(2306),
    [anon_sym___based] = ACTIONS(2306),
    [anon_sym___cdecl] = ACTIONS(2306),
    [anon_sym___clrcall] = ACTIONS(2306),
    [anon_sym___stdcall] = ACTIONS(2306),
    [anon_sym___fastcall] = ACTIONS(2306),
    [anon_sym___thiscall] = ACTIONS(2306),
    [anon_sym___vectorcall] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym___inline] = ACTIONS(2306),
    [anon_sym___inline__] = ACTIONS(2306),
    [anon_sym___forceinline] = ACTIONS(2306),
    [anon_sym_thread_local] = ACTIONS(2306),
    [anon_sym___thread] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_class] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2306),
    [anon_sym_default] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_goto] = ACTIONS(2306),
    [anon_sym___try] = ACTIONS(2306),
    [anon_sym___leave] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2306),
    [anon_sym_compl] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2306),
    [anon_sym___alignof__] = ACTIONS(2306),
    [anon_sym___alignof] = ACTIONS(2306),
    [anon_sym__alignof] = ACTIONS(2306),
    [anon_sym_alignof] = ACTIONS(2306),
    [anon_sym__Alignof] = ACTIONS(2306),
    [anon_sym_offsetof] = ACTIONS(2306),
    [anon_sym__Generic] = ACTIONS(2306),
    [anon_sym_asm] = ACTIONS(2306),
    [anon_sym___asm__] = ACTIONS(2306),
    [anon_sym___asm] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2308),
    [anon_sym_L_SQUOTE] = ACTIONS(2308),
    [anon_sym_u_SQUOTE] = ACTIONS(2308),
    [anon_sym_U_SQUOTE] = ACTIONS(2308),
    [anon_sym_u8_SQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_L_DQUOTE] = ACTIONS(2308),
    [anon_sym_u_DQUOTE] = ACTIONS(2308),
    [anon_sym_U_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8_DQUOTE] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [anon_sym_NULL] = ACTIONS(2306),
    [anon_sym_nullptr] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2306),
    [anon_sym_decltype] = ACTIONS(2306),
    [anon_sym_explicit] = ACTIONS(2306),
    [anon_sym_typename] = ACTIONS(2306),
    [anon_sym_export] = ACTIONS(2306),
    [anon_sym_module] = ACTIONS(2306),
    [anon_sym_import] = ACTIONS(2306),
    [anon_sym_template] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [anon_sym_delete] = ACTIONS(2306),
    [anon_sym_throw] = ACTIONS(2306),
    [anon_sym_namespace] = ACTIONS(2306),
    [anon_sym_static_assert] = ACTIONS(2306),
    [anon_sym_concept] = ACTIONS(2306),
    [anon_sym_co_return] = ACTIONS(2306),
    [anon_sym_co_yield] = ACTIONS(2306),
    [anon_sym_R_DQUOTE] = ACTIONS(2308),
    [anon_sym_LR_DQUOTE] = ACTIONS(2308),
    [anon_sym_uR_DQUOTE] = ACTIONS(2308),
    [anon_sym_UR_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2308),
    [anon_sym_co_await] = ACTIONS(2306),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2306),
    [sym_this] = ACTIONS(2306),
    [anon_sym_discard] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2306),
    [anon_sym_shared] = ACTIONS(2306),
    [anon_sym_groupshared] = ACTIONS(2306),
    [anon_sym_uniform] = ACTIONS(2306),
    [anon_sym_row_major] = ACTIONS(2306),
    [anon_sym_column_major] = ACTIONS(2306),
    [anon_sym_globallycoherent] = ACTIONS(2306),
    [anon_sym_centroid] = ACTIONS(2306),
    [anon_sym_noperspective] = ACTIONS(2306),
    [anon_sym_nointerpolation] = ACTIONS(2306),
    [anon_sym_sample] = ACTIONS(2306),
    [anon_sym_linear] = ACTIONS(2306),
    [anon_sym_snorm] = ACTIONS(2306),
    [anon_sym_unorm] = ACTIONS(2306),
    [anon_sym_point] = ACTIONS(2306),
    [anon_sym_line] = ACTIONS(2306),
    [anon_sym_triangleadj] = ACTIONS(2306),
    [anon_sym_lineadj] = ACTIONS(2306),
    [anon_sym_triangle] = ACTIONS(2306),
    [anon_sym_cbuffer] = ACTIONS(2306),
  },
  [372] = {
    [sym_identifier] = ACTIONS(2552),
    [aux_sym_preproc_include_token1] = ACTIONS(2552),
    [aux_sym_preproc_def_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token2] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2552),
    [aux_sym_preproc_else_token1] = ACTIONS(2552),
    [aux_sym_preproc_elif_token1] = ACTIONS(2552),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_TILDE] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym___extension__] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_out] = ACTIONS(2552),
    [anon_sym_inout] = ACTIONS(2552),
    [anon_sym_virtual] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym___attribute__] = ACTIONS(2552),
    [anon_sym___attribute] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym___declspec] = ACTIONS(2552),
    [anon_sym___based] = ACTIONS(2552),
    [anon_sym___cdecl] = ACTIONS(2552),
    [anon_sym___clrcall] = ACTIONS(2552),
    [anon_sym___stdcall] = ACTIONS(2552),
    [anon_sym___fastcall] = ACTIONS(2552),
    [anon_sym___thiscall] = ACTIONS(2552),
    [anon_sym___vectorcall] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_signed] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym___inline] = ACTIONS(2552),
    [anon_sym___inline__] = ACTIONS(2552),
    [anon_sym___forceinline] = ACTIONS(2552),
    [anon_sym_thread_local] = ACTIONS(2552),
    [anon_sym___thread] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym___restrict__] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym__Noreturn] = ACTIONS(2552),
    [anon_sym_noreturn] = ACTIONS(2552),
    [anon_sym__Nonnull] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_constinit] = ACTIONS(2552),
    [anon_sym_consteval] = ACTIONS(2552),
    [anon_sym_alignas] = ACTIONS(2552),
    [anon_sym__Alignas] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_class] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym___try] = ACTIONS(2552),
    [anon_sym___leave] = ACTIONS(2552),
    [anon_sym_not] = ACTIONS(2552),
    [anon_sym_compl] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_sizeof] = ACTIONS(2552),
    [anon_sym___alignof__] = ACTIONS(2552),
    [anon_sym___alignof] = ACTIONS(2552),
    [anon_sym__alignof] = ACTIONS(2552),
    [anon_sym_alignof] = ACTIONS(2552),
    [anon_sym__Alignof] = ACTIONS(2552),
    [anon_sym_offsetof] = ACTIONS(2552),
    [anon_sym__Generic] = ACTIONS(2552),
    [anon_sym_asm] = ACTIONS(2552),
    [anon_sym___asm__] = ACTIONS(2552),
    [anon_sym___asm] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2554),
    [anon_sym_L_SQUOTE] = ACTIONS(2554),
    [anon_sym_u_SQUOTE] = ACTIONS(2554),
    [anon_sym_U_SQUOTE] = ACTIONS(2554),
    [anon_sym_u8_SQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_L_DQUOTE] = ACTIONS(2554),
    [anon_sym_u_DQUOTE] = ACTIONS(2554),
    [anon_sym_U_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8_DQUOTE] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [anon_sym_NULL] = ACTIONS(2552),
    [anon_sym_nullptr] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_decltype] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [anon_sym_delete] = ACTIONS(2552),
    [anon_sym_throw] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_static_assert] = ACTIONS(2552),
    [anon_sym_concept] = ACTIONS(2552),
    [anon_sym_co_return] = ACTIONS(2552),
    [anon_sym_co_yield] = ACTIONS(2552),
    [anon_sym_R_DQUOTE] = ACTIONS(2554),
    [anon_sym_LR_DQUOTE] = ACTIONS(2554),
    [anon_sym_uR_DQUOTE] = ACTIONS(2554),
    [anon_sym_UR_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2554),
    [anon_sym_co_await] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2552),
    [anon_sym_discard] = ACTIONS(2552),
    [anon_sym_precise] = ACTIONS(2552),
    [anon_sym_shared] = ACTIONS(2552),
    [anon_sym_groupshared] = ACTIONS(2552),
    [anon_sym_uniform] = ACTIONS(2552),
    [anon_sym_row_major] = ACTIONS(2552),
    [anon_sym_column_major] = ACTIONS(2552),
    [anon_sym_globallycoherent] = ACTIONS(2552),
    [anon_sym_centroid] = ACTIONS(2552),
    [anon_sym_noperspective] = ACTIONS(2552),
    [anon_sym_nointerpolation] = ACTIONS(2552),
    [anon_sym_sample] = ACTIONS(2552),
    [anon_sym_linear] = ACTIONS(2552),
    [anon_sym_snorm] = ACTIONS(2552),
    [anon_sym_unorm] = ACTIONS(2552),
    [anon_sym_point] = ACTIONS(2552),
    [anon_sym_line] = ACTIONS(2552),
    [anon_sym_triangleadj] = ACTIONS(2552),
    [anon_sym_lineadj] = ACTIONS(2552),
    [anon_sym_triangle] = ACTIONS(2552),
    [anon_sym_cbuffer] = ACTIONS(2552),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(2352),
    [sym_identifier] = ACTIONS(2350),
    [aux_sym_preproc_include_token1] = ACTIONS(2350),
    [aux_sym_preproc_def_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2350),
    [sym_preproc_directive] = ACTIONS(2350),
    [anon_sym_LPAREN2] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2350),
    [anon_sym_typedef] = ACTIONS(2350),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_out] = ACTIONS(2350),
    [anon_sym_inout] = ACTIONS(2350),
    [anon_sym_virtual] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym___attribute__] = ACTIONS(2350),
    [anon_sym___attribute] = ACTIONS(2350),
    [anon_sym_using] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2352),
    [anon_sym___declspec] = ACTIONS(2350),
    [anon_sym___based] = ACTIONS(2350),
    [anon_sym___cdecl] = ACTIONS(2350),
    [anon_sym___clrcall] = ACTIONS(2350),
    [anon_sym___stdcall] = ACTIONS(2350),
    [anon_sym___fastcall] = ACTIONS(2350),
    [anon_sym___thiscall] = ACTIONS(2350),
    [anon_sym___vectorcall] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_signed] = ACTIONS(2350),
    [anon_sym_unsigned] = ACTIONS(2350),
    [anon_sym_long] = ACTIONS(2350),
    [anon_sym_short] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_register] = ACTIONS(2350),
    [anon_sym_inline] = ACTIONS(2350),
    [anon_sym___inline] = ACTIONS(2350),
    [anon_sym___inline__] = ACTIONS(2350),
    [anon_sym___forceinline] = ACTIONS(2350),
    [anon_sym_thread_local] = ACTIONS(2350),
    [anon_sym___thread] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym___restrict__] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym__Noreturn] = ACTIONS(2350),
    [anon_sym_noreturn] = ACTIONS(2350),
    [anon_sym__Nonnull] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_constinit] = ACTIONS(2350),
    [anon_sym_consteval] = ACTIONS(2350),
    [anon_sym_alignas] = ACTIONS(2350),
    [anon_sym__Alignas] = ACTIONS(2350),
    [sym_primitive_type] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_goto] = ACTIONS(2350),
    [anon_sym___try] = ACTIONS(2350),
    [anon_sym___leave] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2350),
    [anon_sym_compl] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2350),
    [anon_sym___alignof__] = ACTIONS(2350),
    [anon_sym___alignof] = ACTIONS(2350),
    [anon_sym__alignof] = ACTIONS(2350),
    [anon_sym_alignof] = ACTIONS(2350),
    [anon_sym__Alignof] = ACTIONS(2350),
    [anon_sym_offsetof] = ACTIONS(2350),
    [anon_sym__Generic] = ACTIONS(2350),
    [anon_sym_asm] = ACTIONS(2350),
    [anon_sym___asm__] = ACTIONS(2350),
    [anon_sym___asm] = ACTIONS(2350),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_L_SQUOTE] = ACTIONS(2352),
    [anon_sym_u_SQUOTE] = ACTIONS(2352),
    [anon_sym_U_SQUOTE] = ACTIONS(2352),
    [anon_sym_u8_SQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_L_DQUOTE] = ACTIONS(2352),
    [anon_sym_u_DQUOTE] = ACTIONS(2352),
    [anon_sym_U_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8_DQUOTE] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [anon_sym_NULL] = ACTIONS(2350),
    [anon_sym_nullptr] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2350),
    [anon_sym_decltype] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_typename] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2350),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_import] = ACTIONS(2350),
    [anon_sym_template] = ACTIONS(2350),
    [anon_sym_operator] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_static_assert] = ACTIONS(2350),
    [anon_sym_concept] = ACTIONS(2350),
    [anon_sym_co_return] = ACTIONS(2350),
    [anon_sym_co_yield] = ACTIONS(2350),
    [anon_sym_R_DQUOTE] = ACTIONS(2352),
    [anon_sym_LR_DQUOTE] = ACTIONS(2352),
    [anon_sym_uR_DQUOTE] = ACTIONS(2352),
    [anon_sym_UR_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2352),
    [anon_sym_co_await] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_requires] = ACTIONS(2350),
    [sym_this] = ACTIONS(2350),
    [anon_sym_discard] = ACTIONS(2350),
    [anon_sym_precise] = ACTIONS(2350),
    [anon_sym_shared] = ACTIONS(2350),
    [anon_sym_groupshared] = ACTIONS(2350),
    [anon_sym_uniform] = ACTIONS(2350),
    [anon_sym_row_major] = ACTIONS(2350),
    [anon_sym_column_major] = ACTIONS(2350),
    [anon_sym_globallycoherent] = ACTIONS(2350),
    [anon_sym_centroid] = ACTIONS(2350),
    [anon_sym_noperspective] = ACTIONS(2350),
    [anon_sym_nointerpolation] = ACTIONS(2350),
    [anon_sym_sample] = ACTIONS(2350),
    [anon_sym_linear] = ACTIONS(2350),
    [anon_sym_snorm] = ACTIONS(2350),
    [anon_sym_unorm] = ACTIONS(2350),
    [anon_sym_point] = ACTIONS(2350),
    [anon_sym_line] = ACTIONS(2350),
    [anon_sym_triangleadj] = ACTIONS(2350),
    [anon_sym_lineadj] = ACTIONS(2350),
    [anon_sym_triangle] = ACTIONS(2350),
    [anon_sym_cbuffer] = ACTIONS(2350),
  },
  [374] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(2384),
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_include_token1] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym___cdecl] = ACTIONS(2382),
    [anon_sym___clrcall] = ACTIONS(2382),
    [anon_sym___stdcall] = ACTIONS(2382),
    [anon_sym___fastcall] = ACTIONS(2382),
    [anon_sym___thiscall] = ACTIONS(2382),
    [anon_sym___vectorcall] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2382),
    [anon_sym___leave] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2382),
    [anon_sym_compl] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2382),
    [anon_sym___alignof__] = ACTIONS(2382),
    [anon_sym___alignof] = ACTIONS(2382),
    [anon_sym__alignof] = ACTIONS(2382),
    [anon_sym_alignof] = ACTIONS(2382),
    [anon_sym__Alignof] = ACTIONS(2382),
    [anon_sym_offsetof] = ACTIONS(2382),
    [anon_sym__Generic] = ACTIONS(2382),
    [anon_sym_asm] = ACTIONS(2382),
    [anon_sym___asm__] = ACTIONS(2382),
    [anon_sym___asm] = ACTIONS(2382),
    [sym_number_literal] = ACTIONS(2384),
    [anon_sym_L_SQUOTE] = ACTIONS(2384),
    [anon_sym_u_SQUOTE] = ACTIONS(2384),
    [anon_sym_U_SQUOTE] = ACTIONS(2384),
    [anon_sym_u8_SQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_L_DQUOTE] = ACTIONS(2384),
    [anon_sym_u_DQUOTE] = ACTIONS(2384),
    [anon_sym_U_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8_DQUOTE] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_export] = ACTIONS(2382),
    [anon_sym_module] = ACTIONS(2382),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_concept] = ACTIONS(2382),
    [anon_sym_co_return] = ACTIONS(2382),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2384),
    [anon_sym_LR_DQUOTE] = ACTIONS(2384),
    [anon_sym_uR_DQUOTE] = ACTIONS(2384),
    [anon_sym_UR_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2384),
    [anon_sym_co_await] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_requires] = ACTIONS(2382),
    [sym_this] = ACTIONS(2382),
    [anon_sym_discard] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
    [anon_sym_cbuffer] = ACTIONS(2382),
  },
  [376] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [aux_sym_preproc_else_token1] = ACTIONS(2556),
    [aux_sym_preproc_elif_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [377] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [aux_sym_preproc_else_token1] = ACTIONS(2556),
    [aux_sym_preproc_elif_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [378] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_include_token1] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token2] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [aux_sym_preproc_else_token1] = ACTIONS(2560),
    [aux_sym_preproc_elif_token1] = ACTIONS(2560),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym___cdecl] = ACTIONS(2560),
    [anon_sym___clrcall] = ACTIONS(2560),
    [anon_sym___stdcall] = ACTIONS(2560),
    [anon_sym___fastcall] = ACTIONS(2560),
    [anon_sym___thiscall] = ACTIONS(2560),
    [anon_sym___vectorcall] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_switch] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_do] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(2560),
    [anon_sym___try] = ACTIONS(2560),
    [anon_sym___leave] = ACTIONS(2560),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2560),
    [anon_sym___alignof__] = ACTIONS(2560),
    [anon_sym___alignof] = ACTIONS(2560),
    [anon_sym__alignof] = ACTIONS(2560),
    [anon_sym_alignof] = ACTIONS(2560),
    [anon_sym__Alignof] = ACTIONS(2560),
    [anon_sym_offsetof] = ACTIONS(2560),
    [anon_sym__Generic] = ACTIONS(2560),
    [anon_sym_asm] = ACTIONS(2560),
    [anon_sym___asm__] = ACTIONS(2560),
    [anon_sym___asm] = ACTIONS(2560),
    [sym_number_literal] = ACTIONS(2562),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2560),
    [sym_false] = ACTIONS(2560),
    [anon_sym_NULL] = ACTIONS(2560),
    [anon_sym_nullptr] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [anon_sym_delete] = ACTIONS(2560),
    [anon_sym_throw] = ACTIONS(2560),
    [anon_sym_namespace] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_concept] = ACTIONS(2560),
    [anon_sym_co_return] = ACTIONS(2560),
    [anon_sym_co_yield] = ACTIONS(2560),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2560),
    [anon_sym_new] = ACTIONS(2560),
    [anon_sym_requires] = ACTIONS(2560),
    [sym_this] = ACTIONS(2560),
    [anon_sym_discard] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
    [anon_sym_cbuffer] = ACTIONS(2560),
  },
  [379] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_include_token1] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token2] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [aux_sym_preproc_else_token1] = ACTIONS(2564),
    [aux_sym_preproc_elif_token1] = ACTIONS(2564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym___cdecl] = ACTIONS(2564),
    [anon_sym___clrcall] = ACTIONS(2564),
    [anon_sym___stdcall] = ACTIONS(2564),
    [anon_sym___fastcall] = ACTIONS(2564),
    [anon_sym___thiscall] = ACTIONS(2564),
    [anon_sym___vectorcall] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_switch] = ACTIONS(2564),
    [anon_sym_case] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_goto] = ACTIONS(2564),
    [anon_sym___try] = ACTIONS(2564),
    [anon_sym___leave] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2564),
    [anon_sym_compl] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2566),
    [anon_sym_sizeof] = ACTIONS(2564),
    [anon_sym___alignof__] = ACTIONS(2564),
    [anon_sym___alignof] = ACTIONS(2564),
    [anon_sym__alignof] = ACTIONS(2564),
    [anon_sym_alignof] = ACTIONS(2564),
    [anon_sym__Alignof] = ACTIONS(2564),
    [anon_sym_offsetof] = ACTIONS(2564),
    [anon_sym__Generic] = ACTIONS(2564),
    [anon_sym_asm] = ACTIONS(2564),
    [anon_sym___asm__] = ACTIONS(2564),
    [anon_sym___asm] = ACTIONS(2564),
    [sym_number_literal] = ACTIONS(2566),
    [anon_sym_L_SQUOTE] = ACTIONS(2566),
    [anon_sym_u_SQUOTE] = ACTIONS(2566),
    [anon_sym_U_SQUOTE] = ACTIONS(2566),
    [anon_sym_u8_SQUOTE] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_L_DQUOTE] = ACTIONS(2566),
    [anon_sym_u_DQUOTE] = ACTIONS(2566),
    [anon_sym_U_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8_DQUOTE] = ACTIONS(2566),
    [anon_sym_DQUOTE] = ACTIONS(2566),
    [sym_true] = ACTIONS(2564),
    [sym_false] = ACTIONS(2564),
    [anon_sym_NULL] = ACTIONS(2564),
    [anon_sym_nullptr] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [anon_sym_delete] = ACTIONS(2564),
    [anon_sym_throw] = ACTIONS(2564),
    [anon_sym_namespace] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_concept] = ACTIONS(2564),
    [anon_sym_co_return] = ACTIONS(2564),
    [anon_sym_co_yield] = ACTIONS(2564),
    [anon_sym_R_DQUOTE] = ACTIONS(2566),
    [anon_sym_LR_DQUOTE] = ACTIONS(2566),
    [anon_sym_uR_DQUOTE] = ACTIONS(2566),
    [anon_sym_UR_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2566),
    [anon_sym_co_await] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2564),
    [anon_sym_requires] = ACTIONS(2564),
    [sym_this] = ACTIONS(2564),
    [anon_sym_discard] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
    [anon_sym_cbuffer] = ACTIONS(2564),
  },
  [380] = {
    [sym_identifier] = ACTIONS(2568),
    [aux_sym_preproc_include_token1] = ACTIONS(2568),
    [aux_sym_preproc_def_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token2] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2568),
    [aux_sym_preproc_else_token1] = ACTIONS(2568),
    [aux_sym_preproc_elif_token1] = ACTIONS(2568),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2568),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2568),
    [sym_preproc_directive] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_out] = ACTIONS(2568),
    [anon_sym_inout] = ACTIONS(2568),
    [anon_sym_virtual] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym___attribute__] = ACTIONS(2568),
    [anon_sym___attribute] = ACTIONS(2568),
    [anon_sym_using] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2570),
    [anon_sym___declspec] = ACTIONS(2568),
    [anon_sym___based] = ACTIONS(2568),
    [anon_sym___cdecl] = ACTIONS(2568),
    [anon_sym___clrcall] = ACTIONS(2568),
    [anon_sym___stdcall] = ACTIONS(2568),
    [anon_sym___fastcall] = ACTIONS(2568),
    [anon_sym___thiscall] = ACTIONS(2568),
    [anon_sym___vectorcall] = ACTIONS(2568),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2568),
    [anon_sym_unsigned] = ACTIONS(2568),
    [anon_sym_long] = ACTIONS(2568),
    [anon_sym_short] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_register] = ACTIONS(2568),
    [anon_sym_inline] = ACTIONS(2568),
    [anon_sym___inline] = ACTIONS(2568),
    [anon_sym___inline__] = ACTIONS(2568),
    [anon_sym___forceinline] = ACTIONS(2568),
    [anon_sym_thread_local] = ACTIONS(2568),
    [anon_sym___thread] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_constexpr] = ACTIONS(2568),
    [anon_sym_volatile] = ACTIONS(2568),
    [anon_sym_restrict] = ACTIONS(2568),
    [anon_sym___restrict__] = ACTIONS(2568),
    [anon_sym__Atomic] = ACTIONS(2568),
    [anon_sym__Noreturn] = ACTIONS(2568),
    [anon_sym_noreturn] = ACTIONS(2568),
    [anon_sym__Nonnull] = ACTIONS(2568),
    [anon_sym_mutable] = ACTIONS(2568),
    [anon_sym_constinit] = ACTIONS(2568),
    [anon_sym_consteval] = ACTIONS(2568),
    [anon_sym_alignas] = ACTIONS(2568),
    [anon_sym__Alignas] = ACTIONS(2568),
    [sym_primitive_type] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_class] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_switch] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_goto] = ACTIONS(2568),
    [anon_sym___try] = ACTIONS(2568),
    [anon_sym___leave] = ACTIONS(2568),
    [anon_sym_not] = ACTIONS(2568),
    [anon_sym_compl] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(2570),
    [anon_sym_sizeof] = ACTIONS(2568),
    [anon_sym___alignof__] = ACTIONS(2568),
    [anon_sym___alignof] = ACTIONS(2568),
    [anon_sym__alignof] = ACTIONS(2568),
    [anon_sym_alignof] = ACTIONS(2568),
    [anon_sym__Alignof] = ACTIONS(2568),
    [anon_sym_offsetof] = ACTIONS(2568),
    [anon_sym__Generic] = ACTIONS(2568),
    [anon_sym_asm] = ACTIONS(2568),
    [anon_sym___asm__] = ACTIONS(2568),
    [anon_sym___asm] = ACTIONS(2568),
    [sym_number_literal] = ACTIONS(2570),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2570),
    [anon_sym_u_DQUOTE] = ACTIONS(2570),
    [anon_sym_U_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8_DQUOTE] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2570),
    [sym_true] = ACTIONS(2568),
    [sym_false] = ACTIONS(2568),
    [anon_sym_NULL] = ACTIONS(2568),
    [anon_sym_nullptr] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2568),
    [anon_sym_decltype] = ACTIONS(2568),
    [anon_sym_explicit] = ACTIONS(2568),
    [anon_sym_typename] = ACTIONS(2568),
    [anon_sym_template] = ACTIONS(2568),
    [anon_sym_operator] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2568),
    [anon_sym_throw] = ACTIONS(2568),
    [anon_sym_namespace] = ACTIONS(2568),
    [anon_sym_static_assert] = ACTIONS(2568),
    [anon_sym_concept] = ACTIONS(2568),
    [anon_sym_co_return] = ACTIONS(2568),
    [anon_sym_co_yield] = ACTIONS(2568),
    [anon_sym_R_DQUOTE] = ACTIONS(2570),
    [anon_sym_LR_DQUOTE] = ACTIONS(2570),
    [anon_sym_uR_DQUOTE] = ACTIONS(2570),
    [anon_sym_UR_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2570),
    [anon_sym_co_await] = ACTIONS(2568),
    [anon_sym_new] = ACTIONS(2568),
    [anon_sym_requires] = ACTIONS(2568),
    [sym_this] = ACTIONS(2568),
    [anon_sym_discard] = ACTIONS(2568),
    [anon_sym_precise] = ACTIONS(2568),
    [anon_sym_shared] = ACTIONS(2568),
    [anon_sym_groupshared] = ACTIONS(2568),
    [anon_sym_uniform] = ACTIONS(2568),
    [anon_sym_row_major] = ACTIONS(2568),
    [anon_sym_column_major] = ACTIONS(2568),
    [anon_sym_globallycoherent] = ACTIONS(2568),
    [anon_sym_centroid] = ACTIONS(2568),
    [anon_sym_noperspective] = ACTIONS(2568),
    [anon_sym_nointerpolation] = ACTIONS(2568),
    [anon_sym_sample] = ACTIONS(2568),
    [anon_sym_linear] = ACTIONS(2568),
    [anon_sym_snorm] = ACTIONS(2568),
    [anon_sym_unorm] = ACTIONS(2568),
    [anon_sym_point] = ACTIONS(2568),
    [anon_sym_line] = ACTIONS(2568),
    [anon_sym_triangleadj] = ACTIONS(2568),
    [anon_sym_lineadj] = ACTIONS(2568),
    [anon_sym_triangle] = ACTIONS(2568),
    [anon_sym_cbuffer] = ACTIONS(2568),
  },
  [381] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_include_token1] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token2] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [aux_sym_preproc_else_token1] = ACTIONS(2572),
    [aux_sym_preproc_elif_token1] = ACTIONS(2572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym___cdecl] = ACTIONS(2572),
    [anon_sym___clrcall] = ACTIONS(2572),
    [anon_sym___stdcall] = ACTIONS(2572),
    [anon_sym___fastcall] = ACTIONS(2572),
    [anon_sym___thiscall] = ACTIONS(2572),
    [anon_sym___vectorcall] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_goto] = ACTIONS(2572),
    [anon_sym___try] = ACTIONS(2572),
    [anon_sym___leave] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2572),
    [anon_sym_compl] = ACTIONS(2572),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_sizeof] = ACTIONS(2572),
    [anon_sym___alignof__] = ACTIONS(2572),
    [anon_sym___alignof] = ACTIONS(2572),
    [anon_sym__alignof] = ACTIONS(2572),
    [anon_sym_alignof] = ACTIONS(2572),
    [anon_sym__Alignof] = ACTIONS(2572),
    [anon_sym_offsetof] = ACTIONS(2572),
    [anon_sym__Generic] = ACTIONS(2572),
    [anon_sym_asm] = ACTIONS(2572),
    [anon_sym___asm__] = ACTIONS(2572),
    [anon_sym___asm] = ACTIONS(2572),
    [sym_number_literal] = ACTIONS(2574),
    [anon_sym_L_SQUOTE] = ACTIONS(2574),
    [anon_sym_u_SQUOTE] = ACTIONS(2574),
    [anon_sym_U_SQUOTE] = ACTIONS(2574),
    [anon_sym_u8_SQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_L_DQUOTE] = ACTIONS(2574),
    [anon_sym_u_DQUOTE] = ACTIONS(2574),
    [anon_sym_U_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8_DQUOTE] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [anon_sym_NULL] = ACTIONS(2572),
    [anon_sym_nullptr] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_concept] = ACTIONS(2572),
    [anon_sym_co_return] = ACTIONS(2572),
    [anon_sym_co_yield] = ACTIONS(2572),
    [anon_sym_R_DQUOTE] = ACTIONS(2574),
    [anon_sym_LR_DQUOTE] = ACTIONS(2574),
    [anon_sym_uR_DQUOTE] = ACTIONS(2574),
    [anon_sym_UR_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2574),
    [anon_sym_co_await] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_requires] = ACTIONS(2572),
    [sym_this] = ACTIONS(2572),
    [anon_sym_discard] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
    [anon_sym_cbuffer] = ACTIONS(2572),
  },
  [382] = {
    [sym_identifier] = ACTIONS(2576),
    [aux_sym_preproc_include_token1] = ACTIONS(2576),
    [aux_sym_preproc_def_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token2] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2576),
    [aux_sym_preproc_else_token1] = ACTIONS(2576),
    [aux_sym_preproc_elif_token1] = ACTIONS(2576),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2576),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2576),
    [sym_preproc_directive] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym___extension__] = ACTIONS(2576),
    [anon_sym_typedef] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2576),
    [anon_sym_out] = ACTIONS(2576),
    [anon_sym_inout] = ACTIONS(2576),
    [anon_sym_virtual] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym___attribute__] = ACTIONS(2576),
    [anon_sym___attribute] = ACTIONS(2576),
    [anon_sym_using] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2578),
    [anon_sym___declspec] = ACTIONS(2576),
    [anon_sym___based] = ACTIONS(2576),
    [anon_sym___cdecl] = ACTIONS(2576),
    [anon_sym___clrcall] = ACTIONS(2576),
    [anon_sym___stdcall] = ACTIONS(2576),
    [anon_sym___fastcall] = ACTIONS(2576),
    [anon_sym___thiscall] = ACTIONS(2576),
    [anon_sym___vectorcall] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_signed] = ACTIONS(2576),
    [anon_sym_unsigned] = ACTIONS(2576),
    [anon_sym_long] = ACTIONS(2576),
    [anon_sym_short] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_register] = ACTIONS(2576),
    [anon_sym_inline] = ACTIONS(2576),
    [anon_sym___inline] = ACTIONS(2576),
    [anon_sym___inline__] = ACTIONS(2576),
    [anon_sym___forceinline] = ACTIONS(2576),
    [anon_sym_thread_local] = ACTIONS(2576),
    [anon_sym___thread] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_constexpr] = ACTIONS(2576),
    [anon_sym_volatile] = ACTIONS(2576),
    [anon_sym_restrict] = ACTIONS(2576),
    [anon_sym___restrict__] = ACTIONS(2576),
    [anon_sym__Atomic] = ACTIONS(2576),
    [anon_sym__Noreturn] = ACTIONS(2576),
    [anon_sym_noreturn] = ACTIONS(2576),
    [anon_sym__Nonnull] = ACTIONS(2576),
    [anon_sym_mutable] = ACTIONS(2576),
    [anon_sym_constinit] = ACTIONS(2576),
    [anon_sym_consteval] = ACTIONS(2576),
    [anon_sym_alignas] = ACTIONS(2576),
    [anon_sym__Alignas] = ACTIONS(2576),
    [sym_primitive_type] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_goto] = ACTIONS(2576),
    [anon_sym___try] = ACTIONS(2576),
    [anon_sym___leave] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2576),
    [anon_sym_compl] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2578),
    [anon_sym_sizeof] = ACTIONS(2576),
    [anon_sym___alignof__] = ACTIONS(2576),
    [anon_sym___alignof] = ACTIONS(2576),
    [anon_sym__alignof] = ACTIONS(2576),
    [anon_sym_alignof] = ACTIONS(2576),
    [anon_sym__Alignof] = ACTIONS(2576),
    [anon_sym_offsetof] = ACTIONS(2576),
    [anon_sym__Generic] = ACTIONS(2576),
    [anon_sym_asm] = ACTIONS(2576),
    [anon_sym___asm__] = ACTIONS(2576),
    [anon_sym___asm] = ACTIONS(2576),
    [sym_number_literal] = ACTIONS(2578),
    [anon_sym_L_SQUOTE] = ACTIONS(2578),
    [anon_sym_u_SQUOTE] = ACTIONS(2578),
    [anon_sym_U_SQUOTE] = ACTIONS(2578),
    [anon_sym_u8_SQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_L_DQUOTE] = ACTIONS(2578),
    [anon_sym_u_DQUOTE] = ACTIONS(2578),
    [anon_sym_U_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8_DQUOTE] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_NULL] = ACTIONS(2576),
    [anon_sym_nullptr] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2576),
    [anon_sym_decltype] = ACTIONS(2576),
    [anon_sym_explicit] = ACTIONS(2576),
    [anon_sym_typename] = ACTIONS(2576),
    [anon_sym_template] = ACTIONS(2576),
    [anon_sym_operator] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_static_assert] = ACTIONS(2576),
    [anon_sym_concept] = ACTIONS(2576),
    [anon_sym_co_return] = ACTIONS(2576),
    [anon_sym_co_yield] = ACTIONS(2576),
    [anon_sym_R_DQUOTE] = ACTIONS(2578),
    [anon_sym_LR_DQUOTE] = ACTIONS(2578),
    [anon_sym_uR_DQUOTE] = ACTIONS(2578),
    [anon_sym_UR_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2578),
    [anon_sym_co_await] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_requires] = ACTIONS(2576),
    [sym_this] = ACTIONS(2576),
    [anon_sym_discard] = ACTIONS(2576),
    [anon_sym_precise] = ACTIONS(2576),
    [anon_sym_shared] = ACTIONS(2576),
    [anon_sym_groupshared] = ACTIONS(2576),
    [anon_sym_uniform] = ACTIONS(2576),
    [anon_sym_row_major] = ACTIONS(2576),
    [anon_sym_column_major] = ACTIONS(2576),
    [anon_sym_globallycoherent] = ACTIONS(2576),
    [anon_sym_centroid] = ACTIONS(2576),
    [anon_sym_noperspective] = ACTIONS(2576),
    [anon_sym_nointerpolation] = ACTIONS(2576),
    [anon_sym_sample] = ACTIONS(2576),
    [anon_sym_linear] = ACTIONS(2576),
    [anon_sym_snorm] = ACTIONS(2576),
    [anon_sym_unorm] = ACTIONS(2576),
    [anon_sym_point] = ACTIONS(2576),
    [anon_sym_line] = ACTIONS(2576),
    [anon_sym_triangleadj] = ACTIONS(2576),
    [anon_sym_lineadj] = ACTIONS(2576),
    [anon_sym_triangle] = ACTIONS(2576),
    [anon_sym_cbuffer] = ACTIONS(2576),
  },
  [383] = {
    [sym_identifier] = ACTIONS(2580),
    [aux_sym_preproc_include_token1] = ACTIONS(2580),
    [aux_sym_preproc_def_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token2] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2580),
    [aux_sym_preproc_else_token1] = ACTIONS(2580),
    [aux_sym_preproc_elif_token1] = ACTIONS(2580),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2580),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2580),
    [sym_preproc_directive] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym___extension__] = ACTIONS(2580),
    [anon_sym_typedef] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2580),
    [anon_sym_out] = ACTIONS(2580),
    [anon_sym_inout] = ACTIONS(2580),
    [anon_sym_virtual] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym___attribute__] = ACTIONS(2580),
    [anon_sym___attribute] = ACTIONS(2580),
    [anon_sym_using] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2582),
    [anon_sym___declspec] = ACTIONS(2580),
    [anon_sym___based] = ACTIONS(2580),
    [anon_sym___cdecl] = ACTIONS(2580),
    [anon_sym___clrcall] = ACTIONS(2580),
    [anon_sym___stdcall] = ACTIONS(2580),
    [anon_sym___fastcall] = ACTIONS(2580),
    [anon_sym___thiscall] = ACTIONS(2580),
    [anon_sym___vectorcall] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_signed] = ACTIONS(2580),
    [anon_sym_unsigned] = ACTIONS(2580),
    [anon_sym_long] = ACTIONS(2580),
    [anon_sym_short] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_register] = ACTIONS(2580),
    [anon_sym_inline] = ACTIONS(2580),
    [anon_sym___inline] = ACTIONS(2580),
    [anon_sym___inline__] = ACTIONS(2580),
    [anon_sym___forceinline] = ACTIONS(2580),
    [anon_sym_thread_local] = ACTIONS(2580),
    [anon_sym___thread] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_constexpr] = ACTIONS(2580),
    [anon_sym_volatile] = ACTIONS(2580),
    [anon_sym_restrict] = ACTIONS(2580),
    [anon_sym___restrict__] = ACTIONS(2580),
    [anon_sym__Atomic] = ACTIONS(2580),
    [anon_sym__Noreturn] = ACTIONS(2580),
    [anon_sym_noreturn] = ACTIONS(2580),
    [anon_sym__Nonnull] = ACTIONS(2580),
    [anon_sym_mutable] = ACTIONS(2580),
    [anon_sym_constinit] = ACTIONS(2580),
    [anon_sym_consteval] = ACTIONS(2580),
    [anon_sym_alignas] = ACTIONS(2580),
    [anon_sym__Alignas] = ACTIONS(2580),
    [sym_primitive_type] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_goto] = ACTIONS(2580),
    [anon_sym___try] = ACTIONS(2580),
    [anon_sym___leave] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2580),
    [anon_sym_compl] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_sizeof] = ACTIONS(2580),
    [anon_sym___alignof__] = ACTIONS(2580),
    [anon_sym___alignof] = ACTIONS(2580),
    [anon_sym__alignof] = ACTIONS(2580),
    [anon_sym_alignof] = ACTIONS(2580),
    [anon_sym__Alignof] = ACTIONS(2580),
    [anon_sym_offsetof] = ACTIONS(2580),
    [anon_sym__Generic] = ACTIONS(2580),
    [anon_sym_asm] = ACTIONS(2580),
    [anon_sym___asm__] = ACTIONS(2580),
    [anon_sym___asm] = ACTIONS(2580),
    [sym_number_literal] = ACTIONS(2582),
    [anon_sym_L_SQUOTE] = ACTIONS(2582),
    [anon_sym_u_SQUOTE] = ACTIONS(2582),
    [anon_sym_U_SQUOTE] = ACTIONS(2582),
    [anon_sym_u8_SQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_L_DQUOTE] = ACTIONS(2582),
    [anon_sym_u_DQUOTE] = ACTIONS(2582),
    [anon_sym_U_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8_DQUOTE] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [anon_sym_NULL] = ACTIONS(2580),
    [anon_sym_nullptr] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2580),
    [anon_sym_decltype] = ACTIONS(2580),
    [anon_sym_explicit] = ACTIONS(2580),
    [anon_sym_typename] = ACTIONS(2580),
    [anon_sym_template] = ACTIONS(2580),
    [anon_sym_operator] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_static_assert] = ACTIONS(2580),
    [anon_sym_concept] = ACTIONS(2580),
    [anon_sym_co_return] = ACTIONS(2580),
    [anon_sym_co_yield] = ACTIONS(2580),
    [anon_sym_R_DQUOTE] = ACTIONS(2582),
    [anon_sym_LR_DQUOTE] = ACTIONS(2582),
    [anon_sym_uR_DQUOTE] = ACTIONS(2582),
    [anon_sym_UR_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2582),
    [anon_sym_co_await] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2580),
    [sym_this] = ACTIONS(2580),
    [anon_sym_discard] = ACTIONS(2580),
    [anon_sym_precise] = ACTIONS(2580),
    [anon_sym_shared] = ACTIONS(2580),
    [anon_sym_groupshared] = ACTIONS(2580),
    [anon_sym_uniform] = ACTIONS(2580),
    [anon_sym_row_major] = ACTIONS(2580),
    [anon_sym_column_major] = ACTIONS(2580),
    [anon_sym_globallycoherent] = ACTIONS(2580),
    [anon_sym_centroid] = ACTIONS(2580),
    [anon_sym_noperspective] = ACTIONS(2580),
    [anon_sym_nointerpolation] = ACTIONS(2580),
    [anon_sym_sample] = ACTIONS(2580),
    [anon_sym_linear] = ACTIONS(2580),
    [anon_sym_snorm] = ACTIONS(2580),
    [anon_sym_unorm] = ACTIONS(2580),
    [anon_sym_point] = ACTIONS(2580),
    [anon_sym_line] = ACTIONS(2580),
    [anon_sym_triangleadj] = ACTIONS(2580),
    [anon_sym_lineadj] = ACTIONS(2580),
    [anon_sym_triangle] = ACTIONS(2580),
    [anon_sym_cbuffer] = ACTIONS(2580),
  },
  [384] = {
    [sym_identifier] = ACTIONS(2584),
    [aux_sym_preproc_include_token1] = ACTIONS(2584),
    [aux_sym_preproc_def_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token2] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2584),
    [aux_sym_preproc_else_token1] = ACTIONS(2584),
    [aux_sym_preproc_elif_token1] = ACTIONS(2584),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2584),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2584),
    [sym_preproc_directive] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym___extension__] = ACTIONS(2584),
    [anon_sym_typedef] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2584),
    [anon_sym_out] = ACTIONS(2584),
    [anon_sym_inout] = ACTIONS(2584),
    [anon_sym_virtual] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym___attribute] = ACTIONS(2584),
    [anon_sym_using] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2586),
    [anon_sym___declspec] = ACTIONS(2584),
    [anon_sym___based] = ACTIONS(2584),
    [anon_sym___cdecl] = ACTIONS(2584),
    [anon_sym___clrcall] = ACTIONS(2584),
    [anon_sym___stdcall] = ACTIONS(2584),
    [anon_sym___fastcall] = ACTIONS(2584),
    [anon_sym___thiscall] = ACTIONS(2584),
    [anon_sym___vectorcall] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_signed] = ACTIONS(2584),
    [anon_sym_unsigned] = ACTIONS(2584),
    [anon_sym_long] = ACTIONS(2584),
    [anon_sym_short] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_register] = ACTIONS(2584),
    [anon_sym_inline] = ACTIONS(2584),
    [anon_sym___inline] = ACTIONS(2584),
    [anon_sym___inline__] = ACTIONS(2584),
    [anon_sym___forceinline] = ACTIONS(2584),
    [anon_sym_thread_local] = ACTIONS(2584),
    [anon_sym___thread] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_constexpr] = ACTIONS(2584),
    [anon_sym_volatile] = ACTIONS(2584),
    [anon_sym_restrict] = ACTIONS(2584),
    [anon_sym___restrict__] = ACTIONS(2584),
    [anon_sym__Atomic] = ACTIONS(2584),
    [anon_sym__Noreturn] = ACTIONS(2584),
    [anon_sym_noreturn] = ACTIONS(2584),
    [anon_sym__Nonnull] = ACTIONS(2584),
    [anon_sym_mutable] = ACTIONS(2584),
    [anon_sym_constinit] = ACTIONS(2584),
    [anon_sym_consteval] = ACTIONS(2584),
    [anon_sym_alignas] = ACTIONS(2584),
    [anon_sym__Alignas] = ACTIONS(2584),
    [sym_primitive_type] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_goto] = ACTIONS(2584),
    [anon_sym___try] = ACTIONS(2584),
    [anon_sym___leave] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2584),
    [anon_sym_compl] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_sizeof] = ACTIONS(2584),
    [anon_sym___alignof__] = ACTIONS(2584),
    [anon_sym___alignof] = ACTIONS(2584),
    [anon_sym__alignof] = ACTIONS(2584),
    [anon_sym_alignof] = ACTIONS(2584),
    [anon_sym__Alignof] = ACTIONS(2584),
    [anon_sym_offsetof] = ACTIONS(2584),
    [anon_sym__Generic] = ACTIONS(2584),
    [anon_sym_asm] = ACTIONS(2584),
    [anon_sym___asm__] = ACTIONS(2584),
    [anon_sym___asm] = ACTIONS(2584),
    [sym_number_literal] = ACTIONS(2586),
    [anon_sym_L_SQUOTE] = ACTIONS(2586),
    [anon_sym_u_SQUOTE] = ACTIONS(2586),
    [anon_sym_U_SQUOTE] = ACTIONS(2586),
    [anon_sym_u8_SQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_L_DQUOTE] = ACTIONS(2586),
    [anon_sym_u_DQUOTE] = ACTIONS(2586),
    [anon_sym_U_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8_DQUOTE] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [anon_sym_NULL] = ACTIONS(2584),
    [anon_sym_nullptr] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2584),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2584),
    [anon_sym_operator] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_static_assert] = ACTIONS(2584),
    [anon_sym_concept] = ACTIONS(2584),
    [anon_sym_co_return] = ACTIONS(2584),
    [anon_sym_co_yield] = ACTIONS(2584),
    [anon_sym_R_DQUOTE] = ACTIONS(2586),
    [anon_sym_LR_DQUOTE] = ACTIONS(2586),
    [anon_sym_uR_DQUOTE] = ACTIONS(2586),
    [anon_sym_UR_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2586),
    [anon_sym_co_await] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_requires] = ACTIONS(2584),
    [sym_this] = ACTIONS(2584),
    [anon_sym_discard] = ACTIONS(2584),
    [anon_sym_precise] = ACTIONS(2584),
    [anon_sym_shared] = ACTIONS(2584),
    [anon_sym_groupshared] = ACTIONS(2584),
    [anon_sym_uniform] = ACTIONS(2584),
    [anon_sym_row_major] = ACTIONS(2584),
    [anon_sym_column_major] = ACTIONS(2584),
    [anon_sym_globallycoherent] = ACTIONS(2584),
    [anon_sym_centroid] = ACTIONS(2584),
    [anon_sym_noperspective] = ACTIONS(2584),
    [anon_sym_nointerpolation] = ACTIONS(2584),
    [anon_sym_sample] = ACTIONS(2584),
    [anon_sym_linear] = ACTIONS(2584),
    [anon_sym_snorm] = ACTIONS(2584),
    [anon_sym_unorm] = ACTIONS(2584),
    [anon_sym_point] = ACTIONS(2584),
    [anon_sym_line] = ACTIONS(2584),
    [anon_sym_triangleadj] = ACTIONS(2584),
    [anon_sym_lineadj] = ACTIONS(2584),
    [anon_sym_triangle] = ACTIONS(2584),
    [anon_sym_cbuffer] = ACTIONS(2584),
  },
  [385] = {
    [sym_identifier] = ACTIONS(2588),
    [aux_sym_preproc_include_token1] = ACTIONS(2588),
    [aux_sym_preproc_def_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token2] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2588),
    [aux_sym_preproc_else_token1] = ACTIONS(2588),
    [aux_sym_preproc_elif_token1] = ACTIONS(2588),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2588),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2588),
    [sym_preproc_directive] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym___extension__] = ACTIONS(2588),
    [anon_sym_typedef] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_out] = ACTIONS(2588),
    [anon_sym_inout] = ACTIONS(2588),
    [anon_sym_virtual] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym___attribute__] = ACTIONS(2588),
    [anon_sym___attribute] = ACTIONS(2588),
    [anon_sym_using] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2588),
    [anon_sym___based] = ACTIONS(2588),
    [anon_sym___cdecl] = ACTIONS(2588),
    [anon_sym___clrcall] = ACTIONS(2588),
    [anon_sym___stdcall] = ACTIONS(2588),
    [anon_sym___fastcall] = ACTIONS(2588),
    [anon_sym___thiscall] = ACTIONS(2588),
    [anon_sym___vectorcall] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2588),
    [anon_sym_unsigned] = ACTIONS(2588),
    [anon_sym_long] = ACTIONS(2588),
    [anon_sym_short] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_register] = ACTIONS(2588),
    [anon_sym_inline] = ACTIONS(2588),
    [anon_sym___inline] = ACTIONS(2588),
    [anon_sym___inline__] = ACTIONS(2588),
    [anon_sym___forceinline] = ACTIONS(2588),
    [anon_sym_thread_local] = ACTIONS(2588),
    [anon_sym___thread] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_constexpr] = ACTIONS(2588),
    [anon_sym_volatile] = ACTIONS(2588),
    [anon_sym_restrict] = ACTIONS(2588),
    [anon_sym___restrict__] = ACTIONS(2588),
    [anon_sym__Atomic] = ACTIONS(2588),
    [anon_sym__Noreturn] = ACTIONS(2588),
    [anon_sym_noreturn] = ACTIONS(2588),
    [anon_sym__Nonnull] = ACTIONS(2588),
    [anon_sym_mutable] = ACTIONS(2588),
    [anon_sym_constinit] = ACTIONS(2588),
    [anon_sym_consteval] = ACTIONS(2588),
    [anon_sym_alignas] = ACTIONS(2588),
    [anon_sym__Alignas] = ACTIONS(2588),
    [sym_primitive_type] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_goto] = ACTIONS(2588),
    [anon_sym___try] = ACTIONS(2588),
    [anon_sym___leave] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2588),
    [anon_sym_compl] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_sizeof] = ACTIONS(2588),
    [anon_sym___alignof__] = ACTIONS(2588),
    [anon_sym___alignof] = ACTIONS(2588),
    [anon_sym__alignof] = ACTIONS(2588),
    [anon_sym_alignof] = ACTIONS(2588),
    [anon_sym__Alignof] = ACTIONS(2588),
    [anon_sym_offsetof] = ACTIONS(2588),
    [anon_sym__Generic] = ACTIONS(2588),
    [anon_sym_asm] = ACTIONS(2588),
    [anon_sym___asm__] = ACTIONS(2588),
    [anon_sym___asm] = ACTIONS(2588),
    [sym_number_literal] = ACTIONS(2590),
    [anon_sym_L_SQUOTE] = ACTIONS(2590),
    [anon_sym_u_SQUOTE] = ACTIONS(2590),
    [anon_sym_U_SQUOTE] = ACTIONS(2590),
    [anon_sym_u8_SQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [anon_sym_L_DQUOTE] = ACTIONS(2590),
    [anon_sym_u_DQUOTE] = ACTIONS(2590),
    [anon_sym_U_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8_DQUOTE] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [anon_sym_NULL] = ACTIONS(2588),
    [anon_sym_nullptr] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2588),
    [anon_sym_decltype] = ACTIONS(2588),
    [anon_sym_explicit] = ACTIONS(2588),
    [anon_sym_typename] = ACTIONS(2588),
    [anon_sym_template] = ACTIONS(2588),
    [anon_sym_operator] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_static_assert] = ACTIONS(2588),
    [anon_sym_concept] = ACTIONS(2588),
    [anon_sym_co_return] = ACTIONS(2588),
    [anon_sym_co_yield] = ACTIONS(2588),
    [anon_sym_R_DQUOTE] = ACTIONS(2590),
    [anon_sym_LR_DQUOTE] = ACTIONS(2590),
    [anon_sym_uR_DQUOTE] = ACTIONS(2590),
    [anon_sym_UR_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2590),
    [anon_sym_co_await] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_requires] = ACTIONS(2588),
    [sym_this] = ACTIONS(2588),
    [anon_sym_discard] = ACTIONS(2588),
    [anon_sym_precise] = ACTIONS(2588),
    [anon_sym_shared] = ACTIONS(2588),
    [anon_sym_groupshared] = ACTIONS(2588),
    [anon_sym_uniform] = ACTIONS(2588),
    [anon_sym_row_major] = ACTIONS(2588),
    [anon_sym_column_major] = ACTIONS(2588),
    [anon_sym_globallycoherent] = ACTIONS(2588),
    [anon_sym_centroid] = ACTIONS(2588),
    [anon_sym_noperspective] = ACTIONS(2588),
    [anon_sym_nointerpolation] = ACTIONS(2588),
    [anon_sym_sample] = ACTIONS(2588),
    [anon_sym_linear] = ACTIONS(2588),
    [anon_sym_snorm] = ACTIONS(2588),
    [anon_sym_unorm] = ACTIONS(2588),
    [anon_sym_point] = ACTIONS(2588),
    [anon_sym_line] = ACTIONS(2588),
    [anon_sym_triangleadj] = ACTIONS(2588),
    [anon_sym_lineadj] = ACTIONS(2588),
    [anon_sym_triangle] = ACTIONS(2588),
    [anon_sym_cbuffer] = ACTIONS(2588),
  },
  [386] = {
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_include_token1] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token2] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2592),
    [aux_sym_preproc_else_token1] = ACTIONS(2592),
    [aux_sym_preproc_elif_token1] = ACTIONS(2592),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2592),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2592),
    [sym_preproc_directive] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym___extension__] = ACTIONS(2592),
    [anon_sym_typedef] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_out] = ACTIONS(2592),
    [anon_sym_inout] = ACTIONS(2592),
    [anon_sym_virtual] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym___attribute__] = ACTIONS(2592),
    [anon_sym___attribute] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2594),
    [anon_sym___declspec] = ACTIONS(2592),
    [anon_sym___based] = ACTIONS(2592),
    [anon_sym___cdecl] = ACTIONS(2592),
    [anon_sym___clrcall] = ACTIONS(2592),
    [anon_sym___stdcall] = ACTIONS(2592),
    [anon_sym___fastcall] = ACTIONS(2592),
    [anon_sym___thiscall] = ACTIONS(2592),
    [anon_sym___vectorcall] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_signed] = ACTIONS(2592),
    [anon_sym_unsigned] = ACTIONS(2592),
    [anon_sym_long] = ACTIONS(2592),
    [anon_sym_short] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_register] = ACTIONS(2592),
    [anon_sym_inline] = ACTIONS(2592),
    [anon_sym___inline] = ACTIONS(2592),
    [anon_sym___inline__] = ACTIONS(2592),
    [anon_sym___forceinline] = ACTIONS(2592),
    [anon_sym_thread_local] = ACTIONS(2592),
    [anon_sym___thread] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_constexpr] = ACTIONS(2592),
    [anon_sym_volatile] = ACTIONS(2592),
    [anon_sym_restrict] = ACTIONS(2592),
    [anon_sym___restrict__] = ACTIONS(2592),
    [anon_sym__Atomic] = ACTIONS(2592),
    [anon_sym__Noreturn] = ACTIONS(2592),
    [anon_sym_noreturn] = ACTIONS(2592),
    [anon_sym__Nonnull] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_constinit] = ACTIONS(2592),
    [anon_sym_consteval] = ACTIONS(2592),
    [anon_sym_alignas] = ACTIONS(2592),
    [anon_sym__Alignas] = ACTIONS(2592),
    [sym_primitive_type] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_goto] = ACTIONS(2592),
    [anon_sym___try] = ACTIONS(2592),
    [anon_sym___leave] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2592),
    [anon_sym_compl] = ACTIONS(2592),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_sizeof] = ACTIONS(2592),
    [anon_sym___alignof__] = ACTIONS(2592),
    [anon_sym___alignof] = ACTIONS(2592),
    [anon_sym__alignof] = ACTIONS(2592),
    [anon_sym_alignof] = ACTIONS(2592),
    [anon_sym__Alignof] = ACTIONS(2592),
    [anon_sym_offsetof] = ACTIONS(2592),
    [anon_sym__Generic] = ACTIONS(2592),
    [anon_sym_asm] = ACTIONS(2592),
    [anon_sym___asm__] = ACTIONS(2592),
    [anon_sym___asm] = ACTIONS(2592),
    [sym_number_literal] = ACTIONS(2594),
    [anon_sym_L_SQUOTE] = ACTIONS(2594),
    [anon_sym_u_SQUOTE] = ACTIONS(2594),
    [anon_sym_U_SQUOTE] = ACTIONS(2594),
    [anon_sym_u8_SQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_L_DQUOTE] = ACTIONS(2594),
    [anon_sym_u_DQUOTE] = ACTIONS(2594),
    [anon_sym_U_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8_DQUOTE] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [anon_sym_NULL] = ACTIONS(2592),
    [anon_sym_nullptr] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2592),
    [anon_sym_decltype] = ACTIONS(2592),
    [anon_sym_explicit] = ACTIONS(2592),
    [anon_sym_typename] = ACTIONS(2592),
    [anon_sym_template] = ACTIONS(2592),
    [anon_sym_operator] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_static_assert] = ACTIONS(2592),
    [anon_sym_concept] = ACTIONS(2592),
    [anon_sym_co_return] = ACTIONS(2592),
    [anon_sym_co_yield] = ACTIONS(2592),
    [anon_sym_R_DQUOTE] = ACTIONS(2594),
    [anon_sym_LR_DQUOTE] = ACTIONS(2594),
    [anon_sym_uR_DQUOTE] = ACTIONS(2594),
    [anon_sym_UR_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2594),
    [anon_sym_co_await] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_requires] = ACTIONS(2592),
    [sym_this] = ACTIONS(2592),
    [anon_sym_discard] = ACTIONS(2592),
    [anon_sym_precise] = ACTIONS(2592),
    [anon_sym_shared] = ACTIONS(2592),
    [anon_sym_groupshared] = ACTIONS(2592),
    [anon_sym_uniform] = ACTIONS(2592),
    [anon_sym_row_major] = ACTIONS(2592),
    [anon_sym_column_major] = ACTIONS(2592),
    [anon_sym_globallycoherent] = ACTIONS(2592),
    [anon_sym_centroid] = ACTIONS(2592),
    [anon_sym_noperspective] = ACTIONS(2592),
    [anon_sym_nointerpolation] = ACTIONS(2592),
    [anon_sym_sample] = ACTIONS(2592),
    [anon_sym_linear] = ACTIONS(2592),
    [anon_sym_snorm] = ACTIONS(2592),
    [anon_sym_unorm] = ACTIONS(2592),
    [anon_sym_point] = ACTIONS(2592),
    [anon_sym_line] = ACTIONS(2592),
    [anon_sym_triangleadj] = ACTIONS(2592),
    [anon_sym_lineadj] = ACTIONS(2592),
    [anon_sym_triangle] = ACTIONS(2592),
    [anon_sym_cbuffer] = ACTIONS(2592),
  },
  [387] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_include_token1] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token2] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [aux_sym_preproc_else_token1] = ACTIONS(2596),
    [aux_sym_preproc_elif_token1] = ACTIONS(2596),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym___cdecl] = ACTIONS(2596),
    [anon_sym___clrcall] = ACTIONS(2596),
    [anon_sym___stdcall] = ACTIONS(2596),
    [anon_sym___fastcall] = ACTIONS(2596),
    [anon_sym___thiscall] = ACTIONS(2596),
    [anon_sym___vectorcall] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_goto] = ACTIONS(2596),
    [anon_sym___try] = ACTIONS(2596),
    [anon_sym___leave] = ACTIONS(2596),
    [anon_sym_not] = ACTIONS(2596),
    [anon_sym_compl] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_sizeof] = ACTIONS(2596),
    [anon_sym___alignof__] = ACTIONS(2596),
    [anon_sym___alignof] = ACTIONS(2596),
    [anon_sym__alignof] = ACTIONS(2596),
    [anon_sym_alignof] = ACTIONS(2596),
    [anon_sym__Alignof] = ACTIONS(2596),
    [anon_sym_offsetof] = ACTIONS(2596),
    [anon_sym__Generic] = ACTIONS(2596),
    [anon_sym_asm] = ACTIONS(2596),
    [anon_sym___asm__] = ACTIONS(2596),
    [anon_sym___asm] = ACTIONS(2596),
    [sym_number_literal] = ACTIONS(2598),
    [anon_sym_L_SQUOTE] = ACTIONS(2598),
    [anon_sym_u_SQUOTE] = ACTIONS(2598),
    [anon_sym_U_SQUOTE] = ACTIONS(2598),
    [anon_sym_u8_SQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_L_DQUOTE] = ACTIONS(2598),
    [anon_sym_u_DQUOTE] = ACTIONS(2598),
    [anon_sym_U_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8_DQUOTE] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [anon_sym_NULL] = ACTIONS(2596),
    [anon_sym_nullptr] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_concept] = ACTIONS(2596),
    [anon_sym_co_return] = ACTIONS(2596),
    [anon_sym_co_yield] = ACTIONS(2596),
    [anon_sym_R_DQUOTE] = ACTIONS(2598),
    [anon_sym_LR_DQUOTE] = ACTIONS(2598),
    [anon_sym_uR_DQUOTE] = ACTIONS(2598),
    [anon_sym_UR_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2598),
    [anon_sym_co_await] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_requires] = ACTIONS(2596),
    [sym_this] = ACTIONS(2596),
    [anon_sym_discard] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
    [anon_sym_cbuffer] = ACTIONS(2596),
  },
  [388] = {
    [sym_identifier] = ACTIONS(2600),
    [aux_sym_preproc_include_token1] = ACTIONS(2600),
    [aux_sym_preproc_def_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token2] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2600),
    [aux_sym_preproc_else_token1] = ACTIONS(2600),
    [aux_sym_preproc_elif_token1] = ACTIONS(2600),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2600),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2600),
    [sym_preproc_directive] = ACTIONS(2600),
    [anon_sym_LPAREN2] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym___extension__] = ACTIONS(2600),
    [anon_sym_typedef] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_out] = ACTIONS(2600),
    [anon_sym_inout] = ACTIONS(2600),
    [anon_sym_virtual] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym___attribute__] = ACTIONS(2600),
    [anon_sym___attribute] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2602),
    [anon_sym___declspec] = ACTIONS(2600),
    [anon_sym___based] = ACTIONS(2600),
    [anon_sym___cdecl] = ACTIONS(2600),
    [anon_sym___clrcall] = ACTIONS(2600),
    [anon_sym___stdcall] = ACTIONS(2600),
    [anon_sym___fastcall] = ACTIONS(2600),
    [anon_sym___thiscall] = ACTIONS(2600),
    [anon_sym___vectorcall] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_signed] = ACTIONS(2600),
    [anon_sym_unsigned] = ACTIONS(2600),
    [anon_sym_long] = ACTIONS(2600),
    [anon_sym_short] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_register] = ACTIONS(2600),
    [anon_sym_inline] = ACTIONS(2600),
    [anon_sym___inline] = ACTIONS(2600),
    [anon_sym___inline__] = ACTIONS(2600),
    [anon_sym___forceinline] = ACTIONS(2600),
    [anon_sym_thread_local] = ACTIONS(2600),
    [anon_sym___thread] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_constexpr] = ACTIONS(2600),
    [anon_sym_volatile] = ACTIONS(2600),
    [anon_sym_restrict] = ACTIONS(2600),
    [anon_sym___restrict__] = ACTIONS(2600),
    [anon_sym__Atomic] = ACTIONS(2600),
    [anon_sym__Noreturn] = ACTIONS(2600),
    [anon_sym_noreturn] = ACTIONS(2600),
    [anon_sym__Nonnull] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_constinit] = ACTIONS(2600),
    [anon_sym_consteval] = ACTIONS(2600),
    [anon_sym_alignas] = ACTIONS(2600),
    [anon_sym__Alignas] = ACTIONS(2600),
    [sym_primitive_type] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_goto] = ACTIONS(2600),
    [anon_sym___try] = ACTIONS(2600),
    [anon_sym___leave] = ACTIONS(2600),
    [anon_sym_not] = ACTIONS(2600),
    [anon_sym_compl] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_sizeof] = ACTIONS(2600),
    [anon_sym___alignof__] = ACTIONS(2600),
    [anon_sym___alignof] = ACTIONS(2600),
    [anon_sym__alignof] = ACTIONS(2600),
    [anon_sym_alignof] = ACTIONS(2600),
    [anon_sym__Alignof] = ACTIONS(2600),
    [anon_sym_offsetof] = ACTIONS(2600),
    [anon_sym__Generic] = ACTIONS(2600),
    [anon_sym_asm] = ACTIONS(2600),
    [anon_sym___asm__] = ACTIONS(2600),
    [anon_sym___asm] = ACTIONS(2600),
    [sym_number_literal] = ACTIONS(2602),
    [anon_sym_L_SQUOTE] = ACTIONS(2602),
    [anon_sym_u_SQUOTE] = ACTIONS(2602),
    [anon_sym_U_SQUOTE] = ACTIONS(2602),
    [anon_sym_u8_SQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_L_DQUOTE] = ACTIONS(2602),
    [anon_sym_u_DQUOTE] = ACTIONS(2602),
    [anon_sym_U_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8_DQUOTE] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [anon_sym_NULL] = ACTIONS(2600),
    [anon_sym_nullptr] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2600),
    [anon_sym_decltype] = ACTIONS(2600),
    [anon_sym_explicit] = ACTIONS(2600),
    [anon_sym_typename] = ACTIONS(2600),
    [anon_sym_template] = ACTIONS(2600),
    [anon_sym_operator] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_static_assert] = ACTIONS(2600),
    [anon_sym_concept] = ACTIONS(2600),
    [anon_sym_co_return] = ACTIONS(2600),
    [anon_sym_co_yield] = ACTIONS(2600),
    [anon_sym_R_DQUOTE] = ACTIONS(2602),
    [anon_sym_LR_DQUOTE] = ACTIONS(2602),
    [anon_sym_uR_DQUOTE] = ACTIONS(2602),
    [anon_sym_UR_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2602),
    [anon_sym_co_await] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_requires] = ACTIONS(2600),
    [sym_this] = ACTIONS(2600),
    [anon_sym_discard] = ACTIONS(2600),
    [anon_sym_precise] = ACTIONS(2600),
    [anon_sym_shared] = ACTIONS(2600),
    [anon_sym_groupshared] = ACTIONS(2600),
    [anon_sym_uniform] = ACTIONS(2600),
    [anon_sym_row_major] = ACTIONS(2600),
    [anon_sym_column_major] = ACTIONS(2600),
    [anon_sym_globallycoherent] = ACTIONS(2600),
    [anon_sym_centroid] = ACTIONS(2600),
    [anon_sym_noperspective] = ACTIONS(2600),
    [anon_sym_nointerpolation] = ACTIONS(2600),
    [anon_sym_sample] = ACTIONS(2600),
    [anon_sym_linear] = ACTIONS(2600),
    [anon_sym_snorm] = ACTIONS(2600),
    [anon_sym_unorm] = ACTIONS(2600),
    [anon_sym_point] = ACTIONS(2600),
    [anon_sym_line] = ACTIONS(2600),
    [anon_sym_triangleadj] = ACTIONS(2600),
    [anon_sym_lineadj] = ACTIONS(2600),
    [anon_sym_triangle] = ACTIONS(2600),
    [anon_sym_cbuffer] = ACTIONS(2600),
  },
  [389] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [aux_sym_preproc_else_token1] = ACTIONS(2604),
    [aux_sym_preproc_elif_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [390] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [aux_sym_preproc_else_token1] = ACTIONS(2604),
    [aux_sym_preproc_elif_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [391] = {
    [sym_identifier] = ACTIONS(2608),
    [aux_sym_preproc_include_token1] = ACTIONS(2608),
    [aux_sym_preproc_def_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token2] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2608),
    [aux_sym_preproc_else_token1] = ACTIONS(2608),
    [aux_sym_preproc_elif_token1] = ACTIONS(2608),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2608),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2608),
    [sym_preproc_directive] = ACTIONS(2608),
    [anon_sym_LPAREN2] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym___extension__] = ACTIONS(2608),
    [anon_sym_typedef] = ACTIONS(2608),
    [anon_sym_in] = ACTIONS(2608),
    [anon_sym_out] = ACTIONS(2608),
    [anon_sym_inout] = ACTIONS(2608),
    [anon_sym_virtual] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym___attribute__] = ACTIONS(2608),
    [anon_sym___attribute] = ACTIONS(2608),
    [anon_sym_using] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2610),
    [anon_sym___declspec] = ACTIONS(2608),
    [anon_sym___based] = ACTIONS(2608),
    [anon_sym___cdecl] = ACTIONS(2608),
    [anon_sym___clrcall] = ACTIONS(2608),
    [anon_sym___stdcall] = ACTIONS(2608),
    [anon_sym___fastcall] = ACTIONS(2608),
    [anon_sym___thiscall] = ACTIONS(2608),
    [anon_sym___vectorcall] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_signed] = ACTIONS(2608),
    [anon_sym_unsigned] = ACTIONS(2608),
    [anon_sym_long] = ACTIONS(2608),
    [anon_sym_short] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_register] = ACTIONS(2608),
    [anon_sym_inline] = ACTIONS(2608),
    [anon_sym___inline] = ACTIONS(2608),
    [anon_sym___inline__] = ACTIONS(2608),
    [anon_sym___forceinline] = ACTIONS(2608),
    [anon_sym_thread_local] = ACTIONS(2608),
    [anon_sym___thread] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_constexpr] = ACTIONS(2608),
    [anon_sym_volatile] = ACTIONS(2608),
    [anon_sym_restrict] = ACTIONS(2608),
    [anon_sym___restrict__] = ACTIONS(2608),
    [anon_sym__Atomic] = ACTIONS(2608),
    [anon_sym__Noreturn] = ACTIONS(2608),
    [anon_sym_noreturn] = ACTIONS(2608),
    [anon_sym__Nonnull] = ACTIONS(2608),
    [anon_sym_mutable] = ACTIONS(2608),
    [anon_sym_constinit] = ACTIONS(2608),
    [anon_sym_consteval] = ACTIONS(2608),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_goto] = ACTIONS(2608),
    [anon_sym___try] = ACTIONS(2608),
    [anon_sym___leave] = ACTIONS(2608),
    [anon_sym_not] = ACTIONS(2608),
    [anon_sym_compl] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_sizeof] = ACTIONS(2608),
    [anon_sym___alignof__] = ACTIONS(2608),
    [anon_sym___alignof] = ACTIONS(2608),
    [anon_sym__alignof] = ACTIONS(2608),
    [anon_sym_alignof] = ACTIONS(2608),
    [anon_sym__Alignof] = ACTIONS(2608),
    [anon_sym_offsetof] = ACTIONS(2608),
    [anon_sym__Generic] = ACTIONS(2608),
    [anon_sym_asm] = ACTIONS(2608),
    [anon_sym___asm__] = ACTIONS(2608),
    [anon_sym___asm] = ACTIONS(2608),
    [sym_number_literal] = ACTIONS(2610),
    [anon_sym_L_SQUOTE] = ACTIONS(2610),
    [anon_sym_u_SQUOTE] = ACTIONS(2610),
    [anon_sym_U_SQUOTE] = ACTIONS(2610),
    [anon_sym_u8_SQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [anon_sym_L_DQUOTE] = ACTIONS(2610),
    [anon_sym_u_DQUOTE] = ACTIONS(2610),
    [anon_sym_U_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8_DQUOTE] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [anon_sym_NULL] = ACTIONS(2608),
    [anon_sym_nullptr] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(2608),
    [anon_sym_explicit] = ACTIONS(2608),
    [anon_sym_typename] = ACTIONS(2608),
    [anon_sym_template] = ACTIONS(2608),
    [anon_sym_operator] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_static_assert] = ACTIONS(2608),
    [anon_sym_concept] = ACTIONS(2608),
    [anon_sym_co_return] = ACTIONS(2608),
    [anon_sym_co_yield] = ACTIONS(2608),
    [anon_sym_R_DQUOTE] = ACTIONS(2610),
    [anon_sym_LR_DQUOTE] = ACTIONS(2610),
    [anon_sym_uR_DQUOTE] = ACTIONS(2610),
    [anon_sym_UR_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2610),
    [anon_sym_co_await] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_requires] = ACTIONS(2608),
    [sym_this] = ACTIONS(2608),
    [anon_sym_discard] = ACTIONS(2608),
    [anon_sym_precise] = ACTIONS(2608),
    [anon_sym_shared] = ACTIONS(2608),
    [anon_sym_groupshared] = ACTIONS(2608),
    [anon_sym_uniform] = ACTIONS(2608),
    [anon_sym_row_major] = ACTIONS(2608),
    [anon_sym_column_major] = ACTIONS(2608),
    [anon_sym_globallycoherent] = ACTIONS(2608),
    [anon_sym_centroid] = ACTIONS(2608),
    [anon_sym_noperspective] = ACTIONS(2608),
    [anon_sym_nointerpolation] = ACTIONS(2608),
    [anon_sym_sample] = ACTIONS(2608),
    [anon_sym_linear] = ACTIONS(2608),
    [anon_sym_snorm] = ACTIONS(2608),
    [anon_sym_unorm] = ACTIONS(2608),
    [anon_sym_point] = ACTIONS(2608),
    [anon_sym_line] = ACTIONS(2608),
    [anon_sym_triangleadj] = ACTIONS(2608),
    [anon_sym_lineadj] = ACTIONS(2608),
    [anon_sym_triangle] = ACTIONS(2608),
    [anon_sym_cbuffer] = ACTIONS(2608),
  },
  [392] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_include_token1] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token2] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [aux_sym_preproc_else_token1] = ACTIONS(2612),
    [aux_sym_preproc_elif_token1] = ACTIONS(2612),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym___cdecl] = ACTIONS(2612),
    [anon_sym___clrcall] = ACTIONS(2612),
    [anon_sym___stdcall] = ACTIONS(2612),
    [anon_sym___fastcall] = ACTIONS(2612),
    [anon_sym___thiscall] = ACTIONS(2612),
    [anon_sym___vectorcall] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_switch] = ACTIONS(2612),
    [anon_sym_case] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_do] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_goto] = ACTIONS(2612),
    [anon_sym___try] = ACTIONS(2612),
    [anon_sym___leave] = ACTIONS(2612),
    [anon_sym_not] = ACTIONS(2612),
    [anon_sym_compl] = ACTIONS(2612),
    [anon_sym_DASH_DASH] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2614),
    [anon_sym_sizeof] = ACTIONS(2612),
    [anon_sym___alignof__] = ACTIONS(2612),
    [anon_sym___alignof] = ACTIONS(2612),
    [anon_sym__alignof] = ACTIONS(2612),
    [anon_sym_alignof] = ACTIONS(2612),
    [anon_sym__Alignof] = ACTIONS(2612),
    [anon_sym_offsetof] = ACTIONS(2612),
    [anon_sym__Generic] = ACTIONS(2612),
    [anon_sym_asm] = ACTIONS(2612),
    [anon_sym___asm__] = ACTIONS(2612),
    [anon_sym___asm] = ACTIONS(2612),
    [sym_number_literal] = ACTIONS(2614),
    [anon_sym_L_SQUOTE] = ACTIONS(2614),
    [anon_sym_u_SQUOTE] = ACTIONS(2614),
    [anon_sym_U_SQUOTE] = ACTIONS(2614),
    [anon_sym_u8_SQUOTE] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_L_DQUOTE] = ACTIONS(2614),
    [anon_sym_u_DQUOTE] = ACTIONS(2614),
    [anon_sym_U_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8_DQUOTE] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [anon_sym_NULL] = ACTIONS(2612),
    [anon_sym_nullptr] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_delete] = ACTIONS(2612),
    [anon_sym_throw] = ACTIONS(2612),
    [anon_sym_namespace] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_concept] = ACTIONS(2612),
    [anon_sym_co_return] = ACTIONS(2612),
    [anon_sym_co_yield] = ACTIONS(2612),
    [anon_sym_R_DQUOTE] = ACTIONS(2614),
    [anon_sym_LR_DQUOTE] = ACTIONS(2614),
    [anon_sym_uR_DQUOTE] = ACTIONS(2614),
    [anon_sym_UR_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2614),
    [anon_sym_co_await] = ACTIONS(2612),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_requires] = ACTIONS(2612),
    [sym_this] = ACTIONS(2612),
    [anon_sym_discard] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
    [anon_sym_cbuffer] = ACTIONS(2612),
  },
  [393] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_include_token1] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token2] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [aux_sym_preproc_else_token1] = ACTIONS(2616),
    [aux_sym_preproc_elif_token1] = ACTIONS(2616),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym___cdecl] = ACTIONS(2616),
    [anon_sym___clrcall] = ACTIONS(2616),
    [anon_sym___stdcall] = ACTIONS(2616),
    [anon_sym___fastcall] = ACTIONS(2616),
    [anon_sym___thiscall] = ACTIONS(2616),
    [anon_sym___vectorcall] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_switch] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_goto] = ACTIONS(2616),
    [anon_sym___try] = ACTIONS(2616),
    [anon_sym___leave] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_compl] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2618),
    [anon_sym_sizeof] = ACTIONS(2616),
    [anon_sym___alignof__] = ACTIONS(2616),
    [anon_sym___alignof] = ACTIONS(2616),
    [anon_sym__alignof] = ACTIONS(2616),
    [anon_sym_alignof] = ACTIONS(2616),
    [anon_sym__Alignof] = ACTIONS(2616),
    [anon_sym_offsetof] = ACTIONS(2616),
    [anon_sym__Generic] = ACTIONS(2616),
    [anon_sym_asm] = ACTIONS(2616),
    [anon_sym___asm__] = ACTIONS(2616),
    [anon_sym___asm] = ACTIONS(2616),
    [sym_number_literal] = ACTIONS(2618),
    [anon_sym_L_SQUOTE] = ACTIONS(2618),
    [anon_sym_u_SQUOTE] = ACTIONS(2618),
    [anon_sym_U_SQUOTE] = ACTIONS(2618),
    [anon_sym_u8_SQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_L_DQUOTE] = ACTIONS(2618),
    [anon_sym_u_DQUOTE] = ACTIONS(2618),
    [anon_sym_U_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8_DQUOTE] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [anon_sym_NULL] = ACTIONS(2616),
    [anon_sym_nullptr] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_delete] = ACTIONS(2616),
    [anon_sym_throw] = ACTIONS(2616),
    [anon_sym_namespace] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_concept] = ACTIONS(2616),
    [anon_sym_co_return] = ACTIONS(2616),
    [anon_sym_co_yield] = ACTIONS(2616),
    [anon_sym_R_DQUOTE] = ACTIONS(2618),
    [anon_sym_LR_DQUOTE] = ACTIONS(2618),
    [anon_sym_uR_DQUOTE] = ACTIONS(2618),
    [anon_sym_UR_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2618),
    [anon_sym_co_await] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2616),
    [anon_sym_requires] = ACTIONS(2616),
    [sym_this] = ACTIONS(2616),
    [anon_sym_discard] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
    [anon_sym_cbuffer] = ACTIONS(2616),
  },
  [394] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_include_token1] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token2] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [aux_sym_preproc_else_token1] = ACTIONS(2620),
    [aux_sym_preproc_elif_token1] = ACTIONS(2620),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym___cdecl] = ACTIONS(2620),
    [anon_sym___clrcall] = ACTIONS(2620),
    [anon_sym___stdcall] = ACTIONS(2620),
    [anon_sym___fastcall] = ACTIONS(2620),
    [anon_sym___thiscall] = ACTIONS(2620),
    [anon_sym___vectorcall] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_switch] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_goto] = ACTIONS(2620),
    [anon_sym___try] = ACTIONS(2620),
    [anon_sym___leave] = ACTIONS(2620),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_compl] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_sizeof] = ACTIONS(2620),
    [anon_sym___alignof__] = ACTIONS(2620),
    [anon_sym___alignof] = ACTIONS(2620),
    [anon_sym__alignof] = ACTIONS(2620),
    [anon_sym_alignof] = ACTIONS(2620),
    [anon_sym__Alignof] = ACTIONS(2620),
    [anon_sym_offsetof] = ACTIONS(2620),
    [anon_sym__Generic] = ACTIONS(2620),
    [anon_sym_asm] = ACTIONS(2620),
    [anon_sym___asm__] = ACTIONS(2620),
    [anon_sym___asm] = ACTIONS(2620),
    [sym_number_literal] = ACTIONS(2622),
    [anon_sym_L_SQUOTE] = ACTIONS(2622),
    [anon_sym_u_SQUOTE] = ACTIONS(2622),
    [anon_sym_U_SQUOTE] = ACTIONS(2622),
    [anon_sym_u8_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_L_DQUOTE] = ACTIONS(2622),
    [anon_sym_u_DQUOTE] = ACTIONS(2622),
    [anon_sym_U_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8_DQUOTE] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [anon_sym_NULL] = ACTIONS(2620),
    [anon_sym_nullptr] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_delete] = ACTIONS(2620),
    [anon_sym_throw] = ACTIONS(2620),
    [anon_sym_namespace] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_concept] = ACTIONS(2620),
    [anon_sym_co_return] = ACTIONS(2620),
    [anon_sym_co_yield] = ACTIONS(2620),
    [anon_sym_R_DQUOTE] = ACTIONS(2622),
    [anon_sym_LR_DQUOTE] = ACTIONS(2622),
    [anon_sym_uR_DQUOTE] = ACTIONS(2622),
    [anon_sym_UR_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2622),
    [anon_sym_co_await] = ACTIONS(2620),
    [anon_sym_new] = ACTIONS(2620),
    [anon_sym_requires] = ACTIONS(2620),
    [sym_this] = ACTIONS(2620),
    [anon_sym_discard] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
    [anon_sym_cbuffer] = ACTIONS(2620),
  },
  [395] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_include_token1] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token2] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [aux_sym_preproc_else_token1] = ACTIONS(2624),
    [aux_sym_preproc_elif_token1] = ACTIONS(2624),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym___cdecl] = ACTIONS(2624),
    [anon_sym___clrcall] = ACTIONS(2624),
    [anon_sym___stdcall] = ACTIONS(2624),
    [anon_sym___fastcall] = ACTIONS(2624),
    [anon_sym___thiscall] = ACTIONS(2624),
    [anon_sym___vectorcall] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_goto] = ACTIONS(2624),
    [anon_sym___try] = ACTIONS(2624),
    [anon_sym___leave] = ACTIONS(2624),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_compl] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2626),
    [anon_sym_sizeof] = ACTIONS(2624),
    [anon_sym___alignof__] = ACTIONS(2624),
    [anon_sym___alignof] = ACTIONS(2624),
    [anon_sym__alignof] = ACTIONS(2624),
    [anon_sym_alignof] = ACTIONS(2624),
    [anon_sym__Alignof] = ACTIONS(2624),
    [anon_sym_offsetof] = ACTIONS(2624),
    [anon_sym__Generic] = ACTIONS(2624),
    [anon_sym_asm] = ACTIONS(2624),
    [anon_sym___asm__] = ACTIONS(2624),
    [anon_sym___asm] = ACTIONS(2624),
    [sym_number_literal] = ACTIONS(2626),
    [anon_sym_L_SQUOTE] = ACTIONS(2626),
    [anon_sym_u_SQUOTE] = ACTIONS(2626),
    [anon_sym_U_SQUOTE] = ACTIONS(2626),
    [anon_sym_u8_SQUOTE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_L_DQUOTE] = ACTIONS(2626),
    [anon_sym_u_DQUOTE] = ACTIONS(2626),
    [anon_sym_U_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8_DQUOTE] = ACTIONS(2626),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [anon_sym_NULL] = ACTIONS(2624),
    [anon_sym_nullptr] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_concept] = ACTIONS(2624),
    [anon_sym_co_return] = ACTIONS(2624),
    [anon_sym_co_yield] = ACTIONS(2624),
    [anon_sym_R_DQUOTE] = ACTIONS(2626),
    [anon_sym_LR_DQUOTE] = ACTIONS(2626),
    [anon_sym_uR_DQUOTE] = ACTIONS(2626),
    [anon_sym_UR_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2626),
    [anon_sym_co_await] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_requires] = ACTIONS(2624),
    [sym_this] = ACTIONS(2624),
    [anon_sym_discard] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
    [anon_sym_cbuffer] = ACTIONS(2624),
  },
  [396] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_include_token1] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token2] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [aux_sym_preproc_else_token1] = ACTIONS(2628),
    [aux_sym_preproc_elif_token1] = ACTIONS(2628),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym___cdecl] = ACTIONS(2628),
    [anon_sym___clrcall] = ACTIONS(2628),
    [anon_sym___stdcall] = ACTIONS(2628),
    [anon_sym___fastcall] = ACTIONS(2628),
    [anon_sym___thiscall] = ACTIONS(2628),
    [anon_sym___vectorcall] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_goto] = ACTIONS(2628),
    [anon_sym___try] = ACTIONS(2628),
    [anon_sym___leave] = ACTIONS(2628),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_compl] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_sizeof] = ACTIONS(2628),
    [anon_sym___alignof__] = ACTIONS(2628),
    [anon_sym___alignof] = ACTIONS(2628),
    [anon_sym__alignof] = ACTIONS(2628),
    [anon_sym_alignof] = ACTIONS(2628),
    [anon_sym__Alignof] = ACTIONS(2628),
    [anon_sym_offsetof] = ACTIONS(2628),
    [anon_sym__Generic] = ACTIONS(2628),
    [anon_sym_asm] = ACTIONS(2628),
    [anon_sym___asm__] = ACTIONS(2628),
    [anon_sym___asm] = ACTIONS(2628),
    [sym_number_literal] = ACTIONS(2630),
    [anon_sym_L_SQUOTE] = ACTIONS(2630),
    [anon_sym_u_SQUOTE] = ACTIONS(2630),
    [anon_sym_U_SQUOTE] = ACTIONS(2630),
    [anon_sym_u8_SQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_L_DQUOTE] = ACTIONS(2630),
    [anon_sym_u_DQUOTE] = ACTIONS(2630),
    [anon_sym_U_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8_DQUOTE] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [anon_sym_NULL] = ACTIONS(2628),
    [anon_sym_nullptr] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_concept] = ACTIONS(2628),
    [anon_sym_co_return] = ACTIONS(2628),
    [anon_sym_co_yield] = ACTIONS(2628),
    [anon_sym_R_DQUOTE] = ACTIONS(2630),
    [anon_sym_LR_DQUOTE] = ACTIONS(2630),
    [anon_sym_uR_DQUOTE] = ACTIONS(2630),
    [anon_sym_UR_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2630),
    [anon_sym_co_await] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_requires] = ACTIONS(2628),
    [sym_this] = ACTIONS(2628),
    [anon_sym_discard] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
    [anon_sym_cbuffer] = ACTIONS(2628),
  },
  [397] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_include_token1] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token2] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [aux_sym_preproc_else_token1] = ACTIONS(2632),
    [aux_sym_preproc_elif_token1] = ACTIONS(2632),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym___cdecl] = ACTIONS(2632),
    [anon_sym___clrcall] = ACTIONS(2632),
    [anon_sym___stdcall] = ACTIONS(2632),
    [anon_sym___fastcall] = ACTIONS(2632),
    [anon_sym___thiscall] = ACTIONS(2632),
    [anon_sym___vectorcall] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_goto] = ACTIONS(2632),
    [anon_sym___try] = ACTIONS(2632),
    [anon_sym___leave] = ACTIONS(2632),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_compl] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_sizeof] = ACTIONS(2632),
    [anon_sym___alignof__] = ACTIONS(2632),
    [anon_sym___alignof] = ACTIONS(2632),
    [anon_sym__alignof] = ACTIONS(2632),
    [anon_sym_alignof] = ACTIONS(2632),
    [anon_sym__Alignof] = ACTIONS(2632),
    [anon_sym_offsetof] = ACTIONS(2632),
    [anon_sym__Generic] = ACTIONS(2632),
    [anon_sym_asm] = ACTIONS(2632),
    [anon_sym___asm__] = ACTIONS(2632),
    [anon_sym___asm] = ACTIONS(2632),
    [sym_number_literal] = ACTIONS(2634),
    [anon_sym_L_SQUOTE] = ACTIONS(2634),
    [anon_sym_u_SQUOTE] = ACTIONS(2634),
    [anon_sym_U_SQUOTE] = ACTIONS(2634),
    [anon_sym_u8_SQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_L_DQUOTE] = ACTIONS(2634),
    [anon_sym_u_DQUOTE] = ACTIONS(2634),
    [anon_sym_U_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8_DQUOTE] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [anon_sym_NULL] = ACTIONS(2632),
    [anon_sym_nullptr] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_concept] = ACTIONS(2632),
    [anon_sym_co_return] = ACTIONS(2632),
    [anon_sym_co_yield] = ACTIONS(2632),
    [anon_sym_R_DQUOTE] = ACTIONS(2634),
    [anon_sym_LR_DQUOTE] = ACTIONS(2634),
    [anon_sym_uR_DQUOTE] = ACTIONS(2634),
    [anon_sym_UR_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2634),
    [anon_sym_co_await] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_requires] = ACTIONS(2632),
    [sym_this] = ACTIONS(2632),
    [anon_sym_discard] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
    [anon_sym_cbuffer] = ACTIONS(2632),
  },
  [398] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_include_token1] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token2] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [aux_sym_preproc_else_token1] = ACTIONS(2636),
    [aux_sym_preproc_elif_token1] = ACTIONS(2636),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym___cdecl] = ACTIONS(2636),
    [anon_sym___clrcall] = ACTIONS(2636),
    [anon_sym___stdcall] = ACTIONS(2636),
    [anon_sym___fastcall] = ACTIONS(2636),
    [anon_sym___thiscall] = ACTIONS(2636),
    [anon_sym___vectorcall] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(2636),
    [anon_sym___try] = ACTIONS(2636),
    [anon_sym___leave] = ACTIONS(2636),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_compl] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2638),
    [anon_sym_sizeof] = ACTIONS(2636),
    [anon_sym___alignof__] = ACTIONS(2636),
    [anon_sym___alignof] = ACTIONS(2636),
    [anon_sym__alignof] = ACTIONS(2636),
    [anon_sym_alignof] = ACTIONS(2636),
    [anon_sym__Alignof] = ACTIONS(2636),
    [anon_sym_offsetof] = ACTIONS(2636),
    [anon_sym__Generic] = ACTIONS(2636),
    [anon_sym_asm] = ACTIONS(2636),
    [anon_sym___asm__] = ACTIONS(2636),
    [anon_sym___asm] = ACTIONS(2636),
    [sym_number_literal] = ACTIONS(2638),
    [anon_sym_L_SQUOTE] = ACTIONS(2638),
    [anon_sym_u_SQUOTE] = ACTIONS(2638),
    [anon_sym_U_SQUOTE] = ACTIONS(2638),
    [anon_sym_u8_SQUOTE] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_L_DQUOTE] = ACTIONS(2638),
    [anon_sym_u_DQUOTE] = ACTIONS(2638),
    [anon_sym_U_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8_DQUOTE] = ACTIONS(2638),
    [anon_sym_DQUOTE] = ACTIONS(2638),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [anon_sym_NULL] = ACTIONS(2636),
    [anon_sym_nullptr] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_concept] = ACTIONS(2636),
    [anon_sym_co_return] = ACTIONS(2636),
    [anon_sym_co_yield] = ACTIONS(2636),
    [anon_sym_R_DQUOTE] = ACTIONS(2638),
    [anon_sym_LR_DQUOTE] = ACTIONS(2638),
    [anon_sym_uR_DQUOTE] = ACTIONS(2638),
    [anon_sym_UR_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2638),
    [anon_sym_co_await] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_requires] = ACTIONS(2636),
    [sym_this] = ACTIONS(2636),
    [anon_sym_discard] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
    [anon_sym_cbuffer] = ACTIONS(2636),
  },
  [399] = {
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_preproc_include_token1] = ACTIONS(2640),
    [aux_sym_preproc_def_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token2] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2640),
    [aux_sym_preproc_else_token1] = ACTIONS(2640),
    [aux_sym_preproc_elif_token1] = ACTIONS(2640),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2640),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2640),
    [sym_preproc_directive] = ACTIONS(2640),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym___extension__] = ACTIONS(2640),
    [anon_sym_typedef] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_out] = ACTIONS(2640),
    [anon_sym_inout] = ACTIONS(2640),
    [anon_sym_virtual] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym___attribute__] = ACTIONS(2640),
    [anon_sym___attribute] = ACTIONS(2640),
    [anon_sym_using] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2640),
    [anon_sym___based] = ACTIONS(2640),
    [anon_sym___cdecl] = ACTIONS(2640),
    [anon_sym___clrcall] = ACTIONS(2640),
    [anon_sym___stdcall] = ACTIONS(2640),
    [anon_sym___fastcall] = ACTIONS(2640),
    [anon_sym___thiscall] = ACTIONS(2640),
    [anon_sym___vectorcall] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_signed] = ACTIONS(2640),
    [anon_sym_unsigned] = ACTIONS(2640),
    [anon_sym_long] = ACTIONS(2640),
    [anon_sym_short] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_register] = ACTIONS(2640),
    [anon_sym_inline] = ACTIONS(2640),
    [anon_sym___inline] = ACTIONS(2640),
    [anon_sym___inline__] = ACTIONS(2640),
    [anon_sym___forceinline] = ACTIONS(2640),
    [anon_sym_thread_local] = ACTIONS(2640),
    [anon_sym___thread] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_constexpr] = ACTIONS(2640),
    [anon_sym_volatile] = ACTIONS(2640),
    [anon_sym_restrict] = ACTIONS(2640),
    [anon_sym___restrict__] = ACTIONS(2640),
    [anon_sym__Atomic] = ACTIONS(2640),
    [anon_sym__Noreturn] = ACTIONS(2640),
    [anon_sym_noreturn] = ACTIONS(2640),
    [anon_sym__Nonnull] = ACTIONS(2640),
    [anon_sym_mutable] = ACTIONS(2640),
    [anon_sym_constinit] = ACTIONS(2640),
    [anon_sym_consteval] = ACTIONS(2640),
    [anon_sym_alignas] = ACTIONS(2640),
    [anon_sym__Alignas] = ACTIONS(2640),
    [sym_primitive_type] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_switch] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_goto] = ACTIONS(2640),
    [anon_sym___try] = ACTIONS(2640),
    [anon_sym___leave] = ACTIONS(2640),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_compl] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2642),
    [anon_sym_sizeof] = ACTIONS(2640),
    [anon_sym___alignof__] = ACTIONS(2640),
    [anon_sym___alignof] = ACTIONS(2640),
    [anon_sym__alignof] = ACTIONS(2640),
    [anon_sym_alignof] = ACTIONS(2640),
    [anon_sym__Alignof] = ACTIONS(2640),
    [anon_sym_offsetof] = ACTIONS(2640),
    [anon_sym__Generic] = ACTIONS(2640),
    [anon_sym_asm] = ACTIONS(2640),
    [anon_sym___asm__] = ACTIONS(2640),
    [anon_sym___asm] = ACTIONS(2640),
    [sym_number_literal] = ACTIONS(2642),
    [anon_sym_L_SQUOTE] = ACTIONS(2642),
    [anon_sym_u_SQUOTE] = ACTIONS(2642),
    [anon_sym_U_SQUOTE] = ACTIONS(2642),
    [anon_sym_u8_SQUOTE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym_L_DQUOTE] = ACTIONS(2642),
    [anon_sym_u_DQUOTE] = ACTIONS(2642),
    [anon_sym_U_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8_DQUOTE] = ACTIONS(2642),
    [anon_sym_DQUOTE] = ACTIONS(2642),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_NULL] = ACTIONS(2640),
    [anon_sym_nullptr] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2640),
    [anon_sym_decltype] = ACTIONS(2640),
    [anon_sym_explicit] = ACTIONS(2640),
    [anon_sym_typename] = ACTIONS(2640),
    [anon_sym_template] = ACTIONS(2640),
    [anon_sym_operator] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [anon_sym_delete] = ACTIONS(2640),
    [anon_sym_throw] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_static_assert] = ACTIONS(2640),
    [anon_sym_concept] = ACTIONS(2640),
    [anon_sym_co_return] = ACTIONS(2640),
    [anon_sym_co_yield] = ACTIONS(2640),
    [anon_sym_R_DQUOTE] = ACTIONS(2642),
    [anon_sym_LR_DQUOTE] = ACTIONS(2642),
    [anon_sym_uR_DQUOTE] = ACTIONS(2642),
    [anon_sym_UR_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2642),
    [anon_sym_co_await] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2640),
    [anon_sym_requires] = ACTIONS(2640),
    [sym_this] = ACTIONS(2640),
    [anon_sym_discard] = ACTIONS(2640),
    [anon_sym_precise] = ACTIONS(2640),
    [anon_sym_shared] = ACTIONS(2640),
    [anon_sym_groupshared] = ACTIONS(2640),
    [anon_sym_uniform] = ACTIONS(2640),
    [anon_sym_row_major] = ACTIONS(2640),
    [anon_sym_column_major] = ACTIONS(2640),
    [anon_sym_globallycoherent] = ACTIONS(2640),
    [anon_sym_centroid] = ACTIONS(2640),
    [anon_sym_noperspective] = ACTIONS(2640),
    [anon_sym_nointerpolation] = ACTIONS(2640),
    [anon_sym_sample] = ACTIONS(2640),
    [anon_sym_linear] = ACTIONS(2640),
    [anon_sym_snorm] = ACTIONS(2640),
    [anon_sym_unorm] = ACTIONS(2640),
    [anon_sym_point] = ACTIONS(2640),
    [anon_sym_line] = ACTIONS(2640),
    [anon_sym_triangleadj] = ACTIONS(2640),
    [anon_sym_lineadj] = ACTIONS(2640),
    [anon_sym_triangle] = ACTIONS(2640),
    [anon_sym_cbuffer] = ACTIONS(2640),
  },
  [400] = {
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_preproc_include_token1] = ACTIONS(2644),
    [aux_sym_preproc_def_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token2] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2644),
    [aux_sym_preproc_else_token1] = ACTIONS(2644),
    [aux_sym_preproc_elif_token1] = ACTIONS(2644),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2644),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2644),
    [sym_preproc_directive] = ACTIONS(2644),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym___extension__] = ACTIONS(2644),
    [anon_sym_typedef] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_out] = ACTIONS(2644),
    [anon_sym_inout] = ACTIONS(2644),
    [anon_sym_virtual] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym___attribute__] = ACTIONS(2644),
    [anon_sym___attribute] = ACTIONS(2644),
    [anon_sym_using] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2646),
    [anon_sym___declspec] = ACTIONS(2644),
    [anon_sym___based] = ACTIONS(2644),
    [anon_sym___cdecl] = ACTIONS(2644),
    [anon_sym___clrcall] = ACTIONS(2644),
    [anon_sym___stdcall] = ACTIONS(2644),
    [anon_sym___fastcall] = ACTIONS(2644),
    [anon_sym___thiscall] = ACTIONS(2644),
    [anon_sym___vectorcall] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_signed] = ACTIONS(2644),
    [anon_sym_unsigned] = ACTIONS(2644),
    [anon_sym_long] = ACTIONS(2644),
    [anon_sym_short] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_register] = ACTIONS(2644),
    [anon_sym_inline] = ACTIONS(2644),
    [anon_sym___inline] = ACTIONS(2644),
    [anon_sym___inline__] = ACTIONS(2644),
    [anon_sym___forceinline] = ACTIONS(2644),
    [anon_sym_thread_local] = ACTIONS(2644),
    [anon_sym___thread] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_constexpr] = ACTIONS(2644),
    [anon_sym_volatile] = ACTIONS(2644),
    [anon_sym_restrict] = ACTIONS(2644),
    [anon_sym___restrict__] = ACTIONS(2644),
    [anon_sym__Atomic] = ACTIONS(2644),
    [anon_sym__Noreturn] = ACTIONS(2644),
    [anon_sym_noreturn] = ACTIONS(2644),
    [anon_sym__Nonnull] = ACTIONS(2644),
    [anon_sym_mutable] = ACTIONS(2644),
    [anon_sym_constinit] = ACTIONS(2644),
    [anon_sym_consteval] = ACTIONS(2644),
    [anon_sym_alignas] = ACTIONS(2644),
    [anon_sym__Alignas] = ACTIONS(2644),
    [sym_primitive_type] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_switch] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_goto] = ACTIONS(2644),
    [anon_sym___try] = ACTIONS(2644),
    [anon_sym___leave] = ACTIONS(2644),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_compl] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_sizeof] = ACTIONS(2644),
    [anon_sym___alignof__] = ACTIONS(2644),
    [anon_sym___alignof] = ACTIONS(2644),
    [anon_sym__alignof] = ACTIONS(2644),
    [anon_sym_alignof] = ACTIONS(2644),
    [anon_sym__Alignof] = ACTIONS(2644),
    [anon_sym_offsetof] = ACTIONS(2644),
    [anon_sym__Generic] = ACTIONS(2644),
    [anon_sym_asm] = ACTIONS(2644),
    [anon_sym___asm__] = ACTIONS(2644),
    [anon_sym___asm] = ACTIONS(2644),
    [sym_number_literal] = ACTIONS(2646),
    [anon_sym_L_SQUOTE] = ACTIONS(2646),
    [anon_sym_u_SQUOTE] = ACTIONS(2646),
    [anon_sym_U_SQUOTE] = ACTIONS(2646),
    [anon_sym_u8_SQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [anon_sym_L_DQUOTE] = ACTIONS(2646),
    [anon_sym_u_DQUOTE] = ACTIONS(2646),
    [anon_sym_U_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8_DQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [anon_sym_NULL] = ACTIONS(2644),
    [anon_sym_nullptr] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2644),
    [anon_sym_decltype] = ACTIONS(2644),
    [anon_sym_explicit] = ACTIONS(2644),
    [anon_sym_typename] = ACTIONS(2644),
    [anon_sym_template] = ACTIONS(2644),
    [anon_sym_operator] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [anon_sym_delete] = ACTIONS(2644),
    [anon_sym_throw] = ACTIONS(2644),
    [anon_sym_namespace] = ACTIONS(2644),
    [anon_sym_static_assert] = ACTIONS(2644),
    [anon_sym_concept] = ACTIONS(2644),
    [anon_sym_co_return] = ACTIONS(2644),
    [anon_sym_co_yield] = ACTIONS(2644),
    [anon_sym_R_DQUOTE] = ACTIONS(2646),
    [anon_sym_LR_DQUOTE] = ACTIONS(2646),
    [anon_sym_uR_DQUOTE] = ACTIONS(2646),
    [anon_sym_UR_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2646),
    [anon_sym_co_await] = ACTIONS(2644),
    [anon_sym_new] = ACTIONS(2644),
    [anon_sym_requires] = ACTIONS(2644),
    [sym_this] = ACTIONS(2644),
    [anon_sym_discard] = ACTIONS(2644),
    [anon_sym_precise] = ACTIONS(2644),
    [anon_sym_shared] = ACTIONS(2644),
    [anon_sym_groupshared] = ACTIONS(2644),
    [anon_sym_uniform] = ACTIONS(2644),
    [anon_sym_row_major] = ACTIONS(2644),
    [anon_sym_column_major] = ACTIONS(2644),
    [anon_sym_globallycoherent] = ACTIONS(2644),
    [anon_sym_centroid] = ACTIONS(2644),
    [anon_sym_noperspective] = ACTIONS(2644),
    [anon_sym_nointerpolation] = ACTIONS(2644),
    [anon_sym_sample] = ACTIONS(2644),
    [anon_sym_linear] = ACTIONS(2644),
    [anon_sym_snorm] = ACTIONS(2644),
    [anon_sym_unorm] = ACTIONS(2644),
    [anon_sym_point] = ACTIONS(2644),
    [anon_sym_line] = ACTIONS(2644),
    [anon_sym_triangleadj] = ACTIONS(2644),
    [anon_sym_lineadj] = ACTIONS(2644),
    [anon_sym_triangle] = ACTIONS(2644),
    [anon_sym_cbuffer] = ACTIONS(2644),
  },
  [401] = {
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_preproc_include_token1] = ACTIONS(2648),
    [aux_sym_preproc_def_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token2] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2648),
    [aux_sym_preproc_else_token1] = ACTIONS(2648),
    [aux_sym_preproc_elif_token1] = ACTIONS(2648),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2648),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2648),
    [sym_preproc_directive] = ACTIONS(2648),
    [anon_sym_LPAREN2] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_AMP_AMP] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym___extension__] = ACTIONS(2648),
    [anon_sym_typedef] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_out] = ACTIONS(2648),
    [anon_sym_inout] = ACTIONS(2648),
    [anon_sym_virtual] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym___attribute__] = ACTIONS(2648),
    [anon_sym___attribute] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2650),
    [anon_sym___declspec] = ACTIONS(2648),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym___cdecl] = ACTIONS(2648),
    [anon_sym___clrcall] = ACTIONS(2648),
    [anon_sym___stdcall] = ACTIONS(2648),
    [anon_sym___fastcall] = ACTIONS(2648),
    [anon_sym___thiscall] = ACTIONS(2648),
    [anon_sym___vectorcall] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_signed] = ACTIONS(2648),
    [anon_sym_unsigned] = ACTIONS(2648),
    [anon_sym_long] = ACTIONS(2648),
    [anon_sym_short] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_register] = ACTIONS(2648),
    [anon_sym_inline] = ACTIONS(2648),
    [anon_sym___inline] = ACTIONS(2648),
    [anon_sym___inline__] = ACTIONS(2648),
    [anon_sym___forceinline] = ACTIONS(2648),
    [anon_sym_thread_local] = ACTIONS(2648),
    [anon_sym___thread] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_constexpr] = ACTIONS(2648),
    [anon_sym_volatile] = ACTIONS(2648),
    [anon_sym_restrict] = ACTIONS(2648),
    [anon_sym___restrict__] = ACTIONS(2648),
    [anon_sym__Atomic] = ACTIONS(2648),
    [anon_sym__Noreturn] = ACTIONS(2648),
    [anon_sym_noreturn] = ACTIONS(2648),
    [anon_sym__Nonnull] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_constinit] = ACTIONS(2648),
    [anon_sym_consteval] = ACTIONS(2648),
    [anon_sym_alignas] = ACTIONS(2648),
    [anon_sym__Alignas] = ACTIONS(2648),
    [sym_primitive_type] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_class] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_switch] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_goto] = ACTIONS(2648),
    [anon_sym___try] = ACTIONS(2648),
    [anon_sym___leave] = ACTIONS(2648),
    [anon_sym_not] = ACTIONS(2648),
    [anon_sym_compl] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_sizeof] = ACTIONS(2648),
    [anon_sym___alignof__] = ACTIONS(2648),
    [anon_sym___alignof] = ACTIONS(2648),
    [anon_sym__alignof] = ACTIONS(2648),
    [anon_sym_alignof] = ACTIONS(2648),
    [anon_sym__Alignof] = ACTIONS(2648),
    [anon_sym_offsetof] = ACTIONS(2648),
    [anon_sym__Generic] = ACTIONS(2648),
    [anon_sym_asm] = ACTIONS(2648),
    [anon_sym___asm__] = ACTIONS(2648),
    [anon_sym___asm] = ACTIONS(2648),
    [sym_number_literal] = ACTIONS(2650),
    [anon_sym_L_SQUOTE] = ACTIONS(2650),
    [anon_sym_u_SQUOTE] = ACTIONS(2650),
    [anon_sym_U_SQUOTE] = ACTIONS(2650),
    [anon_sym_u8_SQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [anon_sym_L_DQUOTE] = ACTIONS(2650),
    [anon_sym_u_DQUOTE] = ACTIONS(2650),
    [anon_sym_U_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8_DQUOTE] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [anon_sym_NULL] = ACTIONS(2648),
    [anon_sym_nullptr] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2648),
    [anon_sym_decltype] = ACTIONS(2648),
    [anon_sym_explicit] = ACTIONS(2648),
    [anon_sym_typename] = ACTIONS(2648),
    [anon_sym_template] = ACTIONS(2648),
    [anon_sym_operator] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_delete] = ACTIONS(2648),
    [anon_sym_throw] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_static_assert] = ACTIONS(2648),
    [anon_sym_concept] = ACTIONS(2648),
    [anon_sym_co_return] = ACTIONS(2648),
    [anon_sym_co_yield] = ACTIONS(2648),
    [anon_sym_R_DQUOTE] = ACTIONS(2650),
    [anon_sym_LR_DQUOTE] = ACTIONS(2650),
    [anon_sym_uR_DQUOTE] = ACTIONS(2650),
    [anon_sym_UR_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2650),
    [anon_sym_co_await] = ACTIONS(2648),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_requires] = ACTIONS(2648),
    [sym_this] = ACTIONS(2648),
    [anon_sym_discard] = ACTIONS(2648),
    [anon_sym_precise] = ACTIONS(2648),
    [anon_sym_shared] = ACTIONS(2648),
    [anon_sym_groupshared] = ACTIONS(2648),
    [anon_sym_uniform] = ACTIONS(2648),
    [anon_sym_row_major] = ACTIONS(2648),
    [anon_sym_column_major] = ACTIONS(2648),
    [anon_sym_globallycoherent] = ACTIONS(2648),
    [anon_sym_centroid] = ACTIONS(2648),
    [anon_sym_noperspective] = ACTIONS(2648),
    [anon_sym_nointerpolation] = ACTIONS(2648),
    [anon_sym_sample] = ACTIONS(2648),
    [anon_sym_linear] = ACTIONS(2648),
    [anon_sym_snorm] = ACTIONS(2648),
    [anon_sym_unorm] = ACTIONS(2648),
    [anon_sym_point] = ACTIONS(2648),
    [anon_sym_line] = ACTIONS(2648),
    [anon_sym_triangleadj] = ACTIONS(2648),
    [anon_sym_lineadj] = ACTIONS(2648),
    [anon_sym_triangle] = ACTIONS(2648),
    [anon_sym_cbuffer] = ACTIONS(2648),
  },
  [402] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [aux_sym_preproc_else_token1] = ACTIONS(2462),
    [aux_sym_preproc_elif_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [403] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_include_token1] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token2] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [aux_sym_preproc_else_token1] = ACTIONS(2652),
    [aux_sym_preproc_elif_token1] = ACTIONS(2652),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym___cdecl] = ACTIONS(2652),
    [anon_sym___clrcall] = ACTIONS(2652),
    [anon_sym___stdcall] = ACTIONS(2652),
    [anon_sym___fastcall] = ACTIONS(2652),
    [anon_sym___thiscall] = ACTIONS(2652),
    [anon_sym___vectorcall] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_do] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_goto] = ACTIONS(2652),
    [anon_sym___try] = ACTIONS(2652),
    [anon_sym___leave] = ACTIONS(2652),
    [anon_sym_not] = ACTIONS(2652),
    [anon_sym_compl] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_sizeof] = ACTIONS(2652),
    [anon_sym___alignof__] = ACTIONS(2652),
    [anon_sym___alignof] = ACTIONS(2652),
    [anon_sym__alignof] = ACTIONS(2652),
    [anon_sym_alignof] = ACTIONS(2652),
    [anon_sym__Alignof] = ACTIONS(2652),
    [anon_sym_offsetof] = ACTIONS(2652),
    [anon_sym__Generic] = ACTIONS(2652),
    [anon_sym_asm] = ACTIONS(2652),
    [anon_sym___asm__] = ACTIONS(2652),
    [anon_sym___asm] = ACTIONS(2652),
    [sym_number_literal] = ACTIONS(2654),
    [anon_sym_L_SQUOTE] = ACTIONS(2654),
    [anon_sym_u_SQUOTE] = ACTIONS(2654),
    [anon_sym_U_SQUOTE] = ACTIONS(2654),
    [anon_sym_u8_SQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [anon_sym_L_DQUOTE] = ACTIONS(2654),
    [anon_sym_u_DQUOTE] = ACTIONS(2654),
    [anon_sym_U_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8_DQUOTE] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [anon_sym_NULL] = ACTIONS(2652),
    [anon_sym_nullptr] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [anon_sym_delete] = ACTIONS(2652),
    [anon_sym_throw] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_concept] = ACTIONS(2652),
    [anon_sym_co_return] = ACTIONS(2652),
    [anon_sym_co_yield] = ACTIONS(2652),
    [anon_sym_R_DQUOTE] = ACTIONS(2654),
    [anon_sym_LR_DQUOTE] = ACTIONS(2654),
    [anon_sym_uR_DQUOTE] = ACTIONS(2654),
    [anon_sym_UR_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2654),
    [anon_sym_co_await] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_requires] = ACTIONS(2652),
    [sym_this] = ACTIONS(2652),
    [anon_sym_discard] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
    [anon_sym_cbuffer] = ACTIONS(2652),
  },
  [404] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [405] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_include_token1] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token2] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [aux_sym_preproc_else_token1] = ACTIONS(2656),
    [aux_sym_preproc_elif_token1] = ACTIONS(2656),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym___cdecl] = ACTIONS(2656),
    [anon_sym___clrcall] = ACTIONS(2656),
    [anon_sym___stdcall] = ACTIONS(2656),
    [anon_sym___fastcall] = ACTIONS(2656),
    [anon_sym___thiscall] = ACTIONS(2656),
    [anon_sym___vectorcall] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_goto] = ACTIONS(2656),
    [anon_sym___try] = ACTIONS(2656),
    [anon_sym___leave] = ACTIONS(2656),
    [anon_sym_not] = ACTIONS(2656),
    [anon_sym_compl] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_sizeof] = ACTIONS(2656),
    [anon_sym___alignof__] = ACTIONS(2656),
    [anon_sym___alignof] = ACTIONS(2656),
    [anon_sym__alignof] = ACTIONS(2656),
    [anon_sym_alignof] = ACTIONS(2656),
    [anon_sym__Alignof] = ACTIONS(2656),
    [anon_sym_offsetof] = ACTIONS(2656),
    [anon_sym__Generic] = ACTIONS(2656),
    [anon_sym_asm] = ACTIONS(2656),
    [anon_sym___asm__] = ACTIONS(2656),
    [anon_sym___asm] = ACTIONS(2656),
    [sym_number_literal] = ACTIONS(2658),
    [anon_sym_L_SQUOTE] = ACTIONS(2658),
    [anon_sym_u_SQUOTE] = ACTIONS(2658),
    [anon_sym_U_SQUOTE] = ACTIONS(2658),
    [anon_sym_u8_SQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_L_DQUOTE] = ACTIONS(2658),
    [anon_sym_u_DQUOTE] = ACTIONS(2658),
    [anon_sym_U_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8_DQUOTE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [anon_sym_NULL] = ACTIONS(2656),
    [anon_sym_nullptr] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_concept] = ACTIONS(2656),
    [anon_sym_co_return] = ACTIONS(2656),
    [anon_sym_co_yield] = ACTIONS(2656),
    [anon_sym_R_DQUOTE] = ACTIONS(2658),
    [anon_sym_LR_DQUOTE] = ACTIONS(2658),
    [anon_sym_uR_DQUOTE] = ACTIONS(2658),
    [anon_sym_UR_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2658),
    [anon_sym_co_await] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_requires] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [anon_sym_discard] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_cbuffer] = ACTIONS(2656),
  },
  [406] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [407] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_include_token1] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token2] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [aux_sym_preproc_else_token1] = ACTIONS(2660),
    [aux_sym_preproc_elif_token1] = ACTIONS(2660),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym___cdecl] = ACTIONS(2660),
    [anon_sym___clrcall] = ACTIONS(2660),
    [anon_sym___stdcall] = ACTIONS(2660),
    [anon_sym___fastcall] = ACTIONS(2660),
    [anon_sym___thiscall] = ACTIONS(2660),
    [anon_sym___vectorcall] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_goto] = ACTIONS(2660),
    [anon_sym___try] = ACTIONS(2660),
    [anon_sym___leave] = ACTIONS(2660),
    [anon_sym_not] = ACTIONS(2660),
    [anon_sym_compl] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_sizeof] = ACTIONS(2660),
    [anon_sym___alignof__] = ACTIONS(2660),
    [anon_sym___alignof] = ACTIONS(2660),
    [anon_sym__alignof] = ACTIONS(2660),
    [anon_sym_alignof] = ACTIONS(2660),
    [anon_sym__Alignof] = ACTIONS(2660),
    [anon_sym_offsetof] = ACTIONS(2660),
    [anon_sym__Generic] = ACTIONS(2660),
    [anon_sym_asm] = ACTIONS(2660),
    [anon_sym___asm__] = ACTIONS(2660),
    [anon_sym___asm] = ACTIONS(2660),
    [sym_number_literal] = ACTIONS(2662),
    [anon_sym_L_SQUOTE] = ACTIONS(2662),
    [anon_sym_u_SQUOTE] = ACTIONS(2662),
    [anon_sym_U_SQUOTE] = ACTIONS(2662),
    [anon_sym_u8_SQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_L_DQUOTE] = ACTIONS(2662),
    [anon_sym_u_DQUOTE] = ACTIONS(2662),
    [anon_sym_U_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8_DQUOTE] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [anon_sym_NULL] = ACTIONS(2660),
    [anon_sym_nullptr] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_concept] = ACTIONS(2660),
    [anon_sym_co_return] = ACTIONS(2660),
    [anon_sym_co_yield] = ACTIONS(2660),
    [anon_sym_R_DQUOTE] = ACTIONS(2662),
    [anon_sym_LR_DQUOTE] = ACTIONS(2662),
    [anon_sym_uR_DQUOTE] = ACTIONS(2662),
    [anon_sym_UR_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2662),
    [anon_sym_co_await] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_requires] = ACTIONS(2660),
    [sym_this] = ACTIONS(2660),
    [anon_sym_discard] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
    [anon_sym_cbuffer] = ACTIONS(2660),
  },
  [408] = {
    [sym_identifier] = ACTIONS(2664),
    [aux_sym_preproc_include_token1] = ACTIONS(2664),
    [aux_sym_preproc_def_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token2] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2664),
    [aux_sym_preproc_else_token1] = ACTIONS(2664),
    [aux_sym_preproc_elif_token1] = ACTIONS(2664),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2664),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2664),
    [sym_preproc_directive] = ACTIONS(2664),
    [anon_sym_LPAREN2] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym___extension__] = ACTIONS(2664),
    [anon_sym_typedef] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2664),
    [anon_sym_out] = ACTIONS(2664),
    [anon_sym_inout] = ACTIONS(2664),
    [anon_sym_virtual] = ACTIONS(2664),
    [anon_sym_extern] = ACTIONS(2664),
    [anon_sym___attribute__] = ACTIONS(2664),
    [anon_sym___attribute] = ACTIONS(2664),
    [anon_sym_using] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2666),
    [anon_sym___declspec] = ACTIONS(2664),
    [anon_sym___based] = ACTIONS(2664),
    [anon_sym___cdecl] = ACTIONS(2664),
    [anon_sym___clrcall] = ACTIONS(2664),
    [anon_sym___stdcall] = ACTIONS(2664),
    [anon_sym___fastcall] = ACTIONS(2664),
    [anon_sym___thiscall] = ACTIONS(2664),
    [anon_sym___vectorcall] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_signed] = ACTIONS(2664),
    [anon_sym_unsigned] = ACTIONS(2664),
    [anon_sym_long] = ACTIONS(2664),
    [anon_sym_short] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_register] = ACTIONS(2664),
    [anon_sym_inline] = ACTIONS(2664),
    [anon_sym___inline] = ACTIONS(2664),
    [anon_sym___inline__] = ACTIONS(2664),
    [anon_sym___forceinline] = ACTIONS(2664),
    [anon_sym_thread_local] = ACTIONS(2664),
    [anon_sym___thread] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_constexpr] = ACTIONS(2664),
    [anon_sym_volatile] = ACTIONS(2664),
    [anon_sym_restrict] = ACTIONS(2664),
    [anon_sym___restrict__] = ACTIONS(2664),
    [anon_sym__Atomic] = ACTIONS(2664),
    [anon_sym__Noreturn] = ACTIONS(2664),
    [anon_sym_noreturn] = ACTIONS(2664),
    [anon_sym__Nonnull] = ACTIONS(2664),
    [anon_sym_mutable] = ACTIONS(2664),
    [anon_sym_constinit] = ACTIONS(2664),
    [anon_sym_consteval] = ACTIONS(2664),
    [anon_sym_alignas] = ACTIONS(2664),
    [anon_sym__Alignas] = ACTIONS(2664),
    [sym_primitive_type] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_struct] = ACTIONS(2664),
    [anon_sym_union] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_goto] = ACTIONS(2664),
    [anon_sym___try] = ACTIONS(2664),
    [anon_sym___leave] = ACTIONS(2664),
    [anon_sym_not] = ACTIONS(2664),
    [anon_sym_compl] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_sizeof] = ACTIONS(2664),
    [anon_sym___alignof__] = ACTIONS(2664),
    [anon_sym___alignof] = ACTIONS(2664),
    [anon_sym__alignof] = ACTIONS(2664),
    [anon_sym_alignof] = ACTIONS(2664),
    [anon_sym__Alignof] = ACTIONS(2664),
    [anon_sym_offsetof] = ACTIONS(2664),
    [anon_sym__Generic] = ACTIONS(2664),
    [anon_sym_asm] = ACTIONS(2664),
    [anon_sym___asm__] = ACTIONS(2664),
    [anon_sym___asm] = ACTIONS(2664),
    [sym_number_literal] = ACTIONS(2666),
    [anon_sym_L_SQUOTE] = ACTIONS(2666),
    [anon_sym_u_SQUOTE] = ACTIONS(2666),
    [anon_sym_U_SQUOTE] = ACTIONS(2666),
    [anon_sym_u8_SQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_L_DQUOTE] = ACTIONS(2666),
    [anon_sym_u_DQUOTE] = ACTIONS(2666),
    [anon_sym_U_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [anon_sym_NULL] = ACTIONS(2664),
    [anon_sym_nullptr] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2664),
    [anon_sym_decltype] = ACTIONS(2664),
    [anon_sym_explicit] = ACTIONS(2664),
    [anon_sym_typename] = ACTIONS(2664),
    [anon_sym_template] = ACTIONS(2664),
    [anon_sym_operator] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_static_assert] = ACTIONS(2664),
    [anon_sym_concept] = ACTIONS(2664),
    [anon_sym_co_return] = ACTIONS(2664),
    [anon_sym_co_yield] = ACTIONS(2664),
    [anon_sym_R_DQUOTE] = ACTIONS(2666),
    [anon_sym_LR_DQUOTE] = ACTIONS(2666),
    [anon_sym_uR_DQUOTE] = ACTIONS(2666),
    [anon_sym_UR_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2666),
    [anon_sym_co_await] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_requires] = ACTIONS(2664),
    [sym_this] = ACTIONS(2664),
    [anon_sym_discard] = ACTIONS(2664),
    [anon_sym_precise] = ACTIONS(2664),
    [anon_sym_shared] = ACTIONS(2664),
    [anon_sym_groupshared] = ACTIONS(2664),
    [anon_sym_uniform] = ACTIONS(2664),
    [anon_sym_row_major] = ACTIONS(2664),
    [anon_sym_column_major] = ACTIONS(2664),
    [anon_sym_globallycoherent] = ACTIONS(2664),
    [anon_sym_centroid] = ACTIONS(2664),
    [anon_sym_noperspective] = ACTIONS(2664),
    [anon_sym_nointerpolation] = ACTIONS(2664),
    [anon_sym_sample] = ACTIONS(2664),
    [anon_sym_linear] = ACTIONS(2664),
    [anon_sym_snorm] = ACTIONS(2664),
    [anon_sym_unorm] = ACTIONS(2664),
    [anon_sym_point] = ACTIONS(2664),
    [anon_sym_line] = ACTIONS(2664),
    [anon_sym_triangleadj] = ACTIONS(2664),
    [anon_sym_lineadj] = ACTIONS(2664),
    [anon_sym_triangle] = ACTIONS(2664),
    [anon_sym_cbuffer] = ACTIONS(2664),
  },
  [409] = {
    [sym_identifier] = ACTIONS(2668),
    [aux_sym_preproc_include_token1] = ACTIONS(2668),
    [aux_sym_preproc_def_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token2] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2668),
    [aux_sym_preproc_else_token1] = ACTIONS(2668),
    [aux_sym_preproc_elif_token1] = ACTIONS(2668),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2668),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2668),
    [sym_preproc_directive] = ACTIONS(2668),
    [anon_sym_LPAREN2] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_STAR] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym___extension__] = ACTIONS(2668),
    [anon_sym_typedef] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2668),
    [anon_sym_out] = ACTIONS(2668),
    [anon_sym_inout] = ACTIONS(2668),
    [anon_sym_virtual] = ACTIONS(2668),
    [anon_sym_extern] = ACTIONS(2668),
    [anon_sym___attribute__] = ACTIONS(2668),
    [anon_sym___attribute] = ACTIONS(2668),
    [anon_sym_using] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2670),
    [anon_sym___declspec] = ACTIONS(2668),
    [anon_sym___based] = ACTIONS(2668),
    [anon_sym___cdecl] = ACTIONS(2668),
    [anon_sym___clrcall] = ACTIONS(2668),
    [anon_sym___stdcall] = ACTIONS(2668),
    [anon_sym___fastcall] = ACTIONS(2668),
    [anon_sym___thiscall] = ACTIONS(2668),
    [anon_sym___vectorcall] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_signed] = ACTIONS(2668),
    [anon_sym_unsigned] = ACTIONS(2668),
    [anon_sym_long] = ACTIONS(2668),
    [anon_sym_short] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_register] = ACTIONS(2668),
    [anon_sym_inline] = ACTIONS(2668),
    [anon_sym___inline] = ACTIONS(2668),
    [anon_sym___inline__] = ACTIONS(2668),
    [anon_sym___forceinline] = ACTIONS(2668),
    [anon_sym_thread_local] = ACTIONS(2668),
    [anon_sym___thread] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_constexpr] = ACTIONS(2668),
    [anon_sym_volatile] = ACTIONS(2668),
    [anon_sym_restrict] = ACTIONS(2668),
    [anon_sym___restrict__] = ACTIONS(2668),
    [anon_sym__Atomic] = ACTIONS(2668),
    [anon_sym__Noreturn] = ACTIONS(2668),
    [anon_sym_noreturn] = ACTIONS(2668),
    [anon_sym__Nonnull] = ACTIONS(2668),
    [anon_sym_mutable] = ACTIONS(2668),
    [anon_sym_constinit] = ACTIONS(2668),
    [anon_sym_consteval] = ACTIONS(2668),
    [anon_sym_alignas] = ACTIONS(2668),
    [anon_sym__Alignas] = ACTIONS(2668),
    [sym_primitive_type] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_struct] = ACTIONS(2668),
    [anon_sym_union] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_goto] = ACTIONS(2668),
    [anon_sym___try] = ACTIONS(2668),
    [anon_sym___leave] = ACTIONS(2668),
    [anon_sym_not] = ACTIONS(2668),
    [anon_sym_compl] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_sizeof] = ACTIONS(2668),
    [anon_sym___alignof__] = ACTIONS(2668),
    [anon_sym___alignof] = ACTIONS(2668),
    [anon_sym__alignof] = ACTIONS(2668),
    [anon_sym_alignof] = ACTIONS(2668),
    [anon_sym__Alignof] = ACTIONS(2668),
    [anon_sym_offsetof] = ACTIONS(2668),
    [anon_sym__Generic] = ACTIONS(2668),
    [anon_sym_asm] = ACTIONS(2668),
    [anon_sym___asm__] = ACTIONS(2668),
    [anon_sym___asm] = ACTIONS(2668),
    [sym_number_literal] = ACTIONS(2670),
    [anon_sym_L_SQUOTE] = ACTIONS(2670),
    [anon_sym_u_SQUOTE] = ACTIONS(2670),
    [anon_sym_U_SQUOTE] = ACTIONS(2670),
    [anon_sym_u8_SQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_L_DQUOTE] = ACTIONS(2670),
    [anon_sym_u_DQUOTE] = ACTIONS(2670),
    [anon_sym_U_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8_DQUOTE] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [anon_sym_NULL] = ACTIONS(2668),
    [anon_sym_nullptr] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2668),
    [anon_sym_decltype] = ACTIONS(2668),
    [anon_sym_explicit] = ACTIONS(2668),
    [anon_sym_typename] = ACTIONS(2668),
    [anon_sym_template] = ACTIONS(2668),
    [anon_sym_operator] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_static_assert] = ACTIONS(2668),
    [anon_sym_concept] = ACTIONS(2668),
    [anon_sym_co_return] = ACTIONS(2668),
    [anon_sym_co_yield] = ACTIONS(2668),
    [anon_sym_R_DQUOTE] = ACTIONS(2670),
    [anon_sym_LR_DQUOTE] = ACTIONS(2670),
    [anon_sym_uR_DQUOTE] = ACTIONS(2670),
    [anon_sym_UR_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2670),
    [anon_sym_co_await] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_requires] = ACTIONS(2668),
    [sym_this] = ACTIONS(2668),
    [anon_sym_discard] = ACTIONS(2668),
    [anon_sym_precise] = ACTIONS(2668),
    [anon_sym_shared] = ACTIONS(2668),
    [anon_sym_groupshared] = ACTIONS(2668),
    [anon_sym_uniform] = ACTIONS(2668),
    [anon_sym_row_major] = ACTIONS(2668),
    [anon_sym_column_major] = ACTIONS(2668),
    [anon_sym_globallycoherent] = ACTIONS(2668),
    [anon_sym_centroid] = ACTIONS(2668),
    [anon_sym_noperspective] = ACTIONS(2668),
    [anon_sym_nointerpolation] = ACTIONS(2668),
    [anon_sym_sample] = ACTIONS(2668),
    [anon_sym_linear] = ACTIONS(2668),
    [anon_sym_snorm] = ACTIONS(2668),
    [anon_sym_unorm] = ACTIONS(2668),
    [anon_sym_point] = ACTIONS(2668),
    [anon_sym_line] = ACTIONS(2668),
    [anon_sym_triangleadj] = ACTIONS(2668),
    [anon_sym_lineadj] = ACTIONS(2668),
    [anon_sym_triangle] = ACTIONS(2668),
    [anon_sym_cbuffer] = ACTIONS(2668),
  },
  [410] = {
    [sym_identifier] = ACTIONS(2672),
    [aux_sym_preproc_include_token1] = ACTIONS(2672),
    [aux_sym_preproc_def_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token2] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2672),
    [aux_sym_preproc_else_token1] = ACTIONS(2672),
    [aux_sym_preproc_elif_token1] = ACTIONS(2672),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2672),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2672),
    [sym_preproc_directive] = ACTIONS(2672),
    [anon_sym_LPAREN2] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym___extension__] = ACTIONS(2672),
    [anon_sym_typedef] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2672),
    [anon_sym_out] = ACTIONS(2672),
    [anon_sym_inout] = ACTIONS(2672),
    [anon_sym_virtual] = ACTIONS(2672),
    [anon_sym_extern] = ACTIONS(2672),
    [anon_sym___attribute__] = ACTIONS(2672),
    [anon_sym___attribute] = ACTIONS(2672),
    [anon_sym_using] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2674),
    [anon_sym___declspec] = ACTIONS(2672),
    [anon_sym___based] = ACTIONS(2672),
    [anon_sym___cdecl] = ACTIONS(2672),
    [anon_sym___clrcall] = ACTIONS(2672),
    [anon_sym___stdcall] = ACTIONS(2672),
    [anon_sym___fastcall] = ACTIONS(2672),
    [anon_sym___thiscall] = ACTIONS(2672),
    [anon_sym___vectorcall] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_signed] = ACTIONS(2672),
    [anon_sym_unsigned] = ACTIONS(2672),
    [anon_sym_long] = ACTIONS(2672),
    [anon_sym_short] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_register] = ACTIONS(2672),
    [anon_sym_inline] = ACTIONS(2672),
    [anon_sym___inline] = ACTIONS(2672),
    [anon_sym___inline__] = ACTIONS(2672),
    [anon_sym___forceinline] = ACTIONS(2672),
    [anon_sym_thread_local] = ACTIONS(2672),
    [anon_sym___thread] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_constexpr] = ACTIONS(2672),
    [anon_sym_volatile] = ACTIONS(2672),
    [anon_sym_restrict] = ACTIONS(2672),
    [anon_sym___restrict__] = ACTIONS(2672),
    [anon_sym__Atomic] = ACTIONS(2672),
    [anon_sym__Noreturn] = ACTIONS(2672),
    [anon_sym_noreturn] = ACTIONS(2672),
    [anon_sym__Nonnull] = ACTIONS(2672),
    [anon_sym_mutable] = ACTIONS(2672),
    [anon_sym_constinit] = ACTIONS(2672),
    [anon_sym_consteval] = ACTIONS(2672),
    [anon_sym_alignas] = ACTIONS(2672),
    [anon_sym__Alignas] = ACTIONS(2672),
    [sym_primitive_type] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_goto] = ACTIONS(2672),
    [anon_sym___try] = ACTIONS(2672),
    [anon_sym___leave] = ACTIONS(2672),
    [anon_sym_not] = ACTIONS(2672),
    [anon_sym_compl] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_sizeof] = ACTIONS(2672),
    [anon_sym___alignof__] = ACTIONS(2672),
    [anon_sym___alignof] = ACTIONS(2672),
    [anon_sym__alignof] = ACTIONS(2672),
    [anon_sym_alignof] = ACTIONS(2672),
    [anon_sym__Alignof] = ACTIONS(2672),
    [anon_sym_offsetof] = ACTIONS(2672),
    [anon_sym__Generic] = ACTIONS(2672),
    [anon_sym_asm] = ACTIONS(2672),
    [anon_sym___asm__] = ACTIONS(2672),
    [anon_sym___asm] = ACTIONS(2672),
    [sym_number_literal] = ACTIONS(2674),
    [anon_sym_L_SQUOTE] = ACTIONS(2674),
    [anon_sym_u_SQUOTE] = ACTIONS(2674),
    [anon_sym_U_SQUOTE] = ACTIONS(2674),
    [anon_sym_u8_SQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_L_DQUOTE] = ACTIONS(2674),
    [anon_sym_u_DQUOTE] = ACTIONS(2674),
    [anon_sym_U_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8_DQUOTE] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [anon_sym_NULL] = ACTIONS(2672),
    [anon_sym_nullptr] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2672),
    [anon_sym_decltype] = ACTIONS(2672),
    [anon_sym_explicit] = ACTIONS(2672),
    [anon_sym_typename] = ACTIONS(2672),
    [anon_sym_template] = ACTIONS(2672),
    [anon_sym_operator] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_static_assert] = ACTIONS(2672),
    [anon_sym_concept] = ACTIONS(2672),
    [anon_sym_co_return] = ACTIONS(2672),
    [anon_sym_co_yield] = ACTIONS(2672),
    [anon_sym_R_DQUOTE] = ACTIONS(2674),
    [anon_sym_LR_DQUOTE] = ACTIONS(2674),
    [anon_sym_uR_DQUOTE] = ACTIONS(2674),
    [anon_sym_UR_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2674),
    [anon_sym_co_await] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_requires] = ACTIONS(2672),
    [sym_this] = ACTIONS(2672),
    [anon_sym_discard] = ACTIONS(2672),
    [anon_sym_precise] = ACTIONS(2672),
    [anon_sym_shared] = ACTIONS(2672),
    [anon_sym_groupshared] = ACTIONS(2672),
    [anon_sym_uniform] = ACTIONS(2672),
    [anon_sym_row_major] = ACTIONS(2672),
    [anon_sym_column_major] = ACTIONS(2672),
    [anon_sym_globallycoherent] = ACTIONS(2672),
    [anon_sym_centroid] = ACTIONS(2672),
    [anon_sym_noperspective] = ACTIONS(2672),
    [anon_sym_nointerpolation] = ACTIONS(2672),
    [anon_sym_sample] = ACTIONS(2672),
    [anon_sym_linear] = ACTIONS(2672),
    [anon_sym_snorm] = ACTIONS(2672),
    [anon_sym_unorm] = ACTIONS(2672),
    [anon_sym_point] = ACTIONS(2672),
    [anon_sym_line] = ACTIONS(2672),
    [anon_sym_triangleadj] = ACTIONS(2672),
    [anon_sym_lineadj] = ACTIONS(2672),
    [anon_sym_triangle] = ACTIONS(2672),
    [anon_sym_cbuffer] = ACTIONS(2672),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(2400),
    [sym_identifier] = ACTIONS(2398),
    [aux_sym_preproc_include_token1] = ACTIONS(2398),
    [aux_sym_preproc_def_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2398),
    [sym_preproc_directive] = ACTIONS(2398),
    [anon_sym_LPAREN2] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2398),
    [anon_sym_typedef] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_out] = ACTIONS(2398),
    [anon_sym_inout] = ACTIONS(2398),
    [anon_sym_virtual] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym___attribute__] = ACTIONS(2398),
    [anon_sym___attribute] = ACTIONS(2398),
    [anon_sym_using] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2400),
    [anon_sym___declspec] = ACTIONS(2398),
    [anon_sym___based] = ACTIONS(2398),
    [anon_sym___cdecl] = ACTIONS(2398),
    [anon_sym___clrcall] = ACTIONS(2398),
    [anon_sym___stdcall] = ACTIONS(2398),
    [anon_sym___fastcall] = ACTIONS(2398),
    [anon_sym___thiscall] = ACTIONS(2398),
    [anon_sym___vectorcall] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_signed] = ACTIONS(2398),
    [anon_sym_unsigned] = ACTIONS(2398),
    [anon_sym_long] = ACTIONS(2398),
    [anon_sym_short] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_register] = ACTIONS(2398),
    [anon_sym_inline] = ACTIONS(2398),
    [anon_sym___inline] = ACTIONS(2398),
    [anon_sym___inline__] = ACTIONS(2398),
    [anon_sym___forceinline] = ACTIONS(2398),
    [anon_sym_thread_local] = ACTIONS(2398),
    [anon_sym___thread] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_constexpr] = ACTIONS(2398),
    [anon_sym_volatile] = ACTIONS(2398),
    [anon_sym_restrict] = ACTIONS(2398),
    [anon_sym___restrict__] = ACTIONS(2398),
    [anon_sym__Atomic] = ACTIONS(2398),
    [anon_sym__Noreturn] = ACTIONS(2398),
    [anon_sym_noreturn] = ACTIONS(2398),
    [anon_sym__Nonnull] = ACTIONS(2398),
    [anon_sym_mutable] = ACTIONS(2398),
    [anon_sym_constinit] = ACTIONS(2398),
    [anon_sym_consteval] = ACTIONS(2398),
    [anon_sym_alignas] = ACTIONS(2398),
    [anon_sym__Alignas] = ACTIONS(2398),
    [sym_primitive_type] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_goto] = ACTIONS(2398),
    [anon_sym___try] = ACTIONS(2398),
    [anon_sym___leave] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2398),
    [anon_sym_compl] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_sizeof] = ACTIONS(2398),
    [anon_sym___alignof__] = ACTIONS(2398),
    [anon_sym___alignof] = ACTIONS(2398),
    [anon_sym__alignof] = ACTIONS(2398),
    [anon_sym_alignof] = ACTIONS(2398),
    [anon_sym__Alignof] = ACTIONS(2398),
    [anon_sym_offsetof] = ACTIONS(2398),
    [anon_sym__Generic] = ACTIONS(2398),
    [anon_sym_asm] = ACTIONS(2398),
    [anon_sym___asm__] = ACTIONS(2398),
    [anon_sym___asm] = ACTIONS(2398),
    [sym_number_literal] = ACTIONS(2400),
    [anon_sym_L_SQUOTE] = ACTIONS(2400),
    [anon_sym_u_SQUOTE] = ACTIONS(2400),
    [anon_sym_U_SQUOTE] = ACTIONS(2400),
    [anon_sym_u8_SQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_L_DQUOTE] = ACTIONS(2400),
    [anon_sym_u_DQUOTE] = ACTIONS(2400),
    [anon_sym_U_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [anon_sym_NULL] = ACTIONS(2398),
    [anon_sym_nullptr] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2398),
    [anon_sym_decltype] = ACTIONS(2398),
    [anon_sym_explicit] = ACTIONS(2398),
    [anon_sym_typename] = ACTIONS(2398),
    [anon_sym_export] = ACTIONS(2398),
    [anon_sym_module] = ACTIONS(2398),
    [anon_sym_import] = ACTIONS(2398),
    [anon_sym_template] = ACTIONS(2398),
    [anon_sym_operator] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_static_assert] = ACTIONS(2398),
    [anon_sym_concept] = ACTIONS(2398),
    [anon_sym_co_return] = ACTIONS(2398),
    [anon_sym_co_yield] = ACTIONS(2398),
    [anon_sym_R_DQUOTE] = ACTIONS(2400),
    [anon_sym_LR_DQUOTE] = ACTIONS(2400),
    [anon_sym_uR_DQUOTE] = ACTIONS(2400),
    [anon_sym_UR_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2400),
    [anon_sym_co_await] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_requires] = ACTIONS(2398),
    [sym_this] = ACTIONS(2398),
    [anon_sym_discard] = ACTIONS(2398),
    [anon_sym_precise] = ACTIONS(2398),
    [anon_sym_shared] = ACTIONS(2398),
    [anon_sym_groupshared] = ACTIONS(2398),
    [anon_sym_uniform] = ACTIONS(2398),
    [anon_sym_row_major] = ACTIONS(2398),
    [anon_sym_column_major] = ACTIONS(2398),
    [anon_sym_globallycoherent] = ACTIONS(2398),
    [anon_sym_centroid] = ACTIONS(2398),
    [anon_sym_noperspective] = ACTIONS(2398),
    [anon_sym_nointerpolation] = ACTIONS(2398),
    [anon_sym_sample] = ACTIONS(2398),
    [anon_sym_linear] = ACTIONS(2398),
    [anon_sym_snorm] = ACTIONS(2398),
    [anon_sym_unorm] = ACTIONS(2398),
    [anon_sym_point] = ACTIONS(2398),
    [anon_sym_line] = ACTIONS(2398),
    [anon_sym_triangleadj] = ACTIONS(2398),
    [anon_sym_lineadj] = ACTIONS(2398),
    [anon_sym_triangle] = ACTIONS(2398),
    [anon_sym_cbuffer] = ACTIONS(2398),
  },
  [412] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [aux_sym_preproc_else_token1] = ACTIONS(2676),
    [aux_sym_preproc_elif_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(2356),
    [sym_identifier] = ACTIONS(2354),
    [aux_sym_preproc_include_token1] = ACTIONS(2354),
    [aux_sym_preproc_def_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2354),
    [sym_preproc_directive] = ACTIONS(2354),
    [anon_sym_LPAREN2] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_AMP_AMP] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2354),
    [anon_sym_typedef] = ACTIONS(2354),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_out] = ACTIONS(2354),
    [anon_sym_inout] = ACTIONS(2354),
    [anon_sym_virtual] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym___attribute__] = ACTIONS(2354),
    [anon_sym___attribute] = ACTIONS(2354),
    [anon_sym_using] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2356),
    [anon_sym___declspec] = ACTIONS(2354),
    [anon_sym___based] = ACTIONS(2354),
    [anon_sym___cdecl] = ACTIONS(2354),
    [anon_sym___clrcall] = ACTIONS(2354),
    [anon_sym___stdcall] = ACTIONS(2354),
    [anon_sym___fastcall] = ACTIONS(2354),
    [anon_sym___thiscall] = ACTIONS(2354),
    [anon_sym___vectorcall] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_register] = ACTIONS(2354),
    [anon_sym_inline] = ACTIONS(2354),
    [anon_sym___inline] = ACTIONS(2354),
    [anon_sym___inline__] = ACTIONS(2354),
    [anon_sym___forceinline] = ACTIONS(2354),
    [anon_sym_thread_local] = ACTIONS(2354),
    [anon_sym___thread] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_constexpr] = ACTIONS(2354),
    [anon_sym_volatile] = ACTIONS(2354),
    [anon_sym_restrict] = ACTIONS(2354),
    [anon_sym___restrict__] = ACTIONS(2354),
    [anon_sym__Atomic] = ACTIONS(2354),
    [anon_sym__Noreturn] = ACTIONS(2354),
    [anon_sym_noreturn] = ACTIONS(2354),
    [anon_sym__Nonnull] = ACTIONS(2354),
    [anon_sym_mutable] = ACTIONS(2354),
    [anon_sym_constinit] = ACTIONS(2354),
    [anon_sym_consteval] = ACTIONS(2354),
    [anon_sym_alignas] = ACTIONS(2354),
    [anon_sym__Alignas] = ACTIONS(2354),
    [sym_primitive_type] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_goto] = ACTIONS(2354),
    [anon_sym___try] = ACTIONS(2354),
    [anon_sym___leave] = ACTIONS(2354),
    [anon_sym_not] = ACTIONS(2354),
    [anon_sym_compl] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2354),
    [anon_sym___alignof__] = ACTIONS(2354),
    [anon_sym___alignof] = ACTIONS(2354),
    [anon_sym__alignof] = ACTIONS(2354),
    [anon_sym_alignof] = ACTIONS(2354),
    [anon_sym__Alignof] = ACTIONS(2354),
    [anon_sym_offsetof] = ACTIONS(2354),
    [anon_sym__Generic] = ACTIONS(2354),
    [anon_sym_asm] = ACTIONS(2354),
    [anon_sym___asm__] = ACTIONS(2354),
    [anon_sym___asm] = ACTIONS(2354),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_L_SQUOTE] = ACTIONS(2356),
    [anon_sym_u_SQUOTE] = ACTIONS(2356),
    [anon_sym_U_SQUOTE] = ACTIONS(2356),
    [anon_sym_u8_SQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_L_DQUOTE] = ACTIONS(2356),
    [anon_sym_u_DQUOTE] = ACTIONS(2356),
    [anon_sym_U_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8_DQUOTE] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [anon_sym_NULL] = ACTIONS(2354),
    [anon_sym_nullptr] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2354),
    [anon_sym_decltype] = ACTIONS(2354),
    [anon_sym_explicit] = ACTIONS(2354),
    [anon_sym_typename] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_template] = ACTIONS(2354),
    [anon_sym_operator] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_static_assert] = ACTIONS(2354),
    [anon_sym_concept] = ACTIONS(2354),
    [anon_sym_co_return] = ACTIONS(2354),
    [anon_sym_co_yield] = ACTIONS(2354),
    [anon_sym_R_DQUOTE] = ACTIONS(2356),
    [anon_sym_LR_DQUOTE] = ACTIONS(2356),
    [anon_sym_uR_DQUOTE] = ACTIONS(2356),
    [anon_sym_UR_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2356),
    [anon_sym_co_await] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_requires] = ACTIONS(2354),
    [sym_this] = ACTIONS(2354),
    [anon_sym_discard] = ACTIONS(2354),
    [anon_sym_precise] = ACTIONS(2354),
    [anon_sym_shared] = ACTIONS(2354),
    [anon_sym_groupshared] = ACTIONS(2354),
    [anon_sym_uniform] = ACTIONS(2354),
    [anon_sym_row_major] = ACTIONS(2354),
    [anon_sym_column_major] = ACTIONS(2354),
    [anon_sym_globallycoherent] = ACTIONS(2354),
    [anon_sym_centroid] = ACTIONS(2354),
    [anon_sym_noperspective] = ACTIONS(2354),
    [anon_sym_nointerpolation] = ACTIONS(2354),
    [anon_sym_sample] = ACTIONS(2354),
    [anon_sym_linear] = ACTIONS(2354),
    [anon_sym_snorm] = ACTIONS(2354),
    [anon_sym_unorm] = ACTIONS(2354),
    [anon_sym_point] = ACTIONS(2354),
    [anon_sym_line] = ACTIONS(2354),
    [anon_sym_triangleadj] = ACTIONS(2354),
    [anon_sym_lineadj] = ACTIONS(2354),
    [anon_sym_triangle] = ACTIONS(2354),
    [anon_sym_cbuffer] = ACTIONS(2354),
  },
  [414] = {
    [sym_identifier] = ACTIONS(2680),
    [aux_sym_preproc_include_token1] = ACTIONS(2680),
    [aux_sym_preproc_def_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token2] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2680),
    [aux_sym_preproc_else_token1] = ACTIONS(2680),
    [aux_sym_preproc_elif_token1] = ACTIONS(2680),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2680),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2680),
    [sym_preproc_directive] = ACTIONS(2680),
    [anon_sym_LPAREN2] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym___extension__] = ACTIONS(2680),
    [anon_sym_typedef] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2680),
    [anon_sym_out] = ACTIONS(2680),
    [anon_sym_inout] = ACTIONS(2680),
    [anon_sym_virtual] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(2680),
    [anon_sym___attribute__] = ACTIONS(2680),
    [anon_sym___attribute] = ACTIONS(2680),
    [anon_sym_using] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2682),
    [anon_sym___declspec] = ACTIONS(2680),
    [anon_sym___based] = ACTIONS(2680),
    [anon_sym___cdecl] = ACTIONS(2680),
    [anon_sym___clrcall] = ACTIONS(2680),
    [anon_sym___stdcall] = ACTIONS(2680),
    [anon_sym___fastcall] = ACTIONS(2680),
    [anon_sym___thiscall] = ACTIONS(2680),
    [anon_sym___vectorcall] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_signed] = ACTIONS(2680),
    [anon_sym_unsigned] = ACTIONS(2680),
    [anon_sym_long] = ACTIONS(2680),
    [anon_sym_short] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_register] = ACTIONS(2680),
    [anon_sym_inline] = ACTIONS(2680),
    [anon_sym___inline] = ACTIONS(2680),
    [anon_sym___inline__] = ACTIONS(2680),
    [anon_sym___forceinline] = ACTIONS(2680),
    [anon_sym_thread_local] = ACTIONS(2680),
    [anon_sym___thread] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_constexpr] = ACTIONS(2680),
    [anon_sym_volatile] = ACTIONS(2680),
    [anon_sym_restrict] = ACTIONS(2680),
    [anon_sym___restrict__] = ACTIONS(2680),
    [anon_sym__Atomic] = ACTIONS(2680),
    [anon_sym__Noreturn] = ACTIONS(2680),
    [anon_sym_noreturn] = ACTIONS(2680),
    [anon_sym__Nonnull] = ACTIONS(2680),
    [anon_sym_mutable] = ACTIONS(2680),
    [anon_sym_constinit] = ACTIONS(2680),
    [anon_sym_consteval] = ACTIONS(2680),
    [anon_sym_alignas] = ACTIONS(2680),
    [anon_sym__Alignas] = ACTIONS(2680),
    [sym_primitive_type] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [anon_sym_class] = ACTIONS(2680),
    [anon_sym_struct] = ACTIONS(2680),
    [anon_sym_union] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_switch] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_do] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_goto] = ACTIONS(2680),
    [anon_sym___try] = ACTIONS(2680),
    [anon_sym___leave] = ACTIONS(2680),
    [anon_sym_not] = ACTIONS(2680),
    [anon_sym_compl] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_sizeof] = ACTIONS(2680),
    [anon_sym___alignof__] = ACTIONS(2680),
    [anon_sym___alignof] = ACTIONS(2680),
    [anon_sym__alignof] = ACTIONS(2680),
    [anon_sym_alignof] = ACTIONS(2680),
    [anon_sym__Alignof] = ACTIONS(2680),
    [anon_sym_offsetof] = ACTIONS(2680),
    [anon_sym__Generic] = ACTIONS(2680),
    [anon_sym_asm] = ACTIONS(2680),
    [anon_sym___asm__] = ACTIONS(2680),
    [anon_sym___asm] = ACTIONS(2680),
    [sym_number_literal] = ACTIONS(2682),
    [anon_sym_L_SQUOTE] = ACTIONS(2682),
    [anon_sym_u_SQUOTE] = ACTIONS(2682),
    [anon_sym_U_SQUOTE] = ACTIONS(2682),
    [anon_sym_u8_SQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_L_DQUOTE] = ACTIONS(2682),
    [anon_sym_u_DQUOTE] = ACTIONS(2682),
    [anon_sym_U_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8_DQUOTE] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [anon_sym_NULL] = ACTIONS(2680),
    [anon_sym_nullptr] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2680),
    [anon_sym_decltype] = ACTIONS(2680),
    [anon_sym_explicit] = ACTIONS(2680),
    [anon_sym_typename] = ACTIONS(2680),
    [anon_sym_template] = ACTIONS(2680),
    [anon_sym_operator] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [anon_sym_delete] = ACTIONS(2680),
    [anon_sym_throw] = ACTIONS(2680),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_static_assert] = ACTIONS(2680),
    [anon_sym_concept] = ACTIONS(2680),
    [anon_sym_co_return] = ACTIONS(2680),
    [anon_sym_co_yield] = ACTIONS(2680),
    [anon_sym_R_DQUOTE] = ACTIONS(2682),
    [anon_sym_LR_DQUOTE] = ACTIONS(2682),
    [anon_sym_uR_DQUOTE] = ACTIONS(2682),
    [anon_sym_UR_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2682),
    [anon_sym_co_await] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2680),
    [anon_sym_requires] = ACTIONS(2680),
    [sym_this] = ACTIONS(2680),
    [anon_sym_discard] = ACTIONS(2680),
    [anon_sym_precise] = ACTIONS(2680),
    [anon_sym_shared] = ACTIONS(2680),
    [anon_sym_groupshared] = ACTIONS(2680),
    [anon_sym_uniform] = ACTIONS(2680),
    [anon_sym_row_major] = ACTIONS(2680),
    [anon_sym_column_major] = ACTIONS(2680),
    [anon_sym_globallycoherent] = ACTIONS(2680),
    [anon_sym_centroid] = ACTIONS(2680),
    [anon_sym_noperspective] = ACTIONS(2680),
    [anon_sym_nointerpolation] = ACTIONS(2680),
    [anon_sym_sample] = ACTIONS(2680),
    [anon_sym_linear] = ACTIONS(2680),
    [anon_sym_snorm] = ACTIONS(2680),
    [anon_sym_unorm] = ACTIONS(2680),
    [anon_sym_point] = ACTIONS(2680),
    [anon_sym_line] = ACTIONS(2680),
    [anon_sym_triangleadj] = ACTIONS(2680),
    [anon_sym_lineadj] = ACTIONS(2680),
    [anon_sym_triangle] = ACTIONS(2680),
    [anon_sym_cbuffer] = ACTIONS(2680),
  },
  [415] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_include_token1] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token2] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [aux_sym_preproc_else_token1] = ACTIONS(2684),
    [aux_sym_preproc_elif_token1] = ACTIONS(2684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym___cdecl] = ACTIONS(2684),
    [anon_sym___clrcall] = ACTIONS(2684),
    [anon_sym___stdcall] = ACTIONS(2684),
    [anon_sym___fastcall] = ACTIONS(2684),
    [anon_sym___thiscall] = ACTIONS(2684),
    [anon_sym___vectorcall] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_goto] = ACTIONS(2684),
    [anon_sym___try] = ACTIONS(2684),
    [anon_sym___leave] = ACTIONS(2684),
    [anon_sym_not] = ACTIONS(2684),
    [anon_sym_compl] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_sizeof] = ACTIONS(2684),
    [anon_sym___alignof__] = ACTIONS(2684),
    [anon_sym___alignof] = ACTIONS(2684),
    [anon_sym__alignof] = ACTIONS(2684),
    [anon_sym_alignof] = ACTIONS(2684),
    [anon_sym__Alignof] = ACTIONS(2684),
    [anon_sym_offsetof] = ACTIONS(2684),
    [anon_sym__Generic] = ACTIONS(2684),
    [anon_sym_asm] = ACTIONS(2684),
    [anon_sym___asm__] = ACTIONS(2684),
    [anon_sym___asm] = ACTIONS(2684),
    [sym_number_literal] = ACTIONS(2686),
    [anon_sym_L_SQUOTE] = ACTIONS(2686),
    [anon_sym_u_SQUOTE] = ACTIONS(2686),
    [anon_sym_U_SQUOTE] = ACTIONS(2686),
    [anon_sym_u8_SQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_L_DQUOTE] = ACTIONS(2686),
    [anon_sym_u_DQUOTE] = ACTIONS(2686),
    [anon_sym_U_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8_DQUOTE] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [anon_sym_NULL] = ACTIONS(2684),
    [anon_sym_nullptr] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_concept] = ACTIONS(2684),
    [anon_sym_co_return] = ACTIONS(2684),
    [anon_sym_co_yield] = ACTIONS(2684),
    [anon_sym_R_DQUOTE] = ACTIONS(2686),
    [anon_sym_LR_DQUOTE] = ACTIONS(2686),
    [anon_sym_uR_DQUOTE] = ACTIONS(2686),
    [anon_sym_UR_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2686),
    [anon_sym_co_await] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_requires] = ACTIONS(2684),
    [sym_this] = ACTIONS(2684),
    [anon_sym_discard] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
    [anon_sym_cbuffer] = ACTIONS(2684),
  },
  [416] = {
    [sym_identifier] = ACTIONS(2688),
    [aux_sym_preproc_include_token1] = ACTIONS(2688),
    [aux_sym_preproc_def_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token2] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2688),
    [aux_sym_preproc_else_token1] = ACTIONS(2688),
    [aux_sym_preproc_elif_token1] = ACTIONS(2688),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2688),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2688),
    [sym_preproc_directive] = ACTIONS(2688),
    [anon_sym_LPAREN2] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym___extension__] = ACTIONS(2688),
    [anon_sym_typedef] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2688),
    [anon_sym_out] = ACTIONS(2688),
    [anon_sym_inout] = ACTIONS(2688),
    [anon_sym_virtual] = ACTIONS(2688),
    [anon_sym_extern] = ACTIONS(2688),
    [anon_sym___attribute__] = ACTIONS(2688),
    [anon_sym___attribute] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2690),
    [anon_sym___declspec] = ACTIONS(2688),
    [anon_sym___based] = ACTIONS(2688),
    [anon_sym___cdecl] = ACTIONS(2688),
    [anon_sym___clrcall] = ACTIONS(2688),
    [anon_sym___stdcall] = ACTIONS(2688),
    [anon_sym___fastcall] = ACTIONS(2688),
    [anon_sym___thiscall] = ACTIONS(2688),
    [anon_sym___vectorcall] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_signed] = ACTIONS(2688),
    [anon_sym_unsigned] = ACTIONS(2688),
    [anon_sym_long] = ACTIONS(2688),
    [anon_sym_short] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_register] = ACTIONS(2688),
    [anon_sym_inline] = ACTIONS(2688),
    [anon_sym___inline] = ACTIONS(2688),
    [anon_sym___inline__] = ACTIONS(2688),
    [anon_sym___forceinline] = ACTIONS(2688),
    [anon_sym_thread_local] = ACTIONS(2688),
    [anon_sym___thread] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_constexpr] = ACTIONS(2688),
    [anon_sym_volatile] = ACTIONS(2688),
    [anon_sym_restrict] = ACTIONS(2688),
    [anon_sym___restrict__] = ACTIONS(2688),
    [anon_sym__Atomic] = ACTIONS(2688),
    [anon_sym__Noreturn] = ACTIONS(2688),
    [anon_sym_noreturn] = ACTIONS(2688),
    [anon_sym__Nonnull] = ACTIONS(2688),
    [anon_sym_mutable] = ACTIONS(2688),
    [anon_sym_constinit] = ACTIONS(2688),
    [anon_sym_consteval] = ACTIONS(2688),
    [anon_sym_alignas] = ACTIONS(2688),
    [anon_sym__Alignas] = ACTIONS(2688),
    [sym_primitive_type] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_struct] = ACTIONS(2688),
    [anon_sym_union] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_goto] = ACTIONS(2688),
    [anon_sym___try] = ACTIONS(2688),
    [anon_sym___leave] = ACTIONS(2688),
    [anon_sym_not] = ACTIONS(2688),
    [anon_sym_compl] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_sizeof] = ACTIONS(2688),
    [anon_sym___alignof__] = ACTIONS(2688),
    [anon_sym___alignof] = ACTIONS(2688),
    [anon_sym__alignof] = ACTIONS(2688),
    [anon_sym_alignof] = ACTIONS(2688),
    [anon_sym__Alignof] = ACTIONS(2688),
    [anon_sym_offsetof] = ACTIONS(2688),
    [anon_sym__Generic] = ACTIONS(2688),
    [anon_sym_asm] = ACTIONS(2688),
    [anon_sym___asm__] = ACTIONS(2688),
    [anon_sym___asm] = ACTIONS(2688),
    [sym_number_literal] = ACTIONS(2690),
    [anon_sym_L_SQUOTE] = ACTIONS(2690),
    [anon_sym_u_SQUOTE] = ACTIONS(2690),
    [anon_sym_U_SQUOTE] = ACTIONS(2690),
    [anon_sym_u8_SQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_L_DQUOTE] = ACTIONS(2690),
    [anon_sym_u_DQUOTE] = ACTIONS(2690),
    [anon_sym_U_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [anon_sym_NULL] = ACTIONS(2688),
    [anon_sym_nullptr] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2688),
    [anon_sym_decltype] = ACTIONS(2688),
    [anon_sym_explicit] = ACTIONS(2688),
    [anon_sym_typename] = ACTIONS(2688),
    [anon_sym_template] = ACTIONS(2688),
    [anon_sym_operator] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_static_assert] = ACTIONS(2688),
    [anon_sym_concept] = ACTIONS(2688),
    [anon_sym_co_return] = ACTIONS(2688),
    [anon_sym_co_yield] = ACTIONS(2688),
    [anon_sym_R_DQUOTE] = ACTIONS(2690),
    [anon_sym_LR_DQUOTE] = ACTIONS(2690),
    [anon_sym_uR_DQUOTE] = ACTIONS(2690),
    [anon_sym_UR_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2690),
    [anon_sym_co_await] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_requires] = ACTIONS(2688),
    [sym_this] = ACTIONS(2688),
    [anon_sym_discard] = ACTIONS(2688),
    [anon_sym_precise] = ACTIONS(2688),
    [anon_sym_shared] = ACTIONS(2688),
    [anon_sym_groupshared] = ACTIONS(2688),
    [anon_sym_uniform] = ACTIONS(2688),
    [anon_sym_row_major] = ACTIONS(2688),
    [anon_sym_column_major] = ACTIONS(2688),
    [anon_sym_globallycoherent] = ACTIONS(2688),
    [anon_sym_centroid] = ACTIONS(2688),
    [anon_sym_noperspective] = ACTIONS(2688),
    [anon_sym_nointerpolation] = ACTIONS(2688),
    [anon_sym_sample] = ACTIONS(2688),
    [anon_sym_linear] = ACTIONS(2688),
    [anon_sym_snorm] = ACTIONS(2688),
    [anon_sym_unorm] = ACTIONS(2688),
    [anon_sym_point] = ACTIONS(2688),
    [anon_sym_line] = ACTIONS(2688),
    [anon_sym_triangleadj] = ACTIONS(2688),
    [anon_sym_lineadj] = ACTIONS(2688),
    [anon_sym_triangle] = ACTIONS(2688),
    [anon_sym_cbuffer] = ACTIONS(2688),
  },
  [417] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [aux_sym_preproc_else_token1] = ACTIONS(2676),
    [aux_sym_preproc_elif_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [418] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_include_token1] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token2] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [aux_sym_preproc_else_token1] = ACTIONS(2692),
    [aux_sym_preproc_elif_token1] = ACTIONS(2692),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym___cdecl] = ACTIONS(2692),
    [anon_sym___clrcall] = ACTIONS(2692),
    [anon_sym___stdcall] = ACTIONS(2692),
    [anon_sym___fastcall] = ACTIONS(2692),
    [anon_sym___thiscall] = ACTIONS(2692),
    [anon_sym___vectorcall] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_goto] = ACTIONS(2692),
    [anon_sym___try] = ACTIONS(2692),
    [anon_sym___leave] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_compl] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_sizeof] = ACTIONS(2692),
    [anon_sym___alignof__] = ACTIONS(2692),
    [anon_sym___alignof] = ACTIONS(2692),
    [anon_sym__alignof] = ACTIONS(2692),
    [anon_sym_alignof] = ACTIONS(2692),
    [anon_sym__Alignof] = ACTIONS(2692),
    [anon_sym_offsetof] = ACTIONS(2692),
    [anon_sym__Generic] = ACTIONS(2692),
    [anon_sym_asm] = ACTIONS(2692),
    [anon_sym___asm__] = ACTIONS(2692),
    [anon_sym___asm] = ACTIONS(2692),
    [sym_number_literal] = ACTIONS(2694),
    [anon_sym_L_SQUOTE] = ACTIONS(2694),
    [anon_sym_u_SQUOTE] = ACTIONS(2694),
    [anon_sym_U_SQUOTE] = ACTIONS(2694),
    [anon_sym_u8_SQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [anon_sym_L_DQUOTE] = ACTIONS(2694),
    [anon_sym_u_DQUOTE] = ACTIONS(2694),
    [anon_sym_U_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8_DQUOTE] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [anon_sym_NULL] = ACTIONS(2692),
    [anon_sym_nullptr] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_concept] = ACTIONS(2692),
    [anon_sym_co_return] = ACTIONS(2692),
    [anon_sym_co_yield] = ACTIONS(2692),
    [anon_sym_R_DQUOTE] = ACTIONS(2694),
    [anon_sym_LR_DQUOTE] = ACTIONS(2694),
    [anon_sym_uR_DQUOTE] = ACTIONS(2694),
    [anon_sym_UR_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2694),
    [anon_sym_co_await] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_requires] = ACTIONS(2692),
    [sym_this] = ACTIONS(2692),
    [anon_sym_discard] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
    [anon_sym_cbuffer] = ACTIONS(2692),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(2260),
    [sym_identifier] = ACTIONS(2258),
    [aux_sym_preproc_include_token1] = ACTIONS(2258),
    [aux_sym_preproc_def_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2258),
    [sym_preproc_directive] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym_typedef] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2258),
    [anon_sym_out] = ACTIONS(2258),
    [anon_sym_inout] = ACTIONS(2258),
    [anon_sym_virtual] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym___attribute] = ACTIONS(2258),
    [anon_sym_using] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2260),
    [anon_sym___declspec] = ACTIONS(2258),
    [anon_sym___based] = ACTIONS(2258),
    [anon_sym___cdecl] = ACTIONS(2258),
    [anon_sym___clrcall] = ACTIONS(2258),
    [anon_sym___stdcall] = ACTIONS(2258),
    [anon_sym___fastcall] = ACTIONS(2258),
    [anon_sym___thiscall] = ACTIONS(2258),
    [anon_sym___vectorcall] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2258),
    [anon_sym_unsigned] = ACTIONS(2258),
    [anon_sym_long] = ACTIONS(2258),
    [anon_sym_short] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2258),
    [anon_sym_inline] = ACTIONS(2258),
    [anon_sym___inline] = ACTIONS(2258),
    [anon_sym___inline__] = ACTIONS(2258),
    [anon_sym___forceinline] = ACTIONS(2258),
    [anon_sym_thread_local] = ACTIONS(2258),
    [anon_sym___thread] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym__Nonnull] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [sym_primitive_type] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_class] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2258),
    [anon_sym_switch] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_do] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_goto] = ACTIONS(2258),
    [anon_sym___try] = ACTIONS(2258),
    [anon_sym___leave] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2258),
    [anon_sym_compl] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2258),
    [anon_sym___alignof__] = ACTIONS(2258),
    [anon_sym___alignof] = ACTIONS(2258),
    [anon_sym__alignof] = ACTIONS(2258),
    [anon_sym_alignof] = ACTIONS(2258),
    [anon_sym__Alignof] = ACTIONS(2258),
    [anon_sym_offsetof] = ACTIONS(2258),
    [anon_sym__Generic] = ACTIONS(2258),
    [anon_sym_asm] = ACTIONS(2258),
    [anon_sym___asm__] = ACTIONS(2258),
    [anon_sym___asm] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2260),
    [anon_sym_L_SQUOTE] = ACTIONS(2260),
    [anon_sym_u_SQUOTE] = ACTIONS(2260),
    [anon_sym_U_SQUOTE] = ACTIONS(2260),
    [anon_sym_u8_SQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_L_DQUOTE] = ACTIONS(2260),
    [anon_sym_u_DQUOTE] = ACTIONS(2260),
    [anon_sym_U_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8_DQUOTE] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2258),
    [anon_sym_decltype] = ACTIONS(2258),
    [anon_sym_explicit] = ACTIONS(2258),
    [anon_sym_typename] = ACTIONS(2258),
    [anon_sym_export] = ACTIONS(2258),
    [anon_sym_module] = ACTIONS(2258),
    [anon_sym_import] = ACTIONS(2258),
    [anon_sym_template] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [anon_sym_delete] = ACTIONS(2258),
    [anon_sym_throw] = ACTIONS(2258),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_static_assert] = ACTIONS(2258),
    [anon_sym_concept] = ACTIONS(2258),
    [anon_sym_co_return] = ACTIONS(2258),
    [anon_sym_co_yield] = ACTIONS(2258),
    [anon_sym_R_DQUOTE] = ACTIONS(2260),
    [anon_sym_LR_DQUOTE] = ACTIONS(2260),
    [anon_sym_uR_DQUOTE] = ACTIONS(2260),
    [anon_sym_UR_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2260),
    [anon_sym_co_await] = ACTIONS(2258),
    [anon_sym_new] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2258),
    [sym_this] = ACTIONS(2258),
    [anon_sym_discard] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2258),
    [anon_sym_shared] = ACTIONS(2258),
    [anon_sym_groupshared] = ACTIONS(2258),
    [anon_sym_uniform] = ACTIONS(2258),
    [anon_sym_row_major] = ACTIONS(2258),
    [anon_sym_column_major] = ACTIONS(2258),
    [anon_sym_globallycoherent] = ACTIONS(2258),
    [anon_sym_centroid] = ACTIONS(2258),
    [anon_sym_noperspective] = ACTIONS(2258),
    [anon_sym_nointerpolation] = ACTIONS(2258),
    [anon_sym_sample] = ACTIONS(2258),
    [anon_sym_linear] = ACTIONS(2258),
    [anon_sym_snorm] = ACTIONS(2258),
    [anon_sym_unorm] = ACTIONS(2258),
    [anon_sym_point] = ACTIONS(2258),
    [anon_sym_line] = ACTIONS(2258),
    [anon_sym_triangleadj] = ACTIONS(2258),
    [anon_sym_lineadj] = ACTIONS(2258),
    [anon_sym_triangle] = ACTIONS(2258),
    [anon_sym_cbuffer] = ACTIONS(2258),
  },
  [420] = {
    [sym_catch_clause] = STATE(280),
    [aux_sym_constructor_try_statement_repeat1] = STATE(280),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_include_token1] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token2] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym___cdecl] = ACTIONS(2126),
    [anon_sym___clrcall] = ACTIONS(2126),
    [anon_sym___stdcall] = ACTIONS(2126),
    [anon_sym___fastcall] = ACTIONS(2126),
    [anon_sym___thiscall] = ACTIONS(2126),
    [anon_sym___vectorcall] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_goto] = ACTIONS(2126),
    [anon_sym___try] = ACTIONS(2126),
    [anon_sym___leave] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2126),
    [anon_sym_compl] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_sizeof] = ACTIONS(2126),
    [anon_sym___alignof__] = ACTIONS(2126),
    [anon_sym___alignof] = ACTIONS(2126),
    [anon_sym__alignof] = ACTIONS(2126),
    [anon_sym_alignof] = ACTIONS(2126),
    [anon_sym__Alignof] = ACTIONS(2126),
    [anon_sym_offsetof] = ACTIONS(2126),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2126),
    [anon_sym___asm__] = ACTIONS(2126),
    [anon_sym___asm] = ACTIONS(2126),
    [sym_number_literal] = ACTIONS(2128),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2128),
    [anon_sym_u_DQUOTE] = ACTIONS(2128),
    [anon_sym_U_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8_DQUOTE] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [anon_sym_NULL] = ACTIONS(2126),
    [anon_sym_nullptr] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_concept] = ACTIONS(2126),
    [anon_sym_co_return] = ACTIONS(2126),
    [anon_sym_co_yield] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(2408),
    [anon_sym_R_DQUOTE] = ACTIONS(2128),
    [anon_sym_LR_DQUOTE] = ACTIONS(2128),
    [anon_sym_uR_DQUOTE] = ACTIONS(2128),
    [anon_sym_UR_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2128),
    [anon_sym_co_await] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_requires] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [anon_sym_discard] = ACTIONS(2126),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
    [anon_sym_cbuffer] = ACTIONS(2126),
  },
  [421] = {
    [sym_preproc_def] = STATE(423),
    [sym_preproc_function_def] = STATE(423),
    [sym_preproc_call] = STATE(423),
    [sym_preproc_if_in_field_declaration_list] = STATE(423),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(423),
    [sym_preproc_else_in_field_declaration_list] = STATE(8727),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8727),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8727),
    [sym_type_definition] = STATE(423),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(423),
    [sym_field_declaration] = STATE(423),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(423),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(423),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(423),
    [sym_operator_cast_declaration] = STATE(423),
    [sym_constructor_or_destructor_definition] = STATE(423),
    [sym_constructor_or_destructor_declaration] = STATE(423),
    [sym_friend_declaration] = STATE(423),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(423),
    [sym_alias_declaration] = STATE(423),
    [sym_static_assert_declaration] = STATE(423),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(423),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2702),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [422] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8741),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8741),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8741),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2756),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [423] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8840),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8840),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8840),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2760),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [424] = {
    [sym_preproc_def] = STATE(426),
    [sym_preproc_function_def] = STATE(426),
    [sym_preproc_call] = STATE(426),
    [sym_preproc_if_in_field_declaration_list] = STATE(426),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(426),
    [sym_preproc_else_in_field_declaration_list] = STATE(8939),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8939),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8939),
    [sym_type_definition] = STATE(426),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(426),
    [sym_field_declaration] = STATE(426),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(426),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(426),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(426),
    [sym_operator_cast_declaration] = STATE(426),
    [sym_constructor_or_destructor_definition] = STATE(426),
    [sym_constructor_or_destructor_declaration] = STATE(426),
    [sym_friend_declaration] = STATE(426),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(426),
    [sym_alias_declaration] = STATE(426),
    [sym_static_assert_declaration] = STATE(426),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(426),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2762),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2764),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [425] = {
    [sym_preproc_def] = STATE(427),
    [sym_preproc_function_def] = STATE(427),
    [sym_preproc_call] = STATE(427),
    [sym_preproc_if_in_field_declaration_list] = STATE(427),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(427),
    [sym_preproc_else_in_field_declaration_list] = STATE(9052),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9052),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9052),
    [sym_type_definition] = STATE(427),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(427),
    [sym_field_declaration] = STATE(427),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(427),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(427),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(427),
    [sym_operator_cast_declaration] = STATE(427),
    [sym_constructor_or_destructor_definition] = STATE(427),
    [sym_constructor_or_destructor_declaration] = STATE(427),
    [sym_friend_declaration] = STATE(427),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(427),
    [sym_alias_declaration] = STATE(427),
    [sym_static_assert_declaration] = STATE(427),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2766),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2768),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [426] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(9057),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9057),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9057),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2770),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [427] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(9103),
    [sym_preproc_elif_in_field_declaration_list] = STATE(9103),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(9103),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2772),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [428] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8372),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8372),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8372),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2774),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [429] = {
    [sym_preproc_def] = STATE(422),
    [sym_preproc_function_def] = STATE(422),
    [sym_preproc_call] = STATE(422),
    [sym_preproc_if_in_field_declaration_list] = STATE(422),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(422),
    [sym_preproc_else_in_field_declaration_list] = STATE(8409),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8409),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8409),
    [sym_type_definition] = STATE(422),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(422),
    [sym_field_declaration] = STATE(422),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(422),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(422),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(422),
    [sym_operator_cast_declaration] = STATE(422),
    [sym_constructor_or_destructor_definition] = STATE(422),
    [sym_constructor_or_destructor_declaration] = STATE(422),
    [sym_friend_declaration] = STATE(422),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(422),
    [sym_alias_declaration] = STATE(422),
    [sym_static_assert_declaration] = STATE(422),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(422),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2776),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [430] = {
    [sym_catch_clause] = STATE(280),
    [aux_sym_constructor_try_statement_repeat1] = STATE(280),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_include_token1] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token2] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym___cdecl] = ACTIONS(2122),
    [anon_sym___clrcall] = ACTIONS(2122),
    [anon_sym___stdcall] = ACTIONS(2122),
    [anon_sym___fastcall] = ACTIONS(2122),
    [anon_sym___thiscall] = ACTIONS(2122),
    [anon_sym___vectorcall] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_goto] = ACTIONS(2122),
    [anon_sym___try] = ACTIONS(2122),
    [anon_sym___leave] = ACTIONS(2122),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_compl] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_sizeof] = ACTIONS(2122),
    [anon_sym___alignof__] = ACTIONS(2122),
    [anon_sym___alignof] = ACTIONS(2122),
    [anon_sym__alignof] = ACTIONS(2122),
    [anon_sym_alignof] = ACTIONS(2122),
    [anon_sym__Alignof] = ACTIONS(2122),
    [anon_sym_offsetof] = ACTIONS(2122),
    [anon_sym__Generic] = ACTIONS(2122),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2124),
    [anon_sym_L_SQUOTE] = ACTIONS(2124),
    [anon_sym_u_SQUOTE] = ACTIONS(2124),
    [anon_sym_U_SQUOTE] = ACTIONS(2124),
    [anon_sym_u8_SQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_L_DQUOTE] = ACTIONS(2124),
    [anon_sym_u_DQUOTE] = ACTIONS(2124),
    [anon_sym_U_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8_DQUOTE] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [anon_sym_NULL] = ACTIONS(2122),
    [anon_sym_nullptr] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_concept] = ACTIONS(2122),
    [anon_sym_co_return] = ACTIONS(2122),
    [anon_sym_co_yield] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(2408),
    [anon_sym_R_DQUOTE] = ACTIONS(2124),
    [anon_sym_LR_DQUOTE] = ACTIONS(2124),
    [anon_sym_uR_DQUOTE] = ACTIONS(2124),
    [anon_sym_UR_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2124),
    [anon_sym_co_await] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_requires] = ACTIONS(2122),
    [sym_this] = ACTIONS(2122),
    [anon_sym_discard] = ACTIONS(2122),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
    [anon_sym_cbuffer] = ACTIONS(2122),
  },
  [431] = {
    [sym_preproc_def] = STATE(428),
    [sym_preproc_function_def] = STATE(428),
    [sym_preproc_call] = STATE(428),
    [sym_preproc_if_in_field_declaration_list] = STATE(428),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(428),
    [sym_preproc_else_in_field_declaration_list] = STATE(8769),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8769),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8769),
    [sym_type_definition] = STATE(428),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(428),
    [sym_field_declaration] = STATE(428),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(428),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(428),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(428),
    [sym_operator_cast_declaration] = STATE(428),
    [sym_constructor_or_destructor_definition] = STATE(428),
    [sym_constructor_or_destructor_declaration] = STATE(428),
    [sym_friend_declaration] = STATE(428),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(428),
    [sym_alias_declaration] = STATE(428),
    [sym_static_assert_declaration] = STATE(428),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2780),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2782),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [432] = {
    [sym_catch_clause] = STATE(327),
    [aux_sym_constructor_try_statement_repeat1] = STATE(327),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_include_token1] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym___cdecl] = ACTIONS(2122),
    [anon_sym___clrcall] = ACTIONS(2122),
    [anon_sym___stdcall] = ACTIONS(2122),
    [anon_sym___fastcall] = ACTIONS(2122),
    [anon_sym___thiscall] = ACTIONS(2122),
    [anon_sym___vectorcall] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_RBRACE] = ACTIONS(2124),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_goto] = ACTIONS(2122),
    [anon_sym___try] = ACTIONS(2122),
    [anon_sym___leave] = ACTIONS(2122),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_compl] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_sizeof] = ACTIONS(2122),
    [anon_sym___alignof__] = ACTIONS(2122),
    [anon_sym___alignof] = ACTIONS(2122),
    [anon_sym__alignof] = ACTIONS(2122),
    [anon_sym_alignof] = ACTIONS(2122),
    [anon_sym__Alignof] = ACTIONS(2122),
    [anon_sym_offsetof] = ACTIONS(2122),
    [anon_sym__Generic] = ACTIONS(2122),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2124),
    [anon_sym_L_SQUOTE] = ACTIONS(2124),
    [anon_sym_u_SQUOTE] = ACTIONS(2124),
    [anon_sym_U_SQUOTE] = ACTIONS(2124),
    [anon_sym_u8_SQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_L_DQUOTE] = ACTIONS(2124),
    [anon_sym_u_DQUOTE] = ACTIONS(2124),
    [anon_sym_U_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8_DQUOTE] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [anon_sym_NULL] = ACTIONS(2122),
    [anon_sym_nullptr] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_concept] = ACTIONS(2122),
    [anon_sym_co_return] = ACTIONS(2122),
    [anon_sym_co_yield] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2124),
    [anon_sym_LR_DQUOTE] = ACTIONS(2124),
    [anon_sym_uR_DQUOTE] = ACTIONS(2124),
    [anon_sym_UR_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2124),
    [anon_sym_co_await] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_requires] = ACTIONS(2122),
    [sym_this] = ACTIONS(2122),
    [anon_sym_discard] = ACTIONS(2122),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
    [anon_sym_cbuffer] = ACTIONS(2122),
  },
  [433] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8495),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8495),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8495),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2784),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [434] = {
    [sym_preproc_def] = STATE(436),
    [sym_preproc_function_def] = STATE(436),
    [sym_preproc_call] = STATE(436),
    [sym_preproc_if_in_field_declaration_list] = STATE(436),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(436),
    [sym_preproc_else_in_field_declaration_list] = STATE(8525),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8525),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8525),
    [sym_type_definition] = STATE(436),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(436),
    [sym_field_declaration] = STATE(436),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(436),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(436),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(436),
    [sym_operator_cast_declaration] = STATE(436),
    [sym_constructor_or_destructor_definition] = STATE(436),
    [sym_constructor_or_destructor_declaration] = STATE(436),
    [sym_friend_declaration] = STATE(436),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(436),
    [sym_alias_declaration] = STATE(436),
    [sym_static_assert_declaration] = STATE(436),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(436),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2786),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2788),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [435] = {
    [sym_preproc_def] = STATE(437),
    [sym_preproc_function_def] = STATE(437),
    [sym_preproc_call] = STATE(437),
    [sym_preproc_if_in_field_declaration_list] = STATE(437),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(437),
    [sym_preproc_else_in_field_declaration_list] = STATE(8847),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8847),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8847),
    [sym_type_definition] = STATE(437),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(437),
    [sym_field_declaration] = STATE(437),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(437),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(437),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(437),
    [sym_operator_cast_declaration] = STATE(437),
    [sym_constructor_or_destructor_definition] = STATE(437),
    [sym_constructor_or_destructor_declaration] = STATE(437),
    [sym_friend_declaration] = STATE(437),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(437),
    [sym_alias_declaration] = STATE(437),
    [sym_static_assert_declaration] = STATE(437),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(437),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2790),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [436] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8997),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8997),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8997),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2794),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [437] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_preproc_else_in_field_declaration_list] = STATE(8308),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8308),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8308),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2796),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [438] = {
    [sym_preproc_def] = STATE(433),
    [sym_preproc_function_def] = STATE(433),
    [sym_preproc_call] = STATE(433),
    [sym_preproc_if_in_field_declaration_list] = STATE(433),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(433),
    [sym_preproc_else_in_field_declaration_list] = STATE(8718),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8718),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8718),
    [sym_type_definition] = STATE(433),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(433),
    [sym_field_declaration] = STATE(433),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(433),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(433),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(433),
    [sym_operator_cast_declaration] = STATE(433),
    [sym_constructor_or_destructor_definition] = STATE(433),
    [sym_constructor_or_destructor_declaration] = STATE(433),
    [sym_friend_declaration] = STATE(433),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(433),
    [sym_alias_declaration] = STATE(433),
    [sym_static_assert_declaration] = STATE(433),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(433),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(2698),
    [aux_sym_preproc_if_token1] = ACTIONS(2700),
    [aux_sym_preproc_if_token2] = ACTIONS(2798),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2704),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2704),
    [aux_sym_preproc_else_token1] = ACTIONS(2706),
    [aux_sym_preproc_elif_token1] = ACTIONS(2708),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2710),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2710),
    [sym_preproc_directive] = ACTIONS(2712),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2800),
    [anon_sym___extension__] = ACTIONS(2724),
    [anon_sym_typedef] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(2754),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [439] = {
    [sym_catch_clause] = STATE(327),
    [aux_sym_constructor_try_statement_repeat1] = STATE(327),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_include_token1] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym___cdecl] = ACTIONS(2126),
    [anon_sym___clrcall] = ACTIONS(2126),
    [anon_sym___stdcall] = ACTIONS(2126),
    [anon_sym___fastcall] = ACTIONS(2126),
    [anon_sym___thiscall] = ACTIONS(2126),
    [anon_sym___vectorcall] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_RBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_goto] = ACTIONS(2126),
    [anon_sym___try] = ACTIONS(2126),
    [anon_sym___leave] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2126),
    [anon_sym_compl] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_sizeof] = ACTIONS(2126),
    [anon_sym___alignof__] = ACTIONS(2126),
    [anon_sym___alignof] = ACTIONS(2126),
    [anon_sym__alignof] = ACTIONS(2126),
    [anon_sym_alignof] = ACTIONS(2126),
    [anon_sym__Alignof] = ACTIONS(2126),
    [anon_sym_offsetof] = ACTIONS(2126),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2126),
    [anon_sym___asm__] = ACTIONS(2126),
    [anon_sym___asm] = ACTIONS(2126),
    [sym_number_literal] = ACTIONS(2128),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2128),
    [anon_sym_u_DQUOTE] = ACTIONS(2128),
    [anon_sym_U_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8_DQUOTE] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [anon_sym_NULL] = ACTIONS(2126),
    [anon_sym_nullptr] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_concept] = ACTIONS(2126),
    [anon_sym_co_return] = ACTIONS(2126),
    [anon_sym_co_yield] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(2457),
    [anon_sym_R_DQUOTE] = ACTIONS(2128),
    [anon_sym_LR_DQUOTE] = ACTIONS(2128),
    [anon_sym_uR_DQUOTE] = ACTIONS(2128),
    [anon_sym_UR_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2128),
    [anon_sym_co_await] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_requires] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [anon_sym_discard] = ACTIONS(2126),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
    [anon_sym_cbuffer] = ACTIONS(2126),
  },
  [440] = {
    [sym_else_clause] = STATE(544),
    [sym_identifier] = ACTIONS(2139),
    [aux_sym_preproc_include_token1] = ACTIONS(2139),
    [aux_sym_preproc_def_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2139),
    [sym_preproc_directive] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_typedef] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_out] = ACTIONS(2139),
    [anon_sym_inout] = ACTIONS(2139),
    [anon_sym_virtual] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym___attribute] = ACTIONS(2139),
    [anon_sym_using] = ACTIONS(2139),
    [anon_sym_COLON_COLON] = ACTIONS(2141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2141),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_signed] = ACTIONS(2139),
    [anon_sym_unsigned] = ACTIONS(2139),
    [anon_sym_long] = ACTIONS(2139),
    [anon_sym_short] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym__Nonnull] = ACTIONS(2139),
    [anon_sym_mutable] = ACTIONS(2139),
    [anon_sym_constinit] = ACTIONS(2139),
    [anon_sym_consteval] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [sym_primitive_type] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_struct] = ACTIONS(2139),
    [anon_sym_union] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2802),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_goto] = ACTIONS(2139),
    [anon_sym___try] = ACTIONS(2139),
    [anon_sym___leave] = ACTIONS(2139),
    [anon_sym_not] = ACTIONS(2139),
    [anon_sym_compl] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_sizeof] = ACTIONS(2139),
    [anon_sym___alignof__] = ACTIONS(2139),
    [anon_sym___alignof] = ACTIONS(2139),
    [anon_sym__alignof] = ACTIONS(2139),
    [anon_sym_alignof] = ACTIONS(2139),
    [anon_sym__Alignof] = ACTIONS(2139),
    [anon_sym_offsetof] = ACTIONS(2139),
    [anon_sym__Generic] = ACTIONS(2139),
    [anon_sym_asm] = ACTIONS(2139),
    [anon_sym___asm__] = ACTIONS(2139),
    [anon_sym___asm] = ACTIONS(2139),
    [sym_number_literal] = ACTIONS(2141),
    [anon_sym_L_SQUOTE] = ACTIONS(2141),
    [anon_sym_u_SQUOTE] = ACTIONS(2141),
    [anon_sym_U_SQUOTE] = ACTIONS(2141),
    [anon_sym_u8_SQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(2141),
    [anon_sym_u_DQUOTE] = ACTIONS(2141),
    [anon_sym_U_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8_DQUOTE] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [anon_sym_NULL] = ACTIONS(2139),
    [anon_sym_nullptr] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2139),
    [anon_sym_decltype] = ACTIONS(2139),
    [anon_sym_explicit] = ACTIONS(2139),
    [anon_sym_typename] = ACTIONS(2139),
    [anon_sym_template] = ACTIONS(2139),
    [anon_sym_operator] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_static_assert] = ACTIONS(2139),
    [anon_sym_concept] = ACTIONS(2139),
    [anon_sym_co_return] = ACTIONS(2139),
    [anon_sym_co_yield] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2139),
    [anon_sym_discard] = ACTIONS(2139),
    [anon_sym_precise] = ACTIONS(2139),
    [anon_sym_shared] = ACTIONS(2139),
    [anon_sym_groupshared] = ACTIONS(2139),
    [anon_sym_uniform] = ACTIONS(2139),
    [anon_sym_row_major] = ACTIONS(2139),
    [anon_sym_column_major] = ACTIONS(2139),
    [anon_sym_globallycoherent] = ACTIONS(2139),
    [anon_sym_centroid] = ACTIONS(2139),
    [anon_sym_noperspective] = ACTIONS(2139),
    [anon_sym_nointerpolation] = ACTIONS(2139),
    [anon_sym_sample] = ACTIONS(2139),
    [anon_sym_linear] = ACTIONS(2139),
    [anon_sym_snorm] = ACTIONS(2139),
    [anon_sym_unorm] = ACTIONS(2139),
    [anon_sym_point] = ACTIONS(2139),
    [anon_sym_line] = ACTIONS(2139),
    [anon_sym_triangleadj] = ACTIONS(2139),
    [anon_sym_lineadj] = ACTIONS(2139),
    [anon_sym_triangle] = ACTIONS(2139),
    [anon_sym_cbuffer] = ACTIONS(2139),
  },
  [441] = {
    [sym_else_clause] = STATE(521),
    [sym_identifier] = ACTIONS(2151),
    [aux_sym_preproc_include_token1] = ACTIONS(2151),
    [aux_sym_preproc_def_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token2] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2151),
    [sym_preproc_directive] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AMP_AMP] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_typedef] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_out] = ACTIONS(2151),
    [anon_sym_inout] = ACTIONS(2151),
    [anon_sym_virtual] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym___attribute] = ACTIONS(2151),
    [anon_sym_using] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym___based] = ACTIONS(2151),
    [anon_sym___cdecl] = ACTIONS(2151),
    [anon_sym___clrcall] = ACTIONS(2151),
    [anon_sym___stdcall] = ACTIONS(2151),
    [anon_sym___fastcall] = ACTIONS(2151),
    [anon_sym___thiscall] = ACTIONS(2151),
    [anon_sym___vectorcall] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [anon_sym__Nonnull] = ACTIONS(2151),
    [anon_sym_mutable] = ACTIONS(2151),
    [anon_sym_constinit] = ACTIONS(2151),
    [anon_sym_consteval] = ACTIONS(2151),
    [anon_sym_alignas] = ACTIONS(2151),
    [anon_sym__Alignas] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_goto] = ACTIONS(2151),
    [anon_sym___try] = ACTIONS(2151),
    [anon_sym___leave] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_compl] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_sizeof] = ACTIONS(2151),
    [anon_sym___alignof__] = ACTIONS(2151),
    [anon_sym___alignof] = ACTIONS(2151),
    [anon_sym__alignof] = ACTIONS(2151),
    [anon_sym_alignof] = ACTIONS(2151),
    [anon_sym__Alignof] = ACTIONS(2151),
    [anon_sym_offsetof] = ACTIONS(2151),
    [anon_sym__Generic] = ACTIONS(2151),
    [anon_sym_asm] = ACTIONS(2151),
    [anon_sym___asm__] = ACTIONS(2151),
    [anon_sym___asm] = ACTIONS(2151),
    [sym_number_literal] = ACTIONS(2153),
    [anon_sym_L_SQUOTE] = ACTIONS(2153),
    [anon_sym_u_SQUOTE] = ACTIONS(2153),
    [anon_sym_U_SQUOTE] = ACTIONS(2153),
    [anon_sym_u8_SQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [anon_sym_L_DQUOTE] = ACTIONS(2153),
    [anon_sym_u_DQUOTE] = ACTIONS(2153),
    [anon_sym_U_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8_DQUOTE] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [anon_sym_NULL] = ACTIONS(2151),
    [anon_sym_nullptr] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2151),
    [anon_sym_decltype] = ACTIONS(2151),
    [anon_sym_explicit] = ACTIONS(2151),
    [anon_sym_typename] = ACTIONS(2151),
    [anon_sym_template] = ACTIONS(2151),
    [anon_sym_operator] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_static_assert] = ACTIONS(2151),
    [anon_sym_concept] = ACTIONS(2151),
    [anon_sym_co_return] = ACTIONS(2151),
    [anon_sym_co_yield] = ACTIONS(2151),
    [anon_sym_R_DQUOTE] = ACTIONS(2153),
    [anon_sym_LR_DQUOTE] = ACTIONS(2153),
    [anon_sym_uR_DQUOTE] = ACTIONS(2153),
    [anon_sym_UR_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2153),
    [anon_sym_co_await] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_requires] = ACTIONS(2151),
    [sym_this] = ACTIONS(2151),
    [anon_sym_discard] = ACTIONS(2151),
    [anon_sym_precise] = ACTIONS(2151),
    [anon_sym_shared] = ACTIONS(2151),
    [anon_sym_groupshared] = ACTIONS(2151),
    [anon_sym_uniform] = ACTIONS(2151),
    [anon_sym_row_major] = ACTIONS(2151),
    [anon_sym_column_major] = ACTIONS(2151),
    [anon_sym_globallycoherent] = ACTIONS(2151),
    [anon_sym_centroid] = ACTIONS(2151),
    [anon_sym_noperspective] = ACTIONS(2151),
    [anon_sym_nointerpolation] = ACTIONS(2151),
    [anon_sym_sample] = ACTIONS(2151),
    [anon_sym_linear] = ACTIONS(2151),
    [anon_sym_snorm] = ACTIONS(2151),
    [anon_sym_unorm] = ACTIONS(2151),
    [anon_sym_point] = ACTIONS(2151),
    [anon_sym_line] = ACTIONS(2151),
    [anon_sym_triangleadj] = ACTIONS(2151),
    [anon_sym_lineadj] = ACTIONS(2151),
    [anon_sym_triangle] = ACTIONS(2151),
    [anon_sym_cbuffer] = ACTIONS(2151),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_include_token1] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym___cdecl] = ACTIONS(1947),
    [anon_sym___clrcall] = ACTIONS(1947),
    [anon_sym___stdcall] = ACTIONS(1947),
    [anon_sym___fastcall] = ACTIONS(1947),
    [anon_sym___thiscall] = ACTIONS(1947),
    [anon_sym___vectorcall] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_not] = ACTIONS(1947),
    [anon_sym_compl] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [anon_sym___asm] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1945),
    [anon_sym_L_SQUOTE] = ACTIONS(1945),
    [anon_sym_u_SQUOTE] = ACTIONS(1945),
    [anon_sym_U_SQUOTE] = ACTIONS(1945),
    [anon_sym_u8_SQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_concept] = ACTIONS(1947),
    [anon_sym_co_return] = ACTIONS(1947),
    [anon_sym_co_yield] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1945),
    [anon_sym_LR_DQUOTE] = ACTIONS(1945),
    [anon_sym_uR_DQUOTE] = ACTIONS(1945),
    [anon_sym_UR_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1945),
    [anon_sym_co_await] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_requires] = ACTIONS(1947),
    [sym_this] = ACTIONS(1947),
    [anon_sym_discard] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
    [anon_sym_cbuffer] = ACTIONS(1947),
  },
  [443] = {
    [sym_else_clause] = STATE(509),
    [sym_identifier] = ACTIONS(2139),
    [aux_sym_preproc_include_token1] = ACTIONS(2139),
    [aux_sym_preproc_def_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token1] = ACTIONS(2139),
    [aux_sym_preproc_if_token2] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2139),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2139),
    [sym_preproc_directive] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2139),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_typedef] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_out] = ACTIONS(2139),
    [anon_sym_inout] = ACTIONS(2139),
    [anon_sym_virtual] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym___attribute] = ACTIONS(2139),
    [anon_sym_using] = ACTIONS(2139),
    [anon_sym_COLON_COLON] = ACTIONS(2141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2141),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym___based] = ACTIONS(2139),
    [anon_sym___cdecl] = ACTIONS(2139),
    [anon_sym___clrcall] = ACTIONS(2139),
    [anon_sym___stdcall] = ACTIONS(2139),
    [anon_sym___fastcall] = ACTIONS(2139),
    [anon_sym___thiscall] = ACTIONS(2139),
    [anon_sym___vectorcall] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_signed] = ACTIONS(2139),
    [anon_sym_unsigned] = ACTIONS(2139),
    [anon_sym_long] = ACTIONS(2139),
    [anon_sym_short] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym__Nonnull] = ACTIONS(2139),
    [anon_sym_mutable] = ACTIONS(2139),
    [anon_sym_constinit] = ACTIONS(2139),
    [anon_sym_consteval] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [sym_primitive_type] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_struct] = ACTIONS(2139),
    [anon_sym_union] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_case] = ACTIONS(2139),
    [anon_sym_default] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_goto] = ACTIONS(2139),
    [anon_sym___try] = ACTIONS(2139),
    [anon_sym___leave] = ACTIONS(2139),
    [anon_sym_not] = ACTIONS(2139),
    [anon_sym_compl] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_sizeof] = ACTIONS(2139),
    [anon_sym___alignof__] = ACTIONS(2139),
    [anon_sym___alignof] = ACTIONS(2139),
    [anon_sym__alignof] = ACTIONS(2139),
    [anon_sym_alignof] = ACTIONS(2139),
    [anon_sym__Alignof] = ACTIONS(2139),
    [anon_sym_offsetof] = ACTIONS(2139),
    [anon_sym__Generic] = ACTIONS(2139),
    [anon_sym_asm] = ACTIONS(2139),
    [anon_sym___asm__] = ACTIONS(2139),
    [anon_sym___asm] = ACTIONS(2139),
    [sym_number_literal] = ACTIONS(2141),
    [anon_sym_L_SQUOTE] = ACTIONS(2141),
    [anon_sym_u_SQUOTE] = ACTIONS(2141),
    [anon_sym_U_SQUOTE] = ACTIONS(2141),
    [anon_sym_u8_SQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(2141),
    [anon_sym_u_DQUOTE] = ACTIONS(2141),
    [anon_sym_U_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8_DQUOTE] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [anon_sym_NULL] = ACTIONS(2139),
    [anon_sym_nullptr] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2139),
    [anon_sym_decltype] = ACTIONS(2139),
    [anon_sym_explicit] = ACTIONS(2139),
    [anon_sym_typename] = ACTIONS(2139),
    [anon_sym_template] = ACTIONS(2139),
    [anon_sym_operator] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_namespace] = ACTIONS(2139),
    [anon_sym_static_assert] = ACTIONS(2139),
    [anon_sym_concept] = ACTIONS(2139),
    [anon_sym_co_return] = ACTIONS(2139),
    [anon_sym_co_yield] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2139),
    [anon_sym_discard] = ACTIONS(2139),
    [anon_sym_precise] = ACTIONS(2139),
    [anon_sym_shared] = ACTIONS(2139),
    [anon_sym_groupshared] = ACTIONS(2139),
    [anon_sym_uniform] = ACTIONS(2139),
    [anon_sym_row_major] = ACTIONS(2139),
    [anon_sym_column_major] = ACTIONS(2139),
    [anon_sym_globallycoherent] = ACTIONS(2139),
    [anon_sym_centroid] = ACTIONS(2139),
    [anon_sym_noperspective] = ACTIONS(2139),
    [anon_sym_nointerpolation] = ACTIONS(2139),
    [anon_sym_sample] = ACTIONS(2139),
    [anon_sym_linear] = ACTIONS(2139),
    [anon_sym_snorm] = ACTIONS(2139),
    [anon_sym_unorm] = ACTIONS(2139),
    [anon_sym_point] = ACTIONS(2139),
    [anon_sym_line] = ACTIONS(2139),
    [anon_sym_triangleadj] = ACTIONS(2139),
    [anon_sym_lineadj] = ACTIONS(2139),
    [anon_sym_triangle] = ACTIONS(2139),
    [anon_sym_cbuffer] = ACTIONS(2139),
  },
  [444] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [445] = {
    [sym_expression] = STATE(4685),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8786),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2806),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2814),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2817),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2820),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2823),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
  },
  [446] = {
    [sym_catch_clause] = STATE(193),
    [aux_sym_constructor_try_statement_repeat1] = STATE(193),
    [ts_builtin_sym_end] = ACTIONS(2128),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_include_token1] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2126),
    [anon_sym_PLUS] = ACTIONS(2126),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym___cdecl] = ACTIONS(2126),
    [anon_sym___clrcall] = ACTIONS(2126),
    [anon_sym___stdcall] = ACTIONS(2126),
    [anon_sym___fastcall] = ACTIONS(2126),
    [anon_sym___thiscall] = ACTIONS(2126),
    [anon_sym___vectorcall] = ACTIONS(2126),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_switch] = ACTIONS(2126),
    [anon_sym_case] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_do] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_goto] = ACTIONS(2126),
    [anon_sym_not] = ACTIONS(2126),
    [anon_sym_compl] = ACTIONS(2126),
    [anon_sym_DASH_DASH] = ACTIONS(2128),
    [anon_sym_PLUS_PLUS] = ACTIONS(2128),
    [anon_sym_sizeof] = ACTIONS(2126),
    [anon_sym___alignof__] = ACTIONS(2126),
    [anon_sym___alignof] = ACTIONS(2126),
    [anon_sym__alignof] = ACTIONS(2126),
    [anon_sym_alignof] = ACTIONS(2126),
    [anon_sym__Alignof] = ACTIONS(2126),
    [anon_sym_offsetof] = ACTIONS(2126),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2126),
    [anon_sym___asm__] = ACTIONS(2126),
    [anon_sym___asm] = ACTIONS(2126),
    [sym_number_literal] = ACTIONS(2128),
    [anon_sym_L_SQUOTE] = ACTIONS(2128),
    [anon_sym_u_SQUOTE] = ACTIONS(2128),
    [anon_sym_U_SQUOTE] = ACTIONS(2128),
    [anon_sym_u8_SQUOTE] = ACTIONS(2128),
    [anon_sym_SQUOTE] = ACTIONS(2128),
    [anon_sym_L_DQUOTE] = ACTIONS(2128),
    [anon_sym_u_DQUOTE] = ACTIONS(2128),
    [anon_sym_U_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8_DQUOTE] = ACTIONS(2128),
    [anon_sym_DQUOTE] = ACTIONS(2128),
    [sym_true] = ACTIONS(2126),
    [sym_false] = ACTIONS(2126),
    [anon_sym_NULL] = ACTIONS(2126),
    [anon_sym_nullptr] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_export] = ACTIONS(2126),
    [anon_sym_module] = ACTIONS(2126),
    [anon_sym_import] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_try] = ACTIONS(2126),
    [anon_sym_delete] = ACTIONS(2126),
    [anon_sym_throw] = ACTIONS(2126),
    [anon_sym_namespace] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_concept] = ACTIONS(2126),
    [anon_sym_co_return] = ACTIONS(2126),
    [anon_sym_co_yield] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(2118),
    [anon_sym_R_DQUOTE] = ACTIONS(2128),
    [anon_sym_LR_DQUOTE] = ACTIONS(2128),
    [anon_sym_uR_DQUOTE] = ACTIONS(2128),
    [anon_sym_UR_DQUOTE] = ACTIONS(2128),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2128),
    [anon_sym_co_await] = ACTIONS(2126),
    [anon_sym_new] = ACTIONS(2126),
    [anon_sym_requires] = ACTIONS(2126),
    [sym_this] = ACTIONS(2126),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
  },
  [447] = {
    [sym_catch_clause] = STATE(193),
    [aux_sym_constructor_try_statement_repeat1] = STATE(193),
    [ts_builtin_sym_end] = ACTIONS(2124),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_include_token1] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2122),
    [anon_sym_PLUS] = ACTIONS(2122),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym___cdecl] = ACTIONS(2122),
    [anon_sym___clrcall] = ACTIONS(2122),
    [anon_sym___stdcall] = ACTIONS(2122),
    [anon_sym___fastcall] = ACTIONS(2122),
    [anon_sym___thiscall] = ACTIONS(2122),
    [anon_sym___vectorcall] = ACTIONS(2122),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_switch] = ACTIONS(2122),
    [anon_sym_case] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_do] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_goto] = ACTIONS(2122),
    [anon_sym_not] = ACTIONS(2122),
    [anon_sym_compl] = ACTIONS(2122),
    [anon_sym_DASH_DASH] = ACTIONS(2124),
    [anon_sym_PLUS_PLUS] = ACTIONS(2124),
    [anon_sym_sizeof] = ACTIONS(2122),
    [anon_sym___alignof__] = ACTIONS(2122),
    [anon_sym___alignof] = ACTIONS(2122),
    [anon_sym__alignof] = ACTIONS(2122),
    [anon_sym_alignof] = ACTIONS(2122),
    [anon_sym__Alignof] = ACTIONS(2122),
    [anon_sym_offsetof] = ACTIONS(2122),
    [anon_sym__Generic] = ACTIONS(2122),
    [anon_sym_asm] = ACTIONS(2122),
    [anon_sym___asm__] = ACTIONS(2122),
    [anon_sym___asm] = ACTIONS(2122),
    [sym_number_literal] = ACTIONS(2124),
    [anon_sym_L_SQUOTE] = ACTIONS(2124),
    [anon_sym_u_SQUOTE] = ACTIONS(2124),
    [anon_sym_U_SQUOTE] = ACTIONS(2124),
    [anon_sym_u8_SQUOTE] = ACTIONS(2124),
    [anon_sym_SQUOTE] = ACTIONS(2124),
    [anon_sym_L_DQUOTE] = ACTIONS(2124),
    [anon_sym_u_DQUOTE] = ACTIONS(2124),
    [anon_sym_U_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8_DQUOTE] = ACTIONS(2124),
    [anon_sym_DQUOTE] = ACTIONS(2124),
    [sym_true] = ACTIONS(2122),
    [sym_false] = ACTIONS(2122),
    [anon_sym_NULL] = ACTIONS(2122),
    [anon_sym_nullptr] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_export] = ACTIONS(2122),
    [anon_sym_module] = ACTIONS(2122),
    [anon_sym_import] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_try] = ACTIONS(2122),
    [anon_sym_delete] = ACTIONS(2122),
    [anon_sym_throw] = ACTIONS(2122),
    [anon_sym_namespace] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_concept] = ACTIONS(2122),
    [anon_sym_co_return] = ACTIONS(2122),
    [anon_sym_co_yield] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(2118),
    [anon_sym_R_DQUOTE] = ACTIONS(2124),
    [anon_sym_LR_DQUOTE] = ACTIONS(2124),
    [anon_sym_uR_DQUOTE] = ACTIONS(2124),
    [anon_sym_UR_DQUOTE] = ACTIONS(2124),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2124),
    [anon_sym_co_await] = ACTIONS(2122),
    [anon_sym_new] = ACTIONS(2122),
    [anon_sym_requires] = ACTIONS(2122),
    [sym_this] = ACTIONS(2122),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [449] = {
    [sym_expression] = STATE(4724),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8797),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_out] = ACTIONS(2834),
    [anon_sym_inout] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2839),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2841),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2844),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2847),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2834),
    [anon_sym_shared] = ACTIONS(2834),
    [anon_sym_groupshared] = ACTIONS(2834),
    [anon_sym_uniform] = ACTIONS(2834),
    [anon_sym_row_major] = ACTIONS(2834),
    [anon_sym_column_major] = ACTIONS(2834),
    [anon_sym_globallycoherent] = ACTIONS(2834),
    [anon_sym_centroid] = ACTIONS(2834),
    [anon_sym_noperspective] = ACTIONS(2834),
    [anon_sym_nointerpolation] = ACTIONS(2834),
    [anon_sym_sample] = ACTIONS(2834),
    [anon_sym_linear] = ACTIONS(2834),
    [anon_sym_snorm] = ACTIONS(2834),
    [anon_sym_unorm] = ACTIONS(2834),
    [anon_sym_point] = ACTIONS(2834),
    [anon_sym_line] = ACTIONS(2834),
    [anon_sym_triangleadj] = ACTIONS(2834),
    [anon_sym_lineadj] = ACTIONS(2834),
    [anon_sym_triangle] = ACTIONS(2834),
  },
  [450] = {
    [sym_else_clause] = STATE(524),
    [sym_identifier] = ACTIONS(2133),
    [aux_sym_preproc_include_token1] = ACTIONS(2133),
    [aux_sym_preproc_def_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2133),
    [sym_preproc_directive] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym___extension__] = ACTIONS(2133),
    [anon_sym_typedef] = ACTIONS(2133),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_out] = ACTIONS(2133),
    [anon_sym_inout] = ACTIONS(2133),
    [anon_sym_virtual] = ACTIONS(2133),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym___attribute__] = ACTIONS(2133),
    [anon_sym___attribute] = ACTIONS(2133),
    [anon_sym_using] = ACTIONS(2133),
    [anon_sym_COLON_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2135),
    [anon_sym___declspec] = ACTIONS(2133),
    [anon_sym___based] = ACTIONS(2133),
    [anon_sym___cdecl] = ACTIONS(2133),
    [anon_sym___clrcall] = ACTIONS(2133),
    [anon_sym___stdcall] = ACTIONS(2133),
    [anon_sym___fastcall] = ACTIONS(2133),
    [anon_sym___thiscall] = ACTIONS(2133),
    [anon_sym___vectorcall] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_signed] = ACTIONS(2133),
    [anon_sym_unsigned] = ACTIONS(2133),
    [anon_sym_long] = ACTIONS(2133),
    [anon_sym_short] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym___inline] = ACTIONS(2133),
    [anon_sym___inline__] = ACTIONS(2133),
    [anon_sym___forceinline] = ACTIONS(2133),
    [anon_sym_thread_local] = ACTIONS(2133),
    [anon_sym___thread] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_constexpr] = ACTIONS(2133),
    [anon_sym_volatile] = ACTIONS(2133),
    [anon_sym_restrict] = ACTIONS(2133),
    [anon_sym___restrict__] = ACTIONS(2133),
    [anon_sym__Atomic] = ACTIONS(2133),
    [anon_sym__Noreturn] = ACTIONS(2133),
    [anon_sym_noreturn] = ACTIONS(2133),
    [anon_sym__Nonnull] = ACTIONS(2133),
    [anon_sym_mutable] = ACTIONS(2133),
    [anon_sym_constinit] = ACTIONS(2133),
    [anon_sym_consteval] = ACTIONS(2133),
    [anon_sym_alignas] = ACTIONS(2133),
    [anon_sym__Alignas] = ACTIONS(2133),
    [sym_primitive_type] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2133),
    [anon_sym_union] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2802),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_goto] = ACTIONS(2133),
    [anon_sym___try] = ACTIONS(2133),
    [anon_sym___leave] = ACTIONS(2133),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_compl] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_sizeof] = ACTIONS(2133),
    [anon_sym___alignof__] = ACTIONS(2133),
    [anon_sym___alignof] = ACTIONS(2133),
    [anon_sym__alignof] = ACTIONS(2133),
    [anon_sym_alignof] = ACTIONS(2133),
    [anon_sym__Alignof] = ACTIONS(2133),
    [anon_sym_offsetof] = ACTIONS(2133),
    [anon_sym__Generic] = ACTIONS(2133),
    [anon_sym_asm] = ACTIONS(2133),
    [anon_sym___asm__] = ACTIONS(2133),
    [anon_sym___asm] = ACTIONS(2133),
    [sym_number_literal] = ACTIONS(2135),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2135),
    [anon_sym_u_DQUOTE] = ACTIONS(2135),
    [anon_sym_U_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [anon_sym_NULL] = ACTIONS(2133),
    [anon_sym_nullptr] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2133),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_explicit] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2133),
    [anon_sym_template] = ACTIONS(2133),
    [anon_sym_operator] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_static_assert] = ACTIONS(2133),
    [anon_sym_concept] = ACTIONS(2133),
    [anon_sym_co_return] = ACTIONS(2133),
    [anon_sym_co_yield] = ACTIONS(2133),
    [anon_sym_R_DQUOTE] = ACTIONS(2135),
    [anon_sym_LR_DQUOTE] = ACTIONS(2135),
    [anon_sym_uR_DQUOTE] = ACTIONS(2135),
    [anon_sym_UR_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2135),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_requires] = ACTIONS(2133),
    [sym_this] = ACTIONS(2133),
    [anon_sym_discard] = ACTIONS(2133),
    [anon_sym_precise] = ACTIONS(2133),
    [anon_sym_shared] = ACTIONS(2133),
    [anon_sym_groupshared] = ACTIONS(2133),
    [anon_sym_uniform] = ACTIONS(2133),
    [anon_sym_row_major] = ACTIONS(2133),
    [anon_sym_column_major] = ACTIONS(2133),
    [anon_sym_globallycoherent] = ACTIONS(2133),
    [anon_sym_centroid] = ACTIONS(2133),
    [anon_sym_noperspective] = ACTIONS(2133),
    [anon_sym_nointerpolation] = ACTIONS(2133),
    [anon_sym_sample] = ACTIONS(2133),
    [anon_sym_linear] = ACTIONS(2133),
    [anon_sym_snorm] = ACTIONS(2133),
    [anon_sym_unorm] = ACTIONS(2133),
    [anon_sym_point] = ACTIONS(2133),
    [anon_sym_line] = ACTIONS(2133),
    [anon_sym_triangleadj] = ACTIONS(2133),
    [anon_sym_lineadj] = ACTIONS(2133),
    [anon_sym_triangle] = ACTIONS(2133),
    [anon_sym_cbuffer] = ACTIONS(2133),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_include_token1] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token2] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym___cdecl] = ACTIONS(1947),
    [anon_sym___clrcall] = ACTIONS(1947),
    [anon_sym___stdcall] = ACTIONS(1947),
    [anon_sym___fastcall] = ACTIONS(1947),
    [anon_sym___thiscall] = ACTIONS(1947),
    [anon_sym___vectorcall] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_case] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_not] = ACTIONS(1947),
    [anon_sym_compl] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [anon_sym___asm] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1945),
    [anon_sym_L_SQUOTE] = ACTIONS(1945),
    [anon_sym_u_SQUOTE] = ACTIONS(1945),
    [anon_sym_U_SQUOTE] = ACTIONS(1945),
    [anon_sym_u8_SQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_namespace] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_concept] = ACTIONS(1947),
    [anon_sym_co_return] = ACTIONS(1947),
    [anon_sym_co_yield] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1945),
    [anon_sym_LR_DQUOTE] = ACTIONS(1945),
    [anon_sym_uR_DQUOTE] = ACTIONS(1945),
    [anon_sym_UR_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1945),
    [anon_sym_co_await] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_requires] = ACTIONS(1947),
    [sym_this] = ACTIONS(1947),
    [anon_sym_discard] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
    [anon_sym_cbuffer] = ACTIONS(1947),
  },
  [452] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_include_token1] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym___cdecl] = ACTIONS(2145),
    [anon_sym___clrcall] = ACTIONS(2145),
    [anon_sym___stdcall] = ACTIONS(2145),
    [anon_sym___fastcall] = ACTIONS(2145),
    [anon_sym___thiscall] = ACTIONS(2145),
    [anon_sym___vectorcall] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_goto] = ACTIONS(2145),
    [anon_sym___try] = ACTIONS(2145),
    [anon_sym___leave] = ACTIONS(2145),
    [anon_sym_not] = ACTIONS(2145),
    [anon_sym_compl] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2145),
    [anon_sym___alignof__] = ACTIONS(2145),
    [anon_sym___alignof] = ACTIONS(2145),
    [anon_sym__alignof] = ACTIONS(2145),
    [anon_sym_alignof] = ACTIONS(2145),
    [anon_sym__Alignof] = ACTIONS(2145),
    [anon_sym_offsetof] = ACTIONS(2145),
    [anon_sym__Generic] = ACTIONS(2145),
    [anon_sym_asm] = ACTIONS(2145),
    [anon_sym___asm__] = ACTIONS(2145),
    [anon_sym___asm] = ACTIONS(2145),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [anon_sym_NULL] = ACTIONS(2145),
    [anon_sym_nullptr] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_concept] = ACTIONS(2145),
    [anon_sym_co_return] = ACTIONS(2145),
    [anon_sym_co_yield] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_R_DQUOTE] = ACTIONS(2147),
    [anon_sym_LR_DQUOTE] = ACTIONS(2147),
    [anon_sym_uR_DQUOTE] = ACTIONS(2147),
    [anon_sym_UR_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2147),
    [anon_sym_co_await] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_discard] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
    [anon_sym_cbuffer] = ACTIONS(2145),
  },
  [453] = {
    [sym_expression] = STATE(4745),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8283),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2858),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2861),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2864),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2867),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
  },
  [454] = {
    [sym_else_clause] = STATE(502),
    [sym_identifier] = ACTIONS(2133),
    [aux_sym_preproc_include_token1] = ACTIONS(2133),
    [aux_sym_preproc_def_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token1] = ACTIONS(2133),
    [aux_sym_preproc_if_token2] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2133),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2133),
    [sym_preproc_directive] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2135),
    [anon_sym_AMP_AMP] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2133),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym___extension__] = ACTIONS(2133),
    [anon_sym_typedef] = ACTIONS(2133),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_out] = ACTIONS(2133),
    [anon_sym_inout] = ACTIONS(2133),
    [anon_sym_virtual] = ACTIONS(2133),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym___attribute__] = ACTIONS(2133),
    [anon_sym___attribute] = ACTIONS(2133),
    [anon_sym_using] = ACTIONS(2133),
    [anon_sym_COLON_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2135),
    [anon_sym___declspec] = ACTIONS(2133),
    [anon_sym___based] = ACTIONS(2133),
    [anon_sym___cdecl] = ACTIONS(2133),
    [anon_sym___clrcall] = ACTIONS(2133),
    [anon_sym___stdcall] = ACTIONS(2133),
    [anon_sym___fastcall] = ACTIONS(2133),
    [anon_sym___thiscall] = ACTIONS(2133),
    [anon_sym___vectorcall] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_signed] = ACTIONS(2133),
    [anon_sym_unsigned] = ACTIONS(2133),
    [anon_sym_long] = ACTIONS(2133),
    [anon_sym_short] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym___inline] = ACTIONS(2133),
    [anon_sym___inline__] = ACTIONS(2133),
    [anon_sym___forceinline] = ACTIONS(2133),
    [anon_sym_thread_local] = ACTIONS(2133),
    [anon_sym___thread] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_constexpr] = ACTIONS(2133),
    [anon_sym_volatile] = ACTIONS(2133),
    [anon_sym_restrict] = ACTIONS(2133),
    [anon_sym___restrict__] = ACTIONS(2133),
    [anon_sym__Atomic] = ACTIONS(2133),
    [anon_sym__Noreturn] = ACTIONS(2133),
    [anon_sym_noreturn] = ACTIONS(2133),
    [anon_sym__Nonnull] = ACTIONS(2133),
    [anon_sym_mutable] = ACTIONS(2133),
    [anon_sym_constinit] = ACTIONS(2133),
    [anon_sym_consteval] = ACTIONS(2133),
    [anon_sym_alignas] = ACTIONS(2133),
    [anon_sym__Alignas] = ACTIONS(2133),
    [sym_primitive_type] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2133),
    [anon_sym_union] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(2804),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_case] = ACTIONS(2133),
    [anon_sym_default] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_goto] = ACTIONS(2133),
    [anon_sym___try] = ACTIONS(2133),
    [anon_sym___leave] = ACTIONS(2133),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_compl] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_sizeof] = ACTIONS(2133),
    [anon_sym___alignof__] = ACTIONS(2133),
    [anon_sym___alignof] = ACTIONS(2133),
    [anon_sym__alignof] = ACTIONS(2133),
    [anon_sym_alignof] = ACTIONS(2133),
    [anon_sym__Alignof] = ACTIONS(2133),
    [anon_sym_offsetof] = ACTIONS(2133),
    [anon_sym__Generic] = ACTIONS(2133),
    [anon_sym_asm] = ACTIONS(2133),
    [anon_sym___asm__] = ACTIONS(2133),
    [anon_sym___asm] = ACTIONS(2133),
    [sym_number_literal] = ACTIONS(2135),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2135),
    [anon_sym_u_DQUOTE] = ACTIONS(2135),
    [anon_sym_U_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [anon_sym_NULL] = ACTIONS(2133),
    [anon_sym_nullptr] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2133),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_explicit] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2133),
    [anon_sym_template] = ACTIONS(2133),
    [anon_sym_operator] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2133),
    [anon_sym_static_assert] = ACTIONS(2133),
    [anon_sym_concept] = ACTIONS(2133),
    [anon_sym_co_return] = ACTIONS(2133),
    [anon_sym_co_yield] = ACTIONS(2133),
    [anon_sym_R_DQUOTE] = ACTIONS(2135),
    [anon_sym_LR_DQUOTE] = ACTIONS(2135),
    [anon_sym_uR_DQUOTE] = ACTIONS(2135),
    [anon_sym_UR_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2135),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_requires] = ACTIONS(2133),
    [sym_this] = ACTIONS(2133),
    [anon_sym_discard] = ACTIONS(2133),
    [anon_sym_precise] = ACTIONS(2133),
    [anon_sym_shared] = ACTIONS(2133),
    [anon_sym_groupshared] = ACTIONS(2133),
    [anon_sym_uniform] = ACTIONS(2133),
    [anon_sym_row_major] = ACTIONS(2133),
    [anon_sym_column_major] = ACTIONS(2133),
    [anon_sym_globallycoherent] = ACTIONS(2133),
    [anon_sym_centroid] = ACTIONS(2133),
    [anon_sym_noperspective] = ACTIONS(2133),
    [anon_sym_nointerpolation] = ACTIONS(2133),
    [anon_sym_sample] = ACTIONS(2133),
    [anon_sym_linear] = ACTIONS(2133),
    [anon_sym_snorm] = ACTIONS(2133),
    [anon_sym_unorm] = ACTIONS(2133),
    [anon_sym_point] = ACTIONS(2133),
    [anon_sym_line] = ACTIONS(2133),
    [anon_sym_triangleadj] = ACTIONS(2133),
    [anon_sym_lineadj] = ACTIONS(2133),
    [anon_sym_triangle] = ACTIONS(2133),
    [anon_sym_cbuffer] = ACTIONS(2133),
  },
  [455] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_include_token1] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token2] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym___cdecl] = ACTIONS(2145),
    [anon_sym___clrcall] = ACTIONS(2145),
    [anon_sym___stdcall] = ACTIONS(2145),
    [anon_sym___fastcall] = ACTIONS(2145),
    [anon_sym___thiscall] = ACTIONS(2145),
    [anon_sym___vectorcall] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_case] = ACTIONS(2145),
    [anon_sym_default] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_goto] = ACTIONS(2145),
    [anon_sym___try] = ACTIONS(2145),
    [anon_sym___leave] = ACTIONS(2145),
    [anon_sym_not] = ACTIONS(2145),
    [anon_sym_compl] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2145),
    [anon_sym___alignof__] = ACTIONS(2145),
    [anon_sym___alignof] = ACTIONS(2145),
    [anon_sym__alignof] = ACTIONS(2145),
    [anon_sym_alignof] = ACTIONS(2145),
    [anon_sym__Alignof] = ACTIONS(2145),
    [anon_sym_offsetof] = ACTIONS(2145),
    [anon_sym__Generic] = ACTIONS(2145),
    [anon_sym_asm] = ACTIONS(2145),
    [anon_sym___asm__] = ACTIONS(2145),
    [anon_sym___asm] = ACTIONS(2145),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [anon_sym_NULL] = ACTIONS(2145),
    [anon_sym_nullptr] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_namespace] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_concept] = ACTIONS(2145),
    [anon_sym_co_return] = ACTIONS(2145),
    [anon_sym_co_yield] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_R_DQUOTE] = ACTIONS(2147),
    [anon_sym_LR_DQUOTE] = ACTIONS(2147),
    [anon_sym_uR_DQUOTE] = ACTIONS(2147),
    [anon_sym_UR_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2147),
    [anon_sym_co_await] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_discard] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
    [anon_sym_cbuffer] = ACTIONS(2145),
  },
  [456] = {
    [sym_else_clause] = STATE(554),
    [sym_identifier] = ACTIONS(2151),
    [aux_sym_preproc_include_token1] = ACTIONS(2151),
    [aux_sym_preproc_def_token1] = ACTIONS(2151),
    [aux_sym_preproc_if_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2151),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2151),
    [sym_preproc_directive] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AMP_AMP] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2151),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_typedef] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_out] = ACTIONS(2151),
    [anon_sym_inout] = ACTIONS(2151),
    [anon_sym_virtual] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym___attribute] = ACTIONS(2151),
    [anon_sym_using] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym___based] = ACTIONS(2151),
    [anon_sym___cdecl] = ACTIONS(2151),
    [anon_sym___clrcall] = ACTIONS(2151),
    [anon_sym___stdcall] = ACTIONS(2151),
    [anon_sym___fastcall] = ACTIONS(2151),
    [anon_sym___thiscall] = ACTIONS(2151),
    [anon_sym___vectorcall] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_RBRACE] = ACTIONS(2153),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [anon_sym__Nonnull] = ACTIONS(2151),
    [anon_sym_mutable] = ACTIONS(2151),
    [anon_sym_constinit] = ACTIONS(2151),
    [anon_sym_consteval] = ACTIONS(2151),
    [anon_sym_alignas] = ACTIONS(2151),
    [anon_sym__Alignas] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(2802),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_case] = ACTIONS(2151),
    [anon_sym_default] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_goto] = ACTIONS(2151),
    [anon_sym___try] = ACTIONS(2151),
    [anon_sym___leave] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_compl] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_sizeof] = ACTIONS(2151),
    [anon_sym___alignof__] = ACTIONS(2151),
    [anon_sym___alignof] = ACTIONS(2151),
    [anon_sym__alignof] = ACTIONS(2151),
    [anon_sym_alignof] = ACTIONS(2151),
    [anon_sym__Alignof] = ACTIONS(2151),
    [anon_sym_offsetof] = ACTIONS(2151),
    [anon_sym__Generic] = ACTIONS(2151),
    [anon_sym_asm] = ACTIONS(2151),
    [anon_sym___asm__] = ACTIONS(2151),
    [anon_sym___asm] = ACTIONS(2151),
    [sym_number_literal] = ACTIONS(2153),
    [anon_sym_L_SQUOTE] = ACTIONS(2153),
    [anon_sym_u_SQUOTE] = ACTIONS(2153),
    [anon_sym_U_SQUOTE] = ACTIONS(2153),
    [anon_sym_u8_SQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [anon_sym_L_DQUOTE] = ACTIONS(2153),
    [anon_sym_u_DQUOTE] = ACTIONS(2153),
    [anon_sym_U_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8_DQUOTE] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [anon_sym_NULL] = ACTIONS(2151),
    [anon_sym_nullptr] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2151),
    [anon_sym_decltype] = ACTIONS(2151),
    [anon_sym_explicit] = ACTIONS(2151),
    [anon_sym_typename] = ACTIONS(2151),
    [anon_sym_template] = ACTIONS(2151),
    [anon_sym_operator] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_namespace] = ACTIONS(2151),
    [anon_sym_static_assert] = ACTIONS(2151),
    [anon_sym_concept] = ACTIONS(2151),
    [anon_sym_co_return] = ACTIONS(2151),
    [anon_sym_co_yield] = ACTIONS(2151),
    [anon_sym_R_DQUOTE] = ACTIONS(2153),
    [anon_sym_LR_DQUOTE] = ACTIONS(2153),
    [anon_sym_uR_DQUOTE] = ACTIONS(2153),
    [anon_sym_UR_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2153),
    [anon_sym_co_await] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_requires] = ACTIONS(2151),
    [sym_this] = ACTIONS(2151),
    [anon_sym_discard] = ACTIONS(2151),
    [anon_sym_precise] = ACTIONS(2151),
    [anon_sym_shared] = ACTIONS(2151),
    [anon_sym_groupshared] = ACTIONS(2151),
    [anon_sym_uniform] = ACTIONS(2151),
    [anon_sym_row_major] = ACTIONS(2151),
    [anon_sym_column_major] = ACTIONS(2151),
    [anon_sym_globallycoherent] = ACTIONS(2151),
    [anon_sym_centroid] = ACTIONS(2151),
    [anon_sym_noperspective] = ACTIONS(2151),
    [anon_sym_nointerpolation] = ACTIONS(2151),
    [anon_sym_sample] = ACTIONS(2151),
    [anon_sym_linear] = ACTIONS(2151),
    [anon_sym_snorm] = ACTIONS(2151),
    [anon_sym_unorm] = ACTIONS(2151),
    [anon_sym_point] = ACTIONS(2151),
    [anon_sym_line] = ACTIONS(2151),
    [anon_sym_triangleadj] = ACTIONS(2151),
    [anon_sym_lineadj] = ACTIONS(2151),
    [anon_sym_triangle] = ACTIONS(2151),
    [anon_sym_cbuffer] = ACTIONS(2151),
  },
  [457] = {
    [sym_identifier] = ACTIONS(2322),
    [aux_sym_preproc_include_token1] = ACTIONS(2322),
    [aux_sym_preproc_def_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token2] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2322),
    [sym_preproc_directive] = ACTIONS(2322),
    [anon_sym_LPAREN2] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym___extension__] = ACTIONS(2322),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(2322),
    [anon_sym_out] = ACTIONS(2322),
    [anon_sym_inout] = ACTIONS(2322),
    [anon_sym_virtual] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym___attribute__] = ACTIONS(2322),
    [anon_sym___attribute] = ACTIONS(2322),
    [anon_sym_using] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2324),
    [anon_sym___declspec] = ACTIONS(2322),
    [anon_sym___based] = ACTIONS(2322),
    [anon_sym___cdecl] = ACTIONS(2322),
    [anon_sym___clrcall] = ACTIONS(2322),
    [anon_sym___stdcall] = ACTIONS(2322),
    [anon_sym___fastcall] = ACTIONS(2322),
    [anon_sym___thiscall] = ACTIONS(2322),
    [anon_sym___vectorcall] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_signed] = ACTIONS(2322),
    [anon_sym_unsigned] = ACTIONS(2322),
    [anon_sym_long] = ACTIONS(2322),
    [anon_sym_short] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_register] = ACTIONS(2322),
    [anon_sym_inline] = ACTIONS(2322),
    [anon_sym___inline] = ACTIONS(2322),
    [anon_sym___inline__] = ACTIONS(2322),
    [anon_sym___forceinline] = ACTIONS(2322),
    [anon_sym_thread_local] = ACTIONS(2322),
    [anon_sym___thread] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_constexpr] = ACTIONS(2322),
    [anon_sym_volatile] = ACTIONS(2322),
    [anon_sym_restrict] = ACTIONS(2322),
    [anon_sym___restrict__] = ACTIONS(2322),
    [anon_sym__Atomic] = ACTIONS(2322),
    [anon_sym__Noreturn] = ACTIONS(2322),
    [anon_sym_noreturn] = ACTIONS(2322),
    [anon_sym__Nonnull] = ACTIONS(2322),
    [anon_sym_mutable] = ACTIONS(2322),
    [anon_sym_constinit] = ACTIONS(2322),
    [anon_sym_consteval] = ACTIONS(2322),
    [anon_sym_alignas] = ACTIONS(2322),
    [anon_sym__Alignas] = ACTIONS(2322),
    [sym_primitive_type] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_class] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2322),
    [anon_sym_switch] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2322),
    [anon_sym_default] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_goto] = ACTIONS(2322),
    [anon_sym___try] = ACTIONS(2322),
    [anon_sym___leave] = ACTIONS(2322),
    [anon_sym_not] = ACTIONS(2322),
    [anon_sym_compl] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2322),
    [anon_sym___alignof__] = ACTIONS(2322),
    [anon_sym___alignof] = ACTIONS(2322),
    [anon_sym__alignof] = ACTIONS(2322),
    [anon_sym_alignof] = ACTIONS(2322),
    [anon_sym__Alignof] = ACTIONS(2322),
    [anon_sym_offsetof] = ACTIONS(2322),
    [anon_sym__Generic] = ACTIONS(2322),
    [anon_sym_asm] = ACTIONS(2322),
    [anon_sym___asm__] = ACTIONS(2322),
    [anon_sym___asm] = ACTIONS(2322),
    [sym_number_literal] = ACTIONS(2324),
    [anon_sym_L_SQUOTE] = ACTIONS(2324),
    [anon_sym_u_SQUOTE] = ACTIONS(2324),
    [anon_sym_U_SQUOTE] = ACTIONS(2324),
    [anon_sym_u8_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_L_DQUOTE] = ACTIONS(2324),
    [anon_sym_u_DQUOTE] = ACTIONS(2324),
    [anon_sym_U_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8_DQUOTE] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [anon_sym_NULL] = ACTIONS(2322),
    [anon_sym_nullptr] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2322),
    [anon_sym_decltype] = ACTIONS(2322),
    [anon_sym_explicit] = ACTIONS(2322),
    [anon_sym_typename] = ACTIONS(2322),
    [anon_sym_template] = ACTIONS(2322),
    [anon_sym_operator] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [anon_sym_delete] = ACTIONS(2322),
    [anon_sym_throw] = ACTIONS(2322),
    [anon_sym_namespace] = ACTIONS(2322),
    [anon_sym_static_assert] = ACTIONS(2322),
    [anon_sym_concept] = ACTIONS(2322),
    [anon_sym_co_return] = ACTIONS(2322),
    [anon_sym_co_yield] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(2324),
    [anon_sym_LR_DQUOTE] = ACTIONS(2324),
    [anon_sym_uR_DQUOTE] = ACTIONS(2324),
    [anon_sym_UR_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2324),
    [anon_sym_co_await] = ACTIONS(2322),
    [anon_sym_new] = ACTIONS(2322),
    [anon_sym_requires] = ACTIONS(2322),
    [sym_this] = ACTIONS(2322),
    [anon_sym_discard] = ACTIONS(2322),
    [anon_sym_precise] = ACTIONS(2322),
    [anon_sym_shared] = ACTIONS(2322),
    [anon_sym_groupshared] = ACTIONS(2322),
    [anon_sym_uniform] = ACTIONS(2322),
    [anon_sym_row_major] = ACTIONS(2322),
    [anon_sym_column_major] = ACTIONS(2322),
    [anon_sym_globallycoherent] = ACTIONS(2322),
    [anon_sym_centroid] = ACTIONS(2322),
    [anon_sym_noperspective] = ACTIONS(2322),
    [anon_sym_nointerpolation] = ACTIONS(2322),
    [anon_sym_sample] = ACTIONS(2322),
    [anon_sym_linear] = ACTIONS(2322),
    [anon_sym_snorm] = ACTIONS(2322),
    [anon_sym_unorm] = ACTIONS(2322),
    [anon_sym_point] = ACTIONS(2322),
    [anon_sym_line] = ACTIONS(2322),
    [anon_sym_triangleadj] = ACTIONS(2322),
    [anon_sym_lineadj] = ACTIONS(2322),
    [anon_sym_triangle] = ACTIONS(2322),
    [anon_sym_cbuffer] = ACTIONS(2322),
  },
  [458] = {
    [sym_identifier] = ACTIONS(2278),
    [aux_sym_preproc_include_token1] = ACTIONS(2278),
    [aux_sym_preproc_def_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2278),
    [sym_preproc_directive] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_PLUS] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym_typedef] = ACTIONS(2278),
    [anon_sym_in] = ACTIONS(2278),
    [anon_sym_out] = ACTIONS(2278),
    [anon_sym_inout] = ACTIONS(2278),
    [anon_sym_virtual] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2278),
    [anon_sym_using] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2280),
    [anon_sym___declspec] = ACTIONS(2278),
    [anon_sym___based] = ACTIONS(2278),
    [anon_sym___cdecl] = ACTIONS(2278),
    [anon_sym___clrcall] = ACTIONS(2278),
    [anon_sym___stdcall] = ACTIONS(2278),
    [anon_sym___fastcall] = ACTIONS(2278),
    [anon_sym___thiscall] = ACTIONS(2278),
    [anon_sym___vectorcall] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_RBRACE] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2278),
    [anon_sym_unsigned] = ACTIONS(2278),
    [anon_sym_long] = ACTIONS(2278),
    [anon_sym_short] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2278),
    [anon_sym_inline] = ACTIONS(2278),
    [anon_sym___inline] = ACTIONS(2278),
    [anon_sym___inline__] = ACTIONS(2278),
    [anon_sym___forceinline] = ACTIONS(2278),
    [anon_sym_thread_local] = ACTIONS(2278),
    [anon_sym___thread] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [sym_primitive_type] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_class] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2278),
    [anon_sym_default] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_do] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_goto] = ACTIONS(2278),
    [anon_sym___try] = ACTIONS(2278),
    [anon_sym___leave] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2278),
    [anon_sym_compl] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2278),
    [anon_sym___alignof__] = ACTIONS(2278),
    [anon_sym___alignof] = ACTIONS(2278),
    [anon_sym__alignof] = ACTIONS(2278),
    [anon_sym_alignof] = ACTIONS(2278),
    [anon_sym__Alignof] = ACTIONS(2278),
    [anon_sym_offsetof] = ACTIONS(2278),
    [anon_sym__Generic] = ACTIONS(2278),
    [anon_sym_asm] = ACTIONS(2278),
    [anon_sym___asm__] = ACTIONS(2278),
    [anon_sym___asm] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2280),
    [anon_sym_L_SQUOTE] = ACTIONS(2280),
    [anon_sym_u_SQUOTE] = ACTIONS(2280),
    [anon_sym_U_SQUOTE] = ACTIONS(2280),
    [anon_sym_u8_SQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_L_DQUOTE] = ACTIONS(2280),
    [anon_sym_u_DQUOTE] = ACTIONS(2280),
    [anon_sym_U_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8_DQUOTE] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [anon_sym_NULL] = ACTIONS(2278),
    [anon_sym_nullptr] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2278),
    [anon_sym_decltype] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_typename] = ACTIONS(2278),
    [anon_sym_template] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [anon_sym_delete] = ACTIONS(2278),
    [anon_sym_throw] = ACTIONS(2278),
    [anon_sym_namespace] = ACTIONS(2278),
    [anon_sym_static_assert] = ACTIONS(2278),
    [anon_sym_concept] = ACTIONS(2278),
    [anon_sym_co_return] = ACTIONS(2278),
    [anon_sym_co_yield] = ACTIONS(2278),
    [anon_sym_R_DQUOTE] = ACTIONS(2280),
    [anon_sym_LR_DQUOTE] = ACTIONS(2280),
    [anon_sym_uR_DQUOTE] = ACTIONS(2280),
    [anon_sym_UR_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2280),
    [anon_sym_co_await] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2278),
    [sym_this] = ACTIONS(2278),
    [anon_sym_discard] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2278),
    [anon_sym_shared] = ACTIONS(2278),
    [anon_sym_groupshared] = ACTIONS(2278),
    [anon_sym_uniform] = ACTIONS(2278),
    [anon_sym_row_major] = ACTIONS(2278),
    [anon_sym_column_major] = ACTIONS(2278),
    [anon_sym_globallycoherent] = ACTIONS(2278),
    [anon_sym_centroid] = ACTIONS(2278),
    [anon_sym_noperspective] = ACTIONS(2278),
    [anon_sym_nointerpolation] = ACTIONS(2278),
    [anon_sym_sample] = ACTIONS(2278),
    [anon_sym_linear] = ACTIONS(2278),
    [anon_sym_snorm] = ACTIONS(2278),
    [anon_sym_unorm] = ACTIONS(2278),
    [anon_sym_point] = ACTIONS(2278),
    [anon_sym_line] = ACTIONS(2278),
    [anon_sym_triangleadj] = ACTIONS(2278),
    [anon_sym_lineadj] = ACTIONS(2278),
    [anon_sym_triangle] = ACTIONS(2278),
    [anon_sym_cbuffer] = ACTIONS(2278),
  },
  [459] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_out] = ACTIONS(2330),
    [anon_sym_inout] = ACTIONS(2330),
    [anon_sym_virtual] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym___attribute] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_RBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym__Nonnull] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [anon_sym___asm] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym_discard] = ACTIONS(2330),
    [anon_sym_precise] = ACTIONS(2330),
    [anon_sym_shared] = ACTIONS(2330),
    [anon_sym_groupshared] = ACTIONS(2330),
    [anon_sym_uniform] = ACTIONS(2330),
    [anon_sym_row_major] = ACTIONS(2330),
    [anon_sym_column_major] = ACTIONS(2330),
    [anon_sym_globallycoherent] = ACTIONS(2330),
    [anon_sym_centroid] = ACTIONS(2330),
    [anon_sym_noperspective] = ACTIONS(2330),
    [anon_sym_nointerpolation] = ACTIONS(2330),
    [anon_sym_sample] = ACTIONS(2330),
    [anon_sym_linear] = ACTIONS(2330),
    [anon_sym_snorm] = ACTIONS(2330),
    [anon_sym_unorm] = ACTIONS(2330),
    [anon_sym_point] = ACTIONS(2330),
    [anon_sym_line] = ACTIONS(2330),
    [anon_sym_triangleadj] = ACTIONS(2330),
    [anon_sym_lineadj] = ACTIONS(2330),
    [anon_sym_triangle] = ACTIONS(2330),
    [anon_sym_cbuffer] = ACTIONS(2330),
  },
  [460] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2870),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [461] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym_in] = ACTIONS(2334),
    [anon_sym_out] = ACTIONS(2334),
    [anon_sym_inout] = ACTIONS(2334),
    [anon_sym_virtual] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym___attribute] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_RBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym__Nonnull] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [anon_sym___asm] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym_discard] = ACTIONS(2334),
    [anon_sym_precise] = ACTIONS(2334),
    [anon_sym_shared] = ACTIONS(2334),
    [anon_sym_groupshared] = ACTIONS(2334),
    [anon_sym_uniform] = ACTIONS(2334),
    [anon_sym_row_major] = ACTIONS(2334),
    [anon_sym_column_major] = ACTIONS(2334),
    [anon_sym_globallycoherent] = ACTIONS(2334),
    [anon_sym_centroid] = ACTIONS(2334),
    [anon_sym_noperspective] = ACTIONS(2334),
    [anon_sym_nointerpolation] = ACTIONS(2334),
    [anon_sym_sample] = ACTIONS(2334),
    [anon_sym_linear] = ACTIONS(2334),
    [anon_sym_snorm] = ACTIONS(2334),
    [anon_sym_unorm] = ACTIONS(2334),
    [anon_sym_point] = ACTIONS(2334),
    [anon_sym_line] = ACTIONS(2334),
    [anon_sym_triangleadj] = ACTIONS(2334),
    [anon_sym_lineadj] = ACTIONS(2334),
    [anon_sym_triangle] = ACTIONS(2334),
    [anon_sym_cbuffer] = ACTIONS(2334),
  },
  [462] = {
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_preproc_include_token1] = ACTIONS(2306),
    [aux_sym_preproc_def_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2306),
    [sym_preproc_directive] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym_typedef] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_out] = ACTIONS(2306),
    [anon_sym_inout] = ACTIONS(2306),
    [anon_sym_virtual] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2306),
    [anon_sym_using] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2308),
    [anon_sym___declspec] = ACTIONS(2306),
    [anon_sym___based] = ACTIONS(2306),
    [anon_sym___cdecl] = ACTIONS(2306),
    [anon_sym___clrcall] = ACTIONS(2306),
    [anon_sym___stdcall] = ACTIONS(2306),
    [anon_sym___fastcall] = ACTIONS(2306),
    [anon_sym___thiscall] = ACTIONS(2306),
    [anon_sym___vectorcall] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_RBRACE] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym___inline] = ACTIONS(2306),
    [anon_sym___inline__] = ACTIONS(2306),
    [anon_sym___forceinline] = ACTIONS(2306),
    [anon_sym_thread_local] = ACTIONS(2306),
    [anon_sym___thread] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_class] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2306),
    [anon_sym_default] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_goto] = ACTIONS(2306),
    [anon_sym___try] = ACTIONS(2306),
    [anon_sym___leave] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2306),
    [anon_sym_compl] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2306),
    [anon_sym___alignof__] = ACTIONS(2306),
    [anon_sym___alignof] = ACTIONS(2306),
    [anon_sym__alignof] = ACTIONS(2306),
    [anon_sym_alignof] = ACTIONS(2306),
    [anon_sym__Alignof] = ACTIONS(2306),
    [anon_sym_offsetof] = ACTIONS(2306),
    [anon_sym__Generic] = ACTIONS(2306),
    [anon_sym_asm] = ACTIONS(2306),
    [anon_sym___asm__] = ACTIONS(2306),
    [anon_sym___asm] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2308),
    [anon_sym_L_SQUOTE] = ACTIONS(2308),
    [anon_sym_u_SQUOTE] = ACTIONS(2308),
    [anon_sym_U_SQUOTE] = ACTIONS(2308),
    [anon_sym_u8_SQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_L_DQUOTE] = ACTIONS(2308),
    [anon_sym_u_DQUOTE] = ACTIONS(2308),
    [anon_sym_U_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8_DQUOTE] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [anon_sym_NULL] = ACTIONS(2306),
    [anon_sym_nullptr] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2306),
    [anon_sym_decltype] = ACTIONS(2306),
    [anon_sym_explicit] = ACTIONS(2306),
    [anon_sym_typename] = ACTIONS(2306),
    [anon_sym_template] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [anon_sym_delete] = ACTIONS(2306),
    [anon_sym_throw] = ACTIONS(2306),
    [anon_sym_namespace] = ACTIONS(2306),
    [anon_sym_static_assert] = ACTIONS(2306),
    [anon_sym_concept] = ACTIONS(2306),
    [anon_sym_co_return] = ACTIONS(2306),
    [anon_sym_co_yield] = ACTIONS(2306),
    [anon_sym_R_DQUOTE] = ACTIONS(2308),
    [anon_sym_LR_DQUOTE] = ACTIONS(2308),
    [anon_sym_uR_DQUOTE] = ACTIONS(2308),
    [anon_sym_UR_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2308),
    [anon_sym_co_await] = ACTIONS(2306),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2306),
    [sym_this] = ACTIONS(2306),
    [anon_sym_discard] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2306),
    [anon_sym_shared] = ACTIONS(2306),
    [anon_sym_groupshared] = ACTIONS(2306),
    [anon_sym_uniform] = ACTIONS(2306),
    [anon_sym_row_major] = ACTIONS(2306),
    [anon_sym_column_major] = ACTIONS(2306),
    [anon_sym_globallycoherent] = ACTIONS(2306),
    [anon_sym_centroid] = ACTIONS(2306),
    [anon_sym_noperspective] = ACTIONS(2306),
    [anon_sym_nointerpolation] = ACTIONS(2306),
    [anon_sym_sample] = ACTIONS(2306),
    [anon_sym_linear] = ACTIONS(2306),
    [anon_sym_snorm] = ACTIONS(2306),
    [anon_sym_unorm] = ACTIONS(2306),
    [anon_sym_point] = ACTIONS(2306),
    [anon_sym_line] = ACTIONS(2306),
    [anon_sym_triangleadj] = ACTIONS(2306),
    [anon_sym_lineadj] = ACTIONS(2306),
    [anon_sym_triangle] = ACTIONS(2306),
    [anon_sym_cbuffer] = ACTIONS(2306),
  },
  [463] = {
    [sym_identifier] = ACTIONS(2310),
    [aux_sym_preproc_include_token1] = ACTIONS(2310),
    [aux_sym_preproc_def_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2310),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym_typedef] = ACTIONS(2310),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_out] = ACTIONS(2310),
    [anon_sym_inout] = ACTIONS(2310),
    [anon_sym_virtual] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2310),
    [anon_sym_using] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2312),
    [anon_sym___declspec] = ACTIONS(2310),
    [anon_sym___based] = ACTIONS(2310),
    [anon_sym___cdecl] = ACTIONS(2310),
    [anon_sym___clrcall] = ACTIONS(2310),
    [anon_sym___stdcall] = ACTIONS(2310),
    [anon_sym___fastcall] = ACTIONS(2310),
    [anon_sym___thiscall] = ACTIONS(2310),
    [anon_sym___vectorcall] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2310),
    [anon_sym_unsigned] = ACTIONS(2310),
    [anon_sym_long] = ACTIONS(2310),
    [anon_sym_short] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2310),
    [anon_sym_inline] = ACTIONS(2310),
    [anon_sym___inline] = ACTIONS(2310),
    [anon_sym___inline__] = ACTIONS(2310),
    [anon_sym___forceinline] = ACTIONS(2310),
    [anon_sym_thread_local] = ACTIONS(2310),
    [anon_sym___thread] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [sym_primitive_type] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_class] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2310),
    [anon_sym_switch] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_goto] = ACTIONS(2310),
    [anon_sym___try] = ACTIONS(2310),
    [anon_sym___leave] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_compl] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2310),
    [anon_sym___alignof__] = ACTIONS(2310),
    [anon_sym___alignof] = ACTIONS(2310),
    [anon_sym__alignof] = ACTIONS(2310),
    [anon_sym_alignof] = ACTIONS(2310),
    [anon_sym__Alignof] = ACTIONS(2310),
    [anon_sym_offsetof] = ACTIONS(2310),
    [anon_sym__Generic] = ACTIONS(2310),
    [anon_sym_asm] = ACTIONS(2310),
    [anon_sym___asm__] = ACTIONS(2310),
    [anon_sym___asm] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2312),
    [anon_sym_L_SQUOTE] = ACTIONS(2312),
    [anon_sym_u_SQUOTE] = ACTIONS(2312),
    [anon_sym_U_SQUOTE] = ACTIONS(2312),
    [anon_sym_u8_SQUOTE] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_L_DQUOTE] = ACTIONS(2312),
    [anon_sym_u_DQUOTE] = ACTIONS(2312),
    [anon_sym_U_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [anon_sym_NULL] = ACTIONS(2310),
    [anon_sym_nullptr] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2310),
    [anon_sym_decltype] = ACTIONS(2310),
    [anon_sym_explicit] = ACTIONS(2310),
    [anon_sym_typename] = ACTIONS(2310),
    [anon_sym_template] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [anon_sym_delete] = ACTIONS(2310),
    [anon_sym_throw] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2310),
    [anon_sym_static_assert] = ACTIONS(2310),
    [anon_sym_concept] = ACTIONS(2310),
    [anon_sym_co_return] = ACTIONS(2310),
    [anon_sym_co_yield] = ACTIONS(2310),
    [anon_sym_R_DQUOTE] = ACTIONS(2312),
    [anon_sym_LR_DQUOTE] = ACTIONS(2312),
    [anon_sym_uR_DQUOTE] = ACTIONS(2312),
    [anon_sym_UR_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2312),
    [anon_sym_co_await] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2310),
    [sym_this] = ACTIONS(2310),
    [anon_sym_discard] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2310),
    [anon_sym_shared] = ACTIONS(2310),
    [anon_sym_groupshared] = ACTIONS(2310),
    [anon_sym_uniform] = ACTIONS(2310),
    [anon_sym_row_major] = ACTIONS(2310),
    [anon_sym_column_major] = ACTIONS(2310),
    [anon_sym_globallycoherent] = ACTIONS(2310),
    [anon_sym_centroid] = ACTIONS(2310),
    [anon_sym_noperspective] = ACTIONS(2310),
    [anon_sym_nointerpolation] = ACTIONS(2310),
    [anon_sym_sample] = ACTIONS(2310),
    [anon_sym_linear] = ACTIONS(2310),
    [anon_sym_snorm] = ACTIONS(2310),
    [anon_sym_unorm] = ACTIONS(2310),
    [anon_sym_point] = ACTIONS(2310),
    [anon_sym_line] = ACTIONS(2310),
    [anon_sym_triangleadj] = ACTIONS(2310),
    [anon_sym_lineadj] = ACTIONS(2310),
    [anon_sym_triangle] = ACTIONS(2310),
    [anon_sym_cbuffer] = ACTIONS(2310),
  },
  [464] = {
    [sym_identifier] = ACTIONS(2314),
    [aux_sym_preproc_include_token1] = ACTIONS(2314),
    [aux_sym_preproc_def_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2314),
    [sym_preproc_directive] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP_AMP] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym_typedef] = ACTIONS(2314),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_out] = ACTIONS(2314),
    [anon_sym_inout] = ACTIONS(2314),
    [anon_sym_virtual] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2316),
    [anon_sym___declspec] = ACTIONS(2314),
    [anon_sym___based] = ACTIONS(2314),
    [anon_sym___cdecl] = ACTIONS(2314),
    [anon_sym___clrcall] = ACTIONS(2314),
    [anon_sym___stdcall] = ACTIONS(2314),
    [anon_sym___fastcall] = ACTIONS(2314),
    [anon_sym___thiscall] = ACTIONS(2314),
    [anon_sym___vectorcall] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_RBRACE] = ACTIONS(2316),
    [anon_sym_signed] = ACTIONS(2314),
    [anon_sym_unsigned] = ACTIONS(2314),
    [anon_sym_long] = ACTIONS(2314),
    [anon_sym_short] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym___inline] = ACTIONS(2314),
    [anon_sym___inline__] = ACTIONS(2314),
    [anon_sym___forceinline] = ACTIONS(2314),
    [anon_sym_thread_local] = ACTIONS(2314),
    [anon_sym___thread] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [sym_primitive_type] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_goto] = ACTIONS(2314),
    [anon_sym___try] = ACTIONS(2314),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_compl] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2314),
    [anon_sym___alignof__] = ACTIONS(2314),
    [anon_sym___alignof] = ACTIONS(2314),
    [anon_sym__alignof] = ACTIONS(2314),
    [anon_sym_alignof] = ACTIONS(2314),
    [anon_sym__Alignof] = ACTIONS(2314),
    [anon_sym_offsetof] = ACTIONS(2314),
    [anon_sym__Generic] = ACTIONS(2314),
    [anon_sym_asm] = ACTIONS(2314),
    [anon_sym___asm__] = ACTIONS(2314),
    [anon_sym___asm] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_L_SQUOTE] = ACTIONS(2316),
    [anon_sym_u_SQUOTE] = ACTIONS(2316),
    [anon_sym_U_SQUOTE] = ACTIONS(2316),
    [anon_sym_u8_SQUOTE] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_L_DQUOTE] = ACTIONS(2316),
    [anon_sym_u_DQUOTE] = ACTIONS(2316),
    [anon_sym_U_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8_DQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [anon_sym_NULL] = ACTIONS(2314),
    [anon_sym_nullptr] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2314),
    [anon_sym_decltype] = ACTIONS(2314),
    [anon_sym_explicit] = ACTIONS(2314),
    [anon_sym_typename] = ACTIONS(2314),
    [anon_sym_template] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_namespace] = ACTIONS(2314),
    [anon_sym_static_assert] = ACTIONS(2314),
    [anon_sym_concept] = ACTIONS(2314),
    [anon_sym_co_return] = ACTIONS(2314),
    [anon_sym_co_yield] = ACTIONS(2314),
    [anon_sym_R_DQUOTE] = ACTIONS(2316),
    [anon_sym_LR_DQUOTE] = ACTIONS(2316),
    [anon_sym_uR_DQUOTE] = ACTIONS(2316),
    [anon_sym_UR_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2316),
    [anon_sym_co_await] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_discard] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2314),
    [anon_sym_shared] = ACTIONS(2314),
    [anon_sym_groupshared] = ACTIONS(2314),
    [anon_sym_uniform] = ACTIONS(2314),
    [anon_sym_row_major] = ACTIONS(2314),
    [anon_sym_column_major] = ACTIONS(2314),
    [anon_sym_globallycoherent] = ACTIONS(2314),
    [anon_sym_centroid] = ACTIONS(2314),
    [anon_sym_noperspective] = ACTIONS(2314),
    [anon_sym_nointerpolation] = ACTIONS(2314),
    [anon_sym_sample] = ACTIONS(2314),
    [anon_sym_linear] = ACTIONS(2314),
    [anon_sym_snorm] = ACTIONS(2314),
    [anon_sym_unorm] = ACTIONS(2314),
    [anon_sym_point] = ACTIONS(2314),
    [anon_sym_line] = ACTIONS(2314),
    [anon_sym_triangleadj] = ACTIONS(2314),
    [anon_sym_lineadj] = ACTIONS(2314),
    [anon_sym_triangle] = ACTIONS(2314),
    [anon_sym_cbuffer] = ACTIONS(2314),
  },
  [465] = {
    [sym_identifier] = ACTIONS(2318),
    [aux_sym_preproc_include_token1] = ACTIONS(2318),
    [aux_sym_preproc_def_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_LPAREN2] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_AMP_AMP] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym___extension__] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_in] = ACTIONS(2318),
    [anon_sym_out] = ACTIONS(2318),
    [anon_sym_inout] = ACTIONS(2318),
    [anon_sym_virtual] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym___attribute__] = ACTIONS(2318),
    [anon_sym___attribute] = ACTIONS(2318),
    [anon_sym_using] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2320),
    [anon_sym___declspec] = ACTIONS(2318),
    [anon_sym___based] = ACTIONS(2318),
    [anon_sym___cdecl] = ACTIONS(2318),
    [anon_sym___clrcall] = ACTIONS(2318),
    [anon_sym___stdcall] = ACTIONS(2318),
    [anon_sym___fastcall] = ACTIONS(2318),
    [anon_sym___thiscall] = ACTIONS(2318),
    [anon_sym___vectorcall] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_RBRACE] = ACTIONS(2320),
    [anon_sym_signed] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym___inline] = ACTIONS(2318),
    [anon_sym___inline__] = ACTIONS(2318),
    [anon_sym___forceinline] = ACTIONS(2318),
    [anon_sym_thread_local] = ACTIONS(2318),
    [anon_sym___thread] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_constexpr] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym___restrict__] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym__Noreturn] = ACTIONS(2318),
    [anon_sym_noreturn] = ACTIONS(2318),
    [anon_sym__Nonnull] = ACTIONS(2318),
    [anon_sym_mutable] = ACTIONS(2318),
    [anon_sym_constinit] = ACTIONS(2318),
    [anon_sym_consteval] = ACTIONS(2318),
    [anon_sym_alignas] = ACTIONS(2318),
    [anon_sym__Alignas] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_class] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym___try] = ACTIONS(2318),
    [anon_sym___leave] = ACTIONS(2318),
    [anon_sym_not] = ACTIONS(2318),
    [anon_sym_compl] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2318),
    [anon_sym___alignof__] = ACTIONS(2318),
    [anon_sym___alignof] = ACTIONS(2318),
    [anon_sym__alignof] = ACTIONS(2318),
    [anon_sym_alignof] = ACTIONS(2318),
    [anon_sym__Alignof] = ACTIONS(2318),
    [anon_sym_offsetof] = ACTIONS(2318),
    [anon_sym__Generic] = ACTIONS(2318),
    [anon_sym_asm] = ACTIONS(2318),
    [anon_sym___asm__] = ACTIONS(2318),
    [anon_sym___asm] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2320),
    [anon_sym_L_SQUOTE] = ACTIONS(2320),
    [anon_sym_u_SQUOTE] = ACTIONS(2320),
    [anon_sym_U_SQUOTE] = ACTIONS(2320),
    [anon_sym_u8_SQUOTE] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_L_DQUOTE] = ACTIONS(2320),
    [anon_sym_u_DQUOTE] = ACTIONS(2320),
    [anon_sym_U_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8_DQUOTE] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(2320),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [anon_sym_NULL] = ACTIONS(2318),
    [anon_sym_nullptr] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2318),
    [anon_sym_decltype] = ACTIONS(2318),
    [anon_sym_explicit] = ACTIONS(2318),
    [anon_sym_typename] = ACTIONS(2318),
    [anon_sym_template] = ACTIONS(2318),
    [anon_sym_operator] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [anon_sym_delete] = ACTIONS(2318),
    [anon_sym_throw] = ACTIONS(2318),
    [anon_sym_namespace] = ACTIONS(2318),
    [anon_sym_static_assert] = ACTIONS(2318),
    [anon_sym_concept] = ACTIONS(2318),
    [anon_sym_co_return] = ACTIONS(2318),
    [anon_sym_co_yield] = ACTIONS(2318),
    [anon_sym_R_DQUOTE] = ACTIONS(2320),
    [anon_sym_LR_DQUOTE] = ACTIONS(2320),
    [anon_sym_uR_DQUOTE] = ACTIONS(2320),
    [anon_sym_UR_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2320),
    [anon_sym_co_await] = ACTIONS(2318),
    [anon_sym_new] = ACTIONS(2318),
    [anon_sym_requires] = ACTIONS(2318),
    [sym_this] = ACTIONS(2318),
    [anon_sym_discard] = ACTIONS(2318),
    [anon_sym_precise] = ACTIONS(2318),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_groupshared] = ACTIONS(2318),
    [anon_sym_uniform] = ACTIONS(2318),
    [anon_sym_row_major] = ACTIONS(2318),
    [anon_sym_column_major] = ACTIONS(2318),
    [anon_sym_globallycoherent] = ACTIONS(2318),
    [anon_sym_centroid] = ACTIONS(2318),
    [anon_sym_noperspective] = ACTIONS(2318),
    [anon_sym_nointerpolation] = ACTIONS(2318),
    [anon_sym_sample] = ACTIONS(2318),
    [anon_sym_linear] = ACTIONS(2318),
    [anon_sym_snorm] = ACTIONS(2318),
    [anon_sym_unorm] = ACTIONS(2318),
    [anon_sym_point] = ACTIONS(2318),
    [anon_sym_line] = ACTIONS(2318),
    [anon_sym_triangleadj] = ACTIONS(2318),
    [anon_sym_lineadj] = ACTIONS(2318),
    [anon_sym_triangle] = ACTIONS(2318),
    [anon_sym_cbuffer] = ACTIONS(2318),
  },
  [466] = {
    [sym_identifier] = ACTIONS(2322),
    [aux_sym_preproc_include_token1] = ACTIONS(2322),
    [aux_sym_preproc_def_token1] = ACTIONS(2322),
    [aux_sym_preproc_if_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2322),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2322),
    [sym_preproc_directive] = ACTIONS(2322),
    [anon_sym_LPAREN2] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym___extension__] = ACTIONS(2322),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(2322),
    [anon_sym_out] = ACTIONS(2322),
    [anon_sym_inout] = ACTIONS(2322),
    [anon_sym_virtual] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym___attribute__] = ACTIONS(2322),
    [anon_sym___attribute] = ACTIONS(2322),
    [anon_sym_using] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2324),
    [anon_sym___declspec] = ACTIONS(2322),
    [anon_sym___based] = ACTIONS(2322),
    [anon_sym___cdecl] = ACTIONS(2322),
    [anon_sym___clrcall] = ACTIONS(2322),
    [anon_sym___stdcall] = ACTIONS(2322),
    [anon_sym___fastcall] = ACTIONS(2322),
    [anon_sym___thiscall] = ACTIONS(2322),
    [anon_sym___vectorcall] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_signed] = ACTIONS(2322),
    [anon_sym_unsigned] = ACTIONS(2322),
    [anon_sym_long] = ACTIONS(2322),
    [anon_sym_short] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_register] = ACTIONS(2322),
    [anon_sym_inline] = ACTIONS(2322),
    [anon_sym___inline] = ACTIONS(2322),
    [anon_sym___inline__] = ACTIONS(2322),
    [anon_sym___forceinline] = ACTIONS(2322),
    [anon_sym_thread_local] = ACTIONS(2322),
    [anon_sym___thread] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_constexpr] = ACTIONS(2322),
    [anon_sym_volatile] = ACTIONS(2322),
    [anon_sym_restrict] = ACTIONS(2322),
    [anon_sym___restrict__] = ACTIONS(2322),
    [anon_sym__Atomic] = ACTIONS(2322),
    [anon_sym__Noreturn] = ACTIONS(2322),
    [anon_sym_noreturn] = ACTIONS(2322),
    [anon_sym__Nonnull] = ACTIONS(2322),
    [anon_sym_mutable] = ACTIONS(2322),
    [anon_sym_constinit] = ACTIONS(2322),
    [anon_sym_consteval] = ACTIONS(2322),
    [anon_sym_alignas] = ACTIONS(2322),
    [anon_sym__Alignas] = ACTIONS(2322),
    [sym_primitive_type] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_class] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2322),
    [anon_sym_switch] = ACTIONS(2322),
    [anon_sym_case] = ACTIONS(2322),
    [anon_sym_default] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_goto] = ACTIONS(2322),
    [anon_sym___try] = ACTIONS(2322),
    [anon_sym___leave] = ACTIONS(2322),
    [anon_sym_not] = ACTIONS(2322),
    [anon_sym_compl] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2322),
    [anon_sym___alignof__] = ACTIONS(2322),
    [anon_sym___alignof] = ACTIONS(2322),
    [anon_sym__alignof] = ACTIONS(2322),
    [anon_sym_alignof] = ACTIONS(2322),
    [anon_sym__Alignof] = ACTIONS(2322),
    [anon_sym_offsetof] = ACTIONS(2322),
    [anon_sym__Generic] = ACTIONS(2322),
    [anon_sym_asm] = ACTIONS(2322),
    [anon_sym___asm__] = ACTIONS(2322),
    [anon_sym___asm] = ACTIONS(2322),
    [sym_number_literal] = ACTIONS(2324),
    [anon_sym_L_SQUOTE] = ACTIONS(2324),
    [anon_sym_u_SQUOTE] = ACTIONS(2324),
    [anon_sym_U_SQUOTE] = ACTIONS(2324),
    [anon_sym_u8_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_L_DQUOTE] = ACTIONS(2324),
    [anon_sym_u_DQUOTE] = ACTIONS(2324),
    [anon_sym_U_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8_DQUOTE] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [anon_sym_NULL] = ACTIONS(2322),
    [anon_sym_nullptr] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2322),
    [anon_sym_decltype] = ACTIONS(2322),
    [anon_sym_explicit] = ACTIONS(2322),
    [anon_sym_typename] = ACTIONS(2322),
    [anon_sym_template] = ACTIONS(2322),
    [anon_sym_operator] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [anon_sym_delete] = ACTIONS(2322),
    [anon_sym_throw] = ACTIONS(2322),
    [anon_sym_namespace] = ACTIONS(2322),
    [anon_sym_static_assert] = ACTIONS(2322),
    [anon_sym_concept] = ACTIONS(2322),
    [anon_sym_co_return] = ACTIONS(2322),
    [anon_sym_co_yield] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(2324),
    [anon_sym_LR_DQUOTE] = ACTIONS(2324),
    [anon_sym_uR_DQUOTE] = ACTIONS(2324),
    [anon_sym_UR_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2324),
    [anon_sym_co_await] = ACTIONS(2322),
    [anon_sym_new] = ACTIONS(2322),
    [anon_sym_requires] = ACTIONS(2322),
    [sym_this] = ACTIONS(2322),
    [anon_sym_discard] = ACTIONS(2322),
    [anon_sym_precise] = ACTIONS(2322),
    [anon_sym_shared] = ACTIONS(2322),
    [anon_sym_groupshared] = ACTIONS(2322),
    [anon_sym_uniform] = ACTIONS(2322),
    [anon_sym_row_major] = ACTIONS(2322),
    [anon_sym_column_major] = ACTIONS(2322),
    [anon_sym_globallycoherent] = ACTIONS(2322),
    [anon_sym_centroid] = ACTIONS(2322),
    [anon_sym_noperspective] = ACTIONS(2322),
    [anon_sym_nointerpolation] = ACTIONS(2322),
    [anon_sym_sample] = ACTIONS(2322),
    [anon_sym_linear] = ACTIONS(2322),
    [anon_sym_snorm] = ACTIONS(2322),
    [anon_sym_unorm] = ACTIONS(2322),
    [anon_sym_point] = ACTIONS(2322),
    [anon_sym_line] = ACTIONS(2322),
    [anon_sym_triangleadj] = ACTIONS(2322),
    [anon_sym_lineadj] = ACTIONS(2322),
    [anon_sym_triangle] = ACTIONS(2322),
    [anon_sym_cbuffer] = ACTIONS(2322),
  },
  [467] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_out] = ACTIONS(2326),
    [anon_sym_inout] = ACTIONS(2326),
    [anon_sym_virtual] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym___attribute] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym__Nonnull] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [anon_sym___asm] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym_discard] = ACTIONS(2326),
    [anon_sym_precise] = ACTIONS(2326),
    [anon_sym_shared] = ACTIONS(2326),
    [anon_sym_groupshared] = ACTIONS(2326),
    [anon_sym_uniform] = ACTIONS(2326),
    [anon_sym_row_major] = ACTIONS(2326),
    [anon_sym_column_major] = ACTIONS(2326),
    [anon_sym_globallycoherent] = ACTIONS(2326),
    [anon_sym_centroid] = ACTIONS(2326),
    [anon_sym_noperspective] = ACTIONS(2326),
    [anon_sym_nointerpolation] = ACTIONS(2326),
    [anon_sym_sample] = ACTIONS(2326),
    [anon_sym_linear] = ACTIONS(2326),
    [anon_sym_snorm] = ACTIONS(2326),
    [anon_sym_unorm] = ACTIONS(2326),
    [anon_sym_point] = ACTIONS(2326),
    [anon_sym_line] = ACTIONS(2326),
    [anon_sym_triangleadj] = ACTIONS(2326),
    [anon_sym_lineadj] = ACTIONS(2326),
    [anon_sym_triangle] = ACTIONS(2326),
    [anon_sym_cbuffer] = ACTIONS(2326),
  },
  [468] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2338),
    [anon_sym_out] = ACTIONS(2338),
    [anon_sym_inout] = ACTIONS(2338),
    [anon_sym_virtual] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym___attribute] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym__Nonnull] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [anon_sym___asm] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym_discard] = ACTIONS(2338),
    [anon_sym_precise] = ACTIONS(2338),
    [anon_sym_shared] = ACTIONS(2338),
    [anon_sym_groupshared] = ACTIONS(2338),
    [anon_sym_uniform] = ACTIONS(2338),
    [anon_sym_row_major] = ACTIONS(2338),
    [anon_sym_column_major] = ACTIONS(2338),
    [anon_sym_globallycoherent] = ACTIONS(2338),
    [anon_sym_centroid] = ACTIONS(2338),
    [anon_sym_noperspective] = ACTIONS(2338),
    [anon_sym_nointerpolation] = ACTIONS(2338),
    [anon_sym_sample] = ACTIONS(2338),
    [anon_sym_linear] = ACTIONS(2338),
    [anon_sym_snorm] = ACTIONS(2338),
    [anon_sym_unorm] = ACTIONS(2338),
    [anon_sym_point] = ACTIONS(2338),
    [anon_sym_line] = ACTIONS(2338),
    [anon_sym_triangleadj] = ACTIONS(2338),
    [anon_sym_lineadj] = ACTIONS(2338),
    [anon_sym_triangle] = ACTIONS(2338),
    [anon_sym_cbuffer] = ACTIONS(2338),
  },
  [469] = {
    [sym_identifier] = ACTIONS(2298),
    [aux_sym_preproc_include_token1] = ACTIONS(2298),
    [aux_sym_preproc_def_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_using] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym___based] = ACTIONS(2298),
    [anon_sym___cdecl] = ACTIONS(2298),
    [anon_sym___clrcall] = ACTIONS(2298),
    [anon_sym___stdcall] = ACTIONS(2298),
    [anon_sym___fastcall] = ACTIONS(2298),
    [anon_sym___thiscall] = ACTIONS(2298),
    [anon_sym___vectorcall] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym___try] = ACTIONS(2298),
    [anon_sym___leave] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2298),
    [anon_sym_compl] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2298),
    [anon_sym___alignof__] = ACTIONS(2298),
    [anon_sym___alignof] = ACTIONS(2298),
    [anon_sym__alignof] = ACTIONS(2298),
    [anon_sym_alignof] = ACTIONS(2298),
    [anon_sym__Alignof] = ACTIONS(2298),
    [anon_sym_offsetof] = ACTIONS(2298),
    [anon_sym__Generic] = ACTIONS(2298),
    [anon_sym_asm] = ACTIONS(2298),
    [anon_sym___asm__] = ACTIONS(2298),
    [anon_sym___asm] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2300),
    [anon_sym_L_SQUOTE] = ACTIONS(2300),
    [anon_sym_u_SQUOTE] = ACTIONS(2300),
    [anon_sym_U_SQUOTE] = ACTIONS(2300),
    [anon_sym_u8_SQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_L_DQUOTE] = ACTIONS(2300),
    [anon_sym_u_DQUOTE] = ACTIONS(2300),
    [anon_sym_U_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8_DQUOTE] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [anon_sym_NULL] = ACTIONS(2298),
    [anon_sym_nullptr] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2298),
    [anon_sym_explicit] = ACTIONS(2298),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_namespace] = ACTIONS(2298),
    [anon_sym_static_assert] = ACTIONS(2298),
    [anon_sym_concept] = ACTIONS(2298),
    [anon_sym_co_return] = ACTIONS(2298),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2300),
    [anon_sym_LR_DQUOTE] = ACTIONS(2300),
    [anon_sym_uR_DQUOTE] = ACTIONS(2300),
    [anon_sym_UR_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2300),
    [anon_sym_co_await] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_discard] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
    [anon_sym_cbuffer] = ACTIONS(2298),
  },
  [470] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [anon_sym___asm] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_discard] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
    [anon_sym_cbuffer] = ACTIONS(2342),
  },
  [471] = {
    [sym_identifier] = ACTIONS(2346),
    [aux_sym_preproc_include_token1] = ACTIONS(2346),
    [aux_sym_preproc_def_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2346),
    [sym_preproc_directive] = ACTIONS(2346),
    [anon_sym_LPAREN2] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_typedef] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_out] = ACTIONS(2346),
    [anon_sym_inout] = ACTIONS(2346),
    [anon_sym_virtual] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym___attribute__] = ACTIONS(2346),
    [anon_sym___attribute] = ACTIONS(2346),
    [anon_sym_using] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2346),
    [anon_sym___based] = ACTIONS(2346),
    [anon_sym___cdecl] = ACTIONS(2346),
    [anon_sym___clrcall] = ACTIONS(2346),
    [anon_sym___stdcall] = ACTIONS(2346),
    [anon_sym___fastcall] = ACTIONS(2346),
    [anon_sym___thiscall] = ACTIONS(2346),
    [anon_sym___vectorcall] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_signed] = ACTIONS(2346),
    [anon_sym_unsigned] = ACTIONS(2346),
    [anon_sym_long] = ACTIONS(2346),
    [anon_sym_short] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_register] = ACTIONS(2346),
    [anon_sym_inline] = ACTIONS(2346),
    [anon_sym___inline] = ACTIONS(2346),
    [anon_sym___inline__] = ACTIONS(2346),
    [anon_sym___forceinline] = ACTIONS(2346),
    [anon_sym_thread_local] = ACTIONS(2346),
    [anon_sym___thread] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_constexpr] = ACTIONS(2346),
    [anon_sym_volatile] = ACTIONS(2346),
    [anon_sym_restrict] = ACTIONS(2346),
    [anon_sym___restrict__] = ACTIONS(2346),
    [anon_sym__Atomic] = ACTIONS(2346),
    [anon_sym__Noreturn] = ACTIONS(2346),
    [anon_sym_noreturn] = ACTIONS(2346),
    [anon_sym__Nonnull] = ACTIONS(2346),
    [anon_sym_mutable] = ACTIONS(2346),
    [anon_sym_constinit] = ACTIONS(2346),
    [anon_sym_consteval] = ACTIONS(2346),
    [anon_sym_alignas] = ACTIONS(2346),
    [anon_sym__Alignas] = ACTIONS(2346),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_goto] = ACTIONS(2346),
    [anon_sym___try] = ACTIONS(2346),
    [anon_sym___leave] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2346),
    [anon_sym_compl] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2346),
    [anon_sym___alignof__] = ACTIONS(2346),
    [anon_sym___alignof] = ACTIONS(2346),
    [anon_sym__alignof] = ACTIONS(2346),
    [anon_sym_alignof] = ACTIONS(2346),
    [anon_sym__Alignof] = ACTIONS(2346),
    [anon_sym_offsetof] = ACTIONS(2346),
    [anon_sym__Generic] = ACTIONS(2346),
    [anon_sym_asm] = ACTIONS(2346),
    [anon_sym___asm__] = ACTIONS(2346),
    [anon_sym___asm] = ACTIONS(2346),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_L_SQUOTE] = ACTIONS(2348),
    [anon_sym_u_SQUOTE] = ACTIONS(2348),
    [anon_sym_U_SQUOTE] = ACTIONS(2348),
    [anon_sym_u8_SQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_L_DQUOTE] = ACTIONS(2348),
    [anon_sym_u_DQUOTE] = ACTIONS(2348),
    [anon_sym_U_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8_DQUOTE] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [anon_sym_NULL] = ACTIONS(2346),
    [anon_sym_nullptr] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_decltype] = ACTIONS(2346),
    [anon_sym_explicit] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2346),
    [anon_sym_template] = ACTIONS(2346),
    [anon_sym_operator] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_static_assert] = ACTIONS(2346),
    [anon_sym_concept] = ACTIONS(2346),
    [anon_sym_co_return] = ACTIONS(2346),
    [anon_sym_co_yield] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(2348),
    [anon_sym_LR_DQUOTE] = ACTIONS(2348),
    [anon_sym_uR_DQUOTE] = ACTIONS(2348),
    [anon_sym_UR_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2348),
    [anon_sym_co_await] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_requires] = ACTIONS(2346),
    [sym_this] = ACTIONS(2346),
    [anon_sym_discard] = ACTIONS(2346),
    [anon_sym_precise] = ACTIONS(2346),
    [anon_sym_shared] = ACTIONS(2346),
    [anon_sym_groupshared] = ACTIONS(2346),
    [anon_sym_uniform] = ACTIONS(2346),
    [anon_sym_row_major] = ACTIONS(2346),
    [anon_sym_column_major] = ACTIONS(2346),
    [anon_sym_globallycoherent] = ACTIONS(2346),
    [anon_sym_centroid] = ACTIONS(2346),
    [anon_sym_noperspective] = ACTIONS(2346),
    [anon_sym_nointerpolation] = ACTIONS(2346),
    [anon_sym_sample] = ACTIONS(2346),
    [anon_sym_linear] = ACTIONS(2346),
    [anon_sym_snorm] = ACTIONS(2346),
    [anon_sym_unorm] = ACTIONS(2346),
    [anon_sym_point] = ACTIONS(2346),
    [anon_sym_line] = ACTIONS(2346),
    [anon_sym_triangleadj] = ACTIONS(2346),
    [anon_sym_lineadj] = ACTIONS(2346),
    [anon_sym_triangle] = ACTIONS(2346),
    [anon_sym_cbuffer] = ACTIONS(2346),
  },
  [472] = {
    [sym_identifier] = ACTIONS(2350),
    [aux_sym_preproc_include_token1] = ACTIONS(2350),
    [aux_sym_preproc_def_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2350),
    [sym_preproc_directive] = ACTIONS(2350),
    [anon_sym_LPAREN2] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2350),
    [anon_sym_typedef] = ACTIONS(2350),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_out] = ACTIONS(2350),
    [anon_sym_inout] = ACTIONS(2350),
    [anon_sym_virtual] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym___attribute__] = ACTIONS(2350),
    [anon_sym___attribute] = ACTIONS(2350),
    [anon_sym_using] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2352),
    [anon_sym___declspec] = ACTIONS(2350),
    [anon_sym___based] = ACTIONS(2350),
    [anon_sym___cdecl] = ACTIONS(2350),
    [anon_sym___clrcall] = ACTIONS(2350),
    [anon_sym___stdcall] = ACTIONS(2350),
    [anon_sym___fastcall] = ACTIONS(2350),
    [anon_sym___thiscall] = ACTIONS(2350),
    [anon_sym___vectorcall] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_RBRACE] = ACTIONS(2352),
    [anon_sym_signed] = ACTIONS(2350),
    [anon_sym_unsigned] = ACTIONS(2350),
    [anon_sym_long] = ACTIONS(2350),
    [anon_sym_short] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_register] = ACTIONS(2350),
    [anon_sym_inline] = ACTIONS(2350),
    [anon_sym___inline] = ACTIONS(2350),
    [anon_sym___inline__] = ACTIONS(2350),
    [anon_sym___forceinline] = ACTIONS(2350),
    [anon_sym_thread_local] = ACTIONS(2350),
    [anon_sym___thread] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym___restrict__] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym__Noreturn] = ACTIONS(2350),
    [anon_sym_noreturn] = ACTIONS(2350),
    [anon_sym__Nonnull] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_constinit] = ACTIONS(2350),
    [anon_sym_consteval] = ACTIONS(2350),
    [anon_sym_alignas] = ACTIONS(2350),
    [anon_sym__Alignas] = ACTIONS(2350),
    [sym_primitive_type] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_goto] = ACTIONS(2350),
    [anon_sym___try] = ACTIONS(2350),
    [anon_sym___leave] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2350),
    [anon_sym_compl] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2350),
    [anon_sym___alignof__] = ACTIONS(2350),
    [anon_sym___alignof] = ACTIONS(2350),
    [anon_sym__alignof] = ACTIONS(2350),
    [anon_sym_alignof] = ACTIONS(2350),
    [anon_sym__Alignof] = ACTIONS(2350),
    [anon_sym_offsetof] = ACTIONS(2350),
    [anon_sym__Generic] = ACTIONS(2350),
    [anon_sym_asm] = ACTIONS(2350),
    [anon_sym___asm__] = ACTIONS(2350),
    [anon_sym___asm] = ACTIONS(2350),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_L_SQUOTE] = ACTIONS(2352),
    [anon_sym_u_SQUOTE] = ACTIONS(2352),
    [anon_sym_U_SQUOTE] = ACTIONS(2352),
    [anon_sym_u8_SQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_L_DQUOTE] = ACTIONS(2352),
    [anon_sym_u_DQUOTE] = ACTIONS(2352),
    [anon_sym_U_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8_DQUOTE] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [anon_sym_NULL] = ACTIONS(2350),
    [anon_sym_nullptr] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2350),
    [anon_sym_decltype] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_typename] = ACTIONS(2350),
    [anon_sym_template] = ACTIONS(2350),
    [anon_sym_operator] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_static_assert] = ACTIONS(2350),
    [anon_sym_concept] = ACTIONS(2350),
    [anon_sym_co_return] = ACTIONS(2350),
    [anon_sym_co_yield] = ACTIONS(2350),
    [anon_sym_R_DQUOTE] = ACTIONS(2352),
    [anon_sym_LR_DQUOTE] = ACTIONS(2352),
    [anon_sym_uR_DQUOTE] = ACTIONS(2352),
    [anon_sym_UR_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2352),
    [anon_sym_co_await] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_requires] = ACTIONS(2350),
    [sym_this] = ACTIONS(2350),
    [anon_sym_discard] = ACTIONS(2350),
    [anon_sym_precise] = ACTIONS(2350),
    [anon_sym_shared] = ACTIONS(2350),
    [anon_sym_groupshared] = ACTIONS(2350),
    [anon_sym_uniform] = ACTIONS(2350),
    [anon_sym_row_major] = ACTIONS(2350),
    [anon_sym_column_major] = ACTIONS(2350),
    [anon_sym_globallycoherent] = ACTIONS(2350),
    [anon_sym_centroid] = ACTIONS(2350),
    [anon_sym_noperspective] = ACTIONS(2350),
    [anon_sym_nointerpolation] = ACTIONS(2350),
    [anon_sym_sample] = ACTIONS(2350),
    [anon_sym_linear] = ACTIONS(2350),
    [anon_sym_snorm] = ACTIONS(2350),
    [anon_sym_unorm] = ACTIONS(2350),
    [anon_sym_point] = ACTIONS(2350),
    [anon_sym_line] = ACTIONS(2350),
    [anon_sym_triangleadj] = ACTIONS(2350),
    [anon_sym_lineadj] = ACTIONS(2350),
    [anon_sym_triangle] = ACTIONS(2350),
    [anon_sym_cbuffer] = ACTIONS(2350),
  },
  [473] = {
    [sym_identifier] = ACTIONS(2354),
    [aux_sym_preproc_include_token1] = ACTIONS(2354),
    [aux_sym_preproc_def_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2354),
    [sym_preproc_directive] = ACTIONS(2354),
    [anon_sym_LPAREN2] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_AMP_AMP] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2354),
    [anon_sym_typedef] = ACTIONS(2354),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_out] = ACTIONS(2354),
    [anon_sym_inout] = ACTIONS(2354),
    [anon_sym_virtual] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym___attribute__] = ACTIONS(2354),
    [anon_sym___attribute] = ACTIONS(2354),
    [anon_sym_using] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2356),
    [anon_sym___declspec] = ACTIONS(2354),
    [anon_sym___based] = ACTIONS(2354),
    [anon_sym___cdecl] = ACTIONS(2354),
    [anon_sym___clrcall] = ACTIONS(2354),
    [anon_sym___stdcall] = ACTIONS(2354),
    [anon_sym___fastcall] = ACTIONS(2354),
    [anon_sym___thiscall] = ACTIONS(2354),
    [anon_sym___vectorcall] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_register] = ACTIONS(2354),
    [anon_sym_inline] = ACTIONS(2354),
    [anon_sym___inline] = ACTIONS(2354),
    [anon_sym___inline__] = ACTIONS(2354),
    [anon_sym___forceinline] = ACTIONS(2354),
    [anon_sym_thread_local] = ACTIONS(2354),
    [anon_sym___thread] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_constexpr] = ACTIONS(2354),
    [anon_sym_volatile] = ACTIONS(2354),
    [anon_sym_restrict] = ACTIONS(2354),
    [anon_sym___restrict__] = ACTIONS(2354),
    [anon_sym__Atomic] = ACTIONS(2354),
    [anon_sym__Noreturn] = ACTIONS(2354),
    [anon_sym_noreturn] = ACTIONS(2354),
    [anon_sym__Nonnull] = ACTIONS(2354),
    [anon_sym_mutable] = ACTIONS(2354),
    [anon_sym_constinit] = ACTIONS(2354),
    [anon_sym_consteval] = ACTIONS(2354),
    [anon_sym_alignas] = ACTIONS(2354),
    [anon_sym__Alignas] = ACTIONS(2354),
    [sym_primitive_type] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_goto] = ACTIONS(2354),
    [anon_sym___try] = ACTIONS(2354),
    [anon_sym___leave] = ACTIONS(2354),
    [anon_sym_not] = ACTIONS(2354),
    [anon_sym_compl] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2354),
    [anon_sym___alignof__] = ACTIONS(2354),
    [anon_sym___alignof] = ACTIONS(2354),
    [anon_sym__alignof] = ACTIONS(2354),
    [anon_sym_alignof] = ACTIONS(2354),
    [anon_sym__Alignof] = ACTIONS(2354),
    [anon_sym_offsetof] = ACTIONS(2354),
    [anon_sym__Generic] = ACTIONS(2354),
    [anon_sym_asm] = ACTIONS(2354),
    [anon_sym___asm__] = ACTIONS(2354),
    [anon_sym___asm] = ACTIONS(2354),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_L_SQUOTE] = ACTIONS(2356),
    [anon_sym_u_SQUOTE] = ACTIONS(2356),
    [anon_sym_U_SQUOTE] = ACTIONS(2356),
    [anon_sym_u8_SQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_L_DQUOTE] = ACTIONS(2356),
    [anon_sym_u_DQUOTE] = ACTIONS(2356),
    [anon_sym_U_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8_DQUOTE] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [anon_sym_NULL] = ACTIONS(2354),
    [anon_sym_nullptr] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2354),
    [anon_sym_decltype] = ACTIONS(2354),
    [anon_sym_explicit] = ACTIONS(2354),
    [anon_sym_typename] = ACTIONS(2354),
    [anon_sym_template] = ACTIONS(2354),
    [anon_sym_operator] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_static_assert] = ACTIONS(2354),
    [anon_sym_concept] = ACTIONS(2354),
    [anon_sym_co_return] = ACTIONS(2354),
    [anon_sym_co_yield] = ACTIONS(2354),
    [anon_sym_R_DQUOTE] = ACTIONS(2356),
    [anon_sym_LR_DQUOTE] = ACTIONS(2356),
    [anon_sym_uR_DQUOTE] = ACTIONS(2356),
    [anon_sym_UR_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2356),
    [anon_sym_co_await] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_requires] = ACTIONS(2354),
    [sym_this] = ACTIONS(2354),
    [anon_sym_discard] = ACTIONS(2354),
    [anon_sym_precise] = ACTIONS(2354),
    [anon_sym_shared] = ACTIONS(2354),
    [anon_sym_groupshared] = ACTIONS(2354),
    [anon_sym_uniform] = ACTIONS(2354),
    [anon_sym_row_major] = ACTIONS(2354),
    [anon_sym_column_major] = ACTIONS(2354),
    [anon_sym_globallycoherent] = ACTIONS(2354),
    [anon_sym_centroid] = ACTIONS(2354),
    [anon_sym_noperspective] = ACTIONS(2354),
    [anon_sym_nointerpolation] = ACTIONS(2354),
    [anon_sym_sample] = ACTIONS(2354),
    [anon_sym_linear] = ACTIONS(2354),
    [anon_sym_snorm] = ACTIONS(2354),
    [anon_sym_unorm] = ACTIONS(2354),
    [anon_sym_point] = ACTIONS(2354),
    [anon_sym_line] = ACTIONS(2354),
    [anon_sym_triangleadj] = ACTIONS(2354),
    [anon_sym_lineadj] = ACTIONS(2354),
    [anon_sym_triangle] = ACTIONS(2354),
    [anon_sym_cbuffer] = ACTIONS(2354),
  },
  [474] = {
    [sym_identifier] = ACTIONS(2358),
    [aux_sym_preproc_include_token1] = ACTIONS(2358),
    [aux_sym_preproc_def_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2358),
    [sym_preproc_directive] = ACTIONS(2358),
    [anon_sym_LPAREN2] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_AMP_AMP] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym___extension__] = ACTIONS(2358),
    [anon_sym_typedef] = ACTIONS(2358),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_out] = ACTIONS(2358),
    [anon_sym_inout] = ACTIONS(2358),
    [anon_sym_virtual] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym___attribute__] = ACTIONS(2358),
    [anon_sym___attribute] = ACTIONS(2358),
    [anon_sym_using] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(2358),
    [anon_sym___based] = ACTIONS(2358),
    [anon_sym___cdecl] = ACTIONS(2358),
    [anon_sym___clrcall] = ACTIONS(2358),
    [anon_sym___stdcall] = ACTIONS(2358),
    [anon_sym___fastcall] = ACTIONS(2358),
    [anon_sym___thiscall] = ACTIONS(2358),
    [anon_sym___vectorcall] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_RBRACE] = ACTIONS(2360),
    [anon_sym_signed] = ACTIONS(2358),
    [anon_sym_unsigned] = ACTIONS(2358),
    [anon_sym_long] = ACTIONS(2358),
    [anon_sym_short] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_register] = ACTIONS(2358),
    [anon_sym_inline] = ACTIONS(2358),
    [anon_sym___inline] = ACTIONS(2358),
    [anon_sym___inline__] = ACTIONS(2358),
    [anon_sym___forceinline] = ACTIONS(2358),
    [anon_sym_thread_local] = ACTIONS(2358),
    [anon_sym___thread] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_constexpr] = ACTIONS(2358),
    [anon_sym_volatile] = ACTIONS(2358),
    [anon_sym_restrict] = ACTIONS(2358),
    [anon_sym___restrict__] = ACTIONS(2358),
    [anon_sym__Atomic] = ACTIONS(2358),
    [anon_sym__Noreturn] = ACTIONS(2358),
    [anon_sym_noreturn] = ACTIONS(2358),
    [anon_sym__Nonnull] = ACTIONS(2358),
    [anon_sym_mutable] = ACTIONS(2358),
    [anon_sym_constinit] = ACTIONS(2358),
    [anon_sym_consteval] = ACTIONS(2358),
    [anon_sym_alignas] = ACTIONS(2358),
    [anon_sym__Alignas] = ACTIONS(2358),
    [sym_primitive_type] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_goto] = ACTIONS(2358),
    [anon_sym___try] = ACTIONS(2358),
    [anon_sym___leave] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_compl] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2358),
    [anon_sym___alignof__] = ACTIONS(2358),
    [anon_sym___alignof] = ACTIONS(2358),
    [anon_sym__alignof] = ACTIONS(2358),
    [anon_sym_alignof] = ACTIONS(2358),
    [anon_sym__Alignof] = ACTIONS(2358),
    [anon_sym_offsetof] = ACTIONS(2358),
    [anon_sym__Generic] = ACTIONS(2358),
    [anon_sym_asm] = ACTIONS(2358),
    [anon_sym___asm__] = ACTIONS(2358),
    [anon_sym___asm] = ACTIONS(2358),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_L_SQUOTE] = ACTIONS(2360),
    [anon_sym_u_SQUOTE] = ACTIONS(2360),
    [anon_sym_U_SQUOTE] = ACTIONS(2360),
    [anon_sym_u8_SQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_L_DQUOTE] = ACTIONS(2360),
    [anon_sym_u_DQUOTE] = ACTIONS(2360),
    [anon_sym_U_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8_DQUOTE] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [anon_sym_NULL] = ACTIONS(2358),
    [anon_sym_nullptr] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2358),
    [anon_sym_decltype] = ACTIONS(2358),
    [anon_sym_explicit] = ACTIONS(2358),
    [anon_sym_typename] = ACTIONS(2358),
    [anon_sym_template] = ACTIONS(2358),
    [anon_sym_operator] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2358),
    [anon_sym_static_assert] = ACTIONS(2358),
    [anon_sym_concept] = ACTIONS(2358),
    [anon_sym_co_return] = ACTIONS(2358),
    [anon_sym_co_yield] = ACTIONS(2358),
    [anon_sym_R_DQUOTE] = ACTIONS(2360),
    [anon_sym_LR_DQUOTE] = ACTIONS(2360),
    [anon_sym_uR_DQUOTE] = ACTIONS(2360),
    [anon_sym_UR_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2360),
    [anon_sym_co_await] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_requires] = ACTIONS(2358),
    [sym_this] = ACTIONS(2358),
    [anon_sym_discard] = ACTIONS(2358),
    [anon_sym_precise] = ACTIONS(2358),
    [anon_sym_shared] = ACTIONS(2358),
    [anon_sym_groupshared] = ACTIONS(2358),
    [anon_sym_uniform] = ACTIONS(2358),
    [anon_sym_row_major] = ACTIONS(2358),
    [anon_sym_column_major] = ACTIONS(2358),
    [anon_sym_globallycoherent] = ACTIONS(2358),
    [anon_sym_centroid] = ACTIONS(2358),
    [anon_sym_noperspective] = ACTIONS(2358),
    [anon_sym_nointerpolation] = ACTIONS(2358),
    [anon_sym_sample] = ACTIONS(2358),
    [anon_sym_linear] = ACTIONS(2358),
    [anon_sym_snorm] = ACTIONS(2358),
    [anon_sym_unorm] = ACTIONS(2358),
    [anon_sym_point] = ACTIONS(2358),
    [anon_sym_line] = ACTIONS(2358),
    [anon_sym_triangleadj] = ACTIONS(2358),
    [anon_sym_lineadj] = ACTIONS(2358),
    [anon_sym_triangle] = ACTIONS(2358),
    [anon_sym_cbuffer] = ACTIONS(2358),
  },
  [475] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_out] = ACTIONS(2362),
    [anon_sym_inout] = ACTIONS(2362),
    [anon_sym_virtual] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym___attribute] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym__Nonnull] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [anon_sym___asm] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_discard] = ACTIONS(2362),
    [anon_sym_precise] = ACTIONS(2362),
    [anon_sym_shared] = ACTIONS(2362),
    [anon_sym_groupshared] = ACTIONS(2362),
    [anon_sym_uniform] = ACTIONS(2362),
    [anon_sym_row_major] = ACTIONS(2362),
    [anon_sym_column_major] = ACTIONS(2362),
    [anon_sym_globallycoherent] = ACTIONS(2362),
    [anon_sym_centroid] = ACTIONS(2362),
    [anon_sym_noperspective] = ACTIONS(2362),
    [anon_sym_nointerpolation] = ACTIONS(2362),
    [anon_sym_sample] = ACTIONS(2362),
    [anon_sym_linear] = ACTIONS(2362),
    [anon_sym_snorm] = ACTIONS(2362),
    [anon_sym_unorm] = ACTIONS(2362),
    [anon_sym_point] = ACTIONS(2362),
    [anon_sym_line] = ACTIONS(2362),
    [anon_sym_triangleadj] = ACTIONS(2362),
    [anon_sym_lineadj] = ACTIONS(2362),
    [anon_sym_triangle] = ACTIONS(2362),
    [anon_sym_cbuffer] = ACTIONS(2362),
  },
  [476] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym_in] = ACTIONS(2366),
    [anon_sym_out] = ACTIONS(2366),
    [anon_sym_inout] = ACTIONS(2366),
    [anon_sym_virtual] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym___attribute] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym__Nonnull] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [anon_sym___asm] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_discard] = ACTIONS(2366),
    [anon_sym_precise] = ACTIONS(2366),
    [anon_sym_shared] = ACTIONS(2366),
    [anon_sym_groupshared] = ACTIONS(2366),
    [anon_sym_uniform] = ACTIONS(2366),
    [anon_sym_row_major] = ACTIONS(2366),
    [anon_sym_column_major] = ACTIONS(2366),
    [anon_sym_globallycoherent] = ACTIONS(2366),
    [anon_sym_centroid] = ACTIONS(2366),
    [anon_sym_noperspective] = ACTIONS(2366),
    [anon_sym_nointerpolation] = ACTIONS(2366),
    [anon_sym_sample] = ACTIONS(2366),
    [anon_sym_linear] = ACTIONS(2366),
    [anon_sym_snorm] = ACTIONS(2366),
    [anon_sym_unorm] = ACTIONS(2366),
    [anon_sym_point] = ACTIONS(2366),
    [anon_sym_line] = ACTIONS(2366),
    [anon_sym_triangleadj] = ACTIONS(2366),
    [anon_sym_lineadj] = ACTIONS(2366),
    [anon_sym_triangle] = ACTIONS(2366),
    [anon_sym_cbuffer] = ACTIONS(2366),
  },
  [477] = {
    [sym_identifier] = ACTIONS(2302),
    [aux_sym_preproc_include_token1] = ACTIONS(2302),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token2] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2302),
    [sym_preproc_directive] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_PLUS] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym_typedef] = ACTIONS(2302),
    [anon_sym_in] = ACTIONS(2302),
    [anon_sym_out] = ACTIONS(2302),
    [anon_sym_inout] = ACTIONS(2302),
    [anon_sym_virtual] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2302),
    [anon_sym_using] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2304),
    [anon_sym___declspec] = ACTIONS(2302),
    [anon_sym___based] = ACTIONS(2302),
    [anon_sym___cdecl] = ACTIONS(2302),
    [anon_sym___clrcall] = ACTIONS(2302),
    [anon_sym___stdcall] = ACTIONS(2302),
    [anon_sym___fastcall] = ACTIONS(2302),
    [anon_sym___thiscall] = ACTIONS(2302),
    [anon_sym___vectorcall] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2302),
    [anon_sym_unsigned] = ACTIONS(2302),
    [anon_sym_long] = ACTIONS(2302),
    [anon_sym_short] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2302),
    [anon_sym_inline] = ACTIONS(2302),
    [anon_sym___inline] = ACTIONS(2302),
    [anon_sym___inline__] = ACTIONS(2302),
    [anon_sym___forceinline] = ACTIONS(2302),
    [anon_sym_thread_local] = ACTIONS(2302),
    [anon_sym___thread] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [sym_primitive_type] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_class] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2302),
    [anon_sym_default] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_goto] = ACTIONS(2302),
    [anon_sym___try] = ACTIONS(2302),
    [anon_sym___leave] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2302),
    [anon_sym_compl] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2302),
    [anon_sym___alignof__] = ACTIONS(2302),
    [anon_sym___alignof] = ACTIONS(2302),
    [anon_sym__alignof] = ACTIONS(2302),
    [anon_sym_alignof] = ACTIONS(2302),
    [anon_sym__Alignof] = ACTIONS(2302),
    [anon_sym_offsetof] = ACTIONS(2302),
    [anon_sym__Generic] = ACTIONS(2302),
    [anon_sym_asm] = ACTIONS(2302),
    [anon_sym___asm__] = ACTIONS(2302),
    [anon_sym___asm] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2304),
    [anon_sym_L_SQUOTE] = ACTIONS(2304),
    [anon_sym_u_SQUOTE] = ACTIONS(2304),
    [anon_sym_U_SQUOTE] = ACTIONS(2304),
    [anon_sym_u8_SQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_L_DQUOTE] = ACTIONS(2304),
    [anon_sym_u_DQUOTE] = ACTIONS(2304),
    [anon_sym_U_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8_DQUOTE] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [anon_sym_NULL] = ACTIONS(2302),
    [anon_sym_nullptr] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2302),
    [anon_sym_decltype] = ACTIONS(2302),
    [anon_sym_explicit] = ACTIONS(2302),
    [anon_sym_typename] = ACTIONS(2302),
    [anon_sym_template] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [anon_sym_delete] = ACTIONS(2302),
    [anon_sym_throw] = ACTIONS(2302),
    [anon_sym_namespace] = ACTIONS(2302),
    [anon_sym_static_assert] = ACTIONS(2302),
    [anon_sym_concept] = ACTIONS(2302),
    [anon_sym_co_return] = ACTIONS(2302),
    [anon_sym_co_yield] = ACTIONS(2302),
    [anon_sym_R_DQUOTE] = ACTIONS(2304),
    [anon_sym_LR_DQUOTE] = ACTIONS(2304),
    [anon_sym_uR_DQUOTE] = ACTIONS(2304),
    [anon_sym_UR_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2304),
    [anon_sym_co_await] = ACTIONS(2302),
    [anon_sym_new] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2302),
    [sym_this] = ACTIONS(2302),
    [anon_sym_discard] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2302),
    [anon_sym_shared] = ACTIONS(2302),
    [anon_sym_groupshared] = ACTIONS(2302),
    [anon_sym_uniform] = ACTIONS(2302),
    [anon_sym_row_major] = ACTIONS(2302),
    [anon_sym_column_major] = ACTIONS(2302),
    [anon_sym_globallycoherent] = ACTIONS(2302),
    [anon_sym_centroid] = ACTIONS(2302),
    [anon_sym_noperspective] = ACTIONS(2302),
    [anon_sym_nointerpolation] = ACTIONS(2302),
    [anon_sym_sample] = ACTIONS(2302),
    [anon_sym_linear] = ACTIONS(2302),
    [anon_sym_snorm] = ACTIONS(2302),
    [anon_sym_unorm] = ACTIONS(2302),
    [anon_sym_point] = ACTIONS(2302),
    [anon_sym_line] = ACTIONS(2302),
    [anon_sym_triangleadj] = ACTIONS(2302),
    [anon_sym_lineadj] = ACTIONS(2302),
    [anon_sym_triangle] = ACTIONS(2302),
    [anon_sym_cbuffer] = ACTIONS(2302),
  },
  [478] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym_in] = ACTIONS(2370),
    [anon_sym_out] = ACTIONS(2370),
    [anon_sym_inout] = ACTIONS(2370),
    [anon_sym_virtual] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym___attribute] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym__Nonnull] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [anon_sym___asm] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym_discard] = ACTIONS(2370),
    [anon_sym_precise] = ACTIONS(2370),
    [anon_sym_shared] = ACTIONS(2370),
    [anon_sym_groupshared] = ACTIONS(2370),
    [anon_sym_uniform] = ACTIONS(2370),
    [anon_sym_row_major] = ACTIONS(2370),
    [anon_sym_column_major] = ACTIONS(2370),
    [anon_sym_globallycoherent] = ACTIONS(2370),
    [anon_sym_centroid] = ACTIONS(2370),
    [anon_sym_noperspective] = ACTIONS(2370),
    [anon_sym_nointerpolation] = ACTIONS(2370),
    [anon_sym_sample] = ACTIONS(2370),
    [anon_sym_linear] = ACTIONS(2370),
    [anon_sym_snorm] = ACTIONS(2370),
    [anon_sym_unorm] = ACTIONS(2370),
    [anon_sym_point] = ACTIONS(2370),
    [anon_sym_line] = ACTIONS(2370),
    [anon_sym_triangleadj] = ACTIONS(2370),
    [anon_sym_lineadj] = ACTIONS(2370),
    [anon_sym_triangle] = ACTIONS(2370),
    [anon_sym_cbuffer] = ACTIONS(2370),
  },
  [479] = {
    [sym_identifier] = ACTIONS(2306),
    [aux_sym_preproc_include_token1] = ACTIONS(2306),
    [aux_sym_preproc_def_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token1] = ACTIONS(2306),
    [aux_sym_preproc_if_token2] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2306),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2306),
    [sym_preproc_directive] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AMP_AMP] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym_typedef] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_out] = ACTIONS(2306),
    [anon_sym_inout] = ACTIONS(2306),
    [anon_sym_virtual] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2306),
    [anon_sym_using] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2308),
    [anon_sym___declspec] = ACTIONS(2306),
    [anon_sym___based] = ACTIONS(2306),
    [anon_sym___cdecl] = ACTIONS(2306),
    [anon_sym___clrcall] = ACTIONS(2306),
    [anon_sym___stdcall] = ACTIONS(2306),
    [anon_sym___fastcall] = ACTIONS(2306),
    [anon_sym___thiscall] = ACTIONS(2306),
    [anon_sym___vectorcall] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym___inline] = ACTIONS(2306),
    [anon_sym___inline__] = ACTIONS(2306),
    [anon_sym___forceinline] = ACTIONS(2306),
    [anon_sym_thread_local] = ACTIONS(2306),
    [anon_sym___thread] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_class] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_case] = ACTIONS(2306),
    [anon_sym_default] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_goto] = ACTIONS(2306),
    [anon_sym___try] = ACTIONS(2306),
    [anon_sym___leave] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2306),
    [anon_sym_compl] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2306),
    [anon_sym___alignof__] = ACTIONS(2306),
    [anon_sym___alignof] = ACTIONS(2306),
    [anon_sym__alignof] = ACTIONS(2306),
    [anon_sym_alignof] = ACTIONS(2306),
    [anon_sym__Alignof] = ACTIONS(2306),
    [anon_sym_offsetof] = ACTIONS(2306),
    [anon_sym__Generic] = ACTIONS(2306),
    [anon_sym_asm] = ACTIONS(2306),
    [anon_sym___asm__] = ACTIONS(2306),
    [anon_sym___asm] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2308),
    [anon_sym_L_SQUOTE] = ACTIONS(2308),
    [anon_sym_u_SQUOTE] = ACTIONS(2308),
    [anon_sym_U_SQUOTE] = ACTIONS(2308),
    [anon_sym_u8_SQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_L_DQUOTE] = ACTIONS(2308),
    [anon_sym_u_DQUOTE] = ACTIONS(2308),
    [anon_sym_U_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8_DQUOTE] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [anon_sym_NULL] = ACTIONS(2306),
    [anon_sym_nullptr] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2306),
    [anon_sym_decltype] = ACTIONS(2306),
    [anon_sym_explicit] = ACTIONS(2306),
    [anon_sym_typename] = ACTIONS(2306),
    [anon_sym_template] = ACTIONS(2306),
    [anon_sym_operator] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [anon_sym_delete] = ACTIONS(2306),
    [anon_sym_throw] = ACTIONS(2306),
    [anon_sym_namespace] = ACTIONS(2306),
    [anon_sym_static_assert] = ACTIONS(2306),
    [anon_sym_concept] = ACTIONS(2306),
    [anon_sym_co_return] = ACTIONS(2306),
    [anon_sym_co_yield] = ACTIONS(2306),
    [anon_sym_R_DQUOTE] = ACTIONS(2308),
    [anon_sym_LR_DQUOTE] = ACTIONS(2308),
    [anon_sym_uR_DQUOTE] = ACTIONS(2308),
    [anon_sym_UR_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2308),
    [anon_sym_co_await] = ACTIONS(2306),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2306),
    [sym_this] = ACTIONS(2306),
    [anon_sym_discard] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2306),
    [anon_sym_shared] = ACTIONS(2306),
    [anon_sym_groupshared] = ACTIONS(2306),
    [anon_sym_uniform] = ACTIONS(2306),
    [anon_sym_row_major] = ACTIONS(2306),
    [anon_sym_column_major] = ACTIONS(2306),
    [anon_sym_globallycoherent] = ACTIONS(2306),
    [anon_sym_centroid] = ACTIONS(2306),
    [anon_sym_noperspective] = ACTIONS(2306),
    [anon_sym_nointerpolation] = ACTIONS(2306),
    [anon_sym_sample] = ACTIONS(2306),
    [anon_sym_linear] = ACTIONS(2306),
    [anon_sym_snorm] = ACTIONS(2306),
    [anon_sym_unorm] = ACTIONS(2306),
    [anon_sym_point] = ACTIONS(2306),
    [anon_sym_line] = ACTIONS(2306),
    [anon_sym_triangleadj] = ACTIONS(2306),
    [anon_sym_lineadj] = ACTIONS(2306),
    [anon_sym_triangle] = ACTIONS(2306),
    [anon_sym_cbuffer] = ACTIONS(2306),
  },
  [480] = {
    [sym_identifier] = ACTIONS(2310),
    [aux_sym_preproc_include_token1] = ACTIONS(2310),
    [aux_sym_preproc_def_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token1] = ACTIONS(2310),
    [aux_sym_preproc_if_token2] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2310),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2310),
    [sym_preproc_directive] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_AMP_AMP] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym_typedef] = ACTIONS(2310),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_out] = ACTIONS(2310),
    [anon_sym_inout] = ACTIONS(2310),
    [anon_sym_virtual] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2310),
    [anon_sym_using] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2312),
    [anon_sym___declspec] = ACTIONS(2310),
    [anon_sym___based] = ACTIONS(2310),
    [anon_sym___cdecl] = ACTIONS(2310),
    [anon_sym___clrcall] = ACTIONS(2310),
    [anon_sym___stdcall] = ACTIONS(2310),
    [anon_sym___fastcall] = ACTIONS(2310),
    [anon_sym___thiscall] = ACTIONS(2310),
    [anon_sym___vectorcall] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2310),
    [anon_sym_unsigned] = ACTIONS(2310),
    [anon_sym_long] = ACTIONS(2310),
    [anon_sym_short] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2310),
    [anon_sym_inline] = ACTIONS(2310),
    [anon_sym___inline] = ACTIONS(2310),
    [anon_sym___inline__] = ACTIONS(2310),
    [anon_sym___forceinline] = ACTIONS(2310),
    [anon_sym_thread_local] = ACTIONS(2310),
    [anon_sym___thread] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [sym_primitive_type] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_class] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2310),
    [anon_sym_switch] = ACTIONS(2310),
    [anon_sym_case] = ACTIONS(2310),
    [anon_sym_default] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_goto] = ACTIONS(2310),
    [anon_sym___try] = ACTIONS(2310),
    [anon_sym___leave] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_compl] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2310),
    [anon_sym___alignof__] = ACTIONS(2310),
    [anon_sym___alignof] = ACTIONS(2310),
    [anon_sym__alignof] = ACTIONS(2310),
    [anon_sym_alignof] = ACTIONS(2310),
    [anon_sym__Alignof] = ACTIONS(2310),
    [anon_sym_offsetof] = ACTIONS(2310),
    [anon_sym__Generic] = ACTIONS(2310),
    [anon_sym_asm] = ACTIONS(2310),
    [anon_sym___asm__] = ACTIONS(2310),
    [anon_sym___asm] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2312),
    [anon_sym_L_SQUOTE] = ACTIONS(2312),
    [anon_sym_u_SQUOTE] = ACTIONS(2312),
    [anon_sym_U_SQUOTE] = ACTIONS(2312),
    [anon_sym_u8_SQUOTE] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_L_DQUOTE] = ACTIONS(2312),
    [anon_sym_u_DQUOTE] = ACTIONS(2312),
    [anon_sym_U_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [anon_sym_NULL] = ACTIONS(2310),
    [anon_sym_nullptr] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2310),
    [anon_sym_decltype] = ACTIONS(2310),
    [anon_sym_explicit] = ACTIONS(2310),
    [anon_sym_typename] = ACTIONS(2310),
    [anon_sym_template] = ACTIONS(2310),
    [anon_sym_operator] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [anon_sym_delete] = ACTIONS(2310),
    [anon_sym_throw] = ACTIONS(2310),
    [anon_sym_namespace] = ACTIONS(2310),
    [anon_sym_static_assert] = ACTIONS(2310),
    [anon_sym_concept] = ACTIONS(2310),
    [anon_sym_co_return] = ACTIONS(2310),
    [anon_sym_co_yield] = ACTIONS(2310),
    [anon_sym_R_DQUOTE] = ACTIONS(2312),
    [anon_sym_LR_DQUOTE] = ACTIONS(2312),
    [anon_sym_uR_DQUOTE] = ACTIONS(2312),
    [anon_sym_UR_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2312),
    [anon_sym_co_await] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2310),
    [sym_this] = ACTIONS(2310),
    [anon_sym_discard] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2310),
    [anon_sym_shared] = ACTIONS(2310),
    [anon_sym_groupshared] = ACTIONS(2310),
    [anon_sym_uniform] = ACTIONS(2310),
    [anon_sym_row_major] = ACTIONS(2310),
    [anon_sym_column_major] = ACTIONS(2310),
    [anon_sym_globallycoherent] = ACTIONS(2310),
    [anon_sym_centroid] = ACTIONS(2310),
    [anon_sym_noperspective] = ACTIONS(2310),
    [anon_sym_nointerpolation] = ACTIONS(2310),
    [anon_sym_sample] = ACTIONS(2310),
    [anon_sym_linear] = ACTIONS(2310),
    [anon_sym_snorm] = ACTIONS(2310),
    [anon_sym_unorm] = ACTIONS(2310),
    [anon_sym_point] = ACTIONS(2310),
    [anon_sym_line] = ACTIONS(2310),
    [anon_sym_triangleadj] = ACTIONS(2310),
    [anon_sym_lineadj] = ACTIONS(2310),
    [anon_sym_triangle] = ACTIONS(2310),
    [anon_sym_cbuffer] = ACTIONS(2310),
  },
  [481] = {
    [sym_identifier] = ACTIONS(2314),
    [aux_sym_preproc_include_token1] = ACTIONS(2314),
    [aux_sym_preproc_def_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token1] = ACTIONS(2314),
    [aux_sym_preproc_if_token2] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2314),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2314),
    [sym_preproc_directive] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP_AMP] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym_typedef] = ACTIONS(2314),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_out] = ACTIONS(2314),
    [anon_sym_inout] = ACTIONS(2314),
    [anon_sym_virtual] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2314),
    [anon_sym_using] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2316),
    [anon_sym___declspec] = ACTIONS(2314),
    [anon_sym___based] = ACTIONS(2314),
    [anon_sym___cdecl] = ACTIONS(2314),
    [anon_sym___clrcall] = ACTIONS(2314),
    [anon_sym___stdcall] = ACTIONS(2314),
    [anon_sym___fastcall] = ACTIONS(2314),
    [anon_sym___thiscall] = ACTIONS(2314),
    [anon_sym___vectorcall] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_signed] = ACTIONS(2314),
    [anon_sym_unsigned] = ACTIONS(2314),
    [anon_sym_long] = ACTIONS(2314),
    [anon_sym_short] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym___inline] = ACTIONS(2314),
    [anon_sym___inline__] = ACTIONS(2314),
    [anon_sym___forceinline] = ACTIONS(2314),
    [anon_sym_thread_local] = ACTIONS(2314),
    [anon_sym___thread] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [sym_primitive_type] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2314),
    [anon_sym_default] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_goto] = ACTIONS(2314),
    [anon_sym___try] = ACTIONS(2314),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_compl] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2314),
    [anon_sym___alignof__] = ACTIONS(2314),
    [anon_sym___alignof] = ACTIONS(2314),
    [anon_sym__alignof] = ACTIONS(2314),
    [anon_sym_alignof] = ACTIONS(2314),
    [anon_sym__Alignof] = ACTIONS(2314),
    [anon_sym_offsetof] = ACTIONS(2314),
    [anon_sym__Generic] = ACTIONS(2314),
    [anon_sym_asm] = ACTIONS(2314),
    [anon_sym___asm__] = ACTIONS(2314),
    [anon_sym___asm] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_L_SQUOTE] = ACTIONS(2316),
    [anon_sym_u_SQUOTE] = ACTIONS(2316),
    [anon_sym_U_SQUOTE] = ACTIONS(2316),
    [anon_sym_u8_SQUOTE] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_L_DQUOTE] = ACTIONS(2316),
    [anon_sym_u_DQUOTE] = ACTIONS(2316),
    [anon_sym_U_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8_DQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [anon_sym_NULL] = ACTIONS(2314),
    [anon_sym_nullptr] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2314),
    [anon_sym_decltype] = ACTIONS(2314),
    [anon_sym_explicit] = ACTIONS(2314),
    [anon_sym_typename] = ACTIONS(2314),
    [anon_sym_template] = ACTIONS(2314),
    [anon_sym_operator] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_namespace] = ACTIONS(2314),
    [anon_sym_static_assert] = ACTIONS(2314),
    [anon_sym_concept] = ACTIONS(2314),
    [anon_sym_co_return] = ACTIONS(2314),
    [anon_sym_co_yield] = ACTIONS(2314),
    [anon_sym_R_DQUOTE] = ACTIONS(2316),
    [anon_sym_LR_DQUOTE] = ACTIONS(2316),
    [anon_sym_uR_DQUOTE] = ACTIONS(2316),
    [anon_sym_UR_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2316),
    [anon_sym_co_await] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_discard] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2314),
    [anon_sym_shared] = ACTIONS(2314),
    [anon_sym_groupshared] = ACTIONS(2314),
    [anon_sym_uniform] = ACTIONS(2314),
    [anon_sym_row_major] = ACTIONS(2314),
    [anon_sym_column_major] = ACTIONS(2314),
    [anon_sym_globallycoherent] = ACTIONS(2314),
    [anon_sym_centroid] = ACTIONS(2314),
    [anon_sym_noperspective] = ACTIONS(2314),
    [anon_sym_nointerpolation] = ACTIONS(2314),
    [anon_sym_sample] = ACTIONS(2314),
    [anon_sym_linear] = ACTIONS(2314),
    [anon_sym_snorm] = ACTIONS(2314),
    [anon_sym_unorm] = ACTIONS(2314),
    [anon_sym_point] = ACTIONS(2314),
    [anon_sym_line] = ACTIONS(2314),
    [anon_sym_triangleadj] = ACTIONS(2314),
    [anon_sym_lineadj] = ACTIONS(2314),
    [anon_sym_triangle] = ACTIONS(2314),
    [anon_sym_cbuffer] = ACTIONS(2314),
  },
  [482] = {
    [sym_identifier] = ACTIONS(2318),
    [aux_sym_preproc_include_token1] = ACTIONS(2318),
    [aux_sym_preproc_def_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token1] = ACTIONS(2318),
    [aux_sym_preproc_if_token2] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2318),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2318),
    [sym_preproc_directive] = ACTIONS(2318),
    [anon_sym_LPAREN2] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_AMP_AMP] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym___extension__] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_in] = ACTIONS(2318),
    [anon_sym_out] = ACTIONS(2318),
    [anon_sym_inout] = ACTIONS(2318),
    [anon_sym_virtual] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym___attribute__] = ACTIONS(2318),
    [anon_sym___attribute] = ACTIONS(2318),
    [anon_sym_using] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2320),
    [anon_sym___declspec] = ACTIONS(2318),
    [anon_sym___based] = ACTIONS(2318),
    [anon_sym___cdecl] = ACTIONS(2318),
    [anon_sym___clrcall] = ACTIONS(2318),
    [anon_sym___stdcall] = ACTIONS(2318),
    [anon_sym___fastcall] = ACTIONS(2318),
    [anon_sym___thiscall] = ACTIONS(2318),
    [anon_sym___vectorcall] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_signed] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym___inline] = ACTIONS(2318),
    [anon_sym___inline__] = ACTIONS(2318),
    [anon_sym___forceinline] = ACTIONS(2318),
    [anon_sym_thread_local] = ACTIONS(2318),
    [anon_sym___thread] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_constexpr] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym___restrict__] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym__Noreturn] = ACTIONS(2318),
    [anon_sym_noreturn] = ACTIONS(2318),
    [anon_sym__Nonnull] = ACTIONS(2318),
    [anon_sym_mutable] = ACTIONS(2318),
    [anon_sym_constinit] = ACTIONS(2318),
    [anon_sym_consteval] = ACTIONS(2318),
    [anon_sym_alignas] = ACTIONS(2318),
    [anon_sym__Alignas] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_class] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2318),
    [anon_sym_default] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym___try] = ACTIONS(2318),
    [anon_sym___leave] = ACTIONS(2318),
    [anon_sym_not] = ACTIONS(2318),
    [anon_sym_compl] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2318),
    [anon_sym___alignof__] = ACTIONS(2318),
    [anon_sym___alignof] = ACTIONS(2318),
    [anon_sym__alignof] = ACTIONS(2318),
    [anon_sym_alignof] = ACTIONS(2318),
    [anon_sym__Alignof] = ACTIONS(2318),
    [anon_sym_offsetof] = ACTIONS(2318),
    [anon_sym__Generic] = ACTIONS(2318),
    [anon_sym_asm] = ACTIONS(2318),
    [anon_sym___asm__] = ACTIONS(2318),
    [anon_sym___asm] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2320),
    [anon_sym_L_SQUOTE] = ACTIONS(2320),
    [anon_sym_u_SQUOTE] = ACTIONS(2320),
    [anon_sym_U_SQUOTE] = ACTIONS(2320),
    [anon_sym_u8_SQUOTE] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_L_DQUOTE] = ACTIONS(2320),
    [anon_sym_u_DQUOTE] = ACTIONS(2320),
    [anon_sym_U_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8_DQUOTE] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(2320),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [anon_sym_NULL] = ACTIONS(2318),
    [anon_sym_nullptr] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2318),
    [anon_sym_decltype] = ACTIONS(2318),
    [anon_sym_explicit] = ACTIONS(2318),
    [anon_sym_typename] = ACTIONS(2318),
    [anon_sym_template] = ACTIONS(2318),
    [anon_sym_operator] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [anon_sym_delete] = ACTIONS(2318),
    [anon_sym_throw] = ACTIONS(2318),
    [anon_sym_namespace] = ACTIONS(2318),
    [anon_sym_static_assert] = ACTIONS(2318),
    [anon_sym_concept] = ACTIONS(2318),
    [anon_sym_co_return] = ACTIONS(2318),
    [anon_sym_co_yield] = ACTIONS(2318),
    [anon_sym_R_DQUOTE] = ACTIONS(2320),
    [anon_sym_LR_DQUOTE] = ACTIONS(2320),
    [anon_sym_uR_DQUOTE] = ACTIONS(2320),
    [anon_sym_UR_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2320),
    [anon_sym_co_await] = ACTIONS(2318),
    [anon_sym_new] = ACTIONS(2318),
    [anon_sym_requires] = ACTIONS(2318),
    [sym_this] = ACTIONS(2318),
    [anon_sym_discard] = ACTIONS(2318),
    [anon_sym_precise] = ACTIONS(2318),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_groupshared] = ACTIONS(2318),
    [anon_sym_uniform] = ACTIONS(2318),
    [anon_sym_row_major] = ACTIONS(2318),
    [anon_sym_column_major] = ACTIONS(2318),
    [anon_sym_globallycoherent] = ACTIONS(2318),
    [anon_sym_centroid] = ACTIONS(2318),
    [anon_sym_noperspective] = ACTIONS(2318),
    [anon_sym_nointerpolation] = ACTIONS(2318),
    [anon_sym_sample] = ACTIONS(2318),
    [anon_sym_linear] = ACTIONS(2318),
    [anon_sym_snorm] = ACTIONS(2318),
    [anon_sym_unorm] = ACTIONS(2318),
    [anon_sym_point] = ACTIONS(2318),
    [anon_sym_line] = ACTIONS(2318),
    [anon_sym_triangleadj] = ACTIONS(2318),
    [anon_sym_lineadj] = ACTIONS(2318),
    [anon_sym_triangle] = ACTIONS(2318),
    [anon_sym_cbuffer] = ACTIONS(2318),
  },
  [483] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [484] = {
    [sym_identifier] = ACTIONS(2326),
    [aux_sym_preproc_include_token1] = ACTIONS(2326),
    [aux_sym_preproc_def_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token1] = ACTIONS(2326),
    [aux_sym_preproc_if_token2] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2326),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2326),
    [sym_preproc_directive] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_out] = ACTIONS(2326),
    [anon_sym_inout] = ACTIONS(2326),
    [anon_sym_virtual] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym___attribute] = ACTIONS(2326),
    [anon_sym_using] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym___based] = ACTIONS(2326),
    [anon_sym___cdecl] = ACTIONS(2326),
    [anon_sym___clrcall] = ACTIONS(2326),
    [anon_sym___stdcall] = ACTIONS(2326),
    [anon_sym___fastcall] = ACTIONS(2326),
    [anon_sym___thiscall] = ACTIONS(2326),
    [anon_sym___vectorcall] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym__Nonnull] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [anon_sym___asm] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [anon_sym_explicit] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_operator] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_static_assert] = ACTIONS(2326),
    [anon_sym_concept] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym_discard] = ACTIONS(2326),
    [anon_sym_precise] = ACTIONS(2326),
    [anon_sym_shared] = ACTIONS(2326),
    [anon_sym_groupshared] = ACTIONS(2326),
    [anon_sym_uniform] = ACTIONS(2326),
    [anon_sym_row_major] = ACTIONS(2326),
    [anon_sym_column_major] = ACTIONS(2326),
    [anon_sym_globallycoherent] = ACTIONS(2326),
    [anon_sym_centroid] = ACTIONS(2326),
    [anon_sym_noperspective] = ACTIONS(2326),
    [anon_sym_nointerpolation] = ACTIONS(2326),
    [anon_sym_sample] = ACTIONS(2326),
    [anon_sym_linear] = ACTIONS(2326),
    [anon_sym_snorm] = ACTIONS(2326),
    [anon_sym_unorm] = ACTIONS(2326),
    [anon_sym_point] = ACTIONS(2326),
    [anon_sym_line] = ACTIONS(2326),
    [anon_sym_triangleadj] = ACTIONS(2326),
    [anon_sym_lineadj] = ACTIONS(2326),
    [anon_sym_triangle] = ACTIONS(2326),
    [anon_sym_cbuffer] = ACTIONS(2326),
  },
  [485] = {
    [sym_identifier] = ACTIONS(2330),
    [aux_sym_preproc_include_token1] = ACTIONS(2330),
    [aux_sym_preproc_def_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token1] = ACTIONS(2330),
    [aux_sym_preproc_if_token2] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2330),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2330),
    [sym_preproc_directive] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP_AMP] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_out] = ACTIONS(2330),
    [anon_sym_inout] = ACTIONS(2330),
    [anon_sym_virtual] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym___attribute] = ACTIONS(2330),
    [anon_sym_using] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym___based] = ACTIONS(2330),
    [anon_sym___cdecl] = ACTIONS(2330),
    [anon_sym___clrcall] = ACTIONS(2330),
    [anon_sym___stdcall] = ACTIONS(2330),
    [anon_sym___fastcall] = ACTIONS(2330),
    [anon_sym___thiscall] = ACTIONS(2330),
    [anon_sym___vectorcall] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym__Nonnull] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [anon_sym___asm] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [anon_sym_explicit] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_operator] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_static_assert] = ACTIONS(2330),
    [anon_sym_concept] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym_discard] = ACTIONS(2330),
    [anon_sym_precise] = ACTIONS(2330),
    [anon_sym_shared] = ACTIONS(2330),
    [anon_sym_groupshared] = ACTIONS(2330),
    [anon_sym_uniform] = ACTIONS(2330),
    [anon_sym_row_major] = ACTIONS(2330),
    [anon_sym_column_major] = ACTIONS(2330),
    [anon_sym_globallycoherent] = ACTIONS(2330),
    [anon_sym_centroid] = ACTIONS(2330),
    [anon_sym_noperspective] = ACTIONS(2330),
    [anon_sym_nointerpolation] = ACTIONS(2330),
    [anon_sym_sample] = ACTIONS(2330),
    [anon_sym_linear] = ACTIONS(2330),
    [anon_sym_snorm] = ACTIONS(2330),
    [anon_sym_unorm] = ACTIONS(2330),
    [anon_sym_point] = ACTIONS(2330),
    [anon_sym_line] = ACTIONS(2330),
    [anon_sym_triangleadj] = ACTIONS(2330),
    [anon_sym_lineadj] = ACTIONS(2330),
    [anon_sym_triangle] = ACTIONS(2330),
    [anon_sym_cbuffer] = ACTIONS(2330),
  },
  [486] = {
    [sym_identifier] = ACTIONS(2334),
    [aux_sym_preproc_include_token1] = ACTIONS(2334),
    [aux_sym_preproc_def_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token1] = ACTIONS(2334),
    [aux_sym_preproc_if_token2] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2334),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2334),
    [sym_preproc_directive] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP_AMP] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym_in] = ACTIONS(2334),
    [anon_sym_out] = ACTIONS(2334),
    [anon_sym_inout] = ACTIONS(2334),
    [anon_sym_virtual] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym___attribute] = ACTIONS(2334),
    [anon_sym_using] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym___based] = ACTIONS(2334),
    [anon_sym___cdecl] = ACTIONS(2334),
    [anon_sym___clrcall] = ACTIONS(2334),
    [anon_sym___stdcall] = ACTIONS(2334),
    [anon_sym___fastcall] = ACTIONS(2334),
    [anon_sym___thiscall] = ACTIONS(2334),
    [anon_sym___vectorcall] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym__Nonnull] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2334),
    [anon_sym_default] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [anon_sym___asm] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [anon_sym_explicit] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_operator] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_namespace] = ACTIONS(2334),
    [anon_sym_static_assert] = ACTIONS(2334),
    [anon_sym_concept] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym_discard] = ACTIONS(2334),
    [anon_sym_precise] = ACTIONS(2334),
    [anon_sym_shared] = ACTIONS(2334),
    [anon_sym_groupshared] = ACTIONS(2334),
    [anon_sym_uniform] = ACTIONS(2334),
    [anon_sym_row_major] = ACTIONS(2334),
    [anon_sym_column_major] = ACTIONS(2334),
    [anon_sym_globallycoherent] = ACTIONS(2334),
    [anon_sym_centroid] = ACTIONS(2334),
    [anon_sym_noperspective] = ACTIONS(2334),
    [anon_sym_nointerpolation] = ACTIONS(2334),
    [anon_sym_sample] = ACTIONS(2334),
    [anon_sym_linear] = ACTIONS(2334),
    [anon_sym_snorm] = ACTIONS(2334),
    [anon_sym_unorm] = ACTIONS(2334),
    [anon_sym_point] = ACTIONS(2334),
    [anon_sym_line] = ACTIONS(2334),
    [anon_sym_triangleadj] = ACTIONS(2334),
    [anon_sym_lineadj] = ACTIONS(2334),
    [anon_sym_triangle] = ACTIONS(2334),
    [anon_sym_cbuffer] = ACTIONS(2334),
  },
  [487] = {
    [sym_identifier] = ACTIONS(2338),
    [aux_sym_preproc_include_token1] = ACTIONS(2338),
    [aux_sym_preproc_def_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token1] = ACTIONS(2338),
    [aux_sym_preproc_if_token2] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2338),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2338),
    [sym_preproc_directive] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP_AMP] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2338),
    [anon_sym_out] = ACTIONS(2338),
    [anon_sym_inout] = ACTIONS(2338),
    [anon_sym_virtual] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym___attribute] = ACTIONS(2338),
    [anon_sym_using] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym___based] = ACTIONS(2338),
    [anon_sym___cdecl] = ACTIONS(2338),
    [anon_sym___clrcall] = ACTIONS(2338),
    [anon_sym___stdcall] = ACTIONS(2338),
    [anon_sym___fastcall] = ACTIONS(2338),
    [anon_sym___thiscall] = ACTIONS(2338),
    [anon_sym___vectorcall] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym__Nonnull] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_case] = ACTIONS(2338),
    [anon_sym_default] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [anon_sym___asm] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [anon_sym_explicit] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_operator] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_namespace] = ACTIONS(2338),
    [anon_sym_static_assert] = ACTIONS(2338),
    [anon_sym_concept] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym_discard] = ACTIONS(2338),
    [anon_sym_precise] = ACTIONS(2338),
    [anon_sym_shared] = ACTIONS(2338),
    [anon_sym_groupshared] = ACTIONS(2338),
    [anon_sym_uniform] = ACTIONS(2338),
    [anon_sym_row_major] = ACTIONS(2338),
    [anon_sym_column_major] = ACTIONS(2338),
    [anon_sym_globallycoherent] = ACTIONS(2338),
    [anon_sym_centroid] = ACTIONS(2338),
    [anon_sym_noperspective] = ACTIONS(2338),
    [anon_sym_nointerpolation] = ACTIONS(2338),
    [anon_sym_sample] = ACTIONS(2338),
    [anon_sym_linear] = ACTIONS(2338),
    [anon_sym_snorm] = ACTIONS(2338),
    [anon_sym_unorm] = ACTIONS(2338),
    [anon_sym_point] = ACTIONS(2338),
    [anon_sym_line] = ACTIONS(2338),
    [anon_sym_triangleadj] = ACTIONS(2338),
    [anon_sym_lineadj] = ACTIONS(2338),
    [anon_sym_triangle] = ACTIONS(2338),
    [anon_sym_cbuffer] = ACTIONS(2338),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2374),
    [aux_sym_preproc_include_token1] = ACTIONS(2374),
    [aux_sym_preproc_def_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_LPAREN2] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_out] = ACTIONS(2374),
    [anon_sym_inout] = ACTIONS(2374),
    [anon_sym_virtual] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym___attribute__] = ACTIONS(2374),
    [anon_sym___attribute] = ACTIONS(2374),
    [anon_sym_using] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2376),
    [anon_sym___declspec] = ACTIONS(2374),
    [anon_sym___based] = ACTIONS(2374),
    [anon_sym___cdecl] = ACTIONS(2374),
    [anon_sym___clrcall] = ACTIONS(2374),
    [anon_sym___stdcall] = ACTIONS(2374),
    [anon_sym___fastcall] = ACTIONS(2374),
    [anon_sym___thiscall] = ACTIONS(2374),
    [anon_sym___vectorcall] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_signed] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym___inline] = ACTIONS(2374),
    [anon_sym___inline__] = ACTIONS(2374),
    [anon_sym___forceinline] = ACTIONS(2374),
    [anon_sym_thread_local] = ACTIONS(2374),
    [anon_sym___thread] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_constexpr] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym___restrict__] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym__Noreturn] = ACTIONS(2374),
    [anon_sym_noreturn] = ACTIONS(2374),
    [anon_sym__Nonnull] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2374),
    [anon_sym_constinit] = ACTIONS(2374),
    [anon_sym_consteval] = ACTIONS(2374),
    [anon_sym_alignas] = ACTIONS(2374),
    [anon_sym__Alignas] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym___try] = ACTIONS(2374),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2374),
    [anon_sym_compl] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2374),
    [anon_sym___alignof__] = ACTIONS(2374),
    [anon_sym___alignof] = ACTIONS(2374),
    [anon_sym__alignof] = ACTIONS(2374),
    [anon_sym_alignof] = ACTIONS(2374),
    [anon_sym__Alignof] = ACTIONS(2374),
    [anon_sym_offsetof] = ACTIONS(2374),
    [anon_sym__Generic] = ACTIONS(2374),
    [anon_sym_asm] = ACTIONS(2374),
    [anon_sym___asm__] = ACTIONS(2374),
    [anon_sym___asm] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2376),
    [anon_sym_u_DQUOTE] = ACTIONS(2376),
    [anon_sym_U_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8_DQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [anon_sym_NULL] = ACTIONS(2374),
    [anon_sym_nullptr] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2374),
    [anon_sym_decltype] = ACTIONS(2374),
    [anon_sym_explicit] = ACTIONS(2374),
    [anon_sym_typename] = ACTIONS(2374),
    [anon_sym_template] = ACTIONS(2374),
    [anon_sym_operator] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_namespace] = ACTIONS(2374),
    [anon_sym_static_assert] = ACTIONS(2374),
    [anon_sym_concept] = ACTIONS(2374),
    [anon_sym_co_return] = ACTIONS(2374),
    [anon_sym_co_yield] = ACTIONS(2374),
    [anon_sym_R_DQUOTE] = ACTIONS(2376),
    [anon_sym_LR_DQUOTE] = ACTIONS(2376),
    [anon_sym_uR_DQUOTE] = ACTIONS(2376),
    [anon_sym_UR_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2376),
    [anon_sym_co_await] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_requires] = ACTIONS(2374),
    [sym_this] = ACTIONS(2374),
    [anon_sym_discard] = ACTIONS(2374),
    [anon_sym_precise] = ACTIONS(2374),
    [anon_sym_shared] = ACTIONS(2374),
    [anon_sym_groupshared] = ACTIONS(2374),
    [anon_sym_uniform] = ACTIONS(2374),
    [anon_sym_row_major] = ACTIONS(2374),
    [anon_sym_column_major] = ACTIONS(2374),
    [anon_sym_globallycoherent] = ACTIONS(2374),
    [anon_sym_centroid] = ACTIONS(2374),
    [anon_sym_noperspective] = ACTIONS(2374),
    [anon_sym_nointerpolation] = ACTIONS(2374),
    [anon_sym_sample] = ACTIONS(2374),
    [anon_sym_linear] = ACTIONS(2374),
    [anon_sym_snorm] = ACTIONS(2374),
    [anon_sym_unorm] = ACTIONS(2374),
    [anon_sym_point] = ACTIONS(2374),
    [anon_sym_line] = ACTIONS(2374),
    [anon_sym_triangleadj] = ACTIONS(2374),
    [anon_sym_lineadj] = ACTIONS(2374),
    [anon_sym_triangle] = ACTIONS(2374),
    [anon_sym_cbuffer] = ACTIONS(2374),
  },
  [489] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [490] = {
    [sym_identifier] = ACTIONS(2346),
    [aux_sym_preproc_include_token1] = ACTIONS(2346),
    [aux_sym_preproc_def_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token1] = ACTIONS(2346),
    [aux_sym_preproc_if_token2] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2346),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2346),
    [sym_preproc_directive] = ACTIONS(2346),
    [anon_sym_LPAREN2] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_typedef] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_out] = ACTIONS(2346),
    [anon_sym_inout] = ACTIONS(2346),
    [anon_sym_virtual] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym___attribute__] = ACTIONS(2346),
    [anon_sym___attribute] = ACTIONS(2346),
    [anon_sym_using] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2346),
    [anon_sym___based] = ACTIONS(2346),
    [anon_sym___cdecl] = ACTIONS(2346),
    [anon_sym___clrcall] = ACTIONS(2346),
    [anon_sym___stdcall] = ACTIONS(2346),
    [anon_sym___fastcall] = ACTIONS(2346),
    [anon_sym___thiscall] = ACTIONS(2346),
    [anon_sym___vectorcall] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_signed] = ACTIONS(2346),
    [anon_sym_unsigned] = ACTIONS(2346),
    [anon_sym_long] = ACTIONS(2346),
    [anon_sym_short] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_register] = ACTIONS(2346),
    [anon_sym_inline] = ACTIONS(2346),
    [anon_sym___inline] = ACTIONS(2346),
    [anon_sym___inline__] = ACTIONS(2346),
    [anon_sym___forceinline] = ACTIONS(2346),
    [anon_sym_thread_local] = ACTIONS(2346),
    [anon_sym___thread] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_constexpr] = ACTIONS(2346),
    [anon_sym_volatile] = ACTIONS(2346),
    [anon_sym_restrict] = ACTIONS(2346),
    [anon_sym___restrict__] = ACTIONS(2346),
    [anon_sym__Atomic] = ACTIONS(2346),
    [anon_sym__Noreturn] = ACTIONS(2346),
    [anon_sym_noreturn] = ACTIONS(2346),
    [anon_sym__Nonnull] = ACTIONS(2346),
    [anon_sym_mutable] = ACTIONS(2346),
    [anon_sym_constinit] = ACTIONS(2346),
    [anon_sym_consteval] = ACTIONS(2346),
    [anon_sym_alignas] = ACTIONS(2346),
    [anon_sym__Alignas] = ACTIONS(2346),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_goto] = ACTIONS(2346),
    [anon_sym___try] = ACTIONS(2346),
    [anon_sym___leave] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2346),
    [anon_sym_compl] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2346),
    [anon_sym___alignof__] = ACTIONS(2346),
    [anon_sym___alignof] = ACTIONS(2346),
    [anon_sym__alignof] = ACTIONS(2346),
    [anon_sym_alignof] = ACTIONS(2346),
    [anon_sym__Alignof] = ACTIONS(2346),
    [anon_sym_offsetof] = ACTIONS(2346),
    [anon_sym__Generic] = ACTIONS(2346),
    [anon_sym_asm] = ACTIONS(2346),
    [anon_sym___asm__] = ACTIONS(2346),
    [anon_sym___asm] = ACTIONS(2346),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_L_SQUOTE] = ACTIONS(2348),
    [anon_sym_u_SQUOTE] = ACTIONS(2348),
    [anon_sym_U_SQUOTE] = ACTIONS(2348),
    [anon_sym_u8_SQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_L_DQUOTE] = ACTIONS(2348),
    [anon_sym_u_DQUOTE] = ACTIONS(2348),
    [anon_sym_U_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8_DQUOTE] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [anon_sym_NULL] = ACTIONS(2346),
    [anon_sym_nullptr] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_decltype] = ACTIONS(2346),
    [anon_sym_explicit] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2346),
    [anon_sym_template] = ACTIONS(2346),
    [anon_sym_operator] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_static_assert] = ACTIONS(2346),
    [anon_sym_concept] = ACTIONS(2346),
    [anon_sym_co_return] = ACTIONS(2346),
    [anon_sym_co_yield] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(2348),
    [anon_sym_LR_DQUOTE] = ACTIONS(2348),
    [anon_sym_uR_DQUOTE] = ACTIONS(2348),
    [anon_sym_UR_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2348),
    [anon_sym_co_await] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_requires] = ACTIONS(2346),
    [sym_this] = ACTIONS(2346),
    [anon_sym_discard] = ACTIONS(2346),
    [anon_sym_precise] = ACTIONS(2346),
    [anon_sym_shared] = ACTIONS(2346),
    [anon_sym_groupshared] = ACTIONS(2346),
    [anon_sym_uniform] = ACTIONS(2346),
    [anon_sym_row_major] = ACTIONS(2346),
    [anon_sym_column_major] = ACTIONS(2346),
    [anon_sym_globallycoherent] = ACTIONS(2346),
    [anon_sym_centroid] = ACTIONS(2346),
    [anon_sym_noperspective] = ACTIONS(2346),
    [anon_sym_nointerpolation] = ACTIONS(2346),
    [anon_sym_sample] = ACTIONS(2346),
    [anon_sym_linear] = ACTIONS(2346),
    [anon_sym_snorm] = ACTIONS(2346),
    [anon_sym_unorm] = ACTIONS(2346),
    [anon_sym_point] = ACTIONS(2346),
    [anon_sym_line] = ACTIONS(2346),
    [anon_sym_triangleadj] = ACTIONS(2346),
    [anon_sym_lineadj] = ACTIONS(2346),
    [anon_sym_triangle] = ACTIONS(2346),
    [anon_sym_cbuffer] = ACTIONS(2346),
  },
  [491] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [492] = {
    [sym_identifier] = ACTIONS(2350),
    [aux_sym_preproc_include_token1] = ACTIONS(2350),
    [aux_sym_preproc_def_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token1] = ACTIONS(2350),
    [aux_sym_preproc_if_token2] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2350),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2350),
    [sym_preproc_directive] = ACTIONS(2350),
    [anon_sym_LPAREN2] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2350),
    [anon_sym_typedef] = ACTIONS(2350),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_out] = ACTIONS(2350),
    [anon_sym_inout] = ACTIONS(2350),
    [anon_sym_virtual] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym___attribute__] = ACTIONS(2350),
    [anon_sym___attribute] = ACTIONS(2350),
    [anon_sym_using] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2352),
    [anon_sym___declspec] = ACTIONS(2350),
    [anon_sym___based] = ACTIONS(2350),
    [anon_sym___cdecl] = ACTIONS(2350),
    [anon_sym___clrcall] = ACTIONS(2350),
    [anon_sym___stdcall] = ACTIONS(2350),
    [anon_sym___fastcall] = ACTIONS(2350),
    [anon_sym___thiscall] = ACTIONS(2350),
    [anon_sym___vectorcall] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_signed] = ACTIONS(2350),
    [anon_sym_unsigned] = ACTIONS(2350),
    [anon_sym_long] = ACTIONS(2350),
    [anon_sym_short] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_register] = ACTIONS(2350),
    [anon_sym_inline] = ACTIONS(2350),
    [anon_sym___inline] = ACTIONS(2350),
    [anon_sym___inline__] = ACTIONS(2350),
    [anon_sym___forceinline] = ACTIONS(2350),
    [anon_sym_thread_local] = ACTIONS(2350),
    [anon_sym___thread] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym___restrict__] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym__Noreturn] = ACTIONS(2350),
    [anon_sym_noreturn] = ACTIONS(2350),
    [anon_sym__Nonnull] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_constinit] = ACTIONS(2350),
    [anon_sym_consteval] = ACTIONS(2350),
    [anon_sym_alignas] = ACTIONS(2350),
    [anon_sym__Alignas] = ACTIONS(2350),
    [sym_primitive_type] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_goto] = ACTIONS(2350),
    [anon_sym___try] = ACTIONS(2350),
    [anon_sym___leave] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2350),
    [anon_sym_compl] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2350),
    [anon_sym___alignof__] = ACTIONS(2350),
    [anon_sym___alignof] = ACTIONS(2350),
    [anon_sym__alignof] = ACTIONS(2350),
    [anon_sym_alignof] = ACTIONS(2350),
    [anon_sym__Alignof] = ACTIONS(2350),
    [anon_sym_offsetof] = ACTIONS(2350),
    [anon_sym__Generic] = ACTIONS(2350),
    [anon_sym_asm] = ACTIONS(2350),
    [anon_sym___asm__] = ACTIONS(2350),
    [anon_sym___asm] = ACTIONS(2350),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_L_SQUOTE] = ACTIONS(2352),
    [anon_sym_u_SQUOTE] = ACTIONS(2352),
    [anon_sym_U_SQUOTE] = ACTIONS(2352),
    [anon_sym_u8_SQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_L_DQUOTE] = ACTIONS(2352),
    [anon_sym_u_DQUOTE] = ACTIONS(2352),
    [anon_sym_U_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8_DQUOTE] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [anon_sym_NULL] = ACTIONS(2350),
    [anon_sym_nullptr] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2350),
    [anon_sym_decltype] = ACTIONS(2350),
    [anon_sym_explicit] = ACTIONS(2350),
    [anon_sym_typename] = ACTIONS(2350),
    [anon_sym_template] = ACTIONS(2350),
    [anon_sym_operator] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_static_assert] = ACTIONS(2350),
    [anon_sym_concept] = ACTIONS(2350),
    [anon_sym_co_return] = ACTIONS(2350),
    [anon_sym_co_yield] = ACTIONS(2350),
    [anon_sym_R_DQUOTE] = ACTIONS(2352),
    [anon_sym_LR_DQUOTE] = ACTIONS(2352),
    [anon_sym_uR_DQUOTE] = ACTIONS(2352),
    [anon_sym_UR_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2352),
    [anon_sym_co_await] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_requires] = ACTIONS(2350),
    [sym_this] = ACTIONS(2350),
    [anon_sym_discard] = ACTIONS(2350),
    [anon_sym_precise] = ACTIONS(2350),
    [anon_sym_shared] = ACTIONS(2350),
    [anon_sym_groupshared] = ACTIONS(2350),
    [anon_sym_uniform] = ACTIONS(2350),
    [anon_sym_row_major] = ACTIONS(2350),
    [anon_sym_column_major] = ACTIONS(2350),
    [anon_sym_globallycoherent] = ACTIONS(2350),
    [anon_sym_centroid] = ACTIONS(2350),
    [anon_sym_noperspective] = ACTIONS(2350),
    [anon_sym_nointerpolation] = ACTIONS(2350),
    [anon_sym_sample] = ACTIONS(2350),
    [anon_sym_linear] = ACTIONS(2350),
    [anon_sym_snorm] = ACTIONS(2350),
    [anon_sym_unorm] = ACTIONS(2350),
    [anon_sym_point] = ACTIONS(2350),
    [anon_sym_line] = ACTIONS(2350),
    [anon_sym_triangleadj] = ACTIONS(2350),
    [anon_sym_lineadj] = ACTIONS(2350),
    [anon_sym_triangle] = ACTIONS(2350),
    [anon_sym_cbuffer] = ACTIONS(2350),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2354),
    [aux_sym_preproc_include_token1] = ACTIONS(2354),
    [aux_sym_preproc_def_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token1] = ACTIONS(2354),
    [aux_sym_preproc_if_token2] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2354),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2354),
    [sym_preproc_directive] = ACTIONS(2354),
    [anon_sym_LPAREN2] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_AMP_AMP] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2354),
    [anon_sym_typedef] = ACTIONS(2354),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_out] = ACTIONS(2354),
    [anon_sym_inout] = ACTIONS(2354),
    [anon_sym_virtual] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym___attribute__] = ACTIONS(2354),
    [anon_sym___attribute] = ACTIONS(2354),
    [anon_sym_using] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2356),
    [anon_sym___declspec] = ACTIONS(2354),
    [anon_sym___based] = ACTIONS(2354),
    [anon_sym___cdecl] = ACTIONS(2354),
    [anon_sym___clrcall] = ACTIONS(2354),
    [anon_sym___stdcall] = ACTIONS(2354),
    [anon_sym___fastcall] = ACTIONS(2354),
    [anon_sym___thiscall] = ACTIONS(2354),
    [anon_sym___vectorcall] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_register] = ACTIONS(2354),
    [anon_sym_inline] = ACTIONS(2354),
    [anon_sym___inline] = ACTIONS(2354),
    [anon_sym___inline__] = ACTIONS(2354),
    [anon_sym___forceinline] = ACTIONS(2354),
    [anon_sym_thread_local] = ACTIONS(2354),
    [anon_sym___thread] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_constexpr] = ACTIONS(2354),
    [anon_sym_volatile] = ACTIONS(2354),
    [anon_sym_restrict] = ACTIONS(2354),
    [anon_sym___restrict__] = ACTIONS(2354),
    [anon_sym__Atomic] = ACTIONS(2354),
    [anon_sym__Noreturn] = ACTIONS(2354),
    [anon_sym_noreturn] = ACTIONS(2354),
    [anon_sym__Nonnull] = ACTIONS(2354),
    [anon_sym_mutable] = ACTIONS(2354),
    [anon_sym_constinit] = ACTIONS(2354),
    [anon_sym_consteval] = ACTIONS(2354),
    [anon_sym_alignas] = ACTIONS(2354),
    [anon_sym__Alignas] = ACTIONS(2354),
    [sym_primitive_type] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_goto] = ACTIONS(2354),
    [anon_sym___try] = ACTIONS(2354),
    [anon_sym___leave] = ACTIONS(2354),
    [anon_sym_not] = ACTIONS(2354),
    [anon_sym_compl] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2354),
    [anon_sym___alignof__] = ACTIONS(2354),
    [anon_sym___alignof] = ACTIONS(2354),
    [anon_sym__alignof] = ACTIONS(2354),
    [anon_sym_alignof] = ACTIONS(2354),
    [anon_sym__Alignof] = ACTIONS(2354),
    [anon_sym_offsetof] = ACTIONS(2354),
    [anon_sym__Generic] = ACTIONS(2354),
    [anon_sym_asm] = ACTIONS(2354),
    [anon_sym___asm__] = ACTIONS(2354),
    [anon_sym___asm] = ACTIONS(2354),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_L_SQUOTE] = ACTIONS(2356),
    [anon_sym_u_SQUOTE] = ACTIONS(2356),
    [anon_sym_U_SQUOTE] = ACTIONS(2356),
    [anon_sym_u8_SQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_L_DQUOTE] = ACTIONS(2356),
    [anon_sym_u_DQUOTE] = ACTIONS(2356),
    [anon_sym_U_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8_DQUOTE] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [anon_sym_NULL] = ACTIONS(2354),
    [anon_sym_nullptr] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2354),
    [anon_sym_decltype] = ACTIONS(2354),
    [anon_sym_explicit] = ACTIONS(2354),
    [anon_sym_typename] = ACTIONS(2354),
    [anon_sym_template] = ACTIONS(2354),
    [anon_sym_operator] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_static_assert] = ACTIONS(2354),
    [anon_sym_concept] = ACTIONS(2354),
    [anon_sym_co_return] = ACTIONS(2354),
    [anon_sym_co_yield] = ACTIONS(2354),
    [anon_sym_R_DQUOTE] = ACTIONS(2356),
    [anon_sym_LR_DQUOTE] = ACTIONS(2356),
    [anon_sym_uR_DQUOTE] = ACTIONS(2356),
    [anon_sym_UR_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2356),
    [anon_sym_co_await] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_requires] = ACTIONS(2354),
    [sym_this] = ACTIONS(2354),
    [anon_sym_discard] = ACTIONS(2354),
    [anon_sym_precise] = ACTIONS(2354),
    [anon_sym_shared] = ACTIONS(2354),
    [anon_sym_groupshared] = ACTIONS(2354),
    [anon_sym_uniform] = ACTIONS(2354),
    [anon_sym_row_major] = ACTIONS(2354),
    [anon_sym_column_major] = ACTIONS(2354),
    [anon_sym_globallycoherent] = ACTIONS(2354),
    [anon_sym_centroid] = ACTIONS(2354),
    [anon_sym_noperspective] = ACTIONS(2354),
    [anon_sym_nointerpolation] = ACTIONS(2354),
    [anon_sym_sample] = ACTIONS(2354),
    [anon_sym_linear] = ACTIONS(2354),
    [anon_sym_snorm] = ACTIONS(2354),
    [anon_sym_unorm] = ACTIONS(2354),
    [anon_sym_point] = ACTIONS(2354),
    [anon_sym_line] = ACTIONS(2354),
    [anon_sym_triangleadj] = ACTIONS(2354),
    [anon_sym_lineadj] = ACTIONS(2354),
    [anon_sym_triangle] = ACTIONS(2354),
    [anon_sym_cbuffer] = ACTIONS(2354),
  },
  [494] = {
    [sym_identifier] = ACTIONS(2358),
    [aux_sym_preproc_include_token1] = ACTIONS(2358),
    [aux_sym_preproc_def_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token1] = ACTIONS(2358),
    [aux_sym_preproc_if_token2] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2358),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2358),
    [sym_preproc_directive] = ACTIONS(2358),
    [anon_sym_LPAREN2] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_AMP_AMP] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym___extension__] = ACTIONS(2358),
    [anon_sym_typedef] = ACTIONS(2358),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_out] = ACTIONS(2358),
    [anon_sym_inout] = ACTIONS(2358),
    [anon_sym_virtual] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym___attribute__] = ACTIONS(2358),
    [anon_sym___attribute] = ACTIONS(2358),
    [anon_sym_using] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(2358),
    [anon_sym___based] = ACTIONS(2358),
    [anon_sym___cdecl] = ACTIONS(2358),
    [anon_sym___clrcall] = ACTIONS(2358),
    [anon_sym___stdcall] = ACTIONS(2358),
    [anon_sym___fastcall] = ACTIONS(2358),
    [anon_sym___thiscall] = ACTIONS(2358),
    [anon_sym___vectorcall] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_signed] = ACTIONS(2358),
    [anon_sym_unsigned] = ACTIONS(2358),
    [anon_sym_long] = ACTIONS(2358),
    [anon_sym_short] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_register] = ACTIONS(2358),
    [anon_sym_inline] = ACTIONS(2358),
    [anon_sym___inline] = ACTIONS(2358),
    [anon_sym___inline__] = ACTIONS(2358),
    [anon_sym___forceinline] = ACTIONS(2358),
    [anon_sym_thread_local] = ACTIONS(2358),
    [anon_sym___thread] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_constexpr] = ACTIONS(2358),
    [anon_sym_volatile] = ACTIONS(2358),
    [anon_sym_restrict] = ACTIONS(2358),
    [anon_sym___restrict__] = ACTIONS(2358),
    [anon_sym__Atomic] = ACTIONS(2358),
    [anon_sym__Noreturn] = ACTIONS(2358),
    [anon_sym_noreturn] = ACTIONS(2358),
    [anon_sym__Nonnull] = ACTIONS(2358),
    [anon_sym_mutable] = ACTIONS(2358),
    [anon_sym_constinit] = ACTIONS(2358),
    [anon_sym_consteval] = ACTIONS(2358),
    [anon_sym_alignas] = ACTIONS(2358),
    [anon_sym__Alignas] = ACTIONS(2358),
    [sym_primitive_type] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_goto] = ACTIONS(2358),
    [anon_sym___try] = ACTIONS(2358),
    [anon_sym___leave] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_compl] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2358),
    [anon_sym___alignof__] = ACTIONS(2358),
    [anon_sym___alignof] = ACTIONS(2358),
    [anon_sym__alignof] = ACTIONS(2358),
    [anon_sym_alignof] = ACTIONS(2358),
    [anon_sym__Alignof] = ACTIONS(2358),
    [anon_sym_offsetof] = ACTIONS(2358),
    [anon_sym__Generic] = ACTIONS(2358),
    [anon_sym_asm] = ACTIONS(2358),
    [anon_sym___asm__] = ACTIONS(2358),
    [anon_sym___asm] = ACTIONS(2358),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_L_SQUOTE] = ACTIONS(2360),
    [anon_sym_u_SQUOTE] = ACTIONS(2360),
    [anon_sym_U_SQUOTE] = ACTIONS(2360),
    [anon_sym_u8_SQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_L_DQUOTE] = ACTIONS(2360),
    [anon_sym_u_DQUOTE] = ACTIONS(2360),
    [anon_sym_U_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8_DQUOTE] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [anon_sym_NULL] = ACTIONS(2358),
    [anon_sym_nullptr] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2358),
    [anon_sym_decltype] = ACTIONS(2358),
    [anon_sym_explicit] = ACTIONS(2358),
    [anon_sym_typename] = ACTIONS(2358),
    [anon_sym_template] = ACTIONS(2358),
    [anon_sym_operator] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2358),
    [anon_sym_static_assert] = ACTIONS(2358),
    [anon_sym_concept] = ACTIONS(2358),
    [anon_sym_co_return] = ACTIONS(2358),
    [anon_sym_co_yield] = ACTIONS(2358),
    [anon_sym_R_DQUOTE] = ACTIONS(2360),
    [anon_sym_LR_DQUOTE] = ACTIONS(2360),
    [anon_sym_uR_DQUOTE] = ACTIONS(2360),
    [anon_sym_UR_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2360),
    [anon_sym_co_await] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_requires] = ACTIONS(2358),
    [sym_this] = ACTIONS(2358),
    [anon_sym_discard] = ACTIONS(2358),
    [anon_sym_precise] = ACTIONS(2358),
    [anon_sym_shared] = ACTIONS(2358),
    [anon_sym_groupshared] = ACTIONS(2358),
    [anon_sym_uniform] = ACTIONS(2358),
    [anon_sym_row_major] = ACTIONS(2358),
    [anon_sym_column_major] = ACTIONS(2358),
    [anon_sym_globallycoherent] = ACTIONS(2358),
    [anon_sym_centroid] = ACTIONS(2358),
    [anon_sym_noperspective] = ACTIONS(2358),
    [anon_sym_nointerpolation] = ACTIONS(2358),
    [anon_sym_sample] = ACTIONS(2358),
    [anon_sym_linear] = ACTIONS(2358),
    [anon_sym_snorm] = ACTIONS(2358),
    [anon_sym_unorm] = ACTIONS(2358),
    [anon_sym_point] = ACTIONS(2358),
    [anon_sym_line] = ACTIONS(2358),
    [anon_sym_triangleadj] = ACTIONS(2358),
    [anon_sym_lineadj] = ACTIONS(2358),
    [anon_sym_triangle] = ACTIONS(2358),
    [anon_sym_cbuffer] = ACTIONS(2358),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2362),
    [aux_sym_preproc_include_token1] = ACTIONS(2362),
    [aux_sym_preproc_def_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token1] = ACTIONS(2362),
    [aux_sym_preproc_if_token2] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2362),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2362),
    [sym_preproc_directive] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP_AMP] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_out] = ACTIONS(2362),
    [anon_sym_inout] = ACTIONS(2362),
    [anon_sym_virtual] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym___attribute] = ACTIONS(2362),
    [anon_sym_using] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym___based] = ACTIONS(2362),
    [anon_sym___cdecl] = ACTIONS(2362),
    [anon_sym___clrcall] = ACTIONS(2362),
    [anon_sym___stdcall] = ACTIONS(2362),
    [anon_sym___fastcall] = ACTIONS(2362),
    [anon_sym___thiscall] = ACTIONS(2362),
    [anon_sym___vectorcall] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym__Nonnull] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [anon_sym___asm] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [anon_sym_explicit] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_operator] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_static_assert] = ACTIONS(2362),
    [anon_sym_concept] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_discard] = ACTIONS(2362),
    [anon_sym_precise] = ACTIONS(2362),
    [anon_sym_shared] = ACTIONS(2362),
    [anon_sym_groupshared] = ACTIONS(2362),
    [anon_sym_uniform] = ACTIONS(2362),
    [anon_sym_row_major] = ACTIONS(2362),
    [anon_sym_column_major] = ACTIONS(2362),
    [anon_sym_globallycoherent] = ACTIONS(2362),
    [anon_sym_centroid] = ACTIONS(2362),
    [anon_sym_noperspective] = ACTIONS(2362),
    [anon_sym_nointerpolation] = ACTIONS(2362),
    [anon_sym_sample] = ACTIONS(2362),
    [anon_sym_linear] = ACTIONS(2362),
    [anon_sym_snorm] = ACTIONS(2362),
    [anon_sym_unorm] = ACTIONS(2362),
    [anon_sym_point] = ACTIONS(2362),
    [anon_sym_line] = ACTIONS(2362),
    [anon_sym_triangleadj] = ACTIONS(2362),
    [anon_sym_lineadj] = ACTIONS(2362),
    [anon_sym_triangle] = ACTIONS(2362),
    [anon_sym_cbuffer] = ACTIONS(2362),
  },
  [496] = {
    [sym_identifier] = ACTIONS(2366),
    [aux_sym_preproc_include_token1] = ACTIONS(2366),
    [aux_sym_preproc_def_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token1] = ACTIONS(2366),
    [aux_sym_preproc_if_token2] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2366),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2366),
    [sym_preproc_directive] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP_AMP] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym_in] = ACTIONS(2366),
    [anon_sym_out] = ACTIONS(2366),
    [anon_sym_inout] = ACTIONS(2366),
    [anon_sym_virtual] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym___attribute] = ACTIONS(2366),
    [anon_sym_using] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym___based] = ACTIONS(2366),
    [anon_sym___cdecl] = ACTIONS(2366),
    [anon_sym___clrcall] = ACTIONS(2366),
    [anon_sym___stdcall] = ACTIONS(2366),
    [anon_sym___fastcall] = ACTIONS(2366),
    [anon_sym___thiscall] = ACTIONS(2366),
    [anon_sym___vectorcall] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym__Nonnull] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [anon_sym___asm] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [anon_sym_explicit] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_operator] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_static_assert] = ACTIONS(2366),
    [anon_sym_concept] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_discard] = ACTIONS(2366),
    [anon_sym_precise] = ACTIONS(2366),
    [anon_sym_shared] = ACTIONS(2366),
    [anon_sym_groupshared] = ACTIONS(2366),
    [anon_sym_uniform] = ACTIONS(2366),
    [anon_sym_row_major] = ACTIONS(2366),
    [anon_sym_column_major] = ACTIONS(2366),
    [anon_sym_globallycoherent] = ACTIONS(2366),
    [anon_sym_centroid] = ACTIONS(2366),
    [anon_sym_noperspective] = ACTIONS(2366),
    [anon_sym_nointerpolation] = ACTIONS(2366),
    [anon_sym_sample] = ACTIONS(2366),
    [anon_sym_linear] = ACTIONS(2366),
    [anon_sym_snorm] = ACTIONS(2366),
    [anon_sym_unorm] = ACTIONS(2366),
    [anon_sym_point] = ACTIONS(2366),
    [anon_sym_line] = ACTIONS(2366),
    [anon_sym_triangleadj] = ACTIONS(2366),
    [anon_sym_lineadj] = ACTIONS(2366),
    [anon_sym_triangle] = ACTIONS(2366),
    [anon_sym_cbuffer] = ACTIONS(2366),
  },
  [497] = {
    [sym_identifier] = ACTIONS(2370),
    [aux_sym_preproc_include_token1] = ACTIONS(2370),
    [aux_sym_preproc_def_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token1] = ACTIONS(2370),
    [aux_sym_preproc_if_token2] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2370),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2370),
    [sym_preproc_directive] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP_AMP] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym_in] = ACTIONS(2370),
    [anon_sym_out] = ACTIONS(2370),
    [anon_sym_inout] = ACTIONS(2370),
    [anon_sym_virtual] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym___attribute] = ACTIONS(2370),
    [anon_sym_using] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym___based] = ACTIONS(2370),
    [anon_sym___cdecl] = ACTIONS(2370),
    [anon_sym___clrcall] = ACTIONS(2370),
    [anon_sym___stdcall] = ACTIONS(2370),
    [anon_sym___fastcall] = ACTIONS(2370),
    [anon_sym___thiscall] = ACTIONS(2370),
    [anon_sym___vectorcall] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym__Nonnull] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [anon_sym___asm] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [anon_sym_explicit] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_operator] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_static_assert] = ACTIONS(2370),
    [anon_sym_concept] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym_discard] = ACTIONS(2370),
    [anon_sym_precise] = ACTIONS(2370),
    [anon_sym_shared] = ACTIONS(2370),
    [anon_sym_groupshared] = ACTIONS(2370),
    [anon_sym_uniform] = ACTIONS(2370),
    [anon_sym_row_major] = ACTIONS(2370),
    [anon_sym_column_major] = ACTIONS(2370),
    [anon_sym_globallycoherent] = ACTIONS(2370),
    [anon_sym_centroid] = ACTIONS(2370),
    [anon_sym_noperspective] = ACTIONS(2370),
    [anon_sym_nointerpolation] = ACTIONS(2370),
    [anon_sym_sample] = ACTIONS(2370),
    [anon_sym_linear] = ACTIONS(2370),
    [anon_sym_snorm] = ACTIONS(2370),
    [anon_sym_unorm] = ACTIONS(2370),
    [anon_sym_point] = ACTIONS(2370),
    [anon_sym_line] = ACTIONS(2370),
    [anon_sym_triangleadj] = ACTIONS(2370),
    [anon_sym_lineadj] = ACTIONS(2370),
    [anon_sym_triangle] = ACTIONS(2370),
    [anon_sym_cbuffer] = ACTIONS(2370),
  },
  [498] = {
    [sym_identifier] = ACTIONS(2374),
    [aux_sym_preproc_include_token1] = ACTIONS(2374),
    [aux_sym_preproc_def_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token1] = ACTIONS(2374),
    [aux_sym_preproc_if_token2] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2374),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2374),
    [sym_preproc_directive] = ACTIONS(2374),
    [anon_sym_LPAREN2] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_AMP_AMP] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_out] = ACTIONS(2374),
    [anon_sym_inout] = ACTIONS(2374),
    [anon_sym_virtual] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym___attribute__] = ACTIONS(2374),
    [anon_sym___attribute] = ACTIONS(2374),
    [anon_sym_using] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2376),
    [anon_sym___declspec] = ACTIONS(2374),
    [anon_sym___based] = ACTIONS(2374),
    [anon_sym___cdecl] = ACTIONS(2374),
    [anon_sym___clrcall] = ACTIONS(2374),
    [anon_sym___stdcall] = ACTIONS(2374),
    [anon_sym___fastcall] = ACTIONS(2374),
    [anon_sym___thiscall] = ACTIONS(2374),
    [anon_sym___vectorcall] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_signed] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym___inline] = ACTIONS(2374),
    [anon_sym___inline__] = ACTIONS(2374),
    [anon_sym___forceinline] = ACTIONS(2374),
    [anon_sym_thread_local] = ACTIONS(2374),
    [anon_sym___thread] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_constexpr] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym___restrict__] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym__Noreturn] = ACTIONS(2374),
    [anon_sym_noreturn] = ACTIONS(2374),
    [anon_sym__Nonnull] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2374),
    [anon_sym_constinit] = ACTIONS(2374),
    [anon_sym_consteval] = ACTIONS(2374),
    [anon_sym_alignas] = ACTIONS(2374),
    [anon_sym__Alignas] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym___try] = ACTIONS(2374),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2374),
    [anon_sym_compl] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2374),
    [anon_sym___alignof__] = ACTIONS(2374),
    [anon_sym___alignof] = ACTIONS(2374),
    [anon_sym__alignof] = ACTIONS(2374),
    [anon_sym_alignof] = ACTIONS(2374),
    [anon_sym__Alignof] = ACTIONS(2374),
    [anon_sym_offsetof] = ACTIONS(2374),
    [anon_sym__Generic] = ACTIONS(2374),
    [anon_sym_asm] = ACTIONS(2374),
    [anon_sym___asm__] = ACTIONS(2374),
    [anon_sym___asm] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2376),
    [anon_sym_u_DQUOTE] = ACTIONS(2376),
    [anon_sym_U_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8_DQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [anon_sym_NULL] = ACTIONS(2374),
    [anon_sym_nullptr] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2374),
    [anon_sym_decltype] = ACTIONS(2374),
    [anon_sym_explicit] = ACTIONS(2374),
    [anon_sym_typename] = ACTIONS(2374),
    [anon_sym_template] = ACTIONS(2374),
    [anon_sym_operator] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_namespace] = ACTIONS(2374),
    [anon_sym_static_assert] = ACTIONS(2374),
    [anon_sym_concept] = ACTIONS(2374),
    [anon_sym_co_return] = ACTIONS(2374),
    [anon_sym_co_yield] = ACTIONS(2374),
    [anon_sym_R_DQUOTE] = ACTIONS(2376),
    [anon_sym_LR_DQUOTE] = ACTIONS(2376),
    [anon_sym_uR_DQUOTE] = ACTIONS(2376),
    [anon_sym_UR_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2376),
    [anon_sym_co_await] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_requires] = ACTIONS(2374),
    [sym_this] = ACTIONS(2374),
    [anon_sym_discard] = ACTIONS(2374),
    [anon_sym_precise] = ACTIONS(2374),
    [anon_sym_shared] = ACTIONS(2374),
    [anon_sym_groupshared] = ACTIONS(2374),
    [anon_sym_uniform] = ACTIONS(2374),
    [anon_sym_row_major] = ACTIONS(2374),
    [anon_sym_column_major] = ACTIONS(2374),
    [anon_sym_globallycoherent] = ACTIONS(2374),
    [anon_sym_centroid] = ACTIONS(2374),
    [anon_sym_noperspective] = ACTIONS(2374),
    [anon_sym_nointerpolation] = ACTIONS(2374),
    [anon_sym_sample] = ACTIONS(2374),
    [anon_sym_linear] = ACTIONS(2374),
    [anon_sym_snorm] = ACTIONS(2374),
    [anon_sym_unorm] = ACTIONS(2374),
    [anon_sym_point] = ACTIONS(2374),
    [anon_sym_line] = ACTIONS(2374),
    [anon_sym_triangleadj] = ACTIONS(2374),
    [anon_sym_lineadj] = ACTIONS(2374),
    [anon_sym_triangle] = ACTIONS(2374),
    [anon_sym_cbuffer] = ACTIONS(2374),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2386),
    [aux_sym_preproc_include_token1] = ACTIONS(2386),
    [aux_sym_preproc_def_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token2] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2386),
    [sym_preproc_directive] = ACTIONS(2386),
    [anon_sym_LPAREN2] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2386),
    [anon_sym_typedef] = ACTIONS(2386),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_out] = ACTIONS(2386),
    [anon_sym_inout] = ACTIONS(2386),
    [anon_sym_virtual] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym___attribute__] = ACTIONS(2386),
    [anon_sym___attribute] = ACTIONS(2386),
    [anon_sym_using] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2388),
    [anon_sym___declspec] = ACTIONS(2386),
    [anon_sym___based] = ACTIONS(2386),
    [anon_sym___cdecl] = ACTIONS(2386),
    [anon_sym___clrcall] = ACTIONS(2386),
    [anon_sym___stdcall] = ACTIONS(2386),
    [anon_sym___fastcall] = ACTIONS(2386),
    [anon_sym___thiscall] = ACTIONS(2386),
    [anon_sym___vectorcall] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2386),
    [anon_sym_unsigned] = ACTIONS(2386),
    [anon_sym_long] = ACTIONS(2386),
    [anon_sym_short] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_register] = ACTIONS(2386),
    [anon_sym_inline] = ACTIONS(2386),
    [anon_sym___inline] = ACTIONS(2386),
    [anon_sym___inline__] = ACTIONS(2386),
    [anon_sym___forceinline] = ACTIONS(2386),
    [anon_sym_thread_local] = ACTIONS(2386),
    [anon_sym___thread] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_constexpr] = ACTIONS(2386),
    [anon_sym_volatile] = ACTIONS(2386),
    [anon_sym_restrict] = ACTIONS(2386),
    [anon_sym___restrict__] = ACTIONS(2386),
    [anon_sym__Atomic] = ACTIONS(2386),
    [anon_sym__Noreturn] = ACTIONS(2386),
    [anon_sym_noreturn] = ACTIONS(2386),
    [anon_sym__Nonnull] = ACTIONS(2386),
    [anon_sym_mutable] = ACTIONS(2386),
    [anon_sym_constinit] = ACTIONS(2386),
    [anon_sym_consteval] = ACTIONS(2386),
    [anon_sym_alignas] = ACTIONS(2386),
    [anon_sym__Alignas] = ACTIONS(2386),
    [sym_primitive_type] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_goto] = ACTIONS(2386),
    [anon_sym___try] = ACTIONS(2386),
    [anon_sym___leave] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_compl] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2386),
    [anon_sym___alignof__] = ACTIONS(2386),
    [anon_sym___alignof] = ACTIONS(2386),
    [anon_sym__alignof] = ACTIONS(2386),
    [anon_sym_alignof] = ACTIONS(2386),
    [anon_sym__Alignof] = ACTIONS(2386),
    [anon_sym_offsetof] = ACTIONS(2386),
    [anon_sym__Generic] = ACTIONS(2386),
    [anon_sym_asm] = ACTIONS(2386),
    [anon_sym___asm__] = ACTIONS(2386),
    [anon_sym___asm] = ACTIONS(2386),
    [sym_number_literal] = ACTIONS(2388),
    [anon_sym_L_SQUOTE] = ACTIONS(2388),
    [anon_sym_u_SQUOTE] = ACTIONS(2388),
    [anon_sym_U_SQUOTE] = ACTIONS(2388),
    [anon_sym_u8_SQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_L_DQUOTE] = ACTIONS(2388),
    [anon_sym_u_DQUOTE] = ACTIONS(2388),
    [anon_sym_U_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8_DQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [anon_sym_NULL] = ACTIONS(2386),
    [anon_sym_nullptr] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2386),
    [anon_sym_decltype] = ACTIONS(2386),
    [anon_sym_explicit] = ACTIONS(2386),
    [anon_sym_typename] = ACTIONS(2386),
    [anon_sym_template] = ACTIONS(2386),
    [anon_sym_operator] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_static_assert] = ACTIONS(2386),
    [anon_sym_concept] = ACTIONS(2386),
    [anon_sym_co_return] = ACTIONS(2386),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_requires] = ACTIONS(2386),
    [sym_this] = ACTIONS(2386),
    [anon_sym_discard] = ACTIONS(2386),
    [anon_sym_precise] = ACTIONS(2386),
    [anon_sym_shared] = ACTIONS(2386),
    [anon_sym_groupshared] = ACTIONS(2386),
    [anon_sym_uniform] = ACTIONS(2386),
    [anon_sym_row_major] = ACTIONS(2386),
    [anon_sym_column_major] = ACTIONS(2386),
    [anon_sym_globallycoherent] = ACTIONS(2386),
    [anon_sym_centroid] = ACTIONS(2386),
    [anon_sym_noperspective] = ACTIONS(2386),
    [anon_sym_nointerpolation] = ACTIONS(2386),
    [anon_sym_sample] = ACTIONS(2386),
    [anon_sym_linear] = ACTIONS(2386),
    [anon_sym_snorm] = ACTIONS(2386),
    [anon_sym_unorm] = ACTIONS(2386),
    [anon_sym_point] = ACTIONS(2386),
    [anon_sym_line] = ACTIONS(2386),
    [anon_sym_triangleadj] = ACTIONS(2386),
    [anon_sym_lineadj] = ACTIONS(2386),
    [anon_sym_triangle] = ACTIONS(2386),
    [anon_sym_cbuffer] = ACTIONS(2386),
  },
  [500] = {
    [sym_identifier] = ACTIONS(2390),
    [aux_sym_preproc_include_token1] = ACTIONS(2390),
    [aux_sym_preproc_def_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token2] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2390),
    [sym_preproc_directive] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2390),
    [anon_sym_typedef] = ACTIONS(2390),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_out] = ACTIONS(2390),
    [anon_sym_inout] = ACTIONS(2390),
    [anon_sym_virtual] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym___attribute__] = ACTIONS(2390),
    [anon_sym___attribute] = ACTIONS(2390),
    [anon_sym_using] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2392),
    [anon_sym___declspec] = ACTIONS(2390),
    [anon_sym___based] = ACTIONS(2390),
    [anon_sym___cdecl] = ACTIONS(2390),
    [anon_sym___clrcall] = ACTIONS(2390),
    [anon_sym___stdcall] = ACTIONS(2390),
    [anon_sym___fastcall] = ACTIONS(2390),
    [anon_sym___thiscall] = ACTIONS(2390),
    [anon_sym___vectorcall] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2390),
    [anon_sym_unsigned] = ACTIONS(2390),
    [anon_sym_long] = ACTIONS(2390),
    [anon_sym_short] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_register] = ACTIONS(2390),
    [anon_sym_inline] = ACTIONS(2390),
    [anon_sym___inline] = ACTIONS(2390),
    [anon_sym___inline__] = ACTIONS(2390),
    [anon_sym___forceinline] = ACTIONS(2390),
    [anon_sym_thread_local] = ACTIONS(2390),
    [anon_sym___thread] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_constexpr] = ACTIONS(2390),
    [anon_sym_volatile] = ACTIONS(2390),
    [anon_sym_restrict] = ACTIONS(2390),
    [anon_sym___restrict__] = ACTIONS(2390),
    [anon_sym__Atomic] = ACTIONS(2390),
    [anon_sym__Noreturn] = ACTIONS(2390),
    [anon_sym_noreturn] = ACTIONS(2390),
    [anon_sym__Nonnull] = ACTIONS(2390),
    [anon_sym_mutable] = ACTIONS(2390),
    [anon_sym_constinit] = ACTIONS(2390),
    [anon_sym_consteval] = ACTIONS(2390),
    [anon_sym_alignas] = ACTIONS(2390),
    [anon_sym__Alignas] = ACTIONS(2390),
    [sym_primitive_type] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2390),
    [anon_sym___leave] = ACTIONS(2390),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_compl] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2390),
    [anon_sym___alignof__] = ACTIONS(2390),
    [anon_sym___alignof] = ACTIONS(2390),
    [anon_sym__alignof] = ACTIONS(2390),
    [anon_sym_alignof] = ACTIONS(2390),
    [anon_sym__Alignof] = ACTIONS(2390),
    [anon_sym_offsetof] = ACTIONS(2390),
    [anon_sym__Generic] = ACTIONS(2390),
    [anon_sym_asm] = ACTIONS(2390),
    [anon_sym___asm__] = ACTIONS(2390),
    [anon_sym___asm] = ACTIONS(2390),
    [sym_number_literal] = ACTIONS(2392),
    [anon_sym_L_SQUOTE] = ACTIONS(2392),
    [anon_sym_u_SQUOTE] = ACTIONS(2392),
    [anon_sym_U_SQUOTE] = ACTIONS(2392),
    [anon_sym_u8_SQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_L_DQUOTE] = ACTIONS(2392),
    [anon_sym_u_DQUOTE] = ACTIONS(2392),
    [anon_sym_U_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [anon_sym_NULL] = ACTIONS(2390),
    [anon_sym_nullptr] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2390),
    [anon_sym_decltype] = ACTIONS(2390),
    [anon_sym_explicit] = ACTIONS(2390),
    [anon_sym_typename] = ACTIONS(2390),
    [anon_sym_template] = ACTIONS(2390),
    [anon_sym_operator] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_static_assert] = ACTIONS(2390),
    [anon_sym_concept] = ACTIONS(2390),
    [anon_sym_co_return] = ACTIONS(2390),
    [anon_sym_co_yield] = ACTIONS(2390),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_LR_DQUOTE] = ACTIONS(2392),
    [anon_sym_uR_DQUOTE] = ACTIONS(2392),
    [anon_sym_UR_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2392),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_requires] = ACTIONS(2390),
    [sym_this] = ACTIONS(2390),
    [anon_sym_discard] = ACTIONS(2390),
    [anon_sym_precise] = ACTIONS(2390),
    [anon_sym_shared] = ACTIONS(2390),
    [anon_sym_groupshared] = ACTIONS(2390),
    [anon_sym_uniform] = ACTIONS(2390),
    [anon_sym_row_major] = ACTIONS(2390),
    [anon_sym_column_major] = ACTIONS(2390),
    [anon_sym_globallycoherent] = ACTIONS(2390),
    [anon_sym_centroid] = ACTIONS(2390),
    [anon_sym_noperspective] = ACTIONS(2390),
    [anon_sym_nointerpolation] = ACTIONS(2390),
    [anon_sym_sample] = ACTIONS(2390),
    [anon_sym_linear] = ACTIONS(2390),
    [anon_sym_snorm] = ACTIONS(2390),
    [anon_sym_unorm] = ACTIONS(2390),
    [anon_sym_point] = ACTIONS(2390),
    [anon_sym_line] = ACTIONS(2390),
    [anon_sym_triangleadj] = ACTIONS(2390),
    [anon_sym_lineadj] = ACTIONS(2390),
    [anon_sym_triangle] = ACTIONS(2390),
    [anon_sym_cbuffer] = ACTIONS(2390),
  },
  [501] = {
    [sym_identifier] = ACTIONS(2394),
    [aux_sym_preproc_include_token1] = ACTIONS(2394),
    [aux_sym_preproc_def_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token2] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2394),
    [sym_preproc_directive] = ACTIONS(2394),
    [anon_sym_LPAREN2] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2394),
    [anon_sym_typedef] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_out] = ACTIONS(2394),
    [anon_sym_inout] = ACTIONS(2394),
    [anon_sym_virtual] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym___attribute__] = ACTIONS(2394),
    [anon_sym___attribute] = ACTIONS(2394),
    [anon_sym_using] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2396),
    [anon_sym___declspec] = ACTIONS(2394),
    [anon_sym___based] = ACTIONS(2394),
    [anon_sym___cdecl] = ACTIONS(2394),
    [anon_sym___clrcall] = ACTIONS(2394),
    [anon_sym___stdcall] = ACTIONS(2394),
    [anon_sym___fastcall] = ACTIONS(2394),
    [anon_sym___thiscall] = ACTIONS(2394),
    [anon_sym___vectorcall] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2394),
    [anon_sym_unsigned] = ACTIONS(2394),
    [anon_sym_long] = ACTIONS(2394),
    [anon_sym_short] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_register] = ACTIONS(2394),
    [anon_sym_inline] = ACTIONS(2394),
    [anon_sym___inline] = ACTIONS(2394),
    [anon_sym___inline__] = ACTIONS(2394),
    [anon_sym___forceinline] = ACTIONS(2394),
    [anon_sym_thread_local] = ACTIONS(2394),
    [anon_sym___thread] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_constexpr] = ACTIONS(2394),
    [anon_sym_volatile] = ACTIONS(2394),
    [anon_sym_restrict] = ACTIONS(2394),
    [anon_sym___restrict__] = ACTIONS(2394),
    [anon_sym__Atomic] = ACTIONS(2394),
    [anon_sym__Noreturn] = ACTIONS(2394),
    [anon_sym_noreturn] = ACTIONS(2394),
    [anon_sym__Nonnull] = ACTIONS(2394),
    [anon_sym_mutable] = ACTIONS(2394),
    [anon_sym_constinit] = ACTIONS(2394),
    [anon_sym_consteval] = ACTIONS(2394),
    [anon_sym_alignas] = ACTIONS(2394),
    [anon_sym__Alignas] = ACTIONS(2394),
    [sym_primitive_type] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_goto] = ACTIONS(2394),
    [anon_sym___try] = ACTIONS(2394),
    [anon_sym___leave] = ACTIONS(2394),
    [anon_sym_not] = ACTIONS(2394),
    [anon_sym_compl] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2394),
    [anon_sym___alignof] = ACTIONS(2394),
    [anon_sym__alignof] = ACTIONS(2394),
    [anon_sym_alignof] = ACTIONS(2394),
    [anon_sym__Alignof] = ACTIONS(2394),
    [anon_sym_offsetof] = ACTIONS(2394),
    [anon_sym__Generic] = ACTIONS(2394),
    [anon_sym_asm] = ACTIONS(2394),
    [anon_sym___asm__] = ACTIONS(2394),
    [anon_sym___asm] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2396),
    [anon_sym_L_SQUOTE] = ACTIONS(2396),
    [anon_sym_u_SQUOTE] = ACTIONS(2396),
    [anon_sym_U_SQUOTE] = ACTIONS(2396),
    [anon_sym_u8_SQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_L_DQUOTE] = ACTIONS(2396),
    [anon_sym_u_DQUOTE] = ACTIONS(2396),
    [anon_sym_U_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8_DQUOTE] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [anon_sym_NULL] = ACTIONS(2394),
    [anon_sym_nullptr] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2394),
    [anon_sym_decltype] = ACTIONS(2394),
    [anon_sym_explicit] = ACTIONS(2394),
    [anon_sym_typename] = ACTIONS(2394),
    [anon_sym_template] = ACTIONS(2394),
    [anon_sym_operator] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_static_assert] = ACTIONS(2394),
    [anon_sym_concept] = ACTIONS(2394),
    [anon_sym_co_return] = ACTIONS(2394),
    [anon_sym_co_yield] = ACTIONS(2394),
    [anon_sym_R_DQUOTE] = ACTIONS(2396),
    [anon_sym_LR_DQUOTE] = ACTIONS(2396),
    [anon_sym_uR_DQUOTE] = ACTIONS(2396),
    [anon_sym_UR_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2396),
    [anon_sym_co_await] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2394),
    [anon_sym_discard] = ACTIONS(2394),
    [anon_sym_precise] = ACTIONS(2394),
    [anon_sym_shared] = ACTIONS(2394),
    [anon_sym_groupshared] = ACTIONS(2394),
    [anon_sym_uniform] = ACTIONS(2394),
    [anon_sym_row_major] = ACTIONS(2394),
    [anon_sym_column_major] = ACTIONS(2394),
    [anon_sym_globallycoherent] = ACTIONS(2394),
    [anon_sym_centroid] = ACTIONS(2394),
    [anon_sym_noperspective] = ACTIONS(2394),
    [anon_sym_nointerpolation] = ACTIONS(2394),
    [anon_sym_sample] = ACTIONS(2394),
    [anon_sym_linear] = ACTIONS(2394),
    [anon_sym_snorm] = ACTIONS(2394),
    [anon_sym_unorm] = ACTIONS(2394),
    [anon_sym_point] = ACTIONS(2394),
    [anon_sym_line] = ACTIONS(2394),
    [anon_sym_triangleadj] = ACTIONS(2394),
    [anon_sym_lineadj] = ACTIONS(2394),
    [anon_sym_triangle] = ACTIONS(2394),
    [anon_sym_cbuffer] = ACTIONS(2394),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2398),
    [aux_sym_preproc_include_token1] = ACTIONS(2398),
    [aux_sym_preproc_def_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token2] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2398),
    [sym_preproc_directive] = ACTIONS(2398),
    [anon_sym_LPAREN2] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2398),
    [anon_sym_typedef] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_out] = ACTIONS(2398),
    [anon_sym_inout] = ACTIONS(2398),
    [anon_sym_virtual] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym___attribute__] = ACTIONS(2398),
    [anon_sym___attribute] = ACTIONS(2398),
    [anon_sym_using] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2400),
    [anon_sym___declspec] = ACTIONS(2398),
    [anon_sym___based] = ACTIONS(2398),
    [anon_sym___cdecl] = ACTIONS(2398),
    [anon_sym___clrcall] = ACTIONS(2398),
    [anon_sym___stdcall] = ACTIONS(2398),
    [anon_sym___fastcall] = ACTIONS(2398),
    [anon_sym___thiscall] = ACTIONS(2398),
    [anon_sym___vectorcall] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_signed] = ACTIONS(2398),
    [anon_sym_unsigned] = ACTIONS(2398),
    [anon_sym_long] = ACTIONS(2398),
    [anon_sym_short] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_register] = ACTIONS(2398),
    [anon_sym_inline] = ACTIONS(2398),
    [anon_sym___inline] = ACTIONS(2398),
    [anon_sym___inline__] = ACTIONS(2398),
    [anon_sym___forceinline] = ACTIONS(2398),
    [anon_sym_thread_local] = ACTIONS(2398),
    [anon_sym___thread] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_constexpr] = ACTIONS(2398),
    [anon_sym_volatile] = ACTIONS(2398),
    [anon_sym_restrict] = ACTIONS(2398),
    [anon_sym___restrict__] = ACTIONS(2398),
    [anon_sym__Atomic] = ACTIONS(2398),
    [anon_sym__Noreturn] = ACTIONS(2398),
    [anon_sym_noreturn] = ACTIONS(2398),
    [anon_sym__Nonnull] = ACTIONS(2398),
    [anon_sym_mutable] = ACTIONS(2398),
    [anon_sym_constinit] = ACTIONS(2398),
    [anon_sym_consteval] = ACTIONS(2398),
    [anon_sym_alignas] = ACTIONS(2398),
    [anon_sym__Alignas] = ACTIONS(2398),
    [sym_primitive_type] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_goto] = ACTIONS(2398),
    [anon_sym___try] = ACTIONS(2398),
    [anon_sym___leave] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2398),
    [anon_sym_compl] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_sizeof] = ACTIONS(2398),
    [anon_sym___alignof__] = ACTIONS(2398),
    [anon_sym___alignof] = ACTIONS(2398),
    [anon_sym__alignof] = ACTIONS(2398),
    [anon_sym_alignof] = ACTIONS(2398),
    [anon_sym__Alignof] = ACTIONS(2398),
    [anon_sym_offsetof] = ACTIONS(2398),
    [anon_sym__Generic] = ACTIONS(2398),
    [anon_sym_asm] = ACTIONS(2398),
    [anon_sym___asm__] = ACTIONS(2398),
    [anon_sym___asm] = ACTIONS(2398),
    [sym_number_literal] = ACTIONS(2400),
    [anon_sym_L_SQUOTE] = ACTIONS(2400),
    [anon_sym_u_SQUOTE] = ACTIONS(2400),
    [anon_sym_U_SQUOTE] = ACTIONS(2400),
    [anon_sym_u8_SQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_L_DQUOTE] = ACTIONS(2400),
    [anon_sym_u_DQUOTE] = ACTIONS(2400),
    [anon_sym_U_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [anon_sym_NULL] = ACTIONS(2398),
    [anon_sym_nullptr] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2398),
    [anon_sym_decltype] = ACTIONS(2398),
    [anon_sym_explicit] = ACTIONS(2398),
    [anon_sym_typename] = ACTIONS(2398),
    [anon_sym_template] = ACTIONS(2398),
    [anon_sym_operator] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_static_assert] = ACTIONS(2398),
    [anon_sym_concept] = ACTIONS(2398),
    [anon_sym_co_return] = ACTIONS(2398),
    [anon_sym_co_yield] = ACTIONS(2398),
    [anon_sym_R_DQUOTE] = ACTIONS(2400),
    [anon_sym_LR_DQUOTE] = ACTIONS(2400),
    [anon_sym_uR_DQUOTE] = ACTIONS(2400),
    [anon_sym_UR_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2400),
    [anon_sym_co_await] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_requires] = ACTIONS(2398),
    [sym_this] = ACTIONS(2398),
    [anon_sym_discard] = ACTIONS(2398),
    [anon_sym_precise] = ACTIONS(2398),
    [anon_sym_shared] = ACTIONS(2398),
    [anon_sym_groupshared] = ACTIONS(2398),
    [anon_sym_uniform] = ACTIONS(2398),
    [anon_sym_row_major] = ACTIONS(2398),
    [anon_sym_column_major] = ACTIONS(2398),
    [anon_sym_globallycoherent] = ACTIONS(2398),
    [anon_sym_centroid] = ACTIONS(2398),
    [anon_sym_noperspective] = ACTIONS(2398),
    [anon_sym_nointerpolation] = ACTIONS(2398),
    [anon_sym_sample] = ACTIONS(2398),
    [anon_sym_linear] = ACTIONS(2398),
    [anon_sym_snorm] = ACTIONS(2398),
    [anon_sym_unorm] = ACTIONS(2398),
    [anon_sym_point] = ACTIONS(2398),
    [anon_sym_line] = ACTIONS(2398),
    [anon_sym_triangleadj] = ACTIONS(2398),
    [anon_sym_lineadj] = ACTIONS(2398),
    [anon_sym_triangle] = ACTIONS(2398),
    [anon_sym_cbuffer] = ACTIONS(2398),
  },
  [503] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_include_token1] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym___cdecl] = ACTIONS(2382),
    [anon_sym___clrcall] = ACTIONS(2382),
    [anon_sym___stdcall] = ACTIONS(2382),
    [anon_sym___fastcall] = ACTIONS(2382),
    [anon_sym___thiscall] = ACTIONS(2382),
    [anon_sym___vectorcall] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2382),
    [anon_sym___leave] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2382),
    [anon_sym_compl] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2382),
    [anon_sym___alignof__] = ACTIONS(2382),
    [anon_sym___alignof] = ACTIONS(2382),
    [anon_sym__alignof] = ACTIONS(2382),
    [anon_sym_alignof] = ACTIONS(2382),
    [anon_sym__Alignof] = ACTIONS(2382),
    [anon_sym_offsetof] = ACTIONS(2382),
    [anon_sym__Generic] = ACTIONS(2382),
    [anon_sym_asm] = ACTIONS(2382),
    [anon_sym___asm__] = ACTIONS(2382),
    [anon_sym___asm] = ACTIONS(2382),
    [sym_number_literal] = ACTIONS(2384),
    [anon_sym_L_SQUOTE] = ACTIONS(2384),
    [anon_sym_u_SQUOTE] = ACTIONS(2384),
    [anon_sym_U_SQUOTE] = ACTIONS(2384),
    [anon_sym_u8_SQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_L_DQUOTE] = ACTIONS(2384),
    [anon_sym_u_DQUOTE] = ACTIONS(2384),
    [anon_sym_U_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8_DQUOTE] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_concept] = ACTIONS(2382),
    [anon_sym_co_return] = ACTIONS(2382),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2384),
    [anon_sym_LR_DQUOTE] = ACTIONS(2384),
    [anon_sym_uR_DQUOTE] = ACTIONS(2384),
    [anon_sym_UR_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2384),
    [anon_sym_co_await] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_requires] = ACTIONS(2382),
    [sym_this] = ACTIONS(2382),
    [anon_sym_discard] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
    [anon_sym_cbuffer] = ACTIONS(2382),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2171),
    [aux_sym_preproc_include_token1] = ACTIONS(2171),
    [aux_sym_preproc_def_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token2] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2171),
    [sym_preproc_directive] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2171),
    [anon_sym_typedef] = ACTIONS(2171),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_out] = ACTIONS(2171),
    [anon_sym_inout] = ACTIONS(2171),
    [anon_sym_virtual] = ACTIONS(2171),
    [anon_sym_extern] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2171),
    [anon_sym___attribute] = ACTIONS(2171),
    [anon_sym_using] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2171),
    [anon_sym___based] = ACTIONS(2171),
    [anon_sym___cdecl] = ACTIONS(2171),
    [anon_sym___clrcall] = ACTIONS(2171),
    [anon_sym___stdcall] = ACTIONS(2171),
    [anon_sym___fastcall] = ACTIONS(2171),
    [anon_sym___thiscall] = ACTIONS(2171),
    [anon_sym___vectorcall] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_signed] = ACTIONS(2171),
    [anon_sym_unsigned] = ACTIONS(2171),
    [anon_sym_long] = ACTIONS(2171),
    [anon_sym_short] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_register] = ACTIONS(2171),
    [anon_sym_inline] = ACTIONS(2171),
    [anon_sym___inline] = ACTIONS(2171),
    [anon_sym___inline__] = ACTIONS(2171),
    [anon_sym___forceinline] = ACTIONS(2171),
    [anon_sym_thread_local] = ACTIONS(2171),
    [anon_sym___thread] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_constexpr] = ACTIONS(2171),
    [anon_sym_volatile] = ACTIONS(2171),
    [anon_sym_restrict] = ACTIONS(2171),
    [anon_sym___restrict__] = ACTIONS(2171),
    [anon_sym__Atomic] = ACTIONS(2171),
    [anon_sym__Noreturn] = ACTIONS(2171),
    [anon_sym_noreturn] = ACTIONS(2171),
    [anon_sym__Nonnull] = ACTIONS(2171),
    [anon_sym_mutable] = ACTIONS(2171),
    [anon_sym_constinit] = ACTIONS(2171),
    [anon_sym_consteval] = ACTIONS(2171),
    [anon_sym_alignas] = ACTIONS(2171),
    [anon_sym__Alignas] = ACTIONS(2171),
    [sym_primitive_type] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_struct] = ACTIONS(2171),
    [anon_sym_union] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2171),
    [anon_sym_default] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_goto] = ACTIONS(2171),
    [anon_sym___try] = ACTIONS(2171),
    [anon_sym___leave] = ACTIONS(2171),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_compl] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2171),
    [anon_sym___alignof__] = ACTIONS(2171),
    [anon_sym___alignof] = ACTIONS(2171),
    [anon_sym__alignof] = ACTIONS(2171),
    [anon_sym_alignof] = ACTIONS(2171),
    [anon_sym__Alignof] = ACTIONS(2171),
    [anon_sym_offsetof] = ACTIONS(2171),
    [anon_sym__Generic] = ACTIONS(2171),
    [anon_sym_asm] = ACTIONS(2171),
    [anon_sym___asm__] = ACTIONS(2171),
    [anon_sym___asm] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2173),
    [anon_sym_u_SQUOTE] = ACTIONS(2173),
    [anon_sym_U_SQUOTE] = ACTIONS(2173),
    [anon_sym_u8_SQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_L_DQUOTE] = ACTIONS(2173),
    [anon_sym_u_DQUOTE] = ACTIONS(2173),
    [anon_sym_U_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8_DQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [anon_sym_NULL] = ACTIONS(2171),
    [anon_sym_nullptr] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2171),
    [anon_sym_decltype] = ACTIONS(2171),
    [anon_sym_explicit] = ACTIONS(2171),
    [anon_sym_typename] = ACTIONS(2171),
    [anon_sym_template] = ACTIONS(2171),
    [anon_sym_operator] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_static_assert] = ACTIONS(2171),
    [anon_sym_concept] = ACTIONS(2171),
    [anon_sym_co_return] = ACTIONS(2171),
    [anon_sym_co_yield] = ACTIONS(2171),
    [anon_sym_R_DQUOTE] = ACTIONS(2173),
    [anon_sym_LR_DQUOTE] = ACTIONS(2173),
    [anon_sym_uR_DQUOTE] = ACTIONS(2173),
    [anon_sym_UR_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2173),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_requires] = ACTIONS(2171),
    [sym_this] = ACTIONS(2171),
    [anon_sym_discard] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2171),
    [anon_sym_shared] = ACTIONS(2171),
    [anon_sym_groupshared] = ACTIONS(2171),
    [anon_sym_uniform] = ACTIONS(2171),
    [anon_sym_row_major] = ACTIONS(2171),
    [anon_sym_column_major] = ACTIONS(2171),
    [anon_sym_globallycoherent] = ACTIONS(2171),
    [anon_sym_centroid] = ACTIONS(2171),
    [anon_sym_noperspective] = ACTIONS(2171),
    [anon_sym_nointerpolation] = ACTIONS(2171),
    [anon_sym_sample] = ACTIONS(2171),
    [anon_sym_linear] = ACTIONS(2171),
    [anon_sym_snorm] = ACTIONS(2171),
    [anon_sym_unorm] = ACTIONS(2171),
    [anon_sym_point] = ACTIONS(2171),
    [anon_sym_line] = ACTIONS(2171),
    [anon_sym_triangleadj] = ACTIONS(2171),
    [anon_sym_lineadj] = ACTIONS(2171),
    [anon_sym_triangle] = ACTIONS(2171),
    [anon_sym_cbuffer] = ACTIONS(2171),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2155),
    [aux_sym_preproc_include_token1] = ACTIONS(2155),
    [aux_sym_preproc_def_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token2] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2155),
    [sym_preproc_directive] = ACTIONS(2155),
    [anon_sym_LPAREN2] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym___extension__] = ACTIONS(2155),
    [anon_sym_typedef] = ACTIONS(2155),
    [anon_sym_in] = ACTIONS(2155),
    [anon_sym_out] = ACTIONS(2155),
    [anon_sym_inout] = ACTIONS(2155),
    [anon_sym_virtual] = ACTIONS(2155),
    [anon_sym_extern] = ACTIONS(2155),
    [anon_sym___attribute__] = ACTIONS(2155),
    [anon_sym___attribute] = ACTIONS(2155),
    [anon_sym_using] = ACTIONS(2155),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2157),
    [anon_sym___declspec] = ACTIONS(2155),
    [anon_sym___based] = ACTIONS(2155),
    [anon_sym___cdecl] = ACTIONS(2155),
    [anon_sym___clrcall] = ACTIONS(2155),
    [anon_sym___stdcall] = ACTIONS(2155),
    [anon_sym___fastcall] = ACTIONS(2155),
    [anon_sym___thiscall] = ACTIONS(2155),
    [anon_sym___vectorcall] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_signed] = ACTIONS(2155),
    [anon_sym_unsigned] = ACTIONS(2155),
    [anon_sym_long] = ACTIONS(2155),
    [anon_sym_short] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_register] = ACTIONS(2155),
    [anon_sym_inline] = ACTIONS(2155),
    [anon_sym___inline] = ACTIONS(2155),
    [anon_sym___inline__] = ACTIONS(2155),
    [anon_sym___forceinline] = ACTIONS(2155),
    [anon_sym_thread_local] = ACTIONS(2155),
    [anon_sym___thread] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_constexpr] = ACTIONS(2155),
    [anon_sym_volatile] = ACTIONS(2155),
    [anon_sym_restrict] = ACTIONS(2155),
    [anon_sym___restrict__] = ACTIONS(2155),
    [anon_sym__Atomic] = ACTIONS(2155),
    [anon_sym__Noreturn] = ACTIONS(2155),
    [anon_sym_noreturn] = ACTIONS(2155),
    [anon_sym__Nonnull] = ACTIONS(2155),
    [anon_sym_mutable] = ACTIONS(2155),
    [anon_sym_constinit] = ACTIONS(2155),
    [anon_sym_consteval] = ACTIONS(2155),
    [anon_sym_alignas] = ACTIONS(2155),
    [anon_sym__Alignas] = ACTIONS(2155),
    [sym_primitive_type] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_struct] = ACTIONS(2155),
    [anon_sym_union] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2155),
    [anon_sym_default] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_goto] = ACTIONS(2155),
    [anon_sym___try] = ACTIONS(2155),
    [anon_sym___leave] = ACTIONS(2155),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_compl] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_sizeof] = ACTIONS(2155),
    [anon_sym___alignof__] = ACTIONS(2155),
    [anon_sym___alignof] = ACTIONS(2155),
    [anon_sym__alignof] = ACTIONS(2155),
    [anon_sym_alignof] = ACTIONS(2155),
    [anon_sym__Alignof] = ACTIONS(2155),
    [anon_sym_offsetof] = ACTIONS(2155),
    [anon_sym__Generic] = ACTIONS(2155),
    [anon_sym_asm] = ACTIONS(2155),
    [anon_sym___asm__] = ACTIONS(2155),
    [anon_sym___asm] = ACTIONS(2155),
    [sym_number_literal] = ACTIONS(2157),
    [anon_sym_L_SQUOTE] = ACTIONS(2157),
    [anon_sym_u_SQUOTE] = ACTIONS(2157),
    [anon_sym_U_SQUOTE] = ACTIONS(2157),
    [anon_sym_u8_SQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [anon_sym_L_DQUOTE] = ACTIONS(2157),
    [anon_sym_u_DQUOTE] = ACTIONS(2157),
    [anon_sym_U_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8_DQUOTE] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [anon_sym_NULL] = ACTIONS(2155),
    [anon_sym_nullptr] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2155),
    [anon_sym_decltype] = ACTIONS(2155),
    [anon_sym_explicit] = ACTIONS(2155),
    [anon_sym_typename] = ACTIONS(2155),
    [anon_sym_template] = ACTIONS(2155),
    [anon_sym_operator] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_static_assert] = ACTIONS(2155),
    [anon_sym_concept] = ACTIONS(2155),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2155),
    [anon_sym_R_DQUOTE] = ACTIONS(2157),
    [anon_sym_LR_DQUOTE] = ACTIONS(2157),
    [anon_sym_uR_DQUOTE] = ACTIONS(2157),
    [anon_sym_UR_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2157),
    [anon_sym_co_await] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_requires] = ACTIONS(2155),
    [sym_this] = ACTIONS(2155),
    [anon_sym_discard] = ACTIONS(2155),
    [anon_sym_precise] = ACTIONS(2155),
    [anon_sym_shared] = ACTIONS(2155),
    [anon_sym_groupshared] = ACTIONS(2155),
    [anon_sym_uniform] = ACTIONS(2155),
    [anon_sym_row_major] = ACTIONS(2155),
    [anon_sym_column_major] = ACTIONS(2155),
    [anon_sym_globallycoherent] = ACTIONS(2155),
    [anon_sym_centroid] = ACTIONS(2155),
    [anon_sym_noperspective] = ACTIONS(2155),
    [anon_sym_nointerpolation] = ACTIONS(2155),
    [anon_sym_sample] = ACTIONS(2155),
    [anon_sym_linear] = ACTIONS(2155),
    [anon_sym_snorm] = ACTIONS(2155),
    [anon_sym_unorm] = ACTIONS(2155),
    [anon_sym_point] = ACTIONS(2155),
    [anon_sym_line] = ACTIONS(2155),
    [anon_sym_triangleadj] = ACTIONS(2155),
    [anon_sym_lineadj] = ACTIONS(2155),
    [anon_sym_triangle] = ACTIONS(2155),
    [anon_sym_cbuffer] = ACTIONS(2155),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_include_token1] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token2] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_AMP_AMP] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_virtual] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym___attribute] = ACTIONS(2214),
    [anon_sym_using] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym___based] = ACTIONS(2214),
    [anon_sym___cdecl] = ACTIONS(2214),
    [anon_sym___clrcall] = ACTIONS(2214),
    [anon_sym___stdcall] = ACTIONS(2214),
    [anon_sym___fastcall] = ACTIONS(2214),
    [anon_sym___thiscall] = ACTIONS(2214),
    [anon_sym___vectorcall] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym__Nonnull] = ACTIONS(2214),
    [anon_sym_mutable] = ACTIONS(2214),
    [anon_sym_constinit] = ACTIONS(2214),
    [anon_sym_consteval] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_goto] = ACTIONS(2214),
    [anon_sym___try] = ACTIONS(2214),
    [anon_sym___leave] = ACTIONS(2214),
    [anon_sym_not] = ACTIONS(2214),
    [anon_sym_compl] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2214),
    [anon_sym___alignof__] = ACTIONS(2214),
    [anon_sym___alignof] = ACTIONS(2214),
    [anon_sym__alignof] = ACTIONS(2214),
    [anon_sym_alignof] = ACTIONS(2214),
    [anon_sym__Alignof] = ACTIONS(2214),
    [anon_sym_offsetof] = ACTIONS(2214),
    [anon_sym__Generic] = ACTIONS(2214),
    [anon_sym_asm] = ACTIONS(2214),
    [anon_sym___asm__] = ACTIONS(2214),
    [anon_sym___asm] = ACTIONS(2214),
    [sym_number_literal] = ACTIONS(2216),
    [anon_sym_L_SQUOTE] = ACTIONS(2216),
    [anon_sym_u_SQUOTE] = ACTIONS(2216),
    [anon_sym_U_SQUOTE] = ACTIONS(2216),
    [anon_sym_u8_SQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_L_DQUOTE] = ACTIONS(2216),
    [anon_sym_u_DQUOTE] = ACTIONS(2216),
    [anon_sym_U_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8_DQUOTE] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [anon_sym_NULL] = ACTIONS(2214),
    [anon_sym_nullptr] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2214),
    [anon_sym_decltype] = ACTIONS(2214),
    [anon_sym_explicit] = ACTIONS(2214),
    [anon_sym_typename] = ACTIONS(2214),
    [anon_sym_template] = ACTIONS(2214),
    [anon_sym_operator] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_static_assert] = ACTIONS(2214),
    [anon_sym_concept] = ACTIONS(2214),
    [anon_sym_co_return] = ACTIONS(2214),
    [anon_sym_co_yield] = ACTIONS(2214),
    [anon_sym_R_DQUOTE] = ACTIONS(2216),
    [anon_sym_LR_DQUOTE] = ACTIONS(2216),
    [anon_sym_uR_DQUOTE] = ACTIONS(2216),
    [anon_sym_UR_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2216),
    [anon_sym_co_await] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_requires] = ACTIONS(2214),
    [sym_this] = ACTIONS(2214),
    [anon_sym_discard] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_groupshared] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_row_major] = ACTIONS(2214),
    [anon_sym_column_major] = ACTIONS(2214),
    [anon_sym_globallycoherent] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym_nointerpolation] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_linear] = ACTIONS(2214),
    [anon_sym_snorm] = ACTIONS(2214),
    [anon_sym_unorm] = ACTIONS(2214),
    [anon_sym_point] = ACTIONS(2214),
    [anon_sym_line] = ACTIONS(2214),
    [anon_sym_triangleadj] = ACTIONS(2214),
    [anon_sym_lineadj] = ACTIONS(2214),
    [anon_sym_triangle] = ACTIONS(2214),
    [anon_sym_cbuffer] = ACTIONS(2214),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_include_token1] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token2] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AMP_AMP] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_typedef] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_virtual] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym___attribute] = ACTIONS(2218),
    [anon_sym_using] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym___based] = ACTIONS(2218),
    [anon_sym___cdecl] = ACTIONS(2218),
    [anon_sym___clrcall] = ACTIONS(2218),
    [anon_sym___stdcall] = ACTIONS(2218),
    [anon_sym___fastcall] = ACTIONS(2218),
    [anon_sym___thiscall] = ACTIONS(2218),
    [anon_sym___vectorcall] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym__Nonnull] = ACTIONS(2218),
    [anon_sym_mutable] = ACTIONS(2218),
    [anon_sym_constinit] = ACTIONS(2218),
    [anon_sym_consteval] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_goto] = ACTIONS(2218),
    [anon_sym___try] = ACTIONS(2218),
    [anon_sym___leave] = ACTIONS(2218),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_compl] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2218),
    [anon_sym___alignof__] = ACTIONS(2218),
    [anon_sym___alignof] = ACTIONS(2218),
    [anon_sym__alignof] = ACTIONS(2218),
    [anon_sym_alignof] = ACTIONS(2218),
    [anon_sym__Alignof] = ACTIONS(2218),
    [anon_sym_offsetof] = ACTIONS(2218),
    [anon_sym__Generic] = ACTIONS(2218),
    [anon_sym_asm] = ACTIONS(2218),
    [anon_sym___asm__] = ACTIONS(2218),
    [anon_sym___asm] = ACTIONS(2218),
    [sym_number_literal] = ACTIONS(2220),
    [anon_sym_L_SQUOTE] = ACTIONS(2220),
    [anon_sym_u_SQUOTE] = ACTIONS(2220),
    [anon_sym_U_SQUOTE] = ACTIONS(2220),
    [anon_sym_u8_SQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_L_DQUOTE] = ACTIONS(2220),
    [anon_sym_u_DQUOTE] = ACTIONS(2220),
    [anon_sym_U_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8_DQUOTE] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [anon_sym_NULL] = ACTIONS(2218),
    [anon_sym_nullptr] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2218),
    [anon_sym_decltype] = ACTIONS(2218),
    [anon_sym_explicit] = ACTIONS(2218),
    [anon_sym_typename] = ACTIONS(2218),
    [anon_sym_template] = ACTIONS(2218),
    [anon_sym_operator] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_namespace] = ACTIONS(2218),
    [anon_sym_static_assert] = ACTIONS(2218),
    [anon_sym_concept] = ACTIONS(2218),
    [anon_sym_co_return] = ACTIONS(2218),
    [anon_sym_co_yield] = ACTIONS(2218),
    [anon_sym_R_DQUOTE] = ACTIONS(2220),
    [anon_sym_LR_DQUOTE] = ACTIONS(2220),
    [anon_sym_uR_DQUOTE] = ACTIONS(2220),
    [anon_sym_UR_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2220),
    [anon_sym_co_await] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_requires] = ACTIONS(2218),
    [sym_this] = ACTIONS(2218),
    [anon_sym_discard] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_groupshared] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_row_major] = ACTIONS(2218),
    [anon_sym_column_major] = ACTIONS(2218),
    [anon_sym_globallycoherent] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym_nointerpolation] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_linear] = ACTIONS(2218),
    [anon_sym_snorm] = ACTIONS(2218),
    [anon_sym_unorm] = ACTIONS(2218),
    [anon_sym_point] = ACTIONS(2218),
    [anon_sym_line] = ACTIONS(2218),
    [anon_sym_triangleadj] = ACTIONS(2218),
    [anon_sym_lineadj] = ACTIONS(2218),
    [anon_sym_triangle] = ACTIONS(2218),
    [anon_sym_cbuffer] = ACTIONS(2218),
  },
  [508] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [509] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token2] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2224),
    [anon_sym_L_SQUOTE] = ACTIONS(2224),
    [anon_sym_u_SQUOTE] = ACTIONS(2224),
    [anon_sym_U_SQUOTE] = ACTIONS(2224),
    [anon_sym_u8_SQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_L_DQUOTE] = ACTIONS(2224),
    [anon_sym_u_DQUOTE] = ACTIONS(2224),
    [anon_sym_U_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8_DQUOTE] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2224),
    [anon_sym_LR_DQUOTE] = ACTIONS(2224),
    [anon_sym_uR_DQUOTE] = ACTIONS(2224),
    [anon_sym_UR_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2224),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_include_token1] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token2] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_typedef] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_virtual] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym___attribute] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym___based] = ACTIONS(2226),
    [anon_sym___cdecl] = ACTIONS(2226),
    [anon_sym___clrcall] = ACTIONS(2226),
    [anon_sym___stdcall] = ACTIONS(2226),
    [anon_sym___fastcall] = ACTIONS(2226),
    [anon_sym___thiscall] = ACTIONS(2226),
    [anon_sym___vectorcall] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym__Nonnull] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_goto] = ACTIONS(2226),
    [anon_sym___try] = ACTIONS(2226),
    [anon_sym___leave] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2226),
    [anon_sym_compl] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2226),
    [anon_sym___alignof__] = ACTIONS(2226),
    [anon_sym___alignof] = ACTIONS(2226),
    [anon_sym__alignof] = ACTIONS(2226),
    [anon_sym_alignof] = ACTIONS(2226),
    [anon_sym__Alignof] = ACTIONS(2226),
    [anon_sym_offsetof] = ACTIONS(2226),
    [anon_sym__Generic] = ACTIONS(2226),
    [anon_sym_asm] = ACTIONS(2226),
    [anon_sym___asm__] = ACTIONS(2226),
    [anon_sym___asm] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2228),
    [anon_sym_L_SQUOTE] = ACTIONS(2228),
    [anon_sym_u_SQUOTE] = ACTIONS(2228),
    [anon_sym_U_SQUOTE] = ACTIONS(2228),
    [anon_sym_u8_SQUOTE] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_L_DQUOTE] = ACTIONS(2228),
    [anon_sym_u_DQUOTE] = ACTIONS(2228),
    [anon_sym_U_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [anon_sym_NULL] = ACTIONS(2226),
    [anon_sym_nullptr] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2226),
    [anon_sym_decltype] = ACTIONS(2226),
    [anon_sym_explicit] = ACTIONS(2226),
    [anon_sym_typename] = ACTIONS(2226),
    [anon_sym_template] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_static_assert] = ACTIONS(2226),
    [anon_sym_concept] = ACTIONS(2226),
    [anon_sym_co_return] = ACTIONS(2226),
    [anon_sym_co_yield] = ACTIONS(2226),
    [anon_sym_R_DQUOTE] = ACTIONS(2228),
    [anon_sym_LR_DQUOTE] = ACTIONS(2228),
    [anon_sym_uR_DQUOTE] = ACTIONS(2228),
    [anon_sym_UR_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2228),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [anon_sym_discard] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_groupshared] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_row_major] = ACTIONS(2226),
    [anon_sym_column_major] = ACTIONS(2226),
    [anon_sym_globallycoherent] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym_nointerpolation] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_linear] = ACTIONS(2226),
    [anon_sym_snorm] = ACTIONS(2226),
    [anon_sym_unorm] = ACTIONS(2226),
    [anon_sym_point] = ACTIONS(2226),
    [anon_sym_line] = ACTIONS(2226),
    [anon_sym_triangleadj] = ACTIONS(2226),
    [anon_sym_lineadj] = ACTIONS(2226),
    [anon_sym_triangle] = ACTIONS(2226),
    [anon_sym_cbuffer] = ACTIONS(2226),
  },
  [511] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_include_token1] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token2] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AMP_AMP] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_typedef] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_virtual] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym___attribute] = ACTIONS(2230),
    [anon_sym_using] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym___based] = ACTIONS(2230),
    [anon_sym___cdecl] = ACTIONS(2230),
    [anon_sym___clrcall] = ACTIONS(2230),
    [anon_sym___stdcall] = ACTIONS(2230),
    [anon_sym___fastcall] = ACTIONS(2230),
    [anon_sym___thiscall] = ACTIONS(2230),
    [anon_sym___vectorcall] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym__Nonnull] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_class] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2230),
    [anon_sym_switch] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_goto] = ACTIONS(2230),
    [anon_sym___try] = ACTIONS(2230),
    [anon_sym___leave] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2232),
    [anon_sym_sizeof] = ACTIONS(2230),
    [anon_sym___alignof__] = ACTIONS(2230),
    [anon_sym___alignof] = ACTIONS(2230),
    [anon_sym__alignof] = ACTIONS(2230),
    [anon_sym_alignof] = ACTIONS(2230),
    [anon_sym__Alignof] = ACTIONS(2230),
    [anon_sym_offsetof] = ACTIONS(2230),
    [anon_sym__Generic] = ACTIONS(2230),
    [anon_sym_asm] = ACTIONS(2230),
    [anon_sym___asm__] = ACTIONS(2230),
    [anon_sym___asm] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2232),
    [anon_sym_L_SQUOTE] = ACTIONS(2232),
    [anon_sym_u_SQUOTE] = ACTIONS(2232),
    [anon_sym_U_SQUOTE] = ACTIONS(2232),
    [anon_sym_u8_SQUOTE] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_L_DQUOTE] = ACTIONS(2232),
    [anon_sym_u_DQUOTE] = ACTIONS(2232),
    [anon_sym_U_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8_DQUOTE] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [sym_true] = ACTIONS(2230),
    [sym_false] = ACTIONS(2230),
    [anon_sym_NULL] = ACTIONS(2230),
    [anon_sym_nullptr] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2230),
    [anon_sym_decltype] = ACTIONS(2230),
    [anon_sym_explicit] = ACTIONS(2230),
    [anon_sym_typename] = ACTIONS(2230),
    [anon_sym_template] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_delete] = ACTIONS(2230),
    [anon_sym_throw] = ACTIONS(2230),
    [anon_sym_namespace] = ACTIONS(2230),
    [anon_sym_static_assert] = ACTIONS(2230),
    [anon_sym_concept] = ACTIONS(2230),
    [anon_sym_co_return] = ACTIONS(2230),
    [anon_sym_co_yield] = ACTIONS(2230),
    [anon_sym_R_DQUOTE] = ACTIONS(2232),
    [anon_sym_LR_DQUOTE] = ACTIONS(2232),
    [anon_sym_uR_DQUOTE] = ACTIONS(2232),
    [anon_sym_UR_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2232),
    [anon_sym_co_await] = ACTIONS(2230),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2230),
    [sym_this] = ACTIONS(2230),
    [anon_sym_discard] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_groupshared] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_row_major] = ACTIONS(2230),
    [anon_sym_column_major] = ACTIONS(2230),
    [anon_sym_globallycoherent] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym_nointerpolation] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_linear] = ACTIONS(2230),
    [anon_sym_snorm] = ACTIONS(2230),
    [anon_sym_unorm] = ACTIONS(2230),
    [anon_sym_point] = ACTIONS(2230),
    [anon_sym_line] = ACTIONS(2230),
    [anon_sym_triangleadj] = ACTIONS(2230),
    [anon_sym_lineadj] = ACTIONS(2230),
    [anon_sym_triangle] = ACTIONS(2230),
    [anon_sym_cbuffer] = ACTIONS(2230),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_include_token1] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token2] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_typedef] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_virtual] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym___based] = ACTIONS(2234),
    [anon_sym___cdecl] = ACTIONS(2234),
    [anon_sym___clrcall] = ACTIONS(2234),
    [anon_sym___stdcall] = ACTIONS(2234),
    [anon_sym___fastcall] = ACTIONS(2234),
    [anon_sym___thiscall] = ACTIONS(2234),
    [anon_sym___vectorcall] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym__Nonnull] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_goto] = ACTIONS(2234),
    [anon_sym___try] = ACTIONS(2234),
    [anon_sym___leave] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2234),
    [anon_sym_compl] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2236),
    [anon_sym_sizeof] = ACTIONS(2234),
    [anon_sym___alignof__] = ACTIONS(2234),
    [anon_sym___alignof] = ACTIONS(2234),
    [anon_sym__alignof] = ACTIONS(2234),
    [anon_sym_alignof] = ACTIONS(2234),
    [anon_sym__Alignof] = ACTIONS(2234),
    [anon_sym_offsetof] = ACTIONS(2234),
    [anon_sym__Generic] = ACTIONS(2234),
    [anon_sym_asm] = ACTIONS(2234),
    [anon_sym___asm__] = ACTIONS(2234),
    [anon_sym___asm] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2236),
    [anon_sym_L_SQUOTE] = ACTIONS(2236),
    [anon_sym_u_SQUOTE] = ACTIONS(2236),
    [anon_sym_U_SQUOTE] = ACTIONS(2236),
    [anon_sym_u8_SQUOTE] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_L_DQUOTE] = ACTIONS(2236),
    [anon_sym_u_DQUOTE] = ACTIONS(2236),
    [anon_sym_U_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8_DQUOTE] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2236),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [anon_sym_NULL] = ACTIONS(2234),
    [anon_sym_nullptr] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2234),
    [anon_sym_decltype] = ACTIONS(2234),
    [anon_sym_explicit] = ACTIONS(2234),
    [anon_sym_typename] = ACTIONS(2234),
    [anon_sym_template] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_static_assert] = ACTIONS(2234),
    [anon_sym_concept] = ACTIONS(2234),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2236),
    [anon_sym_LR_DQUOTE] = ACTIONS(2236),
    [anon_sym_uR_DQUOTE] = ACTIONS(2236),
    [anon_sym_UR_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2236),
    [anon_sym_co_await] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [anon_sym_discard] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_groupshared] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_row_major] = ACTIONS(2234),
    [anon_sym_column_major] = ACTIONS(2234),
    [anon_sym_globallycoherent] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym_nointerpolation] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_linear] = ACTIONS(2234),
    [anon_sym_snorm] = ACTIONS(2234),
    [anon_sym_unorm] = ACTIONS(2234),
    [anon_sym_point] = ACTIONS(2234),
    [anon_sym_line] = ACTIONS(2234),
    [anon_sym_triangleadj] = ACTIONS(2234),
    [anon_sym_lineadj] = ACTIONS(2234),
    [anon_sym_triangle] = ACTIONS(2234),
    [anon_sym_cbuffer] = ACTIONS(2234),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_include_token1] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token2] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_AMP_AMP] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_typedef] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_virtual] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym___attribute] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym___based] = ACTIONS(2238),
    [anon_sym___cdecl] = ACTIONS(2238),
    [anon_sym___clrcall] = ACTIONS(2238),
    [anon_sym___stdcall] = ACTIONS(2238),
    [anon_sym___fastcall] = ACTIONS(2238),
    [anon_sym___thiscall] = ACTIONS(2238),
    [anon_sym___vectorcall] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym__Nonnull] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_do] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2238),
    [anon_sym___try] = ACTIONS(2238),
    [anon_sym___leave] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2238),
    [anon_sym_compl] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2238),
    [anon_sym___alignof] = ACTIONS(2238),
    [anon_sym__alignof] = ACTIONS(2238),
    [anon_sym_alignof] = ACTIONS(2238),
    [anon_sym__Alignof] = ACTIONS(2238),
    [anon_sym_offsetof] = ACTIONS(2238),
    [anon_sym__Generic] = ACTIONS(2238),
    [anon_sym_asm] = ACTIONS(2238),
    [anon_sym___asm__] = ACTIONS(2238),
    [anon_sym___asm] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2240),
    [anon_sym_L_SQUOTE] = ACTIONS(2240),
    [anon_sym_u_SQUOTE] = ACTIONS(2240),
    [anon_sym_U_SQUOTE] = ACTIONS(2240),
    [anon_sym_u8_SQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_L_DQUOTE] = ACTIONS(2240),
    [anon_sym_u_DQUOTE] = ACTIONS(2240),
    [anon_sym_U_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [anon_sym_NULL] = ACTIONS(2238),
    [anon_sym_nullptr] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2238),
    [anon_sym_decltype] = ACTIONS(2238),
    [anon_sym_explicit] = ACTIONS(2238),
    [anon_sym_typename] = ACTIONS(2238),
    [anon_sym_template] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [anon_sym_delete] = ACTIONS(2238),
    [anon_sym_throw] = ACTIONS(2238),
    [anon_sym_namespace] = ACTIONS(2238),
    [anon_sym_static_assert] = ACTIONS(2238),
    [anon_sym_concept] = ACTIONS(2238),
    [anon_sym_co_return] = ACTIONS(2238),
    [anon_sym_co_yield] = ACTIONS(2238),
    [anon_sym_R_DQUOTE] = ACTIONS(2240),
    [anon_sym_LR_DQUOTE] = ACTIONS(2240),
    [anon_sym_uR_DQUOTE] = ACTIONS(2240),
    [anon_sym_UR_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2240),
    [anon_sym_co_await] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2238),
    [sym_this] = ACTIONS(2238),
    [anon_sym_discard] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_groupshared] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_row_major] = ACTIONS(2238),
    [anon_sym_column_major] = ACTIONS(2238),
    [anon_sym_globallycoherent] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym_nointerpolation] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_linear] = ACTIONS(2238),
    [anon_sym_snorm] = ACTIONS(2238),
    [anon_sym_unorm] = ACTIONS(2238),
    [anon_sym_point] = ACTIONS(2238),
    [anon_sym_line] = ACTIONS(2238),
    [anon_sym_triangleadj] = ACTIONS(2238),
    [anon_sym_lineadj] = ACTIONS(2238),
    [anon_sym_triangle] = ACTIONS(2238),
    [anon_sym_cbuffer] = ACTIONS(2238),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_RPAREN] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_export] = ACTIONS(1951),
    [anon_sym_module] = ACTIONS(1951),
    [anon_sym_import] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [515] = {
    [sym_identifier] = ACTIONS(2386),
    [aux_sym_preproc_include_token1] = ACTIONS(2386),
    [aux_sym_preproc_def_token1] = ACTIONS(2386),
    [aux_sym_preproc_if_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2386),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2386),
    [sym_preproc_directive] = ACTIONS(2386),
    [anon_sym_LPAREN2] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2386),
    [anon_sym_typedef] = ACTIONS(2386),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_out] = ACTIONS(2386),
    [anon_sym_inout] = ACTIONS(2386),
    [anon_sym_virtual] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym___attribute__] = ACTIONS(2386),
    [anon_sym___attribute] = ACTIONS(2386),
    [anon_sym_using] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2388),
    [anon_sym___declspec] = ACTIONS(2386),
    [anon_sym___based] = ACTIONS(2386),
    [anon_sym___cdecl] = ACTIONS(2386),
    [anon_sym___clrcall] = ACTIONS(2386),
    [anon_sym___stdcall] = ACTIONS(2386),
    [anon_sym___fastcall] = ACTIONS(2386),
    [anon_sym___thiscall] = ACTIONS(2386),
    [anon_sym___vectorcall] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2386),
    [anon_sym_unsigned] = ACTIONS(2386),
    [anon_sym_long] = ACTIONS(2386),
    [anon_sym_short] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_register] = ACTIONS(2386),
    [anon_sym_inline] = ACTIONS(2386),
    [anon_sym___inline] = ACTIONS(2386),
    [anon_sym___inline__] = ACTIONS(2386),
    [anon_sym___forceinline] = ACTIONS(2386),
    [anon_sym_thread_local] = ACTIONS(2386),
    [anon_sym___thread] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_constexpr] = ACTIONS(2386),
    [anon_sym_volatile] = ACTIONS(2386),
    [anon_sym_restrict] = ACTIONS(2386),
    [anon_sym___restrict__] = ACTIONS(2386),
    [anon_sym__Atomic] = ACTIONS(2386),
    [anon_sym__Noreturn] = ACTIONS(2386),
    [anon_sym_noreturn] = ACTIONS(2386),
    [anon_sym__Nonnull] = ACTIONS(2386),
    [anon_sym_mutable] = ACTIONS(2386),
    [anon_sym_constinit] = ACTIONS(2386),
    [anon_sym_consteval] = ACTIONS(2386),
    [anon_sym_alignas] = ACTIONS(2386),
    [anon_sym__Alignas] = ACTIONS(2386),
    [sym_primitive_type] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_goto] = ACTIONS(2386),
    [anon_sym___try] = ACTIONS(2386),
    [anon_sym___leave] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_compl] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2386),
    [anon_sym___alignof__] = ACTIONS(2386),
    [anon_sym___alignof] = ACTIONS(2386),
    [anon_sym__alignof] = ACTIONS(2386),
    [anon_sym_alignof] = ACTIONS(2386),
    [anon_sym__Alignof] = ACTIONS(2386),
    [anon_sym_offsetof] = ACTIONS(2386),
    [anon_sym__Generic] = ACTIONS(2386),
    [anon_sym_asm] = ACTIONS(2386),
    [anon_sym___asm__] = ACTIONS(2386),
    [anon_sym___asm] = ACTIONS(2386),
    [sym_number_literal] = ACTIONS(2388),
    [anon_sym_L_SQUOTE] = ACTIONS(2388),
    [anon_sym_u_SQUOTE] = ACTIONS(2388),
    [anon_sym_U_SQUOTE] = ACTIONS(2388),
    [anon_sym_u8_SQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_L_DQUOTE] = ACTIONS(2388),
    [anon_sym_u_DQUOTE] = ACTIONS(2388),
    [anon_sym_U_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8_DQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [anon_sym_NULL] = ACTIONS(2386),
    [anon_sym_nullptr] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2386),
    [anon_sym_decltype] = ACTIONS(2386),
    [anon_sym_explicit] = ACTIONS(2386),
    [anon_sym_typename] = ACTIONS(2386),
    [anon_sym_template] = ACTIONS(2386),
    [anon_sym_operator] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_static_assert] = ACTIONS(2386),
    [anon_sym_concept] = ACTIONS(2386),
    [anon_sym_co_return] = ACTIONS(2386),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_requires] = ACTIONS(2386),
    [sym_this] = ACTIONS(2386),
    [anon_sym_discard] = ACTIONS(2386),
    [anon_sym_precise] = ACTIONS(2386),
    [anon_sym_shared] = ACTIONS(2386),
    [anon_sym_groupshared] = ACTIONS(2386),
    [anon_sym_uniform] = ACTIONS(2386),
    [anon_sym_row_major] = ACTIONS(2386),
    [anon_sym_column_major] = ACTIONS(2386),
    [anon_sym_globallycoherent] = ACTIONS(2386),
    [anon_sym_centroid] = ACTIONS(2386),
    [anon_sym_noperspective] = ACTIONS(2386),
    [anon_sym_nointerpolation] = ACTIONS(2386),
    [anon_sym_sample] = ACTIONS(2386),
    [anon_sym_linear] = ACTIONS(2386),
    [anon_sym_snorm] = ACTIONS(2386),
    [anon_sym_unorm] = ACTIONS(2386),
    [anon_sym_point] = ACTIONS(2386),
    [anon_sym_line] = ACTIONS(2386),
    [anon_sym_triangleadj] = ACTIONS(2386),
    [anon_sym_lineadj] = ACTIONS(2386),
    [anon_sym_triangle] = ACTIONS(2386),
    [anon_sym_cbuffer] = ACTIONS(2386),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_include_token1] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token2] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_typedef] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_virtual] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym___attribute] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2250),
    [anon_sym___cdecl] = ACTIONS(2250),
    [anon_sym___clrcall] = ACTIONS(2250),
    [anon_sym___stdcall] = ACTIONS(2250),
    [anon_sym___fastcall] = ACTIONS(2250),
    [anon_sym___thiscall] = ACTIONS(2250),
    [anon_sym___vectorcall] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_goto] = ACTIONS(2250),
    [anon_sym___try] = ACTIONS(2250),
    [anon_sym___leave] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2250),
    [anon_sym_compl] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2250),
    [anon_sym___alignof__] = ACTIONS(2250),
    [anon_sym___alignof] = ACTIONS(2250),
    [anon_sym__alignof] = ACTIONS(2250),
    [anon_sym_alignof] = ACTIONS(2250),
    [anon_sym__Alignof] = ACTIONS(2250),
    [anon_sym_offsetof] = ACTIONS(2250),
    [anon_sym__Generic] = ACTIONS(2250),
    [anon_sym_asm] = ACTIONS(2250),
    [anon_sym___asm__] = ACTIONS(2250),
    [anon_sym___asm] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2252),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2252),
    [anon_sym_u_DQUOTE] = ACTIONS(2252),
    [anon_sym_U_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [anon_sym_NULL] = ACTIONS(2250),
    [anon_sym_nullptr] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2250),
    [anon_sym_decltype] = ACTIONS(2250),
    [anon_sym_explicit] = ACTIONS(2250),
    [anon_sym_typename] = ACTIONS(2250),
    [anon_sym_template] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_static_assert] = ACTIONS(2250),
    [anon_sym_concept] = ACTIONS(2250),
    [anon_sym_co_return] = ACTIONS(2250),
    [anon_sym_co_yield] = ACTIONS(2250),
    [anon_sym_R_DQUOTE] = ACTIONS(2252),
    [anon_sym_LR_DQUOTE] = ACTIONS(2252),
    [anon_sym_uR_DQUOTE] = ACTIONS(2252),
    [anon_sym_UR_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2252),
    [anon_sym_co_await] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [anon_sym_discard] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_groupshared] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_row_major] = ACTIONS(2250),
    [anon_sym_column_major] = ACTIONS(2250),
    [anon_sym_globallycoherent] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym_nointerpolation] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_linear] = ACTIONS(2250),
    [anon_sym_snorm] = ACTIONS(2250),
    [anon_sym_unorm] = ACTIONS(2250),
    [anon_sym_point] = ACTIONS(2250),
    [anon_sym_line] = ACTIONS(2250),
    [anon_sym_triangleadj] = ACTIONS(2250),
    [anon_sym_lineadj] = ACTIONS(2250),
    [anon_sym_triangle] = ACTIONS(2250),
    [anon_sym_cbuffer] = ACTIONS(2250),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_include_token1] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token2] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_typedef] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_virtual] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym___attribute] = ACTIONS(2254),
    [anon_sym_using] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym___based] = ACTIONS(2254),
    [anon_sym___cdecl] = ACTIONS(2254),
    [anon_sym___clrcall] = ACTIONS(2254),
    [anon_sym___stdcall] = ACTIONS(2254),
    [anon_sym___fastcall] = ACTIONS(2254),
    [anon_sym___thiscall] = ACTIONS(2254),
    [anon_sym___vectorcall] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym__Nonnull] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_class] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2254),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_do] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2254),
    [anon_sym___try] = ACTIONS(2254),
    [anon_sym___leave] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_compl] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2254),
    [anon_sym___alignof__] = ACTIONS(2254),
    [anon_sym___alignof] = ACTIONS(2254),
    [anon_sym__alignof] = ACTIONS(2254),
    [anon_sym_alignof] = ACTIONS(2254),
    [anon_sym__Alignof] = ACTIONS(2254),
    [anon_sym_offsetof] = ACTIONS(2254),
    [anon_sym__Generic] = ACTIONS(2254),
    [anon_sym_asm] = ACTIONS(2254),
    [anon_sym___asm__] = ACTIONS(2254),
    [anon_sym___asm] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_L_SQUOTE] = ACTIONS(2256),
    [anon_sym_u_SQUOTE] = ACTIONS(2256),
    [anon_sym_U_SQUOTE] = ACTIONS(2256),
    [anon_sym_u8_SQUOTE] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_L_DQUOTE] = ACTIONS(2256),
    [anon_sym_u_DQUOTE] = ACTIONS(2256),
    [anon_sym_U_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8_DQUOTE] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2256),
    [sym_true] = ACTIONS(2254),
    [sym_false] = ACTIONS(2254),
    [anon_sym_NULL] = ACTIONS(2254),
    [anon_sym_nullptr] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2254),
    [anon_sym_decltype] = ACTIONS(2254),
    [anon_sym_explicit] = ACTIONS(2254),
    [anon_sym_typename] = ACTIONS(2254),
    [anon_sym_template] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [anon_sym_delete] = ACTIONS(2254),
    [anon_sym_throw] = ACTIONS(2254),
    [anon_sym_namespace] = ACTIONS(2254),
    [anon_sym_static_assert] = ACTIONS(2254),
    [anon_sym_concept] = ACTIONS(2254),
    [anon_sym_co_return] = ACTIONS(2254),
    [anon_sym_co_yield] = ACTIONS(2254),
    [anon_sym_R_DQUOTE] = ACTIONS(2256),
    [anon_sym_LR_DQUOTE] = ACTIONS(2256),
    [anon_sym_uR_DQUOTE] = ACTIONS(2256),
    [anon_sym_UR_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2256),
    [anon_sym_co_await] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2254),
    [sym_this] = ACTIONS(2254),
    [anon_sym_discard] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_groupshared] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_row_major] = ACTIONS(2254),
    [anon_sym_column_major] = ACTIONS(2254),
    [anon_sym_globallycoherent] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym_nointerpolation] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_linear] = ACTIONS(2254),
    [anon_sym_snorm] = ACTIONS(2254),
    [anon_sym_unorm] = ACTIONS(2254),
    [anon_sym_point] = ACTIONS(2254),
    [anon_sym_line] = ACTIONS(2254),
    [anon_sym_triangleadj] = ACTIONS(2254),
    [anon_sym_lineadj] = ACTIONS(2254),
    [anon_sym_triangle] = ACTIONS(2254),
    [anon_sym_cbuffer] = ACTIONS(2254),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2258),
    [aux_sym_preproc_include_token1] = ACTIONS(2258),
    [aux_sym_preproc_def_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token2] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2258),
    [sym_preproc_directive] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym_typedef] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2258),
    [anon_sym_out] = ACTIONS(2258),
    [anon_sym_inout] = ACTIONS(2258),
    [anon_sym_virtual] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym___attribute] = ACTIONS(2258),
    [anon_sym_using] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2260),
    [anon_sym___declspec] = ACTIONS(2258),
    [anon_sym___based] = ACTIONS(2258),
    [anon_sym___cdecl] = ACTIONS(2258),
    [anon_sym___clrcall] = ACTIONS(2258),
    [anon_sym___stdcall] = ACTIONS(2258),
    [anon_sym___fastcall] = ACTIONS(2258),
    [anon_sym___thiscall] = ACTIONS(2258),
    [anon_sym___vectorcall] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2258),
    [anon_sym_unsigned] = ACTIONS(2258),
    [anon_sym_long] = ACTIONS(2258),
    [anon_sym_short] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2258),
    [anon_sym_inline] = ACTIONS(2258),
    [anon_sym___inline] = ACTIONS(2258),
    [anon_sym___inline__] = ACTIONS(2258),
    [anon_sym___forceinline] = ACTIONS(2258),
    [anon_sym_thread_local] = ACTIONS(2258),
    [anon_sym___thread] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym__Nonnull] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [sym_primitive_type] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_class] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2258),
    [anon_sym_switch] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_do] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_goto] = ACTIONS(2258),
    [anon_sym___try] = ACTIONS(2258),
    [anon_sym___leave] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2258),
    [anon_sym_compl] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2258),
    [anon_sym___alignof__] = ACTIONS(2258),
    [anon_sym___alignof] = ACTIONS(2258),
    [anon_sym__alignof] = ACTIONS(2258),
    [anon_sym_alignof] = ACTIONS(2258),
    [anon_sym__Alignof] = ACTIONS(2258),
    [anon_sym_offsetof] = ACTIONS(2258),
    [anon_sym__Generic] = ACTIONS(2258),
    [anon_sym_asm] = ACTIONS(2258),
    [anon_sym___asm__] = ACTIONS(2258),
    [anon_sym___asm] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2260),
    [anon_sym_L_SQUOTE] = ACTIONS(2260),
    [anon_sym_u_SQUOTE] = ACTIONS(2260),
    [anon_sym_U_SQUOTE] = ACTIONS(2260),
    [anon_sym_u8_SQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_L_DQUOTE] = ACTIONS(2260),
    [anon_sym_u_DQUOTE] = ACTIONS(2260),
    [anon_sym_U_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8_DQUOTE] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2258),
    [anon_sym_decltype] = ACTIONS(2258),
    [anon_sym_explicit] = ACTIONS(2258),
    [anon_sym_typename] = ACTIONS(2258),
    [anon_sym_template] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [anon_sym_delete] = ACTIONS(2258),
    [anon_sym_throw] = ACTIONS(2258),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_static_assert] = ACTIONS(2258),
    [anon_sym_concept] = ACTIONS(2258),
    [anon_sym_co_return] = ACTIONS(2258),
    [anon_sym_co_yield] = ACTIONS(2258),
    [anon_sym_R_DQUOTE] = ACTIONS(2260),
    [anon_sym_LR_DQUOTE] = ACTIONS(2260),
    [anon_sym_uR_DQUOTE] = ACTIONS(2260),
    [anon_sym_UR_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2260),
    [anon_sym_co_await] = ACTIONS(2258),
    [anon_sym_new] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2258),
    [sym_this] = ACTIONS(2258),
    [anon_sym_discard] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2258),
    [anon_sym_shared] = ACTIONS(2258),
    [anon_sym_groupshared] = ACTIONS(2258),
    [anon_sym_uniform] = ACTIONS(2258),
    [anon_sym_row_major] = ACTIONS(2258),
    [anon_sym_column_major] = ACTIONS(2258),
    [anon_sym_globallycoherent] = ACTIONS(2258),
    [anon_sym_centroid] = ACTIONS(2258),
    [anon_sym_noperspective] = ACTIONS(2258),
    [anon_sym_nointerpolation] = ACTIONS(2258),
    [anon_sym_sample] = ACTIONS(2258),
    [anon_sym_linear] = ACTIONS(2258),
    [anon_sym_snorm] = ACTIONS(2258),
    [anon_sym_unorm] = ACTIONS(2258),
    [anon_sym_point] = ACTIONS(2258),
    [anon_sym_line] = ACTIONS(2258),
    [anon_sym_triangleadj] = ACTIONS(2258),
    [anon_sym_lineadj] = ACTIONS(2258),
    [anon_sym_triangle] = ACTIONS(2258),
    [anon_sym_cbuffer] = ACTIONS(2258),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2262),
    [aux_sym_preproc_include_token1] = ACTIONS(2262),
    [aux_sym_preproc_def_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token2] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [sym_preproc_directive] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym_typedef] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2262),
    [anon_sym_out] = ACTIONS(2262),
    [anon_sym_inout] = ACTIONS(2262),
    [anon_sym_virtual] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2262),
    [anon_sym_using] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2264),
    [anon_sym___declspec] = ACTIONS(2262),
    [anon_sym___based] = ACTIONS(2262),
    [anon_sym___cdecl] = ACTIONS(2262),
    [anon_sym___clrcall] = ACTIONS(2262),
    [anon_sym___stdcall] = ACTIONS(2262),
    [anon_sym___fastcall] = ACTIONS(2262),
    [anon_sym___thiscall] = ACTIONS(2262),
    [anon_sym___vectorcall] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2262),
    [anon_sym_unsigned] = ACTIONS(2262),
    [anon_sym_long] = ACTIONS(2262),
    [anon_sym_short] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2262),
    [anon_sym_inline] = ACTIONS(2262),
    [anon_sym___inline] = ACTIONS(2262),
    [anon_sym___inline__] = ACTIONS(2262),
    [anon_sym___forceinline] = ACTIONS(2262),
    [anon_sym_thread_local] = ACTIONS(2262),
    [anon_sym___thread] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [sym_primitive_type] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_class] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2262),
    [anon_sym_default] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_goto] = ACTIONS(2262),
    [anon_sym___try] = ACTIONS(2262),
    [anon_sym___leave] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2262),
    [anon_sym_compl] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2262),
    [anon_sym___alignof__] = ACTIONS(2262),
    [anon_sym___alignof] = ACTIONS(2262),
    [anon_sym__alignof] = ACTIONS(2262),
    [anon_sym_alignof] = ACTIONS(2262),
    [anon_sym__Alignof] = ACTIONS(2262),
    [anon_sym_offsetof] = ACTIONS(2262),
    [anon_sym__Generic] = ACTIONS(2262),
    [anon_sym_asm] = ACTIONS(2262),
    [anon_sym___asm__] = ACTIONS(2262),
    [anon_sym___asm] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2264),
    [anon_sym_L_SQUOTE] = ACTIONS(2264),
    [anon_sym_u_SQUOTE] = ACTIONS(2264),
    [anon_sym_U_SQUOTE] = ACTIONS(2264),
    [anon_sym_u8_SQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_L_DQUOTE] = ACTIONS(2264),
    [anon_sym_u_DQUOTE] = ACTIONS(2264),
    [anon_sym_U_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8_DQUOTE] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [anon_sym_NULL] = ACTIONS(2262),
    [anon_sym_nullptr] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2262),
    [anon_sym_decltype] = ACTIONS(2262),
    [anon_sym_explicit] = ACTIONS(2262),
    [anon_sym_typename] = ACTIONS(2262),
    [anon_sym_template] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [anon_sym_delete] = ACTIONS(2262),
    [anon_sym_throw] = ACTIONS(2262),
    [anon_sym_namespace] = ACTIONS(2262),
    [anon_sym_static_assert] = ACTIONS(2262),
    [anon_sym_concept] = ACTIONS(2262),
    [anon_sym_co_return] = ACTIONS(2262),
    [anon_sym_co_yield] = ACTIONS(2262),
    [anon_sym_R_DQUOTE] = ACTIONS(2264),
    [anon_sym_LR_DQUOTE] = ACTIONS(2264),
    [anon_sym_uR_DQUOTE] = ACTIONS(2264),
    [anon_sym_UR_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2264),
    [anon_sym_co_await] = ACTIONS(2262),
    [anon_sym_new] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2262),
    [sym_this] = ACTIONS(2262),
    [anon_sym_discard] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2262),
    [anon_sym_shared] = ACTIONS(2262),
    [anon_sym_groupshared] = ACTIONS(2262),
    [anon_sym_uniform] = ACTIONS(2262),
    [anon_sym_row_major] = ACTIONS(2262),
    [anon_sym_column_major] = ACTIONS(2262),
    [anon_sym_globallycoherent] = ACTIONS(2262),
    [anon_sym_centroid] = ACTIONS(2262),
    [anon_sym_noperspective] = ACTIONS(2262),
    [anon_sym_nointerpolation] = ACTIONS(2262),
    [anon_sym_sample] = ACTIONS(2262),
    [anon_sym_linear] = ACTIONS(2262),
    [anon_sym_snorm] = ACTIONS(2262),
    [anon_sym_unorm] = ACTIONS(2262),
    [anon_sym_point] = ACTIONS(2262),
    [anon_sym_line] = ACTIONS(2262),
    [anon_sym_triangleadj] = ACTIONS(2262),
    [anon_sym_lineadj] = ACTIONS(2262),
    [anon_sym_triangle] = ACTIONS(2262),
    [anon_sym_cbuffer] = ACTIONS(2262),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2390),
    [aux_sym_preproc_include_token1] = ACTIONS(2390),
    [aux_sym_preproc_def_token1] = ACTIONS(2390),
    [aux_sym_preproc_if_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2390),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2390),
    [sym_preproc_directive] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2390),
    [anon_sym_typedef] = ACTIONS(2390),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_out] = ACTIONS(2390),
    [anon_sym_inout] = ACTIONS(2390),
    [anon_sym_virtual] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym___attribute__] = ACTIONS(2390),
    [anon_sym___attribute] = ACTIONS(2390),
    [anon_sym_using] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2392),
    [anon_sym___declspec] = ACTIONS(2390),
    [anon_sym___based] = ACTIONS(2390),
    [anon_sym___cdecl] = ACTIONS(2390),
    [anon_sym___clrcall] = ACTIONS(2390),
    [anon_sym___stdcall] = ACTIONS(2390),
    [anon_sym___fastcall] = ACTIONS(2390),
    [anon_sym___thiscall] = ACTIONS(2390),
    [anon_sym___vectorcall] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2390),
    [anon_sym_unsigned] = ACTIONS(2390),
    [anon_sym_long] = ACTIONS(2390),
    [anon_sym_short] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_register] = ACTIONS(2390),
    [anon_sym_inline] = ACTIONS(2390),
    [anon_sym___inline] = ACTIONS(2390),
    [anon_sym___inline__] = ACTIONS(2390),
    [anon_sym___forceinline] = ACTIONS(2390),
    [anon_sym_thread_local] = ACTIONS(2390),
    [anon_sym___thread] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_constexpr] = ACTIONS(2390),
    [anon_sym_volatile] = ACTIONS(2390),
    [anon_sym_restrict] = ACTIONS(2390),
    [anon_sym___restrict__] = ACTIONS(2390),
    [anon_sym__Atomic] = ACTIONS(2390),
    [anon_sym__Noreturn] = ACTIONS(2390),
    [anon_sym_noreturn] = ACTIONS(2390),
    [anon_sym__Nonnull] = ACTIONS(2390),
    [anon_sym_mutable] = ACTIONS(2390),
    [anon_sym_constinit] = ACTIONS(2390),
    [anon_sym_consteval] = ACTIONS(2390),
    [anon_sym_alignas] = ACTIONS(2390),
    [anon_sym__Alignas] = ACTIONS(2390),
    [sym_primitive_type] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2390),
    [anon_sym___leave] = ACTIONS(2390),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_compl] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2390),
    [anon_sym___alignof__] = ACTIONS(2390),
    [anon_sym___alignof] = ACTIONS(2390),
    [anon_sym__alignof] = ACTIONS(2390),
    [anon_sym_alignof] = ACTIONS(2390),
    [anon_sym__Alignof] = ACTIONS(2390),
    [anon_sym_offsetof] = ACTIONS(2390),
    [anon_sym__Generic] = ACTIONS(2390),
    [anon_sym_asm] = ACTIONS(2390),
    [anon_sym___asm__] = ACTIONS(2390),
    [anon_sym___asm] = ACTIONS(2390),
    [sym_number_literal] = ACTIONS(2392),
    [anon_sym_L_SQUOTE] = ACTIONS(2392),
    [anon_sym_u_SQUOTE] = ACTIONS(2392),
    [anon_sym_U_SQUOTE] = ACTIONS(2392),
    [anon_sym_u8_SQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_L_DQUOTE] = ACTIONS(2392),
    [anon_sym_u_DQUOTE] = ACTIONS(2392),
    [anon_sym_U_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [anon_sym_NULL] = ACTIONS(2390),
    [anon_sym_nullptr] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2390),
    [anon_sym_decltype] = ACTIONS(2390),
    [anon_sym_explicit] = ACTIONS(2390),
    [anon_sym_typename] = ACTIONS(2390),
    [anon_sym_template] = ACTIONS(2390),
    [anon_sym_operator] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_static_assert] = ACTIONS(2390),
    [anon_sym_concept] = ACTIONS(2390),
    [anon_sym_co_return] = ACTIONS(2390),
    [anon_sym_co_yield] = ACTIONS(2390),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_LR_DQUOTE] = ACTIONS(2392),
    [anon_sym_uR_DQUOTE] = ACTIONS(2392),
    [anon_sym_UR_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2392),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_requires] = ACTIONS(2390),
    [sym_this] = ACTIONS(2390),
    [anon_sym_discard] = ACTIONS(2390),
    [anon_sym_precise] = ACTIONS(2390),
    [anon_sym_shared] = ACTIONS(2390),
    [anon_sym_groupshared] = ACTIONS(2390),
    [anon_sym_uniform] = ACTIONS(2390),
    [anon_sym_row_major] = ACTIONS(2390),
    [anon_sym_column_major] = ACTIONS(2390),
    [anon_sym_globallycoherent] = ACTIONS(2390),
    [anon_sym_centroid] = ACTIONS(2390),
    [anon_sym_noperspective] = ACTIONS(2390),
    [anon_sym_nointerpolation] = ACTIONS(2390),
    [anon_sym_sample] = ACTIONS(2390),
    [anon_sym_linear] = ACTIONS(2390),
    [anon_sym_snorm] = ACTIONS(2390),
    [anon_sym_unorm] = ACTIONS(2390),
    [anon_sym_point] = ACTIONS(2390),
    [anon_sym_line] = ACTIONS(2390),
    [anon_sym_triangleadj] = ACTIONS(2390),
    [anon_sym_lineadj] = ACTIONS(2390),
    [anon_sym_triangle] = ACTIONS(2390),
    [anon_sym_cbuffer] = ACTIONS(2390),
  },
  [521] = {
    [sym_identifier] = ACTIONS(2270),
    [aux_sym_preproc_include_token1] = ACTIONS(2270),
    [aux_sym_preproc_def_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token2] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2270),
    [sym_preproc_directive] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_typedef] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_virtual] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2270),
    [anon_sym_using] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym___based] = ACTIONS(2270),
    [anon_sym___cdecl] = ACTIONS(2270),
    [anon_sym___clrcall] = ACTIONS(2270),
    [anon_sym___stdcall] = ACTIONS(2270),
    [anon_sym___fastcall] = ACTIONS(2270),
    [anon_sym___thiscall] = ACTIONS(2270),
    [anon_sym___vectorcall] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_class] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_switch] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2270),
    [anon_sym_default] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_do] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_goto] = ACTIONS(2270),
    [anon_sym___try] = ACTIONS(2270),
    [anon_sym___leave] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_compl] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2270),
    [anon_sym___alignof__] = ACTIONS(2270),
    [anon_sym___alignof] = ACTIONS(2270),
    [anon_sym__alignof] = ACTIONS(2270),
    [anon_sym_alignof] = ACTIONS(2270),
    [anon_sym__Alignof] = ACTIONS(2270),
    [anon_sym_offsetof] = ACTIONS(2270),
    [anon_sym__Generic] = ACTIONS(2270),
    [anon_sym_asm] = ACTIONS(2270),
    [anon_sym___asm__] = ACTIONS(2270),
    [anon_sym___asm] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2272),
    [anon_sym_L_SQUOTE] = ACTIONS(2272),
    [anon_sym_u_SQUOTE] = ACTIONS(2272),
    [anon_sym_U_SQUOTE] = ACTIONS(2272),
    [anon_sym_u8_SQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_L_DQUOTE] = ACTIONS(2272),
    [anon_sym_u_DQUOTE] = ACTIONS(2272),
    [anon_sym_U_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8_DQUOTE] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [anon_sym_NULL] = ACTIONS(2270),
    [anon_sym_nullptr] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2270),
    [anon_sym_decltype] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_typename] = ACTIONS(2270),
    [anon_sym_template] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [anon_sym_delete] = ACTIONS(2270),
    [anon_sym_throw] = ACTIONS(2270),
    [anon_sym_namespace] = ACTIONS(2270),
    [anon_sym_static_assert] = ACTIONS(2270),
    [anon_sym_concept] = ACTIONS(2270),
    [anon_sym_co_return] = ACTIONS(2270),
    [anon_sym_co_yield] = ACTIONS(2270),
    [anon_sym_R_DQUOTE] = ACTIONS(2272),
    [anon_sym_LR_DQUOTE] = ACTIONS(2272),
    [anon_sym_uR_DQUOTE] = ACTIONS(2272),
    [anon_sym_UR_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2272),
    [anon_sym_co_await] = ACTIONS(2270),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2270),
    [sym_this] = ACTIONS(2270),
    [anon_sym_discard] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_groupshared] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_row_major] = ACTIONS(2270),
    [anon_sym_column_major] = ACTIONS(2270),
    [anon_sym_globallycoherent] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym_nointerpolation] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_linear] = ACTIONS(2270),
    [anon_sym_snorm] = ACTIONS(2270),
    [anon_sym_unorm] = ACTIONS(2270),
    [anon_sym_point] = ACTIONS(2270),
    [anon_sym_line] = ACTIONS(2270),
    [anon_sym_triangleadj] = ACTIONS(2270),
    [anon_sym_lineadj] = ACTIONS(2270),
    [anon_sym_triangle] = ACTIONS(2270),
    [anon_sym_cbuffer] = ACTIONS(2270),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2274),
    [aux_sym_preproc_include_token1] = ACTIONS(2274),
    [aux_sym_preproc_def_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token2] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2274),
    [sym_preproc_directive] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_AMP_AMP] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_typedef] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_virtual] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2274),
    [anon_sym_using] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym___based] = ACTIONS(2274),
    [anon_sym___cdecl] = ACTIONS(2274),
    [anon_sym___clrcall] = ACTIONS(2274),
    [anon_sym___stdcall] = ACTIONS(2274),
    [anon_sym___fastcall] = ACTIONS(2274),
    [anon_sym___thiscall] = ACTIONS(2274),
    [anon_sym___vectorcall] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_class] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2274),
    [anon_sym_switch] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_do] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_goto] = ACTIONS(2274),
    [anon_sym___try] = ACTIONS(2274),
    [anon_sym___leave] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2274),
    [anon_sym_compl] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2274),
    [anon_sym___alignof__] = ACTIONS(2274),
    [anon_sym___alignof] = ACTIONS(2274),
    [anon_sym__alignof] = ACTIONS(2274),
    [anon_sym_alignof] = ACTIONS(2274),
    [anon_sym__Alignof] = ACTIONS(2274),
    [anon_sym_offsetof] = ACTIONS(2274),
    [anon_sym__Generic] = ACTIONS(2274),
    [anon_sym_asm] = ACTIONS(2274),
    [anon_sym___asm__] = ACTIONS(2274),
    [anon_sym___asm] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_L_SQUOTE] = ACTIONS(2276),
    [anon_sym_u_SQUOTE] = ACTIONS(2276),
    [anon_sym_U_SQUOTE] = ACTIONS(2276),
    [anon_sym_u8_SQUOTE] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_L_DQUOTE] = ACTIONS(2276),
    [anon_sym_u_DQUOTE] = ACTIONS(2276),
    [anon_sym_U_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8_DQUOTE] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(2276),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [anon_sym_NULL] = ACTIONS(2274),
    [anon_sym_nullptr] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2274),
    [anon_sym_decltype] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_typename] = ACTIONS(2274),
    [anon_sym_template] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [anon_sym_delete] = ACTIONS(2274),
    [anon_sym_throw] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2274),
    [anon_sym_static_assert] = ACTIONS(2274),
    [anon_sym_concept] = ACTIONS(2274),
    [anon_sym_co_return] = ACTIONS(2274),
    [anon_sym_co_yield] = ACTIONS(2274),
    [anon_sym_R_DQUOTE] = ACTIONS(2276),
    [anon_sym_LR_DQUOTE] = ACTIONS(2276),
    [anon_sym_uR_DQUOTE] = ACTIONS(2276),
    [anon_sym_UR_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2276),
    [anon_sym_co_await] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2274),
    [sym_this] = ACTIONS(2274),
    [anon_sym_discard] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_groupshared] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_row_major] = ACTIONS(2274),
    [anon_sym_column_major] = ACTIONS(2274),
    [anon_sym_globallycoherent] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym_nointerpolation] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_linear] = ACTIONS(2274),
    [anon_sym_snorm] = ACTIONS(2274),
    [anon_sym_unorm] = ACTIONS(2274),
    [anon_sym_point] = ACTIONS(2274),
    [anon_sym_line] = ACTIONS(2274),
    [anon_sym_triangleadj] = ACTIONS(2274),
    [anon_sym_lineadj] = ACTIONS(2274),
    [anon_sym_triangle] = ACTIONS(2274),
    [anon_sym_cbuffer] = ACTIONS(2274),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2278),
    [aux_sym_preproc_include_token1] = ACTIONS(2278),
    [aux_sym_preproc_def_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token1] = ACTIONS(2278),
    [aux_sym_preproc_if_token2] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2278),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2278),
    [sym_preproc_directive] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_PLUS] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP_AMP] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym_typedef] = ACTIONS(2278),
    [anon_sym_in] = ACTIONS(2278),
    [anon_sym_out] = ACTIONS(2278),
    [anon_sym_inout] = ACTIONS(2278),
    [anon_sym_virtual] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2278),
    [anon_sym_using] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2280),
    [anon_sym___declspec] = ACTIONS(2278),
    [anon_sym___based] = ACTIONS(2278),
    [anon_sym___cdecl] = ACTIONS(2278),
    [anon_sym___clrcall] = ACTIONS(2278),
    [anon_sym___stdcall] = ACTIONS(2278),
    [anon_sym___fastcall] = ACTIONS(2278),
    [anon_sym___thiscall] = ACTIONS(2278),
    [anon_sym___vectorcall] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2278),
    [anon_sym_unsigned] = ACTIONS(2278),
    [anon_sym_long] = ACTIONS(2278),
    [anon_sym_short] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2278),
    [anon_sym_inline] = ACTIONS(2278),
    [anon_sym___inline] = ACTIONS(2278),
    [anon_sym___inline__] = ACTIONS(2278),
    [anon_sym___forceinline] = ACTIONS(2278),
    [anon_sym_thread_local] = ACTIONS(2278),
    [anon_sym___thread] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [sym_primitive_type] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_class] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2278),
    [anon_sym_case] = ACTIONS(2278),
    [anon_sym_default] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_do] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_goto] = ACTIONS(2278),
    [anon_sym___try] = ACTIONS(2278),
    [anon_sym___leave] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2278),
    [anon_sym_compl] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2278),
    [anon_sym___alignof__] = ACTIONS(2278),
    [anon_sym___alignof] = ACTIONS(2278),
    [anon_sym__alignof] = ACTIONS(2278),
    [anon_sym_alignof] = ACTIONS(2278),
    [anon_sym__Alignof] = ACTIONS(2278),
    [anon_sym_offsetof] = ACTIONS(2278),
    [anon_sym__Generic] = ACTIONS(2278),
    [anon_sym_asm] = ACTIONS(2278),
    [anon_sym___asm__] = ACTIONS(2278),
    [anon_sym___asm] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2280),
    [anon_sym_L_SQUOTE] = ACTIONS(2280),
    [anon_sym_u_SQUOTE] = ACTIONS(2280),
    [anon_sym_U_SQUOTE] = ACTIONS(2280),
    [anon_sym_u8_SQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_L_DQUOTE] = ACTIONS(2280),
    [anon_sym_u_DQUOTE] = ACTIONS(2280),
    [anon_sym_U_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8_DQUOTE] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [anon_sym_NULL] = ACTIONS(2278),
    [anon_sym_nullptr] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2278),
    [anon_sym_decltype] = ACTIONS(2278),
    [anon_sym_explicit] = ACTIONS(2278),
    [anon_sym_typename] = ACTIONS(2278),
    [anon_sym_template] = ACTIONS(2278),
    [anon_sym_operator] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [anon_sym_delete] = ACTIONS(2278),
    [anon_sym_throw] = ACTIONS(2278),
    [anon_sym_namespace] = ACTIONS(2278),
    [anon_sym_static_assert] = ACTIONS(2278),
    [anon_sym_concept] = ACTIONS(2278),
    [anon_sym_co_return] = ACTIONS(2278),
    [anon_sym_co_yield] = ACTIONS(2278),
    [anon_sym_R_DQUOTE] = ACTIONS(2280),
    [anon_sym_LR_DQUOTE] = ACTIONS(2280),
    [anon_sym_uR_DQUOTE] = ACTIONS(2280),
    [anon_sym_UR_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2280),
    [anon_sym_co_await] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2278),
    [sym_this] = ACTIONS(2278),
    [anon_sym_discard] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2278),
    [anon_sym_shared] = ACTIONS(2278),
    [anon_sym_groupshared] = ACTIONS(2278),
    [anon_sym_uniform] = ACTIONS(2278),
    [anon_sym_row_major] = ACTIONS(2278),
    [anon_sym_column_major] = ACTIONS(2278),
    [anon_sym_globallycoherent] = ACTIONS(2278),
    [anon_sym_centroid] = ACTIONS(2278),
    [anon_sym_noperspective] = ACTIONS(2278),
    [anon_sym_nointerpolation] = ACTIONS(2278),
    [anon_sym_sample] = ACTIONS(2278),
    [anon_sym_linear] = ACTIONS(2278),
    [anon_sym_snorm] = ACTIONS(2278),
    [anon_sym_unorm] = ACTIONS(2278),
    [anon_sym_point] = ACTIONS(2278),
    [anon_sym_line] = ACTIONS(2278),
    [anon_sym_triangleadj] = ACTIONS(2278),
    [anon_sym_lineadj] = ACTIONS(2278),
    [anon_sym_triangle] = ACTIONS(2278),
    [anon_sym_cbuffer] = ACTIONS(2278),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2398),
    [aux_sym_preproc_include_token1] = ACTIONS(2398),
    [aux_sym_preproc_def_token1] = ACTIONS(2398),
    [aux_sym_preproc_if_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2398),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2398),
    [sym_preproc_directive] = ACTIONS(2398),
    [anon_sym_LPAREN2] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2398),
    [anon_sym_typedef] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_out] = ACTIONS(2398),
    [anon_sym_inout] = ACTIONS(2398),
    [anon_sym_virtual] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym___attribute__] = ACTIONS(2398),
    [anon_sym___attribute] = ACTIONS(2398),
    [anon_sym_using] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2400),
    [anon_sym___declspec] = ACTIONS(2398),
    [anon_sym___based] = ACTIONS(2398),
    [anon_sym___cdecl] = ACTIONS(2398),
    [anon_sym___clrcall] = ACTIONS(2398),
    [anon_sym___stdcall] = ACTIONS(2398),
    [anon_sym___fastcall] = ACTIONS(2398),
    [anon_sym___thiscall] = ACTIONS(2398),
    [anon_sym___vectorcall] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_signed] = ACTIONS(2398),
    [anon_sym_unsigned] = ACTIONS(2398),
    [anon_sym_long] = ACTIONS(2398),
    [anon_sym_short] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_register] = ACTIONS(2398),
    [anon_sym_inline] = ACTIONS(2398),
    [anon_sym___inline] = ACTIONS(2398),
    [anon_sym___inline__] = ACTIONS(2398),
    [anon_sym___forceinline] = ACTIONS(2398),
    [anon_sym_thread_local] = ACTIONS(2398),
    [anon_sym___thread] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_constexpr] = ACTIONS(2398),
    [anon_sym_volatile] = ACTIONS(2398),
    [anon_sym_restrict] = ACTIONS(2398),
    [anon_sym___restrict__] = ACTIONS(2398),
    [anon_sym__Atomic] = ACTIONS(2398),
    [anon_sym__Noreturn] = ACTIONS(2398),
    [anon_sym_noreturn] = ACTIONS(2398),
    [anon_sym__Nonnull] = ACTIONS(2398),
    [anon_sym_mutable] = ACTIONS(2398),
    [anon_sym_constinit] = ACTIONS(2398),
    [anon_sym_consteval] = ACTIONS(2398),
    [anon_sym_alignas] = ACTIONS(2398),
    [anon_sym__Alignas] = ACTIONS(2398),
    [sym_primitive_type] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_goto] = ACTIONS(2398),
    [anon_sym___try] = ACTIONS(2398),
    [anon_sym___leave] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2398),
    [anon_sym_compl] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_sizeof] = ACTIONS(2398),
    [anon_sym___alignof__] = ACTIONS(2398),
    [anon_sym___alignof] = ACTIONS(2398),
    [anon_sym__alignof] = ACTIONS(2398),
    [anon_sym_alignof] = ACTIONS(2398),
    [anon_sym__Alignof] = ACTIONS(2398),
    [anon_sym_offsetof] = ACTIONS(2398),
    [anon_sym__Generic] = ACTIONS(2398),
    [anon_sym_asm] = ACTIONS(2398),
    [anon_sym___asm__] = ACTIONS(2398),
    [anon_sym___asm] = ACTIONS(2398),
    [sym_number_literal] = ACTIONS(2400),
    [anon_sym_L_SQUOTE] = ACTIONS(2400),
    [anon_sym_u_SQUOTE] = ACTIONS(2400),
    [anon_sym_U_SQUOTE] = ACTIONS(2400),
    [anon_sym_u8_SQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_L_DQUOTE] = ACTIONS(2400),
    [anon_sym_u_DQUOTE] = ACTIONS(2400),
    [anon_sym_U_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [anon_sym_NULL] = ACTIONS(2398),
    [anon_sym_nullptr] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2398),
    [anon_sym_decltype] = ACTIONS(2398),
    [anon_sym_explicit] = ACTIONS(2398),
    [anon_sym_typename] = ACTIONS(2398),
    [anon_sym_template] = ACTIONS(2398),
    [anon_sym_operator] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_static_assert] = ACTIONS(2398),
    [anon_sym_concept] = ACTIONS(2398),
    [anon_sym_co_return] = ACTIONS(2398),
    [anon_sym_co_yield] = ACTIONS(2398),
    [anon_sym_R_DQUOTE] = ACTIONS(2400),
    [anon_sym_LR_DQUOTE] = ACTIONS(2400),
    [anon_sym_uR_DQUOTE] = ACTIONS(2400),
    [anon_sym_UR_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2400),
    [anon_sym_co_await] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_requires] = ACTIONS(2398),
    [sym_this] = ACTIONS(2398),
    [anon_sym_discard] = ACTIONS(2398),
    [anon_sym_precise] = ACTIONS(2398),
    [anon_sym_shared] = ACTIONS(2398),
    [anon_sym_groupshared] = ACTIONS(2398),
    [anon_sym_uniform] = ACTIONS(2398),
    [anon_sym_row_major] = ACTIONS(2398),
    [anon_sym_column_major] = ACTIONS(2398),
    [anon_sym_globallycoherent] = ACTIONS(2398),
    [anon_sym_centroid] = ACTIONS(2398),
    [anon_sym_noperspective] = ACTIONS(2398),
    [anon_sym_nointerpolation] = ACTIONS(2398),
    [anon_sym_sample] = ACTIONS(2398),
    [anon_sym_linear] = ACTIONS(2398),
    [anon_sym_snorm] = ACTIONS(2398),
    [anon_sym_unorm] = ACTIONS(2398),
    [anon_sym_point] = ACTIONS(2398),
    [anon_sym_line] = ACTIONS(2398),
    [anon_sym_triangleadj] = ACTIONS(2398),
    [anon_sym_lineadj] = ACTIONS(2398),
    [anon_sym_triangle] = ACTIONS(2398),
    [anon_sym_cbuffer] = ACTIONS(2398),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2394),
    [aux_sym_preproc_include_token1] = ACTIONS(2394),
    [aux_sym_preproc_def_token1] = ACTIONS(2394),
    [aux_sym_preproc_if_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2394),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2394),
    [sym_preproc_directive] = ACTIONS(2394),
    [anon_sym_LPAREN2] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_AMP_AMP] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2394),
    [anon_sym_typedef] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_out] = ACTIONS(2394),
    [anon_sym_inout] = ACTIONS(2394),
    [anon_sym_virtual] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym___attribute__] = ACTIONS(2394),
    [anon_sym___attribute] = ACTIONS(2394),
    [anon_sym_using] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2396),
    [anon_sym___declspec] = ACTIONS(2394),
    [anon_sym___based] = ACTIONS(2394),
    [anon_sym___cdecl] = ACTIONS(2394),
    [anon_sym___clrcall] = ACTIONS(2394),
    [anon_sym___stdcall] = ACTIONS(2394),
    [anon_sym___fastcall] = ACTIONS(2394),
    [anon_sym___thiscall] = ACTIONS(2394),
    [anon_sym___vectorcall] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2394),
    [anon_sym_unsigned] = ACTIONS(2394),
    [anon_sym_long] = ACTIONS(2394),
    [anon_sym_short] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_register] = ACTIONS(2394),
    [anon_sym_inline] = ACTIONS(2394),
    [anon_sym___inline] = ACTIONS(2394),
    [anon_sym___inline__] = ACTIONS(2394),
    [anon_sym___forceinline] = ACTIONS(2394),
    [anon_sym_thread_local] = ACTIONS(2394),
    [anon_sym___thread] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_constexpr] = ACTIONS(2394),
    [anon_sym_volatile] = ACTIONS(2394),
    [anon_sym_restrict] = ACTIONS(2394),
    [anon_sym___restrict__] = ACTIONS(2394),
    [anon_sym__Atomic] = ACTIONS(2394),
    [anon_sym__Noreturn] = ACTIONS(2394),
    [anon_sym_noreturn] = ACTIONS(2394),
    [anon_sym__Nonnull] = ACTIONS(2394),
    [anon_sym_mutable] = ACTIONS(2394),
    [anon_sym_constinit] = ACTIONS(2394),
    [anon_sym_consteval] = ACTIONS(2394),
    [anon_sym_alignas] = ACTIONS(2394),
    [anon_sym__Alignas] = ACTIONS(2394),
    [sym_primitive_type] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_goto] = ACTIONS(2394),
    [anon_sym___try] = ACTIONS(2394),
    [anon_sym___leave] = ACTIONS(2394),
    [anon_sym_not] = ACTIONS(2394),
    [anon_sym_compl] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2394),
    [anon_sym___alignof] = ACTIONS(2394),
    [anon_sym__alignof] = ACTIONS(2394),
    [anon_sym_alignof] = ACTIONS(2394),
    [anon_sym__Alignof] = ACTIONS(2394),
    [anon_sym_offsetof] = ACTIONS(2394),
    [anon_sym__Generic] = ACTIONS(2394),
    [anon_sym_asm] = ACTIONS(2394),
    [anon_sym___asm__] = ACTIONS(2394),
    [anon_sym___asm] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2396),
    [anon_sym_L_SQUOTE] = ACTIONS(2396),
    [anon_sym_u_SQUOTE] = ACTIONS(2396),
    [anon_sym_U_SQUOTE] = ACTIONS(2396),
    [anon_sym_u8_SQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_L_DQUOTE] = ACTIONS(2396),
    [anon_sym_u_DQUOTE] = ACTIONS(2396),
    [anon_sym_U_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8_DQUOTE] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [anon_sym_NULL] = ACTIONS(2394),
    [anon_sym_nullptr] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2394),
    [anon_sym_decltype] = ACTIONS(2394),
    [anon_sym_explicit] = ACTIONS(2394),
    [anon_sym_typename] = ACTIONS(2394),
    [anon_sym_template] = ACTIONS(2394),
    [anon_sym_operator] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_static_assert] = ACTIONS(2394),
    [anon_sym_concept] = ACTIONS(2394),
    [anon_sym_co_return] = ACTIONS(2394),
    [anon_sym_co_yield] = ACTIONS(2394),
    [anon_sym_R_DQUOTE] = ACTIONS(2396),
    [anon_sym_LR_DQUOTE] = ACTIONS(2396),
    [anon_sym_uR_DQUOTE] = ACTIONS(2396),
    [anon_sym_UR_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2396),
    [anon_sym_co_await] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2394),
    [anon_sym_discard] = ACTIONS(2394),
    [anon_sym_precise] = ACTIONS(2394),
    [anon_sym_shared] = ACTIONS(2394),
    [anon_sym_groupshared] = ACTIONS(2394),
    [anon_sym_uniform] = ACTIONS(2394),
    [anon_sym_row_major] = ACTIONS(2394),
    [anon_sym_column_major] = ACTIONS(2394),
    [anon_sym_globallycoherent] = ACTIONS(2394),
    [anon_sym_centroid] = ACTIONS(2394),
    [anon_sym_noperspective] = ACTIONS(2394),
    [anon_sym_nointerpolation] = ACTIONS(2394),
    [anon_sym_sample] = ACTIONS(2394),
    [anon_sym_linear] = ACTIONS(2394),
    [anon_sym_snorm] = ACTIONS(2394),
    [anon_sym_unorm] = ACTIONS(2394),
    [anon_sym_point] = ACTIONS(2394),
    [anon_sym_line] = ACTIONS(2394),
    [anon_sym_triangleadj] = ACTIONS(2394),
    [anon_sym_lineadj] = ACTIONS(2394),
    [anon_sym_triangle] = ACTIONS(2394),
    [anon_sym_cbuffer] = ACTIONS(2394),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_include_token1] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym___cdecl] = ACTIONS(2378),
    [anon_sym___clrcall] = ACTIONS(2378),
    [anon_sym___stdcall] = ACTIONS(2378),
    [anon_sym___fastcall] = ACTIONS(2378),
    [anon_sym___thiscall] = ACTIONS(2378),
    [anon_sym___vectorcall] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_concept] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [529] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [530] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [531] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_include_token1] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym___cdecl] = ACTIONS(2159),
    [anon_sym___clrcall] = ACTIONS(2159),
    [anon_sym___stdcall] = ACTIONS(2159),
    [anon_sym___fastcall] = ACTIONS(2159),
    [anon_sym___thiscall] = ACTIONS(2159),
    [anon_sym___vectorcall] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_case] = ACTIONS(2159),
    [anon_sym_default] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_namespace] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_concept] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_include_token1] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym___cdecl] = ACTIONS(2242),
    [anon_sym___clrcall] = ACTIONS(2242),
    [anon_sym___stdcall] = ACTIONS(2242),
    [anon_sym___fastcall] = ACTIONS(2242),
    [anon_sym___thiscall] = ACTIONS(2242),
    [anon_sym___vectorcall] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_goto] = ACTIONS(2242),
    [anon_sym___try] = ACTIONS(2242),
    [anon_sym___leave] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_compl] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2244),
    [anon_sym_sizeof] = ACTIONS(2242),
    [anon_sym___alignof__] = ACTIONS(2242),
    [anon_sym___alignof] = ACTIONS(2242),
    [anon_sym__alignof] = ACTIONS(2242),
    [anon_sym_alignof] = ACTIONS(2242),
    [anon_sym__Alignof] = ACTIONS(2242),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2242),
    [anon_sym_asm] = ACTIONS(2242),
    [anon_sym___asm__] = ACTIONS(2242),
    [anon_sym___asm] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2244),
    [anon_sym_L_SQUOTE] = ACTIONS(2244),
    [anon_sym_u_SQUOTE] = ACTIONS(2244),
    [anon_sym_U_SQUOTE] = ACTIONS(2244),
    [anon_sym_u8_SQUOTE] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_L_DQUOTE] = ACTIONS(2244),
    [anon_sym_u_DQUOTE] = ACTIONS(2244),
    [anon_sym_U_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2244),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [anon_sym_NULL] = ACTIONS(2242),
    [anon_sym_nullptr] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_concept] = ACTIONS(2242),
    [anon_sym_co_return] = ACTIONS(2242),
    [anon_sym_co_yield] = ACTIONS(2242),
    [anon_sym_R_DQUOTE] = ACTIONS(2244),
    [anon_sym_LR_DQUOTE] = ACTIONS(2244),
    [anon_sym_uR_DQUOTE] = ACTIONS(2244),
    [anon_sym_UR_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2244),
    [anon_sym_co_await] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [anon_sym_discard] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
    [anon_sym_cbuffer] = ACTIONS(2242),
  },
  [533] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_include_token1] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym___cdecl] = ACTIONS(2266),
    [anon_sym___clrcall] = ACTIONS(2266),
    [anon_sym___stdcall] = ACTIONS(2266),
    [anon_sym___fastcall] = ACTIONS(2266),
    [anon_sym___thiscall] = ACTIONS(2266),
    [anon_sym___vectorcall] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [anon_sym_switch] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_do] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_goto] = ACTIONS(2266),
    [anon_sym___try] = ACTIONS(2266),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2266),
    [anon_sym_compl] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2266),
    [anon_sym___alignof__] = ACTIONS(2266),
    [anon_sym___alignof] = ACTIONS(2266),
    [anon_sym__alignof] = ACTIONS(2266),
    [anon_sym_alignof] = ACTIONS(2266),
    [anon_sym__Alignof] = ACTIONS(2266),
    [anon_sym_offsetof] = ACTIONS(2266),
    [anon_sym__Generic] = ACTIONS(2266),
    [anon_sym_asm] = ACTIONS(2266),
    [anon_sym___asm__] = ACTIONS(2266),
    [anon_sym___asm] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2268),
    [anon_sym_L_SQUOTE] = ACTIONS(2268),
    [anon_sym_u_SQUOTE] = ACTIONS(2268),
    [anon_sym_U_SQUOTE] = ACTIONS(2268),
    [anon_sym_u8_SQUOTE] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_L_DQUOTE] = ACTIONS(2268),
    [anon_sym_u_DQUOTE] = ACTIONS(2268),
    [anon_sym_U_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8_DQUOTE] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [anon_sym_NULL] = ACTIONS(2266),
    [anon_sym_nullptr] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [anon_sym_delete] = ACTIONS(2266),
    [anon_sym_throw] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_concept] = ACTIONS(2266),
    [anon_sym_co_return] = ACTIONS(2266),
    [anon_sym_co_yield] = ACTIONS(2266),
    [anon_sym_R_DQUOTE] = ACTIONS(2268),
    [anon_sym_LR_DQUOTE] = ACTIONS(2268),
    [anon_sym_uR_DQUOTE] = ACTIONS(2268),
    [anon_sym_UR_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2268),
    [anon_sym_co_await] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2266),
    [sym_this] = ACTIONS(2266),
    [anon_sym_discard] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
    [anon_sym_cbuffer] = ACTIONS(2266),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2298),
    [aux_sym_preproc_include_token1] = ACTIONS(2298),
    [aux_sym_preproc_def_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token1] = ACTIONS(2298),
    [aux_sym_preproc_if_token2] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2298),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2298),
    [sym_preproc_directive] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP_AMP] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_using] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym___based] = ACTIONS(2298),
    [anon_sym___cdecl] = ACTIONS(2298),
    [anon_sym___clrcall] = ACTIONS(2298),
    [anon_sym___stdcall] = ACTIONS(2298),
    [anon_sym___fastcall] = ACTIONS(2298),
    [anon_sym___thiscall] = ACTIONS(2298),
    [anon_sym___vectorcall] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym___try] = ACTIONS(2298),
    [anon_sym___leave] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2298),
    [anon_sym_compl] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2298),
    [anon_sym___alignof__] = ACTIONS(2298),
    [anon_sym___alignof] = ACTIONS(2298),
    [anon_sym__alignof] = ACTIONS(2298),
    [anon_sym_alignof] = ACTIONS(2298),
    [anon_sym__Alignof] = ACTIONS(2298),
    [anon_sym_offsetof] = ACTIONS(2298),
    [anon_sym__Generic] = ACTIONS(2298),
    [anon_sym_asm] = ACTIONS(2298),
    [anon_sym___asm__] = ACTIONS(2298),
    [anon_sym___asm] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2300),
    [anon_sym_L_SQUOTE] = ACTIONS(2300),
    [anon_sym_u_SQUOTE] = ACTIONS(2300),
    [anon_sym_U_SQUOTE] = ACTIONS(2300),
    [anon_sym_u8_SQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_L_DQUOTE] = ACTIONS(2300),
    [anon_sym_u_DQUOTE] = ACTIONS(2300),
    [anon_sym_U_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8_DQUOTE] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [anon_sym_NULL] = ACTIONS(2298),
    [anon_sym_nullptr] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2298),
    [anon_sym_explicit] = ACTIONS(2298),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2298),
    [anon_sym_operator] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_namespace] = ACTIONS(2298),
    [anon_sym_static_assert] = ACTIONS(2298),
    [anon_sym_concept] = ACTIONS(2298),
    [anon_sym_co_return] = ACTIONS(2298),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2300),
    [anon_sym_LR_DQUOTE] = ACTIONS(2300),
    [anon_sym_uR_DQUOTE] = ACTIONS(2300),
    [anon_sym_UR_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2300),
    [anon_sym_co_await] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_discard] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
    [anon_sym_cbuffer] = ACTIONS(2298),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_include_token1] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym___cdecl] = ACTIONS(2163),
    [anon_sym___clrcall] = ACTIONS(2163),
    [anon_sym___stdcall] = ACTIONS(2163),
    [anon_sym___fastcall] = ACTIONS(2163),
    [anon_sym___thiscall] = ACTIONS(2163),
    [anon_sym___vectorcall] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_goto] = ACTIONS(2163),
    [anon_sym___try] = ACTIONS(2163),
    [anon_sym___leave] = ACTIONS(2163),
    [anon_sym_not] = ACTIONS(2163),
    [anon_sym_compl] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_sizeof] = ACTIONS(2163),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2163),
    [anon_sym__Generic] = ACTIONS(2163),
    [anon_sym_asm] = ACTIONS(2163),
    [anon_sym___asm__] = ACTIONS(2163),
    [anon_sym___asm] = ACTIONS(2163),
    [sym_number_literal] = ACTIONS(2165),
    [anon_sym_L_SQUOTE] = ACTIONS(2165),
    [anon_sym_u_SQUOTE] = ACTIONS(2165),
    [anon_sym_U_SQUOTE] = ACTIONS(2165),
    [anon_sym_u8_SQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [anon_sym_L_DQUOTE] = ACTIONS(2165),
    [anon_sym_u_DQUOTE] = ACTIONS(2165),
    [anon_sym_U_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8_DQUOTE] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [anon_sym_NULL] = ACTIONS(2163),
    [anon_sym_nullptr] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_concept] = ACTIONS(2163),
    [anon_sym_co_return] = ACTIONS(2163),
    [anon_sym_co_yield] = ACTIONS(2163),
    [anon_sym_R_DQUOTE] = ACTIONS(2165),
    [anon_sym_LR_DQUOTE] = ACTIONS(2165),
    [anon_sym_uR_DQUOTE] = ACTIONS(2165),
    [anon_sym_UR_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2165),
    [anon_sym_co_await] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_requires] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [anon_sym_discard] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
    [anon_sym_cbuffer] = ACTIONS(2163),
  },
  [536] = {
    [sym_identifier] = ACTIONS(2342),
    [aux_sym_preproc_include_token1] = ACTIONS(2342),
    [aux_sym_preproc_def_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token1] = ACTIONS(2342),
    [aux_sym_preproc_if_token2] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2342),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2342),
    [sym_preproc_directive] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_using] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym___based] = ACTIONS(2342),
    [anon_sym___cdecl] = ACTIONS(2342),
    [anon_sym___clrcall] = ACTIONS(2342),
    [anon_sym___stdcall] = ACTIONS(2342),
    [anon_sym___fastcall] = ACTIONS(2342),
    [anon_sym___thiscall] = ACTIONS(2342),
    [anon_sym___vectorcall] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2342),
    [anon_sym_default] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [anon_sym___asm] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [anon_sym_explicit] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_operator] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_namespace] = ACTIONS(2342),
    [anon_sym_static_assert] = ACTIONS(2342),
    [anon_sym_concept] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_discard] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
    [anon_sym_cbuffer] = ACTIONS(2342),
  },
  [537] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_include_token1] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym___cdecl] = ACTIONS(2167),
    [anon_sym___clrcall] = ACTIONS(2167),
    [anon_sym___stdcall] = ACTIONS(2167),
    [anon_sym___fastcall] = ACTIONS(2167),
    [anon_sym___thiscall] = ACTIONS(2167),
    [anon_sym___vectorcall] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_goto] = ACTIONS(2167),
    [anon_sym___try] = ACTIONS(2167),
    [anon_sym___leave] = ACTIONS(2167),
    [anon_sym_not] = ACTIONS(2167),
    [anon_sym_compl] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2167),
    [anon_sym___alignof__] = ACTIONS(2167),
    [anon_sym___alignof] = ACTIONS(2167),
    [anon_sym__alignof] = ACTIONS(2167),
    [anon_sym_alignof] = ACTIONS(2167),
    [anon_sym__Alignof] = ACTIONS(2167),
    [anon_sym_offsetof] = ACTIONS(2167),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2167),
    [anon_sym___asm__] = ACTIONS(2167),
    [anon_sym___asm] = ACTIONS(2167),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [anon_sym_NULL] = ACTIONS(2167),
    [anon_sym_nullptr] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_concept] = ACTIONS(2167),
    [anon_sym_co_return] = ACTIONS(2167),
    [anon_sym_co_yield] = ACTIONS(2167),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [anon_sym_discard] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
    [anon_sym_cbuffer] = ACTIONS(2167),
  },
  [539] = {
    [sym_identifier] = ACTIONS(2302),
    [aux_sym_preproc_include_token1] = ACTIONS(2302),
    [aux_sym_preproc_def_token1] = ACTIONS(2302),
    [aux_sym_preproc_if_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2302),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2302),
    [sym_preproc_directive] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_PLUS] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_AMP_AMP] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym_typedef] = ACTIONS(2302),
    [anon_sym_in] = ACTIONS(2302),
    [anon_sym_out] = ACTIONS(2302),
    [anon_sym_inout] = ACTIONS(2302),
    [anon_sym_virtual] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2302),
    [anon_sym_using] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2304),
    [anon_sym___declspec] = ACTIONS(2302),
    [anon_sym___based] = ACTIONS(2302),
    [anon_sym___cdecl] = ACTIONS(2302),
    [anon_sym___clrcall] = ACTIONS(2302),
    [anon_sym___stdcall] = ACTIONS(2302),
    [anon_sym___fastcall] = ACTIONS(2302),
    [anon_sym___thiscall] = ACTIONS(2302),
    [anon_sym___vectorcall] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_RBRACE] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2302),
    [anon_sym_unsigned] = ACTIONS(2302),
    [anon_sym_long] = ACTIONS(2302),
    [anon_sym_short] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2302),
    [anon_sym_inline] = ACTIONS(2302),
    [anon_sym___inline] = ACTIONS(2302),
    [anon_sym___inline__] = ACTIONS(2302),
    [anon_sym___forceinline] = ACTIONS(2302),
    [anon_sym_thread_local] = ACTIONS(2302),
    [anon_sym___thread] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [sym_primitive_type] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_class] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_case] = ACTIONS(2302),
    [anon_sym_default] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_goto] = ACTIONS(2302),
    [anon_sym___try] = ACTIONS(2302),
    [anon_sym___leave] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2302),
    [anon_sym_compl] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2302),
    [anon_sym___alignof__] = ACTIONS(2302),
    [anon_sym___alignof] = ACTIONS(2302),
    [anon_sym__alignof] = ACTIONS(2302),
    [anon_sym_alignof] = ACTIONS(2302),
    [anon_sym__Alignof] = ACTIONS(2302),
    [anon_sym_offsetof] = ACTIONS(2302),
    [anon_sym__Generic] = ACTIONS(2302),
    [anon_sym_asm] = ACTIONS(2302),
    [anon_sym___asm__] = ACTIONS(2302),
    [anon_sym___asm] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2304),
    [anon_sym_L_SQUOTE] = ACTIONS(2304),
    [anon_sym_u_SQUOTE] = ACTIONS(2304),
    [anon_sym_U_SQUOTE] = ACTIONS(2304),
    [anon_sym_u8_SQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_L_DQUOTE] = ACTIONS(2304),
    [anon_sym_u_DQUOTE] = ACTIONS(2304),
    [anon_sym_U_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8_DQUOTE] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [anon_sym_NULL] = ACTIONS(2302),
    [anon_sym_nullptr] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2302),
    [anon_sym_decltype] = ACTIONS(2302),
    [anon_sym_explicit] = ACTIONS(2302),
    [anon_sym_typename] = ACTIONS(2302),
    [anon_sym_template] = ACTIONS(2302),
    [anon_sym_operator] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [anon_sym_delete] = ACTIONS(2302),
    [anon_sym_throw] = ACTIONS(2302),
    [anon_sym_namespace] = ACTIONS(2302),
    [anon_sym_static_assert] = ACTIONS(2302),
    [anon_sym_concept] = ACTIONS(2302),
    [anon_sym_co_return] = ACTIONS(2302),
    [anon_sym_co_yield] = ACTIONS(2302),
    [anon_sym_R_DQUOTE] = ACTIONS(2304),
    [anon_sym_LR_DQUOTE] = ACTIONS(2304),
    [anon_sym_uR_DQUOTE] = ACTIONS(2304),
    [anon_sym_UR_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2304),
    [anon_sym_co_await] = ACTIONS(2302),
    [anon_sym_new] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2302),
    [sym_this] = ACTIONS(2302),
    [anon_sym_discard] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2302),
    [anon_sym_shared] = ACTIONS(2302),
    [anon_sym_groupshared] = ACTIONS(2302),
    [anon_sym_uniform] = ACTIONS(2302),
    [anon_sym_row_major] = ACTIONS(2302),
    [anon_sym_column_major] = ACTIONS(2302),
    [anon_sym_globallycoherent] = ACTIONS(2302),
    [anon_sym_centroid] = ACTIONS(2302),
    [anon_sym_noperspective] = ACTIONS(2302),
    [anon_sym_nointerpolation] = ACTIONS(2302),
    [anon_sym_sample] = ACTIONS(2302),
    [anon_sym_linear] = ACTIONS(2302),
    [anon_sym_snorm] = ACTIONS(2302),
    [anon_sym_unorm] = ACTIONS(2302),
    [anon_sym_point] = ACTIONS(2302),
    [anon_sym_line] = ACTIONS(2302),
    [anon_sym_triangleadj] = ACTIONS(2302),
    [anon_sym_lineadj] = ACTIONS(2302),
    [anon_sym_triangle] = ACTIONS(2302),
    [anon_sym_cbuffer] = ACTIONS(2302),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_include_token1] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token2] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym___cdecl] = ACTIONS(2382),
    [anon_sym___clrcall] = ACTIONS(2382),
    [anon_sym___stdcall] = ACTIONS(2382),
    [anon_sym___fastcall] = ACTIONS(2382),
    [anon_sym___thiscall] = ACTIONS(2382),
    [anon_sym___vectorcall] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2382),
    [anon_sym___leave] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2382),
    [anon_sym_compl] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2382),
    [anon_sym___alignof__] = ACTIONS(2382),
    [anon_sym___alignof] = ACTIONS(2382),
    [anon_sym__alignof] = ACTIONS(2382),
    [anon_sym_alignof] = ACTIONS(2382),
    [anon_sym__Alignof] = ACTIONS(2382),
    [anon_sym_offsetof] = ACTIONS(2382),
    [anon_sym__Generic] = ACTIONS(2382),
    [anon_sym_asm] = ACTIONS(2382),
    [anon_sym___asm__] = ACTIONS(2382),
    [anon_sym___asm] = ACTIONS(2382),
    [sym_number_literal] = ACTIONS(2384),
    [anon_sym_L_SQUOTE] = ACTIONS(2384),
    [anon_sym_u_SQUOTE] = ACTIONS(2384),
    [anon_sym_U_SQUOTE] = ACTIONS(2384),
    [anon_sym_u8_SQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_L_DQUOTE] = ACTIONS(2384),
    [anon_sym_u_DQUOTE] = ACTIONS(2384),
    [anon_sym_U_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8_DQUOTE] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_concept] = ACTIONS(2382),
    [anon_sym_co_return] = ACTIONS(2382),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2384),
    [anon_sym_LR_DQUOTE] = ACTIONS(2384),
    [anon_sym_uR_DQUOTE] = ACTIONS(2384),
    [anon_sym_UR_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2384),
    [anon_sym_co_await] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_requires] = ACTIONS(2382),
    [sym_this] = ACTIONS(2382),
    [anon_sym_discard] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
    [anon_sym_cbuffer] = ACTIONS(2382),
  },
  [541] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_include_token1] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token2] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym___cdecl] = ACTIONS(2163),
    [anon_sym___clrcall] = ACTIONS(2163),
    [anon_sym___stdcall] = ACTIONS(2163),
    [anon_sym___fastcall] = ACTIONS(2163),
    [anon_sym___thiscall] = ACTIONS(2163),
    [anon_sym___vectorcall] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_case] = ACTIONS(2163),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_goto] = ACTIONS(2163),
    [anon_sym___try] = ACTIONS(2163),
    [anon_sym___leave] = ACTIONS(2163),
    [anon_sym_not] = ACTIONS(2163),
    [anon_sym_compl] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_sizeof] = ACTIONS(2163),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2163),
    [anon_sym__Generic] = ACTIONS(2163),
    [anon_sym_asm] = ACTIONS(2163),
    [anon_sym___asm__] = ACTIONS(2163),
    [anon_sym___asm] = ACTIONS(2163),
    [sym_number_literal] = ACTIONS(2165),
    [anon_sym_L_SQUOTE] = ACTIONS(2165),
    [anon_sym_u_SQUOTE] = ACTIONS(2165),
    [anon_sym_U_SQUOTE] = ACTIONS(2165),
    [anon_sym_u8_SQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [anon_sym_L_DQUOTE] = ACTIONS(2165),
    [anon_sym_u_DQUOTE] = ACTIONS(2165),
    [anon_sym_U_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8_DQUOTE] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [anon_sym_NULL] = ACTIONS(2163),
    [anon_sym_nullptr] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_namespace] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_concept] = ACTIONS(2163),
    [anon_sym_co_return] = ACTIONS(2163),
    [anon_sym_co_yield] = ACTIONS(2163),
    [anon_sym_R_DQUOTE] = ACTIONS(2165),
    [anon_sym_LR_DQUOTE] = ACTIONS(2165),
    [anon_sym_uR_DQUOTE] = ACTIONS(2165),
    [anon_sym_UR_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2165),
    [anon_sym_co_await] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_requires] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [anon_sym_discard] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
    [anon_sym_cbuffer] = ACTIONS(2163),
  },
  [542] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_include_token1] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token2] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym___cdecl] = ACTIONS(2167),
    [anon_sym___clrcall] = ACTIONS(2167),
    [anon_sym___stdcall] = ACTIONS(2167),
    [anon_sym___fastcall] = ACTIONS(2167),
    [anon_sym___thiscall] = ACTIONS(2167),
    [anon_sym___vectorcall] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_case] = ACTIONS(2167),
    [anon_sym_default] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_goto] = ACTIONS(2167),
    [anon_sym___try] = ACTIONS(2167),
    [anon_sym___leave] = ACTIONS(2167),
    [anon_sym_not] = ACTIONS(2167),
    [anon_sym_compl] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2167),
    [anon_sym___alignof__] = ACTIONS(2167),
    [anon_sym___alignof] = ACTIONS(2167),
    [anon_sym__alignof] = ACTIONS(2167),
    [anon_sym_alignof] = ACTIONS(2167),
    [anon_sym__Alignof] = ACTIONS(2167),
    [anon_sym_offsetof] = ACTIONS(2167),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2167),
    [anon_sym___asm__] = ACTIONS(2167),
    [anon_sym___asm] = ACTIONS(2167),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [anon_sym_NULL] = ACTIONS(2167),
    [anon_sym_nullptr] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_concept] = ACTIONS(2167),
    [anon_sym_co_return] = ACTIONS(2167),
    [anon_sym_co_yield] = ACTIONS(2167),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [anon_sym_discard] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
    [anon_sym_cbuffer] = ACTIONS(2167),
  },
  [543] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_include_token1] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym___cdecl] = ACTIONS(2246),
    [anon_sym___clrcall] = ACTIONS(2246),
    [anon_sym___stdcall] = ACTIONS(2246),
    [anon_sym___fastcall] = ACTIONS(2246),
    [anon_sym___thiscall] = ACTIONS(2246),
    [anon_sym___vectorcall] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2246),
    [anon_sym_switch] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_goto] = ACTIONS(2246),
    [anon_sym___try] = ACTIONS(2246),
    [anon_sym___leave] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_compl] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_sizeof] = ACTIONS(2246),
    [anon_sym___alignof__] = ACTIONS(2246),
    [anon_sym___alignof] = ACTIONS(2246),
    [anon_sym__alignof] = ACTIONS(2246),
    [anon_sym_alignof] = ACTIONS(2246),
    [anon_sym__Alignof] = ACTIONS(2246),
    [anon_sym_offsetof] = ACTIONS(2246),
    [anon_sym__Generic] = ACTIONS(2246),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym___asm] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2248),
    [anon_sym_L_SQUOTE] = ACTIONS(2248),
    [anon_sym_u_SQUOTE] = ACTIONS(2248),
    [anon_sym_U_SQUOTE] = ACTIONS(2248),
    [anon_sym_u8_SQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_L_DQUOTE] = ACTIONS(2248),
    [anon_sym_u_DQUOTE] = ACTIONS(2248),
    [anon_sym_U_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [anon_sym_NULL] = ACTIONS(2246),
    [anon_sym_nullptr] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_delete] = ACTIONS(2246),
    [anon_sym_throw] = ACTIONS(2246),
    [anon_sym_namespace] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_concept] = ACTIONS(2246),
    [anon_sym_co_return] = ACTIONS(2246),
    [anon_sym_co_yield] = ACTIONS(2246),
    [anon_sym_R_DQUOTE] = ACTIONS(2248),
    [anon_sym_LR_DQUOTE] = ACTIONS(2248),
    [anon_sym_uR_DQUOTE] = ACTIONS(2248),
    [anon_sym_UR_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2248),
    [anon_sym_co_await] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2246),
    [sym_this] = ACTIONS(2246),
    [anon_sym_discard] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
    [anon_sym_cbuffer] = ACTIONS(2246),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2222),
    [aux_sym_preproc_include_token1] = ACTIONS(2222),
    [aux_sym_preproc_def_token1] = ACTIONS(2222),
    [aux_sym_preproc_if_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2222),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2222),
    [sym_preproc_directive] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP_AMP] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_using] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym___based] = ACTIONS(2222),
    [anon_sym___cdecl] = ACTIONS(2222),
    [anon_sym___clrcall] = ACTIONS(2222),
    [anon_sym___stdcall] = ACTIONS(2222),
    [anon_sym___fastcall] = ACTIONS(2222),
    [anon_sym___thiscall] = ACTIONS(2222),
    [anon_sym___vectorcall] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_RBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_case] = ACTIONS(2222),
    [anon_sym_default] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2224),
    [anon_sym_L_SQUOTE] = ACTIONS(2224),
    [anon_sym_u_SQUOTE] = ACTIONS(2224),
    [anon_sym_U_SQUOTE] = ACTIONS(2224),
    [anon_sym_u8_SQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_L_DQUOTE] = ACTIONS(2224),
    [anon_sym_u_DQUOTE] = ACTIONS(2224),
    [anon_sym_U_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8_DQUOTE] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_explicit] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_operator] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_namespace] = ACTIONS(2222),
    [anon_sym_static_assert] = ACTIONS(2222),
    [anon_sym_concept] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2224),
    [anon_sym_LR_DQUOTE] = ACTIONS(2224),
    [anon_sym_uR_DQUOTE] = ACTIONS(2224),
    [anon_sym_UR_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2224),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
  },
  [545] = {
    [sym_identifier] = ACTIONS(2226),
    [aux_sym_preproc_include_token1] = ACTIONS(2226),
    [aux_sym_preproc_def_token1] = ACTIONS(2226),
    [aux_sym_preproc_if_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2226),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2226),
    [sym_preproc_directive] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_typedef] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_virtual] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym___attribute] = ACTIONS(2226),
    [anon_sym_using] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym___based] = ACTIONS(2226),
    [anon_sym___cdecl] = ACTIONS(2226),
    [anon_sym___clrcall] = ACTIONS(2226),
    [anon_sym___stdcall] = ACTIONS(2226),
    [anon_sym___fastcall] = ACTIONS(2226),
    [anon_sym___thiscall] = ACTIONS(2226),
    [anon_sym___vectorcall] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym__Nonnull] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_case] = ACTIONS(2226),
    [anon_sym_default] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_goto] = ACTIONS(2226),
    [anon_sym___try] = ACTIONS(2226),
    [anon_sym___leave] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2226),
    [anon_sym_compl] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2226),
    [anon_sym___alignof__] = ACTIONS(2226),
    [anon_sym___alignof] = ACTIONS(2226),
    [anon_sym__alignof] = ACTIONS(2226),
    [anon_sym_alignof] = ACTIONS(2226),
    [anon_sym__Alignof] = ACTIONS(2226),
    [anon_sym_offsetof] = ACTIONS(2226),
    [anon_sym__Generic] = ACTIONS(2226),
    [anon_sym_asm] = ACTIONS(2226),
    [anon_sym___asm__] = ACTIONS(2226),
    [anon_sym___asm] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2228),
    [anon_sym_L_SQUOTE] = ACTIONS(2228),
    [anon_sym_u_SQUOTE] = ACTIONS(2228),
    [anon_sym_U_SQUOTE] = ACTIONS(2228),
    [anon_sym_u8_SQUOTE] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_L_DQUOTE] = ACTIONS(2228),
    [anon_sym_u_DQUOTE] = ACTIONS(2228),
    [anon_sym_U_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [anon_sym_NULL] = ACTIONS(2226),
    [anon_sym_nullptr] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2226),
    [anon_sym_decltype] = ACTIONS(2226),
    [anon_sym_explicit] = ACTIONS(2226),
    [anon_sym_typename] = ACTIONS(2226),
    [anon_sym_template] = ACTIONS(2226),
    [anon_sym_operator] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_namespace] = ACTIONS(2226),
    [anon_sym_static_assert] = ACTIONS(2226),
    [anon_sym_concept] = ACTIONS(2226),
    [anon_sym_co_return] = ACTIONS(2226),
    [anon_sym_co_yield] = ACTIONS(2226),
    [anon_sym_R_DQUOTE] = ACTIONS(2228),
    [anon_sym_LR_DQUOTE] = ACTIONS(2228),
    [anon_sym_uR_DQUOTE] = ACTIONS(2228),
    [anon_sym_UR_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2228),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [anon_sym_discard] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_groupshared] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_row_major] = ACTIONS(2226),
    [anon_sym_column_major] = ACTIONS(2226),
    [anon_sym_globallycoherent] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym_nointerpolation] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_linear] = ACTIONS(2226),
    [anon_sym_snorm] = ACTIONS(2226),
    [anon_sym_unorm] = ACTIONS(2226),
    [anon_sym_point] = ACTIONS(2226),
    [anon_sym_line] = ACTIONS(2226),
    [anon_sym_triangleadj] = ACTIONS(2226),
    [anon_sym_lineadj] = ACTIONS(2226),
    [anon_sym_triangle] = ACTIONS(2226),
    [anon_sym_cbuffer] = ACTIONS(2226),
  },
  [546] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token2] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
  },
  [547] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token2] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
  },
  [548] = {
    [sym_identifier] = ACTIONS(2230),
    [aux_sym_preproc_include_token1] = ACTIONS(2230),
    [aux_sym_preproc_def_token1] = ACTIONS(2230),
    [aux_sym_preproc_if_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2230),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2230),
    [sym_preproc_directive] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AMP_AMP] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2230),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_typedef] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_virtual] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym___attribute] = ACTIONS(2230),
    [anon_sym_using] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym___based] = ACTIONS(2230),
    [anon_sym___cdecl] = ACTIONS(2230),
    [anon_sym___clrcall] = ACTIONS(2230),
    [anon_sym___stdcall] = ACTIONS(2230),
    [anon_sym___fastcall] = ACTIONS(2230),
    [anon_sym___thiscall] = ACTIONS(2230),
    [anon_sym___vectorcall] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym__Nonnull] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_class] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2230),
    [anon_sym_switch] = ACTIONS(2230),
    [anon_sym_case] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_goto] = ACTIONS(2230),
    [anon_sym___try] = ACTIONS(2230),
    [anon_sym___leave] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2232),
    [anon_sym_sizeof] = ACTIONS(2230),
    [anon_sym___alignof__] = ACTIONS(2230),
    [anon_sym___alignof] = ACTIONS(2230),
    [anon_sym__alignof] = ACTIONS(2230),
    [anon_sym_alignof] = ACTIONS(2230),
    [anon_sym__Alignof] = ACTIONS(2230),
    [anon_sym_offsetof] = ACTIONS(2230),
    [anon_sym__Generic] = ACTIONS(2230),
    [anon_sym_asm] = ACTIONS(2230),
    [anon_sym___asm__] = ACTIONS(2230),
    [anon_sym___asm] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2232),
    [anon_sym_L_SQUOTE] = ACTIONS(2232),
    [anon_sym_u_SQUOTE] = ACTIONS(2232),
    [anon_sym_U_SQUOTE] = ACTIONS(2232),
    [anon_sym_u8_SQUOTE] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_L_DQUOTE] = ACTIONS(2232),
    [anon_sym_u_DQUOTE] = ACTIONS(2232),
    [anon_sym_U_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8_DQUOTE] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [sym_true] = ACTIONS(2230),
    [sym_false] = ACTIONS(2230),
    [anon_sym_NULL] = ACTIONS(2230),
    [anon_sym_nullptr] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2230),
    [anon_sym_decltype] = ACTIONS(2230),
    [anon_sym_explicit] = ACTIONS(2230),
    [anon_sym_typename] = ACTIONS(2230),
    [anon_sym_template] = ACTIONS(2230),
    [anon_sym_operator] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_delete] = ACTIONS(2230),
    [anon_sym_throw] = ACTIONS(2230),
    [anon_sym_namespace] = ACTIONS(2230),
    [anon_sym_static_assert] = ACTIONS(2230),
    [anon_sym_concept] = ACTIONS(2230),
    [anon_sym_co_return] = ACTIONS(2230),
    [anon_sym_co_yield] = ACTIONS(2230),
    [anon_sym_R_DQUOTE] = ACTIONS(2232),
    [anon_sym_LR_DQUOTE] = ACTIONS(2232),
    [anon_sym_uR_DQUOTE] = ACTIONS(2232),
    [anon_sym_UR_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2232),
    [anon_sym_co_await] = ACTIONS(2230),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2230),
    [sym_this] = ACTIONS(2230),
    [anon_sym_discard] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_groupshared] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_row_major] = ACTIONS(2230),
    [anon_sym_column_major] = ACTIONS(2230),
    [anon_sym_globallycoherent] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym_nointerpolation] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_linear] = ACTIONS(2230),
    [anon_sym_snorm] = ACTIONS(2230),
    [anon_sym_unorm] = ACTIONS(2230),
    [anon_sym_point] = ACTIONS(2230),
    [anon_sym_line] = ACTIONS(2230),
    [anon_sym_triangleadj] = ACTIONS(2230),
    [anon_sym_lineadj] = ACTIONS(2230),
    [anon_sym_triangle] = ACTIONS(2230),
    [anon_sym_cbuffer] = ACTIONS(2230),
  },
  [549] = {
    [sym_identifier] = ACTIONS(2234),
    [aux_sym_preproc_include_token1] = ACTIONS(2234),
    [aux_sym_preproc_def_token1] = ACTIONS(2234),
    [aux_sym_preproc_if_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2234),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2234),
    [sym_preproc_directive] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_AMP_AMP] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_typedef] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_virtual] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_using] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym___based] = ACTIONS(2234),
    [anon_sym___cdecl] = ACTIONS(2234),
    [anon_sym___clrcall] = ACTIONS(2234),
    [anon_sym___stdcall] = ACTIONS(2234),
    [anon_sym___fastcall] = ACTIONS(2234),
    [anon_sym___thiscall] = ACTIONS(2234),
    [anon_sym___vectorcall] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym__Nonnull] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_case] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_goto] = ACTIONS(2234),
    [anon_sym___try] = ACTIONS(2234),
    [anon_sym___leave] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2234),
    [anon_sym_compl] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2236),
    [anon_sym_sizeof] = ACTIONS(2234),
    [anon_sym___alignof__] = ACTIONS(2234),
    [anon_sym___alignof] = ACTIONS(2234),
    [anon_sym__alignof] = ACTIONS(2234),
    [anon_sym_alignof] = ACTIONS(2234),
    [anon_sym__Alignof] = ACTIONS(2234),
    [anon_sym_offsetof] = ACTIONS(2234),
    [anon_sym__Generic] = ACTIONS(2234),
    [anon_sym_asm] = ACTIONS(2234),
    [anon_sym___asm__] = ACTIONS(2234),
    [anon_sym___asm] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2236),
    [anon_sym_L_SQUOTE] = ACTIONS(2236),
    [anon_sym_u_SQUOTE] = ACTIONS(2236),
    [anon_sym_U_SQUOTE] = ACTIONS(2236),
    [anon_sym_u8_SQUOTE] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_L_DQUOTE] = ACTIONS(2236),
    [anon_sym_u_DQUOTE] = ACTIONS(2236),
    [anon_sym_U_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8_DQUOTE] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2236),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [anon_sym_NULL] = ACTIONS(2234),
    [anon_sym_nullptr] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2234),
    [anon_sym_decltype] = ACTIONS(2234),
    [anon_sym_explicit] = ACTIONS(2234),
    [anon_sym_typename] = ACTIONS(2234),
    [anon_sym_template] = ACTIONS(2234),
    [anon_sym_operator] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_namespace] = ACTIONS(2234),
    [anon_sym_static_assert] = ACTIONS(2234),
    [anon_sym_concept] = ACTIONS(2234),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2236),
    [anon_sym_LR_DQUOTE] = ACTIONS(2236),
    [anon_sym_uR_DQUOTE] = ACTIONS(2236),
    [anon_sym_UR_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2236),
    [anon_sym_co_await] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [anon_sym_discard] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_groupshared] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_row_major] = ACTIONS(2234),
    [anon_sym_column_major] = ACTIONS(2234),
    [anon_sym_globallycoherent] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym_nointerpolation] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_linear] = ACTIONS(2234),
    [anon_sym_snorm] = ACTIONS(2234),
    [anon_sym_unorm] = ACTIONS(2234),
    [anon_sym_point] = ACTIONS(2234),
    [anon_sym_line] = ACTIONS(2234),
    [anon_sym_triangleadj] = ACTIONS(2234),
    [anon_sym_lineadj] = ACTIONS(2234),
    [anon_sym_triangle] = ACTIONS(2234),
    [anon_sym_cbuffer] = ACTIONS(2234),
  },
  [550] = {
    [sym_identifier] = ACTIONS(2238),
    [aux_sym_preproc_include_token1] = ACTIONS(2238),
    [aux_sym_preproc_def_token1] = ACTIONS(2238),
    [aux_sym_preproc_if_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2238),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2238),
    [sym_preproc_directive] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_AMP_AMP] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_typedef] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_virtual] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym___attribute] = ACTIONS(2238),
    [anon_sym_using] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym___based] = ACTIONS(2238),
    [anon_sym___cdecl] = ACTIONS(2238),
    [anon_sym___clrcall] = ACTIONS(2238),
    [anon_sym___stdcall] = ACTIONS(2238),
    [anon_sym___fastcall] = ACTIONS(2238),
    [anon_sym___thiscall] = ACTIONS(2238),
    [anon_sym___vectorcall] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym__Nonnull] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_do] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2238),
    [anon_sym___try] = ACTIONS(2238),
    [anon_sym___leave] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2238),
    [anon_sym_compl] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2238),
    [anon_sym___alignof] = ACTIONS(2238),
    [anon_sym__alignof] = ACTIONS(2238),
    [anon_sym_alignof] = ACTIONS(2238),
    [anon_sym__Alignof] = ACTIONS(2238),
    [anon_sym_offsetof] = ACTIONS(2238),
    [anon_sym__Generic] = ACTIONS(2238),
    [anon_sym_asm] = ACTIONS(2238),
    [anon_sym___asm__] = ACTIONS(2238),
    [anon_sym___asm] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2240),
    [anon_sym_L_SQUOTE] = ACTIONS(2240),
    [anon_sym_u_SQUOTE] = ACTIONS(2240),
    [anon_sym_U_SQUOTE] = ACTIONS(2240),
    [anon_sym_u8_SQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_L_DQUOTE] = ACTIONS(2240),
    [anon_sym_u_DQUOTE] = ACTIONS(2240),
    [anon_sym_U_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [anon_sym_NULL] = ACTIONS(2238),
    [anon_sym_nullptr] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2238),
    [anon_sym_decltype] = ACTIONS(2238),
    [anon_sym_explicit] = ACTIONS(2238),
    [anon_sym_typename] = ACTIONS(2238),
    [anon_sym_template] = ACTIONS(2238),
    [anon_sym_operator] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [anon_sym_delete] = ACTIONS(2238),
    [anon_sym_throw] = ACTIONS(2238),
    [anon_sym_namespace] = ACTIONS(2238),
    [anon_sym_static_assert] = ACTIONS(2238),
    [anon_sym_concept] = ACTIONS(2238),
    [anon_sym_co_return] = ACTIONS(2238),
    [anon_sym_co_yield] = ACTIONS(2238),
    [anon_sym_R_DQUOTE] = ACTIONS(2240),
    [anon_sym_LR_DQUOTE] = ACTIONS(2240),
    [anon_sym_uR_DQUOTE] = ACTIONS(2240),
    [anon_sym_UR_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2240),
    [anon_sym_co_await] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2238),
    [sym_this] = ACTIONS(2238),
    [anon_sym_discard] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_groupshared] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_row_major] = ACTIONS(2238),
    [anon_sym_column_major] = ACTIONS(2238),
    [anon_sym_globallycoherent] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym_nointerpolation] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_linear] = ACTIONS(2238),
    [anon_sym_snorm] = ACTIONS(2238),
    [anon_sym_unorm] = ACTIONS(2238),
    [anon_sym_point] = ACTIONS(2238),
    [anon_sym_line] = ACTIONS(2238),
    [anon_sym_triangleadj] = ACTIONS(2238),
    [anon_sym_lineadj] = ACTIONS(2238),
    [anon_sym_triangle] = ACTIONS(2238),
    [anon_sym_cbuffer] = ACTIONS(2238),
  },
  [551] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_include_token1] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym___cdecl] = ACTIONS(2242),
    [anon_sym___clrcall] = ACTIONS(2242),
    [anon_sym___stdcall] = ACTIONS(2242),
    [anon_sym___fastcall] = ACTIONS(2242),
    [anon_sym___thiscall] = ACTIONS(2242),
    [anon_sym___vectorcall] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_case] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_goto] = ACTIONS(2242),
    [anon_sym___try] = ACTIONS(2242),
    [anon_sym___leave] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_compl] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2244),
    [anon_sym_sizeof] = ACTIONS(2242),
    [anon_sym___alignof__] = ACTIONS(2242),
    [anon_sym___alignof] = ACTIONS(2242),
    [anon_sym__alignof] = ACTIONS(2242),
    [anon_sym_alignof] = ACTIONS(2242),
    [anon_sym__Alignof] = ACTIONS(2242),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2242),
    [anon_sym_asm] = ACTIONS(2242),
    [anon_sym___asm__] = ACTIONS(2242),
    [anon_sym___asm] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2244),
    [anon_sym_L_SQUOTE] = ACTIONS(2244),
    [anon_sym_u_SQUOTE] = ACTIONS(2244),
    [anon_sym_U_SQUOTE] = ACTIONS(2244),
    [anon_sym_u8_SQUOTE] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_L_DQUOTE] = ACTIONS(2244),
    [anon_sym_u_DQUOTE] = ACTIONS(2244),
    [anon_sym_U_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2244),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [anon_sym_NULL] = ACTIONS(2242),
    [anon_sym_nullptr] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_namespace] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_concept] = ACTIONS(2242),
    [anon_sym_co_return] = ACTIONS(2242),
    [anon_sym_co_yield] = ACTIONS(2242),
    [anon_sym_R_DQUOTE] = ACTIONS(2244),
    [anon_sym_LR_DQUOTE] = ACTIONS(2244),
    [anon_sym_uR_DQUOTE] = ACTIONS(2244),
    [anon_sym_UR_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2244),
    [anon_sym_co_await] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [anon_sym_discard] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
    [anon_sym_cbuffer] = ACTIONS(2242),
  },
  [552] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_include_token1] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym___cdecl] = ACTIONS(2246),
    [anon_sym___clrcall] = ACTIONS(2246),
    [anon_sym___stdcall] = ACTIONS(2246),
    [anon_sym___fastcall] = ACTIONS(2246),
    [anon_sym___thiscall] = ACTIONS(2246),
    [anon_sym___vectorcall] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2246),
    [anon_sym_switch] = ACTIONS(2246),
    [anon_sym_case] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_goto] = ACTIONS(2246),
    [anon_sym___try] = ACTIONS(2246),
    [anon_sym___leave] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_compl] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_sizeof] = ACTIONS(2246),
    [anon_sym___alignof__] = ACTIONS(2246),
    [anon_sym___alignof] = ACTIONS(2246),
    [anon_sym__alignof] = ACTIONS(2246),
    [anon_sym_alignof] = ACTIONS(2246),
    [anon_sym__Alignof] = ACTIONS(2246),
    [anon_sym_offsetof] = ACTIONS(2246),
    [anon_sym__Generic] = ACTIONS(2246),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym___asm] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2248),
    [anon_sym_L_SQUOTE] = ACTIONS(2248),
    [anon_sym_u_SQUOTE] = ACTIONS(2248),
    [anon_sym_U_SQUOTE] = ACTIONS(2248),
    [anon_sym_u8_SQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_L_DQUOTE] = ACTIONS(2248),
    [anon_sym_u_DQUOTE] = ACTIONS(2248),
    [anon_sym_U_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [anon_sym_NULL] = ACTIONS(2246),
    [anon_sym_nullptr] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_delete] = ACTIONS(2246),
    [anon_sym_throw] = ACTIONS(2246),
    [anon_sym_namespace] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_concept] = ACTIONS(2246),
    [anon_sym_co_return] = ACTIONS(2246),
    [anon_sym_co_yield] = ACTIONS(2246),
    [anon_sym_R_DQUOTE] = ACTIONS(2248),
    [anon_sym_LR_DQUOTE] = ACTIONS(2248),
    [anon_sym_uR_DQUOTE] = ACTIONS(2248),
    [anon_sym_UR_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2248),
    [anon_sym_co_await] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2246),
    [sym_this] = ACTIONS(2246),
    [anon_sym_discard] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
    [anon_sym_cbuffer] = ACTIONS(2246),
  },
  [553] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_include_token1] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym___cdecl] = ACTIONS(2266),
    [anon_sym___clrcall] = ACTIONS(2266),
    [anon_sym___stdcall] = ACTIONS(2266),
    [anon_sym___fastcall] = ACTIONS(2266),
    [anon_sym___thiscall] = ACTIONS(2266),
    [anon_sym___vectorcall] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_RBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [anon_sym_switch] = ACTIONS(2266),
    [anon_sym_case] = ACTIONS(2266),
    [anon_sym_default] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_do] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_goto] = ACTIONS(2266),
    [anon_sym___try] = ACTIONS(2266),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2266),
    [anon_sym_compl] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2266),
    [anon_sym___alignof__] = ACTIONS(2266),
    [anon_sym___alignof] = ACTIONS(2266),
    [anon_sym__alignof] = ACTIONS(2266),
    [anon_sym_alignof] = ACTIONS(2266),
    [anon_sym__Alignof] = ACTIONS(2266),
    [anon_sym_offsetof] = ACTIONS(2266),
    [anon_sym__Generic] = ACTIONS(2266),
    [anon_sym_asm] = ACTIONS(2266),
    [anon_sym___asm__] = ACTIONS(2266),
    [anon_sym___asm] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2268),
    [anon_sym_L_SQUOTE] = ACTIONS(2268),
    [anon_sym_u_SQUOTE] = ACTIONS(2268),
    [anon_sym_U_SQUOTE] = ACTIONS(2268),
    [anon_sym_u8_SQUOTE] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_L_DQUOTE] = ACTIONS(2268),
    [anon_sym_u_DQUOTE] = ACTIONS(2268),
    [anon_sym_U_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8_DQUOTE] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [anon_sym_NULL] = ACTIONS(2266),
    [anon_sym_nullptr] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [anon_sym_delete] = ACTIONS(2266),
    [anon_sym_throw] = ACTIONS(2266),
    [anon_sym_namespace] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_concept] = ACTIONS(2266),
    [anon_sym_co_return] = ACTIONS(2266),
    [anon_sym_co_yield] = ACTIONS(2266),
    [anon_sym_R_DQUOTE] = ACTIONS(2268),
    [anon_sym_LR_DQUOTE] = ACTIONS(2268),
    [anon_sym_uR_DQUOTE] = ACTIONS(2268),
    [anon_sym_UR_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2268),
    [anon_sym_co_await] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2266),
    [sym_this] = ACTIONS(2266),
    [anon_sym_discard] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
    [anon_sym_cbuffer] = ACTIONS(2266),
  },
  [554] = {
    [sym_identifier] = ACTIONS(2270),
    [aux_sym_preproc_include_token1] = ACTIONS(2270),
    [aux_sym_preproc_def_token1] = ACTIONS(2270),
    [aux_sym_preproc_if_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2270),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2270),
    [sym_preproc_directive] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AMP_AMP] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_typedef] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_virtual] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2270),
    [anon_sym_using] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym___based] = ACTIONS(2270),
    [anon_sym___cdecl] = ACTIONS(2270),
    [anon_sym___clrcall] = ACTIONS(2270),
    [anon_sym___stdcall] = ACTIONS(2270),
    [anon_sym___fastcall] = ACTIONS(2270),
    [anon_sym___thiscall] = ACTIONS(2270),
    [anon_sym___vectorcall] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_class] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_switch] = ACTIONS(2270),
    [anon_sym_case] = ACTIONS(2270),
    [anon_sym_default] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_do] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_goto] = ACTIONS(2270),
    [anon_sym___try] = ACTIONS(2270),
    [anon_sym___leave] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_compl] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2270),
    [anon_sym___alignof__] = ACTIONS(2270),
    [anon_sym___alignof] = ACTIONS(2270),
    [anon_sym__alignof] = ACTIONS(2270),
    [anon_sym_alignof] = ACTIONS(2270),
    [anon_sym__Alignof] = ACTIONS(2270),
    [anon_sym_offsetof] = ACTIONS(2270),
    [anon_sym__Generic] = ACTIONS(2270),
    [anon_sym_asm] = ACTIONS(2270),
    [anon_sym___asm__] = ACTIONS(2270),
    [anon_sym___asm] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2272),
    [anon_sym_L_SQUOTE] = ACTIONS(2272),
    [anon_sym_u_SQUOTE] = ACTIONS(2272),
    [anon_sym_U_SQUOTE] = ACTIONS(2272),
    [anon_sym_u8_SQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_L_DQUOTE] = ACTIONS(2272),
    [anon_sym_u_DQUOTE] = ACTIONS(2272),
    [anon_sym_U_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8_DQUOTE] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [anon_sym_NULL] = ACTIONS(2270),
    [anon_sym_nullptr] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2270),
    [anon_sym_decltype] = ACTIONS(2270),
    [anon_sym_explicit] = ACTIONS(2270),
    [anon_sym_typename] = ACTIONS(2270),
    [anon_sym_template] = ACTIONS(2270),
    [anon_sym_operator] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [anon_sym_delete] = ACTIONS(2270),
    [anon_sym_throw] = ACTIONS(2270),
    [anon_sym_namespace] = ACTIONS(2270),
    [anon_sym_static_assert] = ACTIONS(2270),
    [anon_sym_concept] = ACTIONS(2270),
    [anon_sym_co_return] = ACTIONS(2270),
    [anon_sym_co_yield] = ACTIONS(2270),
    [anon_sym_R_DQUOTE] = ACTIONS(2272),
    [anon_sym_LR_DQUOTE] = ACTIONS(2272),
    [anon_sym_uR_DQUOTE] = ACTIONS(2272),
    [anon_sym_UR_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2272),
    [anon_sym_co_await] = ACTIONS(2270),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2270),
    [sym_this] = ACTIONS(2270),
    [anon_sym_discard] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_groupshared] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_row_major] = ACTIONS(2270),
    [anon_sym_column_major] = ACTIONS(2270),
    [anon_sym_globallycoherent] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym_nointerpolation] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_linear] = ACTIONS(2270),
    [anon_sym_snorm] = ACTIONS(2270),
    [anon_sym_unorm] = ACTIONS(2270),
    [anon_sym_point] = ACTIONS(2270),
    [anon_sym_line] = ACTIONS(2270),
    [anon_sym_triangleadj] = ACTIONS(2270),
    [anon_sym_lineadj] = ACTIONS(2270),
    [anon_sym_triangle] = ACTIONS(2270),
    [anon_sym_cbuffer] = ACTIONS(2270),
  },
  [555] = {
    [sym_identifier] = ACTIONS(2274),
    [aux_sym_preproc_include_token1] = ACTIONS(2274),
    [aux_sym_preproc_def_token1] = ACTIONS(2274),
    [aux_sym_preproc_if_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2274),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2274),
    [sym_preproc_directive] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_AMP_AMP] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_typedef] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_virtual] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2274),
    [anon_sym_using] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym___based] = ACTIONS(2274),
    [anon_sym___cdecl] = ACTIONS(2274),
    [anon_sym___clrcall] = ACTIONS(2274),
    [anon_sym___stdcall] = ACTIONS(2274),
    [anon_sym___fastcall] = ACTIONS(2274),
    [anon_sym___thiscall] = ACTIONS(2274),
    [anon_sym___vectorcall] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_RBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_class] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2274),
    [anon_sym_switch] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2274),
    [anon_sym_default] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_do] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_goto] = ACTIONS(2274),
    [anon_sym___try] = ACTIONS(2274),
    [anon_sym___leave] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2274),
    [anon_sym_compl] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2274),
    [anon_sym___alignof__] = ACTIONS(2274),
    [anon_sym___alignof] = ACTIONS(2274),
    [anon_sym__alignof] = ACTIONS(2274),
    [anon_sym_alignof] = ACTIONS(2274),
    [anon_sym__Alignof] = ACTIONS(2274),
    [anon_sym_offsetof] = ACTIONS(2274),
    [anon_sym__Generic] = ACTIONS(2274),
    [anon_sym_asm] = ACTIONS(2274),
    [anon_sym___asm__] = ACTIONS(2274),
    [anon_sym___asm] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_L_SQUOTE] = ACTIONS(2276),
    [anon_sym_u_SQUOTE] = ACTIONS(2276),
    [anon_sym_U_SQUOTE] = ACTIONS(2276),
    [anon_sym_u8_SQUOTE] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_L_DQUOTE] = ACTIONS(2276),
    [anon_sym_u_DQUOTE] = ACTIONS(2276),
    [anon_sym_U_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8_DQUOTE] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(2276),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [anon_sym_NULL] = ACTIONS(2274),
    [anon_sym_nullptr] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2274),
    [anon_sym_decltype] = ACTIONS(2274),
    [anon_sym_explicit] = ACTIONS(2274),
    [anon_sym_typename] = ACTIONS(2274),
    [anon_sym_template] = ACTIONS(2274),
    [anon_sym_operator] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [anon_sym_delete] = ACTIONS(2274),
    [anon_sym_throw] = ACTIONS(2274),
    [anon_sym_namespace] = ACTIONS(2274),
    [anon_sym_static_assert] = ACTIONS(2274),
    [anon_sym_concept] = ACTIONS(2274),
    [anon_sym_co_return] = ACTIONS(2274),
    [anon_sym_co_yield] = ACTIONS(2274),
    [anon_sym_R_DQUOTE] = ACTIONS(2276),
    [anon_sym_LR_DQUOTE] = ACTIONS(2276),
    [anon_sym_uR_DQUOTE] = ACTIONS(2276),
    [anon_sym_UR_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2276),
    [anon_sym_co_await] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2274),
    [sym_this] = ACTIONS(2274),
    [anon_sym_discard] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_groupshared] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_row_major] = ACTIONS(2274),
    [anon_sym_column_major] = ACTIONS(2274),
    [anon_sym_globallycoherent] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym_nointerpolation] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_linear] = ACTIONS(2274),
    [anon_sym_snorm] = ACTIONS(2274),
    [anon_sym_unorm] = ACTIONS(2274),
    [anon_sym_point] = ACTIONS(2274),
    [anon_sym_line] = ACTIONS(2274),
    [anon_sym_triangleadj] = ACTIONS(2274),
    [anon_sym_lineadj] = ACTIONS(2274),
    [anon_sym_triangle] = ACTIONS(2274),
    [anon_sym_cbuffer] = ACTIONS(2274),
  },
  [556] = {
    [sym_identifier] = ACTIONS(2284),
    [aux_sym_preproc_include_token1] = ACTIONS(2284),
    [aux_sym_preproc_def_token1] = ACTIONS(2284),
    [aux_sym_preproc_if_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2284),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2284),
    [sym_preproc_directive] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_explicit] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_static_assert] = ACTIONS(2284),
    [anon_sym_concept] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2171),
    [aux_sym_preproc_include_token1] = ACTIONS(2171),
    [aux_sym_preproc_def_token1] = ACTIONS(2171),
    [aux_sym_preproc_if_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2171),
    [sym_preproc_directive] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_AMP_AMP] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2171),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2171),
    [anon_sym_typedef] = ACTIONS(2171),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_out] = ACTIONS(2171),
    [anon_sym_inout] = ACTIONS(2171),
    [anon_sym_virtual] = ACTIONS(2171),
    [anon_sym_extern] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2171),
    [anon_sym___attribute] = ACTIONS(2171),
    [anon_sym_using] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2171),
    [anon_sym___based] = ACTIONS(2171),
    [anon_sym___cdecl] = ACTIONS(2171),
    [anon_sym___clrcall] = ACTIONS(2171),
    [anon_sym___stdcall] = ACTIONS(2171),
    [anon_sym___fastcall] = ACTIONS(2171),
    [anon_sym___thiscall] = ACTIONS(2171),
    [anon_sym___vectorcall] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_signed] = ACTIONS(2171),
    [anon_sym_unsigned] = ACTIONS(2171),
    [anon_sym_long] = ACTIONS(2171),
    [anon_sym_short] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_register] = ACTIONS(2171),
    [anon_sym_inline] = ACTIONS(2171),
    [anon_sym___inline] = ACTIONS(2171),
    [anon_sym___inline__] = ACTIONS(2171),
    [anon_sym___forceinline] = ACTIONS(2171),
    [anon_sym_thread_local] = ACTIONS(2171),
    [anon_sym___thread] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_constexpr] = ACTIONS(2171),
    [anon_sym_volatile] = ACTIONS(2171),
    [anon_sym_restrict] = ACTIONS(2171),
    [anon_sym___restrict__] = ACTIONS(2171),
    [anon_sym__Atomic] = ACTIONS(2171),
    [anon_sym__Noreturn] = ACTIONS(2171),
    [anon_sym_noreturn] = ACTIONS(2171),
    [anon_sym__Nonnull] = ACTIONS(2171),
    [anon_sym_mutable] = ACTIONS(2171),
    [anon_sym_constinit] = ACTIONS(2171),
    [anon_sym_consteval] = ACTIONS(2171),
    [anon_sym_alignas] = ACTIONS(2171),
    [anon_sym__Alignas] = ACTIONS(2171),
    [sym_primitive_type] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_struct] = ACTIONS(2171),
    [anon_sym_union] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_case] = ACTIONS(2171),
    [anon_sym_default] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_goto] = ACTIONS(2171),
    [anon_sym___try] = ACTIONS(2171),
    [anon_sym___leave] = ACTIONS(2171),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_compl] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2171),
    [anon_sym___alignof__] = ACTIONS(2171),
    [anon_sym___alignof] = ACTIONS(2171),
    [anon_sym__alignof] = ACTIONS(2171),
    [anon_sym_alignof] = ACTIONS(2171),
    [anon_sym__Alignof] = ACTIONS(2171),
    [anon_sym_offsetof] = ACTIONS(2171),
    [anon_sym__Generic] = ACTIONS(2171),
    [anon_sym_asm] = ACTIONS(2171),
    [anon_sym___asm__] = ACTIONS(2171),
    [anon_sym___asm] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2173),
    [anon_sym_u_SQUOTE] = ACTIONS(2173),
    [anon_sym_U_SQUOTE] = ACTIONS(2173),
    [anon_sym_u8_SQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_L_DQUOTE] = ACTIONS(2173),
    [anon_sym_u_DQUOTE] = ACTIONS(2173),
    [anon_sym_U_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8_DQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [anon_sym_NULL] = ACTIONS(2171),
    [anon_sym_nullptr] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2171),
    [anon_sym_decltype] = ACTIONS(2171),
    [anon_sym_explicit] = ACTIONS(2171),
    [anon_sym_typename] = ACTIONS(2171),
    [anon_sym_template] = ACTIONS(2171),
    [anon_sym_operator] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_namespace] = ACTIONS(2171),
    [anon_sym_static_assert] = ACTIONS(2171),
    [anon_sym_concept] = ACTIONS(2171),
    [anon_sym_co_return] = ACTIONS(2171),
    [anon_sym_co_yield] = ACTIONS(2171),
    [anon_sym_R_DQUOTE] = ACTIONS(2173),
    [anon_sym_LR_DQUOTE] = ACTIONS(2173),
    [anon_sym_uR_DQUOTE] = ACTIONS(2173),
    [anon_sym_UR_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2173),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_requires] = ACTIONS(2171),
    [sym_this] = ACTIONS(2171),
    [anon_sym_discard] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2171),
    [anon_sym_shared] = ACTIONS(2171),
    [anon_sym_groupshared] = ACTIONS(2171),
    [anon_sym_uniform] = ACTIONS(2171),
    [anon_sym_row_major] = ACTIONS(2171),
    [anon_sym_column_major] = ACTIONS(2171),
    [anon_sym_globallycoherent] = ACTIONS(2171),
    [anon_sym_centroid] = ACTIONS(2171),
    [anon_sym_noperspective] = ACTIONS(2171),
    [anon_sym_nointerpolation] = ACTIONS(2171),
    [anon_sym_sample] = ACTIONS(2171),
    [anon_sym_linear] = ACTIONS(2171),
    [anon_sym_snorm] = ACTIONS(2171),
    [anon_sym_unorm] = ACTIONS(2171),
    [anon_sym_point] = ACTIONS(2171),
    [anon_sym_line] = ACTIONS(2171),
    [anon_sym_triangleadj] = ACTIONS(2171),
    [anon_sym_lineadj] = ACTIONS(2171),
    [anon_sym_triangle] = ACTIONS(2171),
    [anon_sym_cbuffer] = ACTIONS(2171),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2155),
    [aux_sym_preproc_include_token1] = ACTIONS(2155),
    [aux_sym_preproc_def_token1] = ACTIONS(2155),
    [aux_sym_preproc_if_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2155),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2155),
    [sym_preproc_directive] = ACTIONS(2155),
    [anon_sym_LPAREN2] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AMP_AMP] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym___extension__] = ACTIONS(2155),
    [anon_sym_typedef] = ACTIONS(2155),
    [anon_sym_in] = ACTIONS(2155),
    [anon_sym_out] = ACTIONS(2155),
    [anon_sym_inout] = ACTIONS(2155),
    [anon_sym_virtual] = ACTIONS(2155),
    [anon_sym_extern] = ACTIONS(2155),
    [anon_sym___attribute__] = ACTIONS(2155),
    [anon_sym___attribute] = ACTIONS(2155),
    [anon_sym_using] = ACTIONS(2155),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2157),
    [anon_sym___declspec] = ACTIONS(2155),
    [anon_sym___based] = ACTIONS(2155),
    [anon_sym___cdecl] = ACTIONS(2155),
    [anon_sym___clrcall] = ACTIONS(2155),
    [anon_sym___stdcall] = ACTIONS(2155),
    [anon_sym___fastcall] = ACTIONS(2155),
    [anon_sym___thiscall] = ACTIONS(2155),
    [anon_sym___vectorcall] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_RBRACE] = ACTIONS(2157),
    [anon_sym_signed] = ACTIONS(2155),
    [anon_sym_unsigned] = ACTIONS(2155),
    [anon_sym_long] = ACTIONS(2155),
    [anon_sym_short] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_register] = ACTIONS(2155),
    [anon_sym_inline] = ACTIONS(2155),
    [anon_sym___inline] = ACTIONS(2155),
    [anon_sym___inline__] = ACTIONS(2155),
    [anon_sym___forceinline] = ACTIONS(2155),
    [anon_sym_thread_local] = ACTIONS(2155),
    [anon_sym___thread] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_constexpr] = ACTIONS(2155),
    [anon_sym_volatile] = ACTIONS(2155),
    [anon_sym_restrict] = ACTIONS(2155),
    [anon_sym___restrict__] = ACTIONS(2155),
    [anon_sym__Atomic] = ACTIONS(2155),
    [anon_sym__Noreturn] = ACTIONS(2155),
    [anon_sym_noreturn] = ACTIONS(2155),
    [anon_sym__Nonnull] = ACTIONS(2155),
    [anon_sym_mutable] = ACTIONS(2155),
    [anon_sym_constinit] = ACTIONS(2155),
    [anon_sym_consteval] = ACTIONS(2155),
    [anon_sym_alignas] = ACTIONS(2155),
    [anon_sym__Alignas] = ACTIONS(2155),
    [sym_primitive_type] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_struct] = ACTIONS(2155),
    [anon_sym_union] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2155),
    [anon_sym_default] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_goto] = ACTIONS(2155),
    [anon_sym___try] = ACTIONS(2155),
    [anon_sym___leave] = ACTIONS(2155),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_compl] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_sizeof] = ACTIONS(2155),
    [anon_sym___alignof__] = ACTIONS(2155),
    [anon_sym___alignof] = ACTIONS(2155),
    [anon_sym__alignof] = ACTIONS(2155),
    [anon_sym_alignof] = ACTIONS(2155),
    [anon_sym__Alignof] = ACTIONS(2155),
    [anon_sym_offsetof] = ACTIONS(2155),
    [anon_sym__Generic] = ACTIONS(2155),
    [anon_sym_asm] = ACTIONS(2155),
    [anon_sym___asm__] = ACTIONS(2155),
    [anon_sym___asm] = ACTIONS(2155),
    [sym_number_literal] = ACTIONS(2157),
    [anon_sym_L_SQUOTE] = ACTIONS(2157),
    [anon_sym_u_SQUOTE] = ACTIONS(2157),
    [anon_sym_U_SQUOTE] = ACTIONS(2157),
    [anon_sym_u8_SQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [anon_sym_L_DQUOTE] = ACTIONS(2157),
    [anon_sym_u_DQUOTE] = ACTIONS(2157),
    [anon_sym_U_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8_DQUOTE] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [anon_sym_NULL] = ACTIONS(2155),
    [anon_sym_nullptr] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2155),
    [anon_sym_decltype] = ACTIONS(2155),
    [anon_sym_explicit] = ACTIONS(2155),
    [anon_sym_typename] = ACTIONS(2155),
    [anon_sym_template] = ACTIONS(2155),
    [anon_sym_operator] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_namespace] = ACTIONS(2155),
    [anon_sym_static_assert] = ACTIONS(2155),
    [anon_sym_concept] = ACTIONS(2155),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2155),
    [anon_sym_R_DQUOTE] = ACTIONS(2157),
    [anon_sym_LR_DQUOTE] = ACTIONS(2157),
    [anon_sym_uR_DQUOTE] = ACTIONS(2157),
    [anon_sym_UR_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2157),
    [anon_sym_co_await] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_requires] = ACTIONS(2155),
    [sym_this] = ACTIONS(2155),
    [anon_sym_discard] = ACTIONS(2155),
    [anon_sym_precise] = ACTIONS(2155),
    [anon_sym_shared] = ACTIONS(2155),
    [anon_sym_groupshared] = ACTIONS(2155),
    [anon_sym_uniform] = ACTIONS(2155),
    [anon_sym_row_major] = ACTIONS(2155),
    [anon_sym_column_major] = ACTIONS(2155),
    [anon_sym_globallycoherent] = ACTIONS(2155),
    [anon_sym_centroid] = ACTIONS(2155),
    [anon_sym_noperspective] = ACTIONS(2155),
    [anon_sym_nointerpolation] = ACTIONS(2155),
    [anon_sym_sample] = ACTIONS(2155),
    [anon_sym_linear] = ACTIONS(2155),
    [anon_sym_snorm] = ACTIONS(2155),
    [anon_sym_unorm] = ACTIONS(2155),
    [anon_sym_point] = ACTIONS(2155),
    [anon_sym_line] = ACTIONS(2155),
    [anon_sym_triangleadj] = ACTIONS(2155),
    [anon_sym_lineadj] = ACTIONS(2155),
    [anon_sym_triangle] = ACTIONS(2155),
    [anon_sym_cbuffer] = ACTIONS(2155),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2214),
    [aux_sym_preproc_include_token1] = ACTIONS(2214),
    [aux_sym_preproc_def_token1] = ACTIONS(2214),
    [aux_sym_preproc_if_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2214),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2214),
    [sym_preproc_directive] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_AMP_AMP] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_virtual] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym___attribute] = ACTIONS(2214),
    [anon_sym_using] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym___based] = ACTIONS(2214),
    [anon_sym___cdecl] = ACTIONS(2214),
    [anon_sym___clrcall] = ACTIONS(2214),
    [anon_sym___stdcall] = ACTIONS(2214),
    [anon_sym___fastcall] = ACTIONS(2214),
    [anon_sym___thiscall] = ACTIONS(2214),
    [anon_sym___vectorcall] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym__Nonnull] = ACTIONS(2214),
    [anon_sym_mutable] = ACTIONS(2214),
    [anon_sym_constinit] = ACTIONS(2214),
    [anon_sym_consteval] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_case] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_goto] = ACTIONS(2214),
    [anon_sym___try] = ACTIONS(2214),
    [anon_sym___leave] = ACTIONS(2214),
    [anon_sym_not] = ACTIONS(2214),
    [anon_sym_compl] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2214),
    [anon_sym___alignof__] = ACTIONS(2214),
    [anon_sym___alignof] = ACTIONS(2214),
    [anon_sym__alignof] = ACTIONS(2214),
    [anon_sym_alignof] = ACTIONS(2214),
    [anon_sym__Alignof] = ACTIONS(2214),
    [anon_sym_offsetof] = ACTIONS(2214),
    [anon_sym__Generic] = ACTIONS(2214),
    [anon_sym_asm] = ACTIONS(2214),
    [anon_sym___asm__] = ACTIONS(2214),
    [anon_sym___asm] = ACTIONS(2214),
    [sym_number_literal] = ACTIONS(2216),
    [anon_sym_L_SQUOTE] = ACTIONS(2216),
    [anon_sym_u_SQUOTE] = ACTIONS(2216),
    [anon_sym_U_SQUOTE] = ACTIONS(2216),
    [anon_sym_u8_SQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_L_DQUOTE] = ACTIONS(2216),
    [anon_sym_u_DQUOTE] = ACTIONS(2216),
    [anon_sym_U_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8_DQUOTE] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [anon_sym_NULL] = ACTIONS(2214),
    [anon_sym_nullptr] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2214),
    [anon_sym_decltype] = ACTIONS(2214),
    [anon_sym_explicit] = ACTIONS(2214),
    [anon_sym_typename] = ACTIONS(2214),
    [anon_sym_template] = ACTIONS(2214),
    [anon_sym_operator] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_namespace] = ACTIONS(2214),
    [anon_sym_static_assert] = ACTIONS(2214),
    [anon_sym_concept] = ACTIONS(2214),
    [anon_sym_co_return] = ACTIONS(2214),
    [anon_sym_co_yield] = ACTIONS(2214),
    [anon_sym_R_DQUOTE] = ACTIONS(2216),
    [anon_sym_LR_DQUOTE] = ACTIONS(2216),
    [anon_sym_uR_DQUOTE] = ACTIONS(2216),
    [anon_sym_UR_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2216),
    [anon_sym_co_await] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_requires] = ACTIONS(2214),
    [sym_this] = ACTIONS(2214),
    [anon_sym_discard] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_groupshared] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_row_major] = ACTIONS(2214),
    [anon_sym_column_major] = ACTIONS(2214),
    [anon_sym_globallycoherent] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym_nointerpolation] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_linear] = ACTIONS(2214),
    [anon_sym_snorm] = ACTIONS(2214),
    [anon_sym_unorm] = ACTIONS(2214),
    [anon_sym_point] = ACTIONS(2214),
    [anon_sym_line] = ACTIONS(2214),
    [anon_sym_triangleadj] = ACTIONS(2214),
    [anon_sym_lineadj] = ACTIONS(2214),
    [anon_sym_triangle] = ACTIONS(2214),
    [anon_sym_cbuffer] = ACTIONS(2214),
  },
  [560] = {
    [sym_identifier] = ACTIONS(2218),
    [aux_sym_preproc_include_token1] = ACTIONS(2218),
    [aux_sym_preproc_def_token1] = ACTIONS(2218),
    [aux_sym_preproc_if_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2218),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2218),
    [sym_preproc_directive] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AMP_AMP] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_typedef] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_virtual] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym___attribute] = ACTIONS(2218),
    [anon_sym_using] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym___based] = ACTIONS(2218),
    [anon_sym___cdecl] = ACTIONS(2218),
    [anon_sym___clrcall] = ACTIONS(2218),
    [anon_sym___stdcall] = ACTIONS(2218),
    [anon_sym___fastcall] = ACTIONS(2218),
    [anon_sym___thiscall] = ACTIONS(2218),
    [anon_sym___vectorcall] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_RBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym__Nonnull] = ACTIONS(2218),
    [anon_sym_mutable] = ACTIONS(2218),
    [anon_sym_constinit] = ACTIONS(2218),
    [anon_sym_consteval] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_case] = ACTIONS(2218),
    [anon_sym_default] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_goto] = ACTIONS(2218),
    [anon_sym___try] = ACTIONS(2218),
    [anon_sym___leave] = ACTIONS(2218),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_compl] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2218),
    [anon_sym___alignof__] = ACTIONS(2218),
    [anon_sym___alignof] = ACTIONS(2218),
    [anon_sym__alignof] = ACTIONS(2218),
    [anon_sym_alignof] = ACTIONS(2218),
    [anon_sym__Alignof] = ACTIONS(2218),
    [anon_sym_offsetof] = ACTIONS(2218),
    [anon_sym__Generic] = ACTIONS(2218),
    [anon_sym_asm] = ACTIONS(2218),
    [anon_sym___asm__] = ACTIONS(2218),
    [anon_sym___asm] = ACTIONS(2218),
    [sym_number_literal] = ACTIONS(2220),
    [anon_sym_L_SQUOTE] = ACTIONS(2220),
    [anon_sym_u_SQUOTE] = ACTIONS(2220),
    [anon_sym_U_SQUOTE] = ACTIONS(2220),
    [anon_sym_u8_SQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_L_DQUOTE] = ACTIONS(2220),
    [anon_sym_u_DQUOTE] = ACTIONS(2220),
    [anon_sym_U_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8_DQUOTE] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [anon_sym_NULL] = ACTIONS(2218),
    [anon_sym_nullptr] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2218),
    [anon_sym_decltype] = ACTIONS(2218),
    [anon_sym_explicit] = ACTIONS(2218),
    [anon_sym_typename] = ACTIONS(2218),
    [anon_sym_template] = ACTIONS(2218),
    [anon_sym_operator] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_namespace] = ACTIONS(2218),
    [anon_sym_static_assert] = ACTIONS(2218),
    [anon_sym_concept] = ACTIONS(2218),
    [anon_sym_co_return] = ACTIONS(2218),
    [anon_sym_co_yield] = ACTIONS(2218),
    [anon_sym_R_DQUOTE] = ACTIONS(2220),
    [anon_sym_LR_DQUOTE] = ACTIONS(2220),
    [anon_sym_uR_DQUOTE] = ACTIONS(2220),
    [anon_sym_UR_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2220),
    [anon_sym_co_await] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_requires] = ACTIONS(2218),
    [sym_this] = ACTIONS(2218),
    [anon_sym_discard] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_groupshared] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_row_major] = ACTIONS(2218),
    [anon_sym_column_major] = ACTIONS(2218),
    [anon_sym_globallycoherent] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym_nointerpolation] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_linear] = ACTIONS(2218),
    [anon_sym_snorm] = ACTIONS(2218),
    [anon_sym_unorm] = ACTIONS(2218),
    [anon_sym_point] = ACTIONS(2218),
    [anon_sym_line] = ACTIONS(2218),
    [anon_sym_triangleadj] = ACTIONS(2218),
    [anon_sym_lineadj] = ACTIONS(2218),
    [anon_sym_triangle] = ACTIONS(2218),
    [anon_sym_cbuffer] = ACTIONS(2218),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_include_token1] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2468),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym___cdecl] = ACTIONS(2466),
    [anon_sym___clrcall] = ACTIONS(2466),
    [anon_sym___stdcall] = ACTIONS(2466),
    [anon_sym___fastcall] = ACTIONS(2466),
    [anon_sym___thiscall] = ACTIONS(2466),
    [anon_sym___vectorcall] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym_not] = ACTIONS(2466),
    [anon_sym_compl] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym___alignof__] = ACTIONS(2466),
    [anon_sym___alignof] = ACTIONS(2466),
    [anon_sym__alignof] = ACTIONS(2466),
    [anon_sym_alignof] = ACTIONS(2466),
    [anon_sym__Alignof] = ACTIONS(2466),
    [anon_sym_offsetof] = ACTIONS(2466),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2466),
    [anon_sym___asm__] = ACTIONS(2466),
    [anon_sym___asm] = ACTIONS(2466),
    [sym_number_literal] = ACTIONS(2468),
    [anon_sym_L_SQUOTE] = ACTIONS(2468),
    [anon_sym_u_SQUOTE] = ACTIONS(2468),
    [anon_sym_U_SQUOTE] = ACTIONS(2468),
    [anon_sym_u8_SQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_L_DQUOTE] = ACTIONS(2468),
    [anon_sym_u_DQUOTE] = ACTIONS(2468),
    [anon_sym_U_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [anon_sym_NULL] = ACTIONS(2466),
    [anon_sym_nullptr] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_concept] = ACTIONS(2466),
    [anon_sym_co_return] = ACTIONS(2466),
    [anon_sym_co_yield] = ACTIONS(2466),
    [anon_sym_R_DQUOTE] = ACTIONS(2468),
    [anon_sym_LR_DQUOTE] = ACTIONS(2468),
    [anon_sym_uR_DQUOTE] = ACTIONS(2468),
    [anon_sym_UR_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2468),
    [anon_sym_co_await] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_requires] = ACTIONS(2466),
    [sym_this] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
  },
  [562] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_include_token1] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_case] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_namespace] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2288),
    [aux_sym_preproc_include_token1] = ACTIONS(2288),
    [aux_sym_preproc_def_token1] = ACTIONS(2288),
    [aux_sym_preproc_if_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2288),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2288),
    [sym_preproc_directive] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_explicit] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_static_assert] = ACTIONS(2288),
    [anon_sym_concept] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
  },
  [564] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2296),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2250),
    [aux_sym_preproc_include_token1] = ACTIONS(2250),
    [aux_sym_preproc_def_token1] = ACTIONS(2250),
    [aux_sym_preproc_if_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2250),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2250),
    [sym_preproc_directive] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AMP_AMP] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_typedef] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_virtual] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym___attribute] = ACTIONS(2250),
    [anon_sym_using] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym___based] = ACTIONS(2250),
    [anon_sym___cdecl] = ACTIONS(2250),
    [anon_sym___clrcall] = ACTIONS(2250),
    [anon_sym___stdcall] = ACTIONS(2250),
    [anon_sym___fastcall] = ACTIONS(2250),
    [anon_sym___thiscall] = ACTIONS(2250),
    [anon_sym___vectorcall] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_case] = ACTIONS(2250),
    [anon_sym_default] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_goto] = ACTIONS(2250),
    [anon_sym___try] = ACTIONS(2250),
    [anon_sym___leave] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2250),
    [anon_sym_compl] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2250),
    [anon_sym___alignof__] = ACTIONS(2250),
    [anon_sym___alignof] = ACTIONS(2250),
    [anon_sym__alignof] = ACTIONS(2250),
    [anon_sym_alignof] = ACTIONS(2250),
    [anon_sym__Alignof] = ACTIONS(2250),
    [anon_sym_offsetof] = ACTIONS(2250),
    [anon_sym__Generic] = ACTIONS(2250),
    [anon_sym_asm] = ACTIONS(2250),
    [anon_sym___asm__] = ACTIONS(2250),
    [anon_sym___asm] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2252),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2252),
    [anon_sym_u_DQUOTE] = ACTIONS(2252),
    [anon_sym_U_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [anon_sym_NULL] = ACTIONS(2250),
    [anon_sym_nullptr] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2250),
    [anon_sym_decltype] = ACTIONS(2250),
    [anon_sym_explicit] = ACTIONS(2250),
    [anon_sym_typename] = ACTIONS(2250),
    [anon_sym_template] = ACTIONS(2250),
    [anon_sym_operator] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_namespace] = ACTIONS(2250),
    [anon_sym_static_assert] = ACTIONS(2250),
    [anon_sym_concept] = ACTIONS(2250),
    [anon_sym_co_return] = ACTIONS(2250),
    [anon_sym_co_yield] = ACTIONS(2250),
    [anon_sym_R_DQUOTE] = ACTIONS(2252),
    [anon_sym_LR_DQUOTE] = ACTIONS(2252),
    [anon_sym_uR_DQUOTE] = ACTIONS(2252),
    [anon_sym_UR_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2252),
    [anon_sym_co_await] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [anon_sym_discard] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_groupshared] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_row_major] = ACTIONS(2250),
    [anon_sym_column_major] = ACTIONS(2250),
    [anon_sym_globallycoherent] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym_nointerpolation] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_linear] = ACTIONS(2250),
    [anon_sym_snorm] = ACTIONS(2250),
    [anon_sym_unorm] = ACTIONS(2250),
    [anon_sym_point] = ACTIONS(2250),
    [anon_sym_line] = ACTIONS(2250),
    [anon_sym_triangleadj] = ACTIONS(2250),
    [anon_sym_lineadj] = ACTIONS(2250),
    [anon_sym_triangle] = ACTIONS(2250),
    [anon_sym_cbuffer] = ACTIONS(2250),
  },
  [566] = {
    [sym_identifier] = ACTIONS(2254),
    [aux_sym_preproc_include_token1] = ACTIONS(2254),
    [aux_sym_preproc_def_token1] = ACTIONS(2254),
    [aux_sym_preproc_if_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2254),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2254),
    [sym_preproc_directive] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_AMP_AMP] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_typedef] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_virtual] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym___attribute] = ACTIONS(2254),
    [anon_sym_using] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym___based] = ACTIONS(2254),
    [anon_sym___cdecl] = ACTIONS(2254),
    [anon_sym___clrcall] = ACTIONS(2254),
    [anon_sym___stdcall] = ACTIONS(2254),
    [anon_sym___fastcall] = ACTIONS(2254),
    [anon_sym___thiscall] = ACTIONS(2254),
    [anon_sym___vectorcall] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym__Nonnull] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_class] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2254),
    [anon_sym_case] = ACTIONS(2254),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_do] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2254),
    [anon_sym___try] = ACTIONS(2254),
    [anon_sym___leave] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_compl] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2254),
    [anon_sym___alignof__] = ACTIONS(2254),
    [anon_sym___alignof] = ACTIONS(2254),
    [anon_sym__alignof] = ACTIONS(2254),
    [anon_sym_alignof] = ACTIONS(2254),
    [anon_sym__Alignof] = ACTIONS(2254),
    [anon_sym_offsetof] = ACTIONS(2254),
    [anon_sym__Generic] = ACTIONS(2254),
    [anon_sym_asm] = ACTIONS(2254),
    [anon_sym___asm__] = ACTIONS(2254),
    [anon_sym___asm] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_L_SQUOTE] = ACTIONS(2256),
    [anon_sym_u_SQUOTE] = ACTIONS(2256),
    [anon_sym_U_SQUOTE] = ACTIONS(2256),
    [anon_sym_u8_SQUOTE] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_L_DQUOTE] = ACTIONS(2256),
    [anon_sym_u_DQUOTE] = ACTIONS(2256),
    [anon_sym_U_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8_DQUOTE] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2256),
    [sym_true] = ACTIONS(2254),
    [sym_false] = ACTIONS(2254),
    [anon_sym_NULL] = ACTIONS(2254),
    [anon_sym_nullptr] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2254),
    [anon_sym_decltype] = ACTIONS(2254),
    [anon_sym_explicit] = ACTIONS(2254),
    [anon_sym_typename] = ACTIONS(2254),
    [anon_sym_template] = ACTIONS(2254),
    [anon_sym_operator] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [anon_sym_delete] = ACTIONS(2254),
    [anon_sym_throw] = ACTIONS(2254),
    [anon_sym_namespace] = ACTIONS(2254),
    [anon_sym_static_assert] = ACTIONS(2254),
    [anon_sym_concept] = ACTIONS(2254),
    [anon_sym_co_return] = ACTIONS(2254),
    [anon_sym_co_yield] = ACTIONS(2254),
    [anon_sym_R_DQUOTE] = ACTIONS(2256),
    [anon_sym_LR_DQUOTE] = ACTIONS(2256),
    [anon_sym_uR_DQUOTE] = ACTIONS(2256),
    [anon_sym_UR_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2256),
    [anon_sym_co_await] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2254),
    [sym_this] = ACTIONS(2254),
    [anon_sym_discard] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_groupshared] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_row_major] = ACTIONS(2254),
    [anon_sym_column_major] = ACTIONS(2254),
    [anon_sym_globallycoherent] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym_nointerpolation] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_linear] = ACTIONS(2254),
    [anon_sym_snorm] = ACTIONS(2254),
    [anon_sym_unorm] = ACTIONS(2254),
    [anon_sym_point] = ACTIONS(2254),
    [anon_sym_line] = ACTIONS(2254),
    [anon_sym_triangleadj] = ACTIONS(2254),
    [anon_sym_lineadj] = ACTIONS(2254),
    [anon_sym_triangle] = ACTIONS(2254),
    [anon_sym_cbuffer] = ACTIONS(2254),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2258),
    [aux_sym_preproc_include_token1] = ACTIONS(2258),
    [aux_sym_preproc_def_token1] = ACTIONS(2258),
    [aux_sym_preproc_if_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2258),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2258),
    [sym_preproc_directive] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_AMP_AMP] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym_typedef] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2258),
    [anon_sym_out] = ACTIONS(2258),
    [anon_sym_inout] = ACTIONS(2258),
    [anon_sym_virtual] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym___attribute] = ACTIONS(2258),
    [anon_sym_using] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2260),
    [anon_sym___declspec] = ACTIONS(2258),
    [anon_sym___based] = ACTIONS(2258),
    [anon_sym___cdecl] = ACTIONS(2258),
    [anon_sym___clrcall] = ACTIONS(2258),
    [anon_sym___stdcall] = ACTIONS(2258),
    [anon_sym___fastcall] = ACTIONS(2258),
    [anon_sym___thiscall] = ACTIONS(2258),
    [anon_sym___vectorcall] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2258),
    [anon_sym_unsigned] = ACTIONS(2258),
    [anon_sym_long] = ACTIONS(2258),
    [anon_sym_short] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2258),
    [anon_sym_inline] = ACTIONS(2258),
    [anon_sym___inline] = ACTIONS(2258),
    [anon_sym___inline__] = ACTIONS(2258),
    [anon_sym___forceinline] = ACTIONS(2258),
    [anon_sym_thread_local] = ACTIONS(2258),
    [anon_sym___thread] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym__Nonnull] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [sym_primitive_type] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_class] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2258),
    [anon_sym_switch] = ACTIONS(2258),
    [anon_sym_case] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_do] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_goto] = ACTIONS(2258),
    [anon_sym___try] = ACTIONS(2258),
    [anon_sym___leave] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2258),
    [anon_sym_compl] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2258),
    [anon_sym___alignof__] = ACTIONS(2258),
    [anon_sym___alignof] = ACTIONS(2258),
    [anon_sym__alignof] = ACTIONS(2258),
    [anon_sym_alignof] = ACTIONS(2258),
    [anon_sym__Alignof] = ACTIONS(2258),
    [anon_sym_offsetof] = ACTIONS(2258),
    [anon_sym__Generic] = ACTIONS(2258),
    [anon_sym_asm] = ACTIONS(2258),
    [anon_sym___asm__] = ACTIONS(2258),
    [anon_sym___asm] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2260),
    [anon_sym_L_SQUOTE] = ACTIONS(2260),
    [anon_sym_u_SQUOTE] = ACTIONS(2260),
    [anon_sym_U_SQUOTE] = ACTIONS(2260),
    [anon_sym_u8_SQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_L_DQUOTE] = ACTIONS(2260),
    [anon_sym_u_DQUOTE] = ACTIONS(2260),
    [anon_sym_U_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8_DQUOTE] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2258),
    [anon_sym_decltype] = ACTIONS(2258),
    [anon_sym_explicit] = ACTIONS(2258),
    [anon_sym_typename] = ACTIONS(2258),
    [anon_sym_template] = ACTIONS(2258),
    [anon_sym_operator] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [anon_sym_delete] = ACTIONS(2258),
    [anon_sym_throw] = ACTIONS(2258),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_static_assert] = ACTIONS(2258),
    [anon_sym_concept] = ACTIONS(2258),
    [anon_sym_co_return] = ACTIONS(2258),
    [anon_sym_co_yield] = ACTIONS(2258),
    [anon_sym_R_DQUOTE] = ACTIONS(2260),
    [anon_sym_LR_DQUOTE] = ACTIONS(2260),
    [anon_sym_uR_DQUOTE] = ACTIONS(2260),
    [anon_sym_UR_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2260),
    [anon_sym_co_await] = ACTIONS(2258),
    [anon_sym_new] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2258),
    [sym_this] = ACTIONS(2258),
    [anon_sym_discard] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2258),
    [anon_sym_shared] = ACTIONS(2258),
    [anon_sym_groupshared] = ACTIONS(2258),
    [anon_sym_uniform] = ACTIONS(2258),
    [anon_sym_row_major] = ACTIONS(2258),
    [anon_sym_column_major] = ACTIONS(2258),
    [anon_sym_globallycoherent] = ACTIONS(2258),
    [anon_sym_centroid] = ACTIONS(2258),
    [anon_sym_noperspective] = ACTIONS(2258),
    [anon_sym_nointerpolation] = ACTIONS(2258),
    [anon_sym_sample] = ACTIONS(2258),
    [anon_sym_linear] = ACTIONS(2258),
    [anon_sym_snorm] = ACTIONS(2258),
    [anon_sym_unorm] = ACTIONS(2258),
    [anon_sym_point] = ACTIONS(2258),
    [anon_sym_line] = ACTIONS(2258),
    [anon_sym_triangleadj] = ACTIONS(2258),
    [anon_sym_lineadj] = ACTIONS(2258),
    [anon_sym_triangle] = ACTIONS(2258),
    [anon_sym_cbuffer] = ACTIONS(2258),
  },
  [568] = {
    [sym_identifier] = ACTIONS(2262),
    [aux_sym_preproc_include_token1] = ACTIONS(2262),
    [aux_sym_preproc_def_token1] = ACTIONS(2262),
    [aux_sym_preproc_if_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2262),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2262),
    [sym_preproc_directive] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym_typedef] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2262),
    [anon_sym_out] = ACTIONS(2262),
    [anon_sym_inout] = ACTIONS(2262),
    [anon_sym_virtual] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2262),
    [anon_sym_using] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2264),
    [anon_sym___declspec] = ACTIONS(2262),
    [anon_sym___based] = ACTIONS(2262),
    [anon_sym___cdecl] = ACTIONS(2262),
    [anon_sym___clrcall] = ACTIONS(2262),
    [anon_sym___stdcall] = ACTIONS(2262),
    [anon_sym___fastcall] = ACTIONS(2262),
    [anon_sym___thiscall] = ACTIONS(2262),
    [anon_sym___vectorcall] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2262),
    [anon_sym_unsigned] = ACTIONS(2262),
    [anon_sym_long] = ACTIONS(2262),
    [anon_sym_short] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2262),
    [anon_sym_inline] = ACTIONS(2262),
    [anon_sym___inline] = ACTIONS(2262),
    [anon_sym___inline__] = ACTIONS(2262),
    [anon_sym___forceinline] = ACTIONS(2262),
    [anon_sym_thread_local] = ACTIONS(2262),
    [anon_sym___thread] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [sym_primitive_type] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_class] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2262),
    [anon_sym_case] = ACTIONS(2262),
    [anon_sym_default] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_goto] = ACTIONS(2262),
    [anon_sym___try] = ACTIONS(2262),
    [anon_sym___leave] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2262),
    [anon_sym_compl] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2262),
    [anon_sym___alignof__] = ACTIONS(2262),
    [anon_sym___alignof] = ACTIONS(2262),
    [anon_sym__alignof] = ACTIONS(2262),
    [anon_sym_alignof] = ACTIONS(2262),
    [anon_sym__Alignof] = ACTIONS(2262),
    [anon_sym_offsetof] = ACTIONS(2262),
    [anon_sym__Generic] = ACTIONS(2262),
    [anon_sym_asm] = ACTIONS(2262),
    [anon_sym___asm__] = ACTIONS(2262),
    [anon_sym___asm] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2264),
    [anon_sym_L_SQUOTE] = ACTIONS(2264),
    [anon_sym_u_SQUOTE] = ACTIONS(2264),
    [anon_sym_U_SQUOTE] = ACTIONS(2264),
    [anon_sym_u8_SQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_L_DQUOTE] = ACTIONS(2264),
    [anon_sym_u_DQUOTE] = ACTIONS(2264),
    [anon_sym_U_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8_DQUOTE] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [anon_sym_NULL] = ACTIONS(2262),
    [anon_sym_nullptr] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2262),
    [anon_sym_decltype] = ACTIONS(2262),
    [anon_sym_explicit] = ACTIONS(2262),
    [anon_sym_typename] = ACTIONS(2262),
    [anon_sym_template] = ACTIONS(2262),
    [anon_sym_operator] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [anon_sym_delete] = ACTIONS(2262),
    [anon_sym_throw] = ACTIONS(2262),
    [anon_sym_namespace] = ACTIONS(2262),
    [anon_sym_static_assert] = ACTIONS(2262),
    [anon_sym_concept] = ACTIONS(2262),
    [anon_sym_co_return] = ACTIONS(2262),
    [anon_sym_co_yield] = ACTIONS(2262),
    [anon_sym_R_DQUOTE] = ACTIONS(2264),
    [anon_sym_LR_DQUOTE] = ACTIONS(2264),
    [anon_sym_uR_DQUOTE] = ACTIONS(2264),
    [anon_sym_UR_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2264),
    [anon_sym_co_await] = ACTIONS(2262),
    [anon_sym_new] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2262),
    [sym_this] = ACTIONS(2262),
    [anon_sym_discard] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2262),
    [anon_sym_shared] = ACTIONS(2262),
    [anon_sym_groupshared] = ACTIONS(2262),
    [anon_sym_uniform] = ACTIONS(2262),
    [anon_sym_row_major] = ACTIONS(2262),
    [anon_sym_column_major] = ACTIONS(2262),
    [anon_sym_globallycoherent] = ACTIONS(2262),
    [anon_sym_centroid] = ACTIONS(2262),
    [anon_sym_noperspective] = ACTIONS(2262),
    [anon_sym_nointerpolation] = ACTIONS(2262),
    [anon_sym_sample] = ACTIONS(2262),
    [anon_sym_linear] = ACTIONS(2262),
    [anon_sym_snorm] = ACTIONS(2262),
    [anon_sym_unorm] = ACTIONS(2262),
    [anon_sym_point] = ACTIONS(2262),
    [anon_sym_line] = ACTIONS(2262),
    [anon_sym_triangleadj] = ACTIONS(2262),
    [anon_sym_lineadj] = ACTIONS(2262),
    [anon_sym_triangle] = ACTIONS(2262),
    [anon_sym_cbuffer] = ACTIONS(2262),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(2542),
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_include_token1] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(2542),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym___cdecl] = ACTIONS(2540),
    [anon_sym___clrcall] = ACTIONS(2540),
    [anon_sym___stdcall] = ACTIONS(2540),
    [anon_sym___fastcall] = ACTIONS(2540),
    [anon_sym___thiscall] = ACTIONS(2540),
    [anon_sym___vectorcall] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_goto] = ACTIONS(2540),
    [anon_sym_not] = ACTIONS(2540),
    [anon_sym_compl] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2540),
    [anon_sym___alignof__] = ACTIONS(2540),
    [anon_sym___alignof] = ACTIONS(2540),
    [anon_sym__alignof] = ACTIONS(2540),
    [anon_sym_alignof] = ACTIONS(2540),
    [anon_sym__Alignof] = ACTIONS(2540),
    [anon_sym_offsetof] = ACTIONS(2540),
    [anon_sym__Generic] = ACTIONS(2540),
    [anon_sym_asm] = ACTIONS(2540),
    [anon_sym___asm__] = ACTIONS(2540),
    [anon_sym___asm] = ACTIONS(2540),
    [sym_number_literal] = ACTIONS(2542),
    [anon_sym_L_SQUOTE] = ACTIONS(2542),
    [anon_sym_u_SQUOTE] = ACTIONS(2542),
    [anon_sym_U_SQUOTE] = ACTIONS(2542),
    [anon_sym_u8_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_L_DQUOTE] = ACTIONS(2542),
    [anon_sym_u_DQUOTE] = ACTIONS(2542),
    [anon_sym_U_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8_DQUOTE] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2542),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(2540),
    [anon_sym_module] = ACTIONS(2540),
    [anon_sym_import] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_concept] = ACTIONS(2540),
    [anon_sym_co_return] = ACTIONS(2540),
    [anon_sym_co_yield] = ACTIONS(2540),
    [anon_sym_R_DQUOTE] = ACTIONS(2542),
    [anon_sym_LR_DQUOTE] = ACTIONS(2542),
    [anon_sym_uR_DQUOTE] = ACTIONS(2542),
    [anon_sym_UR_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2542),
    [anon_sym_co_await] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_requires] = ACTIONS(2540),
    [sym_this] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
  },
  [570] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2872),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [571] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [572] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_typedef] = ACTIONS(2292),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [573] = {
    [sym_identifier] = ACTIONS(2588),
    [aux_sym_preproc_include_token1] = ACTIONS(2588),
    [aux_sym_preproc_def_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token2] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2588),
    [sym_preproc_directive] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym___extension__] = ACTIONS(2588),
    [anon_sym_typedef] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_out] = ACTIONS(2588),
    [anon_sym_inout] = ACTIONS(2588),
    [anon_sym_virtual] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym___attribute__] = ACTIONS(2588),
    [anon_sym___attribute] = ACTIONS(2588),
    [anon_sym_using] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2588),
    [anon_sym___based] = ACTIONS(2588),
    [anon_sym___cdecl] = ACTIONS(2588),
    [anon_sym___clrcall] = ACTIONS(2588),
    [anon_sym___stdcall] = ACTIONS(2588),
    [anon_sym___fastcall] = ACTIONS(2588),
    [anon_sym___thiscall] = ACTIONS(2588),
    [anon_sym___vectorcall] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2588),
    [anon_sym_unsigned] = ACTIONS(2588),
    [anon_sym_long] = ACTIONS(2588),
    [anon_sym_short] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_register] = ACTIONS(2588),
    [anon_sym_inline] = ACTIONS(2588),
    [anon_sym___inline] = ACTIONS(2588),
    [anon_sym___inline__] = ACTIONS(2588),
    [anon_sym___forceinline] = ACTIONS(2588),
    [anon_sym_thread_local] = ACTIONS(2588),
    [anon_sym___thread] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_constexpr] = ACTIONS(2588),
    [anon_sym_volatile] = ACTIONS(2588),
    [anon_sym_restrict] = ACTIONS(2588),
    [anon_sym___restrict__] = ACTIONS(2588),
    [anon_sym__Atomic] = ACTIONS(2588),
    [anon_sym__Noreturn] = ACTIONS(2588),
    [anon_sym_noreturn] = ACTIONS(2588),
    [anon_sym__Nonnull] = ACTIONS(2588),
    [anon_sym_mutable] = ACTIONS(2588),
    [anon_sym_constinit] = ACTIONS(2588),
    [anon_sym_consteval] = ACTIONS(2588),
    [anon_sym_alignas] = ACTIONS(2588),
    [anon_sym__Alignas] = ACTIONS(2588),
    [sym_primitive_type] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_goto] = ACTIONS(2588),
    [anon_sym___try] = ACTIONS(2588),
    [anon_sym___leave] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2588),
    [anon_sym_compl] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_sizeof] = ACTIONS(2588),
    [anon_sym___alignof__] = ACTIONS(2588),
    [anon_sym___alignof] = ACTIONS(2588),
    [anon_sym__alignof] = ACTIONS(2588),
    [anon_sym_alignof] = ACTIONS(2588),
    [anon_sym__Alignof] = ACTIONS(2588),
    [anon_sym_offsetof] = ACTIONS(2588),
    [anon_sym__Generic] = ACTIONS(2588),
    [anon_sym_asm] = ACTIONS(2588),
    [anon_sym___asm__] = ACTIONS(2588),
    [anon_sym___asm] = ACTIONS(2588),
    [sym_number_literal] = ACTIONS(2590),
    [anon_sym_L_SQUOTE] = ACTIONS(2590),
    [anon_sym_u_SQUOTE] = ACTIONS(2590),
    [anon_sym_U_SQUOTE] = ACTIONS(2590),
    [anon_sym_u8_SQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [anon_sym_L_DQUOTE] = ACTIONS(2590),
    [anon_sym_u_DQUOTE] = ACTIONS(2590),
    [anon_sym_U_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8_DQUOTE] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [anon_sym_NULL] = ACTIONS(2588),
    [anon_sym_nullptr] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2588),
    [anon_sym_decltype] = ACTIONS(2588),
    [anon_sym_explicit] = ACTIONS(2588),
    [anon_sym_typename] = ACTIONS(2588),
    [anon_sym_template] = ACTIONS(2588),
    [anon_sym_operator] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_static_assert] = ACTIONS(2588),
    [anon_sym_concept] = ACTIONS(2588),
    [anon_sym_co_return] = ACTIONS(2588),
    [anon_sym_co_yield] = ACTIONS(2588),
    [anon_sym_R_DQUOTE] = ACTIONS(2590),
    [anon_sym_LR_DQUOTE] = ACTIONS(2590),
    [anon_sym_uR_DQUOTE] = ACTIONS(2590),
    [anon_sym_UR_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2590),
    [anon_sym_co_await] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_requires] = ACTIONS(2588),
    [sym_this] = ACTIONS(2588),
    [anon_sym_discard] = ACTIONS(2588),
    [anon_sym_precise] = ACTIONS(2588),
    [anon_sym_shared] = ACTIONS(2588),
    [anon_sym_groupshared] = ACTIONS(2588),
    [anon_sym_uniform] = ACTIONS(2588),
    [anon_sym_row_major] = ACTIONS(2588),
    [anon_sym_column_major] = ACTIONS(2588),
    [anon_sym_globallycoherent] = ACTIONS(2588),
    [anon_sym_centroid] = ACTIONS(2588),
    [anon_sym_noperspective] = ACTIONS(2588),
    [anon_sym_nointerpolation] = ACTIONS(2588),
    [anon_sym_sample] = ACTIONS(2588),
    [anon_sym_linear] = ACTIONS(2588),
    [anon_sym_snorm] = ACTIONS(2588),
    [anon_sym_unorm] = ACTIONS(2588),
    [anon_sym_point] = ACTIONS(2588),
    [anon_sym_line] = ACTIONS(2588),
    [anon_sym_triangleadj] = ACTIONS(2588),
    [anon_sym_lineadj] = ACTIONS(2588),
    [anon_sym_triangle] = ACTIONS(2588),
    [anon_sym_cbuffer] = ACTIONS(2588),
  },
  [574] = {
    [sym_identifier] = ACTIONS(2445),
    [aux_sym_preproc_include_token1] = ACTIONS(2445),
    [aux_sym_preproc_def_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token2] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_LPAREN2] = ACTIONS(2447),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(2447),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym___extension__] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_out] = ACTIONS(2445),
    [anon_sym_inout] = ACTIONS(2445),
    [anon_sym_virtual] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym___attribute__] = ACTIONS(2445),
    [anon_sym___attribute] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2447),
    [anon_sym___declspec] = ACTIONS(2445),
    [anon_sym___based] = ACTIONS(2445),
    [anon_sym___cdecl] = ACTIONS(2445),
    [anon_sym___clrcall] = ACTIONS(2445),
    [anon_sym___stdcall] = ACTIONS(2445),
    [anon_sym___fastcall] = ACTIONS(2445),
    [anon_sym___thiscall] = ACTIONS(2445),
    [anon_sym___vectorcall] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_signed] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym___inline] = ACTIONS(2445),
    [anon_sym___inline__] = ACTIONS(2445),
    [anon_sym___forceinline] = ACTIONS(2445),
    [anon_sym_thread_local] = ACTIONS(2445),
    [anon_sym___thread] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym___restrict__] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym__Noreturn] = ACTIONS(2445),
    [anon_sym_noreturn] = ACTIONS(2445),
    [anon_sym__Nonnull] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_constinit] = ACTIONS(2445),
    [anon_sym_consteval] = ACTIONS(2445),
    [anon_sym_alignas] = ACTIONS(2445),
    [anon_sym__Alignas] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym___try] = ACTIONS(2445),
    [anon_sym___leave] = ACTIONS(2445),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_compl] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_sizeof] = ACTIONS(2445),
    [anon_sym___alignof__] = ACTIONS(2445),
    [anon_sym___alignof] = ACTIONS(2445),
    [anon_sym__alignof] = ACTIONS(2445),
    [anon_sym_alignof] = ACTIONS(2445),
    [anon_sym__Alignof] = ACTIONS(2445),
    [anon_sym_offsetof] = ACTIONS(2445),
    [anon_sym__Generic] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym___asm__] = ACTIONS(2445),
    [anon_sym___asm] = ACTIONS(2445),
    [sym_number_literal] = ACTIONS(2447),
    [anon_sym_L_SQUOTE] = ACTIONS(2447),
    [anon_sym_u_SQUOTE] = ACTIONS(2447),
    [anon_sym_U_SQUOTE] = ACTIONS(2447),
    [anon_sym_u8_SQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [anon_sym_L_DQUOTE] = ACTIONS(2447),
    [anon_sym_u_DQUOTE] = ACTIONS(2447),
    [anon_sym_U_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8_DQUOTE] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [anon_sym_NULL] = ACTIONS(2445),
    [anon_sym_nullptr] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_decltype] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_operator] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_static_assert] = ACTIONS(2445),
    [anon_sym_concept] = ACTIONS(2445),
    [anon_sym_co_return] = ACTIONS(2445),
    [anon_sym_co_yield] = ACTIONS(2445),
    [anon_sym_R_DQUOTE] = ACTIONS(2447),
    [anon_sym_LR_DQUOTE] = ACTIONS(2447),
    [anon_sym_uR_DQUOTE] = ACTIONS(2447),
    [anon_sym_UR_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2447),
    [anon_sym_co_await] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_requires] = ACTIONS(2445),
    [sym_this] = ACTIONS(2445),
    [anon_sym_discard] = ACTIONS(2445),
    [anon_sym_precise] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_groupshared] = ACTIONS(2445),
    [anon_sym_uniform] = ACTIONS(2445),
    [anon_sym_row_major] = ACTIONS(2445),
    [anon_sym_column_major] = ACTIONS(2445),
    [anon_sym_globallycoherent] = ACTIONS(2445),
    [anon_sym_centroid] = ACTIONS(2445),
    [anon_sym_noperspective] = ACTIONS(2445),
    [anon_sym_nointerpolation] = ACTIONS(2445),
    [anon_sym_sample] = ACTIONS(2445),
    [anon_sym_linear] = ACTIONS(2445),
    [anon_sym_snorm] = ACTIONS(2445),
    [anon_sym_unorm] = ACTIONS(2445),
    [anon_sym_point] = ACTIONS(2445),
    [anon_sym_line] = ACTIONS(2445),
    [anon_sym_triangleadj] = ACTIONS(2445),
    [anon_sym_lineadj] = ACTIONS(2445),
    [anon_sym_triangle] = ACTIONS(2445),
    [anon_sym_cbuffer] = ACTIONS(2445),
  },
  [575] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_include_token1] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym___cdecl] = ACTIONS(2652),
    [anon_sym___clrcall] = ACTIONS(2652),
    [anon_sym___stdcall] = ACTIONS(2652),
    [anon_sym___fastcall] = ACTIONS(2652),
    [anon_sym___thiscall] = ACTIONS(2652),
    [anon_sym___vectorcall] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_do] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_goto] = ACTIONS(2652),
    [anon_sym___try] = ACTIONS(2652),
    [anon_sym___leave] = ACTIONS(2652),
    [anon_sym_not] = ACTIONS(2652),
    [anon_sym_compl] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_sizeof] = ACTIONS(2652),
    [anon_sym___alignof__] = ACTIONS(2652),
    [anon_sym___alignof] = ACTIONS(2652),
    [anon_sym__alignof] = ACTIONS(2652),
    [anon_sym_alignof] = ACTIONS(2652),
    [anon_sym__Alignof] = ACTIONS(2652),
    [anon_sym_offsetof] = ACTIONS(2652),
    [anon_sym__Generic] = ACTIONS(2652),
    [anon_sym_asm] = ACTIONS(2652),
    [anon_sym___asm__] = ACTIONS(2652),
    [anon_sym___asm] = ACTIONS(2652),
    [sym_number_literal] = ACTIONS(2654),
    [anon_sym_L_SQUOTE] = ACTIONS(2654),
    [anon_sym_u_SQUOTE] = ACTIONS(2654),
    [anon_sym_U_SQUOTE] = ACTIONS(2654),
    [anon_sym_u8_SQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [anon_sym_L_DQUOTE] = ACTIONS(2654),
    [anon_sym_u_DQUOTE] = ACTIONS(2654),
    [anon_sym_U_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8_DQUOTE] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [anon_sym_NULL] = ACTIONS(2652),
    [anon_sym_nullptr] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [anon_sym_delete] = ACTIONS(2652),
    [anon_sym_throw] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_concept] = ACTIONS(2652),
    [anon_sym_co_return] = ACTIONS(2652),
    [anon_sym_co_yield] = ACTIONS(2652),
    [anon_sym_R_DQUOTE] = ACTIONS(2654),
    [anon_sym_LR_DQUOTE] = ACTIONS(2654),
    [anon_sym_uR_DQUOTE] = ACTIONS(2654),
    [anon_sym_UR_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2654),
    [anon_sym_co_await] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_requires] = ACTIONS(2652),
    [sym_this] = ACTIONS(2652),
    [anon_sym_discard] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
    [anon_sym_cbuffer] = ACTIONS(2652),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_include_token1] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym___cdecl] = ACTIONS(2425),
    [anon_sym___clrcall] = ACTIONS(2425),
    [anon_sym___stdcall] = ACTIONS(2425),
    [anon_sym___fastcall] = ACTIONS(2425),
    [anon_sym___thiscall] = ACTIONS(2425),
    [anon_sym___vectorcall] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_goto] = ACTIONS(2425),
    [anon_sym___try] = ACTIONS(2425),
    [anon_sym___leave] = ACTIONS(2425),
    [anon_sym_not] = ACTIONS(2425),
    [anon_sym_compl] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_sizeof] = ACTIONS(2425),
    [anon_sym___alignof__] = ACTIONS(2425),
    [anon_sym___alignof] = ACTIONS(2425),
    [anon_sym__alignof] = ACTIONS(2425),
    [anon_sym_alignof] = ACTIONS(2425),
    [anon_sym__Alignof] = ACTIONS(2425),
    [anon_sym_offsetof] = ACTIONS(2425),
    [anon_sym__Generic] = ACTIONS(2425),
    [anon_sym_asm] = ACTIONS(2425),
    [anon_sym___asm__] = ACTIONS(2425),
    [anon_sym___asm] = ACTIONS(2425),
    [sym_number_literal] = ACTIONS(2427),
    [anon_sym_L_SQUOTE] = ACTIONS(2427),
    [anon_sym_u_SQUOTE] = ACTIONS(2427),
    [anon_sym_U_SQUOTE] = ACTIONS(2427),
    [anon_sym_u8_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_L_DQUOTE] = ACTIONS(2427),
    [anon_sym_u_DQUOTE] = ACTIONS(2427),
    [anon_sym_U_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8_DQUOTE] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [anon_sym_NULL] = ACTIONS(2425),
    [anon_sym_nullptr] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_concept] = ACTIONS(2425),
    [anon_sym_co_return] = ACTIONS(2425),
    [anon_sym_co_yield] = ACTIONS(2425),
    [anon_sym_R_DQUOTE] = ACTIONS(2427),
    [anon_sym_LR_DQUOTE] = ACTIONS(2427),
    [anon_sym_uR_DQUOTE] = ACTIONS(2427),
    [anon_sym_UR_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2427),
    [anon_sym_co_await] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_requires] = ACTIONS(2425),
    [sym_this] = ACTIONS(2425),
    [anon_sym_discard] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
    [anon_sym_cbuffer] = ACTIONS(2425),
  },
  [577] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_include_token1] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token2] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym___cdecl] = ACTIONS(2512),
    [anon_sym___clrcall] = ACTIONS(2512),
    [anon_sym___stdcall] = ACTIONS(2512),
    [anon_sym___fastcall] = ACTIONS(2512),
    [anon_sym___thiscall] = ACTIONS(2512),
    [anon_sym___vectorcall] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_goto] = ACTIONS(2512),
    [anon_sym___try] = ACTIONS(2512),
    [anon_sym___leave] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2512),
    [anon_sym___alignof__] = ACTIONS(2512),
    [anon_sym___alignof] = ACTIONS(2512),
    [anon_sym__alignof] = ACTIONS(2512),
    [anon_sym_alignof] = ACTIONS(2512),
    [anon_sym__Alignof] = ACTIONS(2512),
    [anon_sym_offsetof] = ACTIONS(2512),
    [anon_sym__Generic] = ACTIONS(2512),
    [anon_sym_asm] = ACTIONS(2512),
    [anon_sym___asm__] = ACTIONS(2512),
    [anon_sym___asm] = ACTIONS(2512),
    [sym_number_literal] = ACTIONS(2514),
    [anon_sym_L_SQUOTE] = ACTIONS(2514),
    [anon_sym_u_SQUOTE] = ACTIONS(2514),
    [anon_sym_U_SQUOTE] = ACTIONS(2514),
    [anon_sym_u8_SQUOTE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_L_DQUOTE] = ACTIONS(2514),
    [anon_sym_u_DQUOTE] = ACTIONS(2514),
    [anon_sym_U_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [anon_sym_NULL] = ACTIONS(2512),
    [anon_sym_nullptr] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_concept] = ACTIONS(2512),
    [anon_sym_co_return] = ACTIONS(2512),
    [anon_sym_co_yield] = ACTIONS(2512),
    [anon_sym_R_DQUOTE] = ACTIONS(2514),
    [anon_sym_LR_DQUOTE] = ACTIONS(2514),
    [anon_sym_uR_DQUOTE] = ACTIONS(2514),
    [anon_sym_UR_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2514),
    [anon_sym_co_await] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_requires] = ACTIONS(2512),
    [sym_this] = ACTIONS(2512),
    [anon_sym_discard] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
    [anon_sym_cbuffer] = ACTIONS(2512),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_include_token1] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym___cdecl] = ACTIONS(2429),
    [anon_sym___clrcall] = ACTIONS(2429),
    [anon_sym___stdcall] = ACTIONS(2429),
    [anon_sym___fastcall] = ACTIONS(2429),
    [anon_sym___thiscall] = ACTIONS(2429),
    [anon_sym___vectorcall] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym___try] = ACTIONS(2429),
    [anon_sym___leave] = ACTIONS(2429),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_compl] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_sizeof] = ACTIONS(2429),
    [anon_sym___alignof__] = ACTIONS(2429),
    [anon_sym___alignof] = ACTIONS(2429),
    [anon_sym__alignof] = ACTIONS(2429),
    [anon_sym_alignof] = ACTIONS(2429),
    [anon_sym__Alignof] = ACTIONS(2429),
    [anon_sym_offsetof] = ACTIONS(2429),
    [anon_sym__Generic] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym___asm__] = ACTIONS(2429),
    [anon_sym___asm] = ACTIONS(2429),
    [sym_number_literal] = ACTIONS(2431),
    [anon_sym_L_SQUOTE] = ACTIONS(2431),
    [anon_sym_u_SQUOTE] = ACTIONS(2431),
    [anon_sym_U_SQUOTE] = ACTIONS(2431),
    [anon_sym_u8_SQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [anon_sym_L_DQUOTE] = ACTIONS(2431),
    [anon_sym_u_DQUOTE] = ACTIONS(2431),
    [anon_sym_U_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8_DQUOTE] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [anon_sym_NULL] = ACTIONS(2429),
    [anon_sym_nullptr] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_concept] = ACTIONS(2429),
    [anon_sym_co_return] = ACTIONS(2429),
    [anon_sym_co_yield] = ACTIONS(2429),
    [anon_sym_R_DQUOTE] = ACTIONS(2431),
    [anon_sym_LR_DQUOTE] = ACTIONS(2431),
    [anon_sym_uR_DQUOTE] = ACTIONS(2431),
    [anon_sym_UR_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2431),
    [anon_sym_co_await] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_requires] = ACTIONS(2429),
    [sym_this] = ACTIONS(2429),
    [anon_sym_discard] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
    [anon_sym_cbuffer] = ACTIONS(2429),
  },
  [579] = {
    [sym_identifier] = ACTIONS(2528),
    [aux_sym_preproc_include_token1] = ACTIONS(2528),
    [aux_sym_preproc_def_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token2] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2528),
    [sym_preproc_directive] = ACTIONS(2528),
    [anon_sym_LPAREN2] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym___extension__] = ACTIONS(2528),
    [anon_sym_typedef] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2528),
    [anon_sym_out] = ACTIONS(2528),
    [anon_sym_inout] = ACTIONS(2528),
    [anon_sym_virtual] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym___attribute__] = ACTIONS(2528),
    [anon_sym___attribute] = ACTIONS(2528),
    [anon_sym_using] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2530),
    [anon_sym___declspec] = ACTIONS(2528),
    [anon_sym___based] = ACTIONS(2528),
    [anon_sym___cdecl] = ACTIONS(2528),
    [anon_sym___clrcall] = ACTIONS(2528),
    [anon_sym___stdcall] = ACTIONS(2528),
    [anon_sym___fastcall] = ACTIONS(2528),
    [anon_sym___thiscall] = ACTIONS(2528),
    [anon_sym___vectorcall] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_signed] = ACTIONS(2528),
    [anon_sym_unsigned] = ACTIONS(2528),
    [anon_sym_long] = ACTIONS(2528),
    [anon_sym_short] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_register] = ACTIONS(2528),
    [anon_sym_inline] = ACTIONS(2528),
    [anon_sym___inline] = ACTIONS(2528),
    [anon_sym___inline__] = ACTIONS(2528),
    [anon_sym___forceinline] = ACTIONS(2528),
    [anon_sym_thread_local] = ACTIONS(2528),
    [anon_sym___thread] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_constexpr] = ACTIONS(2528),
    [anon_sym_volatile] = ACTIONS(2528),
    [anon_sym_restrict] = ACTIONS(2528),
    [anon_sym___restrict__] = ACTIONS(2528),
    [anon_sym__Atomic] = ACTIONS(2528),
    [anon_sym__Noreturn] = ACTIONS(2528),
    [anon_sym_noreturn] = ACTIONS(2528),
    [anon_sym__Nonnull] = ACTIONS(2528),
    [anon_sym_mutable] = ACTIONS(2528),
    [anon_sym_constinit] = ACTIONS(2528),
    [anon_sym_consteval] = ACTIONS(2528),
    [anon_sym_alignas] = ACTIONS(2528),
    [anon_sym__Alignas] = ACTIONS(2528),
    [sym_primitive_type] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_goto] = ACTIONS(2528),
    [anon_sym___try] = ACTIONS(2528),
    [anon_sym___leave] = ACTIONS(2528),
    [anon_sym_not] = ACTIONS(2528),
    [anon_sym_compl] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2528),
    [anon_sym___alignof__] = ACTIONS(2528),
    [anon_sym___alignof] = ACTIONS(2528),
    [anon_sym__alignof] = ACTIONS(2528),
    [anon_sym_alignof] = ACTIONS(2528),
    [anon_sym__Alignof] = ACTIONS(2528),
    [anon_sym_offsetof] = ACTIONS(2528),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2528),
    [anon_sym___asm__] = ACTIONS(2528),
    [anon_sym___asm] = ACTIONS(2528),
    [sym_number_literal] = ACTIONS(2530),
    [anon_sym_L_SQUOTE] = ACTIONS(2530),
    [anon_sym_u_SQUOTE] = ACTIONS(2530),
    [anon_sym_U_SQUOTE] = ACTIONS(2530),
    [anon_sym_u8_SQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_L_DQUOTE] = ACTIONS(2530),
    [anon_sym_u_DQUOTE] = ACTIONS(2530),
    [anon_sym_U_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8_DQUOTE] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [anon_sym_NULL] = ACTIONS(2528),
    [anon_sym_nullptr] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2528),
    [anon_sym_decltype] = ACTIONS(2528),
    [anon_sym_explicit] = ACTIONS(2528),
    [anon_sym_typename] = ACTIONS(2528),
    [anon_sym_template] = ACTIONS(2528),
    [anon_sym_operator] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_static_assert] = ACTIONS(2528),
    [anon_sym_concept] = ACTIONS(2528),
    [anon_sym_co_return] = ACTIONS(2528),
    [anon_sym_co_yield] = ACTIONS(2528),
    [anon_sym_R_DQUOTE] = ACTIONS(2530),
    [anon_sym_LR_DQUOTE] = ACTIONS(2530),
    [anon_sym_uR_DQUOTE] = ACTIONS(2530),
    [anon_sym_UR_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2530),
    [anon_sym_co_await] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_requires] = ACTIONS(2528),
    [sym_this] = ACTIONS(2528),
    [anon_sym_discard] = ACTIONS(2528),
    [anon_sym_precise] = ACTIONS(2528),
    [anon_sym_shared] = ACTIONS(2528),
    [anon_sym_groupshared] = ACTIONS(2528),
    [anon_sym_uniform] = ACTIONS(2528),
    [anon_sym_row_major] = ACTIONS(2528),
    [anon_sym_column_major] = ACTIONS(2528),
    [anon_sym_globallycoherent] = ACTIONS(2528),
    [anon_sym_centroid] = ACTIONS(2528),
    [anon_sym_noperspective] = ACTIONS(2528),
    [anon_sym_nointerpolation] = ACTIONS(2528),
    [anon_sym_sample] = ACTIONS(2528),
    [anon_sym_linear] = ACTIONS(2528),
    [anon_sym_snorm] = ACTIONS(2528),
    [anon_sym_unorm] = ACTIONS(2528),
    [anon_sym_point] = ACTIONS(2528),
    [anon_sym_line] = ACTIONS(2528),
    [anon_sym_triangleadj] = ACTIONS(2528),
    [anon_sym_lineadj] = ACTIONS(2528),
    [anon_sym_triangle] = ACTIONS(2528),
    [anon_sym_cbuffer] = ACTIONS(2528),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token2] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2538),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2538),
    [anon_sym_L_SQUOTE] = ACTIONS(2538),
    [anon_sym_u_SQUOTE] = ACTIONS(2538),
    [anon_sym_U_SQUOTE] = ACTIONS(2538),
    [anon_sym_u8_SQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_L_DQUOTE] = ACTIONS(2538),
    [anon_sym_u_DQUOTE] = ACTIONS(2538),
    [anon_sym_U_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8_DQUOTE] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2538),
    [anon_sym_LR_DQUOTE] = ACTIONS(2538),
    [anon_sym_uR_DQUOTE] = ACTIONS(2538),
    [anon_sym_UR_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2538),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
  },
  [581] = {
    [sym_identifier] = ACTIONS(2544),
    [aux_sym_preproc_include_token1] = ACTIONS(2544),
    [aux_sym_preproc_def_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token2] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2544),
    [sym_preproc_directive] = ACTIONS(2544),
    [anon_sym_LPAREN2] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym___extension__] = ACTIONS(2544),
    [anon_sym_typedef] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2544),
    [anon_sym_out] = ACTIONS(2544),
    [anon_sym_inout] = ACTIONS(2544),
    [anon_sym_virtual] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym___attribute__] = ACTIONS(2544),
    [anon_sym___attribute] = ACTIONS(2544),
    [anon_sym_using] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2546),
    [anon_sym___declspec] = ACTIONS(2544),
    [anon_sym___based] = ACTIONS(2544),
    [anon_sym___cdecl] = ACTIONS(2544),
    [anon_sym___clrcall] = ACTIONS(2544),
    [anon_sym___stdcall] = ACTIONS(2544),
    [anon_sym___fastcall] = ACTIONS(2544),
    [anon_sym___thiscall] = ACTIONS(2544),
    [anon_sym___vectorcall] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_signed] = ACTIONS(2544),
    [anon_sym_unsigned] = ACTIONS(2544),
    [anon_sym_long] = ACTIONS(2544),
    [anon_sym_short] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_register] = ACTIONS(2544),
    [anon_sym_inline] = ACTIONS(2544),
    [anon_sym___inline] = ACTIONS(2544),
    [anon_sym___inline__] = ACTIONS(2544),
    [anon_sym___forceinline] = ACTIONS(2544),
    [anon_sym_thread_local] = ACTIONS(2544),
    [anon_sym___thread] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_constexpr] = ACTIONS(2544),
    [anon_sym_volatile] = ACTIONS(2544),
    [anon_sym_restrict] = ACTIONS(2544),
    [anon_sym___restrict__] = ACTIONS(2544),
    [anon_sym__Atomic] = ACTIONS(2544),
    [anon_sym__Noreturn] = ACTIONS(2544),
    [anon_sym_noreturn] = ACTIONS(2544),
    [anon_sym__Nonnull] = ACTIONS(2544),
    [anon_sym_mutable] = ACTIONS(2544),
    [anon_sym_constinit] = ACTIONS(2544),
    [anon_sym_consteval] = ACTIONS(2544),
    [anon_sym_alignas] = ACTIONS(2544),
    [anon_sym__Alignas] = ACTIONS(2544),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_goto] = ACTIONS(2544),
    [anon_sym___try] = ACTIONS(2544),
    [anon_sym___leave] = ACTIONS(2544),
    [anon_sym_not] = ACTIONS(2544),
    [anon_sym_compl] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_sizeof] = ACTIONS(2544),
    [anon_sym___alignof__] = ACTIONS(2544),
    [anon_sym___alignof] = ACTIONS(2544),
    [anon_sym__alignof] = ACTIONS(2544),
    [anon_sym_alignof] = ACTIONS(2544),
    [anon_sym__Alignof] = ACTIONS(2544),
    [anon_sym_offsetof] = ACTIONS(2544),
    [anon_sym__Generic] = ACTIONS(2544),
    [anon_sym_asm] = ACTIONS(2544),
    [anon_sym___asm__] = ACTIONS(2544),
    [anon_sym___asm] = ACTIONS(2544),
    [sym_number_literal] = ACTIONS(2546),
    [anon_sym_L_SQUOTE] = ACTIONS(2546),
    [anon_sym_u_SQUOTE] = ACTIONS(2546),
    [anon_sym_U_SQUOTE] = ACTIONS(2546),
    [anon_sym_u8_SQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_L_DQUOTE] = ACTIONS(2546),
    [anon_sym_u_DQUOTE] = ACTIONS(2546),
    [anon_sym_U_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8_DQUOTE] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [anon_sym_NULL] = ACTIONS(2544),
    [anon_sym_nullptr] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2544),
    [anon_sym_decltype] = ACTIONS(2544),
    [anon_sym_explicit] = ACTIONS(2544),
    [anon_sym_typename] = ACTIONS(2544),
    [anon_sym_template] = ACTIONS(2544),
    [anon_sym_operator] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_static_assert] = ACTIONS(2544),
    [anon_sym_concept] = ACTIONS(2544),
    [anon_sym_co_return] = ACTIONS(2544),
    [anon_sym_co_yield] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_requires] = ACTIONS(2544),
    [sym_this] = ACTIONS(2544),
    [anon_sym_discard] = ACTIONS(2544),
    [anon_sym_precise] = ACTIONS(2544),
    [anon_sym_shared] = ACTIONS(2544),
    [anon_sym_groupshared] = ACTIONS(2544),
    [anon_sym_uniform] = ACTIONS(2544),
    [anon_sym_row_major] = ACTIONS(2544),
    [anon_sym_column_major] = ACTIONS(2544),
    [anon_sym_globallycoherent] = ACTIONS(2544),
    [anon_sym_centroid] = ACTIONS(2544),
    [anon_sym_noperspective] = ACTIONS(2544),
    [anon_sym_nointerpolation] = ACTIONS(2544),
    [anon_sym_sample] = ACTIONS(2544),
    [anon_sym_linear] = ACTIONS(2544),
    [anon_sym_snorm] = ACTIONS(2544),
    [anon_sym_unorm] = ACTIONS(2544),
    [anon_sym_point] = ACTIONS(2544),
    [anon_sym_line] = ACTIONS(2544),
    [anon_sym_triangleadj] = ACTIONS(2544),
    [anon_sym_lineadj] = ACTIONS(2544),
    [anon_sym_triangle] = ACTIONS(2544),
    [anon_sym_cbuffer] = ACTIONS(2544),
  },
  [582] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_include_token1] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym___cdecl] = ACTIONS(2466),
    [anon_sym___clrcall] = ACTIONS(2466),
    [anon_sym___stdcall] = ACTIONS(2466),
    [anon_sym___fastcall] = ACTIONS(2466),
    [anon_sym___thiscall] = ACTIONS(2466),
    [anon_sym___vectorcall] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym___try] = ACTIONS(2466),
    [anon_sym___leave] = ACTIONS(2466),
    [anon_sym_not] = ACTIONS(2466),
    [anon_sym_compl] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym___alignof__] = ACTIONS(2466),
    [anon_sym___alignof] = ACTIONS(2466),
    [anon_sym__alignof] = ACTIONS(2466),
    [anon_sym_alignof] = ACTIONS(2466),
    [anon_sym__Alignof] = ACTIONS(2466),
    [anon_sym_offsetof] = ACTIONS(2466),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2466),
    [anon_sym___asm__] = ACTIONS(2466),
    [anon_sym___asm] = ACTIONS(2466),
    [sym_number_literal] = ACTIONS(2468),
    [anon_sym_L_SQUOTE] = ACTIONS(2468),
    [anon_sym_u_SQUOTE] = ACTIONS(2468),
    [anon_sym_U_SQUOTE] = ACTIONS(2468),
    [anon_sym_u8_SQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_L_DQUOTE] = ACTIONS(2468),
    [anon_sym_u_DQUOTE] = ACTIONS(2468),
    [anon_sym_U_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [anon_sym_NULL] = ACTIONS(2466),
    [anon_sym_nullptr] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_concept] = ACTIONS(2466),
    [anon_sym_co_return] = ACTIONS(2466),
    [anon_sym_co_yield] = ACTIONS(2466),
    [anon_sym_R_DQUOTE] = ACTIONS(2468),
    [anon_sym_LR_DQUOTE] = ACTIONS(2468),
    [anon_sym_uR_DQUOTE] = ACTIONS(2468),
    [anon_sym_UR_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2468),
    [anon_sym_co_await] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_requires] = ACTIONS(2466),
    [sym_this] = ACTIONS(2466),
    [anon_sym_discard] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
    [anon_sym_cbuffer] = ACTIONS(2466),
  },
  [583] = {
    [sym_identifier] = ACTIONS(2480),
    [aux_sym_preproc_include_token1] = ACTIONS(2480),
    [aux_sym_preproc_def_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token2] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_LPAREN2] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_out] = ACTIONS(2480),
    [anon_sym_inout] = ACTIONS(2480),
    [anon_sym_virtual] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym___attribute__] = ACTIONS(2480),
    [anon_sym___attribute] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2482),
    [anon_sym___declspec] = ACTIONS(2480),
    [anon_sym___based] = ACTIONS(2480),
    [anon_sym___cdecl] = ACTIONS(2480),
    [anon_sym___clrcall] = ACTIONS(2480),
    [anon_sym___stdcall] = ACTIONS(2480),
    [anon_sym___fastcall] = ACTIONS(2480),
    [anon_sym___thiscall] = ACTIONS(2480),
    [anon_sym___vectorcall] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym___inline] = ACTIONS(2480),
    [anon_sym___inline__] = ACTIONS(2480),
    [anon_sym___forceinline] = ACTIONS(2480),
    [anon_sym_thread_local] = ACTIONS(2480),
    [anon_sym___thread] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym___restrict__] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym__Noreturn] = ACTIONS(2480),
    [anon_sym_noreturn] = ACTIONS(2480),
    [anon_sym__Nonnull] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_constinit] = ACTIONS(2480),
    [anon_sym_consteval] = ACTIONS(2480),
    [anon_sym_alignas] = ACTIONS(2480),
    [anon_sym__Alignas] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym___try] = ACTIONS(2480),
    [anon_sym___leave] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2480),
    [anon_sym_compl] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2480),
    [anon_sym___alignof__] = ACTIONS(2480),
    [anon_sym___alignof] = ACTIONS(2480),
    [anon_sym__alignof] = ACTIONS(2480),
    [anon_sym_alignof] = ACTIONS(2480),
    [anon_sym__Alignof] = ACTIONS(2480),
    [anon_sym_offsetof] = ACTIONS(2480),
    [anon_sym__Generic] = ACTIONS(2480),
    [anon_sym_asm] = ACTIONS(2480),
    [anon_sym___asm__] = ACTIONS(2480),
    [anon_sym___asm] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2482),
    [anon_sym_u_SQUOTE] = ACTIONS(2482),
    [anon_sym_U_SQUOTE] = ACTIONS(2482),
    [anon_sym_u8_SQUOTE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_L_DQUOTE] = ACTIONS(2482),
    [anon_sym_u_DQUOTE] = ACTIONS(2482),
    [anon_sym_U_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8_DQUOTE] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [anon_sym_NULL] = ACTIONS(2480),
    [anon_sym_nullptr] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_decltype] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_operator] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_throw] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_static_assert] = ACTIONS(2480),
    [anon_sym_concept] = ACTIONS(2480),
    [anon_sym_co_return] = ACTIONS(2480),
    [anon_sym_co_yield] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_requires] = ACTIONS(2480),
    [sym_this] = ACTIONS(2480),
    [anon_sym_discard] = ACTIONS(2480),
    [anon_sym_precise] = ACTIONS(2480),
    [anon_sym_shared] = ACTIONS(2480),
    [anon_sym_groupshared] = ACTIONS(2480),
    [anon_sym_uniform] = ACTIONS(2480),
    [anon_sym_row_major] = ACTIONS(2480),
    [anon_sym_column_major] = ACTIONS(2480),
    [anon_sym_globallycoherent] = ACTIONS(2480),
    [anon_sym_centroid] = ACTIONS(2480),
    [anon_sym_noperspective] = ACTIONS(2480),
    [anon_sym_nointerpolation] = ACTIONS(2480),
    [anon_sym_sample] = ACTIONS(2480),
    [anon_sym_linear] = ACTIONS(2480),
    [anon_sym_snorm] = ACTIONS(2480),
    [anon_sym_unorm] = ACTIONS(2480),
    [anon_sym_point] = ACTIONS(2480),
    [anon_sym_line] = ACTIONS(2480),
    [anon_sym_triangleadj] = ACTIONS(2480),
    [anon_sym_lineadj] = ACTIONS(2480),
    [anon_sym_triangle] = ACTIONS(2480),
    [anon_sym_cbuffer] = ACTIONS(2480),
  },
  [584] = {
    [sym_identifier] = ACTIONS(2484),
    [aux_sym_preproc_include_token1] = ACTIONS(2484),
    [aux_sym_preproc_def_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token2] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2484),
    [sym_preproc_directive] = ACTIONS(2484),
    [anon_sym_LPAREN2] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym___extension__] = ACTIONS(2484),
    [anon_sym_typedef] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_out] = ACTIONS(2484),
    [anon_sym_inout] = ACTIONS(2484),
    [anon_sym_virtual] = ACTIONS(2484),
    [anon_sym_extern] = ACTIONS(2484),
    [anon_sym___attribute__] = ACTIONS(2484),
    [anon_sym___attribute] = ACTIONS(2484),
    [anon_sym_using] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2486),
    [anon_sym___declspec] = ACTIONS(2484),
    [anon_sym___based] = ACTIONS(2484),
    [anon_sym___cdecl] = ACTIONS(2484),
    [anon_sym___clrcall] = ACTIONS(2484),
    [anon_sym___stdcall] = ACTIONS(2484),
    [anon_sym___fastcall] = ACTIONS(2484),
    [anon_sym___thiscall] = ACTIONS(2484),
    [anon_sym___vectorcall] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_signed] = ACTIONS(2484),
    [anon_sym_unsigned] = ACTIONS(2484),
    [anon_sym_long] = ACTIONS(2484),
    [anon_sym_short] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_register] = ACTIONS(2484),
    [anon_sym_inline] = ACTIONS(2484),
    [anon_sym___inline] = ACTIONS(2484),
    [anon_sym___inline__] = ACTIONS(2484),
    [anon_sym___forceinline] = ACTIONS(2484),
    [anon_sym_thread_local] = ACTIONS(2484),
    [anon_sym___thread] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_constexpr] = ACTIONS(2484),
    [anon_sym_volatile] = ACTIONS(2484),
    [anon_sym_restrict] = ACTIONS(2484),
    [anon_sym___restrict__] = ACTIONS(2484),
    [anon_sym__Atomic] = ACTIONS(2484),
    [anon_sym__Noreturn] = ACTIONS(2484),
    [anon_sym_noreturn] = ACTIONS(2484),
    [anon_sym__Nonnull] = ACTIONS(2484),
    [anon_sym_mutable] = ACTIONS(2484),
    [anon_sym_constinit] = ACTIONS(2484),
    [anon_sym_consteval] = ACTIONS(2484),
    [anon_sym_alignas] = ACTIONS(2484),
    [anon_sym__Alignas] = ACTIONS(2484),
    [sym_primitive_type] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_struct] = ACTIONS(2484),
    [anon_sym_union] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_goto] = ACTIONS(2484),
    [anon_sym___try] = ACTIONS(2484),
    [anon_sym___leave] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2484),
    [anon_sym_compl] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2484),
    [anon_sym___alignof__] = ACTIONS(2484),
    [anon_sym___alignof] = ACTIONS(2484),
    [anon_sym__alignof] = ACTIONS(2484),
    [anon_sym_alignof] = ACTIONS(2484),
    [anon_sym__Alignof] = ACTIONS(2484),
    [anon_sym_offsetof] = ACTIONS(2484),
    [anon_sym__Generic] = ACTIONS(2484),
    [anon_sym_asm] = ACTIONS(2484),
    [anon_sym___asm__] = ACTIONS(2484),
    [anon_sym___asm] = ACTIONS(2484),
    [sym_number_literal] = ACTIONS(2486),
    [anon_sym_L_SQUOTE] = ACTIONS(2486),
    [anon_sym_u_SQUOTE] = ACTIONS(2486),
    [anon_sym_U_SQUOTE] = ACTIONS(2486),
    [anon_sym_u8_SQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_L_DQUOTE] = ACTIONS(2486),
    [anon_sym_u_DQUOTE] = ACTIONS(2486),
    [anon_sym_U_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8_DQUOTE] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [anon_sym_NULL] = ACTIONS(2484),
    [anon_sym_nullptr] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2484),
    [anon_sym_decltype] = ACTIONS(2484),
    [anon_sym_explicit] = ACTIONS(2484),
    [anon_sym_typename] = ACTIONS(2484),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_static_assert] = ACTIONS(2484),
    [anon_sym_concept] = ACTIONS(2484),
    [anon_sym_co_return] = ACTIONS(2484),
    [anon_sym_co_yield] = ACTIONS(2484),
    [anon_sym_R_DQUOTE] = ACTIONS(2486),
    [anon_sym_LR_DQUOTE] = ACTIONS(2486),
    [anon_sym_uR_DQUOTE] = ACTIONS(2486),
    [anon_sym_UR_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2486),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2484),
    [anon_sym_requires] = ACTIONS(2484),
    [sym_this] = ACTIONS(2484),
    [anon_sym_discard] = ACTIONS(2484),
    [anon_sym_precise] = ACTIONS(2484),
    [anon_sym_shared] = ACTIONS(2484),
    [anon_sym_groupshared] = ACTIONS(2484),
    [anon_sym_uniform] = ACTIONS(2484),
    [anon_sym_row_major] = ACTIONS(2484),
    [anon_sym_column_major] = ACTIONS(2484),
    [anon_sym_globallycoherent] = ACTIONS(2484),
    [anon_sym_centroid] = ACTIONS(2484),
    [anon_sym_noperspective] = ACTIONS(2484),
    [anon_sym_nointerpolation] = ACTIONS(2484),
    [anon_sym_sample] = ACTIONS(2484),
    [anon_sym_linear] = ACTIONS(2484),
    [anon_sym_snorm] = ACTIONS(2484),
    [anon_sym_unorm] = ACTIONS(2484),
    [anon_sym_point] = ACTIONS(2484),
    [anon_sym_line] = ACTIONS(2484),
    [anon_sym_triangleadj] = ACTIONS(2484),
    [anon_sym_lineadj] = ACTIONS(2484),
    [anon_sym_triangle] = ACTIONS(2484),
    [anon_sym_cbuffer] = ACTIONS(2484),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [anon_sym___asm] = ACTIONS(2492),
    [sym_number_literal] = ACTIONS(2494),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
    [anon_sym_discard] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
    [anon_sym_cbuffer] = ACTIONS(2492),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [587] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2552),
    [aux_sym_preproc_include_token1] = ACTIONS(2552),
    [aux_sym_preproc_def_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_TILDE] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym___extension__] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_out] = ACTIONS(2552),
    [anon_sym_inout] = ACTIONS(2552),
    [anon_sym_virtual] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym___attribute__] = ACTIONS(2552),
    [anon_sym___attribute] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym___declspec] = ACTIONS(2552),
    [anon_sym___based] = ACTIONS(2552),
    [anon_sym___cdecl] = ACTIONS(2552),
    [anon_sym___clrcall] = ACTIONS(2552),
    [anon_sym___stdcall] = ACTIONS(2552),
    [anon_sym___fastcall] = ACTIONS(2552),
    [anon_sym___thiscall] = ACTIONS(2552),
    [anon_sym___vectorcall] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_RBRACE] = ACTIONS(2554),
    [anon_sym_signed] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym___inline] = ACTIONS(2552),
    [anon_sym___inline__] = ACTIONS(2552),
    [anon_sym___forceinline] = ACTIONS(2552),
    [anon_sym_thread_local] = ACTIONS(2552),
    [anon_sym___thread] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym___restrict__] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym__Noreturn] = ACTIONS(2552),
    [anon_sym_noreturn] = ACTIONS(2552),
    [anon_sym__Nonnull] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_constinit] = ACTIONS(2552),
    [anon_sym_consteval] = ACTIONS(2552),
    [anon_sym_alignas] = ACTIONS(2552),
    [anon_sym__Alignas] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_class] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym___try] = ACTIONS(2552),
    [anon_sym___leave] = ACTIONS(2552),
    [anon_sym_not] = ACTIONS(2552),
    [anon_sym_compl] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_sizeof] = ACTIONS(2552),
    [anon_sym___alignof__] = ACTIONS(2552),
    [anon_sym___alignof] = ACTIONS(2552),
    [anon_sym__alignof] = ACTIONS(2552),
    [anon_sym_alignof] = ACTIONS(2552),
    [anon_sym__Alignof] = ACTIONS(2552),
    [anon_sym_offsetof] = ACTIONS(2552),
    [anon_sym__Generic] = ACTIONS(2552),
    [anon_sym_asm] = ACTIONS(2552),
    [anon_sym___asm__] = ACTIONS(2552),
    [anon_sym___asm] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2554),
    [anon_sym_L_SQUOTE] = ACTIONS(2554),
    [anon_sym_u_SQUOTE] = ACTIONS(2554),
    [anon_sym_U_SQUOTE] = ACTIONS(2554),
    [anon_sym_u8_SQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_L_DQUOTE] = ACTIONS(2554),
    [anon_sym_u_DQUOTE] = ACTIONS(2554),
    [anon_sym_U_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8_DQUOTE] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [anon_sym_NULL] = ACTIONS(2552),
    [anon_sym_nullptr] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_decltype] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [anon_sym_delete] = ACTIONS(2552),
    [anon_sym_throw] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_static_assert] = ACTIONS(2552),
    [anon_sym_concept] = ACTIONS(2552),
    [anon_sym_co_return] = ACTIONS(2552),
    [anon_sym_co_yield] = ACTIONS(2552),
    [anon_sym_R_DQUOTE] = ACTIONS(2554),
    [anon_sym_LR_DQUOTE] = ACTIONS(2554),
    [anon_sym_uR_DQUOTE] = ACTIONS(2554),
    [anon_sym_UR_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2554),
    [anon_sym_co_await] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2552),
    [anon_sym_discard] = ACTIONS(2552),
    [anon_sym_precise] = ACTIONS(2552),
    [anon_sym_shared] = ACTIONS(2552),
    [anon_sym_groupshared] = ACTIONS(2552),
    [anon_sym_uniform] = ACTIONS(2552),
    [anon_sym_row_major] = ACTIONS(2552),
    [anon_sym_column_major] = ACTIONS(2552),
    [anon_sym_globallycoherent] = ACTIONS(2552),
    [anon_sym_centroid] = ACTIONS(2552),
    [anon_sym_noperspective] = ACTIONS(2552),
    [anon_sym_nointerpolation] = ACTIONS(2552),
    [anon_sym_sample] = ACTIONS(2552),
    [anon_sym_linear] = ACTIONS(2552),
    [anon_sym_snorm] = ACTIONS(2552),
    [anon_sym_unorm] = ACTIONS(2552),
    [anon_sym_point] = ACTIONS(2552),
    [anon_sym_line] = ACTIONS(2552),
    [anon_sym_triangleadj] = ACTIONS(2552),
    [anon_sym_lineadj] = ACTIONS(2552),
    [anon_sym_triangle] = ACTIONS(2552),
    [anon_sym_cbuffer] = ACTIONS(2552),
  },
  [589] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [590] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [591] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [593] = {
    [sym_identifier] = ACTIONS(2576),
    [aux_sym_preproc_include_token1] = ACTIONS(2576),
    [aux_sym_preproc_def_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token2] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2576),
    [sym_preproc_directive] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym___extension__] = ACTIONS(2576),
    [anon_sym_typedef] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2576),
    [anon_sym_out] = ACTIONS(2576),
    [anon_sym_inout] = ACTIONS(2576),
    [anon_sym_virtual] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym___attribute__] = ACTIONS(2576),
    [anon_sym___attribute] = ACTIONS(2576),
    [anon_sym_using] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2578),
    [anon_sym___declspec] = ACTIONS(2576),
    [anon_sym___based] = ACTIONS(2576),
    [anon_sym___cdecl] = ACTIONS(2576),
    [anon_sym___clrcall] = ACTIONS(2576),
    [anon_sym___stdcall] = ACTIONS(2576),
    [anon_sym___fastcall] = ACTIONS(2576),
    [anon_sym___thiscall] = ACTIONS(2576),
    [anon_sym___vectorcall] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_signed] = ACTIONS(2576),
    [anon_sym_unsigned] = ACTIONS(2576),
    [anon_sym_long] = ACTIONS(2576),
    [anon_sym_short] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_register] = ACTIONS(2576),
    [anon_sym_inline] = ACTIONS(2576),
    [anon_sym___inline] = ACTIONS(2576),
    [anon_sym___inline__] = ACTIONS(2576),
    [anon_sym___forceinline] = ACTIONS(2576),
    [anon_sym_thread_local] = ACTIONS(2576),
    [anon_sym___thread] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_constexpr] = ACTIONS(2576),
    [anon_sym_volatile] = ACTIONS(2576),
    [anon_sym_restrict] = ACTIONS(2576),
    [anon_sym___restrict__] = ACTIONS(2576),
    [anon_sym__Atomic] = ACTIONS(2576),
    [anon_sym__Noreturn] = ACTIONS(2576),
    [anon_sym_noreturn] = ACTIONS(2576),
    [anon_sym__Nonnull] = ACTIONS(2576),
    [anon_sym_mutable] = ACTIONS(2576),
    [anon_sym_constinit] = ACTIONS(2576),
    [anon_sym_consteval] = ACTIONS(2576),
    [anon_sym_alignas] = ACTIONS(2576),
    [anon_sym__Alignas] = ACTIONS(2576),
    [sym_primitive_type] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_goto] = ACTIONS(2576),
    [anon_sym___try] = ACTIONS(2576),
    [anon_sym___leave] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2576),
    [anon_sym_compl] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2578),
    [anon_sym_sizeof] = ACTIONS(2576),
    [anon_sym___alignof__] = ACTIONS(2576),
    [anon_sym___alignof] = ACTIONS(2576),
    [anon_sym__alignof] = ACTIONS(2576),
    [anon_sym_alignof] = ACTIONS(2576),
    [anon_sym__Alignof] = ACTIONS(2576),
    [anon_sym_offsetof] = ACTIONS(2576),
    [anon_sym__Generic] = ACTIONS(2576),
    [anon_sym_asm] = ACTIONS(2576),
    [anon_sym___asm__] = ACTIONS(2576),
    [anon_sym___asm] = ACTIONS(2576),
    [sym_number_literal] = ACTIONS(2578),
    [anon_sym_L_SQUOTE] = ACTIONS(2578),
    [anon_sym_u_SQUOTE] = ACTIONS(2578),
    [anon_sym_U_SQUOTE] = ACTIONS(2578),
    [anon_sym_u8_SQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_L_DQUOTE] = ACTIONS(2578),
    [anon_sym_u_DQUOTE] = ACTIONS(2578),
    [anon_sym_U_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8_DQUOTE] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_NULL] = ACTIONS(2576),
    [anon_sym_nullptr] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2576),
    [anon_sym_decltype] = ACTIONS(2576),
    [anon_sym_explicit] = ACTIONS(2576),
    [anon_sym_typename] = ACTIONS(2576),
    [anon_sym_template] = ACTIONS(2576),
    [anon_sym_operator] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_static_assert] = ACTIONS(2576),
    [anon_sym_concept] = ACTIONS(2576),
    [anon_sym_co_return] = ACTIONS(2576),
    [anon_sym_co_yield] = ACTIONS(2576),
    [anon_sym_R_DQUOTE] = ACTIONS(2578),
    [anon_sym_LR_DQUOTE] = ACTIONS(2578),
    [anon_sym_uR_DQUOTE] = ACTIONS(2578),
    [anon_sym_UR_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2578),
    [anon_sym_co_await] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_requires] = ACTIONS(2576),
    [sym_this] = ACTIONS(2576),
    [anon_sym_discard] = ACTIONS(2576),
    [anon_sym_precise] = ACTIONS(2576),
    [anon_sym_shared] = ACTIONS(2576),
    [anon_sym_groupshared] = ACTIONS(2576),
    [anon_sym_uniform] = ACTIONS(2576),
    [anon_sym_row_major] = ACTIONS(2576),
    [anon_sym_column_major] = ACTIONS(2576),
    [anon_sym_globallycoherent] = ACTIONS(2576),
    [anon_sym_centroid] = ACTIONS(2576),
    [anon_sym_noperspective] = ACTIONS(2576),
    [anon_sym_nointerpolation] = ACTIONS(2576),
    [anon_sym_sample] = ACTIONS(2576),
    [anon_sym_linear] = ACTIONS(2576),
    [anon_sym_snorm] = ACTIONS(2576),
    [anon_sym_unorm] = ACTIONS(2576),
    [anon_sym_point] = ACTIONS(2576),
    [anon_sym_line] = ACTIONS(2576),
    [anon_sym_triangleadj] = ACTIONS(2576),
    [anon_sym_lineadj] = ACTIONS(2576),
    [anon_sym_triangle] = ACTIONS(2576),
    [anon_sym_cbuffer] = ACTIONS(2576),
  },
  [594] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [anon_sym___asm] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym_discard] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
    [anon_sym_cbuffer] = ACTIONS(2504),
  },
  [595] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_include_token1] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym___cdecl] = ACTIONS(2508),
    [anon_sym___clrcall] = ACTIONS(2508),
    [anon_sym___stdcall] = ACTIONS(2508),
    [anon_sym___fastcall] = ACTIONS(2508),
    [anon_sym___thiscall] = ACTIONS(2508),
    [anon_sym___vectorcall] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_goto] = ACTIONS(2508),
    [anon_sym___try] = ACTIONS(2508),
    [anon_sym___leave] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2508),
    [anon_sym_compl] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2508),
    [anon_sym___alignof__] = ACTIONS(2508),
    [anon_sym___alignof] = ACTIONS(2508),
    [anon_sym__alignof] = ACTIONS(2508),
    [anon_sym_alignof] = ACTIONS(2508),
    [anon_sym__Alignof] = ACTIONS(2508),
    [anon_sym_offsetof] = ACTIONS(2508),
    [anon_sym__Generic] = ACTIONS(2508),
    [anon_sym_asm] = ACTIONS(2508),
    [anon_sym___asm__] = ACTIONS(2508),
    [anon_sym___asm] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(2510),
    [anon_sym_L_SQUOTE] = ACTIONS(2510),
    [anon_sym_u_SQUOTE] = ACTIONS(2510),
    [anon_sym_U_SQUOTE] = ACTIONS(2510),
    [anon_sym_u8_SQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_L_DQUOTE] = ACTIONS(2510),
    [anon_sym_u_DQUOTE] = ACTIONS(2510),
    [anon_sym_U_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [anon_sym_NULL] = ACTIONS(2508),
    [anon_sym_nullptr] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_concept] = ACTIONS(2508),
    [anon_sym_co_return] = ACTIONS(2508),
    [anon_sym_co_yield] = ACTIONS(2508),
    [anon_sym_R_DQUOTE] = ACTIONS(2510),
    [anon_sym_LR_DQUOTE] = ACTIONS(2510),
    [anon_sym_uR_DQUOTE] = ACTIONS(2510),
    [anon_sym_UR_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2510),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_requires] = ACTIONS(2508),
    [sym_this] = ACTIONS(2508),
    [anon_sym_discard] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
    [anon_sym_cbuffer] = ACTIONS(2508),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_include_token1] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym___cdecl] = ACTIONS(2512),
    [anon_sym___clrcall] = ACTIONS(2512),
    [anon_sym___stdcall] = ACTIONS(2512),
    [anon_sym___fastcall] = ACTIONS(2512),
    [anon_sym___thiscall] = ACTIONS(2512),
    [anon_sym___vectorcall] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_goto] = ACTIONS(2512),
    [anon_sym___try] = ACTIONS(2512),
    [anon_sym___leave] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2512),
    [anon_sym___alignof__] = ACTIONS(2512),
    [anon_sym___alignof] = ACTIONS(2512),
    [anon_sym__alignof] = ACTIONS(2512),
    [anon_sym_alignof] = ACTIONS(2512),
    [anon_sym__Alignof] = ACTIONS(2512),
    [anon_sym_offsetof] = ACTIONS(2512),
    [anon_sym__Generic] = ACTIONS(2512),
    [anon_sym_asm] = ACTIONS(2512),
    [anon_sym___asm__] = ACTIONS(2512),
    [anon_sym___asm] = ACTIONS(2512),
    [sym_number_literal] = ACTIONS(2514),
    [anon_sym_L_SQUOTE] = ACTIONS(2514),
    [anon_sym_u_SQUOTE] = ACTIONS(2514),
    [anon_sym_U_SQUOTE] = ACTIONS(2514),
    [anon_sym_u8_SQUOTE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_L_DQUOTE] = ACTIONS(2514),
    [anon_sym_u_DQUOTE] = ACTIONS(2514),
    [anon_sym_U_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [anon_sym_NULL] = ACTIONS(2512),
    [anon_sym_nullptr] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_concept] = ACTIONS(2512),
    [anon_sym_co_return] = ACTIONS(2512),
    [anon_sym_co_yield] = ACTIONS(2512),
    [anon_sym_R_DQUOTE] = ACTIONS(2514),
    [anon_sym_LR_DQUOTE] = ACTIONS(2514),
    [anon_sym_uR_DQUOTE] = ACTIONS(2514),
    [anon_sym_UR_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2514),
    [anon_sym_co_await] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_requires] = ACTIONS(2512),
    [sym_this] = ACTIONS(2512),
    [anon_sym_discard] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
    [anon_sym_cbuffer] = ACTIONS(2512),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2552),
    [aux_sym_preproc_include_token1] = ACTIONS(2552),
    [aux_sym_preproc_def_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token2] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_TILDE] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym___extension__] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_out] = ACTIONS(2552),
    [anon_sym_inout] = ACTIONS(2552),
    [anon_sym_virtual] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym___attribute__] = ACTIONS(2552),
    [anon_sym___attribute] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym___declspec] = ACTIONS(2552),
    [anon_sym___based] = ACTIONS(2552),
    [anon_sym___cdecl] = ACTIONS(2552),
    [anon_sym___clrcall] = ACTIONS(2552),
    [anon_sym___stdcall] = ACTIONS(2552),
    [anon_sym___fastcall] = ACTIONS(2552),
    [anon_sym___thiscall] = ACTIONS(2552),
    [anon_sym___vectorcall] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_signed] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym___inline] = ACTIONS(2552),
    [anon_sym___inline__] = ACTIONS(2552),
    [anon_sym___forceinline] = ACTIONS(2552),
    [anon_sym_thread_local] = ACTIONS(2552),
    [anon_sym___thread] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym___restrict__] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym__Noreturn] = ACTIONS(2552),
    [anon_sym_noreturn] = ACTIONS(2552),
    [anon_sym__Nonnull] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_constinit] = ACTIONS(2552),
    [anon_sym_consteval] = ACTIONS(2552),
    [anon_sym_alignas] = ACTIONS(2552),
    [anon_sym__Alignas] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_class] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym___try] = ACTIONS(2552),
    [anon_sym___leave] = ACTIONS(2552),
    [anon_sym_not] = ACTIONS(2552),
    [anon_sym_compl] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_sizeof] = ACTIONS(2552),
    [anon_sym___alignof__] = ACTIONS(2552),
    [anon_sym___alignof] = ACTIONS(2552),
    [anon_sym__alignof] = ACTIONS(2552),
    [anon_sym_alignof] = ACTIONS(2552),
    [anon_sym__Alignof] = ACTIONS(2552),
    [anon_sym_offsetof] = ACTIONS(2552),
    [anon_sym__Generic] = ACTIONS(2552),
    [anon_sym_asm] = ACTIONS(2552),
    [anon_sym___asm__] = ACTIONS(2552),
    [anon_sym___asm] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2554),
    [anon_sym_L_SQUOTE] = ACTIONS(2554),
    [anon_sym_u_SQUOTE] = ACTIONS(2554),
    [anon_sym_U_SQUOTE] = ACTIONS(2554),
    [anon_sym_u8_SQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_L_DQUOTE] = ACTIONS(2554),
    [anon_sym_u_DQUOTE] = ACTIONS(2554),
    [anon_sym_U_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8_DQUOTE] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [anon_sym_NULL] = ACTIONS(2552),
    [anon_sym_nullptr] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_decltype] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [anon_sym_delete] = ACTIONS(2552),
    [anon_sym_throw] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_static_assert] = ACTIONS(2552),
    [anon_sym_concept] = ACTIONS(2552),
    [anon_sym_co_return] = ACTIONS(2552),
    [anon_sym_co_yield] = ACTIONS(2552),
    [anon_sym_R_DQUOTE] = ACTIONS(2554),
    [anon_sym_LR_DQUOTE] = ACTIONS(2554),
    [anon_sym_uR_DQUOTE] = ACTIONS(2554),
    [anon_sym_UR_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2554),
    [anon_sym_co_await] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2552),
    [anon_sym_discard] = ACTIONS(2552),
    [anon_sym_precise] = ACTIONS(2552),
    [anon_sym_shared] = ACTIONS(2552),
    [anon_sym_groupshared] = ACTIONS(2552),
    [anon_sym_uniform] = ACTIONS(2552),
    [anon_sym_row_major] = ACTIONS(2552),
    [anon_sym_column_major] = ACTIONS(2552),
    [anon_sym_globallycoherent] = ACTIONS(2552),
    [anon_sym_centroid] = ACTIONS(2552),
    [anon_sym_noperspective] = ACTIONS(2552),
    [anon_sym_nointerpolation] = ACTIONS(2552),
    [anon_sym_sample] = ACTIONS(2552),
    [anon_sym_linear] = ACTIONS(2552),
    [anon_sym_snorm] = ACTIONS(2552),
    [anon_sym_unorm] = ACTIONS(2552),
    [anon_sym_point] = ACTIONS(2552),
    [anon_sym_line] = ACTIONS(2552),
    [anon_sym_triangleadj] = ACTIONS(2552),
    [anon_sym_lineadj] = ACTIONS(2552),
    [anon_sym_triangle] = ACTIONS(2552),
    [anon_sym_cbuffer] = ACTIONS(2552),
  },
  [598] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [599] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [600] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_include_token1] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym___cdecl] = ACTIONS(2516),
    [anon_sym___clrcall] = ACTIONS(2516),
    [anon_sym___stdcall] = ACTIONS(2516),
    [anon_sym___fastcall] = ACTIONS(2516),
    [anon_sym___thiscall] = ACTIONS(2516),
    [anon_sym___vectorcall] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_switch] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_do] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_goto] = ACTIONS(2516),
    [anon_sym___try] = ACTIONS(2516),
    [anon_sym___leave] = ACTIONS(2516),
    [anon_sym_not] = ACTIONS(2516),
    [anon_sym_compl] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2516),
    [anon_sym___alignof__] = ACTIONS(2516),
    [anon_sym___alignof] = ACTIONS(2516),
    [anon_sym__alignof] = ACTIONS(2516),
    [anon_sym_alignof] = ACTIONS(2516),
    [anon_sym__Alignof] = ACTIONS(2516),
    [anon_sym_offsetof] = ACTIONS(2516),
    [anon_sym__Generic] = ACTIONS(2516),
    [anon_sym_asm] = ACTIONS(2516),
    [anon_sym___asm__] = ACTIONS(2516),
    [anon_sym___asm] = ACTIONS(2516),
    [sym_number_literal] = ACTIONS(2518),
    [anon_sym_L_SQUOTE] = ACTIONS(2518),
    [anon_sym_u_SQUOTE] = ACTIONS(2518),
    [anon_sym_U_SQUOTE] = ACTIONS(2518),
    [anon_sym_u8_SQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_L_DQUOTE] = ACTIONS(2518),
    [anon_sym_u_DQUOTE] = ACTIONS(2518),
    [anon_sym_U_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [anon_sym_NULL] = ACTIONS(2516),
    [anon_sym_nullptr] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [anon_sym_delete] = ACTIONS(2516),
    [anon_sym_throw] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_concept] = ACTIONS(2516),
    [anon_sym_co_return] = ACTIONS(2516),
    [anon_sym_co_yield] = ACTIONS(2516),
    [anon_sym_R_DQUOTE] = ACTIONS(2518),
    [anon_sym_LR_DQUOTE] = ACTIONS(2518),
    [anon_sym_uR_DQUOTE] = ACTIONS(2518),
    [anon_sym_UR_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2518),
    [anon_sym_co_await] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2516),
    [anon_sym_requires] = ACTIONS(2516),
    [sym_this] = ACTIONS(2516),
    [anon_sym_discard] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
    [anon_sym_cbuffer] = ACTIONS(2516),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_include_token1] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym___cdecl] = ACTIONS(2433),
    [anon_sym___clrcall] = ACTIONS(2433),
    [anon_sym___stdcall] = ACTIONS(2433),
    [anon_sym___fastcall] = ACTIONS(2433),
    [anon_sym___thiscall] = ACTIONS(2433),
    [anon_sym___vectorcall] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_goto] = ACTIONS(2433),
    [anon_sym___try] = ACTIONS(2433),
    [anon_sym___leave] = ACTIONS(2433),
    [anon_sym_not] = ACTIONS(2433),
    [anon_sym_compl] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_sizeof] = ACTIONS(2433),
    [anon_sym___alignof__] = ACTIONS(2433),
    [anon_sym___alignof] = ACTIONS(2433),
    [anon_sym__alignof] = ACTIONS(2433),
    [anon_sym_alignof] = ACTIONS(2433),
    [anon_sym__Alignof] = ACTIONS(2433),
    [anon_sym_offsetof] = ACTIONS(2433),
    [anon_sym__Generic] = ACTIONS(2433),
    [anon_sym_asm] = ACTIONS(2433),
    [anon_sym___asm__] = ACTIONS(2433),
    [anon_sym___asm] = ACTIONS(2433),
    [sym_number_literal] = ACTIONS(2435),
    [anon_sym_L_SQUOTE] = ACTIONS(2435),
    [anon_sym_u_SQUOTE] = ACTIONS(2435),
    [anon_sym_U_SQUOTE] = ACTIONS(2435),
    [anon_sym_u8_SQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_L_DQUOTE] = ACTIONS(2435),
    [anon_sym_u_DQUOTE] = ACTIONS(2435),
    [anon_sym_U_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8_DQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [anon_sym_NULL] = ACTIONS(2433),
    [anon_sym_nullptr] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_concept] = ACTIONS(2433),
    [anon_sym_co_return] = ACTIONS(2433),
    [anon_sym_co_yield] = ACTIONS(2433),
    [anon_sym_R_DQUOTE] = ACTIONS(2435),
    [anon_sym_LR_DQUOTE] = ACTIONS(2435),
    [anon_sym_uR_DQUOTE] = ACTIONS(2435),
    [anon_sym_UR_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2435),
    [anon_sym_co_await] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_requires] = ACTIONS(2433),
    [sym_this] = ACTIONS(2433),
    [anon_sym_discard] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
    [anon_sym_cbuffer] = ACTIONS(2433),
  },
  [604] = {
    [sym_identifier] = ACTIONS(2664),
    [aux_sym_preproc_include_token1] = ACTIONS(2664),
    [aux_sym_preproc_def_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2664),
    [sym_preproc_directive] = ACTIONS(2664),
    [anon_sym_LPAREN2] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym___extension__] = ACTIONS(2664),
    [anon_sym_typedef] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2664),
    [anon_sym_out] = ACTIONS(2664),
    [anon_sym_inout] = ACTIONS(2664),
    [anon_sym_virtual] = ACTIONS(2664),
    [anon_sym_extern] = ACTIONS(2664),
    [anon_sym___attribute__] = ACTIONS(2664),
    [anon_sym___attribute] = ACTIONS(2664),
    [anon_sym_using] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2666),
    [anon_sym___declspec] = ACTIONS(2664),
    [anon_sym___based] = ACTIONS(2664),
    [anon_sym___cdecl] = ACTIONS(2664),
    [anon_sym___clrcall] = ACTIONS(2664),
    [anon_sym___stdcall] = ACTIONS(2664),
    [anon_sym___fastcall] = ACTIONS(2664),
    [anon_sym___thiscall] = ACTIONS(2664),
    [anon_sym___vectorcall] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_RBRACE] = ACTIONS(2666),
    [anon_sym_signed] = ACTIONS(2664),
    [anon_sym_unsigned] = ACTIONS(2664),
    [anon_sym_long] = ACTIONS(2664),
    [anon_sym_short] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_register] = ACTIONS(2664),
    [anon_sym_inline] = ACTIONS(2664),
    [anon_sym___inline] = ACTIONS(2664),
    [anon_sym___inline__] = ACTIONS(2664),
    [anon_sym___forceinline] = ACTIONS(2664),
    [anon_sym_thread_local] = ACTIONS(2664),
    [anon_sym___thread] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_constexpr] = ACTIONS(2664),
    [anon_sym_volatile] = ACTIONS(2664),
    [anon_sym_restrict] = ACTIONS(2664),
    [anon_sym___restrict__] = ACTIONS(2664),
    [anon_sym__Atomic] = ACTIONS(2664),
    [anon_sym__Noreturn] = ACTIONS(2664),
    [anon_sym_noreturn] = ACTIONS(2664),
    [anon_sym__Nonnull] = ACTIONS(2664),
    [anon_sym_mutable] = ACTIONS(2664),
    [anon_sym_constinit] = ACTIONS(2664),
    [anon_sym_consteval] = ACTIONS(2664),
    [anon_sym_alignas] = ACTIONS(2664),
    [anon_sym__Alignas] = ACTIONS(2664),
    [sym_primitive_type] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_struct] = ACTIONS(2664),
    [anon_sym_union] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_goto] = ACTIONS(2664),
    [anon_sym___try] = ACTIONS(2664),
    [anon_sym___leave] = ACTIONS(2664),
    [anon_sym_not] = ACTIONS(2664),
    [anon_sym_compl] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_sizeof] = ACTIONS(2664),
    [anon_sym___alignof__] = ACTIONS(2664),
    [anon_sym___alignof] = ACTIONS(2664),
    [anon_sym__alignof] = ACTIONS(2664),
    [anon_sym_alignof] = ACTIONS(2664),
    [anon_sym__Alignof] = ACTIONS(2664),
    [anon_sym_offsetof] = ACTIONS(2664),
    [anon_sym__Generic] = ACTIONS(2664),
    [anon_sym_asm] = ACTIONS(2664),
    [anon_sym___asm__] = ACTIONS(2664),
    [anon_sym___asm] = ACTIONS(2664),
    [sym_number_literal] = ACTIONS(2666),
    [anon_sym_L_SQUOTE] = ACTIONS(2666),
    [anon_sym_u_SQUOTE] = ACTIONS(2666),
    [anon_sym_U_SQUOTE] = ACTIONS(2666),
    [anon_sym_u8_SQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_L_DQUOTE] = ACTIONS(2666),
    [anon_sym_u_DQUOTE] = ACTIONS(2666),
    [anon_sym_U_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [anon_sym_NULL] = ACTIONS(2664),
    [anon_sym_nullptr] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2664),
    [anon_sym_decltype] = ACTIONS(2664),
    [anon_sym_explicit] = ACTIONS(2664),
    [anon_sym_typename] = ACTIONS(2664),
    [anon_sym_template] = ACTIONS(2664),
    [anon_sym_operator] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_static_assert] = ACTIONS(2664),
    [anon_sym_concept] = ACTIONS(2664),
    [anon_sym_co_return] = ACTIONS(2664),
    [anon_sym_co_yield] = ACTIONS(2664),
    [anon_sym_R_DQUOTE] = ACTIONS(2666),
    [anon_sym_LR_DQUOTE] = ACTIONS(2666),
    [anon_sym_uR_DQUOTE] = ACTIONS(2666),
    [anon_sym_UR_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2666),
    [anon_sym_co_await] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_requires] = ACTIONS(2664),
    [sym_this] = ACTIONS(2664),
    [anon_sym_discard] = ACTIONS(2664),
    [anon_sym_precise] = ACTIONS(2664),
    [anon_sym_shared] = ACTIONS(2664),
    [anon_sym_groupshared] = ACTIONS(2664),
    [anon_sym_uniform] = ACTIONS(2664),
    [anon_sym_row_major] = ACTIONS(2664),
    [anon_sym_column_major] = ACTIONS(2664),
    [anon_sym_globallycoherent] = ACTIONS(2664),
    [anon_sym_centroid] = ACTIONS(2664),
    [anon_sym_noperspective] = ACTIONS(2664),
    [anon_sym_nointerpolation] = ACTIONS(2664),
    [anon_sym_sample] = ACTIONS(2664),
    [anon_sym_linear] = ACTIONS(2664),
    [anon_sym_snorm] = ACTIONS(2664),
    [anon_sym_unorm] = ACTIONS(2664),
    [anon_sym_point] = ACTIONS(2664),
    [anon_sym_line] = ACTIONS(2664),
    [anon_sym_triangleadj] = ACTIONS(2664),
    [anon_sym_lineadj] = ACTIONS(2664),
    [anon_sym_triangle] = ACTIONS(2664),
    [anon_sym_cbuffer] = ACTIONS(2664),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_include_token1] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token2] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym___cdecl] = ACTIONS(2466),
    [anon_sym___clrcall] = ACTIONS(2466),
    [anon_sym___stdcall] = ACTIONS(2466),
    [anon_sym___fastcall] = ACTIONS(2466),
    [anon_sym___thiscall] = ACTIONS(2466),
    [anon_sym___vectorcall] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym___try] = ACTIONS(2466),
    [anon_sym___leave] = ACTIONS(2466),
    [anon_sym_not] = ACTIONS(2466),
    [anon_sym_compl] = ACTIONS(2466),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym___alignof__] = ACTIONS(2466),
    [anon_sym___alignof] = ACTIONS(2466),
    [anon_sym__alignof] = ACTIONS(2466),
    [anon_sym_alignof] = ACTIONS(2466),
    [anon_sym__Alignof] = ACTIONS(2466),
    [anon_sym_offsetof] = ACTIONS(2466),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2466),
    [anon_sym___asm__] = ACTIONS(2466),
    [anon_sym___asm] = ACTIONS(2466),
    [sym_number_literal] = ACTIONS(2468),
    [anon_sym_L_SQUOTE] = ACTIONS(2468),
    [anon_sym_u_SQUOTE] = ACTIONS(2468),
    [anon_sym_U_SQUOTE] = ACTIONS(2468),
    [anon_sym_u8_SQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym_L_DQUOTE] = ACTIONS(2468),
    [anon_sym_u_DQUOTE] = ACTIONS(2468),
    [anon_sym_U_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [anon_sym_NULL] = ACTIONS(2466),
    [anon_sym_nullptr] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_concept] = ACTIONS(2466),
    [anon_sym_co_return] = ACTIONS(2466),
    [anon_sym_co_yield] = ACTIONS(2466),
    [anon_sym_R_DQUOTE] = ACTIONS(2468),
    [anon_sym_LR_DQUOTE] = ACTIONS(2468),
    [anon_sym_uR_DQUOTE] = ACTIONS(2468),
    [anon_sym_UR_DQUOTE] = ACTIONS(2468),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2468),
    [anon_sym_co_await] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_requires] = ACTIONS(2466),
    [sym_this] = ACTIONS(2466),
    [anon_sym_discard] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
    [anon_sym_cbuffer] = ACTIONS(2466),
  },
  [606] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2668),
    [aux_sym_preproc_include_token1] = ACTIONS(2668),
    [aux_sym_preproc_def_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2668),
    [sym_preproc_directive] = ACTIONS(2668),
    [anon_sym_LPAREN2] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_STAR] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym___extension__] = ACTIONS(2668),
    [anon_sym_typedef] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2668),
    [anon_sym_out] = ACTIONS(2668),
    [anon_sym_inout] = ACTIONS(2668),
    [anon_sym_virtual] = ACTIONS(2668),
    [anon_sym_extern] = ACTIONS(2668),
    [anon_sym___attribute__] = ACTIONS(2668),
    [anon_sym___attribute] = ACTIONS(2668),
    [anon_sym_using] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2670),
    [anon_sym___declspec] = ACTIONS(2668),
    [anon_sym___based] = ACTIONS(2668),
    [anon_sym___cdecl] = ACTIONS(2668),
    [anon_sym___clrcall] = ACTIONS(2668),
    [anon_sym___stdcall] = ACTIONS(2668),
    [anon_sym___fastcall] = ACTIONS(2668),
    [anon_sym___thiscall] = ACTIONS(2668),
    [anon_sym___vectorcall] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_RBRACE] = ACTIONS(2670),
    [anon_sym_signed] = ACTIONS(2668),
    [anon_sym_unsigned] = ACTIONS(2668),
    [anon_sym_long] = ACTIONS(2668),
    [anon_sym_short] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_register] = ACTIONS(2668),
    [anon_sym_inline] = ACTIONS(2668),
    [anon_sym___inline] = ACTIONS(2668),
    [anon_sym___inline__] = ACTIONS(2668),
    [anon_sym___forceinline] = ACTIONS(2668),
    [anon_sym_thread_local] = ACTIONS(2668),
    [anon_sym___thread] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_constexpr] = ACTIONS(2668),
    [anon_sym_volatile] = ACTIONS(2668),
    [anon_sym_restrict] = ACTIONS(2668),
    [anon_sym___restrict__] = ACTIONS(2668),
    [anon_sym__Atomic] = ACTIONS(2668),
    [anon_sym__Noreturn] = ACTIONS(2668),
    [anon_sym_noreturn] = ACTIONS(2668),
    [anon_sym__Nonnull] = ACTIONS(2668),
    [anon_sym_mutable] = ACTIONS(2668),
    [anon_sym_constinit] = ACTIONS(2668),
    [anon_sym_consteval] = ACTIONS(2668),
    [anon_sym_alignas] = ACTIONS(2668),
    [anon_sym__Alignas] = ACTIONS(2668),
    [sym_primitive_type] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_struct] = ACTIONS(2668),
    [anon_sym_union] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_goto] = ACTIONS(2668),
    [anon_sym___try] = ACTIONS(2668),
    [anon_sym___leave] = ACTIONS(2668),
    [anon_sym_not] = ACTIONS(2668),
    [anon_sym_compl] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_sizeof] = ACTIONS(2668),
    [anon_sym___alignof__] = ACTIONS(2668),
    [anon_sym___alignof] = ACTIONS(2668),
    [anon_sym__alignof] = ACTIONS(2668),
    [anon_sym_alignof] = ACTIONS(2668),
    [anon_sym__Alignof] = ACTIONS(2668),
    [anon_sym_offsetof] = ACTIONS(2668),
    [anon_sym__Generic] = ACTIONS(2668),
    [anon_sym_asm] = ACTIONS(2668),
    [anon_sym___asm__] = ACTIONS(2668),
    [anon_sym___asm] = ACTIONS(2668),
    [sym_number_literal] = ACTIONS(2670),
    [anon_sym_L_SQUOTE] = ACTIONS(2670),
    [anon_sym_u_SQUOTE] = ACTIONS(2670),
    [anon_sym_U_SQUOTE] = ACTIONS(2670),
    [anon_sym_u8_SQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_L_DQUOTE] = ACTIONS(2670),
    [anon_sym_u_DQUOTE] = ACTIONS(2670),
    [anon_sym_U_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8_DQUOTE] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [anon_sym_NULL] = ACTIONS(2668),
    [anon_sym_nullptr] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2668),
    [anon_sym_decltype] = ACTIONS(2668),
    [anon_sym_explicit] = ACTIONS(2668),
    [anon_sym_typename] = ACTIONS(2668),
    [anon_sym_template] = ACTIONS(2668),
    [anon_sym_operator] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_static_assert] = ACTIONS(2668),
    [anon_sym_concept] = ACTIONS(2668),
    [anon_sym_co_return] = ACTIONS(2668),
    [anon_sym_co_yield] = ACTIONS(2668),
    [anon_sym_R_DQUOTE] = ACTIONS(2670),
    [anon_sym_LR_DQUOTE] = ACTIONS(2670),
    [anon_sym_uR_DQUOTE] = ACTIONS(2670),
    [anon_sym_UR_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2670),
    [anon_sym_co_await] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_requires] = ACTIONS(2668),
    [sym_this] = ACTIONS(2668),
    [anon_sym_discard] = ACTIONS(2668),
    [anon_sym_precise] = ACTIONS(2668),
    [anon_sym_shared] = ACTIONS(2668),
    [anon_sym_groupshared] = ACTIONS(2668),
    [anon_sym_uniform] = ACTIONS(2668),
    [anon_sym_row_major] = ACTIONS(2668),
    [anon_sym_column_major] = ACTIONS(2668),
    [anon_sym_globallycoherent] = ACTIONS(2668),
    [anon_sym_centroid] = ACTIONS(2668),
    [anon_sym_noperspective] = ACTIONS(2668),
    [anon_sym_nointerpolation] = ACTIONS(2668),
    [anon_sym_sample] = ACTIONS(2668),
    [anon_sym_linear] = ACTIONS(2668),
    [anon_sym_snorm] = ACTIONS(2668),
    [anon_sym_unorm] = ACTIONS(2668),
    [anon_sym_point] = ACTIONS(2668),
    [anon_sym_line] = ACTIONS(2668),
    [anon_sym_triangleadj] = ACTIONS(2668),
    [anon_sym_lineadj] = ACTIONS(2668),
    [anon_sym_triangle] = ACTIONS(2668),
    [anon_sym_cbuffer] = ACTIONS(2668),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2672),
    [aux_sym_preproc_include_token1] = ACTIONS(2672),
    [aux_sym_preproc_def_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2672),
    [sym_preproc_directive] = ACTIONS(2672),
    [anon_sym_LPAREN2] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym___extension__] = ACTIONS(2672),
    [anon_sym_typedef] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2672),
    [anon_sym_out] = ACTIONS(2672),
    [anon_sym_inout] = ACTIONS(2672),
    [anon_sym_virtual] = ACTIONS(2672),
    [anon_sym_extern] = ACTIONS(2672),
    [anon_sym___attribute__] = ACTIONS(2672),
    [anon_sym___attribute] = ACTIONS(2672),
    [anon_sym_using] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2674),
    [anon_sym___declspec] = ACTIONS(2672),
    [anon_sym___based] = ACTIONS(2672),
    [anon_sym___cdecl] = ACTIONS(2672),
    [anon_sym___clrcall] = ACTIONS(2672),
    [anon_sym___stdcall] = ACTIONS(2672),
    [anon_sym___fastcall] = ACTIONS(2672),
    [anon_sym___thiscall] = ACTIONS(2672),
    [anon_sym___vectorcall] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_RBRACE] = ACTIONS(2674),
    [anon_sym_signed] = ACTIONS(2672),
    [anon_sym_unsigned] = ACTIONS(2672),
    [anon_sym_long] = ACTIONS(2672),
    [anon_sym_short] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_register] = ACTIONS(2672),
    [anon_sym_inline] = ACTIONS(2672),
    [anon_sym___inline] = ACTIONS(2672),
    [anon_sym___inline__] = ACTIONS(2672),
    [anon_sym___forceinline] = ACTIONS(2672),
    [anon_sym_thread_local] = ACTIONS(2672),
    [anon_sym___thread] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_constexpr] = ACTIONS(2672),
    [anon_sym_volatile] = ACTIONS(2672),
    [anon_sym_restrict] = ACTIONS(2672),
    [anon_sym___restrict__] = ACTIONS(2672),
    [anon_sym__Atomic] = ACTIONS(2672),
    [anon_sym__Noreturn] = ACTIONS(2672),
    [anon_sym_noreturn] = ACTIONS(2672),
    [anon_sym__Nonnull] = ACTIONS(2672),
    [anon_sym_mutable] = ACTIONS(2672),
    [anon_sym_constinit] = ACTIONS(2672),
    [anon_sym_consteval] = ACTIONS(2672),
    [anon_sym_alignas] = ACTIONS(2672),
    [anon_sym__Alignas] = ACTIONS(2672),
    [sym_primitive_type] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_goto] = ACTIONS(2672),
    [anon_sym___try] = ACTIONS(2672),
    [anon_sym___leave] = ACTIONS(2672),
    [anon_sym_not] = ACTIONS(2672),
    [anon_sym_compl] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_sizeof] = ACTIONS(2672),
    [anon_sym___alignof__] = ACTIONS(2672),
    [anon_sym___alignof] = ACTIONS(2672),
    [anon_sym__alignof] = ACTIONS(2672),
    [anon_sym_alignof] = ACTIONS(2672),
    [anon_sym__Alignof] = ACTIONS(2672),
    [anon_sym_offsetof] = ACTIONS(2672),
    [anon_sym__Generic] = ACTIONS(2672),
    [anon_sym_asm] = ACTIONS(2672),
    [anon_sym___asm__] = ACTIONS(2672),
    [anon_sym___asm] = ACTIONS(2672),
    [sym_number_literal] = ACTIONS(2674),
    [anon_sym_L_SQUOTE] = ACTIONS(2674),
    [anon_sym_u_SQUOTE] = ACTIONS(2674),
    [anon_sym_U_SQUOTE] = ACTIONS(2674),
    [anon_sym_u8_SQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_L_DQUOTE] = ACTIONS(2674),
    [anon_sym_u_DQUOTE] = ACTIONS(2674),
    [anon_sym_U_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8_DQUOTE] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [anon_sym_NULL] = ACTIONS(2672),
    [anon_sym_nullptr] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2672),
    [anon_sym_decltype] = ACTIONS(2672),
    [anon_sym_explicit] = ACTIONS(2672),
    [anon_sym_typename] = ACTIONS(2672),
    [anon_sym_template] = ACTIONS(2672),
    [anon_sym_operator] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_static_assert] = ACTIONS(2672),
    [anon_sym_concept] = ACTIONS(2672),
    [anon_sym_co_return] = ACTIONS(2672),
    [anon_sym_co_yield] = ACTIONS(2672),
    [anon_sym_R_DQUOTE] = ACTIONS(2674),
    [anon_sym_LR_DQUOTE] = ACTIONS(2674),
    [anon_sym_uR_DQUOTE] = ACTIONS(2674),
    [anon_sym_UR_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2674),
    [anon_sym_co_await] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_requires] = ACTIONS(2672),
    [sym_this] = ACTIONS(2672),
    [anon_sym_discard] = ACTIONS(2672),
    [anon_sym_precise] = ACTIONS(2672),
    [anon_sym_shared] = ACTIONS(2672),
    [anon_sym_groupshared] = ACTIONS(2672),
    [anon_sym_uniform] = ACTIONS(2672),
    [anon_sym_row_major] = ACTIONS(2672),
    [anon_sym_column_major] = ACTIONS(2672),
    [anon_sym_globallycoherent] = ACTIONS(2672),
    [anon_sym_centroid] = ACTIONS(2672),
    [anon_sym_noperspective] = ACTIONS(2672),
    [anon_sym_nointerpolation] = ACTIONS(2672),
    [anon_sym_sample] = ACTIONS(2672),
    [anon_sym_linear] = ACTIONS(2672),
    [anon_sym_snorm] = ACTIONS(2672),
    [anon_sym_unorm] = ACTIONS(2672),
    [anon_sym_point] = ACTIONS(2672),
    [anon_sym_line] = ACTIONS(2672),
    [anon_sym_triangleadj] = ACTIONS(2672),
    [anon_sym_lineadj] = ACTIONS(2672),
    [anon_sym_triangle] = ACTIONS(2672),
    [anon_sym_cbuffer] = ACTIONS(2672),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym___try] = ACTIONS(2504),
    [anon_sym___leave] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [anon_sym___asm] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym_discard] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
    [anon_sym_cbuffer] = ACTIONS(2504),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_include_token1] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token2] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym___cdecl] = ACTIONS(2508),
    [anon_sym___clrcall] = ACTIONS(2508),
    [anon_sym___stdcall] = ACTIONS(2508),
    [anon_sym___fastcall] = ACTIONS(2508),
    [anon_sym___thiscall] = ACTIONS(2508),
    [anon_sym___vectorcall] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_goto] = ACTIONS(2508),
    [anon_sym___try] = ACTIONS(2508),
    [anon_sym___leave] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2508),
    [anon_sym_compl] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2508),
    [anon_sym___alignof__] = ACTIONS(2508),
    [anon_sym___alignof] = ACTIONS(2508),
    [anon_sym__alignof] = ACTIONS(2508),
    [anon_sym_alignof] = ACTIONS(2508),
    [anon_sym__Alignof] = ACTIONS(2508),
    [anon_sym_offsetof] = ACTIONS(2508),
    [anon_sym__Generic] = ACTIONS(2508),
    [anon_sym_asm] = ACTIONS(2508),
    [anon_sym___asm__] = ACTIONS(2508),
    [anon_sym___asm] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(2510),
    [anon_sym_L_SQUOTE] = ACTIONS(2510),
    [anon_sym_u_SQUOTE] = ACTIONS(2510),
    [anon_sym_U_SQUOTE] = ACTIONS(2510),
    [anon_sym_u8_SQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_L_DQUOTE] = ACTIONS(2510),
    [anon_sym_u_DQUOTE] = ACTIONS(2510),
    [anon_sym_U_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [anon_sym_NULL] = ACTIONS(2508),
    [anon_sym_nullptr] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_concept] = ACTIONS(2508),
    [anon_sym_co_return] = ACTIONS(2508),
    [anon_sym_co_yield] = ACTIONS(2508),
    [anon_sym_R_DQUOTE] = ACTIONS(2510),
    [anon_sym_LR_DQUOTE] = ACTIONS(2510),
    [anon_sym_uR_DQUOTE] = ACTIONS(2510),
    [anon_sym_UR_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2510),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_requires] = ACTIONS(2508),
    [sym_this] = ACTIONS(2508),
    [anon_sym_discard] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
    [anon_sym_cbuffer] = ACTIONS(2508),
  },
  [611] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_include_token1] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token2] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym___cdecl] = ACTIONS(2516),
    [anon_sym___clrcall] = ACTIONS(2516),
    [anon_sym___stdcall] = ACTIONS(2516),
    [anon_sym___fastcall] = ACTIONS(2516),
    [anon_sym___thiscall] = ACTIONS(2516),
    [anon_sym___vectorcall] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_switch] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_do] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_goto] = ACTIONS(2516),
    [anon_sym___try] = ACTIONS(2516),
    [anon_sym___leave] = ACTIONS(2516),
    [anon_sym_not] = ACTIONS(2516),
    [anon_sym_compl] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2516),
    [anon_sym___alignof__] = ACTIONS(2516),
    [anon_sym___alignof] = ACTIONS(2516),
    [anon_sym__alignof] = ACTIONS(2516),
    [anon_sym_alignof] = ACTIONS(2516),
    [anon_sym__Alignof] = ACTIONS(2516),
    [anon_sym_offsetof] = ACTIONS(2516),
    [anon_sym__Generic] = ACTIONS(2516),
    [anon_sym_asm] = ACTIONS(2516),
    [anon_sym___asm__] = ACTIONS(2516),
    [anon_sym___asm] = ACTIONS(2516),
    [sym_number_literal] = ACTIONS(2518),
    [anon_sym_L_SQUOTE] = ACTIONS(2518),
    [anon_sym_u_SQUOTE] = ACTIONS(2518),
    [anon_sym_U_SQUOTE] = ACTIONS(2518),
    [anon_sym_u8_SQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_L_DQUOTE] = ACTIONS(2518),
    [anon_sym_u_DQUOTE] = ACTIONS(2518),
    [anon_sym_U_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [anon_sym_NULL] = ACTIONS(2516),
    [anon_sym_nullptr] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [anon_sym_delete] = ACTIONS(2516),
    [anon_sym_throw] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_concept] = ACTIONS(2516),
    [anon_sym_co_return] = ACTIONS(2516),
    [anon_sym_co_yield] = ACTIONS(2516),
    [anon_sym_R_DQUOTE] = ACTIONS(2518),
    [anon_sym_LR_DQUOTE] = ACTIONS(2518),
    [anon_sym_uR_DQUOTE] = ACTIONS(2518),
    [anon_sym_UR_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2518),
    [anon_sym_co_await] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2516),
    [anon_sym_requires] = ACTIONS(2516),
    [sym_this] = ACTIONS(2516),
    [anon_sym_discard] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
    [anon_sym_cbuffer] = ACTIONS(2516),
  },
  [612] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_include_token1] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token2] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym___cdecl] = ACTIONS(2520),
    [anon_sym___clrcall] = ACTIONS(2520),
    [anon_sym___stdcall] = ACTIONS(2520),
    [anon_sym___fastcall] = ACTIONS(2520),
    [anon_sym___thiscall] = ACTIONS(2520),
    [anon_sym___vectorcall] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_switch] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_do] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_goto] = ACTIONS(2520),
    [anon_sym___try] = ACTIONS(2520),
    [anon_sym___leave] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2520),
    [anon_sym_compl] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2520),
    [anon_sym___alignof__] = ACTIONS(2520),
    [anon_sym___alignof] = ACTIONS(2520),
    [anon_sym__alignof] = ACTIONS(2520),
    [anon_sym_alignof] = ACTIONS(2520),
    [anon_sym__Alignof] = ACTIONS(2520),
    [anon_sym_offsetof] = ACTIONS(2520),
    [anon_sym__Generic] = ACTIONS(2520),
    [anon_sym_asm] = ACTIONS(2520),
    [anon_sym___asm__] = ACTIONS(2520),
    [anon_sym___asm] = ACTIONS(2520),
    [sym_number_literal] = ACTIONS(2522),
    [anon_sym_L_SQUOTE] = ACTIONS(2522),
    [anon_sym_u_SQUOTE] = ACTIONS(2522),
    [anon_sym_U_SQUOTE] = ACTIONS(2522),
    [anon_sym_u8_SQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_L_DQUOTE] = ACTIONS(2522),
    [anon_sym_u_DQUOTE] = ACTIONS(2522),
    [anon_sym_U_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8_DQUOTE] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [anon_sym_NULL] = ACTIONS(2520),
    [anon_sym_nullptr] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(2520),
    [anon_sym_throw] = ACTIONS(2520),
    [anon_sym_namespace] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_concept] = ACTIONS(2520),
    [anon_sym_co_return] = ACTIONS(2520),
    [anon_sym_co_yield] = ACTIONS(2520),
    [anon_sym_R_DQUOTE] = ACTIONS(2522),
    [anon_sym_LR_DQUOTE] = ACTIONS(2522),
    [anon_sym_uR_DQUOTE] = ACTIONS(2522),
    [anon_sym_UR_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2522),
    [anon_sym_co_await] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_requires] = ACTIONS(2520),
    [sym_this] = ACTIONS(2520),
    [anon_sym_discard] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
    [anon_sym_cbuffer] = ACTIONS(2520),
  },
  [613] = {
    [sym_preproc_def] = STATE(613),
    [sym_preproc_function_def] = STATE(613),
    [sym_preproc_call] = STATE(613),
    [sym_preproc_if_in_field_declaration_list] = STATE(613),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(613),
    [sym_type_definition] = STATE(613),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5742),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(613),
    [sym_field_declaration] = STATE(613),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(613),
    [sym_operator_cast] = STATE(7046),
    [sym_inline_method_definition] = STATE(613),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(613),
    [sym_operator_cast_declaration] = STATE(613),
    [sym_constructor_or_destructor_definition] = STATE(613),
    [sym_constructor_or_destructor_declaration] = STATE(613),
    [sym_friend_declaration] = STATE(613),
    [sym_access_specifier] = STATE(9123),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(613),
    [sym_alias_declaration] = STATE(613),
    [sym_static_assert_declaration] = STATE(613),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(613),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7251),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(2874),
    [aux_sym_preproc_def_token1] = ACTIONS(2877),
    [aux_sym_preproc_if_token1] = ACTIONS(2880),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2885),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2885),
    [aux_sym_preproc_else_token1] = ACTIONS(2883),
    [aux_sym_preproc_elif_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2883),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2883),
    [sym_preproc_directive] = ACTIONS(2888),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym___extension__] = ACTIONS(2909),
    [anon_sym_typedef] = ACTIONS(2912),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2921),
    [anon_sym___attribute] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2933),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(2948),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym__Nonnull] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2969),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_template] = ACTIONS(2984),
    [anon_sym_operator] = ACTIONS(2987),
    [anon_sym_friend] = ACTIONS(2990),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_static_assert] = ACTIONS(2993),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
  },
  [614] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_include_token1] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token2] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym___cdecl] = ACTIONS(2532),
    [anon_sym___clrcall] = ACTIONS(2532),
    [anon_sym___stdcall] = ACTIONS(2532),
    [anon_sym___fastcall] = ACTIONS(2532),
    [anon_sym___thiscall] = ACTIONS(2532),
    [anon_sym___vectorcall] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_goto] = ACTIONS(2532),
    [anon_sym___try] = ACTIONS(2532),
    [anon_sym___leave] = ACTIONS(2532),
    [anon_sym_not] = ACTIONS(2532),
    [anon_sym_compl] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2532),
    [anon_sym___alignof__] = ACTIONS(2532),
    [anon_sym___alignof] = ACTIONS(2532),
    [anon_sym__alignof] = ACTIONS(2532),
    [anon_sym_alignof] = ACTIONS(2532),
    [anon_sym__Alignof] = ACTIONS(2532),
    [anon_sym_offsetof] = ACTIONS(2532),
    [anon_sym__Generic] = ACTIONS(2532),
    [anon_sym_asm] = ACTIONS(2532),
    [anon_sym___asm__] = ACTIONS(2532),
    [anon_sym___asm] = ACTIONS(2532),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [anon_sym_NULL] = ACTIONS(2532),
    [anon_sym_nullptr] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_concept] = ACTIONS(2532),
    [anon_sym_co_return] = ACTIONS(2532),
    [anon_sym_co_yield] = ACTIONS(2532),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_requires] = ACTIONS(2532),
    [sym_this] = ACTIONS(2532),
    [anon_sym_discard] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
    [anon_sym_cbuffer] = ACTIONS(2532),
  },
  [615] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_include_token1] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token2] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym___cdecl] = ACTIONS(2540),
    [anon_sym___clrcall] = ACTIONS(2540),
    [anon_sym___stdcall] = ACTIONS(2540),
    [anon_sym___fastcall] = ACTIONS(2540),
    [anon_sym___thiscall] = ACTIONS(2540),
    [anon_sym___vectorcall] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_goto] = ACTIONS(2540),
    [anon_sym___try] = ACTIONS(2540),
    [anon_sym___leave] = ACTIONS(2540),
    [anon_sym_not] = ACTIONS(2540),
    [anon_sym_compl] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2540),
    [anon_sym___alignof__] = ACTIONS(2540),
    [anon_sym___alignof] = ACTIONS(2540),
    [anon_sym__alignof] = ACTIONS(2540),
    [anon_sym_alignof] = ACTIONS(2540),
    [anon_sym__Alignof] = ACTIONS(2540),
    [anon_sym_offsetof] = ACTIONS(2540),
    [anon_sym__Generic] = ACTIONS(2540),
    [anon_sym_asm] = ACTIONS(2540),
    [anon_sym___asm__] = ACTIONS(2540),
    [anon_sym___asm] = ACTIONS(2540),
    [sym_number_literal] = ACTIONS(2542),
    [anon_sym_L_SQUOTE] = ACTIONS(2542),
    [anon_sym_u_SQUOTE] = ACTIONS(2542),
    [anon_sym_U_SQUOTE] = ACTIONS(2542),
    [anon_sym_u8_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_L_DQUOTE] = ACTIONS(2542),
    [anon_sym_u_DQUOTE] = ACTIONS(2542),
    [anon_sym_U_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8_DQUOTE] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2542),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_concept] = ACTIONS(2540),
    [anon_sym_co_return] = ACTIONS(2540),
    [anon_sym_co_yield] = ACTIONS(2540),
    [anon_sym_R_DQUOTE] = ACTIONS(2542),
    [anon_sym_LR_DQUOTE] = ACTIONS(2542),
    [anon_sym_uR_DQUOTE] = ACTIONS(2542),
    [anon_sym_UR_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2542),
    [anon_sym_co_await] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_requires] = ACTIONS(2540),
    [sym_this] = ACTIONS(2540),
    [anon_sym_discard] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
    [anon_sym_cbuffer] = ACTIONS(2540),
  },
  [616] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_include_token1] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym___cdecl] = ACTIONS(2612),
    [anon_sym___clrcall] = ACTIONS(2612),
    [anon_sym___stdcall] = ACTIONS(2612),
    [anon_sym___fastcall] = ACTIONS(2612),
    [anon_sym___thiscall] = ACTIONS(2612),
    [anon_sym___vectorcall] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_switch] = ACTIONS(2612),
    [anon_sym_case] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_do] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_goto] = ACTIONS(2612),
    [anon_sym___try] = ACTIONS(2612),
    [anon_sym___leave] = ACTIONS(2612),
    [anon_sym_not] = ACTIONS(2612),
    [anon_sym_compl] = ACTIONS(2612),
    [anon_sym_DASH_DASH] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2614),
    [anon_sym_sizeof] = ACTIONS(2612),
    [anon_sym___alignof__] = ACTIONS(2612),
    [anon_sym___alignof] = ACTIONS(2612),
    [anon_sym__alignof] = ACTIONS(2612),
    [anon_sym_alignof] = ACTIONS(2612),
    [anon_sym__Alignof] = ACTIONS(2612),
    [anon_sym_offsetof] = ACTIONS(2612),
    [anon_sym__Generic] = ACTIONS(2612),
    [anon_sym_asm] = ACTIONS(2612),
    [anon_sym___asm__] = ACTIONS(2612),
    [anon_sym___asm] = ACTIONS(2612),
    [sym_number_literal] = ACTIONS(2614),
    [anon_sym_L_SQUOTE] = ACTIONS(2614),
    [anon_sym_u_SQUOTE] = ACTIONS(2614),
    [anon_sym_U_SQUOTE] = ACTIONS(2614),
    [anon_sym_u8_SQUOTE] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_L_DQUOTE] = ACTIONS(2614),
    [anon_sym_u_DQUOTE] = ACTIONS(2614),
    [anon_sym_U_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8_DQUOTE] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [anon_sym_NULL] = ACTIONS(2612),
    [anon_sym_nullptr] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_delete] = ACTIONS(2612),
    [anon_sym_throw] = ACTIONS(2612),
    [anon_sym_namespace] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_concept] = ACTIONS(2612),
    [anon_sym_co_return] = ACTIONS(2612),
    [anon_sym_co_yield] = ACTIONS(2612),
    [anon_sym_R_DQUOTE] = ACTIONS(2614),
    [anon_sym_LR_DQUOTE] = ACTIONS(2614),
    [anon_sym_uR_DQUOTE] = ACTIONS(2614),
    [anon_sym_UR_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2614),
    [anon_sym_co_await] = ACTIONS(2612),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_requires] = ACTIONS(2612),
    [sym_this] = ACTIONS(2612),
    [anon_sym_discard] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
    [anon_sym_cbuffer] = ACTIONS(2612),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_include_token1] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token2] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym___cdecl] = ACTIONS(2548),
    [anon_sym___clrcall] = ACTIONS(2548),
    [anon_sym___stdcall] = ACTIONS(2548),
    [anon_sym___fastcall] = ACTIONS(2548),
    [anon_sym___thiscall] = ACTIONS(2548),
    [anon_sym___vectorcall] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_switch] = ACTIONS(2548),
    [anon_sym_case] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_do] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_goto] = ACTIONS(2548),
    [anon_sym___try] = ACTIONS(2548),
    [anon_sym___leave] = ACTIONS(2548),
    [anon_sym_not] = ACTIONS(2548),
    [anon_sym_compl] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2548),
    [anon_sym___alignof__] = ACTIONS(2548),
    [anon_sym___alignof] = ACTIONS(2548),
    [anon_sym__alignof] = ACTIONS(2548),
    [anon_sym_alignof] = ACTIONS(2548),
    [anon_sym__Alignof] = ACTIONS(2548),
    [anon_sym_offsetof] = ACTIONS(2548),
    [anon_sym__Generic] = ACTIONS(2548),
    [anon_sym_asm] = ACTIONS(2548),
    [anon_sym___asm__] = ACTIONS(2548),
    [anon_sym___asm] = ACTIONS(2548),
    [sym_number_literal] = ACTIONS(2550),
    [anon_sym_L_SQUOTE] = ACTIONS(2550),
    [anon_sym_u_SQUOTE] = ACTIONS(2550),
    [anon_sym_U_SQUOTE] = ACTIONS(2550),
    [anon_sym_u8_SQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_L_DQUOTE] = ACTIONS(2550),
    [anon_sym_u_DQUOTE] = ACTIONS(2550),
    [anon_sym_U_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8_DQUOTE] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [anon_sym_NULL] = ACTIONS(2548),
    [anon_sym_nullptr] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [anon_sym_delete] = ACTIONS(2548),
    [anon_sym_throw] = ACTIONS(2548),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_concept] = ACTIONS(2548),
    [anon_sym_co_return] = ACTIONS(2548),
    [anon_sym_co_yield] = ACTIONS(2548),
    [anon_sym_R_DQUOTE] = ACTIONS(2550),
    [anon_sym_LR_DQUOTE] = ACTIONS(2550),
    [anon_sym_uR_DQUOTE] = ACTIONS(2550),
    [anon_sym_UR_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2550),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_requires] = ACTIONS(2548),
    [sym_this] = ACTIONS(2548),
    [anon_sym_discard] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
    [anon_sym_cbuffer] = ACTIONS(2548),
  },
  [618] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_include_token1] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym___cdecl] = ACTIONS(2520),
    [anon_sym___clrcall] = ACTIONS(2520),
    [anon_sym___stdcall] = ACTIONS(2520),
    [anon_sym___fastcall] = ACTIONS(2520),
    [anon_sym___thiscall] = ACTIONS(2520),
    [anon_sym___vectorcall] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_switch] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_do] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_goto] = ACTIONS(2520),
    [anon_sym___try] = ACTIONS(2520),
    [anon_sym___leave] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2520),
    [anon_sym_compl] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2520),
    [anon_sym___alignof__] = ACTIONS(2520),
    [anon_sym___alignof] = ACTIONS(2520),
    [anon_sym__alignof] = ACTIONS(2520),
    [anon_sym_alignof] = ACTIONS(2520),
    [anon_sym__Alignof] = ACTIONS(2520),
    [anon_sym_offsetof] = ACTIONS(2520),
    [anon_sym__Generic] = ACTIONS(2520),
    [anon_sym_asm] = ACTIONS(2520),
    [anon_sym___asm__] = ACTIONS(2520),
    [anon_sym___asm] = ACTIONS(2520),
    [sym_number_literal] = ACTIONS(2522),
    [anon_sym_L_SQUOTE] = ACTIONS(2522),
    [anon_sym_u_SQUOTE] = ACTIONS(2522),
    [anon_sym_U_SQUOTE] = ACTIONS(2522),
    [anon_sym_u8_SQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_L_DQUOTE] = ACTIONS(2522),
    [anon_sym_u_DQUOTE] = ACTIONS(2522),
    [anon_sym_U_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8_DQUOTE] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [anon_sym_NULL] = ACTIONS(2520),
    [anon_sym_nullptr] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(2520),
    [anon_sym_throw] = ACTIONS(2520),
    [anon_sym_namespace] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_concept] = ACTIONS(2520),
    [anon_sym_co_return] = ACTIONS(2520),
    [anon_sym_co_yield] = ACTIONS(2520),
    [anon_sym_R_DQUOTE] = ACTIONS(2522),
    [anon_sym_LR_DQUOTE] = ACTIONS(2522),
    [anon_sym_uR_DQUOTE] = ACTIONS(2522),
    [anon_sym_UR_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2522),
    [anon_sym_co_await] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_requires] = ACTIONS(2520),
    [sym_this] = ACTIONS(2520),
    [anon_sym_discard] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
    [anon_sym_cbuffer] = ACTIONS(2520),
  },
  [619] = {
    [sym_identifier] = ACTIONS(2680),
    [aux_sym_preproc_include_token1] = ACTIONS(2680),
    [aux_sym_preproc_def_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2680),
    [sym_preproc_directive] = ACTIONS(2680),
    [anon_sym_LPAREN2] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym___extension__] = ACTIONS(2680),
    [anon_sym_typedef] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2680),
    [anon_sym_out] = ACTIONS(2680),
    [anon_sym_inout] = ACTIONS(2680),
    [anon_sym_virtual] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(2680),
    [anon_sym___attribute__] = ACTIONS(2680),
    [anon_sym___attribute] = ACTIONS(2680),
    [anon_sym_using] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2682),
    [anon_sym___declspec] = ACTIONS(2680),
    [anon_sym___based] = ACTIONS(2680),
    [anon_sym___cdecl] = ACTIONS(2680),
    [anon_sym___clrcall] = ACTIONS(2680),
    [anon_sym___stdcall] = ACTIONS(2680),
    [anon_sym___fastcall] = ACTIONS(2680),
    [anon_sym___thiscall] = ACTIONS(2680),
    [anon_sym___vectorcall] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_RBRACE] = ACTIONS(2682),
    [anon_sym_signed] = ACTIONS(2680),
    [anon_sym_unsigned] = ACTIONS(2680),
    [anon_sym_long] = ACTIONS(2680),
    [anon_sym_short] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_register] = ACTIONS(2680),
    [anon_sym_inline] = ACTIONS(2680),
    [anon_sym___inline] = ACTIONS(2680),
    [anon_sym___inline__] = ACTIONS(2680),
    [anon_sym___forceinline] = ACTIONS(2680),
    [anon_sym_thread_local] = ACTIONS(2680),
    [anon_sym___thread] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_constexpr] = ACTIONS(2680),
    [anon_sym_volatile] = ACTIONS(2680),
    [anon_sym_restrict] = ACTIONS(2680),
    [anon_sym___restrict__] = ACTIONS(2680),
    [anon_sym__Atomic] = ACTIONS(2680),
    [anon_sym__Noreturn] = ACTIONS(2680),
    [anon_sym_noreturn] = ACTIONS(2680),
    [anon_sym__Nonnull] = ACTIONS(2680),
    [anon_sym_mutable] = ACTIONS(2680),
    [anon_sym_constinit] = ACTIONS(2680),
    [anon_sym_consteval] = ACTIONS(2680),
    [anon_sym_alignas] = ACTIONS(2680),
    [anon_sym__Alignas] = ACTIONS(2680),
    [sym_primitive_type] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [anon_sym_class] = ACTIONS(2680),
    [anon_sym_struct] = ACTIONS(2680),
    [anon_sym_union] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_switch] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_do] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_goto] = ACTIONS(2680),
    [anon_sym___try] = ACTIONS(2680),
    [anon_sym___leave] = ACTIONS(2680),
    [anon_sym_not] = ACTIONS(2680),
    [anon_sym_compl] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_sizeof] = ACTIONS(2680),
    [anon_sym___alignof__] = ACTIONS(2680),
    [anon_sym___alignof] = ACTIONS(2680),
    [anon_sym__alignof] = ACTIONS(2680),
    [anon_sym_alignof] = ACTIONS(2680),
    [anon_sym__Alignof] = ACTIONS(2680),
    [anon_sym_offsetof] = ACTIONS(2680),
    [anon_sym__Generic] = ACTIONS(2680),
    [anon_sym_asm] = ACTIONS(2680),
    [anon_sym___asm__] = ACTIONS(2680),
    [anon_sym___asm] = ACTIONS(2680),
    [sym_number_literal] = ACTIONS(2682),
    [anon_sym_L_SQUOTE] = ACTIONS(2682),
    [anon_sym_u_SQUOTE] = ACTIONS(2682),
    [anon_sym_U_SQUOTE] = ACTIONS(2682),
    [anon_sym_u8_SQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_L_DQUOTE] = ACTIONS(2682),
    [anon_sym_u_DQUOTE] = ACTIONS(2682),
    [anon_sym_U_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8_DQUOTE] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [anon_sym_NULL] = ACTIONS(2680),
    [anon_sym_nullptr] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2680),
    [anon_sym_decltype] = ACTIONS(2680),
    [anon_sym_explicit] = ACTIONS(2680),
    [anon_sym_typename] = ACTIONS(2680),
    [anon_sym_template] = ACTIONS(2680),
    [anon_sym_operator] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [anon_sym_delete] = ACTIONS(2680),
    [anon_sym_throw] = ACTIONS(2680),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_static_assert] = ACTIONS(2680),
    [anon_sym_concept] = ACTIONS(2680),
    [anon_sym_co_return] = ACTIONS(2680),
    [anon_sym_co_yield] = ACTIONS(2680),
    [anon_sym_R_DQUOTE] = ACTIONS(2682),
    [anon_sym_LR_DQUOTE] = ACTIONS(2682),
    [anon_sym_uR_DQUOTE] = ACTIONS(2682),
    [anon_sym_UR_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2682),
    [anon_sym_co_await] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2680),
    [anon_sym_requires] = ACTIONS(2680),
    [sym_this] = ACTIONS(2680),
    [anon_sym_discard] = ACTIONS(2680),
    [anon_sym_precise] = ACTIONS(2680),
    [anon_sym_shared] = ACTIONS(2680),
    [anon_sym_groupshared] = ACTIONS(2680),
    [anon_sym_uniform] = ACTIONS(2680),
    [anon_sym_row_major] = ACTIONS(2680),
    [anon_sym_column_major] = ACTIONS(2680),
    [anon_sym_globallycoherent] = ACTIONS(2680),
    [anon_sym_centroid] = ACTIONS(2680),
    [anon_sym_noperspective] = ACTIONS(2680),
    [anon_sym_nointerpolation] = ACTIONS(2680),
    [anon_sym_sample] = ACTIONS(2680),
    [anon_sym_linear] = ACTIONS(2680),
    [anon_sym_snorm] = ACTIONS(2680),
    [anon_sym_unorm] = ACTIONS(2680),
    [anon_sym_point] = ACTIONS(2680),
    [anon_sym_line] = ACTIONS(2680),
    [anon_sym_triangleadj] = ACTIONS(2680),
    [anon_sym_lineadj] = ACTIONS(2680),
    [anon_sym_triangle] = ACTIONS(2680),
    [anon_sym_cbuffer] = ACTIONS(2680),
  },
  [620] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_include_token1] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym___cdecl] = ACTIONS(2684),
    [anon_sym___clrcall] = ACTIONS(2684),
    [anon_sym___stdcall] = ACTIONS(2684),
    [anon_sym___fastcall] = ACTIONS(2684),
    [anon_sym___thiscall] = ACTIONS(2684),
    [anon_sym___vectorcall] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_goto] = ACTIONS(2684),
    [anon_sym___try] = ACTIONS(2684),
    [anon_sym___leave] = ACTIONS(2684),
    [anon_sym_not] = ACTIONS(2684),
    [anon_sym_compl] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_sizeof] = ACTIONS(2684),
    [anon_sym___alignof__] = ACTIONS(2684),
    [anon_sym___alignof] = ACTIONS(2684),
    [anon_sym__alignof] = ACTIONS(2684),
    [anon_sym_alignof] = ACTIONS(2684),
    [anon_sym__Alignof] = ACTIONS(2684),
    [anon_sym_offsetof] = ACTIONS(2684),
    [anon_sym__Generic] = ACTIONS(2684),
    [anon_sym_asm] = ACTIONS(2684),
    [anon_sym___asm__] = ACTIONS(2684),
    [anon_sym___asm] = ACTIONS(2684),
    [sym_number_literal] = ACTIONS(2686),
    [anon_sym_L_SQUOTE] = ACTIONS(2686),
    [anon_sym_u_SQUOTE] = ACTIONS(2686),
    [anon_sym_U_SQUOTE] = ACTIONS(2686),
    [anon_sym_u8_SQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_L_DQUOTE] = ACTIONS(2686),
    [anon_sym_u_DQUOTE] = ACTIONS(2686),
    [anon_sym_U_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8_DQUOTE] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [anon_sym_NULL] = ACTIONS(2684),
    [anon_sym_nullptr] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_concept] = ACTIONS(2684),
    [anon_sym_co_return] = ACTIONS(2684),
    [anon_sym_co_yield] = ACTIONS(2684),
    [anon_sym_R_DQUOTE] = ACTIONS(2686),
    [anon_sym_LR_DQUOTE] = ACTIONS(2686),
    [anon_sym_uR_DQUOTE] = ACTIONS(2686),
    [anon_sym_UR_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2686),
    [anon_sym_co_await] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_requires] = ACTIONS(2684),
    [sym_this] = ACTIONS(2684),
    [anon_sym_discard] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
    [anon_sym_cbuffer] = ACTIONS(2684),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_include_token1] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token2] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym___cdecl] = ACTIONS(2572),
    [anon_sym___clrcall] = ACTIONS(2572),
    [anon_sym___stdcall] = ACTIONS(2572),
    [anon_sym___fastcall] = ACTIONS(2572),
    [anon_sym___thiscall] = ACTIONS(2572),
    [anon_sym___vectorcall] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_goto] = ACTIONS(2572),
    [anon_sym___try] = ACTIONS(2572),
    [anon_sym___leave] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2572),
    [anon_sym_compl] = ACTIONS(2572),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_sizeof] = ACTIONS(2572),
    [anon_sym___alignof__] = ACTIONS(2572),
    [anon_sym___alignof] = ACTIONS(2572),
    [anon_sym__alignof] = ACTIONS(2572),
    [anon_sym_alignof] = ACTIONS(2572),
    [anon_sym__Alignof] = ACTIONS(2572),
    [anon_sym_offsetof] = ACTIONS(2572),
    [anon_sym__Generic] = ACTIONS(2572),
    [anon_sym_asm] = ACTIONS(2572),
    [anon_sym___asm__] = ACTIONS(2572),
    [anon_sym___asm] = ACTIONS(2572),
    [sym_number_literal] = ACTIONS(2574),
    [anon_sym_L_SQUOTE] = ACTIONS(2574),
    [anon_sym_u_SQUOTE] = ACTIONS(2574),
    [anon_sym_U_SQUOTE] = ACTIONS(2574),
    [anon_sym_u8_SQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_L_DQUOTE] = ACTIONS(2574),
    [anon_sym_u_DQUOTE] = ACTIONS(2574),
    [anon_sym_U_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8_DQUOTE] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [anon_sym_NULL] = ACTIONS(2572),
    [anon_sym_nullptr] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_concept] = ACTIONS(2572),
    [anon_sym_co_return] = ACTIONS(2572),
    [anon_sym_co_yield] = ACTIONS(2572),
    [anon_sym_R_DQUOTE] = ACTIONS(2574),
    [anon_sym_LR_DQUOTE] = ACTIONS(2574),
    [anon_sym_uR_DQUOTE] = ACTIONS(2574),
    [anon_sym_UR_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2574),
    [anon_sym_co_await] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_requires] = ACTIONS(2572),
    [sym_this] = ACTIONS(2572),
    [anon_sym_discard] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
    [anon_sym_cbuffer] = ACTIONS(2572),
  },
  [622] = {
    [sym_identifier] = ACTIONS(2568),
    [aux_sym_preproc_include_token1] = ACTIONS(2568),
    [aux_sym_preproc_def_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2568),
    [sym_preproc_directive] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_out] = ACTIONS(2568),
    [anon_sym_inout] = ACTIONS(2568),
    [anon_sym_virtual] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym___attribute__] = ACTIONS(2568),
    [anon_sym___attribute] = ACTIONS(2568),
    [anon_sym_using] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2570),
    [anon_sym___declspec] = ACTIONS(2568),
    [anon_sym___based] = ACTIONS(2568),
    [anon_sym___cdecl] = ACTIONS(2568),
    [anon_sym___clrcall] = ACTIONS(2568),
    [anon_sym___stdcall] = ACTIONS(2568),
    [anon_sym___fastcall] = ACTIONS(2568),
    [anon_sym___thiscall] = ACTIONS(2568),
    [anon_sym___vectorcall] = ACTIONS(2568),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_RBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2568),
    [anon_sym_unsigned] = ACTIONS(2568),
    [anon_sym_long] = ACTIONS(2568),
    [anon_sym_short] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_register] = ACTIONS(2568),
    [anon_sym_inline] = ACTIONS(2568),
    [anon_sym___inline] = ACTIONS(2568),
    [anon_sym___inline__] = ACTIONS(2568),
    [anon_sym___forceinline] = ACTIONS(2568),
    [anon_sym_thread_local] = ACTIONS(2568),
    [anon_sym___thread] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_constexpr] = ACTIONS(2568),
    [anon_sym_volatile] = ACTIONS(2568),
    [anon_sym_restrict] = ACTIONS(2568),
    [anon_sym___restrict__] = ACTIONS(2568),
    [anon_sym__Atomic] = ACTIONS(2568),
    [anon_sym__Noreturn] = ACTIONS(2568),
    [anon_sym_noreturn] = ACTIONS(2568),
    [anon_sym__Nonnull] = ACTIONS(2568),
    [anon_sym_mutable] = ACTIONS(2568),
    [anon_sym_constinit] = ACTIONS(2568),
    [anon_sym_consteval] = ACTIONS(2568),
    [anon_sym_alignas] = ACTIONS(2568),
    [anon_sym__Alignas] = ACTIONS(2568),
    [sym_primitive_type] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_class] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_switch] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_goto] = ACTIONS(2568),
    [anon_sym___try] = ACTIONS(2568),
    [anon_sym___leave] = ACTIONS(2568),
    [anon_sym_not] = ACTIONS(2568),
    [anon_sym_compl] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(2570),
    [anon_sym_sizeof] = ACTIONS(2568),
    [anon_sym___alignof__] = ACTIONS(2568),
    [anon_sym___alignof] = ACTIONS(2568),
    [anon_sym__alignof] = ACTIONS(2568),
    [anon_sym_alignof] = ACTIONS(2568),
    [anon_sym__Alignof] = ACTIONS(2568),
    [anon_sym_offsetof] = ACTIONS(2568),
    [anon_sym__Generic] = ACTIONS(2568),
    [anon_sym_asm] = ACTIONS(2568),
    [anon_sym___asm__] = ACTIONS(2568),
    [anon_sym___asm] = ACTIONS(2568),
    [sym_number_literal] = ACTIONS(2570),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2570),
    [anon_sym_u_DQUOTE] = ACTIONS(2570),
    [anon_sym_U_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8_DQUOTE] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2570),
    [sym_true] = ACTIONS(2568),
    [sym_false] = ACTIONS(2568),
    [anon_sym_NULL] = ACTIONS(2568),
    [anon_sym_nullptr] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2568),
    [anon_sym_decltype] = ACTIONS(2568),
    [anon_sym_explicit] = ACTIONS(2568),
    [anon_sym_typename] = ACTIONS(2568),
    [anon_sym_template] = ACTIONS(2568),
    [anon_sym_operator] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2568),
    [anon_sym_throw] = ACTIONS(2568),
    [anon_sym_namespace] = ACTIONS(2568),
    [anon_sym_static_assert] = ACTIONS(2568),
    [anon_sym_concept] = ACTIONS(2568),
    [anon_sym_co_return] = ACTIONS(2568),
    [anon_sym_co_yield] = ACTIONS(2568),
    [anon_sym_R_DQUOTE] = ACTIONS(2570),
    [anon_sym_LR_DQUOTE] = ACTIONS(2570),
    [anon_sym_uR_DQUOTE] = ACTIONS(2570),
    [anon_sym_UR_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2570),
    [anon_sym_co_await] = ACTIONS(2568),
    [anon_sym_new] = ACTIONS(2568),
    [anon_sym_requires] = ACTIONS(2568),
    [sym_this] = ACTIONS(2568),
    [anon_sym_discard] = ACTIONS(2568),
    [anon_sym_precise] = ACTIONS(2568),
    [anon_sym_shared] = ACTIONS(2568),
    [anon_sym_groupshared] = ACTIONS(2568),
    [anon_sym_uniform] = ACTIONS(2568),
    [anon_sym_row_major] = ACTIONS(2568),
    [anon_sym_column_major] = ACTIONS(2568),
    [anon_sym_globallycoherent] = ACTIONS(2568),
    [anon_sym_centroid] = ACTIONS(2568),
    [anon_sym_noperspective] = ACTIONS(2568),
    [anon_sym_nointerpolation] = ACTIONS(2568),
    [anon_sym_sample] = ACTIONS(2568),
    [anon_sym_linear] = ACTIONS(2568),
    [anon_sym_snorm] = ACTIONS(2568),
    [anon_sym_unorm] = ACTIONS(2568),
    [anon_sym_point] = ACTIONS(2568),
    [anon_sym_line] = ACTIONS(2568),
    [anon_sym_triangleadj] = ACTIONS(2568),
    [anon_sym_lineadj] = ACTIONS(2568),
    [anon_sym_triangle] = ACTIONS(2568),
    [anon_sym_cbuffer] = ACTIONS(2568),
  },
  [623] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_include_token1] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym___cdecl] = ACTIONS(2572),
    [anon_sym___clrcall] = ACTIONS(2572),
    [anon_sym___stdcall] = ACTIONS(2572),
    [anon_sym___fastcall] = ACTIONS(2572),
    [anon_sym___thiscall] = ACTIONS(2572),
    [anon_sym___vectorcall] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_goto] = ACTIONS(2572),
    [anon_sym___try] = ACTIONS(2572),
    [anon_sym___leave] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2572),
    [anon_sym_compl] = ACTIONS(2572),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_sizeof] = ACTIONS(2572),
    [anon_sym___alignof__] = ACTIONS(2572),
    [anon_sym___alignof] = ACTIONS(2572),
    [anon_sym__alignof] = ACTIONS(2572),
    [anon_sym_alignof] = ACTIONS(2572),
    [anon_sym__Alignof] = ACTIONS(2572),
    [anon_sym_offsetof] = ACTIONS(2572),
    [anon_sym__Generic] = ACTIONS(2572),
    [anon_sym_asm] = ACTIONS(2572),
    [anon_sym___asm__] = ACTIONS(2572),
    [anon_sym___asm] = ACTIONS(2572),
    [sym_number_literal] = ACTIONS(2574),
    [anon_sym_L_SQUOTE] = ACTIONS(2574),
    [anon_sym_u_SQUOTE] = ACTIONS(2574),
    [anon_sym_U_SQUOTE] = ACTIONS(2574),
    [anon_sym_u8_SQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_L_DQUOTE] = ACTIONS(2574),
    [anon_sym_u_DQUOTE] = ACTIONS(2574),
    [anon_sym_U_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8_DQUOTE] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [anon_sym_NULL] = ACTIONS(2572),
    [anon_sym_nullptr] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_concept] = ACTIONS(2572),
    [anon_sym_co_return] = ACTIONS(2572),
    [anon_sym_co_yield] = ACTIONS(2572),
    [anon_sym_R_DQUOTE] = ACTIONS(2574),
    [anon_sym_LR_DQUOTE] = ACTIONS(2574),
    [anon_sym_uR_DQUOTE] = ACTIONS(2574),
    [anon_sym_UR_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2574),
    [anon_sym_co_await] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_requires] = ACTIONS(2572),
    [sym_this] = ACTIONS(2572),
    [anon_sym_discard] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
    [anon_sym_cbuffer] = ACTIONS(2572),
  },
  [624] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_include_token1] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token2] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym___cdecl] = ACTIONS(2612),
    [anon_sym___clrcall] = ACTIONS(2612),
    [anon_sym___stdcall] = ACTIONS(2612),
    [anon_sym___fastcall] = ACTIONS(2612),
    [anon_sym___thiscall] = ACTIONS(2612),
    [anon_sym___vectorcall] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_switch] = ACTIONS(2612),
    [anon_sym_case] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_do] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_goto] = ACTIONS(2612),
    [anon_sym___try] = ACTIONS(2612),
    [anon_sym___leave] = ACTIONS(2612),
    [anon_sym_not] = ACTIONS(2612),
    [anon_sym_compl] = ACTIONS(2612),
    [anon_sym_DASH_DASH] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2614),
    [anon_sym_sizeof] = ACTIONS(2612),
    [anon_sym___alignof__] = ACTIONS(2612),
    [anon_sym___alignof] = ACTIONS(2612),
    [anon_sym__alignof] = ACTIONS(2612),
    [anon_sym_alignof] = ACTIONS(2612),
    [anon_sym__Alignof] = ACTIONS(2612),
    [anon_sym_offsetof] = ACTIONS(2612),
    [anon_sym__Generic] = ACTIONS(2612),
    [anon_sym_asm] = ACTIONS(2612),
    [anon_sym___asm__] = ACTIONS(2612),
    [anon_sym___asm] = ACTIONS(2612),
    [sym_number_literal] = ACTIONS(2614),
    [anon_sym_L_SQUOTE] = ACTIONS(2614),
    [anon_sym_u_SQUOTE] = ACTIONS(2614),
    [anon_sym_U_SQUOTE] = ACTIONS(2614),
    [anon_sym_u8_SQUOTE] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_L_DQUOTE] = ACTIONS(2614),
    [anon_sym_u_DQUOTE] = ACTIONS(2614),
    [anon_sym_U_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8_DQUOTE] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [anon_sym_NULL] = ACTIONS(2612),
    [anon_sym_nullptr] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_delete] = ACTIONS(2612),
    [anon_sym_throw] = ACTIONS(2612),
    [anon_sym_namespace] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_concept] = ACTIONS(2612),
    [anon_sym_co_return] = ACTIONS(2612),
    [anon_sym_co_yield] = ACTIONS(2612),
    [anon_sym_R_DQUOTE] = ACTIONS(2614),
    [anon_sym_LR_DQUOTE] = ACTIONS(2614),
    [anon_sym_uR_DQUOTE] = ACTIONS(2614),
    [anon_sym_UR_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2614),
    [anon_sym_co_await] = ACTIONS(2612),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_requires] = ACTIONS(2612),
    [sym_this] = ACTIONS(2612),
    [anon_sym_discard] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
    [anon_sym_cbuffer] = ACTIONS(2612),
  },
  [625] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_include_token1] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token2] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym___cdecl] = ACTIONS(2616),
    [anon_sym___clrcall] = ACTIONS(2616),
    [anon_sym___stdcall] = ACTIONS(2616),
    [anon_sym___fastcall] = ACTIONS(2616),
    [anon_sym___thiscall] = ACTIONS(2616),
    [anon_sym___vectorcall] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_switch] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_goto] = ACTIONS(2616),
    [anon_sym___try] = ACTIONS(2616),
    [anon_sym___leave] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_compl] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2618),
    [anon_sym_sizeof] = ACTIONS(2616),
    [anon_sym___alignof__] = ACTIONS(2616),
    [anon_sym___alignof] = ACTIONS(2616),
    [anon_sym__alignof] = ACTIONS(2616),
    [anon_sym_alignof] = ACTIONS(2616),
    [anon_sym__Alignof] = ACTIONS(2616),
    [anon_sym_offsetof] = ACTIONS(2616),
    [anon_sym__Generic] = ACTIONS(2616),
    [anon_sym_asm] = ACTIONS(2616),
    [anon_sym___asm__] = ACTIONS(2616),
    [anon_sym___asm] = ACTIONS(2616),
    [sym_number_literal] = ACTIONS(2618),
    [anon_sym_L_SQUOTE] = ACTIONS(2618),
    [anon_sym_u_SQUOTE] = ACTIONS(2618),
    [anon_sym_U_SQUOTE] = ACTIONS(2618),
    [anon_sym_u8_SQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_L_DQUOTE] = ACTIONS(2618),
    [anon_sym_u_DQUOTE] = ACTIONS(2618),
    [anon_sym_U_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8_DQUOTE] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [anon_sym_NULL] = ACTIONS(2616),
    [anon_sym_nullptr] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_delete] = ACTIONS(2616),
    [anon_sym_throw] = ACTIONS(2616),
    [anon_sym_namespace] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_concept] = ACTIONS(2616),
    [anon_sym_co_return] = ACTIONS(2616),
    [anon_sym_co_yield] = ACTIONS(2616),
    [anon_sym_R_DQUOTE] = ACTIONS(2618),
    [anon_sym_LR_DQUOTE] = ACTIONS(2618),
    [anon_sym_uR_DQUOTE] = ACTIONS(2618),
    [anon_sym_UR_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2618),
    [anon_sym_co_await] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2616),
    [anon_sym_requires] = ACTIONS(2616),
    [sym_this] = ACTIONS(2616),
    [anon_sym_discard] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
    [anon_sym_cbuffer] = ACTIONS(2616),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_include_token1] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token2] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym___cdecl] = ACTIONS(2620),
    [anon_sym___clrcall] = ACTIONS(2620),
    [anon_sym___stdcall] = ACTIONS(2620),
    [anon_sym___fastcall] = ACTIONS(2620),
    [anon_sym___thiscall] = ACTIONS(2620),
    [anon_sym___vectorcall] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_switch] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_goto] = ACTIONS(2620),
    [anon_sym___try] = ACTIONS(2620),
    [anon_sym___leave] = ACTIONS(2620),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_compl] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_sizeof] = ACTIONS(2620),
    [anon_sym___alignof__] = ACTIONS(2620),
    [anon_sym___alignof] = ACTIONS(2620),
    [anon_sym__alignof] = ACTIONS(2620),
    [anon_sym_alignof] = ACTIONS(2620),
    [anon_sym__Alignof] = ACTIONS(2620),
    [anon_sym_offsetof] = ACTIONS(2620),
    [anon_sym__Generic] = ACTIONS(2620),
    [anon_sym_asm] = ACTIONS(2620),
    [anon_sym___asm__] = ACTIONS(2620),
    [anon_sym___asm] = ACTIONS(2620),
    [sym_number_literal] = ACTIONS(2622),
    [anon_sym_L_SQUOTE] = ACTIONS(2622),
    [anon_sym_u_SQUOTE] = ACTIONS(2622),
    [anon_sym_U_SQUOTE] = ACTIONS(2622),
    [anon_sym_u8_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_L_DQUOTE] = ACTIONS(2622),
    [anon_sym_u_DQUOTE] = ACTIONS(2622),
    [anon_sym_U_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8_DQUOTE] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [anon_sym_NULL] = ACTIONS(2620),
    [anon_sym_nullptr] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_delete] = ACTIONS(2620),
    [anon_sym_throw] = ACTIONS(2620),
    [anon_sym_namespace] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_concept] = ACTIONS(2620),
    [anon_sym_co_return] = ACTIONS(2620),
    [anon_sym_co_yield] = ACTIONS(2620),
    [anon_sym_R_DQUOTE] = ACTIONS(2622),
    [anon_sym_LR_DQUOTE] = ACTIONS(2622),
    [anon_sym_uR_DQUOTE] = ACTIONS(2622),
    [anon_sym_UR_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2622),
    [anon_sym_co_await] = ACTIONS(2620),
    [anon_sym_new] = ACTIONS(2620),
    [anon_sym_requires] = ACTIONS(2620),
    [sym_this] = ACTIONS(2620),
    [anon_sym_discard] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
    [anon_sym_cbuffer] = ACTIONS(2620),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_include_token1] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token2] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym___cdecl] = ACTIONS(2624),
    [anon_sym___clrcall] = ACTIONS(2624),
    [anon_sym___stdcall] = ACTIONS(2624),
    [anon_sym___fastcall] = ACTIONS(2624),
    [anon_sym___thiscall] = ACTIONS(2624),
    [anon_sym___vectorcall] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_goto] = ACTIONS(2624),
    [anon_sym___try] = ACTIONS(2624),
    [anon_sym___leave] = ACTIONS(2624),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_compl] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2626),
    [anon_sym_sizeof] = ACTIONS(2624),
    [anon_sym___alignof__] = ACTIONS(2624),
    [anon_sym___alignof] = ACTIONS(2624),
    [anon_sym__alignof] = ACTIONS(2624),
    [anon_sym_alignof] = ACTIONS(2624),
    [anon_sym__Alignof] = ACTIONS(2624),
    [anon_sym_offsetof] = ACTIONS(2624),
    [anon_sym__Generic] = ACTIONS(2624),
    [anon_sym_asm] = ACTIONS(2624),
    [anon_sym___asm__] = ACTIONS(2624),
    [anon_sym___asm] = ACTIONS(2624),
    [sym_number_literal] = ACTIONS(2626),
    [anon_sym_L_SQUOTE] = ACTIONS(2626),
    [anon_sym_u_SQUOTE] = ACTIONS(2626),
    [anon_sym_U_SQUOTE] = ACTIONS(2626),
    [anon_sym_u8_SQUOTE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_L_DQUOTE] = ACTIONS(2626),
    [anon_sym_u_DQUOTE] = ACTIONS(2626),
    [anon_sym_U_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8_DQUOTE] = ACTIONS(2626),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [anon_sym_NULL] = ACTIONS(2624),
    [anon_sym_nullptr] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_concept] = ACTIONS(2624),
    [anon_sym_co_return] = ACTIONS(2624),
    [anon_sym_co_yield] = ACTIONS(2624),
    [anon_sym_R_DQUOTE] = ACTIONS(2626),
    [anon_sym_LR_DQUOTE] = ACTIONS(2626),
    [anon_sym_uR_DQUOTE] = ACTIONS(2626),
    [anon_sym_UR_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2626),
    [anon_sym_co_await] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_requires] = ACTIONS(2624),
    [sym_this] = ACTIONS(2624),
    [anon_sym_discard] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
    [anon_sym_cbuffer] = ACTIONS(2624),
  },
  [628] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_include_token1] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token2] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym___cdecl] = ACTIONS(2628),
    [anon_sym___clrcall] = ACTIONS(2628),
    [anon_sym___stdcall] = ACTIONS(2628),
    [anon_sym___fastcall] = ACTIONS(2628),
    [anon_sym___thiscall] = ACTIONS(2628),
    [anon_sym___vectorcall] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_goto] = ACTIONS(2628),
    [anon_sym___try] = ACTIONS(2628),
    [anon_sym___leave] = ACTIONS(2628),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_compl] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_sizeof] = ACTIONS(2628),
    [anon_sym___alignof__] = ACTIONS(2628),
    [anon_sym___alignof] = ACTIONS(2628),
    [anon_sym__alignof] = ACTIONS(2628),
    [anon_sym_alignof] = ACTIONS(2628),
    [anon_sym__Alignof] = ACTIONS(2628),
    [anon_sym_offsetof] = ACTIONS(2628),
    [anon_sym__Generic] = ACTIONS(2628),
    [anon_sym_asm] = ACTIONS(2628),
    [anon_sym___asm__] = ACTIONS(2628),
    [anon_sym___asm] = ACTIONS(2628),
    [sym_number_literal] = ACTIONS(2630),
    [anon_sym_L_SQUOTE] = ACTIONS(2630),
    [anon_sym_u_SQUOTE] = ACTIONS(2630),
    [anon_sym_U_SQUOTE] = ACTIONS(2630),
    [anon_sym_u8_SQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_L_DQUOTE] = ACTIONS(2630),
    [anon_sym_u_DQUOTE] = ACTIONS(2630),
    [anon_sym_U_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8_DQUOTE] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [anon_sym_NULL] = ACTIONS(2628),
    [anon_sym_nullptr] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_concept] = ACTIONS(2628),
    [anon_sym_co_return] = ACTIONS(2628),
    [anon_sym_co_yield] = ACTIONS(2628),
    [anon_sym_R_DQUOTE] = ACTIONS(2630),
    [anon_sym_LR_DQUOTE] = ACTIONS(2630),
    [anon_sym_uR_DQUOTE] = ACTIONS(2630),
    [anon_sym_UR_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2630),
    [anon_sym_co_await] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_requires] = ACTIONS(2628),
    [sym_this] = ACTIONS(2628),
    [anon_sym_discard] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
    [anon_sym_cbuffer] = ACTIONS(2628),
  },
  [629] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_include_token1] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token2] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym___cdecl] = ACTIONS(2632),
    [anon_sym___clrcall] = ACTIONS(2632),
    [anon_sym___stdcall] = ACTIONS(2632),
    [anon_sym___fastcall] = ACTIONS(2632),
    [anon_sym___thiscall] = ACTIONS(2632),
    [anon_sym___vectorcall] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_goto] = ACTIONS(2632),
    [anon_sym___try] = ACTIONS(2632),
    [anon_sym___leave] = ACTIONS(2632),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_compl] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_sizeof] = ACTIONS(2632),
    [anon_sym___alignof__] = ACTIONS(2632),
    [anon_sym___alignof] = ACTIONS(2632),
    [anon_sym__alignof] = ACTIONS(2632),
    [anon_sym_alignof] = ACTIONS(2632),
    [anon_sym__Alignof] = ACTIONS(2632),
    [anon_sym_offsetof] = ACTIONS(2632),
    [anon_sym__Generic] = ACTIONS(2632),
    [anon_sym_asm] = ACTIONS(2632),
    [anon_sym___asm__] = ACTIONS(2632),
    [anon_sym___asm] = ACTIONS(2632),
    [sym_number_literal] = ACTIONS(2634),
    [anon_sym_L_SQUOTE] = ACTIONS(2634),
    [anon_sym_u_SQUOTE] = ACTIONS(2634),
    [anon_sym_U_SQUOTE] = ACTIONS(2634),
    [anon_sym_u8_SQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_L_DQUOTE] = ACTIONS(2634),
    [anon_sym_u_DQUOTE] = ACTIONS(2634),
    [anon_sym_U_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8_DQUOTE] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [anon_sym_NULL] = ACTIONS(2632),
    [anon_sym_nullptr] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_concept] = ACTIONS(2632),
    [anon_sym_co_return] = ACTIONS(2632),
    [anon_sym_co_yield] = ACTIONS(2632),
    [anon_sym_R_DQUOTE] = ACTIONS(2634),
    [anon_sym_LR_DQUOTE] = ACTIONS(2634),
    [anon_sym_uR_DQUOTE] = ACTIONS(2634),
    [anon_sym_UR_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2634),
    [anon_sym_co_await] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_requires] = ACTIONS(2632),
    [sym_this] = ACTIONS(2632),
    [anon_sym_discard] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
    [anon_sym_cbuffer] = ACTIONS(2632),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_include_token1] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token2] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym___cdecl] = ACTIONS(2636),
    [anon_sym___clrcall] = ACTIONS(2636),
    [anon_sym___stdcall] = ACTIONS(2636),
    [anon_sym___fastcall] = ACTIONS(2636),
    [anon_sym___thiscall] = ACTIONS(2636),
    [anon_sym___vectorcall] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(2636),
    [anon_sym___try] = ACTIONS(2636),
    [anon_sym___leave] = ACTIONS(2636),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_compl] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2638),
    [anon_sym_sizeof] = ACTIONS(2636),
    [anon_sym___alignof__] = ACTIONS(2636),
    [anon_sym___alignof] = ACTIONS(2636),
    [anon_sym__alignof] = ACTIONS(2636),
    [anon_sym_alignof] = ACTIONS(2636),
    [anon_sym__Alignof] = ACTIONS(2636),
    [anon_sym_offsetof] = ACTIONS(2636),
    [anon_sym__Generic] = ACTIONS(2636),
    [anon_sym_asm] = ACTIONS(2636),
    [anon_sym___asm__] = ACTIONS(2636),
    [anon_sym___asm] = ACTIONS(2636),
    [sym_number_literal] = ACTIONS(2638),
    [anon_sym_L_SQUOTE] = ACTIONS(2638),
    [anon_sym_u_SQUOTE] = ACTIONS(2638),
    [anon_sym_U_SQUOTE] = ACTIONS(2638),
    [anon_sym_u8_SQUOTE] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_L_DQUOTE] = ACTIONS(2638),
    [anon_sym_u_DQUOTE] = ACTIONS(2638),
    [anon_sym_U_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8_DQUOTE] = ACTIONS(2638),
    [anon_sym_DQUOTE] = ACTIONS(2638),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [anon_sym_NULL] = ACTIONS(2636),
    [anon_sym_nullptr] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_concept] = ACTIONS(2636),
    [anon_sym_co_return] = ACTIONS(2636),
    [anon_sym_co_yield] = ACTIONS(2636),
    [anon_sym_R_DQUOTE] = ACTIONS(2638),
    [anon_sym_LR_DQUOTE] = ACTIONS(2638),
    [anon_sym_uR_DQUOTE] = ACTIONS(2638),
    [anon_sym_UR_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2638),
    [anon_sym_co_await] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_requires] = ACTIONS(2636),
    [sym_this] = ACTIONS(2636),
    [anon_sym_discard] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
    [anon_sym_cbuffer] = ACTIONS(2636),
  },
  [631] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_include_token1] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token2] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym___cdecl] = ACTIONS(2652),
    [anon_sym___clrcall] = ACTIONS(2652),
    [anon_sym___stdcall] = ACTIONS(2652),
    [anon_sym___fastcall] = ACTIONS(2652),
    [anon_sym___thiscall] = ACTIONS(2652),
    [anon_sym___vectorcall] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_do] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_goto] = ACTIONS(2652),
    [anon_sym___try] = ACTIONS(2652),
    [anon_sym___leave] = ACTIONS(2652),
    [anon_sym_not] = ACTIONS(2652),
    [anon_sym_compl] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_sizeof] = ACTIONS(2652),
    [anon_sym___alignof__] = ACTIONS(2652),
    [anon_sym___alignof] = ACTIONS(2652),
    [anon_sym__alignof] = ACTIONS(2652),
    [anon_sym_alignof] = ACTIONS(2652),
    [anon_sym__Alignof] = ACTIONS(2652),
    [anon_sym_offsetof] = ACTIONS(2652),
    [anon_sym__Generic] = ACTIONS(2652),
    [anon_sym_asm] = ACTIONS(2652),
    [anon_sym___asm__] = ACTIONS(2652),
    [anon_sym___asm] = ACTIONS(2652),
    [sym_number_literal] = ACTIONS(2654),
    [anon_sym_L_SQUOTE] = ACTIONS(2654),
    [anon_sym_u_SQUOTE] = ACTIONS(2654),
    [anon_sym_U_SQUOTE] = ACTIONS(2654),
    [anon_sym_u8_SQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [anon_sym_L_DQUOTE] = ACTIONS(2654),
    [anon_sym_u_DQUOTE] = ACTIONS(2654),
    [anon_sym_U_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8_DQUOTE] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [anon_sym_NULL] = ACTIONS(2652),
    [anon_sym_nullptr] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [anon_sym_delete] = ACTIONS(2652),
    [anon_sym_throw] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_concept] = ACTIONS(2652),
    [anon_sym_co_return] = ACTIONS(2652),
    [anon_sym_co_yield] = ACTIONS(2652),
    [anon_sym_R_DQUOTE] = ACTIONS(2654),
    [anon_sym_LR_DQUOTE] = ACTIONS(2654),
    [anon_sym_uR_DQUOTE] = ACTIONS(2654),
    [anon_sym_UR_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2654),
    [anon_sym_co_await] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_requires] = ACTIONS(2652),
    [sym_this] = ACTIONS(2652),
    [anon_sym_discard] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
    [anon_sym_cbuffer] = ACTIONS(2652),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2688),
    [aux_sym_preproc_include_token1] = ACTIONS(2688),
    [aux_sym_preproc_def_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2688),
    [sym_preproc_directive] = ACTIONS(2688),
    [anon_sym_LPAREN2] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym___extension__] = ACTIONS(2688),
    [anon_sym_typedef] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2688),
    [anon_sym_out] = ACTIONS(2688),
    [anon_sym_inout] = ACTIONS(2688),
    [anon_sym_virtual] = ACTIONS(2688),
    [anon_sym_extern] = ACTIONS(2688),
    [anon_sym___attribute__] = ACTIONS(2688),
    [anon_sym___attribute] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2690),
    [anon_sym___declspec] = ACTIONS(2688),
    [anon_sym___based] = ACTIONS(2688),
    [anon_sym___cdecl] = ACTIONS(2688),
    [anon_sym___clrcall] = ACTIONS(2688),
    [anon_sym___stdcall] = ACTIONS(2688),
    [anon_sym___fastcall] = ACTIONS(2688),
    [anon_sym___thiscall] = ACTIONS(2688),
    [anon_sym___vectorcall] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_RBRACE] = ACTIONS(2690),
    [anon_sym_signed] = ACTIONS(2688),
    [anon_sym_unsigned] = ACTIONS(2688),
    [anon_sym_long] = ACTIONS(2688),
    [anon_sym_short] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_register] = ACTIONS(2688),
    [anon_sym_inline] = ACTIONS(2688),
    [anon_sym___inline] = ACTIONS(2688),
    [anon_sym___inline__] = ACTIONS(2688),
    [anon_sym___forceinline] = ACTIONS(2688),
    [anon_sym_thread_local] = ACTIONS(2688),
    [anon_sym___thread] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_constexpr] = ACTIONS(2688),
    [anon_sym_volatile] = ACTIONS(2688),
    [anon_sym_restrict] = ACTIONS(2688),
    [anon_sym___restrict__] = ACTIONS(2688),
    [anon_sym__Atomic] = ACTIONS(2688),
    [anon_sym__Noreturn] = ACTIONS(2688),
    [anon_sym_noreturn] = ACTIONS(2688),
    [anon_sym__Nonnull] = ACTIONS(2688),
    [anon_sym_mutable] = ACTIONS(2688),
    [anon_sym_constinit] = ACTIONS(2688),
    [anon_sym_consteval] = ACTIONS(2688),
    [anon_sym_alignas] = ACTIONS(2688),
    [anon_sym__Alignas] = ACTIONS(2688),
    [sym_primitive_type] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_struct] = ACTIONS(2688),
    [anon_sym_union] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_goto] = ACTIONS(2688),
    [anon_sym___try] = ACTIONS(2688),
    [anon_sym___leave] = ACTIONS(2688),
    [anon_sym_not] = ACTIONS(2688),
    [anon_sym_compl] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_sizeof] = ACTIONS(2688),
    [anon_sym___alignof__] = ACTIONS(2688),
    [anon_sym___alignof] = ACTIONS(2688),
    [anon_sym__alignof] = ACTIONS(2688),
    [anon_sym_alignof] = ACTIONS(2688),
    [anon_sym__Alignof] = ACTIONS(2688),
    [anon_sym_offsetof] = ACTIONS(2688),
    [anon_sym__Generic] = ACTIONS(2688),
    [anon_sym_asm] = ACTIONS(2688),
    [anon_sym___asm__] = ACTIONS(2688),
    [anon_sym___asm] = ACTIONS(2688),
    [sym_number_literal] = ACTIONS(2690),
    [anon_sym_L_SQUOTE] = ACTIONS(2690),
    [anon_sym_u_SQUOTE] = ACTIONS(2690),
    [anon_sym_U_SQUOTE] = ACTIONS(2690),
    [anon_sym_u8_SQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_L_DQUOTE] = ACTIONS(2690),
    [anon_sym_u_DQUOTE] = ACTIONS(2690),
    [anon_sym_U_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [anon_sym_NULL] = ACTIONS(2688),
    [anon_sym_nullptr] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2688),
    [anon_sym_decltype] = ACTIONS(2688),
    [anon_sym_explicit] = ACTIONS(2688),
    [anon_sym_typename] = ACTIONS(2688),
    [anon_sym_template] = ACTIONS(2688),
    [anon_sym_operator] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_static_assert] = ACTIONS(2688),
    [anon_sym_concept] = ACTIONS(2688),
    [anon_sym_co_return] = ACTIONS(2688),
    [anon_sym_co_yield] = ACTIONS(2688),
    [anon_sym_R_DQUOTE] = ACTIONS(2690),
    [anon_sym_LR_DQUOTE] = ACTIONS(2690),
    [anon_sym_uR_DQUOTE] = ACTIONS(2690),
    [anon_sym_UR_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2690),
    [anon_sym_co_await] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_requires] = ACTIONS(2688),
    [sym_this] = ACTIONS(2688),
    [anon_sym_discard] = ACTIONS(2688),
    [anon_sym_precise] = ACTIONS(2688),
    [anon_sym_shared] = ACTIONS(2688),
    [anon_sym_groupshared] = ACTIONS(2688),
    [anon_sym_uniform] = ACTIONS(2688),
    [anon_sym_row_major] = ACTIONS(2688),
    [anon_sym_column_major] = ACTIONS(2688),
    [anon_sym_globallycoherent] = ACTIONS(2688),
    [anon_sym_centroid] = ACTIONS(2688),
    [anon_sym_noperspective] = ACTIONS(2688),
    [anon_sym_nointerpolation] = ACTIONS(2688),
    [anon_sym_sample] = ACTIONS(2688),
    [anon_sym_linear] = ACTIONS(2688),
    [anon_sym_snorm] = ACTIONS(2688),
    [anon_sym_unorm] = ACTIONS(2688),
    [anon_sym_point] = ACTIONS(2688),
    [anon_sym_line] = ACTIONS(2688),
    [anon_sym_triangleadj] = ACTIONS(2688),
    [anon_sym_lineadj] = ACTIONS(2688),
    [anon_sym_triangle] = ACTIONS(2688),
    [anon_sym_cbuffer] = ACTIONS(2688),
  },
  [633] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [634] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [635] = {
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_out] = ACTIONS(2496),
    [anon_sym_inout] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym___attribute] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym__Nonnull] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym__Alignas] = ACTIONS(2496),
    [sym_primitive_type] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [anon_sym___asm] = ACTIONS(2496),
    [sym_number_literal] = ACTIONS(2498),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
    [anon_sym_discard] = ACTIONS(2496),
    [anon_sym_precise] = ACTIONS(2496),
    [anon_sym_shared] = ACTIONS(2496),
    [anon_sym_groupshared] = ACTIONS(2496),
    [anon_sym_uniform] = ACTIONS(2496),
    [anon_sym_row_major] = ACTIONS(2496),
    [anon_sym_column_major] = ACTIONS(2496),
    [anon_sym_globallycoherent] = ACTIONS(2496),
    [anon_sym_centroid] = ACTIONS(2496),
    [anon_sym_noperspective] = ACTIONS(2496),
    [anon_sym_nointerpolation] = ACTIONS(2496),
    [anon_sym_sample] = ACTIONS(2496),
    [anon_sym_linear] = ACTIONS(2496),
    [anon_sym_snorm] = ACTIONS(2496),
    [anon_sym_unorm] = ACTIONS(2496),
    [anon_sym_point] = ACTIONS(2496),
    [anon_sym_line] = ACTIONS(2496),
    [anon_sym_triangleadj] = ACTIONS(2496),
    [anon_sym_lineadj] = ACTIONS(2496),
    [anon_sym_triangle] = ACTIONS(2496),
    [anon_sym_cbuffer] = ACTIONS(2496),
  },
  [636] = {
    [sym_identifier] = ACTIONS(2568),
    [aux_sym_preproc_include_token1] = ACTIONS(2568),
    [aux_sym_preproc_def_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token2] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2568),
    [sym_preproc_directive] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_out] = ACTIONS(2568),
    [anon_sym_inout] = ACTIONS(2568),
    [anon_sym_virtual] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym___attribute__] = ACTIONS(2568),
    [anon_sym___attribute] = ACTIONS(2568),
    [anon_sym_using] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2570),
    [anon_sym___declspec] = ACTIONS(2568),
    [anon_sym___based] = ACTIONS(2568),
    [anon_sym___cdecl] = ACTIONS(2568),
    [anon_sym___clrcall] = ACTIONS(2568),
    [anon_sym___stdcall] = ACTIONS(2568),
    [anon_sym___fastcall] = ACTIONS(2568),
    [anon_sym___thiscall] = ACTIONS(2568),
    [anon_sym___vectorcall] = ACTIONS(2568),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2568),
    [anon_sym_unsigned] = ACTIONS(2568),
    [anon_sym_long] = ACTIONS(2568),
    [anon_sym_short] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_register] = ACTIONS(2568),
    [anon_sym_inline] = ACTIONS(2568),
    [anon_sym___inline] = ACTIONS(2568),
    [anon_sym___inline__] = ACTIONS(2568),
    [anon_sym___forceinline] = ACTIONS(2568),
    [anon_sym_thread_local] = ACTIONS(2568),
    [anon_sym___thread] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_constexpr] = ACTIONS(2568),
    [anon_sym_volatile] = ACTIONS(2568),
    [anon_sym_restrict] = ACTIONS(2568),
    [anon_sym___restrict__] = ACTIONS(2568),
    [anon_sym__Atomic] = ACTIONS(2568),
    [anon_sym__Noreturn] = ACTIONS(2568),
    [anon_sym_noreturn] = ACTIONS(2568),
    [anon_sym__Nonnull] = ACTIONS(2568),
    [anon_sym_mutable] = ACTIONS(2568),
    [anon_sym_constinit] = ACTIONS(2568),
    [anon_sym_consteval] = ACTIONS(2568),
    [anon_sym_alignas] = ACTIONS(2568),
    [anon_sym__Alignas] = ACTIONS(2568),
    [sym_primitive_type] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_class] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_switch] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_goto] = ACTIONS(2568),
    [anon_sym___try] = ACTIONS(2568),
    [anon_sym___leave] = ACTIONS(2568),
    [anon_sym_not] = ACTIONS(2568),
    [anon_sym_compl] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(2570),
    [anon_sym_sizeof] = ACTIONS(2568),
    [anon_sym___alignof__] = ACTIONS(2568),
    [anon_sym___alignof] = ACTIONS(2568),
    [anon_sym__alignof] = ACTIONS(2568),
    [anon_sym_alignof] = ACTIONS(2568),
    [anon_sym__Alignof] = ACTIONS(2568),
    [anon_sym_offsetof] = ACTIONS(2568),
    [anon_sym__Generic] = ACTIONS(2568),
    [anon_sym_asm] = ACTIONS(2568),
    [anon_sym___asm__] = ACTIONS(2568),
    [anon_sym___asm] = ACTIONS(2568),
    [sym_number_literal] = ACTIONS(2570),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2570),
    [anon_sym_u_DQUOTE] = ACTIONS(2570),
    [anon_sym_U_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8_DQUOTE] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2570),
    [sym_true] = ACTIONS(2568),
    [sym_false] = ACTIONS(2568),
    [anon_sym_NULL] = ACTIONS(2568),
    [anon_sym_nullptr] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2568),
    [anon_sym_decltype] = ACTIONS(2568),
    [anon_sym_explicit] = ACTIONS(2568),
    [anon_sym_typename] = ACTIONS(2568),
    [anon_sym_template] = ACTIONS(2568),
    [anon_sym_operator] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2568),
    [anon_sym_throw] = ACTIONS(2568),
    [anon_sym_namespace] = ACTIONS(2568),
    [anon_sym_static_assert] = ACTIONS(2568),
    [anon_sym_concept] = ACTIONS(2568),
    [anon_sym_co_return] = ACTIONS(2568),
    [anon_sym_co_yield] = ACTIONS(2568),
    [anon_sym_R_DQUOTE] = ACTIONS(2570),
    [anon_sym_LR_DQUOTE] = ACTIONS(2570),
    [anon_sym_uR_DQUOTE] = ACTIONS(2570),
    [anon_sym_UR_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2570),
    [anon_sym_co_await] = ACTIONS(2568),
    [anon_sym_new] = ACTIONS(2568),
    [anon_sym_requires] = ACTIONS(2568),
    [sym_this] = ACTIONS(2568),
    [anon_sym_discard] = ACTIONS(2568),
    [anon_sym_precise] = ACTIONS(2568),
    [anon_sym_shared] = ACTIONS(2568),
    [anon_sym_groupshared] = ACTIONS(2568),
    [anon_sym_uniform] = ACTIONS(2568),
    [anon_sym_row_major] = ACTIONS(2568),
    [anon_sym_column_major] = ACTIONS(2568),
    [anon_sym_globallycoherent] = ACTIONS(2568),
    [anon_sym_centroid] = ACTIONS(2568),
    [anon_sym_noperspective] = ACTIONS(2568),
    [anon_sym_nointerpolation] = ACTIONS(2568),
    [anon_sym_sample] = ACTIONS(2568),
    [anon_sym_linear] = ACTIONS(2568),
    [anon_sym_snorm] = ACTIONS(2568),
    [anon_sym_unorm] = ACTIONS(2568),
    [anon_sym_point] = ACTIONS(2568),
    [anon_sym_line] = ACTIONS(2568),
    [anon_sym_triangleadj] = ACTIONS(2568),
    [anon_sym_lineadj] = ACTIONS(2568),
    [anon_sym_triangle] = ACTIONS(2568),
    [anon_sym_cbuffer] = ACTIONS(2568),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [638] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [639] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_include_token1] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token2] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym___cdecl] = ACTIONS(2684),
    [anon_sym___clrcall] = ACTIONS(2684),
    [anon_sym___stdcall] = ACTIONS(2684),
    [anon_sym___fastcall] = ACTIONS(2684),
    [anon_sym___thiscall] = ACTIONS(2684),
    [anon_sym___vectorcall] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_goto] = ACTIONS(2684),
    [anon_sym___try] = ACTIONS(2684),
    [anon_sym___leave] = ACTIONS(2684),
    [anon_sym_not] = ACTIONS(2684),
    [anon_sym_compl] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_sizeof] = ACTIONS(2684),
    [anon_sym___alignof__] = ACTIONS(2684),
    [anon_sym___alignof] = ACTIONS(2684),
    [anon_sym__alignof] = ACTIONS(2684),
    [anon_sym_alignof] = ACTIONS(2684),
    [anon_sym__Alignof] = ACTIONS(2684),
    [anon_sym_offsetof] = ACTIONS(2684),
    [anon_sym__Generic] = ACTIONS(2684),
    [anon_sym_asm] = ACTIONS(2684),
    [anon_sym___asm__] = ACTIONS(2684),
    [anon_sym___asm] = ACTIONS(2684),
    [sym_number_literal] = ACTIONS(2686),
    [anon_sym_L_SQUOTE] = ACTIONS(2686),
    [anon_sym_u_SQUOTE] = ACTIONS(2686),
    [anon_sym_U_SQUOTE] = ACTIONS(2686),
    [anon_sym_u8_SQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_L_DQUOTE] = ACTIONS(2686),
    [anon_sym_u_DQUOTE] = ACTIONS(2686),
    [anon_sym_U_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8_DQUOTE] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [anon_sym_NULL] = ACTIONS(2684),
    [anon_sym_nullptr] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_concept] = ACTIONS(2684),
    [anon_sym_co_return] = ACTIONS(2684),
    [anon_sym_co_yield] = ACTIONS(2684),
    [anon_sym_R_DQUOTE] = ACTIONS(2686),
    [anon_sym_LR_DQUOTE] = ACTIONS(2686),
    [anon_sym_uR_DQUOTE] = ACTIONS(2686),
    [anon_sym_UR_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2686),
    [anon_sym_co_await] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_requires] = ACTIONS(2684),
    [sym_this] = ACTIONS(2684),
    [anon_sym_discard] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
    [anon_sym_cbuffer] = ACTIONS(2684),
  },
  [640] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_include_token1] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym___cdecl] = ACTIONS(2616),
    [anon_sym___clrcall] = ACTIONS(2616),
    [anon_sym___stdcall] = ACTIONS(2616),
    [anon_sym___fastcall] = ACTIONS(2616),
    [anon_sym___thiscall] = ACTIONS(2616),
    [anon_sym___vectorcall] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_switch] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_goto] = ACTIONS(2616),
    [anon_sym___try] = ACTIONS(2616),
    [anon_sym___leave] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_compl] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2618),
    [anon_sym_sizeof] = ACTIONS(2616),
    [anon_sym___alignof__] = ACTIONS(2616),
    [anon_sym___alignof] = ACTIONS(2616),
    [anon_sym__alignof] = ACTIONS(2616),
    [anon_sym_alignof] = ACTIONS(2616),
    [anon_sym__Alignof] = ACTIONS(2616),
    [anon_sym_offsetof] = ACTIONS(2616),
    [anon_sym__Generic] = ACTIONS(2616),
    [anon_sym_asm] = ACTIONS(2616),
    [anon_sym___asm__] = ACTIONS(2616),
    [anon_sym___asm] = ACTIONS(2616),
    [sym_number_literal] = ACTIONS(2618),
    [anon_sym_L_SQUOTE] = ACTIONS(2618),
    [anon_sym_u_SQUOTE] = ACTIONS(2618),
    [anon_sym_U_SQUOTE] = ACTIONS(2618),
    [anon_sym_u8_SQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_L_DQUOTE] = ACTIONS(2618),
    [anon_sym_u_DQUOTE] = ACTIONS(2618),
    [anon_sym_U_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8_DQUOTE] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [anon_sym_NULL] = ACTIONS(2616),
    [anon_sym_nullptr] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_delete] = ACTIONS(2616),
    [anon_sym_throw] = ACTIONS(2616),
    [anon_sym_namespace] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_concept] = ACTIONS(2616),
    [anon_sym_co_return] = ACTIONS(2616),
    [anon_sym_co_yield] = ACTIONS(2616),
    [anon_sym_R_DQUOTE] = ACTIONS(2618),
    [anon_sym_LR_DQUOTE] = ACTIONS(2618),
    [anon_sym_uR_DQUOTE] = ACTIONS(2618),
    [anon_sym_UR_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2618),
    [anon_sym_co_await] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2616),
    [anon_sym_requires] = ACTIONS(2616),
    [sym_this] = ACTIONS(2616),
    [anon_sym_discard] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
    [anon_sym_cbuffer] = ACTIONS(2616),
  },
  [641] = {
    [sym_identifier] = ACTIONS(2580),
    [aux_sym_preproc_include_token1] = ACTIONS(2580),
    [aux_sym_preproc_def_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2580),
    [sym_preproc_directive] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym___extension__] = ACTIONS(2580),
    [anon_sym_typedef] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2580),
    [anon_sym_out] = ACTIONS(2580),
    [anon_sym_inout] = ACTIONS(2580),
    [anon_sym_virtual] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym___attribute__] = ACTIONS(2580),
    [anon_sym___attribute] = ACTIONS(2580),
    [anon_sym_using] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2582),
    [anon_sym___declspec] = ACTIONS(2580),
    [anon_sym___based] = ACTIONS(2580),
    [anon_sym___cdecl] = ACTIONS(2580),
    [anon_sym___clrcall] = ACTIONS(2580),
    [anon_sym___stdcall] = ACTIONS(2580),
    [anon_sym___fastcall] = ACTIONS(2580),
    [anon_sym___thiscall] = ACTIONS(2580),
    [anon_sym___vectorcall] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_RBRACE] = ACTIONS(2582),
    [anon_sym_signed] = ACTIONS(2580),
    [anon_sym_unsigned] = ACTIONS(2580),
    [anon_sym_long] = ACTIONS(2580),
    [anon_sym_short] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_register] = ACTIONS(2580),
    [anon_sym_inline] = ACTIONS(2580),
    [anon_sym___inline] = ACTIONS(2580),
    [anon_sym___inline__] = ACTIONS(2580),
    [anon_sym___forceinline] = ACTIONS(2580),
    [anon_sym_thread_local] = ACTIONS(2580),
    [anon_sym___thread] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_constexpr] = ACTIONS(2580),
    [anon_sym_volatile] = ACTIONS(2580),
    [anon_sym_restrict] = ACTIONS(2580),
    [anon_sym___restrict__] = ACTIONS(2580),
    [anon_sym__Atomic] = ACTIONS(2580),
    [anon_sym__Noreturn] = ACTIONS(2580),
    [anon_sym_noreturn] = ACTIONS(2580),
    [anon_sym__Nonnull] = ACTIONS(2580),
    [anon_sym_mutable] = ACTIONS(2580),
    [anon_sym_constinit] = ACTIONS(2580),
    [anon_sym_consteval] = ACTIONS(2580),
    [anon_sym_alignas] = ACTIONS(2580),
    [anon_sym__Alignas] = ACTIONS(2580),
    [sym_primitive_type] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_goto] = ACTIONS(2580),
    [anon_sym___try] = ACTIONS(2580),
    [anon_sym___leave] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2580),
    [anon_sym_compl] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_sizeof] = ACTIONS(2580),
    [anon_sym___alignof__] = ACTIONS(2580),
    [anon_sym___alignof] = ACTIONS(2580),
    [anon_sym__alignof] = ACTIONS(2580),
    [anon_sym_alignof] = ACTIONS(2580),
    [anon_sym__Alignof] = ACTIONS(2580),
    [anon_sym_offsetof] = ACTIONS(2580),
    [anon_sym__Generic] = ACTIONS(2580),
    [anon_sym_asm] = ACTIONS(2580),
    [anon_sym___asm__] = ACTIONS(2580),
    [anon_sym___asm] = ACTIONS(2580),
    [sym_number_literal] = ACTIONS(2582),
    [anon_sym_L_SQUOTE] = ACTIONS(2582),
    [anon_sym_u_SQUOTE] = ACTIONS(2582),
    [anon_sym_U_SQUOTE] = ACTIONS(2582),
    [anon_sym_u8_SQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_L_DQUOTE] = ACTIONS(2582),
    [anon_sym_u_DQUOTE] = ACTIONS(2582),
    [anon_sym_U_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8_DQUOTE] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [anon_sym_NULL] = ACTIONS(2580),
    [anon_sym_nullptr] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2580),
    [anon_sym_decltype] = ACTIONS(2580),
    [anon_sym_explicit] = ACTIONS(2580),
    [anon_sym_typename] = ACTIONS(2580),
    [anon_sym_template] = ACTIONS(2580),
    [anon_sym_operator] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_static_assert] = ACTIONS(2580),
    [anon_sym_concept] = ACTIONS(2580),
    [anon_sym_co_return] = ACTIONS(2580),
    [anon_sym_co_yield] = ACTIONS(2580),
    [anon_sym_R_DQUOTE] = ACTIONS(2582),
    [anon_sym_LR_DQUOTE] = ACTIONS(2582),
    [anon_sym_uR_DQUOTE] = ACTIONS(2582),
    [anon_sym_UR_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2582),
    [anon_sym_co_await] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2580),
    [sym_this] = ACTIONS(2580),
    [anon_sym_discard] = ACTIONS(2580),
    [anon_sym_precise] = ACTIONS(2580),
    [anon_sym_shared] = ACTIONS(2580),
    [anon_sym_groupshared] = ACTIONS(2580),
    [anon_sym_uniform] = ACTIONS(2580),
    [anon_sym_row_major] = ACTIONS(2580),
    [anon_sym_column_major] = ACTIONS(2580),
    [anon_sym_globallycoherent] = ACTIONS(2580),
    [anon_sym_centroid] = ACTIONS(2580),
    [anon_sym_noperspective] = ACTIONS(2580),
    [anon_sym_nointerpolation] = ACTIONS(2580),
    [anon_sym_sample] = ACTIONS(2580),
    [anon_sym_linear] = ACTIONS(2580),
    [anon_sym_snorm] = ACTIONS(2580),
    [anon_sym_unorm] = ACTIONS(2580),
    [anon_sym_point] = ACTIONS(2580),
    [anon_sym_line] = ACTIONS(2580),
    [anon_sym_triangleadj] = ACTIONS(2580),
    [anon_sym_lineadj] = ACTIONS(2580),
    [anon_sym_triangle] = ACTIONS(2580),
    [anon_sym_cbuffer] = ACTIONS(2580),
  },
  [642] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_include_token1] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token2] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym___cdecl] = ACTIONS(2660),
    [anon_sym___clrcall] = ACTIONS(2660),
    [anon_sym___stdcall] = ACTIONS(2660),
    [anon_sym___fastcall] = ACTIONS(2660),
    [anon_sym___thiscall] = ACTIONS(2660),
    [anon_sym___vectorcall] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_goto] = ACTIONS(2660),
    [anon_sym___try] = ACTIONS(2660),
    [anon_sym___leave] = ACTIONS(2660),
    [anon_sym_not] = ACTIONS(2660),
    [anon_sym_compl] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_sizeof] = ACTIONS(2660),
    [anon_sym___alignof__] = ACTIONS(2660),
    [anon_sym___alignof] = ACTIONS(2660),
    [anon_sym__alignof] = ACTIONS(2660),
    [anon_sym_alignof] = ACTIONS(2660),
    [anon_sym__Alignof] = ACTIONS(2660),
    [anon_sym_offsetof] = ACTIONS(2660),
    [anon_sym__Generic] = ACTIONS(2660),
    [anon_sym_asm] = ACTIONS(2660),
    [anon_sym___asm__] = ACTIONS(2660),
    [anon_sym___asm] = ACTIONS(2660),
    [sym_number_literal] = ACTIONS(2662),
    [anon_sym_L_SQUOTE] = ACTIONS(2662),
    [anon_sym_u_SQUOTE] = ACTIONS(2662),
    [anon_sym_U_SQUOTE] = ACTIONS(2662),
    [anon_sym_u8_SQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_L_DQUOTE] = ACTIONS(2662),
    [anon_sym_u_DQUOTE] = ACTIONS(2662),
    [anon_sym_U_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8_DQUOTE] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [anon_sym_NULL] = ACTIONS(2660),
    [anon_sym_nullptr] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_concept] = ACTIONS(2660),
    [anon_sym_co_return] = ACTIONS(2660),
    [anon_sym_co_yield] = ACTIONS(2660),
    [anon_sym_R_DQUOTE] = ACTIONS(2662),
    [anon_sym_LR_DQUOTE] = ACTIONS(2662),
    [anon_sym_uR_DQUOTE] = ACTIONS(2662),
    [anon_sym_UR_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2662),
    [anon_sym_co_await] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_requires] = ACTIONS(2660),
    [sym_this] = ACTIONS(2660),
    [anon_sym_discard] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
    [anon_sym_cbuffer] = ACTIONS(2660),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_include_token1] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token2] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym___cdecl] = ACTIONS(2692),
    [anon_sym___clrcall] = ACTIONS(2692),
    [anon_sym___stdcall] = ACTIONS(2692),
    [anon_sym___fastcall] = ACTIONS(2692),
    [anon_sym___thiscall] = ACTIONS(2692),
    [anon_sym___vectorcall] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_goto] = ACTIONS(2692),
    [anon_sym___try] = ACTIONS(2692),
    [anon_sym___leave] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_compl] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_sizeof] = ACTIONS(2692),
    [anon_sym___alignof__] = ACTIONS(2692),
    [anon_sym___alignof] = ACTIONS(2692),
    [anon_sym__alignof] = ACTIONS(2692),
    [anon_sym_alignof] = ACTIONS(2692),
    [anon_sym__Alignof] = ACTIONS(2692),
    [anon_sym_offsetof] = ACTIONS(2692),
    [anon_sym__Generic] = ACTIONS(2692),
    [anon_sym_asm] = ACTIONS(2692),
    [anon_sym___asm__] = ACTIONS(2692),
    [anon_sym___asm] = ACTIONS(2692),
    [sym_number_literal] = ACTIONS(2694),
    [anon_sym_L_SQUOTE] = ACTIONS(2694),
    [anon_sym_u_SQUOTE] = ACTIONS(2694),
    [anon_sym_U_SQUOTE] = ACTIONS(2694),
    [anon_sym_u8_SQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [anon_sym_L_DQUOTE] = ACTIONS(2694),
    [anon_sym_u_DQUOTE] = ACTIONS(2694),
    [anon_sym_U_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8_DQUOTE] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [anon_sym_NULL] = ACTIONS(2692),
    [anon_sym_nullptr] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_concept] = ACTIONS(2692),
    [anon_sym_co_return] = ACTIONS(2692),
    [anon_sym_co_yield] = ACTIONS(2692),
    [anon_sym_R_DQUOTE] = ACTIONS(2694),
    [anon_sym_LR_DQUOTE] = ACTIONS(2694),
    [anon_sym_uR_DQUOTE] = ACTIONS(2694),
    [anon_sym_UR_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2694),
    [anon_sym_co_await] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_requires] = ACTIONS(2692),
    [sym_this] = ACTIONS(2692),
    [anon_sym_discard] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
    [anon_sym_cbuffer] = ACTIONS(2692),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_include_token1] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym___cdecl] = ACTIONS(2660),
    [anon_sym___clrcall] = ACTIONS(2660),
    [anon_sym___stdcall] = ACTIONS(2660),
    [anon_sym___fastcall] = ACTIONS(2660),
    [anon_sym___thiscall] = ACTIONS(2660),
    [anon_sym___vectorcall] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_goto] = ACTIONS(2660),
    [anon_sym___try] = ACTIONS(2660),
    [anon_sym___leave] = ACTIONS(2660),
    [anon_sym_not] = ACTIONS(2660),
    [anon_sym_compl] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_sizeof] = ACTIONS(2660),
    [anon_sym___alignof__] = ACTIONS(2660),
    [anon_sym___alignof] = ACTIONS(2660),
    [anon_sym__alignof] = ACTIONS(2660),
    [anon_sym_alignof] = ACTIONS(2660),
    [anon_sym__Alignof] = ACTIONS(2660),
    [anon_sym_offsetof] = ACTIONS(2660),
    [anon_sym__Generic] = ACTIONS(2660),
    [anon_sym_asm] = ACTIONS(2660),
    [anon_sym___asm__] = ACTIONS(2660),
    [anon_sym___asm] = ACTIONS(2660),
    [sym_number_literal] = ACTIONS(2662),
    [anon_sym_L_SQUOTE] = ACTIONS(2662),
    [anon_sym_u_SQUOTE] = ACTIONS(2662),
    [anon_sym_U_SQUOTE] = ACTIONS(2662),
    [anon_sym_u8_SQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_L_DQUOTE] = ACTIONS(2662),
    [anon_sym_u_DQUOTE] = ACTIONS(2662),
    [anon_sym_U_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8_DQUOTE] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [anon_sym_NULL] = ACTIONS(2660),
    [anon_sym_nullptr] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_concept] = ACTIONS(2660),
    [anon_sym_co_return] = ACTIONS(2660),
    [anon_sym_co_yield] = ACTIONS(2660),
    [anon_sym_R_DQUOTE] = ACTIONS(2662),
    [anon_sym_LR_DQUOTE] = ACTIONS(2662),
    [anon_sym_uR_DQUOTE] = ACTIONS(2662),
    [anon_sym_UR_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2662),
    [anon_sym_co_await] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_requires] = ACTIONS(2660),
    [sym_this] = ACTIONS(2660),
    [anon_sym_discard] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
    [anon_sym_cbuffer] = ACTIONS(2660),
  },
  [646] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_include_token1] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token2] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym___cdecl] = ACTIONS(2449),
    [anon_sym___clrcall] = ACTIONS(2449),
    [anon_sym___stdcall] = ACTIONS(2449),
    [anon_sym___fastcall] = ACTIONS(2449),
    [anon_sym___thiscall] = ACTIONS(2449),
    [anon_sym___vectorcall] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_goto] = ACTIONS(2449),
    [anon_sym___try] = ACTIONS(2449),
    [anon_sym___leave] = ACTIONS(2449),
    [anon_sym_not] = ACTIONS(2449),
    [anon_sym_compl] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_sizeof] = ACTIONS(2449),
    [anon_sym___alignof__] = ACTIONS(2449),
    [anon_sym___alignof] = ACTIONS(2449),
    [anon_sym__alignof] = ACTIONS(2449),
    [anon_sym_alignof] = ACTIONS(2449),
    [anon_sym__Alignof] = ACTIONS(2449),
    [anon_sym_offsetof] = ACTIONS(2449),
    [anon_sym__Generic] = ACTIONS(2449),
    [anon_sym_asm] = ACTIONS(2449),
    [anon_sym___asm__] = ACTIONS(2449),
    [anon_sym___asm] = ACTIONS(2449),
    [sym_number_literal] = ACTIONS(2451),
    [anon_sym_L_SQUOTE] = ACTIONS(2451),
    [anon_sym_u_SQUOTE] = ACTIONS(2451),
    [anon_sym_U_SQUOTE] = ACTIONS(2451),
    [anon_sym_u8_SQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_L_DQUOTE] = ACTIONS(2451),
    [anon_sym_u_DQUOTE] = ACTIONS(2451),
    [anon_sym_U_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8_DQUOTE] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [anon_sym_NULL] = ACTIONS(2449),
    [anon_sym_nullptr] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_concept] = ACTIONS(2449),
    [anon_sym_co_return] = ACTIONS(2449),
    [anon_sym_co_yield] = ACTIONS(2449),
    [anon_sym_R_DQUOTE] = ACTIONS(2451),
    [anon_sym_LR_DQUOTE] = ACTIONS(2451),
    [anon_sym_uR_DQUOTE] = ACTIONS(2451),
    [anon_sym_UR_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2451),
    [anon_sym_co_await] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_requires] = ACTIONS(2449),
    [sym_this] = ACTIONS(2449),
    [anon_sym_discard] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
    [anon_sym_cbuffer] = ACTIONS(2449),
  },
  [647] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_include_token1] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token2] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym___cdecl] = ACTIONS(2470),
    [anon_sym___clrcall] = ACTIONS(2470),
    [anon_sym___stdcall] = ACTIONS(2470),
    [anon_sym___fastcall] = ACTIONS(2470),
    [anon_sym___thiscall] = ACTIONS(2470),
    [anon_sym___vectorcall] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym___try] = ACTIONS(2470),
    [anon_sym___leave] = ACTIONS(2470),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_compl] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym___alignof__] = ACTIONS(2470),
    [anon_sym___alignof] = ACTIONS(2470),
    [anon_sym__alignof] = ACTIONS(2470),
    [anon_sym_alignof] = ACTIONS(2470),
    [anon_sym__Alignof] = ACTIONS(2470),
    [anon_sym_offsetof] = ACTIONS(2470),
    [anon_sym__Generic] = ACTIONS(2470),
    [anon_sym_asm] = ACTIONS(2470),
    [anon_sym___asm__] = ACTIONS(2470),
    [anon_sym___asm] = ACTIONS(2470),
    [sym_number_literal] = ACTIONS(2472),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2472),
    [anon_sym_u_DQUOTE] = ACTIONS(2472),
    [anon_sym_U_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [anon_sym_NULL] = ACTIONS(2470),
    [anon_sym_nullptr] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_concept] = ACTIONS(2470),
    [anon_sym_co_return] = ACTIONS(2470),
    [anon_sym_co_yield] = ACTIONS(2470),
    [anon_sym_R_DQUOTE] = ACTIONS(2472),
    [anon_sym_LR_DQUOTE] = ACTIONS(2472),
    [anon_sym_uR_DQUOTE] = ACTIONS(2472),
    [anon_sym_UR_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2472),
    [anon_sym_co_await] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_requires] = ACTIONS(2470),
    [sym_this] = ACTIONS(2470),
    [anon_sym_discard] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
    [anon_sym_cbuffer] = ACTIONS(2470),
  },
  [648] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [anon_sym___asm] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym_discard] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
    [anon_sym_cbuffer] = ACTIONS(2500),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_include_token1] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym___cdecl] = ACTIONS(2692),
    [anon_sym___clrcall] = ACTIONS(2692),
    [anon_sym___stdcall] = ACTIONS(2692),
    [anon_sym___fastcall] = ACTIONS(2692),
    [anon_sym___thiscall] = ACTIONS(2692),
    [anon_sym___vectorcall] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_goto] = ACTIONS(2692),
    [anon_sym___try] = ACTIONS(2692),
    [anon_sym___leave] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_compl] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_sizeof] = ACTIONS(2692),
    [anon_sym___alignof__] = ACTIONS(2692),
    [anon_sym___alignof] = ACTIONS(2692),
    [anon_sym__alignof] = ACTIONS(2692),
    [anon_sym_alignof] = ACTIONS(2692),
    [anon_sym__Alignof] = ACTIONS(2692),
    [anon_sym_offsetof] = ACTIONS(2692),
    [anon_sym__Generic] = ACTIONS(2692),
    [anon_sym_asm] = ACTIONS(2692),
    [anon_sym___asm__] = ACTIONS(2692),
    [anon_sym___asm] = ACTIONS(2692),
    [sym_number_literal] = ACTIONS(2694),
    [anon_sym_L_SQUOTE] = ACTIONS(2694),
    [anon_sym_u_SQUOTE] = ACTIONS(2694),
    [anon_sym_U_SQUOTE] = ACTIONS(2694),
    [anon_sym_u8_SQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [anon_sym_L_DQUOTE] = ACTIONS(2694),
    [anon_sym_u_DQUOTE] = ACTIONS(2694),
    [anon_sym_U_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8_DQUOTE] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [anon_sym_NULL] = ACTIONS(2692),
    [anon_sym_nullptr] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_concept] = ACTIONS(2692),
    [anon_sym_co_return] = ACTIONS(2692),
    [anon_sym_co_yield] = ACTIONS(2692),
    [anon_sym_R_DQUOTE] = ACTIONS(2694),
    [anon_sym_LR_DQUOTE] = ACTIONS(2694),
    [anon_sym_uR_DQUOTE] = ACTIONS(2694),
    [anon_sym_UR_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2694),
    [anon_sym_co_await] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_requires] = ACTIONS(2692),
    [sym_this] = ACTIONS(2692),
    [anon_sym_discard] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
    [anon_sym_cbuffer] = ACTIONS(2692),
  },
  [650] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym___try] = ACTIONS(2410),
    [anon_sym___leave] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_discard] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
    [anon_sym_cbuffer] = ACTIONS(2410),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [anon_sym___asm] = ACTIONS(2488),
    [sym_number_literal] = ACTIONS(2490),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
    [anon_sym_discard] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
    [anon_sym_cbuffer] = ACTIONS(2488),
  },
  [652] = {
    [sym_identifier] = ACTIONS(2580),
    [aux_sym_preproc_include_token1] = ACTIONS(2580),
    [aux_sym_preproc_def_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token2] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2580),
    [sym_preproc_directive] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym___extension__] = ACTIONS(2580),
    [anon_sym_typedef] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2580),
    [anon_sym_out] = ACTIONS(2580),
    [anon_sym_inout] = ACTIONS(2580),
    [anon_sym_virtual] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym___attribute__] = ACTIONS(2580),
    [anon_sym___attribute] = ACTIONS(2580),
    [anon_sym_using] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2582),
    [anon_sym___declspec] = ACTIONS(2580),
    [anon_sym___based] = ACTIONS(2580),
    [anon_sym___cdecl] = ACTIONS(2580),
    [anon_sym___clrcall] = ACTIONS(2580),
    [anon_sym___stdcall] = ACTIONS(2580),
    [anon_sym___fastcall] = ACTIONS(2580),
    [anon_sym___thiscall] = ACTIONS(2580),
    [anon_sym___vectorcall] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_signed] = ACTIONS(2580),
    [anon_sym_unsigned] = ACTIONS(2580),
    [anon_sym_long] = ACTIONS(2580),
    [anon_sym_short] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_register] = ACTIONS(2580),
    [anon_sym_inline] = ACTIONS(2580),
    [anon_sym___inline] = ACTIONS(2580),
    [anon_sym___inline__] = ACTIONS(2580),
    [anon_sym___forceinline] = ACTIONS(2580),
    [anon_sym_thread_local] = ACTIONS(2580),
    [anon_sym___thread] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_constexpr] = ACTIONS(2580),
    [anon_sym_volatile] = ACTIONS(2580),
    [anon_sym_restrict] = ACTIONS(2580),
    [anon_sym___restrict__] = ACTIONS(2580),
    [anon_sym__Atomic] = ACTIONS(2580),
    [anon_sym__Noreturn] = ACTIONS(2580),
    [anon_sym_noreturn] = ACTIONS(2580),
    [anon_sym__Nonnull] = ACTIONS(2580),
    [anon_sym_mutable] = ACTIONS(2580),
    [anon_sym_constinit] = ACTIONS(2580),
    [anon_sym_consteval] = ACTIONS(2580),
    [anon_sym_alignas] = ACTIONS(2580),
    [anon_sym__Alignas] = ACTIONS(2580),
    [sym_primitive_type] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_goto] = ACTIONS(2580),
    [anon_sym___try] = ACTIONS(2580),
    [anon_sym___leave] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2580),
    [anon_sym_compl] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_sizeof] = ACTIONS(2580),
    [anon_sym___alignof__] = ACTIONS(2580),
    [anon_sym___alignof] = ACTIONS(2580),
    [anon_sym__alignof] = ACTIONS(2580),
    [anon_sym_alignof] = ACTIONS(2580),
    [anon_sym__Alignof] = ACTIONS(2580),
    [anon_sym_offsetof] = ACTIONS(2580),
    [anon_sym__Generic] = ACTIONS(2580),
    [anon_sym_asm] = ACTIONS(2580),
    [anon_sym___asm__] = ACTIONS(2580),
    [anon_sym___asm] = ACTIONS(2580),
    [sym_number_literal] = ACTIONS(2582),
    [anon_sym_L_SQUOTE] = ACTIONS(2582),
    [anon_sym_u_SQUOTE] = ACTIONS(2582),
    [anon_sym_U_SQUOTE] = ACTIONS(2582),
    [anon_sym_u8_SQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_L_DQUOTE] = ACTIONS(2582),
    [anon_sym_u_DQUOTE] = ACTIONS(2582),
    [anon_sym_U_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8_DQUOTE] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [anon_sym_NULL] = ACTIONS(2580),
    [anon_sym_nullptr] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2580),
    [anon_sym_decltype] = ACTIONS(2580),
    [anon_sym_explicit] = ACTIONS(2580),
    [anon_sym_typename] = ACTIONS(2580),
    [anon_sym_template] = ACTIONS(2580),
    [anon_sym_operator] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_static_assert] = ACTIONS(2580),
    [anon_sym_concept] = ACTIONS(2580),
    [anon_sym_co_return] = ACTIONS(2580),
    [anon_sym_co_yield] = ACTIONS(2580),
    [anon_sym_R_DQUOTE] = ACTIONS(2582),
    [anon_sym_LR_DQUOTE] = ACTIONS(2582),
    [anon_sym_uR_DQUOTE] = ACTIONS(2582),
    [anon_sym_UR_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2582),
    [anon_sym_co_await] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2580),
    [sym_this] = ACTIONS(2580),
    [anon_sym_discard] = ACTIONS(2580),
    [anon_sym_precise] = ACTIONS(2580),
    [anon_sym_shared] = ACTIONS(2580),
    [anon_sym_groupshared] = ACTIONS(2580),
    [anon_sym_uniform] = ACTIONS(2580),
    [anon_sym_row_major] = ACTIONS(2580),
    [anon_sym_column_major] = ACTIONS(2580),
    [anon_sym_globallycoherent] = ACTIONS(2580),
    [anon_sym_centroid] = ACTIONS(2580),
    [anon_sym_noperspective] = ACTIONS(2580),
    [anon_sym_nointerpolation] = ACTIONS(2580),
    [anon_sym_sample] = ACTIONS(2580),
    [anon_sym_linear] = ACTIONS(2580),
    [anon_sym_snorm] = ACTIONS(2580),
    [anon_sym_unorm] = ACTIONS(2580),
    [anon_sym_point] = ACTIONS(2580),
    [anon_sym_line] = ACTIONS(2580),
    [anon_sym_triangleadj] = ACTIONS(2580),
    [anon_sym_lineadj] = ACTIONS(2580),
    [anon_sym_triangle] = ACTIONS(2580),
    [anon_sym_cbuffer] = ACTIONS(2580),
  },
  [653] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_include_token1] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym___cdecl] = ACTIONS(2449),
    [anon_sym___clrcall] = ACTIONS(2449),
    [anon_sym___stdcall] = ACTIONS(2449),
    [anon_sym___fastcall] = ACTIONS(2449),
    [anon_sym___thiscall] = ACTIONS(2449),
    [anon_sym___vectorcall] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_goto] = ACTIONS(2449),
    [anon_sym___try] = ACTIONS(2449),
    [anon_sym___leave] = ACTIONS(2449),
    [anon_sym_not] = ACTIONS(2449),
    [anon_sym_compl] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_sizeof] = ACTIONS(2449),
    [anon_sym___alignof__] = ACTIONS(2449),
    [anon_sym___alignof] = ACTIONS(2449),
    [anon_sym__alignof] = ACTIONS(2449),
    [anon_sym_alignof] = ACTIONS(2449),
    [anon_sym__Alignof] = ACTIONS(2449),
    [anon_sym_offsetof] = ACTIONS(2449),
    [anon_sym__Generic] = ACTIONS(2449),
    [anon_sym_asm] = ACTIONS(2449),
    [anon_sym___asm__] = ACTIONS(2449),
    [anon_sym___asm] = ACTIONS(2449),
    [sym_number_literal] = ACTIONS(2451),
    [anon_sym_L_SQUOTE] = ACTIONS(2451),
    [anon_sym_u_SQUOTE] = ACTIONS(2451),
    [anon_sym_U_SQUOTE] = ACTIONS(2451),
    [anon_sym_u8_SQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_L_DQUOTE] = ACTIONS(2451),
    [anon_sym_u_DQUOTE] = ACTIONS(2451),
    [anon_sym_U_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8_DQUOTE] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [anon_sym_NULL] = ACTIONS(2449),
    [anon_sym_nullptr] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_concept] = ACTIONS(2449),
    [anon_sym_co_return] = ACTIONS(2449),
    [anon_sym_co_yield] = ACTIONS(2449),
    [anon_sym_R_DQUOTE] = ACTIONS(2451),
    [anon_sym_LR_DQUOTE] = ACTIONS(2451),
    [anon_sym_uR_DQUOTE] = ACTIONS(2451),
    [anon_sym_UR_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2451),
    [anon_sym_co_await] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_requires] = ACTIONS(2449),
    [sym_this] = ACTIONS(2449),
    [anon_sym_discard] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
    [anon_sym_cbuffer] = ACTIONS(2449),
  },
  [654] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_include_token1] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token2] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym___cdecl] = ACTIONS(2560),
    [anon_sym___clrcall] = ACTIONS(2560),
    [anon_sym___stdcall] = ACTIONS(2560),
    [anon_sym___fastcall] = ACTIONS(2560),
    [anon_sym___thiscall] = ACTIONS(2560),
    [anon_sym___vectorcall] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_switch] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_do] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(2560),
    [anon_sym___try] = ACTIONS(2560),
    [anon_sym___leave] = ACTIONS(2560),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2560),
    [anon_sym___alignof__] = ACTIONS(2560),
    [anon_sym___alignof] = ACTIONS(2560),
    [anon_sym__alignof] = ACTIONS(2560),
    [anon_sym_alignof] = ACTIONS(2560),
    [anon_sym__Alignof] = ACTIONS(2560),
    [anon_sym_offsetof] = ACTIONS(2560),
    [anon_sym__Generic] = ACTIONS(2560),
    [anon_sym_asm] = ACTIONS(2560),
    [anon_sym___asm__] = ACTIONS(2560),
    [anon_sym___asm] = ACTIONS(2560),
    [sym_number_literal] = ACTIONS(2562),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2560),
    [sym_false] = ACTIONS(2560),
    [anon_sym_NULL] = ACTIONS(2560),
    [anon_sym_nullptr] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [anon_sym_delete] = ACTIONS(2560),
    [anon_sym_throw] = ACTIONS(2560),
    [anon_sym_namespace] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_concept] = ACTIONS(2560),
    [anon_sym_co_return] = ACTIONS(2560),
    [anon_sym_co_yield] = ACTIONS(2560),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2560),
    [anon_sym_new] = ACTIONS(2560),
    [anon_sym_requires] = ACTIONS(2560),
    [sym_this] = ACTIONS(2560),
    [anon_sym_discard] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
    [anon_sym_cbuffer] = ACTIONS(2560),
  },
  [655] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_include_token1] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token2] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym___cdecl] = ACTIONS(2564),
    [anon_sym___clrcall] = ACTIONS(2564),
    [anon_sym___stdcall] = ACTIONS(2564),
    [anon_sym___fastcall] = ACTIONS(2564),
    [anon_sym___thiscall] = ACTIONS(2564),
    [anon_sym___vectorcall] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_switch] = ACTIONS(2564),
    [anon_sym_case] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_goto] = ACTIONS(2564),
    [anon_sym___try] = ACTIONS(2564),
    [anon_sym___leave] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2564),
    [anon_sym_compl] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2566),
    [anon_sym_sizeof] = ACTIONS(2564),
    [anon_sym___alignof__] = ACTIONS(2564),
    [anon_sym___alignof] = ACTIONS(2564),
    [anon_sym__alignof] = ACTIONS(2564),
    [anon_sym_alignof] = ACTIONS(2564),
    [anon_sym__Alignof] = ACTIONS(2564),
    [anon_sym_offsetof] = ACTIONS(2564),
    [anon_sym__Generic] = ACTIONS(2564),
    [anon_sym_asm] = ACTIONS(2564),
    [anon_sym___asm__] = ACTIONS(2564),
    [anon_sym___asm] = ACTIONS(2564),
    [sym_number_literal] = ACTIONS(2566),
    [anon_sym_L_SQUOTE] = ACTIONS(2566),
    [anon_sym_u_SQUOTE] = ACTIONS(2566),
    [anon_sym_U_SQUOTE] = ACTIONS(2566),
    [anon_sym_u8_SQUOTE] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_L_DQUOTE] = ACTIONS(2566),
    [anon_sym_u_DQUOTE] = ACTIONS(2566),
    [anon_sym_U_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8_DQUOTE] = ACTIONS(2566),
    [anon_sym_DQUOTE] = ACTIONS(2566),
    [sym_true] = ACTIONS(2564),
    [sym_false] = ACTIONS(2564),
    [anon_sym_NULL] = ACTIONS(2564),
    [anon_sym_nullptr] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [anon_sym_delete] = ACTIONS(2564),
    [anon_sym_throw] = ACTIONS(2564),
    [anon_sym_namespace] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_concept] = ACTIONS(2564),
    [anon_sym_co_return] = ACTIONS(2564),
    [anon_sym_co_yield] = ACTIONS(2564),
    [anon_sym_R_DQUOTE] = ACTIONS(2566),
    [anon_sym_LR_DQUOTE] = ACTIONS(2566),
    [anon_sym_uR_DQUOTE] = ACTIONS(2566),
    [anon_sym_UR_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2566),
    [anon_sym_co_await] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2564),
    [anon_sym_requires] = ACTIONS(2564),
    [sym_this] = ACTIONS(2564),
    [anon_sym_discard] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
    [anon_sym_cbuffer] = ACTIONS(2564),
  },
  [656] = {
    [sym_identifier] = ACTIONS(2584),
    [aux_sym_preproc_include_token1] = ACTIONS(2584),
    [aux_sym_preproc_def_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token2] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2584),
    [sym_preproc_directive] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym___extension__] = ACTIONS(2584),
    [anon_sym_typedef] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2584),
    [anon_sym_out] = ACTIONS(2584),
    [anon_sym_inout] = ACTIONS(2584),
    [anon_sym_virtual] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym___attribute] = ACTIONS(2584),
    [anon_sym_using] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2586),
    [anon_sym___declspec] = ACTIONS(2584),
    [anon_sym___based] = ACTIONS(2584),
    [anon_sym___cdecl] = ACTIONS(2584),
    [anon_sym___clrcall] = ACTIONS(2584),
    [anon_sym___stdcall] = ACTIONS(2584),
    [anon_sym___fastcall] = ACTIONS(2584),
    [anon_sym___thiscall] = ACTIONS(2584),
    [anon_sym___vectorcall] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_signed] = ACTIONS(2584),
    [anon_sym_unsigned] = ACTIONS(2584),
    [anon_sym_long] = ACTIONS(2584),
    [anon_sym_short] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_register] = ACTIONS(2584),
    [anon_sym_inline] = ACTIONS(2584),
    [anon_sym___inline] = ACTIONS(2584),
    [anon_sym___inline__] = ACTIONS(2584),
    [anon_sym___forceinline] = ACTIONS(2584),
    [anon_sym_thread_local] = ACTIONS(2584),
    [anon_sym___thread] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_constexpr] = ACTIONS(2584),
    [anon_sym_volatile] = ACTIONS(2584),
    [anon_sym_restrict] = ACTIONS(2584),
    [anon_sym___restrict__] = ACTIONS(2584),
    [anon_sym__Atomic] = ACTIONS(2584),
    [anon_sym__Noreturn] = ACTIONS(2584),
    [anon_sym_noreturn] = ACTIONS(2584),
    [anon_sym__Nonnull] = ACTIONS(2584),
    [anon_sym_mutable] = ACTIONS(2584),
    [anon_sym_constinit] = ACTIONS(2584),
    [anon_sym_consteval] = ACTIONS(2584),
    [anon_sym_alignas] = ACTIONS(2584),
    [anon_sym__Alignas] = ACTIONS(2584),
    [sym_primitive_type] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_goto] = ACTIONS(2584),
    [anon_sym___try] = ACTIONS(2584),
    [anon_sym___leave] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2584),
    [anon_sym_compl] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_sizeof] = ACTIONS(2584),
    [anon_sym___alignof__] = ACTIONS(2584),
    [anon_sym___alignof] = ACTIONS(2584),
    [anon_sym__alignof] = ACTIONS(2584),
    [anon_sym_alignof] = ACTIONS(2584),
    [anon_sym__Alignof] = ACTIONS(2584),
    [anon_sym_offsetof] = ACTIONS(2584),
    [anon_sym__Generic] = ACTIONS(2584),
    [anon_sym_asm] = ACTIONS(2584),
    [anon_sym___asm__] = ACTIONS(2584),
    [anon_sym___asm] = ACTIONS(2584),
    [sym_number_literal] = ACTIONS(2586),
    [anon_sym_L_SQUOTE] = ACTIONS(2586),
    [anon_sym_u_SQUOTE] = ACTIONS(2586),
    [anon_sym_U_SQUOTE] = ACTIONS(2586),
    [anon_sym_u8_SQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_L_DQUOTE] = ACTIONS(2586),
    [anon_sym_u_DQUOTE] = ACTIONS(2586),
    [anon_sym_U_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8_DQUOTE] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [anon_sym_NULL] = ACTIONS(2584),
    [anon_sym_nullptr] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2584),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2584),
    [anon_sym_operator] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_static_assert] = ACTIONS(2584),
    [anon_sym_concept] = ACTIONS(2584),
    [anon_sym_co_return] = ACTIONS(2584),
    [anon_sym_co_yield] = ACTIONS(2584),
    [anon_sym_R_DQUOTE] = ACTIONS(2586),
    [anon_sym_LR_DQUOTE] = ACTIONS(2586),
    [anon_sym_uR_DQUOTE] = ACTIONS(2586),
    [anon_sym_UR_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2586),
    [anon_sym_co_await] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_requires] = ACTIONS(2584),
    [sym_this] = ACTIONS(2584),
    [anon_sym_discard] = ACTIONS(2584),
    [anon_sym_precise] = ACTIONS(2584),
    [anon_sym_shared] = ACTIONS(2584),
    [anon_sym_groupshared] = ACTIONS(2584),
    [anon_sym_uniform] = ACTIONS(2584),
    [anon_sym_row_major] = ACTIONS(2584),
    [anon_sym_column_major] = ACTIONS(2584),
    [anon_sym_globallycoherent] = ACTIONS(2584),
    [anon_sym_centroid] = ACTIONS(2584),
    [anon_sym_noperspective] = ACTIONS(2584),
    [anon_sym_nointerpolation] = ACTIONS(2584),
    [anon_sym_sample] = ACTIONS(2584),
    [anon_sym_linear] = ACTIONS(2584),
    [anon_sym_snorm] = ACTIONS(2584),
    [anon_sym_unorm] = ACTIONS(2584),
    [anon_sym_point] = ACTIONS(2584),
    [anon_sym_line] = ACTIONS(2584),
    [anon_sym_triangleadj] = ACTIONS(2584),
    [anon_sym_lineadj] = ACTIONS(2584),
    [anon_sym_triangle] = ACTIONS(2584),
    [anon_sym_cbuffer] = ACTIONS(2584),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2406),
    [anon_sym_L_SQUOTE] = ACTIONS(2406),
    [anon_sym_u_SQUOTE] = ACTIONS(2406),
    [anon_sym_U_SQUOTE] = ACTIONS(2406),
    [anon_sym_u8_SQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_L_DQUOTE] = ACTIONS(2406),
    [anon_sym_u_DQUOTE] = ACTIONS(2406),
    [anon_sym_U_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8_DQUOTE] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2406),
    [anon_sym_LR_DQUOTE] = ACTIONS(2406),
    [anon_sym_uR_DQUOTE] = ACTIONS(2406),
    [anon_sym_UR_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2406),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
  },
  [658] = {
    [sym_expression] = STATE(3848),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(3008),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [659] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [660] = {
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token2] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_out] = ACTIONS(2496),
    [anon_sym_inout] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym___attribute] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym__Nonnull] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym__Alignas] = ACTIONS(2496),
    [sym_primitive_type] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym___try] = ACTIONS(2496),
    [anon_sym___leave] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [anon_sym___asm] = ACTIONS(2496),
    [sym_number_literal] = ACTIONS(2498),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
    [anon_sym_discard] = ACTIONS(2496),
    [anon_sym_precise] = ACTIONS(2496),
    [anon_sym_shared] = ACTIONS(2496),
    [anon_sym_groupshared] = ACTIONS(2496),
    [anon_sym_uniform] = ACTIONS(2496),
    [anon_sym_row_major] = ACTIONS(2496),
    [anon_sym_column_major] = ACTIONS(2496),
    [anon_sym_globallycoherent] = ACTIONS(2496),
    [anon_sym_centroid] = ACTIONS(2496),
    [anon_sym_noperspective] = ACTIONS(2496),
    [anon_sym_nointerpolation] = ACTIONS(2496),
    [anon_sym_sample] = ACTIONS(2496),
    [anon_sym_linear] = ACTIONS(2496),
    [anon_sym_snorm] = ACTIONS(2496),
    [anon_sym_unorm] = ACTIONS(2496),
    [anon_sym_point] = ACTIONS(2496),
    [anon_sym_line] = ACTIONS(2496),
    [anon_sym_triangleadj] = ACTIONS(2496),
    [anon_sym_lineadj] = ACTIONS(2496),
    [anon_sym_triangle] = ACTIONS(2496),
    [anon_sym_cbuffer] = ACTIONS(2496),
  },
  [661] = {
    [sym_identifier] = ACTIONS(2441),
    [aux_sym_preproc_include_token1] = ACTIONS(2441),
    [aux_sym_preproc_def_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token2] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2441),
    [sym_preproc_directive] = ACTIONS(2441),
    [anon_sym_LPAREN2] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym___extension__] = ACTIONS(2441),
    [anon_sym_typedef] = ACTIONS(2441),
    [anon_sym_in] = ACTIONS(2441),
    [anon_sym_out] = ACTIONS(2441),
    [anon_sym_inout] = ACTIONS(2441),
    [anon_sym_virtual] = ACTIONS(2441),
    [anon_sym_extern] = ACTIONS(2441),
    [anon_sym___attribute__] = ACTIONS(2441),
    [anon_sym___attribute] = ACTIONS(2441),
    [anon_sym_using] = ACTIONS(2441),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2443),
    [anon_sym___declspec] = ACTIONS(2441),
    [anon_sym___based] = ACTIONS(2441),
    [anon_sym___cdecl] = ACTIONS(2441),
    [anon_sym___clrcall] = ACTIONS(2441),
    [anon_sym___stdcall] = ACTIONS(2441),
    [anon_sym___fastcall] = ACTIONS(2441),
    [anon_sym___thiscall] = ACTIONS(2441),
    [anon_sym___vectorcall] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_signed] = ACTIONS(2441),
    [anon_sym_unsigned] = ACTIONS(2441),
    [anon_sym_long] = ACTIONS(2441),
    [anon_sym_short] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_register] = ACTIONS(2441),
    [anon_sym_inline] = ACTIONS(2441),
    [anon_sym___inline] = ACTIONS(2441),
    [anon_sym___inline__] = ACTIONS(2441),
    [anon_sym___forceinline] = ACTIONS(2441),
    [anon_sym_thread_local] = ACTIONS(2441),
    [anon_sym___thread] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_constexpr] = ACTIONS(2441),
    [anon_sym_volatile] = ACTIONS(2441),
    [anon_sym_restrict] = ACTIONS(2441),
    [anon_sym___restrict__] = ACTIONS(2441),
    [anon_sym__Atomic] = ACTIONS(2441),
    [anon_sym__Noreturn] = ACTIONS(2441),
    [anon_sym_noreturn] = ACTIONS(2441),
    [anon_sym__Nonnull] = ACTIONS(2441),
    [anon_sym_mutable] = ACTIONS(2441),
    [anon_sym_constinit] = ACTIONS(2441),
    [anon_sym_consteval] = ACTIONS(2441),
    [anon_sym_alignas] = ACTIONS(2441),
    [anon_sym__Alignas] = ACTIONS(2441),
    [sym_primitive_type] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_struct] = ACTIONS(2441),
    [anon_sym_union] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_goto] = ACTIONS(2441),
    [anon_sym___try] = ACTIONS(2441),
    [anon_sym___leave] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2441),
    [anon_sym_compl] = ACTIONS(2441),
    [anon_sym_DASH_DASH] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_sizeof] = ACTIONS(2441),
    [anon_sym___alignof__] = ACTIONS(2441),
    [anon_sym___alignof] = ACTIONS(2441),
    [anon_sym__alignof] = ACTIONS(2441),
    [anon_sym_alignof] = ACTIONS(2441),
    [anon_sym__Alignof] = ACTIONS(2441),
    [anon_sym_offsetof] = ACTIONS(2441),
    [anon_sym__Generic] = ACTIONS(2441),
    [anon_sym_asm] = ACTIONS(2441),
    [anon_sym___asm__] = ACTIONS(2441),
    [anon_sym___asm] = ACTIONS(2441),
    [sym_number_literal] = ACTIONS(2443),
    [anon_sym_L_SQUOTE] = ACTIONS(2443),
    [anon_sym_u_SQUOTE] = ACTIONS(2443),
    [anon_sym_U_SQUOTE] = ACTIONS(2443),
    [anon_sym_u8_SQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_L_DQUOTE] = ACTIONS(2443),
    [anon_sym_u_DQUOTE] = ACTIONS(2443),
    [anon_sym_U_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8_DQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [anon_sym_NULL] = ACTIONS(2441),
    [anon_sym_nullptr] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2441),
    [anon_sym_decltype] = ACTIONS(2441),
    [anon_sym_explicit] = ACTIONS(2441),
    [anon_sym_typename] = ACTIONS(2441),
    [anon_sym_template] = ACTIONS(2441),
    [anon_sym_operator] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_static_assert] = ACTIONS(2441),
    [anon_sym_concept] = ACTIONS(2441),
    [anon_sym_co_return] = ACTIONS(2441),
    [anon_sym_co_yield] = ACTIONS(2441),
    [anon_sym_R_DQUOTE] = ACTIONS(2443),
    [anon_sym_LR_DQUOTE] = ACTIONS(2443),
    [anon_sym_uR_DQUOTE] = ACTIONS(2443),
    [anon_sym_UR_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2443),
    [anon_sym_co_await] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_requires] = ACTIONS(2441),
    [sym_this] = ACTIONS(2441),
    [anon_sym_discard] = ACTIONS(2441),
    [anon_sym_precise] = ACTIONS(2441),
    [anon_sym_shared] = ACTIONS(2441),
    [anon_sym_groupshared] = ACTIONS(2441),
    [anon_sym_uniform] = ACTIONS(2441),
    [anon_sym_row_major] = ACTIONS(2441),
    [anon_sym_column_major] = ACTIONS(2441),
    [anon_sym_globallycoherent] = ACTIONS(2441),
    [anon_sym_centroid] = ACTIONS(2441),
    [anon_sym_noperspective] = ACTIONS(2441),
    [anon_sym_nointerpolation] = ACTIONS(2441),
    [anon_sym_sample] = ACTIONS(2441),
    [anon_sym_linear] = ACTIONS(2441),
    [anon_sym_snorm] = ACTIONS(2441),
    [anon_sym_unorm] = ACTIONS(2441),
    [anon_sym_point] = ACTIONS(2441),
    [anon_sym_line] = ACTIONS(2441),
    [anon_sym_triangleadj] = ACTIONS(2441),
    [anon_sym_lineadj] = ACTIONS(2441),
    [anon_sym_triangle] = ACTIONS(2441),
    [anon_sym_cbuffer] = ACTIONS(2441),
  },
  [662] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_include_token1] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym___cdecl] = ACTIONS(2470),
    [anon_sym___clrcall] = ACTIONS(2470),
    [anon_sym___stdcall] = ACTIONS(2470),
    [anon_sym___fastcall] = ACTIONS(2470),
    [anon_sym___thiscall] = ACTIONS(2470),
    [anon_sym___vectorcall] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym___try] = ACTIONS(2470),
    [anon_sym___leave] = ACTIONS(2470),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_compl] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym___alignof__] = ACTIONS(2470),
    [anon_sym___alignof] = ACTIONS(2470),
    [anon_sym__alignof] = ACTIONS(2470),
    [anon_sym_alignof] = ACTIONS(2470),
    [anon_sym__Alignof] = ACTIONS(2470),
    [anon_sym_offsetof] = ACTIONS(2470),
    [anon_sym__Generic] = ACTIONS(2470),
    [anon_sym_asm] = ACTIONS(2470),
    [anon_sym___asm__] = ACTIONS(2470),
    [anon_sym___asm] = ACTIONS(2470),
    [sym_number_literal] = ACTIONS(2472),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2472),
    [anon_sym_u_DQUOTE] = ACTIONS(2472),
    [anon_sym_U_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [anon_sym_NULL] = ACTIONS(2470),
    [anon_sym_nullptr] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_concept] = ACTIONS(2470),
    [anon_sym_co_return] = ACTIONS(2470),
    [anon_sym_co_yield] = ACTIONS(2470),
    [anon_sym_R_DQUOTE] = ACTIONS(2472),
    [anon_sym_LR_DQUOTE] = ACTIONS(2472),
    [anon_sym_uR_DQUOTE] = ACTIONS(2472),
    [anon_sym_UR_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2472),
    [anon_sym_co_await] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_requires] = ACTIONS(2470),
    [sym_this] = ACTIONS(2470),
    [anon_sym_discard] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
    [anon_sym_cbuffer] = ACTIONS(2470),
  },
  [663] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym___try] = ACTIONS(2500),
    [anon_sym___leave] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [anon_sym___asm] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym_discard] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
    [anon_sym_cbuffer] = ACTIONS(2500),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_include_token1] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2592),
    [sym_preproc_directive] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym___extension__] = ACTIONS(2592),
    [anon_sym_typedef] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_out] = ACTIONS(2592),
    [anon_sym_inout] = ACTIONS(2592),
    [anon_sym_virtual] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym___attribute__] = ACTIONS(2592),
    [anon_sym___attribute] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2594),
    [anon_sym___declspec] = ACTIONS(2592),
    [anon_sym___based] = ACTIONS(2592),
    [anon_sym___cdecl] = ACTIONS(2592),
    [anon_sym___clrcall] = ACTIONS(2592),
    [anon_sym___stdcall] = ACTIONS(2592),
    [anon_sym___fastcall] = ACTIONS(2592),
    [anon_sym___thiscall] = ACTIONS(2592),
    [anon_sym___vectorcall] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_signed] = ACTIONS(2592),
    [anon_sym_unsigned] = ACTIONS(2592),
    [anon_sym_long] = ACTIONS(2592),
    [anon_sym_short] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_register] = ACTIONS(2592),
    [anon_sym_inline] = ACTIONS(2592),
    [anon_sym___inline] = ACTIONS(2592),
    [anon_sym___inline__] = ACTIONS(2592),
    [anon_sym___forceinline] = ACTIONS(2592),
    [anon_sym_thread_local] = ACTIONS(2592),
    [anon_sym___thread] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_constexpr] = ACTIONS(2592),
    [anon_sym_volatile] = ACTIONS(2592),
    [anon_sym_restrict] = ACTIONS(2592),
    [anon_sym___restrict__] = ACTIONS(2592),
    [anon_sym__Atomic] = ACTIONS(2592),
    [anon_sym__Noreturn] = ACTIONS(2592),
    [anon_sym_noreturn] = ACTIONS(2592),
    [anon_sym__Nonnull] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_constinit] = ACTIONS(2592),
    [anon_sym_consteval] = ACTIONS(2592),
    [anon_sym_alignas] = ACTIONS(2592),
    [anon_sym__Alignas] = ACTIONS(2592),
    [sym_primitive_type] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_goto] = ACTIONS(2592),
    [anon_sym___try] = ACTIONS(2592),
    [anon_sym___leave] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2592),
    [anon_sym_compl] = ACTIONS(2592),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_sizeof] = ACTIONS(2592),
    [anon_sym___alignof__] = ACTIONS(2592),
    [anon_sym___alignof] = ACTIONS(2592),
    [anon_sym__alignof] = ACTIONS(2592),
    [anon_sym_alignof] = ACTIONS(2592),
    [anon_sym__Alignof] = ACTIONS(2592),
    [anon_sym_offsetof] = ACTIONS(2592),
    [anon_sym__Generic] = ACTIONS(2592),
    [anon_sym_asm] = ACTIONS(2592),
    [anon_sym___asm__] = ACTIONS(2592),
    [anon_sym___asm] = ACTIONS(2592),
    [sym_number_literal] = ACTIONS(2594),
    [anon_sym_L_SQUOTE] = ACTIONS(2594),
    [anon_sym_u_SQUOTE] = ACTIONS(2594),
    [anon_sym_U_SQUOTE] = ACTIONS(2594),
    [anon_sym_u8_SQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_L_DQUOTE] = ACTIONS(2594),
    [anon_sym_u_DQUOTE] = ACTIONS(2594),
    [anon_sym_U_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8_DQUOTE] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [anon_sym_NULL] = ACTIONS(2592),
    [anon_sym_nullptr] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2592),
    [anon_sym_decltype] = ACTIONS(2592),
    [anon_sym_explicit] = ACTIONS(2592),
    [anon_sym_typename] = ACTIONS(2592),
    [anon_sym_template] = ACTIONS(2592),
    [anon_sym_operator] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_static_assert] = ACTIONS(2592),
    [anon_sym_concept] = ACTIONS(2592),
    [anon_sym_co_return] = ACTIONS(2592),
    [anon_sym_co_yield] = ACTIONS(2592),
    [anon_sym_R_DQUOTE] = ACTIONS(2594),
    [anon_sym_LR_DQUOTE] = ACTIONS(2594),
    [anon_sym_uR_DQUOTE] = ACTIONS(2594),
    [anon_sym_UR_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2594),
    [anon_sym_co_await] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_requires] = ACTIONS(2592),
    [sym_this] = ACTIONS(2592),
    [anon_sym_discard] = ACTIONS(2592),
    [anon_sym_precise] = ACTIONS(2592),
    [anon_sym_shared] = ACTIONS(2592),
    [anon_sym_groupshared] = ACTIONS(2592),
    [anon_sym_uniform] = ACTIONS(2592),
    [anon_sym_row_major] = ACTIONS(2592),
    [anon_sym_column_major] = ACTIONS(2592),
    [anon_sym_globallycoherent] = ACTIONS(2592),
    [anon_sym_centroid] = ACTIONS(2592),
    [anon_sym_noperspective] = ACTIONS(2592),
    [anon_sym_nointerpolation] = ACTIONS(2592),
    [anon_sym_sample] = ACTIONS(2592),
    [anon_sym_linear] = ACTIONS(2592),
    [anon_sym_snorm] = ACTIONS(2592),
    [anon_sym_unorm] = ACTIONS(2592),
    [anon_sym_point] = ACTIONS(2592),
    [anon_sym_line] = ACTIONS(2592),
    [anon_sym_triangleadj] = ACTIONS(2592),
    [anon_sym_lineadj] = ACTIONS(2592),
    [anon_sym_triangle] = ACTIONS(2592),
    [anon_sym_cbuffer] = ACTIONS(2592),
  },
  [665] = {
    [sym_identifier] = ACTIONS(2600),
    [aux_sym_preproc_include_token1] = ACTIONS(2600),
    [aux_sym_preproc_def_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2600),
    [sym_preproc_directive] = ACTIONS(2600),
    [anon_sym_LPAREN2] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym___extension__] = ACTIONS(2600),
    [anon_sym_typedef] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_out] = ACTIONS(2600),
    [anon_sym_inout] = ACTIONS(2600),
    [anon_sym_virtual] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym___attribute__] = ACTIONS(2600),
    [anon_sym___attribute] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2602),
    [anon_sym___declspec] = ACTIONS(2600),
    [anon_sym___based] = ACTIONS(2600),
    [anon_sym___cdecl] = ACTIONS(2600),
    [anon_sym___clrcall] = ACTIONS(2600),
    [anon_sym___stdcall] = ACTIONS(2600),
    [anon_sym___fastcall] = ACTIONS(2600),
    [anon_sym___thiscall] = ACTIONS(2600),
    [anon_sym___vectorcall] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_signed] = ACTIONS(2600),
    [anon_sym_unsigned] = ACTIONS(2600),
    [anon_sym_long] = ACTIONS(2600),
    [anon_sym_short] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_register] = ACTIONS(2600),
    [anon_sym_inline] = ACTIONS(2600),
    [anon_sym___inline] = ACTIONS(2600),
    [anon_sym___inline__] = ACTIONS(2600),
    [anon_sym___forceinline] = ACTIONS(2600),
    [anon_sym_thread_local] = ACTIONS(2600),
    [anon_sym___thread] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_constexpr] = ACTIONS(2600),
    [anon_sym_volatile] = ACTIONS(2600),
    [anon_sym_restrict] = ACTIONS(2600),
    [anon_sym___restrict__] = ACTIONS(2600),
    [anon_sym__Atomic] = ACTIONS(2600),
    [anon_sym__Noreturn] = ACTIONS(2600),
    [anon_sym_noreturn] = ACTIONS(2600),
    [anon_sym__Nonnull] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_constinit] = ACTIONS(2600),
    [anon_sym_consteval] = ACTIONS(2600),
    [anon_sym_alignas] = ACTIONS(2600),
    [anon_sym__Alignas] = ACTIONS(2600),
    [sym_primitive_type] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_goto] = ACTIONS(2600),
    [anon_sym___try] = ACTIONS(2600),
    [anon_sym___leave] = ACTIONS(2600),
    [anon_sym_not] = ACTIONS(2600),
    [anon_sym_compl] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_sizeof] = ACTIONS(2600),
    [anon_sym___alignof__] = ACTIONS(2600),
    [anon_sym___alignof] = ACTIONS(2600),
    [anon_sym__alignof] = ACTIONS(2600),
    [anon_sym_alignof] = ACTIONS(2600),
    [anon_sym__Alignof] = ACTIONS(2600),
    [anon_sym_offsetof] = ACTIONS(2600),
    [anon_sym__Generic] = ACTIONS(2600),
    [anon_sym_asm] = ACTIONS(2600),
    [anon_sym___asm__] = ACTIONS(2600),
    [anon_sym___asm] = ACTIONS(2600),
    [sym_number_literal] = ACTIONS(2602),
    [anon_sym_L_SQUOTE] = ACTIONS(2602),
    [anon_sym_u_SQUOTE] = ACTIONS(2602),
    [anon_sym_U_SQUOTE] = ACTIONS(2602),
    [anon_sym_u8_SQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_L_DQUOTE] = ACTIONS(2602),
    [anon_sym_u_DQUOTE] = ACTIONS(2602),
    [anon_sym_U_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8_DQUOTE] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [anon_sym_NULL] = ACTIONS(2600),
    [anon_sym_nullptr] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2600),
    [anon_sym_decltype] = ACTIONS(2600),
    [anon_sym_explicit] = ACTIONS(2600),
    [anon_sym_typename] = ACTIONS(2600),
    [anon_sym_template] = ACTIONS(2600),
    [anon_sym_operator] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_static_assert] = ACTIONS(2600),
    [anon_sym_concept] = ACTIONS(2600),
    [anon_sym_co_return] = ACTIONS(2600),
    [anon_sym_co_yield] = ACTIONS(2600),
    [anon_sym_R_DQUOTE] = ACTIONS(2602),
    [anon_sym_LR_DQUOTE] = ACTIONS(2602),
    [anon_sym_uR_DQUOTE] = ACTIONS(2602),
    [anon_sym_UR_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2602),
    [anon_sym_co_await] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_requires] = ACTIONS(2600),
    [sym_this] = ACTIONS(2600),
    [anon_sym_discard] = ACTIONS(2600),
    [anon_sym_precise] = ACTIONS(2600),
    [anon_sym_shared] = ACTIONS(2600),
    [anon_sym_groupshared] = ACTIONS(2600),
    [anon_sym_uniform] = ACTIONS(2600),
    [anon_sym_row_major] = ACTIONS(2600),
    [anon_sym_column_major] = ACTIONS(2600),
    [anon_sym_globallycoherent] = ACTIONS(2600),
    [anon_sym_centroid] = ACTIONS(2600),
    [anon_sym_noperspective] = ACTIONS(2600),
    [anon_sym_nointerpolation] = ACTIONS(2600),
    [anon_sym_sample] = ACTIONS(2600),
    [anon_sym_linear] = ACTIONS(2600),
    [anon_sym_snorm] = ACTIONS(2600),
    [anon_sym_unorm] = ACTIONS(2600),
    [anon_sym_point] = ACTIONS(2600),
    [anon_sym_line] = ACTIONS(2600),
    [anon_sym_triangleadj] = ACTIONS(2600),
    [anon_sym_lineadj] = ACTIONS(2600),
    [anon_sym_triangle] = ACTIONS(2600),
    [anon_sym_cbuffer] = ACTIONS(2600),
  },
  [666] = {
    [sym_identifier] = ACTIONS(2608),
    [aux_sym_preproc_include_token1] = ACTIONS(2608),
    [aux_sym_preproc_def_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2608),
    [sym_preproc_directive] = ACTIONS(2608),
    [anon_sym_LPAREN2] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym___extension__] = ACTIONS(2608),
    [anon_sym_typedef] = ACTIONS(2608),
    [anon_sym_in] = ACTIONS(2608),
    [anon_sym_out] = ACTIONS(2608),
    [anon_sym_inout] = ACTIONS(2608),
    [anon_sym_virtual] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym___attribute__] = ACTIONS(2608),
    [anon_sym___attribute] = ACTIONS(2608),
    [anon_sym_using] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2610),
    [anon_sym___declspec] = ACTIONS(2608),
    [anon_sym___based] = ACTIONS(2608),
    [anon_sym___cdecl] = ACTIONS(2608),
    [anon_sym___clrcall] = ACTIONS(2608),
    [anon_sym___stdcall] = ACTIONS(2608),
    [anon_sym___fastcall] = ACTIONS(2608),
    [anon_sym___thiscall] = ACTIONS(2608),
    [anon_sym___vectorcall] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_signed] = ACTIONS(2608),
    [anon_sym_unsigned] = ACTIONS(2608),
    [anon_sym_long] = ACTIONS(2608),
    [anon_sym_short] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_register] = ACTIONS(2608),
    [anon_sym_inline] = ACTIONS(2608),
    [anon_sym___inline] = ACTIONS(2608),
    [anon_sym___inline__] = ACTIONS(2608),
    [anon_sym___forceinline] = ACTIONS(2608),
    [anon_sym_thread_local] = ACTIONS(2608),
    [anon_sym___thread] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_constexpr] = ACTIONS(2608),
    [anon_sym_volatile] = ACTIONS(2608),
    [anon_sym_restrict] = ACTIONS(2608),
    [anon_sym___restrict__] = ACTIONS(2608),
    [anon_sym__Atomic] = ACTIONS(2608),
    [anon_sym__Noreturn] = ACTIONS(2608),
    [anon_sym_noreturn] = ACTIONS(2608),
    [anon_sym__Nonnull] = ACTIONS(2608),
    [anon_sym_mutable] = ACTIONS(2608),
    [anon_sym_constinit] = ACTIONS(2608),
    [anon_sym_consteval] = ACTIONS(2608),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_goto] = ACTIONS(2608),
    [anon_sym___try] = ACTIONS(2608),
    [anon_sym___leave] = ACTIONS(2608),
    [anon_sym_not] = ACTIONS(2608),
    [anon_sym_compl] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_sizeof] = ACTIONS(2608),
    [anon_sym___alignof__] = ACTIONS(2608),
    [anon_sym___alignof] = ACTIONS(2608),
    [anon_sym__alignof] = ACTIONS(2608),
    [anon_sym_alignof] = ACTIONS(2608),
    [anon_sym__Alignof] = ACTIONS(2608),
    [anon_sym_offsetof] = ACTIONS(2608),
    [anon_sym__Generic] = ACTIONS(2608),
    [anon_sym_asm] = ACTIONS(2608),
    [anon_sym___asm__] = ACTIONS(2608),
    [anon_sym___asm] = ACTIONS(2608),
    [sym_number_literal] = ACTIONS(2610),
    [anon_sym_L_SQUOTE] = ACTIONS(2610),
    [anon_sym_u_SQUOTE] = ACTIONS(2610),
    [anon_sym_U_SQUOTE] = ACTIONS(2610),
    [anon_sym_u8_SQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [anon_sym_L_DQUOTE] = ACTIONS(2610),
    [anon_sym_u_DQUOTE] = ACTIONS(2610),
    [anon_sym_U_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8_DQUOTE] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [anon_sym_NULL] = ACTIONS(2608),
    [anon_sym_nullptr] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(2608),
    [anon_sym_explicit] = ACTIONS(2608),
    [anon_sym_typename] = ACTIONS(2608),
    [anon_sym_template] = ACTIONS(2608),
    [anon_sym_operator] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_static_assert] = ACTIONS(2608),
    [anon_sym_concept] = ACTIONS(2608),
    [anon_sym_co_return] = ACTIONS(2608),
    [anon_sym_co_yield] = ACTIONS(2608),
    [anon_sym_R_DQUOTE] = ACTIONS(2610),
    [anon_sym_LR_DQUOTE] = ACTIONS(2610),
    [anon_sym_uR_DQUOTE] = ACTIONS(2610),
    [anon_sym_UR_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2610),
    [anon_sym_co_await] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_requires] = ACTIONS(2608),
    [sym_this] = ACTIONS(2608),
    [anon_sym_discard] = ACTIONS(2608),
    [anon_sym_precise] = ACTIONS(2608),
    [anon_sym_shared] = ACTIONS(2608),
    [anon_sym_groupshared] = ACTIONS(2608),
    [anon_sym_uniform] = ACTIONS(2608),
    [anon_sym_row_major] = ACTIONS(2608),
    [anon_sym_column_major] = ACTIONS(2608),
    [anon_sym_globallycoherent] = ACTIONS(2608),
    [anon_sym_centroid] = ACTIONS(2608),
    [anon_sym_noperspective] = ACTIONS(2608),
    [anon_sym_nointerpolation] = ACTIONS(2608),
    [anon_sym_sample] = ACTIONS(2608),
    [anon_sym_linear] = ACTIONS(2608),
    [anon_sym_snorm] = ACTIONS(2608),
    [anon_sym_unorm] = ACTIONS(2608),
    [anon_sym_point] = ACTIONS(2608),
    [anon_sym_line] = ACTIONS(2608),
    [anon_sym_triangleadj] = ACTIONS(2608),
    [anon_sym_lineadj] = ACTIONS(2608),
    [anon_sym_triangle] = ACTIONS(2608),
    [anon_sym_cbuffer] = ACTIONS(2608),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_include_token1] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym___cdecl] = ACTIONS(2437),
    [anon_sym___clrcall] = ACTIONS(2437),
    [anon_sym___stdcall] = ACTIONS(2437),
    [anon_sym___fastcall] = ACTIONS(2437),
    [anon_sym___thiscall] = ACTIONS(2437),
    [anon_sym___vectorcall] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_goto] = ACTIONS(2437),
    [anon_sym___try] = ACTIONS(2437),
    [anon_sym___leave] = ACTIONS(2437),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_compl] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_sizeof] = ACTIONS(2437),
    [anon_sym___alignof__] = ACTIONS(2437),
    [anon_sym___alignof] = ACTIONS(2437),
    [anon_sym__alignof] = ACTIONS(2437),
    [anon_sym_alignof] = ACTIONS(2437),
    [anon_sym__Alignof] = ACTIONS(2437),
    [anon_sym_offsetof] = ACTIONS(2437),
    [anon_sym__Generic] = ACTIONS(2437),
    [anon_sym_asm] = ACTIONS(2437),
    [anon_sym___asm__] = ACTIONS(2437),
    [anon_sym___asm] = ACTIONS(2437),
    [sym_number_literal] = ACTIONS(2439),
    [anon_sym_L_SQUOTE] = ACTIONS(2439),
    [anon_sym_u_SQUOTE] = ACTIONS(2439),
    [anon_sym_U_SQUOTE] = ACTIONS(2439),
    [anon_sym_u8_SQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_L_DQUOTE] = ACTIONS(2439),
    [anon_sym_u_DQUOTE] = ACTIONS(2439),
    [anon_sym_U_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8_DQUOTE] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [anon_sym_NULL] = ACTIONS(2437),
    [anon_sym_nullptr] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_concept] = ACTIONS(2437),
    [anon_sym_co_return] = ACTIONS(2437),
    [anon_sym_co_yield] = ACTIONS(2437),
    [anon_sym_R_DQUOTE] = ACTIONS(2439),
    [anon_sym_LR_DQUOTE] = ACTIONS(2439),
    [anon_sym_uR_DQUOTE] = ACTIONS(2439),
    [anon_sym_UR_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2439),
    [anon_sym_co_await] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_requires] = ACTIONS(2437),
    [sym_this] = ACTIONS(2437),
    [anon_sym_discard] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
    [anon_sym_cbuffer] = ACTIONS(2437),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2584),
    [aux_sym_preproc_include_token1] = ACTIONS(2584),
    [aux_sym_preproc_def_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2584),
    [sym_preproc_directive] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym___extension__] = ACTIONS(2584),
    [anon_sym_typedef] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2584),
    [anon_sym_out] = ACTIONS(2584),
    [anon_sym_inout] = ACTIONS(2584),
    [anon_sym_virtual] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym___attribute] = ACTIONS(2584),
    [anon_sym_using] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2586),
    [anon_sym___declspec] = ACTIONS(2584),
    [anon_sym___based] = ACTIONS(2584),
    [anon_sym___cdecl] = ACTIONS(2584),
    [anon_sym___clrcall] = ACTIONS(2584),
    [anon_sym___stdcall] = ACTIONS(2584),
    [anon_sym___fastcall] = ACTIONS(2584),
    [anon_sym___thiscall] = ACTIONS(2584),
    [anon_sym___vectorcall] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_signed] = ACTIONS(2584),
    [anon_sym_unsigned] = ACTIONS(2584),
    [anon_sym_long] = ACTIONS(2584),
    [anon_sym_short] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_register] = ACTIONS(2584),
    [anon_sym_inline] = ACTIONS(2584),
    [anon_sym___inline] = ACTIONS(2584),
    [anon_sym___inline__] = ACTIONS(2584),
    [anon_sym___forceinline] = ACTIONS(2584),
    [anon_sym_thread_local] = ACTIONS(2584),
    [anon_sym___thread] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_constexpr] = ACTIONS(2584),
    [anon_sym_volatile] = ACTIONS(2584),
    [anon_sym_restrict] = ACTIONS(2584),
    [anon_sym___restrict__] = ACTIONS(2584),
    [anon_sym__Atomic] = ACTIONS(2584),
    [anon_sym__Noreturn] = ACTIONS(2584),
    [anon_sym_noreturn] = ACTIONS(2584),
    [anon_sym__Nonnull] = ACTIONS(2584),
    [anon_sym_mutable] = ACTIONS(2584),
    [anon_sym_constinit] = ACTIONS(2584),
    [anon_sym_consteval] = ACTIONS(2584),
    [anon_sym_alignas] = ACTIONS(2584),
    [anon_sym__Alignas] = ACTIONS(2584),
    [sym_primitive_type] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_goto] = ACTIONS(2584),
    [anon_sym___try] = ACTIONS(2584),
    [anon_sym___leave] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2584),
    [anon_sym_compl] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_sizeof] = ACTIONS(2584),
    [anon_sym___alignof__] = ACTIONS(2584),
    [anon_sym___alignof] = ACTIONS(2584),
    [anon_sym__alignof] = ACTIONS(2584),
    [anon_sym_alignof] = ACTIONS(2584),
    [anon_sym__Alignof] = ACTIONS(2584),
    [anon_sym_offsetof] = ACTIONS(2584),
    [anon_sym__Generic] = ACTIONS(2584),
    [anon_sym_asm] = ACTIONS(2584),
    [anon_sym___asm__] = ACTIONS(2584),
    [anon_sym___asm] = ACTIONS(2584),
    [sym_number_literal] = ACTIONS(2586),
    [anon_sym_L_SQUOTE] = ACTIONS(2586),
    [anon_sym_u_SQUOTE] = ACTIONS(2586),
    [anon_sym_U_SQUOTE] = ACTIONS(2586),
    [anon_sym_u8_SQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_L_DQUOTE] = ACTIONS(2586),
    [anon_sym_u_DQUOTE] = ACTIONS(2586),
    [anon_sym_U_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8_DQUOTE] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [anon_sym_NULL] = ACTIONS(2584),
    [anon_sym_nullptr] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2584),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2584),
    [anon_sym_operator] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_static_assert] = ACTIONS(2584),
    [anon_sym_concept] = ACTIONS(2584),
    [anon_sym_co_return] = ACTIONS(2584),
    [anon_sym_co_yield] = ACTIONS(2584),
    [anon_sym_R_DQUOTE] = ACTIONS(2586),
    [anon_sym_LR_DQUOTE] = ACTIONS(2586),
    [anon_sym_uR_DQUOTE] = ACTIONS(2586),
    [anon_sym_UR_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2586),
    [anon_sym_co_await] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_requires] = ACTIONS(2584),
    [sym_this] = ACTIONS(2584),
    [anon_sym_discard] = ACTIONS(2584),
    [anon_sym_precise] = ACTIONS(2584),
    [anon_sym_shared] = ACTIONS(2584),
    [anon_sym_groupshared] = ACTIONS(2584),
    [anon_sym_uniform] = ACTIONS(2584),
    [anon_sym_row_major] = ACTIONS(2584),
    [anon_sym_column_major] = ACTIONS(2584),
    [anon_sym_globallycoherent] = ACTIONS(2584),
    [anon_sym_centroid] = ACTIONS(2584),
    [anon_sym_noperspective] = ACTIONS(2584),
    [anon_sym_nointerpolation] = ACTIONS(2584),
    [anon_sym_sample] = ACTIONS(2584),
    [anon_sym_linear] = ACTIONS(2584),
    [anon_sym_snorm] = ACTIONS(2584),
    [anon_sym_unorm] = ACTIONS(2584),
    [anon_sym_point] = ACTIONS(2584),
    [anon_sym_line] = ACTIONS(2584),
    [anon_sym_triangleadj] = ACTIONS(2584),
    [anon_sym_lineadj] = ACTIONS(2584),
    [anon_sym_triangle] = ACTIONS(2584),
    [anon_sym_cbuffer] = ACTIONS(2584),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
  },
  [671] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
  },
  [672] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_include_token1] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token2] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym___cdecl] = ACTIONS(2425),
    [anon_sym___clrcall] = ACTIONS(2425),
    [anon_sym___stdcall] = ACTIONS(2425),
    [anon_sym___fastcall] = ACTIONS(2425),
    [anon_sym___thiscall] = ACTIONS(2425),
    [anon_sym___vectorcall] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_goto] = ACTIONS(2425),
    [anon_sym___try] = ACTIONS(2425),
    [anon_sym___leave] = ACTIONS(2425),
    [anon_sym_not] = ACTIONS(2425),
    [anon_sym_compl] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_sizeof] = ACTIONS(2425),
    [anon_sym___alignof__] = ACTIONS(2425),
    [anon_sym___alignof] = ACTIONS(2425),
    [anon_sym__alignof] = ACTIONS(2425),
    [anon_sym_alignof] = ACTIONS(2425),
    [anon_sym__Alignof] = ACTIONS(2425),
    [anon_sym_offsetof] = ACTIONS(2425),
    [anon_sym__Generic] = ACTIONS(2425),
    [anon_sym_asm] = ACTIONS(2425),
    [anon_sym___asm__] = ACTIONS(2425),
    [anon_sym___asm] = ACTIONS(2425),
    [sym_number_literal] = ACTIONS(2427),
    [anon_sym_L_SQUOTE] = ACTIONS(2427),
    [anon_sym_u_SQUOTE] = ACTIONS(2427),
    [anon_sym_U_SQUOTE] = ACTIONS(2427),
    [anon_sym_u8_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_L_DQUOTE] = ACTIONS(2427),
    [anon_sym_u_DQUOTE] = ACTIONS(2427),
    [anon_sym_U_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8_DQUOTE] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [anon_sym_NULL] = ACTIONS(2425),
    [anon_sym_nullptr] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_concept] = ACTIONS(2425),
    [anon_sym_co_return] = ACTIONS(2425),
    [anon_sym_co_yield] = ACTIONS(2425),
    [anon_sym_R_DQUOTE] = ACTIONS(2427),
    [anon_sym_LR_DQUOTE] = ACTIONS(2427),
    [anon_sym_uR_DQUOTE] = ACTIONS(2427),
    [anon_sym_UR_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2427),
    [anon_sym_co_await] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_requires] = ACTIONS(2425),
    [sym_this] = ACTIONS(2425),
    [anon_sym_discard] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
    [anon_sym_cbuffer] = ACTIONS(2425),
  },
  [673] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_include_token1] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token2] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym___cdecl] = ACTIONS(2429),
    [anon_sym___clrcall] = ACTIONS(2429),
    [anon_sym___stdcall] = ACTIONS(2429),
    [anon_sym___fastcall] = ACTIONS(2429),
    [anon_sym___thiscall] = ACTIONS(2429),
    [anon_sym___vectorcall] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym___try] = ACTIONS(2429),
    [anon_sym___leave] = ACTIONS(2429),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_compl] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_sizeof] = ACTIONS(2429),
    [anon_sym___alignof__] = ACTIONS(2429),
    [anon_sym___alignof] = ACTIONS(2429),
    [anon_sym__alignof] = ACTIONS(2429),
    [anon_sym_alignof] = ACTIONS(2429),
    [anon_sym__Alignof] = ACTIONS(2429),
    [anon_sym_offsetof] = ACTIONS(2429),
    [anon_sym__Generic] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym___asm__] = ACTIONS(2429),
    [anon_sym___asm] = ACTIONS(2429),
    [sym_number_literal] = ACTIONS(2431),
    [anon_sym_L_SQUOTE] = ACTIONS(2431),
    [anon_sym_u_SQUOTE] = ACTIONS(2431),
    [anon_sym_U_SQUOTE] = ACTIONS(2431),
    [anon_sym_u8_SQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [anon_sym_L_DQUOTE] = ACTIONS(2431),
    [anon_sym_u_DQUOTE] = ACTIONS(2431),
    [anon_sym_U_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8_DQUOTE] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [anon_sym_NULL] = ACTIONS(2429),
    [anon_sym_nullptr] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_concept] = ACTIONS(2429),
    [anon_sym_co_return] = ACTIONS(2429),
    [anon_sym_co_yield] = ACTIONS(2429),
    [anon_sym_R_DQUOTE] = ACTIONS(2431),
    [anon_sym_LR_DQUOTE] = ACTIONS(2431),
    [anon_sym_uR_DQUOTE] = ACTIONS(2431),
    [anon_sym_UR_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2431),
    [anon_sym_co_await] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_requires] = ACTIONS(2429),
    [sym_this] = ACTIONS(2429),
    [anon_sym_discard] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
    [anon_sym_cbuffer] = ACTIONS(2429),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_include_token1] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token2] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym___cdecl] = ACTIONS(2433),
    [anon_sym___clrcall] = ACTIONS(2433),
    [anon_sym___stdcall] = ACTIONS(2433),
    [anon_sym___fastcall] = ACTIONS(2433),
    [anon_sym___thiscall] = ACTIONS(2433),
    [anon_sym___vectorcall] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_goto] = ACTIONS(2433),
    [anon_sym___try] = ACTIONS(2433),
    [anon_sym___leave] = ACTIONS(2433),
    [anon_sym_not] = ACTIONS(2433),
    [anon_sym_compl] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_sizeof] = ACTIONS(2433),
    [anon_sym___alignof__] = ACTIONS(2433),
    [anon_sym___alignof] = ACTIONS(2433),
    [anon_sym__alignof] = ACTIONS(2433),
    [anon_sym_alignof] = ACTIONS(2433),
    [anon_sym__Alignof] = ACTIONS(2433),
    [anon_sym_offsetof] = ACTIONS(2433),
    [anon_sym__Generic] = ACTIONS(2433),
    [anon_sym_asm] = ACTIONS(2433),
    [anon_sym___asm__] = ACTIONS(2433),
    [anon_sym___asm] = ACTIONS(2433),
    [sym_number_literal] = ACTIONS(2435),
    [anon_sym_L_SQUOTE] = ACTIONS(2435),
    [anon_sym_u_SQUOTE] = ACTIONS(2435),
    [anon_sym_U_SQUOTE] = ACTIONS(2435),
    [anon_sym_u8_SQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_L_DQUOTE] = ACTIONS(2435),
    [anon_sym_u_DQUOTE] = ACTIONS(2435),
    [anon_sym_U_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8_DQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [anon_sym_NULL] = ACTIONS(2433),
    [anon_sym_nullptr] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_concept] = ACTIONS(2433),
    [anon_sym_co_return] = ACTIONS(2433),
    [anon_sym_co_yield] = ACTIONS(2433),
    [anon_sym_R_DQUOTE] = ACTIONS(2435),
    [anon_sym_LR_DQUOTE] = ACTIONS(2435),
    [anon_sym_uR_DQUOTE] = ACTIONS(2435),
    [anon_sym_UR_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2435),
    [anon_sym_co_await] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_requires] = ACTIONS(2433),
    [sym_this] = ACTIONS(2433),
    [anon_sym_discard] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
    [anon_sym_cbuffer] = ACTIONS(2433),
  },
  [675] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_include_token1] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token2] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym___cdecl] = ACTIONS(2437),
    [anon_sym___clrcall] = ACTIONS(2437),
    [anon_sym___stdcall] = ACTIONS(2437),
    [anon_sym___fastcall] = ACTIONS(2437),
    [anon_sym___thiscall] = ACTIONS(2437),
    [anon_sym___vectorcall] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_goto] = ACTIONS(2437),
    [anon_sym___try] = ACTIONS(2437),
    [anon_sym___leave] = ACTIONS(2437),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_compl] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_sizeof] = ACTIONS(2437),
    [anon_sym___alignof__] = ACTIONS(2437),
    [anon_sym___alignof] = ACTIONS(2437),
    [anon_sym__alignof] = ACTIONS(2437),
    [anon_sym_alignof] = ACTIONS(2437),
    [anon_sym__Alignof] = ACTIONS(2437),
    [anon_sym_offsetof] = ACTIONS(2437),
    [anon_sym__Generic] = ACTIONS(2437),
    [anon_sym_asm] = ACTIONS(2437),
    [anon_sym___asm__] = ACTIONS(2437),
    [anon_sym___asm] = ACTIONS(2437),
    [sym_number_literal] = ACTIONS(2439),
    [anon_sym_L_SQUOTE] = ACTIONS(2439),
    [anon_sym_u_SQUOTE] = ACTIONS(2439),
    [anon_sym_U_SQUOTE] = ACTIONS(2439),
    [anon_sym_u8_SQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_L_DQUOTE] = ACTIONS(2439),
    [anon_sym_u_DQUOTE] = ACTIONS(2439),
    [anon_sym_U_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8_DQUOTE] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [anon_sym_NULL] = ACTIONS(2437),
    [anon_sym_nullptr] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_concept] = ACTIONS(2437),
    [anon_sym_co_return] = ACTIONS(2437),
    [anon_sym_co_yield] = ACTIONS(2437),
    [anon_sym_R_DQUOTE] = ACTIONS(2439),
    [anon_sym_LR_DQUOTE] = ACTIONS(2439),
    [anon_sym_uR_DQUOTE] = ACTIONS(2439),
    [anon_sym_UR_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2439),
    [anon_sym_co_await] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_requires] = ACTIONS(2437),
    [sym_this] = ACTIONS(2437),
    [anon_sym_discard] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
    [anon_sym_cbuffer] = ACTIONS(2437),
  },
  [676] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym___try] = ACTIONS(2604),
    [anon_sym___leave] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_discard] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
    [anon_sym_cbuffer] = ACTIONS(2604),
  },
  [677] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_include_token1] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym___cdecl] = ACTIONS(2656),
    [anon_sym___clrcall] = ACTIONS(2656),
    [anon_sym___stdcall] = ACTIONS(2656),
    [anon_sym___fastcall] = ACTIONS(2656),
    [anon_sym___thiscall] = ACTIONS(2656),
    [anon_sym___vectorcall] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_goto] = ACTIONS(2656),
    [anon_sym___try] = ACTIONS(2656),
    [anon_sym___leave] = ACTIONS(2656),
    [anon_sym_not] = ACTIONS(2656),
    [anon_sym_compl] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_sizeof] = ACTIONS(2656),
    [anon_sym___alignof__] = ACTIONS(2656),
    [anon_sym___alignof] = ACTIONS(2656),
    [anon_sym__alignof] = ACTIONS(2656),
    [anon_sym_alignof] = ACTIONS(2656),
    [anon_sym__Alignof] = ACTIONS(2656),
    [anon_sym_offsetof] = ACTIONS(2656),
    [anon_sym__Generic] = ACTIONS(2656),
    [anon_sym_asm] = ACTIONS(2656),
    [anon_sym___asm__] = ACTIONS(2656),
    [anon_sym___asm] = ACTIONS(2656),
    [sym_number_literal] = ACTIONS(2658),
    [anon_sym_L_SQUOTE] = ACTIONS(2658),
    [anon_sym_u_SQUOTE] = ACTIONS(2658),
    [anon_sym_U_SQUOTE] = ACTIONS(2658),
    [anon_sym_u8_SQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_L_DQUOTE] = ACTIONS(2658),
    [anon_sym_u_DQUOTE] = ACTIONS(2658),
    [anon_sym_U_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8_DQUOTE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [anon_sym_NULL] = ACTIONS(2656),
    [anon_sym_nullptr] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_concept] = ACTIONS(2656),
    [anon_sym_co_return] = ACTIONS(2656),
    [anon_sym_co_yield] = ACTIONS(2656),
    [anon_sym_R_DQUOTE] = ACTIONS(2658),
    [anon_sym_LR_DQUOTE] = ACTIONS(2658),
    [anon_sym_uR_DQUOTE] = ACTIONS(2658),
    [anon_sym_UR_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2658),
    [anon_sym_co_await] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_requires] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [anon_sym_discard] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_cbuffer] = ACTIONS(2656),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_preproc_include_token1] = ACTIONS(2640),
    [aux_sym_preproc_def_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token2] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2640),
    [sym_preproc_directive] = ACTIONS(2640),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym___extension__] = ACTIONS(2640),
    [anon_sym_typedef] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_out] = ACTIONS(2640),
    [anon_sym_inout] = ACTIONS(2640),
    [anon_sym_virtual] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym___attribute__] = ACTIONS(2640),
    [anon_sym___attribute] = ACTIONS(2640),
    [anon_sym_using] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2640),
    [anon_sym___based] = ACTIONS(2640),
    [anon_sym___cdecl] = ACTIONS(2640),
    [anon_sym___clrcall] = ACTIONS(2640),
    [anon_sym___stdcall] = ACTIONS(2640),
    [anon_sym___fastcall] = ACTIONS(2640),
    [anon_sym___thiscall] = ACTIONS(2640),
    [anon_sym___vectorcall] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_signed] = ACTIONS(2640),
    [anon_sym_unsigned] = ACTIONS(2640),
    [anon_sym_long] = ACTIONS(2640),
    [anon_sym_short] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_register] = ACTIONS(2640),
    [anon_sym_inline] = ACTIONS(2640),
    [anon_sym___inline] = ACTIONS(2640),
    [anon_sym___inline__] = ACTIONS(2640),
    [anon_sym___forceinline] = ACTIONS(2640),
    [anon_sym_thread_local] = ACTIONS(2640),
    [anon_sym___thread] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_constexpr] = ACTIONS(2640),
    [anon_sym_volatile] = ACTIONS(2640),
    [anon_sym_restrict] = ACTIONS(2640),
    [anon_sym___restrict__] = ACTIONS(2640),
    [anon_sym__Atomic] = ACTIONS(2640),
    [anon_sym__Noreturn] = ACTIONS(2640),
    [anon_sym_noreturn] = ACTIONS(2640),
    [anon_sym__Nonnull] = ACTIONS(2640),
    [anon_sym_mutable] = ACTIONS(2640),
    [anon_sym_constinit] = ACTIONS(2640),
    [anon_sym_consteval] = ACTIONS(2640),
    [anon_sym_alignas] = ACTIONS(2640),
    [anon_sym__Alignas] = ACTIONS(2640),
    [sym_primitive_type] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_switch] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_goto] = ACTIONS(2640),
    [anon_sym___try] = ACTIONS(2640),
    [anon_sym___leave] = ACTIONS(2640),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_compl] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2642),
    [anon_sym_sizeof] = ACTIONS(2640),
    [anon_sym___alignof__] = ACTIONS(2640),
    [anon_sym___alignof] = ACTIONS(2640),
    [anon_sym__alignof] = ACTIONS(2640),
    [anon_sym_alignof] = ACTIONS(2640),
    [anon_sym__Alignof] = ACTIONS(2640),
    [anon_sym_offsetof] = ACTIONS(2640),
    [anon_sym__Generic] = ACTIONS(2640),
    [anon_sym_asm] = ACTIONS(2640),
    [anon_sym___asm__] = ACTIONS(2640),
    [anon_sym___asm] = ACTIONS(2640),
    [sym_number_literal] = ACTIONS(2642),
    [anon_sym_L_SQUOTE] = ACTIONS(2642),
    [anon_sym_u_SQUOTE] = ACTIONS(2642),
    [anon_sym_U_SQUOTE] = ACTIONS(2642),
    [anon_sym_u8_SQUOTE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym_L_DQUOTE] = ACTIONS(2642),
    [anon_sym_u_DQUOTE] = ACTIONS(2642),
    [anon_sym_U_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8_DQUOTE] = ACTIONS(2642),
    [anon_sym_DQUOTE] = ACTIONS(2642),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_NULL] = ACTIONS(2640),
    [anon_sym_nullptr] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2640),
    [anon_sym_decltype] = ACTIONS(2640),
    [anon_sym_explicit] = ACTIONS(2640),
    [anon_sym_typename] = ACTIONS(2640),
    [anon_sym_template] = ACTIONS(2640),
    [anon_sym_operator] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [anon_sym_delete] = ACTIONS(2640),
    [anon_sym_throw] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_static_assert] = ACTIONS(2640),
    [anon_sym_concept] = ACTIONS(2640),
    [anon_sym_co_return] = ACTIONS(2640),
    [anon_sym_co_yield] = ACTIONS(2640),
    [anon_sym_R_DQUOTE] = ACTIONS(2642),
    [anon_sym_LR_DQUOTE] = ACTIONS(2642),
    [anon_sym_uR_DQUOTE] = ACTIONS(2642),
    [anon_sym_UR_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2642),
    [anon_sym_co_await] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2640),
    [anon_sym_requires] = ACTIONS(2640),
    [sym_this] = ACTIONS(2640),
    [anon_sym_discard] = ACTIONS(2640),
    [anon_sym_precise] = ACTIONS(2640),
    [anon_sym_shared] = ACTIONS(2640),
    [anon_sym_groupshared] = ACTIONS(2640),
    [anon_sym_uniform] = ACTIONS(2640),
    [anon_sym_row_major] = ACTIONS(2640),
    [anon_sym_column_major] = ACTIONS(2640),
    [anon_sym_globallycoherent] = ACTIONS(2640),
    [anon_sym_centroid] = ACTIONS(2640),
    [anon_sym_noperspective] = ACTIONS(2640),
    [anon_sym_nointerpolation] = ACTIONS(2640),
    [anon_sym_sample] = ACTIONS(2640),
    [anon_sym_linear] = ACTIONS(2640),
    [anon_sym_snorm] = ACTIONS(2640),
    [anon_sym_unorm] = ACTIONS(2640),
    [anon_sym_point] = ACTIONS(2640),
    [anon_sym_line] = ACTIONS(2640),
    [anon_sym_triangleadj] = ACTIONS(2640),
    [anon_sym_lineadj] = ACTIONS(2640),
    [anon_sym_triangle] = ACTIONS(2640),
    [anon_sym_cbuffer] = ACTIONS(2640),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2441),
    [aux_sym_preproc_include_token1] = ACTIONS(2441),
    [aux_sym_preproc_def_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2441),
    [sym_preproc_directive] = ACTIONS(2441),
    [anon_sym_LPAREN2] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym___extension__] = ACTIONS(2441),
    [anon_sym_typedef] = ACTIONS(2441),
    [anon_sym_in] = ACTIONS(2441),
    [anon_sym_out] = ACTIONS(2441),
    [anon_sym_inout] = ACTIONS(2441),
    [anon_sym_virtual] = ACTIONS(2441),
    [anon_sym_extern] = ACTIONS(2441),
    [anon_sym___attribute__] = ACTIONS(2441),
    [anon_sym___attribute] = ACTIONS(2441),
    [anon_sym_using] = ACTIONS(2441),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2443),
    [anon_sym___declspec] = ACTIONS(2441),
    [anon_sym___based] = ACTIONS(2441),
    [anon_sym___cdecl] = ACTIONS(2441),
    [anon_sym___clrcall] = ACTIONS(2441),
    [anon_sym___stdcall] = ACTIONS(2441),
    [anon_sym___fastcall] = ACTIONS(2441),
    [anon_sym___thiscall] = ACTIONS(2441),
    [anon_sym___vectorcall] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_RBRACE] = ACTIONS(2443),
    [anon_sym_signed] = ACTIONS(2441),
    [anon_sym_unsigned] = ACTIONS(2441),
    [anon_sym_long] = ACTIONS(2441),
    [anon_sym_short] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_register] = ACTIONS(2441),
    [anon_sym_inline] = ACTIONS(2441),
    [anon_sym___inline] = ACTIONS(2441),
    [anon_sym___inline__] = ACTIONS(2441),
    [anon_sym___forceinline] = ACTIONS(2441),
    [anon_sym_thread_local] = ACTIONS(2441),
    [anon_sym___thread] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_constexpr] = ACTIONS(2441),
    [anon_sym_volatile] = ACTIONS(2441),
    [anon_sym_restrict] = ACTIONS(2441),
    [anon_sym___restrict__] = ACTIONS(2441),
    [anon_sym__Atomic] = ACTIONS(2441),
    [anon_sym__Noreturn] = ACTIONS(2441),
    [anon_sym_noreturn] = ACTIONS(2441),
    [anon_sym__Nonnull] = ACTIONS(2441),
    [anon_sym_mutable] = ACTIONS(2441),
    [anon_sym_constinit] = ACTIONS(2441),
    [anon_sym_consteval] = ACTIONS(2441),
    [anon_sym_alignas] = ACTIONS(2441),
    [anon_sym__Alignas] = ACTIONS(2441),
    [sym_primitive_type] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_struct] = ACTIONS(2441),
    [anon_sym_union] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_goto] = ACTIONS(2441),
    [anon_sym___try] = ACTIONS(2441),
    [anon_sym___leave] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2441),
    [anon_sym_compl] = ACTIONS(2441),
    [anon_sym_DASH_DASH] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_sizeof] = ACTIONS(2441),
    [anon_sym___alignof__] = ACTIONS(2441),
    [anon_sym___alignof] = ACTIONS(2441),
    [anon_sym__alignof] = ACTIONS(2441),
    [anon_sym_alignof] = ACTIONS(2441),
    [anon_sym__Alignof] = ACTIONS(2441),
    [anon_sym_offsetof] = ACTIONS(2441),
    [anon_sym__Generic] = ACTIONS(2441),
    [anon_sym_asm] = ACTIONS(2441),
    [anon_sym___asm__] = ACTIONS(2441),
    [anon_sym___asm] = ACTIONS(2441),
    [sym_number_literal] = ACTIONS(2443),
    [anon_sym_L_SQUOTE] = ACTIONS(2443),
    [anon_sym_u_SQUOTE] = ACTIONS(2443),
    [anon_sym_U_SQUOTE] = ACTIONS(2443),
    [anon_sym_u8_SQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_L_DQUOTE] = ACTIONS(2443),
    [anon_sym_u_DQUOTE] = ACTIONS(2443),
    [anon_sym_U_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8_DQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [anon_sym_NULL] = ACTIONS(2441),
    [anon_sym_nullptr] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2441),
    [anon_sym_decltype] = ACTIONS(2441),
    [anon_sym_explicit] = ACTIONS(2441),
    [anon_sym_typename] = ACTIONS(2441),
    [anon_sym_template] = ACTIONS(2441),
    [anon_sym_operator] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_static_assert] = ACTIONS(2441),
    [anon_sym_concept] = ACTIONS(2441),
    [anon_sym_co_return] = ACTIONS(2441),
    [anon_sym_co_yield] = ACTIONS(2441),
    [anon_sym_R_DQUOTE] = ACTIONS(2443),
    [anon_sym_LR_DQUOTE] = ACTIONS(2443),
    [anon_sym_uR_DQUOTE] = ACTIONS(2443),
    [anon_sym_UR_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2443),
    [anon_sym_co_await] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_requires] = ACTIONS(2441),
    [sym_this] = ACTIONS(2441),
    [anon_sym_discard] = ACTIONS(2441),
    [anon_sym_precise] = ACTIONS(2441),
    [anon_sym_shared] = ACTIONS(2441),
    [anon_sym_groupshared] = ACTIONS(2441),
    [anon_sym_uniform] = ACTIONS(2441),
    [anon_sym_row_major] = ACTIONS(2441),
    [anon_sym_column_major] = ACTIONS(2441),
    [anon_sym_globallycoherent] = ACTIONS(2441),
    [anon_sym_centroid] = ACTIONS(2441),
    [anon_sym_noperspective] = ACTIONS(2441),
    [anon_sym_nointerpolation] = ACTIONS(2441),
    [anon_sym_sample] = ACTIONS(2441),
    [anon_sym_linear] = ACTIONS(2441),
    [anon_sym_snorm] = ACTIONS(2441),
    [anon_sym_unorm] = ACTIONS(2441),
    [anon_sym_point] = ACTIONS(2441),
    [anon_sym_line] = ACTIONS(2441),
    [anon_sym_triangleadj] = ACTIONS(2441),
    [anon_sym_lineadj] = ACTIONS(2441),
    [anon_sym_triangle] = ACTIONS(2441),
    [anon_sym_cbuffer] = ACTIONS(2441),
  },
  [680] = {
    [sym_identifier] = ACTIONS(2445),
    [aux_sym_preproc_include_token1] = ACTIONS(2445),
    [aux_sym_preproc_def_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_LPAREN2] = ACTIONS(2447),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(2447),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym___extension__] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_out] = ACTIONS(2445),
    [anon_sym_inout] = ACTIONS(2445),
    [anon_sym_virtual] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym___attribute__] = ACTIONS(2445),
    [anon_sym___attribute] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2447),
    [anon_sym___declspec] = ACTIONS(2445),
    [anon_sym___based] = ACTIONS(2445),
    [anon_sym___cdecl] = ACTIONS(2445),
    [anon_sym___clrcall] = ACTIONS(2445),
    [anon_sym___stdcall] = ACTIONS(2445),
    [anon_sym___fastcall] = ACTIONS(2445),
    [anon_sym___thiscall] = ACTIONS(2445),
    [anon_sym___vectorcall] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_RBRACE] = ACTIONS(2447),
    [anon_sym_signed] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym___inline] = ACTIONS(2445),
    [anon_sym___inline__] = ACTIONS(2445),
    [anon_sym___forceinline] = ACTIONS(2445),
    [anon_sym_thread_local] = ACTIONS(2445),
    [anon_sym___thread] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym___restrict__] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym__Noreturn] = ACTIONS(2445),
    [anon_sym_noreturn] = ACTIONS(2445),
    [anon_sym__Nonnull] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_constinit] = ACTIONS(2445),
    [anon_sym_consteval] = ACTIONS(2445),
    [anon_sym_alignas] = ACTIONS(2445),
    [anon_sym__Alignas] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym___try] = ACTIONS(2445),
    [anon_sym___leave] = ACTIONS(2445),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_compl] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_sizeof] = ACTIONS(2445),
    [anon_sym___alignof__] = ACTIONS(2445),
    [anon_sym___alignof] = ACTIONS(2445),
    [anon_sym__alignof] = ACTIONS(2445),
    [anon_sym_alignof] = ACTIONS(2445),
    [anon_sym__Alignof] = ACTIONS(2445),
    [anon_sym_offsetof] = ACTIONS(2445),
    [anon_sym__Generic] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym___asm__] = ACTIONS(2445),
    [anon_sym___asm] = ACTIONS(2445),
    [sym_number_literal] = ACTIONS(2447),
    [anon_sym_L_SQUOTE] = ACTIONS(2447),
    [anon_sym_u_SQUOTE] = ACTIONS(2447),
    [anon_sym_U_SQUOTE] = ACTIONS(2447),
    [anon_sym_u8_SQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [anon_sym_L_DQUOTE] = ACTIONS(2447),
    [anon_sym_u_DQUOTE] = ACTIONS(2447),
    [anon_sym_U_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8_DQUOTE] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [anon_sym_NULL] = ACTIONS(2445),
    [anon_sym_nullptr] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_decltype] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_operator] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_static_assert] = ACTIONS(2445),
    [anon_sym_concept] = ACTIONS(2445),
    [anon_sym_co_return] = ACTIONS(2445),
    [anon_sym_co_yield] = ACTIONS(2445),
    [anon_sym_R_DQUOTE] = ACTIONS(2447),
    [anon_sym_LR_DQUOTE] = ACTIONS(2447),
    [anon_sym_uR_DQUOTE] = ACTIONS(2447),
    [anon_sym_UR_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2447),
    [anon_sym_co_await] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_requires] = ACTIONS(2445),
    [sym_this] = ACTIONS(2445),
    [anon_sym_discard] = ACTIONS(2445),
    [anon_sym_precise] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_groupshared] = ACTIONS(2445),
    [anon_sym_uniform] = ACTIONS(2445),
    [anon_sym_row_major] = ACTIONS(2445),
    [anon_sym_column_major] = ACTIONS(2445),
    [anon_sym_globallycoherent] = ACTIONS(2445),
    [anon_sym_centroid] = ACTIONS(2445),
    [anon_sym_noperspective] = ACTIONS(2445),
    [anon_sym_nointerpolation] = ACTIONS(2445),
    [anon_sym_sample] = ACTIONS(2445),
    [anon_sym_linear] = ACTIONS(2445),
    [anon_sym_snorm] = ACTIONS(2445),
    [anon_sym_unorm] = ACTIONS(2445),
    [anon_sym_point] = ACTIONS(2445),
    [anon_sym_line] = ACTIONS(2445),
    [anon_sym_triangleadj] = ACTIONS(2445),
    [anon_sym_lineadj] = ACTIONS(2445),
    [anon_sym_triangle] = ACTIONS(2445),
    [anon_sym_cbuffer] = ACTIONS(2445),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_preproc_include_token1] = ACTIONS(2644),
    [aux_sym_preproc_def_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token2] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2644),
    [sym_preproc_directive] = ACTIONS(2644),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym___extension__] = ACTIONS(2644),
    [anon_sym_typedef] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_out] = ACTIONS(2644),
    [anon_sym_inout] = ACTIONS(2644),
    [anon_sym_virtual] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym___attribute__] = ACTIONS(2644),
    [anon_sym___attribute] = ACTIONS(2644),
    [anon_sym_using] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2646),
    [anon_sym___declspec] = ACTIONS(2644),
    [anon_sym___based] = ACTIONS(2644),
    [anon_sym___cdecl] = ACTIONS(2644),
    [anon_sym___clrcall] = ACTIONS(2644),
    [anon_sym___stdcall] = ACTIONS(2644),
    [anon_sym___fastcall] = ACTIONS(2644),
    [anon_sym___thiscall] = ACTIONS(2644),
    [anon_sym___vectorcall] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_signed] = ACTIONS(2644),
    [anon_sym_unsigned] = ACTIONS(2644),
    [anon_sym_long] = ACTIONS(2644),
    [anon_sym_short] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_register] = ACTIONS(2644),
    [anon_sym_inline] = ACTIONS(2644),
    [anon_sym___inline] = ACTIONS(2644),
    [anon_sym___inline__] = ACTIONS(2644),
    [anon_sym___forceinline] = ACTIONS(2644),
    [anon_sym_thread_local] = ACTIONS(2644),
    [anon_sym___thread] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_constexpr] = ACTIONS(2644),
    [anon_sym_volatile] = ACTIONS(2644),
    [anon_sym_restrict] = ACTIONS(2644),
    [anon_sym___restrict__] = ACTIONS(2644),
    [anon_sym__Atomic] = ACTIONS(2644),
    [anon_sym__Noreturn] = ACTIONS(2644),
    [anon_sym_noreturn] = ACTIONS(2644),
    [anon_sym__Nonnull] = ACTIONS(2644),
    [anon_sym_mutable] = ACTIONS(2644),
    [anon_sym_constinit] = ACTIONS(2644),
    [anon_sym_consteval] = ACTIONS(2644),
    [anon_sym_alignas] = ACTIONS(2644),
    [anon_sym__Alignas] = ACTIONS(2644),
    [sym_primitive_type] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_switch] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_goto] = ACTIONS(2644),
    [anon_sym___try] = ACTIONS(2644),
    [anon_sym___leave] = ACTIONS(2644),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_compl] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_sizeof] = ACTIONS(2644),
    [anon_sym___alignof__] = ACTIONS(2644),
    [anon_sym___alignof] = ACTIONS(2644),
    [anon_sym__alignof] = ACTIONS(2644),
    [anon_sym_alignof] = ACTIONS(2644),
    [anon_sym__Alignof] = ACTIONS(2644),
    [anon_sym_offsetof] = ACTIONS(2644),
    [anon_sym__Generic] = ACTIONS(2644),
    [anon_sym_asm] = ACTIONS(2644),
    [anon_sym___asm__] = ACTIONS(2644),
    [anon_sym___asm] = ACTIONS(2644),
    [sym_number_literal] = ACTIONS(2646),
    [anon_sym_L_SQUOTE] = ACTIONS(2646),
    [anon_sym_u_SQUOTE] = ACTIONS(2646),
    [anon_sym_U_SQUOTE] = ACTIONS(2646),
    [anon_sym_u8_SQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [anon_sym_L_DQUOTE] = ACTIONS(2646),
    [anon_sym_u_DQUOTE] = ACTIONS(2646),
    [anon_sym_U_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8_DQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [anon_sym_NULL] = ACTIONS(2644),
    [anon_sym_nullptr] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2644),
    [anon_sym_decltype] = ACTIONS(2644),
    [anon_sym_explicit] = ACTIONS(2644),
    [anon_sym_typename] = ACTIONS(2644),
    [anon_sym_template] = ACTIONS(2644),
    [anon_sym_operator] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [anon_sym_delete] = ACTIONS(2644),
    [anon_sym_throw] = ACTIONS(2644),
    [anon_sym_namespace] = ACTIONS(2644),
    [anon_sym_static_assert] = ACTIONS(2644),
    [anon_sym_concept] = ACTIONS(2644),
    [anon_sym_co_return] = ACTIONS(2644),
    [anon_sym_co_yield] = ACTIONS(2644),
    [anon_sym_R_DQUOTE] = ACTIONS(2646),
    [anon_sym_LR_DQUOTE] = ACTIONS(2646),
    [anon_sym_uR_DQUOTE] = ACTIONS(2646),
    [anon_sym_UR_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2646),
    [anon_sym_co_await] = ACTIONS(2644),
    [anon_sym_new] = ACTIONS(2644),
    [anon_sym_requires] = ACTIONS(2644),
    [sym_this] = ACTIONS(2644),
    [anon_sym_discard] = ACTIONS(2644),
    [anon_sym_precise] = ACTIONS(2644),
    [anon_sym_shared] = ACTIONS(2644),
    [anon_sym_groupshared] = ACTIONS(2644),
    [anon_sym_uniform] = ACTIONS(2644),
    [anon_sym_row_major] = ACTIONS(2644),
    [anon_sym_column_major] = ACTIONS(2644),
    [anon_sym_globallycoherent] = ACTIONS(2644),
    [anon_sym_centroid] = ACTIONS(2644),
    [anon_sym_noperspective] = ACTIONS(2644),
    [anon_sym_nointerpolation] = ACTIONS(2644),
    [anon_sym_sample] = ACTIONS(2644),
    [anon_sym_linear] = ACTIONS(2644),
    [anon_sym_snorm] = ACTIONS(2644),
    [anon_sym_unorm] = ACTIONS(2644),
    [anon_sym_point] = ACTIONS(2644),
    [anon_sym_line] = ACTIONS(2644),
    [anon_sym_triangleadj] = ACTIONS(2644),
    [anon_sym_lineadj] = ACTIONS(2644),
    [anon_sym_triangle] = ACTIONS(2644),
    [anon_sym_cbuffer] = ACTIONS(2644),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_preproc_include_token1] = ACTIONS(2648),
    [aux_sym_preproc_def_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token2] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2648),
    [sym_preproc_directive] = ACTIONS(2648),
    [anon_sym_LPAREN2] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_AMP_AMP] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym___extension__] = ACTIONS(2648),
    [anon_sym_typedef] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_out] = ACTIONS(2648),
    [anon_sym_inout] = ACTIONS(2648),
    [anon_sym_virtual] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym___attribute__] = ACTIONS(2648),
    [anon_sym___attribute] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2650),
    [anon_sym___declspec] = ACTIONS(2648),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym___cdecl] = ACTIONS(2648),
    [anon_sym___clrcall] = ACTIONS(2648),
    [anon_sym___stdcall] = ACTIONS(2648),
    [anon_sym___fastcall] = ACTIONS(2648),
    [anon_sym___thiscall] = ACTIONS(2648),
    [anon_sym___vectorcall] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_signed] = ACTIONS(2648),
    [anon_sym_unsigned] = ACTIONS(2648),
    [anon_sym_long] = ACTIONS(2648),
    [anon_sym_short] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_register] = ACTIONS(2648),
    [anon_sym_inline] = ACTIONS(2648),
    [anon_sym___inline] = ACTIONS(2648),
    [anon_sym___inline__] = ACTIONS(2648),
    [anon_sym___forceinline] = ACTIONS(2648),
    [anon_sym_thread_local] = ACTIONS(2648),
    [anon_sym___thread] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_constexpr] = ACTIONS(2648),
    [anon_sym_volatile] = ACTIONS(2648),
    [anon_sym_restrict] = ACTIONS(2648),
    [anon_sym___restrict__] = ACTIONS(2648),
    [anon_sym__Atomic] = ACTIONS(2648),
    [anon_sym__Noreturn] = ACTIONS(2648),
    [anon_sym_noreturn] = ACTIONS(2648),
    [anon_sym__Nonnull] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_constinit] = ACTIONS(2648),
    [anon_sym_consteval] = ACTIONS(2648),
    [anon_sym_alignas] = ACTIONS(2648),
    [anon_sym__Alignas] = ACTIONS(2648),
    [sym_primitive_type] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_class] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_switch] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_goto] = ACTIONS(2648),
    [anon_sym___try] = ACTIONS(2648),
    [anon_sym___leave] = ACTIONS(2648),
    [anon_sym_not] = ACTIONS(2648),
    [anon_sym_compl] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_sizeof] = ACTIONS(2648),
    [anon_sym___alignof__] = ACTIONS(2648),
    [anon_sym___alignof] = ACTIONS(2648),
    [anon_sym__alignof] = ACTIONS(2648),
    [anon_sym_alignof] = ACTIONS(2648),
    [anon_sym__Alignof] = ACTIONS(2648),
    [anon_sym_offsetof] = ACTIONS(2648),
    [anon_sym__Generic] = ACTIONS(2648),
    [anon_sym_asm] = ACTIONS(2648),
    [anon_sym___asm__] = ACTIONS(2648),
    [anon_sym___asm] = ACTIONS(2648),
    [sym_number_literal] = ACTIONS(2650),
    [anon_sym_L_SQUOTE] = ACTIONS(2650),
    [anon_sym_u_SQUOTE] = ACTIONS(2650),
    [anon_sym_U_SQUOTE] = ACTIONS(2650),
    [anon_sym_u8_SQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [anon_sym_L_DQUOTE] = ACTIONS(2650),
    [anon_sym_u_DQUOTE] = ACTIONS(2650),
    [anon_sym_U_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8_DQUOTE] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [anon_sym_NULL] = ACTIONS(2648),
    [anon_sym_nullptr] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2648),
    [anon_sym_decltype] = ACTIONS(2648),
    [anon_sym_explicit] = ACTIONS(2648),
    [anon_sym_typename] = ACTIONS(2648),
    [anon_sym_template] = ACTIONS(2648),
    [anon_sym_operator] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_delete] = ACTIONS(2648),
    [anon_sym_throw] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_static_assert] = ACTIONS(2648),
    [anon_sym_concept] = ACTIONS(2648),
    [anon_sym_co_return] = ACTIONS(2648),
    [anon_sym_co_yield] = ACTIONS(2648),
    [anon_sym_R_DQUOTE] = ACTIONS(2650),
    [anon_sym_LR_DQUOTE] = ACTIONS(2650),
    [anon_sym_uR_DQUOTE] = ACTIONS(2650),
    [anon_sym_UR_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2650),
    [anon_sym_co_await] = ACTIONS(2648),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_requires] = ACTIONS(2648),
    [sym_this] = ACTIONS(2648),
    [anon_sym_discard] = ACTIONS(2648),
    [anon_sym_precise] = ACTIONS(2648),
    [anon_sym_shared] = ACTIONS(2648),
    [anon_sym_groupshared] = ACTIONS(2648),
    [anon_sym_uniform] = ACTIONS(2648),
    [anon_sym_row_major] = ACTIONS(2648),
    [anon_sym_column_major] = ACTIONS(2648),
    [anon_sym_globallycoherent] = ACTIONS(2648),
    [anon_sym_centroid] = ACTIONS(2648),
    [anon_sym_noperspective] = ACTIONS(2648),
    [anon_sym_nointerpolation] = ACTIONS(2648),
    [anon_sym_sample] = ACTIONS(2648),
    [anon_sym_linear] = ACTIONS(2648),
    [anon_sym_snorm] = ACTIONS(2648),
    [anon_sym_unorm] = ACTIONS(2648),
    [anon_sym_point] = ACTIONS(2648),
    [anon_sym_line] = ACTIONS(2648),
    [anon_sym_triangleadj] = ACTIONS(2648),
    [anon_sym_lineadj] = ACTIONS(2648),
    [anon_sym_triangle] = ACTIONS(2648),
    [anon_sym_cbuffer] = ACTIONS(2648),
  },
  [683] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_include_token1] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym___cdecl] = ACTIONS(2620),
    [anon_sym___clrcall] = ACTIONS(2620),
    [anon_sym___stdcall] = ACTIONS(2620),
    [anon_sym___fastcall] = ACTIONS(2620),
    [anon_sym___thiscall] = ACTIONS(2620),
    [anon_sym___vectorcall] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_switch] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_goto] = ACTIONS(2620),
    [anon_sym___try] = ACTIONS(2620),
    [anon_sym___leave] = ACTIONS(2620),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_compl] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_sizeof] = ACTIONS(2620),
    [anon_sym___alignof__] = ACTIONS(2620),
    [anon_sym___alignof] = ACTIONS(2620),
    [anon_sym__alignof] = ACTIONS(2620),
    [anon_sym_alignof] = ACTIONS(2620),
    [anon_sym__Alignof] = ACTIONS(2620),
    [anon_sym_offsetof] = ACTIONS(2620),
    [anon_sym__Generic] = ACTIONS(2620),
    [anon_sym_asm] = ACTIONS(2620),
    [anon_sym___asm__] = ACTIONS(2620),
    [anon_sym___asm] = ACTIONS(2620),
    [sym_number_literal] = ACTIONS(2622),
    [anon_sym_L_SQUOTE] = ACTIONS(2622),
    [anon_sym_u_SQUOTE] = ACTIONS(2622),
    [anon_sym_U_SQUOTE] = ACTIONS(2622),
    [anon_sym_u8_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_L_DQUOTE] = ACTIONS(2622),
    [anon_sym_u_DQUOTE] = ACTIONS(2622),
    [anon_sym_U_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8_DQUOTE] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [anon_sym_NULL] = ACTIONS(2620),
    [anon_sym_nullptr] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_delete] = ACTIONS(2620),
    [anon_sym_throw] = ACTIONS(2620),
    [anon_sym_namespace] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_concept] = ACTIONS(2620),
    [anon_sym_co_return] = ACTIONS(2620),
    [anon_sym_co_yield] = ACTIONS(2620),
    [anon_sym_R_DQUOTE] = ACTIONS(2622),
    [anon_sym_LR_DQUOTE] = ACTIONS(2622),
    [anon_sym_uR_DQUOTE] = ACTIONS(2622),
    [anon_sym_UR_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2622),
    [anon_sym_co_await] = ACTIONS(2620),
    [anon_sym_new] = ACTIONS(2620),
    [anon_sym_requires] = ACTIONS(2620),
    [sym_this] = ACTIONS(2620),
    [anon_sym_discard] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
    [anon_sym_cbuffer] = ACTIONS(2620),
  },
  [684] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_include_token1] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token2] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym___cdecl] = ACTIONS(2656),
    [anon_sym___clrcall] = ACTIONS(2656),
    [anon_sym___stdcall] = ACTIONS(2656),
    [anon_sym___fastcall] = ACTIONS(2656),
    [anon_sym___thiscall] = ACTIONS(2656),
    [anon_sym___vectorcall] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_goto] = ACTIONS(2656),
    [anon_sym___try] = ACTIONS(2656),
    [anon_sym___leave] = ACTIONS(2656),
    [anon_sym_not] = ACTIONS(2656),
    [anon_sym_compl] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_sizeof] = ACTIONS(2656),
    [anon_sym___alignof__] = ACTIONS(2656),
    [anon_sym___alignof] = ACTIONS(2656),
    [anon_sym__alignof] = ACTIONS(2656),
    [anon_sym_alignof] = ACTIONS(2656),
    [anon_sym__Alignof] = ACTIONS(2656),
    [anon_sym_offsetof] = ACTIONS(2656),
    [anon_sym__Generic] = ACTIONS(2656),
    [anon_sym_asm] = ACTIONS(2656),
    [anon_sym___asm__] = ACTIONS(2656),
    [anon_sym___asm] = ACTIONS(2656),
    [sym_number_literal] = ACTIONS(2658),
    [anon_sym_L_SQUOTE] = ACTIONS(2658),
    [anon_sym_u_SQUOTE] = ACTIONS(2658),
    [anon_sym_U_SQUOTE] = ACTIONS(2658),
    [anon_sym_u8_SQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_L_DQUOTE] = ACTIONS(2658),
    [anon_sym_u_DQUOTE] = ACTIONS(2658),
    [anon_sym_U_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8_DQUOTE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [anon_sym_NULL] = ACTIONS(2656),
    [anon_sym_nullptr] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_concept] = ACTIONS(2656),
    [anon_sym_co_return] = ACTIONS(2656),
    [anon_sym_co_yield] = ACTIONS(2656),
    [anon_sym_R_DQUOTE] = ACTIONS(2658),
    [anon_sym_LR_DQUOTE] = ACTIONS(2658),
    [anon_sym_uR_DQUOTE] = ACTIONS(2658),
    [anon_sym_UR_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2658),
    [anon_sym_co_await] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_requires] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [anon_sym_discard] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
    [anon_sym_cbuffer] = ACTIONS(2656),
  },
  [685] = {
    [sym_identifier] = ACTIONS(2588),
    [aux_sym_preproc_include_token1] = ACTIONS(2588),
    [aux_sym_preproc_def_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2588),
    [sym_preproc_directive] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym___extension__] = ACTIONS(2588),
    [anon_sym_typedef] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_out] = ACTIONS(2588),
    [anon_sym_inout] = ACTIONS(2588),
    [anon_sym_virtual] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym___attribute__] = ACTIONS(2588),
    [anon_sym___attribute] = ACTIONS(2588),
    [anon_sym_using] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2588),
    [anon_sym___based] = ACTIONS(2588),
    [anon_sym___cdecl] = ACTIONS(2588),
    [anon_sym___clrcall] = ACTIONS(2588),
    [anon_sym___stdcall] = ACTIONS(2588),
    [anon_sym___fastcall] = ACTIONS(2588),
    [anon_sym___thiscall] = ACTIONS(2588),
    [anon_sym___vectorcall] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2588),
    [anon_sym_unsigned] = ACTIONS(2588),
    [anon_sym_long] = ACTIONS(2588),
    [anon_sym_short] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_register] = ACTIONS(2588),
    [anon_sym_inline] = ACTIONS(2588),
    [anon_sym___inline] = ACTIONS(2588),
    [anon_sym___inline__] = ACTIONS(2588),
    [anon_sym___forceinline] = ACTIONS(2588),
    [anon_sym_thread_local] = ACTIONS(2588),
    [anon_sym___thread] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_constexpr] = ACTIONS(2588),
    [anon_sym_volatile] = ACTIONS(2588),
    [anon_sym_restrict] = ACTIONS(2588),
    [anon_sym___restrict__] = ACTIONS(2588),
    [anon_sym__Atomic] = ACTIONS(2588),
    [anon_sym__Noreturn] = ACTIONS(2588),
    [anon_sym_noreturn] = ACTIONS(2588),
    [anon_sym__Nonnull] = ACTIONS(2588),
    [anon_sym_mutable] = ACTIONS(2588),
    [anon_sym_constinit] = ACTIONS(2588),
    [anon_sym_consteval] = ACTIONS(2588),
    [anon_sym_alignas] = ACTIONS(2588),
    [anon_sym__Alignas] = ACTIONS(2588),
    [sym_primitive_type] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_goto] = ACTIONS(2588),
    [anon_sym___try] = ACTIONS(2588),
    [anon_sym___leave] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2588),
    [anon_sym_compl] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_sizeof] = ACTIONS(2588),
    [anon_sym___alignof__] = ACTIONS(2588),
    [anon_sym___alignof] = ACTIONS(2588),
    [anon_sym__alignof] = ACTIONS(2588),
    [anon_sym_alignof] = ACTIONS(2588),
    [anon_sym__Alignof] = ACTIONS(2588),
    [anon_sym_offsetof] = ACTIONS(2588),
    [anon_sym__Generic] = ACTIONS(2588),
    [anon_sym_asm] = ACTIONS(2588),
    [anon_sym___asm__] = ACTIONS(2588),
    [anon_sym___asm] = ACTIONS(2588),
    [sym_number_literal] = ACTIONS(2590),
    [anon_sym_L_SQUOTE] = ACTIONS(2590),
    [anon_sym_u_SQUOTE] = ACTIONS(2590),
    [anon_sym_U_SQUOTE] = ACTIONS(2590),
    [anon_sym_u8_SQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [anon_sym_L_DQUOTE] = ACTIONS(2590),
    [anon_sym_u_DQUOTE] = ACTIONS(2590),
    [anon_sym_U_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8_DQUOTE] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [anon_sym_NULL] = ACTIONS(2588),
    [anon_sym_nullptr] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2588),
    [anon_sym_decltype] = ACTIONS(2588),
    [anon_sym_explicit] = ACTIONS(2588),
    [anon_sym_typename] = ACTIONS(2588),
    [anon_sym_template] = ACTIONS(2588),
    [anon_sym_operator] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_static_assert] = ACTIONS(2588),
    [anon_sym_concept] = ACTIONS(2588),
    [anon_sym_co_return] = ACTIONS(2588),
    [anon_sym_co_yield] = ACTIONS(2588),
    [anon_sym_R_DQUOTE] = ACTIONS(2590),
    [anon_sym_LR_DQUOTE] = ACTIONS(2590),
    [anon_sym_uR_DQUOTE] = ACTIONS(2590),
    [anon_sym_UR_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2590),
    [anon_sym_co_await] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_requires] = ACTIONS(2588),
    [sym_this] = ACTIONS(2588),
    [anon_sym_discard] = ACTIONS(2588),
    [anon_sym_precise] = ACTIONS(2588),
    [anon_sym_shared] = ACTIONS(2588),
    [anon_sym_groupshared] = ACTIONS(2588),
    [anon_sym_uniform] = ACTIONS(2588),
    [anon_sym_row_major] = ACTIONS(2588),
    [anon_sym_column_major] = ACTIONS(2588),
    [anon_sym_globallycoherent] = ACTIONS(2588),
    [anon_sym_centroid] = ACTIONS(2588),
    [anon_sym_noperspective] = ACTIONS(2588),
    [anon_sym_nointerpolation] = ACTIONS(2588),
    [anon_sym_sample] = ACTIONS(2588),
    [anon_sym_linear] = ACTIONS(2588),
    [anon_sym_snorm] = ACTIONS(2588),
    [anon_sym_unorm] = ACTIONS(2588),
    [anon_sym_point] = ACTIONS(2588),
    [anon_sym_line] = ACTIONS(2588),
    [anon_sym_triangleadj] = ACTIONS(2588),
    [anon_sym_lineadj] = ACTIONS(2588),
    [anon_sym_triangle] = ACTIONS(2588),
    [anon_sym_cbuffer] = ACTIONS(2588),
  },
  [686] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_include_token1] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token2] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym___cdecl] = ACTIONS(2596),
    [anon_sym___clrcall] = ACTIONS(2596),
    [anon_sym___stdcall] = ACTIONS(2596),
    [anon_sym___fastcall] = ACTIONS(2596),
    [anon_sym___thiscall] = ACTIONS(2596),
    [anon_sym___vectorcall] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_goto] = ACTIONS(2596),
    [anon_sym___try] = ACTIONS(2596),
    [anon_sym___leave] = ACTIONS(2596),
    [anon_sym_not] = ACTIONS(2596),
    [anon_sym_compl] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_sizeof] = ACTIONS(2596),
    [anon_sym___alignof__] = ACTIONS(2596),
    [anon_sym___alignof] = ACTIONS(2596),
    [anon_sym__alignof] = ACTIONS(2596),
    [anon_sym_alignof] = ACTIONS(2596),
    [anon_sym__Alignof] = ACTIONS(2596),
    [anon_sym_offsetof] = ACTIONS(2596),
    [anon_sym__Generic] = ACTIONS(2596),
    [anon_sym_asm] = ACTIONS(2596),
    [anon_sym___asm__] = ACTIONS(2596),
    [anon_sym___asm] = ACTIONS(2596),
    [sym_number_literal] = ACTIONS(2598),
    [anon_sym_L_SQUOTE] = ACTIONS(2598),
    [anon_sym_u_SQUOTE] = ACTIONS(2598),
    [anon_sym_U_SQUOTE] = ACTIONS(2598),
    [anon_sym_u8_SQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_L_DQUOTE] = ACTIONS(2598),
    [anon_sym_u_DQUOTE] = ACTIONS(2598),
    [anon_sym_U_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8_DQUOTE] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [anon_sym_NULL] = ACTIONS(2596),
    [anon_sym_nullptr] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_concept] = ACTIONS(2596),
    [anon_sym_co_return] = ACTIONS(2596),
    [anon_sym_co_yield] = ACTIONS(2596),
    [anon_sym_R_DQUOTE] = ACTIONS(2598),
    [anon_sym_LR_DQUOTE] = ACTIONS(2598),
    [anon_sym_uR_DQUOTE] = ACTIONS(2598),
    [anon_sym_UR_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2598),
    [anon_sym_co_await] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_requires] = ACTIONS(2596),
    [sym_this] = ACTIONS(2596),
    [anon_sym_discard] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
    [anon_sym_cbuffer] = ACTIONS(2596),
  },
  [687] = {
    [sym_identifier] = ACTIONS(2528),
    [aux_sym_preproc_include_token1] = ACTIONS(2528),
    [aux_sym_preproc_def_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2528),
    [sym_preproc_directive] = ACTIONS(2528),
    [anon_sym_LPAREN2] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym___extension__] = ACTIONS(2528),
    [anon_sym_typedef] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2528),
    [anon_sym_out] = ACTIONS(2528),
    [anon_sym_inout] = ACTIONS(2528),
    [anon_sym_virtual] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym___attribute__] = ACTIONS(2528),
    [anon_sym___attribute] = ACTIONS(2528),
    [anon_sym_using] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2530),
    [anon_sym___declspec] = ACTIONS(2528),
    [anon_sym___based] = ACTIONS(2528),
    [anon_sym___cdecl] = ACTIONS(2528),
    [anon_sym___clrcall] = ACTIONS(2528),
    [anon_sym___stdcall] = ACTIONS(2528),
    [anon_sym___fastcall] = ACTIONS(2528),
    [anon_sym___thiscall] = ACTIONS(2528),
    [anon_sym___vectorcall] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_RBRACE] = ACTIONS(2530),
    [anon_sym_signed] = ACTIONS(2528),
    [anon_sym_unsigned] = ACTIONS(2528),
    [anon_sym_long] = ACTIONS(2528),
    [anon_sym_short] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_register] = ACTIONS(2528),
    [anon_sym_inline] = ACTIONS(2528),
    [anon_sym___inline] = ACTIONS(2528),
    [anon_sym___inline__] = ACTIONS(2528),
    [anon_sym___forceinline] = ACTIONS(2528),
    [anon_sym_thread_local] = ACTIONS(2528),
    [anon_sym___thread] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_constexpr] = ACTIONS(2528),
    [anon_sym_volatile] = ACTIONS(2528),
    [anon_sym_restrict] = ACTIONS(2528),
    [anon_sym___restrict__] = ACTIONS(2528),
    [anon_sym__Atomic] = ACTIONS(2528),
    [anon_sym__Noreturn] = ACTIONS(2528),
    [anon_sym_noreturn] = ACTIONS(2528),
    [anon_sym__Nonnull] = ACTIONS(2528),
    [anon_sym_mutable] = ACTIONS(2528),
    [anon_sym_constinit] = ACTIONS(2528),
    [anon_sym_consteval] = ACTIONS(2528),
    [anon_sym_alignas] = ACTIONS(2528),
    [anon_sym__Alignas] = ACTIONS(2528),
    [sym_primitive_type] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_goto] = ACTIONS(2528),
    [anon_sym___try] = ACTIONS(2528),
    [anon_sym___leave] = ACTIONS(2528),
    [anon_sym_not] = ACTIONS(2528),
    [anon_sym_compl] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2528),
    [anon_sym___alignof__] = ACTIONS(2528),
    [anon_sym___alignof] = ACTIONS(2528),
    [anon_sym__alignof] = ACTIONS(2528),
    [anon_sym_alignof] = ACTIONS(2528),
    [anon_sym__Alignof] = ACTIONS(2528),
    [anon_sym_offsetof] = ACTIONS(2528),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2528),
    [anon_sym___asm__] = ACTIONS(2528),
    [anon_sym___asm] = ACTIONS(2528),
    [sym_number_literal] = ACTIONS(2530),
    [anon_sym_L_SQUOTE] = ACTIONS(2530),
    [anon_sym_u_SQUOTE] = ACTIONS(2530),
    [anon_sym_U_SQUOTE] = ACTIONS(2530),
    [anon_sym_u8_SQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_L_DQUOTE] = ACTIONS(2530),
    [anon_sym_u_DQUOTE] = ACTIONS(2530),
    [anon_sym_U_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8_DQUOTE] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [anon_sym_NULL] = ACTIONS(2528),
    [anon_sym_nullptr] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2528),
    [anon_sym_decltype] = ACTIONS(2528),
    [anon_sym_explicit] = ACTIONS(2528),
    [anon_sym_typename] = ACTIONS(2528),
    [anon_sym_template] = ACTIONS(2528),
    [anon_sym_operator] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_static_assert] = ACTIONS(2528),
    [anon_sym_concept] = ACTIONS(2528),
    [anon_sym_co_return] = ACTIONS(2528),
    [anon_sym_co_yield] = ACTIONS(2528),
    [anon_sym_R_DQUOTE] = ACTIONS(2530),
    [anon_sym_LR_DQUOTE] = ACTIONS(2530),
    [anon_sym_uR_DQUOTE] = ACTIONS(2530),
    [anon_sym_UR_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2530),
    [anon_sym_co_await] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_requires] = ACTIONS(2528),
    [sym_this] = ACTIONS(2528),
    [anon_sym_discard] = ACTIONS(2528),
    [anon_sym_precise] = ACTIONS(2528),
    [anon_sym_shared] = ACTIONS(2528),
    [anon_sym_groupshared] = ACTIONS(2528),
    [anon_sym_uniform] = ACTIONS(2528),
    [anon_sym_row_major] = ACTIONS(2528),
    [anon_sym_column_major] = ACTIONS(2528),
    [anon_sym_globallycoherent] = ACTIONS(2528),
    [anon_sym_centroid] = ACTIONS(2528),
    [anon_sym_noperspective] = ACTIONS(2528),
    [anon_sym_nointerpolation] = ACTIONS(2528),
    [anon_sym_sample] = ACTIONS(2528),
    [anon_sym_linear] = ACTIONS(2528),
    [anon_sym_snorm] = ACTIONS(2528),
    [anon_sym_unorm] = ACTIONS(2528),
    [anon_sym_point] = ACTIONS(2528),
    [anon_sym_line] = ACTIONS(2528),
    [anon_sym_triangleadj] = ACTIONS(2528),
    [anon_sym_lineadj] = ACTIONS(2528),
    [anon_sym_triangle] = ACTIONS(2528),
    [anon_sym_cbuffer] = ACTIONS(2528),
  },
  [688] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_include_token1] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym___cdecl] = ACTIONS(2624),
    [anon_sym___clrcall] = ACTIONS(2624),
    [anon_sym___stdcall] = ACTIONS(2624),
    [anon_sym___fastcall] = ACTIONS(2624),
    [anon_sym___thiscall] = ACTIONS(2624),
    [anon_sym___vectorcall] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_goto] = ACTIONS(2624),
    [anon_sym___try] = ACTIONS(2624),
    [anon_sym___leave] = ACTIONS(2624),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_compl] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2626),
    [anon_sym_sizeof] = ACTIONS(2624),
    [anon_sym___alignof__] = ACTIONS(2624),
    [anon_sym___alignof] = ACTIONS(2624),
    [anon_sym__alignof] = ACTIONS(2624),
    [anon_sym_alignof] = ACTIONS(2624),
    [anon_sym__Alignof] = ACTIONS(2624),
    [anon_sym_offsetof] = ACTIONS(2624),
    [anon_sym__Generic] = ACTIONS(2624),
    [anon_sym_asm] = ACTIONS(2624),
    [anon_sym___asm__] = ACTIONS(2624),
    [anon_sym___asm] = ACTIONS(2624),
    [sym_number_literal] = ACTIONS(2626),
    [anon_sym_L_SQUOTE] = ACTIONS(2626),
    [anon_sym_u_SQUOTE] = ACTIONS(2626),
    [anon_sym_U_SQUOTE] = ACTIONS(2626),
    [anon_sym_u8_SQUOTE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_L_DQUOTE] = ACTIONS(2626),
    [anon_sym_u_DQUOTE] = ACTIONS(2626),
    [anon_sym_U_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8_DQUOTE] = ACTIONS(2626),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [anon_sym_NULL] = ACTIONS(2624),
    [anon_sym_nullptr] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_concept] = ACTIONS(2624),
    [anon_sym_co_return] = ACTIONS(2624),
    [anon_sym_co_yield] = ACTIONS(2624),
    [anon_sym_R_DQUOTE] = ACTIONS(2626),
    [anon_sym_LR_DQUOTE] = ACTIONS(2626),
    [anon_sym_uR_DQUOTE] = ACTIONS(2626),
    [anon_sym_UR_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2626),
    [anon_sym_co_await] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_requires] = ACTIONS(2624),
    [sym_this] = ACTIONS(2624),
    [anon_sym_discard] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
    [anon_sym_cbuffer] = ACTIONS(2624),
  },
  [689] = {
    [sym_identifier] = ACTIONS(2474),
    [aux_sym_preproc_include_token1] = ACTIONS(2474),
    [aux_sym_preproc_def_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token2] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2474),
    [sym_preproc_directive] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2474),
    [anon_sym_typedef] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_out] = ACTIONS(2474),
    [anon_sym_inout] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym___attribute__] = ACTIONS(2474),
    [anon_sym___attribute] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2474),
    [anon_sym___based] = ACTIONS(2474),
    [anon_sym___cdecl] = ACTIONS(2474),
    [anon_sym___clrcall] = ACTIONS(2474),
    [anon_sym___stdcall] = ACTIONS(2474),
    [anon_sym___fastcall] = ACTIONS(2474),
    [anon_sym___thiscall] = ACTIONS(2474),
    [anon_sym___vectorcall] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2474),
    [anon_sym_unsigned] = ACTIONS(2474),
    [anon_sym_long] = ACTIONS(2474),
    [anon_sym_short] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_register] = ACTIONS(2474),
    [anon_sym_inline] = ACTIONS(2474),
    [anon_sym___inline] = ACTIONS(2474),
    [anon_sym___inline__] = ACTIONS(2474),
    [anon_sym___forceinline] = ACTIONS(2474),
    [anon_sym_thread_local] = ACTIONS(2474),
    [anon_sym___thread] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_constexpr] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_restrict] = ACTIONS(2474),
    [anon_sym___restrict__] = ACTIONS(2474),
    [anon_sym__Atomic] = ACTIONS(2474),
    [anon_sym__Noreturn] = ACTIONS(2474),
    [anon_sym_noreturn] = ACTIONS(2474),
    [anon_sym__Nonnull] = ACTIONS(2474),
    [anon_sym_mutable] = ACTIONS(2474),
    [anon_sym_constinit] = ACTIONS(2474),
    [anon_sym_consteval] = ACTIONS(2474),
    [anon_sym_alignas] = ACTIONS(2474),
    [anon_sym__Alignas] = ACTIONS(2474),
    [sym_primitive_type] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym___try] = ACTIONS(2474),
    [anon_sym___leave] = ACTIONS(2474),
    [anon_sym_not] = ACTIONS(2474),
    [anon_sym_compl] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym___alignof__] = ACTIONS(2474),
    [anon_sym___alignof] = ACTIONS(2474),
    [anon_sym__alignof] = ACTIONS(2474),
    [anon_sym_alignof] = ACTIONS(2474),
    [anon_sym__Alignof] = ACTIONS(2474),
    [anon_sym_offsetof] = ACTIONS(2474),
    [anon_sym__Generic] = ACTIONS(2474),
    [anon_sym_asm] = ACTIONS(2474),
    [anon_sym___asm__] = ACTIONS(2474),
    [anon_sym___asm] = ACTIONS(2474),
    [sym_number_literal] = ACTIONS(2477),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [anon_sym_NULL] = ACTIONS(2474),
    [anon_sym_nullptr] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2474),
    [anon_sym_decltype] = ACTIONS(2474),
    [anon_sym_explicit] = ACTIONS(2474),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_template] = ACTIONS(2474),
    [anon_sym_operator] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_static_assert] = ACTIONS(2474),
    [anon_sym_concept] = ACTIONS(2474),
    [anon_sym_co_return] = ACTIONS(2474),
    [anon_sym_co_yield] = ACTIONS(2474),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_requires] = ACTIONS(2474),
    [sym_this] = ACTIONS(2474),
    [anon_sym_discard] = ACTIONS(2474),
    [anon_sym_precise] = ACTIONS(2474),
    [anon_sym_shared] = ACTIONS(2474),
    [anon_sym_groupshared] = ACTIONS(2474),
    [anon_sym_uniform] = ACTIONS(2474),
    [anon_sym_row_major] = ACTIONS(2474),
    [anon_sym_column_major] = ACTIONS(2474),
    [anon_sym_globallycoherent] = ACTIONS(2474),
    [anon_sym_centroid] = ACTIONS(2474),
    [anon_sym_noperspective] = ACTIONS(2474),
    [anon_sym_nointerpolation] = ACTIONS(2474),
    [anon_sym_sample] = ACTIONS(2474),
    [anon_sym_linear] = ACTIONS(2474),
    [anon_sym_snorm] = ACTIONS(2474),
    [anon_sym_unorm] = ACTIONS(2474),
    [anon_sym_point] = ACTIONS(2474),
    [anon_sym_line] = ACTIONS(2474),
    [anon_sym_triangleadj] = ACTIONS(2474),
    [anon_sym_lineadj] = ACTIONS(2474),
    [anon_sym_triangle] = ACTIONS(2474),
    [anon_sym_cbuffer] = ACTIONS(2474),
  },
  [690] = {
    [sym_identifier] = ACTIONS(2664),
    [aux_sym_preproc_include_token1] = ACTIONS(2664),
    [aux_sym_preproc_def_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token2] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2664),
    [sym_preproc_directive] = ACTIONS(2664),
    [anon_sym_LPAREN2] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym___extension__] = ACTIONS(2664),
    [anon_sym_typedef] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2664),
    [anon_sym_out] = ACTIONS(2664),
    [anon_sym_inout] = ACTIONS(2664),
    [anon_sym_virtual] = ACTIONS(2664),
    [anon_sym_extern] = ACTIONS(2664),
    [anon_sym___attribute__] = ACTIONS(2664),
    [anon_sym___attribute] = ACTIONS(2664),
    [anon_sym_using] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2666),
    [anon_sym___declspec] = ACTIONS(2664),
    [anon_sym___based] = ACTIONS(2664),
    [anon_sym___cdecl] = ACTIONS(2664),
    [anon_sym___clrcall] = ACTIONS(2664),
    [anon_sym___stdcall] = ACTIONS(2664),
    [anon_sym___fastcall] = ACTIONS(2664),
    [anon_sym___thiscall] = ACTIONS(2664),
    [anon_sym___vectorcall] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_signed] = ACTIONS(2664),
    [anon_sym_unsigned] = ACTIONS(2664),
    [anon_sym_long] = ACTIONS(2664),
    [anon_sym_short] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_register] = ACTIONS(2664),
    [anon_sym_inline] = ACTIONS(2664),
    [anon_sym___inline] = ACTIONS(2664),
    [anon_sym___inline__] = ACTIONS(2664),
    [anon_sym___forceinline] = ACTIONS(2664),
    [anon_sym_thread_local] = ACTIONS(2664),
    [anon_sym___thread] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_constexpr] = ACTIONS(2664),
    [anon_sym_volatile] = ACTIONS(2664),
    [anon_sym_restrict] = ACTIONS(2664),
    [anon_sym___restrict__] = ACTIONS(2664),
    [anon_sym__Atomic] = ACTIONS(2664),
    [anon_sym__Noreturn] = ACTIONS(2664),
    [anon_sym_noreturn] = ACTIONS(2664),
    [anon_sym__Nonnull] = ACTIONS(2664),
    [anon_sym_mutable] = ACTIONS(2664),
    [anon_sym_constinit] = ACTIONS(2664),
    [anon_sym_consteval] = ACTIONS(2664),
    [anon_sym_alignas] = ACTIONS(2664),
    [anon_sym__Alignas] = ACTIONS(2664),
    [sym_primitive_type] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_struct] = ACTIONS(2664),
    [anon_sym_union] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_goto] = ACTIONS(2664),
    [anon_sym___try] = ACTIONS(2664),
    [anon_sym___leave] = ACTIONS(2664),
    [anon_sym_not] = ACTIONS(2664),
    [anon_sym_compl] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_sizeof] = ACTIONS(2664),
    [anon_sym___alignof__] = ACTIONS(2664),
    [anon_sym___alignof] = ACTIONS(2664),
    [anon_sym__alignof] = ACTIONS(2664),
    [anon_sym_alignof] = ACTIONS(2664),
    [anon_sym__Alignof] = ACTIONS(2664),
    [anon_sym_offsetof] = ACTIONS(2664),
    [anon_sym__Generic] = ACTIONS(2664),
    [anon_sym_asm] = ACTIONS(2664),
    [anon_sym___asm__] = ACTIONS(2664),
    [anon_sym___asm] = ACTIONS(2664),
    [sym_number_literal] = ACTIONS(2666),
    [anon_sym_L_SQUOTE] = ACTIONS(2666),
    [anon_sym_u_SQUOTE] = ACTIONS(2666),
    [anon_sym_U_SQUOTE] = ACTIONS(2666),
    [anon_sym_u8_SQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_L_DQUOTE] = ACTIONS(2666),
    [anon_sym_u_DQUOTE] = ACTIONS(2666),
    [anon_sym_U_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [anon_sym_NULL] = ACTIONS(2664),
    [anon_sym_nullptr] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2664),
    [anon_sym_decltype] = ACTIONS(2664),
    [anon_sym_explicit] = ACTIONS(2664),
    [anon_sym_typename] = ACTIONS(2664),
    [anon_sym_template] = ACTIONS(2664),
    [anon_sym_operator] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_static_assert] = ACTIONS(2664),
    [anon_sym_concept] = ACTIONS(2664),
    [anon_sym_co_return] = ACTIONS(2664),
    [anon_sym_co_yield] = ACTIONS(2664),
    [anon_sym_R_DQUOTE] = ACTIONS(2666),
    [anon_sym_LR_DQUOTE] = ACTIONS(2666),
    [anon_sym_uR_DQUOTE] = ACTIONS(2666),
    [anon_sym_UR_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2666),
    [anon_sym_co_await] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_requires] = ACTIONS(2664),
    [sym_this] = ACTIONS(2664),
    [anon_sym_discard] = ACTIONS(2664),
    [anon_sym_precise] = ACTIONS(2664),
    [anon_sym_shared] = ACTIONS(2664),
    [anon_sym_groupshared] = ACTIONS(2664),
    [anon_sym_uniform] = ACTIONS(2664),
    [anon_sym_row_major] = ACTIONS(2664),
    [anon_sym_column_major] = ACTIONS(2664),
    [anon_sym_globallycoherent] = ACTIONS(2664),
    [anon_sym_centroid] = ACTIONS(2664),
    [anon_sym_noperspective] = ACTIONS(2664),
    [anon_sym_nointerpolation] = ACTIONS(2664),
    [anon_sym_sample] = ACTIONS(2664),
    [anon_sym_linear] = ACTIONS(2664),
    [anon_sym_snorm] = ACTIONS(2664),
    [anon_sym_unorm] = ACTIONS(2664),
    [anon_sym_point] = ACTIONS(2664),
    [anon_sym_line] = ACTIONS(2664),
    [anon_sym_triangleadj] = ACTIONS(2664),
    [anon_sym_lineadj] = ACTIONS(2664),
    [anon_sym_triangle] = ACTIONS(2664),
    [anon_sym_cbuffer] = ACTIONS(2664),
  },
  [691] = {
    [sym_identifier] = ACTIONS(2668),
    [aux_sym_preproc_include_token1] = ACTIONS(2668),
    [aux_sym_preproc_def_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token2] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2668),
    [sym_preproc_directive] = ACTIONS(2668),
    [anon_sym_LPAREN2] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_STAR] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym___extension__] = ACTIONS(2668),
    [anon_sym_typedef] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2668),
    [anon_sym_out] = ACTIONS(2668),
    [anon_sym_inout] = ACTIONS(2668),
    [anon_sym_virtual] = ACTIONS(2668),
    [anon_sym_extern] = ACTIONS(2668),
    [anon_sym___attribute__] = ACTIONS(2668),
    [anon_sym___attribute] = ACTIONS(2668),
    [anon_sym_using] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2670),
    [anon_sym___declspec] = ACTIONS(2668),
    [anon_sym___based] = ACTIONS(2668),
    [anon_sym___cdecl] = ACTIONS(2668),
    [anon_sym___clrcall] = ACTIONS(2668),
    [anon_sym___stdcall] = ACTIONS(2668),
    [anon_sym___fastcall] = ACTIONS(2668),
    [anon_sym___thiscall] = ACTIONS(2668),
    [anon_sym___vectorcall] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_signed] = ACTIONS(2668),
    [anon_sym_unsigned] = ACTIONS(2668),
    [anon_sym_long] = ACTIONS(2668),
    [anon_sym_short] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_register] = ACTIONS(2668),
    [anon_sym_inline] = ACTIONS(2668),
    [anon_sym___inline] = ACTIONS(2668),
    [anon_sym___inline__] = ACTIONS(2668),
    [anon_sym___forceinline] = ACTIONS(2668),
    [anon_sym_thread_local] = ACTIONS(2668),
    [anon_sym___thread] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_constexpr] = ACTIONS(2668),
    [anon_sym_volatile] = ACTIONS(2668),
    [anon_sym_restrict] = ACTIONS(2668),
    [anon_sym___restrict__] = ACTIONS(2668),
    [anon_sym__Atomic] = ACTIONS(2668),
    [anon_sym__Noreturn] = ACTIONS(2668),
    [anon_sym_noreturn] = ACTIONS(2668),
    [anon_sym__Nonnull] = ACTIONS(2668),
    [anon_sym_mutable] = ACTIONS(2668),
    [anon_sym_constinit] = ACTIONS(2668),
    [anon_sym_consteval] = ACTIONS(2668),
    [anon_sym_alignas] = ACTIONS(2668),
    [anon_sym__Alignas] = ACTIONS(2668),
    [sym_primitive_type] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_struct] = ACTIONS(2668),
    [anon_sym_union] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_goto] = ACTIONS(2668),
    [anon_sym___try] = ACTIONS(2668),
    [anon_sym___leave] = ACTIONS(2668),
    [anon_sym_not] = ACTIONS(2668),
    [anon_sym_compl] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_sizeof] = ACTIONS(2668),
    [anon_sym___alignof__] = ACTIONS(2668),
    [anon_sym___alignof] = ACTIONS(2668),
    [anon_sym__alignof] = ACTIONS(2668),
    [anon_sym_alignof] = ACTIONS(2668),
    [anon_sym__Alignof] = ACTIONS(2668),
    [anon_sym_offsetof] = ACTIONS(2668),
    [anon_sym__Generic] = ACTIONS(2668),
    [anon_sym_asm] = ACTIONS(2668),
    [anon_sym___asm__] = ACTIONS(2668),
    [anon_sym___asm] = ACTIONS(2668),
    [sym_number_literal] = ACTIONS(2670),
    [anon_sym_L_SQUOTE] = ACTIONS(2670),
    [anon_sym_u_SQUOTE] = ACTIONS(2670),
    [anon_sym_U_SQUOTE] = ACTIONS(2670),
    [anon_sym_u8_SQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_L_DQUOTE] = ACTIONS(2670),
    [anon_sym_u_DQUOTE] = ACTIONS(2670),
    [anon_sym_U_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8_DQUOTE] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [anon_sym_NULL] = ACTIONS(2668),
    [anon_sym_nullptr] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2668),
    [anon_sym_decltype] = ACTIONS(2668),
    [anon_sym_explicit] = ACTIONS(2668),
    [anon_sym_typename] = ACTIONS(2668),
    [anon_sym_template] = ACTIONS(2668),
    [anon_sym_operator] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_static_assert] = ACTIONS(2668),
    [anon_sym_concept] = ACTIONS(2668),
    [anon_sym_co_return] = ACTIONS(2668),
    [anon_sym_co_yield] = ACTIONS(2668),
    [anon_sym_R_DQUOTE] = ACTIONS(2670),
    [anon_sym_LR_DQUOTE] = ACTIONS(2670),
    [anon_sym_uR_DQUOTE] = ACTIONS(2670),
    [anon_sym_UR_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2670),
    [anon_sym_co_await] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_requires] = ACTIONS(2668),
    [sym_this] = ACTIONS(2668),
    [anon_sym_discard] = ACTIONS(2668),
    [anon_sym_precise] = ACTIONS(2668),
    [anon_sym_shared] = ACTIONS(2668),
    [anon_sym_groupshared] = ACTIONS(2668),
    [anon_sym_uniform] = ACTIONS(2668),
    [anon_sym_row_major] = ACTIONS(2668),
    [anon_sym_column_major] = ACTIONS(2668),
    [anon_sym_globallycoherent] = ACTIONS(2668),
    [anon_sym_centroid] = ACTIONS(2668),
    [anon_sym_noperspective] = ACTIONS(2668),
    [anon_sym_nointerpolation] = ACTIONS(2668),
    [anon_sym_sample] = ACTIONS(2668),
    [anon_sym_linear] = ACTIONS(2668),
    [anon_sym_snorm] = ACTIONS(2668),
    [anon_sym_unorm] = ACTIONS(2668),
    [anon_sym_point] = ACTIONS(2668),
    [anon_sym_line] = ACTIONS(2668),
    [anon_sym_triangleadj] = ACTIONS(2668),
    [anon_sym_lineadj] = ACTIONS(2668),
    [anon_sym_triangle] = ACTIONS(2668),
    [anon_sym_cbuffer] = ACTIONS(2668),
  },
  [692] = {
    [sym_identifier] = ACTIONS(2672),
    [aux_sym_preproc_include_token1] = ACTIONS(2672),
    [aux_sym_preproc_def_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token2] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2672),
    [sym_preproc_directive] = ACTIONS(2672),
    [anon_sym_LPAREN2] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym___extension__] = ACTIONS(2672),
    [anon_sym_typedef] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2672),
    [anon_sym_out] = ACTIONS(2672),
    [anon_sym_inout] = ACTIONS(2672),
    [anon_sym_virtual] = ACTIONS(2672),
    [anon_sym_extern] = ACTIONS(2672),
    [anon_sym___attribute__] = ACTIONS(2672),
    [anon_sym___attribute] = ACTIONS(2672),
    [anon_sym_using] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2674),
    [anon_sym___declspec] = ACTIONS(2672),
    [anon_sym___based] = ACTIONS(2672),
    [anon_sym___cdecl] = ACTIONS(2672),
    [anon_sym___clrcall] = ACTIONS(2672),
    [anon_sym___stdcall] = ACTIONS(2672),
    [anon_sym___fastcall] = ACTIONS(2672),
    [anon_sym___thiscall] = ACTIONS(2672),
    [anon_sym___vectorcall] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_signed] = ACTIONS(2672),
    [anon_sym_unsigned] = ACTIONS(2672),
    [anon_sym_long] = ACTIONS(2672),
    [anon_sym_short] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_register] = ACTIONS(2672),
    [anon_sym_inline] = ACTIONS(2672),
    [anon_sym___inline] = ACTIONS(2672),
    [anon_sym___inline__] = ACTIONS(2672),
    [anon_sym___forceinline] = ACTIONS(2672),
    [anon_sym_thread_local] = ACTIONS(2672),
    [anon_sym___thread] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_constexpr] = ACTIONS(2672),
    [anon_sym_volatile] = ACTIONS(2672),
    [anon_sym_restrict] = ACTIONS(2672),
    [anon_sym___restrict__] = ACTIONS(2672),
    [anon_sym__Atomic] = ACTIONS(2672),
    [anon_sym__Noreturn] = ACTIONS(2672),
    [anon_sym_noreturn] = ACTIONS(2672),
    [anon_sym__Nonnull] = ACTIONS(2672),
    [anon_sym_mutable] = ACTIONS(2672),
    [anon_sym_constinit] = ACTIONS(2672),
    [anon_sym_consteval] = ACTIONS(2672),
    [anon_sym_alignas] = ACTIONS(2672),
    [anon_sym__Alignas] = ACTIONS(2672),
    [sym_primitive_type] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_goto] = ACTIONS(2672),
    [anon_sym___try] = ACTIONS(2672),
    [anon_sym___leave] = ACTIONS(2672),
    [anon_sym_not] = ACTIONS(2672),
    [anon_sym_compl] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_sizeof] = ACTIONS(2672),
    [anon_sym___alignof__] = ACTIONS(2672),
    [anon_sym___alignof] = ACTIONS(2672),
    [anon_sym__alignof] = ACTIONS(2672),
    [anon_sym_alignof] = ACTIONS(2672),
    [anon_sym__Alignof] = ACTIONS(2672),
    [anon_sym_offsetof] = ACTIONS(2672),
    [anon_sym__Generic] = ACTIONS(2672),
    [anon_sym_asm] = ACTIONS(2672),
    [anon_sym___asm__] = ACTIONS(2672),
    [anon_sym___asm] = ACTIONS(2672),
    [sym_number_literal] = ACTIONS(2674),
    [anon_sym_L_SQUOTE] = ACTIONS(2674),
    [anon_sym_u_SQUOTE] = ACTIONS(2674),
    [anon_sym_U_SQUOTE] = ACTIONS(2674),
    [anon_sym_u8_SQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_L_DQUOTE] = ACTIONS(2674),
    [anon_sym_u_DQUOTE] = ACTIONS(2674),
    [anon_sym_U_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8_DQUOTE] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [anon_sym_NULL] = ACTIONS(2672),
    [anon_sym_nullptr] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2672),
    [anon_sym_decltype] = ACTIONS(2672),
    [anon_sym_explicit] = ACTIONS(2672),
    [anon_sym_typename] = ACTIONS(2672),
    [anon_sym_template] = ACTIONS(2672),
    [anon_sym_operator] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_static_assert] = ACTIONS(2672),
    [anon_sym_concept] = ACTIONS(2672),
    [anon_sym_co_return] = ACTIONS(2672),
    [anon_sym_co_yield] = ACTIONS(2672),
    [anon_sym_R_DQUOTE] = ACTIONS(2674),
    [anon_sym_LR_DQUOTE] = ACTIONS(2674),
    [anon_sym_uR_DQUOTE] = ACTIONS(2674),
    [anon_sym_UR_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2674),
    [anon_sym_co_await] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_requires] = ACTIONS(2672),
    [sym_this] = ACTIONS(2672),
    [anon_sym_discard] = ACTIONS(2672),
    [anon_sym_precise] = ACTIONS(2672),
    [anon_sym_shared] = ACTIONS(2672),
    [anon_sym_groupshared] = ACTIONS(2672),
    [anon_sym_uniform] = ACTIONS(2672),
    [anon_sym_row_major] = ACTIONS(2672),
    [anon_sym_column_major] = ACTIONS(2672),
    [anon_sym_globallycoherent] = ACTIONS(2672),
    [anon_sym_centroid] = ACTIONS(2672),
    [anon_sym_noperspective] = ACTIONS(2672),
    [anon_sym_nointerpolation] = ACTIONS(2672),
    [anon_sym_sample] = ACTIONS(2672),
    [anon_sym_linear] = ACTIONS(2672),
    [anon_sym_snorm] = ACTIONS(2672),
    [anon_sym_unorm] = ACTIONS(2672),
    [anon_sym_point] = ACTIONS(2672),
    [anon_sym_line] = ACTIONS(2672),
    [anon_sym_triangleadj] = ACTIONS(2672),
    [anon_sym_lineadj] = ACTIONS(2672),
    [anon_sym_triangle] = ACTIONS(2672),
    [anon_sym_cbuffer] = ACTIONS(2672),
  },
  [693] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_include_token1] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym___cdecl] = ACTIONS(2628),
    [anon_sym___clrcall] = ACTIONS(2628),
    [anon_sym___stdcall] = ACTIONS(2628),
    [anon_sym___fastcall] = ACTIONS(2628),
    [anon_sym___thiscall] = ACTIONS(2628),
    [anon_sym___vectorcall] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_goto] = ACTIONS(2628),
    [anon_sym___try] = ACTIONS(2628),
    [anon_sym___leave] = ACTIONS(2628),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_compl] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_sizeof] = ACTIONS(2628),
    [anon_sym___alignof__] = ACTIONS(2628),
    [anon_sym___alignof] = ACTIONS(2628),
    [anon_sym__alignof] = ACTIONS(2628),
    [anon_sym_alignof] = ACTIONS(2628),
    [anon_sym__Alignof] = ACTIONS(2628),
    [anon_sym_offsetof] = ACTIONS(2628),
    [anon_sym__Generic] = ACTIONS(2628),
    [anon_sym_asm] = ACTIONS(2628),
    [anon_sym___asm__] = ACTIONS(2628),
    [anon_sym___asm] = ACTIONS(2628),
    [sym_number_literal] = ACTIONS(2630),
    [anon_sym_L_SQUOTE] = ACTIONS(2630),
    [anon_sym_u_SQUOTE] = ACTIONS(2630),
    [anon_sym_U_SQUOTE] = ACTIONS(2630),
    [anon_sym_u8_SQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_L_DQUOTE] = ACTIONS(2630),
    [anon_sym_u_DQUOTE] = ACTIONS(2630),
    [anon_sym_U_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8_DQUOTE] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [anon_sym_NULL] = ACTIONS(2628),
    [anon_sym_nullptr] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_concept] = ACTIONS(2628),
    [anon_sym_co_return] = ACTIONS(2628),
    [anon_sym_co_yield] = ACTIONS(2628),
    [anon_sym_R_DQUOTE] = ACTIONS(2630),
    [anon_sym_LR_DQUOTE] = ACTIONS(2630),
    [anon_sym_uR_DQUOTE] = ACTIONS(2630),
    [anon_sym_UR_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2630),
    [anon_sym_co_await] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_requires] = ACTIONS(2628),
    [sym_this] = ACTIONS(2628),
    [anon_sym_discard] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
    [anon_sym_cbuffer] = ACTIONS(2628),
  },
  [694] = {
    [sym_identifier] = ACTIONS(2474),
    [aux_sym_preproc_include_token1] = ACTIONS(2474),
    [aux_sym_preproc_def_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2474),
    [sym_preproc_directive] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2474),
    [anon_sym_typedef] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_out] = ACTIONS(2474),
    [anon_sym_inout] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym___attribute__] = ACTIONS(2474),
    [anon_sym___attribute] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2474),
    [anon_sym___based] = ACTIONS(2474),
    [anon_sym___cdecl] = ACTIONS(2474),
    [anon_sym___clrcall] = ACTIONS(2474),
    [anon_sym___stdcall] = ACTIONS(2474),
    [anon_sym___fastcall] = ACTIONS(2474),
    [anon_sym___thiscall] = ACTIONS(2474),
    [anon_sym___vectorcall] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_RBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2474),
    [anon_sym_unsigned] = ACTIONS(2474),
    [anon_sym_long] = ACTIONS(2474),
    [anon_sym_short] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_register] = ACTIONS(2474),
    [anon_sym_inline] = ACTIONS(2474),
    [anon_sym___inline] = ACTIONS(2474),
    [anon_sym___inline__] = ACTIONS(2474),
    [anon_sym___forceinline] = ACTIONS(2474),
    [anon_sym_thread_local] = ACTIONS(2474),
    [anon_sym___thread] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_constexpr] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_restrict] = ACTIONS(2474),
    [anon_sym___restrict__] = ACTIONS(2474),
    [anon_sym__Atomic] = ACTIONS(2474),
    [anon_sym__Noreturn] = ACTIONS(2474),
    [anon_sym_noreturn] = ACTIONS(2474),
    [anon_sym__Nonnull] = ACTIONS(2474),
    [anon_sym_mutable] = ACTIONS(2474),
    [anon_sym_constinit] = ACTIONS(2474),
    [anon_sym_consteval] = ACTIONS(2474),
    [anon_sym_alignas] = ACTIONS(2474),
    [anon_sym__Alignas] = ACTIONS(2474),
    [sym_primitive_type] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym___try] = ACTIONS(2474),
    [anon_sym___leave] = ACTIONS(2474),
    [anon_sym_not] = ACTIONS(2474),
    [anon_sym_compl] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym___alignof__] = ACTIONS(2474),
    [anon_sym___alignof] = ACTIONS(2474),
    [anon_sym__alignof] = ACTIONS(2474),
    [anon_sym_alignof] = ACTIONS(2474),
    [anon_sym__Alignof] = ACTIONS(2474),
    [anon_sym_offsetof] = ACTIONS(2474),
    [anon_sym__Generic] = ACTIONS(2474),
    [anon_sym_asm] = ACTIONS(2474),
    [anon_sym___asm__] = ACTIONS(2474),
    [anon_sym___asm] = ACTIONS(2474),
    [sym_number_literal] = ACTIONS(2477),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [anon_sym_NULL] = ACTIONS(2474),
    [anon_sym_nullptr] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2474),
    [anon_sym_decltype] = ACTIONS(2474),
    [anon_sym_explicit] = ACTIONS(2474),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_template] = ACTIONS(2474),
    [anon_sym_operator] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_static_assert] = ACTIONS(2474),
    [anon_sym_concept] = ACTIONS(2474),
    [anon_sym_co_return] = ACTIONS(2474),
    [anon_sym_co_yield] = ACTIONS(2474),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_requires] = ACTIONS(2474),
    [sym_this] = ACTIONS(2474),
    [anon_sym_discard] = ACTIONS(2474),
    [anon_sym_precise] = ACTIONS(2474),
    [anon_sym_shared] = ACTIONS(2474),
    [anon_sym_groupshared] = ACTIONS(2474),
    [anon_sym_uniform] = ACTIONS(2474),
    [anon_sym_row_major] = ACTIONS(2474),
    [anon_sym_column_major] = ACTIONS(2474),
    [anon_sym_globallycoherent] = ACTIONS(2474),
    [anon_sym_centroid] = ACTIONS(2474),
    [anon_sym_noperspective] = ACTIONS(2474),
    [anon_sym_nointerpolation] = ACTIONS(2474),
    [anon_sym_sample] = ACTIONS(2474),
    [anon_sym_linear] = ACTIONS(2474),
    [anon_sym_snorm] = ACTIONS(2474),
    [anon_sym_unorm] = ACTIONS(2474),
    [anon_sym_point] = ACTIONS(2474),
    [anon_sym_line] = ACTIONS(2474),
    [anon_sym_triangleadj] = ACTIONS(2474),
    [anon_sym_lineadj] = ACTIONS(2474),
    [anon_sym_triangle] = ACTIONS(2474),
    [anon_sym_cbuffer] = ACTIONS(2474),
  },
  [695] = {
    [sym_identifier] = ACTIONS(2480),
    [aux_sym_preproc_include_token1] = ACTIONS(2480),
    [aux_sym_preproc_def_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_LPAREN2] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_out] = ACTIONS(2480),
    [anon_sym_inout] = ACTIONS(2480),
    [anon_sym_virtual] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym___attribute__] = ACTIONS(2480),
    [anon_sym___attribute] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2482),
    [anon_sym___declspec] = ACTIONS(2480),
    [anon_sym___based] = ACTIONS(2480),
    [anon_sym___cdecl] = ACTIONS(2480),
    [anon_sym___clrcall] = ACTIONS(2480),
    [anon_sym___stdcall] = ACTIONS(2480),
    [anon_sym___fastcall] = ACTIONS(2480),
    [anon_sym___thiscall] = ACTIONS(2480),
    [anon_sym___vectorcall] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym___inline] = ACTIONS(2480),
    [anon_sym___inline__] = ACTIONS(2480),
    [anon_sym___forceinline] = ACTIONS(2480),
    [anon_sym_thread_local] = ACTIONS(2480),
    [anon_sym___thread] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym___restrict__] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym__Noreturn] = ACTIONS(2480),
    [anon_sym_noreturn] = ACTIONS(2480),
    [anon_sym__Nonnull] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_constinit] = ACTIONS(2480),
    [anon_sym_consteval] = ACTIONS(2480),
    [anon_sym_alignas] = ACTIONS(2480),
    [anon_sym__Alignas] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym___try] = ACTIONS(2480),
    [anon_sym___leave] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2480),
    [anon_sym_compl] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2480),
    [anon_sym___alignof__] = ACTIONS(2480),
    [anon_sym___alignof] = ACTIONS(2480),
    [anon_sym__alignof] = ACTIONS(2480),
    [anon_sym_alignof] = ACTIONS(2480),
    [anon_sym__Alignof] = ACTIONS(2480),
    [anon_sym_offsetof] = ACTIONS(2480),
    [anon_sym__Generic] = ACTIONS(2480),
    [anon_sym_asm] = ACTIONS(2480),
    [anon_sym___asm__] = ACTIONS(2480),
    [anon_sym___asm] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2482),
    [anon_sym_u_SQUOTE] = ACTIONS(2482),
    [anon_sym_U_SQUOTE] = ACTIONS(2482),
    [anon_sym_u8_SQUOTE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_L_DQUOTE] = ACTIONS(2482),
    [anon_sym_u_DQUOTE] = ACTIONS(2482),
    [anon_sym_U_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8_DQUOTE] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [anon_sym_NULL] = ACTIONS(2480),
    [anon_sym_nullptr] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_decltype] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_operator] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_throw] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_static_assert] = ACTIONS(2480),
    [anon_sym_concept] = ACTIONS(2480),
    [anon_sym_co_return] = ACTIONS(2480),
    [anon_sym_co_yield] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_requires] = ACTIONS(2480),
    [sym_this] = ACTIONS(2480),
    [anon_sym_discard] = ACTIONS(2480),
    [anon_sym_precise] = ACTIONS(2480),
    [anon_sym_shared] = ACTIONS(2480),
    [anon_sym_groupshared] = ACTIONS(2480),
    [anon_sym_uniform] = ACTIONS(2480),
    [anon_sym_row_major] = ACTIONS(2480),
    [anon_sym_column_major] = ACTIONS(2480),
    [anon_sym_globallycoherent] = ACTIONS(2480),
    [anon_sym_centroid] = ACTIONS(2480),
    [anon_sym_noperspective] = ACTIONS(2480),
    [anon_sym_nointerpolation] = ACTIONS(2480),
    [anon_sym_sample] = ACTIONS(2480),
    [anon_sym_linear] = ACTIONS(2480),
    [anon_sym_snorm] = ACTIONS(2480),
    [anon_sym_unorm] = ACTIONS(2480),
    [anon_sym_point] = ACTIONS(2480),
    [anon_sym_line] = ACTIONS(2480),
    [anon_sym_triangleadj] = ACTIONS(2480),
    [anon_sym_lineadj] = ACTIONS(2480),
    [anon_sym_triangle] = ACTIONS(2480),
    [anon_sym_cbuffer] = ACTIONS(2480),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2484),
    [aux_sym_preproc_include_token1] = ACTIONS(2484),
    [aux_sym_preproc_def_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2484),
    [sym_preproc_directive] = ACTIONS(2484),
    [anon_sym_LPAREN2] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym___extension__] = ACTIONS(2484),
    [anon_sym_typedef] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_out] = ACTIONS(2484),
    [anon_sym_inout] = ACTIONS(2484),
    [anon_sym_virtual] = ACTIONS(2484),
    [anon_sym_extern] = ACTIONS(2484),
    [anon_sym___attribute__] = ACTIONS(2484),
    [anon_sym___attribute] = ACTIONS(2484),
    [anon_sym_using] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2486),
    [anon_sym___declspec] = ACTIONS(2484),
    [anon_sym___based] = ACTIONS(2484),
    [anon_sym___cdecl] = ACTIONS(2484),
    [anon_sym___clrcall] = ACTIONS(2484),
    [anon_sym___stdcall] = ACTIONS(2484),
    [anon_sym___fastcall] = ACTIONS(2484),
    [anon_sym___thiscall] = ACTIONS(2484),
    [anon_sym___vectorcall] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2486),
    [anon_sym_signed] = ACTIONS(2484),
    [anon_sym_unsigned] = ACTIONS(2484),
    [anon_sym_long] = ACTIONS(2484),
    [anon_sym_short] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_register] = ACTIONS(2484),
    [anon_sym_inline] = ACTIONS(2484),
    [anon_sym___inline] = ACTIONS(2484),
    [anon_sym___inline__] = ACTIONS(2484),
    [anon_sym___forceinline] = ACTIONS(2484),
    [anon_sym_thread_local] = ACTIONS(2484),
    [anon_sym___thread] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_constexpr] = ACTIONS(2484),
    [anon_sym_volatile] = ACTIONS(2484),
    [anon_sym_restrict] = ACTIONS(2484),
    [anon_sym___restrict__] = ACTIONS(2484),
    [anon_sym__Atomic] = ACTIONS(2484),
    [anon_sym__Noreturn] = ACTIONS(2484),
    [anon_sym_noreturn] = ACTIONS(2484),
    [anon_sym__Nonnull] = ACTIONS(2484),
    [anon_sym_mutable] = ACTIONS(2484),
    [anon_sym_constinit] = ACTIONS(2484),
    [anon_sym_consteval] = ACTIONS(2484),
    [anon_sym_alignas] = ACTIONS(2484),
    [anon_sym__Alignas] = ACTIONS(2484),
    [sym_primitive_type] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_struct] = ACTIONS(2484),
    [anon_sym_union] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_goto] = ACTIONS(2484),
    [anon_sym___try] = ACTIONS(2484),
    [anon_sym___leave] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2484),
    [anon_sym_compl] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2484),
    [anon_sym___alignof__] = ACTIONS(2484),
    [anon_sym___alignof] = ACTIONS(2484),
    [anon_sym__alignof] = ACTIONS(2484),
    [anon_sym_alignof] = ACTIONS(2484),
    [anon_sym__Alignof] = ACTIONS(2484),
    [anon_sym_offsetof] = ACTIONS(2484),
    [anon_sym__Generic] = ACTIONS(2484),
    [anon_sym_asm] = ACTIONS(2484),
    [anon_sym___asm__] = ACTIONS(2484),
    [anon_sym___asm] = ACTIONS(2484),
    [sym_number_literal] = ACTIONS(2486),
    [anon_sym_L_SQUOTE] = ACTIONS(2486),
    [anon_sym_u_SQUOTE] = ACTIONS(2486),
    [anon_sym_U_SQUOTE] = ACTIONS(2486),
    [anon_sym_u8_SQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_L_DQUOTE] = ACTIONS(2486),
    [anon_sym_u_DQUOTE] = ACTIONS(2486),
    [anon_sym_U_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8_DQUOTE] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [anon_sym_NULL] = ACTIONS(2484),
    [anon_sym_nullptr] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2484),
    [anon_sym_decltype] = ACTIONS(2484),
    [anon_sym_explicit] = ACTIONS(2484),
    [anon_sym_typename] = ACTIONS(2484),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_static_assert] = ACTIONS(2484),
    [anon_sym_concept] = ACTIONS(2484),
    [anon_sym_co_return] = ACTIONS(2484),
    [anon_sym_co_yield] = ACTIONS(2484),
    [anon_sym_R_DQUOTE] = ACTIONS(2486),
    [anon_sym_LR_DQUOTE] = ACTIONS(2486),
    [anon_sym_uR_DQUOTE] = ACTIONS(2486),
    [anon_sym_UR_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2486),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2484),
    [anon_sym_requires] = ACTIONS(2484),
    [sym_this] = ACTIONS(2484),
    [anon_sym_discard] = ACTIONS(2484),
    [anon_sym_precise] = ACTIONS(2484),
    [anon_sym_shared] = ACTIONS(2484),
    [anon_sym_groupshared] = ACTIONS(2484),
    [anon_sym_uniform] = ACTIONS(2484),
    [anon_sym_row_major] = ACTIONS(2484),
    [anon_sym_column_major] = ACTIONS(2484),
    [anon_sym_globallycoherent] = ACTIONS(2484),
    [anon_sym_centroid] = ACTIONS(2484),
    [anon_sym_noperspective] = ACTIONS(2484),
    [anon_sym_nointerpolation] = ACTIONS(2484),
    [anon_sym_sample] = ACTIONS(2484),
    [anon_sym_linear] = ACTIONS(2484),
    [anon_sym_snorm] = ACTIONS(2484),
    [anon_sym_unorm] = ACTIONS(2484),
    [anon_sym_point] = ACTIONS(2484),
    [anon_sym_line] = ACTIONS(2484),
    [anon_sym_triangleadj] = ACTIONS(2484),
    [anon_sym_lineadj] = ACTIONS(2484),
    [anon_sym_triangle] = ACTIONS(2484),
    [anon_sym_cbuffer] = ACTIONS(2484),
  },
  [697] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym___try] = ACTIONS(2488),
    [anon_sym___leave] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [anon_sym___asm] = ACTIONS(2488),
    [sym_number_literal] = ACTIONS(2490),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
    [anon_sym_discard] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
    [anon_sym_cbuffer] = ACTIONS(2488),
  },
  [698] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym___try] = ACTIONS(2492),
    [anon_sym___leave] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [anon_sym___asm] = ACTIONS(2492),
    [sym_number_literal] = ACTIONS(2494),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
    [anon_sym_discard] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
    [anon_sym_cbuffer] = ACTIONS(2492),
  },
  [699] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_include_token1] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym___cdecl] = ACTIONS(2632),
    [anon_sym___clrcall] = ACTIONS(2632),
    [anon_sym___stdcall] = ACTIONS(2632),
    [anon_sym___fastcall] = ACTIONS(2632),
    [anon_sym___thiscall] = ACTIONS(2632),
    [anon_sym___vectorcall] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_goto] = ACTIONS(2632),
    [anon_sym___try] = ACTIONS(2632),
    [anon_sym___leave] = ACTIONS(2632),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_compl] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_sizeof] = ACTIONS(2632),
    [anon_sym___alignof__] = ACTIONS(2632),
    [anon_sym___alignof] = ACTIONS(2632),
    [anon_sym__alignof] = ACTIONS(2632),
    [anon_sym_alignof] = ACTIONS(2632),
    [anon_sym__Alignof] = ACTIONS(2632),
    [anon_sym_offsetof] = ACTIONS(2632),
    [anon_sym__Generic] = ACTIONS(2632),
    [anon_sym_asm] = ACTIONS(2632),
    [anon_sym___asm__] = ACTIONS(2632),
    [anon_sym___asm] = ACTIONS(2632),
    [sym_number_literal] = ACTIONS(2634),
    [anon_sym_L_SQUOTE] = ACTIONS(2634),
    [anon_sym_u_SQUOTE] = ACTIONS(2634),
    [anon_sym_U_SQUOTE] = ACTIONS(2634),
    [anon_sym_u8_SQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_L_DQUOTE] = ACTIONS(2634),
    [anon_sym_u_DQUOTE] = ACTIONS(2634),
    [anon_sym_U_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8_DQUOTE] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [anon_sym_NULL] = ACTIONS(2632),
    [anon_sym_nullptr] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_concept] = ACTIONS(2632),
    [anon_sym_co_return] = ACTIONS(2632),
    [anon_sym_co_yield] = ACTIONS(2632),
    [anon_sym_R_DQUOTE] = ACTIONS(2634),
    [anon_sym_LR_DQUOTE] = ACTIONS(2634),
    [anon_sym_uR_DQUOTE] = ACTIONS(2634),
    [anon_sym_UR_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2634),
    [anon_sym_co_await] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_requires] = ACTIONS(2632),
    [sym_this] = ACTIONS(2632),
    [anon_sym_discard] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
    [anon_sym_cbuffer] = ACTIONS(2632),
  },
  [700] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [701] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [702] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym___try] = ACTIONS(2524),
    [anon_sym___leave] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_discard] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
    [anon_sym_cbuffer] = ACTIONS(2524),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym___try] = ACTIONS(2556),
    [anon_sym___leave] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_discard] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
    [anon_sym_cbuffer] = ACTIONS(2556),
  },
  [706] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_include_token1] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym___cdecl] = ACTIONS(2560),
    [anon_sym___clrcall] = ACTIONS(2560),
    [anon_sym___stdcall] = ACTIONS(2560),
    [anon_sym___fastcall] = ACTIONS(2560),
    [anon_sym___thiscall] = ACTIONS(2560),
    [anon_sym___vectorcall] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_switch] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_do] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(2560),
    [anon_sym___try] = ACTIONS(2560),
    [anon_sym___leave] = ACTIONS(2560),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2560),
    [anon_sym___alignof__] = ACTIONS(2560),
    [anon_sym___alignof] = ACTIONS(2560),
    [anon_sym__alignof] = ACTIONS(2560),
    [anon_sym_alignof] = ACTIONS(2560),
    [anon_sym__Alignof] = ACTIONS(2560),
    [anon_sym_offsetof] = ACTIONS(2560),
    [anon_sym__Generic] = ACTIONS(2560),
    [anon_sym_asm] = ACTIONS(2560),
    [anon_sym___asm__] = ACTIONS(2560),
    [anon_sym___asm] = ACTIONS(2560),
    [sym_number_literal] = ACTIONS(2562),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2560),
    [sym_false] = ACTIONS(2560),
    [anon_sym_NULL] = ACTIONS(2560),
    [anon_sym_nullptr] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [anon_sym_delete] = ACTIONS(2560),
    [anon_sym_throw] = ACTIONS(2560),
    [anon_sym_namespace] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_concept] = ACTIONS(2560),
    [anon_sym_co_return] = ACTIONS(2560),
    [anon_sym_co_yield] = ACTIONS(2560),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2560),
    [anon_sym_new] = ACTIONS(2560),
    [anon_sym_requires] = ACTIONS(2560),
    [sym_this] = ACTIONS(2560),
    [anon_sym_discard] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
    [anon_sym_cbuffer] = ACTIONS(2560),
  },
  [707] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_include_token1] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym___cdecl] = ACTIONS(2564),
    [anon_sym___clrcall] = ACTIONS(2564),
    [anon_sym___stdcall] = ACTIONS(2564),
    [anon_sym___fastcall] = ACTIONS(2564),
    [anon_sym___thiscall] = ACTIONS(2564),
    [anon_sym___vectorcall] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_switch] = ACTIONS(2564),
    [anon_sym_case] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_goto] = ACTIONS(2564),
    [anon_sym___try] = ACTIONS(2564),
    [anon_sym___leave] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2564),
    [anon_sym_compl] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2566),
    [anon_sym_sizeof] = ACTIONS(2564),
    [anon_sym___alignof__] = ACTIONS(2564),
    [anon_sym___alignof] = ACTIONS(2564),
    [anon_sym__alignof] = ACTIONS(2564),
    [anon_sym_alignof] = ACTIONS(2564),
    [anon_sym__Alignof] = ACTIONS(2564),
    [anon_sym_offsetof] = ACTIONS(2564),
    [anon_sym__Generic] = ACTIONS(2564),
    [anon_sym_asm] = ACTIONS(2564),
    [anon_sym___asm__] = ACTIONS(2564),
    [anon_sym___asm] = ACTIONS(2564),
    [sym_number_literal] = ACTIONS(2566),
    [anon_sym_L_SQUOTE] = ACTIONS(2566),
    [anon_sym_u_SQUOTE] = ACTIONS(2566),
    [anon_sym_U_SQUOTE] = ACTIONS(2566),
    [anon_sym_u8_SQUOTE] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_L_DQUOTE] = ACTIONS(2566),
    [anon_sym_u_DQUOTE] = ACTIONS(2566),
    [anon_sym_U_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8_DQUOTE] = ACTIONS(2566),
    [anon_sym_DQUOTE] = ACTIONS(2566),
    [sym_true] = ACTIONS(2564),
    [sym_false] = ACTIONS(2564),
    [anon_sym_NULL] = ACTIONS(2564),
    [anon_sym_nullptr] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [anon_sym_delete] = ACTIONS(2564),
    [anon_sym_throw] = ACTIONS(2564),
    [anon_sym_namespace] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_concept] = ACTIONS(2564),
    [anon_sym_co_return] = ACTIONS(2564),
    [anon_sym_co_yield] = ACTIONS(2564),
    [anon_sym_R_DQUOTE] = ACTIONS(2566),
    [anon_sym_LR_DQUOTE] = ACTIONS(2566),
    [anon_sym_uR_DQUOTE] = ACTIONS(2566),
    [anon_sym_UR_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2566),
    [anon_sym_co_await] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2564),
    [anon_sym_requires] = ACTIONS(2564),
    [sym_this] = ACTIONS(2564),
    [anon_sym_discard] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
    [anon_sym_cbuffer] = ACTIONS(2564),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2576),
    [aux_sym_preproc_include_token1] = ACTIONS(2576),
    [aux_sym_preproc_def_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2576),
    [sym_preproc_directive] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym___extension__] = ACTIONS(2576),
    [anon_sym_typedef] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2576),
    [anon_sym_out] = ACTIONS(2576),
    [anon_sym_inout] = ACTIONS(2576),
    [anon_sym_virtual] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym___attribute__] = ACTIONS(2576),
    [anon_sym___attribute] = ACTIONS(2576),
    [anon_sym_using] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2578),
    [anon_sym___declspec] = ACTIONS(2576),
    [anon_sym___based] = ACTIONS(2576),
    [anon_sym___cdecl] = ACTIONS(2576),
    [anon_sym___clrcall] = ACTIONS(2576),
    [anon_sym___stdcall] = ACTIONS(2576),
    [anon_sym___fastcall] = ACTIONS(2576),
    [anon_sym___thiscall] = ACTIONS(2576),
    [anon_sym___vectorcall] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_RBRACE] = ACTIONS(2578),
    [anon_sym_signed] = ACTIONS(2576),
    [anon_sym_unsigned] = ACTIONS(2576),
    [anon_sym_long] = ACTIONS(2576),
    [anon_sym_short] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_register] = ACTIONS(2576),
    [anon_sym_inline] = ACTIONS(2576),
    [anon_sym___inline] = ACTIONS(2576),
    [anon_sym___inline__] = ACTIONS(2576),
    [anon_sym___forceinline] = ACTIONS(2576),
    [anon_sym_thread_local] = ACTIONS(2576),
    [anon_sym___thread] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_constexpr] = ACTIONS(2576),
    [anon_sym_volatile] = ACTIONS(2576),
    [anon_sym_restrict] = ACTIONS(2576),
    [anon_sym___restrict__] = ACTIONS(2576),
    [anon_sym__Atomic] = ACTIONS(2576),
    [anon_sym__Noreturn] = ACTIONS(2576),
    [anon_sym_noreturn] = ACTIONS(2576),
    [anon_sym__Nonnull] = ACTIONS(2576),
    [anon_sym_mutable] = ACTIONS(2576),
    [anon_sym_constinit] = ACTIONS(2576),
    [anon_sym_consteval] = ACTIONS(2576),
    [anon_sym_alignas] = ACTIONS(2576),
    [anon_sym__Alignas] = ACTIONS(2576),
    [sym_primitive_type] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_goto] = ACTIONS(2576),
    [anon_sym___try] = ACTIONS(2576),
    [anon_sym___leave] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2576),
    [anon_sym_compl] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2578),
    [anon_sym_sizeof] = ACTIONS(2576),
    [anon_sym___alignof__] = ACTIONS(2576),
    [anon_sym___alignof] = ACTIONS(2576),
    [anon_sym__alignof] = ACTIONS(2576),
    [anon_sym_alignof] = ACTIONS(2576),
    [anon_sym__Alignof] = ACTIONS(2576),
    [anon_sym_offsetof] = ACTIONS(2576),
    [anon_sym__Generic] = ACTIONS(2576),
    [anon_sym_asm] = ACTIONS(2576),
    [anon_sym___asm__] = ACTIONS(2576),
    [anon_sym___asm] = ACTIONS(2576),
    [sym_number_literal] = ACTIONS(2578),
    [anon_sym_L_SQUOTE] = ACTIONS(2578),
    [anon_sym_u_SQUOTE] = ACTIONS(2578),
    [anon_sym_U_SQUOTE] = ACTIONS(2578),
    [anon_sym_u8_SQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_L_DQUOTE] = ACTIONS(2578),
    [anon_sym_u_DQUOTE] = ACTIONS(2578),
    [anon_sym_U_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8_DQUOTE] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_NULL] = ACTIONS(2576),
    [anon_sym_nullptr] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2576),
    [anon_sym_decltype] = ACTIONS(2576),
    [anon_sym_explicit] = ACTIONS(2576),
    [anon_sym_typename] = ACTIONS(2576),
    [anon_sym_template] = ACTIONS(2576),
    [anon_sym_operator] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_static_assert] = ACTIONS(2576),
    [anon_sym_concept] = ACTIONS(2576),
    [anon_sym_co_return] = ACTIONS(2576),
    [anon_sym_co_yield] = ACTIONS(2576),
    [anon_sym_R_DQUOTE] = ACTIONS(2578),
    [anon_sym_LR_DQUOTE] = ACTIONS(2578),
    [anon_sym_uR_DQUOTE] = ACTIONS(2578),
    [anon_sym_UR_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2578),
    [anon_sym_co_await] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_requires] = ACTIONS(2576),
    [sym_this] = ACTIONS(2576),
    [anon_sym_discard] = ACTIONS(2576),
    [anon_sym_precise] = ACTIONS(2576),
    [anon_sym_shared] = ACTIONS(2576),
    [anon_sym_groupshared] = ACTIONS(2576),
    [anon_sym_uniform] = ACTIONS(2576),
    [anon_sym_row_major] = ACTIONS(2576),
    [anon_sym_column_major] = ACTIONS(2576),
    [anon_sym_globallycoherent] = ACTIONS(2576),
    [anon_sym_centroid] = ACTIONS(2576),
    [anon_sym_noperspective] = ACTIONS(2576),
    [anon_sym_nointerpolation] = ACTIONS(2576),
    [anon_sym_sample] = ACTIONS(2576),
    [anon_sym_linear] = ACTIONS(2576),
    [anon_sym_snorm] = ACTIONS(2576),
    [anon_sym_unorm] = ACTIONS(2576),
    [anon_sym_point] = ACTIONS(2576),
    [anon_sym_line] = ACTIONS(2576),
    [anon_sym_triangleadj] = ACTIONS(2576),
    [anon_sym_lineadj] = ACTIONS(2576),
    [anon_sym_triangle] = ACTIONS(2576),
    [anon_sym_cbuffer] = ACTIONS(2576),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_include_token1] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym___cdecl] = ACTIONS(2636),
    [anon_sym___clrcall] = ACTIONS(2636),
    [anon_sym___stdcall] = ACTIONS(2636),
    [anon_sym___fastcall] = ACTIONS(2636),
    [anon_sym___thiscall] = ACTIONS(2636),
    [anon_sym___vectorcall] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(2636),
    [anon_sym___try] = ACTIONS(2636),
    [anon_sym___leave] = ACTIONS(2636),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_compl] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2638),
    [anon_sym_sizeof] = ACTIONS(2636),
    [anon_sym___alignof__] = ACTIONS(2636),
    [anon_sym___alignof] = ACTIONS(2636),
    [anon_sym__alignof] = ACTIONS(2636),
    [anon_sym_alignof] = ACTIONS(2636),
    [anon_sym__Alignof] = ACTIONS(2636),
    [anon_sym_offsetof] = ACTIONS(2636),
    [anon_sym__Generic] = ACTIONS(2636),
    [anon_sym_asm] = ACTIONS(2636),
    [anon_sym___asm__] = ACTIONS(2636),
    [anon_sym___asm] = ACTIONS(2636),
    [sym_number_literal] = ACTIONS(2638),
    [anon_sym_L_SQUOTE] = ACTIONS(2638),
    [anon_sym_u_SQUOTE] = ACTIONS(2638),
    [anon_sym_U_SQUOTE] = ACTIONS(2638),
    [anon_sym_u8_SQUOTE] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_L_DQUOTE] = ACTIONS(2638),
    [anon_sym_u_DQUOTE] = ACTIONS(2638),
    [anon_sym_U_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8_DQUOTE] = ACTIONS(2638),
    [anon_sym_DQUOTE] = ACTIONS(2638),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [anon_sym_NULL] = ACTIONS(2636),
    [anon_sym_nullptr] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_concept] = ACTIONS(2636),
    [anon_sym_co_return] = ACTIONS(2636),
    [anon_sym_co_yield] = ACTIONS(2636),
    [anon_sym_R_DQUOTE] = ACTIONS(2638),
    [anon_sym_LR_DQUOTE] = ACTIONS(2638),
    [anon_sym_uR_DQUOTE] = ACTIONS(2638),
    [anon_sym_UR_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2638),
    [anon_sym_co_await] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_requires] = ACTIONS(2636),
    [sym_this] = ACTIONS(2636),
    [anon_sym_discard] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
    [anon_sym_cbuffer] = ACTIONS(2636),
  },
  [710] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_include_token1] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym___cdecl] = ACTIONS(2596),
    [anon_sym___clrcall] = ACTIONS(2596),
    [anon_sym___stdcall] = ACTIONS(2596),
    [anon_sym___fastcall] = ACTIONS(2596),
    [anon_sym___thiscall] = ACTIONS(2596),
    [anon_sym___vectorcall] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_goto] = ACTIONS(2596),
    [anon_sym___try] = ACTIONS(2596),
    [anon_sym___leave] = ACTIONS(2596),
    [anon_sym_not] = ACTIONS(2596),
    [anon_sym_compl] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_sizeof] = ACTIONS(2596),
    [anon_sym___alignof__] = ACTIONS(2596),
    [anon_sym___alignof] = ACTIONS(2596),
    [anon_sym__alignof] = ACTIONS(2596),
    [anon_sym_alignof] = ACTIONS(2596),
    [anon_sym__Alignof] = ACTIONS(2596),
    [anon_sym_offsetof] = ACTIONS(2596),
    [anon_sym__Generic] = ACTIONS(2596),
    [anon_sym_asm] = ACTIONS(2596),
    [anon_sym___asm__] = ACTIONS(2596),
    [anon_sym___asm] = ACTIONS(2596),
    [sym_number_literal] = ACTIONS(2598),
    [anon_sym_L_SQUOTE] = ACTIONS(2598),
    [anon_sym_u_SQUOTE] = ACTIONS(2598),
    [anon_sym_U_SQUOTE] = ACTIONS(2598),
    [anon_sym_u8_SQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_L_DQUOTE] = ACTIONS(2598),
    [anon_sym_u_DQUOTE] = ACTIONS(2598),
    [anon_sym_U_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8_DQUOTE] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [anon_sym_NULL] = ACTIONS(2596),
    [anon_sym_nullptr] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_concept] = ACTIONS(2596),
    [anon_sym_co_return] = ACTIONS(2596),
    [anon_sym_co_yield] = ACTIONS(2596),
    [anon_sym_R_DQUOTE] = ACTIONS(2598),
    [anon_sym_LR_DQUOTE] = ACTIONS(2598),
    [anon_sym_uR_DQUOTE] = ACTIONS(2598),
    [anon_sym_UR_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2598),
    [anon_sym_co_await] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_requires] = ACTIONS(2596),
    [sym_this] = ACTIONS(2596),
    [anon_sym_discard] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
    [anon_sym_cbuffer] = ACTIONS(2596),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_preproc_include_token1] = ACTIONS(2640),
    [aux_sym_preproc_def_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2640),
    [sym_preproc_directive] = ACTIONS(2640),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym___extension__] = ACTIONS(2640),
    [anon_sym_typedef] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_out] = ACTIONS(2640),
    [anon_sym_inout] = ACTIONS(2640),
    [anon_sym_virtual] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym___attribute__] = ACTIONS(2640),
    [anon_sym___attribute] = ACTIONS(2640),
    [anon_sym_using] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2640),
    [anon_sym___based] = ACTIONS(2640),
    [anon_sym___cdecl] = ACTIONS(2640),
    [anon_sym___clrcall] = ACTIONS(2640),
    [anon_sym___stdcall] = ACTIONS(2640),
    [anon_sym___fastcall] = ACTIONS(2640),
    [anon_sym___thiscall] = ACTIONS(2640),
    [anon_sym___vectorcall] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2642),
    [anon_sym_signed] = ACTIONS(2640),
    [anon_sym_unsigned] = ACTIONS(2640),
    [anon_sym_long] = ACTIONS(2640),
    [anon_sym_short] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_register] = ACTIONS(2640),
    [anon_sym_inline] = ACTIONS(2640),
    [anon_sym___inline] = ACTIONS(2640),
    [anon_sym___inline__] = ACTIONS(2640),
    [anon_sym___forceinline] = ACTIONS(2640),
    [anon_sym_thread_local] = ACTIONS(2640),
    [anon_sym___thread] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_constexpr] = ACTIONS(2640),
    [anon_sym_volatile] = ACTIONS(2640),
    [anon_sym_restrict] = ACTIONS(2640),
    [anon_sym___restrict__] = ACTIONS(2640),
    [anon_sym__Atomic] = ACTIONS(2640),
    [anon_sym__Noreturn] = ACTIONS(2640),
    [anon_sym_noreturn] = ACTIONS(2640),
    [anon_sym__Nonnull] = ACTIONS(2640),
    [anon_sym_mutable] = ACTIONS(2640),
    [anon_sym_constinit] = ACTIONS(2640),
    [anon_sym_consteval] = ACTIONS(2640),
    [anon_sym_alignas] = ACTIONS(2640),
    [anon_sym__Alignas] = ACTIONS(2640),
    [sym_primitive_type] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_switch] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_goto] = ACTIONS(2640),
    [anon_sym___try] = ACTIONS(2640),
    [anon_sym___leave] = ACTIONS(2640),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_compl] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2642),
    [anon_sym_sizeof] = ACTIONS(2640),
    [anon_sym___alignof__] = ACTIONS(2640),
    [anon_sym___alignof] = ACTIONS(2640),
    [anon_sym__alignof] = ACTIONS(2640),
    [anon_sym_alignof] = ACTIONS(2640),
    [anon_sym__Alignof] = ACTIONS(2640),
    [anon_sym_offsetof] = ACTIONS(2640),
    [anon_sym__Generic] = ACTIONS(2640),
    [anon_sym_asm] = ACTIONS(2640),
    [anon_sym___asm__] = ACTIONS(2640),
    [anon_sym___asm] = ACTIONS(2640),
    [sym_number_literal] = ACTIONS(2642),
    [anon_sym_L_SQUOTE] = ACTIONS(2642),
    [anon_sym_u_SQUOTE] = ACTIONS(2642),
    [anon_sym_U_SQUOTE] = ACTIONS(2642),
    [anon_sym_u8_SQUOTE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym_L_DQUOTE] = ACTIONS(2642),
    [anon_sym_u_DQUOTE] = ACTIONS(2642),
    [anon_sym_U_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8_DQUOTE] = ACTIONS(2642),
    [anon_sym_DQUOTE] = ACTIONS(2642),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_NULL] = ACTIONS(2640),
    [anon_sym_nullptr] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2640),
    [anon_sym_decltype] = ACTIONS(2640),
    [anon_sym_explicit] = ACTIONS(2640),
    [anon_sym_typename] = ACTIONS(2640),
    [anon_sym_template] = ACTIONS(2640),
    [anon_sym_operator] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [anon_sym_delete] = ACTIONS(2640),
    [anon_sym_throw] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_static_assert] = ACTIONS(2640),
    [anon_sym_concept] = ACTIONS(2640),
    [anon_sym_co_return] = ACTIONS(2640),
    [anon_sym_co_yield] = ACTIONS(2640),
    [anon_sym_R_DQUOTE] = ACTIONS(2642),
    [anon_sym_LR_DQUOTE] = ACTIONS(2642),
    [anon_sym_uR_DQUOTE] = ACTIONS(2642),
    [anon_sym_UR_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2642),
    [anon_sym_co_await] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2640),
    [anon_sym_requires] = ACTIONS(2640),
    [sym_this] = ACTIONS(2640),
    [anon_sym_discard] = ACTIONS(2640),
    [anon_sym_precise] = ACTIONS(2640),
    [anon_sym_shared] = ACTIONS(2640),
    [anon_sym_groupshared] = ACTIONS(2640),
    [anon_sym_uniform] = ACTIONS(2640),
    [anon_sym_row_major] = ACTIONS(2640),
    [anon_sym_column_major] = ACTIONS(2640),
    [anon_sym_globallycoherent] = ACTIONS(2640),
    [anon_sym_centroid] = ACTIONS(2640),
    [anon_sym_noperspective] = ACTIONS(2640),
    [anon_sym_nointerpolation] = ACTIONS(2640),
    [anon_sym_sample] = ACTIONS(2640),
    [anon_sym_linear] = ACTIONS(2640),
    [anon_sym_snorm] = ACTIONS(2640),
    [anon_sym_unorm] = ACTIONS(2640),
    [anon_sym_point] = ACTIONS(2640),
    [anon_sym_line] = ACTIONS(2640),
    [anon_sym_triangleadj] = ACTIONS(2640),
    [anon_sym_lineadj] = ACTIONS(2640),
    [anon_sym_triangle] = ACTIONS(2640),
    [anon_sym_cbuffer] = ACTIONS(2640),
  },
  [712] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_include_token1] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym___cdecl] = ACTIONS(2532),
    [anon_sym___clrcall] = ACTIONS(2532),
    [anon_sym___stdcall] = ACTIONS(2532),
    [anon_sym___fastcall] = ACTIONS(2532),
    [anon_sym___thiscall] = ACTIONS(2532),
    [anon_sym___vectorcall] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_goto] = ACTIONS(2532),
    [anon_sym___try] = ACTIONS(2532),
    [anon_sym___leave] = ACTIONS(2532),
    [anon_sym_not] = ACTIONS(2532),
    [anon_sym_compl] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2532),
    [anon_sym___alignof__] = ACTIONS(2532),
    [anon_sym___alignof] = ACTIONS(2532),
    [anon_sym__alignof] = ACTIONS(2532),
    [anon_sym_alignof] = ACTIONS(2532),
    [anon_sym__Alignof] = ACTIONS(2532),
    [anon_sym_offsetof] = ACTIONS(2532),
    [anon_sym__Generic] = ACTIONS(2532),
    [anon_sym_asm] = ACTIONS(2532),
    [anon_sym___asm__] = ACTIONS(2532),
    [anon_sym___asm] = ACTIONS(2532),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [anon_sym_NULL] = ACTIONS(2532),
    [anon_sym_nullptr] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_concept] = ACTIONS(2532),
    [anon_sym_co_return] = ACTIONS(2532),
    [anon_sym_co_yield] = ACTIONS(2532),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_requires] = ACTIONS(2532),
    [sym_this] = ACTIONS(2532),
    [anon_sym_discard] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
    [anon_sym_cbuffer] = ACTIONS(2532),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_preproc_include_token1] = ACTIONS(2644),
    [aux_sym_preproc_def_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2644),
    [sym_preproc_directive] = ACTIONS(2644),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym___extension__] = ACTIONS(2644),
    [anon_sym_typedef] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_out] = ACTIONS(2644),
    [anon_sym_inout] = ACTIONS(2644),
    [anon_sym_virtual] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym___attribute__] = ACTIONS(2644),
    [anon_sym___attribute] = ACTIONS(2644),
    [anon_sym_using] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2646),
    [anon_sym___declspec] = ACTIONS(2644),
    [anon_sym___based] = ACTIONS(2644),
    [anon_sym___cdecl] = ACTIONS(2644),
    [anon_sym___clrcall] = ACTIONS(2644),
    [anon_sym___stdcall] = ACTIONS(2644),
    [anon_sym___fastcall] = ACTIONS(2644),
    [anon_sym___thiscall] = ACTIONS(2644),
    [anon_sym___vectorcall] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_signed] = ACTIONS(2644),
    [anon_sym_unsigned] = ACTIONS(2644),
    [anon_sym_long] = ACTIONS(2644),
    [anon_sym_short] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_register] = ACTIONS(2644),
    [anon_sym_inline] = ACTIONS(2644),
    [anon_sym___inline] = ACTIONS(2644),
    [anon_sym___inline__] = ACTIONS(2644),
    [anon_sym___forceinline] = ACTIONS(2644),
    [anon_sym_thread_local] = ACTIONS(2644),
    [anon_sym___thread] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_constexpr] = ACTIONS(2644),
    [anon_sym_volatile] = ACTIONS(2644),
    [anon_sym_restrict] = ACTIONS(2644),
    [anon_sym___restrict__] = ACTIONS(2644),
    [anon_sym__Atomic] = ACTIONS(2644),
    [anon_sym__Noreturn] = ACTIONS(2644),
    [anon_sym_noreturn] = ACTIONS(2644),
    [anon_sym__Nonnull] = ACTIONS(2644),
    [anon_sym_mutable] = ACTIONS(2644),
    [anon_sym_constinit] = ACTIONS(2644),
    [anon_sym_consteval] = ACTIONS(2644),
    [anon_sym_alignas] = ACTIONS(2644),
    [anon_sym__Alignas] = ACTIONS(2644),
    [sym_primitive_type] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_switch] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_goto] = ACTIONS(2644),
    [anon_sym___try] = ACTIONS(2644),
    [anon_sym___leave] = ACTIONS(2644),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_compl] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_sizeof] = ACTIONS(2644),
    [anon_sym___alignof__] = ACTIONS(2644),
    [anon_sym___alignof] = ACTIONS(2644),
    [anon_sym__alignof] = ACTIONS(2644),
    [anon_sym_alignof] = ACTIONS(2644),
    [anon_sym__Alignof] = ACTIONS(2644),
    [anon_sym_offsetof] = ACTIONS(2644),
    [anon_sym__Generic] = ACTIONS(2644),
    [anon_sym_asm] = ACTIONS(2644),
    [anon_sym___asm__] = ACTIONS(2644),
    [anon_sym___asm] = ACTIONS(2644),
    [sym_number_literal] = ACTIONS(2646),
    [anon_sym_L_SQUOTE] = ACTIONS(2646),
    [anon_sym_u_SQUOTE] = ACTIONS(2646),
    [anon_sym_U_SQUOTE] = ACTIONS(2646),
    [anon_sym_u8_SQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [anon_sym_L_DQUOTE] = ACTIONS(2646),
    [anon_sym_u_DQUOTE] = ACTIONS(2646),
    [anon_sym_U_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8_DQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [anon_sym_NULL] = ACTIONS(2644),
    [anon_sym_nullptr] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2644),
    [anon_sym_decltype] = ACTIONS(2644),
    [anon_sym_explicit] = ACTIONS(2644),
    [anon_sym_typename] = ACTIONS(2644),
    [anon_sym_template] = ACTIONS(2644),
    [anon_sym_operator] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [anon_sym_delete] = ACTIONS(2644),
    [anon_sym_throw] = ACTIONS(2644),
    [anon_sym_namespace] = ACTIONS(2644),
    [anon_sym_static_assert] = ACTIONS(2644),
    [anon_sym_concept] = ACTIONS(2644),
    [anon_sym_co_return] = ACTIONS(2644),
    [anon_sym_co_yield] = ACTIONS(2644),
    [anon_sym_R_DQUOTE] = ACTIONS(2646),
    [anon_sym_LR_DQUOTE] = ACTIONS(2646),
    [anon_sym_uR_DQUOTE] = ACTIONS(2646),
    [anon_sym_UR_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2646),
    [anon_sym_co_await] = ACTIONS(2644),
    [anon_sym_new] = ACTIONS(2644),
    [anon_sym_requires] = ACTIONS(2644),
    [sym_this] = ACTIONS(2644),
    [anon_sym_discard] = ACTIONS(2644),
    [anon_sym_precise] = ACTIONS(2644),
    [anon_sym_shared] = ACTIONS(2644),
    [anon_sym_groupshared] = ACTIONS(2644),
    [anon_sym_uniform] = ACTIONS(2644),
    [anon_sym_row_major] = ACTIONS(2644),
    [anon_sym_column_major] = ACTIONS(2644),
    [anon_sym_globallycoherent] = ACTIONS(2644),
    [anon_sym_centroid] = ACTIONS(2644),
    [anon_sym_noperspective] = ACTIONS(2644),
    [anon_sym_nointerpolation] = ACTIONS(2644),
    [anon_sym_sample] = ACTIONS(2644),
    [anon_sym_linear] = ACTIONS(2644),
    [anon_sym_snorm] = ACTIONS(2644),
    [anon_sym_unorm] = ACTIONS(2644),
    [anon_sym_point] = ACTIONS(2644),
    [anon_sym_line] = ACTIONS(2644),
    [anon_sym_triangleadj] = ACTIONS(2644),
    [anon_sym_lineadj] = ACTIONS(2644),
    [anon_sym_triangle] = ACTIONS(2644),
    [anon_sym_cbuffer] = ACTIONS(2644),
  },
  [714] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym___try] = ACTIONS(2676),
    [anon_sym___leave] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_discard] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
    [anon_sym_cbuffer] = ACTIONS(2676),
  },
  [716] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym___try] = ACTIONS(2404),
    [anon_sym___leave] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2406),
    [anon_sym_L_SQUOTE] = ACTIONS(2406),
    [anon_sym_u_SQUOTE] = ACTIONS(2406),
    [anon_sym_U_SQUOTE] = ACTIONS(2406),
    [anon_sym_u8_SQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_L_DQUOTE] = ACTIONS(2406),
    [anon_sym_u_DQUOTE] = ACTIONS(2406),
    [anon_sym_U_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8_DQUOTE] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2406),
    [anon_sym_LR_DQUOTE] = ACTIONS(2406),
    [anon_sym_uR_DQUOTE] = ACTIONS(2406),
    [anon_sym_UR_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2406),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_discard] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
    [anon_sym_cbuffer] = ACTIONS(2404),
  },
  [717] = {
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_preproc_include_token1] = ACTIONS(2648),
    [aux_sym_preproc_def_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2648),
    [sym_preproc_directive] = ACTIONS(2648),
    [anon_sym_LPAREN2] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_AMP_AMP] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym___extension__] = ACTIONS(2648),
    [anon_sym_typedef] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_out] = ACTIONS(2648),
    [anon_sym_inout] = ACTIONS(2648),
    [anon_sym_virtual] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym___attribute__] = ACTIONS(2648),
    [anon_sym___attribute] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2650),
    [anon_sym___declspec] = ACTIONS(2648),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym___cdecl] = ACTIONS(2648),
    [anon_sym___clrcall] = ACTIONS(2648),
    [anon_sym___stdcall] = ACTIONS(2648),
    [anon_sym___fastcall] = ACTIONS(2648),
    [anon_sym___thiscall] = ACTIONS(2648),
    [anon_sym___vectorcall] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2650),
    [anon_sym_signed] = ACTIONS(2648),
    [anon_sym_unsigned] = ACTIONS(2648),
    [anon_sym_long] = ACTIONS(2648),
    [anon_sym_short] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_register] = ACTIONS(2648),
    [anon_sym_inline] = ACTIONS(2648),
    [anon_sym___inline] = ACTIONS(2648),
    [anon_sym___inline__] = ACTIONS(2648),
    [anon_sym___forceinline] = ACTIONS(2648),
    [anon_sym_thread_local] = ACTIONS(2648),
    [anon_sym___thread] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_constexpr] = ACTIONS(2648),
    [anon_sym_volatile] = ACTIONS(2648),
    [anon_sym_restrict] = ACTIONS(2648),
    [anon_sym___restrict__] = ACTIONS(2648),
    [anon_sym__Atomic] = ACTIONS(2648),
    [anon_sym__Noreturn] = ACTIONS(2648),
    [anon_sym_noreturn] = ACTIONS(2648),
    [anon_sym__Nonnull] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_constinit] = ACTIONS(2648),
    [anon_sym_consteval] = ACTIONS(2648),
    [anon_sym_alignas] = ACTIONS(2648),
    [anon_sym__Alignas] = ACTIONS(2648),
    [sym_primitive_type] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_class] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_switch] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_goto] = ACTIONS(2648),
    [anon_sym___try] = ACTIONS(2648),
    [anon_sym___leave] = ACTIONS(2648),
    [anon_sym_not] = ACTIONS(2648),
    [anon_sym_compl] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_sizeof] = ACTIONS(2648),
    [anon_sym___alignof__] = ACTIONS(2648),
    [anon_sym___alignof] = ACTIONS(2648),
    [anon_sym__alignof] = ACTIONS(2648),
    [anon_sym_alignof] = ACTIONS(2648),
    [anon_sym__Alignof] = ACTIONS(2648),
    [anon_sym_offsetof] = ACTIONS(2648),
    [anon_sym__Generic] = ACTIONS(2648),
    [anon_sym_asm] = ACTIONS(2648),
    [anon_sym___asm__] = ACTIONS(2648),
    [anon_sym___asm] = ACTIONS(2648),
    [sym_number_literal] = ACTIONS(2650),
    [anon_sym_L_SQUOTE] = ACTIONS(2650),
    [anon_sym_u_SQUOTE] = ACTIONS(2650),
    [anon_sym_U_SQUOTE] = ACTIONS(2650),
    [anon_sym_u8_SQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [anon_sym_L_DQUOTE] = ACTIONS(2650),
    [anon_sym_u_DQUOTE] = ACTIONS(2650),
    [anon_sym_U_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8_DQUOTE] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [anon_sym_NULL] = ACTIONS(2648),
    [anon_sym_nullptr] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2648),
    [anon_sym_decltype] = ACTIONS(2648),
    [anon_sym_explicit] = ACTIONS(2648),
    [anon_sym_typename] = ACTIONS(2648),
    [anon_sym_template] = ACTIONS(2648),
    [anon_sym_operator] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_delete] = ACTIONS(2648),
    [anon_sym_throw] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_static_assert] = ACTIONS(2648),
    [anon_sym_concept] = ACTIONS(2648),
    [anon_sym_co_return] = ACTIONS(2648),
    [anon_sym_co_yield] = ACTIONS(2648),
    [anon_sym_R_DQUOTE] = ACTIONS(2650),
    [anon_sym_LR_DQUOTE] = ACTIONS(2650),
    [anon_sym_uR_DQUOTE] = ACTIONS(2650),
    [anon_sym_UR_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2650),
    [anon_sym_co_await] = ACTIONS(2648),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_requires] = ACTIONS(2648),
    [sym_this] = ACTIONS(2648),
    [anon_sym_discard] = ACTIONS(2648),
    [anon_sym_precise] = ACTIONS(2648),
    [anon_sym_shared] = ACTIONS(2648),
    [anon_sym_groupshared] = ACTIONS(2648),
    [anon_sym_uniform] = ACTIONS(2648),
    [anon_sym_row_major] = ACTIONS(2648),
    [anon_sym_column_major] = ACTIONS(2648),
    [anon_sym_globallycoherent] = ACTIONS(2648),
    [anon_sym_centroid] = ACTIONS(2648),
    [anon_sym_noperspective] = ACTIONS(2648),
    [anon_sym_nointerpolation] = ACTIONS(2648),
    [anon_sym_sample] = ACTIONS(2648),
    [anon_sym_linear] = ACTIONS(2648),
    [anon_sym_snorm] = ACTIONS(2648),
    [anon_sym_unorm] = ACTIONS(2648),
    [anon_sym_point] = ACTIONS(2648),
    [anon_sym_line] = ACTIONS(2648),
    [anon_sym_triangleadj] = ACTIONS(2648),
    [anon_sym_lineadj] = ACTIONS(2648),
    [anon_sym_triangle] = ACTIONS(2648),
    [anon_sym_cbuffer] = ACTIONS(2648),
  },
  [718] = {
    [sym_identifier] = ACTIONS(2680),
    [aux_sym_preproc_include_token1] = ACTIONS(2680),
    [aux_sym_preproc_def_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token2] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2680),
    [sym_preproc_directive] = ACTIONS(2680),
    [anon_sym_LPAREN2] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym___extension__] = ACTIONS(2680),
    [anon_sym_typedef] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2680),
    [anon_sym_out] = ACTIONS(2680),
    [anon_sym_inout] = ACTIONS(2680),
    [anon_sym_virtual] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(2680),
    [anon_sym___attribute__] = ACTIONS(2680),
    [anon_sym___attribute] = ACTIONS(2680),
    [anon_sym_using] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2682),
    [anon_sym___declspec] = ACTIONS(2680),
    [anon_sym___based] = ACTIONS(2680),
    [anon_sym___cdecl] = ACTIONS(2680),
    [anon_sym___clrcall] = ACTIONS(2680),
    [anon_sym___stdcall] = ACTIONS(2680),
    [anon_sym___fastcall] = ACTIONS(2680),
    [anon_sym___thiscall] = ACTIONS(2680),
    [anon_sym___vectorcall] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_signed] = ACTIONS(2680),
    [anon_sym_unsigned] = ACTIONS(2680),
    [anon_sym_long] = ACTIONS(2680),
    [anon_sym_short] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_register] = ACTIONS(2680),
    [anon_sym_inline] = ACTIONS(2680),
    [anon_sym___inline] = ACTIONS(2680),
    [anon_sym___inline__] = ACTIONS(2680),
    [anon_sym___forceinline] = ACTIONS(2680),
    [anon_sym_thread_local] = ACTIONS(2680),
    [anon_sym___thread] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_constexpr] = ACTIONS(2680),
    [anon_sym_volatile] = ACTIONS(2680),
    [anon_sym_restrict] = ACTIONS(2680),
    [anon_sym___restrict__] = ACTIONS(2680),
    [anon_sym__Atomic] = ACTIONS(2680),
    [anon_sym__Noreturn] = ACTIONS(2680),
    [anon_sym_noreturn] = ACTIONS(2680),
    [anon_sym__Nonnull] = ACTIONS(2680),
    [anon_sym_mutable] = ACTIONS(2680),
    [anon_sym_constinit] = ACTIONS(2680),
    [anon_sym_consteval] = ACTIONS(2680),
    [anon_sym_alignas] = ACTIONS(2680),
    [anon_sym__Alignas] = ACTIONS(2680),
    [sym_primitive_type] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [anon_sym_class] = ACTIONS(2680),
    [anon_sym_struct] = ACTIONS(2680),
    [anon_sym_union] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_switch] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_do] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_goto] = ACTIONS(2680),
    [anon_sym___try] = ACTIONS(2680),
    [anon_sym___leave] = ACTIONS(2680),
    [anon_sym_not] = ACTIONS(2680),
    [anon_sym_compl] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_sizeof] = ACTIONS(2680),
    [anon_sym___alignof__] = ACTIONS(2680),
    [anon_sym___alignof] = ACTIONS(2680),
    [anon_sym__alignof] = ACTIONS(2680),
    [anon_sym_alignof] = ACTIONS(2680),
    [anon_sym__Alignof] = ACTIONS(2680),
    [anon_sym_offsetof] = ACTIONS(2680),
    [anon_sym__Generic] = ACTIONS(2680),
    [anon_sym_asm] = ACTIONS(2680),
    [anon_sym___asm__] = ACTIONS(2680),
    [anon_sym___asm] = ACTIONS(2680),
    [sym_number_literal] = ACTIONS(2682),
    [anon_sym_L_SQUOTE] = ACTIONS(2682),
    [anon_sym_u_SQUOTE] = ACTIONS(2682),
    [anon_sym_U_SQUOTE] = ACTIONS(2682),
    [anon_sym_u8_SQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_L_DQUOTE] = ACTIONS(2682),
    [anon_sym_u_DQUOTE] = ACTIONS(2682),
    [anon_sym_U_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8_DQUOTE] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [anon_sym_NULL] = ACTIONS(2680),
    [anon_sym_nullptr] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2680),
    [anon_sym_decltype] = ACTIONS(2680),
    [anon_sym_explicit] = ACTIONS(2680),
    [anon_sym_typename] = ACTIONS(2680),
    [anon_sym_template] = ACTIONS(2680),
    [anon_sym_operator] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [anon_sym_delete] = ACTIONS(2680),
    [anon_sym_throw] = ACTIONS(2680),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_static_assert] = ACTIONS(2680),
    [anon_sym_concept] = ACTIONS(2680),
    [anon_sym_co_return] = ACTIONS(2680),
    [anon_sym_co_yield] = ACTIONS(2680),
    [anon_sym_R_DQUOTE] = ACTIONS(2682),
    [anon_sym_LR_DQUOTE] = ACTIONS(2682),
    [anon_sym_uR_DQUOTE] = ACTIONS(2682),
    [anon_sym_UR_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2682),
    [anon_sym_co_await] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2680),
    [anon_sym_requires] = ACTIONS(2680),
    [sym_this] = ACTIONS(2680),
    [anon_sym_discard] = ACTIONS(2680),
    [anon_sym_precise] = ACTIONS(2680),
    [anon_sym_shared] = ACTIONS(2680),
    [anon_sym_groupshared] = ACTIONS(2680),
    [anon_sym_uniform] = ACTIONS(2680),
    [anon_sym_row_major] = ACTIONS(2680),
    [anon_sym_column_major] = ACTIONS(2680),
    [anon_sym_globallycoherent] = ACTIONS(2680),
    [anon_sym_centroid] = ACTIONS(2680),
    [anon_sym_noperspective] = ACTIONS(2680),
    [anon_sym_nointerpolation] = ACTIONS(2680),
    [anon_sym_sample] = ACTIONS(2680),
    [anon_sym_linear] = ACTIONS(2680),
    [anon_sym_snorm] = ACTIONS(2680),
    [anon_sym_unorm] = ACTIONS(2680),
    [anon_sym_point] = ACTIONS(2680),
    [anon_sym_line] = ACTIONS(2680),
    [anon_sym_triangleadj] = ACTIONS(2680),
    [anon_sym_lineadj] = ACTIONS(2680),
    [anon_sym_triangle] = ACTIONS(2680),
    [anon_sym_cbuffer] = ACTIONS(2680),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2538),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym___try] = ACTIONS(2536),
    [anon_sym___leave] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2538),
    [anon_sym_L_SQUOTE] = ACTIONS(2538),
    [anon_sym_u_SQUOTE] = ACTIONS(2538),
    [anon_sym_U_SQUOTE] = ACTIONS(2538),
    [anon_sym_u8_SQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_L_DQUOTE] = ACTIONS(2538),
    [anon_sym_u_DQUOTE] = ACTIONS(2538),
    [anon_sym_U_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8_DQUOTE] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2538),
    [anon_sym_LR_DQUOTE] = ACTIONS(2538),
    [anon_sym_uR_DQUOTE] = ACTIONS(2538),
    [anon_sym_UR_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2538),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_discard] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
    [anon_sym_cbuffer] = ACTIONS(2536),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2688),
    [aux_sym_preproc_include_token1] = ACTIONS(2688),
    [aux_sym_preproc_def_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token2] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2688),
    [sym_preproc_directive] = ACTIONS(2688),
    [anon_sym_LPAREN2] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym___extension__] = ACTIONS(2688),
    [anon_sym_typedef] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2688),
    [anon_sym_out] = ACTIONS(2688),
    [anon_sym_inout] = ACTIONS(2688),
    [anon_sym_virtual] = ACTIONS(2688),
    [anon_sym_extern] = ACTIONS(2688),
    [anon_sym___attribute__] = ACTIONS(2688),
    [anon_sym___attribute] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2690),
    [anon_sym___declspec] = ACTIONS(2688),
    [anon_sym___based] = ACTIONS(2688),
    [anon_sym___cdecl] = ACTIONS(2688),
    [anon_sym___clrcall] = ACTIONS(2688),
    [anon_sym___stdcall] = ACTIONS(2688),
    [anon_sym___fastcall] = ACTIONS(2688),
    [anon_sym___thiscall] = ACTIONS(2688),
    [anon_sym___vectorcall] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_signed] = ACTIONS(2688),
    [anon_sym_unsigned] = ACTIONS(2688),
    [anon_sym_long] = ACTIONS(2688),
    [anon_sym_short] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_register] = ACTIONS(2688),
    [anon_sym_inline] = ACTIONS(2688),
    [anon_sym___inline] = ACTIONS(2688),
    [anon_sym___inline__] = ACTIONS(2688),
    [anon_sym___forceinline] = ACTIONS(2688),
    [anon_sym_thread_local] = ACTIONS(2688),
    [anon_sym___thread] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_constexpr] = ACTIONS(2688),
    [anon_sym_volatile] = ACTIONS(2688),
    [anon_sym_restrict] = ACTIONS(2688),
    [anon_sym___restrict__] = ACTIONS(2688),
    [anon_sym__Atomic] = ACTIONS(2688),
    [anon_sym__Noreturn] = ACTIONS(2688),
    [anon_sym_noreturn] = ACTIONS(2688),
    [anon_sym__Nonnull] = ACTIONS(2688),
    [anon_sym_mutable] = ACTIONS(2688),
    [anon_sym_constinit] = ACTIONS(2688),
    [anon_sym_consteval] = ACTIONS(2688),
    [anon_sym_alignas] = ACTIONS(2688),
    [anon_sym__Alignas] = ACTIONS(2688),
    [sym_primitive_type] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_struct] = ACTIONS(2688),
    [anon_sym_union] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_goto] = ACTIONS(2688),
    [anon_sym___try] = ACTIONS(2688),
    [anon_sym___leave] = ACTIONS(2688),
    [anon_sym_not] = ACTIONS(2688),
    [anon_sym_compl] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_sizeof] = ACTIONS(2688),
    [anon_sym___alignof__] = ACTIONS(2688),
    [anon_sym___alignof] = ACTIONS(2688),
    [anon_sym__alignof] = ACTIONS(2688),
    [anon_sym_alignof] = ACTIONS(2688),
    [anon_sym__Alignof] = ACTIONS(2688),
    [anon_sym_offsetof] = ACTIONS(2688),
    [anon_sym__Generic] = ACTIONS(2688),
    [anon_sym_asm] = ACTIONS(2688),
    [anon_sym___asm__] = ACTIONS(2688),
    [anon_sym___asm] = ACTIONS(2688),
    [sym_number_literal] = ACTIONS(2690),
    [anon_sym_L_SQUOTE] = ACTIONS(2690),
    [anon_sym_u_SQUOTE] = ACTIONS(2690),
    [anon_sym_U_SQUOTE] = ACTIONS(2690),
    [anon_sym_u8_SQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_L_DQUOTE] = ACTIONS(2690),
    [anon_sym_u_DQUOTE] = ACTIONS(2690),
    [anon_sym_U_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [anon_sym_NULL] = ACTIONS(2688),
    [anon_sym_nullptr] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2688),
    [anon_sym_decltype] = ACTIONS(2688),
    [anon_sym_explicit] = ACTIONS(2688),
    [anon_sym_typename] = ACTIONS(2688),
    [anon_sym_template] = ACTIONS(2688),
    [anon_sym_operator] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_static_assert] = ACTIONS(2688),
    [anon_sym_concept] = ACTIONS(2688),
    [anon_sym_co_return] = ACTIONS(2688),
    [anon_sym_co_yield] = ACTIONS(2688),
    [anon_sym_R_DQUOTE] = ACTIONS(2690),
    [anon_sym_LR_DQUOTE] = ACTIONS(2690),
    [anon_sym_uR_DQUOTE] = ACTIONS(2690),
    [anon_sym_UR_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2690),
    [anon_sym_co_await] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_requires] = ACTIONS(2688),
    [sym_this] = ACTIONS(2688),
    [anon_sym_discard] = ACTIONS(2688),
    [anon_sym_precise] = ACTIONS(2688),
    [anon_sym_shared] = ACTIONS(2688),
    [anon_sym_groupshared] = ACTIONS(2688),
    [anon_sym_uniform] = ACTIONS(2688),
    [anon_sym_row_major] = ACTIONS(2688),
    [anon_sym_column_major] = ACTIONS(2688),
    [anon_sym_globallycoherent] = ACTIONS(2688),
    [anon_sym_centroid] = ACTIONS(2688),
    [anon_sym_noperspective] = ACTIONS(2688),
    [anon_sym_nointerpolation] = ACTIONS(2688),
    [anon_sym_sample] = ACTIONS(2688),
    [anon_sym_linear] = ACTIONS(2688),
    [anon_sym_snorm] = ACTIONS(2688),
    [anon_sym_unorm] = ACTIONS(2688),
    [anon_sym_point] = ACTIONS(2688),
    [anon_sym_line] = ACTIONS(2688),
    [anon_sym_triangleadj] = ACTIONS(2688),
    [anon_sym_lineadj] = ACTIONS(2688),
    [anon_sym_triangle] = ACTIONS(2688),
    [anon_sym_cbuffer] = ACTIONS(2688),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [722] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym___try] = ACTIONS(2462),
    [anon_sym___leave] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_discard] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
    [anon_sym_cbuffer] = ACTIONS(2462),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [724] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym___try] = ACTIONS(2414),
    [anon_sym___leave] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_discard] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
    [anon_sym_cbuffer] = ACTIONS(2414),
  },
  [725] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym___try] = ACTIONS(2418),
    [anon_sym___leave] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_discard] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
    [anon_sym_cbuffer] = ACTIONS(2418),
  },
  [726] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [728] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [729] = {
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_include_token1] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token2] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2592),
    [sym_preproc_directive] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym___extension__] = ACTIONS(2592),
    [anon_sym_typedef] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_out] = ACTIONS(2592),
    [anon_sym_inout] = ACTIONS(2592),
    [anon_sym_virtual] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym___attribute__] = ACTIONS(2592),
    [anon_sym___attribute] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2594),
    [anon_sym___declspec] = ACTIONS(2592),
    [anon_sym___based] = ACTIONS(2592),
    [anon_sym___cdecl] = ACTIONS(2592),
    [anon_sym___clrcall] = ACTIONS(2592),
    [anon_sym___stdcall] = ACTIONS(2592),
    [anon_sym___fastcall] = ACTIONS(2592),
    [anon_sym___thiscall] = ACTIONS(2592),
    [anon_sym___vectorcall] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_signed] = ACTIONS(2592),
    [anon_sym_unsigned] = ACTIONS(2592),
    [anon_sym_long] = ACTIONS(2592),
    [anon_sym_short] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_register] = ACTIONS(2592),
    [anon_sym_inline] = ACTIONS(2592),
    [anon_sym___inline] = ACTIONS(2592),
    [anon_sym___inline__] = ACTIONS(2592),
    [anon_sym___forceinline] = ACTIONS(2592),
    [anon_sym_thread_local] = ACTIONS(2592),
    [anon_sym___thread] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_constexpr] = ACTIONS(2592),
    [anon_sym_volatile] = ACTIONS(2592),
    [anon_sym_restrict] = ACTIONS(2592),
    [anon_sym___restrict__] = ACTIONS(2592),
    [anon_sym__Atomic] = ACTIONS(2592),
    [anon_sym__Noreturn] = ACTIONS(2592),
    [anon_sym_noreturn] = ACTIONS(2592),
    [anon_sym__Nonnull] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_constinit] = ACTIONS(2592),
    [anon_sym_consteval] = ACTIONS(2592),
    [anon_sym_alignas] = ACTIONS(2592),
    [anon_sym__Alignas] = ACTIONS(2592),
    [sym_primitive_type] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_goto] = ACTIONS(2592),
    [anon_sym___try] = ACTIONS(2592),
    [anon_sym___leave] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2592),
    [anon_sym_compl] = ACTIONS(2592),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_sizeof] = ACTIONS(2592),
    [anon_sym___alignof__] = ACTIONS(2592),
    [anon_sym___alignof] = ACTIONS(2592),
    [anon_sym__alignof] = ACTIONS(2592),
    [anon_sym_alignof] = ACTIONS(2592),
    [anon_sym__Alignof] = ACTIONS(2592),
    [anon_sym_offsetof] = ACTIONS(2592),
    [anon_sym__Generic] = ACTIONS(2592),
    [anon_sym_asm] = ACTIONS(2592),
    [anon_sym___asm__] = ACTIONS(2592),
    [anon_sym___asm] = ACTIONS(2592),
    [sym_number_literal] = ACTIONS(2594),
    [anon_sym_L_SQUOTE] = ACTIONS(2594),
    [anon_sym_u_SQUOTE] = ACTIONS(2594),
    [anon_sym_U_SQUOTE] = ACTIONS(2594),
    [anon_sym_u8_SQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_L_DQUOTE] = ACTIONS(2594),
    [anon_sym_u_DQUOTE] = ACTIONS(2594),
    [anon_sym_U_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8_DQUOTE] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [anon_sym_NULL] = ACTIONS(2592),
    [anon_sym_nullptr] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2592),
    [anon_sym_decltype] = ACTIONS(2592),
    [anon_sym_explicit] = ACTIONS(2592),
    [anon_sym_typename] = ACTIONS(2592),
    [anon_sym_template] = ACTIONS(2592),
    [anon_sym_operator] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_static_assert] = ACTIONS(2592),
    [anon_sym_concept] = ACTIONS(2592),
    [anon_sym_co_return] = ACTIONS(2592),
    [anon_sym_co_yield] = ACTIONS(2592),
    [anon_sym_R_DQUOTE] = ACTIONS(2594),
    [anon_sym_LR_DQUOTE] = ACTIONS(2594),
    [anon_sym_uR_DQUOTE] = ACTIONS(2594),
    [anon_sym_UR_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2594),
    [anon_sym_co_await] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_requires] = ACTIONS(2592),
    [sym_this] = ACTIONS(2592),
    [anon_sym_discard] = ACTIONS(2592),
    [anon_sym_precise] = ACTIONS(2592),
    [anon_sym_shared] = ACTIONS(2592),
    [anon_sym_groupshared] = ACTIONS(2592),
    [anon_sym_uniform] = ACTIONS(2592),
    [anon_sym_row_major] = ACTIONS(2592),
    [anon_sym_column_major] = ACTIONS(2592),
    [anon_sym_globallycoherent] = ACTIONS(2592),
    [anon_sym_centroid] = ACTIONS(2592),
    [anon_sym_noperspective] = ACTIONS(2592),
    [anon_sym_nointerpolation] = ACTIONS(2592),
    [anon_sym_sample] = ACTIONS(2592),
    [anon_sym_linear] = ACTIONS(2592),
    [anon_sym_snorm] = ACTIONS(2592),
    [anon_sym_unorm] = ACTIONS(2592),
    [anon_sym_point] = ACTIONS(2592),
    [anon_sym_line] = ACTIONS(2592),
    [anon_sym_triangleadj] = ACTIONS(2592),
    [anon_sym_lineadj] = ACTIONS(2592),
    [anon_sym_triangle] = ACTIONS(2592),
    [anon_sym_cbuffer] = ACTIONS(2592),
  },
  [730] = {
    [sym_identifier] = ACTIONS(2600),
    [aux_sym_preproc_include_token1] = ACTIONS(2600),
    [aux_sym_preproc_def_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token2] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2600),
    [sym_preproc_directive] = ACTIONS(2600),
    [anon_sym_LPAREN2] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym___extension__] = ACTIONS(2600),
    [anon_sym_typedef] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_out] = ACTIONS(2600),
    [anon_sym_inout] = ACTIONS(2600),
    [anon_sym_virtual] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym___attribute__] = ACTIONS(2600),
    [anon_sym___attribute] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2602),
    [anon_sym___declspec] = ACTIONS(2600),
    [anon_sym___based] = ACTIONS(2600),
    [anon_sym___cdecl] = ACTIONS(2600),
    [anon_sym___clrcall] = ACTIONS(2600),
    [anon_sym___stdcall] = ACTIONS(2600),
    [anon_sym___fastcall] = ACTIONS(2600),
    [anon_sym___thiscall] = ACTIONS(2600),
    [anon_sym___vectorcall] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_signed] = ACTIONS(2600),
    [anon_sym_unsigned] = ACTIONS(2600),
    [anon_sym_long] = ACTIONS(2600),
    [anon_sym_short] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_register] = ACTIONS(2600),
    [anon_sym_inline] = ACTIONS(2600),
    [anon_sym___inline] = ACTIONS(2600),
    [anon_sym___inline__] = ACTIONS(2600),
    [anon_sym___forceinline] = ACTIONS(2600),
    [anon_sym_thread_local] = ACTIONS(2600),
    [anon_sym___thread] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_constexpr] = ACTIONS(2600),
    [anon_sym_volatile] = ACTIONS(2600),
    [anon_sym_restrict] = ACTIONS(2600),
    [anon_sym___restrict__] = ACTIONS(2600),
    [anon_sym__Atomic] = ACTIONS(2600),
    [anon_sym__Noreturn] = ACTIONS(2600),
    [anon_sym_noreturn] = ACTIONS(2600),
    [anon_sym__Nonnull] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_constinit] = ACTIONS(2600),
    [anon_sym_consteval] = ACTIONS(2600),
    [anon_sym_alignas] = ACTIONS(2600),
    [anon_sym__Alignas] = ACTIONS(2600),
    [sym_primitive_type] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_goto] = ACTIONS(2600),
    [anon_sym___try] = ACTIONS(2600),
    [anon_sym___leave] = ACTIONS(2600),
    [anon_sym_not] = ACTIONS(2600),
    [anon_sym_compl] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_sizeof] = ACTIONS(2600),
    [anon_sym___alignof__] = ACTIONS(2600),
    [anon_sym___alignof] = ACTIONS(2600),
    [anon_sym__alignof] = ACTIONS(2600),
    [anon_sym_alignof] = ACTIONS(2600),
    [anon_sym__Alignof] = ACTIONS(2600),
    [anon_sym_offsetof] = ACTIONS(2600),
    [anon_sym__Generic] = ACTIONS(2600),
    [anon_sym_asm] = ACTIONS(2600),
    [anon_sym___asm__] = ACTIONS(2600),
    [anon_sym___asm] = ACTIONS(2600),
    [sym_number_literal] = ACTIONS(2602),
    [anon_sym_L_SQUOTE] = ACTIONS(2602),
    [anon_sym_u_SQUOTE] = ACTIONS(2602),
    [anon_sym_U_SQUOTE] = ACTIONS(2602),
    [anon_sym_u8_SQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_L_DQUOTE] = ACTIONS(2602),
    [anon_sym_u_DQUOTE] = ACTIONS(2602),
    [anon_sym_U_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8_DQUOTE] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [anon_sym_NULL] = ACTIONS(2600),
    [anon_sym_nullptr] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2600),
    [anon_sym_decltype] = ACTIONS(2600),
    [anon_sym_explicit] = ACTIONS(2600),
    [anon_sym_typename] = ACTIONS(2600),
    [anon_sym_template] = ACTIONS(2600),
    [anon_sym_operator] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_static_assert] = ACTIONS(2600),
    [anon_sym_concept] = ACTIONS(2600),
    [anon_sym_co_return] = ACTIONS(2600),
    [anon_sym_co_yield] = ACTIONS(2600),
    [anon_sym_R_DQUOTE] = ACTIONS(2602),
    [anon_sym_LR_DQUOTE] = ACTIONS(2602),
    [anon_sym_uR_DQUOTE] = ACTIONS(2602),
    [anon_sym_UR_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2602),
    [anon_sym_co_await] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_requires] = ACTIONS(2600),
    [sym_this] = ACTIONS(2600),
    [anon_sym_discard] = ACTIONS(2600),
    [anon_sym_precise] = ACTIONS(2600),
    [anon_sym_shared] = ACTIONS(2600),
    [anon_sym_groupshared] = ACTIONS(2600),
    [anon_sym_uniform] = ACTIONS(2600),
    [anon_sym_row_major] = ACTIONS(2600),
    [anon_sym_column_major] = ACTIONS(2600),
    [anon_sym_globallycoherent] = ACTIONS(2600),
    [anon_sym_centroid] = ACTIONS(2600),
    [anon_sym_noperspective] = ACTIONS(2600),
    [anon_sym_nointerpolation] = ACTIONS(2600),
    [anon_sym_sample] = ACTIONS(2600),
    [anon_sym_linear] = ACTIONS(2600),
    [anon_sym_snorm] = ACTIONS(2600),
    [anon_sym_unorm] = ACTIONS(2600),
    [anon_sym_point] = ACTIONS(2600),
    [anon_sym_line] = ACTIONS(2600),
    [anon_sym_triangleadj] = ACTIONS(2600),
    [anon_sym_lineadj] = ACTIONS(2600),
    [anon_sym_triangle] = ACTIONS(2600),
    [anon_sym_cbuffer] = ACTIONS(2600),
  },
  [731] = {
    [sym_identifier] = ACTIONS(2608),
    [aux_sym_preproc_include_token1] = ACTIONS(2608),
    [aux_sym_preproc_def_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token2] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2608),
    [sym_preproc_directive] = ACTIONS(2608),
    [anon_sym_LPAREN2] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym___extension__] = ACTIONS(2608),
    [anon_sym_typedef] = ACTIONS(2608),
    [anon_sym_in] = ACTIONS(2608),
    [anon_sym_out] = ACTIONS(2608),
    [anon_sym_inout] = ACTIONS(2608),
    [anon_sym_virtual] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym___attribute__] = ACTIONS(2608),
    [anon_sym___attribute] = ACTIONS(2608),
    [anon_sym_using] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2610),
    [anon_sym___declspec] = ACTIONS(2608),
    [anon_sym___based] = ACTIONS(2608),
    [anon_sym___cdecl] = ACTIONS(2608),
    [anon_sym___clrcall] = ACTIONS(2608),
    [anon_sym___stdcall] = ACTIONS(2608),
    [anon_sym___fastcall] = ACTIONS(2608),
    [anon_sym___thiscall] = ACTIONS(2608),
    [anon_sym___vectorcall] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_signed] = ACTIONS(2608),
    [anon_sym_unsigned] = ACTIONS(2608),
    [anon_sym_long] = ACTIONS(2608),
    [anon_sym_short] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_register] = ACTIONS(2608),
    [anon_sym_inline] = ACTIONS(2608),
    [anon_sym___inline] = ACTIONS(2608),
    [anon_sym___inline__] = ACTIONS(2608),
    [anon_sym___forceinline] = ACTIONS(2608),
    [anon_sym_thread_local] = ACTIONS(2608),
    [anon_sym___thread] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_constexpr] = ACTIONS(2608),
    [anon_sym_volatile] = ACTIONS(2608),
    [anon_sym_restrict] = ACTIONS(2608),
    [anon_sym___restrict__] = ACTIONS(2608),
    [anon_sym__Atomic] = ACTIONS(2608),
    [anon_sym__Noreturn] = ACTIONS(2608),
    [anon_sym_noreturn] = ACTIONS(2608),
    [anon_sym__Nonnull] = ACTIONS(2608),
    [anon_sym_mutable] = ACTIONS(2608),
    [anon_sym_constinit] = ACTIONS(2608),
    [anon_sym_consteval] = ACTIONS(2608),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_goto] = ACTIONS(2608),
    [anon_sym___try] = ACTIONS(2608),
    [anon_sym___leave] = ACTIONS(2608),
    [anon_sym_not] = ACTIONS(2608),
    [anon_sym_compl] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_sizeof] = ACTIONS(2608),
    [anon_sym___alignof__] = ACTIONS(2608),
    [anon_sym___alignof] = ACTIONS(2608),
    [anon_sym__alignof] = ACTIONS(2608),
    [anon_sym_alignof] = ACTIONS(2608),
    [anon_sym__Alignof] = ACTIONS(2608),
    [anon_sym_offsetof] = ACTIONS(2608),
    [anon_sym__Generic] = ACTIONS(2608),
    [anon_sym_asm] = ACTIONS(2608),
    [anon_sym___asm__] = ACTIONS(2608),
    [anon_sym___asm] = ACTIONS(2608),
    [sym_number_literal] = ACTIONS(2610),
    [anon_sym_L_SQUOTE] = ACTIONS(2610),
    [anon_sym_u_SQUOTE] = ACTIONS(2610),
    [anon_sym_U_SQUOTE] = ACTIONS(2610),
    [anon_sym_u8_SQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [anon_sym_L_DQUOTE] = ACTIONS(2610),
    [anon_sym_u_DQUOTE] = ACTIONS(2610),
    [anon_sym_U_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8_DQUOTE] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [anon_sym_NULL] = ACTIONS(2608),
    [anon_sym_nullptr] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(2608),
    [anon_sym_explicit] = ACTIONS(2608),
    [anon_sym_typename] = ACTIONS(2608),
    [anon_sym_template] = ACTIONS(2608),
    [anon_sym_operator] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_static_assert] = ACTIONS(2608),
    [anon_sym_concept] = ACTIONS(2608),
    [anon_sym_co_return] = ACTIONS(2608),
    [anon_sym_co_yield] = ACTIONS(2608),
    [anon_sym_R_DQUOTE] = ACTIONS(2610),
    [anon_sym_LR_DQUOTE] = ACTIONS(2610),
    [anon_sym_uR_DQUOTE] = ACTIONS(2610),
    [anon_sym_UR_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2610),
    [anon_sym_co_await] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_requires] = ACTIONS(2608),
    [sym_this] = ACTIONS(2608),
    [anon_sym_discard] = ACTIONS(2608),
    [anon_sym_precise] = ACTIONS(2608),
    [anon_sym_shared] = ACTIONS(2608),
    [anon_sym_groupshared] = ACTIONS(2608),
    [anon_sym_uniform] = ACTIONS(2608),
    [anon_sym_row_major] = ACTIONS(2608),
    [anon_sym_column_major] = ACTIONS(2608),
    [anon_sym_globallycoherent] = ACTIONS(2608),
    [anon_sym_centroid] = ACTIONS(2608),
    [anon_sym_noperspective] = ACTIONS(2608),
    [anon_sym_nointerpolation] = ACTIONS(2608),
    [anon_sym_sample] = ACTIONS(2608),
    [anon_sym_linear] = ACTIONS(2608),
    [anon_sym_snorm] = ACTIONS(2608),
    [anon_sym_unorm] = ACTIONS(2608),
    [anon_sym_point] = ACTIONS(2608),
    [anon_sym_line] = ACTIONS(2608),
    [anon_sym_triangleadj] = ACTIONS(2608),
    [anon_sym_lineadj] = ACTIONS(2608),
    [anon_sym_triangle] = ACTIONS(2608),
    [anon_sym_cbuffer] = ACTIONS(2608),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_include_token1] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym___cdecl] = ACTIONS(2540),
    [anon_sym___clrcall] = ACTIONS(2540),
    [anon_sym___stdcall] = ACTIONS(2540),
    [anon_sym___fastcall] = ACTIONS(2540),
    [anon_sym___thiscall] = ACTIONS(2540),
    [anon_sym___vectorcall] = ACTIONS(2540),
    [anon_sym_LBRACE] = ACTIONS(2542),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2540),
    [anon_sym_switch] = ACTIONS(2540),
    [anon_sym_case] = ACTIONS(2540),
    [anon_sym_default] = ACTIONS(2540),
    [anon_sym_while] = ACTIONS(2540),
    [anon_sym_do] = ACTIONS(2540),
    [anon_sym_for] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2540),
    [anon_sym_break] = ACTIONS(2540),
    [anon_sym_continue] = ACTIONS(2540),
    [anon_sym_goto] = ACTIONS(2540),
    [anon_sym___try] = ACTIONS(2540),
    [anon_sym___leave] = ACTIONS(2540),
    [anon_sym_not] = ACTIONS(2540),
    [anon_sym_compl] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2540),
    [anon_sym___alignof__] = ACTIONS(2540),
    [anon_sym___alignof] = ACTIONS(2540),
    [anon_sym__alignof] = ACTIONS(2540),
    [anon_sym_alignof] = ACTIONS(2540),
    [anon_sym__Alignof] = ACTIONS(2540),
    [anon_sym_offsetof] = ACTIONS(2540),
    [anon_sym__Generic] = ACTIONS(2540),
    [anon_sym_asm] = ACTIONS(2540),
    [anon_sym___asm__] = ACTIONS(2540),
    [anon_sym___asm] = ACTIONS(2540),
    [sym_number_literal] = ACTIONS(2542),
    [anon_sym_L_SQUOTE] = ACTIONS(2542),
    [anon_sym_u_SQUOTE] = ACTIONS(2542),
    [anon_sym_U_SQUOTE] = ACTIONS(2542),
    [anon_sym_u8_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_L_DQUOTE] = ACTIONS(2542),
    [anon_sym_u_DQUOTE] = ACTIONS(2542),
    [anon_sym_U_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8_DQUOTE] = ACTIONS(2542),
    [anon_sym_DQUOTE] = ACTIONS(2542),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [anon_sym_NULL] = ACTIONS(2540),
    [anon_sym_nullptr] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_try] = ACTIONS(2540),
    [anon_sym_delete] = ACTIONS(2540),
    [anon_sym_throw] = ACTIONS(2540),
    [anon_sym_namespace] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_concept] = ACTIONS(2540),
    [anon_sym_co_return] = ACTIONS(2540),
    [anon_sym_co_yield] = ACTIONS(2540),
    [anon_sym_R_DQUOTE] = ACTIONS(2542),
    [anon_sym_LR_DQUOTE] = ACTIONS(2542),
    [anon_sym_uR_DQUOTE] = ACTIONS(2542),
    [anon_sym_UR_DQUOTE] = ACTIONS(2542),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2542),
    [anon_sym_co_await] = ACTIONS(2540),
    [anon_sym_new] = ACTIONS(2540),
    [anon_sym_requires] = ACTIONS(2540),
    [sym_this] = ACTIONS(2540),
    [anon_sym_discard] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
    [anon_sym_cbuffer] = ACTIONS(2540),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2544),
    [aux_sym_preproc_include_token1] = ACTIONS(2544),
    [aux_sym_preproc_def_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2544),
    [sym_preproc_directive] = ACTIONS(2544),
    [anon_sym_LPAREN2] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym___extension__] = ACTIONS(2544),
    [anon_sym_typedef] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2544),
    [anon_sym_out] = ACTIONS(2544),
    [anon_sym_inout] = ACTIONS(2544),
    [anon_sym_virtual] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym___attribute__] = ACTIONS(2544),
    [anon_sym___attribute] = ACTIONS(2544),
    [anon_sym_using] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2546),
    [anon_sym___declspec] = ACTIONS(2544),
    [anon_sym___based] = ACTIONS(2544),
    [anon_sym___cdecl] = ACTIONS(2544),
    [anon_sym___clrcall] = ACTIONS(2544),
    [anon_sym___stdcall] = ACTIONS(2544),
    [anon_sym___fastcall] = ACTIONS(2544),
    [anon_sym___thiscall] = ACTIONS(2544),
    [anon_sym___vectorcall] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_RBRACE] = ACTIONS(2546),
    [anon_sym_signed] = ACTIONS(2544),
    [anon_sym_unsigned] = ACTIONS(2544),
    [anon_sym_long] = ACTIONS(2544),
    [anon_sym_short] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_register] = ACTIONS(2544),
    [anon_sym_inline] = ACTIONS(2544),
    [anon_sym___inline] = ACTIONS(2544),
    [anon_sym___inline__] = ACTIONS(2544),
    [anon_sym___forceinline] = ACTIONS(2544),
    [anon_sym_thread_local] = ACTIONS(2544),
    [anon_sym___thread] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_constexpr] = ACTIONS(2544),
    [anon_sym_volatile] = ACTIONS(2544),
    [anon_sym_restrict] = ACTIONS(2544),
    [anon_sym___restrict__] = ACTIONS(2544),
    [anon_sym__Atomic] = ACTIONS(2544),
    [anon_sym__Noreturn] = ACTIONS(2544),
    [anon_sym_noreturn] = ACTIONS(2544),
    [anon_sym__Nonnull] = ACTIONS(2544),
    [anon_sym_mutable] = ACTIONS(2544),
    [anon_sym_constinit] = ACTIONS(2544),
    [anon_sym_consteval] = ACTIONS(2544),
    [anon_sym_alignas] = ACTIONS(2544),
    [anon_sym__Alignas] = ACTIONS(2544),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_goto] = ACTIONS(2544),
    [anon_sym___try] = ACTIONS(2544),
    [anon_sym___leave] = ACTIONS(2544),
    [anon_sym_not] = ACTIONS(2544),
    [anon_sym_compl] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_sizeof] = ACTIONS(2544),
    [anon_sym___alignof__] = ACTIONS(2544),
    [anon_sym___alignof] = ACTIONS(2544),
    [anon_sym__alignof] = ACTIONS(2544),
    [anon_sym_alignof] = ACTIONS(2544),
    [anon_sym__Alignof] = ACTIONS(2544),
    [anon_sym_offsetof] = ACTIONS(2544),
    [anon_sym__Generic] = ACTIONS(2544),
    [anon_sym_asm] = ACTIONS(2544),
    [anon_sym___asm__] = ACTIONS(2544),
    [anon_sym___asm] = ACTIONS(2544),
    [sym_number_literal] = ACTIONS(2546),
    [anon_sym_L_SQUOTE] = ACTIONS(2546),
    [anon_sym_u_SQUOTE] = ACTIONS(2546),
    [anon_sym_U_SQUOTE] = ACTIONS(2546),
    [anon_sym_u8_SQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_L_DQUOTE] = ACTIONS(2546),
    [anon_sym_u_DQUOTE] = ACTIONS(2546),
    [anon_sym_U_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8_DQUOTE] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [anon_sym_NULL] = ACTIONS(2544),
    [anon_sym_nullptr] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2544),
    [anon_sym_decltype] = ACTIONS(2544),
    [anon_sym_explicit] = ACTIONS(2544),
    [anon_sym_typename] = ACTIONS(2544),
    [anon_sym_template] = ACTIONS(2544),
    [anon_sym_operator] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_static_assert] = ACTIONS(2544),
    [anon_sym_concept] = ACTIONS(2544),
    [anon_sym_co_return] = ACTIONS(2544),
    [anon_sym_co_yield] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_requires] = ACTIONS(2544),
    [sym_this] = ACTIONS(2544),
    [anon_sym_discard] = ACTIONS(2544),
    [anon_sym_precise] = ACTIONS(2544),
    [anon_sym_shared] = ACTIONS(2544),
    [anon_sym_groupshared] = ACTIONS(2544),
    [anon_sym_uniform] = ACTIONS(2544),
    [anon_sym_row_major] = ACTIONS(2544),
    [anon_sym_column_major] = ACTIONS(2544),
    [anon_sym_globallycoherent] = ACTIONS(2544),
    [anon_sym_centroid] = ACTIONS(2544),
    [anon_sym_noperspective] = ACTIONS(2544),
    [anon_sym_nointerpolation] = ACTIONS(2544),
    [anon_sym_sample] = ACTIONS(2544),
    [anon_sym_linear] = ACTIONS(2544),
    [anon_sym_snorm] = ACTIONS(2544),
    [anon_sym_unorm] = ACTIONS(2544),
    [anon_sym_point] = ACTIONS(2544),
    [anon_sym_line] = ACTIONS(2544),
    [anon_sym_triangleadj] = ACTIONS(2544),
    [anon_sym_lineadj] = ACTIONS(2544),
    [anon_sym_triangle] = ACTIONS(2544),
    [anon_sym_cbuffer] = ACTIONS(2544),
  },
  [734] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_include_token1] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym___cdecl] = ACTIONS(2548),
    [anon_sym___clrcall] = ACTIONS(2548),
    [anon_sym___stdcall] = ACTIONS(2548),
    [anon_sym___fastcall] = ACTIONS(2548),
    [anon_sym___thiscall] = ACTIONS(2548),
    [anon_sym___vectorcall] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_switch] = ACTIONS(2548),
    [anon_sym_case] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_do] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_goto] = ACTIONS(2548),
    [anon_sym___try] = ACTIONS(2548),
    [anon_sym___leave] = ACTIONS(2548),
    [anon_sym_not] = ACTIONS(2548),
    [anon_sym_compl] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2548),
    [anon_sym___alignof__] = ACTIONS(2548),
    [anon_sym___alignof] = ACTIONS(2548),
    [anon_sym__alignof] = ACTIONS(2548),
    [anon_sym_alignof] = ACTIONS(2548),
    [anon_sym__Alignof] = ACTIONS(2548),
    [anon_sym_offsetof] = ACTIONS(2548),
    [anon_sym__Generic] = ACTIONS(2548),
    [anon_sym_asm] = ACTIONS(2548),
    [anon_sym___asm__] = ACTIONS(2548),
    [anon_sym___asm] = ACTIONS(2548),
    [sym_number_literal] = ACTIONS(2550),
    [anon_sym_L_SQUOTE] = ACTIONS(2550),
    [anon_sym_u_SQUOTE] = ACTIONS(2550),
    [anon_sym_U_SQUOTE] = ACTIONS(2550),
    [anon_sym_u8_SQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_L_DQUOTE] = ACTIONS(2550),
    [anon_sym_u_DQUOTE] = ACTIONS(2550),
    [anon_sym_U_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8_DQUOTE] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [anon_sym_NULL] = ACTIONS(2548),
    [anon_sym_nullptr] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [anon_sym_delete] = ACTIONS(2548),
    [anon_sym_throw] = ACTIONS(2548),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_concept] = ACTIONS(2548),
    [anon_sym_co_return] = ACTIONS(2548),
    [anon_sym_co_yield] = ACTIONS(2548),
    [anon_sym_R_DQUOTE] = ACTIONS(2550),
    [anon_sym_LR_DQUOTE] = ACTIONS(2550),
    [anon_sym_uR_DQUOTE] = ACTIONS(2550),
    [anon_sym_UR_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2550),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_requires] = ACTIONS(2548),
    [sym_this] = ACTIONS(2548),
    [anon_sym_discard] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
    [anon_sym_cbuffer] = ACTIONS(2548),
  },
  [735] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym___try] = ACTIONS(2453),
    [anon_sym___leave] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_discard] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
    [anon_sym_cbuffer] = ACTIONS(2453),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2590),
    [sym_identifier] = ACTIONS(2588),
    [aux_sym_preproc_include_token1] = ACTIONS(2588),
    [aux_sym_preproc_def_token1] = ACTIONS(2588),
    [aux_sym_preproc_if_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2588),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2588),
    [sym_preproc_directive] = ACTIONS(2588),
    [anon_sym_LPAREN2] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2590),
    [anon_sym_DASH] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2588),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2590),
    [anon_sym___extension__] = ACTIONS(2588),
    [anon_sym_typedef] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2588),
    [anon_sym_out] = ACTIONS(2588),
    [anon_sym_inout] = ACTIONS(2588),
    [anon_sym_virtual] = ACTIONS(2588),
    [anon_sym_extern] = ACTIONS(2588),
    [anon_sym___attribute__] = ACTIONS(2588),
    [anon_sym___attribute] = ACTIONS(2588),
    [anon_sym_using] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2590),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2590),
    [anon_sym___declspec] = ACTIONS(2588),
    [anon_sym___based] = ACTIONS(2588),
    [anon_sym___cdecl] = ACTIONS(2588),
    [anon_sym___clrcall] = ACTIONS(2588),
    [anon_sym___stdcall] = ACTIONS(2588),
    [anon_sym___fastcall] = ACTIONS(2588),
    [anon_sym___thiscall] = ACTIONS(2588),
    [anon_sym___vectorcall] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_signed] = ACTIONS(2588),
    [anon_sym_unsigned] = ACTIONS(2588),
    [anon_sym_long] = ACTIONS(2588),
    [anon_sym_short] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2588),
    [anon_sym_register] = ACTIONS(2588),
    [anon_sym_inline] = ACTIONS(2588),
    [anon_sym___inline] = ACTIONS(2588),
    [anon_sym___inline__] = ACTIONS(2588),
    [anon_sym___forceinline] = ACTIONS(2588),
    [anon_sym_thread_local] = ACTIONS(2588),
    [anon_sym___thread] = ACTIONS(2588),
    [anon_sym_const] = ACTIONS(2588),
    [anon_sym_constexpr] = ACTIONS(2588),
    [anon_sym_volatile] = ACTIONS(2588),
    [anon_sym_restrict] = ACTIONS(2588),
    [anon_sym___restrict__] = ACTIONS(2588),
    [anon_sym__Atomic] = ACTIONS(2588),
    [anon_sym__Noreturn] = ACTIONS(2588),
    [anon_sym_noreturn] = ACTIONS(2588),
    [anon_sym__Nonnull] = ACTIONS(2588),
    [anon_sym_mutable] = ACTIONS(2588),
    [anon_sym_constinit] = ACTIONS(2588),
    [anon_sym_consteval] = ACTIONS(2588),
    [anon_sym_alignas] = ACTIONS(2588),
    [anon_sym__Alignas] = ACTIONS(2588),
    [sym_primitive_type] = ACTIONS(2588),
    [anon_sym_enum] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_struct] = ACTIONS(2588),
    [anon_sym_union] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_switch] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_default] = ACTIONS(2588),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_do] = ACTIONS(2588),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_return] = ACTIONS(2588),
    [anon_sym_break] = ACTIONS(2588),
    [anon_sym_continue] = ACTIONS(2588),
    [anon_sym_goto] = ACTIONS(2588),
    [anon_sym_not] = ACTIONS(2588),
    [anon_sym_compl] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2590),
    [anon_sym_PLUS_PLUS] = ACTIONS(2590),
    [anon_sym_sizeof] = ACTIONS(2588),
    [anon_sym___alignof__] = ACTIONS(2588),
    [anon_sym___alignof] = ACTIONS(2588),
    [anon_sym__alignof] = ACTIONS(2588),
    [anon_sym_alignof] = ACTIONS(2588),
    [anon_sym__Alignof] = ACTIONS(2588),
    [anon_sym_offsetof] = ACTIONS(2588),
    [anon_sym__Generic] = ACTIONS(2588),
    [anon_sym_asm] = ACTIONS(2588),
    [anon_sym___asm__] = ACTIONS(2588),
    [anon_sym___asm] = ACTIONS(2588),
    [sym_number_literal] = ACTIONS(2590),
    [anon_sym_L_SQUOTE] = ACTIONS(2590),
    [anon_sym_u_SQUOTE] = ACTIONS(2590),
    [anon_sym_U_SQUOTE] = ACTIONS(2590),
    [anon_sym_u8_SQUOTE] = ACTIONS(2590),
    [anon_sym_SQUOTE] = ACTIONS(2590),
    [anon_sym_L_DQUOTE] = ACTIONS(2590),
    [anon_sym_u_DQUOTE] = ACTIONS(2590),
    [anon_sym_U_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8_DQUOTE] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2590),
    [sym_true] = ACTIONS(2588),
    [sym_false] = ACTIONS(2588),
    [anon_sym_NULL] = ACTIONS(2588),
    [anon_sym_nullptr] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2588),
    [anon_sym_decltype] = ACTIONS(2588),
    [anon_sym_explicit] = ACTIONS(2588),
    [anon_sym_typename] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_module] = ACTIONS(2588),
    [anon_sym_import] = ACTIONS(2588),
    [anon_sym_template] = ACTIONS(2588),
    [anon_sym_operator] = ACTIONS(2588),
    [anon_sym_try] = ACTIONS(2588),
    [anon_sym_delete] = ACTIONS(2588),
    [anon_sym_throw] = ACTIONS(2588),
    [anon_sym_namespace] = ACTIONS(2588),
    [anon_sym_static_assert] = ACTIONS(2588),
    [anon_sym_concept] = ACTIONS(2588),
    [anon_sym_co_return] = ACTIONS(2588),
    [anon_sym_co_yield] = ACTIONS(2588),
    [anon_sym_R_DQUOTE] = ACTIONS(2590),
    [anon_sym_LR_DQUOTE] = ACTIONS(2590),
    [anon_sym_uR_DQUOTE] = ACTIONS(2590),
    [anon_sym_UR_DQUOTE] = ACTIONS(2590),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2590),
    [anon_sym_co_await] = ACTIONS(2588),
    [anon_sym_new] = ACTIONS(2588),
    [anon_sym_requires] = ACTIONS(2588),
    [sym_this] = ACTIONS(2588),
    [anon_sym_precise] = ACTIONS(2588),
    [anon_sym_shared] = ACTIONS(2588),
    [anon_sym_groupshared] = ACTIONS(2588),
    [anon_sym_uniform] = ACTIONS(2588),
    [anon_sym_row_major] = ACTIONS(2588),
    [anon_sym_column_major] = ACTIONS(2588),
    [anon_sym_globallycoherent] = ACTIONS(2588),
    [anon_sym_centroid] = ACTIONS(2588),
    [anon_sym_noperspective] = ACTIONS(2588),
    [anon_sym_nointerpolation] = ACTIONS(2588),
    [anon_sym_sample] = ACTIONS(2588),
    [anon_sym_linear] = ACTIONS(2588),
    [anon_sym_snorm] = ACTIONS(2588),
    [anon_sym_unorm] = ACTIONS(2588),
    [anon_sym_point] = ACTIONS(2588),
    [anon_sym_line] = ACTIONS(2588),
    [anon_sym_triangleadj] = ACTIONS(2588),
    [anon_sym_lineadj] = ACTIONS(2588),
    [anon_sym_triangle] = ACTIONS(2588),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_include_token1] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym___cdecl] = ACTIONS(2632),
    [anon_sym___clrcall] = ACTIONS(2632),
    [anon_sym___stdcall] = ACTIONS(2632),
    [anon_sym___fastcall] = ACTIONS(2632),
    [anon_sym___thiscall] = ACTIONS(2632),
    [anon_sym___vectorcall] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2634),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_switch] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2632),
    [anon_sym_default] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [anon_sym_do] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_break] = ACTIONS(2632),
    [anon_sym_continue] = ACTIONS(2632),
    [anon_sym_goto] = ACTIONS(2632),
    [anon_sym_not] = ACTIONS(2632),
    [anon_sym_compl] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2634),
    [anon_sym_sizeof] = ACTIONS(2632),
    [anon_sym___alignof__] = ACTIONS(2632),
    [anon_sym___alignof] = ACTIONS(2632),
    [anon_sym__alignof] = ACTIONS(2632),
    [anon_sym_alignof] = ACTIONS(2632),
    [anon_sym__Alignof] = ACTIONS(2632),
    [anon_sym_offsetof] = ACTIONS(2632),
    [anon_sym__Generic] = ACTIONS(2632),
    [anon_sym_asm] = ACTIONS(2632),
    [anon_sym___asm__] = ACTIONS(2632),
    [anon_sym___asm] = ACTIONS(2632),
    [sym_number_literal] = ACTIONS(2634),
    [anon_sym_L_SQUOTE] = ACTIONS(2634),
    [anon_sym_u_SQUOTE] = ACTIONS(2634),
    [anon_sym_U_SQUOTE] = ACTIONS(2634),
    [anon_sym_u8_SQUOTE] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_L_DQUOTE] = ACTIONS(2634),
    [anon_sym_u_DQUOTE] = ACTIONS(2634),
    [anon_sym_U_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8_DQUOTE] = ACTIONS(2634),
    [anon_sym_DQUOTE] = ACTIONS(2634),
    [sym_true] = ACTIONS(2632),
    [sym_false] = ACTIONS(2632),
    [anon_sym_NULL] = ACTIONS(2632),
    [anon_sym_nullptr] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_delete] = ACTIONS(2632),
    [anon_sym_throw] = ACTIONS(2632),
    [anon_sym_namespace] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_concept] = ACTIONS(2632),
    [anon_sym_co_return] = ACTIONS(2632),
    [anon_sym_co_yield] = ACTIONS(2632),
    [anon_sym_R_DQUOTE] = ACTIONS(2634),
    [anon_sym_LR_DQUOTE] = ACTIONS(2634),
    [anon_sym_uR_DQUOTE] = ACTIONS(2634),
    [anon_sym_UR_DQUOTE] = ACTIONS(2634),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2634),
    [anon_sym_co_await] = ACTIONS(2632),
    [anon_sym_new] = ACTIONS(2632),
    [anon_sym_requires] = ACTIONS(2632),
    [sym_this] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2638),
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_include_token1] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym___cdecl] = ACTIONS(2636),
    [anon_sym___clrcall] = ACTIONS(2636),
    [anon_sym___stdcall] = ACTIONS(2636),
    [anon_sym___fastcall] = ACTIONS(2636),
    [anon_sym___thiscall] = ACTIONS(2636),
    [anon_sym___vectorcall] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2638),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_switch] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2636),
    [anon_sym_default] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_break] = ACTIONS(2636),
    [anon_sym_continue] = ACTIONS(2636),
    [anon_sym_goto] = ACTIONS(2636),
    [anon_sym_not] = ACTIONS(2636),
    [anon_sym_compl] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2638),
    [anon_sym_sizeof] = ACTIONS(2636),
    [anon_sym___alignof__] = ACTIONS(2636),
    [anon_sym___alignof] = ACTIONS(2636),
    [anon_sym__alignof] = ACTIONS(2636),
    [anon_sym_alignof] = ACTIONS(2636),
    [anon_sym__Alignof] = ACTIONS(2636),
    [anon_sym_offsetof] = ACTIONS(2636),
    [anon_sym__Generic] = ACTIONS(2636),
    [anon_sym_asm] = ACTIONS(2636),
    [anon_sym___asm__] = ACTIONS(2636),
    [anon_sym___asm] = ACTIONS(2636),
    [sym_number_literal] = ACTIONS(2638),
    [anon_sym_L_SQUOTE] = ACTIONS(2638),
    [anon_sym_u_SQUOTE] = ACTIONS(2638),
    [anon_sym_U_SQUOTE] = ACTIONS(2638),
    [anon_sym_u8_SQUOTE] = ACTIONS(2638),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_L_DQUOTE] = ACTIONS(2638),
    [anon_sym_u_DQUOTE] = ACTIONS(2638),
    [anon_sym_U_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8_DQUOTE] = ACTIONS(2638),
    [anon_sym_DQUOTE] = ACTIONS(2638),
    [sym_true] = ACTIONS(2636),
    [sym_false] = ACTIONS(2636),
    [anon_sym_NULL] = ACTIONS(2636),
    [anon_sym_nullptr] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_delete] = ACTIONS(2636),
    [anon_sym_throw] = ACTIONS(2636),
    [anon_sym_namespace] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_concept] = ACTIONS(2636),
    [anon_sym_co_return] = ACTIONS(2636),
    [anon_sym_co_yield] = ACTIONS(2636),
    [anon_sym_R_DQUOTE] = ACTIONS(2638),
    [anon_sym_LR_DQUOTE] = ACTIONS(2638),
    [anon_sym_uR_DQUOTE] = ACTIONS(2638),
    [anon_sym_UR_DQUOTE] = ACTIONS(2638),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2638),
    [anon_sym_co_await] = ACTIONS(2636),
    [anon_sym_new] = ACTIONS(2636),
    [anon_sym_requires] = ACTIONS(2636),
    [sym_this] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2674),
    [sym_identifier] = ACTIONS(2672),
    [aux_sym_preproc_include_token1] = ACTIONS(2672),
    [aux_sym_preproc_def_token1] = ACTIONS(2672),
    [aux_sym_preproc_if_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2672),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2672),
    [sym_preproc_directive] = ACTIONS(2672),
    [anon_sym_LPAREN2] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2672),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_AMP] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym___extension__] = ACTIONS(2672),
    [anon_sym_typedef] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2672),
    [anon_sym_out] = ACTIONS(2672),
    [anon_sym_inout] = ACTIONS(2672),
    [anon_sym_virtual] = ACTIONS(2672),
    [anon_sym_extern] = ACTIONS(2672),
    [anon_sym___attribute__] = ACTIONS(2672),
    [anon_sym___attribute] = ACTIONS(2672),
    [anon_sym_using] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2674),
    [anon_sym___declspec] = ACTIONS(2672),
    [anon_sym___based] = ACTIONS(2672),
    [anon_sym___cdecl] = ACTIONS(2672),
    [anon_sym___clrcall] = ACTIONS(2672),
    [anon_sym___stdcall] = ACTIONS(2672),
    [anon_sym___fastcall] = ACTIONS(2672),
    [anon_sym___thiscall] = ACTIONS(2672),
    [anon_sym___vectorcall] = ACTIONS(2672),
    [anon_sym_LBRACE] = ACTIONS(2674),
    [anon_sym_signed] = ACTIONS(2672),
    [anon_sym_unsigned] = ACTIONS(2672),
    [anon_sym_long] = ACTIONS(2672),
    [anon_sym_short] = ACTIONS(2672),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2672),
    [anon_sym_register] = ACTIONS(2672),
    [anon_sym_inline] = ACTIONS(2672),
    [anon_sym___inline] = ACTIONS(2672),
    [anon_sym___inline__] = ACTIONS(2672),
    [anon_sym___forceinline] = ACTIONS(2672),
    [anon_sym_thread_local] = ACTIONS(2672),
    [anon_sym___thread] = ACTIONS(2672),
    [anon_sym_const] = ACTIONS(2672),
    [anon_sym_constexpr] = ACTIONS(2672),
    [anon_sym_volatile] = ACTIONS(2672),
    [anon_sym_restrict] = ACTIONS(2672),
    [anon_sym___restrict__] = ACTIONS(2672),
    [anon_sym__Atomic] = ACTIONS(2672),
    [anon_sym__Noreturn] = ACTIONS(2672),
    [anon_sym_noreturn] = ACTIONS(2672),
    [anon_sym__Nonnull] = ACTIONS(2672),
    [anon_sym_mutable] = ACTIONS(2672),
    [anon_sym_constinit] = ACTIONS(2672),
    [anon_sym_consteval] = ACTIONS(2672),
    [anon_sym_alignas] = ACTIONS(2672),
    [anon_sym__Alignas] = ACTIONS(2672),
    [sym_primitive_type] = ACTIONS(2672),
    [anon_sym_enum] = ACTIONS(2672),
    [anon_sym_class] = ACTIONS(2672),
    [anon_sym_struct] = ACTIONS(2672),
    [anon_sym_union] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2672),
    [anon_sym_switch] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2672),
    [anon_sym_default] = ACTIONS(2672),
    [anon_sym_while] = ACTIONS(2672),
    [anon_sym_do] = ACTIONS(2672),
    [anon_sym_for] = ACTIONS(2672),
    [anon_sym_return] = ACTIONS(2672),
    [anon_sym_break] = ACTIONS(2672),
    [anon_sym_continue] = ACTIONS(2672),
    [anon_sym_goto] = ACTIONS(2672),
    [anon_sym_not] = ACTIONS(2672),
    [anon_sym_compl] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2674),
    [anon_sym_sizeof] = ACTIONS(2672),
    [anon_sym___alignof__] = ACTIONS(2672),
    [anon_sym___alignof] = ACTIONS(2672),
    [anon_sym__alignof] = ACTIONS(2672),
    [anon_sym_alignof] = ACTIONS(2672),
    [anon_sym__Alignof] = ACTIONS(2672),
    [anon_sym_offsetof] = ACTIONS(2672),
    [anon_sym__Generic] = ACTIONS(2672),
    [anon_sym_asm] = ACTIONS(2672),
    [anon_sym___asm__] = ACTIONS(2672),
    [anon_sym___asm] = ACTIONS(2672),
    [sym_number_literal] = ACTIONS(2674),
    [anon_sym_L_SQUOTE] = ACTIONS(2674),
    [anon_sym_u_SQUOTE] = ACTIONS(2674),
    [anon_sym_U_SQUOTE] = ACTIONS(2674),
    [anon_sym_u8_SQUOTE] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_L_DQUOTE] = ACTIONS(2674),
    [anon_sym_u_DQUOTE] = ACTIONS(2674),
    [anon_sym_U_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8_DQUOTE] = ACTIONS(2674),
    [anon_sym_DQUOTE] = ACTIONS(2674),
    [sym_true] = ACTIONS(2672),
    [sym_false] = ACTIONS(2672),
    [anon_sym_NULL] = ACTIONS(2672),
    [anon_sym_nullptr] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2672),
    [anon_sym_decltype] = ACTIONS(2672),
    [anon_sym_explicit] = ACTIONS(2672),
    [anon_sym_typename] = ACTIONS(2672),
    [anon_sym_export] = ACTIONS(2672),
    [anon_sym_module] = ACTIONS(2672),
    [anon_sym_import] = ACTIONS(2672),
    [anon_sym_template] = ACTIONS(2672),
    [anon_sym_operator] = ACTIONS(2672),
    [anon_sym_try] = ACTIONS(2672),
    [anon_sym_delete] = ACTIONS(2672),
    [anon_sym_throw] = ACTIONS(2672),
    [anon_sym_namespace] = ACTIONS(2672),
    [anon_sym_static_assert] = ACTIONS(2672),
    [anon_sym_concept] = ACTIONS(2672),
    [anon_sym_co_return] = ACTIONS(2672),
    [anon_sym_co_yield] = ACTIONS(2672),
    [anon_sym_R_DQUOTE] = ACTIONS(2674),
    [anon_sym_LR_DQUOTE] = ACTIONS(2674),
    [anon_sym_uR_DQUOTE] = ACTIONS(2674),
    [anon_sym_UR_DQUOTE] = ACTIONS(2674),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2674),
    [anon_sym_co_await] = ACTIONS(2672),
    [anon_sym_new] = ACTIONS(2672),
    [anon_sym_requires] = ACTIONS(2672),
    [sym_this] = ACTIONS(2672),
    [anon_sym_precise] = ACTIONS(2672),
    [anon_sym_shared] = ACTIONS(2672),
    [anon_sym_groupshared] = ACTIONS(2672),
    [anon_sym_uniform] = ACTIONS(2672),
    [anon_sym_row_major] = ACTIONS(2672),
    [anon_sym_column_major] = ACTIONS(2672),
    [anon_sym_globallycoherent] = ACTIONS(2672),
    [anon_sym_centroid] = ACTIONS(2672),
    [anon_sym_noperspective] = ACTIONS(2672),
    [anon_sym_nointerpolation] = ACTIONS(2672),
    [anon_sym_sample] = ACTIONS(2672),
    [anon_sym_linear] = ACTIONS(2672),
    [anon_sym_snorm] = ACTIONS(2672),
    [anon_sym_unorm] = ACTIONS(2672),
    [anon_sym_point] = ACTIONS(2672),
    [anon_sym_line] = ACTIONS(2672),
    [anon_sym_triangleadj] = ACTIONS(2672),
    [anon_sym_lineadj] = ACTIONS(2672),
    [anon_sym_triangle] = ACTIONS(2672),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2554),
    [sym_identifier] = ACTIONS(2552),
    [aux_sym_preproc_include_token1] = ACTIONS(2552),
    [aux_sym_preproc_def_token1] = ACTIONS(2552),
    [aux_sym_preproc_if_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2552),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2552),
    [sym_preproc_directive] = ACTIONS(2552),
    [anon_sym_LPAREN2] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2554),
    [anon_sym_TILDE] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2552),
    [anon_sym_STAR] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym___extension__] = ACTIONS(2552),
    [anon_sym_typedef] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2552),
    [anon_sym_out] = ACTIONS(2552),
    [anon_sym_inout] = ACTIONS(2552),
    [anon_sym_virtual] = ACTIONS(2552),
    [anon_sym_extern] = ACTIONS(2552),
    [anon_sym___attribute__] = ACTIONS(2552),
    [anon_sym___attribute] = ACTIONS(2552),
    [anon_sym_using] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2554),
    [anon_sym___declspec] = ACTIONS(2552),
    [anon_sym___based] = ACTIONS(2552),
    [anon_sym___cdecl] = ACTIONS(2552),
    [anon_sym___clrcall] = ACTIONS(2552),
    [anon_sym___stdcall] = ACTIONS(2552),
    [anon_sym___fastcall] = ACTIONS(2552),
    [anon_sym___thiscall] = ACTIONS(2552),
    [anon_sym___vectorcall] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(2554),
    [anon_sym_signed] = ACTIONS(2552),
    [anon_sym_unsigned] = ACTIONS(2552),
    [anon_sym_long] = ACTIONS(2552),
    [anon_sym_short] = ACTIONS(2552),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2552),
    [anon_sym_register] = ACTIONS(2552),
    [anon_sym_inline] = ACTIONS(2552),
    [anon_sym___inline] = ACTIONS(2552),
    [anon_sym___inline__] = ACTIONS(2552),
    [anon_sym___forceinline] = ACTIONS(2552),
    [anon_sym_thread_local] = ACTIONS(2552),
    [anon_sym___thread] = ACTIONS(2552),
    [anon_sym_const] = ACTIONS(2552),
    [anon_sym_constexpr] = ACTIONS(2552),
    [anon_sym_volatile] = ACTIONS(2552),
    [anon_sym_restrict] = ACTIONS(2552),
    [anon_sym___restrict__] = ACTIONS(2552),
    [anon_sym__Atomic] = ACTIONS(2552),
    [anon_sym__Noreturn] = ACTIONS(2552),
    [anon_sym_noreturn] = ACTIONS(2552),
    [anon_sym__Nonnull] = ACTIONS(2552),
    [anon_sym_mutable] = ACTIONS(2552),
    [anon_sym_constinit] = ACTIONS(2552),
    [anon_sym_consteval] = ACTIONS(2552),
    [anon_sym_alignas] = ACTIONS(2552),
    [anon_sym__Alignas] = ACTIONS(2552),
    [sym_primitive_type] = ACTIONS(2552),
    [anon_sym_enum] = ACTIONS(2552),
    [anon_sym_class] = ACTIONS(2552),
    [anon_sym_struct] = ACTIONS(2552),
    [anon_sym_union] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_switch] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2552),
    [anon_sym_default] = ACTIONS(2552),
    [anon_sym_while] = ACTIONS(2552),
    [anon_sym_do] = ACTIONS(2552),
    [anon_sym_for] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2552),
    [anon_sym_break] = ACTIONS(2552),
    [anon_sym_continue] = ACTIONS(2552),
    [anon_sym_goto] = ACTIONS(2552),
    [anon_sym_not] = ACTIONS(2552),
    [anon_sym_compl] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2554),
    [anon_sym_sizeof] = ACTIONS(2552),
    [anon_sym___alignof__] = ACTIONS(2552),
    [anon_sym___alignof] = ACTIONS(2552),
    [anon_sym__alignof] = ACTIONS(2552),
    [anon_sym_alignof] = ACTIONS(2552),
    [anon_sym__Alignof] = ACTIONS(2552),
    [anon_sym_offsetof] = ACTIONS(2552),
    [anon_sym__Generic] = ACTIONS(2552),
    [anon_sym_asm] = ACTIONS(2552),
    [anon_sym___asm__] = ACTIONS(2552),
    [anon_sym___asm] = ACTIONS(2552),
    [sym_number_literal] = ACTIONS(2554),
    [anon_sym_L_SQUOTE] = ACTIONS(2554),
    [anon_sym_u_SQUOTE] = ACTIONS(2554),
    [anon_sym_U_SQUOTE] = ACTIONS(2554),
    [anon_sym_u8_SQUOTE] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_L_DQUOTE] = ACTIONS(2554),
    [anon_sym_u_DQUOTE] = ACTIONS(2554),
    [anon_sym_U_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8_DQUOTE] = ACTIONS(2554),
    [anon_sym_DQUOTE] = ACTIONS(2554),
    [sym_true] = ACTIONS(2552),
    [sym_false] = ACTIONS(2552),
    [anon_sym_NULL] = ACTIONS(2552),
    [anon_sym_nullptr] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2552),
    [anon_sym_decltype] = ACTIONS(2552),
    [anon_sym_explicit] = ACTIONS(2552),
    [anon_sym_typename] = ACTIONS(2552),
    [anon_sym_export] = ACTIONS(2552),
    [anon_sym_module] = ACTIONS(2552),
    [anon_sym_import] = ACTIONS(2552),
    [anon_sym_template] = ACTIONS(2552),
    [anon_sym_operator] = ACTIONS(2552),
    [anon_sym_try] = ACTIONS(2552),
    [anon_sym_delete] = ACTIONS(2552),
    [anon_sym_throw] = ACTIONS(2552),
    [anon_sym_namespace] = ACTIONS(2552),
    [anon_sym_static_assert] = ACTIONS(2552),
    [anon_sym_concept] = ACTIONS(2552),
    [anon_sym_co_return] = ACTIONS(2552),
    [anon_sym_co_yield] = ACTIONS(2552),
    [anon_sym_R_DQUOTE] = ACTIONS(2554),
    [anon_sym_LR_DQUOTE] = ACTIONS(2554),
    [anon_sym_uR_DQUOTE] = ACTIONS(2554),
    [anon_sym_UR_DQUOTE] = ACTIONS(2554),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2554),
    [anon_sym_co_await] = ACTIONS(2552),
    [anon_sym_new] = ACTIONS(2552),
    [anon_sym_requires] = ACTIONS(2552),
    [sym_this] = ACTIONS(2552),
    [anon_sym_precise] = ACTIONS(2552),
    [anon_sym_shared] = ACTIONS(2552),
    [anon_sym_groupshared] = ACTIONS(2552),
    [anon_sym_uniform] = ACTIONS(2552),
    [anon_sym_row_major] = ACTIONS(2552),
    [anon_sym_column_major] = ACTIONS(2552),
    [anon_sym_globallycoherent] = ACTIONS(2552),
    [anon_sym_centroid] = ACTIONS(2552),
    [anon_sym_noperspective] = ACTIONS(2552),
    [anon_sym_nointerpolation] = ACTIONS(2552),
    [anon_sym_sample] = ACTIONS(2552),
    [anon_sym_linear] = ACTIONS(2552),
    [anon_sym_snorm] = ACTIONS(2552),
    [anon_sym_unorm] = ACTIONS(2552),
    [anon_sym_point] = ACTIONS(2552),
    [anon_sym_line] = ACTIONS(2552),
    [anon_sym_triangleadj] = ACTIONS(2552),
    [anon_sym_lineadj] = ACTIONS(2552),
    [anon_sym_triangle] = ACTIONS(2552),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2642),
    [sym_identifier] = ACTIONS(2640),
    [aux_sym_preproc_include_token1] = ACTIONS(2640),
    [aux_sym_preproc_def_token1] = ACTIONS(2640),
    [aux_sym_preproc_if_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2640),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2640),
    [sym_preproc_directive] = ACTIONS(2640),
    [anon_sym_LPAREN2] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2642),
    [anon_sym_AMP_AMP] = ACTIONS(2642),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2642),
    [anon_sym___extension__] = ACTIONS(2640),
    [anon_sym_typedef] = ACTIONS(2640),
    [anon_sym_in] = ACTIONS(2640),
    [anon_sym_out] = ACTIONS(2640),
    [anon_sym_inout] = ACTIONS(2640),
    [anon_sym_virtual] = ACTIONS(2640),
    [anon_sym_extern] = ACTIONS(2640),
    [anon_sym___attribute__] = ACTIONS(2640),
    [anon_sym___attribute] = ACTIONS(2640),
    [anon_sym_using] = ACTIONS(2640),
    [anon_sym_COLON_COLON] = ACTIONS(2642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2642),
    [anon_sym___declspec] = ACTIONS(2640),
    [anon_sym___based] = ACTIONS(2640),
    [anon_sym___cdecl] = ACTIONS(2640),
    [anon_sym___clrcall] = ACTIONS(2640),
    [anon_sym___stdcall] = ACTIONS(2640),
    [anon_sym___fastcall] = ACTIONS(2640),
    [anon_sym___thiscall] = ACTIONS(2640),
    [anon_sym___vectorcall] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_signed] = ACTIONS(2640),
    [anon_sym_unsigned] = ACTIONS(2640),
    [anon_sym_long] = ACTIONS(2640),
    [anon_sym_short] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2640),
    [anon_sym_register] = ACTIONS(2640),
    [anon_sym_inline] = ACTIONS(2640),
    [anon_sym___inline] = ACTIONS(2640),
    [anon_sym___inline__] = ACTIONS(2640),
    [anon_sym___forceinline] = ACTIONS(2640),
    [anon_sym_thread_local] = ACTIONS(2640),
    [anon_sym___thread] = ACTIONS(2640),
    [anon_sym_const] = ACTIONS(2640),
    [anon_sym_constexpr] = ACTIONS(2640),
    [anon_sym_volatile] = ACTIONS(2640),
    [anon_sym_restrict] = ACTIONS(2640),
    [anon_sym___restrict__] = ACTIONS(2640),
    [anon_sym__Atomic] = ACTIONS(2640),
    [anon_sym__Noreturn] = ACTIONS(2640),
    [anon_sym_noreturn] = ACTIONS(2640),
    [anon_sym__Nonnull] = ACTIONS(2640),
    [anon_sym_mutable] = ACTIONS(2640),
    [anon_sym_constinit] = ACTIONS(2640),
    [anon_sym_consteval] = ACTIONS(2640),
    [anon_sym_alignas] = ACTIONS(2640),
    [anon_sym__Alignas] = ACTIONS(2640),
    [sym_primitive_type] = ACTIONS(2640),
    [anon_sym_enum] = ACTIONS(2640),
    [anon_sym_class] = ACTIONS(2640),
    [anon_sym_struct] = ACTIONS(2640),
    [anon_sym_union] = ACTIONS(2640),
    [anon_sym_if] = ACTIONS(2640),
    [anon_sym_switch] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2640),
    [anon_sym_default] = ACTIONS(2640),
    [anon_sym_while] = ACTIONS(2640),
    [anon_sym_do] = ACTIONS(2640),
    [anon_sym_for] = ACTIONS(2640),
    [anon_sym_return] = ACTIONS(2640),
    [anon_sym_break] = ACTIONS(2640),
    [anon_sym_continue] = ACTIONS(2640),
    [anon_sym_goto] = ACTIONS(2640),
    [anon_sym_not] = ACTIONS(2640),
    [anon_sym_compl] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2642),
    [anon_sym_sizeof] = ACTIONS(2640),
    [anon_sym___alignof__] = ACTIONS(2640),
    [anon_sym___alignof] = ACTIONS(2640),
    [anon_sym__alignof] = ACTIONS(2640),
    [anon_sym_alignof] = ACTIONS(2640),
    [anon_sym__Alignof] = ACTIONS(2640),
    [anon_sym_offsetof] = ACTIONS(2640),
    [anon_sym__Generic] = ACTIONS(2640),
    [anon_sym_asm] = ACTIONS(2640),
    [anon_sym___asm__] = ACTIONS(2640),
    [anon_sym___asm] = ACTIONS(2640),
    [sym_number_literal] = ACTIONS(2642),
    [anon_sym_L_SQUOTE] = ACTIONS(2642),
    [anon_sym_u_SQUOTE] = ACTIONS(2642),
    [anon_sym_U_SQUOTE] = ACTIONS(2642),
    [anon_sym_u8_SQUOTE] = ACTIONS(2642),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym_L_DQUOTE] = ACTIONS(2642),
    [anon_sym_u_DQUOTE] = ACTIONS(2642),
    [anon_sym_U_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8_DQUOTE] = ACTIONS(2642),
    [anon_sym_DQUOTE] = ACTIONS(2642),
    [sym_true] = ACTIONS(2640),
    [sym_false] = ACTIONS(2640),
    [anon_sym_NULL] = ACTIONS(2640),
    [anon_sym_nullptr] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2640),
    [anon_sym_decltype] = ACTIONS(2640),
    [anon_sym_explicit] = ACTIONS(2640),
    [anon_sym_typename] = ACTIONS(2640),
    [anon_sym_export] = ACTIONS(2640),
    [anon_sym_module] = ACTIONS(2640),
    [anon_sym_import] = ACTIONS(2640),
    [anon_sym_template] = ACTIONS(2640),
    [anon_sym_operator] = ACTIONS(2640),
    [anon_sym_try] = ACTIONS(2640),
    [anon_sym_delete] = ACTIONS(2640),
    [anon_sym_throw] = ACTIONS(2640),
    [anon_sym_namespace] = ACTIONS(2640),
    [anon_sym_static_assert] = ACTIONS(2640),
    [anon_sym_concept] = ACTIONS(2640),
    [anon_sym_co_return] = ACTIONS(2640),
    [anon_sym_co_yield] = ACTIONS(2640),
    [anon_sym_R_DQUOTE] = ACTIONS(2642),
    [anon_sym_LR_DQUOTE] = ACTIONS(2642),
    [anon_sym_uR_DQUOTE] = ACTIONS(2642),
    [anon_sym_UR_DQUOTE] = ACTIONS(2642),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2642),
    [anon_sym_co_await] = ACTIONS(2640),
    [anon_sym_new] = ACTIONS(2640),
    [anon_sym_requires] = ACTIONS(2640),
    [sym_this] = ACTIONS(2640),
    [anon_sym_precise] = ACTIONS(2640),
    [anon_sym_shared] = ACTIONS(2640),
    [anon_sym_groupshared] = ACTIONS(2640),
    [anon_sym_uniform] = ACTIONS(2640),
    [anon_sym_row_major] = ACTIONS(2640),
    [anon_sym_column_major] = ACTIONS(2640),
    [anon_sym_globallycoherent] = ACTIONS(2640),
    [anon_sym_centroid] = ACTIONS(2640),
    [anon_sym_noperspective] = ACTIONS(2640),
    [anon_sym_nointerpolation] = ACTIONS(2640),
    [anon_sym_sample] = ACTIONS(2640),
    [anon_sym_linear] = ACTIONS(2640),
    [anon_sym_snorm] = ACTIONS(2640),
    [anon_sym_unorm] = ACTIONS(2640),
    [anon_sym_point] = ACTIONS(2640),
    [anon_sym_line] = ACTIONS(2640),
    [anon_sym_triangleadj] = ACTIONS(2640),
    [anon_sym_lineadj] = ACTIONS(2640),
    [anon_sym_triangle] = ACTIONS(2640),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(3011),
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_include_token1] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_out] = ACTIONS(3013),
    [anon_sym_inout] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3011),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym___cdecl] = ACTIONS(3013),
    [anon_sym___clrcall] = ACTIONS(3013),
    [anon_sym___stdcall] = ACTIONS(3013),
    [anon_sym___fastcall] = ACTIONS(3013),
    [anon_sym___thiscall] = ACTIONS(3013),
    [anon_sym___vectorcall] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_not] = ACTIONS(3013),
    [anon_sym_compl] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym___alignof__] = ACTIONS(3013),
    [anon_sym___alignof] = ACTIONS(3013),
    [anon_sym__alignof] = ACTIONS(3013),
    [anon_sym_alignof] = ACTIONS(3013),
    [anon_sym__Alignof] = ACTIONS(3013),
    [anon_sym_offsetof] = ACTIONS(3013),
    [anon_sym__Generic] = ACTIONS(3013),
    [anon_sym_asm] = ACTIONS(3013),
    [anon_sym___asm__] = ACTIONS(3013),
    [anon_sym___asm] = ACTIONS(3013),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_L_SQUOTE] = ACTIONS(3011),
    [anon_sym_u_SQUOTE] = ACTIONS(3011),
    [anon_sym_U_SQUOTE] = ACTIONS(3011),
    [anon_sym_u8_SQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_L_DQUOTE] = ACTIONS(3011),
    [anon_sym_u_DQUOTE] = ACTIONS(3011),
    [anon_sym_U_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [anon_sym_NULL] = ACTIONS(3013),
    [anon_sym_nullptr] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
    [anon_sym_concept] = ACTIONS(3013),
    [anon_sym_co_return] = ACTIONS(3013),
    [anon_sym_co_yield] = ACTIONS(3013),
    [anon_sym_R_DQUOTE] = ACTIONS(3011),
    [anon_sym_LR_DQUOTE] = ACTIONS(3011),
    [anon_sym_uR_DQUOTE] = ACTIONS(3011),
    [anon_sym_UR_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3011),
    [anon_sym_co_await] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_requires] = ACTIONS(3013),
    [sym_this] = ACTIONS(3013),
    [anon_sym_precise] = ACTIONS(3013),
    [anon_sym_shared] = ACTIONS(3013),
    [anon_sym_groupshared] = ACTIONS(3013),
    [anon_sym_uniform] = ACTIONS(3013),
    [anon_sym_row_major] = ACTIONS(3013),
    [anon_sym_column_major] = ACTIONS(3013),
    [anon_sym_globallycoherent] = ACTIONS(3013),
    [anon_sym_centroid] = ACTIONS(3013),
    [anon_sym_noperspective] = ACTIONS(3013),
    [anon_sym_nointerpolation] = ACTIONS(3013),
    [anon_sym_sample] = ACTIONS(3013),
    [anon_sym_linear] = ACTIONS(3013),
    [anon_sym_snorm] = ACTIONS(3013),
    [anon_sym_unorm] = ACTIONS(3013),
    [anon_sym_point] = ACTIONS(3013),
    [anon_sym_line] = ACTIONS(3013),
    [anon_sym_triangleadj] = ACTIONS(3013),
    [anon_sym_lineadj] = ACTIONS(3013),
    [anon_sym_triangle] = ACTIONS(3013),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_include_token1] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym___cdecl] = ACTIONS(2616),
    [anon_sym___clrcall] = ACTIONS(2616),
    [anon_sym___stdcall] = ACTIONS(2616),
    [anon_sym___fastcall] = ACTIONS(2616),
    [anon_sym___thiscall] = ACTIONS(2616),
    [anon_sym___vectorcall] = ACTIONS(2616),
    [anon_sym_LBRACE] = ACTIONS(2618),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_switch] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2616),
    [anon_sym_default] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [anon_sym_do] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_break] = ACTIONS(2616),
    [anon_sym_continue] = ACTIONS(2616),
    [anon_sym_goto] = ACTIONS(2616),
    [anon_sym_not] = ACTIONS(2616),
    [anon_sym_compl] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2618),
    [anon_sym_sizeof] = ACTIONS(2616),
    [anon_sym___alignof__] = ACTIONS(2616),
    [anon_sym___alignof] = ACTIONS(2616),
    [anon_sym__alignof] = ACTIONS(2616),
    [anon_sym_alignof] = ACTIONS(2616),
    [anon_sym__Alignof] = ACTIONS(2616),
    [anon_sym_offsetof] = ACTIONS(2616),
    [anon_sym__Generic] = ACTIONS(2616),
    [anon_sym_asm] = ACTIONS(2616),
    [anon_sym___asm__] = ACTIONS(2616),
    [anon_sym___asm] = ACTIONS(2616),
    [sym_number_literal] = ACTIONS(2618),
    [anon_sym_L_SQUOTE] = ACTIONS(2618),
    [anon_sym_u_SQUOTE] = ACTIONS(2618),
    [anon_sym_U_SQUOTE] = ACTIONS(2618),
    [anon_sym_u8_SQUOTE] = ACTIONS(2618),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_L_DQUOTE] = ACTIONS(2618),
    [anon_sym_u_DQUOTE] = ACTIONS(2618),
    [anon_sym_U_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8_DQUOTE] = ACTIONS(2618),
    [anon_sym_DQUOTE] = ACTIONS(2618),
    [sym_true] = ACTIONS(2616),
    [sym_false] = ACTIONS(2616),
    [anon_sym_NULL] = ACTIONS(2616),
    [anon_sym_nullptr] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_delete] = ACTIONS(2616),
    [anon_sym_throw] = ACTIONS(2616),
    [anon_sym_namespace] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_concept] = ACTIONS(2616),
    [anon_sym_co_return] = ACTIONS(2616),
    [anon_sym_co_yield] = ACTIONS(2616),
    [anon_sym_R_DQUOTE] = ACTIONS(2618),
    [anon_sym_LR_DQUOTE] = ACTIONS(2618),
    [anon_sym_uR_DQUOTE] = ACTIONS(2618),
    [anon_sym_UR_DQUOTE] = ACTIONS(2618),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2618),
    [anon_sym_co_await] = ACTIONS(2616),
    [anon_sym_new] = ACTIONS(2616),
    [anon_sym_requires] = ACTIONS(2616),
    [sym_this] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(3015),
    [sym_identifier] = ACTIONS(3017),
    [aux_sym_preproc_include_token1] = ACTIONS(3017),
    [aux_sym_preproc_def_token1] = ACTIONS(3017),
    [aux_sym_preproc_if_token1] = ACTIONS(3017),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3017),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3017),
    [sym_preproc_directive] = ACTIONS(3017),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3017),
    [anon_sym_typedef] = ACTIONS(3017),
    [anon_sym_in] = ACTIONS(3017),
    [anon_sym_out] = ACTIONS(3017),
    [anon_sym_inout] = ACTIONS(3017),
    [anon_sym_virtual] = ACTIONS(3017),
    [anon_sym_extern] = ACTIONS(3017),
    [anon_sym___attribute__] = ACTIONS(3017),
    [anon_sym___attribute] = ACTIONS(3017),
    [anon_sym_using] = ACTIONS(3017),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3017),
    [anon_sym___based] = ACTIONS(3017),
    [anon_sym___cdecl] = ACTIONS(3017),
    [anon_sym___clrcall] = ACTIONS(3017),
    [anon_sym___stdcall] = ACTIONS(3017),
    [anon_sym___fastcall] = ACTIONS(3017),
    [anon_sym___thiscall] = ACTIONS(3017),
    [anon_sym___vectorcall] = ACTIONS(3017),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3017),
    [anon_sym_unsigned] = ACTIONS(3017),
    [anon_sym_long] = ACTIONS(3017),
    [anon_sym_short] = ACTIONS(3017),
    [anon_sym_LBRACK] = ACTIONS(3017),
    [anon_sym_static] = ACTIONS(3017),
    [anon_sym_register] = ACTIONS(3017),
    [anon_sym_inline] = ACTIONS(3017),
    [anon_sym___inline] = ACTIONS(3017),
    [anon_sym___inline__] = ACTIONS(3017),
    [anon_sym___forceinline] = ACTIONS(3017),
    [anon_sym_thread_local] = ACTIONS(3017),
    [anon_sym___thread] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_constexpr] = ACTIONS(3017),
    [anon_sym_volatile] = ACTIONS(3017),
    [anon_sym_restrict] = ACTIONS(3017),
    [anon_sym___restrict__] = ACTIONS(3017),
    [anon_sym__Atomic] = ACTIONS(3017),
    [anon_sym__Noreturn] = ACTIONS(3017),
    [anon_sym_noreturn] = ACTIONS(3017),
    [anon_sym__Nonnull] = ACTIONS(3017),
    [anon_sym_mutable] = ACTIONS(3017),
    [anon_sym_constinit] = ACTIONS(3017),
    [anon_sym_consteval] = ACTIONS(3017),
    [anon_sym_alignas] = ACTIONS(3017),
    [anon_sym__Alignas] = ACTIONS(3017),
    [sym_primitive_type] = ACTIONS(3017),
    [anon_sym_enum] = ACTIONS(3017),
    [anon_sym_class] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3017),
    [anon_sym_union] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_switch] = ACTIONS(3017),
    [anon_sym_case] = ACTIONS(3017),
    [anon_sym_default] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [anon_sym_do] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_break] = ACTIONS(3017),
    [anon_sym_continue] = ACTIONS(3017),
    [anon_sym_goto] = ACTIONS(3017),
    [anon_sym_not] = ACTIONS(3017),
    [anon_sym_compl] = ACTIONS(3017),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_sizeof] = ACTIONS(3017),
    [anon_sym___alignof__] = ACTIONS(3017),
    [anon_sym___alignof] = ACTIONS(3017),
    [anon_sym__alignof] = ACTIONS(3017),
    [anon_sym_alignof] = ACTIONS(3017),
    [anon_sym__Alignof] = ACTIONS(3017),
    [anon_sym_offsetof] = ACTIONS(3017),
    [anon_sym__Generic] = ACTIONS(3017),
    [anon_sym_asm] = ACTIONS(3017),
    [anon_sym___asm__] = ACTIONS(3017),
    [anon_sym___asm] = ACTIONS(3017),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_L_SQUOTE] = ACTIONS(3015),
    [anon_sym_u_SQUOTE] = ACTIONS(3015),
    [anon_sym_U_SQUOTE] = ACTIONS(3015),
    [anon_sym_u8_SQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_L_DQUOTE] = ACTIONS(3015),
    [anon_sym_u_DQUOTE] = ACTIONS(3015),
    [anon_sym_U_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [sym_true] = ACTIONS(3017),
    [sym_false] = ACTIONS(3017),
    [anon_sym_NULL] = ACTIONS(3017),
    [anon_sym_nullptr] = ACTIONS(3017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3017),
    [anon_sym_decltype] = ACTIONS(3017),
    [anon_sym_explicit] = ACTIONS(3017),
    [anon_sym_typename] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_template] = ACTIONS(3017),
    [anon_sym_operator] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_delete] = ACTIONS(3017),
    [anon_sym_throw] = ACTIONS(3017),
    [anon_sym_namespace] = ACTIONS(3017),
    [anon_sym_static_assert] = ACTIONS(3017),
    [anon_sym_concept] = ACTIONS(3017),
    [anon_sym_co_return] = ACTIONS(3017),
    [anon_sym_co_yield] = ACTIONS(3017),
    [anon_sym_R_DQUOTE] = ACTIONS(3015),
    [anon_sym_LR_DQUOTE] = ACTIONS(3015),
    [anon_sym_uR_DQUOTE] = ACTIONS(3015),
    [anon_sym_UR_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3015),
    [anon_sym_co_await] = ACTIONS(3017),
    [anon_sym_new] = ACTIONS(3017),
    [anon_sym_requires] = ACTIONS(3017),
    [sym_this] = ACTIONS(3017),
    [anon_sym_precise] = ACTIONS(3017),
    [anon_sym_shared] = ACTIONS(3017),
    [anon_sym_groupshared] = ACTIONS(3017),
    [anon_sym_uniform] = ACTIONS(3017),
    [anon_sym_row_major] = ACTIONS(3017),
    [anon_sym_column_major] = ACTIONS(3017),
    [anon_sym_globallycoherent] = ACTIONS(3017),
    [anon_sym_centroid] = ACTIONS(3017),
    [anon_sym_noperspective] = ACTIONS(3017),
    [anon_sym_nointerpolation] = ACTIONS(3017),
    [anon_sym_sample] = ACTIONS(3017),
    [anon_sym_linear] = ACTIONS(3017),
    [anon_sym_snorm] = ACTIONS(3017),
    [anon_sym_unorm] = ACTIONS(3017),
    [anon_sym_point] = ACTIONS(3017),
    [anon_sym_line] = ACTIONS(3017),
    [anon_sym_triangleadj] = ACTIONS(3017),
    [anon_sym_lineadj] = ACTIONS(3017),
    [anon_sym_triangle] = ACTIONS(3017),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(3019),
    [sym_identifier] = ACTIONS(3021),
    [aux_sym_preproc_include_token1] = ACTIONS(3021),
    [aux_sym_preproc_def_token1] = ACTIONS(3021),
    [aux_sym_preproc_if_token1] = ACTIONS(3021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3021),
    [sym_preproc_directive] = ACTIONS(3021),
    [anon_sym_LPAREN2] = ACTIONS(3019),
    [anon_sym_BANG] = ACTIONS(3019),
    [anon_sym_TILDE] = ACTIONS(3019),
    [anon_sym_DASH] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_STAR] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_AMP] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym___extension__] = ACTIONS(3021),
    [anon_sym_typedef] = ACTIONS(3021),
    [anon_sym_in] = ACTIONS(3021),
    [anon_sym_out] = ACTIONS(3021),
    [anon_sym_inout] = ACTIONS(3021),
    [anon_sym_virtual] = ACTIONS(3021),
    [anon_sym_extern] = ACTIONS(3021),
    [anon_sym___attribute__] = ACTIONS(3021),
    [anon_sym___attribute] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_COLON_COLON] = ACTIONS(3019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3019),
    [anon_sym___declspec] = ACTIONS(3021),
    [anon_sym___based] = ACTIONS(3021),
    [anon_sym___cdecl] = ACTIONS(3021),
    [anon_sym___clrcall] = ACTIONS(3021),
    [anon_sym___stdcall] = ACTIONS(3021),
    [anon_sym___fastcall] = ACTIONS(3021),
    [anon_sym___thiscall] = ACTIONS(3021),
    [anon_sym___vectorcall] = ACTIONS(3021),
    [anon_sym_LBRACE] = ACTIONS(3019),
    [anon_sym_signed] = ACTIONS(3021),
    [anon_sym_unsigned] = ACTIONS(3021),
    [anon_sym_long] = ACTIONS(3021),
    [anon_sym_short] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(3021),
    [anon_sym_static] = ACTIONS(3021),
    [anon_sym_register] = ACTIONS(3021),
    [anon_sym_inline] = ACTIONS(3021),
    [anon_sym___inline] = ACTIONS(3021),
    [anon_sym___inline__] = ACTIONS(3021),
    [anon_sym___forceinline] = ACTIONS(3021),
    [anon_sym_thread_local] = ACTIONS(3021),
    [anon_sym___thread] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_constexpr] = ACTIONS(3021),
    [anon_sym_volatile] = ACTIONS(3021),
    [anon_sym_restrict] = ACTIONS(3021),
    [anon_sym___restrict__] = ACTIONS(3021),
    [anon_sym__Atomic] = ACTIONS(3021),
    [anon_sym__Noreturn] = ACTIONS(3021),
    [anon_sym_noreturn] = ACTIONS(3021),
    [anon_sym__Nonnull] = ACTIONS(3021),
    [anon_sym_mutable] = ACTIONS(3021),
    [anon_sym_constinit] = ACTIONS(3021),
    [anon_sym_consteval] = ACTIONS(3021),
    [anon_sym_alignas] = ACTIONS(3021),
    [anon_sym__Alignas] = ACTIONS(3021),
    [sym_primitive_type] = ACTIONS(3021),
    [anon_sym_enum] = ACTIONS(3021),
    [anon_sym_class] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3021),
    [anon_sym_union] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_switch] = ACTIONS(3021),
    [anon_sym_case] = ACTIONS(3021),
    [anon_sym_default] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [anon_sym_do] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_break] = ACTIONS(3021),
    [anon_sym_continue] = ACTIONS(3021),
    [anon_sym_goto] = ACTIONS(3021),
    [anon_sym_not] = ACTIONS(3021),
    [anon_sym_compl] = ACTIONS(3021),
    [anon_sym_DASH_DASH] = ACTIONS(3019),
    [anon_sym_PLUS_PLUS] = ACTIONS(3019),
    [anon_sym_sizeof] = ACTIONS(3021),
    [anon_sym___alignof__] = ACTIONS(3021),
    [anon_sym___alignof] = ACTIONS(3021),
    [anon_sym__alignof] = ACTIONS(3021),
    [anon_sym_alignof] = ACTIONS(3021),
    [anon_sym__Alignof] = ACTIONS(3021),
    [anon_sym_offsetof] = ACTIONS(3021),
    [anon_sym__Generic] = ACTIONS(3021),
    [anon_sym_asm] = ACTIONS(3021),
    [anon_sym___asm__] = ACTIONS(3021),
    [anon_sym___asm] = ACTIONS(3021),
    [sym_number_literal] = ACTIONS(3019),
    [anon_sym_L_SQUOTE] = ACTIONS(3019),
    [anon_sym_u_SQUOTE] = ACTIONS(3019),
    [anon_sym_U_SQUOTE] = ACTIONS(3019),
    [anon_sym_u8_SQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_L_DQUOTE] = ACTIONS(3019),
    [anon_sym_u_DQUOTE] = ACTIONS(3019),
    [anon_sym_U_DQUOTE] = ACTIONS(3019),
    [anon_sym_u8_DQUOTE] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [sym_true] = ACTIONS(3021),
    [sym_false] = ACTIONS(3021),
    [anon_sym_NULL] = ACTIONS(3021),
    [anon_sym_nullptr] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3021),
    [anon_sym_decltype] = ACTIONS(3021),
    [anon_sym_explicit] = ACTIONS(3021),
    [anon_sym_typename] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_template] = ACTIONS(3021),
    [anon_sym_operator] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_delete] = ACTIONS(3021),
    [anon_sym_throw] = ACTIONS(3021),
    [anon_sym_namespace] = ACTIONS(3021),
    [anon_sym_static_assert] = ACTIONS(3021),
    [anon_sym_concept] = ACTIONS(3021),
    [anon_sym_co_return] = ACTIONS(3021),
    [anon_sym_co_yield] = ACTIONS(3021),
    [anon_sym_R_DQUOTE] = ACTIONS(3019),
    [anon_sym_LR_DQUOTE] = ACTIONS(3019),
    [anon_sym_uR_DQUOTE] = ACTIONS(3019),
    [anon_sym_UR_DQUOTE] = ACTIONS(3019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3019),
    [anon_sym_co_await] = ACTIONS(3021),
    [anon_sym_new] = ACTIONS(3021),
    [anon_sym_requires] = ACTIONS(3021),
    [sym_this] = ACTIONS(3021),
    [anon_sym_precise] = ACTIONS(3021),
    [anon_sym_shared] = ACTIONS(3021),
    [anon_sym_groupshared] = ACTIONS(3021),
    [anon_sym_uniform] = ACTIONS(3021),
    [anon_sym_row_major] = ACTIONS(3021),
    [anon_sym_column_major] = ACTIONS(3021),
    [anon_sym_globallycoherent] = ACTIONS(3021),
    [anon_sym_centroid] = ACTIONS(3021),
    [anon_sym_noperspective] = ACTIONS(3021),
    [anon_sym_nointerpolation] = ACTIONS(3021),
    [anon_sym_sample] = ACTIONS(3021),
    [anon_sym_linear] = ACTIONS(3021),
    [anon_sym_snorm] = ACTIONS(3021),
    [anon_sym_unorm] = ACTIONS(3021),
    [anon_sym_point] = ACTIONS(3021),
    [anon_sym_line] = ACTIONS(3021),
    [anon_sym_triangleadj] = ACTIONS(3021),
    [anon_sym_lineadj] = ACTIONS(3021),
    [anon_sym_triangle] = ACTIONS(3021),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(3023),
    [sym_identifier] = ACTIONS(3025),
    [aux_sym_preproc_include_token1] = ACTIONS(3025),
    [aux_sym_preproc_def_token1] = ACTIONS(3025),
    [aux_sym_preproc_if_token1] = ACTIONS(3025),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3025),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3025),
    [sym_preproc_directive] = ACTIONS(3025),
    [anon_sym_LPAREN2] = ACTIONS(3023),
    [anon_sym_BANG] = ACTIONS(3023),
    [anon_sym_TILDE] = ACTIONS(3023),
    [anon_sym_DASH] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_AMP] = ACTIONS(3025),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym___extension__] = ACTIONS(3025),
    [anon_sym_typedef] = ACTIONS(3025),
    [anon_sym_in] = ACTIONS(3025),
    [anon_sym_out] = ACTIONS(3025),
    [anon_sym_inout] = ACTIONS(3025),
    [anon_sym_virtual] = ACTIONS(3025),
    [anon_sym_extern] = ACTIONS(3025),
    [anon_sym___attribute__] = ACTIONS(3025),
    [anon_sym___attribute] = ACTIONS(3025),
    [anon_sym_using] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3023),
    [anon_sym___declspec] = ACTIONS(3025),
    [anon_sym___based] = ACTIONS(3025),
    [anon_sym___cdecl] = ACTIONS(3025),
    [anon_sym___clrcall] = ACTIONS(3025),
    [anon_sym___stdcall] = ACTIONS(3025),
    [anon_sym___fastcall] = ACTIONS(3025),
    [anon_sym___thiscall] = ACTIONS(3025),
    [anon_sym___vectorcall] = ACTIONS(3025),
    [anon_sym_LBRACE] = ACTIONS(3023),
    [anon_sym_signed] = ACTIONS(3025),
    [anon_sym_unsigned] = ACTIONS(3025),
    [anon_sym_long] = ACTIONS(3025),
    [anon_sym_short] = ACTIONS(3025),
    [anon_sym_LBRACK] = ACTIONS(3025),
    [anon_sym_static] = ACTIONS(3025),
    [anon_sym_register] = ACTIONS(3025),
    [anon_sym_inline] = ACTIONS(3025),
    [anon_sym___inline] = ACTIONS(3025),
    [anon_sym___inline__] = ACTIONS(3025),
    [anon_sym___forceinline] = ACTIONS(3025),
    [anon_sym_thread_local] = ACTIONS(3025),
    [anon_sym___thread] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_constexpr] = ACTIONS(3025),
    [anon_sym_volatile] = ACTIONS(3025),
    [anon_sym_restrict] = ACTIONS(3025),
    [anon_sym___restrict__] = ACTIONS(3025),
    [anon_sym__Atomic] = ACTIONS(3025),
    [anon_sym__Noreturn] = ACTIONS(3025),
    [anon_sym_noreturn] = ACTIONS(3025),
    [anon_sym__Nonnull] = ACTIONS(3025),
    [anon_sym_mutable] = ACTIONS(3025),
    [anon_sym_constinit] = ACTIONS(3025),
    [anon_sym_consteval] = ACTIONS(3025),
    [anon_sym_alignas] = ACTIONS(3025),
    [anon_sym__Alignas] = ACTIONS(3025),
    [sym_primitive_type] = ACTIONS(3025),
    [anon_sym_enum] = ACTIONS(3025),
    [anon_sym_class] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3025),
    [anon_sym_union] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_switch] = ACTIONS(3025),
    [anon_sym_case] = ACTIONS(3025),
    [anon_sym_default] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [anon_sym_do] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_break] = ACTIONS(3025),
    [anon_sym_continue] = ACTIONS(3025),
    [anon_sym_goto] = ACTIONS(3025),
    [anon_sym_not] = ACTIONS(3025),
    [anon_sym_compl] = ACTIONS(3025),
    [anon_sym_DASH_DASH] = ACTIONS(3023),
    [anon_sym_PLUS_PLUS] = ACTIONS(3023),
    [anon_sym_sizeof] = ACTIONS(3025),
    [anon_sym___alignof__] = ACTIONS(3025),
    [anon_sym___alignof] = ACTIONS(3025),
    [anon_sym__alignof] = ACTIONS(3025),
    [anon_sym_alignof] = ACTIONS(3025),
    [anon_sym__Alignof] = ACTIONS(3025),
    [anon_sym_offsetof] = ACTIONS(3025),
    [anon_sym__Generic] = ACTIONS(3025),
    [anon_sym_asm] = ACTIONS(3025),
    [anon_sym___asm__] = ACTIONS(3025),
    [anon_sym___asm] = ACTIONS(3025),
    [sym_number_literal] = ACTIONS(3023),
    [anon_sym_L_SQUOTE] = ACTIONS(3023),
    [anon_sym_u_SQUOTE] = ACTIONS(3023),
    [anon_sym_U_SQUOTE] = ACTIONS(3023),
    [anon_sym_u8_SQUOTE] = ACTIONS(3023),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_L_DQUOTE] = ACTIONS(3023),
    [anon_sym_u_DQUOTE] = ACTIONS(3023),
    [anon_sym_U_DQUOTE] = ACTIONS(3023),
    [anon_sym_u8_DQUOTE] = ACTIONS(3023),
    [anon_sym_DQUOTE] = ACTIONS(3023),
    [sym_true] = ACTIONS(3025),
    [sym_false] = ACTIONS(3025),
    [anon_sym_NULL] = ACTIONS(3025),
    [anon_sym_nullptr] = ACTIONS(3025),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3025),
    [anon_sym_decltype] = ACTIONS(3025),
    [anon_sym_explicit] = ACTIONS(3025),
    [anon_sym_typename] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_template] = ACTIONS(3025),
    [anon_sym_operator] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_delete] = ACTIONS(3025),
    [anon_sym_throw] = ACTIONS(3025),
    [anon_sym_namespace] = ACTIONS(3025),
    [anon_sym_static_assert] = ACTIONS(3025),
    [anon_sym_concept] = ACTIONS(3025),
    [anon_sym_co_return] = ACTIONS(3025),
    [anon_sym_co_yield] = ACTIONS(3025),
    [anon_sym_R_DQUOTE] = ACTIONS(3023),
    [anon_sym_LR_DQUOTE] = ACTIONS(3023),
    [anon_sym_uR_DQUOTE] = ACTIONS(3023),
    [anon_sym_UR_DQUOTE] = ACTIONS(3023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3023),
    [anon_sym_co_await] = ACTIONS(3025),
    [anon_sym_new] = ACTIONS(3025),
    [anon_sym_requires] = ACTIONS(3025),
    [sym_this] = ACTIONS(3025),
    [anon_sym_precise] = ACTIONS(3025),
    [anon_sym_shared] = ACTIONS(3025),
    [anon_sym_groupshared] = ACTIONS(3025),
    [anon_sym_uniform] = ACTIONS(3025),
    [anon_sym_row_major] = ACTIONS(3025),
    [anon_sym_column_major] = ACTIONS(3025),
    [anon_sym_globallycoherent] = ACTIONS(3025),
    [anon_sym_centroid] = ACTIONS(3025),
    [anon_sym_noperspective] = ACTIONS(3025),
    [anon_sym_nointerpolation] = ACTIONS(3025),
    [anon_sym_sample] = ACTIONS(3025),
    [anon_sym_linear] = ACTIONS(3025),
    [anon_sym_snorm] = ACTIONS(3025),
    [anon_sym_unorm] = ACTIONS(3025),
    [anon_sym_point] = ACTIONS(3025),
    [anon_sym_line] = ACTIONS(3025),
    [anon_sym_triangleadj] = ACTIONS(3025),
    [anon_sym_lineadj] = ACTIONS(3025),
    [anon_sym_triangle] = ACTIONS(3025),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(3027),
    [sym_identifier] = ACTIONS(3029),
    [aux_sym_preproc_include_token1] = ACTIONS(3029),
    [aux_sym_preproc_def_token1] = ACTIONS(3029),
    [aux_sym_preproc_if_token1] = ACTIONS(3029),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3029),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3029),
    [sym_preproc_directive] = ACTIONS(3029),
    [anon_sym_LPAREN2] = ACTIONS(3027),
    [anon_sym_BANG] = ACTIONS(3027),
    [anon_sym_TILDE] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_AMP] = ACTIONS(3029),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym___extension__] = ACTIONS(3029),
    [anon_sym_typedef] = ACTIONS(3029),
    [anon_sym_in] = ACTIONS(3029),
    [anon_sym_out] = ACTIONS(3029),
    [anon_sym_inout] = ACTIONS(3029),
    [anon_sym_virtual] = ACTIONS(3029),
    [anon_sym_extern] = ACTIONS(3029),
    [anon_sym___attribute__] = ACTIONS(3029),
    [anon_sym___attribute] = ACTIONS(3029),
    [anon_sym_using] = ACTIONS(3029),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3027),
    [anon_sym___declspec] = ACTIONS(3029),
    [anon_sym___based] = ACTIONS(3029),
    [anon_sym___cdecl] = ACTIONS(3029),
    [anon_sym___clrcall] = ACTIONS(3029),
    [anon_sym___stdcall] = ACTIONS(3029),
    [anon_sym___fastcall] = ACTIONS(3029),
    [anon_sym___thiscall] = ACTIONS(3029),
    [anon_sym___vectorcall] = ACTIONS(3029),
    [anon_sym_LBRACE] = ACTIONS(3027),
    [anon_sym_signed] = ACTIONS(3029),
    [anon_sym_unsigned] = ACTIONS(3029),
    [anon_sym_long] = ACTIONS(3029),
    [anon_sym_short] = ACTIONS(3029),
    [anon_sym_LBRACK] = ACTIONS(3029),
    [anon_sym_static] = ACTIONS(3029),
    [anon_sym_register] = ACTIONS(3029),
    [anon_sym_inline] = ACTIONS(3029),
    [anon_sym___inline] = ACTIONS(3029),
    [anon_sym___inline__] = ACTIONS(3029),
    [anon_sym___forceinline] = ACTIONS(3029),
    [anon_sym_thread_local] = ACTIONS(3029),
    [anon_sym___thread] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_constexpr] = ACTIONS(3029),
    [anon_sym_volatile] = ACTIONS(3029),
    [anon_sym_restrict] = ACTIONS(3029),
    [anon_sym___restrict__] = ACTIONS(3029),
    [anon_sym__Atomic] = ACTIONS(3029),
    [anon_sym__Noreturn] = ACTIONS(3029),
    [anon_sym_noreturn] = ACTIONS(3029),
    [anon_sym__Nonnull] = ACTIONS(3029),
    [anon_sym_mutable] = ACTIONS(3029),
    [anon_sym_constinit] = ACTIONS(3029),
    [anon_sym_consteval] = ACTIONS(3029),
    [anon_sym_alignas] = ACTIONS(3029),
    [anon_sym__Alignas] = ACTIONS(3029),
    [sym_primitive_type] = ACTIONS(3029),
    [anon_sym_enum] = ACTIONS(3029),
    [anon_sym_class] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3029),
    [anon_sym_union] = ACTIONS(3029),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_switch] = ACTIONS(3029),
    [anon_sym_case] = ACTIONS(3029),
    [anon_sym_default] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [anon_sym_do] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_break] = ACTIONS(3029),
    [anon_sym_continue] = ACTIONS(3029),
    [anon_sym_goto] = ACTIONS(3029),
    [anon_sym_not] = ACTIONS(3029),
    [anon_sym_compl] = ACTIONS(3029),
    [anon_sym_DASH_DASH] = ACTIONS(3027),
    [anon_sym_PLUS_PLUS] = ACTIONS(3027),
    [anon_sym_sizeof] = ACTIONS(3029),
    [anon_sym___alignof__] = ACTIONS(3029),
    [anon_sym___alignof] = ACTIONS(3029),
    [anon_sym__alignof] = ACTIONS(3029),
    [anon_sym_alignof] = ACTIONS(3029),
    [anon_sym__Alignof] = ACTIONS(3029),
    [anon_sym_offsetof] = ACTIONS(3029),
    [anon_sym__Generic] = ACTIONS(3029),
    [anon_sym_asm] = ACTIONS(3029),
    [anon_sym___asm__] = ACTIONS(3029),
    [anon_sym___asm] = ACTIONS(3029),
    [sym_number_literal] = ACTIONS(3027),
    [anon_sym_L_SQUOTE] = ACTIONS(3027),
    [anon_sym_u_SQUOTE] = ACTIONS(3027),
    [anon_sym_U_SQUOTE] = ACTIONS(3027),
    [anon_sym_u8_SQUOTE] = ACTIONS(3027),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_L_DQUOTE] = ACTIONS(3027),
    [anon_sym_u_DQUOTE] = ACTIONS(3027),
    [anon_sym_U_DQUOTE] = ACTIONS(3027),
    [anon_sym_u8_DQUOTE] = ACTIONS(3027),
    [anon_sym_DQUOTE] = ACTIONS(3027),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [anon_sym_NULL] = ACTIONS(3029),
    [anon_sym_nullptr] = ACTIONS(3029),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3029),
    [anon_sym_decltype] = ACTIONS(3029),
    [anon_sym_explicit] = ACTIONS(3029),
    [anon_sym_typename] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_template] = ACTIONS(3029),
    [anon_sym_operator] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_delete] = ACTIONS(3029),
    [anon_sym_throw] = ACTIONS(3029),
    [anon_sym_namespace] = ACTIONS(3029),
    [anon_sym_static_assert] = ACTIONS(3029),
    [anon_sym_concept] = ACTIONS(3029),
    [anon_sym_co_return] = ACTIONS(3029),
    [anon_sym_co_yield] = ACTIONS(3029),
    [anon_sym_R_DQUOTE] = ACTIONS(3027),
    [anon_sym_LR_DQUOTE] = ACTIONS(3027),
    [anon_sym_uR_DQUOTE] = ACTIONS(3027),
    [anon_sym_UR_DQUOTE] = ACTIONS(3027),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3027),
    [anon_sym_co_await] = ACTIONS(3029),
    [anon_sym_new] = ACTIONS(3029),
    [anon_sym_requires] = ACTIONS(3029),
    [sym_this] = ACTIONS(3029),
    [anon_sym_precise] = ACTIONS(3029),
    [anon_sym_shared] = ACTIONS(3029),
    [anon_sym_groupshared] = ACTIONS(3029),
    [anon_sym_uniform] = ACTIONS(3029),
    [anon_sym_row_major] = ACTIONS(3029),
    [anon_sym_column_major] = ACTIONS(3029),
    [anon_sym_globallycoherent] = ACTIONS(3029),
    [anon_sym_centroid] = ACTIONS(3029),
    [anon_sym_noperspective] = ACTIONS(3029),
    [anon_sym_nointerpolation] = ACTIONS(3029),
    [anon_sym_sample] = ACTIONS(3029),
    [anon_sym_linear] = ACTIONS(3029),
    [anon_sym_snorm] = ACTIONS(3029),
    [anon_sym_unorm] = ACTIONS(3029),
    [anon_sym_point] = ACTIONS(3029),
    [anon_sym_line] = ACTIONS(3029),
    [anon_sym_triangleadj] = ACTIONS(3029),
    [anon_sym_lineadj] = ACTIONS(3029),
    [anon_sym_triangle] = ACTIONS(3029),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(2435),
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_include_token1] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_DASH] = ACTIONS(2433),
    [anon_sym_PLUS] = ACTIONS(2433),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym___cdecl] = ACTIONS(2433),
    [anon_sym___clrcall] = ACTIONS(2433),
    [anon_sym___stdcall] = ACTIONS(2433),
    [anon_sym___fastcall] = ACTIONS(2433),
    [anon_sym___thiscall] = ACTIONS(2433),
    [anon_sym___vectorcall] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2435),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [anon_sym_if] = ACTIONS(2433),
    [anon_sym_switch] = ACTIONS(2433),
    [anon_sym_case] = ACTIONS(2433),
    [anon_sym_default] = ACTIONS(2433),
    [anon_sym_while] = ACTIONS(2433),
    [anon_sym_do] = ACTIONS(2433),
    [anon_sym_for] = ACTIONS(2433),
    [anon_sym_return] = ACTIONS(2433),
    [anon_sym_break] = ACTIONS(2433),
    [anon_sym_continue] = ACTIONS(2433),
    [anon_sym_goto] = ACTIONS(2433),
    [anon_sym_not] = ACTIONS(2433),
    [anon_sym_compl] = ACTIONS(2433),
    [anon_sym_DASH_DASH] = ACTIONS(2435),
    [anon_sym_PLUS_PLUS] = ACTIONS(2435),
    [anon_sym_sizeof] = ACTIONS(2433),
    [anon_sym___alignof__] = ACTIONS(2433),
    [anon_sym___alignof] = ACTIONS(2433),
    [anon_sym__alignof] = ACTIONS(2433),
    [anon_sym_alignof] = ACTIONS(2433),
    [anon_sym__Alignof] = ACTIONS(2433),
    [anon_sym_offsetof] = ACTIONS(2433),
    [anon_sym__Generic] = ACTIONS(2433),
    [anon_sym_asm] = ACTIONS(2433),
    [anon_sym___asm__] = ACTIONS(2433),
    [anon_sym___asm] = ACTIONS(2433),
    [sym_number_literal] = ACTIONS(2435),
    [anon_sym_L_SQUOTE] = ACTIONS(2435),
    [anon_sym_u_SQUOTE] = ACTIONS(2435),
    [anon_sym_U_SQUOTE] = ACTIONS(2435),
    [anon_sym_u8_SQUOTE] = ACTIONS(2435),
    [anon_sym_SQUOTE] = ACTIONS(2435),
    [anon_sym_L_DQUOTE] = ACTIONS(2435),
    [anon_sym_u_DQUOTE] = ACTIONS(2435),
    [anon_sym_U_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8_DQUOTE] = ACTIONS(2435),
    [anon_sym_DQUOTE] = ACTIONS(2435),
    [sym_true] = ACTIONS(2433),
    [sym_false] = ACTIONS(2433),
    [anon_sym_NULL] = ACTIONS(2433),
    [anon_sym_nullptr] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_export] = ACTIONS(2433),
    [anon_sym_module] = ACTIONS(2433),
    [anon_sym_import] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_try] = ACTIONS(2433),
    [anon_sym_delete] = ACTIONS(2433),
    [anon_sym_throw] = ACTIONS(2433),
    [anon_sym_namespace] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_concept] = ACTIONS(2433),
    [anon_sym_co_return] = ACTIONS(2433),
    [anon_sym_co_yield] = ACTIONS(2433),
    [anon_sym_R_DQUOTE] = ACTIONS(2435),
    [anon_sym_LR_DQUOTE] = ACTIONS(2435),
    [anon_sym_uR_DQUOTE] = ACTIONS(2435),
    [anon_sym_UR_DQUOTE] = ACTIONS(2435),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2435),
    [anon_sym_co_await] = ACTIONS(2433),
    [anon_sym_new] = ACTIONS(2433),
    [anon_sym_requires] = ACTIONS(2433),
    [sym_this] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(2427),
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_include_token1] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_BANG] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym___cdecl] = ACTIONS(2425),
    [anon_sym___clrcall] = ACTIONS(2425),
    [anon_sym___stdcall] = ACTIONS(2425),
    [anon_sym___fastcall] = ACTIONS(2425),
    [anon_sym___thiscall] = ACTIONS(2425),
    [anon_sym___vectorcall] = ACTIONS(2425),
    [anon_sym_LBRACE] = ACTIONS(2427),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [anon_sym_if] = ACTIONS(2425),
    [anon_sym_switch] = ACTIONS(2425),
    [anon_sym_case] = ACTIONS(2425),
    [anon_sym_default] = ACTIONS(2425),
    [anon_sym_while] = ACTIONS(2425),
    [anon_sym_do] = ACTIONS(2425),
    [anon_sym_for] = ACTIONS(2425),
    [anon_sym_return] = ACTIONS(2425),
    [anon_sym_break] = ACTIONS(2425),
    [anon_sym_continue] = ACTIONS(2425),
    [anon_sym_goto] = ACTIONS(2425),
    [anon_sym_not] = ACTIONS(2425),
    [anon_sym_compl] = ACTIONS(2425),
    [anon_sym_DASH_DASH] = ACTIONS(2427),
    [anon_sym_PLUS_PLUS] = ACTIONS(2427),
    [anon_sym_sizeof] = ACTIONS(2425),
    [anon_sym___alignof__] = ACTIONS(2425),
    [anon_sym___alignof] = ACTIONS(2425),
    [anon_sym__alignof] = ACTIONS(2425),
    [anon_sym_alignof] = ACTIONS(2425),
    [anon_sym__Alignof] = ACTIONS(2425),
    [anon_sym_offsetof] = ACTIONS(2425),
    [anon_sym__Generic] = ACTIONS(2425),
    [anon_sym_asm] = ACTIONS(2425),
    [anon_sym___asm__] = ACTIONS(2425),
    [anon_sym___asm] = ACTIONS(2425),
    [sym_number_literal] = ACTIONS(2427),
    [anon_sym_L_SQUOTE] = ACTIONS(2427),
    [anon_sym_u_SQUOTE] = ACTIONS(2427),
    [anon_sym_U_SQUOTE] = ACTIONS(2427),
    [anon_sym_u8_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_L_DQUOTE] = ACTIONS(2427),
    [anon_sym_u_DQUOTE] = ACTIONS(2427),
    [anon_sym_U_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8_DQUOTE] = ACTIONS(2427),
    [anon_sym_DQUOTE] = ACTIONS(2427),
    [sym_true] = ACTIONS(2425),
    [sym_false] = ACTIONS(2425),
    [anon_sym_NULL] = ACTIONS(2425),
    [anon_sym_nullptr] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_export] = ACTIONS(2425),
    [anon_sym_module] = ACTIONS(2425),
    [anon_sym_import] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_try] = ACTIONS(2425),
    [anon_sym_delete] = ACTIONS(2425),
    [anon_sym_throw] = ACTIONS(2425),
    [anon_sym_namespace] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_concept] = ACTIONS(2425),
    [anon_sym_co_return] = ACTIONS(2425),
    [anon_sym_co_yield] = ACTIONS(2425),
    [anon_sym_R_DQUOTE] = ACTIONS(2427),
    [anon_sym_LR_DQUOTE] = ACTIONS(2427),
    [anon_sym_uR_DQUOTE] = ACTIONS(2427),
    [anon_sym_UR_DQUOTE] = ACTIONS(2427),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2427),
    [anon_sym_co_await] = ACTIONS(2425),
    [anon_sym_new] = ACTIONS(2425),
    [anon_sym_requires] = ACTIONS(2425),
    [sym_this] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_include_token1] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym___cdecl] = ACTIONS(2620),
    [anon_sym___clrcall] = ACTIONS(2620),
    [anon_sym___stdcall] = ACTIONS(2620),
    [anon_sym___fastcall] = ACTIONS(2620),
    [anon_sym___thiscall] = ACTIONS(2620),
    [anon_sym___vectorcall] = ACTIONS(2620),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_switch] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2620),
    [anon_sym_default] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [anon_sym_do] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_break] = ACTIONS(2620),
    [anon_sym_continue] = ACTIONS(2620),
    [anon_sym_goto] = ACTIONS(2620),
    [anon_sym_not] = ACTIONS(2620),
    [anon_sym_compl] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2622),
    [anon_sym_sizeof] = ACTIONS(2620),
    [anon_sym___alignof__] = ACTIONS(2620),
    [anon_sym___alignof] = ACTIONS(2620),
    [anon_sym__alignof] = ACTIONS(2620),
    [anon_sym_alignof] = ACTIONS(2620),
    [anon_sym__Alignof] = ACTIONS(2620),
    [anon_sym_offsetof] = ACTIONS(2620),
    [anon_sym__Generic] = ACTIONS(2620),
    [anon_sym_asm] = ACTIONS(2620),
    [anon_sym___asm__] = ACTIONS(2620),
    [anon_sym___asm] = ACTIONS(2620),
    [sym_number_literal] = ACTIONS(2622),
    [anon_sym_L_SQUOTE] = ACTIONS(2622),
    [anon_sym_u_SQUOTE] = ACTIONS(2622),
    [anon_sym_U_SQUOTE] = ACTIONS(2622),
    [anon_sym_u8_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_L_DQUOTE] = ACTIONS(2622),
    [anon_sym_u_DQUOTE] = ACTIONS(2622),
    [anon_sym_U_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8_DQUOTE] = ACTIONS(2622),
    [anon_sym_DQUOTE] = ACTIONS(2622),
    [sym_true] = ACTIONS(2620),
    [sym_false] = ACTIONS(2620),
    [anon_sym_NULL] = ACTIONS(2620),
    [anon_sym_nullptr] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_delete] = ACTIONS(2620),
    [anon_sym_throw] = ACTIONS(2620),
    [anon_sym_namespace] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_concept] = ACTIONS(2620),
    [anon_sym_co_return] = ACTIONS(2620),
    [anon_sym_co_yield] = ACTIONS(2620),
    [anon_sym_R_DQUOTE] = ACTIONS(2622),
    [anon_sym_LR_DQUOTE] = ACTIONS(2622),
    [anon_sym_uR_DQUOTE] = ACTIONS(2622),
    [anon_sym_UR_DQUOTE] = ACTIONS(2622),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2622),
    [anon_sym_co_await] = ACTIONS(2620),
    [anon_sym_new] = ACTIONS(2620),
    [anon_sym_requires] = ACTIONS(2620),
    [sym_this] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(2477),
    [sym_identifier] = ACTIONS(2474),
    [aux_sym_preproc_include_token1] = ACTIONS(2474),
    [aux_sym_preproc_def_token1] = ACTIONS(2474),
    [aux_sym_preproc_if_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2474),
    [sym_preproc_directive] = ACTIONS(2474),
    [anon_sym_LPAREN2] = ACTIONS(2477),
    [anon_sym_BANG] = ACTIONS(2477),
    [anon_sym_TILDE] = ACTIONS(2477),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2477),
    [anon_sym_AMP_AMP] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym___extension__] = ACTIONS(2474),
    [anon_sym_typedef] = ACTIONS(2474),
    [anon_sym_in] = ACTIONS(2474),
    [anon_sym_out] = ACTIONS(2474),
    [anon_sym_inout] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym___attribute__] = ACTIONS(2474),
    [anon_sym___attribute] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_COLON_COLON] = ACTIONS(2477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2477),
    [anon_sym___declspec] = ACTIONS(2474),
    [anon_sym___based] = ACTIONS(2474),
    [anon_sym___cdecl] = ACTIONS(2474),
    [anon_sym___clrcall] = ACTIONS(2474),
    [anon_sym___stdcall] = ACTIONS(2474),
    [anon_sym___fastcall] = ACTIONS(2474),
    [anon_sym___thiscall] = ACTIONS(2474),
    [anon_sym___vectorcall] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2477),
    [anon_sym_signed] = ACTIONS(2474),
    [anon_sym_unsigned] = ACTIONS(2474),
    [anon_sym_long] = ACTIONS(2474),
    [anon_sym_short] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_register] = ACTIONS(2474),
    [anon_sym_inline] = ACTIONS(2474),
    [anon_sym___inline] = ACTIONS(2474),
    [anon_sym___inline__] = ACTIONS(2474),
    [anon_sym___forceinline] = ACTIONS(2474),
    [anon_sym_thread_local] = ACTIONS(2474),
    [anon_sym___thread] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_constexpr] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_restrict] = ACTIONS(2474),
    [anon_sym___restrict__] = ACTIONS(2474),
    [anon_sym__Atomic] = ACTIONS(2474),
    [anon_sym__Noreturn] = ACTIONS(2474),
    [anon_sym_noreturn] = ACTIONS(2474),
    [anon_sym__Nonnull] = ACTIONS(2474),
    [anon_sym_mutable] = ACTIONS(2474),
    [anon_sym_constinit] = ACTIONS(2474),
    [anon_sym_consteval] = ACTIONS(2474),
    [anon_sym_alignas] = ACTIONS(2474),
    [anon_sym__Alignas] = ACTIONS(2474),
    [sym_primitive_type] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_union] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym_not] = ACTIONS(2474),
    [anon_sym_compl] = ACTIONS(2474),
    [anon_sym_DASH_DASH] = ACTIONS(2477),
    [anon_sym_PLUS_PLUS] = ACTIONS(2477),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym___alignof__] = ACTIONS(2474),
    [anon_sym___alignof] = ACTIONS(2474),
    [anon_sym__alignof] = ACTIONS(2474),
    [anon_sym_alignof] = ACTIONS(2474),
    [anon_sym__Alignof] = ACTIONS(2474),
    [anon_sym_offsetof] = ACTIONS(2474),
    [anon_sym__Generic] = ACTIONS(2474),
    [anon_sym_asm] = ACTIONS(2474),
    [anon_sym___asm__] = ACTIONS(2474),
    [anon_sym___asm] = ACTIONS(2474),
    [sym_number_literal] = ACTIONS(2477),
    [anon_sym_L_SQUOTE] = ACTIONS(2477),
    [anon_sym_u_SQUOTE] = ACTIONS(2477),
    [anon_sym_U_SQUOTE] = ACTIONS(2477),
    [anon_sym_u8_SQUOTE] = ACTIONS(2477),
    [anon_sym_SQUOTE] = ACTIONS(2477),
    [anon_sym_L_DQUOTE] = ACTIONS(2477),
    [anon_sym_u_DQUOTE] = ACTIONS(2477),
    [anon_sym_U_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8_DQUOTE] = ACTIONS(2477),
    [anon_sym_DQUOTE] = ACTIONS(2477),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [anon_sym_NULL] = ACTIONS(2474),
    [anon_sym_nullptr] = ACTIONS(2474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2474),
    [anon_sym_decltype] = ACTIONS(2474),
    [anon_sym_explicit] = ACTIONS(2474),
    [anon_sym_typename] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_template] = ACTIONS(2474),
    [anon_sym_operator] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_static_assert] = ACTIONS(2474),
    [anon_sym_concept] = ACTIONS(2474),
    [anon_sym_co_return] = ACTIONS(2474),
    [anon_sym_co_yield] = ACTIONS(2474),
    [anon_sym_R_DQUOTE] = ACTIONS(2477),
    [anon_sym_LR_DQUOTE] = ACTIONS(2477),
    [anon_sym_uR_DQUOTE] = ACTIONS(2477),
    [anon_sym_UR_DQUOTE] = ACTIONS(2477),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2477),
    [anon_sym_co_await] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_requires] = ACTIONS(2474),
    [sym_this] = ACTIONS(2474),
    [anon_sym_precise] = ACTIONS(2474),
    [anon_sym_shared] = ACTIONS(2474),
    [anon_sym_groupshared] = ACTIONS(2474),
    [anon_sym_uniform] = ACTIONS(2474),
    [anon_sym_row_major] = ACTIONS(2474),
    [anon_sym_column_major] = ACTIONS(2474),
    [anon_sym_globallycoherent] = ACTIONS(2474),
    [anon_sym_centroid] = ACTIONS(2474),
    [anon_sym_noperspective] = ACTIONS(2474),
    [anon_sym_nointerpolation] = ACTIONS(2474),
    [anon_sym_sample] = ACTIONS(2474),
    [anon_sym_linear] = ACTIONS(2474),
    [anon_sym_snorm] = ACTIONS(2474),
    [anon_sym_unorm] = ACTIONS(2474),
    [anon_sym_point] = ACTIONS(2474),
    [anon_sym_line] = ACTIONS(2474),
    [anon_sym_triangleadj] = ACTIONS(2474),
    [anon_sym_lineadj] = ACTIONS(2474),
    [anon_sym_triangle] = ACTIONS(2474),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(2646),
    [sym_identifier] = ACTIONS(2644),
    [aux_sym_preproc_include_token1] = ACTIONS(2644),
    [aux_sym_preproc_def_token1] = ACTIONS(2644),
    [aux_sym_preproc_if_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2644),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2644),
    [sym_preproc_directive] = ACTIONS(2644),
    [anon_sym_LPAREN2] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2644),
    [anon_sym_PLUS] = ACTIONS(2644),
    [anon_sym_STAR] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2644),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym___extension__] = ACTIONS(2644),
    [anon_sym_typedef] = ACTIONS(2644),
    [anon_sym_in] = ACTIONS(2644),
    [anon_sym_out] = ACTIONS(2644),
    [anon_sym_inout] = ACTIONS(2644),
    [anon_sym_virtual] = ACTIONS(2644),
    [anon_sym_extern] = ACTIONS(2644),
    [anon_sym___attribute__] = ACTIONS(2644),
    [anon_sym___attribute] = ACTIONS(2644),
    [anon_sym_using] = ACTIONS(2644),
    [anon_sym_COLON_COLON] = ACTIONS(2646),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2646),
    [anon_sym___declspec] = ACTIONS(2644),
    [anon_sym___based] = ACTIONS(2644),
    [anon_sym___cdecl] = ACTIONS(2644),
    [anon_sym___clrcall] = ACTIONS(2644),
    [anon_sym___stdcall] = ACTIONS(2644),
    [anon_sym___fastcall] = ACTIONS(2644),
    [anon_sym___thiscall] = ACTIONS(2644),
    [anon_sym___vectorcall] = ACTIONS(2644),
    [anon_sym_LBRACE] = ACTIONS(2646),
    [anon_sym_signed] = ACTIONS(2644),
    [anon_sym_unsigned] = ACTIONS(2644),
    [anon_sym_long] = ACTIONS(2644),
    [anon_sym_short] = ACTIONS(2644),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2644),
    [anon_sym_register] = ACTIONS(2644),
    [anon_sym_inline] = ACTIONS(2644),
    [anon_sym___inline] = ACTIONS(2644),
    [anon_sym___inline__] = ACTIONS(2644),
    [anon_sym___forceinline] = ACTIONS(2644),
    [anon_sym_thread_local] = ACTIONS(2644),
    [anon_sym___thread] = ACTIONS(2644),
    [anon_sym_const] = ACTIONS(2644),
    [anon_sym_constexpr] = ACTIONS(2644),
    [anon_sym_volatile] = ACTIONS(2644),
    [anon_sym_restrict] = ACTIONS(2644),
    [anon_sym___restrict__] = ACTIONS(2644),
    [anon_sym__Atomic] = ACTIONS(2644),
    [anon_sym__Noreturn] = ACTIONS(2644),
    [anon_sym_noreturn] = ACTIONS(2644),
    [anon_sym__Nonnull] = ACTIONS(2644),
    [anon_sym_mutable] = ACTIONS(2644),
    [anon_sym_constinit] = ACTIONS(2644),
    [anon_sym_consteval] = ACTIONS(2644),
    [anon_sym_alignas] = ACTIONS(2644),
    [anon_sym__Alignas] = ACTIONS(2644),
    [sym_primitive_type] = ACTIONS(2644),
    [anon_sym_enum] = ACTIONS(2644),
    [anon_sym_class] = ACTIONS(2644),
    [anon_sym_struct] = ACTIONS(2644),
    [anon_sym_union] = ACTIONS(2644),
    [anon_sym_if] = ACTIONS(2644),
    [anon_sym_switch] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2644),
    [anon_sym_default] = ACTIONS(2644),
    [anon_sym_while] = ACTIONS(2644),
    [anon_sym_do] = ACTIONS(2644),
    [anon_sym_for] = ACTIONS(2644),
    [anon_sym_return] = ACTIONS(2644),
    [anon_sym_break] = ACTIONS(2644),
    [anon_sym_continue] = ACTIONS(2644),
    [anon_sym_goto] = ACTIONS(2644),
    [anon_sym_not] = ACTIONS(2644),
    [anon_sym_compl] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2646),
    [anon_sym_sizeof] = ACTIONS(2644),
    [anon_sym___alignof__] = ACTIONS(2644),
    [anon_sym___alignof] = ACTIONS(2644),
    [anon_sym__alignof] = ACTIONS(2644),
    [anon_sym_alignof] = ACTIONS(2644),
    [anon_sym__Alignof] = ACTIONS(2644),
    [anon_sym_offsetof] = ACTIONS(2644),
    [anon_sym__Generic] = ACTIONS(2644),
    [anon_sym_asm] = ACTIONS(2644),
    [anon_sym___asm__] = ACTIONS(2644),
    [anon_sym___asm] = ACTIONS(2644),
    [sym_number_literal] = ACTIONS(2646),
    [anon_sym_L_SQUOTE] = ACTIONS(2646),
    [anon_sym_u_SQUOTE] = ACTIONS(2646),
    [anon_sym_U_SQUOTE] = ACTIONS(2646),
    [anon_sym_u8_SQUOTE] = ACTIONS(2646),
    [anon_sym_SQUOTE] = ACTIONS(2646),
    [anon_sym_L_DQUOTE] = ACTIONS(2646),
    [anon_sym_u_DQUOTE] = ACTIONS(2646),
    [anon_sym_U_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8_DQUOTE] = ACTIONS(2646),
    [anon_sym_DQUOTE] = ACTIONS(2646),
    [sym_true] = ACTIONS(2644),
    [sym_false] = ACTIONS(2644),
    [anon_sym_NULL] = ACTIONS(2644),
    [anon_sym_nullptr] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2644),
    [anon_sym_decltype] = ACTIONS(2644),
    [anon_sym_explicit] = ACTIONS(2644),
    [anon_sym_typename] = ACTIONS(2644),
    [anon_sym_export] = ACTIONS(2644),
    [anon_sym_module] = ACTIONS(2644),
    [anon_sym_import] = ACTIONS(2644),
    [anon_sym_template] = ACTIONS(2644),
    [anon_sym_operator] = ACTIONS(2644),
    [anon_sym_try] = ACTIONS(2644),
    [anon_sym_delete] = ACTIONS(2644),
    [anon_sym_throw] = ACTIONS(2644),
    [anon_sym_namespace] = ACTIONS(2644),
    [anon_sym_static_assert] = ACTIONS(2644),
    [anon_sym_concept] = ACTIONS(2644),
    [anon_sym_co_return] = ACTIONS(2644),
    [anon_sym_co_yield] = ACTIONS(2644),
    [anon_sym_R_DQUOTE] = ACTIONS(2646),
    [anon_sym_LR_DQUOTE] = ACTIONS(2646),
    [anon_sym_uR_DQUOTE] = ACTIONS(2646),
    [anon_sym_UR_DQUOTE] = ACTIONS(2646),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2646),
    [anon_sym_co_await] = ACTIONS(2644),
    [anon_sym_new] = ACTIONS(2644),
    [anon_sym_requires] = ACTIONS(2644),
    [sym_this] = ACTIONS(2644),
    [anon_sym_precise] = ACTIONS(2644),
    [anon_sym_shared] = ACTIONS(2644),
    [anon_sym_groupshared] = ACTIONS(2644),
    [anon_sym_uniform] = ACTIONS(2644),
    [anon_sym_row_major] = ACTIONS(2644),
    [anon_sym_column_major] = ACTIONS(2644),
    [anon_sym_globallycoherent] = ACTIONS(2644),
    [anon_sym_centroid] = ACTIONS(2644),
    [anon_sym_noperspective] = ACTIONS(2644),
    [anon_sym_nointerpolation] = ACTIONS(2644),
    [anon_sym_sample] = ACTIONS(2644),
    [anon_sym_linear] = ACTIONS(2644),
    [anon_sym_snorm] = ACTIONS(2644),
    [anon_sym_unorm] = ACTIONS(2644),
    [anon_sym_point] = ACTIONS(2644),
    [anon_sym_line] = ACTIONS(2644),
    [anon_sym_triangleadj] = ACTIONS(2644),
    [anon_sym_lineadj] = ACTIONS(2644),
    [anon_sym_triangle] = ACTIONS(2644),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_include_token1] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym___cdecl] = ACTIONS(2624),
    [anon_sym___clrcall] = ACTIONS(2624),
    [anon_sym___stdcall] = ACTIONS(2624),
    [anon_sym___fastcall] = ACTIONS(2624),
    [anon_sym___thiscall] = ACTIONS(2624),
    [anon_sym___vectorcall] = ACTIONS(2624),
    [anon_sym_LBRACE] = ACTIONS(2626),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_switch] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2624),
    [anon_sym_default] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [anon_sym_do] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_break] = ACTIONS(2624),
    [anon_sym_continue] = ACTIONS(2624),
    [anon_sym_goto] = ACTIONS(2624),
    [anon_sym_not] = ACTIONS(2624),
    [anon_sym_compl] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2626),
    [anon_sym_sizeof] = ACTIONS(2624),
    [anon_sym___alignof__] = ACTIONS(2624),
    [anon_sym___alignof] = ACTIONS(2624),
    [anon_sym__alignof] = ACTIONS(2624),
    [anon_sym_alignof] = ACTIONS(2624),
    [anon_sym__Alignof] = ACTIONS(2624),
    [anon_sym_offsetof] = ACTIONS(2624),
    [anon_sym__Generic] = ACTIONS(2624),
    [anon_sym_asm] = ACTIONS(2624),
    [anon_sym___asm__] = ACTIONS(2624),
    [anon_sym___asm] = ACTIONS(2624),
    [sym_number_literal] = ACTIONS(2626),
    [anon_sym_L_SQUOTE] = ACTIONS(2626),
    [anon_sym_u_SQUOTE] = ACTIONS(2626),
    [anon_sym_U_SQUOTE] = ACTIONS(2626),
    [anon_sym_u8_SQUOTE] = ACTIONS(2626),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_L_DQUOTE] = ACTIONS(2626),
    [anon_sym_u_DQUOTE] = ACTIONS(2626),
    [anon_sym_U_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8_DQUOTE] = ACTIONS(2626),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [sym_true] = ACTIONS(2624),
    [sym_false] = ACTIONS(2624),
    [anon_sym_NULL] = ACTIONS(2624),
    [anon_sym_nullptr] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_delete] = ACTIONS(2624),
    [anon_sym_throw] = ACTIONS(2624),
    [anon_sym_namespace] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_concept] = ACTIONS(2624),
    [anon_sym_co_return] = ACTIONS(2624),
    [anon_sym_co_yield] = ACTIONS(2624),
    [anon_sym_R_DQUOTE] = ACTIONS(2626),
    [anon_sym_LR_DQUOTE] = ACTIONS(2626),
    [anon_sym_uR_DQUOTE] = ACTIONS(2626),
    [anon_sym_UR_DQUOTE] = ACTIONS(2626),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2626),
    [anon_sym_co_await] = ACTIONS(2624),
    [anon_sym_new] = ACTIONS(2624),
    [anon_sym_requires] = ACTIONS(2624),
    [sym_this] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(3031),
    [sym_identifier] = ACTIONS(3033),
    [aux_sym_preproc_include_token1] = ACTIONS(3033),
    [aux_sym_preproc_def_token1] = ACTIONS(3033),
    [aux_sym_preproc_if_token1] = ACTIONS(3033),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3033),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3033),
    [sym_preproc_directive] = ACTIONS(3033),
    [anon_sym_LPAREN2] = ACTIONS(3031),
    [anon_sym_BANG] = ACTIONS(3031),
    [anon_sym_TILDE] = ACTIONS(3031),
    [anon_sym_DASH] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_STAR] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_AMP] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym___extension__] = ACTIONS(3033),
    [anon_sym_typedef] = ACTIONS(3033),
    [anon_sym_in] = ACTIONS(3033),
    [anon_sym_out] = ACTIONS(3033),
    [anon_sym_inout] = ACTIONS(3033),
    [anon_sym_virtual] = ACTIONS(3033),
    [anon_sym_extern] = ACTIONS(3033),
    [anon_sym___attribute__] = ACTIONS(3033),
    [anon_sym___attribute] = ACTIONS(3033),
    [anon_sym_using] = ACTIONS(3033),
    [anon_sym_COLON_COLON] = ACTIONS(3031),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3031),
    [anon_sym___declspec] = ACTIONS(3033),
    [anon_sym___based] = ACTIONS(3033),
    [anon_sym___cdecl] = ACTIONS(3033),
    [anon_sym___clrcall] = ACTIONS(3033),
    [anon_sym___stdcall] = ACTIONS(3033),
    [anon_sym___fastcall] = ACTIONS(3033),
    [anon_sym___thiscall] = ACTIONS(3033),
    [anon_sym___vectorcall] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(3031),
    [anon_sym_signed] = ACTIONS(3033),
    [anon_sym_unsigned] = ACTIONS(3033),
    [anon_sym_long] = ACTIONS(3033),
    [anon_sym_short] = ACTIONS(3033),
    [anon_sym_LBRACK] = ACTIONS(3033),
    [anon_sym_static] = ACTIONS(3033),
    [anon_sym_register] = ACTIONS(3033),
    [anon_sym_inline] = ACTIONS(3033),
    [anon_sym___inline] = ACTIONS(3033),
    [anon_sym___inline__] = ACTIONS(3033),
    [anon_sym___forceinline] = ACTIONS(3033),
    [anon_sym_thread_local] = ACTIONS(3033),
    [anon_sym___thread] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_constexpr] = ACTIONS(3033),
    [anon_sym_volatile] = ACTIONS(3033),
    [anon_sym_restrict] = ACTIONS(3033),
    [anon_sym___restrict__] = ACTIONS(3033),
    [anon_sym__Atomic] = ACTIONS(3033),
    [anon_sym__Noreturn] = ACTIONS(3033),
    [anon_sym_noreturn] = ACTIONS(3033),
    [anon_sym__Nonnull] = ACTIONS(3033),
    [anon_sym_mutable] = ACTIONS(3033),
    [anon_sym_constinit] = ACTIONS(3033),
    [anon_sym_consteval] = ACTIONS(3033),
    [anon_sym_alignas] = ACTIONS(3033),
    [anon_sym__Alignas] = ACTIONS(3033),
    [sym_primitive_type] = ACTIONS(3033),
    [anon_sym_enum] = ACTIONS(3033),
    [anon_sym_class] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3033),
    [anon_sym_union] = ACTIONS(3033),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_switch] = ACTIONS(3033),
    [anon_sym_case] = ACTIONS(3033),
    [anon_sym_default] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [anon_sym_do] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_break] = ACTIONS(3033),
    [anon_sym_continue] = ACTIONS(3033),
    [anon_sym_goto] = ACTIONS(3033),
    [anon_sym_not] = ACTIONS(3033),
    [anon_sym_compl] = ACTIONS(3033),
    [anon_sym_DASH_DASH] = ACTIONS(3031),
    [anon_sym_PLUS_PLUS] = ACTIONS(3031),
    [anon_sym_sizeof] = ACTIONS(3033),
    [anon_sym___alignof__] = ACTIONS(3033),
    [anon_sym___alignof] = ACTIONS(3033),
    [anon_sym__alignof] = ACTIONS(3033),
    [anon_sym_alignof] = ACTIONS(3033),
    [anon_sym__Alignof] = ACTIONS(3033),
    [anon_sym_offsetof] = ACTIONS(3033),
    [anon_sym__Generic] = ACTIONS(3033),
    [anon_sym_asm] = ACTIONS(3033),
    [anon_sym___asm__] = ACTIONS(3033),
    [anon_sym___asm] = ACTIONS(3033),
    [sym_number_literal] = ACTIONS(3031),
    [anon_sym_L_SQUOTE] = ACTIONS(3031),
    [anon_sym_u_SQUOTE] = ACTIONS(3031),
    [anon_sym_U_SQUOTE] = ACTIONS(3031),
    [anon_sym_u8_SQUOTE] = ACTIONS(3031),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_L_DQUOTE] = ACTIONS(3031),
    [anon_sym_u_DQUOTE] = ACTIONS(3031),
    [anon_sym_U_DQUOTE] = ACTIONS(3031),
    [anon_sym_u8_DQUOTE] = ACTIONS(3031),
    [anon_sym_DQUOTE] = ACTIONS(3031),
    [sym_true] = ACTIONS(3033),
    [sym_false] = ACTIONS(3033),
    [anon_sym_NULL] = ACTIONS(3033),
    [anon_sym_nullptr] = ACTIONS(3033),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3033),
    [anon_sym_decltype] = ACTIONS(3033),
    [anon_sym_explicit] = ACTIONS(3033),
    [anon_sym_typename] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_template] = ACTIONS(3033),
    [anon_sym_operator] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_delete] = ACTIONS(3033),
    [anon_sym_throw] = ACTIONS(3033),
    [anon_sym_namespace] = ACTIONS(3033),
    [anon_sym_static_assert] = ACTIONS(3033),
    [anon_sym_concept] = ACTIONS(3033),
    [anon_sym_co_return] = ACTIONS(3033),
    [anon_sym_co_yield] = ACTIONS(3033),
    [anon_sym_R_DQUOTE] = ACTIONS(3031),
    [anon_sym_LR_DQUOTE] = ACTIONS(3031),
    [anon_sym_uR_DQUOTE] = ACTIONS(3031),
    [anon_sym_UR_DQUOTE] = ACTIONS(3031),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3031),
    [anon_sym_co_await] = ACTIONS(3033),
    [anon_sym_new] = ACTIONS(3033),
    [anon_sym_requires] = ACTIONS(3033),
    [sym_this] = ACTIONS(3033),
    [anon_sym_precise] = ACTIONS(3033),
    [anon_sym_shared] = ACTIONS(3033),
    [anon_sym_groupshared] = ACTIONS(3033),
    [anon_sym_uniform] = ACTIONS(3033),
    [anon_sym_row_major] = ACTIONS(3033),
    [anon_sym_column_major] = ACTIONS(3033),
    [anon_sym_globallycoherent] = ACTIONS(3033),
    [anon_sym_centroid] = ACTIONS(3033),
    [anon_sym_noperspective] = ACTIONS(3033),
    [anon_sym_nointerpolation] = ACTIONS(3033),
    [anon_sym_sample] = ACTIONS(3033),
    [anon_sym_linear] = ACTIONS(3033),
    [anon_sym_snorm] = ACTIONS(3033),
    [anon_sym_unorm] = ACTIONS(3033),
    [anon_sym_point] = ACTIONS(3033),
    [anon_sym_line] = ACTIONS(3033),
    [anon_sym_triangleadj] = ACTIONS(3033),
    [anon_sym_lineadj] = ACTIONS(3033),
    [anon_sym_triangle] = ACTIONS(3033),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2439),
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_include_token1] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_BANG] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym___cdecl] = ACTIONS(2437),
    [anon_sym___clrcall] = ACTIONS(2437),
    [anon_sym___stdcall] = ACTIONS(2437),
    [anon_sym___fastcall] = ACTIONS(2437),
    [anon_sym___thiscall] = ACTIONS(2437),
    [anon_sym___vectorcall] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_switch] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2437),
    [anon_sym_default] = ACTIONS(2437),
    [anon_sym_while] = ACTIONS(2437),
    [anon_sym_do] = ACTIONS(2437),
    [anon_sym_for] = ACTIONS(2437),
    [anon_sym_return] = ACTIONS(2437),
    [anon_sym_break] = ACTIONS(2437),
    [anon_sym_continue] = ACTIONS(2437),
    [anon_sym_goto] = ACTIONS(2437),
    [anon_sym_not] = ACTIONS(2437),
    [anon_sym_compl] = ACTIONS(2437),
    [anon_sym_DASH_DASH] = ACTIONS(2439),
    [anon_sym_PLUS_PLUS] = ACTIONS(2439),
    [anon_sym_sizeof] = ACTIONS(2437),
    [anon_sym___alignof__] = ACTIONS(2437),
    [anon_sym___alignof] = ACTIONS(2437),
    [anon_sym__alignof] = ACTIONS(2437),
    [anon_sym_alignof] = ACTIONS(2437),
    [anon_sym__Alignof] = ACTIONS(2437),
    [anon_sym_offsetof] = ACTIONS(2437),
    [anon_sym__Generic] = ACTIONS(2437),
    [anon_sym_asm] = ACTIONS(2437),
    [anon_sym___asm__] = ACTIONS(2437),
    [anon_sym___asm] = ACTIONS(2437),
    [sym_number_literal] = ACTIONS(2439),
    [anon_sym_L_SQUOTE] = ACTIONS(2439),
    [anon_sym_u_SQUOTE] = ACTIONS(2439),
    [anon_sym_U_SQUOTE] = ACTIONS(2439),
    [anon_sym_u8_SQUOTE] = ACTIONS(2439),
    [anon_sym_SQUOTE] = ACTIONS(2439),
    [anon_sym_L_DQUOTE] = ACTIONS(2439),
    [anon_sym_u_DQUOTE] = ACTIONS(2439),
    [anon_sym_U_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8_DQUOTE] = ACTIONS(2439),
    [anon_sym_DQUOTE] = ACTIONS(2439),
    [sym_true] = ACTIONS(2437),
    [sym_false] = ACTIONS(2437),
    [anon_sym_NULL] = ACTIONS(2437),
    [anon_sym_nullptr] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_export] = ACTIONS(2437),
    [anon_sym_module] = ACTIONS(2437),
    [anon_sym_import] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_try] = ACTIONS(2437),
    [anon_sym_delete] = ACTIONS(2437),
    [anon_sym_throw] = ACTIONS(2437),
    [anon_sym_namespace] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_concept] = ACTIONS(2437),
    [anon_sym_co_return] = ACTIONS(2437),
    [anon_sym_co_yield] = ACTIONS(2437),
    [anon_sym_R_DQUOTE] = ACTIONS(2439),
    [anon_sym_LR_DQUOTE] = ACTIONS(2439),
    [anon_sym_uR_DQUOTE] = ACTIONS(2439),
    [anon_sym_UR_DQUOTE] = ACTIONS(2439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2439),
    [anon_sym_co_await] = ACTIONS(2437),
    [anon_sym_new] = ACTIONS(2437),
    [anon_sym_requires] = ACTIONS(2437),
    [sym_this] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(2650),
    [sym_identifier] = ACTIONS(2648),
    [aux_sym_preproc_include_token1] = ACTIONS(2648),
    [aux_sym_preproc_def_token1] = ACTIONS(2648),
    [aux_sym_preproc_if_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2648),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2648),
    [sym_preproc_directive] = ACTIONS(2648),
    [anon_sym_LPAREN2] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_STAR] = ACTIONS(2650),
    [anon_sym_AMP_AMP] = ACTIONS(2650),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym___extension__] = ACTIONS(2648),
    [anon_sym_typedef] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_out] = ACTIONS(2648),
    [anon_sym_inout] = ACTIONS(2648),
    [anon_sym_virtual] = ACTIONS(2648),
    [anon_sym_extern] = ACTIONS(2648),
    [anon_sym___attribute__] = ACTIONS(2648),
    [anon_sym___attribute] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2650),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2650),
    [anon_sym___declspec] = ACTIONS(2648),
    [anon_sym___based] = ACTIONS(2648),
    [anon_sym___cdecl] = ACTIONS(2648),
    [anon_sym___clrcall] = ACTIONS(2648),
    [anon_sym___stdcall] = ACTIONS(2648),
    [anon_sym___fastcall] = ACTIONS(2648),
    [anon_sym___thiscall] = ACTIONS(2648),
    [anon_sym___vectorcall] = ACTIONS(2648),
    [anon_sym_LBRACE] = ACTIONS(2650),
    [anon_sym_signed] = ACTIONS(2648),
    [anon_sym_unsigned] = ACTIONS(2648),
    [anon_sym_long] = ACTIONS(2648),
    [anon_sym_short] = ACTIONS(2648),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2648),
    [anon_sym_register] = ACTIONS(2648),
    [anon_sym_inline] = ACTIONS(2648),
    [anon_sym___inline] = ACTIONS(2648),
    [anon_sym___inline__] = ACTIONS(2648),
    [anon_sym___forceinline] = ACTIONS(2648),
    [anon_sym_thread_local] = ACTIONS(2648),
    [anon_sym___thread] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_constexpr] = ACTIONS(2648),
    [anon_sym_volatile] = ACTIONS(2648),
    [anon_sym_restrict] = ACTIONS(2648),
    [anon_sym___restrict__] = ACTIONS(2648),
    [anon_sym__Atomic] = ACTIONS(2648),
    [anon_sym__Noreturn] = ACTIONS(2648),
    [anon_sym_noreturn] = ACTIONS(2648),
    [anon_sym__Nonnull] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_constinit] = ACTIONS(2648),
    [anon_sym_consteval] = ACTIONS(2648),
    [anon_sym_alignas] = ACTIONS(2648),
    [anon_sym__Alignas] = ACTIONS(2648),
    [sym_primitive_type] = ACTIONS(2648),
    [anon_sym_enum] = ACTIONS(2648),
    [anon_sym_class] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_union] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_switch] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2648),
    [anon_sym_default] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [anon_sym_do] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_break] = ACTIONS(2648),
    [anon_sym_continue] = ACTIONS(2648),
    [anon_sym_goto] = ACTIONS(2648),
    [anon_sym_not] = ACTIONS(2648),
    [anon_sym_compl] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2650),
    [anon_sym_sizeof] = ACTIONS(2648),
    [anon_sym___alignof__] = ACTIONS(2648),
    [anon_sym___alignof] = ACTIONS(2648),
    [anon_sym__alignof] = ACTIONS(2648),
    [anon_sym_alignof] = ACTIONS(2648),
    [anon_sym__Alignof] = ACTIONS(2648),
    [anon_sym_offsetof] = ACTIONS(2648),
    [anon_sym__Generic] = ACTIONS(2648),
    [anon_sym_asm] = ACTIONS(2648),
    [anon_sym___asm__] = ACTIONS(2648),
    [anon_sym___asm] = ACTIONS(2648),
    [sym_number_literal] = ACTIONS(2650),
    [anon_sym_L_SQUOTE] = ACTIONS(2650),
    [anon_sym_u_SQUOTE] = ACTIONS(2650),
    [anon_sym_U_SQUOTE] = ACTIONS(2650),
    [anon_sym_u8_SQUOTE] = ACTIONS(2650),
    [anon_sym_SQUOTE] = ACTIONS(2650),
    [anon_sym_L_DQUOTE] = ACTIONS(2650),
    [anon_sym_u_DQUOTE] = ACTIONS(2650),
    [anon_sym_U_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8_DQUOTE] = ACTIONS(2650),
    [anon_sym_DQUOTE] = ACTIONS(2650),
    [sym_true] = ACTIONS(2648),
    [sym_false] = ACTIONS(2648),
    [anon_sym_NULL] = ACTIONS(2648),
    [anon_sym_nullptr] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2648),
    [anon_sym_decltype] = ACTIONS(2648),
    [anon_sym_explicit] = ACTIONS(2648),
    [anon_sym_typename] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_template] = ACTIONS(2648),
    [anon_sym_operator] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_delete] = ACTIONS(2648),
    [anon_sym_throw] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2648),
    [anon_sym_static_assert] = ACTIONS(2648),
    [anon_sym_concept] = ACTIONS(2648),
    [anon_sym_co_return] = ACTIONS(2648),
    [anon_sym_co_yield] = ACTIONS(2648),
    [anon_sym_R_DQUOTE] = ACTIONS(2650),
    [anon_sym_LR_DQUOTE] = ACTIONS(2650),
    [anon_sym_uR_DQUOTE] = ACTIONS(2650),
    [anon_sym_UR_DQUOTE] = ACTIONS(2650),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2650),
    [anon_sym_co_await] = ACTIONS(2648),
    [anon_sym_new] = ACTIONS(2648),
    [anon_sym_requires] = ACTIONS(2648),
    [sym_this] = ACTIONS(2648),
    [anon_sym_precise] = ACTIONS(2648),
    [anon_sym_shared] = ACTIONS(2648),
    [anon_sym_groupshared] = ACTIONS(2648),
    [anon_sym_uniform] = ACTIONS(2648),
    [anon_sym_row_major] = ACTIONS(2648),
    [anon_sym_column_major] = ACTIONS(2648),
    [anon_sym_globallycoherent] = ACTIONS(2648),
    [anon_sym_centroid] = ACTIONS(2648),
    [anon_sym_noperspective] = ACTIONS(2648),
    [anon_sym_nointerpolation] = ACTIONS(2648),
    [anon_sym_sample] = ACTIONS(2648),
    [anon_sym_linear] = ACTIONS(2648),
    [anon_sym_snorm] = ACTIONS(2648),
    [anon_sym_unorm] = ACTIONS(2648),
    [anon_sym_point] = ACTIONS(2648),
    [anon_sym_line] = ACTIONS(2648),
    [anon_sym_triangleadj] = ACTIONS(2648),
    [anon_sym_lineadj] = ACTIONS(2648),
    [anon_sym_triangle] = ACTIONS(2648),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(3035),
    [sym_identifier] = ACTIONS(3037),
    [aux_sym_preproc_include_token1] = ACTIONS(3037),
    [aux_sym_preproc_def_token1] = ACTIONS(3037),
    [aux_sym_preproc_if_token1] = ACTIONS(3037),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3037),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3037),
    [sym_preproc_directive] = ACTIONS(3037),
    [anon_sym_LPAREN2] = ACTIONS(3035),
    [anon_sym_BANG] = ACTIONS(3035),
    [anon_sym_TILDE] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_STAR] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym___extension__] = ACTIONS(3037),
    [anon_sym_typedef] = ACTIONS(3037),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_out] = ACTIONS(3037),
    [anon_sym_inout] = ACTIONS(3037),
    [anon_sym_virtual] = ACTIONS(3037),
    [anon_sym_extern] = ACTIONS(3037),
    [anon_sym___attribute__] = ACTIONS(3037),
    [anon_sym___attribute] = ACTIONS(3037),
    [anon_sym_using] = ACTIONS(3037),
    [anon_sym_COLON_COLON] = ACTIONS(3035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3035),
    [anon_sym___declspec] = ACTIONS(3037),
    [anon_sym___based] = ACTIONS(3037),
    [anon_sym___cdecl] = ACTIONS(3037),
    [anon_sym___clrcall] = ACTIONS(3037),
    [anon_sym___stdcall] = ACTIONS(3037),
    [anon_sym___fastcall] = ACTIONS(3037),
    [anon_sym___thiscall] = ACTIONS(3037),
    [anon_sym___vectorcall] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3035),
    [anon_sym_signed] = ACTIONS(3037),
    [anon_sym_unsigned] = ACTIONS(3037),
    [anon_sym_long] = ACTIONS(3037),
    [anon_sym_short] = ACTIONS(3037),
    [anon_sym_LBRACK] = ACTIONS(3037),
    [anon_sym_static] = ACTIONS(3037),
    [anon_sym_register] = ACTIONS(3037),
    [anon_sym_inline] = ACTIONS(3037),
    [anon_sym___inline] = ACTIONS(3037),
    [anon_sym___inline__] = ACTIONS(3037),
    [anon_sym___forceinline] = ACTIONS(3037),
    [anon_sym_thread_local] = ACTIONS(3037),
    [anon_sym___thread] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3037),
    [anon_sym_constexpr] = ACTIONS(3037),
    [anon_sym_volatile] = ACTIONS(3037),
    [anon_sym_restrict] = ACTIONS(3037),
    [anon_sym___restrict__] = ACTIONS(3037),
    [anon_sym__Atomic] = ACTIONS(3037),
    [anon_sym__Noreturn] = ACTIONS(3037),
    [anon_sym_noreturn] = ACTIONS(3037),
    [anon_sym__Nonnull] = ACTIONS(3037),
    [anon_sym_mutable] = ACTIONS(3037),
    [anon_sym_constinit] = ACTIONS(3037),
    [anon_sym_consteval] = ACTIONS(3037),
    [anon_sym_alignas] = ACTIONS(3037),
    [anon_sym__Alignas] = ACTIONS(3037),
    [sym_primitive_type] = ACTIONS(3037),
    [anon_sym_enum] = ACTIONS(3037),
    [anon_sym_class] = ACTIONS(3037),
    [anon_sym_struct] = ACTIONS(3037),
    [anon_sym_union] = ACTIONS(3037),
    [anon_sym_if] = ACTIONS(3037),
    [anon_sym_switch] = ACTIONS(3037),
    [anon_sym_case] = ACTIONS(3037),
    [anon_sym_default] = ACTIONS(3037),
    [anon_sym_while] = ACTIONS(3037),
    [anon_sym_do] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3037),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_break] = ACTIONS(3037),
    [anon_sym_continue] = ACTIONS(3037),
    [anon_sym_goto] = ACTIONS(3037),
    [anon_sym_not] = ACTIONS(3037),
    [anon_sym_compl] = ACTIONS(3037),
    [anon_sym_DASH_DASH] = ACTIONS(3035),
    [anon_sym_PLUS_PLUS] = ACTIONS(3035),
    [anon_sym_sizeof] = ACTIONS(3037),
    [anon_sym___alignof__] = ACTIONS(3037),
    [anon_sym___alignof] = ACTIONS(3037),
    [anon_sym__alignof] = ACTIONS(3037),
    [anon_sym_alignof] = ACTIONS(3037),
    [anon_sym__Alignof] = ACTIONS(3037),
    [anon_sym_offsetof] = ACTIONS(3037),
    [anon_sym__Generic] = ACTIONS(3037),
    [anon_sym_asm] = ACTIONS(3037),
    [anon_sym___asm__] = ACTIONS(3037),
    [anon_sym___asm] = ACTIONS(3037),
    [sym_number_literal] = ACTIONS(3035),
    [anon_sym_L_SQUOTE] = ACTIONS(3035),
    [anon_sym_u_SQUOTE] = ACTIONS(3035),
    [anon_sym_U_SQUOTE] = ACTIONS(3035),
    [anon_sym_u8_SQUOTE] = ACTIONS(3035),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_L_DQUOTE] = ACTIONS(3035),
    [anon_sym_u_DQUOTE] = ACTIONS(3035),
    [anon_sym_U_DQUOTE] = ACTIONS(3035),
    [anon_sym_u8_DQUOTE] = ACTIONS(3035),
    [anon_sym_DQUOTE] = ACTIONS(3035),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [anon_sym_NULL] = ACTIONS(3037),
    [anon_sym_nullptr] = ACTIONS(3037),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3037),
    [anon_sym_decltype] = ACTIONS(3037),
    [anon_sym_explicit] = ACTIONS(3037),
    [anon_sym_typename] = ACTIONS(3037),
    [anon_sym_export] = ACTIONS(3037),
    [anon_sym_module] = ACTIONS(3037),
    [anon_sym_import] = ACTIONS(3037),
    [anon_sym_template] = ACTIONS(3037),
    [anon_sym_operator] = ACTIONS(3037),
    [anon_sym_try] = ACTIONS(3037),
    [anon_sym_delete] = ACTIONS(3037),
    [anon_sym_throw] = ACTIONS(3037),
    [anon_sym_namespace] = ACTIONS(3037),
    [anon_sym_static_assert] = ACTIONS(3037),
    [anon_sym_concept] = ACTIONS(3037),
    [anon_sym_co_return] = ACTIONS(3037),
    [anon_sym_co_yield] = ACTIONS(3037),
    [anon_sym_R_DQUOTE] = ACTIONS(3035),
    [anon_sym_LR_DQUOTE] = ACTIONS(3035),
    [anon_sym_uR_DQUOTE] = ACTIONS(3035),
    [anon_sym_UR_DQUOTE] = ACTIONS(3035),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3035),
    [anon_sym_co_await] = ACTIONS(3037),
    [anon_sym_new] = ACTIONS(3037),
    [anon_sym_requires] = ACTIONS(3037),
    [sym_this] = ACTIONS(3037),
    [anon_sym_precise] = ACTIONS(3037),
    [anon_sym_shared] = ACTIONS(3037),
    [anon_sym_groupshared] = ACTIONS(3037),
    [anon_sym_uniform] = ACTIONS(3037),
    [anon_sym_row_major] = ACTIONS(3037),
    [anon_sym_column_major] = ACTIONS(3037),
    [anon_sym_globallycoherent] = ACTIONS(3037),
    [anon_sym_centroid] = ACTIONS(3037),
    [anon_sym_noperspective] = ACTIONS(3037),
    [anon_sym_nointerpolation] = ACTIONS(3037),
    [anon_sym_sample] = ACTIONS(3037),
    [anon_sym_linear] = ACTIONS(3037),
    [anon_sym_snorm] = ACTIONS(3037),
    [anon_sym_unorm] = ACTIONS(3037),
    [anon_sym_point] = ACTIONS(3037),
    [anon_sym_line] = ACTIONS(3037),
    [anon_sym_triangleadj] = ACTIONS(3037),
    [anon_sym_lineadj] = ACTIONS(3037),
    [anon_sym_triangle] = ACTIONS(3037),
  },
  [758] = {
    [ts_builtin_sym_end] = ACTIONS(3039),
    [sym_identifier] = ACTIONS(3041),
    [aux_sym_preproc_include_token1] = ACTIONS(3041),
    [aux_sym_preproc_def_token1] = ACTIONS(3041),
    [aux_sym_preproc_if_token1] = ACTIONS(3041),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3041),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3041),
    [sym_preproc_directive] = ACTIONS(3041),
    [anon_sym_LPAREN2] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_STAR] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym___extension__] = ACTIONS(3041),
    [anon_sym_typedef] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_out] = ACTIONS(3041),
    [anon_sym_inout] = ACTIONS(3041),
    [anon_sym_virtual] = ACTIONS(3041),
    [anon_sym_extern] = ACTIONS(3041),
    [anon_sym___attribute__] = ACTIONS(3041),
    [anon_sym___attribute] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_COLON_COLON] = ACTIONS(3039),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3039),
    [anon_sym___declspec] = ACTIONS(3041),
    [anon_sym___based] = ACTIONS(3041),
    [anon_sym___cdecl] = ACTIONS(3041),
    [anon_sym___clrcall] = ACTIONS(3041),
    [anon_sym___stdcall] = ACTIONS(3041),
    [anon_sym___fastcall] = ACTIONS(3041),
    [anon_sym___thiscall] = ACTIONS(3041),
    [anon_sym___vectorcall] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_signed] = ACTIONS(3041),
    [anon_sym_unsigned] = ACTIONS(3041),
    [anon_sym_long] = ACTIONS(3041),
    [anon_sym_short] = ACTIONS(3041),
    [anon_sym_LBRACK] = ACTIONS(3041),
    [anon_sym_static] = ACTIONS(3041),
    [anon_sym_register] = ACTIONS(3041),
    [anon_sym_inline] = ACTIONS(3041),
    [anon_sym___inline] = ACTIONS(3041),
    [anon_sym___inline__] = ACTIONS(3041),
    [anon_sym___forceinline] = ACTIONS(3041),
    [anon_sym_thread_local] = ACTIONS(3041),
    [anon_sym___thread] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_constexpr] = ACTIONS(3041),
    [anon_sym_volatile] = ACTIONS(3041),
    [anon_sym_restrict] = ACTIONS(3041),
    [anon_sym___restrict__] = ACTIONS(3041),
    [anon_sym__Atomic] = ACTIONS(3041),
    [anon_sym__Noreturn] = ACTIONS(3041),
    [anon_sym_noreturn] = ACTIONS(3041),
    [anon_sym__Nonnull] = ACTIONS(3041),
    [anon_sym_mutable] = ACTIONS(3041),
    [anon_sym_constinit] = ACTIONS(3041),
    [anon_sym_consteval] = ACTIONS(3041),
    [anon_sym_alignas] = ACTIONS(3041),
    [anon_sym__Alignas] = ACTIONS(3041),
    [sym_primitive_type] = ACTIONS(3041),
    [anon_sym_enum] = ACTIONS(3041),
    [anon_sym_class] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_union] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_switch] = ACTIONS(3041),
    [anon_sym_case] = ACTIONS(3041),
    [anon_sym_default] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [anon_sym_do] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_break] = ACTIONS(3041),
    [anon_sym_continue] = ACTIONS(3041),
    [anon_sym_goto] = ACTIONS(3041),
    [anon_sym_not] = ACTIONS(3041),
    [anon_sym_compl] = ACTIONS(3041),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_sizeof] = ACTIONS(3041),
    [anon_sym___alignof__] = ACTIONS(3041),
    [anon_sym___alignof] = ACTIONS(3041),
    [anon_sym__alignof] = ACTIONS(3041),
    [anon_sym_alignof] = ACTIONS(3041),
    [anon_sym__Alignof] = ACTIONS(3041),
    [anon_sym_offsetof] = ACTIONS(3041),
    [anon_sym__Generic] = ACTIONS(3041),
    [anon_sym_asm] = ACTIONS(3041),
    [anon_sym___asm__] = ACTIONS(3041),
    [anon_sym___asm] = ACTIONS(3041),
    [sym_number_literal] = ACTIONS(3039),
    [anon_sym_L_SQUOTE] = ACTIONS(3039),
    [anon_sym_u_SQUOTE] = ACTIONS(3039),
    [anon_sym_U_SQUOTE] = ACTIONS(3039),
    [anon_sym_u8_SQUOTE] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3039),
    [anon_sym_L_DQUOTE] = ACTIONS(3039),
    [anon_sym_u_DQUOTE] = ACTIONS(3039),
    [anon_sym_U_DQUOTE] = ACTIONS(3039),
    [anon_sym_u8_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [anon_sym_NULL] = ACTIONS(3041),
    [anon_sym_nullptr] = ACTIONS(3041),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3041),
    [anon_sym_decltype] = ACTIONS(3041),
    [anon_sym_explicit] = ACTIONS(3041),
    [anon_sym_typename] = ACTIONS(3041),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_module] = ACTIONS(3041),
    [anon_sym_import] = ACTIONS(3041),
    [anon_sym_template] = ACTIONS(3041),
    [anon_sym_operator] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_delete] = ACTIONS(3041),
    [anon_sym_throw] = ACTIONS(3041),
    [anon_sym_namespace] = ACTIONS(3041),
    [anon_sym_static_assert] = ACTIONS(3041),
    [anon_sym_concept] = ACTIONS(3041),
    [anon_sym_co_return] = ACTIONS(3041),
    [anon_sym_co_yield] = ACTIONS(3041),
    [anon_sym_R_DQUOTE] = ACTIONS(3039),
    [anon_sym_LR_DQUOTE] = ACTIONS(3039),
    [anon_sym_uR_DQUOTE] = ACTIONS(3039),
    [anon_sym_UR_DQUOTE] = ACTIONS(3039),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3039),
    [anon_sym_co_await] = ACTIONS(3041),
    [anon_sym_new] = ACTIONS(3041),
    [anon_sym_requires] = ACTIONS(3041),
    [sym_this] = ACTIONS(3041),
    [anon_sym_precise] = ACTIONS(3041),
    [anon_sym_shared] = ACTIONS(3041),
    [anon_sym_groupshared] = ACTIONS(3041),
    [anon_sym_uniform] = ACTIONS(3041),
    [anon_sym_row_major] = ACTIONS(3041),
    [anon_sym_column_major] = ACTIONS(3041),
    [anon_sym_globallycoherent] = ACTIONS(3041),
    [anon_sym_centroid] = ACTIONS(3041),
    [anon_sym_noperspective] = ACTIONS(3041),
    [anon_sym_nointerpolation] = ACTIONS(3041),
    [anon_sym_sample] = ACTIONS(3041),
    [anon_sym_linear] = ACTIONS(3041),
    [anon_sym_snorm] = ACTIONS(3041),
    [anon_sym_unorm] = ACTIONS(3041),
    [anon_sym_point] = ACTIONS(3041),
    [anon_sym_line] = ACTIONS(3041),
    [anon_sym_triangleadj] = ACTIONS(3041),
    [anon_sym_lineadj] = ACTIONS(3041),
    [anon_sym_triangle] = ACTIONS(3041),
  },
  [759] = {
    [ts_builtin_sym_end] = ACTIONS(3043),
    [sym_identifier] = ACTIONS(3045),
    [aux_sym_preproc_include_token1] = ACTIONS(3045),
    [aux_sym_preproc_def_token1] = ACTIONS(3045),
    [aux_sym_preproc_if_token1] = ACTIONS(3045),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3045),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3045),
    [sym_preproc_directive] = ACTIONS(3045),
    [anon_sym_LPAREN2] = ACTIONS(3043),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym___extension__] = ACTIONS(3045),
    [anon_sym_typedef] = ACTIONS(3045),
    [anon_sym_in] = ACTIONS(3045),
    [anon_sym_out] = ACTIONS(3045),
    [anon_sym_inout] = ACTIONS(3045),
    [anon_sym_virtual] = ACTIONS(3045),
    [anon_sym_extern] = ACTIONS(3045),
    [anon_sym___attribute__] = ACTIONS(3045),
    [anon_sym___attribute] = ACTIONS(3045),
    [anon_sym_using] = ACTIONS(3045),
    [anon_sym_COLON_COLON] = ACTIONS(3043),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3043),
    [anon_sym___declspec] = ACTIONS(3045),
    [anon_sym___based] = ACTIONS(3045),
    [anon_sym___cdecl] = ACTIONS(3045),
    [anon_sym___clrcall] = ACTIONS(3045),
    [anon_sym___stdcall] = ACTIONS(3045),
    [anon_sym___fastcall] = ACTIONS(3045),
    [anon_sym___thiscall] = ACTIONS(3045),
    [anon_sym___vectorcall] = ACTIONS(3045),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_signed] = ACTIONS(3045),
    [anon_sym_unsigned] = ACTIONS(3045),
    [anon_sym_long] = ACTIONS(3045),
    [anon_sym_short] = ACTIONS(3045),
    [anon_sym_LBRACK] = ACTIONS(3045),
    [anon_sym_static] = ACTIONS(3045),
    [anon_sym_register] = ACTIONS(3045),
    [anon_sym_inline] = ACTIONS(3045),
    [anon_sym___inline] = ACTIONS(3045),
    [anon_sym___inline__] = ACTIONS(3045),
    [anon_sym___forceinline] = ACTIONS(3045),
    [anon_sym_thread_local] = ACTIONS(3045),
    [anon_sym___thread] = ACTIONS(3045),
    [anon_sym_const] = ACTIONS(3045),
    [anon_sym_constexpr] = ACTIONS(3045),
    [anon_sym_volatile] = ACTIONS(3045),
    [anon_sym_restrict] = ACTIONS(3045),
    [anon_sym___restrict__] = ACTIONS(3045),
    [anon_sym__Atomic] = ACTIONS(3045),
    [anon_sym__Noreturn] = ACTIONS(3045),
    [anon_sym_noreturn] = ACTIONS(3045),
    [anon_sym__Nonnull] = ACTIONS(3045),
    [anon_sym_mutable] = ACTIONS(3045),
    [anon_sym_constinit] = ACTIONS(3045),
    [anon_sym_consteval] = ACTIONS(3045),
    [anon_sym_alignas] = ACTIONS(3045),
    [anon_sym__Alignas] = ACTIONS(3045),
    [sym_primitive_type] = ACTIONS(3045),
    [anon_sym_enum] = ACTIONS(3045),
    [anon_sym_class] = ACTIONS(3045),
    [anon_sym_struct] = ACTIONS(3045),
    [anon_sym_union] = ACTIONS(3045),
    [anon_sym_if] = ACTIONS(3045),
    [anon_sym_switch] = ACTIONS(3045),
    [anon_sym_case] = ACTIONS(3045),
    [anon_sym_default] = ACTIONS(3045),
    [anon_sym_while] = ACTIONS(3045),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_for] = ACTIONS(3045),
    [anon_sym_return] = ACTIONS(3045),
    [anon_sym_break] = ACTIONS(3045),
    [anon_sym_continue] = ACTIONS(3045),
    [anon_sym_goto] = ACTIONS(3045),
    [anon_sym_not] = ACTIONS(3045),
    [anon_sym_compl] = ACTIONS(3045),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_sizeof] = ACTIONS(3045),
    [anon_sym___alignof__] = ACTIONS(3045),
    [anon_sym___alignof] = ACTIONS(3045),
    [anon_sym__alignof] = ACTIONS(3045),
    [anon_sym_alignof] = ACTIONS(3045),
    [anon_sym__Alignof] = ACTIONS(3045),
    [anon_sym_offsetof] = ACTIONS(3045),
    [anon_sym__Generic] = ACTIONS(3045),
    [anon_sym_asm] = ACTIONS(3045),
    [anon_sym___asm__] = ACTIONS(3045),
    [anon_sym___asm] = ACTIONS(3045),
    [sym_number_literal] = ACTIONS(3043),
    [anon_sym_L_SQUOTE] = ACTIONS(3043),
    [anon_sym_u_SQUOTE] = ACTIONS(3043),
    [anon_sym_U_SQUOTE] = ACTIONS(3043),
    [anon_sym_u8_SQUOTE] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_L_DQUOTE] = ACTIONS(3043),
    [anon_sym_u_DQUOTE] = ACTIONS(3043),
    [anon_sym_U_DQUOTE] = ACTIONS(3043),
    [anon_sym_u8_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [anon_sym_NULL] = ACTIONS(3045),
    [anon_sym_nullptr] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3045),
    [anon_sym_decltype] = ACTIONS(3045),
    [anon_sym_explicit] = ACTIONS(3045),
    [anon_sym_typename] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(3045),
    [anon_sym_module] = ACTIONS(3045),
    [anon_sym_import] = ACTIONS(3045),
    [anon_sym_template] = ACTIONS(3045),
    [anon_sym_operator] = ACTIONS(3045),
    [anon_sym_try] = ACTIONS(3045),
    [anon_sym_delete] = ACTIONS(3045),
    [anon_sym_throw] = ACTIONS(3045),
    [anon_sym_namespace] = ACTIONS(3045),
    [anon_sym_static_assert] = ACTIONS(3045),
    [anon_sym_concept] = ACTIONS(3045),
    [anon_sym_co_return] = ACTIONS(3045),
    [anon_sym_co_yield] = ACTIONS(3045),
    [anon_sym_R_DQUOTE] = ACTIONS(3043),
    [anon_sym_LR_DQUOTE] = ACTIONS(3043),
    [anon_sym_uR_DQUOTE] = ACTIONS(3043),
    [anon_sym_UR_DQUOTE] = ACTIONS(3043),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3043),
    [anon_sym_co_await] = ACTIONS(3045),
    [anon_sym_new] = ACTIONS(3045),
    [anon_sym_requires] = ACTIONS(3045),
    [sym_this] = ACTIONS(3045),
    [anon_sym_precise] = ACTIONS(3045),
    [anon_sym_shared] = ACTIONS(3045),
    [anon_sym_groupshared] = ACTIONS(3045),
    [anon_sym_uniform] = ACTIONS(3045),
    [anon_sym_row_major] = ACTIONS(3045),
    [anon_sym_column_major] = ACTIONS(3045),
    [anon_sym_globallycoherent] = ACTIONS(3045),
    [anon_sym_centroid] = ACTIONS(3045),
    [anon_sym_noperspective] = ACTIONS(3045),
    [anon_sym_nointerpolation] = ACTIONS(3045),
    [anon_sym_sample] = ACTIONS(3045),
    [anon_sym_linear] = ACTIONS(3045),
    [anon_sym_snorm] = ACTIONS(3045),
    [anon_sym_unorm] = ACTIONS(3045),
    [anon_sym_point] = ACTIONS(3045),
    [anon_sym_line] = ACTIONS(3045),
    [anon_sym_triangleadj] = ACTIONS(3045),
    [anon_sym_lineadj] = ACTIONS(3045),
    [anon_sym_triangle] = ACTIONS(3045),
  },
  [760] = {
    [ts_builtin_sym_end] = ACTIONS(3047),
    [sym_identifier] = ACTIONS(3049),
    [aux_sym_preproc_include_token1] = ACTIONS(3049),
    [aux_sym_preproc_def_token1] = ACTIONS(3049),
    [aux_sym_preproc_if_token1] = ACTIONS(3049),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3049),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3049),
    [sym_preproc_directive] = ACTIONS(3049),
    [anon_sym_LPAREN2] = ACTIONS(3047),
    [anon_sym_BANG] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym___extension__] = ACTIONS(3049),
    [anon_sym_typedef] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_out] = ACTIONS(3049),
    [anon_sym_inout] = ACTIONS(3049),
    [anon_sym_virtual] = ACTIONS(3049),
    [anon_sym_extern] = ACTIONS(3049),
    [anon_sym___attribute__] = ACTIONS(3049),
    [anon_sym___attribute] = ACTIONS(3049),
    [anon_sym_using] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3047),
    [anon_sym___declspec] = ACTIONS(3049),
    [anon_sym___based] = ACTIONS(3049),
    [anon_sym___cdecl] = ACTIONS(3049),
    [anon_sym___clrcall] = ACTIONS(3049),
    [anon_sym___stdcall] = ACTIONS(3049),
    [anon_sym___fastcall] = ACTIONS(3049),
    [anon_sym___thiscall] = ACTIONS(3049),
    [anon_sym___vectorcall] = ACTIONS(3049),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_signed] = ACTIONS(3049),
    [anon_sym_unsigned] = ACTIONS(3049),
    [anon_sym_long] = ACTIONS(3049),
    [anon_sym_short] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3049),
    [anon_sym_static] = ACTIONS(3049),
    [anon_sym_register] = ACTIONS(3049),
    [anon_sym_inline] = ACTIONS(3049),
    [anon_sym___inline] = ACTIONS(3049),
    [anon_sym___inline__] = ACTIONS(3049),
    [anon_sym___forceinline] = ACTIONS(3049),
    [anon_sym_thread_local] = ACTIONS(3049),
    [anon_sym___thread] = ACTIONS(3049),
    [anon_sym_const] = ACTIONS(3049),
    [anon_sym_constexpr] = ACTIONS(3049),
    [anon_sym_volatile] = ACTIONS(3049),
    [anon_sym_restrict] = ACTIONS(3049),
    [anon_sym___restrict__] = ACTIONS(3049),
    [anon_sym__Atomic] = ACTIONS(3049),
    [anon_sym__Noreturn] = ACTIONS(3049),
    [anon_sym_noreturn] = ACTIONS(3049),
    [anon_sym__Nonnull] = ACTIONS(3049),
    [anon_sym_mutable] = ACTIONS(3049),
    [anon_sym_constinit] = ACTIONS(3049),
    [anon_sym_consteval] = ACTIONS(3049),
    [anon_sym_alignas] = ACTIONS(3049),
    [anon_sym__Alignas] = ACTIONS(3049),
    [sym_primitive_type] = ACTIONS(3049),
    [anon_sym_enum] = ACTIONS(3049),
    [anon_sym_class] = ACTIONS(3049),
    [anon_sym_struct] = ACTIONS(3049),
    [anon_sym_union] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3049),
    [anon_sym_switch] = ACTIONS(3049),
    [anon_sym_case] = ACTIONS(3049),
    [anon_sym_default] = ACTIONS(3049),
    [anon_sym_while] = ACTIONS(3049),
    [anon_sym_do] = ACTIONS(3049),
    [anon_sym_for] = ACTIONS(3049),
    [anon_sym_return] = ACTIONS(3049),
    [anon_sym_break] = ACTIONS(3049),
    [anon_sym_continue] = ACTIONS(3049),
    [anon_sym_goto] = ACTIONS(3049),
    [anon_sym_not] = ACTIONS(3049),
    [anon_sym_compl] = ACTIONS(3049),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_sizeof] = ACTIONS(3049),
    [anon_sym___alignof__] = ACTIONS(3049),
    [anon_sym___alignof] = ACTIONS(3049),
    [anon_sym__alignof] = ACTIONS(3049),
    [anon_sym_alignof] = ACTIONS(3049),
    [anon_sym__Alignof] = ACTIONS(3049),
    [anon_sym_offsetof] = ACTIONS(3049),
    [anon_sym__Generic] = ACTIONS(3049),
    [anon_sym_asm] = ACTIONS(3049),
    [anon_sym___asm__] = ACTIONS(3049),
    [anon_sym___asm] = ACTIONS(3049),
    [sym_number_literal] = ACTIONS(3047),
    [anon_sym_L_SQUOTE] = ACTIONS(3047),
    [anon_sym_u_SQUOTE] = ACTIONS(3047),
    [anon_sym_U_SQUOTE] = ACTIONS(3047),
    [anon_sym_u8_SQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_L_DQUOTE] = ACTIONS(3047),
    [anon_sym_u_DQUOTE] = ACTIONS(3047),
    [anon_sym_U_DQUOTE] = ACTIONS(3047),
    [anon_sym_u8_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [anon_sym_NULL] = ACTIONS(3049),
    [anon_sym_nullptr] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3049),
    [anon_sym_decltype] = ACTIONS(3049),
    [anon_sym_explicit] = ACTIONS(3049),
    [anon_sym_typename] = ACTIONS(3049),
    [anon_sym_export] = ACTIONS(3049),
    [anon_sym_module] = ACTIONS(3049),
    [anon_sym_import] = ACTIONS(3049),
    [anon_sym_template] = ACTIONS(3049),
    [anon_sym_operator] = ACTIONS(3049),
    [anon_sym_try] = ACTIONS(3049),
    [anon_sym_delete] = ACTIONS(3049),
    [anon_sym_throw] = ACTIONS(3049),
    [anon_sym_namespace] = ACTIONS(3049),
    [anon_sym_static_assert] = ACTIONS(3049),
    [anon_sym_concept] = ACTIONS(3049),
    [anon_sym_co_return] = ACTIONS(3049),
    [anon_sym_co_yield] = ACTIONS(3049),
    [anon_sym_R_DQUOTE] = ACTIONS(3047),
    [anon_sym_LR_DQUOTE] = ACTIONS(3047),
    [anon_sym_uR_DQUOTE] = ACTIONS(3047),
    [anon_sym_UR_DQUOTE] = ACTIONS(3047),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3047),
    [anon_sym_co_await] = ACTIONS(3049),
    [anon_sym_new] = ACTIONS(3049),
    [anon_sym_requires] = ACTIONS(3049),
    [sym_this] = ACTIONS(3049),
    [anon_sym_precise] = ACTIONS(3049),
    [anon_sym_shared] = ACTIONS(3049),
    [anon_sym_groupshared] = ACTIONS(3049),
    [anon_sym_uniform] = ACTIONS(3049),
    [anon_sym_row_major] = ACTIONS(3049),
    [anon_sym_column_major] = ACTIONS(3049),
    [anon_sym_globallycoherent] = ACTIONS(3049),
    [anon_sym_centroid] = ACTIONS(3049),
    [anon_sym_noperspective] = ACTIONS(3049),
    [anon_sym_nointerpolation] = ACTIONS(3049),
    [anon_sym_sample] = ACTIONS(3049),
    [anon_sym_linear] = ACTIONS(3049),
    [anon_sym_snorm] = ACTIONS(3049),
    [anon_sym_unorm] = ACTIONS(3049),
    [anon_sym_point] = ACTIONS(3049),
    [anon_sym_line] = ACTIONS(3049),
    [anon_sym_triangleadj] = ACTIONS(3049),
    [anon_sym_lineadj] = ACTIONS(3049),
    [anon_sym_triangle] = ACTIONS(3049),
  },
  [761] = {
    [ts_builtin_sym_end] = ACTIONS(3051),
    [sym_identifier] = ACTIONS(3053),
    [aux_sym_preproc_include_token1] = ACTIONS(3053),
    [aux_sym_preproc_def_token1] = ACTIONS(3053),
    [aux_sym_preproc_if_token1] = ACTIONS(3053),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3053),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3053),
    [sym_preproc_directive] = ACTIONS(3053),
    [anon_sym_LPAREN2] = ACTIONS(3051),
    [anon_sym_BANG] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_STAR] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym___extension__] = ACTIONS(3053),
    [anon_sym_typedef] = ACTIONS(3053),
    [anon_sym_in] = ACTIONS(3053),
    [anon_sym_out] = ACTIONS(3053),
    [anon_sym_inout] = ACTIONS(3053),
    [anon_sym_virtual] = ACTIONS(3053),
    [anon_sym_extern] = ACTIONS(3053),
    [anon_sym___attribute__] = ACTIONS(3053),
    [anon_sym___attribute] = ACTIONS(3053),
    [anon_sym_using] = ACTIONS(3053),
    [anon_sym_COLON_COLON] = ACTIONS(3051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3051),
    [anon_sym___declspec] = ACTIONS(3053),
    [anon_sym___based] = ACTIONS(3053),
    [anon_sym___cdecl] = ACTIONS(3053),
    [anon_sym___clrcall] = ACTIONS(3053),
    [anon_sym___stdcall] = ACTIONS(3053),
    [anon_sym___fastcall] = ACTIONS(3053),
    [anon_sym___thiscall] = ACTIONS(3053),
    [anon_sym___vectorcall] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_signed] = ACTIONS(3053),
    [anon_sym_unsigned] = ACTIONS(3053),
    [anon_sym_long] = ACTIONS(3053),
    [anon_sym_short] = ACTIONS(3053),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_static] = ACTIONS(3053),
    [anon_sym_register] = ACTIONS(3053),
    [anon_sym_inline] = ACTIONS(3053),
    [anon_sym___inline] = ACTIONS(3053),
    [anon_sym___inline__] = ACTIONS(3053),
    [anon_sym___forceinline] = ACTIONS(3053),
    [anon_sym_thread_local] = ACTIONS(3053),
    [anon_sym___thread] = ACTIONS(3053),
    [anon_sym_const] = ACTIONS(3053),
    [anon_sym_constexpr] = ACTIONS(3053),
    [anon_sym_volatile] = ACTIONS(3053),
    [anon_sym_restrict] = ACTIONS(3053),
    [anon_sym___restrict__] = ACTIONS(3053),
    [anon_sym__Atomic] = ACTIONS(3053),
    [anon_sym__Noreturn] = ACTIONS(3053),
    [anon_sym_noreturn] = ACTIONS(3053),
    [anon_sym__Nonnull] = ACTIONS(3053),
    [anon_sym_mutable] = ACTIONS(3053),
    [anon_sym_constinit] = ACTIONS(3053),
    [anon_sym_consteval] = ACTIONS(3053),
    [anon_sym_alignas] = ACTIONS(3053),
    [anon_sym__Alignas] = ACTIONS(3053),
    [sym_primitive_type] = ACTIONS(3053),
    [anon_sym_enum] = ACTIONS(3053),
    [anon_sym_class] = ACTIONS(3053),
    [anon_sym_struct] = ACTIONS(3053),
    [anon_sym_union] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3053),
    [anon_sym_switch] = ACTIONS(3053),
    [anon_sym_case] = ACTIONS(3053),
    [anon_sym_default] = ACTIONS(3053),
    [anon_sym_while] = ACTIONS(3053),
    [anon_sym_do] = ACTIONS(3053),
    [anon_sym_for] = ACTIONS(3053),
    [anon_sym_return] = ACTIONS(3053),
    [anon_sym_break] = ACTIONS(3053),
    [anon_sym_continue] = ACTIONS(3053),
    [anon_sym_goto] = ACTIONS(3053),
    [anon_sym_not] = ACTIONS(3053),
    [anon_sym_compl] = ACTIONS(3053),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_sizeof] = ACTIONS(3053),
    [anon_sym___alignof__] = ACTIONS(3053),
    [anon_sym___alignof] = ACTIONS(3053),
    [anon_sym__alignof] = ACTIONS(3053),
    [anon_sym_alignof] = ACTIONS(3053),
    [anon_sym__Alignof] = ACTIONS(3053),
    [anon_sym_offsetof] = ACTIONS(3053),
    [anon_sym__Generic] = ACTIONS(3053),
    [anon_sym_asm] = ACTIONS(3053),
    [anon_sym___asm__] = ACTIONS(3053),
    [anon_sym___asm] = ACTIONS(3053),
    [sym_number_literal] = ACTIONS(3051),
    [anon_sym_L_SQUOTE] = ACTIONS(3051),
    [anon_sym_u_SQUOTE] = ACTIONS(3051),
    [anon_sym_U_SQUOTE] = ACTIONS(3051),
    [anon_sym_u8_SQUOTE] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_L_DQUOTE] = ACTIONS(3051),
    [anon_sym_u_DQUOTE] = ACTIONS(3051),
    [anon_sym_U_DQUOTE] = ACTIONS(3051),
    [anon_sym_u8_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [sym_true] = ACTIONS(3053),
    [sym_false] = ACTIONS(3053),
    [anon_sym_NULL] = ACTIONS(3053),
    [anon_sym_nullptr] = ACTIONS(3053),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3053),
    [anon_sym_decltype] = ACTIONS(3053),
    [anon_sym_explicit] = ACTIONS(3053),
    [anon_sym_typename] = ACTIONS(3053),
    [anon_sym_export] = ACTIONS(3053),
    [anon_sym_module] = ACTIONS(3053),
    [anon_sym_import] = ACTIONS(3053),
    [anon_sym_template] = ACTIONS(3053),
    [anon_sym_operator] = ACTIONS(3053),
    [anon_sym_try] = ACTIONS(3053),
    [anon_sym_delete] = ACTIONS(3053),
    [anon_sym_throw] = ACTIONS(3053),
    [anon_sym_namespace] = ACTIONS(3053),
    [anon_sym_static_assert] = ACTIONS(3053),
    [anon_sym_concept] = ACTIONS(3053),
    [anon_sym_co_return] = ACTIONS(3053),
    [anon_sym_co_yield] = ACTIONS(3053),
    [anon_sym_R_DQUOTE] = ACTIONS(3051),
    [anon_sym_LR_DQUOTE] = ACTIONS(3051),
    [anon_sym_uR_DQUOTE] = ACTIONS(3051),
    [anon_sym_UR_DQUOTE] = ACTIONS(3051),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3051),
    [anon_sym_co_await] = ACTIONS(3053),
    [anon_sym_new] = ACTIONS(3053),
    [anon_sym_requires] = ACTIONS(3053),
    [sym_this] = ACTIONS(3053),
    [anon_sym_precise] = ACTIONS(3053),
    [anon_sym_shared] = ACTIONS(3053),
    [anon_sym_groupshared] = ACTIONS(3053),
    [anon_sym_uniform] = ACTIONS(3053),
    [anon_sym_row_major] = ACTIONS(3053),
    [anon_sym_column_major] = ACTIONS(3053),
    [anon_sym_globallycoherent] = ACTIONS(3053),
    [anon_sym_centroid] = ACTIONS(3053),
    [anon_sym_noperspective] = ACTIONS(3053),
    [anon_sym_nointerpolation] = ACTIONS(3053),
    [anon_sym_sample] = ACTIONS(3053),
    [anon_sym_linear] = ACTIONS(3053),
    [anon_sym_snorm] = ACTIONS(3053),
    [anon_sym_unorm] = ACTIONS(3053),
    [anon_sym_point] = ACTIONS(3053),
    [anon_sym_line] = ACTIONS(3053),
    [anon_sym_triangleadj] = ACTIONS(3053),
    [anon_sym_lineadj] = ACTIONS(3053),
    [anon_sym_triangle] = ACTIONS(3053),
  },
  [762] = {
    [ts_builtin_sym_end] = ACTIONS(3055),
    [sym_identifier] = ACTIONS(3057),
    [aux_sym_preproc_include_token1] = ACTIONS(3057),
    [aux_sym_preproc_def_token1] = ACTIONS(3057),
    [aux_sym_preproc_if_token1] = ACTIONS(3057),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3057),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3057),
    [sym_preproc_directive] = ACTIONS(3057),
    [anon_sym_LPAREN2] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym___extension__] = ACTIONS(3057),
    [anon_sym_typedef] = ACTIONS(3057),
    [anon_sym_in] = ACTIONS(3057),
    [anon_sym_out] = ACTIONS(3057),
    [anon_sym_inout] = ACTIONS(3057),
    [anon_sym_virtual] = ACTIONS(3057),
    [anon_sym_extern] = ACTIONS(3057),
    [anon_sym___attribute__] = ACTIONS(3057),
    [anon_sym___attribute] = ACTIONS(3057),
    [anon_sym_using] = ACTIONS(3057),
    [anon_sym_COLON_COLON] = ACTIONS(3055),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3055),
    [anon_sym___declspec] = ACTIONS(3057),
    [anon_sym___based] = ACTIONS(3057),
    [anon_sym___cdecl] = ACTIONS(3057),
    [anon_sym___clrcall] = ACTIONS(3057),
    [anon_sym___stdcall] = ACTIONS(3057),
    [anon_sym___fastcall] = ACTIONS(3057),
    [anon_sym___thiscall] = ACTIONS(3057),
    [anon_sym___vectorcall] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_signed] = ACTIONS(3057),
    [anon_sym_unsigned] = ACTIONS(3057),
    [anon_sym_long] = ACTIONS(3057),
    [anon_sym_short] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3057),
    [anon_sym_static] = ACTIONS(3057),
    [anon_sym_register] = ACTIONS(3057),
    [anon_sym_inline] = ACTIONS(3057),
    [anon_sym___inline] = ACTIONS(3057),
    [anon_sym___inline__] = ACTIONS(3057),
    [anon_sym___forceinline] = ACTIONS(3057),
    [anon_sym_thread_local] = ACTIONS(3057),
    [anon_sym___thread] = ACTIONS(3057),
    [anon_sym_const] = ACTIONS(3057),
    [anon_sym_constexpr] = ACTIONS(3057),
    [anon_sym_volatile] = ACTIONS(3057),
    [anon_sym_restrict] = ACTIONS(3057),
    [anon_sym___restrict__] = ACTIONS(3057),
    [anon_sym__Atomic] = ACTIONS(3057),
    [anon_sym__Noreturn] = ACTIONS(3057),
    [anon_sym_noreturn] = ACTIONS(3057),
    [anon_sym__Nonnull] = ACTIONS(3057),
    [anon_sym_mutable] = ACTIONS(3057),
    [anon_sym_constinit] = ACTIONS(3057),
    [anon_sym_consteval] = ACTIONS(3057),
    [anon_sym_alignas] = ACTIONS(3057),
    [anon_sym__Alignas] = ACTIONS(3057),
    [sym_primitive_type] = ACTIONS(3057),
    [anon_sym_enum] = ACTIONS(3057),
    [anon_sym_class] = ACTIONS(3057),
    [anon_sym_struct] = ACTIONS(3057),
    [anon_sym_union] = ACTIONS(3057),
    [anon_sym_if] = ACTIONS(3057),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_case] = ACTIONS(3057),
    [anon_sym_default] = ACTIONS(3057),
    [anon_sym_while] = ACTIONS(3057),
    [anon_sym_do] = ACTIONS(3057),
    [anon_sym_for] = ACTIONS(3057),
    [anon_sym_return] = ACTIONS(3057),
    [anon_sym_break] = ACTIONS(3057),
    [anon_sym_continue] = ACTIONS(3057),
    [anon_sym_goto] = ACTIONS(3057),
    [anon_sym_not] = ACTIONS(3057),
    [anon_sym_compl] = ACTIONS(3057),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_sizeof] = ACTIONS(3057),
    [anon_sym___alignof__] = ACTIONS(3057),
    [anon_sym___alignof] = ACTIONS(3057),
    [anon_sym__alignof] = ACTIONS(3057),
    [anon_sym_alignof] = ACTIONS(3057),
    [anon_sym__Alignof] = ACTIONS(3057),
    [anon_sym_offsetof] = ACTIONS(3057),
    [anon_sym__Generic] = ACTIONS(3057),
    [anon_sym_asm] = ACTIONS(3057),
    [anon_sym___asm__] = ACTIONS(3057),
    [anon_sym___asm] = ACTIONS(3057),
    [sym_number_literal] = ACTIONS(3055),
    [anon_sym_L_SQUOTE] = ACTIONS(3055),
    [anon_sym_u_SQUOTE] = ACTIONS(3055),
    [anon_sym_U_SQUOTE] = ACTIONS(3055),
    [anon_sym_u8_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_L_DQUOTE] = ACTIONS(3055),
    [anon_sym_u_DQUOTE] = ACTIONS(3055),
    [anon_sym_U_DQUOTE] = ACTIONS(3055),
    [anon_sym_u8_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [sym_true] = ACTIONS(3057),
    [sym_false] = ACTIONS(3057),
    [anon_sym_NULL] = ACTIONS(3057),
    [anon_sym_nullptr] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3057),
    [anon_sym_decltype] = ACTIONS(3057),
    [anon_sym_explicit] = ACTIONS(3057),
    [anon_sym_typename] = ACTIONS(3057),
    [anon_sym_export] = ACTIONS(3057),
    [anon_sym_module] = ACTIONS(3057),
    [anon_sym_import] = ACTIONS(3057),
    [anon_sym_template] = ACTIONS(3057),
    [anon_sym_operator] = ACTIONS(3057),
    [anon_sym_try] = ACTIONS(3057),
    [anon_sym_delete] = ACTIONS(3057),
    [anon_sym_throw] = ACTIONS(3057),
    [anon_sym_namespace] = ACTIONS(3057),
    [anon_sym_static_assert] = ACTIONS(3057),
    [anon_sym_concept] = ACTIONS(3057),
    [anon_sym_co_return] = ACTIONS(3057),
    [anon_sym_co_yield] = ACTIONS(3057),
    [anon_sym_R_DQUOTE] = ACTIONS(3055),
    [anon_sym_LR_DQUOTE] = ACTIONS(3055),
    [anon_sym_uR_DQUOTE] = ACTIONS(3055),
    [anon_sym_UR_DQUOTE] = ACTIONS(3055),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3055),
    [anon_sym_co_await] = ACTIONS(3057),
    [anon_sym_new] = ACTIONS(3057),
    [anon_sym_requires] = ACTIONS(3057),
    [sym_this] = ACTIONS(3057),
    [anon_sym_precise] = ACTIONS(3057),
    [anon_sym_shared] = ACTIONS(3057),
    [anon_sym_groupshared] = ACTIONS(3057),
    [anon_sym_uniform] = ACTIONS(3057),
    [anon_sym_row_major] = ACTIONS(3057),
    [anon_sym_column_major] = ACTIONS(3057),
    [anon_sym_globallycoherent] = ACTIONS(3057),
    [anon_sym_centroid] = ACTIONS(3057),
    [anon_sym_noperspective] = ACTIONS(3057),
    [anon_sym_nointerpolation] = ACTIONS(3057),
    [anon_sym_sample] = ACTIONS(3057),
    [anon_sym_linear] = ACTIONS(3057),
    [anon_sym_snorm] = ACTIONS(3057),
    [anon_sym_unorm] = ACTIONS(3057),
    [anon_sym_point] = ACTIONS(3057),
    [anon_sym_line] = ACTIONS(3057),
    [anon_sym_triangleadj] = ACTIONS(3057),
    [anon_sym_lineadj] = ACTIONS(3057),
    [anon_sym_triangle] = ACTIONS(3057),
  },
  [763] = {
    [ts_builtin_sym_end] = ACTIONS(2682),
    [sym_identifier] = ACTIONS(2680),
    [aux_sym_preproc_include_token1] = ACTIONS(2680),
    [aux_sym_preproc_def_token1] = ACTIONS(2680),
    [aux_sym_preproc_if_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2680),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2680),
    [sym_preproc_directive] = ACTIONS(2680),
    [anon_sym_LPAREN2] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2680),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_AMP] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym___extension__] = ACTIONS(2680),
    [anon_sym_typedef] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2680),
    [anon_sym_out] = ACTIONS(2680),
    [anon_sym_inout] = ACTIONS(2680),
    [anon_sym_virtual] = ACTIONS(2680),
    [anon_sym_extern] = ACTIONS(2680),
    [anon_sym___attribute__] = ACTIONS(2680),
    [anon_sym___attribute] = ACTIONS(2680),
    [anon_sym_using] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2682),
    [anon_sym___declspec] = ACTIONS(2680),
    [anon_sym___based] = ACTIONS(2680),
    [anon_sym___cdecl] = ACTIONS(2680),
    [anon_sym___clrcall] = ACTIONS(2680),
    [anon_sym___stdcall] = ACTIONS(2680),
    [anon_sym___fastcall] = ACTIONS(2680),
    [anon_sym___thiscall] = ACTIONS(2680),
    [anon_sym___vectorcall] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_signed] = ACTIONS(2680),
    [anon_sym_unsigned] = ACTIONS(2680),
    [anon_sym_long] = ACTIONS(2680),
    [anon_sym_short] = ACTIONS(2680),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2680),
    [anon_sym_register] = ACTIONS(2680),
    [anon_sym_inline] = ACTIONS(2680),
    [anon_sym___inline] = ACTIONS(2680),
    [anon_sym___inline__] = ACTIONS(2680),
    [anon_sym___forceinline] = ACTIONS(2680),
    [anon_sym_thread_local] = ACTIONS(2680),
    [anon_sym___thread] = ACTIONS(2680),
    [anon_sym_const] = ACTIONS(2680),
    [anon_sym_constexpr] = ACTIONS(2680),
    [anon_sym_volatile] = ACTIONS(2680),
    [anon_sym_restrict] = ACTIONS(2680),
    [anon_sym___restrict__] = ACTIONS(2680),
    [anon_sym__Atomic] = ACTIONS(2680),
    [anon_sym__Noreturn] = ACTIONS(2680),
    [anon_sym_noreturn] = ACTIONS(2680),
    [anon_sym__Nonnull] = ACTIONS(2680),
    [anon_sym_mutable] = ACTIONS(2680),
    [anon_sym_constinit] = ACTIONS(2680),
    [anon_sym_consteval] = ACTIONS(2680),
    [anon_sym_alignas] = ACTIONS(2680),
    [anon_sym__Alignas] = ACTIONS(2680),
    [sym_primitive_type] = ACTIONS(2680),
    [anon_sym_enum] = ACTIONS(2680),
    [anon_sym_class] = ACTIONS(2680),
    [anon_sym_struct] = ACTIONS(2680),
    [anon_sym_union] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2680),
    [anon_sym_switch] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2680),
    [anon_sym_default] = ACTIONS(2680),
    [anon_sym_while] = ACTIONS(2680),
    [anon_sym_do] = ACTIONS(2680),
    [anon_sym_for] = ACTIONS(2680),
    [anon_sym_return] = ACTIONS(2680),
    [anon_sym_break] = ACTIONS(2680),
    [anon_sym_continue] = ACTIONS(2680),
    [anon_sym_goto] = ACTIONS(2680),
    [anon_sym_not] = ACTIONS(2680),
    [anon_sym_compl] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2682),
    [anon_sym_sizeof] = ACTIONS(2680),
    [anon_sym___alignof__] = ACTIONS(2680),
    [anon_sym___alignof] = ACTIONS(2680),
    [anon_sym__alignof] = ACTIONS(2680),
    [anon_sym_alignof] = ACTIONS(2680),
    [anon_sym__Alignof] = ACTIONS(2680),
    [anon_sym_offsetof] = ACTIONS(2680),
    [anon_sym__Generic] = ACTIONS(2680),
    [anon_sym_asm] = ACTIONS(2680),
    [anon_sym___asm__] = ACTIONS(2680),
    [anon_sym___asm] = ACTIONS(2680),
    [sym_number_literal] = ACTIONS(2682),
    [anon_sym_L_SQUOTE] = ACTIONS(2682),
    [anon_sym_u_SQUOTE] = ACTIONS(2682),
    [anon_sym_U_SQUOTE] = ACTIONS(2682),
    [anon_sym_u8_SQUOTE] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_L_DQUOTE] = ACTIONS(2682),
    [anon_sym_u_DQUOTE] = ACTIONS(2682),
    [anon_sym_U_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8_DQUOTE] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(2682),
    [sym_true] = ACTIONS(2680),
    [sym_false] = ACTIONS(2680),
    [anon_sym_NULL] = ACTIONS(2680),
    [anon_sym_nullptr] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2680),
    [anon_sym_decltype] = ACTIONS(2680),
    [anon_sym_explicit] = ACTIONS(2680),
    [anon_sym_typename] = ACTIONS(2680),
    [anon_sym_export] = ACTIONS(2680),
    [anon_sym_module] = ACTIONS(2680),
    [anon_sym_import] = ACTIONS(2680),
    [anon_sym_template] = ACTIONS(2680),
    [anon_sym_operator] = ACTIONS(2680),
    [anon_sym_try] = ACTIONS(2680),
    [anon_sym_delete] = ACTIONS(2680),
    [anon_sym_throw] = ACTIONS(2680),
    [anon_sym_namespace] = ACTIONS(2680),
    [anon_sym_static_assert] = ACTIONS(2680),
    [anon_sym_concept] = ACTIONS(2680),
    [anon_sym_co_return] = ACTIONS(2680),
    [anon_sym_co_yield] = ACTIONS(2680),
    [anon_sym_R_DQUOTE] = ACTIONS(2682),
    [anon_sym_LR_DQUOTE] = ACTIONS(2682),
    [anon_sym_uR_DQUOTE] = ACTIONS(2682),
    [anon_sym_UR_DQUOTE] = ACTIONS(2682),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2682),
    [anon_sym_co_await] = ACTIONS(2680),
    [anon_sym_new] = ACTIONS(2680),
    [anon_sym_requires] = ACTIONS(2680),
    [sym_this] = ACTIONS(2680),
    [anon_sym_precise] = ACTIONS(2680),
    [anon_sym_shared] = ACTIONS(2680),
    [anon_sym_groupshared] = ACTIONS(2680),
    [anon_sym_uniform] = ACTIONS(2680),
    [anon_sym_row_major] = ACTIONS(2680),
    [anon_sym_column_major] = ACTIONS(2680),
    [anon_sym_globallycoherent] = ACTIONS(2680),
    [anon_sym_centroid] = ACTIONS(2680),
    [anon_sym_noperspective] = ACTIONS(2680),
    [anon_sym_nointerpolation] = ACTIONS(2680),
    [anon_sym_sample] = ACTIONS(2680),
    [anon_sym_linear] = ACTIONS(2680),
    [anon_sym_snorm] = ACTIONS(2680),
    [anon_sym_unorm] = ACTIONS(2680),
    [anon_sym_point] = ACTIONS(2680),
    [anon_sym_line] = ACTIONS(2680),
    [anon_sym_triangleadj] = ACTIONS(2680),
    [anon_sym_lineadj] = ACTIONS(2680),
    [anon_sym_triangle] = ACTIONS(2680),
  },
  [764] = {
    [ts_builtin_sym_end] = ACTIONS(2686),
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_include_token1] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2684),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym___cdecl] = ACTIONS(2684),
    [anon_sym___clrcall] = ACTIONS(2684),
    [anon_sym___stdcall] = ACTIONS(2684),
    [anon_sym___fastcall] = ACTIONS(2684),
    [anon_sym___thiscall] = ACTIONS(2684),
    [anon_sym___vectorcall] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2686),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2684),
    [anon_sym_switch] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2684),
    [anon_sym_default] = ACTIONS(2684),
    [anon_sym_while] = ACTIONS(2684),
    [anon_sym_do] = ACTIONS(2684),
    [anon_sym_for] = ACTIONS(2684),
    [anon_sym_return] = ACTIONS(2684),
    [anon_sym_break] = ACTIONS(2684),
    [anon_sym_continue] = ACTIONS(2684),
    [anon_sym_goto] = ACTIONS(2684),
    [anon_sym_not] = ACTIONS(2684),
    [anon_sym_compl] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2686),
    [anon_sym_sizeof] = ACTIONS(2684),
    [anon_sym___alignof__] = ACTIONS(2684),
    [anon_sym___alignof] = ACTIONS(2684),
    [anon_sym__alignof] = ACTIONS(2684),
    [anon_sym_alignof] = ACTIONS(2684),
    [anon_sym__Alignof] = ACTIONS(2684),
    [anon_sym_offsetof] = ACTIONS(2684),
    [anon_sym__Generic] = ACTIONS(2684),
    [anon_sym_asm] = ACTIONS(2684),
    [anon_sym___asm__] = ACTIONS(2684),
    [anon_sym___asm] = ACTIONS(2684),
    [sym_number_literal] = ACTIONS(2686),
    [anon_sym_L_SQUOTE] = ACTIONS(2686),
    [anon_sym_u_SQUOTE] = ACTIONS(2686),
    [anon_sym_U_SQUOTE] = ACTIONS(2686),
    [anon_sym_u8_SQUOTE] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_L_DQUOTE] = ACTIONS(2686),
    [anon_sym_u_DQUOTE] = ACTIONS(2686),
    [anon_sym_U_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8_DQUOTE] = ACTIONS(2686),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [sym_true] = ACTIONS(2684),
    [sym_false] = ACTIONS(2684),
    [anon_sym_NULL] = ACTIONS(2684),
    [anon_sym_nullptr] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_export] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(2684),
    [anon_sym_import] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_try] = ACTIONS(2684),
    [anon_sym_delete] = ACTIONS(2684),
    [anon_sym_throw] = ACTIONS(2684),
    [anon_sym_namespace] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_concept] = ACTIONS(2684),
    [anon_sym_co_return] = ACTIONS(2684),
    [anon_sym_co_yield] = ACTIONS(2684),
    [anon_sym_R_DQUOTE] = ACTIONS(2686),
    [anon_sym_LR_DQUOTE] = ACTIONS(2686),
    [anon_sym_uR_DQUOTE] = ACTIONS(2686),
    [anon_sym_UR_DQUOTE] = ACTIONS(2686),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2686),
    [anon_sym_co_await] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(2684),
    [anon_sym_requires] = ACTIONS(2684),
    [sym_this] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
  },
  [765] = {
    [ts_builtin_sym_end] = ACTIONS(2514),
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_include_token1] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym___cdecl] = ACTIONS(2512),
    [anon_sym___clrcall] = ACTIONS(2512),
    [anon_sym___stdcall] = ACTIONS(2512),
    [anon_sym___fastcall] = ACTIONS(2512),
    [anon_sym___thiscall] = ACTIONS(2512),
    [anon_sym___vectorcall] = ACTIONS(2512),
    [anon_sym_LBRACE] = ACTIONS(2514),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2512),
    [anon_sym_switch] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2512),
    [anon_sym_default] = ACTIONS(2512),
    [anon_sym_while] = ACTIONS(2512),
    [anon_sym_do] = ACTIONS(2512),
    [anon_sym_for] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2512),
    [anon_sym_break] = ACTIONS(2512),
    [anon_sym_continue] = ACTIONS(2512),
    [anon_sym_goto] = ACTIONS(2512),
    [anon_sym_not] = ACTIONS(2512),
    [anon_sym_compl] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2512),
    [anon_sym___alignof__] = ACTIONS(2512),
    [anon_sym___alignof] = ACTIONS(2512),
    [anon_sym__alignof] = ACTIONS(2512),
    [anon_sym_alignof] = ACTIONS(2512),
    [anon_sym__Alignof] = ACTIONS(2512),
    [anon_sym_offsetof] = ACTIONS(2512),
    [anon_sym__Generic] = ACTIONS(2512),
    [anon_sym_asm] = ACTIONS(2512),
    [anon_sym___asm__] = ACTIONS(2512),
    [anon_sym___asm] = ACTIONS(2512),
    [sym_number_literal] = ACTIONS(2514),
    [anon_sym_L_SQUOTE] = ACTIONS(2514),
    [anon_sym_u_SQUOTE] = ACTIONS(2514),
    [anon_sym_U_SQUOTE] = ACTIONS(2514),
    [anon_sym_u8_SQUOTE] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_L_DQUOTE] = ACTIONS(2514),
    [anon_sym_u_DQUOTE] = ACTIONS(2514),
    [anon_sym_U_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8_DQUOTE] = ACTIONS(2514),
    [anon_sym_DQUOTE] = ACTIONS(2514),
    [sym_true] = ACTIONS(2512),
    [sym_false] = ACTIONS(2512),
    [anon_sym_NULL] = ACTIONS(2512),
    [anon_sym_nullptr] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_export] = ACTIONS(2512),
    [anon_sym_module] = ACTIONS(2512),
    [anon_sym_import] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_try] = ACTIONS(2512),
    [anon_sym_delete] = ACTIONS(2512),
    [anon_sym_throw] = ACTIONS(2512),
    [anon_sym_namespace] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_concept] = ACTIONS(2512),
    [anon_sym_co_return] = ACTIONS(2512),
    [anon_sym_co_yield] = ACTIONS(2512),
    [anon_sym_R_DQUOTE] = ACTIONS(2514),
    [anon_sym_LR_DQUOTE] = ACTIONS(2514),
    [anon_sym_uR_DQUOTE] = ACTIONS(2514),
    [anon_sym_UR_DQUOTE] = ACTIONS(2514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2514),
    [anon_sym_co_await] = ACTIONS(2512),
    [anon_sym_new] = ACTIONS(2512),
    [anon_sym_requires] = ACTIONS(2512),
    [sym_this] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
  },
  [766] = {
    [ts_builtin_sym_end] = ACTIONS(2690),
    [sym_identifier] = ACTIONS(2688),
    [aux_sym_preproc_include_token1] = ACTIONS(2688),
    [aux_sym_preproc_def_token1] = ACTIONS(2688),
    [aux_sym_preproc_if_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2688),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2688),
    [sym_preproc_directive] = ACTIONS(2688),
    [anon_sym_LPAREN2] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2688),
    [anon_sym_STAR] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym___extension__] = ACTIONS(2688),
    [anon_sym_typedef] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2688),
    [anon_sym_out] = ACTIONS(2688),
    [anon_sym_inout] = ACTIONS(2688),
    [anon_sym_virtual] = ACTIONS(2688),
    [anon_sym_extern] = ACTIONS(2688),
    [anon_sym___attribute__] = ACTIONS(2688),
    [anon_sym___attribute] = ACTIONS(2688),
    [anon_sym_using] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2690),
    [anon_sym___declspec] = ACTIONS(2688),
    [anon_sym___based] = ACTIONS(2688),
    [anon_sym___cdecl] = ACTIONS(2688),
    [anon_sym___clrcall] = ACTIONS(2688),
    [anon_sym___stdcall] = ACTIONS(2688),
    [anon_sym___fastcall] = ACTIONS(2688),
    [anon_sym___thiscall] = ACTIONS(2688),
    [anon_sym___vectorcall] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2690),
    [anon_sym_signed] = ACTIONS(2688),
    [anon_sym_unsigned] = ACTIONS(2688),
    [anon_sym_long] = ACTIONS(2688),
    [anon_sym_short] = ACTIONS(2688),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2688),
    [anon_sym_register] = ACTIONS(2688),
    [anon_sym_inline] = ACTIONS(2688),
    [anon_sym___inline] = ACTIONS(2688),
    [anon_sym___inline__] = ACTIONS(2688),
    [anon_sym___forceinline] = ACTIONS(2688),
    [anon_sym_thread_local] = ACTIONS(2688),
    [anon_sym___thread] = ACTIONS(2688),
    [anon_sym_const] = ACTIONS(2688),
    [anon_sym_constexpr] = ACTIONS(2688),
    [anon_sym_volatile] = ACTIONS(2688),
    [anon_sym_restrict] = ACTIONS(2688),
    [anon_sym___restrict__] = ACTIONS(2688),
    [anon_sym__Atomic] = ACTIONS(2688),
    [anon_sym__Noreturn] = ACTIONS(2688),
    [anon_sym_noreturn] = ACTIONS(2688),
    [anon_sym__Nonnull] = ACTIONS(2688),
    [anon_sym_mutable] = ACTIONS(2688),
    [anon_sym_constinit] = ACTIONS(2688),
    [anon_sym_consteval] = ACTIONS(2688),
    [anon_sym_alignas] = ACTIONS(2688),
    [anon_sym__Alignas] = ACTIONS(2688),
    [sym_primitive_type] = ACTIONS(2688),
    [anon_sym_enum] = ACTIONS(2688),
    [anon_sym_class] = ACTIONS(2688),
    [anon_sym_struct] = ACTIONS(2688),
    [anon_sym_union] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2688),
    [anon_sym_switch] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2688),
    [anon_sym_default] = ACTIONS(2688),
    [anon_sym_while] = ACTIONS(2688),
    [anon_sym_do] = ACTIONS(2688),
    [anon_sym_for] = ACTIONS(2688),
    [anon_sym_return] = ACTIONS(2688),
    [anon_sym_break] = ACTIONS(2688),
    [anon_sym_continue] = ACTIONS(2688),
    [anon_sym_goto] = ACTIONS(2688),
    [anon_sym_not] = ACTIONS(2688),
    [anon_sym_compl] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_sizeof] = ACTIONS(2688),
    [anon_sym___alignof__] = ACTIONS(2688),
    [anon_sym___alignof] = ACTIONS(2688),
    [anon_sym__alignof] = ACTIONS(2688),
    [anon_sym_alignof] = ACTIONS(2688),
    [anon_sym__Alignof] = ACTIONS(2688),
    [anon_sym_offsetof] = ACTIONS(2688),
    [anon_sym__Generic] = ACTIONS(2688),
    [anon_sym_asm] = ACTIONS(2688),
    [anon_sym___asm__] = ACTIONS(2688),
    [anon_sym___asm] = ACTIONS(2688),
    [sym_number_literal] = ACTIONS(2690),
    [anon_sym_L_SQUOTE] = ACTIONS(2690),
    [anon_sym_u_SQUOTE] = ACTIONS(2690),
    [anon_sym_U_SQUOTE] = ACTIONS(2690),
    [anon_sym_u8_SQUOTE] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_L_DQUOTE] = ACTIONS(2690),
    [anon_sym_u_DQUOTE] = ACTIONS(2690),
    [anon_sym_U_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8_DQUOTE] = ACTIONS(2690),
    [anon_sym_DQUOTE] = ACTIONS(2690),
    [sym_true] = ACTIONS(2688),
    [sym_false] = ACTIONS(2688),
    [anon_sym_NULL] = ACTIONS(2688),
    [anon_sym_nullptr] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2688),
    [anon_sym_decltype] = ACTIONS(2688),
    [anon_sym_explicit] = ACTIONS(2688),
    [anon_sym_typename] = ACTIONS(2688),
    [anon_sym_export] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(2688),
    [anon_sym_import] = ACTIONS(2688),
    [anon_sym_template] = ACTIONS(2688),
    [anon_sym_operator] = ACTIONS(2688),
    [anon_sym_try] = ACTIONS(2688),
    [anon_sym_delete] = ACTIONS(2688),
    [anon_sym_throw] = ACTIONS(2688),
    [anon_sym_namespace] = ACTIONS(2688),
    [anon_sym_static_assert] = ACTIONS(2688),
    [anon_sym_concept] = ACTIONS(2688),
    [anon_sym_co_return] = ACTIONS(2688),
    [anon_sym_co_yield] = ACTIONS(2688),
    [anon_sym_R_DQUOTE] = ACTIONS(2690),
    [anon_sym_LR_DQUOTE] = ACTIONS(2690),
    [anon_sym_uR_DQUOTE] = ACTIONS(2690),
    [anon_sym_UR_DQUOTE] = ACTIONS(2690),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2690),
    [anon_sym_co_await] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(2688),
    [anon_sym_requires] = ACTIONS(2688),
    [sym_this] = ACTIONS(2688),
    [anon_sym_precise] = ACTIONS(2688),
    [anon_sym_shared] = ACTIONS(2688),
    [anon_sym_groupshared] = ACTIONS(2688),
    [anon_sym_uniform] = ACTIONS(2688),
    [anon_sym_row_major] = ACTIONS(2688),
    [anon_sym_column_major] = ACTIONS(2688),
    [anon_sym_globallycoherent] = ACTIONS(2688),
    [anon_sym_centroid] = ACTIONS(2688),
    [anon_sym_noperspective] = ACTIONS(2688),
    [anon_sym_nointerpolation] = ACTIONS(2688),
    [anon_sym_sample] = ACTIONS(2688),
    [anon_sym_linear] = ACTIONS(2688),
    [anon_sym_snorm] = ACTIONS(2688),
    [anon_sym_unorm] = ACTIONS(2688),
    [anon_sym_point] = ACTIONS(2688),
    [anon_sym_line] = ACTIONS(2688),
    [anon_sym_triangleadj] = ACTIONS(2688),
    [anon_sym_lineadj] = ACTIONS(2688),
    [anon_sym_triangle] = ACTIONS(2688),
  },
  [767] = {
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [768] = {
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_include_token1] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym___cdecl] = ACTIONS(2462),
    [anon_sym___clrcall] = ACTIONS(2462),
    [anon_sym___stdcall] = ACTIONS(2462),
    [anon_sym___fastcall] = ACTIONS(2462),
    [anon_sym___thiscall] = ACTIONS(2462),
    [anon_sym___vectorcall] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym_not] = ACTIONS(2462),
    [anon_sym_compl] = ACTIONS(2462),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2462),
    [anon_sym__Generic] = ACTIONS(2462),
    [anon_sym_asm] = ACTIONS(2462),
    [anon_sym___asm__] = ACTIONS(2462),
    [anon_sym___asm] = ACTIONS(2462),
    [sym_number_literal] = ACTIONS(2464),
    [anon_sym_L_SQUOTE] = ACTIONS(2464),
    [anon_sym_u_SQUOTE] = ACTIONS(2464),
    [anon_sym_U_SQUOTE] = ACTIONS(2464),
    [anon_sym_u8_SQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_L_DQUOTE] = ACTIONS(2464),
    [anon_sym_u_DQUOTE] = ACTIONS(2464),
    [anon_sym_U_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [anon_sym_NULL] = ACTIONS(2462),
    [anon_sym_nullptr] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_concept] = ACTIONS(2462),
    [anon_sym_co_return] = ACTIONS(2462),
    [anon_sym_co_yield] = ACTIONS(2462),
    [anon_sym_R_DQUOTE] = ACTIONS(2464),
    [anon_sym_LR_DQUOTE] = ACTIONS(2464),
    [anon_sym_uR_DQUOTE] = ACTIONS(2464),
    [anon_sym_UR_DQUOTE] = ACTIONS(2464),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2464),
    [anon_sym_co_await] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_requires] = ACTIONS(2462),
    [sym_this] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [769] = {
    [ts_builtin_sym_end] = ACTIONS(2518),
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_include_token1] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2516),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym___cdecl] = ACTIONS(2516),
    [anon_sym___clrcall] = ACTIONS(2516),
    [anon_sym___stdcall] = ACTIONS(2516),
    [anon_sym___fastcall] = ACTIONS(2516),
    [anon_sym___thiscall] = ACTIONS(2516),
    [anon_sym___vectorcall] = ACTIONS(2516),
    [anon_sym_LBRACE] = ACTIONS(2518),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2516),
    [anon_sym_switch] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2516),
    [anon_sym_default] = ACTIONS(2516),
    [anon_sym_while] = ACTIONS(2516),
    [anon_sym_do] = ACTIONS(2516),
    [anon_sym_for] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2516),
    [anon_sym_break] = ACTIONS(2516),
    [anon_sym_continue] = ACTIONS(2516),
    [anon_sym_goto] = ACTIONS(2516),
    [anon_sym_not] = ACTIONS(2516),
    [anon_sym_compl] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2516),
    [anon_sym___alignof__] = ACTIONS(2516),
    [anon_sym___alignof] = ACTIONS(2516),
    [anon_sym__alignof] = ACTIONS(2516),
    [anon_sym_alignof] = ACTIONS(2516),
    [anon_sym__Alignof] = ACTIONS(2516),
    [anon_sym_offsetof] = ACTIONS(2516),
    [anon_sym__Generic] = ACTIONS(2516),
    [anon_sym_asm] = ACTIONS(2516),
    [anon_sym___asm__] = ACTIONS(2516),
    [anon_sym___asm] = ACTIONS(2516),
    [sym_number_literal] = ACTIONS(2518),
    [anon_sym_L_SQUOTE] = ACTIONS(2518),
    [anon_sym_u_SQUOTE] = ACTIONS(2518),
    [anon_sym_U_SQUOTE] = ACTIONS(2518),
    [anon_sym_u8_SQUOTE] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_L_DQUOTE] = ACTIONS(2518),
    [anon_sym_u_DQUOTE] = ACTIONS(2518),
    [anon_sym_U_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8_DQUOTE] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(2518),
    [sym_true] = ACTIONS(2516),
    [sym_false] = ACTIONS(2516),
    [anon_sym_NULL] = ACTIONS(2516),
    [anon_sym_nullptr] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_export] = ACTIONS(2516),
    [anon_sym_module] = ACTIONS(2516),
    [anon_sym_import] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_try] = ACTIONS(2516),
    [anon_sym_delete] = ACTIONS(2516),
    [anon_sym_throw] = ACTIONS(2516),
    [anon_sym_namespace] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_concept] = ACTIONS(2516),
    [anon_sym_co_return] = ACTIONS(2516),
    [anon_sym_co_yield] = ACTIONS(2516),
    [anon_sym_R_DQUOTE] = ACTIONS(2518),
    [anon_sym_LR_DQUOTE] = ACTIONS(2518),
    [anon_sym_uR_DQUOTE] = ACTIONS(2518),
    [anon_sym_UR_DQUOTE] = ACTIONS(2518),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2518),
    [anon_sym_co_await] = ACTIONS(2516),
    [anon_sym_new] = ACTIONS(2516),
    [anon_sym_requires] = ACTIONS(2516),
    [sym_this] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
  },
  [770] = {
    [ts_builtin_sym_end] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_include_token1] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym___cdecl] = ACTIONS(2520),
    [anon_sym___clrcall] = ACTIONS(2520),
    [anon_sym___stdcall] = ACTIONS(2520),
    [anon_sym___fastcall] = ACTIONS(2520),
    [anon_sym___thiscall] = ACTIONS(2520),
    [anon_sym___vectorcall] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2522),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2520),
    [anon_sym_switch] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2520),
    [anon_sym_default] = ACTIONS(2520),
    [anon_sym_while] = ACTIONS(2520),
    [anon_sym_do] = ACTIONS(2520),
    [anon_sym_for] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2520),
    [anon_sym_break] = ACTIONS(2520),
    [anon_sym_continue] = ACTIONS(2520),
    [anon_sym_goto] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2520),
    [anon_sym_compl] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2520),
    [anon_sym___alignof__] = ACTIONS(2520),
    [anon_sym___alignof] = ACTIONS(2520),
    [anon_sym__alignof] = ACTIONS(2520),
    [anon_sym_alignof] = ACTIONS(2520),
    [anon_sym__Alignof] = ACTIONS(2520),
    [anon_sym_offsetof] = ACTIONS(2520),
    [anon_sym__Generic] = ACTIONS(2520),
    [anon_sym_asm] = ACTIONS(2520),
    [anon_sym___asm__] = ACTIONS(2520),
    [anon_sym___asm] = ACTIONS(2520),
    [sym_number_literal] = ACTIONS(2522),
    [anon_sym_L_SQUOTE] = ACTIONS(2522),
    [anon_sym_u_SQUOTE] = ACTIONS(2522),
    [anon_sym_U_SQUOTE] = ACTIONS(2522),
    [anon_sym_u8_SQUOTE] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_L_DQUOTE] = ACTIONS(2522),
    [anon_sym_u_DQUOTE] = ACTIONS(2522),
    [anon_sym_U_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8_DQUOTE] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2522),
    [sym_true] = ACTIONS(2520),
    [sym_false] = ACTIONS(2520),
    [anon_sym_NULL] = ACTIONS(2520),
    [anon_sym_nullptr] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_export] = ACTIONS(2520),
    [anon_sym_module] = ACTIONS(2520),
    [anon_sym_import] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_try] = ACTIONS(2520),
    [anon_sym_delete] = ACTIONS(2520),
    [anon_sym_throw] = ACTIONS(2520),
    [anon_sym_namespace] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_concept] = ACTIONS(2520),
    [anon_sym_co_return] = ACTIONS(2520),
    [anon_sym_co_yield] = ACTIONS(2520),
    [anon_sym_R_DQUOTE] = ACTIONS(2522),
    [anon_sym_LR_DQUOTE] = ACTIONS(2522),
    [anon_sym_uR_DQUOTE] = ACTIONS(2522),
    [anon_sym_UR_DQUOTE] = ACTIONS(2522),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2522),
    [anon_sym_co_await] = ACTIONS(2520),
    [anon_sym_new] = ACTIONS(2520),
    [anon_sym_requires] = ACTIONS(2520),
    [sym_this] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
  },
  [771] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [772] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [773] = {
    [ts_builtin_sym_end] = ACTIONS(2662),
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_include_token1] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2660),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym___cdecl] = ACTIONS(2660),
    [anon_sym___clrcall] = ACTIONS(2660),
    [anon_sym___stdcall] = ACTIONS(2660),
    [anon_sym___fastcall] = ACTIONS(2660),
    [anon_sym___thiscall] = ACTIONS(2660),
    [anon_sym___vectorcall] = ACTIONS(2660),
    [anon_sym_LBRACE] = ACTIONS(2662),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2660),
    [anon_sym_switch] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2660),
    [anon_sym_default] = ACTIONS(2660),
    [anon_sym_while] = ACTIONS(2660),
    [anon_sym_do] = ACTIONS(2660),
    [anon_sym_for] = ACTIONS(2660),
    [anon_sym_return] = ACTIONS(2660),
    [anon_sym_break] = ACTIONS(2660),
    [anon_sym_continue] = ACTIONS(2660),
    [anon_sym_goto] = ACTIONS(2660),
    [anon_sym_not] = ACTIONS(2660),
    [anon_sym_compl] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2662),
    [anon_sym_sizeof] = ACTIONS(2660),
    [anon_sym___alignof__] = ACTIONS(2660),
    [anon_sym___alignof] = ACTIONS(2660),
    [anon_sym__alignof] = ACTIONS(2660),
    [anon_sym_alignof] = ACTIONS(2660),
    [anon_sym__Alignof] = ACTIONS(2660),
    [anon_sym_offsetof] = ACTIONS(2660),
    [anon_sym__Generic] = ACTIONS(2660),
    [anon_sym_asm] = ACTIONS(2660),
    [anon_sym___asm__] = ACTIONS(2660),
    [anon_sym___asm] = ACTIONS(2660),
    [sym_number_literal] = ACTIONS(2662),
    [anon_sym_L_SQUOTE] = ACTIONS(2662),
    [anon_sym_u_SQUOTE] = ACTIONS(2662),
    [anon_sym_U_SQUOTE] = ACTIONS(2662),
    [anon_sym_u8_SQUOTE] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_L_DQUOTE] = ACTIONS(2662),
    [anon_sym_u_DQUOTE] = ACTIONS(2662),
    [anon_sym_U_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8_DQUOTE] = ACTIONS(2662),
    [anon_sym_DQUOTE] = ACTIONS(2662),
    [sym_true] = ACTIONS(2660),
    [sym_false] = ACTIONS(2660),
    [anon_sym_NULL] = ACTIONS(2660),
    [anon_sym_nullptr] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_export] = ACTIONS(2660),
    [anon_sym_module] = ACTIONS(2660),
    [anon_sym_import] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_try] = ACTIONS(2660),
    [anon_sym_delete] = ACTIONS(2660),
    [anon_sym_throw] = ACTIONS(2660),
    [anon_sym_namespace] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_concept] = ACTIONS(2660),
    [anon_sym_co_return] = ACTIONS(2660),
    [anon_sym_co_yield] = ACTIONS(2660),
    [anon_sym_R_DQUOTE] = ACTIONS(2662),
    [anon_sym_LR_DQUOTE] = ACTIONS(2662),
    [anon_sym_uR_DQUOTE] = ACTIONS(2662),
    [anon_sym_UR_DQUOTE] = ACTIONS(2662),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2662),
    [anon_sym_co_await] = ACTIONS(2660),
    [anon_sym_new] = ACTIONS(2660),
    [anon_sym_requires] = ACTIONS(2660),
    [sym_this] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
  },
  [774] = {
    [ts_builtin_sym_end] = ACTIONS(2694),
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_include_token1] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym___cdecl] = ACTIONS(2692),
    [anon_sym___clrcall] = ACTIONS(2692),
    [anon_sym___stdcall] = ACTIONS(2692),
    [anon_sym___fastcall] = ACTIONS(2692),
    [anon_sym___thiscall] = ACTIONS(2692),
    [anon_sym___vectorcall] = ACTIONS(2692),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2692),
    [anon_sym_switch] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_default] = ACTIONS(2692),
    [anon_sym_while] = ACTIONS(2692),
    [anon_sym_do] = ACTIONS(2692),
    [anon_sym_for] = ACTIONS(2692),
    [anon_sym_return] = ACTIONS(2692),
    [anon_sym_break] = ACTIONS(2692),
    [anon_sym_continue] = ACTIONS(2692),
    [anon_sym_goto] = ACTIONS(2692),
    [anon_sym_not] = ACTIONS(2692),
    [anon_sym_compl] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2694),
    [anon_sym_sizeof] = ACTIONS(2692),
    [anon_sym___alignof__] = ACTIONS(2692),
    [anon_sym___alignof] = ACTIONS(2692),
    [anon_sym__alignof] = ACTIONS(2692),
    [anon_sym_alignof] = ACTIONS(2692),
    [anon_sym__Alignof] = ACTIONS(2692),
    [anon_sym_offsetof] = ACTIONS(2692),
    [anon_sym__Generic] = ACTIONS(2692),
    [anon_sym_asm] = ACTIONS(2692),
    [anon_sym___asm__] = ACTIONS(2692),
    [anon_sym___asm] = ACTIONS(2692),
    [sym_number_literal] = ACTIONS(2694),
    [anon_sym_L_SQUOTE] = ACTIONS(2694),
    [anon_sym_u_SQUOTE] = ACTIONS(2694),
    [anon_sym_U_SQUOTE] = ACTIONS(2694),
    [anon_sym_u8_SQUOTE] = ACTIONS(2694),
    [anon_sym_SQUOTE] = ACTIONS(2694),
    [anon_sym_L_DQUOTE] = ACTIONS(2694),
    [anon_sym_u_DQUOTE] = ACTIONS(2694),
    [anon_sym_U_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8_DQUOTE] = ACTIONS(2694),
    [anon_sym_DQUOTE] = ACTIONS(2694),
    [sym_true] = ACTIONS(2692),
    [sym_false] = ACTIONS(2692),
    [anon_sym_NULL] = ACTIONS(2692),
    [anon_sym_nullptr] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_export] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(2692),
    [anon_sym_import] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_try] = ACTIONS(2692),
    [anon_sym_delete] = ACTIONS(2692),
    [anon_sym_throw] = ACTIONS(2692),
    [anon_sym_namespace] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_concept] = ACTIONS(2692),
    [anon_sym_co_return] = ACTIONS(2692),
    [anon_sym_co_yield] = ACTIONS(2692),
    [anon_sym_R_DQUOTE] = ACTIONS(2694),
    [anon_sym_LR_DQUOTE] = ACTIONS(2694),
    [anon_sym_uR_DQUOTE] = ACTIONS(2694),
    [anon_sym_UR_DQUOTE] = ACTIONS(2694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2694),
    [anon_sym_co_await] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(2692),
    [anon_sym_requires] = ACTIONS(2692),
    [sym_this] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
  },
  [775] = {
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_include_token1] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym___cdecl] = ACTIONS(2410),
    [anon_sym___clrcall] = ACTIONS(2410),
    [anon_sym___stdcall] = ACTIONS(2410),
    [anon_sym___fastcall] = ACTIONS(2410),
    [anon_sym___thiscall] = ACTIONS(2410),
    [anon_sym___vectorcall] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(2410),
    [anon_sym_compl] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym___alignof__] = ACTIONS(2410),
    [anon_sym___alignof] = ACTIONS(2410),
    [anon_sym__alignof] = ACTIONS(2410),
    [anon_sym_alignof] = ACTIONS(2410),
    [anon_sym__Alignof] = ACTIONS(2410),
    [anon_sym_offsetof] = ACTIONS(2410),
    [anon_sym__Generic] = ACTIONS(2410),
    [anon_sym_asm] = ACTIONS(2410),
    [anon_sym___asm__] = ACTIONS(2410),
    [anon_sym___asm] = ACTIONS(2410),
    [sym_number_literal] = ACTIONS(2412),
    [anon_sym_L_SQUOTE] = ACTIONS(2412),
    [anon_sym_u_SQUOTE] = ACTIONS(2412),
    [anon_sym_U_SQUOTE] = ACTIONS(2412),
    [anon_sym_u8_SQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_L_DQUOTE] = ACTIONS(2412),
    [anon_sym_u_DQUOTE] = ACTIONS(2412),
    [anon_sym_U_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [anon_sym_NULL] = ACTIONS(2410),
    [anon_sym_nullptr] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_export] = ACTIONS(2410),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_concept] = ACTIONS(2410),
    [anon_sym_co_return] = ACTIONS(2410),
    [anon_sym_co_yield] = ACTIONS(2410),
    [anon_sym_R_DQUOTE] = ACTIONS(2412),
    [anon_sym_LR_DQUOTE] = ACTIONS(2412),
    [anon_sym_uR_DQUOTE] = ACTIONS(2412),
    [anon_sym_UR_DQUOTE] = ACTIONS(2412),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2412),
    [anon_sym_co_await] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_requires] = ACTIONS(2410),
    [sym_this] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [776] = {
    [ts_builtin_sym_end] = ACTIONS(3059),
    [sym_identifier] = ACTIONS(3062),
    [aux_sym_preproc_include_token1] = ACTIONS(3062),
    [aux_sym_preproc_def_token1] = ACTIONS(3062),
    [aux_sym_preproc_if_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3062),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3062),
    [sym_preproc_directive] = ACTIONS(3062),
    [anon_sym_LPAREN2] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym___extension__] = ACTIONS(3062),
    [anon_sym_typedef] = ACTIONS(3062),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_out] = ACTIONS(3062),
    [anon_sym_inout] = ACTIONS(3062),
    [anon_sym_virtual] = ACTIONS(3062),
    [anon_sym_extern] = ACTIONS(3062),
    [anon_sym___attribute__] = ACTIONS(3062),
    [anon_sym___attribute] = ACTIONS(3062),
    [anon_sym_using] = ACTIONS(3062),
    [anon_sym_COLON_COLON] = ACTIONS(3059),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3059),
    [anon_sym___declspec] = ACTIONS(3062),
    [anon_sym___based] = ACTIONS(3062),
    [anon_sym___cdecl] = ACTIONS(3062),
    [anon_sym___clrcall] = ACTIONS(3062),
    [anon_sym___stdcall] = ACTIONS(3062),
    [anon_sym___fastcall] = ACTIONS(3062),
    [anon_sym___thiscall] = ACTIONS(3062),
    [anon_sym___vectorcall] = ACTIONS(3062),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_signed] = ACTIONS(3062),
    [anon_sym_unsigned] = ACTIONS(3062),
    [anon_sym_long] = ACTIONS(3062),
    [anon_sym_short] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3062),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_register] = ACTIONS(3062),
    [anon_sym_inline] = ACTIONS(3062),
    [anon_sym___inline] = ACTIONS(3062),
    [anon_sym___inline__] = ACTIONS(3062),
    [anon_sym___forceinline] = ACTIONS(3062),
    [anon_sym_thread_local] = ACTIONS(3062),
    [anon_sym___thread] = ACTIONS(3062),
    [anon_sym_const] = ACTIONS(3062),
    [anon_sym_constexpr] = ACTIONS(3062),
    [anon_sym_volatile] = ACTIONS(3062),
    [anon_sym_restrict] = ACTIONS(3062),
    [anon_sym___restrict__] = ACTIONS(3062),
    [anon_sym__Atomic] = ACTIONS(3062),
    [anon_sym__Noreturn] = ACTIONS(3062),
    [anon_sym_noreturn] = ACTIONS(3062),
    [anon_sym__Nonnull] = ACTIONS(3062),
    [anon_sym_mutable] = ACTIONS(3062),
    [anon_sym_constinit] = ACTIONS(3062),
    [anon_sym_consteval] = ACTIONS(3062),
    [anon_sym_alignas] = ACTIONS(3062),
    [anon_sym__Alignas] = ACTIONS(3062),
    [sym_primitive_type] = ACTIONS(3062),
    [anon_sym_enum] = ACTIONS(3062),
    [anon_sym_class] = ACTIONS(3062),
    [anon_sym_struct] = ACTIONS(3062),
    [anon_sym_union] = ACTIONS(3062),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_switch] = ACTIONS(3062),
    [anon_sym_case] = ACTIONS(3062),
    [anon_sym_default] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_for] = ACTIONS(3062),
    [anon_sym_return] = ACTIONS(3062),
    [anon_sym_break] = ACTIONS(3062),
    [anon_sym_continue] = ACTIONS(3062),
    [anon_sym_goto] = ACTIONS(3062),
    [anon_sym_not] = ACTIONS(3062),
    [anon_sym_compl] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_sizeof] = ACTIONS(3062),
    [anon_sym___alignof__] = ACTIONS(3062),
    [anon_sym___alignof] = ACTIONS(3062),
    [anon_sym__alignof] = ACTIONS(3062),
    [anon_sym_alignof] = ACTIONS(3062),
    [anon_sym__Alignof] = ACTIONS(3062),
    [anon_sym_offsetof] = ACTIONS(3062),
    [anon_sym__Generic] = ACTIONS(3062),
    [anon_sym_asm] = ACTIONS(3062),
    [anon_sym___asm__] = ACTIONS(3062),
    [anon_sym___asm] = ACTIONS(3062),
    [sym_number_literal] = ACTIONS(3059),
    [anon_sym_L_SQUOTE] = ACTIONS(3059),
    [anon_sym_u_SQUOTE] = ACTIONS(3059),
    [anon_sym_U_SQUOTE] = ACTIONS(3059),
    [anon_sym_u8_SQUOTE] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [anon_sym_L_DQUOTE] = ACTIONS(3059),
    [anon_sym_u_DQUOTE] = ACTIONS(3059),
    [anon_sym_U_DQUOTE] = ACTIONS(3059),
    [anon_sym_u8_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [sym_true] = ACTIONS(3062),
    [sym_false] = ACTIONS(3062),
    [anon_sym_NULL] = ACTIONS(3062),
    [anon_sym_nullptr] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3062),
    [anon_sym_decltype] = ACTIONS(3062),
    [anon_sym_explicit] = ACTIONS(3062),
    [anon_sym_typename] = ACTIONS(3062),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_import] = ACTIONS(3062),
    [anon_sym_template] = ACTIONS(3062),
    [anon_sym_operator] = ACTIONS(3062),
    [anon_sym_try] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3062),
    [anon_sym_throw] = ACTIONS(3062),
    [anon_sym_namespace] = ACTIONS(3062),
    [anon_sym_static_assert] = ACTIONS(3062),
    [anon_sym_concept] = ACTIONS(3062),
    [anon_sym_co_return] = ACTIONS(3062),
    [anon_sym_co_yield] = ACTIONS(3062),
    [anon_sym_R_DQUOTE] = ACTIONS(3059),
    [anon_sym_LR_DQUOTE] = ACTIONS(3059),
    [anon_sym_uR_DQUOTE] = ACTIONS(3059),
    [anon_sym_UR_DQUOTE] = ACTIONS(3059),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3059),
    [anon_sym_co_await] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3062),
    [anon_sym_requires] = ACTIONS(3062),
    [sym_this] = ACTIONS(3062),
    [anon_sym_precise] = ACTIONS(3062),
    [anon_sym_shared] = ACTIONS(3062),
    [anon_sym_groupshared] = ACTIONS(3062),
    [anon_sym_uniform] = ACTIONS(3062),
    [anon_sym_row_major] = ACTIONS(3062),
    [anon_sym_column_major] = ACTIONS(3062),
    [anon_sym_globallycoherent] = ACTIONS(3062),
    [anon_sym_centroid] = ACTIONS(3062),
    [anon_sym_noperspective] = ACTIONS(3062),
    [anon_sym_nointerpolation] = ACTIONS(3062),
    [anon_sym_sample] = ACTIONS(3062),
    [anon_sym_linear] = ACTIONS(3062),
    [anon_sym_snorm] = ACTIONS(3062),
    [anon_sym_unorm] = ACTIONS(3062),
    [anon_sym_point] = ACTIONS(3062),
    [anon_sym_line] = ACTIONS(3062),
    [anon_sym_triangleadj] = ACTIONS(3062),
    [anon_sym_lineadj] = ACTIONS(3062),
    [anon_sym_triangle] = ACTIONS(3062),
  },
  [777] = {
    [ts_builtin_sym_end] = ACTIONS(2451),
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_include_token1] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_BANG] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_DASH] = ACTIONS(2449),
    [anon_sym_PLUS] = ACTIONS(2449),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym___cdecl] = ACTIONS(2449),
    [anon_sym___clrcall] = ACTIONS(2449),
    [anon_sym___stdcall] = ACTIONS(2449),
    [anon_sym___fastcall] = ACTIONS(2449),
    [anon_sym___thiscall] = ACTIONS(2449),
    [anon_sym___vectorcall] = ACTIONS(2449),
    [anon_sym_LBRACE] = ACTIONS(2451),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [anon_sym_if] = ACTIONS(2449),
    [anon_sym_switch] = ACTIONS(2449),
    [anon_sym_case] = ACTIONS(2449),
    [anon_sym_default] = ACTIONS(2449),
    [anon_sym_while] = ACTIONS(2449),
    [anon_sym_do] = ACTIONS(2449),
    [anon_sym_for] = ACTIONS(2449),
    [anon_sym_return] = ACTIONS(2449),
    [anon_sym_break] = ACTIONS(2449),
    [anon_sym_continue] = ACTIONS(2449),
    [anon_sym_goto] = ACTIONS(2449),
    [anon_sym_not] = ACTIONS(2449),
    [anon_sym_compl] = ACTIONS(2449),
    [anon_sym_DASH_DASH] = ACTIONS(2451),
    [anon_sym_PLUS_PLUS] = ACTIONS(2451),
    [anon_sym_sizeof] = ACTIONS(2449),
    [anon_sym___alignof__] = ACTIONS(2449),
    [anon_sym___alignof] = ACTIONS(2449),
    [anon_sym__alignof] = ACTIONS(2449),
    [anon_sym_alignof] = ACTIONS(2449),
    [anon_sym__Alignof] = ACTIONS(2449),
    [anon_sym_offsetof] = ACTIONS(2449),
    [anon_sym__Generic] = ACTIONS(2449),
    [anon_sym_asm] = ACTIONS(2449),
    [anon_sym___asm__] = ACTIONS(2449),
    [anon_sym___asm] = ACTIONS(2449),
    [sym_number_literal] = ACTIONS(2451),
    [anon_sym_L_SQUOTE] = ACTIONS(2451),
    [anon_sym_u_SQUOTE] = ACTIONS(2451),
    [anon_sym_U_SQUOTE] = ACTIONS(2451),
    [anon_sym_u8_SQUOTE] = ACTIONS(2451),
    [anon_sym_SQUOTE] = ACTIONS(2451),
    [anon_sym_L_DQUOTE] = ACTIONS(2451),
    [anon_sym_u_DQUOTE] = ACTIONS(2451),
    [anon_sym_U_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8_DQUOTE] = ACTIONS(2451),
    [anon_sym_DQUOTE] = ACTIONS(2451),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [anon_sym_NULL] = ACTIONS(2449),
    [anon_sym_nullptr] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_export] = ACTIONS(2449),
    [anon_sym_module] = ACTIONS(2449),
    [anon_sym_import] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_try] = ACTIONS(2449),
    [anon_sym_delete] = ACTIONS(2449),
    [anon_sym_throw] = ACTIONS(2449),
    [anon_sym_namespace] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_concept] = ACTIONS(2449),
    [anon_sym_co_return] = ACTIONS(2449),
    [anon_sym_co_yield] = ACTIONS(2449),
    [anon_sym_R_DQUOTE] = ACTIONS(2451),
    [anon_sym_LR_DQUOTE] = ACTIONS(2451),
    [anon_sym_uR_DQUOTE] = ACTIONS(2451),
    [anon_sym_UR_DQUOTE] = ACTIONS(2451),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2451),
    [anon_sym_co_await] = ACTIONS(2449),
    [anon_sym_new] = ACTIONS(2449),
    [anon_sym_requires] = ACTIONS(2449),
    [sym_this] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
  },
  [778] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [779] = {
    [ts_builtin_sym_end] = ACTIONS(2455),
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_include_token1] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_BANG] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_DASH] = ACTIONS(2453),
    [anon_sym_PLUS] = ACTIONS(2453),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym___cdecl] = ACTIONS(2453),
    [anon_sym___clrcall] = ACTIONS(2453),
    [anon_sym___stdcall] = ACTIONS(2453),
    [anon_sym___fastcall] = ACTIONS(2453),
    [anon_sym___thiscall] = ACTIONS(2453),
    [anon_sym___vectorcall] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [anon_sym_if] = ACTIONS(2453),
    [anon_sym_switch] = ACTIONS(2453),
    [anon_sym_case] = ACTIONS(2453),
    [anon_sym_default] = ACTIONS(2453),
    [anon_sym_while] = ACTIONS(2453),
    [anon_sym_do] = ACTIONS(2453),
    [anon_sym_for] = ACTIONS(2453),
    [anon_sym_return] = ACTIONS(2453),
    [anon_sym_break] = ACTIONS(2453),
    [anon_sym_continue] = ACTIONS(2453),
    [anon_sym_goto] = ACTIONS(2453),
    [anon_sym_not] = ACTIONS(2453),
    [anon_sym_compl] = ACTIONS(2453),
    [anon_sym_DASH_DASH] = ACTIONS(2455),
    [anon_sym_PLUS_PLUS] = ACTIONS(2455),
    [anon_sym_sizeof] = ACTIONS(2453),
    [anon_sym___alignof__] = ACTIONS(2453),
    [anon_sym___alignof] = ACTIONS(2453),
    [anon_sym__alignof] = ACTIONS(2453),
    [anon_sym_alignof] = ACTIONS(2453),
    [anon_sym__Alignof] = ACTIONS(2453),
    [anon_sym_offsetof] = ACTIONS(2453),
    [anon_sym__Generic] = ACTIONS(2453),
    [anon_sym_asm] = ACTIONS(2453),
    [anon_sym___asm__] = ACTIONS(2453),
    [anon_sym___asm] = ACTIONS(2453),
    [sym_number_literal] = ACTIONS(2455),
    [anon_sym_L_SQUOTE] = ACTIONS(2455),
    [anon_sym_u_SQUOTE] = ACTIONS(2455),
    [anon_sym_U_SQUOTE] = ACTIONS(2455),
    [anon_sym_u8_SQUOTE] = ACTIONS(2455),
    [anon_sym_SQUOTE] = ACTIONS(2455),
    [anon_sym_L_DQUOTE] = ACTIONS(2455),
    [anon_sym_u_DQUOTE] = ACTIONS(2455),
    [anon_sym_U_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8_DQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2455),
    [sym_true] = ACTIONS(2453),
    [sym_false] = ACTIONS(2453),
    [anon_sym_NULL] = ACTIONS(2453),
    [anon_sym_nullptr] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_export] = ACTIONS(2453),
    [anon_sym_module] = ACTIONS(2453),
    [anon_sym_import] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_try] = ACTIONS(2453),
    [anon_sym_delete] = ACTIONS(2453),
    [anon_sym_throw] = ACTIONS(2453),
    [anon_sym_namespace] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_concept] = ACTIONS(2453),
    [anon_sym_co_return] = ACTIONS(2453),
    [anon_sym_co_yield] = ACTIONS(2453),
    [anon_sym_R_DQUOTE] = ACTIONS(2455),
    [anon_sym_LR_DQUOTE] = ACTIONS(2455),
    [anon_sym_uR_DQUOTE] = ACTIONS(2455),
    [anon_sym_UR_DQUOTE] = ACTIONS(2455),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2455),
    [anon_sym_co_await] = ACTIONS(2453),
    [anon_sym_new] = ACTIONS(2453),
    [anon_sym_requires] = ACTIONS(2453),
    [sym_this] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [780] = {
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_include_token1] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym___cdecl] = ACTIONS(2470),
    [anon_sym___clrcall] = ACTIONS(2470),
    [anon_sym___stdcall] = ACTIONS(2470),
    [anon_sym___fastcall] = ACTIONS(2470),
    [anon_sym___thiscall] = ACTIONS(2470),
    [anon_sym___vectorcall] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym_not] = ACTIONS(2470),
    [anon_sym_compl] = ACTIONS(2470),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym___alignof__] = ACTIONS(2470),
    [anon_sym___alignof] = ACTIONS(2470),
    [anon_sym__alignof] = ACTIONS(2470),
    [anon_sym_alignof] = ACTIONS(2470),
    [anon_sym__Alignof] = ACTIONS(2470),
    [anon_sym_offsetof] = ACTIONS(2470),
    [anon_sym__Generic] = ACTIONS(2470),
    [anon_sym_asm] = ACTIONS(2470),
    [anon_sym___asm__] = ACTIONS(2470),
    [anon_sym___asm] = ACTIONS(2470),
    [sym_number_literal] = ACTIONS(2472),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2472),
    [anon_sym_u_DQUOTE] = ACTIONS(2472),
    [anon_sym_U_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [anon_sym_NULL] = ACTIONS(2470),
    [anon_sym_nullptr] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_concept] = ACTIONS(2470),
    [anon_sym_co_return] = ACTIONS(2470),
    [anon_sym_co_yield] = ACTIONS(2470),
    [anon_sym_R_DQUOTE] = ACTIONS(2472),
    [anon_sym_LR_DQUOTE] = ACTIONS(2472),
    [anon_sym_uR_DQUOTE] = ACTIONS(2472),
    [anon_sym_UR_DQUOTE] = ACTIONS(2472),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2472),
    [anon_sym_co_await] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_requires] = ACTIONS(2470),
    [sym_this] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
  },
  [781] = {
    [ts_builtin_sym_end] = ACTIONS(2502),
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_include_token1] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2500),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym___cdecl] = ACTIONS(2500),
    [anon_sym___clrcall] = ACTIONS(2500),
    [anon_sym___stdcall] = ACTIONS(2500),
    [anon_sym___fastcall] = ACTIONS(2500),
    [anon_sym___thiscall] = ACTIONS(2500),
    [anon_sym___vectorcall] = ACTIONS(2500),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2500),
    [anon_sym_switch] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2500),
    [anon_sym_default] = ACTIONS(2500),
    [anon_sym_while] = ACTIONS(2500),
    [anon_sym_do] = ACTIONS(2500),
    [anon_sym_for] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2500),
    [anon_sym_break] = ACTIONS(2500),
    [anon_sym_continue] = ACTIONS(2500),
    [anon_sym_goto] = ACTIONS(2500),
    [anon_sym_not] = ACTIONS(2500),
    [anon_sym_compl] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2500),
    [anon_sym___alignof__] = ACTIONS(2500),
    [anon_sym___alignof] = ACTIONS(2500),
    [anon_sym__alignof] = ACTIONS(2500),
    [anon_sym_alignof] = ACTIONS(2500),
    [anon_sym__Alignof] = ACTIONS(2500),
    [anon_sym_offsetof] = ACTIONS(2500),
    [anon_sym__Generic] = ACTIONS(2500),
    [anon_sym_asm] = ACTIONS(2500),
    [anon_sym___asm__] = ACTIONS(2500),
    [anon_sym___asm] = ACTIONS(2500),
    [sym_number_literal] = ACTIONS(2502),
    [anon_sym_L_SQUOTE] = ACTIONS(2502),
    [anon_sym_u_SQUOTE] = ACTIONS(2502),
    [anon_sym_U_SQUOTE] = ACTIONS(2502),
    [anon_sym_u8_SQUOTE] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_L_DQUOTE] = ACTIONS(2502),
    [anon_sym_u_DQUOTE] = ACTIONS(2502),
    [anon_sym_U_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8_DQUOTE] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [sym_true] = ACTIONS(2500),
    [sym_false] = ACTIONS(2500),
    [anon_sym_NULL] = ACTIONS(2500),
    [anon_sym_nullptr] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_export] = ACTIONS(2500),
    [anon_sym_module] = ACTIONS(2500),
    [anon_sym_import] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_try] = ACTIONS(2500),
    [anon_sym_delete] = ACTIONS(2500),
    [anon_sym_throw] = ACTIONS(2500),
    [anon_sym_namespace] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_concept] = ACTIONS(2500),
    [anon_sym_co_return] = ACTIONS(2500),
    [anon_sym_co_yield] = ACTIONS(2500),
    [anon_sym_R_DQUOTE] = ACTIONS(2502),
    [anon_sym_LR_DQUOTE] = ACTIONS(2502),
    [anon_sym_uR_DQUOTE] = ACTIONS(2502),
    [anon_sym_UR_DQUOTE] = ACTIONS(2502),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2502),
    [anon_sym_co_await] = ACTIONS(2500),
    [anon_sym_new] = ACTIONS(2500),
    [anon_sym_requires] = ACTIONS(2500),
    [sym_this] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
  },
  [782] = {
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2592),
    [aux_sym_preproc_include_token1] = ACTIONS(2592),
    [aux_sym_preproc_def_token1] = ACTIONS(2592),
    [aux_sym_preproc_if_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2592),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2592),
    [sym_preproc_directive] = ACTIONS(2592),
    [anon_sym_LPAREN2] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_STAR] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_AMP] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym___extension__] = ACTIONS(2592),
    [anon_sym_typedef] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_out] = ACTIONS(2592),
    [anon_sym_inout] = ACTIONS(2592),
    [anon_sym_virtual] = ACTIONS(2592),
    [anon_sym_extern] = ACTIONS(2592),
    [anon_sym___attribute__] = ACTIONS(2592),
    [anon_sym___attribute] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2594),
    [anon_sym___declspec] = ACTIONS(2592),
    [anon_sym___based] = ACTIONS(2592),
    [anon_sym___cdecl] = ACTIONS(2592),
    [anon_sym___clrcall] = ACTIONS(2592),
    [anon_sym___stdcall] = ACTIONS(2592),
    [anon_sym___fastcall] = ACTIONS(2592),
    [anon_sym___thiscall] = ACTIONS(2592),
    [anon_sym___vectorcall] = ACTIONS(2592),
    [anon_sym_LBRACE] = ACTIONS(2594),
    [anon_sym_signed] = ACTIONS(2592),
    [anon_sym_unsigned] = ACTIONS(2592),
    [anon_sym_long] = ACTIONS(2592),
    [anon_sym_short] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2592),
    [anon_sym_register] = ACTIONS(2592),
    [anon_sym_inline] = ACTIONS(2592),
    [anon_sym___inline] = ACTIONS(2592),
    [anon_sym___inline__] = ACTIONS(2592),
    [anon_sym___forceinline] = ACTIONS(2592),
    [anon_sym_thread_local] = ACTIONS(2592),
    [anon_sym___thread] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_constexpr] = ACTIONS(2592),
    [anon_sym_volatile] = ACTIONS(2592),
    [anon_sym_restrict] = ACTIONS(2592),
    [anon_sym___restrict__] = ACTIONS(2592),
    [anon_sym__Atomic] = ACTIONS(2592),
    [anon_sym__Noreturn] = ACTIONS(2592),
    [anon_sym_noreturn] = ACTIONS(2592),
    [anon_sym__Nonnull] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_constinit] = ACTIONS(2592),
    [anon_sym_consteval] = ACTIONS(2592),
    [anon_sym_alignas] = ACTIONS(2592),
    [anon_sym__Alignas] = ACTIONS(2592),
    [sym_primitive_type] = ACTIONS(2592),
    [anon_sym_enum] = ACTIONS(2592),
    [anon_sym_class] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_union] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_switch] = ACTIONS(2592),
    [anon_sym_case] = ACTIONS(2592),
    [anon_sym_default] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [anon_sym_do] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_break] = ACTIONS(2592),
    [anon_sym_continue] = ACTIONS(2592),
    [anon_sym_goto] = ACTIONS(2592),
    [anon_sym_not] = ACTIONS(2592),
    [anon_sym_compl] = ACTIONS(2592),
    [anon_sym_DASH_DASH] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2594),
    [anon_sym_sizeof] = ACTIONS(2592),
    [anon_sym___alignof__] = ACTIONS(2592),
    [anon_sym___alignof] = ACTIONS(2592),
    [anon_sym__alignof] = ACTIONS(2592),
    [anon_sym_alignof] = ACTIONS(2592),
    [anon_sym__Alignof] = ACTIONS(2592),
    [anon_sym_offsetof] = ACTIONS(2592),
    [anon_sym__Generic] = ACTIONS(2592),
    [anon_sym_asm] = ACTIONS(2592),
    [anon_sym___asm__] = ACTIONS(2592),
    [anon_sym___asm] = ACTIONS(2592),
    [sym_number_literal] = ACTIONS(2594),
    [anon_sym_L_SQUOTE] = ACTIONS(2594),
    [anon_sym_u_SQUOTE] = ACTIONS(2594),
    [anon_sym_U_SQUOTE] = ACTIONS(2594),
    [anon_sym_u8_SQUOTE] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_L_DQUOTE] = ACTIONS(2594),
    [anon_sym_u_DQUOTE] = ACTIONS(2594),
    [anon_sym_U_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8_DQUOTE] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2594),
    [sym_true] = ACTIONS(2592),
    [sym_false] = ACTIONS(2592),
    [anon_sym_NULL] = ACTIONS(2592),
    [anon_sym_nullptr] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2592),
    [anon_sym_decltype] = ACTIONS(2592),
    [anon_sym_explicit] = ACTIONS(2592),
    [anon_sym_typename] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_template] = ACTIONS(2592),
    [anon_sym_operator] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_delete] = ACTIONS(2592),
    [anon_sym_throw] = ACTIONS(2592),
    [anon_sym_namespace] = ACTIONS(2592),
    [anon_sym_static_assert] = ACTIONS(2592),
    [anon_sym_concept] = ACTIONS(2592),
    [anon_sym_co_return] = ACTIONS(2592),
    [anon_sym_co_yield] = ACTIONS(2592),
    [anon_sym_R_DQUOTE] = ACTIONS(2594),
    [anon_sym_LR_DQUOTE] = ACTIONS(2594),
    [anon_sym_uR_DQUOTE] = ACTIONS(2594),
    [anon_sym_UR_DQUOTE] = ACTIONS(2594),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2594),
    [anon_sym_co_await] = ACTIONS(2592),
    [anon_sym_new] = ACTIONS(2592),
    [anon_sym_requires] = ACTIONS(2592),
    [sym_this] = ACTIONS(2592),
    [anon_sym_precise] = ACTIONS(2592),
    [anon_sym_shared] = ACTIONS(2592),
    [anon_sym_groupshared] = ACTIONS(2592),
    [anon_sym_uniform] = ACTIONS(2592),
    [anon_sym_row_major] = ACTIONS(2592),
    [anon_sym_column_major] = ACTIONS(2592),
    [anon_sym_globallycoherent] = ACTIONS(2592),
    [anon_sym_centroid] = ACTIONS(2592),
    [anon_sym_noperspective] = ACTIONS(2592),
    [anon_sym_nointerpolation] = ACTIONS(2592),
    [anon_sym_sample] = ACTIONS(2592),
    [anon_sym_linear] = ACTIONS(2592),
    [anon_sym_snorm] = ACTIONS(2592),
    [anon_sym_unorm] = ACTIONS(2592),
    [anon_sym_point] = ACTIONS(2592),
    [anon_sym_line] = ACTIONS(2592),
    [anon_sym_triangleadj] = ACTIONS(2592),
    [anon_sym_lineadj] = ACTIONS(2592),
    [anon_sym_triangle] = ACTIONS(2592),
  },
  [783] = {
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2600),
    [aux_sym_preproc_include_token1] = ACTIONS(2600),
    [aux_sym_preproc_def_token1] = ACTIONS(2600),
    [aux_sym_preproc_if_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2600),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2600),
    [sym_preproc_directive] = ACTIONS(2600),
    [anon_sym_LPAREN2] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym___extension__] = ACTIONS(2600),
    [anon_sym_typedef] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_out] = ACTIONS(2600),
    [anon_sym_inout] = ACTIONS(2600),
    [anon_sym_virtual] = ACTIONS(2600),
    [anon_sym_extern] = ACTIONS(2600),
    [anon_sym___attribute__] = ACTIONS(2600),
    [anon_sym___attribute] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2602),
    [anon_sym___declspec] = ACTIONS(2600),
    [anon_sym___based] = ACTIONS(2600),
    [anon_sym___cdecl] = ACTIONS(2600),
    [anon_sym___clrcall] = ACTIONS(2600),
    [anon_sym___stdcall] = ACTIONS(2600),
    [anon_sym___fastcall] = ACTIONS(2600),
    [anon_sym___thiscall] = ACTIONS(2600),
    [anon_sym___vectorcall] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_signed] = ACTIONS(2600),
    [anon_sym_unsigned] = ACTIONS(2600),
    [anon_sym_long] = ACTIONS(2600),
    [anon_sym_short] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2600),
    [anon_sym_register] = ACTIONS(2600),
    [anon_sym_inline] = ACTIONS(2600),
    [anon_sym___inline] = ACTIONS(2600),
    [anon_sym___inline__] = ACTIONS(2600),
    [anon_sym___forceinline] = ACTIONS(2600),
    [anon_sym_thread_local] = ACTIONS(2600),
    [anon_sym___thread] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_constexpr] = ACTIONS(2600),
    [anon_sym_volatile] = ACTIONS(2600),
    [anon_sym_restrict] = ACTIONS(2600),
    [anon_sym___restrict__] = ACTIONS(2600),
    [anon_sym__Atomic] = ACTIONS(2600),
    [anon_sym__Noreturn] = ACTIONS(2600),
    [anon_sym_noreturn] = ACTIONS(2600),
    [anon_sym__Nonnull] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_constinit] = ACTIONS(2600),
    [anon_sym_consteval] = ACTIONS(2600),
    [anon_sym_alignas] = ACTIONS(2600),
    [anon_sym__Alignas] = ACTIONS(2600),
    [sym_primitive_type] = ACTIONS(2600),
    [anon_sym_enum] = ACTIONS(2600),
    [anon_sym_class] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_union] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2600),
    [anon_sym_default] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [anon_sym_do] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_break] = ACTIONS(2600),
    [anon_sym_continue] = ACTIONS(2600),
    [anon_sym_goto] = ACTIONS(2600),
    [anon_sym_not] = ACTIONS(2600),
    [anon_sym_compl] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2602),
    [anon_sym_sizeof] = ACTIONS(2600),
    [anon_sym___alignof__] = ACTIONS(2600),
    [anon_sym___alignof] = ACTIONS(2600),
    [anon_sym__alignof] = ACTIONS(2600),
    [anon_sym_alignof] = ACTIONS(2600),
    [anon_sym__Alignof] = ACTIONS(2600),
    [anon_sym_offsetof] = ACTIONS(2600),
    [anon_sym__Generic] = ACTIONS(2600),
    [anon_sym_asm] = ACTIONS(2600),
    [anon_sym___asm__] = ACTIONS(2600),
    [anon_sym___asm] = ACTIONS(2600),
    [sym_number_literal] = ACTIONS(2602),
    [anon_sym_L_SQUOTE] = ACTIONS(2602),
    [anon_sym_u_SQUOTE] = ACTIONS(2602),
    [anon_sym_U_SQUOTE] = ACTIONS(2602),
    [anon_sym_u8_SQUOTE] = ACTIONS(2602),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_L_DQUOTE] = ACTIONS(2602),
    [anon_sym_u_DQUOTE] = ACTIONS(2602),
    [anon_sym_U_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8_DQUOTE] = ACTIONS(2602),
    [anon_sym_DQUOTE] = ACTIONS(2602),
    [sym_true] = ACTIONS(2600),
    [sym_false] = ACTIONS(2600),
    [anon_sym_NULL] = ACTIONS(2600),
    [anon_sym_nullptr] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2600),
    [anon_sym_decltype] = ACTIONS(2600),
    [anon_sym_explicit] = ACTIONS(2600),
    [anon_sym_typename] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_template] = ACTIONS(2600),
    [anon_sym_operator] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_delete] = ACTIONS(2600),
    [anon_sym_throw] = ACTIONS(2600),
    [anon_sym_namespace] = ACTIONS(2600),
    [anon_sym_static_assert] = ACTIONS(2600),
    [anon_sym_concept] = ACTIONS(2600),
    [anon_sym_co_return] = ACTIONS(2600),
    [anon_sym_co_yield] = ACTIONS(2600),
    [anon_sym_R_DQUOTE] = ACTIONS(2602),
    [anon_sym_LR_DQUOTE] = ACTIONS(2602),
    [anon_sym_uR_DQUOTE] = ACTIONS(2602),
    [anon_sym_UR_DQUOTE] = ACTIONS(2602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2602),
    [anon_sym_co_await] = ACTIONS(2600),
    [anon_sym_new] = ACTIONS(2600),
    [anon_sym_requires] = ACTIONS(2600),
    [sym_this] = ACTIONS(2600),
    [anon_sym_precise] = ACTIONS(2600),
    [anon_sym_shared] = ACTIONS(2600),
    [anon_sym_groupshared] = ACTIONS(2600),
    [anon_sym_uniform] = ACTIONS(2600),
    [anon_sym_row_major] = ACTIONS(2600),
    [anon_sym_column_major] = ACTIONS(2600),
    [anon_sym_globallycoherent] = ACTIONS(2600),
    [anon_sym_centroid] = ACTIONS(2600),
    [anon_sym_noperspective] = ACTIONS(2600),
    [anon_sym_nointerpolation] = ACTIONS(2600),
    [anon_sym_sample] = ACTIONS(2600),
    [anon_sym_linear] = ACTIONS(2600),
    [anon_sym_snorm] = ACTIONS(2600),
    [anon_sym_unorm] = ACTIONS(2600),
    [anon_sym_point] = ACTIONS(2600),
    [anon_sym_line] = ACTIONS(2600),
    [anon_sym_triangleadj] = ACTIONS(2600),
    [anon_sym_lineadj] = ACTIONS(2600),
    [anon_sym_triangle] = ACTIONS(2600),
  },
  [784] = {
    [ts_builtin_sym_end] = ACTIONS(3065),
    [sym_identifier] = ACTIONS(3067),
    [aux_sym_preproc_include_token1] = ACTIONS(3067),
    [aux_sym_preproc_def_token1] = ACTIONS(3067),
    [aux_sym_preproc_if_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3067),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3067),
    [sym_preproc_directive] = ACTIONS(3067),
    [anon_sym_LPAREN2] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym___extension__] = ACTIONS(3067),
    [anon_sym_typedef] = ACTIONS(3067),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_out] = ACTIONS(3067),
    [anon_sym_inout] = ACTIONS(3067),
    [anon_sym_virtual] = ACTIONS(3067),
    [anon_sym_extern] = ACTIONS(3067),
    [anon_sym___attribute__] = ACTIONS(3067),
    [anon_sym___attribute] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3065),
    [anon_sym___declspec] = ACTIONS(3067),
    [anon_sym___based] = ACTIONS(3067),
    [anon_sym___cdecl] = ACTIONS(3067),
    [anon_sym___clrcall] = ACTIONS(3067),
    [anon_sym___stdcall] = ACTIONS(3067),
    [anon_sym___fastcall] = ACTIONS(3067),
    [anon_sym___thiscall] = ACTIONS(3067),
    [anon_sym___vectorcall] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3065),
    [anon_sym_signed] = ACTIONS(3067),
    [anon_sym_unsigned] = ACTIONS(3067),
    [anon_sym_long] = ACTIONS(3067),
    [anon_sym_short] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_static] = ACTIONS(3067),
    [anon_sym_register] = ACTIONS(3067),
    [anon_sym_inline] = ACTIONS(3067),
    [anon_sym___inline] = ACTIONS(3067),
    [anon_sym___inline__] = ACTIONS(3067),
    [anon_sym___forceinline] = ACTIONS(3067),
    [anon_sym_thread_local] = ACTIONS(3067),
    [anon_sym___thread] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_constexpr] = ACTIONS(3067),
    [anon_sym_volatile] = ACTIONS(3067),
    [anon_sym_restrict] = ACTIONS(3067),
    [anon_sym___restrict__] = ACTIONS(3067),
    [anon_sym__Atomic] = ACTIONS(3067),
    [anon_sym__Noreturn] = ACTIONS(3067),
    [anon_sym_noreturn] = ACTIONS(3067),
    [anon_sym__Nonnull] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_constinit] = ACTIONS(3067),
    [anon_sym_consteval] = ACTIONS(3067),
    [anon_sym_alignas] = ACTIONS(3067),
    [anon_sym__Alignas] = ACTIONS(3067),
    [sym_primitive_type] = ACTIONS(3067),
    [anon_sym_enum] = ACTIONS(3067),
    [anon_sym_class] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_union] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_case] = ACTIONS(3067),
    [anon_sym_default] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_break] = ACTIONS(3067),
    [anon_sym_continue] = ACTIONS(3067),
    [anon_sym_goto] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3067),
    [anon_sym_compl] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3065),
    [anon_sym_PLUS_PLUS] = ACTIONS(3065),
    [anon_sym_sizeof] = ACTIONS(3067),
    [anon_sym___alignof__] = ACTIONS(3067),
    [anon_sym___alignof] = ACTIONS(3067),
    [anon_sym__alignof] = ACTIONS(3067),
    [anon_sym_alignof] = ACTIONS(3067),
    [anon_sym__Alignof] = ACTIONS(3067),
    [anon_sym_offsetof] = ACTIONS(3067),
    [anon_sym__Generic] = ACTIONS(3067),
    [anon_sym_asm] = ACTIONS(3067),
    [anon_sym___asm__] = ACTIONS(3067),
    [anon_sym___asm] = ACTIONS(3067),
    [sym_number_literal] = ACTIONS(3065),
    [anon_sym_L_SQUOTE] = ACTIONS(3065),
    [anon_sym_u_SQUOTE] = ACTIONS(3065),
    [anon_sym_U_SQUOTE] = ACTIONS(3065),
    [anon_sym_u8_SQUOTE] = ACTIONS(3065),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_L_DQUOTE] = ACTIONS(3065),
    [anon_sym_u_DQUOTE] = ACTIONS(3065),
    [anon_sym_U_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8_DQUOTE] = ACTIONS(3065),
    [anon_sym_DQUOTE] = ACTIONS(3065),
    [sym_true] = ACTIONS(3067),
    [sym_false] = ACTIONS(3067),
    [anon_sym_NULL] = ACTIONS(3067),
    [anon_sym_nullptr] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3067),
    [anon_sym_decltype] = ACTIONS(3067),
    [anon_sym_explicit] = ACTIONS(3067),
    [anon_sym_typename] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_template] = ACTIONS(3067),
    [anon_sym_operator] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_delete] = ACTIONS(3067),
    [anon_sym_throw] = ACTIONS(3067),
    [anon_sym_namespace] = ACTIONS(3067),
    [anon_sym_static_assert] = ACTIONS(3067),
    [anon_sym_concept] = ACTIONS(3067),
    [anon_sym_co_return] = ACTIONS(3067),
    [anon_sym_co_yield] = ACTIONS(3067),
    [anon_sym_R_DQUOTE] = ACTIONS(3065),
    [anon_sym_LR_DQUOTE] = ACTIONS(3065),
    [anon_sym_uR_DQUOTE] = ACTIONS(3065),
    [anon_sym_UR_DQUOTE] = ACTIONS(3065),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3065),
    [anon_sym_co_await] = ACTIONS(3067),
    [anon_sym_new] = ACTIONS(3067),
    [anon_sym_requires] = ACTIONS(3067),
    [sym_this] = ACTIONS(3067),
    [anon_sym_precise] = ACTIONS(3067),
    [anon_sym_shared] = ACTIONS(3067),
    [anon_sym_groupshared] = ACTIONS(3067),
    [anon_sym_uniform] = ACTIONS(3067),
    [anon_sym_row_major] = ACTIONS(3067),
    [anon_sym_column_major] = ACTIONS(3067),
    [anon_sym_globallycoherent] = ACTIONS(3067),
    [anon_sym_centroid] = ACTIONS(3067),
    [anon_sym_noperspective] = ACTIONS(3067),
    [anon_sym_nointerpolation] = ACTIONS(3067),
    [anon_sym_sample] = ACTIONS(3067),
    [anon_sym_linear] = ACTIONS(3067),
    [anon_sym_snorm] = ACTIONS(3067),
    [anon_sym_unorm] = ACTIONS(3067),
    [anon_sym_point] = ACTIONS(3067),
    [anon_sym_line] = ACTIONS(3067),
    [anon_sym_triangleadj] = ACTIONS(3067),
    [anon_sym_lineadj] = ACTIONS(3067),
    [anon_sym_triangle] = ACTIONS(3067),
  },
  [785] = {
    [ts_builtin_sym_end] = ACTIONS(2610),
    [sym_identifier] = ACTIONS(2608),
    [aux_sym_preproc_include_token1] = ACTIONS(2608),
    [aux_sym_preproc_def_token1] = ACTIONS(2608),
    [aux_sym_preproc_if_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2608),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2608),
    [sym_preproc_directive] = ACTIONS(2608),
    [anon_sym_LPAREN2] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_STAR] = ACTIONS(2610),
    [anon_sym_AMP_AMP] = ACTIONS(2610),
    [anon_sym_AMP] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym___extension__] = ACTIONS(2608),
    [anon_sym_typedef] = ACTIONS(2608),
    [anon_sym_in] = ACTIONS(2608),
    [anon_sym_out] = ACTIONS(2608),
    [anon_sym_inout] = ACTIONS(2608),
    [anon_sym_virtual] = ACTIONS(2608),
    [anon_sym_extern] = ACTIONS(2608),
    [anon_sym___attribute__] = ACTIONS(2608),
    [anon_sym___attribute] = ACTIONS(2608),
    [anon_sym_using] = ACTIONS(2608),
    [anon_sym_COLON_COLON] = ACTIONS(2610),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2610),
    [anon_sym___declspec] = ACTIONS(2608),
    [anon_sym___based] = ACTIONS(2608),
    [anon_sym___cdecl] = ACTIONS(2608),
    [anon_sym___clrcall] = ACTIONS(2608),
    [anon_sym___stdcall] = ACTIONS(2608),
    [anon_sym___fastcall] = ACTIONS(2608),
    [anon_sym___thiscall] = ACTIONS(2608),
    [anon_sym___vectorcall] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_signed] = ACTIONS(2608),
    [anon_sym_unsigned] = ACTIONS(2608),
    [anon_sym_long] = ACTIONS(2608),
    [anon_sym_short] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2608),
    [anon_sym_register] = ACTIONS(2608),
    [anon_sym_inline] = ACTIONS(2608),
    [anon_sym___inline] = ACTIONS(2608),
    [anon_sym___inline__] = ACTIONS(2608),
    [anon_sym___forceinline] = ACTIONS(2608),
    [anon_sym_thread_local] = ACTIONS(2608),
    [anon_sym___thread] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [anon_sym_constexpr] = ACTIONS(2608),
    [anon_sym_volatile] = ACTIONS(2608),
    [anon_sym_restrict] = ACTIONS(2608),
    [anon_sym___restrict__] = ACTIONS(2608),
    [anon_sym__Atomic] = ACTIONS(2608),
    [anon_sym__Noreturn] = ACTIONS(2608),
    [anon_sym_noreturn] = ACTIONS(2608),
    [anon_sym__Nonnull] = ACTIONS(2608),
    [anon_sym_mutable] = ACTIONS(2608),
    [anon_sym_constinit] = ACTIONS(2608),
    [anon_sym_consteval] = ACTIONS(2608),
    [anon_sym_alignas] = ACTIONS(2608),
    [anon_sym__Alignas] = ACTIONS(2608),
    [sym_primitive_type] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_struct] = ACTIONS(2608),
    [anon_sym_union] = ACTIONS(2608),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_goto] = ACTIONS(2608),
    [anon_sym_not] = ACTIONS(2608),
    [anon_sym_compl] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_sizeof] = ACTIONS(2608),
    [anon_sym___alignof__] = ACTIONS(2608),
    [anon_sym___alignof] = ACTIONS(2608),
    [anon_sym__alignof] = ACTIONS(2608),
    [anon_sym_alignof] = ACTIONS(2608),
    [anon_sym__Alignof] = ACTIONS(2608),
    [anon_sym_offsetof] = ACTIONS(2608),
    [anon_sym__Generic] = ACTIONS(2608),
    [anon_sym_asm] = ACTIONS(2608),
    [anon_sym___asm__] = ACTIONS(2608),
    [anon_sym___asm] = ACTIONS(2608),
    [sym_number_literal] = ACTIONS(2610),
    [anon_sym_L_SQUOTE] = ACTIONS(2610),
    [anon_sym_u_SQUOTE] = ACTIONS(2610),
    [anon_sym_U_SQUOTE] = ACTIONS(2610),
    [anon_sym_u8_SQUOTE] = ACTIONS(2610),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [anon_sym_L_DQUOTE] = ACTIONS(2610),
    [anon_sym_u_DQUOTE] = ACTIONS(2610),
    [anon_sym_U_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8_DQUOTE] = ACTIONS(2610),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [sym_true] = ACTIONS(2608),
    [sym_false] = ACTIONS(2608),
    [anon_sym_NULL] = ACTIONS(2608),
    [anon_sym_nullptr] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2608),
    [anon_sym_decltype] = ACTIONS(2608),
    [anon_sym_explicit] = ACTIONS(2608),
    [anon_sym_typename] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_template] = ACTIONS(2608),
    [anon_sym_operator] = ACTIONS(2608),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_static_assert] = ACTIONS(2608),
    [anon_sym_concept] = ACTIONS(2608),
    [anon_sym_co_return] = ACTIONS(2608),
    [anon_sym_co_yield] = ACTIONS(2608),
    [anon_sym_R_DQUOTE] = ACTIONS(2610),
    [anon_sym_LR_DQUOTE] = ACTIONS(2610),
    [anon_sym_uR_DQUOTE] = ACTIONS(2610),
    [anon_sym_UR_DQUOTE] = ACTIONS(2610),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2610),
    [anon_sym_co_await] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [anon_sym_requires] = ACTIONS(2608),
    [sym_this] = ACTIONS(2608),
    [anon_sym_precise] = ACTIONS(2608),
    [anon_sym_shared] = ACTIONS(2608),
    [anon_sym_groupshared] = ACTIONS(2608),
    [anon_sym_uniform] = ACTIONS(2608),
    [anon_sym_row_major] = ACTIONS(2608),
    [anon_sym_column_major] = ACTIONS(2608),
    [anon_sym_globallycoherent] = ACTIONS(2608),
    [anon_sym_centroid] = ACTIONS(2608),
    [anon_sym_noperspective] = ACTIONS(2608),
    [anon_sym_nointerpolation] = ACTIONS(2608),
    [anon_sym_sample] = ACTIONS(2608),
    [anon_sym_linear] = ACTIONS(2608),
    [anon_sym_snorm] = ACTIONS(2608),
    [anon_sym_unorm] = ACTIONS(2608),
    [anon_sym_point] = ACTIONS(2608),
    [anon_sym_line] = ACTIONS(2608),
    [anon_sym_triangleadj] = ACTIONS(2608),
    [anon_sym_lineadj] = ACTIONS(2608),
    [anon_sym_triangle] = ACTIONS(2608),
  },
  [786] = {
    [ts_builtin_sym_end] = ACTIONS(2530),
    [sym_identifier] = ACTIONS(2528),
    [aux_sym_preproc_include_token1] = ACTIONS(2528),
    [aux_sym_preproc_def_token1] = ACTIONS(2528),
    [aux_sym_preproc_if_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2528),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2528),
    [sym_preproc_directive] = ACTIONS(2528),
    [anon_sym_LPAREN2] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2528),
    [anon_sym_STAR] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym___extension__] = ACTIONS(2528),
    [anon_sym_typedef] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2528),
    [anon_sym_out] = ACTIONS(2528),
    [anon_sym_inout] = ACTIONS(2528),
    [anon_sym_virtual] = ACTIONS(2528),
    [anon_sym_extern] = ACTIONS(2528),
    [anon_sym___attribute__] = ACTIONS(2528),
    [anon_sym___attribute] = ACTIONS(2528),
    [anon_sym_using] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2530),
    [anon_sym___declspec] = ACTIONS(2528),
    [anon_sym___based] = ACTIONS(2528),
    [anon_sym___cdecl] = ACTIONS(2528),
    [anon_sym___clrcall] = ACTIONS(2528),
    [anon_sym___stdcall] = ACTIONS(2528),
    [anon_sym___fastcall] = ACTIONS(2528),
    [anon_sym___thiscall] = ACTIONS(2528),
    [anon_sym___vectorcall] = ACTIONS(2528),
    [anon_sym_LBRACE] = ACTIONS(2530),
    [anon_sym_signed] = ACTIONS(2528),
    [anon_sym_unsigned] = ACTIONS(2528),
    [anon_sym_long] = ACTIONS(2528),
    [anon_sym_short] = ACTIONS(2528),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2528),
    [anon_sym_register] = ACTIONS(2528),
    [anon_sym_inline] = ACTIONS(2528),
    [anon_sym___inline] = ACTIONS(2528),
    [anon_sym___inline__] = ACTIONS(2528),
    [anon_sym___forceinline] = ACTIONS(2528),
    [anon_sym_thread_local] = ACTIONS(2528),
    [anon_sym___thread] = ACTIONS(2528),
    [anon_sym_const] = ACTIONS(2528),
    [anon_sym_constexpr] = ACTIONS(2528),
    [anon_sym_volatile] = ACTIONS(2528),
    [anon_sym_restrict] = ACTIONS(2528),
    [anon_sym___restrict__] = ACTIONS(2528),
    [anon_sym__Atomic] = ACTIONS(2528),
    [anon_sym__Noreturn] = ACTIONS(2528),
    [anon_sym_noreturn] = ACTIONS(2528),
    [anon_sym__Nonnull] = ACTIONS(2528),
    [anon_sym_mutable] = ACTIONS(2528),
    [anon_sym_constinit] = ACTIONS(2528),
    [anon_sym_consteval] = ACTIONS(2528),
    [anon_sym_alignas] = ACTIONS(2528),
    [anon_sym__Alignas] = ACTIONS(2528),
    [sym_primitive_type] = ACTIONS(2528),
    [anon_sym_enum] = ACTIONS(2528),
    [anon_sym_class] = ACTIONS(2528),
    [anon_sym_struct] = ACTIONS(2528),
    [anon_sym_union] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2528),
    [anon_sym_switch] = ACTIONS(2528),
    [anon_sym_case] = ACTIONS(2528),
    [anon_sym_default] = ACTIONS(2528),
    [anon_sym_while] = ACTIONS(2528),
    [anon_sym_do] = ACTIONS(2528),
    [anon_sym_for] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2528),
    [anon_sym_break] = ACTIONS(2528),
    [anon_sym_continue] = ACTIONS(2528),
    [anon_sym_goto] = ACTIONS(2528),
    [anon_sym_not] = ACTIONS(2528),
    [anon_sym_compl] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2528),
    [anon_sym___alignof__] = ACTIONS(2528),
    [anon_sym___alignof] = ACTIONS(2528),
    [anon_sym__alignof] = ACTIONS(2528),
    [anon_sym_alignof] = ACTIONS(2528),
    [anon_sym__Alignof] = ACTIONS(2528),
    [anon_sym_offsetof] = ACTIONS(2528),
    [anon_sym__Generic] = ACTIONS(2528),
    [anon_sym_asm] = ACTIONS(2528),
    [anon_sym___asm__] = ACTIONS(2528),
    [anon_sym___asm] = ACTIONS(2528),
    [sym_number_literal] = ACTIONS(2530),
    [anon_sym_L_SQUOTE] = ACTIONS(2530),
    [anon_sym_u_SQUOTE] = ACTIONS(2530),
    [anon_sym_U_SQUOTE] = ACTIONS(2530),
    [anon_sym_u8_SQUOTE] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_L_DQUOTE] = ACTIONS(2530),
    [anon_sym_u_DQUOTE] = ACTIONS(2530),
    [anon_sym_U_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8_DQUOTE] = ACTIONS(2530),
    [anon_sym_DQUOTE] = ACTIONS(2530),
    [sym_true] = ACTIONS(2528),
    [sym_false] = ACTIONS(2528),
    [anon_sym_NULL] = ACTIONS(2528),
    [anon_sym_nullptr] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2528),
    [anon_sym_decltype] = ACTIONS(2528),
    [anon_sym_explicit] = ACTIONS(2528),
    [anon_sym_typename] = ACTIONS(2528),
    [anon_sym_export] = ACTIONS(2528),
    [anon_sym_module] = ACTIONS(2528),
    [anon_sym_import] = ACTIONS(2528),
    [anon_sym_template] = ACTIONS(2528),
    [anon_sym_operator] = ACTIONS(2528),
    [anon_sym_try] = ACTIONS(2528),
    [anon_sym_delete] = ACTIONS(2528),
    [anon_sym_throw] = ACTIONS(2528),
    [anon_sym_namespace] = ACTIONS(2528),
    [anon_sym_static_assert] = ACTIONS(2528),
    [anon_sym_concept] = ACTIONS(2528),
    [anon_sym_co_return] = ACTIONS(2528),
    [anon_sym_co_yield] = ACTIONS(2528),
    [anon_sym_R_DQUOTE] = ACTIONS(2530),
    [anon_sym_LR_DQUOTE] = ACTIONS(2530),
    [anon_sym_uR_DQUOTE] = ACTIONS(2530),
    [anon_sym_UR_DQUOTE] = ACTIONS(2530),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2530),
    [anon_sym_co_await] = ACTIONS(2528),
    [anon_sym_new] = ACTIONS(2528),
    [anon_sym_requires] = ACTIONS(2528),
    [sym_this] = ACTIONS(2528),
    [anon_sym_precise] = ACTIONS(2528),
    [anon_sym_shared] = ACTIONS(2528),
    [anon_sym_groupshared] = ACTIONS(2528),
    [anon_sym_uniform] = ACTIONS(2528),
    [anon_sym_row_major] = ACTIONS(2528),
    [anon_sym_column_major] = ACTIONS(2528),
    [anon_sym_globallycoherent] = ACTIONS(2528),
    [anon_sym_centroid] = ACTIONS(2528),
    [anon_sym_noperspective] = ACTIONS(2528),
    [anon_sym_nointerpolation] = ACTIONS(2528),
    [anon_sym_sample] = ACTIONS(2528),
    [anon_sym_linear] = ACTIONS(2528),
    [anon_sym_snorm] = ACTIONS(2528),
    [anon_sym_unorm] = ACTIONS(2528),
    [anon_sym_point] = ACTIONS(2528),
    [anon_sym_line] = ACTIONS(2528),
    [anon_sym_triangleadj] = ACTIONS(2528),
    [anon_sym_lineadj] = ACTIONS(2528),
    [anon_sym_triangle] = ACTIONS(2528),
  },
  [787] = {
    [ts_builtin_sym_end] = ACTIONS(2534),
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_include_token1] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym___cdecl] = ACTIONS(2532),
    [anon_sym___clrcall] = ACTIONS(2532),
    [anon_sym___stdcall] = ACTIONS(2532),
    [anon_sym___fastcall] = ACTIONS(2532),
    [anon_sym___thiscall] = ACTIONS(2532),
    [anon_sym___vectorcall] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2532),
    [anon_sym_switch] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2532),
    [anon_sym_default] = ACTIONS(2532),
    [anon_sym_while] = ACTIONS(2532),
    [anon_sym_do] = ACTIONS(2532),
    [anon_sym_for] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2532),
    [anon_sym_break] = ACTIONS(2532),
    [anon_sym_continue] = ACTIONS(2532),
    [anon_sym_goto] = ACTIONS(2532),
    [anon_sym_not] = ACTIONS(2532),
    [anon_sym_compl] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2532),
    [anon_sym___alignof__] = ACTIONS(2532),
    [anon_sym___alignof] = ACTIONS(2532),
    [anon_sym__alignof] = ACTIONS(2532),
    [anon_sym_alignof] = ACTIONS(2532),
    [anon_sym__Alignof] = ACTIONS(2532),
    [anon_sym_offsetof] = ACTIONS(2532),
    [anon_sym__Generic] = ACTIONS(2532),
    [anon_sym_asm] = ACTIONS(2532),
    [anon_sym___asm__] = ACTIONS(2532),
    [anon_sym___asm] = ACTIONS(2532),
    [sym_number_literal] = ACTIONS(2534),
    [anon_sym_L_SQUOTE] = ACTIONS(2534),
    [anon_sym_u_SQUOTE] = ACTIONS(2534),
    [anon_sym_U_SQUOTE] = ACTIONS(2534),
    [anon_sym_u8_SQUOTE] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_L_DQUOTE] = ACTIONS(2534),
    [anon_sym_u_DQUOTE] = ACTIONS(2534),
    [anon_sym_U_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8_DQUOTE] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [anon_sym_NULL] = ACTIONS(2532),
    [anon_sym_nullptr] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_export] = ACTIONS(2532),
    [anon_sym_module] = ACTIONS(2532),
    [anon_sym_import] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_try] = ACTIONS(2532),
    [anon_sym_delete] = ACTIONS(2532),
    [anon_sym_throw] = ACTIONS(2532),
    [anon_sym_namespace] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_concept] = ACTIONS(2532),
    [anon_sym_co_return] = ACTIONS(2532),
    [anon_sym_co_yield] = ACTIONS(2532),
    [anon_sym_R_DQUOTE] = ACTIONS(2534),
    [anon_sym_LR_DQUOTE] = ACTIONS(2534),
    [anon_sym_uR_DQUOTE] = ACTIONS(2534),
    [anon_sym_UR_DQUOTE] = ACTIONS(2534),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2534),
    [anon_sym_co_await] = ACTIONS(2532),
    [anon_sym_new] = ACTIONS(2532),
    [anon_sym_requires] = ACTIONS(2532),
    [sym_this] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
  },
  [788] = {
    [ts_builtin_sym_end] = ACTIONS(2658),
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_include_token1] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym___cdecl] = ACTIONS(2656),
    [anon_sym___clrcall] = ACTIONS(2656),
    [anon_sym___stdcall] = ACTIONS(2656),
    [anon_sym___fastcall] = ACTIONS(2656),
    [anon_sym___thiscall] = ACTIONS(2656),
    [anon_sym___vectorcall] = ACTIONS(2656),
    [anon_sym_LBRACE] = ACTIONS(2658),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2656),
    [anon_sym_switch] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2656),
    [anon_sym_default] = ACTIONS(2656),
    [anon_sym_while] = ACTIONS(2656),
    [anon_sym_do] = ACTIONS(2656),
    [anon_sym_for] = ACTIONS(2656),
    [anon_sym_return] = ACTIONS(2656),
    [anon_sym_break] = ACTIONS(2656),
    [anon_sym_continue] = ACTIONS(2656),
    [anon_sym_goto] = ACTIONS(2656),
    [anon_sym_not] = ACTIONS(2656),
    [anon_sym_compl] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_sizeof] = ACTIONS(2656),
    [anon_sym___alignof__] = ACTIONS(2656),
    [anon_sym___alignof] = ACTIONS(2656),
    [anon_sym__alignof] = ACTIONS(2656),
    [anon_sym_alignof] = ACTIONS(2656),
    [anon_sym__Alignof] = ACTIONS(2656),
    [anon_sym_offsetof] = ACTIONS(2656),
    [anon_sym__Generic] = ACTIONS(2656),
    [anon_sym_asm] = ACTIONS(2656),
    [anon_sym___asm__] = ACTIONS(2656),
    [anon_sym___asm] = ACTIONS(2656),
    [sym_number_literal] = ACTIONS(2658),
    [anon_sym_L_SQUOTE] = ACTIONS(2658),
    [anon_sym_u_SQUOTE] = ACTIONS(2658),
    [anon_sym_U_SQUOTE] = ACTIONS(2658),
    [anon_sym_u8_SQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_L_DQUOTE] = ACTIONS(2658),
    [anon_sym_u_DQUOTE] = ACTIONS(2658),
    [anon_sym_U_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8_DQUOTE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [anon_sym_NULL] = ACTIONS(2656),
    [anon_sym_nullptr] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_export] = ACTIONS(2656),
    [anon_sym_module] = ACTIONS(2656),
    [anon_sym_import] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_try] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_throw] = ACTIONS(2656),
    [anon_sym_namespace] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_concept] = ACTIONS(2656),
    [anon_sym_co_return] = ACTIONS(2656),
    [anon_sym_co_yield] = ACTIONS(2656),
    [anon_sym_R_DQUOTE] = ACTIONS(2658),
    [anon_sym_LR_DQUOTE] = ACTIONS(2658),
    [anon_sym_uR_DQUOTE] = ACTIONS(2658),
    [anon_sym_UR_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2658),
    [anon_sym_co_await] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_requires] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [789] = {
    [ts_builtin_sym_end] = ACTIONS(3069),
    [sym_identifier] = ACTIONS(3071),
    [aux_sym_preproc_include_token1] = ACTIONS(3071),
    [aux_sym_preproc_def_token1] = ACTIONS(3071),
    [aux_sym_preproc_if_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3071),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3071),
    [sym_preproc_directive] = ACTIONS(3071),
    [anon_sym_LPAREN2] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym___extension__] = ACTIONS(3071),
    [anon_sym_typedef] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_out] = ACTIONS(3071),
    [anon_sym_inout] = ACTIONS(3071),
    [anon_sym_virtual] = ACTIONS(3071),
    [anon_sym_extern] = ACTIONS(3071),
    [anon_sym___attribute__] = ACTIONS(3071),
    [anon_sym___attribute] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3069),
    [anon_sym___declspec] = ACTIONS(3071),
    [anon_sym___based] = ACTIONS(3071),
    [anon_sym___cdecl] = ACTIONS(3071),
    [anon_sym___clrcall] = ACTIONS(3071),
    [anon_sym___stdcall] = ACTIONS(3071),
    [anon_sym___fastcall] = ACTIONS(3071),
    [anon_sym___thiscall] = ACTIONS(3071),
    [anon_sym___vectorcall] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3069),
    [anon_sym_signed] = ACTIONS(3071),
    [anon_sym_unsigned] = ACTIONS(3071),
    [anon_sym_long] = ACTIONS(3071),
    [anon_sym_short] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_static] = ACTIONS(3071),
    [anon_sym_register] = ACTIONS(3071),
    [anon_sym_inline] = ACTIONS(3071),
    [anon_sym___inline] = ACTIONS(3071),
    [anon_sym___inline__] = ACTIONS(3071),
    [anon_sym___forceinline] = ACTIONS(3071),
    [anon_sym_thread_local] = ACTIONS(3071),
    [anon_sym___thread] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_constexpr] = ACTIONS(3071),
    [anon_sym_volatile] = ACTIONS(3071),
    [anon_sym_restrict] = ACTIONS(3071),
    [anon_sym___restrict__] = ACTIONS(3071),
    [anon_sym__Atomic] = ACTIONS(3071),
    [anon_sym__Noreturn] = ACTIONS(3071),
    [anon_sym_noreturn] = ACTIONS(3071),
    [anon_sym__Nonnull] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_constinit] = ACTIONS(3071),
    [anon_sym_consteval] = ACTIONS(3071),
    [anon_sym_alignas] = ACTIONS(3071),
    [anon_sym__Alignas] = ACTIONS(3071),
    [sym_primitive_type] = ACTIONS(3071),
    [anon_sym_enum] = ACTIONS(3071),
    [anon_sym_class] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_union] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_switch] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(3071),
    [anon_sym_default] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [anon_sym_do] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_break] = ACTIONS(3071),
    [anon_sym_continue] = ACTIONS(3071),
    [anon_sym_goto] = ACTIONS(3071),
    [anon_sym_not] = ACTIONS(3071),
    [anon_sym_compl] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3069),
    [anon_sym_PLUS_PLUS] = ACTIONS(3069),
    [anon_sym_sizeof] = ACTIONS(3071),
    [anon_sym___alignof__] = ACTIONS(3071),
    [anon_sym___alignof] = ACTIONS(3071),
    [anon_sym__alignof] = ACTIONS(3071),
    [anon_sym_alignof] = ACTIONS(3071),
    [anon_sym__Alignof] = ACTIONS(3071),
    [anon_sym_offsetof] = ACTIONS(3071),
    [anon_sym__Generic] = ACTIONS(3071),
    [anon_sym_asm] = ACTIONS(3071),
    [anon_sym___asm__] = ACTIONS(3071),
    [anon_sym___asm] = ACTIONS(3071),
    [sym_number_literal] = ACTIONS(3069),
    [anon_sym_L_SQUOTE] = ACTIONS(3069),
    [anon_sym_u_SQUOTE] = ACTIONS(3069),
    [anon_sym_U_SQUOTE] = ACTIONS(3069),
    [anon_sym_u8_SQUOTE] = ACTIONS(3069),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_L_DQUOTE] = ACTIONS(3069),
    [anon_sym_u_DQUOTE] = ACTIONS(3069),
    [anon_sym_U_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8_DQUOTE] = ACTIONS(3069),
    [anon_sym_DQUOTE] = ACTIONS(3069),
    [sym_true] = ACTIONS(3071),
    [sym_false] = ACTIONS(3071),
    [anon_sym_NULL] = ACTIONS(3071),
    [anon_sym_nullptr] = ACTIONS(3071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3071),
    [anon_sym_decltype] = ACTIONS(3071),
    [anon_sym_explicit] = ACTIONS(3071),
    [anon_sym_typename] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_template] = ACTIONS(3071),
    [anon_sym_operator] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_delete] = ACTIONS(3071),
    [anon_sym_throw] = ACTIONS(3071),
    [anon_sym_namespace] = ACTIONS(3071),
    [anon_sym_static_assert] = ACTIONS(3071),
    [anon_sym_concept] = ACTIONS(3071),
    [anon_sym_co_return] = ACTIONS(3071),
    [anon_sym_co_yield] = ACTIONS(3071),
    [anon_sym_R_DQUOTE] = ACTIONS(3069),
    [anon_sym_LR_DQUOTE] = ACTIONS(3069),
    [anon_sym_uR_DQUOTE] = ACTIONS(3069),
    [anon_sym_UR_DQUOTE] = ACTIONS(3069),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3069),
    [anon_sym_co_await] = ACTIONS(3071),
    [anon_sym_new] = ACTIONS(3071),
    [anon_sym_requires] = ACTIONS(3071),
    [sym_this] = ACTIONS(3071),
    [anon_sym_precise] = ACTIONS(3071),
    [anon_sym_shared] = ACTIONS(3071),
    [anon_sym_groupshared] = ACTIONS(3071),
    [anon_sym_uniform] = ACTIONS(3071),
    [anon_sym_row_major] = ACTIONS(3071),
    [anon_sym_column_major] = ACTIONS(3071),
    [anon_sym_globallycoherent] = ACTIONS(3071),
    [anon_sym_centroid] = ACTIONS(3071),
    [anon_sym_noperspective] = ACTIONS(3071),
    [anon_sym_nointerpolation] = ACTIONS(3071),
    [anon_sym_sample] = ACTIONS(3071),
    [anon_sym_linear] = ACTIONS(3071),
    [anon_sym_snorm] = ACTIONS(3071),
    [anon_sym_unorm] = ACTIONS(3071),
    [anon_sym_point] = ACTIONS(3071),
    [anon_sym_line] = ACTIONS(3071),
    [anon_sym_triangleadj] = ACTIONS(3071),
    [anon_sym_lineadj] = ACTIONS(3071),
    [anon_sym_triangle] = ACTIONS(3071),
  },
  [790] = {
    [ts_builtin_sym_end] = ACTIONS(2431),
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_include_token1] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_BANG] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_DASH] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym___cdecl] = ACTIONS(2429),
    [anon_sym___clrcall] = ACTIONS(2429),
    [anon_sym___stdcall] = ACTIONS(2429),
    [anon_sym___fastcall] = ACTIONS(2429),
    [anon_sym___thiscall] = ACTIONS(2429),
    [anon_sym___vectorcall] = ACTIONS(2429),
    [anon_sym_LBRACE] = ACTIONS(2431),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [anon_sym_if] = ACTIONS(2429),
    [anon_sym_switch] = ACTIONS(2429),
    [anon_sym_case] = ACTIONS(2429),
    [anon_sym_default] = ACTIONS(2429),
    [anon_sym_while] = ACTIONS(2429),
    [anon_sym_do] = ACTIONS(2429),
    [anon_sym_for] = ACTIONS(2429),
    [anon_sym_return] = ACTIONS(2429),
    [anon_sym_break] = ACTIONS(2429),
    [anon_sym_continue] = ACTIONS(2429),
    [anon_sym_goto] = ACTIONS(2429),
    [anon_sym_not] = ACTIONS(2429),
    [anon_sym_compl] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2431),
    [anon_sym_PLUS_PLUS] = ACTIONS(2431),
    [anon_sym_sizeof] = ACTIONS(2429),
    [anon_sym___alignof__] = ACTIONS(2429),
    [anon_sym___alignof] = ACTIONS(2429),
    [anon_sym__alignof] = ACTIONS(2429),
    [anon_sym_alignof] = ACTIONS(2429),
    [anon_sym__Alignof] = ACTIONS(2429),
    [anon_sym_offsetof] = ACTIONS(2429),
    [anon_sym__Generic] = ACTIONS(2429),
    [anon_sym_asm] = ACTIONS(2429),
    [anon_sym___asm__] = ACTIONS(2429),
    [anon_sym___asm] = ACTIONS(2429),
    [sym_number_literal] = ACTIONS(2431),
    [anon_sym_L_SQUOTE] = ACTIONS(2431),
    [anon_sym_u_SQUOTE] = ACTIONS(2431),
    [anon_sym_U_SQUOTE] = ACTIONS(2431),
    [anon_sym_u8_SQUOTE] = ACTIONS(2431),
    [anon_sym_SQUOTE] = ACTIONS(2431),
    [anon_sym_L_DQUOTE] = ACTIONS(2431),
    [anon_sym_u_DQUOTE] = ACTIONS(2431),
    [anon_sym_U_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8_DQUOTE] = ACTIONS(2431),
    [anon_sym_DQUOTE] = ACTIONS(2431),
    [sym_true] = ACTIONS(2429),
    [sym_false] = ACTIONS(2429),
    [anon_sym_NULL] = ACTIONS(2429),
    [anon_sym_nullptr] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_export] = ACTIONS(2429),
    [anon_sym_module] = ACTIONS(2429),
    [anon_sym_import] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_try] = ACTIONS(2429),
    [anon_sym_delete] = ACTIONS(2429),
    [anon_sym_throw] = ACTIONS(2429),
    [anon_sym_namespace] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_concept] = ACTIONS(2429),
    [anon_sym_co_return] = ACTIONS(2429),
    [anon_sym_co_yield] = ACTIONS(2429),
    [anon_sym_R_DQUOTE] = ACTIONS(2431),
    [anon_sym_LR_DQUOTE] = ACTIONS(2431),
    [anon_sym_uR_DQUOTE] = ACTIONS(2431),
    [anon_sym_UR_DQUOTE] = ACTIONS(2431),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2431),
    [anon_sym_co_await] = ACTIONS(2429),
    [anon_sym_new] = ACTIONS(2429),
    [anon_sym_requires] = ACTIONS(2429),
    [sym_this] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
  },
  [791] = {
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_include_token1] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym___cdecl] = ACTIONS(2414),
    [anon_sym___clrcall] = ACTIONS(2414),
    [anon_sym___stdcall] = ACTIONS(2414),
    [anon_sym___fastcall] = ACTIONS(2414),
    [anon_sym___thiscall] = ACTIONS(2414),
    [anon_sym___vectorcall] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym_not] = ACTIONS(2414),
    [anon_sym_compl] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym___alignof__] = ACTIONS(2414),
    [anon_sym___alignof] = ACTIONS(2414),
    [anon_sym__alignof] = ACTIONS(2414),
    [anon_sym_alignof] = ACTIONS(2414),
    [anon_sym__Alignof] = ACTIONS(2414),
    [anon_sym_offsetof] = ACTIONS(2414),
    [anon_sym__Generic] = ACTIONS(2414),
    [anon_sym_asm] = ACTIONS(2414),
    [anon_sym___asm__] = ACTIONS(2414),
    [anon_sym___asm] = ACTIONS(2414),
    [sym_number_literal] = ACTIONS(2416),
    [anon_sym_L_SQUOTE] = ACTIONS(2416),
    [anon_sym_u_SQUOTE] = ACTIONS(2416),
    [anon_sym_U_SQUOTE] = ACTIONS(2416),
    [anon_sym_u8_SQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_L_DQUOTE] = ACTIONS(2416),
    [anon_sym_u_DQUOTE] = ACTIONS(2416),
    [anon_sym_U_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [anon_sym_NULL] = ACTIONS(2414),
    [anon_sym_nullptr] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2414),
    [anon_sym_module] = ACTIONS(2414),
    [anon_sym_import] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_concept] = ACTIONS(2414),
    [anon_sym_co_return] = ACTIONS(2414),
    [anon_sym_co_yield] = ACTIONS(2414),
    [anon_sym_R_DQUOTE] = ACTIONS(2416),
    [anon_sym_LR_DQUOTE] = ACTIONS(2416),
    [anon_sym_uR_DQUOTE] = ACTIONS(2416),
    [anon_sym_UR_DQUOTE] = ACTIONS(2416),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2416),
    [anon_sym_co_await] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_requires] = ACTIONS(2414),
    [sym_this] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
  },
  [792] = {
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_include_token1] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym___cdecl] = ACTIONS(2418),
    [anon_sym___clrcall] = ACTIONS(2418),
    [anon_sym___stdcall] = ACTIONS(2418),
    [anon_sym___fastcall] = ACTIONS(2418),
    [anon_sym___thiscall] = ACTIONS(2418),
    [anon_sym___vectorcall] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym_not] = ACTIONS(2418),
    [anon_sym_compl] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym___alignof__] = ACTIONS(2418),
    [anon_sym___alignof] = ACTIONS(2418),
    [anon_sym__alignof] = ACTIONS(2418),
    [anon_sym_alignof] = ACTIONS(2418),
    [anon_sym__Alignof] = ACTIONS(2418),
    [anon_sym_offsetof] = ACTIONS(2418),
    [anon_sym__Generic] = ACTIONS(2418),
    [anon_sym_asm] = ACTIONS(2418),
    [anon_sym___asm__] = ACTIONS(2418),
    [anon_sym___asm] = ACTIONS(2418),
    [sym_number_literal] = ACTIONS(2420),
    [anon_sym_L_SQUOTE] = ACTIONS(2420),
    [anon_sym_u_SQUOTE] = ACTIONS(2420),
    [anon_sym_U_SQUOTE] = ACTIONS(2420),
    [anon_sym_u8_SQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_L_DQUOTE] = ACTIONS(2420),
    [anon_sym_u_DQUOTE] = ACTIONS(2420),
    [anon_sym_U_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [anon_sym_NULL] = ACTIONS(2418),
    [anon_sym_nullptr] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_export] = ACTIONS(2418),
    [anon_sym_module] = ACTIONS(2418),
    [anon_sym_import] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_concept] = ACTIONS(2418),
    [anon_sym_co_return] = ACTIONS(2418),
    [anon_sym_co_yield] = ACTIONS(2418),
    [anon_sym_R_DQUOTE] = ACTIONS(2420),
    [anon_sym_LR_DQUOTE] = ACTIONS(2420),
    [anon_sym_uR_DQUOTE] = ACTIONS(2420),
    [anon_sym_UR_DQUOTE] = ACTIONS(2420),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2420),
    [anon_sym_co_await] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_requires] = ACTIONS(2418),
    [sym_this] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
  },
  [793] = {
    [ts_builtin_sym_end] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_include_token1] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2548),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym___cdecl] = ACTIONS(2548),
    [anon_sym___clrcall] = ACTIONS(2548),
    [anon_sym___stdcall] = ACTIONS(2548),
    [anon_sym___fastcall] = ACTIONS(2548),
    [anon_sym___thiscall] = ACTIONS(2548),
    [anon_sym___vectorcall] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2550),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2548),
    [anon_sym_switch] = ACTIONS(2548),
    [anon_sym_case] = ACTIONS(2548),
    [anon_sym_default] = ACTIONS(2548),
    [anon_sym_while] = ACTIONS(2548),
    [anon_sym_do] = ACTIONS(2548),
    [anon_sym_for] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2548),
    [anon_sym_break] = ACTIONS(2548),
    [anon_sym_continue] = ACTIONS(2548),
    [anon_sym_goto] = ACTIONS(2548),
    [anon_sym_not] = ACTIONS(2548),
    [anon_sym_compl] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2548),
    [anon_sym___alignof__] = ACTIONS(2548),
    [anon_sym___alignof] = ACTIONS(2548),
    [anon_sym__alignof] = ACTIONS(2548),
    [anon_sym_alignof] = ACTIONS(2548),
    [anon_sym__Alignof] = ACTIONS(2548),
    [anon_sym_offsetof] = ACTIONS(2548),
    [anon_sym__Generic] = ACTIONS(2548),
    [anon_sym_asm] = ACTIONS(2548),
    [anon_sym___asm__] = ACTIONS(2548),
    [anon_sym___asm] = ACTIONS(2548),
    [sym_number_literal] = ACTIONS(2550),
    [anon_sym_L_SQUOTE] = ACTIONS(2550),
    [anon_sym_u_SQUOTE] = ACTIONS(2550),
    [anon_sym_U_SQUOTE] = ACTIONS(2550),
    [anon_sym_u8_SQUOTE] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_L_DQUOTE] = ACTIONS(2550),
    [anon_sym_u_DQUOTE] = ACTIONS(2550),
    [anon_sym_U_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8_DQUOTE] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(2550),
    [sym_true] = ACTIONS(2548),
    [sym_false] = ACTIONS(2548),
    [anon_sym_NULL] = ACTIONS(2548),
    [anon_sym_nullptr] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_export] = ACTIONS(2548),
    [anon_sym_module] = ACTIONS(2548),
    [anon_sym_import] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_try] = ACTIONS(2548),
    [anon_sym_delete] = ACTIONS(2548),
    [anon_sym_throw] = ACTIONS(2548),
    [anon_sym_namespace] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_concept] = ACTIONS(2548),
    [anon_sym_co_return] = ACTIONS(2548),
    [anon_sym_co_yield] = ACTIONS(2548),
    [anon_sym_R_DQUOTE] = ACTIONS(2550),
    [anon_sym_LR_DQUOTE] = ACTIONS(2550),
    [anon_sym_uR_DQUOTE] = ACTIONS(2550),
    [anon_sym_UR_DQUOTE] = ACTIONS(2550),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2550),
    [anon_sym_co_await] = ACTIONS(2548),
    [anon_sym_new] = ACTIONS(2548),
    [anon_sym_requires] = ACTIONS(2548),
    [sym_this] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
  },
  [794] = {
    [ts_builtin_sym_end] = ACTIONS(2443),
    [sym_identifier] = ACTIONS(2441),
    [aux_sym_preproc_include_token1] = ACTIONS(2441),
    [aux_sym_preproc_def_token1] = ACTIONS(2441),
    [aux_sym_preproc_if_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2441),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2441),
    [sym_preproc_directive] = ACTIONS(2441),
    [anon_sym_LPAREN2] = ACTIONS(2443),
    [anon_sym_BANG] = ACTIONS(2443),
    [anon_sym_TILDE] = ACTIONS(2443),
    [anon_sym_DASH] = ACTIONS(2441),
    [anon_sym_PLUS] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2443),
    [anon_sym___extension__] = ACTIONS(2441),
    [anon_sym_typedef] = ACTIONS(2441),
    [anon_sym_in] = ACTIONS(2441),
    [anon_sym_out] = ACTIONS(2441),
    [anon_sym_inout] = ACTIONS(2441),
    [anon_sym_virtual] = ACTIONS(2441),
    [anon_sym_extern] = ACTIONS(2441),
    [anon_sym___attribute__] = ACTIONS(2441),
    [anon_sym___attribute] = ACTIONS(2441),
    [anon_sym_using] = ACTIONS(2441),
    [anon_sym_COLON_COLON] = ACTIONS(2443),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2443),
    [anon_sym___declspec] = ACTIONS(2441),
    [anon_sym___based] = ACTIONS(2441),
    [anon_sym___cdecl] = ACTIONS(2441),
    [anon_sym___clrcall] = ACTIONS(2441),
    [anon_sym___stdcall] = ACTIONS(2441),
    [anon_sym___fastcall] = ACTIONS(2441),
    [anon_sym___thiscall] = ACTIONS(2441),
    [anon_sym___vectorcall] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_signed] = ACTIONS(2441),
    [anon_sym_unsigned] = ACTIONS(2441),
    [anon_sym_long] = ACTIONS(2441),
    [anon_sym_short] = ACTIONS(2441),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_static] = ACTIONS(2441),
    [anon_sym_register] = ACTIONS(2441),
    [anon_sym_inline] = ACTIONS(2441),
    [anon_sym___inline] = ACTIONS(2441),
    [anon_sym___inline__] = ACTIONS(2441),
    [anon_sym___forceinline] = ACTIONS(2441),
    [anon_sym_thread_local] = ACTIONS(2441),
    [anon_sym___thread] = ACTIONS(2441),
    [anon_sym_const] = ACTIONS(2441),
    [anon_sym_constexpr] = ACTIONS(2441),
    [anon_sym_volatile] = ACTIONS(2441),
    [anon_sym_restrict] = ACTIONS(2441),
    [anon_sym___restrict__] = ACTIONS(2441),
    [anon_sym__Atomic] = ACTIONS(2441),
    [anon_sym__Noreturn] = ACTIONS(2441),
    [anon_sym_noreturn] = ACTIONS(2441),
    [anon_sym__Nonnull] = ACTIONS(2441),
    [anon_sym_mutable] = ACTIONS(2441),
    [anon_sym_constinit] = ACTIONS(2441),
    [anon_sym_consteval] = ACTIONS(2441),
    [anon_sym_alignas] = ACTIONS(2441),
    [anon_sym__Alignas] = ACTIONS(2441),
    [sym_primitive_type] = ACTIONS(2441),
    [anon_sym_enum] = ACTIONS(2441),
    [anon_sym_class] = ACTIONS(2441),
    [anon_sym_struct] = ACTIONS(2441),
    [anon_sym_union] = ACTIONS(2441),
    [anon_sym_if] = ACTIONS(2441),
    [anon_sym_switch] = ACTIONS(2441),
    [anon_sym_case] = ACTIONS(2441),
    [anon_sym_default] = ACTIONS(2441),
    [anon_sym_while] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_for] = ACTIONS(2441),
    [anon_sym_return] = ACTIONS(2441),
    [anon_sym_break] = ACTIONS(2441),
    [anon_sym_continue] = ACTIONS(2441),
    [anon_sym_goto] = ACTIONS(2441),
    [anon_sym_not] = ACTIONS(2441),
    [anon_sym_compl] = ACTIONS(2441),
    [anon_sym_DASH_DASH] = ACTIONS(2443),
    [anon_sym_PLUS_PLUS] = ACTIONS(2443),
    [anon_sym_sizeof] = ACTIONS(2441),
    [anon_sym___alignof__] = ACTIONS(2441),
    [anon_sym___alignof] = ACTIONS(2441),
    [anon_sym__alignof] = ACTIONS(2441),
    [anon_sym_alignof] = ACTIONS(2441),
    [anon_sym__Alignof] = ACTIONS(2441),
    [anon_sym_offsetof] = ACTIONS(2441),
    [anon_sym__Generic] = ACTIONS(2441),
    [anon_sym_asm] = ACTIONS(2441),
    [anon_sym___asm__] = ACTIONS(2441),
    [anon_sym___asm] = ACTIONS(2441),
    [sym_number_literal] = ACTIONS(2443),
    [anon_sym_L_SQUOTE] = ACTIONS(2443),
    [anon_sym_u_SQUOTE] = ACTIONS(2443),
    [anon_sym_U_SQUOTE] = ACTIONS(2443),
    [anon_sym_u8_SQUOTE] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2443),
    [anon_sym_L_DQUOTE] = ACTIONS(2443),
    [anon_sym_u_DQUOTE] = ACTIONS(2443),
    [anon_sym_U_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8_DQUOTE] = ACTIONS(2443),
    [anon_sym_DQUOTE] = ACTIONS(2443),
    [sym_true] = ACTIONS(2441),
    [sym_false] = ACTIONS(2441),
    [anon_sym_NULL] = ACTIONS(2441),
    [anon_sym_nullptr] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2441),
    [anon_sym_decltype] = ACTIONS(2441),
    [anon_sym_explicit] = ACTIONS(2441),
    [anon_sym_typename] = ACTIONS(2441),
    [anon_sym_export] = ACTIONS(2441),
    [anon_sym_module] = ACTIONS(2441),
    [anon_sym_import] = ACTIONS(2441),
    [anon_sym_template] = ACTIONS(2441),
    [anon_sym_operator] = ACTIONS(2441),
    [anon_sym_try] = ACTIONS(2441),
    [anon_sym_delete] = ACTIONS(2441),
    [anon_sym_throw] = ACTIONS(2441),
    [anon_sym_namespace] = ACTIONS(2441),
    [anon_sym_static_assert] = ACTIONS(2441),
    [anon_sym_concept] = ACTIONS(2441),
    [anon_sym_co_return] = ACTIONS(2441),
    [anon_sym_co_yield] = ACTIONS(2441),
    [anon_sym_R_DQUOTE] = ACTIONS(2443),
    [anon_sym_LR_DQUOTE] = ACTIONS(2443),
    [anon_sym_uR_DQUOTE] = ACTIONS(2443),
    [anon_sym_UR_DQUOTE] = ACTIONS(2443),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2443),
    [anon_sym_co_await] = ACTIONS(2441),
    [anon_sym_new] = ACTIONS(2441),
    [anon_sym_requires] = ACTIONS(2441),
    [sym_this] = ACTIONS(2441),
    [anon_sym_precise] = ACTIONS(2441),
    [anon_sym_shared] = ACTIONS(2441),
    [anon_sym_groupshared] = ACTIONS(2441),
    [anon_sym_uniform] = ACTIONS(2441),
    [anon_sym_row_major] = ACTIONS(2441),
    [anon_sym_column_major] = ACTIONS(2441),
    [anon_sym_globallycoherent] = ACTIONS(2441),
    [anon_sym_centroid] = ACTIONS(2441),
    [anon_sym_noperspective] = ACTIONS(2441),
    [anon_sym_nointerpolation] = ACTIONS(2441),
    [anon_sym_sample] = ACTIONS(2441),
    [anon_sym_linear] = ACTIONS(2441),
    [anon_sym_snorm] = ACTIONS(2441),
    [anon_sym_unorm] = ACTIONS(2441),
    [anon_sym_point] = ACTIONS(2441),
    [anon_sym_line] = ACTIONS(2441),
    [anon_sym_triangleadj] = ACTIONS(2441),
    [anon_sym_lineadj] = ACTIONS(2441),
    [anon_sym_triangle] = ACTIONS(2441),
  },
  [795] = {
    [ts_builtin_sym_end] = ACTIONS(2447),
    [sym_identifier] = ACTIONS(2445),
    [aux_sym_preproc_include_token1] = ACTIONS(2445),
    [aux_sym_preproc_def_token1] = ACTIONS(2445),
    [aux_sym_preproc_if_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2445),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2445),
    [sym_preproc_directive] = ACTIONS(2445),
    [anon_sym_LPAREN2] = ACTIONS(2447),
    [anon_sym_BANG] = ACTIONS(2447),
    [anon_sym_TILDE] = ACTIONS(2447),
    [anon_sym_DASH] = ACTIONS(2445),
    [anon_sym_PLUS] = ACTIONS(2445),
    [anon_sym_STAR] = ACTIONS(2447),
    [anon_sym_AMP_AMP] = ACTIONS(2447),
    [anon_sym_AMP] = ACTIONS(2445),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym___extension__] = ACTIONS(2445),
    [anon_sym_typedef] = ACTIONS(2445),
    [anon_sym_in] = ACTIONS(2445),
    [anon_sym_out] = ACTIONS(2445),
    [anon_sym_inout] = ACTIONS(2445),
    [anon_sym_virtual] = ACTIONS(2445),
    [anon_sym_extern] = ACTIONS(2445),
    [anon_sym___attribute__] = ACTIONS(2445),
    [anon_sym___attribute] = ACTIONS(2445),
    [anon_sym_using] = ACTIONS(2445),
    [anon_sym_COLON_COLON] = ACTIONS(2447),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2447),
    [anon_sym___declspec] = ACTIONS(2445),
    [anon_sym___based] = ACTIONS(2445),
    [anon_sym___cdecl] = ACTIONS(2445),
    [anon_sym___clrcall] = ACTIONS(2445),
    [anon_sym___stdcall] = ACTIONS(2445),
    [anon_sym___fastcall] = ACTIONS(2445),
    [anon_sym___thiscall] = ACTIONS(2445),
    [anon_sym___vectorcall] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(2447),
    [anon_sym_signed] = ACTIONS(2445),
    [anon_sym_unsigned] = ACTIONS(2445),
    [anon_sym_long] = ACTIONS(2445),
    [anon_sym_short] = ACTIONS(2445),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_static] = ACTIONS(2445),
    [anon_sym_register] = ACTIONS(2445),
    [anon_sym_inline] = ACTIONS(2445),
    [anon_sym___inline] = ACTIONS(2445),
    [anon_sym___inline__] = ACTIONS(2445),
    [anon_sym___forceinline] = ACTIONS(2445),
    [anon_sym_thread_local] = ACTIONS(2445),
    [anon_sym___thread] = ACTIONS(2445),
    [anon_sym_const] = ACTIONS(2445),
    [anon_sym_constexpr] = ACTIONS(2445),
    [anon_sym_volatile] = ACTIONS(2445),
    [anon_sym_restrict] = ACTIONS(2445),
    [anon_sym___restrict__] = ACTIONS(2445),
    [anon_sym__Atomic] = ACTIONS(2445),
    [anon_sym__Noreturn] = ACTIONS(2445),
    [anon_sym_noreturn] = ACTIONS(2445),
    [anon_sym__Nonnull] = ACTIONS(2445),
    [anon_sym_mutable] = ACTIONS(2445),
    [anon_sym_constinit] = ACTIONS(2445),
    [anon_sym_consteval] = ACTIONS(2445),
    [anon_sym_alignas] = ACTIONS(2445),
    [anon_sym__Alignas] = ACTIONS(2445),
    [sym_primitive_type] = ACTIONS(2445),
    [anon_sym_enum] = ACTIONS(2445),
    [anon_sym_class] = ACTIONS(2445),
    [anon_sym_struct] = ACTIONS(2445),
    [anon_sym_union] = ACTIONS(2445),
    [anon_sym_if] = ACTIONS(2445),
    [anon_sym_switch] = ACTIONS(2445),
    [anon_sym_case] = ACTIONS(2445),
    [anon_sym_default] = ACTIONS(2445),
    [anon_sym_while] = ACTIONS(2445),
    [anon_sym_do] = ACTIONS(2445),
    [anon_sym_for] = ACTIONS(2445),
    [anon_sym_return] = ACTIONS(2445),
    [anon_sym_break] = ACTIONS(2445),
    [anon_sym_continue] = ACTIONS(2445),
    [anon_sym_goto] = ACTIONS(2445),
    [anon_sym_not] = ACTIONS(2445),
    [anon_sym_compl] = ACTIONS(2445),
    [anon_sym_DASH_DASH] = ACTIONS(2447),
    [anon_sym_PLUS_PLUS] = ACTIONS(2447),
    [anon_sym_sizeof] = ACTIONS(2445),
    [anon_sym___alignof__] = ACTIONS(2445),
    [anon_sym___alignof] = ACTIONS(2445),
    [anon_sym__alignof] = ACTIONS(2445),
    [anon_sym_alignof] = ACTIONS(2445),
    [anon_sym__Alignof] = ACTIONS(2445),
    [anon_sym_offsetof] = ACTIONS(2445),
    [anon_sym__Generic] = ACTIONS(2445),
    [anon_sym_asm] = ACTIONS(2445),
    [anon_sym___asm__] = ACTIONS(2445),
    [anon_sym___asm] = ACTIONS(2445),
    [sym_number_literal] = ACTIONS(2447),
    [anon_sym_L_SQUOTE] = ACTIONS(2447),
    [anon_sym_u_SQUOTE] = ACTIONS(2447),
    [anon_sym_U_SQUOTE] = ACTIONS(2447),
    [anon_sym_u8_SQUOTE] = ACTIONS(2447),
    [anon_sym_SQUOTE] = ACTIONS(2447),
    [anon_sym_L_DQUOTE] = ACTIONS(2447),
    [anon_sym_u_DQUOTE] = ACTIONS(2447),
    [anon_sym_U_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8_DQUOTE] = ACTIONS(2447),
    [anon_sym_DQUOTE] = ACTIONS(2447),
    [sym_true] = ACTIONS(2445),
    [sym_false] = ACTIONS(2445),
    [anon_sym_NULL] = ACTIONS(2445),
    [anon_sym_nullptr] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2445),
    [anon_sym_decltype] = ACTIONS(2445),
    [anon_sym_explicit] = ACTIONS(2445),
    [anon_sym_typename] = ACTIONS(2445),
    [anon_sym_export] = ACTIONS(2445),
    [anon_sym_module] = ACTIONS(2445),
    [anon_sym_import] = ACTIONS(2445),
    [anon_sym_template] = ACTIONS(2445),
    [anon_sym_operator] = ACTIONS(2445),
    [anon_sym_try] = ACTIONS(2445),
    [anon_sym_delete] = ACTIONS(2445),
    [anon_sym_throw] = ACTIONS(2445),
    [anon_sym_namespace] = ACTIONS(2445),
    [anon_sym_static_assert] = ACTIONS(2445),
    [anon_sym_concept] = ACTIONS(2445),
    [anon_sym_co_return] = ACTIONS(2445),
    [anon_sym_co_yield] = ACTIONS(2445),
    [anon_sym_R_DQUOTE] = ACTIONS(2447),
    [anon_sym_LR_DQUOTE] = ACTIONS(2447),
    [anon_sym_uR_DQUOTE] = ACTIONS(2447),
    [anon_sym_UR_DQUOTE] = ACTIONS(2447),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2447),
    [anon_sym_co_await] = ACTIONS(2445),
    [anon_sym_new] = ACTIONS(2445),
    [anon_sym_requires] = ACTIONS(2445),
    [sym_this] = ACTIONS(2445),
    [anon_sym_precise] = ACTIONS(2445),
    [anon_sym_shared] = ACTIONS(2445),
    [anon_sym_groupshared] = ACTIONS(2445),
    [anon_sym_uniform] = ACTIONS(2445),
    [anon_sym_row_major] = ACTIONS(2445),
    [anon_sym_column_major] = ACTIONS(2445),
    [anon_sym_globallycoherent] = ACTIONS(2445),
    [anon_sym_centroid] = ACTIONS(2445),
    [anon_sym_noperspective] = ACTIONS(2445),
    [anon_sym_nointerpolation] = ACTIONS(2445),
    [anon_sym_sample] = ACTIONS(2445),
    [anon_sym_linear] = ACTIONS(2445),
    [anon_sym_snorm] = ACTIONS(2445),
    [anon_sym_unorm] = ACTIONS(2445),
    [anon_sym_point] = ACTIONS(2445),
    [anon_sym_line] = ACTIONS(2445),
    [anon_sym_triangleadj] = ACTIONS(2445),
    [anon_sym_lineadj] = ACTIONS(2445),
    [anon_sym_triangle] = ACTIONS(2445),
  },
  [796] = {
    [ts_builtin_sym_end] = ACTIONS(3073),
    [sym_identifier] = ACTIONS(3075),
    [aux_sym_preproc_include_token1] = ACTIONS(3075),
    [aux_sym_preproc_def_token1] = ACTIONS(3075),
    [aux_sym_preproc_if_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3075),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3075),
    [sym_preproc_directive] = ACTIONS(3075),
    [anon_sym_LPAREN2] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_AMP] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym___extension__] = ACTIONS(3075),
    [anon_sym_typedef] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3075),
    [anon_sym_out] = ACTIONS(3075),
    [anon_sym_inout] = ACTIONS(3075),
    [anon_sym_virtual] = ACTIONS(3075),
    [anon_sym_extern] = ACTIONS(3075),
    [anon_sym___attribute__] = ACTIONS(3075),
    [anon_sym___attribute] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3073),
    [anon_sym___declspec] = ACTIONS(3075),
    [anon_sym___based] = ACTIONS(3075),
    [anon_sym___cdecl] = ACTIONS(3075),
    [anon_sym___clrcall] = ACTIONS(3075),
    [anon_sym___stdcall] = ACTIONS(3075),
    [anon_sym___fastcall] = ACTIONS(3075),
    [anon_sym___thiscall] = ACTIONS(3075),
    [anon_sym___vectorcall] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3073),
    [anon_sym_signed] = ACTIONS(3075),
    [anon_sym_unsigned] = ACTIONS(3075),
    [anon_sym_long] = ACTIONS(3075),
    [anon_sym_short] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_register] = ACTIONS(3075),
    [anon_sym_inline] = ACTIONS(3075),
    [anon_sym___inline] = ACTIONS(3075),
    [anon_sym___inline__] = ACTIONS(3075),
    [anon_sym___forceinline] = ACTIONS(3075),
    [anon_sym_thread_local] = ACTIONS(3075),
    [anon_sym___thread] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_constexpr] = ACTIONS(3075),
    [anon_sym_volatile] = ACTIONS(3075),
    [anon_sym_restrict] = ACTIONS(3075),
    [anon_sym___restrict__] = ACTIONS(3075),
    [anon_sym__Atomic] = ACTIONS(3075),
    [anon_sym__Noreturn] = ACTIONS(3075),
    [anon_sym_noreturn] = ACTIONS(3075),
    [anon_sym__Nonnull] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_constinit] = ACTIONS(3075),
    [anon_sym_consteval] = ACTIONS(3075),
    [anon_sym_alignas] = ACTIONS(3075),
    [anon_sym__Alignas] = ACTIONS(3075),
    [sym_primitive_type] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_union] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_goto] = ACTIONS(3075),
    [anon_sym_not] = ACTIONS(3075),
    [anon_sym_compl] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3073),
    [anon_sym_PLUS_PLUS] = ACTIONS(3073),
    [anon_sym_sizeof] = ACTIONS(3075),
    [anon_sym___alignof__] = ACTIONS(3075),
    [anon_sym___alignof] = ACTIONS(3075),
    [anon_sym__alignof] = ACTIONS(3075),
    [anon_sym_alignof] = ACTIONS(3075),
    [anon_sym__Alignof] = ACTIONS(3075),
    [anon_sym_offsetof] = ACTIONS(3075),
    [anon_sym__Generic] = ACTIONS(3075),
    [anon_sym_asm] = ACTIONS(3075),
    [anon_sym___asm__] = ACTIONS(3075),
    [anon_sym___asm] = ACTIONS(3075),
    [sym_number_literal] = ACTIONS(3073),
    [anon_sym_L_SQUOTE] = ACTIONS(3073),
    [anon_sym_u_SQUOTE] = ACTIONS(3073),
    [anon_sym_U_SQUOTE] = ACTIONS(3073),
    [anon_sym_u8_SQUOTE] = ACTIONS(3073),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_L_DQUOTE] = ACTIONS(3073),
    [anon_sym_u_DQUOTE] = ACTIONS(3073),
    [anon_sym_U_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8_DQUOTE] = ACTIONS(3073),
    [anon_sym_DQUOTE] = ACTIONS(3073),
    [sym_true] = ACTIONS(3075),
    [sym_false] = ACTIONS(3075),
    [anon_sym_NULL] = ACTIONS(3075),
    [anon_sym_nullptr] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3075),
    [anon_sym_decltype] = ACTIONS(3075),
    [anon_sym_explicit] = ACTIONS(3075),
    [anon_sym_typename] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_template] = ACTIONS(3075),
    [anon_sym_operator] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_static_assert] = ACTIONS(3075),
    [anon_sym_concept] = ACTIONS(3075),
    [anon_sym_co_return] = ACTIONS(3075),
    [anon_sym_co_yield] = ACTIONS(3075),
    [anon_sym_R_DQUOTE] = ACTIONS(3073),
    [anon_sym_LR_DQUOTE] = ACTIONS(3073),
    [anon_sym_uR_DQUOTE] = ACTIONS(3073),
    [anon_sym_UR_DQUOTE] = ACTIONS(3073),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3073),
    [anon_sym_co_await] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [anon_sym_requires] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
    [anon_sym_precise] = ACTIONS(3075),
    [anon_sym_shared] = ACTIONS(3075),
    [anon_sym_groupshared] = ACTIONS(3075),
    [anon_sym_uniform] = ACTIONS(3075),
    [anon_sym_row_major] = ACTIONS(3075),
    [anon_sym_column_major] = ACTIONS(3075),
    [anon_sym_globallycoherent] = ACTIONS(3075),
    [anon_sym_centroid] = ACTIONS(3075),
    [anon_sym_noperspective] = ACTIONS(3075),
    [anon_sym_nointerpolation] = ACTIONS(3075),
    [anon_sym_sample] = ACTIONS(3075),
    [anon_sym_linear] = ACTIONS(3075),
    [anon_sym_snorm] = ACTIONS(3075),
    [anon_sym_unorm] = ACTIONS(3075),
    [anon_sym_point] = ACTIONS(3075),
    [anon_sym_line] = ACTIONS(3075),
    [anon_sym_triangleadj] = ACTIONS(3075),
    [anon_sym_lineadj] = ACTIONS(3075),
    [anon_sym_triangle] = ACTIONS(3075),
  },
  [797] = {
    [ts_builtin_sym_end] = ACTIONS(3077),
    [sym_identifier] = ACTIONS(3079),
    [aux_sym_preproc_include_token1] = ACTIONS(3079),
    [aux_sym_preproc_def_token1] = ACTIONS(3079),
    [aux_sym_preproc_if_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3079),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3079),
    [sym_preproc_directive] = ACTIONS(3079),
    [anon_sym_LPAREN2] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_AMP] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym___extension__] = ACTIONS(3079),
    [anon_sym_typedef] = ACTIONS(3079),
    [anon_sym_in] = ACTIONS(3079),
    [anon_sym_out] = ACTIONS(3079),
    [anon_sym_inout] = ACTIONS(3079),
    [anon_sym_virtual] = ACTIONS(3079),
    [anon_sym_extern] = ACTIONS(3079),
    [anon_sym___attribute__] = ACTIONS(3079),
    [anon_sym___attribute] = ACTIONS(3079),
    [anon_sym_using] = ACTIONS(3079),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3077),
    [anon_sym___declspec] = ACTIONS(3079),
    [anon_sym___based] = ACTIONS(3079),
    [anon_sym___cdecl] = ACTIONS(3079),
    [anon_sym___clrcall] = ACTIONS(3079),
    [anon_sym___stdcall] = ACTIONS(3079),
    [anon_sym___fastcall] = ACTIONS(3079),
    [anon_sym___thiscall] = ACTIONS(3079),
    [anon_sym___vectorcall] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_signed] = ACTIONS(3079),
    [anon_sym_unsigned] = ACTIONS(3079),
    [anon_sym_long] = ACTIONS(3079),
    [anon_sym_short] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_static] = ACTIONS(3079),
    [anon_sym_register] = ACTIONS(3079),
    [anon_sym_inline] = ACTIONS(3079),
    [anon_sym___inline] = ACTIONS(3079),
    [anon_sym___inline__] = ACTIONS(3079),
    [anon_sym___forceinline] = ACTIONS(3079),
    [anon_sym_thread_local] = ACTIONS(3079),
    [anon_sym___thread] = ACTIONS(3079),
    [anon_sym_const] = ACTIONS(3079),
    [anon_sym_constexpr] = ACTIONS(3079),
    [anon_sym_volatile] = ACTIONS(3079),
    [anon_sym_restrict] = ACTIONS(3079),
    [anon_sym___restrict__] = ACTIONS(3079),
    [anon_sym__Atomic] = ACTIONS(3079),
    [anon_sym__Noreturn] = ACTIONS(3079),
    [anon_sym_noreturn] = ACTIONS(3079),
    [anon_sym__Nonnull] = ACTIONS(3079),
    [anon_sym_mutable] = ACTIONS(3079),
    [anon_sym_constinit] = ACTIONS(3079),
    [anon_sym_consteval] = ACTIONS(3079),
    [anon_sym_alignas] = ACTIONS(3079),
    [anon_sym__Alignas] = ACTIONS(3079),
    [sym_primitive_type] = ACTIONS(3079),
    [anon_sym_enum] = ACTIONS(3079),
    [anon_sym_class] = ACTIONS(3079),
    [anon_sym_struct] = ACTIONS(3079),
    [anon_sym_union] = ACTIONS(3079),
    [anon_sym_if] = ACTIONS(3079),
    [anon_sym_switch] = ACTIONS(3079),
    [anon_sym_case] = ACTIONS(3079),
    [anon_sym_default] = ACTIONS(3079),
    [anon_sym_while] = ACTIONS(3079),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_for] = ACTIONS(3079),
    [anon_sym_return] = ACTIONS(3079),
    [anon_sym_break] = ACTIONS(3079),
    [anon_sym_continue] = ACTIONS(3079),
    [anon_sym_goto] = ACTIONS(3079),
    [anon_sym_not] = ACTIONS(3079),
    [anon_sym_compl] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_sizeof] = ACTIONS(3079),
    [anon_sym___alignof__] = ACTIONS(3079),
    [anon_sym___alignof] = ACTIONS(3079),
    [anon_sym__alignof] = ACTIONS(3079),
    [anon_sym_alignof] = ACTIONS(3079),
    [anon_sym__Alignof] = ACTIONS(3079),
    [anon_sym_offsetof] = ACTIONS(3079),
    [anon_sym__Generic] = ACTIONS(3079),
    [anon_sym_asm] = ACTIONS(3079),
    [anon_sym___asm__] = ACTIONS(3079),
    [anon_sym___asm] = ACTIONS(3079),
    [sym_number_literal] = ACTIONS(3077),
    [anon_sym_L_SQUOTE] = ACTIONS(3077),
    [anon_sym_u_SQUOTE] = ACTIONS(3077),
    [anon_sym_U_SQUOTE] = ACTIONS(3077),
    [anon_sym_u8_SQUOTE] = ACTIONS(3077),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_L_DQUOTE] = ACTIONS(3077),
    [anon_sym_u_DQUOTE] = ACTIONS(3077),
    [anon_sym_U_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8_DQUOTE] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [sym_true] = ACTIONS(3079),
    [sym_false] = ACTIONS(3079),
    [anon_sym_NULL] = ACTIONS(3079),
    [anon_sym_nullptr] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3079),
    [anon_sym_decltype] = ACTIONS(3079),
    [anon_sym_explicit] = ACTIONS(3079),
    [anon_sym_typename] = ACTIONS(3079),
    [anon_sym_export] = ACTIONS(3079),
    [anon_sym_module] = ACTIONS(3079),
    [anon_sym_import] = ACTIONS(3079),
    [anon_sym_template] = ACTIONS(3079),
    [anon_sym_operator] = ACTIONS(3079),
    [anon_sym_try] = ACTIONS(3079),
    [anon_sym_delete] = ACTIONS(3079),
    [anon_sym_throw] = ACTIONS(3079),
    [anon_sym_namespace] = ACTIONS(3079),
    [anon_sym_static_assert] = ACTIONS(3079),
    [anon_sym_concept] = ACTIONS(3079),
    [anon_sym_co_return] = ACTIONS(3079),
    [anon_sym_co_yield] = ACTIONS(3079),
    [anon_sym_R_DQUOTE] = ACTIONS(3077),
    [anon_sym_LR_DQUOTE] = ACTIONS(3077),
    [anon_sym_uR_DQUOTE] = ACTIONS(3077),
    [anon_sym_UR_DQUOTE] = ACTIONS(3077),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3077),
    [anon_sym_co_await] = ACTIONS(3079),
    [anon_sym_new] = ACTIONS(3079),
    [anon_sym_requires] = ACTIONS(3079),
    [sym_this] = ACTIONS(3079),
    [anon_sym_precise] = ACTIONS(3079),
    [anon_sym_shared] = ACTIONS(3079),
    [anon_sym_groupshared] = ACTIONS(3079),
    [anon_sym_uniform] = ACTIONS(3079),
    [anon_sym_row_major] = ACTIONS(3079),
    [anon_sym_column_major] = ACTIONS(3079),
    [anon_sym_globallycoherent] = ACTIONS(3079),
    [anon_sym_centroid] = ACTIONS(3079),
    [anon_sym_noperspective] = ACTIONS(3079),
    [anon_sym_nointerpolation] = ACTIONS(3079),
    [anon_sym_sample] = ACTIONS(3079),
    [anon_sym_linear] = ACTIONS(3079),
    [anon_sym_snorm] = ACTIONS(3079),
    [anon_sym_unorm] = ACTIONS(3079),
    [anon_sym_point] = ACTIONS(3079),
    [anon_sym_line] = ACTIONS(3079),
    [anon_sym_triangleadj] = ACTIONS(3079),
    [anon_sym_lineadj] = ACTIONS(3079),
    [anon_sym_triangle] = ACTIONS(3079),
  },
  [798] = {
    [ts_builtin_sym_end] = ACTIONS(3081),
    [sym_identifier] = ACTIONS(3083),
    [aux_sym_preproc_include_token1] = ACTIONS(3083),
    [aux_sym_preproc_def_token1] = ACTIONS(3083),
    [aux_sym_preproc_if_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3083),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3083),
    [sym_preproc_directive] = ACTIONS(3083),
    [anon_sym_LPAREN2] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_AMP] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym___extension__] = ACTIONS(3083),
    [anon_sym_typedef] = ACTIONS(3083),
    [anon_sym_in] = ACTIONS(3083),
    [anon_sym_out] = ACTIONS(3083),
    [anon_sym_inout] = ACTIONS(3083),
    [anon_sym_virtual] = ACTIONS(3083),
    [anon_sym_extern] = ACTIONS(3083),
    [anon_sym___attribute__] = ACTIONS(3083),
    [anon_sym___attribute] = ACTIONS(3083),
    [anon_sym_using] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3081),
    [anon_sym___declspec] = ACTIONS(3083),
    [anon_sym___based] = ACTIONS(3083),
    [anon_sym___cdecl] = ACTIONS(3083),
    [anon_sym___clrcall] = ACTIONS(3083),
    [anon_sym___stdcall] = ACTIONS(3083),
    [anon_sym___fastcall] = ACTIONS(3083),
    [anon_sym___thiscall] = ACTIONS(3083),
    [anon_sym___vectorcall] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3081),
    [anon_sym_signed] = ACTIONS(3083),
    [anon_sym_unsigned] = ACTIONS(3083),
    [anon_sym_long] = ACTIONS(3083),
    [anon_sym_short] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_static] = ACTIONS(3083),
    [anon_sym_register] = ACTIONS(3083),
    [anon_sym_inline] = ACTIONS(3083),
    [anon_sym___inline] = ACTIONS(3083),
    [anon_sym___inline__] = ACTIONS(3083),
    [anon_sym___forceinline] = ACTIONS(3083),
    [anon_sym_thread_local] = ACTIONS(3083),
    [anon_sym___thread] = ACTIONS(3083),
    [anon_sym_const] = ACTIONS(3083),
    [anon_sym_constexpr] = ACTIONS(3083),
    [anon_sym_volatile] = ACTIONS(3083),
    [anon_sym_restrict] = ACTIONS(3083),
    [anon_sym___restrict__] = ACTIONS(3083),
    [anon_sym__Atomic] = ACTIONS(3083),
    [anon_sym__Noreturn] = ACTIONS(3083),
    [anon_sym_noreturn] = ACTIONS(3083),
    [anon_sym__Nonnull] = ACTIONS(3083),
    [anon_sym_mutable] = ACTIONS(3083),
    [anon_sym_constinit] = ACTIONS(3083),
    [anon_sym_consteval] = ACTIONS(3083),
    [anon_sym_alignas] = ACTIONS(3083),
    [anon_sym__Alignas] = ACTIONS(3083),
    [sym_primitive_type] = ACTIONS(3083),
    [anon_sym_enum] = ACTIONS(3083),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3083),
    [anon_sym_union] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3083),
    [anon_sym_switch] = ACTIONS(3083),
    [anon_sym_case] = ACTIONS(3083),
    [anon_sym_default] = ACTIONS(3083),
    [anon_sym_while] = ACTIONS(3083),
    [anon_sym_do] = ACTIONS(3083),
    [anon_sym_for] = ACTIONS(3083),
    [anon_sym_return] = ACTIONS(3083),
    [anon_sym_break] = ACTIONS(3083),
    [anon_sym_continue] = ACTIONS(3083),
    [anon_sym_goto] = ACTIONS(3083),
    [anon_sym_not] = ACTIONS(3083),
    [anon_sym_compl] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3081),
    [anon_sym_PLUS_PLUS] = ACTIONS(3081),
    [anon_sym_sizeof] = ACTIONS(3083),
    [anon_sym___alignof__] = ACTIONS(3083),
    [anon_sym___alignof] = ACTIONS(3083),
    [anon_sym__alignof] = ACTIONS(3083),
    [anon_sym_alignof] = ACTIONS(3083),
    [anon_sym__Alignof] = ACTIONS(3083),
    [anon_sym_offsetof] = ACTIONS(3083),
    [anon_sym__Generic] = ACTIONS(3083),
    [anon_sym_asm] = ACTIONS(3083),
    [anon_sym___asm__] = ACTIONS(3083),
    [anon_sym___asm] = ACTIONS(3083),
    [sym_number_literal] = ACTIONS(3081),
    [anon_sym_L_SQUOTE] = ACTIONS(3081),
    [anon_sym_u_SQUOTE] = ACTIONS(3081),
    [anon_sym_U_SQUOTE] = ACTIONS(3081),
    [anon_sym_u8_SQUOTE] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_L_DQUOTE] = ACTIONS(3081),
    [anon_sym_u_DQUOTE] = ACTIONS(3081),
    [anon_sym_U_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8_DQUOTE] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(3081),
    [sym_true] = ACTIONS(3083),
    [sym_false] = ACTIONS(3083),
    [anon_sym_NULL] = ACTIONS(3083),
    [anon_sym_nullptr] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3083),
    [anon_sym_decltype] = ACTIONS(3083),
    [anon_sym_explicit] = ACTIONS(3083),
    [anon_sym_typename] = ACTIONS(3083),
    [anon_sym_export] = ACTIONS(3083),
    [anon_sym_module] = ACTIONS(3083),
    [anon_sym_import] = ACTIONS(3083),
    [anon_sym_template] = ACTIONS(3083),
    [anon_sym_operator] = ACTIONS(3083),
    [anon_sym_try] = ACTIONS(3083),
    [anon_sym_delete] = ACTIONS(3083),
    [anon_sym_throw] = ACTIONS(3083),
    [anon_sym_namespace] = ACTIONS(3083),
    [anon_sym_static_assert] = ACTIONS(3083),
    [anon_sym_concept] = ACTIONS(3083),
    [anon_sym_co_return] = ACTIONS(3083),
    [anon_sym_co_yield] = ACTIONS(3083),
    [anon_sym_R_DQUOTE] = ACTIONS(3081),
    [anon_sym_LR_DQUOTE] = ACTIONS(3081),
    [anon_sym_uR_DQUOTE] = ACTIONS(3081),
    [anon_sym_UR_DQUOTE] = ACTIONS(3081),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3081),
    [anon_sym_co_await] = ACTIONS(3083),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_requires] = ACTIONS(3083),
    [sym_this] = ACTIONS(3083),
    [anon_sym_precise] = ACTIONS(3083),
    [anon_sym_shared] = ACTIONS(3083),
    [anon_sym_groupshared] = ACTIONS(3083),
    [anon_sym_uniform] = ACTIONS(3083),
    [anon_sym_row_major] = ACTIONS(3083),
    [anon_sym_column_major] = ACTIONS(3083),
    [anon_sym_globallycoherent] = ACTIONS(3083),
    [anon_sym_centroid] = ACTIONS(3083),
    [anon_sym_noperspective] = ACTIONS(3083),
    [anon_sym_nointerpolation] = ACTIONS(3083),
    [anon_sym_sample] = ACTIONS(3083),
    [anon_sym_linear] = ACTIONS(3083),
    [anon_sym_snorm] = ACTIONS(3083),
    [anon_sym_unorm] = ACTIONS(3083),
    [anon_sym_point] = ACTIONS(3083),
    [anon_sym_line] = ACTIONS(3083),
    [anon_sym_triangleadj] = ACTIONS(3083),
    [anon_sym_lineadj] = ACTIONS(3083),
    [anon_sym_triangle] = ACTIONS(3083),
  },
  [799] = {
    [ts_builtin_sym_end] = ACTIONS(3085),
    [sym_identifier] = ACTIONS(3087),
    [aux_sym_preproc_include_token1] = ACTIONS(3087),
    [aux_sym_preproc_def_token1] = ACTIONS(3087),
    [aux_sym_preproc_if_token1] = ACTIONS(3087),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3087),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3087),
    [sym_preproc_directive] = ACTIONS(3087),
    [anon_sym_LPAREN2] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_DASH] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_AMP] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym___extension__] = ACTIONS(3087),
    [anon_sym_typedef] = ACTIONS(3087),
    [anon_sym_in] = ACTIONS(3087),
    [anon_sym_out] = ACTIONS(3087),
    [anon_sym_inout] = ACTIONS(3087),
    [anon_sym_virtual] = ACTIONS(3087),
    [anon_sym_extern] = ACTIONS(3087),
    [anon_sym___attribute__] = ACTIONS(3087),
    [anon_sym___attribute] = ACTIONS(3087),
    [anon_sym_using] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3085),
    [anon_sym___declspec] = ACTIONS(3087),
    [anon_sym___based] = ACTIONS(3087),
    [anon_sym___cdecl] = ACTIONS(3087),
    [anon_sym___clrcall] = ACTIONS(3087),
    [anon_sym___stdcall] = ACTIONS(3087),
    [anon_sym___fastcall] = ACTIONS(3087),
    [anon_sym___thiscall] = ACTIONS(3087),
    [anon_sym___vectorcall] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3085),
    [anon_sym_signed] = ACTIONS(3087),
    [anon_sym_unsigned] = ACTIONS(3087),
    [anon_sym_long] = ACTIONS(3087),
    [anon_sym_short] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_static] = ACTIONS(3087),
    [anon_sym_register] = ACTIONS(3087),
    [anon_sym_inline] = ACTIONS(3087),
    [anon_sym___inline] = ACTIONS(3087),
    [anon_sym___inline__] = ACTIONS(3087),
    [anon_sym___forceinline] = ACTIONS(3087),
    [anon_sym_thread_local] = ACTIONS(3087),
    [anon_sym___thread] = ACTIONS(3087),
    [anon_sym_const] = ACTIONS(3087),
    [anon_sym_constexpr] = ACTIONS(3087),
    [anon_sym_volatile] = ACTIONS(3087),
    [anon_sym_restrict] = ACTIONS(3087),
    [anon_sym___restrict__] = ACTIONS(3087),
    [anon_sym__Atomic] = ACTIONS(3087),
    [anon_sym__Noreturn] = ACTIONS(3087),
    [anon_sym_noreturn] = ACTIONS(3087),
    [anon_sym__Nonnull] = ACTIONS(3087),
    [anon_sym_mutable] = ACTIONS(3087),
    [anon_sym_constinit] = ACTIONS(3087),
    [anon_sym_consteval] = ACTIONS(3087),
    [anon_sym_alignas] = ACTIONS(3087),
    [anon_sym__Alignas] = ACTIONS(3087),
    [sym_primitive_type] = ACTIONS(3087),
    [anon_sym_enum] = ACTIONS(3087),
    [anon_sym_class] = ACTIONS(3087),
    [anon_sym_struct] = ACTIONS(3087),
    [anon_sym_union] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_switch] = ACTIONS(3087),
    [anon_sym_case] = ACTIONS(3087),
    [anon_sym_default] = ACTIONS(3087),
    [anon_sym_while] = ACTIONS(3087),
    [anon_sym_do] = ACTIONS(3087),
    [anon_sym_for] = ACTIONS(3087),
    [anon_sym_return] = ACTIONS(3087),
    [anon_sym_break] = ACTIONS(3087),
    [anon_sym_continue] = ACTIONS(3087),
    [anon_sym_goto] = ACTIONS(3087),
    [anon_sym_not] = ACTIONS(3087),
    [anon_sym_compl] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3085),
    [anon_sym_PLUS_PLUS] = ACTIONS(3085),
    [anon_sym_sizeof] = ACTIONS(3087),
    [anon_sym___alignof__] = ACTIONS(3087),
    [anon_sym___alignof] = ACTIONS(3087),
    [anon_sym__alignof] = ACTIONS(3087),
    [anon_sym_alignof] = ACTIONS(3087),
    [anon_sym__Alignof] = ACTIONS(3087),
    [anon_sym_offsetof] = ACTIONS(3087),
    [anon_sym__Generic] = ACTIONS(3087),
    [anon_sym_asm] = ACTIONS(3087),
    [anon_sym___asm__] = ACTIONS(3087),
    [anon_sym___asm] = ACTIONS(3087),
    [sym_number_literal] = ACTIONS(3085),
    [anon_sym_L_SQUOTE] = ACTIONS(3085),
    [anon_sym_u_SQUOTE] = ACTIONS(3085),
    [anon_sym_U_SQUOTE] = ACTIONS(3085),
    [anon_sym_u8_SQUOTE] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_L_DQUOTE] = ACTIONS(3085),
    [anon_sym_u_DQUOTE] = ACTIONS(3085),
    [anon_sym_U_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8_DQUOTE] = ACTIONS(3085),
    [anon_sym_DQUOTE] = ACTIONS(3085),
    [sym_true] = ACTIONS(3087),
    [sym_false] = ACTIONS(3087),
    [anon_sym_NULL] = ACTIONS(3087),
    [anon_sym_nullptr] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3087),
    [anon_sym_decltype] = ACTIONS(3087),
    [anon_sym_explicit] = ACTIONS(3087),
    [anon_sym_typename] = ACTIONS(3087),
    [anon_sym_export] = ACTIONS(3087),
    [anon_sym_module] = ACTIONS(3087),
    [anon_sym_import] = ACTIONS(3087),
    [anon_sym_template] = ACTIONS(3087),
    [anon_sym_operator] = ACTIONS(3087),
    [anon_sym_try] = ACTIONS(3087),
    [anon_sym_delete] = ACTIONS(3087),
    [anon_sym_throw] = ACTIONS(3087),
    [anon_sym_namespace] = ACTIONS(3087),
    [anon_sym_static_assert] = ACTIONS(3087),
    [anon_sym_concept] = ACTIONS(3087),
    [anon_sym_co_return] = ACTIONS(3087),
    [anon_sym_co_yield] = ACTIONS(3087),
    [anon_sym_R_DQUOTE] = ACTIONS(3085),
    [anon_sym_LR_DQUOTE] = ACTIONS(3085),
    [anon_sym_uR_DQUOTE] = ACTIONS(3085),
    [anon_sym_UR_DQUOTE] = ACTIONS(3085),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3085),
    [anon_sym_co_await] = ACTIONS(3087),
    [anon_sym_new] = ACTIONS(3087),
    [anon_sym_requires] = ACTIONS(3087),
    [sym_this] = ACTIONS(3087),
    [anon_sym_precise] = ACTIONS(3087),
    [anon_sym_shared] = ACTIONS(3087),
    [anon_sym_groupshared] = ACTIONS(3087),
    [anon_sym_uniform] = ACTIONS(3087),
    [anon_sym_row_major] = ACTIONS(3087),
    [anon_sym_column_major] = ACTIONS(3087),
    [anon_sym_globallycoherent] = ACTIONS(3087),
    [anon_sym_centroid] = ACTIONS(3087),
    [anon_sym_noperspective] = ACTIONS(3087),
    [anon_sym_nointerpolation] = ACTIONS(3087),
    [anon_sym_sample] = ACTIONS(3087),
    [anon_sym_linear] = ACTIONS(3087),
    [anon_sym_snorm] = ACTIONS(3087),
    [anon_sym_unorm] = ACTIONS(3087),
    [anon_sym_point] = ACTIONS(3087),
    [anon_sym_line] = ACTIONS(3087),
    [anon_sym_triangleadj] = ACTIONS(3087),
    [anon_sym_lineadj] = ACTIONS(3087),
    [anon_sym_triangle] = ACTIONS(3087),
  },
  [800] = {
    [ts_builtin_sym_end] = ACTIONS(2570),
    [sym_identifier] = ACTIONS(2568),
    [aux_sym_preproc_include_token1] = ACTIONS(2568),
    [aux_sym_preproc_def_token1] = ACTIONS(2568),
    [aux_sym_preproc_if_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2568),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2568),
    [sym_preproc_directive] = ACTIONS(2568),
    [anon_sym_LPAREN2] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2570),
    [anon_sym_TILDE] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2568),
    [anon_sym_STAR] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_AMP] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym___extension__] = ACTIONS(2568),
    [anon_sym_typedef] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2568),
    [anon_sym_out] = ACTIONS(2568),
    [anon_sym_inout] = ACTIONS(2568),
    [anon_sym_virtual] = ACTIONS(2568),
    [anon_sym_extern] = ACTIONS(2568),
    [anon_sym___attribute__] = ACTIONS(2568),
    [anon_sym___attribute] = ACTIONS(2568),
    [anon_sym_using] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2570),
    [anon_sym___declspec] = ACTIONS(2568),
    [anon_sym___based] = ACTIONS(2568),
    [anon_sym___cdecl] = ACTIONS(2568),
    [anon_sym___clrcall] = ACTIONS(2568),
    [anon_sym___stdcall] = ACTIONS(2568),
    [anon_sym___fastcall] = ACTIONS(2568),
    [anon_sym___thiscall] = ACTIONS(2568),
    [anon_sym___vectorcall] = ACTIONS(2568),
    [anon_sym_LBRACE] = ACTIONS(2570),
    [anon_sym_signed] = ACTIONS(2568),
    [anon_sym_unsigned] = ACTIONS(2568),
    [anon_sym_long] = ACTIONS(2568),
    [anon_sym_short] = ACTIONS(2568),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2568),
    [anon_sym_register] = ACTIONS(2568),
    [anon_sym_inline] = ACTIONS(2568),
    [anon_sym___inline] = ACTIONS(2568),
    [anon_sym___inline__] = ACTIONS(2568),
    [anon_sym___forceinline] = ACTIONS(2568),
    [anon_sym_thread_local] = ACTIONS(2568),
    [anon_sym___thread] = ACTIONS(2568),
    [anon_sym_const] = ACTIONS(2568),
    [anon_sym_constexpr] = ACTIONS(2568),
    [anon_sym_volatile] = ACTIONS(2568),
    [anon_sym_restrict] = ACTIONS(2568),
    [anon_sym___restrict__] = ACTIONS(2568),
    [anon_sym__Atomic] = ACTIONS(2568),
    [anon_sym__Noreturn] = ACTIONS(2568),
    [anon_sym_noreturn] = ACTIONS(2568),
    [anon_sym__Nonnull] = ACTIONS(2568),
    [anon_sym_mutable] = ACTIONS(2568),
    [anon_sym_constinit] = ACTIONS(2568),
    [anon_sym_consteval] = ACTIONS(2568),
    [anon_sym_alignas] = ACTIONS(2568),
    [anon_sym__Alignas] = ACTIONS(2568),
    [sym_primitive_type] = ACTIONS(2568),
    [anon_sym_enum] = ACTIONS(2568),
    [anon_sym_class] = ACTIONS(2568),
    [anon_sym_struct] = ACTIONS(2568),
    [anon_sym_union] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_switch] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2568),
    [anon_sym_default] = ACTIONS(2568),
    [anon_sym_while] = ACTIONS(2568),
    [anon_sym_do] = ACTIONS(2568),
    [anon_sym_for] = ACTIONS(2568),
    [anon_sym_return] = ACTIONS(2568),
    [anon_sym_break] = ACTIONS(2568),
    [anon_sym_continue] = ACTIONS(2568),
    [anon_sym_goto] = ACTIONS(2568),
    [anon_sym_not] = ACTIONS(2568),
    [anon_sym_compl] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(2570),
    [anon_sym_sizeof] = ACTIONS(2568),
    [anon_sym___alignof__] = ACTIONS(2568),
    [anon_sym___alignof] = ACTIONS(2568),
    [anon_sym__alignof] = ACTIONS(2568),
    [anon_sym_alignof] = ACTIONS(2568),
    [anon_sym__Alignof] = ACTIONS(2568),
    [anon_sym_offsetof] = ACTIONS(2568),
    [anon_sym__Generic] = ACTIONS(2568),
    [anon_sym_asm] = ACTIONS(2568),
    [anon_sym___asm__] = ACTIONS(2568),
    [anon_sym___asm] = ACTIONS(2568),
    [sym_number_literal] = ACTIONS(2570),
    [anon_sym_L_SQUOTE] = ACTIONS(2570),
    [anon_sym_u_SQUOTE] = ACTIONS(2570),
    [anon_sym_U_SQUOTE] = ACTIONS(2570),
    [anon_sym_u8_SQUOTE] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_L_DQUOTE] = ACTIONS(2570),
    [anon_sym_u_DQUOTE] = ACTIONS(2570),
    [anon_sym_U_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8_DQUOTE] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(2570),
    [sym_true] = ACTIONS(2568),
    [sym_false] = ACTIONS(2568),
    [anon_sym_NULL] = ACTIONS(2568),
    [anon_sym_nullptr] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2568),
    [anon_sym_decltype] = ACTIONS(2568),
    [anon_sym_explicit] = ACTIONS(2568),
    [anon_sym_typename] = ACTIONS(2568),
    [anon_sym_export] = ACTIONS(2568),
    [anon_sym_module] = ACTIONS(2568),
    [anon_sym_import] = ACTIONS(2568),
    [anon_sym_template] = ACTIONS(2568),
    [anon_sym_operator] = ACTIONS(2568),
    [anon_sym_try] = ACTIONS(2568),
    [anon_sym_delete] = ACTIONS(2568),
    [anon_sym_throw] = ACTIONS(2568),
    [anon_sym_namespace] = ACTIONS(2568),
    [anon_sym_static_assert] = ACTIONS(2568),
    [anon_sym_concept] = ACTIONS(2568),
    [anon_sym_co_return] = ACTIONS(2568),
    [anon_sym_co_yield] = ACTIONS(2568),
    [anon_sym_R_DQUOTE] = ACTIONS(2570),
    [anon_sym_LR_DQUOTE] = ACTIONS(2570),
    [anon_sym_uR_DQUOTE] = ACTIONS(2570),
    [anon_sym_UR_DQUOTE] = ACTIONS(2570),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2570),
    [anon_sym_co_await] = ACTIONS(2568),
    [anon_sym_new] = ACTIONS(2568),
    [anon_sym_requires] = ACTIONS(2568),
    [sym_this] = ACTIONS(2568),
    [anon_sym_precise] = ACTIONS(2568),
    [anon_sym_shared] = ACTIONS(2568),
    [anon_sym_groupshared] = ACTIONS(2568),
    [anon_sym_uniform] = ACTIONS(2568),
    [anon_sym_row_major] = ACTIONS(2568),
    [anon_sym_column_major] = ACTIONS(2568),
    [anon_sym_globallycoherent] = ACTIONS(2568),
    [anon_sym_centroid] = ACTIONS(2568),
    [anon_sym_noperspective] = ACTIONS(2568),
    [anon_sym_nointerpolation] = ACTIONS(2568),
    [anon_sym_sample] = ACTIONS(2568),
    [anon_sym_linear] = ACTIONS(2568),
    [anon_sym_snorm] = ACTIONS(2568),
    [anon_sym_unorm] = ACTIONS(2568),
    [anon_sym_point] = ACTIONS(2568),
    [anon_sym_line] = ACTIONS(2568),
    [anon_sym_triangleadj] = ACTIONS(2568),
    [anon_sym_lineadj] = ACTIONS(2568),
    [anon_sym_triangle] = ACTIONS(2568),
  },
  [801] = {
    [ts_builtin_sym_end] = ACTIONS(2574),
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_include_token1] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2572),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym___cdecl] = ACTIONS(2572),
    [anon_sym___clrcall] = ACTIONS(2572),
    [anon_sym___stdcall] = ACTIONS(2572),
    [anon_sym___fastcall] = ACTIONS(2572),
    [anon_sym___thiscall] = ACTIONS(2572),
    [anon_sym___vectorcall] = ACTIONS(2572),
    [anon_sym_LBRACE] = ACTIONS(2574),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2572),
    [anon_sym_switch] = ACTIONS(2572),
    [anon_sym_case] = ACTIONS(2572),
    [anon_sym_default] = ACTIONS(2572),
    [anon_sym_while] = ACTIONS(2572),
    [anon_sym_do] = ACTIONS(2572),
    [anon_sym_for] = ACTIONS(2572),
    [anon_sym_return] = ACTIONS(2572),
    [anon_sym_break] = ACTIONS(2572),
    [anon_sym_continue] = ACTIONS(2572),
    [anon_sym_goto] = ACTIONS(2572),
    [anon_sym_not] = ACTIONS(2572),
    [anon_sym_compl] = ACTIONS(2572),
    [anon_sym_DASH_DASH] = ACTIONS(2574),
    [anon_sym_PLUS_PLUS] = ACTIONS(2574),
    [anon_sym_sizeof] = ACTIONS(2572),
    [anon_sym___alignof__] = ACTIONS(2572),
    [anon_sym___alignof] = ACTIONS(2572),
    [anon_sym__alignof] = ACTIONS(2572),
    [anon_sym_alignof] = ACTIONS(2572),
    [anon_sym__Alignof] = ACTIONS(2572),
    [anon_sym_offsetof] = ACTIONS(2572),
    [anon_sym__Generic] = ACTIONS(2572),
    [anon_sym_asm] = ACTIONS(2572),
    [anon_sym___asm__] = ACTIONS(2572),
    [anon_sym___asm] = ACTIONS(2572),
    [sym_number_literal] = ACTIONS(2574),
    [anon_sym_L_SQUOTE] = ACTIONS(2574),
    [anon_sym_u_SQUOTE] = ACTIONS(2574),
    [anon_sym_U_SQUOTE] = ACTIONS(2574),
    [anon_sym_u8_SQUOTE] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_L_DQUOTE] = ACTIONS(2574),
    [anon_sym_u_DQUOTE] = ACTIONS(2574),
    [anon_sym_U_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8_DQUOTE] = ACTIONS(2574),
    [anon_sym_DQUOTE] = ACTIONS(2574),
    [sym_true] = ACTIONS(2572),
    [sym_false] = ACTIONS(2572),
    [anon_sym_NULL] = ACTIONS(2572),
    [anon_sym_nullptr] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_export] = ACTIONS(2572),
    [anon_sym_module] = ACTIONS(2572),
    [anon_sym_import] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_try] = ACTIONS(2572),
    [anon_sym_delete] = ACTIONS(2572),
    [anon_sym_throw] = ACTIONS(2572),
    [anon_sym_namespace] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_concept] = ACTIONS(2572),
    [anon_sym_co_return] = ACTIONS(2572),
    [anon_sym_co_yield] = ACTIONS(2572),
    [anon_sym_R_DQUOTE] = ACTIONS(2574),
    [anon_sym_LR_DQUOTE] = ACTIONS(2574),
    [anon_sym_uR_DQUOTE] = ACTIONS(2574),
    [anon_sym_UR_DQUOTE] = ACTIONS(2574),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2574),
    [anon_sym_co_await] = ACTIONS(2572),
    [anon_sym_new] = ACTIONS(2572),
    [anon_sym_requires] = ACTIONS(2572),
    [sym_this] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
  },
  [802] = {
    [ts_builtin_sym_end] = ACTIONS(3089),
    [sym_identifier] = ACTIONS(3091),
    [aux_sym_preproc_include_token1] = ACTIONS(3091),
    [aux_sym_preproc_def_token1] = ACTIONS(3091),
    [aux_sym_preproc_if_token1] = ACTIONS(3091),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3091),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3091),
    [sym_preproc_directive] = ACTIONS(3091),
    [anon_sym_LPAREN2] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_AMP_AMP] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym___extension__] = ACTIONS(3091),
    [anon_sym_typedef] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3091),
    [anon_sym_out] = ACTIONS(3091),
    [anon_sym_inout] = ACTIONS(3091),
    [anon_sym_virtual] = ACTIONS(3091),
    [anon_sym_extern] = ACTIONS(3091),
    [anon_sym___attribute__] = ACTIONS(3091),
    [anon_sym___attribute] = ACTIONS(3091),
    [anon_sym_using] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3089),
    [anon_sym___declspec] = ACTIONS(3091),
    [anon_sym___based] = ACTIONS(3091),
    [anon_sym___cdecl] = ACTIONS(3091),
    [anon_sym___clrcall] = ACTIONS(3091),
    [anon_sym___stdcall] = ACTIONS(3091),
    [anon_sym___fastcall] = ACTIONS(3091),
    [anon_sym___thiscall] = ACTIONS(3091),
    [anon_sym___vectorcall] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3091),
    [anon_sym_unsigned] = ACTIONS(3091),
    [anon_sym_long] = ACTIONS(3091),
    [anon_sym_short] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_static] = ACTIONS(3091),
    [anon_sym_register] = ACTIONS(3091),
    [anon_sym_inline] = ACTIONS(3091),
    [anon_sym___inline] = ACTIONS(3091),
    [anon_sym___inline__] = ACTIONS(3091),
    [anon_sym___forceinline] = ACTIONS(3091),
    [anon_sym_thread_local] = ACTIONS(3091),
    [anon_sym___thread] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3091),
    [anon_sym_constexpr] = ACTIONS(3091),
    [anon_sym_volatile] = ACTIONS(3091),
    [anon_sym_restrict] = ACTIONS(3091),
    [anon_sym___restrict__] = ACTIONS(3091),
    [anon_sym__Atomic] = ACTIONS(3091),
    [anon_sym__Noreturn] = ACTIONS(3091),
    [anon_sym_noreturn] = ACTIONS(3091),
    [anon_sym__Nonnull] = ACTIONS(3091),
    [anon_sym_mutable] = ACTIONS(3091),
    [anon_sym_constinit] = ACTIONS(3091),
    [anon_sym_consteval] = ACTIONS(3091),
    [anon_sym_alignas] = ACTIONS(3091),
    [anon_sym__Alignas] = ACTIONS(3091),
    [sym_primitive_type] = ACTIONS(3091),
    [anon_sym_enum] = ACTIONS(3091),
    [anon_sym_class] = ACTIONS(3091),
    [anon_sym_struct] = ACTIONS(3091),
    [anon_sym_union] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3091),
    [anon_sym_switch] = ACTIONS(3091),
    [anon_sym_case] = ACTIONS(3091),
    [anon_sym_default] = ACTIONS(3091),
    [anon_sym_while] = ACTIONS(3091),
    [anon_sym_do] = ACTIONS(3091),
    [anon_sym_for] = ACTIONS(3091),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_break] = ACTIONS(3091),
    [anon_sym_continue] = ACTIONS(3091),
    [anon_sym_goto] = ACTIONS(3091),
    [anon_sym_not] = ACTIONS(3091),
    [anon_sym_compl] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3091),
    [anon_sym___alignof__] = ACTIONS(3091),
    [anon_sym___alignof] = ACTIONS(3091),
    [anon_sym__alignof] = ACTIONS(3091),
    [anon_sym_alignof] = ACTIONS(3091),
    [anon_sym__Alignof] = ACTIONS(3091),
    [anon_sym_offsetof] = ACTIONS(3091),
    [anon_sym__Generic] = ACTIONS(3091),
    [anon_sym_asm] = ACTIONS(3091),
    [anon_sym___asm__] = ACTIONS(3091),
    [anon_sym___asm] = ACTIONS(3091),
    [sym_number_literal] = ACTIONS(3089),
    [anon_sym_L_SQUOTE] = ACTIONS(3089),
    [anon_sym_u_SQUOTE] = ACTIONS(3089),
    [anon_sym_U_SQUOTE] = ACTIONS(3089),
    [anon_sym_u8_SQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym_L_DQUOTE] = ACTIONS(3089),
    [anon_sym_u_DQUOTE] = ACTIONS(3089),
    [anon_sym_U_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [sym_true] = ACTIONS(3091),
    [sym_false] = ACTIONS(3091),
    [anon_sym_NULL] = ACTIONS(3091),
    [anon_sym_nullptr] = ACTIONS(3091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3091),
    [anon_sym_decltype] = ACTIONS(3091),
    [anon_sym_explicit] = ACTIONS(3091),
    [anon_sym_typename] = ACTIONS(3091),
    [anon_sym_export] = ACTIONS(3091),
    [anon_sym_module] = ACTIONS(3091),
    [anon_sym_import] = ACTIONS(3091),
    [anon_sym_template] = ACTIONS(3091),
    [anon_sym_operator] = ACTIONS(3091),
    [anon_sym_try] = ACTIONS(3091),
    [anon_sym_delete] = ACTIONS(3091),
    [anon_sym_throw] = ACTIONS(3091),
    [anon_sym_namespace] = ACTIONS(3091),
    [anon_sym_static_assert] = ACTIONS(3091),
    [anon_sym_concept] = ACTIONS(3091),
    [anon_sym_co_return] = ACTIONS(3091),
    [anon_sym_co_yield] = ACTIONS(3091),
    [anon_sym_R_DQUOTE] = ACTIONS(3089),
    [anon_sym_LR_DQUOTE] = ACTIONS(3089),
    [anon_sym_uR_DQUOTE] = ACTIONS(3089),
    [anon_sym_UR_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3089),
    [anon_sym_co_await] = ACTIONS(3091),
    [anon_sym_new] = ACTIONS(3091),
    [anon_sym_requires] = ACTIONS(3091),
    [sym_this] = ACTIONS(3091),
    [anon_sym_precise] = ACTIONS(3091),
    [anon_sym_shared] = ACTIONS(3091),
    [anon_sym_groupshared] = ACTIONS(3091),
    [anon_sym_uniform] = ACTIONS(3091),
    [anon_sym_row_major] = ACTIONS(3091),
    [anon_sym_column_major] = ACTIONS(3091),
    [anon_sym_globallycoherent] = ACTIONS(3091),
    [anon_sym_centroid] = ACTIONS(3091),
    [anon_sym_noperspective] = ACTIONS(3091),
    [anon_sym_nointerpolation] = ACTIONS(3091),
    [anon_sym_sample] = ACTIONS(3091),
    [anon_sym_linear] = ACTIONS(3091),
    [anon_sym_snorm] = ACTIONS(3091),
    [anon_sym_unorm] = ACTIONS(3091),
    [anon_sym_point] = ACTIONS(3091),
    [anon_sym_line] = ACTIONS(3091),
    [anon_sym_triangleadj] = ACTIONS(3091),
    [anon_sym_lineadj] = ACTIONS(3091),
    [anon_sym_triangle] = ACTIONS(3091),
  },
  [803] = {
    [ts_builtin_sym_end] = ACTIONS(3093),
    [sym_identifier] = ACTIONS(3095),
    [aux_sym_preproc_include_token1] = ACTIONS(3095),
    [aux_sym_preproc_def_token1] = ACTIONS(3095),
    [aux_sym_preproc_if_token1] = ACTIONS(3095),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3095),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3095),
    [sym_preproc_directive] = ACTIONS(3095),
    [anon_sym_LPAREN2] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_DASH] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_AMP_AMP] = ACTIONS(3093),
    [anon_sym_AMP] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym___extension__] = ACTIONS(3095),
    [anon_sym_typedef] = ACTIONS(3095),
    [anon_sym_in] = ACTIONS(3095),
    [anon_sym_out] = ACTIONS(3095),
    [anon_sym_inout] = ACTIONS(3095),
    [anon_sym_virtual] = ACTIONS(3095),
    [anon_sym_extern] = ACTIONS(3095),
    [anon_sym___attribute__] = ACTIONS(3095),
    [anon_sym___attribute] = ACTIONS(3095),
    [anon_sym_using] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3093),
    [anon_sym___declspec] = ACTIONS(3095),
    [anon_sym___based] = ACTIONS(3095),
    [anon_sym___cdecl] = ACTIONS(3095),
    [anon_sym___clrcall] = ACTIONS(3095),
    [anon_sym___stdcall] = ACTIONS(3095),
    [anon_sym___fastcall] = ACTIONS(3095),
    [anon_sym___thiscall] = ACTIONS(3095),
    [anon_sym___vectorcall] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3093),
    [anon_sym_signed] = ACTIONS(3095),
    [anon_sym_unsigned] = ACTIONS(3095),
    [anon_sym_long] = ACTIONS(3095),
    [anon_sym_short] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_static] = ACTIONS(3095),
    [anon_sym_register] = ACTIONS(3095),
    [anon_sym_inline] = ACTIONS(3095),
    [anon_sym___inline] = ACTIONS(3095),
    [anon_sym___inline__] = ACTIONS(3095),
    [anon_sym___forceinline] = ACTIONS(3095),
    [anon_sym_thread_local] = ACTIONS(3095),
    [anon_sym___thread] = ACTIONS(3095),
    [anon_sym_const] = ACTIONS(3095),
    [anon_sym_constexpr] = ACTIONS(3095),
    [anon_sym_volatile] = ACTIONS(3095),
    [anon_sym_restrict] = ACTIONS(3095),
    [anon_sym___restrict__] = ACTIONS(3095),
    [anon_sym__Atomic] = ACTIONS(3095),
    [anon_sym__Noreturn] = ACTIONS(3095),
    [anon_sym_noreturn] = ACTIONS(3095),
    [anon_sym__Nonnull] = ACTIONS(3095),
    [anon_sym_mutable] = ACTIONS(3095),
    [anon_sym_constinit] = ACTIONS(3095),
    [anon_sym_consteval] = ACTIONS(3095),
    [anon_sym_alignas] = ACTIONS(3095),
    [anon_sym__Alignas] = ACTIONS(3095),
    [sym_primitive_type] = ACTIONS(3095),
    [anon_sym_enum] = ACTIONS(3095),
    [anon_sym_class] = ACTIONS(3095),
    [anon_sym_struct] = ACTIONS(3095),
    [anon_sym_union] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3095),
    [anon_sym_switch] = ACTIONS(3095),
    [anon_sym_case] = ACTIONS(3095),
    [anon_sym_default] = ACTIONS(3095),
    [anon_sym_while] = ACTIONS(3095),
    [anon_sym_do] = ACTIONS(3095),
    [anon_sym_for] = ACTIONS(3095),
    [anon_sym_return] = ACTIONS(3095),
    [anon_sym_break] = ACTIONS(3095),
    [anon_sym_continue] = ACTIONS(3095),
    [anon_sym_goto] = ACTIONS(3095),
    [anon_sym_not] = ACTIONS(3095),
    [anon_sym_compl] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3093),
    [anon_sym_PLUS_PLUS] = ACTIONS(3093),
    [anon_sym_sizeof] = ACTIONS(3095),
    [anon_sym___alignof__] = ACTIONS(3095),
    [anon_sym___alignof] = ACTIONS(3095),
    [anon_sym__alignof] = ACTIONS(3095),
    [anon_sym_alignof] = ACTIONS(3095),
    [anon_sym__Alignof] = ACTIONS(3095),
    [anon_sym_offsetof] = ACTIONS(3095),
    [anon_sym__Generic] = ACTIONS(3095),
    [anon_sym_asm] = ACTIONS(3095),
    [anon_sym___asm__] = ACTIONS(3095),
    [anon_sym___asm] = ACTIONS(3095),
    [sym_number_literal] = ACTIONS(3093),
    [anon_sym_L_SQUOTE] = ACTIONS(3093),
    [anon_sym_u_SQUOTE] = ACTIONS(3093),
    [anon_sym_U_SQUOTE] = ACTIONS(3093),
    [anon_sym_u8_SQUOTE] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym_L_DQUOTE] = ACTIONS(3093),
    [anon_sym_u_DQUOTE] = ACTIONS(3093),
    [anon_sym_U_DQUOTE] = ACTIONS(3093),
    [anon_sym_u8_DQUOTE] = ACTIONS(3093),
    [anon_sym_DQUOTE] = ACTIONS(3093),
    [sym_true] = ACTIONS(3095),
    [sym_false] = ACTIONS(3095),
    [anon_sym_NULL] = ACTIONS(3095),
    [anon_sym_nullptr] = ACTIONS(3095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3095),
    [anon_sym_decltype] = ACTIONS(3095),
    [anon_sym_explicit] = ACTIONS(3095),
    [anon_sym_typename] = ACTIONS(3095),
    [anon_sym_export] = ACTIONS(3095),
    [anon_sym_module] = ACTIONS(3095),
    [anon_sym_import] = ACTIONS(3095),
    [anon_sym_template] = ACTIONS(3095),
    [anon_sym_operator] = ACTIONS(3095),
    [anon_sym_try] = ACTIONS(3095),
    [anon_sym_delete] = ACTIONS(3095),
    [anon_sym_throw] = ACTIONS(3095),
    [anon_sym_namespace] = ACTIONS(3095),
    [anon_sym_static_assert] = ACTIONS(3095),
    [anon_sym_concept] = ACTIONS(3095),
    [anon_sym_co_return] = ACTIONS(3095),
    [anon_sym_co_yield] = ACTIONS(3095),
    [anon_sym_R_DQUOTE] = ACTIONS(3093),
    [anon_sym_LR_DQUOTE] = ACTIONS(3093),
    [anon_sym_uR_DQUOTE] = ACTIONS(3093),
    [anon_sym_UR_DQUOTE] = ACTIONS(3093),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3093),
    [anon_sym_co_await] = ACTIONS(3095),
    [anon_sym_new] = ACTIONS(3095),
    [anon_sym_requires] = ACTIONS(3095),
    [sym_this] = ACTIONS(3095),
    [anon_sym_precise] = ACTIONS(3095),
    [anon_sym_shared] = ACTIONS(3095),
    [anon_sym_groupshared] = ACTIONS(3095),
    [anon_sym_uniform] = ACTIONS(3095),
    [anon_sym_row_major] = ACTIONS(3095),
    [anon_sym_column_major] = ACTIONS(3095),
    [anon_sym_globallycoherent] = ACTIONS(3095),
    [anon_sym_centroid] = ACTIONS(3095),
    [anon_sym_noperspective] = ACTIONS(3095),
    [anon_sym_nointerpolation] = ACTIONS(3095),
    [anon_sym_sample] = ACTIONS(3095),
    [anon_sym_linear] = ACTIONS(3095),
    [anon_sym_snorm] = ACTIONS(3095),
    [anon_sym_unorm] = ACTIONS(3095),
    [anon_sym_point] = ACTIONS(3095),
    [anon_sym_line] = ACTIONS(3095),
    [anon_sym_triangleadj] = ACTIONS(3095),
    [anon_sym_lineadj] = ACTIONS(3095),
    [anon_sym_triangle] = ACTIONS(3095),
  },
  [804] = {
    [ts_builtin_sym_end] = ACTIONS(3097),
    [sym_identifier] = ACTIONS(3099),
    [aux_sym_preproc_include_token1] = ACTIONS(3099),
    [aux_sym_preproc_def_token1] = ACTIONS(3099),
    [aux_sym_preproc_if_token1] = ACTIONS(3099),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3099),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3099),
    [sym_preproc_directive] = ACTIONS(3099),
    [anon_sym_LPAREN2] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_DASH] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_AMP] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym___extension__] = ACTIONS(3099),
    [anon_sym_typedef] = ACTIONS(3099),
    [anon_sym_in] = ACTIONS(3099),
    [anon_sym_out] = ACTIONS(3099),
    [anon_sym_inout] = ACTIONS(3099),
    [anon_sym_virtual] = ACTIONS(3099),
    [anon_sym_extern] = ACTIONS(3099),
    [anon_sym___attribute__] = ACTIONS(3099),
    [anon_sym___attribute] = ACTIONS(3099),
    [anon_sym_using] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3097),
    [anon_sym___declspec] = ACTIONS(3099),
    [anon_sym___based] = ACTIONS(3099),
    [anon_sym___cdecl] = ACTIONS(3099),
    [anon_sym___clrcall] = ACTIONS(3099),
    [anon_sym___stdcall] = ACTIONS(3099),
    [anon_sym___fastcall] = ACTIONS(3099),
    [anon_sym___thiscall] = ACTIONS(3099),
    [anon_sym___vectorcall] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3097),
    [anon_sym_signed] = ACTIONS(3099),
    [anon_sym_unsigned] = ACTIONS(3099),
    [anon_sym_long] = ACTIONS(3099),
    [anon_sym_short] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_static] = ACTIONS(3099),
    [anon_sym_register] = ACTIONS(3099),
    [anon_sym_inline] = ACTIONS(3099),
    [anon_sym___inline] = ACTIONS(3099),
    [anon_sym___inline__] = ACTIONS(3099),
    [anon_sym___forceinline] = ACTIONS(3099),
    [anon_sym_thread_local] = ACTIONS(3099),
    [anon_sym___thread] = ACTIONS(3099),
    [anon_sym_const] = ACTIONS(3099),
    [anon_sym_constexpr] = ACTIONS(3099),
    [anon_sym_volatile] = ACTIONS(3099),
    [anon_sym_restrict] = ACTIONS(3099),
    [anon_sym___restrict__] = ACTIONS(3099),
    [anon_sym__Atomic] = ACTIONS(3099),
    [anon_sym__Noreturn] = ACTIONS(3099),
    [anon_sym_noreturn] = ACTIONS(3099),
    [anon_sym__Nonnull] = ACTIONS(3099),
    [anon_sym_mutable] = ACTIONS(3099),
    [anon_sym_constinit] = ACTIONS(3099),
    [anon_sym_consteval] = ACTIONS(3099),
    [anon_sym_alignas] = ACTIONS(3099),
    [anon_sym__Alignas] = ACTIONS(3099),
    [sym_primitive_type] = ACTIONS(3099),
    [anon_sym_enum] = ACTIONS(3099),
    [anon_sym_class] = ACTIONS(3099),
    [anon_sym_struct] = ACTIONS(3099),
    [anon_sym_union] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3099),
    [anon_sym_case] = ACTIONS(3099),
    [anon_sym_default] = ACTIONS(3099),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_do] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3099),
    [anon_sym_return] = ACTIONS(3099),
    [anon_sym_break] = ACTIONS(3099),
    [anon_sym_continue] = ACTIONS(3099),
    [anon_sym_goto] = ACTIONS(3099),
    [anon_sym_not] = ACTIONS(3099),
    [anon_sym_compl] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3097),
    [anon_sym_PLUS_PLUS] = ACTIONS(3097),
    [anon_sym_sizeof] = ACTIONS(3099),
    [anon_sym___alignof__] = ACTIONS(3099),
    [anon_sym___alignof] = ACTIONS(3099),
    [anon_sym__alignof] = ACTIONS(3099),
    [anon_sym_alignof] = ACTIONS(3099),
    [anon_sym__Alignof] = ACTIONS(3099),
    [anon_sym_offsetof] = ACTIONS(3099),
    [anon_sym__Generic] = ACTIONS(3099),
    [anon_sym_asm] = ACTIONS(3099),
    [anon_sym___asm__] = ACTIONS(3099),
    [anon_sym___asm] = ACTIONS(3099),
    [sym_number_literal] = ACTIONS(3097),
    [anon_sym_L_SQUOTE] = ACTIONS(3097),
    [anon_sym_u_SQUOTE] = ACTIONS(3097),
    [anon_sym_U_SQUOTE] = ACTIONS(3097),
    [anon_sym_u8_SQUOTE] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [anon_sym_L_DQUOTE] = ACTIONS(3097),
    [anon_sym_u_DQUOTE] = ACTIONS(3097),
    [anon_sym_U_DQUOTE] = ACTIONS(3097),
    [anon_sym_u8_DQUOTE] = ACTIONS(3097),
    [anon_sym_DQUOTE] = ACTIONS(3097),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [anon_sym_NULL] = ACTIONS(3099),
    [anon_sym_nullptr] = ACTIONS(3099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3099),
    [anon_sym_decltype] = ACTIONS(3099),
    [anon_sym_explicit] = ACTIONS(3099),
    [anon_sym_typename] = ACTIONS(3099),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_module] = ACTIONS(3099),
    [anon_sym_import] = ACTIONS(3099),
    [anon_sym_template] = ACTIONS(3099),
    [anon_sym_operator] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3099),
    [anon_sym_delete] = ACTIONS(3099),
    [anon_sym_throw] = ACTIONS(3099),
    [anon_sym_namespace] = ACTIONS(3099),
    [anon_sym_static_assert] = ACTIONS(3099),
    [anon_sym_concept] = ACTIONS(3099),
    [anon_sym_co_return] = ACTIONS(3099),
    [anon_sym_co_yield] = ACTIONS(3099),
    [anon_sym_R_DQUOTE] = ACTIONS(3097),
    [anon_sym_LR_DQUOTE] = ACTIONS(3097),
    [anon_sym_uR_DQUOTE] = ACTIONS(3097),
    [anon_sym_UR_DQUOTE] = ACTIONS(3097),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3097),
    [anon_sym_co_await] = ACTIONS(3099),
    [anon_sym_new] = ACTIONS(3099),
    [anon_sym_requires] = ACTIONS(3099),
    [sym_this] = ACTIONS(3099),
    [anon_sym_precise] = ACTIONS(3099),
    [anon_sym_shared] = ACTIONS(3099),
    [anon_sym_groupshared] = ACTIONS(3099),
    [anon_sym_uniform] = ACTIONS(3099),
    [anon_sym_row_major] = ACTIONS(3099),
    [anon_sym_column_major] = ACTIONS(3099),
    [anon_sym_globallycoherent] = ACTIONS(3099),
    [anon_sym_centroid] = ACTIONS(3099),
    [anon_sym_noperspective] = ACTIONS(3099),
    [anon_sym_nointerpolation] = ACTIONS(3099),
    [anon_sym_sample] = ACTIONS(3099),
    [anon_sym_linear] = ACTIONS(3099),
    [anon_sym_snorm] = ACTIONS(3099),
    [anon_sym_unorm] = ACTIONS(3099),
    [anon_sym_point] = ACTIONS(3099),
    [anon_sym_line] = ACTIONS(3099),
    [anon_sym_triangleadj] = ACTIONS(3099),
    [anon_sym_lineadj] = ACTIONS(3099),
    [anon_sym_triangle] = ACTIONS(3099),
  },
  [805] = {
    [ts_builtin_sym_end] = ACTIONS(3101),
    [sym_identifier] = ACTIONS(3103),
    [aux_sym_preproc_include_token1] = ACTIONS(3103),
    [aux_sym_preproc_def_token1] = ACTIONS(3103),
    [aux_sym_preproc_if_token1] = ACTIONS(3103),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3103),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3103),
    [sym_preproc_directive] = ACTIONS(3103),
    [anon_sym_LPAREN2] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_DASH] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_AMP_AMP] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym___extension__] = ACTIONS(3103),
    [anon_sym_typedef] = ACTIONS(3103),
    [anon_sym_in] = ACTIONS(3103),
    [anon_sym_out] = ACTIONS(3103),
    [anon_sym_inout] = ACTIONS(3103),
    [anon_sym_virtual] = ACTIONS(3103),
    [anon_sym_extern] = ACTIONS(3103),
    [anon_sym___attribute__] = ACTIONS(3103),
    [anon_sym___attribute] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3101),
    [anon_sym___declspec] = ACTIONS(3103),
    [anon_sym___based] = ACTIONS(3103),
    [anon_sym___cdecl] = ACTIONS(3103),
    [anon_sym___clrcall] = ACTIONS(3103),
    [anon_sym___stdcall] = ACTIONS(3103),
    [anon_sym___fastcall] = ACTIONS(3103),
    [anon_sym___thiscall] = ACTIONS(3103),
    [anon_sym___vectorcall] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_signed] = ACTIONS(3103),
    [anon_sym_unsigned] = ACTIONS(3103),
    [anon_sym_long] = ACTIONS(3103),
    [anon_sym_short] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_static] = ACTIONS(3103),
    [anon_sym_register] = ACTIONS(3103),
    [anon_sym_inline] = ACTIONS(3103),
    [anon_sym___inline] = ACTIONS(3103),
    [anon_sym___inline__] = ACTIONS(3103),
    [anon_sym___forceinline] = ACTIONS(3103),
    [anon_sym_thread_local] = ACTIONS(3103),
    [anon_sym___thread] = ACTIONS(3103),
    [anon_sym_const] = ACTIONS(3103),
    [anon_sym_constexpr] = ACTIONS(3103),
    [anon_sym_volatile] = ACTIONS(3103),
    [anon_sym_restrict] = ACTIONS(3103),
    [anon_sym___restrict__] = ACTIONS(3103),
    [anon_sym__Atomic] = ACTIONS(3103),
    [anon_sym__Noreturn] = ACTIONS(3103),
    [anon_sym_noreturn] = ACTIONS(3103),
    [anon_sym__Nonnull] = ACTIONS(3103),
    [anon_sym_mutable] = ACTIONS(3103),
    [anon_sym_constinit] = ACTIONS(3103),
    [anon_sym_consteval] = ACTIONS(3103),
    [anon_sym_alignas] = ACTIONS(3103),
    [anon_sym__Alignas] = ACTIONS(3103),
    [sym_primitive_type] = ACTIONS(3103),
    [anon_sym_enum] = ACTIONS(3103),
    [anon_sym_class] = ACTIONS(3103),
    [anon_sym_struct] = ACTIONS(3103),
    [anon_sym_union] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3103),
    [anon_sym_switch] = ACTIONS(3103),
    [anon_sym_case] = ACTIONS(3103),
    [anon_sym_default] = ACTIONS(3103),
    [anon_sym_while] = ACTIONS(3103),
    [anon_sym_do] = ACTIONS(3103),
    [anon_sym_for] = ACTIONS(3103),
    [anon_sym_return] = ACTIONS(3103),
    [anon_sym_break] = ACTIONS(3103),
    [anon_sym_continue] = ACTIONS(3103),
    [anon_sym_goto] = ACTIONS(3103),
    [anon_sym_not] = ACTIONS(3103),
    [anon_sym_compl] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3101),
    [anon_sym_sizeof] = ACTIONS(3103),
    [anon_sym___alignof__] = ACTIONS(3103),
    [anon_sym___alignof] = ACTIONS(3103),
    [anon_sym__alignof] = ACTIONS(3103),
    [anon_sym_alignof] = ACTIONS(3103),
    [anon_sym__Alignof] = ACTIONS(3103),
    [anon_sym_offsetof] = ACTIONS(3103),
    [anon_sym__Generic] = ACTIONS(3103),
    [anon_sym_asm] = ACTIONS(3103),
    [anon_sym___asm__] = ACTIONS(3103),
    [anon_sym___asm] = ACTIONS(3103),
    [sym_number_literal] = ACTIONS(3101),
    [anon_sym_L_SQUOTE] = ACTIONS(3101),
    [anon_sym_u_SQUOTE] = ACTIONS(3101),
    [anon_sym_U_SQUOTE] = ACTIONS(3101),
    [anon_sym_u8_SQUOTE] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [anon_sym_L_DQUOTE] = ACTIONS(3101),
    [anon_sym_u_DQUOTE] = ACTIONS(3101),
    [anon_sym_U_DQUOTE] = ACTIONS(3101),
    [anon_sym_u8_DQUOTE] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3101),
    [sym_true] = ACTIONS(3103),
    [sym_false] = ACTIONS(3103),
    [anon_sym_NULL] = ACTIONS(3103),
    [anon_sym_nullptr] = ACTIONS(3103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3103),
    [anon_sym_decltype] = ACTIONS(3103),
    [anon_sym_explicit] = ACTIONS(3103),
    [anon_sym_typename] = ACTIONS(3103),
    [anon_sym_export] = ACTIONS(3103),
    [anon_sym_module] = ACTIONS(3103),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_template] = ACTIONS(3103),
    [anon_sym_operator] = ACTIONS(3103),
    [anon_sym_try] = ACTIONS(3103),
    [anon_sym_delete] = ACTIONS(3103),
    [anon_sym_throw] = ACTIONS(3103),
    [anon_sym_namespace] = ACTIONS(3103),
    [anon_sym_static_assert] = ACTIONS(3103),
    [anon_sym_concept] = ACTIONS(3103),
    [anon_sym_co_return] = ACTIONS(3103),
    [anon_sym_co_yield] = ACTIONS(3103),
    [anon_sym_R_DQUOTE] = ACTIONS(3101),
    [anon_sym_LR_DQUOTE] = ACTIONS(3101),
    [anon_sym_uR_DQUOTE] = ACTIONS(3101),
    [anon_sym_UR_DQUOTE] = ACTIONS(3101),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3101),
    [anon_sym_co_await] = ACTIONS(3103),
    [anon_sym_new] = ACTIONS(3103),
    [anon_sym_requires] = ACTIONS(3103),
    [sym_this] = ACTIONS(3103),
    [anon_sym_precise] = ACTIONS(3103),
    [anon_sym_shared] = ACTIONS(3103),
    [anon_sym_groupshared] = ACTIONS(3103),
    [anon_sym_uniform] = ACTIONS(3103),
    [anon_sym_row_major] = ACTIONS(3103),
    [anon_sym_column_major] = ACTIONS(3103),
    [anon_sym_globallycoherent] = ACTIONS(3103),
    [anon_sym_centroid] = ACTIONS(3103),
    [anon_sym_noperspective] = ACTIONS(3103),
    [anon_sym_nointerpolation] = ACTIONS(3103),
    [anon_sym_sample] = ACTIONS(3103),
    [anon_sym_linear] = ACTIONS(3103),
    [anon_sym_snorm] = ACTIONS(3103),
    [anon_sym_unorm] = ACTIONS(3103),
    [anon_sym_point] = ACTIONS(3103),
    [anon_sym_line] = ACTIONS(3103),
    [anon_sym_triangleadj] = ACTIONS(3103),
    [anon_sym_lineadj] = ACTIONS(3103),
    [anon_sym_triangle] = ACTIONS(3103),
  },
  [806] = {
    [ts_builtin_sym_end] = ACTIONS(3105),
    [sym_identifier] = ACTIONS(3107),
    [aux_sym_preproc_include_token1] = ACTIONS(3107),
    [aux_sym_preproc_def_token1] = ACTIONS(3107),
    [aux_sym_preproc_if_token1] = ACTIONS(3107),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3107),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3107),
    [sym_preproc_directive] = ACTIONS(3107),
    [anon_sym_LPAREN2] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_DASH] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_AMP_AMP] = ACTIONS(3105),
    [anon_sym_AMP] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym___extension__] = ACTIONS(3107),
    [anon_sym_typedef] = ACTIONS(3107),
    [anon_sym_in] = ACTIONS(3107),
    [anon_sym_out] = ACTIONS(3107),
    [anon_sym_inout] = ACTIONS(3107),
    [anon_sym_virtual] = ACTIONS(3107),
    [anon_sym_extern] = ACTIONS(3107),
    [anon_sym___attribute__] = ACTIONS(3107),
    [anon_sym___attribute] = ACTIONS(3107),
    [anon_sym_using] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3105),
    [anon_sym___declspec] = ACTIONS(3107),
    [anon_sym___based] = ACTIONS(3107),
    [anon_sym___cdecl] = ACTIONS(3107),
    [anon_sym___clrcall] = ACTIONS(3107),
    [anon_sym___stdcall] = ACTIONS(3107),
    [anon_sym___fastcall] = ACTIONS(3107),
    [anon_sym___thiscall] = ACTIONS(3107),
    [anon_sym___vectorcall] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3105),
    [anon_sym_signed] = ACTIONS(3107),
    [anon_sym_unsigned] = ACTIONS(3107),
    [anon_sym_long] = ACTIONS(3107),
    [anon_sym_short] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_static] = ACTIONS(3107),
    [anon_sym_register] = ACTIONS(3107),
    [anon_sym_inline] = ACTIONS(3107),
    [anon_sym___inline] = ACTIONS(3107),
    [anon_sym___inline__] = ACTIONS(3107),
    [anon_sym___forceinline] = ACTIONS(3107),
    [anon_sym_thread_local] = ACTIONS(3107),
    [anon_sym___thread] = ACTIONS(3107),
    [anon_sym_const] = ACTIONS(3107),
    [anon_sym_constexpr] = ACTIONS(3107),
    [anon_sym_volatile] = ACTIONS(3107),
    [anon_sym_restrict] = ACTIONS(3107),
    [anon_sym___restrict__] = ACTIONS(3107),
    [anon_sym__Atomic] = ACTIONS(3107),
    [anon_sym__Noreturn] = ACTIONS(3107),
    [anon_sym_noreturn] = ACTIONS(3107),
    [anon_sym__Nonnull] = ACTIONS(3107),
    [anon_sym_mutable] = ACTIONS(3107),
    [anon_sym_constinit] = ACTIONS(3107),
    [anon_sym_consteval] = ACTIONS(3107),
    [anon_sym_alignas] = ACTIONS(3107),
    [anon_sym__Alignas] = ACTIONS(3107),
    [sym_primitive_type] = ACTIONS(3107),
    [anon_sym_enum] = ACTIONS(3107),
    [anon_sym_class] = ACTIONS(3107),
    [anon_sym_struct] = ACTIONS(3107),
    [anon_sym_union] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3107),
    [anon_sym_switch] = ACTIONS(3107),
    [anon_sym_case] = ACTIONS(3107),
    [anon_sym_default] = ACTIONS(3107),
    [anon_sym_while] = ACTIONS(3107),
    [anon_sym_do] = ACTIONS(3107),
    [anon_sym_for] = ACTIONS(3107),
    [anon_sym_return] = ACTIONS(3107),
    [anon_sym_break] = ACTIONS(3107),
    [anon_sym_continue] = ACTIONS(3107),
    [anon_sym_goto] = ACTIONS(3107),
    [anon_sym_not] = ACTIONS(3107),
    [anon_sym_compl] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3105),
    [anon_sym_PLUS_PLUS] = ACTIONS(3105),
    [anon_sym_sizeof] = ACTIONS(3107),
    [anon_sym___alignof__] = ACTIONS(3107),
    [anon_sym___alignof] = ACTIONS(3107),
    [anon_sym__alignof] = ACTIONS(3107),
    [anon_sym_alignof] = ACTIONS(3107),
    [anon_sym__Alignof] = ACTIONS(3107),
    [anon_sym_offsetof] = ACTIONS(3107),
    [anon_sym__Generic] = ACTIONS(3107),
    [anon_sym_asm] = ACTIONS(3107),
    [anon_sym___asm__] = ACTIONS(3107),
    [anon_sym___asm] = ACTIONS(3107),
    [sym_number_literal] = ACTIONS(3105),
    [anon_sym_L_SQUOTE] = ACTIONS(3105),
    [anon_sym_u_SQUOTE] = ACTIONS(3105),
    [anon_sym_U_SQUOTE] = ACTIONS(3105),
    [anon_sym_u8_SQUOTE] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [anon_sym_L_DQUOTE] = ACTIONS(3105),
    [anon_sym_u_DQUOTE] = ACTIONS(3105),
    [anon_sym_U_DQUOTE] = ACTIONS(3105),
    [anon_sym_u8_DQUOTE] = ACTIONS(3105),
    [anon_sym_DQUOTE] = ACTIONS(3105),
    [sym_true] = ACTIONS(3107),
    [sym_false] = ACTIONS(3107),
    [anon_sym_NULL] = ACTIONS(3107),
    [anon_sym_nullptr] = ACTIONS(3107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3107),
    [anon_sym_decltype] = ACTIONS(3107),
    [anon_sym_explicit] = ACTIONS(3107),
    [anon_sym_typename] = ACTIONS(3107),
    [anon_sym_export] = ACTIONS(3107),
    [anon_sym_module] = ACTIONS(3107),
    [anon_sym_import] = ACTIONS(3107),
    [anon_sym_template] = ACTIONS(3107),
    [anon_sym_operator] = ACTIONS(3107),
    [anon_sym_try] = ACTIONS(3107),
    [anon_sym_delete] = ACTIONS(3107),
    [anon_sym_throw] = ACTIONS(3107),
    [anon_sym_namespace] = ACTIONS(3107),
    [anon_sym_static_assert] = ACTIONS(3107),
    [anon_sym_concept] = ACTIONS(3107),
    [anon_sym_co_return] = ACTIONS(3107),
    [anon_sym_co_yield] = ACTIONS(3107),
    [anon_sym_R_DQUOTE] = ACTIONS(3105),
    [anon_sym_LR_DQUOTE] = ACTIONS(3105),
    [anon_sym_uR_DQUOTE] = ACTIONS(3105),
    [anon_sym_UR_DQUOTE] = ACTIONS(3105),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3105),
    [anon_sym_co_await] = ACTIONS(3107),
    [anon_sym_new] = ACTIONS(3107),
    [anon_sym_requires] = ACTIONS(3107),
    [sym_this] = ACTIONS(3107),
    [anon_sym_precise] = ACTIONS(3107),
    [anon_sym_shared] = ACTIONS(3107),
    [anon_sym_groupshared] = ACTIONS(3107),
    [anon_sym_uniform] = ACTIONS(3107),
    [anon_sym_row_major] = ACTIONS(3107),
    [anon_sym_column_major] = ACTIONS(3107),
    [anon_sym_globallycoherent] = ACTIONS(3107),
    [anon_sym_centroid] = ACTIONS(3107),
    [anon_sym_noperspective] = ACTIONS(3107),
    [anon_sym_nointerpolation] = ACTIONS(3107),
    [anon_sym_sample] = ACTIONS(3107),
    [anon_sym_linear] = ACTIONS(3107),
    [anon_sym_snorm] = ACTIONS(3107),
    [anon_sym_unorm] = ACTIONS(3107),
    [anon_sym_point] = ACTIONS(3107),
    [anon_sym_line] = ACTIONS(3107),
    [anon_sym_triangleadj] = ACTIONS(3107),
    [anon_sym_lineadj] = ACTIONS(3107),
    [anon_sym_triangle] = ACTIONS(3107),
  },
  [807] = {
    [ts_builtin_sym_end] = ACTIONS(3109),
    [sym_identifier] = ACTIONS(3111),
    [aux_sym_preproc_include_token1] = ACTIONS(3111),
    [aux_sym_preproc_def_token1] = ACTIONS(3111),
    [aux_sym_preproc_if_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3111),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3111),
    [sym_preproc_directive] = ACTIONS(3111),
    [anon_sym_LPAREN2] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_AMP] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym___extension__] = ACTIONS(3111),
    [anon_sym_typedef] = ACTIONS(3111),
    [anon_sym_in] = ACTIONS(3111),
    [anon_sym_out] = ACTIONS(3111),
    [anon_sym_inout] = ACTIONS(3111),
    [anon_sym_virtual] = ACTIONS(3111),
    [anon_sym_extern] = ACTIONS(3111),
    [anon_sym___attribute__] = ACTIONS(3111),
    [anon_sym___attribute] = ACTIONS(3111),
    [anon_sym_using] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3109),
    [anon_sym___declspec] = ACTIONS(3111),
    [anon_sym___based] = ACTIONS(3111),
    [anon_sym___cdecl] = ACTIONS(3111),
    [anon_sym___clrcall] = ACTIONS(3111),
    [anon_sym___stdcall] = ACTIONS(3111),
    [anon_sym___fastcall] = ACTIONS(3111),
    [anon_sym___thiscall] = ACTIONS(3111),
    [anon_sym___vectorcall] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [anon_sym_signed] = ACTIONS(3111),
    [anon_sym_unsigned] = ACTIONS(3111),
    [anon_sym_long] = ACTIONS(3111),
    [anon_sym_short] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_static] = ACTIONS(3111),
    [anon_sym_register] = ACTIONS(3111),
    [anon_sym_inline] = ACTIONS(3111),
    [anon_sym___inline] = ACTIONS(3111),
    [anon_sym___inline__] = ACTIONS(3111),
    [anon_sym___forceinline] = ACTIONS(3111),
    [anon_sym_thread_local] = ACTIONS(3111),
    [anon_sym___thread] = ACTIONS(3111),
    [anon_sym_const] = ACTIONS(3111),
    [anon_sym_constexpr] = ACTIONS(3111),
    [anon_sym_volatile] = ACTIONS(3111),
    [anon_sym_restrict] = ACTIONS(3111),
    [anon_sym___restrict__] = ACTIONS(3111),
    [anon_sym__Atomic] = ACTIONS(3111),
    [anon_sym__Noreturn] = ACTIONS(3111),
    [anon_sym_noreturn] = ACTIONS(3111),
    [anon_sym__Nonnull] = ACTIONS(3111),
    [anon_sym_mutable] = ACTIONS(3111),
    [anon_sym_constinit] = ACTIONS(3111),
    [anon_sym_consteval] = ACTIONS(3111),
    [anon_sym_alignas] = ACTIONS(3111),
    [anon_sym__Alignas] = ACTIONS(3111),
    [sym_primitive_type] = ACTIONS(3111),
    [anon_sym_enum] = ACTIONS(3111),
    [anon_sym_class] = ACTIONS(3111),
    [anon_sym_struct] = ACTIONS(3111),
    [anon_sym_union] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3111),
    [anon_sym_switch] = ACTIONS(3111),
    [anon_sym_case] = ACTIONS(3111),
    [anon_sym_default] = ACTIONS(3111),
    [anon_sym_while] = ACTIONS(3111),
    [anon_sym_do] = ACTIONS(3111),
    [anon_sym_for] = ACTIONS(3111),
    [anon_sym_return] = ACTIONS(3111),
    [anon_sym_break] = ACTIONS(3111),
    [anon_sym_continue] = ACTIONS(3111),
    [anon_sym_goto] = ACTIONS(3111),
    [anon_sym_not] = ACTIONS(3111),
    [anon_sym_compl] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3109),
    [anon_sym_PLUS_PLUS] = ACTIONS(3109),
    [anon_sym_sizeof] = ACTIONS(3111),
    [anon_sym___alignof__] = ACTIONS(3111),
    [anon_sym___alignof] = ACTIONS(3111),
    [anon_sym__alignof] = ACTIONS(3111),
    [anon_sym_alignof] = ACTIONS(3111),
    [anon_sym__Alignof] = ACTIONS(3111),
    [anon_sym_offsetof] = ACTIONS(3111),
    [anon_sym__Generic] = ACTIONS(3111),
    [anon_sym_asm] = ACTIONS(3111),
    [anon_sym___asm__] = ACTIONS(3111),
    [anon_sym___asm] = ACTIONS(3111),
    [sym_number_literal] = ACTIONS(3109),
    [anon_sym_L_SQUOTE] = ACTIONS(3109),
    [anon_sym_u_SQUOTE] = ACTIONS(3109),
    [anon_sym_U_SQUOTE] = ACTIONS(3109),
    [anon_sym_u8_SQUOTE] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [anon_sym_L_DQUOTE] = ACTIONS(3109),
    [anon_sym_u_DQUOTE] = ACTIONS(3109),
    [anon_sym_U_DQUOTE] = ACTIONS(3109),
    [anon_sym_u8_DQUOTE] = ACTIONS(3109),
    [anon_sym_DQUOTE] = ACTIONS(3109),
    [sym_true] = ACTIONS(3111),
    [sym_false] = ACTIONS(3111),
    [anon_sym_NULL] = ACTIONS(3111),
    [anon_sym_nullptr] = ACTIONS(3111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3111),
    [anon_sym_decltype] = ACTIONS(3111),
    [anon_sym_explicit] = ACTIONS(3111),
    [anon_sym_typename] = ACTIONS(3111),
    [anon_sym_export] = ACTIONS(3111),
    [anon_sym_module] = ACTIONS(3111),
    [anon_sym_import] = ACTIONS(3111),
    [anon_sym_template] = ACTIONS(3111),
    [anon_sym_operator] = ACTIONS(3111),
    [anon_sym_try] = ACTIONS(3111),
    [anon_sym_delete] = ACTIONS(3111),
    [anon_sym_throw] = ACTIONS(3111),
    [anon_sym_namespace] = ACTIONS(3111),
    [anon_sym_static_assert] = ACTIONS(3111),
    [anon_sym_concept] = ACTIONS(3111),
    [anon_sym_co_return] = ACTIONS(3111),
    [anon_sym_co_yield] = ACTIONS(3111),
    [anon_sym_R_DQUOTE] = ACTIONS(3109),
    [anon_sym_LR_DQUOTE] = ACTIONS(3109),
    [anon_sym_uR_DQUOTE] = ACTIONS(3109),
    [anon_sym_UR_DQUOTE] = ACTIONS(3109),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3109),
    [anon_sym_co_await] = ACTIONS(3111),
    [anon_sym_new] = ACTIONS(3111),
    [anon_sym_requires] = ACTIONS(3111),
    [sym_this] = ACTIONS(3111),
    [anon_sym_precise] = ACTIONS(3111),
    [anon_sym_shared] = ACTIONS(3111),
    [anon_sym_groupshared] = ACTIONS(3111),
    [anon_sym_uniform] = ACTIONS(3111),
    [anon_sym_row_major] = ACTIONS(3111),
    [anon_sym_column_major] = ACTIONS(3111),
    [anon_sym_globallycoherent] = ACTIONS(3111),
    [anon_sym_centroid] = ACTIONS(3111),
    [anon_sym_noperspective] = ACTIONS(3111),
    [anon_sym_nointerpolation] = ACTIONS(3111),
    [anon_sym_sample] = ACTIONS(3111),
    [anon_sym_linear] = ACTIONS(3111),
    [anon_sym_snorm] = ACTIONS(3111),
    [anon_sym_unorm] = ACTIONS(3111),
    [anon_sym_point] = ACTIONS(3111),
    [anon_sym_line] = ACTIONS(3111),
    [anon_sym_triangleadj] = ACTIONS(3111),
    [anon_sym_lineadj] = ACTIONS(3111),
    [anon_sym_triangle] = ACTIONS(3111),
  },
  [808] = {
    [ts_builtin_sym_end] = ACTIONS(2538),
    [sym_identifier] = ACTIONS(2536),
    [aux_sym_preproc_include_token1] = ACTIONS(2536),
    [aux_sym_preproc_def_token1] = ACTIONS(2536),
    [aux_sym_preproc_if_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2536),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2536),
    [sym_preproc_directive] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_typedef] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2536),
    [anon_sym_out] = ACTIONS(2536),
    [anon_sym_inout] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_using] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2538),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2536),
    [anon_sym_switch] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2536),
    [anon_sym_default] = ACTIONS(2536),
    [anon_sym_while] = ACTIONS(2536),
    [anon_sym_do] = ACTIONS(2536),
    [anon_sym_for] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2536),
    [anon_sym_break] = ACTIONS(2536),
    [anon_sym_continue] = ACTIONS(2536),
    [anon_sym_goto] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2538),
    [anon_sym_L_SQUOTE] = ACTIONS(2538),
    [anon_sym_u_SQUOTE] = ACTIONS(2538),
    [anon_sym_U_SQUOTE] = ACTIONS(2538),
    [anon_sym_u8_SQUOTE] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_L_DQUOTE] = ACTIONS(2538),
    [anon_sym_u_DQUOTE] = ACTIONS(2538),
    [anon_sym_U_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8_DQUOTE] = ACTIONS(2538),
    [anon_sym_DQUOTE] = ACTIONS(2538),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_export] = ACTIONS(2536),
    [anon_sym_module] = ACTIONS(2536),
    [anon_sym_import] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_namespace] = ACTIONS(2536),
    [anon_sym_static_assert] = ACTIONS(2536),
    [anon_sym_concept] = ACTIONS(2536),
    [anon_sym_co_return] = ACTIONS(2536),
    [anon_sym_co_yield] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2538),
    [anon_sym_LR_DQUOTE] = ACTIONS(2538),
    [anon_sym_uR_DQUOTE] = ACTIONS(2538),
    [anon_sym_UR_DQUOTE] = ACTIONS(2538),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2538),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
    [anon_sym_precise] = ACTIONS(2536),
    [anon_sym_shared] = ACTIONS(2536),
    [anon_sym_groupshared] = ACTIONS(2536),
    [anon_sym_uniform] = ACTIONS(2536),
    [anon_sym_row_major] = ACTIONS(2536),
    [anon_sym_column_major] = ACTIONS(2536),
    [anon_sym_globallycoherent] = ACTIONS(2536),
    [anon_sym_centroid] = ACTIONS(2536),
    [anon_sym_noperspective] = ACTIONS(2536),
    [anon_sym_nointerpolation] = ACTIONS(2536),
    [anon_sym_sample] = ACTIONS(2536),
    [anon_sym_linear] = ACTIONS(2536),
    [anon_sym_snorm] = ACTIONS(2536),
    [anon_sym_unorm] = ACTIONS(2536),
    [anon_sym_point] = ACTIONS(2536),
    [anon_sym_line] = ACTIONS(2536),
    [anon_sym_triangleadj] = ACTIONS(2536),
    [anon_sym_lineadj] = ACTIONS(2536),
    [anon_sym_triangle] = ACTIONS(2536),
  },
  [809] = {
    [ts_builtin_sym_end] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2480),
    [aux_sym_preproc_include_token1] = ACTIONS(2480),
    [aux_sym_preproc_def_token1] = ACTIONS(2480),
    [aux_sym_preproc_if_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2480),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2480),
    [sym_preproc_directive] = ACTIONS(2480),
    [anon_sym_LPAREN2] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym___extension__] = ACTIONS(2480),
    [anon_sym_typedef] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_out] = ACTIONS(2480),
    [anon_sym_inout] = ACTIONS(2480),
    [anon_sym_virtual] = ACTIONS(2480),
    [anon_sym_extern] = ACTIONS(2480),
    [anon_sym___attribute__] = ACTIONS(2480),
    [anon_sym___attribute] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2482),
    [anon_sym___declspec] = ACTIONS(2480),
    [anon_sym___based] = ACTIONS(2480),
    [anon_sym___cdecl] = ACTIONS(2480),
    [anon_sym___clrcall] = ACTIONS(2480),
    [anon_sym___stdcall] = ACTIONS(2480),
    [anon_sym___fastcall] = ACTIONS(2480),
    [anon_sym___thiscall] = ACTIONS(2480),
    [anon_sym___vectorcall] = ACTIONS(2480),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_signed] = ACTIONS(2480),
    [anon_sym_unsigned] = ACTIONS(2480),
    [anon_sym_long] = ACTIONS(2480),
    [anon_sym_short] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2480),
    [anon_sym_register] = ACTIONS(2480),
    [anon_sym_inline] = ACTIONS(2480),
    [anon_sym___inline] = ACTIONS(2480),
    [anon_sym___inline__] = ACTIONS(2480),
    [anon_sym___forceinline] = ACTIONS(2480),
    [anon_sym_thread_local] = ACTIONS(2480),
    [anon_sym___thread] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_constexpr] = ACTIONS(2480),
    [anon_sym_volatile] = ACTIONS(2480),
    [anon_sym_restrict] = ACTIONS(2480),
    [anon_sym___restrict__] = ACTIONS(2480),
    [anon_sym__Atomic] = ACTIONS(2480),
    [anon_sym__Noreturn] = ACTIONS(2480),
    [anon_sym_noreturn] = ACTIONS(2480),
    [anon_sym__Nonnull] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_constinit] = ACTIONS(2480),
    [anon_sym_consteval] = ACTIONS(2480),
    [anon_sym_alignas] = ACTIONS(2480),
    [anon_sym__Alignas] = ACTIONS(2480),
    [sym_primitive_type] = ACTIONS(2480),
    [anon_sym_enum] = ACTIONS(2480),
    [anon_sym_class] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_union] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_switch] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2480),
    [anon_sym_default] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_break] = ACTIONS(2480),
    [anon_sym_continue] = ACTIONS(2480),
    [anon_sym_goto] = ACTIONS(2480),
    [anon_sym_not] = ACTIONS(2480),
    [anon_sym_compl] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2480),
    [anon_sym___alignof__] = ACTIONS(2480),
    [anon_sym___alignof] = ACTIONS(2480),
    [anon_sym__alignof] = ACTIONS(2480),
    [anon_sym_alignof] = ACTIONS(2480),
    [anon_sym__Alignof] = ACTIONS(2480),
    [anon_sym_offsetof] = ACTIONS(2480),
    [anon_sym__Generic] = ACTIONS(2480),
    [anon_sym_asm] = ACTIONS(2480),
    [anon_sym___asm__] = ACTIONS(2480),
    [anon_sym___asm] = ACTIONS(2480),
    [sym_number_literal] = ACTIONS(2482),
    [anon_sym_L_SQUOTE] = ACTIONS(2482),
    [anon_sym_u_SQUOTE] = ACTIONS(2482),
    [anon_sym_U_SQUOTE] = ACTIONS(2482),
    [anon_sym_u8_SQUOTE] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_L_DQUOTE] = ACTIONS(2482),
    [anon_sym_u_DQUOTE] = ACTIONS(2482),
    [anon_sym_U_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8_DQUOTE] = ACTIONS(2482),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [sym_true] = ACTIONS(2480),
    [sym_false] = ACTIONS(2480),
    [anon_sym_NULL] = ACTIONS(2480),
    [anon_sym_nullptr] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2480),
    [anon_sym_decltype] = ACTIONS(2480),
    [anon_sym_explicit] = ACTIONS(2480),
    [anon_sym_typename] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_template] = ACTIONS(2480),
    [anon_sym_operator] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_throw] = ACTIONS(2480),
    [anon_sym_namespace] = ACTIONS(2480),
    [anon_sym_static_assert] = ACTIONS(2480),
    [anon_sym_concept] = ACTIONS(2480),
    [anon_sym_co_return] = ACTIONS(2480),
    [anon_sym_co_yield] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2480),
    [anon_sym_new] = ACTIONS(2480),
    [anon_sym_requires] = ACTIONS(2480),
    [sym_this] = ACTIONS(2480),
    [anon_sym_precise] = ACTIONS(2480),
    [anon_sym_shared] = ACTIONS(2480),
    [anon_sym_groupshared] = ACTIONS(2480),
    [anon_sym_uniform] = ACTIONS(2480),
    [anon_sym_row_major] = ACTIONS(2480),
    [anon_sym_column_major] = ACTIONS(2480),
    [anon_sym_globallycoherent] = ACTIONS(2480),
    [anon_sym_centroid] = ACTIONS(2480),
    [anon_sym_noperspective] = ACTIONS(2480),
    [anon_sym_nointerpolation] = ACTIONS(2480),
    [anon_sym_sample] = ACTIONS(2480),
    [anon_sym_linear] = ACTIONS(2480),
    [anon_sym_snorm] = ACTIONS(2480),
    [anon_sym_unorm] = ACTIONS(2480),
    [anon_sym_point] = ACTIONS(2480),
    [anon_sym_line] = ACTIONS(2480),
    [anon_sym_triangleadj] = ACTIONS(2480),
    [anon_sym_lineadj] = ACTIONS(2480),
    [anon_sym_triangle] = ACTIONS(2480),
  },
  [810] = {
    [ts_builtin_sym_end] = ACTIONS(2486),
    [sym_identifier] = ACTIONS(2484),
    [aux_sym_preproc_include_token1] = ACTIONS(2484),
    [aux_sym_preproc_def_token1] = ACTIONS(2484),
    [aux_sym_preproc_if_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2484),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2484),
    [sym_preproc_directive] = ACTIONS(2484),
    [anon_sym_LPAREN2] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2484),
    [anon_sym_PLUS] = ACTIONS(2484),
    [anon_sym_STAR] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym___extension__] = ACTIONS(2484),
    [anon_sym_typedef] = ACTIONS(2484),
    [anon_sym_in] = ACTIONS(2484),
    [anon_sym_out] = ACTIONS(2484),
    [anon_sym_inout] = ACTIONS(2484),
    [anon_sym_virtual] = ACTIONS(2484),
    [anon_sym_extern] = ACTIONS(2484),
    [anon_sym___attribute__] = ACTIONS(2484),
    [anon_sym___attribute] = ACTIONS(2484),
    [anon_sym_using] = ACTIONS(2484),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2486),
    [anon_sym___declspec] = ACTIONS(2484),
    [anon_sym___based] = ACTIONS(2484),
    [anon_sym___cdecl] = ACTIONS(2484),
    [anon_sym___clrcall] = ACTIONS(2484),
    [anon_sym___stdcall] = ACTIONS(2484),
    [anon_sym___fastcall] = ACTIONS(2484),
    [anon_sym___thiscall] = ACTIONS(2484),
    [anon_sym___vectorcall] = ACTIONS(2484),
    [anon_sym_LBRACE] = ACTIONS(2486),
    [anon_sym_signed] = ACTIONS(2484),
    [anon_sym_unsigned] = ACTIONS(2484),
    [anon_sym_long] = ACTIONS(2484),
    [anon_sym_short] = ACTIONS(2484),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2484),
    [anon_sym_register] = ACTIONS(2484),
    [anon_sym_inline] = ACTIONS(2484),
    [anon_sym___inline] = ACTIONS(2484),
    [anon_sym___inline__] = ACTIONS(2484),
    [anon_sym___forceinline] = ACTIONS(2484),
    [anon_sym_thread_local] = ACTIONS(2484),
    [anon_sym___thread] = ACTIONS(2484),
    [anon_sym_const] = ACTIONS(2484),
    [anon_sym_constexpr] = ACTIONS(2484),
    [anon_sym_volatile] = ACTIONS(2484),
    [anon_sym_restrict] = ACTIONS(2484),
    [anon_sym___restrict__] = ACTIONS(2484),
    [anon_sym__Atomic] = ACTIONS(2484),
    [anon_sym__Noreturn] = ACTIONS(2484),
    [anon_sym_noreturn] = ACTIONS(2484),
    [anon_sym__Nonnull] = ACTIONS(2484),
    [anon_sym_mutable] = ACTIONS(2484),
    [anon_sym_constinit] = ACTIONS(2484),
    [anon_sym_consteval] = ACTIONS(2484),
    [anon_sym_alignas] = ACTIONS(2484),
    [anon_sym__Alignas] = ACTIONS(2484),
    [sym_primitive_type] = ACTIONS(2484),
    [anon_sym_enum] = ACTIONS(2484),
    [anon_sym_class] = ACTIONS(2484),
    [anon_sym_struct] = ACTIONS(2484),
    [anon_sym_union] = ACTIONS(2484),
    [anon_sym_if] = ACTIONS(2484),
    [anon_sym_switch] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2484),
    [anon_sym_default] = ACTIONS(2484),
    [anon_sym_while] = ACTIONS(2484),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_for] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2484),
    [anon_sym_break] = ACTIONS(2484),
    [anon_sym_continue] = ACTIONS(2484),
    [anon_sym_goto] = ACTIONS(2484),
    [anon_sym_not] = ACTIONS(2484),
    [anon_sym_compl] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2484),
    [anon_sym___alignof__] = ACTIONS(2484),
    [anon_sym___alignof] = ACTIONS(2484),
    [anon_sym__alignof] = ACTIONS(2484),
    [anon_sym_alignof] = ACTIONS(2484),
    [anon_sym__Alignof] = ACTIONS(2484),
    [anon_sym_offsetof] = ACTIONS(2484),
    [anon_sym__Generic] = ACTIONS(2484),
    [anon_sym_asm] = ACTIONS(2484),
    [anon_sym___asm__] = ACTIONS(2484),
    [anon_sym___asm] = ACTIONS(2484),
    [sym_number_literal] = ACTIONS(2486),
    [anon_sym_L_SQUOTE] = ACTIONS(2486),
    [anon_sym_u_SQUOTE] = ACTIONS(2486),
    [anon_sym_U_SQUOTE] = ACTIONS(2486),
    [anon_sym_u8_SQUOTE] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_L_DQUOTE] = ACTIONS(2486),
    [anon_sym_u_DQUOTE] = ACTIONS(2486),
    [anon_sym_U_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8_DQUOTE] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2486),
    [sym_true] = ACTIONS(2484),
    [sym_false] = ACTIONS(2484),
    [anon_sym_NULL] = ACTIONS(2484),
    [anon_sym_nullptr] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2484),
    [anon_sym_decltype] = ACTIONS(2484),
    [anon_sym_explicit] = ACTIONS(2484),
    [anon_sym_typename] = ACTIONS(2484),
    [anon_sym_export] = ACTIONS(2484),
    [anon_sym_module] = ACTIONS(2484),
    [anon_sym_import] = ACTIONS(2484),
    [anon_sym_template] = ACTIONS(2484),
    [anon_sym_operator] = ACTIONS(2484),
    [anon_sym_try] = ACTIONS(2484),
    [anon_sym_delete] = ACTIONS(2484),
    [anon_sym_throw] = ACTIONS(2484),
    [anon_sym_namespace] = ACTIONS(2484),
    [anon_sym_static_assert] = ACTIONS(2484),
    [anon_sym_concept] = ACTIONS(2484),
    [anon_sym_co_return] = ACTIONS(2484),
    [anon_sym_co_yield] = ACTIONS(2484),
    [anon_sym_R_DQUOTE] = ACTIONS(2486),
    [anon_sym_LR_DQUOTE] = ACTIONS(2486),
    [anon_sym_uR_DQUOTE] = ACTIONS(2486),
    [anon_sym_UR_DQUOTE] = ACTIONS(2486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2486),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2484),
    [anon_sym_requires] = ACTIONS(2484),
    [sym_this] = ACTIONS(2484),
    [anon_sym_precise] = ACTIONS(2484),
    [anon_sym_shared] = ACTIONS(2484),
    [anon_sym_groupshared] = ACTIONS(2484),
    [anon_sym_uniform] = ACTIONS(2484),
    [anon_sym_row_major] = ACTIONS(2484),
    [anon_sym_column_major] = ACTIONS(2484),
    [anon_sym_globallycoherent] = ACTIONS(2484),
    [anon_sym_centroid] = ACTIONS(2484),
    [anon_sym_noperspective] = ACTIONS(2484),
    [anon_sym_nointerpolation] = ACTIONS(2484),
    [anon_sym_sample] = ACTIONS(2484),
    [anon_sym_linear] = ACTIONS(2484),
    [anon_sym_snorm] = ACTIONS(2484),
    [anon_sym_unorm] = ACTIONS(2484),
    [anon_sym_point] = ACTIONS(2484),
    [anon_sym_line] = ACTIONS(2484),
    [anon_sym_triangleadj] = ACTIONS(2484),
    [anon_sym_lineadj] = ACTIONS(2484),
    [anon_sym_triangle] = ACTIONS(2484),
  },
  [811] = {
    [ts_builtin_sym_end] = ACTIONS(2490),
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_include_token1] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2488),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym___cdecl] = ACTIONS(2488),
    [anon_sym___clrcall] = ACTIONS(2488),
    [anon_sym___stdcall] = ACTIONS(2488),
    [anon_sym___fastcall] = ACTIONS(2488),
    [anon_sym___thiscall] = ACTIONS(2488),
    [anon_sym___vectorcall] = ACTIONS(2488),
    [anon_sym_LBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2488),
    [anon_sym_switch] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2488),
    [anon_sym_default] = ACTIONS(2488),
    [anon_sym_while] = ACTIONS(2488),
    [anon_sym_do] = ACTIONS(2488),
    [anon_sym_for] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2488),
    [anon_sym_break] = ACTIONS(2488),
    [anon_sym_continue] = ACTIONS(2488),
    [anon_sym_goto] = ACTIONS(2488),
    [anon_sym_not] = ACTIONS(2488),
    [anon_sym_compl] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2488),
    [anon_sym___alignof__] = ACTIONS(2488),
    [anon_sym___alignof] = ACTIONS(2488),
    [anon_sym__alignof] = ACTIONS(2488),
    [anon_sym_alignof] = ACTIONS(2488),
    [anon_sym__Alignof] = ACTIONS(2488),
    [anon_sym_offsetof] = ACTIONS(2488),
    [anon_sym__Generic] = ACTIONS(2488),
    [anon_sym_asm] = ACTIONS(2488),
    [anon_sym___asm__] = ACTIONS(2488),
    [anon_sym___asm] = ACTIONS(2488),
    [sym_number_literal] = ACTIONS(2490),
    [anon_sym_L_SQUOTE] = ACTIONS(2490),
    [anon_sym_u_SQUOTE] = ACTIONS(2490),
    [anon_sym_U_SQUOTE] = ACTIONS(2490),
    [anon_sym_u8_SQUOTE] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_L_DQUOTE] = ACTIONS(2490),
    [anon_sym_u_DQUOTE] = ACTIONS(2490),
    [anon_sym_U_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8_DQUOTE] = ACTIONS(2490),
    [anon_sym_DQUOTE] = ACTIONS(2490),
    [sym_true] = ACTIONS(2488),
    [sym_false] = ACTIONS(2488),
    [anon_sym_NULL] = ACTIONS(2488),
    [anon_sym_nullptr] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_export] = ACTIONS(2488),
    [anon_sym_module] = ACTIONS(2488),
    [anon_sym_import] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_try] = ACTIONS(2488),
    [anon_sym_delete] = ACTIONS(2488),
    [anon_sym_throw] = ACTIONS(2488),
    [anon_sym_namespace] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_concept] = ACTIONS(2488),
    [anon_sym_co_return] = ACTIONS(2488),
    [anon_sym_co_yield] = ACTIONS(2488),
    [anon_sym_R_DQUOTE] = ACTIONS(2490),
    [anon_sym_LR_DQUOTE] = ACTIONS(2490),
    [anon_sym_uR_DQUOTE] = ACTIONS(2490),
    [anon_sym_UR_DQUOTE] = ACTIONS(2490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2490),
    [anon_sym_co_await] = ACTIONS(2488),
    [anon_sym_new] = ACTIONS(2488),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
  },
  [812] = {
    [ts_builtin_sym_end] = ACTIONS(2494),
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_include_token1] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym___cdecl] = ACTIONS(2492),
    [anon_sym___clrcall] = ACTIONS(2492),
    [anon_sym___stdcall] = ACTIONS(2492),
    [anon_sym___fastcall] = ACTIONS(2492),
    [anon_sym___thiscall] = ACTIONS(2492),
    [anon_sym___vectorcall] = ACTIONS(2492),
    [anon_sym_LBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2492),
    [anon_sym_switch] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2492),
    [anon_sym_default] = ACTIONS(2492),
    [anon_sym_while] = ACTIONS(2492),
    [anon_sym_do] = ACTIONS(2492),
    [anon_sym_for] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2492),
    [anon_sym_break] = ACTIONS(2492),
    [anon_sym_continue] = ACTIONS(2492),
    [anon_sym_goto] = ACTIONS(2492),
    [anon_sym_not] = ACTIONS(2492),
    [anon_sym_compl] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2492),
    [anon_sym___alignof__] = ACTIONS(2492),
    [anon_sym___alignof] = ACTIONS(2492),
    [anon_sym__alignof] = ACTIONS(2492),
    [anon_sym_alignof] = ACTIONS(2492),
    [anon_sym__Alignof] = ACTIONS(2492),
    [anon_sym_offsetof] = ACTIONS(2492),
    [anon_sym__Generic] = ACTIONS(2492),
    [anon_sym_asm] = ACTIONS(2492),
    [anon_sym___asm__] = ACTIONS(2492),
    [anon_sym___asm] = ACTIONS(2492),
    [sym_number_literal] = ACTIONS(2494),
    [anon_sym_L_SQUOTE] = ACTIONS(2494),
    [anon_sym_u_SQUOTE] = ACTIONS(2494),
    [anon_sym_U_SQUOTE] = ACTIONS(2494),
    [anon_sym_u8_SQUOTE] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_L_DQUOTE] = ACTIONS(2494),
    [anon_sym_u_DQUOTE] = ACTIONS(2494),
    [anon_sym_U_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8_DQUOTE] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [sym_true] = ACTIONS(2492),
    [sym_false] = ACTIONS(2492),
    [anon_sym_NULL] = ACTIONS(2492),
    [anon_sym_nullptr] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_export] = ACTIONS(2492),
    [anon_sym_module] = ACTIONS(2492),
    [anon_sym_import] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_try] = ACTIONS(2492),
    [anon_sym_delete] = ACTIONS(2492),
    [anon_sym_throw] = ACTIONS(2492),
    [anon_sym_namespace] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_concept] = ACTIONS(2492),
    [anon_sym_co_return] = ACTIONS(2492),
    [anon_sym_co_yield] = ACTIONS(2492),
    [anon_sym_R_DQUOTE] = ACTIONS(2494),
    [anon_sym_LR_DQUOTE] = ACTIONS(2494),
    [anon_sym_uR_DQUOTE] = ACTIONS(2494),
    [anon_sym_UR_DQUOTE] = ACTIONS(2494),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2494),
    [anon_sym_co_await] = ACTIONS(2492),
    [anon_sym_new] = ACTIONS(2492),
    [anon_sym_requires] = ACTIONS(2492),
    [sym_this] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
  },
  [813] = {
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [814] = {
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [815] = {
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [816] = {
    [ts_builtin_sym_end] = ACTIONS(2582),
    [sym_identifier] = ACTIONS(2580),
    [aux_sym_preproc_include_token1] = ACTIONS(2580),
    [aux_sym_preproc_def_token1] = ACTIONS(2580),
    [aux_sym_preproc_if_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2580),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2580),
    [sym_preproc_directive] = ACTIONS(2580),
    [anon_sym_LPAREN2] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2580),
    [anon_sym_STAR] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_AMP] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym___extension__] = ACTIONS(2580),
    [anon_sym_typedef] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2580),
    [anon_sym_out] = ACTIONS(2580),
    [anon_sym_inout] = ACTIONS(2580),
    [anon_sym_virtual] = ACTIONS(2580),
    [anon_sym_extern] = ACTIONS(2580),
    [anon_sym___attribute__] = ACTIONS(2580),
    [anon_sym___attribute] = ACTIONS(2580),
    [anon_sym_using] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2582),
    [anon_sym___declspec] = ACTIONS(2580),
    [anon_sym___based] = ACTIONS(2580),
    [anon_sym___cdecl] = ACTIONS(2580),
    [anon_sym___clrcall] = ACTIONS(2580),
    [anon_sym___stdcall] = ACTIONS(2580),
    [anon_sym___fastcall] = ACTIONS(2580),
    [anon_sym___thiscall] = ACTIONS(2580),
    [anon_sym___vectorcall] = ACTIONS(2580),
    [anon_sym_LBRACE] = ACTIONS(2582),
    [anon_sym_signed] = ACTIONS(2580),
    [anon_sym_unsigned] = ACTIONS(2580),
    [anon_sym_long] = ACTIONS(2580),
    [anon_sym_short] = ACTIONS(2580),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2580),
    [anon_sym_register] = ACTIONS(2580),
    [anon_sym_inline] = ACTIONS(2580),
    [anon_sym___inline] = ACTIONS(2580),
    [anon_sym___inline__] = ACTIONS(2580),
    [anon_sym___forceinline] = ACTIONS(2580),
    [anon_sym_thread_local] = ACTIONS(2580),
    [anon_sym___thread] = ACTIONS(2580),
    [anon_sym_const] = ACTIONS(2580),
    [anon_sym_constexpr] = ACTIONS(2580),
    [anon_sym_volatile] = ACTIONS(2580),
    [anon_sym_restrict] = ACTIONS(2580),
    [anon_sym___restrict__] = ACTIONS(2580),
    [anon_sym__Atomic] = ACTIONS(2580),
    [anon_sym__Noreturn] = ACTIONS(2580),
    [anon_sym_noreturn] = ACTIONS(2580),
    [anon_sym__Nonnull] = ACTIONS(2580),
    [anon_sym_mutable] = ACTIONS(2580),
    [anon_sym_constinit] = ACTIONS(2580),
    [anon_sym_consteval] = ACTIONS(2580),
    [anon_sym_alignas] = ACTIONS(2580),
    [anon_sym__Alignas] = ACTIONS(2580),
    [sym_primitive_type] = ACTIONS(2580),
    [anon_sym_enum] = ACTIONS(2580),
    [anon_sym_class] = ACTIONS(2580),
    [anon_sym_struct] = ACTIONS(2580),
    [anon_sym_union] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2580),
    [anon_sym_switch] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2580),
    [anon_sym_default] = ACTIONS(2580),
    [anon_sym_while] = ACTIONS(2580),
    [anon_sym_do] = ACTIONS(2580),
    [anon_sym_for] = ACTIONS(2580),
    [anon_sym_return] = ACTIONS(2580),
    [anon_sym_break] = ACTIONS(2580),
    [anon_sym_continue] = ACTIONS(2580),
    [anon_sym_goto] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2580),
    [anon_sym_compl] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2582),
    [anon_sym_sizeof] = ACTIONS(2580),
    [anon_sym___alignof__] = ACTIONS(2580),
    [anon_sym___alignof] = ACTIONS(2580),
    [anon_sym__alignof] = ACTIONS(2580),
    [anon_sym_alignof] = ACTIONS(2580),
    [anon_sym__Alignof] = ACTIONS(2580),
    [anon_sym_offsetof] = ACTIONS(2580),
    [anon_sym__Generic] = ACTIONS(2580),
    [anon_sym_asm] = ACTIONS(2580),
    [anon_sym___asm__] = ACTIONS(2580),
    [anon_sym___asm] = ACTIONS(2580),
    [sym_number_literal] = ACTIONS(2582),
    [anon_sym_L_SQUOTE] = ACTIONS(2582),
    [anon_sym_u_SQUOTE] = ACTIONS(2582),
    [anon_sym_U_SQUOTE] = ACTIONS(2582),
    [anon_sym_u8_SQUOTE] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_L_DQUOTE] = ACTIONS(2582),
    [anon_sym_u_DQUOTE] = ACTIONS(2582),
    [anon_sym_U_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8_DQUOTE] = ACTIONS(2582),
    [anon_sym_DQUOTE] = ACTIONS(2582),
    [sym_true] = ACTIONS(2580),
    [sym_false] = ACTIONS(2580),
    [anon_sym_NULL] = ACTIONS(2580),
    [anon_sym_nullptr] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2580),
    [anon_sym_decltype] = ACTIONS(2580),
    [anon_sym_explicit] = ACTIONS(2580),
    [anon_sym_typename] = ACTIONS(2580),
    [anon_sym_export] = ACTIONS(2580),
    [anon_sym_module] = ACTIONS(2580),
    [anon_sym_import] = ACTIONS(2580),
    [anon_sym_template] = ACTIONS(2580),
    [anon_sym_operator] = ACTIONS(2580),
    [anon_sym_try] = ACTIONS(2580),
    [anon_sym_delete] = ACTIONS(2580),
    [anon_sym_throw] = ACTIONS(2580),
    [anon_sym_namespace] = ACTIONS(2580),
    [anon_sym_static_assert] = ACTIONS(2580),
    [anon_sym_concept] = ACTIONS(2580),
    [anon_sym_co_return] = ACTIONS(2580),
    [anon_sym_co_yield] = ACTIONS(2580),
    [anon_sym_R_DQUOTE] = ACTIONS(2582),
    [anon_sym_LR_DQUOTE] = ACTIONS(2582),
    [anon_sym_uR_DQUOTE] = ACTIONS(2582),
    [anon_sym_UR_DQUOTE] = ACTIONS(2582),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2582),
    [anon_sym_co_await] = ACTIONS(2580),
    [anon_sym_new] = ACTIONS(2580),
    [anon_sym_requires] = ACTIONS(2580),
    [sym_this] = ACTIONS(2580),
    [anon_sym_precise] = ACTIONS(2580),
    [anon_sym_shared] = ACTIONS(2580),
    [anon_sym_groupshared] = ACTIONS(2580),
    [anon_sym_uniform] = ACTIONS(2580),
    [anon_sym_row_major] = ACTIONS(2580),
    [anon_sym_column_major] = ACTIONS(2580),
    [anon_sym_globallycoherent] = ACTIONS(2580),
    [anon_sym_centroid] = ACTIONS(2580),
    [anon_sym_noperspective] = ACTIONS(2580),
    [anon_sym_nointerpolation] = ACTIONS(2580),
    [anon_sym_sample] = ACTIONS(2580),
    [anon_sym_linear] = ACTIONS(2580),
    [anon_sym_snorm] = ACTIONS(2580),
    [anon_sym_unorm] = ACTIONS(2580),
    [anon_sym_point] = ACTIONS(2580),
    [anon_sym_line] = ACTIONS(2580),
    [anon_sym_triangleadj] = ACTIONS(2580),
    [anon_sym_lineadj] = ACTIONS(2580),
    [anon_sym_triangle] = ACTIONS(2580),
  },
  [817] = {
    [ts_builtin_sym_end] = ACTIONS(3113),
    [sym_identifier] = ACTIONS(3115),
    [aux_sym_preproc_include_token1] = ACTIONS(3115),
    [aux_sym_preproc_def_token1] = ACTIONS(3115),
    [aux_sym_preproc_if_token1] = ACTIONS(3115),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3115),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3115),
    [sym_preproc_directive] = ACTIONS(3115),
    [anon_sym_LPAREN2] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_AMP] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym___extension__] = ACTIONS(3115),
    [anon_sym_typedef] = ACTIONS(3115),
    [anon_sym_in] = ACTIONS(3115),
    [anon_sym_out] = ACTIONS(3115),
    [anon_sym_inout] = ACTIONS(3115),
    [anon_sym_virtual] = ACTIONS(3115),
    [anon_sym_extern] = ACTIONS(3115),
    [anon_sym___attribute__] = ACTIONS(3115),
    [anon_sym___attribute] = ACTIONS(3115),
    [anon_sym_using] = ACTIONS(3115),
    [anon_sym_COLON_COLON] = ACTIONS(3113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3113),
    [anon_sym___declspec] = ACTIONS(3115),
    [anon_sym___based] = ACTIONS(3115),
    [anon_sym___cdecl] = ACTIONS(3115),
    [anon_sym___clrcall] = ACTIONS(3115),
    [anon_sym___stdcall] = ACTIONS(3115),
    [anon_sym___fastcall] = ACTIONS(3115),
    [anon_sym___thiscall] = ACTIONS(3115),
    [anon_sym___vectorcall] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3113),
    [anon_sym_signed] = ACTIONS(3115),
    [anon_sym_unsigned] = ACTIONS(3115),
    [anon_sym_long] = ACTIONS(3115),
    [anon_sym_short] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_static] = ACTIONS(3115),
    [anon_sym_register] = ACTIONS(3115),
    [anon_sym_inline] = ACTIONS(3115),
    [anon_sym___inline] = ACTIONS(3115),
    [anon_sym___inline__] = ACTIONS(3115),
    [anon_sym___forceinline] = ACTIONS(3115),
    [anon_sym_thread_local] = ACTIONS(3115),
    [anon_sym___thread] = ACTIONS(3115),
    [anon_sym_const] = ACTIONS(3115),
    [anon_sym_constexpr] = ACTIONS(3115),
    [anon_sym_volatile] = ACTIONS(3115),
    [anon_sym_restrict] = ACTIONS(3115),
    [anon_sym___restrict__] = ACTIONS(3115),
    [anon_sym__Atomic] = ACTIONS(3115),
    [anon_sym__Noreturn] = ACTIONS(3115),
    [anon_sym_noreturn] = ACTIONS(3115),
    [anon_sym__Nonnull] = ACTIONS(3115),
    [anon_sym_mutable] = ACTIONS(3115),
    [anon_sym_constinit] = ACTIONS(3115),
    [anon_sym_consteval] = ACTIONS(3115),
    [anon_sym_alignas] = ACTIONS(3115),
    [anon_sym__Alignas] = ACTIONS(3115),
    [sym_primitive_type] = ACTIONS(3115),
    [anon_sym_enum] = ACTIONS(3115),
    [anon_sym_class] = ACTIONS(3115),
    [anon_sym_struct] = ACTIONS(3115),
    [anon_sym_union] = ACTIONS(3115),
    [anon_sym_if] = ACTIONS(3115),
    [anon_sym_switch] = ACTIONS(3115),
    [anon_sym_case] = ACTIONS(3115),
    [anon_sym_default] = ACTIONS(3115),
    [anon_sym_while] = ACTIONS(3115),
    [anon_sym_do] = ACTIONS(3115),
    [anon_sym_for] = ACTIONS(3115),
    [anon_sym_return] = ACTIONS(3115),
    [anon_sym_break] = ACTIONS(3115),
    [anon_sym_continue] = ACTIONS(3115),
    [anon_sym_goto] = ACTIONS(3115),
    [anon_sym_not] = ACTIONS(3115),
    [anon_sym_compl] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3113),
    [anon_sym_PLUS_PLUS] = ACTIONS(3113),
    [anon_sym_sizeof] = ACTIONS(3115),
    [anon_sym___alignof__] = ACTIONS(3115),
    [anon_sym___alignof] = ACTIONS(3115),
    [anon_sym__alignof] = ACTIONS(3115),
    [anon_sym_alignof] = ACTIONS(3115),
    [anon_sym__Alignof] = ACTIONS(3115),
    [anon_sym_offsetof] = ACTIONS(3115),
    [anon_sym__Generic] = ACTIONS(3115),
    [anon_sym_asm] = ACTIONS(3115),
    [anon_sym___asm__] = ACTIONS(3115),
    [anon_sym___asm] = ACTIONS(3115),
    [sym_number_literal] = ACTIONS(3113),
    [anon_sym_L_SQUOTE] = ACTIONS(3113),
    [anon_sym_u_SQUOTE] = ACTIONS(3113),
    [anon_sym_U_SQUOTE] = ACTIONS(3113),
    [anon_sym_u8_SQUOTE] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym_L_DQUOTE] = ACTIONS(3113),
    [anon_sym_u_DQUOTE] = ACTIONS(3113),
    [anon_sym_U_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8_DQUOTE] = ACTIONS(3113),
    [anon_sym_DQUOTE] = ACTIONS(3113),
    [sym_true] = ACTIONS(3115),
    [sym_false] = ACTIONS(3115),
    [anon_sym_NULL] = ACTIONS(3115),
    [anon_sym_nullptr] = ACTIONS(3115),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3115),
    [anon_sym_decltype] = ACTIONS(3115),
    [anon_sym_explicit] = ACTIONS(3115),
    [anon_sym_typename] = ACTIONS(3115),
    [anon_sym_export] = ACTIONS(3115),
    [anon_sym_module] = ACTIONS(3115),
    [anon_sym_import] = ACTIONS(3115),
    [anon_sym_template] = ACTIONS(3115),
    [anon_sym_operator] = ACTIONS(3115),
    [anon_sym_try] = ACTIONS(3115),
    [anon_sym_delete] = ACTIONS(3115),
    [anon_sym_throw] = ACTIONS(3115),
    [anon_sym_namespace] = ACTIONS(3115),
    [anon_sym_static_assert] = ACTIONS(3115),
    [anon_sym_concept] = ACTIONS(3115),
    [anon_sym_co_return] = ACTIONS(3115),
    [anon_sym_co_yield] = ACTIONS(3115),
    [anon_sym_R_DQUOTE] = ACTIONS(3113),
    [anon_sym_LR_DQUOTE] = ACTIONS(3113),
    [anon_sym_uR_DQUOTE] = ACTIONS(3113),
    [anon_sym_UR_DQUOTE] = ACTIONS(3113),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3113),
    [anon_sym_co_await] = ACTIONS(3115),
    [anon_sym_new] = ACTIONS(3115),
    [anon_sym_requires] = ACTIONS(3115),
    [sym_this] = ACTIONS(3115),
    [anon_sym_precise] = ACTIONS(3115),
    [anon_sym_shared] = ACTIONS(3115),
    [anon_sym_groupshared] = ACTIONS(3115),
    [anon_sym_uniform] = ACTIONS(3115),
    [anon_sym_row_major] = ACTIONS(3115),
    [anon_sym_column_major] = ACTIONS(3115),
    [anon_sym_globallycoherent] = ACTIONS(3115),
    [anon_sym_centroid] = ACTIONS(3115),
    [anon_sym_noperspective] = ACTIONS(3115),
    [anon_sym_nointerpolation] = ACTIONS(3115),
    [anon_sym_sample] = ACTIONS(3115),
    [anon_sym_linear] = ACTIONS(3115),
    [anon_sym_snorm] = ACTIONS(3115),
    [anon_sym_unorm] = ACTIONS(3115),
    [anon_sym_point] = ACTIONS(3115),
    [anon_sym_line] = ACTIONS(3115),
    [anon_sym_triangleadj] = ACTIONS(3115),
    [anon_sym_lineadj] = ACTIONS(3115),
    [anon_sym_triangle] = ACTIONS(3115),
  },
  [818] = {
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [819] = {
    [ts_builtin_sym_end] = ACTIONS(2526),
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_include_token1] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2524),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym___cdecl] = ACTIONS(2524),
    [anon_sym___clrcall] = ACTIONS(2524),
    [anon_sym___stdcall] = ACTIONS(2524),
    [anon_sym___fastcall] = ACTIONS(2524),
    [anon_sym___thiscall] = ACTIONS(2524),
    [anon_sym___vectorcall] = ACTIONS(2524),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2524),
    [anon_sym_switch] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2524),
    [anon_sym_default] = ACTIONS(2524),
    [anon_sym_while] = ACTIONS(2524),
    [anon_sym_do] = ACTIONS(2524),
    [anon_sym_for] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2524),
    [anon_sym_break] = ACTIONS(2524),
    [anon_sym_continue] = ACTIONS(2524),
    [anon_sym_goto] = ACTIONS(2524),
    [anon_sym_not] = ACTIONS(2524),
    [anon_sym_compl] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2524),
    [anon_sym___alignof__] = ACTIONS(2524),
    [anon_sym___alignof] = ACTIONS(2524),
    [anon_sym__alignof] = ACTIONS(2524),
    [anon_sym_alignof] = ACTIONS(2524),
    [anon_sym__Alignof] = ACTIONS(2524),
    [anon_sym_offsetof] = ACTIONS(2524),
    [anon_sym__Generic] = ACTIONS(2524),
    [anon_sym_asm] = ACTIONS(2524),
    [anon_sym___asm__] = ACTIONS(2524),
    [anon_sym___asm] = ACTIONS(2524),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2524),
    [sym_false] = ACTIONS(2524),
    [anon_sym_NULL] = ACTIONS(2524),
    [anon_sym_nullptr] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_export] = ACTIONS(2524),
    [anon_sym_module] = ACTIONS(2524),
    [anon_sym_import] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_try] = ACTIONS(2524),
    [anon_sym_delete] = ACTIONS(2524),
    [anon_sym_throw] = ACTIONS(2524),
    [anon_sym_namespace] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_concept] = ACTIONS(2524),
    [anon_sym_co_return] = ACTIONS(2524),
    [anon_sym_co_yield] = ACTIONS(2524),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2524),
    [anon_sym_new] = ACTIONS(2524),
    [anon_sym_requires] = ACTIONS(2524),
    [sym_this] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [820] = {
    [ts_builtin_sym_end] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_export] = ACTIONS(2556),
    [anon_sym_module] = ACTIONS(2556),
    [anon_sym_import] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [821] = {
    [ts_builtin_sym_end] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_include_token1] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2556),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym___cdecl] = ACTIONS(2556),
    [anon_sym___clrcall] = ACTIONS(2556),
    [anon_sym___stdcall] = ACTIONS(2556),
    [anon_sym___fastcall] = ACTIONS(2556),
    [anon_sym___thiscall] = ACTIONS(2556),
    [anon_sym___vectorcall] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2556),
    [anon_sym_switch] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2556),
    [anon_sym_default] = ACTIONS(2556),
    [anon_sym_while] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_for] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2556),
    [anon_sym_break] = ACTIONS(2556),
    [anon_sym_continue] = ACTIONS(2556),
    [anon_sym_goto] = ACTIONS(2556),
    [anon_sym_not] = ACTIONS(2556),
    [anon_sym_compl] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2556),
    [anon_sym___alignof__] = ACTIONS(2556),
    [anon_sym___alignof] = ACTIONS(2556),
    [anon_sym__alignof] = ACTIONS(2556),
    [anon_sym_alignof] = ACTIONS(2556),
    [anon_sym__Alignof] = ACTIONS(2556),
    [anon_sym_offsetof] = ACTIONS(2556),
    [anon_sym__Generic] = ACTIONS(2556),
    [anon_sym_asm] = ACTIONS(2556),
    [anon_sym___asm__] = ACTIONS(2556),
    [anon_sym___asm] = ACTIONS(2556),
    [sym_number_literal] = ACTIONS(2558),
    [anon_sym_L_SQUOTE] = ACTIONS(2558),
    [anon_sym_u_SQUOTE] = ACTIONS(2558),
    [anon_sym_U_SQUOTE] = ACTIONS(2558),
    [anon_sym_u8_SQUOTE] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_L_DQUOTE] = ACTIONS(2558),
    [anon_sym_u_DQUOTE] = ACTIONS(2558),
    [anon_sym_U_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8_DQUOTE] = ACTIONS(2558),
    [anon_sym_DQUOTE] = ACTIONS(2558),
    [sym_true] = ACTIONS(2556),
    [sym_false] = ACTIONS(2556),
    [anon_sym_NULL] = ACTIONS(2556),
    [anon_sym_nullptr] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_export] = ACTIONS(2556),
    [anon_sym_module] = ACTIONS(2556),
    [anon_sym_import] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_try] = ACTIONS(2556),
    [anon_sym_delete] = ACTIONS(2556),
    [anon_sym_throw] = ACTIONS(2556),
    [anon_sym_namespace] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_concept] = ACTIONS(2556),
    [anon_sym_co_return] = ACTIONS(2556),
    [anon_sym_co_yield] = ACTIONS(2556),
    [anon_sym_R_DQUOTE] = ACTIONS(2558),
    [anon_sym_LR_DQUOTE] = ACTIONS(2558),
    [anon_sym_uR_DQUOTE] = ACTIONS(2558),
    [anon_sym_UR_DQUOTE] = ACTIONS(2558),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2558),
    [anon_sym_co_await] = ACTIONS(2556),
    [anon_sym_new] = ACTIONS(2556),
    [anon_sym_requires] = ACTIONS(2556),
    [sym_this] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [822] = {
    [ts_builtin_sym_end] = ACTIONS(2562),
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_include_token1] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2560),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym___cdecl] = ACTIONS(2560),
    [anon_sym___clrcall] = ACTIONS(2560),
    [anon_sym___stdcall] = ACTIONS(2560),
    [anon_sym___fastcall] = ACTIONS(2560),
    [anon_sym___thiscall] = ACTIONS(2560),
    [anon_sym___vectorcall] = ACTIONS(2560),
    [anon_sym_LBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2560),
    [anon_sym_switch] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2560),
    [anon_sym_default] = ACTIONS(2560),
    [anon_sym_while] = ACTIONS(2560),
    [anon_sym_do] = ACTIONS(2560),
    [anon_sym_for] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2560),
    [anon_sym_break] = ACTIONS(2560),
    [anon_sym_continue] = ACTIONS(2560),
    [anon_sym_goto] = ACTIONS(2560),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_compl] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2560),
    [anon_sym___alignof__] = ACTIONS(2560),
    [anon_sym___alignof] = ACTIONS(2560),
    [anon_sym__alignof] = ACTIONS(2560),
    [anon_sym_alignof] = ACTIONS(2560),
    [anon_sym__Alignof] = ACTIONS(2560),
    [anon_sym_offsetof] = ACTIONS(2560),
    [anon_sym__Generic] = ACTIONS(2560),
    [anon_sym_asm] = ACTIONS(2560),
    [anon_sym___asm__] = ACTIONS(2560),
    [anon_sym___asm] = ACTIONS(2560),
    [sym_number_literal] = ACTIONS(2562),
    [anon_sym_L_SQUOTE] = ACTIONS(2562),
    [anon_sym_u_SQUOTE] = ACTIONS(2562),
    [anon_sym_U_SQUOTE] = ACTIONS(2562),
    [anon_sym_u8_SQUOTE] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_L_DQUOTE] = ACTIONS(2562),
    [anon_sym_u_DQUOTE] = ACTIONS(2562),
    [anon_sym_U_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8_DQUOTE] = ACTIONS(2562),
    [anon_sym_DQUOTE] = ACTIONS(2562),
    [sym_true] = ACTIONS(2560),
    [sym_false] = ACTIONS(2560),
    [anon_sym_NULL] = ACTIONS(2560),
    [anon_sym_nullptr] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_export] = ACTIONS(2560),
    [anon_sym_module] = ACTIONS(2560),
    [anon_sym_import] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_try] = ACTIONS(2560),
    [anon_sym_delete] = ACTIONS(2560),
    [anon_sym_throw] = ACTIONS(2560),
    [anon_sym_namespace] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_concept] = ACTIONS(2560),
    [anon_sym_co_return] = ACTIONS(2560),
    [anon_sym_co_yield] = ACTIONS(2560),
    [anon_sym_R_DQUOTE] = ACTIONS(2562),
    [anon_sym_LR_DQUOTE] = ACTIONS(2562),
    [anon_sym_uR_DQUOTE] = ACTIONS(2562),
    [anon_sym_UR_DQUOTE] = ACTIONS(2562),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2562),
    [anon_sym_co_await] = ACTIONS(2560),
    [anon_sym_new] = ACTIONS(2560),
    [anon_sym_requires] = ACTIONS(2560),
    [sym_this] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
  },
  [823] = {
    [ts_builtin_sym_end] = ACTIONS(2566),
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_include_token1] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2564),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym___cdecl] = ACTIONS(2564),
    [anon_sym___clrcall] = ACTIONS(2564),
    [anon_sym___stdcall] = ACTIONS(2564),
    [anon_sym___fastcall] = ACTIONS(2564),
    [anon_sym___thiscall] = ACTIONS(2564),
    [anon_sym___vectorcall] = ACTIONS(2564),
    [anon_sym_LBRACE] = ACTIONS(2566),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2564),
    [anon_sym_switch] = ACTIONS(2564),
    [anon_sym_case] = ACTIONS(2564),
    [anon_sym_default] = ACTIONS(2564),
    [anon_sym_while] = ACTIONS(2564),
    [anon_sym_do] = ACTIONS(2564),
    [anon_sym_for] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2564),
    [anon_sym_break] = ACTIONS(2564),
    [anon_sym_continue] = ACTIONS(2564),
    [anon_sym_goto] = ACTIONS(2564),
    [anon_sym_not] = ACTIONS(2564),
    [anon_sym_compl] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2566),
    [anon_sym_sizeof] = ACTIONS(2564),
    [anon_sym___alignof__] = ACTIONS(2564),
    [anon_sym___alignof] = ACTIONS(2564),
    [anon_sym__alignof] = ACTIONS(2564),
    [anon_sym_alignof] = ACTIONS(2564),
    [anon_sym__Alignof] = ACTIONS(2564),
    [anon_sym_offsetof] = ACTIONS(2564),
    [anon_sym__Generic] = ACTIONS(2564),
    [anon_sym_asm] = ACTIONS(2564),
    [anon_sym___asm__] = ACTIONS(2564),
    [anon_sym___asm] = ACTIONS(2564),
    [sym_number_literal] = ACTIONS(2566),
    [anon_sym_L_SQUOTE] = ACTIONS(2566),
    [anon_sym_u_SQUOTE] = ACTIONS(2566),
    [anon_sym_U_SQUOTE] = ACTIONS(2566),
    [anon_sym_u8_SQUOTE] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_L_DQUOTE] = ACTIONS(2566),
    [anon_sym_u_DQUOTE] = ACTIONS(2566),
    [anon_sym_U_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8_DQUOTE] = ACTIONS(2566),
    [anon_sym_DQUOTE] = ACTIONS(2566),
    [sym_true] = ACTIONS(2564),
    [sym_false] = ACTIONS(2564),
    [anon_sym_NULL] = ACTIONS(2564),
    [anon_sym_nullptr] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_export] = ACTIONS(2564),
    [anon_sym_module] = ACTIONS(2564),
    [anon_sym_import] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_try] = ACTIONS(2564),
    [anon_sym_delete] = ACTIONS(2564),
    [anon_sym_throw] = ACTIONS(2564),
    [anon_sym_namespace] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_concept] = ACTIONS(2564),
    [anon_sym_co_return] = ACTIONS(2564),
    [anon_sym_co_yield] = ACTIONS(2564),
    [anon_sym_R_DQUOTE] = ACTIONS(2566),
    [anon_sym_LR_DQUOTE] = ACTIONS(2566),
    [anon_sym_uR_DQUOTE] = ACTIONS(2566),
    [anon_sym_UR_DQUOTE] = ACTIONS(2566),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2566),
    [anon_sym_co_await] = ACTIONS(2564),
    [anon_sym_new] = ACTIONS(2564),
    [anon_sym_requires] = ACTIONS(2564),
    [sym_this] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
  },
  [824] = {
    [ts_builtin_sym_end] = ACTIONS(2498),
    [sym_identifier] = ACTIONS(2496),
    [aux_sym_preproc_include_token1] = ACTIONS(2496),
    [aux_sym_preproc_def_token1] = ACTIONS(2496),
    [aux_sym_preproc_if_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2496),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2496),
    [sym_preproc_directive] = ACTIONS(2496),
    [anon_sym_LPAREN2] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym___extension__] = ACTIONS(2496),
    [anon_sym_typedef] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2496),
    [anon_sym_out] = ACTIONS(2496),
    [anon_sym_inout] = ACTIONS(2496),
    [anon_sym_virtual] = ACTIONS(2496),
    [anon_sym_extern] = ACTIONS(2496),
    [anon_sym___attribute__] = ACTIONS(2496),
    [anon_sym___attribute] = ACTIONS(2496),
    [anon_sym_using] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2498),
    [anon_sym___declspec] = ACTIONS(2496),
    [anon_sym___based] = ACTIONS(2496),
    [anon_sym___cdecl] = ACTIONS(2496),
    [anon_sym___clrcall] = ACTIONS(2496),
    [anon_sym___stdcall] = ACTIONS(2496),
    [anon_sym___fastcall] = ACTIONS(2496),
    [anon_sym___thiscall] = ACTIONS(2496),
    [anon_sym___vectorcall] = ACTIONS(2496),
    [anon_sym_LBRACE] = ACTIONS(2498),
    [anon_sym_signed] = ACTIONS(2496),
    [anon_sym_unsigned] = ACTIONS(2496),
    [anon_sym_long] = ACTIONS(2496),
    [anon_sym_short] = ACTIONS(2496),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2496),
    [anon_sym_register] = ACTIONS(2496),
    [anon_sym_inline] = ACTIONS(2496),
    [anon_sym___inline] = ACTIONS(2496),
    [anon_sym___inline__] = ACTIONS(2496),
    [anon_sym___forceinline] = ACTIONS(2496),
    [anon_sym_thread_local] = ACTIONS(2496),
    [anon_sym___thread] = ACTIONS(2496),
    [anon_sym_const] = ACTIONS(2496),
    [anon_sym_constexpr] = ACTIONS(2496),
    [anon_sym_volatile] = ACTIONS(2496),
    [anon_sym_restrict] = ACTIONS(2496),
    [anon_sym___restrict__] = ACTIONS(2496),
    [anon_sym__Atomic] = ACTIONS(2496),
    [anon_sym__Noreturn] = ACTIONS(2496),
    [anon_sym_noreturn] = ACTIONS(2496),
    [anon_sym__Nonnull] = ACTIONS(2496),
    [anon_sym_mutable] = ACTIONS(2496),
    [anon_sym_constinit] = ACTIONS(2496),
    [anon_sym_consteval] = ACTIONS(2496),
    [anon_sym_alignas] = ACTIONS(2496),
    [anon_sym__Alignas] = ACTIONS(2496),
    [sym_primitive_type] = ACTIONS(2496),
    [anon_sym_enum] = ACTIONS(2496),
    [anon_sym_class] = ACTIONS(2496),
    [anon_sym_struct] = ACTIONS(2496),
    [anon_sym_union] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2496),
    [anon_sym_switch] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2496),
    [anon_sym_default] = ACTIONS(2496),
    [anon_sym_while] = ACTIONS(2496),
    [anon_sym_do] = ACTIONS(2496),
    [anon_sym_for] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2496),
    [anon_sym_break] = ACTIONS(2496),
    [anon_sym_continue] = ACTIONS(2496),
    [anon_sym_goto] = ACTIONS(2496),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2496),
    [anon_sym___alignof__] = ACTIONS(2496),
    [anon_sym___alignof] = ACTIONS(2496),
    [anon_sym__alignof] = ACTIONS(2496),
    [anon_sym_alignof] = ACTIONS(2496),
    [anon_sym__Alignof] = ACTIONS(2496),
    [anon_sym_offsetof] = ACTIONS(2496),
    [anon_sym__Generic] = ACTIONS(2496),
    [anon_sym_asm] = ACTIONS(2496),
    [anon_sym___asm__] = ACTIONS(2496),
    [anon_sym___asm] = ACTIONS(2496),
    [sym_number_literal] = ACTIONS(2498),
    [anon_sym_L_SQUOTE] = ACTIONS(2498),
    [anon_sym_u_SQUOTE] = ACTIONS(2498),
    [anon_sym_U_SQUOTE] = ACTIONS(2498),
    [anon_sym_u8_SQUOTE] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_L_DQUOTE] = ACTIONS(2498),
    [anon_sym_u_DQUOTE] = ACTIONS(2498),
    [anon_sym_U_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8_DQUOTE] = ACTIONS(2498),
    [anon_sym_DQUOTE] = ACTIONS(2498),
    [sym_true] = ACTIONS(2496),
    [sym_false] = ACTIONS(2496),
    [anon_sym_NULL] = ACTIONS(2496),
    [anon_sym_nullptr] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2496),
    [anon_sym_decltype] = ACTIONS(2496),
    [anon_sym_explicit] = ACTIONS(2496),
    [anon_sym_typename] = ACTIONS(2496),
    [anon_sym_export] = ACTIONS(2496),
    [anon_sym_module] = ACTIONS(2496),
    [anon_sym_import] = ACTIONS(2496),
    [anon_sym_template] = ACTIONS(2496),
    [anon_sym_operator] = ACTIONS(2496),
    [anon_sym_try] = ACTIONS(2496),
    [anon_sym_delete] = ACTIONS(2496),
    [anon_sym_throw] = ACTIONS(2496),
    [anon_sym_namespace] = ACTIONS(2496),
    [anon_sym_static_assert] = ACTIONS(2496),
    [anon_sym_concept] = ACTIONS(2496),
    [anon_sym_co_return] = ACTIONS(2496),
    [anon_sym_co_yield] = ACTIONS(2496),
    [anon_sym_R_DQUOTE] = ACTIONS(2498),
    [anon_sym_LR_DQUOTE] = ACTIONS(2498),
    [anon_sym_uR_DQUOTE] = ACTIONS(2498),
    [anon_sym_UR_DQUOTE] = ACTIONS(2498),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2498),
    [anon_sym_co_await] = ACTIONS(2496),
    [anon_sym_new] = ACTIONS(2496),
    [anon_sym_requires] = ACTIONS(2496),
    [sym_this] = ACTIONS(2496),
    [anon_sym_precise] = ACTIONS(2496),
    [anon_sym_shared] = ACTIONS(2496),
    [anon_sym_groupshared] = ACTIONS(2496),
    [anon_sym_uniform] = ACTIONS(2496),
    [anon_sym_row_major] = ACTIONS(2496),
    [anon_sym_column_major] = ACTIONS(2496),
    [anon_sym_globallycoherent] = ACTIONS(2496),
    [anon_sym_centroid] = ACTIONS(2496),
    [anon_sym_noperspective] = ACTIONS(2496),
    [anon_sym_nointerpolation] = ACTIONS(2496),
    [anon_sym_sample] = ACTIONS(2496),
    [anon_sym_linear] = ACTIONS(2496),
    [anon_sym_snorm] = ACTIONS(2496),
    [anon_sym_unorm] = ACTIONS(2496),
    [anon_sym_point] = ACTIONS(2496),
    [anon_sym_line] = ACTIONS(2496),
    [anon_sym_triangleadj] = ACTIONS(2496),
    [anon_sym_lineadj] = ACTIONS(2496),
    [anon_sym_triangle] = ACTIONS(2496),
  },
  [825] = {
    [ts_builtin_sym_end] = ACTIONS(3117),
    [sym_identifier] = ACTIONS(3119),
    [aux_sym_preproc_include_token1] = ACTIONS(3119),
    [aux_sym_preproc_def_token1] = ACTIONS(3119),
    [aux_sym_preproc_if_token1] = ACTIONS(3119),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3119),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3119),
    [sym_preproc_directive] = ACTIONS(3119),
    [anon_sym_LPAREN2] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_DASH] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_AMP_AMP] = ACTIONS(3117),
    [anon_sym_AMP] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym___extension__] = ACTIONS(3119),
    [anon_sym_typedef] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_out] = ACTIONS(3119),
    [anon_sym_inout] = ACTIONS(3119),
    [anon_sym_virtual] = ACTIONS(3119),
    [anon_sym_extern] = ACTIONS(3119),
    [anon_sym___attribute__] = ACTIONS(3119),
    [anon_sym___attribute] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_COLON_COLON] = ACTIONS(3117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3117),
    [anon_sym___declspec] = ACTIONS(3119),
    [anon_sym___based] = ACTIONS(3119),
    [anon_sym___cdecl] = ACTIONS(3119),
    [anon_sym___clrcall] = ACTIONS(3119),
    [anon_sym___stdcall] = ACTIONS(3119),
    [anon_sym___fastcall] = ACTIONS(3119),
    [anon_sym___thiscall] = ACTIONS(3119),
    [anon_sym___vectorcall] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3117),
    [anon_sym_signed] = ACTIONS(3119),
    [anon_sym_unsigned] = ACTIONS(3119),
    [anon_sym_long] = ACTIONS(3119),
    [anon_sym_short] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_static] = ACTIONS(3119),
    [anon_sym_register] = ACTIONS(3119),
    [anon_sym_inline] = ACTIONS(3119),
    [anon_sym___inline] = ACTIONS(3119),
    [anon_sym___inline__] = ACTIONS(3119),
    [anon_sym___forceinline] = ACTIONS(3119),
    [anon_sym_thread_local] = ACTIONS(3119),
    [anon_sym___thread] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_constexpr] = ACTIONS(3119),
    [anon_sym_volatile] = ACTIONS(3119),
    [anon_sym_restrict] = ACTIONS(3119),
    [anon_sym___restrict__] = ACTIONS(3119),
    [anon_sym__Atomic] = ACTIONS(3119),
    [anon_sym__Noreturn] = ACTIONS(3119),
    [anon_sym_noreturn] = ACTIONS(3119),
    [anon_sym__Nonnull] = ACTIONS(3119),
    [anon_sym_mutable] = ACTIONS(3119),
    [anon_sym_constinit] = ACTIONS(3119),
    [anon_sym_consteval] = ACTIONS(3119),
    [anon_sym_alignas] = ACTIONS(3119),
    [anon_sym__Alignas] = ACTIONS(3119),
    [sym_primitive_type] = ACTIONS(3119),
    [anon_sym_enum] = ACTIONS(3119),
    [anon_sym_class] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_union] = ACTIONS(3119),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_switch] = ACTIONS(3119),
    [anon_sym_case] = ACTIONS(3119),
    [anon_sym_default] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [anon_sym_do] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_break] = ACTIONS(3119),
    [anon_sym_continue] = ACTIONS(3119),
    [anon_sym_goto] = ACTIONS(3119),
    [anon_sym_not] = ACTIONS(3119),
    [anon_sym_compl] = ACTIONS(3119),
    [anon_sym_DASH_DASH] = ACTIONS(3117),
    [anon_sym_PLUS_PLUS] = ACTIONS(3117),
    [anon_sym_sizeof] = ACTIONS(3119),
    [anon_sym___alignof__] = ACTIONS(3119),
    [anon_sym___alignof] = ACTIONS(3119),
    [anon_sym__alignof] = ACTIONS(3119),
    [anon_sym_alignof] = ACTIONS(3119),
    [anon_sym__Alignof] = ACTIONS(3119),
    [anon_sym_offsetof] = ACTIONS(3119),
    [anon_sym__Generic] = ACTIONS(3119),
    [anon_sym_asm] = ACTIONS(3119),
    [anon_sym___asm__] = ACTIONS(3119),
    [anon_sym___asm] = ACTIONS(3119),
    [sym_number_literal] = ACTIONS(3117),
    [anon_sym_L_SQUOTE] = ACTIONS(3117),
    [anon_sym_u_SQUOTE] = ACTIONS(3117),
    [anon_sym_U_SQUOTE] = ACTIONS(3117),
    [anon_sym_u8_SQUOTE] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym_L_DQUOTE] = ACTIONS(3117),
    [anon_sym_u_DQUOTE] = ACTIONS(3117),
    [anon_sym_U_DQUOTE] = ACTIONS(3117),
    [anon_sym_u8_DQUOTE] = ACTIONS(3117),
    [anon_sym_DQUOTE] = ACTIONS(3117),
    [sym_true] = ACTIONS(3119),
    [sym_false] = ACTIONS(3119),
    [anon_sym_NULL] = ACTIONS(3119),
    [anon_sym_nullptr] = ACTIONS(3119),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3119),
    [anon_sym_decltype] = ACTIONS(3119),
    [anon_sym_explicit] = ACTIONS(3119),
    [anon_sym_typename] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_template] = ACTIONS(3119),
    [anon_sym_operator] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_delete] = ACTIONS(3119),
    [anon_sym_throw] = ACTIONS(3119),
    [anon_sym_namespace] = ACTIONS(3119),
    [anon_sym_static_assert] = ACTIONS(3119),
    [anon_sym_concept] = ACTIONS(3119),
    [anon_sym_co_return] = ACTIONS(3119),
    [anon_sym_co_yield] = ACTIONS(3119),
    [anon_sym_R_DQUOTE] = ACTIONS(3117),
    [anon_sym_LR_DQUOTE] = ACTIONS(3117),
    [anon_sym_uR_DQUOTE] = ACTIONS(3117),
    [anon_sym_UR_DQUOTE] = ACTIONS(3117),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3117),
    [anon_sym_co_await] = ACTIONS(3119),
    [anon_sym_new] = ACTIONS(3119),
    [anon_sym_requires] = ACTIONS(3119),
    [sym_this] = ACTIONS(3119),
    [anon_sym_precise] = ACTIONS(3119),
    [anon_sym_shared] = ACTIONS(3119),
    [anon_sym_groupshared] = ACTIONS(3119),
    [anon_sym_uniform] = ACTIONS(3119),
    [anon_sym_row_major] = ACTIONS(3119),
    [anon_sym_column_major] = ACTIONS(3119),
    [anon_sym_globallycoherent] = ACTIONS(3119),
    [anon_sym_centroid] = ACTIONS(3119),
    [anon_sym_noperspective] = ACTIONS(3119),
    [anon_sym_nointerpolation] = ACTIONS(3119),
    [anon_sym_sample] = ACTIONS(3119),
    [anon_sym_linear] = ACTIONS(3119),
    [anon_sym_snorm] = ACTIONS(3119),
    [anon_sym_unorm] = ACTIONS(3119),
    [anon_sym_point] = ACTIONS(3119),
    [anon_sym_line] = ACTIONS(3119),
    [anon_sym_triangleadj] = ACTIONS(3119),
    [anon_sym_lineadj] = ACTIONS(3119),
    [anon_sym_triangle] = ACTIONS(3119),
  },
  [826] = {
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_include_token1] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym___cdecl] = ACTIONS(2628),
    [anon_sym___clrcall] = ACTIONS(2628),
    [anon_sym___stdcall] = ACTIONS(2628),
    [anon_sym___fastcall] = ACTIONS(2628),
    [anon_sym___thiscall] = ACTIONS(2628),
    [anon_sym___vectorcall] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_goto] = ACTIONS(2628),
    [anon_sym_not] = ACTIONS(2628),
    [anon_sym_compl] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_sizeof] = ACTIONS(2628),
    [anon_sym___alignof__] = ACTIONS(2628),
    [anon_sym___alignof] = ACTIONS(2628),
    [anon_sym__alignof] = ACTIONS(2628),
    [anon_sym_alignof] = ACTIONS(2628),
    [anon_sym__Alignof] = ACTIONS(2628),
    [anon_sym_offsetof] = ACTIONS(2628),
    [anon_sym__Generic] = ACTIONS(2628),
    [anon_sym_asm] = ACTIONS(2628),
    [anon_sym___asm__] = ACTIONS(2628),
    [anon_sym___asm] = ACTIONS(2628),
    [sym_number_literal] = ACTIONS(2630),
    [anon_sym_L_SQUOTE] = ACTIONS(2630),
    [anon_sym_u_SQUOTE] = ACTIONS(2630),
    [anon_sym_U_SQUOTE] = ACTIONS(2630),
    [anon_sym_u8_SQUOTE] = ACTIONS(2630),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_L_DQUOTE] = ACTIONS(2630),
    [anon_sym_u_DQUOTE] = ACTIONS(2630),
    [anon_sym_U_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8_DQUOTE] = ACTIONS(2630),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [sym_true] = ACTIONS(2628),
    [sym_false] = ACTIONS(2628),
    [anon_sym_NULL] = ACTIONS(2628),
    [anon_sym_nullptr] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_concept] = ACTIONS(2628),
    [anon_sym_co_return] = ACTIONS(2628),
    [anon_sym_co_yield] = ACTIONS(2628),
    [anon_sym_R_DQUOTE] = ACTIONS(2630),
    [anon_sym_LR_DQUOTE] = ACTIONS(2630),
    [anon_sym_uR_DQUOTE] = ACTIONS(2630),
    [anon_sym_UR_DQUOTE] = ACTIONS(2630),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2630),
    [anon_sym_co_await] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [anon_sym_requires] = ACTIONS(2628),
    [sym_this] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
  },
  [827] = {
    [ts_builtin_sym_end] = ACTIONS(2578),
    [sym_identifier] = ACTIONS(2576),
    [aux_sym_preproc_include_token1] = ACTIONS(2576),
    [aux_sym_preproc_def_token1] = ACTIONS(2576),
    [aux_sym_preproc_if_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2576),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2576),
    [sym_preproc_directive] = ACTIONS(2576),
    [anon_sym_LPAREN2] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2576),
    [anon_sym_STAR] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_AMP] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym___extension__] = ACTIONS(2576),
    [anon_sym_typedef] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2576),
    [anon_sym_out] = ACTIONS(2576),
    [anon_sym_inout] = ACTIONS(2576),
    [anon_sym_virtual] = ACTIONS(2576),
    [anon_sym_extern] = ACTIONS(2576),
    [anon_sym___attribute__] = ACTIONS(2576),
    [anon_sym___attribute] = ACTIONS(2576),
    [anon_sym_using] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2578),
    [anon_sym___declspec] = ACTIONS(2576),
    [anon_sym___based] = ACTIONS(2576),
    [anon_sym___cdecl] = ACTIONS(2576),
    [anon_sym___clrcall] = ACTIONS(2576),
    [anon_sym___stdcall] = ACTIONS(2576),
    [anon_sym___fastcall] = ACTIONS(2576),
    [anon_sym___thiscall] = ACTIONS(2576),
    [anon_sym___vectorcall] = ACTIONS(2576),
    [anon_sym_LBRACE] = ACTIONS(2578),
    [anon_sym_signed] = ACTIONS(2576),
    [anon_sym_unsigned] = ACTIONS(2576),
    [anon_sym_long] = ACTIONS(2576),
    [anon_sym_short] = ACTIONS(2576),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2576),
    [anon_sym_register] = ACTIONS(2576),
    [anon_sym_inline] = ACTIONS(2576),
    [anon_sym___inline] = ACTIONS(2576),
    [anon_sym___inline__] = ACTIONS(2576),
    [anon_sym___forceinline] = ACTIONS(2576),
    [anon_sym_thread_local] = ACTIONS(2576),
    [anon_sym___thread] = ACTIONS(2576),
    [anon_sym_const] = ACTIONS(2576),
    [anon_sym_constexpr] = ACTIONS(2576),
    [anon_sym_volatile] = ACTIONS(2576),
    [anon_sym_restrict] = ACTIONS(2576),
    [anon_sym___restrict__] = ACTIONS(2576),
    [anon_sym__Atomic] = ACTIONS(2576),
    [anon_sym__Noreturn] = ACTIONS(2576),
    [anon_sym_noreturn] = ACTIONS(2576),
    [anon_sym__Nonnull] = ACTIONS(2576),
    [anon_sym_mutable] = ACTIONS(2576),
    [anon_sym_constinit] = ACTIONS(2576),
    [anon_sym_consteval] = ACTIONS(2576),
    [anon_sym_alignas] = ACTIONS(2576),
    [anon_sym__Alignas] = ACTIONS(2576),
    [sym_primitive_type] = ACTIONS(2576),
    [anon_sym_enum] = ACTIONS(2576),
    [anon_sym_class] = ACTIONS(2576),
    [anon_sym_struct] = ACTIONS(2576),
    [anon_sym_union] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2576),
    [anon_sym_switch] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2576),
    [anon_sym_default] = ACTIONS(2576),
    [anon_sym_while] = ACTIONS(2576),
    [anon_sym_do] = ACTIONS(2576),
    [anon_sym_for] = ACTIONS(2576),
    [anon_sym_return] = ACTIONS(2576),
    [anon_sym_break] = ACTIONS(2576),
    [anon_sym_continue] = ACTIONS(2576),
    [anon_sym_goto] = ACTIONS(2576),
    [anon_sym_not] = ACTIONS(2576),
    [anon_sym_compl] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2578),
    [anon_sym_sizeof] = ACTIONS(2576),
    [anon_sym___alignof__] = ACTIONS(2576),
    [anon_sym___alignof] = ACTIONS(2576),
    [anon_sym__alignof] = ACTIONS(2576),
    [anon_sym_alignof] = ACTIONS(2576),
    [anon_sym__Alignof] = ACTIONS(2576),
    [anon_sym_offsetof] = ACTIONS(2576),
    [anon_sym__Generic] = ACTIONS(2576),
    [anon_sym_asm] = ACTIONS(2576),
    [anon_sym___asm__] = ACTIONS(2576),
    [anon_sym___asm] = ACTIONS(2576),
    [sym_number_literal] = ACTIONS(2578),
    [anon_sym_L_SQUOTE] = ACTIONS(2578),
    [anon_sym_u_SQUOTE] = ACTIONS(2578),
    [anon_sym_U_SQUOTE] = ACTIONS(2578),
    [anon_sym_u8_SQUOTE] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_L_DQUOTE] = ACTIONS(2578),
    [anon_sym_u_DQUOTE] = ACTIONS(2578),
    [anon_sym_U_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8_DQUOTE] = ACTIONS(2578),
    [anon_sym_DQUOTE] = ACTIONS(2578),
    [sym_true] = ACTIONS(2576),
    [sym_false] = ACTIONS(2576),
    [anon_sym_NULL] = ACTIONS(2576),
    [anon_sym_nullptr] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2576),
    [anon_sym_decltype] = ACTIONS(2576),
    [anon_sym_explicit] = ACTIONS(2576),
    [anon_sym_typename] = ACTIONS(2576),
    [anon_sym_export] = ACTIONS(2576),
    [anon_sym_module] = ACTIONS(2576),
    [anon_sym_import] = ACTIONS(2576),
    [anon_sym_template] = ACTIONS(2576),
    [anon_sym_operator] = ACTIONS(2576),
    [anon_sym_try] = ACTIONS(2576),
    [anon_sym_delete] = ACTIONS(2576),
    [anon_sym_throw] = ACTIONS(2576),
    [anon_sym_namespace] = ACTIONS(2576),
    [anon_sym_static_assert] = ACTIONS(2576),
    [anon_sym_concept] = ACTIONS(2576),
    [anon_sym_co_return] = ACTIONS(2576),
    [anon_sym_co_yield] = ACTIONS(2576),
    [anon_sym_R_DQUOTE] = ACTIONS(2578),
    [anon_sym_LR_DQUOTE] = ACTIONS(2578),
    [anon_sym_uR_DQUOTE] = ACTIONS(2578),
    [anon_sym_UR_DQUOTE] = ACTIONS(2578),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2578),
    [anon_sym_co_await] = ACTIONS(2576),
    [anon_sym_new] = ACTIONS(2576),
    [anon_sym_requires] = ACTIONS(2576),
    [sym_this] = ACTIONS(2576),
    [anon_sym_precise] = ACTIONS(2576),
    [anon_sym_shared] = ACTIONS(2576),
    [anon_sym_groupshared] = ACTIONS(2576),
    [anon_sym_uniform] = ACTIONS(2576),
    [anon_sym_row_major] = ACTIONS(2576),
    [anon_sym_column_major] = ACTIONS(2576),
    [anon_sym_globallycoherent] = ACTIONS(2576),
    [anon_sym_centroid] = ACTIONS(2576),
    [anon_sym_noperspective] = ACTIONS(2576),
    [anon_sym_nointerpolation] = ACTIONS(2576),
    [anon_sym_sample] = ACTIONS(2576),
    [anon_sym_linear] = ACTIONS(2576),
    [anon_sym_snorm] = ACTIONS(2576),
    [anon_sym_unorm] = ACTIONS(2576),
    [anon_sym_point] = ACTIONS(2576),
    [anon_sym_line] = ACTIONS(2576),
    [anon_sym_triangleadj] = ACTIONS(2576),
    [anon_sym_lineadj] = ACTIONS(2576),
    [anon_sym_triangle] = ACTIONS(2576),
  },
  [828] = {
    [ts_builtin_sym_end] = ACTIONS(2586),
    [sym_identifier] = ACTIONS(2584),
    [aux_sym_preproc_include_token1] = ACTIONS(2584),
    [aux_sym_preproc_def_token1] = ACTIONS(2584),
    [aux_sym_preproc_if_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2584),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2584),
    [sym_preproc_directive] = ACTIONS(2584),
    [anon_sym_LPAREN2] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_AMP] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym___extension__] = ACTIONS(2584),
    [anon_sym_typedef] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2584),
    [anon_sym_out] = ACTIONS(2584),
    [anon_sym_inout] = ACTIONS(2584),
    [anon_sym_virtual] = ACTIONS(2584),
    [anon_sym_extern] = ACTIONS(2584),
    [anon_sym___attribute__] = ACTIONS(2584),
    [anon_sym___attribute] = ACTIONS(2584),
    [anon_sym_using] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2586),
    [anon_sym___declspec] = ACTIONS(2584),
    [anon_sym___based] = ACTIONS(2584),
    [anon_sym___cdecl] = ACTIONS(2584),
    [anon_sym___clrcall] = ACTIONS(2584),
    [anon_sym___stdcall] = ACTIONS(2584),
    [anon_sym___fastcall] = ACTIONS(2584),
    [anon_sym___thiscall] = ACTIONS(2584),
    [anon_sym___vectorcall] = ACTIONS(2584),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_signed] = ACTIONS(2584),
    [anon_sym_unsigned] = ACTIONS(2584),
    [anon_sym_long] = ACTIONS(2584),
    [anon_sym_short] = ACTIONS(2584),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2584),
    [anon_sym_register] = ACTIONS(2584),
    [anon_sym_inline] = ACTIONS(2584),
    [anon_sym___inline] = ACTIONS(2584),
    [anon_sym___inline__] = ACTIONS(2584),
    [anon_sym___forceinline] = ACTIONS(2584),
    [anon_sym_thread_local] = ACTIONS(2584),
    [anon_sym___thread] = ACTIONS(2584),
    [anon_sym_const] = ACTIONS(2584),
    [anon_sym_constexpr] = ACTIONS(2584),
    [anon_sym_volatile] = ACTIONS(2584),
    [anon_sym_restrict] = ACTIONS(2584),
    [anon_sym___restrict__] = ACTIONS(2584),
    [anon_sym__Atomic] = ACTIONS(2584),
    [anon_sym__Noreturn] = ACTIONS(2584),
    [anon_sym_noreturn] = ACTIONS(2584),
    [anon_sym__Nonnull] = ACTIONS(2584),
    [anon_sym_mutable] = ACTIONS(2584),
    [anon_sym_constinit] = ACTIONS(2584),
    [anon_sym_consteval] = ACTIONS(2584),
    [anon_sym_alignas] = ACTIONS(2584),
    [anon_sym__Alignas] = ACTIONS(2584),
    [sym_primitive_type] = ACTIONS(2584),
    [anon_sym_enum] = ACTIONS(2584),
    [anon_sym_class] = ACTIONS(2584),
    [anon_sym_struct] = ACTIONS(2584),
    [anon_sym_union] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2584),
    [anon_sym_switch] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2584),
    [anon_sym_default] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2584),
    [anon_sym_do] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2584),
    [anon_sym_return] = ACTIONS(2584),
    [anon_sym_break] = ACTIONS(2584),
    [anon_sym_continue] = ACTIONS(2584),
    [anon_sym_goto] = ACTIONS(2584),
    [anon_sym_not] = ACTIONS(2584),
    [anon_sym_compl] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2586),
    [anon_sym_sizeof] = ACTIONS(2584),
    [anon_sym___alignof__] = ACTIONS(2584),
    [anon_sym___alignof] = ACTIONS(2584),
    [anon_sym__alignof] = ACTIONS(2584),
    [anon_sym_alignof] = ACTIONS(2584),
    [anon_sym__Alignof] = ACTIONS(2584),
    [anon_sym_offsetof] = ACTIONS(2584),
    [anon_sym__Generic] = ACTIONS(2584),
    [anon_sym_asm] = ACTIONS(2584),
    [anon_sym___asm__] = ACTIONS(2584),
    [anon_sym___asm] = ACTIONS(2584),
    [sym_number_literal] = ACTIONS(2586),
    [anon_sym_L_SQUOTE] = ACTIONS(2586),
    [anon_sym_u_SQUOTE] = ACTIONS(2586),
    [anon_sym_U_SQUOTE] = ACTIONS(2586),
    [anon_sym_u8_SQUOTE] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_L_DQUOTE] = ACTIONS(2586),
    [anon_sym_u_DQUOTE] = ACTIONS(2586),
    [anon_sym_U_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8_DQUOTE] = ACTIONS(2586),
    [anon_sym_DQUOTE] = ACTIONS(2586),
    [sym_true] = ACTIONS(2584),
    [sym_false] = ACTIONS(2584),
    [anon_sym_NULL] = ACTIONS(2584),
    [anon_sym_nullptr] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2584),
    [anon_sym_decltype] = ACTIONS(2584),
    [anon_sym_explicit] = ACTIONS(2584),
    [anon_sym_typename] = ACTIONS(2584),
    [anon_sym_export] = ACTIONS(2584),
    [anon_sym_module] = ACTIONS(2584),
    [anon_sym_import] = ACTIONS(2584),
    [anon_sym_template] = ACTIONS(2584),
    [anon_sym_operator] = ACTIONS(2584),
    [anon_sym_try] = ACTIONS(2584),
    [anon_sym_delete] = ACTIONS(2584),
    [anon_sym_throw] = ACTIONS(2584),
    [anon_sym_namespace] = ACTIONS(2584),
    [anon_sym_static_assert] = ACTIONS(2584),
    [anon_sym_concept] = ACTIONS(2584),
    [anon_sym_co_return] = ACTIONS(2584),
    [anon_sym_co_yield] = ACTIONS(2584),
    [anon_sym_R_DQUOTE] = ACTIONS(2586),
    [anon_sym_LR_DQUOTE] = ACTIONS(2586),
    [anon_sym_uR_DQUOTE] = ACTIONS(2586),
    [anon_sym_UR_DQUOTE] = ACTIONS(2586),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2586),
    [anon_sym_co_await] = ACTIONS(2584),
    [anon_sym_new] = ACTIONS(2584),
    [anon_sym_requires] = ACTIONS(2584),
    [sym_this] = ACTIONS(2584),
    [anon_sym_precise] = ACTIONS(2584),
    [anon_sym_shared] = ACTIONS(2584),
    [anon_sym_groupshared] = ACTIONS(2584),
    [anon_sym_uniform] = ACTIONS(2584),
    [anon_sym_row_major] = ACTIONS(2584),
    [anon_sym_column_major] = ACTIONS(2584),
    [anon_sym_globallycoherent] = ACTIONS(2584),
    [anon_sym_centroid] = ACTIONS(2584),
    [anon_sym_noperspective] = ACTIONS(2584),
    [anon_sym_nointerpolation] = ACTIONS(2584),
    [anon_sym_sample] = ACTIONS(2584),
    [anon_sym_linear] = ACTIONS(2584),
    [anon_sym_snorm] = ACTIONS(2584),
    [anon_sym_unorm] = ACTIONS(2584),
    [anon_sym_point] = ACTIONS(2584),
    [anon_sym_line] = ACTIONS(2584),
    [anon_sym_triangleadj] = ACTIONS(2584),
    [anon_sym_lineadj] = ACTIONS(2584),
    [anon_sym_triangle] = ACTIONS(2584),
  },
  [829] = {
    [ts_builtin_sym_end] = ACTIONS(3121),
    [sym_identifier] = ACTIONS(3123),
    [aux_sym_preproc_include_token1] = ACTIONS(3123),
    [aux_sym_preproc_def_token1] = ACTIONS(3123),
    [aux_sym_preproc_if_token1] = ACTIONS(3123),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3123),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3123),
    [sym_preproc_directive] = ACTIONS(3123),
    [anon_sym_LPAREN2] = ACTIONS(3121),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_DASH] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_AMP_AMP] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym___extension__] = ACTIONS(3123),
    [anon_sym_typedef] = ACTIONS(3123),
    [anon_sym_in] = ACTIONS(3123),
    [anon_sym_out] = ACTIONS(3123),
    [anon_sym_inout] = ACTIONS(3123),
    [anon_sym_virtual] = ACTIONS(3123),
    [anon_sym_extern] = ACTIONS(3123),
    [anon_sym___attribute__] = ACTIONS(3123),
    [anon_sym___attribute] = ACTIONS(3123),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3121),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3121),
    [anon_sym___declspec] = ACTIONS(3123),
    [anon_sym___based] = ACTIONS(3123),
    [anon_sym___cdecl] = ACTIONS(3123),
    [anon_sym___clrcall] = ACTIONS(3123),
    [anon_sym___stdcall] = ACTIONS(3123),
    [anon_sym___fastcall] = ACTIONS(3123),
    [anon_sym___thiscall] = ACTIONS(3123),
    [anon_sym___vectorcall] = ACTIONS(3123),
    [anon_sym_LBRACE] = ACTIONS(3121),
    [anon_sym_signed] = ACTIONS(3123),
    [anon_sym_unsigned] = ACTIONS(3123),
    [anon_sym_long] = ACTIONS(3123),
    [anon_sym_short] = ACTIONS(3123),
    [anon_sym_LBRACK] = ACTIONS(3123),
    [anon_sym_static] = ACTIONS(3123),
    [anon_sym_register] = ACTIONS(3123),
    [anon_sym_inline] = ACTIONS(3123),
    [anon_sym___inline] = ACTIONS(3123),
    [anon_sym___inline__] = ACTIONS(3123),
    [anon_sym___forceinline] = ACTIONS(3123),
    [anon_sym_thread_local] = ACTIONS(3123),
    [anon_sym___thread] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_constexpr] = ACTIONS(3123),
    [anon_sym_volatile] = ACTIONS(3123),
    [anon_sym_restrict] = ACTIONS(3123),
    [anon_sym___restrict__] = ACTIONS(3123),
    [anon_sym__Atomic] = ACTIONS(3123),
    [anon_sym__Noreturn] = ACTIONS(3123),
    [anon_sym_noreturn] = ACTIONS(3123),
    [anon_sym__Nonnull] = ACTIONS(3123),
    [anon_sym_mutable] = ACTIONS(3123),
    [anon_sym_constinit] = ACTIONS(3123),
    [anon_sym_consteval] = ACTIONS(3123),
    [anon_sym_alignas] = ACTIONS(3123),
    [anon_sym__Alignas] = ACTIONS(3123),
    [sym_primitive_type] = ACTIONS(3123),
    [anon_sym_enum] = ACTIONS(3123),
    [anon_sym_class] = ACTIONS(3123),
    [anon_sym_struct] = ACTIONS(3123),
    [anon_sym_union] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_switch] = ACTIONS(3123),
    [anon_sym_case] = ACTIONS(3123),
    [anon_sym_default] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [anon_sym_do] = ACTIONS(3123),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_break] = ACTIONS(3123),
    [anon_sym_continue] = ACTIONS(3123),
    [anon_sym_goto] = ACTIONS(3123),
    [anon_sym_not] = ACTIONS(3123),
    [anon_sym_compl] = ACTIONS(3123),
    [anon_sym_DASH_DASH] = ACTIONS(3121),
    [anon_sym_PLUS_PLUS] = ACTIONS(3121),
    [anon_sym_sizeof] = ACTIONS(3123),
    [anon_sym___alignof__] = ACTIONS(3123),
    [anon_sym___alignof] = ACTIONS(3123),
    [anon_sym__alignof] = ACTIONS(3123),
    [anon_sym_alignof] = ACTIONS(3123),
    [anon_sym__Alignof] = ACTIONS(3123),
    [anon_sym_offsetof] = ACTIONS(3123),
    [anon_sym__Generic] = ACTIONS(3123),
    [anon_sym_asm] = ACTIONS(3123),
    [anon_sym___asm__] = ACTIONS(3123),
    [anon_sym___asm] = ACTIONS(3123),
    [sym_number_literal] = ACTIONS(3121),
    [anon_sym_L_SQUOTE] = ACTIONS(3121),
    [anon_sym_u_SQUOTE] = ACTIONS(3121),
    [anon_sym_U_SQUOTE] = ACTIONS(3121),
    [anon_sym_u8_SQUOTE] = ACTIONS(3121),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym_L_DQUOTE] = ACTIONS(3121),
    [anon_sym_u_DQUOTE] = ACTIONS(3121),
    [anon_sym_U_DQUOTE] = ACTIONS(3121),
    [anon_sym_u8_DQUOTE] = ACTIONS(3121),
    [anon_sym_DQUOTE] = ACTIONS(3121),
    [sym_true] = ACTIONS(3123),
    [sym_false] = ACTIONS(3123),
    [anon_sym_NULL] = ACTIONS(3123),
    [anon_sym_nullptr] = ACTIONS(3123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3123),
    [anon_sym_decltype] = ACTIONS(3123),
    [anon_sym_explicit] = ACTIONS(3123),
    [anon_sym_typename] = ACTIONS(3123),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_module] = ACTIONS(3123),
    [anon_sym_import] = ACTIONS(3123),
    [anon_sym_template] = ACTIONS(3123),
    [anon_sym_operator] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_delete] = ACTIONS(3123),
    [anon_sym_throw] = ACTIONS(3123),
    [anon_sym_namespace] = ACTIONS(3123),
    [anon_sym_static_assert] = ACTIONS(3123),
    [anon_sym_concept] = ACTIONS(3123),
    [anon_sym_co_return] = ACTIONS(3123),
    [anon_sym_co_yield] = ACTIONS(3123),
    [anon_sym_R_DQUOTE] = ACTIONS(3121),
    [anon_sym_LR_DQUOTE] = ACTIONS(3121),
    [anon_sym_uR_DQUOTE] = ACTIONS(3121),
    [anon_sym_UR_DQUOTE] = ACTIONS(3121),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3121),
    [anon_sym_co_await] = ACTIONS(3123),
    [anon_sym_new] = ACTIONS(3123),
    [anon_sym_requires] = ACTIONS(3123),
    [sym_this] = ACTIONS(3123),
    [anon_sym_precise] = ACTIONS(3123),
    [anon_sym_shared] = ACTIONS(3123),
    [anon_sym_groupshared] = ACTIONS(3123),
    [anon_sym_uniform] = ACTIONS(3123),
    [anon_sym_row_major] = ACTIONS(3123),
    [anon_sym_column_major] = ACTIONS(3123),
    [anon_sym_globallycoherent] = ACTIONS(3123),
    [anon_sym_centroid] = ACTIONS(3123),
    [anon_sym_noperspective] = ACTIONS(3123),
    [anon_sym_nointerpolation] = ACTIONS(3123),
    [anon_sym_sample] = ACTIONS(3123),
    [anon_sym_linear] = ACTIONS(3123),
    [anon_sym_snorm] = ACTIONS(3123),
    [anon_sym_unorm] = ACTIONS(3123),
    [anon_sym_point] = ACTIONS(3123),
    [anon_sym_line] = ACTIONS(3123),
    [anon_sym_triangleadj] = ACTIONS(3123),
    [anon_sym_lineadj] = ACTIONS(3123),
    [anon_sym_triangle] = ACTIONS(3123),
  },
  [830] = {
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_include_token1] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym___cdecl] = ACTIONS(2596),
    [anon_sym___clrcall] = ACTIONS(2596),
    [anon_sym___stdcall] = ACTIONS(2596),
    [anon_sym___fastcall] = ACTIONS(2596),
    [anon_sym___thiscall] = ACTIONS(2596),
    [anon_sym___vectorcall] = ACTIONS(2596),
    [anon_sym_LBRACE] = ACTIONS(2598),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2596),
    [anon_sym_default] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [anon_sym_do] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_break] = ACTIONS(2596),
    [anon_sym_continue] = ACTIONS(2596),
    [anon_sym_goto] = ACTIONS(2596),
    [anon_sym_not] = ACTIONS(2596),
    [anon_sym_compl] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_sizeof] = ACTIONS(2596),
    [anon_sym___alignof__] = ACTIONS(2596),
    [anon_sym___alignof] = ACTIONS(2596),
    [anon_sym__alignof] = ACTIONS(2596),
    [anon_sym_alignof] = ACTIONS(2596),
    [anon_sym__Alignof] = ACTIONS(2596),
    [anon_sym_offsetof] = ACTIONS(2596),
    [anon_sym__Generic] = ACTIONS(2596),
    [anon_sym_asm] = ACTIONS(2596),
    [anon_sym___asm__] = ACTIONS(2596),
    [anon_sym___asm] = ACTIONS(2596),
    [sym_number_literal] = ACTIONS(2598),
    [anon_sym_L_SQUOTE] = ACTIONS(2598),
    [anon_sym_u_SQUOTE] = ACTIONS(2598),
    [anon_sym_U_SQUOTE] = ACTIONS(2598),
    [anon_sym_u8_SQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_L_DQUOTE] = ACTIONS(2598),
    [anon_sym_u_DQUOTE] = ACTIONS(2598),
    [anon_sym_U_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8_DQUOTE] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [anon_sym_NULL] = ACTIONS(2596),
    [anon_sym_nullptr] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_throw] = ACTIONS(2596),
    [anon_sym_namespace] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_concept] = ACTIONS(2596),
    [anon_sym_co_return] = ACTIONS(2596),
    [anon_sym_co_yield] = ACTIONS(2596),
    [anon_sym_R_DQUOTE] = ACTIONS(2598),
    [anon_sym_LR_DQUOTE] = ACTIONS(2598),
    [anon_sym_uR_DQUOTE] = ACTIONS(2598),
    [anon_sym_UR_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2598),
    [anon_sym_co_await] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_requires] = ACTIONS(2596),
    [sym_this] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [831] = {
    [ts_builtin_sym_end] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_include_token1] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym___cdecl] = ACTIONS(2404),
    [anon_sym___clrcall] = ACTIONS(2404),
    [anon_sym___stdcall] = ACTIONS(2404),
    [anon_sym___fastcall] = ACTIONS(2404),
    [anon_sym___thiscall] = ACTIONS(2404),
    [anon_sym___vectorcall] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_goto] = ACTIONS(2404),
    [anon_sym_not] = ACTIONS(2404),
    [anon_sym_compl] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2404),
    [anon_sym___alignof__] = ACTIONS(2404),
    [anon_sym___alignof] = ACTIONS(2404),
    [anon_sym__alignof] = ACTIONS(2404),
    [anon_sym_alignof] = ACTIONS(2404),
    [anon_sym__Alignof] = ACTIONS(2404),
    [anon_sym_offsetof] = ACTIONS(2404),
    [anon_sym__Generic] = ACTIONS(2404),
    [anon_sym_asm] = ACTIONS(2404),
    [anon_sym___asm__] = ACTIONS(2404),
    [anon_sym___asm] = ACTIONS(2404),
    [sym_number_literal] = ACTIONS(2406),
    [anon_sym_L_SQUOTE] = ACTIONS(2406),
    [anon_sym_u_SQUOTE] = ACTIONS(2406),
    [anon_sym_U_SQUOTE] = ACTIONS(2406),
    [anon_sym_u8_SQUOTE] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2406),
    [anon_sym_L_DQUOTE] = ACTIONS(2406),
    [anon_sym_u_DQUOTE] = ACTIONS(2406),
    [anon_sym_U_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8_DQUOTE] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [sym_true] = ACTIONS(2404),
    [sym_false] = ACTIONS(2404),
    [anon_sym_NULL] = ACTIONS(2404),
    [anon_sym_nullptr] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_concept] = ACTIONS(2404),
    [anon_sym_co_return] = ACTIONS(2404),
    [anon_sym_co_yield] = ACTIONS(2404),
    [anon_sym_R_DQUOTE] = ACTIONS(2406),
    [anon_sym_LR_DQUOTE] = ACTIONS(2406),
    [anon_sym_uR_DQUOTE] = ACTIONS(2406),
    [anon_sym_UR_DQUOTE] = ACTIONS(2406),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2406),
    [anon_sym_co_await] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_requires] = ACTIONS(2404),
    [sym_this] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
  },
  [832] = {
    [ts_builtin_sym_end] = ACTIONS(2666),
    [sym_identifier] = ACTIONS(2664),
    [aux_sym_preproc_include_token1] = ACTIONS(2664),
    [aux_sym_preproc_def_token1] = ACTIONS(2664),
    [aux_sym_preproc_if_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2664),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2664),
    [sym_preproc_directive] = ACTIONS(2664),
    [anon_sym_LPAREN2] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2664),
    [anon_sym_STAR] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_AMP] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym___extension__] = ACTIONS(2664),
    [anon_sym_typedef] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2664),
    [anon_sym_out] = ACTIONS(2664),
    [anon_sym_inout] = ACTIONS(2664),
    [anon_sym_virtual] = ACTIONS(2664),
    [anon_sym_extern] = ACTIONS(2664),
    [anon_sym___attribute__] = ACTIONS(2664),
    [anon_sym___attribute] = ACTIONS(2664),
    [anon_sym_using] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2666),
    [anon_sym___declspec] = ACTIONS(2664),
    [anon_sym___based] = ACTIONS(2664),
    [anon_sym___cdecl] = ACTIONS(2664),
    [anon_sym___clrcall] = ACTIONS(2664),
    [anon_sym___stdcall] = ACTIONS(2664),
    [anon_sym___fastcall] = ACTIONS(2664),
    [anon_sym___thiscall] = ACTIONS(2664),
    [anon_sym___vectorcall] = ACTIONS(2664),
    [anon_sym_LBRACE] = ACTIONS(2666),
    [anon_sym_signed] = ACTIONS(2664),
    [anon_sym_unsigned] = ACTIONS(2664),
    [anon_sym_long] = ACTIONS(2664),
    [anon_sym_short] = ACTIONS(2664),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2664),
    [anon_sym_register] = ACTIONS(2664),
    [anon_sym_inline] = ACTIONS(2664),
    [anon_sym___inline] = ACTIONS(2664),
    [anon_sym___inline__] = ACTIONS(2664),
    [anon_sym___forceinline] = ACTIONS(2664),
    [anon_sym_thread_local] = ACTIONS(2664),
    [anon_sym___thread] = ACTIONS(2664),
    [anon_sym_const] = ACTIONS(2664),
    [anon_sym_constexpr] = ACTIONS(2664),
    [anon_sym_volatile] = ACTIONS(2664),
    [anon_sym_restrict] = ACTIONS(2664),
    [anon_sym___restrict__] = ACTIONS(2664),
    [anon_sym__Atomic] = ACTIONS(2664),
    [anon_sym__Noreturn] = ACTIONS(2664),
    [anon_sym_noreturn] = ACTIONS(2664),
    [anon_sym__Nonnull] = ACTIONS(2664),
    [anon_sym_mutable] = ACTIONS(2664),
    [anon_sym_constinit] = ACTIONS(2664),
    [anon_sym_consteval] = ACTIONS(2664),
    [anon_sym_alignas] = ACTIONS(2664),
    [anon_sym__Alignas] = ACTIONS(2664),
    [sym_primitive_type] = ACTIONS(2664),
    [anon_sym_enum] = ACTIONS(2664),
    [anon_sym_class] = ACTIONS(2664),
    [anon_sym_struct] = ACTIONS(2664),
    [anon_sym_union] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2664),
    [anon_sym_switch] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2664),
    [anon_sym_default] = ACTIONS(2664),
    [anon_sym_while] = ACTIONS(2664),
    [anon_sym_do] = ACTIONS(2664),
    [anon_sym_for] = ACTIONS(2664),
    [anon_sym_return] = ACTIONS(2664),
    [anon_sym_break] = ACTIONS(2664),
    [anon_sym_continue] = ACTIONS(2664),
    [anon_sym_goto] = ACTIONS(2664),
    [anon_sym_not] = ACTIONS(2664),
    [anon_sym_compl] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2666),
    [anon_sym_sizeof] = ACTIONS(2664),
    [anon_sym___alignof__] = ACTIONS(2664),
    [anon_sym___alignof] = ACTIONS(2664),
    [anon_sym__alignof] = ACTIONS(2664),
    [anon_sym_alignof] = ACTIONS(2664),
    [anon_sym__Alignof] = ACTIONS(2664),
    [anon_sym_offsetof] = ACTIONS(2664),
    [anon_sym__Generic] = ACTIONS(2664),
    [anon_sym_asm] = ACTIONS(2664),
    [anon_sym___asm__] = ACTIONS(2664),
    [anon_sym___asm] = ACTIONS(2664),
    [sym_number_literal] = ACTIONS(2666),
    [anon_sym_L_SQUOTE] = ACTIONS(2666),
    [anon_sym_u_SQUOTE] = ACTIONS(2666),
    [anon_sym_U_SQUOTE] = ACTIONS(2666),
    [anon_sym_u8_SQUOTE] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_L_DQUOTE] = ACTIONS(2666),
    [anon_sym_u_DQUOTE] = ACTIONS(2666),
    [anon_sym_U_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2666),
    [sym_true] = ACTIONS(2664),
    [sym_false] = ACTIONS(2664),
    [anon_sym_NULL] = ACTIONS(2664),
    [anon_sym_nullptr] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2664),
    [anon_sym_decltype] = ACTIONS(2664),
    [anon_sym_explicit] = ACTIONS(2664),
    [anon_sym_typename] = ACTIONS(2664),
    [anon_sym_export] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(2664),
    [anon_sym_import] = ACTIONS(2664),
    [anon_sym_template] = ACTIONS(2664),
    [anon_sym_operator] = ACTIONS(2664),
    [anon_sym_try] = ACTIONS(2664),
    [anon_sym_delete] = ACTIONS(2664),
    [anon_sym_throw] = ACTIONS(2664),
    [anon_sym_namespace] = ACTIONS(2664),
    [anon_sym_static_assert] = ACTIONS(2664),
    [anon_sym_concept] = ACTIONS(2664),
    [anon_sym_co_return] = ACTIONS(2664),
    [anon_sym_co_yield] = ACTIONS(2664),
    [anon_sym_R_DQUOTE] = ACTIONS(2666),
    [anon_sym_LR_DQUOTE] = ACTIONS(2666),
    [anon_sym_uR_DQUOTE] = ACTIONS(2666),
    [anon_sym_UR_DQUOTE] = ACTIONS(2666),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2666),
    [anon_sym_co_await] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(2664),
    [anon_sym_requires] = ACTIONS(2664),
    [sym_this] = ACTIONS(2664),
    [anon_sym_precise] = ACTIONS(2664),
    [anon_sym_shared] = ACTIONS(2664),
    [anon_sym_groupshared] = ACTIONS(2664),
    [anon_sym_uniform] = ACTIONS(2664),
    [anon_sym_row_major] = ACTIONS(2664),
    [anon_sym_column_major] = ACTIONS(2664),
    [anon_sym_globallycoherent] = ACTIONS(2664),
    [anon_sym_centroid] = ACTIONS(2664),
    [anon_sym_noperspective] = ACTIONS(2664),
    [anon_sym_nointerpolation] = ACTIONS(2664),
    [anon_sym_sample] = ACTIONS(2664),
    [anon_sym_linear] = ACTIONS(2664),
    [anon_sym_snorm] = ACTIONS(2664),
    [anon_sym_unorm] = ACTIONS(2664),
    [anon_sym_point] = ACTIONS(2664),
    [anon_sym_line] = ACTIONS(2664),
    [anon_sym_triangleadj] = ACTIONS(2664),
    [anon_sym_lineadj] = ACTIONS(2664),
    [anon_sym_triangle] = ACTIONS(2664),
  },
  [833] = {
    [ts_builtin_sym_end] = ACTIONS(2614),
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_include_token1] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym___cdecl] = ACTIONS(2612),
    [anon_sym___clrcall] = ACTIONS(2612),
    [anon_sym___stdcall] = ACTIONS(2612),
    [anon_sym___fastcall] = ACTIONS(2612),
    [anon_sym___thiscall] = ACTIONS(2612),
    [anon_sym___vectorcall] = ACTIONS(2612),
    [anon_sym_LBRACE] = ACTIONS(2614),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_switch] = ACTIONS(2612),
    [anon_sym_case] = ACTIONS(2612),
    [anon_sym_default] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [anon_sym_do] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_break] = ACTIONS(2612),
    [anon_sym_continue] = ACTIONS(2612),
    [anon_sym_goto] = ACTIONS(2612),
    [anon_sym_not] = ACTIONS(2612),
    [anon_sym_compl] = ACTIONS(2612),
    [anon_sym_DASH_DASH] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2614),
    [anon_sym_sizeof] = ACTIONS(2612),
    [anon_sym___alignof__] = ACTIONS(2612),
    [anon_sym___alignof] = ACTIONS(2612),
    [anon_sym__alignof] = ACTIONS(2612),
    [anon_sym_alignof] = ACTIONS(2612),
    [anon_sym__Alignof] = ACTIONS(2612),
    [anon_sym_offsetof] = ACTIONS(2612),
    [anon_sym__Generic] = ACTIONS(2612),
    [anon_sym_asm] = ACTIONS(2612),
    [anon_sym___asm__] = ACTIONS(2612),
    [anon_sym___asm] = ACTIONS(2612),
    [sym_number_literal] = ACTIONS(2614),
    [anon_sym_L_SQUOTE] = ACTIONS(2614),
    [anon_sym_u_SQUOTE] = ACTIONS(2614),
    [anon_sym_U_SQUOTE] = ACTIONS(2614),
    [anon_sym_u8_SQUOTE] = ACTIONS(2614),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_L_DQUOTE] = ACTIONS(2614),
    [anon_sym_u_DQUOTE] = ACTIONS(2614),
    [anon_sym_U_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8_DQUOTE] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2614),
    [sym_true] = ACTIONS(2612),
    [sym_false] = ACTIONS(2612),
    [anon_sym_NULL] = ACTIONS(2612),
    [anon_sym_nullptr] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_delete] = ACTIONS(2612),
    [anon_sym_throw] = ACTIONS(2612),
    [anon_sym_namespace] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_concept] = ACTIONS(2612),
    [anon_sym_co_return] = ACTIONS(2612),
    [anon_sym_co_yield] = ACTIONS(2612),
    [anon_sym_R_DQUOTE] = ACTIONS(2614),
    [anon_sym_LR_DQUOTE] = ACTIONS(2614),
    [anon_sym_uR_DQUOTE] = ACTIONS(2614),
    [anon_sym_UR_DQUOTE] = ACTIONS(2614),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2614),
    [anon_sym_co_await] = ACTIONS(2612),
    [anon_sym_new] = ACTIONS(2612),
    [anon_sym_requires] = ACTIONS(2612),
    [sym_this] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
  },
  [834] = {
    [ts_builtin_sym_end] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_include_token1] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2652),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym___cdecl] = ACTIONS(2652),
    [anon_sym___clrcall] = ACTIONS(2652),
    [anon_sym___stdcall] = ACTIONS(2652),
    [anon_sym___fastcall] = ACTIONS(2652),
    [anon_sym___thiscall] = ACTIONS(2652),
    [anon_sym___vectorcall] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [anon_sym_if] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2652),
    [anon_sym_default] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_do] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2652),
    [anon_sym_return] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2652),
    [anon_sym_continue] = ACTIONS(2652),
    [anon_sym_goto] = ACTIONS(2652),
    [anon_sym_not] = ACTIONS(2652),
    [anon_sym_compl] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2654),
    [anon_sym_sizeof] = ACTIONS(2652),
    [anon_sym___alignof__] = ACTIONS(2652),
    [anon_sym___alignof] = ACTIONS(2652),
    [anon_sym__alignof] = ACTIONS(2652),
    [anon_sym_alignof] = ACTIONS(2652),
    [anon_sym__Alignof] = ACTIONS(2652),
    [anon_sym_offsetof] = ACTIONS(2652),
    [anon_sym__Generic] = ACTIONS(2652),
    [anon_sym_asm] = ACTIONS(2652),
    [anon_sym___asm__] = ACTIONS(2652),
    [anon_sym___asm] = ACTIONS(2652),
    [sym_number_literal] = ACTIONS(2654),
    [anon_sym_L_SQUOTE] = ACTIONS(2654),
    [anon_sym_u_SQUOTE] = ACTIONS(2654),
    [anon_sym_U_SQUOTE] = ACTIONS(2654),
    [anon_sym_u8_SQUOTE] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2654),
    [anon_sym_L_DQUOTE] = ACTIONS(2654),
    [anon_sym_u_DQUOTE] = ACTIONS(2654),
    [anon_sym_U_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8_DQUOTE] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2654),
    [sym_true] = ACTIONS(2652),
    [sym_false] = ACTIONS(2652),
    [anon_sym_NULL] = ACTIONS(2652),
    [anon_sym_nullptr] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_export] = ACTIONS(2652),
    [anon_sym_module] = ACTIONS(2652),
    [anon_sym_import] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2652),
    [anon_sym_delete] = ACTIONS(2652),
    [anon_sym_throw] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_concept] = ACTIONS(2652),
    [anon_sym_co_return] = ACTIONS(2652),
    [anon_sym_co_yield] = ACTIONS(2652),
    [anon_sym_R_DQUOTE] = ACTIONS(2654),
    [anon_sym_LR_DQUOTE] = ACTIONS(2654),
    [anon_sym_uR_DQUOTE] = ACTIONS(2654),
    [anon_sym_UR_DQUOTE] = ACTIONS(2654),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2654),
    [anon_sym_co_await] = ACTIONS(2652),
    [anon_sym_new] = ACTIONS(2652),
    [anon_sym_requires] = ACTIONS(2652),
    [sym_this] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
  },
  [835] = {
    [ts_builtin_sym_end] = ACTIONS(2670),
    [sym_identifier] = ACTIONS(2668),
    [aux_sym_preproc_include_token1] = ACTIONS(2668),
    [aux_sym_preproc_def_token1] = ACTIONS(2668),
    [aux_sym_preproc_if_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2668),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2668),
    [sym_preproc_directive] = ACTIONS(2668),
    [anon_sym_LPAREN2] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2668),
    [anon_sym_STAR] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_AMP] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym___extension__] = ACTIONS(2668),
    [anon_sym_typedef] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2668),
    [anon_sym_out] = ACTIONS(2668),
    [anon_sym_inout] = ACTIONS(2668),
    [anon_sym_virtual] = ACTIONS(2668),
    [anon_sym_extern] = ACTIONS(2668),
    [anon_sym___attribute__] = ACTIONS(2668),
    [anon_sym___attribute] = ACTIONS(2668),
    [anon_sym_using] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2670),
    [anon_sym___declspec] = ACTIONS(2668),
    [anon_sym___based] = ACTIONS(2668),
    [anon_sym___cdecl] = ACTIONS(2668),
    [anon_sym___clrcall] = ACTIONS(2668),
    [anon_sym___stdcall] = ACTIONS(2668),
    [anon_sym___fastcall] = ACTIONS(2668),
    [anon_sym___thiscall] = ACTIONS(2668),
    [anon_sym___vectorcall] = ACTIONS(2668),
    [anon_sym_LBRACE] = ACTIONS(2670),
    [anon_sym_signed] = ACTIONS(2668),
    [anon_sym_unsigned] = ACTIONS(2668),
    [anon_sym_long] = ACTIONS(2668),
    [anon_sym_short] = ACTIONS(2668),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2668),
    [anon_sym_register] = ACTIONS(2668),
    [anon_sym_inline] = ACTIONS(2668),
    [anon_sym___inline] = ACTIONS(2668),
    [anon_sym___inline__] = ACTIONS(2668),
    [anon_sym___forceinline] = ACTIONS(2668),
    [anon_sym_thread_local] = ACTIONS(2668),
    [anon_sym___thread] = ACTIONS(2668),
    [anon_sym_const] = ACTIONS(2668),
    [anon_sym_constexpr] = ACTIONS(2668),
    [anon_sym_volatile] = ACTIONS(2668),
    [anon_sym_restrict] = ACTIONS(2668),
    [anon_sym___restrict__] = ACTIONS(2668),
    [anon_sym__Atomic] = ACTIONS(2668),
    [anon_sym__Noreturn] = ACTIONS(2668),
    [anon_sym_noreturn] = ACTIONS(2668),
    [anon_sym__Nonnull] = ACTIONS(2668),
    [anon_sym_mutable] = ACTIONS(2668),
    [anon_sym_constinit] = ACTIONS(2668),
    [anon_sym_consteval] = ACTIONS(2668),
    [anon_sym_alignas] = ACTIONS(2668),
    [anon_sym__Alignas] = ACTIONS(2668),
    [sym_primitive_type] = ACTIONS(2668),
    [anon_sym_enum] = ACTIONS(2668),
    [anon_sym_class] = ACTIONS(2668),
    [anon_sym_struct] = ACTIONS(2668),
    [anon_sym_union] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2668),
    [anon_sym_switch] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2668),
    [anon_sym_default] = ACTIONS(2668),
    [anon_sym_while] = ACTIONS(2668),
    [anon_sym_do] = ACTIONS(2668),
    [anon_sym_for] = ACTIONS(2668),
    [anon_sym_return] = ACTIONS(2668),
    [anon_sym_break] = ACTIONS(2668),
    [anon_sym_continue] = ACTIONS(2668),
    [anon_sym_goto] = ACTIONS(2668),
    [anon_sym_not] = ACTIONS(2668),
    [anon_sym_compl] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2670),
    [anon_sym_sizeof] = ACTIONS(2668),
    [anon_sym___alignof__] = ACTIONS(2668),
    [anon_sym___alignof] = ACTIONS(2668),
    [anon_sym__alignof] = ACTIONS(2668),
    [anon_sym_alignof] = ACTIONS(2668),
    [anon_sym__Alignof] = ACTIONS(2668),
    [anon_sym_offsetof] = ACTIONS(2668),
    [anon_sym__Generic] = ACTIONS(2668),
    [anon_sym_asm] = ACTIONS(2668),
    [anon_sym___asm__] = ACTIONS(2668),
    [anon_sym___asm] = ACTIONS(2668),
    [sym_number_literal] = ACTIONS(2670),
    [anon_sym_L_SQUOTE] = ACTIONS(2670),
    [anon_sym_u_SQUOTE] = ACTIONS(2670),
    [anon_sym_U_SQUOTE] = ACTIONS(2670),
    [anon_sym_u8_SQUOTE] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_L_DQUOTE] = ACTIONS(2670),
    [anon_sym_u_DQUOTE] = ACTIONS(2670),
    [anon_sym_U_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8_DQUOTE] = ACTIONS(2670),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [sym_true] = ACTIONS(2668),
    [sym_false] = ACTIONS(2668),
    [anon_sym_NULL] = ACTIONS(2668),
    [anon_sym_nullptr] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2668),
    [anon_sym_decltype] = ACTIONS(2668),
    [anon_sym_explicit] = ACTIONS(2668),
    [anon_sym_typename] = ACTIONS(2668),
    [anon_sym_export] = ACTIONS(2668),
    [anon_sym_module] = ACTIONS(2668),
    [anon_sym_import] = ACTIONS(2668),
    [anon_sym_template] = ACTIONS(2668),
    [anon_sym_operator] = ACTIONS(2668),
    [anon_sym_try] = ACTIONS(2668),
    [anon_sym_delete] = ACTIONS(2668),
    [anon_sym_throw] = ACTIONS(2668),
    [anon_sym_namespace] = ACTIONS(2668),
    [anon_sym_static_assert] = ACTIONS(2668),
    [anon_sym_concept] = ACTIONS(2668),
    [anon_sym_co_return] = ACTIONS(2668),
    [anon_sym_co_yield] = ACTIONS(2668),
    [anon_sym_R_DQUOTE] = ACTIONS(2670),
    [anon_sym_LR_DQUOTE] = ACTIONS(2670),
    [anon_sym_uR_DQUOTE] = ACTIONS(2670),
    [anon_sym_UR_DQUOTE] = ACTIONS(2670),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2670),
    [anon_sym_co_await] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(2668),
    [anon_sym_requires] = ACTIONS(2668),
    [sym_this] = ACTIONS(2668),
    [anon_sym_precise] = ACTIONS(2668),
    [anon_sym_shared] = ACTIONS(2668),
    [anon_sym_groupshared] = ACTIONS(2668),
    [anon_sym_uniform] = ACTIONS(2668),
    [anon_sym_row_major] = ACTIONS(2668),
    [anon_sym_column_major] = ACTIONS(2668),
    [anon_sym_globallycoherent] = ACTIONS(2668),
    [anon_sym_centroid] = ACTIONS(2668),
    [anon_sym_noperspective] = ACTIONS(2668),
    [anon_sym_nointerpolation] = ACTIONS(2668),
    [anon_sym_sample] = ACTIONS(2668),
    [anon_sym_linear] = ACTIONS(2668),
    [anon_sym_snorm] = ACTIONS(2668),
    [anon_sym_unorm] = ACTIONS(2668),
    [anon_sym_point] = ACTIONS(2668),
    [anon_sym_line] = ACTIONS(2668),
    [anon_sym_triangleadj] = ACTIONS(2668),
    [anon_sym_lineadj] = ACTIONS(2668),
    [anon_sym_triangle] = ACTIONS(2668),
  },
  [836] = {
    [ts_builtin_sym_end] = ACTIONS(2606),
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_include_token1] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2604),
    [anon_sym_PLUS] = ACTIONS(2604),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym___cdecl] = ACTIONS(2604),
    [anon_sym___clrcall] = ACTIONS(2604),
    [anon_sym___stdcall] = ACTIONS(2604),
    [anon_sym___fastcall] = ACTIONS(2604),
    [anon_sym___thiscall] = ACTIONS(2604),
    [anon_sym___vectorcall] = ACTIONS(2604),
    [anon_sym_LBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [anon_sym_if] = ACTIONS(2604),
    [anon_sym_switch] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2604),
    [anon_sym_default] = ACTIONS(2604),
    [anon_sym_while] = ACTIONS(2604),
    [anon_sym_do] = ACTIONS(2604),
    [anon_sym_for] = ACTIONS(2604),
    [anon_sym_return] = ACTIONS(2604),
    [anon_sym_break] = ACTIONS(2604),
    [anon_sym_continue] = ACTIONS(2604),
    [anon_sym_goto] = ACTIONS(2604),
    [anon_sym_not] = ACTIONS(2604),
    [anon_sym_compl] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2606),
    [anon_sym_sizeof] = ACTIONS(2604),
    [anon_sym___alignof__] = ACTIONS(2604),
    [anon_sym___alignof] = ACTIONS(2604),
    [anon_sym__alignof] = ACTIONS(2604),
    [anon_sym_alignof] = ACTIONS(2604),
    [anon_sym__Alignof] = ACTIONS(2604),
    [anon_sym_offsetof] = ACTIONS(2604),
    [anon_sym__Generic] = ACTIONS(2604),
    [anon_sym_asm] = ACTIONS(2604),
    [anon_sym___asm__] = ACTIONS(2604),
    [anon_sym___asm] = ACTIONS(2604),
    [sym_number_literal] = ACTIONS(2606),
    [anon_sym_L_SQUOTE] = ACTIONS(2606),
    [anon_sym_u_SQUOTE] = ACTIONS(2606),
    [anon_sym_U_SQUOTE] = ACTIONS(2606),
    [anon_sym_u8_SQUOTE] = ACTIONS(2606),
    [anon_sym_SQUOTE] = ACTIONS(2606),
    [anon_sym_L_DQUOTE] = ACTIONS(2606),
    [anon_sym_u_DQUOTE] = ACTIONS(2606),
    [anon_sym_U_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8_DQUOTE] = ACTIONS(2606),
    [anon_sym_DQUOTE] = ACTIONS(2606),
    [sym_true] = ACTIONS(2604),
    [sym_false] = ACTIONS(2604),
    [anon_sym_NULL] = ACTIONS(2604),
    [anon_sym_nullptr] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_export] = ACTIONS(2604),
    [anon_sym_module] = ACTIONS(2604),
    [anon_sym_import] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_try] = ACTIONS(2604),
    [anon_sym_delete] = ACTIONS(2604),
    [anon_sym_throw] = ACTIONS(2604),
    [anon_sym_namespace] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_concept] = ACTIONS(2604),
    [anon_sym_co_return] = ACTIONS(2604),
    [anon_sym_co_yield] = ACTIONS(2604),
    [anon_sym_R_DQUOTE] = ACTIONS(2606),
    [anon_sym_LR_DQUOTE] = ACTIONS(2606),
    [anon_sym_uR_DQUOTE] = ACTIONS(2606),
    [anon_sym_UR_DQUOTE] = ACTIONS(2606),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2606),
    [anon_sym_co_await] = ACTIONS(2604),
    [anon_sym_new] = ACTIONS(2604),
    [anon_sym_requires] = ACTIONS(2604),
    [sym_this] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [837] = {
    [ts_builtin_sym_end] = ACTIONS(2678),
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [838] = {
    [ts_builtin_sym_end] = ACTIONS(2506),
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_include_token1] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym___cdecl] = ACTIONS(2504),
    [anon_sym___clrcall] = ACTIONS(2504),
    [anon_sym___stdcall] = ACTIONS(2504),
    [anon_sym___fastcall] = ACTIONS(2504),
    [anon_sym___thiscall] = ACTIONS(2504),
    [anon_sym___vectorcall] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2504),
    [anon_sym_switch] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2504),
    [anon_sym_default] = ACTIONS(2504),
    [anon_sym_while] = ACTIONS(2504),
    [anon_sym_do] = ACTIONS(2504),
    [anon_sym_for] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2504),
    [anon_sym_break] = ACTIONS(2504),
    [anon_sym_continue] = ACTIONS(2504),
    [anon_sym_goto] = ACTIONS(2504),
    [anon_sym_not] = ACTIONS(2504),
    [anon_sym_compl] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(2504),
    [anon_sym___alignof] = ACTIONS(2504),
    [anon_sym__alignof] = ACTIONS(2504),
    [anon_sym_alignof] = ACTIONS(2504),
    [anon_sym__Alignof] = ACTIONS(2504),
    [anon_sym_offsetof] = ACTIONS(2504),
    [anon_sym__Generic] = ACTIONS(2504),
    [anon_sym_asm] = ACTIONS(2504),
    [anon_sym___asm__] = ACTIONS(2504),
    [anon_sym___asm] = ACTIONS(2504),
    [sym_number_literal] = ACTIONS(2506),
    [anon_sym_L_SQUOTE] = ACTIONS(2506),
    [anon_sym_u_SQUOTE] = ACTIONS(2506),
    [anon_sym_U_SQUOTE] = ACTIONS(2506),
    [anon_sym_u8_SQUOTE] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_L_DQUOTE] = ACTIONS(2506),
    [anon_sym_u_DQUOTE] = ACTIONS(2506),
    [anon_sym_U_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8_DQUOTE] = ACTIONS(2506),
    [anon_sym_DQUOTE] = ACTIONS(2506),
    [sym_true] = ACTIONS(2504),
    [sym_false] = ACTIONS(2504),
    [anon_sym_NULL] = ACTIONS(2504),
    [anon_sym_nullptr] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_export] = ACTIONS(2504),
    [anon_sym_module] = ACTIONS(2504),
    [anon_sym_import] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_try] = ACTIONS(2504),
    [anon_sym_delete] = ACTIONS(2504),
    [anon_sym_throw] = ACTIONS(2504),
    [anon_sym_namespace] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_concept] = ACTIONS(2504),
    [anon_sym_co_return] = ACTIONS(2504),
    [anon_sym_co_yield] = ACTIONS(2504),
    [anon_sym_R_DQUOTE] = ACTIONS(2506),
    [anon_sym_LR_DQUOTE] = ACTIONS(2506),
    [anon_sym_uR_DQUOTE] = ACTIONS(2506),
    [anon_sym_UR_DQUOTE] = ACTIONS(2506),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2506),
    [anon_sym_co_await] = ACTIONS(2504),
    [anon_sym_new] = ACTIONS(2504),
    [anon_sym_requires] = ACTIONS(2504),
    [sym_this] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
  },
  [839] = {
    [ts_builtin_sym_end] = ACTIONS(2546),
    [sym_identifier] = ACTIONS(2544),
    [aux_sym_preproc_include_token1] = ACTIONS(2544),
    [aux_sym_preproc_def_token1] = ACTIONS(2544),
    [aux_sym_preproc_if_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2544),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2544),
    [sym_preproc_directive] = ACTIONS(2544),
    [anon_sym_LPAREN2] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2544),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym___extension__] = ACTIONS(2544),
    [anon_sym_typedef] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2544),
    [anon_sym_out] = ACTIONS(2544),
    [anon_sym_inout] = ACTIONS(2544),
    [anon_sym_virtual] = ACTIONS(2544),
    [anon_sym_extern] = ACTIONS(2544),
    [anon_sym___attribute__] = ACTIONS(2544),
    [anon_sym___attribute] = ACTIONS(2544),
    [anon_sym_using] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2546),
    [anon_sym___declspec] = ACTIONS(2544),
    [anon_sym___based] = ACTIONS(2544),
    [anon_sym___cdecl] = ACTIONS(2544),
    [anon_sym___clrcall] = ACTIONS(2544),
    [anon_sym___stdcall] = ACTIONS(2544),
    [anon_sym___fastcall] = ACTIONS(2544),
    [anon_sym___thiscall] = ACTIONS(2544),
    [anon_sym___vectorcall] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(2546),
    [anon_sym_signed] = ACTIONS(2544),
    [anon_sym_unsigned] = ACTIONS(2544),
    [anon_sym_long] = ACTIONS(2544),
    [anon_sym_short] = ACTIONS(2544),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2544),
    [anon_sym_register] = ACTIONS(2544),
    [anon_sym_inline] = ACTIONS(2544),
    [anon_sym___inline] = ACTIONS(2544),
    [anon_sym___inline__] = ACTIONS(2544),
    [anon_sym___forceinline] = ACTIONS(2544),
    [anon_sym_thread_local] = ACTIONS(2544),
    [anon_sym___thread] = ACTIONS(2544),
    [anon_sym_const] = ACTIONS(2544),
    [anon_sym_constexpr] = ACTIONS(2544),
    [anon_sym_volatile] = ACTIONS(2544),
    [anon_sym_restrict] = ACTIONS(2544),
    [anon_sym___restrict__] = ACTIONS(2544),
    [anon_sym__Atomic] = ACTIONS(2544),
    [anon_sym__Noreturn] = ACTIONS(2544),
    [anon_sym_noreturn] = ACTIONS(2544),
    [anon_sym__Nonnull] = ACTIONS(2544),
    [anon_sym_mutable] = ACTIONS(2544),
    [anon_sym_constinit] = ACTIONS(2544),
    [anon_sym_consteval] = ACTIONS(2544),
    [anon_sym_alignas] = ACTIONS(2544),
    [anon_sym__Alignas] = ACTIONS(2544),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2544),
    [anon_sym_class] = ACTIONS(2544),
    [anon_sym_struct] = ACTIONS(2544),
    [anon_sym_union] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2544),
    [anon_sym_switch] = ACTIONS(2544),
    [anon_sym_case] = ACTIONS(2544),
    [anon_sym_default] = ACTIONS(2544),
    [anon_sym_while] = ACTIONS(2544),
    [anon_sym_do] = ACTIONS(2544),
    [anon_sym_for] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2544),
    [anon_sym_break] = ACTIONS(2544),
    [anon_sym_continue] = ACTIONS(2544),
    [anon_sym_goto] = ACTIONS(2544),
    [anon_sym_not] = ACTIONS(2544),
    [anon_sym_compl] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2546),
    [anon_sym_sizeof] = ACTIONS(2544),
    [anon_sym___alignof__] = ACTIONS(2544),
    [anon_sym___alignof] = ACTIONS(2544),
    [anon_sym__alignof] = ACTIONS(2544),
    [anon_sym_alignof] = ACTIONS(2544),
    [anon_sym__Alignof] = ACTIONS(2544),
    [anon_sym_offsetof] = ACTIONS(2544),
    [anon_sym__Generic] = ACTIONS(2544),
    [anon_sym_asm] = ACTIONS(2544),
    [anon_sym___asm__] = ACTIONS(2544),
    [anon_sym___asm] = ACTIONS(2544),
    [sym_number_literal] = ACTIONS(2546),
    [anon_sym_L_SQUOTE] = ACTIONS(2546),
    [anon_sym_u_SQUOTE] = ACTIONS(2546),
    [anon_sym_U_SQUOTE] = ACTIONS(2546),
    [anon_sym_u8_SQUOTE] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_L_DQUOTE] = ACTIONS(2546),
    [anon_sym_u_DQUOTE] = ACTIONS(2546),
    [anon_sym_U_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8_DQUOTE] = ACTIONS(2546),
    [anon_sym_DQUOTE] = ACTIONS(2546),
    [sym_true] = ACTIONS(2544),
    [sym_false] = ACTIONS(2544),
    [anon_sym_NULL] = ACTIONS(2544),
    [anon_sym_nullptr] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2544),
    [anon_sym_decltype] = ACTIONS(2544),
    [anon_sym_explicit] = ACTIONS(2544),
    [anon_sym_typename] = ACTIONS(2544),
    [anon_sym_export] = ACTIONS(2544),
    [anon_sym_module] = ACTIONS(2544),
    [anon_sym_import] = ACTIONS(2544),
    [anon_sym_template] = ACTIONS(2544),
    [anon_sym_operator] = ACTIONS(2544),
    [anon_sym_try] = ACTIONS(2544),
    [anon_sym_delete] = ACTIONS(2544),
    [anon_sym_throw] = ACTIONS(2544),
    [anon_sym_namespace] = ACTIONS(2544),
    [anon_sym_static_assert] = ACTIONS(2544),
    [anon_sym_concept] = ACTIONS(2544),
    [anon_sym_co_return] = ACTIONS(2544),
    [anon_sym_co_yield] = ACTIONS(2544),
    [anon_sym_R_DQUOTE] = ACTIONS(2546),
    [anon_sym_LR_DQUOTE] = ACTIONS(2546),
    [anon_sym_uR_DQUOTE] = ACTIONS(2546),
    [anon_sym_UR_DQUOTE] = ACTIONS(2546),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2546),
    [anon_sym_co_await] = ACTIONS(2544),
    [anon_sym_new] = ACTIONS(2544),
    [anon_sym_requires] = ACTIONS(2544),
    [sym_this] = ACTIONS(2544),
    [anon_sym_precise] = ACTIONS(2544),
    [anon_sym_shared] = ACTIONS(2544),
    [anon_sym_groupshared] = ACTIONS(2544),
    [anon_sym_uniform] = ACTIONS(2544),
    [anon_sym_row_major] = ACTIONS(2544),
    [anon_sym_column_major] = ACTIONS(2544),
    [anon_sym_globallycoherent] = ACTIONS(2544),
    [anon_sym_centroid] = ACTIONS(2544),
    [anon_sym_noperspective] = ACTIONS(2544),
    [anon_sym_nointerpolation] = ACTIONS(2544),
    [anon_sym_sample] = ACTIONS(2544),
    [anon_sym_linear] = ACTIONS(2544),
    [anon_sym_snorm] = ACTIONS(2544),
    [anon_sym_unorm] = ACTIONS(2544),
    [anon_sym_point] = ACTIONS(2544),
    [anon_sym_line] = ACTIONS(2544),
    [anon_sym_triangleadj] = ACTIONS(2544),
    [anon_sym_lineadj] = ACTIONS(2544),
    [anon_sym_triangle] = ACTIONS(2544),
  },
  [840] = {
    [ts_builtin_sym_end] = ACTIONS(2510),
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_include_token1] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2508),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym___cdecl] = ACTIONS(2508),
    [anon_sym___clrcall] = ACTIONS(2508),
    [anon_sym___stdcall] = ACTIONS(2508),
    [anon_sym___fastcall] = ACTIONS(2508),
    [anon_sym___thiscall] = ACTIONS(2508),
    [anon_sym___vectorcall] = ACTIONS(2508),
    [anon_sym_LBRACE] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2508),
    [anon_sym_switch] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(2508),
    [anon_sym_default] = ACTIONS(2508),
    [anon_sym_while] = ACTIONS(2508),
    [anon_sym_do] = ACTIONS(2508),
    [anon_sym_for] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2508),
    [anon_sym_break] = ACTIONS(2508),
    [anon_sym_continue] = ACTIONS(2508),
    [anon_sym_goto] = ACTIONS(2508),
    [anon_sym_not] = ACTIONS(2508),
    [anon_sym_compl] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2508),
    [anon_sym___alignof__] = ACTIONS(2508),
    [anon_sym___alignof] = ACTIONS(2508),
    [anon_sym__alignof] = ACTIONS(2508),
    [anon_sym_alignof] = ACTIONS(2508),
    [anon_sym__Alignof] = ACTIONS(2508),
    [anon_sym_offsetof] = ACTIONS(2508),
    [anon_sym__Generic] = ACTIONS(2508),
    [anon_sym_asm] = ACTIONS(2508),
    [anon_sym___asm__] = ACTIONS(2508),
    [anon_sym___asm] = ACTIONS(2508),
    [sym_number_literal] = ACTIONS(2510),
    [anon_sym_L_SQUOTE] = ACTIONS(2510),
    [anon_sym_u_SQUOTE] = ACTIONS(2510),
    [anon_sym_U_SQUOTE] = ACTIONS(2510),
    [anon_sym_u8_SQUOTE] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_L_DQUOTE] = ACTIONS(2510),
    [anon_sym_u_DQUOTE] = ACTIONS(2510),
    [anon_sym_U_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8_DQUOTE] = ACTIONS(2510),
    [anon_sym_DQUOTE] = ACTIONS(2510),
    [sym_true] = ACTIONS(2508),
    [sym_false] = ACTIONS(2508),
    [anon_sym_NULL] = ACTIONS(2508),
    [anon_sym_nullptr] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_export] = ACTIONS(2508),
    [anon_sym_module] = ACTIONS(2508),
    [anon_sym_import] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_try] = ACTIONS(2508),
    [anon_sym_delete] = ACTIONS(2508),
    [anon_sym_throw] = ACTIONS(2508),
    [anon_sym_namespace] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_concept] = ACTIONS(2508),
    [anon_sym_co_return] = ACTIONS(2508),
    [anon_sym_co_yield] = ACTIONS(2508),
    [anon_sym_R_DQUOTE] = ACTIONS(2510),
    [anon_sym_LR_DQUOTE] = ACTIONS(2510),
    [anon_sym_uR_DQUOTE] = ACTIONS(2510),
    [anon_sym_UR_DQUOTE] = ACTIONS(2510),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2510),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(2508),
    [anon_sym_requires] = ACTIONS(2508),
    [sym_this] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
  },
  [841] = {
    [ts_builtin_sym_end] = ACTIONS(2678),
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_include_token1] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym___cdecl] = ACTIONS(2676),
    [anon_sym___clrcall] = ACTIONS(2676),
    [anon_sym___stdcall] = ACTIONS(2676),
    [anon_sym___fastcall] = ACTIONS(2676),
    [anon_sym___thiscall] = ACTIONS(2676),
    [anon_sym___vectorcall] = ACTIONS(2676),
    [anon_sym_LBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2676),
    [anon_sym_switch] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2676),
    [anon_sym_default] = ACTIONS(2676),
    [anon_sym_while] = ACTIONS(2676),
    [anon_sym_do] = ACTIONS(2676),
    [anon_sym_for] = ACTIONS(2676),
    [anon_sym_return] = ACTIONS(2676),
    [anon_sym_break] = ACTIONS(2676),
    [anon_sym_continue] = ACTIONS(2676),
    [anon_sym_goto] = ACTIONS(2676),
    [anon_sym_not] = ACTIONS(2676),
    [anon_sym_compl] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2678),
    [anon_sym_sizeof] = ACTIONS(2676),
    [anon_sym___alignof__] = ACTIONS(2676),
    [anon_sym___alignof] = ACTIONS(2676),
    [anon_sym__alignof] = ACTIONS(2676),
    [anon_sym_alignof] = ACTIONS(2676),
    [anon_sym__Alignof] = ACTIONS(2676),
    [anon_sym_offsetof] = ACTIONS(2676),
    [anon_sym__Generic] = ACTIONS(2676),
    [anon_sym_asm] = ACTIONS(2676),
    [anon_sym___asm__] = ACTIONS(2676),
    [anon_sym___asm] = ACTIONS(2676),
    [sym_number_literal] = ACTIONS(2678),
    [anon_sym_L_SQUOTE] = ACTIONS(2678),
    [anon_sym_u_SQUOTE] = ACTIONS(2678),
    [anon_sym_U_SQUOTE] = ACTIONS(2678),
    [anon_sym_u8_SQUOTE] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_L_DQUOTE] = ACTIONS(2678),
    [anon_sym_u_DQUOTE] = ACTIONS(2678),
    [anon_sym_U_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8_DQUOTE] = ACTIONS(2678),
    [anon_sym_DQUOTE] = ACTIONS(2678),
    [sym_true] = ACTIONS(2676),
    [sym_false] = ACTIONS(2676),
    [anon_sym_NULL] = ACTIONS(2676),
    [anon_sym_nullptr] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_export] = ACTIONS(2676),
    [anon_sym_module] = ACTIONS(2676),
    [anon_sym_import] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_try] = ACTIONS(2676),
    [anon_sym_delete] = ACTIONS(2676),
    [anon_sym_throw] = ACTIONS(2676),
    [anon_sym_namespace] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_concept] = ACTIONS(2676),
    [anon_sym_co_return] = ACTIONS(2676),
    [anon_sym_co_yield] = ACTIONS(2676),
    [anon_sym_R_DQUOTE] = ACTIONS(2678),
    [anon_sym_LR_DQUOTE] = ACTIONS(2678),
    [anon_sym_uR_DQUOTE] = ACTIONS(2678),
    [anon_sym_UR_DQUOTE] = ACTIONS(2678),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2678),
    [anon_sym_co_await] = ACTIONS(2676),
    [anon_sym_new] = ACTIONS(2676),
    [anon_sym_requires] = ACTIONS(2676),
    [sym_this] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [842] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [843] = {
    [sym_preproc_def] = STATE(866),
    [sym_preproc_function_def] = STATE(866),
    [sym_preproc_call] = STATE(866),
    [sym_preproc_if_in_field_declaration_list] = STATE(866),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(866),
    [sym_type_definition] = STATE(866),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(866),
    [sym_field_declaration] = STATE(866),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(866),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(866),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(866),
    [sym_operator_cast_declaration] = STATE(866),
    [sym_constructor_or_destructor_definition] = STATE(866),
    [sym_constructor_or_destructor_declaration] = STATE(866),
    [sym_friend_declaration] = STATE(866),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(866),
    [sym_alias_declaration] = STATE(866),
    [sym_static_assert_declaration] = STATE(866),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(866),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3151),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [844] = {
    [sym_preproc_def] = STATE(862),
    [sym_preproc_function_def] = STATE(862),
    [sym_preproc_call] = STATE(862),
    [sym_preproc_if_in_field_declaration_list] = STATE(862),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(862),
    [sym_type_definition] = STATE(862),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(862),
    [sym_field_declaration] = STATE(862),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(862),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(862),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(862),
    [sym_operator_cast_declaration] = STATE(862),
    [sym_constructor_or_destructor_definition] = STATE(862),
    [sym_constructor_or_destructor_declaration] = STATE(862),
    [sym_friend_declaration] = STATE(862),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(862),
    [sym_alias_declaration] = STATE(862),
    [sym_static_assert_declaration] = STATE(862),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(862),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3157),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [845] = {
    [sym_preproc_def] = STATE(846),
    [sym_preproc_function_def] = STATE(846),
    [sym_preproc_call] = STATE(846),
    [sym_preproc_if_in_field_declaration_list] = STATE(846),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(846),
    [sym_type_definition] = STATE(846),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(846),
    [sym_field_declaration] = STATE(846),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(846),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(846),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(846),
    [sym_operator_cast_declaration] = STATE(846),
    [sym_constructor_or_destructor_definition] = STATE(846),
    [sym_constructor_or_destructor_declaration] = STATE(846),
    [sym_friend_declaration] = STATE(846),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(846),
    [sym_alias_declaration] = STATE(846),
    [sym_static_assert_declaration] = STATE(846),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(846),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [846] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3163),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [847] = {
    [sym_preproc_def] = STATE(854),
    [sym_preproc_function_def] = STATE(854),
    [sym_preproc_call] = STATE(854),
    [sym_preproc_if_in_field_declaration_list] = STATE(854),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(854),
    [sym_type_definition] = STATE(854),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(854),
    [sym_field_declaration] = STATE(854),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(854),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(854),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(854),
    [sym_operator_cast_declaration] = STATE(854),
    [sym_constructor_or_destructor_definition] = STATE(854),
    [sym_constructor_or_destructor_declaration] = STATE(854),
    [sym_friend_declaration] = STATE(854),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(854),
    [sym_alias_declaration] = STATE(854),
    [sym_static_assert_declaration] = STATE(854),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(854),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3167),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [848] = {
    [sym_preproc_def] = STATE(873),
    [sym_preproc_function_def] = STATE(873),
    [sym_preproc_call] = STATE(873),
    [sym_preproc_if_in_field_declaration_list] = STATE(873),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(873),
    [sym_type_definition] = STATE(873),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5737),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6366),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(873),
    [sym_field_declaration] = STATE(873),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1898),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(873),
    [sym_operator_cast] = STATE(7025),
    [sym_inline_method_definition] = STATE(873),
    [sym__constructor_specifiers] = STATE(1898),
    [sym_operator_cast_definition] = STATE(873),
    [sym_operator_cast_declaration] = STATE(873),
    [sym_constructor_or_destructor_definition] = STATE(873),
    [sym_constructor_or_destructor_declaration] = STATE(873),
    [sym_friend_declaration] = STATE(873),
    [sym_access_specifier] = STATE(8411),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(873),
    [sym_alias_declaration] = STATE(873),
    [sym_static_assert_declaration] = STATE(873),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7025),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(873),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7306),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3169),
    [aux_sym_preproc_if_token1] = ACTIONS(3171),
    [aux_sym_preproc_if_token2] = ACTIONS(3173),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3175),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3175),
    [sym_preproc_directive] = ACTIONS(3177),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym___extension__] = ACTIONS(3181),
    [anon_sym_typedef] = ACTIONS(3183),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3185),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3189),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3193),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [849] = {
    [sym_preproc_def] = STATE(850),
    [sym_preproc_function_def] = STATE(850),
    [sym_preproc_call] = STATE(850),
    [sym_preproc_if_in_field_declaration_list] = STATE(850),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(850),
    [sym_type_definition] = STATE(850),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(850),
    [sym_field_declaration] = STATE(850),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(850),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(850),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(850),
    [sym_operator_cast_declaration] = STATE(850),
    [sym_constructor_or_destructor_definition] = STATE(850),
    [sym_constructor_or_destructor_declaration] = STATE(850),
    [sym_friend_declaration] = STATE(850),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(850),
    [sym_alias_declaration] = STATE(850),
    [sym_static_assert_declaration] = STATE(850),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(850),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3197),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [850] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3199),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [851] = {
    [sym_preproc_def] = STATE(865),
    [sym_preproc_function_def] = STATE(865),
    [sym_preproc_call] = STATE(865),
    [sym_preproc_if_in_field_declaration_list] = STATE(865),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(865),
    [sym_type_definition] = STATE(865),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(865),
    [sym_field_declaration] = STATE(865),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(865),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(865),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(865),
    [sym_operator_cast_declaration] = STATE(865),
    [sym_constructor_or_destructor_definition] = STATE(865),
    [sym_constructor_or_destructor_declaration] = STATE(865),
    [sym_friend_declaration] = STATE(865),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(865),
    [sym_alias_declaration] = STATE(865),
    [sym_static_assert_declaration] = STATE(865),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(865),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3201),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3203),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [852] = {
    [sym_preproc_def] = STATE(853),
    [sym_preproc_function_def] = STATE(853),
    [sym_preproc_call] = STATE(853),
    [sym_preproc_if_in_field_declaration_list] = STATE(853),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(853),
    [sym_type_definition] = STATE(853),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(853),
    [sym_field_declaration] = STATE(853),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(853),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(853),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(853),
    [sym_operator_cast_declaration] = STATE(853),
    [sym_constructor_or_destructor_definition] = STATE(853),
    [sym_constructor_or_destructor_declaration] = STATE(853),
    [sym_friend_declaration] = STATE(853),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(853),
    [sym_alias_declaration] = STATE(853),
    [sym_static_assert_declaration] = STATE(853),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(853),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3207),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [853] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3209),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [854] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [855] = {
    [sym_preproc_def] = STATE(856),
    [sym_preproc_function_def] = STATE(856),
    [sym_preproc_call] = STATE(856),
    [sym_preproc_if_in_field_declaration_list] = STATE(856),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(856),
    [sym_type_definition] = STATE(856),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(856),
    [sym_field_declaration] = STATE(856),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(856),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(856),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(856),
    [sym_operator_cast_declaration] = STATE(856),
    [sym_constructor_or_destructor_definition] = STATE(856),
    [sym_constructor_or_destructor_declaration] = STATE(856),
    [sym_friend_declaration] = STATE(856),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(856),
    [sym_alias_declaration] = STATE(856),
    [sym_static_assert_declaration] = STATE(856),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(856),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [856] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3217),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [857] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [858] = {
    [sym_preproc_def] = STATE(875),
    [sym_preproc_function_def] = STATE(875),
    [sym_preproc_call] = STATE(875),
    [sym_preproc_if_in_field_declaration_list] = STATE(875),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(875),
    [sym_type_definition] = STATE(875),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(875),
    [sym_field_declaration] = STATE(875),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(875),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(875),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(875),
    [sym_operator_cast_declaration] = STATE(875),
    [sym_constructor_or_destructor_definition] = STATE(875),
    [sym_constructor_or_destructor_declaration] = STATE(875),
    [sym_friend_declaration] = STATE(875),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(875),
    [sym_alias_declaration] = STATE(875),
    [sym_static_assert_declaration] = STATE(875),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(875),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3221),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [859] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3225),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [860] = {
    [sym_preproc_def] = STATE(857),
    [sym_preproc_function_def] = STATE(857),
    [sym_preproc_call] = STATE(857),
    [sym_preproc_if_in_field_declaration_list] = STATE(857),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(857),
    [sym_type_definition] = STATE(857),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(857),
    [sym_field_declaration] = STATE(857),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(857),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(857),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(857),
    [sym_operator_cast_declaration] = STATE(857),
    [sym_constructor_or_destructor_definition] = STATE(857),
    [sym_constructor_or_destructor_declaration] = STATE(857),
    [sym_friend_declaration] = STATE(857),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(857),
    [sym_alias_declaration] = STATE(857),
    [sym_static_assert_declaration] = STATE(857),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(857),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3229),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [861] = {
    [sym_preproc_def] = STATE(864),
    [sym_preproc_function_def] = STATE(864),
    [sym_preproc_call] = STATE(864),
    [sym_preproc_if_in_field_declaration_list] = STATE(864),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(864),
    [sym_type_definition] = STATE(864),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(864),
    [sym_field_declaration] = STATE(864),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(864),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(864),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(864),
    [sym_operator_cast_declaration] = STATE(864),
    [sym_constructor_or_destructor_definition] = STATE(864),
    [sym_constructor_or_destructor_declaration] = STATE(864),
    [sym_friend_declaration] = STATE(864),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(864),
    [sym_alias_declaration] = STATE(864),
    [sym_static_assert_declaration] = STATE(864),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(864),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3231),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3233),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [862] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [863] = {
    [sym_preproc_def] = STATE(863),
    [sym_preproc_function_def] = STATE(863),
    [sym_preproc_call] = STATE(863),
    [sym_preproc_if_in_field_declaration_list] = STATE(863),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(863),
    [sym_type_definition] = STATE(863),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5737),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6366),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(863),
    [sym_field_declaration] = STATE(863),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1898),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(863),
    [sym_operator_cast] = STATE(7025),
    [sym_inline_method_definition] = STATE(863),
    [sym__constructor_specifiers] = STATE(1898),
    [sym_operator_cast_definition] = STATE(863),
    [sym_operator_cast_declaration] = STATE(863),
    [sym_constructor_or_destructor_definition] = STATE(863),
    [sym_constructor_or_destructor_declaration] = STATE(863),
    [sym_friend_declaration] = STATE(863),
    [sym_access_specifier] = STATE(8411),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(863),
    [sym_alias_declaration] = STATE(863),
    [sym_static_assert_declaration] = STATE(863),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7025),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(863),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7306),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2874),
    [aux_sym_preproc_def_token1] = ACTIONS(3237),
    [aux_sym_preproc_if_token1] = ACTIONS(3240),
    [aux_sym_preproc_if_token2] = ACTIONS(2883),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3243),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3243),
    [sym_preproc_directive] = ACTIONS(3246),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(3249),
    [anon_sym___extension__] = ACTIONS(3252),
    [anon_sym_typedef] = ACTIONS(3255),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2921),
    [anon_sym___attribute] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(3258),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2933),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(3261),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym__Nonnull] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2969),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_template] = ACTIONS(3264),
    [anon_sym_operator] = ACTIONS(2987),
    [anon_sym_friend] = ACTIONS(3267),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_static_assert] = ACTIONS(3270),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
  },
  [864] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3273),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [865] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [866] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3277),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [867] = {
    [sym_preproc_def] = STATE(869),
    [sym_preproc_function_def] = STATE(869),
    [sym_preproc_call] = STATE(869),
    [sym_preproc_if_in_field_declaration_list] = STATE(869),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(869),
    [sym_type_definition] = STATE(869),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(869),
    [sym_field_declaration] = STATE(869),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(869),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(869),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(869),
    [sym_operator_cast_declaration] = STATE(869),
    [sym_constructor_or_destructor_definition] = STATE(869),
    [sym_constructor_or_destructor_declaration] = STATE(869),
    [sym_friend_declaration] = STATE(869),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(869),
    [sym_alias_declaration] = STATE(869),
    [sym_static_assert_declaration] = STATE(869),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(869),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [868] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2874),
    [aux_sym_preproc_def_token1] = ACTIONS(3283),
    [aux_sym_preproc_if_token1] = ACTIONS(3286),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3289),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3289),
    [sym_preproc_directive] = ACTIONS(3292),
    [anon_sym_LPAREN2] = ACTIONS(2891),
    [anon_sym_TILDE] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(2897),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(3295),
    [anon_sym___extension__] = ACTIONS(3298),
    [anon_sym_typedef] = ACTIONS(3301),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_out] = ACTIONS(2915),
    [anon_sym_inout] = ACTIONS(2915),
    [anon_sym_virtual] = ACTIONS(2915),
    [anon_sym_extern] = ACTIONS(2918),
    [anon_sym___attribute__] = ACTIONS(2921),
    [anon_sym___attribute] = ACTIONS(2921),
    [anon_sym_using] = ACTIONS(3304),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2933),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_signed] = ACTIONS(2939),
    [anon_sym_unsigned] = ACTIONS(2939),
    [anon_sym_long] = ACTIONS(2939),
    [anon_sym_short] = ACTIONS(2939),
    [anon_sym_LBRACK] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_register] = ACTIONS(2918),
    [anon_sym_inline] = ACTIONS(2918),
    [anon_sym___inline] = ACTIONS(2918),
    [anon_sym___inline__] = ACTIONS(2918),
    [anon_sym___forceinline] = ACTIONS(2918),
    [anon_sym_thread_local] = ACTIONS(2918),
    [anon_sym___thread] = ACTIONS(2918),
    [anon_sym_const] = ACTIONS(2945),
    [anon_sym_constexpr] = ACTIONS(3309),
    [anon_sym_volatile] = ACTIONS(2945),
    [anon_sym_restrict] = ACTIONS(2945),
    [anon_sym___restrict__] = ACTIONS(2945),
    [anon_sym__Atomic] = ACTIONS(2945),
    [anon_sym__Noreturn] = ACTIONS(2945),
    [anon_sym_noreturn] = ACTIONS(2945),
    [anon_sym__Nonnull] = ACTIONS(2945),
    [anon_sym_mutable] = ACTIONS(2945),
    [anon_sym_constinit] = ACTIONS(2945),
    [anon_sym_consteval] = ACTIONS(2945),
    [anon_sym_alignas] = ACTIONS(2951),
    [anon_sym__Alignas] = ACTIONS(2951),
    [sym_primitive_type] = ACTIONS(2954),
    [anon_sym_enum] = ACTIONS(2957),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_union] = ACTIONS(2966),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2969),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2975),
    [anon_sym_typename] = ACTIONS(2978),
    [anon_sym_private] = ACTIONS(2981),
    [anon_sym_template] = ACTIONS(3312),
    [anon_sym_operator] = ACTIONS(2987),
    [anon_sym_friend] = ACTIONS(3315),
    [anon_sym_public] = ACTIONS(2981),
    [anon_sym_protected] = ACTIONS(2981),
    [anon_sym_static_assert] = ACTIONS(3318),
    [anon_sym_precise] = ACTIONS(2996),
    [anon_sym_shared] = ACTIONS(2996),
    [anon_sym_groupshared] = ACTIONS(2996),
    [anon_sym_uniform] = ACTIONS(2996),
    [anon_sym_row_major] = ACTIONS(2996),
    [anon_sym_column_major] = ACTIONS(2996),
    [anon_sym_globallycoherent] = ACTIONS(2996),
    [anon_sym_centroid] = ACTIONS(2996),
    [anon_sym_noperspective] = ACTIONS(2996),
    [anon_sym_nointerpolation] = ACTIONS(2996),
    [anon_sym_sample] = ACTIONS(2996),
    [anon_sym_linear] = ACTIONS(2996),
    [anon_sym_snorm] = ACTIONS(2996),
    [anon_sym_unorm] = ACTIONS(2996),
    [anon_sym_point] = ACTIONS(2996),
    [anon_sym_line] = ACTIONS(2996),
    [anon_sym_triangleadj] = ACTIONS(2996),
    [anon_sym_lineadj] = ACTIONS(2996),
    [anon_sym_triangle] = ACTIONS(2996),
  },
  [869] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [870] = {
    [sym_preproc_def] = STATE(872),
    [sym_preproc_function_def] = STATE(872),
    [sym_preproc_call] = STATE(872),
    [sym_preproc_if_in_field_declaration_list] = STATE(872),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(872),
    [sym_type_definition] = STATE(872),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(872),
    [sym_field_declaration] = STATE(872),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(872),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(872),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(872),
    [sym_operator_cast_declaration] = STATE(872),
    [sym_constructor_or_destructor_definition] = STATE(872),
    [sym_constructor_or_destructor_declaration] = STATE(872),
    [sym_friend_declaration] = STATE(872),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(872),
    [sym_alias_declaration] = STATE(872),
    [sym_static_assert_declaration] = STATE(872),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(872),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3325),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [871] = {
    [sym_preproc_def] = STATE(842),
    [sym_preproc_function_def] = STATE(842),
    [sym_preproc_call] = STATE(842),
    [sym_preproc_if_in_field_declaration_list] = STATE(842),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(842),
    [sym_type_definition] = STATE(842),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(842),
    [sym_field_declaration] = STATE(842),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(842),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(842),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(842),
    [sym_operator_cast_declaration] = STATE(842),
    [sym_constructor_or_destructor_definition] = STATE(842),
    [sym_constructor_or_destructor_declaration] = STATE(842),
    [sym_friend_declaration] = STATE(842),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(842),
    [sym_alias_declaration] = STATE(842),
    [sym_static_assert_declaration] = STATE(842),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(842),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3327),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3329),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [872] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3331),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [873] = {
    [sym_preproc_def] = STATE(863),
    [sym_preproc_function_def] = STATE(863),
    [sym_preproc_call] = STATE(863),
    [sym_preproc_if_in_field_declaration_list] = STATE(863),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(863),
    [sym_type_definition] = STATE(863),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5737),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6366),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(863),
    [sym_field_declaration] = STATE(863),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1898),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(863),
    [sym_operator_cast] = STATE(7025),
    [sym_inline_method_definition] = STATE(863),
    [sym__constructor_specifiers] = STATE(1898),
    [sym_operator_cast_definition] = STATE(863),
    [sym_operator_cast_declaration] = STATE(863),
    [sym_constructor_or_destructor_definition] = STATE(863),
    [sym_constructor_or_destructor_declaration] = STATE(863),
    [sym_friend_declaration] = STATE(863),
    [sym_access_specifier] = STATE(8411),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(863),
    [sym_alias_declaration] = STATE(863),
    [sym_static_assert_declaration] = STATE(863),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7025),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(863),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7306),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3169),
    [aux_sym_preproc_if_token1] = ACTIONS(3171),
    [aux_sym_preproc_if_token2] = ACTIONS(3333),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3175),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3175),
    [sym_preproc_directive] = ACTIONS(3177),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3335),
    [anon_sym___extension__] = ACTIONS(3181),
    [anon_sym_typedef] = ACTIONS(3183),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3185),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3189),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3191),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3193),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [874] = {
    [sym_preproc_def] = STATE(859),
    [sym_preproc_function_def] = STATE(859),
    [sym_preproc_call] = STATE(859),
    [sym_preproc_if_in_field_declaration_list] = STATE(859),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(859),
    [sym_type_definition] = STATE(859),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(859),
    [sym_field_declaration] = STATE(859),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(859),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(859),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(859),
    [sym_operator_cast_declaration] = STATE(859),
    [sym_constructor_or_destructor_definition] = STATE(859),
    [sym_constructor_or_destructor_declaration] = STATE(859),
    [sym_friend_declaration] = STATE(859),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(859),
    [sym_alias_declaration] = STATE(859),
    [sym_static_assert_declaration] = STATE(859),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(859),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3337),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [875] = {
    [sym_preproc_def] = STATE(868),
    [sym_preproc_function_def] = STATE(868),
    [sym_preproc_call] = STATE(868),
    [sym_preproc_if_in_field_declaration_list] = STATE(868),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(868),
    [sym_type_definition] = STATE(868),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(5799),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2442),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__field_declaration_list_item] = STATE(868),
    [sym_field_declaration] = STATE(868),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(868),
    [sym_operator_cast] = STATE(7024),
    [sym_inline_method_definition] = STATE(868),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(868),
    [sym_operator_cast_declaration] = STATE(868),
    [sym_constructor_or_destructor_definition] = STATE(868),
    [sym_constructor_or_destructor_declaration] = STATE(868),
    [sym_friend_declaration] = STATE(868),
    [sym_access_specifier] = STATE(9039),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_using_declaration] = STATE(868),
    [sym_alias_declaration] = STATE(868),
    [sym_static_assert_declaration] = STATE(868),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(868),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2041),
    [aux_sym_attributed_declarator_repeat1] = STATE(7134),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(2696),
    [aux_sym_preproc_def_token1] = ACTIONS(3125),
    [aux_sym_preproc_if_token1] = ACTIONS(3127),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3129),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3129),
    [sym_preproc_directive] = ACTIONS(3131),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym___extension__] = ACTIONS(3135),
    [anon_sym_typedef] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(2730),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_static_assert] = ACTIONS(3149),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [876] = {
    [sym_attribute_declaration] = STATE(876),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(242),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(876),
    [sym_identifier] = ACTIONS(3343),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3372),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3381),
    [anon_sym_switch] = ACTIONS(3384),
    [anon_sym_case] = ACTIONS(3387),
    [anon_sym_default] = ACTIONS(3390),
    [anon_sym_while] = ACTIONS(3393),
    [anon_sym_do] = ACTIONS(3396),
    [anon_sym_for] = ACTIONS(3399),
    [anon_sym_return] = ACTIONS(3402),
    [anon_sym_break] = ACTIONS(3405),
    [anon_sym_continue] = ACTIONS(3408),
    [anon_sym_goto] = ACTIONS(3411),
    [anon_sym___try] = ACTIONS(3414),
    [anon_sym___leave] = ACTIONS(3417),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3459),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3465),
    [anon_sym_co_return] = ACTIONS(3468),
    [anon_sym_co_yield] = ACTIONS(3471),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3486),
    [anon_sym_cbuffer] = ACTIONS(3489),
  },
  [877] = {
    [sym_attribute_declaration] = STATE(877),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(467),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(877),
    [sym_identifier] = ACTIONS(3492),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3501),
    [anon_sym_switch] = ACTIONS(3504),
    [anon_sym_case] = ACTIONS(3507),
    [anon_sym_default] = ACTIONS(3510),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3516),
    [anon_sym_for] = ACTIONS(3519),
    [anon_sym_return] = ACTIONS(3522),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3528),
    [anon_sym_goto] = ACTIONS(3531),
    [anon_sym___try] = ACTIONS(3534),
    [anon_sym___leave] = ACTIONS(3537),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3540),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3543),
    [anon_sym_co_return] = ACTIONS(3546),
    [anon_sym_co_yield] = ACTIONS(3549),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3552),
    [anon_sym_cbuffer] = ACTIONS(3555),
  },
  [878] = {
    [sym_attribute_declaration] = STATE(877),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(467),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(877),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [879] = {
    [sym_attribute_declaration] = STATE(879),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(272),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(3568),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3577),
    [anon_sym_switch] = ACTIONS(3580),
    [anon_sym_case] = ACTIONS(3583),
    [anon_sym_default] = ACTIONS(3586),
    [anon_sym_while] = ACTIONS(3589),
    [anon_sym_do] = ACTIONS(3592),
    [anon_sym_for] = ACTIONS(3595),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3604),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3610),
    [anon_sym___leave] = ACTIONS(3613),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3622),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3628),
    [anon_sym_cbuffer] = ACTIONS(3631),
  },
  [880] = {
    [sym_attribute_declaration] = STATE(879),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(272),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_using] = ACTIONS(3636),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [881] = {
    [sym_attribute_declaration] = STATE(883),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(484),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(883),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_using] = ACTIONS(3640),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [882] = {
    [sym_attribute_declaration] = STATE(876),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(242),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(876),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_using] = ACTIONS(3644),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [883] = {
    [sym_attribute_declaration] = STATE(883),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(484),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(883),
    [sym_identifier] = ACTIONS(3646),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3649),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_using] = ACTIONS(3364),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3652),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_switch] = ACTIONS(3658),
    [anon_sym_case] = ACTIONS(3661),
    [anon_sym_default] = ACTIONS(3664),
    [anon_sym_while] = ACTIONS(3667),
    [anon_sym_do] = ACTIONS(3670),
    [anon_sym_for] = ACTIONS(3673),
    [anon_sym_return] = ACTIONS(3676),
    [anon_sym_break] = ACTIONS(3679),
    [anon_sym_continue] = ACTIONS(3682),
    [anon_sym_goto] = ACTIONS(3685),
    [anon_sym___try] = ACTIONS(3688),
    [anon_sym___leave] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3694),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3697),
    [anon_sym_co_return] = ACTIONS(3700),
    [anon_sym_co_yield] = ACTIONS(3703),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3706),
    [anon_sym_cbuffer] = ACTIONS(3709),
  },
  [884] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(8708),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [885] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(8647),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [886] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(440),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [887] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(8898),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [888] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(260),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [889] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(264),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [890] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(233),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [891] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(373),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [892] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(545),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [893] = {
    [sym_attribute_declaration] = STATE(910),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(272),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(910),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [894] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(549),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [895] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(550),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [896] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(456),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [897] = {
    [sym_attribute_declaration] = STATE(876),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(242),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(876),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [898] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(196),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [899] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(248),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [900] = {
    [sym_attribute_declaration] = STATE(877),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(467),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(877),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [901] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(303),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [902] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(197),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [903] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(214),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [904] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(216),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [905] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(217),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [906] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(203),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [907] = {
    [sym_attribute_declaration] = STATE(897),
    [sym_compound_statement] = STATE(236),
    [sym_attributed_statement] = STATE(236),
    [sym_statement] = STATE(226),
    [sym_labeled_statement] = STATE(236),
    [sym_expression_statement] = STATE(236),
    [sym_if_statement] = STATE(236),
    [sym_switch_statement] = STATE(236),
    [sym_case_statement] = STATE(236),
    [sym_while_statement] = STATE(236),
    [sym_do_statement] = STATE(236),
    [sym_for_statement] = STATE(236),
    [sym_return_statement] = STATE(236),
    [sym_break_statement] = STATE(236),
    [sym_continue_statement] = STATE(236),
    [sym_goto_statement] = STATE(236),
    [sym_seh_try_statement] = STATE(236),
    [sym_seh_leave_statement] = STATE(236),
    [sym_expression] = STATE(4781),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8405),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(236),
    [sym_co_return_statement] = STATE(236),
    [sym_co_yield_statement] = STATE(236),
    [sym_throw_statement] = STATE(236),
    [sym_try_statement] = STATE(236),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(236),
    [sym_cbuffer_specifier] = STATE(236),
    [sym_hlsl_attribute] = STATE(8001),
    [aux_sym_attributed_declarator_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3642),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_switch] = ACTIONS(309),
    [anon_sym_case] = ACTIONS(311),
    [anon_sym_default] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_do] = ACTIONS(317),
    [anon_sym_for] = ACTIONS(319),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(323),
    [anon_sym_continue] = ACTIONS(325),
    [anon_sym_goto] = ACTIONS(327),
    [anon_sym___try] = ACTIONS(329),
    [anon_sym___leave] = ACTIONS(331),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(335),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_co_return] = ACTIONS(345),
    [anon_sym_co_yield] = ACTIONS(347),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(349),
    [anon_sym_cbuffer] = ACTIONS(351),
  },
  [908] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(7659),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [909] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(373),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [910] = {
    [sym_attribute_declaration] = STATE(910),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(272),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(910),
    [sym_identifier] = ACTIONS(3714),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3495),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3717),
    [anon_sym_switch] = ACTIONS(3580),
    [anon_sym_case] = ACTIONS(3720),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3726),
    [anon_sym_do] = ACTIONS(3592),
    [anon_sym_for] = ACTIONS(3729),
    [anon_sym_return] = ACTIONS(3598),
    [anon_sym_break] = ACTIONS(3601),
    [anon_sym_continue] = ACTIONS(3604),
    [anon_sym_goto] = ACTIONS(3607),
    [anon_sym___try] = ACTIONS(3732),
    [anon_sym___leave] = ACTIONS(3537),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3616),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3619),
    [anon_sym_co_return] = ACTIONS(3622),
    [anon_sym_co_yield] = ACTIONS(3625),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3552),
    [anon_sym_cbuffer] = ACTIONS(3735),
  },
  [911] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(7484),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [912] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(279),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [913] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(292),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [914] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(294),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [915] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(7391),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [916] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(8843),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [917] = {
    [sym_attribute_declaration] = STATE(883),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(484),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(883),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [918] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(555),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [919] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(454),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [920] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(492),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [921] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(443),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [922] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(510),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [923] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(512),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [924] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(513),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [925] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(441),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [926] = {
    [sym_attribute_declaration] = STATE(917),
    [sym_compound_statement] = STATE(477),
    [sym_attributed_statement] = STATE(477),
    [sym_statement] = STATE(522),
    [sym_labeled_statement] = STATE(477),
    [sym_expression_statement] = STATE(477),
    [sym_if_statement] = STATE(477),
    [sym_switch_statement] = STATE(477),
    [sym_case_statement] = STATE(477),
    [sym_while_statement] = STATE(477),
    [sym_do_statement] = STATE(477),
    [sym_for_statement] = STATE(477),
    [sym_return_statement] = STATE(477),
    [sym_break_statement] = STATE(477),
    [sym_continue_statement] = STATE(477),
    [sym_goto_statement] = STATE(477),
    [sym_seh_try_statement] = STATE(477),
    [sym_seh_leave_statement] = STATE(477),
    [sym_expression] = STATE(4751),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8698),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(477),
    [sym_co_return_statement] = STATE(477),
    [sym_co_yield_statement] = STATE(477),
    [sym_throw_statement] = STATE(477),
    [sym_try_statement] = STATE(477),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(477),
    [sym_cbuffer_specifier] = STATE(477),
    [sym_hlsl_attribute] = STATE(8244),
    [aux_sym_attributed_declarator_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3638),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(785),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(795),
    [anon_sym_while] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(803),
    [anon_sym_break] = ACTIONS(805),
    [anon_sym_continue] = ACTIONS(807),
    [anon_sym_goto] = ACTIONS(809),
    [anon_sym___try] = ACTIONS(811),
    [anon_sym___leave] = ACTIONS(813),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(819),
    [anon_sym_co_return] = ACTIONS(827),
    [anon_sym_co_yield] = ACTIONS(829),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(831),
    [anon_sym_cbuffer] = ACTIONS(833),
  },
  [927] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1039),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [928] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1059),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [929] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(8874),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [930] = {
    [sym_attribute_declaration] = STATE(930),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1081),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(930),
    [sym_identifier] = ACTIONS(3740),
    [anon_sym_LPAREN2] = ACTIONS(3346),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_TILDE] = ACTIONS(3349),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3355),
    [anon_sym_AMP] = ACTIONS(3355),
    [anon_sym_SEMI] = ACTIONS(3743),
    [anon_sym___extension__] = ACTIONS(3361),
    [anon_sym_COLON_COLON] = ACTIONS(3366),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3375),
    [sym_primitive_type] = ACTIONS(3378),
    [anon_sym_if] = ACTIONS(3749),
    [anon_sym_switch] = ACTIONS(3752),
    [anon_sym_case] = ACTIONS(3720),
    [anon_sym_default] = ACTIONS(3723),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3758),
    [anon_sym_for] = ACTIONS(3761),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3770),
    [anon_sym_goto] = ACTIONS(3773),
    [anon_sym___try] = ACTIONS(3776),
    [anon_sym___leave] = ACTIONS(3779),
    [anon_sym_not] = ACTIONS(3352),
    [anon_sym_compl] = ACTIONS(3352),
    [anon_sym_DASH_DASH] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3420),
    [anon_sym_sizeof] = ACTIONS(3423),
    [anon_sym___alignof__] = ACTIONS(3426),
    [anon_sym___alignof] = ACTIONS(3426),
    [anon_sym__alignof] = ACTIONS(3426),
    [anon_sym_alignof] = ACTIONS(3426),
    [anon_sym__Alignof] = ACTIONS(3426),
    [anon_sym_offsetof] = ACTIONS(3429),
    [anon_sym__Generic] = ACTIONS(3432),
    [anon_sym_asm] = ACTIONS(3435),
    [anon_sym___asm__] = ACTIONS(3435),
    [anon_sym___asm] = ACTIONS(3435),
    [sym_number_literal] = ACTIONS(3438),
    [anon_sym_L_SQUOTE] = ACTIONS(3441),
    [anon_sym_u_SQUOTE] = ACTIONS(3441),
    [anon_sym_U_SQUOTE] = ACTIONS(3441),
    [anon_sym_u8_SQUOTE] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_L_DQUOTE] = ACTIONS(3444),
    [anon_sym_u_DQUOTE] = ACTIONS(3444),
    [anon_sym_U_DQUOTE] = ACTIONS(3444),
    [anon_sym_u8_DQUOTE] = ACTIONS(3444),
    [anon_sym_DQUOTE] = ACTIONS(3444),
    [sym_true] = ACTIONS(3447),
    [sym_false] = ACTIONS(3447),
    [anon_sym_NULL] = ACTIONS(3450),
    [anon_sym_nullptr] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3453),
    [anon_sym_template] = ACTIONS(3456),
    [anon_sym_try] = ACTIONS(3782),
    [anon_sym_delete] = ACTIONS(3462),
    [anon_sym_throw] = ACTIONS(3785),
    [anon_sym_co_return] = ACTIONS(3788),
    [anon_sym_co_yield] = ACTIONS(3791),
    [anon_sym_R_DQUOTE] = ACTIONS(3474),
    [anon_sym_LR_DQUOTE] = ACTIONS(3474),
    [anon_sym_uR_DQUOTE] = ACTIONS(3474),
    [anon_sym_UR_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3474),
    [anon_sym_co_await] = ACTIONS(3477),
    [anon_sym_new] = ACTIONS(3480),
    [anon_sym_requires] = ACTIONS(3483),
    [sym_this] = ACTIONS(3447),
    [anon_sym_discard] = ACTIONS(3794),
    [anon_sym_cbuffer] = ACTIONS(3797),
  },
  [931] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1038),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [932] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1069),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [933] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1072),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [934] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1073),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [935] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1045),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [936] = {
    [sym_attribute_declaration] = STATE(937),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1088),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(937),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [937] = {
    [sym_attribute_declaration] = STATE(930),
    [sym_compound_statement] = STATE(1096),
    [sym_attributed_statement] = STATE(1096),
    [sym_statement] = STATE(1081),
    [sym_labeled_statement] = STATE(1096),
    [sym_expression_statement] = STATE(1096),
    [sym_if_statement] = STATE(1096),
    [sym_switch_statement] = STATE(1096),
    [sym_case_statement] = STATE(1096),
    [sym_while_statement] = STATE(1096),
    [sym_do_statement] = STATE(1096),
    [sym_for_statement] = STATE(1096),
    [sym_return_statement] = STATE(1096),
    [sym_break_statement] = STATE(1096),
    [sym_continue_statement] = STATE(1096),
    [sym_goto_statement] = STATE(1096),
    [sym_seh_try_statement] = STATE(1096),
    [sym_seh_leave_statement] = STATE(1096),
    [sym_expression] = STATE(4770),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8365),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(1096),
    [sym_co_return_statement] = STATE(1096),
    [sym_co_yield_statement] = STATE(1096),
    [sym_throw_statement] = STATE(1096),
    [sym_try_statement] = STATE(1096),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(1096),
    [sym_cbuffer_specifier] = STATE(1096),
    [sym_hlsl_attribute] = STATE(8030),
    [aux_sym_attributed_declarator_repeat1] = STATE(930),
    [sym_identifier] = ACTIONS(3738),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_switch] = ACTIONS(1807),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_do] = ACTIONS(1811),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1819),
    [anon_sym_goto] = ACTIONS(1821),
    [anon_sym___try] = ACTIONS(1823),
    [anon_sym___leave] = ACTIONS(1825),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(1829),
    [anon_sym_co_return] = ACTIONS(1831),
    [anon_sym_co_yield] = ACTIONS(1833),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(1835),
    [anon_sym_cbuffer] = ACTIONS(1837),
  },
  [938] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(450),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [939] = {
    [sym_attribute_declaration] = STATE(900),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(472),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7962),
    [aux_sym_attributed_declarator_repeat1] = STATE(900),
    [sym_identifier] = ACTIONS(3558),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_case] = ACTIONS(205),
    [anon_sym_default] = ACTIONS(207),
    [anon_sym_while] = ACTIONS(209),
    [anon_sym_do] = ACTIONS(211),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_return] = ACTIONS(215),
    [anon_sym_break] = ACTIONS(217),
    [anon_sym_continue] = ACTIONS(219),
    [anon_sym_goto] = ACTIONS(221),
    [anon_sym___try] = ACTIONS(223),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(235),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(237),
    [anon_sym_co_return] = ACTIONS(245),
    [anon_sym_co_yield] = ACTIONS(247),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(251),
  },
  [940] = {
    [sym_attribute_declaration] = STATE(879),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(272),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [941] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(279),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [942] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(292),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [943] = {
    [sym_attribute_declaration] = STATE(940),
    [sym_compound_statement] = STATE(305),
    [sym_attributed_statement] = STATE(305),
    [sym_statement] = STATE(294),
    [sym_labeled_statement] = STATE(305),
    [sym_expression_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_switch_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_do_statement] = STATE(305),
    [sym_for_statement] = STATE(305),
    [sym_return_statement] = STATE(305),
    [sym_break_statement] = STATE(305),
    [sym_continue_statement] = STATE(305),
    [sym_goto_statement] = STATE(305),
    [sym_seh_try_statement] = STATE(305),
    [sym_seh_leave_statement] = STATE(305),
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8664),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(305),
    [sym_co_return_statement] = STATE(305),
    [sym_co_yield_statement] = STATE(305),
    [sym_throw_statement] = STATE(305),
    [sym_try_statement] = STATE(305),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(305),
    [sym_cbuffer_specifier] = STATE(305),
    [sym_hlsl_attribute] = STATE(7835),
    [aux_sym_attributed_declarator_repeat1] = STATE(940),
    [sym_identifier] = ACTIONS(3634),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_default] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(93),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(971),
    [anon_sym___leave] = ACTIONS(973),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(979),
    [anon_sym_cbuffer] = ACTIONS(981),
  },
  [944] = {
    [sym_attribute_declaration] = STATE(893),
    [sym_compound_statement] = STATE(539),
    [sym_attributed_statement] = STATE(539),
    [sym_statement] = STATE(303),
    [sym_labeled_statement] = STATE(539),
    [sym_expression_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_switch_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_do_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_return_statement] = STATE(539),
    [sym_break_statement] = STATE(539),
    [sym_continue_statement] = STATE(539),
    [sym_goto_statement] = STATE(539),
    [sym_seh_try_statement] = STATE(539),
    [sym_seh_leave_statement] = STATE(539),
    [sym_expression] = STATE(4680),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8520),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_for_range_loop] = STATE(539),
    [sym_co_return_statement] = STATE(539),
    [sym_co_yield_statement] = STATE(539),
    [sym_throw_statement] = STATE(539),
    [sym_try_statement] = STATE(539),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_discard_statement] = STATE(539),
    [sym_cbuffer_specifier] = STATE(539),
    [sym_hlsl_attribute] = STATE(7934),
    [aux_sym_attributed_declarator_repeat1] = STATE(893),
    [sym_identifier] = ACTIONS(3712),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1306),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1847),
    [anon_sym_do] = ACTIONS(91),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(95),
    [anon_sym_break] = ACTIONS(97),
    [anon_sym_continue] = ACTIONS(99),
    [anon_sym_goto] = ACTIONS(101),
    [anon_sym___try] = ACTIONS(1851),
    [anon_sym___leave] = ACTIONS(225),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(143),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_throw] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(155),
    [anon_sym_co_yield] = ACTIONS(157),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
    [anon_sym_discard] = ACTIONS(249),
    [anon_sym_cbuffer] = ACTIONS(1853),
  },
  [945] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [aux_sym_preproc_if_token2] = ACTIONS(3802),
    [aux_sym_preproc_else_token1] = ACTIONS(3802),
    [aux_sym_preproc_elif_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3802),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3804),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [946] = {
    [sym__declaration_modifiers] = STATE(2037),
    [sym__declaration_specifiers] = STATE(6518),
    [sym_attribute_specifier] = STATE(2037),
    [sym_attribute_declaration] = STATE(2037),
    [sym_ms_declspec_modifier] = STATE(2037),
    [sym_storage_class_specifier] = STATE(2037),
    [sym_type_qualifier] = STATE(2037),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2037),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2037),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2598),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym_COMMA] = ACTIONS(3848),
    [anon_sym_BANG] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_STAR] = ACTIONS(3850),
    [anon_sym_SLASH] = ACTIONS(3850),
    [anon_sym_PERCENT] = ACTIONS(3850),
    [anon_sym_PIPE_PIPE] = ACTIONS(3848),
    [anon_sym_AMP_AMP] = ACTIONS(3848),
    [anon_sym_PIPE] = ACTIONS(3850),
    [anon_sym_CARET] = ACTIONS(3850),
    [anon_sym_AMP] = ACTIONS(3850),
    [anon_sym_EQ_EQ] = ACTIONS(3848),
    [anon_sym_BANG_EQ] = ACTIONS(3848),
    [anon_sym_GT] = ACTIONS(3850),
    [anon_sym_GT_EQ] = ACTIONS(3848),
    [anon_sym_LT_EQ] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3850),
    [anon_sym_LT_LT] = ACTIONS(3850),
    [anon_sym_GT_GT] = ACTIONS(3850),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_out] = ACTIONS(3852),
    [anon_sym_inout] = ACTIONS(3852),
    [anon_sym_virtual] = ACTIONS(3852),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3856),
    [anon_sym_unsigned] = ACTIONS(3856),
    [anon_sym_long] = ACTIONS(3856),
    [anon_sym_short] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(3850),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(3858),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_STAR_EQ] = ACTIONS(3848),
    [anon_sym_SLASH_EQ] = ACTIONS(3848),
    [anon_sym_PERCENT_EQ] = ACTIONS(3848),
    [anon_sym_PLUS_EQ] = ACTIONS(3848),
    [anon_sym_DASH_EQ] = ACTIONS(3848),
    [anon_sym_LT_LT_EQ] = ACTIONS(3848),
    [anon_sym_GT_GT_EQ] = ACTIONS(3848),
    [anon_sym_AMP_EQ] = ACTIONS(3848),
    [anon_sym_CARET_EQ] = ACTIONS(3848),
    [anon_sym_PIPE_EQ] = ACTIONS(3848),
    [anon_sym_and_eq] = ACTIONS(3850),
    [anon_sym_or_eq] = ACTIONS(3850),
    [anon_sym_xor_eq] = ACTIONS(3850),
    [anon_sym_not] = ACTIONS(3850),
    [anon_sym_compl] = ACTIONS(3850),
    [anon_sym_LT_EQ_GT] = ACTIONS(3848),
    [anon_sym_or] = ACTIONS(3850),
    [anon_sym_and] = ACTIONS(3850),
    [anon_sym_bitor] = ACTIONS(3850),
    [anon_sym_xor] = ACTIONS(3850),
    [anon_sym_bitand] = ACTIONS(3850),
    [anon_sym_not_eq] = ACTIONS(3850),
    [anon_sym_DASH_DASH] = ACTIONS(3848),
    [anon_sym_PLUS_PLUS] = ACTIONS(3848),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3860),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3862),
    [anon_sym_co_await] = ACTIONS(3850),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3848),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3848),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3848),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3864),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [947] = {
    [sym__declaration_modifiers] = STATE(2037),
    [sym__declaration_specifiers] = STATE(6518),
    [sym_attribute_specifier] = STATE(2037),
    [sym_attribute_declaration] = STATE(2037),
    [sym_ms_declspec_modifier] = STATE(2037),
    [sym_storage_class_specifier] = STATE(2037),
    [sym_type_qualifier] = STATE(2037),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2037),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2037),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2598),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_BANG] = ACTIONS(3868),
    [anon_sym_TILDE] = ACTIONS(3866),
    [anon_sym_DASH] = ACTIONS(3868),
    [anon_sym_PLUS] = ACTIONS(3868),
    [anon_sym_STAR] = ACTIONS(3868),
    [anon_sym_SLASH] = ACTIONS(3868),
    [anon_sym_PERCENT] = ACTIONS(3868),
    [anon_sym_PIPE_PIPE] = ACTIONS(3866),
    [anon_sym_AMP_AMP] = ACTIONS(3866),
    [anon_sym_PIPE] = ACTIONS(3868),
    [anon_sym_CARET] = ACTIONS(3868),
    [anon_sym_AMP] = ACTIONS(3868),
    [anon_sym_EQ_EQ] = ACTIONS(3866),
    [anon_sym_BANG_EQ] = ACTIONS(3866),
    [anon_sym_GT] = ACTIONS(3868),
    [anon_sym_GT_EQ] = ACTIONS(3866),
    [anon_sym_LT_EQ] = ACTIONS(3868),
    [anon_sym_LT] = ACTIONS(3868),
    [anon_sym_LT_LT] = ACTIONS(3868),
    [anon_sym_GT_GT] = ACTIONS(3868),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(3852),
    [anon_sym_out] = ACTIONS(3852),
    [anon_sym_inout] = ACTIONS(3852),
    [anon_sym_virtual] = ACTIONS(3852),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3856),
    [anon_sym_unsigned] = ACTIONS(3856),
    [anon_sym_long] = ACTIONS(3856),
    [anon_sym_short] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_EQ] = ACTIONS(3868),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(3858),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [anon_sym_STAR_EQ] = ACTIONS(3866),
    [anon_sym_SLASH_EQ] = ACTIONS(3866),
    [anon_sym_PERCENT_EQ] = ACTIONS(3866),
    [anon_sym_PLUS_EQ] = ACTIONS(3866),
    [anon_sym_DASH_EQ] = ACTIONS(3866),
    [anon_sym_LT_LT_EQ] = ACTIONS(3866),
    [anon_sym_GT_GT_EQ] = ACTIONS(3866),
    [anon_sym_AMP_EQ] = ACTIONS(3866),
    [anon_sym_CARET_EQ] = ACTIONS(3866),
    [anon_sym_PIPE_EQ] = ACTIONS(3866),
    [anon_sym_and_eq] = ACTIONS(3868),
    [anon_sym_or_eq] = ACTIONS(3868),
    [anon_sym_xor_eq] = ACTIONS(3868),
    [anon_sym_not] = ACTIONS(3868),
    [anon_sym_compl] = ACTIONS(3868),
    [anon_sym_LT_EQ_GT] = ACTIONS(3866),
    [anon_sym_or] = ACTIONS(3868),
    [anon_sym_and] = ACTIONS(3868),
    [anon_sym_bitor] = ACTIONS(3868),
    [anon_sym_xor] = ACTIONS(3868),
    [anon_sym_bitand] = ACTIONS(3868),
    [anon_sym_not_eq] = ACTIONS(3868),
    [anon_sym_DASH_DASH] = ACTIONS(3866),
    [anon_sym_PLUS_PLUS] = ACTIONS(3866),
    [anon_sym_DASH_GT] = ACTIONS(3868),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3860),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3870),
    [anon_sym_co_await] = ACTIONS(3868),
    [anon_sym_new] = ACTIONS(3870),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3866),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3866),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3866),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3872),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_COMMA] = ACTIONS(3876),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_LPAREN2] = ACTIONS(3876),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_AMP_AMP] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym___extension__] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3874),
    [anon_sym_out] = ACTIONS(3874),
    [anon_sym_inout] = ACTIONS(3874),
    [anon_sym_virtual] = ACTIONS(3874),
    [anon_sym_extern] = ACTIONS(3874),
    [anon_sym___attribute__] = ACTIONS(3874),
    [anon_sym___attribute] = ACTIONS(3874),
    [anon_sym_using] = ACTIONS(3874),
    [anon_sym_COLON_COLON] = ACTIONS(3876),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3876),
    [anon_sym___declspec] = ACTIONS(3874),
    [anon_sym___based] = ACTIONS(3874),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_signed] = ACTIONS(3874),
    [anon_sym_unsigned] = ACTIONS(3874),
    [anon_sym_long] = ACTIONS(3874),
    [anon_sym_short] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3874),
    [anon_sym_RBRACK] = ACTIONS(3876),
    [anon_sym_EQ] = ACTIONS(3876),
    [anon_sym_register] = ACTIONS(3874),
    [anon_sym_inline] = ACTIONS(3874),
    [anon_sym___inline] = ACTIONS(3874),
    [anon_sym___inline__] = ACTIONS(3874),
    [anon_sym___forceinline] = ACTIONS(3874),
    [anon_sym_thread_local] = ACTIONS(3874),
    [anon_sym___thread] = ACTIONS(3874),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_constexpr] = ACTIONS(3874),
    [anon_sym_volatile] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3874),
    [anon_sym___restrict__] = ACTIONS(3874),
    [anon_sym__Atomic] = ACTIONS(3874),
    [anon_sym__Noreturn] = ACTIONS(3874),
    [anon_sym_noreturn] = ACTIONS(3874),
    [anon_sym__Nonnull] = ACTIONS(3874),
    [anon_sym_mutable] = ACTIONS(3874),
    [anon_sym_constinit] = ACTIONS(3874),
    [anon_sym_consteval] = ACTIONS(3874),
    [anon_sym_alignas] = ACTIONS(3874),
    [anon_sym__Alignas] = ACTIONS(3874),
    [sym_primitive_type] = ACTIONS(3874),
    [anon_sym_enum] = ACTIONS(3874),
    [anon_sym_class] = ACTIONS(3874),
    [anon_sym_struct] = ACTIONS(3874),
    [anon_sym_union] = ACTIONS(3874),
    [anon_sym_if] = ACTIONS(3874),
    [anon_sym_switch] = ACTIONS(3874),
    [anon_sym_case] = ACTIONS(3874),
    [anon_sym_default] = ACTIONS(3874),
    [anon_sym_while] = ACTIONS(3874),
    [anon_sym_do] = ACTIONS(3874),
    [anon_sym_for] = ACTIONS(3874),
    [anon_sym_return] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3874),
    [anon_sym_continue] = ACTIONS(3874),
    [anon_sym_goto] = ACTIONS(3874),
    [anon_sym___try] = ACTIONS(3874),
    [anon_sym___leave] = ACTIONS(3874),
    [anon_sym_not] = ACTIONS(3874),
    [anon_sym_compl] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3876),
    [anon_sym_sizeof] = ACTIONS(3874),
    [anon_sym___alignof__] = ACTIONS(3874),
    [anon_sym___alignof] = ACTIONS(3874),
    [anon_sym__alignof] = ACTIONS(3874),
    [anon_sym_alignof] = ACTIONS(3874),
    [anon_sym__Alignof] = ACTIONS(3874),
    [anon_sym_offsetof] = ACTIONS(3874),
    [anon_sym__Generic] = ACTIONS(3874),
    [anon_sym_asm] = ACTIONS(3874),
    [anon_sym___asm__] = ACTIONS(3874),
    [anon_sym___asm] = ACTIONS(3874),
    [sym_number_literal] = ACTIONS(3876),
    [anon_sym_L_SQUOTE] = ACTIONS(3876),
    [anon_sym_u_SQUOTE] = ACTIONS(3876),
    [anon_sym_U_SQUOTE] = ACTIONS(3876),
    [anon_sym_u8_SQUOTE] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(3876),
    [anon_sym_L_DQUOTE] = ACTIONS(3876),
    [anon_sym_u_DQUOTE] = ACTIONS(3876),
    [anon_sym_U_DQUOTE] = ACTIONS(3876),
    [anon_sym_u8_DQUOTE] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3876),
    [sym_true] = ACTIONS(3874),
    [sym_false] = ACTIONS(3874),
    [anon_sym_NULL] = ACTIONS(3874),
    [anon_sym_nullptr] = ACTIONS(3874),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3874),
    [anon_sym_decltype] = ACTIONS(3874),
    [anon_sym_explicit] = ACTIONS(3874),
    [anon_sym_typename] = ACTIONS(3874),
    [anon_sym_template] = ACTIONS(3874),
    [anon_sym_operator] = ACTIONS(3874),
    [anon_sym_try] = ACTIONS(3874),
    [anon_sym_delete] = ACTIONS(3874),
    [anon_sym_throw] = ACTIONS(3874),
    [anon_sym_co_return] = ACTIONS(3874),
    [anon_sym_co_yield] = ACTIONS(3874),
    [anon_sym_R_DQUOTE] = ACTIONS(3876),
    [anon_sym_LR_DQUOTE] = ACTIONS(3876),
    [anon_sym_uR_DQUOTE] = ACTIONS(3876),
    [anon_sym_UR_DQUOTE] = ACTIONS(3876),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3876),
    [anon_sym_co_await] = ACTIONS(3874),
    [anon_sym_new] = ACTIONS(3874),
    [anon_sym_requires] = ACTIONS(3874),
    [sym_this] = ACTIONS(3874),
    [anon_sym_discard] = ACTIONS(3874),
    [anon_sym_precise] = ACTIONS(3874),
    [anon_sym_shared] = ACTIONS(3874),
    [anon_sym_groupshared] = ACTIONS(3874),
    [anon_sym_uniform] = ACTIONS(3874),
    [anon_sym_row_major] = ACTIONS(3874),
    [anon_sym_column_major] = ACTIONS(3874),
    [anon_sym_globallycoherent] = ACTIONS(3874),
    [anon_sym_centroid] = ACTIONS(3874),
    [anon_sym_noperspective] = ACTIONS(3874),
    [anon_sym_nointerpolation] = ACTIONS(3874),
    [anon_sym_sample] = ACTIONS(3874),
    [anon_sym_linear] = ACTIONS(3874),
    [anon_sym_snorm] = ACTIONS(3874),
    [anon_sym_unorm] = ACTIONS(3874),
    [anon_sym_point] = ACTIONS(3874),
    [anon_sym_line] = ACTIONS(3874),
    [anon_sym_triangleadj] = ACTIONS(3874),
    [anon_sym_lineadj] = ACTIONS(3874),
    [anon_sym_triangle] = ACTIONS(3874),
    [anon_sym_cbuffer] = ACTIONS(3874),
  },
  [949] = {
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3878),
    [anon_sym_out] = ACTIONS(3878),
    [anon_sym_inout] = ACTIONS(3878),
    [anon_sym_virtual] = ACTIONS(3878),
    [anon_sym_extern] = ACTIONS(3878),
    [anon_sym___attribute__] = ACTIONS(3878),
    [anon_sym___attribute] = ACTIONS(3878),
    [anon_sym_using] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3880),
    [anon_sym___declspec] = ACTIONS(3878),
    [anon_sym___based] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_signed] = ACTIONS(3878),
    [anon_sym_unsigned] = ACTIONS(3878),
    [anon_sym_long] = ACTIONS(3878),
    [anon_sym_short] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3878),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_register] = ACTIONS(3878),
    [anon_sym_inline] = ACTIONS(3878),
    [anon_sym___inline] = ACTIONS(3878),
    [anon_sym___inline__] = ACTIONS(3878),
    [anon_sym___forceinline] = ACTIONS(3878),
    [anon_sym_thread_local] = ACTIONS(3878),
    [anon_sym___thread] = ACTIONS(3878),
    [anon_sym_const] = ACTIONS(3878),
    [anon_sym_constexpr] = ACTIONS(3878),
    [anon_sym_volatile] = ACTIONS(3878),
    [anon_sym_restrict] = ACTIONS(3878),
    [anon_sym___restrict__] = ACTIONS(3878),
    [anon_sym__Atomic] = ACTIONS(3878),
    [anon_sym__Noreturn] = ACTIONS(3878),
    [anon_sym_noreturn] = ACTIONS(3878),
    [anon_sym__Nonnull] = ACTIONS(3878),
    [anon_sym_mutable] = ACTIONS(3878),
    [anon_sym_constinit] = ACTIONS(3878),
    [anon_sym_consteval] = ACTIONS(3878),
    [anon_sym_alignas] = ACTIONS(3878),
    [anon_sym__Alignas] = ACTIONS(3878),
    [sym_primitive_type] = ACTIONS(3878),
    [anon_sym_enum] = ACTIONS(3878),
    [anon_sym_class] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3878),
    [anon_sym_union] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_switch] = ACTIONS(3878),
    [anon_sym_case] = ACTIONS(3878),
    [anon_sym_default] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_break] = ACTIONS(3878),
    [anon_sym_continue] = ACTIONS(3878),
    [anon_sym_goto] = ACTIONS(3878),
    [anon_sym___try] = ACTIONS(3878),
    [anon_sym___leave] = ACTIONS(3878),
    [anon_sym_not] = ACTIONS(3878),
    [anon_sym_compl] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3878),
    [anon_sym___alignof__] = ACTIONS(3878),
    [anon_sym___alignof] = ACTIONS(3878),
    [anon_sym__alignof] = ACTIONS(3878),
    [anon_sym_alignof] = ACTIONS(3878),
    [anon_sym__Alignof] = ACTIONS(3878),
    [anon_sym_offsetof] = ACTIONS(3878),
    [anon_sym__Generic] = ACTIONS(3878),
    [anon_sym_asm] = ACTIONS(3878),
    [anon_sym___asm__] = ACTIONS(3878),
    [anon_sym___asm] = ACTIONS(3878),
    [sym_number_literal] = ACTIONS(3880),
    [anon_sym_L_SQUOTE] = ACTIONS(3880),
    [anon_sym_u_SQUOTE] = ACTIONS(3880),
    [anon_sym_U_SQUOTE] = ACTIONS(3880),
    [anon_sym_u8_SQUOTE] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(3880),
    [anon_sym_L_DQUOTE] = ACTIONS(3880),
    [anon_sym_u_DQUOTE] = ACTIONS(3880),
    [anon_sym_U_DQUOTE] = ACTIONS(3880),
    [anon_sym_u8_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE] = ACTIONS(3880),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [anon_sym_NULL] = ACTIONS(3878),
    [anon_sym_nullptr] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3878),
    [anon_sym_decltype] = ACTIONS(3878),
    [anon_sym_explicit] = ACTIONS(3878),
    [anon_sym_typename] = ACTIONS(3878),
    [anon_sym_template] = ACTIONS(3878),
    [anon_sym_operator] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_delete] = ACTIONS(3878),
    [anon_sym_throw] = ACTIONS(3878),
    [anon_sym_co_return] = ACTIONS(3878),
    [anon_sym_co_yield] = ACTIONS(3878),
    [anon_sym_R_DQUOTE] = ACTIONS(3880),
    [anon_sym_LR_DQUOTE] = ACTIONS(3880),
    [anon_sym_uR_DQUOTE] = ACTIONS(3880),
    [anon_sym_UR_DQUOTE] = ACTIONS(3880),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3880),
    [anon_sym_co_await] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_requires] = ACTIONS(3878),
    [sym_this] = ACTIONS(3878),
    [anon_sym_discard] = ACTIONS(3878),
    [anon_sym_precise] = ACTIONS(3878),
    [anon_sym_shared] = ACTIONS(3878),
    [anon_sym_groupshared] = ACTIONS(3878),
    [anon_sym_uniform] = ACTIONS(3878),
    [anon_sym_row_major] = ACTIONS(3878),
    [anon_sym_column_major] = ACTIONS(3878),
    [anon_sym_globallycoherent] = ACTIONS(3878),
    [anon_sym_centroid] = ACTIONS(3878),
    [anon_sym_noperspective] = ACTIONS(3878),
    [anon_sym_nointerpolation] = ACTIONS(3878),
    [anon_sym_sample] = ACTIONS(3878),
    [anon_sym_linear] = ACTIONS(3878),
    [anon_sym_snorm] = ACTIONS(3878),
    [anon_sym_unorm] = ACTIONS(3878),
    [anon_sym_point] = ACTIONS(3878),
    [anon_sym_line] = ACTIONS(3878),
    [anon_sym_triangleadj] = ACTIONS(3878),
    [anon_sym_lineadj] = ACTIONS(3878),
    [anon_sym_triangle] = ACTIONS(3878),
    [anon_sym_cbuffer] = ACTIONS(3878),
  },
  [950] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_RBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [951] = {
    [sym_compound_statement] = STATE(8621),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3319),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8621),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(9048),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8330),
    [sym__unary_right_fold] = STATE(8333),
    [sym__binary_fold] = STATE(8338),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8830),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [952] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8857),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [953] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8726),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [954] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8457),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [955] = {
    [sym_compound_statement] = STATE(9044),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3303),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8251),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8263),
    [sym__unary_right_fold] = STATE(8285),
    [sym__binary_fold] = STATE(8310),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8329),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [956] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8820),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [957] = {
    [sym_compound_statement] = STATE(8621),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3319),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8621),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8324),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8330),
    [sym__unary_right_fold] = STATE(8333),
    [sym__binary_fold] = STATE(8338),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8830),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [958] = {
    [sym_compound_statement] = STATE(9044),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3303),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8391),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8263),
    [sym__unary_right_fold] = STATE(8285),
    [sym__binary_fold] = STATE(8310),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8329),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [959] = {
    [sym_compound_statement] = STATE(9044),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3303),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8650),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8652),
    [sym__unary_right_fold] = STATE(8658),
    [sym__binary_fold] = STATE(8659),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8329),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [960] = {
    [sym_compound_statement] = STATE(9044),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3303),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(9044),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8825),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8652),
    [sym__unary_right_fold] = STATE(8658),
    [sym__binary_fold] = STATE(8659),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8329),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [961] = {
    [sym_compound_statement] = STATE(8621),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3319),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8621),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8730),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8768),
    [sym__unary_right_fold] = STATE(8810),
    [sym__binary_fold] = STATE(8886),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8830),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [962] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(3916),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [963] = {
    [sym_compound_statement] = STATE(8621),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3319),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8621),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8247),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8768),
    [sym__unary_right_fold] = STATE(8810),
    [sym__binary_fold] = STATE(8886),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8830),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [964] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8693),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [965] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8339),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [966] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8947),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [967] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8722),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [968] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8991),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [969] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8407),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [970] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8954),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [971] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8543),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [972] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8637),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [973] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8595),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [974] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8839),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [975] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8675),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [976] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(9035),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [977] = {
    [sym_compound_statement] = STATE(8559),
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(3645),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_type_descriptor] = STATE(8808),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(7911),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5977),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(3908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [978] = {
    [sym_function_definition] = STATE(2158),
    [sym_declaration] = STATE(2158),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4969),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2023),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6366),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2332),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(2158),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1898),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(2158),
    [sym_operator_cast] = STATE(7025),
    [sym__constructor_specifiers] = STATE(1898),
    [sym_operator_cast_definition] = STATE(2158),
    [sym_operator_cast_declaration] = STATE(2158),
    [sym_constructor_or_destructor_definition] = STATE(2158),
    [sym_constructor_or_destructor_declaration] = STATE(2158),
    [sym_friend_declaration] = STATE(2158),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(2158),
    [sym_concept_definition] = STATE(2158),
    [sym_requires_clause] = STATE(999),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7025),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1493),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3189),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3191),
    [anon_sym_concept] = ACTIONS(3946),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [979] = {
    [sym_expression] = STATE(3490),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_initializer_list] = STATE(3677),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(2050),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3802),
    [sym_this] = ACTIONS(2094),
  },
  [980] = {
    [sym_function_definition] = STATE(621),
    [sym_declaration] = STATE(621),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2032),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6395),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2342),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(621),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1897),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(621),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(1897),
    [sym_operator_cast_definition] = STATE(621),
    [sym_operator_cast_declaration] = STATE(621),
    [sym_constructor_or_destructor_definition] = STATE(621),
    [sym_constructor_or_destructor_declaration] = STATE(621),
    [sym_friend_declaration] = STATE(621),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(621),
    [sym_concept_definition] = STATE(621),
    [sym_requires_clause] = STATE(993),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1485),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1897),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3962),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3964),
    [anon_sym_concept] = ACTIONS(825),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [981] = {
    [sym_function_definition] = STATE(381),
    [sym_declaration] = STATE(381),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6365),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(381),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1905),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(381),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1905),
    [sym_operator_cast_definition] = STATE(381),
    [sym_operator_cast_declaration] = STATE(381),
    [sym_constructor_or_destructor_definition] = STATE(381),
    [sym_constructor_or_destructor_declaration] = STATE(381),
    [sym_friend_declaration] = STATE(381),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(381),
    [sym_concept_definition] = STATE(381),
    [sym_requires_clause] = STATE(996),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1452),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3968),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3970),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3972),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [982] = {
    [sym_function_definition] = STATE(1992),
    [sym_declaration] = STATE(1992),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4968),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2022),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2334),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(1992),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(1992),
    [sym_operator_cast] = STATE(7046),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(1992),
    [sym_operator_cast_declaration] = STATE(1992),
    [sym_constructor_or_destructor_definition] = STATE(1992),
    [sym_constructor_or_destructor_declaration] = STATE(1992),
    [sym_friend_declaration] = STATE(1992),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(1992),
    [sym_concept_definition] = STATE(1992),
    [sym_requires_clause] = STATE(995),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1490),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3974),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_concept] = ACTIONS(3976),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [983] = {
    [sym_function_definition] = STATE(801),
    [sym_declaration] = STATE(801),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6406),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(801),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1911),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(801),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1911),
    [sym_operator_cast_definition] = STATE(801),
    [sym_operator_cast_declaration] = STATE(801),
    [sym_constructor_or_destructor_definition] = STATE(801),
    [sym_constructor_or_destructor_declaration] = STATE(801),
    [sym_friend_declaration] = STATE(801),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(801),
    [sym_concept_definition] = STATE(801),
    [sym_requires_clause] = STATE(994),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1499),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1911),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3978),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3982),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3984),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [984] = {
    [sym_function_definition] = STATE(2110),
    [sym_declaration] = STATE(2110),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4966),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2035),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2333),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(2110),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(2110),
    [sym_operator_cast] = STATE(7024),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(2110),
    [sym_operator_cast_declaration] = STATE(2110),
    [sym_constructor_or_destructor_definition] = STATE(2110),
    [sym_constructor_or_destructor_declaration] = STATE(2110),
    [sym_friend_declaration] = STATE(2110),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(2110),
    [sym_concept_definition] = STATE(2110),
    [sym_requires_clause] = STATE(990),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1444),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3986),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_concept] = ACTIONS(3988),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [985] = {
    [sym_function_definition] = STATE(623),
    [sym_declaration] = STATE(623),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6404),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(623),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1909),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(623),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1909),
    [sym_operator_cast_definition] = STATE(623),
    [sym_operator_cast_declaration] = STATE(623),
    [sym_constructor_or_destructor_definition] = STATE(623),
    [sym_constructor_or_destructor_declaration] = STATE(623),
    [sym_friend_declaration] = STATE(623),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(623),
    [sym_concept_definition] = STATE(623),
    [sym_requires_clause] = STATE(991),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1909),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3990),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3994),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3996),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_requires] = ACTIONS(3948),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [986] = {
    [sym_field_declaration_list] = STATE(1084),
    [sym_virtual_specifier] = STATE(7213),
    [sym_base_class_clause] = STATE(7884),
    [sym_identifier] = ACTIONS(1957),
    [anon_sym_LPAREN2] = ACTIONS(1959),
    [anon_sym_BANG] = ACTIONS(1959),
    [anon_sym_TILDE] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1959),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1959),
    [anon_sym___extension__] = ACTIONS(1957),
    [anon_sym_typedef] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_inout] = ACTIONS(1957),
    [anon_sym_virtual] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1957),
    [anon_sym___attribute__] = ACTIONS(1957),
    [anon_sym___attribute] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1959),
    [anon_sym___declspec] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_signed] = ACTIONS(1957),
    [anon_sym_unsigned] = ACTIONS(1957),
    [anon_sym_long] = ACTIONS(1957),
    [anon_sym_short] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_static] = ACTIONS(1957),
    [anon_sym_register] = ACTIONS(1957),
    [anon_sym_inline] = ACTIONS(1957),
    [anon_sym___inline] = ACTIONS(1957),
    [anon_sym___inline__] = ACTIONS(1957),
    [anon_sym___forceinline] = ACTIONS(1957),
    [anon_sym_thread_local] = ACTIONS(1957),
    [anon_sym___thread] = ACTIONS(1957),
    [anon_sym_const] = ACTIONS(1957),
    [anon_sym_constexpr] = ACTIONS(1957),
    [anon_sym_volatile] = ACTIONS(1957),
    [anon_sym_restrict] = ACTIONS(1957),
    [anon_sym___restrict__] = ACTIONS(1957),
    [anon_sym__Atomic] = ACTIONS(1957),
    [anon_sym__Noreturn] = ACTIONS(1957),
    [anon_sym_noreturn] = ACTIONS(1957),
    [anon_sym__Nonnull] = ACTIONS(1957),
    [anon_sym_mutable] = ACTIONS(1957),
    [anon_sym_constinit] = ACTIONS(1957),
    [anon_sym_consteval] = ACTIONS(1957),
    [anon_sym_alignas] = ACTIONS(1957),
    [anon_sym__Alignas] = ACTIONS(1957),
    [sym_primitive_type] = ACTIONS(1957),
    [anon_sym_enum] = ACTIONS(1957),
    [anon_sym_class] = ACTIONS(1957),
    [anon_sym_struct] = ACTIONS(1957),
    [anon_sym_union] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_switch] = ACTIONS(1957),
    [anon_sym_while] = ACTIONS(1957),
    [anon_sym_do] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_return] = ACTIONS(1957),
    [anon_sym_break] = ACTIONS(1957),
    [anon_sym_continue] = ACTIONS(1957),
    [anon_sym_goto] = ACTIONS(1957),
    [anon_sym___try] = ACTIONS(1957),
    [anon_sym___leave] = ACTIONS(1957),
    [anon_sym_not] = ACTIONS(1957),
    [anon_sym_compl] = ACTIONS(1957),
    [anon_sym_DASH_DASH] = ACTIONS(1959),
    [anon_sym_PLUS_PLUS] = ACTIONS(1959),
    [anon_sym_sizeof] = ACTIONS(1957),
    [anon_sym___alignof__] = ACTIONS(1957),
    [anon_sym___alignof] = ACTIONS(1957),
    [anon_sym__alignof] = ACTIONS(1957),
    [anon_sym_alignof] = ACTIONS(1957),
    [anon_sym__Alignof] = ACTIONS(1957),
    [anon_sym_offsetof] = ACTIONS(1957),
    [anon_sym__Generic] = ACTIONS(1957),
    [anon_sym_asm] = ACTIONS(1957),
    [anon_sym___asm__] = ACTIONS(1957),
    [anon_sym___asm] = ACTIONS(1957),
    [sym_number_literal] = ACTIONS(1959),
    [anon_sym_L_SQUOTE] = ACTIONS(1959),
    [anon_sym_u_SQUOTE] = ACTIONS(1959),
    [anon_sym_U_SQUOTE] = ACTIONS(1959),
    [anon_sym_u8_SQUOTE] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_L_DQUOTE] = ACTIONS(1959),
    [anon_sym_u_DQUOTE] = ACTIONS(1959),
    [anon_sym_U_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8_DQUOTE] = ACTIONS(1959),
    [anon_sym_DQUOTE] = ACTIONS(1959),
    [sym_true] = ACTIONS(1957),
    [sym_false] = ACTIONS(1957),
    [anon_sym_NULL] = ACTIONS(1957),
    [anon_sym_nullptr] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1957),
    [anon_sym_decltype] = ACTIONS(1957),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_typename] = ACTIONS(1957),
    [anon_sym_template] = ACTIONS(1957),
    [anon_sym_try] = ACTIONS(1957),
    [anon_sym_delete] = ACTIONS(1957),
    [anon_sym_throw] = ACTIONS(1957),
    [anon_sym_co_return] = ACTIONS(1957),
    [anon_sym_co_yield] = ACTIONS(1957),
    [anon_sym_R_DQUOTE] = ACTIONS(1959),
    [anon_sym_LR_DQUOTE] = ACTIONS(1959),
    [anon_sym_uR_DQUOTE] = ACTIONS(1959),
    [anon_sym_UR_DQUOTE] = ACTIONS(1959),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1959),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1957),
    [anon_sym_requires] = ACTIONS(1957),
    [sym_this] = ACTIONS(1957),
    [anon_sym_discard] = ACTIONS(1957),
    [anon_sym_precise] = ACTIONS(1957),
    [anon_sym_shared] = ACTIONS(1957),
    [anon_sym_groupshared] = ACTIONS(1957),
    [anon_sym_uniform] = ACTIONS(1957),
    [anon_sym_row_major] = ACTIONS(1957),
    [anon_sym_column_major] = ACTIONS(1957),
    [anon_sym_globallycoherent] = ACTIONS(1957),
    [anon_sym_centroid] = ACTIONS(1957),
    [anon_sym_noperspective] = ACTIONS(1957),
    [anon_sym_nointerpolation] = ACTIONS(1957),
    [anon_sym_sample] = ACTIONS(1957),
    [anon_sym_linear] = ACTIONS(1957),
    [anon_sym_snorm] = ACTIONS(1957),
    [anon_sym_unorm] = ACTIONS(1957),
    [anon_sym_point] = ACTIONS(1957),
    [anon_sym_line] = ACTIONS(1957),
    [anon_sym_triangleadj] = ACTIONS(1957),
    [anon_sym_lineadj] = ACTIONS(1957),
    [anon_sym_triangle] = ACTIONS(1957),
    [anon_sym_cbuffer] = ACTIONS(1957),
  },
  [987] = {
    [sym_expression] = STATE(3635),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [988] = {
    [sym_field_declaration_list] = STATE(1064),
    [sym_virtual_specifier] = STATE(7246),
    [sym_base_class_clause] = STATE(7902),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_LPAREN2] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_TILDE] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym___extension__] = ACTIONS(1967),
    [anon_sym_typedef] = ACTIONS(1967),
    [anon_sym_in] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1967),
    [anon_sym_inout] = ACTIONS(1967),
    [anon_sym_virtual] = ACTIONS(1967),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym___attribute__] = ACTIONS(1967),
    [anon_sym___attribute] = ACTIONS(1967),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1969),
    [anon_sym___declspec] = ACTIONS(1967),
    [anon_sym_LBRACE] = ACTIONS(3998),
    [anon_sym_signed] = ACTIONS(1967),
    [anon_sym_unsigned] = ACTIONS(1967),
    [anon_sym_long] = ACTIONS(1967),
    [anon_sym_short] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_register] = ACTIONS(1967),
    [anon_sym_inline] = ACTIONS(1967),
    [anon_sym___inline] = ACTIONS(1967),
    [anon_sym___inline__] = ACTIONS(1967),
    [anon_sym___forceinline] = ACTIONS(1967),
    [anon_sym_thread_local] = ACTIONS(1967),
    [anon_sym___thread] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_constexpr] = ACTIONS(1967),
    [anon_sym_volatile] = ACTIONS(1967),
    [anon_sym_restrict] = ACTIONS(1967),
    [anon_sym___restrict__] = ACTIONS(1967),
    [anon_sym__Atomic] = ACTIONS(1967),
    [anon_sym__Noreturn] = ACTIONS(1967),
    [anon_sym_noreturn] = ACTIONS(1967),
    [anon_sym__Nonnull] = ACTIONS(1967),
    [anon_sym_mutable] = ACTIONS(1967),
    [anon_sym_constinit] = ACTIONS(1967),
    [anon_sym_consteval] = ACTIONS(1967),
    [anon_sym_alignas] = ACTIONS(1967),
    [anon_sym__Alignas] = ACTIONS(1967),
    [sym_primitive_type] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_class] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_else] = ACTIONS(1967),
    [anon_sym_switch] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_goto] = ACTIONS(1967),
    [anon_sym___try] = ACTIONS(1967),
    [anon_sym___leave] = ACTIONS(1967),
    [anon_sym_not] = ACTIONS(1967),
    [anon_sym_compl] = ACTIONS(1967),
    [anon_sym_DASH_DASH] = ACTIONS(1969),
    [anon_sym_PLUS_PLUS] = ACTIONS(1969),
    [anon_sym_sizeof] = ACTIONS(1967),
    [anon_sym___alignof__] = ACTIONS(1967),
    [anon_sym___alignof] = ACTIONS(1967),
    [anon_sym__alignof] = ACTIONS(1967),
    [anon_sym_alignof] = ACTIONS(1967),
    [anon_sym__Alignof] = ACTIONS(1967),
    [anon_sym_offsetof] = ACTIONS(1967),
    [anon_sym__Generic] = ACTIONS(1967),
    [anon_sym_asm] = ACTIONS(1967),
    [anon_sym___asm__] = ACTIONS(1967),
    [anon_sym___asm] = ACTIONS(1967),
    [sym_number_literal] = ACTIONS(1969),
    [anon_sym_L_SQUOTE] = ACTIONS(1969),
    [anon_sym_u_SQUOTE] = ACTIONS(1969),
    [anon_sym_U_SQUOTE] = ACTIONS(1969),
    [anon_sym_u8_SQUOTE] = ACTIONS(1969),
    [anon_sym_SQUOTE] = ACTIONS(1969),
    [anon_sym_L_DQUOTE] = ACTIONS(1969),
    [anon_sym_u_DQUOTE] = ACTIONS(1969),
    [anon_sym_U_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8_DQUOTE] = ACTIONS(1969),
    [anon_sym_DQUOTE] = ACTIONS(1969),
    [sym_true] = ACTIONS(1967),
    [sym_false] = ACTIONS(1967),
    [anon_sym_NULL] = ACTIONS(1967),
    [anon_sym_nullptr] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1967),
    [anon_sym_decltype] = ACTIONS(1967),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_typename] = ACTIONS(1967),
    [anon_sym_template] = ACTIONS(1967),
    [anon_sym_try] = ACTIONS(1967),
    [anon_sym_delete] = ACTIONS(1967),
    [anon_sym_throw] = ACTIONS(1967),
    [anon_sym_co_return] = ACTIONS(1967),
    [anon_sym_co_yield] = ACTIONS(1967),
    [anon_sym_R_DQUOTE] = ACTIONS(1969),
    [anon_sym_LR_DQUOTE] = ACTIONS(1969),
    [anon_sym_uR_DQUOTE] = ACTIONS(1969),
    [anon_sym_UR_DQUOTE] = ACTIONS(1969),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1969),
    [anon_sym_co_await] = ACTIONS(1967),
    [anon_sym_new] = ACTIONS(1967),
    [anon_sym_requires] = ACTIONS(1967),
    [sym_this] = ACTIONS(1967),
    [anon_sym_discard] = ACTIONS(1967),
    [anon_sym_precise] = ACTIONS(1967),
    [anon_sym_shared] = ACTIONS(1967),
    [anon_sym_groupshared] = ACTIONS(1967),
    [anon_sym_uniform] = ACTIONS(1967),
    [anon_sym_row_major] = ACTIONS(1967),
    [anon_sym_column_major] = ACTIONS(1967),
    [anon_sym_globallycoherent] = ACTIONS(1967),
    [anon_sym_centroid] = ACTIONS(1967),
    [anon_sym_noperspective] = ACTIONS(1967),
    [anon_sym_nointerpolation] = ACTIONS(1967),
    [anon_sym_sample] = ACTIONS(1967),
    [anon_sym_linear] = ACTIONS(1967),
    [anon_sym_snorm] = ACTIONS(1967),
    [anon_sym_unorm] = ACTIONS(1967),
    [anon_sym_point] = ACTIONS(1967),
    [anon_sym_line] = ACTIONS(1967),
    [anon_sym_triangleadj] = ACTIONS(1967),
    [anon_sym_lineadj] = ACTIONS(1967),
    [anon_sym_triangle] = ACTIONS(1967),
    [anon_sym_cbuffer] = ACTIONS(1967),
  },
  [989] = {
    [sym_expression] = STATE(3609),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_initializer_list] = STATE(3880),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4016),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3800),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3800),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_and_eq] = ACTIONS(3800),
    [anon_sym_or_eq] = ACTIONS(3800),
    [anon_sym_xor_eq] = ACTIONS(3800),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(3802),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [990] = {
    [sym_function_definition] = STATE(2134),
    [sym_declaration] = STATE(2134),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4966),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2035),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6402),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2333),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(2134),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1902),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(2134),
    [sym_operator_cast] = STATE(7024),
    [sym__constructor_specifiers] = STATE(1902),
    [sym_operator_cast_definition] = STATE(2134),
    [sym_operator_cast_declaration] = STATE(2134),
    [sym_constructor_or_destructor_definition] = STATE(2134),
    [sym_constructor_or_destructor_declaration] = STATE(2134),
    [sym_friend_declaration] = STATE(2134),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(2134),
    [sym_concept_definition] = STATE(2134),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7024),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1444),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1902),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3986),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3143),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3145),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3147),
    [anon_sym_concept] = ACTIONS(3988),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [991] = {
    [sym_function_definition] = STATE(620),
    [sym_declaration] = STATE(620),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2033),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6404),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2329),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(620),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1909),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(620),
    [sym_operator_cast] = STATE(7018),
    [sym__constructor_specifiers] = STATE(1909),
    [sym_operator_cast_definition] = STATE(620),
    [sym_operator_cast_declaration] = STATE(620),
    [sym_constructor_or_destructor_definition] = STATE(620),
    [sym_constructor_or_destructor_declaration] = STATE(620),
    [sym_friend_declaration] = STATE(620),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(620),
    [sym_concept_definition] = STATE(620),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7018),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1909),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3990),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3992),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3994),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3996),
    [anon_sym_concept] = ACTIONS(243),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [992] = {
    [sym_template_argument_list] = STATE(1004),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_BANG] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_typedef] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2005),
    [anon_sym_while] = ACTIONS(2005),
    [anon_sym_do] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2005),
    [anon_sym_return] = ACTIONS(2005),
    [anon_sym_break] = ACTIONS(2005),
    [anon_sym_continue] = ACTIONS(2005),
    [anon_sym_goto] = ACTIONS(2005),
    [anon_sym___try] = ACTIONS(2005),
    [anon_sym___leave] = ACTIONS(2005),
    [anon_sym_not] = ACTIONS(2005),
    [anon_sym_compl] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_sizeof] = ACTIONS(2005),
    [anon_sym___alignof__] = ACTIONS(2005),
    [anon_sym___alignof] = ACTIONS(2005),
    [anon_sym__alignof] = ACTIONS(2005),
    [anon_sym_alignof] = ACTIONS(2005),
    [anon_sym__Alignof] = ACTIONS(2005),
    [anon_sym_offsetof] = ACTIONS(2005),
    [anon_sym__Generic] = ACTIONS(2005),
    [anon_sym_asm] = ACTIONS(2005),
    [anon_sym___asm__] = ACTIONS(2005),
    [anon_sym___asm] = ACTIONS(2005),
    [sym_number_literal] = ACTIONS(2007),
    [anon_sym_L_SQUOTE] = ACTIONS(2007),
    [anon_sym_u_SQUOTE] = ACTIONS(2007),
    [anon_sym_U_SQUOTE] = ACTIONS(2007),
    [anon_sym_u8_SQUOTE] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_L_DQUOTE] = ACTIONS(2007),
    [anon_sym_u_DQUOTE] = ACTIONS(2007),
    [anon_sym_U_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8_DQUOTE] = ACTIONS(2007),
    [anon_sym_DQUOTE] = ACTIONS(2007),
    [sym_true] = ACTIONS(2005),
    [sym_false] = ACTIONS(2005),
    [anon_sym_NULL] = ACTIONS(2005),
    [anon_sym_nullptr] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_delete] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_co_return] = ACTIONS(2005),
    [anon_sym_co_yield] = ACTIONS(2005),
    [anon_sym_R_DQUOTE] = ACTIONS(2007),
    [anon_sym_LR_DQUOTE] = ACTIONS(2007),
    [anon_sym_uR_DQUOTE] = ACTIONS(2007),
    [anon_sym_UR_DQUOTE] = ACTIONS(2007),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2007),
    [anon_sym_co_await] = ACTIONS(2005),
    [anon_sym_new] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [sym_this] = ACTIONS(2005),
    [anon_sym_discard] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
    [anon_sym_cbuffer] = ACTIONS(2005),
  },
  [993] = {
    [sym_function_definition] = STATE(639),
    [sym_declaration] = STATE(639),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2032),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6395),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2342),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(639),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1897),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(639),
    [sym_operator_cast] = STATE(6990),
    [sym__constructor_specifiers] = STATE(1897),
    [sym_operator_cast_definition] = STATE(639),
    [sym_operator_cast_declaration] = STATE(639),
    [sym_constructor_or_destructor_definition] = STATE(639),
    [sym_constructor_or_destructor_declaration] = STATE(639),
    [sym_friend_declaration] = STATE(639),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(639),
    [sym_concept_definition] = STATE(639),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(6990),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1485),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1897),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3958),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3962),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3964),
    [anon_sym_concept] = ACTIONS(825),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [994] = {
    [sym_function_definition] = STATE(764),
    [sym_declaration] = STATE(764),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2031),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6406),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2341),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(764),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1911),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(764),
    [sym_operator_cast] = STATE(7015),
    [sym__constructor_specifiers] = STATE(1911),
    [sym_operator_cast_definition] = STATE(764),
    [sym_operator_cast_declaration] = STATE(764),
    [sym_constructor_or_destructor_definition] = STATE(764),
    [sym_constructor_or_destructor_declaration] = STATE(764),
    [sym_friend_declaration] = STATE(764),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(764),
    [sym_concept_definition] = STATE(764),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7015),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1499),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1911),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3978),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3980),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3982),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3984),
    [anon_sym_concept] = ACTIONS(153),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [995] = {
    [sym_function_definition] = STATE(1938),
    [sym_declaration] = STATE(1938),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4968),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2022),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6355),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2334),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(1938),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1899),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(1938),
    [sym_operator_cast] = STATE(7046),
    [sym__constructor_specifiers] = STATE(1899),
    [sym_operator_cast_definition] = STATE(1938),
    [sym_operator_cast_declaration] = STATE(1938),
    [sym_constructor_or_destructor_definition] = STATE(1938),
    [sym_constructor_or_destructor_declaration] = STATE(1938),
    [sym_friend_declaration] = STATE(1938),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(1938),
    [sym_concept_definition] = STATE(1938),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7046),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1490),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1899),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3974),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(2734),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(2750),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(2752),
    [anon_sym_concept] = ACTIONS(3976),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [996] = {
    [sym_function_definition] = STATE(415),
    [sym_declaration] = STATE(415),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2028),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6365),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2335),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(415),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1905),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(415),
    [sym_operator_cast] = STATE(7032),
    [sym__constructor_specifiers] = STATE(1905),
    [sym_operator_cast_definition] = STATE(415),
    [sym_operator_cast_declaration] = STATE(415),
    [sym_constructor_or_destructor_definition] = STATE(415),
    [sym_constructor_or_destructor_declaration] = STATE(415),
    [sym_friend_declaration] = STATE(415),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(415),
    [sym_concept_definition] = STATE(415),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7032),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1452),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1905),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3968),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3970),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3972),
    [anon_sym_concept] = ACTIONS(343),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [997] = {
    [sym_template_argument_list] = STATE(1004),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_BANG] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(4058),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_typedef] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(1997),
    [anon_sym_else] = ACTIONS(1997),
    [anon_sym_switch] = ACTIONS(1997),
    [anon_sym_while] = ACTIONS(1997),
    [anon_sym_do] = ACTIONS(1997),
    [anon_sym_for] = ACTIONS(1997),
    [anon_sym_return] = ACTIONS(1997),
    [anon_sym_break] = ACTIONS(1997),
    [anon_sym_continue] = ACTIONS(1997),
    [anon_sym_goto] = ACTIONS(1997),
    [anon_sym___try] = ACTIONS(1997),
    [anon_sym___leave] = ACTIONS(1997),
    [anon_sym_not] = ACTIONS(1997),
    [anon_sym_compl] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_sizeof] = ACTIONS(1997),
    [anon_sym___alignof__] = ACTIONS(1997),
    [anon_sym___alignof] = ACTIONS(1997),
    [anon_sym__alignof] = ACTIONS(1997),
    [anon_sym_alignof] = ACTIONS(1997),
    [anon_sym__Alignof] = ACTIONS(1997),
    [anon_sym_offsetof] = ACTIONS(1997),
    [anon_sym__Generic] = ACTIONS(1997),
    [anon_sym_asm] = ACTIONS(1997),
    [anon_sym___asm__] = ACTIONS(1997),
    [anon_sym___asm] = ACTIONS(1997),
    [sym_number_literal] = ACTIONS(1999),
    [anon_sym_L_SQUOTE] = ACTIONS(1999),
    [anon_sym_u_SQUOTE] = ACTIONS(1999),
    [anon_sym_U_SQUOTE] = ACTIONS(1999),
    [anon_sym_u8_SQUOTE] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_L_DQUOTE] = ACTIONS(1999),
    [anon_sym_u_DQUOTE] = ACTIONS(1999),
    [anon_sym_U_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8_DQUOTE] = ACTIONS(1999),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [sym_true] = ACTIONS(1997),
    [sym_false] = ACTIONS(1997),
    [anon_sym_NULL] = ACTIONS(1997),
    [anon_sym_nullptr] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_delete] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_co_return] = ACTIONS(1997),
    [anon_sym_co_yield] = ACTIONS(1997),
    [anon_sym_R_DQUOTE] = ACTIONS(1999),
    [anon_sym_LR_DQUOTE] = ACTIONS(1999),
    [anon_sym_uR_DQUOTE] = ACTIONS(1999),
    [anon_sym_UR_DQUOTE] = ACTIONS(1999),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1999),
    [anon_sym_co_await] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [sym_this] = ACTIONS(1997),
    [anon_sym_discard] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
    [anon_sym_cbuffer] = ACTIONS(1997),
  },
  [998] = {
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_LPAREN2] = ACTIONS(4063),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_TILDE] = ACTIONS(4063),
    [anon_sym_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_STAR] = ACTIONS(4063),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4060),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym___extension__] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_out] = ACTIONS(4072),
    [anon_sym_inout] = ACTIONS(4072),
    [anon_sym_virtual] = ACTIONS(4072),
    [anon_sym_extern] = ACTIONS(4072),
    [anon_sym___attribute__] = ACTIONS(4072),
    [anon_sym___attribute] = ACTIONS(4072),
    [anon_sym_using] = ACTIONS(4068),
    [anon_sym_COLON_COLON] = ACTIONS(4063),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4063),
    [anon_sym___declspec] = ACTIONS(4072),
    [anon_sym___based] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4066),
    [anon_sym_signed] = ACTIONS(4072),
    [anon_sym_unsigned] = ACTIONS(4072),
    [anon_sym_long] = ACTIONS(4072),
    [anon_sym_short] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [anon_sym_static] = ACTIONS(4072),
    [anon_sym_register] = ACTIONS(4072),
    [anon_sym_inline] = ACTIONS(4072),
    [anon_sym___inline] = ACTIONS(4072),
    [anon_sym___inline__] = ACTIONS(4072),
    [anon_sym___forceinline] = ACTIONS(4072),
    [anon_sym_thread_local] = ACTIONS(4072),
    [anon_sym___thread] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4072),
    [anon_sym_constexpr] = ACTIONS(4072),
    [anon_sym_volatile] = ACTIONS(4072),
    [anon_sym_restrict] = ACTIONS(4072),
    [anon_sym___restrict__] = ACTIONS(4072),
    [anon_sym__Atomic] = ACTIONS(4072),
    [anon_sym__Noreturn] = ACTIONS(4072),
    [anon_sym_noreturn] = ACTIONS(4072),
    [anon_sym__Nonnull] = ACTIONS(4072),
    [anon_sym_mutable] = ACTIONS(4072),
    [anon_sym_constinit] = ACTIONS(4072),
    [anon_sym_consteval] = ACTIONS(4072),
    [anon_sym_alignas] = ACTIONS(4072),
    [anon_sym__Alignas] = ACTIONS(4072),
    [sym_primitive_type] = ACTIONS(4060),
    [anon_sym_enum] = ACTIONS(4072),
    [anon_sym_class] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4072),
    [anon_sym_union] = ACTIONS(4072),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_case] = ACTIONS(4068),
    [anon_sym_default] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_return] = ACTIONS(4068),
    [anon_sym_break] = ACTIONS(4068),
    [anon_sym_continue] = ACTIONS(4068),
    [anon_sym_goto] = ACTIONS(4068),
    [anon_sym___try] = ACTIONS(4068),
    [anon_sym___leave] = ACTIONS(4068),
    [anon_sym_not] = ACTIONS(4068),
    [anon_sym_compl] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4066),
    [anon_sym_sizeof] = ACTIONS(4068),
    [anon_sym___alignof__] = ACTIONS(4068),
    [anon_sym___alignof] = ACTIONS(4068),
    [anon_sym__alignof] = ACTIONS(4068),
    [anon_sym_alignof] = ACTIONS(4068),
    [anon_sym__Alignof] = ACTIONS(4068),
    [anon_sym_offsetof] = ACTIONS(4068),
    [anon_sym__Generic] = ACTIONS(4068),
    [anon_sym_asm] = ACTIONS(4068),
    [anon_sym___asm__] = ACTIONS(4068),
    [anon_sym___asm] = ACTIONS(4068),
    [sym_number_literal] = ACTIONS(4066),
    [anon_sym_L_SQUOTE] = ACTIONS(4066),
    [anon_sym_u_SQUOTE] = ACTIONS(4066),
    [anon_sym_U_SQUOTE] = ACTIONS(4066),
    [anon_sym_u8_SQUOTE] = ACTIONS(4066),
    [anon_sym_SQUOTE] = ACTIONS(4066),
    [anon_sym_L_DQUOTE] = ACTIONS(4066),
    [anon_sym_u_DQUOTE] = ACTIONS(4066),
    [anon_sym_U_DQUOTE] = ACTIONS(4066),
    [anon_sym_u8_DQUOTE] = ACTIONS(4066),
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [sym_true] = ACTIONS(4068),
    [sym_false] = ACTIONS(4068),
    [anon_sym_NULL] = ACTIONS(4068),
    [anon_sym_nullptr] = ACTIONS(4068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4072),
    [anon_sym_decltype] = ACTIONS(4060),
    [anon_sym_explicit] = ACTIONS(4072),
    [anon_sym_typename] = ACTIONS(4072),
    [anon_sym_template] = ACTIONS(4060),
    [anon_sym_operator] = ACTIONS(4072),
    [anon_sym_try] = ACTIONS(4068),
    [anon_sym_delete] = ACTIONS(4068),
    [anon_sym_throw] = ACTIONS(4068),
    [anon_sym_co_return] = ACTIONS(4068),
    [anon_sym_co_yield] = ACTIONS(4068),
    [anon_sym_R_DQUOTE] = ACTIONS(4066),
    [anon_sym_LR_DQUOTE] = ACTIONS(4066),
    [anon_sym_uR_DQUOTE] = ACTIONS(4066),
    [anon_sym_UR_DQUOTE] = ACTIONS(4066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4066),
    [anon_sym_co_await] = ACTIONS(4068),
    [anon_sym_new] = ACTIONS(4068),
    [anon_sym_requires] = ACTIONS(4068),
    [sym_this] = ACTIONS(4068),
    [anon_sym_discard] = ACTIONS(4068),
    [anon_sym_precise] = ACTIONS(4072),
    [anon_sym_shared] = ACTIONS(4072),
    [anon_sym_groupshared] = ACTIONS(4072),
    [anon_sym_uniform] = ACTIONS(4072),
    [anon_sym_row_major] = ACTIONS(4072),
    [anon_sym_column_major] = ACTIONS(4072),
    [anon_sym_globallycoherent] = ACTIONS(4072),
    [anon_sym_centroid] = ACTIONS(4072),
    [anon_sym_noperspective] = ACTIONS(4072),
    [anon_sym_nointerpolation] = ACTIONS(4072),
    [anon_sym_sample] = ACTIONS(4072),
    [anon_sym_linear] = ACTIONS(4072),
    [anon_sym_snorm] = ACTIONS(4072),
    [anon_sym_unorm] = ACTIONS(4072),
    [anon_sym_point] = ACTIONS(4072),
    [anon_sym_line] = ACTIONS(4072),
    [anon_sym_triangleadj] = ACTIONS(4072),
    [anon_sym_lineadj] = ACTIONS(4072),
    [anon_sym_triangle] = ACTIONS(4072),
    [anon_sym_cbuffer] = ACTIONS(4068),
  },
  [999] = {
    [sym_function_definition] = STATE(2176),
    [sym_declaration] = STATE(2176),
    [sym__declaration_modifiers] = STATE(2477),
    [sym__declaration_specifiers] = STATE(4969),
    [sym_attribute_specifier] = STATE(2477),
    [sym_attribute_declaration] = STATE(2477),
    [sym_ms_declspec_modifier] = STATE(2477),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(2023),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6366),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2477),
    [sym_type_qualifier] = STATE(2477),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2332),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym__empty_declaration] = STATE(2176),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_explicit_function_specifier] = STATE(1898),
    [sym_dependent_type] = STATE(2348),
    [sym_template_declaration] = STATE(2176),
    [sym_operator_cast] = STATE(7025),
    [sym__constructor_specifiers] = STATE(1898),
    [sym_operator_cast_definition] = STATE(2176),
    [sym_operator_cast_declaration] = STATE(2176),
    [sym_constructor_or_destructor_definition] = STATE(2176),
    [sym_constructor_or_destructor_declaration] = STATE(2176),
    [sym_friend_declaration] = STATE(2176),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_alias_declaration] = STATE(2176),
    [sym_concept_definition] = STATE(2176),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5707),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualified_operator_cast_identifier] = STATE(7025),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2477),
    [sym_hlsl_attribute] = STATE(1493),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1898),
    [sym_identifier] = ACTIONS(3938),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(39),
    [anon_sym_out] = ACTIONS(39),
    [anon_sym_inout] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(3940),
    [anon_sym_COLON_COLON] = ACTIONS(3942),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(3944),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(3187),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(3189),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_friend] = ACTIONS(3191),
    [anon_sym_concept] = ACTIONS(3946),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1000] = {
    [sym_expression] = STATE(3945),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_initializer_list] = STATE(4140),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(1881),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3800),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3800),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3800),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_EQ] = ACTIONS(3800),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_STAR_EQ] = ACTIONS(3802),
    [anon_sym_SLASH_EQ] = ACTIONS(3802),
    [anon_sym_PERCENT_EQ] = ACTIONS(3802),
    [anon_sym_PLUS_EQ] = ACTIONS(3802),
    [anon_sym_DASH_EQ] = ACTIONS(3802),
    [anon_sym_LT_LT_EQ] = ACTIONS(3802),
    [anon_sym_GT_GT_EQ] = ACTIONS(3802),
    [anon_sym_AMP_EQ] = ACTIONS(3802),
    [anon_sym_CARET_EQ] = ACTIONS(3802),
    [anon_sym_PIPE_EQ] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3800),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3802),
    [sym_this] = ACTIONS(1919),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [1002] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_typedef] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym___try] = ACTIONS(1979),
    [anon_sym___leave] = ACTIONS(1979),
    [anon_sym_not] = ACTIONS(1979),
    [anon_sym_compl] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym___alignof__] = ACTIONS(1979),
    [anon_sym___alignof] = ACTIONS(1979),
    [anon_sym__alignof] = ACTIONS(1979),
    [anon_sym_alignof] = ACTIONS(1979),
    [anon_sym__Alignof] = ACTIONS(1979),
    [anon_sym_offsetof] = ACTIONS(1979),
    [anon_sym__Generic] = ACTIONS(1979),
    [anon_sym_asm] = ACTIONS(1979),
    [anon_sym___asm__] = ACTIONS(1979),
    [anon_sym___asm] = ACTIONS(1979),
    [sym_number_literal] = ACTIONS(1981),
    [anon_sym_L_SQUOTE] = ACTIONS(1981),
    [anon_sym_u_SQUOTE] = ACTIONS(1981),
    [anon_sym_U_SQUOTE] = ACTIONS(1981),
    [anon_sym_u8_SQUOTE] = ACTIONS(1981),
    [anon_sym_SQUOTE] = ACTIONS(1981),
    [anon_sym_L_DQUOTE] = ACTIONS(1981),
    [anon_sym_u_DQUOTE] = ACTIONS(1981),
    [anon_sym_U_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [sym_true] = ACTIONS(1979),
    [sym_false] = ACTIONS(1979),
    [anon_sym_NULL] = ACTIONS(1979),
    [anon_sym_nullptr] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_delete] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_co_return] = ACTIONS(1979),
    [anon_sym_co_yield] = ACTIONS(1979),
    [anon_sym_R_DQUOTE] = ACTIONS(1981),
    [anon_sym_LR_DQUOTE] = ACTIONS(1981),
    [anon_sym_uR_DQUOTE] = ACTIONS(1981),
    [anon_sym_UR_DQUOTE] = ACTIONS(1981),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1981),
    [anon_sym_co_await] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [sym_this] = ACTIONS(1979),
    [anon_sym_discard] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
    [anon_sym_cbuffer] = ACTIONS(1979),
  },
  [1003] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_typedef] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_switch] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_do] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_goto] = ACTIONS(1991),
    [anon_sym___try] = ACTIONS(1991),
    [anon_sym___leave] = ACTIONS(1991),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_sizeof] = ACTIONS(1991),
    [anon_sym___alignof__] = ACTIONS(1991),
    [anon_sym___alignof] = ACTIONS(1991),
    [anon_sym__alignof] = ACTIONS(1991),
    [anon_sym_alignof] = ACTIONS(1991),
    [anon_sym__Alignof] = ACTIONS(1991),
    [anon_sym_offsetof] = ACTIONS(1991),
    [anon_sym__Generic] = ACTIONS(1991),
    [anon_sym_asm] = ACTIONS(1991),
    [anon_sym___asm__] = ACTIONS(1991),
    [anon_sym___asm] = ACTIONS(1991),
    [sym_number_literal] = ACTIONS(1993),
    [anon_sym_L_SQUOTE] = ACTIONS(1993),
    [anon_sym_u_SQUOTE] = ACTIONS(1993),
    [anon_sym_U_SQUOTE] = ACTIONS(1993),
    [anon_sym_u8_SQUOTE] = ACTIONS(1993),
    [anon_sym_SQUOTE] = ACTIONS(1993),
    [anon_sym_L_DQUOTE] = ACTIONS(1993),
    [anon_sym_u_DQUOTE] = ACTIONS(1993),
    [anon_sym_U_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8_DQUOTE] = ACTIONS(1993),
    [anon_sym_DQUOTE] = ACTIONS(1993),
    [sym_true] = ACTIONS(1991),
    [sym_false] = ACTIONS(1991),
    [anon_sym_NULL] = ACTIONS(1991),
    [anon_sym_nullptr] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_delete] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_co_return] = ACTIONS(1991),
    [anon_sym_co_yield] = ACTIONS(1991),
    [anon_sym_R_DQUOTE] = ACTIONS(1993),
    [anon_sym_LR_DQUOTE] = ACTIONS(1993),
    [anon_sym_uR_DQUOTE] = ACTIONS(1993),
    [anon_sym_UR_DQUOTE] = ACTIONS(1993),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1993),
    [anon_sym_co_await] = ACTIONS(1991),
    [anon_sym_new] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [sym_this] = ACTIONS(1991),
    [anon_sym_discard] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
    [anon_sym_cbuffer] = ACTIONS(1991),
  },
  [1004] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_BANG] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2040),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_typedef] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_if] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_switch] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_do] = ACTIONS(2038),
    [anon_sym_for] = ACTIONS(2038),
    [anon_sym_return] = ACTIONS(2038),
    [anon_sym_break] = ACTIONS(2038),
    [anon_sym_continue] = ACTIONS(2038),
    [anon_sym_goto] = ACTIONS(2038),
    [anon_sym___try] = ACTIONS(2038),
    [anon_sym___leave] = ACTIONS(2038),
    [anon_sym_not] = ACTIONS(2038),
    [anon_sym_compl] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_sizeof] = ACTIONS(2038),
    [anon_sym___alignof__] = ACTIONS(2038),
    [anon_sym___alignof] = ACTIONS(2038),
    [anon_sym__alignof] = ACTIONS(2038),
    [anon_sym_alignof] = ACTIONS(2038),
    [anon_sym__Alignof] = ACTIONS(2038),
    [anon_sym_offsetof] = ACTIONS(2038),
    [anon_sym__Generic] = ACTIONS(2038),
    [anon_sym_asm] = ACTIONS(2038),
    [anon_sym___asm__] = ACTIONS(2038),
    [anon_sym___asm] = ACTIONS(2038),
    [sym_number_literal] = ACTIONS(2040),
    [anon_sym_L_SQUOTE] = ACTIONS(2040),
    [anon_sym_u_SQUOTE] = ACTIONS(2040),
    [anon_sym_U_SQUOTE] = ACTIONS(2040),
    [anon_sym_u8_SQUOTE] = ACTIONS(2040),
    [anon_sym_SQUOTE] = ACTIONS(2040),
    [anon_sym_L_DQUOTE] = ACTIONS(2040),
    [anon_sym_u_DQUOTE] = ACTIONS(2040),
    [anon_sym_U_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8_DQUOTE] = ACTIONS(2040),
    [anon_sym_DQUOTE] = ACTIONS(2040),
    [sym_true] = ACTIONS(2038),
    [sym_false] = ACTIONS(2038),
    [anon_sym_NULL] = ACTIONS(2038),
    [anon_sym_nullptr] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_delete] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_co_return] = ACTIONS(2038),
    [anon_sym_co_yield] = ACTIONS(2038),
    [anon_sym_R_DQUOTE] = ACTIONS(2040),
    [anon_sym_LR_DQUOTE] = ACTIONS(2040),
    [anon_sym_uR_DQUOTE] = ACTIONS(2040),
    [anon_sym_UR_DQUOTE] = ACTIONS(2040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2040),
    [anon_sym_co_await] = ACTIONS(2038),
    [anon_sym_new] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [sym_this] = ACTIONS(2038),
    [anon_sym_discard] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
    [anon_sym_cbuffer] = ACTIONS(2038),
  },
  [1005] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [1006] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_typedef] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_switch] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_do] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_goto] = ACTIONS(2017),
    [anon_sym___try] = ACTIONS(2017),
    [anon_sym___leave] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2017),
    [anon_sym_compl] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_sizeof] = ACTIONS(2017),
    [anon_sym___alignof__] = ACTIONS(2017),
    [anon_sym___alignof] = ACTIONS(2017),
    [anon_sym__alignof] = ACTIONS(2017),
    [anon_sym_alignof] = ACTIONS(2017),
    [anon_sym__Alignof] = ACTIONS(2017),
    [anon_sym_offsetof] = ACTIONS(2017),
    [anon_sym__Generic] = ACTIONS(2017),
    [anon_sym_asm] = ACTIONS(2017),
    [anon_sym___asm__] = ACTIONS(2017),
    [anon_sym___asm] = ACTIONS(2017),
    [sym_number_literal] = ACTIONS(2019),
    [anon_sym_L_SQUOTE] = ACTIONS(2019),
    [anon_sym_u_SQUOTE] = ACTIONS(2019),
    [anon_sym_U_SQUOTE] = ACTIONS(2019),
    [anon_sym_u8_SQUOTE] = ACTIONS(2019),
    [anon_sym_SQUOTE] = ACTIONS(2019),
    [anon_sym_L_DQUOTE] = ACTIONS(2019),
    [anon_sym_u_DQUOTE] = ACTIONS(2019),
    [anon_sym_U_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8_DQUOTE] = ACTIONS(2019),
    [anon_sym_DQUOTE] = ACTIONS(2019),
    [sym_true] = ACTIONS(2017),
    [sym_false] = ACTIONS(2017),
    [anon_sym_NULL] = ACTIONS(2017),
    [anon_sym_nullptr] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_delete] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_co_return] = ACTIONS(2017),
    [anon_sym_co_yield] = ACTIONS(2017),
    [anon_sym_R_DQUOTE] = ACTIONS(2019),
    [anon_sym_LR_DQUOTE] = ACTIONS(2019),
    [anon_sym_uR_DQUOTE] = ACTIONS(2019),
    [anon_sym_UR_DQUOTE] = ACTIONS(2019),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2019),
    [anon_sym_co_await] = ACTIONS(2017),
    [anon_sym_new] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [sym_this] = ACTIONS(2017),
    [anon_sym_discard] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
    [anon_sym_cbuffer] = ACTIONS(2017),
  },
  [1007] = {
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_BANG] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_typedef] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_switch] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_do] = ACTIONS(2027),
    [anon_sym_for] = ACTIONS(2027),
    [anon_sym_return] = ACTIONS(2027),
    [anon_sym_break] = ACTIONS(2027),
    [anon_sym_continue] = ACTIONS(2027),
    [anon_sym_goto] = ACTIONS(2027),
    [anon_sym___try] = ACTIONS(2027),
    [anon_sym___leave] = ACTIONS(2027),
    [anon_sym_not] = ACTIONS(2027),
    [anon_sym_compl] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_sizeof] = ACTIONS(2027),
    [anon_sym___alignof__] = ACTIONS(2027),
    [anon_sym___alignof] = ACTIONS(2027),
    [anon_sym__alignof] = ACTIONS(2027),
    [anon_sym_alignof] = ACTIONS(2027),
    [anon_sym__Alignof] = ACTIONS(2027),
    [anon_sym_offsetof] = ACTIONS(2027),
    [anon_sym__Generic] = ACTIONS(2027),
    [anon_sym_asm] = ACTIONS(2027),
    [anon_sym___asm__] = ACTIONS(2027),
    [anon_sym___asm] = ACTIONS(2027),
    [sym_number_literal] = ACTIONS(2029),
    [anon_sym_L_SQUOTE] = ACTIONS(2029),
    [anon_sym_u_SQUOTE] = ACTIONS(2029),
    [anon_sym_U_SQUOTE] = ACTIONS(2029),
    [anon_sym_u8_SQUOTE] = ACTIONS(2029),
    [anon_sym_SQUOTE] = ACTIONS(2029),
    [anon_sym_L_DQUOTE] = ACTIONS(2029),
    [anon_sym_u_DQUOTE] = ACTIONS(2029),
    [anon_sym_U_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8_DQUOTE] = ACTIONS(2029),
    [anon_sym_DQUOTE] = ACTIONS(2029),
    [sym_true] = ACTIONS(2027),
    [sym_false] = ACTIONS(2027),
    [anon_sym_NULL] = ACTIONS(2027),
    [anon_sym_nullptr] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_delete] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_co_return] = ACTIONS(2027),
    [anon_sym_co_yield] = ACTIONS(2027),
    [anon_sym_R_DQUOTE] = ACTIONS(2029),
    [anon_sym_LR_DQUOTE] = ACTIONS(2029),
    [anon_sym_uR_DQUOTE] = ACTIONS(2029),
    [anon_sym_UR_DQUOTE] = ACTIONS(2029),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2029),
    [anon_sym_co_await] = ACTIONS(2027),
    [anon_sym_new] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [sym_this] = ACTIONS(2027),
    [anon_sym_discard] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
    [anon_sym_cbuffer] = ACTIONS(2027),
  },
  [1008] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_typedef] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_switch] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_do] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_goto] = ACTIONS(1987),
    [anon_sym___try] = ACTIONS(1987),
    [anon_sym___leave] = ACTIONS(1987),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_compl] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_sizeof] = ACTIONS(1987),
    [anon_sym___alignof__] = ACTIONS(1987),
    [anon_sym___alignof] = ACTIONS(1987),
    [anon_sym__alignof] = ACTIONS(1987),
    [anon_sym_alignof] = ACTIONS(1987),
    [anon_sym__Alignof] = ACTIONS(1987),
    [anon_sym_offsetof] = ACTIONS(1987),
    [anon_sym__Generic] = ACTIONS(1987),
    [anon_sym_asm] = ACTIONS(1987),
    [anon_sym___asm__] = ACTIONS(1987),
    [anon_sym___asm] = ACTIONS(1987),
    [sym_number_literal] = ACTIONS(1989),
    [anon_sym_L_SQUOTE] = ACTIONS(1989),
    [anon_sym_u_SQUOTE] = ACTIONS(1989),
    [anon_sym_U_SQUOTE] = ACTIONS(1989),
    [anon_sym_u8_SQUOTE] = ACTIONS(1989),
    [anon_sym_SQUOTE] = ACTIONS(1989),
    [anon_sym_L_DQUOTE] = ACTIONS(1989),
    [anon_sym_u_DQUOTE] = ACTIONS(1989),
    [anon_sym_U_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8_DQUOTE] = ACTIONS(1989),
    [anon_sym_DQUOTE] = ACTIONS(1989),
    [sym_true] = ACTIONS(1987),
    [sym_false] = ACTIONS(1987),
    [anon_sym_NULL] = ACTIONS(1987),
    [anon_sym_nullptr] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_delete] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_co_return] = ACTIONS(1987),
    [anon_sym_co_yield] = ACTIONS(1987),
    [anon_sym_R_DQUOTE] = ACTIONS(1989),
    [anon_sym_LR_DQUOTE] = ACTIONS(1989),
    [anon_sym_uR_DQUOTE] = ACTIONS(1989),
    [anon_sym_UR_DQUOTE] = ACTIONS(1989),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1989),
    [anon_sym_co_await] = ACTIONS(1987),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [sym_this] = ACTIONS(1987),
    [anon_sym_discard] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
    [anon_sym_cbuffer] = ACTIONS(1987),
  },
  [1009] = {
    [sym_catch_clause] = STATE(1009),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1009),
    [sym_identifier] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_BANG] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2031),
    [anon_sym_PLUS] = ACTIONS(2031),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2033),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [anon_sym_if] = ACTIONS(2031),
    [anon_sym_else] = ACTIONS(2031),
    [anon_sym_switch] = ACTIONS(2031),
    [anon_sym_while] = ACTIONS(2031),
    [anon_sym_do] = ACTIONS(2031),
    [anon_sym_for] = ACTIONS(2031),
    [anon_sym_return] = ACTIONS(2031),
    [anon_sym_break] = ACTIONS(2031),
    [anon_sym_continue] = ACTIONS(2031),
    [anon_sym_goto] = ACTIONS(2031),
    [anon_sym___try] = ACTIONS(2031),
    [anon_sym___leave] = ACTIONS(2031),
    [anon_sym_not] = ACTIONS(2031),
    [anon_sym_compl] = ACTIONS(2031),
    [anon_sym_DASH_DASH] = ACTIONS(2033),
    [anon_sym_PLUS_PLUS] = ACTIONS(2033),
    [anon_sym_sizeof] = ACTIONS(2031),
    [anon_sym___alignof__] = ACTIONS(2031),
    [anon_sym___alignof] = ACTIONS(2031),
    [anon_sym__alignof] = ACTIONS(2031),
    [anon_sym_alignof] = ACTIONS(2031),
    [anon_sym__Alignof] = ACTIONS(2031),
    [anon_sym_offsetof] = ACTIONS(2031),
    [anon_sym__Generic] = ACTIONS(2031),
    [anon_sym_asm] = ACTIONS(2031),
    [anon_sym___asm__] = ACTIONS(2031),
    [anon_sym___asm] = ACTIONS(2031),
    [sym_number_literal] = ACTIONS(2033),
    [anon_sym_L_SQUOTE] = ACTIONS(2033),
    [anon_sym_u_SQUOTE] = ACTIONS(2033),
    [anon_sym_U_SQUOTE] = ACTIONS(2033),
    [anon_sym_u8_SQUOTE] = ACTIONS(2033),
    [anon_sym_SQUOTE] = ACTIONS(2033),
    [anon_sym_L_DQUOTE] = ACTIONS(2033),
    [anon_sym_u_DQUOTE] = ACTIONS(2033),
    [anon_sym_U_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8_DQUOTE] = ACTIONS(2033),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym_true] = ACTIONS(2031),
    [sym_false] = ACTIONS(2031),
    [anon_sym_NULL] = ACTIONS(2031),
    [anon_sym_nullptr] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_try] = ACTIONS(2031),
    [anon_sym_delete] = ACTIONS(2031),
    [anon_sym_throw] = ACTIONS(2031),
    [anon_sym_co_return] = ACTIONS(2031),
    [anon_sym_co_yield] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(4082),
    [anon_sym_R_DQUOTE] = ACTIONS(2033),
    [anon_sym_LR_DQUOTE] = ACTIONS(2033),
    [anon_sym_uR_DQUOTE] = ACTIONS(2033),
    [anon_sym_UR_DQUOTE] = ACTIONS(2033),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2033),
    [anon_sym_co_await] = ACTIONS(2031),
    [anon_sym_new] = ACTIONS(2031),
    [anon_sym_requires] = ACTIONS(2031),
    [sym_this] = ACTIONS(2031),
    [anon_sym_discard] = ACTIONS(2031),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
    [anon_sym_cbuffer] = ACTIONS(2031),
  },
  [1010] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_BANG] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1955),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_typedef] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_if] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_switch] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_do] = ACTIONS(1953),
    [anon_sym_for] = ACTIONS(1953),
    [anon_sym_return] = ACTIONS(1953),
    [anon_sym_break] = ACTIONS(1953),
    [anon_sym_continue] = ACTIONS(1953),
    [anon_sym_goto] = ACTIONS(1953),
    [anon_sym___try] = ACTIONS(1953),
    [anon_sym___leave] = ACTIONS(1953),
    [anon_sym_not] = ACTIONS(1953),
    [anon_sym_compl] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_sizeof] = ACTIONS(1953),
    [anon_sym___alignof__] = ACTIONS(1953),
    [anon_sym___alignof] = ACTIONS(1953),
    [anon_sym__alignof] = ACTIONS(1953),
    [anon_sym_alignof] = ACTIONS(1953),
    [anon_sym__Alignof] = ACTIONS(1953),
    [anon_sym_offsetof] = ACTIONS(1953),
    [anon_sym__Generic] = ACTIONS(1953),
    [anon_sym_asm] = ACTIONS(1953),
    [anon_sym___asm__] = ACTIONS(1953),
    [anon_sym___asm] = ACTIONS(1953),
    [sym_number_literal] = ACTIONS(1955),
    [anon_sym_L_SQUOTE] = ACTIONS(1955),
    [anon_sym_u_SQUOTE] = ACTIONS(1955),
    [anon_sym_U_SQUOTE] = ACTIONS(1955),
    [anon_sym_u8_SQUOTE] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_L_DQUOTE] = ACTIONS(1955),
    [anon_sym_u_DQUOTE] = ACTIONS(1955),
    [anon_sym_U_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8_DQUOTE] = ACTIONS(1955),
    [anon_sym_DQUOTE] = ACTIONS(1955),
    [sym_true] = ACTIONS(1953),
    [sym_false] = ACTIONS(1953),
    [anon_sym_NULL] = ACTIONS(1953),
    [anon_sym_nullptr] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_co_return] = ACTIONS(1953),
    [anon_sym_co_yield] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1953),
    [anon_sym_new] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [sym_this] = ACTIONS(1953),
    [anon_sym_discard] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
    [anon_sym_cbuffer] = ACTIONS(1953),
  },
  [1011] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_typedef] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_switch] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_do] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_goto] = ACTIONS(1971),
    [anon_sym___try] = ACTIONS(1971),
    [anon_sym___leave] = ACTIONS(1971),
    [anon_sym_not] = ACTIONS(1971),
    [anon_sym_compl] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_sizeof] = ACTIONS(1971),
    [anon_sym___alignof__] = ACTIONS(1971),
    [anon_sym___alignof] = ACTIONS(1971),
    [anon_sym__alignof] = ACTIONS(1971),
    [anon_sym_alignof] = ACTIONS(1971),
    [anon_sym__Alignof] = ACTIONS(1971),
    [anon_sym_offsetof] = ACTIONS(1971),
    [anon_sym__Generic] = ACTIONS(1971),
    [anon_sym_asm] = ACTIONS(1971),
    [anon_sym___asm__] = ACTIONS(1971),
    [anon_sym___asm] = ACTIONS(1971),
    [sym_number_literal] = ACTIONS(1973),
    [anon_sym_L_SQUOTE] = ACTIONS(1973),
    [anon_sym_u_SQUOTE] = ACTIONS(1973),
    [anon_sym_U_SQUOTE] = ACTIONS(1973),
    [anon_sym_u8_SQUOTE] = ACTIONS(1973),
    [anon_sym_SQUOTE] = ACTIONS(1973),
    [anon_sym_L_DQUOTE] = ACTIONS(1973),
    [anon_sym_u_DQUOTE] = ACTIONS(1973),
    [anon_sym_U_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8_DQUOTE] = ACTIONS(1973),
    [anon_sym_DQUOTE] = ACTIONS(1973),
    [sym_true] = ACTIONS(1971),
    [sym_false] = ACTIONS(1971),
    [anon_sym_NULL] = ACTIONS(1971),
    [anon_sym_nullptr] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_delete] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_co_return] = ACTIONS(1971),
    [anon_sym_co_yield] = ACTIONS(1971),
    [anon_sym_R_DQUOTE] = ACTIONS(1973),
    [anon_sym_LR_DQUOTE] = ACTIONS(1973),
    [anon_sym_uR_DQUOTE] = ACTIONS(1973),
    [anon_sym_UR_DQUOTE] = ACTIONS(1973),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1973),
    [anon_sym_co_await] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [sym_this] = ACTIONS(1971),
    [anon_sym_discard] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
    [anon_sym_cbuffer] = ACTIONS(1971),
  },
  [1012] = {
    [sym_catch_clause] = STATE(1009),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1009),
    [sym_identifier] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_DASH] = ACTIONS(2021),
    [anon_sym_PLUS] = ACTIONS(2021),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2023),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_else] = ACTIONS(2021),
    [anon_sym_switch] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_do] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_goto] = ACTIONS(2021),
    [anon_sym___try] = ACTIONS(2021),
    [anon_sym___leave] = ACTIONS(2021),
    [anon_sym_not] = ACTIONS(2021),
    [anon_sym_compl] = ACTIONS(2021),
    [anon_sym_DASH_DASH] = ACTIONS(2023),
    [anon_sym_PLUS_PLUS] = ACTIONS(2023),
    [anon_sym_sizeof] = ACTIONS(2021),
    [anon_sym___alignof__] = ACTIONS(2021),
    [anon_sym___alignof] = ACTIONS(2021),
    [anon_sym__alignof] = ACTIONS(2021),
    [anon_sym_alignof] = ACTIONS(2021),
    [anon_sym__Alignof] = ACTIONS(2021),
    [anon_sym_offsetof] = ACTIONS(2021),
    [anon_sym__Generic] = ACTIONS(2021),
    [anon_sym_asm] = ACTIONS(2021),
    [anon_sym___asm__] = ACTIONS(2021),
    [anon_sym___asm] = ACTIONS(2021),
    [sym_number_literal] = ACTIONS(2023),
    [anon_sym_L_SQUOTE] = ACTIONS(2023),
    [anon_sym_u_SQUOTE] = ACTIONS(2023),
    [anon_sym_U_SQUOTE] = ACTIONS(2023),
    [anon_sym_u8_SQUOTE] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_L_DQUOTE] = ACTIONS(2023),
    [anon_sym_u_DQUOTE] = ACTIONS(2023),
    [anon_sym_U_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8_DQUOTE] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(2023),
    [sym_true] = ACTIONS(2021),
    [sym_false] = ACTIONS(2021),
    [anon_sym_NULL] = ACTIONS(2021),
    [anon_sym_nullptr] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_try] = ACTIONS(2021),
    [anon_sym_delete] = ACTIONS(2021),
    [anon_sym_throw] = ACTIONS(2021),
    [anon_sym_co_return] = ACTIONS(2021),
    [anon_sym_co_yield] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(4085),
    [anon_sym_R_DQUOTE] = ACTIONS(2023),
    [anon_sym_LR_DQUOTE] = ACTIONS(2023),
    [anon_sym_uR_DQUOTE] = ACTIONS(2023),
    [anon_sym_UR_DQUOTE] = ACTIONS(2023),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2023),
    [anon_sym_co_await] = ACTIONS(2021),
    [anon_sym_new] = ACTIONS(2021),
    [anon_sym_requires] = ACTIONS(2021),
    [sym_this] = ACTIONS(2021),
    [anon_sym_discard] = ACTIONS(2021),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
    [anon_sym_cbuffer] = ACTIONS(2021),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_typedef] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_switch] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_do] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_goto] = ACTIONS(1975),
    [anon_sym___try] = ACTIONS(1975),
    [anon_sym___leave] = ACTIONS(1975),
    [anon_sym_not] = ACTIONS(1975),
    [anon_sym_compl] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_sizeof] = ACTIONS(1975),
    [anon_sym___alignof__] = ACTIONS(1975),
    [anon_sym___alignof] = ACTIONS(1975),
    [anon_sym__alignof] = ACTIONS(1975),
    [anon_sym_alignof] = ACTIONS(1975),
    [anon_sym__Alignof] = ACTIONS(1975),
    [anon_sym_offsetof] = ACTIONS(1975),
    [anon_sym__Generic] = ACTIONS(1975),
    [anon_sym_asm] = ACTIONS(1975),
    [anon_sym___asm__] = ACTIONS(1975),
    [anon_sym___asm] = ACTIONS(1975),
    [sym_number_literal] = ACTIONS(1977),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1977),
    [anon_sym_u_DQUOTE] = ACTIONS(1977),
    [anon_sym_U_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [sym_true] = ACTIONS(1975),
    [sym_false] = ACTIONS(1975),
    [anon_sym_NULL] = ACTIONS(1975),
    [anon_sym_nullptr] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_co_return] = ACTIONS(1975),
    [anon_sym_co_yield] = ACTIONS(1975),
    [anon_sym_R_DQUOTE] = ACTIONS(1977),
    [anon_sym_LR_DQUOTE] = ACTIONS(1977),
    [anon_sym_uR_DQUOTE] = ACTIONS(1977),
    [anon_sym_UR_DQUOTE] = ACTIONS(1977),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1977),
    [anon_sym_co_await] = ACTIONS(1975),
    [anon_sym_new] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [sym_this] = ACTIONS(1975),
    [anon_sym_discard] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
    [anon_sym_cbuffer] = ACTIONS(1975),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_typedef] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_switch] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_do] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_goto] = ACTIONS(2011),
    [anon_sym___try] = ACTIONS(2011),
    [anon_sym___leave] = ACTIONS(2011),
    [anon_sym_not] = ACTIONS(2011),
    [anon_sym_compl] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_sizeof] = ACTIONS(2011),
    [anon_sym___alignof__] = ACTIONS(2011),
    [anon_sym___alignof] = ACTIONS(2011),
    [anon_sym__alignof] = ACTIONS(2011),
    [anon_sym_alignof] = ACTIONS(2011),
    [anon_sym__Alignof] = ACTIONS(2011),
    [anon_sym_offsetof] = ACTIONS(2011),
    [anon_sym__Generic] = ACTIONS(2011),
    [anon_sym_asm] = ACTIONS(2011),
    [anon_sym___asm__] = ACTIONS(2011),
    [anon_sym___asm] = ACTIONS(2011),
    [sym_number_literal] = ACTIONS(2013),
    [anon_sym_L_SQUOTE] = ACTIONS(2013),
    [anon_sym_u_SQUOTE] = ACTIONS(2013),
    [anon_sym_U_SQUOTE] = ACTIONS(2013),
    [anon_sym_u8_SQUOTE] = ACTIONS(2013),
    [anon_sym_SQUOTE] = ACTIONS(2013),
    [anon_sym_L_DQUOTE] = ACTIONS(2013),
    [anon_sym_u_DQUOTE] = ACTIONS(2013),
    [anon_sym_U_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8_DQUOTE] = ACTIONS(2013),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_true] = ACTIONS(2011),
    [sym_false] = ACTIONS(2011),
    [anon_sym_NULL] = ACTIONS(2011),
    [anon_sym_nullptr] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_delete] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_co_return] = ACTIONS(2011),
    [anon_sym_co_yield] = ACTIONS(2011),
    [anon_sym_R_DQUOTE] = ACTIONS(2013),
    [anon_sym_LR_DQUOTE] = ACTIONS(2013),
    [anon_sym_uR_DQUOTE] = ACTIONS(2013),
    [anon_sym_UR_DQUOTE] = ACTIONS(2013),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2013),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [sym_this] = ACTIONS(2011),
    [anon_sym_discard] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
    [anon_sym_cbuffer] = ACTIONS(2011),
  },
  [1015] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_typedef] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_switch] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_do] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_goto] = ACTIONS(1983),
    [anon_sym___try] = ACTIONS(1983),
    [anon_sym___leave] = ACTIONS(1983),
    [anon_sym_not] = ACTIONS(1983),
    [anon_sym_compl] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_sizeof] = ACTIONS(1983),
    [anon_sym___alignof__] = ACTIONS(1983),
    [anon_sym___alignof] = ACTIONS(1983),
    [anon_sym__alignof] = ACTIONS(1983),
    [anon_sym_alignof] = ACTIONS(1983),
    [anon_sym__Alignof] = ACTIONS(1983),
    [anon_sym_offsetof] = ACTIONS(1983),
    [anon_sym__Generic] = ACTIONS(1983),
    [anon_sym_asm] = ACTIONS(1983),
    [anon_sym___asm__] = ACTIONS(1983),
    [anon_sym___asm] = ACTIONS(1983),
    [sym_number_literal] = ACTIONS(1985),
    [anon_sym_L_SQUOTE] = ACTIONS(1985),
    [anon_sym_u_SQUOTE] = ACTIONS(1985),
    [anon_sym_U_SQUOTE] = ACTIONS(1985),
    [anon_sym_u8_SQUOTE] = ACTIONS(1985),
    [anon_sym_SQUOTE] = ACTIONS(1985),
    [anon_sym_L_DQUOTE] = ACTIONS(1985),
    [anon_sym_u_DQUOTE] = ACTIONS(1985),
    [anon_sym_U_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8_DQUOTE] = ACTIONS(1985),
    [anon_sym_DQUOTE] = ACTIONS(1985),
    [sym_true] = ACTIONS(1983),
    [sym_false] = ACTIONS(1983),
    [anon_sym_NULL] = ACTIONS(1983),
    [anon_sym_nullptr] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_delete] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_co_return] = ACTIONS(1983),
    [anon_sym_co_yield] = ACTIONS(1983),
    [anon_sym_R_DQUOTE] = ACTIONS(1985),
    [anon_sym_LR_DQUOTE] = ACTIONS(1985),
    [anon_sym_uR_DQUOTE] = ACTIONS(1985),
    [anon_sym_UR_DQUOTE] = ACTIONS(1985),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1985),
    [anon_sym_co_await] = ACTIONS(1983),
    [anon_sym_new] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [sym_this] = ACTIONS(1983),
    [anon_sym_discard] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
    [anon_sym_cbuffer] = ACTIONS(1983),
  },
  [1016] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4595),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7139),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7378),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4141),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1017] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4586),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7149),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7499),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4153),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1018] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4593),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7191),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7711),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4155),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1019] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4596),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7181),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7641),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4157),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1020] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4597),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7200),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7815),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4159),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1021] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4606),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7205),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7388),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4161),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1022] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4610),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7245),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7515),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4163),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1023] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4637),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7277),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7612),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4165),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1024] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4639),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7172),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7597),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4167),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1025] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4611),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7228),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7458),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4169),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1026] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4646),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7300),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7667),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4171),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1027] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4623),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7264),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7569),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4173),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1028] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4575),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7331),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7731),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4175),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1029] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4579),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7174),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7595),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4177),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1030] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4563),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7140),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7430),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4179),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1031] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4594),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7342),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7753),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4181),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1032] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4569),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7353),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7776),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4183),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1033] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4643),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7177),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7601),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4185),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1034] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4638),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7327),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7729),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4187),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1035] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4607),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7310),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7700),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4189),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1036] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4585),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7189),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7695),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4191),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1037] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7360),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(7801),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(4193),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1038] = {
    [sym_else_clause] = STATE(1068),
    [sym_identifier] = ACTIONS(2139),
    [anon_sym_LPAREN2] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2141),
    [anon_sym_TILDE] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2139),
    [anon_sym_PLUS] = ACTIONS(2139),
    [anon_sym_STAR] = ACTIONS(2141),
    [anon_sym_AMP] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym___extension__] = ACTIONS(2139),
    [anon_sym_typedef] = ACTIONS(2139),
    [anon_sym_in] = ACTIONS(2139),
    [anon_sym_out] = ACTIONS(2139),
    [anon_sym_inout] = ACTIONS(2139),
    [anon_sym_virtual] = ACTIONS(2139),
    [anon_sym_extern] = ACTIONS(2139),
    [anon_sym___attribute__] = ACTIONS(2139),
    [anon_sym___attribute] = ACTIONS(2139),
    [anon_sym_COLON_COLON] = ACTIONS(2141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2141),
    [anon_sym___declspec] = ACTIONS(2139),
    [anon_sym_LBRACE] = ACTIONS(2141),
    [anon_sym_signed] = ACTIONS(2139),
    [anon_sym_unsigned] = ACTIONS(2139),
    [anon_sym_long] = ACTIONS(2139),
    [anon_sym_short] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(2139),
    [anon_sym_static] = ACTIONS(2139),
    [anon_sym_register] = ACTIONS(2139),
    [anon_sym_inline] = ACTIONS(2139),
    [anon_sym___inline] = ACTIONS(2139),
    [anon_sym___inline__] = ACTIONS(2139),
    [anon_sym___forceinline] = ACTIONS(2139),
    [anon_sym_thread_local] = ACTIONS(2139),
    [anon_sym___thread] = ACTIONS(2139),
    [anon_sym_const] = ACTIONS(2139),
    [anon_sym_constexpr] = ACTIONS(2139),
    [anon_sym_volatile] = ACTIONS(2139),
    [anon_sym_restrict] = ACTIONS(2139),
    [anon_sym___restrict__] = ACTIONS(2139),
    [anon_sym__Atomic] = ACTIONS(2139),
    [anon_sym__Noreturn] = ACTIONS(2139),
    [anon_sym_noreturn] = ACTIONS(2139),
    [anon_sym__Nonnull] = ACTIONS(2139),
    [anon_sym_mutable] = ACTIONS(2139),
    [anon_sym_constinit] = ACTIONS(2139),
    [anon_sym_consteval] = ACTIONS(2139),
    [anon_sym_alignas] = ACTIONS(2139),
    [anon_sym__Alignas] = ACTIONS(2139),
    [sym_primitive_type] = ACTIONS(2139),
    [anon_sym_enum] = ACTIONS(2139),
    [anon_sym_class] = ACTIONS(2139),
    [anon_sym_struct] = ACTIONS(2139),
    [anon_sym_union] = ACTIONS(2139),
    [anon_sym_if] = ACTIONS(2139),
    [anon_sym_else] = ACTIONS(4195),
    [anon_sym_switch] = ACTIONS(2139),
    [anon_sym_while] = ACTIONS(2139),
    [anon_sym_do] = ACTIONS(2139),
    [anon_sym_for] = ACTIONS(2139),
    [anon_sym_return] = ACTIONS(2139),
    [anon_sym_break] = ACTIONS(2139),
    [anon_sym_continue] = ACTIONS(2139),
    [anon_sym_goto] = ACTIONS(2139),
    [anon_sym___try] = ACTIONS(2139),
    [anon_sym___leave] = ACTIONS(2139),
    [anon_sym_not] = ACTIONS(2139),
    [anon_sym_compl] = ACTIONS(2139),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_sizeof] = ACTIONS(2139),
    [anon_sym___alignof__] = ACTIONS(2139),
    [anon_sym___alignof] = ACTIONS(2139),
    [anon_sym__alignof] = ACTIONS(2139),
    [anon_sym_alignof] = ACTIONS(2139),
    [anon_sym__Alignof] = ACTIONS(2139),
    [anon_sym_offsetof] = ACTIONS(2139),
    [anon_sym__Generic] = ACTIONS(2139),
    [anon_sym_asm] = ACTIONS(2139),
    [anon_sym___asm__] = ACTIONS(2139),
    [anon_sym___asm] = ACTIONS(2139),
    [sym_number_literal] = ACTIONS(2141),
    [anon_sym_L_SQUOTE] = ACTIONS(2141),
    [anon_sym_u_SQUOTE] = ACTIONS(2141),
    [anon_sym_U_SQUOTE] = ACTIONS(2141),
    [anon_sym_u8_SQUOTE] = ACTIONS(2141),
    [anon_sym_SQUOTE] = ACTIONS(2141),
    [anon_sym_L_DQUOTE] = ACTIONS(2141),
    [anon_sym_u_DQUOTE] = ACTIONS(2141),
    [anon_sym_U_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8_DQUOTE] = ACTIONS(2141),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [sym_true] = ACTIONS(2139),
    [sym_false] = ACTIONS(2139),
    [anon_sym_NULL] = ACTIONS(2139),
    [anon_sym_nullptr] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2139),
    [anon_sym_decltype] = ACTIONS(2139),
    [anon_sym_typename] = ACTIONS(2139),
    [anon_sym_template] = ACTIONS(2139),
    [anon_sym_try] = ACTIONS(2139),
    [anon_sym_delete] = ACTIONS(2139),
    [anon_sym_throw] = ACTIONS(2139),
    [anon_sym_co_return] = ACTIONS(2139),
    [anon_sym_co_yield] = ACTIONS(2139),
    [anon_sym_R_DQUOTE] = ACTIONS(2141),
    [anon_sym_LR_DQUOTE] = ACTIONS(2141),
    [anon_sym_uR_DQUOTE] = ACTIONS(2141),
    [anon_sym_UR_DQUOTE] = ACTIONS(2141),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2141),
    [anon_sym_co_await] = ACTIONS(2139),
    [anon_sym_new] = ACTIONS(2139),
    [anon_sym_requires] = ACTIONS(2139),
    [sym_this] = ACTIONS(2139),
    [anon_sym_discard] = ACTIONS(2139),
    [anon_sym_precise] = ACTIONS(2139),
    [anon_sym_shared] = ACTIONS(2139),
    [anon_sym_groupshared] = ACTIONS(2139),
    [anon_sym_uniform] = ACTIONS(2139),
    [anon_sym_row_major] = ACTIONS(2139),
    [anon_sym_column_major] = ACTIONS(2139),
    [anon_sym_globallycoherent] = ACTIONS(2139),
    [anon_sym_centroid] = ACTIONS(2139),
    [anon_sym_noperspective] = ACTIONS(2139),
    [anon_sym_nointerpolation] = ACTIONS(2139),
    [anon_sym_sample] = ACTIONS(2139),
    [anon_sym_linear] = ACTIONS(2139),
    [anon_sym_snorm] = ACTIONS(2139),
    [anon_sym_unorm] = ACTIONS(2139),
    [anon_sym_point] = ACTIONS(2139),
    [anon_sym_line] = ACTIONS(2139),
    [anon_sym_triangleadj] = ACTIONS(2139),
    [anon_sym_lineadj] = ACTIONS(2139),
    [anon_sym_triangle] = ACTIONS(2139),
    [anon_sym_cbuffer] = ACTIONS(2139),
  },
  [1039] = {
    [sym_else_clause] = STATE(1054),
    [sym_identifier] = ACTIONS(2133),
    [anon_sym_LPAREN2] = ACTIONS(2135),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [anon_sym_DASH] = ACTIONS(2133),
    [anon_sym_PLUS] = ACTIONS(2133),
    [anon_sym_STAR] = ACTIONS(2135),
    [anon_sym_AMP] = ACTIONS(2135),
    [anon_sym_SEMI] = ACTIONS(2135),
    [anon_sym___extension__] = ACTIONS(2133),
    [anon_sym_typedef] = ACTIONS(2133),
    [anon_sym_in] = ACTIONS(2133),
    [anon_sym_out] = ACTIONS(2133),
    [anon_sym_inout] = ACTIONS(2133),
    [anon_sym_virtual] = ACTIONS(2133),
    [anon_sym_extern] = ACTIONS(2133),
    [anon_sym___attribute__] = ACTIONS(2133),
    [anon_sym___attribute] = ACTIONS(2133),
    [anon_sym_COLON_COLON] = ACTIONS(2135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2135),
    [anon_sym___declspec] = ACTIONS(2133),
    [anon_sym_LBRACE] = ACTIONS(2135),
    [anon_sym_signed] = ACTIONS(2133),
    [anon_sym_unsigned] = ACTIONS(2133),
    [anon_sym_long] = ACTIONS(2133),
    [anon_sym_short] = ACTIONS(2133),
    [anon_sym_LBRACK] = ACTIONS(2133),
    [anon_sym_static] = ACTIONS(2133),
    [anon_sym_register] = ACTIONS(2133),
    [anon_sym_inline] = ACTIONS(2133),
    [anon_sym___inline] = ACTIONS(2133),
    [anon_sym___inline__] = ACTIONS(2133),
    [anon_sym___forceinline] = ACTIONS(2133),
    [anon_sym_thread_local] = ACTIONS(2133),
    [anon_sym___thread] = ACTIONS(2133),
    [anon_sym_const] = ACTIONS(2133),
    [anon_sym_constexpr] = ACTIONS(2133),
    [anon_sym_volatile] = ACTIONS(2133),
    [anon_sym_restrict] = ACTIONS(2133),
    [anon_sym___restrict__] = ACTIONS(2133),
    [anon_sym__Atomic] = ACTIONS(2133),
    [anon_sym__Noreturn] = ACTIONS(2133),
    [anon_sym_noreturn] = ACTIONS(2133),
    [anon_sym__Nonnull] = ACTIONS(2133),
    [anon_sym_mutable] = ACTIONS(2133),
    [anon_sym_constinit] = ACTIONS(2133),
    [anon_sym_consteval] = ACTIONS(2133),
    [anon_sym_alignas] = ACTIONS(2133),
    [anon_sym__Alignas] = ACTIONS(2133),
    [sym_primitive_type] = ACTIONS(2133),
    [anon_sym_enum] = ACTIONS(2133),
    [anon_sym_class] = ACTIONS(2133),
    [anon_sym_struct] = ACTIONS(2133),
    [anon_sym_union] = ACTIONS(2133),
    [anon_sym_if] = ACTIONS(2133),
    [anon_sym_else] = ACTIONS(4195),
    [anon_sym_switch] = ACTIONS(2133),
    [anon_sym_while] = ACTIONS(2133),
    [anon_sym_do] = ACTIONS(2133),
    [anon_sym_for] = ACTIONS(2133),
    [anon_sym_return] = ACTIONS(2133),
    [anon_sym_break] = ACTIONS(2133),
    [anon_sym_continue] = ACTIONS(2133),
    [anon_sym_goto] = ACTIONS(2133),
    [anon_sym___try] = ACTIONS(2133),
    [anon_sym___leave] = ACTIONS(2133),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_compl] = ACTIONS(2133),
    [anon_sym_DASH_DASH] = ACTIONS(2135),
    [anon_sym_PLUS_PLUS] = ACTIONS(2135),
    [anon_sym_sizeof] = ACTIONS(2133),
    [anon_sym___alignof__] = ACTIONS(2133),
    [anon_sym___alignof] = ACTIONS(2133),
    [anon_sym__alignof] = ACTIONS(2133),
    [anon_sym_alignof] = ACTIONS(2133),
    [anon_sym__Alignof] = ACTIONS(2133),
    [anon_sym_offsetof] = ACTIONS(2133),
    [anon_sym__Generic] = ACTIONS(2133),
    [anon_sym_asm] = ACTIONS(2133),
    [anon_sym___asm__] = ACTIONS(2133),
    [anon_sym___asm] = ACTIONS(2133),
    [sym_number_literal] = ACTIONS(2135),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2135),
    [anon_sym_u_DQUOTE] = ACTIONS(2135),
    [anon_sym_U_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [sym_true] = ACTIONS(2133),
    [sym_false] = ACTIONS(2133),
    [anon_sym_NULL] = ACTIONS(2133),
    [anon_sym_nullptr] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2133),
    [anon_sym_decltype] = ACTIONS(2133),
    [anon_sym_typename] = ACTIONS(2133),
    [anon_sym_template] = ACTIONS(2133),
    [anon_sym_try] = ACTIONS(2133),
    [anon_sym_delete] = ACTIONS(2133),
    [anon_sym_throw] = ACTIONS(2133),
    [anon_sym_co_return] = ACTIONS(2133),
    [anon_sym_co_yield] = ACTIONS(2133),
    [anon_sym_R_DQUOTE] = ACTIONS(2135),
    [anon_sym_LR_DQUOTE] = ACTIONS(2135),
    [anon_sym_uR_DQUOTE] = ACTIONS(2135),
    [anon_sym_UR_DQUOTE] = ACTIONS(2135),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2135),
    [anon_sym_co_await] = ACTIONS(2133),
    [anon_sym_new] = ACTIONS(2133),
    [anon_sym_requires] = ACTIONS(2133),
    [sym_this] = ACTIONS(2133),
    [anon_sym_discard] = ACTIONS(2133),
    [anon_sym_precise] = ACTIONS(2133),
    [anon_sym_shared] = ACTIONS(2133),
    [anon_sym_groupshared] = ACTIONS(2133),
    [anon_sym_uniform] = ACTIONS(2133),
    [anon_sym_row_major] = ACTIONS(2133),
    [anon_sym_column_major] = ACTIONS(2133),
    [anon_sym_globallycoherent] = ACTIONS(2133),
    [anon_sym_centroid] = ACTIONS(2133),
    [anon_sym_noperspective] = ACTIONS(2133),
    [anon_sym_nointerpolation] = ACTIONS(2133),
    [anon_sym_sample] = ACTIONS(2133),
    [anon_sym_linear] = ACTIONS(2133),
    [anon_sym_snorm] = ACTIONS(2133),
    [anon_sym_unorm] = ACTIONS(2133),
    [anon_sym_point] = ACTIONS(2133),
    [anon_sym_line] = ACTIONS(2133),
    [anon_sym_triangleadj] = ACTIONS(2133),
    [anon_sym_lineadj] = ACTIONS(2133),
    [anon_sym_triangle] = ACTIONS(2133),
    [anon_sym_cbuffer] = ACTIONS(2133),
  },
  [1040] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(3257),
    [sym__declarator] = STATE(6609),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_type_qualifier] = STATE(4219),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3525),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5854),
    [sym_qualified_identifier] = STATE(3527),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(2941),
    [aux_sym__type_definition_type_repeat1] = STATE(4219),
    [aux_sym_pointer_declarator_repeat1] = STATE(3257),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(4203),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1041] = {
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_else] = ACTIONS(1951),
    [anon_sym_switch] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_do] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_goto] = ACTIONS(1951),
    [anon_sym___try] = ACTIONS(1951),
    [anon_sym___leave] = ACTIONS(1951),
    [anon_sym_not] = ACTIONS(1951),
    [anon_sym_compl] = ACTIONS(1951),
    [anon_sym_DASH_DASH] = ACTIONS(1949),
    [anon_sym_PLUS_PLUS] = ACTIONS(1949),
    [anon_sym_sizeof] = ACTIONS(1951),
    [anon_sym___alignof__] = ACTIONS(1951),
    [anon_sym___alignof] = ACTIONS(1951),
    [anon_sym__alignof] = ACTIONS(1951),
    [anon_sym_alignof] = ACTIONS(1951),
    [anon_sym__Alignof] = ACTIONS(1951),
    [anon_sym_offsetof] = ACTIONS(1951),
    [anon_sym__Generic] = ACTIONS(1951),
    [anon_sym_asm] = ACTIONS(1951),
    [anon_sym___asm__] = ACTIONS(1951),
    [anon_sym___asm] = ACTIONS(1951),
    [sym_number_literal] = ACTIONS(1949),
    [anon_sym_L_SQUOTE] = ACTIONS(1949),
    [anon_sym_u_SQUOTE] = ACTIONS(1949),
    [anon_sym_U_SQUOTE] = ACTIONS(1949),
    [anon_sym_u8_SQUOTE] = ACTIONS(1949),
    [anon_sym_SQUOTE] = ACTIONS(1949),
    [anon_sym_L_DQUOTE] = ACTIONS(1949),
    [anon_sym_u_DQUOTE] = ACTIONS(1949),
    [anon_sym_U_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8_DQUOTE] = ACTIONS(1949),
    [anon_sym_DQUOTE] = ACTIONS(1949),
    [sym_true] = ACTIONS(1951),
    [sym_false] = ACTIONS(1951),
    [anon_sym_NULL] = ACTIONS(1951),
    [anon_sym_nullptr] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_try] = ACTIONS(1951),
    [anon_sym_delete] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_co_return] = ACTIONS(1951),
    [anon_sym_co_yield] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_R_DQUOTE] = ACTIONS(1949),
    [anon_sym_LR_DQUOTE] = ACTIONS(1949),
    [anon_sym_uR_DQUOTE] = ACTIONS(1949),
    [anon_sym_UR_DQUOTE] = ACTIONS(1949),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1949),
    [anon_sym_co_await] = ACTIONS(1951),
    [anon_sym_new] = ACTIONS(1951),
    [anon_sym_requires] = ACTIONS(1951),
    [sym_this] = ACTIONS(1951),
    [anon_sym_discard] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
    [anon_sym_cbuffer] = ACTIONS(1951),
  },
  [1042] = {
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_else] = ACTIONS(1947),
    [anon_sym_switch] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_do] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_goto] = ACTIONS(1947),
    [anon_sym___try] = ACTIONS(1947),
    [anon_sym___leave] = ACTIONS(1947),
    [anon_sym_not] = ACTIONS(1947),
    [anon_sym_compl] = ACTIONS(1947),
    [anon_sym_DASH_DASH] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1945),
    [anon_sym_sizeof] = ACTIONS(1947),
    [anon_sym___alignof__] = ACTIONS(1947),
    [anon_sym___alignof] = ACTIONS(1947),
    [anon_sym__alignof] = ACTIONS(1947),
    [anon_sym_alignof] = ACTIONS(1947),
    [anon_sym__Alignof] = ACTIONS(1947),
    [anon_sym_offsetof] = ACTIONS(1947),
    [anon_sym__Generic] = ACTIONS(1947),
    [anon_sym_asm] = ACTIONS(1947),
    [anon_sym___asm__] = ACTIONS(1947),
    [anon_sym___asm] = ACTIONS(1947),
    [sym_number_literal] = ACTIONS(1945),
    [anon_sym_L_SQUOTE] = ACTIONS(1945),
    [anon_sym_u_SQUOTE] = ACTIONS(1945),
    [anon_sym_U_SQUOTE] = ACTIONS(1945),
    [anon_sym_u8_SQUOTE] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1945),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1947),
    [anon_sym_nullptr] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_try] = ACTIONS(1947),
    [anon_sym_delete] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_co_return] = ACTIONS(1947),
    [anon_sym_co_yield] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_R_DQUOTE] = ACTIONS(1945),
    [anon_sym_LR_DQUOTE] = ACTIONS(1945),
    [anon_sym_uR_DQUOTE] = ACTIONS(1945),
    [anon_sym_UR_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1945),
    [anon_sym_co_await] = ACTIONS(1947),
    [anon_sym_new] = ACTIONS(1947),
    [anon_sym_requires] = ACTIONS(1947),
    [sym_this] = ACTIONS(1947),
    [anon_sym_discard] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
    [anon_sym_cbuffer] = ACTIONS(1947),
  },
  [1043] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4236),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1044] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(3257),
    [sym__declarator] = STATE(6609),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_type_qualifier] = STATE(4219),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_expression] = STATE(3444),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3563),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5861),
    [sym_qualified_identifier] = STATE(3606),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3802),
    [aux_sym__type_definition_type_repeat1] = STATE(4219),
    [aux_sym_pointer_declarator_repeat1] = STATE(3257),
    [sym_identifier] = ACTIONS(4255),
    [anon_sym_LPAREN2] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(4257),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1045] = {
    [sym_else_clause] = STATE(1087),
    [sym_identifier] = ACTIONS(2151),
    [anon_sym_LPAREN2] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2153),
    [anon_sym_DASH] = ACTIONS(2151),
    [anon_sym_PLUS] = ACTIONS(2151),
    [anon_sym_STAR] = ACTIONS(2153),
    [anon_sym_AMP] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym___extension__] = ACTIONS(2151),
    [anon_sym_typedef] = ACTIONS(2151),
    [anon_sym_in] = ACTIONS(2151),
    [anon_sym_out] = ACTIONS(2151),
    [anon_sym_inout] = ACTIONS(2151),
    [anon_sym_virtual] = ACTIONS(2151),
    [anon_sym_extern] = ACTIONS(2151),
    [anon_sym___attribute__] = ACTIONS(2151),
    [anon_sym___attribute] = ACTIONS(2151),
    [anon_sym_COLON_COLON] = ACTIONS(2153),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2153),
    [anon_sym___declspec] = ACTIONS(2151),
    [anon_sym_LBRACE] = ACTIONS(2153),
    [anon_sym_signed] = ACTIONS(2151),
    [anon_sym_unsigned] = ACTIONS(2151),
    [anon_sym_long] = ACTIONS(2151),
    [anon_sym_short] = ACTIONS(2151),
    [anon_sym_LBRACK] = ACTIONS(2151),
    [anon_sym_static] = ACTIONS(2151),
    [anon_sym_register] = ACTIONS(2151),
    [anon_sym_inline] = ACTIONS(2151),
    [anon_sym___inline] = ACTIONS(2151),
    [anon_sym___inline__] = ACTIONS(2151),
    [anon_sym___forceinline] = ACTIONS(2151),
    [anon_sym_thread_local] = ACTIONS(2151),
    [anon_sym___thread] = ACTIONS(2151),
    [anon_sym_const] = ACTIONS(2151),
    [anon_sym_constexpr] = ACTIONS(2151),
    [anon_sym_volatile] = ACTIONS(2151),
    [anon_sym_restrict] = ACTIONS(2151),
    [anon_sym___restrict__] = ACTIONS(2151),
    [anon_sym__Atomic] = ACTIONS(2151),
    [anon_sym__Noreturn] = ACTIONS(2151),
    [anon_sym_noreturn] = ACTIONS(2151),
    [anon_sym__Nonnull] = ACTIONS(2151),
    [anon_sym_mutable] = ACTIONS(2151),
    [anon_sym_constinit] = ACTIONS(2151),
    [anon_sym_consteval] = ACTIONS(2151),
    [anon_sym_alignas] = ACTIONS(2151),
    [anon_sym__Alignas] = ACTIONS(2151),
    [sym_primitive_type] = ACTIONS(2151),
    [anon_sym_enum] = ACTIONS(2151),
    [anon_sym_class] = ACTIONS(2151),
    [anon_sym_struct] = ACTIONS(2151),
    [anon_sym_union] = ACTIONS(2151),
    [anon_sym_if] = ACTIONS(2151),
    [anon_sym_else] = ACTIONS(4195),
    [anon_sym_switch] = ACTIONS(2151),
    [anon_sym_while] = ACTIONS(2151),
    [anon_sym_do] = ACTIONS(2151),
    [anon_sym_for] = ACTIONS(2151),
    [anon_sym_return] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2151),
    [anon_sym_continue] = ACTIONS(2151),
    [anon_sym_goto] = ACTIONS(2151),
    [anon_sym___try] = ACTIONS(2151),
    [anon_sym___leave] = ACTIONS(2151),
    [anon_sym_not] = ACTIONS(2151),
    [anon_sym_compl] = ACTIONS(2151),
    [anon_sym_DASH_DASH] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2153),
    [anon_sym_sizeof] = ACTIONS(2151),
    [anon_sym___alignof__] = ACTIONS(2151),
    [anon_sym___alignof] = ACTIONS(2151),
    [anon_sym__alignof] = ACTIONS(2151),
    [anon_sym_alignof] = ACTIONS(2151),
    [anon_sym__Alignof] = ACTIONS(2151),
    [anon_sym_offsetof] = ACTIONS(2151),
    [anon_sym__Generic] = ACTIONS(2151),
    [anon_sym_asm] = ACTIONS(2151),
    [anon_sym___asm__] = ACTIONS(2151),
    [anon_sym___asm] = ACTIONS(2151),
    [sym_number_literal] = ACTIONS(2153),
    [anon_sym_L_SQUOTE] = ACTIONS(2153),
    [anon_sym_u_SQUOTE] = ACTIONS(2153),
    [anon_sym_U_SQUOTE] = ACTIONS(2153),
    [anon_sym_u8_SQUOTE] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2153),
    [anon_sym_L_DQUOTE] = ACTIONS(2153),
    [anon_sym_u_DQUOTE] = ACTIONS(2153),
    [anon_sym_U_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8_DQUOTE] = ACTIONS(2153),
    [anon_sym_DQUOTE] = ACTIONS(2153),
    [sym_true] = ACTIONS(2151),
    [sym_false] = ACTIONS(2151),
    [anon_sym_NULL] = ACTIONS(2151),
    [anon_sym_nullptr] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2151),
    [anon_sym_decltype] = ACTIONS(2151),
    [anon_sym_typename] = ACTIONS(2151),
    [anon_sym_template] = ACTIONS(2151),
    [anon_sym_try] = ACTIONS(2151),
    [anon_sym_delete] = ACTIONS(2151),
    [anon_sym_throw] = ACTIONS(2151),
    [anon_sym_co_return] = ACTIONS(2151),
    [anon_sym_co_yield] = ACTIONS(2151),
    [anon_sym_R_DQUOTE] = ACTIONS(2153),
    [anon_sym_LR_DQUOTE] = ACTIONS(2153),
    [anon_sym_uR_DQUOTE] = ACTIONS(2153),
    [anon_sym_UR_DQUOTE] = ACTIONS(2153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2153),
    [anon_sym_co_await] = ACTIONS(2151),
    [anon_sym_new] = ACTIONS(2151),
    [anon_sym_requires] = ACTIONS(2151),
    [sym_this] = ACTIONS(2151),
    [anon_sym_discard] = ACTIONS(2151),
    [anon_sym_precise] = ACTIONS(2151),
    [anon_sym_shared] = ACTIONS(2151),
    [anon_sym_groupshared] = ACTIONS(2151),
    [anon_sym_uniform] = ACTIONS(2151),
    [anon_sym_row_major] = ACTIONS(2151),
    [anon_sym_column_major] = ACTIONS(2151),
    [anon_sym_globallycoherent] = ACTIONS(2151),
    [anon_sym_centroid] = ACTIONS(2151),
    [anon_sym_noperspective] = ACTIONS(2151),
    [anon_sym_nointerpolation] = ACTIONS(2151),
    [anon_sym_sample] = ACTIONS(2151),
    [anon_sym_linear] = ACTIONS(2151),
    [anon_sym_snorm] = ACTIONS(2151),
    [anon_sym_unorm] = ACTIONS(2151),
    [anon_sym_point] = ACTIONS(2151),
    [anon_sym_line] = ACTIONS(2151),
    [anon_sym_triangleadj] = ACTIONS(2151),
    [anon_sym_lineadj] = ACTIONS(2151),
    [anon_sym_triangle] = ACTIONS(2151),
    [anon_sym_cbuffer] = ACTIONS(2151),
  },
  [1046] = {
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_LPAREN2] = ACTIONS(3876),
    [anon_sym_BANG] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3876),
    [anon_sym_DASH] = ACTIONS(3874),
    [anon_sym_PLUS] = ACTIONS(3874),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym___extension__] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3874),
    [anon_sym_out] = ACTIONS(3874),
    [anon_sym_inout] = ACTIONS(3874),
    [anon_sym_virtual] = ACTIONS(3874),
    [anon_sym_extern] = ACTIONS(3874),
    [anon_sym___attribute__] = ACTIONS(3874),
    [anon_sym___attribute] = ACTIONS(3874),
    [anon_sym_using] = ACTIONS(3874),
    [anon_sym_COLON_COLON] = ACTIONS(3876),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3876),
    [anon_sym___declspec] = ACTIONS(3874),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_signed] = ACTIONS(3874),
    [anon_sym_unsigned] = ACTIONS(3874),
    [anon_sym_long] = ACTIONS(3874),
    [anon_sym_short] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3874),
    [anon_sym_register] = ACTIONS(3874),
    [anon_sym_inline] = ACTIONS(3874),
    [anon_sym___inline] = ACTIONS(3874),
    [anon_sym___inline__] = ACTIONS(3874),
    [anon_sym___forceinline] = ACTIONS(3874),
    [anon_sym_thread_local] = ACTIONS(3874),
    [anon_sym___thread] = ACTIONS(3874),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_constexpr] = ACTIONS(3874),
    [anon_sym_volatile] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3874),
    [anon_sym___restrict__] = ACTIONS(3874),
    [anon_sym__Atomic] = ACTIONS(3874),
    [anon_sym__Noreturn] = ACTIONS(3874),
    [anon_sym_noreturn] = ACTIONS(3874),
    [anon_sym__Nonnull] = ACTIONS(3874),
    [anon_sym_mutable] = ACTIONS(3874),
    [anon_sym_constinit] = ACTIONS(3874),
    [anon_sym_consteval] = ACTIONS(3874),
    [anon_sym_alignas] = ACTIONS(3874),
    [anon_sym__Alignas] = ACTIONS(3874),
    [sym_primitive_type] = ACTIONS(3874),
    [anon_sym_enum] = ACTIONS(3874),
    [anon_sym_class] = ACTIONS(3874),
    [anon_sym_struct] = ACTIONS(3874),
    [anon_sym_union] = ACTIONS(3874),
    [anon_sym_if] = ACTIONS(3874),
    [anon_sym_switch] = ACTIONS(3874),
    [anon_sym_case] = ACTIONS(3874),
    [anon_sym_default] = ACTIONS(3874),
    [anon_sym_while] = ACTIONS(3874),
    [anon_sym_do] = ACTIONS(3874),
    [anon_sym_for] = ACTIONS(3874),
    [anon_sym_return] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3874),
    [anon_sym_continue] = ACTIONS(3874),
    [anon_sym_goto] = ACTIONS(3874),
    [anon_sym___try] = ACTIONS(3874),
    [anon_sym___leave] = ACTIONS(3874),
    [anon_sym_not] = ACTIONS(3874),
    [anon_sym_compl] = ACTIONS(3874),
    [anon_sym_DASH_DASH] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3876),
    [anon_sym_sizeof] = ACTIONS(3874),
    [anon_sym___alignof__] = ACTIONS(3874),
    [anon_sym___alignof] = ACTIONS(3874),
    [anon_sym__alignof] = ACTIONS(3874),
    [anon_sym_alignof] = ACTIONS(3874),
    [anon_sym__Alignof] = ACTIONS(3874),
    [anon_sym_offsetof] = ACTIONS(3874),
    [anon_sym__Generic] = ACTIONS(3874),
    [anon_sym_asm] = ACTIONS(3874),
    [anon_sym___asm__] = ACTIONS(3874),
    [anon_sym___asm] = ACTIONS(3874),
    [sym_number_literal] = ACTIONS(3876),
    [anon_sym_L_SQUOTE] = ACTIONS(3876),
    [anon_sym_u_SQUOTE] = ACTIONS(3876),
    [anon_sym_U_SQUOTE] = ACTIONS(3876),
    [anon_sym_u8_SQUOTE] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(3876),
    [anon_sym_L_DQUOTE] = ACTIONS(3876),
    [anon_sym_u_DQUOTE] = ACTIONS(3876),
    [anon_sym_U_DQUOTE] = ACTIONS(3876),
    [anon_sym_u8_DQUOTE] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3876),
    [sym_true] = ACTIONS(3874),
    [sym_false] = ACTIONS(3874),
    [anon_sym_NULL] = ACTIONS(3874),
    [anon_sym_nullptr] = ACTIONS(3874),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3874),
    [anon_sym_decltype] = ACTIONS(3874),
    [anon_sym_typename] = ACTIONS(3874),
    [anon_sym_template] = ACTIONS(3874),
    [anon_sym_try] = ACTIONS(3874),
    [anon_sym_delete] = ACTIONS(3874),
    [anon_sym_throw] = ACTIONS(3874),
    [anon_sym_co_return] = ACTIONS(3874),
    [anon_sym_co_yield] = ACTIONS(3874),
    [anon_sym_R_DQUOTE] = ACTIONS(3876),
    [anon_sym_LR_DQUOTE] = ACTIONS(3876),
    [anon_sym_uR_DQUOTE] = ACTIONS(3876),
    [anon_sym_UR_DQUOTE] = ACTIONS(3876),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3876),
    [anon_sym_co_await] = ACTIONS(3874),
    [anon_sym_new] = ACTIONS(3874),
    [anon_sym_requires] = ACTIONS(3874),
    [sym_this] = ACTIONS(3874),
    [anon_sym_discard] = ACTIONS(3874),
    [anon_sym_precise] = ACTIONS(3874),
    [anon_sym_shared] = ACTIONS(3874),
    [anon_sym_groupshared] = ACTIONS(3874),
    [anon_sym_uniform] = ACTIONS(3874),
    [anon_sym_row_major] = ACTIONS(3874),
    [anon_sym_column_major] = ACTIONS(3874),
    [anon_sym_globallycoherent] = ACTIONS(3874),
    [anon_sym_centroid] = ACTIONS(3874),
    [anon_sym_noperspective] = ACTIONS(3874),
    [anon_sym_nointerpolation] = ACTIONS(3874),
    [anon_sym_sample] = ACTIONS(3874),
    [anon_sym_linear] = ACTIONS(3874),
    [anon_sym_snorm] = ACTIONS(3874),
    [anon_sym_unorm] = ACTIONS(3874),
    [anon_sym_point] = ACTIONS(3874),
    [anon_sym_line] = ACTIONS(3874),
    [anon_sym_triangleadj] = ACTIONS(3874),
    [anon_sym_lineadj] = ACTIONS(3874),
    [anon_sym_triangle] = ACTIONS(3874),
    [anon_sym_cbuffer] = ACTIONS(3874),
  },
  [1047] = {
    [sym_type_qualifier] = STATE(4085),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4831),
    [sym_sized_type_specifier] = STATE(3067),
    [sym_enum_specifier] = STATE(3067),
    [sym_struct_specifier] = STATE(3067),
    [sym_union_specifier] = STATE(3067),
    [sym_expression] = STATE(4746),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_type_descriptor] = STATE(7552),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_placeholder_type_specifier] = STATE(3067),
    [sym_decltype_auto] = STATE(3066),
    [sym_decltype] = STATE(3000),
    [sym_class_specifier] = STATE(3067),
    [sym__class_name] = STATE(7870),
    [sym_dependent_type] = STATE(3067),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_type_parameter_pack_expansion] = STATE(8055),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5975),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3873),
    [aux_sym__type_definition_type_repeat1] = STATE(4085),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4430),
    [sym_identifier] = ACTIONS(4087),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4097),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_signed] = ACTIONS(4101),
    [anon_sym_unsigned] = ACTIONS(4101),
    [anon_sym_long] = ACTIONS(4101),
    [anon_sym_short] = ACTIONS(4101),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4103),
    [anon_sym_enum] = ACTIONS(4105),
    [anon_sym_class] = ACTIONS(4107),
    [anon_sym_struct] = ACTIONS(4109),
    [anon_sym_union] = ACTIONS(4111),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4135),
    [anon_sym_decltype] = ACTIONS(4137),
    [anon_sym_typename] = ACTIONS(4139),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_DASH] = ACTIONS(3878),
    [anon_sym_PLUS] = ACTIONS(3878),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3878),
    [anon_sym_out] = ACTIONS(3878),
    [anon_sym_inout] = ACTIONS(3878),
    [anon_sym_virtual] = ACTIONS(3878),
    [anon_sym_extern] = ACTIONS(3878),
    [anon_sym___attribute__] = ACTIONS(3878),
    [anon_sym___attribute] = ACTIONS(3878),
    [anon_sym_using] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3880),
    [anon_sym___declspec] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_signed] = ACTIONS(3878),
    [anon_sym_unsigned] = ACTIONS(3878),
    [anon_sym_long] = ACTIONS(3878),
    [anon_sym_short] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3878),
    [anon_sym_register] = ACTIONS(3878),
    [anon_sym_inline] = ACTIONS(3878),
    [anon_sym___inline] = ACTIONS(3878),
    [anon_sym___inline__] = ACTIONS(3878),
    [anon_sym___forceinline] = ACTIONS(3878),
    [anon_sym_thread_local] = ACTIONS(3878),
    [anon_sym___thread] = ACTIONS(3878),
    [anon_sym_const] = ACTIONS(3878),
    [anon_sym_constexpr] = ACTIONS(3878),
    [anon_sym_volatile] = ACTIONS(3878),
    [anon_sym_restrict] = ACTIONS(3878),
    [anon_sym___restrict__] = ACTIONS(3878),
    [anon_sym__Atomic] = ACTIONS(3878),
    [anon_sym__Noreturn] = ACTIONS(3878),
    [anon_sym_noreturn] = ACTIONS(3878),
    [anon_sym__Nonnull] = ACTIONS(3878),
    [anon_sym_mutable] = ACTIONS(3878),
    [anon_sym_constinit] = ACTIONS(3878),
    [anon_sym_consteval] = ACTIONS(3878),
    [anon_sym_alignas] = ACTIONS(3878),
    [anon_sym__Alignas] = ACTIONS(3878),
    [sym_primitive_type] = ACTIONS(3878),
    [anon_sym_enum] = ACTIONS(3878),
    [anon_sym_class] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3878),
    [anon_sym_union] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3878),
    [anon_sym_switch] = ACTIONS(3878),
    [anon_sym_case] = ACTIONS(3878),
    [anon_sym_default] = ACTIONS(3878),
    [anon_sym_while] = ACTIONS(3878),
    [anon_sym_do] = ACTIONS(3878),
    [anon_sym_for] = ACTIONS(3878),
    [anon_sym_return] = ACTIONS(3878),
    [anon_sym_break] = ACTIONS(3878),
    [anon_sym_continue] = ACTIONS(3878),
    [anon_sym_goto] = ACTIONS(3878),
    [anon_sym___try] = ACTIONS(3878),
    [anon_sym___leave] = ACTIONS(3878),
    [anon_sym_not] = ACTIONS(3878),
    [anon_sym_compl] = ACTIONS(3878),
    [anon_sym_DASH_DASH] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3880),
    [anon_sym_sizeof] = ACTIONS(3878),
    [anon_sym___alignof__] = ACTIONS(3878),
    [anon_sym___alignof] = ACTIONS(3878),
    [anon_sym__alignof] = ACTIONS(3878),
    [anon_sym_alignof] = ACTIONS(3878),
    [anon_sym__Alignof] = ACTIONS(3878),
    [anon_sym_offsetof] = ACTIONS(3878),
    [anon_sym__Generic] = ACTIONS(3878),
    [anon_sym_asm] = ACTIONS(3878),
    [anon_sym___asm__] = ACTIONS(3878),
    [anon_sym___asm] = ACTIONS(3878),
    [sym_number_literal] = ACTIONS(3880),
    [anon_sym_L_SQUOTE] = ACTIONS(3880),
    [anon_sym_u_SQUOTE] = ACTIONS(3880),
    [anon_sym_U_SQUOTE] = ACTIONS(3880),
    [anon_sym_u8_SQUOTE] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(3880),
    [anon_sym_L_DQUOTE] = ACTIONS(3880),
    [anon_sym_u_DQUOTE] = ACTIONS(3880),
    [anon_sym_U_DQUOTE] = ACTIONS(3880),
    [anon_sym_u8_DQUOTE] = ACTIONS(3880),
    [anon_sym_DQUOTE] = ACTIONS(3880),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [anon_sym_NULL] = ACTIONS(3878),
    [anon_sym_nullptr] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3878),
    [anon_sym_decltype] = ACTIONS(3878),
    [anon_sym_typename] = ACTIONS(3878),
    [anon_sym_template] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_delete] = ACTIONS(3878),
    [anon_sym_throw] = ACTIONS(3878),
    [anon_sym_co_return] = ACTIONS(3878),
    [anon_sym_co_yield] = ACTIONS(3878),
    [anon_sym_R_DQUOTE] = ACTIONS(3880),
    [anon_sym_LR_DQUOTE] = ACTIONS(3880),
    [anon_sym_uR_DQUOTE] = ACTIONS(3880),
    [anon_sym_UR_DQUOTE] = ACTIONS(3880),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3880),
    [anon_sym_co_await] = ACTIONS(3878),
    [anon_sym_new] = ACTIONS(3878),
    [anon_sym_requires] = ACTIONS(3878),
    [sym_this] = ACTIONS(3878),
    [anon_sym_discard] = ACTIONS(3878),
    [anon_sym_precise] = ACTIONS(3878),
    [anon_sym_shared] = ACTIONS(3878),
    [anon_sym_groupshared] = ACTIONS(3878),
    [anon_sym_uniform] = ACTIONS(3878),
    [anon_sym_row_major] = ACTIONS(3878),
    [anon_sym_column_major] = ACTIONS(3878),
    [anon_sym_globallycoherent] = ACTIONS(3878),
    [anon_sym_centroid] = ACTIONS(3878),
    [anon_sym_noperspective] = ACTIONS(3878),
    [anon_sym_nointerpolation] = ACTIONS(3878),
    [anon_sym_sample] = ACTIONS(3878),
    [anon_sym_linear] = ACTIONS(3878),
    [anon_sym_snorm] = ACTIONS(3878),
    [anon_sym_unorm] = ACTIONS(3878),
    [anon_sym_point] = ACTIONS(3878),
    [anon_sym_line] = ACTIONS(3878),
    [anon_sym_triangleadj] = ACTIONS(3878),
    [anon_sym_lineadj] = ACTIONS(3878),
    [anon_sym_triangle] = ACTIONS(3878),
    [anon_sym_cbuffer] = ACTIONS(3878),
  },
  [1049] = {
    [sym_identifier] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_DASH] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [anon_sym_if] = ACTIONS(2145),
    [anon_sym_else] = ACTIONS(2145),
    [anon_sym_switch] = ACTIONS(2145),
    [anon_sym_while] = ACTIONS(2145),
    [anon_sym_do] = ACTIONS(2145),
    [anon_sym_for] = ACTIONS(2145),
    [anon_sym_return] = ACTIONS(2145),
    [anon_sym_break] = ACTIONS(2145),
    [anon_sym_continue] = ACTIONS(2145),
    [anon_sym_goto] = ACTIONS(2145),
    [anon_sym___try] = ACTIONS(2145),
    [anon_sym___leave] = ACTIONS(2145),
    [anon_sym_not] = ACTIONS(2145),
    [anon_sym_compl] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2147),
    [anon_sym_sizeof] = ACTIONS(2145),
    [anon_sym___alignof__] = ACTIONS(2145),
    [anon_sym___alignof] = ACTIONS(2145),
    [anon_sym__alignof] = ACTIONS(2145),
    [anon_sym_alignof] = ACTIONS(2145),
    [anon_sym__Alignof] = ACTIONS(2145),
    [anon_sym_offsetof] = ACTIONS(2145),
    [anon_sym__Generic] = ACTIONS(2145),
    [anon_sym_asm] = ACTIONS(2145),
    [anon_sym___asm__] = ACTIONS(2145),
    [anon_sym___asm] = ACTIONS(2145),
    [sym_number_literal] = ACTIONS(2147),
    [anon_sym_L_SQUOTE] = ACTIONS(2147),
    [anon_sym_u_SQUOTE] = ACTIONS(2147),
    [anon_sym_U_SQUOTE] = ACTIONS(2147),
    [anon_sym_u8_SQUOTE] = ACTIONS(2147),
    [anon_sym_SQUOTE] = ACTIONS(2147),
    [anon_sym_L_DQUOTE] = ACTIONS(2147),
    [anon_sym_u_DQUOTE] = ACTIONS(2147),
    [anon_sym_U_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8_DQUOTE] = ACTIONS(2147),
    [anon_sym_DQUOTE] = ACTIONS(2147),
    [sym_true] = ACTIONS(2145),
    [sym_false] = ACTIONS(2145),
    [anon_sym_NULL] = ACTIONS(2145),
    [anon_sym_nullptr] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_try] = ACTIONS(2145),
    [anon_sym_delete] = ACTIONS(2145),
    [anon_sym_throw] = ACTIONS(2145),
    [anon_sym_co_return] = ACTIONS(2145),
    [anon_sym_co_yield] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_R_DQUOTE] = ACTIONS(2147),
    [anon_sym_LR_DQUOTE] = ACTIONS(2147),
    [anon_sym_uR_DQUOTE] = ACTIONS(2147),
    [anon_sym_UR_DQUOTE] = ACTIONS(2147),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2147),
    [anon_sym_co_await] = ACTIONS(2145),
    [anon_sym_new] = ACTIONS(2145),
    [anon_sym_requires] = ACTIONS(2145),
    [sym_this] = ACTIONS(2145),
    [anon_sym_discard] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
    [anon_sym_cbuffer] = ACTIONS(2145),
  },
  [1050] = {
    [sym_identifier] = ACTIONS(2254),
    [anon_sym_LPAREN2] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2256),
    [anon_sym_TILDE] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2254),
    [anon_sym_PLUS] = ACTIONS(2254),
    [anon_sym_STAR] = ACTIONS(2256),
    [anon_sym_AMP] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2256),
    [anon_sym___extension__] = ACTIONS(2254),
    [anon_sym_typedef] = ACTIONS(2254),
    [anon_sym_in] = ACTIONS(2254),
    [anon_sym_out] = ACTIONS(2254),
    [anon_sym_inout] = ACTIONS(2254),
    [anon_sym_virtual] = ACTIONS(2254),
    [anon_sym_extern] = ACTIONS(2254),
    [anon_sym___attribute__] = ACTIONS(2254),
    [anon_sym___attribute] = ACTIONS(2254),
    [anon_sym_COLON_COLON] = ACTIONS(2256),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2256),
    [anon_sym___declspec] = ACTIONS(2254),
    [anon_sym_LBRACE] = ACTIONS(2256),
    [anon_sym_signed] = ACTIONS(2254),
    [anon_sym_unsigned] = ACTIONS(2254),
    [anon_sym_long] = ACTIONS(2254),
    [anon_sym_short] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_static] = ACTIONS(2254),
    [anon_sym_register] = ACTIONS(2254),
    [anon_sym_inline] = ACTIONS(2254),
    [anon_sym___inline] = ACTIONS(2254),
    [anon_sym___inline__] = ACTIONS(2254),
    [anon_sym___forceinline] = ACTIONS(2254),
    [anon_sym_thread_local] = ACTIONS(2254),
    [anon_sym___thread] = ACTIONS(2254),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_constexpr] = ACTIONS(2254),
    [anon_sym_volatile] = ACTIONS(2254),
    [anon_sym_restrict] = ACTIONS(2254),
    [anon_sym___restrict__] = ACTIONS(2254),
    [anon_sym__Atomic] = ACTIONS(2254),
    [anon_sym__Noreturn] = ACTIONS(2254),
    [anon_sym_noreturn] = ACTIONS(2254),
    [anon_sym__Nonnull] = ACTIONS(2254),
    [anon_sym_mutable] = ACTIONS(2254),
    [anon_sym_constinit] = ACTIONS(2254),
    [anon_sym_consteval] = ACTIONS(2254),
    [anon_sym_alignas] = ACTIONS(2254),
    [anon_sym__Alignas] = ACTIONS(2254),
    [sym_primitive_type] = ACTIONS(2254),
    [anon_sym_enum] = ACTIONS(2254),
    [anon_sym_class] = ACTIONS(2254),
    [anon_sym_struct] = ACTIONS(2254),
    [anon_sym_union] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(2254),
    [anon_sym_else] = ACTIONS(2254),
    [anon_sym_switch] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2254),
    [anon_sym_do] = ACTIONS(2254),
    [anon_sym_for] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2254),
    [anon_sym_break] = ACTIONS(2254),
    [anon_sym_continue] = ACTIONS(2254),
    [anon_sym_goto] = ACTIONS(2254),
    [anon_sym___try] = ACTIONS(2254),
    [anon_sym___leave] = ACTIONS(2254),
    [anon_sym_not] = ACTIONS(2254),
    [anon_sym_compl] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2256),
    [anon_sym_PLUS_PLUS] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2254),
    [anon_sym___alignof__] = ACTIONS(2254),
    [anon_sym___alignof] = ACTIONS(2254),
    [anon_sym__alignof] = ACTIONS(2254),
    [anon_sym_alignof] = ACTIONS(2254),
    [anon_sym__Alignof] = ACTIONS(2254),
    [anon_sym_offsetof] = ACTIONS(2254),
    [anon_sym__Generic] = ACTIONS(2254),
    [anon_sym_asm] = ACTIONS(2254),
    [anon_sym___asm__] = ACTIONS(2254),
    [anon_sym___asm] = ACTIONS(2254),
    [sym_number_literal] = ACTIONS(2256),
    [anon_sym_L_SQUOTE] = ACTIONS(2256),
    [anon_sym_u_SQUOTE] = ACTIONS(2256),
    [anon_sym_U_SQUOTE] = ACTIONS(2256),
    [anon_sym_u8_SQUOTE] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2256),
    [anon_sym_L_DQUOTE] = ACTIONS(2256),
    [anon_sym_u_DQUOTE] = ACTIONS(2256),
    [anon_sym_U_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8_DQUOTE] = ACTIONS(2256),
    [anon_sym_DQUOTE] = ACTIONS(2256),
    [sym_true] = ACTIONS(2254),
    [sym_false] = ACTIONS(2254),
    [anon_sym_NULL] = ACTIONS(2254),
    [anon_sym_nullptr] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2254),
    [anon_sym_decltype] = ACTIONS(2254),
    [anon_sym_typename] = ACTIONS(2254),
    [anon_sym_template] = ACTIONS(2254),
    [anon_sym_try] = ACTIONS(2254),
    [anon_sym_delete] = ACTIONS(2254),
    [anon_sym_throw] = ACTIONS(2254),
    [anon_sym_co_return] = ACTIONS(2254),
    [anon_sym_co_yield] = ACTIONS(2254),
    [anon_sym_R_DQUOTE] = ACTIONS(2256),
    [anon_sym_LR_DQUOTE] = ACTIONS(2256),
    [anon_sym_uR_DQUOTE] = ACTIONS(2256),
    [anon_sym_UR_DQUOTE] = ACTIONS(2256),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2256),
    [anon_sym_co_await] = ACTIONS(2254),
    [anon_sym_new] = ACTIONS(2254),
    [anon_sym_requires] = ACTIONS(2254),
    [sym_this] = ACTIONS(2254),
    [anon_sym_discard] = ACTIONS(2254),
    [anon_sym_precise] = ACTIONS(2254),
    [anon_sym_shared] = ACTIONS(2254),
    [anon_sym_groupshared] = ACTIONS(2254),
    [anon_sym_uniform] = ACTIONS(2254),
    [anon_sym_row_major] = ACTIONS(2254),
    [anon_sym_column_major] = ACTIONS(2254),
    [anon_sym_globallycoherent] = ACTIONS(2254),
    [anon_sym_centroid] = ACTIONS(2254),
    [anon_sym_noperspective] = ACTIONS(2254),
    [anon_sym_nointerpolation] = ACTIONS(2254),
    [anon_sym_sample] = ACTIONS(2254),
    [anon_sym_linear] = ACTIONS(2254),
    [anon_sym_snorm] = ACTIONS(2254),
    [anon_sym_unorm] = ACTIONS(2254),
    [anon_sym_point] = ACTIONS(2254),
    [anon_sym_line] = ACTIONS(2254),
    [anon_sym_triangleadj] = ACTIONS(2254),
    [anon_sym_lineadj] = ACTIONS(2254),
    [anon_sym_triangle] = ACTIONS(2254),
    [anon_sym_cbuffer] = ACTIONS(2254),
  },
  [1051] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_typedef] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_union] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym___try] = ACTIONS(2284),
    [anon_sym___leave] = ACTIONS(2284),
    [anon_sym_not] = ACTIONS(2284),
    [anon_sym_compl] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym___alignof__] = ACTIONS(2284),
    [anon_sym___alignof] = ACTIONS(2284),
    [anon_sym__alignof] = ACTIONS(2284),
    [anon_sym_alignof] = ACTIONS(2284),
    [anon_sym__Alignof] = ACTIONS(2284),
    [anon_sym_offsetof] = ACTIONS(2284),
    [anon_sym__Generic] = ACTIONS(2284),
    [anon_sym_asm] = ACTIONS(2284),
    [anon_sym___asm__] = ACTIONS(2284),
    [anon_sym___asm] = ACTIONS(2284),
    [sym_number_literal] = ACTIONS(2286),
    [anon_sym_L_SQUOTE] = ACTIONS(2286),
    [anon_sym_u_SQUOTE] = ACTIONS(2286),
    [anon_sym_U_SQUOTE] = ACTIONS(2286),
    [anon_sym_u8_SQUOTE] = ACTIONS(2286),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [anon_sym_L_DQUOTE] = ACTIONS(2286),
    [anon_sym_u_DQUOTE] = ACTIONS(2286),
    [anon_sym_U_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [sym_true] = ACTIONS(2284),
    [sym_false] = ACTIONS(2284),
    [anon_sym_NULL] = ACTIONS(2284),
    [anon_sym_nullptr] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_typename] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_delete] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_co_return] = ACTIONS(2284),
    [anon_sym_co_yield] = ACTIONS(2284),
    [anon_sym_R_DQUOTE] = ACTIONS(2286),
    [anon_sym_LR_DQUOTE] = ACTIONS(2286),
    [anon_sym_uR_DQUOTE] = ACTIONS(2286),
    [anon_sym_UR_DQUOTE] = ACTIONS(2286),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2286),
    [anon_sym_co_await] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [sym_this] = ACTIONS(2284),
    [anon_sym_discard] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
    [anon_sym_cbuffer] = ACTIONS(2284),
  },
  [1052] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_typedef] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_union] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym___try] = ACTIONS(2288),
    [anon_sym___leave] = ACTIONS(2288),
    [anon_sym_not] = ACTIONS(2288),
    [anon_sym_compl] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym___alignof__] = ACTIONS(2288),
    [anon_sym___alignof] = ACTIONS(2288),
    [anon_sym__alignof] = ACTIONS(2288),
    [anon_sym_alignof] = ACTIONS(2288),
    [anon_sym__Alignof] = ACTIONS(2288),
    [anon_sym_offsetof] = ACTIONS(2288),
    [anon_sym__Generic] = ACTIONS(2288),
    [anon_sym_asm] = ACTIONS(2288),
    [anon_sym___asm__] = ACTIONS(2288),
    [anon_sym___asm] = ACTIONS(2288),
    [sym_number_literal] = ACTIONS(2290),
    [anon_sym_L_SQUOTE] = ACTIONS(2290),
    [anon_sym_u_SQUOTE] = ACTIONS(2290),
    [anon_sym_U_SQUOTE] = ACTIONS(2290),
    [anon_sym_u8_SQUOTE] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [anon_sym_L_DQUOTE] = ACTIONS(2290),
    [anon_sym_u_DQUOTE] = ACTIONS(2290),
    [anon_sym_U_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_true] = ACTIONS(2288),
    [sym_false] = ACTIONS(2288),
    [anon_sym_NULL] = ACTIONS(2288),
    [anon_sym_nullptr] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_typename] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_delete] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_co_return] = ACTIONS(2288),
    [anon_sym_co_yield] = ACTIONS(2288),
    [anon_sym_R_DQUOTE] = ACTIONS(2290),
    [anon_sym_LR_DQUOTE] = ACTIONS(2290),
    [anon_sym_uR_DQUOTE] = ACTIONS(2290),
    [anon_sym_UR_DQUOTE] = ACTIONS(2290),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2290),
    [anon_sym_co_await] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [sym_this] = ACTIONS(2288),
    [anon_sym_discard] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
    [anon_sym_cbuffer] = ACTIONS(2288),
  },
  [1053] = {
    [sym_identifier] = ACTIONS(2346),
    [anon_sym_LPAREN2] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym___extension__] = ACTIONS(2346),
    [anon_sym_typedef] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2346),
    [anon_sym_out] = ACTIONS(2346),
    [anon_sym_inout] = ACTIONS(2346),
    [anon_sym_virtual] = ACTIONS(2346),
    [anon_sym_extern] = ACTIONS(2346),
    [anon_sym___attribute__] = ACTIONS(2346),
    [anon_sym___attribute] = ACTIONS(2346),
    [anon_sym_COLON_COLON] = ACTIONS(2348),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2348),
    [anon_sym___declspec] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_signed] = ACTIONS(2346),
    [anon_sym_unsigned] = ACTIONS(2346),
    [anon_sym_long] = ACTIONS(2346),
    [anon_sym_short] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_register] = ACTIONS(2346),
    [anon_sym_inline] = ACTIONS(2346),
    [anon_sym___inline] = ACTIONS(2346),
    [anon_sym___inline__] = ACTIONS(2346),
    [anon_sym___forceinline] = ACTIONS(2346),
    [anon_sym_thread_local] = ACTIONS(2346),
    [anon_sym___thread] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_constexpr] = ACTIONS(2346),
    [anon_sym_volatile] = ACTIONS(2346),
    [anon_sym_restrict] = ACTIONS(2346),
    [anon_sym___restrict__] = ACTIONS(2346),
    [anon_sym__Atomic] = ACTIONS(2346),
    [anon_sym__Noreturn] = ACTIONS(2346),
    [anon_sym_noreturn] = ACTIONS(2346),
    [anon_sym__Nonnull] = ACTIONS(2346),
    [anon_sym_mutable] = ACTIONS(2346),
    [anon_sym_constinit] = ACTIONS(2346),
    [anon_sym_consteval] = ACTIONS(2346),
    [anon_sym_alignas] = ACTIONS(2346),
    [anon_sym__Alignas] = ACTIONS(2346),
    [sym_primitive_type] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_goto] = ACTIONS(2346),
    [anon_sym___try] = ACTIONS(2346),
    [anon_sym___leave] = ACTIONS(2346),
    [anon_sym_not] = ACTIONS(2346),
    [anon_sym_compl] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2346),
    [anon_sym___alignof__] = ACTIONS(2346),
    [anon_sym___alignof] = ACTIONS(2346),
    [anon_sym__alignof] = ACTIONS(2346),
    [anon_sym_alignof] = ACTIONS(2346),
    [anon_sym__Alignof] = ACTIONS(2346),
    [anon_sym_offsetof] = ACTIONS(2346),
    [anon_sym__Generic] = ACTIONS(2346),
    [anon_sym_asm] = ACTIONS(2346),
    [anon_sym___asm__] = ACTIONS(2346),
    [anon_sym___asm] = ACTIONS(2346),
    [sym_number_literal] = ACTIONS(2348),
    [anon_sym_L_SQUOTE] = ACTIONS(2348),
    [anon_sym_u_SQUOTE] = ACTIONS(2348),
    [anon_sym_U_SQUOTE] = ACTIONS(2348),
    [anon_sym_u8_SQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [anon_sym_L_DQUOTE] = ACTIONS(2348),
    [anon_sym_u_DQUOTE] = ACTIONS(2348),
    [anon_sym_U_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8_DQUOTE] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [anon_sym_NULL] = ACTIONS(2346),
    [anon_sym_nullptr] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2346),
    [anon_sym_decltype] = ACTIONS(2346),
    [anon_sym_typename] = ACTIONS(2346),
    [anon_sym_template] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_co_return] = ACTIONS(2346),
    [anon_sym_co_yield] = ACTIONS(2346),
    [anon_sym_R_DQUOTE] = ACTIONS(2348),
    [anon_sym_LR_DQUOTE] = ACTIONS(2348),
    [anon_sym_uR_DQUOTE] = ACTIONS(2348),
    [anon_sym_UR_DQUOTE] = ACTIONS(2348),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2348),
    [anon_sym_co_await] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_requires] = ACTIONS(2346),
    [sym_this] = ACTIONS(2346),
    [anon_sym_discard] = ACTIONS(2346),
    [anon_sym_precise] = ACTIONS(2346),
    [anon_sym_shared] = ACTIONS(2346),
    [anon_sym_groupshared] = ACTIONS(2346),
    [anon_sym_uniform] = ACTIONS(2346),
    [anon_sym_row_major] = ACTIONS(2346),
    [anon_sym_column_major] = ACTIONS(2346),
    [anon_sym_globallycoherent] = ACTIONS(2346),
    [anon_sym_centroid] = ACTIONS(2346),
    [anon_sym_noperspective] = ACTIONS(2346),
    [anon_sym_nointerpolation] = ACTIONS(2346),
    [anon_sym_sample] = ACTIONS(2346),
    [anon_sym_linear] = ACTIONS(2346),
    [anon_sym_snorm] = ACTIONS(2346),
    [anon_sym_unorm] = ACTIONS(2346),
    [anon_sym_point] = ACTIONS(2346),
    [anon_sym_line] = ACTIONS(2346),
    [anon_sym_triangleadj] = ACTIONS(2346),
    [anon_sym_lineadj] = ACTIONS(2346),
    [anon_sym_triangle] = ACTIONS(2346),
    [anon_sym_cbuffer] = ACTIONS(2346),
  },
  [1054] = {
    [sym_identifier] = ACTIONS(2398),
    [anon_sym_LPAREN2] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym___extension__] = ACTIONS(2398),
    [anon_sym_typedef] = ACTIONS(2398),
    [anon_sym_in] = ACTIONS(2398),
    [anon_sym_out] = ACTIONS(2398),
    [anon_sym_inout] = ACTIONS(2398),
    [anon_sym_virtual] = ACTIONS(2398),
    [anon_sym_extern] = ACTIONS(2398),
    [anon_sym___attribute__] = ACTIONS(2398),
    [anon_sym___attribute] = ACTIONS(2398),
    [anon_sym_COLON_COLON] = ACTIONS(2400),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2400),
    [anon_sym___declspec] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_signed] = ACTIONS(2398),
    [anon_sym_unsigned] = ACTIONS(2398),
    [anon_sym_long] = ACTIONS(2398),
    [anon_sym_short] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_register] = ACTIONS(2398),
    [anon_sym_inline] = ACTIONS(2398),
    [anon_sym___inline] = ACTIONS(2398),
    [anon_sym___inline__] = ACTIONS(2398),
    [anon_sym___forceinline] = ACTIONS(2398),
    [anon_sym_thread_local] = ACTIONS(2398),
    [anon_sym___thread] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_constexpr] = ACTIONS(2398),
    [anon_sym_volatile] = ACTIONS(2398),
    [anon_sym_restrict] = ACTIONS(2398),
    [anon_sym___restrict__] = ACTIONS(2398),
    [anon_sym__Atomic] = ACTIONS(2398),
    [anon_sym__Noreturn] = ACTIONS(2398),
    [anon_sym_noreturn] = ACTIONS(2398),
    [anon_sym__Nonnull] = ACTIONS(2398),
    [anon_sym_mutable] = ACTIONS(2398),
    [anon_sym_constinit] = ACTIONS(2398),
    [anon_sym_consteval] = ACTIONS(2398),
    [anon_sym_alignas] = ACTIONS(2398),
    [anon_sym__Alignas] = ACTIONS(2398),
    [sym_primitive_type] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_struct] = ACTIONS(2398),
    [anon_sym_union] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_goto] = ACTIONS(2398),
    [anon_sym___try] = ACTIONS(2398),
    [anon_sym___leave] = ACTIONS(2398),
    [anon_sym_not] = ACTIONS(2398),
    [anon_sym_compl] = ACTIONS(2398),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_sizeof] = ACTIONS(2398),
    [anon_sym___alignof__] = ACTIONS(2398),
    [anon_sym___alignof] = ACTIONS(2398),
    [anon_sym__alignof] = ACTIONS(2398),
    [anon_sym_alignof] = ACTIONS(2398),
    [anon_sym__Alignof] = ACTIONS(2398),
    [anon_sym_offsetof] = ACTIONS(2398),
    [anon_sym__Generic] = ACTIONS(2398),
    [anon_sym_asm] = ACTIONS(2398),
    [anon_sym___asm__] = ACTIONS(2398),
    [anon_sym___asm] = ACTIONS(2398),
    [sym_number_literal] = ACTIONS(2400),
    [anon_sym_L_SQUOTE] = ACTIONS(2400),
    [anon_sym_u_SQUOTE] = ACTIONS(2400),
    [anon_sym_U_SQUOTE] = ACTIONS(2400),
    [anon_sym_u8_SQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_L_DQUOTE] = ACTIONS(2400),
    [anon_sym_u_DQUOTE] = ACTIONS(2400),
    [anon_sym_U_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [anon_sym_NULL] = ACTIONS(2398),
    [anon_sym_nullptr] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2398),
    [anon_sym_decltype] = ACTIONS(2398),
    [anon_sym_typename] = ACTIONS(2398),
    [anon_sym_template] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_co_return] = ACTIONS(2398),
    [anon_sym_co_yield] = ACTIONS(2398),
    [anon_sym_R_DQUOTE] = ACTIONS(2400),
    [anon_sym_LR_DQUOTE] = ACTIONS(2400),
    [anon_sym_uR_DQUOTE] = ACTIONS(2400),
    [anon_sym_UR_DQUOTE] = ACTIONS(2400),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2400),
    [anon_sym_co_await] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_requires] = ACTIONS(2398),
    [sym_this] = ACTIONS(2398),
    [anon_sym_discard] = ACTIONS(2398),
    [anon_sym_precise] = ACTIONS(2398),
    [anon_sym_shared] = ACTIONS(2398),
    [anon_sym_groupshared] = ACTIONS(2398),
    [anon_sym_uniform] = ACTIONS(2398),
    [anon_sym_row_major] = ACTIONS(2398),
    [anon_sym_column_major] = ACTIONS(2398),
    [anon_sym_globallycoherent] = ACTIONS(2398),
    [anon_sym_centroid] = ACTIONS(2398),
    [anon_sym_noperspective] = ACTIONS(2398),
    [anon_sym_nointerpolation] = ACTIONS(2398),
    [anon_sym_sample] = ACTIONS(2398),
    [anon_sym_linear] = ACTIONS(2398),
    [anon_sym_snorm] = ACTIONS(2398),
    [anon_sym_unorm] = ACTIONS(2398),
    [anon_sym_point] = ACTIONS(2398),
    [anon_sym_line] = ACTIONS(2398),
    [anon_sym_triangleadj] = ACTIONS(2398),
    [anon_sym_lineadj] = ACTIONS(2398),
    [anon_sym_triangle] = ACTIONS(2398),
    [anon_sym_cbuffer] = ACTIONS(2398),
  },
  [1055] = {
    [sym_identifier] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [1056] = {
    [sym_identifier] = ACTIONS(2330),
    [anon_sym_LPAREN2] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2332),
    [anon_sym_TILDE] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2332),
    [anon_sym_AMP] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2332),
    [anon_sym___extension__] = ACTIONS(2330),
    [anon_sym_typedef] = ACTIONS(2330),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_out] = ACTIONS(2330),
    [anon_sym_inout] = ACTIONS(2330),
    [anon_sym_virtual] = ACTIONS(2330),
    [anon_sym_extern] = ACTIONS(2330),
    [anon_sym___attribute__] = ACTIONS(2330),
    [anon_sym___attribute] = ACTIONS(2330),
    [anon_sym_COLON_COLON] = ACTIONS(2332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2332),
    [anon_sym___declspec] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2332),
    [anon_sym_signed] = ACTIONS(2330),
    [anon_sym_unsigned] = ACTIONS(2330),
    [anon_sym_long] = ACTIONS(2330),
    [anon_sym_short] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_register] = ACTIONS(2330),
    [anon_sym_inline] = ACTIONS(2330),
    [anon_sym___inline] = ACTIONS(2330),
    [anon_sym___inline__] = ACTIONS(2330),
    [anon_sym___forceinline] = ACTIONS(2330),
    [anon_sym_thread_local] = ACTIONS(2330),
    [anon_sym___thread] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [anon_sym_constexpr] = ACTIONS(2330),
    [anon_sym_volatile] = ACTIONS(2330),
    [anon_sym_restrict] = ACTIONS(2330),
    [anon_sym___restrict__] = ACTIONS(2330),
    [anon_sym__Atomic] = ACTIONS(2330),
    [anon_sym__Noreturn] = ACTIONS(2330),
    [anon_sym_noreturn] = ACTIONS(2330),
    [anon_sym__Nonnull] = ACTIONS(2330),
    [anon_sym_mutable] = ACTIONS(2330),
    [anon_sym_constinit] = ACTIONS(2330),
    [anon_sym_consteval] = ACTIONS(2330),
    [anon_sym_alignas] = ACTIONS(2330),
    [anon_sym__Alignas] = ACTIONS(2330),
    [sym_primitive_type] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_struct] = ACTIONS(2330),
    [anon_sym_union] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_goto] = ACTIONS(2330),
    [anon_sym___try] = ACTIONS(2330),
    [anon_sym___leave] = ACTIONS(2330),
    [anon_sym_not] = ACTIONS(2330),
    [anon_sym_compl] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2332),
    [anon_sym_PLUS_PLUS] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2330),
    [anon_sym___alignof__] = ACTIONS(2330),
    [anon_sym___alignof] = ACTIONS(2330),
    [anon_sym__alignof] = ACTIONS(2330),
    [anon_sym_alignof] = ACTIONS(2330),
    [anon_sym__Alignof] = ACTIONS(2330),
    [anon_sym_offsetof] = ACTIONS(2330),
    [anon_sym__Generic] = ACTIONS(2330),
    [anon_sym_asm] = ACTIONS(2330),
    [anon_sym___asm__] = ACTIONS(2330),
    [anon_sym___asm] = ACTIONS(2330),
    [sym_number_literal] = ACTIONS(2332),
    [anon_sym_L_SQUOTE] = ACTIONS(2332),
    [anon_sym_u_SQUOTE] = ACTIONS(2332),
    [anon_sym_U_SQUOTE] = ACTIONS(2332),
    [anon_sym_u8_SQUOTE] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2332),
    [anon_sym_L_DQUOTE] = ACTIONS(2332),
    [anon_sym_u_DQUOTE] = ACTIONS(2332),
    [anon_sym_U_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8_DQUOTE] = ACTIONS(2332),
    [anon_sym_DQUOTE] = ACTIONS(2332),
    [sym_true] = ACTIONS(2330),
    [sym_false] = ACTIONS(2330),
    [anon_sym_NULL] = ACTIONS(2330),
    [anon_sym_nullptr] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2330),
    [anon_sym_decltype] = ACTIONS(2330),
    [anon_sym_typename] = ACTIONS(2330),
    [anon_sym_template] = ACTIONS(2330),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_co_return] = ACTIONS(2330),
    [anon_sym_co_yield] = ACTIONS(2330),
    [anon_sym_R_DQUOTE] = ACTIONS(2332),
    [anon_sym_LR_DQUOTE] = ACTIONS(2332),
    [anon_sym_uR_DQUOTE] = ACTIONS(2332),
    [anon_sym_UR_DQUOTE] = ACTIONS(2332),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2332),
    [anon_sym_co_await] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_requires] = ACTIONS(2330),
    [sym_this] = ACTIONS(2330),
    [anon_sym_discard] = ACTIONS(2330),
    [anon_sym_precise] = ACTIONS(2330),
    [anon_sym_shared] = ACTIONS(2330),
    [anon_sym_groupshared] = ACTIONS(2330),
    [anon_sym_uniform] = ACTIONS(2330),
    [anon_sym_row_major] = ACTIONS(2330),
    [anon_sym_column_major] = ACTIONS(2330),
    [anon_sym_globallycoherent] = ACTIONS(2330),
    [anon_sym_centroid] = ACTIONS(2330),
    [anon_sym_noperspective] = ACTIONS(2330),
    [anon_sym_nointerpolation] = ACTIONS(2330),
    [anon_sym_sample] = ACTIONS(2330),
    [anon_sym_linear] = ACTIONS(2330),
    [anon_sym_snorm] = ACTIONS(2330),
    [anon_sym_unorm] = ACTIONS(2330),
    [anon_sym_point] = ACTIONS(2330),
    [anon_sym_line] = ACTIONS(2330),
    [anon_sym_triangleadj] = ACTIONS(2330),
    [anon_sym_lineadj] = ACTIONS(2330),
    [anon_sym_triangle] = ACTIONS(2330),
    [anon_sym_cbuffer] = ACTIONS(2330),
  },
  [1057] = {
    [sym_identifier] = ACTIONS(4060),
    [anon_sym_LPAREN2] = ACTIONS(4066),
    [anon_sym_BANG] = ACTIONS(4066),
    [anon_sym_TILDE] = ACTIONS(4066),
    [anon_sym_DASH] = ACTIONS(4068),
    [anon_sym_PLUS] = ACTIONS(4068),
    [anon_sym_STAR] = ACTIONS(4066),
    [anon_sym_AMP] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4066),
    [anon_sym___extension__] = ACTIONS(4060),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_out] = ACTIONS(4072),
    [anon_sym_inout] = ACTIONS(4072),
    [anon_sym_virtual] = ACTIONS(4072),
    [anon_sym_extern] = ACTIONS(4072),
    [anon_sym___attribute__] = ACTIONS(4072),
    [anon_sym___attribute] = ACTIONS(4072),
    [anon_sym_COLON_COLON] = ACTIONS(4063),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4063),
    [anon_sym___declspec] = ACTIONS(4072),
    [anon_sym_LBRACE] = ACTIONS(4066),
    [anon_sym_signed] = ACTIONS(4072),
    [anon_sym_unsigned] = ACTIONS(4072),
    [anon_sym_long] = ACTIONS(4072),
    [anon_sym_short] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [anon_sym_static] = ACTIONS(4072),
    [anon_sym_register] = ACTIONS(4072),
    [anon_sym_inline] = ACTIONS(4072),
    [anon_sym___inline] = ACTIONS(4072),
    [anon_sym___inline__] = ACTIONS(4072),
    [anon_sym___forceinline] = ACTIONS(4072),
    [anon_sym_thread_local] = ACTIONS(4072),
    [anon_sym___thread] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4072),
    [anon_sym_constexpr] = ACTIONS(4072),
    [anon_sym_volatile] = ACTIONS(4072),
    [anon_sym_restrict] = ACTIONS(4072),
    [anon_sym___restrict__] = ACTIONS(4072),
    [anon_sym__Atomic] = ACTIONS(4072),
    [anon_sym__Noreturn] = ACTIONS(4072),
    [anon_sym_noreturn] = ACTIONS(4072),
    [anon_sym__Nonnull] = ACTIONS(4072),
    [anon_sym_mutable] = ACTIONS(4072),
    [anon_sym_constinit] = ACTIONS(4072),
    [anon_sym_consteval] = ACTIONS(4072),
    [anon_sym_alignas] = ACTIONS(4072),
    [anon_sym__Alignas] = ACTIONS(4072),
    [sym_primitive_type] = ACTIONS(4060),
    [anon_sym_enum] = ACTIONS(4072),
    [anon_sym_class] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4072),
    [anon_sym_union] = ACTIONS(4072),
    [anon_sym_if] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4068),
    [anon_sym_case] = ACTIONS(4068),
    [anon_sym_default] = ACTIONS(4068),
    [anon_sym_while] = ACTIONS(4068),
    [anon_sym_do] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4068),
    [anon_sym_return] = ACTIONS(4068),
    [anon_sym_break] = ACTIONS(4068),
    [anon_sym_continue] = ACTIONS(4068),
    [anon_sym_goto] = ACTIONS(4068),
    [anon_sym___try] = ACTIONS(4068),
    [anon_sym___leave] = ACTIONS(4068),
    [anon_sym_not] = ACTIONS(4068),
    [anon_sym_compl] = ACTIONS(4068),
    [anon_sym_DASH_DASH] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4066),
    [anon_sym_sizeof] = ACTIONS(4068),
    [anon_sym___alignof__] = ACTIONS(4068),
    [anon_sym___alignof] = ACTIONS(4068),
    [anon_sym__alignof] = ACTIONS(4068),
    [anon_sym_alignof] = ACTIONS(4068),
    [anon_sym__Alignof] = ACTIONS(4068),
    [anon_sym_offsetof] = ACTIONS(4068),
    [anon_sym__Generic] = ACTIONS(4068),
    [anon_sym_asm] = ACTIONS(4068),
    [anon_sym___asm__] = ACTIONS(4068),
    [anon_sym___asm] = ACTIONS(4068),
    [sym_number_literal] = ACTIONS(4066),
    [anon_sym_L_SQUOTE] = ACTIONS(4066),
    [anon_sym_u_SQUOTE] = ACTIONS(4066),
    [anon_sym_U_SQUOTE] = ACTIONS(4066),
    [anon_sym_u8_SQUOTE] = ACTIONS(4066),
    [anon_sym_SQUOTE] = ACTIONS(4066),
    [anon_sym_L_DQUOTE] = ACTIONS(4066),
    [anon_sym_u_DQUOTE] = ACTIONS(4066),
    [anon_sym_U_DQUOTE] = ACTIONS(4066),
    [anon_sym_u8_DQUOTE] = ACTIONS(4066),
    [anon_sym_DQUOTE] = ACTIONS(4066),
    [sym_true] = ACTIONS(4068),
    [sym_false] = ACTIONS(4068),
    [anon_sym_NULL] = ACTIONS(4068),
    [anon_sym_nullptr] = ACTIONS(4068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4072),
    [anon_sym_decltype] = ACTIONS(4060),
    [anon_sym_typename] = ACTIONS(4072),
    [anon_sym_template] = ACTIONS(4060),
    [anon_sym_try] = ACTIONS(4068),
    [anon_sym_delete] = ACTIONS(4068),
    [anon_sym_throw] = ACTIONS(4068),
    [anon_sym_co_return] = ACTIONS(4068),
    [anon_sym_co_yield] = ACTIONS(4068),
    [anon_sym_R_DQUOTE] = ACTIONS(4066),
    [anon_sym_LR_DQUOTE] = ACTIONS(4066),
    [anon_sym_uR_DQUOTE] = ACTIONS(4066),
    [anon_sym_UR_DQUOTE] = ACTIONS(4066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4066),
    [anon_sym_co_await] = ACTIONS(4068),
    [anon_sym_new] = ACTIONS(4068),
    [anon_sym_requires] = ACTIONS(4068),
    [sym_this] = ACTIONS(4068),
    [anon_sym_discard] = ACTIONS(4068),
    [anon_sym_precise] = ACTIONS(4072),
    [anon_sym_shared] = ACTIONS(4072),
    [anon_sym_groupshared] = ACTIONS(4072),
    [anon_sym_uniform] = ACTIONS(4072),
    [anon_sym_row_major] = ACTIONS(4072),
    [anon_sym_column_major] = ACTIONS(4072),
    [anon_sym_globallycoherent] = ACTIONS(4072),
    [anon_sym_centroid] = ACTIONS(4072),
    [anon_sym_noperspective] = ACTIONS(4072),
    [anon_sym_nointerpolation] = ACTIONS(4072),
    [anon_sym_sample] = ACTIONS(4072),
    [anon_sym_linear] = ACTIONS(4072),
    [anon_sym_snorm] = ACTIONS(4072),
    [anon_sym_unorm] = ACTIONS(4072),
    [anon_sym_point] = ACTIONS(4072),
    [anon_sym_line] = ACTIONS(4072),
    [anon_sym_triangleadj] = ACTIONS(4072),
    [anon_sym_lineadj] = ACTIONS(4072),
    [anon_sym_triangle] = ACTIONS(4072),
    [anon_sym_cbuffer] = ACTIONS(4068),
  },
  [1058] = {
    [sym_identifier] = ACTIONS(2334),
    [anon_sym_LPAREN2] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(2334),
    [anon_sym_STAR] = ACTIONS(2336),
    [anon_sym_AMP] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2336),
    [anon_sym___extension__] = ACTIONS(2334),
    [anon_sym_typedef] = ACTIONS(2334),
    [anon_sym_in] = ACTIONS(2334),
    [anon_sym_out] = ACTIONS(2334),
    [anon_sym_inout] = ACTIONS(2334),
    [anon_sym_virtual] = ACTIONS(2334),
    [anon_sym_extern] = ACTIONS(2334),
    [anon_sym___attribute__] = ACTIONS(2334),
    [anon_sym___attribute] = ACTIONS(2334),
    [anon_sym_COLON_COLON] = ACTIONS(2336),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2336),
    [anon_sym___declspec] = ACTIONS(2334),
    [anon_sym_LBRACE] = ACTIONS(2336),
    [anon_sym_signed] = ACTIONS(2334),
    [anon_sym_unsigned] = ACTIONS(2334),
    [anon_sym_long] = ACTIONS(2334),
    [anon_sym_short] = ACTIONS(2334),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_static] = ACTIONS(2334),
    [anon_sym_register] = ACTIONS(2334),
    [anon_sym_inline] = ACTIONS(2334),
    [anon_sym___inline] = ACTIONS(2334),
    [anon_sym___inline__] = ACTIONS(2334),
    [anon_sym___forceinline] = ACTIONS(2334),
    [anon_sym_thread_local] = ACTIONS(2334),
    [anon_sym___thread] = ACTIONS(2334),
    [anon_sym_const] = ACTIONS(2334),
    [anon_sym_constexpr] = ACTIONS(2334),
    [anon_sym_volatile] = ACTIONS(2334),
    [anon_sym_restrict] = ACTIONS(2334),
    [anon_sym___restrict__] = ACTIONS(2334),
    [anon_sym__Atomic] = ACTIONS(2334),
    [anon_sym__Noreturn] = ACTIONS(2334),
    [anon_sym_noreturn] = ACTIONS(2334),
    [anon_sym__Nonnull] = ACTIONS(2334),
    [anon_sym_mutable] = ACTIONS(2334),
    [anon_sym_constinit] = ACTIONS(2334),
    [anon_sym_consteval] = ACTIONS(2334),
    [anon_sym_alignas] = ACTIONS(2334),
    [anon_sym__Alignas] = ACTIONS(2334),
    [sym_primitive_type] = ACTIONS(2334),
    [anon_sym_enum] = ACTIONS(2334),
    [anon_sym_class] = ACTIONS(2334),
    [anon_sym_struct] = ACTIONS(2334),
    [anon_sym_union] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_else] = ACTIONS(2334),
    [anon_sym_switch] = ACTIONS(2334),
    [anon_sym_while] = ACTIONS(2334),
    [anon_sym_do] = ACTIONS(2334),
    [anon_sym_for] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2334),
    [anon_sym_break] = ACTIONS(2334),
    [anon_sym_continue] = ACTIONS(2334),
    [anon_sym_goto] = ACTIONS(2334),
    [anon_sym___try] = ACTIONS(2334),
    [anon_sym___leave] = ACTIONS(2334),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_compl] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2336),
    [anon_sym_PLUS_PLUS] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2334),
    [anon_sym___alignof__] = ACTIONS(2334),
    [anon_sym___alignof] = ACTIONS(2334),
    [anon_sym__alignof] = ACTIONS(2334),
    [anon_sym_alignof] = ACTIONS(2334),
    [anon_sym__Alignof] = ACTIONS(2334),
    [anon_sym_offsetof] = ACTIONS(2334),
    [anon_sym__Generic] = ACTIONS(2334),
    [anon_sym_asm] = ACTIONS(2334),
    [anon_sym___asm__] = ACTIONS(2334),
    [anon_sym___asm] = ACTIONS(2334),
    [sym_number_literal] = ACTIONS(2336),
    [anon_sym_L_SQUOTE] = ACTIONS(2336),
    [anon_sym_u_SQUOTE] = ACTIONS(2336),
    [anon_sym_U_SQUOTE] = ACTIONS(2336),
    [anon_sym_u8_SQUOTE] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2336),
    [anon_sym_L_DQUOTE] = ACTIONS(2336),
    [anon_sym_u_DQUOTE] = ACTIONS(2336),
    [anon_sym_U_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8_DQUOTE] = ACTIONS(2336),
    [anon_sym_DQUOTE] = ACTIONS(2336),
    [sym_true] = ACTIONS(2334),
    [sym_false] = ACTIONS(2334),
    [anon_sym_NULL] = ACTIONS(2334),
    [anon_sym_nullptr] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2334),
    [anon_sym_decltype] = ACTIONS(2334),
    [anon_sym_typename] = ACTIONS(2334),
    [anon_sym_template] = ACTIONS(2334),
    [anon_sym_try] = ACTIONS(2334),
    [anon_sym_delete] = ACTIONS(2334),
    [anon_sym_throw] = ACTIONS(2334),
    [anon_sym_co_return] = ACTIONS(2334),
    [anon_sym_co_yield] = ACTIONS(2334),
    [anon_sym_R_DQUOTE] = ACTIONS(2336),
    [anon_sym_LR_DQUOTE] = ACTIONS(2336),
    [anon_sym_uR_DQUOTE] = ACTIONS(2336),
    [anon_sym_UR_DQUOTE] = ACTIONS(2336),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2336),
    [anon_sym_co_await] = ACTIONS(2334),
    [anon_sym_new] = ACTIONS(2334),
    [anon_sym_requires] = ACTIONS(2334),
    [sym_this] = ACTIONS(2334),
    [anon_sym_discard] = ACTIONS(2334),
    [anon_sym_precise] = ACTIONS(2334),
    [anon_sym_shared] = ACTIONS(2334),
    [anon_sym_groupshared] = ACTIONS(2334),
    [anon_sym_uniform] = ACTIONS(2334),
    [anon_sym_row_major] = ACTIONS(2334),
    [anon_sym_column_major] = ACTIONS(2334),
    [anon_sym_globallycoherent] = ACTIONS(2334),
    [anon_sym_centroid] = ACTIONS(2334),
    [anon_sym_noperspective] = ACTIONS(2334),
    [anon_sym_nointerpolation] = ACTIONS(2334),
    [anon_sym_sample] = ACTIONS(2334),
    [anon_sym_linear] = ACTIONS(2334),
    [anon_sym_snorm] = ACTIONS(2334),
    [anon_sym_unorm] = ACTIONS(2334),
    [anon_sym_point] = ACTIONS(2334),
    [anon_sym_line] = ACTIONS(2334),
    [anon_sym_triangleadj] = ACTIONS(2334),
    [anon_sym_lineadj] = ACTIONS(2334),
    [anon_sym_triangle] = ACTIONS(2334),
    [anon_sym_cbuffer] = ACTIONS(2334),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_LPAREN2] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_STAR] = ACTIONS(2352),
    [anon_sym_AMP] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym___extension__] = ACTIONS(2350),
    [anon_sym_typedef] = ACTIONS(2350),
    [anon_sym_in] = ACTIONS(2350),
    [anon_sym_out] = ACTIONS(2350),
    [anon_sym_inout] = ACTIONS(2350),
    [anon_sym_virtual] = ACTIONS(2350),
    [anon_sym_extern] = ACTIONS(2350),
    [anon_sym___attribute__] = ACTIONS(2350),
    [anon_sym___attribute] = ACTIONS(2350),
    [anon_sym_COLON_COLON] = ACTIONS(2352),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2352),
    [anon_sym___declspec] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_signed] = ACTIONS(2350),
    [anon_sym_unsigned] = ACTIONS(2350),
    [anon_sym_long] = ACTIONS(2350),
    [anon_sym_short] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_register] = ACTIONS(2350),
    [anon_sym_inline] = ACTIONS(2350),
    [anon_sym___inline] = ACTIONS(2350),
    [anon_sym___inline__] = ACTIONS(2350),
    [anon_sym___forceinline] = ACTIONS(2350),
    [anon_sym_thread_local] = ACTIONS(2350),
    [anon_sym___thread] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_constexpr] = ACTIONS(2350),
    [anon_sym_volatile] = ACTIONS(2350),
    [anon_sym_restrict] = ACTIONS(2350),
    [anon_sym___restrict__] = ACTIONS(2350),
    [anon_sym__Atomic] = ACTIONS(2350),
    [anon_sym__Noreturn] = ACTIONS(2350),
    [anon_sym_noreturn] = ACTIONS(2350),
    [anon_sym__Nonnull] = ACTIONS(2350),
    [anon_sym_mutable] = ACTIONS(2350),
    [anon_sym_constinit] = ACTIONS(2350),
    [anon_sym_consteval] = ACTIONS(2350),
    [anon_sym_alignas] = ACTIONS(2350),
    [anon_sym__Alignas] = ACTIONS(2350),
    [sym_primitive_type] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_struct] = ACTIONS(2350),
    [anon_sym_union] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_goto] = ACTIONS(2350),
    [anon_sym___try] = ACTIONS(2350),
    [anon_sym___leave] = ACTIONS(2350),
    [anon_sym_not] = ACTIONS(2350),
    [anon_sym_compl] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2350),
    [anon_sym___alignof__] = ACTIONS(2350),
    [anon_sym___alignof] = ACTIONS(2350),
    [anon_sym__alignof] = ACTIONS(2350),
    [anon_sym_alignof] = ACTIONS(2350),
    [anon_sym__Alignof] = ACTIONS(2350),
    [anon_sym_offsetof] = ACTIONS(2350),
    [anon_sym__Generic] = ACTIONS(2350),
    [anon_sym_asm] = ACTIONS(2350),
    [anon_sym___asm__] = ACTIONS(2350),
    [anon_sym___asm] = ACTIONS(2350),
    [sym_number_literal] = ACTIONS(2352),
    [anon_sym_L_SQUOTE] = ACTIONS(2352),
    [anon_sym_u_SQUOTE] = ACTIONS(2352),
    [anon_sym_U_SQUOTE] = ACTIONS(2352),
    [anon_sym_u8_SQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [anon_sym_L_DQUOTE] = ACTIONS(2352),
    [anon_sym_u_DQUOTE] = ACTIONS(2352),
    [anon_sym_U_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8_DQUOTE] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [anon_sym_NULL] = ACTIONS(2350),
    [anon_sym_nullptr] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2350),
    [anon_sym_decltype] = ACTIONS(2350),
    [anon_sym_typename] = ACTIONS(2350),
    [anon_sym_template] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_co_return] = ACTIONS(2350),
    [anon_sym_co_yield] = ACTIONS(2350),
    [anon_sym_R_DQUOTE] = ACTIONS(2352),
    [anon_sym_LR_DQUOTE] = ACTIONS(2352),
    [anon_sym_uR_DQUOTE] = ACTIONS(2352),
    [anon_sym_UR_DQUOTE] = ACTIONS(2352),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2352),
    [anon_sym_co_await] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_requires] = ACTIONS(2350),
    [sym_this] = ACTIONS(2350),
    [anon_sym_discard] = ACTIONS(2350),
    [anon_sym_precise] = ACTIONS(2350),
    [anon_sym_shared] = ACTIONS(2350),
    [anon_sym_groupshared] = ACTIONS(2350),
    [anon_sym_uniform] = ACTIONS(2350),
    [anon_sym_row_major] = ACTIONS(2350),
    [anon_sym_column_major] = ACTIONS(2350),
    [anon_sym_globallycoherent] = ACTIONS(2350),
    [anon_sym_centroid] = ACTIONS(2350),
    [anon_sym_noperspective] = ACTIONS(2350),
    [anon_sym_nointerpolation] = ACTIONS(2350),
    [anon_sym_sample] = ACTIONS(2350),
    [anon_sym_linear] = ACTIONS(2350),
    [anon_sym_snorm] = ACTIONS(2350),
    [anon_sym_unorm] = ACTIONS(2350),
    [anon_sym_point] = ACTIONS(2350),
    [anon_sym_line] = ACTIONS(2350),
    [anon_sym_triangleadj] = ACTIONS(2350),
    [anon_sym_lineadj] = ACTIONS(2350),
    [anon_sym_triangle] = ACTIONS(2350),
    [anon_sym_cbuffer] = ACTIONS(2350),
  },
  [1060] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_BANG] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_DASH] = ACTIONS(2163),
    [anon_sym_PLUS] = ACTIONS(2163),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2165),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym_LBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [anon_sym_if] = ACTIONS(2163),
    [anon_sym_else] = ACTIONS(2163),
    [anon_sym_switch] = ACTIONS(2163),
    [anon_sym_while] = ACTIONS(2163),
    [anon_sym_do] = ACTIONS(2163),
    [anon_sym_for] = ACTIONS(2163),
    [anon_sym_return] = ACTIONS(2163),
    [anon_sym_break] = ACTIONS(2163),
    [anon_sym_continue] = ACTIONS(2163),
    [anon_sym_goto] = ACTIONS(2163),
    [anon_sym___try] = ACTIONS(2163),
    [anon_sym___leave] = ACTIONS(2163),
    [anon_sym_not] = ACTIONS(2163),
    [anon_sym_compl] = ACTIONS(2163),
    [anon_sym_DASH_DASH] = ACTIONS(2165),
    [anon_sym_PLUS_PLUS] = ACTIONS(2165),
    [anon_sym_sizeof] = ACTIONS(2163),
    [anon_sym___alignof__] = ACTIONS(2163),
    [anon_sym___alignof] = ACTIONS(2163),
    [anon_sym__alignof] = ACTIONS(2163),
    [anon_sym_alignof] = ACTIONS(2163),
    [anon_sym__Alignof] = ACTIONS(2163),
    [anon_sym_offsetof] = ACTIONS(2163),
    [anon_sym__Generic] = ACTIONS(2163),
    [anon_sym_asm] = ACTIONS(2163),
    [anon_sym___asm__] = ACTIONS(2163),
    [anon_sym___asm] = ACTIONS(2163),
    [sym_number_literal] = ACTIONS(2165),
    [anon_sym_L_SQUOTE] = ACTIONS(2165),
    [anon_sym_u_SQUOTE] = ACTIONS(2165),
    [anon_sym_U_SQUOTE] = ACTIONS(2165),
    [anon_sym_u8_SQUOTE] = ACTIONS(2165),
    [anon_sym_SQUOTE] = ACTIONS(2165),
    [anon_sym_L_DQUOTE] = ACTIONS(2165),
    [anon_sym_u_DQUOTE] = ACTIONS(2165),
    [anon_sym_U_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8_DQUOTE] = ACTIONS(2165),
    [anon_sym_DQUOTE] = ACTIONS(2165),
    [sym_true] = ACTIONS(2163),
    [sym_false] = ACTIONS(2163),
    [anon_sym_NULL] = ACTIONS(2163),
    [anon_sym_nullptr] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_try] = ACTIONS(2163),
    [anon_sym_delete] = ACTIONS(2163),
    [anon_sym_throw] = ACTIONS(2163),
    [anon_sym_co_return] = ACTIONS(2163),
    [anon_sym_co_yield] = ACTIONS(2163),
    [anon_sym_R_DQUOTE] = ACTIONS(2165),
    [anon_sym_LR_DQUOTE] = ACTIONS(2165),
    [anon_sym_uR_DQUOTE] = ACTIONS(2165),
    [anon_sym_UR_DQUOTE] = ACTIONS(2165),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2165),
    [anon_sym_co_await] = ACTIONS(2163),
    [anon_sym_new] = ACTIONS(2163),
    [anon_sym_requires] = ACTIONS(2163),
    [sym_this] = ACTIONS(2163),
    [anon_sym_discard] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
    [anon_sym_cbuffer] = ACTIONS(2163),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2167),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [anon_sym_if] = ACTIONS(2167),
    [anon_sym_else] = ACTIONS(2167),
    [anon_sym_switch] = ACTIONS(2167),
    [anon_sym_while] = ACTIONS(2167),
    [anon_sym_do] = ACTIONS(2167),
    [anon_sym_for] = ACTIONS(2167),
    [anon_sym_return] = ACTIONS(2167),
    [anon_sym_break] = ACTIONS(2167),
    [anon_sym_continue] = ACTIONS(2167),
    [anon_sym_goto] = ACTIONS(2167),
    [anon_sym___try] = ACTIONS(2167),
    [anon_sym___leave] = ACTIONS(2167),
    [anon_sym_not] = ACTIONS(2167),
    [anon_sym_compl] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2169),
    [anon_sym_PLUS_PLUS] = ACTIONS(2169),
    [anon_sym_sizeof] = ACTIONS(2167),
    [anon_sym___alignof__] = ACTIONS(2167),
    [anon_sym___alignof] = ACTIONS(2167),
    [anon_sym__alignof] = ACTIONS(2167),
    [anon_sym_alignof] = ACTIONS(2167),
    [anon_sym__Alignof] = ACTIONS(2167),
    [anon_sym_offsetof] = ACTIONS(2167),
    [anon_sym__Generic] = ACTIONS(2167),
    [anon_sym_asm] = ACTIONS(2167),
    [anon_sym___asm__] = ACTIONS(2167),
    [anon_sym___asm] = ACTIONS(2167),
    [sym_number_literal] = ACTIONS(2169),
    [anon_sym_L_SQUOTE] = ACTIONS(2169),
    [anon_sym_u_SQUOTE] = ACTIONS(2169),
    [anon_sym_U_SQUOTE] = ACTIONS(2169),
    [anon_sym_u8_SQUOTE] = ACTIONS(2169),
    [anon_sym_SQUOTE] = ACTIONS(2169),
    [anon_sym_L_DQUOTE] = ACTIONS(2169),
    [anon_sym_u_DQUOTE] = ACTIONS(2169),
    [anon_sym_U_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8_DQUOTE] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2169),
    [sym_true] = ACTIONS(2167),
    [sym_false] = ACTIONS(2167),
    [anon_sym_NULL] = ACTIONS(2167),
    [anon_sym_nullptr] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_try] = ACTIONS(2167),
    [anon_sym_delete] = ACTIONS(2167),
    [anon_sym_throw] = ACTIONS(2167),
    [anon_sym_co_return] = ACTIONS(2167),
    [anon_sym_co_yield] = ACTIONS(2167),
    [anon_sym_R_DQUOTE] = ACTIONS(2169),
    [anon_sym_LR_DQUOTE] = ACTIONS(2169),
    [anon_sym_uR_DQUOTE] = ACTIONS(2169),
    [anon_sym_UR_DQUOTE] = ACTIONS(2169),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2169),
    [anon_sym_co_await] = ACTIONS(2167),
    [anon_sym_new] = ACTIONS(2167),
    [anon_sym_requires] = ACTIONS(2167),
    [sym_this] = ACTIONS(2167),
    [anon_sym_discard] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
    [anon_sym_cbuffer] = ACTIONS(2167),
  },
  [1063] = {
    [sym_identifier] = ACTIONS(2171),
    [anon_sym_LPAREN2] = ACTIONS(2173),
    [anon_sym_BANG] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(2173),
    [anon_sym_DASH] = ACTIONS(2171),
    [anon_sym_PLUS] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2173),
    [anon_sym_AMP] = ACTIONS(2173),
    [anon_sym_SEMI] = ACTIONS(2173),
    [anon_sym___extension__] = ACTIONS(2171),
    [anon_sym_typedef] = ACTIONS(2171),
    [anon_sym_in] = ACTIONS(2171),
    [anon_sym_out] = ACTIONS(2171),
    [anon_sym_inout] = ACTIONS(2171),
    [anon_sym_virtual] = ACTIONS(2171),
    [anon_sym_extern] = ACTIONS(2171),
    [anon_sym___attribute__] = ACTIONS(2171),
    [anon_sym___attribute] = ACTIONS(2171),
    [anon_sym_COLON_COLON] = ACTIONS(2173),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2173),
    [anon_sym___declspec] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_signed] = ACTIONS(2171),
    [anon_sym_unsigned] = ACTIONS(2171),
    [anon_sym_long] = ACTIONS(2171),
    [anon_sym_short] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(2171),
    [anon_sym_static] = ACTIONS(2171),
    [anon_sym_register] = ACTIONS(2171),
    [anon_sym_inline] = ACTIONS(2171),
    [anon_sym___inline] = ACTIONS(2171),
    [anon_sym___inline__] = ACTIONS(2171),
    [anon_sym___forceinline] = ACTIONS(2171),
    [anon_sym_thread_local] = ACTIONS(2171),
    [anon_sym___thread] = ACTIONS(2171),
    [anon_sym_const] = ACTIONS(2171),
    [anon_sym_constexpr] = ACTIONS(2171),
    [anon_sym_volatile] = ACTIONS(2171),
    [anon_sym_restrict] = ACTIONS(2171),
    [anon_sym___restrict__] = ACTIONS(2171),
    [anon_sym__Atomic] = ACTIONS(2171),
    [anon_sym__Noreturn] = ACTIONS(2171),
    [anon_sym_noreturn] = ACTIONS(2171),
    [anon_sym__Nonnull] = ACTIONS(2171),
    [anon_sym_mutable] = ACTIONS(2171),
    [anon_sym_constinit] = ACTIONS(2171),
    [anon_sym_consteval] = ACTIONS(2171),
    [anon_sym_alignas] = ACTIONS(2171),
    [anon_sym__Alignas] = ACTIONS(2171),
    [sym_primitive_type] = ACTIONS(2171),
    [anon_sym_enum] = ACTIONS(2171),
    [anon_sym_class] = ACTIONS(2171),
    [anon_sym_struct] = ACTIONS(2171),
    [anon_sym_union] = ACTIONS(2171),
    [anon_sym_if] = ACTIONS(2171),
    [anon_sym_else] = ACTIONS(2171),
    [anon_sym_switch] = ACTIONS(2171),
    [anon_sym_while] = ACTIONS(2171),
    [anon_sym_do] = ACTIONS(2171),
    [anon_sym_for] = ACTIONS(2171),
    [anon_sym_return] = ACTIONS(2171),
    [anon_sym_break] = ACTIONS(2171),
    [anon_sym_continue] = ACTIONS(2171),
    [anon_sym_goto] = ACTIONS(2171),
    [anon_sym___try] = ACTIONS(2171),
    [anon_sym___leave] = ACTIONS(2171),
    [anon_sym_not] = ACTIONS(2171),
    [anon_sym_compl] = ACTIONS(2171),
    [anon_sym_DASH_DASH] = ACTIONS(2173),
    [anon_sym_PLUS_PLUS] = ACTIONS(2173),
    [anon_sym_sizeof] = ACTIONS(2171),
    [anon_sym___alignof__] = ACTIONS(2171),
    [anon_sym___alignof] = ACTIONS(2171),
    [anon_sym__alignof] = ACTIONS(2171),
    [anon_sym_alignof] = ACTIONS(2171),
    [anon_sym__Alignof] = ACTIONS(2171),
    [anon_sym_offsetof] = ACTIONS(2171),
    [anon_sym__Generic] = ACTIONS(2171),
    [anon_sym_asm] = ACTIONS(2171),
    [anon_sym___asm__] = ACTIONS(2171),
    [anon_sym___asm] = ACTIONS(2171),
    [sym_number_literal] = ACTIONS(2173),
    [anon_sym_L_SQUOTE] = ACTIONS(2173),
    [anon_sym_u_SQUOTE] = ACTIONS(2173),
    [anon_sym_U_SQUOTE] = ACTIONS(2173),
    [anon_sym_u8_SQUOTE] = ACTIONS(2173),
    [anon_sym_SQUOTE] = ACTIONS(2173),
    [anon_sym_L_DQUOTE] = ACTIONS(2173),
    [anon_sym_u_DQUOTE] = ACTIONS(2173),
    [anon_sym_U_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8_DQUOTE] = ACTIONS(2173),
    [anon_sym_DQUOTE] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [sym_false] = ACTIONS(2171),
    [anon_sym_NULL] = ACTIONS(2171),
    [anon_sym_nullptr] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2171),
    [anon_sym_decltype] = ACTIONS(2171),
    [anon_sym_typename] = ACTIONS(2171),
    [anon_sym_template] = ACTIONS(2171),
    [anon_sym_try] = ACTIONS(2171),
    [anon_sym_delete] = ACTIONS(2171),
    [anon_sym_throw] = ACTIONS(2171),
    [anon_sym_co_return] = ACTIONS(2171),
    [anon_sym_co_yield] = ACTIONS(2171),
    [anon_sym_R_DQUOTE] = ACTIONS(2173),
    [anon_sym_LR_DQUOTE] = ACTIONS(2173),
    [anon_sym_uR_DQUOTE] = ACTIONS(2173),
    [anon_sym_UR_DQUOTE] = ACTIONS(2173),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2173),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2171),
    [anon_sym_requires] = ACTIONS(2171),
    [sym_this] = ACTIONS(2171),
    [anon_sym_discard] = ACTIONS(2171),
    [anon_sym_precise] = ACTIONS(2171),
    [anon_sym_shared] = ACTIONS(2171),
    [anon_sym_groupshared] = ACTIONS(2171),
    [anon_sym_uniform] = ACTIONS(2171),
    [anon_sym_row_major] = ACTIONS(2171),
    [anon_sym_column_major] = ACTIONS(2171),
    [anon_sym_globallycoherent] = ACTIONS(2171),
    [anon_sym_centroid] = ACTIONS(2171),
    [anon_sym_noperspective] = ACTIONS(2171),
    [anon_sym_nointerpolation] = ACTIONS(2171),
    [anon_sym_sample] = ACTIONS(2171),
    [anon_sym_linear] = ACTIONS(2171),
    [anon_sym_snorm] = ACTIONS(2171),
    [anon_sym_unorm] = ACTIONS(2171),
    [anon_sym_point] = ACTIONS(2171),
    [anon_sym_line] = ACTIONS(2171),
    [anon_sym_triangleadj] = ACTIONS(2171),
    [anon_sym_lineadj] = ACTIONS(2171),
    [anon_sym_triangle] = ACTIONS(2171),
    [anon_sym_cbuffer] = ACTIONS(2171),
  },
  [1064] = {
    [sym_identifier] = ACTIONS(2155),
    [anon_sym_LPAREN2] = ACTIONS(2157),
    [anon_sym_BANG] = ACTIONS(2157),
    [anon_sym_TILDE] = ACTIONS(2157),
    [anon_sym_DASH] = ACTIONS(2155),
    [anon_sym_PLUS] = ACTIONS(2155),
    [anon_sym_STAR] = ACTIONS(2157),
    [anon_sym_AMP] = ACTIONS(2157),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym___extension__] = ACTIONS(2155),
    [anon_sym_typedef] = ACTIONS(2155),
    [anon_sym_in] = ACTIONS(2155),
    [anon_sym_out] = ACTIONS(2155),
    [anon_sym_inout] = ACTIONS(2155),
    [anon_sym_virtual] = ACTIONS(2155),
    [anon_sym_extern] = ACTIONS(2155),
    [anon_sym___attribute__] = ACTIONS(2155),
    [anon_sym___attribute] = ACTIONS(2155),
    [anon_sym_COLON_COLON] = ACTIONS(2157),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2157),
    [anon_sym___declspec] = ACTIONS(2155),
    [anon_sym_LBRACE] = ACTIONS(2157),
    [anon_sym_signed] = ACTIONS(2155),
    [anon_sym_unsigned] = ACTIONS(2155),
    [anon_sym_long] = ACTIONS(2155),
    [anon_sym_short] = ACTIONS(2155),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [anon_sym_static] = ACTIONS(2155),
    [anon_sym_register] = ACTIONS(2155),
    [anon_sym_inline] = ACTIONS(2155),
    [anon_sym___inline] = ACTIONS(2155),
    [anon_sym___inline__] = ACTIONS(2155),
    [anon_sym___forceinline] = ACTIONS(2155),
    [anon_sym_thread_local] = ACTIONS(2155),
    [anon_sym___thread] = ACTIONS(2155),
    [anon_sym_const] = ACTIONS(2155),
    [anon_sym_constexpr] = ACTIONS(2155),
    [anon_sym_volatile] = ACTIONS(2155),
    [anon_sym_restrict] = ACTIONS(2155),
    [anon_sym___restrict__] = ACTIONS(2155),
    [anon_sym__Atomic] = ACTIONS(2155),
    [anon_sym__Noreturn] = ACTIONS(2155),
    [anon_sym_noreturn] = ACTIONS(2155),
    [anon_sym__Nonnull] = ACTIONS(2155),
    [anon_sym_mutable] = ACTIONS(2155),
    [anon_sym_constinit] = ACTIONS(2155),
    [anon_sym_consteval] = ACTIONS(2155),
    [anon_sym_alignas] = ACTIONS(2155),
    [anon_sym__Alignas] = ACTIONS(2155),
    [sym_primitive_type] = ACTIONS(2155),
    [anon_sym_enum] = ACTIONS(2155),
    [anon_sym_class] = ACTIONS(2155),
    [anon_sym_struct] = ACTIONS(2155),
    [anon_sym_union] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2155),
    [anon_sym_while] = ACTIONS(2155),
    [anon_sym_do] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2155),
    [anon_sym_return] = ACTIONS(2155),
    [anon_sym_break] = ACTIONS(2155),
    [anon_sym_continue] = ACTIONS(2155),
    [anon_sym_goto] = ACTIONS(2155),
    [anon_sym___try] = ACTIONS(2155),
    [anon_sym___leave] = ACTIONS(2155),
    [anon_sym_not] = ACTIONS(2155),
    [anon_sym_compl] = ACTIONS(2155),
    [anon_sym_DASH_DASH] = ACTIONS(2157),
    [anon_sym_PLUS_PLUS] = ACTIONS(2157),
    [anon_sym_sizeof] = ACTIONS(2155),
    [anon_sym___alignof__] = ACTIONS(2155),
    [anon_sym___alignof] = ACTIONS(2155),
    [anon_sym__alignof] = ACTIONS(2155),
    [anon_sym_alignof] = ACTIONS(2155),
    [anon_sym__Alignof] = ACTIONS(2155),
    [anon_sym_offsetof] = ACTIONS(2155),
    [anon_sym__Generic] = ACTIONS(2155),
    [anon_sym_asm] = ACTIONS(2155),
    [anon_sym___asm__] = ACTIONS(2155),
    [anon_sym___asm] = ACTIONS(2155),
    [sym_number_literal] = ACTIONS(2157),
    [anon_sym_L_SQUOTE] = ACTIONS(2157),
    [anon_sym_u_SQUOTE] = ACTIONS(2157),
    [anon_sym_U_SQUOTE] = ACTIONS(2157),
    [anon_sym_u8_SQUOTE] = ACTIONS(2157),
    [anon_sym_SQUOTE] = ACTIONS(2157),
    [anon_sym_L_DQUOTE] = ACTIONS(2157),
    [anon_sym_u_DQUOTE] = ACTIONS(2157),
    [anon_sym_U_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8_DQUOTE] = ACTIONS(2157),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym_true] = ACTIONS(2155),
    [sym_false] = ACTIONS(2155),
    [anon_sym_NULL] = ACTIONS(2155),
    [anon_sym_nullptr] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2155),
    [anon_sym_decltype] = ACTIONS(2155),
    [anon_sym_typename] = ACTIONS(2155),
    [anon_sym_template] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2155),
    [anon_sym_delete] = ACTIONS(2155),
    [anon_sym_throw] = ACTIONS(2155),
    [anon_sym_co_return] = ACTIONS(2155),
    [anon_sym_co_yield] = ACTIONS(2155),
    [anon_sym_R_DQUOTE] = ACTIONS(2157),
    [anon_sym_LR_DQUOTE] = ACTIONS(2157),
    [anon_sym_uR_DQUOTE] = ACTIONS(2157),
    [anon_sym_UR_DQUOTE] = ACTIONS(2157),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2157),
    [anon_sym_co_await] = ACTIONS(2155),
    [anon_sym_new] = ACTIONS(2155),
    [anon_sym_requires] = ACTIONS(2155),
    [sym_this] = ACTIONS(2155),
    [anon_sym_discard] = ACTIONS(2155),
    [anon_sym_precise] = ACTIONS(2155),
    [anon_sym_shared] = ACTIONS(2155),
    [anon_sym_groupshared] = ACTIONS(2155),
    [anon_sym_uniform] = ACTIONS(2155),
    [anon_sym_row_major] = ACTIONS(2155),
    [anon_sym_column_major] = ACTIONS(2155),
    [anon_sym_globallycoherent] = ACTIONS(2155),
    [anon_sym_centroid] = ACTIONS(2155),
    [anon_sym_noperspective] = ACTIONS(2155),
    [anon_sym_nointerpolation] = ACTIONS(2155),
    [anon_sym_sample] = ACTIONS(2155),
    [anon_sym_linear] = ACTIONS(2155),
    [anon_sym_snorm] = ACTIONS(2155),
    [anon_sym_unorm] = ACTIONS(2155),
    [anon_sym_point] = ACTIONS(2155),
    [anon_sym_line] = ACTIONS(2155),
    [anon_sym_triangleadj] = ACTIONS(2155),
    [anon_sym_lineadj] = ACTIONS(2155),
    [anon_sym_triangle] = ACTIONS(2155),
    [anon_sym_cbuffer] = ACTIONS(2155),
  },
  [1065] = {
    [sym_identifier] = ACTIONS(2298),
    [anon_sym_LPAREN2] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AMP] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym___extension__] = ACTIONS(2298),
    [anon_sym_typedef] = ACTIONS(2298),
    [anon_sym_in] = ACTIONS(2298),
    [anon_sym_out] = ACTIONS(2298),
    [anon_sym_inout] = ACTIONS(2298),
    [anon_sym_virtual] = ACTIONS(2298),
    [anon_sym_extern] = ACTIONS(2298),
    [anon_sym___attribute__] = ACTIONS(2298),
    [anon_sym___attribute] = ACTIONS(2298),
    [anon_sym_COLON_COLON] = ACTIONS(2300),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2300),
    [anon_sym___declspec] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_signed] = ACTIONS(2298),
    [anon_sym_unsigned] = ACTIONS(2298),
    [anon_sym_long] = ACTIONS(2298),
    [anon_sym_short] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_register] = ACTIONS(2298),
    [anon_sym_inline] = ACTIONS(2298),
    [anon_sym___inline] = ACTIONS(2298),
    [anon_sym___inline__] = ACTIONS(2298),
    [anon_sym___forceinline] = ACTIONS(2298),
    [anon_sym_thread_local] = ACTIONS(2298),
    [anon_sym___thread] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [anon_sym_constexpr] = ACTIONS(2298),
    [anon_sym_volatile] = ACTIONS(2298),
    [anon_sym_restrict] = ACTIONS(2298),
    [anon_sym___restrict__] = ACTIONS(2298),
    [anon_sym__Atomic] = ACTIONS(2298),
    [anon_sym__Noreturn] = ACTIONS(2298),
    [anon_sym_noreturn] = ACTIONS(2298),
    [anon_sym__Nonnull] = ACTIONS(2298),
    [anon_sym_mutable] = ACTIONS(2298),
    [anon_sym_constinit] = ACTIONS(2298),
    [anon_sym_consteval] = ACTIONS(2298),
    [anon_sym_alignas] = ACTIONS(2298),
    [anon_sym__Alignas] = ACTIONS(2298),
    [sym_primitive_type] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_struct] = ACTIONS(2298),
    [anon_sym_union] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(2298),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_goto] = ACTIONS(2298),
    [anon_sym___try] = ACTIONS(2298),
    [anon_sym___leave] = ACTIONS(2298),
    [anon_sym_not] = ACTIONS(2298),
    [anon_sym_compl] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2298),
    [anon_sym___alignof__] = ACTIONS(2298),
    [anon_sym___alignof] = ACTIONS(2298),
    [anon_sym__alignof] = ACTIONS(2298),
    [anon_sym_alignof] = ACTIONS(2298),
    [anon_sym__Alignof] = ACTIONS(2298),
    [anon_sym_offsetof] = ACTIONS(2298),
    [anon_sym__Generic] = ACTIONS(2298),
    [anon_sym_asm] = ACTIONS(2298),
    [anon_sym___asm__] = ACTIONS(2298),
    [anon_sym___asm] = ACTIONS(2298),
    [sym_number_literal] = ACTIONS(2300),
    [anon_sym_L_SQUOTE] = ACTIONS(2300),
    [anon_sym_u_SQUOTE] = ACTIONS(2300),
    [anon_sym_U_SQUOTE] = ACTIONS(2300),
    [anon_sym_u8_SQUOTE] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_L_DQUOTE] = ACTIONS(2300),
    [anon_sym_u_DQUOTE] = ACTIONS(2300),
    [anon_sym_U_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8_DQUOTE] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [sym_true] = ACTIONS(2298),
    [sym_false] = ACTIONS(2298),
    [anon_sym_NULL] = ACTIONS(2298),
    [anon_sym_nullptr] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2298),
    [anon_sym_decltype] = ACTIONS(2298),
    [anon_sym_typename] = ACTIONS(2298),
    [anon_sym_template] = ACTIONS(2298),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_co_return] = ACTIONS(2298),
    [anon_sym_co_yield] = ACTIONS(2298),
    [anon_sym_R_DQUOTE] = ACTIONS(2300),
    [anon_sym_LR_DQUOTE] = ACTIONS(2300),
    [anon_sym_uR_DQUOTE] = ACTIONS(2300),
    [anon_sym_UR_DQUOTE] = ACTIONS(2300),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2300),
    [anon_sym_co_await] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [anon_sym_requires] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_discard] = ACTIONS(2298),
    [anon_sym_precise] = ACTIONS(2298),
    [anon_sym_shared] = ACTIONS(2298),
    [anon_sym_groupshared] = ACTIONS(2298),
    [anon_sym_uniform] = ACTIONS(2298),
    [anon_sym_row_major] = ACTIONS(2298),
    [anon_sym_column_major] = ACTIONS(2298),
    [anon_sym_globallycoherent] = ACTIONS(2298),
    [anon_sym_centroid] = ACTIONS(2298),
    [anon_sym_noperspective] = ACTIONS(2298),
    [anon_sym_nointerpolation] = ACTIONS(2298),
    [anon_sym_sample] = ACTIONS(2298),
    [anon_sym_linear] = ACTIONS(2298),
    [anon_sym_snorm] = ACTIONS(2298),
    [anon_sym_unorm] = ACTIONS(2298),
    [anon_sym_point] = ACTIONS(2298),
    [anon_sym_line] = ACTIONS(2298),
    [anon_sym_triangleadj] = ACTIONS(2298),
    [anon_sym_lineadj] = ACTIONS(2298),
    [anon_sym_triangle] = ACTIONS(2298),
    [anon_sym_cbuffer] = ACTIONS(2298),
  },
  [1066] = {
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN2] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2214),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2216),
    [anon_sym___extension__] = ACTIONS(2214),
    [anon_sym_typedef] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_out] = ACTIONS(2214),
    [anon_sym_inout] = ACTIONS(2214),
    [anon_sym_virtual] = ACTIONS(2214),
    [anon_sym_extern] = ACTIONS(2214),
    [anon_sym___attribute__] = ACTIONS(2214),
    [anon_sym___attribute] = ACTIONS(2214),
    [anon_sym_COLON_COLON] = ACTIONS(2216),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2216),
    [anon_sym___declspec] = ACTIONS(2214),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_signed] = ACTIONS(2214),
    [anon_sym_unsigned] = ACTIONS(2214),
    [anon_sym_long] = ACTIONS(2214),
    [anon_sym_short] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_register] = ACTIONS(2214),
    [anon_sym_inline] = ACTIONS(2214),
    [anon_sym___inline] = ACTIONS(2214),
    [anon_sym___inline__] = ACTIONS(2214),
    [anon_sym___forceinline] = ACTIONS(2214),
    [anon_sym_thread_local] = ACTIONS(2214),
    [anon_sym___thread] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_constexpr] = ACTIONS(2214),
    [anon_sym_volatile] = ACTIONS(2214),
    [anon_sym_restrict] = ACTIONS(2214),
    [anon_sym___restrict__] = ACTIONS(2214),
    [anon_sym__Atomic] = ACTIONS(2214),
    [anon_sym__Noreturn] = ACTIONS(2214),
    [anon_sym_noreturn] = ACTIONS(2214),
    [anon_sym__Nonnull] = ACTIONS(2214),
    [anon_sym_mutable] = ACTIONS(2214),
    [anon_sym_constinit] = ACTIONS(2214),
    [anon_sym_consteval] = ACTIONS(2214),
    [anon_sym_alignas] = ACTIONS(2214),
    [anon_sym__Alignas] = ACTIONS(2214),
    [sym_primitive_type] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_class] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_else] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [anon_sym_do] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_goto] = ACTIONS(2214),
    [anon_sym___try] = ACTIONS(2214),
    [anon_sym___leave] = ACTIONS(2214),
    [anon_sym_not] = ACTIONS(2214),
    [anon_sym_compl] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2214),
    [anon_sym___alignof__] = ACTIONS(2214),
    [anon_sym___alignof] = ACTIONS(2214),
    [anon_sym__alignof] = ACTIONS(2214),
    [anon_sym_alignof] = ACTIONS(2214),
    [anon_sym__Alignof] = ACTIONS(2214),
    [anon_sym_offsetof] = ACTIONS(2214),
    [anon_sym__Generic] = ACTIONS(2214),
    [anon_sym_asm] = ACTIONS(2214),
    [anon_sym___asm__] = ACTIONS(2214),
    [anon_sym___asm] = ACTIONS(2214),
    [sym_number_literal] = ACTIONS(2216),
    [anon_sym_L_SQUOTE] = ACTIONS(2216),
    [anon_sym_u_SQUOTE] = ACTIONS(2216),
    [anon_sym_U_SQUOTE] = ACTIONS(2216),
    [anon_sym_u8_SQUOTE] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2216),
    [anon_sym_L_DQUOTE] = ACTIONS(2216),
    [anon_sym_u_DQUOTE] = ACTIONS(2216),
    [anon_sym_U_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8_DQUOTE] = ACTIONS(2216),
    [anon_sym_DQUOTE] = ACTIONS(2216),
    [sym_true] = ACTIONS(2214),
    [sym_false] = ACTIONS(2214),
    [anon_sym_NULL] = ACTIONS(2214),
    [anon_sym_nullptr] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2214),
    [anon_sym_decltype] = ACTIONS(2214),
    [anon_sym_typename] = ACTIONS(2214),
    [anon_sym_template] = ACTIONS(2214),
    [anon_sym_try] = ACTIONS(2214),
    [anon_sym_delete] = ACTIONS(2214),
    [anon_sym_throw] = ACTIONS(2214),
    [anon_sym_co_return] = ACTIONS(2214),
    [anon_sym_co_yield] = ACTIONS(2214),
    [anon_sym_R_DQUOTE] = ACTIONS(2216),
    [anon_sym_LR_DQUOTE] = ACTIONS(2216),
    [anon_sym_uR_DQUOTE] = ACTIONS(2216),
    [anon_sym_UR_DQUOTE] = ACTIONS(2216),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2216),
    [anon_sym_co_await] = ACTIONS(2214),
    [anon_sym_new] = ACTIONS(2214),
    [anon_sym_requires] = ACTIONS(2214),
    [sym_this] = ACTIONS(2214),
    [anon_sym_discard] = ACTIONS(2214),
    [anon_sym_precise] = ACTIONS(2214),
    [anon_sym_shared] = ACTIONS(2214),
    [anon_sym_groupshared] = ACTIONS(2214),
    [anon_sym_uniform] = ACTIONS(2214),
    [anon_sym_row_major] = ACTIONS(2214),
    [anon_sym_column_major] = ACTIONS(2214),
    [anon_sym_globallycoherent] = ACTIONS(2214),
    [anon_sym_centroid] = ACTIONS(2214),
    [anon_sym_noperspective] = ACTIONS(2214),
    [anon_sym_nointerpolation] = ACTIONS(2214),
    [anon_sym_sample] = ACTIONS(2214),
    [anon_sym_linear] = ACTIONS(2214),
    [anon_sym_snorm] = ACTIONS(2214),
    [anon_sym_unorm] = ACTIONS(2214),
    [anon_sym_point] = ACTIONS(2214),
    [anon_sym_line] = ACTIONS(2214),
    [anon_sym_triangleadj] = ACTIONS(2214),
    [anon_sym_lineadj] = ACTIONS(2214),
    [anon_sym_triangle] = ACTIONS(2214),
    [anon_sym_cbuffer] = ACTIONS(2214),
  },
  [1067] = {
    [sym_identifier] = ACTIONS(2218),
    [anon_sym_LPAREN2] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2220),
    [anon_sym_TILDE] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2218),
    [anon_sym_PLUS] = ACTIONS(2218),
    [anon_sym_STAR] = ACTIONS(2220),
    [anon_sym_AMP] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2220),
    [anon_sym___extension__] = ACTIONS(2218),
    [anon_sym_typedef] = ACTIONS(2218),
    [anon_sym_in] = ACTIONS(2218),
    [anon_sym_out] = ACTIONS(2218),
    [anon_sym_inout] = ACTIONS(2218),
    [anon_sym_virtual] = ACTIONS(2218),
    [anon_sym_extern] = ACTIONS(2218),
    [anon_sym___attribute__] = ACTIONS(2218),
    [anon_sym___attribute] = ACTIONS(2218),
    [anon_sym_COLON_COLON] = ACTIONS(2220),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2220),
    [anon_sym___declspec] = ACTIONS(2218),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_signed] = ACTIONS(2218),
    [anon_sym_unsigned] = ACTIONS(2218),
    [anon_sym_long] = ACTIONS(2218),
    [anon_sym_short] = ACTIONS(2218),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_static] = ACTIONS(2218),
    [anon_sym_register] = ACTIONS(2218),
    [anon_sym_inline] = ACTIONS(2218),
    [anon_sym___inline] = ACTIONS(2218),
    [anon_sym___inline__] = ACTIONS(2218),
    [anon_sym___forceinline] = ACTIONS(2218),
    [anon_sym_thread_local] = ACTIONS(2218),
    [anon_sym___thread] = ACTIONS(2218),
    [anon_sym_const] = ACTIONS(2218),
    [anon_sym_constexpr] = ACTIONS(2218),
    [anon_sym_volatile] = ACTIONS(2218),
    [anon_sym_restrict] = ACTIONS(2218),
    [anon_sym___restrict__] = ACTIONS(2218),
    [anon_sym__Atomic] = ACTIONS(2218),
    [anon_sym__Noreturn] = ACTIONS(2218),
    [anon_sym_noreturn] = ACTIONS(2218),
    [anon_sym__Nonnull] = ACTIONS(2218),
    [anon_sym_mutable] = ACTIONS(2218),
    [anon_sym_constinit] = ACTIONS(2218),
    [anon_sym_consteval] = ACTIONS(2218),
    [anon_sym_alignas] = ACTIONS(2218),
    [anon_sym__Alignas] = ACTIONS(2218),
    [sym_primitive_type] = ACTIONS(2218),
    [anon_sym_enum] = ACTIONS(2218),
    [anon_sym_class] = ACTIONS(2218),
    [anon_sym_struct] = ACTIONS(2218),
    [anon_sym_union] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(2218),
    [anon_sym_else] = ACTIONS(2218),
    [anon_sym_switch] = ACTIONS(2218),
    [anon_sym_while] = ACTIONS(2218),
    [anon_sym_do] = ACTIONS(2218),
    [anon_sym_for] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2218),
    [anon_sym_break] = ACTIONS(2218),
    [anon_sym_continue] = ACTIONS(2218),
    [anon_sym_goto] = ACTIONS(2218),
    [anon_sym___try] = ACTIONS(2218),
    [anon_sym___leave] = ACTIONS(2218),
    [anon_sym_not] = ACTIONS(2218),
    [anon_sym_compl] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2220),
    [anon_sym_PLUS_PLUS] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2218),
    [anon_sym___alignof__] = ACTIONS(2218),
    [anon_sym___alignof] = ACTIONS(2218),
    [anon_sym__alignof] = ACTIONS(2218),
    [anon_sym_alignof] = ACTIONS(2218),
    [anon_sym__Alignof] = ACTIONS(2218),
    [anon_sym_offsetof] = ACTIONS(2218),
    [anon_sym__Generic] = ACTIONS(2218),
    [anon_sym_asm] = ACTIONS(2218),
    [anon_sym___asm__] = ACTIONS(2218),
    [anon_sym___asm] = ACTIONS(2218),
    [sym_number_literal] = ACTIONS(2220),
    [anon_sym_L_SQUOTE] = ACTIONS(2220),
    [anon_sym_u_SQUOTE] = ACTIONS(2220),
    [anon_sym_U_SQUOTE] = ACTIONS(2220),
    [anon_sym_u8_SQUOTE] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_L_DQUOTE] = ACTIONS(2220),
    [anon_sym_u_DQUOTE] = ACTIONS(2220),
    [anon_sym_U_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8_DQUOTE] = ACTIONS(2220),
    [anon_sym_DQUOTE] = ACTIONS(2220),
    [sym_true] = ACTIONS(2218),
    [sym_false] = ACTIONS(2218),
    [anon_sym_NULL] = ACTIONS(2218),
    [anon_sym_nullptr] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2218),
    [anon_sym_decltype] = ACTIONS(2218),
    [anon_sym_typename] = ACTIONS(2218),
    [anon_sym_template] = ACTIONS(2218),
    [anon_sym_try] = ACTIONS(2218),
    [anon_sym_delete] = ACTIONS(2218),
    [anon_sym_throw] = ACTIONS(2218),
    [anon_sym_co_return] = ACTIONS(2218),
    [anon_sym_co_yield] = ACTIONS(2218),
    [anon_sym_R_DQUOTE] = ACTIONS(2220),
    [anon_sym_LR_DQUOTE] = ACTIONS(2220),
    [anon_sym_uR_DQUOTE] = ACTIONS(2220),
    [anon_sym_UR_DQUOTE] = ACTIONS(2220),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2220),
    [anon_sym_co_await] = ACTIONS(2218),
    [anon_sym_new] = ACTIONS(2218),
    [anon_sym_requires] = ACTIONS(2218),
    [sym_this] = ACTIONS(2218),
    [anon_sym_discard] = ACTIONS(2218),
    [anon_sym_precise] = ACTIONS(2218),
    [anon_sym_shared] = ACTIONS(2218),
    [anon_sym_groupshared] = ACTIONS(2218),
    [anon_sym_uniform] = ACTIONS(2218),
    [anon_sym_row_major] = ACTIONS(2218),
    [anon_sym_column_major] = ACTIONS(2218),
    [anon_sym_globallycoherent] = ACTIONS(2218),
    [anon_sym_centroid] = ACTIONS(2218),
    [anon_sym_noperspective] = ACTIONS(2218),
    [anon_sym_nointerpolation] = ACTIONS(2218),
    [anon_sym_sample] = ACTIONS(2218),
    [anon_sym_linear] = ACTIONS(2218),
    [anon_sym_snorm] = ACTIONS(2218),
    [anon_sym_unorm] = ACTIONS(2218),
    [anon_sym_point] = ACTIONS(2218),
    [anon_sym_line] = ACTIONS(2218),
    [anon_sym_triangleadj] = ACTIONS(2218),
    [anon_sym_lineadj] = ACTIONS(2218),
    [anon_sym_triangle] = ACTIONS(2218),
    [anon_sym_cbuffer] = ACTIONS(2218),
  },
  [1068] = {
    [sym_identifier] = ACTIONS(2222),
    [anon_sym_LPAREN2] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2224),
    [anon_sym_TILDE] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2222),
    [anon_sym_PLUS] = ACTIONS(2222),
    [anon_sym_STAR] = ACTIONS(2224),
    [anon_sym_AMP] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2224),
    [anon_sym___extension__] = ACTIONS(2222),
    [anon_sym_typedef] = ACTIONS(2222),
    [anon_sym_in] = ACTIONS(2222),
    [anon_sym_out] = ACTIONS(2222),
    [anon_sym_inout] = ACTIONS(2222),
    [anon_sym_virtual] = ACTIONS(2222),
    [anon_sym_extern] = ACTIONS(2222),
    [anon_sym___attribute__] = ACTIONS(2222),
    [anon_sym___attribute] = ACTIONS(2222),
    [anon_sym_COLON_COLON] = ACTIONS(2224),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2224),
    [anon_sym___declspec] = ACTIONS(2222),
    [anon_sym_LBRACE] = ACTIONS(2224),
    [anon_sym_signed] = ACTIONS(2222),
    [anon_sym_unsigned] = ACTIONS(2222),
    [anon_sym_long] = ACTIONS(2222),
    [anon_sym_short] = ACTIONS(2222),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_static] = ACTIONS(2222),
    [anon_sym_register] = ACTIONS(2222),
    [anon_sym_inline] = ACTIONS(2222),
    [anon_sym___inline] = ACTIONS(2222),
    [anon_sym___inline__] = ACTIONS(2222),
    [anon_sym___forceinline] = ACTIONS(2222),
    [anon_sym_thread_local] = ACTIONS(2222),
    [anon_sym___thread] = ACTIONS(2222),
    [anon_sym_const] = ACTIONS(2222),
    [anon_sym_constexpr] = ACTIONS(2222),
    [anon_sym_volatile] = ACTIONS(2222),
    [anon_sym_restrict] = ACTIONS(2222),
    [anon_sym___restrict__] = ACTIONS(2222),
    [anon_sym__Atomic] = ACTIONS(2222),
    [anon_sym__Noreturn] = ACTIONS(2222),
    [anon_sym_noreturn] = ACTIONS(2222),
    [anon_sym__Nonnull] = ACTIONS(2222),
    [anon_sym_mutable] = ACTIONS(2222),
    [anon_sym_constinit] = ACTIONS(2222),
    [anon_sym_consteval] = ACTIONS(2222),
    [anon_sym_alignas] = ACTIONS(2222),
    [anon_sym__Alignas] = ACTIONS(2222),
    [sym_primitive_type] = ACTIONS(2222),
    [anon_sym_enum] = ACTIONS(2222),
    [anon_sym_class] = ACTIONS(2222),
    [anon_sym_struct] = ACTIONS(2222),
    [anon_sym_union] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(2222),
    [anon_sym_else] = ACTIONS(2222),
    [anon_sym_switch] = ACTIONS(2222),
    [anon_sym_while] = ACTIONS(2222),
    [anon_sym_do] = ACTIONS(2222),
    [anon_sym_for] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2222),
    [anon_sym_break] = ACTIONS(2222),
    [anon_sym_continue] = ACTIONS(2222),
    [anon_sym_goto] = ACTIONS(2222),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2222),
    [anon_sym_not] = ACTIONS(2222),
    [anon_sym_compl] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2224),
    [anon_sym_PLUS_PLUS] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2222),
    [anon_sym___alignof__] = ACTIONS(2222),
    [anon_sym___alignof] = ACTIONS(2222),
    [anon_sym__alignof] = ACTIONS(2222),
    [anon_sym_alignof] = ACTIONS(2222),
    [anon_sym__Alignof] = ACTIONS(2222),
    [anon_sym_offsetof] = ACTIONS(2222),
    [anon_sym__Generic] = ACTIONS(2222),
    [anon_sym_asm] = ACTIONS(2222),
    [anon_sym___asm__] = ACTIONS(2222),
    [anon_sym___asm] = ACTIONS(2222),
    [sym_number_literal] = ACTIONS(2224),
    [anon_sym_L_SQUOTE] = ACTIONS(2224),
    [anon_sym_u_SQUOTE] = ACTIONS(2224),
    [anon_sym_U_SQUOTE] = ACTIONS(2224),
    [anon_sym_u8_SQUOTE] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_L_DQUOTE] = ACTIONS(2224),
    [anon_sym_u_DQUOTE] = ACTIONS(2224),
    [anon_sym_U_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8_DQUOTE] = ACTIONS(2224),
    [anon_sym_DQUOTE] = ACTIONS(2224),
    [sym_true] = ACTIONS(2222),
    [sym_false] = ACTIONS(2222),
    [anon_sym_NULL] = ACTIONS(2222),
    [anon_sym_nullptr] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2222),
    [anon_sym_decltype] = ACTIONS(2222),
    [anon_sym_typename] = ACTIONS(2222),
    [anon_sym_template] = ACTIONS(2222),
    [anon_sym_try] = ACTIONS(2222),
    [anon_sym_delete] = ACTIONS(2222),
    [anon_sym_throw] = ACTIONS(2222),
    [anon_sym_co_return] = ACTIONS(2222),
    [anon_sym_co_yield] = ACTIONS(2222),
    [anon_sym_R_DQUOTE] = ACTIONS(2224),
    [anon_sym_LR_DQUOTE] = ACTIONS(2224),
    [anon_sym_uR_DQUOTE] = ACTIONS(2224),
    [anon_sym_UR_DQUOTE] = ACTIONS(2224),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2224),
    [anon_sym_co_await] = ACTIONS(2222),
    [anon_sym_new] = ACTIONS(2222),
    [anon_sym_requires] = ACTIONS(2222),
    [sym_this] = ACTIONS(2222),
    [anon_sym_discard] = ACTIONS(2222),
    [anon_sym_precise] = ACTIONS(2222),
    [anon_sym_shared] = ACTIONS(2222),
    [anon_sym_groupshared] = ACTIONS(2222),
    [anon_sym_uniform] = ACTIONS(2222),
    [anon_sym_row_major] = ACTIONS(2222),
    [anon_sym_column_major] = ACTIONS(2222),
    [anon_sym_globallycoherent] = ACTIONS(2222),
    [anon_sym_centroid] = ACTIONS(2222),
    [anon_sym_noperspective] = ACTIONS(2222),
    [anon_sym_nointerpolation] = ACTIONS(2222),
    [anon_sym_sample] = ACTIONS(2222),
    [anon_sym_linear] = ACTIONS(2222),
    [anon_sym_snorm] = ACTIONS(2222),
    [anon_sym_unorm] = ACTIONS(2222),
    [anon_sym_point] = ACTIONS(2222),
    [anon_sym_line] = ACTIONS(2222),
    [anon_sym_triangleadj] = ACTIONS(2222),
    [anon_sym_lineadj] = ACTIONS(2222),
    [anon_sym_triangle] = ACTIONS(2222),
    [anon_sym_cbuffer] = ACTIONS(2222),
  },
  [1069] = {
    [sym_identifier] = ACTIONS(2226),
    [anon_sym_LPAREN2] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2228),
    [anon_sym_TILDE] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2226),
    [anon_sym_PLUS] = ACTIONS(2226),
    [anon_sym_STAR] = ACTIONS(2228),
    [anon_sym_AMP] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2228),
    [anon_sym___extension__] = ACTIONS(2226),
    [anon_sym_typedef] = ACTIONS(2226),
    [anon_sym_in] = ACTIONS(2226),
    [anon_sym_out] = ACTIONS(2226),
    [anon_sym_inout] = ACTIONS(2226),
    [anon_sym_virtual] = ACTIONS(2226),
    [anon_sym_extern] = ACTIONS(2226),
    [anon_sym___attribute__] = ACTIONS(2226),
    [anon_sym___attribute] = ACTIONS(2226),
    [anon_sym_COLON_COLON] = ACTIONS(2228),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2228),
    [anon_sym___declspec] = ACTIONS(2226),
    [anon_sym_LBRACE] = ACTIONS(2228),
    [anon_sym_signed] = ACTIONS(2226),
    [anon_sym_unsigned] = ACTIONS(2226),
    [anon_sym_long] = ACTIONS(2226),
    [anon_sym_short] = ACTIONS(2226),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_static] = ACTIONS(2226),
    [anon_sym_register] = ACTIONS(2226),
    [anon_sym_inline] = ACTIONS(2226),
    [anon_sym___inline] = ACTIONS(2226),
    [anon_sym___inline__] = ACTIONS(2226),
    [anon_sym___forceinline] = ACTIONS(2226),
    [anon_sym_thread_local] = ACTIONS(2226),
    [anon_sym___thread] = ACTIONS(2226),
    [anon_sym_const] = ACTIONS(2226),
    [anon_sym_constexpr] = ACTIONS(2226),
    [anon_sym_volatile] = ACTIONS(2226),
    [anon_sym_restrict] = ACTIONS(2226),
    [anon_sym___restrict__] = ACTIONS(2226),
    [anon_sym__Atomic] = ACTIONS(2226),
    [anon_sym__Noreturn] = ACTIONS(2226),
    [anon_sym_noreturn] = ACTIONS(2226),
    [anon_sym__Nonnull] = ACTIONS(2226),
    [anon_sym_mutable] = ACTIONS(2226),
    [anon_sym_constinit] = ACTIONS(2226),
    [anon_sym_consteval] = ACTIONS(2226),
    [anon_sym_alignas] = ACTIONS(2226),
    [anon_sym__Alignas] = ACTIONS(2226),
    [sym_primitive_type] = ACTIONS(2226),
    [anon_sym_enum] = ACTIONS(2226),
    [anon_sym_class] = ACTIONS(2226),
    [anon_sym_struct] = ACTIONS(2226),
    [anon_sym_union] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(2226),
    [anon_sym_else] = ACTIONS(2226),
    [anon_sym_switch] = ACTIONS(2226),
    [anon_sym_while] = ACTIONS(2226),
    [anon_sym_do] = ACTIONS(2226),
    [anon_sym_for] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2226),
    [anon_sym_break] = ACTIONS(2226),
    [anon_sym_continue] = ACTIONS(2226),
    [anon_sym_goto] = ACTIONS(2226),
    [anon_sym___try] = ACTIONS(2226),
    [anon_sym___leave] = ACTIONS(2226),
    [anon_sym_not] = ACTIONS(2226),
    [anon_sym_compl] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2228),
    [anon_sym_PLUS_PLUS] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2226),
    [anon_sym___alignof__] = ACTIONS(2226),
    [anon_sym___alignof] = ACTIONS(2226),
    [anon_sym__alignof] = ACTIONS(2226),
    [anon_sym_alignof] = ACTIONS(2226),
    [anon_sym__Alignof] = ACTIONS(2226),
    [anon_sym_offsetof] = ACTIONS(2226),
    [anon_sym__Generic] = ACTIONS(2226),
    [anon_sym_asm] = ACTIONS(2226),
    [anon_sym___asm__] = ACTIONS(2226),
    [anon_sym___asm] = ACTIONS(2226),
    [sym_number_literal] = ACTIONS(2228),
    [anon_sym_L_SQUOTE] = ACTIONS(2228),
    [anon_sym_u_SQUOTE] = ACTIONS(2228),
    [anon_sym_U_SQUOTE] = ACTIONS(2228),
    [anon_sym_u8_SQUOTE] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2228),
    [anon_sym_L_DQUOTE] = ACTIONS(2228),
    [anon_sym_u_DQUOTE] = ACTIONS(2228),
    [anon_sym_U_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8_DQUOTE] = ACTIONS(2228),
    [anon_sym_DQUOTE] = ACTIONS(2228),
    [sym_true] = ACTIONS(2226),
    [sym_false] = ACTIONS(2226),
    [anon_sym_NULL] = ACTIONS(2226),
    [anon_sym_nullptr] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2226),
    [anon_sym_decltype] = ACTIONS(2226),
    [anon_sym_typename] = ACTIONS(2226),
    [anon_sym_template] = ACTIONS(2226),
    [anon_sym_try] = ACTIONS(2226),
    [anon_sym_delete] = ACTIONS(2226),
    [anon_sym_throw] = ACTIONS(2226),
    [anon_sym_co_return] = ACTIONS(2226),
    [anon_sym_co_yield] = ACTIONS(2226),
    [anon_sym_R_DQUOTE] = ACTIONS(2228),
    [anon_sym_LR_DQUOTE] = ACTIONS(2228),
    [anon_sym_uR_DQUOTE] = ACTIONS(2228),
    [anon_sym_UR_DQUOTE] = ACTIONS(2228),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2228),
    [anon_sym_co_await] = ACTIONS(2226),
    [anon_sym_new] = ACTIONS(2226),
    [anon_sym_requires] = ACTIONS(2226),
    [sym_this] = ACTIONS(2226),
    [anon_sym_discard] = ACTIONS(2226),
    [anon_sym_precise] = ACTIONS(2226),
    [anon_sym_shared] = ACTIONS(2226),
    [anon_sym_groupshared] = ACTIONS(2226),
    [anon_sym_uniform] = ACTIONS(2226),
    [anon_sym_row_major] = ACTIONS(2226),
    [anon_sym_column_major] = ACTIONS(2226),
    [anon_sym_globallycoherent] = ACTIONS(2226),
    [anon_sym_centroid] = ACTIONS(2226),
    [anon_sym_noperspective] = ACTIONS(2226),
    [anon_sym_nointerpolation] = ACTIONS(2226),
    [anon_sym_sample] = ACTIONS(2226),
    [anon_sym_linear] = ACTIONS(2226),
    [anon_sym_snorm] = ACTIONS(2226),
    [anon_sym_unorm] = ACTIONS(2226),
    [anon_sym_point] = ACTIONS(2226),
    [anon_sym_line] = ACTIONS(2226),
    [anon_sym_triangleadj] = ACTIONS(2226),
    [anon_sym_lineadj] = ACTIONS(2226),
    [anon_sym_triangle] = ACTIONS(2226),
    [anon_sym_cbuffer] = ACTIONS(2226),
  },
  [1070] = {
    [sym_identifier] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [1071] = {
    [sym_identifier] = ACTIONS(2230),
    [anon_sym_LPAREN2] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2230),
    [anon_sym_PLUS] = ACTIONS(2230),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym___extension__] = ACTIONS(2230),
    [anon_sym_typedef] = ACTIONS(2230),
    [anon_sym_in] = ACTIONS(2230),
    [anon_sym_out] = ACTIONS(2230),
    [anon_sym_inout] = ACTIONS(2230),
    [anon_sym_virtual] = ACTIONS(2230),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym___attribute__] = ACTIONS(2230),
    [anon_sym___attribute] = ACTIONS(2230),
    [anon_sym_COLON_COLON] = ACTIONS(2232),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2232),
    [anon_sym___declspec] = ACTIONS(2230),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_signed] = ACTIONS(2230),
    [anon_sym_unsigned] = ACTIONS(2230),
    [anon_sym_long] = ACTIONS(2230),
    [anon_sym_short] = ACTIONS(2230),
    [anon_sym_LBRACK] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_register] = ACTIONS(2230),
    [anon_sym_inline] = ACTIONS(2230),
    [anon_sym___inline] = ACTIONS(2230),
    [anon_sym___inline__] = ACTIONS(2230),
    [anon_sym___forceinline] = ACTIONS(2230),
    [anon_sym_thread_local] = ACTIONS(2230),
    [anon_sym___thread] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_constexpr] = ACTIONS(2230),
    [anon_sym_volatile] = ACTIONS(2230),
    [anon_sym_restrict] = ACTIONS(2230),
    [anon_sym___restrict__] = ACTIONS(2230),
    [anon_sym__Atomic] = ACTIONS(2230),
    [anon_sym__Noreturn] = ACTIONS(2230),
    [anon_sym_noreturn] = ACTIONS(2230),
    [anon_sym__Nonnull] = ACTIONS(2230),
    [anon_sym_mutable] = ACTIONS(2230),
    [anon_sym_constinit] = ACTIONS(2230),
    [anon_sym_consteval] = ACTIONS(2230),
    [anon_sym_alignas] = ACTIONS(2230),
    [anon_sym__Alignas] = ACTIONS(2230),
    [sym_primitive_type] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_class] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_else] = ACTIONS(2230),
    [anon_sym_switch] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [anon_sym_do] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_goto] = ACTIONS(2230),
    [anon_sym___try] = ACTIONS(2230),
    [anon_sym___leave] = ACTIONS(2230),
    [anon_sym_not] = ACTIONS(2230),
    [anon_sym_compl] = ACTIONS(2230),
    [anon_sym_DASH_DASH] = ACTIONS(2232),
    [anon_sym_PLUS_PLUS] = ACTIONS(2232),
    [anon_sym_sizeof] = ACTIONS(2230),
    [anon_sym___alignof__] = ACTIONS(2230),
    [anon_sym___alignof] = ACTIONS(2230),
    [anon_sym__alignof] = ACTIONS(2230),
    [anon_sym_alignof] = ACTIONS(2230),
    [anon_sym__Alignof] = ACTIONS(2230),
    [anon_sym_offsetof] = ACTIONS(2230),
    [anon_sym__Generic] = ACTIONS(2230),
    [anon_sym_asm] = ACTIONS(2230),
    [anon_sym___asm__] = ACTIONS(2230),
    [anon_sym___asm] = ACTIONS(2230),
    [sym_number_literal] = ACTIONS(2232),
    [anon_sym_L_SQUOTE] = ACTIONS(2232),
    [anon_sym_u_SQUOTE] = ACTIONS(2232),
    [anon_sym_U_SQUOTE] = ACTIONS(2232),
    [anon_sym_u8_SQUOTE] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_L_DQUOTE] = ACTIONS(2232),
    [anon_sym_u_DQUOTE] = ACTIONS(2232),
    [anon_sym_U_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8_DQUOTE] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [sym_true] = ACTIONS(2230),
    [sym_false] = ACTIONS(2230),
    [anon_sym_NULL] = ACTIONS(2230),
    [anon_sym_nullptr] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2230),
    [anon_sym_decltype] = ACTIONS(2230),
    [anon_sym_typename] = ACTIONS(2230),
    [anon_sym_template] = ACTIONS(2230),
    [anon_sym_try] = ACTIONS(2230),
    [anon_sym_delete] = ACTIONS(2230),
    [anon_sym_throw] = ACTIONS(2230),
    [anon_sym_co_return] = ACTIONS(2230),
    [anon_sym_co_yield] = ACTIONS(2230),
    [anon_sym_R_DQUOTE] = ACTIONS(2232),
    [anon_sym_LR_DQUOTE] = ACTIONS(2232),
    [anon_sym_uR_DQUOTE] = ACTIONS(2232),
    [anon_sym_UR_DQUOTE] = ACTIONS(2232),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2232),
    [anon_sym_co_await] = ACTIONS(2230),
    [anon_sym_new] = ACTIONS(2230),
    [anon_sym_requires] = ACTIONS(2230),
    [sym_this] = ACTIONS(2230),
    [anon_sym_discard] = ACTIONS(2230),
    [anon_sym_precise] = ACTIONS(2230),
    [anon_sym_shared] = ACTIONS(2230),
    [anon_sym_groupshared] = ACTIONS(2230),
    [anon_sym_uniform] = ACTIONS(2230),
    [anon_sym_row_major] = ACTIONS(2230),
    [anon_sym_column_major] = ACTIONS(2230),
    [anon_sym_globallycoherent] = ACTIONS(2230),
    [anon_sym_centroid] = ACTIONS(2230),
    [anon_sym_noperspective] = ACTIONS(2230),
    [anon_sym_nointerpolation] = ACTIONS(2230),
    [anon_sym_sample] = ACTIONS(2230),
    [anon_sym_linear] = ACTIONS(2230),
    [anon_sym_snorm] = ACTIONS(2230),
    [anon_sym_unorm] = ACTIONS(2230),
    [anon_sym_point] = ACTIONS(2230),
    [anon_sym_line] = ACTIONS(2230),
    [anon_sym_triangleadj] = ACTIONS(2230),
    [anon_sym_lineadj] = ACTIONS(2230),
    [anon_sym_triangle] = ACTIONS(2230),
    [anon_sym_cbuffer] = ACTIONS(2230),
  },
  [1072] = {
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_LPAREN2] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2236),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2236),
    [anon_sym_AMP] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2236),
    [anon_sym___extension__] = ACTIONS(2234),
    [anon_sym_typedef] = ACTIONS(2234),
    [anon_sym_in] = ACTIONS(2234),
    [anon_sym_out] = ACTIONS(2234),
    [anon_sym_inout] = ACTIONS(2234),
    [anon_sym_virtual] = ACTIONS(2234),
    [anon_sym_extern] = ACTIONS(2234),
    [anon_sym___attribute__] = ACTIONS(2234),
    [anon_sym___attribute] = ACTIONS(2234),
    [anon_sym_COLON_COLON] = ACTIONS(2236),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2236),
    [anon_sym___declspec] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2236),
    [anon_sym_signed] = ACTIONS(2234),
    [anon_sym_unsigned] = ACTIONS(2234),
    [anon_sym_long] = ACTIONS(2234),
    [anon_sym_short] = ACTIONS(2234),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_register] = ACTIONS(2234),
    [anon_sym_inline] = ACTIONS(2234),
    [anon_sym___inline] = ACTIONS(2234),
    [anon_sym___inline__] = ACTIONS(2234),
    [anon_sym___forceinline] = ACTIONS(2234),
    [anon_sym_thread_local] = ACTIONS(2234),
    [anon_sym___thread] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_constexpr] = ACTIONS(2234),
    [anon_sym_volatile] = ACTIONS(2234),
    [anon_sym_restrict] = ACTIONS(2234),
    [anon_sym___restrict__] = ACTIONS(2234),
    [anon_sym__Atomic] = ACTIONS(2234),
    [anon_sym__Noreturn] = ACTIONS(2234),
    [anon_sym_noreturn] = ACTIONS(2234),
    [anon_sym__Nonnull] = ACTIONS(2234),
    [anon_sym_mutable] = ACTIONS(2234),
    [anon_sym_constinit] = ACTIONS(2234),
    [anon_sym_consteval] = ACTIONS(2234),
    [anon_sym_alignas] = ACTIONS(2234),
    [anon_sym__Alignas] = ACTIONS(2234),
    [sym_primitive_type] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_class] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_else] = ACTIONS(2234),
    [anon_sym_switch] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [anon_sym_do] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_goto] = ACTIONS(2234),
    [anon_sym___try] = ACTIONS(2234),
    [anon_sym___leave] = ACTIONS(2234),
    [anon_sym_not] = ACTIONS(2234),
    [anon_sym_compl] = ACTIONS(2234),
    [anon_sym_DASH_DASH] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2236),
    [anon_sym_sizeof] = ACTIONS(2234),
    [anon_sym___alignof__] = ACTIONS(2234),
    [anon_sym___alignof] = ACTIONS(2234),
    [anon_sym__alignof] = ACTIONS(2234),
    [anon_sym_alignof] = ACTIONS(2234),
    [anon_sym__Alignof] = ACTIONS(2234),
    [anon_sym_offsetof] = ACTIONS(2234),
    [anon_sym__Generic] = ACTIONS(2234),
    [anon_sym_asm] = ACTIONS(2234),
    [anon_sym___asm__] = ACTIONS(2234),
    [anon_sym___asm] = ACTIONS(2234),
    [sym_number_literal] = ACTIONS(2236),
    [anon_sym_L_SQUOTE] = ACTIONS(2236),
    [anon_sym_u_SQUOTE] = ACTIONS(2236),
    [anon_sym_U_SQUOTE] = ACTIONS(2236),
    [anon_sym_u8_SQUOTE] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2236),
    [anon_sym_L_DQUOTE] = ACTIONS(2236),
    [anon_sym_u_DQUOTE] = ACTIONS(2236),
    [anon_sym_U_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8_DQUOTE] = ACTIONS(2236),
    [anon_sym_DQUOTE] = ACTIONS(2236),
    [sym_true] = ACTIONS(2234),
    [sym_false] = ACTIONS(2234),
    [anon_sym_NULL] = ACTIONS(2234),
    [anon_sym_nullptr] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2234),
    [anon_sym_decltype] = ACTIONS(2234),
    [anon_sym_typename] = ACTIONS(2234),
    [anon_sym_template] = ACTIONS(2234),
    [anon_sym_try] = ACTIONS(2234),
    [anon_sym_delete] = ACTIONS(2234),
    [anon_sym_throw] = ACTIONS(2234),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2234),
    [anon_sym_R_DQUOTE] = ACTIONS(2236),
    [anon_sym_LR_DQUOTE] = ACTIONS(2236),
    [anon_sym_uR_DQUOTE] = ACTIONS(2236),
    [anon_sym_UR_DQUOTE] = ACTIONS(2236),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2236),
    [anon_sym_co_await] = ACTIONS(2234),
    [anon_sym_new] = ACTIONS(2234),
    [anon_sym_requires] = ACTIONS(2234),
    [sym_this] = ACTIONS(2234),
    [anon_sym_discard] = ACTIONS(2234),
    [anon_sym_precise] = ACTIONS(2234),
    [anon_sym_shared] = ACTIONS(2234),
    [anon_sym_groupshared] = ACTIONS(2234),
    [anon_sym_uniform] = ACTIONS(2234),
    [anon_sym_row_major] = ACTIONS(2234),
    [anon_sym_column_major] = ACTIONS(2234),
    [anon_sym_globallycoherent] = ACTIONS(2234),
    [anon_sym_centroid] = ACTIONS(2234),
    [anon_sym_noperspective] = ACTIONS(2234),
    [anon_sym_nointerpolation] = ACTIONS(2234),
    [anon_sym_sample] = ACTIONS(2234),
    [anon_sym_linear] = ACTIONS(2234),
    [anon_sym_snorm] = ACTIONS(2234),
    [anon_sym_unorm] = ACTIONS(2234),
    [anon_sym_point] = ACTIONS(2234),
    [anon_sym_line] = ACTIONS(2234),
    [anon_sym_triangleadj] = ACTIONS(2234),
    [anon_sym_lineadj] = ACTIONS(2234),
    [anon_sym_triangle] = ACTIONS(2234),
    [anon_sym_cbuffer] = ACTIONS(2234),
  },
  [1073] = {
    [sym_identifier] = ACTIONS(2238),
    [anon_sym_LPAREN2] = ACTIONS(2240),
    [anon_sym_BANG] = ACTIONS(2240),
    [anon_sym_TILDE] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_PLUS] = ACTIONS(2238),
    [anon_sym_STAR] = ACTIONS(2240),
    [anon_sym_AMP] = ACTIONS(2240),
    [anon_sym_SEMI] = ACTIONS(2240),
    [anon_sym___extension__] = ACTIONS(2238),
    [anon_sym_typedef] = ACTIONS(2238),
    [anon_sym_in] = ACTIONS(2238),
    [anon_sym_out] = ACTIONS(2238),
    [anon_sym_inout] = ACTIONS(2238),
    [anon_sym_virtual] = ACTIONS(2238),
    [anon_sym_extern] = ACTIONS(2238),
    [anon_sym___attribute__] = ACTIONS(2238),
    [anon_sym___attribute] = ACTIONS(2238),
    [anon_sym_COLON_COLON] = ACTIONS(2240),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2240),
    [anon_sym___declspec] = ACTIONS(2238),
    [anon_sym_LBRACE] = ACTIONS(2240),
    [anon_sym_signed] = ACTIONS(2238),
    [anon_sym_unsigned] = ACTIONS(2238),
    [anon_sym_long] = ACTIONS(2238),
    [anon_sym_short] = ACTIONS(2238),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_register] = ACTIONS(2238),
    [anon_sym_inline] = ACTIONS(2238),
    [anon_sym___inline] = ACTIONS(2238),
    [anon_sym___inline__] = ACTIONS(2238),
    [anon_sym___forceinline] = ACTIONS(2238),
    [anon_sym_thread_local] = ACTIONS(2238),
    [anon_sym___thread] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_constexpr] = ACTIONS(2238),
    [anon_sym_volatile] = ACTIONS(2238),
    [anon_sym_restrict] = ACTIONS(2238),
    [anon_sym___restrict__] = ACTIONS(2238),
    [anon_sym__Atomic] = ACTIONS(2238),
    [anon_sym__Noreturn] = ACTIONS(2238),
    [anon_sym_noreturn] = ACTIONS(2238),
    [anon_sym__Nonnull] = ACTIONS(2238),
    [anon_sym_mutable] = ACTIONS(2238),
    [anon_sym_constinit] = ACTIONS(2238),
    [anon_sym_consteval] = ACTIONS(2238),
    [anon_sym_alignas] = ACTIONS(2238),
    [anon_sym__Alignas] = ACTIONS(2238),
    [sym_primitive_type] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [anon_sym_do] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_goto] = ACTIONS(2238),
    [anon_sym___try] = ACTIONS(2238),
    [anon_sym___leave] = ACTIONS(2238),
    [anon_sym_not] = ACTIONS(2238),
    [anon_sym_compl] = ACTIONS(2238),
    [anon_sym_DASH_DASH] = ACTIONS(2240),
    [anon_sym_PLUS_PLUS] = ACTIONS(2240),
    [anon_sym_sizeof] = ACTIONS(2238),
    [anon_sym___alignof__] = ACTIONS(2238),
    [anon_sym___alignof] = ACTIONS(2238),
    [anon_sym__alignof] = ACTIONS(2238),
    [anon_sym_alignof] = ACTIONS(2238),
    [anon_sym__Alignof] = ACTIONS(2238),
    [anon_sym_offsetof] = ACTIONS(2238),
    [anon_sym__Generic] = ACTIONS(2238),
    [anon_sym_asm] = ACTIONS(2238),
    [anon_sym___asm__] = ACTIONS(2238),
    [anon_sym___asm] = ACTIONS(2238),
    [sym_number_literal] = ACTIONS(2240),
    [anon_sym_L_SQUOTE] = ACTIONS(2240),
    [anon_sym_u_SQUOTE] = ACTIONS(2240),
    [anon_sym_U_SQUOTE] = ACTIONS(2240),
    [anon_sym_u8_SQUOTE] = ACTIONS(2240),
    [anon_sym_SQUOTE] = ACTIONS(2240),
    [anon_sym_L_DQUOTE] = ACTIONS(2240),
    [anon_sym_u_DQUOTE] = ACTIONS(2240),
    [anon_sym_U_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8_DQUOTE] = ACTIONS(2240),
    [anon_sym_DQUOTE] = ACTIONS(2240),
    [sym_true] = ACTIONS(2238),
    [sym_false] = ACTIONS(2238),
    [anon_sym_NULL] = ACTIONS(2238),
    [anon_sym_nullptr] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2238),
    [anon_sym_decltype] = ACTIONS(2238),
    [anon_sym_typename] = ACTIONS(2238),
    [anon_sym_template] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2238),
    [anon_sym_delete] = ACTIONS(2238),
    [anon_sym_throw] = ACTIONS(2238),
    [anon_sym_co_return] = ACTIONS(2238),
    [anon_sym_co_yield] = ACTIONS(2238),
    [anon_sym_R_DQUOTE] = ACTIONS(2240),
    [anon_sym_LR_DQUOTE] = ACTIONS(2240),
    [anon_sym_uR_DQUOTE] = ACTIONS(2240),
    [anon_sym_UR_DQUOTE] = ACTIONS(2240),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2240),
    [anon_sym_co_await] = ACTIONS(2238),
    [anon_sym_new] = ACTIONS(2238),
    [anon_sym_requires] = ACTIONS(2238),
    [sym_this] = ACTIONS(2238),
    [anon_sym_discard] = ACTIONS(2238),
    [anon_sym_precise] = ACTIONS(2238),
    [anon_sym_shared] = ACTIONS(2238),
    [anon_sym_groupshared] = ACTIONS(2238),
    [anon_sym_uniform] = ACTIONS(2238),
    [anon_sym_row_major] = ACTIONS(2238),
    [anon_sym_column_major] = ACTIONS(2238),
    [anon_sym_globallycoherent] = ACTIONS(2238),
    [anon_sym_centroid] = ACTIONS(2238),
    [anon_sym_noperspective] = ACTIONS(2238),
    [anon_sym_nointerpolation] = ACTIONS(2238),
    [anon_sym_sample] = ACTIONS(2238),
    [anon_sym_linear] = ACTIONS(2238),
    [anon_sym_snorm] = ACTIONS(2238),
    [anon_sym_unorm] = ACTIONS(2238),
    [anon_sym_point] = ACTIONS(2238),
    [anon_sym_line] = ACTIONS(2238),
    [anon_sym_triangleadj] = ACTIONS(2238),
    [anon_sym_lineadj] = ACTIONS(2238),
    [anon_sym_triangle] = ACTIONS(2238),
    [anon_sym_cbuffer] = ACTIONS(2238),
  },
  [1074] = {
    [sym_identifier] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_DASH] = ACTIONS(2159),
    [anon_sym_PLUS] = ACTIONS(2159),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2161),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym_LBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [anon_sym_if] = ACTIONS(2159),
    [anon_sym_else] = ACTIONS(2159),
    [anon_sym_switch] = ACTIONS(2159),
    [anon_sym_while] = ACTIONS(2159),
    [anon_sym_do] = ACTIONS(2159),
    [anon_sym_for] = ACTIONS(2159),
    [anon_sym_return] = ACTIONS(2159),
    [anon_sym_break] = ACTIONS(2159),
    [anon_sym_continue] = ACTIONS(2159),
    [anon_sym_goto] = ACTIONS(2159),
    [anon_sym___try] = ACTIONS(2159),
    [anon_sym___leave] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2159),
    [anon_sym_compl] = ACTIONS(2159),
    [anon_sym_DASH_DASH] = ACTIONS(2161),
    [anon_sym_PLUS_PLUS] = ACTIONS(2161),
    [anon_sym_sizeof] = ACTIONS(2159),
    [anon_sym___alignof__] = ACTIONS(2159),
    [anon_sym___alignof] = ACTIONS(2159),
    [anon_sym__alignof] = ACTIONS(2159),
    [anon_sym_alignof] = ACTIONS(2159),
    [anon_sym__Alignof] = ACTIONS(2159),
    [anon_sym_offsetof] = ACTIONS(2159),
    [anon_sym__Generic] = ACTIONS(2159),
    [anon_sym_asm] = ACTIONS(2159),
    [anon_sym___asm__] = ACTIONS(2159),
    [anon_sym___asm] = ACTIONS(2159),
    [sym_number_literal] = ACTIONS(2161),
    [anon_sym_L_SQUOTE] = ACTIONS(2161),
    [anon_sym_u_SQUOTE] = ACTIONS(2161),
    [anon_sym_U_SQUOTE] = ACTIONS(2161),
    [anon_sym_u8_SQUOTE] = ACTIONS(2161),
    [anon_sym_SQUOTE] = ACTIONS(2161),
    [anon_sym_L_DQUOTE] = ACTIONS(2161),
    [anon_sym_u_DQUOTE] = ACTIONS(2161),
    [anon_sym_U_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8_DQUOTE] = ACTIONS(2161),
    [anon_sym_DQUOTE] = ACTIONS(2161),
    [sym_true] = ACTIONS(2159),
    [sym_false] = ACTIONS(2159),
    [anon_sym_NULL] = ACTIONS(2159),
    [anon_sym_nullptr] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_try] = ACTIONS(2159),
    [anon_sym_delete] = ACTIONS(2159),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2159),
    [anon_sym_co_yield] = ACTIONS(2159),
    [anon_sym_R_DQUOTE] = ACTIONS(2161),
    [anon_sym_LR_DQUOTE] = ACTIONS(2161),
    [anon_sym_uR_DQUOTE] = ACTIONS(2161),
    [anon_sym_UR_DQUOTE] = ACTIONS(2161),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2161),
    [anon_sym_co_await] = ACTIONS(2159),
    [anon_sym_new] = ACTIONS(2159),
    [anon_sym_requires] = ACTIONS(2159),
    [sym_this] = ACTIONS(2159),
    [anon_sym_discard] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
    [anon_sym_cbuffer] = ACTIONS(2159),
  },
  [1075] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_LPAREN2] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_AMP] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym___extension__] = ACTIONS(2354),
    [anon_sym_typedef] = ACTIONS(2354),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_out] = ACTIONS(2354),
    [anon_sym_inout] = ACTIONS(2354),
    [anon_sym_virtual] = ACTIONS(2354),
    [anon_sym_extern] = ACTIONS(2354),
    [anon_sym___attribute__] = ACTIONS(2354),
    [anon_sym___attribute] = ACTIONS(2354),
    [anon_sym_COLON_COLON] = ACTIONS(2356),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2356),
    [anon_sym___declspec] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_signed] = ACTIONS(2354),
    [anon_sym_unsigned] = ACTIONS(2354),
    [anon_sym_long] = ACTIONS(2354),
    [anon_sym_short] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_register] = ACTIONS(2354),
    [anon_sym_inline] = ACTIONS(2354),
    [anon_sym___inline] = ACTIONS(2354),
    [anon_sym___inline__] = ACTIONS(2354),
    [anon_sym___forceinline] = ACTIONS(2354),
    [anon_sym_thread_local] = ACTIONS(2354),
    [anon_sym___thread] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_constexpr] = ACTIONS(2354),
    [anon_sym_volatile] = ACTIONS(2354),
    [anon_sym_restrict] = ACTIONS(2354),
    [anon_sym___restrict__] = ACTIONS(2354),
    [anon_sym__Atomic] = ACTIONS(2354),
    [anon_sym__Noreturn] = ACTIONS(2354),
    [anon_sym_noreturn] = ACTIONS(2354),
    [anon_sym__Nonnull] = ACTIONS(2354),
    [anon_sym_mutable] = ACTIONS(2354),
    [anon_sym_constinit] = ACTIONS(2354),
    [anon_sym_consteval] = ACTIONS(2354),
    [anon_sym_alignas] = ACTIONS(2354),
    [anon_sym__Alignas] = ACTIONS(2354),
    [sym_primitive_type] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_struct] = ACTIONS(2354),
    [anon_sym_union] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_goto] = ACTIONS(2354),
    [anon_sym___try] = ACTIONS(2354),
    [anon_sym___leave] = ACTIONS(2354),
    [anon_sym_not] = ACTIONS(2354),
    [anon_sym_compl] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2354),
    [anon_sym___alignof__] = ACTIONS(2354),
    [anon_sym___alignof] = ACTIONS(2354),
    [anon_sym__alignof] = ACTIONS(2354),
    [anon_sym_alignof] = ACTIONS(2354),
    [anon_sym__Alignof] = ACTIONS(2354),
    [anon_sym_offsetof] = ACTIONS(2354),
    [anon_sym__Generic] = ACTIONS(2354),
    [anon_sym_asm] = ACTIONS(2354),
    [anon_sym___asm__] = ACTIONS(2354),
    [anon_sym___asm] = ACTIONS(2354),
    [sym_number_literal] = ACTIONS(2356),
    [anon_sym_L_SQUOTE] = ACTIONS(2356),
    [anon_sym_u_SQUOTE] = ACTIONS(2356),
    [anon_sym_U_SQUOTE] = ACTIONS(2356),
    [anon_sym_u8_SQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [anon_sym_L_DQUOTE] = ACTIONS(2356),
    [anon_sym_u_DQUOTE] = ACTIONS(2356),
    [anon_sym_U_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8_DQUOTE] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [anon_sym_NULL] = ACTIONS(2354),
    [anon_sym_nullptr] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2354),
    [anon_sym_decltype] = ACTIONS(2354),
    [anon_sym_typename] = ACTIONS(2354),
    [anon_sym_template] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_co_return] = ACTIONS(2354),
    [anon_sym_co_yield] = ACTIONS(2354),
    [anon_sym_R_DQUOTE] = ACTIONS(2356),
    [anon_sym_LR_DQUOTE] = ACTIONS(2356),
    [anon_sym_uR_DQUOTE] = ACTIONS(2356),
    [anon_sym_UR_DQUOTE] = ACTIONS(2356),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2356),
    [anon_sym_co_await] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_requires] = ACTIONS(2354),
    [sym_this] = ACTIONS(2354),
    [anon_sym_discard] = ACTIONS(2354),
    [anon_sym_precise] = ACTIONS(2354),
    [anon_sym_shared] = ACTIONS(2354),
    [anon_sym_groupshared] = ACTIONS(2354),
    [anon_sym_uniform] = ACTIONS(2354),
    [anon_sym_row_major] = ACTIONS(2354),
    [anon_sym_column_major] = ACTIONS(2354),
    [anon_sym_globallycoherent] = ACTIONS(2354),
    [anon_sym_centroid] = ACTIONS(2354),
    [anon_sym_noperspective] = ACTIONS(2354),
    [anon_sym_nointerpolation] = ACTIONS(2354),
    [anon_sym_sample] = ACTIONS(2354),
    [anon_sym_linear] = ACTIONS(2354),
    [anon_sym_snorm] = ACTIONS(2354),
    [anon_sym_unorm] = ACTIONS(2354),
    [anon_sym_point] = ACTIONS(2354),
    [anon_sym_line] = ACTIONS(2354),
    [anon_sym_triangleadj] = ACTIONS(2354),
    [anon_sym_lineadj] = ACTIONS(2354),
    [anon_sym_triangle] = ACTIONS(2354),
    [anon_sym_cbuffer] = ACTIONS(2354),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_goto] = ACTIONS(2378),
    [anon_sym___try] = ACTIONS(2378),
    [anon_sym___leave] = ACTIONS(2378),
    [anon_sym_not] = ACTIONS(2378),
    [anon_sym_compl] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2378),
    [anon_sym___alignof__] = ACTIONS(2378),
    [anon_sym___alignof] = ACTIONS(2378),
    [anon_sym__alignof] = ACTIONS(2378),
    [anon_sym_alignof] = ACTIONS(2378),
    [anon_sym__Alignof] = ACTIONS(2378),
    [anon_sym_offsetof] = ACTIONS(2378),
    [anon_sym__Generic] = ACTIONS(2378),
    [anon_sym_asm] = ACTIONS(2378),
    [anon_sym___asm__] = ACTIONS(2378),
    [anon_sym___asm] = ACTIONS(2378),
    [sym_number_literal] = ACTIONS(2380),
    [anon_sym_L_SQUOTE] = ACTIONS(2380),
    [anon_sym_u_SQUOTE] = ACTIONS(2380),
    [anon_sym_U_SQUOTE] = ACTIONS(2380),
    [anon_sym_u8_SQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_L_DQUOTE] = ACTIONS(2380),
    [anon_sym_u_DQUOTE] = ACTIONS(2380),
    [anon_sym_U_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8_DQUOTE] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [anon_sym_NULL] = ACTIONS(2378),
    [anon_sym_nullptr] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_co_return] = ACTIONS(2378),
    [anon_sym_co_yield] = ACTIONS(2378),
    [anon_sym_R_DQUOTE] = ACTIONS(2380),
    [anon_sym_LR_DQUOTE] = ACTIONS(2380),
    [anon_sym_uR_DQUOTE] = ACTIONS(2380),
    [anon_sym_UR_DQUOTE] = ACTIONS(2380),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2380),
    [anon_sym_co_await] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_requires] = ACTIONS(2378),
    [sym_this] = ACTIONS(2378),
    [anon_sym_discard] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
    [anon_sym_cbuffer] = ACTIONS(2378),
  },
  [1077] = {
    [sym_identifier] = ACTIONS(2358),
    [anon_sym_LPAREN2] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_STAR] = ACTIONS(2360),
    [anon_sym_AMP] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym___extension__] = ACTIONS(2358),
    [anon_sym_typedef] = ACTIONS(2358),
    [anon_sym_in] = ACTIONS(2358),
    [anon_sym_out] = ACTIONS(2358),
    [anon_sym_inout] = ACTIONS(2358),
    [anon_sym_virtual] = ACTIONS(2358),
    [anon_sym_extern] = ACTIONS(2358),
    [anon_sym___attribute__] = ACTIONS(2358),
    [anon_sym___attribute] = ACTIONS(2358),
    [anon_sym_COLON_COLON] = ACTIONS(2360),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2360),
    [anon_sym___declspec] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_signed] = ACTIONS(2358),
    [anon_sym_unsigned] = ACTIONS(2358),
    [anon_sym_long] = ACTIONS(2358),
    [anon_sym_short] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_register] = ACTIONS(2358),
    [anon_sym_inline] = ACTIONS(2358),
    [anon_sym___inline] = ACTIONS(2358),
    [anon_sym___inline__] = ACTIONS(2358),
    [anon_sym___forceinline] = ACTIONS(2358),
    [anon_sym_thread_local] = ACTIONS(2358),
    [anon_sym___thread] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_constexpr] = ACTIONS(2358),
    [anon_sym_volatile] = ACTIONS(2358),
    [anon_sym_restrict] = ACTIONS(2358),
    [anon_sym___restrict__] = ACTIONS(2358),
    [anon_sym__Atomic] = ACTIONS(2358),
    [anon_sym__Noreturn] = ACTIONS(2358),
    [anon_sym_noreturn] = ACTIONS(2358),
    [anon_sym__Nonnull] = ACTIONS(2358),
    [anon_sym_mutable] = ACTIONS(2358),
    [anon_sym_constinit] = ACTIONS(2358),
    [anon_sym_consteval] = ACTIONS(2358),
    [anon_sym_alignas] = ACTIONS(2358),
    [anon_sym__Alignas] = ACTIONS(2358),
    [sym_primitive_type] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_struct] = ACTIONS(2358),
    [anon_sym_union] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_goto] = ACTIONS(2358),
    [anon_sym___try] = ACTIONS(2358),
    [anon_sym___leave] = ACTIONS(2358),
    [anon_sym_not] = ACTIONS(2358),
    [anon_sym_compl] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2358),
    [anon_sym___alignof__] = ACTIONS(2358),
    [anon_sym___alignof] = ACTIONS(2358),
    [anon_sym__alignof] = ACTIONS(2358),
    [anon_sym_alignof] = ACTIONS(2358),
    [anon_sym__Alignof] = ACTIONS(2358),
    [anon_sym_offsetof] = ACTIONS(2358),
    [anon_sym__Generic] = ACTIONS(2358),
    [anon_sym_asm] = ACTIONS(2358),
    [anon_sym___asm__] = ACTIONS(2358),
    [anon_sym___asm] = ACTIONS(2358),
    [sym_number_literal] = ACTIONS(2360),
    [anon_sym_L_SQUOTE] = ACTIONS(2360),
    [anon_sym_u_SQUOTE] = ACTIONS(2360),
    [anon_sym_U_SQUOTE] = ACTIONS(2360),
    [anon_sym_u8_SQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_L_DQUOTE] = ACTIONS(2360),
    [anon_sym_u_DQUOTE] = ACTIONS(2360),
    [anon_sym_U_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8_DQUOTE] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [anon_sym_NULL] = ACTIONS(2358),
    [anon_sym_nullptr] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2358),
    [anon_sym_decltype] = ACTIONS(2358),
    [anon_sym_typename] = ACTIONS(2358),
    [anon_sym_template] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_co_return] = ACTIONS(2358),
    [anon_sym_co_yield] = ACTIONS(2358),
    [anon_sym_R_DQUOTE] = ACTIONS(2360),
    [anon_sym_LR_DQUOTE] = ACTIONS(2360),
    [anon_sym_uR_DQUOTE] = ACTIONS(2360),
    [anon_sym_UR_DQUOTE] = ACTIONS(2360),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2360),
    [anon_sym_co_await] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_requires] = ACTIONS(2358),
    [sym_this] = ACTIONS(2358),
    [anon_sym_discard] = ACTIONS(2358),
    [anon_sym_precise] = ACTIONS(2358),
    [anon_sym_shared] = ACTIONS(2358),
    [anon_sym_groupshared] = ACTIONS(2358),
    [anon_sym_uniform] = ACTIONS(2358),
    [anon_sym_row_major] = ACTIONS(2358),
    [anon_sym_column_major] = ACTIONS(2358),
    [anon_sym_globallycoherent] = ACTIONS(2358),
    [anon_sym_centroid] = ACTIONS(2358),
    [anon_sym_noperspective] = ACTIONS(2358),
    [anon_sym_nointerpolation] = ACTIONS(2358),
    [anon_sym_sample] = ACTIONS(2358),
    [anon_sym_linear] = ACTIONS(2358),
    [anon_sym_snorm] = ACTIONS(2358),
    [anon_sym_unorm] = ACTIONS(2358),
    [anon_sym_point] = ACTIONS(2358),
    [anon_sym_line] = ACTIONS(2358),
    [anon_sym_triangleadj] = ACTIONS(2358),
    [anon_sym_lineadj] = ACTIONS(2358),
    [anon_sym_triangle] = ACTIONS(2358),
    [anon_sym_cbuffer] = ACTIONS(2358),
  },
  [1078] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4261),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1079] = {
    [sym_identifier] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_BANG] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2246),
    [anon_sym_PLUS] = ACTIONS(2246),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2248),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym_LBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_else] = ACTIONS(2246),
    [anon_sym_switch] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [anon_sym_do] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_goto] = ACTIONS(2246),
    [anon_sym___try] = ACTIONS(2246),
    [anon_sym___leave] = ACTIONS(2246),
    [anon_sym_not] = ACTIONS(2246),
    [anon_sym_compl] = ACTIONS(2246),
    [anon_sym_DASH_DASH] = ACTIONS(2248),
    [anon_sym_PLUS_PLUS] = ACTIONS(2248),
    [anon_sym_sizeof] = ACTIONS(2246),
    [anon_sym___alignof__] = ACTIONS(2246),
    [anon_sym___alignof] = ACTIONS(2246),
    [anon_sym__alignof] = ACTIONS(2246),
    [anon_sym_alignof] = ACTIONS(2246),
    [anon_sym__Alignof] = ACTIONS(2246),
    [anon_sym_offsetof] = ACTIONS(2246),
    [anon_sym__Generic] = ACTIONS(2246),
    [anon_sym_asm] = ACTIONS(2246),
    [anon_sym___asm__] = ACTIONS(2246),
    [anon_sym___asm] = ACTIONS(2246),
    [sym_number_literal] = ACTIONS(2248),
    [anon_sym_L_SQUOTE] = ACTIONS(2248),
    [anon_sym_u_SQUOTE] = ACTIONS(2248),
    [anon_sym_U_SQUOTE] = ACTIONS(2248),
    [anon_sym_u8_SQUOTE] = ACTIONS(2248),
    [anon_sym_SQUOTE] = ACTIONS(2248),
    [anon_sym_L_DQUOTE] = ACTIONS(2248),
    [anon_sym_u_DQUOTE] = ACTIONS(2248),
    [anon_sym_U_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8_DQUOTE] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(2248),
    [sym_true] = ACTIONS(2246),
    [sym_false] = ACTIONS(2246),
    [anon_sym_NULL] = ACTIONS(2246),
    [anon_sym_nullptr] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_try] = ACTIONS(2246),
    [anon_sym_delete] = ACTIONS(2246),
    [anon_sym_throw] = ACTIONS(2246),
    [anon_sym_co_return] = ACTIONS(2246),
    [anon_sym_co_yield] = ACTIONS(2246),
    [anon_sym_R_DQUOTE] = ACTIONS(2248),
    [anon_sym_LR_DQUOTE] = ACTIONS(2248),
    [anon_sym_uR_DQUOTE] = ACTIONS(2248),
    [anon_sym_UR_DQUOTE] = ACTIONS(2248),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2248),
    [anon_sym_co_await] = ACTIONS(2246),
    [anon_sym_new] = ACTIONS(2246),
    [anon_sym_requires] = ACTIONS(2246),
    [sym_this] = ACTIONS(2246),
    [anon_sym_discard] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
    [anon_sym_cbuffer] = ACTIONS(2246),
  },
  [1080] = {
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN2] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2252),
    [anon_sym_TILDE] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2250),
    [anon_sym_PLUS] = ACTIONS(2250),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_AMP] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym___extension__] = ACTIONS(2250),
    [anon_sym_typedef] = ACTIONS(2250),
    [anon_sym_in] = ACTIONS(2250),
    [anon_sym_out] = ACTIONS(2250),
    [anon_sym_inout] = ACTIONS(2250),
    [anon_sym_virtual] = ACTIONS(2250),
    [anon_sym_extern] = ACTIONS(2250),
    [anon_sym___attribute__] = ACTIONS(2250),
    [anon_sym___attribute] = ACTIONS(2250),
    [anon_sym_COLON_COLON] = ACTIONS(2252),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2252),
    [anon_sym___declspec] = ACTIONS(2250),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_signed] = ACTIONS(2250),
    [anon_sym_unsigned] = ACTIONS(2250),
    [anon_sym_long] = ACTIONS(2250),
    [anon_sym_short] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_static] = ACTIONS(2250),
    [anon_sym_register] = ACTIONS(2250),
    [anon_sym_inline] = ACTIONS(2250),
    [anon_sym___inline] = ACTIONS(2250),
    [anon_sym___inline__] = ACTIONS(2250),
    [anon_sym___forceinline] = ACTIONS(2250),
    [anon_sym_thread_local] = ACTIONS(2250),
    [anon_sym___thread] = ACTIONS(2250),
    [anon_sym_const] = ACTIONS(2250),
    [anon_sym_constexpr] = ACTIONS(2250),
    [anon_sym_volatile] = ACTIONS(2250),
    [anon_sym_restrict] = ACTIONS(2250),
    [anon_sym___restrict__] = ACTIONS(2250),
    [anon_sym__Atomic] = ACTIONS(2250),
    [anon_sym__Noreturn] = ACTIONS(2250),
    [anon_sym_noreturn] = ACTIONS(2250),
    [anon_sym__Nonnull] = ACTIONS(2250),
    [anon_sym_mutable] = ACTIONS(2250),
    [anon_sym_constinit] = ACTIONS(2250),
    [anon_sym_consteval] = ACTIONS(2250),
    [anon_sym_alignas] = ACTIONS(2250),
    [anon_sym__Alignas] = ACTIONS(2250),
    [sym_primitive_type] = ACTIONS(2250),
    [anon_sym_enum] = ACTIONS(2250),
    [anon_sym_class] = ACTIONS(2250),
    [anon_sym_struct] = ACTIONS(2250),
    [anon_sym_union] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(2250),
    [anon_sym_else] = ACTIONS(2250),
    [anon_sym_switch] = ACTIONS(2250),
    [anon_sym_while] = ACTIONS(2250),
    [anon_sym_do] = ACTIONS(2250),
    [anon_sym_for] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2250),
    [anon_sym_break] = ACTIONS(2250),
    [anon_sym_continue] = ACTIONS(2250),
    [anon_sym_goto] = ACTIONS(2250),
    [anon_sym___try] = ACTIONS(2250),
    [anon_sym___leave] = ACTIONS(2250),
    [anon_sym_not] = ACTIONS(2250),
    [anon_sym_compl] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2252),
    [anon_sym_PLUS_PLUS] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2250),
    [anon_sym___alignof__] = ACTIONS(2250),
    [anon_sym___alignof] = ACTIONS(2250),
    [anon_sym__alignof] = ACTIONS(2250),
    [anon_sym_alignof] = ACTIONS(2250),
    [anon_sym__Alignof] = ACTIONS(2250),
    [anon_sym_offsetof] = ACTIONS(2250),
    [anon_sym__Generic] = ACTIONS(2250),
    [anon_sym_asm] = ACTIONS(2250),
    [anon_sym___asm__] = ACTIONS(2250),
    [anon_sym___asm] = ACTIONS(2250),
    [sym_number_literal] = ACTIONS(2252),
    [anon_sym_L_SQUOTE] = ACTIONS(2252),
    [anon_sym_u_SQUOTE] = ACTIONS(2252),
    [anon_sym_U_SQUOTE] = ACTIONS(2252),
    [anon_sym_u8_SQUOTE] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2252),
    [anon_sym_L_DQUOTE] = ACTIONS(2252),
    [anon_sym_u_DQUOTE] = ACTIONS(2252),
    [anon_sym_U_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8_DQUOTE] = ACTIONS(2252),
    [anon_sym_DQUOTE] = ACTIONS(2252),
    [sym_true] = ACTIONS(2250),
    [sym_false] = ACTIONS(2250),
    [anon_sym_NULL] = ACTIONS(2250),
    [anon_sym_nullptr] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2250),
    [anon_sym_decltype] = ACTIONS(2250),
    [anon_sym_typename] = ACTIONS(2250),
    [anon_sym_template] = ACTIONS(2250),
    [anon_sym_try] = ACTIONS(2250),
    [anon_sym_delete] = ACTIONS(2250),
    [anon_sym_throw] = ACTIONS(2250),
    [anon_sym_co_return] = ACTIONS(2250),
    [anon_sym_co_yield] = ACTIONS(2250),
    [anon_sym_R_DQUOTE] = ACTIONS(2252),
    [anon_sym_LR_DQUOTE] = ACTIONS(2252),
    [anon_sym_uR_DQUOTE] = ACTIONS(2252),
    [anon_sym_UR_DQUOTE] = ACTIONS(2252),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2252),
    [anon_sym_co_await] = ACTIONS(2250),
    [anon_sym_new] = ACTIONS(2250),
    [anon_sym_requires] = ACTIONS(2250),
    [sym_this] = ACTIONS(2250),
    [anon_sym_discard] = ACTIONS(2250),
    [anon_sym_precise] = ACTIONS(2250),
    [anon_sym_shared] = ACTIONS(2250),
    [anon_sym_groupshared] = ACTIONS(2250),
    [anon_sym_uniform] = ACTIONS(2250),
    [anon_sym_row_major] = ACTIONS(2250),
    [anon_sym_column_major] = ACTIONS(2250),
    [anon_sym_globallycoherent] = ACTIONS(2250),
    [anon_sym_centroid] = ACTIONS(2250),
    [anon_sym_noperspective] = ACTIONS(2250),
    [anon_sym_nointerpolation] = ACTIONS(2250),
    [anon_sym_sample] = ACTIONS(2250),
    [anon_sym_linear] = ACTIONS(2250),
    [anon_sym_snorm] = ACTIONS(2250),
    [anon_sym_unorm] = ACTIONS(2250),
    [anon_sym_point] = ACTIONS(2250),
    [anon_sym_line] = ACTIONS(2250),
    [anon_sym_triangleadj] = ACTIONS(2250),
    [anon_sym_lineadj] = ACTIONS(2250),
    [anon_sym_triangle] = ACTIONS(2250),
    [anon_sym_cbuffer] = ACTIONS(2250),
  },
  [1081] = {
    [sym_identifier] = ACTIONS(2326),
    [anon_sym_LPAREN2] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym___extension__] = ACTIONS(2326),
    [anon_sym_typedef] = ACTIONS(2326),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_out] = ACTIONS(2326),
    [anon_sym_inout] = ACTIONS(2326),
    [anon_sym_virtual] = ACTIONS(2326),
    [anon_sym_extern] = ACTIONS(2326),
    [anon_sym___attribute__] = ACTIONS(2326),
    [anon_sym___attribute] = ACTIONS(2326),
    [anon_sym_COLON_COLON] = ACTIONS(2328),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2328),
    [anon_sym___declspec] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_signed] = ACTIONS(2326),
    [anon_sym_unsigned] = ACTIONS(2326),
    [anon_sym_long] = ACTIONS(2326),
    [anon_sym_short] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_register] = ACTIONS(2326),
    [anon_sym_inline] = ACTIONS(2326),
    [anon_sym___inline] = ACTIONS(2326),
    [anon_sym___inline__] = ACTIONS(2326),
    [anon_sym___forceinline] = ACTIONS(2326),
    [anon_sym_thread_local] = ACTIONS(2326),
    [anon_sym___thread] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [anon_sym_constexpr] = ACTIONS(2326),
    [anon_sym_volatile] = ACTIONS(2326),
    [anon_sym_restrict] = ACTIONS(2326),
    [anon_sym___restrict__] = ACTIONS(2326),
    [anon_sym__Atomic] = ACTIONS(2326),
    [anon_sym__Noreturn] = ACTIONS(2326),
    [anon_sym_noreturn] = ACTIONS(2326),
    [anon_sym__Nonnull] = ACTIONS(2326),
    [anon_sym_mutable] = ACTIONS(2326),
    [anon_sym_constinit] = ACTIONS(2326),
    [anon_sym_consteval] = ACTIONS(2326),
    [anon_sym_alignas] = ACTIONS(2326),
    [anon_sym__Alignas] = ACTIONS(2326),
    [sym_primitive_type] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_struct] = ACTIONS(2326),
    [anon_sym_union] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_goto] = ACTIONS(2326),
    [anon_sym___try] = ACTIONS(2326),
    [anon_sym___leave] = ACTIONS(2326),
    [anon_sym_not] = ACTIONS(2326),
    [anon_sym_compl] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_sizeof] = ACTIONS(2326),
    [anon_sym___alignof__] = ACTIONS(2326),
    [anon_sym___alignof] = ACTIONS(2326),
    [anon_sym__alignof] = ACTIONS(2326),
    [anon_sym_alignof] = ACTIONS(2326),
    [anon_sym__Alignof] = ACTIONS(2326),
    [anon_sym_offsetof] = ACTIONS(2326),
    [anon_sym__Generic] = ACTIONS(2326),
    [anon_sym_asm] = ACTIONS(2326),
    [anon_sym___asm__] = ACTIONS(2326),
    [anon_sym___asm] = ACTIONS(2326),
    [sym_number_literal] = ACTIONS(2328),
    [anon_sym_L_SQUOTE] = ACTIONS(2328),
    [anon_sym_u_SQUOTE] = ACTIONS(2328),
    [anon_sym_U_SQUOTE] = ACTIONS(2328),
    [anon_sym_u8_SQUOTE] = ACTIONS(2328),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_L_DQUOTE] = ACTIONS(2328),
    [anon_sym_u_DQUOTE] = ACTIONS(2328),
    [anon_sym_U_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8_DQUOTE] = ACTIONS(2328),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [sym_true] = ACTIONS(2326),
    [sym_false] = ACTIONS(2326),
    [anon_sym_NULL] = ACTIONS(2326),
    [anon_sym_nullptr] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2326),
    [anon_sym_decltype] = ACTIONS(2326),
    [anon_sym_typename] = ACTIONS(2326),
    [anon_sym_template] = ACTIONS(2326),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_co_return] = ACTIONS(2326),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2328),
    [anon_sym_LR_DQUOTE] = ACTIONS(2328),
    [anon_sym_uR_DQUOTE] = ACTIONS(2328),
    [anon_sym_UR_DQUOTE] = ACTIONS(2328),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2328),
    [anon_sym_co_await] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_requires] = ACTIONS(2326),
    [sym_this] = ACTIONS(2326),
    [anon_sym_discard] = ACTIONS(2326),
    [anon_sym_precise] = ACTIONS(2326),
    [anon_sym_shared] = ACTIONS(2326),
    [anon_sym_groupshared] = ACTIONS(2326),
    [anon_sym_uniform] = ACTIONS(2326),
    [anon_sym_row_major] = ACTIONS(2326),
    [anon_sym_column_major] = ACTIONS(2326),
    [anon_sym_globallycoherent] = ACTIONS(2326),
    [anon_sym_centroid] = ACTIONS(2326),
    [anon_sym_noperspective] = ACTIONS(2326),
    [anon_sym_nointerpolation] = ACTIONS(2326),
    [anon_sym_sample] = ACTIONS(2326),
    [anon_sym_linear] = ACTIONS(2326),
    [anon_sym_snorm] = ACTIONS(2326),
    [anon_sym_unorm] = ACTIONS(2326),
    [anon_sym_point] = ACTIONS(2326),
    [anon_sym_line] = ACTIONS(2326),
    [anon_sym_triangleadj] = ACTIONS(2326),
    [anon_sym_lineadj] = ACTIONS(2326),
    [anon_sym_triangle] = ACTIONS(2326),
    [anon_sym_cbuffer] = ACTIONS(2326),
  },
  [1082] = {
    [sym_identifier] = ACTIONS(2258),
    [anon_sym_LPAREN2] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2260),
    [anon_sym_TILDE] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_PLUS] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(2260),
    [anon_sym_AMP] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2260),
    [anon_sym___extension__] = ACTIONS(2258),
    [anon_sym_typedef] = ACTIONS(2258),
    [anon_sym_in] = ACTIONS(2258),
    [anon_sym_out] = ACTIONS(2258),
    [anon_sym_inout] = ACTIONS(2258),
    [anon_sym_virtual] = ACTIONS(2258),
    [anon_sym_extern] = ACTIONS(2258),
    [anon_sym___attribute__] = ACTIONS(2258),
    [anon_sym___attribute] = ACTIONS(2258),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2260),
    [anon_sym___declspec] = ACTIONS(2258),
    [anon_sym_LBRACE] = ACTIONS(2260),
    [anon_sym_signed] = ACTIONS(2258),
    [anon_sym_unsigned] = ACTIONS(2258),
    [anon_sym_long] = ACTIONS(2258),
    [anon_sym_short] = ACTIONS(2258),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_register] = ACTIONS(2258),
    [anon_sym_inline] = ACTIONS(2258),
    [anon_sym___inline] = ACTIONS(2258),
    [anon_sym___inline__] = ACTIONS(2258),
    [anon_sym___forceinline] = ACTIONS(2258),
    [anon_sym_thread_local] = ACTIONS(2258),
    [anon_sym___thread] = ACTIONS(2258),
    [anon_sym_const] = ACTIONS(2258),
    [anon_sym_constexpr] = ACTIONS(2258),
    [anon_sym_volatile] = ACTIONS(2258),
    [anon_sym_restrict] = ACTIONS(2258),
    [anon_sym___restrict__] = ACTIONS(2258),
    [anon_sym__Atomic] = ACTIONS(2258),
    [anon_sym__Noreturn] = ACTIONS(2258),
    [anon_sym_noreturn] = ACTIONS(2258),
    [anon_sym__Nonnull] = ACTIONS(2258),
    [anon_sym_mutable] = ACTIONS(2258),
    [anon_sym_constinit] = ACTIONS(2258),
    [anon_sym_consteval] = ACTIONS(2258),
    [anon_sym_alignas] = ACTIONS(2258),
    [anon_sym__Alignas] = ACTIONS(2258),
    [sym_primitive_type] = ACTIONS(2258),
    [anon_sym_enum] = ACTIONS(2258),
    [anon_sym_class] = ACTIONS(2258),
    [anon_sym_struct] = ACTIONS(2258),
    [anon_sym_union] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(2258),
    [anon_sym_else] = ACTIONS(2258),
    [anon_sym_switch] = ACTIONS(2258),
    [anon_sym_while] = ACTIONS(2258),
    [anon_sym_do] = ACTIONS(2258),
    [anon_sym_for] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2258),
    [anon_sym_break] = ACTIONS(2258),
    [anon_sym_continue] = ACTIONS(2258),
    [anon_sym_goto] = ACTIONS(2258),
    [anon_sym___try] = ACTIONS(2258),
    [anon_sym___leave] = ACTIONS(2258),
    [anon_sym_not] = ACTIONS(2258),
    [anon_sym_compl] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2260),
    [anon_sym_PLUS_PLUS] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2258),
    [anon_sym___alignof__] = ACTIONS(2258),
    [anon_sym___alignof] = ACTIONS(2258),
    [anon_sym__alignof] = ACTIONS(2258),
    [anon_sym_alignof] = ACTIONS(2258),
    [anon_sym__Alignof] = ACTIONS(2258),
    [anon_sym_offsetof] = ACTIONS(2258),
    [anon_sym__Generic] = ACTIONS(2258),
    [anon_sym_asm] = ACTIONS(2258),
    [anon_sym___asm__] = ACTIONS(2258),
    [anon_sym___asm] = ACTIONS(2258),
    [sym_number_literal] = ACTIONS(2260),
    [anon_sym_L_SQUOTE] = ACTIONS(2260),
    [anon_sym_u_SQUOTE] = ACTIONS(2260),
    [anon_sym_U_SQUOTE] = ACTIONS(2260),
    [anon_sym_u8_SQUOTE] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2260),
    [anon_sym_L_DQUOTE] = ACTIONS(2260),
    [anon_sym_u_DQUOTE] = ACTIONS(2260),
    [anon_sym_U_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8_DQUOTE] = ACTIONS(2260),
    [anon_sym_DQUOTE] = ACTIONS(2260),
    [sym_true] = ACTIONS(2258),
    [sym_false] = ACTIONS(2258),
    [anon_sym_NULL] = ACTIONS(2258),
    [anon_sym_nullptr] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2258),
    [anon_sym_decltype] = ACTIONS(2258),
    [anon_sym_typename] = ACTIONS(2258),
    [anon_sym_template] = ACTIONS(2258),
    [anon_sym_try] = ACTIONS(2258),
    [anon_sym_delete] = ACTIONS(2258),
    [anon_sym_throw] = ACTIONS(2258),
    [anon_sym_co_return] = ACTIONS(2258),
    [anon_sym_co_yield] = ACTIONS(2258),
    [anon_sym_R_DQUOTE] = ACTIONS(2260),
    [anon_sym_LR_DQUOTE] = ACTIONS(2260),
    [anon_sym_uR_DQUOTE] = ACTIONS(2260),
    [anon_sym_UR_DQUOTE] = ACTIONS(2260),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2260),
    [anon_sym_co_await] = ACTIONS(2258),
    [anon_sym_new] = ACTIONS(2258),
    [anon_sym_requires] = ACTIONS(2258),
    [sym_this] = ACTIONS(2258),
    [anon_sym_discard] = ACTIONS(2258),
    [anon_sym_precise] = ACTIONS(2258),
    [anon_sym_shared] = ACTIONS(2258),
    [anon_sym_groupshared] = ACTIONS(2258),
    [anon_sym_uniform] = ACTIONS(2258),
    [anon_sym_row_major] = ACTIONS(2258),
    [anon_sym_column_major] = ACTIONS(2258),
    [anon_sym_globallycoherent] = ACTIONS(2258),
    [anon_sym_centroid] = ACTIONS(2258),
    [anon_sym_noperspective] = ACTIONS(2258),
    [anon_sym_nointerpolation] = ACTIONS(2258),
    [anon_sym_sample] = ACTIONS(2258),
    [anon_sym_linear] = ACTIONS(2258),
    [anon_sym_snorm] = ACTIONS(2258),
    [anon_sym_unorm] = ACTIONS(2258),
    [anon_sym_point] = ACTIONS(2258),
    [anon_sym_line] = ACTIONS(2258),
    [anon_sym_triangleadj] = ACTIONS(2258),
    [anon_sym_lineadj] = ACTIONS(2258),
    [anon_sym_triangle] = ACTIONS(2258),
    [anon_sym_cbuffer] = ACTIONS(2258),
  },
  [1083] = {
    [sym_identifier] = ACTIONS(2342),
    [anon_sym_LPAREN2] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2344),
    [anon_sym_TILDE] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2342),
    [anon_sym_PLUS] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2344),
    [anon_sym___extension__] = ACTIONS(2342),
    [anon_sym_typedef] = ACTIONS(2342),
    [anon_sym_in] = ACTIONS(2342),
    [anon_sym_out] = ACTIONS(2342),
    [anon_sym_inout] = ACTIONS(2342),
    [anon_sym_virtual] = ACTIONS(2342),
    [anon_sym_extern] = ACTIONS(2342),
    [anon_sym___attribute__] = ACTIONS(2342),
    [anon_sym___attribute] = ACTIONS(2342),
    [anon_sym_COLON_COLON] = ACTIONS(2344),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2344),
    [anon_sym___declspec] = ACTIONS(2342),
    [anon_sym_LBRACE] = ACTIONS(2344),
    [anon_sym_signed] = ACTIONS(2342),
    [anon_sym_unsigned] = ACTIONS(2342),
    [anon_sym_long] = ACTIONS(2342),
    [anon_sym_short] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2342),
    [anon_sym_register] = ACTIONS(2342),
    [anon_sym_inline] = ACTIONS(2342),
    [anon_sym___inline] = ACTIONS(2342),
    [anon_sym___inline__] = ACTIONS(2342),
    [anon_sym___forceinline] = ACTIONS(2342),
    [anon_sym_thread_local] = ACTIONS(2342),
    [anon_sym___thread] = ACTIONS(2342),
    [anon_sym_const] = ACTIONS(2342),
    [anon_sym_constexpr] = ACTIONS(2342),
    [anon_sym_volatile] = ACTIONS(2342),
    [anon_sym_restrict] = ACTIONS(2342),
    [anon_sym___restrict__] = ACTIONS(2342),
    [anon_sym__Atomic] = ACTIONS(2342),
    [anon_sym__Noreturn] = ACTIONS(2342),
    [anon_sym_noreturn] = ACTIONS(2342),
    [anon_sym__Nonnull] = ACTIONS(2342),
    [anon_sym_mutable] = ACTIONS(2342),
    [anon_sym_constinit] = ACTIONS(2342),
    [anon_sym_consteval] = ACTIONS(2342),
    [anon_sym_alignas] = ACTIONS(2342),
    [anon_sym__Alignas] = ACTIONS(2342),
    [sym_primitive_type] = ACTIONS(2342),
    [anon_sym_enum] = ACTIONS(2342),
    [anon_sym_class] = ACTIONS(2342),
    [anon_sym_struct] = ACTIONS(2342),
    [anon_sym_union] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2342),
    [anon_sym_switch] = ACTIONS(2342),
    [anon_sym_while] = ACTIONS(2342),
    [anon_sym_do] = ACTIONS(2342),
    [anon_sym_for] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2342),
    [anon_sym_break] = ACTIONS(2342),
    [anon_sym_continue] = ACTIONS(2342),
    [anon_sym_goto] = ACTIONS(2342),
    [anon_sym___try] = ACTIONS(2342),
    [anon_sym___leave] = ACTIONS(2342),
    [anon_sym_not] = ACTIONS(2342),
    [anon_sym_compl] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2342),
    [anon_sym___alignof__] = ACTIONS(2342),
    [anon_sym___alignof] = ACTIONS(2342),
    [anon_sym__alignof] = ACTIONS(2342),
    [anon_sym_alignof] = ACTIONS(2342),
    [anon_sym__Alignof] = ACTIONS(2342),
    [anon_sym_offsetof] = ACTIONS(2342),
    [anon_sym__Generic] = ACTIONS(2342),
    [anon_sym_asm] = ACTIONS(2342),
    [anon_sym___asm__] = ACTIONS(2342),
    [anon_sym___asm] = ACTIONS(2342),
    [sym_number_literal] = ACTIONS(2344),
    [anon_sym_L_SQUOTE] = ACTIONS(2344),
    [anon_sym_u_SQUOTE] = ACTIONS(2344),
    [anon_sym_U_SQUOTE] = ACTIONS(2344),
    [anon_sym_u8_SQUOTE] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2344),
    [anon_sym_L_DQUOTE] = ACTIONS(2344),
    [anon_sym_u_DQUOTE] = ACTIONS(2344),
    [anon_sym_U_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8_DQUOTE] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [sym_true] = ACTIONS(2342),
    [sym_false] = ACTIONS(2342),
    [anon_sym_NULL] = ACTIONS(2342),
    [anon_sym_nullptr] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2342),
    [anon_sym_decltype] = ACTIONS(2342),
    [anon_sym_typename] = ACTIONS(2342),
    [anon_sym_template] = ACTIONS(2342),
    [anon_sym_try] = ACTIONS(2342),
    [anon_sym_delete] = ACTIONS(2342),
    [anon_sym_throw] = ACTIONS(2342),
    [anon_sym_co_return] = ACTIONS(2342),
    [anon_sym_co_yield] = ACTIONS(2342),
    [anon_sym_R_DQUOTE] = ACTIONS(2344),
    [anon_sym_LR_DQUOTE] = ACTIONS(2344),
    [anon_sym_uR_DQUOTE] = ACTIONS(2344),
    [anon_sym_UR_DQUOTE] = ACTIONS(2344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2344),
    [anon_sym_co_await] = ACTIONS(2342),
    [anon_sym_new] = ACTIONS(2342),
    [anon_sym_requires] = ACTIONS(2342),
    [sym_this] = ACTIONS(2342),
    [anon_sym_discard] = ACTIONS(2342),
    [anon_sym_precise] = ACTIONS(2342),
    [anon_sym_shared] = ACTIONS(2342),
    [anon_sym_groupshared] = ACTIONS(2342),
    [anon_sym_uniform] = ACTIONS(2342),
    [anon_sym_row_major] = ACTIONS(2342),
    [anon_sym_column_major] = ACTIONS(2342),
    [anon_sym_globallycoherent] = ACTIONS(2342),
    [anon_sym_centroid] = ACTIONS(2342),
    [anon_sym_noperspective] = ACTIONS(2342),
    [anon_sym_nointerpolation] = ACTIONS(2342),
    [anon_sym_sample] = ACTIONS(2342),
    [anon_sym_linear] = ACTIONS(2342),
    [anon_sym_snorm] = ACTIONS(2342),
    [anon_sym_unorm] = ACTIONS(2342),
    [anon_sym_point] = ACTIONS(2342),
    [anon_sym_line] = ACTIONS(2342),
    [anon_sym_triangleadj] = ACTIONS(2342),
    [anon_sym_lineadj] = ACTIONS(2342),
    [anon_sym_triangle] = ACTIONS(2342),
    [anon_sym_cbuffer] = ACTIONS(2342),
  },
  [1084] = {
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_LPAREN2] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2396),
    [anon_sym_AMP] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym___extension__] = ACTIONS(2394),
    [anon_sym_typedef] = ACTIONS(2394),
    [anon_sym_in] = ACTIONS(2394),
    [anon_sym_out] = ACTIONS(2394),
    [anon_sym_inout] = ACTIONS(2394),
    [anon_sym_virtual] = ACTIONS(2394),
    [anon_sym_extern] = ACTIONS(2394),
    [anon_sym___attribute__] = ACTIONS(2394),
    [anon_sym___attribute] = ACTIONS(2394),
    [anon_sym_COLON_COLON] = ACTIONS(2396),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2396),
    [anon_sym___declspec] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_signed] = ACTIONS(2394),
    [anon_sym_unsigned] = ACTIONS(2394),
    [anon_sym_long] = ACTIONS(2394),
    [anon_sym_short] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_register] = ACTIONS(2394),
    [anon_sym_inline] = ACTIONS(2394),
    [anon_sym___inline] = ACTIONS(2394),
    [anon_sym___inline__] = ACTIONS(2394),
    [anon_sym___forceinline] = ACTIONS(2394),
    [anon_sym_thread_local] = ACTIONS(2394),
    [anon_sym___thread] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_constexpr] = ACTIONS(2394),
    [anon_sym_volatile] = ACTIONS(2394),
    [anon_sym_restrict] = ACTIONS(2394),
    [anon_sym___restrict__] = ACTIONS(2394),
    [anon_sym__Atomic] = ACTIONS(2394),
    [anon_sym__Noreturn] = ACTIONS(2394),
    [anon_sym_noreturn] = ACTIONS(2394),
    [anon_sym__Nonnull] = ACTIONS(2394),
    [anon_sym_mutable] = ACTIONS(2394),
    [anon_sym_constinit] = ACTIONS(2394),
    [anon_sym_consteval] = ACTIONS(2394),
    [anon_sym_alignas] = ACTIONS(2394),
    [anon_sym__Alignas] = ACTIONS(2394),
    [sym_primitive_type] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_struct] = ACTIONS(2394),
    [anon_sym_union] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_goto] = ACTIONS(2394),
    [anon_sym___try] = ACTIONS(2394),
    [anon_sym___leave] = ACTIONS(2394),
    [anon_sym_not] = ACTIONS(2394),
    [anon_sym_compl] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2394),
    [anon_sym___alignof__] = ACTIONS(2394),
    [anon_sym___alignof] = ACTIONS(2394),
    [anon_sym__alignof] = ACTIONS(2394),
    [anon_sym_alignof] = ACTIONS(2394),
    [anon_sym__Alignof] = ACTIONS(2394),
    [anon_sym_offsetof] = ACTIONS(2394),
    [anon_sym__Generic] = ACTIONS(2394),
    [anon_sym_asm] = ACTIONS(2394),
    [anon_sym___asm__] = ACTIONS(2394),
    [anon_sym___asm] = ACTIONS(2394),
    [sym_number_literal] = ACTIONS(2396),
    [anon_sym_L_SQUOTE] = ACTIONS(2396),
    [anon_sym_u_SQUOTE] = ACTIONS(2396),
    [anon_sym_U_SQUOTE] = ACTIONS(2396),
    [anon_sym_u8_SQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_L_DQUOTE] = ACTIONS(2396),
    [anon_sym_u_DQUOTE] = ACTIONS(2396),
    [anon_sym_U_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8_DQUOTE] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [anon_sym_NULL] = ACTIONS(2394),
    [anon_sym_nullptr] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2394),
    [anon_sym_decltype] = ACTIONS(2394),
    [anon_sym_typename] = ACTIONS(2394),
    [anon_sym_template] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_co_return] = ACTIONS(2394),
    [anon_sym_co_yield] = ACTIONS(2394),
    [anon_sym_R_DQUOTE] = ACTIONS(2396),
    [anon_sym_LR_DQUOTE] = ACTIONS(2396),
    [anon_sym_uR_DQUOTE] = ACTIONS(2396),
    [anon_sym_UR_DQUOTE] = ACTIONS(2396),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2396),
    [anon_sym_co_await] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_requires] = ACTIONS(2394),
    [sym_this] = ACTIONS(2394),
    [anon_sym_discard] = ACTIONS(2394),
    [anon_sym_precise] = ACTIONS(2394),
    [anon_sym_shared] = ACTIONS(2394),
    [anon_sym_groupshared] = ACTIONS(2394),
    [anon_sym_uniform] = ACTIONS(2394),
    [anon_sym_row_major] = ACTIONS(2394),
    [anon_sym_column_major] = ACTIONS(2394),
    [anon_sym_globallycoherent] = ACTIONS(2394),
    [anon_sym_centroid] = ACTIONS(2394),
    [anon_sym_noperspective] = ACTIONS(2394),
    [anon_sym_nointerpolation] = ACTIONS(2394),
    [anon_sym_sample] = ACTIONS(2394),
    [anon_sym_linear] = ACTIONS(2394),
    [anon_sym_snorm] = ACTIONS(2394),
    [anon_sym_unorm] = ACTIONS(2394),
    [anon_sym_point] = ACTIONS(2394),
    [anon_sym_line] = ACTIONS(2394),
    [anon_sym_triangleadj] = ACTIONS(2394),
    [anon_sym_lineadj] = ACTIONS(2394),
    [anon_sym_triangle] = ACTIONS(2394),
    [anon_sym_cbuffer] = ACTIONS(2394),
  },
  [1085] = {
    [sym_identifier] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_goto] = ACTIONS(2382),
    [anon_sym___try] = ACTIONS(2382),
    [anon_sym___leave] = ACTIONS(2382),
    [anon_sym_not] = ACTIONS(2382),
    [anon_sym_compl] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2382),
    [anon_sym___alignof__] = ACTIONS(2382),
    [anon_sym___alignof] = ACTIONS(2382),
    [anon_sym__alignof] = ACTIONS(2382),
    [anon_sym_alignof] = ACTIONS(2382),
    [anon_sym__Alignof] = ACTIONS(2382),
    [anon_sym_offsetof] = ACTIONS(2382),
    [anon_sym__Generic] = ACTIONS(2382),
    [anon_sym_asm] = ACTIONS(2382),
    [anon_sym___asm__] = ACTIONS(2382),
    [anon_sym___asm] = ACTIONS(2382),
    [sym_number_literal] = ACTIONS(2384),
    [anon_sym_L_SQUOTE] = ACTIONS(2384),
    [anon_sym_u_SQUOTE] = ACTIONS(2384),
    [anon_sym_U_SQUOTE] = ACTIONS(2384),
    [anon_sym_u8_SQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_L_DQUOTE] = ACTIONS(2384),
    [anon_sym_u_DQUOTE] = ACTIONS(2384),
    [anon_sym_U_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8_DQUOTE] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [anon_sym_NULL] = ACTIONS(2382),
    [anon_sym_nullptr] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_co_return] = ACTIONS(2382),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2384),
    [anon_sym_LR_DQUOTE] = ACTIONS(2384),
    [anon_sym_uR_DQUOTE] = ACTIONS(2384),
    [anon_sym_UR_DQUOTE] = ACTIONS(2384),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2384),
    [anon_sym_co_await] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_requires] = ACTIONS(2382),
    [sym_this] = ACTIONS(2382),
    [anon_sym_discard] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
    [anon_sym_cbuffer] = ACTIONS(2382),
  },
  [1086] = {
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_BANG] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_PLUS] = ACTIONS(2242),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2244),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym_LBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_else] = ACTIONS(2242),
    [anon_sym_switch] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [anon_sym_do] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_goto] = ACTIONS(2242),
    [anon_sym___try] = ACTIONS(2242),
    [anon_sym___leave] = ACTIONS(2242),
    [anon_sym_not] = ACTIONS(2242),
    [anon_sym_compl] = ACTIONS(2242),
    [anon_sym_DASH_DASH] = ACTIONS(2244),
    [anon_sym_PLUS_PLUS] = ACTIONS(2244),
    [anon_sym_sizeof] = ACTIONS(2242),
    [anon_sym___alignof__] = ACTIONS(2242),
    [anon_sym___alignof] = ACTIONS(2242),
    [anon_sym__alignof] = ACTIONS(2242),
    [anon_sym_alignof] = ACTIONS(2242),
    [anon_sym__Alignof] = ACTIONS(2242),
    [anon_sym_offsetof] = ACTIONS(2242),
    [anon_sym__Generic] = ACTIONS(2242),
    [anon_sym_asm] = ACTIONS(2242),
    [anon_sym___asm__] = ACTIONS(2242),
    [anon_sym___asm] = ACTIONS(2242),
    [sym_number_literal] = ACTIONS(2244),
    [anon_sym_L_SQUOTE] = ACTIONS(2244),
    [anon_sym_u_SQUOTE] = ACTIONS(2244),
    [anon_sym_U_SQUOTE] = ACTIONS(2244),
    [anon_sym_u8_SQUOTE] = ACTIONS(2244),
    [anon_sym_SQUOTE] = ACTIONS(2244),
    [anon_sym_L_DQUOTE] = ACTIONS(2244),
    [anon_sym_u_DQUOTE] = ACTIONS(2244),
    [anon_sym_U_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8_DQUOTE] = ACTIONS(2244),
    [anon_sym_DQUOTE] = ACTIONS(2244),
    [sym_true] = ACTIONS(2242),
    [sym_false] = ACTIONS(2242),
    [anon_sym_NULL] = ACTIONS(2242),
    [anon_sym_nullptr] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_try] = ACTIONS(2242),
    [anon_sym_delete] = ACTIONS(2242),
    [anon_sym_throw] = ACTIONS(2242),
    [anon_sym_co_return] = ACTIONS(2242),
    [anon_sym_co_yield] = ACTIONS(2242),
    [anon_sym_R_DQUOTE] = ACTIONS(2244),
    [anon_sym_LR_DQUOTE] = ACTIONS(2244),
    [anon_sym_uR_DQUOTE] = ACTIONS(2244),
    [anon_sym_UR_DQUOTE] = ACTIONS(2244),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2244),
    [anon_sym_co_await] = ACTIONS(2242),
    [anon_sym_new] = ACTIONS(2242),
    [anon_sym_requires] = ACTIONS(2242),
    [sym_this] = ACTIONS(2242),
    [anon_sym_discard] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
    [anon_sym_cbuffer] = ACTIONS(2242),
  },
  [1087] = {
    [sym_identifier] = ACTIONS(2270),
    [anon_sym_LPAREN2] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2270),
    [anon_sym_PLUS] = ACTIONS(2270),
    [anon_sym_STAR] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2270),
    [anon_sym_typedef] = ACTIONS(2270),
    [anon_sym_in] = ACTIONS(2270),
    [anon_sym_out] = ACTIONS(2270),
    [anon_sym_inout] = ACTIONS(2270),
    [anon_sym_virtual] = ACTIONS(2270),
    [anon_sym_extern] = ACTIONS(2270),
    [anon_sym___attribute__] = ACTIONS(2270),
    [anon_sym___attribute] = ACTIONS(2270),
    [anon_sym_COLON_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2272),
    [anon_sym___declspec] = ACTIONS(2270),
    [anon_sym_LBRACE] = ACTIONS(2272),
    [anon_sym_signed] = ACTIONS(2270),
    [anon_sym_unsigned] = ACTIONS(2270),
    [anon_sym_long] = ACTIONS(2270),
    [anon_sym_short] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_static] = ACTIONS(2270),
    [anon_sym_register] = ACTIONS(2270),
    [anon_sym_inline] = ACTIONS(2270),
    [anon_sym___inline] = ACTIONS(2270),
    [anon_sym___inline__] = ACTIONS(2270),
    [anon_sym___forceinline] = ACTIONS(2270),
    [anon_sym_thread_local] = ACTIONS(2270),
    [anon_sym___thread] = ACTIONS(2270),
    [anon_sym_const] = ACTIONS(2270),
    [anon_sym_constexpr] = ACTIONS(2270),
    [anon_sym_volatile] = ACTIONS(2270),
    [anon_sym_restrict] = ACTIONS(2270),
    [anon_sym___restrict__] = ACTIONS(2270),
    [anon_sym__Atomic] = ACTIONS(2270),
    [anon_sym__Noreturn] = ACTIONS(2270),
    [anon_sym_noreturn] = ACTIONS(2270),
    [anon_sym__Nonnull] = ACTIONS(2270),
    [anon_sym_mutable] = ACTIONS(2270),
    [anon_sym_constinit] = ACTIONS(2270),
    [anon_sym_consteval] = ACTIONS(2270),
    [anon_sym_alignas] = ACTIONS(2270),
    [anon_sym__Alignas] = ACTIONS(2270),
    [sym_primitive_type] = ACTIONS(2270),
    [anon_sym_enum] = ACTIONS(2270),
    [anon_sym_class] = ACTIONS(2270),
    [anon_sym_struct] = ACTIONS(2270),
    [anon_sym_union] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_switch] = ACTIONS(2270),
    [anon_sym_while] = ACTIONS(2270),
    [anon_sym_do] = ACTIONS(2270),
    [anon_sym_for] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2270),
    [anon_sym_break] = ACTIONS(2270),
    [anon_sym_continue] = ACTIONS(2270),
    [anon_sym_goto] = ACTIONS(2270),
    [anon_sym___try] = ACTIONS(2270),
    [anon_sym___leave] = ACTIONS(2270),
    [anon_sym_not] = ACTIONS(2270),
    [anon_sym_compl] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2270),
    [anon_sym___alignof__] = ACTIONS(2270),
    [anon_sym___alignof] = ACTIONS(2270),
    [anon_sym__alignof] = ACTIONS(2270),
    [anon_sym_alignof] = ACTIONS(2270),
    [anon_sym__Alignof] = ACTIONS(2270),
    [anon_sym_offsetof] = ACTIONS(2270),
    [anon_sym__Generic] = ACTIONS(2270),
    [anon_sym_asm] = ACTIONS(2270),
    [anon_sym___asm__] = ACTIONS(2270),
    [anon_sym___asm] = ACTIONS(2270),
    [sym_number_literal] = ACTIONS(2272),
    [anon_sym_L_SQUOTE] = ACTIONS(2272),
    [anon_sym_u_SQUOTE] = ACTIONS(2272),
    [anon_sym_U_SQUOTE] = ACTIONS(2272),
    [anon_sym_u8_SQUOTE] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2272),
    [anon_sym_L_DQUOTE] = ACTIONS(2272),
    [anon_sym_u_DQUOTE] = ACTIONS(2272),
    [anon_sym_U_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8_DQUOTE] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2272),
    [sym_true] = ACTIONS(2270),
    [sym_false] = ACTIONS(2270),
    [anon_sym_NULL] = ACTIONS(2270),
    [anon_sym_nullptr] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2270),
    [anon_sym_decltype] = ACTIONS(2270),
    [anon_sym_typename] = ACTIONS(2270),
    [anon_sym_template] = ACTIONS(2270),
    [anon_sym_try] = ACTIONS(2270),
    [anon_sym_delete] = ACTIONS(2270),
    [anon_sym_throw] = ACTIONS(2270),
    [anon_sym_co_return] = ACTIONS(2270),
    [anon_sym_co_yield] = ACTIONS(2270),
    [anon_sym_R_DQUOTE] = ACTIONS(2272),
    [anon_sym_LR_DQUOTE] = ACTIONS(2272),
    [anon_sym_uR_DQUOTE] = ACTIONS(2272),
    [anon_sym_UR_DQUOTE] = ACTIONS(2272),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2272),
    [anon_sym_co_await] = ACTIONS(2270),
    [anon_sym_new] = ACTIONS(2270),
    [anon_sym_requires] = ACTIONS(2270),
    [sym_this] = ACTIONS(2270),
    [anon_sym_discard] = ACTIONS(2270),
    [anon_sym_precise] = ACTIONS(2270),
    [anon_sym_shared] = ACTIONS(2270),
    [anon_sym_groupshared] = ACTIONS(2270),
    [anon_sym_uniform] = ACTIONS(2270),
    [anon_sym_row_major] = ACTIONS(2270),
    [anon_sym_column_major] = ACTIONS(2270),
    [anon_sym_globallycoherent] = ACTIONS(2270),
    [anon_sym_centroid] = ACTIONS(2270),
    [anon_sym_noperspective] = ACTIONS(2270),
    [anon_sym_nointerpolation] = ACTIONS(2270),
    [anon_sym_sample] = ACTIONS(2270),
    [anon_sym_linear] = ACTIONS(2270),
    [anon_sym_snorm] = ACTIONS(2270),
    [anon_sym_unorm] = ACTIONS(2270),
    [anon_sym_point] = ACTIONS(2270),
    [anon_sym_line] = ACTIONS(2270),
    [anon_sym_triangleadj] = ACTIONS(2270),
    [anon_sym_lineadj] = ACTIONS(2270),
    [anon_sym_triangle] = ACTIONS(2270),
    [anon_sym_cbuffer] = ACTIONS(2270),
  },
  [1088] = {
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN2] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2276),
    [anon_sym_TILDE] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2274),
    [anon_sym_PLUS] = ACTIONS(2274),
    [anon_sym_STAR] = ACTIONS(2276),
    [anon_sym_AMP] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2276),
    [anon_sym___extension__] = ACTIONS(2274),
    [anon_sym_typedef] = ACTIONS(2274),
    [anon_sym_in] = ACTIONS(2274),
    [anon_sym_out] = ACTIONS(2274),
    [anon_sym_inout] = ACTIONS(2274),
    [anon_sym_virtual] = ACTIONS(2274),
    [anon_sym_extern] = ACTIONS(2274),
    [anon_sym___attribute__] = ACTIONS(2274),
    [anon_sym___attribute] = ACTIONS(2274),
    [anon_sym_COLON_COLON] = ACTIONS(2276),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2276),
    [anon_sym___declspec] = ACTIONS(2274),
    [anon_sym_LBRACE] = ACTIONS(2276),
    [anon_sym_signed] = ACTIONS(2274),
    [anon_sym_unsigned] = ACTIONS(2274),
    [anon_sym_long] = ACTIONS(2274),
    [anon_sym_short] = ACTIONS(2274),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2274),
    [anon_sym_register] = ACTIONS(2274),
    [anon_sym_inline] = ACTIONS(2274),
    [anon_sym___inline] = ACTIONS(2274),
    [anon_sym___inline__] = ACTIONS(2274),
    [anon_sym___forceinline] = ACTIONS(2274),
    [anon_sym_thread_local] = ACTIONS(2274),
    [anon_sym___thread] = ACTIONS(2274),
    [anon_sym_const] = ACTIONS(2274),
    [anon_sym_constexpr] = ACTIONS(2274),
    [anon_sym_volatile] = ACTIONS(2274),
    [anon_sym_restrict] = ACTIONS(2274),
    [anon_sym___restrict__] = ACTIONS(2274),
    [anon_sym__Atomic] = ACTIONS(2274),
    [anon_sym__Noreturn] = ACTIONS(2274),
    [anon_sym_noreturn] = ACTIONS(2274),
    [anon_sym__Nonnull] = ACTIONS(2274),
    [anon_sym_mutable] = ACTIONS(2274),
    [anon_sym_constinit] = ACTIONS(2274),
    [anon_sym_consteval] = ACTIONS(2274),
    [anon_sym_alignas] = ACTIONS(2274),
    [anon_sym__Alignas] = ACTIONS(2274),
    [sym_primitive_type] = ACTIONS(2274),
    [anon_sym_enum] = ACTIONS(2274),
    [anon_sym_class] = ACTIONS(2274),
    [anon_sym_struct] = ACTIONS(2274),
    [anon_sym_union] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2274),
    [anon_sym_switch] = ACTIONS(2274),
    [anon_sym_while] = ACTIONS(2274),
    [anon_sym_do] = ACTIONS(2274),
    [anon_sym_for] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2274),
    [anon_sym_break] = ACTIONS(2274),
    [anon_sym_continue] = ACTIONS(2274),
    [anon_sym_goto] = ACTIONS(2274),
    [anon_sym___try] = ACTIONS(2274),
    [anon_sym___leave] = ACTIONS(2274),
    [anon_sym_not] = ACTIONS(2274),
    [anon_sym_compl] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2276),
    [anon_sym_PLUS_PLUS] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2274),
    [anon_sym___alignof__] = ACTIONS(2274),
    [anon_sym___alignof] = ACTIONS(2274),
    [anon_sym__alignof] = ACTIONS(2274),
    [anon_sym_alignof] = ACTIONS(2274),
    [anon_sym__Alignof] = ACTIONS(2274),
    [anon_sym_offsetof] = ACTIONS(2274),
    [anon_sym__Generic] = ACTIONS(2274),
    [anon_sym_asm] = ACTIONS(2274),
    [anon_sym___asm__] = ACTIONS(2274),
    [anon_sym___asm] = ACTIONS(2274),
    [sym_number_literal] = ACTIONS(2276),
    [anon_sym_L_SQUOTE] = ACTIONS(2276),
    [anon_sym_u_SQUOTE] = ACTIONS(2276),
    [anon_sym_U_SQUOTE] = ACTIONS(2276),
    [anon_sym_u8_SQUOTE] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2276),
    [anon_sym_L_DQUOTE] = ACTIONS(2276),
    [anon_sym_u_DQUOTE] = ACTIONS(2276),
    [anon_sym_U_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8_DQUOTE] = ACTIONS(2276),
    [anon_sym_DQUOTE] = ACTIONS(2276),
    [sym_true] = ACTIONS(2274),
    [sym_false] = ACTIONS(2274),
    [anon_sym_NULL] = ACTIONS(2274),
    [anon_sym_nullptr] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2274),
    [anon_sym_decltype] = ACTIONS(2274),
    [anon_sym_typename] = ACTIONS(2274),
    [anon_sym_template] = ACTIONS(2274),
    [anon_sym_try] = ACTIONS(2274),
    [anon_sym_delete] = ACTIONS(2274),
    [anon_sym_throw] = ACTIONS(2274),
    [anon_sym_co_return] = ACTIONS(2274),
    [anon_sym_co_yield] = ACTIONS(2274),
    [anon_sym_R_DQUOTE] = ACTIONS(2276),
    [anon_sym_LR_DQUOTE] = ACTIONS(2276),
    [anon_sym_uR_DQUOTE] = ACTIONS(2276),
    [anon_sym_UR_DQUOTE] = ACTIONS(2276),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2276),
    [anon_sym_co_await] = ACTIONS(2274),
    [anon_sym_new] = ACTIONS(2274),
    [anon_sym_requires] = ACTIONS(2274),
    [sym_this] = ACTIONS(2274),
    [anon_sym_discard] = ACTIONS(2274),
    [anon_sym_precise] = ACTIONS(2274),
    [anon_sym_shared] = ACTIONS(2274),
    [anon_sym_groupshared] = ACTIONS(2274),
    [anon_sym_uniform] = ACTIONS(2274),
    [anon_sym_row_major] = ACTIONS(2274),
    [anon_sym_column_major] = ACTIONS(2274),
    [anon_sym_globallycoherent] = ACTIONS(2274),
    [anon_sym_centroid] = ACTIONS(2274),
    [anon_sym_noperspective] = ACTIONS(2274),
    [anon_sym_nointerpolation] = ACTIONS(2274),
    [anon_sym_sample] = ACTIONS(2274),
    [anon_sym_linear] = ACTIONS(2274),
    [anon_sym_snorm] = ACTIONS(2274),
    [anon_sym_unorm] = ACTIONS(2274),
    [anon_sym_point] = ACTIONS(2274),
    [anon_sym_line] = ACTIONS(2274),
    [anon_sym_triangleadj] = ACTIONS(2274),
    [anon_sym_lineadj] = ACTIONS(2274),
    [anon_sym_triangle] = ACTIONS(2274),
    [anon_sym_cbuffer] = ACTIONS(2274),
  },
  [1089] = {
    [sym_identifier] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_PLUS] = ACTIONS(2266),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym_LBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(2266),
    [anon_sym_else] = ACTIONS(2266),
    [anon_sym_switch] = ACTIONS(2266),
    [anon_sym_while] = ACTIONS(2266),
    [anon_sym_do] = ACTIONS(2266),
    [anon_sym_for] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2266),
    [anon_sym_break] = ACTIONS(2266),
    [anon_sym_continue] = ACTIONS(2266),
    [anon_sym_goto] = ACTIONS(2266),
    [anon_sym___try] = ACTIONS(2266),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2266),
    [anon_sym_compl] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2268),
    [anon_sym_PLUS_PLUS] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2266),
    [anon_sym___alignof__] = ACTIONS(2266),
    [anon_sym___alignof] = ACTIONS(2266),
    [anon_sym__alignof] = ACTIONS(2266),
    [anon_sym_alignof] = ACTIONS(2266),
    [anon_sym__Alignof] = ACTIONS(2266),
    [anon_sym_offsetof] = ACTIONS(2266),
    [anon_sym__Generic] = ACTIONS(2266),
    [anon_sym_asm] = ACTIONS(2266),
    [anon_sym___asm__] = ACTIONS(2266),
    [anon_sym___asm] = ACTIONS(2266),
    [sym_number_literal] = ACTIONS(2268),
    [anon_sym_L_SQUOTE] = ACTIONS(2268),
    [anon_sym_u_SQUOTE] = ACTIONS(2268),
    [anon_sym_U_SQUOTE] = ACTIONS(2268),
    [anon_sym_u8_SQUOTE] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2268),
    [anon_sym_L_DQUOTE] = ACTIONS(2268),
    [anon_sym_u_DQUOTE] = ACTIONS(2268),
    [anon_sym_U_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8_DQUOTE] = ACTIONS(2268),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym_true] = ACTIONS(2266),
    [sym_false] = ACTIONS(2266),
    [anon_sym_NULL] = ACTIONS(2266),
    [anon_sym_nullptr] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_try] = ACTIONS(2266),
    [anon_sym_delete] = ACTIONS(2266),
    [anon_sym_throw] = ACTIONS(2266),
    [anon_sym_co_return] = ACTIONS(2266),
    [anon_sym_co_yield] = ACTIONS(2266),
    [anon_sym_R_DQUOTE] = ACTIONS(2268),
    [anon_sym_LR_DQUOTE] = ACTIONS(2268),
    [anon_sym_uR_DQUOTE] = ACTIONS(2268),
    [anon_sym_UR_DQUOTE] = ACTIONS(2268),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2268),
    [anon_sym_co_await] = ACTIONS(2266),
    [anon_sym_new] = ACTIONS(2266),
    [anon_sym_requires] = ACTIONS(2266),
    [sym_this] = ACTIONS(2266),
    [anon_sym_discard] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
    [anon_sym_cbuffer] = ACTIONS(2266),
  },
  [1090] = {
    [sym_identifier] = ACTIONS(2278),
    [anon_sym_LPAREN2] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2280),
    [anon_sym_TILDE] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2278),
    [anon_sym_PLUS] = ACTIONS(2278),
    [anon_sym_STAR] = ACTIONS(2280),
    [anon_sym_AMP] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2280),
    [anon_sym___extension__] = ACTIONS(2278),
    [anon_sym_typedef] = ACTIONS(2278),
    [anon_sym_in] = ACTIONS(2278),
    [anon_sym_out] = ACTIONS(2278),
    [anon_sym_inout] = ACTIONS(2278),
    [anon_sym_virtual] = ACTIONS(2278),
    [anon_sym_extern] = ACTIONS(2278),
    [anon_sym___attribute__] = ACTIONS(2278),
    [anon_sym___attribute] = ACTIONS(2278),
    [anon_sym_COLON_COLON] = ACTIONS(2280),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2280),
    [anon_sym___declspec] = ACTIONS(2278),
    [anon_sym_LBRACE] = ACTIONS(2280),
    [anon_sym_signed] = ACTIONS(2278),
    [anon_sym_unsigned] = ACTIONS(2278),
    [anon_sym_long] = ACTIONS(2278),
    [anon_sym_short] = ACTIONS(2278),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_static] = ACTIONS(2278),
    [anon_sym_register] = ACTIONS(2278),
    [anon_sym_inline] = ACTIONS(2278),
    [anon_sym___inline] = ACTIONS(2278),
    [anon_sym___inline__] = ACTIONS(2278),
    [anon_sym___forceinline] = ACTIONS(2278),
    [anon_sym_thread_local] = ACTIONS(2278),
    [anon_sym___thread] = ACTIONS(2278),
    [anon_sym_const] = ACTIONS(2278),
    [anon_sym_constexpr] = ACTIONS(2278),
    [anon_sym_volatile] = ACTIONS(2278),
    [anon_sym_restrict] = ACTIONS(2278),
    [anon_sym___restrict__] = ACTIONS(2278),
    [anon_sym__Atomic] = ACTIONS(2278),
    [anon_sym__Noreturn] = ACTIONS(2278),
    [anon_sym_noreturn] = ACTIONS(2278),
    [anon_sym__Nonnull] = ACTIONS(2278),
    [anon_sym_mutable] = ACTIONS(2278),
    [anon_sym_constinit] = ACTIONS(2278),
    [anon_sym_consteval] = ACTIONS(2278),
    [anon_sym_alignas] = ACTIONS(2278),
    [anon_sym__Alignas] = ACTIONS(2278),
    [sym_primitive_type] = ACTIONS(2278),
    [anon_sym_enum] = ACTIONS(2278),
    [anon_sym_class] = ACTIONS(2278),
    [anon_sym_struct] = ACTIONS(2278),
    [anon_sym_union] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_else] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2278),
    [anon_sym_while] = ACTIONS(2278),
    [anon_sym_do] = ACTIONS(2278),
    [anon_sym_for] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2278),
    [anon_sym_break] = ACTIONS(2278),
    [anon_sym_continue] = ACTIONS(2278),
    [anon_sym_goto] = ACTIONS(2278),
    [anon_sym___try] = ACTIONS(2278),
    [anon_sym___leave] = ACTIONS(2278),
    [anon_sym_not] = ACTIONS(2278),
    [anon_sym_compl] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2280),
    [anon_sym_PLUS_PLUS] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2278),
    [anon_sym___alignof__] = ACTIONS(2278),
    [anon_sym___alignof] = ACTIONS(2278),
    [anon_sym__alignof] = ACTIONS(2278),
    [anon_sym_alignof] = ACTIONS(2278),
    [anon_sym__Alignof] = ACTIONS(2278),
    [anon_sym_offsetof] = ACTIONS(2278),
    [anon_sym__Generic] = ACTIONS(2278),
    [anon_sym_asm] = ACTIONS(2278),
    [anon_sym___asm__] = ACTIONS(2278),
    [anon_sym___asm] = ACTIONS(2278),
    [sym_number_literal] = ACTIONS(2280),
    [anon_sym_L_SQUOTE] = ACTIONS(2280),
    [anon_sym_u_SQUOTE] = ACTIONS(2280),
    [anon_sym_U_SQUOTE] = ACTIONS(2280),
    [anon_sym_u8_SQUOTE] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2280),
    [anon_sym_L_DQUOTE] = ACTIONS(2280),
    [anon_sym_u_DQUOTE] = ACTIONS(2280),
    [anon_sym_U_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8_DQUOTE] = ACTIONS(2280),
    [anon_sym_DQUOTE] = ACTIONS(2280),
    [sym_true] = ACTIONS(2278),
    [sym_false] = ACTIONS(2278),
    [anon_sym_NULL] = ACTIONS(2278),
    [anon_sym_nullptr] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2278),
    [anon_sym_decltype] = ACTIONS(2278),
    [anon_sym_typename] = ACTIONS(2278),
    [anon_sym_template] = ACTIONS(2278),
    [anon_sym_try] = ACTIONS(2278),
    [anon_sym_delete] = ACTIONS(2278),
    [anon_sym_throw] = ACTIONS(2278),
    [anon_sym_co_return] = ACTIONS(2278),
    [anon_sym_co_yield] = ACTIONS(2278),
    [anon_sym_R_DQUOTE] = ACTIONS(2280),
    [anon_sym_LR_DQUOTE] = ACTIONS(2280),
    [anon_sym_uR_DQUOTE] = ACTIONS(2280),
    [anon_sym_UR_DQUOTE] = ACTIONS(2280),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2280),
    [anon_sym_co_await] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(2278),
    [anon_sym_requires] = ACTIONS(2278),
    [sym_this] = ACTIONS(2278),
    [anon_sym_discard] = ACTIONS(2278),
    [anon_sym_precise] = ACTIONS(2278),
    [anon_sym_shared] = ACTIONS(2278),
    [anon_sym_groupshared] = ACTIONS(2278),
    [anon_sym_uniform] = ACTIONS(2278),
    [anon_sym_row_major] = ACTIONS(2278),
    [anon_sym_column_major] = ACTIONS(2278),
    [anon_sym_globallycoherent] = ACTIONS(2278),
    [anon_sym_centroid] = ACTIONS(2278),
    [anon_sym_noperspective] = ACTIONS(2278),
    [anon_sym_nointerpolation] = ACTIONS(2278),
    [anon_sym_sample] = ACTIONS(2278),
    [anon_sym_linear] = ACTIONS(2278),
    [anon_sym_snorm] = ACTIONS(2278),
    [anon_sym_unorm] = ACTIONS(2278),
    [anon_sym_point] = ACTIONS(2278),
    [anon_sym_line] = ACTIONS(2278),
    [anon_sym_triangleadj] = ACTIONS(2278),
    [anon_sym_lineadj] = ACTIONS(2278),
    [anon_sym_triangle] = ACTIONS(2278),
    [anon_sym_cbuffer] = ACTIONS(2278),
  },
  [1091] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4846),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8522),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1092] = {
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_LPAREN2] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_STAR] = ACTIONS(2364),
    [anon_sym_AMP] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym___extension__] = ACTIONS(2362),
    [anon_sym_typedef] = ACTIONS(2362),
    [anon_sym_in] = ACTIONS(2362),
    [anon_sym_out] = ACTIONS(2362),
    [anon_sym_inout] = ACTIONS(2362),
    [anon_sym_virtual] = ACTIONS(2362),
    [anon_sym_extern] = ACTIONS(2362),
    [anon_sym___attribute__] = ACTIONS(2362),
    [anon_sym___attribute] = ACTIONS(2362),
    [anon_sym_COLON_COLON] = ACTIONS(2364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2364),
    [anon_sym___declspec] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_signed] = ACTIONS(2362),
    [anon_sym_unsigned] = ACTIONS(2362),
    [anon_sym_long] = ACTIONS(2362),
    [anon_sym_short] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_register] = ACTIONS(2362),
    [anon_sym_inline] = ACTIONS(2362),
    [anon_sym___inline] = ACTIONS(2362),
    [anon_sym___inline__] = ACTIONS(2362),
    [anon_sym___forceinline] = ACTIONS(2362),
    [anon_sym_thread_local] = ACTIONS(2362),
    [anon_sym___thread] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_constexpr] = ACTIONS(2362),
    [anon_sym_volatile] = ACTIONS(2362),
    [anon_sym_restrict] = ACTIONS(2362),
    [anon_sym___restrict__] = ACTIONS(2362),
    [anon_sym__Atomic] = ACTIONS(2362),
    [anon_sym__Noreturn] = ACTIONS(2362),
    [anon_sym_noreturn] = ACTIONS(2362),
    [anon_sym__Nonnull] = ACTIONS(2362),
    [anon_sym_mutable] = ACTIONS(2362),
    [anon_sym_constinit] = ACTIONS(2362),
    [anon_sym_consteval] = ACTIONS(2362),
    [anon_sym_alignas] = ACTIONS(2362),
    [anon_sym__Alignas] = ACTIONS(2362),
    [sym_primitive_type] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_struct] = ACTIONS(2362),
    [anon_sym_union] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_goto] = ACTIONS(2362),
    [anon_sym___try] = ACTIONS(2362),
    [anon_sym___leave] = ACTIONS(2362),
    [anon_sym_not] = ACTIONS(2362),
    [anon_sym_compl] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2362),
    [anon_sym___alignof__] = ACTIONS(2362),
    [anon_sym___alignof] = ACTIONS(2362),
    [anon_sym__alignof] = ACTIONS(2362),
    [anon_sym_alignof] = ACTIONS(2362),
    [anon_sym__Alignof] = ACTIONS(2362),
    [anon_sym_offsetof] = ACTIONS(2362),
    [anon_sym__Generic] = ACTIONS(2362),
    [anon_sym_asm] = ACTIONS(2362),
    [anon_sym___asm__] = ACTIONS(2362),
    [anon_sym___asm] = ACTIONS(2362),
    [sym_number_literal] = ACTIONS(2364),
    [anon_sym_L_SQUOTE] = ACTIONS(2364),
    [anon_sym_u_SQUOTE] = ACTIONS(2364),
    [anon_sym_U_SQUOTE] = ACTIONS(2364),
    [anon_sym_u8_SQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_L_DQUOTE] = ACTIONS(2364),
    [anon_sym_u_DQUOTE] = ACTIONS(2364),
    [anon_sym_U_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8_DQUOTE] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [anon_sym_NULL] = ACTIONS(2362),
    [anon_sym_nullptr] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2362),
    [anon_sym_decltype] = ACTIONS(2362),
    [anon_sym_typename] = ACTIONS(2362),
    [anon_sym_template] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_co_return] = ACTIONS(2362),
    [anon_sym_co_yield] = ACTIONS(2362),
    [anon_sym_R_DQUOTE] = ACTIONS(2364),
    [anon_sym_LR_DQUOTE] = ACTIONS(2364),
    [anon_sym_uR_DQUOTE] = ACTIONS(2364),
    [anon_sym_UR_DQUOTE] = ACTIONS(2364),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2364),
    [anon_sym_co_await] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_requires] = ACTIONS(2362),
    [sym_this] = ACTIONS(2362),
    [anon_sym_discard] = ACTIONS(2362),
    [anon_sym_precise] = ACTIONS(2362),
    [anon_sym_shared] = ACTIONS(2362),
    [anon_sym_groupshared] = ACTIONS(2362),
    [anon_sym_uniform] = ACTIONS(2362),
    [anon_sym_row_major] = ACTIONS(2362),
    [anon_sym_column_major] = ACTIONS(2362),
    [anon_sym_globallycoherent] = ACTIONS(2362),
    [anon_sym_centroid] = ACTIONS(2362),
    [anon_sym_noperspective] = ACTIONS(2362),
    [anon_sym_nointerpolation] = ACTIONS(2362),
    [anon_sym_sample] = ACTIONS(2362),
    [anon_sym_linear] = ACTIONS(2362),
    [anon_sym_snorm] = ACTIONS(2362),
    [anon_sym_unorm] = ACTIONS(2362),
    [anon_sym_point] = ACTIONS(2362),
    [anon_sym_line] = ACTIONS(2362),
    [anon_sym_triangleadj] = ACTIONS(2362),
    [anon_sym_lineadj] = ACTIONS(2362),
    [anon_sym_triangle] = ACTIONS(2362),
    [anon_sym_cbuffer] = ACTIONS(2362),
  },
  [1093] = {
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_LPAREN2] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym___extension__] = ACTIONS(2390),
    [anon_sym_typedef] = ACTIONS(2390),
    [anon_sym_in] = ACTIONS(2390),
    [anon_sym_out] = ACTIONS(2390),
    [anon_sym_inout] = ACTIONS(2390),
    [anon_sym_virtual] = ACTIONS(2390),
    [anon_sym_extern] = ACTIONS(2390),
    [anon_sym___attribute__] = ACTIONS(2390),
    [anon_sym___attribute] = ACTIONS(2390),
    [anon_sym_COLON_COLON] = ACTIONS(2392),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2392),
    [anon_sym___declspec] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_signed] = ACTIONS(2390),
    [anon_sym_unsigned] = ACTIONS(2390),
    [anon_sym_long] = ACTIONS(2390),
    [anon_sym_short] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_register] = ACTIONS(2390),
    [anon_sym_inline] = ACTIONS(2390),
    [anon_sym___inline] = ACTIONS(2390),
    [anon_sym___inline__] = ACTIONS(2390),
    [anon_sym___forceinline] = ACTIONS(2390),
    [anon_sym_thread_local] = ACTIONS(2390),
    [anon_sym___thread] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_constexpr] = ACTIONS(2390),
    [anon_sym_volatile] = ACTIONS(2390),
    [anon_sym_restrict] = ACTIONS(2390),
    [anon_sym___restrict__] = ACTIONS(2390),
    [anon_sym__Atomic] = ACTIONS(2390),
    [anon_sym__Noreturn] = ACTIONS(2390),
    [anon_sym_noreturn] = ACTIONS(2390),
    [anon_sym__Nonnull] = ACTIONS(2390),
    [anon_sym_mutable] = ACTIONS(2390),
    [anon_sym_constinit] = ACTIONS(2390),
    [anon_sym_consteval] = ACTIONS(2390),
    [anon_sym_alignas] = ACTIONS(2390),
    [anon_sym__Alignas] = ACTIONS(2390),
    [sym_primitive_type] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_struct] = ACTIONS(2390),
    [anon_sym_union] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_goto] = ACTIONS(2390),
    [anon_sym___try] = ACTIONS(2390),
    [anon_sym___leave] = ACTIONS(2390),
    [anon_sym_not] = ACTIONS(2390),
    [anon_sym_compl] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2390),
    [anon_sym___alignof__] = ACTIONS(2390),
    [anon_sym___alignof] = ACTIONS(2390),
    [anon_sym__alignof] = ACTIONS(2390),
    [anon_sym_alignof] = ACTIONS(2390),
    [anon_sym__Alignof] = ACTIONS(2390),
    [anon_sym_offsetof] = ACTIONS(2390),
    [anon_sym__Generic] = ACTIONS(2390),
    [anon_sym_asm] = ACTIONS(2390),
    [anon_sym___asm__] = ACTIONS(2390),
    [anon_sym___asm] = ACTIONS(2390),
    [sym_number_literal] = ACTIONS(2392),
    [anon_sym_L_SQUOTE] = ACTIONS(2392),
    [anon_sym_u_SQUOTE] = ACTIONS(2392),
    [anon_sym_U_SQUOTE] = ACTIONS(2392),
    [anon_sym_u8_SQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_L_DQUOTE] = ACTIONS(2392),
    [anon_sym_u_DQUOTE] = ACTIONS(2392),
    [anon_sym_U_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8_DQUOTE] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [anon_sym_NULL] = ACTIONS(2390),
    [anon_sym_nullptr] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2390),
    [anon_sym_decltype] = ACTIONS(2390),
    [anon_sym_typename] = ACTIONS(2390),
    [anon_sym_template] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_co_return] = ACTIONS(2390),
    [anon_sym_co_yield] = ACTIONS(2390),
    [anon_sym_R_DQUOTE] = ACTIONS(2392),
    [anon_sym_LR_DQUOTE] = ACTIONS(2392),
    [anon_sym_uR_DQUOTE] = ACTIONS(2392),
    [anon_sym_UR_DQUOTE] = ACTIONS(2392),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2392),
    [anon_sym_co_await] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_requires] = ACTIONS(2390),
    [sym_this] = ACTIONS(2390),
    [anon_sym_discard] = ACTIONS(2390),
    [anon_sym_precise] = ACTIONS(2390),
    [anon_sym_shared] = ACTIONS(2390),
    [anon_sym_groupshared] = ACTIONS(2390),
    [anon_sym_uniform] = ACTIONS(2390),
    [anon_sym_row_major] = ACTIONS(2390),
    [anon_sym_column_major] = ACTIONS(2390),
    [anon_sym_globallycoherent] = ACTIONS(2390),
    [anon_sym_centroid] = ACTIONS(2390),
    [anon_sym_noperspective] = ACTIONS(2390),
    [anon_sym_nointerpolation] = ACTIONS(2390),
    [anon_sym_sample] = ACTIONS(2390),
    [anon_sym_linear] = ACTIONS(2390),
    [anon_sym_snorm] = ACTIONS(2390),
    [anon_sym_unorm] = ACTIONS(2390),
    [anon_sym_point] = ACTIONS(2390),
    [anon_sym_line] = ACTIONS(2390),
    [anon_sym_triangleadj] = ACTIONS(2390),
    [anon_sym_lineadj] = ACTIONS(2390),
    [anon_sym_triangle] = ACTIONS(2390),
    [anon_sym_cbuffer] = ACTIONS(2390),
  },
  [1094] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4837),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8754),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1095] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4871),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8370),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1096] = {
    [sym_identifier] = ACTIONS(2302),
    [anon_sym_LPAREN2] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2304),
    [anon_sym_TILDE] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2302),
    [anon_sym_PLUS] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2304),
    [anon_sym_AMP] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2304),
    [anon_sym___extension__] = ACTIONS(2302),
    [anon_sym_typedef] = ACTIONS(2302),
    [anon_sym_in] = ACTIONS(2302),
    [anon_sym_out] = ACTIONS(2302),
    [anon_sym_inout] = ACTIONS(2302),
    [anon_sym_virtual] = ACTIONS(2302),
    [anon_sym_extern] = ACTIONS(2302),
    [anon_sym___attribute__] = ACTIONS(2302),
    [anon_sym___attribute] = ACTIONS(2302),
    [anon_sym_COLON_COLON] = ACTIONS(2304),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2304),
    [anon_sym___declspec] = ACTIONS(2302),
    [anon_sym_LBRACE] = ACTIONS(2304),
    [anon_sym_signed] = ACTIONS(2302),
    [anon_sym_unsigned] = ACTIONS(2302),
    [anon_sym_long] = ACTIONS(2302),
    [anon_sym_short] = ACTIONS(2302),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_static] = ACTIONS(2302),
    [anon_sym_register] = ACTIONS(2302),
    [anon_sym_inline] = ACTIONS(2302),
    [anon_sym___inline] = ACTIONS(2302),
    [anon_sym___inline__] = ACTIONS(2302),
    [anon_sym___forceinline] = ACTIONS(2302),
    [anon_sym_thread_local] = ACTIONS(2302),
    [anon_sym___thread] = ACTIONS(2302),
    [anon_sym_const] = ACTIONS(2302),
    [anon_sym_constexpr] = ACTIONS(2302),
    [anon_sym_volatile] = ACTIONS(2302),
    [anon_sym_restrict] = ACTIONS(2302),
    [anon_sym___restrict__] = ACTIONS(2302),
    [anon_sym__Atomic] = ACTIONS(2302),
    [anon_sym__Noreturn] = ACTIONS(2302),
    [anon_sym_noreturn] = ACTIONS(2302),
    [anon_sym__Nonnull] = ACTIONS(2302),
    [anon_sym_mutable] = ACTIONS(2302),
    [anon_sym_constinit] = ACTIONS(2302),
    [anon_sym_consteval] = ACTIONS(2302),
    [anon_sym_alignas] = ACTIONS(2302),
    [anon_sym__Alignas] = ACTIONS(2302),
    [sym_primitive_type] = ACTIONS(2302),
    [anon_sym_enum] = ACTIONS(2302),
    [anon_sym_class] = ACTIONS(2302),
    [anon_sym_struct] = ACTIONS(2302),
    [anon_sym_union] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(2302),
    [anon_sym_else] = ACTIONS(2302),
    [anon_sym_switch] = ACTIONS(2302),
    [anon_sym_while] = ACTIONS(2302),
    [anon_sym_do] = ACTIONS(2302),
    [anon_sym_for] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2302),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2302),
    [anon_sym_goto] = ACTIONS(2302),
    [anon_sym___try] = ACTIONS(2302),
    [anon_sym___leave] = ACTIONS(2302),
    [anon_sym_not] = ACTIONS(2302),
    [anon_sym_compl] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2304),
    [anon_sym_PLUS_PLUS] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2302),
    [anon_sym___alignof__] = ACTIONS(2302),
    [anon_sym___alignof] = ACTIONS(2302),
    [anon_sym__alignof] = ACTIONS(2302),
    [anon_sym_alignof] = ACTIONS(2302),
    [anon_sym__Alignof] = ACTIONS(2302),
    [anon_sym_offsetof] = ACTIONS(2302),
    [anon_sym__Generic] = ACTIONS(2302),
    [anon_sym_asm] = ACTIONS(2302),
    [anon_sym___asm__] = ACTIONS(2302),
    [anon_sym___asm] = ACTIONS(2302),
    [sym_number_literal] = ACTIONS(2304),
    [anon_sym_L_SQUOTE] = ACTIONS(2304),
    [anon_sym_u_SQUOTE] = ACTIONS(2304),
    [anon_sym_U_SQUOTE] = ACTIONS(2304),
    [anon_sym_u8_SQUOTE] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2304),
    [anon_sym_L_DQUOTE] = ACTIONS(2304),
    [anon_sym_u_DQUOTE] = ACTIONS(2304),
    [anon_sym_U_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8_DQUOTE] = ACTIONS(2304),
    [anon_sym_DQUOTE] = ACTIONS(2304),
    [sym_true] = ACTIONS(2302),
    [sym_false] = ACTIONS(2302),
    [anon_sym_NULL] = ACTIONS(2302),
    [anon_sym_nullptr] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2302),
    [anon_sym_decltype] = ACTIONS(2302),
    [anon_sym_typename] = ACTIONS(2302),
    [anon_sym_template] = ACTIONS(2302),
    [anon_sym_try] = ACTIONS(2302),
    [anon_sym_delete] = ACTIONS(2302),
    [anon_sym_throw] = ACTIONS(2302),
    [anon_sym_co_return] = ACTIONS(2302),
    [anon_sym_co_yield] = ACTIONS(2302),
    [anon_sym_R_DQUOTE] = ACTIONS(2304),
    [anon_sym_LR_DQUOTE] = ACTIONS(2304),
    [anon_sym_uR_DQUOTE] = ACTIONS(2304),
    [anon_sym_UR_DQUOTE] = ACTIONS(2304),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2304),
    [anon_sym_co_await] = ACTIONS(2302),
    [anon_sym_new] = ACTIONS(2302),
    [anon_sym_requires] = ACTIONS(2302),
    [sym_this] = ACTIONS(2302),
    [anon_sym_discard] = ACTIONS(2302),
    [anon_sym_precise] = ACTIONS(2302),
    [anon_sym_shared] = ACTIONS(2302),
    [anon_sym_groupshared] = ACTIONS(2302),
    [anon_sym_uniform] = ACTIONS(2302),
    [anon_sym_row_major] = ACTIONS(2302),
    [anon_sym_column_major] = ACTIONS(2302),
    [anon_sym_globallycoherent] = ACTIONS(2302),
    [anon_sym_centroid] = ACTIONS(2302),
    [anon_sym_noperspective] = ACTIONS(2302),
    [anon_sym_nointerpolation] = ACTIONS(2302),
    [anon_sym_sample] = ACTIONS(2302),
    [anon_sym_linear] = ACTIONS(2302),
    [anon_sym_snorm] = ACTIONS(2302),
    [anon_sym_unorm] = ACTIONS(2302),
    [anon_sym_point] = ACTIONS(2302),
    [anon_sym_line] = ACTIONS(2302),
    [anon_sym_triangleadj] = ACTIONS(2302),
    [anon_sym_lineadj] = ACTIONS(2302),
    [anon_sym_triangle] = ACTIONS(2302),
    [anon_sym_cbuffer] = ACTIONS(2302),
  },
  [1097] = {
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_LPAREN2] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_STAR] = ACTIONS(2368),
    [anon_sym_AMP] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym___extension__] = ACTIONS(2366),
    [anon_sym_typedef] = ACTIONS(2366),
    [anon_sym_in] = ACTIONS(2366),
    [anon_sym_out] = ACTIONS(2366),
    [anon_sym_inout] = ACTIONS(2366),
    [anon_sym_virtual] = ACTIONS(2366),
    [anon_sym_extern] = ACTIONS(2366),
    [anon_sym___attribute__] = ACTIONS(2366),
    [anon_sym___attribute] = ACTIONS(2366),
    [anon_sym_COLON_COLON] = ACTIONS(2368),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2368),
    [anon_sym___declspec] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_signed] = ACTIONS(2366),
    [anon_sym_unsigned] = ACTIONS(2366),
    [anon_sym_long] = ACTIONS(2366),
    [anon_sym_short] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_register] = ACTIONS(2366),
    [anon_sym_inline] = ACTIONS(2366),
    [anon_sym___inline] = ACTIONS(2366),
    [anon_sym___inline__] = ACTIONS(2366),
    [anon_sym___forceinline] = ACTIONS(2366),
    [anon_sym_thread_local] = ACTIONS(2366),
    [anon_sym___thread] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_constexpr] = ACTIONS(2366),
    [anon_sym_volatile] = ACTIONS(2366),
    [anon_sym_restrict] = ACTIONS(2366),
    [anon_sym___restrict__] = ACTIONS(2366),
    [anon_sym__Atomic] = ACTIONS(2366),
    [anon_sym__Noreturn] = ACTIONS(2366),
    [anon_sym_noreturn] = ACTIONS(2366),
    [anon_sym__Nonnull] = ACTIONS(2366),
    [anon_sym_mutable] = ACTIONS(2366),
    [anon_sym_constinit] = ACTIONS(2366),
    [anon_sym_consteval] = ACTIONS(2366),
    [anon_sym_alignas] = ACTIONS(2366),
    [anon_sym__Alignas] = ACTIONS(2366),
    [sym_primitive_type] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_struct] = ACTIONS(2366),
    [anon_sym_union] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_goto] = ACTIONS(2366),
    [anon_sym___try] = ACTIONS(2366),
    [anon_sym___leave] = ACTIONS(2366),
    [anon_sym_not] = ACTIONS(2366),
    [anon_sym_compl] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2366),
    [anon_sym___alignof__] = ACTIONS(2366),
    [anon_sym___alignof] = ACTIONS(2366),
    [anon_sym__alignof] = ACTIONS(2366),
    [anon_sym_alignof] = ACTIONS(2366),
    [anon_sym__Alignof] = ACTIONS(2366),
    [anon_sym_offsetof] = ACTIONS(2366),
    [anon_sym__Generic] = ACTIONS(2366),
    [anon_sym_asm] = ACTIONS(2366),
    [anon_sym___asm__] = ACTIONS(2366),
    [anon_sym___asm] = ACTIONS(2366),
    [sym_number_literal] = ACTIONS(2368),
    [anon_sym_L_SQUOTE] = ACTIONS(2368),
    [anon_sym_u_SQUOTE] = ACTIONS(2368),
    [anon_sym_U_SQUOTE] = ACTIONS(2368),
    [anon_sym_u8_SQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_L_DQUOTE] = ACTIONS(2368),
    [anon_sym_u_DQUOTE] = ACTIONS(2368),
    [anon_sym_U_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8_DQUOTE] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [anon_sym_NULL] = ACTIONS(2366),
    [anon_sym_nullptr] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2366),
    [anon_sym_decltype] = ACTIONS(2366),
    [anon_sym_typename] = ACTIONS(2366),
    [anon_sym_template] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_co_return] = ACTIONS(2366),
    [anon_sym_co_yield] = ACTIONS(2366),
    [anon_sym_R_DQUOTE] = ACTIONS(2368),
    [anon_sym_LR_DQUOTE] = ACTIONS(2368),
    [anon_sym_uR_DQUOTE] = ACTIONS(2368),
    [anon_sym_UR_DQUOTE] = ACTIONS(2368),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2368),
    [anon_sym_co_await] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_requires] = ACTIONS(2366),
    [sym_this] = ACTIONS(2366),
    [anon_sym_discard] = ACTIONS(2366),
    [anon_sym_precise] = ACTIONS(2366),
    [anon_sym_shared] = ACTIONS(2366),
    [anon_sym_groupshared] = ACTIONS(2366),
    [anon_sym_uniform] = ACTIONS(2366),
    [anon_sym_row_major] = ACTIONS(2366),
    [anon_sym_column_major] = ACTIONS(2366),
    [anon_sym_globallycoherent] = ACTIONS(2366),
    [anon_sym_centroid] = ACTIONS(2366),
    [anon_sym_noperspective] = ACTIONS(2366),
    [anon_sym_nointerpolation] = ACTIONS(2366),
    [anon_sym_sample] = ACTIONS(2366),
    [anon_sym_linear] = ACTIONS(2366),
    [anon_sym_snorm] = ACTIONS(2366),
    [anon_sym_unorm] = ACTIONS(2366),
    [anon_sym_point] = ACTIONS(2366),
    [anon_sym_line] = ACTIONS(2366),
    [anon_sym_triangleadj] = ACTIONS(2366),
    [anon_sym_lineadj] = ACTIONS(2366),
    [anon_sym_triangle] = ACTIONS(2366),
    [anon_sym_cbuffer] = ACTIONS(2366),
  },
  [1098] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4894),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8859),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1099] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4911),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8801),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1100] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4919),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8931),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1101] = {
    [sym_identifier] = ACTIONS(2306),
    [anon_sym_LPAREN2] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2308),
    [anon_sym_TILDE] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2306),
    [anon_sym_PLUS] = ACTIONS(2306),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AMP] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2308),
    [anon_sym___extension__] = ACTIONS(2306),
    [anon_sym_typedef] = ACTIONS(2306),
    [anon_sym_in] = ACTIONS(2306),
    [anon_sym_out] = ACTIONS(2306),
    [anon_sym_inout] = ACTIONS(2306),
    [anon_sym_virtual] = ACTIONS(2306),
    [anon_sym_extern] = ACTIONS(2306),
    [anon_sym___attribute__] = ACTIONS(2306),
    [anon_sym___attribute] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2308),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2308),
    [anon_sym___declspec] = ACTIONS(2306),
    [anon_sym_LBRACE] = ACTIONS(2308),
    [anon_sym_signed] = ACTIONS(2306),
    [anon_sym_unsigned] = ACTIONS(2306),
    [anon_sym_long] = ACTIONS(2306),
    [anon_sym_short] = ACTIONS(2306),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_static] = ACTIONS(2306),
    [anon_sym_register] = ACTIONS(2306),
    [anon_sym_inline] = ACTIONS(2306),
    [anon_sym___inline] = ACTIONS(2306),
    [anon_sym___inline__] = ACTIONS(2306),
    [anon_sym___forceinline] = ACTIONS(2306),
    [anon_sym_thread_local] = ACTIONS(2306),
    [anon_sym___thread] = ACTIONS(2306),
    [anon_sym_const] = ACTIONS(2306),
    [anon_sym_constexpr] = ACTIONS(2306),
    [anon_sym_volatile] = ACTIONS(2306),
    [anon_sym_restrict] = ACTIONS(2306),
    [anon_sym___restrict__] = ACTIONS(2306),
    [anon_sym__Atomic] = ACTIONS(2306),
    [anon_sym__Noreturn] = ACTIONS(2306),
    [anon_sym_noreturn] = ACTIONS(2306),
    [anon_sym__Nonnull] = ACTIONS(2306),
    [anon_sym_mutable] = ACTIONS(2306),
    [anon_sym_constinit] = ACTIONS(2306),
    [anon_sym_consteval] = ACTIONS(2306),
    [anon_sym_alignas] = ACTIONS(2306),
    [anon_sym__Alignas] = ACTIONS(2306),
    [sym_primitive_type] = ACTIONS(2306),
    [anon_sym_enum] = ACTIONS(2306),
    [anon_sym_class] = ACTIONS(2306),
    [anon_sym_struct] = ACTIONS(2306),
    [anon_sym_union] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(2306),
    [anon_sym_else] = ACTIONS(2306),
    [anon_sym_switch] = ACTIONS(2306),
    [anon_sym_while] = ACTIONS(2306),
    [anon_sym_do] = ACTIONS(2306),
    [anon_sym_for] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2306),
    [anon_sym_break] = ACTIONS(2306),
    [anon_sym_continue] = ACTIONS(2306),
    [anon_sym_goto] = ACTIONS(2306),
    [anon_sym___try] = ACTIONS(2306),
    [anon_sym___leave] = ACTIONS(2306),
    [anon_sym_not] = ACTIONS(2306),
    [anon_sym_compl] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2308),
    [anon_sym_PLUS_PLUS] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2306),
    [anon_sym___alignof__] = ACTIONS(2306),
    [anon_sym___alignof] = ACTIONS(2306),
    [anon_sym__alignof] = ACTIONS(2306),
    [anon_sym_alignof] = ACTIONS(2306),
    [anon_sym__Alignof] = ACTIONS(2306),
    [anon_sym_offsetof] = ACTIONS(2306),
    [anon_sym__Generic] = ACTIONS(2306),
    [anon_sym_asm] = ACTIONS(2306),
    [anon_sym___asm__] = ACTIONS(2306),
    [anon_sym___asm] = ACTIONS(2306),
    [sym_number_literal] = ACTIONS(2308),
    [anon_sym_L_SQUOTE] = ACTIONS(2308),
    [anon_sym_u_SQUOTE] = ACTIONS(2308),
    [anon_sym_U_SQUOTE] = ACTIONS(2308),
    [anon_sym_u8_SQUOTE] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2308),
    [anon_sym_L_DQUOTE] = ACTIONS(2308),
    [anon_sym_u_DQUOTE] = ACTIONS(2308),
    [anon_sym_U_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8_DQUOTE] = ACTIONS(2308),
    [anon_sym_DQUOTE] = ACTIONS(2308),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [anon_sym_NULL] = ACTIONS(2306),
    [anon_sym_nullptr] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2306),
    [anon_sym_decltype] = ACTIONS(2306),
    [anon_sym_typename] = ACTIONS(2306),
    [anon_sym_template] = ACTIONS(2306),
    [anon_sym_try] = ACTIONS(2306),
    [anon_sym_delete] = ACTIONS(2306),
    [anon_sym_throw] = ACTIONS(2306),
    [anon_sym_co_return] = ACTIONS(2306),
    [anon_sym_co_yield] = ACTIONS(2306),
    [anon_sym_R_DQUOTE] = ACTIONS(2308),
    [anon_sym_LR_DQUOTE] = ACTIONS(2308),
    [anon_sym_uR_DQUOTE] = ACTIONS(2308),
    [anon_sym_UR_DQUOTE] = ACTIONS(2308),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2308),
    [anon_sym_co_await] = ACTIONS(2306),
    [anon_sym_new] = ACTIONS(2306),
    [anon_sym_requires] = ACTIONS(2306),
    [sym_this] = ACTIONS(2306),
    [anon_sym_discard] = ACTIONS(2306),
    [anon_sym_precise] = ACTIONS(2306),
    [anon_sym_shared] = ACTIONS(2306),
    [anon_sym_groupshared] = ACTIONS(2306),
    [anon_sym_uniform] = ACTIONS(2306),
    [anon_sym_row_major] = ACTIONS(2306),
    [anon_sym_column_major] = ACTIONS(2306),
    [anon_sym_globallycoherent] = ACTIONS(2306),
    [anon_sym_centroid] = ACTIONS(2306),
    [anon_sym_noperspective] = ACTIONS(2306),
    [anon_sym_nointerpolation] = ACTIONS(2306),
    [anon_sym_sample] = ACTIONS(2306),
    [anon_sym_linear] = ACTIONS(2306),
    [anon_sym_snorm] = ACTIONS(2306),
    [anon_sym_unorm] = ACTIONS(2306),
    [anon_sym_point] = ACTIONS(2306),
    [anon_sym_line] = ACTIONS(2306),
    [anon_sym_triangleadj] = ACTIONS(2306),
    [anon_sym_lineadj] = ACTIONS(2306),
    [anon_sym_triangle] = ACTIONS(2306),
    [anon_sym_cbuffer] = ACTIONS(2306),
  },
  [1102] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4925),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8881),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1103] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4932),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8395),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1104] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4934),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8533),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1105] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4938),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8671),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1106] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4940),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8734),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1107] = {
    [sym_type_qualifier] = STATE(4187),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(4704),
    [sym_sized_type_specifier] = STATE(2581),
    [sym_enum_specifier] = STATE(2581),
    [sym_struct_specifier] = STATE(2581),
    [sym_union_specifier] = STATE(2581),
    [sym_expression] = STATE(4941),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_type_descriptor] = STATE(8773),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_placeholder_type_specifier] = STATE(2581),
    [sym_decltype_auto] = STATE(2545),
    [sym_decltype] = STATE(2521),
    [sym_class_specifier] = STATE(2581),
    [sym__class_name] = STATE(8100),
    [sym_dependent_type] = STATE(2581),
    [sym_template_type] = STATE(5596),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5955),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(5613),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym__type_definition_type_repeat1] = STATE(4187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4437),
    [sym_identifier] = ACTIONS(4263),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4265),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_signed] = ACTIONS(2062),
    [anon_sym_unsigned] = ACTIONS(2062),
    [anon_sym_long] = ACTIONS(2062),
    [anon_sym_short] = ACTIONS(2062),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(4267),
    [anon_sym_enum] = ACTIONS(2068),
    [anon_sym_class] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2072),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2098),
    [anon_sym_decltype] = ACTIONS(2100),
    [anon_sym_typename] = ACTIONS(2102),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1108] = {
    [sym_identifier] = ACTIONS(2310),
    [anon_sym_LPAREN2] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2310),
    [anon_sym_PLUS] = ACTIONS(2310),
    [anon_sym_STAR] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2312),
    [anon_sym___extension__] = ACTIONS(2310),
    [anon_sym_typedef] = ACTIONS(2310),
    [anon_sym_in] = ACTIONS(2310),
    [anon_sym_out] = ACTIONS(2310),
    [anon_sym_inout] = ACTIONS(2310),
    [anon_sym_virtual] = ACTIONS(2310),
    [anon_sym_extern] = ACTIONS(2310),
    [anon_sym___attribute__] = ACTIONS(2310),
    [anon_sym___attribute] = ACTIONS(2310),
    [anon_sym_COLON_COLON] = ACTIONS(2312),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2312),
    [anon_sym___declspec] = ACTIONS(2310),
    [anon_sym_LBRACE] = ACTIONS(2312),
    [anon_sym_signed] = ACTIONS(2310),
    [anon_sym_unsigned] = ACTIONS(2310),
    [anon_sym_long] = ACTIONS(2310),
    [anon_sym_short] = ACTIONS(2310),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_static] = ACTIONS(2310),
    [anon_sym_register] = ACTIONS(2310),
    [anon_sym_inline] = ACTIONS(2310),
    [anon_sym___inline] = ACTIONS(2310),
    [anon_sym___inline__] = ACTIONS(2310),
    [anon_sym___forceinline] = ACTIONS(2310),
    [anon_sym_thread_local] = ACTIONS(2310),
    [anon_sym___thread] = ACTIONS(2310),
    [anon_sym_const] = ACTIONS(2310),
    [anon_sym_constexpr] = ACTIONS(2310),
    [anon_sym_volatile] = ACTIONS(2310),
    [anon_sym_restrict] = ACTIONS(2310),
    [anon_sym___restrict__] = ACTIONS(2310),
    [anon_sym__Atomic] = ACTIONS(2310),
    [anon_sym__Noreturn] = ACTIONS(2310),
    [anon_sym_noreturn] = ACTIONS(2310),
    [anon_sym__Nonnull] = ACTIONS(2310),
    [anon_sym_mutable] = ACTIONS(2310),
    [anon_sym_constinit] = ACTIONS(2310),
    [anon_sym_consteval] = ACTIONS(2310),
    [anon_sym_alignas] = ACTIONS(2310),
    [anon_sym__Alignas] = ACTIONS(2310),
    [sym_primitive_type] = ACTIONS(2310),
    [anon_sym_enum] = ACTIONS(2310),
    [anon_sym_class] = ACTIONS(2310),
    [anon_sym_struct] = ACTIONS(2310),
    [anon_sym_union] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(2310),
    [anon_sym_else] = ACTIONS(2310),
    [anon_sym_switch] = ACTIONS(2310),
    [anon_sym_while] = ACTIONS(2310),
    [anon_sym_do] = ACTIONS(2310),
    [anon_sym_for] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2310),
    [anon_sym_break] = ACTIONS(2310),
    [anon_sym_continue] = ACTIONS(2310),
    [anon_sym_goto] = ACTIONS(2310),
    [anon_sym___try] = ACTIONS(2310),
    [anon_sym___leave] = ACTIONS(2310),
    [anon_sym_not] = ACTIONS(2310),
    [anon_sym_compl] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2310),
    [anon_sym___alignof__] = ACTIONS(2310),
    [anon_sym___alignof] = ACTIONS(2310),
    [anon_sym__alignof] = ACTIONS(2310),
    [anon_sym_alignof] = ACTIONS(2310),
    [anon_sym__Alignof] = ACTIONS(2310),
    [anon_sym_offsetof] = ACTIONS(2310),
    [anon_sym__Generic] = ACTIONS(2310),
    [anon_sym_asm] = ACTIONS(2310),
    [anon_sym___asm__] = ACTIONS(2310),
    [anon_sym___asm] = ACTIONS(2310),
    [sym_number_literal] = ACTIONS(2312),
    [anon_sym_L_SQUOTE] = ACTIONS(2312),
    [anon_sym_u_SQUOTE] = ACTIONS(2312),
    [anon_sym_U_SQUOTE] = ACTIONS(2312),
    [anon_sym_u8_SQUOTE] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2312),
    [anon_sym_L_DQUOTE] = ACTIONS(2312),
    [anon_sym_u_DQUOTE] = ACTIONS(2312),
    [anon_sym_U_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8_DQUOTE] = ACTIONS(2312),
    [anon_sym_DQUOTE] = ACTIONS(2312),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [anon_sym_NULL] = ACTIONS(2310),
    [anon_sym_nullptr] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2310),
    [anon_sym_decltype] = ACTIONS(2310),
    [anon_sym_typename] = ACTIONS(2310),
    [anon_sym_template] = ACTIONS(2310),
    [anon_sym_try] = ACTIONS(2310),
    [anon_sym_delete] = ACTIONS(2310),
    [anon_sym_throw] = ACTIONS(2310),
    [anon_sym_co_return] = ACTIONS(2310),
    [anon_sym_co_yield] = ACTIONS(2310),
    [anon_sym_R_DQUOTE] = ACTIONS(2312),
    [anon_sym_LR_DQUOTE] = ACTIONS(2312),
    [anon_sym_uR_DQUOTE] = ACTIONS(2312),
    [anon_sym_UR_DQUOTE] = ACTIONS(2312),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2312),
    [anon_sym_co_await] = ACTIONS(2310),
    [anon_sym_new] = ACTIONS(2310),
    [anon_sym_requires] = ACTIONS(2310),
    [sym_this] = ACTIONS(2310),
    [anon_sym_discard] = ACTIONS(2310),
    [anon_sym_precise] = ACTIONS(2310),
    [anon_sym_shared] = ACTIONS(2310),
    [anon_sym_groupshared] = ACTIONS(2310),
    [anon_sym_uniform] = ACTIONS(2310),
    [anon_sym_row_major] = ACTIONS(2310),
    [anon_sym_column_major] = ACTIONS(2310),
    [anon_sym_globallycoherent] = ACTIONS(2310),
    [anon_sym_centroid] = ACTIONS(2310),
    [anon_sym_noperspective] = ACTIONS(2310),
    [anon_sym_nointerpolation] = ACTIONS(2310),
    [anon_sym_sample] = ACTIONS(2310),
    [anon_sym_linear] = ACTIONS(2310),
    [anon_sym_snorm] = ACTIONS(2310),
    [anon_sym_unorm] = ACTIONS(2310),
    [anon_sym_point] = ACTIONS(2310),
    [anon_sym_line] = ACTIONS(2310),
    [anon_sym_triangleadj] = ACTIONS(2310),
    [anon_sym_lineadj] = ACTIONS(2310),
    [anon_sym_triangle] = ACTIONS(2310),
    [anon_sym_cbuffer] = ACTIONS(2310),
  },
  [1109] = {
    [sym_identifier] = ACTIONS(2370),
    [anon_sym_LPAREN2] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_STAR] = ACTIONS(2372),
    [anon_sym_AMP] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym___extension__] = ACTIONS(2370),
    [anon_sym_typedef] = ACTIONS(2370),
    [anon_sym_in] = ACTIONS(2370),
    [anon_sym_out] = ACTIONS(2370),
    [anon_sym_inout] = ACTIONS(2370),
    [anon_sym_virtual] = ACTIONS(2370),
    [anon_sym_extern] = ACTIONS(2370),
    [anon_sym___attribute__] = ACTIONS(2370),
    [anon_sym___attribute] = ACTIONS(2370),
    [anon_sym_COLON_COLON] = ACTIONS(2372),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2372),
    [anon_sym___declspec] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_signed] = ACTIONS(2370),
    [anon_sym_unsigned] = ACTIONS(2370),
    [anon_sym_long] = ACTIONS(2370),
    [anon_sym_short] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_register] = ACTIONS(2370),
    [anon_sym_inline] = ACTIONS(2370),
    [anon_sym___inline] = ACTIONS(2370),
    [anon_sym___inline__] = ACTIONS(2370),
    [anon_sym___forceinline] = ACTIONS(2370),
    [anon_sym_thread_local] = ACTIONS(2370),
    [anon_sym___thread] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_constexpr] = ACTIONS(2370),
    [anon_sym_volatile] = ACTIONS(2370),
    [anon_sym_restrict] = ACTIONS(2370),
    [anon_sym___restrict__] = ACTIONS(2370),
    [anon_sym__Atomic] = ACTIONS(2370),
    [anon_sym__Noreturn] = ACTIONS(2370),
    [anon_sym_noreturn] = ACTIONS(2370),
    [anon_sym__Nonnull] = ACTIONS(2370),
    [anon_sym_mutable] = ACTIONS(2370),
    [anon_sym_constinit] = ACTIONS(2370),
    [anon_sym_consteval] = ACTIONS(2370),
    [anon_sym_alignas] = ACTIONS(2370),
    [anon_sym__Alignas] = ACTIONS(2370),
    [sym_primitive_type] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_struct] = ACTIONS(2370),
    [anon_sym_union] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_goto] = ACTIONS(2370),
    [anon_sym___try] = ACTIONS(2370),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2370),
    [anon_sym_compl] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2370),
    [anon_sym___alignof__] = ACTIONS(2370),
    [anon_sym___alignof] = ACTIONS(2370),
    [anon_sym__alignof] = ACTIONS(2370),
    [anon_sym_alignof] = ACTIONS(2370),
    [anon_sym__Alignof] = ACTIONS(2370),
    [anon_sym_offsetof] = ACTIONS(2370),
    [anon_sym__Generic] = ACTIONS(2370),
    [anon_sym_asm] = ACTIONS(2370),
    [anon_sym___asm__] = ACTIONS(2370),
    [anon_sym___asm] = ACTIONS(2370),
    [sym_number_literal] = ACTIONS(2372),
    [anon_sym_L_SQUOTE] = ACTIONS(2372),
    [anon_sym_u_SQUOTE] = ACTIONS(2372),
    [anon_sym_U_SQUOTE] = ACTIONS(2372),
    [anon_sym_u8_SQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_L_DQUOTE] = ACTIONS(2372),
    [anon_sym_u_DQUOTE] = ACTIONS(2372),
    [anon_sym_U_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8_DQUOTE] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [anon_sym_NULL] = ACTIONS(2370),
    [anon_sym_nullptr] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2370),
    [anon_sym_decltype] = ACTIONS(2370),
    [anon_sym_typename] = ACTIONS(2370),
    [anon_sym_template] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_co_return] = ACTIONS(2370),
    [anon_sym_co_yield] = ACTIONS(2370),
    [anon_sym_R_DQUOTE] = ACTIONS(2372),
    [anon_sym_LR_DQUOTE] = ACTIONS(2372),
    [anon_sym_uR_DQUOTE] = ACTIONS(2372),
    [anon_sym_UR_DQUOTE] = ACTIONS(2372),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2372),
    [anon_sym_co_await] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_requires] = ACTIONS(2370),
    [sym_this] = ACTIONS(2370),
    [anon_sym_discard] = ACTIONS(2370),
    [anon_sym_precise] = ACTIONS(2370),
    [anon_sym_shared] = ACTIONS(2370),
    [anon_sym_groupshared] = ACTIONS(2370),
    [anon_sym_uniform] = ACTIONS(2370),
    [anon_sym_row_major] = ACTIONS(2370),
    [anon_sym_column_major] = ACTIONS(2370),
    [anon_sym_globallycoherent] = ACTIONS(2370),
    [anon_sym_centroid] = ACTIONS(2370),
    [anon_sym_noperspective] = ACTIONS(2370),
    [anon_sym_nointerpolation] = ACTIONS(2370),
    [anon_sym_sample] = ACTIONS(2370),
    [anon_sym_linear] = ACTIONS(2370),
    [anon_sym_snorm] = ACTIONS(2370),
    [anon_sym_unorm] = ACTIONS(2370),
    [anon_sym_point] = ACTIONS(2370),
    [anon_sym_line] = ACTIONS(2370),
    [anon_sym_triangleadj] = ACTIONS(2370),
    [anon_sym_lineadj] = ACTIONS(2370),
    [anon_sym_triangle] = ACTIONS(2370),
    [anon_sym_cbuffer] = ACTIONS(2370),
  },
  [1110] = {
    [sym_identifier] = ACTIONS(2314),
    [anon_sym_LPAREN2] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2314),
    [anon_sym_PLUS] = ACTIONS(2314),
    [anon_sym_STAR] = ACTIONS(2316),
    [anon_sym_AMP] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2316),
    [anon_sym___extension__] = ACTIONS(2314),
    [anon_sym_typedef] = ACTIONS(2314),
    [anon_sym_in] = ACTIONS(2314),
    [anon_sym_out] = ACTIONS(2314),
    [anon_sym_inout] = ACTIONS(2314),
    [anon_sym_virtual] = ACTIONS(2314),
    [anon_sym_extern] = ACTIONS(2314),
    [anon_sym___attribute__] = ACTIONS(2314),
    [anon_sym___attribute] = ACTIONS(2314),
    [anon_sym_COLON_COLON] = ACTIONS(2316),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2316),
    [anon_sym___declspec] = ACTIONS(2314),
    [anon_sym_LBRACE] = ACTIONS(2316),
    [anon_sym_signed] = ACTIONS(2314),
    [anon_sym_unsigned] = ACTIONS(2314),
    [anon_sym_long] = ACTIONS(2314),
    [anon_sym_short] = ACTIONS(2314),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_static] = ACTIONS(2314),
    [anon_sym_register] = ACTIONS(2314),
    [anon_sym_inline] = ACTIONS(2314),
    [anon_sym___inline] = ACTIONS(2314),
    [anon_sym___inline__] = ACTIONS(2314),
    [anon_sym___forceinline] = ACTIONS(2314),
    [anon_sym_thread_local] = ACTIONS(2314),
    [anon_sym___thread] = ACTIONS(2314),
    [anon_sym_const] = ACTIONS(2314),
    [anon_sym_constexpr] = ACTIONS(2314),
    [anon_sym_volatile] = ACTIONS(2314),
    [anon_sym_restrict] = ACTIONS(2314),
    [anon_sym___restrict__] = ACTIONS(2314),
    [anon_sym__Atomic] = ACTIONS(2314),
    [anon_sym__Noreturn] = ACTIONS(2314),
    [anon_sym_noreturn] = ACTIONS(2314),
    [anon_sym__Nonnull] = ACTIONS(2314),
    [anon_sym_mutable] = ACTIONS(2314),
    [anon_sym_constinit] = ACTIONS(2314),
    [anon_sym_consteval] = ACTIONS(2314),
    [anon_sym_alignas] = ACTIONS(2314),
    [anon_sym__Alignas] = ACTIONS(2314),
    [sym_primitive_type] = ACTIONS(2314),
    [anon_sym_enum] = ACTIONS(2314),
    [anon_sym_class] = ACTIONS(2314),
    [anon_sym_struct] = ACTIONS(2314),
    [anon_sym_union] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2314),
    [anon_sym_while] = ACTIONS(2314),
    [anon_sym_do] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2314),
    [anon_sym_break] = ACTIONS(2314),
    [anon_sym_continue] = ACTIONS(2314),
    [anon_sym_goto] = ACTIONS(2314),
    [anon_sym___try] = ACTIONS(2314),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2314),
    [anon_sym_compl] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2314),
    [anon_sym___alignof__] = ACTIONS(2314),
    [anon_sym___alignof] = ACTIONS(2314),
    [anon_sym__alignof] = ACTIONS(2314),
    [anon_sym_alignof] = ACTIONS(2314),
    [anon_sym__Alignof] = ACTIONS(2314),
    [anon_sym_offsetof] = ACTIONS(2314),
    [anon_sym__Generic] = ACTIONS(2314),
    [anon_sym_asm] = ACTIONS(2314),
    [anon_sym___asm__] = ACTIONS(2314),
    [anon_sym___asm] = ACTIONS(2314),
    [sym_number_literal] = ACTIONS(2316),
    [anon_sym_L_SQUOTE] = ACTIONS(2316),
    [anon_sym_u_SQUOTE] = ACTIONS(2316),
    [anon_sym_U_SQUOTE] = ACTIONS(2316),
    [anon_sym_u8_SQUOTE] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2316),
    [anon_sym_L_DQUOTE] = ACTIONS(2316),
    [anon_sym_u_DQUOTE] = ACTIONS(2316),
    [anon_sym_U_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8_DQUOTE] = ACTIONS(2316),
    [anon_sym_DQUOTE] = ACTIONS(2316),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [anon_sym_NULL] = ACTIONS(2314),
    [anon_sym_nullptr] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2314),
    [anon_sym_decltype] = ACTIONS(2314),
    [anon_sym_typename] = ACTIONS(2314),
    [anon_sym_template] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2314),
    [anon_sym_delete] = ACTIONS(2314),
    [anon_sym_throw] = ACTIONS(2314),
    [anon_sym_co_return] = ACTIONS(2314),
    [anon_sym_co_yield] = ACTIONS(2314),
    [anon_sym_R_DQUOTE] = ACTIONS(2316),
    [anon_sym_LR_DQUOTE] = ACTIONS(2316),
    [anon_sym_uR_DQUOTE] = ACTIONS(2316),
    [anon_sym_UR_DQUOTE] = ACTIONS(2316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2316),
    [anon_sym_co_await] = ACTIONS(2314),
    [anon_sym_new] = ACTIONS(2314),
    [anon_sym_requires] = ACTIONS(2314),
    [sym_this] = ACTIONS(2314),
    [anon_sym_discard] = ACTIONS(2314),
    [anon_sym_precise] = ACTIONS(2314),
    [anon_sym_shared] = ACTIONS(2314),
    [anon_sym_groupshared] = ACTIONS(2314),
    [anon_sym_uniform] = ACTIONS(2314),
    [anon_sym_row_major] = ACTIONS(2314),
    [anon_sym_column_major] = ACTIONS(2314),
    [anon_sym_globallycoherent] = ACTIONS(2314),
    [anon_sym_centroid] = ACTIONS(2314),
    [anon_sym_noperspective] = ACTIONS(2314),
    [anon_sym_nointerpolation] = ACTIONS(2314),
    [anon_sym_sample] = ACTIONS(2314),
    [anon_sym_linear] = ACTIONS(2314),
    [anon_sym_snorm] = ACTIONS(2314),
    [anon_sym_unorm] = ACTIONS(2314),
    [anon_sym_point] = ACTIONS(2314),
    [anon_sym_line] = ACTIONS(2314),
    [anon_sym_triangleadj] = ACTIONS(2314),
    [anon_sym_lineadj] = ACTIONS(2314),
    [anon_sym_triangle] = ACTIONS(2314),
    [anon_sym_cbuffer] = ACTIONS(2314),
  },
  [1111] = {
    [sym_identifier] = ACTIONS(2374),
    [anon_sym_LPAREN2] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_STAR] = ACTIONS(2376),
    [anon_sym_AMP] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym___extension__] = ACTIONS(2374),
    [anon_sym_typedef] = ACTIONS(2374),
    [anon_sym_in] = ACTIONS(2374),
    [anon_sym_out] = ACTIONS(2374),
    [anon_sym_inout] = ACTIONS(2374),
    [anon_sym_virtual] = ACTIONS(2374),
    [anon_sym_extern] = ACTIONS(2374),
    [anon_sym___attribute__] = ACTIONS(2374),
    [anon_sym___attribute] = ACTIONS(2374),
    [anon_sym_COLON_COLON] = ACTIONS(2376),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2376),
    [anon_sym___declspec] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_signed] = ACTIONS(2374),
    [anon_sym_unsigned] = ACTIONS(2374),
    [anon_sym_long] = ACTIONS(2374),
    [anon_sym_short] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_register] = ACTIONS(2374),
    [anon_sym_inline] = ACTIONS(2374),
    [anon_sym___inline] = ACTIONS(2374),
    [anon_sym___inline__] = ACTIONS(2374),
    [anon_sym___forceinline] = ACTIONS(2374),
    [anon_sym_thread_local] = ACTIONS(2374),
    [anon_sym___thread] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_constexpr] = ACTIONS(2374),
    [anon_sym_volatile] = ACTIONS(2374),
    [anon_sym_restrict] = ACTIONS(2374),
    [anon_sym___restrict__] = ACTIONS(2374),
    [anon_sym__Atomic] = ACTIONS(2374),
    [anon_sym__Noreturn] = ACTIONS(2374),
    [anon_sym_noreturn] = ACTIONS(2374),
    [anon_sym__Nonnull] = ACTIONS(2374),
    [anon_sym_mutable] = ACTIONS(2374),
    [anon_sym_constinit] = ACTIONS(2374),
    [anon_sym_consteval] = ACTIONS(2374),
    [anon_sym_alignas] = ACTIONS(2374),
    [anon_sym__Alignas] = ACTIONS(2374),
    [sym_primitive_type] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_struct] = ACTIONS(2374),
    [anon_sym_union] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_goto] = ACTIONS(2374),
    [anon_sym___try] = ACTIONS(2374),
    [anon_sym___leave] = ACTIONS(2374),
    [anon_sym_not] = ACTIONS(2374),
    [anon_sym_compl] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2374),
    [anon_sym___alignof__] = ACTIONS(2374),
    [anon_sym___alignof] = ACTIONS(2374),
    [anon_sym__alignof] = ACTIONS(2374),
    [anon_sym_alignof] = ACTIONS(2374),
    [anon_sym__Alignof] = ACTIONS(2374),
    [anon_sym_offsetof] = ACTIONS(2374),
    [anon_sym__Generic] = ACTIONS(2374),
    [anon_sym_asm] = ACTIONS(2374),
    [anon_sym___asm__] = ACTIONS(2374),
    [anon_sym___asm] = ACTIONS(2374),
    [sym_number_literal] = ACTIONS(2376),
    [anon_sym_L_SQUOTE] = ACTIONS(2376),
    [anon_sym_u_SQUOTE] = ACTIONS(2376),
    [anon_sym_U_SQUOTE] = ACTIONS(2376),
    [anon_sym_u8_SQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_L_DQUOTE] = ACTIONS(2376),
    [anon_sym_u_DQUOTE] = ACTIONS(2376),
    [anon_sym_U_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8_DQUOTE] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [anon_sym_NULL] = ACTIONS(2374),
    [anon_sym_nullptr] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2374),
    [anon_sym_decltype] = ACTIONS(2374),
    [anon_sym_typename] = ACTIONS(2374),
    [anon_sym_template] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_co_return] = ACTIONS(2374),
    [anon_sym_co_yield] = ACTIONS(2374),
    [anon_sym_R_DQUOTE] = ACTIONS(2376),
    [anon_sym_LR_DQUOTE] = ACTIONS(2376),
    [anon_sym_uR_DQUOTE] = ACTIONS(2376),
    [anon_sym_UR_DQUOTE] = ACTIONS(2376),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2376),
    [anon_sym_co_await] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_requires] = ACTIONS(2374),
    [sym_this] = ACTIONS(2374),
    [anon_sym_discard] = ACTIONS(2374),
    [anon_sym_precise] = ACTIONS(2374),
    [anon_sym_shared] = ACTIONS(2374),
    [anon_sym_groupshared] = ACTIONS(2374),
    [anon_sym_uniform] = ACTIONS(2374),
    [anon_sym_row_major] = ACTIONS(2374),
    [anon_sym_column_major] = ACTIONS(2374),
    [anon_sym_globallycoherent] = ACTIONS(2374),
    [anon_sym_centroid] = ACTIONS(2374),
    [anon_sym_noperspective] = ACTIONS(2374),
    [anon_sym_nointerpolation] = ACTIONS(2374),
    [anon_sym_sample] = ACTIONS(2374),
    [anon_sym_linear] = ACTIONS(2374),
    [anon_sym_snorm] = ACTIONS(2374),
    [anon_sym_unorm] = ACTIONS(2374),
    [anon_sym_point] = ACTIONS(2374),
    [anon_sym_line] = ACTIONS(2374),
    [anon_sym_triangleadj] = ACTIONS(2374),
    [anon_sym_lineadj] = ACTIONS(2374),
    [anon_sym_triangle] = ACTIONS(2374),
    [anon_sym_cbuffer] = ACTIONS(2374),
  },
  [1112] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4269),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(2318),
    [anon_sym_LPAREN2] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2320),
    [anon_sym_TILDE] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2318),
    [anon_sym_PLUS] = ACTIONS(2318),
    [anon_sym_STAR] = ACTIONS(2320),
    [anon_sym_AMP] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2320),
    [anon_sym___extension__] = ACTIONS(2318),
    [anon_sym_typedef] = ACTIONS(2318),
    [anon_sym_in] = ACTIONS(2318),
    [anon_sym_out] = ACTIONS(2318),
    [anon_sym_inout] = ACTIONS(2318),
    [anon_sym_virtual] = ACTIONS(2318),
    [anon_sym_extern] = ACTIONS(2318),
    [anon_sym___attribute__] = ACTIONS(2318),
    [anon_sym___attribute] = ACTIONS(2318),
    [anon_sym_COLON_COLON] = ACTIONS(2320),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2320),
    [anon_sym___declspec] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(2320),
    [anon_sym_signed] = ACTIONS(2318),
    [anon_sym_unsigned] = ACTIONS(2318),
    [anon_sym_long] = ACTIONS(2318),
    [anon_sym_short] = ACTIONS(2318),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_static] = ACTIONS(2318),
    [anon_sym_register] = ACTIONS(2318),
    [anon_sym_inline] = ACTIONS(2318),
    [anon_sym___inline] = ACTIONS(2318),
    [anon_sym___inline__] = ACTIONS(2318),
    [anon_sym___forceinline] = ACTIONS(2318),
    [anon_sym_thread_local] = ACTIONS(2318),
    [anon_sym___thread] = ACTIONS(2318),
    [anon_sym_const] = ACTIONS(2318),
    [anon_sym_constexpr] = ACTIONS(2318),
    [anon_sym_volatile] = ACTIONS(2318),
    [anon_sym_restrict] = ACTIONS(2318),
    [anon_sym___restrict__] = ACTIONS(2318),
    [anon_sym__Atomic] = ACTIONS(2318),
    [anon_sym__Noreturn] = ACTIONS(2318),
    [anon_sym_noreturn] = ACTIONS(2318),
    [anon_sym__Nonnull] = ACTIONS(2318),
    [anon_sym_mutable] = ACTIONS(2318),
    [anon_sym_constinit] = ACTIONS(2318),
    [anon_sym_consteval] = ACTIONS(2318),
    [anon_sym_alignas] = ACTIONS(2318),
    [anon_sym__Alignas] = ACTIONS(2318),
    [sym_primitive_type] = ACTIONS(2318),
    [anon_sym_enum] = ACTIONS(2318),
    [anon_sym_class] = ACTIONS(2318),
    [anon_sym_struct] = ACTIONS(2318),
    [anon_sym_union] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2318),
    [anon_sym_while] = ACTIONS(2318),
    [anon_sym_do] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2318),
    [anon_sym_break] = ACTIONS(2318),
    [anon_sym_continue] = ACTIONS(2318),
    [anon_sym_goto] = ACTIONS(2318),
    [anon_sym___try] = ACTIONS(2318),
    [anon_sym___leave] = ACTIONS(2318),
    [anon_sym_not] = ACTIONS(2318),
    [anon_sym_compl] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2320),
    [anon_sym_PLUS_PLUS] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2318),
    [anon_sym___alignof__] = ACTIONS(2318),
    [anon_sym___alignof] = ACTIONS(2318),
    [anon_sym__alignof] = ACTIONS(2318),
    [anon_sym_alignof] = ACTIONS(2318),
    [anon_sym__Alignof] = ACTIONS(2318),
    [anon_sym_offsetof] = ACTIONS(2318),
    [anon_sym__Generic] = ACTIONS(2318),
    [anon_sym_asm] = ACTIONS(2318),
    [anon_sym___asm__] = ACTIONS(2318),
    [anon_sym___asm] = ACTIONS(2318),
    [sym_number_literal] = ACTIONS(2320),
    [anon_sym_L_SQUOTE] = ACTIONS(2320),
    [anon_sym_u_SQUOTE] = ACTIONS(2320),
    [anon_sym_U_SQUOTE] = ACTIONS(2320),
    [anon_sym_u8_SQUOTE] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2320),
    [anon_sym_L_DQUOTE] = ACTIONS(2320),
    [anon_sym_u_DQUOTE] = ACTIONS(2320),
    [anon_sym_U_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8_DQUOTE] = ACTIONS(2320),
    [anon_sym_DQUOTE] = ACTIONS(2320),
    [sym_true] = ACTIONS(2318),
    [sym_false] = ACTIONS(2318),
    [anon_sym_NULL] = ACTIONS(2318),
    [anon_sym_nullptr] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2318),
    [anon_sym_decltype] = ACTIONS(2318),
    [anon_sym_typename] = ACTIONS(2318),
    [anon_sym_template] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2318),
    [anon_sym_delete] = ACTIONS(2318),
    [anon_sym_throw] = ACTIONS(2318),
    [anon_sym_co_return] = ACTIONS(2318),
    [anon_sym_co_yield] = ACTIONS(2318),
    [anon_sym_R_DQUOTE] = ACTIONS(2320),
    [anon_sym_LR_DQUOTE] = ACTIONS(2320),
    [anon_sym_uR_DQUOTE] = ACTIONS(2320),
    [anon_sym_UR_DQUOTE] = ACTIONS(2320),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2320),
    [anon_sym_co_await] = ACTIONS(2318),
    [anon_sym_new] = ACTIONS(2318),
    [anon_sym_requires] = ACTIONS(2318),
    [sym_this] = ACTIONS(2318),
    [anon_sym_discard] = ACTIONS(2318),
    [anon_sym_precise] = ACTIONS(2318),
    [anon_sym_shared] = ACTIONS(2318),
    [anon_sym_groupshared] = ACTIONS(2318),
    [anon_sym_uniform] = ACTIONS(2318),
    [anon_sym_row_major] = ACTIONS(2318),
    [anon_sym_column_major] = ACTIONS(2318),
    [anon_sym_globallycoherent] = ACTIONS(2318),
    [anon_sym_centroid] = ACTIONS(2318),
    [anon_sym_noperspective] = ACTIONS(2318),
    [anon_sym_nointerpolation] = ACTIONS(2318),
    [anon_sym_sample] = ACTIONS(2318),
    [anon_sym_linear] = ACTIONS(2318),
    [anon_sym_snorm] = ACTIONS(2318),
    [anon_sym_unorm] = ACTIONS(2318),
    [anon_sym_point] = ACTIONS(2318),
    [anon_sym_line] = ACTIONS(2318),
    [anon_sym_triangleadj] = ACTIONS(2318),
    [anon_sym_lineadj] = ACTIONS(2318),
    [anon_sym_triangle] = ACTIONS(2318),
    [anon_sym_cbuffer] = ACTIONS(2318),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(2322),
    [anon_sym_LPAREN2] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2322),
    [anon_sym_PLUS] = ACTIONS(2322),
    [anon_sym_STAR] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym___extension__] = ACTIONS(2322),
    [anon_sym_typedef] = ACTIONS(2322),
    [anon_sym_in] = ACTIONS(2322),
    [anon_sym_out] = ACTIONS(2322),
    [anon_sym_inout] = ACTIONS(2322),
    [anon_sym_virtual] = ACTIONS(2322),
    [anon_sym_extern] = ACTIONS(2322),
    [anon_sym___attribute__] = ACTIONS(2322),
    [anon_sym___attribute] = ACTIONS(2322),
    [anon_sym_COLON_COLON] = ACTIONS(2324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2324),
    [anon_sym___declspec] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_signed] = ACTIONS(2322),
    [anon_sym_unsigned] = ACTIONS(2322),
    [anon_sym_long] = ACTIONS(2322),
    [anon_sym_short] = ACTIONS(2322),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_static] = ACTIONS(2322),
    [anon_sym_register] = ACTIONS(2322),
    [anon_sym_inline] = ACTIONS(2322),
    [anon_sym___inline] = ACTIONS(2322),
    [anon_sym___inline__] = ACTIONS(2322),
    [anon_sym___forceinline] = ACTIONS(2322),
    [anon_sym_thread_local] = ACTIONS(2322),
    [anon_sym___thread] = ACTIONS(2322),
    [anon_sym_const] = ACTIONS(2322),
    [anon_sym_constexpr] = ACTIONS(2322),
    [anon_sym_volatile] = ACTIONS(2322),
    [anon_sym_restrict] = ACTIONS(2322),
    [anon_sym___restrict__] = ACTIONS(2322),
    [anon_sym__Atomic] = ACTIONS(2322),
    [anon_sym__Noreturn] = ACTIONS(2322),
    [anon_sym_noreturn] = ACTIONS(2322),
    [anon_sym__Nonnull] = ACTIONS(2322),
    [anon_sym_mutable] = ACTIONS(2322),
    [anon_sym_constinit] = ACTIONS(2322),
    [anon_sym_consteval] = ACTIONS(2322),
    [anon_sym_alignas] = ACTIONS(2322),
    [anon_sym__Alignas] = ACTIONS(2322),
    [sym_primitive_type] = ACTIONS(2322),
    [anon_sym_enum] = ACTIONS(2322),
    [anon_sym_class] = ACTIONS(2322),
    [anon_sym_struct] = ACTIONS(2322),
    [anon_sym_union] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(2322),
    [anon_sym_else] = ACTIONS(2322),
    [anon_sym_switch] = ACTIONS(2322),
    [anon_sym_while] = ACTIONS(2322),
    [anon_sym_do] = ACTIONS(2322),
    [anon_sym_for] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2322),
    [anon_sym_break] = ACTIONS(2322),
    [anon_sym_continue] = ACTIONS(2322),
    [anon_sym_goto] = ACTIONS(2322),
    [anon_sym___try] = ACTIONS(2322),
    [anon_sym___leave] = ACTIONS(2322),
    [anon_sym_not] = ACTIONS(2322),
    [anon_sym_compl] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2322),
    [anon_sym___alignof__] = ACTIONS(2322),
    [anon_sym___alignof] = ACTIONS(2322),
    [anon_sym__alignof] = ACTIONS(2322),
    [anon_sym_alignof] = ACTIONS(2322),
    [anon_sym__Alignof] = ACTIONS(2322),
    [anon_sym_offsetof] = ACTIONS(2322),
    [anon_sym__Generic] = ACTIONS(2322),
    [anon_sym_asm] = ACTIONS(2322),
    [anon_sym___asm__] = ACTIONS(2322),
    [anon_sym___asm] = ACTIONS(2322),
    [sym_number_literal] = ACTIONS(2324),
    [anon_sym_L_SQUOTE] = ACTIONS(2324),
    [anon_sym_u_SQUOTE] = ACTIONS(2324),
    [anon_sym_U_SQUOTE] = ACTIONS(2324),
    [anon_sym_u8_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_L_DQUOTE] = ACTIONS(2324),
    [anon_sym_u_DQUOTE] = ACTIONS(2324),
    [anon_sym_U_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8_DQUOTE] = ACTIONS(2324),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [sym_true] = ACTIONS(2322),
    [sym_false] = ACTIONS(2322),
    [anon_sym_NULL] = ACTIONS(2322),
    [anon_sym_nullptr] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2322),
    [anon_sym_decltype] = ACTIONS(2322),
    [anon_sym_typename] = ACTIONS(2322),
    [anon_sym_template] = ACTIONS(2322),
    [anon_sym_try] = ACTIONS(2322),
    [anon_sym_delete] = ACTIONS(2322),
    [anon_sym_throw] = ACTIONS(2322),
    [anon_sym_co_return] = ACTIONS(2322),
    [anon_sym_co_yield] = ACTIONS(2322),
    [anon_sym_R_DQUOTE] = ACTIONS(2324),
    [anon_sym_LR_DQUOTE] = ACTIONS(2324),
    [anon_sym_uR_DQUOTE] = ACTIONS(2324),
    [anon_sym_UR_DQUOTE] = ACTIONS(2324),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2324),
    [anon_sym_co_await] = ACTIONS(2322),
    [anon_sym_new] = ACTIONS(2322),
    [anon_sym_requires] = ACTIONS(2322),
    [sym_this] = ACTIONS(2322),
    [anon_sym_discard] = ACTIONS(2322),
    [anon_sym_precise] = ACTIONS(2322),
    [anon_sym_shared] = ACTIONS(2322),
    [anon_sym_groupshared] = ACTIONS(2322),
    [anon_sym_uniform] = ACTIONS(2322),
    [anon_sym_row_major] = ACTIONS(2322),
    [anon_sym_column_major] = ACTIONS(2322),
    [anon_sym_globallycoherent] = ACTIONS(2322),
    [anon_sym_centroid] = ACTIONS(2322),
    [anon_sym_noperspective] = ACTIONS(2322),
    [anon_sym_nointerpolation] = ACTIONS(2322),
    [anon_sym_sample] = ACTIONS(2322),
    [anon_sym_linear] = ACTIONS(2322),
    [anon_sym_snorm] = ACTIONS(2322),
    [anon_sym_unorm] = ACTIONS(2322),
    [anon_sym_point] = ACTIONS(2322),
    [anon_sym_line] = ACTIONS(2322),
    [anon_sym_triangleadj] = ACTIONS(2322),
    [anon_sym_lineadj] = ACTIONS(2322),
    [anon_sym_triangle] = ACTIONS(2322),
    [anon_sym_cbuffer] = ACTIONS(2322),
  },
  [1115] = {
    [sym_identifier] = ACTIONS(2338),
    [anon_sym_LPAREN2] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2338),
    [anon_sym_PLUS] = ACTIONS(2338),
    [anon_sym_STAR] = ACTIONS(2340),
    [anon_sym_AMP] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2340),
    [anon_sym___extension__] = ACTIONS(2338),
    [anon_sym_typedef] = ACTIONS(2338),
    [anon_sym_in] = ACTIONS(2338),
    [anon_sym_out] = ACTIONS(2338),
    [anon_sym_inout] = ACTIONS(2338),
    [anon_sym_virtual] = ACTIONS(2338),
    [anon_sym_extern] = ACTIONS(2338),
    [anon_sym___attribute__] = ACTIONS(2338),
    [anon_sym___attribute] = ACTIONS(2338),
    [anon_sym_COLON_COLON] = ACTIONS(2340),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2340),
    [anon_sym___declspec] = ACTIONS(2338),
    [anon_sym_LBRACE] = ACTIONS(2340),
    [anon_sym_signed] = ACTIONS(2338),
    [anon_sym_unsigned] = ACTIONS(2338),
    [anon_sym_long] = ACTIONS(2338),
    [anon_sym_short] = ACTIONS(2338),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_static] = ACTIONS(2338),
    [anon_sym_register] = ACTIONS(2338),
    [anon_sym_inline] = ACTIONS(2338),
    [anon_sym___inline] = ACTIONS(2338),
    [anon_sym___inline__] = ACTIONS(2338),
    [anon_sym___forceinline] = ACTIONS(2338),
    [anon_sym_thread_local] = ACTIONS(2338),
    [anon_sym___thread] = ACTIONS(2338),
    [anon_sym_const] = ACTIONS(2338),
    [anon_sym_constexpr] = ACTIONS(2338),
    [anon_sym_volatile] = ACTIONS(2338),
    [anon_sym_restrict] = ACTIONS(2338),
    [anon_sym___restrict__] = ACTIONS(2338),
    [anon_sym__Atomic] = ACTIONS(2338),
    [anon_sym__Noreturn] = ACTIONS(2338),
    [anon_sym_noreturn] = ACTIONS(2338),
    [anon_sym__Nonnull] = ACTIONS(2338),
    [anon_sym_mutable] = ACTIONS(2338),
    [anon_sym_constinit] = ACTIONS(2338),
    [anon_sym_consteval] = ACTIONS(2338),
    [anon_sym_alignas] = ACTIONS(2338),
    [anon_sym__Alignas] = ACTIONS(2338),
    [sym_primitive_type] = ACTIONS(2338),
    [anon_sym_enum] = ACTIONS(2338),
    [anon_sym_class] = ACTIONS(2338),
    [anon_sym_struct] = ACTIONS(2338),
    [anon_sym_union] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(2338),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_switch] = ACTIONS(2338),
    [anon_sym_while] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_for] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2338),
    [anon_sym_break] = ACTIONS(2338),
    [anon_sym_continue] = ACTIONS(2338),
    [anon_sym_goto] = ACTIONS(2338),
    [anon_sym___try] = ACTIONS(2338),
    [anon_sym___leave] = ACTIONS(2338),
    [anon_sym_not] = ACTIONS(2338),
    [anon_sym_compl] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2338),
    [anon_sym___alignof__] = ACTIONS(2338),
    [anon_sym___alignof] = ACTIONS(2338),
    [anon_sym__alignof] = ACTIONS(2338),
    [anon_sym_alignof] = ACTIONS(2338),
    [anon_sym__Alignof] = ACTIONS(2338),
    [anon_sym_offsetof] = ACTIONS(2338),
    [anon_sym__Generic] = ACTIONS(2338),
    [anon_sym_asm] = ACTIONS(2338),
    [anon_sym___asm__] = ACTIONS(2338),
    [anon_sym___asm] = ACTIONS(2338),
    [sym_number_literal] = ACTIONS(2340),
    [anon_sym_L_SQUOTE] = ACTIONS(2340),
    [anon_sym_u_SQUOTE] = ACTIONS(2340),
    [anon_sym_U_SQUOTE] = ACTIONS(2340),
    [anon_sym_u8_SQUOTE] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2340),
    [anon_sym_L_DQUOTE] = ACTIONS(2340),
    [anon_sym_u_DQUOTE] = ACTIONS(2340),
    [anon_sym_U_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8_DQUOTE] = ACTIONS(2340),
    [anon_sym_DQUOTE] = ACTIONS(2340),
    [sym_true] = ACTIONS(2338),
    [sym_false] = ACTIONS(2338),
    [anon_sym_NULL] = ACTIONS(2338),
    [anon_sym_nullptr] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2338),
    [anon_sym_decltype] = ACTIONS(2338),
    [anon_sym_typename] = ACTIONS(2338),
    [anon_sym_template] = ACTIONS(2338),
    [anon_sym_try] = ACTIONS(2338),
    [anon_sym_delete] = ACTIONS(2338),
    [anon_sym_throw] = ACTIONS(2338),
    [anon_sym_co_return] = ACTIONS(2338),
    [anon_sym_co_yield] = ACTIONS(2338),
    [anon_sym_R_DQUOTE] = ACTIONS(2340),
    [anon_sym_LR_DQUOTE] = ACTIONS(2340),
    [anon_sym_uR_DQUOTE] = ACTIONS(2340),
    [anon_sym_UR_DQUOTE] = ACTIONS(2340),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2340),
    [anon_sym_co_await] = ACTIONS(2338),
    [anon_sym_new] = ACTIONS(2338),
    [anon_sym_requires] = ACTIONS(2338),
    [sym_this] = ACTIONS(2338),
    [anon_sym_discard] = ACTIONS(2338),
    [anon_sym_precise] = ACTIONS(2338),
    [anon_sym_shared] = ACTIONS(2338),
    [anon_sym_groupshared] = ACTIONS(2338),
    [anon_sym_uniform] = ACTIONS(2338),
    [anon_sym_row_major] = ACTIONS(2338),
    [anon_sym_column_major] = ACTIONS(2338),
    [anon_sym_globallycoherent] = ACTIONS(2338),
    [anon_sym_centroid] = ACTIONS(2338),
    [anon_sym_noperspective] = ACTIONS(2338),
    [anon_sym_nointerpolation] = ACTIONS(2338),
    [anon_sym_sample] = ACTIONS(2338),
    [anon_sym_linear] = ACTIONS(2338),
    [anon_sym_snorm] = ACTIONS(2338),
    [anon_sym_unorm] = ACTIONS(2338),
    [anon_sym_point] = ACTIONS(2338),
    [anon_sym_line] = ACTIONS(2338),
    [anon_sym_triangleadj] = ACTIONS(2338),
    [anon_sym_lineadj] = ACTIONS(2338),
    [anon_sym_triangle] = ACTIONS(2338),
    [anon_sym_cbuffer] = ACTIONS(2338),
  },
  [1116] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4271),
    [anon_sym_SEMI] = ACTIONS(4230),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1117] = {
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_LPAREN2] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_STAR] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym___extension__] = ACTIONS(2386),
    [anon_sym_typedef] = ACTIONS(2386),
    [anon_sym_in] = ACTIONS(2386),
    [anon_sym_out] = ACTIONS(2386),
    [anon_sym_inout] = ACTIONS(2386),
    [anon_sym_virtual] = ACTIONS(2386),
    [anon_sym_extern] = ACTIONS(2386),
    [anon_sym___attribute__] = ACTIONS(2386),
    [anon_sym___attribute] = ACTIONS(2386),
    [anon_sym_COLON_COLON] = ACTIONS(2388),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2388),
    [anon_sym___declspec] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_signed] = ACTIONS(2386),
    [anon_sym_unsigned] = ACTIONS(2386),
    [anon_sym_long] = ACTIONS(2386),
    [anon_sym_short] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_register] = ACTIONS(2386),
    [anon_sym_inline] = ACTIONS(2386),
    [anon_sym___inline] = ACTIONS(2386),
    [anon_sym___inline__] = ACTIONS(2386),
    [anon_sym___forceinline] = ACTIONS(2386),
    [anon_sym_thread_local] = ACTIONS(2386),
    [anon_sym___thread] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_constexpr] = ACTIONS(2386),
    [anon_sym_volatile] = ACTIONS(2386),
    [anon_sym_restrict] = ACTIONS(2386),
    [anon_sym___restrict__] = ACTIONS(2386),
    [anon_sym__Atomic] = ACTIONS(2386),
    [anon_sym__Noreturn] = ACTIONS(2386),
    [anon_sym_noreturn] = ACTIONS(2386),
    [anon_sym__Nonnull] = ACTIONS(2386),
    [anon_sym_mutable] = ACTIONS(2386),
    [anon_sym_constinit] = ACTIONS(2386),
    [anon_sym_consteval] = ACTIONS(2386),
    [anon_sym_alignas] = ACTIONS(2386),
    [anon_sym__Alignas] = ACTIONS(2386),
    [sym_primitive_type] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_struct] = ACTIONS(2386),
    [anon_sym_union] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_goto] = ACTIONS(2386),
    [anon_sym___try] = ACTIONS(2386),
    [anon_sym___leave] = ACTIONS(2386),
    [anon_sym_not] = ACTIONS(2386),
    [anon_sym_compl] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2386),
    [anon_sym___alignof__] = ACTIONS(2386),
    [anon_sym___alignof] = ACTIONS(2386),
    [anon_sym__alignof] = ACTIONS(2386),
    [anon_sym_alignof] = ACTIONS(2386),
    [anon_sym__Alignof] = ACTIONS(2386),
    [anon_sym_offsetof] = ACTIONS(2386),
    [anon_sym__Generic] = ACTIONS(2386),
    [anon_sym_asm] = ACTIONS(2386),
    [anon_sym___asm__] = ACTIONS(2386),
    [anon_sym___asm] = ACTIONS(2386),
    [sym_number_literal] = ACTIONS(2388),
    [anon_sym_L_SQUOTE] = ACTIONS(2388),
    [anon_sym_u_SQUOTE] = ACTIONS(2388),
    [anon_sym_U_SQUOTE] = ACTIONS(2388),
    [anon_sym_u8_SQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_L_DQUOTE] = ACTIONS(2388),
    [anon_sym_u_DQUOTE] = ACTIONS(2388),
    [anon_sym_U_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8_DQUOTE] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [anon_sym_NULL] = ACTIONS(2386),
    [anon_sym_nullptr] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2386),
    [anon_sym_decltype] = ACTIONS(2386),
    [anon_sym_typename] = ACTIONS(2386),
    [anon_sym_template] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_co_return] = ACTIONS(2386),
    [anon_sym_co_yield] = ACTIONS(2386),
    [anon_sym_R_DQUOTE] = ACTIONS(2388),
    [anon_sym_LR_DQUOTE] = ACTIONS(2388),
    [anon_sym_uR_DQUOTE] = ACTIONS(2388),
    [anon_sym_UR_DQUOTE] = ACTIONS(2388),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2388),
    [anon_sym_co_await] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_requires] = ACTIONS(2386),
    [sym_this] = ACTIONS(2386),
    [anon_sym_discard] = ACTIONS(2386),
    [anon_sym_precise] = ACTIONS(2386),
    [anon_sym_shared] = ACTIONS(2386),
    [anon_sym_groupshared] = ACTIONS(2386),
    [anon_sym_uniform] = ACTIONS(2386),
    [anon_sym_row_major] = ACTIONS(2386),
    [anon_sym_column_major] = ACTIONS(2386),
    [anon_sym_globallycoherent] = ACTIONS(2386),
    [anon_sym_centroid] = ACTIONS(2386),
    [anon_sym_noperspective] = ACTIONS(2386),
    [anon_sym_nointerpolation] = ACTIONS(2386),
    [anon_sym_sample] = ACTIONS(2386),
    [anon_sym_linear] = ACTIONS(2386),
    [anon_sym_snorm] = ACTIONS(2386),
    [anon_sym_unorm] = ACTIONS(2386),
    [anon_sym_point] = ACTIONS(2386),
    [anon_sym_line] = ACTIONS(2386),
    [anon_sym_triangleadj] = ACTIONS(2386),
    [anon_sym_lineadj] = ACTIONS(2386),
    [anon_sym_triangle] = ACTIONS(2386),
    [anon_sym_cbuffer] = ACTIONS(2386),
  },
  [1118] = {
    [sym_identifier] = ACTIONS(2262),
    [anon_sym_LPAREN2] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_PLUS] = ACTIONS(2262),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2264),
    [anon_sym___extension__] = ACTIONS(2262),
    [anon_sym_typedef] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2262),
    [anon_sym_out] = ACTIONS(2262),
    [anon_sym_inout] = ACTIONS(2262),
    [anon_sym_virtual] = ACTIONS(2262),
    [anon_sym_extern] = ACTIONS(2262),
    [anon_sym___attribute__] = ACTIONS(2262),
    [anon_sym___attribute] = ACTIONS(2262),
    [anon_sym_COLON_COLON] = ACTIONS(2264),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2264),
    [anon_sym___declspec] = ACTIONS(2262),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_signed] = ACTIONS(2262),
    [anon_sym_unsigned] = ACTIONS(2262),
    [anon_sym_long] = ACTIONS(2262),
    [anon_sym_short] = ACTIONS(2262),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_static] = ACTIONS(2262),
    [anon_sym_register] = ACTIONS(2262),
    [anon_sym_inline] = ACTIONS(2262),
    [anon_sym___inline] = ACTIONS(2262),
    [anon_sym___inline__] = ACTIONS(2262),
    [anon_sym___forceinline] = ACTIONS(2262),
    [anon_sym_thread_local] = ACTIONS(2262),
    [anon_sym___thread] = ACTIONS(2262),
    [anon_sym_const] = ACTIONS(2262),
    [anon_sym_constexpr] = ACTIONS(2262),
    [anon_sym_volatile] = ACTIONS(2262),
    [anon_sym_restrict] = ACTIONS(2262),
    [anon_sym___restrict__] = ACTIONS(2262),
    [anon_sym__Atomic] = ACTIONS(2262),
    [anon_sym__Noreturn] = ACTIONS(2262),
    [anon_sym_noreturn] = ACTIONS(2262),
    [anon_sym__Nonnull] = ACTIONS(2262),
    [anon_sym_mutable] = ACTIONS(2262),
    [anon_sym_constinit] = ACTIONS(2262),
    [anon_sym_consteval] = ACTIONS(2262),
    [anon_sym_alignas] = ACTIONS(2262),
    [anon_sym__Alignas] = ACTIONS(2262),
    [sym_primitive_type] = ACTIONS(2262),
    [anon_sym_enum] = ACTIONS(2262),
    [anon_sym_class] = ACTIONS(2262),
    [anon_sym_struct] = ACTIONS(2262),
    [anon_sym_union] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2262),
    [anon_sym_else] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2262),
    [anon_sym_while] = ACTIONS(2262),
    [anon_sym_do] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2262),
    [anon_sym_break] = ACTIONS(2262),
    [anon_sym_continue] = ACTIONS(2262),
    [anon_sym_goto] = ACTIONS(2262),
    [anon_sym___try] = ACTIONS(2262),
    [anon_sym___leave] = ACTIONS(2262),
    [anon_sym_not] = ACTIONS(2262),
    [anon_sym_compl] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2262),
    [anon_sym___alignof__] = ACTIONS(2262),
    [anon_sym___alignof] = ACTIONS(2262),
    [anon_sym__alignof] = ACTIONS(2262),
    [anon_sym_alignof] = ACTIONS(2262),
    [anon_sym__Alignof] = ACTIONS(2262),
    [anon_sym_offsetof] = ACTIONS(2262),
    [anon_sym__Generic] = ACTIONS(2262),
    [anon_sym_asm] = ACTIONS(2262),
    [anon_sym___asm__] = ACTIONS(2262),
    [anon_sym___asm] = ACTIONS(2262),
    [sym_number_literal] = ACTIONS(2264),
    [anon_sym_L_SQUOTE] = ACTIONS(2264),
    [anon_sym_u_SQUOTE] = ACTIONS(2264),
    [anon_sym_U_SQUOTE] = ACTIONS(2264),
    [anon_sym_u8_SQUOTE] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2264),
    [anon_sym_L_DQUOTE] = ACTIONS(2264),
    [anon_sym_u_DQUOTE] = ACTIONS(2264),
    [anon_sym_U_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8_DQUOTE] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(2264),
    [sym_true] = ACTIONS(2262),
    [sym_false] = ACTIONS(2262),
    [anon_sym_NULL] = ACTIONS(2262),
    [anon_sym_nullptr] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2262),
    [anon_sym_decltype] = ACTIONS(2262),
    [anon_sym_typename] = ACTIONS(2262),
    [anon_sym_template] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2262),
    [anon_sym_delete] = ACTIONS(2262),
    [anon_sym_throw] = ACTIONS(2262),
    [anon_sym_co_return] = ACTIONS(2262),
    [anon_sym_co_yield] = ACTIONS(2262),
    [anon_sym_R_DQUOTE] = ACTIONS(2264),
    [anon_sym_LR_DQUOTE] = ACTIONS(2264),
    [anon_sym_uR_DQUOTE] = ACTIONS(2264),
    [anon_sym_UR_DQUOTE] = ACTIONS(2264),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2264),
    [anon_sym_co_await] = ACTIONS(2262),
    [anon_sym_new] = ACTIONS(2262),
    [anon_sym_requires] = ACTIONS(2262),
    [sym_this] = ACTIONS(2262),
    [anon_sym_discard] = ACTIONS(2262),
    [anon_sym_precise] = ACTIONS(2262),
    [anon_sym_shared] = ACTIONS(2262),
    [anon_sym_groupshared] = ACTIONS(2262),
    [anon_sym_uniform] = ACTIONS(2262),
    [anon_sym_row_major] = ACTIONS(2262),
    [anon_sym_column_major] = ACTIONS(2262),
    [anon_sym_globallycoherent] = ACTIONS(2262),
    [anon_sym_centroid] = ACTIONS(2262),
    [anon_sym_noperspective] = ACTIONS(2262),
    [anon_sym_nointerpolation] = ACTIONS(2262),
    [anon_sym_sample] = ACTIONS(2262),
    [anon_sym_linear] = ACTIONS(2262),
    [anon_sym_snorm] = ACTIONS(2262),
    [anon_sym_unorm] = ACTIONS(2262),
    [anon_sym_point] = ACTIONS(2262),
    [anon_sym_line] = ACTIONS(2262),
    [anon_sym_triangleadj] = ACTIONS(2262),
    [anon_sym_lineadj] = ACTIONS(2262),
    [anon_sym_triangle] = ACTIONS(2262),
    [anon_sym_cbuffer] = ACTIONS(2262),
  },
  [1119] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1283),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4261),
    [anon_sym_SEMI] = ACTIONS(4273),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1120] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_call_modifier] = STATE(4910),
    [sym__declarator] = STATE(6854),
    [sym__abstract_declarator] = STATE(7116),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_list] = STATE(3376),
    [sym_parameter_declaration] = STATE(7627),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7627),
    [sym_variadic_parameter_declaration] = STATE(7627),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(2326),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5954),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(4277),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4287),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4289),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1121] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(3800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [aux_sym_preproc_if_token2] = ACTIONS(3802),
    [aux_sym_preproc_else_token1] = ACTIONS(3802),
    [aux_sym_preproc_elif_token1] = ACTIONS(3800),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3802),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4291),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1122] = {
    [sym_string_literal] = STATE(2884),
    [sym_template_argument_list] = STATE(1232),
    [sym_raw_string_literal] = STATE(2884),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4315),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4227),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4318),
    [anon_sym_or_eq] = ACTIONS(4318),
    [anon_sym_xor_eq] = ACTIONS(4318),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(4320),
    [anon_sym_u_DQUOTE] = ACTIONS(4320),
    [anon_sym_U_DQUOTE] = ACTIONS(4320),
    [anon_sym_u8_DQUOTE] = ACTIONS(4320),
    [anon_sym_DQUOTE] = ACTIONS(4320),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4322),
    [anon_sym_LR_DQUOTE] = ACTIONS(4322),
    [anon_sym_uR_DQUOTE] = ACTIONS(4322),
    [anon_sym_UR_DQUOTE] = ACTIONS(4322),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4322),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1123] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1124] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1459),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1125] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4269),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1126] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4326),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3802),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym___attribute__] = ACTIONS(3800),
    [anon_sym___attribute] = ACTIONS(3800),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1127] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4261),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1128] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1129] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_RPAREN] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3802),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1130] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1131] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1132] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(1476),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(4233),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4271),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4247),
    [anon_sym_or_eq] = ACTIONS(4247),
    [anon_sym_xor_eq] = ACTIONS(4247),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [1133] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3802),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [anon_sym_RBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1134] = {
    [sym_expression] = STATE(4749),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4374),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3802),
    [anon_sym_COLON] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1135] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_initializer_list] = STATE(5039),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3802),
    [anon_sym_COMMA] = ACTIONS(3802),
    [anon_sym_LPAREN2] = ACTIONS(3802),
    [anon_sym_BANG] = ACTIONS(4093),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(3800),
    [anon_sym_PLUS] = ACTIONS(3800),
    [anon_sym_STAR] = ACTIONS(3802),
    [anon_sym_SLASH] = ACTIONS(3800),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_PIPE_PIPE] = ACTIONS(3802),
    [anon_sym_AMP_AMP] = ACTIONS(3802),
    [anon_sym_PIPE] = ACTIONS(3800),
    [anon_sym_CARET] = ACTIONS(3802),
    [anon_sym_AMP] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3802),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_GT] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3800),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_LT] = ACTIONS(3800),
    [anon_sym_LT_LT] = ACTIONS(3802),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACE] = ACTIONS(4392),
    [anon_sym_LBRACK] = ACTIONS(3802),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_QMARK] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_or] = ACTIONS(3800),
    [anon_sym_and] = ACTIONS(3800),
    [anon_sym_bitor] = ACTIONS(3800),
    [anon_sym_xor] = ACTIONS(3800),
    [anon_sym_bitand] = ACTIONS(3800),
    [anon_sym_not_eq] = ACTIONS(3800),
    [anon_sym_DASH_DASH] = ACTIONS(3802),
    [anon_sym_PLUS_PLUS] = ACTIONS(3802),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [anon_sym_DOT] = ACTIONS(3800),
    [anon_sym_DOT_STAR] = ACTIONS(3802),
    [anon_sym_DASH_GT] = ACTIONS(3802),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(3802),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1136] = {
    [sym_expression] = STATE(4939),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4396),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_SLASH] = ACTIONS(4400),
    [anon_sym_PERCENT] = ACTIONS(4396),
    [anon_sym_PIPE_PIPE] = ACTIONS(4396),
    [anon_sym_AMP_AMP] = ACTIONS(4396),
    [anon_sym_PIPE] = ACTIONS(4400),
    [anon_sym_CARET] = ACTIONS(4396),
    [anon_sym_AMP] = ACTIONS(1300),
    [anon_sym_EQ_EQ] = ACTIONS(4396),
    [anon_sym_BANG_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4400),
    [anon_sym_GT_EQ] = ACTIONS(4396),
    [anon_sym_LT_EQ] = ACTIONS(4400),
    [anon_sym_LT] = ACTIONS(4400),
    [anon_sym_LT_LT] = ACTIONS(4396),
    [anon_sym_GT_GT] = ACTIONS(4396),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(4396),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_QMARK] = ACTIONS(4396),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_LT_EQ_GT] = ACTIONS(4396),
    [anon_sym_or] = ACTIONS(4400),
    [anon_sym_and] = ACTIONS(4400),
    [anon_sym_bitor] = ACTIONS(4400),
    [anon_sym_xor] = ACTIONS(4400),
    [anon_sym_bitand] = ACTIONS(4400),
    [anon_sym_not_eq] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(4400),
    [anon_sym_DOT_STAR] = ACTIONS(4396),
    [anon_sym_DASH_GT] = ACTIONS(4396),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1137] = {
    [sym_expression] = STATE(3440),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4407),
    [anon_sym_COLON_COLON] = ACTIONS(4410),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(4413),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1138] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4419),
    [anon_sym_COLON_COLON] = ACTIONS(4422),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(4425),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1139] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(2175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(2192),
    [anon_sym_COLON_COLON] = ACTIONS(2199),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1140] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_and_eq] = ACTIONS(1975),
    [anon_sym_or_eq] = ACTIONS(1975),
    [anon_sym_xor_eq] = ACTIONS(1975),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [1141] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1973),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_and_eq] = ACTIONS(1971),
    [anon_sym_or_eq] = ACTIONS(1971),
    [anon_sym_xor_eq] = ACTIONS(1971),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [1142] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1955),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_and_eq] = ACTIONS(1953),
    [anon_sym_or_eq] = ACTIONS(1953),
    [anon_sym_xor_eq] = ACTIONS(1953),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [1143] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_and_eq] = ACTIONS(1979),
    [anon_sym_or_eq] = ACTIONS(1979),
    [anon_sym_xor_eq] = ACTIONS(1979),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [1144] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1993),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_and_eq] = ACTIONS(1991),
    [anon_sym_or_eq] = ACTIONS(1991),
    [anon_sym_xor_eq] = ACTIONS(1991),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [1145] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_and_eq] = ACTIONS(1987),
    [anon_sym_or_eq] = ACTIONS(1987),
    [anon_sym_xor_eq] = ACTIONS(1987),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_and_eq] = ACTIONS(1983),
    [anon_sym_or_eq] = ACTIONS(1983),
    [anon_sym_xor_eq] = ACTIONS(1983),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [1147] = {
    [sym_template_argument_list] = STATE(1159),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(4438),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4430),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4433),
    [anon_sym_or_eq] = ACTIONS(4433),
    [anon_sym_xor_eq] = ACTIONS(4433),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4433),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4433),
    [anon_sym_not_eq] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [1148] = {
    [sym_expression] = STATE(4550),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1149] = {
    [sym_expression] = STATE(3850),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1150] = {
    [sym_expression] = STATE(3640),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1151] = {
    [sym_expression] = STATE(3278),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1152] = {
    [sym_expression] = STATE(3330),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1153] = {
    [sym_expression] = STATE(3614),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1154] = {
    [sym_expression] = STATE(3275),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1155] = {
    [sym_expression] = STATE(4698),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1156] = {
    [sym_expression] = STATE(3384),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1157] = {
    [sym_expression] = STATE(4707),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1158] = {
    [sym_expression] = STATE(3473),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1159] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4453),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4456),
    [anon_sym_or_eq] = ACTIONS(4456),
    [anon_sym_xor_eq] = ACTIONS(4456),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1160] = {
    [sym_expression] = STATE(3457),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1161] = {
    [sym_expression] = STATE(3943),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1162] = {
    [sym_expression] = STATE(4361),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1163] = {
    [sym_expression] = STATE(4553),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1164] = {
    [sym_expression] = STATE(3160),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1165] = {
    [sym_expression] = STATE(3636),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1166] = {
    [sym_expression] = STATE(3638),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1167] = {
    [sym_expression] = STATE(3158),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1168] = {
    [sym_expression] = STATE(4760),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1169] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1170] = {
    [sym_expression] = STATE(4678),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1171] = {
    [sym_expression] = STATE(4786),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1172] = {
    [sym_expression] = STATE(4489),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1173] = {
    [sym_expression] = STATE(4364),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1174] = {
    [sym_expression] = STATE(4551),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(4443),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4441),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(4443),
    [anon_sym_constexpr] = ACTIONS(4443),
    [anon_sym_volatile] = ACTIONS(4443),
    [anon_sym_restrict] = ACTIONS(4443),
    [anon_sym___restrict__] = ACTIONS(4443),
    [anon_sym__Atomic] = ACTIONS(4443),
    [anon_sym__Noreturn] = ACTIONS(4443),
    [anon_sym_noreturn] = ACTIONS(4443),
    [anon_sym__Nonnull] = ACTIONS(4443),
    [anon_sym_mutable] = ACTIONS(4443),
    [anon_sym_constinit] = ACTIONS(4443),
    [anon_sym_consteval] = ACTIONS(4443),
    [anon_sym_alignas] = ACTIONS(4443),
    [anon_sym__Alignas] = ACTIONS(4443),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(4441),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_noexcept] = ACTIONS(4443),
    [anon_sym_throw] = ACTIONS(4443),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1175] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4863),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4477),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4483),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1176] = {
    [sym_type_qualifier] = STATE(1175),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4980),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1175),
    [sym_identifier] = ACTIONS(4489),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4491),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4493),
    [anon_sym_RBRACK] = ACTIONS(4495),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1177] = {
    [sym_type_qualifier] = STATE(1184),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4946),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1184),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4497),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4499),
    [anon_sym_RBRACK] = ACTIONS(4501),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1178] = {
    [sym_type_qualifier] = STATE(1189),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4944),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1189),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4503),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4505),
    [anon_sym_RBRACK] = ACTIONS(4507),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1179] = {
    [sym_type_qualifier] = STATE(1190),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4864),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1190),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4509),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4511),
    [anon_sym_RBRACK] = ACTIONS(4513),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1180] = {
    [sym_type_qualifier] = STATE(1191),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4866),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1191),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4515),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4517),
    [anon_sym_RBRACK] = ACTIONS(4519),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1181] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_ms_call_modifier] = STATE(6513),
    [sym__abstract_declarator] = STATE(7116),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_list] = STATE(3376),
    [sym_parameter_declaration] = STATE(7627),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7627),
    [sym_variadic_parameter_declaration] = STATE(7627),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(4277),
    [anon_sym_LPAREN2] = ACTIONS(4523),
    [anon_sym_STAR] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_AMP] = ACTIONS(4529),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1182] = {
    [sym_type_qualifier] = STATE(1175),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4980),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1175),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4491),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4493),
    [anon_sym_RBRACK] = ACTIONS(4495),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1183] = {
    [sym_type_qualifier] = STATE(1185),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4881),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1185),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4535),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4537),
    [anon_sym_RBRACK] = ACTIONS(4539),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1184] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4967),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4541),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4543),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1185] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4882),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4545),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4547),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1186] = {
    [sym_type_qualifier] = STATE(1188),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4900),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1188),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4549),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4551),
    [anon_sym_RBRACK] = ACTIONS(4553),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1187] = {
    [sym_type_qualifier] = STATE(1197),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4852),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1197),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4555),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4557),
    [anon_sym_RBRACK] = ACTIONS(4559),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1188] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4901),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4563),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1189] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4853),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4567),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1190] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4936),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4569),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4571),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1191] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4937),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4575),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1192] = {
    [sym_type_qualifier] = STATE(1196),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4851),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1196),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4577),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4579),
    [anon_sym_RBRACK] = ACTIONS(4581),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1193] = {
    [sym_type_qualifier] = STATE(1195),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4843),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(1195),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4583),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4585),
    [anon_sym_RBRACK] = ACTIONS(4587),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1194] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_ms_call_modifier] = STATE(6447),
    [sym__abstract_declarator] = STATE(7114),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_list] = STATE(3376),
    [sym_parameter_declaration] = STATE(7627),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7627),
    [sym_variadic_parameter_declaration] = STATE(7627),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(4277),
    [anon_sym_LPAREN2] = ACTIONS(4523),
    [anon_sym_STAR] = ACTIONS(4525),
    [anon_sym_AMP_AMP] = ACTIONS(4527),
    [anon_sym_AMP] = ACTIONS(4529),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(2060),
    [anon_sym___clrcall] = ACTIONS(2060),
    [anon_sym___stdcall] = ACTIONS(2060),
    [anon_sym___fastcall] = ACTIONS(2060),
    [anon_sym___thiscall] = ACTIONS(2060),
    [anon_sym___vectorcall] = ACTIONS(2060),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4533),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1195] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4850),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4589),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4591),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1196] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4855),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4593),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4595),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1197] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [sym_expression] = STATE(4856),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4597),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4479),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_static] = ACTIONS(4481),
    [anon_sym_RBRACK] = ACTIONS(4599),
    [anon_sym_const] = ACTIONS(4485),
    [anon_sym_constexpr] = ACTIONS(4485),
    [anon_sym_volatile] = ACTIONS(4485),
    [anon_sym_restrict] = ACTIONS(4485),
    [anon_sym___restrict__] = ACTIONS(4485),
    [anon_sym__Atomic] = ACTIONS(4485),
    [anon_sym__Noreturn] = ACTIONS(4485),
    [anon_sym_noreturn] = ACTIONS(4485),
    [anon_sym__Nonnull] = ACTIONS(4485),
    [anon_sym_mutable] = ACTIONS(4485),
    [anon_sym_constinit] = ACTIONS(4485),
    [anon_sym_consteval] = ACTIONS(4485),
    [anon_sym_alignas] = ACTIONS(4487),
    [anon_sym__Alignas] = ACTIONS(4487),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1198] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1973),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1973),
    [anon_sym_GT_GT] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_RBRACK] = ACTIONS(1973),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [anon_sym_else] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_try] = ACTIONS(1971),
    [anon_sym_noexcept] = ACTIONS(1971),
    [anon_sym_throw] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [1199] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1985),
    [anon_sym_GT_GT] = ACTIONS(1985),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [anon_sym_else] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_try] = ACTIONS(1983),
    [anon_sym_noexcept] = ACTIONS(1983),
    [anon_sym_throw] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [1200] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1993),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1993),
    [anon_sym_GT_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_RBRACK] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [anon_sym_else] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_try] = ACTIONS(1991),
    [anon_sym_noexcept] = ACTIONS(1991),
    [anon_sym_throw] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [1201] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1981),
    [anon_sym_GT_GT] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_noexcept] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [1202] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1955),
    [anon_sym_GT_GT] = ACTIONS(1955),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_RBRACK] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [anon_sym_else] = ACTIONS(1953),
    [anon_sym_while] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_try] = ACTIONS(1953),
    [anon_sym_noexcept] = ACTIONS(1953),
    [anon_sym_throw] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [1203] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1977),
    [anon_sym_GT_GT] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [anon_sym_else] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_try] = ACTIONS(1975),
    [anon_sym_noexcept] = ACTIONS(1975),
    [anon_sym_throw] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [1204] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1989),
    [anon_sym_GT_GT] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [anon_sym_else] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_try] = ACTIONS(1987),
    [anon_sym_noexcept] = ACTIONS(1987),
    [anon_sym_throw] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [1205] = {
    [sym_identifier] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2839),
    [anon_sym_BANG] = ACTIONS(2839),
    [anon_sym_TILDE] = ACTIONS(2839),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_AMP] = ACTIONS(2839),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_out] = ACTIONS(2834),
    [anon_sym_inout] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2839),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(2834),
    [anon_sym_compl] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2839),
    [anon_sym_PLUS_PLUS] = ACTIONS(2839),
    [anon_sym_sizeof] = ACTIONS(2834),
    [anon_sym___alignof__] = ACTIONS(2834),
    [anon_sym___alignof] = ACTIONS(2834),
    [anon_sym__alignof] = ACTIONS(2834),
    [anon_sym_alignof] = ACTIONS(2834),
    [anon_sym__Alignof] = ACTIONS(2834),
    [anon_sym_offsetof] = ACTIONS(2834),
    [anon_sym__Generic] = ACTIONS(2834),
    [anon_sym_asm] = ACTIONS(2834),
    [anon_sym___asm__] = ACTIONS(2834),
    [anon_sym___asm] = ACTIONS(2834),
    [sym_number_literal] = ACTIONS(2839),
    [anon_sym_L_SQUOTE] = ACTIONS(2839),
    [anon_sym_u_SQUOTE] = ACTIONS(2839),
    [anon_sym_U_SQUOTE] = ACTIONS(2839),
    [anon_sym_u8_SQUOTE] = ACTIONS(2839),
    [anon_sym_SQUOTE] = ACTIONS(2839),
    [anon_sym_L_DQUOTE] = ACTIONS(2839),
    [anon_sym_u_DQUOTE] = ACTIONS(2839),
    [anon_sym_U_DQUOTE] = ACTIONS(2839),
    [anon_sym_u8_DQUOTE] = ACTIONS(2839),
    [anon_sym_DQUOTE] = ACTIONS(2839),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [anon_sym_NULL] = ACTIONS(2834),
    [anon_sym_nullptr] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_delete] = ACTIONS(2834),
    [anon_sym_R_DQUOTE] = ACTIONS(2839),
    [anon_sym_LR_DQUOTE] = ACTIONS(2839),
    [anon_sym_uR_DQUOTE] = ACTIONS(2839),
    [anon_sym_UR_DQUOTE] = ACTIONS(2839),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2839),
    [anon_sym_co_await] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_requires] = ACTIONS(2834),
    [sym_this] = ACTIONS(2834),
    [anon_sym_precise] = ACTIONS(2834),
    [anon_sym_shared] = ACTIONS(2834),
    [anon_sym_groupshared] = ACTIONS(2834),
    [anon_sym_uniform] = ACTIONS(2834),
    [anon_sym_row_major] = ACTIONS(2834),
    [anon_sym_column_major] = ACTIONS(2834),
    [anon_sym_globallycoherent] = ACTIONS(2834),
    [anon_sym_centroid] = ACTIONS(2834),
    [anon_sym_noperspective] = ACTIONS(2834),
    [anon_sym_nointerpolation] = ACTIONS(2834),
    [anon_sym_sample] = ACTIONS(2834),
    [anon_sym_linear] = ACTIONS(2834),
    [anon_sym_snorm] = ACTIONS(2834),
    [anon_sym_unorm] = ACTIONS(2834),
    [anon_sym_point] = ACTIONS(2834),
    [anon_sym_line] = ACTIONS(2834),
    [anon_sym_triangleadj] = ACTIONS(2834),
    [anon_sym_lineadj] = ACTIONS(2834),
    [anon_sym_triangle] = ACTIONS(2834),
  },
  [1206] = {
    [sym_expression] = STATE(3440),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_LPAREN2] = ACTIONS(4601),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(4607),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(4610),
    [anon_sym___extension__] = ACTIONS(4407),
    [anon_sym_COLON_COLON] = ACTIONS(4410),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(4613),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1207] = {
    [sym_identifier] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [anon_sym_not] = ACTIONS(2656),
    [anon_sym_compl] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2658),
    [anon_sym_sizeof] = ACTIONS(2656),
    [anon_sym___alignof__] = ACTIONS(2656),
    [anon_sym___alignof] = ACTIONS(2656),
    [anon_sym__alignof] = ACTIONS(2656),
    [anon_sym_alignof] = ACTIONS(2656),
    [anon_sym__Alignof] = ACTIONS(2656),
    [anon_sym_offsetof] = ACTIONS(2656),
    [anon_sym__Generic] = ACTIONS(2656),
    [anon_sym_asm] = ACTIONS(2656),
    [anon_sym___asm__] = ACTIONS(2656),
    [anon_sym___asm] = ACTIONS(2656),
    [sym_number_literal] = ACTIONS(2658),
    [anon_sym_L_SQUOTE] = ACTIONS(2658),
    [anon_sym_u_SQUOTE] = ACTIONS(2658),
    [anon_sym_U_SQUOTE] = ACTIONS(2658),
    [anon_sym_u8_SQUOTE] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_L_DQUOTE] = ACTIONS(2658),
    [anon_sym_u_DQUOTE] = ACTIONS(2658),
    [anon_sym_U_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8_DQUOTE] = ACTIONS(2658),
    [anon_sym_DQUOTE] = ACTIONS(2658),
    [sym_true] = ACTIONS(2656),
    [sym_false] = ACTIONS(2656),
    [anon_sym_NULL] = ACTIONS(2656),
    [anon_sym_nullptr] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_delete] = ACTIONS(2656),
    [anon_sym_R_DQUOTE] = ACTIONS(2658),
    [anon_sym_LR_DQUOTE] = ACTIONS(2658),
    [anon_sym_uR_DQUOTE] = ACTIONS(2658),
    [anon_sym_UR_DQUOTE] = ACTIONS(2658),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2658),
    [anon_sym_co_await] = ACTIONS(2656),
    [anon_sym_new] = ACTIONS(2656),
    [anon_sym_requires] = ACTIONS(2656),
    [sym_this] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [1208] = {
    [sym_expression] = STATE(3251),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(4616),
    [anon_sym_LPAREN2] = ACTIONS(4619),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(4622),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2189),
    [anon_sym___extension__] = ACTIONS(4625),
    [anon_sym_COLON_COLON] = ACTIONS(4628),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(4613),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1209] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5540),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6874),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_parameter_list] = STATE(983),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2812),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5946),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4631),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1210] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5588),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6914),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_parameter_list] = STATE(980),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2812),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5946),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4631),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1211] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5560),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6875),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_parameter_list] = STATE(985),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2812),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5946),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4631),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1212] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5574),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6865),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_parameter_list] = STATE(981),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2812),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5946),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4631),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(4633),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1213] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [anon_sym_not] = ACTIONS(2596),
    [anon_sym_compl] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2598),
    [anon_sym_sizeof] = ACTIONS(2596),
    [anon_sym___alignof__] = ACTIONS(2596),
    [anon_sym___alignof] = ACTIONS(2596),
    [anon_sym__alignof] = ACTIONS(2596),
    [anon_sym_alignof] = ACTIONS(2596),
    [anon_sym__Alignof] = ACTIONS(2596),
    [anon_sym_offsetof] = ACTIONS(2596),
    [anon_sym__Generic] = ACTIONS(2596),
    [anon_sym_asm] = ACTIONS(2596),
    [anon_sym___asm__] = ACTIONS(2596),
    [anon_sym___asm] = ACTIONS(2596),
    [sym_number_literal] = ACTIONS(2598),
    [anon_sym_L_SQUOTE] = ACTIONS(2598),
    [anon_sym_u_SQUOTE] = ACTIONS(2598),
    [anon_sym_U_SQUOTE] = ACTIONS(2598),
    [anon_sym_u8_SQUOTE] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_L_DQUOTE] = ACTIONS(2598),
    [anon_sym_u_DQUOTE] = ACTIONS(2598),
    [anon_sym_U_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8_DQUOTE] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2598),
    [sym_true] = ACTIONS(2596),
    [sym_false] = ACTIONS(2596),
    [anon_sym_NULL] = ACTIONS(2596),
    [anon_sym_nullptr] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_delete] = ACTIONS(2596),
    [anon_sym_R_DQUOTE] = ACTIONS(2598),
    [anon_sym_LR_DQUOTE] = ACTIONS(2598),
    [anon_sym_uR_DQUOTE] = ACTIONS(2598),
    [anon_sym_UR_DQUOTE] = ACTIONS(2598),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2598),
    [anon_sym_co_await] = ACTIONS(2596),
    [anon_sym_new] = ACTIONS(2596),
    [anon_sym_requires] = ACTIONS(2596),
    [sym_this] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [1214] = {
    [sym_template_argument_list] = STATE(1220),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4430),
    [anon_sym_COMMA] = ACTIONS(4430),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(4435),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4433),
    [anon_sym_or_eq] = ACTIONS(4433),
    [anon_sym_xor_eq] = ACTIONS(4433),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4433),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4433),
    [anon_sym_not_eq] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4428),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [1215] = {
    [sym_template_argument_list] = STATE(1218),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(4438),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4433),
    [anon_sym_or_eq] = ACTIONS(4433),
    [anon_sym_xor_eq] = ACTIONS(4433),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4433),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4433),
    [anon_sym_not_eq] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [1216] = {
    [sym_expression] = STATE(4701),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4640),
    [anon_sym_LPAREN2] = ACTIONS(4643),
    [anon_sym_BANG] = ACTIONS(4646),
    [anon_sym_TILDE] = ACTIONS(4646),
    [anon_sym_DASH] = ACTIONS(4649),
    [anon_sym_PLUS] = ACTIONS(4649),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym___extension__] = ACTIONS(4652),
    [anon_sym_COLON_COLON] = ACTIONS(4655),
    [anon_sym_LBRACK] = ACTIONS(4613),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2205),
    [anon_sym_not] = ACTIONS(4649),
    [anon_sym_compl] = ACTIONS(4649),
    [anon_sym_DASH_DASH] = ACTIONS(4658),
    [anon_sym_PLUS_PLUS] = ACTIONS(4658),
    [anon_sym_sizeof] = ACTIONS(4661),
    [anon_sym___alignof__] = ACTIONS(4664),
    [anon_sym___alignof] = ACTIONS(4664),
    [anon_sym__alignof] = ACTIONS(4664),
    [anon_sym_alignof] = ACTIONS(4664),
    [anon_sym__Alignof] = ACTIONS(4664),
    [anon_sym_offsetof] = ACTIONS(4667),
    [anon_sym__Generic] = ACTIONS(4670),
    [anon_sym_asm] = ACTIONS(4673),
    [anon_sym___asm__] = ACTIONS(4673),
    [anon_sym___asm] = ACTIONS(4673),
    [sym_number_literal] = ACTIONS(4676),
    [anon_sym_L_SQUOTE] = ACTIONS(4679),
    [anon_sym_u_SQUOTE] = ACTIONS(4679),
    [anon_sym_U_SQUOTE] = ACTIONS(4679),
    [anon_sym_u8_SQUOTE] = ACTIONS(4679),
    [anon_sym_SQUOTE] = ACTIONS(4679),
    [anon_sym_L_DQUOTE] = ACTIONS(4682),
    [anon_sym_u_DQUOTE] = ACTIONS(4682),
    [anon_sym_U_DQUOTE] = ACTIONS(4682),
    [anon_sym_u8_DQUOTE] = ACTIONS(4682),
    [anon_sym_DQUOTE] = ACTIONS(4682),
    [sym_true] = ACTIONS(4685),
    [sym_false] = ACTIONS(4685),
    [anon_sym_NULL] = ACTIONS(4688),
    [anon_sym_nullptr] = ACTIONS(4688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2208),
    [anon_sym_template] = ACTIONS(2211),
    [anon_sym_delete] = ACTIONS(4691),
    [anon_sym_R_DQUOTE] = ACTIONS(4694),
    [anon_sym_LR_DQUOTE] = ACTIONS(4694),
    [anon_sym_uR_DQUOTE] = ACTIONS(4694),
    [anon_sym_UR_DQUOTE] = ACTIONS(4694),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4694),
    [anon_sym_co_await] = ACTIONS(4697),
    [anon_sym_new] = ACTIONS(4700),
    [anon_sym_requires] = ACTIONS(4703),
    [sym_this] = ACTIONS(4685),
  },
  [1217] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_and_eq] = ACTIONS(1979),
    [anon_sym_or_eq] = ACTIONS(1979),
    [anon_sym_xor_eq] = ACTIONS(1979),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1981),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [1218] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4456),
    [anon_sym_or_eq] = ACTIONS(4456),
    [anon_sym_xor_eq] = ACTIONS(4456),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1219] = {
    [sym_template_argument_list] = STATE(1227),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4430),
    [anon_sym_COMMA] = ACTIONS(4430),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(4438),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(4435),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4433),
    [anon_sym_or_eq] = ACTIONS(4433),
    [anon_sym_xor_eq] = ACTIONS(4433),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4433),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4433),
    [anon_sym_not_eq] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [1220] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(4458),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4456),
    [anon_sym_or_eq] = ACTIONS(4456),
    [anon_sym_xor_eq] = ACTIONS(4456),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4451),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1221] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_and_eq] = ACTIONS(1987),
    [anon_sym_or_eq] = ACTIONS(1987),
    [anon_sym_xor_eq] = ACTIONS(1987),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1989),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [1222] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1993),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_and_eq] = ACTIONS(1991),
    [anon_sym_or_eq] = ACTIONS(1991),
    [anon_sym_xor_eq] = ACTIONS(1991),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1993),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [1223] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1973),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_and_eq] = ACTIONS(1971),
    [anon_sym_or_eq] = ACTIONS(1971),
    [anon_sym_xor_eq] = ACTIONS(1971),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1973),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [1224] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_and_eq] = ACTIONS(1983),
    [anon_sym_or_eq] = ACTIONS(1983),
    [anon_sym_xor_eq] = ACTIONS(1983),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1985),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [1225] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_and_eq] = ACTIONS(1975),
    [anon_sym_or_eq] = ACTIONS(1975),
    [anon_sym_xor_eq] = ACTIONS(1975),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1977),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [1226] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1955),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_and_eq] = ACTIONS(1953),
    [anon_sym_or_eq] = ACTIONS(1953),
    [anon_sym_xor_eq] = ACTIONS(1953),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1955),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [1227] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(4458),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4456),
    [anon_sym_or_eq] = ACTIONS(4456),
    [anon_sym_xor_eq] = ACTIONS(4456),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1228] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6706),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_expression] = STATE(3444),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3563),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5861),
    [sym_qualified_identifier] = STATE(3606),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(4255),
    [anon_sym_LPAREN2] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2048),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1229] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6706),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6529),
    [sym_array_declarator] = STATE(6529),
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3525),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5854),
    [sym_qualified_identifier] = STATE(3527),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_operator_name] = STATE(6529),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(4197),
    [anon_sym_LPAREN2] = ACTIONS(4199),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(4201),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1230] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1955),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1955),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [1231] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1977),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [1232] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(4458),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4451),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1233] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1973),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1973),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [1234] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1981),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [1235] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1985),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [1236] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1993),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1993),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [1237] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1989),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [1238] = {
    [sym_expression] = STATE(4632),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(7808),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4708),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1239] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1258),
    [sym_compound_requirement] = STATE(1258),
    [sym__requirement] = STATE(1258),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1258),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4716),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1240] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1241),
    [sym_compound_requirement] = STATE(1241),
    [sym__requirement] = STATE(1241),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1241),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4720),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1241] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4722),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1242] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1244),
    [sym_compound_requirement] = STATE(1244),
    [sym__requirement] = STATE(1244),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1244),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4724),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1243] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1256),
    [sym_compound_requirement] = STATE(1256),
    [sym__requirement] = STATE(1256),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1256),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4726),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1244] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4728),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1245] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1246),
    [sym_compound_requirement] = STATE(1246),
    [sym__requirement] = STATE(1246),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1246),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4730),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1246] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1247] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1248),
    [sym_compound_requirement] = STATE(1248),
    [sym__requirement] = STATE(1248),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1248),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1248] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1249] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1250] = {
    [sym_expression] = STATE(4592),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7624),
    [sym_initializer_pair] = STATE(7624),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(4740),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1251] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1249),
    [sym_compound_requirement] = STATE(1249),
    [sym__requirement] = STATE(1249),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1249),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1252] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1261),
    [sym_compound_requirement] = STATE(1261),
    [sym__requirement] = STATE(1261),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1261),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4746),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1253] = {
    [sym_expression] = STATE(4562),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7454),
    [sym_initializer_pair] = STATE(7454),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(4748),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4750),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1254] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1259),
    [sym_compound_requirement] = STATE(1259),
    [sym__requirement] = STATE(1259),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1259),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1255] = {
    [sym_expression] = STATE(4641),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7572),
    [sym_initializer_pair] = STATE(7572),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(4754),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1256] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4758),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1257] = {
    [sym_expression] = STATE(4587),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7736),
    [sym_initializer_pair] = STATE(7736),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(175),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4760),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1258] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1259] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1260] = {
    [sym_expression] = STATE(4625),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7395),
    [sym_initializer_pair] = STATE(7395),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(4766),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1261] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4770),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_typename] = ACTIONS(4718),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1262] = {
    [sym_expression_statement] = STATE(3155),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8428),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_type_requirement] = STATE(1262),
    [sym_compound_requirement] = STATE(1262),
    [sym__requirement] = STATE(1262),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_requirement_seq_repeat1] = STATE(1262),
    [sym_identifier] = ACTIONS(4772),
    [anon_sym_LPAREN2] = ACTIONS(4775),
    [anon_sym_BANG] = ACTIONS(4778),
    [anon_sym_TILDE] = ACTIONS(4778),
    [anon_sym_DASH] = ACTIONS(4781),
    [anon_sym_PLUS] = ACTIONS(4781),
    [anon_sym_STAR] = ACTIONS(4784),
    [anon_sym_AMP] = ACTIONS(4784),
    [anon_sym_SEMI] = ACTIONS(4787),
    [anon_sym___extension__] = ACTIONS(4790),
    [anon_sym_COLON_COLON] = ACTIONS(4793),
    [anon_sym_LBRACE] = ACTIONS(4796),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4801),
    [sym_primitive_type] = ACTIONS(4804),
    [anon_sym_not] = ACTIONS(4781),
    [anon_sym_compl] = ACTIONS(4781),
    [anon_sym_DASH_DASH] = ACTIONS(4807),
    [anon_sym_PLUS_PLUS] = ACTIONS(4807),
    [anon_sym_sizeof] = ACTIONS(4810),
    [anon_sym___alignof__] = ACTIONS(4813),
    [anon_sym___alignof] = ACTIONS(4813),
    [anon_sym__alignof] = ACTIONS(4813),
    [anon_sym_alignof] = ACTIONS(4813),
    [anon_sym__Alignof] = ACTIONS(4813),
    [anon_sym_offsetof] = ACTIONS(4816),
    [anon_sym__Generic] = ACTIONS(4819),
    [anon_sym_asm] = ACTIONS(4822),
    [anon_sym___asm__] = ACTIONS(4822),
    [anon_sym___asm] = ACTIONS(4822),
    [sym_number_literal] = ACTIONS(4825),
    [anon_sym_L_SQUOTE] = ACTIONS(4828),
    [anon_sym_u_SQUOTE] = ACTIONS(4828),
    [anon_sym_U_SQUOTE] = ACTIONS(4828),
    [anon_sym_u8_SQUOTE] = ACTIONS(4828),
    [anon_sym_SQUOTE] = ACTIONS(4828),
    [anon_sym_L_DQUOTE] = ACTIONS(4831),
    [anon_sym_u_DQUOTE] = ACTIONS(4831),
    [anon_sym_U_DQUOTE] = ACTIONS(4831),
    [anon_sym_u8_DQUOTE] = ACTIONS(4831),
    [anon_sym_DQUOTE] = ACTIONS(4831),
    [sym_true] = ACTIONS(4834),
    [sym_false] = ACTIONS(4834),
    [anon_sym_NULL] = ACTIONS(4837),
    [anon_sym_nullptr] = ACTIONS(4837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4840),
    [anon_sym_typename] = ACTIONS(4843),
    [anon_sym_template] = ACTIONS(4846),
    [anon_sym_delete] = ACTIONS(4849),
    [anon_sym_R_DQUOTE] = ACTIONS(4852),
    [anon_sym_LR_DQUOTE] = ACTIONS(4852),
    [anon_sym_uR_DQUOTE] = ACTIONS(4852),
    [anon_sym_UR_DQUOTE] = ACTIONS(4852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4852),
    [anon_sym_co_await] = ACTIONS(4855),
    [anon_sym_new] = ACTIONS(4858),
    [anon_sym_requires] = ACTIONS(4861),
    [sym_this] = ACTIONS(4834),
  },
  [1263] = {
    [sym_expression] = STATE(4582),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7616),
    [sym_initializer_pair] = STATE(7616),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1264] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4868),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1265] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4870),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1266] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1267] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4874),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1268] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4708),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1269] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4876),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1270] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4878),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1271] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1272] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4882),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1273] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1274] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4886),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1275] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1276] = {
    [sym_expression] = STATE(4947),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_lambda_default_capture] = STATE(7871),
    [sym__lambda_capture_identifier] = STATE(7527),
    [sym_lambda_capture_initializer] = STATE(7527),
    [sym__lambda_capture] = STATE(7527),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_identifier_parameter_pack_expansion] = STATE(7527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3866),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4892),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(4900),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4902),
  },
  [1277] = {
    [sym_expression] = STATE(4870),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_lambda_default_capture] = STATE(7871),
    [sym__lambda_capture_identifier] = STATE(7527),
    [sym_lambda_capture_initializer] = STATE(7527),
    [sym__lambda_capture] = STATE(7527),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_identifier_parameter_pack_expansion] = STATE(7527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3866),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4892),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(4900),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4902),
  },
  [1278] = {
    [sym_expression] = STATE(4691),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8078),
    [sym_initializer_pair] = STATE(8078),
    [sym_subscript_designator] = STATE(6970),
    [sym_subscript_range_designator] = STATE(6970),
    [sym_field_designator] = STATE(6970),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [aux_sym_initializer_pair_repeat1] = STATE(6970),
    [sym_identifier] = ACTIONS(4706),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(4710),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(227),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1279] = {
    [sym_expression] = STATE(4947),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_lambda_default_capture] = STATE(7871),
    [sym__lambda_capture_identifier] = STATE(7527),
    [sym_lambda_capture_initializer] = STATE(7527),
    [sym__lambda_capture] = STATE(7527),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_identifier_parameter_pack_expansion] = STATE(7527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3866),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4892),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(4900),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4902),
  },
  [1280] = {
    [sym_expression] = STATE(4827),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_lambda_default_capture] = STATE(7871),
    [sym__lambda_capture_identifier] = STATE(7527),
    [sym_lambda_capture_initializer] = STATE(7527),
    [sym__lambda_capture] = STATE(7527),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_identifier_parameter_pack_expansion] = STATE(7527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3866),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4892),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4894),
    [anon_sym_AMP] = ACTIONS(4896),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(4898),
    [anon_sym_EQ] = ACTIONS(4900),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(4902),
  },
  [1281] = {
    [sym_function_definition] = STATE(365),
    [sym_declaration] = STATE(365),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2028),
    [sym_declaration_list] = STATE(365),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1452),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(4906),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1282] = {
    [sym_function_definition] = STATE(581),
    [sym_declaration] = STATE(581),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2032),
    [sym_declaration_list] = STATE(581),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1485),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(4910),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1283] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4451),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4453),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_RBRACK] = ACTIONS(4451),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1284] = {
    [sym_function_definition] = STATE(839),
    [sym_declaration] = STATE(839),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2031),
    [sym_declaration_list] = STATE(839),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1499),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(4912),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1285] = {
    [sym_function_definition] = STATE(733),
    [sym_declaration] = STATE(733),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2033),
    [sym_declaration_list] = STATE(733),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(4914),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1286] = {
    [sym_function_definition] = STATE(576),
    [sym_declaration] = STATE(576),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8953),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_struct] = ACTIONS(4920),
    [anon_sym_union] = ACTIONS(4922),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1287] = {
    [sym_function_definition] = STATE(2174),
    [sym_declaration] = STATE(2174),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4969),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2023),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8252),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1493),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4924),
    [anon_sym_struct] = ACTIONS(4926),
    [anon_sym_union] = ACTIONS(4928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1288] = {
    [sym_function_definition] = STATE(749),
    [sym_declaration] = STATE(749),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2031),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8557),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1499),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4930),
    [anon_sym_struct] = ACTIONS(4932),
    [anon_sym_union] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1289] = {
    [sym_function_definition] = STATE(791),
    [sym_declaration] = STATE(791),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4873),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2031),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(9040),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1499),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4936),
    [anon_sym_struct] = ACTIONS(4938),
    [anon_sym_union] = ACTIONS(4940),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1290] = {
    [sym_function_definition] = STATE(275),
    [sym_declaration] = STATE(275),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2028),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8347),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1452),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4942),
    [anon_sym_struct] = ACTIONS(4944),
    [anon_sym_union] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1291] = {
    [sym_function_definition] = STATE(670),
    [sym_declaration] = STATE(670),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2032),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8406),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1485),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4948),
    [anon_sym_struct] = ACTIONS(4950),
    [anon_sym_union] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1292] = {
    [sym_function_definition] = STATE(281),
    [sym_declaration] = STATE(281),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4959),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2028),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8456),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1452),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4954),
    [anon_sym_struct] = ACTIONS(4956),
    [anon_sym_union] = ACTIONS(4958),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1293] = {
    [sym_function_definition] = STATE(2195),
    [sym_declaration] = STATE(2195),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4969),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2023),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8288),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1493),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4960),
    [anon_sym_struct] = ACTIONS(4962),
    [anon_sym_union] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1294] = {
    [sym_function_definition] = STATE(2091),
    [sym_declaration] = STATE(2091),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4966),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2035),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(9060),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1444),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4966),
    [anon_sym_struct] = ACTIONS(4968),
    [anon_sym_union] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1295] = {
    [sym_function_definition] = STATE(2096),
    [sym_declaration] = STATE(2096),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4966),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2035),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8317),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1444),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4972),
    [anon_sym_struct] = ACTIONS(4974),
    [anon_sym_union] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1296] = {
    [sym_function_definition] = STATE(1978),
    [sym_declaration] = STATE(1978),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4968),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2022),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(9054),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1490),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4978),
    [anon_sym_struct] = ACTIONS(4980),
    [anon_sym_union] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1297] = {
    [sym_function_definition] = STATE(1984),
    [sym_declaration] = STATE(1984),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4968),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2022),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8994),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1490),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4984),
    [anon_sym_struct] = ACTIONS(4986),
    [anon_sym_union] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1298] = {
    [sym_function_definition] = STATE(672),
    [sym_declaration] = STATE(672),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4964),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2032),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8501),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1485),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4990),
    [anon_sym_struct] = ACTIONS(4992),
    [anon_sym_union] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1299] = {
    [sym_function_definition] = STATE(724),
    [sym_declaration] = STATE(724),
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(4943),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym__class_name] = STATE(8739),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2527),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2528),
    [sym_qualifiers] = STATE(2043),
    [sym_hlsl_attribute] = STATE(1427),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4916),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(4996),
    [anon_sym_struct] = ACTIONS(4998),
    [anon_sym_union] = ACTIONS(5000),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1300] = {
    [sym_compound_statement] = STATE(7596),
    [sym_expression] = STATE(4588),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7596),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5002),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1301] = {
    [sym_expression] = STATE(4659),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8778),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8778),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5004),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1302] = {
    [sym_compound_statement] = STATE(7773),
    [sym_expression] = STATE(4622),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7773),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5006),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1303] = {
    [sym_compound_statement] = STATE(7611),
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7611),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5008),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1304] = {
    [sym_expression] = STATE(4742),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8500),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8500),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5010),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1305] = {
    [sym_compound_statement] = STATE(7602),
    [sym_expression] = STATE(4559),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7602),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5012),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1306] = {
    [sym_compound_statement] = STATE(7699),
    [sym_expression] = STATE(4640),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7699),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5014),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1307] = {
    [sym_compound_statement] = STATE(7696),
    [sym_expression] = STATE(4651),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7696),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5016),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1308] = {
    [sym_expression] = STATE(4703),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8793),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8793),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5018),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1309] = {
    [sym_expression] = STATE(3560),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8695),
    [sym__unary_right_fold] = STATE(8699),
    [sym__binary_fold] = STATE(8701),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1310] = {
    [sym_compound_statement] = STATE(8559),
    [sym_expression] = STATE(3550),
    [sym__string] = STATE(3313),
    [sym_comma_expression] = STATE(8559),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym__assignment_expression_lhs] = STATE(8514),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1311] = {
    [sym_expression] = STATE(4687),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8542),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8542),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5022),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1312] = {
    [sym_type_qualifier] = STATE(1312),
    [sym_alignas_qualifier] = STATE(1369),
    [aux_sym__type_definition_type_repeat1] = STATE(1312),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5026),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_COLON] = ACTIONS(5024),
    [anon_sym_SEMI] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(5028),
    [anon_sym_in] = ACTIONS(5024),
    [anon_sym_out] = ACTIONS(5024),
    [anon_sym_inout] = ACTIONS(5024),
    [anon_sym_virtual] = ACTIONS(5024),
    [anon_sym_extern] = ACTIONS(5024),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_COLON_COLON] = ACTIONS(5026),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5026),
    [anon_sym___declspec] = ACTIONS(5024),
    [anon_sym___based] = ACTIONS(5024),
    [anon_sym___cdecl] = ACTIONS(5024),
    [anon_sym___clrcall] = ACTIONS(5024),
    [anon_sym___stdcall] = ACTIONS(5024),
    [anon_sym___fastcall] = ACTIONS(5024),
    [anon_sym___thiscall] = ACTIONS(5024),
    [anon_sym___vectorcall] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5024),
    [anon_sym_static] = ACTIONS(5024),
    [anon_sym_EQ] = ACTIONS(5026),
    [anon_sym_register] = ACTIONS(5024),
    [anon_sym_inline] = ACTIONS(5024),
    [anon_sym___inline] = ACTIONS(5024),
    [anon_sym___inline__] = ACTIONS(5024),
    [anon_sym___forceinline] = ACTIONS(5024),
    [anon_sym_thread_local] = ACTIONS(5024),
    [anon_sym___thread] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(5028),
    [anon_sym_constexpr] = ACTIONS(5028),
    [anon_sym_volatile] = ACTIONS(5028),
    [anon_sym_restrict] = ACTIONS(5028),
    [anon_sym___restrict__] = ACTIONS(5028),
    [anon_sym__Atomic] = ACTIONS(5028),
    [anon_sym__Noreturn] = ACTIONS(5028),
    [anon_sym_noreturn] = ACTIONS(5028),
    [anon_sym__Nonnull] = ACTIONS(5028),
    [anon_sym_mutable] = ACTIONS(5028),
    [anon_sym_constinit] = ACTIONS(5028),
    [anon_sym_consteval] = ACTIONS(5028),
    [anon_sym_alignas] = ACTIONS(5031),
    [anon_sym__Alignas] = ACTIONS(5031),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_enum] = ACTIONS(5024),
    [anon_sym_class] = ACTIONS(5024),
    [anon_sym_struct] = ACTIONS(5024),
    [anon_sym_union] = ACTIONS(5024),
    [anon_sym_asm] = ACTIONS(5024),
    [anon_sym___asm__] = ACTIONS(5024),
    [anon_sym___asm] = ACTIONS(5024),
    [anon_sym_DASH_GT] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_final] = ACTIONS(5024),
    [anon_sym_override] = ACTIONS(5024),
    [anon_sym_typename] = ACTIONS(5024),
    [anon_sym_template] = ACTIONS(5024),
    [anon_sym_GT2] = ACTIONS(5026),
    [anon_sym_operator] = ACTIONS(5024),
    [anon_sym_try] = ACTIONS(5024),
    [anon_sym_noexcept] = ACTIONS(5024),
    [anon_sym_throw] = ACTIONS(5024),
    [anon_sym_requires] = ACTIONS(5024),
    [anon_sym_precise] = ACTIONS(5024),
    [anon_sym_shared] = ACTIONS(5024),
    [anon_sym_groupshared] = ACTIONS(5024),
    [anon_sym_uniform] = ACTIONS(5024),
    [anon_sym_row_major] = ACTIONS(5024),
    [anon_sym_column_major] = ACTIONS(5024),
    [anon_sym_globallycoherent] = ACTIONS(5024),
    [anon_sym_centroid] = ACTIONS(5024),
    [anon_sym_noperspective] = ACTIONS(5024),
    [anon_sym_nointerpolation] = ACTIONS(5024),
    [anon_sym_sample] = ACTIONS(5024),
    [anon_sym_linear] = ACTIONS(5024),
    [anon_sym_snorm] = ACTIONS(5024),
    [anon_sym_unorm] = ACTIONS(5024),
    [anon_sym_point] = ACTIONS(5024),
    [anon_sym_line] = ACTIONS(5024),
    [anon_sym_triangleadj] = ACTIONS(5024),
    [anon_sym_lineadj] = ACTIONS(5024),
    [anon_sym_triangle] = ACTIONS(5024),
  },
  [1313] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_identifier_parameter_pack_expansion] = STATE(7879),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3837),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_COMMA] = ACTIONS(5038),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5038),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1314] = {
    [sym_expression] = STATE(3573),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8340),
    [sym__unary_right_fold] = STATE(8341),
    [sym__binary_fold] = STATE(8343),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1315] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7021),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_default] = ACTIONS(5042),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(5044),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(5046),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1316] = {
    [sym_expression] = STATE(3534),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8263),
    [sym__unary_right_fold] = STATE(8285),
    [sym__binary_fold] = STATE(8310),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1317] = {
    [sym_expression] = STATE(4406),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7007),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_default] = ACTIONS(5048),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(5050),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(5052),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1318] = {
    [sym_expression] = STATE(3553),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8746),
    [sym__unary_right_fold] = STATE(8749),
    [sym__binary_fold] = STATE(8752),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1319] = {
    [sym_expression] = STATE(3577),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8492),
    [sym__unary_right_fold] = STATE(8494),
    [sym__binary_fold] = STATE(8496),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1320] = {
    [sym_expression] = STATE(3558),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8330),
    [sym__unary_right_fold] = STATE(8333),
    [sym__binary_fold] = STATE(8338),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1321] = {
    [sym_expression] = STATE(3564),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8652),
    [sym__unary_right_fold] = STATE(8658),
    [sym__binary_fold] = STATE(8659),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1322] = {
    [sym_expression] = STATE(3574),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8768),
    [sym__unary_right_fold] = STATE(8810),
    [sym__binary_fold] = STATE(8886),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1323] = {
    [sym_expression] = STATE(4753),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8719),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8719),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5054),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1324] = {
    [sym_expression] = STATE(3539),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym__unary_left_fold] = STATE(8473),
    [sym__unary_right_fold] = STATE(8396),
    [sym__binary_fold] = STATE(8427),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1325] = {
    [sym_compound_statement] = STATE(7522),
    [sym_expression] = STATE(4580),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7522),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5056),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1326] = {
    [sym_expression] = STATE(4427),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7034),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_default] = ACTIONS(5058),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(5060),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(5062),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1327] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5064),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1328] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5067),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1329] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5070),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1330] = {
    [sym_expression] = STATE(4649),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(7728),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5073),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1331] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5075),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1332] = {
    [sym_expression] = STATE(4600),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(7457),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1333] = {
    [sym_compound_statement] = STATE(7943),
    [sym_expression] = STATE(4783),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(7943),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1334] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5080),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1335] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5083),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1336] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2029),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(5086),
    [anon_sym_for] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1337] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5090),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1338] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5093),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1339] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5096),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1340] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5065),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2030),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(5099),
    [anon_sym_for] = ACTIONS(5101),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1341] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5103),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1342] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(7568),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5106),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1343] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5072),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2034),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(5108),
    [anon_sym_for] = ACTIONS(5110),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1344] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5112),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1345] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5043),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2027),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(5115),
    [anon_sym_for] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1346] = {
    [sym_expression] = STATE(3490),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_initializer_list] = STATE(3677),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACE] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1347] = {
    [sym_expression] = STATE(4714),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8547),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5119),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1348] = {
    [sym_expression] = STATE(4584),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8226),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1349] = {
    [sym_expression] = STATE(4971),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8556),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1350] = {
    [sym_expression] = STATE(3609),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_initializer_list] = STATE(3880),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(4024),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1351] = {
    [sym_expression] = STATE(4516),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(7276),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1352] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1353] = {
    [sym_expression] = STATE(4689),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8426),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5127),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1354] = {
    [sym_expression] = STATE(4538),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8894),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1355] = {
    [sym_expression] = STATE(4766),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_initializer_list] = STATE(5039),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACE] = ACTIONS(4392),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1356] = {
    [sym_expression] = STATE(4576),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(7808),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5129),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1357] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1358] = {
    [sym_expression] = STATE(4728),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8937),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5132),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1359] = {
    [sym_expression] = STATE(4748),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8885),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5134),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1360] = {
    [sym_expression] = STATE(4655),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8803),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5136),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1361] = {
    [sym_expression] = STATE(4708),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9005),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5138),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1362] = {
    [sym_expression] = STATE(4734),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9078),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1363] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1364] = {
    [sym_expression] = STATE(4491),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1365] = {
    [sym_expression] = STATE(4801),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8284),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5142),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1366] = {
    [sym_expression] = STATE(4724),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8797),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1367] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3976),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7791),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_type_parameter_declaration] = STATE(7791),
    [sym_variadic_type_parameter_declaration] = STATE(7791),
    [sym_optional_type_parameter_declaration] = STATE(7791),
    [sym_template_template_parameter_declaration] = STATE(7791),
    [sym_optional_parameter_declaration] = STATE(7791),
    [sym_variadic_parameter_declaration] = STATE(7791),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(5144),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5148),
    [anon_sym_GT2] = ACTIONS(5150),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1368] = {
    [sym_expression] = STATE(3945),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_initializer_list] = STATE(4140),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1369] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_COLON] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym___cdecl] = ACTIONS(2197),
    [anon_sym___clrcall] = ACTIONS(2197),
    [anon_sym___stdcall] = ACTIONS(2197),
    [anon_sym___fastcall] = ACTIONS(2197),
    [anon_sym___thiscall] = ACTIONS(2197),
    [anon_sym___vectorcall] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [anon_sym_asm] = ACTIONS(2197),
    [anon_sym___asm__] = ACTIONS(2197),
    [anon_sym___asm] = ACTIONS(2197),
    [anon_sym_DASH_GT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_final] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_GT2] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_noexcept] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_requires] = ACTIONS(2197),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [1370] = {
    [sym_expression] = STATE(4737),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8081),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1371] = {
    [sym_expression] = STATE(4738),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8683),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5152),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1372] = {
    [sym_expression] = STATE(4784),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8336),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5154),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1373] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1374] = {
    [sym_expression] = STATE(4775),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1375] = {
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8776),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5156),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1376] = {
    [sym_expression] = STATE(4820),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8714),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1377] = {
    [sym_expression] = STATE(3996),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1378] = {
    [sym_expression] = STATE(4745),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8283),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1379] = {
    [sym_expression] = STATE(4705),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(7865),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1380] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1381] = {
    [sym_expression] = STATE(4652),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9047),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5160),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1382] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1383] = {
    [sym_expression] = STATE(4779),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1384] = {
    [sym_expression] = STATE(4750),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8250),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5164),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym_in] = ACTIONS(5166),
    [anon_sym_out] = ACTIONS(5166),
    [anon_sym_inout] = ACTIONS(5166),
    [anon_sym_virtual] = ACTIONS(5166),
    [anon_sym_extern] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5168),
    [anon_sym___declspec] = ACTIONS(5166),
    [anon_sym___based] = ACTIONS(5166),
    [anon_sym___cdecl] = ACTIONS(5166),
    [anon_sym___clrcall] = ACTIONS(5166),
    [anon_sym___stdcall] = ACTIONS(5166),
    [anon_sym___fastcall] = ACTIONS(5166),
    [anon_sym___thiscall] = ACTIONS(5166),
    [anon_sym___vectorcall] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_register] = ACTIONS(5166),
    [anon_sym_inline] = ACTIONS(5166),
    [anon_sym___inline] = ACTIONS(5166),
    [anon_sym___inline__] = ACTIONS(5166),
    [anon_sym___forceinline] = ACTIONS(5166),
    [anon_sym_thread_local] = ACTIONS(5166),
    [anon_sym___thread] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_enum] = ACTIONS(5166),
    [anon_sym_class] = ACTIONS(5166),
    [anon_sym_struct] = ACTIONS(5166),
    [anon_sym_union] = ACTIONS(5166),
    [anon_sym_asm] = ACTIONS(5166),
    [anon_sym___asm__] = ACTIONS(5166),
    [anon_sym___asm] = ACTIONS(5166),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_explicit] = ACTIONS(5166),
    [anon_sym_typename] = ACTIONS(5166),
    [anon_sym_template] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
    [anon_sym_operator] = ACTIONS(5166),
    [anon_sym_try] = ACTIONS(5166),
    [anon_sym_noexcept] = ACTIONS(5166),
    [anon_sym_throw] = ACTIONS(5166),
    [anon_sym_requires] = ACTIONS(5166),
    [anon_sym_precise] = ACTIONS(5166),
    [anon_sym_shared] = ACTIONS(5166),
    [anon_sym_groupshared] = ACTIONS(5166),
    [anon_sym_uniform] = ACTIONS(5166),
    [anon_sym_row_major] = ACTIONS(5166),
    [anon_sym_column_major] = ACTIONS(5166),
    [anon_sym_globallycoherent] = ACTIONS(5166),
    [anon_sym_centroid] = ACTIONS(5166),
    [anon_sym_noperspective] = ACTIONS(5166),
    [anon_sym_nointerpolation] = ACTIONS(5166),
    [anon_sym_sample] = ACTIONS(5166),
    [anon_sym_linear] = ACTIONS(5166),
    [anon_sym_snorm] = ACTIONS(5166),
    [anon_sym_unorm] = ACTIONS(5166),
    [anon_sym_point] = ACTIONS(5166),
    [anon_sym_line] = ACTIONS(5166),
    [anon_sym_triangleadj] = ACTIONS(5166),
    [anon_sym_lineadj] = ACTIONS(5166),
    [anon_sym_triangle] = ACTIONS(5166),
  },
  [1386] = {
    [sym_expression] = STATE(4785),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8779),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5170),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1387] = {
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1388] = {
    [sym_expression] = STATE(4690),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8066),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1389] = {
    [sym_expression] = STATE(4685),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8786),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1390] = {
    [sym_expression] = STATE(4755),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_initializer_list] = STATE(8226),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1391] = {
    [sym_expression] = STATE(4741),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8684),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5172),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1392] = {
    [sym_expression] = STATE(3924),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_initializer_list] = STATE(4138),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1393] = {
    [sym_expression] = STATE(4749),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_initializer_list] = STATE(4142),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1394] = {
    [sym_expression] = STATE(4681),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(8564),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5174),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1395] = {
    [sym_expression] = STATE(4657),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_initializer_list] = STATE(5111),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACE] = ACTIONS(4392),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1396] = {
    [sym_expression] = STATE(3635),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_initializer_list] = STATE(2903),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1397] = {
    [sym_expression] = STATE(4733),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9071),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5178),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1398] = {
    [sym_expression] = STATE(4756),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9042),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5180),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1399] = {
    [sym_expression] = STATE(4664),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1400] = {
    [sym_expression] = STATE(4782),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(9072),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym_COLON] = ACTIONS(5182),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1401] = {
    [sym_expression] = STATE(4542),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_initializer_list] = STATE(4124),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1402] = {
    [sym_expression] = STATE(4709),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5184),
    [anon_sym_LPAREN2] = ACTIONS(5186),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1403] = {
    [sym_expression] = STATE(3861),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5188),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1404] = {
    [sym_expression] = STATE(3861),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5191),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1405] = {
    [sym_expression] = STATE(3861),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1406] = {
    [sym_expression] = STATE(4857),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5197),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1407] = {
    [sym_expression] = STATE(4807),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5199),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1408] = {
    [sym_expression] = STATE(3864),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5201),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1409] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3976),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(8171),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_type_parameter_declaration] = STATE(8171),
    [sym_variadic_type_parameter_declaration] = STATE(8171),
    [sym_optional_type_parameter_declaration] = STATE(8171),
    [sym_template_template_parameter_declaration] = STATE(8171),
    [sym_optional_parameter_declaration] = STATE(8171),
    [sym_variadic_parameter_declaration] = STATE(8171),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(5144),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5148),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1410] = {
    [sym_expression] = STATE(2870),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5204),
    [anon_sym_LPAREN2] = ACTIONS(5206),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1411] = {
    [sym_expression] = STATE(3507),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5208),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1412] = {
    [sym_expression] = STATE(2870),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5204),
    [anon_sym_LPAREN2] = ACTIONS(5211),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1413] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5213),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1414] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5215),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1415] = {
    [sym_expression] = STATE(3868),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5217),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1416] = {
    [sym_expression] = STATE(4867),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5220),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1417] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5222),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1418] = {
    [sym_expression] = STATE(3508),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5224),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1419] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(5227),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(5229),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1420] = {
    [sym_expression] = STATE(3876),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5231),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1421] = {
    [sym_expression] = STATE(4868),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5234),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1422] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5236),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1423] = {
    [sym_expression] = STATE(4840),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5238),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1424] = {
    [sym_expression] = STATE(3446),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5240),
    [anon_sym_LPAREN2] = ACTIONS(5242),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1425] = {
    [sym_expression] = STATE(3459),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1426] = {
    [sym_expression] = STATE(3868),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1427] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5043),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2027),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1428] = {
    [sym_expression] = STATE(4684),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(7808),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1429] = {
    [sym_expression] = STATE(3475),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5250),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1430] = {
    [sym_expression] = STATE(3878),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1431] = {
    [sym_expression] = STATE(3472),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5247),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1432] = {
    [sym_expression] = STATE(3501),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5253),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1433] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5256),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1434] = {
    [sym_expression] = STATE(3567),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5260),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1435] = {
    [sym_expression] = STATE(2870),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5204),
    [anon_sym_LPAREN2] = ACTIONS(5262),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1436] = {
    [sym_expression] = STATE(3881),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5208),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1437] = {
    [sym_expression] = STATE(3881),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1438] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5267),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1439] = {
    [sym_expression] = STATE(3510),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5269),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1440] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5272),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1441] = {
    [sym_expression] = STATE(3510),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1442] = {
    [sym_expression] = STATE(4872),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5277),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1443] = {
    [sym_expression] = STATE(3507),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5264),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1444] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5077),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2021),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1445] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1446] = {
    [sym_expression] = STATE(4890),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5282),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1447] = {
    [sym_expression] = STATE(4891),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5284),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1448] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5286),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1449] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5288),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1450] = {
    [sym_expression] = STATE(3459),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5290),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1451] = {
    [sym_expression] = STATE(4895),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5293),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1452] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5065),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2030),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1453] = {
    [sym_expression] = STATE(4833),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5295),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1454] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5297),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1455] = {
    [sym_expression] = STATE(4912),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5299),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1456] = {
    [sym_expression] = STATE(4024),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(5303),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1457] = {
    [sym_expression] = STATE(4576),
    [sym__string] = STATE(4467),
    [sym_comma_expression] = STATE(7808),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1458] = {
    [sym_expression] = STATE(4920),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5305),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1459] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4451),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1460] = {
    [sym_expression] = STATE(3878),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1461] = {
    [sym_expression] = STATE(4834),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5310),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1462] = {
    [sym_expression] = STATE(3508),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5312),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1463] = {
    [sym_expression] = STATE(3472),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5217),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1464] = {
    [sym_expression] = STATE(3510),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5315),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1465] = {
    [sym_expression] = STATE(4926),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5318),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1466] = {
    [sym_expression] = STATE(4024),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(5320),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1467] = {
    [sym_expression] = STATE(3462),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5188),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1468] = {
    [sym_expression] = STATE(4933),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5322),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1469] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5324),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1470] = {
    [sym_expression] = STATE(4935),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5326),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1471] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5328),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1472] = {
    [sym_expression] = STATE(4858),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RPAREN] = ACTIONS(5330),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1473] = {
    [sym_expression] = STATE(4024),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(5332),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1474] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5334),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1475] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(5336),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(5229),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1476] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4453),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4451),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4451),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4451),
    [anon_sym_GT_GT] = ACTIONS(4451),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [1477] = {
    [sym_expression] = STATE(3897),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5338),
    [anon_sym_LPAREN2] = ACTIONS(5340),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1478] = {
    [sym_expression] = STATE(3501),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1479] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1480] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5344),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1481] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5346),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1482] = {
    [sym_expression] = STATE(3619),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5204),
    [anon_sym_LPAREN2] = ACTIONS(5348),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1483] = {
    [sym_expression] = STATE(3464),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1484] = {
    [sym_expression] = STATE(4907),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5353),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1485] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5072),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2034),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1486] = {
    [sym_expression] = STATE(3876),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5250),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1487] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5355),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1488] = {
    [sym_expression] = STATE(4908),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5357),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1489] = {
    [sym_expression] = STATE(3508),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5279),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1490] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5082),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2026),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1491] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5312),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1492] = {
    [sym_expression] = STATE(3906),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5269),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1493] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5086),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2025),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1494] = {
    [sym_expression] = STATE(3906),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1495] = {
    [sym_expression] = STATE(3510),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5359),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1496] = {
    [sym_expression] = STATE(3518),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5362),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1497] = {
    [sym_expression] = STATE(3906),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5315),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1498] = {
    [sym_expression] = STATE(3475),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5231),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1499] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5031),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_ms_call_modifier] = STATE(2029),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(55),
    [anon_sym___clrcall] = ACTIONS(55),
    [anon_sym___stdcall] = ACTIONS(55),
    [anon_sym___fastcall] = ACTIONS(55),
    [anon_sym___thiscall] = ACTIONS(55),
    [anon_sym___vectorcall] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1500] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5365),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1501] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1502] = {
    [sym_expression] = STATE(3462),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5191),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1503] = {
    [sym_expression] = STATE(3860),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5244),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1504] = {
    [sym_expression] = STATE(3860),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5290),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1505] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(5229),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1506] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5224),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1507] = {
    [sym_expression] = STATE(4727),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(5371),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1508] = {
    [sym_expression] = STATE(4844),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1509] = {
    [sym_expression] = STATE(3906),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5359),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1510] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_RBRACK] = ACTIONS(5375),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1511] = {
    [sym_expression] = STATE(3518),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5377),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1512] = {
    [sym_expression] = STATE(3907),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5362),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1513] = {
    [sym_expression] = STATE(3907),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5377),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1514] = {
    [sym_expression] = STATE(4024),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5301),
    [anon_sym_LPAREN2] = ACTIONS(5380),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1515] = {
    [sym_expression] = STATE(3462),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5194),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1516] = {
    [sym_expression] = STATE(3464),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5201),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1517] = {
    [sym_expression] = STATE(3864),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5350),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1518] = {
    [sym_expression] = STATE(4807),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5382),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1519] = {
    [sym_expression] = STATE(4572),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1520] = {
    [sym_expression] = STATE(4807),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1521] = {
    [sym_expression] = STATE(4503),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1522] = {
    [sym_expression] = STATE(4947),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1523] = {
    [sym_expression] = STATE(4059),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1524] = {
    [sym_expression] = STATE(3328),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1525] = {
    [sym_expression] = STATE(4883),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1526] = {
    [sym_expression] = STATE(4059),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(5384),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1527] = {
    [sym_expression] = STATE(4739),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1528] = {
    [sym_expression] = STATE(3264),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1529] = {
    [sym_expression] = STATE(4520),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1530] = {
    [sym_expression] = STATE(4893),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1531] = {
    [sym_expression] = STATE(4797),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1532] = {
    [sym_expression] = STATE(4735),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1533] = {
    [sym_expression] = STATE(4773),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(5386),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1534] = {
    [sym_expression] = STATE(4658),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1535] = {
    [sym_expression] = STATE(3848),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1536] = {
    [sym_expression] = STATE(4800),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1537] = {
    [sym_expression] = STATE(4759),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1538] = {
    [sym_expression] = STATE(3860),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1539] = {
    [sym_expression] = STATE(3861),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1540] = {
    [sym_expression] = STATE(3864),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1541] = {
    [sym_expression] = STATE(3868),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1542] = {
    [sym_expression] = STATE(3876),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1543] = {
    [sym_expression] = STATE(3878),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1544] = {
    [sym_expression] = STATE(3881),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1545] = {
    [sym_expression] = STATE(3892),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1546] = {
    [sym_expression] = STATE(3906),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1547] = {
    [sym_expression] = STATE(3907),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1548] = {
    [sym_expression] = STATE(4796),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1549] = {
    [sym_expression] = STATE(4693),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1550] = {
    [sym_expression] = STATE(4706),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1551] = {
    [sym_expression] = STATE(4970),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1552] = {
    [sym_expression] = STATE(4609),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1553] = {
    [sym_expression] = STATE(4972),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1554] = {
    [sym_expression] = STATE(4695),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1555] = {
    [sym_expression] = STATE(4947),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4489),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1556] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1557] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1558] = {
    [sym_expression] = STATE(4506),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1559] = {
    [sym_expression] = STATE(4051),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1560] = {
    [sym_expression] = STATE(4976),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1561] = {
    [sym_expression] = STATE(4510),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1562] = {
    [sym_expression] = STATE(3905),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(5390),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1563] = {
    [sym_expression] = STATE(3912),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1564] = {
    [sym_expression] = STATE(3962),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(5392),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1565] = {
    [sym_expression] = STATE(4977),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1566] = {
    [sym_expression] = STATE(4661),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1567] = {
    [sym_expression] = STATE(4978),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1568] = {
    [sym_expression] = STATE(4838),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1569] = {
    [sym_expression] = STATE(3914),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1570] = {
    [sym_expression] = STATE(3489),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(5394),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1571] = {
    [sym_expression] = STATE(3511),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1572] = {
    [sym_expression] = STATE(4546),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1573] = {
    [sym_expression] = STATE(4514),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1574] = {
    [sym_expression] = STATE(3444),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1575] = {
    [sym_expression] = STATE(3251),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1576] = {
    [sym_expression] = STATE(3839),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1577] = {
    [sym_expression] = STATE(3461),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(5396),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1578] = {
    [sym_expression] = STATE(4839),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1579] = {
    [sym_expression] = STATE(4841),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1580] = {
    [sym_expression] = STATE(4494),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1581] = {
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1582] = {
    [sym_expression] = STATE(3830),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1583] = {
    [sym_expression] = STATE(4567),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1584] = {
    [sym_expression] = STATE(4522),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1585] = {
    [sym_expression] = STATE(4544),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1586] = {
    [sym_expression] = STATE(4534),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1587] = {
    [sym_expression] = STATE(3315),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1588] = {
    [sym_expression] = STATE(2873),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1589] = {
    [sym_expression] = STATE(3329),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1590] = {
    [sym_expression] = STATE(3326),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1591] = {
    [sym_expression] = STATE(3256),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1592] = {
    [sym_expression] = STATE(3280),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1593] = {
    [sym_expression] = STATE(3250),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1594] = {
    [sym_expression] = STATE(3276),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1595] = {
    [sym_expression] = STATE(3281),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1596] = {
    [sym_expression] = STATE(3292),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1597] = {
    [sym_expression] = STATE(3494),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1598] = {
    [sym_expression] = STATE(3569),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(5398),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1599] = {
    [sym_expression] = STATE(3570),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1600] = {
    [sym_expression] = STATE(3586),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(5400),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1601] = {
    [sym_expression] = STATE(3604),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1602] = {
    [sym_expression] = STATE(4545),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1603] = {
    [sym_expression] = STATE(3616),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1604] = {
    [sym_expression] = STATE(3647),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1605] = {
    [sym_expression] = STATE(3392),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(5402),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1606] = {
    [sym_expression] = STATE(3361),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1607] = {
    [sym_expression] = STATE(4541),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1608] = {
    [sym_expression] = STATE(3372),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1609] = {
    [sym_expression] = STATE(3419),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1610] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_PIPE_PIPE] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_or] = ACTIONS(1951),
    [anon_sym_and] = ACTIONS(1951),
    [anon_sym_DASH_GT] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_noexcept] = ACTIONS(1951),
    [anon_sym_throw] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [1611] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_or] = ACTIONS(1947),
    [anon_sym_and] = ACTIONS(1947),
    [anon_sym_DASH_GT] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_friend] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_noexcept] = ACTIONS(1947),
    [anon_sym_throw] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
  },
  [1612] = {
    [sym_expression] = STATE(4965),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1613] = {
    [sym_expression] = STATE(4861),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1614] = {
    [sym_expression] = STATE(4985),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1615] = {
    [sym_expression] = STATE(4653),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1616] = {
    [sym_expression] = STATE(3447),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1617] = {
    [sym_expression] = STATE(3447),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(5404),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1618] = {
    [sym_expression] = STATE(3433),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1619] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(5229),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1620] = {
    [sym_expression] = STATE(3984),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1621] = {
    [sym_expression] = STATE(3602),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1622] = {
    [sym_expression] = STATE(4508),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1623] = {
    [sym_expression] = STATE(4526),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(5406),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1624] = {
    [sym_expression] = STATE(3516),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1625] = {
    [sym_expression] = STATE(4488),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1626] = {
    [sym_expression] = STATE(4051),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1627] = {
    [sym_expression] = STATE(4495),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1628] = {
    [sym_expression] = STATE(4496),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1629] = {
    [sym_expression] = STATE(4497),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1630] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1631] = {
    [sym_expression] = STATE(4499),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1632] = {
    [sym_expression] = STATE(4504),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1633] = {
    [sym_expression] = STATE(4505),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1634] = {
    [sym_expression] = STATE(4507),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1635] = {
    [sym_expression] = STATE(4517),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1636] = {
    [sym_expression] = STATE(4547),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1637] = {
    [sym_expression] = STATE(4366),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1638] = {
    [sym_expression] = STATE(4490),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1639] = {
    [sym_expression] = STATE(4682),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1640] = {
    [sym_expression] = STATE(4774),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1641] = {
    [sym_expression] = STATE(4765),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1642] = {
    [sym_expression] = STATE(4792),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1643] = {
    [sym_expression] = STATE(4771),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1644] = {
    [sym_expression] = STATE(4772),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1645] = {
    [sym_expression] = STATE(4662),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1646] = {
    [sym_expression] = STATE(4720),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1647] = {
    [sym_expression] = STATE(4789),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1648] = {
    [sym_expression] = STATE(4791),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1649] = {
    [sym_expression] = STATE(4696),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1650] = {
    [sym_expression] = STATE(4694),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1651] = {
    [sym_expression] = STATE(3358),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(5408),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1652] = {
    [sym_expression] = STATE(2853),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1653] = {
    [sym_expression] = STATE(3206),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1654] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1655] = {
    [sym_expression] = STATE(3167),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1656] = {
    [sym_expression] = STATE(3173),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1657] = {
    [sym_expression] = STATE(2854),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1658] = {
    [sym_expression] = STATE(2854),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(5412),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1659] = {
    [sym_expression] = STATE(2869),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1660] = {
    [sym_expression] = STATE(4395),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(5414),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1661] = {
    [sym_expression] = STATE(3984),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1662] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1663] = {
    [sym_expression] = STATE(4378),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1664] = {
    [sym_expression] = STATE(4381),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(5416),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1665] = {
    [sym_expression] = STATE(4979),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1666] = {
    [sym_expression] = STATE(4827),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1667] = {
    [sym_expression] = STATE(4699),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1668] = {
    [sym_expression] = STATE(4391),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1669] = {
    [sym_expression] = STATE(4051),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1670] = {
    [sym_expression] = STATE(4394),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1671] = {
    [sym_expression] = STATE(4984),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1672] = {
    [sym_expression] = STATE(4398),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1673] = {
    [sym_expression] = STATE(4351),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1674] = {
    [sym_expression] = STATE(4352),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1675] = {
    [sym_expression] = STATE(4354),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1676] = {
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1677] = {
    [sym_expression] = STATE(4355),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1678] = {
    [sym_expression] = STATE(4356),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1679] = {
    [sym_expression] = STATE(4790),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1680] = {
    [sym_expression] = STATE(4362),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1681] = {
    [sym_expression] = STATE(4548),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(5418),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1682] = {
    [sym_expression] = STATE(4372),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1683] = {
    [sym_expression] = STATE(3562),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1684] = {
    [sym_expression] = STATE(3593),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1685] = {
    [sym_expression] = STATE(3594),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1686] = {
    [sym_expression] = STATE(3595),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1687] = {
    [sym_expression] = STATE(3596),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1688] = {
    [sym_expression] = STATE(3597),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1689] = {
    [sym_expression] = STATE(3598),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1690] = {
    [sym_expression] = STATE(3599),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1691] = {
    [sym_expression] = STATE(3600),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1692] = {
    [sym_expression] = STATE(3601),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1693] = {
    [sym_expression] = STATE(3603),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1694] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(5420),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1695] = {
    [sym_expression] = STATE(2853),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1696] = {
    [sym_expression] = STATE(4732),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1697] = {
    [sym_expression] = STATE(4757),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1698] = {
    [sym_expression] = STATE(3442),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1699] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1700] = {
    [sym_expression] = STATE(4527),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(5422),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1701] = {
    [sym_expression] = STATE(4825),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1702] = {
    [sym_expression] = STATE(4860),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1703] = {
    [sym_expression] = STATE(3984),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1704] = {
    [sym_expression] = STATE(3354),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1705] = {
    [sym_expression] = STATE(3359),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1706] = {
    [sym_expression] = STATE(2873),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1707] = {
    [sym_expression] = STATE(3408),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1708] = {
    [sym_expression] = STATE(3409),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1709] = {
    [sym_expression] = STATE(3410),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1710] = {
    [sym_expression] = STATE(3411),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1711] = {
    [sym_expression] = STATE(3412),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1712] = {
    [sym_expression] = STATE(3413),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1713] = {
    [sym_expression] = STATE(3414),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1714] = {
    [sym_expression] = STATE(3360),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1715] = {
    [sym_expression] = STATE(3825),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1716] = {
    [sym_expression] = STATE(3895),
    [sym__string] = STATE(3990),
    [sym_conditional_expression] = STATE(4125),
    [sym_assignment_expression] = STATE(4125),
    [sym_pointer_expression] = STATE(3724),
    [sym_unary_expression] = STATE(4125),
    [sym_binary_expression] = STATE(4125),
    [sym_update_expression] = STATE(4125),
    [sym_cast_expression] = STATE(4125),
    [sym_sizeof_expression] = STATE(4125),
    [sym_alignof_expression] = STATE(4125),
    [sym_offsetof_expression] = STATE(4125),
    [sym_generic_expression] = STATE(4125),
    [sym_subscript_expression] = STATE(3724),
    [sym_call_expression] = STATE(3724),
    [sym_gnu_asm_expression] = STATE(4125),
    [sym_extension_expression] = STATE(4125),
    [sym_field_expression] = STATE(3724),
    [sym_compound_literal_expression] = STATE(4125),
    [sym_parenthesized_expression] = STATE(3724),
    [sym_char_literal] = STATE(3990),
    [sym_concatenated_string] = STATE(3990),
    [sym_string_literal] = STATE(3018),
    [sym_null] = STATE(4125),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8098),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4125),
    [sym_raw_string_literal] = STATE(3018),
    [sym_co_await_expression] = STATE(4125),
    [sym_new_expression] = STATE(4125),
    [sym_delete_expression] = STATE(4125),
    [sym_requires_clause] = STATE(4125),
    [sym_requires_expression] = STATE(4125),
    [sym_lambda_expression] = STATE(4125),
    [sym_lambda_capture_specifier] = STATE(5234),
    [sym_fold_expression] = STATE(4125),
    [sym_parameter_pack_expansion] = STATE(4125),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3724),
    [sym_qualified_type_identifier] = STATE(8098),
    [sym_user_defined_literal] = STATE(3724),
    [sym_identifier] = ACTIONS(4074),
    [anon_sym_LPAREN2] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1879),
    [anon_sym_TILDE] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(4076),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4080),
    [anon_sym_not] = ACTIONS(1881),
    [anon_sym_compl] = ACTIONS(1881),
    [anon_sym_DASH_DASH] = ACTIONS(1901),
    [anon_sym_PLUS_PLUS] = ACTIONS(1901),
    [anon_sym_sizeof] = ACTIONS(1903),
    [anon_sym___alignof__] = ACTIONS(1905),
    [anon_sym___alignof] = ACTIONS(1905),
    [anon_sym__alignof] = ACTIONS(1905),
    [anon_sym_alignof] = ACTIONS(1905),
    [anon_sym__Alignof] = ACTIONS(1905),
    [anon_sym_offsetof] = ACTIONS(1907),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1911),
    [anon_sym___asm__] = ACTIONS(1911),
    [anon_sym___asm] = ACTIONS(1911),
    [sym_number_literal] = ACTIONS(1913),
    [anon_sym_L_SQUOTE] = ACTIONS(1915),
    [anon_sym_u_SQUOTE] = ACTIONS(1915),
    [anon_sym_U_SQUOTE] = ACTIONS(1915),
    [anon_sym_u8_SQUOTE] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_L_DQUOTE] = ACTIONS(1917),
    [anon_sym_u_DQUOTE] = ACTIONS(1917),
    [anon_sym_U_DQUOTE] = ACTIONS(1917),
    [anon_sym_u8_DQUOTE] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1917),
    [sym_true] = ACTIONS(1919),
    [sym_false] = ACTIONS(1919),
    [anon_sym_NULL] = ACTIONS(1921),
    [anon_sym_nullptr] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1925),
    [anon_sym_R_DQUOTE] = ACTIONS(1927),
    [anon_sym_LR_DQUOTE] = ACTIONS(1927),
    [anon_sym_uR_DQUOTE] = ACTIONS(1927),
    [anon_sym_UR_DQUOTE] = ACTIONS(1927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1927),
    [anon_sym_co_await] = ACTIONS(1929),
    [anon_sym_new] = ACTIONS(1931),
    [anon_sym_requires] = ACTIONS(1933),
    [sym_this] = ACTIONS(1919),
  },
  [1717] = {
    [sym_expression] = STATE(2872),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(5424),
  },
  [1718] = {
    [sym_expression] = STATE(4718),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1719] = {
    [sym_expression] = STATE(3193),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1720] = {
    [sym_expression] = STATE(3194),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1721] = {
    [sym_expression] = STATE(2873),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1722] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1723] = {
    [sym_expression] = STATE(3170),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1724] = {
    [sym_expression] = STATE(3174),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1725] = {
    [sym_expression] = STATE(3178),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1726] = {
    [sym_expression] = STATE(3221),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1727] = {
    [sym_expression] = STATE(3208),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1728] = {
    [sym_expression] = STATE(3217),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1729] = {
    [sym_expression] = STATE(3195),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1730] = {
    [sym_expression] = STATE(3561),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1731] = {
    [sym_expression] = STATE(4719),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1732] = {
    [sym_expression] = STATE(3566),
    [sym__string] = STATE(3668),
    [sym_conditional_expression] = STATE(3874),
    [sym_assignment_expression] = STATE(3874),
    [sym_pointer_expression] = STATE(3879),
    [sym_unary_expression] = STATE(3874),
    [sym_binary_expression] = STATE(3874),
    [sym_update_expression] = STATE(3874),
    [sym_cast_expression] = STATE(3874),
    [sym_sizeof_expression] = STATE(3874),
    [sym_alignof_expression] = STATE(3874),
    [sym_offsetof_expression] = STATE(3874),
    [sym_generic_expression] = STATE(3874),
    [sym_subscript_expression] = STATE(3879),
    [sym_call_expression] = STATE(3879),
    [sym_gnu_asm_expression] = STATE(3874),
    [sym_extension_expression] = STATE(3874),
    [sym_field_expression] = STATE(3879),
    [sym_compound_literal_expression] = STATE(3874),
    [sym_parenthesized_expression] = STATE(3879),
    [sym_char_literal] = STATE(3668),
    [sym_concatenated_string] = STATE(3668),
    [sym_string_literal] = STATE(2882),
    [sym_null] = STATE(3874),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7834),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3874),
    [sym_raw_string_literal] = STATE(2882),
    [sym_co_await_expression] = STATE(3874),
    [sym_new_expression] = STATE(3874),
    [sym_delete_expression] = STATE(3874),
    [sym_requires_clause] = STATE(3874),
    [sym_requires_expression] = STATE(3874),
    [sym_lambda_expression] = STATE(3874),
    [sym_lambda_capture_specifier] = STATE(5196),
    [sym_fold_expression] = STATE(3874),
    [sym_parameter_pack_expansion] = STATE(3874),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3879),
    [sym_qualified_type_identifier] = STATE(7834),
    [sym_user_defined_literal] = STATE(3879),
    [sym_identifier] = ACTIONS(4014),
    [anon_sym_LPAREN2] = ACTIONS(5121),
    [anon_sym_BANG] = ACTIONS(4018),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_DASH] = ACTIONS(4016),
    [anon_sym_PLUS] = ACTIONS(4016),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4020),
    [anon_sym_COLON_COLON] = ACTIONS(4022),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4026),
    [anon_sym_not] = ACTIONS(4016),
    [anon_sym_compl] = ACTIONS(4016),
    [anon_sym_DASH_DASH] = ACTIONS(4445),
    [anon_sym_PLUS_PLUS] = ACTIONS(4445),
    [anon_sym_sizeof] = ACTIONS(4028),
    [anon_sym___alignof__] = ACTIONS(4030),
    [anon_sym___alignof] = ACTIONS(4030),
    [anon_sym__alignof] = ACTIONS(4030),
    [anon_sym_alignof] = ACTIONS(4030),
    [anon_sym__Alignof] = ACTIONS(4030),
    [anon_sym_offsetof] = ACTIONS(4032),
    [anon_sym__Generic] = ACTIONS(4034),
    [anon_sym_asm] = ACTIONS(4036),
    [anon_sym___asm__] = ACTIONS(4036),
    [anon_sym___asm] = ACTIONS(4036),
    [sym_number_literal] = ACTIONS(4038),
    [anon_sym_L_SQUOTE] = ACTIONS(4040),
    [anon_sym_u_SQUOTE] = ACTIONS(4040),
    [anon_sym_U_SQUOTE] = ACTIONS(4040),
    [anon_sym_u8_SQUOTE] = ACTIONS(4040),
    [anon_sym_SQUOTE] = ACTIONS(4040),
    [anon_sym_L_DQUOTE] = ACTIONS(4042),
    [anon_sym_u_DQUOTE] = ACTIONS(4042),
    [anon_sym_U_DQUOTE] = ACTIONS(4042),
    [anon_sym_u8_DQUOTE] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [sym_true] = ACTIONS(4044),
    [sym_false] = ACTIONS(4044),
    [anon_sym_NULL] = ACTIONS(4046),
    [anon_sym_nullptr] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4050),
    [anon_sym_LR_DQUOTE] = ACTIONS(4050),
    [anon_sym_uR_DQUOTE] = ACTIONS(4050),
    [anon_sym_UR_DQUOTE] = ACTIONS(4050),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4050),
    [anon_sym_co_await] = ACTIONS(4052),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_requires] = ACTIONS(4056),
    [sym_this] = ACTIONS(4044),
  },
  [1733] = {
    [sym_expression] = STATE(4059),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1734] = {
    [sym_expression] = STATE(3997),
    [sym__string] = STATE(4599),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3538),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3538),
    [sym_call_expression] = STATE(3538),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3538),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3538),
    [sym_char_literal] = STATE(4599),
    [sym_concatenated_string] = STATE(4599),
    [sym_string_literal] = STATE(3742),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3742),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3538),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3538),
    [sym_identifier] = ACTIONS(4324),
    [anon_sym_LPAREN2] = ACTIONS(5040),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4326),
    [anon_sym_compl] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(4467),
    [anon_sym_sizeof] = ACTIONS(4334),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4336),
    [anon_sym_L_SQUOTE] = ACTIONS(4338),
    [anon_sym_u_SQUOTE] = ACTIONS(4338),
    [anon_sym_U_SQUOTE] = ACTIONS(4338),
    [anon_sym_u8_SQUOTE] = ACTIONS(4338),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym_L_DQUOTE] = ACTIONS(4340),
    [anon_sym_u_DQUOTE] = ACTIONS(4340),
    [anon_sym_U_DQUOTE] = ACTIONS(4340),
    [anon_sym_u8_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4342),
    [anon_sym_R_DQUOTE] = ACTIONS(4344),
    [anon_sym_LR_DQUOTE] = ACTIONS(4344),
    [anon_sym_uR_DQUOTE] = ACTIONS(4344),
    [anon_sym_UR_DQUOTE] = ACTIONS(4344),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4344),
    [anon_sym_co_await] = ACTIONS(4346),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1735] = {
    [sym_expression] = STATE(4754),
    [sym__string] = STATE(4973),
    [sym_conditional_expression] = STATE(5091),
    [sym_assignment_expression] = STATE(5091),
    [sym_pointer_expression] = STATE(3873),
    [sym_unary_expression] = STATE(5091),
    [sym_binary_expression] = STATE(5091),
    [sym_update_expression] = STATE(5091),
    [sym_cast_expression] = STATE(5091),
    [sym_sizeof_expression] = STATE(5091),
    [sym_alignof_expression] = STATE(5091),
    [sym_offsetof_expression] = STATE(5091),
    [sym_generic_expression] = STATE(5091),
    [sym_subscript_expression] = STATE(3873),
    [sym_call_expression] = STATE(3873),
    [sym_gnu_asm_expression] = STATE(5091),
    [sym_extension_expression] = STATE(5091),
    [sym_field_expression] = STATE(3873),
    [sym_compound_literal_expression] = STATE(5091),
    [sym_parenthesized_expression] = STATE(3873),
    [sym_char_literal] = STATE(4973),
    [sym_concatenated_string] = STATE(4973),
    [sym_string_literal] = STATE(4054),
    [sym_null] = STATE(5091),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7870),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(5091),
    [sym_raw_string_literal] = STATE(4054),
    [sym_co_await_expression] = STATE(5091),
    [sym_new_expression] = STATE(5091),
    [sym_delete_expression] = STATE(5091),
    [sym_requires_clause] = STATE(5091),
    [sym_requires_expression] = STATE(5091),
    [sym_lambda_expression] = STATE(5091),
    [sym_lambda_capture_specifier] = STATE(5237),
    [sym_fold_expression] = STATE(5091),
    [sym_parameter_pack_expansion] = STATE(5091),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5935),
    [sym_qualified_identifier] = STATE(3873),
    [sym_qualified_type_identifier] = STATE(7870),
    [sym_user_defined_literal] = STATE(3873),
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_LPAREN2] = ACTIONS(4089),
    [anon_sym_BANG] = ACTIONS(4091),
    [anon_sym_TILDE] = ACTIONS(4091),
    [anon_sym_DASH] = ACTIONS(4093),
    [anon_sym_PLUS] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AMP] = ACTIONS(4095),
    [anon_sym___extension__] = ACTIONS(4390),
    [anon_sym_COLON_COLON] = ACTIONS(4099),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(4394),
    [anon_sym_not] = ACTIONS(4093),
    [anon_sym_compl] = ACTIONS(4093),
    [anon_sym_DASH_DASH] = ACTIONS(4113),
    [anon_sym_PLUS_PLUS] = ACTIONS(4113),
    [anon_sym_sizeof] = ACTIONS(4115),
    [anon_sym___alignof__] = ACTIONS(4117),
    [anon_sym___alignof] = ACTIONS(4117),
    [anon_sym__alignof] = ACTIONS(4117),
    [anon_sym_alignof] = ACTIONS(4117),
    [anon_sym__Alignof] = ACTIONS(4117),
    [anon_sym_offsetof] = ACTIONS(4119),
    [anon_sym__Generic] = ACTIONS(4121),
    [anon_sym_asm] = ACTIONS(4123),
    [anon_sym___asm__] = ACTIONS(4123),
    [anon_sym___asm] = ACTIONS(4123),
    [sym_number_literal] = ACTIONS(4125),
    [anon_sym_L_SQUOTE] = ACTIONS(4127),
    [anon_sym_u_SQUOTE] = ACTIONS(4127),
    [anon_sym_U_SQUOTE] = ACTIONS(4127),
    [anon_sym_u8_SQUOTE] = ACTIONS(4127),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_L_DQUOTE] = ACTIONS(4129),
    [anon_sym_u_DQUOTE] = ACTIONS(4129),
    [anon_sym_U_DQUOTE] = ACTIONS(4129),
    [anon_sym_u8_DQUOTE] = ACTIONS(4129),
    [anon_sym_DQUOTE] = ACTIONS(4129),
    [sym_true] = ACTIONS(4131),
    [sym_false] = ACTIONS(4131),
    [anon_sym_NULL] = ACTIONS(4133),
    [anon_sym_nullptr] = ACTIONS(4133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4143),
    [anon_sym_R_DQUOTE] = ACTIONS(4145),
    [anon_sym_LR_DQUOTE] = ACTIONS(4145),
    [anon_sym_uR_DQUOTE] = ACTIONS(4145),
    [anon_sym_UR_DQUOTE] = ACTIONS(4145),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4145),
    [anon_sym_co_await] = ACTIONS(4147),
    [anon_sym_new] = ACTIONS(4149),
    [anon_sym_requires] = ACTIONS(4151),
    [sym_this] = ACTIONS(4131),
  },
  [1736] = {
    [sym_expression] = STATE(4059),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1737] = {
    [sym_expression] = STATE(3997),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1738] = {
    [sym_expression] = STATE(2854),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1739] = {
    [sym_expression] = STATE(2869),
    [sym__string] = STATE(3484),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3484),
    [sym_concatenated_string] = STATE(3484),
    [sym_string_literal] = STATE(2753),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2753),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_LPAREN2] = ACTIONS(5162),
    [anon_sym_BANG] = ACTIONS(3918),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_DASH] = ACTIONS(3916),
    [anon_sym_PLUS] = ACTIONS(3916),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_AMP] = ACTIONS(4447),
    [anon_sym___extension__] = ACTIONS(3920),
    [anon_sym_COLON_COLON] = ACTIONS(3922),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3916),
    [anon_sym_compl] = ACTIONS(3916),
    [anon_sym_DASH_DASH] = ACTIONS(4449),
    [anon_sym_PLUS_PLUS] = ACTIONS(4449),
    [anon_sym_sizeof] = ACTIONS(3924),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3926),
    [anon_sym_L_SQUOTE] = ACTIONS(3928),
    [anon_sym_u_SQUOTE] = ACTIONS(3928),
    [anon_sym_U_SQUOTE] = ACTIONS(3928),
    [anon_sym_u8_SQUOTE] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(3928),
    [anon_sym_L_DQUOTE] = ACTIONS(3930),
    [anon_sym_u_DQUOTE] = ACTIONS(3930),
    [anon_sym_U_DQUOTE] = ACTIONS(3930),
    [anon_sym_u8_DQUOTE] = ACTIONS(3930),
    [anon_sym_DQUOTE] = ACTIONS(3930),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3932),
    [anon_sym_R_DQUOTE] = ACTIONS(3934),
    [anon_sym_LR_DQUOTE] = ACTIONS(3934),
    [anon_sym_uR_DQUOTE] = ACTIONS(3934),
    [anon_sym_UR_DQUOTE] = ACTIONS(3934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3934),
    [anon_sym_co_await] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1740] = {
    [sym_expression] = STATE(2854),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1741] = {
    [sym_expression] = STATE(2869),
    [sym__string] = STATE(3248),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3248),
    [sym_concatenated_string] = STATE(3248),
    [sym_string_literal] = STATE(2627),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2627),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5158),
    [anon_sym_BANG] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3804),
    [anon_sym_PLUS] = ACTIONS(3804),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(3808),
    [anon_sym_COLON_COLON] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_compl] = ACTIONS(3804),
    [anon_sym_DASH_DASH] = ACTIONS(4469),
    [anon_sym_PLUS_PLUS] = ACTIONS(4469),
    [anon_sym_sizeof] = ACTIONS(3816),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3826),
    [anon_sym_L_SQUOTE] = ACTIONS(3828),
    [anon_sym_u_SQUOTE] = ACTIONS(3828),
    [anon_sym_U_SQUOTE] = ACTIONS(3828),
    [anon_sym_u8_SQUOTE] = ACTIONS(3828),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3836),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [anon_sym_co_await] = ACTIONS(3840),
    [anon_sym_new] = ACTIONS(3842),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1742] = {
    [sym_expression] = STATE(3291),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(5426),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1743] = {
    [sym_expression] = STATE(2853),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1744] = {
    [sym_expression] = STATE(4832),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1745] = {
    [sym_expression] = STATE(4835),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1746] = {
    [sym_expression] = STATE(4701),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1747] = {
    [sym_expression] = STATE(4764),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(5428),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1748] = {
    [sym_expression] = STATE(4787),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1749] = {
    [sym_expression] = STATE(4051),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1750] = {
    [sym_expression] = STATE(4793),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1751] = {
    [sym_expression] = STATE(4794),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1752] = {
    [sym_expression] = STATE(4795),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1753] = {
    [sym_expression] = STATE(4798),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1754] = {
    [sym_expression] = STATE(4802),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1755] = {
    [sym_expression] = STATE(4803),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1756] = {
    [sym_expression] = STATE(4804),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1757] = {
    [sym_expression] = STATE(4736),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1758] = {
    [sym_expression] = STATE(3440),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1759] = {
    [sym_expression] = STATE(4656),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1760] = {
    [sym_expression] = STATE(4842),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1761] = {
    [sym_expression] = STATE(4847),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1762] = {
    [sym_expression] = STATE(4848),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1763] = {
    [sym_expression] = STATE(4647),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1764] = {
    [sym_expression] = STATE(4700),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1765] = {
    [sym_expression] = STATE(4849),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1766] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1767] = {
    [sym_expression] = STATE(3282),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(5430),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1768] = {
    [sym_expression] = STATE(4635),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1769] = {
    [sym_expression] = STATE(4865),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1770] = {
    [sym_expression] = STATE(4869),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1771] = {
    [sym_expression] = STATE(4876),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1772] = {
    [sym_expression] = STATE(4878),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1773] = {
    [sym_expression] = STATE(4879),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1774] = {
    [sym_expression] = STATE(4568),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1775] = {
    [sym_expression] = STATE(4880),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1776] = {
    [sym_expression] = STATE(4590),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1777] = {
    [sym_expression] = STATE(4889),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1778] = {
    [sym_expression] = STATE(4892),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1779] = {
    [sym_expression] = STATE(4896),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1780] = {
    [sym_expression] = STATE(4897),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1781] = {
    [sym_expression] = STATE(4898),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1782] = {
    [sym_expression] = STATE(4617),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1783] = {
    [sym_expression] = STATE(4899),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1784] = {
    [sym_expression] = STATE(4564),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1785] = {
    [sym_expression] = STATE(4906),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1786] = {
    [sym_expression] = STATE(4909),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1787] = {
    [sym_expression] = STATE(4913),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1788] = {
    [sym_expression] = STATE(4914),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1789] = {
    [sym_expression] = STATE(4915),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1790] = {
    [sym_expression] = STATE(4642),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1791] = {
    [sym_expression] = STATE(4916),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1792] = {
    [sym_expression] = STATE(4581),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1793] = {
    [sym_expression] = STATE(4921),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1794] = {
    [sym_expression] = STATE(4922),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1795] = {
    [sym_expression] = STATE(4923),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1796] = {
    [sym_expression] = STATE(4589),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1797] = {
    [sym_expression] = STATE(4924),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1798] = {
    [sym_expression] = STATE(4928),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1799] = {
    [sym_expression] = STATE(4929),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1800] = {
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1801] = {
    [sym_expression] = STATE(4930),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1802] = {
    [sym_expression] = STATE(4601),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1803] = {
    [sym_expression] = STATE(4613),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1804] = {
    [sym_expression] = STATE(4059),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1805] = {
    [sym_expression] = STATE(3997),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1806] = {
    [sym_expression] = STATE(4824),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1807] = {
    [sym_expression] = STATE(4713),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(5432),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1808] = {
    [sym_expression] = STATE(3984),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3863),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3863),
    [sym_call_expression] = STATE(3863),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3863),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3863),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3863),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3863),
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_LPAREN2] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4358),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(4360),
    [anon_sym_COLON_COLON] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4356),
    [anon_sym_compl] = ACTIONS(4356),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_sizeof] = ACTIONS(4364),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4366),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1809] = {
    [sym_expression] = STATE(3997),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1810] = {
    [sym_expression] = STATE(4780),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1811] = {
    [sym_expression] = STATE(3459),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1812] = {
    [sym_expression] = STATE(3462),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1813] = {
    [sym_expression] = STATE(3464),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1814] = {
    [sym_expression] = STATE(3472),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1815] = {
    [sym_expression] = STATE(3617),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1816] = {
    [sym_expression] = STATE(3520),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1817] = {
    [sym_expression] = STATE(3475),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1818] = {
    [sym_expression] = STATE(4740),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1819] = {
    [sym_expression] = STATE(3501),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1820] = {
    [sym_expression] = STATE(3507),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1821] = {
    [sym_expression] = STATE(3508),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1822] = {
    [sym_expression] = STATE(3510),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1823] = {
    [sym_expression] = STATE(3518),
    [sym__string] = STATE(3645),
    [sym_conditional_expression] = STATE(3819),
    [sym_assignment_expression] = STATE(3819),
    [sym_pointer_expression] = STATE(3802),
    [sym_unary_expression] = STATE(3819),
    [sym_binary_expression] = STATE(3819),
    [sym_update_expression] = STATE(3819),
    [sym_cast_expression] = STATE(3819),
    [sym_sizeof_expression] = STATE(3819),
    [sym_alignof_expression] = STATE(3819),
    [sym_offsetof_expression] = STATE(3819),
    [sym_generic_expression] = STATE(3819),
    [sym_subscript_expression] = STATE(3802),
    [sym_call_expression] = STATE(3802),
    [sym_gnu_asm_expression] = STATE(3819),
    [sym_extension_expression] = STATE(3819),
    [sym_field_expression] = STATE(3802),
    [sym_compound_literal_expression] = STATE(3819),
    [sym_parenthesized_expression] = STATE(3802),
    [sym_char_literal] = STATE(3645),
    [sym_concatenated_string] = STATE(3645),
    [sym_string_literal] = STATE(2830),
    [sym_null] = STATE(3819),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7911),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(3819),
    [sym_raw_string_literal] = STATE(2830),
    [sym_co_await_expression] = STATE(3819),
    [sym_new_expression] = STATE(3819),
    [sym_delete_expression] = STATE(3819),
    [sym_requires_clause] = STATE(3819),
    [sym_requires_expression] = STATE(3819),
    [sym_lambda_expression] = STATE(3819),
    [sym_lambda_capture_specifier] = STATE(5212),
    [sym_fold_expression] = STATE(3819),
    [sym_parameter_pack_expansion] = STATE(3819),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5948),
    [sym_qualified_identifier] = STATE(3802),
    [sym_qualified_type_identifier] = STATE(7911),
    [sym_user_defined_literal] = STATE(3802),
    [sym_identifier] = ACTIONS(3950),
    [anon_sym_LPAREN2] = ACTIONS(3910),
    [anon_sym_BANG] = ACTIONS(2046),
    [anon_sym_TILDE] = ACTIONS(2046),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1883),
    [anon_sym___extension__] = ACTIONS(3952),
    [anon_sym_COLON_COLON] = ACTIONS(2058),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_compl] = ACTIONS(2050),
    [anon_sym_DASH_DASH] = ACTIONS(2076),
    [anon_sym_PLUS_PLUS] = ACTIONS(2076),
    [anon_sym_sizeof] = ACTIONS(2078),
    [anon_sym___alignof__] = ACTIONS(2080),
    [anon_sym___alignof] = ACTIONS(2080),
    [anon_sym__alignof] = ACTIONS(2080),
    [anon_sym_alignof] = ACTIONS(2080),
    [anon_sym__Alignof] = ACTIONS(2080),
    [anon_sym_offsetof] = ACTIONS(2082),
    [anon_sym__Generic] = ACTIONS(2084),
    [anon_sym_asm] = ACTIONS(2086),
    [anon_sym___asm__] = ACTIONS(2086),
    [anon_sym___asm] = ACTIONS(2086),
    [sym_number_literal] = ACTIONS(2088),
    [anon_sym_L_SQUOTE] = ACTIONS(2090),
    [anon_sym_u_SQUOTE] = ACTIONS(2090),
    [anon_sym_U_SQUOTE] = ACTIONS(2090),
    [anon_sym_u8_SQUOTE] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_L_DQUOTE] = ACTIONS(2092),
    [anon_sym_u_DQUOTE] = ACTIONS(2092),
    [anon_sym_U_DQUOTE] = ACTIONS(2092),
    [anon_sym_u8_DQUOTE] = ACTIONS(2092),
    [anon_sym_DQUOTE] = ACTIONS(2092),
    [sym_true] = ACTIONS(2094),
    [sym_false] = ACTIONS(2094),
    [anon_sym_NULL] = ACTIONS(2096),
    [anon_sym_nullptr] = ACTIONS(2096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(2106),
    [anon_sym_R_DQUOTE] = ACTIONS(2108),
    [anon_sym_LR_DQUOTE] = ACTIONS(2108),
    [anon_sym_uR_DQUOTE] = ACTIONS(2108),
    [anon_sym_UR_DQUOTE] = ACTIONS(2108),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2108),
    [anon_sym_co_await] = ACTIONS(2110),
    [anon_sym_new] = ACTIONS(2112),
    [anon_sym_requires] = ACTIONS(2114),
    [sym_this] = ACTIONS(2094),
  },
  [1824] = {
    [sym_expression] = STATE(3302),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5020),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [anon_sym_DASH] = ACTIONS(3884),
    [anon_sym_PLUS] = ACTIONS(3884),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3888),
    [anon_sym_COLON_COLON] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_compl] = ACTIONS(3884),
    [anon_sym_DASH_DASH] = ACTIONS(4213),
    [anon_sym_PLUS_PLUS] = ACTIONS(4213),
    [anon_sym_sizeof] = ACTIONS(3892),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(3900),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(3904),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1825] = {
    [sym_expression] = STATE(4769),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1826] = {
    [sym_expression] = STATE(4768),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1827] = {
    [sym_expression] = STATE(4710),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1828] = {
    [sym_expression] = STATE(4715),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1829] = {
    [sym_expression] = STATE(4660),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1830] = {
    [sym_expression] = STATE(3643),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1831] = {
    [sym_expression] = STATE(3618),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1832] = {
    [sym_expression] = STATE(3624),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1833] = {
    [sym_expression] = STATE(3625),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1834] = {
    [sym_expression] = STATE(3626),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1835] = {
    [sym_expression] = STATE(3627),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1836] = {
    [sym_expression] = STATE(3628),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1837] = {
    [sym_expression] = STATE(3629),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1838] = {
    [sym_expression] = STATE(3630),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1839] = {
    [sym_expression] = STATE(3631),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1840] = {
    [sym_expression] = STATE(3632),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1841] = {
    [sym_expression] = STATE(3633),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1842] = {
    [sym_expression] = STATE(3620),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(5434),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1843] = {
    [sym_expression] = STATE(3621),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1844] = {
    [sym_expression] = STATE(3622),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(5436),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1845] = {
    [sym_expression] = STATE(3634),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1846] = {
    [sym_expression] = STATE(3637),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1847] = {
    [sym_expression] = STATE(3639),
    [sym__string] = STATE(3313),
    [sym_conditional_expression] = STATE(2937),
    [sym_assignment_expression] = STATE(2937),
    [sym_pointer_expression] = STATE(2941),
    [sym_unary_expression] = STATE(2937),
    [sym_binary_expression] = STATE(2937),
    [sym_update_expression] = STATE(2937),
    [sym_cast_expression] = STATE(2937),
    [sym_sizeof_expression] = STATE(2937),
    [sym_alignof_expression] = STATE(2937),
    [sym_offsetof_expression] = STATE(2937),
    [sym_generic_expression] = STATE(2937),
    [sym_subscript_expression] = STATE(2941),
    [sym_call_expression] = STATE(2941),
    [sym_gnu_asm_expression] = STATE(2937),
    [sym_extension_expression] = STATE(2937),
    [sym_field_expression] = STATE(2941),
    [sym_compound_literal_expression] = STATE(2937),
    [sym_parenthesized_expression] = STATE(2941),
    [sym_char_literal] = STATE(3313),
    [sym_concatenated_string] = STATE(3313),
    [sym_string_literal] = STATE(2637),
    [sym_null] = STATE(2937),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(7842),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(2937),
    [sym_raw_string_literal] = STATE(2637),
    [sym_co_await_expression] = STATE(2937),
    [sym_new_expression] = STATE(2937),
    [sym_delete_expression] = STATE(2937),
    [sym_requires_clause] = STATE(2937),
    [sym_requires_expression] = STATE(2937),
    [sym_lambda_expression] = STATE(2937),
    [sym_lambda_capture_specifier] = STATE(5199),
    [sym_fold_expression] = STATE(2937),
    [sym_parameter_pack_expansion] = STATE(2937),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(2941),
    [sym_qualified_type_identifier] = STATE(7842),
    [sym_user_defined_literal] = STATE(2941),
    [sym_identifier] = ACTIONS(3882),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_BANG] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4002),
    [anon_sym_DASH] = ACTIONS(4000),
    [anon_sym_PLUS] = ACTIONS(4000),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4004),
    [anon_sym_COLON_COLON] = ACTIONS(4006),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3814),
    [anon_sym_not] = ACTIONS(4000),
    [anon_sym_compl] = ACTIONS(4000),
    [anon_sym_DASH_DASH] = ACTIONS(4473),
    [anon_sym_PLUS_PLUS] = ACTIONS(4473),
    [anon_sym_sizeof] = ACTIONS(4008),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3820),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3824),
    [anon_sym___asm__] = ACTIONS(3824),
    [anon_sym___asm] = ACTIONS(3824),
    [sym_number_literal] = ACTIONS(3894),
    [anon_sym_L_SQUOTE] = ACTIONS(3896),
    [anon_sym_u_SQUOTE] = ACTIONS(3896),
    [anon_sym_U_SQUOTE] = ACTIONS(3896),
    [anon_sym_u8_SQUOTE] = ACTIONS(3896),
    [anon_sym_SQUOTE] = ACTIONS(3896),
    [anon_sym_L_DQUOTE] = ACTIONS(3898),
    [anon_sym_u_DQUOTE] = ACTIONS(3898),
    [anon_sym_U_DQUOTE] = ACTIONS(3898),
    [anon_sym_u8_DQUOTE] = ACTIONS(3898),
    [anon_sym_DQUOTE] = ACTIONS(3898),
    [sym_true] = ACTIONS(3832),
    [sym_false] = ACTIONS(3832),
    [anon_sym_NULL] = ACTIONS(3834),
    [anon_sym_nullptr] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4010),
    [anon_sym_R_DQUOTE] = ACTIONS(3902),
    [anon_sym_LR_DQUOTE] = ACTIONS(3902),
    [anon_sym_uR_DQUOTE] = ACTIONS(3902),
    [anon_sym_UR_DQUOTE] = ACTIONS(3902),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3902),
    [anon_sym_co_await] = ACTIONS(4012),
    [anon_sym_new] = ACTIONS(3906),
    [anon_sym_requires] = ACTIONS(3844),
    [sym_this] = ACTIONS(3832),
  },
  [1848] = {
    [sym_expression] = STATE(4686),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1849] = {
    [sym_expression] = STATE(4663),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(5438),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1850] = {
    [sym_expression] = STATE(4665),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1851] = {
    [sym_expression] = STATE(4666),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1852] = {
    [sym_expression] = STATE(4667),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1853] = {
    [sym_expression] = STATE(4668),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1854] = {
    [sym_expression] = STATE(4669),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1855] = {
    [sym_expression] = STATE(4670),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1856] = {
    [sym_expression] = STATE(4671),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1857] = {
    [sym_expression] = STATE(4672),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1858] = {
    [sym_expression] = STATE(4673),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1859] = {
    [sym_expression] = STATE(4674),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1860] = {
    [sym_expression] = STATE(4677),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1861] = {
    [sym_expression] = STATE(4679),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1862] = {
    [sym_expression] = STATE(4723),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1863] = {
    [sym_expression] = STATE(4725),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1864] = {
    [sym_expression] = STATE(4688),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(5440),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1865] = {
    [sym_expression] = STATE(4729),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3960),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3960),
    [sym_call_expression] = STATE(3960),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3960),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3960),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3960),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3960),
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_LPAREN2] = ACTIONS(5125),
    [anon_sym_BANG] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4376),
    [anon_sym_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4471),
    [anon_sym_AMP] = ACTIONS(4471),
    [anon_sym___extension__] = ACTIONS(4378),
    [anon_sym_COLON_COLON] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4374),
    [anon_sym_compl] = ACTIONS(4374),
    [anon_sym_DASH_DASH] = ACTIONS(4475),
    [anon_sym_PLUS_PLUS] = ACTIONS(4475),
    [anon_sym_sizeof] = ACTIONS(4382),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4384),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(4370),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1866] = {
    [sym_expression] = STATE(4981),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1867] = {
    [sym_expression] = STATE(4982),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1868] = {
    [sym_expression] = STATE(4983),
    [sym__string] = STATE(4467),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3523),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3523),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3523),
    [sym_char_literal] = STATE(4467),
    [sym_concatenated_string] = STATE(4467),
    [sym_string_literal] = STATE(3500),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3500),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3523),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3523),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_LPAREN2] = ACTIONS(1294),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1296),
    [anon_sym___extension__] = ACTIONS(3560),
    [anon_sym_COLON_COLON] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(103),
    [anon_sym_PLUS_PLUS] = ACTIONS(103),
    [anon_sym_sizeof] = ACTIONS(105),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(229),
    [anon_sym_L_SQUOTE] = ACTIONS(117),
    [anon_sym_u_SQUOTE] = ACTIONS(117),
    [anon_sym_U_SQUOTE] = ACTIONS(117),
    [anon_sym_u8_SQUOTE] = ACTIONS(117),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_L_DQUOTE] = ACTIONS(119),
    [anon_sym_u_DQUOTE] = ACTIONS(119),
    [anon_sym_U_DQUOTE] = ACTIONS(119),
    [anon_sym_u8_DQUOTE] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_R_DQUOTE] = ACTIONS(159),
    [anon_sym_LR_DQUOTE] = ACTIONS(159),
    [anon_sym_uR_DQUOTE] = ACTIONS(159),
    [anon_sym_UR_DQUOTE] = ACTIONS(159),
    [anon_sym_u8R_DQUOTE] = ACTIONS(159),
    [anon_sym_co_await] = ACTIONS(161),
    [anon_sym_new] = ACTIONS(163),
    [anon_sym_requires] = ACTIONS(165),
    [sym_this] = ACTIONS(231),
  },
  [1869] = {
    [sym_expression] = STATE(4396),
    [sym__string] = STATE(4431),
    [sym_conditional_expression] = STATE(4117),
    [sym_assignment_expression] = STATE(4117),
    [sym_pointer_expression] = STATE(3287),
    [sym_unary_expression] = STATE(4117),
    [sym_binary_expression] = STATE(4117),
    [sym_update_expression] = STATE(4117),
    [sym_cast_expression] = STATE(4117),
    [sym_sizeof_expression] = STATE(4117),
    [sym_alignof_expression] = STATE(4117),
    [sym_offsetof_expression] = STATE(4117),
    [sym_generic_expression] = STATE(4117),
    [sym_subscript_expression] = STATE(3287),
    [sym_call_expression] = STATE(3287),
    [sym_gnu_asm_expression] = STATE(4117),
    [sym_extension_expression] = STATE(4117),
    [sym_field_expression] = STATE(3287),
    [sym_compound_literal_expression] = STATE(4117),
    [sym_parenthesized_expression] = STATE(3287),
    [sym_char_literal] = STATE(4431),
    [sym_concatenated_string] = STATE(4431),
    [sym_string_literal] = STATE(3350),
    [sym_null] = STATE(4117),
    [sym_decltype] = STATE(8681),
    [sym__class_name] = STATE(8100),
    [sym_template_type] = STATE(2039),
    [sym_template_function] = STATE(4117),
    [sym_raw_string_literal] = STATE(3350),
    [sym_co_await_expression] = STATE(4117),
    [sym_new_expression] = STATE(4117),
    [sym_delete_expression] = STATE(4117),
    [sym_requires_clause] = STATE(4117),
    [sym_requires_expression] = STATE(4117),
    [sym_lambda_expression] = STATE(4117),
    [sym_lambda_capture_specifier] = STATE(5216),
    [sym_fold_expression] = STATE(4117),
    [sym_parameter_pack_expansion] = STATE(4117),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5925),
    [sym_qualified_identifier] = STATE(3287),
    [sym_qualified_type_identifier] = STATE(8100),
    [sym_user_defined_literal] = STATE(3287),
    [sym_identifier] = ACTIONS(4461),
    [anon_sym_LPAREN2] = ACTIONS(5123),
    [anon_sym_BANG] = ACTIONS(4293),
    [anon_sym_TILDE] = ACTIONS(4293),
    [anon_sym_DASH] = ACTIONS(4291),
    [anon_sym_PLUS] = ACTIONS(4291),
    [anon_sym_STAR] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
    [anon_sym___extension__] = ACTIONS(4295),
    [anon_sym_COLON_COLON] = ACTIONS(4297),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [sym_primitive_type] = ACTIONS(3564),
    [anon_sym_not] = ACTIONS(4291),
    [anon_sym_compl] = ACTIONS(4291),
    [anon_sym_DASH_DASH] = ACTIONS(4465),
    [anon_sym_PLUS_PLUS] = ACTIONS(4465),
    [anon_sym_sizeof] = ACTIONS(4301),
    [anon_sym___alignof__] = ACTIONS(107),
    [anon_sym___alignof] = ACTIONS(107),
    [anon_sym__alignof] = ACTIONS(107),
    [anon_sym_alignof] = ACTIONS(107),
    [anon_sym__Alignof] = ACTIONS(107),
    [anon_sym_offsetof] = ACTIONS(109),
    [anon_sym__Generic] = ACTIONS(111),
    [anon_sym_asm] = ACTIONS(113),
    [anon_sym___asm__] = ACTIONS(113),
    [anon_sym___asm] = ACTIONS(113),
    [sym_number_literal] = ACTIONS(4303),
    [anon_sym_L_SQUOTE] = ACTIONS(4305),
    [anon_sym_u_SQUOTE] = ACTIONS(4305),
    [anon_sym_U_SQUOTE] = ACTIONS(4305),
    [anon_sym_u8_SQUOTE] = ACTIONS(4305),
    [anon_sym_SQUOTE] = ACTIONS(4305),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_true] = ACTIONS(231),
    [sym_false] = ACTIONS(231),
    [anon_sym_NULL] = ACTIONS(123),
    [anon_sym_nullptr] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(4307),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
    [anon_sym_co_await] = ACTIONS(4309),
    [anon_sym_new] = ACTIONS(4311),
    [anon_sym_requires] = ACTIONS(4313),
    [sym_this] = ACTIONS(231),
  },
  [1870] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7741),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7741),
    [sym_variadic_parameter_declaration] = STATE(7741),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5442),
    [anon_sym_RPAREN] = ACTIONS(5444),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1871] = {
    [sym_catch_clause] = STATE(1875),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1875),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token2] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [aux_sym_preproc_else_token1] = ACTIONS(2122),
    [aux_sym_preproc_elif_token1] = ACTIONS(2122),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_private] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_friend] = ACTIONS(2122),
    [anon_sym_public] = ACTIONS(2122),
    [anon_sym_protected] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(5446),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
  },
  [1872] = {
    [sym_catch_clause] = STATE(1875),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1875),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token2] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [aux_sym_preproc_else_token1] = ACTIONS(2126),
    [aux_sym_preproc_elif_token1] = ACTIONS(2126),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_friend] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(5446),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
  },
  [1873] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7692),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7692),
    [sym_variadic_parameter_declaration] = STATE(7692),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5448),
    [anon_sym_RPAREN] = ACTIONS(5450),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1874] = {
    [sym_catch_clause] = STATE(1875),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1875),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token2] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [aux_sym_preproc_else_token1] = ACTIONS(2021),
    [aux_sym_preproc_elif_token1] = ACTIONS(2021),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_private] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_friend] = ACTIONS(2021),
    [anon_sym_public] = ACTIONS(2021),
    [anon_sym_protected] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(5446),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
  },
  [1875] = {
    [sym_catch_clause] = STATE(1875),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1875),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token2] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [aux_sym_preproc_else_token1] = ACTIONS(2031),
    [aux_sym_preproc_elif_token1] = ACTIONS(2031),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_friend] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(5452),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
  },
  [1876] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7627),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7627),
    [sym_variadic_parameter_declaration] = STATE(7627),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1937),
    [anon_sym_RPAREN] = ACTIONS(4277),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1877] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7757),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7757),
    [sym_variadic_parameter_declaration] = STATE(7757),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5455),
    [anon_sym_RPAREN] = ACTIONS(5457),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1878] = {
    [sym_identifier] = ACTIONS(5459),
    [anon_sym_RPAREN] = ACTIONS(5461),
    [anon_sym_LPAREN2] = ACTIONS(5461),
    [anon_sym_TILDE] = ACTIONS(5461),
    [anon_sym_STAR] = ACTIONS(5461),
    [anon_sym_PIPE_PIPE] = ACTIONS(5461),
    [anon_sym_AMP_AMP] = ACTIONS(5461),
    [anon_sym_AMP] = ACTIONS(5459),
    [anon_sym___extension__] = ACTIONS(5459),
    [anon_sym_in] = ACTIONS(5459),
    [anon_sym_out] = ACTIONS(5459),
    [anon_sym_inout] = ACTIONS(5459),
    [anon_sym_virtual] = ACTIONS(5459),
    [anon_sym_extern] = ACTIONS(5459),
    [anon_sym___attribute__] = ACTIONS(5459),
    [anon_sym___attribute] = ACTIONS(5459),
    [anon_sym_using] = ACTIONS(5459),
    [anon_sym_COLON_COLON] = ACTIONS(5461),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5461),
    [anon_sym___declspec] = ACTIONS(5459),
    [anon_sym___based] = ACTIONS(5459),
    [anon_sym___cdecl] = ACTIONS(5459),
    [anon_sym___clrcall] = ACTIONS(5459),
    [anon_sym___stdcall] = ACTIONS(5459),
    [anon_sym___fastcall] = ACTIONS(5459),
    [anon_sym___thiscall] = ACTIONS(5459),
    [anon_sym___vectorcall] = ACTIONS(5459),
    [anon_sym_LBRACE] = ACTIONS(5461),
    [anon_sym_signed] = ACTIONS(5459),
    [anon_sym_unsigned] = ACTIONS(5459),
    [anon_sym_long] = ACTIONS(5459),
    [anon_sym_short] = ACTIONS(5459),
    [anon_sym_LBRACK] = ACTIONS(5459),
    [anon_sym_static] = ACTIONS(5459),
    [anon_sym_register] = ACTIONS(5459),
    [anon_sym_inline] = ACTIONS(5459),
    [anon_sym___inline] = ACTIONS(5459),
    [anon_sym___inline__] = ACTIONS(5459),
    [anon_sym___forceinline] = ACTIONS(5459),
    [anon_sym_thread_local] = ACTIONS(5459),
    [anon_sym___thread] = ACTIONS(5459),
    [anon_sym_const] = ACTIONS(5459),
    [anon_sym_constexpr] = ACTIONS(5459),
    [anon_sym_volatile] = ACTIONS(5459),
    [anon_sym_restrict] = ACTIONS(5459),
    [anon_sym___restrict__] = ACTIONS(5459),
    [anon_sym__Atomic] = ACTIONS(5459),
    [anon_sym__Noreturn] = ACTIONS(5459),
    [anon_sym_noreturn] = ACTIONS(5459),
    [anon_sym__Nonnull] = ACTIONS(5459),
    [anon_sym_mutable] = ACTIONS(5459),
    [anon_sym_constinit] = ACTIONS(5459),
    [anon_sym_consteval] = ACTIONS(5459),
    [anon_sym_alignas] = ACTIONS(5459),
    [anon_sym__Alignas] = ACTIONS(5459),
    [sym_primitive_type] = ACTIONS(5459),
    [anon_sym_enum] = ACTIONS(5459),
    [anon_sym_class] = ACTIONS(5459),
    [anon_sym_struct] = ACTIONS(5459),
    [anon_sym_union] = ACTIONS(5459),
    [anon_sym_or] = ACTIONS(5459),
    [anon_sym_and] = ACTIONS(5459),
    [anon_sym_DASH_GT] = ACTIONS(5461),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5459),
    [anon_sym_decltype] = ACTIONS(5459),
    [anon_sym_final] = ACTIONS(5459),
    [anon_sym_override] = ACTIONS(5459),
    [anon_sym_explicit] = ACTIONS(5459),
    [anon_sym_typename] = ACTIONS(5459),
    [anon_sym_template] = ACTIONS(5459),
    [anon_sym_operator] = ACTIONS(5459),
    [anon_sym_friend] = ACTIONS(5459),
    [anon_sym_noexcept] = ACTIONS(5459),
    [anon_sym_throw] = ACTIONS(5459),
    [anon_sym_concept] = ACTIONS(5459),
    [anon_sym_requires] = ACTIONS(5459),
    [anon_sym_precise] = ACTIONS(5459),
    [anon_sym_shared] = ACTIONS(5459),
    [anon_sym_groupshared] = ACTIONS(5459),
    [anon_sym_uniform] = ACTIONS(5459),
    [anon_sym_row_major] = ACTIONS(5459),
    [anon_sym_column_major] = ACTIONS(5459),
    [anon_sym_globallycoherent] = ACTIONS(5459),
    [anon_sym_centroid] = ACTIONS(5459),
    [anon_sym_noperspective] = ACTIONS(5459),
    [anon_sym_nointerpolation] = ACTIONS(5459),
    [anon_sym_sample] = ACTIONS(5459),
    [anon_sym_linear] = ACTIONS(5459),
    [anon_sym_snorm] = ACTIONS(5459),
    [anon_sym_unorm] = ACTIONS(5459),
    [anon_sym_point] = ACTIONS(5459),
    [anon_sym_line] = ACTIONS(5459),
    [anon_sym_triangleadj] = ACTIONS(5459),
    [anon_sym_lineadj] = ACTIONS(5459),
    [anon_sym_triangle] = ACTIONS(5459),
  },
  [1879] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7548),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7548),
    [sym_variadic_parameter_declaration] = STATE(7548),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_RPAREN] = ACTIONS(1875),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1880] = {
    [sym_identifier] = ACTIONS(5463),
    [anon_sym_RPAREN] = ACTIONS(5465),
    [anon_sym_LPAREN2] = ACTIONS(5465),
    [anon_sym_TILDE] = ACTIONS(5465),
    [anon_sym_STAR] = ACTIONS(5465),
    [anon_sym_PIPE_PIPE] = ACTIONS(5465),
    [anon_sym_AMP_AMP] = ACTIONS(5465),
    [anon_sym_AMP] = ACTIONS(5463),
    [anon_sym___extension__] = ACTIONS(5463),
    [anon_sym_in] = ACTIONS(5463),
    [anon_sym_out] = ACTIONS(5463),
    [anon_sym_inout] = ACTIONS(5463),
    [anon_sym_virtual] = ACTIONS(5463),
    [anon_sym_extern] = ACTIONS(5463),
    [anon_sym___attribute__] = ACTIONS(5463),
    [anon_sym___attribute] = ACTIONS(5463),
    [anon_sym_using] = ACTIONS(5463),
    [anon_sym_COLON_COLON] = ACTIONS(5465),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5465),
    [anon_sym___declspec] = ACTIONS(5463),
    [anon_sym___based] = ACTIONS(5463),
    [anon_sym___cdecl] = ACTIONS(5463),
    [anon_sym___clrcall] = ACTIONS(5463),
    [anon_sym___stdcall] = ACTIONS(5463),
    [anon_sym___fastcall] = ACTIONS(5463),
    [anon_sym___thiscall] = ACTIONS(5463),
    [anon_sym___vectorcall] = ACTIONS(5463),
    [anon_sym_LBRACE] = ACTIONS(5465),
    [anon_sym_signed] = ACTIONS(5463),
    [anon_sym_unsigned] = ACTIONS(5463),
    [anon_sym_long] = ACTIONS(5463),
    [anon_sym_short] = ACTIONS(5463),
    [anon_sym_LBRACK] = ACTIONS(5463),
    [anon_sym_static] = ACTIONS(5463),
    [anon_sym_register] = ACTIONS(5463),
    [anon_sym_inline] = ACTIONS(5463),
    [anon_sym___inline] = ACTIONS(5463),
    [anon_sym___inline__] = ACTIONS(5463),
    [anon_sym___forceinline] = ACTIONS(5463),
    [anon_sym_thread_local] = ACTIONS(5463),
    [anon_sym___thread] = ACTIONS(5463),
    [anon_sym_const] = ACTIONS(5463),
    [anon_sym_constexpr] = ACTIONS(5463),
    [anon_sym_volatile] = ACTIONS(5463),
    [anon_sym_restrict] = ACTIONS(5463),
    [anon_sym___restrict__] = ACTIONS(5463),
    [anon_sym__Atomic] = ACTIONS(5463),
    [anon_sym__Noreturn] = ACTIONS(5463),
    [anon_sym_noreturn] = ACTIONS(5463),
    [anon_sym__Nonnull] = ACTIONS(5463),
    [anon_sym_mutable] = ACTIONS(5463),
    [anon_sym_constinit] = ACTIONS(5463),
    [anon_sym_consteval] = ACTIONS(5463),
    [anon_sym_alignas] = ACTIONS(5463),
    [anon_sym__Alignas] = ACTIONS(5463),
    [sym_primitive_type] = ACTIONS(5463),
    [anon_sym_enum] = ACTIONS(5463),
    [anon_sym_class] = ACTIONS(5463),
    [anon_sym_struct] = ACTIONS(5463),
    [anon_sym_union] = ACTIONS(5463),
    [anon_sym_or] = ACTIONS(5463),
    [anon_sym_and] = ACTIONS(5463),
    [anon_sym_DASH_GT] = ACTIONS(5465),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5463),
    [anon_sym_decltype] = ACTIONS(5463),
    [anon_sym_final] = ACTIONS(5463),
    [anon_sym_override] = ACTIONS(5463),
    [anon_sym_explicit] = ACTIONS(5463),
    [anon_sym_typename] = ACTIONS(5463),
    [anon_sym_template] = ACTIONS(5463),
    [anon_sym_operator] = ACTIONS(5463),
    [anon_sym_friend] = ACTIONS(5463),
    [anon_sym_noexcept] = ACTIONS(5463),
    [anon_sym_throw] = ACTIONS(5463),
    [anon_sym_concept] = ACTIONS(5463),
    [anon_sym_requires] = ACTIONS(5463),
    [anon_sym_precise] = ACTIONS(5463),
    [anon_sym_shared] = ACTIONS(5463),
    [anon_sym_groupshared] = ACTIONS(5463),
    [anon_sym_uniform] = ACTIONS(5463),
    [anon_sym_row_major] = ACTIONS(5463),
    [anon_sym_column_major] = ACTIONS(5463),
    [anon_sym_globallycoherent] = ACTIONS(5463),
    [anon_sym_centroid] = ACTIONS(5463),
    [anon_sym_noperspective] = ACTIONS(5463),
    [anon_sym_nointerpolation] = ACTIONS(5463),
    [anon_sym_sample] = ACTIONS(5463),
    [anon_sym_linear] = ACTIONS(5463),
    [anon_sym_snorm] = ACTIONS(5463),
    [anon_sym_unorm] = ACTIONS(5463),
    [anon_sym_point] = ACTIONS(5463),
    [anon_sym_line] = ACTIONS(5463),
    [anon_sym_triangleadj] = ACTIONS(5463),
    [anon_sym_lineadj] = ACTIONS(5463),
    [anon_sym_triangle] = ACTIONS(5463),
  },
  [1881] = {
    [sym_identifier] = ACTIONS(5467),
    [anon_sym_RPAREN] = ACTIONS(5469),
    [anon_sym_LPAREN2] = ACTIONS(5469),
    [anon_sym_TILDE] = ACTIONS(5469),
    [anon_sym_STAR] = ACTIONS(5469),
    [anon_sym_PIPE_PIPE] = ACTIONS(5469),
    [anon_sym_AMP_AMP] = ACTIONS(5469),
    [anon_sym_AMP] = ACTIONS(5467),
    [anon_sym___extension__] = ACTIONS(5467),
    [anon_sym_in] = ACTIONS(5467),
    [anon_sym_out] = ACTIONS(5467),
    [anon_sym_inout] = ACTIONS(5467),
    [anon_sym_virtual] = ACTIONS(5467),
    [anon_sym_extern] = ACTIONS(5467),
    [anon_sym___attribute__] = ACTIONS(5467),
    [anon_sym___attribute] = ACTIONS(5467),
    [anon_sym_using] = ACTIONS(5467),
    [anon_sym_COLON_COLON] = ACTIONS(5469),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5469),
    [anon_sym___declspec] = ACTIONS(5467),
    [anon_sym___based] = ACTIONS(5467),
    [anon_sym___cdecl] = ACTIONS(5467),
    [anon_sym___clrcall] = ACTIONS(5467),
    [anon_sym___stdcall] = ACTIONS(5467),
    [anon_sym___fastcall] = ACTIONS(5467),
    [anon_sym___thiscall] = ACTIONS(5467),
    [anon_sym___vectorcall] = ACTIONS(5467),
    [anon_sym_LBRACE] = ACTIONS(5469),
    [anon_sym_signed] = ACTIONS(5467),
    [anon_sym_unsigned] = ACTIONS(5467),
    [anon_sym_long] = ACTIONS(5467),
    [anon_sym_short] = ACTIONS(5467),
    [anon_sym_LBRACK] = ACTIONS(5467),
    [anon_sym_static] = ACTIONS(5467),
    [anon_sym_register] = ACTIONS(5467),
    [anon_sym_inline] = ACTIONS(5467),
    [anon_sym___inline] = ACTIONS(5467),
    [anon_sym___inline__] = ACTIONS(5467),
    [anon_sym___forceinline] = ACTIONS(5467),
    [anon_sym_thread_local] = ACTIONS(5467),
    [anon_sym___thread] = ACTIONS(5467),
    [anon_sym_const] = ACTIONS(5467),
    [anon_sym_constexpr] = ACTIONS(5467),
    [anon_sym_volatile] = ACTIONS(5467),
    [anon_sym_restrict] = ACTIONS(5467),
    [anon_sym___restrict__] = ACTIONS(5467),
    [anon_sym__Atomic] = ACTIONS(5467),
    [anon_sym__Noreturn] = ACTIONS(5467),
    [anon_sym_noreturn] = ACTIONS(5467),
    [anon_sym__Nonnull] = ACTIONS(5467),
    [anon_sym_mutable] = ACTIONS(5467),
    [anon_sym_constinit] = ACTIONS(5467),
    [anon_sym_consteval] = ACTIONS(5467),
    [anon_sym_alignas] = ACTIONS(5467),
    [anon_sym__Alignas] = ACTIONS(5467),
    [sym_primitive_type] = ACTIONS(5467),
    [anon_sym_enum] = ACTIONS(5467),
    [anon_sym_class] = ACTIONS(5467),
    [anon_sym_struct] = ACTIONS(5467),
    [anon_sym_union] = ACTIONS(5467),
    [anon_sym_or] = ACTIONS(5467),
    [anon_sym_and] = ACTIONS(5467),
    [anon_sym_DASH_GT] = ACTIONS(5469),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5467),
    [anon_sym_decltype] = ACTIONS(5467),
    [anon_sym_final] = ACTIONS(5467),
    [anon_sym_override] = ACTIONS(5467),
    [anon_sym_explicit] = ACTIONS(5467),
    [anon_sym_typename] = ACTIONS(5467),
    [anon_sym_template] = ACTIONS(5467),
    [anon_sym_operator] = ACTIONS(5467),
    [anon_sym_friend] = ACTIONS(5467),
    [anon_sym_noexcept] = ACTIONS(5467),
    [anon_sym_throw] = ACTIONS(5467),
    [anon_sym_concept] = ACTIONS(5467),
    [anon_sym_requires] = ACTIONS(5467),
    [anon_sym_precise] = ACTIONS(5467),
    [anon_sym_shared] = ACTIONS(5467),
    [anon_sym_groupshared] = ACTIONS(5467),
    [anon_sym_uniform] = ACTIONS(5467),
    [anon_sym_row_major] = ACTIONS(5467),
    [anon_sym_column_major] = ACTIONS(5467),
    [anon_sym_globallycoherent] = ACTIONS(5467),
    [anon_sym_centroid] = ACTIONS(5467),
    [anon_sym_noperspective] = ACTIONS(5467),
    [anon_sym_nointerpolation] = ACTIONS(5467),
    [anon_sym_sample] = ACTIONS(5467),
    [anon_sym_linear] = ACTIONS(5467),
    [anon_sym_snorm] = ACTIONS(5467),
    [anon_sym_unorm] = ACTIONS(5467),
    [anon_sym_point] = ACTIONS(5467),
    [anon_sym_line] = ACTIONS(5467),
    [anon_sym_triangleadj] = ACTIONS(5467),
    [anon_sym_lineadj] = ACTIONS(5467),
    [anon_sym_triangle] = ACTIONS(5467),
  },
  [1882] = {
    [sym_identifier] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5473),
    [anon_sym_LPAREN2] = ACTIONS(5473),
    [anon_sym_TILDE] = ACTIONS(5473),
    [anon_sym_STAR] = ACTIONS(5473),
    [anon_sym_PIPE_PIPE] = ACTIONS(5473),
    [anon_sym_AMP_AMP] = ACTIONS(5473),
    [anon_sym_AMP] = ACTIONS(5471),
    [anon_sym___extension__] = ACTIONS(5471),
    [anon_sym_in] = ACTIONS(5471),
    [anon_sym_out] = ACTIONS(5471),
    [anon_sym_inout] = ACTIONS(5471),
    [anon_sym_virtual] = ACTIONS(5471),
    [anon_sym_extern] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(5471),
    [anon_sym___attribute] = ACTIONS(5471),
    [anon_sym_using] = ACTIONS(5471),
    [anon_sym_COLON_COLON] = ACTIONS(5473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5473),
    [anon_sym___declspec] = ACTIONS(5471),
    [anon_sym___based] = ACTIONS(5471),
    [anon_sym___cdecl] = ACTIONS(5471),
    [anon_sym___clrcall] = ACTIONS(5471),
    [anon_sym___stdcall] = ACTIONS(5471),
    [anon_sym___fastcall] = ACTIONS(5471),
    [anon_sym___thiscall] = ACTIONS(5471),
    [anon_sym___vectorcall] = ACTIONS(5471),
    [anon_sym_LBRACE] = ACTIONS(5473),
    [anon_sym_signed] = ACTIONS(5471),
    [anon_sym_unsigned] = ACTIONS(5471),
    [anon_sym_long] = ACTIONS(5471),
    [anon_sym_short] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_static] = ACTIONS(5471),
    [anon_sym_register] = ACTIONS(5471),
    [anon_sym_inline] = ACTIONS(5471),
    [anon_sym___inline] = ACTIONS(5471),
    [anon_sym___inline__] = ACTIONS(5471),
    [anon_sym___forceinline] = ACTIONS(5471),
    [anon_sym_thread_local] = ACTIONS(5471),
    [anon_sym___thread] = ACTIONS(5471),
    [anon_sym_const] = ACTIONS(5471),
    [anon_sym_constexpr] = ACTIONS(5471),
    [anon_sym_volatile] = ACTIONS(5471),
    [anon_sym_restrict] = ACTIONS(5471),
    [anon_sym___restrict__] = ACTIONS(5471),
    [anon_sym__Atomic] = ACTIONS(5471),
    [anon_sym__Noreturn] = ACTIONS(5471),
    [anon_sym_noreturn] = ACTIONS(5471),
    [anon_sym__Nonnull] = ACTIONS(5471),
    [anon_sym_mutable] = ACTIONS(5471),
    [anon_sym_constinit] = ACTIONS(5471),
    [anon_sym_consteval] = ACTIONS(5471),
    [anon_sym_alignas] = ACTIONS(5471),
    [anon_sym__Alignas] = ACTIONS(5471),
    [sym_primitive_type] = ACTIONS(5471),
    [anon_sym_enum] = ACTIONS(5471),
    [anon_sym_class] = ACTIONS(5471),
    [anon_sym_struct] = ACTIONS(5471),
    [anon_sym_union] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5471),
    [anon_sym_and] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5471),
    [anon_sym_decltype] = ACTIONS(5471),
    [anon_sym_final] = ACTIONS(5471),
    [anon_sym_override] = ACTIONS(5471),
    [anon_sym_explicit] = ACTIONS(5471),
    [anon_sym_typename] = ACTIONS(5471),
    [anon_sym_template] = ACTIONS(5471),
    [anon_sym_operator] = ACTIONS(5471),
    [anon_sym_friend] = ACTIONS(5471),
    [anon_sym_noexcept] = ACTIONS(5471),
    [anon_sym_throw] = ACTIONS(5471),
    [anon_sym_concept] = ACTIONS(5471),
    [anon_sym_requires] = ACTIONS(5471),
    [anon_sym_precise] = ACTIONS(5471),
    [anon_sym_shared] = ACTIONS(5471),
    [anon_sym_groupshared] = ACTIONS(5471),
    [anon_sym_uniform] = ACTIONS(5471),
    [anon_sym_row_major] = ACTIONS(5471),
    [anon_sym_column_major] = ACTIONS(5471),
    [anon_sym_globallycoherent] = ACTIONS(5471),
    [anon_sym_centroid] = ACTIONS(5471),
    [anon_sym_noperspective] = ACTIONS(5471),
    [anon_sym_nointerpolation] = ACTIONS(5471),
    [anon_sym_sample] = ACTIONS(5471),
    [anon_sym_linear] = ACTIONS(5471),
    [anon_sym_snorm] = ACTIONS(5471),
    [anon_sym_unorm] = ACTIONS(5471),
    [anon_sym_point] = ACTIONS(5471),
    [anon_sym_line] = ACTIONS(5471),
    [anon_sym_triangleadj] = ACTIONS(5471),
    [anon_sym_lineadj] = ACTIONS(5471),
    [anon_sym_triangle] = ACTIONS(5471),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5473),
    [anon_sym_LPAREN2] = ACTIONS(5473),
    [anon_sym_TILDE] = ACTIONS(5473),
    [anon_sym_STAR] = ACTIONS(5473),
    [anon_sym_PIPE_PIPE] = ACTIONS(5473),
    [anon_sym_AMP_AMP] = ACTIONS(5473),
    [anon_sym_AMP] = ACTIONS(5471),
    [anon_sym___extension__] = ACTIONS(5471),
    [anon_sym_in] = ACTIONS(5471),
    [anon_sym_out] = ACTIONS(5471),
    [anon_sym_inout] = ACTIONS(5471),
    [anon_sym_virtual] = ACTIONS(5471),
    [anon_sym_extern] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(5471),
    [anon_sym___attribute] = ACTIONS(5471),
    [anon_sym_using] = ACTIONS(5471),
    [anon_sym_COLON_COLON] = ACTIONS(5473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5473),
    [anon_sym___declspec] = ACTIONS(5471),
    [anon_sym___based] = ACTIONS(5471),
    [anon_sym___cdecl] = ACTIONS(5471),
    [anon_sym___clrcall] = ACTIONS(5471),
    [anon_sym___stdcall] = ACTIONS(5471),
    [anon_sym___fastcall] = ACTIONS(5471),
    [anon_sym___thiscall] = ACTIONS(5471),
    [anon_sym___vectorcall] = ACTIONS(5471),
    [anon_sym_LBRACE] = ACTIONS(5473),
    [anon_sym_signed] = ACTIONS(5471),
    [anon_sym_unsigned] = ACTIONS(5471),
    [anon_sym_long] = ACTIONS(5471),
    [anon_sym_short] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_static] = ACTIONS(5471),
    [anon_sym_register] = ACTIONS(5471),
    [anon_sym_inline] = ACTIONS(5471),
    [anon_sym___inline] = ACTIONS(5471),
    [anon_sym___inline__] = ACTIONS(5471),
    [anon_sym___forceinline] = ACTIONS(5471),
    [anon_sym_thread_local] = ACTIONS(5471),
    [anon_sym___thread] = ACTIONS(5471),
    [anon_sym_const] = ACTIONS(5471),
    [anon_sym_constexpr] = ACTIONS(5471),
    [anon_sym_volatile] = ACTIONS(5471),
    [anon_sym_restrict] = ACTIONS(5471),
    [anon_sym___restrict__] = ACTIONS(5471),
    [anon_sym__Atomic] = ACTIONS(5471),
    [anon_sym__Noreturn] = ACTIONS(5471),
    [anon_sym_noreturn] = ACTIONS(5471),
    [anon_sym__Nonnull] = ACTIONS(5471),
    [anon_sym_mutable] = ACTIONS(5471),
    [anon_sym_constinit] = ACTIONS(5471),
    [anon_sym_consteval] = ACTIONS(5471),
    [anon_sym_alignas] = ACTIONS(5471),
    [anon_sym__Alignas] = ACTIONS(5471),
    [sym_primitive_type] = ACTIONS(5471),
    [anon_sym_enum] = ACTIONS(5471),
    [anon_sym_class] = ACTIONS(5471),
    [anon_sym_struct] = ACTIONS(5471),
    [anon_sym_union] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5471),
    [anon_sym_and] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5471),
    [anon_sym_decltype] = ACTIONS(5471),
    [anon_sym_final] = ACTIONS(5471),
    [anon_sym_override] = ACTIONS(5471),
    [anon_sym_explicit] = ACTIONS(5471),
    [anon_sym_typename] = ACTIONS(5471),
    [anon_sym_template] = ACTIONS(5471),
    [anon_sym_operator] = ACTIONS(5471),
    [anon_sym_friend] = ACTIONS(5471),
    [anon_sym_noexcept] = ACTIONS(5471),
    [anon_sym_throw] = ACTIONS(5471),
    [anon_sym_concept] = ACTIONS(5471),
    [anon_sym_requires] = ACTIONS(5471),
    [anon_sym_precise] = ACTIONS(5471),
    [anon_sym_shared] = ACTIONS(5471),
    [anon_sym_groupshared] = ACTIONS(5471),
    [anon_sym_uniform] = ACTIONS(5471),
    [anon_sym_row_major] = ACTIONS(5471),
    [anon_sym_column_major] = ACTIONS(5471),
    [anon_sym_globallycoherent] = ACTIONS(5471),
    [anon_sym_centroid] = ACTIONS(5471),
    [anon_sym_noperspective] = ACTIONS(5471),
    [anon_sym_nointerpolation] = ACTIONS(5471),
    [anon_sym_sample] = ACTIONS(5471),
    [anon_sym_linear] = ACTIONS(5471),
    [anon_sym_snorm] = ACTIONS(5471),
    [anon_sym_unorm] = ACTIONS(5471),
    [anon_sym_point] = ACTIONS(5471),
    [anon_sym_line] = ACTIONS(5471),
    [anon_sym_triangleadj] = ACTIONS(5471),
    [anon_sym_lineadj] = ACTIONS(5471),
    [anon_sym_triangle] = ACTIONS(5471),
  },
  [1884] = {
    [sym_identifier] = ACTIONS(5471),
    [anon_sym_RPAREN] = ACTIONS(5473),
    [anon_sym_LPAREN2] = ACTIONS(5473),
    [anon_sym_TILDE] = ACTIONS(5473),
    [anon_sym_STAR] = ACTIONS(5473),
    [anon_sym_PIPE_PIPE] = ACTIONS(5473),
    [anon_sym_AMP_AMP] = ACTIONS(5473),
    [anon_sym_AMP] = ACTIONS(5471),
    [anon_sym___extension__] = ACTIONS(5471),
    [anon_sym_in] = ACTIONS(5471),
    [anon_sym_out] = ACTIONS(5471),
    [anon_sym_inout] = ACTIONS(5471),
    [anon_sym_virtual] = ACTIONS(5471),
    [anon_sym_extern] = ACTIONS(5471),
    [anon_sym___attribute__] = ACTIONS(5471),
    [anon_sym___attribute] = ACTIONS(5471),
    [anon_sym_using] = ACTIONS(5471),
    [anon_sym_COLON_COLON] = ACTIONS(5473),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5473),
    [anon_sym___declspec] = ACTIONS(5471),
    [anon_sym___based] = ACTIONS(5471),
    [anon_sym___cdecl] = ACTIONS(5471),
    [anon_sym___clrcall] = ACTIONS(5471),
    [anon_sym___stdcall] = ACTIONS(5471),
    [anon_sym___fastcall] = ACTIONS(5471),
    [anon_sym___thiscall] = ACTIONS(5471),
    [anon_sym___vectorcall] = ACTIONS(5471),
    [anon_sym_LBRACE] = ACTIONS(5473),
    [anon_sym_signed] = ACTIONS(5471),
    [anon_sym_unsigned] = ACTIONS(5471),
    [anon_sym_long] = ACTIONS(5471),
    [anon_sym_short] = ACTIONS(5471),
    [anon_sym_LBRACK] = ACTIONS(5471),
    [anon_sym_static] = ACTIONS(5471),
    [anon_sym_register] = ACTIONS(5471),
    [anon_sym_inline] = ACTIONS(5471),
    [anon_sym___inline] = ACTIONS(5471),
    [anon_sym___inline__] = ACTIONS(5471),
    [anon_sym___forceinline] = ACTIONS(5471),
    [anon_sym_thread_local] = ACTIONS(5471),
    [anon_sym___thread] = ACTIONS(5471),
    [anon_sym_const] = ACTIONS(5471),
    [anon_sym_constexpr] = ACTIONS(5471),
    [anon_sym_volatile] = ACTIONS(5471),
    [anon_sym_restrict] = ACTIONS(5471),
    [anon_sym___restrict__] = ACTIONS(5471),
    [anon_sym__Atomic] = ACTIONS(5471),
    [anon_sym__Noreturn] = ACTIONS(5471),
    [anon_sym_noreturn] = ACTIONS(5471),
    [anon_sym__Nonnull] = ACTIONS(5471),
    [anon_sym_mutable] = ACTIONS(5471),
    [anon_sym_constinit] = ACTIONS(5471),
    [anon_sym_consteval] = ACTIONS(5471),
    [anon_sym_alignas] = ACTIONS(5471),
    [anon_sym__Alignas] = ACTIONS(5471),
    [sym_primitive_type] = ACTIONS(5471),
    [anon_sym_enum] = ACTIONS(5471),
    [anon_sym_class] = ACTIONS(5471),
    [anon_sym_struct] = ACTIONS(5471),
    [anon_sym_union] = ACTIONS(5471),
    [anon_sym_or] = ACTIONS(5471),
    [anon_sym_and] = ACTIONS(5471),
    [anon_sym_DASH_GT] = ACTIONS(5473),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5471),
    [anon_sym_decltype] = ACTIONS(5471),
    [anon_sym_final] = ACTIONS(5471),
    [anon_sym_override] = ACTIONS(5471),
    [anon_sym_explicit] = ACTIONS(5471),
    [anon_sym_typename] = ACTIONS(5471),
    [anon_sym_template] = ACTIONS(5471),
    [anon_sym_operator] = ACTIONS(5471),
    [anon_sym_friend] = ACTIONS(5471),
    [anon_sym_noexcept] = ACTIONS(5471),
    [anon_sym_throw] = ACTIONS(5471),
    [anon_sym_concept] = ACTIONS(5471),
    [anon_sym_requires] = ACTIONS(5471),
    [anon_sym_precise] = ACTIONS(5471),
    [anon_sym_shared] = ACTIONS(5471),
    [anon_sym_groupshared] = ACTIONS(5471),
    [anon_sym_uniform] = ACTIONS(5471),
    [anon_sym_row_major] = ACTIONS(5471),
    [anon_sym_column_major] = ACTIONS(5471),
    [anon_sym_globallycoherent] = ACTIONS(5471),
    [anon_sym_centroid] = ACTIONS(5471),
    [anon_sym_noperspective] = ACTIONS(5471),
    [anon_sym_nointerpolation] = ACTIONS(5471),
    [anon_sym_sample] = ACTIONS(5471),
    [anon_sym_linear] = ACTIONS(5471),
    [anon_sym_snorm] = ACTIONS(5471),
    [anon_sym_unorm] = ACTIONS(5471),
    [anon_sym_point] = ACTIONS(5471),
    [anon_sym_line] = ACTIONS(5471),
    [anon_sym_triangleadj] = ACTIONS(5471),
    [anon_sym_lineadj] = ACTIONS(5471),
    [anon_sym_triangle] = ACTIONS(5471),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(5475),
    [anon_sym_RPAREN] = ACTIONS(5477),
    [anon_sym_LPAREN2] = ACTIONS(5477),
    [anon_sym_TILDE] = ACTIONS(5477),
    [anon_sym_STAR] = ACTIONS(5477),
    [anon_sym_PIPE_PIPE] = ACTIONS(5477),
    [anon_sym_AMP_AMP] = ACTIONS(5477),
    [anon_sym_AMP] = ACTIONS(5475),
    [anon_sym___extension__] = ACTIONS(5475),
    [anon_sym_in] = ACTIONS(5475),
    [anon_sym_out] = ACTIONS(5475),
    [anon_sym_inout] = ACTIONS(5475),
    [anon_sym_virtual] = ACTIONS(5475),
    [anon_sym_extern] = ACTIONS(5475),
    [anon_sym___attribute__] = ACTIONS(5475),
    [anon_sym___attribute] = ACTIONS(5475),
    [anon_sym_using] = ACTIONS(5475),
    [anon_sym_COLON_COLON] = ACTIONS(5477),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5477),
    [anon_sym___declspec] = ACTIONS(5475),
    [anon_sym___based] = ACTIONS(5475),
    [anon_sym___cdecl] = ACTIONS(5475),
    [anon_sym___clrcall] = ACTIONS(5475),
    [anon_sym___stdcall] = ACTIONS(5475),
    [anon_sym___fastcall] = ACTIONS(5475),
    [anon_sym___thiscall] = ACTIONS(5475),
    [anon_sym___vectorcall] = ACTIONS(5475),
    [anon_sym_LBRACE] = ACTIONS(5477),
    [anon_sym_signed] = ACTIONS(5475),
    [anon_sym_unsigned] = ACTIONS(5475),
    [anon_sym_long] = ACTIONS(5475),
    [anon_sym_short] = ACTIONS(5475),
    [anon_sym_LBRACK] = ACTIONS(5475),
    [anon_sym_static] = ACTIONS(5475),
    [anon_sym_register] = ACTIONS(5475),
    [anon_sym_inline] = ACTIONS(5475),
    [anon_sym___inline] = ACTIONS(5475),
    [anon_sym___inline__] = ACTIONS(5475),
    [anon_sym___forceinline] = ACTIONS(5475),
    [anon_sym_thread_local] = ACTIONS(5475),
    [anon_sym___thread] = ACTIONS(5475),
    [anon_sym_const] = ACTIONS(5475),
    [anon_sym_constexpr] = ACTIONS(5475),
    [anon_sym_volatile] = ACTIONS(5475),
    [anon_sym_restrict] = ACTIONS(5475),
    [anon_sym___restrict__] = ACTIONS(5475),
    [anon_sym__Atomic] = ACTIONS(5475),
    [anon_sym__Noreturn] = ACTIONS(5475),
    [anon_sym_noreturn] = ACTIONS(5475),
    [anon_sym__Nonnull] = ACTIONS(5475),
    [anon_sym_mutable] = ACTIONS(5475),
    [anon_sym_constinit] = ACTIONS(5475),
    [anon_sym_consteval] = ACTIONS(5475),
    [anon_sym_alignas] = ACTIONS(5475),
    [anon_sym__Alignas] = ACTIONS(5475),
    [sym_primitive_type] = ACTIONS(5475),
    [anon_sym_enum] = ACTIONS(5475),
    [anon_sym_class] = ACTIONS(5475),
    [anon_sym_struct] = ACTIONS(5475),
    [anon_sym_union] = ACTIONS(5475),
    [anon_sym_or] = ACTIONS(5475),
    [anon_sym_and] = ACTIONS(5475),
    [anon_sym_DASH_GT] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5475),
    [anon_sym_decltype] = ACTIONS(5475),
    [anon_sym_final] = ACTIONS(5475),
    [anon_sym_override] = ACTIONS(5475),
    [anon_sym_explicit] = ACTIONS(5475),
    [anon_sym_typename] = ACTIONS(5475),
    [anon_sym_template] = ACTIONS(5475),
    [anon_sym_operator] = ACTIONS(5475),
    [anon_sym_friend] = ACTIONS(5475),
    [anon_sym_noexcept] = ACTIONS(5475),
    [anon_sym_throw] = ACTIONS(5475),
    [anon_sym_concept] = ACTIONS(5475),
    [anon_sym_requires] = ACTIONS(5475),
    [anon_sym_precise] = ACTIONS(5475),
    [anon_sym_shared] = ACTIONS(5475),
    [anon_sym_groupshared] = ACTIONS(5475),
    [anon_sym_uniform] = ACTIONS(5475),
    [anon_sym_row_major] = ACTIONS(5475),
    [anon_sym_column_major] = ACTIONS(5475),
    [anon_sym_globallycoherent] = ACTIONS(5475),
    [anon_sym_centroid] = ACTIONS(5475),
    [anon_sym_noperspective] = ACTIONS(5475),
    [anon_sym_nointerpolation] = ACTIONS(5475),
    [anon_sym_sample] = ACTIONS(5475),
    [anon_sym_linear] = ACTIONS(5475),
    [anon_sym_snorm] = ACTIONS(5475),
    [anon_sym_unorm] = ACTIONS(5475),
    [anon_sym_point] = ACTIONS(5475),
    [anon_sym_line] = ACTIONS(5475),
    [anon_sym_triangleadj] = ACTIONS(5475),
    [anon_sym_lineadj] = ACTIONS(5475),
    [anon_sym_triangle] = ACTIONS(5475),
  },
  [1886] = {
    [sym_identifier] = ACTIONS(5479),
    [anon_sym_RPAREN] = ACTIONS(5481),
    [anon_sym_LPAREN2] = ACTIONS(5481),
    [anon_sym_TILDE] = ACTIONS(5481),
    [anon_sym_STAR] = ACTIONS(5481),
    [anon_sym_PIPE_PIPE] = ACTIONS(5481),
    [anon_sym_AMP_AMP] = ACTIONS(5481),
    [anon_sym_AMP] = ACTIONS(5479),
    [anon_sym___extension__] = ACTIONS(5479),
    [anon_sym_in] = ACTIONS(5479),
    [anon_sym_out] = ACTIONS(5479),
    [anon_sym_inout] = ACTIONS(5479),
    [anon_sym_virtual] = ACTIONS(5479),
    [anon_sym_extern] = ACTIONS(5479),
    [anon_sym___attribute__] = ACTIONS(5479),
    [anon_sym___attribute] = ACTIONS(5479),
    [anon_sym_using] = ACTIONS(5479),
    [anon_sym_COLON_COLON] = ACTIONS(5481),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5481),
    [anon_sym___declspec] = ACTIONS(5479),
    [anon_sym___based] = ACTIONS(5479),
    [anon_sym___cdecl] = ACTIONS(5479),
    [anon_sym___clrcall] = ACTIONS(5479),
    [anon_sym___stdcall] = ACTIONS(5479),
    [anon_sym___fastcall] = ACTIONS(5479),
    [anon_sym___thiscall] = ACTIONS(5479),
    [anon_sym___vectorcall] = ACTIONS(5479),
    [anon_sym_LBRACE] = ACTIONS(5481),
    [anon_sym_signed] = ACTIONS(5479),
    [anon_sym_unsigned] = ACTIONS(5479),
    [anon_sym_long] = ACTIONS(5479),
    [anon_sym_short] = ACTIONS(5479),
    [anon_sym_LBRACK] = ACTIONS(5479),
    [anon_sym_static] = ACTIONS(5479),
    [anon_sym_register] = ACTIONS(5479),
    [anon_sym_inline] = ACTIONS(5479),
    [anon_sym___inline] = ACTIONS(5479),
    [anon_sym___inline__] = ACTIONS(5479),
    [anon_sym___forceinline] = ACTIONS(5479),
    [anon_sym_thread_local] = ACTIONS(5479),
    [anon_sym___thread] = ACTIONS(5479),
    [anon_sym_const] = ACTIONS(5479),
    [anon_sym_constexpr] = ACTIONS(5479),
    [anon_sym_volatile] = ACTIONS(5479),
    [anon_sym_restrict] = ACTIONS(5479),
    [anon_sym___restrict__] = ACTIONS(5479),
    [anon_sym__Atomic] = ACTIONS(5479),
    [anon_sym__Noreturn] = ACTIONS(5479),
    [anon_sym_noreturn] = ACTIONS(5479),
    [anon_sym__Nonnull] = ACTIONS(5479),
    [anon_sym_mutable] = ACTIONS(5479),
    [anon_sym_constinit] = ACTIONS(5479),
    [anon_sym_consteval] = ACTIONS(5479),
    [anon_sym_alignas] = ACTIONS(5479),
    [anon_sym__Alignas] = ACTIONS(5479),
    [sym_primitive_type] = ACTIONS(5479),
    [anon_sym_enum] = ACTIONS(5479),
    [anon_sym_class] = ACTIONS(5479),
    [anon_sym_struct] = ACTIONS(5479),
    [anon_sym_union] = ACTIONS(5479),
    [anon_sym_or] = ACTIONS(5479),
    [anon_sym_and] = ACTIONS(5479),
    [anon_sym_DASH_GT] = ACTIONS(5481),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5479),
    [anon_sym_decltype] = ACTIONS(5479),
    [anon_sym_final] = ACTIONS(5479),
    [anon_sym_override] = ACTIONS(5479),
    [anon_sym_explicit] = ACTIONS(5479),
    [anon_sym_typename] = ACTIONS(5479),
    [anon_sym_template] = ACTIONS(5479),
    [anon_sym_operator] = ACTIONS(5479),
    [anon_sym_friend] = ACTIONS(5479),
    [anon_sym_noexcept] = ACTIONS(5479),
    [anon_sym_throw] = ACTIONS(5479),
    [anon_sym_concept] = ACTIONS(5479),
    [anon_sym_requires] = ACTIONS(5479),
    [anon_sym_precise] = ACTIONS(5479),
    [anon_sym_shared] = ACTIONS(5479),
    [anon_sym_groupshared] = ACTIONS(5479),
    [anon_sym_uniform] = ACTIONS(5479),
    [anon_sym_row_major] = ACTIONS(5479),
    [anon_sym_column_major] = ACTIONS(5479),
    [anon_sym_globallycoherent] = ACTIONS(5479),
    [anon_sym_centroid] = ACTIONS(5479),
    [anon_sym_noperspective] = ACTIONS(5479),
    [anon_sym_nointerpolation] = ACTIONS(5479),
    [anon_sym_sample] = ACTIONS(5479),
    [anon_sym_linear] = ACTIONS(5479),
    [anon_sym_snorm] = ACTIONS(5479),
    [anon_sym_unorm] = ACTIONS(5479),
    [anon_sym_point] = ACTIONS(5479),
    [anon_sym_line] = ACTIONS(5479),
    [anon_sym_triangleadj] = ACTIONS(5479),
    [anon_sym_lineadj] = ACTIONS(5479),
    [anon_sym_triangle] = ACTIONS(5479),
  },
  [1887] = {
    [sym_identifier] = ACTIONS(5483),
    [anon_sym_RPAREN] = ACTIONS(5485),
    [anon_sym_LPAREN2] = ACTIONS(5485),
    [anon_sym_TILDE] = ACTIONS(5485),
    [anon_sym_STAR] = ACTIONS(5485),
    [anon_sym_PIPE_PIPE] = ACTIONS(5485),
    [anon_sym_AMP_AMP] = ACTIONS(5485),
    [anon_sym_AMP] = ACTIONS(5483),
    [anon_sym___extension__] = ACTIONS(5483),
    [anon_sym_in] = ACTIONS(5483),
    [anon_sym_out] = ACTIONS(5483),
    [anon_sym_inout] = ACTIONS(5483),
    [anon_sym_virtual] = ACTIONS(5483),
    [anon_sym_extern] = ACTIONS(5483),
    [anon_sym___attribute__] = ACTIONS(5483),
    [anon_sym___attribute] = ACTIONS(5483),
    [anon_sym_using] = ACTIONS(5483),
    [anon_sym_COLON_COLON] = ACTIONS(5485),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5485),
    [anon_sym___declspec] = ACTIONS(5483),
    [anon_sym___based] = ACTIONS(5483),
    [anon_sym___cdecl] = ACTIONS(5483),
    [anon_sym___clrcall] = ACTIONS(5483),
    [anon_sym___stdcall] = ACTIONS(5483),
    [anon_sym___fastcall] = ACTIONS(5483),
    [anon_sym___thiscall] = ACTIONS(5483),
    [anon_sym___vectorcall] = ACTIONS(5483),
    [anon_sym_LBRACE] = ACTIONS(5485),
    [anon_sym_signed] = ACTIONS(5483),
    [anon_sym_unsigned] = ACTIONS(5483),
    [anon_sym_long] = ACTIONS(5483),
    [anon_sym_short] = ACTIONS(5483),
    [anon_sym_LBRACK] = ACTIONS(5483),
    [anon_sym_static] = ACTIONS(5483),
    [anon_sym_register] = ACTIONS(5483),
    [anon_sym_inline] = ACTIONS(5483),
    [anon_sym___inline] = ACTIONS(5483),
    [anon_sym___inline__] = ACTIONS(5483),
    [anon_sym___forceinline] = ACTIONS(5483),
    [anon_sym_thread_local] = ACTIONS(5483),
    [anon_sym___thread] = ACTIONS(5483),
    [anon_sym_const] = ACTIONS(5483),
    [anon_sym_constexpr] = ACTIONS(5483),
    [anon_sym_volatile] = ACTIONS(5483),
    [anon_sym_restrict] = ACTIONS(5483),
    [anon_sym___restrict__] = ACTIONS(5483),
    [anon_sym__Atomic] = ACTIONS(5483),
    [anon_sym__Noreturn] = ACTIONS(5483),
    [anon_sym_noreturn] = ACTIONS(5483),
    [anon_sym__Nonnull] = ACTIONS(5483),
    [anon_sym_mutable] = ACTIONS(5483),
    [anon_sym_constinit] = ACTIONS(5483),
    [anon_sym_consteval] = ACTIONS(5483),
    [anon_sym_alignas] = ACTIONS(5483),
    [anon_sym__Alignas] = ACTIONS(5483),
    [sym_primitive_type] = ACTIONS(5483),
    [anon_sym_enum] = ACTIONS(5483),
    [anon_sym_class] = ACTIONS(5483),
    [anon_sym_struct] = ACTIONS(5483),
    [anon_sym_union] = ACTIONS(5483),
    [anon_sym_or] = ACTIONS(5483),
    [anon_sym_and] = ACTIONS(5483),
    [anon_sym_DASH_GT] = ACTIONS(5485),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5483),
    [anon_sym_decltype] = ACTIONS(5483),
    [anon_sym_final] = ACTIONS(5483),
    [anon_sym_override] = ACTIONS(5483),
    [anon_sym_explicit] = ACTIONS(5483),
    [anon_sym_typename] = ACTIONS(5483),
    [anon_sym_template] = ACTIONS(5483),
    [anon_sym_operator] = ACTIONS(5483),
    [anon_sym_friend] = ACTIONS(5483),
    [anon_sym_noexcept] = ACTIONS(5483),
    [anon_sym_throw] = ACTIONS(5483),
    [anon_sym_concept] = ACTIONS(5483),
    [anon_sym_requires] = ACTIONS(5483),
    [anon_sym_precise] = ACTIONS(5483),
    [anon_sym_shared] = ACTIONS(5483),
    [anon_sym_groupshared] = ACTIONS(5483),
    [anon_sym_uniform] = ACTIONS(5483),
    [anon_sym_row_major] = ACTIONS(5483),
    [anon_sym_column_major] = ACTIONS(5483),
    [anon_sym_globallycoherent] = ACTIONS(5483),
    [anon_sym_centroid] = ACTIONS(5483),
    [anon_sym_noperspective] = ACTIONS(5483),
    [anon_sym_nointerpolation] = ACTIONS(5483),
    [anon_sym_sample] = ACTIONS(5483),
    [anon_sym_linear] = ACTIONS(5483),
    [anon_sym_snorm] = ACTIONS(5483),
    [anon_sym_unorm] = ACTIONS(5483),
    [anon_sym_point] = ACTIONS(5483),
    [anon_sym_line] = ACTIONS(5483),
    [anon_sym_triangleadj] = ACTIONS(5483),
    [anon_sym_lineadj] = ACTIONS(5483),
    [anon_sym_triangle] = ACTIONS(5483),
  },
  [1888] = {
    [sym_identifier] = ACTIONS(5487),
    [anon_sym_RPAREN] = ACTIONS(5489),
    [anon_sym_LPAREN2] = ACTIONS(5489),
    [anon_sym_TILDE] = ACTIONS(5489),
    [anon_sym_STAR] = ACTIONS(5489),
    [anon_sym_PIPE_PIPE] = ACTIONS(5489),
    [anon_sym_AMP_AMP] = ACTIONS(5489),
    [anon_sym_AMP] = ACTIONS(5487),
    [anon_sym___extension__] = ACTIONS(5487),
    [anon_sym_in] = ACTIONS(5487),
    [anon_sym_out] = ACTIONS(5487),
    [anon_sym_inout] = ACTIONS(5487),
    [anon_sym_virtual] = ACTIONS(5487),
    [anon_sym_extern] = ACTIONS(5487),
    [anon_sym___attribute__] = ACTIONS(5487),
    [anon_sym___attribute] = ACTIONS(5487),
    [anon_sym_using] = ACTIONS(5487),
    [anon_sym_COLON_COLON] = ACTIONS(5489),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5489),
    [anon_sym___declspec] = ACTIONS(5487),
    [anon_sym___based] = ACTIONS(5487),
    [anon_sym___cdecl] = ACTIONS(5487),
    [anon_sym___clrcall] = ACTIONS(5487),
    [anon_sym___stdcall] = ACTIONS(5487),
    [anon_sym___fastcall] = ACTIONS(5487),
    [anon_sym___thiscall] = ACTIONS(5487),
    [anon_sym___vectorcall] = ACTIONS(5487),
    [anon_sym_LBRACE] = ACTIONS(5489),
    [anon_sym_signed] = ACTIONS(5487),
    [anon_sym_unsigned] = ACTIONS(5487),
    [anon_sym_long] = ACTIONS(5487),
    [anon_sym_short] = ACTIONS(5487),
    [anon_sym_LBRACK] = ACTIONS(5487),
    [anon_sym_static] = ACTIONS(5487),
    [anon_sym_register] = ACTIONS(5487),
    [anon_sym_inline] = ACTIONS(5487),
    [anon_sym___inline] = ACTIONS(5487),
    [anon_sym___inline__] = ACTIONS(5487),
    [anon_sym___forceinline] = ACTIONS(5487),
    [anon_sym_thread_local] = ACTIONS(5487),
    [anon_sym___thread] = ACTIONS(5487),
    [anon_sym_const] = ACTIONS(5487),
    [anon_sym_constexpr] = ACTIONS(5487),
    [anon_sym_volatile] = ACTIONS(5487),
    [anon_sym_restrict] = ACTIONS(5487),
    [anon_sym___restrict__] = ACTIONS(5487),
    [anon_sym__Atomic] = ACTIONS(5487),
    [anon_sym__Noreturn] = ACTIONS(5487),
    [anon_sym_noreturn] = ACTIONS(5487),
    [anon_sym__Nonnull] = ACTIONS(5487),
    [anon_sym_mutable] = ACTIONS(5487),
    [anon_sym_constinit] = ACTIONS(5487),
    [anon_sym_consteval] = ACTIONS(5487),
    [anon_sym_alignas] = ACTIONS(5487),
    [anon_sym__Alignas] = ACTIONS(5487),
    [sym_primitive_type] = ACTIONS(5487),
    [anon_sym_enum] = ACTIONS(5487),
    [anon_sym_class] = ACTIONS(5487),
    [anon_sym_struct] = ACTIONS(5487),
    [anon_sym_union] = ACTIONS(5487),
    [anon_sym_or] = ACTIONS(5487),
    [anon_sym_and] = ACTIONS(5487),
    [anon_sym_DASH_GT] = ACTIONS(5489),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5487),
    [anon_sym_decltype] = ACTIONS(5487),
    [anon_sym_final] = ACTIONS(5487),
    [anon_sym_override] = ACTIONS(5487),
    [anon_sym_explicit] = ACTIONS(5487),
    [anon_sym_typename] = ACTIONS(5487),
    [anon_sym_template] = ACTIONS(5487),
    [anon_sym_operator] = ACTIONS(5487),
    [anon_sym_friend] = ACTIONS(5487),
    [anon_sym_noexcept] = ACTIONS(5487),
    [anon_sym_throw] = ACTIONS(5487),
    [anon_sym_concept] = ACTIONS(5487),
    [anon_sym_requires] = ACTIONS(5487),
    [anon_sym_precise] = ACTIONS(5487),
    [anon_sym_shared] = ACTIONS(5487),
    [anon_sym_groupshared] = ACTIONS(5487),
    [anon_sym_uniform] = ACTIONS(5487),
    [anon_sym_row_major] = ACTIONS(5487),
    [anon_sym_column_major] = ACTIONS(5487),
    [anon_sym_globallycoherent] = ACTIONS(5487),
    [anon_sym_centroid] = ACTIONS(5487),
    [anon_sym_noperspective] = ACTIONS(5487),
    [anon_sym_nointerpolation] = ACTIONS(5487),
    [anon_sym_sample] = ACTIONS(5487),
    [anon_sym_linear] = ACTIONS(5487),
    [anon_sym_snorm] = ACTIONS(5487),
    [anon_sym_unorm] = ACTIONS(5487),
    [anon_sym_point] = ACTIONS(5487),
    [anon_sym_line] = ACTIONS(5487),
    [anon_sym_triangleadj] = ACTIONS(5487),
    [anon_sym_lineadj] = ACTIONS(5487),
    [anon_sym_triangle] = ACTIONS(5487),
  },
  [1889] = {
    [sym_identifier] = ACTIONS(5491),
    [anon_sym_RPAREN] = ACTIONS(5493),
    [anon_sym_LPAREN2] = ACTIONS(5493),
    [anon_sym_TILDE] = ACTIONS(5493),
    [anon_sym_STAR] = ACTIONS(5493),
    [anon_sym_PIPE_PIPE] = ACTIONS(5493),
    [anon_sym_AMP_AMP] = ACTIONS(5493),
    [anon_sym_AMP] = ACTIONS(5491),
    [anon_sym___extension__] = ACTIONS(5491),
    [anon_sym_in] = ACTIONS(5491),
    [anon_sym_out] = ACTIONS(5491),
    [anon_sym_inout] = ACTIONS(5491),
    [anon_sym_virtual] = ACTIONS(5491),
    [anon_sym_extern] = ACTIONS(5491),
    [anon_sym___attribute__] = ACTIONS(5491),
    [anon_sym___attribute] = ACTIONS(5491),
    [anon_sym_using] = ACTIONS(5491),
    [anon_sym_COLON_COLON] = ACTIONS(5493),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5493),
    [anon_sym___declspec] = ACTIONS(5491),
    [anon_sym___based] = ACTIONS(5491),
    [anon_sym___cdecl] = ACTIONS(5491),
    [anon_sym___clrcall] = ACTIONS(5491),
    [anon_sym___stdcall] = ACTIONS(5491),
    [anon_sym___fastcall] = ACTIONS(5491),
    [anon_sym___thiscall] = ACTIONS(5491),
    [anon_sym___vectorcall] = ACTIONS(5491),
    [anon_sym_LBRACE] = ACTIONS(5493),
    [anon_sym_signed] = ACTIONS(5491),
    [anon_sym_unsigned] = ACTIONS(5491),
    [anon_sym_long] = ACTIONS(5491),
    [anon_sym_short] = ACTIONS(5491),
    [anon_sym_LBRACK] = ACTIONS(5491),
    [anon_sym_static] = ACTIONS(5491),
    [anon_sym_register] = ACTIONS(5491),
    [anon_sym_inline] = ACTIONS(5491),
    [anon_sym___inline] = ACTIONS(5491),
    [anon_sym___inline__] = ACTIONS(5491),
    [anon_sym___forceinline] = ACTIONS(5491),
    [anon_sym_thread_local] = ACTIONS(5491),
    [anon_sym___thread] = ACTIONS(5491),
    [anon_sym_const] = ACTIONS(5491),
    [anon_sym_constexpr] = ACTIONS(5491),
    [anon_sym_volatile] = ACTIONS(5491),
    [anon_sym_restrict] = ACTIONS(5491),
    [anon_sym___restrict__] = ACTIONS(5491),
    [anon_sym__Atomic] = ACTIONS(5491),
    [anon_sym__Noreturn] = ACTIONS(5491),
    [anon_sym_noreturn] = ACTIONS(5491),
    [anon_sym__Nonnull] = ACTIONS(5491),
    [anon_sym_mutable] = ACTIONS(5491),
    [anon_sym_constinit] = ACTIONS(5491),
    [anon_sym_consteval] = ACTIONS(5491),
    [anon_sym_alignas] = ACTIONS(5491),
    [anon_sym__Alignas] = ACTIONS(5491),
    [sym_primitive_type] = ACTIONS(5491),
    [anon_sym_enum] = ACTIONS(5491),
    [anon_sym_class] = ACTIONS(5491),
    [anon_sym_struct] = ACTIONS(5491),
    [anon_sym_union] = ACTIONS(5491),
    [anon_sym_or] = ACTIONS(5491),
    [anon_sym_and] = ACTIONS(5491),
    [anon_sym_DASH_GT] = ACTIONS(5493),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5491),
    [anon_sym_decltype] = ACTIONS(5491),
    [anon_sym_final] = ACTIONS(5491),
    [anon_sym_override] = ACTIONS(5491),
    [anon_sym_explicit] = ACTIONS(5491),
    [anon_sym_typename] = ACTIONS(5491),
    [anon_sym_template] = ACTIONS(5491),
    [anon_sym_operator] = ACTIONS(5491),
    [anon_sym_friend] = ACTIONS(5491),
    [anon_sym_noexcept] = ACTIONS(5491),
    [anon_sym_throw] = ACTIONS(5491),
    [anon_sym_concept] = ACTIONS(5491),
    [anon_sym_requires] = ACTIONS(5491),
    [anon_sym_precise] = ACTIONS(5491),
    [anon_sym_shared] = ACTIONS(5491),
    [anon_sym_groupshared] = ACTIONS(5491),
    [anon_sym_uniform] = ACTIONS(5491),
    [anon_sym_row_major] = ACTIONS(5491),
    [anon_sym_column_major] = ACTIONS(5491),
    [anon_sym_globallycoherent] = ACTIONS(5491),
    [anon_sym_centroid] = ACTIONS(5491),
    [anon_sym_noperspective] = ACTIONS(5491),
    [anon_sym_nointerpolation] = ACTIONS(5491),
    [anon_sym_sample] = ACTIONS(5491),
    [anon_sym_linear] = ACTIONS(5491),
    [anon_sym_snorm] = ACTIONS(5491),
    [anon_sym_unorm] = ACTIONS(5491),
    [anon_sym_point] = ACTIONS(5491),
    [anon_sym_line] = ACTIONS(5491),
    [anon_sym_triangleadj] = ACTIONS(5491),
    [anon_sym_lineadj] = ACTIONS(5491),
    [anon_sym_triangle] = ACTIONS(5491),
  },
  [1890] = {
    [sym_identifier] = ACTIONS(5495),
    [anon_sym_RPAREN] = ACTIONS(5497),
    [anon_sym_LPAREN2] = ACTIONS(5497),
    [anon_sym_TILDE] = ACTIONS(5497),
    [anon_sym_STAR] = ACTIONS(5497),
    [anon_sym_PIPE_PIPE] = ACTIONS(5497),
    [anon_sym_AMP_AMP] = ACTIONS(5497),
    [anon_sym_AMP] = ACTIONS(5495),
    [anon_sym___extension__] = ACTIONS(5495),
    [anon_sym_in] = ACTIONS(5495),
    [anon_sym_out] = ACTIONS(5495),
    [anon_sym_inout] = ACTIONS(5495),
    [anon_sym_virtual] = ACTIONS(5495),
    [anon_sym_extern] = ACTIONS(5495),
    [anon_sym___attribute__] = ACTIONS(5495),
    [anon_sym___attribute] = ACTIONS(5495),
    [anon_sym_using] = ACTIONS(5495),
    [anon_sym_COLON_COLON] = ACTIONS(5497),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5497),
    [anon_sym___declspec] = ACTIONS(5495),
    [anon_sym___based] = ACTIONS(5495),
    [anon_sym___cdecl] = ACTIONS(5495),
    [anon_sym___clrcall] = ACTIONS(5495),
    [anon_sym___stdcall] = ACTIONS(5495),
    [anon_sym___fastcall] = ACTIONS(5495),
    [anon_sym___thiscall] = ACTIONS(5495),
    [anon_sym___vectorcall] = ACTIONS(5495),
    [anon_sym_LBRACE] = ACTIONS(5497),
    [anon_sym_signed] = ACTIONS(5495),
    [anon_sym_unsigned] = ACTIONS(5495),
    [anon_sym_long] = ACTIONS(5495),
    [anon_sym_short] = ACTIONS(5495),
    [anon_sym_LBRACK] = ACTIONS(5495),
    [anon_sym_static] = ACTIONS(5495),
    [anon_sym_register] = ACTIONS(5495),
    [anon_sym_inline] = ACTIONS(5495),
    [anon_sym___inline] = ACTIONS(5495),
    [anon_sym___inline__] = ACTIONS(5495),
    [anon_sym___forceinline] = ACTIONS(5495),
    [anon_sym_thread_local] = ACTIONS(5495),
    [anon_sym___thread] = ACTIONS(5495),
    [anon_sym_const] = ACTIONS(5495),
    [anon_sym_constexpr] = ACTIONS(5495),
    [anon_sym_volatile] = ACTIONS(5495),
    [anon_sym_restrict] = ACTIONS(5495),
    [anon_sym___restrict__] = ACTIONS(5495),
    [anon_sym__Atomic] = ACTIONS(5495),
    [anon_sym__Noreturn] = ACTIONS(5495),
    [anon_sym_noreturn] = ACTIONS(5495),
    [anon_sym__Nonnull] = ACTIONS(5495),
    [anon_sym_mutable] = ACTIONS(5495),
    [anon_sym_constinit] = ACTIONS(5495),
    [anon_sym_consteval] = ACTIONS(5495),
    [anon_sym_alignas] = ACTIONS(5495),
    [anon_sym__Alignas] = ACTIONS(5495),
    [sym_primitive_type] = ACTIONS(5495),
    [anon_sym_enum] = ACTIONS(5495),
    [anon_sym_class] = ACTIONS(5495),
    [anon_sym_struct] = ACTIONS(5495),
    [anon_sym_union] = ACTIONS(5495),
    [anon_sym_or] = ACTIONS(5495),
    [anon_sym_and] = ACTIONS(5495),
    [anon_sym_DASH_GT] = ACTIONS(5497),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5495),
    [anon_sym_decltype] = ACTIONS(5495),
    [anon_sym_final] = ACTIONS(5495),
    [anon_sym_override] = ACTIONS(5495),
    [anon_sym_explicit] = ACTIONS(5495),
    [anon_sym_typename] = ACTIONS(5495),
    [anon_sym_template] = ACTIONS(5495),
    [anon_sym_operator] = ACTIONS(5495),
    [anon_sym_friend] = ACTIONS(5495),
    [anon_sym_noexcept] = ACTIONS(5495),
    [anon_sym_throw] = ACTIONS(5495),
    [anon_sym_concept] = ACTIONS(5495),
    [anon_sym_requires] = ACTIONS(5495),
    [anon_sym_precise] = ACTIONS(5495),
    [anon_sym_shared] = ACTIONS(5495),
    [anon_sym_groupshared] = ACTIONS(5495),
    [anon_sym_uniform] = ACTIONS(5495),
    [anon_sym_row_major] = ACTIONS(5495),
    [anon_sym_column_major] = ACTIONS(5495),
    [anon_sym_globallycoherent] = ACTIONS(5495),
    [anon_sym_centroid] = ACTIONS(5495),
    [anon_sym_noperspective] = ACTIONS(5495),
    [anon_sym_nointerpolation] = ACTIONS(5495),
    [anon_sym_sample] = ACTIONS(5495),
    [anon_sym_linear] = ACTIONS(5495),
    [anon_sym_snorm] = ACTIONS(5495),
    [anon_sym_unorm] = ACTIONS(5495),
    [anon_sym_point] = ACTIONS(5495),
    [anon_sym_line] = ACTIONS(5495),
    [anon_sym_triangleadj] = ACTIONS(5495),
    [anon_sym_lineadj] = ACTIONS(5495),
    [anon_sym_triangle] = ACTIONS(5495),
  },
  [1891] = {
    [sym_identifier] = ACTIONS(5499),
    [anon_sym_RPAREN] = ACTIONS(5501),
    [anon_sym_LPAREN2] = ACTIONS(5501),
    [anon_sym_TILDE] = ACTIONS(5501),
    [anon_sym_STAR] = ACTIONS(5501),
    [anon_sym_PIPE_PIPE] = ACTIONS(5501),
    [anon_sym_AMP_AMP] = ACTIONS(5501),
    [anon_sym_AMP] = ACTIONS(5499),
    [anon_sym___extension__] = ACTIONS(5499),
    [anon_sym_in] = ACTIONS(5499),
    [anon_sym_out] = ACTIONS(5499),
    [anon_sym_inout] = ACTIONS(5499),
    [anon_sym_virtual] = ACTIONS(5499),
    [anon_sym_extern] = ACTIONS(5499),
    [anon_sym___attribute__] = ACTIONS(5499),
    [anon_sym___attribute] = ACTIONS(5499),
    [anon_sym_using] = ACTIONS(5499),
    [anon_sym_COLON_COLON] = ACTIONS(5501),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5501),
    [anon_sym___declspec] = ACTIONS(5499),
    [anon_sym___based] = ACTIONS(5499),
    [anon_sym___cdecl] = ACTIONS(5499),
    [anon_sym___clrcall] = ACTIONS(5499),
    [anon_sym___stdcall] = ACTIONS(5499),
    [anon_sym___fastcall] = ACTIONS(5499),
    [anon_sym___thiscall] = ACTIONS(5499),
    [anon_sym___vectorcall] = ACTIONS(5499),
    [anon_sym_LBRACE] = ACTIONS(5501),
    [anon_sym_signed] = ACTIONS(5499),
    [anon_sym_unsigned] = ACTIONS(5499),
    [anon_sym_long] = ACTIONS(5499),
    [anon_sym_short] = ACTIONS(5499),
    [anon_sym_LBRACK] = ACTIONS(5499),
    [anon_sym_static] = ACTIONS(5499),
    [anon_sym_register] = ACTIONS(5499),
    [anon_sym_inline] = ACTIONS(5499),
    [anon_sym___inline] = ACTIONS(5499),
    [anon_sym___inline__] = ACTIONS(5499),
    [anon_sym___forceinline] = ACTIONS(5499),
    [anon_sym_thread_local] = ACTIONS(5499),
    [anon_sym___thread] = ACTIONS(5499),
    [anon_sym_const] = ACTIONS(5499),
    [anon_sym_constexpr] = ACTIONS(5499),
    [anon_sym_volatile] = ACTIONS(5499),
    [anon_sym_restrict] = ACTIONS(5499),
    [anon_sym___restrict__] = ACTIONS(5499),
    [anon_sym__Atomic] = ACTIONS(5499),
    [anon_sym__Noreturn] = ACTIONS(5499),
    [anon_sym_noreturn] = ACTIONS(5499),
    [anon_sym__Nonnull] = ACTIONS(5499),
    [anon_sym_mutable] = ACTIONS(5499),
    [anon_sym_constinit] = ACTIONS(5499),
    [anon_sym_consteval] = ACTIONS(5499),
    [anon_sym_alignas] = ACTIONS(5499),
    [anon_sym__Alignas] = ACTIONS(5499),
    [sym_primitive_type] = ACTIONS(5499),
    [anon_sym_enum] = ACTIONS(5499),
    [anon_sym_class] = ACTIONS(5499),
    [anon_sym_struct] = ACTIONS(5499),
    [anon_sym_union] = ACTIONS(5499),
    [anon_sym_or] = ACTIONS(5499),
    [anon_sym_and] = ACTIONS(5499),
    [anon_sym_DASH_GT] = ACTIONS(5501),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5499),
    [anon_sym_decltype] = ACTIONS(5499),
    [anon_sym_final] = ACTIONS(5499),
    [anon_sym_override] = ACTIONS(5499),
    [anon_sym_explicit] = ACTIONS(5499),
    [anon_sym_typename] = ACTIONS(5499),
    [anon_sym_template] = ACTIONS(5499),
    [anon_sym_operator] = ACTIONS(5499),
    [anon_sym_friend] = ACTIONS(5499),
    [anon_sym_noexcept] = ACTIONS(5499),
    [anon_sym_throw] = ACTIONS(5499),
    [anon_sym_concept] = ACTIONS(5499),
    [anon_sym_requires] = ACTIONS(5499),
    [anon_sym_precise] = ACTIONS(5499),
    [anon_sym_shared] = ACTIONS(5499),
    [anon_sym_groupshared] = ACTIONS(5499),
    [anon_sym_uniform] = ACTIONS(5499),
    [anon_sym_row_major] = ACTIONS(5499),
    [anon_sym_column_major] = ACTIONS(5499),
    [anon_sym_globallycoherent] = ACTIONS(5499),
    [anon_sym_centroid] = ACTIONS(5499),
    [anon_sym_noperspective] = ACTIONS(5499),
    [anon_sym_nointerpolation] = ACTIONS(5499),
    [anon_sym_sample] = ACTIONS(5499),
    [anon_sym_linear] = ACTIONS(5499),
    [anon_sym_snorm] = ACTIONS(5499),
    [anon_sym_unorm] = ACTIONS(5499),
    [anon_sym_point] = ACTIONS(5499),
    [anon_sym_line] = ACTIONS(5499),
    [anon_sym_triangleadj] = ACTIONS(5499),
    [anon_sym_lineadj] = ACTIONS(5499),
    [anon_sym_triangle] = ACTIONS(5499),
  },
  [1892] = {
    [sym_identifier] = ACTIONS(5503),
    [anon_sym_RPAREN] = ACTIONS(5505),
    [anon_sym_LPAREN2] = ACTIONS(5505),
    [anon_sym_TILDE] = ACTIONS(5505),
    [anon_sym_STAR] = ACTIONS(5505),
    [anon_sym_PIPE_PIPE] = ACTIONS(5505),
    [anon_sym_AMP_AMP] = ACTIONS(5505),
    [anon_sym_AMP] = ACTIONS(5503),
    [anon_sym___extension__] = ACTIONS(5503),
    [anon_sym_in] = ACTIONS(5503),
    [anon_sym_out] = ACTIONS(5503),
    [anon_sym_inout] = ACTIONS(5503),
    [anon_sym_virtual] = ACTIONS(5503),
    [anon_sym_extern] = ACTIONS(5503),
    [anon_sym___attribute__] = ACTIONS(5503),
    [anon_sym___attribute] = ACTIONS(5503),
    [anon_sym_using] = ACTIONS(5503),
    [anon_sym_COLON_COLON] = ACTIONS(5505),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5505),
    [anon_sym___declspec] = ACTIONS(5503),
    [anon_sym___based] = ACTIONS(5503),
    [anon_sym___cdecl] = ACTIONS(5503),
    [anon_sym___clrcall] = ACTIONS(5503),
    [anon_sym___stdcall] = ACTIONS(5503),
    [anon_sym___fastcall] = ACTIONS(5503),
    [anon_sym___thiscall] = ACTIONS(5503),
    [anon_sym___vectorcall] = ACTIONS(5503),
    [anon_sym_LBRACE] = ACTIONS(5505),
    [anon_sym_signed] = ACTIONS(5503),
    [anon_sym_unsigned] = ACTIONS(5503),
    [anon_sym_long] = ACTIONS(5503),
    [anon_sym_short] = ACTIONS(5503),
    [anon_sym_LBRACK] = ACTIONS(5503),
    [anon_sym_static] = ACTIONS(5503),
    [anon_sym_register] = ACTIONS(5503),
    [anon_sym_inline] = ACTIONS(5503),
    [anon_sym___inline] = ACTIONS(5503),
    [anon_sym___inline__] = ACTIONS(5503),
    [anon_sym___forceinline] = ACTIONS(5503),
    [anon_sym_thread_local] = ACTIONS(5503),
    [anon_sym___thread] = ACTIONS(5503),
    [anon_sym_const] = ACTIONS(5503),
    [anon_sym_constexpr] = ACTIONS(5503),
    [anon_sym_volatile] = ACTIONS(5503),
    [anon_sym_restrict] = ACTIONS(5503),
    [anon_sym___restrict__] = ACTIONS(5503),
    [anon_sym__Atomic] = ACTIONS(5503),
    [anon_sym__Noreturn] = ACTIONS(5503),
    [anon_sym_noreturn] = ACTIONS(5503),
    [anon_sym__Nonnull] = ACTIONS(5503),
    [anon_sym_mutable] = ACTIONS(5503),
    [anon_sym_constinit] = ACTIONS(5503),
    [anon_sym_consteval] = ACTIONS(5503),
    [anon_sym_alignas] = ACTIONS(5503),
    [anon_sym__Alignas] = ACTIONS(5503),
    [sym_primitive_type] = ACTIONS(5503),
    [anon_sym_enum] = ACTIONS(5503),
    [anon_sym_class] = ACTIONS(5503),
    [anon_sym_struct] = ACTIONS(5503),
    [anon_sym_union] = ACTIONS(5503),
    [anon_sym_or] = ACTIONS(5503),
    [anon_sym_and] = ACTIONS(5503),
    [anon_sym_DASH_GT] = ACTIONS(5505),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5503),
    [anon_sym_decltype] = ACTIONS(5503),
    [anon_sym_final] = ACTIONS(5503),
    [anon_sym_override] = ACTIONS(5503),
    [anon_sym_explicit] = ACTIONS(5503),
    [anon_sym_typename] = ACTIONS(5503),
    [anon_sym_template] = ACTIONS(5503),
    [anon_sym_operator] = ACTIONS(5503),
    [anon_sym_friend] = ACTIONS(5503),
    [anon_sym_noexcept] = ACTIONS(5503),
    [anon_sym_throw] = ACTIONS(5503),
    [anon_sym_concept] = ACTIONS(5503),
    [anon_sym_requires] = ACTIONS(5503),
    [anon_sym_precise] = ACTIONS(5503),
    [anon_sym_shared] = ACTIONS(5503),
    [anon_sym_groupshared] = ACTIONS(5503),
    [anon_sym_uniform] = ACTIONS(5503),
    [anon_sym_row_major] = ACTIONS(5503),
    [anon_sym_column_major] = ACTIONS(5503),
    [anon_sym_globallycoherent] = ACTIONS(5503),
    [anon_sym_centroid] = ACTIONS(5503),
    [anon_sym_noperspective] = ACTIONS(5503),
    [anon_sym_nointerpolation] = ACTIONS(5503),
    [anon_sym_sample] = ACTIONS(5503),
    [anon_sym_linear] = ACTIONS(5503),
    [anon_sym_snorm] = ACTIONS(5503),
    [anon_sym_unorm] = ACTIONS(5503),
    [anon_sym_point] = ACTIONS(5503),
    [anon_sym_line] = ACTIONS(5503),
    [anon_sym_triangleadj] = ACTIONS(5503),
    [anon_sym_lineadj] = ACTIONS(5503),
    [anon_sym_triangle] = ACTIONS(5503),
  },
  [1893] = {
    [sym_identifier] = ACTIONS(5507),
    [anon_sym_RPAREN] = ACTIONS(5509),
    [anon_sym_LPAREN2] = ACTIONS(5509),
    [anon_sym_TILDE] = ACTIONS(5509),
    [anon_sym_STAR] = ACTIONS(5509),
    [anon_sym_PIPE_PIPE] = ACTIONS(5509),
    [anon_sym_AMP_AMP] = ACTIONS(5509),
    [anon_sym_AMP] = ACTIONS(5507),
    [anon_sym___extension__] = ACTIONS(5507),
    [anon_sym_in] = ACTIONS(5507),
    [anon_sym_out] = ACTIONS(5507),
    [anon_sym_inout] = ACTIONS(5507),
    [anon_sym_virtual] = ACTIONS(5507),
    [anon_sym_extern] = ACTIONS(5507),
    [anon_sym___attribute__] = ACTIONS(5507),
    [anon_sym___attribute] = ACTIONS(5507),
    [anon_sym_using] = ACTIONS(5507),
    [anon_sym_COLON_COLON] = ACTIONS(5509),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5509),
    [anon_sym___declspec] = ACTIONS(5507),
    [anon_sym___based] = ACTIONS(5507),
    [anon_sym___cdecl] = ACTIONS(5507),
    [anon_sym___clrcall] = ACTIONS(5507),
    [anon_sym___stdcall] = ACTIONS(5507),
    [anon_sym___fastcall] = ACTIONS(5507),
    [anon_sym___thiscall] = ACTIONS(5507),
    [anon_sym___vectorcall] = ACTIONS(5507),
    [anon_sym_LBRACE] = ACTIONS(5509),
    [anon_sym_signed] = ACTIONS(5507),
    [anon_sym_unsigned] = ACTIONS(5507),
    [anon_sym_long] = ACTIONS(5507),
    [anon_sym_short] = ACTIONS(5507),
    [anon_sym_LBRACK] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_register] = ACTIONS(5507),
    [anon_sym_inline] = ACTIONS(5507),
    [anon_sym___inline] = ACTIONS(5507),
    [anon_sym___inline__] = ACTIONS(5507),
    [anon_sym___forceinline] = ACTIONS(5507),
    [anon_sym_thread_local] = ACTIONS(5507),
    [anon_sym___thread] = ACTIONS(5507),
    [anon_sym_const] = ACTIONS(5507),
    [anon_sym_constexpr] = ACTIONS(5507),
    [anon_sym_volatile] = ACTIONS(5507),
    [anon_sym_restrict] = ACTIONS(5507),
    [anon_sym___restrict__] = ACTIONS(5507),
    [anon_sym__Atomic] = ACTIONS(5507),
    [anon_sym__Noreturn] = ACTIONS(5507),
    [anon_sym_noreturn] = ACTIONS(5507),
    [anon_sym__Nonnull] = ACTIONS(5507),
    [anon_sym_mutable] = ACTIONS(5507),
    [anon_sym_constinit] = ACTIONS(5507),
    [anon_sym_consteval] = ACTIONS(5507),
    [anon_sym_alignas] = ACTIONS(5507),
    [anon_sym__Alignas] = ACTIONS(5507),
    [sym_primitive_type] = ACTIONS(5507),
    [anon_sym_enum] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(5507),
    [anon_sym_struct] = ACTIONS(5507),
    [anon_sym_union] = ACTIONS(5507),
    [anon_sym_or] = ACTIONS(5507),
    [anon_sym_and] = ACTIONS(5507),
    [anon_sym_DASH_GT] = ACTIONS(5509),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5507),
    [anon_sym_decltype] = ACTIONS(5507),
    [anon_sym_final] = ACTIONS(5507),
    [anon_sym_override] = ACTIONS(5507),
    [anon_sym_explicit] = ACTIONS(5507),
    [anon_sym_typename] = ACTIONS(5507),
    [anon_sym_template] = ACTIONS(5507),
    [anon_sym_operator] = ACTIONS(5507),
    [anon_sym_friend] = ACTIONS(5507),
    [anon_sym_noexcept] = ACTIONS(5507),
    [anon_sym_throw] = ACTIONS(5507),
    [anon_sym_concept] = ACTIONS(5507),
    [anon_sym_requires] = ACTIONS(5507),
    [anon_sym_precise] = ACTIONS(5507),
    [anon_sym_shared] = ACTIONS(5507),
    [anon_sym_groupshared] = ACTIONS(5507),
    [anon_sym_uniform] = ACTIONS(5507),
    [anon_sym_row_major] = ACTIONS(5507),
    [anon_sym_column_major] = ACTIONS(5507),
    [anon_sym_globallycoherent] = ACTIONS(5507),
    [anon_sym_centroid] = ACTIONS(5507),
    [anon_sym_noperspective] = ACTIONS(5507),
    [anon_sym_nointerpolation] = ACTIONS(5507),
    [anon_sym_sample] = ACTIONS(5507),
    [anon_sym_linear] = ACTIONS(5507),
    [anon_sym_snorm] = ACTIONS(5507),
    [anon_sym_unorm] = ACTIONS(5507),
    [anon_sym_point] = ACTIONS(5507),
    [anon_sym_line] = ACTIONS(5507),
    [anon_sym_triangleadj] = ACTIONS(5507),
    [anon_sym_lineadj] = ACTIONS(5507),
    [anon_sym_triangle] = ACTIONS(5507),
  },
  [1894] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(7839),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(7839),
    [sym_variadic_parameter_declaration] = STATE(7839),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5511),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1895] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [aux_sym_preproc_else_token1] = ACTIONS(1951),
    [aux_sym_preproc_elif_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [1896] = {
    [sym__declaration_modifiers] = STATE(2044),
    [sym__declaration_specifiers] = STATE(3970),
    [sym_attribute_specifier] = STATE(2044),
    [sym_attribute_declaration] = STATE(2044),
    [sym_ms_declspec_modifier] = STATE(2044),
    [sym_storage_class_specifier] = STATE(2044),
    [sym_type_qualifier] = STATE(2044),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_parameter_declaration] = STATE(8221),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_optional_parameter_declaration] = STATE(8221),
    [sym_variadic_parameter_declaration] = STATE(8221),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2044),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2044),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1887),
    [anon_sym_out] = ACTIONS(1887),
    [anon_sym_inout] = ACTIONS(1887),
    [anon_sym_virtual] = ACTIONS(1887),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [1897] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6401),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(6996),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(6996),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1898] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6379),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7047),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7047),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1899] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6370),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7019),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7019),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1900] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6519),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(6996),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(6996),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1901] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token2] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [aux_sym_preproc_else_token1] = ACTIONS(2145),
    [aux_sym_preproc_elif_token1] = ACTIONS(2145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_friend] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
  },
  [1902] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6426),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7044),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7044),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1903] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6462),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7028),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7028),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [aux_sym_preproc_else_token1] = ACTIONS(1951),
    [aux_sym_preproc_elif_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [1905] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6422),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7028),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7028),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1906] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [aux_sym_preproc_else_token1] = ACTIONS(1951),
    [aux_sym_preproc_elif_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [1907] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6450),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7004),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7004),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token2] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [aux_sym_preproc_else_token1] = ACTIONS(1947),
    [aux_sym_preproc_elif_token1] = ACTIONS(1947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_friend] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
  },
  [1909] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6369),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7004),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7004),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1910] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6494),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7048),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7048),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1911] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_ms_based_modifier] = STATE(9120),
    [sym__declarator] = STATE(6968),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_function_declarator] = STATE(6416),
    [sym_array_declarator] = STATE(6529),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype] = STATE(8681),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym_operator_cast] = STATE(7048),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_reference_declarator] = STATE(6529),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(5756),
    [sym_qualified_identifier] = STATE(6529),
    [sym_qualified_operator_cast_identifier] = STATE(7048),
    [sym_operator_name] = STATE(6529),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_LPAREN2] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(2720),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5517),
    [anon_sym_out] = ACTIONS(5517),
    [anon_sym_inout] = ACTIONS(5517),
    [anon_sym_virtual] = ACTIONS(5517),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5523),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_explicit] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(141),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [1912] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [aux_sym_preproc_else_token1] = ACTIONS(2378),
    [aux_sym_preproc_elif_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [1913] = {
    [sym_identifier] = ACTIONS(5535),
    [aux_sym_preproc_def_token1] = ACTIONS(5535),
    [aux_sym_preproc_if_token1] = ACTIONS(5535),
    [aux_sym_preproc_if_token2] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5535),
    [aux_sym_preproc_else_token1] = ACTIONS(5535),
    [aux_sym_preproc_elif_token1] = ACTIONS(5535),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5535),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5535),
    [sym_preproc_directive] = ACTIONS(5535),
    [anon_sym_LPAREN2] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_AMP_AMP] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5535),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym___extension__] = ACTIONS(5535),
    [anon_sym_typedef] = ACTIONS(5535),
    [anon_sym_in] = ACTIONS(5535),
    [anon_sym_out] = ACTIONS(5535),
    [anon_sym_inout] = ACTIONS(5535),
    [anon_sym_virtual] = ACTIONS(5535),
    [anon_sym_extern] = ACTIONS(5535),
    [anon_sym___attribute__] = ACTIONS(5535),
    [anon_sym___attribute] = ACTIONS(5535),
    [anon_sym_using] = ACTIONS(5535),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5537),
    [anon_sym___declspec] = ACTIONS(5535),
    [anon_sym___based] = ACTIONS(5535),
    [anon_sym_signed] = ACTIONS(5535),
    [anon_sym_unsigned] = ACTIONS(5535),
    [anon_sym_long] = ACTIONS(5535),
    [anon_sym_short] = ACTIONS(5535),
    [anon_sym_LBRACK] = ACTIONS(5535),
    [anon_sym_static] = ACTIONS(5535),
    [anon_sym_register] = ACTIONS(5535),
    [anon_sym_inline] = ACTIONS(5535),
    [anon_sym___inline] = ACTIONS(5535),
    [anon_sym___inline__] = ACTIONS(5535),
    [anon_sym___forceinline] = ACTIONS(5535),
    [anon_sym_thread_local] = ACTIONS(5535),
    [anon_sym___thread] = ACTIONS(5535),
    [anon_sym_const] = ACTIONS(5535),
    [anon_sym_constexpr] = ACTIONS(5535),
    [anon_sym_volatile] = ACTIONS(5535),
    [anon_sym_restrict] = ACTIONS(5535),
    [anon_sym___restrict__] = ACTIONS(5535),
    [anon_sym__Atomic] = ACTIONS(5535),
    [anon_sym__Noreturn] = ACTIONS(5535),
    [anon_sym_noreturn] = ACTIONS(5535),
    [anon_sym__Nonnull] = ACTIONS(5535),
    [anon_sym_mutable] = ACTIONS(5535),
    [anon_sym_constinit] = ACTIONS(5535),
    [anon_sym_consteval] = ACTIONS(5535),
    [anon_sym_alignas] = ACTIONS(5535),
    [anon_sym__Alignas] = ACTIONS(5535),
    [sym_primitive_type] = ACTIONS(5535),
    [anon_sym_enum] = ACTIONS(5535),
    [anon_sym_class] = ACTIONS(5535),
    [anon_sym_struct] = ACTIONS(5535),
    [anon_sym_union] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5535),
    [anon_sym_decltype] = ACTIONS(5535),
    [anon_sym_explicit] = ACTIONS(5535),
    [anon_sym_typename] = ACTIONS(5535),
    [anon_sym_private] = ACTIONS(5535),
    [anon_sym_template] = ACTIONS(5535),
    [anon_sym_operator] = ACTIONS(5535),
    [anon_sym_friend] = ACTIONS(5535),
    [anon_sym_public] = ACTIONS(5535),
    [anon_sym_protected] = ACTIONS(5535),
    [anon_sym_static_assert] = ACTIONS(5535),
    [anon_sym_precise] = ACTIONS(5535),
    [anon_sym_shared] = ACTIONS(5535),
    [anon_sym_groupshared] = ACTIONS(5535),
    [anon_sym_uniform] = ACTIONS(5535),
    [anon_sym_row_major] = ACTIONS(5535),
    [anon_sym_column_major] = ACTIONS(5535),
    [anon_sym_globallycoherent] = ACTIONS(5535),
    [anon_sym_centroid] = ACTIONS(5535),
    [anon_sym_noperspective] = ACTIONS(5535),
    [anon_sym_nointerpolation] = ACTIONS(5535),
    [anon_sym_sample] = ACTIONS(5535),
    [anon_sym_linear] = ACTIONS(5535),
    [anon_sym_snorm] = ACTIONS(5535),
    [anon_sym_unorm] = ACTIONS(5535),
    [anon_sym_point] = ACTIONS(5535),
    [anon_sym_line] = ACTIONS(5535),
    [anon_sym_triangleadj] = ACTIONS(5535),
    [anon_sym_lineadj] = ACTIONS(5535),
    [anon_sym_triangle] = ACTIONS(5535),
  },
  [1914] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [1915] = {
    [sym_identifier] = ACTIONS(5539),
    [aux_sym_preproc_def_token1] = ACTIONS(5539),
    [aux_sym_preproc_if_token1] = ACTIONS(5539),
    [aux_sym_preproc_if_token2] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5539),
    [aux_sym_preproc_else_token1] = ACTIONS(5539),
    [aux_sym_preproc_elif_token1] = ACTIONS(5539),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5539),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_LPAREN2] = ACTIONS(5541),
    [anon_sym_TILDE] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_AMP_AMP] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5541),
    [anon_sym___extension__] = ACTIONS(5539),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_in] = ACTIONS(5539),
    [anon_sym_out] = ACTIONS(5539),
    [anon_sym_inout] = ACTIONS(5539),
    [anon_sym_virtual] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym___attribute__] = ACTIONS(5539),
    [anon_sym___attribute] = ACTIONS(5539),
    [anon_sym_using] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5541),
    [anon_sym___declspec] = ACTIONS(5539),
    [anon_sym___based] = ACTIONS(5539),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym___inline] = ACTIONS(5539),
    [anon_sym___inline__] = ACTIONS(5539),
    [anon_sym___forceinline] = ACTIONS(5539),
    [anon_sym_thread_local] = ACTIONS(5539),
    [anon_sym___thread] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym___restrict__] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym__Noreturn] = ACTIONS(5539),
    [anon_sym_noreturn] = ACTIONS(5539),
    [anon_sym__Nonnull] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_constinit] = ACTIONS(5539),
    [anon_sym_consteval] = ACTIONS(5539),
    [anon_sym_alignas] = ACTIONS(5539),
    [anon_sym__Alignas] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_class] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_decltype] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_private] = ACTIONS(5539),
    [anon_sym_template] = ACTIONS(5539),
    [anon_sym_operator] = ACTIONS(5539),
    [anon_sym_friend] = ACTIONS(5539),
    [anon_sym_public] = ACTIONS(5539),
    [anon_sym_protected] = ACTIONS(5539),
    [anon_sym_static_assert] = ACTIONS(5539),
    [anon_sym_precise] = ACTIONS(5539),
    [anon_sym_shared] = ACTIONS(5539),
    [anon_sym_groupshared] = ACTIONS(5539),
    [anon_sym_uniform] = ACTIONS(5539),
    [anon_sym_row_major] = ACTIONS(5539),
    [anon_sym_column_major] = ACTIONS(5539),
    [anon_sym_globallycoherent] = ACTIONS(5539),
    [anon_sym_centroid] = ACTIONS(5539),
    [anon_sym_noperspective] = ACTIONS(5539),
    [anon_sym_nointerpolation] = ACTIONS(5539),
    [anon_sym_sample] = ACTIONS(5539),
    [anon_sym_linear] = ACTIONS(5539),
    [anon_sym_snorm] = ACTIONS(5539),
    [anon_sym_unorm] = ACTIONS(5539),
    [anon_sym_point] = ACTIONS(5539),
    [anon_sym_line] = ACTIONS(5539),
    [anon_sym_triangleadj] = ACTIONS(5539),
    [anon_sym_lineadj] = ACTIONS(5539),
    [anon_sym_triangle] = ACTIONS(5539),
  },
  [1916] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [aux_sym_preproc_else_token1] = ACTIONS(2556),
    [aux_sym_preproc_elif_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [1918] = {
    [sym_identifier] = ACTIONS(5543),
    [aux_sym_preproc_def_token1] = ACTIONS(5543),
    [aux_sym_preproc_if_token1] = ACTIONS(5543),
    [aux_sym_preproc_if_token2] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5543),
    [aux_sym_preproc_else_token1] = ACTIONS(5543),
    [aux_sym_preproc_elif_token1] = ACTIONS(5543),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5543),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5543),
    [sym_preproc_directive] = ACTIONS(5543),
    [anon_sym_LPAREN2] = ACTIONS(5545),
    [anon_sym_TILDE] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_AMP_AMP] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym___extension__] = ACTIONS(5543),
    [anon_sym_typedef] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5543),
    [anon_sym_out] = ACTIONS(5543),
    [anon_sym_inout] = ACTIONS(5543),
    [anon_sym_virtual] = ACTIONS(5543),
    [anon_sym_extern] = ACTIONS(5543),
    [anon_sym___attribute__] = ACTIONS(5543),
    [anon_sym___attribute] = ACTIONS(5543),
    [anon_sym_using] = ACTIONS(5543),
    [anon_sym_COLON_COLON] = ACTIONS(5545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5545),
    [anon_sym___declspec] = ACTIONS(5543),
    [anon_sym___based] = ACTIONS(5543),
    [anon_sym_signed] = ACTIONS(5543),
    [anon_sym_unsigned] = ACTIONS(5543),
    [anon_sym_long] = ACTIONS(5543),
    [anon_sym_short] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_static] = ACTIONS(5543),
    [anon_sym_register] = ACTIONS(5543),
    [anon_sym_inline] = ACTIONS(5543),
    [anon_sym___inline] = ACTIONS(5543),
    [anon_sym___inline__] = ACTIONS(5543),
    [anon_sym___forceinline] = ACTIONS(5543),
    [anon_sym_thread_local] = ACTIONS(5543),
    [anon_sym___thread] = ACTIONS(5543),
    [anon_sym_const] = ACTIONS(5543),
    [anon_sym_constexpr] = ACTIONS(5543),
    [anon_sym_volatile] = ACTIONS(5543),
    [anon_sym_restrict] = ACTIONS(5543),
    [anon_sym___restrict__] = ACTIONS(5543),
    [anon_sym__Atomic] = ACTIONS(5543),
    [anon_sym__Noreturn] = ACTIONS(5543),
    [anon_sym_noreturn] = ACTIONS(5543),
    [anon_sym__Nonnull] = ACTIONS(5543),
    [anon_sym_mutable] = ACTIONS(5543),
    [anon_sym_constinit] = ACTIONS(5543),
    [anon_sym_consteval] = ACTIONS(5543),
    [anon_sym_alignas] = ACTIONS(5543),
    [anon_sym__Alignas] = ACTIONS(5543),
    [sym_primitive_type] = ACTIONS(5543),
    [anon_sym_enum] = ACTIONS(5543),
    [anon_sym_class] = ACTIONS(5543),
    [anon_sym_struct] = ACTIONS(5543),
    [anon_sym_union] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5543),
    [anon_sym_decltype] = ACTIONS(5543),
    [anon_sym_explicit] = ACTIONS(5543),
    [anon_sym_typename] = ACTIONS(5543),
    [anon_sym_private] = ACTIONS(5543),
    [anon_sym_template] = ACTIONS(5543),
    [anon_sym_operator] = ACTIONS(5543),
    [anon_sym_friend] = ACTIONS(5543),
    [anon_sym_public] = ACTIONS(5543),
    [anon_sym_protected] = ACTIONS(5543),
    [anon_sym_static_assert] = ACTIONS(5543),
    [anon_sym_precise] = ACTIONS(5543),
    [anon_sym_shared] = ACTIONS(5543),
    [anon_sym_groupshared] = ACTIONS(5543),
    [anon_sym_uniform] = ACTIONS(5543),
    [anon_sym_row_major] = ACTIONS(5543),
    [anon_sym_column_major] = ACTIONS(5543),
    [anon_sym_globallycoherent] = ACTIONS(5543),
    [anon_sym_centroid] = ACTIONS(5543),
    [anon_sym_noperspective] = ACTIONS(5543),
    [anon_sym_nointerpolation] = ACTIONS(5543),
    [anon_sym_sample] = ACTIONS(5543),
    [anon_sym_linear] = ACTIONS(5543),
    [anon_sym_snorm] = ACTIONS(5543),
    [anon_sym_unorm] = ACTIONS(5543),
    [anon_sym_point] = ACTIONS(5543),
    [anon_sym_line] = ACTIONS(5543),
    [anon_sym_triangleadj] = ACTIONS(5543),
    [anon_sym_lineadj] = ACTIONS(5543),
    [anon_sym_triangle] = ACTIONS(5543),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [aux_sym_preproc_else_token1] = ACTIONS(2556),
    [aux_sym_preproc_elif_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [aux_sym_preproc_else_token1] = ACTIONS(5547),
    [aux_sym_preproc_elif_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token2] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [aux_sym_preproc_else_token1] = ACTIONS(2560),
    [aux_sym_preproc_elif_token1] = ACTIONS(2560),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_private] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_friend] = ACTIONS(2560),
    [anon_sym_public] = ACTIONS(2560),
    [anon_sym_protected] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token2] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [aux_sym_preproc_else_token1] = ACTIONS(2564),
    [aux_sym_preproc_elif_token1] = ACTIONS(2564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_private] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_friend] = ACTIONS(2564),
    [anon_sym_public] = ACTIONS(2564),
    [anon_sym_protected] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [aux_sym_preproc_else_token1] = ACTIONS(2676),
    [aux_sym_preproc_elif_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [1924] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token2] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [aux_sym_preproc_else_token1] = ACTIONS(5551),
    [aux_sym_preproc_elif_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [1925] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [aux_sym_preproc_else_token1] = ACTIONS(2676),
    [aux_sym_preproc_elif_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [1926] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [aux_sym_preproc_else_token1] = ACTIONS(2404),
    [aux_sym_preproc_elif_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [aux_sym_preproc_else_token1] = ACTIONS(5547),
    [aux_sym_preproc_elif_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [1928] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token2] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [aux_sym_preproc_else_token1] = ACTIONS(5551),
    [aux_sym_preproc_elif_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [1929] = {
    [sym_identifier] = ACTIONS(5555),
    [aux_sym_preproc_def_token1] = ACTIONS(5555),
    [aux_sym_preproc_if_token1] = ACTIONS(5555),
    [aux_sym_preproc_if_token2] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5555),
    [aux_sym_preproc_else_token1] = ACTIONS(5555),
    [aux_sym_preproc_elif_token1] = ACTIONS(5555),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5555),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5555),
    [sym_preproc_directive] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(5557),
    [anon_sym_TILDE] = ACTIONS(5557),
    [anon_sym_STAR] = ACTIONS(5557),
    [anon_sym_AMP_AMP] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5555),
    [anon_sym_SEMI] = ACTIONS(5557),
    [anon_sym___extension__] = ACTIONS(5555),
    [anon_sym_typedef] = ACTIONS(5555),
    [anon_sym_in] = ACTIONS(5555),
    [anon_sym_out] = ACTIONS(5555),
    [anon_sym_inout] = ACTIONS(5555),
    [anon_sym_virtual] = ACTIONS(5555),
    [anon_sym_extern] = ACTIONS(5555),
    [anon_sym___attribute__] = ACTIONS(5555),
    [anon_sym___attribute] = ACTIONS(5555),
    [anon_sym_using] = ACTIONS(5555),
    [anon_sym_COLON_COLON] = ACTIONS(5557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5557),
    [anon_sym___declspec] = ACTIONS(5555),
    [anon_sym___based] = ACTIONS(5555),
    [anon_sym_signed] = ACTIONS(5555),
    [anon_sym_unsigned] = ACTIONS(5555),
    [anon_sym_long] = ACTIONS(5555),
    [anon_sym_short] = ACTIONS(5555),
    [anon_sym_LBRACK] = ACTIONS(5555),
    [anon_sym_static] = ACTIONS(5555),
    [anon_sym_register] = ACTIONS(5555),
    [anon_sym_inline] = ACTIONS(5555),
    [anon_sym___inline] = ACTIONS(5555),
    [anon_sym___inline__] = ACTIONS(5555),
    [anon_sym___forceinline] = ACTIONS(5555),
    [anon_sym_thread_local] = ACTIONS(5555),
    [anon_sym___thread] = ACTIONS(5555),
    [anon_sym_const] = ACTIONS(5555),
    [anon_sym_constexpr] = ACTIONS(5555),
    [anon_sym_volatile] = ACTIONS(5555),
    [anon_sym_restrict] = ACTIONS(5555),
    [anon_sym___restrict__] = ACTIONS(5555),
    [anon_sym__Atomic] = ACTIONS(5555),
    [anon_sym__Noreturn] = ACTIONS(5555),
    [anon_sym_noreturn] = ACTIONS(5555),
    [anon_sym__Nonnull] = ACTIONS(5555),
    [anon_sym_mutable] = ACTIONS(5555),
    [anon_sym_constinit] = ACTIONS(5555),
    [anon_sym_consteval] = ACTIONS(5555),
    [anon_sym_alignas] = ACTIONS(5555),
    [anon_sym__Alignas] = ACTIONS(5555),
    [sym_primitive_type] = ACTIONS(5555),
    [anon_sym_enum] = ACTIONS(5555),
    [anon_sym_class] = ACTIONS(5555),
    [anon_sym_struct] = ACTIONS(5555),
    [anon_sym_union] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5555),
    [anon_sym_decltype] = ACTIONS(5555),
    [anon_sym_explicit] = ACTIONS(5555),
    [anon_sym_typename] = ACTIONS(5555),
    [anon_sym_private] = ACTIONS(5555),
    [anon_sym_template] = ACTIONS(5555),
    [anon_sym_operator] = ACTIONS(5555),
    [anon_sym_friend] = ACTIONS(5555),
    [anon_sym_public] = ACTIONS(5555),
    [anon_sym_protected] = ACTIONS(5555),
    [anon_sym_static_assert] = ACTIONS(5555),
    [anon_sym_precise] = ACTIONS(5555),
    [anon_sym_shared] = ACTIONS(5555),
    [anon_sym_groupshared] = ACTIONS(5555),
    [anon_sym_uniform] = ACTIONS(5555),
    [anon_sym_row_major] = ACTIONS(5555),
    [anon_sym_column_major] = ACTIONS(5555),
    [anon_sym_globallycoherent] = ACTIONS(5555),
    [anon_sym_centroid] = ACTIONS(5555),
    [anon_sym_noperspective] = ACTIONS(5555),
    [anon_sym_nointerpolation] = ACTIONS(5555),
    [anon_sym_sample] = ACTIONS(5555),
    [anon_sym_linear] = ACTIONS(5555),
    [anon_sym_snorm] = ACTIONS(5555),
    [anon_sym_unorm] = ACTIONS(5555),
    [anon_sym_point] = ACTIONS(5555),
    [anon_sym_line] = ACTIONS(5555),
    [anon_sym_triangleadj] = ACTIONS(5555),
    [anon_sym_lineadj] = ACTIONS(5555),
    [anon_sym_triangle] = ACTIONS(5555),
  },
  [1930] = {
    [sym_identifier] = ACTIONS(5559),
    [aux_sym_preproc_def_token1] = ACTIONS(5559),
    [aux_sym_preproc_if_token1] = ACTIONS(5559),
    [aux_sym_preproc_if_token2] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5559),
    [aux_sym_preproc_else_token1] = ACTIONS(5559),
    [aux_sym_preproc_elif_token1] = ACTIONS(5559),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5559),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5559),
    [sym_preproc_directive] = ACTIONS(5559),
    [anon_sym_LPAREN2] = ACTIONS(5561),
    [anon_sym_TILDE] = ACTIONS(5561),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP_AMP] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5559),
    [anon_sym_typedef] = ACTIONS(5559),
    [anon_sym_in] = ACTIONS(5559),
    [anon_sym_out] = ACTIONS(5559),
    [anon_sym_inout] = ACTIONS(5559),
    [anon_sym_virtual] = ACTIONS(5559),
    [anon_sym_extern] = ACTIONS(5559),
    [anon_sym___attribute__] = ACTIONS(5559),
    [anon_sym___attribute] = ACTIONS(5559),
    [anon_sym_using] = ACTIONS(5559),
    [anon_sym_COLON_COLON] = ACTIONS(5561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5561),
    [anon_sym___declspec] = ACTIONS(5559),
    [anon_sym___based] = ACTIONS(5559),
    [anon_sym_signed] = ACTIONS(5559),
    [anon_sym_unsigned] = ACTIONS(5559),
    [anon_sym_long] = ACTIONS(5559),
    [anon_sym_short] = ACTIONS(5559),
    [anon_sym_LBRACK] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_register] = ACTIONS(5559),
    [anon_sym_inline] = ACTIONS(5559),
    [anon_sym___inline] = ACTIONS(5559),
    [anon_sym___inline__] = ACTIONS(5559),
    [anon_sym___forceinline] = ACTIONS(5559),
    [anon_sym_thread_local] = ACTIONS(5559),
    [anon_sym___thread] = ACTIONS(5559),
    [anon_sym_const] = ACTIONS(5559),
    [anon_sym_constexpr] = ACTIONS(5559),
    [anon_sym_volatile] = ACTIONS(5559),
    [anon_sym_restrict] = ACTIONS(5559),
    [anon_sym___restrict__] = ACTIONS(5559),
    [anon_sym__Atomic] = ACTIONS(5559),
    [anon_sym__Noreturn] = ACTIONS(5559),
    [anon_sym_noreturn] = ACTIONS(5559),
    [anon_sym__Nonnull] = ACTIONS(5559),
    [anon_sym_mutable] = ACTIONS(5559),
    [anon_sym_constinit] = ACTIONS(5559),
    [anon_sym_consteval] = ACTIONS(5559),
    [anon_sym_alignas] = ACTIONS(5559),
    [anon_sym__Alignas] = ACTIONS(5559),
    [sym_primitive_type] = ACTIONS(5559),
    [anon_sym_enum] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(5559),
    [anon_sym_struct] = ACTIONS(5559),
    [anon_sym_union] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5559),
    [anon_sym_decltype] = ACTIONS(5559),
    [anon_sym_explicit] = ACTIONS(5559),
    [anon_sym_typename] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_template] = ACTIONS(5559),
    [anon_sym_operator] = ACTIONS(5559),
    [anon_sym_friend] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_static_assert] = ACTIONS(5559),
    [anon_sym_precise] = ACTIONS(5559),
    [anon_sym_shared] = ACTIONS(5559),
    [anon_sym_groupshared] = ACTIONS(5559),
    [anon_sym_uniform] = ACTIONS(5559),
    [anon_sym_row_major] = ACTIONS(5559),
    [anon_sym_column_major] = ACTIONS(5559),
    [anon_sym_globallycoherent] = ACTIONS(5559),
    [anon_sym_centroid] = ACTIONS(5559),
    [anon_sym_noperspective] = ACTIONS(5559),
    [anon_sym_nointerpolation] = ACTIONS(5559),
    [anon_sym_sample] = ACTIONS(5559),
    [anon_sym_linear] = ACTIONS(5559),
    [anon_sym_snorm] = ACTIONS(5559),
    [anon_sym_unorm] = ACTIONS(5559),
    [anon_sym_point] = ACTIONS(5559),
    [anon_sym_line] = ACTIONS(5559),
    [anon_sym_triangleadj] = ACTIONS(5559),
    [anon_sym_lineadj] = ACTIONS(5559),
    [anon_sym_triangle] = ACTIONS(5559),
  },
  [1931] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token2] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [aux_sym_preproc_else_token1] = ACTIONS(5563),
    [aux_sym_preproc_elif_token1] = ACTIONS(5563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [1932] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token2] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [aux_sym_preproc_else_token1] = ACTIONS(5563),
    [aux_sym_preproc_elif_token1] = ACTIONS(5563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [1933] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token2] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [aux_sym_preproc_else_token1] = ACTIONS(2628),
    [aux_sym_preproc_elif_token1] = ACTIONS(2628),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_friend] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
  },
  [1934] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token2] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [aux_sym_preproc_else_token1] = ACTIONS(2632),
    [aux_sym_preproc_elif_token1] = ACTIONS(2632),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_friend] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
  },
  [1935] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token2] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [aux_sym_preproc_else_token1] = ACTIONS(2636),
    [aux_sym_preproc_elif_token1] = ACTIONS(2636),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_friend] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
  },
  [1936] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token2] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [aux_sym_preproc_else_token1] = ACTIONS(2652),
    [aux_sym_preproc_elif_token1] = ACTIONS(2652),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_private] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_friend] = ACTIONS(2652),
    [anon_sym_public] = ACTIONS(2652),
    [anon_sym_protected] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
  },
  [1937] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token2] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [aux_sym_preproc_else_token1] = ACTIONS(5567),
    [aux_sym_preproc_elif_token1] = ACTIONS(5567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [1938] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token2] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [aux_sym_preproc_else_token1] = ACTIONS(2684),
    [aux_sym_preproc_elif_token1] = ACTIONS(2684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_friend] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
  },
  [1939] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [aux_sym_preproc_else_token1] = ACTIONS(2462),
    [aux_sym_preproc_elif_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [1940] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [aux_sym_preproc_else_token1] = ACTIONS(2462),
    [aux_sym_preproc_elif_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [1941] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [1942] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [1943] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token2] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [aux_sym_preproc_else_token1] = ACTIONS(2660),
    [aux_sym_preproc_elif_token1] = ACTIONS(2660),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_friend] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
  },
  [1944] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token2] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [aux_sym_preproc_else_token1] = ACTIONS(2692),
    [aux_sym_preproc_elif_token1] = ACTIONS(2692),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_friend] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
  },
  [1945] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [aux_sym_preproc_else_token1] = ACTIONS(2410),
    [aux_sym_preproc_elif_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_friend] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [1946] = {
    [sym_identifier] = ACTIONS(5571),
    [aux_sym_preproc_def_token1] = ACTIONS(5571),
    [aux_sym_preproc_if_token1] = ACTIONS(5571),
    [aux_sym_preproc_if_token2] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5571),
    [aux_sym_preproc_else_token1] = ACTIONS(5571),
    [aux_sym_preproc_elif_token1] = ACTIONS(5571),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5571),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5571),
    [sym_preproc_directive] = ACTIONS(5571),
    [anon_sym_LPAREN2] = ACTIONS(5573),
    [anon_sym_TILDE] = ACTIONS(5573),
    [anon_sym_STAR] = ACTIONS(5573),
    [anon_sym_AMP_AMP] = ACTIONS(5573),
    [anon_sym_AMP] = ACTIONS(5571),
    [anon_sym_SEMI] = ACTIONS(5573),
    [anon_sym___extension__] = ACTIONS(5571),
    [anon_sym_typedef] = ACTIONS(5571),
    [anon_sym_in] = ACTIONS(5571),
    [anon_sym_out] = ACTIONS(5571),
    [anon_sym_inout] = ACTIONS(5571),
    [anon_sym_virtual] = ACTIONS(5571),
    [anon_sym_extern] = ACTIONS(5571),
    [anon_sym___attribute__] = ACTIONS(5571),
    [anon_sym___attribute] = ACTIONS(5571),
    [anon_sym_using] = ACTIONS(5571),
    [anon_sym_COLON_COLON] = ACTIONS(5573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5573),
    [anon_sym___declspec] = ACTIONS(5571),
    [anon_sym___based] = ACTIONS(5571),
    [anon_sym_signed] = ACTIONS(5571),
    [anon_sym_unsigned] = ACTIONS(5571),
    [anon_sym_long] = ACTIONS(5571),
    [anon_sym_short] = ACTIONS(5571),
    [anon_sym_LBRACK] = ACTIONS(5571),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_register] = ACTIONS(5571),
    [anon_sym_inline] = ACTIONS(5571),
    [anon_sym___inline] = ACTIONS(5571),
    [anon_sym___inline__] = ACTIONS(5571),
    [anon_sym___forceinline] = ACTIONS(5571),
    [anon_sym_thread_local] = ACTIONS(5571),
    [anon_sym___thread] = ACTIONS(5571),
    [anon_sym_const] = ACTIONS(5571),
    [anon_sym_constexpr] = ACTIONS(5571),
    [anon_sym_volatile] = ACTIONS(5571),
    [anon_sym_restrict] = ACTIONS(5571),
    [anon_sym___restrict__] = ACTIONS(5571),
    [anon_sym__Atomic] = ACTIONS(5571),
    [anon_sym__Noreturn] = ACTIONS(5571),
    [anon_sym_noreturn] = ACTIONS(5571),
    [anon_sym__Nonnull] = ACTIONS(5571),
    [anon_sym_mutable] = ACTIONS(5571),
    [anon_sym_constinit] = ACTIONS(5571),
    [anon_sym_consteval] = ACTIONS(5571),
    [anon_sym_alignas] = ACTIONS(5571),
    [anon_sym__Alignas] = ACTIONS(5571),
    [sym_primitive_type] = ACTIONS(5571),
    [anon_sym_enum] = ACTIONS(5571),
    [anon_sym_class] = ACTIONS(5571),
    [anon_sym_struct] = ACTIONS(5571),
    [anon_sym_union] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5571),
    [anon_sym_decltype] = ACTIONS(5571),
    [anon_sym_explicit] = ACTIONS(5571),
    [anon_sym_typename] = ACTIONS(5571),
    [anon_sym_private] = ACTIONS(5571),
    [anon_sym_template] = ACTIONS(5571),
    [anon_sym_operator] = ACTIONS(5571),
    [anon_sym_friend] = ACTIONS(5571),
    [anon_sym_public] = ACTIONS(5571),
    [anon_sym_protected] = ACTIONS(5571),
    [anon_sym_static_assert] = ACTIONS(5571),
    [anon_sym_precise] = ACTIONS(5571),
    [anon_sym_shared] = ACTIONS(5571),
    [anon_sym_groupshared] = ACTIONS(5571),
    [anon_sym_uniform] = ACTIONS(5571),
    [anon_sym_row_major] = ACTIONS(5571),
    [anon_sym_column_major] = ACTIONS(5571),
    [anon_sym_globallycoherent] = ACTIONS(5571),
    [anon_sym_centroid] = ACTIONS(5571),
    [anon_sym_noperspective] = ACTIONS(5571),
    [anon_sym_nointerpolation] = ACTIONS(5571),
    [anon_sym_sample] = ACTIONS(5571),
    [anon_sym_linear] = ACTIONS(5571),
    [anon_sym_snorm] = ACTIONS(5571),
    [anon_sym_unorm] = ACTIONS(5571),
    [anon_sym_point] = ACTIONS(5571),
    [anon_sym_line] = ACTIONS(5571),
    [anon_sym_triangleadj] = ACTIONS(5571),
    [anon_sym_lineadj] = ACTIONS(5571),
    [anon_sym_triangle] = ACTIONS(5571),
  },
  [1947] = {
    [sym_identifier] = ACTIONS(5575),
    [aux_sym_preproc_def_token1] = ACTIONS(5575),
    [aux_sym_preproc_if_token1] = ACTIONS(5575),
    [aux_sym_preproc_if_token2] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5575),
    [aux_sym_preproc_else_token1] = ACTIONS(5575),
    [aux_sym_preproc_elif_token1] = ACTIONS(5575),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5575),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5575),
    [sym_preproc_directive] = ACTIONS(5575),
    [anon_sym_LPAREN2] = ACTIONS(5577),
    [anon_sym_TILDE] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_AMP_AMP] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5575),
    [anon_sym_SEMI] = ACTIONS(5577),
    [anon_sym___extension__] = ACTIONS(5575),
    [anon_sym_typedef] = ACTIONS(5575),
    [anon_sym_in] = ACTIONS(5575),
    [anon_sym_out] = ACTIONS(5575),
    [anon_sym_inout] = ACTIONS(5575),
    [anon_sym_virtual] = ACTIONS(5575),
    [anon_sym_extern] = ACTIONS(5575),
    [anon_sym___attribute__] = ACTIONS(5575),
    [anon_sym___attribute] = ACTIONS(5575),
    [anon_sym_using] = ACTIONS(5575),
    [anon_sym_COLON_COLON] = ACTIONS(5577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5577),
    [anon_sym___declspec] = ACTIONS(5575),
    [anon_sym___based] = ACTIONS(5575),
    [anon_sym_signed] = ACTIONS(5575),
    [anon_sym_unsigned] = ACTIONS(5575),
    [anon_sym_long] = ACTIONS(5575),
    [anon_sym_short] = ACTIONS(5575),
    [anon_sym_LBRACK] = ACTIONS(5575),
    [anon_sym_static] = ACTIONS(5575),
    [anon_sym_register] = ACTIONS(5575),
    [anon_sym_inline] = ACTIONS(5575),
    [anon_sym___inline] = ACTIONS(5575),
    [anon_sym___inline__] = ACTIONS(5575),
    [anon_sym___forceinline] = ACTIONS(5575),
    [anon_sym_thread_local] = ACTIONS(5575),
    [anon_sym___thread] = ACTIONS(5575),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5575),
    [anon_sym__Alignas] = ACTIONS(5575),
    [sym_primitive_type] = ACTIONS(5575),
    [anon_sym_enum] = ACTIONS(5575),
    [anon_sym_class] = ACTIONS(5575),
    [anon_sym_struct] = ACTIONS(5575),
    [anon_sym_union] = ACTIONS(5575),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5575),
    [anon_sym_decltype] = ACTIONS(5575),
    [anon_sym_explicit] = ACTIONS(5575),
    [anon_sym_typename] = ACTIONS(5575),
    [anon_sym_private] = ACTIONS(5575),
    [anon_sym_template] = ACTIONS(5575),
    [anon_sym_operator] = ACTIONS(5575),
    [anon_sym_friend] = ACTIONS(5575),
    [anon_sym_public] = ACTIONS(5575),
    [anon_sym_protected] = ACTIONS(5575),
    [anon_sym_static_assert] = ACTIONS(5575),
    [anon_sym_precise] = ACTIONS(5575),
    [anon_sym_shared] = ACTIONS(5575),
    [anon_sym_groupshared] = ACTIONS(5575),
    [anon_sym_uniform] = ACTIONS(5575),
    [anon_sym_row_major] = ACTIONS(5575),
    [anon_sym_column_major] = ACTIONS(5575),
    [anon_sym_globallycoherent] = ACTIONS(5575),
    [anon_sym_centroid] = ACTIONS(5575),
    [anon_sym_noperspective] = ACTIONS(5575),
    [anon_sym_nointerpolation] = ACTIONS(5575),
    [anon_sym_sample] = ACTIONS(5575),
    [anon_sym_linear] = ACTIONS(5575),
    [anon_sym_snorm] = ACTIONS(5575),
    [anon_sym_unorm] = ACTIONS(5575),
    [anon_sym_point] = ACTIONS(5575),
    [anon_sym_line] = ACTIONS(5575),
    [anon_sym_triangleadj] = ACTIONS(5575),
    [anon_sym_lineadj] = ACTIONS(5575),
    [anon_sym_triangle] = ACTIONS(5575),
  },
  [1948] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token2] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [aux_sym_preproc_else_token1] = ACTIONS(2449),
    [aux_sym_preproc_elif_token1] = ACTIONS(2449),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_friend] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [1950] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [aux_sym_preproc_else_token1] = ACTIONS(2453),
    [aux_sym_preproc_elif_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(5579),
    [aux_sym_preproc_def_token1] = ACTIONS(5579),
    [aux_sym_preproc_if_token1] = ACTIONS(5579),
    [aux_sym_preproc_if_token2] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5579),
    [aux_sym_preproc_else_token1] = ACTIONS(5579),
    [aux_sym_preproc_elif_token1] = ACTIONS(5579),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5579),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5579),
    [sym_preproc_directive] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5581),
    [anon_sym_TILDE] = ACTIONS(5581),
    [anon_sym_STAR] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_SEMI] = ACTIONS(5581),
    [anon_sym___extension__] = ACTIONS(5579),
    [anon_sym_typedef] = ACTIONS(5579),
    [anon_sym_in] = ACTIONS(5579),
    [anon_sym_out] = ACTIONS(5579),
    [anon_sym_inout] = ACTIONS(5579),
    [anon_sym_virtual] = ACTIONS(5579),
    [anon_sym_extern] = ACTIONS(5579),
    [anon_sym___attribute__] = ACTIONS(5579),
    [anon_sym___attribute] = ACTIONS(5579),
    [anon_sym_using] = ACTIONS(5579),
    [anon_sym_COLON_COLON] = ACTIONS(5581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5581),
    [anon_sym___declspec] = ACTIONS(5579),
    [anon_sym___based] = ACTIONS(5579),
    [anon_sym_signed] = ACTIONS(5579),
    [anon_sym_unsigned] = ACTIONS(5579),
    [anon_sym_long] = ACTIONS(5579),
    [anon_sym_short] = ACTIONS(5579),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_static] = ACTIONS(5579),
    [anon_sym_register] = ACTIONS(5579),
    [anon_sym_inline] = ACTIONS(5579),
    [anon_sym___inline] = ACTIONS(5579),
    [anon_sym___inline__] = ACTIONS(5579),
    [anon_sym___forceinline] = ACTIONS(5579),
    [anon_sym_thread_local] = ACTIONS(5579),
    [anon_sym___thread] = ACTIONS(5579),
    [anon_sym_const] = ACTIONS(5579),
    [anon_sym_constexpr] = ACTIONS(5579),
    [anon_sym_volatile] = ACTIONS(5579),
    [anon_sym_restrict] = ACTIONS(5579),
    [anon_sym___restrict__] = ACTIONS(5579),
    [anon_sym__Atomic] = ACTIONS(5579),
    [anon_sym__Noreturn] = ACTIONS(5579),
    [anon_sym_noreturn] = ACTIONS(5579),
    [anon_sym__Nonnull] = ACTIONS(5579),
    [anon_sym_mutable] = ACTIONS(5579),
    [anon_sym_constinit] = ACTIONS(5579),
    [anon_sym_consteval] = ACTIONS(5579),
    [anon_sym_alignas] = ACTIONS(5579),
    [anon_sym__Alignas] = ACTIONS(5579),
    [sym_primitive_type] = ACTIONS(5579),
    [anon_sym_enum] = ACTIONS(5579),
    [anon_sym_class] = ACTIONS(5579),
    [anon_sym_struct] = ACTIONS(5579),
    [anon_sym_union] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5579),
    [anon_sym_decltype] = ACTIONS(5579),
    [anon_sym_explicit] = ACTIONS(5579),
    [anon_sym_typename] = ACTIONS(5579),
    [anon_sym_private] = ACTIONS(5579),
    [anon_sym_template] = ACTIONS(5579),
    [anon_sym_operator] = ACTIONS(5579),
    [anon_sym_friend] = ACTIONS(5579),
    [anon_sym_public] = ACTIONS(5579),
    [anon_sym_protected] = ACTIONS(5579),
    [anon_sym_static_assert] = ACTIONS(5579),
    [anon_sym_precise] = ACTIONS(5579),
    [anon_sym_shared] = ACTIONS(5579),
    [anon_sym_groupshared] = ACTIONS(5579),
    [anon_sym_uniform] = ACTIONS(5579),
    [anon_sym_row_major] = ACTIONS(5579),
    [anon_sym_column_major] = ACTIONS(5579),
    [anon_sym_globallycoherent] = ACTIONS(5579),
    [anon_sym_centroid] = ACTIONS(5579),
    [anon_sym_noperspective] = ACTIONS(5579),
    [anon_sym_nointerpolation] = ACTIONS(5579),
    [anon_sym_sample] = ACTIONS(5579),
    [anon_sym_linear] = ACTIONS(5579),
    [anon_sym_snorm] = ACTIONS(5579),
    [anon_sym_unorm] = ACTIONS(5579),
    [anon_sym_point] = ACTIONS(5579),
    [anon_sym_line] = ACTIONS(5579),
    [anon_sym_triangleadj] = ACTIONS(5579),
    [anon_sym_lineadj] = ACTIONS(5579),
    [anon_sym_triangle] = ACTIONS(5579),
  },
  [1952] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [aux_sym_preproc_else_token1] = ACTIONS(2378),
    [aux_sym_preproc_elif_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token2] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [aux_sym_preproc_else_token1] = ACTIONS(2382),
    [aux_sym_preproc_elif_token1] = ACTIONS(2382),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_friend] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token2] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [aux_sym_preproc_else_token1] = ACTIONS(2470),
    [aux_sym_preproc_elif_token1] = ACTIONS(2470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_friend] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
  },
  [1955] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [aux_sym_preproc_else_token1] = ACTIONS(2500),
    [aux_sym_preproc_elif_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
  },
  [1956] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [aux_sym_preproc_else_token1] = ACTIONS(2159),
    [aux_sym_preproc_elif_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [aux_sym_preproc_else_token1] = ACTIONS(2159),
    [aux_sym_preproc_elif_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token2] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [aux_sym_preproc_else_token1] = ACTIONS(2163),
    [aux_sym_preproc_elif_token1] = ACTIONS(2163),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_friend] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(5583),
    [aux_sym_preproc_def_token1] = ACTIONS(5583),
    [aux_sym_preproc_if_token1] = ACTIONS(5583),
    [aux_sym_preproc_if_token2] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5583),
    [aux_sym_preproc_else_token1] = ACTIONS(5583),
    [aux_sym_preproc_elif_token1] = ACTIONS(5583),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5583),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5583),
    [sym_preproc_directive] = ACTIONS(5583),
    [anon_sym_LPAREN2] = ACTIONS(5585),
    [anon_sym_TILDE] = ACTIONS(5585),
    [anon_sym_STAR] = ACTIONS(5585),
    [anon_sym_AMP_AMP] = ACTIONS(5585),
    [anon_sym_AMP] = ACTIONS(5583),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym___extension__] = ACTIONS(5583),
    [anon_sym_typedef] = ACTIONS(5583),
    [anon_sym_in] = ACTIONS(5583),
    [anon_sym_out] = ACTIONS(5583),
    [anon_sym_inout] = ACTIONS(5583),
    [anon_sym_virtual] = ACTIONS(5583),
    [anon_sym_extern] = ACTIONS(5583),
    [anon_sym___attribute__] = ACTIONS(5583),
    [anon_sym___attribute] = ACTIONS(5583),
    [anon_sym_using] = ACTIONS(5583),
    [anon_sym_COLON_COLON] = ACTIONS(5585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5585),
    [anon_sym___declspec] = ACTIONS(5583),
    [anon_sym___based] = ACTIONS(5583),
    [anon_sym_signed] = ACTIONS(5583),
    [anon_sym_unsigned] = ACTIONS(5583),
    [anon_sym_long] = ACTIONS(5583),
    [anon_sym_short] = ACTIONS(5583),
    [anon_sym_LBRACK] = ACTIONS(5583),
    [anon_sym_static] = ACTIONS(5583),
    [anon_sym_register] = ACTIONS(5583),
    [anon_sym_inline] = ACTIONS(5583),
    [anon_sym___inline] = ACTIONS(5583),
    [anon_sym___inline__] = ACTIONS(5583),
    [anon_sym___forceinline] = ACTIONS(5583),
    [anon_sym_thread_local] = ACTIONS(5583),
    [anon_sym___thread] = ACTIONS(5583),
    [anon_sym_const] = ACTIONS(5583),
    [anon_sym_constexpr] = ACTIONS(5583),
    [anon_sym_volatile] = ACTIONS(5583),
    [anon_sym_restrict] = ACTIONS(5583),
    [anon_sym___restrict__] = ACTIONS(5583),
    [anon_sym__Atomic] = ACTIONS(5583),
    [anon_sym__Noreturn] = ACTIONS(5583),
    [anon_sym_noreturn] = ACTIONS(5583),
    [anon_sym__Nonnull] = ACTIONS(5583),
    [anon_sym_mutable] = ACTIONS(5583),
    [anon_sym_constinit] = ACTIONS(5583),
    [anon_sym_consteval] = ACTIONS(5583),
    [anon_sym_alignas] = ACTIONS(5583),
    [anon_sym__Alignas] = ACTIONS(5583),
    [sym_primitive_type] = ACTIONS(5583),
    [anon_sym_enum] = ACTIONS(5583),
    [anon_sym_class] = ACTIONS(5583),
    [anon_sym_struct] = ACTIONS(5583),
    [anon_sym_union] = ACTIONS(5583),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5583),
    [anon_sym_decltype] = ACTIONS(5583),
    [anon_sym_explicit] = ACTIONS(5583),
    [anon_sym_typename] = ACTIONS(5583),
    [anon_sym_private] = ACTIONS(5583),
    [anon_sym_template] = ACTIONS(5583),
    [anon_sym_operator] = ACTIONS(5583),
    [anon_sym_friend] = ACTIONS(5583),
    [anon_sym_public] = ACTIONS(5583),
    [anon_sym_protected] = ACTIONS(5583),
    [anon_sym_static_assert] = ACTIONS(5583),
    [anon_sym_precise] = ACTIONS(5583),
    [anon_sym_shared] = ACTIONS(5583),
    [anon_sym_groupshared] = ACTIONS(5583),
    [anon_sym_uniform] = ACTIONS(5583),
    [anon_sym_row_major] = ACTIONS(5583),
    [anon_sym_column_major] = ACTIONS(5583),
    [anon_sym_globallycoherent] = ACTIONS(5583),
    [anon_sym_centroid] = ACTIONS(5583),
    [anon_sym_noperspective] = ACTIONS(5583),
    [anon_sym_nointerpolation] = ACTIONS(5583),
    [anon_sym_sample] = ACTIONS(5583),
    [anon_sym_linear] = ACTIONS(5583),
    [anon_sym_snorm] = ACTIONS(5583),
    [anon_sym_unorm] = ACTIONS(5583),
    [anon_sym_point] = ACTIONS(5583),
    [anon_sym_line] = ACTIONS(5583),
    [anon_sym_triangleadj] = ACTIONS(5583),
    [anon_sym_lineadj] = ACTIONS(5583),
    [anon_sym_triangle] = ACTIONS(5583),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(5587),
    [aux_sym_preproc_def_token1] = ACTIONS(5587),
    [aux_sym_preproc_if_token1] = ACTIONS(5587),
    [aux_sym_preproc_if_token2] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5587),
    [aux_sym_preproc_else_token1] = ACTIONS(5587),
    [aux_sym_preproc_elif_token1] = ACTIONS(5587),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5587),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5587),
    [sym_preproc_directive] = ACTIONS(5587),
    [anon_sym_LPAREN2] = ACTIONS(5589),
    [anon_sym_TILDE] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_AMP_AMP] = ACTIONS(5589),
    [anon_sym_AMP] = ACTIONS(5587),
    [anon_sym_SEMI] = ACTIONS(5589),
    [anon_sym___extension__] = ACTIONS(5587),
    [anon_sym_typedef] = ACTIONS(5587),
    [anon_sym_in] = ACTIONS(5587),
    [anon_sym_out] = ACTIONS(5587),
    [anon_sym_inout] = ACTIONS(5587),
    [anon_sym_virtual] = ACTIONS(5587),
    [anon_sym_extern] = ACTIONS(5587),
    [anon_sym___attribute__] = ACTIONS(5587),
    [anon_sym___attribute] = ACTIONS(5587),
    [anon_sym_using] = ACTIONS(5587),
    [anon_sym_COLON_COLON] = ACTIONS(5589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5589),
    [anon_sym___declspec] = ACTIONS(5587),
    [anon_sym___based] = ACTIONS(5587),
    [anon_sym_signed] = ACTIONS(5587),
    [anon_sym_unsigned] = ACTIONS(5587),
    [anon_sym_long] = ACTIONS(5587),
    [anon_sym_short] = ACTIONS(5587),
    [anon_sym_LBRACK] = ACTIONS(5587),
    [anon_sym_static] = ACTIONS(5587),
    [anon_sym_register] = ACTIONS(5587),
    [anon_sym_inline] = ACTIONS(5587),
    [anon_sym___inline] = ACTIONS(5587),
    [anon_sym___inline__] = ACTIONS(5587),
    [anon_sym___forceinline] = ACTIONS(5587),
    [anon_sym_thread_local] = ACTIONS(5587),
    [anon_sym___thread] = ACTIONS(5587),
    [anon_sym_const] = ACTIONS(5587),
    [anon_sym_constexpr] = ACTIONS(5587),
    [anon_sym_volatile] = ACTIONS(5587),
    [anon_sym_restrict] = ACTIONS(5587),
    [anon_sym___restrict__] = ACTIONS(5587),
    [anon_sym__Atomic] = ACTIONS(5587),
    [anon_sym__Noreturn] = ACTIONS(5587),
    [anon_sym_noreturn] = ACTIONS(5587),
    [anon_sym__Nonnull] = ACTIONS(5587),
    [anon_sym_mutable] = ACTIONS(5587),
    [anon_sym_constinit] = ACTIONS(5587),
    [anon_sym_consteval] = ACTIONS(5587),
    [anon_sym_alignas] = ACTIONS(5587),
    [anon_sym__Alignas] = ACTIONS(5587),
    [sym_primitive_type] = ACTIONS(5587),
    [anon_sym_enum] = ACTIONS(5587),
    [anon_sym_class] = ACTIONS(5587),
    [anon_sym_struct] = ACTIONS(5587),
    [anon_sym_union] = ACTIONS(5587),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5587),
    [anon_sym_decltype] = ACTIONS(5587),
    [anon_sym_explicit] = ACTIONS(5587),
    [anon_sym_typename] = ACTIONS(5587),
    [anon_sym_private] = ACTIONS(5587),
    [anon_sym_template] = ACTIONS(5587),
    [anon_sym_operator] = ACTIONS(5587),
    [anon_sym_friend] = ACTIONS(5587),
    [anon_sym_public] = ACTIONS(5587),
    [anon_sym_protected] = ACTIONS(5587),
    [anon_sym_static_assert] = ACTIONS(5587),
    [anon_sym_precise] = ACTIONS(5587),
    [anon_sym_shared] = ACTIONS(5587),
    [anon_sym_groupshared] = ACTIONS(5587),
    [anon_sym_uniform] = ACTIONS(5587),
    [anon_sym_row_major] = ACTIONS(5587),
    [anon_sym_column_major] = ACTIONS(5587),
    [anon_sym_globallycoherent] = ACTIONS(5587),
    [anon_sym_centroid] = ACTIONS(5587),
    [anon_sym_noperspective] = ACTIONS(5587),
    [anon_sym_nointerpolation] = ACTIONS(5587),
    [anon_sym_sample] = ACTIONS(5587),
    [anon_sym_linear] = ACTIONS(5587),
    [anon_sym_snorm] = ACTIONS(5587),
    [anon_sym_unorm] = ACTIONS(5587),
    [anon_sym_point] = ACTIONS(5587),
    [anon_sym_line] = ACTIONS(5587),
    [anon_sym_triangleadj] = ACTIONS(5587),
    [anon_sym_lineadj] = ACTIONS(5587),
    [anon_sym_triangle] = ACTIONS(5587),
  },
  [1961] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token2] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [aux_sym_preproc_else_token1] = ACTIONS(2167),
    [aux_sym_preproc_elif_token1] = ACTIONS(2167),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_friend] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token2] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [aux_sym_preproc_else_token1] = ACTIONS(2656),
    [aux_sym_preproc_elif_token1] = ACTIONS(2656),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_private] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_friend] = ACTIONS(2656),
    [anon_sym_public] = ACTIONS(2656),
    [anon_sym_protected] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [aux_sym_preproc_else_token1] = ACTIONS(2242),
    [aux_sym_preproc_elif_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_friend] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
  },
  [1964] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [aux_sym_preproc_else_token1] = ACTIONS(2246),
    [aux_sym_preproc_elif_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_private] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_friend] = ACTIONS(2246),
    [anon_sym_public] = ACTIONS(2246),
    [anon_sym_protected] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token2] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [aux_sym_preproc_else_token1] = ACTIONS(2596),
    [aux_sym_preproc_elif_token1] = ACTIONS(2596),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_friend] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [aux_sym_preproc_else_token1] = ACTIONS(2266),
    [aux_sym_preproc_elif_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_private] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_friend] = ACTIONS(2266),
    [anon_sym_public] = ACTIONS(2266),
    [anon_sym_protected] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
  },
  [1967] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token2] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [aux_sym_preproc_else_token1] = ACTIONS(5567),
    [aux_sym_preproc_elif_token1] = ACTIONS(5567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [aux_sym_preproc_else_token1] = ACTIONS(2488),
    [aux_sym_preproc_elif_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [aux_sym_preproc_else_token1] = ACTIONS(2492),
    [aux_sym_preproc_elif_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token2] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [aux_sym_preproc_else_token1] = ACTIONS(2433),
    [aux_sym_preproc_elif_token1] = ACTIONS(2433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_friend] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token2] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [aux_sym_preproc_else_token1] = ACTIONS(2437),
    [aux_sym_preproc_elif_token1] = ACTIONS(2437),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_friend] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(5591),
    [aux_sym_preproc_def_token1] = ACTIONS(5591),
    [aux_sym_preproc_if_token1] = ACTIONS(5591),
    [aux_sym_preproc_if_token2] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5591),
    [aux_sym_preproc_else_token1] = ACTIONS(5591),
    [aux_sym_preproc_elif_token1] = ACTIONS(5591),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5591),
    [sym_preproc_directive] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5593),
    [anon_sym_TILDE] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5591),
    [anon_sym_SEMI] = ACTIONS(5593),
    [anon_sym___extension__] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5591),
    [anon_sym_in] = ACTIONS(5591),
    [anon_sym_out] = ACTIONS(5591),
    [anon_sym_inout] = ACTIONS(5591),
    [anon_sym_virtual] = ACTIONS(5591),
    [anon_sym_extern] = ACTIONS(5591),
    [anon_sym___attribute__] = ACTIONS(5591),
    [anon_sym___attribute] = ACTIONS(5591),
    [anon_sym_using] = ACTIONS(5591),
    [anon_sym_COLON_COLON] = ACTIONS(5593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5593),
    [anon_sym___declspec] = ACTIONS(5591),
    [anon_sym___based] = ACTIONS(5591),
    [anon_sym_signed] = ACTIONS(5591),
    [anon_sym_unsigned] = ACTIONS(5591),
    [anon_sym_long] = ACTIONS(5591),
    [anon_sym_short] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5591),
    [anon_sym_register] = ACTIONS(5591),
    [anon_sym_inline] = ACTIONS(5591),
    [anon_sym___inline] = ACTIONS(5591),
    [anon_sym___inline__] = ACTIONS(5591),
    [anon_sym___forceinline] = ACTIONS(5591),
    [anon_sym_thread_local] = ACTIONS(5591),
    [anon_sym___thread] = ACTIONS(5591),
    [anon_sym_const] = ACTIONS(5591),
    [anon_sym_constexpr] = ACTIONS(5591),
    [anon_sym_volatile] = ACTIONS(5591),
    [anon_sym_restrict] = ACTIONS(5591),
    [anon_sym___restrict__] = ACTIONS(5591),
    [anon_sym__Atomic] = ACTIONS(5591),
    [anon_sym__Noreturn] = ACTIONS(5591),
    [anon_sym_noreturn] = ACTIONS(5591),
    [anon_sym__Nonnull] = ACTIONS(5591),
    [anon_sym_mutable] = ACTIONS(5591),
    [anon_sym_constinit] = ACTIONS(5591),
    [anon_sym_consteval] = ACTIONS(5591),
    [anon_sym_alignas] = ACTIONS(5591),
    [anon_sym__Alignas] = ACTIONS(5591),
    [sym_primitive_type] = ACTIONS(5591),
    [anon_sym_enum] = ACTIONS(5591),
    [anon_sym_class] = ACTIONS(5591),
    [anon_sym_struct] = ACTIONS(5591),
    [anon_sym_union] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5591),
    [anon_sym_decltype] = ACTIONS(5591),
    [anon_sym_explicit] = ACTIONS(5591),
    [anon_sym_typename] = ACTIONS(5591),
    [anon_sym_private] = ACTIONS(5591),
    [anon_sym_template] = ACTIONS(5591),
    [anon_sym_operator] = ACTIONS(5591),
    [anon_sym_friend] = ACTIONS(5591),
    [anon_sym_public] = ACTIONS(5591),
    [anon_sym_protected] = ACTIONS(5591),
    [anon_sym_static_assert] = ACTIONS(5591),
    [anon_sym_precise] = ACTIONS(5591),
    [anon_sym_shared] = ACTIONS(5591),
    [anon_sym_groupshared] = ACTIONS(5591),
    [anon_sym_uniform] = ACTIONS(5591),
    [anon_sym_row_major] = ACTIONS(5591),
    [anon_sym_column_major] = ACTIONS(5591),
    [anon_sym_globallycoherent] = ACTIONS(5591),
    [anon_sym_centroid] = ACTIONS(5591),
    [anon_sym_noperspective] = ACTIONS(5591),
    [anon_sym_nointerpolation] = ACTIONS(5591),
    [anon_sym_sample] = ACTIONS(5591),
    [anon_sym_linear] = ACTIONS(5591),
    [anon_sym_snorm] = ACTIONS(5591),
    [anon_sym_unorm] = ACTIONS(5591),
    [anon_sym_point] = ACTIONS(5591),
    [anon_sym_line] = ACTIONS(5591),
    [anon_sym_triangleadj] = ACTIONS(5591),
    [anon_sym_lineadj] = ACTIONS(5591),
    [anon_sym_triangle] = ACTIONS(5591),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token2] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [aux_sym_preproc_else_token1] = ACTIONS(5595),
    [aux_sym_preproc_elif_token1] = ACTIONS(5595),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [aux_sym_preproc_else_token1] = ACTIONS(5599),
    [aux_sym_preproc_elif_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [aux_sym_preproc_else_token1] = ACTIONS(5599),
    [aux_sym_preproc_elif_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [1976] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [aux_sym_preproc_else_token1] = ACTIONS(5599),
    [aux_sym_preproc_elif_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token2] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [aux_sym_preproc_else_token1] = ACTIONS(5595),
    [aux_sym_preproc_elif_token1] = ACTIONS(5595),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token2] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [aux_sym_preproc_else_token1] = ACTIONS(2425),
    [aux_sym_preproc_elif_token1] = ACTIONS(2425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_friend] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token2] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [aux_sym_preproc_else_token1] = ACTIONS(2466),
    [aux_sym_preproc_elif_token1] = ACTIONS(2466),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_friend] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token2] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [aux_sym_preproc_else_token1] = ACTIONS(2429),
    [aux_sym_preproc_elif_token1] = ACTIONS(2429),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_private] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_friend] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(2429),
    [anon_sym_protected] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [aux_sym_preproc_else_token1] = ACTIONS(2504),
    [aux_sym_preproc_elif_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token2] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [aux_sym_preproc_else_token1] = ACTIONS(2508),
    [aux_sym_preproc_elif_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_friend] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token2] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [aux_sym_preproc_else_token1] = ACTIONS(2512),
    [aux_sym_preproc_elif_token1] = ACTIONS(2512),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_private] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_friend] = ACTIONS(2512),
    [anon_sym_public] = ACTIONS(2512),
    [anon_sym_protected] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [aux_sym_preproc_else_token1] = ACTIONS(2414),
    [aux_sym_preproc_elif_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token2] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [aux_sym_preproc_else_token1] = ACTIONS(2516),
    [aux_sym_preproc_elif_token1] = ACTIONS(2516),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_friend] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token2] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [aux_sym_preproc_else_token1] = ACTIONS(2520),
    [aux_sym_preproc_elif_token1] = ACTIONS(2520),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_private] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_friend] = ACTIONS(2520),
    [anon_sym_public] = ACTIONS(2520),
    [anon_sym_protected] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token2] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [aux_sym_preproc_else_token1] = ACTIONS(2532),
    [aux_sym_preproc_elif_token1] = ACTIONS(2532),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_friend] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token2] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [aux_sym_preproc_else_token1] = ACTIONS(2540),
    [aux_sym_preproc_elif_token1] = ACTIONS(2540),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_friend] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token2] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [aux_sym_preproc_else_token1] = ACTIONS(2548),
    [aux_sym_preproc_elif_token1] = ACTIONS(2548),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_friend] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
  },
  [1991] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [aux_sym_preproc_else_token1] = ACTIONS(2418),
    [aux_sym_preproc_elif_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_friend] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
  },
  [1992] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token2] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [aux_sym_preproc_else_token1] = ACTIONS(2572),
    [aux_sym_preproc_elif_token1] = ACTIONS(2572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_friend] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
  },
  [1993] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [aux_sym_preproc_else_token1] = ACTIONS(2604),
    [aux_sym_preproc_elif_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [aux_sym_preproc_else_token1] = ACTIONS(2604),
    [aux_sym_preproc_elif_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token2] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [aux_sym_preproc_else_token1] = ACTIONS(2612),
    [aux_sym_preproc_elif_token1] = ACTIONS(2612),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_private] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_friend] = ACTIONS(2612),
    [anon_sym_public] = ACTIONS(2612),
    [anon_sym_protected] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [aux_sym_preproc_else_token1] = ACTIONS(2524),
    [aux_sym_preproc_elif_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [1997] = {
    [sym_identifier] = ACTIONS(5603),
    [aux_sym_preproc_def_token1] = ACTIONS(5603),
    [aux_sym_preproc_if_token1] = ACTIONS(5603),
    [aux_sym_preproc_if_token2] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5603),
    [aux_sym_preproc_else_token1] = ACTIONS(5603),
    [aux_sym_preproc_elif_token1] = ACTIONS(5603),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5603),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5603),
    [sym_preproc_directive] = ACTIONS(5603),
    [anon_sym_LPAREN2] = ACTIONS(5605),
    [anon_sym_TILDE] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5605),
    [anon_sym_AMP_AMP] = ACTIONS(5605),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_SEMI] = ACTIONS(5605),
    [anon_sym___extension__] = ACTIONS(5603),
    [anon_sym_typedef] = ACTIONS(5603),
    [anon_sym_in] = ACTIONS(5603),
    [anon_sym_out] = ACTIONS(5603),
    [anon_sym_inout] = ACTIONS(5603),
    [anon_sym_virtual] = ACTIONS(5603),
    [anon_sym_extern] = ACTIONS(5603),
    [anon_sym___attribute__] = ACTIONS(5603),
    [anon_sym___attribute] = ACTIONS(5603),
    [anon_sym_using] = ACTIONS(5603),
    [anon_sym_COLON_COLON] = ACTIONS(5605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5605),
    [anon_sym___declspec] = ACTIONS(5603),
    [anon_sym___based] = ACTIONS(5603),
    [anon_sym_signed] = ACTIONS(5603),
    [anon_sym_unsigned] = ACTIONS(5603),
    [anon_sym_long] = ACTIONS(5603),
    [anon_sym_short] = ACTIONS(5603),
    [anon_sym_LBRACK] = ACTIONS(5603),
    [anon_sym_static] = ACTIONS(5603),
    [anon_sym_register] = ACTIONS(5603),
    [anon_sym_inline] = ACTIONS(5603),
    [anon_sym___inline] = ACTIONS(5603),
    [anon_sym___inline__] = ACTIONS(5603),
    [anon_sym___forceinline] = ACTIONS(5603),
    [anon_sym_thread_local] = ACTIONS(5603),
    [anon_sym___thread] = ACTIONS(5603),
    [anon_sym_const] = ACTIONS(5603),
    [anon_sym_constexpr] = ACTIONS(5603),
    [anon_sym_volatile] = ACTIONS(5603),
    [anon_sym_restrict] = ACTIONS(5603),
    [anon_sym___restrict__] = ACTIONS(5603),
    [anon_sym__Atomic] = ACTIONS(5603),
    [anon_sym__Noreturn] = ACTIONS(5603),
    [anon_sym_noreturn] = ACTIONS(5603),
    [anon_sym__Nonnull] = ACTIONS(5603),
    [anon_sym_mutable] = ACTIONS(5603),
    [anon_sym_constinit] = ACTIONS(5603),
    [anon_sym_consteval] = ACTIONS(5603),
    [anon_sym_alignas] = ACTIONS(5603),
    [anon_sym__Alignas] = ACTIONS(5603),
    [sym_primitive_type] = ACTIONS(5603),
    [anon_sym_enum] = ACTIONS(5603),
    [anon_sym_class] = ACTIONS(5603),
    [anon_sym_struct] = ACTIONS(5603),
    [anon_sym_union] = ACTIONS(5603),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5603),
    [anon_sym_decltype] = ACTIONS(5603),
    [anon_sym_explicit] = ACTIONS(5603),
    [anon_sym_typename] = ACTIONS(5603),
    [anon_sym_private] = ACTIONS(5603),
    [anon_sym_template] = ACTIONS(5603),
    [anon_sym_operator] = ACTIONS(5603),
    [anon_sym_friend] = ACTIONS(5603),
    [anon_sym_public] = ACTIONS(5603),
    [anon_sym_protected] = ACTIONS(5603),
    [anon_sym_static_assert] = ACTIONS(5603),
    [anon_sym_precise] = ACTIONS(5603),
    [anon_sym_shared] = ACTIONS(5603),
    [anon_sym_groupshared] = ACTIONS(5603),
    [anon_sym_uniform] = ACTIONS(5603),
    [anon_sym_row_major] = ACTIONS(5603),
    [anon_sym_column_major] = ACTIONS(5603),
    [anon_sym_globallycoherent] = ACTIONS(5603),
    [anon_sym_centroid] = ACTIONS(5603),
    [anon_sym_noperspective] = ACTIONS(5603),
    [anon_sym_nointerpolation] = ACTIONS(5603),
    [anon_sym_sample] = ACTIONS(5603),
    [anon_sym_linear] = ACTIONS(5603),
    [anon_sym_snorm] = ACTIONS(5603),
    [anon_sym_unorm] = ACTIONS(5603),
    [anon_sym_point] = ACTIONS(5603),
    [anon_sym_line] = ACTIONS(5603),
    [anon_sym_triangleadj] = ACTIONS(5603),
    [anon_sym_lineadj] = ACTIONS(5603),
    [anon_sym_triangle] = ACTIONS(5603),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(5607),
    [aux_sym_preproc_def_token1] = ACTIONS(5607),
    [aux_sym_preproc_if_token1] = ACTIONS(5607),
    [aux_sym_preproc_if_token2] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5607),
    [aux_sym_preproc_else_token1] = ACTIONS(5607),
    [aux_sym_preproc_elif_token1] = ACTIONS(5607),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5607),
    [sym_preproc_directive] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5609),
    [anon_sym_TILDE] = ACTIONS(5609),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_AMP_AMP] = ACTIONS(5609),
    [anon_sym_AMP] = ACTIONS(5607),
    [anon_sym_SEMI] = ACTIONS(5609),
    [anon_sym___extension__] = ACTIONS(5607),
    [anon_sym_typedef] = ACTIONS(5607),
    [anon_sym_in] = ACTIONS(5607),
    [anon_sym_out] = ACTIONS(5607),
    [anon_sym_inout] = ACTIONS(5607),
    [anon_sym_virtual] = ACTIONS(5607),
    [anon_sym_extern] = ACTIONS(5607),
    [anon_sym___attribute__] = ACTIONS(5607),
    [anon_sym___attribute] = ACTIONS(5607),
    [anon_sym_using] = ACTIONS(5607),
    [anon_sym_COLON_COLON] = ACTIONS(5609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5609),
    [anon_sym___declspec] = ACTIONS(5607),
    [anon_sym___based] = ACTIONS(5607),
    [anon_sym_signed] = ACTIONS(5607),
    [anon_sym_unsigned] = ACTIONS(5607),
    [anon_sym_long] = ACTIONS(5607),
    [anon_sym_short] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_static] = ACTIONS(5607),
    [anon_sym_register] = ACTIONS(5607),
    [anon_sym_inline] = ACTIONS(5607),
    [anon_sym___inline] = ACTIONS(5607),
    [anon_sym___inline__] = ACTIONS(5607),
    [anon_sym___forceinline] = ACTIONS(5607),
    [anon_sym_thread_local] = ACTIONS(5607),
    [anon_sym___thread] = ACTIONS(5607),
    [anon_sym_const] = ACTIONS(5607),
    [anon_sym_constexpr] = ACTIONS(5607),
    [anon_sym_volatile] = ACTIONS(5607),
    [anon_sym_restrict] = ACTIONS(5607),
    [anon_sym___restrict__] = ACTIONS(5607),
    [anon_sym__Atomic] = ACTIONS(5607),
    [anon_sym__Noreturn] = ACTIONS(5607),
    [anon_sym_noreturn] = ACTIONS(5607),
    [anon_sym__Nonnull] = ACTIONS(5607),
    [anon_sym_mutable] = ACTIONS(5607),
    [anon_sym_constinit] = ACTIONS(5607),
    [anon_sym_consteval] = ACTIONS(5607),
    [anon_sym_alignas] = ACTIONS(5607),
    [anon_sym__Alignas] = ACTIONS(5607),
    [sym_primitive_type] = ACTIONS(5607),
    [anon_sym_enum] = ACTIONS(5607),
    [anon_sym_class] = ACTIONS(5607),
    [anon_sym_struct] = ACTIONS(5607),
    [anon_sym_union] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5607),
    [anon_sym_decltype] = ACTIONS(5607),
    [anon_sym_explicit] = ACTIONS(5607),
    [anon_sym_typename] = ACTIONS(5607),
    [anon_sym_private] = ACTIONS(5607),
    [anon_sym_template] = ACTIONS(5607),
    [anon_sym_operator] = ACTIONS(5607),
    [anon_sym_friend] = ACTIONS(5607),
    [anon_sym_public] = ACTIONS(5607),
    [anon_sym_protected] = ACTIONS(5607),
    [anon_sym_static_assert] = ACTIONS(5607),
    [anon_sym_precise] = ACTIONS(5607),
    [anon_sym_shared] = ACTIONS(5607),
    [anon_sym_groupshared] = ACTIONS(5607),
    [anon_sym_uniform] = ACTIONS(5607),
    [anon_sym_row_major] = ACTIONS(5607),
    [anon_sym_column_major] = ACTIONS(5607),
    [anon_sym_globallycoherent] = ACTIONS(5607),
    [anon_sym_centroid] = ACTIONS(5607),
    [anon_sym_noperspective] = ACTIONS(5607),
    [anon_sym_nointerpolation] = ACTIONS(5607),
    [anon_sym_sample] = ACTIONS(5607),
    [anon_sym_linear] = ACTIONS(5607),
    [anon_sym_snorm] = ACTIONS(5607),
    [anon_sym_unorm] = ACTIONS(5607),
    [anon_sym_point] = ACTIONS(5607),
    [anon_sym_line] = ACTIONS(5607),
    [anon_sym_triangleadj] = ACTIONS(5607),
    [anon_sym_lineadj] = ACTIONS(5607),
    [anon_sym_triangle] = ACTIONS(5607),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(5611),
    [aux_sym_preproc_def_token1] = ACTIONS(5611),
    [aux_sym_preproc_if_token1] = ACTIONS(5611),
    [aux_sym_preproc_if_token2] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5611),
    [aux_sym_preproc_else_token1] = ACTIONS(5611),
    [aux_sym_preproc_elif_token1] = ACTIONS(5611),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5611),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5611),
    [sym_preproc_directive] = ACTIONS(5611),
    [anon_sym_LPAREN2] = ACTIONS(5613),
    [anon_sym_TILDE] = ACTIONS(5613),
    [anon_sym_STAR] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_AMP] = ACTIONS(5611),
    [anon_sym_SEMI] = ACTIONS(5613),
    [anon_sym___extension__] = ACTIONS(5611),
    [anon_sym_typedef] = ACTIONS(5611),
    [anon_sym_in] = ACTIONS(5611),
    [anon_sym_out] = ACTIONS(5611),
    [anon_sym_inout] = ACTIONS(5611),
    [anon_sym_virtual] = ACTIONS(5611),
    [anon_sym_extern] = ACTIONS(5611),
    [anon_sym___attribute__] = ACTIONS(5611),
    [anon_sym___attribute] = ACTIONS(5611),
    [anon_sym_using] = ACTIONS(5611),
    [anon_sym_COLON_COLON] = ACTIONS(5613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5613),
    [anon_sym___declspec] = ACTIONS(5611),
    [anon_sym___based] = ACTIONS(5611),
    [anon_sym_signed] = ACTIONS(5611),
    [anon_sym_unsigned] = ACTIONS(5611),
    [anon_sym_long] = ACTIONS(5611),
    [anon_sym_short] = ACTIONS(5611),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_static] = ACTIONS(5611),
    [anon_sym_register] = ACTIONS(5611),
    [anon_sym_inline] = ACTIONS(5611),
    [anon_sym___inline] = ACTIONS(5611),
    [anon_sym___inline__] = ACTIONS(5611),
    [anon_sym___forceinline] = ACTIONS(5611),
    [anon_sym_thread_local] = ACTIONS(5611),
    [anon_sym___thread] = ACTIONS(5611),
    [anon_sym_const] = ACTIONS(5611),
    [anon_sym_constexpr] = ACTIONS(5611),
    [anon_sym_volatile] = ACTIONS(5611),
    [anon_sym_restrict] = ACTIONS(5611),
    [anon_sym___restrict__] = ACTIONS(5611),
    [anon_sym__Atomic] = ACTIONS(5611),
    [anon_sym__Noreturn] = ACTIONS(5611),
    [anon_sym_noreturn] = ACTIONS(5611),
    [anon_sym__Nonnull] = ACTIONS(5611),
    [anon_sym_mutable] = ACTIONS(5611),
    [anon_sym_constinit] = ACTIONS(5611),
    [anon_sym_consteval] = ACTIONS(5611),
    [anon_sym_alignas] = ACTIONS(5611),
    [anon_sym__Alignas] = ACTIONS(5611),
    [sym_primitive_type] = ACTIONS(5611),
    [anon_sym_enum] = ACTIONS(5611),
    [anon_sym_class] = ACTIONS(5611),
    [anon_sym_struct] = ACTIONS(5611),
    [anon_sym_union] = ACTIONS(5611),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5611),
    [anon_sym_decltype] = ACTIONS(5611),
    [anon_sym_explicit] = ACTIONS(5611),
    [anon_sym_typename] = ACTIONS(5611),
    [anon_sym_private] = ACTIONS(5611),
    [anon_sym_template] = ACTIONS(5611),
    [anon_sym_operator] = ACTIONS(5611),
    [anon_sym_friend] = ACTIONS(5611),
    [anon_sym_public] = ACTIONS(5611),
    [anon_sym_protected] = ACTIONS(5611),
    [anon_sym_static_assert] = ACTIONS(5611),
    [anon_sym_precise] = ACTIONS(5611),
    [anon_sym_shared] = ACTIONS(5611),
    [anon_sym_groupshared] = ACTIONS(5611),
    [anon_sym_uniform] = ACTIONS(5611),
    [anon_sym_row_major] = ACTIONS(5611),
    [anon_sym_column_major] = ACTIONS(5611),
    [anon_sym_globallycoherent] = ACTIONS(5611),
    [anon_sym_centroid] = ACTIONS(5611),
    [anon_sym_noperspective] = ACTIONS(5611),
    [anon_sym_nointerpolation] = ACTIONS(5611),
    [anon_sym_sample] = ACTIONS(5611),
    [anon_sym_linear] = ACTIONS(5611),
    [anon_sym_snorm] = ACTIONS(5611),
    [anon_sym_unorm] = ACTIONS(5611),
    [anon_sym_point] = ACTIONS(5611),
    [anon_sym_line] = ACTIONS(5611),
    [anon_sym_triangleadj] = ACTIONS(5611),
    [anon_sym_lineadj] = ACTIONS(5611),
    [anon_sym_triangle] = ACTIONS(5611),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token2] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [aux_sym_preproc_else_token1] = ACTIONS(5615),
    [aux_sym_preproc_elif_token1] = ACTIONS(5615),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(5619),
    [aux_sym_preproc_def_token1] = ACTIONS(5619),
    [aux_sym_preproc_if_token1] = ACTIONS(5619),
    [aux_sym_preproc_if_token2] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5619),
    [aux_sym_preproc_else_token1] = ACTIONS(5619),
    [aux_sym_preproc_elif_token1] = ACTIONS(5619),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5619),
    [sym_preproc_directive] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_AMP] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym___extension__] = ACTIONS(5619),
    [anon_sym_typedef] = ACTIONS(5619),
    [anon_sym_in] = ACTIONS(5619),
    [anon_sym_out] = ACTIONS(5619),
    [anon_sym_inout] = ACTIONS(5619),
    [anon_sym_virtual] = ACTIONS(5619),
    [anon_sym_extern] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5619),
    [anon_sym___attribute] = ACTIONS(5619),
    [anon_sym_using] = ACTIONS(5619),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5621),
    [anon_sym___declspec] = ACTIONS(5619),
    [anon_sym___based] = ACTIONS(5619),
    [anon_sym_signed] = ACTIONS(5619),
    [anon_sym_unsigned] = ACTIONS(5619),
    [anon_sym_long] = ACTIONS(5619),
    [anon_sym_short] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_static] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5619),
    [anon_sym_inline] = ACTIONS(5619),
    [anon_sym___inline] = ACTIONS(5619),
    [anon_sym___inline__] = ACTIONS(5619),
    [anon_sym___forceinline] = ACTIONS(5619),
    [anon_sym_thread_local] = ACTIONS(5619),
    [anon_sym___thread] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5619),
    [anon_sym_constexpr] = ACTIONS(5619),
    [anon_sym_volatile] = ACTIONS(5619),
    [anon_sym_restrict] = ACTIONS(5619),
    [anon_sym___restrict__] = ACTIONS(5619),
    [anon_sym__Atomic] = ACTIONS(5619),
    [anon_sym__Noreturn] = ACTIONS(5619),
    [anon_sym_noreturn] = ACTIONS(5619),
    [anon_sym__Nonnull] = ACTIONS(5619),
    [anon_sym_mutable] = ACTIONS(5619),
    [anon_sym_constinit] = ACTIONS(5619),
    [anon_sym_consteval] = ACTIONS(5619),
    [anon_sym_alignas] = ACTIONS(5619),
    [anon_sym__Alignas] = ACTIONS(5619),
    [sym_primitive_type] = ACTIONS(5619),
    [anon_sym_enum] = ACTIONS(5619),
    [anon_sym_class] = ACTIONS(5619),
    [anon_sym_struct] = ACTIONS(5619),
    [anon_sym_union] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5619),
    [anon_sym_decltype] = ACTIONS(5619),
    [anon_sym_explicit] = ACTIONS(5619),
    [anon_sym_typename] = ACTIONS(5619),
    [anon_sym_private] = ACTIONS(5619),
    [anon_sym_template] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5619),
    [anon_sym_friend] = ACTIONS(5619),
    [anon_sym_public] = ACTIONS(5619),
    [anon_sym_protected] = ACTIONS(5619),
    [anon_sym_static_assert] = ACTIONS(5619),
    [anon_sym_precise] = ACTIONS(5619),
    [anon_sym_shared] = ACTIONS(5619),
    [anon_sym_groupshared] = ACTIONS(5619),
    [anon_sym_uniform] = ACTIONS(5619),
    [anon_sym_row_major] = ACTIONS(5619),
    [anon_sym_column_major] = ACTIONS(5619),
    [anon_sym_globallycoherent] = ACTIONS(5619),
    [anon_sym_centroid] = ACTIONS(5619),
    [anon_sym_noperspective] = ACTIONS(5619),
    [anon_sym_nointerpolation] = ACTIONS(5619),
    [anon_sym_sample] = ACTIONS(5619),
    [anon_sym_linear] = ACTIONS(5619),
    [anon_sym_snorm] = ACTIONS(5619),
    [anon_sym_unorm] = ACTIONS(5619),
    [anon_sym_point] = ACTIONS(5619),
    [anon_sym_line] = ACTIONS(5619),
    [anon_sym_triangleadj] = ACTIONS(5619),
    [anon_sym_lineadj] = ACTIONS(5619),
    [anon_sym_triangle] = ACTIONS(5619),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token2] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [aux_sym_preproc_else_token1] = ACTIONS(5615),
    [aux_sym_preproc_elif_token1] = ACTIONS(5615),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(5623),
    [aux_sym_preproc_def_token1] = ACTIONS(5623),
    [aux_sym_preproc_if_token1] = ACTIONS(5623),
    [aux_sym_preproc_if_token2] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5623),
    [aux_sym_preproc_else_token1] = ACTIONS(5623),
    [aux_sym_preproc_elif_token1] = ACTIONS(5623),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5623),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_LPAREN2] = ACTIONS(5625),
    [anon_sym_TILDE] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_AMP_AMP] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5625),
    [anon_sym___extension__] = ACTIONS(5623),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_in] = ACTIONS(5623),
    [anon_sym_out] = ACTIONS(5623),
    [anon_sym_inout] = ACTIONS(5623),
    [anon_sym_virtual] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym___attribute__] = ACTIONS(5623),
    [anon_sym___attribute] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5625),
    [anon_sym___declspec] = ACTIONS(5623),
    [anon_sym___based] = ACTIONS(5623),
    [anon_sym_signed] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(5623),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym___inline] = ACTIONS(5623),
    [anon_sym___inline__] = ACTIONS(5623),
    [anon_sym___forceinline] = ACTIONS(5623),
    [anon_sym_thread_local] = ACTIONS(5623),
    [anon_sym___thread] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym___restrict__] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym__Noreturn] = ACTIONS(5623),
    [anon_sym_noreturn] = ACTIONS(5623),
    [anon_sym__Nonnull] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_constinit] = ACTIONS(5623),
    [anon_sym_consteval] = ACTIONS(5623),
    [anon_sym_alignas] = ACTIONS(5623),
    [anon_sym__Alignas] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_class] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_decltype] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_private] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_operator] = ACTIONS(5623),
    [anon_sym_friend] = ACTIONS(5623),
    [anon_sym_public] = ACTIONS(5623),
    [anon_sym_protected] = ACTIONS(5623),
    [anon_sym_static_assert] = ACTIONS(5623),
    [anon_sym_precise] = ACTIONS(5623),
    [anon_sym_shared] = ACTIONS(5623),
    [anon_sym_groupshared] = ACTIONS(5623),
    [anon_sym_uniform] = ACTIONS(5623),
    [anon_sym_row_major] = ACTIONS(5623),
    [anon_sym_column_major] = ACTIONS(5623),
    [anon_sym_globallycoherent] = ACTIONS(5623),
    [anon_sym_centroid] = ACTIONS(5623),
    [anon_sym_noperspective] = ACTIONS(5623),
    [anon_sym_nointerpolation] = ACTIONS(5623),
    [anon_sym_sample] = ACTIONS(5623),
    [anon_sym_linear] = ACTIONS(5623),
    [anon_sym_snorm] = ACTIONS(5623),
    [anon_sym_unorm] = ACTIONS(5623),
    [anon_sym_point] = ACTIONS(5623),
    [anon_sym_line] = ACTIONS(5623),
    [anon_sym_triangleadj] = ACTIONS(5623),
    [anon_sym_lineadj] = ACTIONS(5623),
    [anon_sym_triangle] = ACTIONS(5623),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(5627),
    [aux_sym_preproc_def_token1] = ACTIONS(5627),
    [aux_sym_preproc_if_token1] = ACTIONS(5627),
    [aux_sym_preproc_if_token2] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5627),
    [aux_sym_preproc_else_token1] = ACTIONS(5627),
    [aux_sym_preproc_elif_token1] = ACTIONS(5627),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5627),
    [sym_preproc_directive] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5629),
    [anon_sym_TILDE] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5629),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_AMP] = ACTIONS(5627),
    [anon_sym_SEMI] = ACTIONS(5629),
    [anon_sym___extension__] = ACTIONS(5627),
    [anon_sym_typedef] = ACTIONS(5627),
    [anon_sym_in] = ACTIONS(5627),
    [anon_sym_out] = ACTIONS(5627),
    [anon_sym_inout] = ACTIONS(5627),
    [anon_sym_virtual] = ACTIONS(5627),
    [anon_sym_extern] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5627),
    [anon_sym___attribute] = ACTIONS(5627),
    [anon_sym_using] = ACTIONS(5627),
    [anon_sym_COLON_COLON] = ACTIONS(5629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5629),
    [anon_sym___declspec] = ACTIONS(5627),
    [anon_sym___based] = ACTIONS(5627),
    [anon_sym_signed] = ACTIONS(5627),
    [anon_sym_unsigned] = ACTIONS(5627),
    [anon_sym_long] = ACTIONS(5627),
    [anon_sym_short] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_static] = ACTIONS(5627),
    [anon_sym_register] = ACTIONS(5627),
    [anon_sym_inline] = ACTIONS(5627),
    [anon_sym___inline] = ACTIONS(5627),
    [anon_sym___inline__] = ACTIONS(5627),
    [anon_sym___forceinline] = ACTIONS(5627),
    [anon_sym_thread_local] = ACTIONS(5627),
    [anon_sym___thread] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5627),
    [anon_sym_constexpr] = ACTIONS(5627),
    [anon_sym_volatile] = ACTIONS(5627),
    [anon_sym_restrict] = ACTIONS(5627),
    [anon_sym___restrict__] = ACTIONS(5627),
    [anon_sym__Atomic] = ACTIONS(5627),
    [anon_sym__Noreturn] = ACTIONS(5627),
    [anon_sym_noreturn] = ACTIONS(5627),
    [anon_sym__Nonnull] = ACTIONS(5627),
    [anon_sym_mutable] = ACTIONS(5627),
    [anon_sym_constinit] = ACTIONS(5627),
    [anon_sym_consteval] = ACTIONS(5627),
    [anon_sym_alignas] = ACTIONS(5627),
    [anon_sym__Alignas] = ACTIONS(5627),
    [sym_primitive_type] = ACTIONS(5627),
    [anon_sym_enum] = ACTIONS(5627),
    [anon_sym_class] = ACTIONS(5627),
    [anon_sym_struct] = ACTIONS(5627),
    [anon_sym_union] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5627),
    [anon_sym_decltype] = ACTIONS(5627),
    [anon_sym_explicit] = ACTIONS(5627),
    [anon_sym_typename] = ACTIONS(5627),
    [anon_sym_private] = ACTIONS(5627),
    [anon_sym_template] = ACTIONS(5627),
    [anon_sym_operator] = ACTIONS(5627),
    [anon_sym_friend] = ACTIONS(5627),
    [anon_sym_public] = ACTIONS(5627),
    [anon_sym_protected] = ACTIONS(5627),
    [anon_sym_static_assert] = ACTIONS(5627),
    [anon_sym_precise] = ACTIONS(5627),
    [anon_sym_shared] = ACTIONS(5627),
    [anon_sym_groupshared] = ACTIONS(5627),
    [anon_sym_uniform] = ACTIONS(5627),
    [anon_sym_row_major] = ACTIONS(5627),
    [anon_sym_column_major] = ACTIONS(5627),
    [anon_sym_globallycoherent] = ACTIONS(5627),
    [anon_sym_centroid] = ACTIONS(5627),
    [anon_sym_noperspective] = ACTIONS(5627),
    [anon_sym_nointerpolation] = ACTIONS(5627),
    [anon_sym_sample] = ACTIONS(5627),
    [anon_sym_linear] = ACTIONS(5627),
    [anon_sym_snorm] = ACTIONS(5627),
    [anon_sym_unorm] = ACTIONS(5627),
    [anon_sym_point] = ACTIONS(5627),
    [anon_sym_line] = ACTIONS(5627),
    [anon_sym_triangleadj] = ACTIONS(5627),
    [anon_sym_lineadj] = ACTIONS(5627),
    [anon_sym_triangle] = ACTIONS(5627),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token2] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [aux_sym_preproc_else_token1] = ACTIONS(2616),
    [aux_sym_preproc_elif_token1] = ACTIONS(2616),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_private] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_friend] = ACTIONS(2616),
    [anon_sym_public] = ACTIONS(2616),
    [anon_sym_protected] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token2] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [aux_sym_preproc_else_token1] = ACTIONS(2620),
    [aux_sym_preproc_elif_token1] = ACTIONS(2620),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_private] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_friend] = ACTIONS(2620),
    [anon_sym_public] = ACTIONS(2620),
    [anon_sym_protected] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(5631),
    [aux_sym_preproc_def_token1] = ACTIONS(5631),
    [aux_sym_preproc_if_token1] = ACTIONS(5631),
    [aux_sym_preproc_if_token2] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5631),
    [aux_sym_preproc_else_token1] = ACTIONS(5631),
    [aux_sym_preproc_elif_token1] = ACTIONS(5631),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5631),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5631),
    [sym_preproc_directive] = ACTIONS(5631),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_TILDE] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___extension__] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5631),
    [anon_sym_in] = ACTIONS(5631),
    [anon_sym_out] = ACTIONS(5631),
    [anon_sym_inout] = ACTIONS(5631),
    [anon_sym_virtual] = ACTIONS(5631),
    [anon_sym_extern] = ACTIONS(5631),
    [anon_sym___attribute__] = ACTIONS(5631),
    [anon_sym___attribute] = ACTIONS(5631),
    [anon_sym_using] = ACTIONS(5631),
    [anon_sym_COLON_COLON] = ACTIONS(5633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5633),
    [anon_sym___declspec] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(5631),
    [anon_sym_signed] = ACTIONS(5631),
    [anon_sym_unsigned] = ACTIONS(5631),
    [anon_sym_long] = ACTIONS(5631),
    [anon_sym_short] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5631),
    [anon_sym_register] = ACTIONS(5631),
    [anon_sym_inline] = ACTIONS(5631),
    [anon_sym___inline] = ACTIONS(5631),
    [anon_sym___inline__] = ACTIONS(5631),
    [anon_sym___forceinline] = ACTIONS(5631),
    [anon_sym_thread_local] = ACTIONS(5631),
    [anon_sym___thread] = ACTIONS(5631),
    [anon_sym_const] = ACTIONS(5631),
    [anon_sym_constexpr] = ACTIONS(5631),
    [anon_sym_volatile] = ACTIONS(5631),
    [anon_sym_restrict] = ACTIONS(5631),
    [anon_sym___restrict__] = ACTIONS(5631),
    [anon_sym__Atomic] = ACTIONS(5631),
    [anon_sym__Noreturn] = ACTIONS(5631),
    [anon_sym_noreturn] = ACTIONS(5631),
    [anon_sym__Nonnull] = ACTIONS(5631),
    [anon_sym_mutable] = ACTIONS(5631),
    [anon_sym_constinit] = ACTIONS(5631),
    [anon_sym_consteval] = ACTIONS(5631),
    [anon_sym_alignas] = ACTIONS(5631),
    [anon_sym__Alignas] = ACTIONS(5631),
    [sym_primitive_type] = ACTIONS(5631),
    [anon_sym_enum] = ACTIONS(5631),
    [anon_sym_class] = ACTIONS(5631),
    [anon_sym_struct] = ACTIONS(5631),
    [anon_sym_union] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5631),
    [anon_sym_decltype] = ACTIONS(5631),
    [anon_sym_explicit] = ACTIONS(5631),
    [anon_sym_typename] = ACTIONS(5631),
    [anon_sym_private] = ACTIONS(5631),
    [anon_sym_template] = ACTIONS(5631),
    [anon_sym_operator] = ACTIONS(5631),
    [anon_sym_friend] = ACTIONS(5631),
    [anon_sym_public] = ACTIONS(5631),
    [anon_sym_protected] = ACTIONS(5631),
    [anon_sym_static_assert] = ACTIONS(5631),
    [anon_sym_precise] = ACTIONS(5631),
    [anon_sym_shared] = ACTIONS(5631),
    [anon_sym_groupshared] = ACTIONS(5631),
    [anon_sym_uniform] = ACTIONS(5631),
    [anon_sym_row_major] = ACTIONS(5631),
    [anon_sym_column_major] = ACTIONS(5631),
    [anon_sym_globallycoherent] = ACTIONS(5631),
    [anon_sym_centroid] = ACTIONS(5631),
    [anon_sym_noperspective] = ACTIONS(5631),
    [anon_sym_nointerpolation] = ACTIONS(5631),
    [anon_sym_sample] = ACTIONS(5631),
    [anon_sym_linear] = ACTIONS(5631),
    [anon_sym_snorm] = ACTIONS(5631),
    [anon_sym_unorm] = ACTIONS(5631),
    [anon_sym_point] = ACTIONS(5631),
    [anon_sym_line] = ACTIONS(5631),
    [anon_sym_triangleadj] = ACTIONS(5631),
    [anon_sym_lineadj] = ACTIONS(5631),
    [anon_sym_triangle] = ACTIONS(5631),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token2] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [aux_sym_preproc_else_token1] = ACTIONS(2624),
    [aux_sym_preproc_elif_token1] = ACTIONS(2624),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_friend] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(5635),
    [aux_sym_preproc_def_token1] = ACTIONS(5635),
    [aux_sym_preproc_if_token1] = ACTIONS(5635),
    [aux_sym_preproc_if_token2] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5635),
    [aux_sym_preproc_else_token1] = ACTIONS(5635),
    [aux_sym_preproc_elif_token1] = ACTIONS(5635),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5635),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5635),
    [sym_preproc_directive] = ACTIONS(5635),
    [anon_sym_LPAREN2] = ACTIONS(5637),
    [anon_sym_TILDE] = ACTIONS(5637),
    [anon_sym_STAR] = ACTIONS(5637),
    [anon_sym_AMP_AMP] = ACTIONS(5637),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SEMI] = ACTIONS(5637),
    [anon_sym___extension__] = ACTIONS(5635),
    [anon_sym_typedef] = ACTIONS(5635),
    [anon_sym_in] = ACTIONS(5635),
    [anon_sym_out] = ACTIONS(5635),
    [anon_sym_inout] = ACTIONS(5635),
    [anon_sym_virtual] = ACTIONS(5635),
    [anon_sym_extern] = ACTIONS(5635),
    [anon_sym___attribute__] = ACTIONS(5635),
    [anon_sym___attribute] = ACTIONS(5635),
    [anon_sym_using] = ACTIONS(5635),
    [anon_sym_COLON_COLON] = ACTIONS(5637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5637),
    [anon_sym___declspec] = ACTIONS(5635),
    [anon_sym___based] = ACTIONS(5635),
    [anon_sym_signed] = ACTIONS(5635),
    [anon_sym_unsigned] = ACTIONS(5635),
    [anon_sym_long] = ACTIONS(5635),
    [anon_sym_short] = ACTIONS(5635),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_static] = ACTIONS(5635),
    [anon_sym_register] = ACTIONS(5635),
    [anon_sym_inline] = ACTIONS(5635),
    [anon_sym___inline] = ACTIONS(5635),
    [anon_sym___inline__] = ACTIONS(5635),
    [anon_sym___forceinline] = ACTIONS(5635),
    [anon_sym_thread_local] = ACTIONS(5635),
    [anon_sym___thread] = ACTIONS(5635),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5635),
    [anon_sym_volatile] = ACTIONS(5635),
    [anon_sym_restrict] = ACTIONS(5635),
    [anon_sym___restrict__] = ACTIONS(5635),
    [anon_sym__Atomic] = ACTIONS(5635),
    [anon_sym__Noreturn] = ACTIONS(5635),
    [anon_sym_noreturn] = ACTIONS(5635),
    [anon_sym__Nonnull] = ACTIONS(5635),
    [anon_sym_mutable] = ACTIONS(5635),
    [anon_sym_constinit] = ACTIONS(5635),
    [anon_sym_consteval] = ACTIONS(5635),
    [anon_sym_alignas] = ACTIONS(5635),
    [anon_sym__Alignas] = ACTIONS(5635),
    [sym_primitive_type] = ACTIONS(5635),
    [anon_sym_enum] = ACTIONS(5635),
    [anon_sym_class] = ACTIONS(5635),
    [anon_sym_struct] = ACTIONS(5635),
    [anon_sym_union] = ACTIONS(5635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5635),
    [anon_sym_decltype] = ACTIONS(5635),
    [anon_sym_explicit] = ACTIONS(5635),
    [anon_sym_typename] = ACTIONS(5635),
    [anon_sym_private] = ACTIONS(5635),
    [anon_sym_template] = ACTIONS(5635),
    [anon_sym_operator] = ACTIONS(5635),
    [anon_sym_friend] = ACTIONS(5635),
    [anon_sym_public] = ACTIONS(5635),
    [anon_sym_protected] = ACTIONS(5635),
    [anon_sym_static_assert] = ACTIONS(5635),
    [anon_sym_precise] = ACTIONS(5635),
    [anon_sym_shared] = ACTIONS(5635),
    [anon_sym_groupshared] = ACTIONS(5635),
    [anon_sym_uniform] = ACTIONS(5635),
    [anon_sym_row_major] = ACTIONS(5635),
    [anon_sym_column_major] = ACTIONS(5635),
    [anon_sym_globallycoherent] = ACTIONS(5635),
    [anon_sym_centroid] = ACTIONS(5635),
    [anon_sym_noperspective] = ACTIONS(5635),
    [anon_sym_nointerpolation] = ACTIONS(5635),
    [anon_sym_sample] = ACTIONS(5635),
    [anon_sym_linear] = ACTIONS(5635),
    [anon_sym_snorm] = ACTIONS(5635),
    [anon_sym_unorm] = ACTIONS(5635),
    [anon_sym_point] = ACTIONS(5635),
    [anon_sym_line] = ACTIONS(5635),
    [anon_sym_triangleadj] = ACTIONS(5635),
    [anon_sym_lineadj] = ACTIONS(5635),
    [anon_sym_triangle] = ACTIONS(5635),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(5639),
    [aux_sym_preproc_def_token1] = ACTIONS(5639),
    [aux_sym_preproc_if_token1] = ACTIONS(5639),
    [aux_sym_preproc_if_token2] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5639),
    [aux_sym_preproc_else_token1] = ACTIONS(5639),
    [aux_sym_preproc_elif_token1] = ACTIONS(5639),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5639),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5639),
    [sym_preproc_directive] = ACTIONS(5639),
    [anon_sym_LPAREN2] = ACTIONS(5641),
    [anon_sym_TILDE] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(5641),
    [anon_sym_AMP_AMP] = ACTIONS(5641),
    [anon_sym_AMP] = ACTIONS(5639),
    [anon_sym_SEMI] = ACTIONS(5641),
    [anon_sym___extension__] = ACTIONS(5639),
    [anon_sym_typedef] = ACTIONS(5639),
    [anon_sym_in] = ACTIONS(5639),
    [anon_sym_out] = ACTIONS(5639),
    [anon_sym_inout] = ACTIONS(5639),
    [anon_sym_virtual] = ACTIONS(5639),
    [anon_sym_extern] = ACTIONS(5639),
    [anon_sym___attribute__] = ACTIONS(5639),
    [anon_sym___attribute] = ACTIONS(5639),
    [anon_sym_using] = ACTIONS(5639),
    [anon_sym_COLON_COLON] = ACTIONS(5641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5641),
    [anon_sym___declspec] = ACTIONS(5639),
    [anon_sym___based] = ACTIONS(5639),
    [anon_sym_signed] = ACTIONS(5639),
    [anon_sym_unsigned] = ACTIONS(5639),
    [anon_sym_long] = ACTIONS(5639),
    [anon_sym_short] = ACTIONS(5639),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_static] = ACTIONS(5639),
    [anon_sym_register] = ACTIONS(5639),
    [anon_sym_inline] = ACTIONS(5639),
    [anon_sym___inline] = ACTIONS(5639),
    [anon_sym___inline__] = ACTIONS(5639),
    [anon_sym___forceinline] = ACTIONS(5639),
    [anon_sym_thread_local] = ACTIONS(5639),
    [anon_sym___thread] = ACTIONS(5639),
    [anon_sym_const] = ACTIONS(5639),
    [anon_sym_constexpr] = ACTIONS(5639),
    [anon_sym_volatile] = ACTIONS(5639),
    [anon_sym_restrict] = ACTIONS(5639),
    [anon_sym___restrict__] = ACTIONS(5639),
    [anon_sym__Atomic] = ACTIONS(5639),
    [anon_sym__Noreturn] = ACTIONS(5639),
    [anon_sym_noreturn] = ACTIONS(5639),
    [anon_sym__Nonnull] = ACTIONS(5639),
    [anon_sym_mutable] = ACTIONS(5639),
    [anon_sym_constinit] = ACTIONS(5639),
    [anon_sym_consteval] = ACTIONS(5639),
    [anon_sym_alignas] = ACTIONS(5639),
    [anon_sym__Alignas] = ACTIONS(5639),
    [sym_primitive_type] = ACTIONS(5639),
    [anon_sym_enum] = ACTIONS(5639),
    [anon_sym_class] = ACTIONS(5639),
    [anon_sym_struct] = ACTIONS(5639),
    [anon_sym_union] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5639),
    [anon_sym_decltype] = ACTIONS(5639),
    [anon_sym_explicit] = ACTIONS(5639),
    [anon_sym_typename] = ACTIONS(5639),
    [anon_sym_private] = ACTIONS(5639),
    [anon_sym_template] = ACTIONS(5639),
    [anon_sym_operator] = ACTIONS(5639),
    [anon_sym_friend] = ACTIONS(5639),
    [anon_sym_public] = ACTIONS(5639),
    [anon_sym_protected] = ACTIONS(5639),
    [anon_sym_static_assert] = ACTIONS(5639),
    [anon_sym_precise] = ACTIONS(5639),
    [anon_sym_shared] = ACTIONS(5639),
    [anon_sym_groupshared] = ACTIONS(5639),
    [anon_sym_uniform] = ACTIONS(5639),
    [anon_sym_row_major] = ACTIONS(5639),
    [anon_sym_column_major] = ACTIONS(5639),
    [anon_sym_globallycoherent] = ACTIONS(5639),
    [anon_sym_centroid] = ACTIONS(5639),
    [anon_sym_noperspective] = ACTIONS(5639),
    [anon_sym_nointerpolation] = ACTIONS(5639),
    [anon_sym_sample] = ACTIONS(5639),
    [anon_sym_linear] = ACTIONS(5639),
    [anon_sym_snorm] = ACTIONS(5639),
    [anon_sym_unorm] = ACTIONS(5639),
    [anon_sym_point] = ACTIONS(5639),
    [anon_sym_line] = ACTIONS(5639),
    [anon_sym_triangleadj] = ACTIONS(5639),
    [anon_sym_lineadj] = ACTIONS(5639),
    [anon_sym_triangle] = ACTIONS(5639),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(5643),
    [aux_sym_preproc_def_token1] = ACTIONS(5643),
    [aux_sym_preproc_if_token1] = ACTIONS(5643),
    [aux_sym_preproc_if_token2] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5643),
    [aux_sym_preproc_else_token1] = ACTIONS(5643),
    [aux_sym_preproc_elif_token1] = ACTIONS(5643),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5643),
    [sym_preproc_directive] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5645),
    [anon_sym_TILDE] = ACTIONS(5645),
    [anon_sym_STAR] = ACTIONS(5645),
    [anon_sym_AMP_AMP] = ACTIONS(5645),
    [anon_sym_AMP] = ACTIONS(5643),
    [anon_sym_SEMI] = ACTIONS(5645),
    [anon_sym___extension__] = ACTIONS(5643),
    [anon_sym_typedef] = ACTIONS(5643),
    [anon_sym_in] = ACTIONS(5643),
    [anon_sym_out] = ACTIONS(5643),
    [anon_sym_inout] = ACTIONS(5643),
    [anon_sym_virtual] = ACTIONS(5643),
    [anon_sym_extern] = ACTIONS(5643),
    [anon_sym___attribute__] = ACTIONS(5643),
    [anon_sym___attribute] = ACTIONS(5643),
    [anon_sym_using] = ACTIONS(5643),
    [anon_sym_COLON_COLON] = ACTIONS(5645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5645),
    [anon_sym___declspec] = ACTIONS(5643),
    [anon_sym___based] = ACTIONS(5643),
    [anon_sym_signed] = ACTIONS(5643),
    [anon_sym_unsigned] = ACTIONS(5643),
    [anon_sym_long] = ACTIONS(5643),
    [anon_sym_short] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5643),
    [anon_sym_static] = ACTIONS(5643),
    [anon_sym_register] = ACTIONS(5643),
    [anon_sym_inline] = ACTIONS(5643),
    [anon_sym___inline] = ACTIONS(5643),
    [anon_sym___inline__] = ACTIONS(5643),
    [anon_sym___forceinline] = ACTIONS(5643),
    [anon_sym_thread_local] = ACTIONS(5643),
    [anon_sym___thread] = ACTIONS(5643),
    [anon_sym_const] = ACTIONS(5643),
    [anon_sym_constexpr] = ACTIONS(5643),
    [anon_sym_volatile] = ACTIONS(5643),
    [anon_sym_restrict] = ACTIONS(5643),
    [anon_sym___restrict__] = ACTIONS(5643),
    [anon_sym__Atomic] = ACTIONS(5643),
    [anon_sym__Noreturn] = ACTIONS(5643),
    [anon_sym_noreturn] = ACTIONS(5643),
    [anon_sym__Nonnull] = ACTIONS(5643),
    [anon_sym_mutable] = ACTIONS(5643),
    [anon_sym_constinit] = ACTIONS(5643),
    [anon_sym_consteval] = ACTIONS(5643),
    [anon_sym_alignas] = ACTIONS(5643),
    [anon_sym__Alignas] = ACTIONS(5643),
    [sym_primitive_type] = ACTIONS(5643),
    [anon_sym_enum] = ACTIONS(5643),
    [anon_sym_class] = ACTIONS(5643),
    [anon_sym_struct] = ACTIONS(5643),
    [anon_sym_union] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5643),
    [anon_sym_decltype] = ACTIONS(5643),
    [anon_sym_explicit] = ACTIONS(5643),
    [anon_sym_typename] = ACTIONS(5643),
    [anon_sym_private] = ACTIONS(5643),
    [anon_sym_template] = ACTIONS(5643),
    [anon_sym_operator] = ACTIONS(5643),
    [anon_sym_friend] = ACTIONS(5643),
    [anon_sym_public] = ACTIONS(5643),
    [anon_sym_protected] = ACTIONS(5643),
    [anon_sym_static_assert] = ACTIONS(5643),
    [anon_sym_precise] = ACTIONS(5643),
    [anon_sym_shared] = ACTIONS(5643),
    [anon_sym_groupshared] = ACTIONS(5643),
    [anon_sym_uniform] = ACTIONS(5643),
    [anon_sym_row_major] = ACTIONS(5643),
    [anon_sym_column_major] = ACTIONS(5643),
    [anon_sym_globallycoherent] = ACTIONS(5643),
    [anon_sym_centroid] = ACTIONS(5643),
    [anon_sym_noperspective] = ACTIONS(5643),
    [anon_sym_nointerpolation] = ACTIONS(5643),
    [anon_sym_sample] = ACTIONS(5643),
    [anon_sym_linear] = ACTIONS(5643),
    [anon_sym_snorm] = ACTIONS(5643),
    [anon_sym_unorm] = ACTIONS(5643),
    [anon_sym_point] = ACTIONS(5643),
    [anon_sym_line] = ACTIONS(5643),
    [anon_sym_triangleadj] = ACTIONS(5643),
    [anon_sym_lineadj] = ACTIONS(5643),
    [anon_sym_triangle] = ACTIONS(5643),
  },
  [2012] = {
    [sym_catch_clause] = STATE(2012),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2012),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token2] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_friend] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(5647),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
  },
  [2013] = {
    [sym_catch_clause] = STATE(2012),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2012),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token2] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_private] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_friend] = ACTIONS(2021),
    [anon_sym_public] = ACTIONS(2021),
    [anon_sym_protected] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
  },
  [2014] = {
    [sym_catch_clause] = STATE(2018),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2018),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym_RBRACE] = ACTIONS(2124),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_private] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_friend] = ACTIONS(2122),
    [anon_sym_public] = ACTIONS(2122),
    [anon_sym_protected] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(5652),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
  },
  [2015] = {
    [sym_catch_clause] = STATE(2012),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2012),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token2] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_friend] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
  },
  [2016] = {
    [sym_catch_clause] = STATE(2018),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2018),
    [sym_identifier] = ACTIONS(2126),
    [aux_sym_preproc_def_token1] = ACTIONS(2126),
    [aux_sym_preproc_if_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2126),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2126),
    [sym_preproc_directive] = ACTIONS(2126),
    [anon_sym_LPAREN2] = ACTIONS(2128),
    [anon_sym_TILDE] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_AMP_AMP] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym___extension__] = ACTIONS(2126),
    [anon_sym_typedef] = ACTIONS(2126),
    [anon_sym_in] = ACTIONS(2126),
    [anon_sym_out] = ACTIONS(2126),
    [anon_sym_inout] = ACTIONS(2126),
    [anon_sym_virtual] = ACTIONS(2126),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym___attribute__] = ACTIONS(2126),
    [anon_sym___attribute] = ACTIONS(2126),
    [anon_sym_using] = ACTIONS(2126),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2128),
    [anon_sym___declspec] = ACTIONS(2126),
    [anon_sym___based] = ACTIONS(2126),
    [anon_sym_RBRACE] = ACTIONS(2128),
    [anon_sym_signed] = ACTIONS(2126),
    [anon_sym_unsigned] = ACTIONS(2126),
    [anon_sym_long] = ACTIONS(2126),
    [anon_sym_short] = ACTIONS(2126),
    [anon_sym_LBRACK] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_register] = ACTIONS(2126),
    [anon_sym_inline] = ACTIONS(2126),
    [anon_sym___inline] = ACTIONS(2126),
    [anon_sym___inline__] = ACTIONS(2126),
    [anon_sym___forceinline] = ACTIONS(2126),
    [anon_sym_thread_local] = ACTIONS(2126),
    [anon_sym___thread] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_constexpr] = ACTIONS(2126),
    [anon_sym_volatile] = ACTIONS(2126),
    [anon_sym_restrict] = ACTIONS(2126),
    [anon_sym___restrict__] = ACTIONS(2126),
    [anon_sym__Atomic] = ACTIONS(2126),
    [anon_sym__Noreturn] = ACTIONS(2126),
    [anon_sym_noreturn] = ACTIONS(2126),
    [anon_sym__Nonnull] = ACTIONS(2126),
    [anon_sym_mutable] = ACTIONS(2126),
    [anon_sym_constinit] = ACTIONS(2126),
    [anon_sym_consteval] = ACTIONS(2126),
    [anon_sym_alignas] = ACTIONS(2126),
    [anon_sym__Alignas] = ACTIONS(2126),
    [sym_primitive_type] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_class] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2126),
    [anon_sym_decltype] = ACTIONS(2126),
    [anon_sym_explicit] = ACTIONS(2126),
    [anon_sym_typename] = ACTIONS(2126),
    [anon_sym_private] = ACTIONS(2126),
    [anon_sym_template] = ACTIONS(2126),
    [anon_sym_operator] = ACTIONS(2126),
    [anon_sym_friend] = ACTIONS(2126),
    [anon_sym_public] = ACTIONS(2126),
    [anon_sym_protected] = ACTIONS(2126),
    [anon_sym_static_assert] = ACTIONS(2126),
    [anon_sym_catch] = ACTIONS(5652),
    [anon_sym_precise] = ACTIONS(2126),
    [anon_sym_shared] = ACTIONS(2126),
    [anon_sym_groupshared] = ACTIONS(2126),
    [anon_sym_uniform] = ACTIONS(2126),
    [anon_sym_row_major] = ACTIONS(2126),
    [anon_sym_column_major] = ACTIONS(2126),
    [anon_sym_globallycoherent] = ACTIONS(2126),
    [anon_sym_centroid] = ACTIONS(2126),
    [anon_sym_noperspective] = ACTIONS(2126),
    [anon_sym_nointerpolation] = ACTIONS(2126),
    [anon_sym_sample] = ACTIONS(2126),
    [anon_sym_linear] = ACTIONS(2126),
    [anon_sym_snorm] = ACTIONS(2126),
    [anon_sym_unorm] = ACTIONS(2126),
    [anon_sym_point] = ACTIONS(2126),
    [anon_sym_line] = ACTIONS(2126),
    [anon_sym_triangleadj] = ACTIONS(2126),
    [anon_sym_lineadj] = ACTIONS(2126),
    [anon_sym_triangle] = ACTIONS(2126),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(5654),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_TILDE] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___extension__] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5654),
    [anon_sym_out] = ACTIONS(5654),
    [anon_sym_inout] = ACTIONS(5654),
    [anon_sym_virtual] = ACTIONS(5654),
    [anon_sym_extern] = ACTIONS(5654),
    [anon_sym___attribute__] = ACTIONS(5654),
    [anon_sym___attribute] = ACTIONS(5654),
    [anon_sym_COLON_COLON] = ACTIONS(5656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5656),
    [anon_sym___declspec] = ACTIONS(5654),
    [anon_sym___based] = ACTIONS(5654),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_signed] = ACTIONS(5654),
    [anon_sym_unsigned] = ACTIONS(5654),
    [anon_sym_long] = ACTIONS(5654),
    [anon_sym_short] = ACTIONS(5654),
    [anon_sym_LBRACK] = ACTIONS(5654),
    [anon_sym_static] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_register] = ACTIONS(5654),
    [anon_sym_inline] = ACTIONS(5654),
    [anon_sym___inline] = ACTIONS(5654),
    [anon_sym___inline__] = ACTIONS(5654),
    [anon_sym___forceinline] = ACTIONS(5654),
    [anon_sym_thread_local] = ACTIONS(5654),
    [anon_sym___thread] = ACTIONS(5654),
    [anon_sym_const] = ACTIONS(5654),
    [anon_sym_constexpr] = ACTIONS(5654),
    [anon_sym_volatile] = ACTIONS(5654),
    [anon_sym_restrict] = ACTIONS(5654),
    [anon_sym___restrict__] = ACTIONS(5654),
    [anon_sym__Atomic] = ACTIONS(5654),
    [anon_sym__Noreturn] = ACTIONS(5654),
    [anon_sym_noreturn] = ACTIONS(5654),
    [anon_sym__Nonnull] = ACTIONS(5654),
    [anon_sym_mutable] = ACTIONS(5654),
    [anon_sym_constinit] = ACTIONS(5654),
    [anon_sym_consteval] = ACTIONS(5654),
    [anon_sym_alignas] = ACTIONS(5654),
    [anon_sym__Alignas] = ACTIONS(5654),
    [sym_primitive_type] = ACTIONS(5654),
    [anon_sym_enum] = ACTIONS(5654),
    [anon_sym_class] = ACTIONS(5654),
    [anon_sym_struct] = ACTIONS(5654),
    [anon_sym_union] = ACTIONS(5654),
    [anon_sym_asm] = ACTIONS(5654),
    [anon_sym___asm__] = ACTIONS(5654),
    [anon_sym___asm] = ACTIONS(5654),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5654),
    [anon_sym_decltype] = ACTIONS(5654),
    [anon_sym_final] = ACTIONS(5654),
    [anon_sym_override] = ACTIONS(5654),
    [anon_sym_explicit] = ACTIONS(5654),
    [anon_sym_typename] = ACTIONS(5654),
    [anon_sym_template] = ACTIONS(5654),
    [anon_sym_GT2] = ACTIONS(5656),
    [anon_sym_operator] = ACTIONS(5654),
    [anon_sym_try] = ACTIONS(5654),
    [anon_sym_noexcept] = ACTIONS(5654),
    [anon_sym_throw] = ACTIONS(5654),
    [anon_sym_requires] = ACTIONS(5654),
    [anon_sym_precise] = ACTIONS(5654),
    [anon_sym_shared] = ACTIONS(5654),
    [anon_sym_groupshared] = ACTIONS(5654),
    [anon_sym_uniform] = ACTIONS(5654),
    [anon_sym_row_major] = ACTIONS(5654),
    [anon_sym_column_major] = ACTIONS(5654),
    [anon_sym_globallycoherent] = ACTIONS(5654),
    [anon_sym_centroid] = ACTIONS(5654),
    [anon_sym_noperspective] = ACTIONS(5654),
    [anon_sym_nointerpolation] = ACTIONS(5654),
    [anon_sym_sample] = ACTIONS(5654),
    [anon_sym_linear] = ACTIONS(5654),
    [anon_sym_snorm] = ACTIONS(5654),
    [anon_sym_unorm] = ACTIONS(5654),
    [anon_sym_point] = ACTIONS(5654),
    [anon_sym_line] = ACTIONS(5654),
    [anon_sym_triangleadj] = ACTIONS(5654),
    [anon_sym_lineadj] = ACTIONS(5654),
    [anon_sym_triangle] = ACTIONS(5654),
  },
  [2018] = {
    [sym_catch_clause] = STATE(2018),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2018),
    [sym_identifier] = ACTIONS(2031),
    [aux_sym_preproc_def_token1] = ACTIONS(2031),
    [aux_sym_preproc_if_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2031),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2031),
    [sym_preproc_directive] = ACTIONS(2031),
    [anon_sym_LPAREN2] = ACTIONS(2033),
    [anon_sym_TILDE] = ACTIONS(2033),
    [anon_sym_STAR] = ACTIONS(2033),
    [anon_sym_AMP_AMP] = ACTIONS(2033),
    [anon_sym_AMP] = ACTIONS(2031),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym___extension__] = ACTIONS(2031),
    [anon_sym_typedef] = ACTIONS(2031),
    [anon_sym_in] = ACTIONS(2031),
    [anon_sym_out] = ACTIONS(2031),
    [anon_sym_inout] = ACTIONS(2031),
    [anon_sym_virtual] = ACTIONS(2031),
    [anon_sym_extern] = ACTIONS(2031),
    [anon_sym___attribute__] = ACTIONS(2031),
    [anon_sym___attribute] = ACTIONS(2031),
    [anon_sym_using] = ACTIONS(2031),
    [anon_sym_COLON_COLON] = ACTIONS(2033),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2033),
    [anon_sym___declspec] = ACTIONS(2031),
    [anon_sym___based] = ACTIONS(2031),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [anon_sym_signed] = ACTIONS(2031),
    [anon_sym_unsigned] = ACTIONS(2031),
    [anon_sym_long] = ACTIONS(2031),
    [anon_sym_short] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2031),
    [anon_sym_static] = ACTIONS(2031),
    [anon_sym_register] = ACTIONS(2031),
    [anon_sym_inline] = ACTIONS(2031),
    [anon_sym___inline] = ACTIONS(2031),
    [anon_sym___inline__] = ACTIONS(2031),
    [anon_sym___forceinline] = ACTIONS(2031),
    [anon_sym_thread_local] = ACTIONS(2031),
    [anon_sym___thread] = ACTIONS(2031),
    [anon_sym_const] = ACTIONS(2031),
    [anon_sym_constexpr] = ACTIONS(2031),
    [anon_sym_volatile] = ACTIONS(2031),
    [anon_sym_restrict] = ACTIONS(2031),
    [anon_sym___restrict__] = ACTIONS(2031),
    [anon_sym__Atomic] = ACTIONS(2031),
    [anon_sym__Noreturn] = ACTIONS(2031),
    [anon_sym_noreturn] = ACTIONS(2031),
    [anon_sym__Nonnull] = ACTIONS(2031),
    [anon_sym_mutable] = ACTIONS(2031),
    [anon_sym_constinit] = ACTIONS(2031),
    [anon_sym_consteval] = ACTIONS(2031),
    [anon_sym_alignas] = ACTIONS(2031),
    [anon_sym__Alignas] = ACTIONS(2031),
    [sym_primitive_type] = ACTIONS(2031),
    [anon_sym_enum] = ACTIONS(2031),
    [anon_sym_class] = ACTIONS(2031),
    [anon_sym_struct] = ACTIONS(2031),
    [anon_sym_union] = ACTIONS(2031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2031),
    [anon_sym_decltype] = ACTIONS(2031),
    [anon_sym_explicit] = ACTIONS(2031),
    [anon_sym_typename] = ACTIONS(2031),
    [anon_sym_private] = ACTIONS(2031),
    [anon_sym_template] = ACTIONS(2031),
    [anon_sym_operator] = ACTIONS(2031),
    [anon_sym_friend] = ACTIONS(2031),
    [anon_sym_public] = ACTIONS(2031),
    [anon_sym_protected] = ACTIONS(2031),
    [anon_sym_static_assert] = ACTIONS(2031),
    [anon_sym_catch] = ACTIONS(5658),
    [anon_sym_precise] = ACTIONS(2031),
    [anon_sym_shared] = ACTIONS(2031),
    [anon_sym_groupshared] = ACTIONS(2031),
    [anon_sym_uniform] = ACTIONS(2031),
    [anon_sym_row_major] = ACTIONS(2031),
    [anon_sym_column_major] = ACTIONS(2031),
    [anon_sym_globallycoherent] = ACTIONS(2031),
    [anon_sym_centroid] = ACTIONS(2031),
    [anon_sym_noperspective] = ACTIONS(2031),
    [anon_sym_nointerpolation] = ACTIONS(2031),
    [anon_sym_sample] = ACTIONS(2031),
    [anon_sym_linear] = ACTIONS(2031),
    [anon_sym_snorm] = ACTIONS(2031),
    [anon_sym_unorm] = ACTIONS(2031),
    [anon_sym_point] = ACTIONS(2031),
    [anon_sym_line] = ACTIONS(2031),
    [anon_sym_triangleadj] = ACTIONS(2031),
    [anon_sym_lineadj] = ACTIONS(2031),
    [anon_sym_triangle] = ACTIONS(2031),
  },
  [2019] = {
    [sym_catch_clause] = STATE(2012),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2012),
    [sym_identifier] = ACTIONS(2122),
    [aux_sym_preproc_def_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token1] = ACTIONS(2122),
    [aux_sym_preproc_if_token2] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2122),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2122),
    [sym_preproc_directive] = ACTIONS(2122),
    [anon_sym_LPAREN2] = ACTIONS(2124),
    [anon_sym_TILDE] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_AMP_AMP] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym___extension__] = ACTIONS(2122),
    [anon_sym_typedef] = ACTIONS(2122),
    [anon_sym_in] = ACTIONS(2122),
    [anon_sym_out] = ACTIONS(2122),
    [anon_sym_inout] = ACTIONS(2122),
    [anon_sym_virtual] = ACTIONS(2122),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym___attribute__] = ACTIONS(2122),
    [anon_sym___attribute] = ACTIONS(2122),
    [anon_sym_using] = ACTIONS(2122),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2124),
    [anon_sym___declspec] = ACTIONS(2122),
    [anon_sym___based] = ACTIONS(2122),
    [anon_sym_signed] = ACTIONS(2122),
    [anon_sym_unsigned] = ACTIONS(2122),
    [anon_sym_long] = ACTIONS(2122),
    [anon_sym_short] = ACTIONS(2122),
    [anon_sym_LBRACK] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_register] = ACTIONS(2122),
    [anon_sym_inline] = ACTIONS(2122),
    [anon_sym___inline] = ACTIONS(2122),
    [anon_sym___inline__] = ACTIONS(2122),
    [anon_sym___forceinline] = ACTIONS(2122),
    [anon_sym_thread_local] = ACTIONS(2122),
    [anon_sym___thread] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_constexpr] = ACTIONS(2122),
    [anon_sym_volatile] = ACTIONS(2122),
    [anon_sym_restrict] = ACTIONS(2122),
    [anon_sym___restrict__] = ACTIONS(2122),
    [anon_sym__Atomic] = ACTIONS(2122),
    [anon_sym__Noreturn] = ACTIONS(2122),
    [anon_sym_noreturn] = ACTIONS(2122),
    [anon_sym__Nonnull] = ACTIONS(2122),
    [anon_sym_mutable] = ACTIONS(2122),
    [anon_sym_constinit] = ACTIONS(2122),
    [anon_sym_consteval] = ACTIONS(2122),
    [anon_sym_alignas] = ACTIONS(2122),
    [anon_sym__Alignas] = ACTIONS(2122),
    [sym_primitive_type] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_class] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2122),
    [anon_sym_decltype] = ACTIONS(2122),
    [anon_sym_explicit] = ACTIONS(2122),
    [anon_sym_typename] = ACTIONS(2122),
    [anon_sym_private] = ACTIONS(2122),
    [anon_sym_template] = ACTIONS(2122),
    [anon_sym_operator] = ACTIONS(2122),
    [anon_sym_friend] = ACTIONS(2122),
    [anon_sym_public] = ACTIONS(2122),
    [anon_sym_protected] = ACTIONS(2122),
    [anon_sym_static_assert] = ACTIONS(2122),
    [anon_sym_catch] = ACTIONS(5650),
    [anon_sym_precise] = ACTIONS(2122),
    [anon_sym_shared] = ACTIONS(2122),
    [anon_sym_groupshared] = ACTIONS(2122),
    [anon_sym_uniform] = ACTIONS(2122),
    [anon_sym_row_major] = ACTIONS(2122),
    [anon_sym_column_major] = ACTIONS(2122),
    [anon_sym_globallycoherent] = ACTIONS(2122),
    [anon_sym_centroid] = ACTIONS(2122),
    [anon_sym_noperspective] = ACTIONS(2122),
    [anon_sym_nointerpolation] = ACTIONS(2122),
    [anon_sym_sample] = ACTIONS(2122),
    [anon_sym_linear] = ACTIONS(2122),
    [anon_sym_snorm] = ACTIONS(2122),
    [anon_sym_unorm] = ACTIONS(2122),
    [anon_sym_point] = ACTIONS(2122),
    [anon_sym_line] = ACTIONS(2122),
    [anon_sym_triangleadj] = ACTIONS(2122),
    [anon_sym_lineadj] = ACTIONS(2122),
    [anon_sym_triangle] = ACTIONS(2122),
  },
  [2020] = {
    [sym_catch_clause] = STATE(2018),
    [aux_sym_constructor_try_statement_repeat1] = STATE(2018),
    [sym_identifier] = ACTIONS(2021),
    [aux_sym_preproc_def_token1] = ACTIONS(2021),
    [aux_sym_preproc_if_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2021),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2021),
    [sym_preproc_directive] = ACTIONS(2021),
    [anon_sym_LPAREN2] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [anon_sym_STAR] = ACTIONS(2023),
    [anon_sym_AMP_AMP] = ACTIONS(2023),
    [anon_sym_AMP] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2023),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_typedef] = ACTIONS(2021),
    [anon_sym_in] = ACTIONS(2021),
    [anon_sym_out] = ACTIONS(2021),
    [anon_sym_inout] = ACTIONS(2021),
    [anon_sym_virtual] = ACTIONS(2021),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym___attribute__] = ACTIONS(2021),
    [anon_sym___attribute] = ACTIONS(2021),
    [anon_sym_using] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(2023),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2023),
    [anon_sym___declspec] = ACTIONS(2021),
    [anon_sym___based] = ACTIONS(2021),
    [anon_sym_RBRACE] = ACTIONS(2023),
    [anon_sym_signed] = ACTIONS(2021),
    [anon_sym_unsigned] = ACTIONS(2021),
    [anon_sym_long] = ACTIONS(2021),
    [anon_sym_short] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_register] = ACTIONS(2021),
    [anon_sym_inline] = ACTIONS(2021),
    [anon_sym___inline] = ACTIONS(2021),
    [anon_sym___inline__] = ACTIONS(2021),
    [anon_sym___forceinline] = ACTIONS(2021),
    [anon_sym_thread_local] = ACTIONS(2021),
    [anon_sym___thread] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_constexpr] = ACTIONS(2021),
    [anon_sym_volatile] = ACTIONS(2021),
    [anon_sym_restrict] = ACTIONS(2021),
    [anon_sym___restrict__] = ACTIONS(2021),
    [anon_sym__Atomic] = ACTIONS(2021),
    [anon_sym__Noreturn] = ACTIONS(2021),
    [anon_sym_noreturn] = ACTIONS(2021),
    [anon_sym__Nonnull] = ACTIONS(2021),
    [anon_sym_mutable] = ACTIONS(2021),
    [anon_sym_constinit] = ACTIONS(2021),
    [anon_sym_consteval] = ACTIONS(2021),
    [anon_sym_alignas] = ACTIONS(2021),
    [anon_sym__Alignas] = ACTIONS(2021),
    [sym_primitive_type] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_class] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2021),
    [anon_sym_decltype] = ACTIONS(2021),
    [anon_sym_explicit] = ACTIONS(2021),
    [anon_sym_typename] = ACTIONS(2021),
    [anon_sym_private] = ACTIONS(2021),
    [anon_sym_template] = ACTIONS(2021),
    [anon_sym_operator] = ACTIONS(2021),
    [anon_sym_friend] = ACTIONS(2021),
    [anon_sym_public] = ACTIONS(2021),
    [anon_sym_protected] = ACTIONS(2021),
    [anon_sym_static_assert] = ACTIONS(2021),
    [anon_sym_catch] = ACTIONS(5652),
    [anon_sym_precise] = ACTIONS(2021),
    [anon_sym_shared] = ACTIONS(2021),
    [anon_sym_groupshared] = ACTIONS(2021),
    [anon_sym_uniform] = ACTIONS(2021),
    [anon_sym_row_major] = ACTIONS(2021),
    [anon_sym_column_major] = ACTIONS(2021),
    [anon_sym_globallycoherent] = ACTIONS(2021),
    [anon_sym_centroid] = ACTIONS(2021),
    [anon_sym_noperspective] = ACTIONS(2021),
    [anon_sym_nointerpolation] = ACTIONS(2021),
    [anon_sym_sample] = ACTIONS(2021),
    [anon_sym_linear] = ACTIONS(2021),
    [anon_sym_snorm] = ACTIONS(2021),
    [anon_sym_unorm] = ACTIONS(2021),
    [anon_sym_point] = ACTIONS(2021),
    [anon_sym_line] = ACTIONS(2021),
    [anon_sym_triangleadj] = ACTIONS(2021),
    [anon_sym_lineadj] = ACTIONS(2021),
    [anon_sym_triangle] = ACTIONS(2021),
  },
  [2021] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5078),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2022] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5081),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2023] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5085),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2024] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5582),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2025] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5089),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2026] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5083),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2027] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5045),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2028] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5064),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2029] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5099),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2030] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5067),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2031] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5006),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2032] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5071),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2033] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5038),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2034] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5073),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2035] = {
    [sym__declaration_modifiers] = STATE(2043),
    [sym__declaration_specifiers] = STATE(5076),
    [sym_attribute_specifier] = STATE(2043),
    [sym_attribute_declaration] = STATE(2043),
    [sym_ms_declspec_modifier] = STATE(2043),
    [sym_storage_class_specifier] = STATE(2043),
    [sym_type_qualifier] = STATE(2043),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2268),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2043),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2043),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_out] = ACTIONS(1304),
    [anon_sym_inout] = ACTIONS(1304),
    [anon_sym_virtual] = ACTIONS(1304),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(2019),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_GT2] = ACTIONS(2019),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_noexcept] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2037] = {
    [sym__declaration_modifiers] = STATE(2463),
    [sym_attribute_specifier] = STATE(2463),
    [sym_attribute_declaration] = STATE(2463),
    [sym_ms_declspec_modifier] = STATE(2463),
    [sym_storage_class_specifier] = STATE(2463),
    [sym_type_qualifier] = STATE(2463),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2264),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2598),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(5661),
    [anon_sym_out] = ACTIONS(5661),
    [anon_sym_inout] = ACTIONS(5661),
    [anon_sym_virtual] = ACTIONS(5661),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(3856),
    [anon_sym_unsigned] = ACTIONS(3856),
    [anon_sym_long] = ACTIONS(3856),
    [anon_sym_short] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(3858),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3860),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2013),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_PIPE_PIPE] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [anon_sym_else] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_or] = ACTIONS(2011),
    [anon_sym_and] = ACTIONS(2011),
    [anon_sym_DASH_GT] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_GT2] = ACTIONS(2013),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_try] = ACTIONS(2011),
    [anon_sym_noexcept] = ACTIONS(2011),
    [anon_sym_throw] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
  },
  [2040] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2147),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_friend] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
  },
  [2041] = {
    [sym__declaration_modifiers] = STATE(2463),
    [sym_attribute_specifier] = STATE(2463),
    [sym_attribute_declaration] = STATE(2463),
    [sym_ms_declspec_modifier] = STATE(2463),
    [sym_storage_class_specifier] = STATE(2463),
    [sym_type_qualifier] = STATE(2463),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2264),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(5661),
    [anon_sym_out] = ACTIONS(5661),
    [anon_sym_inout] = ACTIONS(5661),
    [anon_sym_virtual] = ACTIONS(5661),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2738),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_struct] = ACTIONS(2742),
    [anon_sym_union] = ACTIONS(2744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(2746),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2029),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_EQ] = ACTIONS(2029),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [anon_sym_else] = ACTIONS(2027),
    [anon_sym_while] = ACTIONS(2027),
    [anon_sym_or] = ACTIONS(2027),
    [anon_sym_and] = ACTIONS(2027),
    [anon_sym_DASH_GT] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_GT2] = ACTIONS(2029),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_try] = ACTIONS(2027),
    [anon_sym_noexcept] = ACTIONS(2027),
    [anon_sym_throw] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
  },
  [2043] = {
    [sym__declaration_modifiers] = STATE(2463),
    [sym_attribute_specifier] = STATE(2463),
    [sym_attribute_declaration] = STATE(2463),
    [sym_ms_declspec_modifier] = STATE(2463),
    [sym_storage_class_specifier] = STATE(2463),
    [sym_type_qualifier] = STATE(2463),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2264),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6773),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(3846),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(5661),
    [anon_sym_out] = ACTIONS(5661),
    [anon_sym_inout] = ACTIONS(5661),
    [anon_sym_virtual] = ACTIONS(5661),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3854),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(73),
    [anon_sym_class] = ACTIONS(75),
    [anon_sym_struct] = ACTIONS(77),
    [anon_sym_union] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(131),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2044] = {
    [sym__declaration_modifiers] = STATE(2463),
    [sym_attribute_specifier] = STATE(2463),
    [sym_attribute_declaration] = STATE(2463),
    [sym_ms_declspec_modifier] = STATE(2463),
    [sym_storage_class_specifier] = STATE(2463),
    [sym_type_qualifier] = STATE(2463),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_type_specifier] = STATE(2264),
    [sym_sized_type_specifier] = STATE(2348),
    [sym_enum_specifier] = STATE(2348),
    [sym_struct_specifier] = STATE(2348),
    [sym_union_specifier] = STATE(2348),
    [sym_placeholder_type_specifier] = STATE(2348),
    [sym_decltype_auto] = STATE(2373),
    [sym_decltype] = STATE(2326),
    [sym_class_specifier] = STATE(2348),
    [sym_dependent_type] = STATE(2348),
    [sym_template_type] = STATE(2326),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6822),
    [sym_qualified_type_identifier] = STATE(2363),
    [sym_qualifiers] = STATE(2463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2463),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2272),
    [sym_identifier] = ACTIONS(4521),
    [anon_sym___extension__] = ACTIONS(67),
    [anon_sym_in] = ACTIONS(5661),
    [anon_sym_out] = ACTIONS(5661),
    [anon_sym_inout] = ACTIONS(5661),
    [anon_sym_virtual] = ACTIONS(5661),
    [anon_sym_extern] = ACTIONS(63),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4531),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1865),
    [anon_sym___declspec] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(59),
    [anon_sym_unsigned] = ACTIONS(59),
    [anon_sym_long] = ACTIONS(59),
    [anon_sym_short] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(63),
    [anon_sym_register] = ACTIONS(63),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(63),
    [anon_sym___inline__] = ACTIONS(63),
    [anon_sym___forceinline] = ACTIONS(63),
    [anon_sym_thread_local] = ACTIONS(63),
    [anon_sym___thread] = ACTIONS(63),
    [anon_sym_const] = ACTIONS(67),
    [anon_sym_constexpr] = ACTIONS(67),
    [anon_sym_volatile] = ACTIONS(67),
    [anon_sym_restrict] = ACTIONS(67),
    [anon_sym___restrict__] = ACTIONS(67),
    [anon_sym__Atomic] = ACTIONS(67),
    [anon_sym__Noreturn] = ACTIONS(67),
    [anon_sym_noreturn] = ACTIONS(67),
    [anon_sym__Nonnull] = ACTIONS(67),
    [anon_sym_mutable] = ACTIONS(67),
    [anon_sym_constinit] = ACTIONS(67),
    [anon_sym_consteval] = ACTIONS(67),
    [anon_sym_alignas] = ACTIONS(69),
    [anon_sym__Alignas] = ACTIONS(69),
    [sym_primitive_type] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(1893),
    [anon_sym_class] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(125),
    [anon_sym_decltype] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(1923),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_precise] = ACTIONS(167),
    [anon_sym_shared] = ACTIONS(167),
    [anon_sym_groupshared] = ACTIONS(167),
    [anon_sym_uniform] = ACTIONS(167),
    [anon_sym_row_major] = ACTIONS(167),
    [anon_sym_column_major] = ACTIONS(167),
    [anon_sym_globallycoherent] = ACTIONS(167),
    [anon_sym_centroid] = ACTIONS(167),
    [anon_sym_noperspective] = ACTIONS(167),
    [anon_sym_nointerpolation] = ACTIONS(167),
    [anon_sym_sample] = ACTIONS(167),
    [anon_sym_linear] = ACTIONS(167),
    [anon_sym_snorm] = ACTIONS(167),
    [anon_sym_unorm] = ACTIONS(167),
    [anon_sym_point] = ACTIONS(167),
    [anon_sym_line] = ACTIONS(167),
    [anon_sym_triangleadj] = ACTIONS(167),
    [anon_sym_lineadj] = ACTIONS(167),
    [anon_sym_triangle] = ACTIONS(167),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(2145),
    [aux_sym_preproc_def_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token1] = ACTIONS(2145),
    [aux_sym_preproc_if_token2] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2145),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2145),
    [sym_preproc_directive] = ACTIONS(2145),
    [anon_sym_LPAREN2] = ACTIONS(2147),
    [anon_sym_TILDE] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym___extension__] = ACTIONS(2145),
    [anon_sym_typedef] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2145),
    [anon_sym_out] = ACTIONS(2145),
    [anon_sym_inout] = ACTIONS(2145),
    [anon_sym_virtual] = ACTIONS(2145),
    [anon_sym_extern] = ACTIONS(2145),
    [anon_sym___attribute__] = ACTIONS(2145),
    [anon_sym___attribute] = ACTIONS(2145),
    [anon_sym_using] = ACTIONS(2145),
    [anon_sym_COLON_COLON] = ACTIONS(2147),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2147),
    [anon_sym___declspec] = ACTIONS(2145),
    [anon_sym___based] = ACTIONS(2145),
    [anon_sym_signed] = ACTIONS(2145),
    [anon_sym_unsigned] = ACTIONS(2145),
    [anon_sym_long] = ACTIONS(2145),
    [anon_sym_short] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_static] = ACTIONS(2145),
    [anon_sym_register] = ACTIONS(2145),
    [anon_sym_inline] = ACTIONS(2145),
    [anon_sym___inline] = ACTIONS(2145),
    [anon_sym___inline__] = ACTIONS(2145),
    [anon_sym___forceinline] = ACTIONS(2145),
    [anon_sym_thread_local] = ACTIONS(2145),
    [anon_sym___thread] = ACTIONS(2145),
    [anon_sym_const] = ACTIONS(2145),
    [anon_sym_constexpr] = ACTIONS(2145),
    [anon_sym_volatile] = ACTIONS(2145),
    [anon_sym_restrict] = ACTIONS(2145),
    [anon_sym___restrict__] = ACTIONS(2145),
    [anon_sym__Atomic] = ACTIONS(2145),
    [anon_sym__Noreturn] = ACTIONS(2145),
    [anon_sym_noreturn] = ACTIONS(2145),
    [anon_sym__Nonnull] = ACTIONS(2145),
    [anon_sym_mutable] = ACTIONS(2145),
    [anon_sym_constinit] = ACTIONS(2145),
    [anon_sym_consteval] = ACTIONS(2145),
    [anon_sym_alignas] = ACTIONS(2145),
    [anon_sym__Alignas] = ACTIONS(2145),
    [sym_primitive_type] = ACTIONS(2145),
    [anon_sym_enum] = ACTIONS(2145),
    [anon_sym_class] = ACTIONS(2145),
    [anon_sym_struct] = ACTIONS(2145),
    [anon_sym_union] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2145),
    [anon_sym_decltype] = ACTIONS(2145),
    [anon_sym_explicit] = ACTIONS(2145),
    [anon_sym_typename] = ACTIONS(2145),
    [anon_sym_private] = ACTIONS(2145),
    [anon_sym_template] = ACTIONS(2145),
    [anon_sym_operator] = ACTIONS(2145),
    [anon_sym_friend] = ACTIONS(2145),
    [anon_sym_public] = ACTIONS(2145),
    [anon_sym_protected] = ACTIONS(2145),
    [anon_sym_static_assert] = ACTIONS(2145),
    [anon_sym_catch] = ACTIONS(2145),
    [anon_sym_precise] = ACTIONS(2145),
    [anon_sym_shared] = ACTIONS(2145),
    [anon_sym_groupshared] = ACTIONS(2145),
    [anon_sym_uniform] = ACTIONS(2145),
    [anon_sym_row_major] = ACTIONS(2145),
    [anon_sym_column_major] = ACTIONS(2145),
    [anon_sym_globallycoherent] = ACTIONS(2145),
    [anon_sym_centroid] = ACTIONS(2145),
    [anon_sym_noperspective] = ACTIONS(2145),
    [anon_sym_nointerpolation] = ACTIONS(2145),
    [anon_sym_sample] = ACTIONS(2145),
    [anon_sym_linear] = ACTIONS(2145),
    [anon_sym_snorm] = ACTIONS(2145),
    [anon_sym_unorm] = ACTIONS(2145),
    [anon_sym_point] = ACTIONS(2145),
    [anon_sym_line] = ACTIONS(2145),
    [anon_sym_triangleadj] = ACTIONS(2145),
    [anon_sym_lineadj] = ACTIONS(2145),
    [anon_sym_triangle] = ACTIONS(2145),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(2282),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(1951),
    [aux_sym_preproc_def_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token1] = ACTIONS(1951),
    [aux_sym_preproc_if_token2] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1951),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1951),
    [sym_preproc_directive] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_typedef] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_private] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_public] = ACTIONS(1951),
    [anon_sym_protected] = ACTIONS(1951),
    [anon_sym_static_assert] = ACTIONS(1951),
    [anon_sym_catch] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(1947),
    [aux_sym_preproc_def_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token1] = ACTIONS(1947),
    [aux_sym_preproc_if_token2] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1947),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1947),
    [sym_preproc_directive] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_typedef] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_private] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_friend] = ACTIONS(1947),
    [anon_sym_public] = ACTIONS(1947),
    [anon_sym_protected] = ACTIONS(1947),
    [anon_sym_static_assert] = ACTIONS(1947),
    [anon_sym_catch] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(2019),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_GT2] = ACTIONS(2019),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_noexcept] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym_RBRACE] = ACTIONS(2451),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_friend] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(5579),
    [aux_sym_preproc_def_token1] = ACTIONS(5579),
    [aux_sym_preproc_if_token1] = ACTIONS(5579),
    [aux_sym_preproc_if_token2] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5579),
    [sym_preproc_directive] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5581),
    [anon_sym_TILDE] = ACTIONS(5581),
    [anon_sym_STAR] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_SEMI] = ACTIONS(5581),
    [anon_sym___extension__] = ACTIONS(5579),
    [anon_sym_typedef] = ACTIONS(5579),
    [anon_sym_in] = ACTIONS(5579),
    [anon_sym_out] = ACTIONS(5579),
    [anon_sym_inout] = ACTIONS(5579),
    [anon_sym_virtual] = ACTIONS(5579),
    [anon_sym_extern] = ACTIONS(5579),
    [anon_sym___attribute__] = ACTIONS(5579),
    [anon_sym___attribute] = ACTIONS(5579),
    [anon_sym_using] = ACTIONS(5579),
    [anon_sym_COLON_COLON] = ACTIONS(5581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5581),
    [anon_sym___declspec] = ACTIONS(5579),
    [anon_sym___based] = ACTIONS(5579),
    [anon_sym_signed] = ACTIONS(5579),
    [anon_sym_unsigned] = ACTIONS(5579),
    [anon_sym_long] = ACTIONS(5579),
    [anon_sym_short] = ACTIONS(5579),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_static] = ACTIONS(5579),
    [anon_sym_register] = ACTIONS(5579),
    [anon_sym_inline] = ACTIONS(5579),
    [anon_sym___inline] = ACTIONS(5579),
    [anon_sym___inline__] = ACTIONS(5579),
    [anon_sym___forceinline] = ACTIONS(5579),
    [anon_sym_thread_local] = ACTIONS(5579),
    [anon_sym___thread] = ACTIONS(5579),
    [anon_sym_const] = ACTIONS(5579),
    [anon_sym_constexpr] = ACTIONS(5579),
    [anon_sym_volatile] = ACTIONS(5579),
    [anon_sym_restrict] = ACTIONS(5579),
    [anon_sym___restrict__] = ACTIONS(5579),
    [anon_sym__Atomic] = ACTIONS(5579),
    [anon_sym__Noreturn] = ACTIONS(5579),
    [anon_sym_noreturn] = ACTIONS(5579),
    [anon_sym__Nonnull] = ACTIONS(5579),
    [anon_sym_mutable] = ACTIONS(5579),
    [anon_sym_constinit] = ACTIONS(5579),
    [anon_sym_consteval] = ACTIONS(5579),
    [anon_sym_alignas] = ACTIONS(5579),
    [anon_sym__Alignas] = ACTIONS(5579),
    [sym_primitive_type] = ACTIONS(5579),
    [anon_sym_enum] = ACTIONS(5579),
    [anon_sym_class] = ACTIONS(5579),
    [anon_sym_struct] = ACTIONS(5579),
    [anon_sym_union] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5579),
    [anon_sym_decltype] = ACTIONS(5579),
    [anon_sym_explicit] = ACTIONS(5579),
    [anon_sym_typename] = ACTIONS(5579),
    [anon_sym_private] = ACTIONS(5579),
    [anon_sym_template] = ACTIONS(5579),
    [anon_sym_operator] = ACTIONS(5579),
    [anon_sym_friend] = ACTIONS(5579),
    [anon_sym_public] = ACTIONS(5579),
    [anon_sym_protected] = ACTIONS(5579),
    [anon_sym_static_assert] = ACTIONS(5579),
    [anon_sym_precise] = ACTIONS(5579),
    [anon_sym_shared] = ACTIONS(5579),
    [anon_sym_groupshared] = ACTIONS(5579),
    [anon_sym_uniform] = ACTIONS(5579),
    [anon_sym_row_major] = ACTIONS(5579),
    [anon_sym_column_major] = ACTIONS(5579),
    [anon_sym_globallycoherent] = ACTIONS(5579),
    [anon_sym_centroid] = ACTIONS(5579),
    [anon_sym_noperspective] = ACTIONS(5579),
    [anon_sym_nointerpolation] = ACTIONS(5579),
    [anon_sym_sample] = ACTIONS(5579),
    [anon_sym_linear] = ACTIONS(5579),
    [anon_sym_snorm] = ACTIONS(5579),
    [anon_sym_unorm] = ACTIONS(5579),
    [anon_sym_point] = ACTIONS(5579),
    [anon_sym_line] = ACTIONS(5579),
    [anon_sym_triangleadj] = ACTIONS(5579),
    [anon_sym_lineadj] = ACTIONS(5579),
    [anon_sym_triangle] = ACTIONS(5579),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token2] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [2055] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token2] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(5571),
    [aux_sym_preproc_def_token1] = ACTIONS(5571),
    [aux_sym_preproc_if_token1] = ACTIONS(5571),
    [aux_sym_preproc_if_token2] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5571),
    [sym_preproc_directive] = ACTIONS(5571),
    [anon_sym_LPAREN2] = ACTIONS(5573),
    [anon_sym_TILDE] = ACTIONS(5573),
    [anon_sym_STAR] = ACTIONS(5573),
    [anon_sym_AMP_AMP] = ACTIONS(5573),
    [anon_sym_AMP] = ACTIONS(5571),
    [anon_sym_SEMI] = ACTIONS(5573),
    [anon_sym___extension__] = ACTIONS(5571),
    [anon_sym_typedef] = ACTIONS(5571),
    [anon_sym_in] = ACTIONS(5571),
    [anon_sym_out] = ACTIONS(5571),
    [anon_sym_inout] = ACTIONS(5571),
    [anon_sym_virtual] = ACTIONS(5571),
    [anon_sym_extern] = ACTIONS(5571),
    [anon_sym___attribute__] = ACTIONS(5571),
    [anon_sym___attribute] = ACTIONS(5571),
    [anon_sym_using] = ACTIONS(5571),
    [anon_sym_COLON_COLON] = ACTIONS(5573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5573),
    [anon_sym___declspec] = ACTIONS(5571),
    [anon_sym___based] = ACTIONS(5571),
    [anon_sym_signed] = ACTIONS(5571),
    [anon_sym_unsigned] = ACTIONS(5571),
    [anon_sym_long] = ACTIONS(5571),
    [anon_sym_short] = ACTIONS(5571),
    [anon_sym_LBRACK] = ACTIONS(5571),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_register] = ACTIONS(5571),
    [anon_sym_inline] = ACTIONS(5571),
    [anon_sym___inline] = ACTIONS(5571),
    [anon_sym___inline__] = ACTIONS(5571),
    [anon_sym___forceinline] = ACTIONS(5571),
    [anon_sym_thread_local] = ACTIONS(5571),
    [anon_sym___thread] = ACTIONS(5571),
    [anon_sym_const] = ACTIONS(5571),
    [anon_sym_constexpr] = ACTIONS(5571),
    [anon_sym_volatile] = ACTIONS(5571),
    [anon_sym_restrict] = ACTIONS(5571),
    [anon_sym___restrict__] = ACTIONS(5571),
    [anon_sym__Atomic] = ACTIONS(5571),
    [anon_sym__Noreturn] = ACTIONS(5571),
    [anon_sym_noreturn] = ACTIONS(5571),
    [anon_sym__Nonnull] = ACTIONS(5571),
    [anon_sym_mutable] = ACTIONS(5571),
    [anon_sym_constinit] = ACTIONS(5571),
    [anon_sym_consteval] = ACTIONS(5571),
    [anon_sym_alignas] = ACTIONS(5571),
    [anon_sym__Alignas] = ACTIONS(5571),
    [sym_primitive_type] = ACTIONS(5571),
    [anon_sym_enum] = ACTIONS(5571),
    [anon_sym_class] = ACTIONS(5571),
    [anon_sym_struct] = ACTIONS(5571),
    [anon_sym_union] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5571),
    [anon_sym_decltype] = ACTIONS(5571),
    [anon_sym_explicit] = ACTIONS(5571),
    [anon_sym_typename] = ACTIONS(5571),
    [anon_sym_private] = ACTIONS(5571),
    [anon_sym_template] = ACTIONS(5571),
    [anon_sym_operator] = ACTIONS(5571),
    [anon_sym_friend] = ACTIONS(5571),
    [anon_sym_public] = ACTIONS(5571),
    [anon_sym_protected] = ACTIONS(5571),
    [anon_sym_static_assert] = ACTIONS(5571),
    [anon_sym_precise] = ACTIONS(5571),
    [anon_sym_shared] = ACTIONS(5571),
    [anon_sym_groupshared] = ACTIONS(5571),
    [anon_sym_uniform] = ACTIONS(5571),
    [anon_sym_row_major] = ACTIONS(5571),
    [anon_sym_column_major] = ACTIONS(5571),
    [anon_sym_globallycoherent] = ACTIONS(5571),
    [anon_sym_centroid] = ACTIONS(5571),
    [anon_sym_noperspective] = ACTIONS(5571),
    [anon_sym_nointerpolation] = ACTIONS(5571),
    [anon_sym_sample] = ACTIONS(5571),
    [anon_sym_linear] = ACTIONS(5571),
    [anon_sym_snorm] = ACTIONS(5571),
    [anon_sym_unorm] = ACTIONS(5571),
    [anon_sym_point] = ACTIONS(5571),
    [anon_sym_line] = ACTIONS(5571),
    [anon_sym_triangleadj] = ACTIONS(5571),
    [anon_sym_lineadj] = ACTIONS(5571),
    [anon_sym_triangle] = ACTIONS(5571),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(5575),
    [aux_sym_preproc_def_token1] = ACTIONS(5575),
    [aux_sym_preproc_if_token1] = ACTIONS(5575),
    [aux_sym_preproc_if_token2] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5575),
    [sym_preproc_directive] = ACTIONS(5575),
    [anon_sym_LPAREN2] = ACTIONS(5577),
    [anon_sym_TILDE] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_AMP_AMP] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5575),
    [anon_sym_SEMI] = ACTIONS(5577),
    [anon_sym___extension__] = ACTIONS(5575),
    [anon_sym_typedef] = ACTIONS(5575),
    [anon_sym_in] = ACTIONS(5575),
    [anon_sym_out] = ACTIONS(5575),
    [anon_sym_inout] = ACTIONS(5575),
    [anon_sym_virtual] = ACTIONS(5575),
    [anon_sym_extern] = ACTIONS(5575),
    [anon_sym___attribute__] = ACTIONS(5575),
    [anon_sym___attribute] = ACTIONS(5575),
    [anon_sym_using] = ACTIONS(5575),
    [anon_sym_COLON_COLON] = ACTIONS(5577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5577),
    [anon_sym___declspec] = ACTIONS(5575),
    [anon_sym___based] = ACTIONS(5575),
    [anon_sym_signed] = ACTIONS(5575),
    [anon_sym_unsigned] = ACTIONS(5575),
    [anon_sym_long] = ACTIONS(5575),
    [anon_sym_short] = ACTIONS(5575),
    [anon_sym_LBRACK] = ACTIONS(5575),
    [anon_sym_static] = ACTIONS(5575),
    [anon_sym_register] = ACTIONS(5575),
    [anon_sym_inline] = ACTIONS(5575),
    [anon_sym___inline] = ACTIONS(5575),
    [anon_sym___inline__] = ACTIONS(5575),
    [anon_sym___forceinline] = ACTIONS(5575),
    [anon_sym_thread_local] = ACTIONS(5575),
    [anon_sym___thread] = ACTIONS(5575),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5575),
    [anon_sym__Alignas] = ACTIONS(5575),
    [sym_primitive_type] = ACTIONS(5575),
    [anon_sym_enum] = ACTIONS(5575),
    [anon_sym_class] = ACTIONS(5575),
    [anon_sym_struct] = ACTIONS(5575),
    [anon_sym_union] = ACTIONS(5575),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5575),
    [anon_sym_decltype] = ACTIONS(5575),
    [anon_sym_explicit] = ACTIONS(5575),
    [anon_sym_typename] = ACTIONS(5575),
    [anon_sym_private] = ACTIONS(5575),
    [anon_sym_template] = ACTIONS(5575),
    [anon_sym_operator] = ACTIONS(5575),
    [anon_sym_friend] = ACTIONS(5575),
    [anon_sym_public] = ACTIONS(5575),
    [anon_sym_protected] = ACTIONS(5575),
    [anon_sym_static_assert] = ACTIONS(5575),
    [anon_sym_precise] = ACTIONS(5575),
    [anon_sym_shared] = ACTIONS(5575),
    [anon_sym_groupshared] = ACTIONS(5575),
    [anon_sym_uniform] = ACTIONS(5575),
    [anon_sym_row_major] = ACTIONS(5575),
    [anon_sym_column_major] = ACTIONS(5575),
    [anon_sym_globallycoherent] = ACTIONS(5575),
    [anon_sym_centroid] = ACTIONS(5575),
    [anon_sym_noperspective] = ACTIONS(5575),
    [anon_sym_nointerpolation] = ACTIONS(5575),
    [anon_sym_sample] = ACTIONS(5575),
    [anon_sym_linear] = ACTIONS(5575),
    [anon_sym_snorm] = ACTIONS(5575),
    [anon_sym_unorm] = ACTIONS(5575),
    [anon_sym_point] = ACTIONS(5575),
    [anon_sym_line] = ACTIONS(5575),
    [anon_sym_triangleadj] = ACTIONS(5575),
    [anon_sym_lineadj] = ACTIONS(5575),
    [anon_sym_triangle] = ACTIONS(5575),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5643),
    [aux_sym_preproc_def_token1] = ACTIONS(5643),
    [aux_sym_preproc_if_token1] = ACTIONS(5643),
    [aux_sym_preproc_if_token2] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5643),
    [sym_preproc_directive] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5645),
    [anon_sym_TILDE] = ACTIONS(5645),
    [anon_sym_STAR] = ACTIONS(5645),
    [anon_sym_AMP_AMP] = ACTIONS(5645),
    [anon_sym_AMP] = ACTIONS(5643),
    [anon_sym_SEMI] = ACTIONS(5645),
    [anon_sym___extension__] = ACTIONS(5643),
    [anon_sym_typedef] = ACTIONS(5643),
    [anon_sym_in] = ACTIONS(5643),
    [anon_sym_out] = ACTIONS(5643),
    [anon_sym_inout] = ACTIONS(5643),
    [anon_sym_virtual] = ACTIONS(5643),
    [anon_sym_extern] = ACTIONS(5643),
    [anon_sym___attribute__] = ACTIONS(5643),
    [anon_sym___attribute] = ACTIONS(5643),
    [anon_sym_using] = ACTIONS(5643),
    [anon_sym_COLON_COLON] = ACTIONS(5645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5645),
    [anon_sym___declspec] = ACTIONS(5643),
    [anon_sym___based] = ACTIONS(5643),
    [anon_sym_signed] = ACTIONS(5643),
    [anon_sym_unsigned] = ACTIONS(5643),
    [anon_sym_long] = ACTIONS(5643),
    [anon_sym_short] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5643),
    [anon_sym_static] = ACTIONS(5643),
    [anon_sym_register] = ACTIONS(5643),
    [anon_sym_inline] = ACTIONS(5643),
    [anon_sym___inline] = ACTIONS(5643),
    [anon_sym___inline__] = ACTIONS(5643),
    [anon_sym___forceinline] = ACTIONS(5643),
    [anon_sym_thread_local] = ACTIONS(5643),
    [anon_sym___thread] = ACTIONS(5643),
    [anon_sym_const] = ACTIONS(5643),
    [anon_sym_constexpr] = ACTIONS(5643),
    [anon_sym_volatile] = ACTIONS(5643),
    [anon_sym_restrict] = ACTIONS(5643),
    [anon_sym___restrict__] = ACTIONS(5643),
    [anon_sym__Atomic] = ACTIONS(5643),
    [anon_sym__Noreturn] = ACTIONS(5643),
    [anon_sym_noreturn] = ACTIONS(5643),
    [anon_sym__Nonnull] = ACTIONS(5643),
    [anon_sym_mutable] = ACTIONS(5643),
    [anon_sym_constinit] = ACTIONS(5643),
    [anon_sym_consteval] = ACTIONS(5643),
    [anon_sym_alignas] = ACTIONS(5643),
    [anon_sym__Alignas] = ACTIONS(5643),
    [sym_primitive_type] = ACTIONS(5643),
    [anon_sym_enum] = ACTIONS(5643),
    [anon_sym_class] = ACTIONS(5643),
    [anon_sym_struct] = ACTIONS(5643),
    [anon_sym_union] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5643),
    [anon_sym_decltype] = ACTIONS(5643),
    [anon_sym_explicit] = ACTIONS(5643),
    [anon_sym_typename] = ACTIONS(5643),
    [anon_sym_private] = ACTIONS(5643),
    [anon_sym_template] = ACTIONS(5643),
    [anon_sym_operator] = ACTIONS(5643),
    [anon_sym_friend] = ACTIONS(5643),
    [anon_sym_public] = ACTIONS(5643),
    [anon_sym_protected] = ACTIONS(5643),
    [anon_sym_static_assert] = ACTIONS(5643),
    [anon_sym_precise] = ACTIONS(5643),
    [anon_sym_shared] = ACTIONS(5643),
    [anon_sym_groupshared] = ACTIONS(5643),
    [anon_sym_uniform] = ACTIONS(5643),
    [anon_sym_row_major] = ACTIONS(5643),
    [anon_sym_column_major] = ACTIONS(5643),
    [anon_sym_globallycoherent] = ACTIONS(5643),
    [anon_sym_centroid] = ACTIONS(5643),
    [anon_sym_noperspective] = ACTIONS(5643),
    [anon_sym_nointerpolation] = ACTIONS(5643),
    [anon_sym_sample] = ACTIONS(5643),
    [anon_sym_linear] = ACTIONS(5643),
    [anon_sym_snorm] = ACTIONS(5643),
    [anon_sym_unorm] = ACTIONS(5643),
    [anon_sym_point] = ACTIONS(5643),
    [anon_sym_line] = ACTIONS(5643),
    [anon_sym_triangleadj] = ACTIONS(5643),
    [anon_sym_lineadj] = ACTIONS(5643),
    [anon_sym_triangle] = ACTIONS(5643),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_RBRACE] = ACTIONS(2455),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(5631),
    [aux_sym_preproc_def_token1] = ACTIONS(5631),
    [aux_sym_preproc_if_token1] = ACTIONS(5631),
    [aux_sym_preproc_if_token2] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5631),
    [sym_preproc_directive] = ACTIONS(5631),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_TILDE] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___extension__] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5631),
    [anon_sym_in] = ACTIONS(5631),
    [anon_sym_out] = ACTIONS(5631),
    [anon_sym_inout] = ACTIONS(5631),
    [anon_sym_virtual] = ACTIONS(5631),
    [anon_sym_extern] = ACTIONS(5631),
    [anon_sym___attribute__] = ACTIONS(5631),
    [anon_sym___attribute] = ACTIONS(5631),
    [anon_sym_using] = ACTIONS(5631),
    [anon_sym_COLON_COLON] = ACTIONS(5633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5633),
    [anon_sym___declspec] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(5631),
    [anon_sym_signed] = ACTIONS(5631),
    [anon_sym_unsigned] = ACTIONS(5631),
    [anon_sym_long] = ACTIONS(5631),
    [anon_sym_short] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5631),
    [anon_sym_register] = ACTIONS(5631),
    [anon_sym_inline] = ACTIONS(5631),
    [anon_sym___inline] = ACTIONS(5631),
    [anon_sym___inline__] = ACTIONS(5631),
    [anon_sym___forceinline] = ACTIONS(5631),
    [anon_sym_thread_local] = ACTIONS(5631),
    [anon_sym___thread] = ACTIONS(5631),
    [anon_sym_const] = ACTIONS(5631),
    [anon_sym_constexpr] = ACTIONS(5631),
    [anon_sym_volatile] = ACTIONS(5631),
    [anon_sym_restrict] = ACTIONS(5631),
    [anon_sym___restrict__] = ACTIONS(5631),
    [anon_sym__Atomic] = ACTIONS(5631),
    [anon_sym__Noreturn] = ACTIONS(5631),
    [anon_sym_noreturn] = ACTIONS(5631),
    [anon_sym__Nonnull] = ACTIONS(5631),
    [anon_sym_mutable] = ACTIONS(5631),
    [anon_sym_constinit] = ACTIONS(5631),
    [anon_sym_consteval] = ACTIONS(5631),
    [anon_sym_alignas] = ACTIONS(5631),
    [anon_sym__Alignas] = ACTIONS(5631),
    [sym_primitive_type] = ACTIONS(5631),
    [anon_sym_enum] = ACTIONS(5631),
    [anon_sym_class] = ACTIONS(5631),
    [anon_sym_struct] = ACTIONS(5631),
    [anon_sym_union] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5631),
    [anon_sym_decltype] = ACTIONS(5631),
    [anon_sym_explicit] = ACTIONS(5631),
    [anon_sym_typename] = ACTIONS(5631),
    [anon_sym_private] = ACTIONS(5631),
    [anon_sym_template] = ACTIONS(5631),
    [anon_sym_operator] = ACTIONS(5631),
    [anon_sym_friend] = ACTIONS(5631),
    [anon_sym_public] = ACTIONS(5631),
    [anon_sym_protected] = ACTIONS(5631),
    [anon_sym_static_assert] = ACTIONS(5631),
    [anon_sym_precise] = ACTIONS(5631),
    [anon_sym_shared] = ACTIONS(5631),
    [anon_sym_groupshared] = ACTIONS(5631),
    [anon_sym_uniform] = ACTIONS(5631),
    [anon_sym_row_major] = ACTIONS(5631),
    [anon_sym_column_major] = ACTIONS(5631),
    [anon_sym_globallycoherent] = ACTIONS(5631),
    [anon_sym_centroid] = ACTIONS(5631),
    [anon_sym_noperspective] = ACTIONS(5631),
    [anon_sym_nointerpolation] = ACTIONS(5631),
    [anon_sym_sample] = ACTIONS(5631),
    [anon_sym_linear] = ACTIONS(5631),
    [anon_sym_snorm] = ACTIONS(5631),
    [anon_sym_unorm] = ACTIONS(5631),
    [anon_sym_point] = ACTIONS(5631),
    [anon_sym_line] = ACTIONS(5631),
    [anon_sym_triangleadj] = ACTIONS(5631),
    [anon_sym_lineadj] = ACTIONS(5631),
    [anon_sym_triangle] = ACTIONS(5631),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(5539),
    [aux_sym_preproc_def_token1] = ACTIONS(5539),
    [aux_sym_preproc_if_token1] = ACTIONS(5539),
    [aux_sym_preproc_if_token2] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_LPAREN2] = ACTIONS(5541),
    [anon_sym_TILDE] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_AMP_AMP] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5541),
    [anon_sym___extension__] = ACTIONS(5539),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_in] = ACTIONS(5539),
    [anon_sym_out] = ACTIONS(5539),
    [anon_sym_inout] = ACTIONS(5539),
    [anon_sym_virtual] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym___attribute__] = ACTIONS(5539),
    [anon_sym___attribute] = ACTIONS(5539),
    [anon_sym_using] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5541),
    [anon_sym___declspec] = ACTIONS(5539),
    [anon_sym___based] = ACTIONS(5539),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym___inline] = ACTIONS(5539),
    [anon_sym___inline__] = ACTIONS(5539),
    [anon_sym___forceinline] = ACTIONS(5539),
    [anon_sym_thread_local] = ACTIONS(5539),
    [anon_sym___thread] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym___restrict__] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym__Noreturn] = ACTIONS(5539),
    [anon_sym_noreturn] = ACTIONS(5539),
    [anon_sym__Nonnull] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_constinit] = ACTIONS(5539),
    [anon_sym_consteval] = ACTIONS(5539),
    [anon_sym_alignas] = ACTIONS(5539),
    [anon_sym__Alignas] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_class] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_decltype] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_private] = ACTIONS(5539),
    [anon_sym_template] = ACTIONS(5539),
    [anon_sym_operator] = ACTIONS(5539),
    [anon_sym_friend] = ACTIONS(5539),
    [anon_sym_public] = ACTIONS(5539),
    [anon_sym_protected] = ACTIONS(5539),
    [anon_sym_static_assert] = ACTIONS(5539),
    [anon_sym_precise] = ACTIONS(5539),
    [anon_sym_shared] = ACTIONS(5539),
    [anon_sym_groupshared] = ACTIONS(5539),
    [anon_sym_uniform] = ACTIONS(5539),
    [anon_sym_row_major] = ACTIONS(5539),
    [anon_sym_column_major] = ACTIONS(5539),
    [anon_sym_globallycoherent] = ACTIONS(5539),
    [anon_sym_centroid] = ACTIONS(5539),
    [anon_sym_noperspective] = ACTIONS(5539),
    [anon_sym_nointerpolation] = ACTIONS(5539),
    [anon_sym_sample] = ACTIONS(5539),
    [anon_sym_linear] = ACTIONS(5539),
    [anon_sym_snorm] = ACTIONS(5539),
    [anon_sym_unorm] = ACTIONS(5539),
    [anon_sym_point] = ACTIONS(5539),
    [anon_sym_line] = ACTIONS(5539),
    [anon_sym_triangleadj] = ACTIONS(5539),
    [anon_sym_lineadj] = ACTIONS(5539),
    [anon_sym_triangle] = ACTIONS(5539),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(5543),
    [aux_sym_preproc_def_token1] = ACTIONS(5543),
    [aux_sym_preproc_if_token1] = ACTIONS(5543),
    [aux_sym_preproc_if_token2] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5543),
    [sym_preproc_directive] = ACTIONS(5543),
    [anon_sym_LPAREN2] = ACTIONS(5545),
    [anon_sym_TILDE] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_AMP_AMP] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym___extension__] = ACTIONS(5543),
    [anon_sym_typedef] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5543),
    [anon_sym_out] = ACTIONS(5543),
    [anon_sym_inout] = ACTIONS(5543),
    [anon_sym_virtual] = ACTIONS(5543),
    [anon_sym_extern] = ACTIONS(5543),
    [anon_sym___attribute__] = ACTIONS(5543),
    [anon_sym___attribute] = ACTIONS(5543),
    [anon_sym_using] = ACTIONS(5543),
    [anon_sym_COLON_COLON] = ACTIONS(5545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5545),
    [anon_sym___declspec] = ACTIONS(5543),
    [anon_sym___based] = ACTIONS(5543),
    [anon_sym_signed] = ACTIONS(5543),
    [anon_sym_unsigned] = ACTIONS(5543),
    [anon_sym_long] = ACTIONS(5543),
    [anon_sym_short] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_static] = ACTIONS(5543),
    [anon_sym_register] = ACTIONS(5543),
    [anon_sym_inline] = ACTIONS(5543),
    [anon_sym___inline] = ACTIONS(5543),
    [anon_sym___inline__] = ACTIONS(5543),
    [anon_sym___forceinline] = ACTIONS(5543),
    [anon_sym_thread_local] = ACTIONS(5543),
    [anon_sym___thread] = ACTIONS(5543),
    [anon_sym_const] = ACTIONS(5543),
    [anon_sym_constexpr] = ACTIONS(5543),
    [anon_sym_volatile] = ACTIONS(5543),
    [anon_sym_restrict] = ACTIONS(5543),
    [anon_sym___restrict__] = ACTIONS(5543),
    [anon_sym__Atomic] = ACTIONS(5543),
    [anon_sym__Noreturn] = ACTIONS(5543),
    [anon_sym_noreturn] = ACTIONS(5543),
    [anon_sym__Nonnull] = ACTIONS(5543),
    [anon_sym_mutable] = ACTIONS(5543),
    [anon_sym_constinit] = ACTIONS(5543),
    [anon_sym_consteval] = ACTIONS(5543),
    [anon_sym_alignas] = ACTIONS(5543),
    [anon_sym__Alignas] = ACTIONS(5543),
    [sym_primitive_type] = ACTIONS(5543),
    [anon_sym_enum] = ACTIONS(5543),
    [anon_sym_class] = ACTIONS(5543),
    [anon_sym_struct] = ACTIONS(5543),
    [anon_sym_union] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5543),
    [anon_sym_decltype] = ACTIONS(5543),
    [anon_sym_explicit] = ACTIONS(5543),
    [anon_sym_typename] = ACTIONS(5543),
    [anon_sym_private] = ACTIONS(5543),
    [anon_sym_template] = ACTIONS(5543),
    [anon_sym_operator] = ACTIONS(5543),
    [anon_sym_friend] = ACTIONS(5543),
    [anon_sym_public] = ACTIONS(5543),
    [anon_sym_protected] = ACTIONS(5543),
    [anon_sym_static_assert] = ACTIONS(5543),
    [anon_sym_precise] = ACTIONS(5543),
    [anon_sym_shared] = ACTIONS(5543),
    [anon_sym_groupshared] = ACTIONS(5543),
    [anon_sym_uniform] = ACTIONS(5543),
    [anon_sym_row_major] = ACTIONS(5543),
    [anon_sym_column_major] = ACTIONS(5543),
    [anon_sym_globallycoherent] = ACTIONS(5543),
    [anon_sym_centroid] = ACTIONS(5543),
    [anon_sym_noperspective] = ACTIONS(5543),
    [anon_sym_nointerpolation] = ACTIONS(5543),
    [anon_sym_sample] = ACTIONS(5543),
    [anon_sym_linear] = ACTIONS(5543),
    [anon_sym_snorm] = ACTIONS(5543),
    [anon_sym_unorm] = ACTIONS(5543),
    [anon_sym_point] = ACTIONS(5543),
    [anon_sym_line] = ACTIONS(5543),
    [anon_sym_triangleadj] = ACTIONS(5543),
    [anon_sym_lineadj] = ACTIONS(5543),
    [anon_sym_triangle] = ACTIONS(5543),
  },
  [2068] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [2069] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token2] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(5623),
    [aux_sym_preproc_def_token1] = ACTIONS(5623),
    [aux_sym_preproc_if_token1] = ACTIONS(5623),
    [aux_sym_preproc_if_token2] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_LPAREN2] = ACTIONS(5625),
    [anon_sym_TILDE] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_AMP_AMP] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5625),
    [anon_sym___extension__] = ACTIONS(5623),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_in] = ACTIONS(5623),
    [anon_sym_out] = ACTIONS(5623),
    [anon_sym_inout] = ACTIONS(5623),
    [anon_sym_virtual] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym___attribute__] = ACTIONS(5623),
    [anon_sym___attribute] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5625),
    [anon_sym___declspec] = ACTIONS(5623),
    [anon_sym___based] = ACTIONS(5623),
    [anon_sym_signed] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(5623),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym___inline] = ACTIONS(5623),
    [anon_sym___inline__] = ACTIONS(5623),
    [anon_sym___forceinline] = ACTIONS(5623),
    [anon_sym_thread_local] = ACTIONS(5623),
    [anon_sym___thread] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym___restrict__] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym__Noreturn] = ACTIONS(5623),
    [anon_sym_noreturn] = ACTIONS(5623),
    [anon_sym__Nonnull] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_constinit] = ACTIONS(5623),
    [anon_sym_consteval] = ACTIONS(5623),
    [anon_sym_alignas] = ACTIONS(5623),
    [anon_sym__Alignas] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_class] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_decltype] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_private] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_operator] = ACTIONS(5623),
    [anon_sym_friend] = ACTIONS(5623),
    [anon_sym_public] = ACTIONS(5623),
    [anon_sym_protected] = ACTIONS(5623),
    [anon_sym_static_assert] = ACTIONS(5623),
    [anon_sym_precise] = ACTIONS(5623),
    [anon_sym_shared] = ACTIONS(5623),
    [anon_sym_groupshared] = ACTIONS(5623),
    [anon_sym_uniform] = ACTIONS(5623),
    [anon_sym_row_major] = ACTIONS(5623),
    [anon_sym_column_major] = ACTIONS(5623),
    [anon_sym_globallycoherent] = ACTIONS(5623),
    [anon_sym_centroid] = ACTIONS(5623),
    [anon_sym_noperspective] = ACTIONS(5623),
    [anon_sym_nointerpolation] = ACTIONS(5623),
    [anon_sym_sample] = ACTIONS(5623),
    [anon_sym_linear] = ACTIONS(5623),
    [anon_sym_snorm] = ACTIONS(5623),
    [anon_sym_unorm] = ACTIONS(5623),
    [anon_sym_point] = ACTIONS(5623),
    [anon_sym_line] = ACTIONS(5623),
    [anon_sym_triangleadj] = ACTIONS(5623),
    [anon_sym_lineadj] = ACTIONS(5623),
    [anon_sym_triangle] = ACTIONS(5623),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2494),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(5627),
    [aux_sym_preproc_def_token1] = ACTIONS(5627),
    [aux_sym_preproc_if_token1] = ACTIONS(5627),
    [aux_sym_preproc_if_token2] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5627),
    [sym_preproc_directive] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5629),
    [anon_sym_TILDE] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5629),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_AMP] = ACTIONS(5627),
    [anon_sym_SEMI] = ACTIONS(5629),
    [anon_sym___extension__] = ACTIONS(5627),
    [anon_sym_typedef] = ACTIONS(5627),
    [anon_sym_in] = ACTIONS(5627),
    [anon_sym_out] = ACTIONS(5627),
    [anon_sym_inout] = ACTIONS(5627),
    [anon_sym_virtual] = ACTIONS(5627),
    [anon_sym_extern] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5627),
    [anon_sym___attribute] = ACTIONS(5627),
    [anon_sym_using] = ACTIONS(5627),
    [anon_sym_COLON_COLON] = ACTIONS(5629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5629),
    [anon_sym___declspec] = ACTIONS(5627),
    [anon_sym___based] = ACTIONS(5627),
    [anon_sym_signed] = ACTIONS(5627),
    [anon_sym_unsigned] = ACTIONS(5627),
    [anon_sym_long] = ACTIONS(5627),
    [anon_sym_short] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_static] = ACTIONS(5627),
    [anon_sym_register] = ACTIONS(5627),
    [anon_sym_inline] = ACTIONS(5627),
    [anon_sym___inline] = ACTIONS(5627),
    [anon_sym___inline__] = ACTIONS(5627),
    [anon_sym___forceinline] = ACTIONS(5627),
    [anon_sym_thread_local] = ACTIONS(5627),
    [anon_sym___thread] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5627),
    [anon_sym_constexpr] = ACTIONS(5627),
    [anon_sym_volatile] = ACTIONS(5627),
    [anon_sym_restrict] = ACTIONS(5627),
    [anon_sym___restrict__] = ACTIONS(5627),
    [anon_sym__Atomic] = ACTIONS(5627),
    [anon_sym__Noreturn] = ACTIONS(5627),
    [anon_sym_noreturn] = ACTIONS(5627),
    [anon_sym__Nonnull] = ACTIONS(5627),
    [anon_sym_mutable] = ACTIONS(5627),
    [anon_sym_constinit] = ACTIONS(5627),
    [anon_sym_consteval] = ACTIONS(5627),
    [anon_sym_alignas] = ACTIONS(5627),
    [anon_sym__Alignas] = ACTIONS(5627),
    [sym_primitive_type] = ACTIONS(5627),
    [anon_sym_enum] = ACTIONS(5627),
    [anon_sym_class] = ACTIONS(5627),
    [anon_sym_struct] = ACTIONS(5627),
    [anon_sym_union] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5627),
    [anon_sym_decltype] = ACTIONS(5627),
    [anon_sym_explicit] = ACTIONS(5627),
    [anon_sym_typename] = ACTIONS(5627),
    [anon_sym_private] = ACTIONS(5627),
    [anon_sym_template] = ACTIONS(5627),
    [anon_sym_operator] = ACTIONS(5627),
    [anon_sym_friend] = ACTIONS(5627),
    [anon_sym_public] = ACTIONS(5627),
    [anon_sym_protected] = ACTIONS(5627),
    [anon_sym_static_assert] = ACTIONS(5627),
    [anon_sym_precise] = ACTIONS(5627),
    [anon_sym_shared] = ACTIONS(5627),
    [anon_sym_groupshared] = ACTIONS(5627),
    [anon_sym_uniform] = ACTIONS(5627),
    [anon_sym_row_major] = ACTIONS(5627),
    [anon_sym_column_major] = ACTIONS(5627),
    [anon_sym_globallycoherent] = ACTIONS(5627),
    [anon_sym_centroid] = ACTIONS(5627),
    [anon_sym_noperspective] = ACTIONS(5627),
    [anon_sym_nointerpolation] = ACTIONS(5627),
    [anon_sym_sample] = ACTIONS(5627),
    [anon_sym_linear] = ACTIONS(5627),
    [anon_sym_snorm] = ACTIONS(5627),
    [anon_sym_unorm] = ACTIONS(5627),
    [anon_sym_point] = ACTIONS(5627),
    [anon_sym_line] = ACTIONS(5627),
    [anon_sym_triangleadj] = ACTIONS(5627),
    [anon_sym_lineadj] = ACTIONS(5627),
    [anon_sym_triangle] = ACTIONS(5627),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token2] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(5555),
    [aux_sym_preproc_def_token1] = ACTIONS(5555),
    [aux_sym_preproc_if_token1] = ACTIONS(5555),
    [aux_sym_preproc_if_token2] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5555),
    [sym_preproc_directive] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(5557),
    [anon_sym_TILDE] = ACTIONS(5557),
    [anon_sym_STAR] = ACTIONS(5557),
    [anon_sym_AMP_AMP] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5555),
    [anon_sym_SEMI] = ACTIONS(5557),
    [anon_sym___extension__] = ACTIONS(5555),
    [anon_sym_typedef] = ACTIONS(5555),
    [anon_sym_in] = ACTIONS(5555),
    [anon_sym_out] = ACTIONS(5555),
    [anon_sym_inout] = ACTIONS(5555),
    [anon_sym_virtual] = ACTIONS(5555),
    [anon_sym_extern] = ACTIONS(5555),
    [anon_sym___attribute__] = ACTIONS(5555),
    [anon_sym___attribute] = ACTIONS(5555),
    [anon_sym_using] = ACTIONS(5555),
    [anon_sym_COLON_COLON] = ACTIONS(5557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5557),
    [anon_sym___declspec] = ACTIONS(5555),
    [anon_sym___based] = ACTIONS(5555),
    [anon_sym_signed] = ACTIONS(5555),
    [anon_sym_unsigned] = ACTIONS(5555),
    [anon_sym_long] = ACTIONS(5555),
    [anon_sym_short] = ACTIONS(5555),
    [anon_sym_LBRACK] = ACTIONS(5555),
    [anon_sym_static] = ACTIONS(5555),
    [anon_sym_register] = ACTIONS(5555),
    [anon_sym_inline] = ACTIONS(5555),
    [anon_sym___inline] = ACTIONS(5555),
    [anon_sym___inline__] = ACTIONS(5555),
    [anon_sym___forceinline] = ACTIONS(5555),
    [anon_sym_thread_local] = ACTIONS(5555),
    [anon_sym___thread] = ACTIONS(5555),
    [anon_sym_const] = ACTIONS(5555),
    [anon_sym_constexpr] = ACTIONS(5555),
    [anon_sym_volatile] = ACTIONS(5555),
    [anon_sym_restrict] = ACTIONS(5555),
    [anon_sym___restrict__] = ACTIONS(5555),
    [anon_sym__Atomic] = ACTIONS(5555),
    [anon_sym__Noreturn] = ACTIONS(5555),
    [anon_sym_noreturn] = ACTIONS(5555),
    [anon_sym__Nonnull] = ACTIONS(5555),
    [anon_sym_mutable] = ACTIONS(5555),
    [anon_sym_constinit] = ACTIONS(5555),
    [anon_sym_consteval] = ACTIONS(5555),
    [anon_sym_alignas] = ACTIONS(5555),
    [anon_sym__Alignas] = ACTIONS(5555),
    [sym_primitive_type] = ACTIONS(5555),
    [anon_sym_enum] = ACTIONS(5555),
    [anon_sym_class] = ACTIONS(5555),
    [anon_sym_struct] = ACTIONS(5555),
    [anon_sym_union] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5555),
    [anon_sym_decltype] = ACTIONS(5555),
    [anon_sym_explicit] = ACTIONS(5555),
    [anon_sym_typename] = ACTIONS(5555),
    [anon_sym_private] = ACTIONS(5555),
    [anon_sym_template] = ACTIONS(5555),
    [anon_sym_operator] = ACTIONS(5555),
    [anon_sym_friend] = ACTIONS(5555),
    [anon_sym_public] = ACTIONS(5555),
    [anon_sym_protected] = ACTIONS(5555),
    [anon_sym_static_assert] = ACTIONS(5555),
    [anon_sym_precise] = ACTIONS(5555),
    [anon_sym_shared] = ACTIONS(5555),
    [anon_sym_groupshared] = ACTIONS(5555),
    [anon_sym_uniform] = ACTIONS(5555),
    [anon_sym_row_major] = ACTIONS(5555),
    [anon_sym_column_major] = ACTIONS(5555),
    [anon_sym_globallycoherent] = ACTIONS(5555),
    [anon_sym_centroid] = ACTIONS(5555),
    [anon_sym_noperspective] = ACTIONS(5555),
    [anon_sym_nointerpolation] = ACTIONS(5555),
    [anon_sym_sample] = ACTIONS(5555),
    [anon_sym_linear] = ACTIONS(5555),
    [anon_sym_snorm] = ACTIONS(5555),
    [anon_sym_unorm] = ACTIONS(5555),
    [anon_sym_point] = ACTIONS(5555),
    [anon_sym_line] = ACTIONS(5555),
    [anon_sym_triangleadj] = ACTIONS(5555),
    [anon_sym_lineadj] = ACTIONS(5555),
    [anon_sym_triangle] = ACTIONS(5555),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2558),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(5559),
    [aux_sym_preproc_def_token1] = ACTIONS(5559),
    [aux_sym_preproc_if_token1] = ACTIONS(5559),
    [aux_sym_preproc_if_token2] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5559),
    [sym_preproc_directive] = ACTIONS(5559),
    [anon_sym_LPAREN2] = ACTIONS(5561),
    [anon_sym_TILDE] = ACTIONS(5561),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP_AMP] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5559),
    [anon_sym_typedef] = ACTIONS(5559),
    [anon_sym_in] = ACTIONS(5559),
    [anon_sym_out] = ACTIONS(5559),
    [anon_sym_inout] = ACTIONS(5559),
    [anon_sym_virtual] = ACTIONS(5559),
    [anon_sym_extern] = ACTIONS(5559),
    [anon_sym___attribute__] = ACTIONS(5559),
    [anon_sym___attribute] = ACTIONS(5559),
    [anon_sym_using] = ACTIONS(5559),
    [anon_sym_COLON_COLON] = ACTIONS(5561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5561),
    [anon_sym___declspec] = ACTIONS(5559),
    [anon_sym___based] = ACTIONS(5559),
    [anon_sym_signed] = ACTIONS(5559),
    [anon_sym_unsigned] = ACTIONS(5559),
    [anon_sym_long] = ACTIONS(5559),
    [anon_sym_short] = ACTIONS(5559),
    [anon_sym_LBRACK] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_register] = ACTIONS(5559),
    [anon_sym_inline] = ACTIONS(5559),
    [anon_sym___inline] = ACTIONS(5559),
    [anon_sym___inline__] = ACTIONS(5559),
    [anon_sym___forceinline] = ACTIONS(5559),
    [anon_sym_thread_local] = ACTIONS(5559),
    [anon_sym___thread] = ACTIONS(5559),
    [anon_sym_const] = ACTIONS(5559),
    [anon_sym_constexpr] = ACTIONS(5559),
    [anon_sym_volatile] = ACTIONS(5559),
    [anon_sym_restrict] = ACTIONS(5559),
    [anon_sym___restrict__] = ACTIONS(5559),
    [anon_sym__Atomic] = ACTIONS(5559),
    [anon_sym__Noreturn] = ACTIONS(5559),
    [anon_sym_noreturn] = ACTIONS(5559),
    [anon_sym__Nonnull] = ACTIONS(5559),
    [anon_sym_mutable] = ACTIONS(5559),
    [anon_sym_constinit] = ACTIONS(5559),
    [anon_sym_consteval] = ACTIONS(5559),
    [anon_sym_alignas] = ACTIONS(5559),
    [anon_sym__Alignas] = ACTIONS(5559),
    [sym_primitive_type] = ACTIONS(5559),
    [anon_sym_enum] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(5559),
    [anon_sym_struct] = ACTIONS(5559),
    [anon_sym_union] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5559),
    [anon_sym_decltype] = ACTIONS(5559),
    [anon_sym_explicit] = ACTIONS(5559),
    [anon_sym_typename] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_template] = ACTIONS(5559),
    [anon_sym_operator] = ACTIONS(5559),
    [anon_sym_friend] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_static_assert] = ACTIONS(5559),
    [anon_sym_precise] = ACTIONS(5559),
    [anon_sym_shared] = ACTIONS(5559),
    [anon_sym_groupshared] = ACTIONS(5559),
    [anon_sym_uniform] = ACTIONS(5559),
    [anon_sym_row_major] = ACTIONS(5559),
    [anon_sym_column_major] = ACTIONS(5559),
    [anon_sym_globallycoherent] = ACTIONS(5559),
    [anon_sym_centroid] = ACTIONS(5559),
    [anon_sym_noperspective] = ACTIONS(5559),
    [anon_sym_nointerpolation] = ACTIONS(5559),
    [anon_sym_sample] = ACTIONS(5559),
    [anon_sym_linear] = ACTIONS(5559),
    [anon_sym_snorm] = ACTIONS(5559),
    [anon_sym_unorm] = ACTIONS(5559),
    [anon_sym_point] = ACTIONS(5559),
    [anon_sym_line] = ACTIONS(5559),
    [anon_sym_triangleadj] = ACTIONS(5559),
    [anon_sym_lineadj] = ACTIONS(5559),
    [anon_sym_triangle] = ACTIONS(5559),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token2] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token2] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_friend] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2678),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [2089] = {
    [sym_string_literal] = STATE(2670),
    [sym_template_argument_list] = STATE(2512),
    [sym_raw_string_literal] = STATE(2670),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [anon_sym_LPAREN2] = ACTIONS(4219),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym___extension__] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(5668),
    [anon_sym_unsigned] = ACTIONS(5668),
    [anon_sym_long] = ACTIONS(5668),
    [anon_sym_short] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(4243),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4223),
    [anon_sym_volatile] = ACTIONS(4223),
    [anon_sym_restrict] = ACTIONS(4223),
    [anon_sym___restrict__] = ACTIONS(4223),
    [anon_sym__Atomic] = ACTIONS(4223),
    [anon_sym__Noreturn] = ACTIONS(4223),
    [anon_sym_noreturn] = ACTIONS(4223),
    [anon_sym__Nonnull] = ACTIONS(4223),
    [anon_sym_mutable] = ACTIONS(4223),
    [anon_sym_constinit] = ACTIONS(4223),
    [anon_sym_consteval] = ACTIONS(4223),
    [anon_sym_alignas] = ACTIONS(4223),
    [anon_sym__Alignas] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4223),
    [anon_sym_decltype] = ACTIONS(4223),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2506),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_friend] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(5619),
    [aux_sym_preproc_def_token1] = ACTIONS(5619),
    [aux_sym_preproc_if_token1] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5619),
    [sym_preproc_directive] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_AMP] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym___extension__] = ACTIONS(5619),
    [anon_sym_typedef] = ACTIONS(5619),
    [anon_sym_in] = ACTIONS(5619),
    [anon_sym_out] = ACTIONS(5619),
    [anon_sym_inout] = ACTIONS(5619),
    [anon_sym_virtual] = ACTIONS(5619),
    [anon_sym_extern] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5619),
    [anon_sym___attribute] = ACTIONS(5619),
    [anon_sym_using] = ACTIONS(5619),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5621),
    [anon_sym___declspec] = ACTIONS(5619),
    [anon_sym___based] = ACTIONS(5619),
    [anon_sym_RBRACE] = ACTIONS(5621),
    [anon_sym_signed] = ACTIONS(5619),
    [anon_sym_unsigned] = ACTIONS(5619),
    [anon_sym_long] = ACTIONS(5619),
    [anon_sym_short] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_static] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5619),
    [anon_sym_inline] = ACTIONS(5619),
    [anon_sym___inline] = ACTIONS(5619),
    [anon_sym___inline__] = ACTIONS(5619),
    [anon_sym___forceinline] = ACTIONS(5619),
    [anon_sym_thread_local] = ACTIONS(5619),
    [anon_sym___thread] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5619),
    [anon_sym_constexpr] = ACTIONS(5619),
    [anon_sym_volatile] = ACTIONS(5619),
    [anon_sym_restrict] = ACTIONS(5619),
    [anon_sym___restrict__] = ACTIONS(5619),
    [anon_sym__Atomic] = ACTIONS(5619),
    [anon_sym__Noreturn] = ACTIONS(5619),
    [anon_sym_noreturn] = ACTIONS(5619),
    [anon_sym__Nonnull] = ACTIONS(5619),
    [anon_sym_mutable] = ACTIONS(5619),
    [anon_sym_constinit] = ACTIONS(5619),
    [anon_sym_consteval] = ACTIONS(5619),
    [anon_sym_alignas] = ACTIONS(5619),
    [anon_sym__Alignas] = ACTIONS(5619),
    [sym_primitive_type] = ACTIONS(5619),
    [anon_sym_enum] = ACTIONS(5619),
    [anon_sym_class] = ACTIONS(5619),
    [anon_sym_struct] = ACTIONS(5619),
    [anon_sym_union] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5619),
    [anon_sym_decltype] = ACTIONS(5619),
    [anon_sym_explicit] = ACTIONS(5619),
    [anon_sym_typename] = ACTIONS(5619),
    [anon_sym_private] = ACTIONS(5619),
    [anon_sym_template] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5619),
    [anon_sym_friend] = ACTIONS(5619),
    [anon_sym_public] = ACTIONS(5619),
    [anon_sym_protected] = ACTIONS(5619),
    [anon_sym_static_assert] = ACTIONS(5619),
    [anon_sym_precise] = ACTIONS(5619),
    [anon_sym_shared] = ACTIONS(5619),
    [anon_sym_groupshared] = ACTIONS(5619),
    [anon_sym_uniform] = ACTIONS(5619),
    [anon_sym_row_major] = ACTIONS(5619),
    [anon_sym_column_major] = ACTIONS(5619),
    [anon_sym_globallycoherent] = ACTIONS(5619),
    [anon_sym_centroid] = ACTIONS(5619),
    [anon_sym_noperspective] = ACTIONS(5619),
    [anon_sym_nointerpolation] = ACTIONS(5619),
    [anon_sym_sample] = ACTIONS(5619),
    [anon_sym_linear] = ACTIONS(5619),
    [anon_sym_snorm] = ACTIONS(5619),
    [anon_sym_unorm] = ACTIONS(5619),
    [anon_sym_point] = ACTIONS(5619),
    [anon_sym_line] = ACTIONS(5619),
    [anon_sym_triangleadj] = ACTIONS(5619),
    [anon_sym_lineadj] = ACTIONS(5619),
    [anon_sym_triangle] = ACTIONS(5619),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_friend] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(5583),
    [aux_sym_preproc_def_token1] = ACTIONS(5583),
    [aux_sym_preproc_if_token1] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5583),
    [sym_preproc_directive] = ACTIONS(5583),
    [anon_sym_LPAREN2] = ACTIONS(5585),
    [anon_sym_TILDE] = ACTIONS(5585),
    [anon_sym_STAR] = ACTIONS(5585),
    [anon_sym_AMP_AMP] = ACTIONS(5585),
    [anon_sym_AMP] = ACTIONS(5583),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym___extension__] = ACTIONS(5583),
    [anon_sym_typedef] = ACTIONS(5583),
    [anon_sym_in] = ACTIONS(5583),
    [anon_sym_out] = ACTIONS(5583),
    [anon_sym_inout] = ACTIONS(5583),
    [anon_sym_virtual] = ACTIONS(5583),
    [anon_sym_extern] = ACTIONS(5583),
    [anon_sym___attribute__] = ACTIONS(5583),
    [anon_sym___attribute] = ACTIONS(5583),
    [anon_sym_using] = ACTIONS(5583),
    [anon_sym_COLON_COLON] = ACTIONS(5585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5585),
    [anon_sym___declspec] = ACTIONS(5583),
    [anon_sym___based] = ACTIONS(5583),
    [anon_sym_RBRACE] = ACTIONS(5585),
    [anon_sym_signed] = ACTIONS(5583),
    [anon_sym_unsigned] = ACTIONS(5583),
    [anon_sym_long] = ACTIONS(5583),
    [anon_sym_short] = ACTIONS(5583),
    [anon_sym_LBRACK] = ACTIONS(5583),
    [anon_sym_static] = ACTIONS(5583),
    [anon_sym_register] = ACTIONS(5583),
    [anon_sym_inline] = ACTIONS(5583),
    [anon_sym___inline] = ACTIONS(5583),
    [anon_sym___inline__] = ACTIONS(5583),
    [anon_sym___forceinline] = ACTIONS(5583),
    [anon_sym_thread_local] = ACTIONS(5583),
    [anon_sym___thread] = ACTIONS(5583),
    [anon_sym_const] = ACTIONS(5583),
    [anon_sym_constexpr] = ACTIONS(5583),
    [anon_sym_volatile] = ACTIONS(5583),
    [anon_sym_restrict] = ACTIONS(5583),
    [anon_sym___restrict__] = ACTIONS(5583),
    [anon_sym__Atomic] = ACTIONS(5583),
    [anon_sym__Noreturn] = ACTIONS(5583),
    [anon_sym_noreturn] = ACTIONS(5583),
    [anon_sym__Nonnull] = ACTIONS(5583),
    [anon_sym_mutable] = ACTIONS(5583),
    [anon_sym_constinit] = ACTIONS(5583),
    [anon_sym_consteval] = ACTIONS(5583),
    [anon_sym_alignas] = ACTIONS(5583),
    [anon_sym__Alignas] = ACTIONS(5583),
    [sym_primitive_type] = ACTIONS(5583),
    [anon_sym_enum] = ACTIONS(5583),
    [anon_sym_class] = ACTIONS(5583),
    [anon_sym_struct] = ACTIONS(5583),
    [anon_sym_union] = ACTIONS(5583),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5583),
    [anon_sym_decltype] = ACTIONS(5583),
    [anon_sym_explicit] = ACTIONS(5583),
    [anon_sym_typename] = ACTIONS(5583),
    [anon_sym_private] = ACTIONS(5583),
    [anon_sym_template] = ACTIONS(5583),
    [anon_sym_operator] = ACTIONS(5583),
    [anon_sym_friend] = ACTIONS(5583),
    [anon_sym_public] = ACTIONS(5583),
    [anon_sym_protected] = ACTIONS(5583),
    [anon_sym_static_assert] = ACTIONS(5583),
    [anon_sym_precise] = ACTIONS(5583),
    [anon_sym_shared] = ACTIONS(5583),
    [anon_sym_groupshared] = ACTIONS(5583),
    [anon_sym_uniform] = ACTIONS(5583),
    [anon_sym_row_major] = ACTIONS(5583),
    [anon_sym_column_major] = ACTIONS(5583),
    [anon_sym_globallycoherent] = ACTIONS(5583),
    [anon_sym_centroid] = ACTIONS(5583),
    [anon_sym_noperspective] = ACTIONS(5583),
    [anon_sym_nointerpolation] = ACTIONS(5583),
    [anon_sym_sample] = ACTIONS(5583),
    [anon_sym_linear] = ACTIONS(5583),
    [anon_sym_snorm] = ACTIONS(5583),
    [anon_sym_unorm] = ACTIONS(5583),
    [anon_sym_point] = ACTIONS(5583),
    [anon_sym_line] = ACTIONS(5583),
    [anon_sym_triangleadj] = ACTIONS(5583),
    [anon_sym_lineadj] = ACTIONS(5583),
    [anon_sym_triangle] = ACTIONS(5583),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_friend] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(5587),
    [aux_sym_preproc_def_token1] = ACTIONS(5587),
    [aux_sym_preproc_if_token1] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5587),
    [sym_preproc_directive] = ACTIONS(5587),
    [anon_sym_LPAREN2] = ACTIONS(5589),
    [anon_sym_TILDE] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_AMP_AMP] = ACTIONS(5589),
    [anon_sym_AMP] = ACTIONS(5587),
    [anon_sym_SEMI] = ACTIONS(5589),
    [anon_sym___extension__] = ACTIONS(5587),
    [anon_sym_typedef] = ACTIONS(5587),
    [anon_sym_in] = ACTIONS(5587),
    [anon_sym_out] = ACTIONS(5587),
    [anon_sym_inout] = ACTIONS(5587),
    [anon_sym_virtual] = ACTIONS(5587),
    [anon_sym_extern] = ACTIONS(5587),
    [anon_sym___attribute__] = ACTIONS(5587),
    [anon_sym___attribute] = ACTIONS(5587),
    [anon_sym_using] = ACTIONS(5587),
    [anon_sym_COLON_COLON] = ACTIONS(5589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5589),
    [anon_sym___declspec] = ACTIONS(5587),
    [anon_sym___based] = ACTIONS(5587),
    [anon_sym_RBRACE] = ACTIONS(5589),
    [anon_sym_signed] = ACTIONS(5587),
    [anon_sym_unsigned] = ACTIONS(5587),
    [anon_sym_long] = ACTIONS(5587),
    [anon_sym_short] = ACTIONS(5587),
    [anon_sym_LBRACK] = ACTIONS(5587),
    [anon_sym_static] = ACTIONS(5587),
    [anon_sym_register] = ACTIONS(5587),
    [anon_sym_inline] = ACTIONS(5587),
    [anon_sym___inline] = ACTIONS(5587),
    [anon_sym___inline__] = ACTIONS(5587),
    [anon_sym___forceinline] = ACTIONS(5587),
    [anon_sym_thread_local] = ACTIONS(5587),
    [anon_sym___thread] = ACTIONS(5587),
    [anon_sym_const] = ACTIONS(5587),
    [anon_sym_constexpr] = ACTIONS(5587),
    [anon_sym_volatile] = ACTIONS(5587),
    [anon_sym_restrict] = ACTIONS(5587),
    [anon_sym___restrict__] = ACTIONS(5587),
    [anon_sym__Atomic] = ACTIONS(5587),
    [anon_sym__Noreturn] = ACTIONS(5587),
    [anon_sym_noreturn] = ACTIONS(5587),
    [anon_sym__Nonnull] = ACTIONS(5587),
    [anon_sym_mutable] = ACTIONS(5587),
    [anon_sym_constinit] = ACTIONS(5587),
    [anon_sym_consteval] = ACTIONS(5587),
    [anon_sym_alignas] = ACTIONS(5587),
    [anon_sym__Alignas] = ACTIONS(5587),
    [sym_primitive_type] = ACTIONS(5587),
    [anon_sym_enum] = ACTIONS(5587),
    [anon_sym_class] = ACTIONS(5587),
    [anon_sym_struct] = ACTIONS(5587),
    [anon_sym_union] = ACTIONS(5587),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5587),
    [anon_sym_decltype] = ACTIONS(5587),
    [anon_sym_explicit] = ACTIONS(5587),
    [anon_sym_typename] = ACTIONS(5587),
    [anon_sym_private] = ACTIONS(5587),
    [anon_sym_template] = ACTIONS(5587),
    [anon_sym_operator] = ACTIONS(5587),
    [anon_sym_friend] = ACTIONS(5587),
    [anon_sym_public] = ACTIONS(5587),
    [anon_sym_protected] = ACTIONS(5587),
    [anon_sym_static_assert] = ACTIONS(5587),
    [anon_sym_precise] = ACTIONS(5587),
    [anon_sym_shared] = ACTIONS(5587),
    [anon_sym_groupshared] = ACTIONS(5587),
    [anon_sym_uniform] = ACTIONS(5587),
    [anon_sym_row_major] = ACTIONS(5587),
    [anon_sym_column_major] = ACTIONS(5587),
    [anon_sym_globallycoherent] = ACTIONS(5587),
    [anon_sym_centroid] = ACTIONS(5587),
    [anon_sym_noperspective] = ACTIONS(5587),
    [anon_sym_nointerpolation] = ACTIONS(5587),
    [anon_sym_sample] = ACTIONS(5587),
    [anon_sym_linear] = ACTIONS(5587),
    [anon_sym_snorm] = ACTIONS(5587),
    [anon_sym_unorm] = ACTIONS(5587),
    [anon_sym_point] = ACTIONS(5587),
    [anon_sym_line] = ACTIONS(5587),
    [anon_sym_triangleadj] = ACTIONS(5587),
    [anon_sym_lineadj] = ACTIONS(5587),
    [anon_sym_triangle] = ACTIONS(5587),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(5591),
    [aux_sym_preproc_def_token1] = ACTIONS(5591),
    [aux_sym_preproc_if_token1] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5591),
    [sym_preproc_directive] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5593),
    [anon_sym_TILDE] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5591),
    [anon_sym_SEMI] = ACTIONS(5593),
    [anon_sym___extension__] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5591),
    [anon_sym_in] = ACTIONS(5591),
    [anon_sym_out] = ACTIONS(5591),
    [anon_sym_inout] = ACTIONS(5591),
    [anon_sym_virtual] = ACTIONS(5591),
    [anon_sym_extern] = ACTIONS(5591),
    [anon_sym___attribute__] = ACTIONS(5591),
    [anon_sym___attribute] = ACTIONS(5591),
    [anon_sym_using] = ACTIONS(5591),
    [anon_sym_COLON_COLON] = ACTIONS(5593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5593),
    [anon_sym___declspec] = ACTIONS(5591),
    [anon_sym___based] = ACTIONS(5591),
    [anon_sym_RBRACE] = ACTIONS(5593),
    [anon_sym_signed] = ACTIONS(5591),
    [anon_sym_unsigned] = ACTIONS(5591),
    [anon_sym_long] = ACTIONS(5591),
    [anon_sym_short] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5591),
    [anon_sym_register] = ACTIONS(5591),
    [anon_sym_inline] = ACTIONS(5591),
    [anon_sym___inline] = ACTIONS(5591),
    [anon_sym___inline__] = ACTIONS(5591),
    [anon_sym___forceinline] = ACTIONS(5591),
    [anon_sym_thread_local] = ACTIONS(5591),
    [anon_sym___thread] = ACTIONS(5591),
    [anon_sym_const] = ACTIONS(5591),
    [anon_sym_constexpr] = ACTIONS(5591),
    [anon_sym_volatile] = ACTIONS(5591),
    [anon_sym_restrict] = ACTIONS(5591),
    [anon_sym___restrict__] = ACTIONS(5591),
    [anon_sym__Atomic] = ACTIONS(5591),
    [anon_sym__Noreturn] = ACTIONS(5591),
    [anon_sym_noreturn] = ACTIONS(5591),
    [anon_sym__Nonnull] = ACTIONS(5591),
    [anon_sym_mutable] = ACTIONS(5591),
    [anon_sym_constinit] = ACTIONS(5591),
    [anon_sym_consteval] = ACTIONS(5591),
    [anon_sym_alignas] = ACTIONS(5591),
    [anon_sym__Alignas] = ACTIONS(5591),
    [sym_primitive_type] = ACTIONS(5591),
    [anon_sym_enum] = ACTIONS(5591),
    [anon_sym_class] = ACTIONS(5591),
    [anon_sym_struct] = ACTIONS(5591),
    [anon_sym_union] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5591),
    [anon_sym_decltype] = ACTIONS(5591),
    [anon_sym_explicit] = ACTIONS(5591),
    [anon_sym_typename] = ACTIONS(5591),
    [anon_sym_private] = ACTIONS(5591),
    [anon_sym_template] = ACTIONS(5591),
    [anon_sym_operator] = ACTIONS(5591),
    [anon_sym_friend] = ACTIONS(5591),
    [anon_sym_public] = ACTIONS(5591),
    [anon_sym_protected] = ACTIONS(5591),
    [anon_sym_static_assert] = ACTIONS(5591),
    [anon_sym_precise] = ACTIONS(5591),
    [anon_sym_shared] = ACTIONS(5591),
    [anon_sym_groupshared] = ACTIONS(5591),
    [anon_sym_uniform] = ACTIONS(5591),
    [anon_sym_row_major] = ACTIONS(5591),
    [anon_sym_column_major] = ACTIONS(5591),
    [anon_sym_globallycoherent] = ACTIONS(5591),
    [anon_sym_centroid] = ACTIONS(5591),
    [anon_sym_noperspective] = ACTIONS(5591),
    [anon_sym_nointerpolation] = ACTIONS(5591),
    [anon_sym_sample] = ACTIONS(5591),
    [anon_sym_linear] = ACTIONS(5591),
    [anon_sym_snorm] = ACTIONS(5591),
    [anon_sym_unorm] = ACTIONS(5591),
    [anon_sym_point] = ACTIONS(5591),
    [anon_sym_line] = ACTIONS(5591),
    [anon_sym_triangleadj] = ACTIONS(5591),
    [anon_sym_lineadj] = ACTIONS(5591),
    [anon_sym_triangle] = ACTIONS(5591),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(5535),
    [aux_sym_preproc_def_token1] = ACTIONS(5535),
    [aux_sym_preproc_if_token1] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5535),
    [sym_preproc_directive] = ACTIONS(5535),
    [anon_sym_LPAREN2] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_AMP_AMP] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5535),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym___extension__] = ACTIONS(5535),
    [anon_sym_typedef] = ACTIONS(5535),
    [anon_sym_in] = ACTIONS(5535),
    [anon_sym_out] = ACTIONS(5535),
    [anon_sym_inout] = ACTIONS(5535),
    [anon_sym_virtual] = ACTIONS(5535),
    [anon_sym_extern] = ACTIONS(5535),
    [anon_sym___attribute__] = ACTIONS(5535),
    [anon_sym___attribute] = ACTIONS(5535),
    [anon_sym_using] = ACTIONS(5535),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5537),
    [anon_sym___declspec] = ACTIONS(5535),
    [anon_sym___based] = ACTIONS(5535),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [anon_sym_signed] = ACTIONS(5535),
    [anon_sym_unsigned] = ACTIONS(5535),
    [anon_sym_long] = ACTIONS(5535),
    [anon_sym_short] = ACTIONS(5535),
    [anon_sym_LBRACK] = ACTIONS(5535),
    [anon_sym_static] = ACTIONS(5535),
    [anon_sym_register] = ACTIONS(5535),
    [anon_sym_inline] = ACTIONS(5535),
    [anon_sym___inline] = ACTIONS(5535),
    [anon_sym___inline__] = ACTIONS(5535),
    [anon_sym___forceinline] = ACTIONS(5535),
    [anon_sym_thread_local] = ACTIONS(5535),
    [anon_sym___thread] = ACTIONS(5535),
    [anon_sym_const] = ACTIONS(5535),
    [anon_sym_constexpr] = ACTIONS(5535),
    [anon_sym_volatile] = ACTIONS(5535),
    [anon_sym_restrict] = ACTIONS(5535),
    [anon_sym___restrict__] = ACTIONS(5535),
    [anon_sym__Atomic] = ACTIONS(5535),
    [anon_sym__Noreturn] = ACTIONS(5535),
    [anon_sym_noreturn] = ACTIONS(5535),
    [anon_sym__Nonnull] = ACTIONS(5535),
    [anon_sym_mutable] = ACTIONS(5535),
    [anon_sym_constinit] = ACTIONS(5535),
    [anon_sym_consteval] = ACTIONS(5535),
    [anon_sym_alignas] = ACTIONS(5535),
    [anon_sym__Alignas] = ACTIONS(5535),
    [sym_primitive_type] = ACTIONS(5535),
    [anon_sym_enum] = ACTIONS(5535),
    [anon_sym_class] = ACTIONS(5535),
    [anon_sym_struct] = ACTIONS(5535),
    [anon_sym_union] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5535),
    [anon_sym_decltype] = ACTIONS(5535),
    [anon_sym_explicit] = ACTIONS(5535),
    [anon_sym_typename] = ACTIONS(5535),
    [anon_sym_private] = ACTIONS(5535),
    [anon_sym_template] = ACTIONS(5535),
    [anon_sym_operator] = ACTIONS(5535),
    [anon_sym_friend] = ACTIONS(5535),
    [anon_sym_public] = ACTIONS(5535),
    [anon_sym_protected] = ACTIONS(5535),
    [anon_sym_static_assert] = ACTIONS(5535),
    [anon_sym_precise] = ACTIONS(5535),
    [anon_sym_shared] = ACTIONS(5535),
    [anon_sym_groupshared] = ACTIONS(5535),
    [anon_sym_uniform] = ACTIONS(5535),
    [anon_sym_row_major] = ACTIONS(5535),
    [anon_sym_column_major] = ACTIONS(5535),
    [anon_sym_globallycoherent] = ACTIONS(5535),
    [anon_sym_centroid] = ACTIONS(5535),
    [anon_sym_noperspective] = ACTIONS(5535),
    [anon_sym_nointerpolation] = ACTIONS(5535),
    [anon_sym_sample] = ACTIONS(5535),
    [anon_sym_linear] = ACTIONS(5535),
    [anon_sym_snorm] = ACTIONS(5535),
    [anon_sym_unorm] = ACTIONS(5535),
    [anon_sym_point] = ACTIONS(5535),
    [anon_sym_line] = ACTIONS(5535),
    [anon_sym_triangleadj] = ACTIONS(5535),
    [anon_sym_lineadj] = ACTIONS(5535),
    [anon_sym_triangle] = ACTIONS(5535),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2518),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_friend] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2522),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_private] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_friend] = ACTIONS(2520),
    [anon_sym_public] = ACTIONS(2520),
    [anon_sym_protected] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_friend] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2542),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_friend] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2550),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_friend] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_RBRACE] = ACTIONS(5601),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_RBRACE] = ACTIONS(5601),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2574),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_friend] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(5603),
    [aux_sym_preproc_def_token1] = ACTIONS(5603),
    [aux_sym_preproc_if_token1] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5603),
    [sym_preproc_directive] = ACTIONS(5603),
    [anon_sym_LPAREN2] = ACTIONS(5605),
    [anon_sym_TILDE] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5605),
    [anon_sym_AMP_AMP] = ACTIONS(5605),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_SEMI] = ACTIONS(5605),
    [anon_sym___extension__] = ACTIONS(5603),
    [anon_sym_typedef] = ACTIONS(5603),
    [anon_sym_in] = ACTIONS(5603),
    [anon_sym_out] = ACTIONS(5603),
    [anon_sym_inout] = ACTIONS(5603),
    [anon_sym_virtual] = ACTIONS(5603),
    [anon_sym_extern] = ACTIONS(5603),
    [anon_sym___attribute__] = ACTIONS(5603),
    [anon_sym___attribute] = ACTIONS(5603),
    [anon_sym_using] = ACTIONS(5603),
    [anon_sym_COLON_COLON] = ACTIONS(5605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5605),
    [anon_sym___declspec] = ACTIONS(5603),
    [anon_sym___based] = ACTIONS(5603),
    [anon_sym_RBRACE] = ACTIONS(5605),
    [anon_sym_signed] = ACTIONS(5603),
    [anon_sym_unsigned] = ACTIONS(5603),
    [anon_sym_long] = ACTIONS(5603),
    [anon_sym_short] = ACTIONS(5603),
    [anon_sym_LBRACK] = ACTIONS(5603),
    [anon_sym_static] = ACTIONS(5603),
    [anon_sym_register] = ACTIONS(5603),
    [anon_sym_inline] = ACTIONS(5603),
    [anon_sym___inline] = ACTIONS(5603),
    [anon_sym___inline__] = ACTIONS(5603),
    [anon_sym___forceinline] = ACTIONS(5603),
    [anon_sym_thread_local] = ACTIONS(5603),
    [anon_sym___thread] = ACTIONS(5603),
    [anon_sym_const] = ACTIONS(5603),
    [anon_sym_constexpr] = ACTIONS(5603),
    [anon_sym_volatile] = ACTIONS(5603),
    [anon_sym_restrict] = ACTIONS(5603),
    [anon_sym___restrict__] = ACTIONS(5603),
    [anon_sym__Atomic] = ACTIONS(5603),
    [anon_sym__Noreturn] = ACTIONS(5603),
    [anon_sym_noreturn] = ACTIONS(5603),
    [anon_sym__Nonnull] = ACTIONS(5603),
    [anon_sym_mutable] = ACTIONS(5603),
    [anon_sym_constinit] = ACTIONS(5603),
    [anon_sym_consteval] = ACTIONS(5603),
    [anon_sym_alignas] = ACTIONS(5603),
    [anon_sym__Alignas] = ACTIONS(5603),
    [sym_primitive_type] = ACTIONS(5603),
    [anon_sym_enum] = ACTIONS(5603),
    [anon_sym_class] = ACTIONS(5603),
    [anon_sym_struct] = ACTIONS(5603),
    [anon_sym_union] = ACTIONS(5603),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5603),
    [anon_sym_decltype] = ACTIONS(5603),
    [anon_sym_explicit] = ACTIONS(5603),
    [anon_sym_typename] = ACTIONS(5603),
    [anon_sym_private] = ACTIONS(5603),
    [anon_sym_template] = ACTIONS(5603),
    [anon_sym_operator] = ACTIONS(5603),
    [anon_sym_friend] = ACTIONS(5603),
    [anon_sym_public] = ACTIONS(5603),
    [anon_sym_protected] = ACTIONS(5603),
    [anon_sym_static_assert] = ACTIONS(5603),
    [anon_sym_precise] = ACTIONS(5603),
    [anon_sym_shared] = ACTIONS(5603),
    [anon_sym_groupshared] = ACTIONS(5603),
    [anon_sym_uniform] = ACTIONS(5603),
    [anon_sym_row_major] = ACTIONS(5603),
    [anon_sym_column_major] = ACTIONS(5603),
    [anon_sym_globallycoherent] = ACTIONS(5603),
    [anon_sym_centroid] = ACTIONS(5603),
    [anon_sym_noperspective] = ACTIONS(5603),
    [anon_sym_nointerpolation] = ACTIONS(5603),
    [anon_sym_sample] = ACTIONS(5603),
    [anon_sym_linear] = ACTIONS(5603),
    [anon_sym_snorm] = ACTIONS(5603),
    [anon_sym_unorm] = ACTIONS(5603),
    [anon_sym_point] = ACTIONS(5603),
    [anon_sym_line] = ACTIONS(5603),
    [anon_sym_triangleadj] = ACTIONS(5603),
    [anon_sym_lineadj] = ACTIONS(5603),
    [anon_sym_triangle] = ACTIONS(5603),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_private] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_friend] = ACTIONS(2612),
    [anon_sym_public] = ACTIONS(2612),
    [anon_sym_protected] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_RBRACE] = ACTIONS(5601),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_private] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_friend] = ACTIONS(2616),
    [anon_sym_public] = ACTIONS(2616),
    [anon_sym_protected] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_RBRACE] = ACTIONS(2161),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_private] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_friend] = ACTIONS(2620),
    [anon_sym_public] = ACTIONS(2620),
    [anon_sym_protected] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_friend] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_friend] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_friend] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_friend] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(5607),
    [aux_sym_preproc_def_token1] = ACTIONS(5607),
    [aux_sym_preproc_if_token1] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5607),
    [sym_preproc_directive] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5609),
    [anon_sym_TILDE] = ACTIONS(5609),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_AMP_AMP] = ACTIONS(5609),
    [anon_sym_AMP] = ACTIONS(5607),
    [anon_sym_SEMI] = ACTIONS(5609),
    [anon_sym___extension__] = ACTIONS(5607),
    [anon_sym_typedef] = ACTIONS(5607),
    [anon_sym_in] = ACTIONS(5607),
    [anon_sym_out] = ACTIONS(5607),
    [anon_sym_inout] = ACTIONS(5607),
    [anon_sym_virtual] = ACTIONS(5607),
    [anon_sym_extern] = ACTIONS(5607),
    [anon_sym___attribute__] = ACTIONS(5607),
    [anon_sym___attribute] = ACTIONS(5607),
    [anon_sym_using] = ACTIONS(5607),
    [anon_sym_COLON_COLON] = ACTIONS(5609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5609),
    [anon_sym___declspec] = ACTIONS(5607),
    [anon_sym___based] = ACTIONS(5607),
    [anon_sym_RBRACE] = ACTIONS(5609),
    [anon_sym_signed] = ACTIONS(5607),
    [anon_sym_unsigned] = ACTIONS(5607),
    [anon_sym_long] = ACTIONS(5607),
    [anon_sym_short] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_static] = ACTIONS(5607),
    [anon_sym_register] = ACTIONS(5607),
    [anon_sym_inline] = ACTIONS(5607),
    [anon_sym___inline] = ACTIONS(5607),
    [anon_sym___inline__] = ACTIONS(5607),
    [anon_sym___forceinline] = ACTIONS(5607),
    [anon_sym_thread_local] = ACTIONS(5607),
    [anon_sym___thread] = ACTIONS(5607),
    [anon_sym_const] = ACTIONS(5607),
    [anon_sym_constexpr] = ACTIONS(5607),
    [anon_sym_volatile] = ACTIONS(5607),
    [anon_sym_restrict] = ACTIONS(5607),
    [anon_sym___restrict__] = ACTIONS(5607),
    [anon_sym__Atomic] = ACTIONS(5607),
    [anon_sym__Noreturn] = ACTIONS(5607),
    [anon_sym_noreturn] = ACTIONS(5607),
    [anon_sym__Nonnull] = ACTIONS(5607),
    [anon_sym_mutable] = ACTIONS(5607),
    [anon_sym_constinit] = ACTIONS(5607),
    [anon_sym_consteval] = ACTIONS(5607),
    [anon_sym_alignas] = ACTIONS(5607),
    [anon_sym__Alignas] = ACTIONS(5607),
    [sym_primitive_type] = ACTIONS(5607),
    [anon_sym_enum] = ACTIONS(5607),
    [anon_sym_class] = ACTIONS(5607),
    [anon_sym_struct] = ACTIONS(5607),
    [anon_sym_union] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5607),
    [anon_sym_decltype] = ACTIONS(5607),
    [anon_sym_explicit] = ACTIONS(5607),
    [anon_sym_typename] = ACTIONS(5607),
    [anon_sym_private] = ACTIONS(5607),
    [anon_sym_template] = ACTIONS(5607),
    [anon_sym_operator] = ACTIONS(5607),
    [anon_sym_friend] = ACTIONS(5607),
    [anon_sym_public] = ACTIONS(5607),
    [anon_sym_protected] = ACTIONS(5607),
    [anon_sym_static_assert] = ACTIONS(5607),
    [anon_sym_precise] = ACTIONS(5607),
    [anon_sym_shared] = ACTIONS(5607),
    [anon_sym_groupshared] = ACTIONS(5607),
    [anon_sym_uniform] = ACTIONS(5607),
    [anon_sym_row_major] = ACTIONS(5607),
    [anon_sym_column_major] = ACTIONS(5607),
    [anon_sym_globallycoherent] = ACTIONS(5607),
    [anon_sym_centroid] = ACTIONS(5607),
    [anon_sym_noperspective] = ACTIONS(5607),
    [anon_sym_nointerpolation] = ACTIONS(5607),
    [anon_sym_sample] = ACTIONS(5607),
    [anon_sym_linear] = ACTIONS(5607),
    [anon_sym_snorm] = ACTIONS(5607),
    [anon_sym_unorm] = ACTIONS(5607),
    [anon_sym_point] = ACTIONS(5607),
    [anon_sym_line] = ACTIONS(5607),
    [anon_sym_triangleadj] = ACTIONS(5607),
    [anon_sym_lineadj] = ACTIONS(5607),
    [anon_sym_triangle] = ACTIONS(5607),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_friend] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2654),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_private] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_friend] = ACTIONS(2652),
    [anon_sym_public] = ACTIONS(2652),
    [anon_sym_protected] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(5611),
    [aux_sym_preproc_def_token1] = ACTIONS(5611),
    [aux_sym_preproc_if_token1] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5611),
    [sym_preproc_directive] = ACTIONS(5611),
    [anon_sym_LPAREN2] = ACTIONS(5613),
    [anon_sym_TILDE] = ACTIONS(5613),
    [anon_sym_STAR] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_AMP] = ACTIONS(5611),
    [anon_sym_SEMI] = ACTIONS(5613),
    [anon_sym___extension__] = ACTIONS(5611),
    [anon_sym_typedef] = ACTIONS(5611),
    [anon_sym_in] = ACTIONS(5611),
    [anon_sym_out] = ACTIONS(5611),
    [anon_sym_inout] = ACTIONS(5611),
    [anon_sym_virtual] = ACTIONS(5611),
    [anon_sym_extern] = ACTIONS(5611),
    [anon_sym___attribute__] = ACTIONS(5611),
    [anon_sym___attribute] = ACTIONS(5611),
    [anon_sym_using] = ACTIONS(5611),
    [anon_sym_COLON_COLON] = ACTIONS(5613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5613),
    [anon_sym___declspec] = ACTIONS(5611),
    [anon_sym___based] = ACTIONS(5611),
    [anon_sym_RBRACE] = ACTIONS(5613),
    [anon_sym_signed] = ACTIONS(5611),
    [anon_sym_unsigned] = ACTIONS(5611),
    [anon_sym_long] = ACTIONS(5611),
    [anon_sym_short] = ACTIONS(5611),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_static] = ACTIONS(5611),
    [anon_sym_register] = ACTIONS(5611),
    [anon_sym_inline] = ACTIONS(5611),
    [anon_sym___inline] = ACTIONS(5611),
    [anon_sym___inline__] = ACTIONS(5611),
    [anon_sym___forceinline] = ACTIONS(5611),
    [anon_sym_thread_local] = ACTIONS(5611),
    [anon_sym___thread] = ACTIONS(5611),
    [anon_sym_const] = ACTIONS(5611),
    [anon_sym_constexpr] = ACTIONS(5611),
    [anon_sym_volatile] = ACTIONS(5611),
    [anon_sym_restrict] = ACTIONS(5611),
    [anon_sym___restrict__] = ACTIONS(5611),
    [anon_sym__Atomic] = ACTIONS(5611),
    [anon_sym__Noreturn] = ACTIONS(5611),
    [anon_sym_noreturn] = ACTIONS(5611),
    [anon_sym__Nonnull] = ACTIONS(5611),
    [anon_sym_mutable] = ACTIONS(5611),
    [anon_sym_constinit] = ACTIONS(5611),
    [anon_sym_consteval] = ACTIONS(5611),
    [anon_sym_alignas] = ACTIONS(5611),
    [anon_sym__Alignas] = ACTIONS(5611),
    [sym_primitive_type] = ACTIONS(5611),
    [anon_sym_enum] = ACTIONS(5611),
    [anon_sym_class] = ACTIONS(5611),
    [anon_sym_struct] = ACTIONS(5611),
    [anon_sym_union] = ACTIONS(5611),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5611),
    [anon_sym_decltype] = ACTIONS(5611),
    [anon_sym_explicit] = ACTIONS(5611),
    [anon_sym_typename] = ACTIONS(5611),
    [anon_sym_private] = ACTIONS(5611),
    [anon_sym_template] = ACTIONS(5611),
    [anon_sym_operator] = ACTIONS(5611),
    [anon_sym_friend] = ACTIONS(5611),
    [anon_sym_public] = ACTIONS(5611),
    [anon_sym_protected] = ACTIONS(5611),
    [anon_sym_static_assert] = ACTIONS(5611),
    [anon_sym_precise] = ACTIONS(5611),
    [anon_sym_shared] = ACTIONS(5611),
    [anon_sym_groupshared] = ACTIONS(5611),
    [anon_sym_uniform] = ACTIONS(5611),
    [anon_sym_row_major] = ACTIONS(5611),
    [anon_sym_column_major] = ACTIONS(5611),
    [anon_sym_globallycoherent] = ACTIONS(5611),
    [anon_sym_centroid] = ACTIONS(5611),
    [anon_sym_noperspective] = ACTIONS(5611),
    [anon_sym_nointerpolation] = ACTIONS(5611),
    [anon_sym_sample] = ACTIONS(5611),
    [anon_sym_linear] = ACTIONS(5611),
    [anon_sym_snorm] = ACTIONS(5611),
    [anon_sym_unorm] = ACTIONS(5611),
    [anon_sym_point] = ACTIONS(5611),
    [anon_sym_line] = ACTIONS(5611),
    [anon_sym_triangleadj] = ACTIONS(5611),
    [anon_sym_lineadj] = ACTIONS(5611),
    [anon_sym_triangle] = ACTIONS(5611),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym_RBRACE] = ACTIONS(2435),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_friend] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_RBRACE] = ACTIONS(5597),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5617),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5617),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2130] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym_RBRACE] = ACTIONS(2244),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_friend] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
  },
  [2131] = {
    [sym_identifier] = ACTIONS(5623),
    [aux_sym_preproc_def_token1] = ACTIONS(5623),
    [aux_sym_preproc_if_token1] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5623),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5623),
    [sym_preproc_directive] = ACTIONS(5623),
    [anon_sym_LPAREN2] = ACTIONS(5625),
    [anon_sym_TILDE] = ACTIONS(5625),
    [anon_sym_STAR] = ACTIONS(5625),
    [anon_sym_AMP_AMP] = ACTIONS(5625),
    [anon_sym_AMP] = ACTIONS(5623),
    [anon_sym_SEMI] = ACTIONS(5625),
    [anon_sym___extension__] = ACTIONS(5623),
    [anon_sym_typedef] = ACTIONS(5623),
    [anon_sym_in] = ACTIONS(5623),
    [anon_sym_out] = ACTIONS(5623),
    [anon_sym_inout] = ACTIONS(5623),
    [anon_sym_virtual] = ACTIONS(5623),
    [anon_sym_extern] = ACTIONS(5623),
    [anon_sym___attribute__] = ACTIONS(5623),
    [anon_sym___attribute] = ACTIONS(5623),
    [anon_sym_using] = ACTIONS(5623),
    [anon_sym_COLON_COLON] = ACTIONS(5625),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5625),
    [anon_sym___declspec] = ACTIONS(5623),
    [anon_sym___based] = ACTIONS(5623),
    [anon_sym_RBRACE] = ACTIONS(5625),
    [anon_sym_signed] = ACTIONS(5623),
    [anon_sym_unsigned] = ACTIONS(5623),
    [anon_sym_long] = ACTIONS(5623),
    [anon_sym_short] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(5623),
    [anon_sym_static] = ACTIONS(5623),
    [anon_sym_register] = ACTIONS(5623),
    [anon_sym_inline] = ACTIONS(5623),
    [anon_sym___inline] = ACTIONS(5623),
    [anon_sym___inline__] = ACTIONS(5623),
    [anon_sym___forceinline] = ACTIONS(5623),
    [anon_sym_thread_local] = ACTIONS(5623),
    [anon_sym___thread] = ACTIONS(5623),
    [anon_sym_const] = ACTIONS(5623),
    [anon_sym_constexpr] = ACTIONS(5623),
    [anon_sym_volatile] = ACTIONS(5623),
    [anon_sym_restrict] = ACTIONS(5623),
    [anon_sym___restrict__] = ACTIONS(5623),
    [anon_sym__Atomic] = ACTIONS(5623),
    [anon_sym__Noreturn] = ACTIONS(5623),
    [anon_sym_noreturn] = ACTIONS(5623),
    [anon_sym__Nonnull] = ACTIONS(5623),
    [anon_sym_mutable] = ACTIONS(5623),
    [anon_sym_constinit] = ACTIONS(5623),
    [anon_sym_consteval] = ACTIONS(5623),
    [anon_sym_alignas] = ACTIONS(5623),
    [anon_sym__Alignas] = ACTIONS(5623),
    [sym_primitive_type] = ACTIONS(5623),
    [anon_sym_enum] = ACTIONS(5623),
    [anon_sym_class] = ACTIONS(5623),
    [anon_sym_struct] = ACTIONS(5623),
    [anon_sym_union] = ACTIONS(5623),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5623),
    [anon_sym_decltype] = ACTIONS(5623),
    [anon_sym_explicit] = ACTIONS(5623),
    [anon_sym_typename] = ACTIONS(5623),
    [anon_sym_private] = ACTIONS(5623),
    [anon_sym_template] = ACTIONS(5623),
    [anon_sym_operator] = ACTIONS(5623),
    [anon_sym_friend] = ACTIONS(5623),
    [anon_sym_public] = ACTIONS(5623),
    [anon_sym_protected] = ACTIONS(5623),
    [anon_sym_static_assert] = ACTIONS(5623),
    [anon_sym_precise] = ACTIONS(5623),
    [anon_sym_shared] = ACTIONS(5623),
    [anon_sym_groupshared] = ACTIONS(5623),
    [anon_sym_uniform] = ACTIONS(5623),
    [anon_sym_row_major] = ACTIONS(5623),
    [anon_sym_column_major] = ACTIONS(5623),
    [anon_sym_globallycoherent] = ACTIONS(5623),
    [anon_sym_centroid] = ACTIONS(5623),
    [anon_sym_noperspective] = ACTIONS(5623),
    [anon_sym_nointerpolation] = ACTIONS(5623),
    [anon_sym_sample] = ACTIONS(5623),
    [anon_sym_linear] = ACTIONS(5623),
    [anon_sym_snorm] = ACTIONS(5623),
    [anon_sym_unorm] = ACTIONS(5623),
    [anon_sym_point] = ACTIONS(5623),
    [anon_sym_line] = ACTIONS(5623),
    [anon_sym_triangleadj] = ACTIONS(5623),
    [anon_sym_lineadj] = ACTIONS(5623),
    [anon_sym_triangle] = ACTIONS(5623),
  },
  [2132] = {
    [sym_identifier] = ACTIONS(5627),
    [aux_sym_preproc_def_token1] = ACTIONS(5627),
    [aux_sym_preproc_if_token1] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5627),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5627),
    [sym_preproc_directive] = ACTIONS(5627),
    [anon_sym_LPAREN2] = ACTIONS(5629),
    [anon_sym_TILDE] = ACTIONS(5629),
    [anon_sym_STAR] = ACTIONS(5629),
    [anon_sym_AMP_AMP] = ACTIONS(5629),
    [anon_sym_AMP] = ACTIONS(5627),
    [anon_sym_SEMI] = ACTIONS(5629),
    [anon_sym___extension__] = ACTIONS(5627),
    [anon_sym_typedef] = ACTIONS(5627),
    [anon_sym_in] = ACTIONS(5627),
    [anon_sym_out] = ACTIONS(5627),
    [anon_sym_inout] = ACTIONS(5627),
    [anon_sym_virtual] = ACTIONS(5627),
    [anon_sym_extern] = ACTIONS(5627),
    [anon_sym___attribute__] = ACTIONS(5627),
    [anon_sym___attribute] = ACTIONS(5627),
    [anon_sym_using] = ACTIONS(5627),
    [anon_sym_COLON_COLON] = ACTIONS(5629),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5629),
    [anon_sym___declspec] = ACTIONS(5627),
    [anon_sym___based] = ACTIONS(5627),
    [anon_sym_RBRACE] = ACTIONS(5629),
    [anon_sym_signed] = ACTIONS(5627),
    [anon_sym_unsigned] = ACTIONS(5627),
    [anon_sym_long] = ACTIONS(5627),
    [anon_sym_short] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(5627),
    [anon_sym_static] = ACTIONS(5627),
    [anon_sym_register] = ACTIONS(5627),
    [anon_sym_inline] = ACTIONS(5627),
    [anon_sym___inline] = ACTIONS(5627),
    [anon_sym___inline__] = ACTIONS(5627),
    [anon_sym___forceinline] = ACTIONS(5627),
    [anon_sym_thread_local] = ACTIONS(5627),
    [anon_sym___thread] = ACTIONS(5627),
    [anon_sym_const] = ACTIONS(5627),
    [anon_sym_constexpr] = ACTIONS(5627),
    [anon_sym_volatile] = ACTIONS(5627),
    [anon_sym_restrict] = ACTIONS(5627),
    [anon_sym___restrict__] = ACTIONS(5627),
    [anon_sym__Atomic] = ACTIONS(5627),
    [anon_sym__Noreturn] = ACTIONS(5627),
    [anon_sym_noreturn] = ACTIONS(5627),
    [anon_sym__Nonnull] = ACTIONS(5627),
    [anon_sym_mutable] = ACTIONS(5627),
    [anon_sym_constinit] = ACTIONS(5627),
    [anon_sym_consteval] = ACTIONS(5627),
    [anon_sym_alignas] = ACTIONS(5627),
    [anon_sym__Alignas] = ACTIONS(5627),
    [sym_primitive_type] = ACTIONS(5627),
    [anon_sym_enum] = ACTIONS(5627),
    [anon_sym_class] = ACTIONS(5627),
    [anon_sym_struct] = ACTIONS(5627),
    [anon_sym_union] = ACTIONS(5627),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5627),
    [anon_sym_decltype] = ACTIONS(5627),
    [anon_sym_explicit] = ACTIONS(5627),
    [anon_sym_typename] = ACTIONS(5627),
    [anon_sym_private] = ACTIONS(5627),
    [anon_sym_template] = ACTIONS(5627),
    [anon_sym_operator] = ACTIONS(5627),
    [anon_sym_friend] = ACTIONS(5627),
    [anon_sym_public] = ACTIONS(5627),
    [anon_sym_protected] = ACTIONS(5627),
    [anon_sym_static_assert] = ACTIONS(5627),
    [anon_sym_precise] = ACTIONS(5627),
    [anon_sym_shared] = ACTIONS(5627),
    [anon_sym_groupshared] = ACTIONS(5627),
    [anon_sym_uniform] = ACTIONS(5627),
    [anon_sym_row_major] = ACTIONS(5627),
    [anon_sym_column_major] = ACTIONS(5627),
    [anon_sym_globallycoherent] = ACTIONS(5627),
    [anon_sym_centroid] = ACTIONS(5627),
    [anon_sym_noperspective] = ACTIONS(5627),
    [anon_sym_nointerpolation] = ACTIONS(5627),
    [anon_sym_sample] = ACTIONS(5627),
    [anon_sym_linear] = ACTIONS(5627),
    [anon_sym_snorm] = ACTIONS(5627),
    [anon_sym_unorm] = ACTIONS(5627),
    [anon_sym_point] = ACTIONS(5627),
    [anon_sym_line] = ACTIONS(5627),
    [anon_sym_triangleadj] = ACTIONS(5627),
    [anon_sym_lineadj] = ACTIONS(5627),
    [anon_sym_triangle] = ACTIONS(5627),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_private] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_friend] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(2429),
    [anon_sym_protected] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
  },
  [2134] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_friend] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
  },
  [2135] = {
    [sym_identifier] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_AMP_AMP] = ACTIONS(5676),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym___extension__] = ACTIONS(5674),
    [anon_sym_in] = ACTIONS(5674),
    [anon_sym_out] = ACTIONS(5674),
    [anon_sym_inout] = ACTIONS(5674),
    [anon_sym_virtual] = ACTIONS(5674),
    [anon_sym_extern] = ACTIONS(5674),
    [anon_sym___attribute__] = ACTIONS(5674),
    [anon_sym___attribute] = ACTIONS(5674),
    [anon_sym_using] = ACTIONS(5674),
    [anon_sym_COLON_COLON] = ACTIONS(5676),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5676),
    [anon_sym___declspec] = ACTIONS(5674),
    [anon_sym___based] = ACTIONS(5674),
    [anon_sym___cdecl] = ACTIONS(5674),
    [anon_sym___clrcall] = ACTIONS(5674),
    [anon_sym___stdcall] = ACTIONS(5674),
    [anon_sym___fastcall] = ACTIONS(5674),
    [anon_sym___thiscall] = ACTIONS(5674),
    [anon_sym___vectorcall] = ACTIONS(5674),
    [anon_sym_LBRACE] = ACTIONS(5676),
    [anon_sym_signed] = ACTIONS(5674),
    [anon_sym_unsigned] = ACTIONS(5674),
    [anon_sym_long] = ACTIONS(5674),
    [anon_sym_short] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_static] = ACTIONS(5674),
    [anon_sym_register] = ACTIONS(5674),
    [anon_sym_inline] = ACTIONS(5674),
    [anon_sym___inline] = ACTIONS(5674),
    [anon_sym___inline__] = ACTIONS(5674),
    [anon_sym___forceinline] = ACTIONS(5674),
    [anon_sym_thread_local] = ACTIONS(5674),
    [anon_sym___thread] = ACTIONS(5674),
    [anon_sym_const] = ACTIONS(5674),
    [anon_sym_constexpr] = ACTIONS(5674),
    [anon_sym_volatile] = ACTIONS(5674),
    [anon_sym_restrict] = ACTIONS(5674),
    [anon_sym___restrict__] = ACTIONS(5674),
    [anon_sym__Atomic] = ACTIONS(5674),
    [anon_sym__Noreturn] = ACTIONS(5674),
    [anon_sym_noreturn] = ACTIONS(5674),
    [anon_sym__Nonnull] = ACTIONS(5674),
    [anon_sym_mutable] = ACTIONS(5674),
    [anon_sym_constinit] = ACTIONS(5674),
    [anon_sym_consteval] = ACTIONS(5674),
    [anon_sym_alignas] = ACTIONS(5674),
    [anon_sym__Alignas] = ACTIONS(5674),
    [sym_primitive_type] = ACTIONS(5674),
    [anon_sym_enum] = ACTIONS(5674),
    [anon_sym_class] = ACTIONS(5674),
    [anon_sym_struct] = ACTIONS(5674),
    [anon_sym_union] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5674),
    [anon_sym_decltype] = ACTIONS(5674),
    [anon_sym_explicit] = ACTIONS(5674),
    [anon_sym_typename] = ACTIONS(5674),
    [anon_sym_template] = ACTIONS(5674),
    [anon_sym_operator] = ACTIONS(5674),
    [anon_sym_friend] = ACTIONS(5674),
    [anon_sym_noexcept] = ACTIONS(5674),
    [anon_sym_throw] = ACTIONS(5674),
    [anon_sym_concept] = ACTIONS(5674),
    [anon_sym_requires] = ACTIONS(5674),
    [anon_sym_precise] = ACTIONS(5674),
    [anon_sym_shared] = ACTIONS(5674),
    [anon_sym_groupshared] = ACTIONS(5674),
    [anon_sym_uniform] = ACTIONS(5674),
    [anon_sym_row_major] = ACTIONS(5674),
    [anon_sym_column_major] = ACTIONS(5674),
    [anon_sym_globallycoherent] = ACTIONS(5674),
    [anon_sym_centroid] = ACTIONS(5674),
    [anon_sym_noperspective] = ACTIONS(5674),
    [anon_sym_nointerpolation] = ACTIONS(5674),
    [anon_sym_sample] = ACTIONS(5674),
    [anon_sym_linear] = ACTIONS(5674),
    [anon_sym_snorm] = ACTIONS(5674),
    [anon_sym_unorm] = ACTIONS(5674),
    [anon_sym_point] = ACTIONS(5674),
    [anon_sym_line] = ACTIONS(5674),
    [anon_sym_triangleadj] = ACTIONS(5674),
    [anon_sym_lineadj] = ACTIONS(5674),
    [anon_sym_triangle] = ACTIONS(5674),
  },
  [2136] = {
    [sym_identifier] = ACTIONS(5583),
    [aux_sym_preproc_def_token1] = ACTIONS(5583),
    [aux_sym_preproc_if_token1] = ACTIONS(5583),
    [aux_sym_preproc_if_token2] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5583),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5583),
    [sym_preproc_directive] = ACTIONS(5583),
    [anon_sym_LPAREN2] = ACTIONS(5585),
    [anon_sym_TILDE] = ACTIONS(5585),
    [anon_sym_STAR] = ACTIONS(5585),
    [anon_sym_AMP_AMP] = ACTIONS(5585),
    [anon_sym_AMP] = ACTIONS(5583),
    [anon_sym_SEMI] = ACTIONS(5585),
    [anon_sym___extension__] = ACTIONS(5583),
    [anon_sym_typedef] = ACTIONS(5583),
    [anon_sym_in] = ACTIONS(5583),
    [anon_sym_out] = ACTIONS(5583),
    [anon_sym_inout] = ACTIONS(5583),
    [anon_sym_virtual] = ACTIONS(5583),
    [anon_sym_extern] = ACTIONS(5583),
    [anon_sym___attribute__] = ACTIONS(5583),
    [anon_sym___attribute] = ACTIONS(5583),
    [anon_sym_using] = ACTIONS(5583),
    [anon_sym_COLON_COLON] = ACTIONS(5585),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5585),
    [anon_sym___declspec] = ACTIONS(5583),
    [anon_sym___based] = ACTIONS(5583),
    [anon_sym_signed] = ACTIONS(5583),
    [anon_sym_unsigned] = ACTIONS(5583),
    [anon_sym_long] = ACTIONS(5583),
    [anon_sym_short] = ACTIONS(5583),
    [anon_sym_LBRACK] = ACTIONS(5583),
    [anon_sym_static] = ACTIONS(5583),
    [anon_sym_register] = ACTIONS(5583),
    [anon_sym_inline] = ACTIONS(5583),
    [anon_sym___inline] = ACTIONS(5583),
    [anon_sym___inline__] = ACTIONS(5583),
    [anon_sym___forceinline] = ACTIONS(5583),
    [anon_sym_thread_local] = ACTIONS(5583),
    [anon_sym___thread] = ACTIONS(5583),
    [anon_sym_const] = ACTIONS(5583),
    [anon_sym_constexpr] = ACTIONS(5583),
    [anon_sym_volatile] = ACTIONS(5583),
    [anon_sym_restrict] = ACTIONS(5583),
    [anon_sym___restrict__] = ACTIONS(5583),
    [anon_sym__Atomic] = ACTIONS(5583),
    [anon_sym__Noreturn] = ACTIONS(5583),
    [anon_sym_noreturn] = ACTIONS(5583),
    [anon_sym__Nonnull] = ACTIONS(5583),
    [anon_sym_mutable] = ACTIONS(5583),
    [anon_sym_constinit] = ACTIONS(5583),
    [anon_sym_consteval] = ACTIONS(5583),
    [anon_sym_alignas] = ACTIONS(5583),
    [anon_sym__Alignas] = ACTIONS(5583),
    [sym_primitive_type] = ACTIONS(5583),
    [anon_sym_enum] = ACTIONS(5583),
    [anon_sym_class] = ACTIONS(5583),
    [anon_sym_struct] = ACTIONS(5583),
    [anon_sym_union] = ACTIONS(5583),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5583),
    [anon_sym_decltype] = ACTIONS(5583),
    [anon_sym_explicit] = ACTIONS(5583),
    [anon_sym_typename] = ACTIONS(5583),
    [anon_sym_private] = ACTIONS(5583),
    [anon_sym_template] = ACTIONS(5583),
    [anon_sym_operator] = ACTIONS(5583),
    [anon_sym_friend] = ACTIONS(5583),
    [anon_sym_public] = ACTIONS(5583),
    [anon_sym_protected] = ACTIONS(5583),
    [anon_sym_static_assert] = ACTIONS(5583),
    [anon_sym_precise] = ACTIONS(5583),
    [anon_sym_shared] = ACTIONS(5583),
    [anon_sym_groupshared] = ACTIONS(5583),
    [anon_sym_uniform] = ACTIONS(5583),
    [anon_sym_row_major] = ACTIONS(5583),
    [anon_sym_column_major] = ACTIONS(5583),
    [anon_sym_globallycoherent] = ACTIONS(5583),
    [anon_sym_centroid] = ACTIONS(5583),
    [anon_sym_noperspective] = ACTIONS(5583),
    [anon_sym_nointerpolation] = ACTIONS(5583),
    [anon_sym_sample] = ACTIONS(5583),
    [anon_sym_linear] = ACTIONS(5583),
    [anon_sym_snorm] = ACTIONS(5583),
    [anon_sym_unorm] = ACTIONS(5583),
    [anon_sym_point] = ACTIONS(5583),
    [anon_sym_line] = ACTIONS(5583),
    [anon_sym_triangleadj] = ACTIONS(5583),
    [anon_sym_lineadj] = ACTIONS(5583),
    [anon_sym_triangle] = ACTIONS(5583),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2662),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_friend] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
  },
  [2138] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2268),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_private] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_friend] = ACTIONS(2266),
    [anon_sym_public] = ACTIONS(2266),
    [anon_sym_protected] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
  },
  [2139] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_friend] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
  },
  [2140] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_friend] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [2141] = {
    [sym_identifier] = ACTIONS(2466),
    [aux_sym_preproc_def_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token1] = ACTIONS(2466),
    [aux_sym_preproc_if_token2] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2466),
    [sym_preproc_directive] = ACTIONS(2466),
    [anon_sym_LPAREN2] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_AMP_AMP] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym___extension__] = ACTIONS(2466),
    [anon_sym_typedef] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2466),
    [anon_sym_out] = ACTIONS(2466),
    [anon_sym_inout] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym___attribute__] = ACTIONS(2466),
    [anon_sym___attribute] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2468),
    [anon_sym___declspec] = ACTIONS(2466),
    [anon_sym___based] = ACTIONS(2466),
    [anon_sym_signed] = ACTIONS(2466),
    [anon_sym_unsigned] = ACTIONS(2466),
    [anon_sym_long] = ACTIONS(2466),
    [anon_sym_short] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_register] = ACTIONS(2466),
    [anon_sym_inline] = ACTIONS(2466),
    [anon_sym___inline] = ACTIONS(2466),
    [anon_sym___inline__] = ACTIONS(2466),
    [anon_sym___forceinline] = ACTIONS(2466),
    [anon_sym_thread_local] = ACTIONS(2466),
    [anon_sym___thread] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_constexpr] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_restrict] = ACTIONS(2466),
    [anon_sym___restrict__] = ACTIONS(2466),
    [anon_sym__Atomic] = ACTIONS(2466),
    [anon_sym__Noreturn] = ACTIONS(2466),
    [anon_sym_noreturn] = ACTIONS(2466),
    [anon_sym__Nonnull] = ACTIONS(2466),
    [anon_sym_mutable] = ACTIONS(2466),
    [anon_sym_constinit] = ACTIONS(2466),
    [anon_sym_consteval] = ACTIONS(2466),
    [anon_sym_alignas] = ACTIONS(2466),
    [anon_sym__Alignas] = ACTIONS(2466),
    [sym_primitive_type] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_union] = ACTIONS(2466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2466),
    [anon_sym_decltype] = ACTIONS(2466),
    [anon_sym_explicit] = ACTIONS(2466),
    [anon_sym_typename] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_template] = ACTIONS(2466),
    [anon_sym_operator] = ACTIONS(2466),
    [anon_sym_friend] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_static_assert] = ACTIONS(2466),
    [anon_sym_precise] = ACTIONS(2466),
    [anon_sym_shared] = ACTIONS(2466),
    [anon_sym_groupshared] = ACTIONS(2466),
    [anon_sym_uniform] = ACTIONS(2466),
    [anon_sym_row_major] = ACTIONS(2466),
    [anon_sym_column_major] = ACTIONS(2466),
    [anon_sym_globallycoherent] = ACTIONS(2466),
    [anon_sym_centroid] = ACTIONS(2466),
    [anon_sym_noperspective] = ACTIONS(2466),
    [anon_sym_nointerpolation] = ACTIONS(2466),
    [anon_sym_sample] = ACTIONS(2466),
    [anon_sym_linear] = ACTIONS(2466),
    [anon_sym_snorm] = ACTIONS(2466),
    [anon_sym_unorm] = ACTIONS(2466),
    [anon_sym_point] = ACTIONS(2466),
    [anon_sym_line] = ACTIONS(2466),
    [anon_sym_triangleadj] = ACTIONS(2466),
    [anon_sym_lineadj] = ACTIONS(2466),
    [anon_sym_triangle] = ACTIONS(2466),
  },
  [2142] = {
    [sym_identifier] = ACTIONS(5587),
    [aux_sym_preproc_def_token1] = ACTIONS(5587),
    [aux_sym_preproc_if_token1] = ACTIONS(5587),
    [aux_sym_preproc_if_token2] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5587),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5587),
    [sym_preproc_directive] = ACTIONS(5587),
    [anon_sym_LPAREN2] = ACTIONS(5589),
    [anon_sym_TILDE] = ACTIONS(5589),
    [anon_sym_STAR] = ACTIONS(5589),
    [anon_sym_AMP_AMP] = ACTIONS(5589),
    [anon_sym_AMP] = ACTIONS(5587),
    [anon_sym_SEMI] = ACTIONS(5589),
    [anon_sym___extension__] = ACTIONS(5587),
    [anon_sym_typedef] = ACTIONS(5587),
    [anon_sym_in] = ACTIONS(5587),
    [anon_sym_out] = ACTIONS(5587),
    [anon_sym_inout] = ACTIONS(5587),
    [anon_sym_virtual] = ACTIONS(5587),
    [anon_sym_extern] = ACTIONS(5587),
    [anon_sym___attribute__] = ACTIONS(5587),
    [anon_sym___attribute] = ACTIONS(5587),
    [anon_sym_using] = ACTIONS(5587),
    [anon_sym_COLON_COLON] = ACTIONS(5589),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5589),
    [anon_sym___declspec] = ACTIONS(5587),
    [anon_sym___based] = ACTIONS(5587),
    [anon_sym_signed] = ACTIONS(5587),
    [anon_sym_unsigned] = ACTIONS(5587),
    [anon_sym_long] = ACTIONS(5587),
    [anon_sym_short] = ACTIONS(5587),
    [anon_sym_LBRACK] = ACTIONS(5587),
    [anon_sym_static] = ACTIONS(5587),
    [anon_sym_register] = ACTIONS(5587),
    [anon_sym_inline] = ACTIONS(5587),
    [anon_sym___inline] = ACTIONS(5587),
    [anon_sym___inline__] = ACTIONS(5587),
    [anon_sym___forceinline] = ACTIONS(5587),
    [anon_sym_thread_local] = ACTIONS(5587),
    [anon_sym___thread] = ACTIONS(5587),
    [anon_sym_const] = ACTIONS(5587),
    [anon_sym_constexpr] = ACTIONS(5587),
    [anon_sym_volatile] = ACTIONS(5587),
    [anon_sym_restrict] = ACTIONS(5587),
    [anon_sym___restrict__] = ACTIONS(5587),
    [anon_sym__Atomic] = ACTIONS(5587),
    [anon_sym__Noreturn] = ACTIONS(5587),
    [anon_sym_noreturn] = ACTIONS(5587),
    [anon_sym__Nonnull] = ACTIONS(5587),
    [anon_sym_mutable] = ACTIONS(5587),
    [anon_sym_constinit] = ACTIONS(5587),
    [anon_sym_consteval] = ACTIONS(5587),
    [anon_sym_alignas] = ACTIONS(5587),
    [anon_sym__Alignas] = ACTIONS(5587),
    [sym_primitive_type] = ACTIONS(5587),
    [anon_sym_enum] = ACTIONS(5587),
    [anon_sym_class] = ACTIONS(5587),
    [anon_sym_struct] = ACTIONS(5587),
    [anon_sym_union] = ACTIONS(5587),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5587),
    [anon_sym_decltype] = ACTIONS(5587),
    [anon_sym_explicit] = ACTIONS(5587),
    [anon_sym_typename] = ACTIONS(5587),
    [anon_sym_private] = ACTIONS(5587),
    [anon_sym_template] = ACTIONS(5587),
    [anon_sym_operator] = ACTIONS(5587),
    [anon_sym_friend] = ACTIONS(5587),
    [anon_sym_public] = ACTIONS(5587),
    [anon_sym_protected] = ACTIONS(5587),
    [anon_sym_static_assert] = ACTIONS(5587),
    [anon_sym_precise] = ACTIONS(5587),
    [anon_sym_shared] = ACTIONS(5587),
    [anon_sym_groupshared] = ACTIONS(5587),
    [anon_sym_uniform] = ACTIONS(5587),
    [anon_sym_row_major] = ACTIONS(5587),
    [anon_sym_column_major] = ACTIONS(5587),
    [anon_sym_globallycoherent] = ACTIONS(5587),
    [anon_sym_centroid] = ACTIONS(5587),
    [anon_sym_noperspective] = ACTIONS(5587),
    [anon_sym_nointerpolation] = ACTIONS(5587),
    [anon_sym_sample] = ACTIONS(5587),
    [anon_sym_linear] = ACTIONS(5587),
    [anon_sym_snorm] = ACTIONS(5587),
    [anon_sym_unorm] = ACTIONS(5587),
    [anon_sym_point] = ACTIONS(5587),
    [anon_sym_line] = ACTIONS(5587),
    [anon_sym_triangleadj] = ACTIONS(5587),
    [anon_sym_lineadj] = ACTIONS(5587),
    [anon_sym_triangle] = ACTIONS(5587),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(2504),
    [aux_sym_preproc_def_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token1] = ACTIONS(2504),
    [aux_sym_preproc_if_token2] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2504),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2504),
    [sym_preproc_directive] = ACTIONS(2504),
    [anon_sym_LPAREN2] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym___extension__] = ACTIONS(2504),
    [anon_sym_typedef] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2504),
    [anon_sym_out] = ACTIONS(2504),
    [anon_sym_inout] = ACTIONS(2504),
    [anon_sym_virtual] = ACTIONS(2504),
    [anon_sym_extern] = ACTIONS(2504),
    [anon_sym___attribute__] = ACTIONS(2504),
    [anon_sym___attribute] = ACTIONS(2504),
    [anon_sym_using] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2506),
    [anon_sym___declspec] = ACTIONS(2504),
    [anon_sym___based] = ACTIONS(2504),
    [anon_sym_signed] = ACTIONS(2504),
    [anon_sym_unsigned] = ACTIONS(2504),
    [anon_sym_long] = ACTIONS(2504),
    [anon_sym_short] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2504),
    [anon_sym_register] = ACTIONS(2504),
    [anon_sym_inline] = ACTIONS(2504),
    [anon_sym___inline] = ACTIONS(2504),
    [anon_sym___inline__] = ACTIONS(2504),
    [anon_sym___forceinline] = ACTIONS(2504),
    [anon_sym_thread_local] = ACTIONS(2504),
    [anon_sym___thread] = ACTIONS(2504),
    [anon_sym_const] = ACTIONS(2504),
    [anon_sym_constexpr] = ACTIONS(2504),
    [anon_sym_volatile] = ACTIONS(2504),
    [anon_sym_restrict] = ACTIONS(2504),
    [anon_sym___restrict__] = ACTIONS(2504),
    [anon_sym__Atomic] = ACTIONS(2504),
    [anon_sym__Noreturn] = ACTIONS(2504),
    [anon_sym_noreturn] = ACTIONS(2504),
    [anon_sym__Nonnull] = ACTIONS(2504),
    [anon_sym_mutable] = ACTIONS(2504),
    [anon_sym_constinit] = ACTIONS(2504),
    [anon_sym_consteval] = ACTIONS(2504),
    [anon_sym_alignas] = ACTIONS(2504),
    [anon_sym__Alignas] = ACTIONS(2504),
    [sym_primitive_type] = ACTIONS(2504),
    [anon_sym_enum] = ACTIONS(2504),
    [anon_sym_class] = ACTIONS(2504),
    [anon_sym_struct] = ACTIONS(2504),
    [anon_sym_union] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2504),
    [anon_sym_decltype] = ACTIONS(2504),
    [anon_sym_explicit] = ACTIONS(2504),
    [anon_sym_typename] = ACTIONS(2504),
    [anon_sym_private] = ACTIONS(2504),
    [anon_sym_template] = ACTIONS(2504),
    [anon_sym_operator] = ACTIONS(2504),
    [anon_sym_friend] = ACTIONS(2504),
    [anon_sym_public] = ACTIONS(2504),
    [anon_sym_protected] = ACTIONS(2504),
    [anon_sym_static_assert] = ACTIONS(2504),
    [anon_sym_precise] = ACTIONS(2504),
    [anon_sym_shared] = ACTIONS(2504),
    [anon_sym_groupshared] = ACTIONS(2504),
    [anon_sym_uniform] = ACTIONS(2504),
    [anon_sym_row_major] = ACTIONS(2504),
    [anon_sym_column_major] = ACTIONS(2504),
    [anon_sym_globallycoherent] = ACTIONS(2504),
    [anon_sym_centroid] = ACTIONS(2504),
    [anon_sym_noperspective] = ACTIONS(2504),
    [anon_sym_nointerpolation] = ACTIONS(2504),
    [anon_sym_sample] = ACTIONS(2504),
    [anon_sym_linear] = ACTIONS(2504),
    [anon_sym_snorm] = ACTIONS(2504),
    [anon_sym_unorm] = ACTIONS(2504),
    [anon_sym_point] = ACTIONS(2504),
    [anon_sym_line] = ACTIONS(2504),
    [anon_sym_triangleadj] = ACTIONS(2504),
    [anon_sym_lineadj] = ACTIONS(2504),
    [anon_sym_triangle] = ACTIONS(2504),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(2508),
    [aux_sym_preproc_def_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token1] = ACTIONS(2508),
    [aux_sym_preproc_if_token2] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2508),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2508),
    [sym_preproc_directive] = ACTIONS(2508),
    [anon_sym_LPAREN2] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym___extension__] = ACTIONS(2508),
    [anon_sym_typedef] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2508),
    [anon_sym_out] = ACTIONS(2508),
    [anon_sym_inout] = ACTIONS(2508),
    [anon_sym_virtual] = ACTIONS(2508),
    [anon_sym_extern] = ACTIONS(2508),
    [anon_sym___attribute__] = ACTIONS(2508),
    [anon_sym___attribute] = ACTIONS(2508),
    [anon_sym_using] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2510),
    [anon_sym___declspec] = ACTIONS(2508),
    [anon_sym___based] = ACTIONS(2508),
    [anon_sym_signed] = ACTIONS(2508),
    [anon_sym_unsigned] = ACTIONS(2508),
    [anon_sym_long] = ACTIONS(2508),
    [anon_sym_short] = ACTIONS(2508),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2508),
    [anon_sym_register] = ACTIONS(2508),
    [anon_sym_inline] = ACTIONS(2508),
    [anon_sym___inline] = ACTIONS(2508),
    [anon_sym___inline__] = ACTIONS(2508),
    [anon_sym___forceinline] = ACTIONS(2508),
    [anon_sym_thread_local] = ACTIONS(2508),
    [anon_sym___thread] = ACTIONS(2508),
    [anon_sym_const] = ACTIONS(2508),
    [anon_sym_constexpr] = ACTIONS(2508),
    [anon_sym_volatile] = ACTIONS(2508),
    [anon_sym_restrict] = ACTIONS(2508),
    [anon_sym___restrict__] = ACTIONS(2508),
    [anon_sym__Atomic] = ACTIONS(2508),
    [anon_sym__Noreturn] = ACTIONS(2508),
    [anon_sym_noreturn] = ACTIONS(2508),
    [anon_sym__Nonnull] = ACTIONS(2508),
    [anon_sym_mutable] = ACTIONS(2508),
    [anon_sym_constinit] = ACTIONS(2508),
    [anon_sym_consteval] = ACTIONS(2508),
    [anon_sym_alignas] = ACTIONS(2508),
    [anon_sym__Alignas] = ACTIONS(2508),
    [sym_primitive_type] = ACTIONS(2508),
    [anon_sym_enum] = ACTIONS(2508),
    [anon_sym_class] = ACTIONS(2508),
    [anon_sym_struct] = ACTIONS(2508),
    [anon_sym_union] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2508),
    [anon_sym_decltype] = ACTIONS(2508),
    [anon_sym_explicit] = ACTIONS(2508),
    [anon_sym_typename] = ACTIONS(2508),
    [anon_sym_private] = ACTIONS(2508),
    [anon_sym_template] = ACTIONS(2508),
    [anon_sym_operator] = ACTIONS(2508),
    [anon_sym_friend] = ACTIONS(2508),
    [anon_sym_public] = ACTIONS(2508),
    [anon_sym_protected] = ACTIONS(2508),
    [anon_sym_static_assert] = ACTIONS(2508),
    [anon_sym_precise] = ACTIONS(2508),
    [anon_sym_shared] = ACTIONS(2508),
    [anon_sym_groupshared] = ACTIONS(2508),
    [anon_sym_uniform] = ACTIONS(2508),
    [anon_sym_row_major] = ACTIONS(2508),
    [anon_sym_column_major] = ACTIONS(2508),
    [anon_sym_globallycoherent] = ACTIONS(2508),
    [anon_sym_centroid] = ACTIONS(2508),
    [anon_sym_noperspective] = ACTIONS(2508),
    [anon_sym_nointerpolation] = ACTIONS(2508),
    [anon_sym_sample] = ACTIONS(2508),
    [anon_sym_linear] = ACTIONS(2508),
    [anon_sym_snorm] = ACTIONS(2508),
    [anon_sym_unorm] = ACTIONS(2508),
    [anon_sym_point] = ACTIONS(2508),
    [anon_sym_line] = ACTIONS(2508),
    [anon_sym_triangleadj] = ACTIONS(2508),
    [anon_sym_lineadj] = ACTIONS(2508),
    [anon_sym_triangle] = ACTIONS(2508),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token2] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_private] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_friend] = ACTIONS(2512),
    [anon_sym_public] = ACTIONS(2512),
    [anon_sym_protected] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_friend] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
  },
  [2147] = {
    [sym_identifier] = ACTIONS(2516),
    [aux_sym_preproc_def_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token1] = ACTIONS(2516),
    [aux_sym_preproc_if_token2] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2516),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2516),
    [sym_preproc_directive] = ACTIONS(2516),
    [anon_sym_LPAREN2] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym___extension__] = ACTIONS(2516),
    [anon_sym_typedef] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2516),
    [anon_sym_out] = ACTIONS(2516),
    [anon_sym_inout] = ACTIONS(2516),
    [anon_sym_virtual] = ACTIONS(2516),
    [anon_sym_extern] = ACTIONS(2516),
    [anon_sym___attribute__] = ACTIONS(2516),
    [anon_sym___attribute] = ACTIONS(2516),
    [anon_sym_using] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2518),
    [anon_sym___declspec] = ACTIONS(2516),
    [anon_sym___based] = ACTIONS(2516),
    [anon_sym_signed] = ACTIONS(2516),
    [anon_sym_unsigned] = ACTIONS(2516),
    [anon_sym_long] = ACTIONS(2516),
    [anon_sym_short] = ACTIONS(2516),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2516),
    [anon_sym_register] = ACTIONS(2516),
    [anon_sym_inline] = ACTIONS(2516),
    [anon_sym___inline] = ACTIONS(2516),
    [anon_sym___inline__] = ACTIONS(2516),
    [anon_sym___forceinline] = ACTIONS(2516),
    [anon_sym_thread_local] = ACTIONS(2516),
    [anon_sym___thread] = ACTIONS(2516),
    [anon_sym_const] = ACTIONS(2516),
    [anon_sym_constexpr] = ACTIONS(2516),
    [anon_sym_volatile] = ACTIONS(2516),
    [anon_sym_restrict] = ACTIONS(2516),
    [anon_sym___restrict__] = ACTIONS(2516),
    [anon_sym__Atomic] = ACTIONS(2516),
    [anon_sym__Noreturn] = ACTIONS(2516),
    [anon_sym_noreturn] = ACTIONS(2516),
    [anon_sym__Nonnull] = ACTIONS(2516),
    [anon_sym_mutable] = ACTIONS(2516),
    [anon_sym_constinit] = ACTIONS(2516),
    [anon_sym_consteval] = ACTIONS(2516),
    [anon_sym_alignas] = ACTIONS(2516),
    [anon_sym__Alignas] = ACTIONS(2516),
    [sym_primitive_type] = ACTIONS(2516),
    [anon_sym_enum] = ACTIONS(2516),
    [anon_sym_class] = ACTIONS(2516),
    [anon_sym_struct] = ACTIONS(2516),
    [anon_sym_union] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2516),
    [anon_sym_decltype] = ACTIONS(2516),
    [anon_sym_explicit] = ACTIONS(2516),
    [anon_sym_typename] = ACTIONS(2516),
    [anon_sym_private] = ACTIONS(2516),
    [anon_sym_template] = ACTIONS(2516),
    [anon_sym_operator] = ACTIONS(2516),
    [anon_sym_friend] = ACTIONS(2516),
    [anon_sym_public] = ACTIONS(2516),
    [anon_sym_protected] = ACTIONS(2516),
    [anon_sym_static_assert] = ACTIONS(2516),
    [anon_sym_precise] = ACTIONS(2516),
    [anon_sym_shared] = ACTIONS(2516),
    [anon_sym_groupshared] = ACTIONS(2516),
    [anon_sym_uniform] = ACTIONS(2516),
    [anon_sym_row_major] = ACTIONS(2516),
    [anon_sym_column_major] = ACTIONS(2516),
    [anon_sym_globallycoherent] = ACTIONS(2516),
    [anon_sym_centroid] = ACTIONS(2516),
    [anon_sym_noperspective] = ACTIONS(2516),
    [anon_sym_nointerpolation] = ACTIONS(2516),
    [anon_sym_sample] = ACTIONS(2516),
    [anon_sym_linear] = ACTIONS(2516),
    [anon_sym_snorm] = ACTIONS(2516),
    [anon_sym_unorm] = ACTIONS(2516),
    [anon_sym_point] = ACTIONS(2516),
    [anon_sym_line] = ACTIONS(2516),
    [anon_sym_triangleadj] = ACTIONS(2516),
    [anon_sym_lineadj] = ACTIONS(2516),
    [anon_sym_triangle] = ACTIONS(2516),
  },
  [2148] = {
    [sym_identifier] = ACTIONS(2520),
    [aux_sym_preproc_def_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token1] = ACTIONS(2520),
    [aux_sym_preproc_if_token2] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2520),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2520),
    [sym_preproc_directive] = ACTIONS(2520),
    [anon_sym_LPAREN2] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym___extension__] = ACTIONS(2520),
    [anon_sym_typedef] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2520),
    [anon_sym_out] = ACTIONS(2520),
    [anon_sym_inout] = ACTIONS(2520),
    [anon_sym_virtual] = ACTIONS(2520),
    [anon_sym_extern] = ACTIONS(2520),
    [anon_sym___attribute__] = ACTIONS(2520),
    [anon_sym___attribute] = ACTIONS(2520),
    [anon_sym_using] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2522),
    [anon_sym___declspec] = ACTIONS(2520),
    [anon_sym___based] = ACTIONS(2520),
    [anon_sym_signed] = ACTIONS(2520),
    [anon_sym_unsigned] = ACTIONS(2520),
    [anon_sym_long] = ACTIONS(2520),
    [anon_sym_short] = ACTIONS(2520),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2520),
    [anon_sym_register] = ACTIONS(2520),
    [anon_sym_inline] = ACTIONS(2520),
    [anon_sym___inline] = ACTIONS(2520),
    [anon_sym___inline__] = ACTIONS(2520),
    [anon_sym___forceinline] = ACTIONS(2520),
    [anon_sym_thread_local] = ACTIONS(2520),
    [anon_sym___thread] = ACTIONS(2520),
    [anon_sym_const] = ACTIONS(2520),
    [anon_sym_constexpr] = ACTIONS(2520),
    [anon_sym_volatile] = ACTIONS(2520),
    [anon_sym_restrict] = ACTIONS(2520),
    [anon_sym___restrict__] = ACTIONS(2520),
    [anon_sym__Atomic] = ACTIONS(2520),
    [anon_sym__Noreturn] = ACTIONS(2520),
    [anon_sym_noreturn] = ACTIONS(2520),
    [anon_sym__Nonnull] = ACTIONS(2520),
    [anon_sym_mutable] = ACTIONS(2520),
    [anon_sym_constinit] = ACTIONS(2520),
    [anon_sym_consteval] = ACTIONS(2520),
    [anon_sym_alignas] = ACTIONS(2520),
    [anon_sym__Alignas] = ACTIONS(2520),
    [sym_primitive_type] = ACTIONS(2520),
    [anon_sym_enum] = ACTIONS(2520),
    [anon_sym_class] = ACTIONS(2520),
    [anon_sym_struct] = ACTIONS(2520),
    [anon_sym_union] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2520),
    [anon_sym_decltype] = ACTIONS(2520),
    [anon_sym_explicit] = ACTIONS(2520),
    [anon_sym_typename] = ACTIONS(2520),
    [anon_sym_private] = ACTIONS(2520),
    [anon_sym_template] = ACTIONS(2520),
    [anon_sym_operator] = ACTIONS(2520),
    [anon_sym_friend] = ACTIONS(2520),
    [anon_sym_public] = ACTIONS(2520),
    [anon_sym_protected] = ACTIONS(2520),
    [anon_sym_static_assert] = ACTIONS(2520),
    [anon_sym_precise] = ACTIONS(2520),
    [anon_sym_shared] = ACTIONS(2520),
    [anon_sym_groupshared] = ACTIONS(2520),
    [anon_sym_uniform] = ACTIONS(2520),
    [anon_sym_row_major] = ACTIONS(2520),
    [anon_sym_column_major] = ACTIONS(2520),
    [anon_sym_globallycoherent] = ACTIONS(2520),
    [anon_sym_centroid] = ACTIONS(2520),
    [anon_sym_noperspective] = ACTIONS(2520),
    [anon_sym_nointerpolation] = ACTIONS(2520),
    [anon_sym_sample] = ACTIONS(2520),
    [anon_sym_linear] = ACTIONS(2520),
    [anon_sym_snorm] = ACTIONS(2520),
    [anon_sym_unorm] = ACTIONS(2520),
    [anon_sym_point] = ACTIONS(2520),
    [anon_sym_line] = ACTIONS(2520),
    [anon_sym_triangleadj] = ACTIONS(2520),
    [anon_sym_lineadj] = ACTIONS(2520),
    [anon_sym_triangle] = ACTIONS(2520),
  },
  [2149] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(5678),
    [anon_sym_LPAREN2] = ACTIONS(5680),
    [anon_sym_TILDE] = ACTIONS(5680),
    [anon_sym_STAR] = ACTIONS(5680),
    [anon_sym_AMP_AMP] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5678),
    [anon_sym___extension__] = ACTIONS(5678),
    [anon_sym_in] = ACTIONS(5678),
    [anon_sym_out] = ACTIONS(5678),
    [anon_sym_inout] = ACTIONS(5678),
    [anon_sym_virtual] = ACTIONS(5678),
    [anon_sym_extern] = ACTIONS(5678),
    [anon_sym___attribute__] = ACTIONS(5678),
    [anon_sym___attribute] = ACTIONS(5678),
    [anon_sym_using] = ACTIONS(5678),
    [anon_sym_COLON_COLON] = ACTIONS(5680),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5680),
    [anon_sym___declspec] = ACTIONS(5678),
    [anon_sym___based] = ACTIONS(5678),
    [anon_sym___cdecl] = ACTIONS(5678),
    [anon_sym___clrcall] = ACTIONS(5678),
    [anon_sym___stdcall] = ACTIONS(5678),
    [anon_sym___fastcall] = ACTIONS(5678),
    [anon_sym___thiscall] = ACTIONS(5678),
    [anon_sym___vectorcall] = ACTIONS(5678),
    [anon_sym_LBRACE] = ACTIONS(5680),
    [anon_sym_signed] = ACTIONS(5678),
    [anon_sym_unsigned] = ACTIONS(5678),
    [anon_sym_long] = ACTIONS(5678),
    [anon_sym_short] = ACTIONS(5678),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_static] = ACTIONS(5678),
    [anon_sym_register] = ACTIONS(5678),
    [anon_sym_inline] = ACTIONS(5678),
    [anon_sym___inline] = ACTIONS(5678),
    [anon_sym___inline__] = ACTIONS(5678),
    [anon_sym___forceinline] = ACTIONS(5678),
    [anon_sym_thread_local] = ACTIONS(5678),
    [anon_sym___thread] = ACTIONS(5678),
    [anon_sym_const] = ACTIONS(5678),
    [anon_sym_constexpr] = ACTIONS(5678),
    [anon_sym_volatile] = ACTIONS(5678),
    [anon_sym_restrict] = ACTIONS(5678),
    [anon_sym___restrict__] = ACTIONS(5678),
    [anon_sym__Atomic] = ACTIONS(5678),
    [anon_sym__Noreturn] = ACTIONS(5678),
    [anon_sym_noreturn] = ACTIONS(5678),
    [anon_sym__Nonnull] = ACTIONS(5678),
    [anon_sym_mutable] = ACTIONS(5678),
    [anon_sym_constinit] = ACTIONS(5678),
    [anon_sym_consteval] = ACTIONS(5678),
    [anon_sym_alignas] = ACTIONS(5678),
    [anon_sym__Alignas] = ACTIONS(5678),
    [sym_primitive_type] = ACTIONS(5678),
    [anon_sym_enum] = ACTIONS(5678),
    [anon_sym_class] = ACTIONS(5678),
    [anon_sym_struct] = ACTIONS(5678),
    [anon_sym_union] = ACTIONS(5678),
    [anon_sym_DASH_GT] = ACTIONS(5680),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5678),
    [anon_sym_decltype] = ACTIONS(5678),
    [anon_sym_explicit] = ACTIONS(5678),
    [anon_sym_typename] = ACTIONS(5678),
    [anon_sym_template] = ACTIONS(5678),
    [anon_sym_operator] = ACTIONS(5678),
    [anon_sym_friend] = ACTIONS(5678),
    [anon_sym_noexcept] = ACTIONS(5678),
    [anon_sym_throw] = ACTIONS(5678),
    [anon_sym_concept] = ACTIONS(5678),
    [anon_sym_requires] = ACTIONS(5678),
    [anon_sym_precise] = ACTIONS(5678),
    [anon_sym_shared] = ACTIONS(5678),
    [anon_sym_groupshared] = ACTIONS(5678),
    [anon_sym_uniform] = ACTIONS(5678),
    [anon_sym_row_major] = ACTIONS(5678),
    [anon_sym_column_major] = ACTIONS(5678),
    [anon_sym_globallycoherent] = ACTIONS(5678),
    [anon_sym_centroid] = ACTIONS(5678),
    [anon_sym_noperspective] = ACTIONS(5678),
    [anon_sym_nointerpolation] = ACTIONS(5678),
    [anon_sym_sample] = ACTIONS(5678),
    [anon_sym_linear] = ACTIONS(5678),
    [anon_sym_snorm] = ACTIONS(5678),
    [anon_sym_unorm] = ACTIONS(5678),
    [anon_sym_point] = ACTIONS(5678),
    [anon_sym_line] = ACTIONS(5678),
    [anon_sym_triangleadj] = ACTIONS(5678),
    [anon_sym_lineadj] = ACTIONS(5678),
    [anon_sym_triangle] = ACTIONS(5678),
  },
  [2151] = {
    [sym_identifier] = ACTIONS(2532),
    [aux_sym_preproc_def_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token1] = ACTIONS(2532),
    [aux_sym_preproc_if_token2] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2532),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2532),
    [sym_preproc_directive] = ACTIONS(2532),
    [anon_sym_LPAREN2] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym___extension__] = ACTIONS(2532),
    [anon_sym_typedef] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2532),
    [anon_sym_out] = ACTIONS(2532),
    [anon_sym_inout] = ACTIONS(2532),
    [anon_sym_virtual] = ACTIONS(2532),
    [anon_sym_extern] = ACTIONS(2532),
    [anon_sym___attribute__] = ACTIONS(2532),
    [anon_sym___attribute] = ACTIONS(2532),
    [anon_sym_using] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2534),
    [anon_sym___declspec] = ACTIONS(2532),
    [anon_sym___based] = ACTIONS(2532),
    [anon_sym_signed] = ACTIONS(2532),
    [anon_sym_unsigned] = ACTIONS(2532),
    [anon_sym_long] = ACTIONS(2532),
    [anon_sym_short] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2532),
    [anon_sym_register] = ACTIONS(2532),
    [anon_sym_inline] = ACTIONS(2532),
    [anon_sym___inline] = ACTIONS(2532),
    [anon_sym___inline__] = ACTIONS(2532),
    [anon_sym___forceinline] = ACTIONS(2532),
    [anon_sym_thread_local] = ACTIONS(2532),
    [anon_sym___thread] = ACTIONS(2532),
    [anon_sym_const] = ACTIONS(2532),
    [anon_sym_constexpr] = ACTIONS(2532),
    [anon_sym_volatile] = ACTIONS(2532),
    [anon_sym_restrict] = ACTIONS(2532),
    [anon_sym___restrict__] = ACTIONS(2532),
    [anon_sym__Atomic] = ACTIONS(2532),
    [anon_sym__Noreturn] = ACTIONS(2532),
    [anon_sym_noreturn] = ACTIONS(2532),
    [anon_sym__Nonnull] = ACTIONS(2532),
    [anon_sym_mutable] = ACTIONS(2532),
    [anon_sym_constinit] = ACTIONS(2532),
    [anon_sym_consteval] = ACTIONS(2532),
    [anon_sym_alignas] = ACTIONS(2532),
    [anon_sym__Alignas] = ACTIONS(2532),
    [sym_primitive_type] = ACTIONS(2532),
    [anon_sym_enum] = ACTIONS(2532),
    [anon_sym_class] = ACTIONS(2532),
    [anon_sym_struct] = ACTIONS(2532),
    [anon_sym_union] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2532),
    [anon_sym_decltype] = ACTIONS(2532),
    [anon_sym_explicit] = ACTIONS(2532),
    [anon_sym_typename] = ACTIONS(2532),
    [anon_sym_private] = ACTIONS(2532),
    [anon_sym_template] = ACTIONS(2532),
    [anon_sym_operator] = ACTIONS(2532),
    [anon_sym_friend] = ACTIONS(2532),
    [anon_sym_public] = ACTIONS(2532),
    [anon_sym_protected] = ACTIONS(2532),
    [anon_sym_static_assert] = ACTIONS(2532),
    [anon_sym_precise] = ACTIONS(2532),
    [anon_sym_shared] = ACTIONS(2532),
    [anon_sym_groupshared] = ACTIONS(2532),
    [anon_sym_uniform] = ACTIONS(2532),
    [anon_sym_row_major] = ACTIONS(2532),
    [anon_sym_column_major] = ACTIONS(2532),
    [anon_sym_globallycoherent] = ACTIONS(2532),
    [anon_sym_centroid] = ACTIONS(2532),
    [anon_sym_noperspective] = ACTIONS(2532),
    [anon_sym_nointerpolation] = ACTIONS(2532),
    [anon_sym_sample] = ACTIONS(2532),
    [anon_sym_linear] = ACTIONS(2532),
    [anon_sym_snorm] = ACTIONS(2532),
    [anon_sym_unorm] = ACTIONS(2532),
    [anon_sym_point] = ACTIONS(2532),
    [anon_sym_line] = ACTIONS(2532),
    [anon_sym_triangleadj] = ACTIONS(2532),
    [anon_sym_lineadj] = ACTIONS(2532),
    [anon_sym_triangle] = ACTIONS(2532),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(2540),
    [aux_sym_preproc_def_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token1] = ACTIONS(2540),
    [aux_sym_preproc_if_token2] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2540),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2540),
    [sym_preproc_directive] = ACTIONS(2540),
    [anon_sym_LPAREN2] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym___extension__] = ACTIONS(2540),
    [anon_sym_typedef] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2540),
    [anon_sym_out] = ACTIONS(2540),
    [anon_sym_inout] = ACTIONS(2540),
    [anon_sym_virtual] = ACTIONS(2540),
    [anon_sym_extern] = ACTIONS(2540),
    [anon_sym___attribute__] = ACTIONS(2540),
    [anon_sym___attribute] = ACTIONS(2540),
    [anon_sym_using] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2542),
    [anon_sym___declspec] = ACTIONS(2540),
    [anon_sym___based] = ACTIONS(2540),
    [anon_sym_signed] = ACTIONS(2540),
    [anon_sym_unsigned] = ACTIONS(2540),
    [anon_sym_long] = ACTIONS(2540),
    [anon_sym_short] = ACTIONS(2540),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2540),
    [anon_sym_register] = ACTIONS(2540),
    [anon_sym_inline] = ACTIONS(2540),
    [anon_sym___inline] = ACTIONS(2540),
    [anon_sym___inline__] = ACTIONS(2540),
    [anon_sym___forceinline] = ACTIONS(2540),
    [anon_sym_thread_local] = ACTIONS(2540),
    [anon_sym___thread] = ACTIONS(2540),
    [anon_sym_const] = ACTIONS(2540),
    [anon_sym_constexpr] = ACTIONS(2540),
    [anon_sym_volatile] = ACTIONS(2540),
    [anon_sym_restrict] = ACTIONS(2540),
    [anon_sym___restrict__] = ACTIONS(2540),
    [anon_sym__Atomic] = ACTIONS(2540),
    [anon_sym__Noreturn] = ACTIONS(2540),
    [anon_sym_noreturn] = ACTIONS(2540),
    [anon_sym__Nonnull] = ACTIONS(2540),
    [anon_sym_mutable] = ACTIONS(2540),
    [anon_sym_constinit] = ACTIONS(2540),
    [anon_sym_consteval] = ACTIONS(2540),
    [anon_sym_alignas] = ACTIONS(2540),
    [anon_sym__Alignas] = ACTIONS(2540),
    [sym_primitive_type] = ACTIONS(2540),
    [anon_sym_enum] = ACTIONS(2540),
    [anon_sym_class] = ACTIONS(2540),
    [anon_sym_struct] = ACTIONS(2540),
    [anon_sym_union] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2540),
    [anon_sym_decltype] = ACTIONS(2540),
    [anon_sym_explicit] = ACTIONS(2540),
    [anon_sym_typename] = ACTIONS(2540),
    [anon_sym_private] = ACTIONS(2540),
    [anon_sym_template] = ACTIONS(2540),
    [anon_sym_operator] = ACTIONS(2540),
    [anon_sym_friend] = ACTIONS(2540),
    [anon_sym_public] = ACTIONS(2540),
    [anon_sym_protected] = ACTIONS(2540),
    [anon_sym_static_assert] = ACTIONS(2540),
    [anon_sym_precise] = ACTIONS(2540),
    [anon_sym_shared] = ACTIONS(2540),
    [anon_sym_groupshared] = ACTIONS(2540),
    [anon_sym_uniform] = ACTIONS(2540),
    [anon_sym_row_major] = ACTIONS(2540),
    [anon_sym_column_major] = ACTIONS(2540),
    [anon_sym_globallycoherent] = ACTIONS(2540),
    [anon_sym_centroid] = ACTIONS(2540),
    [anon_sym_noperspective] = ACTIONS(2540),
    [anon_sym_nointerpolation] = ACTIONS(2540),
    [anon_sym_sample] = ACTIONS(2540),
    [anon_sym_linear] = ACTIONS(2540),
    [anon_sym_snorm] = ACTIONS(2540),
    [anon_sym_unorm] = ACTIONS(2540),
    [anon_sym_point] = ACTIONS(2540),
    [anon_sym_line] = ACTIONS(2540),
    [anon_sym_triangleadj] = ACTIONS(2540),
    [anon_sym_lineadj] = ACTIONS(2540),
    [anon_sym_triangle] = ACTIONS(2540),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym_RBRACE] = ACTIONS(2165),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_friend] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2169),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_friend] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
  },
  [2155] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2658),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_private] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_friend] = ACTIONS(2656),
    [anon_sym_public] = ACTIONS(2656),
    [anon_sym_protected] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [2156] = {
    [sym_identifier] = ACTIONS(5591),
    [aux_sym_preproc_def_token1] = ACTIONS(5591),
    [aux_sym_preproc_if_token1] = ACTIONS(5591),
    [aux_sym_preproc_if_token2] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5591),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5591),
    [sym_preproc_directive] = ACTIONS(5591),
    [anon_sym_LPAREN2] = ACTIONS(5593),
    [anon_sym_TILDE] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5593),
    [anon_sym_AMP] = ACTIONS(5591),
    [anon_sym_SEMI] = ACTIONS(5593),
    [anon_sym___extension__] = ACTIONS(5591),
    [anon_sym_typedef] = ACTIONS(5591),
    [anon_sym_in] = ACTIONS(5591),
    [anon_sym_out] = ACTIONS(5591),
    [anon_sym_inout] = ACTIONS(5591),
    [anon_sym_virtual] = ACTIONS(5591),
    [anon_sym_extern] = ACTIONS(5591),
    [anon_sym___attribute__] = ACTIONS(5591),
    [anon_sym___attribute] = ACTIONS(5591),
    [anon_sym_using] = ACTIONS(5591),
    [anon_sym_COLON_COLON] = ACTIONS(5593),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5593),
    [anon_sym___declspec] = ACTIONS(5591),
    [anon_sym___based] = ACTIONS(5591),
    [anon_sym_signed] = ACTIONS(5591),
    [anon_sym_unsigned] = ACTIONS(5591),
    [anon_sym_long] = ACTIONS(5591),
    [anon_sym_short] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(5591),
    [anon_sym_static] = ACTIONS(5591),
    [anon_sym_register] = ACTIONS(5591),
    [anon_sym_inline] = ACTIONS(5591),
    [anon_sym___inline] = ACTIONS(5591),
    [anon_sym___inline__] = ACTIONS(5591),
    [anon_sym___forceinline] = ACTIONS(5591),
    [anon_sym_thread_local] = ACTIONS(5591),
    [anon_sym___thread] = ACTIONS(5591),
    [anon_sym_const] = ACTIONS(5591),
    [anon_sym_constexpr] = ACTIONS(5591),
    [anon_sym_volatile] = ACTIONS(5591),
    [anon_sym_restrict] = ACTIONS(5591),
    [anon_sym___restrict__] = ACTIONS(5591),
    [anon_sym__Atomic] = ACTIONS(5591),
    [anon_sym__Noreturn] = ACTIONS(5591),
    [anon_sym_noreturn] = ACTIONS(5591),
    [anon_sym__Nonnull] = ACTIONS(5591),
    [anon_sym_mutable] = ACTIONS(5591),
    [anon_sym_constinit] = ACTIONS(5591),
    [anon_sym_consteval] = ACTIONS(5591),
    [anon_sym_alignas] = ACTIONS(5591),
    [anon_sym__Alignas] = ACTIONS(5591),
    [sym_primitive_type] = ACTIONS(5591),
    [anon_sym_enum] = ACTIONS(5591),
    [anon_sym_class] = ACTIONS(5591),
    [anon_sym_struct] = ACTIONS(5591),
    [anon_sym_union] = ACTIONS(5591),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5591),
    [anon_sym_decltype] = ACTIONS(5591),
    [anon_sym_explicit] = ACTIONS(5591),
    [anon_sym_typename] = ACTIONS(5591),
    [anon_sym_private] = ACTIONS(5591),
    [anon_sym_template] = ACTIONS(5591),
    [anon_sym_operator] = ACTIONS(5591),
    [anon_sym_friend] = ACTIONS(5591),
    [anon_sym_public] = ACTIONS(5591),
    [anon_sym_protected] = ACTIONS(5591),
    [anon_sym_static_assert] = ACTIONS(5591),
    [anon_sym_precise] = ACTIONS(5591),
    [anon_sym_shared] = ACTIONS(5591),
    [anon_sym_groupshared] = ACTIONS(5591),
    [anon_sym_uniform] = ACTIONS(5591),
    [anon_sym_row_major] = ACTIONS(5591),
    [anon_sym_column_major] = ACTIONS(5591),
    [anon_sym_globallycoherent] = ACTIONS(5591),
    [anon_sym_centroid] = ACTIONS(5591),
    [anon_sym_noperspective] = ACTIONS(5591),
    [anon_sym_nointerpolation] = ACTIONS(5591),
    [anon_sym_sample] = ACTIONS(5591),
    [anon_sym_linear] = ACTIONS(5591),
    [anon_sym_snorm] = ACTIONS(5591),
    [anon_sym_unorm] = ACTIONS(5591),
    [anon_sym_point] = ACTIONS(5591),
    [anon_sym_line] = ACTIONS(5591),
    [anon_sym_triangleadj] = ACTIONS(5591),
    [anon_sym_lineadj] = ACTIONS(5591),
    [anon_sym_triangle] = ACTIONS(5591),
  },
  [2157] = {
    [sym_identifier] = ACTIONS(2548),
    [aux_sym_preproc_def_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token1] = ACTIONS(2548),
    [aux_sym_preproc_if_token2] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2548),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2548),
    [sym_preproc_directive] = ACTIONS(2548),
    [anon_sym_LPAREN2] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym___extension__] = ACTIONS(2548),
    [anon_sym_typedef] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2548),
    [anon_sym_out] = ACTIONS(2548),
    [anon_sym_inout] = ACTIONS(2548),
    [anon_sym_virtual] = ACTIONS(2548),
    [anon_sym_extern] = ACTIONS(2548),
    [anon_sym___attribute__] = ACTIONS(2548),
    [anon_sym___attribute] = ACTIONS(2548),
    [anon_sym_using] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2550),
    [anon_sym___declspec] = ACTIONS(2548),
    [anon_sym___based] = ACTIONS(2548),
    [anon_sym_signed] = ACTIONS(2548),
    [anon_sym_unsigned] = ACTIONS(2548),
    [anon_sym_long] = ACTIONS(2548),
    [anon_sym_short] = ACTIONS(2548),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2548),
    [anon_sym_register] = ACTIONS(2548),
    [anon_sym_inline] = ACTIONS(2548),
    [anon_sym___inline] = ACTIONS(2548),
    [anon_sym___inline__] = ACTIONS(2548),
    [anon_sym___forceinline] = ACTIONS(2548),
    [anon_sym_thread_local] = ACTIONS(2548),
    [anon_sym___thread] = ACTIONS(2548),
    [anon_sym_const] = ACTIONS(2548),
    [anon_sym_constexpr] = ACTIONS(2548),
    [anon_sym_volatile] = ACTIONS(2548),
    [anon_sym_restrict] = ACTIONS(2548),
    [anon_sym___restrict__] = ACTIONS(2548),
    [anon_sym__Atomic] = ACTIONS(2548),
    [anon_sym__Noreturn] = ACTIONS(2548),
    [anon_sym_noreturn] = ACTIONS(2548),
    [anon_sym__Nonnull] = ACTIONS(2548),
    [anon_sym_mutable] = ACTIONS(2548),
    [anon_sym_constinit] = ACTIONS(2548),
    [anon_sym_consteval] = ACTIONS(2548),
    [anon_sym_alignas] = ACTIONS(2548),
    [anon_sym__Alignas] = ACTIONS(2548),
    [sym_primitive_type] = ACTIONS(2548),
    [anon_sym_enum] = ACTIONS(2548),
    [anon_sym_class] = ACTIONS(2548),
    [anon_sym_struct] = ACTIONS(2548),
    [anon_sym_union] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2548),
    [anon_sym_decltype] = ACTIONS(2548),
    [anon_sym_explicit] = ACTIONS(2548),
    [anon_sym_typename] = ACTIONS(2548),
    [anon_sym_private] = ACTIONS(2548),
    [anon_sym_template] = ACTIONS(2548),
    [anon_sym_operator] = ACTIONS(2548),
    [anon_sym_friend] = ACTIONS(2548),
    [anon_sym_public] = ACTIONS(2548),
    [anon_sym_protected] = ACTIONS(2548),
    [anon_sym_static_assert] = ACTIONS(2548),
    [anon_sym_precise] = ACTIONS(2548),
    [anon_sym_shared] = ACTIONS(2548),
    [anon_sym_groupshared] = ACTIONS(2548),
    [anon_sym_uniform] = ACTIONS(2548),
    [anon_sym_row_major] = ACTIONS(2548),
    [anon_sym_column_major] = ACTIONS(2548),
    [anon_sym_globallycoherent] = ACTIONS(2548),
    [anon_sym_centroid] = ACTIONS(2548),
    [anon_sym_noperspective] = ACTIONS(2548),
    [anon_sym_nointerpolation] = ACTIONS(2548),
    [anon_sym_sample] = ACTIONS(2548),
    [anon_sym_linear] = ACTIONS(2548),
    [anon_sym_snorm] = ACTIONS(2548),
    [anon_sym_unorm] = ACTIONS(2548),
    [anon_sym_point] = ACTIONS(2548),
    [anon_sym_line] = ACTIONS(2548),
    [anon_sym_triangleadj] = ACTIONS(2548),
    [anon_sym_lineadj] = ACTIONS(2548),
    [anon_sym_triangle] = ACTIONS(2548),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(2572),
    [aux_sym_preproc_def_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token1] = ACTIONS(2572),
    [aux_sym_preproc_if_token2] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2572),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2572),
    [sym_preproc_directive] = ACTIONS(2572),
    [anon_sym_LPAREN2] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2574),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_AMP] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym___extension__] = ACTIONS(2572),
    [anon_sym_typedef] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2572),
    [anon_sym_out] = ACTIONS(2572),
    [anon_sym_inout] = ACTIONS(2572),
    [anon_sym_virtual] = ACTIONS(2572),
    [anon_sym_extern] = ACTIONS(2572),
    [anon_sym___attribute__] = ACTIONS(2572),
    [anon_sym___attribute] = ACTIONS(2572),
    [anon_sym_using] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2574),
    [anon_sym___declspec] = ACTIONS(2572),
    [anon_sym___based] = ACTIONS(2572),
    [anon_sym_signed] = ACTIONS(2572),
    [anon_sym_unsigned] = ACTIONS(2572),
    [anon_sym_long] = ACTIONS(2572),
    [anon_sym_short] = ACTIONS(2572),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2572),
    [anon_sym_register] = ACTIONS(2572),
    [anon_sym_inline] = ACTIONS(2572),
    [anon_sym___inline] = ACTIONS(2572),
    [anon_sym___inline__] = ACTIONS(2572),
    [anon_sym___forceinline] = ACTIONS(2572),
    [anon_sym_thread_local] = ACTIONS(2572),
    [anon_sym___thread] = ACTIONS(2572),
    [anon_sym_const] = ACTIONS(2572),
    [anon_sym_constexpr] = ACTIONS(2572),
    [anon_sym_volatile] = ACTIONS(2572),
    [anon_sym_restrict] = ACTIONS(2572),
    [anon_sym___restrict__] = ACTIONS(2572),
    [anon_sym__Atomic] = ACTIONS(2572),
    [anon_sym__Noreturn] = ACTIONS(2572),
    [anon_sym_noreturn] = ACTIONS(2572),
    [anon_sym__Nonnull] = ACTIONS(2572),
    [anon_sym_mutable] = ACTIONS(2572),
    [anon_sym_constinit] = ACTIONS(2572),
    [anon_sym_consteval] = ACTIONS(2572),
    [anon_sym_alignas] = ACTIONS(2572),
    [anon_sym__Alignas] = ACTIONS(2572),
    [sym_primitive_type] = ACTIONS(2572),
    [anon_sym_enum] = ACTIONS(2572),
    [anon_sym_class] = ACTIONS(2572),
    [anon_sym_struct] = ACTIONS(2572),
    [anon_sym_union] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2572),
    [anon_sym_decltype] = ACTIONS(2572),
    [anon_sym_explicit] = ACTIONS(2572),
    [anon_sym_typename] = ACTIONS(2572),
    [anon_sym_private] = ACTIONS(2572),
    [anon_sym_template] = ACTIONS(2572),
    [anon_sym_operator] = ACTIONS(2572),
    [anon_sym_friend] = ACTIONS(2572),
    [anon_sym_public] = ACTIONS(2572),
    [anon_sym_protected] = ACTIONS(2572),
    [anon_sym_static_assert] = ACTIONS(2572),
    [anon_sym_precise] = ACTIONS(2572),
    [anon_sym_shared] = ACTIONS(2572),
    [anon_sym_groupshared] = ACTIONS(2572),
    [anon_sym_uniform] = ACTIONS(2572),
    [anon_sym_row_major] = ACTIONS(2572),
    [anon_sym_column_major] = ACTIONS(2572),
    [anon_sym_globallycoherent] = ACTIONS(2572),
    [anon_sym_centroid] = ACTIONS(2572),
    [anon_sym_noperspective] = ACTIONS(2572),
    [anon_sym_nointerpolation] = ACTIONS(2572),
    [anon_sym_sample] = ACTIONS(2572),
    [anon_sym_linear] = ACTIONS(2572),
    [anon_sym_snorm] = ACTIONS(2572),
    [anon_sym_unorm] = ACTIONS(2572),
    [anon_sym_point] = ACTIONS(2572),
    [anon_sym_line] = ACTIONS(2572),
    [anon_sym_triangleadj] = ACTIONS(2572),
    [anon_sym_lineadj] = ACTIONS(2572),
    [anon_sym_triangle] = ACTIONS(2572),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token2] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token2] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(2612),
    [aux_sym_preproc_def_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token1] = ACTIONS(2612),
    [aux_sym_preproc_if_token2] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2612),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2612),
    [sym_preproc_directive] = ACTIONS(2612),
    [anon_sym_LPAREN2] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2614),
    [anon_sym_STAR] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_AMP] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym___extension__] = ACTIONS(2612),
    [anon_sym_typedef] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_out] = ACTIONS(2612),
    [anon_sym_inout] = ACTIONS(2612),
    [anon_sym_virtual] = ACTIONS(2612),
    [anon_sym_extern] = ACTIONS(2612),
    [anon_sym___attribute__] = ACTIONS(2612),
    [anon_sym___attribute] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2614),
    [anon_sym___declspec] = ACTIONS(2612),
    [anon_sym___based] = ACTIONS(2612),
    [anon_sym_signed] = ACTIONS(2612),
    [anon_sym_unsigned] = ACTIONS(2612),
    [anon_sym_long] = ACTIONS(2612),
    [anon_sym_short] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2612),
    [anon_sym_register] = ACTIONS(2612),
    [anon_sym_inline] = ACTIONS(2612),
    [anon_sym___inline] = ACTIONS(2612),
    [anon_sym___inline__] = ACTIONS(2612),
    [anon_sym___forceinline] = ACTIONS(2612),
    [anon_sym_thread_local] = ACTIONS(2612),
    [anon_sym___thread] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_constexpr] = ACTIONS(2612),
    [anon_sym_volatile] = ACTIONS(2612),
    [anon_sym_restrict] = ACTIONS(2612),
    [anon_sym___restrict__] = ACTIONS(2612),
    [anon_sym__Atomic] = ACTIONS(2612),
    [anon_sym__Noreturn] = ACTIONS(2612),
    [anon_sym_noreturn] = ACTIONS(2612),
    [anon_sym__Nonnull] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_constinit] = ACTIONS(2612),
    [anon_sym_consteval] = ACTIONS(2612),
    [anon_sym_alignas] = ACTIONS(2612),
    [anon_sym__Alignas] = ACTIONS(2612),
    [sym_primitive_type] = ACTIONS(2612),
    [anon_sym_enum] = ACTIONS(2612),
    [anon_sym_class] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_union] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2612),
    [anon_sym_decltype] = ACTIONS(2612),
    [anon_sym_explicit] = ACTIONS(2612),
    [anon_sym_typename] = ACTIONS(2612),
    [anon_sym_private] = ACTIONS(2612),
    [anon_sym_template] = ACTIONS(2612),
    [anon_sym_operator] = ACTIONS(2612),
    [anon_sym_friend] = ACTIONS(2612),
    [anon_sym_public] = ACTIONS(2612),
    [anon_sym_protected] = ACTIONS(2612),
    [anon_sym_static_assert] = ACTIONS(2612),
    [anon_sym_precise] = ACTIONS(2612),
    [anon_sym_shared] = ACTIONS(2612),
    [anon_sym_groupshared] = ACTIONS(2612),
    [anon_sym_uniform] = ACTIONS(2612),
    [anon_sym_row_major] = ACTIONS(2612),
    [anon_sym_column_major] = ACTIONS(2612),
    [anon_sym_globallycoherent] = ACTIONS(2612),
    [anon_sym_centroid] = ACTIONS(2612),
    [anon_sym_noperspective] = ACTIONS(2612),
    [anon_sym_nointerpolation] = ACTIONS(2612),
    [anon_sym_sample] = ACTIONS(2612),
    [anon_sym_linear] = ACTIONS(2612),
    [anon_sym_snorm] = ACTIONS(2612),
    [anon_sym_unorm] = ACTIONS(2612),
    [anon_sym_point] = ACTIONS(2612),
    [anon_sym_line] = ACTIONS(2612),
    [anon_sym_triangleadj] = ACTIONS(2612),
    [anon_sym_lineadj] = ACTIONS(2612),
    [anon_sym_triangle] = ACTIONS(2612),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(5635),
    [aux_sym_preproc_def_token1] = ACTIONS(5635),
    [aux_sym_preproc_if_token1] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5635),
    [sym_preproc_directive] = ACTIONS(5635),
    [anon_sym_LPAREN2] = ACTIONS(5637),
    [anon_sym_TILDE] = ACTIONS(5637),
    [anon_sym_STAR] = ACTIONS(5637),
    [anon_sym_AMP_AMP] = ACTIONS(5637),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SEMI] = ACTIONS(5637),
    [anon_sym___extension__] = ACTIONS(5635),
    [anon_sym_typedef] = ACTIONS(5635),
    [anon_sym_in] = ACTIONS(5635),
    [anon_sym_out] = ACTIONS(5635),
    [anon_sym_inout] = ACTIONS(5635),
    [anon_sym_virtual] = ACTIONS(5635),
    [anon_sym_extern] = ACTIONS(5635),
    [anon_sym___attribute__] = ACTIONS(5635),
    [anon_sym___attribute] = ACTIONS(5635),
    [anon_sym_using] = ACTIONS(5635),
    [anon_sym_COLON_COLON] = ACTIONS(5637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5637),
    [anon_sym___declspec] = ACTIONS(5635),
    [anon_sym___based] = ACTIONS(5635),
    [anon_sym_RBRACE] = ACTIONS(5637),
    [anon_sym_signed] = ACTIONS(5635),
    [anon_sym_unsigned] = ACTIONS(5635),
    [anon_sym_long] = ACTIONS(5635),
    [anon_sym_short] = ACTIONS(5635),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_static] = ACTIONS(5635),
    [anon_sym_register] = ACTIONS(5635),
    [anon_sym_inline] = ACTIONS(5635),
    [anon_sym___inline] = ACTIONS(5635),
    [anon_sym___inline__] = ACTIONS(5635),
    [anon_sym___forceinline] = ACTIONS(5635),
    [anon_sym_thread_local] = ACTIONS(5635),
    [anon_sym___thread] = ACTIONS(5635),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5635),
    [anon_sym_volatile] = ACTIONS(5635),
    [anon_sym_restrict] = ACTIONS(5635),
    [anon_sym___restrict__] = ACTIONS(5635),
    [anon_sym__Atomic] = ACTIONS(5635),
    [anon_sym__Noreturn] = ACTIONS(5635),
    [anon_sym_noreturn] = ACTIONS(5635),
    [anon_sym__Nonnull] = ACTIONS(5635),
    [anon_sym_mutable] = ACTIONS(5635),
    [anon_sym_constinit] = ACTIONS(5635),
    [anon_sym_consteval] = ACTIONS(5635),
    [anon_sym_alignas] = ACTIONS(5635),
    [anon_sym__Alignas] = ACTIONS(5635),
    [sym_primitive_type] = ACTIONS(5635),
    [anon_sym_enum] = ACTIONS(5635),
    [anon_sym_class] = ACTIONS(5635),
    [anon_sym_struct] = ACTIONS(5635),
    [anon_sym_union] = ACTIONS(5635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5635),
    [anon_sym_decltype] = ACTIONS(5635),
    [anon_sym_explicit] = ACTIONS(5635),
    [anon_sym_typename] = ACTIONS(5635),
    [anon_sym_private] = ACTIONS(5635),
    [anon_sym_template] = ACTIONS(5635),
    [anon_sym_operator] = ACTIONS(5635),
    [anon_sym_friend] = ACTIONS(5635),
    [anon_sym_public] = ACTIONS(5635),
    [anon_sym_protected] = ACTIONS(5635),
    [anon_sym_static_assert] = ACTIONS(5635),
    [anon_sym_precise] = ACTIONS(5635),
    [anon_sym_shared] = ACTIONS(5635),
    [anon_sym_groupshared] = ACTIONS(5635),
    [anon_sym_uniform] = ACTIONS(5635),
    [anon_sym_row_major] = ACTIONS(5635),
    [anon_sym_column_major] = ACTIONS(5635),
    [anon_sym_globallycoherent] = ACTIONS(5635),
    [anon_sym_centroid] = ACTIONS(5635),
    [anon_sym_noperspective] = ACTIONS(5635),
    [anon_sym_nointerpolation] = ACTIONS(5635),
    [anon_sym_sample] = ACTIONS(5635),
    [anon_sym_linear] = ACTIONS(5635),
    [anon_sym_snorm] = ACTIONS(5635),
    [anon_sym_unorm] = ACTIONS(5635),
    [anon_sym_point] = ACTIONS(5635),
    [anon_sym_line] = ACTIONS(5635),
    [anon_sym_triangleadj] = ACTIONS(5635),
    [anon_sym_lineadj] = ACTIONS(5635),
    [anon_sym_triangle] = ACTIONS(5635),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(5639),
    [aux_sym_preproc_def_token1] = ACTIONS(5639),
    [aux_sym_preproc_if_token1] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5639),
    [sym_preproc_directive] = ACTIONS(5639),
    [anon_sym_LPAREN2] = ACTIONS(5641),
    [anon_sym_TILDE] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(5641),
    [anon_sym_AMP_AMP] = ACTIONS(5641),
    [anon_sym_AMP] = ACTIONS(5639),
    [anon_sym_SEMI] = ACTIONS(5641),
    [anon_sym___extension__] = ACTIONS(5639),
    [anon_sym_typedef] = ACTIONS(5639),
    [anon_sym_in] = ACTIONS(5639),
    [anon_sym_out] = ACTIONS(5639),
    [anon_sym_inout] = ACTIONS(5639),
    [anon_sym_virtual] = ACTIONS(5639),
    [anon_sym_extern] = ACTIONS(5639),
    [anon_sym___attribute__] = ACTIONS(5639),
    [anon_sym___attribute] = ACTIONS(5639),
    [anon_sym_using] = ACTIONS(5639),
    [anon_sym_COLON_COLON] = ACTIONS(5641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5641),
    [anon_sym___declspec] = ACTIONS(5639),
    [anon_sym___based] = ACTIONS(5639),
    [anon_sym_RBRACE] = ACTIONS(5641),
    [anon_sym_signed] = ACTIONS(5639),
    [anon_sym_unsigned] = ACTIONS(5639),
    [anon_sym_long] = ACTIONS(5639),
    [anon_sym_short] = ACTIONS(5639),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_static] = ACTIONS(5639),
    [anon_sym_register] = ACTIONS(5639),
    [anon_sym_inline] = ACTIONS(5639),
    [anon_sym___inline] = ACTIONS(5639),
    [anon_sym___inline__] = ACTIONS(5639),
    [anon_sym___forceinline] = ACTIONS(5639),
    [anon_sym_thread_local] = ACTIONS(5639),
    [anon_sym___thread] = ACTIONS(5639),
    [anon_sym_const] = ACTIONS(5639),
    [anon_sym_constexpr] = ACTIONS(5639),
    [anon_sym_volatile] = ACTIONS(5639),
    [anon_sym_restrict] = ACTIONS(5639),
    [anon_sym___restrict__] = ACTIONS(5639),
    [anon_sym__Atomic] = ACTIONS(5639),
    [anon_sym__Noreturn] = ACTIONS(5639),
    [anon_sym_noreturn] = ACTIONS(5639),
    [anon_sym__Nonnull] = ACTIONS(5639),
    [anon_sym_mutable] = ACTIONS(5639),
    [anon_sym_constinit] = ACTIONS(5639),
    [anon_sym_consteval] = ACTIONS(5639),
    [anon_sym_alignas] = ACTIONS(5639),
    [anon_sym__Alignas] = ACTIONS(5639),
    [sym_primitive_type] = ACTIONS(5639),
    [anon_sym_enum] = ACTIONS(5639),
    [anon_sym_class] = ACTIONS(5639),
    [anon_sym_struct] = ACTIONS(5639),
    [anon_sym_union] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5639),
    [anon_sym_decltype] = ACTIONS(5639),
    [anon_sym_explicit] = ACTIONS(5639),
    [anon_sym_typename] = ACTIONS(5639),
    [anon_sym_private] = ACTIONS(5639),
    [anon_sym_template] = ACTIONS(5639),
    [anon_sym_operator] = ACTIONS(5639),
    [anon_sym_friend] = ACTIONS(5639),
    [anon_sym_public] = ACTIONS(5639),
    [anon_sym_protected] = ACTIONS(5639),
    [anon_sym_static_assert] = ACTIONS(5639),
    [anon_sym_precise] = ACTIONS(5639),
    [anon_sym_shared] = ACTIONS(5639),
    [anon_sym_groupshared] = ACTIONS(5639),
    [anon_sym_uniform] = ACTIONS(5639),
    [anon_sym_row_major] = ACTIONS(5639),
    [anon_sym_column_major] = ACTIONS(5639),
    [anon_sym_globallycoherent] = ACTIONS(5639),
    [anon_sym_centroid] = ACTIONS(5639),
    [anon_sym_noperspective] = ACTIONS(5639),
    [anon_sym_nointerpolation] = ACTIONS(5639),
    [anon_sym_sample] = ACTIONS(5639),
    [anon_sym_linear] = ACTIONS(5639),
    [anon_sym_snorm] = ACTIONS(5639),
    [anon_sym_unorm] = ACTIONS(5639),
    [anon_sym_point] = ACTIONS(5639),
    [anon_sym_line] = ACTIONS(5639),
    [anon_sym_triangleadj] = ACTIONS(5639),
    [anon_sym_lineadj] = ACTIONS(5639),
    [anon_sym_triangle] = ACTIONS(5639),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(2620),
    [aux_sym_preproc_def_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token1] = ACTIONS(2620),
    [aux_sym_preproc_if_token2] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2620),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2620),
    [sym_preproc_directive] = ACTIONS(2620),
    [anon_sym_LPAREN2] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2622),
    [anon_sym_STAR] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_AMP] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym___extension__] = ACTIONS(2620),
    [anon_sym_typedef] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_out] = ACTIONS(2620),
    [anon_sym_inout] = ACTIONS(2620),
    [anon_sym_virtual] = ACTIONS(2620),
    [anon_sym_extern] = ACTIONS(2620),
    [anon_sym___attribute__] = ACTIONS(2620),
    [anon_sym___attribute] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2622),
    [anon_sym___declspec] = ACTIONS(2620),
    [anon_sym___based] = ACTIONS(2620),
    [anon_sym_signed] = ACTIONS(2620),
    [anon_sym_unsigned] = ACTIONS(2620),
    [anon_sym_long] = ACTIONS(2620),
    [anon_sym_short] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2620),
    [anon_sym_register] = ACTIONS(2620),
    [anon_sym_inline] = ACTIONS(2620),
    [anon_sym___inline] = ACTIONS(2620),
    [anon_sym___inline__] = ACTIONS(2620),
    [anon_sym___forceinline] = ACTIONS(2620),
    [anon_sym_thread_local] = ACTIONS(2620),
    [anon_sym___thread] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_constexpr] = ACTIONS(2620),
    [anon_sym_volatile] = ACTIONS(2620),
    [anon_sym_restrict] = ACTIONS(2620),
    [anon_sym___restrict__] = ACTIONS(2620),
    [anon_sym__Atomic] = ACTIONS(2620),
    [anon_sym__Noreturn] = ACTIONS(2620),
    [anon_sym_noreturn] = ACTIONS(2620),
    [anon_sym__Nonnull] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_constinit] = ACTIONS(2620),
    [anon_sym_consteval] = ACTIONS(2620),
    [anon_sym_alignas] = ACTIONS(2620),
    [anon_sym__Alignas] = ACTIONS(2620),
    [sym_primitive_type] = ACTIONS(2620),
    [anon_sym_enum] = ACTIONS(2620),
    [anon_sym_class] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_union] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2620),
    [anon_sym_decltype] = ACTIONS(2620),
    [anon_sym_explicit] = ACTIONS(2620),
    [anon_sym_typename] = ACTIONS(2620),
    [anon_sym_private] = ACTIONS(2620),
    [anon_sym_template] = ACTIONS(2620),
    [anon_sym_operator] = ACTIONS(2620),
    [anon_sym_friend] = ACTIONS(2620),
    [anon_sym_public] = ACTIONS(2620),
    [anon_sym_protected] = ACTIONS(2620),
    [anon_sym_static_assert] = ACTIONS(2620),
    [anon_sym_precise] = ACTIONS(2620),
    [anon_sym_shared] = ACTIONS(2620),
    [anon_sym_groupshared] = ACTIONS(2620),
    [anon_sym_uniform] = ACTIONS(2620),
    [anon_sym_row_major] = ACTIONS(2620),
    [anon_sym_column_major] = ACTIONS(2620),
    [anon_sym_globallycoherent] = ACTIONS(2620),
    [anon_sym_centroid] = ACTIONS(2620),
    [anon_sym_noperspective] = ACTIONS(2620),
    [anon_sym_nointerpolation] = ACTIONS(2620),
    [anon_sym_sample] = ACTIONS(2620),
    [anon_sym_linear] = ACTIONS(2620),
    [anon_sym_snorm] = ACTIONS(2620),
    [anon_sym_unorm] = ACTIONS(2620),
    [anon_sym_point] = ACTIONS(2620),
    [anon_sym_line] = ACTIONS(2620),
    [anon_sym_triangleadj] = ACTIONS(2620),
    [anon_sym_lineadj] = ACTIONS(2620),
    [anon_sym_triangle] = ACTIONS(2620),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(2624),
    [aux_sym_preproc_def_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token1] = ACTIONS(2624),
    [aux_sym_preproc_if_token2] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2624),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2624),
    [sym_preproc_directive] = ACTIONS(2624),
    [anon_sym_LPAREN2] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2626),
    [anon_sym_STAR] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_AMP] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym___extension__] = ACTIONS(2624),
    [anon_sym_typedef] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_out] = ACTIONS(2624),
    [anon_sym_inout] = ACTIONS(2624),
    [anon_sym_virtual] = ACTIONS(2624),
    [anon_sym_extern] = ACTIONS(2624),
    [anon_sym___attribute__] = ACTIONS(2624),
    [anon_sym___attribute] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2626),
    [anon_sym___declspec] = ACTIONS(2624),
    [anon_sym___based] = ACTIONS(2624),
    [anon_sym_signed] = ACTIONS(2624),
    [anon_sym_unsigned] = ACTIONS(2624),
    [anon_sym_long] = ACTIONS(2624),
    [anon_sym_short] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2624),
    [anon_sym_register] = ACTIONS(2624),
    [anon_sym_inline] = ACTIONS(2624),
    [anon_sym___inline] = ACTIONS(2624),
    [anon_sym___inline__] = ACTIONS(2624),
    [anon_sym___forceinline] = ACTIONS(2624),
    [anon_sym_thread_local] = ACTIONS(2624),
    [anon_sym___thread] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_constexpr] = ACTIONS(2624),
    [anon_sym_volatile] = ACTIONS(2624),
    [anon_sym_restrict] = ACTIONS(2624),
    [anon_sym___restrict__] = ACTIONS(2624),
    [anon_sym__Atomic] = ACTIONS(2624),
    [anon_sym__Noreturn] = ACTIONS(2624),
    [anon_sym_noreturn] = ACTIONS(2624),
    [anon_sym__Nonnull] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_constinit] = ACTIONS(2624),
    [anon_sym_consteval] = ACTIONS(2624),
    [anon_sym_alignas] = ACTIONS(2624),
    [anon_sym__Alignas] = ACTIONS(2624),
    [sym_primitive_type] = ACTIONS(2624),
    [anon_sym_enum] = ACTIONS(2624),
    [anon_sym_class] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_union] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2624),
    [anon_sym_decltype] = ACTIONS(2624),
    [anon_sym_explicit] = ACTIONS(2624),
    [anon_sym_typename] = ACTIONS(2624),
    [anon_sym_private] = ACTIONS(2624),
    [anon_sym_template] = ACTIONS(2624),
    [anon_sym_operator] = ACTIONS(2624),
    [anon_sym_friend] = ACTIONS(2624),
    [anon_sym_public] = ACTIONS(2624),
    [anon_sym_protected] = ACTIONS(2624),
    [anon_sym_static_assert] = ACTIONS(2624),
    [anon_sym_precise] = ACTIONS(2624),
    [anon_sym_shared] = ACTIONS(2624),
    [anon_sym_groupshared] = ACTIONS(2624),
    [anon_sym_uniform] = ACTIONS(2624),
    [anon_sym_row_major] = ACTIONS(2624),
    [anon_sym_column_major] = ACTIONS(2624),
    [anon_sym_globallycoherent] = ACTIONS(2624),
    [anon_sym_centroid] = ACTIONS(2624),
    [anon_sym_noperspective] = ACTIONS(2624),
    [anon_sym_nointerpolation] = ACTIONS(2624),
    [anon_sym_sample] = ACTIONS(2624),
    [anon_sym_linear] = ACTIONS(2624),
    [anon_sym_snorm] = ACTIONS(2624),
    [anon_sym_unorm] = ACTIONS(2624),
    [anon_sym_point] = ACTIONS(2624),
    [anon_sym_line] = ACTIONS(2624),
    [anon_sym_triangleadj] = ACTIONS(2624),
    [anon_sym_lineadj] = ACTIONS(2624),
    [anon_sym_triangle] = ACTIONS(2624),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(2628),
    [aux_sym_preproc_def_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token1] = ACTIONS(2628),
    [aux_sym_preproc_if_token2] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2628),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2628),
    [sym_preproc_directive] = ACTIONS(2628),
    [anon_sym_LPAREN2] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_STAR] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_AMP] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym___extension__] = ACTIONS(2628),
    [anon_sym_typedef] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_out] = ACTIONS(2628),
    [anon_sym_inout] = ACTIONS(2628),
    [anon_sym_virtual] = ACTIONS(2628),
    [anon_sym_extern] = ACTIONS(2628),
    [anon_sym___attribute__] = ACTIONS(2628),
    [anon_sym___attribute] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2630),
    [anon_sym___declspec] = ACTIONS(2628),
    [anon_sym___based] = ACTIONS(2628),
    [anon_sym_signed] = ACTIONS(2628),
    [anon_sym_unsigned] = ACTIONS(2628),
    [anon_sym_long] = ACTIONS(2628),
    [anon_sym_short] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2628),
    [anon_sym_register] = ACTIONS(2628),
    [anon_sym_inline] = ACTIONS(2628),
    [anon_sym___inline] = ACTIONS(2628),
    [anon_sym___inline__] = ACTIONS(2628),
    [anon_sym___forceinline] = ACTIONS(2628),
    [anon_sym_thread_local] = ACTIONS(2628),
    [anon_sym___thread] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_constexpr] = ACTIONS(2628),
    [anon_sym_volatile] = ACTIONS(2628),
    [anon_sym_restrict] = ACTIONS(2628),
    [anon_sym___restrict__] = ACTIONS(2628),
    [anon_sym__Atomic] = ACTIONS(2628),
    [anon_sym__Noreturn] = ACTIONS(2628),
    [anon_sym_noreturn] = ACTIONS(2628),
    [anon_sym__Nonnull] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_constinit] = ACTIONS(2628),
    [anon_sym_consteval] = ACTIONS(2628),
    [anon_sym_alignas] = ACTIONS(2628),
    [anon_sym__Alignas] = ACTIONS(2628),
    [sym_primitive_type] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_union] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2628),
    [anon_sym_decltype] = ACTIONS(2628),
    [anon_sym_explicit] = ACTIONS(2628),
    [anon_sym_typename] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_template] = ACTIONS(2628),
    [anon_sym_operator] = ACTIONS(2628),
    [anon_sym_friend] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_static_assert] = ACTIONS(2628),
    [anon_sym_precise] = ACTIONS(2628),
    [anon_sym_shared] = ACTIONS(2628),
    [anon_sym_groupshared] = ACTIONS(2628),
    [anon_sym_uniform] = ACTIONS(2628),
    [anon_sym_row_major] = ACTIONS(2628),
    [anon_sym_column_major] = ACTIONS(2628),
    [anon_sym_globallycoherent] = ACTIONS(2628),
    [anon_sym_centroid] = ACTIONS(2628),
    [anon_sym_noperspective] = ACTIONS(2628),
    [anon_sym_nointerpolation] = ACTIONS(2628),
    [anon_sym_sample] = ACTIONS(2628),
    [anon_sym_linear] = ACTIONS(2628),
    [anon_sym_snorm] = ACTIONS(2628),
    [anon_sym_unorm] = ACTIONS(2628),
    [anon_sym_point] = ACTIONS(2628),
    [anon_sym_line] = ACTIONS(2628),
    [anon_sym_triangleadj] = ACTIONS(2628),
    [anon_sym_lineadj] = ACTIONS(2628),
    [anon_sym_triangle] = ACTIONS(2628),
  },
  [2169] = {
    [sym_identifier] = ACTIONS(2632),
    [aux_sym_preproc_def_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token1] = ACTIONS(2632),
    [aux_sym_preproc_if_token2] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2632),
    [sym_preproc_directive] = ACTIONS(2632),
    [anon_sym_LPAREN2] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2634),
    [anon_sym_STAR] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym___extension__] = ACTIONS(2632),
    [anon_sym_typedef] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_out] = ACTIONS(2632),
    [anon_sym_inout] = ACTIONS(2632),
    [anon_sym_virtual] = ACTIONS(2632),
    [anon_sym_extern] = ACTIONS(2632),
    [anon_sym___attribute__] = ACTIONS(2632),
    [anon_sym___attribute] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2634),
    [anon_sym___declspec] = ACTIONS(2632),
    [anon_sym___based] = ACTIONS(2632),
    [anon_sym_signed] = ACTIONS(2632),
    [anon_sym_unsigned] = ACTIONS(2632),
    [anon_sym_long] = ACTIONS(2632),
    [anon_sym_short] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2632),
    [anon_sym_register] = ACTIONS(2632),
    [anon_sym_inline] = ACTIONS(2632),
    [anon_sym___inline] = ACTIONS(2632),
    [anon_sym___inline__] = ACTIONS(2632),
    [anon_sym___forceinline] = ACTIONS(2632),
    [anon_sym_thread_local] = ACTIONS(2632),
    [anon_sym___thread] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_constexpr] = ACTIONS(2632),
    [anon_sym_volatile] = ACTIONS(2632),
    [anon_sym_restrict] = ACTIONS(2632),
    [anon_sym___restrict__] = ACTIONS(2632),
    [anon_sym__Atomic] = ACTIONS(2632),
    [anon_sym__Noreturn] = ACTIONS(2632),
    [anon_sym_noreturn] = ACTIONS(2632),
    [anon_sym__Nonnull] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_constinit] = ACTIONS(2632),
    [anon_sym_consteval] = ACTIONS(2632),
    [anon_sym_alignas] = ACTIONS(2632),
    [anon_sym__Alignas] = ACTIONS(2632),
    [sym_primitive_type] = ACTIONS(2632),
    [anon_sym_enum] = ACTIONS(2632),
    [anon_sym_class] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_union] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2632),
    [anon_sym_decltype] = ACTIONS(2632),
    [anon_sym_explicit] = ACTIONS(2632),
    [anon_sym_typename] = ACTIONS(2632),
    [anon_sym_private] = ACTIONS(2632),
    [anon_sym_template] = ACTIONS(2632),
    [anon_sym_operator] = ACTIONS(2632),
    [anon_sym_friend] = ACTIONS(2632),
    [anon_sym_public] = ACTIONS(2632),
    [anon_sym_protected] = ACTIONS(2632),
    [anon_sym_static_assert] = ACTIONS(2632),
    [anon_sym_precise] = ACTIONS(2632),
    [anon_sym_shared] = ACTIONS(2632),
    [anon_sym_groupshared] = ACTIONS(2632),
    [anon_sym_uniform] = ACTIONS(2632),
    [anon_sym_row_major] = ACTIONS(2632),
    [anon_sym_column_major] = ACTIONS(2632),
    [anon_sym_globallycoherent] = ACTIONS(2632),
    [anon_sym_centroid] = ACTIONS(2632),
    [anon_sym_noperspective] = ACTIONS(2632),
    [anon_sym_nointerpolation] = ACTIONS(2632),
    [anon_sym_sample] = ACTIONS(2632),
    [anon_sym_linear] = ACTIONS(2632),
    [anon_sym_snorm] = ACTIONS(2632),
    [anon_sym_unorm] = ACTIONS(2632),
    [anon_sym_point] = ACTIONS(2632),
    [anon_sym_line] = ACTIONS(2632),
    [anon_sym_triangleadj] = ACTIONS(2632),
    [anon_sym_lineadj] = ACTIONS(2632),
    [anon_sym_triangle] = ACTIONS(2632),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(2636),
    [aux_sym_preproc_def_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token1] = ACTIONS(2636),
    [aux_sym_preproc_if_token2] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2636),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2636),
    [sym_preproc_directive] = ACTIONS(2636),
    [anon_sym_LPAREN2] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2638),
    [anon_sym_STAR] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym___extension__] = ACTIONS(2636),
    [anon_sym_typedef] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_out] = ACTIONS(2636),
    [anon_sym_inout] = ACTIONS(2636),
    [anon_sym_virtual] = ACTIONS(2636),
    [anon_sym_extern] = ACTIONS(2636),
    [anon_sym___attribute__] = ACTIONS(2636),
    [anon_sym___attribute] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2638),
    [anon_sym___declspec] = ACTIONS(2636),
    [anon_sym___based] = ACTIONS(2636),
    [anon_sym_signed] = ACTIONS(2636),
    [anon_sym_unsigned] = ACTIONS(2636),
    [anon_sym_long] = ACTIONS(2636),
    [anon_sym_short] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2636),
    [anon_sym_register] = ACTIONS(2636),
    [anon_sym_inline] = ACTIONS(2636),
    [anon_sym___inline] = ACTIONS(2636),
    [anon_sym___inline__] = ACTIONS(2636),
    [anon_sym___forceinline] = ACTIONS(2636),
    [anon_sym_thread_local] = ACTIONS(2636),
    [anon_sym___thread] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_constexpr] = ACTIONS(2636),
    [anon_sym_volatile] = ACTIONS(2636),
    [anon_sym_restrict] = ACTIONS(2636),
    [anon_sym___restrict__] = ACTIONS(2636),
    [anon_sym__Atomic] = ACTIONS(2636),
    [anon_sym__Noreturn] = ACTIONS(2636),
    [anon_sym_noreturn] = ACTIONS(2636),
    [anon_sym__Nonnull] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_constinit] = ACTIONS(2636),
    [anon_sym_consteval] = ACTIONS(2636),
    [anon_sym_alignas] = ACTIONS(2636),
    [anon_sym__Alignas] = ACTIONS(2636),
    [sym_primitive_type] = ACTIONS(2636),
    [anon_sym_enum] = ACTIONS(2636),
    [anon_sym_class] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_union] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2636),
    [anon_sym_decltype] = ACTIONS(2636),
    [anon_sym_explicit] = ACTIONS(2636),
    [anon_sym_typename] = ACTIONS(2636),
    [anon_sym_private] = ACTIONS(2636),
    [anon_sym_template] = ACTIONS(2636),
    [anon_sym_operator] = ACTIONS(2636),
    [anon_sym_friend] = ACTIONS(2636),
    [anon_sym_public] = ACTIONS(2636),
    [anon_sym_protected] = ACTIONS(2636),
    [anon_sym_static_assert] = ACTIONS(2636),
    [anon_sym_precise] = ACTIONS(2636),
    [anon_sym_shared] = ACTIONS(2636),
    [anon_sym_groupshared] = ACTIONS(2636),
    [anon_sym_uniform] = ACTIONS(2636),
    [anon_sym_row_major] = ACTIONS(2636),
    [anon_sym_column_major] = ACTIONS(2636),
    [anon_sym_globallycoherent] = ACTIONS(2636),
    [anon_sym_centroid] = ACTIONS(2636),
    [anon_sym_noperspective] = ACTIONS(2636),
    [anon_sym_nointerpolation] = ACTIONS(2636),
    [anon_sym_sample] = ACTIONS(2636),
    [anon_sym_linear] = ACTIONS(2636),
    [anon_sym_snorm] = ACTIONS(2636),
    [anon_sym_unorm] = ACTIONS(2636),
    [anon_sym_point] = ACTIONS(2636),
    [anon_sym_line] = ACTIONS(2636),
    [anon_sym_triangleadj] = ACTIONS(2636),
    [anon_sym_lineadj] = ACTIONS(2636),
    [anon_sym_triangle] = ACTIONS(2636),
  },
  [2171] = {
    [sym_identifier] = ACTIONS(2652),
    [aux_sym_preproc_def_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token1] = ACTIONS(2652),
    [aux_sym_preproc_if_token2] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2652),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2652),
    [sym_preproc_directive] = ACTIONS(2652),
    [anon_sym_LPAREN2] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2654),
    [anon_sym___extension__] = ACTIONS(2652),
    [anon_sym_typedef] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2652),
    [anon_sym_out] = ACTIONS(2652),
    [anon_sym_inout] = ACTIONS(2652),
    [anon_sym_virtual] = ACTIONS(2652),
    [anon_sym_extern] = ACTIONS(2652),
    [anon_sym___attribute__] = ACTIONS(2652),
    [anon_sym___attribute] = ACTIONS(2652),
    [anon_sym_using] = ACTIONS(2652),
    [anon_sym_COLON_COLON] = ACTIONS(2654),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2654),
    [anon_sym___declspec] = ACTIONS(2652),
    [anon_sym___based] = ACTIONS(2652),
    [anon_sym_signed] = ACTIONS(2652),
    [anon_sym_unsigned] = ACTIONS(2652),
    [anon_sym_long] = ACTIONS(2652),
    [anon_sym_short] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2652),
    [anon_sym_register] = ACTIONS(2652),
    [anon_sym_inline] = ACTIONS(2652),
    [anon_sym___inline] = ACTIONS(2652),
    [anon_sym___inline__] = ACTIONS(2652),
    [anon_sym___forceinline] = ACTIONS(2652),
    [anon_sym_thread_local] = ACTIONS(2652),
    [anon_sym___thread] = ACTIONS(2652),
    [anon_sym_const] = ACTIONS(2652),
    [anon_sym_constexpr] = ACTIONS(2652),
    [anon_sym_volatile] = ACTIONS(2652),
    [anon_sym_restrict] = ACTIONS(2652),
    [anon_sym___restrict__] = ACTIONS(2652),
    [anon_sym__Atomic] = ACTIONS(2652),
    [anon_sym__Noreturn] = ACTIONS(2652),
    [anon_sym_noreturn] = ACTIONS(2652),
    [anon_sym__Nonnull] = ACTIONS(2652),
    [anon_sym_mutable] = ACTIONS(2652),
    [anon_sym_constinit] = ACTIONS(2652),
    [anon_sym_consteval] = ACTIONS(2652),
    [anon_sym_alignas] = ACTIONS(2652),
    [anon_sym__Alignas] = ACTIONS(2652),
    [sym_primitive_type] = ACTIONS(2652),
    [anon_sym_enum] = ACTIONS(2652),
    [anon_sym_class] = ACTIONS(2652),
    [anon_sym_struct] = ACTIONS(2652),
    [anon_sym_union] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2652),
    [anon_sym_decltype] = ACTIONS(2652),
    [anon_sym_explicit] = ACTIONS(2652),
    [anon_sym_typename] = ACTIONS(2652),
    [anon_sym_private] = ACTIONS(2652),
    [anon_sym_template] = ACTIONS(2652),
    [anon_sym_operator] = ACTIONS(2652),
    [anon_sym_friend] = ACTIONS(2652),
    [anon_sym_public] = ACTIONS(2652),
    [anon_sym_protected] = ACTIONS(2652),
    [anon_sym_static_assert] = ACTIONS(2652),
    [anon_sym_precise] = ACTIONS(2652),
    [anon_sym_shared] = ACTIONS(2652),
    [anon_sym_groupshared] = ACTIONS(2652),
    [anon_sym_uniform] = ACTIONS(2652),
    [anon_sym_row_major] = ACTIONS(2652),
    [anon_sym_column_major] = ACTIONS(2652),
    [anon_sym_globallycoherent] = ACTIONS(2652),
    [anon_sym_centroid] = ACTIONS(2652),
    [anon_sym_noperspective] = ACTIONS(2652),
    [anon_sym_nointerpolation] = ACTIONS(2652),
    [anon_sym_sample] = ACTIONS(2652),
    [anon_sym_linear] = ACTIONS(2652),
    [anon_sym_snorm] = ACTIONS(2652),
    [anon_sym_unorm] = ACTIONS(2652),
    [anon_sym_point] = ACTIONS(2652),
    [anon_sym_line] = ACTIONS(2652),
    [anon_sym_triangleadj] = ACTIONS(2652),
    [anon_sym_lineadj] = ACTIONS(2652),
    [anon_sym_triangle] = ACTIONS(2652),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(5535),
    [aux_sym_preproc_def_token1] = ACTIONS(5535),
    [aux_sym_preproc_if_token1] = ACTIONS(5535),
    [aux_sym_preproc_if_token2] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5535),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5535),
    [sym_preproc_directive] = ACTIONS(5535),
    [anon_sym_LPAREN2] = ACTIONS(5537),
    [anon_sym_TILDE] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_AMP_AMP] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5535),
    [anon_sym_SEMI] = ACTIONS(5537),
    [anon_sym___extension__] = ACTIONS(5535),
    [anon_sym_typedef] = ACTIONS(5535),
    [anon_sym_in] = ACTIONS(5535),
    [anon_sym_out] = ACTIONS(5535),
    [anon_sym_inout] = ACTIONS(5535),
    [anon_sym_virtual] = ACTIONS(5535),
    [anon_sym_extern] = ACTIONS(5535),
    [anon_sym___attribute__] = ACTIONS(5535),
    [anon_sym___attribute] = ACTIONS(5535),
    [anon_sym_using] = ACTIONS(5535),
    [anon_sym_COLON_COLON] = ACTIONS(5537),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5537),
    [anon_sym___declspec] = ACTIONS(5535),
    [anon_sym___based] = ACTIONS(5535),
    [anon_sym_signed] = ACTIONS(5535),
    [anon_sym_unsigned] = ACTIONS(5535),
    [anon_sym_long] = ACTIONS(5535),
    [anon_sym_short] = ACTIONS(5535),
    [anon_sym_LBRACK] = ACTIONS(5535),
    [anon_sym_static] = ACTIONS(5535),
    [anon_sym_register] = ACTIONS(5535),
    [anon_sym_inline] = ACTIONS(5535),
    [anon_sym___inline] = ACTIONS(5535),
    [anon_sym___inline__] = ACTIONS(5535),
    [anon_sym___forceinline] = ACTIONS(5535),
    [anon_sym_thread_local] = ACTIONS(5535),
    [anon_sym___thread] = ACTIONS(5535),
    [anon_sym_const] = ACTIONS(5535),
    [anon_sym_constexpr] = ACTIONS(5535),
    [anon_sym_volatile] = ACTIONS(5535),
    [anon_sym_restrict] = ACTIONS(5535),
    [anon_sym___restrict__] = ACTIONS(5535),
    [anon_sym__Atomic] = ACTIONS(5535),
    [anon_sym__Noreturn] = ACTIONS(5535),
    [anon_sym_noreturn] = ACTIONS(5535),
    [anon_sym__Nonnull] = ACTIONS(5535),
    [anon_sym_mutable] = ACTIONS(5535),
    [anon_sym_constinit] = ACTIONS(5535),
    [anon_sym_consteval] = ACTIONS(5535),
    [anon_sym_alignas] = ACTIONS(5535),
    [anon_sym__Alignas] = ACTIONS(5535),
    [sym_primitive_type] = ACTIONS(5535),
    [anon_sym_enum] = ACTIONS(5535),
    [anon_sym_class] = ACTIONS(5535),
    [anon_sym_struct] = ACTIONS(5535),
    [anon_sym_union] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5535),
    [anon_sym_decltype] = ACTIONS(5535),
    [anon_sym_explicit] = ACTIONS(5535),
    [anon_sym_typename] = ACTIONS(5535),
    [anon_sym_private] = ACTIONS(5535),
    [anon_sym_template] = ACTIONS(5535),
    [anon_sym_operator] = ACTIONS(5535),
    [anon_sym_friend] = ACTIONS(5535),
    [anon_sym_public] = ACTIONS(5535),
    [anon_sym_protected] = ACTIONS(5535),
    [anon_sym_static_assert] = ACTIONS(5535),
    [anon_sym_precise] = ACTIONS(5535),
    [anon_sym_shared] = ACTIONS(5535),
    [anon_sym_groupshared] = ACTIONS(5535),
    [anon_sym_uniform] = ACTIONS(5535),
    [anon_sym_row_major] = ACTIONS(5535),
    [anon_sym_column_major] = ACTIONS(5535),
    [anon_sym_globallycoherent] = ACTIONS(5535),
    [anon_sym_centroid] = ACTIONS(5535),
    [anon_sym_noperspective] = ACTIONS(5535),
    [anon_sym_nointerpolation] = ACTIONS(5535),
    [anon_sym_sample] = ACTIONS(5535),
    [anon_sym_linear] = ACTIONS(5535),
    [anon_sym_snorm] = ACTIONS(5535),
    [anon_sym_unorm] = ACTIONS(5535),
    [anon_sym_point] = ACTIONS(5535),
    [anon_sym_line] = ACTIONS(5535),
    [anon_sym_triangleadj] = ACTIONS(5535),
    [anon_sym_lineadj] = ACTIONS(5535),
    [anon_sym_triangle] = ACTIONS(5535),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5684),
    [anon_sym_AMP_AMP] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5682),
    [anon_sym___extension__] = ACTIONS(5682),
    [anon_sym_in] = ACTIONS(5682),
    [anon_sym_out] = ACTIONS(5682),
    [anon_sym_inout] = ACTIONS(5682),
    [anon_sym_virtual] = ACTIONS(5682),
    [anon_sym_extern] = ACTIONS(5682),
    [anon_sym___attribute__] = ACTIONS(5682),
    [anon_sym___attribute] = ACTIONS(5682),
    [anon_sym_using] = ACTIONS(5682),
    [anon_sym_COLON_COLON] = ACTIONS(5684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5684),
    [anon_sym___declspec] = ACTIONS(5682),
    [anon_sym___based] = ACTIONS(5682),
    [anon_sym___cdecl] = ACTIONS(5682),
    [anon_sym___clrcall] = ACTIONS(5682),
    [anon_sym___stdcall] = ACTIONS(5682),
    [anon_sym___fastcall] = ACTIONS(5682),
    [anon_sym___thiscall] = ACTIONS(5682),
    [anon_sym___vectorcall] = ACTIONS(5682),
    [anon_sym_LBRACE] = ACTIONS(5684),
    [anon_sym_signed] = ACTIONS(5682),
    [anon_sym_unsigned] = ACTIONS(5682),
    [anon_sym_long] = ACTIONS(5682),
    [anon_sym_short] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_static] = ACTIONS(5682),
    [anon_sym_register] = ACTIONS(5682),
    [anon_sym_inline] = ACTIONS(5682),
    [anon_sym___inline] = ACTIONS(5682),
    [anon_sym___inline__] = ACTIONS(5682),
    [anon_sym___forceinline] = ACTIONS(5682),
    [anon_sym_thread_local] = ACTIONS(5682),
    [anon_sym___thread] = ACTIONS(5682),
    [anon_sym_const] = ACTIONS(5682),
    [anon_sym_constexpr] = ACTIONS(5682),
    [anon_sym_volatile] = ACTIONS(5682),
    [anon_sym_restrict] = ACTIONS(5682),
    [anon_sym___restrict__] = ACTIONS(5682),
    [anon_sym__Atomic] = ACTIONS(5682),
    [anon_sym__Noreturn] = ACTIONS(5682),
    [anon_sym_noreturn] = ACTIONS(5682),
    [anon_sym__Nonnull] = ACTIONS(5682),
    [anon_sym_mutable] = ACTIONS(5682),
    [anon_sym_constinit] = ACTIONS(5682),
    [anon_sym_consteval] = ACTIONS(5682),
    [anon_sym_alignas] = ACTIONS(5682),
    [anon_sym__Alignas] = ACTIONS(5682),
    [sym_primitive_type] = ACTIONS(5682),
    [anon_sym_enum] = ACTIONS(5682),
    [anon_sym_class] = ACTIONS(5682),
    [anon_sym_struct] = ACTIONS(5682),
    [anon_sym_union] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5682),
    [anon_sym_decltype] = ACTIONS(5682),
    [anon_sym_explicit] = ACTIONS(5682),
    [anon_sym_typename] = ACTIONS(5682),
    [anon_sym_template] = ACTIONS(5682),
    [anon_sym_operator] = ACTIONS(5682),
    [anon_sym_friend] = ACTIONS(5682),
    [anon_sym_noexcept] = ACTIONS(5682),
    [anon_sym_throw] = ACTIONS(5682),
    [anon_sym_concept] = ACTIONS(5682),
    [anon_sym_requires] = ACTIONS(5682),
    [anon_sym_precise] = ACTIONS(5682),
    [anon_sym_shared] = ACTIONS(5682),
    [anon_sym_groupshared] = ACTIONS(5682),
    [anon_sym_uniform] = ACTIONS(5682),
    [anon_sym_row_major] = ACTIONS(5682),
    [anon_sym_column_major] = ACTIONS(5682),
    [anon_sym_globallycoherent] = ACTIONS(5682),
    [anon_sym_centroid] = ACTIONS(5682),
    [anon_sym_noperspective] = ACTIONS(5682),
    [anon_sym_nointerpolation] = ACTIONS(5682),
    [anon_sym_sample] = ACTIONS(5682),
    [anon_sym_linear] = ACTIONS(5682),
    [anon_sym_snorm] = ACTIONS(5682),
    [anon_sym_unorm] = ACTIONS(5682),
    [anon_sym_point] = ACTIONS(5682),
    [anon_sym_line] = ACTIONS(5682),
    [anon_sym_triangleadj] = ACTIONS(5682),
    [anon_sym_lineadj] = ACTIONS(5682),
    [anon_sym_triangle] = ACTIONS(5682),
  },
  [2174] = {
    [sym_identifier] = ACTIONS(2414),
    [aux_sym_preproc_def_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token1] = ACTIONS(2414),
    [aux_sym_preproc_if_token2] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2414),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2414),
    [sym_preproc_directive] = ACTIONS(2414),
    [anon_sym_LPAREN2] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym___extension__] = ACTIONS(2414),
    [anon_sym_typedef] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2414),
    [anon_sym_out] = ACTIONS(2414),
    [anon_sym_inout] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym___attribute__] = ACTIONS(2414),
    [anon_sym___attribute] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_COLON_COLON] = ACTIONS(2416),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2416),
    [anon_sym___declspec] = ACTIONS(2414),
    [anon_sym___based] = ACTIONS(2414),
    [anon_sym_signed] = ACTIONS(2414),
    [anon_sym_unsigned] = ACTIONS(2414),
    [anon_sym_long] = ACTIONS(2414),
    [anon_sym_short] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_register] = ACTIONS(2414),
    [anon_sym_inline] = ACTIONS(2414),
    [anon_sym___inline] = ACTIONS(2414),
    [anon_sym___inline__] = ACTIONS(2414),
    [anon_sym___forceinline] = ACTIONS(2414),
    [anon_sym_thread_local] = ACTIONS(2414),
    [anon_sym___thread] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_constexpr] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_restrict] = ACTIONS(2414),
    [anon_sym___restrict__] = ACTIONS(2414),
    [anon_sym__Atomic] = ACTIONS(2414),
    [anon_sym__Noreturn] = ACTIONS(2414),
    [anon_sym_noreturn] = ACTIONS(2414),
    [anon_sym__Nonnull] = ACTIONS(2414),
    [anon_sym_mutable] = ACTIONS(2414),
    [anon_sym_constinit] = ACTIONS(2414),
    [anon_sym_consteval] = ACTIONS(2414),
    [anon_sym_alignas] = ACTIONS(2414),
    [anon_sym__Alignas] = ACTIONS(2414),
    [sym_primitive_type] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_union] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2414),
    [anon_sym_decltype] = ACTIONS(2414),
    [anon_sym_explicit] = ACTIONS(2414),
    [anon_sym_typename] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_template] = ACTIONS(2414),
    [anon_sym_operator] = ACTIONS(2414),
    [anon_sym_friend] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_static_assert] = ACTIONS(2414),
    [anon_sym_precise] = ACTIONS(2414),
    [anon_sym_shared] = ACTIONS(2414),
    [anon_sym_groupshared] = ACTIONS(2414),
    [anon_sym_uniform] = ACTIONS(2414),
    [anon_sym_row_major] = ACTIONS(2414),
    [anon_sym_column_major] = ACTIONS(2414),
    [anon_sym_globallycoherent] = ACTIONS(2414),
    [anon_sym_centroid] = ACTIONS(2414),
    [anon_sym_noperspective] = ACTIONS(2414),
    [anon_sym_nointerpolation] = ACTIONS(2414),
    [anon_sym_sample] = ACTIONS(2414),
    [anon_sym_linear] = ACTIONS(2414),
    [anon_sym_snorm] = ACTIONS(2414),
    [anon_sym_unorm] = ACTIONS(2414),
    [anon_sym_point] = ACTIONS(2414),
    [anon_sym_line] = ACTIONS(2414),
    [anon_sym_triangleadj] = ACTIONS(2414),
    [anon_sym_lineadj] = ACTIONS(2414),
    [anon_sym_triangle] = ACTIONS(2414),
  },
  [2175] = {
    [sym_identifier] = ACTIONS(2418),
    [aux_sym_preproc_def_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token1] = ACTIONS(2418),
    [aux_sym_preproc_if_token2] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2418),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2418),
    [sym_preproc_directive] = ACTIONS(2418),
    [anon_sym_LPAREN2] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym___extension__] = ACTIONS(2418),
    [anon_sym_typedef] = ACTIONS(2418),
    [anon_sym_in] = ACTIONS(2418),
    [anon_sym_out] = ACTIONS(2418),
    [anon_sym_inout] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym___attribute__] = ACTIONS(2418),
    [anon_sym___attribute] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_COLON_COLON] = ACTIONS(2420),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2420),
    [anon_sym___declspec] = ACTIONS(2418),
    [anon_sym___based] = ACTIONS(2418),
    [anon_sym_signed] = ACTIONS(2418),
    [anon_sym_unsigned] = ACTIONS(2418),
    [anon_sym_long] = ACTIONS(2418),
    [anon_sym_short] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_register] = ACTIONS(2418),
    [anon_sym_inline] = ACTIONS(2418),
    [anon_sym___inline] = ACTIONS(2418),
    [anon_sym___inline__] = ACTIONS(2418),
    [anon_sym___forceinline] = ACTIONS(2418),
    [anon_sym_thread_local] = ACTIONS(2418),
    [anon_sym___thread] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_constexpr] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_restrict] = ACTIONS(2418),
    [anon_sym___restrict__] = ACTIONS(2418),
    [anon_sym__Atomic] = ACTIONS(2418),
    [anon_sym__Noreturn] = ACTIONS(2418),
    [anon_sym_noreturn] = ACTIONS(2418),
    [anon_sym__Nonnull] = ACTIONS(2418),
    [anon_sym_mutable] = ACTIONS(2418),
    [anon_sym_constinit] = ACTIONS(2418),
    [anon_sym_consteval] = ACTIONS(2418),
    [anon_sym_alignas] = ACTIONS(2418),
    [anon_sym__Alignas] = ACTIONS(2418),
    [sym_primitive_type] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_union] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2418),
    [anon_sym_decltype] = ACTIONS(2418),
    [anon_sym_explicit] = ACTIONS(2418),
    [anon_sym_typename] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_template] = ACTIONS(2418),
    [anon_sym_operator] = ACTIONS(2418),
    [anon_sym_friend] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_static_assert] = ACTIONS(2418),
    [anon_sym_precise] = ACTIONS(2418),
    [anon_sym_shared] = ACTIONS(2418),
    [anon_sym_groupshared] = ACTIONS(2418),
    [anon_sym_uniform] = ACTIONS(2418),
    [anon_sym_row_major] = ACTIONS(2418),
    [anon_sym_column_major] = ACTIONS(2418),
    [anon_sym_globallycoherent] = ACTIONS(2418),
    [anon_sym_centroid] = ACTIONS(2418),
    [anon_sym_noperspective] = ACTIONS(2418),
    [anon_sym_nointerpolation] = ACTIONS(2418),
    [anon_sym_sample] = ACTIONS(2418),
    [anon_sym_linear] = ACTIONS(2418),
    [anon_sym_snorm] = ACTIONS(2418),
    [anon_sym_unorm] = ACTIONS(2418),
    [anon_sym_point] = ACTIONS(2418),
    [anon_sym_line] = ACTIONS(2418),
    [anon_sym_triangleadj] = ACTIONS(2418),
    [anon_sym_lineadj] = ACTIONS(2418),
    [anon_sym_triangle] = ACTIONS(2418),
  },
  [2176] = {
    [sym_identifier] = ACTIONS(2684),
    [aux_sym_preproc_def_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token1] = ACTIONS(2684),
    [aux_sym_preproc_if_token2] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2684),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2684),
    [sym_preproc_directive] = ACTIONS(2684),
    [anon_sym_LPAREN2] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_AMP] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym___extension__] = ACTIONS(2684),
    [anon_sym_typedef] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2684),
    [anon_sym_out] = ACTIONS(2684),
    [anon_sym_inout] = ACTIONS(2684),
    [anon_sym_virtual] = ACTIONS(2684),
    [anon_sym_extern] = ACTIONS(2684),
    [anon_sym___attribute__] = ACTIONS(2684),
    [anon_sym___attribute] = ACTIONS(2684),
    [anon_sym_using] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2686),
    [anon_sym___declspec] = ACTIONS(2684),
    [anon_sym___based] = ACTIONS(2684),
    [anon_sym_signed] = ACTIONS(2684),
    [anon_sym_unsigned] = ACTIONS(2684),
    [anon_sym_long] = ACTIONS(2684),
    [anon_sym_short] = ACTIONS(2684),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2684),
    [anon_sym_register] = ACTIONS(2684),
    [anon_sym_inline] = ACTIONS(2684),
    [anon_sym___inline] = ACTIONS(2684),
    [anon_sym___inline__] = ACTIONS(2684),
    [anon_sym___forceinline] = ACTIONS(2684),
    [anon_sym_thread_local] = ACTIONS(2684),
    [anon_sym___thread] = ACTIONS(2684),
    [anon_sym_const] = ACTIONS(2684),
    [anon_sym_constexpr] = ACTIONS(2684),
    [anon_sym_volatile] = ACTIONS(2684),
    [anon_sym_restrict] = ACTIONS(2684),
    [anon_sym___restrict__] = ACTIONS(2684),
    [anon_sym__Atomic] = ACTIONS(2684),
    [anon_sym__Noreturn] = ACTIONS(2684),
    [anon_sym_noreturn] = ACTIONS(2684),
    [anon_sym__Nonnull] = ACTIONS(2684),
    [anon_sym_mutable] = ACTIONS(2684),
    [anon_sym_constinit] = ACTIONS(2684),
    [anon_sym_consteval] = ACTIONS(2684),
    [anon_sym_alignas] = ACTIONS(2684),
    [anon_sym__Alignas] = ACTIONS(2684),
    [sym_primitive_type] = ACTIONS(2684),
    [anon_sym_enum] = ACTIONS(2684),
    [anon_sym_class] = ACTIONS(2684),
    [anon_sym_struct] = ACTIONS(2684),
    [anon_sym_union] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2684),
    [anon_sym_decltype] = ACTIONS(2684),
    [anon_sym_explicit] = ACTIONS(2684),
    [anon_sym_typename] = ACTIONS(2684),
    [anon_sym_private] = ACTIONS(2684),
    [anon_sym_template] = ACTIONS(2684),
    [anon_sym_operator] = ACTIONS(2684),
    [anon_sym_friend] = ACTIONS(2684),
    [anon_sym_public] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(2684),
    [anon_sym_static_assert] = ACTIONS(2684),
    [anon_sym_precise] = ACTIONS(2684),
    [anon_sym_shared] = ACTIONS(2684),
    [anon_sym_groupshared] = ACTIONS(2684),
    [anon_sym_uniform] = ACTIONS(2684),
    [anon_sym_row_major] = ACTIONS(2684),
    [anon_sym_column_major] = ACTIONS(2684),
    [anon_sym_globallycoherent] = ACTIONS(2684),
    [anon_sym_centroid] = ACTIONS(2684),
    [anon_sym_noperspective] = ACTIONS(2684),
    [anon_sym_nointerpolation] = ACTIONS(2684),
    [anon_sym_sample] = ACTIONS(2684),
    [anon_sym_linear] = ACTIONS(2684),
    [anon_sym_snorm] = ACTIONS(2684),
    [anon_sym_unorm] = ACTIONS(2684),
    [anon_sym_point] = ACTIONS(2684),
    [anon_sym_line] = ACTIONS(2684),
    [anon_sym_triangleadj] = ACTIONS(2684),
    [anon_sym_lineadj] = ACTIONS(2684),
    [anon_sym_triangle] = ACTIONS(2684),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(5579),
    [aux_sym_preproc_def_token1] = ACTIONS(5579),
    [aux_sym_preproc_if_token1] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5579),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5579),
    [sym_preproc_directive] = ACTIONS(5579),
    [anon_sym_LPAREN2] = ACTIONS(5581),
    [anon_sym_TILDE] = ACTIONS(5581),
    [anon_sym_STAR] = ACTIONS(5581),
    [anon_sym_AMP_AMP] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(5579),
    [anon_sym_SEMI] = ACTIONS(5581),
    [anon_sym___extension__] = ACTIONS(5579),
    [anon_sym_typedef] = ACTIONS(5579),
    [anon_sym_in] = ACTIONS(5579),
    [anon_sym_out] = ACTIONS(5579),
    [anon_sym_inout] = ACTIONS(5579),
    [anon_sym_virtual] = ACTIONS(5579),
    [anon_sym_extern] = ACTIONS(5579),
    [anon_sym___attribute__] = ACTIONS(5579),
    [anon_sym___attribute] = ACTIONS(5579),
    [anon_sym_using] = ACTIONS(5579),
    [anon_sym_COLON_COLON] = ACTIONS(5581),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5581),
    [anon_sym___declspec] = ACTIONS(5579),
    [anon_sym___based] = ACTIONS(5579),
    [anon_sym_RBRACE] = ACTIONS(5581),
    [anon_sym_signed] = ACTIONS(5579),
    [anon_sym_unsigned] = ACTIONS(5579),
    [anon_sym_long] = ACTIONS(5579),
    [anon_sym_short] = ACTIONS(5579),
    [anon_sym_LBRACK] = ACTIONS(5579),
    [anon_sym_static] = ACTIONS(5579),
    [anon_sym_register] = ACTIONS(5579),
    [anon_sym_inline] = ACTIONS(5579),
    [anon_sym___inline] = ACTIONS(5579),
    [anon_sym___inline__] = ACTIONS(5579),
    [anon_sym___forceinline] = ACTIONS(5579),
    [anon_sym_thread_local] = ACTIONS(5579),
    [anon_sym___thread] = ACTIONS(5579),
    [anon_sym_const] = ACTIONS(5579),
    [anon_sym_constexpr] = ACTIONS(5579),
    [anon_sym_volatile] = ACTIONS(5579),
    [anon_sym_restrict] = ACTIONS(5579),
    [anon_sym___restrict__] = ACTIONS(5579),
    [anon_sym__Atomic] = ACTIONS(5579),
    [anon_sym__Noreturn] = ACTIONS(5579),
    [anon_sym_noreturn] = ACTIONS(5579),
    [anon_sym__Nonnull] = ACTIONS(5579),
    [anon_sym_mutable] = ACTIONS(5579),
    [anon_sym_constinit] = ACTIONS(5579),
    [anon_sym_consteval] = ACTIONS(5579),
    [anon_sym_alignas] = ACTIONS(5579),
    [anon_sym__Alignas] = ACTIONS(5579),
    [sym_primitive_type] = ACTIONS(5579),
    [anon_sym_enum] = ACTIONS(5579),
    [anon_sym_class] = ACTIONS(5579),
    [anon_sym_struct] = ACTIONS(5579),
    [anon_sym_union] = ACTIONS(5579),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5579),
    [anon_sym_decltype] = ACTIONS(5579),
    [anon_sym_explicit] = ACTIONS(5579),
    [anon_sym_typename] = ACTIONS(5579),
    [anon_sym_private] = ACTIONS(5579),
    [anon_sym_template] = ACTIONS(5579),
    [anon_sym_operator] = ACTIONS(5579),
    [anon_sym_friend] = ACTIONS(5579),
    [anon_sym_public] = ACTIONS(5579),
    [anon_sym_protected] = ACTIONS(5579),
    [anon_sym_static_assert] = ACTIONS(5579),
    [anon_sym_precise] = ACTIONS(5579),
    [anon_sym_shared] = ACTIONS(5579),
    [anon_sym_groupshared] = ACTIONS(5579),
    [anon_sym_uniform] = ACTIONS(5579),
    [anon_sym_row_major] = ACTIONS(5579),
    [anon_sym_column_major] = ACTIONS(5579),
    [anon_sym_globallycoherent] = ACTIONS(5579),
    [anon_sym_centroid] = ACTIONS(5579),
    [anon_sym_noperspective] = ACTIONS(5579),
    [anon_sym_nointerpolation] = ACTIONS(5579),
    [anon_sym_sample] = ACTIONS(5579),
    [anon_sym_linear] = ACTIONS(5579),
    [anon_sym_snorm] = ACTIONS(5579),
    [anon_sym_unorm] = ACTIONS(5579),
    [anon_sym_point] = ACTIONS(5579),
    [anon_sym_line] = ACTIONS(5579),
    [anon_sym_triangleadj] = ACTIONS(5579),
    [anon_sym_lineadj] = ACTIONS(5579),
    [anon_sym_triangle] = ACTIONS(5579),
  },
  [2178] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_friend] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
  },
  [2179] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [2180] = {
    [sym_identifier] = ACTIONS(2462),
    [aux_sym_preproc_def_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token1] = ACTIONS(2462),
    [aux_sym_preproc_if_token2] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2462),
    [sym_preproc_directive] = ACTIONS(2462),
    [anon_sym_LPAREN2] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym___extension__] = ACTIONS(2462),
    [anon_sym_typedef] = ACTIONS(2462),
    [anon_sym_in] = ACTIONS(2462),
    [anon_sym_out] = ACTIONS(2462),
    [anon_sym_inout] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym___attribute__] = ACTIONS(2462),
    [anon_sym___attribute] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2464),
    [anon_sym___declspec] = ACTIONS(2462),
    [anon_sym___based] = ACTIONS(2462),
    [anon_sym_signed] = ACTIONS(2462),
    [anon_sym_unsigned] = ACTIONS(2462),
    [anon_sym_long] = ACTIONS(2462),
    [anon_sym_short] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_register] = ACTIONS(2462),
    [anon_sym_inline] = ACTIONS(2462),
    [anon_sym___inline] = ACTIONS(2462),
    [anon_sym___inline__] = ACTIONS(2462),
    [anon_sym___forceinline] = ACTIONS(2462),
    [anon_sym_thread_local] = ACTIONS(2462),
    [anon_sym___thread] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_constexpr] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_restrict] = ACTIONS(2462),
    [anon_sym___restrict__] = ACTIONS(2462),
    [anon_sym__Atomic] = ACTIONS(2462),
    [anon_sym__Noreturn] = ACTIONS(2462),
    [anon_sym_noreturn] = ACTIONS(2462),
    [anon_sym__Nonnull] = ACTIONS(2462),
    [anon_sym_mutable] = ACTIONS(2462),
    [anon_sym_constinit] = ACTIONS(2462),
    [anon_sym_consteval] = ACTIONS(2462),
    [anon_sym_alignas] = ACTIONS(2462),
    [anon_sym__Alignas] = ACTIONS(2462),
    [sym_primitive_type] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_union] = ACTIONS(2462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2462),
    [anon_sym_decltype] = ACTIONS(2462),
    [anon_sym_explicit] = ACTIONS(2462),
    [anon_sym_typename] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_template] = ACTIONS(2462),
    [anon_sym_operator] = ACTIONS(2462),
    [anon_sym_friend] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_static_assert] = ACTIONS(2462),
    [anon_sym_precise] = ACTIONS(2462),
    [anon_sym_shared] = ACTIONS(2462),
    [anon_sym_groupshared] = ACTIONS(2462),
    [anon_sym_uniform] = ACTIONS(2462),
    [anon_sym_row_major] = ACTIONS(2462),
    [anon_sym_column_major] = ACTIONS(2462),
    [anon_sym_globallycoherent] = ACTIONS(2462),
    [anon_sym_centroid] = ACTIONS(2462),
    [anon_sym_noperspective] = ACTIONS(2462),
    [anon_sym_nointerpolation] = ACTIONS(2462),
    [anon_sym_sample] = ACTIONS(2462),
    [anon_sym_linear] = ACTIONS(2462),
    [anon_sym_snorm] = ACTIONS(2462),
    [anon_sym_unorm] = ACTIONS(2462),
    [anon_sym_point] = ACTIONS(2462),
    [anon_sym_line] = ACTIONS(2462),
    [anon_sym_triangleadj] = ACTIONS(2462),
    [anon_sym_lineadj] = ACTIONS(2462),
    [anon_sym_triangle] = ACTIONS(2462),
  },
  [2181] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(2660),
    [aux_sym_preproc_def_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token1] = ACTIONS(2660),
    [aux_sym_preproc_if_token2] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2660),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2660),
    [sym_preproc_directive] = ACTIONS(2660),
    [anon_sym_LPAREN2] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2662),
    [anon_sym_STAR] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_AMP] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym___extension__] = ACTIONS(2660),
    [anon_sym_typedef] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2660),
    [anon_sym_out] = ACTIONS(2660),
    [anon_sym_inout] = ACTIONS(2660),
    [anon_sym_virtual] = ACTIONS(2660),
    [anon_sym_extern] = ACTIONS(2660),
    [anon_sym___attribute__] = ACTIONS(2660),
    [anon_sym___attribute] = ACTIONS(2660),
    [anon_sym_using] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2662),
    [anon_sym___declspec] = ACTIONS(2660),
    [anon_sym___based] = ACTIONS(2660),
    [anon_sym_signed] = ACTIONS(2660),
    [anon_sym_unsigned] = ACTIONS(2660),
    [anon_sym_long] = ACTIONS(2660),
    [anon_sym_short] = ACTIONS(2660),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2660),
    [anon_sym_register] = ACTIONS(2660),
    [anon_sym_inline] = ACTIONS(2660),
    [anon_sym___inline] = ACTIONS(2660),
    [anon_sym___inline__] = ACTIONS(2660),
    [anon_sym___forceinline] = ACTIONS(2660),
    [anon_sym_thread_local] = ACTIONS(2660),
    [anon_sym___thread] = ACTIONS(2660),
    [anon_sym_const] = ACTIONS(2660),
    [anon_sym_constexpr] = ACTIONS(2660),
    [anon_sym_volatile] = ACTIONS(2660),
    [anon_sym_restrict] = ACTIONS(2660),
    [anon_sym___restrict__] = ACTIONS(2660),
    [anon_sym__Atomic] = ACTIONS(2660),
    [anon_sym__Noreturn] = ACTIONS(2660),
    [anon_sym_noreturn] = ACTIONS(2660),
    [anon_sym__Nonnull] = ACTIONS(2660),
    [anon_sym_mutable] = ACTIONS(2660),
    [anon_sym_constinit] = ACTIONS(2660),
    [anon_sym_consteval] = ACTIONS(2660),
    [anon_sym_alignas] = ACTIONS(2660),
    [anon_sym__Alignas] = ACTIONS(2660),
    [sym_primitive_type] = ACTIONS(2660),
    [anon_sym_enum] = ACTIONS(2660),
    [anon_sym_class] = ACTIONS(2660),
    [anon_sym_struct] = ACTIONS(2660),
    [anon_sym_union] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2660),
    [anon_sym_decltype] = ACTIONS(2660),
    [anon_sym_explicit] = ACTIONS(2660),
    [anon_sym_typename] = ACTIONS(2660),
    [anon_sym_private] = ACTIONS(2660),
    [anon_sym_template] = ACTIONS(2660),
    [anon_sym_operator] = ACTIONS(2660),
    [anon_sym_friend] = ACTIONS(2660),
    [anon_sym_public] = ACTIONS(2660),
    [anon_sym_protected] = ACTIONS(2660),
    [anon_sym_static_assert] = ACTIONS(2660),
    [anon_sym_precise] = ACTIONS(2660),
    [anon_sym_shared] = ACTIONS(2660),
    [anon_sym_groupshared] = ACTIONS(2660),
    [anon_sym_uniform] = ACTIONS(2660),
    [anon_sym_row_major] = ACTIONS(2660),
    [anon_sym_column_major] = ACTIONS(2660),
    [anon_sym_globallycoherent] = ACTIONS(2660),
    [anon_sym_centroid] = ACTIONS(2660),
    [anon_sym_noperspective] = ACTIONS(2660),
    [anon_sym_nointerpolation] = ACTIONS(2660),
    [anon_sym_sample] = ACTIONS(2660),
    [anon_sym_linear] = ACTIONS(2660),
    [anon_sym_snorm] = ACTIONS(2660),
    [anon_sym_unorm] = ACTIONS(2660),
    [anon_sym_point] = ACTIONS(2660),
    [anon_sym_line] = ACTIONS(2660),
    [anon_sym_triangleadj] = ACTIONS(2660),
    [anon_sym_lineadj] = ACTIONS(2660),
    [anon_sym_triangle] = ACTIONS(2660),
  },
  [2184] = {
    [sym_identifier] = ACTIONS(2692),
    [aux_sym_preproc_def_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token1] = ACTIONS(2692),
    [aux_sym_preproc_if_token2] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2692),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2692),
    [sym_preproc_directive] = ACTIONS(2692),
    [anon_sym_LPAREN2] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2694),
    [anon_sym_STAR] = ACTIONS(2694),
    [anon_sym_AMP_AMP] = ACTIONS(2694),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2694),
    [anon_sym___extension__] = ACTIONS(2692),
    [anon_sym_typedef] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2692),
    [anon_sym_out] = ACTIONS(2692),
    [anon_sym_inout] = ACTIONS(2692),
    [anon_sym_virtual] = ACTIONS(2692),
    [anon_sym_extern] = ACTIONS(2692),
    [anon_sym___attribute__] = ACTIONS(2692),
    [anon_sym___attribute] = ACTIONS(2692),
    [anon_sym_using] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2694),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2694),
    [anon_sym___declspec] = ACTIONS(2692),
    [anon_sym___based] = ACTIONS(2692),
    [anon_sym_signed] = ACTIONS(2692),
    [anon_sym_unsigned] = ACTIONS(2692),
    [anon_sym_long] = ACTIONS(2692),
    [anon_sym_short] = ACTIONS(2692),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2692),
    [anon_sym_register] = ACTIONS(2692),
    [anon_sym_inline] = ACTIONS(2692),
    [anon_sym___inline] = ACTIONS(2692),
    [anon_sym___inline__] = ACTIONS(2692),
    [anon_sym___forceinline] = ACTIONS(2692),
    [anon_sym_thread_local] = ACTIONS(2692),
    [anon_sym___thread] = ACTIONS(2692),
    [anon_sym_const] = ACTIONS(2692),
    [anon_sym_constexpr] = ACTIONS(2692),
    [anon_sym_volatile] = ACTIONS(2692),
    [anon_sym_restrict] = ACTIONS(2692),
    [anon_sym___restrict__] = ACTIONS(2692),
    [anon_sym__Atomic] = ACTIONS(2692),
    [anon_sym__Noreturn] = ACTIONS(2692),
    [anon_sym_noreturn] = ACTIONS(2692),
    [anon_sym__Nonnull] = ACTIONS(2692),
    [anon_sym_mutable] = ACTIONS(2692),
    [anon_sym_constinit] = ACTIONS(2692),
    [anon_sym_consteval] = ACTIONS(2692),
    [anon_sym_alignas] = ACTIONS(2692),
    [anon_sym__Alignas] = ACTIONS(2692),
    [sym_primitive_type] = ACTIONS(2692),
    [anon_sym_enum] = ACTIONS(2692),
    [anon_sym_class] = ACTIONS(2692),
    [anon_sym_struct] = ACTIONS(2692),
    [anon_sym_union] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2692),
    [anon_sym_decltype] = ACTIONS(2692),
    [anon_sym_explicit] = ACTIONS(2692),
    [anon_sym_typename] = ACTIONS(2692),
    [anon_sym_private] = ACTIONS(2692),
    [anon_sym_template] = ACTIONS(2692),
    [anon_sym_operator] = ACTIONS(2692),
    [anon_sym_friend] = ACTIONS(2692),
    [anon_sym_public] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(2692),
    [anon_sym_static_assert] = ACTIONS(2692),
    [anon_sym_precise] = ACTIONS(2692),
    [anon_sym_shared] = ACTIONS(2692),
    [anon_sym_groupshared] = ACTIONS(2692),
    [anon_sym_uniform] = ACTIONS(2692),
    [anon_sym_row_major] = ACTIONS(2692),
    [anon_sym_column_major] = ACTIONS(2692),
    [anon_sym_globallycoherent] = ACTIONS(2692),
    [anon_sym_centroid] = ACTIONS(2692),
    [anon_sym_noperspective] = ACTIONS(2692),
    [anon_sym_nointerpolation] = ACTIONS(2692),
    [anon_sym_sample] = ACTIONS(2692),
    [anon_sym_linear] = ACTIONS(2692),
    [anon_sym_snorm] = ACTIONS(2692),
    [anon_sym_unorm] = ACTIONS(2692),
    [anon_sym_point] = ACTIONS(2692),
    [anon_sym_line] = ACTIONS(2692),
    [anon_sym_triangleadj] = ACTIONS(2692),
    [anon_sym_lineadj] = ACTIONS(2692),
    [anon_sym_triangle] = ACTIONS(2692),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(2410),
    [aux_sym_preproc_def_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token1] = ACTIONS(2410),
    [aux_sym_preproc_if_token2] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2410),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2410),
    [sym_preproc_directive] = ACTIONS(2410),
    [anon_sym_LPAREN2] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym___extension__] = ACTIONS(2410),
    [anon_sym_typedef] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2410),
    [anon_sym_out] = ACTIONS(2410),
    [anon_sym_inout] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym___attribute__] = ACTIONS(2410),
    [anon_sym___attribute] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_COLON_COLON] = ACTIONS(2412),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2412),
    [anon_sym___declspec] = ACTIONS(2410),
    [anon_sym___based] = ACTIONS(2410),
    [anon_sym_signed] = ACTIONS(2410),
    [anon_sym_unsigned] = ACTIONS(2410),
    [anon_sym_long] = ACTIONS(2410),
    [anon_sym_short] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_register] = ACTIONS(2410),
    [anon_sym_inline] = ACTIONS(2410),
    [anon_sym___inline] = ACTIONS(2410),
    [anon_sym___inline__] = ACTIONS(2410),
    [anon_sym___forceinline] = ACTIONS(2410),
    [anon_sym_thread_local] = ACTIONS(2410),
    [anon_sym___thread] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_constexpr] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_restrict] = ACTIONS(2410),
    [anon_sym___restrict__] = ACTIONS(2410),
    [anon_sym__Atomic] = ACTIONS(2410),
    [anon_sym__Noreturn] = ACTIONS(2410),
    [anon_sym_noreturn] = ACTIONS(2410),
    [anon_sym__Nonnull] = ACTIONS(2410),
    [anon_sym_mutable] = ACTIONS(2410),
    [anon_sym_constinit] = ACTIONS(2410),
    [anon_sym_consteval] = ACTIONS(2410),
    [anon_sym_alignas] = ACTIONS(2410),
    [anon_sym__Alignas] = ACTIONS(2410),
    [sym_primitive_type] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_union] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2410),
    [anon_sym_decltype] = ACTIONS(2410),
    [anon_sym_explicit] = ACTIONS(2410),
    [anon_sym_typename] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_template] = ACTIONS(2410),
    [anon_sym_operator] = ACTIONS(2410),
    [anon_sym_friend] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_static_assert] = ACTIONS(2410),
    [anon_sym_precise] = ACTIONS(2410),
    [anon_sym_shared] = ACTIONS(2410),
    [anon_sym_groupshared] = ACTIONS(2410),
    [anon_sym_uniform] = ACTIONS(2410),
    [anon_sym_row_major] = ACTIONS(2410),
    [anon_sym_column_major] = ACTIONS(2410),
    [anon_sym_globallycoherent] = ACTIONS(2410),
    [anon_sym_centroid] = ACTIONS(2410),
    [anon_sym_noperspective] = ACTIONS(2410),
    [anon_sym_nointerpolation] = ACTIONS(2410),
    [anon_sym_sample] = ACTIONS(2410),
    [anon_sym_linear] = ACTIONS(2410),
    [anon_sym_snorm] = ACTIONS(2410),
    [anon_sym_unorm] = ACTIONS(2410),
    [anon_sym_point] = ACTIONS(2410),
    [anon_sym_line] = ACTIONS(2410),
    [anon_sym_triangleadj] = ACTIONS(2410),
    [anon_sym_lineadj] = ACTIONS(2410),
    [anon_sym_triangle] = ACTIONS(2410),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(5599),
    [aux_sym_preproc_def_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token1] = ACTIONS(5599),
    [aux_sym_preproc_if_token2] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5599),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5599),
    [sym_preproc_directive] = ACTIONS(5599),
    [anon_sym_LPAREN2] = ACTIONS(5601),
    [anon_sym_TILDE] = ACTIONS(5601),
    [anon_sym_STAR] = ACTIONS(5601),
    [anon_sym_AMP_AMP] = ACTIONS(5601),
    [anon_sym_AMP] = ACTIONS(5599),
    [anon_sym_SEMI] = ACTIONS(5601),
    [anon_sym___extension__] = ACTIONS(5599),
    [anon_sym_typedef] = ACTIONS(5599),
    [anon_sym_in] = ACTIONS(5599),
    [anon_sym_out] = ACTIONS(5599),
    [anon_sym_inout] = ACTIONS(5599),
    [anon_sym_virtual] = ACTIONS(5599),
    [anon_sym_extern] = ACTIONS(5599),
    [anon_sym___attribute__] = ACTIONS(5599),
    [anon_sym___attribute] = ACTIONS(5599),
    [anon_sym_using] = ACTIONS(5599),
    [anon_sym_COLON_COLON] = ACTIONS(5601),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5601),
    [anon_sym___declspec] = ACTIONS(5599),
    [anon_sym___based] = ACTIONS(5599),
    [anon_sym_signed] = ACTIONS(5599),
    [anon_sym_unsigned] = ACTIONS(5599),
    [anon_sym_long] = ACTIONS(5599),
    [anon_sym_short] = ACTIONS(5599),
    [anon_sym_LBRACK] = ACTIONS(5599),
    [anon_sym_static] = ACTIONS(5599),
    [anon_sym_register] = ACTIONS(5599),
    [anon_sym_inline] = ACTIONS(5599),
    [anon_sym___inline] = ACTIONS(5599),
    [anon_sym___inline__] = ACTIONS(5599),
    [anon_sym___forceinline] = ACTIONS(5599),
    [anon_sym_thread_local] = ACTIONS(5599),
    [anon_sym___thread] = ACTIONS(5599),
    [anon_sym_const] = ACTIONS(5599),
    [anon_sym_constexpr] = ACTIONS(5599),
    [anon_sym_volatile] = ACTIONS(5599),
    [anon_sym_restrict] = ACTIONS(5599),
    [anon_sym___restrict__] = ACTIONS(5599),
    [anon_sym__Atomic] = ACTIONS(5599),
    [anon_sym__Noreturn] = ACTIONS(5599),
    [anon_sym_noreturn] = ACTIONS(5599),
    [anon_sym__Nonnull] = ACTIONS(5599),
    [anon_sym_mutable] = ACTIONS(5599),
    [anon_sym_constinit] = ACTIONS(5599),
    [anon_sym_consteval] = ACTIONS(5599),
    [anon_sym_alignas] = ACTIONS(5599),
    [anon_sym__Alignas] = ACTIONS(5599),
    [sym_primitive_type] = ACTIONS(5599),
    [anon_sym_enum] = ACTIONS(5599),
    [anon_sym_class] = ACTIONS(5599),
    [anon_sym_struct] = ACTIONS(5599),
    [anon_sym_union] = ACTIONS(5599),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5599),
    [anon_sym_decltype] = ACTIONS(5599),
    [anon_sym_explicit] = ACTIONS(5599),
    [anon_sym_typename] = ACTIONS(5599),
    [anon_sym_private] = ACTIONS(5599),
    [anon_sym_template] = ACTIONS(5599),
    [anon_sym_operator] = ACTIONS(5599),
    [anon_sym_friend] = ACTIONS(5599),
    [anon_sym_public] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(5599),
    [anon_sym_static_assert] = ACTIONS(5599),
    [anon_sym_precise] = ACTIONS(5599),
    [anon_sym_shared] = ACTIONS(5599),
    [anon_sym_groupshared] = ACTIONS(5599),
    [anon_sym_uniform] = ACTIONS(5599),
    [anon_sym_row_major] = ACTIONS(5599),
    [anon_sym_column_major] = ACTIONS(5599),
    [anon_sym_globallycoherent] = ACTIONS(5599),
    [anon_sym_centroid] = ACTIONS(5599),
    [anon_sym_noperspective] = ACTIONS(5599),
    [anon_sym_nointerpolation] = ACTIONS(5599),
    [anon_sym_sample] = ACTIONS(5599),
    [anon_sym_linear] = ACTIONS(5599),
    [anon_sym_snorm] = ACTIONS(5599),
    [anon_sym_unorm] = ACTIONS(5599),
    [anon_sym_point] = ACTIONS(5599),
    [anon_sym_line] = ACTIONS(5599),
    [anon_sym_triangleadj] = ACTIONS(5599),
    [anon_sym_lineadj] = ACTIONS(5599),
    [anon_sym_triangle] = ACTIONS(5599),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(2449),
    [aux_sym_preproc_def_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token1] = ACTIONS(2449),
    [aux_sym_preproc_if_token2] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2449),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2449),
    [sym_preproc_directive] = ACTIONS(2449),
    [anon_sym_LPAREN2] = ACTIONS(2451),
    [anon_sym_TILDE] = ACTIONS(2451),
    [anon_sym_STAR] = ACTIONS(2451),
    [anon_sym_AMP_AMP] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2449),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym___extension__] = ACTIONS(2449),
    [anon_sym_typedef] = ACTIONS(2449),
    [anon_sym_in] = ACTIONS(2449),
    [anon_sym_out] = ACTIONS(2449),
    [anon_sym_inout] = ACTIONS(2449),
    [anon_sym_virtual] = ACTIONS(2449),
    [anon_sym_extern] = ACTIONS(2449),
    [anon_sym___attribute__] = ACTIONS(2449),
    [anon_sym___attribute] = ACTIONS(2449),
    [anon_sym_using] = ACTIONS(2449),
    [anon_sym_COLON_COLON] = ACTIONS(2451),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2451),
    [anon_sym___declspec] = ACTIONS(2449),
    [anon_sym___based] = ACTIONS(2449),
    [anon_sym_signed] = ACTIONS(2449),
    [anon_sym_unsigned] = ACTIONS(2449),
    [anon_sym_long] = ACTIONS(2449),
    [anon_sym_short] = ACTIONS(2449),
    [anon_sym_LBRACK] = ACTIONS(2449),
    [anon_sym_static] = ACTIONS(2449),
    [anon_sym_register] = ACTIONS(2449),
    [anon_sym_inline] = ACTIONS(2449),
    [anon_sym___inline] = ACTIONS(2449),
    [anon_sym___inline__] = ACTIONS(2449),
    [anon_sym___forceinline] = ACTIONS(2449),
    [anon_sym_thread_local] = ACTIONS(2449),
    [anon_sym___thread] = ACTIONS(2449),
    [anon_sym_const] = ACTIONS(2449),
    [anon_sym_constexpr] = ACTIONS(2449),
    [anon_sym_volatile] = ACTIONS(2449),
    [anon_sym_restrict] = ACTIONS(2449),
    [anon_sym___restrict__] = ACTIONS(2449),
    [anon_sym__Atomic] = ACTIONS(2449),
    [anon_sym__Noreturn] = ACTIONS(2449),
    [anon_sym_noreturn] = ACTIONS(2449),
    [anon_sym__Nonnull] = ACTIONS(2449),
    [anon_sym_mutable] = ACTIONS(2449),
    [anon_sym_constinit] = ACTIONS(2449),
    [anon_sym_consteval] = ACTIONS(2449),
    [anon_sym_alignas] = ACTIONS(2449),
    [anon_sym__Alignas] = ACTIONS(2449),
    [sym_primitive_type] = ACTIONS(2449),
    [anon_sym_enum] = ACTIONS(2449),
    [anon_sym_class] = ACTIONS(2449),
    [anon_sym_struct] = ACTIONS(2449),
    [anon_sym_union] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2449),
    [anon_sym_decltype] = ACTIONS(2449),
    [anon_sym_explicit] = ACTIONS(2449),
    [anon_sym_typename] = ACTIONS(2449),
    [anon_sym_private] = ACTIONS(2449),
    [anon_sym_template] = ACTIONS(2449),
    [anon_sym_operator] = ACTIONS(2449),
    [anon_sym_friend] = ACTIONS(2449),
    [anon_sym_public] = ACTIONS(2449),
    [anon_sym_protected] = ACTIONS(2449),
    [anon_sym_static_assert] = ACTIONS(2449),
    [anon_sym_precise] = ACTIONS(2449),
    [anon_sym_shared] = ACTIONS(2449),
    [anon_sym_groupshared] = ACTIONS(2449),
    [anon_sym_uniform] = ACTIONS(2449),
    [anon_sym_row_major] = ACTIONS(2449),
    [anon_sym_column_major] = ACTIONS(2449),
    [anon_sym_globallycoherent] = ACTIONS(2449),
    [anon_sym_centroid] = ACTIONS(2449),
    [anon_sym_noperspective] = ACTIONS(2449),
    [anon_sym_nointerpolation] = ACTIONS(2449),
    [anon_sym_sample] = ACTIONS(2449),
    [anon_sym_linear] = ACTIONS(2449),
    [anon_sym_snorm] = ACTIONS(2449),
    [anon_sym_unorm] = ACTIONS(2449),
    [anon_sym_point] = ACTIONS(2449),
    [anon_sym_line] = ACTIONS(2449),
    [anon_sym_triangleadj] = ACTIONS(2449),
    [anon_sym_lineadj] = ACTIONS(2449),
    [anon_sym_triangle] = ACTIONS(2449),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5569),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(5567),
    [aux_sym_preproc_def_token1] = ACTIONS(5567),
    [aux_sym_preproc_if_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5567),
    [sym_preproc_directive] = ACTIONS(5567),
    [anon_sym_LPAREN2] = ACTIONS(5569),
    [anon_sym_TILDE] = ACTIONS(5569),
    [anon_sym_STAR] = ACTIONS(5569),
    [anon_sym_AMP_AMP] = ACTIONS(5569),
    [anon_sym_AMP] = ACTIONS(5567),
    [anon_sym_SEMI] = ACTIONS(5569),
    [anon_sym___extension__] = ACTIONS(5567),
    [anon_sym_typedef] = ACTIONS(5567),
    [anon_sym_in] = ACTIONS(5567),
    [anon_sym_out] = ACTIONS(5567),
    [anon_sym_inout] = ACTIONS(5567),
    [anon_sym_virtual] = ACTIONS(5567),
    [anon_sym_extern] = ACTIONS(5567),
    [anon_sym___attribute__] = ACTIONS(5567),
    [anon_sym___attribute] = ACTIONS(5567),
    [anon_sym_using] = ACTIONS(5567),
    [anon_sym_COLON_COLON] = ACTIONS(5569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5569),
    [anon_sym___declspec] = ACTIONS(5567),
    [anon_sym___based] = ACTIONS(5567),
    [anon_sym_RBRACE] = ACTIONS(5569),
    [anon_sym_signed] = ACTIONS(5567),
    [anon_sym_unsigned] = ACTIONS(5567),
    [anon_sym_long] = ACTIONS(5567),
    [anon_sym_short] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(5567),
    [anon_sym_static] = ACTIONS(5567),
    [anon_sym_register] = ACTIONS(5567),
    [anon_sym_inline] = ACTIONS(5567),
    [anon_sym___inline] = ACTIONS(5567),
    [anon_sym___inline__] = ACTIONS(5567),
    [anon_sym___forceinline] = ACTIONS(5567),
    [anon_sym_thread_local] = ACTIONS(5567),
    [anon_sym___thread] = ACTIONS(5567),
    [anon_sym_const] = ACTIONS(5567),
    [anon_sym_constexpr] = ACTIONS(5567),
    [anon_sym_volatile] = ACTIONS(5567),
    [anon_sym_restrict] = ACTIONS(5567),
    [anon_sym___restrict__] = ACTIONS(5567),
    [anon_sym__Atomic] = ACTIONS(5567),
    [anon_sym__Noreturn] = ACTIONS(5567),
    [anon_sym_noreturn] = ACTIONS(5567),
    [anon_sym__Nonnull] = ACTIONS(5567),
    [anon_sym_mutable] = ACTIONS(5567),
    [anon_sym_constinit] = ACTIONS(5567),
    [anon_sym_consteval] = ACTIONS(5567),
    [anon_sym_alignas] = ACTIONS(5567),
    [anon_sym__Alignas] = ACTIONS(5567),
    [sym_primitive_type] = ACTIONS(5567),
    [anon_sym_enum] = ACTIONS(5567),
    [anon_sym_class] = ACTIONS(5567),
    [anon_sym_struct] = ACTIONS(5567),
    [anon_sym_union] = ACTIONS(5567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5567),
    [anon_sym_decltype] = ACTIONS(5567),
    [anon_sym_explicit] = ACTIONS(5567),
    [anon_sym_typename] = ACTIONS(5567),
    [anon_sym_private] = ACTIONS(5567),
    [anon_sym_template] = ACTIONS(5567),
    [anon_sym_operator] = ACTIONS(5567),
    [anon_sym_friend] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5567),
    [anon_sym_protected] = ACTIONS(5567),
    [anon_sym_static_assert] = ACTIONS(5567),
    [anon_sym_precise] = ACTIONS(5567),
    [anon_sym_shared] = ACTIONS(5567),
    [anon_sym_groupshared] = ACTIONS(5567),
    [anon_sym_uniform] = ACTIONS(5567),
    [anon_sym_row_major] = ACTIONS(5567),
    [anon_sym_column_major] = ACTIONS(5567),
    [anon_sym_globallycoherent] = ACTIONS(5567),
    [anon_sym_centroid] = ACTIONS(5567),
    [anon_sym_noperspective] = ACTIONS(5567),
    [anon_sym_nointerpolation] = ACTIONS(5567),
    [anon_sym_sample] = ACTIONS(5567),
    [anon_sym_linear] = ACTIONS(5567),
    [anon_sym_snorm] = ACTIONS(5567),
    [anon_sym_unorm] = ACTIONS(5567),
    [anon_sym_point] = ACTIONS(5567),
    [anon_sym_line] = ACTIONS(5567),
    [anon_sym_triangleadj] = ACTIONS(5567),
    [anon_sym_lineadj] = ACTIONS(5567),
    [anon_sym_triangle] = ACTIONS(5567),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(2453),
    [aux_sym_preproc_def_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token1] = ACTIONS(2453),
    [aux_sym_preproc_if_token2] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2453),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2453),
    [sym_preproc_directive] = ACTIONS(2453),
    [anon_sym_LPAREN2] = ACTIONS(2455),
    [anon_sym_TILDE] = ACTIONS(2455),
    [anon_sym_STAR] = ACTIONS(2455),
    [anon_sym_AMP_AMP] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_SEMI] = ACTIONS(2455),
    [anon_sym___extension__] = ACTIONS(2453),
    [anon_sym_typedef] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2453),
    [anon_sym_out] = ACTIONS(2453),
    [anon_sym_inout] = ACTIONS(2453),
    [anon_sym_virtual] = ACTIONS(2453),
    [anon_sym_extern] = ACTIONS(2453),
    [anon_sym___attribute__] = ACTIONS(2453),
    [anon_sym___attribute] = ACTIONS(2453),
    [anon_sym_using] = ACTIONS(2453),
    [anon_sym_COLON_COLON] = ACTIONS(2455),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2455),
    [anon_sym___declspec] = ACTIONS(2453),
    [anon_sym___based] = ACTIONS(2453),
    [anon_sym_signed] = ACTIONS(2453),
    [anon_sym_unsigned] = ACTIONS(2453),
    [anon_sym_long] = ACTIONS(2453),
    [anon_sym_short] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_static] = ACTIONS(2453),
    [anon_sym_register] = ACTIONS(2453),
    [anon_sym_inline] = ACTIONS(2453),
    [anon_sym___inline] = ACTIONS(2453),
    [anon_sym___inline__] = ACTIONS(2453),
    [anon_sym___forceinline] = ACTIONS(2453),
    [anon_sym_thread_local] = ACTIONS(2453),
    [anon_sym___thread] = ACTIONS(2453),
    [anon_sym_const] = ACTIONS(2453),
    [anon_sym_constexpr] = ACTIONS(2453),
    [anon_sym_volatile] = ACTIONS(2453),
    [anon_sym_restrict] = ACTIONS(2453),
    [anon_sym___restrict__] = ACTIONS(2453),
    [anon_sym__Atomic] = ACTIONS(2453),
    [anon_sym__Noreturn] = ACTIONS(2453),
    [anon_sym_noreturn] = ACTIONS(2453),
    [anon_sym__Nonnull] = ACTIONS(2453),
    [anon_sym_mutable] = ACTIONS(2453),
    [anon_sym_constinit] = ACTIONS(2453),
    [anon_sym_consteval] = ACTIONS(2453),
    [anon_sym_alignas] = ACTIONS(2453),
    [anon_sym__Alignas] = ACTIONS(2453),
    [sym_primitive_type] = ACTIONS(2453),
    [anon_sym_enum] = ACTIONS(2453),
    [anon_sym_class] = ACTIONS(2453),
    [anon_sym_struct] = ACTIONS(2453),
    [anon_sym_union] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2453),
    [anon_sym_decltype] = ACTIONS(2453),
    [anon_sym_explicit] = ACTIONS(2453),
    [anon_sym_typename] = ACTIONS(2453),
    [anon_sym_private] = ACTIONS(2453),
    [anon_sym_template] = ACTIONS(2453),
    [anon_sym_operator] = ACTIONS(2453),
    [anon_sym_friend] = ACTIONS(2453),
    [anon_sym_public] = ACTIONS(2453),
    [anon_sym_protected] = ACTIONS(2453),
    [anon_sym_static_assert] = ACTIONS(2453),
    [anon_sym_precise] = ACTIONS(2453),
    [anon_sym_shared] = ACTIONS(2453),
    [anon_sym_groupshared] = ACTIONS(2453),
    [anon_sym_uniform] = ACTIONS(2453),
    [anon_sym_row_major] = ACTIONS(2453),
    [anon_sym_column_major] = ACTIONS(2453),
    [anon_sym_globallycoherent] = ACTIONS(2453),
    [anon_sym_centroid] = ACTIONS(2453),
    [anon_sym_noperspective] = ACTIONS(2453),
    [anon_sym_nointerpolation] = ACTIONS(2453),
    [anon_sym_sample] = ACTIONS(2453),
    [anon_sym_linear] = ACTIONS(2453),
    [anon_sym_snorm] = ACTIONS(2453),
    [anon_sym_unorm] = ACTIONS(2453),
    [anon_sym_point] = ACTIONS(2453),
    [anon_sym_line] = ACTIONS(2453),
    [anon_sym_triangleadj] = ACTIONS(2453),
    [anon_sym_lineadj] = ACTIONS(2453),
    [anon_sym_triangle] = ACTIONS(2453),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(2470),
    [aux_sym_preproc_def_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token1] = ACTIONS(2470),
    [aux_sym_preproc_if_token2] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2470),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2470),
    [sym_preproc_directive] = ACTIONS(2470),
    [anon_sym_LPAREN2] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AMP_AMP] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym___extension__] = ACTIONS(2470),
    [anon_sym_typedef] = ACTIONS(2470),
    [anon_sym_in] = ACTIONS(2470),
    [anon_sym_out] = ACTIONS(2470),
    [anon_sym_inout] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym___attribute__] = ACTIONS(2470),
    [anon_sym___attribute] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_COLON_COLON] = ACTIONS(2472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2472),
    [anon_sym___declspec] = ACTIONS(2470),
    [anon_sym___based] = ACTIONS(2470),
    [anon_sym_signed] = ACTIONS(2470),
    [anon_sym_unsigned] = ACTIONS(2470),
    [anon_sym_long] = ACTIONS(2470),
    [anon_sym_short] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_register] = ACTIONS(2470),
    [anon_sym_inline] = ACTIONS(2470),
    [anon_sym___inline] = ACTIONS(2470),
    [anon_sym___inline__] = ACTIONS(2470),
    [anon_sym___forceinline] = ACTIONS(2470),
    [anon_sym_thread_local] = ACTIONS(2470),
    [anon_sym___thread] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_constexpr] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_restrict] = ACTIONS(2470),
    [anon_sym___restrict__] = ACTIONS(2470),
    [anon_sym__Atomic] = ACTIONS(2470),
    [anon_sym__Noreturn] = ACTIONS(2470),
    [anon_sym_noreturn] = ACTIONS(2470),
    [anon_sym__Nonnull] = ACTIONS(2470),
    [anon_sym_mutable] = ACTIONS(2470),
    [anon_sym_constinit] = ACTIONS(2470),
    [anon_sym_consteval] = ACTIONS(2470),
    [anon_sym_alignas] = ACTIONS(2470),
    [anon_sym__Alignas] = ACTIONS(2470),
    [sym_primitive_type] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_union] = ACTIONS(2470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2470),
    [anon_sym_decltype] = ACTIONS(2470),
    [anon_sym_explicit] = ACTIONS(2470),
    [anon_sym_typename] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_template] = ACTIONS(2470),
    [anon_sym_operator] = ACTIONS(2470),
    [anon_sym_friend] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_static_assert] = ACTIONS(2470),
    [anon_sym_precise] = ACTIONS(2470),
    [anon_sym_shared] = ACTIONS(2470),
    [anon_sym_groupshared] = ACTIONS(2470),
    [anon_sym_uniform] = ACTIONS(2470),
    [anon_sym_row_major] = ACTIONS(2470),
    [anon_sym_column_major] = ACTIONS(2470),
    [anon_sym_globallycoherent] = ACTIONS(2470),
    [anon_sym_centroid] = ACTIONS(2470),
    [anon_sym_noperspective] = ACTIONS(2470),
    [anon_sym_nointerpolation] = ACTIONS(2470),
    [anon_sym_sample] = ACTIONS(2470),
    [anon_sym_linear] = ACTIONS(2470),
    [anon_sym_snorm] = ACTIONS(2470),
    [anon_sym_unorm] = ACTIONS(2470),
    [anon_sym_point] = ACTIONS(2470),
    [anon_sym_line] = ACTIONS(2470),
    [anon_sym_triangleadj] = ACTIONS(2470),
    [anon_sym_lineadj] = ACTIONS(2470),
    [anon_sym_triangle] = ACTIONS(2470),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(2500),
    [aux_sym_preproc_def_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token1] = ACTIONS(2500),
    [aux_sym_preproc_if_token2] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2500),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2500),
    [sym_preproc_directive] = ACTIONS(2500),
    [anon_sym_LPAREN2] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_typedef] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_out] = ACTIONS(2500),
    [anon_sym_inout] = ACTIONS(2500),
    [anon_sym_virtual] = ACTIONS(2500),
    [anon_sym_extern] = ACTIONS(2500),
    [anon_sym___attribute__] = ACTIONS(2500),
    [anon_sym___attribute] = ACTIONS(2500),
    [anon_sym_using] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2502),
    [anon_sym___declspec] = ACTIONS(2500),
    [anon_sym___based] = ACTIONS(2500),
    [anon_sym_signed] = ACTIONS(2500),
    [anon_sym_unsigned] = ACTIONS(2500),
    [anon_sym_long] = ACTIONS(2500),
    [anon_sym_short] = ACTIONS(2500),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2500),
    [anon_sym_register] = ACTIONS(2500),
    [anon_sym_inline] = ACTIONS(2500),
    [anon_sym___inline] = ACTIONS(2500),
    [anon_sym___inline__] = ACTIONS(2500),
    [anon_sym___forceinline] = ACTIONS(2500),
    [anon_sym_thread_local] = ACTIONS(2500),
    [anon_sym___thread] = ACTIONS(2500),
    [anon_sym_const] = ACTIONS(2500),
    [anon_sym_constexpr] = ACTIONS(2500),
    [anon_sym_volatile] = ACTIONS(2500),
    [anon_sym_restrict] = ACTIONS(2500),
    [anon_sym___restrict__] = ACTIONS(2500),
    [anon_sym__Atomic] = ACTIONS(2500),
    [anon_sym__Noreturn] = ACTIONS(2500),
    [anon_sym_noreturn] = ACTIONS(2500),
    [anon_sym__Nonnull] = ACTIONS(2500),
    [anon_sym_mutable] = ACTIONS(2500),
    [anon_sym_constinit] = ACTIONS(2500),
    [anon_sym_consteval] = ACTIONS(2500),
    [anon_sym_alignas] = ACTIONS(2500),
    [anon_sym__Alignas] = ACTIONS(2500),
    [sym_primitive_type] = ACTIONS(2500),
    [anon_sym_enum] = ACTIONS(2500),
    [anon_sym_class] = ACTIONS(2500),
    [anon_sym_struct] = ACTIONS(2500),
    [anon_sym_union] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2500),
    [anon_sym_decltype] = ACTIONS(2500),
    [anon_sym_explicit] = ACTIONS(2500),
    [anon_sym_typename] = ACTIONS(2500),
    [anon_sym_private] = ACTIONS(2500),
    [anon_sym_template] = ACTIONS(2500),
    [anon_sym_operator] = ACTIONS(2500),
    [anon_sym_friend] = ACTIONS(2500),
    [anon_sym_public] = ACTIONS(2500),
    [anon_sym_protected] = ACTIONS(2500),
    [anon_sym_static_assert] = ACTIONS(2500),
    [anon_sym_precise] = ACTIONS(2500),
    [anon_sym_shared] = ACTIONS(2500),
    [anon_sym_groupshared] = ACTIONS(2500),
    [anon_sym_uniform] = ACTIONS(2500),
    [anon_sym_row_major] = ACTIONS(2500),
    [anon_sym_column_major] = ACTIONS(2500),
    [anon_sym_globallycoherent] = ACTIONS(2500),
    [anon_sym_centroid] = ACTIONS(2500),
    [anon_sym_noperspective] = ACTIONS(2500),
    [anon_sym_nointerpolation] = ACTIONS(2500),
    [anon_sym_sample] = ACTIONS(2500),
    [anon_sym_linear] = ACTIONS(2500),
    [anon_sym_snorm] = ACTIONS(2500),
    [anon_sym_unorm] = ACTIONS(2500),
    [anon_sym_point] = ACTIONS(2500),
    [anon_sym_line] = ACTIONS(2500),
    [anon_sym_triangleadj] = ACTIONS(2500),
    [anon_sym_lineadj] = ACTIONS(2500),
    [anon_sym_triangle] = ACTIONS(2500),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(2425),
    [aux_sym_preproc_def_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token1] = ACTIONS(2425),
    [aux_sym_preproc_if_token2] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2425),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2425),
    [sym_preproc_directive] = ACTIONS(2425),
    [anon_sym_LPAREN2] = ACTIONS(2427),
    [anon_sym_TILDE] = ACTIONS(2427),
    [anon_sym_STAR] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_SEMI] = ACTIONS(2427),
    [anon_sym___extension__] = ACTIONS(2425),
    [anon_sym_typedef] = ACTIONS(2425),
    [anon_sym_in] = ACTIONS(2425),
    [anon_sym_out] = ACTIONS(2425),
    [anon_sym_inout] = ACTIONS(2425),
    [anon_sym_virtual] = ACTIONS(2425),
    [anon_sym_extern] = ACTIONS(2425),
    [anon_sym___attribute__] = ACTIONS(2425),
    [anon_sym___attribute] = ACTIONS(2425),
    [anon_sym_using] = ACTIONS(2425),
    [anon_sym_COLON_COLON] = ACTIONS(2427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2427),
    [anon_sym___declspec] = ACTIONS(2425),
    [anon_sym___based] = ACTIONS(2425),
    [anon_sym_signed] = ACTIONS(2425),
    [anon_sym_unsigned] = ACTIONS(2425),
    [anon_sym_long] = ACTIONS(2425),
    [anon_sym_short] = ACTIONS(2425),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_static] = ACTIONS(2425),
    [anon_sym_register] = ACTIONS(2425),
    [anon_sym_inline] = ACTIONS(2425),
    [anon_sym___inline] = ACTIONS(2425),
    [anon_sym___inline__] = ACTIONS(2425),
    [anon_sym___forceinline] = ACTIONS(2425),
    [anon_sym_thread_local] = ACTIONS(2425),
    [anon_sym___thread] = ACTIONS(2425),
    [anon_sym_const] = ACTIONS(2425),
    [anon_sym_constexpr] = ACTIONS(2425),
    [anon_sym_volatile] = ACTIONS(2425),
    [anon_sym_restrict] = ACTIONS(2425),
    [anon_sym___restrict__] = ACTIONS(2425),
    [anon_sym__Atomic] = ACTIONS(2425),
    [anon_sym__Noreturn] = ACTIONS(2425),
    [anon_sym_noreturn] = ACTIONS(2425),
    [anon_sym__Nonnull] = ACTIONS(2425),
    [anon_sym_mutable] = ACTIONS(2425),
    [anon_sym_constinit] = ACTIONS(2425),
    [anon_sym_consteval] = ACTIONS(2425),
    [anon_sym_alignas] = ACTIONS(2425),
    [anon_sym__Alignas] = ACTIONS(2425),
    [sym_primitive_type] = ACTIONS(2425),
    [anon_sym_enum] = ACTIONS(2425),
    [anon_sym_class] = ACTIONS(2425),
    [anon_sym_struct] = ACTIONS(2425),
    [anon_sym_union] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2425),
    [anon_sym_decltype] = ACTIONS(2425),
    [anon_sym_explicit] = ACTIONS(2425),
    [anon_sym_typename] = ACTIONS(2425),
    [anon_sym_private] = ACTIONS(2425),
    [anon_sym_template] = ACTIONS(2425),
    [anon_sym_operator] = ACTIONS(2425),
    [anon_sym_friend] = ACTIONS(2425),
    [anon_sym_public] = ACTIONS(2425),
    [anon_sym_protected] = ACTIONS(2425),
    [anon_sym_static_assert] = ACTIONS(2425),
    [anon_sym_precise] = ACTIONS(2425),
    [anon_sym_shared] = ACTIONS(2425),
    [anon_sym_groupshared] = ACTIONS(2425),
    [anon_sym_uniform] = ACTIONS(2425),
    [anon_sym_row_major] = ACTIONS(2425),
    [anon_sym_column_major] = ACTIONS(2425),
    [anon_sym_globallycoherent] = ACTIONS(2425),
    [anon_sym_centroid] = ACTIONS(2425),
    [anon_sym_noperspective] = ACTIONS(2425),
    [anon_sym_nointerpolation] = ACTIONS(2425),
    [anon_sym_sample] = ACTIONS(2425),
    [anon_sym_linear] = ACTIONS(2425),
    [anon_sym_snorm] = ACTIONS(2425),
    [anon_sym_unorm] = ACTIONS(2425),
    [anon_sym_point] = ACTIONS(2425),
    [anon_sym_line] = ACTIONS(2425),
    [anon_sym_triangleadj] = ACTIONS(2425),
    [anon_sym_lineadj] = ACTIONS(2425),
    [anon_sym_triangle] = ACTIONS(2425),
  },
  [2196] = {
    [sym_identifier] = ACTIONS(2429),
    [aux_sym_preproc_def_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token1] = ACTIONS(2429),
    [aux_sym_preproc_if_token2] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2429),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2429),
    [sym_preproc_directive] = ACTIONS(2429),
    [anon_sym_LPAREN2] = ACTIONS(2431),
    [anon_sym_TILDE] = ACTIONS(2431),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AMP_AMP] = ACTIONS(2431),
    [anon_sym_AMP] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym___extension__] = ACTIONS(2429),
    [anon_sym_typedef] = ACTIONS(2429),
    [anon_sym_in] = ACTIONS(2429),
    [anon_sym_out] = ACTIONS(2429),
    [anon_sym_inout] = ACTIONS(2429),
    [anon_sym_virtual] = ACTIONS(2429),
    [anon_sym_extern] = ACTIONS(2429),
    [anon_sym___attribute__] = ACTIONS(2429),
    [anon_sym___attribute] = ACTIONS(2429),
    [anon_sym_using] = ACTIONS(2429),
    [anon_sym_COLON_COLON] = ACTIONS(2431),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2431),
    [anon_sym___declspec] = ACTIONS(2429),
    [anon_sym___based] = ACTIONS(2429),
    [anon_sym_signed] = ACTIONS(2429),
    [anon_sym_unsigned] = ACTIONS(2429),
    [anon_sym_long] = ACTIONS(2429),
    [anon_sym_short] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_static] = ACTIONS(2429),
    [anon_sym_register] = ACTIONS(2429),
    [anon_sym_inline] = ACTIONS(2429),
    [anon_sym___inline] = ACTIONS(2429),
    [anon_sym___inline__] = ACTIONS(2429),
    [anon_sym___forceinline] = ACTIONS(2429),
    [anon_sym_thread_local] = ACTIONS(2429),
    [anon_sym___thread] = ACTIONS(2429),
    [anon_sym_const] = ACTIONS(2429),
    [anon_sym_constexpr] = ACTIONS(2429),
    [anon_sym_volatile] = ACTIONS(2429),
    [anon_sym_restrict] = ACTIONS(2429),
    [anon_sym___restrict__] = ACTIONS(2429),
    [anon_sym__Atomic] = ACTIONS(2429),
    [anon_sym__Noreturn] = ACTIONS(2429),
    [anon_sym_noreturn] = ACTIONS(2429),
    [anon_sym__Nonnull] = ACTIONS(2429),
    [anon_sym_mutable] = ACTIONS(2429),
    [anon_sym_constinit] = ACTIONS(2429),
    [anon_sym_consteval] = ACTIONS(2429),
    [anon_sym_alignas] = ACTIONS(2429),
    [anon_sym__Alignas] = ACTIONS(2429),
    [sym_primitive_type] = ACTIONS(2429),
    [anon_sym_enum] = ACTIONS(2429),
    [anon_sym_class] = ACTIONS(2429),
    [anon_sym_struct] = ACTIONS(2429),
    [anon_sym_union] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2429),
    [anon_sym_decltype] = ACTIONS(2429),
    [anon_sym_explicit] = ACTIONS(2429),
    [anon_sym_typename] = ACTIONS(2429),
    [anon_sym_private] = ACTIONS(2429),
    [anon_sym_template] = ACTIONS(2429),
    [anon_sym_operator] = ACTIONS(2429),
    [anon_sym_friend] = ACTIONS(2429),
    [anon_sym_public] = ACTIONS(2429),
    [anon_sym_protected] = ACTIONS(2429),
    [anon_sym_static_assert] = ACTIONS(2429),
    [anon_sym_precise] = ACTIONS(2429),
    [anon_sym_shared] = ACTIONS(2429),
    [anon_sym_groupshared] = ACTIONS(2429),
    [anon_sym_uniform] = ACTIONS(2429),
    [anon_sym_row_major] = ACTIONS(2429),
    [anon_sym_column_major] = ACTIONS(2429),
    [anon_sym_globallycoherent] = ACTIONS(2429),
    [anon_sym_centroid] = ACTIONS(2429),
    [anon_sym_noperspective] = ACTIONS(2429),
    [anon_sym_nointerpolation] = ACTIONS(2429),
    [anon_sym_sample] = ACTIONS(2429),
    [anon_sym_linear] = ACTIONS(2429),
    [anon_sym_snorm] = ACTIONS(2429),
    [anon_sym_unorm] = ACTIONS(2429),
    [anon_sym_point] = ACTIONS(2429),
    [anon_sym_line] = ACTIONS(2429),
    [anon_sym_triangleadj] = ACTIONS(2429),
    [anon_sym_lineadj] = ACTIONS(2429),
    [anon_sym_triangle] = ACTIONS(2429),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(5571),
    [aux_sym_preproc_def_token1] = ACTIONS(5571),
    [aux_sym_preproc_if_token1] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5571),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5571),
    [sym_preproc_directive] = ACTIONS(5571),
    [anon_sym_LPAREN2] = ACTIONS(5573),
    [anon_sym_TILDE] = ACTIONS(5573),
    [anon_sym_STAR] = ACTIONS(5573),
    [anon_sym_AMP_AMP] = ACTIONS(5573),
    [anon_sym_AMP] = ACTIONS(5571),
    [anon_sym_SEMI] = ACTIONS(5573),
    [anon_sym___extension__] = ACTIONS(5571),
    [anon_sym_typedef] = ACTIONS(5571),
    [anon_sym_in] = ACTIONS(5571),
    [anon_sym_out] = ACTIONS(5571),
    [anon_sym_inout] = ACTIONS(5571),
    [anon_sym_virtual] = ACTIONS(5571),
    [anon_sym_extern] = ACTIONS(5571),
    [anon_sym___attribute__] = ACTIONS(5571),
    [anon_sym___attribute] = ACTIONS(5571),
    [anon_sym_using] = ACTIONS(5571),
    [anon_sym_COLON_COLON] = ACTIONS(5573),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5573),
    [anon_sym___declspec] = ACTIONS(5571),
    [anon_sym___based] = ACTIONS(5571),
    [anon_sym_RBRACE] = ACTIONS(5573),
    [anon_sym_signed] = ACTIONS(5571),
    [anon_sym_unsigned] = ACTIONS(5571),
    [anon_sym_long] = ACTIONS(5571),
    [anon_sym_short] = ACTIONS(5571),
    [anon_sym_LBRACK] = ACTIONS(5571),
    [anon_sym_static] = ACTIONS(5571),
    [anon_sym_register] = ACTIONS(5571),
    [anon_sym_inline] = ACTIONS(5571),
    [anon_sym___inline] = ACTIONS(5571),
    [anon_sym___inline__] = ACTIONS(5571),
    [anon_sym___forceinline] = ACTIONS(5571),
    [anon_sym_thread_local] = ACTIONS(5571),
    [anon_sym___thread] = ACTIONS(5571),
    [anon_sym_const] = ACTIONS(5571),
    [anon_sym_constexpr] = ACTIONS(5571),
    [anon_sym_volatile] = ACTIONS(5571),
    [anon_sym_restrict] = ACTIONS(5571),
    [anon_sym___restrict__] = ACTIONS(5571),
    [anon_sym__Atomic] = ACTIONS(5571),
    [anon_sym__Noreturn] = ACTIONS(5571),
    [anon_sym_noreturn] = ACTIONS(5571),
    [anon_sym__Nonnull] = ACTIONS(5571),
    [anon_sym_mutable] = ACTIONS(5571),
    [anon_sym_constinit] = ACTIONS(5571),
    [anon_sym_consteval] = ACTIONS(5571),
    [anon_sym_alignas] = ACTIONS(5571),
    [anon_sym__Alignas] = ACTIONS(5571),
    [sym_primitive_type] = ACTIONS(5571),
    [anon_sym_enum] = ACTIONS(5571),
    [anon_sym_class] = ACTIONS(5571),
    [anon_sym_struct] = ACTIONS(5571),
    [anon_sym_union] = ACTIONS(5571),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5571),
    [anon_sym_decltype] = ACTIONS(5571),
    [anon_sym_explicit] = ACTIONS(5571),
    [anon_sym_typename] = ACTIONS(5571),
    [anon_sym_private] = ACTIONS(5571),
    [anon_sym_template] = ACTIONS(5571),
    [anon_sym_operator] = ACTIONS(5571),
    [anon_sym_friend] = ACTIONS(5571),
    [anon_sym_public] = ACTIONS(5571),
    [anon_sym_protected] = ACTIONS(5571),
    [anon_sym_static_assert] = ACTIONS(5571),
    [anon_sym_precise] = ACTIONS(5571),
    [anon_sym_shared] = ACTIONS(5571),
    [anon_sym_groupshared] = ACTIONS(5571),
    [anon_sym_uniform] = ACTIONS(5571),
    [anon_sym_row_major] = ACTIONS(5571),
    [anon_sym_column_major] = ACTIONS(5571),
    [anon_sym_globallycoherent] = ACTIONS(5571),
    [anon_sym_centroid] = ACTIONS(5571),
    [anon_sym_noperspective] = ACTIONS(5571),
    [anon_sym_nointerpolation] = ACTIONS(5571),
    [anon_sym_sample] = ACTIONS(5571),
    [anon_sym_linear] = ACTIONS(5571),
    [anon_sym_snorm] = ACTIONS(5571),
    [anon_sym_unorm] = ACTIONS(5571),
    [anon_sym_point] = ACTIONS(5571),
    [anon_sym_line] = ACTIONS(5571),
    [anon_sym_triangleadj] = ACTIONS(5571),
    [anon_sym_lineadj] = ACTIONS(5571),
    [anon_sym_triangle] = ACTIONS(5571),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token2] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(2492),
    [aux_sym_preproc_def_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token1] = ACTIONS(2492),
    [aux_sym_preproc_if_token2] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2492),
    [sym_preproc_directive] = ACTIONS(2492),
    [anon_sym_LPAREN2] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym___extension__] = ACTIONS(2492),
    [anon_sym_typedef] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_out] = ACTIONS(2492),
    [anon_sym_inout] = ACTIONS(2492),
    [anon_sym_virtual] = ACTIONS(2492),
    [anon_sym_extern] = ACTIONS(2492),
    [anon_sym___attribute__] = ACTIONS(2492),
    [anon_sym___attribute] = ACTIONS(2492),
    [anon_sym_using] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2494),
    [anon_sym___declspec] = ACTIONS(2492),
    [anon_sym___based] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2492),
    [anon_sym_unsigned] = ACTIONS(2492),
    [anon_sym_long] = ACTIONS(2492),
    [anon_sym_short] = ACTIONS(2492),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2492),
    [anon_sym_register] = ACTIONS(2492),
    [anon_sym_inline] = ACTIONS(2492),
    [anon_sym___inline] = ACTIONS(2492),
    [anon_sym___inline__] = ACTIONS(2492),
    [anon_sym___forceinline] = ACTIONS(2492),
    [anon_sym_thread_local] = ACTIONS(2492),
    [anon_sym___thread] = ACTIONS(2492),
    [anon_sym_const] = ACTIONS(2492),
    [anon_sym_constexpr] = ACTIONS(2492),
    [anon_sym_volatile] = ACTIONS(2492),
    [anon_sym_restrict] = ACTIONS(2492),
    [anon_sym___restrict__] = ACTIONS(2492),
    [anon_sym__Atomic] = ACTIONS(2492),
    [anon_sym__Noreturn] = ACTIONS(2492),
    [anon_sym_noreturn] = ACTIONS(2492),
    [anon_sym__Nonnull] = ACTIONS(2492),
    [anon_sym_mutable] = ACTIONS(2492),
    [anon_sym_constinit] = ACTIONS(2492),
    [anon_sym_consteval] = ACTIONS(2492),
    [anon_sym_alignas] = ACTIONS(2492),
    [anon_sym__Alignas] = ACTIONS(2492),
    [sym_primitive_type] = ACTIONS(2492),
    [anon_sym_enum] = ACTIONS(2492),
    [anon_sym_class] = ACTIONS(2492),
    [anon_sym_struct] = ACTIONS(2492),
    [anon_sym_union] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2492),
    [anon_sym_decltype] = ACTIONS(2492),
    [anon_sym_explicit] = ACTIONS(2492),
    [anon_sym_typename] = ACTIONS(2492),
    [anon_sym_private] = ACTIONS(2492),
    [anon_sym_template] = ACTIONS(2492),
    [anon_sym_operator] = ACTIONS(2492),
    [anon_sym_friend] = ACTIONS(2492),
    [anon_sym_public] = ACTIONS(2492),
    [anon_sym_protected] = ACTIONS(2492),
    [anon_sym_static_assert] = ACTIONS(2492),
    [anon_sym_precise] = ACTIONS(2492),
    [anon_sym_shared] = ACTIONS(2492),
    [anon_sym_groupshared] = ACTIONS(2492),
    [anon_sym_uniform] = ACTIONS(2492),
    [anon_sym_row_major] = ACTIONS(2492),
    [anon_sym_column_major] = ACTIONS(2492),
    [anon_sym_globallycoherent] = ACTIONS(2492),
    [anon_sym_centroid] = ACTIONS(2492),
    [anon_sym_noperspective] = ACTIONS(2492),
    [anon_sym_nointerpolation] = ACTIONS(2492),
    [anon_sym_sample] = ACTIONS(2492),
    [anon_sym_linear] = ACTIONS(2492),
    [anon_sym_snorm] = ACTIONS(2492),
    [anon_sym_unorm] = ACTIONS(2492),
    [anon_sym_point] = ACTIONS(2492),
    [anon_sym_line] = ACTIONS(2492),
    [anon_sym_triangleadj] = ACTIONS(2492),
    [anon_sym_lineadj] = ACTIONS(2492),
    [anon_sym_triangle] = ACTIONS(2492),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2202] = {
    [sym_identifier] = ACTIONS(2488),
    [aux_sym_preproc_def_token1] = ACTIONS(2488),
    [aux_sym_preproc_if_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2488),
    [sym_preproc_directive] = ACTIONS(2488),
    [anon_sym_LPAREN2] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym___extension__] = ACTIONS(2488),
    [anon_sym_typedef] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2488),
    [anon_sym_out] = ACTIONS(2488),
    [anon_sym_inout] = ACTIONS(2488),
    [anon_sym_virtual] = ACTIONS(2488),
    [anon_sym_extern] = ACTIONS(2488),
    [anon_sym___attribute__] = ACTIONS(2488),
    [anon_sym___attribute] = ACTIONS(2488),
    [anon_sym_using] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2490),
    [anon_sym___declspec] = ACTIONS(2488),
    [anon_sym___based] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2488),
    [anon_sym_unsigned] = ACTIONS(2488),
    [anon_sym_long] = ACTIONS(2488),
    [anon_sym_short] = ACTIONS(2488),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2488),
    [anon_sym_register] = ACTIONS(2488),
    [anon_sym_inline] = ACTIONS(2488),
    [anon_sym___inline] = ACTIONS(2488),
    [anon_sym___inline__] = ACTIONS(2488),
    [anon_sym___forceinline] = ACTIONS(2488),
    [anon_sym_thread_local] = ACTIONS(2488),
    [anon_sym___thread] = ACTIONS(2488),
    [anon_sym_const] = ACTIONS(2488),
    [anon_sym_constexpr] = ACTIONS(2488),
    [anon_sym_volatile] = ACTIONS(2488),
    [anon_sym_restrict] = ACTIONS(2488),
    [anon_sym___restrict__] = ACTIONS(2488),
    [anon_sym__Atomic] = ACTIONS(2488),
    [anon_sym__Noreturn] = ACTIONS(2488),
    [anon_sym_noreturn] = ACTIONS(2488),
    [anon_sym__Nonnull] = ACTIONS(2488),
    [anon_sym_mutable] = ACTIONS(2488),
    [anon_sym_constinit] = ACTIONS(2488),
    [anon_sym_consteval] = ACTIONS(2488),
    [anon_sym_alignas] = ACTIONS(2488),
    [anon_sym__Alignas] = ACTIONS(2488),
    [sym_primitive_type] = ACTIONS(2488),
    [anon_sym_enum] = ACTIONS(2488),
    [anon_sym_class] = ACTIONS(2488),
    [anon_sym_struct] = ACTIONS(2488),
    [anon_sym_union] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2488),
    [anon_sym_decltype] = ACTIONS(2488),
    [anon_sym_explicit] = ACTIONS(2488),
    [anon_sym_typename] = ACTIONS(2488),
    [anon_sym_private] = ACTIONS(2488),
    [anon_sym_template] = ACTIONS(2488),
    [anon_sym_operator] = ACTIONS(2488),
    [anon_sym_friend] = ACTIONS(2488),
    [anon_sym_public] = ACTIONS(2488),
    [anon_sym_protected] = ACTIONS(2488),
    [anon_sym_static_assert] = ACTIONS(2488),
    [anon_sym_precise] = ACTIONS(2488),
    [anon_sym_shared] = ACTIONS(2488),
    [anon_sym_groupshared] = ACTIONS(2488),
    [anon_sym_uniform] = ACTIONS(2488),
    [anon_sym_row_major] = ACTIONS(2488),
    [anon_sym_column_major] = ACTIONS(2488),
    [anon_sym_globallycoherent] = ACTIONS(2488),
    [anon_sym_centroid] = ACTIONS(2488),
    [anon_sym_noperspective] = ACTIONS(2488),
    [anon_sym_nointerpolation] = ACTIONS(2488),
    [anon_sym_sample] = ACTIONS(2488),
    [anon_sym_linear] = ACTIONS(2488),
    [anon_sym_snorm] = ACTIONS(2488),
    [anon_sym_unorm] = ACTIONS(2488),
    [anon_sym_point] = ACTIONS(2488),
    [anon_sym_line] = ACTIONS(2488),
    [anon_sym_triangleadj] = ACTIONS(2488),
    [anon_sym_lineadj] = ACTIONS(2488),
    [anon_sym_triangle] = ACTIONS(2488),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(5575),
    [aux_sym_preproc_def_token1] = ACTIONS(5575),
    [aux_sym_preproc_if_token1] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5575),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5575),
    [sym_preproc_directive] = ACTIONS(5575),
    [anon_sym_LPAREN2] = ACTIONS(5577),
    [anon_sym_TILDE] = ACTIONS(5577),
    [anon_sym_STAR] = ACTIONS(5577),
    [anon_sym_AMP_AMP] = ACTIONS(5577),
    [anon_sym_AMP] = ACTIONS(5575),
    [anon_sym_SEMI] = ACTIONS(5577),
    [anon_sym___extension__] = ACTIONS(5575),
    [anon_sym_typedef] = ACTIONS(5575),
    [anon_sym_in] = ACTIONS(5575),
    [anon_sym_out] = ACTIONS(5575),
    [anon_sym_inout] = ACTIONS(5575),
    [anon_sym_virtual] = ACTIONS(5575),
    [anon_sym_extern] = ACTIONS(5575),
    [anon_sym___attribute__] = ACTIONS(5575),
    [anon_sym___attribute] = ACTIONS(5575),
    [anon_sym_using] = ACTIONS(5575),
    [anon_sym_COLON_COLON] = ACTIONS(5577),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5577),
    [anon_sym___declspec] = ACTIONS(5575),
    [anon_sym___based] = ACTIONS(5575),
    [anon_sym_RBRACE] = ACTIONS(5577),
    [anon_sym_signed] = ACTIONS(5575),
    [anon_sym_unsigned] = ACTIONS(5575),
    [anon_sym_long] = ACTIONS(5575),
    [anon_sym_short] = ACTIONS(5575),
    [anon_sym_LBRACK] = ACTIONS(5575),
    [anon_sym_static] = ACTIONS(5575),
    [anon_sym_register] = ACTIONS(5575),
    [anon_sym_inline] = ACTIONS(5575),
    [anon_sym___inline] = ACTIONS(5575),
    [anon_sym___inline__] = ACTIONS(5575),
    [anon_sym___forceinline] = ACTIONS(5575),
    [anon_sym_thread_local] = ACTIONS(5575),
    [anon_sym___thread] = ACTIONS(5575),
    [anon_sym_const] = ACTIONS(5575),
    [anon_sym_constexpr] = ACTIONS(5575),
    [anon_sym_volatile] = ACTIONS(5575),
    [anon_sym_restrict] = ACTIONS(5575),
    [anon_sym___restrict__] = ACTIONS(5575),
    [anon_sym__Atomic] = ACTIONS(5575),
    [anon_sym__Noreturn] = ACTIONS(5575),
    [anon_sym_noreturn] = ACTIONS(5575),
    [anon_sym__Nonnull] = ACTIONS(5575),
    [anon_sym_mutable] = ACTIONS(5575),
    [anon_sym_constinit] = ACTIONS(5575),
    [anon_sym_consteval] = ACTIONS(5575),
    [anon_sym_alignas] = ACTIONS(5575),
    [anon_sym__Alignas] = ACTIONS(5575),
    [sym_primitive_type] = ACTIONS(5575),
    [anon_sym_enum] = ACTIONS(5575),
    [anon_sym_class] = ACTIONS(5575),
    [anon_sym_struct] = ACTIONS(5575),
    [anon_sym_union] = ACTIONS(5575),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5575),
    [anon_sym_decltype] = ACTIONS(5575),
    [anon_sym_explicit] = ACTIONS(5575),
    [anon_sym_typename] = ACTIONS(5575),
    [anon_sym_private] = ACTIONS(5575),
    [anon_sym_template] = ACTIONS(5575),
    [anon_sym_operator] = ACTIONS(5575),
    [anon_sym_friend] = ACTIONS(5575),
    [anon_sym_public] = ACTIONS(5575),
    [anon_sym_protected] = ACTIONS(5575),
    [anon_sym_static_assert] = ACTIONS(5575),
    [anon_sym_precise] = ACTIONS(5575),
    [anon_sym_shared] = ACTIONS(5575),
    [anon_sym_groupshared] = ACTIONS(5575),
    [anon_sym_uniform] = ACTIONS(5575),
    [anon_sym_row_major] = ACTIONS(5575),
    [anon_sym_column_major] = ACTIONS(5575),
    [anon_sym_globallycoherent] = ACTIONS(5575),
    [anon_sym_centroid] = ACTIONS(5575),
    [anon_sym_noperspective] = ACTIONS(5575),
    [anon_sym_nointerpolation] = ACTIONS(5575),
    [anon_sym_sample] = ACTIONS(5575),
    [anon_sym_linear] = ACTIONS(5575),
    [anon_sym_snorm] = ACTIONS(5575),
    [anon_sym_unorm] = ACTIONS(5575),
    [anon_sym_point] = ACTIONS(5575),
    [anon_sym_line] = ACTIONS(5575),
    [anon_sym_triangleadj] = ACTIONS(5575),
    [anon_sym_lineadj] = ACTIONS(5575),
    [anon_sym_triangle] = ACTIONS(5575),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(2524),
    [aux_sym_preproc_def_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token1] = ACTIONS(2524),
    [aux_sym_preproc_if_token2] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2524),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2524),
    [sym_preproc_directive] = ACTIONS(2524),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2524),
    [anon_sym_typedef] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2524),
    [anon_sym_out] = ACTIONS(2524),
    [anon_sym_inout] = ACTIONS(2524),
    [anon_sym_virtual] = ACTIONS(2524),
    [anon_sym_extern] = ACTIONS(2524),
    [anon_sym___attribute__] = ACTIONS(2524),
    [anon_sym___attribute] = ACTIONS(2524),
    [anon_sym_using] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2524),
    [anon_sym___based] = ACTIONS(2524),
    [anon_sym_signed] = ACTIONS(2524),
    [anon_sym_unsigned] = ACTIONS(2524),
    [anon_sym_long] = ACTIONS(2524),
    [anon_sym_short] = ACTIONS(2524),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2524),
    [anon_sym_register] = ACTIONS(2524),
    [anon_sym_inline] = ACTIONS(2524),
    [anon_sym___inline] = ACTIONS(2524),
    [anon_sym___inline__] = ACTIONS(2524),
    [anon_sym___forceinline] = ACTIONS(2524),
    [anon_sym_thread_local] = ACTIONS(2524),
    [anon_sym___thread] = ACTIONS(2524),
    [anon_sym_const] = ACTIONS(2524),
    [anon_sym_constexpr] = ACTIONS(2524),
    [anon_sym_volatile] = ACTIONS(2524),
    [anon_sym_restrict] = ACTIONS(2524),
    [anon_sym___restrict__] = ACTIONS(2524),
    [anon_sym__Atomic] = ACTIONS(2524),
    [anon_sym__Noreturn] = ACTIONS(2524),
    [anon_sym_noreturn] = ACTIONS(2524),
    [anon_sym__Nonnull] = ACTIONS(2524),
    [anon_sym_mutable] = ACTIONS(2524),
    [anon_sym_constinit] = ACTIONS(2524),
    [anon_sym_consteval] = ACTIONS(2524),
    [anon_sym_alignas] = ACTIONS(2524),
    [anon_sym__Alignas] = ACTIONS(2524),
    [sym_primitive_type] = ACTIONS(2524),
    [anon_sym_enum] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_struct] = ACTIONS(2524),
    [anon_sym_union] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2524),
    [anon_sym_decltype] = ACTIONS(2524),
    [anon_sym_explicit] = ACTIONS(2524),
    [anon_sym_typename] = ACTIONS(2524),
    [anon_sym_private] = ACTIONS(2524),
    [anon_sym_template] = ACTIONS(2524),
    [anon_sym_operator] = ACTIONS(2524),
    [anon_sym_friend] = ACTIONS(2524),
    [anon_sym_public] = ACTIONS(2524),
    [anon_sym_protected] = ACTIONS(2524),
    [anon_sym_static_assert] = ACTIONS(2524),
    [anon_sym_precise] = ACTIONS(2524),
    [anon_sym_shared] = ACTIONS(2524),
    [anon_sym_groupshared] = ACTIONS(2524),
    [anon_sym_uniform] = ACTIONS(2524),
    [anon_sym_row_major] = ACTIONS(2524),
    [anon_sym_column_major] = ACTIONS(2524),
    [anon_sym_globallycoherent] = ACTIONS(2524),
    [anon_sym_centroid] = ACTIONS(2524),
    [anon_sym_noperspective] = ACTIONS(2524),
    [anon_sym_nointerpolation] = ACTIONS(2524),
    [anon_sym_sample] = ACTIONS(2524),
    [anon_sym_linear] = ACTIONS(2524),
    [anon_sym_snorm] = ACTIONS(2524),
    [anon_sym_unorm] = ACTIONS(2524),
    [anon_sym_point] = ACTIONS(2524),
    [anon_sym_line] = ACTIONS(2524),
    [anon_sym_triangleadj] = ACTIONS(2524),
    [anon_sym_lineadj] = ACTIONS(2524),
    [anon_sym_triangle] = ACTIONS(2524),
  },
  [2206] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(2556),
    [aux_sym_preproc_def_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token1] = ACTIONS(2556),
    [aux_sym_preproc_if_token2] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2556),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2556),
    [sym_preproc_directive] = ACTIONS(2556),
    [anon_sym_LPAREN2] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym___extension__] = ACTIONS(2556),
    [anon_sym_typedef] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2556),
    [anon_sym_out] = ACTIONS(2556),
    [anon_sym_inout] = ACTIONS(2556),
    [anon_sym_virtual] = ACTIONS(2556),
    [anon_sym_extern] = ACTIONS(2556),
    [anon_sym___attribute__] = ACTIONS(2556),
    [anon_sym___attribute] = ACTIONS(2556),
    [anon_sym_using] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2558),
    [anon_sym___declspec] = ACTIONS(2556),
    [anon_sym___based] = ACTIONS(2556),
    [anon_sym_signed] = ACTIONS(2556),
    [anon_sym_unsigned] = ACTIONS(2556),
    [anon_sym_long] = ACTIONS(2556),
    [anon_sym_short] = ACTIONS(2556),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2556),
    [anon_sym_register] = ACTIONS(2556),
    [anon_sym_inline] = ACTIONS(2556),
    [anon_sym___inline] = ACTIONS(2556),
    [anon_sym___inline__] = ACTIONS(2556),
    [anon_sym___forceinline] = ACTIONS(2556),
    [anon_sym_thread_local] = ACTIONS(2556),
    [anon_sym___thread] = ACTIONS(2556),
    [anon_sym_const] = ACTIONS(2556),
    [anon_sym_constexpr] = ACTIONS(2556),
    [anon_sym_volatile] = ACTIONS(2556),
    [anon_sym_restrict] = ACTIONS(2556),
    [anon_sym___restrict__] = ACTIONS(2556),
    [anon_sym__Atomic] = ACTIONS(2556),
    [anon_sym__Noreturn] = ACTIONS(2556),
    [anon_sym_noreturn] = ACTIONS(2556),
    [anon_sym__Nonnull] = ACTIONS(2556),
    [anon_sym_mutable] = ACTIONS(2556),
    [anon_sym_constinit] = ACTIONS(2556),
    [anon_sym_consteval] = ACTIONS(2556),
    [anon_sym_alignas] = ACTIONS(2556),
    [anon_sym__Alignas] = ACTIONS(2556),
    [sym_primitive_type] = ACTIONS(2556),
    [anon_sym_enum] = ACTIONS(2556),
    [anon_sym_class] = ACTIONS(2556),
    [anon_sym_struct] = ACTIONS(2556),
    [anon_sym_union] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2556),
    [anon_sym_decltype] = ACTIONS(2556),
    [anon_sym_explicit] = ACTIONS(2556),
    [anon_sym_typename] = ACTIONS(2556),
    [anon_sym_private] = ACTIONS(2556),
    [anon_sym_template] = ACTIONS(2556),
    [anon_sym_operator] = ACTIONS(2556),
    [anon_sym_friend] = ACTIONS(2556),
    [anon_sym_public] = ACTIONS(2556),
    [anon_sym_protected] = ACTIONS(2556),
    [anon_sym_static_assert] = ACTIONS(2556),
    [anon_sym_precise] = ACTIONS(2556),
    [anon_sym_shared] = ACTIONS(2556),
    [anon_sym_groupshared] = ACTIONS(2556),
    [anon_sym_uniform] = ACTIONS(2556),
    [anon_sym_row_major] = ACTIONS(2556),
    [anon_sym_column_major] = ACTIONS(2556),
    [anon_sym_globallycoherent] = ACTIONS(2556),
    [anon_sym_centroid] = ACTIONS(2556),
    [anon_sym_noperspective] = ACTIONS(2556),
    [anon_sym_nointerpolation] = ACTIONS(2556),
    [anon_sym_sample] = ACTIONS(2556),
    [anon_sym_linear] = ACTIONS(2556),
    [anon_sym_snorm] = ACTIONS(2556),
    [anon_sym_unorm] = ACTIONS(2556),
    [anon_sym_point] = ACTIONS(2556),
    [anon_sym_line] = ACTIONS(2556),
    [anon_sym_triangleadj] = ACTIONS(2556),
    [anon_sym_lineadj] = ACTIONS(2556),
    [anon_sym_triangle] = ACTIONS(2556),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token2] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_private] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_friend] = ACTIONS(2560),
    [anon_sym_public] = ACTIONS(2560),
    [anon_sym_protected] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token2] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_private] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_friend] = ACTIONS(2564),
    [anon_sym_public] = ACTIONS(2564),
    [anon_sym_protected] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
  },
  [2210] = {
    [sym_identifier] = ACTIONS(2433),
    [aux_sym_preproc_def_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token1] = ACTIONS(2433),
    [aux_sym_preproc_if_token2] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2433),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2433),
    [sym_preproc_directive] = ACTIONS(2433),
    [anon_sym_LPAREN2] = ACTIONS(2435),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_AMP_AMP] = ACTIONS(2435),
    [anon_sym_AMP] = ACTIONS(2433),
    [anon_sym_SEMI] = ACTIONS(2435),
    [anon_sym___extension__] = ACTIONS(2433),
    [anon_sym_typedef] = ACTIONS(2433),
    [anon_sym_in] = ACTIONS(2433),
    [anon_sym_out] = ACTIONS(2433),
    [anon_sym_inout] = ACTIONS(2433),
    [anon_sym_virtual] = ACTIONS(2433),
    [anon_sym_extern] = ACTIONS(2433),
    [anon_sym___attribute__] = ACTIONS(2433),
    [anon_sym___attribute] = ACTIONS(2433),
    [anon_sym_using] = ACTIONS(2433),
    [anon_sym_COLON_COLON] = ACTIONS(2435),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2435),
    [anon_sym___declspec] = ACTIONS(2433),
    [anon_sym___based] = ACTIONS(2433),
    [anon_sym_signed] = ACTIONS(2433),
    [anon_sym_unsigned] = ACTIONS(2433),
    [anon_sym_long] = ACTIONS(2433),
    [anon_sym_short] = ACTIONS(2433),
    [anon_sym_LBRACK] = ACTIONS(2433),
    [anon_sym_static] = ACTIONS(2433),
    [anon_sym_register] = ACTIONS(2433),
    [anon_sym_inline] = ACTIONS(2433),
    [anon_sym___inline] = ACTIONS(2433),
    [anon_sym___inline__] = ACTIONS(2433),
    [anon_sym___forceinline] = ACTIONS(2433),
    [anon_sym_thread_local] = ACTIONS(2433),
    [anon_sym___thread] = ACTIONS(2433),
    [anon_sym_const] = ACTIONS(2433),
    [anon_sym_constexpr] = ACTIONS(2433),
    [anon_sym_volatile] = ACTIONS(2433),
    [anon_sym_restrict] = ACTIONS(2433),
    [anon_sym___restrict__] = ACTIONS(2433),
    [anon_sym__Atomic] = ACTIONS(2433),
    [anon_sym__Noreturn] = ACTIONS(2433),
    [anon_sym_noreturn] = ACTIONS(2433),
    [anon_sym__Nonnull] = ACTIONS(2433),
    [anon_sym_mutable] = ACTIONS(2433),
    [anon_sym_constinit] = ACTIONS(2433),
    [anon_sym_consteval] = ACTIONS(2433),
    [anon_sym_alignas] = ACTIONS(2433),
    [anon_sym__Alignas] = ACTIONS(2433),
    [sym_primitive_type] = ACTIONS(2433),
    [anon_sym_enum] = ACTIONS(2433),
    [anon_sym_class] = ACTIONS(2433),
    [anon_sym_struct] = ACTIONS(2433),
    [anon_sym_union] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2433),
    [anon_sym_decltype] = ACTIONS(2433),
    [anon_sym_explicit] = ACTIONS(2433),
    [anon_sym_typename] = ACTIONS(2433),
    [anon_sym_private] = ACTIONS(2433),
    [anon_sym_template] = ACTIONS(2433),
    [anon_sym_operator] = ACTIONS(2433),
    [anon_sym_friend] = ACTIONS(2433),
    [anon_sym_public] = ACTIONS(2433),
    [anon_sym_protected] = ACTIONS(2433),
    [anon_sym_static_assert] = ACTIONS(2433),
    [anon_sym_precise] = ACTIONS(2433),
    [anon_sym_shared] = ACTIONS(2433),
    [anon_sym_groupshared] = ACTIONS(2433),
    [anon_sym_uniform] = ACTIONS(2433),
    [anon_sym_row_major] = ACTIONS(2433),
    [anon_sym_column_major] = ACTIONS(2433),
    [anon_sym_globallycoherent] = ACTIONS(2433),
    [anon_sym_centroid] = ACTIONS(2433),
    [anon_sym_noperspective] = ACTIONS(2433),
    [anon_sym_nointerpolation] = ACTIONS(2433),
    [anon_sym_sample] = ACTIONS(2433),
    [anon_sym_linear] = ACTIONS(2433),
    [anon_sym_snorm] = ACTIONS(2433),
    [anon_sym_unorm] = ACTIONS(2433),
    [anon_sym_point] = ACTIONS(2433),
    [anon_sym_line] = ACTIONS(2433),
    [anon_sym_triangleadj] = ACTIONS(2433),
    [anon_sym_lineadj] = ACTIONS(2433),
    [anon_sym_triangle] = ACTIONS(2433),
  },
  [2211] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(2676),
    [aux_sym_preproc_def_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token1] = ACTIONS(2676),
    [aux_sym_preproc_if_token2] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2676),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2676),
    [sym_preproc_directive] = ACTIONS(2676),
    [anon_sym_LPAREN2] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2678),
    [anon_sym_STAR] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_AMP] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym___extension__] = ACTIONS(2676),
    [anon_sym_typedef] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2676),
    [anon_sym_out] = ACTIONS(2676),
    [anon_sym_inout] = ACTIONS(2676),
    [anon_sym_virtual] = ACTIONS(2676),
    [anon_sym_extern] = ACTIONS(2676),
    [anon_sym___attribute__] = ACTIONS(2676),
    [anon_sym___attribute] = ACTIONS(2676),
    [anon_sym_using] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2678),
    [anon_sym___declspec] = ACTIONS(2676),
    [anon_sym___based] = ACTIONS(2676),
    [anon_sym_signed] = ACTIONS(2676),
    [anon_sym_unsigned] = ACTIONS(2676),
    [anon_sym_long] = ACTIONS(2676),
    [anon_sym_short] = ACTIONS(2676),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2676),
    [anon_sym_register] = ACTIONS(2676),
    [anon_sym_inline] = ACTIONS(2676),
    [anon_sym___inline] = ACTIONS(2676),
    [anon_sym___inline__] = ACTIONS(2676),
    [anon_sym___forceinline] = ACTIONS(2676),
    [anon_sym_thread_local] = ACTIONS(2676),
    [anon_sym___thread] = ACTIONS(2676),
    [anon_sym_const] = ACTIONS(2676),
    [anon_sym_constexpr] = ACTIONS(2676),
    [anon_sym_volatile] = ACTIONS(2676),
    [anon_sym_restrict] = ACTIONS(2676),
    [anon_sym___restrict__] = ACTIONS(2676),
    [anon_sym__Atomic] = ACTIONS(2676),
    [anon_sym__Noreturn] = ACTIONS(2676),
    [anon_sym_noreturn] = ACTIONS(2676),
    [anon_sym__Nonnull] = ACTIONS(2676),
    [anon_sym_mutable] = ACTIONS(2676),
    [anon_sym_constinit] = ACTIONS(2676),
    [anon_sym_consteval] = ACTIONS(2676),
    [anon_sym_alignas] = ACTIONS(2676),
    [anon_sym__Alignas] = ACTIONS(2676),
    [sym_primitive_type] = ACTIONS(2676),
    [anon_sym_enum] = ACTIONS(2676),
    [anon_sym_class] = ACTIONS(2676),
    [anon_sym_struct] = ACTIONS(2676),
    [anon_sym_union] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2676),
    [anon_sym_decltype] = ACTIONS(2676),
    [anon_sym_explicit] = ACTIONS(2676),
    [anon_sym_typename] = ACTIONS(2676),
    [anon_sym_private] = ACTIONS(2676),
    [anon_sym_template] = ACTIONS(2676),
    [anon_sym_operator] = ACTIONS(2676),
    [anon_sym_friend] = ACTIONS(2676),
    [anon_sym_public] = ACTIONS(2676),
    [anon_sym_protected] = ACTIONS(2676),
    [anon_sym_static_assert] = ACTIONS(2676),
    [anon_sym_precise] = ACTIONS(2676),
    [anon_sym_shared] = ACTIONS(2676),
    [anon_sym_groupshared] = ACTIONS(2676),
    [anon_sym_uniform] = ACTIONS(2676),
    [anon_sym_row_major] = ACTIONS(2676),
    [anon_sym_column_major] = ACTIONS(2676),
    [anon_sym_globallycoherent] = ACTIONS(2676),
    [anon_sym_centroid] = ACTIONS(2676),
    [anon_sym_noperspective] = ACTIONS(2676),
    [anon_sym_nointerpolation] = ACTIONS(2676),
    [anon_sym_sample] = ACTIONS(2676),
    [anon_sym_linear] = ACTIONS(2676),
    [anon_sym_snorm] = ACTIONS(2676),
    [anon_sym_unorm] = ACTIONS(2676),
    [anon_sym_point] = ACTIONS(2676),
    [anon_sym_line] = ACTIONS(2676),
    [anon_sym_triangleadj] = ACTIONS(2676),
    [anon_sym_lineadj] = ACTIONS(2676),
    [anon_sym_triangle] = ACTIONS(2676),
  },
  [2213] = {
    [sym_identifier] = ACTIONS(2437),
    [aux_sym_preproc_def_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token1] = ACTIONS(2437),
    [aux_sym_preproc_if_token2] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2437),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2437),
    [sym_preproc_directive] = ACTIONS(2437),
    [anon_sym_LPAREN2] = ACTIONS(2439),
    [anon_sym_TILDE] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2439),
    [anon_sym_AMP_AMP] = ACTIONS(2439),
    [anon_sym_AMP] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2439),
    [anon_sym___extension__] = ACTIONS(2437),
    [anon_sym_typedef] = ACTIONS(2437),
    [anon_sym_in] = ACTIONS(2437),
    [anon_sym_out] = ACTIONS(2437),
    [anon_sym_inout] = ACTIONS(2437),
    [anon_sym_virtual] = ACTIONS(2437),
    [anon_sym_extern] = ACTIONS(2437),
    [anon_sym___attribute__] = ACTIONS(2437),
    [anon_sym___attribute] = ACTIONS(2437),
    [anon_sym_using] = ACTIONS(2437),
    [anon_sym_COLON_COLON] = ACTIONS(2439),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2439),
    [anon_sym___declspec] = ACTIONS(2437),
    [anon_sym___based] = ACTIONS(2437),
    [anon_sym_signed] = ACTIONS(2437),
    [anon_sym_unsigned] = ACTIONS(2437),
    [anon_sym_long] = ACTIONS(2437),
    [anon_sym_short] = ACTIONS(2437),
    [anon_sym_LBRACK] = ACTIONS(2437),
    [anon_sym_static] = ACTIONS(2437),
    [anon_sym_register] = ACTIONS(2437),
    [anon_sym_inline] = ACTIONS(2437),
    [anon_sym___inline] = ACTIONS(2437),
    [anon_sym___inline__] = ACTIONS(2437),
    [anon_sym___forceinline] = ACTIONS(2437),
    [anon_sym_thread_local] = ACTIONS(2437),
    [anon_sym___thread] = ACTIONS(2437),
    [anon_sym_const] = ACTIONS(2437),
    [anon_sym_constexpr] = ACTIONS(2437),
    [anon_sym_volatile] = ACTIONS(2437),
    [anon_sym_restrict] = ACTIONS(2437),
    [anon_sym___restrict__] = ACTIONS(2437),
    [anon_sym__Atomic] = ACTIONS(2437),
    [anon_sym__Noreturn] = ACTIONS(2437),
    [anon_sym_noreturn] = ACTIONS(2437),
    [anon_sym__Nonnull] = ACTIONS(2437),
    [anon_sym_mutable] = ACTIONS(2437),
    [anon_sym_constinit] = ACTIONS(2437),
    [anon_sym_consteval] = ACTIONS(2437),
    [anon_sym_alignas] = ACTIONS(2437),
    [anon_sym__Alignas] = ACTIONS(2437),
    [sym_primitive_type] = ACTIONS(2437),
    [anon_sym_enum] = ACTIONS(2437),
    [anon_sym_class] = ACTIONS(2437),
    [anon_sym_struct] = ACTIONS(2437),
    [anon_sym_union] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2437),
    [anon_sym_decltype] = ACTIONS(2437),
    [anon_sym_explicit] = ACTIONS(2437),
    [anon_sym_typename] = ACTIONS(2437),
    [anon_sym_private] = ACTIONS(2437),
    [anon_sym_template] = ACTIONS(2437),
    [anon_sym_operator] = ACTIONS(2437),
    [anon_sym_friend] = ACTIONS(2437),
    [anon_sym_public] = ACTIONS(2437),
    [anon_sym_protected] = ACTIONS(2437),
    [anon_sym_static_assert] = ACTIONS(2437),
    [anon_sym_precise] = ACTIONS(2437),
    [anon_sym_shared] = ACTIONS(2437),
    [anon_sym_groupshared] = ACTIONS(2437),
    [anon_sym_uniform] = ACTIONS(2437),
    [anon_sym_row_major] = ACTIONS(2437),
    [anon_sym_column_major] = ACTIONS(2437),
    [anon_sym_globallycoherent] = ACTIONS(2437),
    [anon_sym_centroid] = ACTIONS(2437),
    [anon_sym_noperspective] = ACTIONS(2437),
    [anon_sym_nointerpolation] = ACTIONS(2437),
    [anon_sym_sample] = ACTIONS(2437),
    [anon_sym_linear] = ACTIONS(2437),
    [anon_sym_snorm] = ACTIONS(2437),
    [anon_sym_unorm] = ACTIONS(2437),
    [anon_sym_point] = ACTIONS(2437),
    [anon_sym_line] = ACTIONS(2437),
    [anon_sym_triangleadj] = ACTIONS(2437),
    [anon_sym_lineadj] = ACTIONS(2437),
    [anon_sym_triangle] = ACTIONS(2437),
  },
  [2214] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token2] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(5643),
    [aux_sym_preproc_def_token1] = ACTIONS(5643),
    [aux_sym_preproc_if_token1] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5643),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5643),
    [sym_preproc_directive] = ACTIONS(5643),
    [anon_sym_LPAREN2] = ACTIONS(5645),
    [anon_sym_TILDE] = ACTIONS(5645),
    [anon_sym_STAR] = ACTIONS(5645),
    [anon_sym_AMP_AMP] = ACTIONS(5645),
    [anon_sym_AMP] = ACTIONS(5643),
    [anon_sym_SEMI] = ACTIONS(5645),
    [anon_sym___extension__] = ACTIONS(5643),
    [anon_sym_typedef] = ACTIONS(5643),
    [anon_sym_in] = ACTIONS(5643),
    [anon_sym_out] = ACTIONS(5643),
    [anon_sym_inout] = ACTIONS(5643),
    [anon_sym_virtual] = ACTIONS(5643),
    [anon_sym_extern] = ACTIONS(5643),
    [anon_sym___attribute__] = ACTIONS(5643),
    [anon_sym___attribute] = ACTIONS(5643),
    [anon_sym_using] = ACTIONS(5643),
    [anon_sym_COLON_COLON] = ACTIONS(5645),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5645),
    [anon_sym___declspec] = ACTIONS(5643),
    [anon_sym___based] = ACTIONS(5643),
    [anon_sym_RBRACE] = ACTIONS(5645),
    [anon_sym_signed] = ACTIONS(5643),
    [anon_sym_unsigned] = ACTIONS(5643),
    [anon_sym_long] = ACTIONS(5643),
    [anon_sym_short] = ACTIONS(5643),
    [anon_sym_LBRACK] = ACTIONS(5643),
    [anon_sym_static] = ACTIONS(5643),
    [anon_sym_register] = ACTIONS(5643),
    [anon_sym_inline] = ACTIONS(5643),
    [anon_sym___inline] = ACTIONS(5643),
    [anon_sym___inline__] = ACTIONS(5643),
    [anon_sym___forceinline] = ACTIONS(5643),
    [anon_sym_thread_local] = ACTIONS(5643),
    [anon_sym___thread] = ACTIONS(5643),
    [anon_sym_const] = ACTIONS(5643),
    [anon_sym_constexpr] = ACTIONS(5643),
    [anon_sym_volatile] = ACTIONS(5643),
    [anon_sym_restrict] = ACTIONS(5643),
    [anon_sym___restrict__] = ACTIONS(5643),
    [anon_sym__Atomic] = ACTIONS(5643),
    [anon_sym__Noreturn] = ACTIONS(5643),
    [anon_sym_noreturn] = ACTIONS(5643),
    [anon_sym__Nonnull] = ACTIONS(5643),
    [anon_sym_mutable] = ACTIONS(5643),
    [anon_sym_constinit] = ACTIONS(5643),
    [anon_sym_consteval] = ACTIONS(5643),
    [anon_sym_alignas] = ACTIONS(5643),
    [anon_sym__Alignas] = ACTIONS(5643),
    [sym_primitive_type] = ACTIONS(5643),
    [anon_sym_enum] = ACTIONS(5643),
    [anon_sym_class] = ACTIONS(5643),
    [anon_sym_struct] = ACTIONS(5643),
    [anon_sym_union] = ACTIONS(5643),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5643),
    [anon_sym_decltype] = ACTIONS(5643),
    [anon_sym_explicit] = ACTIONS(5643),
    [anon_sym_typename] = ACTIONS(5643),
    [anon_sym_private] = ACTIONS(5643),
    [anon_sym_template] = ACTIONS(5643),
    [anon_sym_operator] = ACTIONS(5643),
    [anon_sym_friend] = ACTIONS(5643),
    [anon_sym_public] = ACTIONS(5643),
    [anon_sym_protected] = ACTIONS(5643),
    [anon_sym_static_assert] = ACTIONS(5643),
    [anon_sym_precise] = ACTIONS(5643),
    [anon_sym_shared] = ACTIONS(5643),
    [anon_sym_groupshared] = ACTIONS(5643),
    [anon_sym_uniform] = ACTIONS(5643),
    [anon_sym_row_major] = ACTIONS(5643),
    [anon_sym_column_major] = ACTIONS(5643),
    [anon_sym_globallycoherent] = ACTIONS(5643),
    [anon_sym_centroid] = ACTIONS(5643),
    [anon_sym_noperspective] = ACTIONS(5643),
    [anon_sym_nointerpolation] = ACTIONS(5643),
    [anon_sym_sample] = ACTIONS(5643),
    [anon_sym_linear] = ACTIONS(5643),
    [anon_sym_snorm] = ACTIONS(5643),
    [anon_sym_unorm] = ACTIONS(5643),
    [anon_sym_point] = ACTIONS(5643),
    [anon_sym_line] = ACTIONS(5643),
    [anon_sym_triangleadj] = ACTIONS(5643),
    [anon_sym_lineadj] = ACTIONS(5643),
    [anon_sym_triangle] = ACTIONS(5643),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(5631),
    [aux_sym_preproc_def_token1] = ACTIONS(5631),
    [aux_sym_preproc_if_token1] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5631),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5631),
    [sym_preproc_directive] = ACTIONS(5631),
    [anon_sym_LPAREN2] = ACTIONS(5633),
    [anon_sym_TILDE] = ACTIONS(5633),
    [anon_sym_STAR] = ACTIONS(5633),
    [anon_sym_AMP_AMP] = ACTIONS(5633),
    [anon_sym_AMP] = ACTIONS(5631),
    [anon_sym_SEMI] = ACTIONS(5633),
    [anon_sym___extension__] = ACTIONS(5631),
    [anon_sym_typedef] = ACTIONS(5631),
    [anon_sym_in] = ACTIONS(5631),
    [anon_sym_out] = ACTIONS(5631),
    [anon_sym_inout] = ACTIONS(5631),
    [anon_sym_virtual] = ACTIONS(5631),
    [anon_sym_extern] = ACTIONS(5631),
    [anon_sym___attribute__] = ACTIONS(5631),
    [anon_sym___attribute] = ACTIONS(5631),
    [anon_sym_using] = ACTIONS(5631),
    [anon_sym_COLON_COLON] = ACTIONS(5633),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5633),
    [anon_sym___declspec] = ACTIONS(5631),
    [anon_sym___based] = ACTIONS(5631),
    [anon_sym_RBRACE] = ACTIONS(5633),
    [anon_sym_signed] = ACTIONS(5631),
    [anon_sym_unsigned] = ACTIONS(5631),
    [anon_sym_long] = ACTIONS(5631),
    [anon_sym_short] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(5631),
    [anon_sym_static] = ACTIONS(5631),
    [anon_sym_register] = ACTIONS(5631),
    [anon_sym_inline] = ACTIONS(5631),
    [anon_sym___inline] = ACTIONS(5631),
    [anon_sym___inline__] = ACTIONS(5631),
    [anon_sym___forceinline] = ACTIONS(5631),
    [anon_sym_thread_local] = ACTIONS(5631),
    [anon_sym___thread] = ACTIONS(5631),
    [anon_sym_const] = ACTIONS(5631),
    [anon_sym_constexpr] = ACTIONS(5631),
    [anon_sym_volatile] = ACTIONS(5631),
    [anon_sym_restrict] = ACTIONS(5631),
    [anon_sym___restrict__] = ACTIONS(5631),
    [anon_sym__Atomic] = ACTIONS(5631),
    [anon_sym__Noreturn] = ACTIONS(5631),
    [anon_sym_noreturn] = ACTIONS(5631),
    [anon_sym__Nonnull] = ACTIONS(5631),
    [anon_sym_mutable] = ACTIONS(5631),
    [anon_sym_constinit] = ACTIONS(5631),
    [anon_sym_consteval] = ACTIONS(5631),
    [anon_sym_alignas] = ACTIONS(5631),
    [anon_sym__Alignas] = ACTIONS(5631),
    [sym_primitive_type] = ACTIONS(5631),
    [anon_sym_enum] = ACTIONS(5631),
    [anon_sym_class] = ACTIONS(5631),
    [anon_sym_struct] = ACTIONS(5631),
    [anon_sym_union] = ACTIONS(5631),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5631),
    [anon_sym_decltype] = ACTIONS(5631),
    [anon_sym_explicit] = ACTIONS(5631),
    [anon_sym_typename] = ACTIONS(5631),
    [anon_sym_private] = ACTIONS(5631),
    [anon_sym_template] = ACTIONS(5631),
    [anon_sym_operator] = ACTIONS(5631),
    [anon_sym_friend] = ACTIONS(5631),
    [anon_sym_public] = ACTIONS(5631),
    [anon_sym_protected] = ACTIONS(5631),
    [anon_sym_static_assert] = ACTIONS(5631),
    [anon_sym_precise] = ACTIONS(5631),
    [anon_sym_shared] = ACTIONS(5631),
    [anon_sym_groupshared] = ACTIONS(5631),
    [anon_sym_uniform] = ACTIONS(5631),
    [anon_sym_row_major] = ACTIONS(5631),
    [anon_sym_column_major] = ACTIONS(5631),
    [anon_sym_globallycoherent] = ACTIONS(5631),
    [anon_sym_centroid] = ACTIONS(5631),
    [anon_sym_noperspective] = ACTIONS(5631),
    [anon_sym_nointerpolation] = ACTIONS(5631),
    [anon_sym_sample] = ACTIONS(5631),
    [anon_sym_linear] = ACTIONS(5631),
    [anon_sym_snorm] = ACTIONS(5631),
    [anon_sym_unorm] = ACTIONS(5631),
    [anon_sym_point] = ACTIONS(5631),
    [anon_sym_line] = ACTIONS(5631),
    [anon_sym_triangleadj] = ACTIONS(5631),
    [anon_sym_lineadj] = ACTIONS(5631),
    [anon_sym_triangle] = ACTIONS(5631),
  },
  [2217] = {
    [sym_identifier] = ACTIONS(5539),
    [aux_sym_preproc_def_token1] = ACTIONS(5539),
    [aux_sym_preproc_if_token1] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5539),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5539),
    [sym_preproc_directive] = ACTIONS(5539),
    [anon_sym_LPAREN2] = ACTIONS(5541),
    [anon_sym_TILDE] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_AMP_AMP] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5541),
    [anon_sym___extension__] = ACTIONS(5539),
    [anon_sym_typedef] = ACTIONS(5539),
    [anon_sym_in] = ACTIONS(5539),
    [anon_sym_out] = ACTIONS(5539),
    [anon_sym_inout] = ACTIONS(5539),
    [anon_sym_virtual] = ACTIONS(5539),
    [anon_sym_extern] = ACTIONS(5539),
    [anon_sym___attribute__] = ACTIONS(5539),
    [anon_sym___attribute] = ACTIONS(5539),
    [anon_sym_using] = ACTIONS(5539),
    [anon_sym_COLON_COLON] = ACTIONS(5541),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5541),
    [anon_sym___declspec] = ACTIONS(5539),
    [anon_sym___based] = ACTIONS(5539),
    [anon_sym_RBRACE] = ACTIONS(5541),
    [anon_sym_signed] = ACTIONS(5539),
    [anon_sym_unsigned] = ACTIONS(5539),
    [anon_sym_long] = ACTIONS(5539),
    [anon_sym_short] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_static] = ACTIONS(5539),
    [anon_sym_register] = ACTIONS(5539),
    [anon_sym_inline] = ACTIONS(5539),
    [anon_sym___inline] = ACTIONS(5539),
    [anon_sym___inline__] = ACTIONS(5539),
    [anon_sym___forceinline] = ACTIONS(5539),
    [anon_sym_thread_local] = ACTIONS(5539),
    [anon_sym___thread] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5539),
    [anon_sym_constexpr] = ACTIONS(5539),
    [anon_sym_volatile] = ACTIONS(5539),
    [anon_sym_restrict] = ACTIONS(5539),
    [anon_sym___restrict__] = ACTIONS(5539),
    [anon_sym__Atomic] = ACTIONS(5539),
    [anon_sym__Noreturn] = ACTIONS(5539),
    [anon_sym_noreturn] = ACTIONS(5539),
    [anon_sym__Nonnull] = ACTIONS(5539),
    [anon_sym_mutable] = ACTIONS(5539),
    [anon_sym_constinit] = ACTIONS(5539),
    [anon_sym_consteval] = ACTIONS(5539),
    [anon_sym_alignas] = ACTIONS(5539),
    [anon_sym__Alignas] = ACTIONS(5539),
    [sym_primitive_type] = ACTIONS(5539),
    [anon_sym_enum] = ACTIONS(5539),
    [anon_sym_class] = ACTIONS(5539),
    [anon_sym_struct] = ACTIONS(5539),
    [anon_sym_union] = ACTIONS(5539),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5539),
    [anon_sym_decltype] = ACTIONS(5539),
    [anon_sym_explicit] = ACTIONS(5539),
    [anon_sym_typename] = ACTIONS(5539),
    [anon_sym_private] = ACTIONS(5539),
    [anon_sym_template] = ACTIONS(5539),
    [anon_sym_operator] = ACTIONS(5539),
    [anon_sym_friend] = ACTIONS(5539),
    [anon_sym_public] = ACTIONS(5539),
    [anon_sym_protected] = ACTIONS(5539),
    [anon_sym_static_assert] = ACTIONS(5539),
    [anon_sym_precise] = ACTIONS(5539),
    [anon_sym_shared] = ACTIONS(5539),
    [anon_sym_groupshared] = ACTIONS(5539),
    [anon_sym_uniform] = ACTIONS(5539),
    [anon_sym_row_major] = ACTIONS(5539),
    [anon_sym_column_major] = ACTIONS(5539),
    [anon_sym_globallycoherent] = ACTIONS(5539),
    [anon_sym_centroid] = ACTIONS(5539),
    [anon_sym_noperspective] = ACTIONS(5539),
    [anon_sym_nointerpolation] = ACTIONS(5539),
    [anon_sym_sample] = ACTIONS(5539),
    [anon_sym_linear] = ACTIONS(5539),
    [anon_sym_snorm] = ACTIONS(5539),
    [anon_sym_unorm] = ACTIONS(5539),
    [anon_sym_point] = ACTIONS(5539),
    [anon_sym_line] = ACTIONS(5539),
    [anon_sym_triangleadj] = ACTIONS(5539),
    [anon_sym_lineadj] = ACTIONS(5539),
    [anon_sym_triangle] = ACTIONS(5539),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(5595),
    [aux_sym_preproc_def_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token1] = ACTIONS(5595),
    [aux_sym_preproc_if_token2] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5595),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5595),
    [sym_preproc_directive] = ACTIONS(5595),
    [anon_sym_LPAREN2] = ACTIONS(5597),
    [anon_sym_TILDE] = ACTIONS(5597),
    [anon_sym_STAR] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5597),
    [anon_sym_AMP] = ACTIONS(5595),
    [anon_sym_SEMI] = ACTIONS(5597),
    [anon_sym___extension__] = ACTIONS(5595),
    [anon_sym_typedef] = ACTIONS(5595),
    [anon_sym_in] = ACTIONS(5595),
    [anon_sym_out] = ACTIONS(5595),
    [anon_sym_inout] = ACTIONS(5595),
    [anon_sym_virtual] = ACTIONS(5595),
    [anon_sym_extern] = ACTIONS(5595),
    [anon_sym___attribute__] = ACTIONS(5595),
    [anon_sym___attribute] = ACTIONS(5595),
    [anon_sym_using] = ACTIONS(5595),
    [anon_sym_COLON_COLON] = ACTIONS(5597),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5597),
    [anon_sym___declspec] = ACTIONS(5595),
    [anon_sym___based] = ACTIONS(5595),
    [anon_sym_signed] = ACTIONS(5595),
    [anon_sym_unsigned] = ACTIONS(5595),
    [anon_sym_long] = ACTIONS(5595),
    [anon_sym_short] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(5595),
    [anon_sym_static] = ACTIONS(5595),
    [anon_sym_register] = ACTIONS(5595),
    [anon_sym_inline] = ACTIONS(5595),
    [anon_sym___inline] = ACTIONS(5595),
    [anon_sym___inline__] = ACTIONS(5595),
    [anon_sym___forceinline] = ACTIONS(5595),
    [anon_sym_thread_local] = ACTIONS(5595),
    [anon_sym___thread] = ACTIONS(5595),
    [anon_sym_const] = ACTIONS(5595),
    [anon_sym_constexpr] = ACTIONS(5595),
    [anon_sym_volatile] = ACTIONS(5595),
    [anon_sym_restrict] = ACTIONS(5595),
    [anon_sym___restrict__] = ACTIONS(5595),
    [anon_sym__Atomic] = ACTIONS(5595),
    [anon_sym__Noreturn] = ACTIONS(5595),
    [anon_sym_noreturn] = ACTIONS(5595),
    [anon_sym__Nonnull] = ACTIONS(5595),
    [anon_sym_mutable] = ACTIONS(5595),
    [anon_sym_constinit] = ACTIONS(5595),
    [anon_sym_consteval] = ACTIONS(5595),
    [anon_sym_alignas] = ACTIONS(5595),
    [anon_sym__Alignas] = ACTIONS(5595),
    [sym_primitive_type] = ACTIONS(5595),
    [anon_sym_enum] = ACTIONS(5595),
    [anon_sym_class] = ACTIONS(5595),
    [anon_sym_struct] = ACTIONS(5595),
    [anon_sym_union] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5595),
    [anon_sym_decltype] = ACTIONS(5595),
    [anon_sym_explicit] = ACTIONS(5595),
    [anon_sym_typename] = ACTIONS(5595),
    [anon_sym_private] = ACTIONS(5595),
    [anon_sym_template] = ACTIONS(5595),
    [anon_sym_operator] = ACTIONS(5595),
    [anon_sym_friend] = ACTIONS(5595),
    [anon_sym_public] = ACTIONS(5595),
    [anon_sym_protected] = ACTIONS(5595),
    [anon_sym_static_assert] = ACTIONS(5595),
    [anon_sym_precise] = ACTIONS(5595),
    [anon_sym_shared] = ACTIONS(5595),
    [anon_sym_groupshared] = ACTIONS(5595),
    [anon_sym_uniform] = ACTIONS(5595),
    [anon_sym_row_major] = ACTIONS(5595),
    [anon_sym_column_major] = ACTIONS(5595),
    [anon_sym_globallycoherent] = ACTIONS(5595),
    [anon_sym_centroid] = ACTIONS(5595),
    [anon_sym_noperspective] = ACTIONS(5595),
    [anon_sym_nointerpolation] = ACTIONS(5595),
    [anon_sym_sample] = ACTIONS(5595),
    [anon_sym_linear] = ACTIONS(5595),
    [anon_sym_snorm] = ACTIONS(5595),
    [anon_sym_unorm] = ACTIONS(5595),
    [anon_sym_point] = ACTIONS(5595),
    [anon_sym_line] = ACTIONS(5595),
    [anon_sym_triangleadj] = ACTIONS(5595),
    [anon_sym_lineadj] = ACTIONS(5595),
    [anon_sym_triangle] = ACTIONS(5595),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(2560),
    [aux_sym_preproc_def_token1] = ACTIONS(2560),
    [aux_sym_preproc_if_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2560),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2560),
    [sym_preproc_directive] = ACTIONS(2560),
    [anon_sym_LPAREN2] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym___extension__] = ACTIONS(2560),
    [anon_sym_typedef] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2560),
    [anon_sym_out] = ACTIONS(2560),
    [anon_sym_inout] = ACTIONS(2560),
    [anon_sym_virtual] = ACTIONS(2560),
    [anon_sym_extern] = ACTIONS(2560),
    [anon_sym___attribute__] = ACTIONS(2560),
    [anon_sym___attribute] = ACTIONS(2560),
    [anon_sym_using] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2562),
    [anon_sym___declspec] = ACTIONS(2560),
    [anon_sym___based] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2562),
    [anon_sym_signed] = ACTIONS(2560),
    [anon_sym_unsigned] = ACTIONS(2560),
    [anon_sym_long] = ACTIONS(2560),
    [anon_sym_short] = ACTIONS(2560),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2560),
    [anon_sym_register] = ACTIONS(2560),
    [anon_sym_inline] = ACTIONS(2560),
    [anon_sym___inline] = ACTIONS(2560),
    [anon_sym___inline__] = ACTIONS(2560),
    [anon_sym___forceinline] = ACTIONS(2560),
    [anon_sym_thread_local] = ACTIONS(2560),
    [anon_sym___thread] = ACTIONS(2560),
    [anon_sym_const] = ACTIONS(2560),
    [anon_sym_constexpr] = ACTIONS(2560),
    [anon_sym_volatile] = ACTIONS(2560),
    [anon_sym_restrict] = ACTIONS(2560),
    [anon_sym___restrict__] = ACTIONS(2560),
    [anon_sym__Atomic] = ACTIONS(2560),
    [anon_sym__Noreturn] = ACTIONS(2560),
    [anon_sym_noreturn] = ACTIONS(2560),
    [anon_sym__Nonnull] = ACTIONS(2560),
    [anon_sym_mutable] = ACTIONS(2560),
    [anon_sym_constinit] = ACTIONS(2560),
    [anon_sym_consteval] = ACTIONS(2560),
    [anon_sym_alignas] = ACTIONS(2560),
    [anon_sym__Alignas] = ACTIONS(2560),
    [sym_primitive_type] = ACTIONS(2560),
    [anon_sym_enum] = ACTIONS(2560),
    [anon_sym_class] = ACTIONS(2560),
    [anon_sym_struct] = ACTIONS(2560),
    [anon_sym_union] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2560),
    [anon_sym_decltype] = ACTIONS(2560),
    [anon_sym_explicit] = ACTIONS(2560),
    [anon_sym_typename] = ACTIONS(2560),
    [anon_sym_private] = ACTIONS(2560),
    [anon_sym_template] = ACTIONS(2560),
    [anon_sym_operator] = ACTIONS(2560),
    [anon_sym_friend] = ACTIONS(2560),
    [anon_sym_public] = ACTIONS(2560),
    [anon_sym_protected] = ACTIONS(2560),
    [anon_sym_static_assert] = ACTIONS(2560),
    [anon_sym_precise] = ACTIONS(2560),
    [anon_sym_shared] = ACTIONS(2560),
    [anon_sym_groupshared] = ACTIONS(2560),
    [anon_sym_uniform] = ACTIONS(2560),
    [anon_sym_row_major] = ACTIONS(2560),
    [anon_sym_column_major] = ACTIONS(2560),
    [anon_sym_globallycoherent] = ACTIONS(2560),
    [anon_sym_centroid] = ACTIONS(2560),
    [anon_sym_noperspective] = ACTIONS(2560),
    [anon_sym_nointerpolation] = ACTIONS(2560),
    [anon_sym_sample] = ACTIONS(2560),
    [anon_sym_linear] = ACTIONS(2560),
    [anon_sym_snorm] = ACTIONS(2560),
    [anon_sym_unorm] = ACTIONS(2560),
    [anon_sym_point] = ACTIONS(2560),
    [anon_sym_line] = ACTIONS(2560),
    [anon_sym_triangleadj] = ACTIONS(2560),
    [anon_sym_lineadj] = ACTIONS(2560),
    [anon_sym_triangle] = ACTIONS(2560),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(2564),
    [aux_sym_preproc_def_token1] = ACTIONS(2564),
    [aux_sym_preproc_if_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2564),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2564),
    [sym_preproc_directive] = ACTIONS(2564),
    [anon_sym_LPAREN2] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym___extension__] = ACTIONS(2564),
    [anon_sym_typedef] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2564),
    [anon_sym_out] = ACTIONS(2564),
    [anon_sym_inout] = ACTIONS(2564),
    [anon_sym_virtual] = ACTIONS(2564),
    [anon_sym_extern] = ACTIONS(2564),
    [anon_sym___attribute__] = ACTIONS(2564),
    [anon_sym___attribute] = ACTIONS(2564),
    [anon_sym_using] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2566),
    [anon_sym___declspec] = ACTIONS(2564),
    [anon_sym___based] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2566),
    [anon_sym_signed] = ACTIONS(2564),
    [anon_sym_unsigned] = ACTIONS(2564),
    [anon_sym_long] = ACTIONS(2564),
    [anon_sym_short] = ACTIONS(2564),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2564),
    [anon_sym_register] = ACTIONS(2564),
    [anon_sym_inline] = ACTIONS(2564),
    [anon_sym___inline] = ACTIONS(2564),
    [anon_sym___inline__] = ACTIONS(2564),
    [anon_sym___forceinline] = ACTIONS(2564),
    [anon_sym_thread_local] = ACTIONS(2564),
    [anon_sym___thread] = ACTIONS(2564),
    [anon_sym_const] = ACTIONS(2564),
    [anon_sym_constexpr] = ACTIONS(2564),
    [anon_sym_volatile] = ACTIONS(2564),
    [anon_sym_restrict] = ACTIONS(2564),
    [anon_sym___restrict__] = ACTIONS(2564),
    [anon_sym__Atomic] = ACTIONS(2564),
    [anon_sym__Noreturn] = ACTIONS(2564),
    [anon_sym_noreturn] = ACTIONS(2564),
    [anon_sym__Nonnull] = ACTIONS(2564),
    [anon_sym_mutable] = ACTIONS(2564),
    [anon_sym_constinit] = ACTIONS(2564),
    [anon_sym_consteval] = ACTIONS(2564),
    [anon_sym_alignas] = ACTIONS(2564),
    [anon_sym__Alignas] = ACTIONS(2564),
    [sym_primitive_type] = ACTIONS(2564),
    [anon_sym_enum] = ACTIONS(2564),
    [anon_sym_class] = ACTIONS(2564),
    [anon_sym_struct] = ACTIONS(2564),
    [anon_sym_union] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2564),
    [anon_sym_decltype] = ACTIONS(2564),
    [anon_sym_explicit] = ACTIONS(2564),
    [anon_sym_typename] = ACTIONS(2564),
    [anon_sym_private] = ACTIONS(2564),
    [anon_sym_template] = ACTIONS(2564),
    [anon_sym_operator] = ACTIONS(2564),
    [anon_sym_friend] = ACTIONS(2564),
    [anon_sym_public] = ACTIONS(2564),
    [anon_sym_protected] = ACTIONS(2564),
    [anon_sym_static_assert] = ACTIONS(2564),
    [anon_sym_precise] = ACTIONS(2564),
    [anon_sym_shared] = ACTIONS(2564),
    [anon_sym_groupshared] = ACTIONS(2564),
    [anon_sym_uniform] = ACTIONS(2564),
    [anon_sym_row_major] = ACTIONS(2564),
    [anon_sym_column_major] = ACTIONS(2564),
    [anon_sym_globallycoherent] = ACTIONS(2564),
    [anon_sym_centroid] = ACTIONS(2564),
    [anon_sym_noperspective] = ACTIONS(2564),
    [anon_sym_nointerpolation] = ACTIONS(2564),
    [anon_sym_sample] = ACTIONS(2564),
    [anon_sym_linear] = ACTIONS(2564),
    [anon_sym_snorm] = ACTIONS(2564),
    [anon_sym_unorm] = ACTIONS(2564),
    [anon_sym_point] = ACTIONS(2564),
    [anon_sym_line] = ACTIONS(2564),
    [anon_sym_triangleadj] = ACTIONS(2564),
    [anon_sym_lineadj] = ACTIONS(2564),
    [anon_sym_triangle] = ACTIONS(2564),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_private] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_friend] = ACTIONS(2246),
    [anon_sym_public] = ACTIONS(2246),
    [anon_sym_protected] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
  },
  [2222] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_friend] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(5543),
    [aux_sym_preproc_def_token1] = ACTIONS(5543),
    [aux_sym_preproc_if_token1] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5543),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5543),
    [sym_preproc_directive] = ACTIONS(5543),
    [anon_sym_LPAREN2] = ACTIONS(5545),
    [anon_sym_TILDE] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_AMP_AMP] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5545),
    [anon_sym___extension__] = ACTIONS(5543),
    [anon_sym_typedef] = ACTIONS(5543),
    [anon_sym_in] = ACTIONS(5543),
    [anon_sym_out] = ACTIONS(5543),
    [anon_sym_inout] = ACTIONS(5543),
    [anon_sym_virtual] = ACTIONS(5543),
    [anon_sym_extern] = ACTIONS(5543),
    [anon_sym___attribute__] = ACTIONS(5543),
    [anon_sym___attribute] = ACTIONS(5543),
    [anon_sym_using] = ACTIONS(5543),
    [anon_sym_COLON_COLON] = ACTIONS(5545),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5545),
    [anon_sym___declspec] = ACTIONS(5543),
    [anon_sym___based] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5545),
    [anon_sym_signed] = ACTIONS(5543),
    [anon_sym_unsigned] = ACTIONS(5543),
    [anon_sym_long] = ACTIONS(5543),
    [anon_sym_short] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_static] = ACTIONS(5543),
    [anon_sym_register] = ACTIONS(5543),
    [anon_sym_inline] = ACTIONS(5543),
    [anon_sym___inline] = ACTIONS(5543),
    [anon_sym___inline__] = ACTIONS(5543),
    [anon_sym___forceinline] = ACTIONS(5543),
    [anon_sym_thread_local] = ACTIONS(5543),
    [anon_sym___thread] = ACTIONS(5543),
    [anon_sym_const] = ACTIONS(5543),
    [anon_sym_constexpr] = ACTIONS(5543),
    [anon_sym_volatile] = ACTIONS(5543),
    [anon_sym_restrict] = ACTIONS(5543),
    [anon_sym___restrict__] = ACTIONS(5543),
    [anon_sym__Atomic] = ACTIONS(5543),
    [anon_sym__Noreturn] = ACTIONS(5543),
    [anon_sym_noreturn] = ACTIONS(5543),
    [anon_sym__Nonnull] = ACTIONS(5543),
    [anon_sym_mutable] = ACTIONS(5543),
    [anon_sym_constinit] = ACTIONS(5543),
    [anon_sym_consteval] = ACTIONS(5543),
    [anon_sym_alignas] = ACTIONS(5543),
    [anon_sym__Alignas] = ACTIONS(5543),
    [sym_primitive_type] = ACTIONS(5543),
    [anon_sym_enum] = ACTIONS(5543),
    [anon_sym_class] = ACTIONS(5543),
    [anon_sym_struct] = ACTIONS(5543),
    [anon_sym_union] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5543),
    [anon_sym_decltype] = ACTIONS(5543),
    [anon_sym_explicit] = ACTIONS(5543),
    [anon_sym_typename] = ACTIONS(5543),
    [anon_sym_private] = ACTIONS(5543),
    [anon_sym_template] = ACTIONS(5543),
    [anon_sym_operator] = ACTIONS(5543),
    [anon_sym_friend] = ACTIONS(5543),
    [anon_sym_public] = ACTIONS(5543),
    [anon_sym_protected] = ACTIONS(5543),
    [anon_sym_static_assert] = ACTIONS(5543),
    [anon_sym_precise] = ACTIONS(5543),
    [anon_sym_shared] = ACTIONS(5543),
    [anon_sym_groupshared] = ACTIONS(5543),
    [anon_sym_uniform] = ACTIONS(5543),
    [anon_sym_row_major] = ACTIONS(5543),
    [anon_sym_column_major] = ACTIONS(5543),
    [anon_sym_globallycoherent] = ACTIONS(5543),
    [anon_sym_centroid] = ACTIONS(5543),
    [anon_sym_noperspective] = ACTIONS(5543),
    [anon_sym_nointerpolation] = ACTIONS(5543),
    [anon_sym_sample] = ACTIONS(5543),
    [anon_sym_linear] = ACTIONS(5543),
    [anon_sym_snorm] = ACTIONS(5543),
    [anon_sym_unorm] = ACTIONS(5543),
    [anon_sym_point] = ACTIONS(5543),
    [anon_sym_line] = ACTIONS(5543),
    [anon_sym_triangleadj] = ACTIONS(5543),
    [anon_sym_lineadj] = ACTIONS(5543),
    [anon_sym_triangle] = ACTIONS(5543),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5553),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(5547),
    [aux_sym_preproc_def_token1] = ACTIONS(5547),
    [aux_sym_preproc_if_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5547),
    [sym_preproc_directive] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5549),
    [anon_sym_TILDE] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_AMP_AMP] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5549),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym_typedef] = ACTIONS(5547),
    [anon_sym_in] = ACTIONS(5547),
    [anon_sym_out] = ACTIONS(5547),
    [anon_sym_inout] = ACTIONS(5547),
    [anon_sym_virtual] = ACTIONS(5547),
    [anon_sym_extern] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5547),
    [anon_sym_using] = ACTIONS(5547),
    [anon_sym_COLON_COLON] = ACTIONS(5549),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5549),
    [anon_sym___declspec] = ACTIONS(5547),
    [anon_sym___based] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5549),
    [anon_sym_signed] = ACTIONS(5547),
    [anon_sym_unsigned] = ACTIONS(5547),
    [anon_sym_long] = ACTIONS(5547),
    [anon_sym_short] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_static] = ACTIONS(5547),
    [anon_sym_register] = ACTIONS(5547),
    [anon_sym_inline] = ACTIONS(5547),
    [anon_sym___inline] = ACTIONS(5547),
    [anon_sym___inline__] = ACTIONS(5547),
    [anon_sym___forceinline] = ACTIONS(5547),
    [anon_sym_thread_local] = ACTIONS(5547),
    [anon_sym___thread] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5547),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [sym_primitive_type] = ACTIONS(5547),
    [anon_sym_enum] = ACTIONS(5547),
    [anon_sym_class] = ACTIONS(5547),
    [anon_sym_struct] = ACTIONS(5547),
    [anon_sym_union] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_explicit] = ACTIONS(5547),
    [anon_sym_typename] = ACTIONS(5547),
    [anon_sym_private] = ACTIONS(5547),
    [anon_sym_template] = ACTIONS(5547),
    [anon_sym_operator] = ACTIONS(5547),
    [anon_sym_friend] = ACTIONS(5547),
    [anon_sym_public] = ACTIONS(5547),
    [anon_sym_protected] = ACTIONS(5547),
    [anon_sym_static_assert] = ACTIONS(5547),
    [anon_sym_precise] = ACTIONS(5547),
    [anon_sym_shared] = ACTIONS(5547),
    [anon_sym_groupshared] = ACTIONS(5547),
    [anon_sym_uniform] = ACTIONS(5547),
    [anon_sym_row_major] = ACTIONS(5547),
    [anon_sym_column_major] = ACTIONS(5547),
    [anon_sym_globallycoherent] = ACTIONS(5547),
    [anon_sym_centroid] = ACTIONS(5547),
    [anon_sym_noperspective] = ACTIONS(5547),
    [anon_sym_nointerpolation] = ACTIONS(5547),
    [anon_sym_sample] = ACTIONS(5547),
    [anon_sym_linear] = ACTIONS(5547),
    [anon_sym_snorm] = ACTIONS(5547),
    [anon_sym_unorm] = ACTIONS(5547),
    [anon_sym_point] = ACTIONS(5547),
    [anon_sym_line] = ACTIONS(5547),
    [anon_sym_triangleadj] = ACTIONS(5547),
    [anon_sym_lineadj] = ACTIONS(5547),
    [anon_sym_triangle] = ACTIONS(5547),
  },
  [2227] = {
    [sym_identifier] = ACTIONS(5551),
    [aux_sym_preproc_def_token1] = ACTIONS(5551),
    [aux_sym_preproc_if_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5551),
    [sym_preproc_directive] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5553),
    [anon_sym_TILDE] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_AMP_AMP] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5553),
    [anon_sym___extension__] = ACTIONS(5551),
    [anon_sym_typedef] = ACTIONS(5551),
    [anon_sym_in] = ACTIONS(5551),
    [anon_sym_out] = ACTIONS(5551),
    [anon_sym_inout] = ACTIONS(5551),
    [anon_sym_virtual] = ACTIONS(5551),
    [anon_sym_extern] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5551),
    [anon_sym___attribute] = ACTIONS(5551),
    [anon_sym_using] = ACTIONS(5551),
    [anon_sym_COLON_COLON] = ACTIONS(5553),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5553),
    [anon_sym___declspec] = ACTIONS(5551),
    [anon_sym___based] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5553),
    [anon_sym_signed] = ACTIONS(5551),
    [anon_sym_unsigned] = ACTIONS(5551),
    [anon_sym_long] = ACTIONS(5551),
    [anon_sym_short] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_static] = ACTIONS(5551),
    [anon_sym_register] = ACTIONS(5551),
    [anon_sym_inline] = ACTIONS(5551),
    [anon_sym___inline] = ACTIONS(5551),
    [anon_sym___inline__] = ACTIONS(5551),
    [anon_sym___forceinline] = ACTIONS(5551),
    [anon_sym_thread_local] = ACTIONS(5551),
    [anon_sym___thread] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5551),
    [anon_sym_constexpr] = ACTIONS(5551),
    [anon_sym_volatile] = ACTIONS(5551),
    [anon_sym_restrict] = ACTIONS(5551),
    [anon_sym___restrict__] = ACTIONS(5551),
    [anon_sym__Atomic] = ACTIONS(5551),
    [anon_sym__Noreturn] = ACTIONS(5551),
    [anon_sym_noreturn] = ACTIONS(5551),
    [anon_sym__Nonnull] = ACTIONS(5551),
    [anon_sym_mutable] = ACTIONS(5551),
    [anon_sym_constinit] = ACTIONS(5551),
    [anon_sym_consteval] = ACTIONS(5551),
    [anon_sym_alignas] = ACTIONS(5551),
    [anon_sym__Alignas] = ACTIONS(5551),
    [sym_primitive_type] = ACTIONS(5551),
    [anon_sym_enum] = ACTIONS(5551),
    [anon_sym_class] = ACTIONS(5551),
    [anon_sym_struct] = ACTIONS(5551),
    [anon_sym_union] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5551),
    [anon_sym_decltype] = ACTIONS(5551),
    [anon_sym_explicit] = ACTIONS(5551),
    [anon_sym_typename] = ACTIONS(5551),
    [anon_sym_private] = ACTIONS(5551),
    [anon_sym_template] = ACTIONS(5551),
    [anon_sym_operator] = ACTIONS(5551),
    [anon_sym_friend] = ACTIONS(5551),
    [anon_sym_public] = ACTIONS(5551),
    [anon_sym_protected] = ACTIONS(5551),
    [anon_sym_static_assert] = ACTIONS(5551),
    [anon_sym_precise] = ACTIONS(5551),
    [anon_sym_shared] = ACTIONS(5551),
    [anon_sym_groupshared] = ACTIONS(5551),
    [anon_sym_uniform] = ACTIONS(5551),
    [anon_sym_row_major] = ACTIONS(5551),
    [anon_sym_column_major] = ACTIONS(5551),
    [anon_sym_globallycoherent] = ACTIONS(5551),
    [anon_sym_centroid] = ACTIONS(5551),
    [anon_sym_noperspective] = ACTIONS(5551),
    [anon_sym_nointerpolation] = ACTIONS(5551),
    [anon_sym_sample] = ACTIONS(5551),
    [anon_sym_linear] = ACTIONS(5551),
    [anon_sym_snorm] = ACTIONS(5551),
    [anon_sym_unorm] = ACTIONS(5551),
    [anon_sym_point] = ACTIONS(5551),
    [anon_sym_line] = ACTIONS(5551),
    [anon_sym_triangleadj] = ACTIONS(5551),
    [anon_sym_lineadj] = ACTIONS(5551),
    [anon_sym_triangle] = ACTIONS(5551),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(5555),
    [aux_sym_preproc_def_token1] = ACTIONS(5555),
    [aux_sym_preproc_if_token1] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5555),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5555),
    [sym_preproc_directive] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(5557),
    [anon_sym_TILDE] = ACTIONS(5557),
    [anon_sym_STAR] = ACTIONS(5557),
    [anon_sym_AMP_AMP] = ACTIONS(5557),
    [anon_sym_AMP] = ACTIONS(5555),
    [anon_sym_SEMI] = ACTIONS(5557),
    [anon_sym___extension__] = ACTIONS(5555),
    [anon_sym_typedef] = ACTIONS(5555),
    [anon_sym_in] = ACTIONS(5555),
    [anon_sym_out] = ACTIONS(5555),
    [anon_sym_inout] = ACTIONS(5555),
    [anon_sym_virtual] = ACTIONS(5555),
    [anon_sym_extern] = ACTIONS(5555),
    [anon_sym___attribute__] = ACTIONS(5555),
    [anon_sym___attribute] = ACTIONS(5555),
    [anon_sym_using] = ACTIONS(5555),
    [anon_sym_COLON_COLON] = ACTIONS(5557),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5557),
    [anon_sym___declspec] = ACTIONS(5555),
    [anon_sym___based] = ACTIONS(5555),
    [anon_sym_RBRACE] = ACTIONS(5557),
    [anon_sym_signed] = ACTIONS(5555),
    [anon_sym_unsigned] = ACTIONS(5555),
    [anon_sym_long] = ACTIONS(5555),
    [anon_sym_short] = ACTIONS(5555),
    [anon_sym_LBRACK] = ACTIONS(5555),
    [anon_sym_static] = ACTIONS(5555),
    [anon_sym_register] = ACTIONS(5555),
    [anon_sym_inline] = ACTIONS(5555),
    [anon_sym___inline] = ACTIONS(5555),
    [anon_sym___inline__] = ACTIONS(5555),
    [anon_sym___forceinline] = ACTIONS(5555),
    [anon_sym_thread_local] = ACTIONS(5555),
    [anon_sym___thread] = ACTIONS(5555),
    [anon_sym_const] = ACTIONS(5555),
    [anon_sym_constexpr] = ACTIONS(5555),
    [anon_sym_volatile] = ACTIONS(5555),
    [anon_sym_restrict] = ACTIONS(5555),
    [anon_sym___restrict__] = ACTIONS(5555),
    [anon_sym__Atomic] = ACTIONS(5555),
    [anon_sym__Noreturn] = ACTIONS(5555),
    [anon_sym_noreturn] = ACTIONS(5555),
    [anon_sym__Nonnull] = ACTIONS(5555),
    [anon_sym_mutable] = ACTIONS(5555),
    [anon_sym_constinit] = ACTIONS(5555),
    [anon_sym_consteval] = ACTIONS(5555),
    [anon_sym_alignas] = ACTIONS(5555),
    [anon_sym__Alignas] = ACTIONS(5555),
    [sym_primitive_type] = ACTIONS(5555),
    [anon_sym_enum] = ACTIONS(5555),
    [anon_sym_class] = ACTIONS(5555),
    [anon_sym_struct] = ACTIONS(5555),
    [anon_sym_union] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5555),
    [anon_sym_decltype] = ACTIONS(5555),
    [anon_sym_explicit] = ACTIONS(5555),
    [anon_sym_typename] = ACTIONS(5555),
    [anon_sym_private] = ACTIONS(5555),
    [anon_sym_template] = ACTIONS(5555),
    [anon_sym_operator] = ACTIONS(5555),
    [anon_sym_friend] = ACTIONS(5555),
    [anon_sym_public] = ACTIONS(5555),
    [anon_sym_protected] = ACTIONS(5555),
    [anon_sym_static_assert] = ACTIONS(5555),
    [anon_sym_precise] = ACTIONS(5555),
    [anon_sym_shared] = ACTIONS(5555),
    [anon_sym_groupshared] = ACTIONS(5555),
    [anon_sym_uniform] = ACTIONS(5555),
    [anon_sym_row_major] = ACTIONS(5555),
    [anon_sym_column_major] = ACTIONS(5555),
    [anon_sym_globallycoherent] = ACTIONS(5555),
    [anon_sym_centroid] = ACTIONS(5555),
    [anon_sym_noperspective] = ACTIONS(5555),
    [anon_sym_nointerpolation] = ACTIONS(5555),
    [anon_sym_sample] = ACTIONS(5555),
    [anon_sym_linear] = ACTIONS(5555),
    [anon_sym_snorm] = ACTIONS(5555),
    [anon_sym_unorm] = ACTIONS(5555),
    [anon_sym_point] = ACTIONS(5555),
    [anon_sym_line] = ACTIONS(5555),
    [anon_sym_triangleadj] = ACTIONS(5555),
    [anon_sym_lineadj] = ACTIONS(5555),
    [anon_sym_triangle] = ACTIONS(5555),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(5559),
    [aux_sym_preproc_def_token1] = ACTIONS(5559),
    [aux_sym_preproc_if_token1] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5559),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5559),
    [sym_preproc_directive] = ACTIONS(5559),
    [anon_sym_LPAREN2] = ACTIONS(5561),
    [anon_sym_TILDE] = ACTIONS(5561),
    [anon_sym_STAR] = ACTIONS(5561),
    [anon_sym_AMP_AMP] = ACTIONS(5561),
    [anon_sym_AMP] = ACTIONS(5559),
    [anon_sym_SEMI] = ACTIONS(5561),
    [anon_sym___extension__] = ACTIONS(5559),
    [anon_sym_typedef] = ACTIONS(5559),
    [anon_sym_in] = ACTIONS(5559),
    [anon_sym_out] = ACTIONS(5559),
    [anon_sym_inout] = ACTIONS(5559),
    [anon_sym_virtual] = ACTIONS(5559),
    [anon_sym_extern] = ACTIONS(5559),
    [anon_sym___attribute__] = ACTIONS(5559),
    [anon_sym___attribute] = ACTIONS(5559),
    [anon_sym_using] = ACTIONS(5559),
    [anon_sym_COLON_COLON] = ACTIONS(5561),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5561),
    [anon_sym___declspec] = ACTIONS(5559),
    [anon_sym___based] = ACTIONS(5559),
    [anon_sym_RBRACE] = ACTIONS(5561),
    [anon_sym_signed] = ACTIONS(5559),
    [anon_sym_unsigned] = ACTIONS(5559),
    [anon_sym_long] = ACTIONS(5559),
    [anon_sym_short] = ACTIONS(5559),
    [anon_sym_LBRACK] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_register] = ACTIONS(5559),
    [anon_sym_inline] = ACTIONS(5559),
    [anon_sym___inline] = ACTIONS(5559),
    [anon_sym___inline__] = ACTIONS(5559),
    [anon_sym___forceinline] = ACTIONS(5559),
    [anon_sym_thread_local] = ACTIONS(5559),
    [anon_sym___thread] = ACTIONS(5559),
    [anon_sym_const] = ACTIONS(5559),
    [anon_sym_constexpr] = ACTIONS(5559),
    [anon_sym_volatile] = ACTIONS(5559),
    [anon_sym_restrict] = ACTIONS(5559),
    [anon_sym___restrict__] = ACTIONS(5559),
    [anon_sym__Atomic] = ACTIONS(5559),
    [anon_sym__Noreturn] = ACTIONS(5559),
    [anon_sym_noreturn] = ACTIONS(5559),
    [anon_sym__Nonnull] = ACTIONS(5559),
    [anon_sym_mutable] = ACTIONS(5559),
    [anon_sym_constinit] = ACTIONS(5559),
    [anon_sym_consteval] = ACTIONS(5559),
    [anon_sym_alignas] = ACTIONS(5559),
    [anon_sym__Alignas] = ACTIONS(5559),
    [sym_primitive_type] = ACTIONS(5559),
    [anon_sym_enum] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(5559),
    [anon_sym_struct] = ACTIONS(5559),
    [anon_sym_union] = ACTIONS(5559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5559),
    [anon_sym_decltype] = ACTIONS(5559),
    [anon_sym_explicit] = ACTIONS(5559),
    [anon_sym_typename] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_template] = ACTIONS(5559),
    [anon_sym_operator] = ACTIONS(5559),
    [anon_sym_friend] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_static_assert] = ACTIONS(5559),
    [anon_sym_precise] = ACTIONS(5559),
    [anon_sym_shared] = ACTIONS(5559),
    [anon_sym_groupshared] = ACTIONS(5559),
    [anon_sym_uniform] = ACTIONS(5559),
    [anon_sym_row_major] = ACTIONS(5559),
    [anon_sym_column_major] = ACTIONS(5559),
    [anon_sym_globallycoherent] = ACTIONS(5559),
    [anon_sym_centroid] = ACTIONS(5559),
    [anon_sym_noperspective] = ACTIONS(5559),
    [anon_sym_nointerpolation] = ACTIONS(5559),
    [anon_sym_sample] = ACTIONS(5559),
    [anon_sym_linear] = ACTIONS(5559),
    [anon_sym_snorm] = ACTIONS(5559),
    [anon_sym_unorm] = ACTIONS(5559),
    [anon_sym_point] = ACTIONS(5559),
    [anon_sym_line] = ACTIONS(5559),
    [anon_sym_triangleadj] = ACTIONS(5559),
    [anon_sym_lineadj] = ACTIONS(5559),
    [anon_sym_triangle] = ACTIONS(5559),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [2231] = {
    [sym_identifier] = ACTIONS(2378),
    [aux_sym_preproc_def_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token1] = ACTIONS(2378),
    [aux_sym_preproc_if_token2] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2378),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2378),
    [sym_preproc_directive] = ACTIONS(2378),
    [anon_sym_LPAREN2] = ACTIONS(2380),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2380),
    [anon_sym_AMP_AMP] = ACTIONS(2380),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym___extension__] = ACTIONS(2378),
    [anon_sym_typedef] = ACTIONS(2378),
    [anon_sym_in] = ACTIONS(2378),
    [anon_sym_out] = ACTIONS(2378),
    [anon_sym_inout] = ACTIONS(2378),
    [anon_sym_virtual] = ACTIONS(2378),
    [anon_sym_extern] = ACTIONS(2378),
    [anon_sym___attribute__] = ACTIONS(2378),
    [anon_sym___attribute] = ACTIONS(2378),
    [anon_sym_using] = ACTIONS(2378),
    [anon_sym_COLON_COLON] = ACTIONS(2380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2380),
    [anon_sym___declspec] = ACTIONS(2378),
    [anon_sym___based] = ACTIONS(2378),
    [anon_sym_signed] = ACTIONS(2378),
    [anon_sym_unsigned] = ACTIONS(2378),
    [anon_sym_long] = ACTIONS(2378),
    [anon_sym_short] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_register] = ACTIONS(2378),
    [anon_sym_inline] = ACTIONS(2378),
    [anon_sym___inline] = ACTIONS(2378),
    [anon_sym___inline__] = ACTIONS(2378),
    [anon_sym___forceinline] = ACTIONS(2378),
    [anon_sym_thread_local] = ACTIONS(2378),
    [anon_sym___thread] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_constexpr] = ACTIONS(2378),
    [anon_sym_volatile] = ACTIONS(2378),
    [anon_sym_restrict] = ACTIONS(2378),
    [anon_sym___restrict__] = ACTIONS(2378),
    [anon_sym__Atomic] = ACTIONS(2378),
    [anon_sym__Noreturn] = ACTIONS(2378),
    [anon_sym_noreturn] = ACTIONS(2378),
    [anon_sym__Nonnull] = ACTIONS(2378),
    [anon_sym_mutable] = ACTIONS(2378),
    [anon_sym_constinit] = ACTIONS(2378),
    [anon_sym_consteval] = ACTIONS(2378),
    [anon_sym_alignas] = ACTIONS(2378),
    [anon_sym__Alignas] = ACTIONS(2378),
    [sym_primitive_type] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_struct] = ACTIONS(2378),
    [anon_sym_union] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2378),
    [anon_sym_decltype] = ACTIONS(2378),
    [anon_sym_explicit] = ACTIONS(2378),
    [anon_sym_typename] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_template] = ACTIONS(2378),
    [anon_sym_operator] = ACTIONS(2378),
    [anon_sym_friend] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_static_assert] = ACTIONS(2378),
    [anon_sym_precise] = ACTIONS(2378),
    [anon_sym_shared] = ACTIONS(2378),
    [anon_sym_groupshared] = ACTIONS(2378),
    [anon_sym_uniform] = ACTIONS(2378),
    [anon_sym_row_major] = ACTIONS(2378),
    [anon_sym_column_major] = ACTIONS(2378),
    [anon_sym_globallycoherent] = ACTIONS(2378),
    [anon_sym_centroid] = ACTIONS(2378),
    [anon_sym_noperspective] = ACTIONS(2378),
    [anon_sym_nointerpolation] = ACTIONS(2378),
    [anon_sym_sample] = ACTIONS(2378),
    [anon_sym_linear] = ACTIONS(2378),
    [anon_sym_snorm] = ACTIONS(2378),
    [anon_sym_unorm] = ACTIONS(2378),
    [anon_sym_point] = ACTIONS(2378),
    [anon_sym_line] = ACTIONS(2378),
    [anon_sym_triangleadj] = ACTIONS(2378),
    [anon_sym_lineadj] = ACTIONS(2378),
    [anon_sym_triangle] = ACTIONS(2378),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(2382),
    [aux_sym_preproc_def_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token1] = ACTIONS(2382),
    [aux_sym_preproc_if_token2] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2382),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2382),
    [sym_preproc_directive] = ACTIONS(2382),
    [anon_sym_LPAREN2] = ACTIONS(2384),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2384),
    [anon_sym_AMP_AMP] = ACTIONS(2384),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_typedef] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_using] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym___based] = ACTIONS(2382),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_explicit] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_operator] = ACTIONS(2382),
    [anon_sym_friend] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_static_assert] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [2234] = {
    [sym_identifier] = ACTIONS(2159),
    [aux_sym_preproc_def_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token1] = ACTIONS(2159),
    [aux_sym_preproc_if_token2] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2159),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2159),
    [sym_preproc_directive] = ACTIONS(2159),
    [anon_sym_LPAREN2] = ACTIONS(2161),
    [anon_sym_TILDE] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2161),
    [anon_sym_AMP_AMP] = ACTIONS(2161),
    [anon_sym_AMP] = ACTIONS(2159),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym___extension__] = ACTIONS(2159),
    [anon_sym_typedef] = ACTIONS(2159),
    [anon_sym_in] = ACTIONS(2159),
    [anon_sym_out] = ACTIONS(2159),
    [anon_sym_inout] = ACTIONS(2159),
    [anon_sym_virtual] = ACTIONS(2159),
    [anon_sym_extern] = ACTIONS(2159),
    [anon_sym___attribute__] = ACTIONS(2159),
    [anon_sym___attribute] = ACTIONS(2159),
    [anon_sym_using] = ACTIONS(2159),
    [anon_sym_COLON_COLON] = ACTIONS(2161),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2161),
    [anon_sym___declspec] = ACTIONS(2159),
    [anon_sym___based] = ACTIONS(2159),
    [anon_sym_signed] = ACTIONS(2159),
    [anon_sym_unsigned] = ACTIONS(2159),
    [anon_sym_long] = ACTIONS(2159),
    [anon_sym_short] = ACTIONS(2159),
    [anon_sym_LBRACK] = ACTIONS(2159),
    [anon_sym_static] = ACTIONS(2159),
    [anon_sym_register] = ACTIONS(2159),
    [anon_sym_inline] = ACTIONS(2159),
    [anon_sym___inline] = ACTIONS(2159),
    [anon_sym___inline__] = ACTIONS(2159),
    [anon_sym___forceinline] = ACTIONS(2159),
    [anon_sym_thread_local] = ACTIONS(2159),
    [anon_sym___thread] = ACTIONS(2159),
    [anon_sym_const] = ACTIONS(2159),
    [anon_sym_constexpr] = ACTIONS(2159),
    [anon_sym_volatile] = ACTIONS(2159),
    [anon_sym_restrict] = ACTIONS(2159),
    [anon_sym___restrict__] = ACTIONS(2159),
    [anon_sym__Atomic] = ACTIONS(2159),
    [anon_sym__Noreturn] = ACTIONS(2159),
    [anon_sym_noreturn] = ACTIONS(2159),
    [anon_sym__Nonnull] = ACTIONS(2159),
    [anon_sym_mutable] = ACTIONS(2159),
    [anon_sym_constinit] = ACTIONS(2159),
    [anon_sym_consteval] = ACTIONS(2159),
    [anon_sym_alignas] = ACTIONS(2159),
    [anon_sym__Alignas] = ACTIONS(2159),
    [sym_primitive_type] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2159),
    [anon_sym_class] = ACTIONS(2159),
    [anon_sym_struct] = ACTIONS(2159),
    [anon_sym_union] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2159),
    [anon_sym_decltype] = ACTIONS(2159),
    [anon_sym_explicit] = ACTIONS(2159),
    [anon_sym_typename] = ACTIONS(2159),
    [anon_sym_private] = ACTIONS(2159),
    [anon_sym_template] = ACTIONS(2159),
    [anon_sym_operator] = ACTIONS(2159),
    [anon_sym_friend] = ACTIONS(2159),
    [anon_sym_public] = ACTIONS(2159),
    [anon_sym_protected] = ACTIONS(2159),
    [anon_sym_static_assert] = ACTIONS(2159),
    [anon_sym_precise] = ACTIONS(2159),
    [anon_sym_shared] = ACTIONS(2159),
    [anon_sym_groupshared] = ACTIONS(2159),
    [anon_sym_uniform] = ACTIONS(2159),
    [anon_sym_row_major] = ACTIONS(2159),
    [anon_sym_column_major] = ACTIONS(2159),
    [anon_sym_globallycoherent] = ACTIONS(2159),
    [anon_sym_centroid] = ACTIONS(2159),
    [anon_sym_noperspective] = ACTIONS(2159),
    [anon_sym_nointerpolation] = ACTIONS(2159),
    [anon_sym_sample] = ACTIONS(2159),
    [anon_sym_linear] = ACTIONS(2159),
    [anon_sym_snorm] = ACTIONS(2159),
    [anon_sym_unorm] = ACTIONS(2159),
    [anon_sym_point] = ACTIONS(2159),
    [anon_sym_line] = ACTIONS(2159),
    [anon_sym_triangleadj] = ACTIONS(2159),
    [anon_sym_lineadj] = ACTIONS(2159),
    [anon_sym_triangle] = ACTIONS(2159),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(2163),
    [aux_sym_preproc_def_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token1] = ACTIONS(2163),
    [aux_sym_preproc_if_token2] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2163),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2163),
    [sym_preproc_directive] = ACTIONS(2163),
    [anon_sym_LPAREN2] = ACTIONS(2165),
    [anon_sym_TILDE] = ACTIONS(2165),
    [anon_sym_STAR] = ACTIONS(2165),
    [anon_sym_AMP_AMP] = ACTIONS(2165),
    [anon_sym_AMP] = ACTIONS(2163),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_typedef] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_using] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym___based] = ACTIONS(2163),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_LBRACK] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_explicit] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_private] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_operator] = ACTIONS(2163),
    [anon_sym_friend] = ACTIONS(2163),
    [anon_sym_public] = ACTIONS(2163),
    [anon_sym_protected] = ACTIONS(2163),
    [anon_sym_static_assert] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(2167),
    [aux_sym_preproc_def_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token1] = ACTIONS(2167),
    [aux_sym_preproc_if_token2] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2167),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2167),
    [sym_preproc_directive] = ACTIONS(2167),
    [anon_sym_LPAREN2] = ACTIONS(2169),
    [anon_sym_TILDE] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_typedef] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym___based] = ACTIONS(2167),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_explicit] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_private] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_operator] = ACTIONS(2167),
    [anon_sym_friend] = ACTIONS(2167),
    [anon_sym_public] = ACTIONS(2167),
    [anon_sym_protected] = ACTIONS(2167),
    [anon_sym_static_assert] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
  },
  [2237] = {
    [sym_identifier] = ACTIONS(2656),
    [aux_sym_preproc_def_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token1] = ACTIONS(2656),
    [aux_sym_preproc_if_token2] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2656),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2656),
    [sym_preproc_directive] = ACTIONS(2656),
    [anon_sym_LPAREN2] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2658),
    [anon_sym_STAR] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_AMP] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_typedef] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_using] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym___based] = ACTIONS(2656),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_explicit] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_private] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_operator] = ACTIONS(2656),
    [anon_sym_friend] = ACTIONS(2656),
    [anon_sym_public] = ACTIONS(2656),
    [anon_sym_protected] = ACTIONS(2656),
    [anon_sym_static_assert] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(2242),
    [aux_sym_preproc_def_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token1] = ACTIONS(2242),
    [aux_sym_preproc_if_token2] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2242),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2242),
    [sym_preproc_directive] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2244),
    [anon_sym_TILDE] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2244),
    [anon_sym_AMP_AMP] = ACTIONS(2244),
    [anon_sym_AMP] = ACTIONS(2242),
    [anon_sym_SEMI] = ACTIONS(2244),
    [anon_sym___extension__] = ACTIONS(2242),
    [anon_sym_typedef] = ACTIONS(2242),
    [anon_sym_in] = ACTIONS(2242),
    [anon_sym_out] = ACTIONS(2242),
    [anon_sym_inout] = ACTIONS(2242),
    [anon_sym_virtual] = ACTIONS(2242),
    [anon_sym_extern] = ACTIONS(2242),
    [anon_sym___attribute__] = ACTIONS(2242),
    [anon_sym___attribute] = ACTIONS(2242),
    [anon_sym_using] = ACTIONS(2242),
    [anon_sym_COLON_COLON] = ACTIONS(2244),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2244),
    [anon_sym___declspec] = ACTIONS(2242),
    [anon_sym___based] = ACTIONS(2242),
    [anon_sym_signed] = ACTIONS(2242),
    [anon_sym_unsigned] = ACTIONS(2242),
    [anon_sym_long] = ACTIONS(2242),
    [anon_sym_short] = ACTIONS(2242),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_register] = ACTIONS(2242),
    [anon_sym_inline] = ACTIONS(2242),
    [anon_sym___inline] = ACTIONS(2242),
    [anon_sym___inline__] = ACTIONS(2242),
    [anon_sym___forceinline] = ACTIONS(2242),
    [anon_sym_thread_local] = ACTIONS(2242),
    [anon_sym___thread] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_constexpr] = ACTIONS(2242),
    [anon_sym_volatile] = ACTIONS(2242),
    [anon_sym_restrict] = ACTIONS(2242),
    [anon_sym___restrict__] = ACTIONS(2242),
    [anon_sym__Atomic] = ACTIONS(2242),
    [anon_sym__Noreturn] = ACTIONS(2242),
    [anon_sym_noreturn] = ACTIONS(2242),
    [anon_sym__Nonnull] = ACTIONS(2242),
    [anon_sym_mutable] = ACTIONS(2242),
    [anon_sym_constinit] = ACTIONS(2242),
    [anon_sym_consteval] = ACTIONS(2242),
    [anon_sym_alignas] = ACTIONS(2242),
    [anon_sym__Alignas] = ACTIONS(2242),
    [sym_primitive_type] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_class] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2242),
    [anon_sym_decltype] = ACTIONS(2242),
    [anon_sym_explicit] = ACTIONS(2242),
    [anon_sym_typename] = ACTIONS(2242),
    [anon_sym_private] = ACTIONS(2242),
    [anon_sym_template] = ACTIONS(2242),
    [anon_sym_operator] = ACTIONS(2242),
    [anon_sym_friend] = ACTIONS(2242),
    [anon_sym_public] = ACTIONS(2242),
    [anon_sym_protected] = ACTIONS(2242),
    [anon_sym_static_assert] = ACTIONS(2242),
    [anon_sym_precise] = ACTIONS(2242),
    [anon_sym_shared] = ACTIONS(2242),
    [anon_sym_groupshared] = ACTIONS(2242),
    [anon_sym_uniform] = ACTIONS(2242),
    [anon_sym_row_major] = ACTIONS(2242),
    [anon_sym_column_major] = ACTIONS(2242),
    [anon_sym_globallycoherent] = ACTIONS(2242),
    [anon_sym_centroid] = ACTIONS(2242),
    [anon_sym_noperspective] = ACTIONS(2242),
    [anon_sym_nointerpolation] = ACTIONS(2242),
    [anon_sym_sample] = ACTIONS(2242),
    [anon_sym_linear] = ACTIONS(2242),
    [anon_sym_snorm] = ACTIONS(2242),
    [anon_sym_unorm] = ACTIONS(2242),
    [anon_sym_point] = ACTIONS(2242),
    [anon_sym_line] = ACTIONS(2242),
    [anon_sym_triangleadj] = ACTIONS(2242),
    [anon_sym_lineadj] = ACTIONS(2242),
    [anon_sym_triangle] = ACTIONS(2242),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(2246),
    [aux_sym_preproc_def_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token1] = ACTIONS(2246),
    [aux_sym_preproc_if_token2] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2246),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2246),
    [sym_preproc_directive] = ACTIONS(2246),
    [anon_sym_LPAREN2] = ACTIONS(2248),
    [anon_sym_TILDE] = ACTIONS(2248),
    [anon_sym_STAR] = ACTIONS(2248),
    [anon_sym_AMP_AMP] = ACTIONS(2248),
    [anon_sym_AMP] = ACTIONS(2246),
    [anon_sym_SEMI] = ACTIONS(2248),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_typedef] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_using] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym___based] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_LBRACK] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_explicit] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_private] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_operator] = ACTIONS(2246),
    [anon_sym_friend] = ACTIONS(2246),
    [anon_sym_public] = ACTIONS(2246),
    [anon_sym_protected] = ACTIONS(2246),
    [anon_sym_static_assert] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
  },
  [2240] = {
    [sym_identifier] = ACTIONS(2596),
    [aux_sym_preproc_def_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token1] = ACTIONS(2596),
    [aux_sym_preproc_if_token2] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2596),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2596),
    [sym_preproc_directive] = ACTIONS(2596),
    [anon_sym_LPAREN2] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2598),
    [anon_sym_STAR] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_AMP] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_typedef] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym___based] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_explicit] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_private] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_operator] = ACTIONS(2596),
    [anon_sym_friend] = ACTIONS(2596),
    [anon_sym_public] = ACTIONS(2596),
    [anon_sym_protected] = ACTIONS(2596),
    [anon_sym_static_assert] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [2241] = {
    [sym_identifier] = ACTIONS(2266),
    [aux_sym_preproc_def_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token1] = ACTIONS(2266),
    [aux_sym_preproc_if_token2] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2266),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2266),
    [sym_preproc_directive] = ACTIONS(2266),
    [anon_sym_LPAREN2] = ACTIONS(2268),
    [anon_sym_TILDE] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_SEMI] = ACTIONS(2268),
    [anon_sym___extension__] = ACTIONS(2266),
    [anon_sym_typedef] = ACTIONS(2266),
    [anon_sym_in] = ACTIONS(2266),
    [anon_sym_out] = ACTIONS(2266),
    [anon_sym_inout] = ACTIONS(2266),
    [anon_sym_virtual] = ACTIONS(2266),
    [anon_sym_extern] = ACTIONS(2266),
    [anon_sym___attribute__] = ACTIONS(2266),
    [anon_sym___attribute] = ACTIONS(2266),
    [anon_sym_using] = ACTIONS(2266),
    [anon_sym_COLON_COLON] = ACTIONS(2268),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2268),
    [anon_sym___declspec] = ACTIONS(2266),
    [anon_sym___based] = ACTIONS(2266),
    [anon_sym_signed] = ACTIONS(2266),
    [anon_sym_unsigned] = ACTIONS(2266),
    [anon_sym_long] = ACTIONS(2266),
    [anon_sym_short] = ACTIONS(2266),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_static] = ACTIONS(2266),
    [anon_sym_register] = ACTIONS(2266),
    [anon_sym_inline] = ACTIONS(2266),
    [anon_sym___inline] = ACTIONS(2266),
    [anon_sym___inline__] = ACTIONS(2266),
    [anon_sym___forceinline] = ACTIONS(2266),
    [anon_sym_thread_local] = ACTIONS(2266),
    [anon_sym___thread] = ACTIONS(2266),
    [anon_sym_const] = ACTIONS(2266),
    [anon_sym_constexpr] = ACTIONS(2266),
    [anon_sym_volatile] = ACTIONS(2266),
    [anon_sym_restrict] = ACTIONS(2266),
    [anon_sym___restrict__] = ACTIONS(2266),
    [anon_sym__Atomic] = ACTIONS(2266),
    [anon_sym__Noreturn] = ACTIONS(2266),
    [anon_sym_noreturn] = ACTIONS(2266),
    [anon_sym__Nonnull] = ACTIONS(2266),
    [anon_sym_mutable] = ACTIONS(2266),
    [anon_sym_constinit] = ACTIONS(2266),
    [anon_sym_consteval] = ACTIONS(2266),
    [anon_sym_alignas] = ACTIONS(2266),
    [anon_sym__Alignas] = ACTIONS(2266),
    [sym_primitive_type] = ACTIONS(2266),
    [anon_sym_enum] = ACTIONS(2266),
    [anon_sym_class] = ACTIONS(2266),
    [anon_sym_struct] = ACTIONS(2266),
    [anon_sym_union] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2266),
    [anon_sym_decltype] = ACTIONS(2266),
    [anon_sym_explicit] = ACTIONS(2266),
    [anon_sym_typename] = ACTIONS(2266),
    [anon_sym_private] = ACTIONS(2266),
    [anon_sym_template] = ACTIONS(2266),
    [anon_sym_operator] = ACTIONS(2266),
    [anon_sym_friend] = ACTIONS(2266),
    [anon_sym_public] = ACTIONS(2266),
    [anon_sym_protected] = ACTIONS(2266),
    [anon_sym_static_assert] = ACTIONS(2266),
    [anon_sym_precise] = ACTIONS(2266),
    [anon_sym_shared] = ACTIONS(2266),
    [anon_sym_groupshared] = ACTIONS(2266),
    [anon_sym_uniform] = ACTIONS(2266),
    [anon_sym_row_major] = ACTIONS(2266),
    [anon_sym_column_major] = ACTIONS(2266),
    [anon_sym_globallycoherent] = ACTIONS(2266),
    [anon_sym_centroid] = ACTIONS(2266),
    [anon_sym_noperspective] = ACTIONS(2266),
    [anon_sym_nointerpolation] = ACTIONS(2266),
    [anon_sym_sample] = ACTIONS(2266),
    [anon_sym_linear] = ACTIONS(2266),
    [anon_sym_snorm] = ACTIONS(2266),
    [anon_sym_unorm] = ACTIONS(2266),
    [anon_sym_point] = ACTIONS(2266),
    [anon_sym_line] = ACTIONS(2266),
    [anon_sym_triangleadj] = ACTIONS(2266),
    [anon_sym_lineadj] = ACTIONS(2266),
    [anon_sym_triangle] = ACTIONS(2266),
  },
  [2242] = {
    [sym_template_argument_list] = STATE(2276),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_PIPE_PIPE] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(5686),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_using] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_signed] = ACTIONS(2005),
    [anon_sym_unsigned] = ACTIONS(2005),
    [anon_sym_long] = ACTIONS(2005),
    [anon_sym_short] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_primitive_type] = ACTIONS(2005),
    [anon_sym_enum] = ACTIONS(2005),
    [anon_sym_class] = ACTIONS(2005),
    [anon_sym_struct] = ACTIONS(2005),
    [anon_sym_union] = ACTIONS(2005),
    [anon_sym_or] = ACTIONS(2005),
    [anon_sym_and] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_explicit] = ACTIONS(2005),
    [anon_sym_typename] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_friend] = ACTIONS(2005),
    [anon_sym_concept] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
  },
  [2243] = {
    [sym_identifier] = ACTIONS(2404),
    [aux_sym_preproc_def_token1] = ACTIONS(2404),
    [aux_sym_preproc_if_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2404),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2404),
    [sym_preproc_directive] = ACTIONS(2404),
    [anon_sym_LPAREN2] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2406),
    [anon_sym___extension__] = ACTIONS(2404),
    [anon_sym_typedef] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2404),
    [anon_sym_out] = ACTIONS(2404),
    [anon_sym_inout] = ACTIONS(2404),
    [anon_sym_virtual] = ACTIONS(2404),
    [anon_sym_extern] = ACTIONS(2404),
    [anon_sym___attribute__] = ACTIONS(2404),
    [anon_sym___attribute] = ACTIONS(2404),
    [anon_sym_using] = ACTIONS(2404),
    [anon_sym_COLON_COLON] = ACTIONS(2406),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2406),
    [anon_sym___declspec] = ACTIONS(2404),
    [anon_sym___based] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_signed] = ACTIONS(2404),
    [anon_sym_unsigned] = ACTIONS(2404),
    [anon_sym_long] = ACTIONS(2404),
    [anon_sym_short] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_register] = ACTIONS(2404),
    [anon_sym_inline] = ACTIONS(2404),
    [anon_sym___inline] = ACTIONS(2404),
    [anon_sym___inline__] = ACTIONS(2404),
    [anon_sym___forceinline] = ACTIONS(2404),
    [anon_sym_thread_local] = ACTIONS(2404),
    [anon_sym___thread] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_constexpr] = ACTIONS(2404),
    [anon_sym_volatile] = ACTIONS(2404),
    [anon_sym_restrict] = ACTIONS(2404),
    [anon_sym___restrict__] = ACTIONS(2404),
    [anon_sym__Atomic] = ACTIONS(2404),
    [anon_sym__Noreturn] = ACTIONS(2404),
    [anon_sym_noreturn] = ACTIONS(2404),
    [anon_sym__Nonnull] = ACTIONS(2404),
    [anon_sym_mutable] = ACTIONS(2404),
    [anon_sym_constinit] = ACTIONS(2404),
    [anon_sym_consteval] = ACTIONS(2404),
    [anon_sym_alignas] = ACTIONS(2404),
    [anon_sym__Alignas] = ACTIONS(2404),
    [sym_primitive_type] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2404),
    [anon_sym_decltype] = ACTIONS(2404),
    [anon_sym_explicit] = ACTIONS(2404),
    [anon_sym_typename] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_template] = ACTIONS(2404),
    [anon_sym_operator] = ACTIONS(2404),
    [anon_sym_friend] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_static_assert] = ACTIONS(2404),
    [anon_sym_precise] = ACTIONS(2404),
    [anon_sym_shared] = ACTIONS(2404),
    [anon_sym_groupshared] = ACTIONS(2404),
    [anon_sym_uniform] = ACTIONS(2404),
    [anon_sym_row_major] = ACTIONS(2404),
    [anon_sym_column_major] = ACTIONS(2404),
    [anon_sym_globallycoherent] = ACTIONS(2404),
    [anon_sym_centroid] = ACTIONS(2404),
    [anon_sym_noperspective] = ACTIONS(2404),
    [anon_sym_nointerpolation] = ACTIONS(2404),
    [anon_sym_sample] = ACTIONS(2404),
    [anon_sym_linear] = ACTIONS(2404),
    [anon_sym_snorm] = ACTIONS(2404),
    [anon_sym_unorm] = ACTIONS(2404),
    [anon_sym_point] = ACTIONS(2404),
    [anon_sym_line] = ACTIONS(2404),
    [anon_sym_triangleadj] = ACTIONS(2404),
    [anon_sym_lineadj] = ACTIONS(2404),
    [anon_sym_triangle] = ACTIONS(2404),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(5635),
    [aux_sym_preproc_def_token1] = ACTIONS(5635),
    [aux_sym_preproc_if_token1] = ACTIONS(5635),
    [aux_sym_preproc_if_token2] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5635),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5635),
    [sym_preproc_directive] = ACTIONS(5635),
    [anon_sym_LPAREN2] = ACTIONS(5637),
    [anon_sym_TILDE] = ACTIONS(5637),
    [anon_sym_STAR] = ACTIONS(5637),
    [anon_sym_AMP_AMP] = ACTIONS(5637),
    [anon_sym_AMP] = ACTIONS(5635),
    [anon_sym_SEMI] = ACTIONS(5637),
    [anon_sym___extension__] = ACTIONS(5635),
    [anon_sym_typedef] = ACTIONS(5635),
    [anon_sym_in] = ACTIONS(5635),
    [anon_sym_out] = ACTIONS(5635),
    [anon_sym_inout] = ACTIONS(5635),
    [anon_sym_virtual] = ACTIONS(5635),
    [anon_sym_extern] = ACTIONS(5635),
    [anon_sym___attribute__] = ACTIONS(5635),
    [anon_sym___attribute] = ACTIONS(5635),
    [anon_sym_using] = ACTIONS(5635),
    [anon_sym_COLON_COLON] = ACTIONS(5637),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5637),
    [anon_sym___declspec] = ACTIONS(5635),
    [anon_sym___based] = ACTIONS(5635),
    [anon_sym_signed] = ACTIONS(5635),
    [anon_sym_unsigned] = ACTIONS(5635),
    [anon_sym_long] = ACTIONS(5635),
    [anon_sym_short] = ACTIONS(5635),
    [anon_sym_LBRACK] = ACTIONS(5635),
    [anon_sym_static] = ACTIONS(5635),
    [anon_sym_register] = ACTIONS(5635),
    [anon_sym_inline] = ACTIONS(5635),
    [anon_sym___inline] = ACTIONS(5635),
    [anon_sym___inline__] = ACTIONS(5635),
    [anon_sym___forceinline] = ACTIONS(5635),
    [anon_sym_thread_local] = ACTIONS(5635),
    [anon_sym___thread] = ACTIONS(5635),
    [anon_sym_const] = ACTIONS(5635),
    [anon_sym_constexpr] = ACTIONS(5635),
    [anon_sym_volatile] = ACTIONS(5635),
    [anon_sym_restrict] = ACTIONS(5635),
    [anon_sym___restrict__] = ACTIONS(5635),
    [anon_sym__Atomic] = ACTIONS(5635),
    [anon_sym__Noreturn] = ACTIONS(5635),
    [anon_sym_noreturn] = ACTIONS(5635),
    [anon_sym__Nonnull] = ACTIONS(5635),
    [anon_sym_mutable] = ACTIONS(5635),
    [anon_sym_constinit] = ACTIONS(5635),
    [anon_sym_consteval] = ACTIONS(5635),
    [anon_sym_alignas] = ACTIONS(5635),
    [anon_sym__Alignas] = ACTIONS(5635),
    [sym_primitive_type] = ACTIONS(5635),
    [anon_sym_enum] = ACTIONS(5635),
    [anon_sym_class] = ACTIONS(5635),
    [anon_sym_struct] = ACTIONS(5635),
    [anon_sym_union] = ACTIONS(5635),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5635),
    [anon_sym_decltype] = ACTIONS(5635),
    [anon_sym_explicit] = ACTIONS(5635),
    [anon_sym_typename] = ACTIONS(5635),
    [anon_sym_private] = ACTIONS(5635),
    [anon_sym_template] = ACTIONS(5635),
    [anon_sym_operator] = ACTIONS(5635),
    [anon_sym_friend] = ACTIONS(5635),
    [anon_sym_public] = ACTIONS(5635),
    [anon_sym_protected] = ACTIONS(5635),
    [anon_sym_static_assert] = ACTIONS(5635),
    [anon_sym_precise] = ACTIONS(5635),
    [anon_sym_shared] = ACTIONS(5635),
    [anon_sym_groupshared] = ACTIONS(5635),
    [anon_sym_uniform] = ACTIONS(5635),
    [anon_sym_row_major] = ACTIONS(5635),
    [anon_sym_column_major] = ACTIONS(5635),
    [anon_sym_globallycoherent] = ACTIONS(5635),
    [anon_sym_centroid] = ACTIONS(5635),
    [anon_sym_noperspective] = ACTIONS(5635),
    [anon_sym_nointerpolation] = ACTIONS(5635),
    [anon_sym_sample] = ACTIONS(5635),
    [anon_sym_linear] = ACTIONS(5635),
    [anon_sym_snorm] = ACTIONS(5635),
    [anon_sym_unorm] = ACTIONS(5635),
    [anon_sym_point] = ACTIONS(5635),
    [anon_sym_line] = ACTIONS(5635),
    [anon_sym_triangleadj] = ACTIONS(5635),
    [anon_sym_lineadj] = ACTIONS(5635),
    [anon_sym_triangle] = ACTIONS(5635),
  },
  [2245] = {
    [sym_template_argument_list] = STATE(2276),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(5686),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_using] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_signed] = ACTIONS(1997),
    [anon_sym_unsigned] = ACTIONS(1997),
    [anon_sym_long] = ACTIONS(1997),
    [anon_sym_short] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_primitive_type] = ACTIONS(1997),
    [anon_sym_enum] = ACTIONS(1997),
    [anon_sym_class] = ACTIONS(1997),
    [anon_sym_struct] = ACTIONS(1997),
    [anon_sym_union] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_explicit] = ACTIONS(1997),
    [anon_sym_typename] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_friend] = ACTIONS(1997),
    [anon_sym_concept] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(5639),
    [aux_sym_preproc_def_token1] = ACTIONS(5639),
    [aux_sym_preproc_if_token1] = ACTIONS(5639),
    [aux_sym_preproc_if_token2] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5639),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5639),
    [sym_preproc_directive] = ACTIONS(5639),
    [anon_sym_LPAREN2] = ACTIONS(5641),
    [anon_sym_TILDE] = ACTIONS(5641),
    [anon_sym_STAR] = ACTIONS(5641),
    [anon_sym_AMP_AMP] = ACTIONS(5641),
    [anon_sym_AMP] = ACTIONS(5639),
    [anon_sym_SEMI] = ACTIONS(5641),
    [anon_sym___extension__] = ACTIONS(5639),
    [anon_sym_typedef] = ACTIONS(5639),
    [anon_sym_in] = ACTIONS(5639),
    [anon_sym_out] = ACTIONS(5639),
    [anon_sym_inout] = ACTIONS(5639),
    [anon_sym_virtual] = ACTIONS(5639),
    [anon_sym_extern] = ACTIONS(5639),
    [anon_sym___attribute__] = ACTIONS(5639),
    [anon_sym___attribute] = ACTIONS(5639),
    [anon_sym_using] = ACTIONS(5639),
    [anon_sym_COLON_COLON] = ACTIONS(5641),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5641),
    [anon_sym___declspec] = ACTIONS(5639),
    [anon_sym___based] = ACTIONS(5639),
    [anon_sym_signed] = ACTIONS(5639),
    [anon_sym_unsigned] = ACTIONS(5639),
    [anon_sym_long] = ACTIONS(5639),
    [anon_sym_short] = ACTIONS(5639),
    [anon_sym_LBRACK] = ACTIONS(5639),
    [anon_sym_static] = ACTIONS(5639),
    [anon_sym_register] = ACTIONS(5639),
    [anon_sym_inline] = ACTIONS(5639),
    [anon_sym___inline] = ACTIONS(5639),
    [anon_sym___inline__] = ACTIONS(5639),
    [anon_sym___forceinline] = ACTIONS(5639),
    [anon_sym_thread_local] = ACTIONS(5639),
    [anon_sym___thread] = ACTIONS(5639),
    [anon_sym_const] = ACTIONS(5639),
    [anon_sym_constexpr] = ACTIONS(5639),
    [anon_sym_volatile] = ACTIONS(5639),
    [anon_sym_restrict] = ACTIONS(5639),
    [anon_sym___restrict__] = ACTIONS(5639),
    [anon_sym__Atomic] = ACTIONS(5639),
    [anon_sym__Noreturn] = ACTIONS(5639),
    [anon_sym_noreturn] = ACTIONS(5639),
    [anon_sym__Nonnull] = ACTIONS(5639),
    [anon_sym_mutable] = ACTIONS(5639),
    [anon_sym_constinit] = ACTIONS(5639),
    [anon_sym_consteval] = ACTIONS(5639),
    [anon_sym_alignas] = ACTIONS(5639),
    [anon_sym__Alignas] = ACTIONS(5639),
    [sym_primitive_type] = ACTIONS(5639),
    [anon_sym_enum] = ACTIONS(5639),
    [anon_sym_class] = ACTIONS(5639),
    [anon_sym_struct] = ACTIONS(5639),
    [anon_sym_union] = ACTIONS(5639),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5639),
    [anon_sym_decltype] = ACTIONS(5639),
    [anon_sym_explicit] = ACTIONS(5639),
    [anon_sym_typename] = ACTIONS(5639),
    [anon_sym_private] = ACTIONS(5639),
    [anon_sym_template] = ACTIONS(5639),
    [anon_sym_operator] = ACTIONS(5639),
    [anon_sym_friend] = ACTIONS(5639),
    [anon_sym_public] = ACTIONS(5639),
    [anon_sym_protected] = ACTIONS(5639),
    [anon_sym_static_assert] = ACTIONS(5639),
    [anon_sym_precise] = ACTIONS(5639),
    [anon_sym_shared] = ACTIONS(5639),
    [anon_sym_groupshared] = ACTIONS(5639),
    [anon_sym_uniform] = ACTIONS(5639),
    [anon_sym_row_major] = ACTIONS(5639),
    [anon_sym_column_major] = ACTIONS(5639),
    [anon_sym_globallycoherent] = ACTIONS(5639),
    [anon_sym_centroid] = ACTIONS(5639),
    [anon_sym_noperspective] = ACTIONS(5639),
    [anon_sym_nointerpolation] = ACTIONS(5639),
    [anon_sym_sample] = ACTIONS(5639),
    [anon_sym_linear] = ACTIONS(5639),
    [anon_sym_snorm] = ACTIONS(5639),
    [anon_sym_unorm] = ACTIONS(5639),
    [anon_sym_point] = ACTIONS(5639),
    [anon_sym_line] = ACTIONS(5639),
    [anon_sym_triangleadj] = ACTIONS(5639),
    [anon_sym_lineadj] = ACTIONS(5639),
    [anon_sym_triangle] = ACTIONS(5639),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_RBRACE] = ACTIONS(5565),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [2248] = {
    [sym_identifier] = ACTIONS(2604),
    [aux_sym_preproc_def_token1] = ACTIONS(2604),
    [aux_sym_preproc_if_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2604),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2604),
    [sym_preproc_directive] = ACTIONS(2604),
    [anon_sym_LPAREN2] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2606),
    [anon_sym_STAR] = ACTIONS(2606),
    [anon_sym_AMP_AMP] = ACTIONS(2606),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_SEMI] = ACTIONS(2606),
    [anon_sym___extension__] = ACTIONS(2604),
    [anon_sym_typedef] = ACTIONS(2604),
    [anon_sym_in] = ACTIONS(2604),
    [anon_sym_out] = ACTIONS(2604),
    [anon_sym_inout] = ACTIONS(2604),
    [anon_sym_virtual] = ACTIONS(2604),
    [anon_sym_extern] = ACTIONS(2604),
    [anon_sym___attribute__] = ACTIONS(2604),
    [anon_sym___attribute] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2604),
    [anon_sym_COLON_COLON] = ACTIONS(2606),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2606),
    [anon_sym___declspec] = ACTIONS(2604),
    [anon_sym___based] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2606),
    [anon_sym_signed] = ACTIONS(2604),
    [anon_sym_unsigned] = ACTIONS(2604),
    [anon_sym_long] = ACTIONS(2604),
    [anon_sym_short] = ACTIONS(2604),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2604),
    [anon_sym_register] = ACTIONS(2604),
    [anon_sym_inline] = ACTIONS(2604),
    [anon_sym___inline] = ACTIONS(2604),
    [anon_sym___inline__] = ACTIONS(2604),
    [anon_sym___forceinline] = ACTIONS(2604),
    [anon_sym_thread_local] = ACTIONS(2604),
    [anon_sym___thread] = ACTIONS(2604),
    [anon_sym_const] = ACTIONS(2604),
    [anon_sym_constexpr] = ACTIONS(2604),
    [anon_sym_volatile] = ACTIONS(2604),
    [anon_sym_restrict] = ACTIONS(2604),
    [anon_sym___restrict__] = ACTIONS(2604),
    [anon_sym__Atomic] = ACTIONS(2604),
    [anon_sym__Noreturn] = ACTIONS(2604),
    [anon_sym_noreturn] = ACTIONS(2604),
    [anon_sym__Nonnull] = ACTIONS(2604),
    [anon_sym_mutable] = ACTIONS(2604),
    [anon_sym_constinit] = ACTIONS(2604),
    [anon_sym_consteval] = ACTIONS(2604),
    [anon_sym_alignas] = ACTIONS(2604),
    [anon_sym__Alignas] = ACTIONS(2604),
    [sym_primitive_type] = ACTIONS(2604),
    [anon_sym_enum] = ACTIONS(2604),
    [anon_sym_class] = ACTIONS(2604),
    [anon_sym_struct] = ACTIONS(2604),
    [anon_sym_union] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2604),
    [anon_sym_decltype] = ACTIONS(2604),
    [anon_sym_explicit] = ACTIONS(2604),
    [anon_sym_typename] = ACTIONS(2604),
    [anon_sym_private] = ACTIONS(2604),
    [anon_sym_template] = ACTIONS(2604),
    [anon_sym_operator] = ACTIONS(2604),
    [anon_sym_friend] = ACTIONS(2604),
    [anon_sym_public] = ACTIONS(2604),
    [anon_sym_protected] = ACTIONS(2604),
    [anon_sym_static_assert] = ACTIONS(2604),
    [anon_sym_precise] = ACTIONS(2604),
    [anon_sym_shared] = ACTIONS(2604),
    [anon_sym_groupshared] = ACTIONS(2604),
    [anon_sym_uniform] = ACTIONS(2604),
    [anon_sym_row_major] = ACTIONS(2604),
    [anon_sym_column_major] = ACTIONS(2604),
    [anon_sym_globallycoherent] = ACTIONS(2604),
    [anon_sym_centroid] = ACTIONS(2604),
    [anon_sym_noperspective] = ACTIONS(2604),
    [anon_sym_nointerpolation] = ACTIONS(2604),
    [anon_sym_sample] = ACTIONS(2604),
    [anon_sym_linear] = ACTIONS(2604),
    [anon_sym_snorm] = ACTIONS(2604),
    [anon_sym_unorm] = ACTIONS(2604),
    [anon_sym_point] = ACTIONS(2604),
    [anon_sym_line] = ACTIONS(2604),
    [anon_sym_triangleadj] = ACTIONS(2604),
    [anon_sym_lineadj] = ACTIONS(2604),
    [anon_sym_triangle] = ACTIONS(2604),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(5563),
    [aux_sym_preproc_def_token1] = ACTIONS(5563),
    [aux_sym_preproc_if_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5563),
    [sym_preproc_directive] = ACTIONS(5563),
    [anon_sym_LPAREN2] = ACTIONS(5565),
    [anon_sym_TILDE] = ACTIONS(5565),
    [anon_sym_STAR] = ACTIONS(5565),
    [anon_sym_AMP_AMP] = ACTIONS(5565),
    [anon_sym_AMP] = ACTIONS(5563),
    [anon_sym_SEMI] = ACTIONS(5565),
    [anon_sym___extension__] = ACTIONS(5563),
    [anon_sym_typedef] = ACTIONS(5563),
    [anon_sym_in] = ACTIONS(5563),
    [anon_sym_out] = ACTIONS(5563),
    [anon_sym_inout] = ACTIONS(5563),
    [anon_sym_virtual] = ACTIONS(5563),
    [anon_sym_extern] = ACTIONS(5563),
    [anon_sym___attribute__] = ACTIONS(5563),
    [anon_sym___attribute] = ACTIONS(5563),
    [anon_sym_using] = ACTIONS(5563),
    [anon_sym_COLON_COLON] = ACTIONS(5565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5565),
    [anon_sym___declspec] = ACTIONS(5563),
    [anon_sym___based] = ACTIONS(5563),
    [anon_sym_RBRACE] = ACTIONS(5565),
    [anon_sym_signed] = ACTIONS(5563),
    [anon_sym_unsigned] = ACTIONS(5563),
    [anon_sym_long] = ACTIONS(5563),
    [anon_sym_short] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(5563),
    [anon_sym_static] = ACTIONS(5563),
    [anon_sym_register] = ACTIONS(5563),
    [anon_sym_inline] = ACTIONS(5563),
    [anon_sym___inline] = ACTIONS(5563),
    [anon_sym___inline__] = ACTIONS(5563),
    [anon_sym___forceinline] = ACTIONS(5563),
    [anon_sym_thread_local] = ACTIONS(5563),
    [anon_sym___thread] = ACTIONS(5563),
    [anon_sym_const] = ACTIONS(5563),
    [anon_sym_constexpr] = ACTIONS(5563),
    [anon_sym_volatile] = ACTIONS(5563),
    [anon_sym_restrict] = ACTIONS(5563),
    [anon_sym___restrict__] = ACTIONS(5563),
    [anon_sym__Atomic] = ACTIONS(5563),
    [anon_sym__Noreturn] = ACTIONS(5563),
    [anon_sym_noreturn] = ACTIONS(5563),
    [anon_sym__Nonnull] = ACTIONS(5563),
    [anon_sym_mutable] = ACTIONS(5563),
    [anon_sym_constinit] = ACTIONS(5563),
    [anon_sym_consteval] = ACTIONS(5563),
    [anon_sym_alignas] = ACTIONS(5563),
    [anon_sym__Alignas] = ACTIONS(5563),
    [sym_primitive_type] = ACTIONS(5563),
    [anon_sym_enum] = ACTIONS(5563),
    [anon_sym_class] = ACTIONS(5563),
    [anon_sym_struct] = ACTIONS(5563),
    [anon_sym_union] = ACTIONS(5563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5563),
    [anon_sym_decltype] = ACTIONS(5563),
    [anon_sym_explicit] = ACTIONS(5563),
    [anon_sym_typename] = ACTIONS(5563),
    [anon_sym_private] = ACTIONS(5563),
    [anon_sym_template] = ACTIONS(5563),
    [anon_sym_operator] = ACTIONS(5563),
    [anon_sym_friend] = ACTIONS(5563),
    [anon_sym_public] = ACTIONS(5563),
    [anon_sym_protected] = ACTIONS(5563),
    [anon_sym_static_assert] = ACTIONS(5563),
    [anon_sym_precise] = ACTIONS(5563),
    [anon_sym_shared] = ACTIONS(5563),
    [anon_sym_groupshared] = ACTIONS(5563),
    [anon_sym_uniform] = ACTIONS(5563),
    [anon_sym_row_major] = ACTIONS(5563),
    [anon_sym_column_major] = ACTIONS(5563),
    [anon_sym_globallycoherent] = ACTIONS(5563),
    [anon_sym_centroid] = ACTIONS(5563),
    [anon_sym_noperspective] = ACTIONS(5563),
    [anon_sym_nointerpolation] = ACTIONS(5563),
    [anon_sym_sample] = ACTIONS(5563),
    [anon_sym_linear] = ACTIONS(5563),
    [anon_sym_snorm] = ACTIONS(5563),
    [anon_sym_unorm] = ACTIONS(5563),
    [anon_sym_point] = ACTIONS(5563),
    [anon_sym_line] = ACTIONS(5563),
    [anon_sym_triangleadj] = ACTIONS(5563),
    [anon_sym_lineadj] = ACTIONS(5563),
    [anon_sym_triangle] = ACTIONS(5563),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(5619),
    [aux_sym_preproc_def_token1] = ACTIONS(5619),
    [aux_sym_preproc_if_token1] = ACTIONS(5619),
    [aux_sym_preproc_if_token2] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5619),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5619),
    [sym_preproc_directive] = ACTIONS(5619),
    [anon_sym_LPAREN2] = ACTIONS(5621),
    [anon_sym_TILDE] = ACTIONS(5621),
    [anon_sym_STAR] = ACTIONS(5621),
    [anon_sym_AMP_AMP] = ACTIONS(5621),
    [anon_sym_AMP] = ACTIONS(5619),
    [anon_sym_SEMI] = ACTIONS(5621),
    [anon_sym___extension__] = ACTIONS(5619),
    [anon_sym_typedef] = ACTIONS(5619),
    [anon_sym_in] = ACTIONS(5619),
    [anon_sym_out] = ACTIONS(5619),
    [anon_sym_inout] = ACTIONS(5619),
    [anon_sym_virtual] = ACTIONS(5619),
    [anon_sym_extern] = ACTIONS(5619),
    [anon_sym___attribute__] = ACTIONS(5619),
    [anon_sym___attribute] = ACTIONS(5619),
    [anon_sym_using] = ACTIONS(5619),
    [anon_sym_COLON_COLON] = ACTIONS(5621),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5621),
    [anon_sym___declspec] = ACTIONS(5619),
    [anon_sym___based] = ACTIONS(5619),
    [anon_sym_signed] = ACTIONS(5619),
    [anon_sym_unsigned] = ACTIONS(5619),
    [anon_sym_long] = ACTIONS(5619),
    [anon_sym_short] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(5619),
    [anon_sym_static] = ACTIONS(5619),
    [anon_sym_register] = ACTIONS(5619),
    [anon_sym_inline] = ACTIONS(5619),
    [anon_sym___inline] = ACTIONS(5619),
    [anon_sym___inline__] = ACTIONS(5619),
    [anon_sym___forceinline] = ACTIONS(5619),
    [anon_sym_thread_local] = ACTIONS(5619),
    [anon_sym___thread] = ACTIONS(5619),
    [anon_sym_const] = ACTIONS(5619),
    [anon_sym_constexpr] = ACTIONS(5619),
    [anon_sym_volatile] = ACTIONS(5619),
    [anon_sym_restrict] = ACTIONS(5619),
    [anon_sym___restrict__] = ACTIONS(5619),
    [anon_sym__Atomic] = ACTIONS(5619),
    [anon_sym__Noreturn] = ACTIONS(5619),
    [anon_sym_noreturn] = ACTIONS(5619),
    [anon_sym__Nonnull] = ACTIONS(5619),
    [anon_sym_mutable] = ACTIONS(5619),
    [anon_sym_constinit] = ACTIONS(5619),
    [anon_sym_consteval] = ACTIONS(5619),
    [anon_sym_alignas] = ACTIONS(5619),
    [anon_sym__Alignas] = ACTIONS(5619),
    [sym_primitive_type] = ACTIONS(5619),
    [anon_sym_enum] = ACTIONS(5619),
    [anon_sym_class] = ACTIONS(5619),
    [anon_sym_struct] = ACTIONS(5619),
    [anon_sym_union] = ACTIONS(5619),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5619),
    [anon_sym_decltype] = ACTIONS(5619),
    [anon_sym_explicit] = ACTIONS(5619),
    [anon_sym_typename] = ACTIONS(5619),
    [anon_sym_private] = ACTIONS(5619),
    [anon_sym_template] = ACTIONS(5619),
    [anon_sym_operator] = ACTIONS(5619),
    [anon_sym_friend] = ACTIONS(5619),
    [anon_sym_public] = ACTIONS(5619),
    [anon_sym_protected] = ACTIONS(5619),
    [anon_sym_static_assert] = ACTIONS(5619),
    [anon_sym_precise] = ACTIONS(5619),
    [anon_sym_shared] = ACTIONS(5619),
    [anon_sym_groupshared] = ACTIONS(5619),
    [anon_sym_uniform] = ACTIONS(5619),
    [anon_sym_row_major] = ACTIONS(5619),
    [anon_sym_column_major] = ACTIONS(5619),
    [anon_sym_globallycoherent] = ACTIONS(5619),
    [anon_sym_centroid] = ACTIONS(5619),
    [anon_sym_noperspective] = ACTIONS(5619),
    [anon_sym_nointerpolation] = ACTIONS(5619),
    [anon_sym_sample] = ACTIONS(5619),
    [anon_sym_linear] = ACTIONS(5619),
    [anon_sym_snorm] = ACTIONS(5619),
    [anon_sym_unorm] = ACTIONS(5619),
    [anon_sym_point] = ACTIONS(5619),
    [anon_sym_line] = ACTIONS(5619),
    [anon_sym_triangleadj] = ACTIONS(5619),
    [anon_sym_lineadj] = ACTIONS(5619),
    [anon_sym_triangle] = ACTIONS(5619),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(2512),
    [aux_sym_preproc_def_token1] = ACTIONS(2512),
    [aux_sym_preproc_if_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2512),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2512),
    [sym_preproc_directive] = ACTIONS(2512),
    [anon_sym_LPAREN2] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym___extension__] = ACTIONS(2512),
    [anon_sym_typedef] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2512),
    [anon_sym_out] = ACTIONS(2512),
    [anon_sym_inout] = ACTIONS(2512),
    [anon_sym_virtual] = ACTIONS(2512),
    [anon_sym_extern] = ACTIONS(2512),
    [anon_sym___attribute__] = ACTIONS(2512),
    [anon_sym___attribute] = ACTIONS(2512),
    [anon_sym_using] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2514),
    [anon_sym___declspec] = ACTIONS(2512),
    [anon_sym___based] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2514),
    [anon_sym_signed] = ACTIONS(2512),
    [anon_sym_unsigned] = ACTIONS(2512),
    [anon_sym_long] = ACTIONS(2512),
    [anon_sym_short] = ACTIONS(2512),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2512),
    [anon_sym_register] = ACTIONS(2512),
    [anon_sym_inline] = ACTIONS(2512),
    [anon_sym___inline] = ACTIONS(2512),
    [anon_sym___inline__] = ACTIONS(2512),
    [anon_sym___forceinline] = ACTIONS(2512),
    [anon_sym_thread_local] = ACTIONS(2512),
    [anon_sym___thread] = ACTIONS(2512),
    [anon_sym_const] = ACTIONS(2512),
    [anon_sym_constexpr] = ACTIONS(2512),
    [anon_sym_volatile] = ACTIONS(2512),
    [anon_sym_restrict] = ACTIONS(2512),
    [anon_sym___restrict__] = ACTIONS(2512),
    [anon_sym__Atomic] = ACTIONS(2512),
    [anon_sym__Noreturn] = ACTIONS(2512),
    [anon_sym_noreturn] = ACTIONS(2512),
    [anon_sym__Nonnull] = ACTIONS(2512),
    [anon_sym_mutable] = ACTIONS(2512),
    [anon_sym_constinit] = ACTIONS(2512),
    [anon_sym_consteval] = ACTIONS(2512),
    [anon_sym_alignas] = ACTIONS(2512),
    [anon_sym__Alignas] = ACTIONS(2512),
    [sym_primitive_type] = ACTIONS(2512),
    [anon_sym_enum] = ACTIONS(2512),
    [anon_sym_class] = ACTIONS(2512),
    [anon_sym_struct] = ACTIONS(2512),
    [anon_sym_union] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2512),
    [anon_sym_decltype] = ACTIONS(2512),
    [anon_sym_explicit] = ACTIONS(2512),
    [anon_sym_typename] = ACTIONS(2512),
    [anon_sym_private] = ACTIONS(2512),
    [anon_sym_template] = ACTIONS(2512),
    [anon_sym_operator] = ACTIONS(2512),
    [anon_sym_friend] = ACTIONS(2512),
    [anon_sym_public] = ACTIONS(2512),
    [anon_sym_protected] = ACTIONS(2512),
    [anon_sym_static_assert] = ACTIONS(2512),
    [anon_sym_precise] = ACTIONS(2512),
    [anon_sym_shared] = ACTIONS(2512),
    [anon_sym_groupshared] = ACTIONS(2512),
    [anon_sym_uniform] = ACTIONS(2512),
    [anon_sym_row_major] = ACTIONS(2512),
    [anon_sym_column_major] = ACTIONS(2512),
    [anon_sym_globallycoherent] = ACTIONS(2512),
    [anon_sym_centroid] = ACTIONS(2512),
    [anon_sym_noperspective] = ACTIONS(2512),
    [anon_sym_nointerpolation] = ACTIONS(2512),
    [anon_sym_sample] = ACTIONS(2512),
    [anon_sym_linear] = ACTIONS(2512),
    [anon_sym_snorm] = ACTIONS(2512),
    [anon_sym_unorm] = ACTIONS(2512),
    [anon_sym_point] = ACTIONS(2512),
    [anon_sym_line] = ACTIONS(2512),
    [anon_sym_triangleadj] = ACTIONS(2512),
    [anon_sym_lineadj] = ACTIONS(2512),
    [anon_sym_triangle] = ACTIONS(2512),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(5603),
    [aux_sym_preproc_def_token1] = ACTIONS(5603),
    [aux_sym_preproc_if_token1] = ACTIONS(5603),
    [aux_sym_preproc_if_token2] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5603),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5603),
    [sym_preproc_directive] = ACTIONS(5603),
    [anon_sym_LPAREN2] = ACTIONS(5605),
    [anon_sym_TILDE] = ACTIONS(5605),
    [anon_sym_STAR] = ACTIONS(5605),
    [anon_sym_AMP_AMP] = ACTIONS(5605),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_SEMI] = ACTIONS(5605),
    [anon_sym___extension__] = ACTIONS(5603),
    [anon_sym_typedef] = ACTIONS(5603),
    [anon_sym_in] = ACTIONS(5603),
    [anon_sym_out] = ACTIONS(5603),
    [anon_sym_inout] = ACTIONS(5603),
    [anon_sym_virtual] = ACTIONS(5603),
    [anon_sym_extern] = ACTIONS(5603),
    [anon_sym___attribute__] = ACTIONS(5603),
    [anon_sym___attribute] = ACTIONS(5603),
    [anon_sym_using] = ACTIONS(5603),
    [anon_sym_COLON_COLON] = ACTIONS(5605),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5605),
    [anon_sym___declspec] = ACTIONS(5603),
    [anon_sym___based] = ACTIONS(5603),
    [anon_sym_signed] = ACTIONS(5603),
    [anon_sym_unsigned] = ACTIONS(5603),
    [anon_sym_long] = ACTIONS(5603),
    [anon_sym_short] = ACTIONS(5603),
    [anon_sym_LBRACK] = ACTIONS(5603),
    [anon_sym_static] = ACTIONS(5603),
    [anon_sym_register] = ACTIONS(5603),
    [anon_sym_inline] = ACTIONS(5603),
    [anon_sym___inline] = ACTIONS(5603),
    [anon_sym___inline__] = ACTIONS(5603),
    [anon_sym___forceinline] = ACTIONS(5603),
    [anon_sym_thread_local] = ACTIONS(5603),
    [anon_sym___thread] = ACTIONS(5603),
    [anon_sym_const] = ACTIONS(5603),
    [anon_sym_constexpr] = ACTIONS(5603),
    [anon_sym_volatile] = ACTIONS(5603),
    [anon_sym_restrict] = ACTIONS(5603),
    [anon_sym___restrict__] = ACTIONS(5603),
    [anon_sym__Atomic] = ACTIONS(5603),
    [anon_sym__Noreturn] = ACTIONS(5603),
    [anon_sym_noreturn] = ACTIONS(5603),
    [anon_sym__Nonnull] = ACTIONS(5603),
    [anon_sym_mutable] = ACTIONS(5603),
    [anon_sym_constinit] = ACTIONS(5603),
    [anon_sym_consteval] = ACTIONS(5603),
    [anon_sym_alignas] = ACTIONS(5603),
    [anon_sym__Alignas] = ACTIONS(5603),
    [sym_primitive_type] = ACTIONS(5603),
    [anon_sym_enum] = ACTIONS(5603),
    [anon_sym_class] = ACTIONS(5603),
    [anon_sym_struct] = ACTIONS(5603),
    [anon_sym_union] = ACTIONS(5603),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5603),
    [anon_sym_decltype] = ACTIONS(5603),
    [anon_sym_explicit] = ACTIONS(5603),
    [anon_sym_typename] = ACTIONS(5603),
    [anon_sym_private] = ACTIONS(5603),
    [anon_sym_template] = ACTIONS(5603),
    [anon_sym_operator] = ACTIONS(5603),
    [anon_sym_friend] = ACTIONS(5603),
    [anon_sym_public] = ACTIONS(5603),
    [anon_sym_protected] = ACTIONS(5603),
    [anon_sym_static_assert] = ACTIONS(5603),
    [anon_sym_precise] = ACTIONS(5603),
    [anon_sym_shared] = ACTIONS(5603),
    [anon_sym_groupshared] = ACTIONS(5603),
    [anon_sym_uniform] = ACTIONS(5603),
    [anon_sym_row_major] = ACTIONS(5603),
    [anon_sym_column_major] = ACTIONS(5603),
    [anon_sym_globallycoherent] = ACTIONS(5603),
    [anon_sym_centroid] = ACTIONS(5603),
    [anon_sym_noperspective] = ACTIONS(5603),
    [anon_sym_nointerpolation] = ACTIONS(5603),
    [anon_sym_sample] = ACTIONS(5603),
    [anon_sym_linear] = ACTIONS(5603),
    [anon_sym_snorm] = ACTIONS(5603),
    [anon_sym_unorm] = ACTIONS(5603),
    [anon_sym_point] = ACTIONS(5603),
    [anon_sym_line] = ACTIONS(5603),
    [anon_sym_triangleadj] = ACTIONS(5603),
    [anon_sym_lineadj] = ACTIONS(5603),
    [anon_sym_triangle] = ACTIONS(5603),
  },
  [2253] = {
    [sym_identifier] = ACTIONS(5607),
    [aux_sym_preproc_def_token1] = ACTIONS(5607),
    [aux_sym_preproc_if_token1] = ACTIONS(5607),
    [aux_sym_preproc_if_token2] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5607),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5607),
    [sym_preproc_directive] = ACTIONS(5607),
    [anon_sym_LPAREN2] = ACTIONS(5609),
    [anon_sym_TILDE] = ACTIONS(5609),
    [anon_sym_STAR] = ACTIONS(5609),
    [anon_sym_AMP_AMP] = ACTIONS(5609),
    [anon_sym_AMP] = ACTIONS(5607),
    [anon_sym_SEMI] = ACTIONS(5609),
    [anon_sym___extension__] = ACTIONS(5607),
    [anon_sym_typedef] = ACTIONS(5607),
    [anon_sym_in] = ACTIONS(5607),
    [anon_sym_out] = ACTIONS(5607),
    [anon_sym_inout] = ACTIONS(5607),
    [anon_sym_virtual] = ACTIONS(5607),
    [anon_sym_extern] = ACTIONS(5607),
    [anon_sym___attribute__] = ACTIONS(5607),
    [anon_sym___attribute] = ACTIONS(5607),
    [anon_sym_using] = ACTIONS(5607),
    [anon_sym_COLON_COLON] = ACTIONS(5609),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5609),
    [anon_sym___declspec] = ACTIONS(5607),
    [anon_sym___based] = ACTIONS(5607),
    [anon_sym_signed] = ACTIONS(5607),
    [anon_sym_unsigned] = ACTIONS(5607),
    [anon_sym_long] = ACTIONS(5607),
    [anon_sym_short] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(5607),
    [anon_sym_static] = ACTIONS(5607),
    [anon_sym_register] = ACTIONS(5607),
    [anon_sym_inline] = ACTIONS(5607),
    [anon_sym___inline] = ACTIONS(5607),
    [anon_sym___inline__] = ACTIONS(5607),
    [anon_sym___forceinline] = ACTIONS(5607),
    [anon_sym_thread_local] = ACTIONS(5607),
    [anon_sym___thread] = ACTIONS(5607),
    [anon_sym_const] = ACTIONS(5607),
    [anon_sym_constexpr] = ACTIONS(5607),
    [anon_sym_volatile] = ACTIONS(5607),
    [anon_sym_restrict] = ACTIONS(5607),
    [anon_sym___restrict__] = ACTIONS(5607),
    [anon_sym__Atomic] = ACTIONS(5607),
    [anon_sym__Noreturn] = ACTIONS(5607),
    [anon_sym_noreturn] = ACTIONS(5607),
    [anon_sym__Nonnull] = ACTIONS(5607),
    [anon_sym_mutable] = ACTIONS(5607),
    [anon_sym_constinit] = ACTIONS(5607),
    [anon_sym_consteval] = ACTIONS(5607),
    [anon_sym_alignas] = ACTIONS(5607),
    [anon_sym__Alignas] = ACTIONS(5607),
    [sym_primitive_type] = ACTIONS(5607),
    [anon_sym_enum] = ACTIONS(5607),
    [anon_sym_class] = ACTIONS(5607),
    [anon_sym_struct] = ACTIONS(5607),
    [anon_sym_union] = ACTIONS(5607),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5607),
    [anon_sym_decltype] = ACTIONS(5607),
    [anon_sym_explicit] = ACTIONS(5607),
    [anon_sym_typename] = ACTIONS(5607),
    [anon_sym_private] = ACTIONS(5607),
    [anon_sym_template] = ACTIONS(5607),
    [anon_sym_operator] = ACTIONS(5607),
    [anon_sym_friend] = ACTIONS(5607),
    [anon_sym_public] = ACTIONS(5607),
    [anon_sym_protected] = ACTIONS(5607),
    [anon_sym_static_assert] = ACTIONS(5607),
    [anon_sym_precise] = ACTIONS(5607),
    [anon_sym_shared] = ACTIONS(5607),
    [anon_sym_groupshared] = ACTIONS(5607),
    [anon_sym_uniform] = ACTIONS(5607),
    [anon_sym_row_major] = ACTIONS(5607),
    [anon_sym_column_major] = ACTIONS(5607),
    [anon_sym_globallycoherent] = ACTIONS(5607),
    [anon_sym_centroid] = ACTIONS(5607),
    [anon_sym_noperspective] = ACTIONS(5607),
    [anon_sym_nointerpolation] = ACTIONS(5607),
    [anon_sym_sample] = ACTIONS(5607),
    [anon_sym_linear] = ACTIONS(5607),
    [anon_sym_snorm] = ACTIONS(5607),
    [anon_sym_unorm] = ACTIONS(5607),
    [anon_sym_point] = ACTIONS(5607),
    [anon_sym_line] = ACTIONS(5607),
    [anon_sym_triangleadj] = ACTIONS(5607),
    [anon_sym_lineadj] = ACTIONS(5607),
    [anon_sym_triangle] = ACTIONS(5607),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(5611),
    [aux_sym_preproc_def_token1] = ACTIONS(5611),
    [aux_sym_preproc_if_token1] = ACTIONS(5611),
    [aux_sym_preproc_if_token2] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5611),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5611),
    [sym_preproc_directive] = ACTIONS(5611),
    [anon_sym_LPAREN2] = ACTIONS(5613),
    [anon_sym_TILDE] = ACTIONS(5613),
    [anon_sym_STAR] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5613),
    [anon_sym_AMP] = ACTIONS(5611),
    [anon_sym_SEMI] = ACTIONS(5613),
    [anon_sym___extension__] = ACTIONS(5611),
    [anon_sym_typedef] = ACTIONS(5611),
    [anon_sym_in] = ACTIONS(5611),
    [anon_sym_out] = ACTIONS(5611),
    [anon_sym_inout] = ACTIONS(5611),
    [anon_sym_virtual] = ACTIONS(5611),
    [anon_sym_extern] = ACTIONS(5611),
    [anon_sym___attribute__] = ACTIONS(5611),
    [anon_sym___attribute] = ACTIONS(5611),
    [anon_sym_using] = ACTIONS(5611),
    [anon_sym_COLON_COLON] = ACTIONS(5613),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5613),
    [anon_sym___declspec] = ACTIONS(5611),
    [anon_sym___based] = ACTIONS(5611),
    [anon_sym_signed] = ACTIONS(5611),
    [anon_sym_unsigned] = ACTIONS(5611),
    [anon_sym_long] = ACTIONS(5611),
    [anon_sym_short] = ACTIONS(5611),
    [anon_sym_LBRACK] = ACTIONS(5611),
    [anon_sym_static] = ACTIONS(5611),
    [anon_sym_register] = ACTIONS(5611),
    [anon_sym_inline] = ACTIONS(5611),
    [anon_sym___inline] = ACTIONS(5611),
    [anon_sym___inline__] = ACTIONS(5611),
    [anon_sym___forceinline] = ACTIONS(5611),
    [anon_sym_thread_local] = ACTIONS(5611),
    [anon_sym___thread] = ACTIONS(5611),
    [anon_sym_const] = ACTIONS(5611),
    [anon_sym_constexpr] = ACTIONS(5611),
    [anon_sym_volatile] = ACTIONS(5611),
    [anon_sym_restrict] = ACTIONS(5611),
    [anon_sym___restrict__] = ACTIONS(5611),
    [anon_sym__Atomic] = ACTIONS(5611),
    [anon_sym__Noreturn] = ACTIONS(5611),
    [anon_sym_noreturn] = ACTIONS(5611),
    [anon_sym__Nonnull] = ACTIONS(5611),
    [anon_sym_mutable] = ACTIONS(5611),
    [anon_sym_constinit] = ACTIONS(5611),
    [anon_sym_consteval] = ACTIONS(5611),
    [anon_sym_alignas] = ACTIONS(5611),
    [anon_sym__Alignas] = ACTIONS(5611),
    [sym_primitive_type] = ACTIONS(5611),
    [anon_sym_enum] = ACTIONS(5611),
    [anon_sym_class] = ACTIONS(5611),
    [anon_sym_struct] = ACTIONS(5611),
    [anon_sym_union] = ACTIONS(5611),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5611),
    [anon_sym_decltype] = ACTIONS(5611),
    [anon_sym_explicit] = ACTIONS(5611),
    [anon_sym_typename] = ACTIONS(5611),
    [anon_sym_private] = ACTIONS(5611),
    [anon_sym_template] = ACTIONS(5611),
    [anon_sym_operator] = ACTIONS(5611),
    [anon_sym_friend] = ACTIONS(5611),
    [anon_sym_public] = ACTIONS(5611),
    [anon_sym_protected] = ACTIONS(5611),
    [anon_sym_static_assert] = ACTIONS(5611),
    [anon_sym_precise] = ACTIONS(5611),
    [anon_sym_shared] = ACTIONS(5611),
    [anon_sym_groupshared] = ACTIONS(5611),
    [anon_sym_uniform] = ACTIONS(5611),
    [anon_sym_row_major] = ACTIONS(5611),
    [anon_sym_column_major] = ACTIONS(5611),
    [anon_sym_globallycoherent] = ACTIONS(5611),
    [anon_sym_centroid] = ACTIONS(5611),
    [anon_sym_noperspective] = ACTIONS(5611),
    [anon_sym_nointerpolation] = ACTIONS(5611),
    [anon_sym_sample] = ACTIONS(5611),
    [anon_sym_linear] = ACTIONS(5611),
    [anon_sym_snorm] = ACTIONS(5611),
    [anon_sym_unorm] = ACTIONS(5611),
    [anon_sym_point] = ACTIONS(5611),
    [anon_sym_line] = ACTIONS(5611),
    [anon_sym_triangleadj] = ACTIONS(5611),
    [anon_sym_lineadj] = ACTIONS(5611),
    [anon_sym_triangle] = ACTIONS(5611),
  },
  [2255] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token2] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2256] = {
    [sym_identifier] = ACTIONS(5615),
    [aux_sym_preproc_def_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token1] = ACTIONS(5615),
    [aux_sym_preproc_if_token2] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5615),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5615),
    [sym_preproc_directive] = ACTIONS(5615),
    [anon_sym_LPAREN2] = ACTIONS(5617),
    [anon_sym_TILDE] = ACTIONS(5617),
    [anon_sym_STAR] = ACTIONS(5617),
    [anon_sym_AMP_AMP] = ACTIONS(5617),
    [anon_sym_AMP] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym___extension__] = ACTIONS(5615),
    [anon_sym_typedef] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_out] = ACTIONS(5615),
    [anon_sym_inout] = ACTIONS(5615),
    [anon_sym_virtual] = ACTIONS(5615),
    [anon_sym_extern] = ACTIONS(5615),
    [anon_sym___attribute__] = ACTIONS(5615),
    [anon_sym___attribute] = ACTIONS(5615),
    [anon_sym_using] = ACTIONS(5615),
    [anon_sym_COLON_COLON] = ACTIONS(5617),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5617),
    [anon_sym___declspec] = ACTIONS(5615),
    [anon_sym___based] = ACTIONS(5615),
    [anon_sym_signed] = ACTIONS(5615),
    [anon_sym_unsigned] = ACTIONS(5615),
    [anon_sym_long] = ACTIONS(5615),
    [anon_sym_short] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(5615),
    [anon_sym_static] = ACTIONS(5615),
    [anon_sym_register] = ACTIONS(5615),
    [anon_sym_inline] = ACTIONS(5615),
    [anon_sym___inline] = ACTIONS(5615),
    [anon_sym___inline__] = ACTIONS(5615),
    [anon_sym___forceinline] = ACTIONS(5615),
    [anon_sym_thread_local] = ACTIONS(5615),
    [anon_sym___thread] = ACTIONS(5615),
    [anon_sym_const] = ACTIONS(5615),
    [anon_sym_constexpr] = ACTIONS(5615),
    [anon_sym_volatile] = ACTIONS(5615),
    [anon_sym_restrict] = ACTIONS(5615),
    [anon_sym___restrict__] = ACTIONS(5615),
    [anon_sym__Atomic] = ACTIONS(5615),
    [anon_sym__Noreturn] = ACTIONS(5615),
    [anon_sym_noreturn] = ACTIONS(5615),
    [anon_sym__Nonnull] = ACTIONS(5615),
    [anon_sym_mutable] = ACTIONS(5615),
    [anon_sym_constinit] = ACTIONS(5615),
    [anon_sym_consteval] = ACTIONS(5615),
    [anon_sym_alignas] = ACTIONS(5615),
    [anon_sym__Alignas] = ACTIONS(5615),
    [sym_primitive_type] = ACTIONS(5615),
    [anon_sym_enum] = ACTIONS(5615),
    [anon_sym_class] = ACTIONS(5615),
    [anon_sym_struct] = ACTIONS(5615),
    [anon_sym_union] = ACTIONS(5615),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5615),
    [anon_sym_decltype] = ACTIONS(5615),
    [anon_sym_explicit] = ACTIONS(5615),
    [anon_sym_typename] = ACTIONS(5615),
    [anon_sym_private] = ACTIONS(5615),
    [anon_sym_template] = ACTIONS(5615),
    [anon_sym_operator] = ACTIONS(5615),
    [anon_sym_friend] = ACTIONS(5615),
    [anon_sym_public] = ACTIONS(5615),
    [anon_sym_protected] = ACTIONS(5615),
    [anon_sym_static_assert] = ACTIONS(5615),
    [anon_sym_precise] = ACTIONS(5615),
    [anon_sym_shared] = ACTIONS(5615),
    [anon_sym_groupshared] = ACTIONS(5615),
    [anon_sym_uniform] = ACTIONS(5615),
    [anon_sym_row_major] = ACTIONS(5615),
    [anon_sym_column_major] = ACTIONS(5615),
    [anon_sym_globallycoherent] = ACTIONS(5615),
    [anon_sym_centroid] = ACTIONS(5615),
    [anon_sym_noperspective] = ACTIONS(5615),
    [anon_sym_nointerpolation] = ACTIONS(5615),
    [anon_sym_sample] = ACTIONS(5615),
    [anon_sym_linear] = ACTIONS(5615),
    [anon_sym_snorm] = ACTIONS(5615),
    [anon_sym_unorm] = ACTIONS(5615),
    [anon_sym_point] = ACTIONS(5615),
    [anon_sym_line] = ACTIONS(5615),
    [anon_sym_triangleadj] = ACTIONS(5615),
    [anon_sym_lineadj] = ACTIONS(5615),
    [anon_sym_triangle] = ACTIONS(5615),
  },
  [2257] = {
    [sym_identifier] = ACTIONS(2616),
    [aux_sym_preproc_def_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token1] = ACTIONS(2616),
    [aux_sym_preproc_if_token2] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2616),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2616),
    [sym_preproc_directive] = ACTIONS(2616),
    [anon_sym_LPAREN2] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_AMP] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym___extension__] = ACTIONS(2616),
    [anon_sym_typedef] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_out] = ACTIONS(2616),
    [anon_sym_inout] = ACTIONS(2616),
    [anon_sym_virtual] = ACTIONS(2616),
    [anon_sym_extern] = ACTIONS(2616),
    [anon_sym___attribute__] = ACTIONS(2616),
    [anon_sym___attribute] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2618),
    [anon_sym___declspec] = ACTIONS(2616),
    [anon_sym___based] = ACTIONS(2616),
    [anon_sym_signed] = ACTIONS(2616),
    [anon_sym_unsigned] = ACTIONS(2616),
    [anon_sym_long] = ACTIONS(2616),
    [anon_sym_short] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2616),
    [anon_sym_register] = ACTIONS(2616),
    [anon_sym_inline] = ACTIONS(2616),
    [anon_sym___inline] = ACTIONS(2616),
    [anon_sym___inline__] = ACTIONS(2616),
    [anon_sym___forceinline] = ACTIONS(2616),
    [anon_sym_thread_local] = ACTIONS(2616),
    [anon_sym___thread] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_constexpr] = ACTIONS(2616),
    [anon_sym_volatile] = ACTIONS(2616),
    [anon_sym_restrict] = ACTIONS(2616),
    [anon_sym___restrict__] = ACTIONS(2616),
    [anon_sym__Atomic] = ACTIONS(2616),
    [anon_sym__Noreturn] = ACTIONS(2616),
    [anon_sym_noreturn] = ACTIONS(2616),
    [anon_sym__Nonnull] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_constinit] = ACTIONS(2616),
    [anon_sym_consteval] = ACTIONS(2616),
    [anon_sym_alignas] = ACTIONS(2616),
    [anon_sym__Alignas] = ACTIONS(2616),
    [sym_primitive_type] = ACTIONS(2616),
    [anon_sym_enum] = ACTIONS(2616),
    [anon_sym_class] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_union] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2616),
    [anon_sym_decltype] = ACTIONS(2616),
    [anon_sym_explicit] = ACTIONS(2616),
    [anon_sym_typename] = ACTIONS(2616),
    [anon_sym_private] = ACTIONS(2616),
    [anon_sym_template] = ACTIONS(2616),
    [anon_sym_operator] = ACTIONS(2616),
    [anon_sym_friend] = ACTIONS(2616),
    [anon_sym_public] = ACTIONS(2616),
    [anon_sym_protected] = ACTIONS(2616),
    [anon_sym_static_assert] = ACTIONS(2616),
    [anon_sym_precise] = ACTIONS(2616),
    [anon_sym_shared] = ACTIONS(2616),
    [anon_sym_groupshared] = ACTIONS(2616),
    [anon_sym_uniform] = ACTIONS(2616),
    [anon_sym_row_major] = ACTIONS(2616),
    [anon_sym_column_major] = ACTIONS(2616),
    [anon_sym_globallycoherent] = ACTIONS(2616),
    [anon_sym_centroid] = ACTIONS(2616),
    [anon_sym_noperspective] = ACTIONS(2616),
    [anon_sym_nointerpolation] = ACTIONS(2616),
    [anon_sym_sample] = ACTIONS(2616),
    [anon_sym_linear] = ACTIONS(2616),
    [anon_sym_snorm] = ACTIONS(2616),
    [anon_sym_unorm] = ACTIONS(2616),
    [anon_sym_point] = ACTIONS(2616),
    [anon_sym_line] = ACTIONS(2616),
    [anon_sym_triangleadj] = ACTIONS(2616),
    [anon_sym_lineadj] = ACTIONS(2616),
    [anon_sym_triangle] = ACTIONS(2616),
  },
  [2258] = {
    [sym_string_literal] = STATE(2670),
    [sym_template_argument_list] = STATE(2574),
    [sym_raw_string_literal] = STATE(2670),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym___extension__] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(5668),
    [anon_sym_unsigned] = ACTIONS(5668),
    [anon_sym_long] = ACTIONS(5668),
    [anon_sym_short] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4223),
    [anon_sym_volatile] = ACTIONS(4223),
    [anon_sym_restrict] = ACTIONS(4223),
    [anon_sym___restrict__] = ACTIONS(4223),
    [anon_sym__Atomic] = ACTIONS(4223),
    [anon_sym__Noreturn] = ACTIONS(4223),
    [anon_sym_noreturn] = ACTIONS(4223),
    [anon_sym__Nonnull] = ACTIONS(4223),
    [anon_sym_mutable] = ACTIONS(4223),
    [anon_sym_constinit] = ACTIONS(4223),
    [anon_sym_consteval] = ACTIONS(4223),
    [anon_sym_alignas] = ACTIONS(4223),
    [anon_sym__Alignas] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4223),
    [anon_sym_decltype] = ACTIONS(4223),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3876),
    [anon_sym_COMMA] = ACTIONS(3876),
    [anon_sym_RPAREN] = ACTIONS(3876),
    [anon_sym_LPAREN2] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_AMP_AMP] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym_COLON] = ACTIONS(3874),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym___extension__] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3874),
    [anon_sym_out] = ACTIONS(3874),
    [anon_sym_inout] = ACTIONS(3874),
    [anon_sym_virtual] = ACTIONS(3874),
    [anon_sym_extern] = ACTIONS(3874),
    [anon_sym___attribute__] = ACTIONS(3874),
    [anon_sym___attribute] = ACTIONS(3874),
    [anon_sym_COLON_COLON] = ACTIONS(3876),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3876),
    [anon_sym___declspec] = ACTIONS(3874),
    [anon_sym___based] = ACTIONS(3874),
    [anon_sym___cdecl] = ACTIONS(3874),
    [anon_sym___clrcall] = ACTIONS(3874),
    [anon_sym___stdcall] = ACTIONS(3874),
    [anon_sym___fastcall] = ACTIONS(3874),
    [anon_sym___thiscall] = ACTIONS(3874),
    [anon_sym___vectorcall] = ACTIONS(3874),
    [anon_sym_LBRACE] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3874),
    [anon_sym_EQ] = ACTIONS(3876),
    [anon_sym_register] = ACTIONS(3874),
    [anon_sym_inline] = ACTIONS(3874),
    [anon_sym___inline] = ACTIONS(3874),
    [anon_sym___inline__] = ACTIONS(3874),
    [anon_sym___forceinline] = ACTIONS(3874),
    [anon_sym_thread_local] = ACTIONS(3874),
    [anon_sym___thread] = ACTIONS(3874),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_constexpr] = ACTIONS(3874),
    [anon_sym_volatile] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3874),
    [anon_sym___restrict__] = ACTIONS(3874),
    [anon_sym__Atomic] = ACTIONS(3874),
    [anon_sym__Noreturn] = ACTIONS(3874),
    [anon_sym_noreturn] = ACTIONS(3874),
    [anon_sym__Nonnull] = ACTIONS(3874),
    [anon_sym_mutable] = ACTIONS(3874),
    [anon_sym_constinit] = ACTIONS(3874),
    [anon_sym_consteval] = ACTIONS(3874),
    [anon_sym_alignas] = ACTIONS(3874),
    [anon_sym__Alignas] = ACTIONS(3874),
    [anon_sym_DASH_GT] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3874),
    [anon_sym_final] = ACTIONS(3874),
    [anon_sym_override] = ACTIONS(3874),
    [anon_sym_explicit] = ACTIONS(3874),
    [anon_sym_private] = ACTIONS(3874),
    [anon_sym_template] = ACTIONS(3874),
    [anon_sym_GT2] = ACTIONS(3876),
    [anon_sym_operator] = ACTIONS(3874),
    [anon_sym_try] = ACTIONS(3874),
    [anon_sym_public] = ACTIONS(3874),
    [anon_sym_protected] = ACTIONS(3874),
    [anon_sym_noexcept] = ACTIONS(3874),
    [anon_sym_throw] = ACTIONS(3874),
    [anon_sym_requires] = ACTIONS(3874),
    [anon_sym_precise] = ACTIONS(3874),
    [anon_sym_shared] = ACTIONS(3874),
    [anon_sym_groupshared] = ACTIONS(3874),
    [anon_sym_uniform] = ACTIONS(3874),
    [anon_sym_row_major] = ACTIONS(3874),
    [anon_sym_column_major] = ACTIONS(3874),
    [anon_sym_globallycoherent] = ACTIONS(3874),
    [anon_sym_centroid] = ACTIONS(3874),
    [anon_sym_noperspective] = ACTIONS(3874),
    [anon_sym_nointerpolation] = ACTIONS(3874),
    [anon_sym_sample] = ACTIONS(3874),
    [anon_sym_linear] = ACTIONS(3874),
    [anon_sym_snorm] = ACTIONS(3874),
    [anon_sym_unorm] = ACTIONS(3874),
    [anon_sym_point] = ACTIONS(3874),
    [anon_sym_line] = ACTIONS(3874),
    [anon_sym_triangleadj] = ACTIONS(3874),
    [anon_sym_lineadj] = ACTIONS(3874),
    [anon_sym_triangle] = ACTIONS(3874),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_RPAREN] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_PIPE_PIPE] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [anon_sym_or] = ACTIONS(2038),
    [anon_sym_and] = ACTIONS(2038),
    [anon_sym_DASH_GT] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_GT2] = ACTIONS(2040),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_try] = ACTIONS(2038),
    [anon_sym_noexcept] = ACTIONS(2038),
    [anon_sym_throw] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [2261] = {
    [sym_type_qualifier] = STATE(2261),
    [sym_alignas_qualifier] = STATE(2292),
    [aux_sym__type_definition_type_repeat1] = STATE(2261),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [aux_sym_preproc_if_token2] = ACTIONS(5026),
    [aux_sym_preproc_else_token1] = ACTIONS(5026),
    [aux_sym_preproc_elif_token1] = ACTIONS(5024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5024),
    [anon_sym_GT_GT] = ACTIONS(5024),
    [anon_sym_COLON] = ACTIONS(5026),
    [anon_sym_SEMI] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(5691),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_RBRACK] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(5691),
    [anon_sym_constexpr] = ACTIONS(5691),
    [anon_sym_volatile] = ACTIONS(5691),
    [anon_sym_restrict] = ACTIONS(5691),
    [anon_sym___restrict__] = ACTIONS(5691),
    [anon_sym__Atomic] = ACTIONS(5691),
    [anon_sym__Noreturn] = ACTIONS(5691),
    [anon_sym_noreturn] = ACTIONS(5691),
    [anon_sym__Nonnull] = ACTIONS(5691),
    [anon_sym_mutable] = ACTIONS(5691),
    [anon_sym_constinit] = ACTIONS(5691),
    [anon_sym_consteval] = ACTIONS(5691),
    [anon_sym_alignas] = ACTIONS(5694),
    [anon_sym__Alignas] = ACTIONS(5694),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_STAR_EQ] = ACTIONS(5026),
    [anon_sym_SLASH_EQ] = ACTIONS(5026),
    [anon_sym_PERCENT_EQ] = ACTIONS(5026),
    [anon_sym_PLUS_EQ] = ACTIONS(5026),
    [anon_sym_DASH_EQ] = ACTIONS(5026),
    [anon_sym_LT_LT_EQ] = ACTIONS(5026),
    [anon_sym_GT_GT_EQ] = ACTIONS(5026),
    [anon_sym_AMP_EQ] = ACTIONS(5026),
    [anon_sym_CARET_EQ] = ACTIONS(5026),
    [anon_sym_PIPE_EQ] = ACTIONS(5026),
    [anon_sym_and_eq] = ACTIONS(5024),
    [anon_sym_or_eq] = ACTIONS(5024),
    [anon_sym_xor_eq] = ACTIONS(5024),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3880),
    [anon_sym_COMMA] = ACTIONS(3880),
    [anon_sym_RPAREN] = ACTIONS(3880),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym_COLON] = ACTIONS(3878),
    [anon_sym_SEMI] = ACTIONS(3880),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3878),
    [anon_sym_out] = ACTIONS(3878),
    [anon_sym_inout] = ACTIONS(3878),
    [anon_sym_virtual] = ACTIONS(3878),
    [anon_sym_extern] = ACTIONS(3878),
    [anon_sym___attribute__] = ACTIONS(3878),
    [anon_sym___attribute] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3880),
    [anon_sym___declspec] = ACTIONS(3878),
    [anon_sym___based] = ACTIONS(3878),
    [anon_sym___cdecl] = ACTIONS(3878),
    [anon_sym___clrcall] = ACTIONS(3878),
    [anon_sym___stdcall] = ACTIONS(3878),
    [anon_sym___fastcall] = ACTIONS(3878),
    [anon_sym___thiscall] = ACTIONS(3878),
    [anon_sym___vectorcall] = ACTIONS(3878),
    [anon_sym_LBRACE] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3878),
    [anon_sym_EQ] = ACTIONS(3880),
    [anon_sym_register] = ACTIONS(3878),
    [anon_sym_inline] = ACTIONS(3878),
    [anon_sym___inline] = ACTIONS(3878),
    [anon_sym___inline__] = ACTIONS(3878),
    [anon_sym___forceinline] = ACTIONS(3878),
    [anon_sym_thread_local] = ACTIONS(3878),
    [anon_sym___thread] = ACTIONS(3878),
    [anon_sym_const] = ACTIONS(3878),
    [anon_sym_constexpr] = ACTIONS(3878),
    [anon_sym_volatile] = ACTIONS(3878),
    [anon_sym_restrict] = ACTIONS(3878),
    [anon_sym___restrict__] = ACTIONS(3878),
    [anon_sym__Atomic] = ACTIONS(3878),
    [anon_sym__Noreturn] = ACTIONS(3878),
    [anon_sym_noreturn] = ACTIONS(3878),
    [anon_sym__Nonnull] = ACTIONS(3878),
    [anon_sym_mutable] = ACTIONS(3878),
    [anon_sym_constinit] = ACTIONS(3878),
    [anon_sym_consteval] = ACTIONS(3878),
    [anon_sym_alignas] = ACTIONS(3878),
    [anon_sym__Alignas] = ACTIONS(3878),
    [anon_sym_DASH_GT] = ACTIONS(3880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3878),
    [anon_sym_final] = ACTIONS(3878),
    [anon_sym_override] = ACTIONS(3878),
    [anon_sym_explicit] = ACTIONS(3878),
    [anon_sym_private] = ACTIONS(3878),
    [anon_sym_template] = ACTIONS(3878),
    [anon_sym_GT2] = ACTIONS(3880),
    [anon_sym_operator] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3878),
    [anon_sym_public] = ACTIONS(3878),
    [anon_sym_protected] = ACTIONS(3878),
    [anon_sym_noexcept] = ACTIONS(3878),
    [anon_sym_throw] = ACTIONS(3878),
    [anon_sym_requires] = ACTIONS(3878),
    [anon_sym_precise] = ACTIONS(3878),
    [anon_sym_shared] = ACTIONS(3878),
    [anon_sym_groupshared] = ACTIONS(3878),
    [anon_sym_uniform] = ACTIONS(3878),
    [anon_sym_row_major] = ACTIONS(3878),
    [anon_sym_column_major] = ACTIONS(3878),
    [anon_sym_globallycoherent] = ACTIONS(3878),
    [anon_sym_centroid] = ACTIONS(3878),
    [anon_sym_noperspective] = ACTIONS(3878),
    [anon_sym_nointerpolation] = ACTIONS(3878),
    [anon_sym_sample] = ACTIONS(3878),
    [anon_sym_linear] = ACTIONS(3878),
    [anon_sym_snorm] = ACTIONS(3878),
    [anon_sym_unorm] = ACTIONS(3878),
    [anon_sym_point] = ACTIONS(3878),
    [anon_sym_line] = ACTIONS(3878),
    [anon_sym_triangleadj] = ACTIONS(3878),
    [anon_sym_lineadj] = ACTIONS(3878),
    [anon_sym_triangle] = ACTIONS(3878),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_using] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym___cdecl] = ACTIONS(1971),
    [anon_sym___clrcall] = ACTIONS(1971),
    [anon_sym___stdcall] = ACTIONS(1971),
    [anon_sym___fastcall] = ACTIONS(1971),
    [anon_sym___thiscall] = ACTIONS(1971),
    [anon_sym___vectorcall] = ACTIONS(1971),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_explicit] = ACTIONS(1971),
    [anon_sym_typename] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_friend] = ACTIONS(1971),
    [anon_sym_concept] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [2264] = {
    [sym__declaration_modifiers] = STATE(2295),
    [sym_attribute_specifier] = STATE(2295),
    [sym_attribute_declaration] = STATE(2295),
    [sym_ms_declspec_modifier] = STATE(2295),
    [sym_storage_class_specifier] = STATE(2295),
    [sym_type_qualifier] = STATE(2295),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2295),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2295),
    [sym_identifier] = ACTIONS(5697),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5699),
    [anon_sym_COMMA] = ACTIONS(5699),
    [anon_sym_RPAREN] = ACTIONS(5699),
    [anon_sym_LPAREN2] = ACTIONS(5699),
    [anon_sym_TILDE] = ACTIONS(5699),
    [anon_sym_STAR] = ACTIONS(5699),
    [anon_sym_AMP_AMP] = ACTIONS(5699),
    [anon_sym_AMP] = ACTIONS(5697),
    [anon_sym_COLON] = ACTIONS(5697),
    [anon_sym_SEMI] = ACTIONS(5699),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5701),
    [anon_sym_out] = ACTIONS(5701),
    [anon_sym_inout] = ACTIONS(5701),
    [anon_sym_virtual] = ACTIONS(5701),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5697),
    [anon_sym___cdecl] = ACTIONS(5697),
    [anon_sym___clrcall] = ACTIONS(5697),
    [anon_sym___stdcall] = ACTIONS(5697),
    [anon_sym___fastcall] = ACTIONS(5697),
    [anon_sym___thiscall] = ACTIONS(5697),
    [anon_sym___vectorcall] = ACTIONS(5697),
    [anon_sym_LBRACK] = ACTIONS(5697),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_EQ] = ACTIONS(5699),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5697),
    [anon_sym_GT2] = ACTIONS(5699),
    [anon_sym_operator] = ACTIONS(5697),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2265] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_friend] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_friend] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2267] = {
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(2029),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym_in] = ACTIONS(2027),
    [anon_sym_out] = ACTIONS(2027),
    [anon_sym_inout] = ACTIONS(2027),
    [anon_sym_virtual] = ACTIONS(2027),
    [anon_sym_extern] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_using] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2029),
    [anon_sym___declspec] = ACTIONS(2027),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym___cdecl] = ACTIONS(2027),
    [anon_sym___clrcall] = ACTIONS(2027),
    [anon_sym___stdcall] = ACTIONS(2027),
    [anon_sym___fastcall] = ACTIONS(2027),
    [anon_sym___thiscall] = ACTIONS(2027),
    [anon_sym___vectorcall] = ACTIONS(2027),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2027),
    [anon_sym_static] = ACTIONS(2027),
    [anon_sym_register] = ACTIONS(2027),
    [anon_sym_inline] = ACTIONS(2027),
    [anon_sym___inline] = ACTIONS(2027),
    [anon_sym___inline__] = ACTIONS(2027),
    [anon_sym___forceinline] = ACTIONS(2027),
    [anon_sym_thread_local] = ACTIONS(2027),
    [anon_sym___thread] = ACTIONS(2027),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_enum] = ACTIONS(2027),
    [anon_sym_class] = ACTIONS(2027),
    [anon_sym_struct] = ACTIONS(2027),
    [anon_sym_union] = ACTIONS(2027),
    [anon_sym_or] = ACTIONS(2027),
    [anon_sym_and] = ACTIONS(2027),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_explicit] = ACTIONS(2027),
    [anon_sym_typename] = ACTIONS(2027),
    [anon_sym_template] = ACTIONS(2027),
    [anon_sym_operator] = ACTIONS(2027),
    [anon_sym_friend] = ACTIONS(2027),
    [anon_sym_concept] = ACTIONS(2027),
    [anon_sym_precise] = ACTIONS(2027),
    [anon_sym_shared] = ACTIONS(2027),
    [anon_sym_groupshared] = ACTIONS(2027),
    [anon_sym_uniform] = ACTIONS(2027),
    [anon_sym_row_major] = ACTIONS(2027),
    [anon_sym_column_major] = ACTIONS(2027),
    [anon_sym_globallycoherent] = ACTIONS(2027),
    [anon_sym_centroid] = ACTIONS(2027),
    [anon_sym_noperspective] = ACTIONS(2027),
    [anon_sym_nointerpolation] = ACTIONS(2027),
    [anon_sym_sample] = ACTIONS(2027),
    [anon_sym_linear] = ACTIONS(2027),
    [anon_sym_snorm] = ACTIONS(2027),
    [anon_sym_unorm] = ACTIONS(2027),
    [anon_sym_point] = ACTIONS(2027),
    [anon_sym_line] = ACTIONS(2027),
    [anon_sym_triangleadj] = ACTIONS(2027),
    [anon_sym_lineadj] = ACTIONS(2027),
    [anon_sym_triangle] = ACTIONS(2027),
  },
  [2268] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5709),
    [anon_sym_COMMA] = ACTIONS(5709),
    [anon_sym_RPAREN] = ACTIONS(5709),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_COLON] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5709),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_EQ] = ACTIONS(5709),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_GT2] = ACTIONS(5709),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2269] = {
    [sym_string_literal] = STATE(3771),
    [sym_template_argument_list] = STATE(3290),
    [sym_raw_string_literal] = STATE(3771),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4230),
    [anon_sym_COMMA] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5713),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym___extension__] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(5716),
    [anon_sym_unsigned] = ACTIONS(5716),
    [anon_sym_long] = ACTIONS(5716),
    [anon_sym_short] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4223),
    [anon_sym_volatile] = ACTIONS(4223),
    [anon_sym_restrict] = ACTIONS(4223),
    [anon_sym___restrict__] = ACTIONS(4223),
    [anon_sym__Atomic] = ACTIONS(4223),
    [anon_sym__Noreturn] = ACTIONS(4223),
    [anon_sym_noreturn] = ACTIONS(4223),
    [anon_sym__Nonnull] = ACTIONS(4223),
    [anon_sym_mutable] = ACTIONS(4223),
    [anon_sym_constinit] = ACTIONS(4223),
    [anon_sym_consteval] = ACTIONS(4223),
    [anon_sym_alignas] = ACTIONS(4223),
    [anon_sym__Alignas] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(5720),
    [anon_sym_SLASH_EQ] = ACTIONS(5720),
    [anon_sym_PERCENT_EQ] = ACTIONS(5720),
    [anon_sym_PLUS_EQ] = ACTIONS(5720),
    [anon_sym_DASH_EQ] = ACTIONS(5720),
    [anon_sym_LT_LT_EQ] = ACTIONS(5720),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5720),
    [anon_sym_CARET_EQ] = ACTIONS(5720),
    [anon_sym_PIPE_EQ] = ACTIONS(5720),
    [anon_sym_and_eq] = ACTIONS(5720),
    [anon_sym_or_eq] = ACTIONS(5720),
    [anon_sym_xor_eq] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(5722),
    [anon_sym_u_DQUOTE] = ACTIONS(5722),
    [anon_sym_U_DQUOTE] = ACTIONS(5722),
    [anon_sym_u8_DQUOTE] = ACTIONS(5722),
    [anon_sym_DQUOTE] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4223),
    [anon_sym_decltype] = ACTIONS(4223),
    [anon_sym_GT2] = ACTIONS(4230),
    [anon_sym_R_DQUOTE] = ACTIONS(5724),
    [anon_sym_LR_DQUOTE] = ACTIONS(5724),
    [anon_sym_uR_DQUOTE] = ACTIONS(5724),
    [anon_sym_UR_DQUOTE] = ACTIONS(5724),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5724),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_TILDE] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_PIPE_PIPE] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2011),
    [anon_sym_out] = ACTIONS(2011),
    [anon_sym_inout] = ACTIONS(2011),
    [anon_sym_virtual] = ACTIONS(2011),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_using] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2013),
    [anon_sym___declspec] = ACTIONS(2011),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym___cdecl] = ACTIONS(2011),
    [anon_sym___clrcall] = ACTIONS(2011),
    [anon_sym___stdcall] = ACTIONS(2011),
    [anon_sym___fastcall] = ACTIONS(2011),
    [anon_sym___thiscall] = ACTIONS(2011),
    [anon_sym___vectorcall] = ACTIONS(2011),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_register] = ACTIONS(2011),
    [anon_sym_inline] = ACTIONS(2011),
    [anon_sym___inline] = ACTIONS(2011),
    [anon_sym___inline__] = ACTIONS(2011),
    [anon_sym___forceinline] = ACTIONS(2011),
    [anon_sym_thread_local] = ACTIONS(2011),
    [anon_sym___thread] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_class] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_or] = ACTIONS(2011),
    [anon_sym_and] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_explicit] = ACTIONS(2011),
    [anon_sym_typename] = ACTIONS(2011),
    [anon_sym_template] = ACTIONS(2011),
    [anon_sym_operator] = ACTIONS(2011),
    [anon_sym_friend] = ACTIONS(2011),
    [anon_sym_concept] = ACTIONS(2011),
    [anon_sym_precise] = ACTIONS(2011),
    [anon_sym_shared] = ACTIONS(2011),
    [anon_sym_groupshared] = ACTIONS(2011),
    [anon_sym_uniform] = ACTIONS(2011),
    [anon_sym_row_major] = ACTIONS(2011),
    [anon_sym_column_major] = ACTIONS(2011),
    [anon_sym_globallycoherent] = ACTIONS(2011),
    [anon_sym_centroid] = ACTIONS(2011),
    [anon_sym_noperspective] = ACTIONS(2011),
    [anon_sym_nointerpolation] = ACTIONS(2011),
    [anon_sym_sample] = ACTIONS(2011),
    [anon_sym_linear] = ACTIONS(2011),
    [anon_sym_snorm] = ACTIONS(2011),
    [anon_sym_unorm] = ACTIONS(2011),
    [anon_sym_point] = ACTIONS(2011),
    [anon_sym_line] = ACTIONS(2011),
    [anon_sym_triangleadj] = ACTIONS(2011),
    [anon_sym_lineadj] = ACTIONS(2011),
    [anon_sym_triangle] = ACTIONS(2011),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_using] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_class] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_explicit] = ACTIONS(2017),
    [anon_sym_typename] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_friend] = ACTIONS(2017),
    [anon_sym_concept] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2272] = {
    [sym_type_qualifier] = STATE(2277),
    [sym_alignas_qualifier] = STATE(1369),
    [aux_sym__type_definition_type_repeat1] = STATE(2277),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2302),
    [sym_identifier] = ACTIONS(5726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_TILDE] = ACTIONS(5729),
    [anon_sym_STAR] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_COLON] = ACTIONS(5731),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym_in] = ACTIONS(5731),
    [anon_sym_out] = ACTIONS(5731),
    [anon_sym_inout] = ACTIONS(5731),
    [anon_sym_virtual] = ACTIONS(5731),
    [anon_sym_extern] = ACTIONS(5731),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_COLON_COLON] = ACTIONS(5729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5729),
    [anon_sym___declspec] = ACTIONS(5731),
    [anon_sym___based] = ACTIONS(5731),
    [anon_sym___cdecl] = ACTIONS(5731),
    [anon_sym___clrcall] = ACTIONS(5731),
    [anon_sym___stdcall] = ACTIONS(5731),
    [anon_sym___fastcall] = ACTIONS(5731),
    [anon_sym___thiscall] = ACTIONS(5731),
    [anon_sym___vectorcall] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(5736),
    [anon_sym_unsigned] = ACTIONS(5736),
    [anon_sym_long] = ACTIONS(5736),
    [anon_sym_short] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5731),
    [anon_sym_static] = ACTIONS(5731),
    [anon_sym_EQ] = ACTIONS(5729),
    [anon_sym_register] = ACTIONS(5731),
    [anon_sym_inline] = ACTIONS(5731),
    [anon_sym___inline] = ACTIONS(5731),
    [anon_sym___inline__] = ACTIONS(5731),
    [anon_sym___forceinline] = ACTIONS(5731),
    [anon_sym_thread_local] = ACTIONS(5731),
    [anon_sym___thread] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym__Nonnull] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5738),
    [anon_sym__Alignas] = ACTIONS(5738),
    [sym_primitive_type] = ACTIONS(5741),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_template] = ACTIONS(5731),
    [anon_sym_GT2] = ACTIONS(5729),
    [anon_sym_operator] = ACTIONS(5731),
    [anon_sym_precise] = ACTIONS(5731),
    [anon_sym_shared] = ACTIONS(5731),
    [anon_sym_groupshared] = ACTIONS(5731),
    [anon_sym_uniform] = ACTIONS(5731),
    [anon_sym_row_major] = ACTIONS(5731),
    [anon_sym_column_major] = ACTIONS(5731),
    [anon_sym_globallycoherent] = ACTIONS(5731),
    [anon_sym_centroid] = ACTIONS(5731),
    [anon_sym_noperspective] = ACTIONS(5731),
    [anon_sym_nointerpolation] = ACTIONS(5731),
    [anon_sym_sample] = ACTIONS(5731),
    [anon_sym_linear] = ACTIONS(5731),
    [anon_sym_snorm] = ACTIONS(5731),
    [anon_sym_unorm] = ACTIONS(5731),
    [anon_sym_point] = ACTIONS(5731),
    [anon_sym_line] = ACTIONS(5731),
    [anon_sym_triangleadj] = ACTIONS(5731),
    [anon_sym_lineadj] = ACTIONS(5731),
    [anon_sym_triangle] = ACTIONS(5731),
  },
  [2273] = {
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_LPAREN2] = ACTIONS(1949),
    [anon_sym_TILDE] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_PIPE_PIPE] = ACTIONS(1949),
    [anon_sym_AMP_AMP] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1951),
    [anon_sym___extension__] = ACTIONS(1951),
    [anon_sym_in] = ACTIONS(1951),
    [anon_sym_out] = ACTIONS(1951),
    [anon_sym_inout] = ACTIONS(1951),
    [anon_sym_virtual] = ACTIONS(1951),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym___attribute__] = ACTIONS(1951),
    [anon_sym___attribute] = ACTIONS(1951),
    [anon_sym_using] = ACTIONS(1951),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1949),
    [anon_sym___declspec] = ACTIONS(1951),
    [anon_sym___based] = ACTIONS(1951),
    [anon_sym___cdecl] = ACTIONS(1951),
    [anon_sym___clrcall] = ACTIONS(1951),
    [anon_sym___stdcall] = ACTIONS(1951),
    [anon_sym___fastcall] = ACTIONS(1951),
    [anon_sym___thiscall] = ACTIONS(1951),
    [anon_sym___vectorcall] = ACTIONS(1951),
    [anon_sym_signed] = ACTIONS(1951),
    [anon_sym_unsigned] = ACTIONS(1951),
    [anon_sym_long] = ACTIONS(1951),
    [anon_sym_short] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_register] = ACTIONS(1951),
    [anon_sym_inline] = ACTIONS(1951),
    [anon_sym___inline] = ACTIONS(1951),
    [anon_sym___inline__] = ACTIONS(1951),
    [anon_sym___forceinline] = ACTIONS(1951),
    [anon_sym_thread_local] = ACTIONS(1951),
    [anon_sym___thread] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_constexpr] = ACTIONS(1951),
    [anon_sym_volatile] = ACTIONS(1951),
    [anon_sym_restrict] = ACTIONS(1951),
    [anon_sym___restrict__] = ACTIONS(1951),
    [anon_sym__Atomic] = ACTIONS(1951),
    [anon_sym__Noreturn] = ACTIONS(1951),
    [anon_sym_noreturn] = ACTIONS(1951),
    [anon_sym__Nonnull] = ACTIONS(1951),
    [anon_sym_mutable] = ACTIONS(1951),
    [anon_sym_constinit] = ACTIONS(1951),
    [anon_sym_consteval] = ACTIONS(1951),
    [anon_sym_alignas] = ACTIONS(1951),
    [anon_sym__Alignas] = ACTIONS(1951),
    [sym_primitive_type] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_class] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_or] = ACTIONS(1951),
    [anon_sym_and] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1951),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1951),
    [anon_sym_operator] = ACTIONS(1951),
    [anon_sym_friend] = ACTIONS(1951),
    [anon_sym_concept] = ACTIONS(1951),
    [anon_sym_precise] = ACTIONS(1951),
    [anon_sym_shared] = ACTIONS(1951),
    [anon_sym_groupshared] = ACTIONS(1951),
    [anon_sym_uniform] = ACTIONS(1951),
    [anon_sym_row_major] = ACTIONS(1951),
    [anon_sym_column_major] = ACTIONS(1951),
    [anon_sym_globallycoherent] = ACTIONS(1951),
    [anon_sym_centroid] = ACTIONS(1951),
    [anon_sym_noperspective] = ACTIONS(1951),
    [anon_sym_nointerpolation] = ACTIONS(1951),
    [anon_sym_sample] = ACTIONS(1951),
    [anon_sym_linear] = ACTIONS(1951),
    [anon_sym_snorm] = ACTIONS(1951),
    [anon_sym_unorm] = ACTIONS(1951),
    [anon_sym_point] = ACTIONS(1951),
    [anon_sym_line] = ACTIONS(1951),
    [anon_sym_triangleadj] = ACTIONS(1951),
    [anon_sym_lineadj] = ACTIONS(1951),
    [anon_sym_triangle] = ACTIONS(1951),
  },
  [2274] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_TILDE] = ACTIONS(5745),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5743),
    [anon_sym_SEMI] = ACTIONS(5745),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym_in] = ACTIONS(5743),
    [anon_sym_out] = ACTIONS(5743),
    [anon_sym_inout] = ACTIONS(5743),
    [anon_sym_virtual] = ACTIONS(5743),
    [anon_sym_extern] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_COLON_COLON] = ACTIONS(5745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5745),
    [anon_sym___declspec] = ACTIONS(5743),
    [anon_sym___based] = ACTIONS(5743),
    [anon_sym___cdecl] = ACTIONS(5743),
    [anon_sym___clrcall] = ACTIONS(5743),
    [anon_sym___stdcall] = ACTIONS(5743),
    [anon_sym___fastcall] = ACTIONS(5743),
    [anon_sym___thiscall] = ACTIONS(5743),
    [anon_sym___vectorcall] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(5747),
    [anon_sym_unsigned] = ACTIONS(5747),
    [anon_sym_long] = ACTIONS(5747),
    [anon_sym_short] = ACTIONS(5747),
    [anon_sym_LBRACK] = ACTIONS(5743),
    [anon_sym_static] = ACTIONS(5743),
    [anon_sym_EQ] = ACTIONS(5745),
    [anon_sym_register] = ACTIONS(5743),
    [anon_sym_inline] = ACTIONS(5743),
    [anon_sym___inline] = ACTIONS(5743),
    [anon_sym___inline__] = ACTIONS(5743),
    [anon_sym___forceinline] = ACTIONS(5743),
    [anon_sym_thread_local] = ACTIONS(5743),
    [anon_sym___thread] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_final] = ACTIONS(5743),
    [anon_sym_override] = ACTIONS(5743),
    [anon_sym_template] = ACTIONS(5743),
    [anon_sym_GT2] = ACTIONS(5745),
    [anon_sym_operator] = ACTIONS(5743),
    [anon_sym_requires] = ACTIONS(5743),
    [anon_sym_precise] = ACTIONS(5743),
    [anon_sym_shared] = ACTIONS(5743),
    [anon_sym_groupshared] = ACTIONS(5743),
    [anon_sym_uniform] = ACTIONS(5743),
    [anon_sym_row_major] = ACTIONS(5743),
    [anon_sym_column_major] = ACTIONS(5743),
    [anon_sym_globallycoherent] = ACTIONS(5743),
    [anon_sym_centroid] = ACTIONS(5743),
    [anon_sym_noperspective] = ACTIONS(5743),
    [anon_sym_nointerpolation] = ACTIONS(5743),
    [anon_sym_sample] = ACTIONS(5743),
    [anon_sym_linear] = ACTIONS(5743),
    [anon_sym_snorm] = ACTIONS(5743),
    [anon_sym_unorm] = ACTIONS(5743),
    [anon_sym_point] = ACTIONS(5743),
    [anon_sym_line] = ACTIONS(5743),
    [anon_sym_triangleadj] = ACTIONS(5743),
    [anon_sym_lineadj] = ACTIONS(5743),
    [anon_sym_triangle] = ACTIONS(5743),
  },
  [2275] = {
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_LPAREN2] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1947),
    [anon_sym___extension__] = ACTIONS(1947),
    [anon_sym_in] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(1947),
    [anon_sym_inout] = ACTIONS(1947),
    [anon_sym_virtual] = ACTIONS(1947),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym___attribute__] = ACTIONS(1947),
    [anon_sym___attribute] = ACTIONS(1947),
    [anon_sym_using] = ACTIONS(1947),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1945),
    [anon_sym___declspec] = ACTIONS(1947),
    [anon_sym___based] = ACTIONS(1947),
    [anon_sym___cdecl] = ACTIONS(1947),
    [anon_sym___clrcall] = ACTIONS(1947),
    [anon_sym___stdcall] = ACTIONS(1947),
    [anon_sym___fastcall] = ACTIONS(1947),
    [anon_sym___thiscall] = ACTIONS(1947),
    [anon_sym___vectorcall] = ACTIONS(1947),
    [anon_sym_signed] = ACTIONS(1947),
    [anon_sym_unsigned] = ACTIONS(1947),
    [anon_sym_long] = ACTIONS(1947),
    [anon_sym_short] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_register] = ACTIONS(1947),
    [anon_sym_inline] = ACTIONS(1947),
    [anon_sym___inline] = ACTIONS(1947),
    [anon_sym___inline__] = ACTIONS(1947),
    [anon_sym___forceinline] = ACTIONS(1947),
    [anon_sym_thread_local] = ACTIONS(1947),
    [anon_sym___thread] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_constexpr] = ACTIONS(1947),
    [anon_sym_volatile] = ACTIONS(1947),
    [anon_sym_restrict] = ACTIONS(1947),
    [anon_sym___restrict__] = ACTIONS(1947),
    [anon_sym__Atomic] = ACTIONS(1947),
    [anon_sym__Noreturn] = ACTIONS(1947),
    [anon_sym_noreturn] = ACTIONS(1947),
    [anon_sym__Nonnull] = ACTIONS(1947),
    [anon_sym_mutable] = ACTIONS(1947),
    [anon_sym_constinit] = ACTIONS(1947),
    [anon_sym_consteval] = ACTIONS(1947),
    [anon_sym_alignas] = ACTIONS(1947),
    [anon_sym__Alignas] = ACTIONS(1947),
    [sym_primitive_type] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_class] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_or] = ACTIONS(1947),
    [anon_sym_and] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1947),
    [anon_sym_decltype] = ACTIONS(1947),
    [anon_sym_explicit] = ACTIONS(1947),
    [anon_sym_typename] = ACTIONS(1947),
    [anon_sym_template] = ACTIONS(1947),
    [anon_sym_operator] = ACTIONS(1947),
    [anon_sym_friend] = ACTIONS(1947),
    [anon_sym_concept] = ACTIONS(1947),
    [anon_sym_precise] = ACTIONS(1947),
    [anon_sym_shared] = ACTIONS(1947),
    [anon_sym_groupshared] = ACTIONS(1947),
    [anon_sym_uniform] = ACTIONS(1947),
    [anon_sym_row_major] = ACTIONS(1947),
    [anon_sym_column_major] = ACTIONS(1947),
    [anon_sym_globallycoherent] = ACTIONS(1947),
    [anon_sym_centroid] = ACTIONS(1947),
    [anon_sym_noperspective] = ACTIONS(1947),
    [anon_sym_nointerpolation] = ACTIONS(1947),
    [anon_sym_sample] = ACTIONS(1947),
    [anon_sym_linear] = ACTIONS(1947),
    [anon_sym_snorm] = ACTIONS(1947),
    [anon_sym_unorm] = ACTIONS(1947),
    [anon_sym_point] = ACTIONS(1947),
    [anon_sym_line] = ACTIONS(1947),
    [anon_sym_triangleadj] = ACTIONS(1947),
    [anon_sym_lineadj] = ACTIONS(1947),
    [anon_sym_triangle] = ACTIONS(1947),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_PIPE_PIPE] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_using] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2040),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_enum] = ACTIONS(2038),
    [anon_sym_class] = ACTIONS(2038),
    [anon_sym_struct] = ACTIONS(2038),
    [anon_sym_union] = ACTIONS(2038),
    [anon_sym_or] = ACTIONS(2038),
    [anon_sym_and] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_explicit] = ACTIONS(2038),
    [anon_sym_typename] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_friend] = ACTIONS(2038),
    [anon_sym_concept] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [2277] = {
    [sym_type_qualifier] = STATE(1312),
    [sym_alignas_qualifier] = STATE(1369),
    [aux_sym__type_definition_type_repeat1] = STATE(1312),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2320),
    [sym_identifier] = ACTIONS(5750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_TILDE] = ACTIONS(5753),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_COLON] = ACTIONS(5755),
    [anon_sym_SEMI] = ACTIONS(5753),
    [anon_sym___extension__] = ACTIONS(5757),
    [anon_sym_in] = ACTIONS(5755),
    [anon_sym_out] = ACTIONS(5755),
    [anon_sym_inout] = ACTIONS(5755),
    [anon_sym_virtual] = ACTIONS(5755),
    [anon_sym_extern] = ACTIONS(5755),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_COLON_COLON] = ACTIONS(5753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5753),
    [anon_sym___declspec] = ACTIONS(5755),
    [anon_sym___based] = ACTIONS(5755),
    [anon_sym___cdecl] = ACTIONS(5755),
    [anon_sym___clrcall] = ACTIONS(5755),
    [anon_sym___stdcall] = ACTIONS(5755),
    [anon_sym___fastcall] = ACTIONS(5755),
    [anon_sym___thiscall] = ACTIONS(5755),
    [anon_sym___vectorcall] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5760),
    [anon_sym_unsigned] = ACTIONS(5760),
    [anon_sym_long] = ACTIONS(5760),
    [anon_sym_short] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5755),
    [anon_sym_EQ] = ACTIONS(5753),
    [anon_sym_register] = ACTIONS(5755),
    [anon_sym_inline] = ACTIONS(5755),
    [anon_sym___inline] = ACTIONS(5755),
    [anon_sym___inline__] = ACTIONS(5755),
    [anon_sym___forceinline] = ACTIONS(5755),
    [anon_sym_thread_local] = ACTIONS(5755),
    [anon_sym___thread] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym___restrict__] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym__Noreturn] = ACTIONS(5757),
    [anon_sym_noreturn] = ACTIONS(5757),
    [anon_sym__Nonnull] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_constinit] = ACTIONS(5757),
    [anon_sym_consteval] = ACTIONS(5757),
    [anon_sym_alignas] = ACTIONS(5762),
    [anon_sym__Alignas] = ACTIONS(5762),
    [sym_primitive_type] = ACTIONS(5765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_template] = ACTIONS(5755),
    [anon_sym_GT2] = ACTIONS(5753),
    [anon_sym_operator] = ACTIONS(5755),
    [anon_sym_precise] = ACTIONS(5755),
    [anon_sym_shared] = ACTIONS(5755),
    [anon_sym_groupshared] = ACTIONS(5755),
    [anon_sym_uniform] = ACTIONS(5755),
    [anon_sym_row_major] = ACTIONS(5755),
    [anon_sym_column_major] = ACTIONS(5755),
    [anon_sym_globallycoherent] = ACTIONS(5755),
    [anon_sym_centroid] = ACTIONS(5755),
    [anon_sym_noperspective] = ACTIONS(5755),
    [anon_sym_nointerpolation] = ACTIONS(5755),
    [anon_sym_sample] = ACTIONS(5755),
    [anon_sym_linear] = ACTIONS(5755),
    [anon_sym_snorm] = ACTIONS(5755),
    [anon_sym_unorm] = ACTIONS(5755),
    [anon_sym_point] = ACTIONS(5755),
    [anon_sym_line] = ACTIONS(5755),
    [anon_sym_triangleadj] = ACTIONS(5755),
    [anon_sym_lineadj] = ACTIONS(5755),
    [anon_sym_triangle] = ACTIONS(5755),
  },
  [2278] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_using] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym___cdecl] = ACTIONS(1975),
    [anon_sym___clrcall] = ACTIONS(1975),
    [anon_sym___stdcall] = ACTIONS(1975),
    [anon_sym___fastcall] = ACTIONS(1975),
    [anon_sym___thiscall] = ACTIONS(1975),
    [anon_sym___vectorcall] = ACTIONS(1975),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_class] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_explicit] = ACTIONS(1975),
    [anon_sym_typename] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_friend] = ACTIONS(1975),
    [anon_sym_concept] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_using] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym___cdecl] = ACTIONS(1953),
    [anon_sym___clrcall] = ACTIONS(1953),
    [anon_sym___stdcall] = ACTIONS(1953),
    [anon_sym___fastcall] = ACTIONS(1953),
    [anon_sym___thiscall] = ACTIONS(1953),
    [anon_sym___vectorcall] = ACTIONS(1953),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_enum] = ACTIONS(1953),
    [anon_sym_class] = ACTIONS(1953),
    [anon_sym_struct] = ACTIONS(1953),
    [anon_sym_union] = ACTIONS(1953),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_explicit] = ACTIONS(1953),
    [anon_sym_typename] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_friend] = ACTIONS(1953),
    [anon_sym_concept] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [2280] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym___cdecl] = ACTIONS(1979),
    [anon_sym___clrcall] = ACTIONS(1979),
    [anon_sym___stdcall] = ACTIONS(1979),
    [anon_sym___fastcall] = ACTIONS(1979),
    [anon_sym___thiscall] = ACTIONS(1979),
    [anon_sym___vectorcall] = ACTIONS(1979),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_typename] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_friend] = ACTIONS(1979),
    [anon_sym_concept] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [2281] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_using] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym___cdecl] = ACTIONS(1983),
    [anon_sym___clrcall] = ACTIONS(1983),
    [anon_sym___stdcall] = ACTIONS(1983),
    [anon_sym___fastcall] = ACTIONS(1983),
    [anon_sym___thiscall] = ACTIONS(1983),
    [anon_sym___vectorcall] = ACTIONS(1983),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_class] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_explicit] = ACTIONS(1983),
    [anon_sym_typename] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_friend] = ACTIONS(1983),
    [anon_sym_concept] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_using] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym___cdecl] = ACTIONS(1991),
    [anon_sym___clrcall] = ACTIONS(1991),
    [anon_sym___stdcall] = ACTIONS(1991),
    [anon_sym___fastcall] = ACTIONS(1991),
    [anon_sym___thiscall] = ACTIONS(1991),
    [anon_sym___vectorcall] = ACTIONS(1991),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_class] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_explicit] = ACTIONS(1991),
    [anon_sym_typename] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_friend] = ACTIONS(1991),
    [anon_sym_concept] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [2283] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_using] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym___cdecl] = ACTIONS(1987),
    [anon_sym___clrcall] = ACTIONS(1987),
    [anon_sym___stdcall] = ACTIONS(1987),
    [anon_sym___fastcall] = ACTIONS(1987),
    [anon_sym___thiscall] = ACTIONS(1987),
    [anon_sym___vectorcall] = ACTIONS(1987),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_class] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_explicit] = ACTIONS(1987),
    [anon_sym_typename] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_friend] = ACTIONS(1987),
    [anon_sym_concept] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [2284] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym___cdecl] = ACTIONS(2017),
    [anon_sym___clrcall] = ACTIONS(2017),
    [anon_sym___stdcall] = ACTIONS(2017),
    [anon_sym___fastcall] = ACTIONS(2017),
    [anon_sym___thiscall] = ACTIONS(2017),
    [anon_sym___vectorcall] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(2019),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_template] = ACTIONS(2017),
    [anon_sym_GT2] = ACTIONS(2019),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_noexcept] = ACTIONS(2017),
    [anon_sym_throw] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2285] = {
    [sym_identifier] = ACTIONS(5767),
    [anon_sym_LPAREN2] = ACTIONS(5769),
    [anon_sym_TILDE] = ACTIONS(5769),
    [anon_sym_STAR] = ACTIONS(5769),
    [anon_sym_PIPE_PIPE] = ACTIONS(5771),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5767),
    [anon_sym___extension__] = ACTIONS(5767),
    [anon_sym_in] = ACTIONS(5767),
    [anon_sym_out] = ACTIONS(5767),
    [anon_sym_inout] = ACTIONS(5767),
    [anon_sym_virtual] = ACTIONS(5767),
    [anon_sym_extern] = ACTIONS(5767),
    [anon_sym___attribute__] = ACTIONS(5767),
    [anon_sym___attribute] = ACTIONS(5767),
    [anon_sym_using] = ACTIONS(5767),
    [anon_sym_COLON_COLON] = ACTIONS(5769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5769),
    [anon_sym___declspec] = ACTIONS(5767),
    [anon_sym___based] = ACTIONS(5767),
    [anon_sym___cdecl] = ACTIONS(5767),
    [anon_sym___clrcall] = ACTIONS(5767),
    [anon_sym___stdcall] = ACTIONS(5767),
    [anon_sym___fastcall] = ACTIONS(5767),
    [anon_sym___thiscall] = ACTIONS(5767),
    [anon_sym___vectorcall] = ACTIONS(5767),
    [anon_sym_signed] = ACTIONS(5767),
    [anon_sym_unsigned] = ACTIONS(5767),
    [anon_sym_long] = ACTIONS(5767),
    [anon_sym_short] = ACTIONS(5767),
    [anon_sym_LBRACK] = ACTIONS(5767),
    [anon_sym_static] = ACTIONS(5767),
    [anon_sym_register] = ACTIONS(5767),
    [anon_sym_inline] = ACTIONS(5767),
    [anon_sym___inline] = ACTIONS(5767),
    [anon_sym___inline__] = ACTIONS(5767),
    [anon_sym___forceinline] = ACTIONS(5767),
    [anon_sym_thread_local] = ACTIONS(5767),
    [anon_sym___thread] = ACTIONS(5767),
    [anon_sym_const] = ACTIONS(5767),
    [anon_sym_constexpr] = ACTIONS(5767),
    [anon_sym_volatile] = ACTIONS(5767),
    [anon_sym_restrict] = ACTIONS(5767),
    [anon_sym___restrict__] = ACTIONS(5767),
    [anon_sym__Atomic] = ACTIONS(5767),
    [anon_sym__Noreturn] = ACTIONS(5767),
    [anon_sym_noreturn] = ACTIONS(5767),
    [anon_sym__Nonnull] = ACTIONS(5767),
    [anon_sym_mutable] = ACTIONS(5767),
    [anon_sym_constinit] = ACTIONS(5767),
    [anon_sym_consteval] = ACTIONS(5767),
    [anon_sym_alignas] = ACTIONS(5767),
    [anon_sym__Alignas] = ACTIONS(5767),
    [sym_primitive_type] = ACTIONS(5767),
    [anon_sym_enum] = ACTIONS(5767),
    [anon_sym_class] = ACTIONS(5767),
    [anon_sym_struct] = ACTIONS(5767),
    [anon_sym_union] = ACTIONS(5767),
    [anon_sym_or] = ACTIONS(5775),
    [anon_sym_and] = ACTIONS(5777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5767),
    [anon_sym_decltype] = ACTIONS(5767),
    [anon_sym_explicit] = ACTIONS(5767),
    [anon_sym_typename] = ACTIONS(5767),
    [anon_sym_template] = ACTIONS(5767),
    [anon_sym_operator] = ACTIONS(5767),
    [anon_sym_friend] = ACTIONS(5767),
    [anon_sym_concept] = ACTIONS(5767),
    [anon_sym_precise] = ACTIONS(5767),
    [anon_sym_shared] = ACTIONS(5767),
    [anon_sym_groupshared] = ACTIONS(5767),
    [anon_sym_uniform] = ACTIONS(5767),
    [anon_sym_row_major] = ACTIONS(5767),
    [anon_sym_column_major] = ACTIONS(5767),
    [anon_sym_globallycoherent] = ACTIONS(5767),
    [anon_sym_centroid] = ACTIONS(5767),
    [anon_sym_noperspective] = ACTIONS(5767),
    [anon_sym_nointerpolation] = ACTIONS(5767),
    [anon_sym_sample] = ACTIONS(5767),
    [anon_sym_linear] = ACTIONS(5767),
    [anon_sym_snorm] = ACTIONS(5767),
    [anon_sym_unorm] = ACTIONS(5767),
    [anon_sym_point] = ACTIONS(5767),
    [anon_sym_line] = ACTIONS(5767),
    [anon_sym_triangleadj] = ACTIONS(5767),
    [anon_sym_lineadj] = ACTIONS(5767),
    [anon_sym_triangle] = ACTIONS(5767),
  },
  [2286] = {
    [sym_identifier] = ACTIONS(5779),
    [anon_sym_LPAREN2] = ACTIONS(5781),
    [anon_sym_TILDE] = ACTIONS(5781),
    [anon_sym_STAR] = ACTIONS(5781),
    [anon_sym_PIPE_PIPE] = ACTIONS(5781),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5779),
    [anon_sym___extension__] = ACTIONS(5779),
    [anon_sym_in] = ACTIONS(5779),
    [anon_sym_out] = ACTIONS(5779),
    [anon_sym_inout] = ACTIONS(5779),
    [anon_sym_virtual] = ACTIONS(5779),
    [anon_sym_extern] = ACTIONS(5779),
    [anon_sym___attribute__] = ACTIONS(5779),
    [anon_sym___attribute] = ACTIONS(5779),
    [anon_sym_using] = ACTIONS(5779),
    [anon_sym_COLON_COLON] = ACTIONS(5781),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5781),
    [anon_sym___declspec] = ACTIONS(5779),
    [anon_sym___based] = ACTIONS(5779),
    [anon_sym___cdecl] = ACTIONS(5779),
    [anon_sym___clrcall] = ACTIONS(5779),
    [anon_sym___stdcall] = ACTIONS(5779),
    [anon_sym___fastcall] = ACTIONS(5779),
    [anon_sym___thiscall] = ACTIONS(5779),
    [anon_sym___vectorcall] = ACTIONS(5779),
    [anon_sym_signed] = ACTIONS(5779),
    [anon_sym_unsigned] = ACTIONS(5779),
    [anon_sym_long] = ACTIONS(5779),
    [anon_sym_short] = ACTIONS(5779),
    [anon_sym_LBRACK] = ACTIONS(5779),
    [anon_sym_static] = ACTIONS(5779),
    [anon_sym_register] = ACTIONS(5779),
    [anon_sym_inline] = ACTIONS(5779),
    [anon_sym___inline] = ACTIONS(5779),
    [anon_sym___inline__] = ACTIONS(5779),
    [anon_sym___forceinline] = ACTIONS(5779),
    [anon_sym_thread_local] = ACTIONS(5779),
    [anon_sym___thread] = ACTIONS(5779),
    [anon_sym_const] = ACTIONS(5779),
    [anon_sym_constexpr] = ACTIONS(5779),
    [anon_sym_volatile] = ACTIONS(5779),
    [anon_sym_restrict] = ACTIONS(5779),
    [anon_sym___restrict__] = ACTIONS(5779),
    [anon_sym__Atomic] = ACTIONS(5779),
    [anon_sym__Noreturn] = ACTIONS(5779),
    [anon_sym_noreturn] = ACTIONS(5779),
    [anon_sym__Nonnull] = ACTIONS(5779),
    [anon_sym_mutable] = ACTIONS(5779),
    [anon_sym_constinit] = ACTIONS(5779),
    [anon_sym_consteval] = ACTIONS(5779),
    [anon_sym_alignas] = ACTIONS(5779),
    [anon_sym__Alignas] = ACTIONS(5779),
    [sym_primitive_type] = ACTIONS(5779),
    [anon_sym_enum] = ACTIONS(5779),
    [anon_sym_class] = ACTIONS(5779),
    [anon_sym_struct] = ACTIONS(5779),
    [anon_sym_union] = ACTIONS(5779),
    [anon_sym_or] = ACTIONS(5779),
    [anon_sym_and] = ACTIONS(5777),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5779),
    [anon_sym_decltype] = ACTIONS(5779),
    [anon_sym_explicit] = ACTIONS(5779),
    [anon_sym_typename] = ACTIONS(5779),
    [anon_sym_template] = ACTIONS(5779),
    [anon_sym_operator] = ACTIONS(5779),
    [anon_sym_friend] = ACTIONS(5779),
    [anon_sym_concept] = ACTIONS(5779),
    [anon_sym_precise] = ACTIONS(5779),
    [anon_sym_shared] = ACTIONS(5779),
    [anon_sym_groupshared] = ACTIONS(5779),
    [anon_sym_uniform] = ACTIONS(5779),
    [anon_sym_row_major] = ACTIONS(5779),
    [anon_sym_column_major] = ACTIONS(5779),
    [anon_sym_globallycoherent] = ACTIONS(5779),
    [anon_sym_centroid] = ACTIONS(5779),
    [anon_sym_noperspective] = ACTIONS(5779),
    [anon_sym_nointerpolation] = ACTIONS(5779),
    [anon_sym_sample] = ACTIONS(5779),
    [anon_sym_linear] = ACTIONS(5779),
    [anon_sym_snorm] = ACTIONS(5779),
    [anon_sym_unorm] = ACTIONS(5779),
    [anon_sym_point] = ACTIONS(5779),
    [anon_sym_line] = ACTIONS(5779),
    [anon_sym_triangleadj] = ACTIONS(5779),
    [anon_sym_lineadj] = ACTIONS(5779),
    [anon_sym_triangle] = ACTIONS(5779),
  },
  [2287] = {
    [sym_template_argument_list] = STATE(2260),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_RPAREN] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_PIPE_PIPE] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym___cdecl] = ACTIONS(2005),
    [anon_sym___clrcall] = ACTIONS(2005),
    [anon_sym___stdcall] = ACTIONS(2005),
    [anon_sym___fastcall] = ACTIONS(2005),
    [anon_sym___thiscall] = ACTIONS(2005),
    [anon_sym___vectorcall] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [anon_sym_or] = ACTIONS(2005),
    [anon_sym_and] = ACTIONS(2005),
    [anon_sym_DASH_GT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2005),
    [anon_sym_noexcept] = ACTIONS(2005),
    [anon_sym_throw] = ACTIONS(2005),
    [anon_sym_requires] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
  },
  [2288] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3370),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2609),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4230),
    [anon_sym_LPAREN2] = ACTIONS(4230),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4227),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4230),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4227),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym___extension__] = ACTIONS(4223),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_signed] = ACTIONS(5668),
    [anon_sym_unsigned] = ACTIONS(5668),
    [anon_sym_long] = ACTIONS(5668),
    [anon_sym_short] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4223),
    [anon_sym_volatile] = ACTIONS(4223),
    [anon_sym_restrict] = ACTIONS(4223),
    [anon_sym___restrict__] = ACTIONS(4223),
    [anon_sym__Atomic] = ACTIONS(4223),
    [anon_sym__Noreturn] = ACTIONS(4223),
    [anon_sym_noreturn] = ACTIONS(4223),
    [anon_sym__Nonnull] = ACTIONS(4223),
    [anon_sym_mutable] = ACTIONS(4223),
    [anon_sym_constinit] = ACTIONS(4223),
    [anon_sym_consteval] = ACTIONS(4223),
    [anon_sym_alignas] = ACTIONS(4223),
    [anon_sym__Alignas] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4223),
    [anon_sym_decltype] = ACTIONS(4223),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2289] = {
    [sym_template_argument_list] = STATE(2260),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [anon_sym_or] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_DASH_GT] = ACTIONS(1999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_try] = ACTIONS(1997),
    [anon_sym_noexcept] = ACTIONS(1997),
    [anon_sym_throw] = ACTIONS(1997),
    [anon_sym_requires] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2290] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [aux_sym_preproc_if_token2] = ACTIONS(5745),
    [aux_sym_preproc_else_token1] = ACTIONS(5745),
    [aux_sym_preproc_elif_token1] = ACTIONS(5743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5745),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5743),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5743),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5745),
    [anon_sym_SEMI] = ACTIONS(5745),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_RBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(5788),
    [anon_sym_unsigned] = ACTIONS(5788),
    [anon_sym_long] = ACTIONS(5788),
    [anon_sym_short] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_RBRACK] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_and_eq] = ACTIONS(5743),
    [anon_sym_or_eq] = ACTIONS(5743),
    [anon_sym_xor_eq] = ACTIONS(5743),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
  },
  [2291] = {
    [sym_template_argument_list] = STATE(2507),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(5791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [anon_sym_RPAREN] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_TILDE] = ACTIONS(5793),
    [anon_sym_STAR] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_COLON] = ACTIONS(5791),
    [anon_sym_SEMI] = ACTIONS(5793),
    [anon_sym___extension__] = ACTIONS(5791),
    [anon_sym_in] = ACTIONS(5791),
    [anon_sym_out] = ACTIONS(5791),
    [anon_sym_inout] = ACTIONS(5791),
    [anon_sym_virtual] = ACTIONS(5791),
    [anon_sym_extern] = ACTIONS(5791),
    [anon_sym___attribute__] = ACTIONS(5791),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5793),
    [anon_sym___declspec] = ACTIONS(5791),
    [anon_sym___based] = ACTIONS(5791),
    [anon_sym___cdecl] = ACTIONS(5791),
    [anon_sym___clrcall] = ACTIONS(5791),
    [anon_sym___stdcall] = ACTIONS(5791),
    [anon_sym___fastcall] = ACTIONS(5791),
    [anon_sym___thiscall] = ACTIONS(5791),
    [anon_sym___vectorcall] = ACTIONS(5791),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(5791),
    [anon_sym_static] = ACTIONS(5791),
    [anon_sym_EQ] = ACTIONS(5793),
    [anon_sym_register] = ACTIONS(5791),
    [anon_sym_inline] = ACTIONS(5791),
    [anon_sym___inline] = ACTIONS(5791),
    [anon_sym___inline__] = ACTIONS(5791),
    [anon_sym___forceinline] = ACTIONS(5791),
    [anon_sym_thread_local] = ACTIONS(5791),
    [anon_sym___thread] = ACTIONS(5791),
    [anon_sym_const] = ACTIONS(5791),
    [anon_sym_constexpr] = ACTIONS(5791),
    [anon_sym_volatile] = ACTIONS(5791),
    [anon_sym_restrict] = ACTIONS(5791),
    [anon_sym___restrict__] = ACTIONS(5791),
    [anon_sym__Atomic] = ACTIONS(5791),
    [anon_sym__Noreturn] = ACTIONS(5791),
    [anon_sym_noreturn] = ACTIONS(5791),
    [anon_sym__Nonnull] = ACTIONS(5791),
    [anon_sym_mutable] = ACTIONS(5791),
    [anon_sym_constinit] = ACTIONS(5791),
    [anon_sym_consteval] = ACTIONS(5791),
    [anon_sym_alignas] = ACTIONS(5791),
    [anon_sym__Alignas] = ACTIONS(5791),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5791),
    [anon_sym_decltype] = ACTIONS(5791),
    [anon_sym_template] = ACTIONS(5791),
    [anon_sym_GT2] = ACTIONS(5793),
    [anon_sym_operator] = ACTIONS(5791),
    [anon_sym_precise] = ACTIONS(5791),
    [anon_sym_shared] = ACTIONS(5791),
    [anon_sym_groupshared] = ACTIONS(5791),
    [anon_sym_uniform] = ACTIONS(5791),
    [anon_sym_row_major] = ACTIONS(5791),
    [anon_sym_column_major] = ACTIONS(5791),
    [anon_sym_globallycoherent] = ACTIONS(5791),
    [anon_sym_centroid] = ACTIONS(5791),
    [anon_sym_noperspective] = ACTIONS(5791),
    [anon_sym_nointerpolation] = ACTIONS(5791),
    [anon_sym_sample] = ACTIONS(5791),
    [anon_sym_linear] = ACTIONS(5791),
    [anon_sym_snorm] = ACTIONS(5791),
    [anon_sym_unorm] = ACTIONS(5791),
    [anon_sym_point] = ACTIONS(5791),
    [anon_sym_line] = ACTIONS(5791),
    [anon_sym_triangleadj] = ACTIONS(5791),
    [anon_sym_lineadj] = ACTIONS(5791),
    [anon_sym_triangle] = ACTIONS(5791),
  },
  [2292] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [aux_sym_preproc_if_token2] = ACTIONS(2187),
    [aux_sym_preproc_else_token1] = ACTIONS(2187),
    [aux_sym_preproc_elif_token1] = ACTIONS(2197),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_and_eq] = ACTIONS(2197),
    [anon_sym_or_eq] = ACTIONS(2197),
    [anon_sym_xor_eq] = ACTIONS(2197),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
  },
  [2293] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [aux_sym_preproc_if_token2] = ACTIONS(5168),
    [aux_sym_preproc_else_token1] = ACTIONS(5168),
    [aux_sym_preproc_elif_token1] = ACTIONS(5166),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5168),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5166),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym_COLON] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_RBRACK] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_STAR_EQ] = ACTIONS(5168),
    [anon_sym_SLASH_EQ] = ACTIONS(5168),
    [anon_sym_PERCENT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_GT_EQ] = ACTIONS(5168),
    [anon_sym_AMP_EQ] = ACTIONS(5168),
    [anon_sym_CARET_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_and_eq] = ACTIONS(5166),
    [anon_sym_or_eq] = ACTIONS(5166),
    [anon_sym_xor_eq] = ACTIONS(5166),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
  },
  [2294] = {
    [sym__declaration_modifiers] = STATE(2296),
    [sym_attribute_specifier] = STATE(2296),
    [sym_attribute_declaration] = STATE(2296),
    [sym_ms_declspec_modifier] = STATE(2296),
    [sym_storage_class_specifier] = STATE(2296),
    [sym_type_qualifier] = STATE(2296),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_qualifiers] = STATE(2296),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2296),
    [sym_identifier] = ACTIONS(5795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5797),
    [anon_sym_COMMA] = ACTIONS(5797),
    [anon_sym_RPAREN] = ACTIONS(5797),
    [anon_sym_LPAREN2] = ACTIONS(5797),
    [anon_sym_TILDE] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_AMP_AMP] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_COLON] = ACTIONS(5795),
    [anon_sym_SEMI] = ACTIONS(5797),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5799),
    [anon_sym_out] = ACTIONS(5799),
    [anon_sym_inout] = ACTIONS(5799),
    [anon_sym_virtual] = ACTIONS(5799),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5797),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5795),
    [anon_sym___cdecl] = ACTIONS(5795),
    [anon_sym___clrcall] = ACTIONS(5795),
    [anon_sym___stdcall] = ACTIONS(5795),
    [anon_sym___fastcall] = ACTIONS(5795),
    [anon_sym___thiscall] = ACTIONS(5795),
    [anon_sym___vectorcall] = ACTIONS(5795),
    [anon_sym_LBRACK] = ACTIONS(5795),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5795),
    [anon_sym_template] = ACTIONS(5795),
    [anon_sym_GT2] = ACTIONS(5797),
    [anon_sym_operator] = ACTIONS(5795),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2295] = {
    [sym__declaration_modifiers] = STATE(2296),
    [sym_attribute_specifier] = STATE(2296),
    [sym_attribute_declaration] = STATE(2296),
    [sym_ms_declspec_modifier] = STATE(2296),
    [sym_storage_class_specifier] = STATE(2296),
    [sym_type_qualifier] = STATE(2296),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_qualifiers] = STATE(2296),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2296),
    [sym_identifier] = ACTIONS(5801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5803),
    [anon_sym_COMMA] = ACTIONS(5803),
    [anon_sym_RPAREN] = ACTIONS(5803),
    [anon_sym_LPAREN2] = ACTIONS(5803),
    [anon_sym_TILDE] = ACTIONS(5803),
    [anon_sym_STAR] = ACTIONS(5803),
    [anon_sym_AMP_AMP] = ACTIONS(5803),
    [anon_sym_AMP] = ACTIONS(5801),
    [anon_sym_COLON] = ACTIONS(5801),
    [anon_sym_SEMI] = ACTIONS(5803),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5799),
    [anon_sym_out] = ACTIONS(5799),
    [anon_sym_inout] = ACTIONS(5799),
    [anon_sym_virtual] = ACTIONS(5799),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5803),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5801),
    [anon_sym___cdecl] = ACTIONS(5801),
    [anon_sym___clrcall] = ACTIONS(5801),
    [anon_sym___stdcall] = ACTIONS(5801),
    [anon_sym___fastcall] = ACTIONS(5801),
    [anon_sym___thiscall] = ACTIONS(5801),
    [anon_sym___vectorcall] = ACTIONS(5801),
    [anon_sym_LBRACK] = ACTIONS(5801),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_EQ] = ACTIONS(5803),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5801),
    [anon_sym_template] = ACTIONS(5801),
    [anon_sym_GT2] = ACTIONS(5803),
    [anon_sym_operator] = ACTIONS(5801),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2296] = {
    [sym__declaration_modifiers] = STATE(2296),
    [sym_attribute_specifier] = STATE(2296),
    [sym_attribute_declaration] = STATE(2296),
    [sym_ms_declspec_modifier] = STATE(2296),
    [sym_storage_class_specifier] = STATE(2296),
    [sym_type_qualifier] = STATE(2296),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_qualifiers] = STATE(2296),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2296),
    [sym_identifier] = ACTIONS(5805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5807),
    [anon_sym_COMMA] = ACTIONS(5807),
    [anon_sym_RPAREN] = ACTIONS(5807),
    [anon_sym_LPAREN2] = ACTIONS(5807),
    [anon_sym_TILDE] = ACTIONS(5807),
    [anon_sym_STAR] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5807),
    [anon_sym_AMP] = ACTIONS(5805),
    [anon_sym_COLON] = ACTIONS(5805),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym___extension__] = ACTIONS(5809),
    [anon_sym_in] = ACTIONS(5812),
    [anon_sym_out] = ACTIONS(5812),
    [anon_sym_inout] = ACTIONS(5812),
    [anon_sym_virtual] = ACTIONS(5812),
    [anon_sym_extern] = ACTIONS(5815),
    [anon_sym___attribute__] = ACTIONS(5818),
    [anon_sym___attribute] = ACTIONS(5818),
    [anon_sym_COLON_COLON] = ACTIONS(5807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5821),
    [anon_sym___declspec] = ACTIONS(5824),
    [anon_sym___based] = ACTIONS(5805),
    [anon_sym___cdecl] = ACTIONS(5805),
    [anon_sym___clrcall] = ACTIONS(5805),
    [anon_sym___stdcall] = ACTIONS(5805),
    [anon_sym___fastcall] = ACTIONS(5805),
    [anon_sym___thiscall] = ACTIONS(5805),
    [anon_sym___vectorcall] = ACTIONS(5805),
    [anon_sym_LBRACK] = ACTIONS(5805),
    [anon_sym_static] = ACTIONS(5815),
    [anon_sym_EQ] = ACTIONS(5807),
    [anon_sym_register] = ACTIONS(5815),
    [anon_sym_inline] = ACTIONS(5815),
    [anon_sym___inline] = ACTIONS(5815),
    [anon_sym___inline__] = ACTIONS(5815),
    [anon_sym___forceinline] = ACTIONS(5815),
    [anon_sym_thread_local] = ACTIONS(5815),
    [anon_sym___thread] = ACTIONS(5815),
    [anon_sym_const] = ACTIONS(5809),
    [anon_sym_constexpr] = ACTIONS(5809),
    [anon_sym_volatile] = ACTIONS(5809),
    [anon_sym_restrict] = ACTIONS(5809),
    [anon_sym___restrict__] = ACTIONS(5809),
    [anon_sym__Atomic] = ACTIONS(5809),
    [anon_sym__Noreturn] = ACTIONS(5809),
    [anon_sym_noreturn] = ACTIONS(5809),
    [anon_sym__Nonnull] = ACTIONS(5809),
    [anon_sym_mutable] = ACTIONS(5809),
    [anon_sym_constinit] = ACTIONS(5809),
    [anon_sym_consteval] = ACTIONS(5809),
    [anon_sym_alignas] = ACTIONS(5827),
    [anon_sym__Alignas] = ACTIONS(5827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5805),
    [anon_sym_template] = ACTIONS(5805),
    [anon_sym_GT2] = ACTIONS(5807),
    [anon_sym_operator] = ACTIONS(5805),
    [anon_sym_precise] = ACTIONS(5830),
    [anon_sym_shared] = ACTIONS(5830),
    [anon_sym_groupshared] = ACTIONS(5830),
    [anon_sym_uniform] = ACTIONS(5830),
    [anon_sym_row_major] = ACTIONS(5830),
    [anon_sym_column_major] = ACTIONS(5830),
    [anon_sym_globallycoherent] = ACTIONS(5830),
    [anon_sym_centroid] = ACTIONS(5830),
    [anon_sym_noperspective] = ACTIONS(5830),
    [anon_sym_nointerpolation] = ACTIONS(5830),
    [anon_sym_sample] = ACTIONS(5830),
    [anon_sym_linear] = ACTIONS(5830),
    [anon_sym_snorm] = ACTIONS(5830),
    [anon_sym_unorm] = ACTIONS(5830),
    [anon_sym_point] = ACTIONS(5830),
    [anon_sym_line] = ACTIONS(5830),
    [anon_sym_triangleadj] = ACTIONS(5830),
    [anon_sym_lineadj] = ACTIONS(5830),
    [anon_sym_triangle] = ACTIONS(5830),
  },
  [2297] = {
    [sym_type_qualifier] = STATE(2299),
    [sym_alignas_qualifier] = STATE(2292),
    [aux_sym__type_definition_type_repeat1] = STATE(2299),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2336),
    [sym_identifier] = ACTIONS(5833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [aux_sym_preproc_if_token2] = ACTIONS(5729),
    [aux_sym_preproc_else_token1] = ACTIONS(5729),
    [aux_sym_preproc_elif_token1] = ACTIONS(5731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5729),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5731),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5731),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5731),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(5838),
    [anon_sym_unsigned] = ACTIONS(5838),
    [anon_sym_long] = ACTIONS(5838),
    [anon_sym_short] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(5836),
    [anon_sym_constexpr] = ACTIONS(5836),
    [anon_sym_volatile] = ACTIONS(5836),
    [anon_sym_restrict] = ACTIONS(5836),
    [anon_sym___restrict__] = ACTIONS(5836),
    [anon_sym__Atomic] = ACTIONS(5836),
    [anon_sym__Noreturn] = ACTIONS(5836),
    [anon_sym_noreturn] = ACTIONS(5836),
    [anon_sym__Nonnull] = ACTIONS(5836),
    [anon_sym_mutable] = ACTIONS(5836),
    [anon_sym_constinit] = ACTIONS(5836),
    [anon_sym_consteval] = ACTIONS(5836),
    [anon_sym_alignas] = ACTIONS(5840),
    [anon_sym__Alignas] = ACTIONS(5840),
    [sym_primitive_type] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_STAR_EQ] = ACTIONS(5729),
    [anon_sym_SLASH_EQ] = ACTIONS(5729),
    [anon_sym_PERCENT_EQ] = ACTIONS(5729),
    [anon_sym_PLUS_EQ] = ACTIONS(5729),
    [anon_sym_DASH_EQ] = ACTIONS(5729),
    [anon_sym_LT_LT_EQ] = ACTIONS(5729),
    [anon_sym_GT_GT_EQ] = ACTIONS(5729),
    [anon_sym_AMP_EQ] = ACTIONS(5729),
    [anon_sym_CARET_EQ] = ACTIONS(5729),
    [anon_sym_PIPE_EQ] = ACTIONS(5729),
    [anon_sym_and_eq] = ACTIONS(5731),
    [anon_sym_or_eq] = ACTIONS(5731),
    [anon_sym_xor_eq] = ACTIONS(5731),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
  },
  [2298] = {
    [sym_type_qualifier] = STATE(2261),
    [sym_alignas_qualifier] = STATE(2292),
    [aux_sym__type_definition_type_repeat1] = STATE(2261),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2821),
    [sym_identifier] = ACTIONS(5844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_SEMI] = ACTIONS(5753),
    [anon_sym___extension__] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_RBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5846),
    [anon_sym_unsigned] = ACTIONS(5846),
    [anon_sym_long] = ACTIONS(5846),
    [anon_sym_short] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_RBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5836),
    [anon_sym_constexpr] = ACTIONS(5836),
    [anon_sym_volatile] = ACTIONS(5836),
    [anon_sym_restrict] = ACTIONS(5836),
    [anon_sym___restrict__] = ACTIONS(5836),
    [anon_sym__Atomic] = ACTIONS(5836),
    [anon_sym__Noreturn] = ACTIONS(5836),
    [anon_sym_noreturn] = ACTIONS(5836),
    [anon_sym__Nonnull] = ACTIONS(5836),
    [anon_sym_mutable] = ACTIONS(5836),
    [anon_sym_constinit] = ACTIONS(5836),
    [anon_sym_consteval] = ACTIONS(5836),
    [anon_sym_alignas] = ACTIONS(5840),
    [anon_sym__Alignas] = ACTIONS(5840),
    [sym_primitive_type] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5753),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_and_eq] = ACTIONS(5755),
    [anon_sym_or_eq] = ACTIONS(5755),
    [anon_sym_xor_eq] = ACTIONS(5755),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
  },
  [2299] = {
    [sym_type_qualifier] = STATE(2261),
    [sym_alignas_qualifier] = STATE(2292),
    [aux_sym__type_definition_type_repeat1] = STATE(2261),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2769),
    [sym_identifier] = ACTIONS(5850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [aux_sym_preproc_if_token2] = ACTIONS(5753),
    [aux_sym_preproc_else_token1] = ACTIONS(5753),
    [aux_sym_preproc_elif_token1] = ACTIONS(5755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5753),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5853),
    [anon_sym_unsigned] = ACTIONS(5853),
    [anon_sym_long] = ACTIONS(5853),
    [anon_sym_short] = ACTIONS(5853),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5836),
    [anon_sym_constexpr] = ACTIONS(5836),
    [anon_sym_volatile] = ACTIONS(5836),
    [anon_sym_restrict] = ACTIONS(5836),
    [anon_sym___restrict__] = ACTIONS(5836),
    [anon_sym__Atomic] = ACTIONS(5836),
    [anon_sym__Noreturn] = ACTIONS(5836),
    [anon_sym_noreturn] = ACTIONS(5836),
    [anon_sym__Nonnull] = ACTIONS(5836),
    [anon_sym_mutable] = ACTIONS(5836),
    [anon_sym_constinit] = ACTIONS(5836),
    [anon_sym_consteval] = ACTIONS(5836),
    [anon_sym_alignas] = ACTIONS(5840),
    [anon_sym__Alignas] = ACTIONS(5840),
    [sym_primitive_type] = ACTIONS(5855),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5753),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_and_eq] = ACTIONS(5755),
    [anon_sym_or_eq] = ACTIONS(5755),
    [anon_sym_xor_eq] = ACTIONS(5755),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
  },
  [2300] = {
    [sym_argument_list] = STATE(2926),
    [sym_initializer_list] = STATE(4095),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5861),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(4299),
    [anon_sym_signed] = ACTIONS(5864),
    [anon_sym_unsigned] = ACTIONS(5864),
    [anon_sym_long] = ACTIONS(5864),
    [anon_sym_short] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2301] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5868),
    [anon_sym_COMMA] = ACTIONS(5868),
    [anon_sym_RPAREN] = ACTIONS(5868),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_GT2] = ACTIONS(5868),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2302] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_TILDE] = ACTIONS(5875),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_COLON] = ACTIONS(5872),
    [anon_sym_SEMI] = ACTIONS(5875),
    [anon_sym___extension__] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5872),
    [anon_sym_out] = ACTIONS(5872),
    [anon_sym_inout] = ACTIONS(5872),
    [anon_sym_virtual] = ACTIONS(5872),
    [anon_sym_extern] = ACTIONS(5872),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_COLON_COLON] = ACTIONS(5875),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5875),
    [anon_sym___declspec] = ACTIONS(5872),
    [anon_sym___based] = ACTIONS(5872),
    [anon_sym___cdecl] = ACTIONS(5872),
    [anon_sym___clrcall] = ACTIONS(5872),
    [anon_sym___stdcall] = ACTIONS(5872),
    [anon_sym___fastcall] = ACTIONS(5872),
    [anon_sym___thiscall] = ACTIONS(5872),
    [anon_sym___vectorcall] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(5747),
    [anon_sym_unsigned] = ACTIONS(5747),
    [anon_sym_long] = ACTIONS(5747),
    [anon_sym_short] = ACTIONS(5747),
    [anon_sym_LBRACK] = ACTIONS(5872),
    [anon_sym_static] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(5875),
    [anon_sym_register] = ACTIONS(5872),
    [anon_sym_inline] = ACTIONS(5872),
    [anon_sym___inline] = ACTIONS(5872),
    [anon_sym___inline__] = ACTIONS(5872),
    [anon_sym___forceinline] = ACTIONS(5872),
    [anon_sym_thread_local] = ACTIONS(5872),
    [anon_sym___thread] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5872),
    [anon_sym_constexpr] = ACTIONS(5872),
    [anon_sym_volatile] = ACTIONS(5872),
    [anon_sym_restrict] = ACTIONS(5872),
    [anon_sym___restrict__] = ACTIONS(5872),
    [anon_sym__Atomic] = ACTIONS(5872),
    [anon_sym__Noreturn] = ACTIONS(5872),
    [anon_sym_noreturn] = ACTIONS(5872),
    [anon_sym__Nonnull] = ACTIONS(5872),
    [anon_sym_mutable] = ACTIONS(5872),
    [anon_sym_constinit] = ACTIONS(5872),
    [anon_sym_consteval] = ACTIONS(5872),
    [anon_sym_alignas] = ACTIONS(5872),
    [anon_sym__Alignas] = ACTIONS(5872),
    [sym_primitive_type] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
    [anon_sym_template] = ACTIONS(5872),
    [anon_sym_GT2] = ACTIONS(5875),
    [anon_sym_operator] = ACTIONS(5872),
    [anon_sym_precise] = ACTIONS(5872),
    [anon_sym_shared] = ACTIONS(5872),
    [anon_sym_groupshared] = ACTIONS(5872),
    [anon_sym_uniform] = ACTIONS(5872),
    [anon_sym_row_major] = ACTIONS(5872),
    [anon_sym_column_major] = ACTIONS(5872),
    [anon_sym_globallycoherent] = ACTIONS(5872),
    [anon_sym_centroid] = ACTIONS(5872),
    [anon_sym_noperspective] = ACTIONS(5872),
    [anon_sym_nointerpolation] = ACTIONS(5872),
    [anon_sym_sample] = ACTIONS(5872),
    [anon_sym_linear] = ACTIONS(5872),
    [anon_sym_snorm] = ACTIONS(5872),
    [anon_sym_unorm] = ACTIONS(5872),
    [anon_sym_point] = ACTIONS(5872),
    [anon_sym_line] = ACTIONS(5872),
    [anon_sym_triangleadj] = ACTIONS(5872),
    [anon_sym_lineadj] = ACTIONS(5872),
    [anon_sym_triangle] = ACTIONS(5872),
  },
  [2303] = {
    [sym_type_qualifier] = STATE(2298),
    [sym_alignas_qualifier] = STATE(2292),
    [aux_sym__type_definition_type_repeat1] = STATE(2298),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2344),
    [sym_identifier] = ACTIONS(5878),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5731),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5731),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5731),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym_COLON] = ACTIONS(5729),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym___extension__] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_RBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(5880),
    [anon_sym_unsigned] = ACTIONS(5880),
    [anon_sym_long] = ACTIONS(5880),
    [anon_sym_short] = ACTIONS(5880),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(5836),
    [anon_sym_constexpr] = ACTIONS(5836),
    [anon_sym_volatile] = ACTIONS(5836),
    [anon_sym_restrict] = ACTIONS(5836),
    [anon_sym___restrict__] = ACTIONS(5836),
    [anon_sym__Atomic] = ACTIONS(5836),
    [anon_sym__Noreturn] = ACTIONS(5836),
    [anon_sym_noreturn] = ACTIONS(5836),
    [anon_sym__Nonnull] = ACTIONS(5836),
    [anon_sym_mutable] = ACTIONS(5836),
    [anon_sym_constinit] = ACTIONS(5836),
    [anon_sym_consteval] = ACTIONS(5836),
    [anon_sym_alignas] = ACTIONS(5840),
    [anon_sym__Alignas] = ACTIONS(5840),
    [sym_primitive_type] = ACTIONS(5882),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_STAR_EQ] = ACTIONS(5729),
    [anon_sym_SLASH_EQ] = ACTIONS(5729),
    [anon_sym_PERCENT_EQ] = ACTIONS(5729),
    [anon_sym_PLUS_EQ] = ACTIONS(5729),
    [anon_sym_DASH_EQ] = ACTIONS(5729),
    [anon_sym_LT_LT_EQ] = ACTIONS(5729),
    [anon_sym_GT_GT_EQ] = ACTIONS(5729),
    [anon_sym_AMP_EQ] = ACTIONS(5729),
    [anon_sym_CARET_EQ] = ACTIONS(5729),
    [anon_sym_PIPE_EQ] = ACTIONS(5729),
    [anon_sym_and_eq] = ACTIONS(5731),
    [anon_sym_or_eq] = ACTIONS(5731),
    [anon_sym_xor_eq] = ACTIONS(5731),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
  },
  [2304] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2311),
    [sym_identifier] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RPAREN] = ACTIONS(5886),
    [anon_sym_LPAREN2] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5886),
    [anon_sym_STAR] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_COLON] = ACTIONS(5884),
    [anon_sym_SEMI] = ACTIONS(5886),
    [anon_sym___extension__] = ACTIONS(5884),
    [anon_sym_in] = ACTIONS(5884),
    [anon_sym_out] = ACTIONS(5884),
    [anon_sym_inout] = ACTIONS(5884),
    [anon_sym_virtual] = ACTIONS(5884),
    [anon_sym_extern] = ACTIONS(5884),
    [anon_sym___attribute__] = ACTIONS(5884),
    [anon_sym___attribute] = ACTIONS(5884),
    [anon_sym_COLON_COLON] = ACTIONS(5886),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5886),
    [anon_sym___declspec] = ACTIONS(5884),
    [anon_sym___based] = ACTIONS(5884),
    [anon_sym___cdecl] = ACTIONS(5884),
    [anon_sym___clrcall] = ACTIONS(5884),
    [anon_sym___stdcall] = ACTIONS(5884),
    [anon_sym___fastcall] = ACTIONS(5884),
    [anon_sym___thiscall] = ACTIONS(5884),
    [anon_sym___vectorcall] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(5888),
    [anon_sym_unsigned] = ACTIONS(5888),
    [anon_sym_long] = ACTIONS(5888),
    [anon_sym_short] = ACTIONS(5888),
    [anon_sym_LBRACK] = ACTIONS(5884),
    [anon_sym_static] = ACTIONS(5884),
    [anon_sym_EQ] = ACTIONS(5886),
    [anon_sym_register] = ACTIONS(5884),
    [anon_sym_inline] = ACTIONS(5884),
    [anon_sym___inline] = ACTIONS(5884),
    [anon_sym___inline__] = ACTIONS(5884),
    [anon_sym___forceinline] = ACTIONS(5884),
    [anon_sym_thread_local] = ACTIONS(5884),
    [anon_sym___thread] = ACTIONS(5884),
    [anon_sym_const] = ACTIONS(5884),
    [anon_sym_constexpr] = ACTIONS(5884),
    [anon_sym_volatile] = ACTIONS(5884),
    [anon_sym_restrict] = ACTIONS(5884),
    [anon_sym___restrict__] = ACTIONS(5884),
    [anon_sym__Atomic] = ACTIONS(5884),
    [anon_sym__Noreturn] = ACTIONS(5884),
    [anon_sym_noreturn] = ACTIONS(5884),
    [anon_sym__Nonnull] = ACTIONS(5884),
    [anon_sym_mutable] = ACTIONS(5884),
    [anon_sym_constinit] = ACTIONS(5884),
    [anon_sym_consteval] = ACTIONS(5884),
    [anon_sym_alignas] = ACTIONS(5884),
    [anon_sym__Alignas] = ACTIONS(5884),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5884),
    [anon_sym_decltype] = ACTIONS(5884),
    [anon_sym_template] = ACTIONS(5884),
    [anon_sym_GT2] = ACTIONS(5886),
    [anon_sym_operator] = ACTIONS(5884),
    [anon_sym_precise] = ACTIONS(5884),
    [anon_sym_shared] = ACTIONS(5884),
    [anon_sym_groupshared] = ACTIONS(5884),
    [anon_sym_uniform] = ACTIONS(5884),
    [anon_sym_row_major] = ACTIONS(5884),
    [anon_sym_column_major] = ACTIONS(5884),
    [anon_sym_globallycoherent] = ACTIONS(5884),
    [anon_sym_centroid] = ACTIONS(5884),
    [anon_sym_noperspective] = ACTIONS(5884),
    [anon_sym_nointerpolation] = ACTIONS(5884),
    [anon_sym_sample] = ACTIONS(5884),
    [anon_sym_linear] = ACTIONS(5884),
    [anon_sym_snorm] = ACTIONS(5884),
    [anon_sym_unorm] = ACTIONS(5884),
    [anon_sym_point] = ACTIONS(5884),
    [anon_sym_line] = ACTIONS(5884),
    [anon_sym_triangleadj] = ACTIONS(5884),
    [anon_sym_lineadj] = ACTIONS(5884),
    [anon_sym_triangle] = ACTIONS(5884),
  },
  [2305] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_RPAREN] = ACTIONS(5892),
    [anon_sym_LPAREN2] = ACTIONS(5892),
    [anon_sym_TILDE] = ACTIONS(5892),
    [anon_sym_STAR] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5892),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5890),
    [anon_sym_SEMI] = ACTIONS(5892),
    [anon_sym___extension__] = ACTIONS(5890),
    [anon_sym_in] = ACTIONS(5890),
    [anon_sym_out] = ACTIONS(5890),
    [anon_sym_inout] = ACTIONS(5890),
    [anon_sym_virtual] = ACTIONS(5890),
    [anon_sym_extern] = ACTIONS(5890),
    [anon_sym___attribute__] = ACTIONS(5890),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_COLON_COLON] = ACTIONS(5892),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5892),
    [anon_sym___declspec] = ACTIONS(5890),
    [anon_sym___based] = ACTIONS(5890),
    [anon_sym___cdecl] = ACTIONS(5890),
    [anon_sym___clrcall] = ACTIONS(5890),
    [anon_sym___stdcall] = ACTIONS(5890),
    [anon_sym___fastcall] = ACTIONS(5890),
    [anon_sym___thiscall] = ACTIONS(5890),
    [anon_sym___vectorcall] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5890),
    [anon_sym_static] = ACTIONS(5890),
    [anon_sym_EQ] = ACTIONS(5892),
    [anon_sym_register] = ACTIONS(5890),
    [anon_sym_inline] = ACTIONS(5890),
    [anon_sym___inline] = ACTIONS(5890),
    [anon_sym___inline__] = ACTIONS(5890),
    [anon_sym___forceinline] = ACTIONS(5890),
    [anon_sym_thread_local] = ACTIONS(5890),
    [anon_sym___thread] = ACTIONS(5890),
    [anon_sym_const] = ACTIONS(5890),
    [anon_sym_constexpr] = ACTIONS(5890),
    [anon_sym_volatile] = ACTIONS(5890),
    [anon_sym_restrict] = ACTIONS(5890),
    [anon_sym___restrict__] = ACTIONS(5890),
    [anon_sym__Atomic] = ACTIONS(5890),
    [anon_sym__Noreturn] = ACTIONS(5890),
    [anon_sym_noreturn] = ACTIONS(5890),
    [anon_sym__Nonnull] = ACTIONS(5890),
    [anon_sym_mutable] = ACTIONS(5890),
    [anon_sym_constinit] = ACTIONS(5890),
    [anon_sym_consteval] = ACTIONS(5890),
    [anon_sym_alignas] = ACTIONS(5890),
    [anon_sym__Alignas] = ACTIONS(5890),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5890),
    [anon_sym_decltype] = ACTIONS(5890),
    [anon_sym_template] = ACTIONS(5890),
    [anon_sym_GT2] = ACTIONS(5892),
    [anon_sym_operator] = ACTIONS(5890),
    [anon_sym_precise] = ACTIONS(5890),
    [anon_sym_shared] = ACTIONS(5890),
    [anon_sym_groupshared] = ACTIONS(5890),
    [anon_sym_uniform] = ACTIONS(5890),
    [anon_sym_row_major] = ACTIONS(5890),
    [anon_sym_column_major] = ACTIONS(5890),
    [anon_sym_globallycoherent] = ACTIONS(5890),
    [anon_sym_centroid] = ACTIONS(5890),
    [anon_sym_noperspective] = ACTIONS(5890),
    [anon_sym_nointerpolation] = ACTIONS(5890),
    [anon_sym_sample] = ACTIONS(5890),
    [anon_sym_linear] = ACTIONS(5890),
    [anon_sym_snorm] = ACTIONS(5890),
    [anon_sym_unorm] = ACTIONS(5890),
    [anon_sym_point] = ACTIONS(5890),
    [anon_sym_line] = ACTIONS(5890),
    [anon_sym_triangleadj] = ACTIONS(5890),
    [anon_sym_lineadj] = ACTIONS(5890),
    [anon_sym_triangle] = ACTIONS(5890),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [aux_sym_preproc_if_token2] = ACTIONS(1989),
    [aux_sym_preproc_else_token1] = ACTIONS(1989),
    [aux_sym_preproc_elif_token1] = ACTIONS(1987),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1989),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_and_eq] = ACTIONS(1987),
    [anon_sym_or_eq] = ACTIONS(1987),
    [anon_sym_xor_eq] = ACTIONS(1987),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
  },
  [2307] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2317),
    [sym_identifier] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_TILDE] = ACTIONS(5898),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5896),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___extension__] = ACTIONS(5896),
    [anon_sym_in] = ACTIONS(5896),
    [anon_sym_out] = ACTIONS(5896),
    [anon_sym_inout] = ACTIONS(5896),
    [anon_sym_virtual] = ACTIONS(5896),
    [anon_sym_extern] = ACTIONS(5896),
    [anon_sym___attribute__] = ACTIONS(5896),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_COLON_COLON] = ACTIONS(5898),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5898),
    [anon_sym___declspec] = ACTIONS(5896),
    [anon_sym___based] = ACTIONS(5896),
    [anon_sym___cdecl] = ACTIONS(5896),
    [anon_sym___clrcall] = ACTIONS(5896),
    [anon_sym___stdcall] = ACTIONS(5896),
    [anon_sym___fastcall] = ACTIONS(5896),
    [anon_sym___thiscall] = ACTIONS(5896),
    [anon_sym___vectorcall] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(5900),
    [anon_sym_unsigned] = ACTIONS(5900),
    [anon_sym_long] = ACTIONS(5900),
    [anon_sym_short] = ACTIONS(5900),
    [anon_sym_LBRACK] = ACTIONS(5896),
    [anon_sym_static] = ACTIONS(5896),
    [anon_sym_EQ] = ACTIONS(5898),
    [anon_sym_register] = ACTIONS(5896),
    [anon_sym_inline] = ACTIONS(5896),
    [anon_sym___inline] = ACTIONS(5896),
    [anon_sym___inline__] = ACTIONS(5896),
    [anon_sym___forceinline] = ACTIONS(5896),
    [anon_sym_thread_local] = ACTIONS(5896),
    [anon_sym___thread] = ACTIONS(5896),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5896),
    [anon_sym_volatile] = ACTIONS(5896),
    [anon_sym_restrict] = ACTIONS(5896),
    [anon_sym___restrict__] = ACTIONS(5896),
    [anon_sym__Atomic] = ACTIONS(5896),
    [anon_sym__Noreturn] = ACTIONS(5896),
    [anon_sym_noreturn] = ACTIONS(5896),
    [anon_sym__Nonnull] = ACTIONS(5896),
    [anon_sym_mutable] = ACTIONS(5896),
    [anon_sym_constinit] = ACTIONS(5896),
    [anon_sym_consteval] = ACTIONS(5896),
    [anon_sym_alignas] = ACTIONS(5896),
    [anon_sym__Alignas] = ACTIONS(5896),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5896),
    [anon_sym_decltype] = ACTIONS(5896),
    [anon_sym_template] = ACTIONS(5896),
    [anon_sym_GT2] = ACTIONS(5898),
    [anon_sym_operator] = ACTIONS(5896),
    [anon_sym_precise] = ACTIONS(5896),
    [anon_sym_shared] = ACTIONS(5896),
    [anon_sym_groupshared] = ACTIONS(5896),
    [anon_sym_uniform] = ACTIONS(5896),
    [anon_sym_row_major] = ACTIONS(5896),
    [anon_sym_column_major] = ACTIONS(5896),
    [anon_sym_globallycoherent] = ACTIONS(5896),
    [anon_sym_centroid] = ACTIONS(5896),
    [anon_sym_noperspective] = ACTIONS(5896),
    [anon_sym_nointerpolation] = ACTIONS(5896),
    [anon_sym_sample] = ACTIONS(5896),
    [anon_sym_linear] = ACTIONS(5896),
    [anon_sym_snorm] = ACTIONS(5896),
    [anon_sym_unorm] = ACTIONS(5896),
    [anon_sym_point] = ACTIONS(5896),
    [anon_sym_line] = ACTIONS(5896),
    [anon_sym_triangleadj] = ACTIONS(5896),
    [anon_sym_lineadj] = ACTIONS(5896),
    [anon_sym_triangle] = ACTIONS(5896),
  },
  [2308] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [aux_sym_preproc_if_token2] = ACTIONS(1985),
    [aux_sym_preproc_else_token1] = ACTIONS(1985),
    [aux_sym_preproc_elif_token1] = ACTIONS(1983),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1985),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_and_eq] = ACTIONS(1983),
    [anon_sym_or_eq] = ACTIONS(1983),
    [anon_sym_xor_eq] = ACTIONS(1983),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
  },
  [2309] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [aux_sym_preproc_if_token2] = ACTIONS(1973),
    [aux_sym_preproc_else_token1] = ACTIONS(1973),
    [aux_sym_preproc_elif_token1] = ACTIONS(1971),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1973),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_RBRACK] = ACTIONS(1973),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1973),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_and_eq] = ACTIONS(1971),
    [anon_sym_or_eq] = ACTIONS(1971),
    [anon_sym_xor_eq] = ACTIONS(1971),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
  },
  [2310] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [sym_identifier] = ACTIONS(5902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5902),
    [anon_sym_in] = ACTIONS(5902),
    [anon_sym_out] = ACTIONS(5902),
    [anon_sym_inout] = ACTIONS(5902),
    [anon_sym_virtual] = ACTIONS(5902),
    [anon_sym_extern] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_COLON_COLON] = ACTIONS(5904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5904),
    [anon_sym___declspec] = ACTIONS(5902),
    [anon_sym___based] = ACTIONS(5902),
    [anon_sym___cdecl] = ACTIONS(5902),
    [anon_sym___clrcall] = ACTIONS(5902),
    [anon_sym___stdcall] = ACTIONS(5902),
    [anon_sym___fastcall] = ACTIONS(5902),
    [anon_sym___thiscall] = ACTIONS(5902),
    [anon_sym___vectorcall] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(5864),
    [anon_sym_unsigned] = ACTIONS(5864),
    [anon_sym_long] = ACTIONS(5864),
    [anon_sym_short] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_static] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_register] = ACTIONS(5902),
    [anon_sym_inline] = ACTIONS(5902),
    [anon_sym___inline] = ACTIONS(5902),
    [anon_sym___inline__] = ACTIONS(5902),
    [anon_sym___forceinline] = ACTIONS(5902),
    [anon_sym_thread_local] = ACTIONS(5902),
    [anon_sym___thread] = ACTIONS(5902),
    [anon_sym_const] = ACTIONS(5902),
    [anon_sym_constexpr] = ACTIONS(5902),
    [anon_sym_volatile] = ACTIONS(5902),
    [anon_sym_restrict] = ACTIONS(5902),
    [anon_sym___restrict__] = ACTIONS(5902),
    [anon_sym__Atomic] = ACTIONS(5902),
    [anon_sym__Noreturn] = ACTIONS(5902),
    [anon_sym_noreturn] = ACTIONS(5902),
    [anon_sym__Nonnull] = ACTIONS(5902),
    [anon_sym_mutable] = ACTIONS(5902),
    [anon_sym_constinit] = ACTIONS(5902),
    [anon_sym_consteval] = ACTIONS(5902),
    [anon_sym_alignas] = ACTIONS(5902),
    [anon_sym__Alignas] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
    [anon_sym_template] = ACTIONS(5902),
    [anon_sym_GT2] = ACTIONS(5904),
    [anon_sym_operator] = ACTIONS(5902),
    [anon_sym_precise] = ACTIONS(5902),
    [anon_sym_shared] = ACTIONS(5902),
    [anon_sym_groupshared] = ACTIONS(5902),
    [anon_sym_uniform] = ACTIONS(5902),
    [anon_sym_row_major] = ACTIONS(5902),
    [anon_sym_column_major] = ACTIONS(5902),
    [anon_sym_globallycoherent] = ACTIONS(5902),
    [anon_sym_centroid] = ACTIONS(5902),
    [anon_sym_noperspective] = ACTIONS(5902),
    [anon_sym_nointerpolation] = ACTIONS(5902),
    [anon_sym_sample] = ACTIONS(5902),
    [anon_sym_linear] = ACTIONS(5902),
    [anon_sym_snorm] = ACTIONS(5902),
    [anon_sym_unorm] = ACTIONS(5902),
    [anon_sym_point] = ACTIONS(5902),
    [anon_sym_line] = ACTIONS(5902),
    [anon_sym_triangleadj] = ACTIONS(5902),
    [anon_sym_lineadj] = ACTIONS(5902),
    [anon_sym_triangle] = ACTIONS(5902),
  },
  [2311] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_TILDE] = ACTIONS(5908),
    [anon_sym_STAR] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5906),
    [anon_sym_COLON] = ACTIONS(5906),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___extension__] = ACTIONS(5906),
    [anon_sym_in] = ACTIONS(5906),
    [anon_sym_out] = ACTIONS(5906),
    [anon_sym_inout] = ACTIONS(5906),
    [anon_sym_virtual] = ACTIONS(5906),
    [anon_sym_extern] = ACTIONS(5906),
    [anon_sym___attribute__] = ACTIONS(5906),
    [anon_sym___attribute] = ACTIONS(5906),
    [anon_sym_COLON_COLON] = ACTIONS(5908),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5908),
    [anon_sym___declspec] = ACTIONS(5906),
    [anon_sym___based] = ACTIONS(5906),
    [anon_sym___cdecl] = ACTIONS(5906),
    [anon_sym___clrcall] = ACTIONS(5906),
    [anon_sym___stdcall] = ACTIONS(5906),
    [anon_sym___fastcall] = ACTIONS(5906),
    [anon_sym___thiscall] = ACTIONS(5906),
    [anon_sym___vectorcall] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5906),
    [anon_sym_static] = ACTIONS(5906),
    [anon_sym_EQ] = ACTIONS(5908),
    [anon_sym_register] = ACTIONS(5906),
    [anon_sym_inline] = ACTIONS(5906),
    [anon_sym___inline] = ACTIONS(5906),
    [anon_sym___inline__] = ACTIONS(5906),
    [anon_sym___forceinline] = ACTIONS(5906),
    [anon_sym_thread_local] = ACTIONS(5906),
    [anon_sym___thread] = ACTIONS(5906),
    [anon_sym_const] = ACTIONS(5906),
    [anon_sym_constexpr] = ACTIONS(5906),
    [anon_sym_volatile] = ACTIONS(5906),
    [anon_sym_restrict] = ACTIONS(5906),
    [anon_sym___restrict__] = ACTIONS(5906),
    [anon_sym__Atomic] = ACTIONS(5906),
    [anon_sym__Noreturn] = ACTIONS(5906),
    [anon_sym_noreturn] = ACTIONS(5906),
    [anon_sym__Nonnull] = ACTIONS(5906),
    [anon_sym_mutable] = ACTIONS(5906),
    [anon_sym_constinit] = ACTIONS(5906),
    [anon_sym_consteval] = ACTIONS(5906),
    [anon_sym_alignas] = ACTIONS(5906),
    [anon_sym__Alignas] = ACTIONS(5906),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5906),
    [anon_sym_decltype] = ACTIONS(5906),
    [anon_sym_template] = ACTIONS(5906),
    [anon_sym_GT2] = ACTIONS(5908),
    [anon_sym_operator] = ACTIONS(5906),
    [anon_sym_precise] = ACTIONS(5906),
    [anon_sym_shared] = ACTIONS(5906),
    [anon_sym_groupshared] = ACTIONS(5906),
    [anon_sym_uniform] = ACTIONS(5906),
    [anon_sym_row_major] = ACTIONS(5906),
    [anon_sym_column_major] = ACTIONS(5906),
    [anon_sym_globallycoherent] = ACTIONS(5906),
    [anon_sym_centroid] = ACTIONS(5906),
    [anon_sym_noperspective] = ACTIONS(5906),
    [anon_sym_nointerpolation] = ACTIONS(5906),
    [anon_sym_sample] = ACTIONS(5906),
    [anon_sym_linear] = ACTIONS(5906),
    [anon_sym_snorm] = ACTIONS(5906),
    [anon_sym_unorm] = ACTIONS(5906),
    [anon_sym_point] = ACTIONS(5906),
    [anon_sym_line] = ACTIONS(5906),
    [anon_sym_triangleadj] = ACTIONS(5906),
    [anon_sym_lineadj] = ACTIONS(5906),
    [anon_sym_triangle] = ACTIONS(5906),
  },
  [2312] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [aux_sym_preproc_if_token2] = ACTIONS(1993),
    [aux_sym_preproc_else_token1] = ACTIONS(1993),
    [aux_sym_preproc_elif_token1] = ACTIONS(1991),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1993),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_RBRACK] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1993),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_and_eq] = ACTIONS(1991),
    [anon_sym_or_eq] = ACTIONS(1991),
    [anon_sym_xor_eq] = ACTIONS(1991),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
  },
  [2313] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_TILDE] = ACTIONS(5745),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5743),
    [anon_sym_SEMI] = ACTIONS(5745),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym_in] = ACTIONS(5743),
    [anon_sym_out] = ACTIONS(5743),
    [anon_sym_inout] = ACTIONS(5743),
    [anon_sym_virtual] = ACTIONS(5743),
    [anon_sym_extern] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_COLON_COLON] = ACTIONS(5745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5745),
    [anon_sym___declspec] = ACTIONS(5743),
    [anon_sym___based] = ACTIONS(5743),
    [anon_sym___cdecl] = ACTIONS(5743),
    [anon_sym___clrcall] = ACTIONS(5743),
    [anon_sym___stdcall] = ACTIONS(5743),
    [anon_sym___fastcall] = ACTIONS(5743),
    [anon_sym___thiscall] = ACTIONS(5743),
    [anon_sym___vectorcall] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(5910),
    [anon_sym_unsigned] = ACTIONS(5910),
    [anon_sym_long] = ACTIONS(5910),
    [anon_sym_short] = ACTIONS(5910),
    [anon_sym_LBRACK] = ACTIONS(5743),
    [anon_sym_static] = ACTIONS(5743),
    [anon_sym_EQ] = ACTIONS(5745),
    [anon_sym_register] = ACTIONS(5743),
    [anon_sym_inline] = ACTIONS(5743),
    [anon_sym___inline] = ACTIONS(5743),
    [anon_sym___inline__] = ACTIONS(5743),
    [anon_sym___forceinline] = ACTIONS(5743),
    [anon_sym_thread_local] = ACTIONS(5743),
    [anon_sym___thread] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_template] = ACTIONS(5743),
    [anon_sym_GT2] = ACTIONS(5745),
    [anon_sym_operator] = ACTIONS(5743),
    [anon_sym_precise] = ACTIONS(5743),
    [anon_sym_shared] = ACTIONS(5743),
    [anon_sym_groupshared] = ACTIONS(5743),
    [anon_sym_uniform] = ACTIONS(5743),
    [anon_sym_row_major] = ACTIONS(5743),
    [anon_sym_column_major] = ACTIONS(5743),
    [anon_sym_globallycoherent] = ACTIONS(5743),
    [anon_sym_centroid] = ACTIONS(5743),
    [anon_sym_noperspective] = ACTIONS(5743),
    [anon_sym_nointerpolation] = ACTIONS(5743),
    [anon_sym_sample] = ACTIONS(5743),
    [anon_sym_linear] = ACTIONS(5743),
    [anon_sym_snorm] = ACTIONS(5743),
    [anon_sym_unorm] = ACTIONS(5743),
    [anon_sym_point] = ACTIONS(5743),
    [anon_sym_line] = ACTIONS(5743),
    [anon_sym_triangleadj] = ACTIONS(5743),
    [anon_sym_lineadj] = ACTIONS(5743),
    [anon_sym_triangle] = ACTIONS(5743),
  },
  [2314] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_TILDE] = ACTIONS(5915),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_COLON] = ACTIONS(5913),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym___extension__] = ACTIONS(5913),
    [anon_sym_in] = ACTIONS(5913),
    [anon_sym_out] = ACTIONS(5913),
    [anon_sym_inout] = ACTIONS(5913),
    [anon_sym_virtual] = ACTIONS(5913),
    [anon_sym_extern] = ACTIONS(5913),
    [anon_sym___attribute__] = ACTIONS(5913),
    [anon_sym___attribute] = ACTIONS(5913),
    [anon_sym_COLON_COLON] = ACTIONS(5915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5915),
    [anon_sym___declspec] = ACTIONS(5913),
    [anon_sym___based] = ACTIONS(5913),
    [anon_sym___cdecl] = ACTIONS(5913),
    [anon_sym___clrcall] = ACTIONS(5913),
    [anon_sym___stdcall] = ACTIONS(5913),
    [anon_sym___fastcall] = ACTIONS(5913),
    [anon_sym___thiscall] = ACTIONS(5913),
    [anon_sym___vectorcall] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5913),
    [anon_sym_static] = ACTIONS(5913),
    [anon_sym_EQ] = ACTIONS(5915),
    [anon_sym_register] = ACTIONS(5913),
    [anon_sym_inline] = ACTIONS(5913),
    [anon_sym___inline] = ACTIONS(5913),
    [anon_sym___inline__] = ACTIONS(5913),
    [anon_sym___forceinline] = ACTIONS(5913),
    [anon_sym_thread_local] = ACTIONS(5913),
    [anon_sym___thread] = ACTIONS(5913),
    [anon_sym_const] = ACTIONS(5913),
    [anon_sym_constexpr] = ACTIONS(5913),
    [anon_sym_volatile] = ACTIONS(5913),
    [anon_sym_restrict] = ACTIONS(5913),
    [anon_sym___restrict__] = ACTIONS(5913),
    [anon_sym__Atomic] = ACTIONS(5913),
    [anon_sym__Noreturn] = ACTIONS(5913),
    [anon_sym_noreturn] = ACTIONS(5913),
    [anon_sym__Nonnull] = ACTIONS(5913),
    [anon_sym_mutable] = ACTIONS(5913),
    [anon_sym_constinit] = ACTIONS(5913),
    [anon_sym_consteval] = ACTIONS(5913),
    [anon_sym_alignas] = ACTIONS(5913),
    [anon_sym__Alignas] = ACTIONS(5913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5913),
    [anon_sym_decltype] = ACTIONS(5913),
    [anon_sym_template] = ACTIONS(5913),
    [anon_sym_GT2] = ACTIONS(5915),
    [anon_sym_operator] = ACTIONS(5913),
    [anon_sym_precise] = ACTIONS(5913),
    [anon_sym_shared] = ACTIONS(5913),
    [anon_sym_groupshared] = ACTIONS(5913),
    [anon_sym_uniform] = ACTIONS(5913),
    [anon_sym_row_major] = ACTIONS(5913),
    [anon_sym_column_major] = ACTIONS(5913),
    [anon_sym_globallycoherent] = ACTIONS(5913),
    [anon_sym_centroid] = ACTIONS(5913),
    [anon_sym_noperspective] = ACTIONS(5913),
    [anon_sym_nointerpolation] = ACTIONS(5913),
    [anon_sym_sample] = ACTIONS(5913),
    [anon_sym_linear] = ACTIONS(5913),
    [anon_sym_snorm] = ACTIONS(5913),
    [anon_sym_unorm] = ACTIONS(5913),
    [anon_sym_point] = ACTIONS(5913),
    [anon_sym_line] = ACTIONS(5913),
    [anon_sym_triangleadj] = ACTIONS(5913),
    [anon_sym_lineadj] = ACTIONS(5913),
    [anon_sym_triangle] = ACTIONS(5913),
  },
  [2315] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_RPAREN] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_TILDE] = ACTIONS(5919),
    [anon_sym_STAR] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_COLON] = ACTIONS(5917),
    [anon_sym_SEMI] = ACTIONS(5919),
    [anon_sym___extension__] = ACTIONS(5917),
    [anon_sym_in] = ACTIONS(5917),
    [anon_sym_out] = ACTIONS(5917),
    [anon_sym_inout] = ACTIONS(5917),
    [anon_sym_virtual] = ACTIONS(5917),
    [anon_sym_extern] = ACTIONS(5917),
    [anon_sym___attribute__] = ACTIONS(5917),
    [anon_sym___attribute] = ACTIONS(5917),
    [anon_sym_COLON_COLON] = ACTIONS(5919),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5919),
    [anon_sym___declspec] = ACTIONS(5917),
    [anon_sym___based] = ACTIONS(5917),
    [anon_sym___cdecl] = ACTIONS(5917),
    [anon_sym___clrcall] = ACTIONS(5917),
    [anon_sym___stdcall] = ACTIONS(5917),
    [anon_sym___fastcall] = ACTIONS(5917),
    [anon_sym___thiscall] = ACTIONS(5917),
    [anon_sym___vectorcall] = ACTIONS(5917),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5917),
    [anon_sym_static] = ACTIONS(5917),
    [anon_sym_EQ] = ACTIONS(5919),
    [anon_sym_register] = ACTIONS(5917),
    [anon_sym_inline] = ACTIONS(5917),
    [anon_sym___inline] = ACTIONS(5917),
    [anon_sym___inline__] = ACTIONS(5917),
    [anon_sym___forceinline] = ACTIONS(5917),
    [anon_sym_thread_local] = ACTIONS(5917),
    [anon_sym___thread] = ACTIONS(5917),
    [anon_sym_const] = ACTIONS(5917),
    [anon_sym_constexpr] = ACTIONS(5917),
    [anon_sym_volatile] = ACTIONS(5917),
    [anon_sym_restrict] = ACTIONS(5917),
    [anon_sym___restrict__] = ACTIONS(5917),
    [anon_sym__Atomic] = ACTIONS(5917),
    [anon_sym__Noreturn] = ACTIONS(5917),
    [anon_sym_noreturn] = ACTIONS(5917),
    [anon_sym__Nonnull] = ACTIONS(5917),
    [anon_sym_mutable] = ACTIONS(5917),
    [anon_sym_constinit] = ACTIONS(5917),
    [anon_sym_consteval] = ACTIONS(5917),
    [anon_sym_alignas] = ACTIONS(5917),
    [anon_sym__Alignas] = ACTIONS(5917),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5917),
    [anon_sym_decltype] = ACTIONS(5917),
    [anon_sym_template] = ACTIONS(5917),
    [anon_sym_GT2] = ACTIONS(5919),
    [anon_sym_operator] = ACTIONS(5917),
    [anon_sym_precise] = ACTIONS(5917),
    [anon_sym_shared] = ACTIONS(5917),
    [anon_sym_groupshared] = ACTIONS(5917),
    [anon_sym_uniform] = ACTIONS(5917),
    [anon_sym_row_major] = ACTIONS(5917),
    [anon_sym_column_major] = ACTIONS(5917),
    [anon_sym_globallycoherent] = ACTIONS(5917),
    [anon_sym_centroid] = ACTIONS(5917),
    [anon_sym_noperspective] = ACTIONS(5917),
    [anon_sym_nointerpolation] = ACTIONS(5917),
    [anon_sym_sample] = ACTIONS(5917),
    [anon_sym_linear] = ACTIONS(5917),
    [anon_sym_snorm] = ACTIONS(5917),
    [anon_sym_unorm] = ACTIONS(5917),
    [anon_sym_point] = ACTIONS(5917),
    [anon_sym_line] = ACTIONS(5917),
    [anon_sym_triangleadj] = ACTIONS(5917),
    [anon_sym_lineadj] = ACTIONS(5917),
    [anon_sym_triangle] = ACTIONS(5917),
  },
  [2316] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5923),
    [anon_sym_TILDE] = ACTIONS(5923),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_COLON] = ACTIONS(5921),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym___extension__] = ACTIONS(5921),
    [anon_sym_in] = ACTIONS(5921),
    [anon_sym_out] = ACTIONS(5921),
    [anon_sym_inout] = ACTIONS(5921),
    [anon_sym_virtual] = ACTIONS(5921),
    [anon_sym_extern] = ACTIONS(5921),
    [anon_sym___attribute__] = ACTIONS(5921),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_COLON_COLON] = ACTIONS(5923),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5923),
    [anon_sym___declspec] = ACTIONS(5921),
    [anon_sym___based] = ACTIONS(5921),
    [anon_sym___cdecl] = ACTIONS(5921),
    [anon_sym___clrcall] = ACTIONS(5921),
    [anon_sym___stdcall] = ACTIONS(5921),
    [anon_sym___fastcall] = ACTIONS(5921),
    [anon_sym___thiscall] = ACTIONS(5921),
    [anon_sym___vectorcall] = ACTIONS(5921),
    [anon_sym_LBRACE] = ACTIONS(5923),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5921),
    [anon_sym_static] = ACTIONS(5921),
    [anon_sym_EQ] = ACTIONS(5923),
    [anon_sym_register] = ACTIONS(5921),
    [anon_sym_inline] = ACTIONS(5921),
    [anon_sym___inline] = ACTIONS(5921),
    [anon_sym___inline__] = ACTIONS(5921),
    [anon_sym___forceinline] = ACTIONS(5921),
    [anon_sym_thread_local] = ACTIONS(5921),
    [anon_sym___thread] = ACTIONS(5921),
    [anon_sym_const] = ACTIONS(5921),
    [anon_sym_constexpr] = ACTIONS(5921),
    [anon_sym_volatile] = ACTIONS(5921),
    [anon_sym_restrict] = ACTIONS(5921),
    [anon_sym___restrict__] = ACTIONS(5921),
    [anon_sym__Atomic] = ACTIONS(5921),
    [anon_sym__Noreturn] = ACTIONS(5921),
    [anon_sym_noreturn] = ACTIONS(5921),
    [anon_sym__Nonnull] = ACTIONS(5921),
    [anon_sym_mutable] = ACTIONS(5921),
    [anon_sym_constinit] = ACTIONS(5921),
    [anon_sym_consteval] = ACTIONS(5921),
    [anon_sym_alignas] = ACTIONS(5921),
    [anon_sym__Alignas] = ACTIONS(5921),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5921),
    [anon_sym_decltype] = ACTIONS(5921),
    [anon_sym_template] = ACTIONS(5921),
    [anon_sym_GT2] = ACTIONS(5923),
    [anon_sym_operator] = ACTIONS(5921),
    [anon_sym_precise] = ACTIONS(5921),
    [anon_sym_shared] = ACTIONS(5921),
    [anon_sym_groupshared] = ACTIONS(5921),
    [anon_sym_uniform] = ACTIONS(5921),
    [anon_sym_row_major] = ACTIONS(5921),
    [anon_sym_column_major] = ACTIONS(5921),
    [anon_sym_globallycoherent] = ACTIONS(5921),
    [anon_sym_centroid] = ACTIONS(5921),
    [anon_sym_noperspective] = ACTIONS(5921),
    [anon_sym_nointerpolation] = ACTIONS(5921),
    [anon_sym_sample] = ACTIONS(5921),
    [anon_sym_linear] = ACTIONS(5921),
    [anon_sym_snorm] = ACTIONS(5921),
    [anon_sym_unorm] = ACTIONS(5921),
    [anon_sym_point] = ACTIONS(5921),
    [anon_sym_line] = ACTIONS(5921),
    [anon_sym_triangleadj] = ACTIONS(5921),
    [anon_sym_lineadj] = ACTIONS(5921),
    [anon_sym_triangle] = ACTIONS(5921),
  },
  [2317] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_TILDE] = ACTIONS(5927),
    [anon_sym_STAR] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym___extension__] = ACTIONS(5925),
    [anon_sym_in] = ACTIONS(5925),
    [anon_sym_out] = ACTIONS(5925),
    [anon_sym_inout] = ACTIONS(5925),
    [anon_sym_virtual] = ACTIONS(5925),
    [anon_sym_extern] = ACTIONS(5925),
    [anon_sym___attribute__] = ACTIONS(5925),
    [anon_sym___attribute] = ACTIONS(5925),
    [anon_sym_COLON_COLON] = ACTIONS(5927),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5927),
    [anon_sym___declspec] = ACTIONS(5925),
    [anon_sym___based] = ACTIONS(5925),
    [anon_sym___cdecl] = ACTIONS(5925),
    [anon_sym___clrcall] = ACTIONS(5925),
    [anon_sym___stdcall] = ACTIONS(5925),
    [anon_sym___fastcall] = ACTIONS(5925),
    [anon_sym___thiscall] = ACTIONS(5925),
    [anon_sym___vectorcall] = ACTIONS(5925),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5925),
    [anon_sym_static] = ACTIONS(5925),
    [anon_sym_EQ] = ACTIONS(5927),
    [anon_sym_register] = ACTIONS(5925),
    [anon_sym_inline] = ACTIONS(5925),
    [anon_sym___inline] = ACTIONS(5925),
    [anon_sym___inline__] = ACTIONS(5925),
    [anon_sym___forceinline] = ACTIONS(5925),
    [anon_sym_thread_local] = ACTIONS(5925),
    [anon_sym___thread] = ACTIONS(5925),
    [anon_sym_const] = ACTIONS(5925),
    [anon_sym_constexpr] = ACTIONS(5925),
    [anon_sym_volatile] = ACTIONS(5925),
    [anon_sym_restrict] = ACTIONS(5925),
    [anon_sym___restrict__] = ACTIONS(5925),
    [anon_sym__Atomic] = ACTIONS(5925),
    [anon_sym__Noreturn] = ACTIONS(5925),
    [anon_sym_noreturn] = ACTIONS(5925),
    [anon_sym__Nonnull] = ACTIONS(5925),
    [anon_sym_mutable] = ACTIONS(5925),
    [anon_sym_constinit] = ACTIONS(5925),
    [anon_sym_consteval] = ACTIONS(5925),
    [anon_sym_alignas] = ACTIONS(5925),
    [anon_sym__Alignas] = ACTIONS(5925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5925),
    [anon_sym_decltype] = ACTIONS(5925),
    [anon_sym_template] = ACTIONS(5925),
    [anon_sym_GT2] = ACTIONS(5927),
    [anon_sym_operator] = ACTIONS(5925),
    [anon_sym_precise] = ACTIONS(5925),
    [anon_sym_shared] = ACTIONS(5925),
    [anon_sym_groupshared] = ACTIONS(5925),
    [anon_sym_uniform] = ACTIONS(5925),
    [anon_sym_row_major] = ACTIONS(5925),
    [anon_sym_column_major] = ACTIONS(5925),
    [anon_sym_globallycoherent] = ACTIONS(5925),
    [anon_sym_centroid] = ACTIONS(5925),
    [anon_sym_noperspective] = ACTIONS(5925),
    [anon_sym_nointerpolation] = ACTIONS(5925),
    [anon_sym_sample] = ACTIONS(5925),
    [anon_sym_linear] = ACTIONS(5925),
    [anon_sym_snorm] = ACTIONS(5925),
    [anon_sym_unorm] = ACTIONS(5925),
    [anon_sym_point] = ACTIONS(5925),
    [anon_sym_line] = ACTIONS(5925),
    [anon_sym_triangleadj] = ACTIONS(5925),
    [anon_sym_lineadj] = ACTIONS(5925),
    [anon_sym_triangle] = ACTIONS(5925),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [aux_sym_preproc_if_token2] = ACTIONS(1955),
    [aux_sym_preproc_else_token1] = ACTIONS(1955),
    [aux_sym_preproc_elif_token1] = ACTIONS(1953),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1955),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_RBRACK] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1955),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_and_eq] = ACTIONS(1953),
    [anon_sym_or_eq] = ACTIONS(1953),
    [anon_sym_xor_eq] = ACTIONS(1953),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
  },
  [2319] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2316),
    [sym_identifier] = ACTIONS(5929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5931),
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_RPAREN] = ACTIONS(5931),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_TILDE] = ACTIONS(5931),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5931),
    [anon_sym_AMP] = ACTIONS(5929),
    [anon_sym_COLON] = ACTIONS(5929),
    [anon_sym_SEMI] = ACTIONS(5931),
    [anon_sym___extension__] = ACTIONS(5929),
    [anon_sym_in] = ACTIONS(5929),
    [anon_sym_out] = ACTIONS(5929),
    [anon_sym_inout] = ACTIONS(5929),
    [anon_sym_virtual] = ACTIONS(5929),
    [anon_sym_extern] = ACTIONS(5929),
    [anon_sym___attribute__] = ACTIONS(5929),
    [anon_sym___attribute] = ACTIONS(5929),
    [anon_sym_COLON_COLON] = ACTIONS(5931),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5931),
    [anon_sym___declspec] = ACTIONS(5929),
    [anon_sym___based] = ACTIONS(5929),
    [anon_sym___cdecl] = ACTIONS(5929),
    [anon_sym___clrcall] = ACTIONS(5929),
    [anon_sym___stdcall] = ACTIONS(5929),
    [anon_sym___fastcall] = ACTIONS(5929),
    [anon_sym___thiscall] = ACTIONS(5929),
    [anon_sym___vectorcall] = ACTIONS(5929),
    [anon_sym_LBRACE] = ACTIONS(5931),
    [anon_sym_signed] = ACTIONS(5933),
    [anon_sym_unsigned] = ACTIONS(5933),
    [anon_sym_long] = ACTIONS(5933),
    [anon_sym_short] = ACTIONS(5933),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_static] = ACTIONS(5929),
    [anon_sym_EQ] = ACTIONS(5931),
    [anon_sym_register] = ACTIONS(5929),
    [anon_sym_inline] = ACTIONS(5929),
    [anon_sym___inline] = ACTIONS(5929),
    [anon_sym___inline__] = ACTIONS(5929),
    [anon_sym___forceinline] = ACTIONS(5929),
    [anon_sym_thread_local] = ACTIONS(5929),
    [anon_sym___thread] = ACTIONS(5929),
    [anon_sym_const] = ACTIONS(5929),
    [anon_sym_constexpr] = ACTIONS(5929),
    [anon_sym_volatile] = ACTIONS(5929),
    [anon_sym_restrict] = ACTIONS(5929),
    [anon_sym___restrict__] = ACTIONS(5929),
    [anon_sym__Atomic] = ACTIONS(5929),
    [anon_sym__Noreturn] = ACTIONS(5929),
    [anon_sym_noreturn] = ACTIONS(5929),
    [anon_sym__Nonnull] = ACTIONS(5929),
    [anon_sym_mutable] = ACTIONS(5929),
    [anon_sym_constinit] = ACTIONS(5929),
    [anon_sym_consteval] = ACTIONS(5929),
    [anon_sym_alignas] = ACTIONS(5929),
    [anon_sym__Alignas] = ACTIONS(5929),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5929),
    [anon_sym_decltype] = ACTIONS(5929),
    [anon_sym_template] = ACTIONS(5929),
    [anon_sym_GT2] = ACTIONS(5931),
    [anon_sym_operator] = ACTIONS(5929),
    [anon_sym_precise] = ACTIONS(5929),
    [anon_sym_shared] = ACTIONS(5929),
    [anon_sym_groupshared] = ACTIONS(5929),
    [anon_sym_uniform] = ACTIONS(5929),
    [anon_sym_row_major] = ACTIONS(5929),
    [anon_sym_column_major] = ACTIONS(5929),
    [anon_sym_globallycoherent] = ACTIONS(5929),
    [anon_sym_centroid] = ACTIONS(5929),
    [anon_sym_noperspective] = ACTIONS(5929),
    [anon_sym_nointerpolation] = ACTIONS(5929),
    [anon_sym_sample] = ACTIONS(5929),
    [anon_sym_linear] = ACTIONS(5929),
    [anon_sym_snorm] = ACTIONS(5929),
    [anon_sym_unorm] = ACTIONS(5929),
    [anon_sym_point] = ACTIONS(5929),
    [anon_sym_line] = ACTIONS(5929),
    [anon_sym_triangleadj] = ACTIONS(5929),
    [anon_sym_lineadj] = ACTIONS(5929),
    [anon_sym_triangle] = ACTIONS(5929),
  },
  [2320] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2313),
    [sym_identifier] = ACTIONS(5935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5937),
    [anon_sym_LPAREN2] = ACTIONS(5937),
    [anon_sym_TILDE] = ACTIONS(5937),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_COLON] = ACTIONS(5935),
    [anon_sym_SEMI] = ACTIONS(5937),
    [anon_sym___extension__] = ACTIONS(5935),
    [anon_sym_in] = ACTIONS(5935),
    [anon_sym_out] = ACTIONS(5935),
    [anon_sym_inout] = ACTIONS(5935),
    [anon_sym_virtual] = ACTIONS(5935),
    [anon_sym_extern] = ACTIONS(5935),
    [anon_sym___attribute__] = ACTIONS(5935),
    [anon_sym___attribute] = ACTIONS(5935),
    [anon_sym_COLON_COLON] = ACTIONS(5937),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5937),
    [anon_sym___declspec] = ACTIONS(5935),
    [anon_sym___based] = ACTIONS(5935),
    [anon_sym___cdecl] = ACTIONS(5935),
    [anon_sym___clrcall] = ACTIONS(5935),
    [anon_sym___stdcall] = ACTIONS(5935),
    [anon_sym___fastcall] = ACTIONS(5935),
    [anon_sym___thiscall] = ACTIONS(5935),
    [anon_sym___vectorcall] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(5894),
    [anon_sym_unsigned] = ACTIONS(5894),
    [anon_sym_long] = ACTIONS(5894),
    [anon_sym_short] = ACTIONS(5894),
    [anon_sym_LBRACK] = ACTIONS(5935),
    [anon_sym_static] = ACTIONS(5935),
    [anon_sym_EQ] = ACTIONS(5937),
    [anon_sym_register] = ACTIONS(5935),
    [anon_sym_inline] = ACTIONS(5935),
    [anon_sym___inline] = ACTIONS(5935),
    [anon_sym___inline__] = ACTIONS(5935),
    [anon_sym___forceinline] = ACTIONS(5935),
    [anon_sym_thread_local] = ACTIONS(5935),
    [anon_sym___thread] = ACTIONS(5935),
    [anon_sym_const] = ACTIONS(5935),
    [anon_sym_constexpr] = ACTIONS(5935),
    [anon_sym_volatile] = ACTIONS(5935),
    [anon_sym_restrict] = ACTIONS(5935),
    [anon_sym___restrict__] = ACTIONS(5935),
    [anon_sym__Atomic] = ACTIONS(5935),
    [anon_sym__Noreturn] = ACTIONS(5935),
    [anon_sym_noreturn] = ACTIONS(5935),
    [anon_sym__Nonnull] = ACTIONS(5935),
    [anon_sym_mutable] = ACTIONS(5935),
    [anon_sym_constinit] = ACTIONS(5935),
    [anon_sym_consteval] = ACTIONS(5935),
    [anon_sym_alignas] = ACTIONS(5935),
    [anon_sym__Alignas] = ACTIONS(5935),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5935),
    [anon_sym_decltype] = ACTIONS(5935),
    [anon_sym_template] = ACTIONS(5935),
    [anon_sym_GT2] = ACTIONS(5937),
    [anon_sym_operator] = ACTIONS(5935),
    [anon_sym_precise] = ACTIONS(5935),
    [anon_sym_shared] = ACTIONS(5935),
    [anon_sym_groupshared] = ACTIONS(5935),
    [anon_sym_uniform] = ACTIONS(5935),
    [anon_sym_row_major] = ACTIONS(5935),
    [anon_sym_column_major] = ACTIONS(5935),
    [anon_sym_globallycoherent] = ACTIONS(5935),
    [anon_sym_centroid] = ACTIONS(5935),
    [anon_sym_noperspective] = ACTIONS(5935),
    [anon_sym_nointerpolation] = ACTIONS(5935),
    [anon_sym_sample] = ACTIONS(5935),
    [anon_sym_linear] = ACTIONS(5935),
    [anon_sym_snorm] = ACTIONS(5935),
    [anon_sym_unorm] = ACTIONS(5935),
    [anon_sym_point] = ACTIONS(5935),
    [anon_sym_line] = ACTIONS(5935),
    [anon_sym_triangleadj] = ACTIONS(5935),
    [anon_sym_lineadj] = ACTIONS(5935),
    [anon_sym_triangle] = ACTIONS(5935),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [aux_sym_preproc_if_token2] = ACTIONS(1977),
    [aux_sym_preproc_else_token1] = ACTIONS(1977),
    [aux_sym_preproc_elif_token1] = ACTIONS(1975),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1977),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_and_eq] = ACTIONS(1975),
    [anon_sym_or_eq] = ACTIONS(1975),
    [anon_sym_xor_eq] = ACTIONS(1975),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
  },
  [2322] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [sym_identifier] = ACTIONS(5939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_TILDE] = ACTIONS(5941),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_COLON] = ACTIONS(5939),
    [anon_sym_SEMI] = ACTIONS(5941),
    [anon_sym___extension__] = ACTIONS(5939),
    [anon_sym_in] = ACTIONS(5939),
    [anon_sym_out] = ACTIONS(5939),
    [anon_sym_inout] = ACTIONS(5939),
    [anon_sym_virtual] = ACTIONS(5939),
    [anon_sym_extern] = ACTIONS(5939),
    [anon_sym___attribute__] = ACTIONS(5939),
    [anon_sym___attribute] = ACTIONS(5939),
    [anon_sym_COLON_COLON] = ACTIONS(5941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5941),
    [anon_sym___declspec] = ACTIONS(5939),
    [anon_sym___based] = ACTIONS(5939),
    [anon_sym___cdecl] = ACTIONS(5939),
    [anon_sym___clrcall] = ACTIONS(5939),
    [anon_sym___stdcall] = ACTIONS(5939),
    [anon_sym___fastcall] = ACTIONS(5939),
    [anon_sym___thiscall] = ACTIONS(5939),
    [anon_sym___vectorcall] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(5943),
    [anon_sym_unsigned] = ACTIONS(5943),
    [anon_sym_long] = ACTIONS(5943),
    [anon_sym_short] = ACTIONS(5943),
    [anon_sym_LBRACK] = ACTIONS(5939),
    [anon_sym_static] = ACTIONS(5939),
    [anon_sym_EQ] = ACTIONS(5941),
    [anon_sym_register] = ACTIONS(5939),
    [anon_sym_inline] = ACTIONS(5939),
    [anon_sym___inline] = ACTIONS(5939),
    [anon_sym___inline__] = ACTIONS(5939),
    [anon_sym___forceinline] = ACTIONS(5939),
    [anon_sym_thread_local] = ACTIONS(5939),
    [anon_sym___thread] = ACTIONS(5939),
    [anon_sym_const] = ACTIONS(5939),
    [anon_sym_constexpr] = ACTIONS(5939),
    [anon_sym_volatile] = ACTIONS(5939),
    [anon_sym_restrict] = ACTIONS(5939),
    [anon_sym___restrict__] = ACTIONS(5939),
    [anon_sym__Atomic] = ACTIONS(5939),
    [anon_sym__Noreturn] = ACTIONS(5939),
    [anon_sym_noreturn] = ACTIONS(5939),
    [anon_sym__Nonnull] = ACTIONS(5939),
    [anon_sym_mutable] = ACTIONS(5939),
    [anon_sym_constinit] = ACTIONS(5939),
    [anon_sym_consteval] = ACTIONS(5939),
    [anon_sym_alignas] = ACTIONS(5939),
    [anon_sym__Alignas] = ACTIONS(5939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5939),
    [anon_sym_decltype] = ACTIONS(5939),
    [anon_sym_template] = ACTIONS(5939),
    [anon_sym_GT2] = ACTIONS(5941),
    [anon_sym_operator] = ACTIONS(5939),
    [anon_sym_precise] = ACTIONS(5939),
    [anon_sym_shared] = ACTIONS(5939),
    [anon_sym_groupshared] = ACTIONS(5939),
    [anon_sym_uniform] = ACTIONS(5939),
    [anon_sym_row_major] = ACTIONS(5939),
    [anon_sym_column_major] = ACTIONS(5939),
    [anon_sym_globallycoherent] = ACTIONS(5939),
    [anon_sym_centroid] = ACTIONS(5939),
    [anon_sym_noperspective] = ACTIONS(5939),
    [anon_sym_nointerpolation] = ACTIONS(5939),
    [anon_sym_sample] = ACTIONS(5939),
    [anon_sym_linear] = ACTIONS(5939),
    [anon_sym_snorm] = ACTIONS(5939),
    [anon_sym_unorm] = ACTIONS(5939),
    [anon_sym_point] = ACTIONS(5939),
    [anon_sym_line] = ACTIONS(5939),
    [anon_sym_triangleadj] = ACTIONS(5939),
    [anon_sym_lineadj] = ACTIONS(5939),
    [anon_sym_triangle] = ACTIONS(5939),
  },
  [2323] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [aux_sym_preproc_if_token2] = ACTIONS(1981),
    [aux_sym_preproc_else_token1] = ACTIONS(1981),
    [aux_sym_preproc_elif_token1] = ACTIONS(1979),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1981),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_and_eq] = ACTIONS(1979),
    [anon_sym_or_eq] = ACTIONS(1979),
    [anon_sym_xor_eq] = ACTIONS(1979),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(5945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5947),
    [anon_sym_RPAREN] = ACTIONS(5947),
    [anon_sym_LPAREN2] = ACTIONS(5947),
    [anon_sym_TILDE] = ACTIONS(5947),
    [anon_sym_STAR] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_COLON] = ACTIONS(5945),
    [anon_sym_SEMI] = ACTIONS(5947),
    [anon_sym___extension__] = ACTIONS(5945),
    [anon_sym_in] = ACTIONS(5945),
    [anon_sym_out] = ACTIONS(5945),
    [anon_sym_inout] = ACTIONS(5945),
    [anon_sym_virtual] = ACTIONS(5945),
    [anon_sym_extern] = ACTIONS(5945),
    [anon_sym___attribute__] = ACTIONS(5945),
    [anon_sym___attribute] = ACTIONS(5945),
    [anon_sym_COLON_COLON] = ACTIONS(5947),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5947),
    [anon_sym___declspec] = ACTIONS(5945),
    [anon_sym___based] = ACTIONS(5945),
    [anon_sym___cdecl] = ACTIONS(5945),
    [anon_sym___clrcall] = ACTIONS(5945),
    [anon_sym___stdcall] = ACTIONS(5945),
    [anon_sym___fastcall] = ACTIONS(5945),
    [anon_sym___thiscall] = ACTIONS(5945),
    [anon_sym___vectorcall] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5947),
    [anon_sym_LBRACK] = ACTIONS(5945),
    [anon_sym_static] = ACTIONS(5945),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_register] = ACTIONS(5945),
    [anon_sym_inline] = ACTIONS(5945),
    [anon_sym___inline] = ACTIONS(5945),
    [anon_sym___inline__] = ACTIONS(5945),
    [anon_sym___forceinline] = ACTIONS(5945),
    [anon_sym_thread_local] = ACTIONS(5945),
    [anon_sym___thread] = ACTIONS(5945),
    [anon_sym_const] = ACTIONS(5945),
    [anon_sym_constexpr] = ACTIONS(5945),
    [anon_sym_volatile] = ACTIONS(5945),
    [anon_sym_restrict] = ACTIONS(5945),
    [anon_sym___restrict__] = ACTIONS(5945),
    [anon_sym__Atomic] = ACTIONS(5945),
    [anon_sym__Noreturn] = ACTIONS(5945),
    [anon_sym_noreturn] = ACTIONS(5945),
    [anon_sym__Nonnull] = ACTIONS(5945),
    [anon_sym_mutable] = ACTIONS(5945),
    [anon_sym_constinit] = ACTIONS(5945),
    [anon_sym_consteval] = ACTIONS(5945),
    [anon_sym_alignas] = ACTIONS(5945),
    [anon_sym__Alignas] = ACTIONS(5945),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5945),
    [anon_sym_decltype] = ACTIONS(5945),
    [anon_sym_final] = ACTIONS(5945),
    [anon_sym_override] = ACTIONS(5945),
    [anon_sym_template] = ACTIONS(5945),
    [anon_sym_GT2] = ACTIONS(5947),
    [anon_sym_operator] = ACTIONS(5945),
    [anon_sym_try] = ACTIONS(5945),
    [anon_sym_requires] = ACTIONS(5945),
    [anon_sym_precise] = ACTIONS(5945),
    [anon_sym_shared] = ACTIONS(5945),
    [anon_sym_groupshared] = ACTIONS(5945),
    [anon_sym_uniform] = ACTIONS(5945),
    [anon_sym_row_major] = ACTIONS(5945),
    [anon_sym_column_major] = ACTIONS(5945),
    [anon_sym_globallycoherent] = ACTIONS(5945),
    [anon_sym_centroid] = ACTIONS(5945),
    [anon_sym_noperspective] = ACTIONS(5945),
    [anon_sym_nointerpolation] = ACTIONS(5945),
    [anon_sym_sample] = ACTIONS(5945),
    [anon_sym_linear] = ACTIONS(5945),
    [anon_sym_snorm] = ACTIONS(5945),
    [anon_sym_unorm] = ACTIONS(5945),
    [anon_sym_point] = ACTIONS(5945),
    [anon_sym_line] = ACTIONS(5945),
    [anon_sym_triangleadj] = ACTIONS(5945),
    [anon_sym_lineadj] = ACTIONS(5945),
    [anon_sym_triangle] = ACTIONS(5945),
  },
  [2325] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2288),
    [anon_sym_out] = ACTIONS(2288),
    [anon_sym_inout] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_COLON_COLON] = ACTIONS(2290),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2290),
    [anon_sym___declspec] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym___cdecl] = ACTIONS(2288),
    [anon_sym___clrcall] = ACTIONS(2288),
    [anon_sym___stdcall] = ACTIONS(2288),
    [anon_sym___fastcall] = ACTIONS(2288),
    [anon_sym___thiscall] = ACTIONS(2288),
    [anon_sym___vectorcall] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(2290),
    [anon_sym_register] = ACTIONS(2288),
    [anon_sym_inline] = ACTIONS(2288),
    [anon_sym___inline] = ACTIONS(2288),
    [anon_sym___inline__] = ACTIONS(2288),
    [anon_sym___forceinline] = ACTIONS(2288),
    [anon_sym_thread_local] = ACTIONS(2288),
    [anon_sym___thread] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_template] = ACTIONS(2288),
    [anon_sym_GT2] = ACTIONS(2290),
    [anon_sym_operator] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
    [anon_sym_precise] = ACTIONS(2288),
    [anon_sym_shared] = ACTIONS(2288),
    [anon_sym_groupshared] = ACTIONS(2288),
    [anon_sym_uniform] = ACTIONS(2288),
    [anon_sym_row_major] = ACTIONS(2288),
    [anon_sym_column_major] = ACTIONS(2288),
    [anon_sym_globallycoherent] = ACTIONS(2288),
    [anon_sym_centroid] = ACTIONS(2288),
    [anon_sym_noperspective] = ACTIONS(2288),
    [anon_sym_nointerpolation] = ACTIONS(2288),
    [anon_sym_sample] = ACTIONS(2288),
    [anon_sym_linear] = ACTIONS(2288),
    [anon_sym_snorm] = ACTIONS(2288),
    [anon_sym_unorm] = ACTIONS(2288),
    [anon_sym_point] = ACTIONS(2288),
    [anon_sym_line] = ACTIONS(2288),
    [anon_sym_triangleadj] = ACTIONS(2288),
    [anon_sym_lineadj] = ACTIONS(2288),
    [anon_sym_triangle] = ACTIONS(2288),
  },
  [2326] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_GT2] = ACTIONS(5859),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_try] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2327] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym_in] = ACTIONS(2284),
    [anon_sym_out] = ACTIONS(2284),
    [anon_sym_inout] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_COLON_COLON] = ACTIONS(2286),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2286),
    [anon_sym___declspec] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym___cdecl] = ACTIONS(2284),
    [anon_sym___clrcall] = ACTIONS(2284),
    [anon_sym___stdcall] = ACTIONS(2284),
    [anon_sym___fastcall] = ACTIONS(2284),
    [anon_sym___thiscall] = ACTIONS(2284),
    [anon_sym___vectorcall] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(2286),
    [anon_sym_register] = ACTIONS(2284),
    [anon_sym_inline] = ACTIONS(2284),
    [anon_sym___inline] = ACTIONS(2284),
    [anon_sym___inline__] = ACTIONS(2284),
    [anon_sym___forceinline] = ACTIONS(2284),
    [anon_sym_thread_local] = ACTIONS(2284),
    [anon_sym___thread] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_template] = ACTIONS(2284),
    [anon_sym_GT2] = ACTIONS(2286),
    [anon_sym_operator] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
    [anon_sym_precise] = ACTIONS(2284),
    [anon_sym_shared] = ACTIONS(2284),
    [anon_sym_groupshared] = ACTIONS(2284),
    [anon_sym_uniform] = ACTIONS(2284),
    [anon_sym_row_major] = ACTIONS(2284),
    [anon_sym_column_major] = ACTIONS(2284),
    [anon_sym_globallycoherent] = ACTIONS(2284),
    [anon_sym_centroid] = ACTIONS(2284),
    [anon_sym_noperspective] = ACTIONS(2284),
    [anon_sym_nointerpolation] = ACTIONS(2284),
    [anon_sym_sample] = ACTIONS(2284),
    [anon_sym_linear] = ACTIONS(2284),
    [anon_sym_snorm] = ACTIONS(2284),
    [anon_sym_unorm] = ACTIONS(2284),
    [anon_sym_point] = ACTIONS(2284),
    [anon_sym_line] = ACTIONS(2284),
    [anon_sym_triangleadj] = ACTIONS(2284),
    [anon_sym_lineadj] = ACTIONS(2284),
    [anon_sym_triangle] = ACTIONS(2284),
  },
  [2328] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_signed] = ACTIONS(5864),
    [anon_sym_unsigned] = ACTIONS(5864),
    [anon_sym_long] = ACTIONS(5864),
    [anon_sym_short] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_GT2] = ACTIONS(5859),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2329] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5949),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2330] = {
    [sym_type_qualifier] = STATE(2339),
    [sym_alignas_qualifier] = STATE(2433),
    [aux_sym__type_definition_type_repeat1] = STATE(2339),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2420),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5731),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5731),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5731),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(5953),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(5955),
    [anon_sym_unsigned] = ACTIONS(5955),
    [anon_sym_long] = ACTIONS(5955),
    [anon_sym_short] = ACTIONS(5955),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(5953),
    [anon_sym_constexpr] = ACTIONS(5953),
    [anon_sym_volatile] = ACTIONS(5953),
    [anon_sym_restrict] = ACTIONS(5953),
    [anon_sym___restrict__] = ACTIONS(5953),
    [anon_sym__Atomic] = ACTIONS(5953),
    [anon_sym__Noreturn] = ACTIONS(5953),
    [anon_sym_noreturn] = ACTIONS(5953),
    [anon_sym__Nonnull] = ACTIONS(5953),
    [anon_sym_mutable] = ACTIONS(5953),
    [anon_sym_constinit] = ACTIONS(5953),
    [anon_sym_consteval] = ACTIONS(5953),
    [anon_sym_alignas] = ACTIONS(5957),
    [anon_sym__Alignas] = ACTIONS(5957),
    [sym_primitive_type] = ACTIONS(5959),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_STAR_EQ] = ACTIONS(5729),
    [anon_sym_SLASH_EQ] = ACTIONS(5729),
    [anon_sym_PERCENT_EQ] = ACTIONS(5729),
    [anon_sym_PLUS_EQ] = ACTIONS(5729),
    [anon_sym_DASH_EQ] = ACTIONS(5729),
    [anon_sym_LT_LT_EQ] = ACTIONS(5729),
    [anon_sym_GT_GT_EQ] = ACTIONS(5729),
    [anon_sym_AMP_EQ] = ACTIONS(5729),
    [anon_sym_CARET_EQ] = ACTIONS(5729),
    [anon_sym_PIPE_EQ] = ACTIONS(5729),
    [anon_sym_and_eq] = ACTIONS(5731),
    [anon_sym_or_eq] = ACTIONS(5731),
    [anon_sym_xor_eq] = ACTIONS(5731),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5729),
  },
  [2331] = {
    [sym_string_literal] = STATE(1282),
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [anon_sym_L_DQUOTE] = ACTIONS(5965),
    [anon_sym_u_DQUOTE] = ACTIONS(5965),
    [anon_sym_U_DQUOTE] = ACTIONS(5965),
    [anon_sym_u8_DQUOTE] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2332] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5967),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2333] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5969),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2334] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5971),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2335] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5973),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2336] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [aux_sym_preproc_if_token2] = ACTIONS(5875),
    [aux_sym_preproc_else_token1] = ACTIONS(5875),
    [aux_sym_preproc_elif_token1] = ACTIONS(5872),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5872),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(5788),
    [anon_sym_unsigned] = ACTIONS(5788),
    [anon_sym_long] = ACTIONS(5788),
    [anon_sym_short] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5875),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_and_eq] = ACTIONS(5872),
    [anon_sym_or_eq] = ACTIONS(5872),
    [anon_sym_xor_eq] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
  },
  [2337] = {
    [sym_string_literal] = STATE(1285),
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [anon_sym_L_DQUOTE] = ACTIONS(5965),
    [anon_sym_u_DQUOTE] = ACTIONS(5965),
    [anon_sym_U_DQUOTE] = ACTIONS(5965),
    [anon_sym_u8_DQUOTE] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2338] = {
    [sym_string_literal] = STATE(1281),
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [anon_sym_L_DQUOTE] = ACTIONS(5965),
    [anon_sym_u_DQUOTE] = ACTIONS(5965),
    [anon_sym_U_DQUOTE] = ACTIONS(5965),
    [anon_sym_u8_DQUOTE] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2339] = {
    [sym_type_qualifier] = STATE(2382),
    [sym_alignas_qualifier] = STATE(2433),
    [aux_sym__type_definition_type_repeat1] = STATE(2382),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3015),
    [sym_identifier] = ACTIONS(5975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(5953),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5977),
    [anon_sym_unsigned] = ACTIONS(5977),
    [anon_sym_long] = ACTIONS(5977),
    [anon_sym_short] = ACTIONS(5977),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5953),
    [anon_sym_constexpr] = ACTIONS(5953),
    [anon_sym_volatile] = ACTIONS(5953),
    [anon_sym_restrict] = ACTIONS(5953),
    [anon_sym___restrict__] = ACTIONS(5953),
    [anon_sym__Atomic] = ACTIONS(5953),
    [anon_sym__Noreturn] = ACTIONS(5953),
    [anon_sym_noreturn] = ACTIONS(5953),
    [anon_sym__Nonnull] = ACTIONS(5953),
    [anon_sym_mutable] = ACTIONS(5953),
    [anon_sym_constinit] = ACTIONS(5953),
    [anon_sym_consteval] = ACTIONS(5953),
    [anon_sym_alignas] = ACTIONS(5957),
    [anon_sym__Alignas] = ACTIONS(5957),
    [sym_primitive_type] = ACTIONS(5979),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5753),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_and_eq] = ACTIONS(5755),
    [anon_sym_or_eq] = ACTIONS(5755),
    [anon_sym_xor_eq] = ACTIONS(5755),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5753),
  },
  [2340] = {
    [sym_string_literal] = STATE(1284),
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [anon_sym_L_DQUOTE] = ACTIONS(5965),
    [anon_sym_u_DQUOTE] = ACTIONS(5965),
    [anon_sym_U_DQUOTE] = ACTIONS(5965),
    [anon_sym_u8_DQUOTE] = ACTIONS(5965),
    [anon_sym_DQUOTE] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2341] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5981),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2342] = {
    [sym__declaration_modifiers] = STATE(2294),
    [sym_attribute_specifier] = STATE(2294),
    [sym_attribute_declaration] = STATE(2294),
    [sym_ms_declspec_modifier] = STATE(2294),
    [sym_storage_class_specifier] = STATE(2294),
    [sym_type_qualifier] = STATE(2294),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_decltype_auto] = STATE(2365),
    [sym_qualifiers] = STATE(2294),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2294),
    [sym_identifier] = ACTIONS(5707),
    [anon_sym_LPAREN2] = ACTIONS(5709),
    [anon_sym_TILDE] = ACTIONS(5709),
    [anon_sym_STAR] = ACTIONS(5709),
    [anon_sym_AMP_AMP] = ACTIONS(5709),
    [anon_sym_AMP] = ACTIONS(5707),
    [anon_sym_SEMI] = ACTIONS(5983),
    [anon_sym___extension__] = ACTIONS(5515),
    [anon_sym_in] = ACTIONS(5711),
    [anon_sym_out] = ACTIONS(5711),
    [anon_sym_inout] = ACTIONS(5711),
    [anon_sym_virtual] = ACTIONS(5711),
    [anon_sym_extern] = ACTIONS(5519),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5709),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5525),
    [anon_sym___declspec] = ACTIONS(5527),
    [anon_sym___based] = ACTIONS(5707),
    [anon_sym___cdecl] = ACTIONS(5707),
    [anon_sym___clrcall] = ACTIONS(5707),
    [anon_sym___stdcall] = ACTIONS(5707),
    [anon_sym___fastcall] = ACTIONS(5707),
    [anon_sym___thiscall] = ACTIONS(5707),
    [anon_sym___vectorcall] = ACTIONS(5707),
    [anon_sym_LBRACK] = ACTIONS(5707),
    [anon_sym_static] = ACTIONS(5519),
    [anon_sym_register] = ACTIONS(5519),
    [anon_sym_inline] = ACTIONS(5519),
    [anon_sym___inline] = ACTIONS(5519),
    [anon_sym___inline__] = ACTIONS(5519),
    [anon_sym___forceinline] = ACTIONS(5519),
    [anon_sym_thread_local] = ACTIONS(5519),
    [anon_sym___thread] = ACTIONS(5519),
    [anon_sym_const] = ACTIONS(5515),
    [anon_sym_constexpr] = ACTIONS(5515),
    [anon_sym_volatile] = ACTIONS(5515),
    [anon_sym_restrict] = ACTIONS(5515),
    [anon_sym___restrict__] = ACTIONS(5515),
    [anon_sym__Atomic] = ACTIONS(5515),
    [anon_sym__Noreturn] = ACTIONS(5515),
    [anon_sym_noreturn] = ACTIONS(5515),
    [anon_sym__Nonnull] = ACTIONS(5515),
    [anon_sym_mutable] = ACTIONS(5515),
    [anon_sym_constinit] = ACTIONS(5515),
    [anon_sym_consteval] = ACTIONS(5515),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_template] = ACTIONS(5707),
    [anon_sym_operator] = ACTIONS(5707),
    [anon_sym_precise] = ACTIONS(5531),
    [anon_sym_shared] = ACTIONS(5531),
    [anon_sym_groupshared] = ACTIONS(5531),
    [anon_sym_uniform] = ACTIONS(5531),
    [anon_sym_row_major] = ACTIONS(5531),
    [anon_sym_column_major] = ACTIONS(5531),
    [anon_sym_globallycoherent] = ACTIONS(5531),
    [anon_sym_centroid] = ACTIONS(5531),
    [anon_sym_noperspective] = ACTIONS(5531),
    [anon_sym_nointerpolation] = ACTIONS(5531),
    [anon_sym_sample] = ACTIONS(5531),
    [anon_sym_linear] = ACTIONS(5531),
    [anon_sym_snorm] = ACTIONS(5531),
    [anon_sym_unorm] = ACTIONS(5531),
    [anon_sym_point] = ACTIONS(5531),
    [anon_sym_line] = ACTIONS(5531),
    [anon_sym_triangleadj] = ACTIONS(5531),
    [anon_sym_lineadj] = ACTIONS(5531),
    [anon_sym_triangle] = ACTIONS(5531),
  },
  [2343] = {
    [sym_identifier] = ACTIONS(5654),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_TILDE] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_COLON] = ACTIONS(5654),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___extension__] = ACTIONS(5654),
    [anon_sym_in] = ACTIONS(5654),
    [anon_sym_out] = ACTIONS(5654),
    [anon_sym_inout] = ACTIONS(5654),
    [anon_sym_virtual] = ACTIONS(5654),
    [anon_sym_extern] = ACTIONS(5654),
    [anon_sym___attribute__] = ACTIONS(5654),
    [anon_sym___attribute] = ACTIONS(5654),
    [anon_sym_COLON_COLON] = ACTIONS(5656),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5656),
    [anon_sym___declspec] = ACTIONS(5654),
    [anon_sym___based] = ACTIONS(5654),
    [anon_sym___cdecl] = ACTIONS(5654),
    [anon_sym___clrcall] = ACTIONS(5654),
    [anon_sym___stdcall] = ACTIONS(5654),
    [anon_sym___fastcall] = ACTIONS(5654),
    [anon_sym___thiscall] = ACTIONS(5654),
    [anon_sym___vectorcall] = ACTIONS(5654),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5654),
    [anon_sym_static] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_register] = ACTIONS(5654),
    [anon_sym_inline] = ACTIONS(5654),
    [anon_sym___inline] = ACTIONS(5654),
    [anon_sym___inline__] = ACTIONS(5654),
    [anon_sym___forceinline] = ACTIONS(5654),
    [anon_sym_thread_local] = ACTIONS(5654),
    [anon_sym___thread] = ACTIONS(5654),
    [anon_sym_const] = ACTIONS(5654),
    [anon_sym_constexpr] = ACTIONS(5654),
    [anon_sym_volatile] = ACTIONS(5654),
    [anon_sym_restrict] = ACTIONS(5654),
    [anon_sym___restrict__] = ACTIONS(5654),
    [anon_sym__Atomic] = ACTIONS(5654),
    [anon_sym__Noreturn] = ACTIONS(5654),
    [anon_sym_noreturn] = ACTIONS(5654),
    [anon_sym__Nonnull] = ACTIONS(5654),
    [anon_sym_mutable] = ACTIONS(5654),
    [anon_sym_constinit] = ACTIONS(5654),
    [anon_sym_consteval] = ACTIONS(5654),
    [anon_sym_alignas] = ACTIONS(5654),
    [anon_sym__Alignas] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5654),
    [anon_sym_decltype] = ACTIONS(5654),
    [anon_sym_final] = ACTIONS(5654),
    [anon_sym_override] = ACTIONS(5654),
    [anon_sym_explicit] = ACTIONS(5654),
    [anon_sym_template] = ACTIONS(5654),
    [anon_sym_GT2] = ACTIONS(5656),
    [anon_sym_operator] = ACTIONS(5654),
    [anon_sym_precise] = ACTIONS(5654),
    [anon_sym_shared] = ACTIONS(5654),
    [anon_sym_groupshared] = ACTIONS(5654),
    [anon_sym_uniform] = ACTIONS(5654),
    [anon_sym_row_major] = ACTIONS(5654),
    [anon_sym_column_major] = ACTIONS(5654),
    [anon_sym_globallycoherent] = ACTIONS(5654),
    [anon_sym_centroid] = ACTIONS(5654),
    [anon_sym_noperspective] = ACTIONS(5654),
    [anon_sym_nointerpolation] = ACTIONS(5654),
    [anon_sym_sample] = ACTIONS(5654),
    [anon_sym_linear] = ACTIONS(5654),
    [anon_sym_snorm] = ACTIONS(5654),
    [anon_sym_unorm] = ACTIONS(5654),
    [anon_sym_point] = ACTIONS(5654),
    [anon_sym_line] = ACTIONS(5654),
    [anon_sym_triangleadj] = ACTIONS(5654),
    [anon_sym_lineadj] = ACTIONS(5654),
    [anon_sym_triangle] = ACTIONS(5654),
  },
  [2344] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5872),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_SEMI] = ACTIONS(5875),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_RBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(5788),
    [anon_sym_unsigned] = ACTIONS(5788),
    [anon_sym_long] = ACTIONS(5788),
    [anon_sym_short] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_RBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5875),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_and_eq] = ACTIONS(5872),
    [anon_sym_or_eq] = ACTIONS(5872),
    [anon_sym_xor_eq] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
  },
  [2345] = {
    [sym_identifier] = ACTIONS(5902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_TILDE] = ACTIONS(5904),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5902),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5902),
    [anon_sym_in] = ACTIONS(5902),
    [anon_sym_out] = ACTIONS(5902),
    [anon_sym_inout] = ACTIONS(5902),
    [anon_sym_virtual] = ACTIONS(5902),
    [anon_sym_extern] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_COLON_COLON] = ACTIONS(5904),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5904),
    [anon_sym___declspec] = ACTIONS(5902),
    [anon_sym___based] = ACTIONS(5902),
    [anon_sym___cdecl] = ACTIONS(5902),
    [anon_sym___clrcall] = ACTIONS(5902),
    [anon_sym___stdcall] = ACTIONS(5902),
    [anon_sym___fastcall] = ACTIONS(5902),
    [anon_sym___thiscall] = ACTIONS(5902),
    [anon_sym___vectorcall] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5902),
    [anon_sym_static] = ACTIONS(5902),
    [anon_sym_EQ] = ACTIONS(5904),
    [anon_sym_register] = ACTIONS(5902),
    [anon_sym_inline] = ACTIONS(5902),
    [anon_sym___inline] = ACTIONS(5902),
    [anon_sym___inline__] = ACTIONS(5902),
    [anon_sym___forceinline] = ACTIONS(5902),
    [anon_sym_thread_local] = ACTIONS(5902),
    [anon_sym___thread] = ACTIONS(5902),
    [anon_sym_const] = ACTIONS(5902),
    [anon_sym_constexpr] = ACTIONS(5902),
    [anon_sym_volatile] = ACTIONS(5902),
    [anon_sym_restrict] = ACTIONS(5902),
    [anon_sym___restrict__] = ACTIONS(5902),
    [anon_sym__Atomic] = ACTIONS(5902),
    [anon_sym__Noreturn] = ACTIONS(5902),
    [anon_sym_noreturn] = ACTIONS(5902),
    [anon_sym__Nonnull] = ACTIONS(5902),
    [anon_sym_mutable] = ACTIONS(5902),
    [anon_sym_constinit] = ACTIONS(5902),
    [anon_sym_consteval] = ACTIONS(5902),
    [anon_sym_alignas] = ACTIONS(5902),
    [anon_sym__Alignas] = ACTIONS(5902),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
    [anon_sym_final] = ACTIONS(5902),
    [anon_sym_override] = ACTIONS(5902),
    [anon_sym_template] = ACTIONS(5902),
    [anon_sym_GT2] = ACTIONS(5904),
    [anon_sym_operator] = ACTIONS(5902),
    [anon_sym_requires] = ACTIONS(5902),
    [anon_sym_precise] = ACTIONS(5902),
    [anon_sym_shared] = ACTIONS(5902),
    [anon_sym_groupshared] = ACTIONS(5902),
    [anon_sym_uniform] = ACTIONS(5902),
    [anon_sym_row_major] = ACTIONS(5902),
    [anon_sym_column_major] = ACTIONS(5902),
    [anon_sym_globallycoherent] = ACTIONS(5902),
    [anon_sym_centroid] = ACTIONS(5902),
    [anon_sym_noperspective] = ACTIONS(5902),
    [anon_sym_nointerpolation] = ACTIONS(5902),
    [anon_sym_sample] = ACTIONS(5902),
    [anon_sym_linear] = ACTIONS(5902),
    [anon_sym_snorm] = ACTIONS(5902),
    [anon_sym_unorm] = ACTIONS(5902),
    [anon_sym_point] = ACTIONS(5902),
    [anon_sym_line] = ACTIONS(5902),
    [anon_sym_triangleadj] = ACTIONS(5902),
    [anon_sym_lineadj] = ACTIONS(5902),
    [anon_sym_triangle] = ACTIONS(5902),
  },
  [2346] = {
    [sym_decltype_auto] = STATE(2365),
    [sym_identifier] = ACTIONS(5985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5987),
    [anon_sym_COMMA] = ACTIONS(5987),
    [anon_sym_RPAREN] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(5987),
    [anon_sym_TILDE] = ACTIONS(5987),
    [anon_sym_STAR] = ACTIONS(5987),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_COLON] = ACTIONS(5985),
    [anon_sym_SEMI] = ACTIONS(5987),
    [anon_sym___extension__] = ACTIONS(5985),
    [anon_sym_in] = ACTIONS(5985),
    [anon_sym_out] = ACTIONS(5985),
    [anon_sym_inout] = ACTIONS(5985),
    [anon_sym_virtual] = ACTIONS(5985),
    [anon_sym_extern] = ACTIONS(5985),
    [anon_sym___attribute__] = ACTIONS(5985),
    [anon_sym___attribute] = ACTIONS(5985),
    [anon_sym_COLON_COLON] = ACTIONS(5987),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5987),
    [anon_sym___declspec] = ACTIONS(5985),
    [anon_sym___based] = ACTIONS(5985),
    [anon_sym___cdecl] = ACTIONS(5985),
    [anon_sym___clrcall] = ACTIONS(5985),
    [anon_sym___stdcall] = ACTIONS(5985),
    [anon_sym___fastcall] = ACTIONS(5985),
    [anon_sym___thiscall] = ACTIONS(5985),
    [anon_sym___vectorcall] = ACTIONS(5985),
    [anon_sym_LBRACK] = ACTIONS(5985),
    [anon_sym_static] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5987),
    [anon_sym_register] = ACTIONS(5985),
    [anon_sym_inline] = ACTIONS(5985),
    [anon_sym___inline] = ACTIONS(5985),
    [anon_sym___inline__] = ACTIONS(5985),
    [anon_sym___forceinline] = ACTIONS(5985),
    [anon_sym_thread_local] = ACTIONS(5985),
    [anon_sym___thread] = ACTIONS(5985),
    [anon_sym_const] = ACTIONS(5985),
    [anon_sym_constexpr] = ACTIONS(5985),
    [anon_sym_volatile] = ACTIONS(5985),
    [anon_sym_restrict] = ACTIONS(5985),
    [anon_sym___restrict__] = ACTIONS(5985),
    [anon_sym__Atomic] = ACTIONS(5985),
    [anon_sym__Noreturn] = ACTIONS(5985),
    [anon_sym_noreturn] = ACTIONS(5985),
    [anon_sym__Nonnull] = ACTIONS(5985),
    [anon_sym_mutable] = ACTIONS(5985),
    [anon_sym_constinit] = ACTIONS(5985),
    [anon_sym_consteval] = ACTIONS(5985),
    [anon_sym_alignas] = ACTIONS(5985),
    [anon_sym__Alignas] = ACTIONS(5985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5703),
    [anon_sym_decltype] = ACTIONS(5705),
    [anon_sym_final] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5985),
    [anon_sym_template] = ACTIONS(5985),
    [anon_sym_GT2] = ACTIONS(5987),
    [anon_sym_operator] = ACTIONS(5985),
    [anon_sym_requires] = ACTIONS(5985),
    [anon_sym_precise] = ACTIONS(5985),
    [anon_sym_shared] = ACTIONS(5985),
    [anon_sym_groupshared] = ACTIONS(5985),
    [anon_sym_uniform] = ACTIONS(5985),
    [anon_sym_row_major] = ACTIONS(5985),
    [anon_sym_column_major] = ACTIONS(5985),
    [anon_sym_globallycoherent] = ACTIONS(5985),
    [anon_sym_centroid] = ACTIONS(5985),
    [anon_sym_noperspective] = ACTIONS(5985),
    [anon_sym_nointerpolation] = ACTIONS(5985),
    [anon_sym_sample] = ACTIONS(5985),
    [anon_sym_linear] = ACTIONS(5985),
    [anon_sym_snorm] = ACTIONS(5985),
    [anon_sym_unorm] = ACTIONS(5985),
    [anon_sym_point] = ACTIONS(5985),
    [anon_sym_line] = ACTIONS(5985),
    [anon_sym_triangleadj] = ACTIONS(5985),
    [anon_sym_lineadj] = ACTIONS(5985),
    [anon_sym_triangle] = ACTIONS(5985),
  },
  [2347] = {
    [sym_identifier] = ACTIONS(5989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5991),
    [anon_sym_LPAREN2] = ACTIONS(5991),
    [anon_sym_TILDE] = ACTIONS(5991),
    [anon_sym_STAR] = ACTIONS(5991),
    [anon_sym_AMP_AMP] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5989),
    [anon_sym_COLON] = ACTIONS(5989),
    [anon_sym_SEMI] = ACTIONS(5991),
    [anon_sym___extension__] = ACTIONS(5989),
    [anon_sym_in] = ACTIONS(5989),
    [anon_sym_out] = ACTIONS(5989),
    [anon_sym_inout] = ACTIONS(5989),
    [anon_sym_virtual] = ACTIONS(5989),
    [anon_sym_extern] = ACTIONS(5989),
    [anon_sym___attribute__] = ACTIONS(5989),
    [anon_sym___attribute] = ACTIONS(5989),
    [anon_sym_COLON_COLON] = ACTIONS(5991),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5991),
    [anon_sym___declspec] = ACTIONS(5989),
    [anon_sym___based] = ACTIONS(5989),
    [anon_sym___cdecl] = ACTIONS(5989),
    [anon_sym___clrcall] = ACTIONS(5989),
    [anon_sym___stdcall] = ACTIONS(5989),
    [anon_sym___fastcall] = ACTIONS(5989),
    [anon_sym___thiscall] = ACTIONS(5989),
    [anon_sym___vectorcall] = ACTIONS(5989),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_static] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5991),
    [anon_sym_register] = ACTIONS(5989),
    [anon_sym_inline] = ACTIONS(5989),
    [anon_sym___inline] = ACTIONS(5989),
    [anon_sym___inline__] = ACTIONS(5989),
    [anon_sym___forceinline] = ACTIONS(5989),
    [anon_sym_thread_local] = ACTIONS(5989),
    [anon_sym___thread] = ACTIONS(5989),
    [anon_sym_const] = ACTIONS(5989),
    [anon_sym_constexpr] = ACTIONS(5989),
    [anon_sym_volatile] = ACTIONS(5989),
    [anon_sym_restrict] = ACTIONS(5989),
    [anon_sym___restrict__] = ACTIONS(5989),
    [anon_sym__Atomic] = ACTIONS(5989),
    [anon_sym__Noreturn] = ACTIONS(5989),
    [anon_sym_noreturn] = ACTIONS(5989),
    [anon_sym__Nonnull] = ACTIONS(5989),
    [anon_sym_mutable] = ACTIONS(5989),
    [anon_sym_constinit] = ACTIONS(5989),
    [anon_sym_consteval] = ACTIONS(5989),
    [anon_sym_alignas] = ACTIONS(5989),
    [anon_sym__Alignas] = ACTIONS(5989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5989),
    [anon_sym_decltype] = ACTIONS(5989),
    [anon_sym_final] = ACTIONS(5989),
    [anon_sym_override] = ACTIONS(5989),
    [anon_sym_template] = ACTIONS(5989),
    [anon_sym_GT2] = ACTIONS(5991),
    [anon_sym_operator] = ACTIONS(5989),
    [anon_sym_requires] = ACTIONS(5989),
    [anon_sym_precise] = ACTIONS(5989),
    [anon_sym_shared] = ACTIONS(5989),
    [anon_sym_groupshared] = ACTIONS(5989),
    [anon_sym_uniform] = ACTIONS(5989),
    [anon_sym_row_major] = ACTIONS(5989),
    [anon_sym_column_major] = ACTIONS(5989),
    [anon_sym_globallycoherent] = ACTIONS(5989),
    [anon_sym_centroid] = ACTIONS(5989),
    [anon_sym_noperspective] = ACTIONS(5989),
    [anon_sym_nointerpolation] = ACTIONS(5989),
    [anon_sym_sample] = ACTIONS(5989),
    [anon_sym_linear] = ACTIONS(5989),
    [anon_sym_snorm] = ACTIONS(5989),
    [anon_sym_unorm] = ACTIONS(5989),
    [anon_sym_point] = ACTIONS(5989),
    [anon_sym_line] = ACTIONS(5989),
    [anon_sym_triangleadj] = ACTIONS(5989),
    [anon_sym_lineadj] = ACTIONS(5989),
    [anon_sym_triangle] = ACTIONS(5989),
  },
  [2348] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_GT2] = ACTIONS(5859),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2349] = {
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5995),
    [anon_sym_COMMA] = ACTIONS(5995),
    [anon_sym_RPAREN] = ACTIONS(5995),
    [anon_sym_LPAREN2] = ACTIONS(5995),
    [anon_sym_TILDE] = ACTIONS(5995),
    [anon_sym_STAR] = ACTIONS(5995),
    [anon_sym_AMP_AMP] = ACTIONS(5995),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym_COLON] = ACTIONS(5993),
    [anon_sym_SEMI] = ACTIONS(5995),
    [anon_sym___extension__] = ACTIONS(5993),
    [anon_sym_in] = ACTIONS(5993),
    [anon_sym_out] = ACTIONS(5993),
    [anon_sym_inout] = ACTIONS(5993),
    [anon_sym_virtual] = ACTIONS(5993),
    [anon_sym_extern] = ACTIONS(5993),
    [anon_sym___attribute__] = ACTIONS(5993),
    [anon_sym___attribute] = ACTIONS(5993),
    [anon_sym_COLON_COLON] = ACTIONS(5995),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5995),
    [anon_sym___declspec] = ACTIONS(5993),
    [anon_sym___based] = ACTIONS(5993),
    [anon_sym___cdecl] = ACTIONS(5993),
    [anon_sym___clrcall] = ACTIONS(5993),
    [anon_sym___stdcall] = ACTIONS(5993),
    [anon_sym___fastcall] = ACTIONS(5993),
    [anon_sym___thiscall] = ACTIONS(5993),
    [anon_sym___vectorcall] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5993),
    [anon_sym_static] = ACTIONS(5993),
    [anon_sym_EQ] = ACTIONS(5995),
    [anon_sym_register] = ACTIONS(5993),
    [anon_sym_inline] = ACTIONS(5993),
    [anon_sym___inline] = ACTIONS(5993),
    [anon_sym___inline__] = ACTIONS(5993),
    [anon_sym___forceinline] = ACTIONS(5993),
    [anon_sym_thread_local] = ACTIONS(5993),
    [anon_sym___thread] = ACTIONS(5993),
    [anon_sym_const] = ACTIONS(5993),
    [anon_sym_constexpr] = ACTIONS(5993),
    [anon_sym_volatile] = ACTIONS(5993),
    [anon_sym_restrict] = ACTIONS(5993),
    [anon_sym___restrict__] = ACTIONS(5993),
    [anon_sym__Atomic] = ACTIONS(5993),
    [anon_sym__Noreturn] = ACTIONS(5993),
    [anon_sym_noreturn] = ACTIONS(5993),
    [anon_sym__Nonnull] = ACTIONS(5993),
    [anon_sym_mutable] = ACTIONS(5993),
    [anon_sym_constinit] = ACTIONS(5993),
    [anon_sym_consteval] = ACTIONS(5993),
    [anon_sym_alignas] = ACTIONS(5993),
    [anon_sym__Alignas] = ACTIONS(5993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5993),
    [anon_sym_decltype] = ACTIONS(5993),
    [anon_sym_final] = ACTIONS(5993),
    [anon_sym_override] = ACTIONS(5993),
    [anon_sym_template] = ACTIONS(5993),
    [anon_sym_GT2] = ACTIONS(5995),
    [anon_sym_operator] = ACTIONS(5993),
    [anon_sym_requires] = ACTIONS(5993),
    [anon_sym_precise] = ACTIONS(5993),
    [anon_sym_shared] = ACTIONS(5993),
    [anon_sym_groupshared] = ACTIONS(5993),
    [anon_sym_uniform] = ACTIONS(5993),
    [anon_sym_row_major] = ACTIONS(5993),
    [anon_sym_column_major] = ACTIONS(5993),
    [anon_sym_globallycoherent] = ACTIONS(5993),
    [anon_sym_centroid] = ACTIONS(5993),
    [anon_sym_noperspective] = ACTIONS(5993),
    [anon_sym_nointerpolation] = ACTIONS(5993),
    [anon_sym_sample] = ACTIONS(5993),
    [anon_sym_linear] = ACTIONS(5993),
    [anon_sym_snorm] = ACTIONS(5993),
    [anon_sym_unorm] = ACTIONS(5993),
    [anon_sym_point] = ACTIONS(5993),
    [anon_sym_line] = ACTIONS(5993),
    [anon_sym_triangleadj] = ACTIONS(5993),
    [anon_sym_lineadj] = ACTIONS(5993),
    [anon_sym_triangle] = ACTIONS(5993),
  },
  [2350] = {
    [sym_identifier] = ACTIONS(5997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_LPAREN2] = ACTIONS(5999),
    [anon_sym_TILDE] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_AMP_AMP] = ACTIONS(5999),
    [anon_sym_AMP] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SEMI] = ACTIONS(5999),
    [anon_sym___extension__] = ACTIONS(5997),
    [anon_sym_in] = ACTIONS(5997),
    [anon_sym_out] = ACTIONS(5997),
    [anon_sym_inout] = ACTIONS(5997),
    [anon_sym_virtual] = ACTIONS(5997),
    [anon_sym_extern] = ACTIONS(5997),
    [anon_sym___attribute__] = ACTIONS(5997),
    [anon_sym___attribute] = ACTIONS(5997),
    [anon_sym_COLON_COLON] = ACTIONS(5999),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5999),
    [anon_sym___declspec] = ACTIONS(5997),
    [anon_sym___based] = ACTIONS(5997),
    [anon_sym___cdecl] = ACTIONS(5997),
    [anon_sym___clrcall] = ACTIONS(5997),
    [anon_sym___stdcall] = ACTIONS(5997),
    [anon_sym___fastcall] = ACTIONS(5997),
    [anon_sym___thiscall] = ACTIONS(5997),
    [anon_sym___vectorcall] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5997),
    [anon_sym_static] = ACTIONS(5997),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_register] = ACTIONS(5997),
    [anon_sym_inline] = ACTIONS(5997),
    [anon_sym___inline] = ACTIONS(5997),
    [anon_sym___inline__] = ACTIONS(5997),
    [anon_sym___forceinline] = ACTIONS(5997),
    [anon_sym_thread_local] = ACTIONS(5997),
    [anon_sym___thread] = ACTIONS(5997),
    [anon_sym_const] = ACTIONS(5997),
    [anon_sym_constexpr] = ACTIONS(5997),
    [anon_sym_volatile] = ACTIONS(5997),
    [anon_sym_restrict] = ACTIONS(5997),
    [anon_sym___restrict__] = ACTIONS(5997),
    [anon_sym__Atomic] = ACTIONS(5997),
    [anon_sym__Noreturn] = ACTIONS(5997),
    [anon_sym_noreturn] = ACTIONS(5997),
    [anon_sym__Nonnull] = ACTIONS(5997),
    [anon_sym_mutable] = ACTIONS(5997),
    [anon_sym_constinit] = ACTIONS(5997),
    [anon_sym_consteval] = ACTIONS(5997),
    [anon_sym_alignas] = ACTIONS(5997),
    [anon_sym__Alignas] = ACTIONS(5997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5997),
    [anon_sym_decltype] = ACTIONS(5997),
    [anon_sym_final] = ACTIONS(5997),
    [anon_sym_override] = ACTIONS(5997),
    [anon_sym_template] = ACTIONS(5997),
    [anon_sym_GT2] = ACTIONS(5999),
    [anon_sym_operator] = ACTIONS(5997),
    [anon_sym_requires] = ACTIONS(5997),
    [anon_sym_precise] = ACTIONS(5997),
    [anon_sym_shared] = ACTIONS(5997),
    [anon_sym_groupshared] = ACTIONS(5997),
    [anon_sym_uniform] = ACTIONS(5997),
    [anon_sym_row_major] = ACTIONS(5997),
    [anon_sym_column_major] = ACTIONS(5997),
    [anon_sym_globallycoherent] = ACTIONS(5997),
    [anon_sym_centroid] = ACTIONS(5997),
    [anon_sym_noperspective] = ACTIONS(5997),
    [anon_sym_nointerpolation] = ACTIONS(5997),
    [anon_sym_sample] = ACTIONS(5997),
    [anon_sym_linear] = ACTIONS(5997),
    [anon_sym_snorm] = ACTIONS(5997),
    [anon_sym_unorm] = ACTIONS(5997),
    [anon_sym_point] = ACTIONS(5997),
    [anon_sym_line] = ACTIONS(5997),
    [anon_sym_triangleadj] = ACTIONS(5997),
    [anon_sym_lineadj] = ACTIONS(5997),
    [anon_sym_triangle] = ACTIONS(5997),
  },
  [2351] = {
    [sym_type_qualifier] = STATE(2355),
    [sym_alignas_qualifier] = STATE(2446),
    [aux_sym__type_definition_type_repeat1] = STATE(2355),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2425),
    [sym_identifier] = ACTIONS(6001),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5731),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5731),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5731),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5731),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(6003),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6005),
    [anon_sym_unsigned] = ACTIONS(6005),
    [anon_sym_long] = ACTIONS(6005),
    [anon_sym_short] = ACTIONS(6005),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(6003),
    [anon_sym_constexpr] = ACTIONS(6003),
    [anon_sym_volatile] = ACTIONS(6003),
    [anon_sym_restrict] = ACTIONS(6003),
    [anon_sym___restrict__] = ACTIONS(6003),
    [anon_sym__Atomic] = ACTIONS(6003),
    [anon_sym__Noreturn] = ACTIONS(6003),
    [anon_sym_noreturn] = ACTIONS(6003),
    [anon_sym__Nonnull] = ACTIONS(6003),
    [anon_sym_mutable] = ACTIONS(6003),
    [anon_sym_constinit] = ACTIONS(6003),
    [anon_sym_consteval] = ACTIONS(6003),
    [anon_sym_alignas] = ACTIONS(6007),
    [anon_sym__Alignas] = ACTIONS(6007),
    [sym_primitive_type] = ACTIONS(6009),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_STAR_EQ] = ACTIONS(5729),
    [anon_sym_SLASH_EQ] = ACTIONS(5729),
    [anon_sym_PERCENT_EQ] = ACTIONS(5729),
    [anon_sym_PLUS_EQ] = ACTIONS(5729),
    [anon_sym_DASH_EQ] = ACTIONS(5729),
    [anon_sym_LT_LT_EQ] = ACTIONS(5729),
    [anon_sym_GT_GT_EQ] = ACTIONS(5731),
    [anon_sym_AMP_EQ] = ACTIONS(5729),
    [anon_sym_CARET_EQ] = ACTIONS(5729),
    [anon_sym_PIPE_EQ] = ACTIONS(5729),
    [anon_sym_and_eq] = ACTIONS(5731),
    [anon_sym_or_eq] = ACTIONS(5731),
    [anon_sym_xor_eq] = ACTIONS(5731),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_GT2] = ACTIONS(5729),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_STAR] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_COLON] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___extension__] = ACTIONS(6011),
    [anon_sym_in] = ACTIONS(6011),
    [anon_sym_out] = ACTIONS(6011),
    [anon_sym_inout] = ACTIONS(6011),
    [anon_sym_virtual] = ACTIONS(6011),
    [anon_sym_extern] = ACTIONS(6011),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym_COLON_COLON] = ACTIONS(6013),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6013),
    [anon_sym___declspec] = ACTIONS(6011),
    [anon_sym___based] = ACTIONS(6011),
    [anon_sym___cdecl] = ACTIONS(6011),
    [anon_sym___clrcall] = ACTIONS(6011),
    [anon_sym___stdcall] = ACTIONS(6011),
    [anon_sym___fastcall] = ACTIONS(6011),
    [anon_sym___thiscall] = ACTIONS(6011),
    [anon_sym___vectorcall] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_static] = ACTIONS(6011),
    [anon_sym_EQ] = ACTIONS(6013),
    [anon_sym_register] = ACTIONS(6011),
    [anon_sym_inline] = ACTIONS(6011),
    [anon_sym___inline] = ACTIONS(6011),
    [anon_sym___inline__] = ACTIONS(6011),
    [anon_sym___forceinline] = ACTIONS(6011),
    [anon_sym_thread_local] = ACTIONS(6011),
    [anon_sym___thread] = ACTIONS(6011),
    [anon_sym_const] = ACTIONS(6011),
    [anon_sym_constexpr] = ACTIONS(6011),
    [anon_sym_volatile] = ACTIONS(6011),
    [anon_sym_restrict] = ACTIONS(6011),
    [anon_sym___restrict__] = ACTIONS(6011),
    [anon_sym__Atomic] = ACTIONS(6011),
    [anon_sym__Noreturn] = ACTIONS(6011),
    [anon_sym_noreturn] = ACTIONS(6011),
    [anon_sym__Nonnull] = ACTIONS(6011),
    [anon_sym_mutable] = ACTIONS(6011),
    [anon_sym_constinit] = ACTIONS(6011),
    [anon_sym_consteval] = ACTIONS(6011),
    [anon_sym_alignas] = ACTIONS(6011),
    [anon_sym__Alignas] = ACTIONS(6011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
    [anon_sym_final] = ACTIONS(6011),
    [anon_sym_override] = ACTIONS(6011),
    [anon_sym_template] = ACTIONS(6011),
    [anon_sym_GT2] = ACTIONS(6013),
    [anon_sym_operator] = ACTIONS(6011),
    [anon_sym_requires] = ACTIONS(6011),
    [anon_sym_precise] = ACTIONS(6011),
    [anon_sym_shared] = ACTIONS(6011),
    [anon_sym_groupshared] = ACTIONS(6011),
    [anon_sym_uniform] = ACTIONS(6011),
    [anon_sym_row_major] = ACTIONS(6011),
    [anon_sym_column_major] = ACTIONS(6011),
    [anon_sym_globallycoherent] = ACTIONS(6011),
    [anon_sym_centroid] = ACTIONS(6011),
    [anon_sym_noperspective] = ACTIONS(6011),
    [anon_sym_nointerpolation] = ACTIONS(6011),
    [anon_sym_sample] = ACTIONS(6011),
    [anon_sym_linear] = ACTIONS(6011),
    [anon_sym_snorm] = ACTIONS(6011),
    [anon_sym_unorm] = ACTIONS(6011),
    [anon_sym_point] = ACTIONS(6011),
    [anon_sym_line] = ACTIONS(6011),
    [anon_sym_triangleadj] = ACTIONS(6011),
    [anon_sym_lineadj] = ACTIONS(6011),
    [anon_sym_triangle] = ACTIONS(6011),
  },
  [2353] = {
    [sym_identifier] = ACTIONS(6015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6017),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_LPAREN2] = ACTIONS(6017),
    [anon_sym_TILDE] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6015),
    [anon_sym_COLON] = ACTIONS(6015),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym___extension__] = ACTIONS(6015),
    [anon_sym_in] = ACTIONS(6015),
    [anon_sym_out] = ACTIONS(6015),
    [anon_sym_inout] = ACTIONS(6015),
    [anon_sym_virtual] = ACTIONS(6015),
    [anon_sym_extern] = ACTIONS(6015),
    [anon_sym___attribute__] = ACTIONS(6015),
    [anon_sym___attribute] = ACTIONS(6015),
    [anon_sym_COLON_COLON] = ACTIONS(6017),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6017),
    [anon_sym___declspec] = ACTIONS(6015),
    [anon_sym___based] = ACTIONS(6015),
    [anon_sym___cdecl] = ACTIONS(6015),
    [anon_sym___clrcall] = ACTIONS(6015),
    [anon_sym___stdcall] = ACTIONS(6015),
    [anon_sym___fastcall] = ACTIONS(6015),
    [anon_sym___thiscall] = ACTIONS(6015),
    [anon_sym___vectorcall] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(6015),
    [anon_sym_static] = ACTIONS(6015),
    [anon_sym_EQ] = ACTIONS(6017),
    [anon_sym_register] = ACTIONS(6015),
    [anon_sym_inline] = ACTIONS(6015),
    [anon_sym___inline] = ACTIONS(6015),
    [anon_sym___inline__] = ACTIONS(6015),
    [anon_sym___forceinline] = ACTIONS(6015),
    [anon_sym_thread_local] = ACTIONS(6015),
    [anon_sym___thread] = ACTIONS(6015),
    [anon_sym_const] = ACTIONS(6015),
    [anon_sym_constexpr] = ACTIONS(6015),
    [anon_sym_volatile] = ACTIONS(6015),
    [anon_sym_restrict] = ACTIONS(6015),
    [anon_sym___restrict__] = ACTIONS(6015),
    [anon_sym__Atomic] = ACTIONS(6015),
    [anon_sym__Noreturn] = ACTIONS(6015),
    [anon_sym_noreturn] = ACTIONS(6015),
    [anon_sym__Nonnull] = ACTIONS(6015),
    [anon_sym_mutable] = ACTIONS(6015),
    [anon_sym_constinit] = ACTIONS(6015),
    [anon_sym_consteval] = ACTIONS(6015),
    [anon_sym_alignas] = ACTIONS(6015),
    [anon_sym__Alignas] = ACTIONS(6015),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6015),
    [anon_sym_decltype] = ACTIONS(6015),
    [anon_sym_final] = ACTIONS(6015),
    [anon_sym_override] = ACTIONS(6015),
    [anon_sym_template] = ACTIONS(6015),
    [anon_sym_GT2] = ACTIONS(6017),
    [anon_sym_operator] = ACTIONS(6015),
    [anon_sym_requires] = ACTIONS(6015),
    [anon_sym_precise] = ACTIONS(6015),
    [anon_sym_shared] = ACTIONS(6015),
    [anon_sym_groupshared] = ACTIONS(6015),
    [anon_sym_uniform] = ACTIONS(6015),
    [anon_sym_row_major] = ACTIONS(6015),
    [anon_sym_column_major] = ACTIONS(6015),
    [anon_sym_globallycoherent] = ACTIONS(6015),
    [anon_sym_centroid] = ACTIONS(6015),
    [anon_sym_noperspective] = ACTIONS(6015),
    [anon_sym_nointerpolation] = ACTIONS(6015),
    [anon_sym_sample] = ACTIONS(6015),
    [anon_sym_linear] = ACTIONS(6015),
    [anon_sym_snorm] = ACTIONS(6015),
    [anon_sym_unorm] = ACTIONS(6015),
    [anon_sym_point] = ACTIONS(6015),
    [anon_sym_line] = ACTIONS(6015),
    [anon_sym_triangleadj] = ACTIONS(6015),
    [anon_sym_lineadj] = ACTIONS(6015),
    [anon_sym_triangle] = ACTIONS(6015),
  },
  [2354] = {
    [sym_identifier] = ACTIONS(6019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6021),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [anon_sym_LPAREN2] = ACTIONS(6021),
    [anon_sym_TILDE] = ACTIONS(6021),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(6021),
    [anon_sym_AMP] = ACTIONS(6019),
    [anon_sym_COLON] = ACTIONS(6019),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym___extension__] = ACTIONS(6019),
    [anon_sym_in] = ACTIONS(6019),
    [anon_sym_out] = ACTIONS(6019),
    [anon_sym_inout] = ACTIONS(6019),
    [anon_sym_virtual] = ACTIONS(6019),
    [anon_sym_extern] = ACTIONS(6019),
    [anon_sym___attribute__] = ACTIONS(6019),
    [anon_sym___attribute] = ACTIONS(6019),
    [anon_sym_COLON_COLON] = ACTIONS(6021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6021),
    [anon_sym___declspec] = ACTIONS(6019),
    [anon_sym___based] = ACTIONS(6019),
    [anon_sym___cdecl] = ACTIONS(6019),
    [anon_sym___clrcall] = ACTIONS(6019),
    [anon_sym___stdcall] = ACTIONS(6019),
    [anon_sym___fastcall] = ACTIONS(6019),
    [anon_sym___thiscall] = ACTIONS(6019),
    [anon_sym___vectorcall] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_static] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6021),
    [anon_sym_register] = ACTIONS(6019),
    [anon_sym_inline] = ACTIONS(6019),
    [anon_sym___inline] = ACTIONS(6019),
    [anon_sym___inline__] = ACTIONS(6019),
    [anon_sym___forceinline] = ACTIONS(6019),
    [anon_sym_thread_local] = ACTIONS(6019),
    [anon_sym___thread] = ACTIONS(6019),
    [anon_sym_const] = ACTIONS(6019),
    [anon_sym_constexpr] = ACTIONS(6019),
    [anon_sym_volatile] = ACTIONS(6019),
    [anon_sym_restrict] = ACTIONS(6019),
    [anon_sym___restrict__] = ACTIONS(6019),
    [anon_sym__Atomic] = ACTIONS(6019),
    [anon_sym__Noreturn] = ACTIONS(6019),
    [anon_sym_noreturn] = ACTIONS(6019),
    [anon_sym__Nonnull] = ACTIONS(6019),
    [anon_sym_mutable] = ACTIONS(6019),
    [anon_sym_constinit] = ACTIONS(6019),
    [anon_sym_consteval] = ACTIONS(6019),
    [anon_sym_alignas] = ACTIONS(6019),
    [anon_sym__Alignas] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6019),
    [anon_sym_decltype] = ACTIONS(6019),
    [anon_sym_final] = ACTIONS(6019),
    [anon_sym_override] = ACTIONS(6019),
    [anon_sym_template] = ACTIONS(6019),
    [anon_sym_GT2] = ACTIONS(6021),
    [anon_sym_operator] = ACTIONS(6019),
    [anon_sym_requires] = ACTIONS(6019),
    [anon_sym_precise] = ACTIONS(6019),
    [anon_sym_shared] = ACTIONS(6019),
    [anon_sym_groupshared] = ACTIONS(6019),
    [anon_sym_uniform] = ACTIONS(6019),
    [anon_sym_row_major] = ACTIONS(6019),
    [anon_sym_column_major] = ACTIONS(6019),
    [anon_sym_globallycoherent] = ACTIONS(6019),
    [anon_sym_centroid] = ACTIONS(6019),
    [anon_sym_noperspective] = ACTIONS(6019),
    [anon_sym_nointerpolation] = ACTIONS(6019),
    [anon_sym_sample] = ACTIONS(6019),
    [anon_sym_linear] = ACTIONS(6019),
    [anon_sym_snorm] = ACTIONS(6019),
    [anon_sym_unorm] = ACTIONS(6019),
    [anon_sym_point] = ACTIONS(6019),
    [anon_sym_line] = ACTIONS(6019),
    [anon_sym_triangleadj] = ACTIONS(6019),
    [anon_sym_lineadj] = ACTIONS(6019),
    [anon_sym_triangle] = ACTIONS(6019),
  },
  [2355] = {
    [sym_type_qualifier] = STATE(2391),
    [sym_alignas_qualifier] = STATE(2446),
    [aux_sym__type_definition_type_repeat1] = STATE(2391),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3027),
    [sym_identifier] = ACTIONS(6023),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5755),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(6003),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(6003),
    [anon_sym_constexpr] = ACTIONS(6003),
    [anon_sym_volatile] = ACTIONS(6003),
    [anon_sym_restrict] = ACTIONS(6003),
    [anon_sym___restrict__] = ACTIONS(6003),
    [anon_sym__Atomic] = ACTIONS(6003),
    [anon_sym__Noreturn] = ACTIONS(6003),
    [anon_sym_noreturn] = ACTIONS(6003),
    [anon_sym__Nonnull] = ACTIONS(6003),
    [anon_sym_mutable] = ACTIONS(6003),
    [anon_sym_constinit] = ACTIONS(6003),
    [anon_sym_consteval] = ACTIONS(6003),
    [anon_sym_alignas] = ACTIONS(6007),
    [anon_sym__Alignas] = ACTIONS(6007),
    [sym_primitive_type] = ACTIONS(6027),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5755),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_and_eq] = ACTIONS(5755),
    [anon_sym_or_eq] = ACTIONS(5755),
    [anon_sym_xor_eq] = ACTIONS(5755),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_GT2] = ACTIONS(5753),
  },
  [2356] = {
    [sym_identifier] = ACTIONS(6029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6031),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_RPAREN] = ACTIONS(6031),
    [anon_sym_LPAREN2] = ACTIONS(6031),
    [anon_sym_TILDE] = ACTIONS(6031),
    [anon_sym_STAR] = ACTIONS(6031),
    [anon_sym_AMP_AMP] = ACTIONS(6031),
    [anon_sym_AMP] = ACTIONS(6029),
    [anon_sym_COLON] = ACTIONS(6029),
    [anon_sym_SEMI] = ACTIONS(6031),
    [anon_sym___extension__] = ACTIONS(6029),
    [anon_sym_in] = ACTIONS(6029),
    [anon_sym_out] = ACTIONS(6029),
    [anon_sym_inout] = ACTIONS(6029),
    [anon_sym_virtual] = ACTIONS(6029),
    [anon_sym_extern] = ACTIONS(6029),
    [anon_sym___attribute__] = ACTIONS(6029),
    [anon_sym___attribute] = ACTIONS(6029),
    [anon_sym_COLON_COLON] = ACTIONS(6031),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6031),
    [anon_sym___declspec] = ACTIONS(6029),
    [anon_sym___based] = ACTIONS(6029),
    [anon_sym___cdecl] = ACTIONS(6029),
    [anon_sym___clrcall] = ACTIONS(6029),
    [anon_sym___stdcall] = ACTIONS(6029),
    [anon_sym___fastcall] = ACTIONS(6029),
    [anon_sym___thiscall] = ACTIONS(6029),
    [anon_sym___vectorcall] = ACTIONS(6029),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_static] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6031),
    [anon_sym_register] = ACTIONS(6029),
    [anon_sym_inline] = ACTIONS(6029),
    [anon_sym___inline] = ACTIONS(6029),
    [anon_sym___inline__] = ACTIONS(6029),
    [anon_sym___forceinline] = ACTIONS(6029),
    [anon_sym_thread_local] = ACTIONS(6029),
    [anon_sym___thread] = ACTIONS(6029),
    [anon_sym_const] = ACTIONS(6029),
    [anon_sym_constexpr] = ACTIONS(6029),
    [anon_sym_volatile] = ACTIONS(6029),
    [anon_sym_restrict] = ACTIONS(6029),
    [anon_sym___restrict__] = ACTIONS(6029),
    [anon_sym__Atomic] = ACTIONS(6029),
    [anon_sym__Noreturn] = ACTIONS(6029),
    [anon_sym_noreturn] = ACTIONS(6029),
    [anon_sym__Nonnull] = ACTIONS(6029),
    [anon_sym_mutable] = ACTIONS(6029),
    [anon_sym_constinit] = ACTIONS(6029),
    [anon_sym_consteval] = ACTIONS(6029),
    [anon_sym_alignas] = ACTIONS(6029),
    [anon_sym__Alignas] = ACTIONS(6029),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6029),
    [anon_sym_decltype] = ACTIONS(6029),
    [anon_sym_final] = ACTIONS(6029),
    [anon_sym_override] = ACTIONS(6029),
    [anon_sym_template] = ACTIONS(6029),
    [anon_sym_GT2] = ACTIONS(6031),
    [anon_sym_operator] = ACTIONS(6029),
    [anon_sym_requires] = ACTIONS(6029),
    [anon_sym_precise] = ACTIONS(6029),
    [anon_sym_shared] = ACTIONS(6029),
    [anon_sym_groupshared] = ACTIONS(6029),
    [anon_sym_uniform] = ACTIONS(6029),
    [anon_sym_row_major] = ACTIONS(6029),
    [anon_sym_column_major] = ACTIONS(6029),
    [anon_sym_globallycoherent] = ACTIONS(6029),
    [anon_sym_centroid] = ACTIONS(6029),
    [anon_sym_noperspective] = ACTIONS(6029),
    [anon_sym_nointerpolation] = ACTIONS(6029),
    [anon_sym_sample] = ACTIONS(6029),
    [anon_sym_linear] = ACTIONS(6029),
    [anon_sym_snorm] = ACTIONS(6029),
    [anon_sym_unorm] = ACTIONS(6029),
    [anon_sym_point] = ACTIONS(6029),
    [anon_sym_line] = ACTIONS(6029),
    [anon_sym_triangleadj] = ACTIONS(6029),
    [anon_sym_lineadj] = ACTIONS(6029),
    [anon_sym_triangle] = ACTIONS(6029),
  },
  [2357] = {
    [sym_identifier] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_RPAREN] = ACTIONS(6035),
    [anon_sym_LPAREN2] = ACTIONS(6035),
    [anon_sym_TILDE] = ACTIONS(6035),
    [anon_sym_STAR] = ACTIONS(6035),
    [anon_sym_AMP_AMP] = ACTIONS(6035),
    [anon_sym_AMP] = ACTIONS(6033),
    [anon_sym_COLON] = ACTIONS(6033),
    [anon_sym_SEMI] = ACTIONS(6035),
    [anon_sym___extension__] = ACTIONS(6033),
    [anon_sym_in] = ACTIONS(6033),
    [anon_sym_out] = ACTIONS(6033),
    [anon_sym_inout] = ACTIONS(6033),
    [anon_sym_virtual] = ACTIONS(6033),
    [anon_sym_extern] = ACTIONS(6033),
    [anon_sym___attribute__] = ACTIONS(6033),
    [anon_sym___attribute] = ACTIONS(6033),
    [anon_sym_COLON_COLON] = ACTIONS(6035),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6035),
    [anon_sym___declspec] = ACTIONS(6033),
    [anon_sym___based] = ACTIONS(6033),
    [anon_sym___cdecl] = ACTIONS(6033),
    [anon_sym___clrcall] = ACTIONS(6033),
    [anon_sym___stdcall] = ACTIONS(6033),
    [anon_sym___fastcall] = ACTIONS(6033),
    [anon_sym___thiscall] = ACTIONS(6033),
    [anon_sym___vectorcall] = ACTIONS(6033),
    [anon_sym_LBRACK] = ACTIONS(6033),
    [anon_sym_static] = ACTIONS(6033),
    [anon_sym_EQ] = ACTIONS(6035),
    [anon_sym_register] = ACTIONS(6033),
    [anon_sym_inline] = ACTIONS(6033),
    [anon_sym___inline] = ACTIONS(6033),
    [anon_sym___inline__] = ACTIONS(6033),
    [anon_sym___forceinline] = ACTIONS(6033),
    [anon_sym_thread_local] = ACTIONS(6033),
    [anon_sym___thread] = ACTIONS(6033),
    [anon_sym_const] = ACTIONS(6033),
    [anon_sym_constexpr] = ACTIONS(6033),
    [anon_sym_volatile] = ACTIONS(6033),
    [anon_sym_restrict] = ACTIONS(6033),
    [anon_sym___restrict__] = ACTIONS(6033),
    [anon_sym__Atomic] = ACTIONS(6033),
    [anon_sym__Noreturn] = ACTIONS(6033),
    [anon_sym_noreturn] = ACTIONS(6033),
    [anon_sym__Nonnull] = ACTIONS(6033),
    [anon_sym_mutable] = ACTIONS(6033),
    [anon_sym_constinit] = ACTIONS(6033),
    [anon_sym_consteval] = ACTIONS(6033),
    [anon_sym_alignas] = ACTIONS(6033),
    [anon_sym__Alignas] = ACTIONS(6033),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6033),
    [anon_sym_decltype] = ACTIONS(6033),
    [anon_sym_final] = ACTIONS(6033),
    [anon_sym_override] = ACTIONS(6033),
    [anon_sym_template] = ACTIONS(6033),
    [anon_sym_GT2] = ACTIONS(6035),
    [anon_sym_operator] = ACTIONS(6033),
    [anon_sym_requires] = ACTIONS(6033),
    [anon_sym_precise] = ACTIONS(6033),
    [anon_sym_shared] = ACTIONS(6033),
    [anon_sym_groupshared] = ACTIONS(6033),
    [anon_sym_uniform] = ACTIONS(6033),
    [anon_sym_row_major] = ACTIONS(6033),
    [anon_sym_column_major] = ACTIONS(6033),
    [anon_sym_globallycoherent] = ACTIONS(6033),
    [anon_sym_centroid] = ACTIONS(6033),
    [anon_sym_noperspective] = ACTIONS(6033),
    [anon_sym_nointerpolation] = ACTIONS(6033),
    [anon_sym_sample] = ACTIONS(6033),
    [anon_sym_linear] = ACTIONS(6033),
    [anon_sym_snorm] = ACTIONS(6033),
    [anon_sym_unorm] = ACTIONS(6033),
    [anon_sym_point] = ACTIONS(6033),
    [anon_sym_line] = ACTIONS(6033),
    [anon_sym_triangleadj] = ACTIONS(6033),
    [anon_sym_lineadj] = ACTIONS(6033),
    [anon_sym_triangle] = ACTIONS(6033),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(6037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_LPAREN2] = ACTIONS(6039),
    [anon_sym_TILDE] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_AMP_AMP] = ACTIONS(6039),
    [anon_sym_AMP] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SEMI] = ACTIONS(6039),
    [anon_sym___extension__] = ACTIONS(6037),
    [anon_sym_in] = ACTIONS(6037),
    [anon_sym_out] = ACTIONS(6037),
    [anon_sym_inout] = ACTIONS(6037),
    [anon_sym_virtual] = ACTIONS(6037),
    [anon_sym_extern] = ACTIONS(6037),
    [anon_sym___attribute__] = ACTIONS(6037),
    [anon_sym___attribute] = ACTIONS(6037),
    [anon_sym_COLON_COLON] = ACTIONS(6039),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6039),
    [anon_sym___declspec] = ACTIONS(6037),
    [anon_sym___based] = ACTIONS(6037),
    [anon_sym___cdecl] = ACTIONS(6037),
    [anon_sym___clrcall] = ACTIONS(6037),
    [anon_sym___stdcall] = ACTIONS(6037),
    [anon_sym___fastcall] = ACTIONS(6037),
    [anon_sym___thiscall] = ACTIONS(6037),
    [anon_sym___vectorcall] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6037),
    [anon_sym_static] = ACTIONS(6037),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_register] = ACTIONS(6037),
    [anon_sym_inline] = ACTIONS(6037),
    [anon_sym___inline] = ACTIONS(6037),
    [anon_sym___inline__] = ACTIONS(6037),
    [anon_sym___forceinline] = ACTIONS(6037),
    [anon_sym_thread_local] = ACTIONS(6037),
    [anon_sym___thread] = ACTIONS(6037),
    [anon_sym_const] = ACTIONS(6037),
    [anon_sym_constexpr] = ACTIONS(6037),
    [anon_sym_volatile] = ACTIONS(6037),
    [anon_sym_restrict] = ACTIONS(6037),
    [anon_sym___restrict__] = ACTIONS(6037),
    [anon_sym__Atomic] = ACTIONS(6037),
    [anon_sym__Noreturn] = ACTIONS(6037),
    [anon_sym_noreturn] = ACTIONS(6037),
    [anon_sym__Nonnull] = ACTIONS(6037),
    [anon_sym_mutable] = ACTIONS(6037),
    [anon_sym_constinit] = ACTIONS(6037),
    [anon_sym_consteval] = ACTIONS(6037),
    [anon_sym_alignas] = ACTIONS(6037),
    [anon_sym__Alignas] = ACTIONS(6037),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6037),
    [anon_sym_decltype] = ACTIONS(6037),
    [anon_sym_final] = ACTIONS(6037),
    [anon_sym_override] = ACTIONS(6037),
    [anon_sym_template] = ACTIONS(6037),
    [anon_sym_GT2] = ACTIONS(6039),
    [anon_sym_operator] = ACTIONS(6037),
    [anon_sym_requires] = ACTIONS(6037),
    [anon_sym_precise] = ACTIONS(6037),
    [anon_sym_shared] = ACTIONS(6037),
    [anon_sym_groupshared] = ACTIONS(6037),
    [anon_sym_uniform] = ACTIONS(6037),
    [anon_sym_row_major] = ACTIONS(6037),
    [anon_sym_column_major] = ACTIONS(6037),
    [anon_sym_globallycoherent] = ACTIONS(6037),
    [anon_sym_centroid] = ACTIONS(6037),
    [anon_sym_noperspective] = ACTIONS(6037),
    [anon_sym_nointerpolation] = ACTIONS(6037),
    [anon_sym_sample] = ACTIONS(6037),
    [anon_sym_linear] = ACTIONS(6037),
    [anon_sym_snorm] = ACTIONS(6037),
    [anon_sym_unorm] = ACTIONS(6037),
    [anon_sym_point] = ACTIONS(6037),
    [anon_sym_line] = ACTIONS(6037),
    [anon_sym_triangleadj] = ACTIONS(6037),
    [anon_sym_lineadj] = ACTIONS(6037),
    [anon_sym_triangle] = ACTIONS(6037),
  },
  [2359] = {
    [sym_identifier] = ACTIONS(6041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6043),
    [anon_sym_COMMA] = ACTIONS(6043),
    [anon_sym_RPAREN] = ACTIONS(6043),
    [anon_sym_LPAREN2] = ACTIONS(6043),
    [anon_sym_TILDE] = ACTIONS(6043),
    [anon_sym_STAR] = ACTIONS(6043),
    [anon_sym_AMP_AMP] = ACTIONS(6043),
    [anon_sym_AMP] = ACTIONS(6041),
    [anon_sym_COLON] = ACTIONS(6041),
    [anon_sym_SEMI] = ACTIONS(6043),
    [anon_sym___extension__] = ACTIONS(6041),
    [anon_sym_in] = ACTIONS(6041),
    [anon_sym_out] = ACTIONS(6041),
    [anon_sym_inout] = ACTIONS(6041),
    [anon_sym_virtual] = ACTIONS(6041),
    [anon_sym_extern] = ACTIONS(6041),
    [anon_sym___attribute__] = ACTIONS(6041),
    [anon_sym___attribute] = ACTIONS(6041),
    [anon_sym_COLON_COLON] = ACTIONS(6043),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6043),
    [anon_sym___declspec] = ACTIONS(6041),
    [anon_sym___based] = ACTIONS(6041),
    [anon_sym___cdecl] = ACTIONS(6041),
    [anon_sym___clrcall] = ACTIONS(6041),
    [anon_sym___stdcall] = ACTIONS(6041),
    [anon_sym___fastcall] = ACTIONS(6041),
    [anon_sym___thiscall] = ACTIONS(6041),
    [anon_sym___vectorcall] = ACTIONS(6041),
    [anon_sym_LBRACK] = ACTIONS(6041),
    [anon_sym_static] = ACTIONS(6041),
    [anon_sym_EQ] = ACTIONS(6043),
    [anon_sym_register] = ACTIONS(6041),
    [anon_sym_inline] = ACTIONS(6041),
    [anon_sym___inline] = ACTIONS(6041),
    [anon_sym___inline__] = ACTIONS(6041),
    [anon_sym___forceinline] = ACTIONS(6041),
    [anon_sym_thread_local] = ACTIONS(6041),
    [anon_sym___thread] = ACTIONS(6041),
    [anon_sym_const] = ACTIONS(6041),
    [anon_sym_constexpr] = ACTIONS(6041),
    [anon_sym_volatile] = ACTIONS(6041),
    [anon_sym_restrict] = ACTIONS(6041),
    [anon_sym___restrict__] = ACTIONS(6041),
    [anon_sym__Atomic] = ACTIONS(6041),
    [anon_sym__Noreturn] = ACTIONS(6041),
    [anon_sym_noreturn] = ACTIONS(6041),
    [anon_sym__Nonnull] = ACTIONS(6041),
    [anon_sym_mutable] = ACTIONS(6041),
    [anon_sym_constinit] = ACTIONS(6041),
    [anon_sym_consteval] = ACTIONS(6041),
    [anon_sym_alignas] = ACTIONS(6041),
    [anon_sym__Alignas] = ACTIONS(6041),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6041),
    [anon_sym_decltype] = ACTIONS(6041),
    [anon_sym_final] = ACTIONS(6041),
    [anon_sym_override] = ACTIONS(6041),
    [anon_sym_template] = ACTIONS(6041),
    [anon_sym_GT2] = ACTIONS(6043),
    [anon_sym_operator] = ACTIONS(6041),
    [anon_sym_requires] = ACTIONS(6041),
    [anon_sym_precise] = ACTIONS(6041),
    [anon_sym_shared] = ACTIONS(6041),
    [anon_sym_groupshared] = ACTIONS(6041),
    [anon_sym_uniform] = ACTIONS(6041),
    [anon_sym_row_major] = ACTIONS(6041),
    [anon_sym_column_major] = ACTIONS(6041),
    [anon_sym_globallycoherent] = ACTIONS(6041),
    [anon_sym_centroid] = ACTIONS(6041),
    [anon_sym_noperspective] = ACTIONS(6041),
    [anon_sym_nointerpolation] = ACTIONS(6041),
    [anon_sym_sample] = ACTIONS(6041),
    [anon_sym_linear] = ACTIONS(6041),
    [anon_sym_snorm] = ACTIONS(6041),
    [anon_sym_unorm] = ACTIONS(6041),
    [anon_sym_point] = ACTIONS(6041),
    [anon_sym_line] = ACTIONS(6041),
    [anon_sym_triangleadj] = ACTIONS(6041),
    [anon_sym_lineadj] = ACTIONS(6041),
    [anon_sym_triangle] = ACTIONS(6041),
  },
  [2360] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_TILDE] = ACTIONS(6047),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym_in] = ACTIONS(6045),
    [anon_sym_out] = ACTIONS(6045),
    [anon_sym_inout] = ACTIONS(6045),
    [anon_sym_virtual] = ACTIONS(6045),
    [anon_sym_extern] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_COLON_COLON] = ACTIONS(6047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6047),
    [anon_sym___declspec] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym___cdecl] = ACTIONS(6045),
    [anon_sym___clrcall] = ACTIONS(6045),
    [anon_sym___stdcall] = ACTIONS(6045),
    [anon_sym___fastcall] = ACTIONS(6045),
    [anon_sym___thiscall] = ACTIONS(6045),
    [anon_sym___vectorcall] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6045),
    [anon_sym_static] = ACTIONS(6045),
    [anon_sym_EQ] = ACTIONS(6047),
    [anon_sym_register] = ACTIONS(6045),
    [anon_sym_inline] = ACTIONS(6045),
    [anon_sym___inline] = ACTIONS(6045),
    [anon_sym___inline__] = ACTIONS(6045),
    [anon_sym___forceinline] = ACTIONS(6045),
    [anon_sym_thread_local] = ACTIONS(6045),
    [anon_sym___thread] = ACTIONS(6045),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_template] = ACTIONS(6045),
    [anon_sym_GT2] = ACTIONS(6047),
    [anon_sym_operator] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
    [anon_sym_precise] = ACTIONS(6045),
    [anon_sym_shared] = ACTIONS(6045),
    [anon_sym_groupshared] = ACTIONS(6045),
    [anon_sym_uniform] = ACTIONS(6045),
    [anon_sym_row_major] = ACTIONS(6045),
    [anon_sym_column_major] = ACTIONS(6045),
    [anon_sym_globallycoherent] = ACTIONS(6045),
    [anon_sym_centroid] = ACTIONS(6045),
    [anon_sym_noperspective] = ACTIONS(6045),
    [anon_sym_nointerpolation] = ACTIONS(6045),
    [anon_sym_sample] = ACTIONS(6045),
    [anon_sym_linear] = ACTIONS(6045),
    [anon_sym_snorm] = ACTIONS(6045),
    [anon_sym_unorm] = ACTIONS(6045),
    [anon_sym_point] = ACTIONS(6045),
    [anon_sym_line] = ACTIONS(6045),
    [anon_sym_triangleadj] = ACTIONS(6045),
    [anon_sym_lineadj] = ACTIONS(6045),
    [anon_sym_triangle] = ACTIONS(6045),
  },
  [2361] = {
    [sym_identifier] = ACTIONS(6049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [anon_sym_LPAREN2] = ACTIONS(6051),
    [anon_sym_TILDE] = ACTIONS(6051),
    [anon_sym_STAR] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(6051),
    [anon_sym_AMP] = ACTIONS(6049),
    [anon_sym_COLON] = ACTIONS(6049),
    [anon_sym_SEMI] = ACTIONS(6051),
    [anon_sym___extension__] = ACTIONS(6049),
    [anon_sym_in] = ACTIONS(6049),
    [anon_sym_out] = ACTIONS(6049),
    [anon_sym_inout] = ACTIONS(6049),
    [anon_sym_virtual] = ACTIONS(6049),
    [anon_sym_extern] = ACTIONS(6049),
    [anon_sym___attribute__] = ACTIONS(6049),
    [anon_sym___attribute] = ACTIONS(6049),
    [anon_sym_COLON_COLON] = ACTIONS(6051),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6051),
    [anon_sym___declspec] = ACTIONS(6049),
    [anon_sym___based] = ACTIONS(6049),
    [anon_sym___cdecl] = ACTIONS(6049),
    [anon_sym___clrcall] = ACTIONS(6049),
    [anon_sym___stdcall] = ACTIONS(6049),
    [anon_sym___fastcall] = ACTIONS(6049),
    [anon_sym___thiscall] = ACTIONS(6049),
    [anon_sym___vectorcall] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_static] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6051),
    [anon_sym_register] = ACTIONS(6049),
    [anon_sym_inline] = ACTIONS(6049),
    [anon_sym___inline] = ACTIONS(6049),
    [anon_sym___inline__] = ACTIONS(6049),
    [anon_sym___forceinline] = ACTIONS(6049),
    [anon_sym_thread_local] = ACTIONS(6049),
    [anon_sym___thread] = ACTIONS(6049),
    [anon_sym_const] = ACTIONS(6049),
    [anon_sym_constexpr] = ACTIONS(6049),
    [anon_sym_volatile] = ACTIONS(6049),
    [anon_sym_restrict] = ACTIONS(6049),
    [anon_sym___restrict__] = ACTIONS(6049),
    [anon_sym__Atomic] = ACTIONS(6049),
    [anon_sym__Noreturn] = ACTIONS(6049),
    [anon_sym_noreturn] = ACTIONS(6049),
    [anon_sym__Nonnull] = ACTIONS(6049),
    [anon_sym_mutable] = ACTIONS(6049),
    [anon_sym_constinit] = ACTIONS(6049),
    [anon_sym_consteval] = ACTIONS(6049),
    [anon_sym_alignas] = ACTIONS(6049),
    [anon_sym__Alignas] = ACTIONS(6049),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6049),
    [anon_sym_decltype] = ACTIONS(6049),
    [anon_sym_final] = ACTIONS(6049),
    [anon_sym_override] = ACTIONS(6049),
    [anon_sym_template] = ACTIONS(6049),
    [anon_sym_GT2] = ACTIONS(6051),
    [anon_sym_operator] = ACTIONS(6049),
    [anon_sym_requires] = ACTIONS(6049),
    [anon_sym_precise] = ACTIONS(6049),
    [anon_sym_shared] = ACTIONS(6049),
    [anon_sym_groupshared] = ACTIONS(6049),
    [anon_sym_uniform] = ACTIONS(6049),
    [anon_sym_row_major] = ACTIONS(6049),
    [anon_sym_column_major] = ACTIONS(6049),
    [anon_sym_globallycoherent] = ACTIONS(6049),
    [anon_sym_centroid] = ACTIONS(6049),
    [anon_sym_noperspective] = ACTIONS(6049),
    [anon_sym_nointerpolation] = ACTIONS(6049),
    [anon_sym_sample] = ACTIONS(6049),
    [anon_sym_linear] = ACTIONS(6049),
    [anon_sym_snorm] = ACTIONS(6049),
    [anon_sym_unorm] = ACTIONS(6049),
    [anon_sym_point] = ACTIONS(6049),
    [anon_sym_line] = ACTIONS(6049),
    [anon_sym_triangleadj] = ACTIONS(6049),
    [anon_sym_lineadj] = ACTIONS(6049),
    [anon_sym_triangle] = ACTIONS(6049),
  },
  [2362] = {
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6055),
    [anon_sym_COMMA] = ACTIONS(6055),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [anon_sym_LPAREN2] = ACTIONS(6055),
    [anon_sym_TILDE] = ACTIONS(6055),
    [anon_sym_STAR] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6053),
    [anon_sym_COLON] = ACTIONS(6053),
    [anon_sym_SEMI] = ACTIONS(6055),
    [anon_sym___extension__] = ACTIONS(6053),
    [anon_sym_in] = ACTIONS(6053),
    [anon_sym_out] = ACTIONS(6053),
    [anon_sym_inout] = ACTIONS(6053),
    [anon_sym_virtual] = ACTIONS(6053),
    [anon_sym_extern] = ACTIONS(6053),
    [anon_sym___attribute__] = ACTIONS(6053),
    [anon_sym___attribute] = ACTIONS(6053),
    [anon_sym_COLON_COLON] = ACTIONS(6055),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6055),
    [anon_sym___declspec] = ACTIONS(6053),
    [anon_sym___based] = ACTIONS(6053),
    [anon_sym___cdecl] = ACTIONS(6053),
    [anon_sym___clrcall] = ACTIONS(6053),
    [anon_sym___stdcall] = ACTIONS(6053),
    [anon_sym___fastcall] = ACTIONS(6053),
    [anon_sym___thiscall] = ACTIONS(6053),
    [anon_sym___vectorcall] = ACTIONS(6053),
    [anon_sym_LBRACK] = ACTIONS(6053),
    [anon_sym_static] = ACTIONS(6053),
    [anon_sym_EQ] = ACTIONS(6055),
    [anon_sym_register] = ACTIONS(6053),
    [anon_sym_inline] = ACTIONS(6053),
    [anon_sym___inline] = ACTIONS(6053),
    [anon_sym___inline__] = ACTIONS(6053),
    [anon_sym___forceinline] = ACTIONS(6053),
    [anon_sym_thread_local] = ACTIONS(6053),
    [anon_sym___thread] = ACTIONS(6053),
    [anon_sym_const] = ACTIONS(6053),
    [anon_sym_constexpr] = ACTIONS(6053),
    [anon_sym_volatile] = ACTIONS(6053),
    [anon_sym_restrict] = ACTIONS(6053),
    [anon_sym___restrict__] = ACTIONS(6053),
    [anon_sym__Atomic] = ACTIONS(6053),
    [anon_sym__Noreturn] = ACTIONS(6053),
    [anon_sym_noreturn] = ACTIONS(6053),
    [anon_sym__Nonnull] = ACTIONS(6053),
    [anon_sym_mutable] = ACTIONS(6053),
    [anon_sym_constinit] = ACTIONS(6053),
    [anon_sym_consteval] = ACTIONS(6053),
    [anon_sym_alignas] = ACTIONS(6053),
    [anon_sym__Alignas] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6053),
    [anon_sym_decltype] = ACTIONS(6053),
    [anon_sym_final] = ACTIONS(6053),
    [anon_sym_override] = ACTIONS(6053),
    [anon_sym_template] = ACTIONS(6053),
    [anon_sym_GT2] = ACTIONS(6055),
    [anon_sym_operator] = ACTIONS(6053),
    [anon_sym_requires] = ACTIONS(6053),
    [anon_sym_precise] = ACTIONS(6053),
    [anon_sym_shared] = ACTIONS(6053),
    [anon_sym_groupshared] = ACTIONS(6053),
    [anon_sym_uniform] = ACTIONS(6053),
    [anon_sym_row_major] = ACTIONS(6053),
    [anon_sym_column_major] = ACTIONS(6053),
    [anon_sym_globallycoherent] = ACTIONS(6053),
    [anon_sym_centroid] = ACTIONS(6053),
    [anon_sym_noperspective] = ACTIONS(6053),
    [anon_sym_nointerpolation] = ACTIONS(6053),
    [anon_sym_sample] = ACTIONS(6053),
    [anon_sym_linear] = ACTIONS(6053),
    [anon_sym_snorm] = ACTIONS(6053),
    [anon_sym_unorm] = ACTIONS(6053),
    [anon_sym_point] = ACTIONS(6053),
    [anon_sym_line] = ACTIONS(6053),
    [anon_sym_triangleadj] = ACTIONS(6053),
    [anon_sym_lineadj] = ACTIONS(6053),
    [anon_sym_triangle] = ACTIONS(6053),
  },
  [2363] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_GT2] = ACTIONS(5859),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2364] = {
    [sym_identifier] = ACTIONS(6057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_LPAREN2] = ACTIONS(6059),
    [anon_sym_TILDE] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_AMP_AMP] = ACTIONS(6059),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SEMI] = ACTIONS(6059),
    [anon_sym___extension__] = ACTIONS(6057),
    [anon_sym_in] = ACTIONS(6057),
    [anon_sym_out] = ACTIONS(6057),
    [anon_sym_inout] = ACTIONS(6057),
    [anon_sym_virtual] = ACTIONS(6057),
    [anon_sym_extern] = ACTIONS(6057),
    [anon_sym___attribute__] = ACTIONS(6057),
    [anon_sym___attribute] = ACTIONS(6057),
    [anon_sym_COLON_COLON] = ACTIONS(6059),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6059),
    [anon_sym___declspec] = ACTIONS(6057),
    [anon_sym___based] = ACTIONS(6057),
    [anon_sym___cdecl] = ACTIONS(6057),
    [anon_sym___clrcall] = ACTIONS(6057),
    [anon_sym___stdcall] = ACTIONS(6057),
    [anon_sym___fastcall] = ACTIONS(6057),
    [anon_sym___thiscall] = ACTIONS(6057),
    [anon_sym___vectorcall] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6057),
    [anon_sym_static] = ACTIONS(6057),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_register] = ACTIONS(6057),
    [anon_sym_inline] = ACTIONS(6057),
    [anon_sym___inline] = ACTIONS(6057),
    [anon_sym___inline__] = ACTIONS(6057),
    [anon_sym___forceinline] = ACTIONS(6057),
    [anon_sym_thread_local] = ACTIONS(6057),
    [anon_sym___thread] = ACTIONS(6057),
    [anon_sym_const] = ACTIONS(6057),
    [anon_sym_constexpr] = ACTIONS(6057),
    [anon_sym_volatile] = ACTIONS(6057),
    [anon_sym_restrict] = ACTIONS(6057),
    [anon_sym___restrict__] = ACTIONS(6057),
    [anon_sym__Atomic] = ACTIONS(6057),
    [anon_sym__Noreturn] = ACTIONS(6057),
    [anon_sym_noreturn] = ACTIONS(6057),
    [anon_sym__Nonnull] = ACTIONS(6057),
    [anon_sym_mutable] = ACTIONS(6057),
    [anon_sym_constinit] = ACTIONS(6057),
    [anon_sym_consteval] = ACTIONS(6057),
    [anon_sym_alignas] = ACTIONS(6057),
    [anon_sym__Alignas] = ACTIONS(6057),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6057),
    [anon_sym_decltype] = ACTIONS(6057),
    [anon_sym_final] = ACTIONS(6057),
    [anon_sym_override] = ACTIONS(6057),
    [anon_sym_template] = ACTIONS(6057),
    [anon_sym_GT2] = ACTIONS(6059),
    [anon_sym_operator] = ACTIONS(6057),
    [anon_sym_requires] = ACTIONS(6057),
    [anon_sym_precise] = ACTIONS(6057),
    [anon_sym_shared] = ACTIONS(6057),
    [anon_sym_groupshared] = ACTIONS(6057),
    [anon_sym_uniform] = ACTIONS(6057),
    [anon_sym_row_major] = ACTIONS(6057),
    [anon_sym_column_major] = ACTIONS(6057),
    [anon_sym_globallycoherent] = ACTIONS(6057),
    [anon_sym_centroid] = ACTIONS(6057),
    [anon_sym_noperspective] = ACTIONS(6057),
    [anon_sym_nointerpolation] = ACTIONS(6057),
    [anon_sym_sample] = ACTIONS(6057),
    [anon_sym_linear] = ACTIONS(6057),
    [anon_sym_snorm] = ACTIONS(6057),
    [anon_sym_unorm] = ACTIONS(6057),
    [anon_sym_point] = ACTIONS(6057),
    [anon_sym_line] = ACTIONS(6057),
    [anon_sym_triangleadj] = ACTIONS(6057),
    [anon_sym_lineadj] = ACTIONS(6057),
    [anon_sym_triangle] = ACTIONS(6057),
  },
  [2365] = {
    [sym_identifier] = ACTIONS(6061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_LPAREN2] = ACTIONS(6063),
    [anon_sym_TILDE] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6063),
    [anon_sym_AMP] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SEMI] = ACTIONS(6063),
    [anon_sym___extension__] = ACTIONS(6061),
    [anon_sym_in] = ACTIONS(6061),
    [anon_sym_out] = ACTIONS(6061),
    [anon_sym_inout] = ACTIONS(6061),
    [anon_sym_virtual] = ACTIONS(6061),
    [anon_sym_extern] = ACTIONS(6061),
    [anon_sym___attribute__] = ACTIONS(6061),
    [anon_sym___attribute] = ACTIONS(6061),
    [anon_sym_COLON_COLON] = ACTIONS(6063),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6063),
    [anon_sym___declspec] = ACTIONS(6061),
    [anon_sym___based] = ACTIONS(6061),
    [anon_sym___cdecl] = ACTIONS(6061),
    [anon_sym___clrcall] = ACTIONS(6061),
    [anon_sym___stdcall] = ACTIONS(6061),
    [anon_sym___fastcall] = ACTIONS(6061),
    [anon_sym___thiscall] = ACTIONS(6061),
    [anon_sym___vectorcall] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(6061),
    [anon_sym_static] = ACTIONS(6061),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_register] = ACTIONS(6061),
    [anon_sym_inline] = ACTIONS(6061),
    [anon_sym___inline] = ACTIONS(6061),
    [anon_sym___inline__] = ACTIONS(6061),
    [anon_sym___forceinline] = ACTIONS(6061),
    [anon_sym_thread_local] = ACTIONS(6061),
    [anon_sym___thread] = ACTIONS(6061),
    [anon_sym_const] = ACTIONS(6061),
    [anon_sym_constexpr] = ACTIONS(6061),
    [anon_sym_volatile] = ACTIONS(6061),
    [anon_sym_restrict] = ACTIONS(6061),
    [anon_sym___restrict__] = ACTIONS(6061),
    [anon_sym__Atomic] = ACTIONS(6061),
    [anon_sym__Noreturn] = ACTIONS(6061),
    [anon_sym_noreturn] = ACTIONS(6061),
    [anon_sym__Nonnull] = ACTIONS(6061),
    [anon_sym_mutable] = ACTIONS(6061),
    [anon_sym_constinit] = ACTIONS(6061),
    [anon_sym_consteval] = ACTIONS(6061),
    [anon_sym_alignas] = ACTIONS(6061),
    [anon_sym__Alignas] = ACTIONS(6061),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6061),
    [anon_sym_decltype] = ACTIONS(6061),
    [anon_sym_final] = ACTIONS(6061),
    [anon_sym_override] = ACTIONS(6061),
    [anon_sym_template] = ACTIONS(6061),
    [anon_sym_GT2] = ACTIONS(6063),
    [anon_sym_operator] = ACTIONS(6061),
    [anon_sym_requires] = ACTIONS(6061),
    [anon_sym_precise] = ACTIONS(6061),
    [anon_sym_shared] = ACTIONS(6061),
    [anon_sym_groupshared] = ACTIONS(6061),
    [anon_sym_uniform] = ACTIONS(6061),
    [anon_sym_row_major] = ACTIONS(6061),
    [anon_sym_column_major] = ACTIONS(6061),
    [anon_sym_globallycoherent] = ACTIONS(6061),
    [anon_sym_centroid] = ACTIONS(6061),
    [anon_sym_noperspective] = ACTIONS(6061),
    [anon_sym_nointerpolation] = ACTIONS(6061),
    [anon_sym_sample] = ACTIONS(6061),
    [anon_sym_linear] = ACTIONS(6061),
    [anon_sym_snorm] = ACTIONS(6061),
    [anon_sym_unorm] = ACTIONS(6061),
    [anon_sym_point] = ACTIONS(6061),
    [anon_sym_line] = ACTIONS(6061),
    [anon_sym_triangleadj] = ACTIONS(6061),
    [anon_sym_lineadj] = ACTIONS(6061),
    [anon_sym_triangle] = ACTIONS(6061),
  },
  [2366] = {
    [sym_identifier] = ACTIONS(6065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_LPAREN2] = ACTIONS(6067),
    [anon_sym_TILDE] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_AMP_AMP] = ACTIONS(6067),
    [anon_sym_AMP] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SEMI] = ACTIONS(6067),
    [anon_sym___extension__] = ACTIONS(6065),
    [anon_sym_in] = ACTIONS(6065),
    [anon_sym_out] = ACTIONS(6065),
    [anon_sym_inout] = ACTIONS(6065),
    [anon_sym_virtual] = ACTIONS(6065),
    [anon_sym_extern] = ACTIONS(6065),
    [anon_sym___attribute__] = ACTIONS(6065),
    [anon_sym___attribute] = ACTIONS(6065),
    [anon_sym_COLON_COLON] = ACTIONS(6067),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6067),
    [anon_sym___declspec] = ACTIONS(6065),
    [anon_sym___based] = ACTIONS(6065),
    [anon_sym___cdecl] = ACTIONS(6065),
    [anon_sym___clrcall] = ACTIONS(6065),
    [anon_sym___stdcall] = ACTIONS(6065),
    [anon_sym___fastcall] = ACTIONS(6065),
    [anon_sym___thiscall] = ACTIONS(6065),
    [anon_sym___vectorcall] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6065),
    [anon_sym_static] = ACTIONS(6065),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_register] = ACTIONS(6065),
    [anon_sym_inline] = ACTIONS(6065),
    [anon_sym___inline] = ACTIONS(6065),
    [anon_sym___inline__] = ACTIONS(6065),
    [anon_sym___forceinline] = ACTIONS(6065),
    [anon_sym_thread_local] = ACTIONS(6065),
    [anon_sym___thread] = ACTIONS(6065),
    [anon_sym_const] = ACTIONS(6065),
    [anon_sym_constexpr] = ACTIONS(6065),
    [anon_sym_volatile] = ACTIONS(6065),
    [anon_sym_restrict] = ACTIONS(6065),
    [anon_sym___restrict__] = ACTIONS(6065),
    [anon_sym__Atomic] = ACTIONS(6065),
    [anon_sym__Noreturn] = ACTIONS(6065),
    [anon_sym_noreturn] = ACTIONS(6065),
    [anon_sym__Nonnull] = ACTIONS(6065),
    [anon_sym_mutable] = ACTIONS(6065),
    [anon_sym_constinit] = ACTIONS(6065),
    [anon_sym_consteval] = ACTIONS(6065),
    [anon_sym_alignas] = ACTIONS(6065),
    [anon_sym__Alignas] = ACTIONS(6065),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6065),
    [anon_sym_decltype] = ACTIONS(6065),
    [anon_sym_final] = ACTIONS(6065),
    [anon_sym_override] = ACTIONS(6065),
    [anon_sym_template] = ACTIONS(6065),
    [anon_sym_GT2] = ACTIONS(6067),
    [anon_sym_operator] = ACTIONS(6065),
    [anon_sym_requires] = ACTIONS(6065),
    [anon_sym_precise] = ACTIONS(6065),
    [anon_sym_shared] = ACTIONS(6065),
    [anon_sym_groupshared] = ACTIONS(6065),
    [anon_sym_uniform] = ACTIONS(6065),
    [anon_sym_row_major] = ACTIONS(6065),
    [anon_sym_column_major] = ACTIONS(6065),
    [anon_sym_globallycoherent] = ACTIONS(6065),
    [anon_sym_centroid] = ACTIONS(6065),
    [anon_sym_noperspective] = ACTIONS(6065),
    [anon_sym_nointerpolation] = ACTIONS(6065),
    [anon_sym_sample] = ACTIONS(6065),
    [anon_sym_linear] = ACTIONS(6065),
    [anon_sym_snorm] = ACTIONS(6065),
    [anon_sym_unorm] = ACTIONS(6065),
    [anon_sym_point] = ACTIONS(6065),
    [anon_sym_line] = ACTIONS(6065),
    [anon_sym_triangleadj] = ACTIONS(6065),
    [anon_sym_lineadj] = ACTIONS(6065),
    [anon_sym_triangle] = ACTIONS(6065),
  },
  [2367] = {
    [sym_attribute_specifier] = STATE(2354),
    [sym_enumerator_list] = STATE(2404),
    [sym_identifier] = ACTIONS(6069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(6071),
    [anon_sym_TILDE] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SEMI] = ACTIONS(6071),
    [anon_sym___extension__] = ACTIONS(6069),
    [anon_sym_in] = ACTIONS(6069),
    [anon_sym_out] = ACTIONS(6069),
    [anon_sym_inout] = ACTIONS(6069),
    [anon_sym_virtual] = ACTIONS(6069),
    [anon_sym_extern] = ACTIONS(6069),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6071),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6071),
    [anon_sym___declspec] = ACTIONS(6069),
    [anon_sym___based] = ACTIONS(6069),
    [anon_sym___cdecl] = ACTIONS(6069),
    [anon_sym___clrcall] = ACTIONS(6069),
    [anon_sym___stdcall] = ACTIONS(6069),
    [anon_sym___fastcall] = ACTIONS(6069),
    [anon_sym___thiscall] = ACTIONS(6069),
    [anon_sym___vectorcall] = ACTIONS(6069),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6069),
    [anon_sym_static] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_register] = ACTIONS(6069),
    [anon_sym_inline] = ACTIONS(6069),
    [anon_sym___inline] = ACTIONS(6069),
    [anon_sym___inline__] = ACTIONS(6069),
    [anon_sym___forceinline] = ACTIONS(6069),
    [anon_sym_thread_local] = ACTIONS(6069),
    [anon_sym___thread] = ACTIONS(6069),
    [anon_sym_const] = ACTIONS(6069),
    [anon_sym_constexpr] = ACTIONS(6069),
    [anon_sym_volatile] = ACTIONS(6069),
    [anon_sym_restrict] = ACTIONS(6069),
    [anon_sym___restrict__] = ACTIONS(6069),
    [anon_sym__Atomic] = ACTIONS(6069),
    [anon_sym__Noreturn] = ACTIONS(6069),
    [anon_sym_noreturn] = ACTIONS(6069),
    [anon_sym__Nonnull] = ACTIONS(6069),
    [anon_sym_mutable] = ACTIONS(6069),
    [anon_sym_constinit] = ACTIONS(6069),
    [anon_sym_consteval] = ACTIONS(6069),
    [anon_sym_alignas] = ACTIONS(6069),
    [anon_sym__Alignas] = ACTIONS(6069),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6069),
    [anon_sym_decltype] = ACTIONS(6069),
    [anon_sym_template] = ACTIONS(6069),
    [anon_sym_GT2] = ACTIONS(6071),
    [anon_sym_operator] = ACTIONS(6069),
    [anon_sym_precise] = ACTIONS(6069),
    [anon_sym_shared] = ACTIONS(6069),
    [anon_sym_groupshared] = ACTIONS(6069),
    [anon_sym_uniform] = ACTIONS(6069),
    [anon_sym_row_major] = ACTIONS(6069),
    [anon_sym_column_major] = ACTIONS(6069),
    [anon_sym_globallycoherent] = ACTIONS(6069),
    [anon_sym_centroid] = ACTIONS(6069),
    [anon_sym_noperspective] = ACTIONS(6069),
    [anon_sym_nointerpolation] = ACTIONS(6069),
    [anon_sym_sample] = ACTIONS(6069),
    [anon_sym_linear] = ACTIONS(6069),
    [anon_sym_snorm] = ACTIONS(6069),
    [anon_sym_unorm] = ACTIONS(6069),
    [anon_sym_point] = ACTIONS(6069),
    [anon_sym_line] = ACTIONS(6069),
    [anon_sym_triangleadj] = ACTIONS(6069),
    [anon_sym_lineadj] = ACTIONS(6069),
    [anon_sym_triangle] = ACTIONS(6069),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(6075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_LPAREN2] = ACTIONS(6077),
    [anon_sym_TILDE] = ACTIONS(6077),
    [anon_sym_STAR] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_COLON] = ACTIONS(6075),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym___extension__] = ACTIONS(6075),
    [anon_sym_in] = ACTIONS(6075),
    [anon_sym_out] = ACTIONS(6075),
    [anon_sym_inout] = ACTIONS(6075),
    [anon_sym_virtual] = ACTIONS(6075),
    [anon_sym_extern] = ACTIONS(6075),
    [anon_sym___attribute__] = ACTIONS(6075),
    [anon_sym___attribute] = ACTIONS(6075),
    [anon_sym_COLON_COLON] = ACTIONS(6077),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6077),
    [anon_sym___declspec] = ACTIONS(6075),
    [anon_sym___based] = ACTIONS(6075),
    [anon_sym___cdecl] = ACTIONS(6075),
    [anon_sym___clrcall] = ACTIONS(6075),
    [anon_sym___stdcall] = ACTIONS(6075),
    [anon_sym___fastcall] = ACTIONS(6075),
    [anon_sym___thiscall] = ACTIONS(6075),
    [anon_sym___vectorcall] = ACTIONS(6075),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_static] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6077),
    [anon_sym_register] = ACTIONS(6075),
    [anon_sym_inline] = ACTIONS(6075),
    [anon_sym___inline] = ACTIONS(6075),
    [anon_sym___inline__] = ACTIONS(6075),
    [anon_sym___forceinline] = ACTIONS(6075),
    [anon_sym_thread_local] = ACTIONS(6075),
    [anon_sym___thread] = ACTIONS(6075),
    [anon_sym_const] = ACTIONS(6075),
    [anon_sym_constexpr] = ACTIONS(6075),
    [anon_sym_volatile] = ACTIONS(6075),
    [anon_sym_restrict] = ACTIONS(6075),
    [anon_sym___restrict__] = ACTIONS(6075),
    [anon_sym__Atomic] = ACTIONS(6075),
    [anon_sym__Noreturn] = ACTIONS(6075),
    [anon_sym_noreturn] = ACTIONS(6075),
    [anon_sym__Nonnull] = ACTIONS(6075),
    [anon_sym_mutable] = ACTIONS(6075),
    [anon_sym_constinit] = ACTIONS(6075),
    [anon_sym_consteval] = ACTIONS(6075),
    [anon_sym_alignas] = ACTIONS(6075),
    [anon_sym__Alignas] = ACTIONS(6075),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6075),
    [anon_sym_decltype] = ACTIONS(6075),
    [anon_sym_final] = ACTIONS(6075),
    [anon_sym_override] = ACTIONS(6075),
    [anon_sym_template] = ACTIONS(6075),
    [anon_sym_GT2] = ACTIONS(6077),
    [anon_sym_operator] = ACTIONS(6075),
    [anon_sym_requires] = ACTIONS(6075),
    [anon_sym_precise] = ACTIONS(6075),
    [anon_sym_shared] = ACTIONS(6075),
    [anon_sym_groupshared] = ACTIONS(6075),
    [anon_sym_uniform] = ACTIONS(6075),
    [anon_sym_row_major] = ACTIONS(6075),
    [anon_sym_column_major] = ACTIONS(6075),
    [anon_sym_globallycoherent] = ACTIONS(6075),
    [anon_sym_centroid] = ACTIONS(6075),
    [anon_sym_noperspective] = ACTIONS(6075),
    [anon_sym_nointerpolation] = ACTIONS(6075),
    [anon_sym_sample] = ACTIONS(6075),
    [anon_sym_linear] = ACTIONS(6075),
    [anon_sym_snorm] = ACTIONS(6075),
    [anon_sym_unorm] = ACTIONS(6075),
    [anon_sym_point] = ACTIONS(6075),
    [anon_sym_line] = ACTIONS(6075),
    [anon_sym_triangleadj] = ACTIONS(6075),
    [anon_sym_lineadj] = ACTIONS(6075),
    [anon_sym_triangle] = ACTIONS(6075),
  },
  [2369] = {
    [sym_identifier] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6081),
    [anon_sym_RPAREN] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(6081),
    [anon_sym_TILDE] = ACTIONS(6081),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6079),
    [anon_sym_COLON] = ACTIONS(6079),
    [anon_sym_SEMI] = ACTIONS(6081),
    [anon_sym___extension__] = ACTIONS(6079),
    [anon_sym_in] = ACTIONS(6079),
    [anon_sym_out] = ACTIONS(6079),
    [anon_sym_inout] = ACTIONS(6079),
    [anon_sym_virtual] = ACTIONS(6079),
    [anon_sym_extern] = ACTIONS(6079),
    [anon_sym___attribute__] = ACTIONS(6079),
    [anon_sym___attribute] = ACTIONS(6079),
    [anon_sym_COLON_COLON] = ACTIONS(6081),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6081),
    [anon_sym___declspec] = ACTIONS(6079),
    [anon_sym___based] = ACTIONS(6079),
    [anon_sym___cdecl] = ACTIONS(6079),
    [anon_sym___clrcall] = ACTIONS(6079),
    [anon_sym___stdcall] = ACTIONS(6079),
    [anon_sym___fastcall] = ACTIONS(6079),
    [anon_sym___thiscall] = ACTIONS(6079),
    [anon_sym___vectorcall] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_static] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6081),
    [anon_sym_register] = ACTIONS(6079),
    [anon_sym_inline] = ACTIONS(6079),
    [anon_sym___inline] = ACTIONS(6079),
    [anon_sym___inline__] = ACTIONS(6079),
    [anon_sym___forceinline] = ACTIONS(6079),
    [anon_sym_thread_local] = ACTIONS(6079),
    [anon_sym___thread] = ACTIONS(6079),
    [anon_sym_const] = ACTIONS(6079),
    [anon_sym_constexpr] = ACTIONS(6079),
    [anon_sym_volatile] = ACTIONS(6079),
    [anon_sym_restrict] = ACTIONS(6079),
    [anon_sym___restrict__] = ACTIONS(6079),
    [anon_sym__Atomic] = ACTIONS(6079),
    [anon_sym__Noreturn] = ACTIONS(6079),
    [anon_sym_noreturn] = ACTIONS(6079),
    [anon_sym__Nonnull] = ACTIONS(6079),
    [anon_sym_mutable] = ACTIONS(6079),
    [anon_sym_constinit] = ACTIONS(6079),
    [anon_sym_consteval] = ACTIONS(6079),
    [anon_sym_alignas] = ACTIONS(6079),
    [anon_sym__Alignas] = ACTIONS(6079),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6079),
    [anon_sym_decltype] = ACTIONS(6079),
    [anon_sym_final] = ACTIONS(6079),
    [anon_sym_override] = ACTIONS(6079),
    [anon_sym_template] = ACTIONS(6079),
    [anon_sym_GT2] = ACTIONS(6081),
    [anon_sym_operator] = ACTIONS(6079),
    [anon_sym_requires] = ACTIONS(6079),
    [anon_sym_precise] = ACTIONS(6079),
    [anon_sym_shared] = ACTIONS(6079),
    [anon_sym_groupshared] = ACTIONS(6079),
    [anon_sym_uniform] = ACTIONS(6079),
    [anon_sym_row_major] = ACTIONS(6079),
    [anon_sym_column_major] = ACTIONS(6079),
    [anon_sym_globallycoherent] = ACTIONS(6079),
    [anon_sym_centroid] = ACTIONS(6079),
    [anon_sym_noperspective] = ACTIONS(6079),
    [anon_sym_nointerpolation] = ACTIONS(6079),
    [anon_sym_sample] = ACTIONS(6079),
    [anon_sym_linear] = ACTIONS(6079),
    [anon_sym_snorm] = ACTIONS(6079),
    [anon_sym_unorm] = ACTIONS(6079),
    [anon_sym_point] = ACTIONS(6079),
    [anon_sym_line] = ACTIONS(6079),
    [anon_sym_triangleadj] = ACTIONS(6079),
    [anon_sym_lineadj] = ACTIONS(6079),
    [anon_sym_triangle] = ACTIONS(6079),
  },
  [2370] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_TILDE] = ACTIONS(6013),
    [anon_sym_STAR] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_COLON] = ACTIONS(6011),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___extension__] = ACTIONS(6011),
    [anon_sym_in] = ACTIONS(6011),
    [anon_sym_out] = ACTIONS(6011),
    [anon_sym_inout] = ACTIONS(6011),
    [anon_sym_virtual] = ACTIONS(6011),
    [anon_sym_extern] = ACTIONS(6011),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym_COLON_COLON] = ACTIONS(6013),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6013),
    [anon_sym___declspec] = ACTIONS(6011),
    [anon_sym___based] = ACTIONS(6011),
    [anon_sym___cdecl] = ACTIONS(6011),
    [anon_sym___clrcall] = ACTIONS(6011),
    [anon_sym___stdcall] = ACTIONS(6011),
    [anon_sym___fastcall] = ACTIONS(6011),
    [anon_sym___thiscall] = ACTIONS(6011),
    [anon_sym___vectorcall] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6011),
    [anon_sym_static] = ACTIONS(6011),
    [anon_sym_EQ] = ACTIONS(6013),
    [anon_sym_register] = ACTIONS(6011),
    [anon_sym_inline] = ACTIONS(6011),
    [anon_sym___inline] = ACTIONS(6011),
    [anon_sym___inline__] = ACTIONS(6011),
    [anon_sym___forceinline] = ACTIONS(6011),
    [anon_sym_thread_local] = ACTIONS(6011),
    [anon_sym___thread] = ACTIONS(6011),
    [anon_sym_const] = ACTIONS(6011),
    [anon_sym_constexpr] = ACTIONS(6011),
    [anon_sym_volatile] = ACTIONS(6011),
    [anon_sym_restrict] = ACTIONS(6011),
    [anon_sym___restrict__] = ACTIONS(6011),
    [anon_sym__Atomic] = ACTIONS(6011),
    [anon_sym__Noreturn] = ACTIONS(6011),
    [anon_sym_noreturn] = ACTIONS(6011),
    [anon_sym__Nonnull] = ACTIONS(6011),
    [anon_sym_mutable] = ACTIONS(6011),
    [anon_sym_constinit] = ACTIONS(6011),
    [anon_sym_consteval] = ACTIONS(6011),
    [anon_sym_alignas] = ACTIONS(6011),
    [anon_sym__Alignas] = ACTIONS(6011),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
    [anon_sym_final] = ACTIONS(6011),
    [anon_sym_override] = ACTIONS(6011),
    [anon_sym_template] = ACTIONS(6011),
    [anon_sym_GT2] = ACTIONS(6013),
    [anon_sym_operator] = ACTIONS(6011),
    [anon_sym_requires] = ACTIONS(6011),
    [anon_sym_precise] = ACTIONS(6011),
    [anon_sym_shared] = ACTIONS(6011),
    [anon_sym_groupshared] = ACTIONS(6011),
    [anon_sym_uniform] = ACTIONS(6011),
    [anon_sym_row_major] = ACTIONS(6011),
    [anon_sym_column_major] = ACTIONS(6011),
    [anon_sym_globallycoherent] = ACTIONS(6011),
    [anon_sym_centroid] = ACTIONS(6011),
    [anon_sym_noperspective] = ACTIONS(6011),
    [anon_sym_nointerpolation] = ACTIONS(6011),
    [anon_sym_sample] = ACTIONS(6011),
    [anon_sym_linear] = ACTIONS(6011),
    [anon_sym_snorm] = ACTIONS(6011),
    [anon_sym_unorm] = ACTIONS(6011),
    [anon_sym_point] = ACTIONS(6011),
    [anon_sym_line] = ACTIONS(6011),
    [anon_sym_triangleadj] = ACTIONS(6011),
    [anon_sym_lineadj] = ACTIONS(6011),
    [anon_sym_triangle] = ACTIONS(6011),
  },
  [2371] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_TILDE] = ACTIONS(6047),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym_in] = ACTIONS(6045),
    [anon_sym_out] = ACTIONS(6045),
    [anon_sym_inout] = ACTIONS(6045),
    [anon_sym_virtual] = ACTIONS(6045),
    [anon_sym_extern] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_COLON_COLON] = ACTIONS(6047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6047),
    [anon_sym___declspec] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym___cdecl] = ACTIONS(6045),
    [anon_sym___clrcall] = ACTIONS(6045),
    [anon_sym___stdcall] = ACTIONS(6045),
    [anon_sym___fastcall] = ACTIONS(6045),
    [anon_sym___thiscall] = ACTIONS(6045),
    [anon_sym___vectorcall] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6045),
    [anon_sym_static] = ACTIONS(6045),
    [anon_sym_EQ] = ACTIONS(6047),
    [anon_sym_register] = ACTIONS(6045),
    [anon_sym_inline] = ACTIONS(6045),
    [anon_sym___inline] = ACTIONS(6045),
    [anon_sym___inline__] = ACTIONS(6045),
    [anon_sym___forceinline] = ACTIONS(6045),
    [anon_sym_thread_local] = ACTIONS(6045),
    [anon_sym___thread] = ACTIONS(6045),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_template] = ACTIONS(6045),
    [anon_sym_GT2] = ACTIONS(6047),
    [anon_sym_operator] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
    [anon_sym_precise] = ACTIONS(6045),
    [anon_sym_shared] = ACTIONS(6045),
    [anon_sym_groupshared] = ACTIONS(6045),
    [anon_sym_uniform] = ACTIONS(6045),
    [anon_sym_row_major] = ACTIONS(6045),
    [anon_sym_column_major] = ACTIONS(6045),
    [anon_sym_globallycoherent] = ACTIONS(6045),
    [anon_sym_centroid] = ACTIONS(6045),
    [anon_sym_noperspective] = ACTIONS(6045),
    [anon_sym_nointerpolation] = ACTIONS(6045),
    [anon_sym_sample] = ACTIONS(6045),
    [anon_sym_linear] = ACTIONS(6045),
    [anon_sym_snorm] = ACTIONS(6045),
    [anon_sym_unorm] = ACTIONS(6045),
    [anon_sym_point] = ACTIONS(6045),
    [anon_sym_line] = ACTIONS(6045),
    [anon_sym_triangleadj] = ACTIONS(6045),
    [anon_sym_lineadj] = ACTIONS(6045),
    [anon_sym_triangle] = ACTIONS(6045),
  },
  [2372] = {
    [sym_attribute_specifier] = STATE(2384),
    [sym_enumerator_list] = STATE(2414),
    [sym_identifier] = ACTIONS(6083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6085),
    [anon_sym_COMMA] = ACTIONS(6085),
    [anon_sym_RPAREN] = ACTIONS(6085),
    [anon_sym_LPAREN2] = ACTIONS(6085),
    [anon_sym_TILDE] = ACTIONS(6085),
    [anon_sym_STAR] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_AMP] = ACTIONS(6083),
    [anon_sym_COLON] = ACTIONS(6083),
    [anon_sym_SEMI] = ACTIONS(6085),
    [anon_sym___extension__] = ACTIONS(6083),
    [anon_sym_in] = ACTIONS(6083),
    [anon_sym_out] = ACTIONS(6083),
    [anon_sym_inout] = ACTIONS(6083),
    [anon_sym_virtual] = ACTIONS(6083),
    [anon_sym_extern] = ACTIONS(6083),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6085),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6085),
    [anon_sym___declspec] = ACTIONS(6083),
    [anon_sym___based] = ACTIONS(6083),
    [anon_sym___cdecl] = ACTIONS(6083),
    [anon_sym___clrcall] = ACTIONS(6083),
    [anon_sym___stdcall] = ACTIONS(6083),
    [anon_sym___fastcall] = ACTIONS(6083),
    [anon_sym___thiscall] = ACTIONS(6083),
    [anon_sym___vectorcall] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6083),
    [anon_sym_static] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6085),
    [anon_sym_register] = ACTIONS(6083),
    [anon_sym_inline] = ACTIONS(6083),
    [anon_sym___inline] = ACTIONS(6083),
    [anon_sym___inline__] = ACTIONS(6083),
    [anon_sym___forceinline] = ACTIONS(6083),
    [anon_sym_thread_local] = ACTIONS(6083),
    [anon_sym___thread] = ACTIONS(6083),
    [anon_sym_const] = ACTIONS(6083),
    [anon_sym_constexpr] = ACTIONS(6083),
    [anon_sym_volatile] = ACTIONS(6083),
    [anon_sym_restrict] = ACTIONS(6083),
    [anon_sym___restrict__] = ACTIONS(6083),
    [anon_sym__Atomic] = ACTIONS(6083),
    [anon_sym__Noreturn] = ACTIONS(6083),
    [anon_sym_noreturn] = ACTIONS(6083),
    [anon_sym__Nonnull] = ACTIONS(6083),
    [anon_sym_mutable] = ACTIONS(6083),
    [anon_sym_constinit] = ACTIONS(6083),
    [anon_sym_consteval] = ACTIONS(6083),
    [anon_sym_alignas] = ACTIONS(6083),
    [anon_sym__Alignas] = ACTIONS(6083),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6083),
    [anon_sym_decltype] = ACTIONS(6083),
    [anon_sym_template] = ACTIONS(6083),
    [anon_sym_GT2] = ACTIONS(6085),
    [anon_sym_operator] = ACTIONS(6083),
    [anon_sym_precise] = ACTIONS(6083),
    [anon_sym_shared] = ACTIONS(6083),
    [anon_sym_groupshared] = ACTIONS(6083),
    [anon_sym_uniform] = ACTIONS(6083),
    [anon_sym_row_major] = ACTIONS(6083),
    [anon_sym_column_major] = ACTIONS(6083),
    [anon_sym_globallycoherent] = ACTIONS(6083),
    [anon_sym_centroid] = ACTIONS(6083),
    [anon_sym_noperspective] = ACTIONS(6083),
    [anon_sym_nointerpolation] = ACTIONS(6083),
    [anon_sym_sample] = ACTIONS(6083),
    [anon_sym_linear] = ACTIONS(6083),
    [anon_sym_snorm] = ACTIONS(6083),
    [anon_sym_unorm] = ACTIONS(6083),
    [anon_sym_point] = ACTIONS(6083),
    [anon_sym_line] = ACTIONS(6083),
    [anon_sym_triangleadj] = ACTIONS(6083),
    [anon_sym_lineadj] = ACTIONS(6083),
    [anon_sym_triangle] = ACTIONS(6083),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(6087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6089),
    [anon_sym_COMMA] = ACTIONS(6089),
    [anon_sym_RPAREN] = ACTIONS(6089),
    [anon_sym_LPAREN2] = ACTIONS(6089),
    [anon_sym_TILDE] = ACTIONS(6089),
    [anon_sym_STAR] = ACTIONS(6089),
    [anon_sym_AMP_AMP] = ACTIONS(6089),
    [anon_sym_AMP] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6087),
    [anon_sym_SEMI] = ACTIONS(6089),
    [anon_sym___extension__] = ACTIONS(6087),
    [anon_sym_in] = ACTIONS(6087),
    [anon_sym_out] = ACTIONS(6087),
    [anon_sym_inout] = ACTIONS(6087),
    [anon_sym_virtual] = ACTIONS(6087),
    [anon_sym_extern] = ACTIONS(6087),
    [anon_sym___attribute__] = ACTIONS(6087),
    [anon_sym___attribute] = ACTIONS(6087),
    [anon_sym_COLON_COLON] = ACTIONS(6089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6089),
    [anon_sym___declspec] = ACTIONS(6087),
    [anon_sym___based] = ACTIONS(6087),
    [anon_sym___cdecl] = ACTIONS(6087),
    [anon_sym___clrcall] = ACTIONS(6087),
    [anon_sym___stdcall] = ACTIONS(6087),
    [anon_sym___fastcall] = ACTIONS(6087),
    [anon_sym___thiscall] = ACTIONS(6087),
    [anon_sym___vectorcall] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_static] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6089),
    [anon_sym_register] = ACTIONS(6087),
    [anon_sym_inline] = ACTIONS(6087),
    [anon_sym___inline] = ACTIONS(6087),
    [anon_sym___inline__] = ACTIONS(6087),
    [anon_sym___forceinline] = ACTIONS(6087),
    [anon_sym_thread_local] = ACTIONS(6087),
    [anon_sym___thread] = ACTIONS(6087),
    [anon_sym_const] = ACTIONS(6087),
    [anon_sym_constexpr] = ACTIONS(6087),
    [anon_sym_volatile] = ACTIONS(6087),
    [anon_sym_restrict] = ACTIONS(6087),
    [anon_sym___restrict__] = ACTIONS(6087),
    [anon_sym__Atomic] = ACTIONS(6087),
    [anon_sym__Noreturn] = ACTIONS(6087),
    [anon_sym_noreturn] = ACTIONS(6087),
    [anon_sym__Nonnull] = ACTIONS(6087),
    [anon_sym_mutable] = ACTIONS(6087),
    [anon_sym_constinit] = ACTIONS(6087),
    [anon_sym_consteval] = ACTIONS(6087),
    [anon_sym_alignas] = ACTIONS(6087),
    [anon_sym__Alignas] = ACTIONS(6087),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6087),
    [anon_sym_decltype] = ACTIONS(6087),
    [anon_sym_final] = ACTIONS(6087),
    [anon_sym_override] = ACTIONS(6087),
    [anon_sym_template] = ACTIONS(6087),
    [anon_sym_GT2] = ACTIONS(6089),
    [anon_sym_operator] = ACTIONS(6087),
    [anon_sym_requires] = ACTIONS(6087),
    [anon_sym_precise] = ACTIONS(6087),
    [anon_sym_shared] = ACTIONS(6087),
    [anon_sym_groupshared] = ACTIONS(6087),
    [anon_sym_uniform] = ACTIONS(6087),
    [anon_sym_row_major] = ACTIONS(6087),
    [anon_sym_column_major] = ACTIONS(6087),
    [anon_sym_globallycoherent] = ACTIONS(6087),
    [anon_sym_centroid] = ACTIONS(6087),
    [anon_sym_noperspective] = ACTIONS(6087),
    [anon_sym_nointerpolation] = ACTIONS(6087),
    [anon_sym_sample] = ACTIONS(6087),
    [anon_sym_linear] = ACTIONS(6087),
    [anon_sym_snorm] = ACTIONS(6087),
    [anon_sym_unorm] = ACTIONS(6087),
    [anon_sym_point] = ACTIONS(6087),
    [anon_sym_line] = ACTIONS(6087),
    [anon_sym_triangleadj] = ACTIONS(6087),
    [anon_sym_lineadj] = ACTIONS(6087),
    [anon_sym_triangle] = ACTIONS(6087),
  },
  [2374] = {
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6093),
    [anon_sym_COMMA] = ACTIONS(6093),
    [anon_sym_RPAREN] = ACTIONS(6093),
    [anon_sym_LPAREN2] = ACTIONS(6093),
    [anon_sym_TILDE] = ACTIONS(6093),
    [anon_sym_STAR] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_COLON] = ACTIONS(6091),
    [anon_sym_SEMI] = ACTIONS(6093),
    [anon_sym___extension__] = ACTIONS(6091),
    [anon_sym_in] = ACTIONS(6091),
    [anon_sym_out] = ACTIONS(6091),
    [anon_sym_inout] = ACTIONS(6091),
    [anon_sym_virtual] = ACTIONS(6091),
    [anon_sym_extern] = ACTIONS(6091),
    [anon_sym___attribute__] = ACTIONS(6091),
    [anon_sym___attribute] = ACTIONS(6091),
    [anon_sym_COLON_COLON] = ACTIONS(6093),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6093),
    [anon_sym___declspec] = ACTIONS(6091),
    [anon_sym___based] = ACTIONS(6091),
    [anon_sym___cdecl] = ACTIONS(6091),
    [anon_sym___clrcall] = ACTIONS(6091),
    [anon_sym___stdcall] = ACTIONS(6091),
    [anon_sym___fastcall] = ACTIONS(6091),
    [anon_sym___thiscall] = ACTIONS(6091),
    [anon_sym___vectorcall] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_static] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6093),
    [anon_sym_register] = ACTIONS(6091),
    [anon_sym_inline] = ACTIONS(6091),
    [anon_sym___inline] = ACTIONS(6091),
    [anon_sym___inline__] = ACTIONS(6091),
    [anon_sym___forceinline] = ACTIONS(6091),
    [anon_sym_thread_local] = ACTIONS(6091),
    [anon_sym___thread] = ACTIONS(6091),
    [anon_sym_const] = ACTIONS(6091),
    [anon_sym_constexpr] = ACTIONS(6091),
    [anon_sym_volatile] = ACTIONS(6091),
    [anon_sym_restrict] = ACTIONS(6091),
    [anon_sym___restrict__] = ACTIONS(6091),
    [anon_sym__Atomic] = ACTIONS(6091),
    [anon_sym__Noreturn] = ACTIONS(6091),
    [anon_sym_noreturn] = ACTIONS(6091),
    [anon_sym__Nonnull] = ACTIONS(6091),
    [anon_sym_mutable] = ACTIONS(6091),
    [anon_sym_constinit] = ACTIONS(6091),
    [anon_sym_consteval] = ACTIONS(6091),
    [anon_sym_alignas] = ACTIONS(6091),
    [anon_sym__Alignas] = ACTIONS(6091),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6091),
    [anon_sym_decltype] = ACTIONS(6091),
    [anon_sym_final] = ACTIONS(6091),
    [anon_sym_override] = ACTIONS(6091),
    [anon_sym_template] = ACTIONS(6091),
    [anon_sym_GT2] = ACTIONS(6093),
    [anon_sym_operator] = ACTIONS(6091),
    [anon_sym_requires] = ACTIONS(6091),
    [anon_sym_precise] = ACTIONS(6091),
    [anon_sym_shared] = ACTIONS(6091),
    [anon_sym_groupshared] = ACTIONS(6091),
    [anon_sym_uniform] = ACTIONS(6091),
    [anon_sym_row_major] = ACTIONS(6091),
    [anon_sym_column_major] = ACTIONS(6091),
    [anon_sym_globallycoherent] = ACTIONS(6091),
    [anon_sym_centroid] = ACTIONS(6091),
    [anon_sym_noperspective] = ACTIONS(6091),
    [anon_sym_nointerpolation] = ACTIONS(6091),
    [anon_sym_sample] = ACTIONS(6091),
    [anon_sym_linear] = ACTIONS(6091),
    [anon_sym_snorm] = ACTIONS(6091),
    [anon_sym_unorm] = ACTIONS(6091),
    [anon_sym_point] = ACTIONS(6091),
    [anon_sym_line] = ACTIONS(6091),
    [anon_sym_triangleadj] = ACTIONS(6091),
    [anon_sym_lineadj] = ACTIONS(6091),
    [anon_sym_triangle] = ACTIONS(6091),
  },
  [2375] = {
    [sym_identifier] = ACTIONS(6095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6097),
    [anon_sym_COMMA] = ACTIONS(6097),
    [anon_sym_RPAREN] = ACTIONS(6097),
    [anon_sym_LPAREN2] = ACTIONS(6097),
    [anon_sym_TILDE] = ACTIONS(6097),
    [anon_sym_STAR] = ACTIONS(6097),
    [anon_sym_AMP_AMP] = ACTIONS(6097),
    [anon_sym_AMP] = ACTIONS(6095),
    [anon_sym_COLON] = ACTIONS(6095),
    [anon_sym_SEMI] = ACTIONS(6097),
    [anon_sym___extension__] = ACTIONS(6095),
    [anon_sym_in] = ACTIONS(6095),
    [anon_sym_out] = ACTIONS(6095),
    [anon_sym_inout] = ACTIONS(6095),
    [anon_sym_virtual] = ACTIONS(6095),
    [anon_sym_extern] = ACTIONS(6095),
    [anon_sym___attribute__] = ACTIONS(6095),
    [anon_sym___attribute] = ACTIONS(6095),
    [anon_sym_COLON_COLON] = ACTIONS(6097),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6097),
    [anon_sym___declspec] = ACTIONS(6095),
    [anon_sym___based] = ACTIONS(6095),
    [anon_sym___cdecl] = ACTIONS(6095),
    [anon_sym___clrcall] = ACTIONS(6095),
    [anon_sym___stdcall] = ACTIONS(6095),
    [anon_sym___fastcall] = ACTIONS(6095),
    [anon_sym___thiscall] = ACTIONS(6095),
    [anon_sym___vectorcall] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_static] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6097),
    [anon_sym_register] = ACTIONS(6095),
    [anon_sym_inline] = ACTIONS(6095),
    [anon_sym___inline] = ACTIONS(6095),
    [anon_sym___inline__] = ACTIONS(6095),
    [anon_sym___forceinline] = ACTIONS(6095),
    [anon_sym_thread_local] = ACTIONS(6095),
    [anon_sym___thread] = ACTIONS(6095),
    [anon_sym_const] = ACTIONS(6095),
    [anon_sym_constexpr] = ACTIONS(6095),
    [anon_sym_volatile] = ACTIONS(6095),
    [anon_sym_restrict] = ACTIONS(6095),
    [anon_sym___restrict__] = ACTIONS(6095),
    [anon_sym__Atomic] = ACTIONS(6095),
    [anon_sym__Noreturn] = ACTIONS(6095),
    [anon_sym_noreturn] = ACTIONS(6095),
    [anon_sym__Nonnull] = ACTIONS(6095),
    [anon_sym_mutable] = ACTIONS(6095),
    [anon_sym_constinit] = ACTIONS(6095),
    [anon_sym_consteval] = ACTIONS(6095),
    [anon_sym_alignas] = ACTIONS(6095),
    [anon_sym__Alignas] = ACTIONS(6095),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6095),
    [anon_sym_decltype] = ACTIONS(6095),
    [anon_sym_final] = ACTIONS(6095),
    [anon_sym_override] = ACTIONS(6095),
    [anon_sym_template] = ACTIONS(6095),
    [anon_sym_GT2] = ACTIONS(6097),
    [anon_sym_operator] = ACTIONS(6095),
    [anon_sym_requires] = ACTIONS(6095),
    [anon_sym_precise] = ACTIONS(6095),
    [anon_sym_shared] = ACTIONS(6095),
    [anon_sym_groupshared] = ACTIONS(6095),
    [anon_sym_uniform] = ACTIONS(6095),
    [anon_sym_row_major] = ACTIONS(6095),
    [anon_sym_column_major] = ACTIONS(6095),
    [anon_sym_globallycoherent] = ACTIONS(6095),
    [anon_sym_centroid] = ACTIONS(6095),
    [anon_sym_noperspective] = ACTIONS(6095),
    [anon_sym_nointerpolation] = ACTIONS(6095),
    [anon_sym_sample] = ACTIONS(6095),
    [anon_sym_linear] = ACTIONS(6095),
    [anon_sym_snorm] = ACTIONS(6095),
    [anon_sym_unorm] = ACTIONS(6095),
    [anon_sym_point] = ACTIONS(6095),
    [anon_sym_line] = ACTIONS(6095),
    [anon_sym_triangleadj] = ACTIONS(6095),
    [anon_sym_lineadj] = ACTIONS(6095),
    [anon_sym_triangle] = ACTIONS(6095),
  },
  [2376] = {
    [sym_identifier] = ACTIONS(6099),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6101),
    [anon_sym_COMMA] = ACTIONS(6101),
    [anon_sym_RPAREN] = ACTIONS(6101),
    [anon_sym_LPAREN2] = ACTIONS(6101),
    [anon_sym_TILDE] = ACTIONS(6101),
    [anon_sym_STAR] = ACTIONS(6101),
    [anon_sym_AMP_AMP] = ACTIONS(6101),
    [anon_sym_AMP] = ACTIONS(6099),
    [anon_sym_COLON] = ACTIONS(6099),
    [anon_sym_SEMI] = ACTIONS(6101),
    [anon_sym___extension__] = ACTIONS(6099),
    [anon_sym_in] = ACTIONS(6099),
    [anon_sym_out] = ACTIONS(6099),
    [anon_sym_inout] = ACTIONS(6099),
    [anon_sym_virtual] = ACTIONS(6099),
    [anon_sym_extern] = ACTIONS(6099),
    [anon_sym___attribute__] = ACTIONS(6099),
    [anon_sym___attribute] = ACTIONS(6099),
    [anon_sym_COLON_COLON] = ACTIONS(6101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6101),
    [anon_sym___declspec] = ACTIONS(6099),
    [anon_sym___based] = ACTIONS(6099),
    [anon_sym___cdecl] = ACTIONS(6099),
    [anon_sym___clrcall] = ACTIONS(6099),
    [anon_sym___stdcall] = ACTIONS(6099),
    [anon_sym___fastcall] = ACTIONS(6099),
    [anon_sym___thiscall] = ACTIONS(6099),
    [anon_sym___vectorcall] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_static] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6101),
    [anon_sym_register] = ACTIONS(6099),
    [anon_sym_inline] = ACTIONS(6099),
    [anon_sym___inline] = ACTIONS(6099),
    [anon_sym___inline__] = ACTIONS(6099),
    [anon_sym___forceinline] = ACTIONS(6099),
    [anon_sym_thread_local] = ACTIONS(6099),
    [anon_sym___thread] = ACTIONS(6099),
    [anon_sym_const] = ACTIONS(6099),
    [anon_sym_constexpr] = ACTIONS(6099),
    [anon_sym_volatile] = ACTIONS(6099),
    [anon_sym_restrict] = ACTIONS(6099),
    [anon_sym___restrict__] = ACTIONS(6099),
    [anon_sym__Atomic] = ACTIONS(6099),
    [anon_sym__Noreturn] = ACTIONS(6099),
    [anon_sym_noreturn] = ACTIONS(6099),
    [anon_sym__Nonnull] = ACTIONS(6099),
    [anon_sym_mutable] = ACTIONS(6099),
    [anon_sym_constinit] = ACTIONS(6099),
    [anon_sym_consteval] = ACTIONS(6099),
    [anon_sym_alignas] = ACTIONS(6099),
    [anon_sym__Alignas] = ACTIONS(6099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6099),
    [anon_sym_final] = ACTIONS(6099),
    [anon_sym_override] = ACTIONS(6099),
    [anon_sym_explicit] = ACTIONS(6099),
    [anon_sym_template] = ACTIONS(6099),
    [anon_sym_GT2] = ACTIONS(6101),
    [anon_sym_operator] = ACTIONS(6099),
    [anon_sym_precise] = ACTIONS(6099),
    [anon_sym_shared] = ACTIONS(6099),
    [anon_sym_groupshared] = ACTIONS(6099),
    [anon_sym_uniform] = ACTIONS(6099),
    [anon_sym_row_major] = ACTIONS(6099),
    [anon_sym_column_major] = ACTIONS(6099),
    [anon_sym_globallycoherent] = ACTIONS(6099),
    [anon_sym_centroid] = ACTIONS(6099),
    [anon_sym_noperspective] = ACTIONS(6099),
    [anon_sym_nointerpolation] = ACTIONS(6099),
    [anon_sym_sample] = ACTIONS(6099),
    [anon_sym_linear] = ACTIONS(6099),
    [anon_sym_snorm] = ACTIONS(6099),
    [anon_sym_unorm] = ACTIONS(6099),
    [anon_sym_point] = ACTIONS(6099),
    [anon_sym_line] = ACTIONS(6099),
    [anon_sym_triangleadj] = ACTIONS(6099),
    [anon_sym_lineadj] = ACTIONS(6099),
    [anon_sym_triangle] = ACTIONS(6099),
  },
  [2377] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_TILDE] = ACTIONS(6047),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6045),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym_in] = ACTIONS(6045),
    [anon_sym_out] = ACTIONS(6045),
    [anon_sym_inout] = ACTIONS(6045),
    [anon_sym_virtual] = ACTIONS(6045),
    [anon_sym_extern] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_COLON_COLON] = ACTIONS(6047),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6047),
    [anon_sym___declspec] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym___cdecl] = ACTIONS(6045),
    [anon_sym___clrcall] = ACTIONS(6045),
    [anon_sym___stdcall] = ACTIONS(6045),
    [anon_sym___fastcall] = ACTIONS(6045),
    [anon_sym___thiscall] = ACTIONS(6045),
    [anon_sym___vectorcall] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6045),
    [anon_sym_static] = ACTIONS(6045),
    [anon_sym_EQ] = ACTIONS(6047),
    [anon_sym_register] = ACTIONS(6045),
    [anon_sym_inline] = ACTIONS(6045),
    [anon_sym___inline] = ACTIONS(6045),
    [anon_sym___inline__] = ACTIONS(6045),
    [anon_sym___forceinline] = ACTIONS(6045),
    [anon_sym_thread_local] = ACTIONS(6045),
    [anon_sym___thread] = ACTIONS(6045),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_template] = ACTIONS(6045),
    [anon_sym_GT2] = ACTIONS(6047),
    [anon_sym_operator] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
    [anon_sym_precise] = ACTIONS(6045),
    [anon_sym_shared] = ACTIONS(6045),
    [anon_sym_groupshared] = ACTIONS(6045),
    [anon_sym_uniform] = ACTIONS(6045),
    [anon_sym_row_major] = ACTIONS(6045),
    [anon_sym_column_major] = ACTIONS(6045),
    [anon_sym_globallycoherent] = ACTIONS(6045),
    [anon_sym_centroid] = ACTIONS(6045),
    [anon_sym_noperspective] = ACTIONS(6045),
    [anon_sym_nointerpolation] = ACTIONS(6045),
    [anon_sym_sample] = ACTIONS(6045),
    [anon_sym_linear] = ACTIONS(6045),
    [anon_sym_snorm] = ACTIONS(6045),
    [anon_sym_unorm] = ACTIONS(6045),
    [anon_sym_point] = ACTIONS(6045),
    [anon_sym_line] = ACTIONS(6045),
    [anon_sym_triangleadj] = ACTIONS(6045),
    [anon_sym_lineadj] = ACTIONS(6045),
    [anon_sym_triangle] = ACTIONS(6045),
  },
  [2378] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_COLON] = ACTIONS(5166),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym_in] = ACTIONS(5166),
    [anon_sym_out] = ACTIONS(5166),
    [anon_sym_inout] = ACTIONS(5166),
    [anon_sym_virtual] = ACTIONS(5166),
    [anon_sym_extern] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5168),
    [anon_sym___declspec] = ACTIONS(5166),
    [anon_sym___based] = ACTIONS(5166),
    [anon_sym___cdecl] = ACTIONS(5166),
    [anon_sym___clrcall] = ACTIONS(5166),
    [anon_sym___stdcall] = ACTIONS(5166),
    [anon_sym___fastcall] = ACTIONS(5166),
    [anon_sym___thiscall] = ACTIONS(5166),
    [anon_sym___vectorcall] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_register] = ACTIONS(5166),
    [anon_sym_inline] = ACTIONS(5166),
    [anon_sym___inline] = ACTIONS(5166),
    [anon_sym___inline__] = ACTIONS(5166),
    [anon_sym___forceinline] = ACTIONS(5166),
    [anon_sym_thread_local] = ACTIONS(5166),
    [anon_sym___thread] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_explicit] = ACTIONS(5166),
    [anon_sym_template] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
    [anon_sym_operator] = ACTIONS(5166),
    [anon_sym_precise] = ACTIONS(5166),
    [anon_sym_shared] = ACTIONS(5166),
    [anon_sym_groupshared] = ACTIONS(5166),
    [anon_sym_uniform] = ACTIONS(5166),
    [anon_sym_row_major] = ACTIONS(5166),
    [anon_sym_column_major] = ACTIONS(5166),
    [anon_sym_globallycoherent] = ACTIONS(5166),
    [anon_sym_centroid] = ACTIONS(5166),
    [anon_sym_noperspective] = ACTIONS(5166),
    [anon_sym_nointerpolation] = ACTIONS(5166),
    [anon_sym_sample] = ACTIONS(5166),
    [anon_sym_linear] = ACTIONS(5166),
    [anon_sym_snorm] = ACTIONS(5166),
    [anon_sym_unorm] = ACTIONS(5166),
    [anon_sym_point] = ACTIONS(5166),
    [anon_sym_line] = ACTIONS(5166),
    [anon_sym_triangleadj] = ACTIONS(5166),
    [anon_sym_lineadj] = ACTIONS(5166),
    [anon_sym_triangle] = ACTIONS(5166),
  },
  [2379] = {
    [sym_identifier] = ACTIONS(6103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6105),
    [anon_sym_COMMA] = ACTIONS(6105),
    [anon_sym_RPAREN] = ACTIONS(6105),
    [anon_sym_LPAREN2] = ACTIONS(6105),
    [anon_sym_TILDE] = ACTIONS(6105),
    [anon_sym_STAR] = ACTIONS(6105),
    [anon_sym_AMP_AMP] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6103),
    [anon_sym_COLON] = ACTIONS(6103),
    [anon_sym_SEMI] = ACTIONS(6105),
    [anon_sym___extension__] = ACTIONS(6103),
    [anon_sym_in] = ACTIONS(6103),
    [anon_sym_out] = ACTIONS(6103),
    [anon_sym_inout] = ACTIONS(6103),
    [anon_sym_virtual] = ACTIONS(6103),
    [anon_sym_extern] = ACTIONS(6103),
    [anon_sym___attribute__] = ACTIONS(6103),
    [anon_sym___attribute] = ACTIONS(6103),
    [anon_sym_COLON_COLON] = ACTIONS(6105),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6105),
    [anon_sym___declspec] = ACTIONS(6103),
    [anon_sym___based] = ACTIONS(6103),
    [anon_sym___cdecl] = ACTIONS(6103),
    [anon_sym___clrcall] = ACTIONS(6103),
    [anon_sym___stdcall] = ACTIONS(6103),
    [anon_sym___fastcall] = ACTIONS(6103),
    [anon_sym___thiscall] = ACTIONS(6103),
    [anon_sym___vectorcall] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(6103),
    [anon_sym_static] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6105),
    [anon_sym_register] = ACTIONS(6103),
    [anon_sym_inline] = ACTIONS(6103),
    [anon_sym___inline] = ACTIONS(6103),
    [anon_sym___inline__] = ACTIONS(6103),
    [anon_sym___forceinline] = ACTIONS(6103),
    [anon_sym_thread_local] = ACTIONS(6103),
    [anon_sym___thread] = ACTIONS(6103),
    [anon_sym_const] = ACTIONS(6103),
    [anon_sym_constexpr] = ACTIONS(6103),
    [anon_sym_volatile] = ACTIONS(6103),
    [anon_sym_restrict] = ACTIONS(6103),
    [anon_sym___restrict__] = ACTIONS(6103),
    [anon_sym__Atomic] = ACTIONS(6103),
    [anon_sym__Noreturn] = ACTIONS(6103),
    [anon_sym_noreturn] = ACTIONS(6103),
    [anon_sym__Nonnull] = ACTIONS(6103),
    [anon_sym_mutable] = ACTIONS(6103),
    [anon_sym_constinit] = ACTIONS(6103),
    [anon_sym_consteval] = ACTIONS(6103),
    [anon_sym_alignas] = ACTIONS(6103),
    [anon_sym__Alignas] = ACTIONS(6103),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6103),
    [anon_sym_decltype] = ACTIONS(6103),
    [anon_sym_final] = ACTIONS(6103),
    [anon_sym_override] = ACTIONS(6103),
    [anon_sym_template] = ACTIONS(6103),
    [anon_sym_GT2] = ACTIONS(6105),
    [anon_sym_operator] = ACTIONS(6103),
    [anon_sym_requires] = ACTIONS(6103),
    [anon_sym_precise] = ACTIONS(6103),
    [anon_sym_shared] = ACTIONS(6103),
    [anon_sym_groupshared] = ACTIONS(6103),
    [anon_sym_uniform] = ACTIONS(6103),
    [anon_sym_row_major] = ACTIONS(6103),
    [anon_sym_column_major] = ACTIONS(6103),
    [anon_sym_globallycoherent] = ACTIONS(6103),
    [anon_sym_centroid] = ACTIONS(6103),
    [anon_sym_noperspective] = ACTIONS(6103),
    [anon_sym_nointerpolation] = ACTIONS(6103),
    [anon_sym_sample] = ACTIONS(6103),
    [anon_sym_linear] = ACTIONS(6103),
    [anon_sym_snorm] = ACTIONS(6103),
    [anon_sym_unorm] = ACTIONS(6103),
    [anon_sym_point] = ACTIONS(6103),
    [anon_sym_line] = ACTIONS(6103),
    [anon_sym_triangleadj] = ACTIONS(6103),
    [anon_sym_lineadj] = ACTIONS(6103),
    [anon_sym_triangle] = ACTIONS(6103),
  },
  [2380] = {
    [sym_identifier] = ACTIONS(6107),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LPAREN2] = ACTIONS(6109),
    [anon_sym_TILDE] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_AMP_AMP] = ACTIONS(6109),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_COLON] = ACTIONS(6107),
    [anon_sym_SEMI] = ACTIONS(6109),
    [anon_sym___extension__] = ACTIONS(6107),
    [anon_sym_in] = ACTIONS(6107),
    [anon_sym_out] = ACTIONS(6107),
    [anon_sym_inout] = ACTIONS(6107),
    [anon_sym_virtual] = ACTIONS(6107),
    [anon_sym_extern] = ACTIONS(6107),
    [anon_sym___attribute__] = ACTIONS(6107),
    [anon_sym___attribute] = ACTIONS(6107),
    [anon_sym_COLON_COLON] = ACTIONS(6109),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6109),
    [anon_sym___declspec] = ACTIONS(6107),
    [anon_sym___based] = ACTIONS(6107),
    [anon_sym___cdecl] = ACTIONS(6107),
    [anon_sym___clrcall] = ACTIONS(6107),
    [anon_sym___stdcall] = ACTIONS(6107),
    [anon_sym___fastcall] = ACTIONS(6107),
    [anon_sym___thiscall] = ACTIONS(6107),
    [anon_sym___vectorcall] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_static] = ACTIONS(6107),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_register] = ACTIONS(6107),
    [anon_sym_inline] = ACTIONS(6107),
    [anon_sym___inline] = ACTIONS(6107),
    [anon_sym___inline__] = ACTIONS(6107),
    [anon_sym___forceinline] = ACTIONS(6107),
    [anon_sym_thread_local] = ACTIONS(6107),
    [anon_sym___thread] = ACTIONS(6107),
    [anon_sym_const] = ACTIONS(6107),
    [anon_sym_constexpr] = ACTIONS(6107),
    [anon_sym_volatile] = ACTIONS(6107),
    [anon_sym_restrict] = ACTIONS(6107),
    [anon_sym___restrict__] = ACTIONS(6107),
    [anon_sym__Atomic] = ACTIONS(6107),
    [anon_sym__Noreturn] = ACTIONS(6107),
    [anon_sym_noreturn] = ACTIONS(6107),
    [anon_sym__Nonnull] = ACTIONS(6107),
    [anon_sym_mutable] = ACTIONS(6107),
    [anon_sym_constinit] = ACTIONS(6107),
    [anon_sym_consteval] = ACTIONS(6107),
    [anon_sym_alignas] = ACTIONS(6107),
    [anon_sym__Alignas] = ACTIONS(6107),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6107),
    [anon_sym_decltype] = ACTIONS(6107),
    [anon_sym_final] = ACTIONS(6107),
    [anon_sym_override] = ACTIONS(6107),
    [anon_sym_template] = ACTIONS(6107),
    [anon_sym_GT2] = ACTIONS(6109),
    [anon_sym_operator] = ACTIONS(6107),
    [anon_sym_requires] = ACTIONS(6107),
    [anon_sym_precise] = ACTIONS(6107),
    [anon_sym_shared] = ACTIONS(6107),
    [anon_sym_groupshared] = ACTIONS(6107),
    [anon_sym_uniform] = ACTIONS(6107),
    [anon_sym_row_major] = ACTIONS(6107),
    [anon_sym_column_major] = ACTIONS(6107),
    [anon_sym_globallycoherent] = ACTIONS(6107),
    [anon_sym_centroid] = ACTIONS(6107),
    [anon_sym_noperspective] = ACTIONS(6107),
    [anon_sym_nointerpolation] = ACTIONS(6107),
    [anon_sym_sample] = ACTIONS(6107),
    [anon_sym_linear] = ACTIONS(6107),
    [anon_sym_snorm] = ACTIONS(6107),
    [anon_sym_unorm] = ACTIONS(6107),
    [anon_sym_point] = ACTIONS(6107),
    [anon_sym_line] = ACTIONS(6107),
    [anon_sym_triangleadj] = ACTIONS(6107),
    [anon_sym_lineadj] = ACTIONS(6107),
    [anon_sym_triangle] = ACTIONS(6107),
  },
  [2381] = {
    [sym_identifier] = ACTIONS(6111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6113),
    [anon_sym_COMMA] = ACTIONS(6113),
    [anon_sym_RPAREN] = ACTIONS(6113),
    [anon_sym_LPAREN2] = ACTIONS(6113),
    [anon_sym_TILDE] = ACTIONS(6113),
    [anon_sym_STAR] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_AMP] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SEMI] = ACTIONS(6113),
    [anon_sym___extension__] = ACTIONS(6111),
    [anon_sym_in] = ACTIONS(6111),
    [anon_sym_out] = ACTIONS(6111),
    [anon_sym_inout] = ACTIONS(6111),
    [anon_sym_virtual] = ACTIONS(6111),
    [anon_sym_extern] = ACTIONS(6111),
    [anon_sym___attribute__] = ACTIONS(6111),
    [anon_sym___attribute] = ACTIONS(6111),
    [anon_sym_COLON_COLON] = ACTIONS(6113),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6113),
    [anon_sym___declspec] = ACTIONS(6111),
    [anon_sym___based] = ACTIONS(6111),
    [anon_sym___cdecl] = ACTIONS(6111),
    [anon_sym___clrcall] = ACTIONS(6111),
    [anon_sym___stdcall] = ACTIONS(6111),
    [anon_sym___fastcall] = ACTIONS(6111),
    [anon_sym___thiscall] = ACTIONS(6111),
    [anon_sym___vectorcall] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(6111),
    [anon_sym_static] = ACTIONS(6111),
    [anon_sym_EQ] = ACTIONS(6113),
    [anon_sym_register] = ACTIONS(6111),
    [anon_sym_inline] = ACTIONS(6111),
    [anon_sym___inline] = ACTIONS(6111),
    [anon_sym___inline__] = ACTIONS(6111),
    [anon_sym___forceinline] = ACTIONS(6111),
    [anon_sym_thread_local] = ACTIONS(6111),
    [anon_sym___thread] = ACTIONS(6111),
    [anon_sym_const] = ACTIONS(6111),
    [anon_sym_constexpr] = ACTIONS(6111),
    [anon_sym_volatile] = ACTIONS(6111),
    [anon_sym_restrict] = ACTIONS(6111),
    [anon_sym___restrict__] = ACTIONS(6111),
    [anon_sym__Atomic] = ACTIONS(6111),
    [anon_sym__Noreturn] = ACTIONS(6111),
    [anon_sym_noreturn] = ACTIONS(6111),
    [anon_sym__Nonnull] = ACTIONS(6111),
    [anon_sym_mutable] = ACTIONS(6111),
    [anon_sym_constinit] = ACTIONS(6111),
    [anon_sym_consteval] = ACTIONS(6111),
    [anon_sym_alignas] = ACTIONS(6111),
    [anon_sym__Alignas] = ACTIONS(6111),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6111),
    [anon_sym_decltype] = ACTIONS(6111),
    [anon_sym_final] = ACTIONS(6111),
    [anon_sym_override] = ACTIONS(6111),
    [anon_sym_template] = ACTIONS(6111),
    [anon_sym_GT2] = ACTIONS(6113),
    [anon_sym_operator] = ACTIONS(6111),
    [anon_sym_requires] = ACTIONS(6111),
    [anon_sym_precise] = ACTIONS(6111),
    [anon_sym_shared] = ACTIONS(6111),
    [anon_sym_groupshared] = ACTIONS(6111),
    [anon_sym_uniform] = ACTIONS(6111),
    [anon_sym_row_major] = ACTIONS(6111),
    [anon_sym_column_major] = ACTIONS(6111),
    [anon_sym_globallycoherent] = ACTIONS(6111),
    [anon_sym_centroid] = ACTIONS(6111),
    [anon_sym_noperspective] = ACTIONS(6111),
    [anon_sym_nointerpolation] = ACTIONS(6111),
    [anon_sym_sample] = ACTIONS(6111),
    [anon_sym_linear] = ACTIONS(6111),
    [anon_sym_snorm] = ACTIONS(6111),
    [anon_sym_unorm] = ACTIONS(6111),
    [anon_sym_point] = ACTIONS(6111),
    [anon_sym_line] = ACTIONS(6111),
    [anon_sym_triangleadj] = ACTIONS(6111),
    [anon_sym_lineadj] = ACTIONS(6111),
    [anon_sym_triangle] = ACTIONS(6111),
  },
  [2382] = {
    [sym_type_qualifier] = STATE(2382),
    [sym_alignas_qualifier] = STATE(2433),
    [aux_sym__type_definition_type_repeat1] = STATE(2382),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5024),
    [anon_sym_GT_GT] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(6115),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(6115),
    [anon_sym_constexpr] = ACTIONS(6115),
    [anon_sym_volatile] = ACTIONS(6115),
    [anon_sym_restrict] = ACTIONS(6115),
    [anon_sym___restrict__] = ACTIONS(6115),
    [anon_sym__Atomic] = ACTIONS(6115),
    [anon_sym__Noreturn] = ACTIONS(6115),
    [anon_sym_noreturn] = ACTIONS(6115),
    [anon_sym__Nonnull] = ACTIONS(6115),
    [anon_sym_mutable] = ACTIONS(6115),
    [anon_sym_constinit] = ACTIONS(6115),
    [anon_sym_consteval] = ACTIONS(6115),
    [anon_sym_alignas] = ACTIONS(6118),
    [anon_sym__Alignas] = ACTIONS(6118),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_STAR_EQ] = ACTIONS(5026),
    [anon_sym_SLASH_EQ] = ACTIONS(5026),
    [anon_sym_PERCENT_EQ] = ACTIONS(5026),
    [anon_sym_PLUS_EQ] = ACTIONS(5026),
    [anon_sym_DASH_EQ] = ACTIONS(5026),
    [anon_sym_LT_LT_EQ] = ACTIONS(5026),
    [anon_sym_GT_GT_EQ] = ACTIONS(5026),
    [anon_sym_AMP_EQ] = ACTIONS(5026),
    [anon_sym_CARET_EQ] = ACTIONS(5026),
    [anon_sym_PIPE_EQ] = ACTIONS(5026),
    [anon_sym_and_eq] = ACTIONS(5024),
    [anon_sym_or_eq] = ACTIONS(5024),
    [anon_sym_xor_eq] = ACTIONS(5024),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5026),
  },
  [2383] = {
    [sym_identifier] = ACTIONS(6121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_TILDE] = ACTIONS(6123),
    [anon_sym_STAR] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_COLON] = ACTIONS(6121),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___extension__] = ACTIONS(6121),
    [anon_sym_in] = ACTIONS(6121),
    [anon_sym_out] = ACTIONS(6121),
    [anon_sym_inout] = ACTIONS(6121),
    [anon_sym_virtual] = ACTIONS(6121),
    [anon_sym_extern] = ACTIONS(6121),
    [anon_sym___attribute__] = ACTIONS(6121),
    [anon_sym___attribute] = ACTIONS(6121),
    [anon_sym_COLON_COLON] = ACTIONS(6123),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6123),
    [anon_sym___declspec] = ACTIONS(6121),
    [anon_sym___based] = ACTIONS(6121),
    [anon_sym___cdecl] = ACTIONS(6121),
    [anon_sym___clrcall] = ACTIONS(6121),
    [anon_sym___stdcall] = ACTIONS(6121),
    [anon_sym___fastcall] = ACTIONS(6121),
    [anon_sym___thiscall] = ACTIONS(6121),
    [anon_sym___vectorcall] = ACTIONS(6121),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_static] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6123),
    [anon_sym_register] = ACTIONS(6121),
    [anon_sym_inline] = ACTIONS(6121),
    [anon_sym___inline] = ACTIONS(6121),
    [anon_sym___inline__] = ACTIONS(6121),
    [anon_sym___forceinline] = ACTIONS(6121),
    [anon_sym_thread_local] = ACTIONS(6121),
    [anon_sym___thread] = ACTIONS(6121),
    [anon_sym_const] = ACTIONS(6121),
    [anon_sym_constexpr] = ACTIONS(6121),
    [anon_sym_volatile] = ACTIONS(6121),
    [anon_sym_restrict] = ACTIONS(6121),
    [anon_sym___restrict__] = ACTIONS(6121),
    [anon_sym__Atomic] = ACTIONS(6121),
    [anon_sym__Noreturn] = ACTIONS(6121),
    [anon_sym_noreturn] = ACTIONS(6121),
    [anon_sym__Nonnull] = ACTIONS(6121),
    [anon_sym_mutable] = ACTIONS(6121),
    [anon_sym_constinit] = ACTIONS(6121),
    [anon_sym_consteval] = ACTIONS(6121),
    [anon_sym_alignas] = ACTIONS(6121),
    [anon_sym__Alignas] = ACTIONS(6121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6121),
    [anon_sym_decltype] = ACTIONS(6121),
    [anon_sym_final] = ACTIONS(6121),
    [anon_sym_override] = ACTIONS(6121),
    [anon_sym_template] = ACTIONS(6121),
    [anon_sym_GT2] = ACTIONS(6123),
    [anon_sym_operator] = ACTIONS(6121),
    [anon_sym_requires] = ACTIONS(6121),
    [anon_sym_precise] = ACTIONS(6121),
    [anon_sym_shared] = ACTIONS(6121),
    [anon_sym_groupshared] = ACTIONS(6121),
    [anon_sym_uniform] = ACTIONS(6121),
    [anon_sym_row_major] = ACTIONS(6121),
    [anon_sym_column_major] = ACTIONS(6121),
    [anon_sym_globallycoherent] = ACTIONS(6121),
    [anon_sym_centroid] = ACTIONS(6121),
    [anon_sym_noperspective] = ACTIONS(6121),
    [anon_sym_nointerpolation] = ACTIONS(6121),
    [anon_sym_sample] = ACTIONS(6121),
    [anon_sym_linear] = ACTIONS(6121),
    [anon_sym_snorm] = ACTIONS(6121),
    [anon_sym_unorm] = ACTIONS(6121),
    [anon_sym_point] = ACTIONS(6121),
    [anon_sym_line] = ACTIONS(6121),
    [anon_sym_triangleadj] = ACTIONS(6121),
    [anon_sym_lineadj] = ACTIONS(6121),
    [anon_sym_triangle] = ACTIONS(6121),
  },
  [2384] = {
    [sym_identifier] = ACTIONS(6125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6127),
    [anon_sym_COMMA] = ACTIONS(6127),
    [anon_sym_RPAREN] = ACTIONS(6127),
    [anon_sym_LPAREN2] = ACTIONS(6127),
    [anon_sym_TILDE] = ACTIONS(6127),
    [anon_sym_STAR] = ACTIONS(6127),
    [anon_sym_AMP_AMP] = ACTIONS(6127),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_COLON] = ACTIONS(6125),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym___extension__] = ACTIONS(6125),
    [anon_sym_in] = ACTIONS(6125),
    [anon_sym_out] = ACTIONS(6125),
    [anon_sym_inout] = ACTIONS(6125),
    [anon_sym_virtual] = ACTIONS(6125),
    [anon_sym_extern] = ACTIONS(6125),
    [anon_sym___attribute__] = ACTIONS(6125),
    [anon_sym___attribute] = ACTIONS(6125),
    [anon_sym_COLON_COLON] = ACTIONS(6127),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6127),
    [anon_sym___declspec] = ACTIONS(6125),
    [anon_sym___based] = ACTIONS(6125),
    [anon_sym___cdecl] = ACTIONS(6125),
    [anon_sym___clrcall] = ACTIONS(6125),
    [anon_sym___stdcall] = ACTIONS(6125),
    [anon_sym___fastcall] = ACTIONS(6125),
    [anon_sym___thiscall] = ACTIONS(6125),
    [anon_sym___vectorcall] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_static] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6127),
    [anon_sym_register] = ACTIONS(6125),
    [anon_sym_inline] = ACTIONS(6125),
    [anon_sym___inline] = ACTIONS(6125),
    [anon_sym___inline__] = ACTIONS(6125),
    [anon_sym___forceinline] = ACTIONS(6125),
    [anon_sym_thread_local] = ACTIONS(6125),
    [anon_sym___thread] = ACTIONS(6125),
    [anon_sym_const] = ACTIONS(6125),
    [anon_sym_constexpr] = ACTIONS(6125),
    [anon_sym_volatile] = ACTIONS(6125),
    [anon_sym_restrict] = ACTIONS(6125),
    [anon_sym___restrict__] = ACTIONS(6125),
    [anon_sym__Atomic] = ACTIONS(6125),
    [anon_sym__Noreturn] = ACTIONS(6125),
    [anon_sym_noreturn] = ACTIONS(6125),
    [anon_sym__Nonnull] = ACTIONS(6125),
    [anon_sym_mutable] = ACTIONS(6125),
    [anon_sym_constinit] = ACTIONS(6125),
    [anon_sym_consteval] = ACTIONS(6125),
    [anon_sym_alignas] = ACTIONS(6125),
    [anon_sym__Alignas] = ACTIONS(6125),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6125),
    [anon_sym_decltype] = ACTIONS(6125),
    [anon_sym_final] = ACTIONS(6125),
    [anon_sym_override] = ACTIONS(6125),
    [anon_sym_template] = ACTIONS(6125),
    [anon_sym_GT2] = ACTIONS(6127),
    [anon_sym_operator] = ACTIONS(6125),
    [anon_sym_requires] = ACTIONS(6125),
    [anon_sym_precise] = ACTIONS(6125),
    [anon_sym_shared] = ACTIONS(6125),
    [anon_sym_groupshared] = ACTIONS(6125),
    [anon_sym_uniform] = ACTIONS(6125),
    [anon_sym_row_major] = ACTIONS(6125),
    [anon_sym_column_major] = ACTIONS(6125),
    [anon_sym_globallycoherent] = ACTIONS(6125),
    [anon_sym_centroid] = ACTIONS(6125),
    [anon_sym_noperspective] = ACTIONS(6125),
    [anon_sym_nointerpolation] = ACTIONS(6125),
    [anon_sym_sample] = ACTIONS(6125),
    [anon_sym_linear] = ACTIONS(6125),
    [anon_sym_snorm] = ACTIONS(6125),
    [anon_sym_unorm] = ACTIONS(6125),
    [anon_sym_point] = ACTIONS(6125),
    [anon_sym_line] = ACTIONS(6125),
    [anon_sym_triangleadj] = ACTIONS(6125),
    [anon_sym_lineadj] = ACTIONS(6125),
    [anon_sym_triangle] = ACTIONS(6125),
  },
  [2385] = {
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RPAREN] = ACTIONS(6131),
    [anon_sym_LPAREN2] = ACTIONS(6131),
    [anon_sym_TILDE] = ACTIONS(6131),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(6129),
    [anon_sym_COLON] = ACTIONS(6129),
    [anon_sym_SEMI] = ACTIONS(6131),
    [anon_sym___extension__] = ACTIONS(6129),
    [anon_sym_in] = ACTIONS(6129),
    [anon_sym_out] = ACTIONS(6129),
    [anon_sym_inout] = ACTIONS(6129),
    [anon_sym_virtual] = ACTIONS(6129),
    [anon_sym_extern] = ACTIONS(6129),
    [anon_sym___attribute__] = ACTIONS(6129),
    [anon_sym___attribute] = ACTIONS(6129),
    [anon_sym_COLON_COLON] = ACTIONS(6131),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6131),
    [anon_sym___declspec] = ACTIONS(6129),
    [anon_sym___based] = ACTIONS(6129),
    [anon_sym___cdecl] = ACTIONS(6129),
    [anon_sym___clrcall] = ACTIONS(6129),
    [anon_sym___stdcall] = ACTIONS(6129),
    [anon_sym___fastcall] = ACTIONS(6129),
    [anon_sym___thiscall] = ACTIONS(6129),
    [anon_sym___vectorcall] = ACTIONS(6129),
    [anon_sym_LBRACK] = ACTIONS(6129),
    [anon_sym_static] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6131),
    [anon_sym_register] = ACTIONS(6129),
    [anon_sym_inline] = ACTIONS(6129),
    [anon_sym___inline] = ACTIONS(6129),
    [anon_sym___inline__] = ACTIONS(6129),
    [anon_sym___forceinline] = ACTIONS(6129),
    [anon_sym_thread_local] = ACTIONS(6129),
    [anon_sym___thread] = ACTIONS(6129),
    [anon_sym_const] = ACTIONS(6129),
    [anon_sym_constexpr] = ACTIONS(6129),
    [anon_sym_volatile] = ACTIONS(6129),
    [anon_sym_restrict] = ACTIONS(6129),
    [anon_sym___restrict__] = ACTIONS(6129),
    [anon_sym__Atomic] = ACTIONS(6129),
    [anon_sym__Noreturn] = ACTIONS(6129),
    [anon_sym_noreturn] = ACTIONS(6129),
    [anon_sym__Nonnull] = ACTIONS(6129),
    [anon_sym_mutable] = ACTIONS(6129),
    [anon_sym_constinit] = ACTIONS(6129),
    [anon_sym_consteval] = ACTIONS(6129),
    [anon_sym_alignas] = ACTIONS(6129),
    [anon_sym__Alignas] = ACTIONS(6129),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6129),
    [anon_sym_decltype] = ACTIONS(6129),
    [anon_sym_final] = ACTIONS(6129),
    [anon_sym_override] = ACTIONS(6129),
    [anon_sym_template] = ACTIONS(6129),
    [anon_sym_GT2] = ACTIONS(6131),
    [anon_sym_operator] = ACTIONS(6129),
    [anon_sym_requires] = ACTIONS(6129),
    [anon_sym_precise] = ACTIONS(6129),
    [anon_sym_shared] = ACTIONS(6129),
    [anon_sym_groupshared] = ACTIONS(6129),
    [anon_sym_uniform] = ACTIONS(6129),
    [anon_sym_row_major] = ACTIONS(6129),
    [anon_sym_column_major] = ACTIONS(6129),
    [anon_sym_globallycoherent] = ACTIONS(6129),
    [anon_sym_centroid] = ACTIONS(6129),
    [anon_sym_noperspective] = ACTIONS(6129),
    [anon_sym_nointerpolation] = ACTIONS(6129),
    [anon_sym_sample] = ACTIONS(6129),
    [anon_sym_linear] = ACTIONS(6129),
    [anon_sym_snorm] = ACTIONS(6129),
    [anon_sym_unorm] = ACTIONS(6129),
    [anon_sym_point] = ACTIONS(6129),
    [anon_sym_line] = ACTIONS(6129),
    [anon_sym_triangleadj] = ACTIONS(6129),
    [anon_sym_lineadj] = ACTIONS(6129),
    [anon_sym_triangle] = ACTIONS(6129),
  },
  [2386] = {
    [sym_identifier] = ACTIONS(6133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_LPAREN2] = ACTIONS(6135),
    [anon_sym_TILDE] = ACTIONS(6135),
    [anon_sym_STAR] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_AMP] = ACTIONS(6133),
    [anon_sym_COLON] = ACTIONS(6133),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym___extension__] = ACTIONS(6133),
    [anon_sym_in] = ACTIONS(6133),
    [anon_sym_out] = ACTIONS(6133),
    [anon_sym_inout] = ACTIONS(6133),
    [anon_sym_virtual] = ACTIONS(6133),
    [anon_sym_extern] = ACTIONS(6133),
    [anon_sym___attribute__] = ACTIONS(6133),
    [anon_sym___attribute] = ACTIONS(6133),
    [anon_sym_COLON_COLON] = ACTIONS(6135),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6135),
    [anon_sym___declspec] = ACTIONS(6133),
    [anon_sym___based] = ACTIONS(6133),
    [anon_sym___cdecl] = ACTIONS(6133),
    [anon_sym___clrcall] = ACTIONS(6133),
    [anon_sym___stdcall] = ACTIONS(6133),
    [anon_sym___fastcall] = ACTIONS(6133),
    [anon_sym___thiscall] = ACTIONS(6133),
    [anon_sym___vectorcall] = ACTIONS(6133),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_static] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6135),
    [anon_sym_register] = ACTIONS(6133),
    [anon_sym_inline] = ACTIONS(6133),
    [anon_sym___inline] = ACTIONS(6133),
    [anon_sym___inline__] = ACTIONS(6133),
    [anon_sym___forceinline] = ACTIONS(6133),
    [anon_sym_thread_local] = ACTIONS(6133),
    [anon_sym___thread] = ACTIONS(6133),
    [anon_sym_const] = ACTIONS(6133),
    [anon_sym_constexpr] = ACTIONS(6133),
    [anon_sym_volatile] = ACTIONS(6133),
    [anon_sym_restrict] = ACTIONS(6133),
    [anon_sym___restrict__] = ACTIONS(6133),
    [anon_sym__Atomic] = ACTIONS(6133),
    [anon_sym__Noreturn] = ACTIONS(6133),
    [anon_sym_noreturn] = ACTIONS(6133),
    [anon_sym__Nonnull] = ACTIONS(6133),
    [anon_sym_mutable] = ACTIONS(6133),
    [anon_sym_constinit] = ACTIONS(6133),
    [anon_sym_consteval] = ACTIONS(6133),
    [anon_sym_alignas] = ACTIONS(6133),
    [anon_sym__Alignas] = ACTIONS(6133),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6133),
    [anon_sym_decltype] = ACTIONS(6133),
    [anon_sym_final] = ACTIONS(6133),
    [anon_sym_override] = ACTIONS(6133),
    [anon_sym_template] = ACTIONS(6133),
    [anon_sym_GT2] = ACTIONS(6135),
    [anon_sym_operator] = ACTIONS(6133),
    [anon_sym_requires] = ACTIONS(6133),
    [anon_sym_precise] = ACTIONS(6133),
    [anon_sym_shared] = ACTIONS(6133),
    [anon_sym_groupshared] = ACTIONS(6133),
    [anon_sym_uniform] = ACTIONS(6133),
    [anon_sym_row_major] = ACTIONS(6133),
    [anon_sym_column_major] = ACTIONS(6133),
    [anon_sym_globallycoherent] = ACTIONS(6133),
    [anon_sym_centroid] = ACTIONS(6133),
    [anon_sym_noperspective] = ACTIONS(6133),
    [anon_sym_nointerpolation] = ACTIONS(6133),
    [anon_sym_sample] = ACTIONS(6133),
    [anon_sym_linear] = ACTIONS(6133),
    [anon_sym_snorm] = ACTIONS(6133),
    [anon_sym_unorm] = ACTIONS(6133),
    [anon_sym_point] = ACTIONS(6133),
    [anon_sym_line] = ACTIONS(6133),
    [anon_sym_triangleadj] = ACTIONS(6133),
    [anon_sym_lineadj] = ACTIONS(6133),
    [anon_sym_triangle] = ACTIONS(6133),
  },
  [2387] = {
    [sym_identifier] = ACTIONS(6137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6139),
    [anon_sym_COMMA] = ACTIONS(6139),
    [anon_sym_RPAREN] = ACTIONS(6139),
    [anon_sym_LPAREN2] = ACTIONS(6139),
    [anon_sym_TILDE] = ACTIONS(6139),
    [anon_sym_STAR] = ACTIONS(6139),
    [anon_sym_AMP_AMP] = ACTIONS(6139),
    [anon_sym_AMP] = ACTIONS(6137),
    [anon_sym_COLON] = ACTIONS(6137),
    [anon_sym_SEMI] = ACTIONS(6139),
    [anon_sym___extension__] = ACTIONS(6137),
    [anon_sym_in] = ACTIONS(6137),
    [anon_sym_out] = ACTIONS(6137),
    [anon_sym_inout] = ACTIONS(6137),
    [anon_sym_virtual] = ACTIONS(6137),
    [anon_sym_extern] = ACTIONS(6137),
    [anon_sym___attribute__] = ACTIONS(6137),
    [anon_sym___attribute] = ACTIONS(6137),
    [anon_sym_COLON_COLON] = ACTIONS(6139),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6139),
    [anon_sym___declspec] = ACTIONS(6137),
    [anon_sym___based] = ACTIONS(6137),
    [anon_sym___cdecl] = ACTIONS(6137),
    [anon_sym___clrcall] = ACTIONS(6137),
    [anon_sym___stdcall] = ACTIONS(6137),
    [anon_sym___fastcall] = ACTIONS(6137),
    [anon_sym___thiscall] = ACTIONS(6137),
    [anon_sym___vectorcall] = ACTIONS(6137),
    [anon_sym_LBRACK] = ACTIONS(6137),
    [anon_sym_static] = ACTIONS(6137),
    [anon_sym_EQ] = ACTIONS(6139),
    [anon_sym_register] = ACTIONS(6137),
    [anon_sym_inline] = ACTIONS(6137),
    [anon_sym___inline] = ACTIONS(6137),
    [anon_sym___inline__] = ACTIONS(6137),
    [anon_sym___forceinline] = ACTIONS(6137),
    [anon_sym_thread_local] = ACTIONS(6137),
    [anon_sym___thread] = ACTIONS(6137),
    [anon_sym_const] = ACTIONS(6137),
    [anon_sym_constexpr] = ACTIONS(6137),
    [anon_sym_volatile] = ACTIONS(6137),
    [anon_sym_restrict] = ACTIONS(6137),
    [anon_sym___restrict__] = ACTIONS(6137),
    [anon_sym__Atomic] = ACTIONS(6137),
    [anon_sym__Noreturn] = ACTIONS(6137),
    [anon_sym_noreturn] = ACTIONS(6137),
    [anon_sym__Nonnull] = ACTIONS(6137),
    [anon_sym_mutable] = ACTIONS(6137),
    [anon_sym_constinit] = ACTIONS(6137),
    [anon_sym_consteval] = ACTIONS(6137),
    [anon_sym_alignas] = ACTIONS(6137),
    [anon_sym__Alignas] = ACTIONS(6137),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6137),
    [anon_sym_decltype] = ACTIONS(6137),
    [anon_sym_final] = ACTIONS(6137),
    [anon_sym_override] = ACTIONS(6137),
    [anon_sym_template] = ACTIONS(6137),
    [anon_sym_GT2] = ACTIONS(6139),
    [anon_sym_operator] = ACTIONS(6137),
    [anon_sym_requires] = ACTIONS(6137),
    [anon_sym_precise] = ACTIONS(6137),
    [anon_sym_shared] = ACTIONS(6137),
    [anon_sym_groupshared] = ACTIONS(6137),
    [anon_sym_uniform] = ACTIONS(6137),
    [anon_sym_row_major] = ACTIONS(6137),
    [anon_sym_column_major] = ACTIONS(6137),
    [anon_sym_globallycoherent] = ACTIONS(6137),
    [anon_sym_centroid] = ACTIONS(6137),
    [anon_sym_noperspective] = ACTIONS(6137),
    [anon_sym_nointerpolation] = ACTIONS(6137),
    [anon_sym_sample] = ACTIONS(6137),
    [anon_sym_linear] = ACTIONS(6137),
    [anon_sym_snorm] = ACTIONS(6137),
    [anon_sym_unorm] = ACTIONS(6137),
    [anon_sym_point] = ACTIONS(6137),
    [anon_sym_line] = ACTIONS(6137),
    [anon_sym_triangleadj] = ACTIONS(6137),
    [anon_sym_lineadj] = ACTIONS(6137),
    [anon_sym_triangle] = ACTIONS(6137),
  },
  [2388] = {
    [sym_identifier] = ACTIONS(6141),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6143),
    [anon_sym_COMMA] = ACTIONS(6143),
    [anon_sym_RPAREN] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(6143),
    [anon_sym_TILDE] = ACTIONS(6143),
    [anon_sym_STAR] = ACTIONS(6143),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_AMP] = ACTIONS(6141),
    [anon_sym_COLON] = ACTIONS(6141),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym___extension__] = ACTIONS(6141),
    [anon_sym_in] = ACTIONS(6141),
    [anon_sym_out] = ACTIONS(6141),
    [anon_sym_inout] = ACTIONS(6141),
    [anon_sym_virtual] = ACTIONS(6141),
    [anon_sym_extern] = ACTIONS(6141),
    [anon_sym___attribute__] = ACTIONS(6141),
    [anon_sym___attribute] = ACTIONS(6141),
    [anon_sym_COLON_COLON] = ACTIONS(6143),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6143),
    [anon_sym___declspec] = ACTIONS(6141),
    [anon_sym___based] = ACTIONS(6141),
    [anon_sym___cdecl] = ACTIONS(6141),
    [anon_sym___clrcall] = ACTIONS(6141),
    [anon_sym___stdcall] = ACTIONS(6141),
    [anon_sym___fastcall] = ACTIONS(6141),
    [anon_sym___thiscall] = ACTIONS(6141),
    [anon_sym___vectorcall] = ACTIONS(6141),
    [anon_sym_LBRACK] = ACTIONS(6141),
    [anon_sym_static] = ACTIONS(6141),
    [anon_sym_EQ] = ACTIONS(6143),
    [anon_sym_register] = ACTIONS(6141),
    [anon_sym_inline] = ACTIONS(6141),
    [anon_sym___inline] = ACTIONS(6141),
    [anon_sym___inline__] = ACTIONS(6141),
    [anon_sym___forceinline] = ACTIONS(6141),
    [anon_sym_thread_local] = ACTIONS(6141),
    [anon_sym___thread] = ACTIONS(6141),
    [anon_sym_const] = ACTIONS(6141),
    [anon_sym_constexpr] = ACTIONS(6141),
    [anon_sym_volatile] = ACTIONS(6141),
    [anon_sym_restrict] = ACTIONS(6141),
    [anon_sym___restrict__] = ACTIONS(6141),
    [anon_sym__Atomic] = ACTIONS(6141),
    [anon_sym__Noreturn] = ACTIONS(6141),
    [anon_sym_noreturn] = ACTIONS(6141),
    [anon_sym__Nonnull] = ACTIONS(6141),
    [anon_sym_mutable] = ACTIONS(6141),
    [anon_sym_constinit] = ACTIONS(6141),
    [anon_sym_consteval] = ACTIONS(6141),
    [anon_sym_alignas] = ACTIONS(6141),
    [anon_sym__Alignas] = ACTIONS(6141),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6141),
    [anon_sym_decltype] = ACTIONS(6141),
    [anon_sym_final] = ACTIONS(6141),
    [anon_sym_override] = ACTIONS(6141),
    [anon_sym_template] = ACTIONS(6141),
    [anon_sym_GT2] = ACTIONS(6143),
    [anon_sym_operator] = ACTIONS(6141),
    [anon_sym_requires] = ACTIONS(6141),
    [anon_sym_precise] = ACTIONS(6141),
    [anon_sym_shared] = ACTIONS(6141),
    [anon_sym_groupshared] = ACTIONS(6141),
    [anon_sym_uniform] = ACTIONS(6141),
    [anon_sym_row_major] = ACTIONS(6141),
    [anon_sym_column_major] = ACTIONS(6141),
    [anon_sym_globallycoherent] = ACTIONS(6141),
    [anon_sym_centroid] = ACTIONS(6141),
    [anon_sym_noperspective] = ACTIONS(6141),
    [anon_sym_nointerpolation] = ACTIONS(6141),
    [anon_sym_sample] = ACTIONS(6141),
    [anon_sym_linear] = ACTIONS(6141),
    [anon_sym_snorm] = ACTIONS(6141),
    [anon_sym_unorm] = ACTIONS(6141),
    [anon_sym_point] = ACTIONS(6141),
    [anon_sym_line] = ACTIONS(6141),
    [anon_sym_triangleadj] = ACTIONS(6141),
    [anon_sym_lineadj] = ACTIONS(6141),
    [anon_sym_triangle] = ACTIONS(6141),
  },
  [2389] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6145),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2390] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6147),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2391] = {
    [sym_type_qualifier] = STATE(2391),
    [sym_alignas_qualifier] = STATE(2446),
    [aux_sym__type_definition_type_repeat1] = STATE(2391),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5024),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5024),
    [anon_sym_GT_GT] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(6149),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(6149),
    [anon_sym_constexpr] = ACTIONS(6149),
    [anon_sym_volatile] = ACTIONS(6149),
    [anon_sym_restrict] = ACTIONS(6149),
    [anon_sym___restrict__] = ACTIONS(6149),
    [anon_sym__Atomic] = ACTIONS(6149),
    [anon_sym__Noreturn] = ACTIONS(6149),
    [anon_sym_noreturn] = ACTIONS(6149),
    [anon_sym__Nonnull] = ACTIONS(6149),
    [anon_sym_mutable] = ACTIONS(6149),
    [anon_sym_constinit] = ACTIONS(6149),
    [anon_sym_consteval] = ACTIONS(6149),
    [anon_sym_alignas] = ACTIONS(6152),
    [anon_sym__Alignas] = ACTIONS(6152),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_STAR_EQ] = ACTIONS(5026),
    [anon_sym_SLASH_EQ] = ACTIONS(5026),
    [anon_sym_PERCENT_EQ] = ACTIONS(5026),
    [anon_sym_PLUS_EQ] = ACTIONS(5026),
    [anon_sym_DASH_EQ] = ACTIONS(5026),
    [anon_sym_LT_LT_EQ] = ACTIONS(5026),
    [anon_sym_GT_GT_EQ] = ACTIONS(5024),
    [anon_sym_AMP_EQ] = ACTIONS(5026),
    [anon_sym_CARET_EQ] = ACTIONS(5026),
    [anon_sym_PIPE_EQ] = ACTIONS(5026),
    [anon_sym_and_eq] = ACTIONS(5024),
    [anon_sym_or_eq] = ACTIONS(5024),
    [anon_sym_xor_eq] = ACTIONS(5024),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_GT2] = ACTIONS(5026),
  },
  [2392] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6155),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2393] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6157),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2394] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6159),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2395] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6161),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2396] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6163),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2397] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6165),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2398] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6167),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2399] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6169),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2400] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6171),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2401] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6173),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2402] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6175),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2403] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_TILDE] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(6177),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(5868),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym___cdecl] = ACTIONS(5866),
    [anon_sym___clrcall] = ACTIONS(5866),
    [anon_sym___stdcall] = ACTIONS(5866),
    [anon_sym___fastcall] = ACTIONS(5866),
    [anon_sym___thiscall] = ACTIONS(5866),
    [anon_sym___vectorcall] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_template] = ACTIONS(5866),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2404] = {
    [sym_attribute_specifier] = STATE(2385),
    [sym_identifier] = ACTIONS(6179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6181),
    [anon_sym_COMMA] = ACTIONS(6181),
    [anon_sym_RPAREN] = ACTIONS(6181),
    [anon_sym_LPAREN2] = ACTIONS(6181),
    [anon_sym_TILDE] = ACTIONS(6181),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_AMP] = ACTIONS(6179),
    [anon_sym_COLON] = ACTIONS(6179),
    [anon_sym_SEMI] = ACTIONS(6181),
    [anon_sym___extension__] = ACTIONS(6179),
    [anon_sym_in] = ACTIONS(6179),
    [anon_sym_out] = ACTIONS(6179),
    [anon_sym_inout] = ACTIONS(6179),
    [anon_sym_virtual] = ACTIONS(6179),
    [anon_sym_extern] = ACTIONS(6179),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6181),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6181),
    [anon_sym___declspec] = ACTIONS(6179),
    [anon_sym___based] = ACTIONS(6179),
    [anon_sym___cdecl] = ACTIONS(6179),
    [anon_sym___clrcall] = ACTIONS(6179),
    [anon_sym___stdcall] = ACTIONS(6179),
    [anon_sym___fastcall] = ACTIONS(6179),
    [anon_sym___thiscall] = ACTIONS(6179),
    [anon_sym___vectorcall] = ACTIONS(6179),
    [anon_sym_LBRACK] = ACTIONS(6179),
    [anon_sym_static] = ACTIONS(6179),
    [anon_sym_EQ] = ACTIONS(6181),
    [anon_sym_register] = ACTIONS(6179),
    [anon_sym_inline] = ACTIONS(6179),
    [anon_sym___inline] = ACTIONS(6179),
    [anon_sym___inline__] = ACTIONS(6179),
    [anon_sym___forceinline] = ACTIONS(6179),
    [anon_sym_thread_local] = ACTIONS(6179),
    [anon_sym___thread] = ACTIONS(6179),
    [anon_sym_const] = ACTIONS(6179),
    [anon_sym_constexpr] = ACTIONS(6179),
    [anon_sym_volatile] = ACTIONS(6179),
    [anon_sym_restrict] = ACTIONS(6179),
    [anon_sym___restrict__] = ACTIONS(6179),
    [anon_sym__Atomic] = ACTIONS(6179),
    [anon_sym__Noreturn] = ACTIONS(6179),
    [anon_sym_noreturn] = ACTIONS(6179),
    [anon_sym__Nonnull] = ACTIONS(6179),
    [anon_sym_mutable] = ACTIONS(6179),
    [anon_sym_constinit] = ACTIONS(6179),
    [anon_sym_consteval] = ACTIONS(6179),
    [anon_sym_alignas] = ACTIONS(6179),
    [anon_sym__Alignas] = ACTIONS(6179),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6179),
    [anon_sym_decltype] = ACTIONS(6179),
    [anon_sym_template] = ACTIONS(6179),
    [anon_sym_GT2] = ACTIONS(6181),
    [anon_sym_operator] = ACTIONS(6179),
    [anon_sym_precise] = ACTIONS(6179),
    [anon_sym_shared] = ACTIONS(6179),
    [anon_sym_groupshared] = ACTIONS(6179),
    [anon_sym_uniform] = ACTIONS(6179),
    [anon_sym_row_major] = ACTIONS(6179),
    [anon_sym_column_major] = ACTIONS(6179),
    [anon_sym_globallycoherent] = ACTIONS(6179),
    [anon_sym_centroid] = ACTIONS(6179),
    [anon_sym_noperspective] = ACTIONS(6179),
    [anon_sym_nointerpolation] = ACTIONS(6179),
    [anon_sym_sample] = ACTIONS(6179),
    [anon_sym_linear] = ACTIONS(6179),
    [anon_sym_snorm] = ACTIONS(6179),
    [anon_sym_unorm] = ACTIONS(6179),
    [anon_sym_point] = ACTIONS(6179),
    [anon_sym_line] = ACTIONS(6179),
    [anon_sym_triangleadj] = ACTIONS(6179),
    [anon_sym_lineadj] = ACTIONS(6179),
    [anon_sym_triangle] = ACTIONS(6179),
  },
  [2405] = {
    [sym_attribute_specifier] = STATE(2359),
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6185),
    [anon_sym_COMMA] = ACTIONS(6185),
    [anon_sym_RPAREN] = ACTIONS(6185),
    [anon_sym_LPAREN2] = ACTIONS(6185),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_STAR] = ACTIONS(6185),
    [anon_sym_AMP_AMP] = ACTIONS(6185),
    [anon_sym_AMP] = ACTIONS(6183),
    [anon_sym_COLON] = ACTIONS(6183),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym___extension__] = ACTIONS(6183),
    [anon_sym_in] = ACTIONS(6183),
    [anon_sym_out] = ACTIONS(6183),
    [anon_sym_inout] = ACTIONS(6183),
    [anon_sym_virtual] = ACTIONS(6183),
    [anon_sym_extern] = ACTIONS(6183),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6185),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6185),
    [anon_sym___declspec] = ACTIONS(6183),
    [anon_sym___based] = ACTIONS(6183),
    [anon_sym___cdecl] = ACTIONS(6183),
    [anon_sym___clrcall] = ACTIONS(6183),
    [anon_sym___stdcall] = ACTIONS(6183),
    [anon_sym___fastcall] = ACTIONS(6183),
    [anon_sym___thiscall] = ACTIONS(6183),
    [anon_sym___vectorcall] = ACTIONS(6183),
    [anon_sym_LBRACK] = ACTIONS(6183),
    [anon_sym_static] = ACTIONS(6183),
    [anon_sym_EQ] = ACTIONS(6185),
    [anon_sym_register] = ACTIONS(6183),
    [anon_sym_inline] = ACTIONS(6183),
    [anon_sym___inline] = ACTIONS(6183),
    [anon_sym___inline__] = ACTIONS(6183),
    [anon_sym___forceinline] = ACTIONS(6183),
    [anon_sym_thread_local] = ACTIONS(6183),
    [anon_sym___thread] = ACTIONS(6183),
    [anon_sym_const] = ACTIONS(6183),
    [anon_sym_constexpr] = ACTIONS(6183),
    [anon_sym_volatile] = ACTIONS(6183),
    [anon_sym_restrict] = ACTIONS(6183),
    [anon_sym___restrict__] = ACTIONS(6183),
    [anon_sym__Atomic] = ACTIONS(6183),
    [anon_sym__Noreturn] = ACTIONS(6183),
    [anon_sym_noreturn] = ACTIONS(6183),
    [anon_sym__Nonnull] = ACTIONS(6183),
    [anon_sym_mutable] = ACTIONS(6183),
    [anon_sym_constinit] = ACTIONS(6183),
    [anon_sym_consteval] = ACTIONS(6183),
    [anon_sym_alignas] = ACTIONS(6183),
    [anon_sym__Alignas] = ACTIONS(6183),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6183),
    [anon_sym_decltype] = ACTIONS(6183),
    [anon_sym_template] = ACTIONS(6183),
    [anon_sym_GT2] = ACTIONS(6185),
    [anon_sym_operator] = ACTIONS(6183),
    [anon_sym_precise] = ACTIONS(6183),
    [anon_sym_shared] = ACTIONS(6183),
    [anon_sym_groupshared] = ACTIONS(6183),
    [anon_sym_uniform] = ACTIONS(6183),
    [anon_sym_row_major] = ACTIONS(6183),
    [anon_sym_column_major] = ACTIONS(6183),
    [anon_sym_globallycoherent] = ACTIONS(6183),
    [anon_sym_centroid] = ACTIONS(6183),
    [anon_sym_noperspective] = ACTIONS(6183),
    [anon_sym_nointerpolation] = ACTIONS(6183),
    [anon_sym_sample] = ACTIONS(6183),
    [anon_sym_linear] = ACTIONS(6183),
    [anon_sym_snorm] = ACTIONS(6183),
    [anon_sym_unorm] = ACTIONS(6183),
    [anon_sym_point] = ACTIONS(6183),
    [anon_sym_line] = ACTIONS(6183),
    [anon_sym_triangleadj] = ACTIONS(6183),
    [anon_sym_lineadj] = ACTIONS(6183),
    [anon_sym_triangle] = ACTIONS(6183),
  },
  [2406] = {
    [sym_attribute_specifier] = STATE(2353),
    [sym_identifier] = ACTIONS(6187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6189),
    [anon_sym_COMMA] = ACTIONS(6189),
    [anon_sym_RPAREN] = ACTIONS(6189),
    [anon_sym_LPAREN2] = ACTIONS(6189),
    [anon_sym_TILDE] = ACTIONS(6189),
    [anon_sym_STAR] = ACTIONS(6189),
    [anon_sym_AMP_AMP] = ACTIONS(6189),
    [anon_sym_AMP] = ACTIONS(6187),
    [anon_sym_COLON] = ACTIONS(6187),
    [anon_sym_SEMI] = ACTIONS(6189),
    [anon_sym___extension__] = ACTIONS(6187),
    [anon_sym_in] = ACTIONS(6187),
    [anon_sym_out] = ACTIONS(6187),
    [anon_sym_inout] = ACTIONS(6187),
    [anon_sym_virtual] = ACTIONS(6187),
    [anon_sym_extern] = ACTIONS(6187),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6189),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6189),
    [anon_sym___declspec] = ACTIONS(6187),
    [anon_sym___based] = ACTIONS(6187),
    [anon_sym___cdecl] = ACTIONS(6187),
    [anon_sym___clrcall] = ACTIONS(6187),
    [anon_sym___stdcall] = ACTIONS(6187),
    [anon_sym___fastcall] = ACTIONS(6187),
    [anon_sym___thiscall] = ACTIONS(6187),
    [anon_sym___vectorcall] = ACTIONS(6187),
    [anon_sym_LBRACK] = ACTIONS(6187),
    [anon_sym_static] = ACTIONS(6187),
    [anon_sym_EQ] = ACTIONS(6189),
    [anon_sym_register] = ACTIONS(6187),
    [anon_sym_inline] = ACTIONS(6187),
    [anon_sym___inline] = ACTIONS(6187),
    [anon_sym___inline__] = ACTIONS(6187),
    [anon_sym___forceinline] = ACTIONS(6187),
    [anon_sym_thread_local] = ACTIONS(6187),
    [anon_sym___thread] = ACTIONS(6187),
    [anon_sym_const] = ACTIONS(6187),
    [anon_sym_constexpr] = ACTIONS(6187),
    [anon_sym_volatile] = ACTIONS(6187),
    [anon_sym_restrict] = ACTIONS(6187),
    [anon_sym___restrict__] = ACTIONS(6187),
    [anon_sym__Atomic] = ACTIONS(6187),
    [anon_sym__Noreturn] = ACTIONS(6187),
    [anon_sym_noreturn] = ACTIONS(6187),
    [anon_sym__Nonnull] = ACTIONS(6187),
    [anon_sym_mutable] = ACTIONS(6187),
    [anon_sym_constinit] = ACTIONS(6187),
    [anon_sym_consteval] = ACTIONS(6187),
    [anon_sym_alignas] = ACTIONS(6187),
    [anon_sym__Alignas] = ACTIONS(6187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6187),
    [anon_sym_decltype] = ACTIONS(6187),
    [anon_sym_template] = ACTIONS(6187),
    [anon_sym_GT2] = ACTIONS(6189),
    [anon_sym_operator] = ACTIONS(6187),
    [anon_sym_precise] = ACTIONS(6187),
    [anon_sym_shared] = ACTIONS(6187),
    [anon_sym_groupshared] = ACTIONS(6187),
    [anon_sym_uniform] = ACTIONS(6187),
    [anon_sym_row_major] = ACTIONS(6187),
    [anon_sym_column_major] = ACTIONS(6187),
    [anon_sym_globallycoherent] = ACTIONS(6187),
    [anon_sym_centroid] = ACTIONS(6187),
    [anon_sym_noperspective] = ACTIONS(6187),
    [anon_sym_nointerpolation] = ACTIONS(6187),
    [anon_sym_sample] = ACTIONS(6187),
    [anon_sym_linear] = ACTIONS(6187),
    [anon_sym_snorm] = ACTIONS(6187),
    [anon_sym_unorm] = ACTIONS(6187),
    [anon_sym_point] = ACTIONS(6187),
    [anon_sym_line] = ACTIONS(6187),
    [anon_sym_triangleadj] = ACTIONS(6187),
    [anon_sym_lineadj] = ACTIONS(6187),
    [anon_sym_triangle] = ACTIONS(6187),
  },
  [2407] = {
    [sym_attribute_specifier] = STATE(2369),
    [sym_identifier] = ACTIONS(6191),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6193),
    [anon_sym_LPAREN2] = ACTIONS(6193),
    [anon_sym_TILDE] = ACTIONS(6193),
    [anon_sym_STAR] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6191),
    [anon_sym_COLON] = ACTIONS(6191),
    [anon_sym_SEMI] = ACTIONS(6193),
    [anon_sym___extension__] = ACTIONS(6191),
    [anon_sym_in] = ACTIONS(6191),
    [anon_sym_out] = ACTIONS(6191),
    [anon_sym_inout] = ACTIONS(6191),
    [anon_sym_virtual] = ACTIONS(6191),
    [anon_sym_extern] = ACTIONS(6191),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6193),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6193),
    [anon_sym___declspec] = ACTIONS(6191),
    [anon_sym___based] = ACTIONS(6191),
    [anon_sym___cdecl] = ACTIONS(6191),
    [anon_sym___clrcall] = ACTIONS(6191),
    [anon_sym___stdcall] = ACTIONS(6191),
    [anon_sym___fastcall] = ACTIONS(6191),
    [anon_sym___thiscall] = ACTIONS(6191),
    [anon_sym___vectorcall] = ACTIONS(6191),
    [anon_sym_LBRACK] = ACTIONS(6191),
    [anon_sym_static] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6193),
    [anon_sym_register] = ACTIONS(6191),
    [anon_sym_inline] = ACTIONS(6191),
    [anon_sym___inline] = ACTIONS(6191),
    [anon_sym___inline__] = ACTIONS(6191),
    [anon_sym___forceinline] = ACTIONS(6191),
    [anon_sym_thread_local] = ACTIONS(6191),
    [anon_sym___thread] = ACTIONS(6191),
    [anon_sym_const] = ACTIONS(6191),
    [anon_sym_constexpr] = ACTIONS(6191),
    [anon_sym_volatile] = ACTIONS(6191),
    [anon_sym_restrict] = ACTIONS(6191),
    [anon_sym___restrict__] = ACTIONS(6191),
    [anon_sym__Atomic] = ACTIONS(6191),
    [anon_sym__Noreturn] = ACTIONS(6191),
    [anon_sym_noreturn] = ACTIONS(6191),
    [anon_sym__Nonnull] = ACTIONS(6191),
    [anon_sym_mutable] = ACTIONS(6191),
    [anon_sym_constinit] = ACTIONS(6191),
    [anon_sym_consteval] = ACTIONS(6191),
    [anon_sym_alignas] = ACTIONS(6191),
    [anon_sym__Alignas] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6191),
    [anon_sym_decltype] = ACTIONS(6191),
    [anon_sym_template] = ACTIONS(6191),
    [anon_sym_GT2] = ACTIONS(6193),
    [anon_sym_operator] = ACTIONS(6191),
    [anon_sym_precise] = ACTIONS(6191),
    [anon_sym_shared] = ACTIONS(6191),
    [anon_sym_groupshared] = ACTIONS(6191),
    [anon_sym_uniform] = ACTIONS(6191),
    [anon_sym_row_major] = ACTIONS(6191),
    [anon_sym_column_major] = ACTIONS(6191),
    [anon_sym_globallycoherent] = ACTIONS(6191),
    [anon_sym_centroid] = ACTIONS(6191),
    [anon_sym_noperspective] = ACTIONS(6191),
    [anon_sym_nointerpolation] = ACTIONS(6191),
    [anon_sym_sample] = ACTIONS(6191),
    [anon_sym_linear] = ACTIONS(6191),
    [anon_sym_snorm] = ACTIONS(6191),
    [anon_sym_unorm] = ACTIONS(6191),
    [anon_sym_point] = ACTIONS(6191),
    [anon_sym_line] = ACTIONS(6191),
    [anon_sym_triangleadj] = ACTIONS(6191),
    [anon_sym_lineadj] = ACTIONS(6191),
    [anon_sym_triangle] = ACTIONS(6191),
  },
  [2408] = {
    [sym_attribute_specifier] = STATE(2379),
    [sym_identifier] = ACTIONS(6195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6197),
    [anon_sym_COMMA] = ACTIONS(6197),
    [anon_sym_RPAREN] = ACTIONS(6197),
    [anon_sym_LPAREN2] = ACTIONS(6197),
    [anon_sym_TILDE] = ACTIONS(6197),
    [anon_sym_STAR] = ACTIONS(6197),
    [anon_sym_AMP_AMP] = ACTIONS(6197),
    [anon_sym_AMP] = ACTIONS(6195),
    [anon_sym_COLON] = ACTIONS(6195),
    [anon_sym_SEMI] = ACTIONS(6197),
    [anon_sym___extension__] = ACTIONS(6195),
    [anon_sym_in] = ACTIONS(6195),
    [anon_sym_out] = ACTIONS(6195),
    [anon_sym_inout] = ACTIONS(6195),
    [anon_sym_virtual] = ACTIONS(6195),
    [anon_sym_extern] = ACTIONS(6195),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6197),
    [anon_sym___declspec] = ACTIONS(6195),
    [anon_sym___based] = ACTIONS(6195),
    [anon_sym___cdecl] = ACTIONS(6195),
    [anon_sym___clrcall] = ACTIONS(6195),
    [anon_sym___stdcall] = ACTIONS(6195),
    [anon_sym___fastcall] = ACTIONS(6195),
    [anon_sym___thiscall] = ACTIONS(6195),
    [anon_sym___vectorcall] = ACTIONS(6195),
    [anon_sym_LBRACK] = ACTIONS(6195),
    [anon_sym_static] = ACTIONS(6195),
    [anon_sym_EQ] = ACTIONS(6197),
    [anon_sym_register] = ACTIONS(6195),
    [anon_sym_inline] = ACTIONS(6195),
    [anon_sym___inline] = ACTIONS(6195),
    [anon_sym___inline__] = ACTIONS(6195),
    [anon_sym___forceinline] = ACTIONS(6195),
    [anon_sym_thread_local] = ACTIONS(6195),
    [anon_sym___thread] = ACTIONS(6195),
    [anon_sym_const] = ACTIONS(6195),
    [anon_sym_constexpr] = ACTIONS(6195),
    [anon_sym_volatile] = ACTIONS(6195),
    [anon_sym_restrict] = ACTIONS(6195),
    [anon_sym___restrict__] = ACTIONS(6195),
    [anon_sym__Atomic] = ACTIONS(6195),
    [anon_sym__Noreturn] = ACTIONS(6195),
    [anon_sym_noreturn] = ACTIONS(6195),
    [anon_sym__Nonnull] = ACTIONS(6195),
    [anon_sym_mutable] = ACTIONS(6195),
    [anon_sym_constinit] = ACTIONS(6195),
    [anon_sym_consteval] = ACTIONS(6195),
    [anon_sym_alignas] = ACTIONS(6195),
    [anon_sym__Alignas] = ACTIONS(6195),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6195),
    [anon_sym_decltype] = ACTIONS(6195),
    [anon_sym_template] = ACTIONS(6195),
    [anon_sym_GT2] = ACTIONS(6197),
    [anon_sym_operator] = ACTIONS(6195),
    [anon_sym_precise] = ACTIONS(6195),
    [anon_sym_shared] = ACTIONS(6195),
    [anon_sym_groupshared] = ACTIONS(6195),
    [anon_sym_uniform] = ACTIONS(6195),
    [anon_sym_row_major] = ACTIONS(6195),
    [anon_sym_column_major] = ACTIONS(6195),
    [anon_sym_globallycoherent] = ACTIONS(6195),
    [anon_sym_centroid] = ACTIONS(6195),
    [anon_sym_noperspective] = ACTIONS(6195),
    [anon_sym_nointerpolation] = ACTIONS(6195),
    [anon_sym_sample] = ACTIONS(6195),
    [anon_sym_linear] = ACTIONS(6195),
    [anon_sym_snorm] = ACTIONS(6195),
    [anon_sym_unorm] = ACTIONS(6195),
    [anon_sym_point] = ACTIONS(6195),
    [anon_sym_line] = ACTIONS(6195),
    [anon_sym_triangleadj] = ACTIONS(6195),
    [anon_sym_lineadj] = ACTIONS(6195),
    [anon_sym_triangle] = ACTIONS(6195),
  },
  [2409] = {
    [sym_type_qualifier] = STATE(2423),
    [sym_alignas_qualifier] = STATE(2489),
    [aux_sym__type_definition_type_repeat1] = STATE(2423),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3154),
    [sym_identifier] = ACTIONS(6199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5755),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5755),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5755),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5755),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(6201),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(6203),
    [anon_sym_unsigned] = ACTIONS(6203),
    [anon_sym_long] = ACTIONS(6203),
    [anon_sym_short] = ACTIONS(6203),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_EQ] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(6201),
    [anon_sym_constexpr] = ACTIONS(6201),
    [anon_sym_volatile] = ACTIONS(6201),
    [anon_sym_restrict] = ACTIONS(6201),
    [anon_sym___restrict__] = ACTIONS(6201),
    [anon_sym__Atomic] = ACTIONS(6201),
    [anon_sym__Noreturn] = ACTIONS(6201),
    [anon_sym_noreturn] = ACTIONS(6201),
    [anon_sym__Nonnull] = ACTIONS(6201),
    [anon_sym_mutable] = ACTIONS(6201),
    [anon_sym_constinit] = ACTIONS(6201),
    [anon_sym_consteval] = ACTIONS(6201),
    [anon_sym_alignas] = ACTIONS(6205),
    [anon_sym__Alignas] = ACTIONS(6205),
    [sym_primitive_type] = ACTIONS(6207),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_STAR_EQ] = ACTIONS(5753),
    [anon_sym_SLASH_EQ] = ACTIONS(5753),
    [anon_sym_PERCENT_EQ] = ACTIONS(5753),
    [anon_sym_PLUS_EQ] = ACTIONS(5753),
    [anon_sym_DASH_EQ] = ACTIONS(5753),
    [anon_sym_LT_LT_EQ] = ACTIONS(5753),
    [anon_sym_GT_GT_EQ] = ACTIONS(5753),
    [anon_sym_AMP_EQ] = ACTIONS(5753),
    [anon_sym_CARET_EQ] = ACTIONS(5753),
    [anon_sym_PIPE_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5753),
  },
  [2410] = {
    [sym_type_qualifier] = STATE(2409),
    [sym_alignas_qualifier] = STATE(2489),
    [aux_sym__type_definition_type_repeat1] = STATE(2409),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2481),
    [sym_identifier] = ACTIONS(6209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5731),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5731),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5731),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(6201),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6211),
    [anon_sym_unsigned] = ACTIONS(6211),
    [anon_sym_long] = ACTIONS(6211),
    [anon_sym_short] = ACTIONS(6211),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(6201),
    [anon_sym_constexpr] = ACTIONS(6201),
    [anon_sym_volatile] = ACTIONS(6201),
    [anon_sym_restrict] = ACTIONS(6201),
    [anon_sym___restrict__] = ACTIONS(6201),
    [anon_sym__Atomic] = ACTIONS(6201),
    [anon_sym__Noreturn] = ACTIONS(6201),
    [anon_sym_noreturn] = ACTIONS(6201),
    [anon_sym__Nonnull] = ACTIONS(6201),
    [anon_sym_mutable] = ACTIONS(6201),
    [anon_sym_constinit] = ACTIONS(6201),
    [anon_sym_consteval] = ACTIONS(6201),
    [anon_sym_alignas] = ACTIONS(6205),
    [anon_sym__Alignas] = ACTIONS(6205),
    [sym_primitive_type] = ACTIONS(6213),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_STAR_EQ] = ACTIONS(5729),
    [anon_sym_SLASH_EQ] = ACTIONS(5729),
    [anon_sym_PERCENT_EQ] = ACTIONS(5729),
    [anon_sym_PLUS_EQ] = ACTIONS(5729),
    [anon_sym_DASH_EQ] = ACTIONS(5729),
    [anon_sym_LT_LT_EQ] = ACTIONS(5729),
    [anon_sym_GT_GT_EQ] = ACTIONS(5729),
    [anon_sym_AMP_EQ] = ACTIONS(5729),
    [anon_sym_CARET_EQ] = ACTIONS(5729),
    [anon_sym_PIPE_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5729),
  },
  [2411] = {
    [sym_template_argument_list] = STATE(2260),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4215),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2412] = {
    [sym_attribute_specifier] = STATE(2347),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6217),
    [anon_sym_RPAREN] = ACTIONS(6217),
    [anon_sym_LPAREN2] = ACTIONS(6217),
    [anon_sym_TILDE] = ACTIONS(6217),
    [anon_sym_STAR] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_SEMI] = ACTIONS(6217),
    [anon_sym___extension__] = ACTIONS(6215),
    [anon_sym_in] = ACTIONS(6215),
    [anon_sym_out] = ACTIONS(6215),
    [anon_sym_inout] = ACTIONS(6215),
    [anon_sym_virtual] = ACTIONS(6215),
    [anon_sym_extern] = ACTIONS(6215),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6217),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6217),
    [anon_sym___declspec] = ACTIONS(6215),
    [anon_sym___based] = ACTIONS(6215),
    [anon_sym___cdecl] = ACTIONS(6215),
    [anon_sym___clrcall] = ACTIONS(6215),
    [anon_sym___stdcall] = ACTIONS(6215),
    [anon_sym___fastcall] = ACTIONS(6215),
    [anon_sym___thiscall] = ACTIONS(6215),
    [anon_sym___vectorcall] = ACTIONS(6215),
    [anon_sym_LBRACK] = ACTIONS(6215),
    [anon_sym_static] = ACTIONS(6215),
    [anon_sym_EQ] = ACTIONS(6217),
    [anon_sym_register] = ACTIONS(6215),
    [anon_sym_inline] = ACTIONS(6215),
    [anon_sym___inline] = ACTIONS(6215),
    [anon_sym___inline__] = ACTIONS(6215),
    [anon_sym___forceinline] = ACTIONS(6215),
    [anon_sym_thread_local] = ACTIONS(6215),
    [anon_sym___thread] = ACTIONS(6215),
    [anon_sym_const] = ACTIONS(6215),
    [anon_sym_constexpr] = ACTIONS(6215),
    [anon_sym_volatile] = ACTIONS(6215),
    [anon_sym_restrict] = ACTIONS(6215),
    [anon_sym___restrict__] = ACTIONS(6215),
    [anon_sym__Atomic] = ACTIONS(6215),
    [anon_sym__Noreturn] = ACTIONS(6215),
    [anon_sym_noreturn] = ACTIONS(6215),
    [anon_sym__Nonnull] = ACTIONS(6215),
    [anon_sym_mutable] = ACTIONS(6215),
    [anon_sym_constinit] = ACTIONS(6215),
    [anon_sym_consteval] = ACTIONS(6215),
    [anon_sym_alignas] = ACTIONS(6215),
    [anon_sym__Alignas] = ACTIONS(6215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6215),
    [anon_sym_decltype] = ACTIONS(6215),
    [anon_sym_template] = ACTIONS(6215),
    [anon_sym_GT2] = ACTIONS(6217),
    [anon_sym_operator] = ACTIONS(6215),
    [anon_sym_precise] = ACTIONS(6215),
    [anon_sym_shared] = ACTIONS(6215),
    [anon_sym_groupshared] = ACTIONS(6215),
    [anon_sym_uniform] = ACTIONS(6215),
    [anon_sym_row_major] = ACTIONS(6215),
    [anon_sym_column_major] = ACTIONS(6215),
    [anon_sym_globallycoherent] = ACTIONS(6215),
    [anon_sym_centroid] = ACTIONS(6215),
    [anon_sym_noperspective] = ACTIONS(6215),
    [anon_sym_nointerpolation] = ACTIONS(6215),
    [anon_sym_sample] = ACTIONS(6215),
    [anon_sym_linear] = ACTIONS(6215),
    [anon_sym_snorm] = ACTIONS(6215),
    [anon_sym_unorm] = ACTIONS(6215),
    [anon_sym_point] = ACTIONS(6215),
    [anon_sym_line] = ACTIONS(6215),
    [anon_sym_triangleadj] = ACTIONS(6215),
    [anon_sym_lineadj] = ACTIONS(6215),
    [anon_sym_triangle] = ACTIONS(6215),
  },
  [2413] = {
    [sym_attribute_specifier] = STATE(2349),
    [sym_identifier] = ACTIONS(6219),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6221),
    [anon_sym_COMMA] = ACTIONS(6221),
    [anon_sym_RPAREN] = ACTIONS(6221),
    [anon_sym_LPAREN2] = ACTIONS(6221),
    [anon_sym_TILDE] = ACTIONS(6221),
    [anon_sym_STAR] = ACTIONS(6221),
    [anon_sym_AMP_AMP] = ACTIONS(6221),
    [anon_sym_AMP] = ACTIONS(6219),
    [anon_sym_COLON] = ACTIONS(6219),
    [anon_sym_SEMI] = ACTIONS(6221),
    [anon_sym___extension__] = ACTIONS(6219),
    [anon_sym_in] = ACTIONS(6219),
    [anon_sym_out] = ACTIONS(6219),
    [anon_sym_inout] = ACTIONS(6219),
    [anon_sym_virtual] = ACTIONS(6219),
    [anon_sym_extern] = ACTIONS(6219),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6221),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6221),
    [anon_sym___declspec] = ACTIONS(6219),
    [anon_sym___based] = ACTIONS(6219),
    [anon_sym___cdecl] = ACTIONS(6219),
    [anon_sym___clrcall] = ACTIONS(6219),
    [anon_sym___stdcall] = ACTIONS(6219),
    [anon_sym___fastcall] = ACTIONS(6219),
    [anon_sym___thiscall] = ACTIONS(6219),
    [anon_sym___vectorcall] = ACTIONS(6219),
    [anon_sym_LBRACK] = ACTIONS(6219),
    [anon_sym_static] = ACTIONS(6219),
    [anon_sym_EQ] = ACTIONS(6221),
    [anon_sym_register] = ACTIONS(6219),
    [anon_sym_inline] = ACTIONS(6219),
    [anon_sym___inline] = ACTIONS(6219),
    [anon_sym___inline__] = ACTIONS(6219),
    [anon_sym___forceinline] = ACTIONS(6219),
    [anon_sym_thread_local] = ACTIONS(6219),
    [anon_sym___thread] = ACTIONS(6219),
    [anon_sym_const] = ACTIONS(6219),
    [anon_sym_constexpr] = ACTIONS(6219),
    [anon_sym_volatile] = ACTIONS(6219),
    [anon_sym_restrict] = ACTIONS(6219),
    [anon_sym___restrict__] = ACTIONS(6219),
    [anon_sym__Atomic] = ACTIONS(6219),
    [anon_sym__Noreturn] = ACTIONS(6219),
    [anon_sym_noreturn] = ACTIONS(6219),
    [anon_sym__Nonnull] = ACTIONS(6219),
    [anon_sym_mutable] = ACTIONS(6219),
    [anon_sym_constinit] = ACTIONS(6219),
    [anon_sym_consteval] = ACTIONS(6219),
    [anon_sym_alignas] = ACTIONS(6219),
    [anon_sym__Alignas] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6219),
    [anon_sym_decltype] = ACTIONS(6219),
    [anon_sym_template] = ACTIONS(6219),
    [anon_sym_GT2] = ACTIONS(6221),
    [anon_sym_operator] = ACTIONS(6219),
    [anon_sym_precise] = ACTIONS(6219),
    [anon_sym_shared] = ACTIONS(6219),
    [anon_sym_groupshared] = ACTIONS(6219),
    [anon_sym_uniform] = ACTIONS(6219),
    [anon_sym_row_major] = ACTIONS(6219),
    [anon_sym_column_major] = ACTIONS(6219),
    [anon_sym_globallycoherent] = ACTIONS(6219),
    [anon_sym_centroid] = ACTIONS(6219),
    [anon_sym_noperspective] = ACTIONS(6219),
    [anon_sym_nointerpolation] = ACTIONS(6219),
    [anon_sym_sample] = ACTIONS(6219),
    [anon_sym_linear] = ACTIONS(6219),
    [anon_sym_snorm] = ACTIONS(6219),
    [anon_sym_unorm] = ACTIONS(6219),
    [anon_sym_point] = ACTIONS(6219),
    [anon_sym_line] = ACTIONS(6219),
    [anon_sym_triangleadj] = ACTIONS(6219),
    [anon_sym_lineadj] = ACTIONS(6219),
    [anon_sym_triangle] = ACTIONS(6219),
  },
  [2414] = {
    [sym_attribute_specifier] = STATE(2366),
    [sym_identifier] = ACTIONS(6223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6225),
    [anon_sym_COMMA] = ACTIONS(6225),
    [anon_sym_RPAREN] = ACTIONS(6225),
    [anon_sym_LPAREN2] = ACTIONS(6225),
    [anon_sym_TILDE] = ACTIONS(6225),
    [anon_sym_STAR] = ACTIONS(6225),
    [anon_sym_AMP_AMP] = ACTIONS(6225),
    [anon_sym_AMP] = ACTIONS(6223),
    [anon_sym_COLON] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym___extension__] = ACTIONS(6223),
    [anon_sym_in] = ACTIONS(6223),
    [anon_sym_out] = ACTIONS(6223),
    [anon_sym_inout] = ACTIONS(6223),
    [anon_sym_virtual] = ACTIONS(6223),
    [anon_sym_extern] = ACTIONS(6223),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6225),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6225),
    [anon_sym___declspec] = ACTIONS(6223),
    [anon_sym___based] = ACTIONS(6223),
    [anon_sym___cdecl] = ACTIONS(6223),
    [anon_sym___clrcall] = ACTIONS(6223),
    [anon_sym___stdcall] = ACTIONS(6223),
    [anon_sym___fastcall] = ACTIONS(6223),
    [anon_sym___thiscall] = ACTIONS(6223),
    [anon_sym___vectorcall] = ACTIONS(6223),
    [anon_sym_LBRACK] = ACTIONS(6223),
    [anon_sym_static] = ACTIONS(6223),
    [anon_sym_EQ] = ACTIONS(6225),
    [anon_sym_register] = ACTIONS(6223),
    [anon_sym_inline] = ACTIONS(6223),
    [anon_sym___inline] = ACTIONS(6223),
    [anon_sym___inline__] = ACTIONS(6223),
    [anon_sym___forceinline] = ACTIONS(6223),
    [anon_sym_thread_local] = ACTIONS(6223),
    [anon_sym___thread] = ACTIONS(6223),
    [anon_sym_const] = ACTIONS(6223),
    [anon_sym_constexpr] = ACTIONS(6223),
    [anon_sym_volatile] = ACTIONS(6223),
    [anon_sym_restrict] = ACTIONS(6223),
    [anon_sym___restrict__] = ACTIONS(6223),
    [anon_sym__Atomic] = ACTIONS(6223),
    [anon_sym__Noreturn] = ACTIONS(6223),
    [anon_sym_noreturn] = ACTIONS(6223),
    [anon_sym__Nonnull] = ACTIONS(6223),
    [anon_sym_mutable] = ACTIONS(6223),
    [anon_sym_constinit] = ACTIONS(6223),
    [anon_sym_consteval] = ACTIONS(6223),
    [anon_sym_alignas] = ACTIONS(6223),
    [anon_sym__Alignas] = ACTIONS(6223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6223),
    [anon_sym_decltype] = ACTIONS(6223),
    [anon_sym_template] = ACTIONS(6223),
    [anon_sym_GT2] = ACTIONS(6225),
    [anon_sym_operator] = ACTIONS(6223),
    [anon_sym_precise] = ACTIONS(6223),
    [anon_sym_shared] = ACTIONS(6223),
    [anon_sym_groupshared] = ACTIONS(6223),
    [anon_sym_uniform] = ACTIONS(6223),
    [anon_sym_row_major] = ACTIONS(6223),
    [anon_sym_column_major] = ACTIONS(6223),
    [anon_sym_globallycoherent] = ACTIONS(6223),
    [anon_sym_centroid] = ACTIONS(6223),
    [anon_sym_noperspective] = ACTIONS(6223),
    [anon_sym_nointerpolation] = ACTIONS(6223),
    [anon_sym_sample] = ACTIONS(6223),
    [anon_sym_linear] = ACTIONS(6223),
    [anon_sym_snorm] = ACTIONS(6223),
    [anon_sym_unorm] = ACTIONS(6223),
    [anon_sym_point] = ACTIONS(6223),
    [anon_sym_line] = ACTIONS(6223),
    [anon_sym_triangleadj] = ACTIONS(6223),
    [anon_sym_lineadj] = ACTIONS(6223),
    [anon_sym_triangle] = ACTIONS(6223),
  },
  [2415] = {
    [sym_template_argument_list] = STATE(2260),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4215),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2416] = {
    [sym_attribute_specifier] = STATE(2388),
    [sym_identifier] = ACTIONS(6227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6229),
    [anon_sym_COMMA] = ACTIONS(6229),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [anon_sym_LPAREN2] = ACTIONS(6229),
    [anon_sym_TILDE] = ACTIONS(6229),
    [anon_sym_STAR] = ACTIONS(6229),
    [anon_sym_AMP_AMP] = ACTIONS(6229),
    [anon_sym_AMP] = ACTIONS(6227),
    [anon_sym_COLON] = ACTIONS(6227),
    [anon_sym_SEMI] = ACTIONS(6229),
    [anon_sym___extension__] = ACTIONS(6227),
    [anon_sym_in] = ACTIONS(6227),
    [anon_sym_out] = ACTIONS(6227),
    [anon_sym_inout] = ACTIONS(6227),
    [anon_sym_virtual] = ACTIONS(6227),
    [anon_sym_extern] = ACTIONS(6227),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6229),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6229),
    [anon_sym___declspec] = ACTIONS(6227),
    [anon_sym___based] = ACTIONS(6227),
    [anon_sym___cdecl] = ACTIONS(6227),
    [anon_sym___clrcall] = ACTIONS(6227),
    [anon_sym___stdcall] = ACTIONS(6227),
    [anon_sym___fastcall] = ACTIONS(6227),
    [anon_sym___thiscall] = ACTIONS(6227),
    [anon_sym___vectorcall] = ACTIONS(6227),
    [anon_sym_LBRACK] = ACTIONS(6227),
    [anon_sym_static] = ACTIONS(6227),
    [anon_sym_EQ] = ACTIONS(6229),
    [anon_sym_register] = ACTIONS(6227),
    [anon_sym_inline] = ACTIONS(6227),
    [anon_sym___inline] = ACTIONS(6227),
    [anon_sym___inline__] = ACTIONS(6227),
    [anon_sym___forceinline] = ACTIONS(6227),
    [anon_sym_thread_local] = ACTIONS(6227),
    [anon_sym___thread] = ACTIONS(6227),
    [anon_sym_const] = ACTIONS(6227),
    [anon_sym_constexpr] = ACTIONS(6227),
    [anon_sym_volatile] = ACTIONS(6227),
    [anon_sym_restrict] = ACTIONS(6227),
    [anon_sym___restrict__] = ACTIONS(6227),
    [anon_sym__Atomic] = ACTIONS(6227),
    [anon_sym__Noreturn] = ACTIONS(6227),
    [anon_sym_noreturn] = ACTIONS(6227),
    [anon_sym__Nonnull] = ACTIONS(6227),
    [anon_sym_mutable] = ACTIONS(6227),
    [anon_sym_constinit] = ACTIONS(6227),
    [anon_sym_consteval] = ACTIONS(6227),
    [anon_sym_alignas] = ACTIONS(6227),
    [anon_sym__Alignas] = ACTIONS(6227),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6227),
    [anon_sym_decltype] = ACTIONS(6227),
    [anon_sym_template] = ACTIONS(6227),
    [anon_sym_GT2] = ACTIONS(6229),
    [anon_sym_operator] = ACTIONS(6227),
    [anon_sym_precise] = ACTIONS(6227),
    [anon_sym_shared] = ACTIONS(6227),
    [anon_sym_groupshared] = ACTIONS(6227),
    [anon_sym_uniform] = ACTIONS(6227),
    [anon_sym_row_major] = ACTIONS(6227),
    [anon_sym_column_major] = ACTIONS(6227),
    [anon_sym_globallycoherent] = ACTIONS(6227),
    [anon_sym_centroid] = ACTIONS(6227),
    [anon_sym_noperspective] = ACTIONS(6227),
    [anon_sym_nointerpolation] = ACTIONS(6227),
    [anon_sym_sample] = ACTIONS(6227),
    [anon_sym_linear] = ACTIONS(6227),
    [anon_sym_snorm] = ACTIONS(6227),
    [anon_sym_unorm] = ACTIONS(6227),
    [anon_sym_point] = ACTIONS(6227),
    [anon_sym_line] = ACTIONS(6227),
    [anon_sym_triangleadj] = ACTIONS(6227),
    [anon_sym_lineadj] = ACTIONS(6227),
    [anon_sym_triangle] = ACTIONS(6227),
  },
  [2417] = {
    [sym_attribute_specifier] = STATE(2383),
    [sym_identifier] = ACTIONS(6231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6233),
    [anon_sym_COMMA] = ACTIONS(6233),
    [anon_sym_RPAREN] = ACTIONS(6233),
    [anon_sym_LPAREN2] = ACTIONS(6233),
    [anon_sym_TILDE] = ACTIONS(6233),
    [anon_sym_STAR] = ACTIONS(6233),
    [anon_sym_AMP_AMP] = ACTIONS(6233),
    [anon_sym_AMP] = ACTIONS(6231),
    [anon_sym_COLON] = ACTIONS(6231),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym___extension__] = ACTIONS(6231),
    [anon_sym_in] = ACTIONS(6231),
    [anon_sym_out] = ACTIONS(6231),
    [anon_sym_inout] = ACTIONS(6231),
    [anon_sym_virtual] = ACTIONS(6231),
    [anon_sym_extern] = ACTIONS(6231),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6233),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6233),
    [anon_sym___declspec] = ACTIONS(6231),
    [anon_sym___based] = ACTIONS(6231),
    [anon_sym___cdecl] = ACTIONS(6231),
    [anon_sym___clrcall] = ACTIONS(6231),
    [anon_sym___stdcall] = ACTIONS(6231),
    [anon_sym___fastcall] = ACTIONS(6231),
    [anon_sym___thiscall] = ACTIONS(6231),
    [anon_sym___vectorcall] = ACTIONS(6231),
    [anon_sym_LBRACK] = ACTIONS(6231),
    [anon_sym_static] = ACTIONS(6231),
    [anon_sym_EQ] = ACTIONS(6233),
    [anon_sym_register] = ACTIONS(6231),
    [anon_sym_inline] = ACTIONS(6231),
    [anon_sym___inline] = ACTIONS(6231),
    [anon_sym___inline__] = ACTIONS(6231),
    [anon_sym___forceinline] = ACTIONS(6231),
    [anon_sym_thread_local] = ACTIONS(6231),
    [anon_sym___thread] = ACTIONS(6231),
    [anon_sym_const] = ACTIONS(6231),
    [anon_sym_constexpr] = ACTIONS(6231),
    [anon_sym_volatile] = ACTIONS(6231),
    [anon_sym_restrict] = ACTIONS(6231),
    [anon_sym___restrict__] = ACTIONS(6231),
    [anon_sym__Atomic] = ACTIONS(6231),
    [anon_sym__Noreturn] = ACTIONS(6231),
    [anon_sym_noreturn] = ACTIONS(6231),
    [anon_sym__Nonnull] = ACTIONS(6231),
    [anon_sym_mutable] = ACTIONS(6231),
    [anon_sym_constinit] = ACTIONS(6231),
    [anon_sym_consteval] = ACTIONS(6231),
    [anon_sym_alignas] = ACTIONS(6231),
    [anon_sym__Alignas] = ACTIONS(6231),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6231),
    [anon_sym_decltype] = ACTIONS(6231),
    [anon_sym_template] = ACTIONS(6231),
    [anon_sym_GT2] = ACTIONS(6233),
    [anon_sym_operator] = ACTIONS(6231),
    [anon_sym_precise] = ACTIONS(6231),
    [anon_sym_shared] = ACTIONS(6231),
    [anon_sym_groupshared] = ACTIONS(6231),
    [anon_sym_uniform] = ACTIONS(6231),
    [anon_sym_row_major] = ACTIONS(6231),
    [anon_sym_column_major] = ACTIONS(6231),
    [anon_sym_globallycoherent] = ACTIONS(6231),
    [anon_sym_centroid] = ACTIONS(6231),
    [anon_sym_noperspective] = ACTIONS(6231),
    [anon_sym_nointerpolation] = ACTIONS(6231),
    [anon_sym_sample] = ACTIONS(6231),
    [anon_sym_linear] = ACTIONS(6231),
    [anon_sym_snorm] = ACTIONS(6231),
    [anon_sym_unorm] = ACTIONS(6231),
    [anon_sym_point] = ACTIONS(6231),
    [anon_sym_line] = ACTIONS(6231),
    [anon_sym_triangleadj] = ACTIONS(6231),
    [anon_sym_lineadj] = ACTIONS(6231),
    [anon_sym_triangle] = ACTIONS(6231),
  },
  [2418] = {
    [sym_attribute_specifier] = STATE(2361),
    [sym_identifier] = ACTIONS(6235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6237),
    [anon_sym_COMMA] = ACTIONS(6237),
    [anon_sym_RPAREN] = ACTIONS(6237),
    [anon_sym_LPAREN2] = ACTIONS(6237),
    [anon_sym_TILDE] = ACTIONS(6237),
    [anon_sym_STAR] = ACTIONS(6237),
    [anon_sym_AMP_AMP] = ACTIONS(6237),
    [anon_sym_AMP] = ACTIONS(6235),
    [anon_sym_COLON] = ACTIONS(6235),
    [anon_sym_SEMI] = ACTIONS(6237),
    [anon_sym___extension__] = ACTIONS(6235),
    [anon_sym_in] = ACTIONS(6235),
    [anon_sym_out] = ACTIONS(6235),
    [anon_sym_inout] = ACTIONS(6235),
    [anon_sym_virtual] = ACTIONS(6235),
    [anon_sym_extern] = ACTIONS(6235),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6237),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6237),
    [anon_sym___declspec] = ACTIONS(6235),
    [anon_sym___based] = ACTIONS(6235),
    [anon_sym___cdecl] = ACTIONS(6235),
    [anon_sym___clrcall] = ACTIONS(6235),
    [anon_sym___stdcall] = ACTIONS(6235),
    [anon_sym___fastcall] = ACTIONS(6235),
    [anon_sym___thiscall] = ACTIONS(6235),
    [anon_sym___vectorcall] = ACTIONS(6235),
    [anon_sym_LBRACK] = ACTIONS(6235),
    [anon_sym_static] = ACTIONS(6235),
    [anon_sym_EQ] = ACTIONS(6237),
    [anon_sym_register] = ACTIONS(6235),
    [anon_sym_inline] = ACTIONS(6235),
    [anon_sym___inline] = ACTIONS(6235),
    [anon_sym___inline__] = ACTIONS(6235),
    [anon_sym___forceinline] = ACTIONS(6235),
    [anon_sym_thread_local] = ACTIONS(6235),
    [anon_sym___thread] = ACTIONS(6235),
    [anon_sym_const] = ACTIONS(6235),
    [anon_sym_constexpr] = ACTIONS(6235),
    [anon_sym_volatile] = ACTIONS(6235),
    [anon_sym_restrict] = ACTIONS(6235),
    [anon_sym___restrict__] = ACTIONS(6235),
    [anon_sym__Atomic] = ACTIONS(6235),
    [anon_sym__Noreturn] = ACTIONS(6235),
    [anon_sym_noreturn] = ACTIONS(6235),
    [anon_sym__Nonnull] = ACTIONS(6235),
    [anon_sym_mutable] = ACTIONS(6235),
    [anon_sym_constinit] = ACTIONS(6235),
    [anon_sym_consteval] = ACTIONS(6235),
    [anon_sym_alignas] = ACTIONS(6235),
    [anon_sym__Alignas] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6235),
    [anon_sym_decltype] = ACTIONS(6235),
    [anon_sym_template] = ACTIONS(6235),
    [anon_sym_GT2] = ACTIONS(6237),
    [anon_sym_operator] = ACTIONS(6235),
    [anon_sym_precise] = ACTIONS(6235),
    [anon_sym_shared] = ACTIONS(6235),
    [anon_sym_groupshared] = ACTIONS(6235),
    [anon_sym_uniform] = ACTIONS(6235),
    [anon_sym_row_major] = ACTIONS(6235),
    [anon_sym_column_major] = ACTIONS(6235),
    [anon_sym_globallycoherent] = ACTIONS(6235),
    [anon_sym_centroid] = ACTIONS(6235),
    [anon_sym_noperspective] = ACTIONS(6235),
    [anon_sym_nointerpolation] = ACTIONS(6235),
    [anon_sym_sample] = ACTIONS(6235),
    [anon_sym_linear] = ACTIONS(6235),
    [anon_sym_snorm] = ACTIONS(6235),
    [anon_sym_unorm] = ACTIONS(6235),
    [anon_sym_point] = ACTIONS(6235),
    [anon_sym_line] = ACTIONS(6235),
    [anon_sym_triangleadj] = ACTIONS(6235),
    [anon_sym_lineadj] = ACTIONS(6235),
    [anon_sym_triangle] = ACTIONS(6235),
  },
  [2419] = {
    [sym_attribute_specifier] = STATE(2380),
    [sym_identifier] = ACTIONS(6239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6241),
    [anon_sym_COMMA] = ACTIONS(6241),
    [anon_sym_RPAREN] = ACTIONS(6241),
    [anon_sym_LPAREN2] = ACTIONS(6241),
    [anon_sym_TILDE] = ACTIONS(6241),
    [anon_sym_STAR] = ACTIONS(6241),
    [anon_sym_AMP_AMP] = ACTIONS(6241),
    [anon_sym_AMP] = ACTIONS(6239),
    [anon_sym_COLON] = ACTIONS(6239),
    [anon_sym_SEMI] = ACTIONS(6241),
    [anon_sym___extension__] = ACTIONS(6239),
    [anon_sym_in] = ACTIONS(6239),
    [anon_sym_out] = ACTIONS(6239),
    [anon_sym_inout] = ACTIONS(6239),
    [anon_sym_virtual] = ACTIONS(6239),
    [anon_sym_extern] = ACTIONS(6239),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6241),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6241),
    [anon_sym___declspec] = ACTIONS(6239),
    [anon_sym___based] = ACTIONS(6239),
    [anon_sym___cdecl] = ACTIONS(6239),
    [anon_sym___clrcall] = ACTIONS(6239),
    [anon_sym___stdcall] = ACTIONS(6239),
    [anon_sym___fastcall] = ACTIONS(6239),
    [anon_sym___thiscall] = ACTIONS(6239),
    [anon_sym___vectorcall] = ACTIONS(6239),
    [anon_sym_LBRACK] = ACTIONS(6239),
    [anon_sym_static] = ACTIONS(6239),
    [anon_sym_EQ] = ACTIONS(6241),
    [anon_sym_register] = ACTIONS(6239),
    [anon_sym_inline] = ACTIONS(6239),
    [anon_sym___inline] = ACTIONS(6239),
    [anon_sym___inline__] = ACTIONS(6239),
    [anon_sym___forceinline] = ACTIONS(6239),
    [anon_sym_thread_local] = ACTIONS(6239),
    [anon_sym___thread] = ACTIONS(6239),
    [anon_sym_const] = ACTIONS(6239),
    [anon_sym_constexpr] = ACTIONS(6239),
    [anon_sym_volatile] = ACTIONS(6239),
    [anon_sym_restrict] = ACTIONS(6239),
    [anon_sym___restrict__] = ACTIONS(6239),
    [anon_sym__Atomic] = ACTIONS(6239),
    [anon_sym__Noreturn] = ACTIONS(6239),
    [anon_sym_noreturn] = ACTIONS(6239),
    [anon_sym__Nonnull] = ACTIONS(6239),
    [anon_sym_mutable] = ACTIONS(6239),
    [anon_sym_constinit] = ACTIONS(6239),
    [anon_sym_consteval] = ACTIONS(6239),
    [anon_sym_alignas] = ACTIONS(6239),
    [anon_sym__Alignas] = ACTIONS(6239),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6239),
    [anon_sym_decltype] = ACTIONS(6239),
    [anon_sym_template] = ACTIONS(6239),
    [anon_sym_GT2] = ACTIONS(6241),
    [anon_sym_operator] = ACTIONS(6239),
    [anon_sym_precise] = ACTIONS(6239),
    [anon_sym_shared] = ACTIONS(6239),
    [anon_sym_groupshared] = ACTIONS(6239),
    [anon_sym_uniform] = ACTIONS(6239),
    [anon_sym_row_major] = ACTIONS(6239),
    [anon_sym_column_major] = ACTIONS(6239),
    [anon_sym_globallycoherent] = ACTIONS(6239),
    [anon_sym_centroid] = ACTIONS(6239),
    [anon_sym_noperspective] = ACTIONS(6239),
    [anon_sym_nointerpolation] = ACTIONS(6239),
    [anon_sym_sample] = ACTIONS(6239),
    [anon_sym_linear] = ACTIONS(6239),
    [anon_sym_snorm] = ACTIONS(6239),
    [anon_sym_unorm] = ACTIONS(6239),
    [anon_sym_point] = ACTIONS(6239),
    [anon_sym_line] = ACTIONS(6239),
    [anon_sym_triangleadj] = ACTIONS(6239),
    [anon_sym_lineadj] = ACTIONS(6239),
    [anon_sym_triangle] = ACTIONS(6239),
  },
  [2420] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5872),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(6243),
    [anon_sym_unsigned] = ACTIONS(6243),
    [anon_sym_long] = ACTIONS(6243),
    [anon_sym_short] = ACTIONS(6243),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5875),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_and_eq] = ACTIONS(5872),
    [anon_sym_or_eq] = ACTIONS(5872),
    [anon_sym_xor_eq] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5872),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5875),
  },
  [2421] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2421),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5743),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5743),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6243),
    [anon_sym_unsigned] = ACTIONS(6243),
    [anon_sym_long] = ACTIONS(6243),
    [anon_sym_short] = ACTIONS(6243),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_and_eq] = ACTIONS(5743),
    [anon_sym_or_eq] = ACTIONS(5743),
    [anon_sym_xor_eq] = ACTIONS(5743),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5745),
  },
  [2422] = {
    [sym_template_argument_list] = STATE(2516),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4238),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym___cdecl] = ACTIONS(4215),
    [anon_sym___clrcall] = ACTIONS(4215),
    [anon_sym___stdcall] = ACTIONS(4215),
    [anon_sym___fastcall] = ACTIONS(4215),
    [anon_sym___thiscall] = ACTIONS(4215),
    [anon_sym___vectorcall] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2423] = {
    [sym_type_qualifier] = STATE(2423),
    [sym_alignas_qualifier] = STATE(2489),
    [aux_sym__type_definition_type_repeat1] = STATE(2423),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5024),
    [anon_sym_GT_GT] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(6249),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_EQ] = ACTIONS(5024),
    [anon_sym_const] = ACTIONS(6249),
    [anon_sym_constexpr] = ACTIONS(6249),
    [anon_sym_volatile] = ACTIONS(6249),
    [anon_sym_restrict] = ACTIONS(6249),
    [anon_sym___restrict__] = ACTIONS(6249),
    [anon_sym__Atomic] = ACTIONS(6249),
    [anon_sym__Noreturn] = ACTIONS(6249),
    [anon_sym_noreturn] = ACTIONS(6249),
    [anon_sym__Nonnull] = ACTIONS(6249),
    [anon_sym_mutable] = ACTIONS(6249),
    [anon_sym_constinit] = ACTIONS(6249),
    [anon_sym_consteval] = ACTIONS(6249),
    [anon_sym_alignas] = ACTIONS(6252),
    [anon_sym__Alignas] = ACTIONS(6252),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_STAR_EQ] = ACTIONS(5026),
    [anon_sym_SLASH_EQ] = ACTIONS(5026),
    [anon_sym_PERCENT_EQ] = ACTIONS(5026),
    [anon_sym_PLUS_EQ] = ACTIONS(5026),
    [anon_sym_DASH_EQ] = ACTIONS(5026),
    [anon_sym_LT_LT_EQ] = ACTIONS(5026),
    [anon_sym_GT_GT_EQ] = ACTIONS(5026),
    [anon_sym_AMP_EQ] = ACTIONS(5026),
    [anon_sym_CARET_EQ] = ACTIONS(5026),
    [anon_sym_PIPE_EQ] = ACTIONS(5026),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5026),
  },
  [2424] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2424),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5743),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5743),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5743),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6255),
    [anon_sym_unsigned] = ACTIONS(6255),
    [anon_sym_long] = ACTIONS(6255),
    [anon_sym_short] = ACTIONS(6255),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5743),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_and_eq] = ACTIONS(5743),
    [anon_sym_or_eq] = ACTIONS(5743),
    [anon_sym_xor_eq] = ACTIONS(5743),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_GT2] = ACTIONS(5745),
  },
  [2425] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2424),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5872),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5872),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(6255),
    [anon_sym_unsigned] = ACTIONS(6255),
    [anon_sym_long] = ACTIONS(6255),
    [anon_sym_short] = ACTIONS(6255),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5872),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_and_eq] = ACTIONS(5872),
    [anon_sym_or_eq] = ACTIONS(5872),
    [anon_sym_xor_eq] = ACTIONS(5872),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
    [anon_sym_GT2] = ACTIONS(5875),
  },
  [2426] = {
    [sym_argument_list] = STATE(3793),
    [sym_initializer_list] = STATE(4149),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(6258),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(4078),
    [anon_sym_signed] = ACTIONS(5864),
    [anon_sym_unsigned] = ACTIONS(5864),
    [anon_sym_long] = ACTIONS(5864),
    [anon_sym_short] = ACTIONS(5864),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2427] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5166),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_STAR_EQ] = ACTIONS(5168),
    [anon_sym_SLASH_EQ] = ACTIONS(5168),
    [anon_sym_PERCENT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_GT_EQ] = ACTIONS(5168),
    [anon_sym_AMP_EQ] = ACTIONS(5168),
    [anon_sym_CARET_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_and_eq] = ACTIONS(5166),
    [anon_sym_or_eq] = ACTIONS(5166),
    [anon_sym_xor_eq] = ACTIONS(5166),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5168),
  },
  [2428] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SEMI] = ACTIONS(5963),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym___cdecl] = ACTIONS(5961),
    [anon_sym___clrcall] = ACTIONS(5961),
    [anon_sym___stdcall] = ACTIONS(5961),
    [anon_sym___fastcall] = ACTIONS(5961),
    [anon_sym___thiscall] = ACTIONS(5961),
    [anon_sym___vectorcall] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_GT2] = ACTIONS(5963),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2429] = {
    [sym_identifier] = ACTIONS(6261),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6263),
    [anon_sym_COMMA] = ACTIONS(6263),
    [anon_sym_RPAREN] = ACTIONS(6263),
    [anon_sym_LPAREN2] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6263),
    [anon_sym_AMP_AMP] = ACTIONS(6263),
    [anon_sym_AMP] = ACTIONS(6261),
    [anon_sym_COLON] = ACTIONS(6261),
    [anon_sym_SEMI] = ACTIONS(6263),
    [anon_sym___extension__] = ACTIONS(6261),
    [anon_sym_in] = ACTIONS(6261),
    [anon_sym_out] = ACTIONS(6261),
    [anon_sym_inout] = ACTIONS(6261),
    [anon_sym_virtual] = ACTIONS(6261),
    [anon_sym_extern] = ACTIONS(6261),
    [anon_sym___attribute__] = ACTIONS(6261),
    [anon_sym___attribute] = ACTIONS(6261),
    [anon_sym_COLON_COLON] = ACTIONS(6263),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6263),
    [anon_sym___declspec] = ACTIONS(6261),
    [anon_sym___based] = ACTIONS(6261),
    [anon_sym___cdecl] = ACTIONS(6261),
    [anon_sym___clrcall] = ACTIONS(6261),
    [anon_sym___stdcall] = ACTIONS(6261),
    [anon_sym___fastcall] = ACTIONS(6261),
    [anon_sym___thiscall] = ACTIONS(6261),
    [anon_sym___vectorcall] = ACTIONS(6261),
    [anon_sym_LBRACK] = ACTIONS(6261),
    [anon_sym_static] = ACTIONS(6261),
    [anon_sym_EQ] = ACTIONS(6263),
    [anon_sym_register] = ACTIONS(6261),
    [anon_sym_inline] = ACTIONS(6261),
    [anon_sym___inline] = ACTIONS(6261),
    [anon_sym___inline__] = ACTIONS(6261),
    [anon_sym___forceinline] = ACTIONS(6261),
    [anon_sym_thread_local] = ACTIONS(6261),
    [anon_sym___thread] = ACTIONS(6261),
    [anon_sym_const] = ACTIONS(6261),
    [anon_sym_constexpr] = ACTIONS(6261),
    [anon_sym_volatile] = ACTIONS(6261),
    [anon_sym_restrict] = ACTIONS(6261),
    [anon_sym___restrict__] = ACTIONS(6261),
    [anon_sym__Atomic] = ACTIONS(6261),
    [anon_sym__Noreturn] = ACTIONS(6261),
    [anon_sym_noreturn] = ACTIONS(6261),
    [anon_sym__Nonnull] = ACTIONS(6261),
    [anon_sym_mutable] = ACTIONS(6261),
    [anon_sym_constinit] = ACTIONS(6261),
    [anon_sym_consteval] = ACTIONS(6261),
    [anon_sym_alignas] = ACTIONS(6261),
    [anon_sym__Alignas] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6261),
    [anon_sym_explicit] = ACTIONS(6261),
    [anon_sym_template] = ACTIONS(6261),
    [anon_sym_GT2] = ACTIONS(6263),
    [anon_sym_operator] = ACTIONS(6261),
    [anon_sym_precise] = ACTIONS(6261),
    [anon_sym_shared] = ACTIONS(6261),
    [anon_sym_groupshared] = ACTIONS(6261),
    [anon_sym_uniform] = ACTIONS(6261),
    [anon_sym_row_major] = ACTIONS(6261),
    [anon_sym_column_major] = ACTIONS(6261),
    [anon_sym_globallycoherent] = ACTIONS(6261),
    [anon_sym_centroid] = ACTIONS(6261),
    [anon_sym_noperspective] = ACTIONS(6261),
    [anon_sym_nointerpolation] = ACTIONS(6261),
    [anon_sym_sample] = ACTIONS(6261),
    [anon_sym_linear] = ACTIONS(6261),
    [anon_sym_snorm] = ACTIONS(6261),
    [anon_sym_unorm] = ACTIONS(6261),
    [anon_sym_point] = ACTIONS(6261),
    [anon_sym_line] = ACTIONS(6261),
    [anon_sym_triangleadj] = ACTIONS(6261),
    [anon_sym_lineadj] = ACTIONS(6261),
    [anon_sym_triangle] = ACTIONS(6261),
  },
  [2430] = {
    [sym_template_argument_list] = STATE(2260),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(4223),
    [anon_sym_RPAREN] = ACTIONS(4223),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4215),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4223),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_GT2] = ACTIONS(4223),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2431] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_COLON] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym___cdecl] = ACTIONS(2197),
    [anon_sym___clrcall] = ACTIONS(2197),
    [anon_sym___stdcall] = ACTIONS(2197),
    [anon_sym___fastcall] = ACTIONS(2197),
    [anon_sym___thiscall] = ACTIONS(2197),
    [anon_sym___vectorcall] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_EQ] = ACTIONS(2187),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_GT2] = ACTIONS(2187),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2432] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2433] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_and_eq] = ACTIONS(2197),
    [anon_sym_or_eq] = ACTIONS(2197),
    [anon_sym_xor_eq] = ACTIONS(2197),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2187),
  },
  [2434] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_EQ] = ACTIONS(5859),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2435] = {
    [sym_type_qualifier] = STATE(2435),
    [sym_alignas_qualifier] = STATE(2486),
    [aux_sym__type_definition_type_repeat1] = STATE(2435),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [aux_sym_preproc_if_token2] = ACTIONS(5026),
    [aux_sym_preproc_else_token1] = ACTIONS(5026),
    [aux_sym_preproc_elif_token1] = ACTIONS(5024),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5026),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5026),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5026),
    [anon_sym_GT_GT] = ACTIONS(5026),
    [anon_sym_COLON] = ACTIONS(5026),
    [anon_sym_SEMI] = ACTIONS(5026),
    [anon_sym___extension__] = ACTIONS(6267),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_RBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_RBRACK] = ACTIONS(5026),
    [anon_sym_const] = ACTIONS(6267),
    [anon_sym_constexpr] = ACTIONS(6267),
    [anon_sym_volatile] = ACTIONS(6267),
    [anon_sym_restrict] = ACTIONS(6267),
    [anon_sym___restrict__] = ACTIONS(6267),
    [anon_sym__Atomic] = ACTIONS(6267),
    [anon_sym__Noreturn] = ACTIONS(6267),
    [anon_sym_noreturn] = ACTIONS(6267),
    [anon_sym__Nonnull] = ACTIONS(6267),
    [anon_sym_mutable] = ACTIONS(6267),
    [anon_sym_constinit] = ACTIONS(6267),
    [anon_sym_consteval] = ACTIONS(6267),
    [anon_sym_alignas] = ACTIONS(6270),
    [anon_sym__Alignas] = ACTIONS(6270),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_final] = ACTIONS(5024),
    [anon_sym_override] = ACTIONS(5024),
    [anon_sym_requires] = ACTIONS(5024),
  },
  [2436] = {
    [sym_identifier] = ACTIONS(6273),
    [anon_sym___extension__] = ACTIONS(6273),
    [anon_sym_in] = ACTIONS(6273),
    [anon_sym_out] = ACTIONS(6273),
    [anon_sym_inout] = ACTIONS(6273),
    [anon_sym_virtual] = ACTIONS(6273),
    [anon_sym_extern] = ACTIONS(6273),
    [anon_sym___attribute__] = ACTIONS(6273),
    [anon_sym___attribute] = ACTIONS(6273),
    [anon_sym_COLON_COLON] = ACTIONS(6275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6275),
    [anon_sym___declspec] = ACTIONS(6273),
    [anon_sym___cdecl] = ACTIONS(6273),
    [anon_sym___clrcall] = ACTIONS(6273),
    [anon_sym___stdcall] = ACTIONS(6273),
    [anon_sym___fastcall] = ACTIONS(6273),
    [anon_sym___thiscall] = ACTIONS(6273),
    [anon_sym___vectorcall] = ACTIONS(6273),
    [anon_sym_signed] = ACTIONS(6273),
    [anon_sym_unsigned] = ACTIONS(6273),
    [anon_sym_long] = ACTIONS(6273),
    [anon_sym_short] = ACTIONS(6273),
    [anon_sym_LBRACK] = ACTIONS(6277),
    [anon_sym_static] = ACTIONS(6273),
    [anon_sym_EQ] = ACTIONS(6279),
    [anon_sym_register] = ACTIONS(6273),
    [anon_sym_inline] = ACTIONS(6273),
    [anon_sym___inline] = ACTIONS(6273),
    [anon_sym___inline__] = ACTIONS(6273),
    [anon_sym___forceinline] = ACTIONS(6273),
    [anon_sym_thread_local] = ACTIONS(6273),
    [anon_sym___thread] = ACTIONS(6273),
    [anon_sym_const] = ACTIONS(6273),
    [anon_sym_constexpr] = ACTIONS(6273),
    [anon_sym_volatile] = ACTIONS(6273),
    [anon_sym_restrict] = ACTIONS(6273),
    [anon_sym___restrict__] = ACTIONS(6273),
    [anon_sym__Atomic] = ACTIONS(6273),
    [anon_sym__Noreturn] = ACTIONS(6273),
    [anon_sym_noreturn] = ACTIONS(6273),
    [anon_sym__Nonnull] = ACTIONS(6273),
    [anon_sym_mutable] = ACTIONS(6273),
    [anon_sym_constinit] = ACTIONS(6273),
    [anon_sym_consteval] = ACTIONS(6273),
    [anon_sym_alignas] = ACTIONS(6273),
    [anon_sym__Alignas] = ACTIONS(6273),
    [sym_primitive_type] = ACTIONS(6273),
    [anon_sym_enum] = ACTIONS(6273),
    [anon_sym_class] = ACTIONS(6273),
    [anon_sym_struct] = ACTIONS(6273),
    [anon_sym_union] = ACTIONS(6273),
    [anon_sym_if] = ACTIONS(6273),
    [anon_sym_for] = ACTIONS(6273),
    [anon_sym_DOT] = ACTIONS(6279),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6273),
    [anon_sym_decltype] = ACTIONS(6273),
    [anon_sym_typename] = ACTIONS(6273),
    [anon_sym_template] = ACTIONS(6273),
    [anon_sym_precise] = ACTIONS(6273),
    [anon_sym_shared] = ACTIONS(6273),
    [anon_sym_groupshared] = ACTIONS(6273),
    [anon_sym_uniform] = ACTIONS(6273),
    [anon_sym_row_major] = ACTIONS(6273),
    [anon_sym_column_major] = ACTIONS(6273),
    [anon_sym_globallycoherent] = ACTIONS(6273),
    [anon_sym_centroid] = ACTIONS(6273),
    [anon_sym_noperspective] = ACTIONS(6273),
    [anon_sym_nointerpolation] = ACTIONS(6273),
    [anon_sym_sample] = ACTIONS(6273),
    [anon_sym_linear] = ACTIONS(6273),
    [anon_sym_snorm] = ACTIONS(6273),
    [anon_sym_unorm] = ACTIONS(6273),
    [anon_sym_point] = ACTIONS(6273),
    [anon_sym_line] = ACTIONS(6273),
    [anon_sym_triangleadj] = ACTIONS(6273),
    [anon_sym_lineadj] = ACTIONS(6273),
    [anon_sym_triangle] = ACTIONS(6273),
  },
  [2437] = {
    [sym_identifier] = ACTIONS(6281),
    [anon_sym_LPAREN2] = ACTIONS(6283),
    [anon_sym_BANG] = ACTIONS(6283),
    [anon_sym_TILDE] = ACTIONS(6283),
    [anon_sym_DASH] = ACTIONS(6281),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_STAR] = ACTIONS(6283),
    [anon_sym_AMP] = ACTIONS(6283),
    [anon_sym_SEMI] = ACTIONS(6283),
    [anon_sym___extension__] = ACTIONS(6281),
    [anon_sym_COLON_COLON] = ACTIONS(6283),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6283),
    [anon_sym_LBRACE] = ACTIONS(6283),
    [anon_sym_LBRACK] = ACTIONS(6281),
    [sym_primitive_type] = ACTIONS(6281),
    [anon_sym_if] = ACTIONS(6281),
    [anon_sym_switch] = ACTIONS(6281),
    [anon_sym_case] = ACTIONS(6281),
    [anon_sym_default] = ACTIONS(6281),
    [anon_sym_while] = ACTIONS(6281),
    [anon_sym_do] = ACTIONS(6281),
    [anon_sym_for] = ACTIONS(6281),
    [anon_sym_return] = ACTIONS(6281),
    [anon_sym_break] = ACTIONS(6281),
    [anon_sym_continue] = ACTIONS(6281),
    [anon_sym_goto] = ACTIONS(6281),
    [anon_sym___try] = ACTIONS(6281),
    [anon_sym___leave] = ACTIONS(6281),
    [anon_sym_not] = ACTIONS(6281),
    [anon_sym_compl] = ACTIONS(6281),
    [anon_sym_DASH_DASH] = ACTIONS(6283),
    [anon_sym_PLUS_PLUS] = ACTIONS(6283),
    [anon_sym_sizeof] = ACTIONS(6281),
    [anon_sym___alignof__] = ACTIONS(6281),
    [anon_sym___alignof] = ACTIONS(6281),
    [anon_sym__alignof] = ACTIONS(6281),
    [anon_sym_alignof] = ACTIONS(6281),
    [anon_sym__Alignof] = ACTIONS(6281),
    [anon_sym_offsetof] = ACTIONS(6281),
    [anon_sym__Generic] = ACTIONS(6281),
    [anon_sym_asm] = ACTIONS(6281),
    [anon_sym___asm__] = ACTIONS(6281),
    [anon_sym___asm] = ACTIONS(6281),
    [sym_number_literal] = ACTIONS(6283),
    [anon_sym_L_SQUOTE] = ACTIONS(6283),
    [anon_sym_u_SQUOTE] = ACTIONS(6283),
    [anon_sym_U_SQUOTE] = ACTIONS(6283),
    [anon_sym_u8_SQUOTE] = ACTIONS(6283),
    [anon_sym_SQUOTE] = ACTIONS(6283),
    [anon_sym_L_DQUOTE] = ACTIONS(6283),
    [anon_sym_u_DQUOTE] = ACTIONS(6283),
    [anon_sym_U_DQUOTE] = ACTIONS(6283),
    [anon_sym_u8_DQUOTE] = ACTIONS(6283),
    [anon_sym_DQUOTE] = ACTIONS(6283),
    [sym_true] = ACTIONS(6281),
    [sym_false] = ACTIONS(6281),
    [anon_sym_NULL] = ACTIONS(6281),
    [anon_sym_nullptr] = ACTIONS(6281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6281),
    [anon_sym_template] = ACTIONS(6281),
    [anon_sym_try] = ACTIONS(6281),
    [anon_sym_delete] = ACTIONS(6281),
    [anon_sym_throw] = ACTIONS(6281),
    [anon_sym_co_return] = ACTIONS(6281),
    [anon_sym_co_yield] = ACTIONS(6281),
    [anon_sym_R_DQUOTE] = ACTIONS(6283),
    [anon_sym_LR_DQUOTE] = ACTIONS(6283),
    [anon_sym_uR_DQUOTE] = ACTIONS(6283),
    [anon_sym_UR_DQUOTE] = ACTIONS(6283),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6283),
    [anon_sym_co_await] = ACTIONS(6281),
    [anon_sym_new] = ACTIONS(6281),
    [anon_sym_requires] = ACTIONS(6281),
    [sym_this] = ACTIONS(6281),
    [anon_sym_discard] = ACTIONS(6281),
    [anon_sym_cbuffer] = ACTIONS(6281),
  },
  [2438] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_typedef] = ACTIONS(6285),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6287),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2440] = {
    [sym_identifier] = ACTIONS(3878),
    [anon_sym_LPAREN2] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3880),
    [anon_sym_STAR] = ACTIONS(3880),
    [anon_sym_AMP_AMP] = ACTIONS(3880),
    [anon_sym_AMP] = ACTIONS(3878),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_in] = ACTIONS(3878),
    [anon_sym_out] = ACTIONS(3878),
    [anon_sym_inout] = ACTIONS(3878),
    [anon_sym_virtual] = ACTIONS(3878),
    [anon_sym_extern] = ACTIONS(3878),
    [anon_sym___attribute__] = ACTIONS(3878),
    [anon_sym___attribute] = ACTIONS(3878),
    [anon_sym_using] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3880),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3880),
    [anon_sym___declspec] = ACTIONS(3878),
    [anon_sym___based] = ACTIONS(3878),
    [anon_sym_signed] = ACTIONS(3878),
    [anon_sym_unsigned] = ACTIONS(3878),
    [anon_sym_long] = ACTIONS(3878),
    [anon_sym_short] = ACTIONS(3878),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_static] = ACTIONS(3878),
    [anon_sym_register] = ACTIONS(3878),
    [anon_sym_inline] = ACTIONS(3878),
    [anon_sym___inline] = ACTIONS(3878),
    [anon_sym___inline__] = ACTIONS(3878),
    [anon_sym___forceinline] = ACTIONS(3878),
    [anon_sym_thread_local] = ACTIONS(3878),
    [anon_sym___thread] = ACTIONS(3878),
    [anon_sym_const] = ACTIONS(3878),
    [anon_sym_constexpr] = ACTIONS(3878),
    [anon_sym_volatile] = ACTIONS(3878),
    [anon_sym_restrict] = ACTIONS(3878),
    [anon_sym___restrict__] = ACTIONS(3878),
    [anon_sym__Atomic] = ACTIONS(3878),
    [anon_sym__Noreturn] = ACTIONS(3878),
    [anon_sym_noreturn] = ACTIONS(3878),
    [anon_sym__Nonnull] = ACTIONS(3878),
    [anon_sym_mutable] = ACTIONS(3878),
    [anon_sym_constinit] = ACTIONS(3878),
    [anon_sym_consteval] = ACTIONS(3878),
    [anon_sym_alignas] = ACTIONS(3878),
    [anon_sym__Alignas] = ACTIONS(3878),
    [sym_primitive_type] = ACTIONS(3878),
    [anon_sym_enum] = ACTIONS(3878),
    [anon_sym_class] = ACTIONS(3878),
    [anon_sym_struct] = ACTIONS(3878),
    [anon_sym_union] = ACTIONS(3878),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3878),
    [anon_sym_decltype] = ACTIONS(3878),
    [anon_sym_explicit] = ACTIONS(3878),
    [anon_sym_typename] = ACTIONS(3878),
    [anon_sym_template] = ACTIONS(3878),
    [anon_sym_operator] = ACTIONS(3878),
    [anon_sym_precise] = ACTIONS(3878),
    [anon_sym_shared] = ACTIONS(3878),
    [anon_sym_groupshared] = ACTIONS(3878),
    [anon_sym_uniform] = ACTIONS(3878),
    [anon_sym_row_major] = ACTIONS(3878),
    [anon_sym_column_major] = ACTIONS(3878),
    [anon_sym_globallycoherent] = ACTIONS(3878),
    [anon_sym_centroid] = ACTIONS(3878),
    [anon_sym_noperspective] = ACTIONS(3878),
    [anon_sym_nointerpolation] = ACTIONS(3878),
    [anon_sym_sample] = ACTIONS(3878),
    [anon_sym_linear] = ACTIONS(3878),
    [anon_sym_snorm] = ACTIONS(3878),
    [anon_sym_unorm] = ACTIONS(3878),
    [anon_sym_point] = ACTIONS(3878),
    [anon_sym_line] = ACTIONS(3878),
    [anon_sym_triangleadj] = ACTIONS(3878),
    [anon_sym_lineadj] = ACTIONS(3878),
    [anon_sym_triangle] = ACTIONS(3878),
  },
  [2441] = {
    [sym_template_argument_list] = STATE(2592),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(4223),
    [anon_sym_RPAREN] = ACTIONS(4238),
    [anon_sym_LPAREN2] = ACTIONS(4238),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(4223),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2442] = {
    [sym_identifier] = ACTIONS(4072),
    [anon_sym_LPAREN2] = ACTIONS(4070),
    [anon_sym_TILDE] = ACTIONS(4070),
    [anon_sym_STAR] = ACTIONS(4070),
    [anon_sym_AMP_AMP] = ACTIONS(4070),
    [anon_sym_AMP] = ACTIONS(4072),
    [anon_sym___extension__] = ACTIONS(4072),
    [anon_sym_in] = ACTIONS(4072),
    [anon_sym_out] = ACTIONS(4072),
    [anon_sym_inout] = ACTIONS(4072),
    [anon_sym_virtual] = ACTIONS(4072),
    [anon_sym_extern] = ACTIONS(4072),
    [anon_sym___attribute__] = ACTIONS(4072),
    [anon_sym___attribute] = ACTIONS(4072),
    [anon_sym_using] = ACTIONS(4068),
    [anon_sym_COLON_COLON] = ACTIONS(4070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4063),
    [anon_sym___declspec] = ACTIONS(4072),
    [anon_sym___based] = ACTIONS(4072),
    [anon_sym_signed] = ACTIONS(4072),
    [anon_sym_unsigned] = ACTIONS(4072),
    [anon_sym_long] = ACTIONS(4072),
    [anon_sym_short] = ACTIONS(4072),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_static] = ACTIONS(4072),
    [anon_sym_register] = ACTIONS(4072),
    [anon_sym_inline] = ACTIONS(4072),
    [anon_sym___inline] = ACTIONS(4072),
    [anon_sym___inline__] = ACTIONS(4072),
    [anon_sym___forceinline] = ACTIONS(4072),
    [anon_sym_thread_local] = ACTIONS(4072),
    [anon_sym___thread] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4072),
    [anon_sym_constexpr] = ACTIONS(4072),
    [anon_sym_volatile] = ACTIONS(4072),
    [anon_sym_restrict] = ACTIONS(4072),
    [anon_sym___restrict__] = ACTIONS(4072),
    [anon_sym__Atomic] = ACTIONS(4072),
    [anon_sym__Noreturn] = ACTIONS(4072),
    [anon_sym_noreturn] = ACTIONS(4072),
    [anon_sym__Nonnull] = ACTIONS(4072),
    [anon_sym_mutable] = ACTIONS(4072),
    [anon_sym_constinit] = ACTIONS(4072),
    [anon_sym_consteval] = ACTIONS(4072),
    [anon_sym_alignas] = ACTIONS(4072),
    [anon_sym__Alignas] = ACTIONS(4072),
    [sym_primitive_type] = ACTIONS(4072),
    [anon_sym_enum] = ACTIONS(4072),
    [anon_sym_class] = ACTIONS(4072),
    [anon_sym_struct] = ACTIONS(4072),
    [anon_sym_union] = ACTIONS(4072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4072),
    [anon_sym_decltype] = ACTIONS(4072),
    [anon_sym_explicit] = ACTIONS(4072),
    [anon_sym_typename] = ACTIONS(4072),
    [anon_sym_template] = ACTIONS(4072),
    [anon_sym_operator] = ACTIONS(4072),
    [anon_sym_precise] = ACTIONS(4072),
    [anon_sym_shared] = ACTIONS(4072),
    [anon_sym_groupshared] = ACTIONS(4072),
    [anon_sym_uniform] = ACTIONS(4072),
    [anon_sym_row_major] = ACTIONS(4072),
    [anon_sym_column_major] = ACTIONS(4072),
    [anon_sym_globallycoherent] = ACTIONS(4072),
    [anon_sym_centroid] = ACTIONS(4072),
    [anon_sym_noperspective] = ACTIONS(4072),
    [anon_sym_nointerpolation] = ACTIONS(4072),
    [anon_sym_sample] = ACTIONS(4072),
    [anon_sym_linear] = ACTIONS(4072),
    [anon_sym_snorm] = ACTIONS(4072),
    [anon_sym_unorm] = ACTIONS(4072),
    [anon_sym_point] = ACTIONS(4072),
    [anon_sym_line] = ACTIONS(4072),
    [anon_sym_triangleadj] = ACTIONS(4072),
    [anon_sym_lineadj] = ACTIONS(4072),
    [anon_sym_triangle] = ACTIONS(4072),
  },
  [2443] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_typedef] = ACTIONS(6289),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2444] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_namespace] = ACTIONS(6291),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2445] = {
    [sym_attribute_specifier] = STATE(2356),
    [sym_enumerator_list] = STATE(2412),
    [sym__enum_base_clause] = STATE(2367),
    [sym_identifier] = ACTIONS(6293),
    [anon_sym_LPAREN2] = ACTIONS(6295),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_STAR] = ACTIONS(6295),
    [anon_sym_AMP_AMP] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6295),
    [anon_sym___extension__] = ACTIONS(6293),
    [anon_sym_in] = ACTIONS(6293),
    [anon_sym_out] = ACTIONS(6293),
    [anon_sym_inout] = ACTIONS(6293),
    [anon_sym_virtual] = ACTIONS(6293),
    [anon_sym_extern] = ACTIONS(6293),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6295),
    [anon_sym___declspec] = ACTIONS(6293),
    [anon_sym___based] = ACTIONS(6293),
    [anon_sym___cdecl] = ACTIONS(6293),
    [anon_sym___clrcall] = ACTIONS(6293),
    [anon_sym___stdcall] = ACTIONS(6293),
    [anon_sym___fastcall] = ACTIONS(6293),
    [anon_sym___thiscall] = ACTIONS(6293),
    [anon_sym___vectorcall] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6293),
    [anon_sym_register] = ACTIONS(6293),
    [anon_sym_inline] = ACTIONS(6293),
    [anon_sym___inline] = ACTIONS(6293),
    [anon_sym___inline__] = ACTIONS(6293),
    [anon_sym___forceinline] = ACTIONS(6293),
    [anon_sym_thread_local] = ACTIONS(6293),
    [anon_sym___thread] = ACTIONS(6293),
    [anon_sym_const] = ACTIONS(6293),
    [anon_sym_constexpr] = ACTIONS(6293),
    [anon_sym_volatile] = ACTIONS(6293),
    [anon_sym_restrict] = ACTIONS(6293),
    [anon_sym___restrict__] = ACTIONS(6293),
    [anon_sym__Atomic] = ACTIONS(6293),
    [anon_sym__Noreturn] = ACTIONS(6293),
    [anon_sym_noreturn] = ACTIONS(6293),
    [anon_sym__Nonnull] = ACTIONS(6293),
    [anon_sym_mutable] = ACTIONS(6293),
    [anon_sym_constinit] = ACTIONS(6293),
    [anon_sym_consteval] = ACTIONS(6293),
    [anon_sym_alignas] = ACTIONS(6293),
    [anon_sym__Alignas] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6293),
    [anon_sym_decltype] = ACTIONS(6293),
    [anon_sym_template] = ACTIONS(6293),
    [anon_sym_operator] = ACTIONS(6293),
    [anon_sym_precise] = ACTIONS(6293),
    [anon_sym_shared] = ACTIONS(6293),
    [anon_sym_groupshared] = ACTIONS(6293),
    [anon_sym_uniform] = ACTIONS(6293),
    [anon_sym_row_major] = ACTIONS(6293),
    [anon_sym_column_major] = ACTIONS(6293),
    [anon_sym_globallycoherent] = ACTIONS(6293),
    [anon_sym_centroid] = ACTIONS(6293),
    [anon_sym_noperspective] = ACTIONS(6293),
    [anon_sym_nointerpolation] = ACTIONS(6293),
    [anon_sym_sample] = ACTIONS(6293),
    [anon_sym_linear] = ACTIONS(6293),
    [anon_sym_snorm] = ACTIONS(6293),
    [anon_sym_unorm] = ACTIONS(6293),
    [anon_sym_point] = ACTIONS(6293),
    [anon_sym_line] = ACTIONS(6293),
    [anon_sym_triangleadj] = ACTIONS(6293),
    [anon_sym_lineadj] = ACTIONS(6293),
    [anon_sym_triangle] = ACTIONS(6293),
  },
  [2446] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2197),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_and_eq] = ACTIONS(2197),
    [anon_sym_or_eq] = ACTIONS(2197),
    [anon_sym_xor_eq] = ACTIONS(2197),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_GT2] = ACTIONS(2187),
  },
  [2447] = {
    [sym_identifier] = ACTIONS(6299),
    [anon_sym_LPAREN2] = ACTIONS(6301),
    [anon_sym_BANG] = ACTIONS(6301),
    [anon_sym_TILDE] = ACTIONS(6301),
    [anon_sym_DASH] = ACTIONS(6299),
    [anon_sym_PLUS] = ACTIONS(6299),
    [anon_sym_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6301),
    [anon_sym_SEMI] = ACTIONS(6301),
    [anon_sym___extension__] = ACTIONS(6299),
    [anon_sym_COLON_COLON] = ACTIONS(6301),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6301),
    [anon_sym_LBRACE] = ACTIONS(6301),
    [anon_sym_LBRACK] = ACTIONS(6299),
    [sym_primitive_type] = ACTIONS(6299),
    [anon_sym_if] = ACTIONS(6299),
    [anon_sym_switch] = ACTIONS(6299),
    [anon_sym_case] = ACTIONS(6299),
    [anon_sym_default] = ACTIONS(6299),
    [anon_sym_while] = ACTIONS(6299),
    [anon_sym_do] = ACTIONS(6299),
    [anon_sym_for] = ACTIONS(6299),
    [anon_sym_return] = ACTIONS(6299),
    [anon_sym_break] = ACTIONS(6299),
    [anon_sym_continue] = ACTIONS(6299),
    [anon_sym_goto] = ACTIONS(6299),
    [anon_sym___try] = ACTIONS(6299),
    [anon_sym___leave] = ACTIONS(6299),
    [anon_sym_not] = ACTIONS(6299),
    [anon_sym_compl] = ACTIONS(6299),
    [anon_sym_DASH_DASH] = ACTIONS(6301),
    [anon_sym_PLUS_PLUS] = ACTIONS(6301),
    [anon_sym_sizeof] = ACTIONS(6299),
    [anon_sym___alignof__] = ACTIONS(6299),
    [anon_sym___alignof] = ACTIONS(6299),
    [anon_sym__alignof] = ACTIONS(6299),
    [anon_sym_alignof] = ACTIONS(6299),
    [anon_sym__Alignof] = ACTIONS(6299),
    [anon_sym_offsetof] = ACTIONS(6299),
    [anon_sym__Generic] = ACTIONS(6299),
    [anon_sym_asm] = ACTIONS(6299),
    [anon_sym___asm__] = ACTIONS(6299),
    [anon_sym___asm] = ACTIONS(6299),
    [sym_number_literal] = ACTIONS(6301),
    [anon_sym_L_SQUOTE] = ACTIONS(6301),
    [anon_sym_u_SQUOTE] = ACTIONS(6301),
    [anon_sym_U_SQUOTE] = ACTIONS(6301),
    [anon_sym_u8_SQUOTE] = ACTIONS(6301),
    [anon_sym_SQUOTE] = ACTIONS(6301),
    [anon_sym_L_DQUOTE] = ACTIONS(6301),
    [anon_sym_u_DQUOTE] = ACTIONS(6301),
    [anon_sym_U_DQUOTE] = ACTIONS(6301),
    [anon_sym_u8_DQUOTE] = ACTIONS(6301),
    [anon_sym_DQUOTE] = ACTIONS(6301),
    [sym_true] = ACTIONS(6299),
    [sym_false] = ACTIONS(6299),
    [anon_sym_NULL] = ACTIONS(6299),
    [anon_sym_nullptr] = ACTIONS(6299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6299),
    [anon_sym_template] = ACTIONS(6299),
    [anon_sym_try] = ACTIONS(6299),
    [anon_sym_delete] = ACTIONS(6299),
    [anon_sym_throw] = ACTIONS(6299),
    [anon_sym_co_return] = ACTIONS(6299),
    [anon_sym_co_yield] = ACTIONS(6299),
    [anon_sym_R_DQUOTE] = ACTIONS(6301),
    [anon_sym_LR_DQUOTE] = ACTIONS(6301),
    [anon_sym_uR_DQUOTE] = ACTIONS(6301),
    [anon_sym_UR_DQUOTE] = ACTIONS(6301),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6301),
    [anon_sym_co_await] = ACTIONS(6299),
    [anon_sym_new] = ACTIONS(6299),
    [anon_sym_requires] = ACTIONS(6299),
    [sym_this] = ACTIONS(6299),
    [anon_sym_discard] = ACTIONS(6299),
    [anon_sym_cbuffer] = ACTIONS(6299),
  },
  [2448] = {
    [sym_attribute_specifier] = STATE(2364),
    [sym_enumerator_list] = STATE(2408),
    [sym__enum_base_clause] = STATE(2372),
    [sym_identifier] = ACTIONS(6303),
    [anon_sym_LPAREN2] = ACTIONS(6305),
    [anon_sym_TILDE] = ACTIONS(6305),
    [anon_sym_STAR] = ACTIONS(6305),
    [anon_sym_AMP_AMP] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_COLON] = ACTIONS(6297),
    [anon_sym_SEMI] = ACTIONS(6305),
    [anon_sym___extension__] = ACTIONS(6303),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_virtual] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6303),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6305),
    [anon_sym___declspec] = ACTIONS(6303),
    [anon_sym___based] = ACTIONS(6303),
    [anon_sym___cdecl] = ACTIONS(6303),
    [anon_sym___clrcall] = ACTIONS(6303),
    [anon_sym___stdcall] = ACTIONS(6303),
    [anon_sym___fastcall] = ACTIONS(6303),
    [anon_sym___thiscall] = ACTIONS(6303),
    [anon_sym___vectorcall] = ACTIONS(6303),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6303),
    [anon_sym_static] = ACTIONS(6303),
    [anon_sym_register] = ACTIONS(6303),
    [anon_sym_inline] = ACTIONS(6303),
    [anon_sym___inline] = ACTIONS(6303),
    [anon_sym___inline__] = ACTIONS(6303),
    [anon_sym___forceinline] = ACTIONS(6303),
    [anon_sym_thread_local] = ACTIONS(6303),
    [anon_sym___thread] = ACTIONS(6303),
    [anon_sym_const] = ACTIONS(6303),
    [anon_sym_constexpr] = ACTIONS(6303),
    [anon_sym_volatile] = ACTIONS(6303),
    [anon_sym_restrict] = ACTIONS(6303),
    [anon_sym___restrict__] = ACTIONS(6303),
    [anon_sym__Atomic] = ACTIONS(6303),
    [anon_sym__Noreturn] = ACTIONS(6303),
    [anon_sym_noreturn] = ACTIONS(6303),
    [anon_sym__Nonnull] = ACTIONS(6303),
    [anon_sym_mutable] = ACTIONS(6303),
    [anon_sym_constinit] = ACTIONS(6303),
    [anon_sym_consteval] = ACTIONS(6303),
    [anon_sym_alignas] = ACTIONS(6303),
    [anon_sym__Alignas] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6303),
    [anon_sym_decltype] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6303),
    [anon_sym_operator] = ACTIONS(6303),
    [anon_sym_precise] = ACTIONS(6303),
    [anon_sym_shared] = ACTIONS(6303),
    [anon_sym_groupshared] = ACTIONS(6303),
    [anon_sym_uniform] = ACTIONS(6303),
    [anon_sym_row_major] = ACTIONS(6303),
    [anon_sym_column_major] = ACTIONS(6303),
    [anon_sym_globallycoherent] = ACTIONS(6303),
    [anon_sym_centroid] = ACTIONS(6303),
    [anon_sym_noperspective] = ACTIONS(6303),
    [anon_sym_nointerpolation] = ACTIONS(6303),
    [anon_sym_sample] = ACTIONS(6303),
    [anon_sym_linear] = ACTIONS(6303),
    [anon_sym_snorm] = ACTIONS(6303),
    [anon_sym_unorm] = ACTIONS(6303),
    [anon_sym_point] = ACTIONS(6303),
    [anon_sym_line] = ACTIONS(6303),
    [anon_sym_triangleadj] = ACTIONS(6303),
    [anon_sym_lineadj] = ACTIONS(6303),
    [anon_sym_triangle] = ACTIONS(6303),
  },
  [2449] = {
    [sym_template_argument_list] = STATE(2260),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(6307),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4223),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(4215),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_EQ] = ACTIONS(6309),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_GT2] = ACTIONS(6307),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2450] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5166),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5166),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_STAR_EQ] = ACTIONS(5168),
    [anon_sym_SLASH_EQ] = ACTIONS(5168),
    [anon_sym_PERCENT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_GT_EQ] = ACTIONS(5166),
    [anon_sym_AMP_EQ] = ACTIONS(5168),
    [anon_sym_CARET_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_and_eq] = ACTIONS(5166),
    [anon_sym_or_eq] = ACTIONS(5166),
    [anon_sym_xor_eq] = ACTIONS(5166),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
  },
  [2451] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_namespace] = ACTIONS(6311),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6313),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2453] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_namespace] = ACTIONS(6315),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2454] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6317),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2455] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_typedef] = ACTIONS(6319),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(3874),
    [anon_sym_LPAREN2] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3876),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_AMP_AMP] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(3874),
    [anon_sym___extension__] = ACTIONS(3874),
    [anon_sym_in] = ACTIONS(3874),
    [anon_sym_out] = ACTIONS(3874),
    [anon_sym_inout] = ACTIONS(3874),
    [anon_sym_virtual] = ACTIONS(3874),
    [anon_sym_extern] = ACTIONS(3874),
    [anon_sym___attribute__] = ACTIONS(3874),
    [anon_sym___attribute] = ACTIONS(3874),
    [anon_sym_using] = ACTIONS(3874),
    [anon_sym_COLON_COLON] = ACTIONS(3876),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3876),
    [anon_sym___declspec] = ACTIONS(3874),
    [anon_sym___based] = ACTIONS(3874),
    [anon_sym_signed] = ACTIONS(3874),
    [anon_sym_unsigned] = ACTIONS(3874),
    [anon_sym_long] = ACTIONS(3874),
    [anon_sym_short] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3874),
    [anon_sym_register] = ACTIONS(3874),
    [anon_sym_inline] = ACTIONS(3874),
    [anon_sym___inline] = ACTIONS(3874),
    [anon_sym___inline__] = ACTIONS(3874),
    [anon_sym___forceinline] = ACTIONS(3874),
    [anon_sym_thread_local] = ACTIONS(3874),
    [anon_sym___thread] = ACTIONS(3874),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_constexpr] = ACTIONS(3874),
    [anon_sym_volatile] = ACTIONS(3874),
    [anon_sym_restrict] = ACTIONS(3874),
    [anon_sym___restrict__] = ACTIONS(3874),
    [anon_sym__Atomic] = ACTIONS(3874),
    [anon_sym__Noreturn] = ACTIONS(3874),
    [anon_sym_noreturn] = ACTIONS(3874),
    [anon_sym__Nonnull] = ACTIONS(3874),
    [anon_sym_mutable] = ACTIONS(3874),
    [anon_sym_constinit] = ACTIONS(3874),
    [anon_sym_consteval] = ACTIONS(3874),
    [anon_sym_alignas] = ACTIONS(3874),
    [anon_sym__Alignas] = ACTIONS(3874),
    [sym_primitive_type] = ACTIONS(3874),
    [anon_sym_enum] = ACTIONS(3874),
    [anon_sym_class] = ACTIONS(3874),
    [anon_sym_struct] = ACTIONS(3874),
    [anon_sym_union] = ACTIONS(3874),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3874),
    [anon_sym_decltype] = ACTIONS(3874),
    [anon_sym_explicit] = ACTIONS(3874),
    [anon_sym_typename] = ACTIONS(3874),
    [anon_sym_template] = ACTIONS(3874),
    [anon_sym_operator] = ACTIONS(3874),
    [anon_sym_precise] = ACTIONS(3874),
    [anon_sym_shared] = ACTIONS(3874),
    [anon_sym_groupshared] = ACTIONS(3874),
    [anon_sym_uniform] = ACTIONS(3874),
    [anon_sym_row_major] = ACTIONS(3874),
    [anon_sym_column_major] = ACTIONS(3874),
    [anon_sym_globallycoherent] = ACTIONS(3874),
    [anon_sym_centroid] = ACTIONS(3874),
    [anon_sym_noperspective] = ACTIONS(3874),
    [anon_sym_nointerpolation] = ACTIONS(3874),
    [anon_sym_sample] = ACTIONS(3874),
    [anon_sym_linear] = ACTIONS(3874),
    [anon_sym_snorm] = ACTIONS(3874),
    [anon_sym_unorm] = ACTIONS(3874),
    [anon_sym_point] = ACTIONS(3874),
    [anon_sym_line] = ACTIONS(3874),
    [anon_sym_triangleadj] = ACTIONS(3874),
    [anon_sym_lineadj] = ACTIONS(3874),
    [anon_sym_triangle] = ACTIONS(3874),
  },
  [2457] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_namespace] = ACTIONS(6321),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6323),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6325),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2460] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6327),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_in] = ACTIONS(2197),
    [anon_sym_out] = ACTIONS(2197),
    [anon_sym_inout] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2187),
    [anon_sym___declspec] = ACTIONS(2197),
    [anon_sym___based] = ACTIONS(2197),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_register] = ACTIONS(2197),
    [anon_sym_inline] = ACTIONS(2197),
    [anon_sym___inline] = ACTIONS(2197),
    [anon_sym___inline__] = ACTIONS(2197),
    [anon_sym___forceinline] = ACTIONS(2197),
    [anon_sym_thread_local] = ACTIONS(2197),
    [anon_sym___thread] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_union] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_explicit] = ACTIONS(2197),
    [anon_sym_typename] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_operator] = ACTIONS(2197),
    [anon_sym_friend] = ACTIONS(6329),
    [anon_sym_precise] = ACTIONS(2197),
    [anon_sym_shared] = ACTIONS(2197),
    [anon_sym_groupshared] = ACTIONS(2197),
    [anon_sym_uniform] = ACTIONS(2197),
    [anon_sym_row_major] = ACTIONS(2197),
    [anon_sym_column_major] = ACTIONS(2197),
    [anon_sym_globallycoherent] = ACTIONS(2197),
    [anon_sym_centroid] = ACTIONS(2197),
    [anon_sym_noperspective] = ACTIONS(2197),
    [anon_sym_nointerpolation] = ACTIONS(2197),
    [anon_sym_sample] = ACTIONS(2197),
    [anon_sym_linear] = ACTIONS(2197),
    [anon_sym_snorm] = ACTIONS(2197),
    [anon_sym_unorm] = ACTIONS(2197),
    [anon_sym_point] = ACTIONS(2197),
    [anon_sym_line] = ACTIONS(2197),
    [anon_sym_triangleadj] = ACTIONS(2197),
    [anon_sym_lineadj] = ACTIONS(2197),
    [anon_sym_triangle] = ACTIONS(2197),
  },
  [2462] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1985),
    [anon_sym___attribute__] = ACTIONS(1985),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1985),
    [anon_sym_volatile] = ACTIONS(1985),
    [anon_sym_restrict] = ACTIONS(1985),
    [anon_sym___restrict__] = ACTIONS(1985),
    [anon_sym__Atomic] = ACTIONS(1985),
    [anon_sym__Noreturn] = ACTIONS(1985),
    [anon_sym_noreturn] = ACTIONS(1985),
    [anon_sym__Nonnull] = ACTIONS(1985),
    [anon_sym_mutable] = ACTIONS(1985),
    [anon_sym_constinit] = ACTIONS(1985),
    [anon_sym_consteval] = ACTIONS(1985),
    [anon_sym_alignas] = ACTIONS(1985),
    [anon_sym__Alignas] = ACTIONS(1985),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1985),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_and_eq] = ACTIONS(1985),
    [anon_sym_or_eq] = ACTIONS(1985),
    [anon_sym_xor_eq] = ACTIONS(1985),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1985),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1985),
    [anon_sym_not_eq] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1985),
    [anon_sym_decltype] = ACTIONS(1985),
    [anon_sym_final] = ACTIONS(1985),
    [anon_sym_override] = ACTIONS(1985),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1985),
  },
  [2463] = {
    [sym__declaration_modifiers] = STATE(2463),
    [sym_attribute_specifier] = STATE(2463),
    [sym_attribute_declaration] = STATE(2463),
    [sym_ms_declspec_modifier] = STATE(2463),
    [sym_storage_class_specifier] = STATE(2463),
    [sym_type_qualifier] = STATE(2463),
    [sym_alignas_qualifier] = STATE(1369),
    [sym_qualifiers] = STATE(2463),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2463),
    [sym_identifier] = ACTIONS(5805),
    [anon_sym___extension__] = ACTIONS(6331),
    [anon_sym_in] = ACTIONS(6334),
    [anon_sym_out] = ACTIONS(6334),
    [anon_sym_inout] = ACTIONS(6334),
    [anon_sym_virtual] = ACTIONS(6334),
    [anon_sym_extern] = ACTIONS(6337),
    [anon_sym___attribute__] = ACTIONS(6340),
    [anon_sym___attribute] = ACTIONS(6340),
    [anon_sym_COLON_COLON] = ACTIONS(5807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6343),
    [anon_sym___declspec] = ACTIONS(6346),
    [anon_sym_signed] = ACTIONS(5805),
    [anon_sym_unsigned] = ACTIONS(5805),
    [anon_sym_long] = ACTIONS(5805),
    [anon_sym_short] = ACTIONS(5805),
    [anon_sym_static] = ACTIONS(6337),
    [anon_sym_register] = ACTIONS(6337),
    [anon_sym_inline] = ACTIONS(6337),
    [anon_sym___inline] = ACTIONS(6337),
    [anon_sym___inline__] = ACTIONS(6337),
    [anon_sym___forceinline] = ACTIONS(6337),
    [anon_sym_thread_local] = ACTIONS(6337),
    [anon_sym___thread] = ACTIONS(6337),
    [anon_sym_const] = ACTIONS(6331),
    [anon_sym_constexpr] = ACTIONS(6331),
    [anon_sym_volatile] = ACTIONS(6331),
    [anon_sym_restrict] = ACTIONS(6331),
    [anon_sym___restrict__] = ACTIONS(6331),
    [anon_sym__Atomic] = ACTIONS(6331),
    [anon_sym__Noreturn] = ACTIONS(6331),
    [anon_sym_noreturn] = ACTIONS(6331),
    [anon_sym__Nonnull] = ACTIONS(6331),
    [anon_sym_mutable] = ACTIONS(6331),
    [anon_sym_constinit] = ACTIONS(6331),
    [anon_sym_consteval] = ACTIONS(6331),
    [anon_sym_alignas] = ACTIONS(6349),
    [anon_sym__Alignas] = ACTIONS(6349),
    [sym_primitive_type] = ACTIONS(5805),
    [anon_sym_enum] = ACTIONS(5805),
    [anon_sym_class] = ACTIONS(5805),
    [anon_sym_struct] = ACTIONS(5805),
    [anon_sym_union] = ACTIONS(5805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5805),
    [anon_sym_decltype] = ACTIONS(5805),
    [anon_sym_typename] = ACTIONS(5805),
    [anon_sym_template] = ACTIONS(5805),
    [anon_sym_precise] = ACTIONS(6352),
    [anon_sym_shared] = ACTIONS(6352),
    [anon_sym_groupshared] = ACTIONS(6352),
    [anon_sym_uniform] = ACTIONS(6352),
    [anon_sym_row_major] = ACTIONS(6352),
    [anon_sym_column_major] = ACTIONS(6352),
    [anon_sym_globallycoherent] = ACTIONS(6352),
    [anon_sym_centroid] = ACTIONS(6352),
    [anon_sym_noperspective] = ACTIONS(6352),
    [anon_sym_nointerpolation] = ACTIONS(6352),
    [anon_sym_sample] = ACTIONS(6352),
    [anon_sym_linear] = ACTIONS(6352),
    [anon_sym_snorm] = ACTIONS(6352),
    [anon_sym_unorm] = ACTIONS(6352),
    [anon_sym_point] = ACTIONS(6352),
    [anon_sym_line] = ACTIONS(6352),
    [anon_sym_triangleadj] = ACTIONS(6352),
    [anon_sym_lineadj] = ACTIONS(6352),
    [anon_sym_triangle] = ACTIONS(6352),
  },
  [2464] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [aux_sym_preproc_if_token2] = ACTIONS(5745),
    [aux_sym_preproc_else_token1] = ACTIONS(5745),
    [aux_sym_preproc_elif_token1] = ACTIONS(5743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5745),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5745),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5745),
    [anon_sym_GT_GT] = ACTIONS(5745),
    [anon_sym_COLON] = ACTIONS(5745),
    [anon_sym_SEMI] = ACTIONS(5745),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_RBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6355),
    [anon_sym_unsigned] = ACTIONS(6355),
    [anon_sym_long] = ACTIONS(6355),
    [anon_sym_short] = ACTIONS(6355),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_RBRACK] = ACTIONS(5745),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_final] = ACTIONS(5743),
    [anon_sym_override] = ACTIONS(5743),
    [anon_sym_requires] = ACTIONS(5743),
  },
  [2465] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1977),
    [anon_sym___attribute__] = ACTIONS(1977),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1977),
    [anon_sym_volatile] = ACTIONS(1977),
    [anon_sym_restrict] = ACTIONS(1977),
    [anon_sym___restrict__] = ACTIONS(1977),
    [anon_sym__Atomic] = ACTIONS(1977),
    [anon_sym__Noreturn] = ACTIONS(1977),
    [anon_sym_noreturn] = ACTIONS(1977),
    [anon_sym__Nonnull] = ACTIONS(1977),
    [anon_sym_mutable] = ACTIONS(1977),
    [anon_sym_constinit] = ACTIONS(1977),
    [anon_sym_consteval] = ACTIONS(1977),
    [anon_sym_alignas] = ACTIONS(1977),
    [anon_sym__Alignas] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_and_eq] = ACTIONS(1977),
    [anon_sym_or_eq] = ACTIONS(1977),
    [anon_sym_xor_eq] = ACTIONS(1977),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1977),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1977),
    [anon_sym_not_eq] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1977),
    [anon_sym_decltype] = ACTIONS(1977),
    [anon_sym_final] = ACTIONS(1977),
    [anon_sym_override] = ACTIONS(1977),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1977),
  },
  [2466] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1955),
    [anon_sym___attribute__] = ACTIONS(1955),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1955),
    [anon_sym_volatile] = ACTIONS(1955),
    [anon_sym_restrict] = ACTIONS(1955),
    [anon_sym___restrict__] = ACTIONS(1955),
    [anon_sym__Atomic] = ACTIONS(1955),
    [anon_sym__Noreturn] = ACTIONS(1955),
    [anon_sym_noreturn] = ACTIONS(1955),
    [anon_sym__Nonnull] = ACTIONS(1955),
    [anon_sym_mutable] = ACTIONS(1955),
    [anon_sym_constinit] = ACTIONS(1955),
    [anon_sym_consteval] = ACTIONS(1955),
    [anon_sym_alignas] = ACTIONS(1955),
    [anon_sym__Alignas] = ACTIONS(1955),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1955),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_and_eq] = ACTIONS(1955),
    [anon_sym_or_eq] = ACTIONS(1955),
    [anon_sym_xor_eq] = ACTIONS(1955),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1955),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1955),
    [anon_sym_not_eq] = ACTIONS(1955),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1955),
    [anon_sym_decltype] = ACTIONS(1955),
    [anon_sym_final] = ACTIONS(1955),
    [anon_sym_override] = ACTIONS(1955),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1955),
  },
  [2467] = {
    [sym_template_argument_list] = STATE(2260),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_EQ] = ACTIONS(2007),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_GT2] = ACTIONS(2007),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
  },
  [2468] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1981),
    [anon_sym___attribute__] = ACTIONS(1981),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1981),
    [anon_sym_volatile] = ACTIONS(1981),
    [anon_sym_restrict] = ACTIONS(1981),
    [anon_sym___restrict__] = ACTIONS(1981),
    [anon_sym__Atomic] = ACTIONS(1981),
    [anon_sym__Noreturn] = ACTIONS(1981),
    [anon_sym_noreturn] = ACTIONS(1981),
    [anon_sym__Nonnull] = ACTIONS(1981),
    [anon_sym_mutable] = ACTIONS(1981),
    [anon_sym_constinit] = ACTIONS(1981),
    [anon_sym_consteval] = ACTIONS(1981),
    [anon_sym_alignas] = ACTIONS(1981),
    [anon_sym__Alignas] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_and_eq] = ACTIONS(1981),
    [anon_sym_or_eq] = ACTIONS(1981),
    [anon_sym_xor_eq] = ACTIONS(1981),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1981),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1981),
    [anon_sym_not_eq] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1981),
    [anon_sym_decltype] = ACTIONS(1981),
    [anon_sym_final] = ACTIONS(1981),
    [anon_sym_override] = ACTIONS(1981),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1981),
  },
  [2469] = {
    [sym_string_literal] = STATE(2491),
    [sym_template_argument_list] = STATE(2841),
    [sym_raw_string_literal] = STATE(2491),
    [sym_identifier] = ACTIONS(4225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [aux_sym_preproc_if_token2] = ACTIONS(4217),
    [aux_sym_preproc_else_token1] = ACTIONS(4217),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4225),
    [anon_sym_or_eq] = ACTIONS(4225),
    [anon_sym_xor_eq] = ACTIONS(4225),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
  },
  [2470] = {
    [sym_identifier] = ACTIONS(5961),
    [anon_sym_LPAREN2] = ACTIONS(5963),
    [anon_sym_TILDE] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_AMP_AMP] = ACTIONS(5963),
    [anon_sym_AMP] = ACTIONS(5961),
    [anon_sym___extension__] = ACTIONS(5961),
    [anon_sym_in] = ACTIONS(5961),
    [anon_sym_out] = ACTIONS(5961),
    [anon_sym_inout] = ACTIONS(5961),
    [anon_sym_virtual] = ACTIONS(5961),
    [anon_sym_extern] = ACTIONS(5961),
    [anon_sym___attribute__] = ACTIONS(5961),
    [anon_sym___attribute] = ACTIONS(5961),
    [anon_sym_COLON_COLON] = ACTIONS(5963),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5963),
    [anon_sym___declspec] = ACTIONS(5961),
    [anon_sym___based] = ACTIONS(5961),
    [anon_sym_signed] = ACTIONS(5961),
    [anon_sym_unsigned] = ACTIONS(5961),
    [anon_sym_long] = ACTIONS(5961),
    [anon_sym_short] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5961),
    [anon_sym_static] = ACTIONS(5961),
    [anon_sym_register] = ACTIONS(5961),
    [anon_sym_inline] = ACTIONS(5961),
    [anon_sym___inline] = ACTIONS(5961),
    [anon_sym___inline__] = ACTIONS(5961),
    [anon_sym___forceinline] = ACTIONS(5961),
    [anon_sym_thread_local] = ACTIONS(5961),
    [anon_sym___thread] = ACTIONS(5961),
    [anon_sym_const] = ACTIONS(5961),
    [anon_sym_constexpr] = ACTIONS(5961),
    [anon_sym_volatile] = ACTIONS(5961),
    [anon_sym_restrict] = ACTIONS(5961),
    [anon_sym___restrict__] = ACTIONS(5961),
    [anon_sym__Atomic] = ACTIONS(5961),
    [anon_sym__Noreturn] = ACTIONS(5961),
    [anon_sym_noreturn] = ACTIONS(5961),
    [anon_sym__Nonnull] = ACTIONS(5961),
    [anon_sym_mutable] = ACTIONS(5961),
    [anon_sym_constinit] = ACTIONS(5961),
    [anon_sym_consteval] = ACTIONS(5961),
    [anon_sym_alignas] = ACTIONS(5961),
    [anon_sym__Alignas] = ACTIONS(5961),
    [sym_primitive_type] = ACTIONS(5961),
    [anon_sym_enum] = ACTIONS(5961),
    [anon_sym_class] = ACTIONS(5961),
    [anon_sym_struct] = ACTIONS(5961),
    [anon_sym_union] = ACTIONS(5961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5961),
    [anon_sym_decltype] = ACTIONS(5961),
    [anon_sym_explicit] = ACTIONS(5961),
    [anon_sym_typename] = ACTIONS(5961),
    [anon_sym_template] = ACTIONS(5961),
    [anon_sym_operator] = ACTIONS(5961),
    [anon_sym_precise] = ACTIONS(5961),
    [anon_sym_shared] = ACTIONS(5961),
    [anon_sym_groupshared] = ACTIONS(5961),
    [anon_sym_uniform] = ACTIONS(5961),
    [anon_sym_row_major] = ACTIONS(5961),
    [anon_sym_column_major] = ACTIONS(5961),
    [anon_sym_globallycoherent] = ACTIONS(5961),
    [anon_sym_centroid] = ACTIONS(5961),
    [anon_sym_noperspective] = ACTIONS(5961),
    [anon_sym_nointerpolation] = ACTIONS(5961),
    [anon_sym_sample] = ACTIONS(5961),
    [anon_sym_linear] = ACTIONS(5961),
    [anon_sym_snorm] = ACTIONS(5961),
    [anon_sym_unorm] = ACTIONS(5961),
    [anon_sym_point] = ACTIONS(5961),
    [anon_sym_line] = ACTIONS(5961),
    [anon_sym_triangleadj] = ACTIONS(5961),
    [anon_sym_lineadj] = ACTIONS(5961),
    [anon_sym_triangle] = ACTIONS(5961),
  },
  [2471] = {
    [sym_identifier] = ACTIONS(6099),
    [anon_sym_LPAREN2] = ACTIONS(6101),
    [anon_sym_TILDE] = ACTIONS(6101),
    [anon_sym_STAR] = ACTIONS(6101),
    [anon_sym_AMP_AMP] = ACTIONS(6101),
    [anon_sym_AMP] = ACTIONS(6099),
    [anon_sym___extension__] = ACTIONS(6099),
    [anon_sym_in] = ACTIONS(6099),
    [anon_sym_out] = ACTIONS(6099),
    [anon_sym_inout] = ACTIONS(6099),
    [anon_sym_virtual] = ACTIONS(6099),
    [anon_sym_extern] = ACTIONS(6099),
    [anon_sym___attribute__] = ACTIONS(6099),
    [anon_sym___attribute] = ACTIONS(6099),
    [anon_sym_COLON_COLON] = ACTIONS(6101),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6101),
    [anon_sym___declspec] = ACTIONS(6099),
    [anon_sym___based] = ACTIONS(6099),
    [anon_sym_signed] = ACTIONS(6099),
    [anon_sym_unsigned] = ACTIONS(6099),
    [anon_sym_long] = ACTIONS(6099),
    [anon_sym_short] = ACTIONS(6099),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_static] = ACTIONS(6099),
    [anon_sym_register] = ACTIONS(6099),
    [anon_sym_inline] = ACTIONS(6099),
    [anon_sym___inline] = ACTIONS(6099),
    [anon_sym___inline__] = ACTIONS(6099),
    [anon_sym___forceinline] = ACTIONS(6099),
    [anon_sym_thread_local] = ACTIONS(6099),
    [anon_sym___thread] = ACTIONS(6099),
    [anon_sym_const] = ACTIONS(6099),
    [anon_sym_constexpr] = ACTIONS(6099),
    [anon_sym_volatile] = ACTIONS(6099),
    [anon_sym_restrict] = ACTIONS(6099),
    [anon_sym___restrict__] = ACTIONS(6099),
    [anon_sym__Atomic] = ACTIONS(6099),
    [anon_sym__Noreturn] = ACTIONS(6099),
    [anon_sym_noreturn] = ACTIONS(6099),
    [anon_sym__Nonnull] = ACTIONS(6099),
    [anon_sym_mutable] = ACTIONS(6099),
    [anon_sym_constinit] = ACTIONS(6099),
    [anon_sym_consteval] = ACTIONS(6099),
    [anon_sym_alignas] = ACTIONS(6099),
    [anon_sym__Alignas] = ACTIONS(6099),
    [sym_primitive_type] = ACTIONS(6099),
    [anon_sym_enum] = ACTIONS(6099),
    [anon_sym_class] = ACTIONS(6099),
    [anon_sym_struct] = ACTIONS(6099),
    [anon_sym_union] = ACTIONS(6099),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6099),
    [anon_sym_decltype] = ACTIONS(6099),
    [anon_sym_explicit] = ACTIONS(6099),
    [anon_sym_typename] = ACTIONS(6099),
    [anon_sym_template] = ACTIONS(6099),
    [anon_sym_operator] = ACTIONS(6099),
    [anon_sym_precise] = ACTIONS(6099),
    [anon_sym_shared] = ACTIONS(6099),
    [anon_sym_groupshared] = ACTIONS(6099),
    [anon_sym_uniform] = ACTIONS(6099),
    [anon_sym_row_major] = ACTIONS(6099),
    [anon_sym_column_major] = ACTIONS(6099),
    [anon_sym_globallycoherent] = ACTIONS(6099),
    [anon_sym_centroid] = ACTIONS(6099),
    [anon_sym_noperspective] = ACTIONS(6099),
    [anon_sym_nointerpolation] = ACTIONS(6099),
    [anon_sym_sample] = ACTIONS(6099),
    [anon_sym_linear] = ACTIONS(6099),
    [anon_sym_snorm] = ACTIONS(6099),
    [anon_sym_unorm] = ACTIONS(6099),
    [anon_sym_point] = ACTIONS(6099),
    [anon_sym_line] = ACTIONS(6099),
    [anon_sym_triangleadj] = ACTIONS(6099),
    [anon_sym_lineadj] = ACTIONS(6099),
    [anon_sym_triangle] = ACTIONS(6099),
  },
  [2472] = {
    [sym__declaration_modifiers] = STATE(2472),
    [sym_attribute_specifier] = STATE(2472),
    [sym_attribute_declaration] = STATE(2472),
    [sym_ms_declspec_modifier] = STATE(2472),
    [sym_storage_class_specifier] = STATE(2472),
    [sym_type_qualifier] = STATE(2472),
    [sym_alignas_qualifier] = STATE(2431),
    [sym_explicit_function_specifier] = STATE(2472),
    [sym__constructor_specifiers] = STATE(2472),
    [sym_qualifiers] = STATE(2472),
    [aux_sym_operator_cast_definition_repeat1] = STATE(2472),
    [sym_identifier] = ACTIONS(6361),
    [anon_sym_LPAREN2] = ACTIONS(6363),
    [anon_sym_TILDE] = ACTIONS(6363),
    [anon_sym_STAR] = ACTIONS(6363),
    [anon_sym_AMP_AMP] = ACTIONS(6363),
    [anon_sym_AMP] = ACTIONS(6361),
    [anon_sym___extension__] = ACTIONS(6365),
    [anon_sym_in] = ACTIONS(6368),
    [anon_sym_out] = ACTIONS(6368),
    [anon_sym_inout] = ACTIONS(6368),
    [anon_sym_virtual] = ACTIONS(6368),
    [anon_sym_extern] = ACTIONS(6371),
    [anon_sym___attribute__] = ACTIONS(6374),
    [anon_sym___attribute] = ACTIONS(6374),
    [anon_sym_COLON_COLON] = ACTIONS(6363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6377),
    [anon_sym___declspec] = ACTIONS(6380),
    [anon_sym___based] = ACTIONS(6361),
    [anon_sym_LBRACK] = ACTIONS(6361),
    [anon_sym_static] = ACTIONS(6371),
    [anon_sym_register] = ACTIONS(6371),
    [anon_sym_inline] = ACTIONS(6371),
    [anon_sym___inline] = ACTIONS(6371),
    [anon_sym___inline__] = ACTIONS(6371),
    [anon_sym___forceinline] = ACTIONS(6371),
    [anon_sym_thread_local] = ACTIONS(6371),
    [anon_sym___thread] = ACTIONS(6371),
    [anon_sym_const] = ACTIONS(6365),
    [anon_sym_constexpr] = ACTIONS(6365),
    [anon_sym_volatile] = ACTIONS(6365),
    [anon_sym_restrict] = ACTIONS(6365),
    [anon_sym___restrict__] = ACTIONS(6365),
    [anon_sym__Atomic] = ACTIONS(6365),
    [anon_sym__Noreturn] = ACTIONS(6365),
    [anon_sym_noreturn] = ACTIONS(6365),
    [anon_sym__Nonnull] = ACTIONS(6365),
    [anon_sym_mutable] = ACTIONS(6365),
    [anon_sym_constinit] = ACTIONS(6365),
    [anon_sym_consteval] = ACTIONS(6365),
    [anon_sym_alignas] = ACTIONS(6383),
    [anon_sym__Alignas] = ACTIONS(6383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6361),
    [anon_sym_explicit] = ACTIONS(6386),
    [anon_sym_template] = ACTIONS(6361),
    [anon_sym_operator] = ACTIONS(6361),
    [anon_sym_precise] = ACTIONS(6389),
    [anon_sym_shared] = ACTIONS(6389),
    [anon_sym_groupshared] = ACTIONS(6389),
    [anon_sym_uniform] = ACTIONS(6389),
    [anon_sym_row_major] = ACTIONS(6389),
    [anon_sym_column_major] = ACTIONS(6389),
    [anon_sym_globallycoherent] = ACTIONS(6389),
    [anon_sym_centroid] = ACTIONS(6389),
    [anon_sym_noperspective] = ACTIONS(6389),
    [anon_sym_nointerpolation] = ACTIONS(6389),
    [anon_sym_sample] = ACTIONS(6389),
    [anon_sym_linear] = ACTIONS(6389),
    [anon_sym_snorm] = ACTIONS(6389),
    [anon_sym_unorm] = ACTIONS(6389),
    [anon_sym_point] = ACTIONS(6389),
    [anon_sym_line] = ACTIONS(6389),
    [anon_sym_triangleadj] = ACTIONS(6389),
    [anon_sym_lineadj] = ACTIONS(6389),
    [anon_sym_triangle] = ACTIONS(6389),
  },
  [2473] = {
    [sym_identifier] = ACTIONS(6392),
    [anon_sym_SEMI] = ACTIONS(6394),
    [anon_sym___extension__] = ACTIONS(6392),
    [anon_sym_in] = ACTIONS(6392),
    [anon_sym_out] = ACTIONS(6392),
    [anon_sym_inout] = ACTIONS(6392),
    [anon_sym_virtual] = ACTIONS(6392),
    [anon_sym_extern] = ACTIONS(6392),
    [anon_sym___attribute__] = ACTIONS(6392),
    [anon_sym___attribute] = ACTIONS(6392),
    [anon_sym_COLON_COLON] = ACTIONS(6394),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6394),
    [anon_sym___declspec] = ACTIONS(6392),
    [anon_sym___cdecl] = ACTIONS(6392),
    [anon_sym___clrcall] = ACTIONS(6392),
    [anon_sym___stdcall] = ACTIONS(6392),
    [anon_sym___fastcall] = ACTIONS(6392),
    [anon_sym___thiscall] = ACTIONS(6392),
    [anon_sym___vectorcall] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6394),
    [anon_sym_signed] = ACTIONS(6392),
    [anon_sym_unsigned] = ACTIONS(6392),
    [anon_sym_long] = ACTIONS(6392),
    [anon_sym_short] = ACTIONS(6392),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_static] = ACTIONS(6392),
    [anon_sym_register] = ACTIONS(6392),
    [anon_sym_inline] = ACTIONS(6392),
    [anon_sym___inline] = ACTIONS(6392),
    [anon_sym___inline__] = ACTIONS(6392),
    [anon_sym___forceinline] = ACTIONS(6392),
    [anon_sym_thread_local] = ACTIONS(6392),
    [anon_sym___thread] = ACTIONS(6392),
    [anon_sym_const] = ACTIONS(6392),
    [anon_sym_constexpr] = ACTIONS(6392),
    [anon_sym_volatile] = ACTIONS(6392),
    [anon_sym_restrict] = ACTIONS(6392),
    [anon_sym___restrict__] = ACTIONS(6392),
    [anon_sym__Atomic] = ACTIONS(6392),
    [anon_sym__Noreturn] = ACTIONS(6392),
    [anon_sym_noreturn] = ACTIONS(6392),
    [anon_sym__Nonnull] = ACTIONS(6392),
    [anon_sym_mutable] = ACTIONS(6392),
    [anon_sym_constinit] = ACTIONS(6392),
    [anon_sym_consteval] = ACTIONS(6392),
    [anon_sym_alignas] = ACTIONS(6392),
    [anon_sym__Alignas] = ACTIONS(6392),
    [sym_primitive_type] = ACTIONS(6392),
    [anon_sym_enum] = ACTIONS(6392),
    [anon_sym_class] = ACTIONS(6392),
    [anon_sym_struct] = ACTIONS(6392),
    [anon_sym_union] = ACTIONS(6392),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6392),
    [anon_sym_decltype] = ACTIONS(6392),
    [anon_sym_typename] = ACTIONS(6392),
    [anon_sym_template] = ACTIONS(6392),
    [anon_sym_precise] = ACTIONS(6392),
    [anon_sym_shared] = ACTIONS(6392),
    [anon_sym_groupshared] = ACTIONS(6392),
    [anon_sym_uniform] = ACTIONS(6392),
    [anon_sym_row_major] = ACTIONS(6392),
    [anon_sym_column_major] = ACTIONS(6392),
    [anon_sym_globallycoherent] = ACTIONS(6392),
    [anon_sym_centroid] = ACTIONS(6392),
    [anon_sym_noperspective] = ACTIONS(6392),
    [anon_sym_nointerpolation] = ACTIONS(6392),
    [anon_sym_sample] = ACTIONS(6392),
    [anon_sym_linear] = ACTIONS(6392),
    [anon_sym_snorm] = ACTIONS(6392),
    [anon_sym_unorm] = ACTIONS(6392),
    [anon_sym_point] = ACTIONS(6392),
    [anon_sym_line] = ACTIONS(6392),
    [anon_sym_triangleadj] = ACTIONS(6392),
    [anon_sym_lineadj] = ACTIONS(6392),
    [anon_sym_triangle] = ACTIONS(6392),
  },
  [2474] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1993),
    [anon_sym___attribute__] = ACTIONS(1993),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1993),
    [anon_sym_volatile] = ACTIONS(1993),
    [anon_sym_restrict] = ACTIONS(1993),
    [anon_sym___restrict__] = ACTIONS(1993),
    [anon_sym__Atomic] = ACTIONS(1993),
    [anon_sym__Noreturn] = ACTIONS(1993),
    [anon_sym_noreturn] = ACTIONS(1993),
    [anon_sym__Nonnull] = ACTIONS(1993),
    [anon_sym_mutable] = ACTIONS(1993),
    [anon_sym_constinit] = ACTIONS(1993),
    [anon_sym_consteval] = ACTIONS(1993),
    [anon_sym_alignas] = ACTIONS(1993),
    [anon_sym__Alignas] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1993),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_and_eq] = ACTIONS(1993),
    [anon_sym_or_eq] = ACTIONS(1993),
    [anon_sym_xor_eq] = ACTIONS(1993),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1993),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1993),
    [anon_sym_not_eq] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1993),
    [anon_sym_decltype] = ACTIONS(1993),
    [anon_sym_final] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1993),
  },
  [2475] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1989),
    [anon_sym___attribute__] = ACTIONS(1989),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1989),
    [anon_sym_volatile] = ACTIONS(1989),
    [anon_sym_restrict] = ACTIONS(1989),
    [anon_sym___restrict__] = ACTIONS(1989),
    [anon_sym__Atomic] = ACTIONS(1989),
    [anon_sym__Noreturn] = ACTIONS(1989),
    [anon_sym_noreturn] = ACTIONS(1989),
    [anon_sym__Nonnull] = ACTIONS(1989),
    [anon_sym_mutable] = ACTIONS(1989),
    [anon_sym_constinit] = ACTIONS(1989),
    [anon_sym_consteval] = ACTIONS(1989),
    [anon_sym_alignas] = ACTIONS(1989),
    [anon_sym__Alignas] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_and_eq] = ACTIONS(1989),
    [anon_sym_or_eq] = ACTIONS(1989),
    [anon_sym_xor_eq] = ACTIONS(1989),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1989),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1989),
    [anon_sym_not_eq] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1989),
    [anon_sym_decltype] = ACTIONS(1989),
    [anon_sym_final] = ACTIONS(1989),
    [anon_sym_override] = ACTIONS(1989),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1989),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(6261),
    [anon_sym_LPAREN2] = ACTIONS(6263),
    [anon_sym_TILDE] = ACTIONS(6263),
    [anon_sym_STAR] = ACTIONS(6263),
    [anon_sym_AMP_AMP] = ACTIONS(6263),
    [anon_sym_AMP] = ACTIONS(6261),
    [anon_sym___extension__] = ACTIONS(6261),
    [anon_sym_in] = ACTIONS(6261),
    [anon_sym_out] = ACTIONS(6261),
    [anon_sym_inout] = ACTIONS(6261),
    [anon_sym_virtual] = ACTIONS(6261),
    [anon_sym_extern] = ACTIONS(6261),
    [anon_sym___attribute__] = ACTIONS(6261),
    [anon_sym___attribute] = ACTIONS(6261),
    [anon_sym_COLON_COLON] = ACTIONS(6263),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6263),
    [anon_sym___declspec] = ACTIONS(6261),
    [anon_sym___based] = ACTIONS(6261),
    [anon_sym_signed] = ACTIONS(6261),
    [anon_sym_unsigned] = ACTIONS(6261),
    [anon_sym_long] = ACTIONS(6261),
    [anon_sym_short] = ACTIONS(6261),
    [anon_sym_LBRACK] = ACTIONS(6261),
    [anon_sym_static] = ACTIONS(6261),
    [anon_sym_register] = ACTIONS(6261),
    [anon_sym_inline] = ACTIONS(6261),
    [anon_sym___inline] = ACTIONS(6261),
    [anon_sym___inline__] = ACTIONS(6261),
    [anon_sym___forceinline] = ACTIONS(6261),
    [anon_sym_thread_local] = ACTIONS(6261),
    [anon_sym___thread] = ACTIONS(6261),
    [anon_sym_const] = ACTIONS(6261),
    [anon_sym_constexpr] = ACTIONS(6261),
    [anon_sym_volatile] = ACTIONS(6261),
    [anon_sym_restrict] = ACTIONS(6261),
    [anon_sym___restrict__] = ACTIONS(6261),
    [anon_sym__Atomic] = ACTIONS(6261),
    [anon_sym__Noreturn] = ACTIONS(6261),
    [anon_sym_noreturn] = ACTIONS(6261),
    [anon_sym__Nonnull] = ACTIONS(6261),
    [anon_sym_mutable] = ACTIONS(6261),
    [anon_sym_constinit] = ACTIONS(6261),
    [anon_sym_consteval] = ACTIONS(6261),
    [anon_sym_alignas] = ACTIONS(6261),
    [anon_sym__Alignas] = ACTIONS(6261),
    [sym_primitive_type] = ACTIONS(6261),
    [anon_sym_enum] = ACTIONS(6261),
    [anon_sym_class] = ACTIONS(6261),
    [anon_sym_struct] = ACTIONS(6261),
    [anon_sym_union] = ACTIONS(6261),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6261),
    [anon_sym_decltype] = ACTIONS(6261),
    [anon_sym_explicit] = ACTIONS(6261),
    [anon_sym_typename] = ACTIONS(6261),
    [anon_sym_template] = ACTIONS(6261),
    [anon_sym_operator] = ACTIONS(6261),
    [anon_sym_precise] = ACTIONS(6261),
    [anon_sym_shared] = ACTIONS(6261),
    [anon_sym_groupshared] = ACTIONS(6261),
    [anon_sym_uniform] = ACTIONS(6261),
    [anon_sym_row_major] = ACTIONS(6261),
    [anon_sym_column_major] = ACTIONS(6261),
    [anon_sym_globallycoherent] = ACTIONS(6261),
    [anon_sym_centroid] = ACTIONS(6261),
    [anon_sym_noperspective] = ACTIONS(6261),
    [anon_sym_nointerpolation] = ACTIONS(6261),
    [anon_sym_sample] = ACTIONS(6261),
    [anon_sym_linear] = ACTIONS(6261),
    [anon_sym_snorm] = ACTIONS(6261),
    [anon_sym_unorm] = ACTIONS(6261),
    [anon_sym_point] = ACTIONS(6261),
    [anon_sym_line] = ACTIONS(6261),
    [anon_sym_triangleadj] = ACTIONS(6261),
    [anon_sym_lineadj] = ACTIONS(6261),
    [anon_sym_triangle] = ACTIONS(6261),
  },
  [2477] = {
    [sym_identifier] = ACTIONS(6396),
    [anon_sym_LPAREN2] = ACTIONS(6399),
    [anon_sym_TILDE] = ACTIONS(6399),
    [anon_sym_STAR] = ACTIONS(6399),
    [anon_sym_AMP_AMP] = ACTIONS(6399),
    [anon_sym_AMP] = ACTIONS(6401),
    [anon_sym___extension__] = ACTIONS(6396),
    [anon_sym_in] = ACTIONS(6396),
    [anon_sym_out] = ACTIONS(6396),
    [anon_sym_inout] = ACTIONS(6396),
    [anon_sym_virtual] = ACTIONS(6396),
    [anon_sym_extern] = ACTIONS(6396),
    [anon_sym___attribute__] = ACTIONS(6396),
    [anon_sym___attribute] = ACTIONS(6396),
    [anon_sym_COLON_COLON] = ACTIONS(6403),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6403),
    [anon_sym___declspec] = ACTIONS(6396),
    [anon_sym___based] = ACTIONS(6401),
    [anon_sym_signed] = ACTIONS(6406),
    [anon_sym_unsigned] = ACTIONS(6406),
    [anon_sym_long] = ACTIONS(6406),
    [anon_sym_short] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6401),
    [anon_sym_static] = ACTIONS(6396),
    [anon_sym_register] = ACTIONS(6396),
    [anon_sym_inline] = ACTIONS(6396),
    [anon_sym___inline] = ACTIONS(6396),
    [anon_sym___inline__] = ACTIONS(6396),
    [anon_sym___forceinline] = ACTIONS(6396),
    [anon_sym_thread_local] = ACTIONS(6396),
    [anon_sym___thread] = ACTIONS(6396),
    [anon_sym_const] = ACTIONS(6396),
    [anon_sym_constexpr] = ACTIONS(6396),
    [anon_sym_volatile] = ACTIONS(6396),
    [anon_sym_restrict] = ACTIONS(6396),
    [anon_sym___restrict__] = ACTIONS(6396),
    [anon_sym__Atomic] = ACTIONS(6396),
    [anon_sym__Noreturn] = ACTIONS(6396),
    [anon_sym_noreturn] = ACTIONS(6396),
    [anon_sym__Nonnull] = ACTIONS(6396),
    [anon_sym_mutable] = ACTIONS(6396),
    [anon_sym_constinit] = ACTIONS(6396),
    [anon_sym_consteval] = ACTIONS(6396),
    [anon_sym_alignas] = ACTIONS(6396),
    [anon_sym__Alignas] = ACTIONS(6396),
    [sym_primitive_type] = ACTIONS(6406),
    [anon_sym_enum] = ACTIONS(6406),
    [anon_sym_class] = ACTIONS(6406),
    [anon_sym_struct] = ACTIONS(6406),
    [anon_sym_union] = ACTIONS(6406),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6406),
    [anon_sym_decltype] = ACTIONS(6396),
    [anon_sym_explicit] = ACTIONS(6401),
    [anon_sym_typename] = ACTIONS(6406),
    [anon_sym_template] = ACTIONS(6396),
    [anon_sym_operator] = ACTIONS(6401),
    [anon_sym_precise] = ACTIONS(6396),
    [anon_sym_shared] = ACTIONS(6396),
    [anon_sym_groupshared] = ACTIONS(6396),
    [anon_sym_uniform] = ACTIONS(6396),
    [anon_sym_row_major] = ACTIONS(6396),
    [anon_sym_column_major] = ACTIONS(6396),
    [anon_sym_globallycoherent] = ACTIONS(6396),
    [anon_sym_centroid] = ACTIONS(6396),
    [anon_sym_noperspective] = ACTIONS(6396),
    [anon_sym_nointerpolation] = ACTIONS(6396),
    [anon_sym_sample] = ACTIONS(6396),
    [anon_sym_linear] = ACTIONS(6396),
    [anon_sym_snorm] = ACTIONS(6396),
    [anon_sym_unorm] = ACTIONS(6396),
    [anon_sym_point] = ACTIONS(6396),
    [anon_sym_line] = ACTIONS(6396),
    [anon_sym_triangleadj] = ACTIONS(6396),
    [anon_sym_lineadj] = ACTIONS(6396),
    [anon_sym_triangle] = ACTIONS(6396),
  },
  [2478] = {
    [sym_identifier] = ACTIONS(6408),
    [anon_sym_SEMI] = ACTIONS(6410),
    [anon_sym___extension__] = ACTIONS(6408),
    [anon_sym_in] = ACTIONS(6408),
    [anon_sym_out] = ACTIONS(6408),
    [anon_sym_inout] = ACTIONS(6408),
    [anon_sym_virtual] = ACTIONS(6408),
    [anon_sym_extern] = ACTIONS(6408),
    [anon_sym___attribute__] = ACTIONS(6408),
    [anon_sym___attribute] = ACTIONS(6408),
    [anon_sym_COLON_COLON] = ACTIONS(6410),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6410),
    [anon_sym___declspec] = ACTIONS(6408),
    [anon_sym___cdecl] = ACTIONS(6408),
    [anon_sym___clrcall] = ACTIONS(6408),
    [anon_sym___stdcall] = ACTIONS(6408),
    [anon_sym___fastcall] = ACTIONS(6408),
    [anon_sym___thiscall] = ACTIONS(6408),
    [anon_sym___vectorcall] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6410),
    [anon_sym_signed] = ACTIONS(6408),
    [anon_sym_unsigned] = ACTIONS(6408),
    [anon_sym_long] = ACTIONS(6408),
    [anon_sym_short] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_static] = ACTIONS(6408),
    [anon_sym_register] = ACTIONS(6408),
    [anon_sym_inline] = ACTIONS(6408),
    [anon_sym___inline] = ACTIONS(6408),
    [anon_sym___inline__] = ACTIONS(6408),
    [anon_sym___forceinline] = ACTIONS(6408),
    [anon_sym_thread_local] = ACTIONS(6408),
    [anon_sym___thread] = ACTIONS(6408),
    [anon_sym_const] = ACTIONS(6408),
    [anon_sym_constexpr] = ACTIONS(6408),
    [anon_sym_volatile] = ACTIONS(6408),
    [anon_sym_restrict] = ACTIONS(6408),
    [anon_sym___restrict__] = ACTIONS(6408),
    [anon_sym__Atomic] = ACTIONS(6408),
    [anon_sym__Noreturn] = ACTIONS(6408),
    [anon_sym_noreturn] = ACTIONS(6408),
    [anon_sym__Nonnull] = ACTIONS(6408),
    [anon_sym_mutable] = ACTIONS(6408),
    [anon_sym_constinit] = ACTIONS(6408),
    [anon_sym_consteval] = ACTIONS(6408),
    [anon_sym_alignas] = ACTIONS(6408),
    [anon_sym__Alignas] = ACTIONS(6408),
    [sym_primitive_type] = ACTIONS(6408),
    [anon_sym_enum] = ACTIONS(6408),
    [anon_sym_class] = ACTIONS(6408),
    [anon_sym_struct] = ACTIONS(6408),
    [anon_sym_union] = ACTIONS(6408),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6408),
    [anon_sym_decltype] = ACTIONS(6408),
    [anon_sym_typename] = ACTIONS(6408),
    [anon_sym_template] = ACTIONS(6408),
    [anon_sym_precise] = ACTIONS(6408),
    [anon_sym_shared] = ACTIONS(6408),
    [anon_sym_groupshared] = ACTIONS(6408),
    [anon_sym_uniform] = ACTIONS(6408),
    [anon_sym_row_major] = ACTIONS(6408),
    [anon_sym_column_major] = ACTIONS(6408),
    [anon_sym_globallycoherent] = ACTIONS(6408),
    [anon_sym_centroid] = ACTIONS(6408),
    [anon_sym_noperspective] = ACTIONS(6408),
    [anon_sym_nointerpolation] = ACTIONS(6408),
    [anon_sym_sample] = ACTIONS(6408),
    [anon_sym_linear] = ACTIONS(6408),
    [anon_sym_snorm] = ACTIONS(6408),
    [anon_sym_unorm] = ACTIONS(6408),
    [anon_sym_point] = ACTIONS(6408),
    [anon_sym_line] = ACTIONS(6408),
    [anon_sym_triangleadj] = ACTIONS(6408),
    [anon_sym_lineadj] = ACTIONS(6408),
    [anon_sym_triangle] = ACTIONS(6408),
  },
  [2479] = {
    [sym_template_argument_list] = STATE(2260),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1999),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1999),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_GT2] = ACTIONS(1999),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2480] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1973),
    [anon_sym___attribute__] = ACTIONS(1973),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1973),
    [anon_sym_volatile] = ACTIONS(1973),
    [anon_sym_restrict] = ACTIONS(1973),
    [anon_sym___restrict__] = ACTIONS(1973),
    [anon_sym__Atomic] = ACTIONS(1973),
    [anon_sym__Noreturn] = ACTIONS(1973),
    [anon_sym_noreturn] = ACTIONS(1973),
    [anon_sym__Nonnull] = ACTIONS(1973),
    [anon_sym_mutable] = ACTIONS(1973),
    [anon_sym_constinit] = ACTIONS(1973),
    [anon_sym_consteval] = ACTIONS(1973),
    [anon_sym_alignas] = ACTIONS(1973),
    [anon_sym__Alignas] = ACTIONS(1973),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1973),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_and_eq] = ACTIONS(1973),
    [anon_sym_or_eq] = ACTIONS(1973),
    [anon_sym_xor_eq] = ACTIONS(1973),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1973),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1973),
    [anon_sym_not_eq] = ACTIONS(1973),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1973),
    [anon_sym_decltype] = ACTIONS(1973),
    [anon_sym_final] = ACTIONS(1973),
    [anon_sym_override] = ACTIONS(1973),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1973),
  },
  [2481] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2483),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5872),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5872),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5872),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5872),
    [anon_sym_GT_GT] = ACTIONS(5872),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(6412),
    [anon_sym_unsigned] = ACTIONS(6412),
    [anon_sym_long] = ACTIONS(6412),
    [anon_sym_short] = ACTIONS(6412),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_EQ] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_STAR_EQ] = ACTIONS(5875),
    [anon_sym_SLASH_EQ] = ACTIONS(5875),
    [anon_sym_PERCENT_EQ] = ACTIONS(5875),
    [anon_sym_PLUS_EQ] = ACTIONS(5875),
    [anon_sym_DASH_EQ] = ACTIONS(5875),
    [anon_sym_LT_LT_EQ] = ACTIONS(5875),
    [anon_sym_GT_GT_EQ] = ACTIONS(5875),
    [anon_sym_AMP_EQ] = ACTIONS(5875),
    [anon_sym_CARET_EQ] = ACTIONS(5875),
    [anon_sym_PIPE_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5872),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5875),
  },
  [2482] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(2017),
    [anon_sym_out] = ACTIONS(2017),
    [anon_sym_inout] = ACTIONS(2017),
    [anon_sym_virtual] = ACTIONS(2017),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2019),
    [anon_sym___declspec] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_EQ] = ACTIONS(2019),
    [anon_sym_register] = ACTIONS(2017),
    [anon_sym_inline] = ACTIONS(2017),
    [anon_sym___inline] = ACTIONS(2017),
    [anon_sym___inline__] = ACTIONS(2017),
    [anon_sym___forceinline] = ACTIONS(2017),
    [anon_sym_thread_local] = ACTIONS(2017),
    [anon_sym___thread] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_GT2] = ACTIONS(2019),
    [anon_sym_operator] = ACTIONS(2017),
    [anon_sym_try] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
    [anon_sym_precise] = ACTIONS(2017),
    [anon_sym_shared] = ACTIONS(2017),
    [anon_sym_groupshared] = ACTIONS(2017),
    [anon_sym_uniform] = ACTIONS(2017),
    [anon_sym_row_major] = ACTIONS(2017),
    [anon_sym_column_major] = ACTIONS(2017),
    [anon_sym_globallycoherent] = ACTIONS(2017),
    [anon_sym_centroid] = ACTIONS(2017),
    [anon_sym_noperspective] = ACTIONS(2017),
    [anon_sym_nointerpolation] = ACTIONS(2017),
    [anon_sym_sample] = ACTIONS(2017),
    [anon_sym_linear] = ACTIONS(2017),
    [anon_sym_snorm] = ACTIONS(2017),
    [anon_sym_unorm] = ACTIONS(2017),
    [anon_sym_point] = ACTIONS(2017),
    [anon_sym_line] = ACTIONS(2017),
    [anon_sym_triangleadj] = ACTIONS(2017),
    [anon_sym_lineadj] = ACTIONS(2017),
    [anon_sym_triangle] = ACTIONS(2017),
  },
  [2483] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2483),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_RPAREN] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5743),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5743),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6412),
    [anon_sym_unsigned] = ACTIONS(6412),
    [anon_sym_long] = ACTIONS(6412),
    [anon_sym_short] = ACTIONS(6412),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5745),
  },
  [2484] = {
    [sym_template_argument_list] = STATE(2260),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_COMMA] = ACTIONS(6307),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym___extension__] = ACTIONS(2005),
    [anon_sym_in] = ACTIONS(2005),
    [anon_sym_out] = ACTIONS(2005),
    [anon_sym_inout] = ACTIONS(2005),
    [anon_sym_virtual] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2005),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2007),
    [anon_sym___declspec] = ACTIONS(2005),
    [anon_sym___based] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_static] = ACTIONS(2005),
    [anon_sym_EQ] = ACTIONS(6309),
    [anon_sym_register] = ACTIONS(2005),
    [anon_sym_inline] = ACTIONS(2005),
    [anon_sym___inline] = ACTIONS(2005),
    [anon_sym___inline__] = ACTIONS(2005),
    [anon_sym___forceinline] = ACTIONS(2005),
    [anon_sym_thread_local] = ACTIONS(2005),
    [anon_sym___thread] = ACTIONS(2005),
    [anon_sym_const] = ACTIONS(2005),
    [anon_sym_constexpr] = ACTIONS(2005),
    [anon_sym_volatile] = ACTIONS(2005),
    [anon_sym_restrict] = ACTIONS(2005),
    [anon_sym___restrict__] = ACTIONS(2005),
    [anon_sym__Atomic] = ACTIONS(2005),
    [anon_sym__Noreturn] = ACTIONS(2005),
    [anon_sym_noreturn] = ACTIONS(2005),
    [anon_sym__Nonnull] = ACTIONS(2005),
    [anon_sym_mutable] = ACTIONS(2005),
    [anon_sym_constinit] = ACTIONS(2005),
    [anon_sym_consteval] = ACTIONS(2005),
    [anon_sym_alignas] = ACTIONS(2005),
    [anon_sym__Alignas] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
    [anon_sym_template] = ACTIONS(2005),
    [anon_sym_GT2] = ACTIONS(6307),
    [anon_sym_operator] = ACTIONS(2005),
    [anon_sym_precise] = ACTIONS(2005),
    [anon_sym_shared] = ACTIONS(2005),
    [anon_sym_groupshared] = ACTIONS(2005),
    [anon_sym_uniform] = ACTIONS(2005),
    [anon_sym_row_major] = ACTIONS(2005),
    [anon_sym_column_major] = ACTIONS(2005),
    [anon_sym_globallycoherent] = ACTIONS(2005),
    [anon_sym_centroid] = ACTIONS(2005),
    [anon_sym_noperspective] = ACTIONS(2005),
    [anon_sym_nointerpolation] = ACTIONS(2005),
    [anon_sym_sample] = ACTIONS(2005),
    [anon_sym_linear] = ACTIONS(2005),
    [anon_sym_snorm] = ACTIONS(2005),
    [anon_sym_unorm] = ACTIONS(2005),
    [anon_sym_point] = ACTIONS(2005),
    [anon_sym_line] = ACTIONS(2005),
    [anon_sym_triangleadj] = ACTIONS(2005),
    [anon_sym_lineadj] = ACTIONS(2005),
    [anon_sym_triangle] = ACTIONS(2005),
  },
  [2485] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1991),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1991),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_GT_GT] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1993),
    [anon_sym___attribute__] = ACTIONS(1993),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1993),
    [anon_sym_volatile] = ACTIONS(1993),
    [anon_sym_restrict] = ACTIONS(1993),
    [anon_sym___restrict__] = ACTIONS(1993),
    [anon_sym__Atomic] = ACTIONS(1993),
    [anon_sym__Noreturn] = ACTIONS(1993),
    [anon_sym_noreturn] = ACTIONS(1993),
    [anon_sym__Nonnull] = ACTIONS(1993),
    [anon_sym_mutable] = ACTIONS(1993),
    [anon_sym_constinit] = ACTIONS(1993),
    [anon_sym_consteval] = ACTIONS(1993),
    [anon_sym_alignas] = ACTIONS(1993),
    [anon_sym__Alignas] = ACTIONS(1993),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_STAR_EQ] = ACTIONS(1993),
    [anon_sym_SLASH_EQ] = ACTIONS(1993),
    [anon_sym_PERCENT_EQ] = ACTIONS(1993),
    [anon_sym_PLUS_EQ] = ACTIONS(1993),
    [anon_sym_DASH_EQ] = ACTIONS(1993),
    [anon_sym_LT_LT_EQ] = ACTIONS(1993),
    [anon_sym_GT_GT_EQ] = ACTIONS(1991),
    [anon_sym_AMP_EQ] = ACTIONS(1993),
    [anon_sym_CARET_EQ] = ACTIONS(1993),
    [anon_sym_PIPE_EQ] = ACTIONS(1993),
    [anon_sym_and_eq] = ACTIONS(1993),
    [anon_sym_or_eq] = ACTIONS(1993),
    [anon_sym_xor_eq] = ACTIONS(1993),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1993),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1993),
    [anon_sym_not_eq] = ACTIONS(1993),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1993),
    [anon_sym_decltype] = ACTIONS(1993),
    [anon_sym_final] = ACTIONS(1993),
    [anon_sym_override] = ACTIONS(1993),
    [anon_sym_GT2] = ACTIONS(1993),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [aux_sym_preproc_if_token2] = ACTIONS(2187),
    [aux_sym_preproc_else_token1] = ACTIONS(2187),
    [aux_sym_preproc_elif_token1] = ACTIONS(2197),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2187),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2187),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_final] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_requires] = ACTIONS(2197),
  },
  [2487] = {
    [sym_string_literal] = STATE(2498),
    [sym_raw_string_literal] = STATE(2498),
    [aux_sym_concatenated_string_repeat1] = STATE(2498),
    [sym_identifier] = ACTIONS(6415),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6417),
    [anon_sym_COMMA] = ACTIONS(6417),
    [anon_sym_RPAREN] = ACTIONS(6417),
    [aux_sym_preproc_if_token2] = ACTIONS(6417),
    [aux_sym_preproc_else_token1] = ACTIONS(6417),
    [aux_sym_preproc_elif_token1] = ACTIONS(6419),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6417),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6417),
    [anon_sym_LPAREN2] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_SLASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_PIPE_PIPE] = ACTIONS(6417),
    [anon_sym_AMP_AMP] = ACTIONS(6417),
    [anon_sym_PIPE] = ACTIONS(6419),
    [anon_sym_CARET] = ACTIONS(6419),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_EQ_EQ] = ACTIONS(6417),
    [anon_sym_BANG_EQ] = ACTIONS(6417),
    [anon_sym_GT] = ACTIONS(6419),
    [anon_sym_GT_EQ] = ACTIONS(6417),
    [anon_sym_LT_EQ] = ACTIONS(6419),
    [anon_sym_LT] = ACTIONS(6419),
    [anon_sym_LT_LT] = ACTIONS(6419),
    [anon_sym_GT_GT] = ACTIONS(6419),
    [anon_sym_COLON] = ACTIONS(6417),
    [anon_sym_SEMI] = ACTIONS(6417),
    [anon_sym_RBRACE] = ACTIONS(6417),
    [anon_sym_LBRACK] = ACTIONS(6417),
    [anon_sym_RBRACK] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_STAR_EQ] = ACTIONS(6417),
    [anon_sym_SLASH_EQ] = ACTIONS(6417),
    [anon_sym_PERCENT_EQ] = ACTIONS(6417),
    [anon_sym_PLUS_EQ] = ACTIONS(6417),
    [anon_sym_DASH_EQ] = ACTIONS(6417),
    [anon_sym_LT_LT_EQ] = ACTIONS(6417),
    [anon_sym_GT_GT_EQ] = ACTIONS(6417),
    [anon_sym_AMP_EQ] = ACTIONS(6417),
    [anon_sym_CARET_EQ] = ACTIONS(6417),
    [anon_sym_PIPE_EQ] = ACTIONS(6417),
    [anon_sym_and_eq] = ACTIONS(6419),
    [anon_sym_or_eq] = ACTIONS(6419),
    [anon_sym_xor_eq] = ACTIONS(6419),
    [anon_sym_LT_EQ_GT] = ACTIONS(6417),
    [anon_sym_or] = ACTIONS(6419),
    [anon_sym_and] = ACTIONS(6419),
    [anon_sym_bitor] = ACTIONS(6419),
    [anon_sym_xor] = ACTIONS(6419),
    [anon_sym_bitand] = ACTIONS(6419),
    [anon_sym_not_eq] = ACTIONS(6419),
    [anon_sym_DASH_DASH] = ACTIONS(6417),
    [anon_sym_PLUS_PLUS] = ACTIONS(6417),
    [anon_sym_DOT] = ACTIONS(6419),
    [anon_sym_DOT_STAR] = ACTIONS(6417),
    [anon_sym_DASH_GT] = ACTIONS(6417),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [sym_literal_suffix] = ACTIONS(6419),
  },
  [2488] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1983),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1983),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1983),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1983),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1983),
    [anon_sym_GT_GT] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1985),
    [anon_sym___attribute__] = ACTIONS(1985),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_EQ] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1985),
    [anon_sym_volatile] = ACTIONS(1985),
    [anon_sym_restrict] = ACTIONS(1985),
    [anon_sym___restrict__] = ACTIONS(1985),
    [anon_sym__Atomic] = ACTIONS(1985),
    [anon_sym__Noreturn] = ACTIONS(1985),
    [anon_sym_noreturn] = ACTIONS(1985),
    [anon_sym__Nonnull] = ACTIONS(1985),
    [anon_sym_mutable] = ACTIONS(1985),
    [anon_sym_constinit] = ACTIONS(1985),
    [anon_sym_consteval] = ACTIONS(1985),
    [anon_sym_alignas] = ACTIONS(1985),
    [anon_sym__Alignas] = ACTIONS(1985),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_STAR_EQ] = ACTIONS(1985),
    [anon_sym_SLASH_EQ] = ACTIONS(1985),
    [anon_sym_PERCENT_EQ] = ACTIONS(1985),
    [anon_sym_PLUS_EQ] = ACTIONS(1985),
    [anon_sym_DASH_EQ] = ACTIONS(1985),
    [anon_sym_LT_LT_EQ] = ACTIONS(1985),
    [anon_sym_GT_GT_EQ] = ACTIONS(1983),
    [anon_sym_AMP_EQ] = ACTIONS(1985),
    [anon_sym_CARET_EQ] = ACTIONS(1985),
    [anon_sym_PIPE_EQ] = ACTIONS(1985),
    [anon_sym_and_eq] = ACTIONS(1985),
    [anon_sym_or_eq] = ACTIONS(1985),
    [anon_sym_xor_eq] = ACTIONS(1985),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1985),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1985),
    [anon_sym_not_eq] = ACTIONS(1985),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1985),
    [anon_sym_decltype] = ACTIONS(1985),
    [anon_sym_final] = ACTIONS(1985),
    [anon_sym_override] = ACTIONS(1985),
    [anon_sym_GT2] = ACTIONS(1985),
  },
  [2489] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_RPAREN] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2197),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2197),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2197),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_EQ] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_STAR_EQ] = ACTIONS(2187),
    [anon_sym_SLASH_EQ] = ACTIONS(2187),
    [anon_sym_PERCENT_EQ] = ACTIONS(2187),
    [anon_sym_PLUS_EQ] = ACTIONS(2187),
    [anon_sym_DASH_EQ] = ACTIONS(2187),
    [anon_sym_LT_LT_EQ] = ACTIONS(2187),
    [anon_sym_GT_GT_EQ] = ACTIONS(2187),
    [anon_sym_AMP_EQ] = ACTIONS(2187),
    [anon_sym_CARET_EQ] = ACTIONS(2187),
    [anon_sym_PIPE_EQ] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2187),
  },
  [2490] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [aux_sym_preproc_if_token2] = ACTIONS(5168),
    [aux_sym_preproc_else_token1] = ACTIONS(5168),
    [aux_sym_preproc_elif_token1] = ACTIONS(5166),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5168),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5168),
    [anon_sym_GT_GT] = ACTIONS(5168),
    [anon_sym_COLON] = ACTIONS(5168),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_RBRACK] = ACTIONS(5168),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_requires] = ACTIONS(5166),
  },
  [2491] = {
    [sym_string_literal] = STATE(2487),
    [sym_raw_string_literal] = STATE(2487),
    [aux_sym_concatenated_string_repeat1] = STATE(2487),
    [sym_identifier] = ACTIONS(6421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6423),
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_RPAREN] = ACTIONS(6423),
    [aux_sym_preproc_if_token2] = ACTIONS(6423),
    [aux_sym_preproc_else_token1] = ACTIONS(6423),
    [aux_sym_preproc_elif_token1] = ACTIONS(6425),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6423),
    [anon_sym_LPAREN2] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6425),
    [anon_sym_PLUS] = ACTIONS(6425),
    [anon_sym_STAR] = ACTIONS(6425),
    [anon_sym_SLASH] = ACTIONS(6425),
    [anon_sym_PERCENT] = ACTIONS(6425),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_PIPE] = ACTIONS(6425),
    [anon_sym_CARET] = ACTIONS(6425),
    [anon_sym_AMP] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6423),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_GT] = ACTIONS(6425),
    [anon_sym_GT_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6425),
    [anon_sym_LT] = ACTIONS(6425),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_COLON] = ACTIONS(6423),
    [anon_sym_SEMI] = ACTIONS(6423),
    [anon_sym_RBRACE] = ACTIONS(6423),
    [anon_sym_LBRACK] = ACTIONS(6423),
    [anon_sym_RBRACK] = ACTIONS(6423),
    [anon_sym_EQ] = ACTIONS(6425),
    [anon_sym_QMARK] = ACTIONS(6423),
    [anon_sym_STAR_EQ] = ACTIONS(6423),
    [anon_sym_SLASH_EQ] = ACTIONS(6423),
    [anon_sym_PERCENT_EQ] = ACTIONS(6423),
    [anon_sym_PLUS_EQ] = ACTIONS(6423),
    [anon_sym_DASH_EQ] = ACTIONS(6423),
    [anon_sym_LT_LT_EQ] = ACTIONS(6423),
    [anon_sym_GT_GT_EQ] = ACTIONS(6423),
    [anon_sym_AMP_EQ] = ACTIONS(6423),
    [anon_sym_CARET_EQ] = ACTIONS(6423),
    [anon_sym_PIPE_EQ] = ACTIONS(6423),
    [anon_sym_and_eq] = ACTIONS(6425),
    [anon_sym_or_eq] = ACTIONS(6425),
    [anon_sym_xor_eq] = ACTIONS(6425),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_or] = ACTIONS(6425),
    [anon_sym_and] = ACTIONS(6425),
    [anon_sym_bitor] = ACTIONS(6425),
    [anon_sym_xor] = ACTIONS(6425),
    [anon_sym_bitand] = ACTIONS(6425),
    [anon_sym_not_eq] = ACTIONS(6425),
    [anon_sym_DASH_DASH] = ACTIONS(6423),
    [anon_sym_PLUS_PLUS] = ACTIONS(6423),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_DOT_STAR] = ACTIONS(6423),
    [anon_sym_DASH_GT] = ACTIONS(6423),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [sym_literal_suffix] = ACTIONS(6425),
  },
  [2492] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5166),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5166),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5166),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_EQ] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_STAR_EQ] = ACTIONS(5168),
    [anon_sym_SLASH_EQ] = ACTIONS(5168),
    [anon_sym_PERCENT_EQ] = ACTIONS(5168),
    [anon_sym_PLUS_EQ] = ACTIONS(5168),
    [anon_sym_DASH_EQ] = ACTIONS(5168),
    [anon_sym_LT_LT_EQ] = ACTIONS(5168),
    [anon_sym_GT_GT_EQ] = ACTIONS(5168),
    [anon_sym_AMP_EQ] = ACTIONS(5168),
    [anon_sym_CARET_EQ] = ACTIONS(5168),
    [anon_sym_PIPE_EQ] = ACTIONS(5168),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5168),
  },
  [2493] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1987),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1987),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_GT_GT] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1989),
    [anon_sym___attribute__] = ACTIONS(1989),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1989),
    [anon_sym_volatile] = ACTIONS(1989),
    [anon_sym_restrict] = ACTIONS(1989),
    [anon_sym___restrict__] = ACTIONS(1989),
    [anon_sym__Atomic] = ACTIONS(1989),
    [anon_sym__Noreturn] = ACTIONS(1989),
    [anon_sym_noreturn] = ACTIONS(1989),
    [anon_sym__Nonnull] = ACTIONS(1989),
    [anon_sym_mutable] = ACTIONS(1989),
    [anon_sym_constinit] = ACTIONS(1989),
    [anon_sym_consteval] = ACTIONS(1989),
    [anon_sym_alignas] = ACTIONS(1989),
    [anon_sym__Alignas] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1987),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_and_eq] = ACTIONS(1989),
    [anon_sym_or_eq] = ACTIONS(1989),
    [anon_sym_xor_eq] = ACTIONS(1989),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1989),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1989),
    [anon_sym_not_eq] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1989),
    [anon_sym_decltype] = ACTIONS(1989),
    [anon_sym_final] = ACTIONS(1989),
    [anon_sym_override] = ACTIONS(1989),
    [anon_sym_GT2] = ACTIONS(1989),
  },
  [2494] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1971),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1971),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1971),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1971),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1971),
    [anon_sym_GT_GT] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1973),
    [anon_sym___attribute__] = ACTIONS(1973),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_EQ] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1973),
    [anon_sym_volatile] = ACTIONS(1973),
    [anon_sym_restrict] = ACTIONS(1973),
    [anon_sym___restrict__] = ACTIONS(1973),
    [anon_sym__Atomic] = ACTIONS(1973),
    [anon_sym__Noreturn] = ACTIONS(1973),
    [anon_sym_noreturn] = ACTIONS(1973),
    [anon_sym__Nonnull] = ACTIONS(1973),
    [anon_sym_mutable] = ACTIONS(1973),
    [anon_sym_constinit] = ACTIONS(1973),
    [anon_sym_consteval] = ACTIONS(1973),
    [anon_sym_alignas] = ACTIONS(1973),
    [anon_sym__Alignas] = ACTIONS(1973),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_STAR_EQ] = ACTIONS(1973),
    [anon_sym_SLASH_EQ] = ACTIONS(1973),
    [anon_sym_PERCENT_EQ] = ACTIONS(1973),
    [anon_sym_PLUS_EQ] = ACTIONS(1973),
    [anon_sym_DASH_EQ] = ACTIONS(1973),
    [anon_sym_LT_LT_EQ] = ACTIONS(1973),
    [anon_sym_GT_GT_EQ] = ACTIONS(1971),
    [anon_sym_AMP_EQ] = ACTIONS(1973),
    [anon_sym_CARET_EQ] = ACTIONS(1973),
    [anon_sym_PIPE_EQ] = ACTIONS(1973),
    [anon_sym_and_eq] = ACTIONS(1973),
    [anon_sym_or_eq] = ACTIONS(1973),
    [anon_sym_xor_eq] = ACTIONS(1973),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1973),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1973),
    [anon_sym_not_eq] = ACTIONS(1973),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1973),
    [anon_sym_decltype] = ACTIONS(1973),
    [anon_sym_final] = ACTIONS(1973),
    [anon_sym_override] = ACTIONS(1973),
    [anon_sym_GT2] = ACTIONS(1973),
  },
  [2495] = {
    [sym_attribute_specifier] = STATE(2364),
    [sym_enumerator_list] = STATE(2408),
    [sym__enum_base_clause] = STATE(2372),
    [sym_identifier] = ACTIONS(6303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6305),
    [anon_sym_COMMA] = ACTIONS(6305),
    [anon_sym_RPAREN] = ACTIONS(6305),
    [anon_sym_LPAREN2] = ACTIONS(6305),
    [anon_sym_TILDE] = ACTIONS(6305),
    [anon_sym_STAR] = ACTIONS(6305),
    [anon_sym_AMP_AMP] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_COLON] = ACTIONS(6427),
    [anon_sym___extension__] = ACTIONS(6303),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_virtual] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6303),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6305),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6305),
    [anon_sym___declspec] = ACTIONS(6303),
    [anon_sym___based] = ACTIONS(6303),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6303),
    [anon_sym_static] = ACTIONS(6303),
    [anon_sym_EQ] = ACTIONS(6305),
    [anon_sym_register] = ACTIONS(6303),
    [anon_sym_inline] = ACTIONS(6303),
    [anon_sym___inline] = ACTIONS(6303),
    [anon_sym___inline__] = ACTIONS(6303),
    [anon_sym___forceinline] = ACTIONS(6303),
    [anon_sym_thread_local] = ACTIONS(6303),
    [anon_sym___thread] = ACTIONS(6303),
    [anon_sym_const] = ACTIONS(6303),
    [anon_sym_constexpr] = ACTIONS(6303),
    [anon_sym_volatile] = ACTIONS(6303),
    [anon_sym_restrict] = ACTIONS(6303),
    [anon_sym___restrict__] = ACTIONS(6303),
    [anon_sym__Atomic] = ACTIONS(6303),
    [anon_sym__Noreturn] = ACTIONS(6303),
    [anon_sym_noreturn] = ACTIONS(6303),
    [anon_sym__Nonnull] = ACTIONS(6303),
    [anon_sym_mutable] = ACTIONS(6303),
    [anon_sym_constinit] = ACTIONS(6303),
    [anon_sym_consteval] = ACTIONS(6303),
    [anon_sym_alignas] = ACTIONS(6303),
    [anon_sym__Alignas] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6303),
    [anon_sym_decltype] = ACTIONS(6303),
    [anon_sym_template] = ACTIONS(6303),
    [anon_sym_GT2] = ACTIONS(6305),
    [anon_sym_operator] = ACTIONS(6303),
    [anon_sym_precise] = ACTIONS(6303),
    [anon_sym_shared] = ACTIONS(6303),
    [anon_sym_groupshared] = ACTIONS(6303),
    [anon_sym_uniform] = ACTIONS(6303),
    [anon_sym_row_major] = ACTIONS(6303),
    [anon_sym_column_major] = ACTIONS(6303),
    [anon_sym_globallycoherent] = ACTIONS(6303),
    [anon_sym_centroid] = ACTIONS(6303),
    [anon_sym_noperspective] = ACTIONS(6303),
    [anon_sym_nointerpolation] = ACTIONS(6303),
    [anon_sym_sample] = ACTIONS(6303),
    [anon_sym_linear] = ACTIONS(6303),
    [anon_sym_snorm] = ACTIONS(6303),
    [anon_sym_unorm] = ACTIONS(6303),
    [anon_sym_point] = ACTIONS(6303),
    [anon_sym_line] = ACTIONS(6303),
    [anon_sym_triangleadj] = ACTIONS(6303),
    [anon_sym_lineadj] = ACTIONS(6303),
    [anon_sym_triangle] = ACTIONS(6303),
  },
  [2496] = {
    [sym_attribute_specifier] = STATE(2356),
    [sym_enumerator_list] = STATE(2412),
    [sym__enum_base_clause] = STATE(2367),
    [sym_identifier] = ACTIONS(6293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6295),
    [anon_sym_COMMA] = ACTIONS(6295),
    [anon_sym_RPAREN] = ACTIONS(6295),
    [anon_sym_LPAREN2] = ACTIONS(6295),
    [anon_sym_TILDE] = ACTIONS(6295),
    [anon_sym_STAR] = ACTIONS(6295),
    [anon_sym_AMP_AMP] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6427),
    [anon_sym___extension__] = ACTIONS(6293),
    [anon_sym_in] = ACTIONS(6293),
    [anon_sym_out] = ACTIONS(6293),
    [anon_sym_inout] = ACTIONS(6293),
    [anon_sym_virtual] = ACTIONS(6293),
    [anon_sym_extern] = ACTIONS(6293),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_COLON_COLON] = ACTIONS(6295),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6295),
    [anon_sym___declspec] = ACTIONS(6293),
    [anon_sym___based] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6293),
    [anon_sym_static] = ACTIONS(6293),
    [anon_sym_EQ] = ACTIONS(6295),
    [anon_sym_register] = ACTIONS(6293),
    [anon_sym_inline] = ACTIONS(6293),
    [anon_sym___inline] = ACTIONS(6293),
    [anon_sym___inline__] = ACTIONS(6293),
    [anon_sym___forceinline] = ACTIONS(6293),
    [anon_sym_thread_local] = ACTIONS(6293),
    [anon_sym___thread] = ACTIONS(6293),
    [anon_sym_const] = ACTIONS(6293),
    [anon_sym_constexpr] = ACTIONS(6293),
    [anon_sym_volatile] = ACTIONS(6293),
    [anon_sym_restrict] = ACTIONS(6293),
    [anon_sym___restrict__] = ACTIONS(6293),
    [anon_sym__Atomic] = ACTIONS(6293),
    [anon_sym__Noreturn] = ACTIONS(6293),
    [anon_sym_noreturn] = ACTIONS(6293),
    [anon_sym__Nonnull] = ACTIONS(6293),
    [anon_sym_mutable] = ACTIONS(6293),
    [anon_sym_constinit] = ACTIONS(6293),
    [anon_sym_consteval] = ACTIONS(6293),
    [anon_sym_alignas] = ACTIONS(6293),
    [anon_sym__Alignas] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6293),
    [anon_sym_decltype] = ACTIONS(6293),
    [anon_sym_template] = ACTIONS(6293),
    [anon_sym_GT2] = ACTIONS(6295),
    [anon_sym_operator] = ACTIONS(6293),
    [anon_sym_precise] = ACTIONS(6293),
    [anon_sym_shared] = ACTIONS(6293),
    [anon_sym_groupshared] = ACTIONS(6293),
    [anon_sym_uniform] = ACTIONS(6293),
    [anon_sym_row_major] = ACTIONS(6293),
    [anon_sym_column_major] = ACTIONS(6293),
    [anon_sym_globallycoherent] = ACTIONS(6293),
    [anon_sym_centroid] = ACTIONS(6293),
    [anon_sym_noperspective] = ACTIONS(6293),
    [anon_sym_nointerpolation] = ACTIONS(6293),
    [anon_sym_sample] = ACTIONS(6293),
    [anon_sym_linear] = ACTIONS(6293),
    [anon_sym_snorm] = ACTIONS(6293),
    [anon_sym_unorm] = ACTIONS(6293),
    [anon_sym_point] = ACTIONS(6293),
    [anon_sym_line] = ACTIONS(6293),
    [anon_sym_triangleadj] = ACTIONS(6293),
    [anon_sym_lineadj] = ACTIONS(6293),
    [anon_sym_triangle] = ACTIONS(6293),
  },
  [2497] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1975),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1975),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1975),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1975),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1975),
    [anon_sym_GT_GT] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1977),
    [anon_sym___attribute__] = ACTIONS(1977),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1977),
    [anon_sym_volatile] = ACTIONS(1977),
    [anon_sym_restrict] = ACTIONS(1977),
    [anon_sym___restrict__] = ACTIONS(1977),
    [anon_sym__Atomic] = ACTIONS(1977),
    [anon_sym__Noreturn] = ACTIONS(1977),
    [anon_sym_noreturn] = ACTIONS(1977),
    [anon_sym__Nonnull] = ACTIONS(1977),
    [anon_sym_mutable] = ACTIONS(1977),
    [anon_sym_constinit] = ACTIONS(1977),
    [anon_sym_consteval] = ACTIONS(1977),
    [anon_sym_alignas] = ACTIONS(1977),
    [anon_sym__Alignas] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1975),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_and_eq] = ACTIONS(1977),
    [anon_sym_or_eq] = ACTIONS(1977),
    [anon_sym_xor_eq] = ACTIONS(1977),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1977),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1977),
    [anon_sym_not_eq] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1977),
    [anon_sym_decltype] = ACTIONS(1977),
    [anon_sym_final] = ACTIONS(1977),
    [anon_sym_override] = ACTIONS(1977),
    [anon_sym_GT2] = ACTIONS(1977),
  },
  [2498] = {
    [sym_string_literal] = STATE(2498),
    [sym_raw_string_literal] = STATE(2498),
    [aux_sym_concatenated_string_repeat1] = STATE(2498),
    [sym_identifier] = ACTIONS(6429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [aux_sym_preproc_if_token2] = ACTIONS(6432),
    [aux_sym_preproc_else_token1] = ACTIONS(6432),
    [aux_sym_preproc_elif_token1] = ACTIONS(6434),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6432),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6432),
    [anon_sym_LPAREN2] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6434),
    [anon_sym_PLUS] = ACTIONS(6434),
    [anon_sym_STAR] = ACTIONS(6434),
    [anon_sym_SLASH] = ACTIONS(6434),
    [anon_sym_PERCENT] = ACTIONS(6434),
    [anon_sym_PIPE_PIPE] = ACTIONS(6432),
    [anon_sym_AMP_AMP] = ACTIONS(6432),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_CARET] = ACTIONS(6434),
    [anon_sym_AMP] = ACTIONS(6434),
    [anon_sym_EQ_EQ] = ACTIONS(6432),
    [anon_sym_BANG_EQ] = ACTIONS(6432),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_GT_EQ] = ACTIONS(6432),
    [anon_sym_LT_EQ] = ACTIONS(6434),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_LT_LT] = ACTIONS(6434),
    [anon_sym_GT_GT] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6432),
    [anon_sym_SEMI] = ACTIONS(6432),
    [anon_sym_RBRACE] = ACTIONS(6432),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6434),
    [anon_sym_QMARK] = ACTIONS(6432),
    [anon_sym_STAR_EQ] = ACTIONS(6432),
    [anon_sym_SLASH_EQ] = ACTIONS(6432),
    [anon_sym_PERCENT_EQ] = ACTIONS(6432),
    [anon_sym_PLUS_EQ] = ACTIONS(6432),
    [anon_sym_DASH_EQ] = ACTIONS(6432),
    [anon_sym_LT_LT_EQ] = ACTIONS(6432),
    [anon_sym_GT_GT_EQ] = ACTIONS(6432),
    [anon_sym_AMP_EQ] = ACTIONS(6432),
    [anon_sym_CARET_EQ] = ACTIONS(6432),
    [anon_sym_PIPE_EQ] = ACTIONS(6432),
    [anon_sym_and_eq] = ACTIONS(6434),
    [anon_sym_or_eq] = ACTIONS(6434),
    [anon_sym_xor_eq] = ACTIONS(6434),
    [anon_sym_LT_EQ_GT] = ACTIONS(6432),
    [anon_sym_or] = ACTIONS(6434),
    [anon_sym_and] = ACTIONS(6434),
    [anon_sym_bitor] = ACTIONS(6434),
    [anon_sym_xor] = ACTIONS(6434),
    [anon_sym_bitand] = ACTIONS(6434),
    [anon_sym_not_eq] = ACTIONS(6434),
    [anon_sym_DASH_DASH] = ACTIONS(6432),
    [anon_sym_PLUS_PLUS] = ACTIONS(6432),
    [anon_sym_DOT] = ACTIONS(6434),
    [anon_sym_DOT_STAR] = ACTIONS(6432),
    [anon_sym_DASH_GT] = ACTIONS(6432),
    [anon_sym_L_DQUOTE] = ACTIONS(6436),
    [anon_sym_u_DQUOTE] = ACTIONS(6436),
    [anon_sym_U_DQUOTE] = ACTIONS(6436),
    [anon_sym_u8_DQUOTE] = ACTIONS(6436),
    [anon_sym_DQUOTE] = ACTIONS(6436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6439),
    [anon_sym_LR_DQUOTE] = ACTIONS(6439),
    [anon_sym_uR_DQUOTE] = ACTIONS(6439),
    [anon_sym_UR_DQUOTE] = ACTIONS(6439),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6439),
    [sym_literal_suffix] = ACTIONS(6434),
  },
  [2499] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1953),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1953),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_GT_GT] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1955),
    [anon_sym___attribute__] = ACTIONS(1955),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1955),
    [anon_sym_volatile] = ACTIONS(1955),
    [anon_sym_restrict] = ACTIONS(1955),
    [anon_sym___restrict__] = ACTIONS(1955),
    [anon_sym__Atomic] = ACTIONS(1955),
    [anon_sym__Noreturn] = ACTIONS(1955),
    [anon_sym_noreturn] = ACTIONS(1955),
    [anon_sym__Nonnull] = ACTIONS(1955),
    [anon_sym_mutable] = ACTIONS(1955),
    [anon_sym_constinit] = ACTIONS(1955),
    [anon_sym_consteval] = ACTIONS(1955),
    [anon_sym_alignas] = ACTIONS(1955),
    [anon_sym__Alignas] = ACTIONS(1955),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_STAR_EQ] = ACTIONS(1955),
    [anon_sym_SLASH_EQ] = ACTIONS(1955),
    [anon_sym_PERCENT_EQ] = ACTIONS(1955),
    [anon_sym_PLUS_EQ] = ACTIONS(1955),
    [anon_sym_DASH_EQ] = ACTIONS(1955),
    [anon_sym_LT_LT_EQ] = ACTIONS(1955),
    [anon_sym_GT_GT_EQ] = ACTIONS(1953),
    [anon_sym_AMP_EQ] = ACTIONS(1955),
    [anon_sym_CARET_EQ] = ACTIONS(1955),
    [anon_sym_PIPE_EQ] = ACTIONS(1955),
    [anon_sym_and_eq] = ACTIONS(1955),
    [anon_sym_or_eq] = ACTIONS(1955),
    [anon_sym_xor_eq] = ACTIONS(1955),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1955),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1955),
    [anon_sym_not_eq] = ACTIONS(1955),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1955),
    [anon_sym_decltype] = ACTIONS(1955),
    [anon_sym_final] = ACTIONS(1955),
    [anon_sym_override] = ACTIONS(1955),
    [anon_sym_GT2] = ACTIONS(1955),
  },
  [2500] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1979),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1981),
    [anon_sym___attribute__] = ACTIONS(1981),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1981),
    [anon_sym_volatile] = ACTIONS(1981),
    [anon_sym_restrict] = ACTIONS(1981),
    [anon_sym___restrict__] = ACTIONS(1981),
    [anon_sym__Atomic] = ACTIONS(1981),
    [anon_sym__Noreturn] = ACTIONS(1981),
    [anon_sym_noreturn] = ACTIONS(1981),
    [anon_sym__Nonnull] = ACTIONS(1981),
    [anon_sym_mutable] = ACTIONS(1981),
    [anon_sym_constinit] = ACTIONS(1981),
    [anon_sym_consteval] = ACTIONS(1981),
    [anon_sym_alignas] = ACTIONS(1981),
    [anon_sym__Alignas] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1979),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_and_eq] = ACTIONS(1981),
    [anon_sym_or_eq] = ACTIONS(1981),
    [anon_sym_xor_eq] = ACTIONS(1981),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1981),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1981),
    [anon_sym_not_eq] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1981),
    [anon_sym_decltype] = ACTIONS(1981),
    [anon_sym_final] = ACTIONS(1981),
    [anon_sym_override] = ACTIONS(1981),
    [anon_sym_GT2] = ACTIONS(1981),
  },
  [2501] = {
    [sym_identifier] = ACTIONS(6273),
    [anon_sym___extension__] = ACTIONS(6273),
    [anon_sym_in] = ACTIONS(6273),
    [anon_sym_out] = ACTIONS(6273),
    [anon_sym_inout] = ACTIONS(6273),
    [anon_sym_virtual] = ACTIONS(6273),
    [anon_sym_extern] = ACTIONS(6273),
    [anon_sym___attribute__] = ACTIONS(6273),
    [anon_sym___attribute] = ACTIONS(6273),
    [anon_sym_COLON_COLON] = ACTIONS(6275),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6275),
    [anon_sym___declspec] = ACTIONS(6273),
    [anon_sym___cdecl] = ACTIONS(6273),
    [anon_sym___clrcall] = ACTIONS(6273),
    [anon_sym___stdcall] = ACTIONS(6273),
    [anon_sym___fastcall] = ACTIONS(6273),
    [anon_sym___thiscall] = ACTIONS(6273),
    [anon_sym___vectorcall] = ACTIONS(6273),
    [anon_sym_signed] = ACTIONS(6273),
    [anon_sym_unsigned] = ACTIONS(6273),
    [anon_sym_long] = ACTIONS(6273),
    [anon_sym_short] = ACTIONS(6273),
    [anon_sym_static] = ACTIONS(6273),
    [anon_sym_register] = ACTIONS(6273),
    [anon_sym_inline] = ACTIONS(6273),
    [anon_sym___inline] = ACTIONS(6273),
    [anon_sym___inline__] = ACTIONS(6273),
    [anon_sym___forceinline] = ACTIONS(6273),
    [anon_sym_thread_local] = ACTIONS(6273),
    [anon_sym___thread] = ACTIONS(6273),
    [anon_sym_const] = ACTIONS(6273),
    [anon_sym_constexpr] = ACTIONS(6273),
    [anon_sym_volatile] = ACTIONS(6273),
    [anon_sym_restrict] = ACTIONS(6273),
    [anon_sym___restrict__] = ACTIONS(6273),
    [anon_sym__Atomic] = ACTIONS(6273),
    [anon_sym__Noreturn] = ACTIONS(6273),
    [anon_sym_noreturn] = ACTIONS(6273),
    [anon_sym__Nonnull] = ACTIONS(6273),
    [anon_sym_mutable] = ACTIONS(6273),
    [anon_sym_constinit] = ACTIONS(6273),
    [anon_sym_consteval] = ACTIONS(6273),
    [anon_sym_alignas] = ACTIONS(6273),
    [anon_sym__Alignas] = ACTIONS(6273),
    [sym_primitive_type] = ACTIONS(6273),
    [anon_sym_enum] = ACTIONS(6273),
    [anon_sym_class] = ACTIONS(6273),
    [anon_sym_struct] = ACTIONS(6273),
    [anon_sym_union] = ACTIONS(6273),
    [anon_sym_if] = ACTIONS(6273),
    [anon_sym_for] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6273),
    [anon_sym_decltype] = ACTIONS(6273),
    [anon_sym_typename] = ACTIONS(6273),
    [anon_sym_template] = ACTIONS(6273),
    [anon_sym_precise] = ACTIONS(6273),
    [anon_sym_shared] = ACTIONS(6273),
    [anon_sym_groupshared] = ACTIONS(6273),
    [anon_sym_uniform] = ACTIONS(6273),
    [anon_sym_row_major] = ACTIONS(6273),
    [anon_sym_column_major] = ACTIONS(6273),
    [anon_sym_globallycoherent] = ACTIONS(6273),
    [anon_sym_centroid] = ACTIONS(6273),
    [anon_sym_noperspective] = ACTIONS(6273),
    [anon_sym_nointerpolation] = ACTIONS(6273),
    [anon_sym_sample] = ACTIONS(6273),
    [anon_sym_linear] = ACTIONS(6273),
    [anon_sym_snorm] = ACTIONS(6273),
    [anon_sym_unorm] = ACTIONS(6273),
    [anon_sym_point] = ACTIONS(6273),
    [anon_sym_line] = ACTIONS(6273),
    [anon_sym_triangleadj] = ACTIONS(6273),
    [anon_sym_lineadj] = ACTIONS(6273),
    [anon_sym_triangle] = ACTIONS(6273),
  },
  [2502] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_inout] = ACTIONS(1975),
    [anon_sym_virtual] = ACTIONS(1975),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1977),
    [anon_sym___declspec] = ACTIONS(1975),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_EQ] = ACTIONS(1977),
    [anon_sym_register] = ACTIONS(1975),
    [anon_sym_inline] = ACTIONS(1975),
    [anon_sym___inline] = ACTIONS(1975),
    [anon_sym___inline__] = ACTIONS(1975),
    [anon_sym___forceinline] = ACTIONS(1975),
    [anon_sym_thread_local] = ACTIONS(1975),
    [anon_sym___thread] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_template] = ACTIONS(1975),
    [anon_sym_GT2] = ACTIONS(1977),
    [anon_sym_operator] = ACTIONS(1975),
    [anon_sym_precise] = ACTIONS(1975),
    [anon_sym_shared] = ACTIONS(1975),
    [anon_sym_groupshared] = ACTIONS(1975),
    [anon_sym_uniform] = ACTIONS(1975),
    [anon_sym_row_major] = ACTIONS(1975),
    [anon_sym_column_major] = ACTIONS(1975),
    [anon_sym_globallycoherent] = ACTIONS(1975),
    [anon_sym_centroid] = ACTIONS(1975),
    [anon_sym_noperspective] = ACTIONS(1975),
    [anon_sym_nointerpolation] = ACTIONS(1975),
    [anon_sym_sample] = ACTIONS(1975),
    [anon_sym_linear] = ACTIONS(1975),
    [anon_sym_snorm] = ACTIONS(1975),
    [anon_sym_unorm] = ACTIONS(1975),
    [anon_sym_point] = ACTIONS(1975),
    [anon_sym_line] = ACTIONS(1975),
    [anon_sym_triangleadj] = ACTIONS(1975),
    [anon_sym_lineadj] = ACTIONS(1975),
    [anon_sym_triangle] = ACTIONS(1975),
  },
  [2503] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_TILDE] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym_in] = ACTIONS(1953),
    [anon_sym_out] = ACTIONS(1953),
    [anon_sym_inout] = ACTIONS(1953),
    [anon_sym_virtual] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1955),
    [anon_sym___declspec] = ACTIONS(1953),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_static] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1955),
    [anon_sym_register] = ACTIONS(1953),
    [anon_sym_inline] = ACTIONS(1953),
    [anon_sym___inline] = ACTIONS(1953),
    [anon_sym___inline__] = ACTIONS(1953),
    [anon_sym___forceinline] = ACTIONS(1953),
    [anon_sym_thread_local] = ACTIONS(1953),
    [anon_sym___thread] = ACTIONS(1953),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_template] = ACTIONS(1953),
    [anon_sym_GT2] = ACTIONS(1955),
    [anon_sym_operator] = ACTIONS(1953),
    [anon_sym_precise] = ACTIONS(1953),
    [anon_sym_shared] = ACTIONS(1953),
    [anon_sym_groupshared] = ACTIONS(1953),
    [anon_sym_uniform] = ACTIONS(1953),
    [anon_sym_row_major] = ACTIONS(1953),
    [anon_sym_column_major] = ACTIONS(1953),
    [anon_sym_globallycoherent] = ACTIONS(1953),
    [anon_sym_centroid] = ACTIONS(1953),
    [anon_sym_noperspective] = ACTIONS(1953),
    [anon_sym_nointerpolation] = ACTIONS(1953),
    [anon_sym_sample] = ACTIONS(1953),
    [anon_sym_linear] = ACTIONS(1953),
    [anon_sym_snorm] = ACTIONS(1953),
    [anon_sym_unorm] = ACTIONS(1953),
    [anon_sym_point] = ACTIONS(1953),
    [anon_sym_line] = ACTIONS(1953),
    [anon_sym_triangleadj] = ACTIONS(1953),
    [anon_sym_lineadj] = ACTIONS(1953),
    [anon_sym_triangle] = ACTIONS(1953),
  },
  [2504] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_out] = ACTIONS(1979),
    [anon_sym_inout] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1981),
    [anon_sym___declspec] = ACTIONS(1979),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_register] = ACTIONS(1979),
    [anon_sym_inline] = ACTIONS(1979),
    [anon_sym___inline] = ACTIONS(1979),
    [anon_sym___inline__] = ACTIONS(1979),
    [anon_sym___forceinline] = ACTIONS(1979),
    [anon_sym_thread_local] = ACTIONS(1979),
    [anon_sym___thread] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_template] = ACTIONS(1979),
    [anon_sym_GT2] = ACTIONS(1981),
    [anon_sym_operator] = ACTIONS(1979),
    [anon_sym_precise] = ACTIONS(1979),
    [anon_sym_shared] = ACTIONS(1979),
    [anon_sym_groupshared] = ACTIONS(1979),
    [anon_sym_uniform] = ACTIONS(1979),
    [anon_sym_row_major] = ACTIONS(1979),
    [anon_sym_column_major] = ACTIONS(1979),
    [anon_sym_globallycoherent] = ACTIONS(1979),
    [anon_sym_centroid] = ACTIONS(1979),
    [anon_sym_noperspective] = ACTIONS(1979),
    [anon_sym_nointerpolation] = ACTIONS(1979),
    [anon_sym_sample] = ACTIONS(1979),
    [anon_sym_linear] = ACTIONS(1979),
    [anon_sym_snorm] = ACTIONS(1979),
    [anon_sym_unorm] = ACTIONS(1979),
    [anon_sym_point] = ACTIONS(1979),
    [anon_sym_line] = ACTIONS(1979),
    [anon_sym_triangleadj] = ACTIONS(1979),
    [anon_sym_lineadj] = ACTIONS(1979),
    [anon_sym_triangle] = ACTIONS(1979),
  },
  [2505] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym_in] = ACTIONS(1991),
    [anon_sym_out] = ACTIONS(1991),
    [anon_sym_inout] = ACTIONS(1991),
    [anon_sym_virtual] = ACTIONS(1991),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1993),
    [anon_sym___declspec] = ACTIONS(1991),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_register] = ACTIONS(1991),
    [anon_sym_inline] = ACTIONS(1991),
    [anon_sym___inline] = ACTIONS(1991),
    [anon_sym___inline__] = ACTIONS(1991),
    [anon_sym___forceinline] = ACTIONS(1991),
    [anon_sym_thread_local] = ACTIONS(1991),
    [anon_sym___thread] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_template] = ACTIONS(1991),
    [anon_sym_GT2] = ACTIONS(1993),
    [anon_sym_operator] = ACTIONS(1991),
    [anon_sym_precise] = ACTIONS(1991),
    [anon_sym_shared] = ACTIONS(1991),
    [anon_sym_groupshared] = ACTIONS(1991),
    [anon_sym_uniform] = ACTIONS(1991),
    [anon_sym_row_major] = ACTIONS(1991),
    [anon_sym_column_major] = ACTIONS(1991),
    [anon_sym_globallycoherent] = ACTIONS(1991),
    [anon_sym_centroid] = ACTIONS(1991),
    [anon_sym_noperspective] = ACTIONS(1991),
    [anon_sym_nointerpolation] = ACTIONS(1991),
    [anon_sym_sample] = ACTIONS(1991),
    [anon_sym_linear] = ACTIONS(1991),
    [anon_sym_snorm] = ACTIONS(1991),
    [anon_sym_unorm] = ACTIONS(1991),
    [anon_sym_point] = ACTIONS(1991),
    [anon_sym_line] = ACTIONS(1991),
    [anon_sym_triangleadj] = ACTIONS(1991),
    [anon_sym_lineadj] = ACTIONS(1991),
    [anon_sym_triangle] = ACTIONS(1991),
  },
  [2506] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_TILDE] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_out] = ACTIONS(1983),
    [anon_sym_inout] = ACTIONS(1983),
    [anon_sym_virtual] = ACTIONS(1983),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1985),
    [anon_sym___declspec] = ACTIONS(1983),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_EQ] = ACTIONS(1985),
    [anon_sym_register] = ACTIONS(1983),
    [anon_sym_inline] = ACTIONS(1983),
    [anon_sym___inline] = ACTIONS(1983),
    [anon_sym___inline__] = ACTIONS(1983),
    [anon_sym___forceinline] = ACTIONS(1983),
    [anon_sym_thread_local] = ACTIONS(1983),
    [anon_sym___thread] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_template] = ACTIONS(1983),
    [anon_sym_GT2] = ACTIONS(1985),
    [anon_sym_operator] = ACTIONS(1983),
    [anon_sym_precise] = ACTIONS(1983),
    [anon_sym_shared] = ACTIONS(1983),
    [anon_sym_groupshared] = ACTIONS(1983),
    [anon_sym_uniform] = ACTIONS(1983),
    [anon_sym_row_major] = ACTIONS(1983),
    [anon_sym_column_major] = ACTIONS(1983),
    [anon_sym_globallycoherent] = ACTIONS(1983),
    [anon_sym_centroid] = ACTIONS(1983),
    [anon_sym_noperspective] = ACTIONS(1983),
    [anon_sym_nointerpolation] = ACTIONS(1983),
    [anon_sym_sample] = ACTIONS(1983),
    [anon_sym_linear] = ACTIONS(1983),
    [anon_sym_snorm] = ACTIONS(1983),
    [anon_sym_unorm] = ACTIONS(1983),
    [anon_sym_point] = ACTIONS(1983),
    [anon_sym_line] = ACTIONS(1983),
    [anon_sym_triangleadj] = ACTIONS(1983),
    [anon_sym_lineadj] = ACTIONS(1983),
    [anon_sym_triangle] = ACTIONS(1983),
  },
  [2507] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_RPAREN] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2038),
    [anon_sym_PERCENT] = ACTIONS(2040),
    [anon_sym_PIPE_PIPE] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_PIPE] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_EQ_EQ] = ACTIONS(2040),
    [anon_sym_BANG_EQ] = ACTIONS(2040),
    [anon_sym_GT] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_LT_LT] = ACTIONS(2040),
    [anon_sym_GT_GT] = ACTIONS(2040),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_signed] = ACTIONS(2038),
    [anon_sym_unsigned] = ACTIONS(2038),
    [anon_sym_long] = ACTIONS(2038),
    [anon_sym_short] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_RBRACK] = ACTIONS(2040),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_primitive_type] = ACTIONS(2038),
    [anon_sym_else] = ACTIONS(2038),
    [anon_sym_while] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(2040),
    [anon_sym_LT_EQ_GT] = ACTIONS(2040),
    [anon_sym_or] = ACTIONS(2038),
    [anon_sym_and] = ACTIONS(2038),
    [anon_sym_bitor] = ACTIONS(2038),
    [anon_sym_xor] = ACTIONS(2038),
    [anon_sym_bitand] = ACTIONS(2038),
    [anon_sym_not_eq] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_DOT] = ACTIONS(2038),
    [anon_sym_DOT_STAR] = ACTIONS(2040),
    [anon_sym_DASH_GT] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
    [anon_sym_requires] = ACTIONS(2038),
  },
  [2508] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_TILDE] = ACTIONS(1973),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_inout] = ACTIONS(1971),
    [anon_sym_virtual] = ACTIONS(1971),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1973),
    [anon_sym___declspec] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_EQ] = ACTIONS(1973),
    [anon_sym_register] = ACTIONS(1971),
    [anon_sym_inline] = ACTIONS(1971),
    [anon_sym___inline] = ACTIONS(1971),
    [anon_sym___inline__] = ACTIONS(1971),
    [anon_sym___forceinline] = ACTIONS(1971),
    [anon_sym_thread_local] = ACTIONS(1971),
    [anon_sym___thread] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_template] = ACTIONS(1971),
    [anon_sym_GT2] = ACTIONS(1973),
    [anon_sym_operator] = ACTIONS(1971),
    [anon_sym_precise] = ACTIONS(1971),
    [anon_sym_shared] = ACTIONS(1971),
    [anon_sym_groupshared] = ACTIONS(1971),
    [anon_sym_uniform] = ACTIONS(1971),
    [anon_sym_row_major] = ACTIONS(1971),
    [anon_sym_column_major] = ACTIONS(1971),
    [anon_sym_globallycoherent] = ACTIONS(1971),
    [anon_sym_centroid] = ACTIONS(1971),
    [anon_sym_noperspective] = ACTIONS(1971),
    [anon_sym_nointerpolation] = ACTIONS(1971),
    [anon_sym_sample] = ACTIONS(1971),
    [anon_sym_linear] = ACTIONS(1971),
    [anon_sym_snorm] = ACTIONS(1971),
    [anon_sym_unorm] = ACTIONS(1971),
    [anon_sym_point] = ACTIONS(1971),
    [anon_sym_line] = ACTIONS(1971),
    [anon_sym_triangleadj] = ACTIONS(1971),
    [anon_sym_lineadj] = ACTIONS(1971),
    [anon_sym_triangle] = ACTIONS(1971),
  },
  [2509] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym_in] = ACTIONS(1987),
    [anon_sym_out] = ACTIONS(1987),
    [anon_sym_inout] = ACTIONS(1987),
    [anon_sym_virtual] = ACTIONS(1987),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1989),
    [anon_sym___declspec] = ACTIONS(1987),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1989),
    [anon_sym_register] = ACTIONS(1987),
    [anon_sym_inline] = ACTIONS(1987),
    [anon_sym___inline] = ACTIONS(1987),
    [anon_sym___inline__] = ACTIONS(1987),
    [anon_sym___forceinline] = ACTIONS(1987),
    [anon_sym_thread_local] = ACTIONS(1987),
    [anon_sym___thread] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_template] = ACTIONS(1987),
    [anon_sym_GT2] = ACTIONS(1989),
    [anon_sym_operator] = ACTIONS(1987),
    [anon_sym_precise] = ACTIONS(1987),
    [anon_sym_shared] = ACTIONS(1987),
    [anon_sym_groupshared] = ACTIONS(1987),
    [anon_sym_uniform] = ACTIONS(1987),
    [anon_sym_row_major] = ACTIONS(1987),
    [anon_sym_column_major] = ACTIONS(1987),
    [anon_sym_globallycoherent] = ACTIONS(1987),
    [anon_sym_centroid] = ACTIONS(1987),
    [anon_sym_noperspective] = ACTIONS(1987),
    [anon_sym_nointerpolation] = ACTIONS(1987),
    [anon_sym_sample] = ACTIONS(1987),
    [anon_sym_linear] = ACTIONS(1987),
    [anon_sym_snorm] = ACTIONS(1987),
    [anon_sym_unorm] = ACTIONS(1987),
    [anon_sym_point] = ACTIONS(1987),
    [anon_sym_line] = ACTIONS(1987),
    [anon_sym_triangleadj] = ACTIONS(1987),
    [anon_sym_lineadj] = ACTIONS(1987),
    [anon_sym_triangle] = ACTIONS(1987),
  },
  [2510] = {
    [sym_template_argument_list] = STATE(2516),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4430),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym___cdecl] = ACTIONS(1997),
    [anon_sym___clrcall] = ACTIONS(1997),
    [anon_sym___stdcall] = ACTIONS(1997),
    [anon_sym___fastcall] = ACTIONS(1997),
    [anon_sym___thiscall] = ACTIONS(1997),
    [anon_sym___vectorcall] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2511] = {
    [sym_type_qualifier] = STATE(2511),
    [sym_alignas_qualifier] = STATE(2572),
    [aux_sym_array_declarator_repeat1] = STATE(2511),
    [sym_identifier] = ACTIONS(6442),
    [anon_sym_LPAREN2] = ACTIONS(6444),
    [anon_sym_BANG] = ACTIONS(6444),
    [anon_sym_TILDE] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6442),
    [anon_sym_PLUS] = ACTIONS(6442),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_AMP] = ACTIONS(6444),
    [anon_sym___extension__] = ACTIONS(6446),
    [anon_sym_COLON_COLON] = ACTIONS(6444),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_static] = ACTIONS(6449),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_const] = ACTIONS(6446),
    [anon_sym_constexpr] = ACTIONS(6446),
    [anon_sym_volatile] = ACTIONS(6446),
    [anon_sym_restrict] = ACTIONS(6446),
    [anon_sym___restrict__] = ACTIONS(6446),
    [anon_sym__Atomic] = ACTIONS(6446),
    [anon_sym__Noreturn] = ACTIONS(6446),
    [anon_sym_noreturn] = ACTIONS(6446),
    [anon_sym__Nonnull] = ACTIONS(6446),
    [anon_sym_mutable] = ACTIONS(6446),
    [anon_sym_constinit] = ACTIONS(6446),
    [anon_sym_consteval] = ACTIONS(6446),
    [anon_sym_alignas] = ACTIONS(6452),
    [anon_sym__Alignas] = ACTIONS(6452),
    [sym_primitive_type] = ACTIONS(6442),
    [anon_sym_not] = ACTIONS(6442),
    [anon_sym_compl] = ACTIONS(6442),
    [anon_sym_DASH_DASH] = ACTIONS(6444),
    [anon_sym_PLUS_PLUS] = ACTIONS(6444),
    [anon_sym_sizeof] = ACTIONS(6442),
    [anon_sym___alignof__] = ACTIONS(6442),
    [anon_sym___alignof] = ACTIONS(6442),
    [anon_sym__alignof] = ACTIONS(6442),
    [anon_sym_alignof] = ACTIONS(6442),
    [anon_sym__Alignof] = ACTIONS(6442),
    [anon_sym_offsetof] = ACTIONS(6442),
    [anon_sym__Generic] = ACTIONS(6442),
    [anon_sym_asm] = ACTIONS(6442),
    [anon_sym___asm__] = ACTIONS(6442),
    [anon_sym___asm] = ACTIONS(6442),
    [sym_number_literal] = ACTIONS(6444),
    [anon_sym_L_SQUOTE] = ACTIONS(6444),
    [anon_sym_u_SQUOTE] = ACTIONS(6444),
    [anon_sym_U_SQUOTE] = ACTIONS(6444),
    [anon_sym_u8_SQUOTE] = ACTIONS(6444),
    [anon_sym_SQUOTE] = ACTIONS(6444),
    [anon_sym_L_DQUOTE] = ACTIONS(6444),
    [anon_sym_u_DQUOTE] = ACTIONS(6444),
    [anon_sym_U_DQUOTE] = ACTIONS(6444),
    [anon_sym_u8_DQUOTE] = ACTIONS(6444),
    [anon_sym_DQUOTE] = ACTIONS(6444),
    [sym_true] = ACTIONS(6442),
    [sym_false] = ACTIONS(6442),
    [anon_sym_NULL] = ACTIONS(6442),
    [anon_sym_nullptr] = ACTIONS(6442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6442),
    [anon_sym_template] = ACTIONS(6442),
    [anon_sym_delete] = ACTIONS(6442),
    [anon_sym_R_DQUOTE] = ACTIONS(6444),
    [anon_sym_LR_DQUOTE] = ACTIONS(6444),
    [anon_sym_uR_DQUOTE] = ACTIONS(6444),
    [anon_sym_UR_DQUOTE] = ACTIONS(6444),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6444),
    [anon_sym_co_await] = ACTIONS(6442),
    [anon_sym_new] = ACTIONS(6442),
    [anon_sym_requires] = ACTIONS(6442),
    [sym_this] = ACTIONS(6442),
  },
  [2512] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4451),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym__Nonnull] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4451),
    [anon_sym_or_eq] = ACTIONS(4451),
    [anon_sym_xor_eq] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4451),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4451),
    [anon_sym_not_eq] = ACTIONS(4451),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4451),
  },
  [2513] = {
    [sym_template_argument_list] = STATE(2512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(4637),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym___extension__] = ACTIONS(1999),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4428),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1999),
    [anon_sym_volatile] = ACTIONS(1999),
    [anon_sym_restrict] = ACTIONS(1999),
    [anon_sym___restrict__] = ACTIONS(1999),
    [anon_sym__Atomic] = ACTIONS(1999),
    [anon_sym__Noreturn] = ACTIONS(1999),
    [anon_sym_noreturn] = ACTIONS(1999),
    [anon_sym__Nonnull] = ACTIONS(1999),
    [anon_sym_mutable] = ACTIONS(1999),
    [anon_sym_constinit] = ACTIONS(1999),
    [anon_sym_consteval] = ACTIONS(1999),
    [anon_sym_alignas] = ACTIONS(1999),
    [anon_sym__Alignas] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4428),
    [anon_sym_or_eq] = ACTIONS(4428),
    [anon_sym_xor_eq] = ACTIONS(4428),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4428),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4428),
    [anon_sym_not_eq] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1999),
    [anon_sym_decltype] = ACTIONS(1999),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4428),
  },
  [2514] = {
    [sym_template_argument_list] = STATE(2592),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4238),
    [anon_sym_TILDE] = ACTIONS(4223),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(6246),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_template] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2515] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2019),
    [anon_sym_GT_GT] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_else] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
  },
  [2516] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4453),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym___cdecl] = ACTIONS(2038),
    [anon_sym___clrcall] = ACTIONS(2038),
    [anon_sym___stdcall] = ACTIONS(2038),
    [anon_sym___fastcall] = ACTIONS(2038),
    [anon_sym___thiscall] = ACTIONS(2038),
    [anon_sym___vectorcall] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [2517] = {
    [sym_identifier] = ACTIONS(6408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6410),
    [anon_sym_COMMA] = ACTIONS(6410),
    [anon_sym_RPAREN] = ACTIONS(6410),
    [aux_sym_preproc_if_token2] = ACTIONS(6410),
    [aux_sym_preproc_else_token1] = ACTIONS(6410),
    [aux_sym_preproc_elif_token1] = ACTIONS(6408),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6410),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6410),
    [anon_sym_LPAREN2] = ACTIONS(6410),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_PERCENT] = ACTIONS(6408),
    [anon_sym_PIPE_PIPE] = ACTIONS(6410),
    [anon_sym_AMP_AMP] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_AMP] = ACTIONS(6408),
    [anon_sym_EQ_EQ] = ACTIONS(6410),
    [anon_sym_BANG_EQ] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6408),
    [anon_sym_GT_EQ] = ACTIONS(6410),
    [anon_sym_LT_EQ] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6408),
    [anon_sym_LT_LT] = ACTIONS(6408),
    [anon_sym_GT_GT] = ACTIONS(6408),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SEMI] = ACTIONS(6410),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_RBRACK] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_QMARK] = ACTIONS(6410),
    [anon_sym_STAR_EQ] = ACTIONS(6410),
    [anon_sym_SLASH_EQ] = ACTIONS(6410),
    [anon_sym_PERCENT_EQ] = ACTIONS(6410),
    [anon_sym_PLUS_EQ] = ACTIONS(6410),
    [anon_sym_DASH_EQ] = ACTIONS(6410),
    [anon_sym_LT_LT_EQ] = ACTIONS(6410),
    [anon_sym_GT_GT_EQ] = ACTIONS(6410),
    [anon_sym_AMP_EQ] = ACTIONS(6410),
    [anon_sym_CARET_EQ] = ACTIONS(6410),
    [anon_sym_PIPE_EQ] = ACTIONS(6410),
    [anon_sym_and_eq] = ACTIONS(6408),
    [anon_sym_or_eq] = ACTIONS(6408),
    [anon_sym_xor_eq] = ACTIONS(6408),
    [anon_sym_LT_EQ_GT] = ACTIONS(6410),
    [anon_sym_or] = ACTIONS(6408),
    [anon_sym_and] = ACTIONS(6408),
    [anon_sym_bitor] = ACTIONS(6408),
    [anon_sym_xor] = ACTIONS(6408),
    [anon_sym_bitand] = ACTIONS(6408),
    [anon_sym_not_eq] = ACTIONS(6408),
    [anon_sym_DASH_DASH] = ACTIONS(6410),
    [anon_sym_PLUS_PLUS] = ACTIONS(6410),
    [anon_sym_DOT] = ACTIONS(6408),
    [anon_sym_DOT_STAR] = ACTIONS(6410),
    [anon_sym_DASH_GT] = ACTIONS(6410),
    [anon_sym_L_DQUOTE] = ACTIONS(6410),
    [anon_sym_u_DQUOTE] = ACTIONS(6410),
    [anon_sym_U_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8_DQUOTE] = ACTIONS(6410),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6410),
    [anon_sym_LR_DQUOTE] = ACTIONS(6410),
    [anon_sym_uR_DQUOTE] = ACTIONS(6410),
    [anon_sym_UR_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6410),
    [sym_literal_suffix] = ACTIONS(6408),
  },
  [2518] = {
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1973),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1973),
    [anon_sym_LPAREN2] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1971),
    [anon_sym_PLUS] = ACTIONS(1971),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_SLASH] = ACTIONS(1971),
    [anon_sym_PERCENT] = ACTIONS(1973),
    [anon_sym_PIPE_PIPE] = ACTIONS(1973),
    [anon_sym_AMP_AMP] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1971),
    [anon_sym_CARET] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1971),
    [anon_sym_EQ_EQ] = ACTIONS(1973),
    [anon_sym_BANG_EQ] = ACTIONS(1973),
    [anon_sym_GT] = ACTIONS(1971),
    [anon_sym_GT_EQ] = ACTIONS(1973),
    [anon_sym_LT_EQ] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1971),
    [anon_sym_LT_LT] = ACTIONS(1973),
    [anon_sym_GT_GT] = ACTIONS(1973),
    [anon_sym_COLON] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym___extension__] = ACTIONS(1971),
    [anon_sym___attribute__] = ACTIONS(1971),
    [anon_sym___attribute] = ACTIONS(1971),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym___based] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_signed] = ACTIONS(1971),
    [anon_sym_unsigned] = ACTIONS(1971),
    [anon_sym_long] = ACTIONS(1971),
    [anon_sym_short] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_RBRACK] = ACTIONS(1973),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_constexpr] = ACTIONS(1971),
    [anon_sym_volatile] = ACTIONS(1971),
    [anon_sym_restrict] = ACTIONS(1971),
    [anon_sym___restrict__] = ACTIONS(1971),
    [anon_sym__Atomic] = ACTIONS(1971),
    [anon_sym__Noreturn] = ACTIONS(1971),
    [anon_sym_noreturn] = ACTIONS(1971),
    [anon_sym__Nonnull] = ACTIONS(1971),
    [anon_sym_mutable] = ACTIONS(1971),
    [anon_sym_constinit] = ACTIONS(1971),
    [anon_sym_consteval] = ACTIONS(1971),
    [anon_sym_alignas] = ACTIONS(1971),
    [anon_sym__Alignas] = ACTIONS(1971),
    [sym_primitive_type] = ACTIONS(1971),
    [anon_sym_QMARK] = ACTIONS(1973),
    [anon_sym_LT_EQ_GT] = ACTIONS(1973),
    [anon_sym_or] = ACTIONS(1971),
    [anon_sym_and] = ACTIONS(1971),
    [anon_sym_bitor] = ACTIONS(1971),
    [anon_sym_xor] = ACTIONS(1971),
    [anon_sym_bitand] = ACTIONS(1971),
    [anon_sym_not_eq] = ACTIONS(1971),
    [anon_sym_DASH_DASH] = ACTIONS(1973),
    [anon_sym_PLUS_PLUS] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1971),
    [anon_sym_DOT_STAR] = ACTIONS(1973),
    [anon_sym_DASH_GT] = ACTIONS(1973),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1971),
    [anon_sym_decltype] = ACTIONS(1971),
    [anon_sym_final] = ACTIONS(1971),
    [anon_sym_override] = ACTIONS(1971),
    [anon_sym_requires] = ACTIONS(1971),
  },
  [2519] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2019),
    [anon_sym_GT_GT] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
  },
  [2520] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2019),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2019),
    [anon_sym_GT_GT] = ACTIONS(2019),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___extension__] = ACTIONS(2017),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym___based] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_signed] = ACTIONS(2017),
    [anon_sym_unsigned] = ACTIONS(2017),
    [anon_sym_long] = ACTIONS(2017),
    [anon_sym_short] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_constexpr] = ACTIONS(2017),
    [anon_sym_volatile] = ACTIONS(2017),
    [anon_sym_restrict] = ACTIONS(2017),
    [anon_sym___restrict__] = ACTIONS(2017),
    [anon_sym__Atomic] = ACTIONS(2017),
    [anon_sym__Noreturn] = ACTIONS(2017),
    [anon_sym_noreturn] = ACTIONS(2017),
    [anon_sym__Nonnull] = ACTIONS(2017),
    [anon_sym_mutable] = ACTIONS(2017),
    [anon_sym_constinit] = ACTIONS(2017),
    [anon_sym_consteval] = ACTIONS(2017),
    [anon_sym_alignas] = ACTIONS(2017),
    [anon_sym__Alignas] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
    [anon_sym_requires] = ACTIONS(2017),
  },
  [2521] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5859),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5859),
    [anon_sym_GT_GT] = ACTIONS(5859),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(5857),
    [anon_sym_unsigned] = ACTIONS(5857),
    [anon_sym_long] = ACTIONS(5857),
    [anon_sym_short] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_primitive_type] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
  },
  [2522] = {
    [sym_identifier] = ACTIONS(6455),
    [anon_sym_LPAREN2] = ACTIONS(6457),
    [anon_sym_STAR] = ACTIONS(6457),
    [anon_sym_AMP_AMP] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6455),
    [anon_sym___extension__] = ACTIONS(6455),
    [anon_sym_in] = ACTIONS(6455),
    [anon_sym_out] = ACTIONS(6455),
    [anon_sym_inout] = ACTIONS(6455),
    [anon_sym_virtual] = ACTIONS(6455),
    [anon_sym_extern] = ACTIONS(6455),
    [anon_sym___attribute__] = ACTIONS(6455),
    [anon_sym___attribute] = ACTIONS(6455),
    [anon_sym_COLON_COLON] = ACTIONS(6457),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6457),
    [anon_sym___declspec] = ACTIONS(6455),
    [anon_sym___based] = ACTIONS(6455),
    [anon_sym_signed] = ACTIONS(6455),
    [anon_sym_unsigned] = ACTIONS(6455),
    [anon_sym_long] = ACTIONS(6455),
    [anon_sym_short] = ACTIONS(6455),
    [anon_sym_static] = ACTIONS(6455),
    [anon_sym_register] = ACTIONS(6455),
    [anon_sym_inline] = ACTIONS(6455),
    [anon_sym___inline] = ACTIONS(6455),
    [anon_sym___inline__] = ACTIONS(6455),
    [anon_sym___forceinline] = ACTIONS(6455),
    [anon_sym_thread_local] = ACTIONS(6455),
    [anon_sym___thread] = ACTIONS(6455),
    [anon_sym_const] = ACTIONS(6455),
    [anon_sym_constexpr] = ACTIONS(6455),
    [anon_sym_volatile] = ACTIONS(6455),
    [anon_sym_restrict] = ACTIONS(6455),
    [anon_sym___restrict__] = ACTIONS(6455),
    [anon_sym__Atomic] = ACTIONS(6455),
    [anon_sym__Noreturn] = ACTIONS(6455),
    [anon_sym_noreturn] = ACTIONS(6455),
    [anon_sym__Nonnull] = ACTIONS(6455),
    [anon_sym_mutable] = ACTIONS(6455),
    [anon_sym_constinit] = ACTIONS(6455),
    [anon_sym_consteval] = ACTIONS(6455),
    [anon_sym_alignas] = ACTIONS(6455),
    [anon_sym__Alignas] = ACTIONS(6455),
    [sym_primitive_type] = ACTIONS(6455),
    [anon_sym_enum] = ACTIONS(6455),
    [anon_sym_class] = ACTIONS(6455),
    [anon_sym_struct] = ACTIONS(6455),
    [anon_sym_union] = ACTIONS(6455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6455),
    [anon_sym_decltype] = ACTIONS(6455),
    [anon_sym_typename] = ACTIONS(6455),
    [anon_sym_template] = ACTIONS(6455),
    [anon_sym_precise] = ACTIONS(6455),
    [anon_sym_shared] = ACTIONS(6455),
    [anon_sym_groupshared] = ACTIONS(6455),
    [anon_sym_uniform] = ACTIONS(6455),
    [anon_sym_row_major] = ACTIONS(6455),
    [anon_sym_column_major] = ACTIONS(6455),
    [anon_sym_globallycoherent] = ACTIONS(6455),
    [anon_sym_centroid] = ACTIONS(6455),
    [anon_sym_noperspective] = ACTIONS(6455),
    [anon_sym_nointerpolation] = ACTIONS(6455),
    [anon_sym_sample] = ACTIONS(6455),
    [anon_sym_linear] = ACTIONS(6455),
    [anon_sym_snorm] = ACTIONS(6455),
    [anon_sym_unorm] = ACTIONS(6455),
    [anon_sym_point] = ACTIONS(6455),
    [anon_sym_line] = ACTIONS(6455),
    [anon_sym_triangleadj] = ACTIONS(6455),
    [anon_sym_lineadj] = ACTIONS(6455),
    [anon_sym_triangle] = ACTIONS(6455),
  },
  [2523] = {
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1977),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_LPAREN2] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_PLUS] = ACTIONS(1975),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_SLASH] = ACTIONS(1975),
    [anon_sym_PERCENT] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1975),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1975),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1975),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1975),
    [anon_sym_LT_LT] = ACTIONS(1977),
    [anon_sym_GT_GT] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym___extension__] = ACTIONS(1975),
    [anon_sym___attribute__] = ACTIONS(1975),
    [anon_sym___attribute] = ACTIONS(1975),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym___based] = ACTIONS(1975),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_signed] = ACTIONS(1975),
    [anon_sym_unsigned] = ACTIONS(1975),
    [anon_sym_long] = ACTIONS(1975),
    [anon_sym_short] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_constexpr] = ACTIONS(1975),
    [anon_sym_volatile] = ACTIONS(1975),
    [anon_sym_restrict] = ACTIONS(1975),
    [anon_sym___restrict__] = ACTIONS(1975),
    [anon_sym__Atomic] = ACTIONS(1975),
    [anon_sym__Noreturn] = ACTIONS(1975),
    [anon_sym_noreturn] = ACTIONS(1975),
    [anon_sym__Nonnull] = ACTIONS(1975),
    [anon_sym_mutable] = ACTIONS(1975),
    [anon_sym_constinit] = ACTIONS(1975),
    [anon_sym_consteval] = ACTIONS(1975),
    [anon_sym_alignas] = ACTIONS(1975),
    [anon_sym__Alignas] = ACTIONS(1975),
    [sym_primitive_type] = ACTIONS(1975),
    [anon_sym_QMARK] = ACTIONS(1977),
    [anon_sym_LT_EQ_GT] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1975),
    [anon_sym_and] = ACTIONS(1975),
    [anon_sym_bitor] = ACTIONS(1975),
    [anon_sym_xor] = ACTIONS(1975),
    [anon_sym_bitand] = ACTIONS(1975),
    [anon_sym_not_eq] = ACTIONS(1975),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_DOT_STAR] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1975),
    [anon_sym_decltype] = ACTIONS(1975),
    [anon_sym_final] = ACTIONS(1975),
    [anon_sym_override] = ACTIONS(1975),
    [anon_sym_requires] = ACTIONS(1975),
  },
  [2524] = {
    [sym_identifier] = ACTIONS(1953),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_LPAREN2] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1953),
    [anon_sym_PERCENT] = ACTIONS(1955),
    [anon_sym_PIPE_PIPE] = ACTIONS(1955),
    [anon_sym_AMP_AMP] = ACTIONS(1955),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_CARET] = ACTIONS(1955),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_EQ_EQ] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1955),
    [anon_sym_GT_GT] = ACTIONS(1955),
    [anon_sym_COLON] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1955),
    [anon_sym___extension__] = ACTIONS(1953),
    [anon_sym___attribute__] = ACTIONS(1953),
    [anon_sym___attribute] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1955),
    [anon_sym___based] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_RBRACE] = ACTIONS(1955),
    [anon_sym_signed] = ACTIONS(1953),
    [anon_sym_unsigned] = ACTIONS(1953),
    [anon_sym_long] = ACTIONS(1953),
    [anon_sym_short] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [anon_sym_RBRACK] = ACTIONS(1955),
    [anon_sym_const] = ACTIONS(1953),
    [anon_sym_constexpr] = ACTIONS(1953),
    [anon_sym_volatile] = ACTIONS(1953),
    [anon_sym_restrict] = ACTIONS(1953),
    [anon_sym___restrict__] = ACTIONS(1953),
    [anon_sym__Atomic] = ACTIONS(1953),
    [anon_sym__Noreturn] = ACTIONS(1953),
    [anon_sym_noreturn] = ACTIONS(1953),
    [anon_sym__Nonnull] = ACTIONS(1953),
    [anon_sym_mutable] = ACTIONS(1953),
    [anon_sym_constinit] = ACTIONS(1953),
    [anon_sym_consteval] = ACTIONS(1953),
    [anon_sym_alignas] = ACTIONS(1953),
    [anon_sym__Alignas] = ACTIONS(1953),
    [sym_primitive_type] = ACTIONS(1953),
    [anon_sym_QMARK] = ACTIONS(1955),
    [anon_sym_LT_EQ_GT] = ACTIONS(1955),
    [anon_sym_or] = ACTIONS(1953),
    [anon_sym_and] = ACTIONS(1953),
    [anon_sym_bitor] = ACTIONS(1953),
    [anon_sym_xor] = ACTIONS(1953),
    [anon_sym_bitand] = ACTIONS(1953),
    [anon_sym_not_eq] = ACTIONS(1953),
    [anon_sym_DASH_DASH] = ACTIONS(1955),
    [anon_sym_PLUS_PLUS] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_DOT_STAR] = ACTIONS(1955),
    [anon_sym_DASH_GT] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1953),
    [anon_sym_decltype] = ACTIONS(1953),
    [anon_sym_final] = ACTIONS(1953),
    [anon_sym_override] = ACTIONS(1953),
    [anon_sym_requires] = ACTIONS(1953),
  },
  [2525] = {
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1981),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_LPAREN2] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1981),
    [anon_sym_GT_GT] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym___extension__] = ACTIONS(1979),
    [anon_sym___attribute__] = ACTIONS(1979),
    [anon_sym___attribute] = ACTIONS(1979),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym___based] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_signed] = ACTIONS(1979),
    [anon_sym_unsigned] = ACTIONS(1979),
    [anon_sym_long] = ACTIONS(1979),
    [anon_sym_short] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_constexpr] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_restrict] = ACTIONS(1979),
    [anon_sym___restrict__] = ACTIONS(1979),
    [anon_sym__Atomic] = ACTIONS(1979),
    [anon_sym__Noreturn] = ACTIONS(1979),
    [anon_sym_noreturn] = ACTIONS(1979),
    [anon_sym__Nonnull] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1979),
    [anon_sym_constinit] = ACTIONS(1979),
    [anon_sym_consteval] = ACTIONS(1979),
    [anon_sym_alignas] = ACTIONS(1979),
    [anon_sym__Alignas] = ACTIONS(1979),
    [sym_primitive_type] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_LT_EQ_GT] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_and] = ACTIONS(1979),
    [anon_sym_bitor] = ACTIONS(1979),
    [anon_sym_xor] = ACTIONS(1979),
    [anon_sym_bitand] = ACTIONS(1979),
    [anon_sym_not_eq] = ACTIONS(1979),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_DOT_STAR] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1979),
    [anon_sym_decltype] = ACTIONS(1979),
    [anon_sym_final] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_requires] = ACTIONS(1979),
  },
  [2526] = {
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2013),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2013),
    [anon_sym_PIPE_PIPE] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_PIPE] = ACTIONS(2011),
    [anon_sym_CARET] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(2011),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym___based] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_signed] = ACTIONS(2011),
    [anon_sym_unsigned] = ACTIONS(2011),
    [anon_sym_long] = ACTIONS(2011),
    [anon_sym_short] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [anon_sym_RBRACK] = ACTIONS(2013),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_constexpr] = ACTIONS(2011),
    [anon_sym_volatile] = ACTIONS(2011),
    [anon_sym_restrict] = ACTIONS(2011),
    [anon_sym___restrict__] = ACTIONS(2011),
    [anon_sym__Atomic] = ACTIONS(2011),
    [anon_sym__Noreturn] = ACTIONS(2011),
    [anon_sym_noreturn] = ACTIONS(2011),
    [anon_sym__Nonnull] = ACTIONS(2011),
    [anon_sym_mutable] = ACTIONS(2011),
    [anon_sym_constinit] = ACTIONS(2011),
    [anon_sym_consteval] = ACTIONS(2011),
    [anon_sym_alignas] = ACTIONS(2011),
    [anon_sym__Alignas] = ACTIONS(2011),
    [sym_primitive_type] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(2013),
    [anon_sym_LT_EQ_GT] = ACTIONS(2013),
    [anon_sym_or] = ACTIONS(2011),
    [anon_sym_and] = ACTIONS(2011),
    [anon_sym_bitor] = ACTIONS(2011),
    [anon_sym_xor] = ACTIONS(2011),
    [anon_sym_bitand] = ACTIONS(2011),
    [anon_sym_not_eq] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_DOT_STAR] = ACTIONS(2013),
    [anon_sym_DASH_GT] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
    [anon_sym_requires] = ACTIONS(2011),
  },
  [2527] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2528] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(5859),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym___cdecl] = ACTIONS(5857),
    [anon_sym___clrcall] = ACTIONS(5857),
    [anon_sym___stdcall] = ACTIONS(5857),
    [anon_sym___fastcall] = ACTIONS(5857),
    [anon_sym___thiscall] = ACTIONS(5857),
    [anon_sym___vectorcall] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2529] = {
    [sym_template_argument_list] = STATE(2592),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(6265),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4430),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1999),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2029),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2029),
    [anon_sym_SLASH] = ACTIONS(2027),
    [anon_sym_PERCENT] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2027),
    [anon_sym_CARET] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2029),
    [anon_sym_GT] = ACTIONS(2027),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_LT_EQ] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_LT_LT] = ACTIONS(2029),
    [anon_sym_GT_GT] = ACTIONS(2029),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___extension__] = ACTIONS(2027),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym___based] = ACTIONS(2027),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_signed] = ACTIONS(2027),
    [anon_sym_unsigned] = ACTIONS(2027),
    [anon_sym_long] = ACTIONS(2027),
    [anon_sym_short] = ACTIONS(2027),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_RBRACK] = ACTIONS(2029),
    [anon_sym_const] = ACTIONS(2027),
    [anon_sym_constexpr] = ACTIONS(2027),
    [anon_sym_volatile] = ACTIONS(2027),
    [anon_sym_restrict] = ACTIONS(2027),
    [anon_sym___restrict__] = ACTIONS(2027),
    [anon_sym__Atomic] = ACTIONS(2027),
    [anon_sym__Noreturn] = ACTIONS(2027),
    [anon_sym_noreturn] = ACTIONS(2027),
    [anon_sym__Nonnull] = ACTIONS(2027),
    [anon_sym_mutable] = ACTIONS(2027),
    [anon_sym_constinit] = ACTIONS(2027),
    [anon_sym_consteval] = ACTIONS(2027),
    [anon_sym_alignas] = ACTIONS(2027),
    [anon_sym__Alignas] = ACTIONS(2027),
    [sym_primitive_type] = ACTIONS(2027),
    [anon_sym_QMARK] = ACTIONS(2029),
    [anon_sym_LT_EQ_GT] = ACTIONS(2029),
    [anon_sym_or] = ACTIONS(2027),
    [anon_sym_and] = ACTIONS(2027),
    [anon_sym_bitor] = ACTIONS(2027),
    [anon_sym_xor] = ACTIONS(2027),
    [anon_sym_bitand] = ACTIONS(2027),
    [anon_sym_not_eq] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DOT] = ACTIONS(2027),
    [anon_sym_DOT_STAR] = ACTIONS(2029),
    [anon_sym_DASH_GT] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
    [anon_sym_requires] = ACTIONS(2027),
  },
  [2531] = {
    [sym_identifier] = ACTIONS(6459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6461),
    [anon_sym_COMMA] = ACTIONS(6461),
    [anon_sym_RPAREN] = ACTIONS(6461),
    [aux_sym_preproc_if_token2] = ACTIONS(6461),
    [aux_sym_preproc_else_token1] = ACTIONS(6461),
    [aux_sym_preproc_elif_token1] = ACTIONS(6459),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6461),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6461),
    [anon_sym_LPAREN2] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(6459),
    [anon_sym_PLUS] = ACTIONS(6459),
    [anon_sym_STAR] = ACTIONS(6459),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_PERCENT] = ACTIONS(6459),
    [anon_sym_PIPE_PIPE] = ACTIONS(6461),
    [anon_sym_AMP_AMP] = ACTIONS(6461),
    [anon_sym_PIPE] = ACTIONS(6459),
    [anon_sym_CARET] = ACTIONS(6459),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ_EQ] = ACTIONS(6461),
    [anon_sym_BANG_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6459),
    [anon_sym_GT_EQ] = ACTIONS(6461),
    [anon_sym_LT_EQ] = ACTIONS(6459),
    [anon_sym_LT] = ACTIONS(6459),
    [anon_sym_LT_LT] = ACTIONS(6459),
    [anon_sym_GT_GT] = ACTIONS(6459),
    [anon_sym_COLON] = ACTIONS(6461),
    [anon_sym_SEMI] = ACTIONS(6461),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_LBRACK] = ACTIONS(6461),
    [anon_sym_RBRACK] = ACTIONS(6461),
    [anon_sym_EQ] = ACTIONS(6459),
    [anon_sym_QMARK] = ACTIONS(6461),
    [anon_sym_STAR_EQ] = ACTIONS(6461),
    [anon_sym_SLASH_EQ] = ACTIONS(6461),
    [anon_sym_PERCENT_EQ] = ACTIONS(6461),
    [anon_sym_PLUS_EQ] = ACTIONS(6461),
    [anon_sym_DASH_EQ] = ACTIONS(6461),
    [anon_sym_LT_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT_GT_EQ] = ACTIONS(6461),
    [anon_sym_AMP_EQ] = ACTIONS(6461),
    [anon_sym_CARET_EQ] = ACTIONS(6461),
    [anon_sym_PIPE_EQ] = ACTIONS(6461),
    [anon_sym_and_eq] = ACTIONS(6459),
    [anon_sym_or_eq] = ACTIONS(6459),
    [anon_sym_xor_eq] = ACTIONS(6459),
    [anon_sym_LT_EQ_GT] = ACTIONS(6461),
    [anon_sym_or] = ACTIONS(6459),
    [anon_sym_and] = ACTIONS(6459),
    [anon_sym_bitor] = ACTIONS(6459),
    [anon_sym_xor] = ACTIONS(6459),
    [anon_sym_bitand] = ACTIONS(6459),
    [anon_sym_not_eq] = ACTIONS(6459),
    [anon_sym_DASH_DASH] = ACTIONS(6461),
    [anon_sym_PLUS_PLUS] = ACTIONS(6461),
    [anon_sym_DOT] = ACTIONS(6459),
    [anon_sym_DOT_STAR] = ACTIONS(6461),
    [anon_sym_DASH_GT] = ACTIONS(6461),
    [anon_sym_L_DQUOTE] = ACTIONS(6461),
    [anon_sym_u_DQUOTE] = ACTIONS(6461),
    [anon_sym_U_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8_DQUOTE] = ACTIONS(6461),
    [anon_sym_DQUOTE] = ACTIONS(6461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6461),
    [anon_sym_LR_DQUOTE] = ACTIONS(6461),
    [anon_sym_uR_DQUOTE] = ACTIONS(6461),
    [anon_sym_UR_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6461),
    [sym_literal_suffix] = ACTIONS(6459),
  },
  [2532] = {
    [sym_identifier] = ACTIONS(6463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6465),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6465),
    [aux_sym_preproc_if_token2] = ACTIONS(6465),
    [aux_sym_preproc_else_token1] = ACTIONS(6465),
    [aux_sym_preproc_elif_token1] = ACTIONS(6463),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6465),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6465),
    [anon_sym_LPAREN2] = ACTIONS(6465),
    [anon_sym_DASH] = ACTIONS(6463),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_STAR] = ACTIONS(6463),
    [anon_sym_SLASH] = ACTIONS(6463),
    [anon_sym_PERCENT] = ACTIONS(6463),
    [anon_sym_PIPE_PIPE] = ACTIONS(6465),
    [anon_sym_AMP_AMP] = ACTIONS(6465),
    [anon_sym_PIPE] = ACTIONS(6463),
    [anon_sym_CARET] = ACTIONS(6463),
    [anon_sym_AMP] = ACTIONS(6463),
    [anon_sym_EQ_EQ] = ACTIONS(6465),
    [anon_sym_BANG_EQ] = ACTIONS(6465),
    [anon_sym_GT] = ACTIONS(6463),
    [anon_sym_GT_EQ] = ACTIONS(6465),
    [anon_sym_LT_EQ] = ACTIONS(6463),
    [anon_sym_LT] = ACTIONS(6463),
    [anon_sym_LT_LT] = ACTIONS(6463),
    [anon_sym_GT_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_SEMI] = ACTIONS(6465),
    [anon_sym_RBRACE] = ACTIONS(6465),
    [anon_sym_LBRACK] = ACTIONS(6465),
    [anon_sym_RBRACK] = ACTIONS(6465),
    [anon_sym_EQ] = ACTIONS(6463),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_STAR_EQ] = ACTIONS(6465),
    [anon_sym_SLASH_EQ] = ACTIONS(6465),
    [anon_sym_PERCENT_EQ] = ACTIONS(6465),
    [anon_sym_PLUS_EQ] = ACTIONS(6465),
    [anon_sym_DASH_EQ] = ACTIONS(6465),
    [anon_sym_LT_LT_EQ] = ACTIONS(6465),
    [anon_sym_GT_GT_EQ] = ACTIONS(6465),
    [anon_sym_AMP_EQ] = ACTIONS(6465),
    [anon_sym_CARET_EQ] = ACTIONS(6465),
    [anon_sym_PIPE_EQ] = ACTIONS(6465),
    [anon_sym_and_eq] = ACTIONS(6463),
    [anon_sym_or_eq] = ACTIONS(6463),
    [anon_sym_xor_eq] = ACTIONS(6463),
    [anon_sym_LT_EQ_GT] = ACTIONS(6465),
    [anon_sym_or] = ACTIONS(6463),
    [anon_sym_and] = ACTIONS(6463),
    [anon_sym_bitor] = ACTIONS(6463),
    [anon_sym_xor] = ACTIONS(6463),
    [anon_sym_bitand] = ACTIONS(6463),
    [anon_sym_not_eq] = ACTIONS(6463),
    [anon_sym_DASH_DASH] = ACTIONS(6465),
    [anon_sym_PLUS_PLUS] = ACTIONS(6465),
    [anon_sym_DOT] = ACTIONS(6463),
    [anon_sym_DOT_STAR] = ACTIONS(6465),
    [anon_sym_DASH_GT] = ACTIONS(6465),
    [anon_sym_L_DQUOTE] = ACTIONS(6465),
    [anon_sym_u_DQUOTE] = ACTIONS(6465),
    [anon_sym_U_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8_DQUOTE] = ACTIONS(6465),
    [anon_sym_DQUOTE] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6465),
    [anon_sym_LR_DQUOTE] = ACTIONS(6465),
    [anon_sym_uR_DQUOTE] = ACTIONS(6465),
    [anon_sym_UR_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6465),
    [sym_literal_suffix] = ACTIONS(6463),
  },
  [2533] = {
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1985),
    [anon_sym_COMMA] = ACTIONS(1985),
    [anon_sym_RPAREN] = ACTIONS(1985),
    [anon_sym_LPAREN2] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1983),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1983),
    [anon_sym_PERCENT] = ACTIONS(1985),
    [anon_sym_PIPE_PIPE] = ACTIONS(1985),
    [anon_sym_AMP_AMP] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1983),
    [anon_sym_CARET] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1983),
    [anon_sym_EQ_EQ] = ACTIONS(1985),
    [anon_sym_BANG_EQ] = ACTIONS(1985),
    [anon_sym_GT] = ACTIONS(1983),
    [anon_sym_GT_EQ] = ACTIONS(1985),
    [anon_sym_LT_EQ] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1983),
    [anon_sym_LT_LT] = ACTIONS(1985),
    [anon_sym_GT_GT] = ACTIONS(1985),
    [anon_sym_COLON] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym___extension__] = ACTIONS(1983),
    [anon_sym___attribute__] = ACTIONS(1983),
    [anon_sym___attribute] = ACTIONS(1983),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym___based] = ACTIONS(1983),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_signed] = ACTIONS(1983),
    [anon_sym_unsigned] = ACTIONS(1983),
    [anon_sym_long] = ACTIONS(1983),
    [anon_sym_short] = ACTIONS(1983),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_RBRACK] = ACTIONS(1985),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_constexpr] = ACTIONS(1983),
    [anon_sym_volatile] = ACTIONS(1983),
    [anon_sym_restrict] = ACTIONS(1983),
    [anon_sym___restrict__] = ACTIONS(1983),
    [anon_sym__Atomic] = ACTIONS(1983),
    [anon_sym__Noreturn] = ACTIONS(1983),
    [anon_sym_noreturn] = ACTIONS(1983),
    [anon_sym__Nonnull] = ACTIONS(1983),
    [anon_sym_mutable] = ACTIONS(1983),
    [anon_sym_constinit] = ACTIONS(1983),
    [anon_sym_consteval] = ACTIONS(1983),
    [anon_sym_alignas] = ACTIONS(1983),
    [anon_sym__Alignas] = ACTIONS(1983),
    [sym_primitive_type] = ACTIONS(1983),
    [anon_sym_QMARK] = ACTIONS(1985),
    [anon_sym_LT_EQ_GT] = ACTIONS(1985),
    [anon_sym_or] = ACTIONS(1983),
    [anon_sym_and] = ACTIONS(1983),
    [anon_sym_bitor] = ACTIONS(1983),
    [anon_sym_xor] = ACTIONS(1983),
    [anon_sym_bitand] = ACTIONS(1983),
    [anon_sym_not_eq] = ACTIONS(1983),
    [anon_sym_DASH_DASH] = ACTIONS(1985),
    [anon_sym_PLUS_PLUS] = ACTIONS(1985),
    [anon_sym_DOT] = ACTIONS(1983),
    [anon_sym_DOT_STAR] = ACTIONS(1985),
    [anon_sym_DASH_GT] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1983),
    [anon_sym_decltype] = ACTIONS(1983),
    [anon_sym_final] = ACTIONS(1983),
    [anon_sym_override] = ACTIONS(1983),
    [anon_sym_requires] = ACTIONS(1983),
  },
  [2534] = {
    [sym_identifier] = ACTIONS(6392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6394),
    [anon_sym_COMMA] = ACTIONS(6394),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [aux_sym_preproc_if_token2] = ACTIONS(6394),
    [aux_sym_preproc_else_token1] = ACTIONS(6394),
    [aux_sym_preproc_elif_token1] = ACTIONS(6392),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6394),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6394),
    [anon_sym_LPAREN2] = ACTIONS(6394),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_PERCENT] = ACTIONS(6392),
    [anon_sym_PIPE_PIPE] = ACTIONS(6394),
    [anon_sym_AMP_AMP] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_EQ_EQ] = ACTIONS(6394),
    [anon_sym_BANG_EQ] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6392),
    [anon_sym_GT_EQ] = ACTIONS(6394),
    [anon_sym_LT_EQ] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6392),
    [anon_sym_LT_LT] = ACTIONS(6392),
    [anon_sym_GT_GT] = ACTIONS(6392),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SEMI] = ACTIONS(6394),
    [anon_sym_RBRACE] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6394),
    [anon_sym_RBRACK] = ACTIONS(6394),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_QMARK] = ACTIONS(6394),
    [anon_sym_STAR_EQ] = ACTIONS(6394),
    [anon_sym_SLASH_EQ] = ACTIONS(6394),
    [anon_sym_PERCENT_EQ] = ACTIONS(6394),
    [anon_sym_PLUS_EQ] = ACTIONS(6394),
    [anon_sym_DASH_EQ] = ACTIONS(6394),
    [anon_sym_LT_LT_EQ] = ACTIONS(6394),
    [anon_sym_GT_GT_EQ] = ACTIONS(6394),
    [anon_sym_AMP_EQ] = ACTIONS(6394),
    [anon_sym_CARET_EQ] = ACTIONS(6394),
    [anon_sym_PIPE_EQ] = ACTIONS(6394),
    [anon_sym_and_eq] = ACTIONS(6392),
    [anon_sym_or_eq] = ACTIONS(6392),
    [anon_sym_xor_eq] = ACTIONS(6392),
    [anon_sym_LT_EQ_GT] = ACTIONS(6394),
    [anon_sym_or] = ACTIONS(6392),
    [anon_sym_and] = ACTIONS(6392),
    [anon_sym_bitor] = ACTIONS(6392),
    [anon_sym_xor] = ACTIONS(6392),
    [anon_sym_bitand] = ACTIONS(6392),
    [anon_sym_not_eq] = ACTIONS(6392),
    [anon_sym_DASH_DASH] = ACTIONS(6394),
    [anon_sym_PLUS_PLUS] = ACTIONS(6394),
    [anon_sym_DOT] = ACTIONS(6392),
    [anon_sym_DOT_STAR] = ACTIONS(6394),
    [anon_sym_DASH_GT] = ACTIONS(6394),
    [anon_sym_L_DQUOTE] = ACTIONS(6394),
    [anon_sym_u_DQUOTE] = ACTIONS(6394),
    [anon_sym_U_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8_DQUOTE] = ACTIONS(6394),
    [anon_sym_DQUOTE] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6394),
    [anon_sym_LR_DQUOTE] = ACTIONS(6394),
    [anon_sym_uR_DQUOTE] = ACTIONS(6394),
    [anon_sym_UR_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6394),
    [sym_literal_suffix] = ACTIONS(6392),
  },
  [2535] = {
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_RPAREN] = ACTIONS(1993),
    [anon_sym_LPAREN2] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1991),
    [anon_sym_PERCENT] = ACTIONS(1993),
    [anon_sym_PIPE_PIPE] = ACTIONS(1993),
    [anon_sym_AMP_AMP] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1991),
    [anon_sym_CARET] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1991),
    [anon_sym_EQ_EQ] = ACTIONS(1993),
    [anon_sym_BANG_EQ] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1993),
    [anon_sym_GT_GT] = ACTIONS(1993),
    [anon_sym_COLON] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym___extension__] = ACTIONS(1991),
    [anon_sym___attribute__] = ACTIONS(1991),
    [anon_sym___attribute] = ACTIONS(1991),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym___based] = ACTIONS(1991),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_signed] = ACTIONS(1991),
    [anon_sym_unsigned] = ACTIONS(1991),
    [anon_sym_long] = ACTIONS(1991),
    [anon_sym_short] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_RBRACK] = ACTIONS(1993),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_constexpr] = ACTIONS(1991),
    [anon_sym_volatile] = ACTIONS(1991),
    [anon_sym_restrict] = ACTIONS(1991),
    [anon_sym___restrict__] = ACTIONS(1991),
    [anon_sym__Atomic] = ACTIONS(1991),
    [anon_sym__Noreturn] = ACTIONS(1991),
    [anon_sym_noreturn] = ACTIONS(1991),
    [anon_sym__Nonnull] = ACTIONS(1991),
    [anon_sym_mutable] = ACTIONS(1991),
    [anon_sym_constinit] = ACTIONS(1991),
    [anon_sym_consteval] = ACTIONS(1991),
    [anon_sym_alignas] = ACTIONS(1991),
    [anon_sym__Alignas] = ACTIONS(1991),
    [sym_primitive_type] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1993),
    [anon_sym_LT_EQ_GT] = ACTIONS(1993),
    [anon_sym_or] = ACTIONS(1991),
    [anon_sym_and] = ACTIONS(1991),
    [anon_sym_bitor] = ACTIONS(1991),
    [anon_sym_xor] = ACTIONS(1991),
    [anon_sym_bitand] = ACTIONS(1991),
    [anon_sym_not_eq] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(1993),
    [anon_sym_PLUS_PLUS] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_DOT_STAR] = ACTIONS(1993),
    [anon_sym_DASH_GT] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1991),
    [anon_sym_decltype] = ACTIONS(1991),
    [anon_sym_final] = ACTIONS(1991),
    [anon_sym_override] = ACTIONS(1991),
    [anon_sym_requires] = ACTIONS(1991),
  },
  [2536] = {
    [sym_template_argument_list] = STATE(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(6467),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym___extension__] = ACTIONS(1999),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1999),
    [anon_sym_volatile] = ACTIONS(1999),
    [anon_sym_restrict] = ACTIONS(1999),
    [anon_sym___restrict__] = ACTIONS(1999),
    [anon_sym__Atomic] = ACTIONS(1999),
    [anon_sym__Noreturn] = ACTIONS(1999),
    [anon_sym_noreturn] = ACTIONS(1999),
    [anon_sym__Nonnull] = ACTIONS(1999),
    [anon_sym_mutable] = ACTIONS(1999),
    [anon_sym_constinit] = ACTIONS(1999),
    [anon_sym_consteval] = ACTIONS(1999),
    [anon_sym_alignas] = ACTIONS(1999),
    [anon_sym__Alignas] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4428),
    [anon_sym_or_eq] = ACTIONS(4428),
    [anon_sym_xor_eq] = ACTIONS(4428),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4428),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4428),
    [anon_sym_not_eq] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1999),
    [anon_sym_decltype] = ACTIONS(1999),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4428),
  },
  [2537] = {
    [sym_identifier] = ACTIONS(5945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5947),
    [anon_sym_RPAREN] = ACTIONS(5947),
    [anon_sym_LPAREN2] = ACTIONS(5947),
    [anon_sym_DASH] = ACTIONS(5945),
    [anon_sym_PLUS] = ACTIONS(5945),
    [anon_sym_STAR] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5945),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_PIPE] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5945),
    [anon_sym_GT_EQ] = ACTIONS(5947),
    [anon_sym_LT_EQ] = ACTIONS(5945),
    [anon_sym_LT] = ACTIONS(5945),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_COLON] = ACTIONS(5945),
    [anon_sym_SEMI] = ACTIONS(5947),
    [anon_sym___extension__] = ACTIONS(5945),
    [anon_sym___attribute__] = ACTIONS(5945),
    [anon_sym___attribute] = ACTIONS(5945),
    [anon_sym_COLON_COLON] = ACTIONS(5947),
    [anon_sym___based] = ACTIONS(5945),
    [anon_sym_LBRACE] = ACTIONS(5947),
    [anon_sym_RBRACE] = ACTIONS(5947),
    [anon_sym_signed] = ACTIONS(5945),
    [anon_sym_unsigned] = ACTIONS(5945),
    [anon_sym_long] = ACTIONS(5945),
    [anon_sym_short] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5947),
    [anon_sym_RBRACK] = ACTIONS(5947),
    [anon_sym_const] = ACTIONS(5945),
    [anon_sym_constexpr] = ACTIONS(5945),
    [anon_sym_volatile] = ACTIONS(5945),
    [anon_sym_restrict] = ACTIONS(5945),
    [anon_sym___restrict__] = ACTIONS(5945),
    [anon_sym__Atomic] = ACTIONS(5945),
    [anon_sym__Noreturn] = ACTIONS(5945),
    [anon_sym_noreturn] = ACTIONS(5945),
    [anon_sym__Nonnull] = ACTIONS(5945),
    [anon_sym_mutable] = ACTIONS(5945),
    [anon_sym_constinit] = ACTIONS(5945),
    [anon_sym_consteval] = ACTIONS(5945),
    [anon_sym_alignas] = ACTIONS(5945),
    [anon_sym__Alignas] = ACTIONS(5945),
    [sym_primitive_type] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5947),
    [anon_sym_LT_EQ_GT] = ACTIONS(5947),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_bitor] = ACTIONS(5945),
    [anon_sym_xor] = ACTIONS(5945),
    [anon_sym_bitand] = ACTIONS(5945),
    [anon_sym_not_eq] = ACTIONS(5945),
    [anon_sym_DASH_DASH] = ACTIONS(5947),
    [anon_sym_PLUS_PLUS] = ACTIONS(5947),
    [anon_sym_DOT] = ACTIONS(5945),
    [anon_sym_DOT_STAR] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5945),
    [anon_sym_decltype] = ACTIONS(5945),
    [anon_sym_final] = ACTIONS(5945),
    [anon_sym_override] = ACTIONS(5945),
    [anon_sym_requires] = ACTIONS(5945),
  },
  [2538] = {
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1987),
    [anon_sym_PERCENT] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1987),
    [anon_sym_CARET] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1987),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1989),
    [anon_sym_GT_GT] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym___extension__] = ACTIONS(1987),
    [anon_sym___attribute__] = ACTIONS(1987),
    [anon_sym___attribute] = ACTIONS(1987),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym___based] = ACTIONS(1987),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_signed] = ACTIONS(1987),
    [anon_sym_unsigned] = ACTIONS(1987),
    [anon_sym_long] = ACTIONS(1987),
    [anon_sym_short] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_constexpr] = ACTIONS(1987),
    [anon_sym_volatile] = ACTIONS(1987),
    [anon_sym_restrict] = ACTIONS(1987),
    [anon_sym___restrict__] = ACTIONS(1987),
    [anon_sym__Atomic] = ACTIONS(1987),
    [anon_sym__Noreturn] = ACTIONS(1987),
    [anon_sym_noreturn] = ACTIONS(1987),
    [anon_sym__Nonnull] = ACTIONS(1987),
    [anon_sym_mutable] = ACTIONS(1987),
    [anon_sym_constinit] = ACTIONS(1987),
    [anon_sym_consteval] = ACTIONS(1987),
    [anon_sym_alignas] = ACTIONS(1987),
    [anon_sym__Alignas] = ACTIONS(1987),
    [sym_primitive_type] = ACTIONS(1987),
    [anon_sym_QMARK] = ACTIONS(1989),
    [anon_sym_LT_EQ_GT] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1987),
    [anon_sym_and] = ACTIONS(1987),
    [anon_sym_bitor] = ACTIONS(1987),
    [anon_sym_xor] = ACTIONS(1987),
    [anon_sym_bitand] = ACTIONS(1987),
    [anon_sym_not_eq] = ACTIONS(1987),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_DOT_STAR] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1987),
    [anon_sym_decltype] = ACTIONS(1987),
    [anon_sym_final] = ACTIONS(1987),
    [anon_sym_override] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1987),
  },
  [2539] = {
    [sym_attribute_specifier] = STATE(2775),
    [sym_field_declaration_list] = STATE(2688),
    [sym_virtual_specifier] = STATE(7157),
    [sym_base_class_clause] = STATE(7964),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5868),
    [anon_sym_COMMA] = ACTIONS(5868),
    [anon_sym_RPAREN] = ACTIONS(5868),
    [aux_sym_preproc_if_token2] = ACTIONS(5868),
    [aux_sym_preproc_else_token1] = ACTIONS(5868),
    [aux_sym_preproc_elif_token1] = ACTIONS(5866),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5868),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5868),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5866),
    [anon_sym_STAR] = ACTIONS(5866),
    [anon_sym_SLASH] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5866),
    [anon_sym_PIPE_PIPE] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_PIPE] = ACTIONS(5866),
    [anon_sym_CARET] = ACTIONS(5866),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_EQ_EQ] = ACTIONS(5868),
    [anon_sym_BANG_EQ] = ACTIONS(5868),
    [anon_sym_GT] = ACTIONS(5866),
    [anon_sym_GT_EQ] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5866),
    [anon_sym_LT] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5866),
    [anon_sym_GT_GT] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6474),
    [anon_sym_RBRACE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_RBRACK] = ACTIONS(5868),
    [anon_sym_EQ] = ACTIONS(5866),
    [anon_sym_QMARK] = ACTIONS(5868),
    [anon_sym_STAR_EQ] = ACTIONS(5868),
    [anon_sym_SLASH_EQ] = ACTIONS(5868),
    [anon_sym_PERCENT_EQ] = ACTIONS(5868),
    [anon_sym_PLUS_EQ] = ACTIONS(5868),
    [anon_sym_DASH_EQ] = ACTIONS(5868),
    [anon_sym_LT_LT_EQ] = ACTIONS(5868),
    [anon_sym_GT_GT_EQ] = ACTIONS(5868),
    [anon_sym_AMP_EQ] = ACTIONS(5868),
    [anon_sym_CARET_EQ] = ACTIONS(5868),
    [anon_sym_PIPE_EQ] = ACTIONS(5868),
    [anon_sym_and_eq] = ACTIONS(5866),
    [anon_sym_or_eq] = ACTIONS(5866),
    [anon_sym_xor_eq] = ACTIONS(5866),
    [anon_sym_LT_EQ_GT] = ACTIONS(5868),
    [anon_sym_or] = ACTIONS(5866),
    [anon_sym_and] = ACTIONS(5866),
    [anon_sym_bitor] = ACTIONS(5866),
    [anon_sym_xor] = ACTIONS(5866),
    [anon_sym_bitand] = ACTIONS(5866),
    [anon_sym_not_eq] = ACTIONS(5866),
    [anon_sym_DASH_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_PLUS] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5866),
    [anon_sym_DOT_STAR] = ACTIONS(5868),
    [anon_sym_DASH_GT] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
  },
  [2540] = {
    [sym_decltype_auto] = STATE(2569),
    [sym_identifier] = ACTIONS(5985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5987),
    [anon_sym_COMMA] = ACTIONS(5987),
    [anon_sym_RPAREN] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(5987),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5987),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5987),
    [anon_sym_PIPE_PIPE] = ACTIONS(5987),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5987),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_EQ_EQ] = ACTIONS(5987),
    [anon_sym_BANG_EQ] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5985),
    [anon_sym_GT_EQ] = ACTIONS(5987),
    [anon_sym_LT_EQ] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5985),
    [anon_sym_LT_LT] = ACTIONS(5987),
    [anon_sym_GT_GT] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SEMI] = ACTIONS(5987),
    [anon_sym___extension__] = ACTIONS(5985),
    [anon_sym___attribute__] = ACTIONS(5985),
    [anon_sym___attribute] = ACTIONS(5985),
    [anon_sym___based] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_RBRACE] = ACTIONS(5987),
    [anon_sym_signed] = ACTIONS(5985),
    [anon_sym_unsigned] = ACTIONS(5985),
    [anon_sym_long] = ACTIONS(5985),
    [anon_sym_short] = ACTIONS(5985),
    [anon_sym_LBRACK] = ACTIONS(5987),
    [anon_sym_RBRACK] = ACTIONS(5987),
    [anon_sym_const] = ACTIONS(5985),
    [anon_sym_constexpr] = ACTIONS(5985),
    [anon_sym_volatile] = ACTIONS(5985),
    [anon_sym_restrict] = ACTIONS(5985),
    [anon_sym___restrict__] = ACTIONS(5985),
    [anon_sym__Atomic] = ACTIONS(5985),
    [anon_sym__Noreturn] = ACTIONS(5985),
    [anon_sym_noreturn] = ACTIONS(5985),
    [anon_sym__Nonnull] = ACTIONS(5985),
    [anon_sym_mutable] = ACTIONS(5985),
    [anon_sym_constinit] = ACTIONS(5985),
    [anon_sym_consteval] = ACTIONS(5985),
    [anon_sym_alignas] = ACTIONS(5985),
    [anon_sym__Alignas] = ACTIONS(5985),
    [sym_primitive_type] = ACTIONS(5985),
    [anon_sym_QMARK] = ACTIONS(5987),
    [anon_sym_LT_EQ_GT] = ACTIONS(5987),
    [anon_sym_or] = ACTIONS(5985),
    [anon_sym_and] = ACTIONS(5985),
    [anon_sym_bitor] = ACTIONS(5985),
    [anon_sym_xor] = ACTIONS(5985),
    [anon_sym_bitand] = ACTIONS(5985),
    [anon_sym_not_eq] = ACTIONS(5985),
    [anon_sym_DASH_DASH] = ACTIONS(5987),
    [anon_sym_PLUS_PLUS] = ACTIONS(5987),
    [anon_sym_DOT] = ACTIONS(5985),
    [anon_sym_DOT_STAR] = ACTIONS(5987),
    [anon_sym_DASH_GT] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6476),
    [anon_sym_decltype] = ACTIONS(6478),
    [anon_sym_final] = ACTIONS(5985),
    [anon_sym_override] = ACTIONS(5985),
    [anon_sym_requires] = ACTIONS(5985),
  },
  [2541] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(2584),
    [sym__declarator] = STATE(6378),
    [sym__abstract_declarator] = STATE(6719),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(2962),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3253),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(2962),
    [aux_sym_pointer_declarator_repeat1] = STATE(2584),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6482),
    [anon_sym_RPAREN] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_AMP_AMP] = ACTIONS(6486),
    [anon_sym_AMP] = ACTIONS(6488),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6490),
    [anon_sym___attribute] = ACTIONS(6490),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_EQ] = ACTIONS(6482),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(6482),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2542] = {
    [sym_type_qualifier] = STATE(2546),
    [sym_alignas_qualifier] = STATE(2486),
    [aux_sym__type_definition_type_repeat1] = STATE(2546),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2633),
    [sym_identifier] = ACTIONS(6496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [aux_sym_preproc_if_token2] = ACTIONS(5729),
    [aux_sym_preproc_else_token1] = ACTIONS(5729),
    [aux_sym_preproc_elif_token1] = ACTIONS(5731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5729),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5729),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5729),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5729),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5729),
    [anon_sym_GT_GT] = ACTIONS(5729),
    [anon_sym___extension__] = ACTIONS(6499),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6501),
    [anon_sym_unsigned] = ACTIONS(6501),
    [anon_sym_long] = ACTIONS(6501),
    [anon_sym_short] = ACTIONS(6501),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_const] = ACTIONS(6499),
    [anon_sym_constexpr] = ACTIONS(6499),
    [anon_sym_volatile] = ACTIONS(6499),
    [anon_sym_restrict] = ACTIONS(6499),
    [anon_sym___restrict__] = ACTIONS(6499),
    [anon_sym__Atomic] = ACTIONS(6499),
    [anon_sym__Noreturn] = ACTIONS(6499),
    [anon_sym_noreturn] = ACTIONS(6499),
    [anon_sym__Nonnull] = ACTIONS(6499),
    [anon_sym_mutable] = ACTIONS(6499),
    [anon_sym_constinit] = ACTIONS(6499),
    [anon_sym_consteval] = ACTIONS(6499),
    [anon_sym_alignas] = ACTIONS(6503),
    [anon_sym__Alignas] = ACTIONS(6503),
    [sym_primitive_type] = ACTIONS(6505),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
  },
  [2543] = {
    [sym_identifier] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6081),
    [anon_sym_RPAREN] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6081),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_PERCENT] = ACTIONS(6081),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6081),
    [anon_sym_AMP] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6079),
    [anon_sym_GT_EQ] = ACTIONS(6081),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6079),
    [anon_sym_LT_LT] = ACTIONS(6081),
    [anon_sym_GT_GT] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6081),
    [anon_sym___extension__] = ACTIONS(6079),
    [anon_sym___attribute__] = ACTIONS(6079),
    [anon_sym___attribute] = ACTIONS(6079),
    [anon_sym___based] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6081),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_signed] = ACTIONS(6079),
    [anon_sym_unsigned] = ACTIONS(6079),
    [anon_sym_long] = ACTIONS(6079),
    [anon_sym_short] = ACTIONS(6079),
    [anon_sym_LBRACK] = ACTIONS(6081),
    [anon_sym_RBRACK] = ACTIONS(6081),
    [anon_sym_const] = ACTIONS(6079),
    [anon_sym_constexpr] = ACTIONS(6079),
    [anon_sym_volatile] = ACTIONS(6079),
    [anon_sym_restrict] = ACTIONS(6079),
    [anon_sym___restrict__] = ACTIONS(6079),
    [anon_sym__Atomic] = ACTIONS(6079),
    [anon_sym__Noreturn] = ACTIONS(6079),
    [anon_sym_noreturn] = ACTIONS(6079),
    [anon_sym__Nonnull] = ACTIONS(6079),
    [anon_sym_mutable] = ACTIONS(6079),
    [anon_sym_constinit] = ACTIONS(6079),
    [anon_sym_consteval] = ACTIONS(6079),
    [anon_sym_alignas] = ACTIONS(6079),
    [anon_sym__Alignas] = ACTIONS(6079),
    [sym_primitive_type] = ACTIONS(6079),
    [anon_sym_QMARK] = ACTIONS(6081),
    [anon_sym_LT_EQ_GT] = ACTIONS(6081),
    [anon_sym_or] = ACTIONS(6079),
    [anon_sym_and] = ACTIONS(6079),
    [anon_sym_bitor] = ACTIONS(6079),
    [anon_sym_xor] = ACTIONS(6079),
    [anon_sym_bitand] = ACTIONS(6079),
    [anon_sym_not_eq] = ACTIONS(6079),
    [anon_sym_DASH_DASH] = ACTIONS(6081),
    [anon_sym_PLUS_PLUS] = ACTIONS(6081),
    [anon_sym_DOT] = ACTIONS(6079),
    [anon_sym_DOT_STAR] = ACTIONS(6081),
    [anon_sym_DASH_GT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6079),
    [anon_sym_decltype] = ACTIONS(6079),
    [anon_sym_final] = ACTIONS(6079),
    [anon_sym_override] = ACTIONS(6079),
    [anon_sym_requires] = ACTIONS(6079),
  },
  [2544] = {
    [sym_identifier] = ACTIONS(6065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_LPAREN2] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6065),
    [anon_sym_PLUS] = ACTIONS(6065),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6065),
    [anon_sym_PERCENT] = ACTIONS(6067),
    [anon_sym_PIPE_PIPE] = ACTIONS(6067),
    [anon_sym_AMP_AMP] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_AMP] = ACTIONS(6065),
    [anon_sym_EQ_EQ] = ACTIONS(6067),
    [anon_sym_BANG_EQ] = ACTIONS(6067),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_GT_EQ] = ACTIONS(6067),
    [anon_sym_LT_EQ] = ACTIONS(6065),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_LT_LT] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(6067),
    [anon_sym_COLON] = ACTIONS(6067),
    [anon_sym_SEMI] = ACTIONS(6067),
    [anon_sym___extension__] = ACTIONS(6065),
    [anon_sym___attribute__] = ACTIONS(6065),
    [anon_sym___attribute] = ACTIONS(6065),
    [anon_sym___based] = ACTIONS(6065),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [anon_sym_signed] = ACTIONS(6065),
    [anon_sym_unsigned] = ACTIONS(6065),
    [anon_sym_long] = ACTIONS(6065),
    [anon_sym_short] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_const] = ACTIONS(6065),
    [anon_sym_constexpr] = ACTIONS(6065),
    [anon_sym_volatile] = ACTIONS(6065),
    [anon_sym_restrict] = ACTIONS(6065),
    [anon_sym___restrict__] = ACTIONS(6065),
    [anon_sym__Atomic] = ACTIONS(6065),
    [anon_sym__Noreturn] = ACTIONS(6065),
    [anon_sym_noreturn] = ACTIONS(6065),
    [anon_sym__Nonnull] = ACTIONS(6065),
    [anon_sym_mutable] = ACTIONS(6065),
    [anon_sym_constinit] = ACTIONS(6065),
    [anon_sym_consteval] = ACTIONS(6065),
    [anon_sym_alignas] = ACTIONS(6065),
    [anon_sym__Alignas] = ACTIONS(6065),
    [sym_primitive_type] = ACTIONS(6065),
    [anon_sym_QMARK] = ACTIONS(6067),
    [anon_sym_LT_EQ_GT] = ACTIONS(6067),
    [anon_sym_or] = ACTIONS(6065),
    [anon_sym_and] = ACTIONS(6065),
    [anon_sym_bitor] = ACTIONS(6065),
    [anon_sym_xor] = ACTIONS(6065),
    [anon_sym_bitand] = ACTIONS(6065),
    [anon_sym_not_eq] = ACTIONS(6065),
    [anon_sym_DASH_DASH] = ACTIONS(6067),
    [anon_sym_PLUS_PLUS] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(6065),
    [anon_sym_DOT_STAR] = ACTIONS(6067),
    [anon_sym_DASH_GT] = ACTIONS(6067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6065),
    [anon_sym_decltype] = ACTIONS(6065),
    [anon_sym_final] = ACTIONS(6065),
    [anon_sym_override] = ACTIONS(6065),
    [anon_sym_requires] = ACTIONS(6065),
  },
  [2545] = {
    [sym_identifier] = ACTIONS(6087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6089),
    [anon_sym_COMMA] = ACTIONS(6089),
    [anon_sym_RPAREN] = ACTIONS(6089),
    [anon_sym_LPAREN2] = ACTIONS(6089),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6089),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_PERCENT] = ACTIONS(6089),
    [anon_sym_PIPE_PIPE] = ACTIONS(6089),
    [anon_sym_AMP_AMP] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6089),
    [anon_sym_AMP] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6087),
    [anon_sym_GT_EQ] = ACTIONS(6089),
    [anon_sym_LT_EQ] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6087),
    [anon_sym_LT_LT] = ACTIONS(6089),
    [anon_sym_GT_GT] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SEMI] = ACTIONS(6089),
    [anon_sym___extension__] = ACTIONS(6087),
    [anon_sym___attribute__] = ACTIONS(6087),
    [anon_sym___attribute] = ACTIONS(6087),
    [anon_sym___based] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6089),
    [anon_sym_RBRACE] = ACTIONS(6089),
    [anon_sym_signed] = ACTIONS(6087),
    [anon_sym_unsigned] = ACTIONS(6087),
    [anon_sym_long] = ACTIONS(6087),
    [anon_sym_short] = ACTIONS(6087),
    [anon_sym_LBRACK] = ACTIONS(6089),
    [anon_sym_RBRACK] = ACTIONS(6089),
    [anon_sym_const] = ACTIONS(6087),
    [anon_sym_constexpr] = ACTIONS(6087),
    [anon_sym_volatile] = ACTIONS(6087),
    [anon_sym_restrict] = ACTIONS(6087),
    [anon_sym___restrict__] = ACTIONS(6087),
    [anon_sym__Atomic] = ACTIONS(6087),
    [anon_sym__Noreturn] = ACTIONS(6087),
    [anon_sym_noreturn] = ACTIONS(6087),
    [anon_sym__Nonnull] = ACTIONS(6087),
    [anon_sym_mutable] = ACTIONS(6087),
    [anon_sym_constinit] = ACTIONS(6087),
    [anon_sym_consteval] = ACTIONS(6087),
    [anon_sym_alignas] = ACTIONS(6087),
    [anon_sym__Alignas] = ACTIONS(6087),
    [sym_primitive_type] = ACTIONS(6087),
    [anon_sym_QMARK] = ACTIONS(6089),
    [anon_sym_LT_EQ_GT] = ACTIONS(6089),
    [anon_sym_or] = ACTIONS(6087),
    [anon_sym_and] = ACTIONS(6087),
    [anon_sym_bitor] = ACTIONS(6087),
    [anon_sym_xor] = ACTIONS(6087),
    [anon_sym_bitand] = ACTIONS(6087),
    [anon_sym_not_eq] = ACTIONS(6087),
    [anon_sym_DASH_DASH] = ACTIONS(6089),
    [anon_sym_PLUS_PLUS] = ACTIONS(6089),
    [anon_sym_DOT] = ACTIONS(6087),
    [anon_sym_DOT_STAR] = ACTIONS(6089),
    [anon_sym_DASH_GT] = ACTIONS(6089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6087),
    [anon_sym_decltype] = ACTIONS(6087),
    [anon_sym_final] = ACTIONS(6087),
    [anon_sym_override] = ACTIONS(6087),
    [anon_sym_requires] = ACTIONS(6087),
  },
  [2546] = {
    [sym_type_qualifier] = STATE(2435),
    [sym_alignas_qualifier] = STATE(2486),
    [aux_sym__type_definition_type_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3763),
    [sym_identifier] = ACTIONS(6507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [aux_sym_preproc_if_token2] = ACTIONS(5753),
    [aux_sym_preproc_else_token1] = ACTIONS(5753),
    [aux_sym_preproc_elif_token1] = ACTIONS(5755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5753),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5753),
    [anon_sym_GT_GT] = ACTIONS(5753),
    [anon_sym___extension__] = ACTIONS(6499),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(6510),
    [anon_sym_unsigned] = ACTIONS(6510),
    [anon_sym_long] = ACTIONS(6510),
    [anon_sym_short] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_const] = ACTIONS(6499),
    [anon_sym_constexpr] = ACTIONS(6499),
    [anon_sym_volatile] = ACTIONS(6499),
    [anon_sym_restrict] = ACTIONS(6499),
    [anon_sym___restrict__] = ACTIONS(6499),
    [anon_sym__Atomic] = ACTIONS(6499),
    [anon_sym__Noreturn] = ACTIONS(6499),
    [anon_sym_noreturn] = ACTIONS(6499),
    [anon_sym__Nonnull] = ACTIONS(6499),
    [anon_sym_mutable] = ACTIONS(6499),
    [anon_sym_constinit] = ACTIONS(6499),
    [anon_sym_consteval] = ACTIONS(6499),
    [anon_sym_alignas] = ACTIONS(6503),
    [anon_sym__Alignas] = ACTIONS(6503),
    [sym_primitive_type] = ACTIONS(6512),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
  },
  [2547] = {
    [sym_identifier] = ACTIONS(6141),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6143),
    [anon_sym_COMMA] = ACTIONS(6143),
    [anon_sym_RPAREN] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6141),
    [anon_sym_PLUS] = ACTIONS(6141),
    [anon_sym_STAR] = ACTIONS(6143),
    [anon_sym_SLASH] = ACTIONS(6141),
    [anon_sym_PERCENT] = ACTIONS(6143),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_PIPE] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6143),
    [anon_sym_AMP] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6143),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_GT] = ACTIONS(6141),
    [anon_sym_GT_EQ] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6141),
    [anon_sym_LT] = ACTIONS(6141),
    [anon_sym_LT_LT] = ACTIONS(6143),
    [anon_sym_GT_GT] = ACTIONS(6143),
    [anon_sym_COLON] = ACTIONS(6143),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym___extension__] = ACTIONS(6141),
    [anon_sym___attribute__] = ACTIONS(6141),
    [anon_sym___attribute] = ACTIONS(6141),
    [anon_sym___based] = ACTIONS(6141),
    [anon_sym_LBRACE] = ACTIONS(6143),
    [anon_sym_RBRACE] = ACTIONS(6143),
    [anon_sym_signed] = ACTIONS(6141),
    [anon_sym_unsigned] = ACTIONS(6141),
    [anon_sym_long] = ACTIONS(6141),
    [anon_sym_short] = ACTIONS(6141),
    [anon_sym_LBRACK] = ACTIONS(6143),
    [anon_sym_RBRACK] = ACTIONS(6143),
    [anon_sym_const] = ACTIONS(6141),
    [anon_sym_constexpr] = ACTIONS(6141),
    [anon_sym_volatile] = ACTIONS(6141),
    [anon_sym_restrict] = ACTIONS(6141),
    [anon_sym___restrict__] = ACTIONS(6141),
    [anon_sym__Atomic] = ACTIONS(6141),
    [anon_sym__Noreturn] = ACTIONS(6141),
    [anon_sym_noreturn] = ACTIONS(6141),
    [anon_sym__Nonnull] = ACTIONS(6141),
    [anon_sym_mutable] = ACTIONS(6141),
    [anon_sym_constinit] = ACTIONS(6141),
    [anon_sym_consteval] = ACTIONS(6141),
    [anon_sym_alignas] = ACTIONS(6141),
    [anon_sym__Alignas] = ACTIONS(6141),
    [sym_primitive_type] = ACTIONS(6141),
    [anon_sym_QMARK] = ACTIONS(6143),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_or] = ACTIONS(6141),
    [anon_sym_and] = ACTIONS(6141),
    [anon_sym_bitor] = ACTIONS(6141),
    [anon_sym_xor] = ACTIONS(6141),
    [anon_sym_bitand] = ACTIONS(6141),
    [anon_sym_not_eq] = ACTIONS(6141),
    [anon_sym_DASH_DASH] = ACTIONS(6143),
    [anon_sym_PLUS_PLUS] = ACTIONS(6143),
    [anon_sym_DOT] = ACTIONS(6141),
    [anon_sym_DOT_STAR] = ACTIONS(6143),
    [anon_sym_DASH_GT] = ACTIONS(6143),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6141),
    [anon_sym_decltype] = ACTIONS(6141),
    [anon_sym_final] = ACTIONS(6141),
    [anon_sym_override] = ACTIONS(6141),
    [anon_sym_requires] = ACTIONS(6141),
  },
  [2548] = {
    [sym_identifier] = ACTIONS(6121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6123),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6123),
    [anon_sym_PIPE_PIPE] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6123),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_EQ_EQ] = ACTIONS(6123),
    [anon_sym_BANG_EQ] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6121),
    [anon_sym_GT_EQ] = ACTIONS(6123),
    [anon_sym_LT_EQ] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_LT_LT] = ACTIONS(6123),
    [anon_sym_GT_GT] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___extension__] = ACTIONS(6121),
    [anon_sym___attribute__] = ACTIONS(6121),
    [anon_sym___attribute] = ACTIONS(6121),
    [anon_sym___based] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(6123),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_signed] = ACTIONS(6121),
    [anon_sym_unsigned] = ACTIONS(6121),
    [anon_sym_long] = ACTIONS(6121),
    [anon_sym_short] = ACTIONS(6121),
    [anon_sym_LBRACK] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6123),
    [anon_sym_const] = ACTIONS(6121),
    [anon_sym_constexpr] = ACTIONS(6121),
    [anon_sym_volatile] = ACTIONS(6121),
    [anon_sym_restrict] = ACTIONS(6121),
    [anon_sym___restrict__] = ACTIONS(6121),
    [anon_sym__Atomic] = ACTIONS(6121),
    [anon_sym__Noreturn] = ACTIONS(6121),
    [anon_sym_noreturn] = ACTIONS(6121),
    [anon_sym__Nonnull] = ACTIONS(6121),
    [anon_sym_mutable] = ACTIONS(6121),
    [anon_sym_constinit] = ACTIONS(6121),
    [anon_sym_consteval] = ACTIONS(6121),
    [anon_sym_alignas] = ACTIONS(6121),
    [anon_sym__Alignas] = ACTIONS(6121),
    [sym_primitive_type] = ACTIONS(6121),
    [anon_sym_QMARK] = ACTIONS(6123),
    [anon_sym_LT_EQ_GT] = ACTIONS(6123),
    [anon_sym_or] = ACTIONS(6121),
    [anon_sym_and] = ACTIONS(6121),
    [anon_sym_bitor] = ACTIONS(6121),
    [anon_sym_xor] = ACTIONS(6121),
    [anon_sym_bitand] = ACTIONS(6121),
    [anon_sym_not_eq] = ACTIONS(6121),
    [anon_sym_DASH_DASH] = ACTIONS(6123),
    [anon_sym_PLUS_PLUS] = ACTIONS(6123),
    [anon_sym_DOT] = ACTIONS(6121),
    [anon_sym_DOT_STAR] = ACTIONS(6123),
    [anon_sym_DASH_GT] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6121),
    [anon_sym_decltype] = ACTIONS(6121),
    [anon_sym_final] = ACTIONS(6121),
    [anon_sym_override] = ACTIONS(6121),
    [anon_sym_requires] = ACTIONS(6121),
  },
  [2549] = {
    [sym_identifier] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_RPAREN] = ACTIONS(6035),
    [anon_sym_LPAREN2] = ACTIONS(6035),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_PLUS] = ACTIONS(6033),
    [anon_sym_STAR] = ACTIONS(6035),
    [anon_sym_SLASH] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6035),
    [anon_sym_PIPE_PIPE] = ACTIONS(6035),
    [anon_sym_AMP_AMP] = ACTIONS(6035),
    [anon_sym_PIPE] = ACTIONS(6033),
    [anon_sym_CARET] = ACTIONS(6035),
    [anon_sym_AMP] = ACTIONS(6033),
    [anon_sym_EQ_EQ] = ACTIONS(6035),
    [anon_sym_BANG_EQ] = ACTIONS(6035),
    [anon_sym_GT] = ACTIONS(6033),
    [anon_sym_GT_EQ] = ACTIONS(6035),
    [anon_sym_LT_EQ] = ACTIONS(6033),
    [anon_sym_LT] = ACTIONS(6033),
    [anon_sym_LT_LT] = ACTIONS(6035),
    [anon_sym_GT_GT] = ACTIONS(6035),
    [anon_sym_COLON] = ACTIONS(6035),
    [anon_sym_SEMI] = ACTIONS(6035),
    [anon_sym___extension__] = ACTIONS(6033),
    [anon_sym___attribute__] = ACTIONS(6033),
    [anon_sym___attribute] = ACTIONS(6033),
    [anon_sym___based] = ACTIONS(6033),
    [anon_sym_LBRACE] = ACTIONS(6035),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_signed] = ACTIONS(6033),
    [anon_sym_unsigned] = ACTIONS(6033),
    [anon_sym_long] = ACTIONS(6033),
    [anon_sym_short] = ACTIONS(6033),
    [anon_sym_LBRACK] = ACTIONS(6035),
    [anon_sym_RBRACK] = ACTIONS(6035),
    [anon_sym_const] = ACTIONS(6033),
    [anon_sym_constexpr] = ACTIONS(6033),
    [anon_sym_volatile] = ACTIONS(6033),
    [anon_sym_restrict] = ACTIONS(6033),
    [anon_sym___restrict__] = ACTIONS(6033),
    [anon_sym__Atomic] = ACTIONS(6033),
    [anon_sym__Noreturn] = ACTIONS(6033),
    [anon_sym_noreturn] = ACTIONS(6033),
    [anon_sym__Nonnull] = ACTIONS(6033),
    [anon_sym_mutable] = ACTIONS(6033),
    [anon_sym_constinit] = ACTIONS(6033),
    [anon_sym_consteval] = ACTIONS(6033),
    [anon_sym_alignas] = ACTIONS(6033),
    [anon_sym__Alignas] = ACTIONS(6033),
    [sym_primitive_type] = ACTIONS(6033),
    [anon_sym_QMARK] = ACTIONS(6035),
    [anon_sym_LT_EQ_GT] = ACTIONS(6035),
    [anon_sym_or] = ACTIONS(6033),
    [anon_sym_and] = ACTIONS(6033),
    [anon_sym_bitor] = ACTIONS(6033),
    [anon_sym_xor] = ACTIONS(6033),
    [anon_sym_bitand] = ACTIONS(6033),
    [anon_sym_not_eq] = ACTIONS(6033),
    [anon_sym_DASH_DASH] = ACTIONS(6035),
    [anon_sym_PLUS_PLUS] = ACTIONS(6035),
    [anon_sym_DOT] = ACTIONS(6033),
    [anon_sym_DOT_STAR] = ACTIONS(6035),
    [anon_sym_DASH_GT] = ACTIONS(6035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6033),
    [anon_sym_decltype] = ACTIONS(6033),
    [anon_sym_final] = ACTIONS(6033),
    [anon_sym_override] = ACTIONS(6033),
    [anon_sym_requires] = ACTIONS(6033),
  },
  [2550] = {
    [sym_identifier] = ACTIONS(6075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_LPAREN2] = ACTIONS(6077),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6077),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6077),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6077),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_LT_LT] = ACTIONS(6077),
    [anon_sym_GT_GT] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym___extension__] = ACTIONS(6075),
    [anon_sym___attribute__] = ACTIONS(6075),
    [anon_sym___attribute] = ACTIONS(6075),
    [anon_sym___based] = ACTIONS(6075),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_signed] = ACTIONS(6075),
    [anon_sym_unsigned] = ACTIONS(6075),
    [anon_sym_long] = ACTIONS(6075),
    [anon_sym_short] = ACTIONS(6075),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_const] = ACTIONS(6075),
    [anon_sym_constexpr] = ACTIONS(6075),
    [anon_sym_volatile] = ACTIONS(6075),
    [anon_sym_restrict] = ACTIONS(6075),
    [anon_sym___restrict__] = ACTIONS(6075),
    [anon_sym__Atomic] = ACTIONS(6075),
    [anon_sym__Noreturn] = ACTIONS(6075),
    [anon_sym_noreturn] = ACTIONS(6075),
    [anon_sym__Nonnull] = ACTIONS(6075),
    [anon_sym_mutable] = ACTIONS(6075),
    [anon_sym_constinit] = ACTIONS(6075),
    [anon_sym_consteval] = ACTIONS(6075),
    [anon_sym_alignas] = ACTIONS(6075),
    [anon_sym__Alignas] = ACTIONS(6075),
    [sym_primitive_type] = ACTIONS(6075),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6075),
    [anon_sym_bitor] = ACTIONS(6075),
    [anon_sym_xor] = ACTIONS(6075),
    [anon_sym_bitand] = ACTIONS(6075),
    [anon_sym_not_eq] = ACTIONS(6075),
    [anon_sym_DASH_DASH] = ACTIONS(6077),
    [anon_sym_PLUS_PLUS] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_DOT_STAR] = ACTIONS(6077),
    [anon_sym_DASH_GT] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6075),
    [anon_sym_decltype] = ACTIONS(6075),
    [anon_sym_final] = ACTIONS(6075),
    [anon_sym_override] = ACTIONS(6075),
    [anon_sym_requires] = ACTIONS(6075),
  },
  [2551] = {
    [sym_identifier] = ACTIONS(6133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [anon_sym_LPAREN2] = ACTIONS(6135),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6135),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6135),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6135),
    [anon_sym_AMP] = ACTIONS(6133),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_LT] = ACTIONS(6135),
    [anon_sym_GT_GT] = ACTIONS(6135),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym___extension__] = ACTIONS(6133),
    [anon_sym___attribute__] = ACTIONS(6133),
    [anon_sym___attribute] = ACTIONS(6133),
    [anon_sym___based] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_signed] = ACTIONS(6133),
    [anon_sym_unsigned] = ACTIONS(6133),
    [anon_sym_long] = ACTIONS(6133),
    [anon_sym_short] = ACTIONS(6133),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_const] = ACTIONS(6133),
    [anon_sym_constexpr] = ACTIONS(6133),
    [anon_sym_volatile] = ACTIONS(6133),
    [anon_sym_restrict] = ACTIONS(6133),
    [anon_sym___restrict__] = ACTIONS(6133),
    [anon_sym__Atomic] = ACTIONS(6133),
    [anon_sym__Noreturn] = ACTIONS(6133),
    [anon_sym_noreturn] = ACTIONS(6133),
    [anon_sym__Nonnull] = ACTIONS(6133),
    [anon_sym_mutable] = ACTIONS(6133),
    [anon_sym_constinit] = ACTIONS(6133),
    [anon_sym_consteval] = ACTIONS(6133),
    [anon_sym_alignas] = ACTIONS(6133),
    [anon_sym__Alignas] = ACTIONS(6133),
    [sym_primitive_type] = ACTIONS(6133),
    [anon_sym_QMARK] = ACTIONS(6135),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6133),
    [anon_sym_bitor] = ACTIONS(6133),
    [anon_sym_xor] = ACTIONS(6133),
    [anon_sym_bitand] = ACTIONS(6133),
    [anon_sym_not_eq] = ACTIONS(6133),
    [anon_sym_DASH_DASH] = ACTIONS(6135),
    [anon_sym_PLUS_PLUS] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(6133),
    [anon_sym_DOT_STAR] = ACTIONS(6135),
    [anon_sym_DASH_GT] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6133),
    [anon_sym_decltype] = ACTIONS(6133),
    [anon_sym_final] = ACTIONS(6133),
    [anon_sym_override] = ACTIONS(6133),
    [anon_sym_requires] = ACTIONS(6133),
  },
  [2552] = {
    [sym_identifier] = ACTIONS(6107),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LPAREN2] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6107),
    [anon_sym_PLUS] = ACTIONS(6107),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6107),
    [anon_sym_PERCENT] = ACTIONS(6109),
    [anon_sym_PIPE_PIPE] = ACTIONS(6109),
    [anon_sym_AMP_AMP] = ACTIONS(6109),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT] = ACTIONS(6107),
    [anon_sym_GT_EQ] = ACTIONS(6109),
    [anon_sym_LT_EQ] = ACTIONS(6107),
    [anon_sym_LT] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6109),
    [anon_sym_GT_GT] = ACTIONS(6109),
    [anon_sym_COLON] = ACTIONS(6109),
    [anon_sym_SEMI] = ACTIONS(6109),
    [anon_sym___extension__] = ACTIONS(6107),
    [anon_sym___attribute__] = ACTIONS(6107),
    [anon_sym___attribute] = ACTIONS(6107),
    [anon_sym___based] = ACTIONS(6107),
    [anon_sym_LBRACE] = ACTIONS(6109),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [anon_sym_signed] = ACTIONS(6107),
    [anon_sym_unsigned] = ACTIONS(6107),
    [anon_sym_long] = ACTIONS(6107),
    [anon_sym_short] = ACTIONS(6107),
    [anon_sym_LBRACK] = ACTIONS(6109),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_const] = ACTIONS(6107),
    [anon_sym_constexpr] = ACTIONS(6107),
    [anon_sym_volatile] = ACTIONS(6107),
    [anon_sym_restrict] = ACTIONS(6107),
    [anon_sym___restrict__] = ACTIONS(6107),
    [anon_sym__Atomic] = ACTIONS(6107),
    [anon_sym__Noreturn] = ACTIONS(6107),
    [anon_sym_noreturn] = ACTIONS(6107),
    [anon_sym__Nonnull] = ACTIONS(6107),
    [anon_sym_mutable] = ACTIONS(6107),
    [anon_sym_constinit] = ACTIONS(6107),
    [anon_sym_consteval] = ACTIONS(6107),
    [anon_sym_alignas] = ACTIONS(6107),
    [anon_sym__Alignas] = ACTIONS(6107),
    [sym_primitive_type] = ACTIONS(6107),
    [anon_sym_QMARK] = ACTIONS(6109),
    [anon_sym_LT_EQ_GT] = ACTIONS(6109),
    [anon_sym_or] = ACTIONS(6107),
    [anon_sym_and] = ACTIONS(6107),
    [anon_sym_bitor] = ACTIONS(6107),
    [anon_sym_xor] = ACTIONS(6107),
    [anon_sym_bitand] = ACTIONS(6107),
    [anon_sym_not_eq] = ACTIONS(6107),
    [anon_sym_DASH_DASH] = ACTIONS(6109),
    [anon_sym_PLUS_PLUS] = ACTIONS(6109),
    [anon_sym_DOT] = ACTIONS(6107),
    [anon_sym_DOT_STAR] = ACTIONS(6109),
    [anon_sym_DASH_GT] = ACTIONS(6109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6107),
    [anon_sym_decltype] = ACTIONS(6107),
    [anon_sym_final] = ACTIONS(6107),
    [anon_sym_override] = ACTIONS(6107),
    [anon_sym_requires] = ACTIONS(6107),
  },
  [2553] = {
    [sym_identifier] = ACTIONS(6041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6043),
    [anon_sym_COMMA] = ACTIONS(6043),
    [anon_sym_RPAREN] = ACTIONS(6043),
    [anon_sym_LPAREN2] = ACTIONS(6043),
    [anon_sym_DASH] = ACTIONS(6041),
    [anon_sym_PLUS] = ACTIONS(6041),
    [anon_sym_STAR] = ACTIONS(6043),
    [anon_sym_SLASH] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6043),
    [anon_sym_PIPE_PIPE] = ACTIONS(6043),
    [anon_sym_AMP_AMP] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6041),
    [anon_sym_CARET] = ACTIONS(6043),
    [anon_sym_AMP] = ACTIONS(6041),
    [anon_sym_EQ_EQ] = ACTIONS(6043),
    [anon_sym_BANG_EQ] = ACTIONS(6043),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_LT_LT] = ACTIONS(6043),
    [anon_sym_GT_GT] = ACTIONS(6043),
    [anon_sym_COLON] = ACTIONS(6043),
    [anon_sym_SEMI] = ACTIONS(6043),
    [anon_sym___extension__] = ACTIONS(6041),
    [anon_sym___attribute__] = ACTIONS(6041),
    [anon_sym___attribute] = ACTIONS(6041),
    [anon_sym___based] = ACTIONS(6041),
    [anon_sym_LBRACE] = ACTIONS(6043),
    [anon_sym_RBRACE] = ACTIONS(6043),
    [anon_sym_signed] = ACTIONS(6041),
    [anon_sym_unsigned] = ACTIONS(6041),
    [anon_sym_long] = ACTIONS(6041),
    [anon_sym_short] = ACTIONS(6041),
    [anon_sym_LBRACK] = ACTIONS(6043),
    [anon_sym_RBRACK] = ACTIONS(6043),
    [anon_sym_const] = ACTIONS(6041),
    [anon_sym_constexpr] = ACTIONS(6041),
    [anon_sym_volatile] = ACTIONS(6041),
    [anon_sym_restrict] = ACTIONS(6041),
    [anon_sym___restrict__] = ACTIONS(6041),
    [anon_sym__Atomic] = ACTIONS(6041),
    [anon_sym__Noreturn] = ACTIONS(6041),
    [anon_sym_noreturn] = ACTIONS(6041),
    [anon_sym__Nonnull] = ACTIONS(6041),
    [anon_sym_mutable] = ACTIONS(6041),
    [anon_sym_constinit] = ACTIONS(6041),
    [anon_sym_consteval] = ACTIONS(6041),
    [anon_sym_alignas] = ACTIONS(6041),
    [anon_sym__Alignas] = ACTIONS(6041),
    [sym_primitive_type] = ACTIONS(6041),
    [anon_sym_QMARK] = ACTIONS(6043),
    [anon_sym_LT_EQ_GT] = ACTIONS(6043),
    [anon_sym_or] = ACTIONS(6041),
    [anon_sym_and] = ACTIONS(6041),
    [anon_sym_bitor] = ACTIONS(6041),
    [anon_sym_xor] = ACTIONS(6041),
    [anon_sym_bitand] = ACTIONS(6041),
    [anon_sym_not_eq] = ACTIONS(6041),
    [anon_sym_DASH_DASH] = ACTIONS(6043),
    [anon_sym_PLUS_PLUS] = ACTIONS(6043),
    [anon_sym_DOT] = ACTIONS(6041),
    [anon_sym_DOT_STAR] = ACTIONS(6043),
    [anon_sym_DASH_GT] = ACTIONS(6043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6041),
    [anon_sym_decltype] = ACTIONS(6041),
    [anon_sym_final] = ACTIONS(6041),
    [anon_sym_override] = ACTIONS(6041),
    [anon_sym_requires] = ACTIONS(6041),
  },
  [2554] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [sym_identifier] = ACTIONS(4225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [aux_sym_preproc_if_token2] = ACTIONS(4217),
    [aux_sym_preproc_else_token1] = ACTIONS(4217),
    [aux_sym_preproc_elif_token1] = ACTIONS(4225),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6519),
    [anon_sym_SLASH_EQ] = ACTIONS(6519),
    [anon_sym_PERCENT_EQ] = ACTIONS(6519),
    [anon_sym_PLUS_EQ] = ACTIONS(6519),
    [anon_sym_DASH_EQ] = ACTIONS(6519),
    [anon_sym_LT_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT_GT_EQ] = ACTIONS(6519),
    [anon_sym_AMP_EQ] = ACTIONS(6519),
    [anon_sym_CARET_EQ] = ACTIONS(6519),
    [anon_sym_PIPE_EQ] = ACTIONS(6519),
    [anon_sym_and_eq] = ACTIONS(6517),
    [anon_sym_or_eq] = ACTIONS(6517),
    [anon_sym_xor_eq] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4225),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4225),
    [anon_sym_not_eq] = ACTIONS(4225),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2555] = {
    [sym_identifier] = ACTIONS(6029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6031),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_RPAREN] = ACTIONS(6031),
    [anon_sym_LPAREN2] = ACTIONS(6031),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6031),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_PERCENT] = ACTIONS(6031),
    [anon_sym_PIPE_PIPE] = ACTIONS(6031),
    [anon_sym_AMP_AMP] = ACTIONS(6031),
    [anon_sym_PIPE] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6031),
    [anon_sym_AMP] = ACTIONS(6029),
    [anon_sym_EQ_EQ] = ACTIONS(6031),
    [anon_sym_BANG_EQ] = ACTIONS(6031),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6031),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_LT_LT] = ACTIONS(6031),
    [anon_sym_GT_GT] = ACTIONS(6031),
    [anon_sym_COLON] = ACTIONS(6031),
    [anon_sym_SEMI] = ACTIONS(6031),
    [anon_sym___extension__] = ACTIONS(6029),
    [anon_sym___attribute__] = ACTIONS(6029),
    [anon_sym___attribute] = ACTIONS(6029),
    [anon_sym___based] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6031),
    [anon_sym_RBRACE] = ACTIONS(6031),
    [anon_sym_signed] = ACTIONS(6029),
    [anon_sym_unsigned] = ACTIONS(6029),
    [anon_sym_long] = ACTIONS(6029),
    [anon_sym_short] = ACTIONS(6029),
    [anon_sym_LBRACK] = ACTIONS(6031),
    [anon_sym_RBRACK] = ACTIONS(6031),
    [anon_sym_const] = ACTIONS(6029),
    [anon_sym_constexpr] = ACTIONS(6029),
    [anon_sym_volatile] = ACTIONS(6029),
    [anon_sym_restrict] = ACTIONS(6029),
    [anon_sym___restrict__] = ACTIONS(6029),
    [anon_sym__Atomic] = ACTIONS(6029),
    [anon_sym__Noreturn] = ACTIONS(6029),
    [anon_sym_noreturn] = ACTIONS(6029),
    [anon_sym__Nonnull] = ACTIONS(6029),
    [anon_sym_mutable] = ACTIONS(6029),
    [anon_sym_constinit] = ACTIONS(6029),
    [anon_sym_consteval] = ACTIONS(6029),
    [anon_sym_alignas] = ACTIONS(6029),
    [anon_sym__Alignas] = ACTIONS(6029),
    [sym_primitive_type] = ACTIONS(6029),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_LT_EQ_GT] = ACTIONS(6031),
    [anon_sym_or] = ACTIONS(6029),
    [anon_sym_and] = ACTIONS(6029),
    [anon_sym_bitor] = ACTIONS(6029),
    [anon_sym_xor] = ACTIONS(6029),
    [anon_sym_bitand] = ACTIONS(6029),
    [anon_sym_not_eq] = ACTIONS(6029),
    [anon_sym_DASH_DASH] = ACTIONS(6031),
    [anon_sym_PLUS_PLUS] = ACTIONS(6031),
    [anon_sym_DOT] = ACTIONS(6029),
    [anon_sym_DOT_STAR] = ACTIONS(6031),
    [anon_sym_DASH_GT] = ACTIONS(6031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6029),
    [anon_sym_decltype] = ACTIONS(6029),
    [anon_sym_final] = ACTIONS(6029),
    [anon_sym_override] = ACTIONS(6029),
    [anon_sym_requires] = ACTIONS(6029),
  },
  [2556] = {
    [sym_identifier] = ACTIONS(6111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6113),
    [anon_sym_COMMA] = ACTIONS(6113),
    [anon_sym_RPAREN] = ACTIONS(6113),
    [anon_sym_LPAREN2] = ACTIONS(6113),
    [anon_sym_DASH] = ACTIONS(6111),
    [anon_sym_PLUS] = ACTIONS(6111),
    [anon_sym_STAR] = ACTIONS(6113),
    [anon_sym_SLASH] = ACTIONS(6111),
    [anon_sym_PERCENT] = ACTIONS(6113),
    [anon_sym_PIPE_PIPE] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_CARET] = ACTIONS(6113),
    [anon_sym_AMP] = ACTIONS(6111),
    [anon_sym_EQ_EQ] = ACTIONS(6113),
    [anon_sym_BANG_EQ] = ACTIONS(6113),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_GT_EQ] = ACTIONS(6113),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_LT_LT] = ACTIONS(6113),
    [anon_sym_GT_GT] = ACTIONS(6113),
    [anon_sym_COLON] = ACTIONS(6113),
    [anon_sym_SEMI] = ACTIONS(6113),
    [anon_sym___extension__] = ACTIONS(6111),
    [anon_sym___attribute__] = ACTIONS(6111),
    [anon_sym___attribute] = ACTIONS(6111),
    [anon_sym___based] = ACTIONS(6111),
    [anon_sym_LBRACE] = ACTIONS(6113),
    [anon_sym_RBRACE] = ACTIONS(6113),
    [anon_sym_signed] = ACTIONS(6111),
    [anon_sym_unsigned] = ACTIONS(6111),
    [anon_sym_long] = ACTIONS(6111),
    [anon_sym_short] = ACTIONS(6111),
    [anon_sym_LBRACK] = ACTIONS(6113),
    [anon_sym_RBRACK] = ACTIONS(6113),
    [anon_sym_const] = ACTIONS(6111),
    [anon_sym_constexpr] = ACTIONS(6111),
    [anon_sym_volatile] = ACTIONS(6111),
    [anon_sym_restrict] = ACTIONS(6111),
    [anon_sym___restrict__] = ACTIONS(6111),
    [anon_sym__Atomic] = ACTIONS(6111),
    [anon_sym__Noreturn] = ACTIONS(6111),
    [anon_sym_noreturn] = ACTIONS(6111),
    [anon_sym__Nonnull] = ACTIONS(6111),
    [anon_sym_mutable] = ACTIONS(6111),
    [anon_sym_constinit] = ACTIONS(6111),
    [anon_sym_consteval] = ACTIONS(6111),
    [anon_sym_alignas] = ACTIONS(6111),
    [anon_sym__Alignas] = ACTIONS(6111),
    [sym_primitive_type] = ACTIONS(6111),
    [anon_sym_QMARK] = ACTIONS(6113),
    [anon_sym_LT_EQ_GT] = ACTIONS(6113),
    [anon_sym_or] = ACTIONS(6111),
    [anon_sym_and] = ACTIONS(6111),
    [anon_sym_bitor] = ACTIONS(6111),
    [anon_sym_xor] = ACTIONS(6111),
    [anon_sym_bitand] = ACTIONS(6111),
    [anon_sym_not_eq] = ACTIONS(6111),
    [anon_sym_DASH_DASH] = ACTIONS(6113),
    [anon_sym_PLUS_PLUS] = ACTIONS(6113),
    [anon_sym_DOT] = ACTIONS(6111),
    [anon_sym_DOT_STAR] = ACTIONS(6113),
    [anon_sym_DASH_GT] = ACTIONS(6113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6111),
    [anon_sym_decltype] = ACTIONS(6111),
    [anon_sym_final] = ACTIONS(6111),
    [anon_sym_override] = ACTIONS(6111),
    [anon_sym_requires] = ACTIONS(6111),
  },
  [2557] = {
    [sym_type_qualifier] = STATE(2562),
    [sym_alignas_qualifier] = STATE(2486),
    [aux_sym__type_definition_type_repeat1] = STATE(2562),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2650),
    [sym_identifier] = ACTIONS(6521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_RPAREN] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5729),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5729),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5729),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5729),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5729),
    [anon_sym_GT_GT] = ACTIONS(5729),
    [anon_sym_COLON] = ACTIONS(5729),
    [anon_sym_SEMI] = ACTIONS(5729),
    [anon_sym___extension__] = ACTIONS(6499),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_RBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6523),
    [anon_sym_unsigned] = ACTIONS(6523),
    [anon_sym_long] = ACTIONS(6523),
    [anon_sym_short] = ACTIONS(6523),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [anon_sym_const] = ACTIONS(6499),
    [anon_sym_constexpr] = ACTIONS(6499),
    [anon_sym_volatile] = ACTIONS(6499),
    [anon_sym_restrict] = ACTIONS(6499),
    [anon_sym___restrict__] = ACTIONS(6499),
    [anon_sym__Atomic] = ACTIONS(6499),
    [anon_sym__Noreturn] = ACTIONS(6499),
    [anon_sym_noreturn] = ACTIONS(6499),
    [anon_sym__Nonnull] = ACTIONS(6499),
    [anon_sym_mutable] = ACTIONS(6499),
    [anon_sym_constinit] = ACTIONS(6499),
    [anon_sym_consteval] = ACTIONS(6499),
    [anon_sym_alignas] = ACTIONS(6503),
    [anon_sym__Alignas] = ACTIONS(6503),
    [sym_primitive_type] = ACTIONS(6525),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
  },
  [2558] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2274),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym___extension__] = ACTIONS(5872),
    [anon_sym_in] = ACTIONS(5872),
    [anon_sym_out] = ACTIONS(5872),
    [anon_sym_inout] = ACTIONS(5872),
    [anon_sym_virtual] = ACTIONS(5872),
    [anon_sym_extern] = ACTIONS(5872),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5875),
    [anon_sym___declspec] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(5747),
    [anon_sym_unsigned] = ACTIONS(5747),
    [anon_sym_long] = ACTIONS(5747),
    [anon_sym_short] = ACTIONS(5747),
    [anon_sym_LBRACK] = ACTIONS(5872),
    [anon_sym_static] = ACTIONS(5872),
    [anon_sym_register] = ACTIONS(5872),
    [anon_sym_inline] = ACTIONS(5872),
    [anon_sym___inline] = ACTIONS(5872),
    [anon_sym___inline__] = ACTIONS(5872),
    [anon_sym___forceinline] = ACTIONS(5872),
    [anon_sym_thread_local] = ACTIONS(5872),
    [anon_sym___thread] = ACTIONS(5872),
    [anon_sym_const] = ACTIONS(5872),
    [anon_sym_constexpr] = ACTIONS(5872),
    [anon_sym_volatile] = ACTIONS(5872),
    [anon_sym_restrict] = ACTIONS(5872),
    [anon_sym___restrict__] = ACTIONS(5872),
    [anon_sym__Atomic] = ACTIONS(5872),
    [anon_sym__Noreturn] = ACTIONS(5872),
    [anon_sym_noreturn] = ACTIONS(5872),
    [anon_sym__Nonnull] = ACTIONS(5872),
    [anon_sym_mutable] = ACTIONS(5872),
    [anon_sym_constinit] = ACTIONS(5872),
    [anon_sym_consteval] = ACTIONS(5872),
    [anon_sym_alignas] = ACTIONS(5872),
    [anon_sym__Alignas] = ACTIONS(5872),
    [sym_primitive_type] = ACTIONS(5743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
    [anon_sym_final] = ACTIONS(5872),
    [anon_sym_override] = ACTIONS(5872),
    [anon_sym_requires] = ACTIONS(5872),
    [anon_sym_precise] = ACTIONS(5872),
    [anon_sym_shared] = ACTIONS(5872),
    [anon_sym_groupshared] = ACTIONS(5872),
    [anon_sym_uniform] = ACTIONS(5872),
    [anon_sym_row_major] = ACTIONS(5872),
    [anon_sym_column_major] = ACTIONS(5872),
    [anon_sym_globallycoherent] = ACTIONS(5872),
    [anon_sym_centroid] = ACTIONS(5872),
    [anon_sym_noperspective] = ACTIONS(5872),
    [anon_sym_nointerpolation] = ACTIONS(5872),
    [anon_sym_sample] = ACTIONS(5872),
    [anon_sym_linear] = ACTIONS(5872),
    [anon_sym_snorm] = ACTIONS(5872),
    [anon_sym_unorm] = ACTIONS(5872),
    [anon_sym_point] = ACTIONS(5872),
    [anon_sym_line] = ACTIONS(5872),
    [anon_sym_triangleadj] = ACTIONS(5872),
    [anon_sym_lineadj] = ACTIONS(5872),
    [anon_sym_triangle] = ACTIONS(5872),
  },
  [2559] = {
    [sym_identifier] = ACTIONS(5902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym___based] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(5902),
    [anon_sym_unsigned] = ACTIONS(5902),
    [anon_sym_long] = ACTIONS(5902),
    [anon_sym_short] = ACTIONS(5902),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_const] = ACTIONS(5902),
    [anon_sym_constexpr] = ACTIONS(5902),
    [anon_sym_volatile] = ACTIONS(5902),
    [anon_sym_restrict] = ACTIONS(5902),
    [anon_sym___restrict__] = ACTIONS(5902),
    [anon_sym__Atomic] = ACTIONS(5902),
    [anon_sym__Noreturn] = ACTIONS(5902),
    [anon_sym_noreturn] = ACTIONS(5902),
    [anon_sym__Nonnull] = ACTIONS(5902),
    [anon_sym_mutable] = ACTIONS(5902),
    [anon_sym_constinit] = ACTIONS(5902),
    [anon_sym_consteval] = ACTIONS(5902),
    [anon_sym_alignas] = ACTIONS(5902),
    [anon_sym__Alignas] = ACTIONS(5902),
    [sym_primitive_type] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
    [anon_sym_final] = ACTIONS(5902),
    [anon_sym_override] = ACTIONS(5902),
    [anon_sym_requires] = ACTIONS(5902),
  },
  [2560] = {
    [sym_identifier] = ACTIONS(6103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6105),
    [anon_sym_COMMA] = ACTIONS(6105),
    [anon_sym_RPAREN] = ACTIONS(6105),
    [anon_sym_LPAREN2] = ACTIONS(6105),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6105),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_PERCENT] = ACTIONS(6105),
    [anon_sym_PIPE_PIPE] = ACTIONS(6105),
    [anon_sym_AMP_AMP] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6105),
    [anon_sym_AMP] = ACTIONS(6103),
    [anon_sym_EQ_EQ] = ACTIONS(6105),
    [anon_sym_BANG_EQ] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6103),
    [anon_sym_GT_EQ] = ACTIONS(6105),
    [anon_sym_LT_EQ] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6103),
    [anon_sym_LT_LT] = ACTIONS(6105),
    [anon_sym_GT_GT] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SEMI] = ACTIONS(6105),
    [anon_sym___extension__] = ACTIONS(6103),
    [anon_sym___attribute__] = ACTIONS(6103),
    [anon_sym___attribute] = ACTIONS(6103),
    [anon_sym___based] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(6105),
    [anon_sym_RBRACE] = ACTIONS(6105),
    [anon_sym_signed] = ACTIONS(6103),
    [anon_sym_unsigned] = ACTIONS(6103),
    [anon_sym_long] = ACTIONS(6103),
    [anon_sym_short] = ACTIONS(6103),
    [anon_sym_LBRACK] = ACTIONS(6105),
    [anon_sym_RBRACK] = ACTIONS(6105),
    [anon_sym_const] = ACTIONS(6103),
    [anon_sym_constexpr] = ACTIONS(6103),
    [anon_sym_volatile] = ACTIONS(6103),
    [anon_sym_restrict] = ACTIONS(6103),
    [anon_sym___restrict__] = ACTIONS(6103),
    [anon_sym__Atomic] = ACTIONS(6103),
    [anon_sym__Noreturn] = ACTIONS(6103),
    [anon_sym_noreturn] = ACTIONS(6103),
    [anon_sym__Nonnull] = ACTIONS(6103),
    [anon_sym_mutable] = ACTIONS(6103),
    [anon_sym_constinit] = ACTIONS(6103),
    [anon_sym_consteval] = ACTIONS(6103),
    [anon_sym_alignas] = ACTIONS(6103),
    [anon_sym__Alignas] = ACTIONS(6103),
    [sym_primitive_type] = ACTIONS(6103),
    [anon_sym_QMARK] = ACTIONS(6105),
    [anon_sym_LT_EQ_GT] = ACTIONS(6105),
    [anon_sym_or] = ACTIONS(6103),
    [anon_sym_and] = ACTIONS(6103),
    [anon_sym_bitor] = ACTIONS(6103),
    [anon_sym_xor] = ACTIONS(6103),
    [anon_sym_bitand] = ACTIONS(6103),
    [anon_sym_not_eq] = ACTIONS(6103),
    [anon_sym_DASH_DASH] = ACTIONS(6105),
    [anon_sym_PLUS_PLUS] = ACTIONS(6105),
    [anon_sym_DOT] = ACTIONS(6103),
    [anon_sym_DOT_STAR] = ACTIONS(6105),
    [anon_sym_DASH_GT] = ACTIONS(6105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6103),
    [anon_sym_decltype] = ACTIONS(6103),
    [anon_sym_final] = ACTIONS(6103),
    [anon_sym_override] = ACTIONS(6103),
    [anon_sym_requires] = ACTIONS(6103),
  },
  [2561] = {
    [sym_identifier] = ACTIONS(6125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6127),
    [anon_sym_COMMA] = ACTIONS(6127),
    [anon_sym_RPAREN] = ACTIONS(6127),
    [anon_sym_LPAREN2] = ACTIONS(6127),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6127),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_PERCENT] = ACTIONS(6127),
    [anon_sym_PIPE_PIPE] = ACTIONS(6127),
    [anon_sym_AMP_AMP] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6127),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_EQ_EQ] = ACTIONS(6127),
    [anon_sym_BANG_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_GT_EQ] = ACTIONS(6127),
    [anon_sym_LT_EQ] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_LT_LT] = ACTIONS(6127),
    [anon_sym_GT_GT] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym___extension__] = ACTIONS(6125),
    [anon_sym___attribute__] = ACTIONS(6125),
    [anon_sym___attribute] = ACTIONS(6125),
    [anon_sym___based] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(6127),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [anon_sym_signed] = ACTIONS(6125),
    [anon_sym_unsigned] = ACTIONS(6125),
    [anon_sym_long] = ACTIONS(6125),
    [anon_sym_short] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_RBRACK] = ACTIONS(6127),
    [anon_sym_const] = ACTIONS(6125),
    [anon_sym_constexpr] = ACTIONS(6125),
    [anon_sym_volatile] = ACTIONS(6125),
    [anon_sym_restrict] = ACTIONS(6125),
    [anon_sym___restrict__] = ACTIONS(6125),
    [anon_sym__Atomic] = ACTIONS(6125),
    [anon_sym__Noreturn] = ACTIONS(6125),
    [anon_sym_noreturn] = ACTIONS(6125),
    [anon_sym__Nonnull] = ACTIONS(6125),
    [anon_sym_mutable] = ACTIONS(6125),
    [anon_sym_constinit] = ACTIONS(6125),
    [anon_sym_consteval] = ACTIONS(6125),
    [anon_sym_alignas] = ACTIONS(6125),
    [anon_sym__Alignas] = ACTIONS(6125),
    [sym_primitive_type] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_LT_EQ_GT] = ACTIONS(6127),
    [anon_sym_or] = ACTIONS(6125),
    [anon_sym_and] = ACTIONS(6125),
    [anon_sym_bitor] = ACTIONS(6125),
    [anon_sym_xor] = ACTIONS(6125),
    [anon_sym_bitand] = ACTIONS(6125),
    [anon_sym_not_eq] = ACTIONS(6125),
    [anon_sym_DASH_DASH] = ACTIONS(6127),
    [anon_sym_PLUS_PLUS] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(6125),
    [anon_sym_DOT_STAR] = ACTIONS(6127),
    [anon_sym_DASH_GT] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6125),
    [anon_sym_decltype] = ACTIONS(6125),
    [anon_sym_final] = ACTIONS(6125),
    [anon_sym_override] = ACTIONS(6125),
    [anon_sym_requires] = ACTIONS(6125),
  },
  [2562] = {
    [sym_type_qualifier] = STATE(2435),
    [sym_alignas_qualifier] = STATE(2486),
    [aux_sym__type_definition_type_repeat1] = STATE(2435),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2622),
    [sym_identifier] = ACTIONS(6527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_RPAREN] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5753),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5753),
    [anon_sym_GT_GT] = ACTIONS(5753),
    [anon_sym_COLON] = ACTIONS(5753),
    [anon_sym_SEMI] = ACTIONS(5753),
    [anon_sym___extension__] = ACTIONS(6499),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_RBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(6529),
    [anon_sym_unsigned] = ACTIONS(6529),
    [anon_sym_long] = ACTIONS(6529),
    [anon_sym_short] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_RBRACK] = ACTIONS(5753),
    [anon_sym_const] = ACTIONS(6499),
    [anon_sym_constexpr] = ACTIONS(6499),
    [anon_sym_volatile] = ACTIONS(6499),
    [anon_sym_restrict] = ACTIONS(6499),
    [anon_sym___restrict__] = ACTIONS(6499),
    [anon_sym__Atomic] = ACTIONS(6499),
    [anon_sym__Noreturn] = ACTIONS(6499),
    [anon_sym_noreturn] = ACTIONS(6499),
    [anon_sym__Nonnull] = ACTIONS(6499),
    [anon_sym_mutable] = ACTIONS(6499),
    [anon_sym_constinit] = ACTIONS(6499),
    [anon_sym_consteval] = ACTIONS(6499),
    [anon_sym_alignas] = ACTIONS(6503),
    [anon_sym__Alignas] = ACTIONS(6503),
    [sym_primitive_type] = ACTIONS(6531),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
  },
  [2563] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5859),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5859),
    [anon_sym_GT_GT] = ACTIONS(5859),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(5857),
    [anon_sym_unsigned] = ACTIONS(5857),
    [anon_sym_long] = ACTIONS(5857),
    [anon_sym_short] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_primitive_type] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
  },
  [2564] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___extension__] = ACTIONS(2288),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym___based] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_signed] = ACTIONS(2288),
    [anon_sym_unsigned] = ACTIONS(2288),
    [anon_sym_long] = ACTIONS(2288),
    [anon_sym_short] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_constexpr] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_restrict] = ACTIONS(2288),
    [anon_sym___restrict__] = ACTIONS(2288),
    [anon_sym__Atomic] = ACTIONS(2288),
    [anon_sym__Noreturn] = ACTIONS(2288),
    [anon_sym_noreturn] = ACTIONS(2288),
    [anon_sym__Nonnull] = ACTIONS(2288),
    [anon_sym_mutable] = ACTIONS(2288),
    [anon_sym_constinit] = ACTIONS(2288),
    [anon_sym_consteval] = ACTIONS(2288),
    [anon_sym_alignas] = ACTIONS(2288),
    [anon_sym__Alignas] = ACTIONS(2288),
    [sym_primitive_type] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
    [anon_sym_final] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_requires] = ACTIONS(2288),
  },
  [2565] = {
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RPAREN] = ACTIONS(6131),
    [anon_sym_LPAREN2] = ACTIONS(6131),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_PERCENT] = ACTIONS(6131),
    [anon_sym_PIPE_PIPE] = ACTIONS(6131),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6131),
    [anon_sym_AMP] = ACTIONS(6129),
    [anon_sym_EQ_EQ] = ACTIONS(6131),
    [anon_sym_BANG_EQ] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6129),
    [anon_sym_GT_EQ] = ACTIONS(6131),
    [anon_sym_LT_EQ] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6129),
    [anon_sym_LT_LT] = ACTIONS(6131),
    [anon_sym_GT_GT] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SEMI] = ACTIONS(6131),
    [anon_sym___extension__] = ACTIONS(6129),
    [anon_sym___attribute__] = ACTIONS(6129),
    [anon_sym___attribute] = ACTIONS(6129),
    [anon_sym___based] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(6131),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [anon_sym_signed] = ACTIONS(6129),
    [anon_sym_unsigned] = ACTIONS(6129),
    [anon_sym_long] = ACTIONS(6129),
    [anon_sym_short] = ACTIONS(6129),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_RBRACK] = ACTIONS(6131),
    [anon_sym_const] = ACTIONS(6129),
    [anon_sym_constexpr] = ACTIONS(6129),
    [anon_sym_volatile] = ACTIONS(6129),
    [anon_sym_restrict] = ACTIONS(6129),
    [anon_sym___restrict__] = ACTIONS(6129),
    [anon_sym__Atomic] = ACTIONS(6129),
    [anon_sym__Noreturn] = ACTIONS(6129),
    [anon_sym_noreturn] = ACTIONS(6129),
    [anon_sym__Nonnull] = ACTIONS(6129),
    [anon_sym_mutable] = ACTIONS(6129),
    [anon_sym_constinit] = ACTIONS(6129),
    [anon_sym_consteval] = ACTIONS(6129),
    [anon_sym_alignas] = ACTIONS(6129),
    [anon_sym__Alignas] = ACTIONS(6129),
    [sym_primitive_type] = ACTIONS(6129),
    [anon_sym_QMARK] = ACTIONS(6131),
    [anon_sym_LT_EQ_GT] = ACTIONS(6131),
    [anon_sym_or] = ACTIONS(6129),
    [anon_sym_and] = ACTIONS(6129),
    [anon_sym_bitor] = ACTIONS(6129),
    [anon_sym_xor] = ACTIONS(6129),
    [anon_sym_bitand] = ACTIONS(6129),
    [anon_sym_not_eq] = ACTIONS(6129),
    [anon_sym_DASH_DASH] = ACTIONS(6131),
    [anon_sym_PLUS_PLUS] = ACTIONS(6131),
    [anon_sym_DOT] = ACTIONS(6129),
    [anon_sym_DOT_STAR] = ACTIONS(6131),
    [anon_sym_DASH_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6129),
    [anon_sym_decltype] = ACTIONS(6129),
    [anon_sym_final] = ACTIONS(6129),
    [anon_sym_override] = ACTIONS(6129),
    [anon_sym_requires] = ACTIONS(6129),
  },
  [2566] = {
    [sym_identifier] = ACTIONS(6015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6017),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [anon_sym_LPAREN2] = ACTIONS(6017),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_PLUS] = ACTIONS(6015),
    [anon_sym_STAR] = ACTIONS(6017),
    [anon_sym_SLASH] = ACTIONS(6015),
    [anon_sym_PERCENT] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6015),
    [anon_sym_CARET] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6015),
    [anon_sym_EQ_EQ] = ACTIONS(6017),
    [anon_sym_BANG_EQ] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6015),
    [anon_sym_GT_EQ] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6015),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [anon_sym_GT_GT] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym___extension__] = ACTIONS(6015),
    [anon_sym___attribute__] = ACTIONS(6015),
    [anon_sym___attribute] = ACTIONS(6015),
    [anon_sym___based] = ACTIONS(6015),
    [anon_sym_LBRACE] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_signed] = ACTIONS(6015),
    [anon_sym_unsigned] = ACTIONS(6015),
    [anon_sym_long] = ACTIONS(6015),
    [anon_sym_short] = ACTIONS(6015),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [anon_sym_RBRACK] = ACTIONS(6017),
    [anon_sym_const] = ACTIONS(6015),
    [anon_sym_constexpr] = ACTIONS(6015),
    [anon_sym_volatile] = ACTIONS(6015),
    [anon_sym_restrict] = ACTIONS(6015),
    [anon_sym___restrict__] = ACTIONS(6015),
    [anon_sym__Atomic] = ACTIONS(6015),
    [anon_sym__Noreturn] = ACTIONS(6015),
    [anon_sym_noreturn] = ACTIONS(6015),
    [anon_sym__Nonnull] = ACTIONS(6015),
    [anon_sym_mutable] = ACTIONS(6015),
    [anon_sym_constinit] = ACTIONS(6015),
    [anon_sym_consteval] = ACTIONS(6015),
    [anon_sym_alignas] = ACTIONS(6015),
    [anon_sym__Alignas] = ACTIONS(6015),
    [sym_primitive_type] = ACTIONS(6015),
    [anon_sym_QMARK] = ACTIONS(6017),
    [anon_sym_LT_EQ_GT] = ACTIONS(6017),
    [anon_sym_or] = ACTIONS(6015),
    [anon_sym_and] = ACTIONS(6015),
    [anon_sym_bitor] = ACTIONS(6015),
    [anon_sym_xor] = ACTIONS(6015),
    [anon_sym_bitand] = ACTIONS(6015),
    [anon_sym_not_eq] = ACTIONS(6015),
    [anon_sym_DASH_DASH] = ACTIONS(6017),
    [anon_sym_PLUS_PLUS] = ACTIONS(6017),
    [anon_sym_DOT] = ACTIONS(6015),
    [anon_sym_DOT_STAR] = ACTIONS(6017),
    [anon_sym_DASH_GT] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6015),
    [anon_sym_decltype] = ACTIONS(6015),
    [anon_sym_final] = ACTIONS(6015),
    [anon_sym_override] = ACTIONS(6015),
    [anon_sym_requires] = ACTIONS(6015),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5995),
    [anon_sym_COMMA] = ACTIONS(5995),
    [anon_sym_RPAREN] = ACTIONS(5995),
    [anon_sym_LPAREN2] = ACTIONS(5995),
    [anon_sym_DASH] = ACTIONS(5993),
    [anon_sym_PLUS] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5995),
    [anon_sym_SLASH] = ACTIONS(5993),
    [anon_sym_PERCENT] = ACTIONS(5995),
    [anon_sym_PIPE_PIPE] = ACTIONS(5995),
    [anon_sym_AMP_AMP] = ACTIONS(5995),
    [anon_sym_PIPE] = ACTIONS(5993),
    [anon_sym_CARET] = ACTIONS(5995),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym_EQ_EQ] = ACTIONS(5995),
    [anon_sym_BANG_EQ] = ACTIONS(5995),
    [anon_sym_GT] = ACTIONS(5993),
    [anon_sym_GT_EQ] = ACTIONS(5995),
    [anon_sym_LT_EQ] = ACTIONS(5993),
    [anon_sym_LT] = ACTIONS(5993),
    [anon_sym_LT_LT] = ACTIONS(5995),
    [anon_sym_GT_GT] = ACTIONS(5995),
    [anon_sym_COLON] = ACTIONS(5995),
    [anon_sym_SEMI] = ACTIONS(5995),
    [anon_sym___extension__] = ACTIONS(5993),
    [anon_sym___attribute__] = ACTIONS(5993),
    [anon_sym___attribute] = ACTIONS(5993),
    [anon_sym___based] = ACTIONS(5993),
    [anon_sym_LBRACE] = ACTIONS(5995),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_signed] = ACTIONS(5993),
    [anon_sym_unsigned] = ACTIONS(5993),
    [anon_sym_long] = ACTIONS(5993),
    [anon_sym_short] = ACTIONS(5993),
    [anon_sym_LBRACK] = ACTIONS(5995),
    [anon_sym_RBRACK] = ACTIONS(5995),
    [anon_sym_const] = ACTIONS(5993),
    [anon_sym_constexpr] = ACTIONS(5993),
    [anon_sym_volatile] = ACTIONS(5993),
    [anon_sym_restrict] = ACTIONS(5993),
    [anon_sym___restrict__] = ACTIONS(5993),
    [anon_sym__Atomic] = ACTIONS(5993),
    [anon_sym__Noreturn] = ACTIONS(5993),
    [anon_sym_noreturn] = ACTIONS(5993),
    [anon_sym__Nonnull] = ACTIONS(5993),
    [anon_sym_mutable] = ACTIONS(5993),
    [anon_sym_constinit] = ACTIONS(5993),
    [anon_sym_consteval] = ACTIONS(5993),
    [anon_sym_alignas] = ACTIONS(5993),
    [anon_sym__Alignas] = ACTIONS(5993),
    [sym_primitive_type] = ACTIONS(5993),
    [anon_sym_QMARK] = ACTIONS(5995),
    [anon_sym_LT_EQ_GT] = ACTIONS(5995),
    [anon_sym_or] = ACTIONS(5993),
    [anon_sym_and] = ACTIONS(5993),
    [anon_sym_bitor] = ACTIONS(5993),
    [anon_sym_xor] = ACTIONS(5993),
    [anon_sym_bitand] = ACTIONS(5993),
    [anon_sym_not_eq] = ACTIONS(5993),
    [anon_sym_DASH_DASH] = ACTIONS(5995),
    [anon_sym_PLUS_PLUS] = ACTIONS(5995),
    [anon_sym_DOT] = ACTIONS(5993),
    [anon_sym_DOT_STAR] = ACTIONS(5995),
    [anon_sym_DASH_GT] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5993),
    [anon_sym_decltype] = ACTIONS(5993),
    [anon_sym_final] = ACTIONS(5993),
    [anon_sym_override] = ACTIONS(5993),
    [anon_sym_requires] = ACTIONS(5993),
  },
  [2568] = {
    [sym_attribute_specifier] = STATE(2381),
    [sym_field_declaration_list] = STATE(2406),
    [sym_virtual_specifier] = STATE(7225),
    [sym_base_class_clause] = STATE(7880),
    [sym_identifier] = ACTIONS(5866),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym___extension__] = ACTIONS(5866),
    [anon_sym_in] = ACTIONS(5866),
    [anon_sym_out] = ACTIONS(5866),
    [anon_sym_inout] = ACTIONS(5866),
    [anon_sym_virtual] = ACTIONS(5866),
    [anon_sym_extern] = ACTIONS(5866),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5868),
    [anon_sym___declspec] = ACTIONS(5866),
    [anon_sym___based] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(5870),
    [anon_sym_LBRACK] = ACTIONS(5866),
    [anon_sym_static] = ACTIONS(5866),
    [anon_sym_register] = ACTIONS(5866),
    [anon_sym_inline] = ACTIONS(5866),
    [anon_sym___inline] = ACTIONS(5866),
    [anon_sym___inline__] = ACTIONS(5866),
    [anon_sym___forceinline] = ACTIONS(5866),
    [anon_sym_thread_local] = ACTIONS(5866),
    [anon_sym___thread] = ACTIONS(5866),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5866),
    [anon_sym_volatile] = ACTIONS(5866),
    [anon_sym_restrict] = ACTIONS(5866),
    [anon_sym___restrict__] = ACTIONS(5866),
    [anon_sym__Atomic] = ACTIONS(5866),
    [anon_sym__Noreturn] = ACTIONS(5866),
    [anon_sym_noreturn] = ACTIONS(5866),
    [anon_sym__Nonnull] = ACTIONS(5866),
    [anon_sym_mutable] = ACTIONS(5866),
    [anon_sym_constinit] = ACTIONS(5866),
    [anon_sym_consteval] = ACTIONS(5866),
    [anon_sym_alignas] = ACTIONS(5866),
    [anon_sym__Alignas] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5866),
    [anon_sym_decltype] = ACTIONS(5866),
    [anon_sym_final] = ACTIONS(1965),
    [anon_sym_override] = ACTIONS(1965),
    [anon_sym_operator] = ACTIONS(5866),
    [anon_sym_precise] = ACTIONS(5866),
    [anon_sym_shared] = ACTIONS(5866),
    [anon_sym_groupshared] = ACTIONS(5866),
    [anon_sym_uniform] = ACTIONS(5866),
    [anon_sym_row_major] = ACTIONS(5866),
    [anon_sym_column_major] = ACTIONS(5866),
    [anon_sym_globallycoherent] = ACTIONS(5866),
    [anon_sym_centroid] = ACTIONS(5866),
    [anon_sym_noperspective] = ACTIONS(5866),
    [anon_sym_nointerpolation] = ACTIONS(5866),
    [anon_sym_sample] = ACTIONS(5866),
    [anon_sym_linear] = ACTIONS(5866),
    [anon_sym_snorm] = ACTIONS(5866),
    [anon_sym_unorm] = ACTIONS(5866),
    [anon_sym_point] = ACTIONS(5866),
    [anon_sym_line] = ACTIONS(5866),
    [anon_sym_triangleadj] = ACTIONS(5866),
    [anon_sym_lineadj] = ACTIONS(5866),
    [anon_sym_triangle] = ACTIONS(5866),
  },
  [2569] = {
    [sym_identifier] = ACTIONS(6061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_LPAREN2] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_PLUS] = ACTIONS(6061),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6061),
    [anon_sym_PERCENT] = ACTIONS(6063),
    [anon_sym_PIPE_PIPE] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6063),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_AMP] = ACTIONS(6061),
    [anon_sym_EQ_EQ] = ACTIONS(6063),
    [anon_sym_BANG_EQ] = ACTIONS(6063),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_GT_EQ] = ACTIONS(6063),
    [anon_sym_LT_EQ] = ACTIONS(6061),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_LT_LT] = ACTIONS(6063),
    [anon_sym_GT_GT] = ACTIONS(6063),
    [anon_sym_COLON] = ACTIONS(6063),
    [anon_sym_SEMI] = ACTIONS(6063),
    [anon_sym___extension__] = ACTIONS(6061),
    [anon_sym___attribute__] = ACTIONS(6061),
    [anon_sym___attribute] = ACTIONS(6061),
    [anon_sym___based] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(6063),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_signed] = ACTIONS(6061),
    [anon_sym_unsigned] = ACTIONS(6061),
    [anon_sym_long] = ACTIONS(6061),
    [anon_sym_short] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(6063),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_const] = ACTIONS(6061),
    [anon_sym_constexpr] = ACTIONS(6061),
    [anon_sym_volatile] = ACTIONS(6061),
    [anon_sym_restrict] = ACTIONS(6061),
    [anon_sym___restrict__] = ACTIONS(6061),
    [anon_sym__Atomic] = ACTIONS(6061),
    [anon_sym__Noreturn] = ACTIONS(6061),
    [anon_sym_noreturn] = ACTIONS(6061),
    [anon_sym__Nonnull] = ACTIONS(6061),
    [anon_sym_mutable] = ACTIONS(6061),
    [anon_sym_constinit] = ACTIONS(6061),
    [anon_sym_consteval] = ACTIONS(6061),
    [anon_sym_alignas] = ACTIONS(6061),
    [anon_sym__Alignas] = ACTIONS(6061),
    [sym_primitive_type] = ACTIONS(6061),
    [anon_sym_QMARK] = ACTIONS(6063),
    [anon_sym_LT_EQ_GT] = ACTIONS(6063),
    [anon_sym_or] = ACTIONS(6061),
    [anon_sym_and] = ACTIONS(6061),
    [anon_sym_bitor] = ACTIONS(6061),
    [anon_sym_xor] = ACTIONS(6061),
    [anon_sym_bitand] = ACTIONS(6061),
    [anon_sym_not_eq] = ACTIONS(6061),
    [anon_sym_DASH_DASH] = ACTIONS(6063),
    [anon_sym_PLUS_PLUS] = ACTIONS(6063),
    [anon_sym_DOT] = ACTIONS(6061),
    [anon_sym_DOT_STAR] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6061),
    [anon_sym_decltype] = ACTIONS(6061),
    [anon_sym_final] = ACTIONS(6061),
    [anon_sym_override] = ACTIONS(6061),
    [anon_sym_requires] = ACTIONS(6061),
  },
  [2570] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_DASH] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6013),
    [anon_sym_SLASH] = ACTIONS(6011),
    [anon_sym_PERCENT] = ACTIONS(6013),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_PIPE] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6013),
    [anon_sym_BANG_EQ] = ACTIONS(6013),
    [anon_sym_GT] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6013),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6013),
    [anon_sym_GT_GT] = ACTIONS(6013),
    [anon_sym_COLON] = ACTIONS(6013),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___extension__] = ACTIONS(6011),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym___based] = ACTIONS(6011),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_signed] = ACTIONS(6011),
    [anon_sym_unsigned] = ACTIONS(6011),
    [anon_sym_long] = ACTIONS(6011),
    [anon_sym_short] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6013),
    [anon_sym_RBRACK] = ACTIONS(6013),
    [anon_sym_const] = ACTIONS(6011),
    [anon_sym_constexpr] = ACTIONS(6011),
    [anon_sym_volatile] = ACTIONS(6011),
    [anon_sym_restrict] = ACTIONS(6011),
    [anon_sym___restrict__] = ACTIONS(6011),
    [anon_sym__Atomic] = ACTIONS(6011),
    [anon_sym__Noreturn] = ACTIONS(6011),
    [anon_sym_noreturn] = ACTIONS(6011),
    [anon_sym__Nonnull] = ACTIONS(6011),
    [anon_sym_mutable] = ACTIONS(6011),
    [anon_sym_constinit] = ACTIONS(6011),
    [anon_sym_consteval] = ACTIONS(6011),
    [anon_sym_alignas] = ACTIONS(6011),
    [anon_sym__Alignas] = ACTIONS(6011),
    [sym_primitive_type] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6013),
    [anon_sym_LT_EQ_GT] = ACTIONS(6013),
    [anon_sym_or] = ACTIONS(6011),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_bitor] = ACTIONS(6011),
    [anon_sym_xor] = ACTIONS(6011),
    [anon_sym_bitand] = ACTIONS(6011),
    [anon_sym_not_eq] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6013),
    [anon_sym_PLUS_PLUS] = ACTIONS(6013),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_DOT_STAR] = ACTIONS(6013),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
    [anon_sym_final] = ACTIONS(6011),
    [anon_sym_override] = ACTIONS(6011),
    [anon_sym_requires] = ACTIONS(6011),
  },
  [2571] = {
    [sym_template_argument_list] = STATE(2603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4430),
    [anon_sym_COMMA] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4433),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(6533),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym___extension__] = ACTIONS(1999),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1999),
    [anon_sym_volatile] = ACTIONS(1999),
    [anon_sym_restrict] = ACTIONS(1999),
    [anon_sym___restrict__] = ACTIONS(1999),
    [anon_sym__Atomic] = ACTIONS(1999),
    [anon_sym__Noreturn] = ACTIONS(1999),
    [anon_sym_noreturn] = ACTIONS(1999),
    [anon_sym__Nonnull] = ACTIONS(1999),
    [anon_sym_mutable] = ACTIONS(1999),
    [anon_sym_constinit] = ACTIONS(1999),
    [anon_sym_consteval] = ACTIONS(1999),
    [anon_sym_alignas] = ACTIONS(1999),
    [anon_sym__Alignas] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4433),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4428),
    [anon_sym_or_eq] = ACTIONS(4428),
    [anon_sym_xor_eq] = ACTIONS(4428),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4428),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4428),
    [anon_sym_not_eq] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1999),
    [anon_sym_decltype] = ACTIONS(1999),
    [anon_sym_GT2] = ACTIONS(4430),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym_COLON_COLON] = ACTIONS(2187),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_RBRACK] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_not] = ACTIONS(2197),
    [anon_sym_compl] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_sizeof] = ACTIONS(2197),
    [anon_sym___alignof__] = ACTIONS(2197),
    [anon_sym___alignof] = ACTIONS(2197),
    [anon_sym__alignof] = ACTIONS(2197),
    [anon_sym_alignof] = ACTIONS(2197),
    [anon_sym__Alignof] = ACTIONS(2197),
    [anon_sym_offsetof] = ACTIONS(2197),
    [anon_sym__Generic] = ACTIONS(2197),
    [anon_sym_asm] = ACTIONS(2197),
    [anon_sym___asm__] = ACTIONS(2197),
    [anon_sym___asm] = ACTIONS(2197),
    [sym_number_literal] = ACTIONS(2187),
    [anon_sym_L_SQUOTE] = ACTIONS(2187),
    [anon_sym_u_SQUOTE] = ACTIONS(2187),
    [anon_sym_U_SQUOTE] = ACTIONS(2187),
    [anon_sym_u8_SQUOTE] = ACTIONS(2187),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [anon_sym_L_DQUOTE] = ACTIONS(2187),
    [anon_sym_u_DQUOTE] = ACTIONS(2187),
    [anon_sym_U_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8_DQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [sym_true] = ACTIONS(2197),
    [sym_false] = ACTIONS(2197),
    [anon_sym_NULL] = ACTIONS(2197),
    [anon_sym_nullptr] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_template] = ACTIONS(2197),
    [anon_sym_delete] = ACTIONS(2197),
    [anon_sym_R_DQUOTE] = ACTIONS(2187),
    [anon_sym_LR_DQUOTE] = ACTIONS(2187),
    [anon_sym_uR_DQUOTE] = ACTIONS(2187),
    [anon_sym_UR_DQUOTE] = ACTIONS(2187),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2187),
    [anon_sym_co_await] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_requires] = ACTIONS(2197),
    [sym_this] = ACTIONS(2197),
  },
  [2573] = {
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6055),
    [anon_sym_COMMA] = ACTIONS(6055),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [anon_sym_LPAREN2] = ACTIONS(6055),
    [anon_sym_DASH] = ACTIONS(6053),
    [anon_sym_PLUS] = ACTIONS(6053),
    [anon_sym_STAR] = ACTIONS(6055),
    [anon_sym_SLASH] = ACTIONS(6053),
    [anon_sym_PERCENT] = ACTIONS(6055),
    [anon_sym_PIPE_PIPE] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(6055),
    [anon_sym_PIPE] = ACTIONS(6053),
    [anon_sym_CARET] = ACTIONS(6055),
    [anon_sym_AMP] = ACTIONS(6053),
    [anon_sym_EQ_EQ] = ACTIONS(6055),
    [anon_sym_BANG_EQ] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6053),
    [anon_sym_GT_EQ] = ACTIONS(6055),
    [anon_sym_LT_EQ] = ACTIONS(6053),
    [anon_sym_LT] = ACTIONS(6053),
    [anon_sym_LT_LT] = ACTIONS(6055),
    [anon_sym_GT_GT] = ACTIONS(6055),
    [anon_sym_COLON] = ACTIONS(6055),
    [anon_sym_SEMI] = ACTIONS(6055),
    [anon_sym___extension__] = ACTIONS(6053),
    [anon_sym___attribute__] = ACTIONS(6053),
    [anon_sym___attribute] = ACTIONS(6053),
    [anon_sym___based] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_signed] = ACTIONS(6053),
    [anon_sym_unsigned] = ACTIONS(6053),
    [anon_sym_long] = ACTIONS(6053),
    [anon_sym_short] = ACTIONS(6053),
    [anon_sym_LBRACK] = ACTIONS(6055),
    [anon_sym_RBRACK] = ACTIONS(6055),
    [anon_sym_const] = ACTIONS(6053),
    [anon_sym_constexpr] = ACTIONS(6053),
    [anon_sym_volatile] = ACTIONS(6053),
    [anon_sym_restrict] = ACTIONS(6053),
    [anon_sym___restrict__] = ACTIONS(6053),
    [anon_sym__Atomic] = ACTIONS(6053),
    [anon_sym__Noreturn] = ACTIONS(6053),
    [anon_sym_noreturn] = ACTIONS(6053),
    [anon_sym__Nonnull] = ACTIONS(6053),
    [anon_sym_mutable] = ACTIONS(6053),
    [anon_sym_constinit] = ACTIONS(6053),
    [anon_sym_consteval] = ACTIONS(6053),
    [anon_sym_alignas] = ACTIONS(6053),
    [anon_sym__Alignas] = ACTIONS(6053),
    [sym_primitive_type] = ACTIONS(6053),
    [anon_sym_QMARK] = ACTIONS(6055),
    [anon_sym_LT_EQ_GT] = ACTIONS(6055),
    [anon_sym_or] = ACTIONS(6053),
    [anon_sym_and] = ACTIONS(6053),
    [anon_sym_bitor] = ACTIONS(6053),
    [anon_sym_xor] = ACTIONS(6053),
    [anon_sym_bitand] = ACTIONS(6053),
    [anon_sym_not_eq] = ACTIONS(6053),
    [anon_sym_DASH_DASH] = ACTIONS(6055),
    [anon_sym_PLUS_PLUS] = ACTIONS(6055),
    [anon_sym_DOT] = ACTIONS(6053),
    [anon_sym_DOT_STAR] = ACTIONS(6055),
    [anon_sym_DASH_GT] = ACTIONS(6055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6053),
    [anon_sym_decltype] = ACTIONS(6053),
    [anon_sym_final] = ACTIONS(6053),
    [anon_sym_override] = ACTIONS(6053),
    [anon_sym_requires] = ACTIONS(6053),
  },
  [2574] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym__Nonnull] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4451),
    [anon_sym_or_eq] = ACTIONS(4451),
    [anon_sym_xor_eq] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4451),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4451),
    [anon_sym_not_eq] = ACTIONS(4451),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4456),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4451),
  },
  [2575] = {
    [sym_identifier] = ACTIONS(5997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_LPAREN2] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5997),
    [anon_sym_PLUS] = ACTIONS(5997),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5997),
    [anon_sym_PERCENT] = ACTIONS(5999),
    [anon_sym_PIPE_PIPE] = ACTIONS(5999),
    [anon_sym_AMP_AMP] = ACTIONS(5999),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_AMP] = ACTIONS(5997),
    [anon_sym_EQ_EQ] = ACTIONS(5999),
    [anon_sym_BANG_EQ] = ACTIONS(5999),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_GT_EQ] = ACTIONS(5999),
    [anon_sym_LT_EQ] = ACTIONS(5997),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_LT_LT] = ACTIONS(5999),
    [anon_sym_GT_GT] = ACTIONS(5999),
    [anon_sym_COLON] = ACTIONS(5999),
    [anon_sym_SEMI] = ACTIONS(5999),
    [anon_sym___extension__] = ACTIONS(5997),
    [anon_sym___attribute__] = ACTIONS(5997),
    [anon_sym___attribute] = ACTIONS(5997),
    [anon_sym___based] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_signed] = ACTIONS(5997),
    [anon_sym_unsigned] = ACTIONS(5997),
    [anon_sym_long] = ACTIONS(5997),
    [anon_sym_short] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_const] = ACTIONS(5997),
    [anon_sym_constexpr] = ACTIONS(5997),
    [anon_sym_volatile] = ACTIONS(5997),
    [anon_sym_restrict] = ACTIONS(5997),
    [anon_sym___restrict__] = ACTIONS(5997),
    [anon_sym__Atomic] = ACTIONS(5997),
    [anon_sym__Noreturn] = ACTIONS(5997),
    [anon_sym_noreturn] = ACTIONS(5997),
    [anon_sym__Nonnull] = ACTIONS(5997),
    [anon_sym_mutable] = ACTIONS(5997),
    [anon_sym_constinit] = ACTIONS(5997),
    [anon_sym_consteval] = ACTIONS(5997),
    [anon_sym_alignas] = ACTIONS(5997),
    [anon_sym__Alignas] = ACTIONS(5997),
    [sym_primitive_type] = ACTIONS(5997),
    [anon_sym_QMARK] = ACTIONS(5999),
    [anon_sym_LT_EQ_GT] = ACTIONS(5999),
    [anon_sym_or] = ACTIONS(5997),
    [anon_sym_and] = ACTIONS(5997),
    [anon_sym_bitor] = ACTIONS(5997),
    [anon_sym_xor] = ACTIONS(5997),
    [anon_sym_bitand] = ACTIONS(5997),
    [anon_sym_not_eq] = ACTIONS(5997),
    [anon_sym_DASH_DASH] = ACTIONS(5999),
    [anon_sym_PLUS_PLUS] = ACTIONS(5999),
    [anon_sym_DOT] = ACTIONS(5997),
    [anon_sym_DOT_STAR] = ACTIONS(5999),
    [anon_sym_DASH_GT] = ACTIONS(5999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5997),
    [anon_sym_decltype] = ACTIONS(5997),
    [anon_sym_final] = ACTIONS(5997),
    [anon_sym_override] = ACTIONS(5997),
    [anon_sym_requires] = ACTIONS(5997),
  },
  [2576] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_BANG] = ACTIONS(5168),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_RBRACK] = ACTIONS(5168),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_not] = ACTIONS(5166),
    [anon_sym_compl] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_sizeof] = ACTIONS(5166),
    [anon_sym___alignof__] = ACTIONS(5166),
    [anon_sym___alignof] = ACTIONS(5166),
    [anon_sym__alignof] = ACTIONS(5166),
    [anon_sym_alignof] = ACTIONS(5166),
    [anon_sym__Alignof] = ACTIONS(5166),
    [anon_sym_offsetof] = ACTIONS(5166),
    [anon_sym__Generic] = ACTIONS(5166),
    [anon_sym_asm] = ACTIONS(5166),
    [anon_sym___asm__] = ACTIONS(5166),
    [anon_sym___asm] = ACTIONS(5166),
    [sym_number_literal] = ACTIONS(5168),
    [anon_sym_L_SQUOTE] = ACTIONS(5168),
    [anon_sym_u_SQUOTE] = ACTIONS(5168),
    [anon_sym_U_SQUOTE] = ACTIONS(5168),
    [anon_sym_u8_SQUOTE] = ACTIONS(5168),
    [anon_sym_SQUOTE] = ACTIONS(5168),
    [anon_sym_L_DQUOTE] = ACTIONS(5168),
    [anon_sym_u_DQUOTE] = ACTIONS(5168),
    [anon_sym_U_DQUOTE] = ACTIONS(5168),
    [anon_sym_u8_DQUOTE] = ACTIONS(5168),
    [anon_sym_DQUOTE] = ACTIONS(5168),
    [sym_true] = ACTIONS(5166),
    [sym_false] = ACTIONS(5166),
    [anon_sym_NULL] = ACTIONS(5166),
    [anon_sym_nullptr] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_template] = ACTIONS(5166),
    [anon_sym_delete] = ACTIONS(5166),
    [anon_sym_R_DQUOTE] = ACTIONS(5168),
    [anon_sym_LR_DQUOTE] = ACTIONS(5168),
    [anon_sym_uR_DQUOTE] = ACTIONS(5168),
    [anon_sym_UR_DQUOTE] = ACTIONS(5168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5168),
    [anon_sym_co_await] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5166),
    [anon_sym_requires] = ACTIONS(5166),
    [sym_this] = ACTIONS(5166),
  },
  [2577] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6047),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6047),
    [anon_sym_GT_GT] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_signed] = ACTIONS(6045),
    [anon_sym_unsigned] = ACTIONS(6045),
    [anon_sym_long] = ACTIONS(6045),
    [anon_sym_short] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_primitive_type] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
  },
  [2578] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6047),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6047),
    [anon_sym_GT_GT] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_signed] = ACTIONS(6045),
    [anon_sym_unsigned] = ACTIONS(6045),
    [anon_sym_long] = ACTIONS(6045),
    [anon_sym_short] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_primitive_type] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
  },
  [2579] = {
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6093),
    [anon_sym_COMMA] = ACTIONS(6093),
    [anon_sym_RPAREN] = ACTIONS(6093),
    [anon_sym_LPAREN2] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6093),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_PERCENT] = ACTIONS(6093),
    [anon_sym_PIPE_PIPE] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6093),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_EQ_EQ] = ACTIONS(6093),
    [anon_sym_BANG_EQ] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6091),
    [anon_sym_GT_EQ] = ACTIONS(6093),
    [anon_sym_LT_EQ] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6091),
    [anon_sym_LT_LT] = ACTIONS(6093),
    [anon_sym_GT_GT] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6093),
    [anon_sym___extension__] = ACTIONS(6091),
    [anon_sym___attribute__] = ACTIONS(6091),
    [anon_sym___attribute] = ACTIONS(6091),
    [anon_sym___based] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6093),
    [anon_sym_RBRACE] = ACTIONS(6093),
    [anon_sym_signed] = ACTIONS(6091),
    [anon_sym_unsigned] = ACTIONS(6091),
    [anon_sym_long] = ACTIONS(6091),
    [anon_sym_short] = ACTIONS(6091),
    [anon_sym_LBRACK] = ACTIONS(6093),
    [anon_sym_RBRACK] = ACTIONS(6093),
    [anon_sym_const] = ACTIONS(6091),
    [anon_sym_constexpr] = ACTIONS(6091),
    [anon_sym_volatile] = ACTIONS(6091),
    [anon_sym_restrict] = ACTIONS(6091),
    [anon_sym___restrict__] = ACTIONS(6091),
    [anon_sym__Atomic] = ACTIONS(6091),
    [anon_sym__Noreturn] = ACTIONS(6091),
    [anon_sym_noreturn] = ACTIONS(6091),
    [anon_sym__Nonnull] = ACTIONS(6091),
    [anon_sym_mutable] = ACTIONS(6091),
    [anon_sym_constinit] = ACTIONS(6091),
    [anon_sym_consteval] = ACTIONS(6091),
    [anon_sym_alignas] = ACTIONS(6091),
    [anon_sym__Alignas] = ACTIONS(6091),
    [sym_primitive_type] = ACTIONS(6091),
    [anon_sym_QMARK] = ACTIONS(6093),
    [anon_sym_LT_EQ_GT] = ACTIONS(6093),
    [anon_sym_or] = ACTIONS(6091),
    [anon_sym_and] = ACTIONS(6091),
    [anon_sym_bitor] = ACTIONS(6091),
    [anon_sym_xor] = ACTIONS(6091),
    [anon_sym_bitand] = ACTIONS(6091),
    [anon_sym_not_eq] = ACTIONS(6091),
    [anon_sym_DASH_DASH] = ACTIONS(6093),
    [anon_sym_PLUS_PLUS] = ACTIONS(6093),
    [anon_sym_DOT] = ACTIONS(6091),
    [anon_sym_DOT_STAR] = ACTIONS(6093),
    [anon_sym_DASH_GT] = ACTIONS(6093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6091),
    [anon_sym_decltype] = ACTIONS(6091),
    [anon_sym_final] = ACTIONS(6091),
    [anon_sym_override] = ACTIONS(6091),
    [anon_sym_requires] = ACTIONS(6091),
  },
  [2580] = {
    [sym_identifier] = ACTIONS(6095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6097),
    [anon_sym_COMMA] = ACTIONS(6097),
    [anon_sym_RPAREN] = ACTIONS(6097),
    [anon_sym_LPAREN2] = ACTIONS(6097),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6097),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_PERCENT] = ACTIONS(6097),
    [anon_sym_PIPE_PIPE] = ACTIONS(6097),
    [anon_sym_AMP_AMP] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6097),
    [anon_sym_AMP] = ACTIONS(6095),
    [anon_sym_EQ_EQ] = ACTIONS(6097),
    [anon_sym_BANG_EQ] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6095),
    [anon_sym_GT_EQ] = ACTIONS(6097),
    [anon_sym_LT_EQ] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6095),
    [anon_sym_LT_LT] = ACTIONS(6097),
    [anon_sym_GT_GT] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SEMI] = ACTIONS(6097),
    [anon_sym___extension__] = ACTIONS(6095),
    [anon_sym___attribute__] = ACTIONS(6095),
    [anon_sym___attribute] = ACTIONS(6095),
    [anon_sym___based] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [anon_sym_RBRACE] = ACTIONS(6097),
    [anon_sym_signed] = ACTIONS(6095),
    [anon_sym_unsigned] = ACTIONS(6095),
    [anon_sym_long] = ACTIONS(6095),
    [anon_sym_short] = ACTIONS(6095),
    [anon_sym_LBRACK] = ACTIONS(6097),
    [anon_sym_RBRACK] = ACTIONS(6097),
    [anon_sym_const] = ACTIONS(6095),
    [anon_sym_constexpr] = ACTIONS(6095),
    [anon_sym_volatile] = ACTIONS(6095),
    [anon_sym_restrict] = ACTIONS(6095),
    [anon_sym___restrict__] = ACTIONS(6095),
    [anon_sym__Atomic] = ACTIONS(6095),
    [anon_sym__Noreturn] = ACTIONS(6095),
    [anon_sym_noreturn] = ACTIONS(6095),
    [anon_sym__Nonnull] = ACTIONS(6095),
    [anon_sym_mutable] = ACTIONS(6095),
    [anon_sym_constinit] = ACTIONS(6095),
    [anon_sym_consteval] = ACTIONS(6095),
    [anon_sym_alignas] = ACTIONS(6095),
    [anon_sym__Alignas] = ACTIONS(6095),
    [sym_primitive_type] = ACTIONS(6095),
    [anon_sym_QMARK] = ACTIONS(6097),
    [anon_sym_LT_EQ_GT] = ACTIONS(6097),
    [anon_sym_or] = ACTIONS(6095),
    [anon_sym_and] = ACTIONS(6095),
    [anon_sym_bitor] = ACTIONS(6095),
    [anon_sym_xor] = ACTIONS(6095),
    [anon_sym_bitand] = ACTIONS(6095),
    [anon_sym_not_eq] = ACTIONS(6095),
    [anon_sym_DASH_DASH] = ACTIONS(6097),
    [anon_sym_PLUS_PLUS] = ACTIONS(6097),
    [anon_sym_DOT] = ACTIONS(6095),
    [anon_sym_DOT_STAR] = ACTIONS(6097),
    [anon_sym_DASH_GT] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6095),
    [anon_sym_decltype] = ACTIONS(6095),
    [anon_sym_final] = ACTIONS(6095),
    [anon_sym_override] = ACTIONS(6095),
    [anon_sym_requires] = ACTIONS(6095),
  },
  [2581] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5859),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5859),
    [anon_sym_GT_GT] = ACTIONS(5859),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(5857),
    [anon_sym_unsigned] = ACTIONS(5857),
    [anon_sym_long] = ACTIONS(5857),
    [anon_sym_short] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_primitive_type] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_final] = ACTIONS(5857),
    [anon_sym_override] = ACTIONS(5857),
    [anon_sym_requires] = ACTIONS(5857),
  },
  [2582] = {
    [sym_identifier] = ACTIONS(6037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_LPAREN2] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6037),
    [anon_sym_PLUS] = ACTIONS(6037),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6037),
    [anon_sym_PERCENT] = ACTIONS(6039),
    [anon_sym_PIPE_PIPE] = ACTIONS(6039),
    [anon_sym_AMP_AMP] = ACTIONS(6039),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_AMP] = ACTIONS(6037),
    [anon_sym_EQ_EQ] = ACTIONS(6039),
    [anon_sym_BANG_EQ] = ACTIONS(6039),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_GT_EQ] = ACTIONS(6039),
    [anon_sym_LT_EQ] = ACTIONS(6037),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6039),
    [anon_sym_GT_GT] = ACTIONS(6039),
    [anon_sym_COLON] = ACTIONS(6039),
    [anon_sym_SEMI] = ACTIONS(6039),
    [anon_sym___extension__] = ACTIONS(6037),
    [anon_sym___attribute__] = ACTIONS(6037),
    [anon_sym___attribute] = ACTIONS(6037),
    [anon_sym___based] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_signed] = ACTIONS(6037),
    [anon_sym_unsigned] = ACTIONS(6037),
    [anon_sym_long] = ACTIONS(6037),
    [anon_sym_short] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_const] = ACTIONS(6037),
    [anon_sym_constexpr] = ACTIONS(6037),
    [anon_sym_volatile] = ACTIONS(6037),
    [anon_sym_restrict] = ACTIONS(6037),
    [anon_sym___restrict__] = ACTIONS(6037),
    [anon_sym__Atomic] = ACTIONS(6037),
    [anon_sym__Noreturn] = ACTIONS(6037),
    [anon_sym_noreturn] = ACTIONS(6037),
    [anon_sym__Nonnull] = ACTIONS(6037),
    [anon_sym_mutable] = ACTIONS(6037),
    [anon_sym_constinit] = ACTIONS(6037),
    [anon_sym_consteval] = ACTIONS(6037),
    [anon_sym_alignas] = ACTIONS(6037),
    [anon_sym__Alignas] = ACTIONS(6037),
    [sym_primitive_type] = ACTIONS(6037),
    [anon_sym_QMARK] = ACTIONS(6039),
    [anon_sym_LT_EQ_GT] = ACTIONS(6039),
    [anon_sym_or] = ACTIONS(6037),
    [anon_sym_and] = ACTIONS(6037),
    [anon_sym_bitor] = ACTIONS(6037),
    [anon_sym_xor] = ACTIONS(6037),
    [anon_sym_bitand] = ACTIONS(6037),
    [anon_sym_not_eq] = ACTIONS(6037),
    [anon_sym_DASH_DASH] = ACTIONS(6039),
    [anon_sym_PLUS_PLUS] = ACTIONS(6039),
    [anon_sym_DOT] = ACTIONS(6037),
    [anon_sym_DOT_STAR] = ACTIONS(6039),
    [anon_sym_DASH_GT] = ACTIONS(6039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6037),
    [anon_sym_decltype] = ACTIONS(6037),
    [anon_sym_final] = ACTIONS(6037),
    [anon_sym_override] = ACTIONS(6037),
    [anon_sym_requires] = ACTIONS(6037),
  },
  [2583] = {
    [sym_identifier] = ACTIONS(6137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6139),
    [anon_sym_COMMA] = ACTIONS(6139),
    [anon_sym_RPAREN] = ACTIONS(6139),
    [anon_sym_LPAREN2] = ACTIONS(6139),
    [anon_sym_DASH] = ACTIONS(6137),
    [anon_sym_PLUS] = ACTIONS(6137),
    [anon_sym_STAR] = ACTIONS(6139),
    [anon_sym_SLASH] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6139),
    [anon_sym_PIPE_PIPE] = ACTIONS(6139),
    [anon_sym_AMP_AMP] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_CARET] = ACTIONS(6139),
    [anon_sym_AMP] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6139),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_GT_EQ] = ACTIONS(6139),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_LT_LT] = ACTIONS(6139),
    [anon_sym_GT_GT] = ACTIONS(6139),
    [anon_sym_COLON] = ACTIONS(6139),
    [anon_sym_SEMI] = ACTIONS(6139),
    [anon_sym___extension__] = ACTIONS(6137),
    [anon_sym___attribute__] = ACTIONS(6137),
    [anon_sym___attribute] = ACTIONS(6137),
    [anon_sym___based] = ACTIONS(6137),
    [anon_sym_LBRACE] = ACTIONS(6139),
    [anon_sym_RBRACE] = ACTIONS(6139),
    [anon_sym_signed] = ACTIONS(6137),
    [anon_sym_unsigned] = ACTIONS(6137),
    [anon_sym_long] = ACTIONS(6137),
    [anon_sym_short] = ACTIONS(6137),
    [anon_sym_LBRACK] = ACTIONS(6139),
    [anon_sym_RBRACK] = ACTIONS(6139),
    [anon_sym_const] = ACTIONS(6137),
    [anon_sym_constexpr] = ACTIONS(6137),
    [anon_sym_volatile] = ACTIONS(6137),
    [anon_sym_restrict] = ACTIONS(6137),
    [anon_sym___restrict__] = ACTIONS(6137),
    [anon_sym__Atomic] = ACTIONS(6137),
    [anon_sym__Noreturn] = ACTIONS(6137),
    [anon_sym_noreturn] = ACTIONS(6137),
    [anon_sym__Nonnull] = ACTIONS(6137),
    [anon_sym_mutable] = ACTIONS(6137),
    [anon_sym_constinit] = ACTIONS(6137),
    [anon_sym_consteval] = ACTIONS(6137),
    [anon_sym_alignas] = ACTIONS(6137),
    [anon_sym__Alignas] = ACTIONS(6137),
    [sym_primitive_type] = ACTIONS(6137),
    [anon_sym_QMARK] = ACTIONS(6139),
    [anon_sym_LT_EQ_GT] = ACTIONS(6139),
    [anon_sym_or] = ACTIONS(6137),
    [anon_sym_and] = ACTIONS(6137),
    [anon_sym_bitor] = ACTIONS(6137),
    [anon_sym_xor] = ACTIONS(6137),
    [anon_sym_bitand] = ACTIONS(6137),
    [anon_sym_not_eq] = ACTIONS(6137),
    [anon_sym_DASH_DASH] = ACTIONS(6139),
    [anon_sym_PLUS_PLUS] = ACTIONS(6139),
    [anon_sym_DOT] = ACTIONS(6137),
    [anon_sym_DOT_STAR] = ACTIONS(6139),
    [anon_sym_DASH_GT] = ACTIONS(6139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6137),
    [anon_sym_decltype] = ACTIONS(6137),
    [anon_sym_final] = ACTIONS(6137),
    [anon_sym_override] = ACTIONS(6137),
    [anon_sym_requires] = ACTIONS(6137),
  },
  [2584] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(4029),
    [sym__declarator] = STATE(6372),
    [sym__abstract_declarator] = STATE(6720),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(2963),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3253),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(2963),
    [aux_sym_pointer_declarator_repeat1] = STATE(4029),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6536),
    [anon_sym_RPAREN] = ACTIONS(6536),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_AMP_AMP] = ACTIONS(6486),
    [anon_sym_AMP] = ACTIONS(6488),
    [anon_sym_COLON] = ACTIONS(6538),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6538),
    [anon_sym___attribute] = ACTIONS(6538),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_EQ] = ACTIONS(6536),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(6536),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2585] = {
    [sym_identifier] = ACTIONS(5989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5991),
    [anon_sym_LPAREN2] = ACTIONS(5991),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5991),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_PERCENT] = ACTIONS(5991),
    [anon_sym_PIPE_PIPE] = ACTIONS(5991),
    [anon_sym_AMP_AMP] = ACTIONS(5991),
    [anon_sym_PIPE] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5991),
    [anon_sym_AMP] = ACTIONS(5989),
    [anon_sym_EQ_EQ] = ACTIONS(5991),
    [anon_sym_BANG_EQ] = ACTIONS(5991),
    [anon_sym_GT] = ACTIONS(5989),
    [anon_sym_GT_EQ] = ACTIONS(5991),
    [anon_sym_LT_EQ] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5989),
    [anon_sym_LT_LT] = ACTIONS(5991),
    [anon_sym_GT_GT] = ACTIONS(5991),
    [anon_sym_COLON] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(5991),
    [anon_sym___extension__] = ACTIONS(5989),
    [anon_sym___attribute__] = ACTIONS(5989),
    [anon_sym___attribute] = ACTIONS(5989),
    [anon_sym___based] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5991),
    [anon_sym_RBRACE] = ACTIONS(5991),
    [anon_sym_signed] = ACTIONS(5989),
    [anon_sym_unsigned] = ACTIONS(5989),
    [anon_sym_long] = ACTIONS(5989),
    [anon_sym_short] = ACTIONS(5989),
    [anon_sym_LBRACK] = ACTIONS(5991),
    [anon_sym_RBRACK] = ACTIONS(5991),
    [anon_sym_const] = ACTIONS(5989),
    [anon_sym_constexpr] = ACTIONS(5989),
    [anon_sym_volatile] = ACTIONS(5989),
    [anon_sym_restrict] = ACTIONS(5989),
    [anon_sym___restrict__] = ACTIONS(5989),
    [anon_sym__Atomic] = ACTIONS(5989),
    [anon_sym__Noreturn] = ACTIONS(5989),
    [anon_sym_noreturn] = ACTIONS(5989),
    [anon_sym__Nonnull] = ACTIONS(5989),
    [anon_sym_mutable] = ACTIONS(5989),
    [anon_sym_constinit] = ACTIONS(5989),
    [anon_sym_consteval] = ACTIONS(5989),
    [anon_sym_alignas] = ACTIONS(5989),
    [anon_sym__Alignas] = ACTIONS(5989),
    [sym_primitive_type] = ACTIONS(5989),
    [anon_sym_QMARK] = ACTIONS(5991),
    [anon_sym_LT_EQ_GT] = ACTIONS(5991),
    [anon_sym_or] = ACTIONS(5989),
    [anon_sym_and] = ACTIONS(5989),
    [anon_sym_bitor] = ACTIONS(5989),
    [anon_sym_xor] = ACTIONS(5989),
    [anon_sym_bitand] = ACTIONS(5989),
    [anon_sym_not_eq] = ACTIONS(5989),
    [anon_sym_DASH_DASH] = ACTIONS(5991),
    [anon_sym_PLUS_PLUS] = ACTIONS(5991),
    [anon_sym_DOT] = ACTIONS(5989),
    [anon_sym_DOT_STAR] = ACTIONS(5991),
    [anon_sym_DASH_GT] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5989),
    [anon_sym_decltype] = ACTIONS(5989),
    [anon_sym_final] = ACTIONS(5989),
    [anon_sym_override] = ACTIONS(5989),
    [anon_sym_requires] = ACTIONS(5989),
  },
  [2586] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6047),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6047),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6047),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6047),
    [anon_sym_GT_GT] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___extension__] = ACTIONS(6045),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym___based] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_signed] = ACTIONS(6045),
    [anon_sym_unsigned] = ACTIONS(6045),
    [anon_sym_long] = ACTIONS(6045),
    [anon_sym_short] = ACTIONS(6045),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_const] = ACTIONS(6045),
    [anon_sym_constexpr] = ACTIONS(6045),
    [anon_sym_volatile] = ACTIONS(6045),
    [anon_sym_restrict] = ACTIONS(6045),
    [anon_sym___restrict__] = ACTIONS(6045),
    [anon_sym__Atomic] = ACTIONS(6045),
    [anon_sym__Noreturn] = ACTIONS(6045),
    [anon_sym_noreturn] = ACTIONS(6045),
    [anon_sym__Nonnull] = ACTIONS(6045),
    [anon_sym_mutable] = ACTIONS(6045),
    [anon_sym_constinit] = ACTIONS(6045),
    [anon_sym_consteval] = ACTIONS(6045),
    [anon_sym_alignas] = ACTIONS(6045),
    [anon_sym__Alignas] = ACTIONS(6045),
    [sym_primitive_type] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
    [anon_sym_final] = ACTIONS(6045),
    [anon_sym_override] = ACTIONS(6045),
    [anon_sym_requires] = ACTIONS(6045),
  },
  [2587] = {
    [sym_identifier] = ACTIONS(6049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [anon_sym_LPAREN2] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6051),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_PERCENT] = ACTIONS(6051),
    [anon_sym_PIPE_PIPE] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(6051),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6051),
    [anon_sym_AMP] = ACTIONS(6049),
    [anon_sym_EQ_EQ] = ACTIONS(6051),
    [anon_sym_BANG_EQ] = ACTIONS(6051),
    [anon_sym_GT] = ACTIONS(6049),
    [anon_sym_GT_EQ] = ACTIONS(6051),
    [anon_sym_LT_EQ] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6049),
    [anon_sym_LT_LT] = ACTIONS(6051),
    [anon_sym_GT_GT] = ACTIONS(6051),
    [anon_sym_COLON] = ACTIONS(6051),
    [anon_sym_SEMI] = ACTIONS(6051),
    [anon_sym___extension__] = ACTIONS(6049),
    [anon_sym___attribute__] = ACTIONS(6049),
    [anon_sym___attribute] = ACTIONS(6049),
    [anon_sym___based] = ACTIONS(6049),
    [anon_sym_LBRACE] = ACTIONS(6051),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_signed] = ACTIONS(6049),
    [anon_sym_unsigned] = ACTIONS(6049),
    [anon_sym_long] = ACTIONS(6049),
    [anon_sym_short] = ACTIONS(6049),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_RBRACK] = ACTIONS(6051),
    [anon_sym_const] = ACTIONS(6049),
    [anon_sym_constexpr] = ACTIONS(6049),
    [anon_sym_volatile] = ACTIONS(6049),
    [anon_sym_restrict] = ACTIONS(6049),
    [anon_sym___restrict__] = ACTIONS(6049),
    [anon_sym__Atomic] = ACTIONS(6049),
    [anon_sym__Noreturn] = ACTIONS(6049),
    [anon_sym_noreturn] = ACTIONS(6049),
    [anon_sym__Nonnull] = ACTIONS(6049),
    [anon_sym_mutable] = ACTIONS(6049),
    [anon_sym_constinit] = ACTIONS(6049),
    [anon_sym_consteval] = ACTIONS(6049),
    [anon_sym_alignas] = ACTIONS(6049),
    [anon_sym__Alignas] = ACTIONS(6049),
    [sym_primitive_type] = ACTIONS(6049),
    [anon_sym_QMARK] = ACTIONS(6051),
    [anon_sym_LT_EQ_GT] = ACTIONS(6051),
    [anon_sym_or] = ACTIONS(6049),
    [anon_sym_and] = ACTIONS(6049),
    [anon_sym_bitor] = ACTIONS(6049),
    [anon_sym_xor] = ACTIONS(6049),
    [anon_sym_bitand] = ACTIONS(6049),
    [anon_sym_not_eq] = ACTIONS(6049),
    [anon_sym_DASH_DASH] = ACTIONS(6051),
    [anon_sym_PLUS_PLUS] = ACTIONS(6051),
    [anon_sym_DOT] = ACTIONS(6049),
    [anon_sym_DOT_STAR] = ACTIONS(6051),
    [anon_sym_DASH_GT] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6049),
    [anon_sym_decltype] = ACTIONS(6049),
    [anon_sym_final] = ACTIONS(6049),
    [anon_sym_override] = ACTIONS(6049),
    [anon_sym_requires] = ACTIONS(6049),
  },
  [2588] = {
    [sym_identifier] = ACTIONS(6057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_LPAREN2] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6057),
    [anon_sym_PLUS] = ACTIONS(6057),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6057),
    [anon_sym_PERCENT] = ACTIONS(6059),
    [anon_sym_PIPE_PIPE] = ACTIONS(6059),
    [anon_sym_AMP_AMP] = ACTIONS(6059),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_BANG_EQ] = ACTIONS(6059),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_GT_EQ] = ACTIONS(6059),
    [anon_sym_LT_EQ] = ACTIONS(6057),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_LT_LT] = ACTIONS(6059),
    [anon_sym_GT_GT] = ACTIONS(6059),
    [anon_sym_COLON] = ACTIONS(6059),
    [anon_sym_SEMI] = ACTIONS(6059),
    [anon_sym___extension__] = ACTIONS(6057),
    [anon_sym___attribute__] = ACTIONS(6057),
    [anon_sym___attribute] = ACTIONS(6057),
    [anon_sym___based] = ACTIONS(6057),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_signed] = ACTIONS(6057),
    [anon_sym_unsigned] = ACTIONS(6057),
    [anon_sym_long] = ACTIONS(6057),
    [anon_sym_short] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_const] = ACTIONS(6057),
    [anon_sym_constexpr] = ACTIONS(6057),
    [anon_sym_volatile] = ACTIONS(6057),
    [anon_sym_restrict] = ACTIONS(6057),
    [anon_sym___restrict__] = ACTIONS(6057),
    [anon_sym__Atomic] = ACTIONS(6057),
    [anon_sym__Noreturn] = ACTIONS(6057),
    [anon_sym_noreturn] = ACTIONS(6057),
    [anon_sym__Nonnull] = ACTIONS(6057),
    [anon_sym_mutable] = ACTIONS(6057),
    [anon_sym_constinit] = ACTIONS(6057),
    [anon_sym_consteval] = ACTIONS(6057),
    [anon_sym_alignas] = ACTIONS(6057),
    [anon_sym__Alignas] = ACTIONS(6057),
    [sym_primitive_type] = ACTIONS(6057),
    [anon_sym_QMARK] = ACTIONS(6059),
    [anon_sym_LT_EQ_GT] = ACTIONS(6059),
    [anon_sym_or] = ACTIONS(6057),
    [anon_sym_and] = ACTIONS(6057),
    [anon_sym_bitor] = ACTIONS(6057),
    [anon_sym_xor] = ACTIONS(6057),
    [anon_sym_bitand] = ACTIONS(6057),
    [anon_sym_not_eq] = ACTIONS(6057),
    [anon_sym_DASH_DASH] = ACTIONS(6059),
    [anon_sym_PLUS_PLUS] = ACTIONS(6059),
    [anon_sym_DOT] = ACTIONS(6057),
    [anon_sym_DOT_STAR] = ACTIONS(6059),
    [anon_sym_DASH_GT] = ACTIONS(6059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6057),
    [anon_sym_decltype] = ACTIONS(6057),
    [anon_sym_final] = ACTIONS(6057),
    [anon_sym_override] = ACTIONS(6057),
    [anon_sym_requires] = ACTIONS(6057),
  },
  [2589] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2286),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2286),
    [anon_sym_GT_GT] = ACTIONS(2286),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___extension__] = ACTIONS(2284),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym___based] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_signed] = ACTIONS(2284),
    [anon_sym_unsigned] = ACTIONS(2284),
    [anon_sym_long] = ACTIONS(2284),
    [anon_sym_short] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_constexpr] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_restrict] = ACTIONS(2284),
    [anon_sym___restrict__] = ACTIONS(2284),
    [anon_sym__Atomic] = ACTIONS(2284),
    [anon_sym__Noreturn] = ACTIONS(2284),
    [anon_sym_noreturn] = ACTIONS(2284),
    [anon_sym__Nonnull] = ACTIONS(2284),
    [anon_sym_mutable] = ACTIONS(2284),
    [anon_sym_constinit] = ACTIONS(2284),
    [anon_sym_consteval] = ACTIONS(2284),
    [anon_sym_alignas] = ACTIONS(2284),
    [anon_sym__Alignas] = ACTIONS(2284),
    [sym_primitive_type] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
    [anon_sym_final] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_requires] = ACTIONS(2284),
  },
  [2590] = {
    [sym_identifier] = ACTIONS(6019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6021),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [anon_sym_LPAREN2] = ACTIONS(6021),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_PERCENT] = ACTIONS(6021),
    [anon_sym_PIPE_PIPE] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6021),
    [anon_sym_AMP] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6021),
    [anon_sym_BANG_EQ] = ACTIONS(6021),
    [anon_sym_GT] = ACTIONS(6019),
    [anon_sym_GT_EQ] = ACTIONS(6021),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6019),
    [anon_sym_LT_LT] = ACTIONS(6021),
    [anon_sym_GT_GT] = ACTIONS(6021),
    [anon_sym_COLON] = ACTIONS(6021),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym___extension__] = ACTIONS(6019),
    [anon_sym___attribute__] = ACTIONS(6019),
    [anon_sym___attribute] = ACTIONS(6019),
    [anon_sym___based] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6021),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_signed] = ACTIONS(6019),
    [anon_sym_unsigned] = ACTIONS(6019),
    [anon_sym_long] = ACTIONS(6019),
    [anon_sym_short] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_RBRACK] = ACTIONS(6021),
    [anon_sym_const] = ACTIONS(6019),
    [anon_sym_constexpr] = ACTIONS(6019),
    [anon_sym_volatile] = ACTIONS(6019),
    [anon_sym_restrict] = ACTIONS(6019),
    [anon_sym___restrict__] = ACTIONS(6019),
    [anon_sym__Atomic] = ACTIONS(6019),
    [anon_sym__Noreturn] = ACTIONS(6019),
    [anon_sym_noreturn] = ACTIONS(6019),
    [anon_sym__Nonnull] = ACTIONS(6019),
    [anon_sym_mutable] = ACTIONS(6019),
    [anon_sym_constinit] = ACTIONS(6019),
    [anon_sym_consteval] = ACTIONS(6019),
    [anon_sym_alignas] = ACTIONS(6019),
    [anon_sym__Alignas] = ACTIONS(6019),
    [sym_primitive_type] = ACTIONS(6019),
    [anon_sym_QMARK] = ACTIONS(6021),
    [anon_sym_LT_EQ_GT] = ACTIONS(6021),
    [anon_sym_or] = ACTIONS(6019),
    [anon_sym_and] = ACTIONS(6019),
    [anon_sym_bitor] = ACTIONS(6019),
    [anon_sym_xor] = ACTIONS(6019),
    [anon_sym_bitand] = ACTIONS(6019),
    [anon_sym_not_eq] = ACTIONS(6019),
    [anon_sym_DASH_DASH] = ACTIONS(6021),
    [anon_sym_PLUS_PLUS] = ACTIONS(6021),
    [anon_sym_DOT] = ACTIONS(6019),
    [anon_sym_DOT_STAR] = ACTIONS(6021),
    [anon_sym_DASH_GT] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6019),
    [anon_sym_decltype] = ACTIONS(6019),
    [anon_sym_final] = ACTIONS(6019),
    [anon_sym_override] = ACTIONS(6019),
    [anon_sym_requires] = ACTIONS(6019),
  },
  [2591] = {
    [sym_template_argument_list] = STATE(2878),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2314),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_LPAREN2] = ACTIONS(4238),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym___extension__] = ACTIONS(4215),
    [anon_sym_in] = ACTIONS(4215),
    [anon_sym_out] = ACTIONS(4215),
    [anon_sym_inout] = ACTIONS(4215),
    [anon_sym_virtual] = ACTIONS(4215),
    [anon_sym_extern] = ACTIONS(4215),
    [anon_sym___attribute__] = ACTIONS(4215),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4238),
    [anon_sym___declspec] = ACTIONS(4215),
    [anon_sym___based] = ACTIONS(4215),
    [anon_sym_signed] = ACTIONS(4241),
    [anon_sym_unsigned] = ACTIONS(4241),
    [anon_sym_long] = ACTIONS(4241),
    [anon_sym_short] = ACTIONS(4241),
    [anon_sym_LBRACK] = ACTIONS(6540),
    [anon_sym_static] = ACTIONS(4215),
    [anon_sym_register] = ACTIONS(4215),
    [anon_sym_inline] = ACTIONS(4215),
    [anon_sym___inline] = ACTIONS(4215),
    [anon_sym___inline__] = ACTIONS(4215),
    [anon_sym___forceinline] = ACTIONS(4215),
    [anon_sym_thread_local] = ACTIONS(4215),
    [anon_sym___thread] = ACTIONS(4215),
    [anon_sym_const] = ACTIONS(4215),
    [anon_sym_constexpr] = ACTIONS(4215),
    [anon_sym_volatile] = ACTIONS(4215),
    [anon_sym_restrict] = ACTIONS(4215),
    [anon_sym___restrict__] = ACTIONS(4215),
    [anon_sym__Atomic] = ACTIONS(4215),
    [anon_sym__Noreturn] = ACTIONS(4215),
    [anon_sym_noreturn] = ACTIONS(4215),
    [anon_sym__Nonnull] = ACTIONS(4215),
    [anon_sym_mutable] = ACTIONS(4215),
    [anon_sym_constinit] = ACTIONS(4215),
    [anon_sym_consteval] = ACTIONS(4215),
    [anon_sym_alignas] = ACTIONS(4215),
    [anon_sym__Alignas] = ACTIONS(4215),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
    [anon_sym_operator] = ACTIONS(4215),
    [anon_sym_precise] = ACTIONS(4215),
    [anon_sym_shared] = ACTIONS(4215),
    [anon_sym_groupshared] = ACTIONS(4215),
    [anon_sym_uniform] = ACTIONS(4215),
    [anon_sym_row_major] = ACTIONS(4215),
    [anon_sym_column_major] = ACTIONS(4215),
    [anon_sym_globallycoherent] = ACTIONS(4215),
    [anon_sym_centroid] = ACTIONS(4215),
    [anon_sym_noperspective] = ACTIONS(4215),
    [anon_sym_nointerpolation] = ACTIONS(4215),
    [anon_sym_sample] = ACTIONS(4215),
    [anon_sym_linear] = ACTIONS(4215),
    [anon_sym_snorm] = ACTIONS(4215),
    [anon_sym_unorm] = ACTIONS(4215),
    [anon_sym_point] = ACTIONS(4215),
    [anon_sym_line] = ACTIONS(4215),
    [anon_sym_triangleadj] = ACTIONS(4215),
    [anon_sym_lineadj] = ACTIONS(4215),
    [anon_sym_triangle] = ACTIONS(4215),
  },
  [2592] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_TILDE] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym___extension__] = ACTIONS(2038),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_out] = ACTIONS(2038),
    [anon_sym_inout] = ACTIONS(2038),
    [anon_sym_virtual] = ACTIONS(2038),
    [anon_sym_extern] = ACTIONS(2038),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4453),
    [anon_sym___declspec] = ACTIONS(2038),
    [anon_sym___based] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_static] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(2040),
    [anon_sym_register] = ACTIONS(2038),
    [anon_sym_inline] = ACTIONS(2038),
    [anon_sym___inline] = ACTIONS(2038),
    [anon_sym___inline__] = ACTIONS(2038),
    [anon_sym___forceinline] = ACTIONS(2038),
    [anon_sym_thread_local] = ACTIONS(2038),
    [anon_sym___thread] = ACTIONS(2038),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2038),
    [anon_sym_volatile] = ACTIONS(2038),
    [anon_sym_restrict] = ACTIONS(2038),
    [anon_sym___restrict__] = ACTIONS(2038),
    [anon_sym__Atomic] = ACTIONS(2038),
    [anon_sym__Noreturn] = ACTIONS(2038),
    [anon_sym_noreturn] = ACTIONS(2038),
    [anon_sym__Nonnull] = ACTIONS(2038),
    [anon_sym_mutable] = ACTIONS(2038),
    [anon_sym_constinit] = ACTIONS(2038),
    [anon_sym_consteval] = ACTIONS(2038),
    [anon_sym_alignas] = ACTIONS(2038),
    [anon_sym__Alignas] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_template] = ACTIONS(2038),
    [anon_sym_operator] = ACTIONS(2038),
    [anon_sym_precise] = ACTIONS(2038),
    [anon_sym_shared] = ACTIONS(2038),
    [anon_sym_groupshared] = ACTIONS(2038),
    [anon_sym_uniform] = ACTIONS(2038),
    [anon_sym_row_major] = ACTIONS(2038),
    [anon_sym_column_major] = ACTIONS(2038),
    [anon_sym_globallycoherent] = ACTIONS(2038),
    [anon_sym_centroid] = ACTIONS(2038),
    [anon_sym_noperspective] = ACTIONS(2038),
    [anon_sym_nointerpolation] = ACTIONS(2038),
    [anon_sym_sample] = ACTIONS(2038),
    [anon_sym_linear] = ACTIONS(2038),
    [anon_sym_snorm] = ACTIONS(2038),
    [anon_sym_unorm] = ACTIONS(2038),
    [anon_sym_point] = ACTIONS(2038),
    [anon_sym_line] = ACTIONS(2038),
    [anon_sym_triangleadj] = ACTIONS(2038),
    [anon_sym_lineadj] = ACTIONS(2038),
    [anon_sym_triangle] = ACTIONS(2038),
  },
  [2593] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_DASH] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6013),
    [anon_sym_SLASH] = ACTIONS(6011),
    [anon_sym_PERCENT] = ACTIONS(6013),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_PIPE] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6013),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6013),
    [anon_sym_BANG_EQ] = ACTIONS(6013),
    [anon_sym_GT] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6013),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6013),
    [anon_sym_GT_GT] = ACTIONS(6013),
    [anon_sym_COLON] = ACTIONS(6013),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___extension__] = ACTIONS(6011),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym___based] = ACTIONS(6011),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_signed] = ACTIONS(6011),
    [anon_sym_unsigned] = ACTIONS(6011),
    [anon_sym_long] = ACTIONS(6011),
    [anon_sym_short] = ACTIONS(6011),
    [anon_sym_LBRACK] = ACTIONS(6013),
    [anon_sym_RBRACK] = ACTIONS(6013),
    [anon_sym_const] = ACTIONS(6011),
    [anon_sym_constexpr] = ACTIONS(6011),
    [anon_sym_volatile] = ACTIONS(6011),
    [anon_sym_restrict] = ACTIONS(6011),
    [anon_sym___restrict__] = ACTIONS(6011),
    [anon_sym__Atomic] = ACTIONS(6011),
    [anon_sym__Noreturn] = ACTIONS(6011),
    [anon_sym_noreturn] = ACTIONS(6011),
    [anon_sym__Nonnull] = ACTIONS(6011),
    [anon_sym_mutable] = ACTIONS(6011),
    [anon_sym_constinit] = ACTIONS(6011),
    [anon_sym_consteval] = ACTIONS(6011),
    [anon_sym_alignas] = ACTIONS(6011),
    [anon_sym__Alignas] = ACTIONS(6011),
    [sym_primitive_type] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6013),
    [anon_sym_LT_EQ_GT] = ACTIONS(6013),
    [anon_sym_or] = ACTIONS(6011),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_bitor] = ACTIONS(6011),
    [anon_sym_xor] = ACTIONS(6011),
    [anon_sym_bitand] = ACTIONS(6011),
    [anon_sym_not_eq] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6013),
    [anon_sym_PLUS_PLUS] = ACTIONS(6013),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_DOT_STAR] = ACTIONS(6013),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
    [anon_sym_final] = ACTIONS(6011),
    [anon_sym_override] = ACTIONS(6011),
    [anon_sym_requires] = ACTIONS(6011),
  },
  [2594] = {
    [sym_identifier] = ACTIONS(5654),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [aux_sym_preproc_if_token2] = ACTIONS(5656),
    [aux_sym_preproc_else_token1] = ACTIONS(5656),
    [aux_sym_preproc_elif_token1] = ACTIONS(5654),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5654),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5656),
    [anon_sym_GT_GT] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___extension__] = ACTIONS(5654),
    [anon_sym___attribute__] = ACTIONS(5654),
    [anon_sym___attribute] = ACTIONS(5654),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_const] = ACTIONS(5654),
    [anon_sym_constexpr] = ACTIONS(5654),
    [anon_sym_volatile] = ACTIONS(5654),
    [anon_sym_restrict] = ACTIONS(5654),
    [anon_sym___restrict__] = ACTIONS(5654),
    [anon_sym__Atomic] = ACTIONS(5654),
    [anon_sym__Noreturn] = ACTIONS(5654),
    [anon_sym_noreturn] = ACTIONS(5654),
    [anon_sym__Nonnull] = ACTIONS(5654),
    [anon_sym_mutable] = ACTIONS(5654),
    [anon_sym_constinit] = ACTIONS(5654),
    [anon_sym_consteval] = ACTIONS(5654),
    [anon_sym_alignas] = ACTIONS(5654),
    [anon_sym__Alignas] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5656),
    [anon_sym_LT_EQ_GT] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5654),
    [anon_sym_and] = ACTIONS(5654),
    [anon_sym_bitor] = ACTIONS(5654),
    [anon_sym_xor] = ACTIONS(5654),
    [anon_sym_bitand] = ACTIONS(5654),
    [anon_sym_not_eq] = ACTIONS(5654),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_DOT_STAR] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5654),
    [anon_sym_decltype] = ACTIONS(5654),
    [anon_sym_final] = ACTIONS(5654),
    [anon_sym_override] = ACTIONS(5654),
    [anon_sym_requires] = ACTIONS(5654),
  },
  [2595] = {
    [sym_template_argument_list] = STATE(2624),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [aux_sym_preproc_if_token2] = ACTIONS(1999),
    [aux_sym_preproc_else_token1] = ACTIONS(1999),
    [aux_sym_preproc_elif_token1] = ACTIONS(1997),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1999),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1999),
    [anon_sym_LPAREN2] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1997),
    [anon_sym_PERCENT] = ACTIONS(1997),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_CARET] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_EQ_EQ] = ACTIONS(1999),
    [anon_sym_BANG_EQ] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_GT_GT] = ACTIONS(1997),
    [anon_sym_COLON] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1999),
    [anon_sym_RBRACK] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_QMARK] = ACTIONS(1999),
    [anon_sym_STAR_EQ] = ACTIONS(1999),
    [anon_sym_SLASH_EQ] = ACTIONS(1999),
    [anon_sym_PERCENT_EQ] = ACTIONS(1999),
    [anon_sym_PLUS_EQ] = ACTIONS(1999),
    [anon_sym_DASH_EQ] = ACTIONS(1999),
    [anon_sym_LT_LT_EQ] = ACTIONS(1999),
    [anon_sym_GT_GT_EQ] = ACTIONS(1999),
    [anon_sym_AMP_EQ] = ACTIONS(1999),
    [anon_sym_CARET_EQ] = ACTIONS(1999),
    [anon_sym_PIPE_EQ] = ACTIONS(1999),
    [anon_sym_and_eq] = ACTIONS(1997),
    [anon_sym_or_eq] = ACTIONS(1997),
    [anon_sym_xor_eq] = ACTIONS(1997),
    [anon_sym_LT_EQ_GT] = ACTIONS(1999),
    [anon_sym_or] = ACTIONS(1997),
    [anon_sym_and] = ACTIONS(1997),
    [anon_sym_bitor] = ACTIONS(1997),
    [anon_sym_xor] = ACTIONS(1997),
    [anon_sym_bitand] = ACTIONS(1997),
    [anon_sym_not_eq] = ACTIONS(1997),
    [anon_sym_DASH_DASH] = ACTIONS(1999),
    [anon_sym_PLUS_PLUS] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_DOT_STAR] = ACTIONS(1999),
    [anon_sym_DASH_GT] = ACTIONS(1999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_final] = ACTIONS(1997),
    [anon_sym_override] = ACTIONS(1997),
  },
  [2596] = {
    [sym_argument_list] = STATE(2899),
    [sym_initializer_list] = STATE(2899),
    [sym_decltype_auto] = STATE(2729),
    [sym_new_declarator] = STATE(2750),
    [sym_identifier] = ACTIONS(6545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6547),
    [anon_sym_COMMA] = ACTIONS(6547),
    [anon_sym_RPAREN] = ACTIONS(6547),
    [aux_sym_preproc_if_token2] = ACTIONS(6547),
    [aux_sym_preproc_else_token1] = ACTIONS(6547),
    [aux_sym_preproc_elif_token1] = ACTIONS(6545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6547),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6545),
    [anon_sym_PLUS] = ACTIONS(6545),
    [anon_sym_STAR] = ACTIONS(6545),
    [anon_sym_SLASH] = ACTIONS(6545),
    [anon_sym_PERCENT] = ACTIONS(6545),
    [anon_sym_PIPE_PIPE] = ACTIONS(6547),
    [anon_sym_AMP_AMP] = ACTIONS(6547),
    [anon_sym_PIPE] = ACTIONS(6545),
    [anon_sym_CARET] = ACTIONS(6545),
    [anon_sym_AMP] = ACTIONS(6545),
    [anon_sym_EQ_EQ] = ACTIONS(6547),
    [anon_sym_BANG_EQ] = ACTIONS(6547),
    [anon_sym_GT] = ACTIONS(6545),
    [anon_sym_GT_EQ] = ACTIONS(6547),
    [anon_sym_LT_EQ] = ACTIONS(6545),
    [anon_sym_LT] = ACTIONS(6545),
    [anon_sym_LT_LT] = ACTIONS(6545),
    [anon_sym_GT_GT] = ACTIONS(6545),
    [anon_sym_COLON] = ACTIONS(6547),
    [anon_sym_SEMI] = ACTIONS(6547),
    [anon_sym___attribute__] = ACTIONS(6545),
    [anon_sym___attribute] = ACTIONS(6545),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6547),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6547),
    [anon_sym_EQ] = ACTIONS(6545),
    [anon_sym_QMARK] = ACTIONS(6547),
    [anon_sym_STAR_EQ] = ACTIONS(6547),
    [anon_sym_SLASH_EQ] = ACTIONS(6547),
    [anon_sym_PERCENT_EQ] = ACTIONS(6547),
    [anon_sym_PLUS_EQ] = ACTIONS(6547),
    [anon_sym_DASH_EQ] = ACTIONS(6547),
    [anon_sym_LT_LT_EQ] = ACTIONS(6547),
    [anon_sym_GT_GT_EQ] = ACTIONS(6547),
    [anon_sym_AMP_EQ] = ACTIONS(6547),
    [anon_sym_CARET_EQ] = ACTIONS(6547),
    [anon_sym_PIPE_EQ] = ACTIONS(6547),
    [anon_sym_and_eq] = ACTIONS(6545),
    [anon_sym_or_eq] = ACTIONS(6545),
    [anon_sym_xor_eq] = ACTIONS(6545),
    [anon_sym_LT_EQ_GT] = ACTIONS(6547),
    [anon_sym_or] = ACTIONS(6545),
    [anon_sym_and] = ACTIONS(6545),
    [anon_sym_bitor] = ACTIONS(6545),
    [anon_sym_xor] = ACTIONS(6545),
    [anon_sym_bitand] = ACTIONS(6545),
    [anon_sym_not_eq] = ACTIONS(6545),
    [anon_sym_DASH_DASH] = ACTIONS(6547),
    [anon_sym_PLUS_PLUS] = ACTIONS(6547),
    [anon_sym_DOT] = ACTIONS(6545),
    [anon_sym_DOT_STAR] = ACTIONS(6547),
    [anon_sym_DASH_GT] = ACTIONS(6547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6553),
    [anon_sym_decltype] = ACTIONS(6555),
  },
  [2597] = {
    [sym_argument_list] = STATE(2907),
    [sym_initializer_list] = STATE(2907),
    [sym_decltype_auto] = STATE(2729),
    [sym_new_declarator] = STATE(2757),
    [sym_identifier] = ACTIONS(6557),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6559),
    [anon_sym_COMMA] = ACTIONS(6559),
    [anon_sym_RPAREN] = ACTIONS(6559),
    [aux_sym_preproc_if_token2] = ACTIONS(6559),
    [aux_sym_preproc_else_token1] = ACTIONS(6559),
    [aux_sym_preproc_elif_token1] = ACTIONS(6557),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6559),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6559),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6557),
    [anon_sym_PLUS] = ACTIONS(6557),
    [anon_sym_STAR] = ACTIONS(6557),
    [anon_sym_SLASH] = ACTIONS(6557),
    [anon_sym_PERCENT] = ACTIONS(6557),
    [anon_sym_PIPE_PIPE] = ACTIONS(6559),
    [anon_sym_AMP_AMP] = ACTIONS(6559),
    [anon_sym_PIPE] = ACTIONS(6557),
    [anon_sym_CARET] = ACTIONS(6557),
    [anon_sym_AMP] = ACTIONS(6557),
    [anon_sym_EQ_EQ] = ACTIONS(6559),
    [anon_sym_BANG_EQ] = ACTIONS(6559),
    [anon_sym_GT] = ACTIONS(6557),
    [anon_sym_GT_EQ] = ACTIONS(6559),
    [anon_sym_LT_EQ] = ACTIONS(6557),
    [anon_sym_LT] = ACTIONS(6557),
    [anon_sym_LT_LT] = ACTIONS(6557),
    [anon_sym_GT_GT] = ACTIONS(6557),
    [anon_sym_COLON] = ACTIONS(6559),
    [anon_sym_SEMI] = ACTIONS(6559),
    [anon_sym___attribute__] = ACTIONS(6557),
    [anon_sym___attribute] = ACTIONS(6557),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6559),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6559),
    [anon_sym_EQ] = ACTIONS(6557),
    [anon_sym_QMARK] = ACTIONS(6559),
    [anon_sym_STAR_EQ] = ACTIONS(6559),
    [anon_sym_SLASH_EQ] = ACTIONS(6559),
    [anon_sym_PERCENT_EQ] = ACTIONS(6559),
    [anon_sym_PLUS_EQ] = ACTIONS(6559),
    [anon_sym_DASH_EQ] = ACTIONS(6559),
    [anon_sym_LT_LT_EQ] = ACTIONS(6559),
    [anon_sym_GT_GT_EQ] = ACTIONS(6559),
    [anon_sym_AMP_EQ] = ACTIONS(6559),
    [anon_sym_CARET_EQ] = ACTIONS(6559),
    [anon_sym_PIPE_EQ] = ACTIONS(6559),
    [anon_sym_and_eq] = ACTIONS(6557),
    [anon_sym_or_eq] = ACTIONS(6557),
    [anon_sym_xor_eq] = ACTIONS(6557),
    [anon_sym_LT_EQ_GT] = ACTIONS(6559),
    [anon_sym_or] = ACTIONS(6557),
    [anon_sym_and] = ACTIONS(6557),
    [anon_sym_bitor] = ACTIONS(6557),
    [anon_sym_xor] = ACTIONS(6557),
    [anon_sym_bitand] = ACTIONS(6557),
    [anon_sym_not_eq] = ACTIONS(6557),
    [anon_sym_DASH_DASH] = ACTIONS(6559),
    [anon_sym_PLUS_PLUS] = ACTIONS(6559),
    [anon_sym_DOT] = ACTIONS(6557),
    [anon_sym_DOT_STAR] = ACTIONS(6559),
    [anon_sym_DASH_GT] = ACTIONS(6559),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6553),
    [anon_sym_decltype] = ACTIONS(6555),
  },
  [2598] = {
    [sym_type_qualifier] = STATE(2599),
    [sym_alignas_qualifier] = STATE(1369),
    [aux_sym__type_definition_type_repeat1] = STATE(2599),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2558),
    [sym_identifier] = ACTIONS(6561),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_STAR] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(5733),
    [anon_sym_in] = ACTIONS(5731),
    [anon_sym_out] = ACTIONS(5731),
    [anon_sym_inout] = ACTIONS(5731),
    [anon_sym_virtual] = ACTIONS(5731),
    [anon_sym_extern] = ACTIONS(5731),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5729),
    [anon_sym___declspec] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6563),
    [anon_sym_unsigned] = ACTIONS(6563),
    [anon_sym_long] = ACTIONS(6563),
    [anon_sym_short] = ACTIONS(6563),
    [anon_sym_LBRACK] = ACTIONS(5731),
    [anon_sym_static] = ACTIONS(5731),
    [anon_sym_register] = ACTIONS(5731),
    [anon_sym_inline] = ACTIONS(5731),
    [anon_sym___inline] = ACTIONS(5731),
    [anon_sym___inline__] = ACTIONS(5731),
    [anon_sym___forceinline] = ACTIONS(5731),
    [anon_sym_thread_local] = ACTIONS(5731),
    [anon_sym___thread] = ACTIONS(5731),
    [anon_sym_const] = ACTIONS(5733),
    [anon_sym_constexpr] = ACTIONS(5733),
    [anon_sym_volatile] = ACTIONS(5733),
    [anon_sym_restrict] = ACTIONS(5733),
    [anon_sym___restrict__] = ACTIONS(5733),
    [anon_sym__Atomic] = ACTIONS(5733),
    [anon_sym__Noreturn] = ACTIONS(5733),
    [anon_sym_noreturn] = ACTIONS(5733),
    [anon_sym__Nonnull] = ACTIONS(5733),
    [anon_sym_mutable] = ACTIONS(5733),
    [anon_sym_constinit] = ACTIONS(5733),
    [anon_sym_consteval] = ACTIONS(5733),
    [anon_sym_alignas] = ACTIONS(5738),
    [anon_sym__Alignas] = ACTIONS(5738),
    [sym_primitive_type] = ACTIONS(5741),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_precise] = ACTIONS(5731),
    [anon_sym_shared] = ACTIONS(5731),
    [anon_sym_groupshared] = ACTIONS(5731),
    [anon_sym_uniform] = ACTIONS(5731),
    [anon_sym_row_major] = ACTIONS(5731),
    [anon_sym_column_major] = ACTIONS(5731),
    [anon_sym_globallycoherent] = ACTIONS(5731),
    [anon_sym_centroid] = ACTIONS(5731),
    [anon_sym_noperspective] = ACTIONS(5731),
    [anon_sym_nointerpolation] = ACTIONS(5731),
    [anon_sym_sample] = ACTIONS(5731),
    [anon_sym_linear] = ACTIONS(5731),
    [anon_sym_snorm] = ACTIONS(5731),
    [anon_sym_unorm] = ACTIONS(5731),
    [anon_sym_point] = ACTIONS(5731),
    [anon_sym_line] = ACTIONS(5731),
    [anon_sym_triangleadj] = ACTIONS(5731),
    [anon_sym_lineadj] = ACTIONS(5731),
    [anon_sym_triangle] = ACTIONS(5731),
  },
  [2599] = {
    [sym_type_qualifier] = STATE(1312),
    [sym_alignas_qualifier] = STATE(1369),
    [aux_sym__type_definition_type_repeat1] = STATE(1312),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2320),
    [sym_identifier] = ACTIONS(6565),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(5757),
    [anon_sym_in] = ACTIONS(5755),
    [anon_sym_out] = ACTIONS(5755),
    [anon_sym_inout] = ACTIONS(5755),
    [anon_sym_virtual] = ACTIONS(5755),
    [anon_sym_extern] = ACTIONS(5755),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5753),
    [anon_sym___declspec] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(5760),
    [anon_sym_unsigned] = ACTIONS(5760),
    [anon_sym_long] = ACTIONS(5760),
    [anon_sym_short] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(5755),
    [anon_sym_static] = ACTIONS(5755),
    [anon_sym_register] = ACTIONS(5755),
    [anon_sym_inline] = ACTIONS(5755),
    [anon_sym___inline] = ACTIONS(5755),
    [anon_sym___inline__] = ACTIONS(5755),
    [anon_sym___forceinline] = ACTIONS(5755),
    [anon_sym_thread_local] = ACTIONS(5755),
    [anon_sym___thread] = ACTIONS(5755),
    [anon_sym_const] = ACTIONS(5757),
    [anon_sym_constexpr] = ACTIONS(5757),
    [anon_sym_volatile] = ACTIONS(5757),
    [anon_sym_restrict] = ACTIONS(5757),
    [anon_sym___restrict__] = ACTIONS(5757),
    [anon_sym__Atomic] = ACTIONS(5757),
    [anon_sym__Noreturn] = ACTIONS(5757),
    [anon_sym_noreturn] = ACTIONS(5757),
    [anon_sym__Nonnull] = ACTIONS(5757),
    [anon_sym_mutable] = ACTIONS(5757),
    [anon_sym_constinit] = ACTIONS(5757),
    [anon_sym_consteval] = ACTIONS(5757),
    [anon_sym_alignas] = ACTIONS(5762),
    [anon_sym__Alignas] = ACTIONS(5762),
    [sym_primitive_type] = ACTIONS(5765),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_precise] = ACTIONS(5755),
    [anon_sym_shared] = ACTIONS(5755),
    [anon_sym_groupshared] = ACTIONS(5755),
    [anon_sym_uniform] = ACTIONS(5755),
    [anon_sym_row_major] = ACTIONS(5755),
    [anon_sym_column_major] = ACTIONS(5755),
    [anon_sym_globallycoherent] = ACTIONS(5755),
    [anon_sym_centroid] = ACTIONS(5755),
    [anon_sym_noperspective] = ACTIONS(5755),
    [anon_sym_nointerpolation] = ACTIONS(5755),
    [anon_sym_sample] = ACTIONS(5755),
    [anon_sym_linear] = ACTIONS(5755),
    [anon_sym_snorm] = ACTIONS(5755),
    [anon_sym_unorm] = ACTIONS(5755),
    [anon_sym_point] = ACTIONS(5755),
    [anon_sym_line] = ACTIONS(5755),
    [anon_sym_triangleadj] = ACTIONS(5755),
    [anon_sym_lineadj] = ACTIONS(5755),
    [anon_sym_triangle] = ACTIONS(5755),
  },
  [2600] = {
    [sym_argument_list] = STATE(2945),
    [sym_initializer_list] = STATE(2945),
    [sym_decltype_auto] = STATE(2729),
    [sym_new_declarator] = STATE(2755),
    [sym_identifier] = ACTIONS(6567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6569),
    [anon_sym_COMMA] = ACTIONS(6569),
    [anon_sym_RPAREN] = ACTIONS(6569),
    [aux_sym_preproc_if_token2] = ACTIONS(6569),
    [aux_sym_preproc_else_token1] = ACTIONS(6569),
    [aux_sym_preproc_elif_token1] = ACTIONS(6567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6569),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6569),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6567),
    [anon_sym_PLUS] = ACTIONS(6567),
    [anon_sym_STAR] = ACTIONS(6567),
    [anon_sym_SLASH] = ACTIONS(6567),
    [anon_sym_PERCENT] = ACTIONS(6567),
    [anon_sym_PIPE_PIPE] = ACTIONS(6569),
    [anon_sym_AMP_AMP] = ACTIONS(6569),
    [anon_sym_PIPE] = ACTIONS(6567),
    [anon_sym_CARET] = ACTIONS(6567),
    [anon_sym_AMP] = ACTIONS(6567),
    [anon_sym_EQ_EQ] = ACTIONS(6569),
    [anon_sym_BANG_EQ] = ACTIONS(6569),
    [anon_sym_GT] = ACTIONS(6567),
    [anon_sym_GT_EQ] = ACTIONS(6569),
    [anon_sym_LT_EQ] = ACTIONS(6567),
    [anon_sym_LT] = ACTIONS(6567),
    [anon_sym_LT_LT] = ACTIONS(6567),
    [anon_sym_GT_GT] = ACTIONS(6567),
    [anon_sym_COLON] = ACTIONS(6569),
    [anon_sym_SEMI] = ACTIONS(6569),
    [anon_sym___attribute__] = ACTIONS(6567),
    [anon_sym___attribute] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6569),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6569),
    [anon_sym_EQ] = ACTIONS(6567),
    [anon_sym_QMARK] = ACTIONS(6569),
    [anon_sym_STAR_EQ] = ACTIONS(6569),
    [anon_sym_SLASH_EQ] = ACTIONS(6569),
    [anon_sym_PERCENT_EQ] = ACTIONS(6569),
    [anon_sym_PLUS_EQ] = ACTIONS(6569),
    [anon_sym_DASH_EQ] = ACTIONS(6569),
    [anon_sym_LT_LT_EQ] = ACTIONS(6569),
    [anon_sym_GT_GT_EQ] = ACTIONS(6569),
    [anon_sym_AMP_EQ] = ACTIONS(6569),
    [anon_sym_CARET_EQ] = ACTIONS(6569),
    [anon_sym_PIPE_EQ] = ACTIONS(6569),
    [anon_sym_and_eq] = ACTIONS(6567),
    [anon_sym_or_eq] = ACTIONS(6567),
    [anon_sym_xor_eq] = ACTIONS(6567),
    [anon_sym_LT_EQ_GT] = ACTIONS(6569),
    [anon_sym_or] = ACTIONS(6567),
    [anon_sym_and] = ACTIONS(6567),
    [anon_sym_bitor] = ACTIONS(6567),
    [anon_sym_xor] = ACTIONS(6567),
    [anon_sym_bitand] = ACTIONS(6567),
    [anon_sym_not_eq] = ACTIONS(6567),
    [anon_sym_DASH_DASH] = ACTIONS(6569),
    [anon_sym_PLUS_PLUS] = ACTIONS(6569),
    [anon_sym_DOT] = ACTIONS(6567),
    [anon_sym_DOT_STAR] = ACTIONS(6569),
    [anon_sym_DASH_GT] = ACTIONS(6569),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6553),
    [anon_sym_decltype] = ACTIONS(6555),
  },
  [2601] = {
    [sym_argument_list] = STATE(2940),
    [sym_initializer_list] = STATE(2940),
    [sym_decltype_auto] = STATE(2729),
    [sym_new_declarator] = STATE(2749),
    [sym_identifier] = ACTIONS(6571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6573),
    [anon_sym_COMMA] = ACTIONS(6573),
    [anon_sym_RPAREN] = ACTIONS(6573),
    [aux_sym_preproc_if_token2] = ACTIONS(6573),
    [aux_sym_preproc_else_token1] = ACTIONS(6573),
    [aux_sym_preproc_elif_token1] = ACTIONS(6571),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6573),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6573),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6571),
    [anon_sym_PLUS] = ACTIONS(6571),
    [anon_sym_STAR] = ACTIONS(6571),
    [anon_sym_SLASH] = ACTIONS(6571),
    [anon_sym_PERCENT] = ACTIONS(6571),
    [anon_sym_PIPE_PIPE] = ACTIONS(6573),
    [anon_sym_AMP_AMP] = ACTIONS(6573),
    [anon_sym_PIPE] = ACTIONS(6571),
    [anon_sym_CARET] = ACTIONS(6571),
    [anon_sym_AMP] = ACTIONS(6571),
    [anon_sym_EQ_EQ] = ACTIONS(6573),
    [anon_sym_BANG_EQ] = ACTIONS(6573),
    [anon_sym_GT] = ACTIONS(6571),
    [anon_sym_GT_EQ] = ACTIONS(6573),
    [anon_sym_LT_EQ] = ACTIONS(6571),
    [anon_sym_LT] = ACTIONS(6571),
    [anon_sym_LT_LT] = ACTIONS(6571),
    [anon_sym_GT_GT] = ACTIONS(6571),
    [anon_sym_COLON] = ACTIONS(6573),
    [anon_sym_SEMI] = ACTIONS(6573),
    [anon_sym___attribute__] = ACTIONS(6571),
    [anon_sym___attribute] = ACTIONS(6571),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6573),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6573),
    [anon_sym_EQ] = ACTIONS(6571),
    [anon_sym_QMARK] = ACTIONS(6573),
    [anon_sym_STAR_EQ] = ACTIONS(6573),
    [anon_sym_SLASH_EQ] = ACTIONS(6573),
    [anon_sym_PERCENT_EQ] = ACTIONS(6573),
    [anon_sym_PLUS_EQ] = ACTIONS(6573),
    [anon_sym_DASH_EQ] = ACTIONS(6573),
    [anon_sym_LT_LT_EQ] = ACTIONS(6573),
    [anon_sym_GT_GT_EQ] = ACTIONS(6573),
    [anon_sym_AMP_EQ] = ACTIONS(6573),
    [anon_sym_CARET_EQ] = ACTIONS(6573),
    [anon_sym_PIPE_EQ] = ACTIONS(6573),
    [anon_sym_and_eq] = ACTIONS(6571),
    [anon_sym_or_eq] = ACTIONS(6571),
    [anon_sym_xor_eq] = ACTIONS(6571),
    [anon_sym_LT_EQ_GT] = ACTIONS(6573),
    [anon_sym_or] = ACTIONS(6571),
    [anon_sym_and] = ACTIONS(6571),
    [anon_sym_bitor] = ACTIONS(6571),
    [anon_sym_xor] = ACTIONS(6571),
    [anon_sym_bitand] = ACTIONS(6571),
    [anon_sym_not_eq] = ACTIONS(6571),
    [anon_sym_DASH_DASH] = ACTIONS(6573),
    [anon_sym_PLUS_PLUS] = ACTIONS(6573),
    [anon_sym_DOT] = ACTIONS(6571),
    [anon_sym_DOT_STAR] = ACTIONS(6573),
    [anon_sym_DASH_GT] = ACTIONS(6573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6553),
    [anon_sym_decltype] = ACTIONS(6555),
  },
  [2602] = {
    [sym_template_argument_list] = STATE(2624),
    [sym_identifier] = ACTIONS(2005),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2007),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_RPAREN] = ACTIONS(2007),
    [aux_sym_preproc_if_token2] = ACTIONS(2007),
    [aux_sym_preproc_else_token1] = ACTIONS(2007),
    [aux_sym_preproc_elif_token1] = ACTIONS(2005),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2007),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2007),
    [anon_sym_LPAREN2] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2005),
    [anon_sym_PERCENT] = ACTIONS(2005),
    [anon_sym_PIPE_PIPE] = ACTIONS(2007),
    [anon_sym_AMP_AMP] = ACTIONS(2007),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_CARET] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_EQ_EQ] = ACTIONS(2007),
    [anon_sym_BANG_EQ] = ACTIONS(2007),
    [anon_sym_GT] = ACTIONS(2005),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(2005),
    [anon_sym_GT_GT] = ACTIONS(2005),
    [anon_sym_COLON] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym___attribute__] = ACTIONS(2005),
    [anon_sym___attribute] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2007),
    [anon_sym_RBRACK] = ACTIONS(2007),
    [anon_sym_EQ] = ACTIONS(2005),
    [anon_sym_QMARK] = ACTIONS(2007),
    [anon_sym_STAR_EQ] = ACTIONS(2007),
    [anon_sym_SLASH_EQ] = ACTIONS(2007),
    [anon_sym_PERCENT_EQ] = ACTIONS(2007),
    [anon_sym_PLUS_EQ] = ACTIONS(2007),
    [anon_sym_DASH_EQ] = ACTIONS(2007),
    [anon_sym_LT_LT_EQ] = ACTIONS(2007),
    [anon_sym_GT_GT_EQ] = ACTIONS(2007),
    [anon_sym_AMP_EQ] = ACTIONS(2007),
    [anon_sym_CARET_EQ] = ACTIONS(2007),
    [anon_sym_PIPE_EQ] = ACTIONS(2007),
    [anon_sym_and_eq] = ACTIONS(2005),
    [anon_sym_or_eq] = ACTIONS(2005),
    [anon_sym_xor_eq] = ACTIONS(2005),
    [anon_sym_LT_EQ_GT] = ACTIONS(2007),
    [anon_sym_or] = ACTIONS(2005),
    [anon_sym_and] = ACTIONS(2005),
    [anon_sym_bitor] = ACTIONS(2005),
    [anon_sym_xor] = ACTIONS(2005),
    [anon_sym_bitand] = ACTIONS(2005),
    [anon_sym_not_eq] = ACTIONS(2005),
    [anon_sym_DASH_DASH] = ACTIONS(2007),
    [anon_sym_PLUS_PLUS] = ACTIONS(2007),
    [anon_sym_DOT] = ACTIONS(2005),
    [anon_sym_DOT_STAR] = ACTIONS(2007),
    [anon_sym_DASH_GT] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2005),
    [anon_sym_decltype] = ACTIONS(2005),
    [anon_sym_final] = ACTIONS(2005),
    [anon_sym_override] = ACTIONS(2005),
  },
  [2603] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_COMMA] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4456),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym__Nonnull] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4456),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4451),
    [anon_sym_or_eq] = ACTIONS(4451),
    [anon_sym_xor_eq] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4451),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4451),
    [anon_sym_not_eq] = ACTIONS(4451),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
    [anon_sym_GT2] = ACTIONS(4453),
  },
  [2604] = {
    [sym_template_argument_list] = STATE(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4435),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4430),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4435),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(6577),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym___extension__] = ACTIONS(1999),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1999),
    [anon_sym_volatile] = ACTIONS(1999),
    [anon_sym_restrict] = ACTIONS(1999),
    [anon_sym___restrict__] = ACTIONS(1999),
    [anon_sym__Atomic] = ACTIONS(1999),
    [anon_sym__Noreturn] = ACTIONS(1999),
    [anon_sym_noreturn] = ACTIONS(1999),
    [anon_sym__Nonnull] = ACTIONS(1999),
    [anon_sym_mutable] = ACTIONS(1999),
    [anon_sym_constinit] = ACTIONS(1999),
    [anon_sym_consteval] = ACTIONS(1999),
    [anon_sym_alignas] = ACTIONS(1999),
    [anon_sym__Alignas] = ACTIONS(1999),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4428),
    [anon_sym_or_eq] = ACTIONS(4428),
    [anon_sym_xor_eq] = ACTIONS(4428),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4428),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4428),
    [anon_sym_not_eq] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1999),
    [anon_sym_decltype] = ACTIONS(1999),
  },
  [2605] = {
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2029),
    [anon_sym_COMMA] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [aux_sym_preproc_if_token2] = ACTIONS(2029),
    [aux_sym_preproc_else_token1] = ACTIONS(2029),
    [aux_sym_preproc_elif_token1] = ACTIONS(2027),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2029),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2029),
    [anon_sym_LPAREN2] = ACTIONS(2029),
    [anon_sym_DASH] = ACTIONS(2027),
    [anon_sym_PLUS] = ACTIONS(2027),
    [anon_sym_STAR] = ACTIONS(2027),
    [anon_sym_SLASH] = ACTIONS(2027),
    [anon_sym_PERCENT] = ACTIONS(2027),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE] = ACTIONS(2027),
    [anon_sym_CARET] = ACTIONS(2027),
    [anon_sym_AMP] = ACTIONS(2027),
    [anon_sym_EQ_EQ] = ACTIONS(2029),
    [anon_sym_BANG_EQ] = ACTIONS(2029),
    [anon_sym_GT] = ACTIONS(2027),
    [anon_sym_GT_EQ] = ACTIONS(2029),
    [anon_sym_LT_EQ] = ACTIONS(2027),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_LT_LT] = ACTIONS(2027),
    [anon_sym_GT_GT] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(2027),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym___attribute__] = ACTIONS(2027),
    [anon_sym___attribute] = ACTIONS(2027),
    [anon_sym_COLON_COLON] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2029),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2029),
    [anon_sym_RBRACK] = ACTIONS(2029),
    [anon_sym_EQ] = ACTIONS(2027),
    [anon_sym_QMARK] = ACTIONS(2029),
    [anon_sym_STAR_EQ] = ACTIONS(2029),
    [anon_sym_SLASH_EQ] = ACTIONS(2029),
    [anon_sym_PERCENT_EQ] = ACTIONS(2029),
    [anon_sym_PLUS_EQ] = ACTIONS(2029),
    [anon_sym_DASH_EQ] = ACTIONS(2029),
    [anon_sym_LT_LT_EQ] = ACTIONS(2029),
    [anon_sym_GT_GT_EQ] = ACTIONS(2029),
    [anon_sym_AMP_EQ] = ACTIONS(2029),
    [anon_sym_CARET_EQ] = ACTIONS(2029),
    [anon_sym_PIPE_EQ] = ACTIONS(2029),
    [anon_sym_and_eq] = ACTIONS(2027),
    [anon_sym_or_eq] = ACTIONS(2027),
    [anon_sym_xor_eq] = ACTIONS(2027),
    [anon_sym_LT_EQ_GT] = ACTIONS(2029),
    [anon_sym_or] = ACTIONS(2027),
    [anon_sym_and] = ACTIONS(2027),
    [anon_sym_bitor] = ACTIONS(2027),
    [anon_sym_xor] = ACTIONS(2027),
    [anon_sym_bitand] = ACTIONS(2027),
    [anon_sym_not_eq] = ACTIONS(2027),
    [anon_sym_DASH_DASH] = ACTIONS(2029),
    [anon_sym_PLUS_PLUS] = ACTIONS(2029),
    [anon_sym_DOT] = ACTIONS(2027),
    [anon_sym_DOT_STAR] = ACTIONS(2029),
    [anon_sym_DASH_GT] = ACTIONS(2029),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2027),
    [anon_sym_decltype] = ACTIONS(2027),
    [anon_sym_final] = ACTIONS(2027),
    [anon_sym_override] = ACTIONS(2027),
  },
  [2606] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(4029),
    [sym__declarator] = STATE(6372),
    [sym__abstract_declarator] = STATE(6813),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3059),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3509),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3059),
    [aux_sym_pointer_declarator_repeat1] = STATE(4029),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6536),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6580),
    [anon_sym_AMP_AMP] = ACTIONS(6582),
    [anon_sym_AMP] = ACTIONS(6584),
    [anon_sym_COLON] = ACTIONS(6538),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6538),
    [anon_sym___attribute] = ACTIONS(6538),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(6536),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2607] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_RPAREN] = ACTIONS(5892),
    [anon_sym_LPAREN2] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5892),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5892),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5892),
    [anon_sym_GT_GT] = ACTIONS(5892),
    [anon_sym_COLON] = ACTIONS(5892),
    [anon_sym_SEMI] = ACTIONS(5892),
    [anon_sym___extension__] = ACTIONS(5892),
    [anon_sym___attribute__] = ACTIONS(5892),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_RBRACK] = ACTIONS(5892),
    [anon_sym_const] = ACTIONS(5890),
    [anon_sym_constexpr] = ACTIONS(5892),
    [anon_sym_volatile] = ACTIONS(5892),
    [anon_sym_restrict] = ACTIONS(5892),
    [anon_sym___restrict__] = ACTIONS(5892),
    [anon_sym__Atomic] = ACTIONS(5892),
    [anon_sym__Noreturn] = ACTIONS(5892),
    [anon_sym_noreturn] = ACTIONS(5892),
    [anon_sym__Nonnull] = ACTIONS(5892),
    [anon_sym_mutable] = ACTIONS(5892),
    [anon_sym_constinit] = ACTIONS(5892),
    [anon_sym_consteval] = ACTIONS(5892),
    [anon_sym_alignas] = ACTIONS(5892),
    [anon_sym__Alignas] = ACTIONS(5892),
    [anon_sym_QMARK] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5892),
    [anon_sym_and] = ACTIONS(5892),
    [anon_sym_bitor] = ACTIONS(5892),
    [anon_sym_xor] = ACTIONS(5892),
    [anon_sym_bitand] = ACTIONS(5892),
    [anon_sym_not_eq] = ACTIONS(5892),
    [anon_sym_DASH_DASH] = ACTIONS(5892),
    [anon_sym_PLUS_PLUS] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5892),
    [anon_sym_decltype] = ACTIONS(5892),
    [anon_sym_final] = ACTIONS(5892),
    [anon_sym_override] = ACTIONS(5892),
    [anon_sym_requires] = ACTIONS(5892),
  },
  [2608] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_RPAREN] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5919),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5919),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5919),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5919),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5919),
    [anon_sym_GT_GT] = ACTIONS(5919),
    [anon_sym_COLON] = ACTIONS(5919),
    [anon_sym_SEMI] = ACTIONS(5919),
    [anon_sym___extension__] = ACTIONS(5919),
    [anon_sym___attribute__] = ACTIONS(5919),
    [anon_sym___attribute] = ACTIONS(5917),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_RBRACE] = ACTIONS(5919),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_RBRACK] = ACTIONS(5919),
    [anon_sym_const] = ACTIONS(5917),
    [anon_sym_constexpr] = ACTIONS(5919),
    [anon_sym_volatile] = ACTIONS(5919),
    [anon_sym_restrict] = ACTIONS(5919),
    [anon_sym___restrict__] = ACTIONS(5919),
    [anon_sym__Atomic] = ACTIONS(5919),
    [anon_sym__Noreturn] = ACTIONS(5919),
    [anon_sym_noreturn] = ACTIONS(5919),
    [anon_sym__Nonnull] = ACTIONS(5919),
    [anon_sym_mutable] = ACTIONS(5919),
    [anon_sym_constinit] = ACTIONS(5919),
    [anon_sym_consteval] = ACTIONS(5919),
    [anon_sym_alignas] = ACTIONS(5919),
    [anon_sym__Alignas] = ACTIONS(5919),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5919),
    [anon_sym_and] = ACTIONS(5919),
    [anon_sym_bitor] = ACTIONS(5919),
    [anon_sym_xor] = ACTIONS(5919),
    [anon_sym_bitand] = ACTIONS(5919),
    [anon_sym_not_eq] = ACTIONS(5919),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5919),
    [anon_sym_decltype] = ACTIONS(5919),
    [anon_sym_final] = ACTIONS(5919),
    [anon_sym_override] = ACTIONS(5919),
    [anon_sym_requires] = ACTIONS(5919),
  },
  [2609] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5915),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym___extension__] = ACTIONS(5915),
    [anon_sym___attribute__] = ACTIONS(5915),
    [anon_sym___attribute] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_const] = ACTIONS(5913),
    [anon_sym_constexpr] = ACTIONS(5915),
    [anon_sym_volatile] = ACTIONS(5915),
    [anon_sym_restrict] = ACTIONS(5915),
    [anon_sym___restrict__] = ACTIONS(5915),
    [anon_sym__Atomic] = ACTIONS(5915),
    [anon_sym__Noreturn] = ACTIONS(5915),
    [anon_sym_noreturn] = ACTIONS(5915),
    [anon_sym__Nonnull] = ACTIONS(5915),
    [anon_sym_mutable] = ACTIONS(5915),
    [anon_sym_constinit] = ACTIONS(5915),
    [anon_sym_consteval] = ACTIONS(5915),
    [anon_sym_alignas] = ACTIONS(5915),
    [anon_sym__Alignas] = ACTIONS(5915),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5915),
    [anon_sym_and] = ACTIONS(5915),
    [anon_sym_bitor] = ACTIONS(5915),
    [anon_sym_xor] = ACTIONS(5915),
    [anon_sym_bitand] = ACTIONS(5915),
    [anon_sym_not_eq] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5915),
    [anon_sym_decltype] = ACTIONS(5915),
    [anon_sym_final] = ACTIONS(5915),
    [anon_sym_override] = ACTIONS(5915),
    [anon_sym_requires] = ACTIONS(5915),
  },
  [2610] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5923),
    [anon_sym_DASH] = ACTIONS(5921),
    [anon_sym_PLUS] = ACTIONS(5921),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_SLASH] = ACTIONS(5921),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5923),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT] = ACTIONS(5921),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5921),
    [anon_sym_LT] = ACTIONS(5921),
    [anon_sym_LT_LT] = ACTIONS(5923),
    [anon_sym_GT_GT] = ACTIONS(5923),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym___extension__] = ACTIONS(5923),
    [anon_sym___attribute__] = ACTIONS(5923),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_LBRACE] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_RBRACK] = ACTIONS(5923),
    [anon_sym_const] = ACTIONS(5921),
    [anon_sym_constexpr] = ACTIONS(5923),
    [anon_sym_volatile] = ACTIONS(5923),
    [anon_sym_restrict] = ACTIONS(5923),
    [anon_sym___restrict__] = ACTIONS(5923),
    [anon_sym__Atomic] = ACTIONS(5923),
    [anon_sym__Noreturn] = ACTIONS(5923),
    [anon_sym_noreturn] = ACTIONS(5923),
    [anon_sym__Nonnull] = ACTIONS(5923),
    [anon_sym_mutable] = ACTIONS(5923),
    [anon_sym_constinit] = ACTIONS(5923),
    [anon_sym_consteval] = ACTIONS(5923),
    [anon_sym_alignas] = ACTIONS(5923),
    [anon_sym__Alignas] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(5923),
    [anon_sym_LT_EQ_GT] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5923),
    [anon_sym_and] = ACTIONS(5923),
    [anon_sym_bitor] = ACTIONS(5923),
    [anon_sym_xor] = ACTIONS(5923),
    [anon_sym_bitand] = ACTIONS(5923),
    [anon_sym_not_eq] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_DOT_STAR] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5923),
    [anon_sym_decltype] = ACTIONS(5923),
    [anon_sym_final] = ACTIONS(5923),
    [anon_sym_override] = ACTIONS(5923),
    [anon_sym_requires] = ACTIONS(5923),
  },
  [2611] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_PLUS] = ACTIONS(5906),
    [anon_sym_STAR] = ACTIONS(5908),
    [anon_sym_SLASH] = ACTIONS(5906),
    [anon_sym_PERCENT] = ACTIONS(5908),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_CARET] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5906),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_LT_LT] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5908),
    [anon_sym_COLON] = ACTIONS(5908),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___extension__] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_const] = ACTIONS(5906),
    [anon_sym_constexpr] = ACTIONS(5908),
    [anon_sym_volatile] = ACTIONS(5908),
    [anon_sym_restrict] = ACTIONS(5908),
    [anon_sym___restrict__] = ACTIONS(5908),
    [anon_sym__Atomic] = ACTIONS(5908),
    [anon_sym__Noreturn] = ACTIONS(5908),
    [anon_sym_noreturn] = ACTIONS(5908),
    [anon_sym__Nonnull] = ACTIONS(5908),
    [anon_sym_mutable] = ACTIONS(5908),
    [anon_sym_constinit] = ACTIONS(5908),
    [anon_sym_consteval] = ACTIONS(5908),
    [anon_sym_alignas] = ACTIONS(5908),
    [anon_sym__Alignas] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5908),
    [anon_sym_and] = ACTIONS(5908),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5908),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
    [anon_sym_final] = ACTIONS(5908),
    [anon_sym_override] = ACTIONS(5908),
    [anon_sym_requires] = ACTIONS(5908),
  },
  [2612] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5927),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(5927),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_EQ_EQ] = ACTIONS(5927),
    [anon_sym_BANG_EQ] = ACTIONS(5927),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_EQ] = ACTIONS(5925),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5927),
    [anon_sym_GT_GT] = ACTIONS(5927),
    [anon_sym_COLON] = ACTIONS(5927),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym___extension__] = ACTIONS(5927),
    [anon_sym___attribute__] = ACTIONS(5927),
    [anon_sym___attribute] = ACTIONS(5925),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_const] = ACTIONS(5925),
    [anon_sym_constexpr] = ACTIONS(5927),
    [anon_sym_volatile] = ACTIONS(5927),
    [anon_sym_restrict] = ACTIONS(5927),
    [anon_sym___restrict__] = ACTIONS(5927),
    [anon_sym__Atomic] = ACTIONS(5927),
    [anon_sym__Noreturn] = ACTIONS(5927),
    [anon_sym_noreturn] = ACTIONS(5927),
    [anon_sym__Nonnull] = ACTIONS(5927),
    [anon_sym_mutable] = ACTIONS(5927),
    [anon_sym_constinit] = ACTIONS(5927),
    [anon_sym_consteval] = ACTIONS(5927),
    [anon_sym_alignas] = ACTIONS(5927),
    [anon_sym__Alignas] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_LT_EQ_GT] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_bitor] = ACTIONS(5927),
    [anon_sym_xor] = ACTIONS(5927),
    [anon_sym_bitand] = ACTIONS(5927),
    [anon_sym_not_eq] = ACTIONS(5927),
    [anon_sym_DASH_DASH] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_DOT_STAR] = ACTIONS(5927),
    [anon_sym_DASH_GT] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5927),
    [anon_sym_decltype] = ACTIONS(5927),
    [anon_sym_final] = ACTIONS(5927),
    [anon_sym_override] = ACTIONS(5927),
    [anon_sym_requires] = ACTIONS(5927),
  },
  [2613] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5931),
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_RPAREN] = ACTIONS(5931),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5929),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_SLASH] = ACTIONS(5929),
    [anon_sym_PERCENT] = ACTIONS(5931),
    [anon_sym_PIPE_PIPE] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5931),
    [anon_sym_PIPE] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5931),
    [anon_sym_AMP] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5931),
    [anon_sym_BANG_EQ] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5931),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5929),
    [anon_sym_LT_LT] = ACTIONS(5931),
    [anon_sym_GT_GT] = ACTIONS(5931),
    [anon_sym_COLON] = ACTIONS(5931),
    [anon_sym_SEMI] = ACTIONS(5931),
    [anon_sym___extension__] = ACTIONS(5931),
    [anon_sym___attribute__] = ACTIONS(5931),
    [anon_sym___attribute] = ACTIONS(5929),
    [anon_sym_LBRACE] = ACTIONS(5931),
    [anon_sym_RBRACE] = ACTIONS(5931),
    [anon_sym_signed] = ACTIONS(6588),
    [anon_sym_unsigned] = ACTIONS(6588),
    [anon_sym_long] = ACTIONS(6588),
    [anon_sym_short] = ACTIONS(6588),
    [anon_sym_LBRACK] = ACTIONS(5931),
    [anon_sym_RBRACK] = ACTIONS(5931),
    [anon_sym_const] = ACTIONS(5929),
    [anon_sym_constexpr] = ACTIONS(5931),
    [anon_sym_volatile] = ACTIONS(5931),
    [anon_sym_restrict] = ACTIONS(5931),
    [anon_sym___restrict__] = ACTIONS(5931),
    [anon_sym__Atomic] = ACTIONS(5931),
    [anon_sym__Noreturn] = ACTIONS(5931),
    [anon_sym_noreturn] = ACTIONS(5931),
    [anon_sym__Nonnull] = ACTIONS(5931),
    [anon_sym_mutable] = ACTIONS(5931),
    [anon_sym_constinit] = ACTIONS(5931),
    [anon_sym_consteval] = ACTIONS(5931),
    [anon_sym_alignas] = ACTIONS(5931),
    [anon_sym__Alignas] = ACTIONS(5931),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_LT_EQ_GT] = ACTIONS(5931),
    [anon_sym_or] = ACTIONS(5931),
    [anon_sym_and] = ACTIONS(5931),
    [anon_sym_bitor] = ACTIONS(5931),
    [anon_sym_xor] = ACTIONS(5931),
    [anon_sym_bitand] = ACTIONS(5931),
    [anon_sym_not_eq] = ACTIONS(5931),
    [anon_sym_DASH_DASH] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5931),
    [anon_sym_DOT] = ACTIONS(5929),
    [anon_sym_DOT_STAR] = ACTIONS(5931),
    [anon_sym_DASH_GT] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5931),
    [anon_sym_decltype] = ACTIONS(5931),
    [anon_sym_final] = ACTIONS(5931),
    [anon_sym_override] = ACTIONS(5931),
    [anon_sym_requires] = ACTIONS(5931),
  },
  [2614] = {
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2013),
    [aux_sym_preproc_if_token2] = ACTIONS(2013),
    [aux_sym_preproc_else_token1] = ACTIONS(2013),
    [aux_sym_preproc_elif_token1] = ACTIONS(2011),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2013),
    [anon_sym_LPAREN2] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2013),
    [anon_sym_PIPE] = ACTIONS(2011),
    [anon_sym_CARET] = ACTIONS(2011),
    [anon_sym_AMP] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym___attribute__] = ACTIONS(2011),
    [anon_sym___attribute] = ACTIONS(2011),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [anon_sym_RBRACK] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(2013),
    [anon_sym_STAR_EQ] = ACTIONS(2013),
    [anon_sym_SLASH_EQ] = ACTIONS(2013),
    [anon_sym_PERCENT_EQ] = ACTIONS(2013),
    [anon_sym_PLUS_EQ] = ACTIONS(2013),
    [anon_sym_DASH_EQ] = ACTIONS(2013),
    [anon_sym_LT_LT_EQ] = ACTIONS(2013),
    [anon_sym_GT_GT_EQ] = ACTIONS(2013),
    [anon_sym_AMP_EQ] = ACTIONS(2013),
    [anon_sym_CARET_EQ] = ACTIONS(2013),
    [anon_sym_PIPE_EQ] = ACTIONS(2013),
    [anon_sym_and_eq] = ACTIONS(2011),
    [anon_sym_or_eq] = ACTIONS(2011),
    [anon_sym_xor_eq] = ACTIONS(2011),
    [anon_sym_LT_EQ_GT] = ACTIONS(2013),
    [anon_sym_or] = ACTIONS(2011),
    [anon_sym_and] = ACTIONS(2011),
    [anon_sym_bitor] = ACTIONS(2011),
    [anon_sym_xor] = ACTIONS(2011),
    [anon_sym_bitand] = ACTIONS(2011),
    [anon_sym_not_eq] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2013),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_DOT_STAR] = ACTIONS(2013),
    [anon_sym_DASH_GT] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2011),
    [anon_sym_decltype] = ACTIONS(2011),
    [anon_sym_final] = ACTIONS(2011),
    [anon_sym_override] = ACTIONS(2011),
  },
  [2615] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(2606),
    [sym__declarator] = STATE(6378),
    [sym__abstract_declarator] = STATE(6787),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3062),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3509),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3062),
    [aux_sym_pointer_declarator_repeat1] = STATE(2606),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6580),
    [anon_sym_AMP_AMP] = ACTIONS(6582),
    [anon_sym_AMP] = ACTIONS(6584),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6490),
    [anon_sym___attribute] = ACTIONS(6490),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_GT2] = ACTIONS(6482),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2616] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2608),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_DASH] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5939),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_PIPE] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5939),
    [anon_sym_GT_EQ] = ACTIONS(5941),
    [anon_sym_LT_EQ] = ACTIONS(5939),
    [anon_sym_LT] = ACTIONS(5939),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5941),
    [anon_sym_COLON] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5941),
    [anon_sym___extension__] = ACTIONS(5941),
    [anon_sym___attribute__] = ACTIONS(5941),
    [anon_sym___attribute] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5941),
    [anon_sym_RBRACE] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(6590),
    [anon_sym_unsigned] = ACTIONS(6590),
    [anon_sym_long] = ACTIONS(6590),
    [anon_sym_short] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(5941),
    [anon_sym_RBRACK] = ACTIONS(5941),
    [anon_sym_const] = ACTIONS(5939),
    [anon_sym_constexpr] = ACTIONS(5941),
    [anon_sym_volatile] = ACTIONS(5941),
    [anon_sym_restrict] = ACTIONS(5941),
    [anon_sym___restrict__] = ACTIONS(5941),
    [anon_sym__Atomic] = ACTIONS(5941),
    [anon_sym__Noreturn] = ACTIONS(5941),
    [anon_sym_noreturn] = ACTIONS(5941),
    [anon_sym__Nonnull] = ACTIONS(5941),
    [anon_sym_mutable] = ACTIONS(5941),
    [anon_sym_constinit] = ACTIONS(5941),
    [anon_sym_consteval] = ACTIONS(5941),
    [anon_sym_alignas] = ACTIONS(5941),
    [anon_sym__Alignas] = ACTIONS(5941),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_bitor] = ACTIONS(5941),
    [anon_sym_xor] = ACTIONS(5941),
    [anon_sym_bitand] = ACTIONS(5941),
    [anon_sym_not_eq] = ACTIONS(5941),
    [anon_sym_DASH_DASH] = ACTIONS(5941),
    [anon_sym_PLUS_PLUS] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_DOT_STAR] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5941),
    [anon_sym_decltype] = ACTIONS(5941),
    [anon_sym_final] = ACTIONS(5941),
    [anon_sym_override] = ACTIONS(5941),
    [anon_sym_requires] = ACTIONS(5941),
  },
  [2617] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5898),
    [anon_sym_GT_GT] = ACTIONS(5898),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___extension__] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6592),
    [anon_sym_unsigned] = ACTIONS(6592),
    [anon_sym_long] = ACTIONS(6592),
    [anon_sym_short] = ACTIONS(6592),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_RBRACK] = ACTIONS(5898),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5898),
    [anon_sym_volatile] = ACTIONS(5898),
    [anon_sym_restrict] = ACTIONS(5898),
    [anon_sym___restrict__] = ACTIONS(5898),
    [anon_sym__Atomic] = ACTIONS(5898),
    [anon_sym__Noreturn] = ACTIONS(5898),
    [anon_sym_noreturn] = ACTIONS(5898),
    [anon_sym__Nonnull] = ACTIONS(5898),
    [anon_sym_mutable] = ACTIONS(5898),
    [anon_sym_constinit] = ACTIONS(5898),
    [anon_sym_consteval] = ACTIONS(5898),
    [anon_sym_alignas] = ACTIONS(5898),
    [anon_sym__Alignas] = ACTIONS(5898),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5898),
    [anon_sym_and] = ACTIONS(5898),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5898),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
    [anon_sym_final] = ACTIONS(5898),
    [anon_sym_override] = ACTIONS(5898),
    [anon_sym_requires] = ACTIONS(5898),
  },
  [2618] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(4453),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4453),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym___extension__] = ACTIONS(2040),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_const] = ACTIONS(2038),
    [anon_sym_constexpr] = ACTIONS(2040),
    [anon_sym_volatile] = ACTIONS(2040),
    [anon_sym_restrict] = ACTIONS(2040),
    [anon_sym___restrict__] = ACTIONS(2040),
    [anon_sym__Atomic] = ACTIONS(2040),
    [anon_sym__Noreturn] = ACTIONS(2040),
    [anon_sym_noreturn] = ACTIONS(2040),
    [anon_sym__Nonnull] = ACTIONS(2040),
    [anon_sym_mutable] = ACTIONS(2040),
    [anon_sym_constinit] = ACTIONS(2040),
    [anon_sym_consteval] = ACTIONS(2040),
    [anon_sym_alignas] = ACTIONS(2040),
    [anon_sym__Alignas] = ACTIONS(2040),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4451),
    [anon_sym_or_eq] = ACTIONS(4451),
    [anon_sym_xor_eq] = ACTIONS(4451),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4451),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4451),
    [anon_sym_not_eq] = ACTIONS(4451),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2040),
    [anon_sym_decltype] = ACTIONS(2040),
  },
  [2619] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [aux_sym_preproc_if_token2] = ACTIONS(2019),
    [aux_sym_preproc_else_token1] = ACTIONS(2019),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2017),
    [anon_sym_GT_GT] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_STAR_EQ] = ACTIONS(2019),
    [anon_sym_SLASH_EQ] = ACTIONS(2019),
    [anon_sym_PERCENT_EQ] = ACTIONS(2019),
    [anon_sym_PLUS_EQ] = ACTIONS(2019),
    [anon_sym_DASH_EQ] = ACTIONS(2019),
    [anon_sym_LT_LT_EQ] = ACTIONS(2019),
    [anon_sym_GT_GT_EQ] = ACTIONS(2019),
    [anon_sym_AMP_EQ] = ACTIONS(2019),
    [anon_sym_CARET_EQ] = ACTIONS(2019),
    [anon_sym_PIPE_EQ] = ACTIONS(2019),
    [anon_sym_and_eq] = ACTIONS(2017),
    [anon_sym_or_eq] = ACTIONS(2017),
    [anon_sym_xor_eq] = ACTIONS(2017),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
  },
  [2620] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [aux_sym_preproc_if_token2] = ACTIONS(2019),
    [aux_sym_preproc_else_token1] = ACTIONS(2019),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2017),
    [anon_sym_GT_GT] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_STAR_EQ] = ACTIONS(2019),
    [anon_sym_SLASH_EQ] = ACTIONS(2019),
    [anon_sym_PERCENT_EQ] = ACTIONS(2019),
    [anon_sym_PLUS_EQ] = ACTIONS(2019),
    [anon_sym_DASH_EQ] = ACTIONS(2019),
    [anon_sym_LT_LT_EQ] = ACTIONS(2019),
    [anon_sym_GT_GT_EQ] = ACTIONS(2019),
    [anon_sym_AMP_EQ] = ACTIONS(2019),
    [anon_sym_CARET_EQ] = ACTIONS(2019),
    [anon_sym_PIPE_EQ] = ACTIONS(2019),
    [anon_sym_and_eq] = ACTIONS(2017),
    [anon_sym_or_eq] = ACTIONS(2017),
    [anon_sym_xor_eq] = ACTIONS(2017),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
  },
  [2621] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2611),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RPAREN] = ACTIONS(5886),
    [anon_sym_LPAREN2] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5886),
    [anon_sym_SLASH] = ACTIONS(5884),
    [anon_sym_PERCENT] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_PIPE] = ACTIONS(5884),
    [anon_sym_CARET] = ACTIONS(5886),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_EQ_EQ] = ACTIONS(5886),
    [anon_sym_BANG_EQ] = ACTIONS(5886),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(5886),
    [anon_sym_GT_GT] = ACTIONS(5886),
    [anon_sym_COLON] = ACTIONS(5886),
    [anon_sym_SEMI] = ACTIONS(5886),
    [anon_sym___extension__] = ACTIONS(5886),
    [anon_sym___attribute__] = ACTIONS(5886),
    [anon_sym___attribute] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(5886),
    [anon_sym_RBRACE] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(6594),
    [anon_sym_unsigned] = ACTIONS(6594),
    [anon_sym_long] = ACTIONS(6594),
    [anon_sym_short] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_RBRACK] = ACTIONS(5886),
    [anon_sym_const] = ACTIONS(5884),
    [anon_sym_constexpr] = ACTIONS(5886),
    [anon_sym_volatile] = ACTIONS(5886),
    [anon_sym_restrict] = ACTIONS(5886),
    [anon_sym___restrict__] = ACTIONS(5886),
    [anon_sym__Atomic] = ACTIONS(5886),
    [anon_sym__Noreturn] = ACTIONS(5886),
    [anon_sym_noreturn] = ACTIONS(5886),
    [anon_sym__Nonnull] = ACTIONS(5886),
    [anon_sym_mutable] = ACTIONS(5886),
    [anon_sym_constinit] = ACTIONS(5886),
    [anon_sym_consteval] = ACTIONS(5886),
    [anon_sym_alignas] = ACTIONS(5886),
    [anon_sym__Alignas] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_LT_EQ_GT] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5886),
    [anon_sym_and] = ACTIONS(5886),
    [anon_sym_bitor] = ACTIONS(5886),
    [anon_sym_xor] = ACTIONS(5886),
    [anon_sym_bitand] = ACTIONS(5886),
    [anon_sym_not_eq] = ACTIONS(5886),
    [anon_sym_DASH_DASH] = ACTIONS(5886),
    [anon_sym_PLUS_PLUS] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5884),
    [anon_sym_DOT_STAR] = ACTIONS(5886),
    [anon_sym_DASH_GT] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5886),
    [anon_sym_decltype] = ACTIONS(5886),
    [anon_sym_final] = ACTIONS(5886),
    [anon_sym_override] = ACTIONS(5886),
    [anon_sym_requires] = ACTIONS(5886),
  },
  [2622] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5937),
    [anon_sym_LPAREN2] = ACTIONS(5937),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_GT_EQ] = ACTIONS(5937),
    [anon_sym_LT_EQ] = ACTIONS(5935),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5937),
    [anon_sym_COLON] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5937),
    [anon_sym___extension__] = ACTIONS(5937),
    [anon_sym___attribute__] = ACTIONS(5937),
    [anon_sym___attribute] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_RBRACE] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(6586),
    [anon_sym_unsigned] = ACTIONS(6586),
    [anon_sym_long] = ACTIONS(6586),
    [anon_sym_short] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(5937),
    [anon_sym_RBRACK] = ACTIONS(5937),
    [anon_sym_const] = ACTIONS(5935),
    [anon_sym_constexpr] = ACTIONS(5937),
    [anon_sym_volatile] = ACTIONS(5937),
    [anon_sym_restrict] = ACTIONS(5937),
    [anon_sym___restrict__] = ACTIONS(5937),
    [anon_sym__Atomic] = ACTIONS(5937),
    [anon_sym__Noreturn] = ACTIONS(5937),
    [anon_sym_noreturn] = ACTIONS(5937),
    [anon_sym__Nonnull] = ACTIONS(5937),
    [anon_sym_mutable] = ACTIONS(5937),
    [anon_sym_constinit] = ACTIONS(5937),
    [anon_sym_consteval] = ACTIONS(5937),
    [anon_sym_alignas] = ACTIONS(5937),
    [anon_sym__Alignas] = ACTIONS(5937),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_LT_EQ_GT] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_bitor] = ACTIONS(5937),
    [anon_sym_xor] = ACTIONS(5937),
    [anon_sym_bitand] = ACTIONS(5937),
    [anon_sym_not_eq] = ACTIONS(5937),
    [anon_sym_DASH_DASH] = ACTIONS(5937),
    [anon_sym_PLUS_PLUS] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_DOT_STAR] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5937),
    [anon_sym_decltype] = ACTIONS(5937),
    [anon_sym_final] = ACTIONS(5937),
    [anon_sym_override] = ACTIONS(5937),
    [anon_sym_requires] = ACTIONS(5937),
  },
  [2623] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(2626),
    [sym__declarator] = STATE(6378),
    [sym__abstract_declarator] = STATE(6843),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3031),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3423),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3031),
    [aux_sym_pointer_declarator_repeat1] = STATE(2626),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6482),
    [anon_sym_RPAREN] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6598),
    [anon_sym_AMP] = ACTIONS(6600),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6490),
    [anon_sym___attribute] = ACTIONS(6490),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(2038),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_RPAREN] = ACTIONS(2040),
    [aux_sym_preproc_if_token2] = ACTIONS(2040),
    [aux_sym_preproc_else_token1] = ACTIONS(2040),
    [aux_sym_preproc_elif_token1] = ACTIONS(2038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2040),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2040),
    [anon_sym_LPAREN2] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_SLASH] = ACTIONS(2038),
    [anon_sym_PERCENT] = ACTIONS(2038),
    [anon_sym_PIPE_PIPE] = ACTIONS(2040),
    [anon_sym_AMP_AMP] = ACTIONS(2040),
    [anon_sym_PIPE] = ACTIONS(2038),
    [anon_sym_CARET] = ACTIONS(2038),
    [anon_sym_AMP] = ACTIONS(2038),
    [anon_sym_EQ_EQ] = ACTIONS(2040),
    [anon_sym_BANG_EQ] = ACTIONS(2040),
    [anon_sym_GT] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_LT_LT] = ACTIONS(2038),
    [anon_sym_GT_GT] = ACTIONS(2038),
    [anon_sym_COLON] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2040),
    [anon_sym___attribute__] = ACTIONS(2038),
    [anon_sym___attribute] = ACTIONS(2038),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [anon_sym_RBRACK] = ACTIONS(2040),
    [anon_sym_EQ] = ACTIONS(2038),
    [anon_sym_QMARK] = ACTIONS(2040),
    [anon_sym_STAR_EQ] = ACTIONS(2040),
    [anon_sym_SLASH_EQ] = ACTIONS(2040),
    [anon_sym_PERCENT_EQ] = ACTIONS(2040),
    [anon_sym_PLUS_EQ] = ACTIONS(2040),
    [anon_sym_DASH_EQ] = ACTIONS(2040),
    [anon_sym_LT_LT_EQ] = ACTIONS(2040),
    [anon_sym_GT_GT_EQ] = ACTIONS(2040),
    [anon_sym_AMP_EQ] = ACTIONS(2040),
    [anon_sym_CARET_EQ] = ACTIONS(2040),
    [anon_sym_PIPE_EQ] = ACTIONS(2040),
    [anon_sym_and_eq] = ACTIONS(2038),
    [anon_sym_or_eq] = ACTIONS(2038),
    [anon_sym_xor_eq] = ACTIONS(2038),
    [anon_sym_LT_EQ_GT] = ACTIONS(2040),
    [anon_sym_or] = ACTIONS(2038),
    [anon_sym_and] = ACTIONS(2038),
    [anon_sym_bitor] = ACTIONS(2038),
    [anon_sym_xor] = ACTIONS(2038),
    [anon_sym_bitand] = ACTIONS(2038),
    [anon_sym_not_eq] = ACTIONS(2038),
    [anon_sym_DASH_DASH] = ACTIONS(2040),
    [anon_sym_PLUS_PLUS] = ACTIONS(2040),
    [anon_sym_DOT] = ACTIONS(2038),
    [anon_sym_DOT_STAR] = ACTIONS(2040),
    [anon_sym_DASH_GT] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2038),
    [anon_sym_decltype] = ACTIONS(2038),
    [anon_sym_final] = ACTIONS(2038),
    [anon_sym_override] = ACTIONS(2038),
  },
  [2625] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5859),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5859),
    [anon_sym_GT_GT] = ACTIONS(5859),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(6602),
    [anon_sym_unsigned] = ACTIONS(6602),
    [anon_sym_long] = ACTIONS(6602),
    [anon_sym_short] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5859),
    [anon_sym_volatile] = ACTIONS(5859),
    [anon_sym_restrict] = ACTIONS(5859),
    [anon_sym___restrict__] = ACTIONS(5859),
    [anon_sym__Atomic] = ACTIONS(5859),
    [anon_sym__Noreturn] = ACTIONS(5859),
    [anon_sym_noreturn] = ACTIONS(5859),
    [anon_sym__Nonnull] = ACTIONS(5859),
    [anon_sym_mutable] = ACTIONS(5859),
    [anon_sym_constinit] = ACTIONS(5859),
    [anon_sym_consteval] = ACTIONS(5859),
    [anon_sym_alignas] = ACTIONS(5859),
    [anon_sym__Alignas] = ACTIONS(5859),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5859),
    [anon_sym_and] = ACTIONS(5859),
    [anon_sym_bitor] = ACTIONS(5859),
    [anon_sym_xor] = ACTIONS(5859),
    [anon_sym_bitand] = ACTIONS(5859),
    [anon_sym_not_eq] = ACTIONS(5859),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5859),
    [anon_sym_decltype] = ACTIONS(5859),
    [anon_sym_final] = ACTIONS(5859),
    [anon_sym_override] = ACTIONS(5859),
    [anon_sym_requires] = ACTIONS(5859),
  },
  [2626] = {
    [sym_ms_based_modifier] = STATE(8320),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(4029),
    [sym__declarator] = STATE(6372),
    [sym__abstract_declarator] = STATE(6800),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3037),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3423),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6024),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3037),
    [aux_sym_pointer_declarator_repeat1] = STATE(4029),
    [sym_identifier] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6536),
    [anon_sym_RPAREN] = ACTIONS(6536),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_AMP_AMP] = ACTIONS(6598),
    [anon_sym_AMP] = ACTIONS(6600),
    [anon_sym_COLON] = ACTIONS(6538),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym___attribute__] = ACTIONS(6538),
    [anon_sym___attribute] = ACTIONS(6538),
    [anon_sym_COLON_COLON] = ACTIONS(6492),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2627] = {
    [sym_string_literal] = STATE(2491),
    [sym_raw_string_literal] = STATE(2491),
    [sym_identifier] = ACTIONS(6604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6606),
    [anon_sym_COMMA] = ACTIONS(6606),
    [aux_sym_preproc_if_token2] = ACTIONS(6606),
    [aux_sym_preproc_else_token1] = ACTIONS(6606),
    [aux_sym_preproc_elif_token1] = ACTIONS(6604),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6606),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6606),
    [anon_sym_LPAREN2] = ACTIONS(6606),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_PERCENT] = ACTIONS(6604),
    [anon_sym_PIPE_PIPE] = ACTIONS(6606),
    [anon_sym_AMP_AMP] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_AMP] = ACTIONS(6604),
    [anon_sym_EQ_EQ] = ACTIONS(6606),
    [anon_sym_BANG_EQ] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6604),
    [anon_sym_GT_EQ] = ACTIONS(6606),
    [anon_sym_LT_EQ] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6604),
    [anon_sym_LT_LT] = ACTIONS(6604),
    [anon_sym_GT_GT] = ACTIONS(6604),
    [anon_sym_LBRACK] = ACTIONS(6606),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_QMARK] = ACTIONS(6606),
    [anon_sym_STAR_EQ] = ACTIONS(6606),
    [anon_sym_SLASH_EQ] = ACTIONS(6606),
    [anon_sym_PERCENT_EQ] = ACTIONS(6606),
    [anon_sym_PLUS_EQ] = ACTIONS(6606),
    [anon_sym_DASH_EQ] = ACTIONS(6606),
    [anon_sym_LT_LT_EQ] = ACTIONS(6606),
    [anon_sym_GT_GT_EQ] = ACTIONS(6606),
    [anon_sym_AMP_EQ] = ACTIONS(6606),
    [anon_sym_CARET_EQ] = ACTIONS(6606),
    [anon_sym_PIPE_EQ] = ACTIONS(6606),
    [anon_sym_and_eq] = ACTIONS(6604),
    [anon_sym_or_eq] = ACTIONS(6604),
    [anon_sym_xor_eq] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6604),
    [anon_sym_and] = ACTIONS(6604),
    [anon_sym_bitor] = ACTIONS(6604),
    [anon_sym_xor] = ACTIONS(6604),
    [anon_sym_bitand] = ACTIONS(6604),
    [anon_sym_not_eq] = ACTIONS(6604),
    [anon_sym_DASH_DASH] = ACTIONS(6606),
    [anon_sym_PLUS_PLUS] = ACTIONS(6606),
    [anon_sym_DOT] = ACTIONS(6604),
    [anon_sym_DOT_STAR] = ACTIONS(6606),
    [anon_sym_DASH_GT] = ACTIONS(6606),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [sym_literal_suffix] = ACTIONS(6604),
  },
  [2628] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5904),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5904),
    [anon_sym___attribute__] = ACTIONS(5904),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(6602),
    [anon_sym_unsigned] = ACTIONS(6602),
    [anon_sym_long] = ACTIONS(6602),
    [anon_sym_short] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_const] = ACTIONS(5902),
    [anon_sym_constexpr] = ACTIONS(5904),
    [anon_sym_volatile] = ACTIONS(5904),
    [anon_sym_restrict] = ACTIONS(5904),
    [anon_sym___restrict__] = ACTIONS(5904),
    [anon_sym__Atomic] = ACTIONS(5904),
    [anon_sym__Noreturn] = ACTIONS(5904),
    [anon_sym_noreturn] = ACTIONS(5904),
    [anon_sym__Nonnull] = ACTIONS(5904),
    [anon_sym_mutable] = ACTIONS(5904),
    [anon_sym_constinit] = ACTIONS(5904),
    [anon_sym_consteval] = ACTIONS(5904),
    [anon_sym_alignas] = ACTIONS(5904),
    [anon_sym__Alignas] = ACTIONS(5904),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5904),
    [anon_sym_and] = ACTIONS(5904),
    [anon_sym_bitor] = ACTIONS(5904),
    [anon_sym_xor] = ACTIONS(5904),
    [anon_sym_bitand] = ACTIONS(5904),
    [anon_sym_not_eq] = ACTIONS(5904),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5904),
    [anon_sym_decltype] = ACTIONS(5904),
    [anon_sym_final] = ACTIONS(5904),
    [anon_sym_override] = ACTIONS(5904),
    [anon_sym_requires] = ACTIONS(5904),
  },
  [2629] = {
    [sym_attribute_specifier] = STATE(2790),
    [sym_enumerator_list] = STATE(2697),
    [sym_identifier] = ACTIONS(6083),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6085),
    [anon_sym_COMMA] = ACTIONS(6085),
    [anon_sym_RPAREN] = ACTIONS(6085),
    [aux_sym_preproc_if_token2] = ACTIONS(6085),
    [aux_sym_preproc_else_token1] = ACTIONS(6085),
    [aux_sym_preproc_elif_token1] = ACTIONS(6083),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6085),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6085),
    [anon_sym_LPAREN2] = ACTIONS(6085),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_PERCENT] = ACTIONS(6083),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_AMP] = ACTIONS(6083),
    [anon_sym_EQ_EQ] = ACTIONS(6085),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6083),
    [anon_sym_GT_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6083),
    [anon_sym_LT_LT] = ACTIONS(6083),
    [anon_sym_GT_GT] = ACTIONS(6083),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SEMI] = ACTIONS(6085),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [anon_sym_RBRACE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6085),
    [anon_sym_RBRACK] = ACTIONS(6085),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_QMARK] = ACTIONS(6085),
    [anon_sym_STAR_EQ] = ACTIONS(6085),
    [anon_sym_SLASH_EQ] = ACTIONS(6085),
    [anon_sym_PERCENT_EQ] = ACTIONS(6085),
    [anon_sym_PLUS_EQ] = ACTIONS(6085),
    [anon_sym_DASH_EQ] = ACTIONS(6085),
    [anon_sym_LT_LT_EQ] = ACTIONS(6085),
    [anon_sym_GT_GT_EQ] = ACTIONS(6085),
    [anon_sym_AMP_EQ] = ACTIONS(6085),
    [anon_sym_CARET_EQ] = ACTIONS(6085),
    [anon_sym_PIPE_EQ] = ACTIONS(6085),
    [anon_sym_and_eq] = ACTIONS(6083),
    [anon_sym_or_eq] = ACTIONS(6083),
    [anon_sym_xor_eq] = ACTIONS(6083),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_or] = ACTIONS(6083),
    [anon_sym_and] = ACTIONS(6083),
    [anon_sym_bitor] = ACTIONS(6083),
    [anon_sym_xor] = ACTIONS(6083),
    [anon_sym_bitand] = ACTIONS(6083),
    [anon_sym_not_eq] = ACTIONS(6083),
    [anon_sym_DASH_DASH] = ACTIONS(6085),
    [anon_sym_PLUS_PLUS] = ACTIONS(6085),
    [anon_sym_DOT] = ACTIONS(6083),
    [anon_sym_DOT_STAR] = ACTIONS(6085),
    [anon_sym_DASH_GT] = ACTIONS(6085),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6083),
    [anon_sym_decltype] = ACTIONS(6083),
  },
  [2630] = {
    [sym_string_literal] = STATE(2630),
    [sym_raw_string_literal] = STATE(2630),
    [aux_sym_concatenated_string_repeat1] = STATE(2630),
    [sym_identifier] = ACTIONS(6610),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_LPAREN2] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6434),
    [anon_sym_PLUS] = ACTIONS(6434),
    [anon_sym_STAR] = ACTIONS(6434),
    [anon_sym_SLASH] = ACTIONS(6434),
    [anon_sym_PERCENT] = ACTIONS(6434),
    [anon_sym_PIPE_PIPE] = ACTIONS(6432),
    [anon_sym_AMP_AMP] = ACTIONS(6432),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_CARET] = ACTIONS(6434),
    [anon_sym_AMP] = ACTIONS(6434),
    [anon_sym_EQ_EQ] = ACTIONS(6432),
    [anon_sym_BANG_EQ] = ACTIONS(6432),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_GT_EQ] = ACTIONS(6432),
    [anon_sym_LT_EQ] = ACTIONS(6434),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_LT_LT] = ACTIONS(6434),
    [anon_sym_GT_GT] = ACTIONS(6434),
    [anon_sym_SEMI] = ACTIONS(6432),
    [anon_sym___attribute__] = ACTIONS(6434),
    [anon_sym___attribute] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6434),
    [anon_sym_QMARK] = ACTIONS(6432),
    [anon_sym_STAR_EQ] = ACTIONS(6432),
    [anon_sym_SLASH_EQ] = ACTIONS(6432),
    [anon_sym_PERCENT_EQ] = ACTIONS(6432),
    [anon_sym_PLUS_EQ] = ACTIONS(6432),
    [anon_sym_DASH_EQ] = ACTIONS(6432),
    [anon_sym_LT_LT_EQ] = ACTIONS(6432),
    [anon_sym_GT_GT_EQ] = ACTIONS(6432),
    [anon_sym_AMP_EQ] = ACTIONS(6432),
    [anon_sym_CARET_EQ] = ACTIONS(6432),
    [anon_sym_PIPE_EQ] = ACTIONS(6432),
    [anon_sym_and_eq] = ACTIONS(6434),
    [anon_sym_or_eq] = ACTIONS(6434),
    [anon_sym_xor_eq] = ACTIONS(6434),
    [anon_sym_LT_EQ_GT] = ACTIONS(6432),
    [anon_sym_or] = ACTIONS(6434),
    [anon_sym_and] = ACTIONS(6434),
    [anon_sym_bitor] = ACTIONS(6434),
    [anon_sym_xor] = ACTIONS(6434),
    [anon_sym_bitand] = ACTIONS(6434),
    [anon_sym_not_eq] = ACTIONS(6434),
    [anon_sym_DASH_DASH] = ACTIONS(6432),
    [anon_sym_PLUS_PLUS] = ACTIONS(6432),
    [anon_sym_DOT] = ACTIONS(6434),
    [anon_sym_DOT_STAR] = ACTIONS(6432),
    [anon_sym_DASH_GT] = ACTIONS(6432),
    [anon_sym_L_DQUOTE] = ACTIONS(6613),
    [anon_sym_u_DQUOTE] = ACTIONS(6613),
    [anon_sym_U_DQUOTE] = ACTIONS(6613),
    [anon_sym_u8_DQUOTE] = ACTIONS(6613),
    [anon_sym_DQUOTE] = ACTIONS(6613),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6616),
    [anon_sym_LR_DQUOTE] = ACTIONS(6616),
    [anon_sym_uR_DQUOTE] = ACTIONS(6616),
    [anon_sym_UR_DQUOTE] = ACTIONS(6616),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6616),
    [sym_literal_suffix] = ACTIONS(6434),
  },
  [2631] = {
    [sym_string_literal] = STATE(2645),
    [sym_template_argument_list] = STATE(2841),
    [sym_raw_string_literal] = STATE(2645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___attribute__] = ACTIONS(4217),
    [anon_sym___attribute] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(6619),
    [anon_sym_u_DQUOTE] = ACTIONS(6619),
    [anon_sym_U_DQUOTE] = ACTIONS(6619),
    [anon_sym_u8_DQUOTE] = ACTIONS(6619),
    [anon_sym_DQUOTE] = ACTIONS(6619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6621),
    [anon_sym_LR_DQUOTE] = ACTIONS(6621),
    [anon_sym_uR_DQUOTE] = ACTIONS(6621),
    [anon_sym_UR_DQUOTE] = ACTIONS(6621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6621),
  },
  [2632] = {
    [sym_template_argument_list] = STATE(2507),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2745),
    [sym_identifier] = ACTIONS(5791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [aux_sym_preproc_if_token2] = ACTIONS(5793),
    [aux_sym_preproc_else_token1] = ACTIONS(5793),
    [aux_sym_preproc_elif_token1] = ACTIONS(5791),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5793),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5793),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5791),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym___attribute__] = ACTIONS(5791),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(6623),
    [anon_sym_unsigned] = ACTIONS(6623),
    [anon_sym_long] = ACTIONS(6623),
    [anon_sym_short] = ACTIONS(6623),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(5791),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_STAR_EQ] = ACTIONS(5793),
    [anon_sym_SLASH_EQ] = ACTIONS(5793),
    [anon_sym_PERCENT_EQ] = ACTIONS(5793),
    [anon_sym_PLUS_EQ] = ACTIONS(5793),
    [anon_sym_DASH_EQ] = ACTIONS(5793),
    [anon_sym_LT_LT_EQ] = ACTIONS(5793),
    [anon_sym_GT_GT_EQ] = ACTIONS(5793),
    [anon_sym_AMP_EQ] = ACTIONS(5793),
    [anon_sym_CARET_EQ] = ACTIONS(5793),
    [anon_sym_PIPE_EQ] = ACTIONS(5793),
    [anon_sym_and_eq] = ACTIONS(5791),
    [anon_sym_or_eq] = ACTIONS(5791),
    [anon_sym_xor_eq] = ACTIONS(5791),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5791),
    [anon_sym_and] = ACTIONS(5791),
    [anon_sym_bitor] = ACTIONS(5791),
    [anon_sym_xor] = ACTIONS(5791),
    [anon_sym_bitand] = ACTIONS(5791),
    [anon_sym_not_eq] = ACTIONS(5791),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5791),
    [anon_sym_decltype] = ACTIONS(5791),
  },
  [2633] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [sym_identifier] = ACTIONS(5872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [aux_sym_preproc_if_token2] = ACTIONS(5875),
    [aux_sym_preproc_else_token1] = ACTIONS(5875),
    [aux_sym_preproc_elif_token1] = ACTIONS(5872),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5875),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5875),
    [anon_sym_GT_GT] = ACTIONS(5875),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(6355),
    [anon_sym_unsigned] = ACTIONS(6355),
    [anon_sym_long] = ACTIONS(6355),
    [anon_sym_short] = ACTIONS(6355),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
  },
  [2634] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2635] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(6625),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6625),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(6627),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2636] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5745),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5745),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5743),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5745),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym_COLON] = ACTIONS(5745),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6629),
    [anon_sym_unsigned] = ACTIONS(6629),
    [anon_sym_long] = ACTIONS(6629),
    [anon_sym_short] = ACTIONS(6629),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
    [anon_sym_final] = ACTIONS(5743),
    [anon_sym_override] = ACTIONS(5743),
    [anon_sym_GT2] = ACTIONS(5745),
    [anon_sym_requires] = ACTIONS(5743),
  },
  [2637] = {
    [sym_string_literal] = STATE(2491),
    [sym_raw_string_literal] = STATE(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6606),
    [anon_sym_COMMA] = ACTIONS(6606),
    [anon_sym_RPAREN] = ACTIONS(6606),
    [anon_sym_LPAREN2] = ACTIONS(6606),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_PERCENT] = ACTIONS(6604),
    [anon_sym_PIPE_PIPE] = ACTIONS(6606),
    [anon_sym_AMP_AMP] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_AMP] = ACTIONS(6604),
    [anon_sym_EQ_EQ] = ACTIONS(6606),
    [anon_sym_BANG_EQ] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6604),
    [anon_sym_GT_EQ] = ACTIONS(6606),
    [anon_sym_LT_EQ] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6604),
    [anon_sym_LT_LT] = ACTIONS(6604),
    [anon_sym_GT_GT] = ACTIONS(6604),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SEMI] = ACTIONS(6606),
    [anon_sym_RBRACE] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6606),
    [anon_sym_RBRACK] = ACTIONS(6606),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_QMARK] = ACTIONS(6606),
    [anon_sym_STAR_EQ] = ACTIONS(6606),
    [anon_sym_SLASH_EQ] = ACTIONS(6606),
    [anon_sym_PERCENT_EQ] = ACTIONS(6606),
    [anon_sym_PLUS_EQ] = ACTIONS(6606),
    [anon_sym_DASH_EQ] = ACTIONS(6606),
    [anon_sym_LT_LT_EQ] = ACTIONS(6606),
    [anon_sym_GT_GT_EQ] = ACTIONS(6606),
    [anon_sym_AMP_EQ] = ACTIONS(6606),
    [anon_sym_CARET_EQ] = ACTIONS(6606),
    [anon_sym_PIPE_EQ] = ACTIONS(6606),
    [anon_sym_and_eq] = ACTIONS(6604),
    [anon_sym_or_eq] = ACTIONS(6604),
    [anon_sym_xor_eq] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6604),
    [anon_sym_and] = ACTIONS(6604),
    [anon_sym_bitor] = ACTIONS(6604),
    [anon_sym_xor] = ACTIONS(6604),
    [anon_sym_bitand] = ACTIONS(6604),
    [anon_sym_not_eq] = ACTIONS(6604),
    [anon_sym_DASH_DASH] = ACTIONS(6606),
    [anon_sym_PLUS_PLUS] = ACTIONS(6606),
    [anon_sym_DOT] = ACTIONS(6604),
    [anon_sym_DOT_STAR] = ACTIONS(6606),
    [anon_sym_DASH_GT] = ACTIONS(6606),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
    [sym_literal_suffix] = ACTIONS(6604),
  },
  [2638] = {
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2019),
    [anon_sym_COMMA] = ACTIONS(2019),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [aux_sym_preproc_if_token2] = ACTIONS(2019),
    [aux_sym_preproc_else_token1] = ACTIONS(2019),
    [aux_sym_preproc_elif_token1] = ACTIONS(2017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2017),
    [anon_sym_PLUS] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2017),
    [anon_sym_SLASH] = ACTIONS(2017),
    [anon_sym_PERCENT] = ACTIONS(2017),
    [anon_sym_PIPE_PIPE] = ACTIONS(2019),
    [anon_sym_AMP_AMP] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2017),
    [anon_sym_CARET] = ACTIONS(2017),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_EQ_EQ] = ACTIONS(2019),
    [anon_sym_BANG_EQ] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(2017),
    [anon_sym_GT_EQ] = ACTIONS(2019),
    [anon_sym_LT_EQ] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2017),
    [anon_sym_LT_LT] = ACTIONS(2017),
    [anon_sym_GT_GT] = ACTIONS(2017),
    [anon_sym_COLON] = ACTIONS(2019),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym___attribute__] = ACTIONS(2017),
    [anon_sym___attribute] = ACTIONS(2017),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_RBRACK] = ACTIONS(2019),
    [anon_sym_EQ] = ACTIONS(2017),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_STAR_EQ] = ACTIONS(2019),
    [anon_sym_SLASH_EQ] = ACTIONS(2019),
    [anon_sym_PERCENT_EQ] = ACTIONS(2019),
    [anon_sym_PLUS_EQ] = ACTIONS(2019),
    [anon_sym_DASH_EQ] = ACTIONS(2019),
    [anon_sym_LT_LT_EQ] = ACTIONS(2019),
    [anon_sym_GT_GT_EQ] = ACTIONS(2019),
    [anon_sym_AMP_EQ] = ACTIONS(2019),
    [anon_sym_CARET_EQ] = ACTIONS(2019),
    [anon_sym_PIPE_EQ] = ACTIONS(2019),
    [anon_sym_and_eq] = ACTIONS(2017),
    [anon_sym_or_eq] = ACTIONS(2017),
    [anon_sym_xor_eq] = ACTIONS(2017),
    [anon_sym_LT_EQ_GT] = ACTIONS(2019),
    [anon_sym_or] = ACTIONS(2017),
    [anon_sym_and] = ACTIONS(2017),
    [anon_sym_bitor] = ACTIONS(2017),
    [anon_sym_xor] = ACTIONS(2017),
    [anon_sym_bitand] = ACTIONS(2017),
    [anon_sym_not_eq] = ACTIONS(2017),
    [anon_sym_DASH_DASH] = ACTIONS(2019),
    [anon_sym_PLUS_PLUS] = ACTIONS(2019),
    [anon_sym_DOT] = ACTIONS(2017),
    [anon_sym_DOT_STAR] = ACTIONS(2019),
    [anon_sym_DASH_GT] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2017),
    [anon_sym_decltype] = ACTIONS(2017),
    [anon_sym_final] = ACTIONS(2017),
    [anon_sym_override] = ACTIONS(2017),
  },
  [2639] = {
    [sym_attribute_specifier] = STATE(2556),
    [sym_field_declaration_list] = STATE(2827),
    [sym_virtual_specifier] = STATE(7295),
    [sym_base_class_clause] = STATE(7983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5868),
    [anon_sym_COMMA] = ACTIONS(5868),
    [anon_sym_RPAREN] = ACTIONS(5868),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5866),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_SLASH] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_PIPE] = ACTIONS(5866),
    [anon_sym_CARET] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_EQ_EQ] = ACTIONS(5868),
    [anon_sym_BANG_EQ] = ACTIONS(5868),
    [anon_sym_GT] = ACTIONS(5866),
    [anon_sym_GT_EQ] = ACTIONS(5868),
    [anon_sym_LT_EQ] = ACTIONS(5866),
    [anon_sym_LT] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5868),
    [anon_sym_GT_GT] = ACTIONS(5868),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SEMI] = ACTIONS(5868),
    [anon_sym___extension__] = ACTIONS(5868),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [anon_sym_RBRACE] = ACTIONS(5868),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_RBRACK] = ACTIONS(5868),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5868),
    [anon_sym_volatile] = ACTIONS(5868),
    [anon_sym_restrict] = ACTIONS(5868),
    [anon_sym___restrict__] = ACTIONS(5868),
    [anon_sym__Atomic] = ACTIONS(5868),
    [anon_sym__Noreturn] = ACTIONS(5868),
    [anon_sym_noreturn] = ACTIONS(5868),
    [anon_sym__Nonnull] = ACTIONS(5868),
    [anon_sym_mutable] = ACTIONS(5868),
    [anon_sym_constinit] = ACTIONS(5868),
    [anon_sym_consteval] = ACTIONS(5868),
    [anon_sym_alignas] = ACTIONS(5868),
    [anon_sym__Alignas] = ACTIONS(5868),
    [anon_sym_QMARK] = ACTIONS(5868),
    [anon_sym_LT_EQ_GT] = ACTIONS(5868),
    [anon_sym_or] = ACTIONS(5868),
    [anon_sym_and] = ACTIONS(5868),
    [anon_sym_bitor] = ACTIONS(5868),
    [anon_sym_xor] = ACTIONS(5868),
    [anon_sym_bitand] = ACTIONS(5868),
    [anon_sym_not_eq] = ACTIONS(5868),
    [anon_sym_DASH_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_PLUS] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5866),
    [anon_sym_DOT_STAR] = ACTIONS(5868),
    [anon_sym_DASH_GT] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5868),
    [anon_sym_decltype] = ACTIONS(5868),
    [anon_sym_final] = ACTIONS(6638),
    [anon_sym_override] = ACTIONS(6638),
    [anon_sym_requires] = ACTIONS(5868),
  },
  [2640] = {
    [sym_attribute_specifier] = STATE(2727),
    [sym_enumerator_list] = STATE(2652),
    [sym_identifier] = ACTIONS(6069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [aux_sym_preproc_if_token2] = ACTIONS(6071),
    [aux_sym_preproc_else_token1] = ACTIONS(6071),
    [aux_sym_preproc_elif_token1] = ACTIONS(6069),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6071),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6069),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6069),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_CARET] = ACTIONS(6069),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_BANG_EQ] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_GT_EQ] = ACTIONS(6071),
    [anon_sym_LT_EQ] = ACTIONS(6069),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_LT_LT] = ACTIONS(6069),
    [anon_sym_GT_GT] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6071),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6069),
    [anon_sym_QMARK] = ACTIONS(6071),
    [anon_sym_STAR_EQ] = ACTIONS(6071),
    [anon_sym_SLASH_EQ] = ACTIONS(6071),
    [anon_sym_PERCENT_EQ] = ACTIONS(6071),
    [anon_sym_PLUS_EQ] = ACTIONS(6071),
    [anon_sym_DASH_EQ] = ACTIONS(6071),
    [anon_sym_LT_LT_EQ] = ACTIONS(6071),
    [anon_sym_GT_GT_EQ] = ACTIONS(6071),
    [anon_sym_AMP_EQ] = ACTIONS(6071),
    [anon_sym_CARET_EQ] = ACTIONS(6071),
    [anon_sym_PIPE_EQ] = ACTIONS(6071),
    [anon_sym_and_eq] = ACTIONS(6069),
    [anon_sym_or_eq] = ACTIONS(6069),
    [anon_sym_xor_eq] = ACTIONS(6069),
    [anon_sym_LT_EQ_GT] = ACTIONS(6071),
    [anon_sym_or] = ACTIONS(6069),
    [anon_sym_and] = ACTIONS(6069),
    [anon_sym_bitor] = ACTIONS(6069),
    [anon_sym_xor] = ACTIONS(6069),
    [anon_sym_bitand] = ACTIONS(6069),
    [anon_sym_not_eq] = ACTIONS(6069),
    [anon_sym_DASH_DASH] = ACTIONS(6071),
    [anon_sym_PLUS_PLUS] = ACTIONS(6071),
    [anon_sym_DOT] = ACTIONS(6069),
    [anon_sym_DOT_STAR] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6069),
    [anon_sym_decltype] = ACTIONS(6069),
  },
  [2641] = {
    [sym_string_literal] = STATE(2491),
    [sym_template_argument_list] = STATE(2841),
    [sym_raw_string_literal] = STATE(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(6625),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6625),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(6627),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
  },
  [2642] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(6640),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2643] = {
    [sym_string_literal] = STATE(2670),
    [sym_template_argument_list] = STATE(3493),
    [sym_raw_string_literal] = STATE(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(6625),
    [anon_sym_LPAREN2] = ACTIONS(6625),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6625),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(6627),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2644] = {
    [sym_string_literal] = STATE(2670),
    [sym_template_argument_list] = STATE(3351),
    [sym_raw_string_literal] = STATE(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(6642),
    [anon_sym_LPAREN2] = ACTIONS(6642),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5663),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(6645),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2645] = {
    [sym_string_literal] = STATE(2649),
    [sym_raw_string_literal] = STATE(2649),
    [aux_sym_concatenated_string_repeat1] = STATE(2649),
    [sym_identifier] = ACTIONS(6648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6423),
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_LPAREN2] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6425),
    [anon_sym_PLUS] = ACTIONS(6425),
    [anon_sym_STAR] = ACTIONS(6425),
    [anon_sym_SLASH] = ACTIONS(6425),
    [anon_sym_PERCENT] = ACTIONS(6425),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_PIPE] = ACTIONS(6425),
    [anon_sym_CARET] = ACTIONS(6425),
    [anon_sym_AMP] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6423),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_GT] = ACTIONS(6425),
    [anon_sym_GT_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6425),
    [anon_sym_LT] = ACTIONS(6425),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_SEMI] = ACTIONS(6423),
    [anon_sym___attribute__] = ACTIONS(6425),
    [anon_sym___attribute] = ACTIONS(6425),
    [anon_sym_LBRACK] = ACTIONS(6423),
    [anon_sym_EQ] = ACTIONS(6425),
    [anon_sym_QMARK] = ACTIONS(6423),
    [anon_sym_STAR_EQ] = ACTIONS(6423),
    [anon_sym_SLASH_EQ] = ACTIONS(6423),
    [anon_sym_PERCENT_EQ] = ACTIONS(6423),
    [anon_sym_PLUS_EQ] = ACTIONS(6423),
    [anon_sym_DASH_EQ] = ACTIONS(6423),
    [anon_sym_LT_LT_EQ] = ACTIONS(6423),
    [anon_sym_GT_GT_EQ] = ACTIONS(6423),
    [anon_sym_AMP_EQ] = ACTIONS(6423),
    [anon_sym_CARET_EQ] = ACTIONS(6423),
    [anon_sym_PIPE_EQ] = ACTIONS(6423),
    [anon_sym_and_eq] = ACTIONS(6425),
    [anon_sym_or_eq] = ACTIONS(6425),
    [anon_sym_xor_eq] = ACTIONS(6425),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_or] = ACTIONS(6425),
    [anon_sym_and] = ACTIONS(6425),
    [anon_sym_bitor] = ACTIONS(6425),
    [anon_sym_xor] = ACTIONS(6425),
    [anon_sym_bitand] = ACTIONS(6425),
    [anon_sym_not_eq] = ACTIONS(6425),
    [anon_sym_DASH_DASH] = ACTIONS(6423),
    [anon_sym_PLUS_PLUS] = ACTIONS(6423),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_DOT_STAR] = ACTIONS(6423),
    [anon_sym_DASH_GT] = ACTIONS(6423),
    [anon_sym_L_DQUOTE] = ACTIONS(6619),
    [anon_sym_u_DQUOTE] = ACTIONS(6619),
    [anon_sym_U_DQUOTE] = ACTIONS(6619),
    [anon_sym_u8_DQUOTE] = ACTIONS(6619),
    [anon_sym_DQUOTE] = ACTIONS(6619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6621),
    [anon_sym_LR_DQUOTE] = ACTIONS(6621),
    [anon_sym_uR_DQUOTE] = ACTIONS(6621),
    [anon_sym_UR_DQUOTE] = ACTIONS(6621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6621),
    [sym_literal_suffix] = ACTIONS(6425),
  },
  [2646] = {
    [sym_string_literal] = STATE(2491),
    [sym_template_argument_list] = STATE(3244),
    [sym_raw_string_literal] = STATE(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(6642),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5666),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_LBRACK] = ACTIONS(6645),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
  },
  [2647] = {
    [sym_template_argument_list] = STATE(2592),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4430),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4435),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_template] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2648] = {
    [sym_string_literal] = STATE(3477),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3477),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym___attribute__] = ACTIONS(4217),
    [anon_sym___attribute] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(6653),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6655),
    [anon_sym_SLASH_EQ] = ACTIONS(6655),
    [anon_sym_PERCENT_EQ] = ACTIONS(6655),
    [anon_sym_PLUS_EQ] = ACTIONS(6655),
    [anon_sym_DASH_EQ] = ACTIONS(6655),
    [anon_sym_LT_LT_EQ] = ACTIONS(6655),
    [anon_sym_GT_GT_EQ] = ACTIONS(6655),
    [anon_sym_AMP_EQ] = ACTIONS(6655),
    [anon_sym_CARET_EQ] = ACTIONS(6655),
    [anon_sym_PIPE_EQ] = ACTIONS(6655),
    [anon_sym_and_eq] = ACTIONS(6655),
    [anon_sym_or_eq] = ACTIONS(6655),
    [anon_sym_xor_eq] = ACTIONS(6655),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(6657),
    [anon_sym_u_DQUOTE] = ACTIONS(6657),
    [anon_sym_U_DQUOTE] = ACTIONS(6657),
    [anon_sym_u8_DQUOTE] = ACTIONS(6657),
    [anon_sym_DQUOTE] = ACTIONS(6657),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6659),
    [anon_sym_LR_DQUOTE] = ACTIONS(6659),
    [anon_sym_uR_DQUOTE] = ACTIONS(6659),
    [anon_sym_UR_DQUOTE] = ACTIONS(6659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6659),
  },
  [2649] = {
    [sym_string_literal] = STATE(2630),
    [sym_raw_string_literal] = STATE(2630),
    [aux_sym_concatenated_string_repeat1] = STATE(2630),
    [sym_identifier] = ACTIONS(6661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6417),
    [anon_sym_COMMA] = ACTIONS(6417),
    [anon_sym_LPAREN2] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_SLASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_PIPE_PIPE] = ACTIONS(6417),
    [anon_sym_AMP_AMP] = ACTIONS(6417),
    [anon_sym_PIPE] = ACTIONS(6419),
    [anon_sym_CARET] = ACTIONS(6419),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_EQ_EQ] = ACTIONS(6417),
    [anon_sym_BANG_EQ] = ACTIONS(6417),
    [anon_sym_GT] = ACTIONS(6419),
    [anon_sym_GT_EQ] = ACTIONS(6417),
    [anon_sym_LT_EQ] = ACTIONS(6419),
    [anon_sym_LT] = ACTIONS(6419),
    [anon_sym_LT_LT] = ACTIONS(6419),
    [anon_sym_GT_GT] = ACTIONS(6419),
    [anon_sym_SEMI] = ACTIONS(6417),
    [anon_sym___attribute__] = ACTIONS(6419),
    [anon_sym___attribute] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_STAR_EQ] = ACTIONS(6417),
    [anon_sym_SLASH_EQ] = ACTIONS(6417),
    [anon_sym_PERCENT_EQ] = ACTIONS(6417),
    [anon_sym_PLUS_EQ] = ACTIONS(6417),
    [anon_sym_DASH_EQ] = ACTIONS(6417),
    [anon_sym_LT_LT_EQ] = ACTIONS(6417),
    [anon_sym_GT_GT_EQ] = ACTIONS(6417),
    [anon_sym_AMP_EQ] = ACTIONS(6417),
    [anon_sym_CARET_EQ] = ACTIONS(6417),
    [anon_sym_PIPE_EQ] = ACTIONS(6417),
    [anon_sym_and_eq] = ACTIONS(6419),
    [anon_sym_or_eq] = ACTIONS(6419),
    [anon_sym_xor_eq] = ACTIONS(6419),
    [anon_sym_LT_EQ_GT] = ACTIONS(6417),
    [anon_sym_or] = ACTIONS(6419),
    [anon_sym_and] = ACTIONS(6419),
    [anon_sym_bitor] = ACTIONS(6419),
    [anon_sym_xor] = ACTIONS(6419),
    [anon_sym_bitand] = ACTIONS(6419),
    [anon_sym_not_eq] = ACTIONS(6419),
    [anon_sym_DASH_DASH] = ACTIONS(6417),
    [anon_sym_PLUS_PLUS] = ACTIONS(6417),
    [anon_sym_DOT] = ACTIONS(6419),
    [anon_sym_DOT_STAR] = ACTIONS(6417),
    [anon_sym_DASH_GT] = ACTIONS(6417),
    [anon_sym_L_DQUOTE] = ACTIONS(6619),
    [anon_sym_u_DQUOTE] = ACTIONS(6619),
    [anon_sym_U_DQUOTE] = ACTIONS(6619),
    [anon_sym_u8_DQUOTE] = ACTIONS(6619),
    [anon_sym_DQUOTE] = ACTIONS(6619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6621),
    [anon_sym_LR_DQUOTE] = ACTIONS(6621),
    [anon_sym_uR_DQUOTE] = ACTIONS(6621),
    [anon_sym_UR_DQUOTE] = ACTIONS(6621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6621),
    [sym_literal_suffix] = ACTIONS(6419),
  },
  [2650] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2464),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5875),
    [anon_sym_COMMA] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5875),
    [anon_sym_LPAREN2] = ACTIONS(5875),
    [anon_sym_DASH] = ACTIONS(5872),
    [anon_sym_PLUS] = ACTIONS(5872),
    [anon_sym_STAR] = ACTIONS(5875),
    [anon_sym_SLASH] = ACTIONS(5872),
    [anon_sym_PERCENT] = ACTIONS(5875),
    [anon_sym_PIPE_PIPE] = ACTIONS(5875),
    [anon_sym_AMP_AMP] = ACTIONS(5875),
    [anon_sym_PIPE] = ACTIONS(5872),
    [anon_sym_CARET] = ACTIONS(5875),
    [anon_sym_AMP] = ACTIONS(5872),
    [anon_sym_EQ_EQ] = ACTIONS(5875),
    [anon_sym_BANG_EQ] = ACTIONS(5875),
    [anon_sym_GT] = ACTIONS(5872),
    [anon_sym_GT_EQ] = ACTIONS(5875),
    [anon_sym_LT_EQ] = ACTIONS(5872),
    [anon_sym_LT] = ACTIONS(5872),
    [anon_sym_LT_LT] = ACTIONS(5875),
    [anon_sym_GT_GT] = ACTIONS(5875),
    [anon_sym_COLON] = ACTIONS(5875),
    [anon_sym_SEMI] = ACTIONS(5875),
    [anon_sym___extension__] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5872),
    [anon_sym___attribute] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(5875),
    [anon_sym_RBRACE] = ACTIONS(5875),
    [anon_sym_signed] = ACTIONS(6355),
    [anon_sym_unsigned] = ACTIONS(6355),
    [anon_sym_long] = ACTIONS(6355),
    [anon_sym_short] = ACTIONS(6355),
    [anon_sym_LBRACK] = ACTIONS(5875),
    [anon_sym_RBRACK] = ACTIONS(5875),
    [anon_sym_const] = ACTIONS(5743),
    [anon_sym_constexpr] = ACTIONS(5743),
    [anon_sym_volatile] = ACTIONS(5743),
    [anon_sym_restrict] = ACTIONS(5743),
    [anon_sym___restrict__] = ACTIONS(5743),
    [anon_sym__Atomic] = ACTIONS(5743),
    [anon_sym__Noreturn] = ACTIONS(5743),
    [anon_sym_noreturn] = ACTIONS(5743),
    [anon_sym__Nonnull] = ACTIONS(5743),
    [anon_sym_mutable] = ACTIONS(5743),
    [anon_sym_constinit] = ACTIONS(5743),
    [anon_sym_consteval] = ACTIONS(5743),
    [anon_sym_alignas] = ACTIONS(5743),
    [anon_sym__Alignas] = ACTIONS(5743),
    [sym_primitive_type] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5875),
    [anon_sym_LT_EQ_GT] = ACTIONS(5875),
    [anon_sym_or] = ACTIONS(5872),
    [anon_sym_and] = ACTIONS(5872),
    [anon_sym_bitor] = ACTIONS(5872),
    [anon_sym_xor] = ACTIONS(5872),
    [anon_sym_bitand] = ACTIONS(5872),
    [anon_sym_not_eq] = ACTIONS(5872),
    [anon_sym_DASH_DASH] = ACTIONS(5875),
    [anon_sym_PLUS_PLUS] = ACTIONS(5875),
    [anon_sym_DOT] = ACTIONS(5872),
    [anon_sym_DOT_STAR] = ACTIONS(5875),
    [anon_sym_DASH_GT] = ACTIONS(5875),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5872),
    [anon_sym_decltype] = ACTIONS(5872),
  },
  [2651] = {
    [sym_string_literal] = STATE(2651),
    [sym_raw_string_literal] = STATE(2651),
    [aux_sym_concatenated_string_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(6663),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_LPAREN2] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6434),
    [anon_sym_PLUS] = ACTIONS(6434),
    [anon_sym_STAR] = ACTIONS(6434),
    [anon_sym_SLASH] = ACTIONS(6434),
    [anon_sym_PERCENT] = ACTIONS(6434),
    [anon_sym_PIPE_PIPE] = ACTIONS(6432),
    [anon_sym_AMP_AMP] = ACTIONS(6432),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_CARET] = ACTIONS(6434),
    [anon_sym_AMP] = ACTIONS(6434),
    [anon_sym_EQ_EQ] = ACTIONS(6432),
    [anon_sym_BANG_EQ] = ACTIONS(6432),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_GT_EQ] = ACTIONS(6432),
    [anon_sym_LT_EQ] = ACTIONS(6434),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_LT_LT] = ACTIONS(6434),
    [anon_sym_GT_GT] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6434),
    [anon_sym_QMARK] = ACTIONS(6432),
    [anon_sym_STAR_EQ] = ACTIONS(6432),
    [anon_sym_SLASH_EQ] = ACTIONS(6432),
    [anon_sym_PERCENT_EQ] = ACTIONS(6432),
    [anon_sym_PLUS_EQ] = ACTIONS(6432),
    [anon_sym_DASH_EQ] = ACTIONS(6432),
    [anon_sym_LT_LT_EQ] = ACTIONS(6432),
    [anon_sym_GT_GT_EQ] = ACTIONS(6432),
    [anon_sym_AMP_EQ] = ACTIONS(6432),
    [anon_sym_CARET_EQ] = ACTIONS(6432),
    [anon_sym_PIPE_EQ] = ACTIONS(6432),
    [anon_sym_and_eq] = ACTIONS(6434),
    [anon_sym_or_eq] = ACTIONS(6434),
    [anon_sym_xor_eq] = ACTIONS(6434),
    [anon_sym_LT_EQ_GT] = ACTIONS(6432),
    [anon_sym_or] = ACTIONS(6434),
    [anon_sym_and] = ACTIONS(6434),
    [anon_sym_bitor] = ACTIONS(6434),
    [anon_sym_xor] = ACTIONS(6434),
    [anon_sym_bitand] = ACTIONS(6434),
    [anon_sym_not_eq] = ACTIONS(6434),
    [anon_sym_DASH_DASH] = ACTIONS(6432),
    [anon_sym_PLUS_PLUS] = ACTIONS(6432),
    [anon_sym_DOT] = ACTIONS(6434),
    [anon_sym_DOT_STAR] = ACTIONS(6432),
    [anon_sym_DASH_GT] = ACTIONS(6434),
    [anon_sym_L_DQUOTE] = ACTIONS(6666),
    [anon_sym_u_DQUOTE] = ACTIONS(6666),
    [anon_sym_U_DQUOTE] = ACTIONS(6666),
    [anon_sym_u8_DQUOTE] = ACTIONS(6666),
    [anon_sym_DQUOTE] = ACTIONS(6666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6669),
    [anon_sym_LR_DQUOTE] = ACTIONS(6669),
    [anon_sym_uR_DQUOTE] = ACTIONS(6669),
    [anon_sym_UR_DQUOTE] = ACTIONS(6669),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6669),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6432),
    [sym_literal_suffix] = ACTIONS(6434),
  },
  [2652] = {
    [sym_attribute_specifier] = STATE(2724),
    [sym_identifier] = ACTIONS(6179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6181),
    [anon_sym_COMMA] = ACTIONS(6181),
    [anon_sym_RPAREN] = ACTIONS(6181),
    [aux_sym_preproc_if_token2] = ACTIONS(6181),
    [aux_sym_preproc_else_token1] = ACTIONS(6181),
    [aux_sym_preproc_elif_token1] = ACTIONS(6179),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6181),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6181),
    [anon_sym_LPAREN2] = ACTIONS(6181),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6179),
    [anon_sym_SLASH] = ACTIONS(6179),
    [anon_sym_PERCENT] = ACTIONS(6179),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_PIPE] = ACTIONS(6179),
    [anon_sym_CARET] = ACTIONS(6179),
    [anon_sym_AMP] = ACTIONS(6179),
    [anon_sym_EQ_EQ] = ACTIONS(6181),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_GT] = ACTIONS(6179),
    [anon_sym_GT_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6179),
    [anon_sym_LT] = ACTIONS(6179),
    [anon_sym_LT_LT] = ACTIONS(6179),
    [anon_sym_GT_GT] = ACTIONS(6179),
    [anon_sym_COLON] = ACTIONS(6181),
    [anon_sym_SEMI] = ACTIONS(6181),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6181),
    [anon_sym_RBRACE] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6181),
    [anon_sym_RBRACK] = ACTIONS(6181),
    [anon_sym_EQ] = ACTIONS(6179),
    [anon_sym_QMARK] = ACTIONS(6181),
    [anon_sym_STAR_EQ] = ACTIONS(6181),
    [anon_sym_SLASH_EQ] = ACTIONS(6181),
    [anon_sym_PERCENT_EQ] = ACTIONS(6181),
    [anon_sym_PLUS_EQ] = ACTIONS(6181),
    [anon_sym_DASH_EQ] = ACTIONS(6181),
    [anon_sym_LT_LT_EQ] = ACTIONS(6181),
    [anon_sym_GT_GT_EQ] = ACTIONS(6181),
    [anon_sym_AMP_EQ] = ACTIONS(6181),
    [anon_sym_CARET_EQ] = ACTIONS(6181),
    [anon_sym_PIPE_EQ] = ACTIONS(6181),
    [anon_sym_and_eq] = ACTIONS(6179),
    [anon_sym_or_eq] = ACTIONS(6179),
    [anon_sym_xor_eq] = ACTIONS(6179),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_or] = ACTIONS(6179),
    [anon_sym_and] = ACTIONS(6179),
    [anon_sym_bitor] = ACTIONS(6179),
    [anon_sym_xor] = ACTIONS(6179),
    [anon_sym_bitand] = ACTIONS(6179),
    [anon_sym_not_eq] = ACTIONS(6179),
    [anon_sym_DASH_DASH] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(6181),
    [anon_sym_DOT] = ACTIONS(6179),
    [anon_sym_DOT_STAR] = ACTIONS(6181),
    [anon_sym_DASH_GT] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6179),
    [anon_sym_decltype] = ACTIONS(6179),
  },
  [2653] = {
    [sym_identifier] = ACTIONS(2382),
    [anon_sym___extension__] = ACTIONS(2382),
    [anon_sym_in] = ACTIONS(2382),
    [anon_sym_out] = ACTIONS(2382),
    [anon_sym_inout] = ACTIONS(2382),
    [anon_sym_virtual] = ACTIONS(2382),
    [anon_sym_extern] = ACTIONS(2382),
    [anon_sym___attribute__] = ACTIONS(2382),
    [anon_sym___attribute] = ACTIONS(2382),
    [anon_sym_COLON_COLON] = ACTIONS(2384),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2384),
    [anon_sym___declspec] = ACTIONS(2382),
    [anon_sym_signed] = ACTIONS(2382),
    [anon_sym_unsigned] = ACTIONS(2382),
    [anon_sym_long] = ACTIONS(2382),
    [anon_sym_short] = ACTIONS(2382),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_register] = ACTIONS(2382),
    [anon_sym_inline] = ACTIONS(2382),
    [anon_sym___inline] = ACTIONS(2382),
    [anon_sym___inline__] = ACTIONS(2382),
    [anon_sym___forceinline] = ACTIONS(2382),
    [anon_sym_thread_local] = ACTIONS(2382),
    [anon_sym___thread] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_constexpr] = ACTIONS(2382),
    [anon_sym_volatile] = ACTIONS(2382),
    [anon_sym_restrict] = ACTIONS(2382),
    [anon_sym___restrict__] = ACTIONS(2382),
    [anon_sym__Atomic] = ACTIONS(2382),
    [anon_sym__Noreturn] = ACTIONS(2382),
    [anon_sym_noreturn] = ACTIONS(2382),
    [anon_sym__Nonnull] = ACTIONS(2382),
    [anon_sym_mutable] = ACTIONS(2382),
    [anon_sym_constinit] = ACTIONS(2382),
    [anon_sym_consteval] = ACTIONS(2382),
    [anon_sym_alignas] = ACTIONS(2382),
    [anon_sym__Alignas] = ACTIONS(2382),
    [sym_primitive_type] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_struct] = ACTIONS(2382),
    [anon_sym_union] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2382),
    [anon_sym_decltype] = ACTIONS(2382),
    [anon_sym_typename] = ACTIONS(2382),
    [anon_sym_template] = ACTIONS(2382),
    [anon_sym_precise] = ACTIONS(2382),
    [anon_sym_shared] = ACTIONS(2382),
    [anon_sym_groupshared] = ACTIONS(2382),
    [anon_sym_uniform] = ACTIONS(2382),
    [anon_sym_row_major] = ACTIONS(2382),
    [anon_sym_column_major] = ACTIONS(2382),
    [anon_sym_globallycoherent] = ACTIONS(2382),
    [anon_sym_centroid] = ACTIONS(2382),
    [anon_sym_noperspective] = ACTIONS(2382),
    [anon_sym_nointerpolation] = ACTIONS(2382),
    [anon_sym_sample] = ACTIONS(2382),
    [anon_sym_linear] = ACTIONS(2382),
    [anon_sym_snorm] = ACTIONS(2382),
    [anon_sym_unorm] = ACTIONS(2382),
    [anon_sym_point] = ACTIONS(2382),
    [anon_sym_line] = ACTIONS(2382),
    [anon_sym_triangleadj] = ACTIONS(2382),
    [anon_sym_lineadj] = ACTIONS(2382),
    [anon_sym_triangle] = ACTIONS(2382),
  },
  [2654] = {
    [sym_identifier] = ACTIONS(2197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2187),
    [anon_sym_COMMA] = ACTIONS(2187),
    [anon_sym_LPAREN2] = ACTIONS(2187),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(2197),
    [anon_sym_PERCENT] = ACTIONS(2187),
    [anon_sym_PIPE_PIPE] = ACTIONS(2187),
    [anon_sym_AMP_AMP] = ACTIONS(2187),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2197),
    [anon_sym_EQ_EQ] = ACTIONS(2187),
    [anon_sym_BANG_EQ] = ACTIONS(2187),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_EQ] = ACTIONS(2197),
    [anon_sym_LT_EQ] = ACTIONS(2197),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_LT_LT] = ACTIONS(2187),
    [anon_sym_GT_GT] = ACTIONS(2197),
    [anon_sym_COLON] = ACTIONS(2187),
    [anon_sym___extension__] = ACTIONS(2197),
    [anon_sym___attribute__] = ACTIONS(2197),
    [anon_sym___attribute] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_signed] = ACTIONS(2197),
    [anon_sym_unsigned] = ACTIONS(2197),
    [anon_sym_long] = ACTIONS(2197),
    [anon_sym_short] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_constexpr] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_restrict] = ACTIONS(2197),
    [anon_sym___restrict__] = ACTIONS(2197),
    [anon_sym__Atomic] = ACTIONS(2197),
    [anon_sym__Noreturn] = ACTIONS(2197),
    [anon_sym_noreturn] = ACTIONS(2197),
    [anon_sym__Nonnull] = ACTIONS(2197),
    [anon_sym_mutable] = ACTIONS(2197),
    [anon_sym_constinit] = ACTIONS(2197),
    [anon_sym_consteval] = ACTIONS(2197),
    [anon_sym_alignas] = ACTIONS(2197),
    [anon_sym__Alignas] = ACTIONS(2197),
    [sym_primitive_type] = ACTIONS(2197),
    [anon_sym_QMARK] = ACTIONS(2187),
    [anon_sym_LT_EQ_GT] = ACTIONS(2187),
    [anon_sym_or] = ACTIONS(2197),
    [anon_sym_and] = ACTIONS(2197),
    [anon_sym_bitor] = ACTIONS(2197),
    [anon_sym_xor] = ACTIONS(2197),
    [anon_sym_bitand] = ACTIONS(2197),
    [anon_sym_not_eq] = ACTIONS(2197),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DOT] = ACTIONS(2197),
    [anon_sym_DOT_STAR] = ACTIONS(2187),
    [anon_sym_DASH_GT] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2197),
    [anon_sym_decltype] = ACTIONS(2197),
    [anon_sym_final] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_GT2] = ACTIONS(2187),
    [anon_sym_requires] = ACTIONS(2197),
  },
  [2655] = {
    [sym_attribute_declaration] = STATE(2751),
    [sym_parameter_list] = STATE(2776),
    [aux_sym_attributed_declarator_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(6672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6674),
    [anon_sym_COMMA] = ACTIONS(6674),
    [anon_sym_RPAREN] = ACTIONS(6674),
    [aux_sym_preproc_if_token2] = ACTIONS(6674),
    [aux_sym_preproc_else_token1] = ACTIONS(6674),
    [aux_sym_preproc_elif_token1] = ACTIONS(6672),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6674),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6674),
    [anon_sym_LPAREN2] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_PERCENT] = ACTIONS(6672),
    [anon_sym_PIPE_PIPE] = ACTIONS(6674),
    [anon_sym_AMP_AMP] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_AMP] = ACTIONS(6672),
    [anon_sym_EQ_EQ] = ACTIONS(6674),
    [anon_sym_BANG_EQ] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6672),
    [anon_sym_GT_EQ] = ACTIONS(6674),
    [anon_sym_LT_EQ] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6672),
    [anon_sym_LT_LT] = ACTIONS(6672),
    [anon_sym_GT_GT] = ACTIONS(6672),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SEMI] = ACTIONS(6674),
    [anon_sym___attribute__] = ACTIONS(6672),
    [anon_sym___attribute] = ACTIONS(6672),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6674),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_QMARK] = ACTIONS(6674),
    [anon_sym_STAR_EQ] = ACTIONS(6674),
    [anon_sym_SLASH_EQ] = ACTIONS(6674),
    [anon_sym_PERCENT_EQ] = ACTIONS(6674),
    [anon_sym_PLUS_EQ] = ACTIONS(6674),
    [anon_sym_DASH_EQ] = ACTIONS(6674),
    [anon_sym_LT_LT_EQ] = ACTIONS(6674),
    [anon_sym_GT_GT_EQ] = ACTIONS(6674),
    [anon_sym_AMP_EQ] = ACTIONS(6674),
    [anon_sym_CARET_EQ] = ACTIONS(6674),
    [anon_sym_PIPE_EQ] = ACTIONS(6674),
    [anon_sym_and_eq] = ACTIONS(6672),
    [anon_sym_or_eq] = ACTIONS(6672),
    [anon_sym_xor_eq] = ACTIONS(6672),
    [anon_sym_LT_EQ_GT] = ACTIONS(6674),
    [anon_sym_or] = ACTIONS(6672),
    [anon_sym_and] = ACTIONS(6672),
    [anon_sym_bitor] = ACTIONS(6672),
    [anon_sym_xor] = ACTIONS(6672),
    [anon_sym_bitand] = ACTIONS(6672),
    [anon_sym_not_eq] = ACTIONS(6672),
    [anon_sym_DASH_DASH] = ACTIONS(6674),
    [anon_sym_PLUS_PLUS] = ACTIONS(6674),
    [anon_sym_DOT] = ACTIONS(6672),
    [anon_sym_DOT_STAR] = ACTIONS(6674),
    [anon_sym_DASH_GT] = ACTIONS(6674),
    [sym_comment] = ACTIONS(3),
  },
  [2656] = {
    [sym_attribute_specifier] = STATE(2730),
    [sym_identifier] = ACTIONS(6191),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6193),
    [aux_sym_preproc_if_token2] = ACTIONS(6193),
    [aux_sym_preproc_else_token1] = ACTIONS(6193),
    [aux_sym_preproc_elif_token1] = ACTIONS(6191),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6193),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6193),
    [anon_sym_LPAREN2] = ACTIONS(6193),
    [anon_sym_DASH] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_STAR] = ACTIONS(6191),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6191),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6191),
    [anon_sym_AMP] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6191),
    [anon_sym_GT_EQ] = ACTIONS(6193),
    [anon_sym_LT_EQ] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6191),
    [anon_sym_GT_GT] = ACTIONS(6191),
    [anon_sym_COLON] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6193),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6193),
    [anon_sym_RBRACE] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6193),
    [anon_sym_RBRACK] = ACTIONS(6193),
    [anon_sym_EQ] = ACTIONS(6191),
    [anon_sym_QMARK] = ACTIONS(6193),
    [anon_sym_STAR_EQ] = ACTIONS(6193),
    [anon_sym_SLASH_EQ] = ACTIONS(6193),
    [anon_sym_PERCENT_EQ] = ACTIONS(6193),
    [anon_sym_PLUS_EQ] = ACTIONS(6193),
    [anon_sym_DASH_EQ] = ACTIONS(6193),
    [anon_sym_LT_LT_EQ] = ACTIONS(6193),
    [anon_sym_GT_GT_EQ] = ACTIONS(6193),
    [anon_sym_AMP_EQ] = ACTIONS(6193),
    [anon_sym_CARET_EQ] = ACTIONS(6193),
    [anon_sym_PIPE_EQ] = ACTIONS(6193),
    [anon_sym_and_eq] = ACTIONS(6191),
    [anon_sym_or_eq] = ACTIONS(6191),
    [anon_sym_xor_eq] = ACTIONS(6191),
    [anon_sym_LT_EQ_GT] = ACTIONS(6193),
    [anon_sym_or] = ACTIONS(6191),
    [anon_sym_and] = ACTIONS(6191),
    [anon_sym_bitor] = ACTIONS(6191),
    [anon_sym_xor] = ACTIONS(6191),
    [anon_sym_bitand] = ACTIONS(6191),
    [anon_sym_not_eq] = ACTIONS(6191),
    [anon_sym_DASH_DASH] = ACTIONS(6193),
    [anon_sym_PLUS_PLUS] = ACTIONS(6193),
    [anon_sym_DOT] = ACTIONS(6191),
    [anon_sym_DOT_STAR] = ACTIONS(6193),
    [anon_sym_DASH_GT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6191),
    [anon_sym_decltype] = ACTIONS(6191),
  },
  [2657] = {
    [sym_template_argument_list] = STATE(2507),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [anon_sym_RPAREN] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5793),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5791),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym_COLON] = ACTIONS(5791),
    [anon_sym_SEMI] = ACTIONS(5793),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_RBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(6682),
    [anon_sym_unsigned] = ACTIONS(6682),
    [anon_sym_long] = ACTIONS(6682),
    [anon_sym_short] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_RBRACK] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(5791),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_STAR_EQ] = ACTIONS(5793),
    [anon_sym_SLASH_EQ] = ACTIONS(5793),
    [anon_sym_PERCENT_EQ] = ACTIONS(5793),
    [anon_sym_PLUS_EQ] = ACTIONS(5793),
    [anon_sym_DASH_EQ] = ACTIONS(5793),
    [anon_sym_LT_LT_EQ] = ACTIONS(5793),
    [anon_sym_GT_GT_EQ] = ACTIONS(5793),
    [anon_sym_AMP_EQ] = ACTIONS(5793),
    [anon_sym_CARET_EQ] = ACTIONS(5793),
    [anon_sym_PIPE_EQ] = ACTIONS(5793),
    [anon_sym_and_eq] = ACTIONS(5793),
    [anon_sym_or_eq] = ACTIONS(5793),
    [anon_sym_xor_eq] = ACTIONS(5793),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5791),
    [anon_sym_and] = ACTIONS(5791),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5791),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
  },
  [2658] = {
    [sym_string_literal] = STATE(2670),
    [sym_template_argument_list] = STATE(3493),
    [sym_raw_string_literal] = STATE(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5688),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2659] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2660] = {
    [sym_attribute_declaration] = STATE(2751),
    [sym_parameter_list] = STATE(2776),
    [aux_sym_attributed_declarator_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(6684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6686),
    [anon_sym_COMMA] = ACTIONS(6686),
    [anon_sym_RPAREN] = ACTIONS(6686),
    [aux_sym_preproc_if_token2] = ACTIONS(6686),
    [aux_sym_preproc_else_token1] = ACTIONS(6686),
    [aux_sym_preproc_elif_token1] = ACTIONS(6684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6686),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6686),
    [anon_sym_LPAREN2] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_PERCENT] = ACTIONS(6684),
    [anon_sym_PIPE_PIPE] = ACTIONS(6686),
    [anon_sym_AMP_AMP] = ACTIONS(6686),
    [anon_sym_PIPE] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_AMP] = ACTIONS(6684),
    [anon_sym_EQ_EQ] = ACTIONS(6686),
    [anon_sym_BANG_EQ] = ACTIONS(6686),
    [anon_sym_GT] = ACTIONS(6684),
    [anon_sym_GT_EQ] = ACTIONS(6686),
    [anon_sym_LT_EQ] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6684),
    [anon_sym_LT_LT] = ACTIONS(6684),
    [anon_sym_GT_GT] = ACTIONS(6684),
    [anon_sym_COLON] = ACTIONS(6686),
    [anon_sym_SEMI] = ACTIONS(6686),
    [anon_sym___attribute__] = ACTIONS(6684),
    [anon_sym___attribute] = ACTIONS(6684),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6686),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6686),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_QMARK] = ACTIONS(6686),
    [anon_sym_STAR_EQ] = ACTIONS(6686),
    [anon_sym_SLASH_EQ] = ACTIONS(6686),
    [anon_sym_PERCENT_EQ] = ACTIONS(6686),
    [anon_sym_PLUS_EQ] = ACTIONS(6686),
    [anon_sym_DASH_EQ] = ACTIONS(6686),
    [anon_sym_LT_LT_EQ] = ACTIONS(6686),
    [anon_sym_GT_GT_EQ] = ACTIONS(6686),
    [anon_sym_AMP_EQ] = ACTIONS(6686),
    [anon_sym_CARET_EQ] = ACTIONS(6686),
    [anon_sym_PIPE_EQ] = ACTIONS(6686),
    [anon_sym_and_eq] = ACTIONS(6684),
    [anon_sym_or_eq] = ACTIONS(6684),
    [anon_sym_xor_eq] = ACTIONS(6684),
    [anon_sym_LT_EQ_GT] = ACTIONS(6686),
    [anon_sym_or] = ACTIONS(6684),
    [anon_sym_and] = ACTIONS(6684),
    [anon_sym_bitor] = ACTIONS(6684),
    [anon_sym_xor] = ACTIONS(6684),
    [anon_sym_bitand] = ACTIONS(6684),
    [anon_sym_not_eq] = ACTIONS(6684),
    [anon_sym_DASH_DASH] = ACTIONS(6686),
    [anon_sym_PLUS_PLUS] = ACTIONS(6686),
    [anon_sym_DOT] = ACTIONS(6684),
    [anon_sym_DOT_STAR] = ACTIONS(6686),
    [anon_sym_DASH_GT] = ACTIONS(6686),
    [sym_comment] = ACTIONS(3),
  },
  [2661] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_DASH] = ACTIONS(5166),
    [anon_sym_PLUS] = ACTIONS(5166),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_SLASH] = ACTIONS(5166),
    [anon_sym_PERCENT] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_PIPE] = ACTIONS(5166),
    [anon_sym_CARET] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_EQ_EQ] = ACTIONS(5168),
    [anon_sym_BANG_EQ] = ACTIONS(5168),
    [anon_sym_GT] = ACTIONS(5166),
    [anon_sym_GT_EQ] = ACTIONS(5166),
    [anon_sym_LT_EQ] = ACTIONS(5166),
    [anon_sym_LT] = ACTIONS(5166),
    [anon_sym_LT_LT] = ACTIONS(5168),
    [anon_sym_GT_GT] = ACTIONS(5166),
    [anon_sym_COLON] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_QMARK] = ACTIONS(5168),
    [anon_sym_LT_EQ_GT] = ACTIONS(5168),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_bitor] = ACTIONS(5166),
    [anon_sym_xor] = ACTIONS(5166),
    [anon_sym_bitand] = ACTIONS(5166),
    [anon_sym_not_eq] = ACTIONS(5166),
    [anon_sym_DASH_DASH] = ACTIONS(5168),
    [anon_sym_PLUS_PLUS] = ACTIONS(5168),
    [anon_sym_DOT] = ACTIONS(5166),
    [anon_sym_DOT_STAR] = ACTIONS(5168),
    [anon_sym_DASH_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
    [anon_sym_requires] = ACTIONS(5166),
  },
  [2662] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2663] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4271),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2664] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [aux_sym_preproc_if_token2] = ACTIONS(5859),
    [aux_sym_preproc_else_token1] = ACTIONS(5859),
    [aux_sym_preproc_elif_token1] = ACTIONS(5857),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5857),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5857),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5857),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5857),
    [anon_sym_GT_GT] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5857),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_EQ] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_STAR_EQ] = ACTIONS(5859),
    [anon_sym_SLASH_EQ] = ACTIONS(5859),
    [anon_sym_PERCENT_EQ] = ACTIONS(5859),
    [anon_sym_PLUS_EQ] = ACTIONS(5859),
    [anon_sym_DASH_EQ] = ACTIONS(5859),
    [anon_sym_LT_LT_EQ] = ACTIONS(5859),
    [anon_sym_GT_GT_EQ] = ACTIONS(5859),
    [anon_sym_AMP_EQ] = ACTIONS(5859),
    [anon_sym_CARET_EQ] = ACTIONS(5859),
    [anon_sym_PIPE_EQ] = ACTIONS(5859),
    [anon_sym_and_eq] = ACTIONS(5857),
    [anon_sym_or_eq] = ACTIONS(5857),
    [anon_sym_xor_eq] = ACTIONS(5857),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
  },
  [2665] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6688),
    [anon_sym_COMMA] = ACTIONS(6691),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(6694),
    [anon_sym_EQ] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6700),
    [anon_sym_SLASH_EQ] = ACTIONS(6700),
    [anon_sym_PERCENT_EQ] = ACTIONS(6700),
    [anon_sym_PLUS_EQ] = ACTIONS(6700),
    [anon_sym_DASH_EQ] = ACTIONS(6700),
    [anon_sym_LT_LT_EQ] = ACTIONS(6700),
    [anon_sym_GT_GT_EQ] = ACTIONS(6700),
    [anon_sym_AMP_EQ] = ACTIONS(6700),
    [anon_sym_CARET_EQ] = ACTIONS(6700),
    [anon_sym_PIPE_EQ] = ACTIONS(6700),
    [anon_sym_and_eq] = ACTIONS(6700),
    [anon_sym_or_eq] = ACTIONS(6700),
    [anon_sym_xor_eq] = ACTIONS(6700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2666] = {
    [sym_string_literal] = STATE(2884),
    [sym_template_argument_list] = STATE(3929),
    [sym_raw_string_literal] = STATE(2884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6702),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(6705),
    [anon_sym_or_eq] = ACTIONS(6705),
    [anon_sym_xor_eq] = ACTIONS(6705),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4225),
    [anon_sym_L_DQUOTE] = ACTIONS(4320),
    [anon_sym_u_DQUOTE] = ACTIONS(4320),
    [anon_sym_U_DQUOTE] = ACTIONS(4320),
    [anon_sym_u8_DQUOTE] = ACTIONS(4320),
    [anon_sym_DQUOTE] = ACTIONS(4320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4322),
    [anon_sym_LR_DQUOTE] = ACTIONS(4322),
    [anon_sym_uR_DQUOTE] = ACTIONS(4322),
    [anon_sym_UR_DQUOTE] = ACTIONS(4322),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4322),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4217),
  },
  [2667] = {
    [sym_attribute_declaration] = STATE(2751),
    [sym_parameter_list] = STATE(2776),
    [aux_sym_attributed_declarator_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(6707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6709),
    [anon_sym_COMMA] = ACTIONS(6709),
    [anon_sym_RPAREN] = ACTIONS(6709),
    [aux_sym_preproc_if_token2] = ACTIONS(6709),
    [aux_sym_preproc_else_token1] = ACTIONS(6709),
    [aux_sym_preproc_elif_token1] = ACTIONS(6707),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6709),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6709),
    [anon_sym_LPAREN2] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6707),
    [anon_sym_PLUS] = ACTIONS(6707),
    [anon_sym_STAR] = ACTIONS(6707),
    [anon_sym_SLASH] = ACTIONS(6707),
    [anon_sym_PERCENT] = ACTIONS(6707),
    [anon_sym_PIPE_PIPE] = ACTIONS(6709),
    [anon_sym_AMP_AMP] = ACTIONS(6709),
    [anon_sym_PIPE] = ACTIONS(6707),
    [anon_sym_CARET] = ACTIONS(6707),
    [anon_sym_AMP] = ACTIONS(6707),
    [anon_sym_EQ_EQ] = ACTIONS(6709),
    [anon_sym_BANG_EQ] = ACTIONS(6709),
    [anon_sym_GT] = ACTIONS(6707),
    [anon_sym_GT_EQ] = ACTIONS(6709),
    [anon_sym_LT_EQ] = ACTIONS(6707),
    [anon_sym_LT] = ACTIONS(6707),
    [anon_sym_LT_LT] = ACTIONS(6707),
    [anon_sym_GT_GT] = ACTIONS(6707),
    [anon_sym_COLON] = ACTIONS(6709),
    [anon_sym_SEMI] = ACTIONS(6709),
    [anon_sym___attribute__] = ACTIONS(6707),
    [anon_sym___attribute] = ACTIONS(6707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6709),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6709),
    [anon_sym_EQ] = ACTIONS(6707),
    [anon_sym_QMARK] = ACTIONS(6709),
    [anon_sym_STAR_EQ] = ACTIONS(6709),
    [anon_sym_SLASH_EQ] = ACTIONS(6709),
    [anon_sym_PERCENT_EQ] = ACTIONS(6709),
    [anon_sym_PLUS_EQ] = ACTIONS(6709),
    [anon_sym_DASH_EQ] = ACTIONS(6709),
    [anon_sym_LT_LT_EQ] = ACTIONS(6709),
    [anon_sym_GT_GT_EQ] = ACTIONS(6709),
    [anon_sym_AMP_EQ] = ACTIONS(6709),
    [anon_sym_CARET_EQ] = ACTIONS(6709),
    [anon_sym_PIPE_EQ] = ACTIONS(6709),
    [anon_sym_and_eq] = ACTIONS(6707),
    [anon_sym_or_eq] = ACTIONS(6707),
    [anon_sym_xor_eq] = ACTIONS(6707),
    [anon_sym_LT_EQ_GT] = ACTIONS(6709),
    [anon_sym_or] = ACTIONS(6707),
    [anon_sym_and] = ACTIONS(6707),
    [anon_sym_bitor] = ACTIONS(6707),
    [anon_sym_xor] = ACTIONS(6707),
    [anon_sym_bitand] = ACTIONS(6707),
    [anon_sym_not_eq] = ACTIONS(6707),
    [anon_sym_DASH_DASH] = ACTIONS(6709),
    [anon_sym_PLUS_PLUS] = ACTIONS(6709),
    [anon_sym_DOT] = ACTIONS(6707),
    [anon_sym_DOT_STAR] = ACTIONS(6709),
    [anon_sym_DASH_GT] = ACTIONS(6709),
    [sym_comment] = ACTIONS(3),
  },
  [2668] = {
    [sym_template_argument_list] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2820),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(4223),
    [anon_sym_RPAREN] = ACTIONS(4223),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_PIPE_PIPE] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4223),
    [anon_sym_BANG_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_GT_EQ] = ACTIONS(4223),
    [anon_sym_LT_EQ] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_COLON] = ACTIONS(4215),
    [anon_sym_SEMI] = ACTIONS(4223),
    [anon_sym___attribute__] = ACTIONS(4223),
    [anon_sym___attribute] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(4223),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_signed] = ACTIONS(6682),
    [anon_sym_unsigned] = ACTIONS(6682),
    [anon_sym_long] = ACTIONS(6682),
    [anon_sym_short] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(4223),
    [anon_sym_RBRACK] = ACTIONS(4223),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4223),
    [anon_sym_STAR_EQ] = ACTIONS(4223),
    [anon_sym_SLASH_EQ] = ACTIONS(4223),
    [anon_sym_PERCENT_EQ] = ACTIONS(4223),
    [anon_sym_PLUS_EQ] = ACTIONS(4223),
    [anon_sym_DASH_EQ] = ACTIONS(4223),
    [anon_sym_LT_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT_GT_EQ] = ACTIONS(4223),
    [anon_sym_AMP_EQ] = ACTIONS(4223),
    [anon_sym_CARET_EQ] = ACTIONS(4223),
    [anon_sym_PIPE_EQ] = ACTIONS(4223),
    [anon_sym_and_eq] = ACTIONS(4223),
    [anon_sym_or_eq] = ACTIONS(4223),
    [anon_sym_xor_eq] = ACTIONS(4223),
    [anon_sym_LT_EQ_GT] = ACTIONS(4223),
    [anon_sym_or] = ACTIONS(4215),
    [anon_sym_and] = ACTIONS(4215),
    [anon_sym_bitor] = ACTIONS(4223),
    [anon_sym_xor] = ACTIONS(4215),
    [anon_sym_bitand] = ACTIONS(4223),
    [anon_sym_not_eq] = ACTIONS(4223),
    [anon_sym_DASH_DASH] = ACTIONS(4223),
    [anon_sym_PLUS_PLUS] = ACTIONS(4223),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_DOT_STAR] = ACTIONS(4223),
    [anon_sym_DASH_GT] = ACTIONS(4223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4223),
    [anon_sym_decltype] = ACTIONS(4223),
  },
  [2669] = {
    [sym_attribute_specifier] = STATE(2725),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6217),
    [anon_sym_RPAREN] = ACTIONS(6217),
    [aux_sym_preproc_if_token2] = ACTIONS(6217),
    [aux_sym_preproc_else_token1] = ACTIONS(6217),
    [aux_sym_preproc_elif_token1] = ACTIONS(6215),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6217),
    [anon_sym_LPAREN2] = ACTIONS(6217),
    [anon_sym_DASH] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_SLASH] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_CARET] = ACTIONS(6215),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(6217),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_LT_LT] = ACTIONS(6215),
    [anon_sym_GT_GT] = ACTIONS(6215),
    [anon_sym_COLON] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6217),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6217),
    [anon_sym_RBRACE] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6217),
    [anon_sym_RBRACK] = ACTIONS(6217),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_QMARK] = ACTIONS(6217),
    [anon_sym_STAR_EQ] = ACTIONS(6217),
    [anon_sym_SLASH_EQ] = ACTIONS(6217),
    [anon_sym_PERCENT_EQ] = ACTIONS(6217),
    [anon_sym_PLUS_EQ] = ACTIONS(6217),
    [anon_sym_DASH_EQ] = ACTIONS(6217),
    [anon_sym_LT_LT_EQ] = ACTIONS(6217),
    [anon_sym_GT_GT_EQ] = ACTIONS(6217),
    [anon_sym_AMP_EQ] = ACTIONS(6217),
    [anon_sym_CARET_EQ] = ACTIONS(6217),
    [anon_sym_PIPE_EQ] = ACTIONS(6217),
    [anon_sym_and_eq] = ACTIONS(6215),
    [anon_sym_or_eq] = ACTIONS(6215),
    [anon_sym_xor_eq] = ACTIONS(6215),
    [anon_sym_LT_EQ_GT] = ACTIONS(6217),
    [anon_sym_or] = ACTIONS(6215),
    [anon_sym_and] = ACTIONS(6215),
    [anon_sym_bitor] = ACTIONS(6215),
    [anon_sym_xor] = ACTIONS(6215),
    [anon_sym_bitand] = ACTIONS(6215),
    [anon_sym_not_eq] = ACTIONS(6215),
    [anon_sym_DASH_DASH] = ACTIONS(6217),
    [anon_sym_PLUS_PLUS] = ACTIONS(6217),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_DOT_STAR] = ACTIONS(6217),
    [anon_sym_DASH_GT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6215),
    [anon_sym_decltype] = ACTIONS(6215),
  },
  [2670] = {
    [sym_string_literal] = STATE(2678),
    [sym_raw_string_literal] = STATE(2678),
    [aux_sym_concatenated_string_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(6711),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6423),
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_RPAREN] = ACTIONS(6423),
    [anon_sym_LPAREN2] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6425),
    [anon_sym_PLUS] = ACTIONS(6425),
    [anon_sym_STAR] = ACTIONS(6425),
    [anon_sym_SLASH] = ACTIONS(6425),
    [anon_sym_PERCENT] = ACTIONS(6425),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_PIPE] = ACTIONS(6425),
    [anon_sym_CARET] = ACTIONS(6425),
    [anon_sym_AMP] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6423),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_GT] = ACTIONS(6425),
    [anon_sym_GT_EQ] = ACTIONS(6423),
    [anon_sym_LT_EQ] = ACTIONS(6425),
    [anon_sym_LT] = ACTIONS(6425),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_LBRACK] = ACTIONS(6423),
    [anon_sym_EQ] = ACTIONS(6425),
    [anon_sym_QMARK] = ACTIONS(6423),
    [anon_sym_STAR_EQ] = ACTIONS(6423),
    [anon_sym_SLASH_EQ] = ACTIONS(6423),
    [anon_sym_PERCENT_EQ] = ACTIONS(6423),
    [anon_sym_PLUS_EQ] = ACTIONS(6423),
    [anon_sym_DASH_EQ] = ACTIONS(6423),
    [anon_sym_LT_LT_EQ] = ACTIONS(6423),
    [anon_sym_GT_GT_EQ] = ACTIONS(6423),
    [anon_sym_AMP_EQ] = ACTIONS(6423),
    [anon_sym_CARET_EQ] = ACTIONS(6423),
    [anon_sym_PIPE_EQ] = ACTIONS(6423),
    [anon_sym_and_eq] = ACTIONS(6425),
    [anon_sym_or_eq] = ACTIONS(6425),
    [anon_sym_xor_eq] = ACTIONS(6425),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_or] = ACTIONS(6425),
    [anon_sym_and] = ACTIONS(6425),
    [anon_sym_bitor] = ACTIONS(6425),
    [anon_sym_xor] = ACTIONS(6425),
    [anon_sym_bitand] = ACTIONS(6425),
    [anon_sym_not_eq] = ACTIONS(6425),
    [anon_sym_DASH_DASH] = ACTIONS(6423),
    [anon_sym_PLUS_PLUS] = ACTIONS(6423),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_DOT_STAR] = ACTIONS(6423),
    [anon_sym_DASH_GT] = ACTIONS(6425),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6423),
    [sym_literal_suffix] = ACTIONS(6425),
  },
  [2671] = {
    [sym_attribute_declaration] = STATE(2751),
    [sym_parameter_list] = STATE(2776),
    [aux_sym_attributed_declarator_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(6713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6715),
    [anon_sym_COMMA] = ACTIONS(6715),
    [anon_sym_RPAREN] = ACTIONS(6715),
    [aux_sym_preproc_if_token2] = ACTIONS(6715),
    [aux_sym_preproc_else_token1] = ACTIONS(6715),
    [aux_sym_preproc_elif_token1] = ACTIONS(6713),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6715),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6715),
    [anon_sym_LPAREN2] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6713),
    [anon_sym_PLUS] = ACTIONS(6713),
    [anon_sym_STAR] = ACTIONS(6713),
    [anon_sym_SLASH] = ACTIONS(6713),
    [anon_sym_PERCENT] = ACTIONS(6713),
    [anon_sym_PIPE_PIPE] = ACTIONS(6715),
    [anon_sym_AMP_AMP] = ACTIONS(6715),
    [anon_sym_PIPE] = ACTIONS(6713),
    [anon_sym_CARET] = ACTIONS(6713),
    [anon_sym_AMP] = ACTIONS(6713),
    [anon_sym_EQ_EQ] = ACTIONS(6715),
    [anon_sym_BANG_EQ] = ACTIONS(6715),
    [anon_sym_GT] = ACTIONS(6713),
    [anon_sym_GT_EQ] = ACTIONS(6715),
    [anon_sym_LT_EQ] = ACTIONS(6713),
    [anon_sym_LT] = ACTIONS(6713),
    [anon_sym_LT_LT] = ACTIONS(6713),
    [anon_sym_GT_GT] = ACTIONS(6713),
    [anon_sym_COLON] = ACTIONS(6715),
    [anon_sym_SEMI] = ACTIONS(6715),
    [anon_sym___attribute__] = ACTIONS(6713),
    [anon_sym___attribute] = ACTIONS(6713),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6715),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6715),
    [anon_sym_EQ] = ACTIONS(6713),
    [anon_sym_QMARK] = ACTIONS(6715),
    [anon_sym_STAR_EQ] = ACTIONS(6715),
    [anon_sym_SLASH_EQ] = ACTIONS(6715),
    [anon_sym_PERCENT_EQ] = ACTIONS(6715),
    [anon_sym_PLUS_EQ] = ACTIONS(6715),
    [anon_sym_DASH_EQ] = ACTIONS(6715),
    [anon_sym_LT_LT_EQ] = ACTIONS(6715),
    [anon_sym_GT_GT_EQ] = ACTIONS(6715),
    [anon_sym_AMP_EQ] = ACTIONS(6715),
    [anon_sym_CARET_EQ] = ACTIONS(6715),
    [anon_sym_PIPE_EQ] = ACTIONS(6715),
    [anon_sym_and_eq] = ACTIONS(6713),
    [anon_sym_or_eq] = ACTIONS(6713),
    [anon_sym_xor_eq] = ACTIONS(6713),
    [anon_sym_LT_EQ_GT] = ACTIONS(6715),
    [anon_sym_or] = ACTIONS(6713),
    [anon_sym_and] = ACTIONS(6713),
    [anon_sym_bitor] = ACTIONS(6713),
    [anon_sym_xor] = ACTIONS(6713),
    [anon_sym_bitand] = ACTIONS(6713),
    [anon_sym_not_eq] = ACTIONS(6713),
    [anon_sym_DASH_DASH] = ACTIONS(6715),
    [anon_sym_PLUS_PLUS] = ACTIONS(6715),
    [anon_sym_DOT] = ACTIONS(6713),
    [anon_sym_DOT_STAR] = ACTIONS(6715),
    [anon_sym_DASH_GT] = ACTIONS(6715),
    [sym_comment] = ACTIONS(3),
  },
  [2672] = {
    [sym_type_qualifier] = STATE(2687),
    [sym_alignas_qualifier] = STATE(2654),
    [aux_sym__type_definition_type_repeat1] = STATE(2687),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2850),
    [sym_identifier] = ACTIONS(6717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5729),
    [anon_sym_COMMA] = ACTIONS(5729),
    [anon_sym_LPAREN2] = ACTIONS(5729),
    [anon_sym_DASH] = ACTIONS(5731),
    [anon_sym_PLUS] = ACTIONS(5731),
    [anon_sym_STAR] = ACTIONS(5729),
    [anon_sym_SLASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5729),
    [anon_sym_PIPE_PIPE] = ACTIONS(5729),
    [anon_sym_AMP_AMP] = ACTIONS(5729),
    [anon_sym_PIPE] = ACTIONS(5731),
    [anon_sym_CARET] = ACTIONS(5729),
    [anon_sym_AMP] = ACTIONS(5731),
    [anon_sym_EQ_EQ] = ACTIONS(5729),
    [anon_sym_BANG_EQ] = ACTIONS(5729),
    [anon_sym_GT] = ACTIONS(5731),
    [anon_sym_GT_EQ] = ACTIONS(5731),
    [anon_sym_LT_EQ] = ACTIONS(5731),
    [anon_sym_LT] = ACTIONS(5731),
    [anon_sym_LT_LT] = ACTIONS(5729),
    [anon_sym_GT_GT] = ACTIONS(5731),
    [anon_sym___extension__] = ACTIONS(6719),
    [anon_sym___attribute__] = ACTIONS(5731),
    [anon_sym___attribute] = ACTIONS(5731),
    [anon_sym_LBRACE] = ACTIONS(5729),
    [anon_sym_signed] = ACTIONS(6721),
    [anon_sym_unsigned] = ACTIONS(6721),
    [anon_sym_long] = ACTIONS(6721),
    [anon_sym_short] = ACTIONS(6721),
    [anon_sym_LBRACK] = ACTIONS(5729),
    [anon_sym_const] = ACTIONS(6719),
    [anon_sym_constexpr] = ACTIONS(6719),
    [anon_sym_volatile] = ACTIONS(6719),
    [anon_sym_restrict] = ACTIONS(6719),
    [anon_sym___restrict__] = ACTIONS(6719),
    [anon_sym__Atomic] = ACTIONS(6719),
    [anon_sym__Noreturn] = ACTIONS(6719),
    [anon_sym_noreturn] = ACTIONS(6719),
    [anon_sym__Nonnull] = ACTIONS(6719),
    [anon_sym_mutable] = ACTIONS(6719),
    [anon_sym_constinit] = ACTIONS(6719),
    [anon_sym_consteval] = ACTIONS(6719),
    [anon_sym_alignas] = ACTIONS(6723),
    [anon_sym__Alignas] = ACTIONS(6723),
    [sym_primitive_type] = ACTIONS(6725),
    [anon_sym_QMARK] = ACTIONS(5729),
    [anon_sym_LT_EQ_GT] = ACTIONS(5729),
    [anon_sym_or] = ACTIONS(5731),
    [anon_sym_and] = ACTIONS(5731),
    [anon_sym_bitor] = ACTIONS(5731),
    [anon_sym_xor] = ACTIONS(5731),
    [anon_sym_bitand] = ACTIONS(5731),
    [anon_sym_not_eq] = ACTIONS(5731),
    [anon_sym_DASH_DASH] = ACTIONS(5729),
    [anon_sym_PLUS_PLUS] = ACTIONS(5729),
    [anon_sym_DOT] = ACTIONS(5731),
    [anon_sym_DOT_STAR] = ACTIONS(5729),
    [anon_sym_DASH_GT] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5731),
    [anon_sym_decltype] = ACTIONS(5731),
    [anon_sym_GT2] = ACTIONS(5729),
  },
  [2673] = {
    [sym_identifier] = ACTIONS(2167),
    [anon_sym___extension__] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2167),
    [anon_sym_out] = ACTIONS(2167),
    [anon_sym_inout] = ACTIONS(2167),
    [anon_sym_virtual] = ACTIONS(2167),
    [anon_sym_extern] = ACTIONS(2167),
    [anon_sym___attribute__] = ACTIONS(2167),
    [anon_sym___attribute] = ACTIONS(2167),
    [anon_sym_COLON_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2169),
    [anon_sym___declspec] = ACTIONS(2167),
    [anon_sym_signed] = ACTIONS(2167),
    [anon_sym_unsigned] = ACTIONS(2167),
    [anon_sym_long] = ACTIONS(2167),
    [anon_sym_short] = ACTIONS(2167),
    [anon_sym_static] = ACTIONS(2167),
    [anon_sym_register] = ACTIONS(2167),
    [anon_sym_inline] = ACTIONS(2167),
    [anon_sym___inline] = ACTIONS(2167),
    [anon_sym___inline__] = ACTIONS(2167),
    [anon_sym___forceinline] = ACTIONS(2167),
    [anon_sym_thread_local] = ACTIONS(2167),
    [anon_sym___thread] = ACTIONS(2167),
    [anon_sym_const] = ACTIONS(2167),
    [anon_sym_constexpr] = ACTIONS(2167),
    [anon_sym_volatile] = ACTIONS(2167),
    [anon_sym_restrict] = ACTIONS(2167),
    [anon_sym___restrict__] = ACTIONS(2167),
    [anon_sym__Atomic] = ACTIONS(2167),
    [anon_sym__Noreturn] = ACTIONS(2167),
    [anon_sym_noreturn] = ACTIONS(2167),
    [anon_sym__Nonnull] = ACTIONS(2167),
    [anon_sym_mutable] = ACTIONS(2167),
    [anon_sym_constinit] = ACTIONS(2167),
    [anon_sym_consteval] = ACTIONS(2167),
    [anon_sym_alignas] = ACTIONS(2167),
    [anon_sym__Alignas] = ACTIONS(2167),
    [sym_primitive_type] = ACTIONS(2167),
    [anon_sym_enum] = ACTIONS(2167),
    [anon_sym_class] = ACTIONS(2167),
    [anon_sym_struct] = ACTIONS(2167),
    [anon_sym_union] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2167),
    [anon_sym_decltype] = ACTIONS(2167),
    [anon_sym_typename] = ACTIONS(2167),
    [anon_sym_template] = ACTIONS(2167),
    [anon_sym_precise] = ACTIONS(2167),
    [anon_sym_shared] = ACTIONS(2167),
    [anon_sym_groupshared] = ACTIONS(2167),
    [anon_sym_uniform] = ACTIONS(2167),
    [anon_sym_row_major] = ACTIONS(2167),
    [anon_sym_column_major] = ACTIONS(2167),
    [anon_sym_globallycoherent] = ACTIONS(2167),
    [anon_sym_centroid] = ACTIONS(2167),
    [anon_sym_noperspective] = ACTIONS(2167),
    [anon_sym_nointerpolation] = ACTIONS(2167),
    [anon_sym_sample] = ACTIONS(2167),
    [anon_sym_linear] = ACTIONS(2167),
    [anon_sym_snorm] = ACTIONS(2167),
    [anon_sym_unorm] = ACTIONS(2167),
    [anon_sym_point] = ACTIONS(2167),
    [anon_sym_line] = ACTIONS(2167),
    [anon_sym_triangleadj] = ACTIONS(2167),
    [anon_sym_lineadj] = ACTIONS(2167),
    [anon_sym_triangle] = ACTIONS(2167),
  },
  [2674] = {
    [sym_identifier] = ACTIONS(2656),
    [anon_sym___extension__] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2656),
    [anon_sym_out] = ACTIONS(2656),
    [anon_sym_inout] = ACTIONS(2656),
    [anon_sym_virtual] = ACTIONS(2656),
    [anon_sym_extern] = ACTIONS(2656),
    [anon_sym___attribute__] = ACTIONS(2656),
    [anon_sym___attribute] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2658),
    [anon_sym___declspec] = ACTIONS(2656),
    [anon_sym_signed] = ACTIONS(2656),
    [anon_sym_unsigned] = ACTIONS(2656),
    [anon_sym_long] = ACTIONS(2656),
    [anon_sym_short] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2656),
    [anon_sym_register] = ACTIONS(2656),
    [anon_sym_inline] = ACTIONS(2656),
    [anon_sym___inline] = ACTIONS(2656),
    [anon_sym___inline__] = ACTIONS(2656),
    [anon_sym___forceinline] = ACTIONS(2656),
    [anon_sym_thread_local] = ACTIONS(2656),
    [anon_sym___thread] = ACTIONS(2656),
    [anon_sym_const] = ACTIONS(2656),
    [anon_sym_constexpr] = ACTIONS(2656),
    [anon_sym_volatile] = ACTIONS(2656),
    [anon_sym_restrict] = ACTIONS(2656),
    [anon_sym___restrict__] = ACTIONS(2656),
    [anon_sym__Atomic] = ACTIONS(2656),
    [anon_sym__Noreturn] = ACTIONS(2656),
    [anon_sym_noreturn] = ACTIONS(2656),
    [anon_sym__Nonnull] = ACTIONS(2656),
    [anon_sym_mutable] = ACTIONS(2656),
    [anon_sym_constinit] = ACTIONS(2656),
    [anon_sym_consteval] = ACTIONS(2656),
    [anon_sym_alignas] = ACTIONS(2656),
    [anon_sym__Alignas] = ACTIONS(2656),
    [sym_primitive_type] = ACTIONS(2656),
    [anon_sym_enum] = ACTIONS(2656),
    [anon_sym_class] = ACTIONS(2656),
    [anon_sym_struct] = ACTIONS(2656),
    [anon_sym_union] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2656),
    [anon_sym_decltype] = ACTIONS(2656),
    [anon_sym_typename] = ACTIONS(2656),
    [anon_sym_template] = ACTIONS(2656),
    [anon_sym_precise] = ACTIONS(2656),
    [anon_sym_shared] = ACTIONS(2656),
    [anon_sym_groupshared] = ACTIONS(2656),
    [anon_sym_uniform] = ACTIONS(2656),
    [anon_sym_row_major] = ACTIONS(2656),
    [anon_sym_column_major] = ACTIONS(2656),
    [anon_sym_globallycoherent] = ACTIONS(2656),
    [anon_sym_centroid] = ACTIONS(2656),
    [anon_sym_noperspective] = ACTIONS(2656),
    [anon_sym_nointerpolation] = ACTIONS(2656),
    [anon_sym_sample] = ACTIONS(2656),
    [anon_sym_linear] = ACTIONS(2656),
    [anon_sym_snorm] = ACTIONS(2656),
    [anon_sym_unorm] = ACTIONS(2656),
    [anon_sym_point] = ACTIONS(2656),
    [anon_sym_line] = ACTIONS(2656),
    [anon_sym_triangleadj] = ACTIONS(2656),
    [anon_sym_lineadj] = ACTIONS(2656),
    [anon_sym_triangle] = ACTIONS(2656),
  },
  [2675] = {
    [sym_identifier] = ACTIONS(2834),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_in] = ACTIONS(2834),
    [anon_sym_out] = ACTIONS(2834),
    [anon_sym_inout] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2839),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_precise] = ACTIONS(2834),
    [anon_sym_shared] = ACTIONS(2834),
    [anon_sym_groupshared] = ACTIONS(2834),
    [anon_sym_uniform] = ACTIONS(2834),
    [anon_sym_row_major] = ACTIONS(2834),
    [anon_sym_column_major] = ACTIONS(2834),
    [anon_sym_globallycoherent] = ACTIONS(2834),
    [anon_sym_centroid] = ACTIONS(2834),
    [anon_sym_noperspective] = ACTIONS(2834),
    [anon_sym_nointerpolation] = ACTIONS(2834),
    [anon_sym_sample] = ACTIONS(2834),
    [anon_sym_linear] = ACTIONS(2834),
    [anon_sym_snorm] = ACTIONS(2834),
    [anon_sym_unorm] = ACTIONS(2834),
    [anon_sym_point] = ACTIONS(2834),
    [anon_sym_line] = ACTIONS(2834),
    [anon_sym_triangleadj] = ACTIONS(2834),
    [anon_sym_lineadj] = ACTIONS(2834),
    [anon_sym_triangle] = ACTIONS(2834),
  },
  [2676] = {
    [sym_attribute_specifier] = STATE(2364),
    [sym_enumerator_list] = STATE(2408),
    [sym__enum_base_clause] = STATE(2372),
    [sym_identifier] = ACTIONS(6303),
    [anon_sym_LPAREN2] = ACTIONS(6305),
    [anon_sym_STAR] = ACTIONS(6305),
    [anon_sym_AMP_AMP] = ACTIONS(6305),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_COLON] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6305),
    [anon_sym___extension__] = ACTIONS(6303),
    [anon_sym_in] = ACTIONS(6303),
    [anon_sym_out] = ACTIONS(6303),
    [anon_sym_inout] = ACTIONS(6303),
    [anon_sym_virtual] = ACTIONS(6303),
    [anon_sym_extern] = ACTIONS(6303),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6305),
    [anon_sym___declspec] = ACTIONS(6303),
    [anon_sym___based] = ACTIONS(6303),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_static] = ACTIONS(6303),
    [anon_sym_register] = ACTIONS(6303),
    [anon_sym_inline] = ACTIONS(6303),
    [anon_sym___inline] = ACTIONS(6303),
    [anon_sym___inline__] = ACTIONS(6303),
    [anon_sym___forceinline] = ACTIONS(6303),
    [anon_sym_thread_local] = ACTIONS(6303),
    [anon_sym___thread] = ACTIONS(6303),
    [anon_sym_const] = ACTIONS(6303),
    [anon_sym_constexpr] = ACTIONS(6303),
    [anon_sym_volatile] = ACTIONS(6303),
    [anon_sym_restrict] = ACTIONS(6303),
    [anon_sym___restrict__] = ACTIONS(6303),
    [anon_sym__Atomic] = ACTIONS(6303),
    [anon_sym__Noreturn] = ACTIONS(6303),
    [anon_sym_noreturn] = ACTIONS(6303),
    [anon_sym__Nonnull] = ACTIONS(6303),
    [anon_sym_mutable] = ACTIONS(6303),
    [anon_sym_constinit] = ACTIONS(6303),
    [anon_sym_consteval] = ACTIONS(6303),
    [anon_sym_alignas] = ACTIONS(6303),
    [anon_sym__Alignas] = ACTIONS(6303),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6303),
    [anon_sym_decltype] = ACTIONS(6303),
    [anon_sym_operator] = ACTIONS(6303),
    [anon_sym_precise] = ACTIONS(6303),
    [anon_sym_shared] = ACTIONS(6303),
    [anon_sym_groupshared] = ACTIONS(6303),
    [anon_sym_uniform] = ACTIONS(6303),
    [anon_sym_row_major] = ACTIONS(6303),
    [anon_sym_column_major] = ACTIONS(6303),
    [anon_sym_globallycoherent] = ACTIONS(6303),
    [anon_sym_centroid] = ACTIONS(6303),
    [anon_sym_noperspective] = ACTIONS(6303),
    [anon_sym_nointerpolation] = ACTIONS(6303),
    [anon_sym_sample] = ACTIONS(6303),
    [anon_sym_linear] = ACTIONS(6303),
    [anon_sym_snorm] = ACTIONS(6303),
    [anon_sym_unorm] = ACTIONS(6303),
    [anon_sym_point] = ACTIONS(6303),
    [anon_sym_line] = ACTIONS(6303),
    [anon_sym_triangleadj] = ACTIONS(6303),
    [anon_sym_lineadj] = ACTIONS(6303),
    [anon_sym_triangle] = ACTIONS(6303),
  },
  [2677] = {
    [sym_attribute_specifier] = STATE(2746),
    [sym_identifier] = ACTIONS(6231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6233),
    [anon_sym_COMMA] = ACTIONS(6233),
    [anon_sym_RPAREN] = ACTIONS(6233),
    [aux_sym_preproc_if_token2] = ACTIONS(6233),
    [aux_sym_preproc_else_token1] = ACTIONS(6233),
    [aux_sym_preproc_elif_token1] = ACTIONS(6231),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6233),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6233),
    [anon_sym_LPAREN2] = ACTIONS(6233),
    [anon_sym_DASH] = ACTIONS(6231),
    [anon_sym_PLUS] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(6231),
    [anon_sym_SLASH] = ACTIONS(6231),
    [anon_sym_PERCENT] = ACTIONS(6231),
    [anon_sym_PIPE_PIPE] = ACTIONS(6233),
    [anon_sym_AMP_AMP] = ACTIONS(6233),
    [anon_sym_PIPE] = ACTIONS(6231),
    [anon_sym_CARET] = ACTIONS(6231),
    [anon_sym_AMP] = ACTIONS(6231),
    [anon_sym_EQ_EQ] = ACTIONS(6233),
    [anon_sym_BANG_EQ] = ACTIONS(6233),
    [anon_sym_GT] = ACTIONS(6231),
    [anon_sym_GT_EQ] = ACTIONS(6233),
    [anon_sym_LT_EQ] = ACTIONS(6231),
    [anon_sym_LT] = ACTIONS(6231),
    [anon_sym_LT_LT] = ACTIONS(6231),
    [anon_sym_GT_GT] = ACTIONS(6231),
    [anon_sym_COLON] = ACTIONS(6233),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6233),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [anon_sym_LBRACK] = ACTIONS(6233),
    [anon_sym_RBRACK] = ACTIONS(6233),
    [anon_sym_EQ] = ACTIONS(6231),
    [anon_sym_QMARK] = ACTIONS(6233),
    [anon_sym_STAR_EQ] = ACTIONS(6233),
    [anon_sym_SLASH_EQ] = ACTIONS(6233),
    [anon_sym_PERCENT_EQ] = ACTIONS(6233),
    [anon_sym_PLUS_EQ] = ACTIONS(6233),
    [anon_sym_DASH_EQ] = ACTIONS(6233),
    [anon_sym_LT_LT_EQ] = ACTIONS(6233),
    [anon_sym_GT_GT_EQ] = ACTIONS(6233),
    [anon_sym_AMP_EQ] = ACTIONS(6233),
    [anon_sym_CARET_EQ] = ACTIONS(6233),
    [anon_sym_PIPE_EQ] = ACTIONS(6233),
    [anon_sym_and_eq] = ACTIONS(6231),
    [anon_sym_or_eq] = ACTIONS(6231),
    [anon_sym_xor_eq] = ACTIONS(6231),
    [anon_sym_LT_EQ_GT] = ACTIONS(6233),
    [anon_sym_or] = ACTIONS(6231),
    [anon_sym_and] = ACTIONS(6231),
    [anon_sym_bitor] = ACTIONS(6231),
    [anon_sym_xor] = ACTIONS(6231),
    [anon_sym_bitand] = ACTIONS(6231),
    [anon_sym_not_eq] = ACTIONS(6231),
    [anon_sym_DASH_DASH] = ACTIONS(6233),
    [anon_sym_PLUS_PLUS] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(6231),
    [anon_sym_DOT_STAR] = ACTIONS(6233),
    [anon_sym_DASH_GT] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6231),
    [anon_sym_decltype] = ACTIONS(6231),
  },
  [2678] = {
    [sym_string_literal] = STATE(2651),
    [sym_raw_string_literal] = STATE(2651),
    [aux_sym_concatenated_string_repeat1] = STATE(2651),
    [sym_identifier] = ACTIONS(6729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6417),
    [anon_sym_COMMA] = ACTIONS(6417),
    [anon_sym_RPAREN] = ACTIONS(6417),
    [anon_sym_LPAREN2] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_SLASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_PIPE_PIPE] = ACTIONS(6417),
    [anon_sym_AMP_AMP] = ACTIONS(6417),
    [anon_sym_PIPE] = ACTIONS(6419),
    [anon_sym_CARET] = ACTIONS(6419),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_EQ_EQ] = ACTIONS(6417),
    [anon_sym_BANG_EQ] = ACTIONS(6417),
    [anon_sym_GT] = ACTIONS(6419),
    [anon_sym_GT_EQ] = ACTIONS(6417),
    [anon_sym_LT_EQ] = ACTIONS(6419),
    [anon_sym_LT] = ACTIONS(6419),
    [anon_sym_LT_LT] = ACTIONS(6419),
    [anon_sym_GT_GT] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_STAR_EQ] = ACTIONS(6417),
    [anon_sym_SLASH_EQ] = ACTIONS(6417),
    [anon_sym_PERCENT_EQ] = ACTIONS(6417),
    [anon_sym_PLUS_EQ] = ACTIONS(6417),
    [anon_sym_DASH_EQ] = ACTIONS(6417),
    [anon_sym_LT_LT_EQ] = ACTIONS(6417),
    [anon_sym_GT_GT_EQ] = ACTIONS(6417),
    [anon_sym_AMP_EQ] = ACTIONS(6417),
    [anon_sym_CARET_EQ] = ACTIONS(6417),
    [anon_sym_PIPE_EQ] = ACTIONS(6417),
    [anon_sym_and_eq] = ACTIONS(6419),
    [anon_sym_or_eq] = ACTIONS(6419),
    [anon_sym_xor_eq] = ACTIONS(6419),
    [anon_sym_LT_EQ_GT] = ACTIONS(6417),
    [anon_sym_or] = ACTIONS(6419),
    [anon_sym_and] = ACTIONS(6419),
    [anon_sym_bitor] = ACTIONS(6419),
    [anon_sym_xor] = ACTIONS(6419),
    [anon_sym_bitand] = ACTIONS(6419),
    [anon_sym_not_eq] = ACTIONS(6419),
    [anon_sym_DASH_DASH] = ACTIONS(6417),
    [anon_sym_PLUS_PLUS] = ACTIONS(6417),
    [anon_sym_DOT] = ACTIONS(6419),
    [anon_sym_DOT_STAR] = ACTIONS(6417),
    [anon_sym_DASH_GT] = ACTIONS(6419),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6417),
    [sym_literal_suffix] = ACTIONS(6419),
  },
  [2679] = {
    [sym_attribute_specifier] = STATE(2356),
    [sym_enumerator_list] = STATE(2412),
    [sym__enum_base_clause] = STATE(2367),
    [sym_identifier] = ACTIONS(6293),
    [anon_sym_LPAREN2] = ACTIONS(6295),
    [anon_sym_STAR] = ACTIONS(6295),
    [anon_sym_AMP_AMP] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6727),
    [anon_sym_SEMI] = ACTIONS(6295),
    [anon_sym___extension__] = ACTIONS(6293),
    [anon_sym_in] = ACTIONS(6293),
    [anon_sym_out] = ACTIONS(6293),
    [anon_sym_inout] = ACTIONS(6293),
    [anon_sym_virtual] = ACTIONS(6293),
    [anon_sym_extern] = ACTIONS(6293),
    [anon_sym___attribute__] = ACTIONS(5521),
    [anon_sym___attribute] = ACTIONS(5521),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6295),
    [anon_sym___declspec] = ACTIONS(6293),
    [anon_sym___based] = ACTIONS(6293),
    [anon_sym_LBRACE] = ACTIONS(6073),
    [anon_sym_static] = ACTIONS(6293),
    [anon_sym_register] = ACTIONS(6293),
    [anon_sym_inline] = ACTIONS(6293),
    [anon_sym___inline] = ACTIONS(6293),
    [anon_sym___inline__] = ACTIONS(6293),
    [anon_sym___forceinline] = ACTIONS(6293),
    [anon_sym_thread_local] = ACTIONS(6293),
    [anon_sym___thread] = ACTIONS(6293),
    [anon_sym_const] = ACTIONS(6293),
    [anon_sym_constexpr] = ACTIONS(6293),
    [anon_sym_volatile] = ACTIONS(6293),
    [anon_sym_restrict] = ACTIONS(6293),
    [anon_sym___restrict__] = ACTIONS(6293),
    [anon_sym__Atomic] = ACTIONS(6293),
    [anon_sym__Noreturn] = ACTIONS(6293),
    [anon_sym_noreturn] = ACTIONS(6293),
    [anon_sym__Nonnull] = ACTIONS(6293),
    [anon_sym_mutable] = ACTIONS(6293),
    [anon_sym_constinit] = ACTIONS(6293),
    [anon_sym_consteval] = ACTIONS(6293),
    [anon_sym_alignas] = ACTIONS(6293),
    [anon_sym__Alignas] = ACTIONS(6293),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6293),
    [anon_sym_decltype] = ACTIONS(6293),
    [anon_sym_operator] = ACTIONS(6293),
    [anon_sym_precise] = ACTIONS(6293),
    [anon_sym_shared] = ACTIONS(6293),
    [anon_sym_groupshared] = ACTIONS(6293),
    [anon_sym_uniform] = ACTIONS(6293),
    [anon_sym_row_major] = ACTIONS(6293),
    [anon_sym_column_major] = ACTIONS(6293),
    [anon_sym_globallycoherent] = ACTIONS(6293),
    [anon_sym_centroid] = ACTIONS(6293),
    [anon_sym_noperspective] = ACTIONS(6293),
    [anon_sym_nointerpolation] = ACTIONS(6293),
    [anon_sym_sample] = ACTIONS(6293),
    [anon_sym_linear] = ACTIONS(6293),
    [anon_sym_snorm] = ACTIONS(6293),
    [anon_sym_unorm] = ACTIONS(6293),
    [anon_sym_point] = ACTIONS(6293),
    [anon_sym_line] = ACTIONS(6293),
    [anon_sym_triangleadj] = ACTIONS(6293),
    [anon_sym_lineadj] = ACTIONS(6293),
    [anon_sym_triangle] = ACTIONS(6293),
  },
  [2680] = {
    [sym_attribute_specifier] = STATE(2739),
    [sym_identifier] = ACTIONS(6227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6229),
    [anon_sym_COMMA] = ACTIONS(6229),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [aux_sym_preproc_if_token2] = ACTIONS(6229),
    [aux_sym_preproc_else_token1] = ACTIONS(6229),
    [aux_sym_preproc_elif_token1] = ACTIONS(6227),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6229),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6229),
    [anon_sym_LPAREN2] = ACTIONS(6229),
    [anon_sym_DASH] = ACTIONS(6227),
    [anon_sym_PLUS] = ACTIONS(6227),
    [anon_sym_STAR] = ACTIONS(6227),
    [anon_sym_SLASH] = ACTIONS(6227),
    [anon_sym_PERCENT] = ACTIONS(6227),
    [anon_sym_PIPE_PIPE] = ACTIONS(6229),
    [anon_sym_AMP_AMP] = ACTIONS(6229),
    [anon_sym_PIPE] = ACTIONS(6227),
    [anon_sym_CARET] = ACTIONS(6227),
    [anon_sym_AMP] = ACTIONS(6227),
    [anon_sym_EQ_EQ] = ACTIONS(6229),
    [anon_sym_BANG_EQ] = ACTIONS(6229),
    [anon_sym_GT] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(6229),
    [anon_sym_LT_EQ] = ACTIONS(6227),
    [anon_sym_LT] = ACTIONS(6227),
    [anon_sym_LT_LT] = ACTIONS(6227),
    [anon_sym_GT_GT] = ACTIONS(6227),
    [anon_sym_COLON] = ACTIONS(6229),
    [anon_sym_SEMI] = ACTIONS(6229),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6229),
    [anon_sym_RBRACE] = ACTIONS(6229),
    [anon_sym_LBRACK] = ACTIONS(6229),
    [anon_sym_RBRACK] = ACTIONS(6229),
    [anon_sym_EQ] = ACTIONS(6227),
    [anon_sym_QMARK] = ACTIONS(6229),
    [anon_sym_STAR_EQ] = ACTIONS(6229),
    [anon_sym_SLASH_EQ] = ACTIONS(6229),
    [anon_sym_PERCENT_EQ] = ACTIONS(6229),
    [anon_sym_PLUS_EQ] = ACTIONS(6229),
    [anon_sym_DASH_EQ] = ACTIONS(6229),
    [anon_sym_LT_LT_EQ] = ACTIONS(6229),
    [anon_sym_GT_GT_EQ] = ACTIONS(6229),
    [anon_sym_AMP_EQ] = ACTIONS(6229),
    [anon_sym_CARET_EQ] = ACTIONS(6229),
    [anon_sym_PIPE_EQ] = ACTIONS(6229),
    [anon_sym_and_eq] = ACTIONS(6227),
    [anon_sym_or_eq] = ACTIONS(6227),
    [anon_sym_xor_eq] = ACTIONS(6227),
    [anon_sym_LT_EQ_GT] = ACTIONS(6229),
    [anon_sym_or] = ACTIONS(6227),
    [anon_sym_and] = ACTIONS(6227),
    [anon_sym_bitor] = ACTIONS(6227),
    [anon_sym_xor] = ACTIONS(6227),
    [anon_sym_bitand] = ACTIONS(6227),
    [anon_sym_not_eq] = ACTIONS(6227),
    [anon_sym_DASH_DASH] = ACTIONS(6229),
    [anon_sym_PLUS_PLUS] = ACTIONS(6229),
    [anon_sym_DOT] = ACTIONS(6227),
    [anon_sym_DOT_STAR] = ACTIONS(6229),
    [anon_sym_DASH_GT] = ACTIONS(6229),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6227),
    [anon_sym_decltype] = ACTIONS(6227),
  },
  [2681] = {
    [sym_attribute_specifier] = STATE(2700),
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6185),
    [anon_sym_COMMA] = ACTIONS(6185),
    [anon_sym_RPAREN] = ACTIONS(6185),
    [aux_sym_preproc_if_token2] = ACTIONS(6185),
    [aux_sym_preproc_else_token1] = ACTIONS(6185),
    [aux_sym_preproc_elif_token1] = ACTIONS(6183),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6185),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6185),
    [anon_sym_LPAREN2] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6183),
    [anon_sym_PLUS] = ACTIONS(6183),
    [anon_sym_STAR] = ACTIONS(6183),
    [anon_sym_SLASH] = ACTIONS(6183),
    [anon_sym_PERCENT] = ACTIONS(6183),
    [anon_sym_PIPE_PIPE] = ACTIONS(6185),
    [anon_sym_AMP_AMP] = ACTIONS(6185),
    [anon_sym_PIPE] = ACTIONS(6183),
    [anon_sym_CARET] = ACTIONS(6183),
    [anon_sym_AMP] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6185),
    [anon_sym_GT] = ACTIONS(6183),
    [anon_sym_GT_EQ] = ACTIONS(6185),
    [anon_sym_LT_EQ] = ACTIONS(6183),
    [anon_sym_LT] = ACTIONS(6183),
    [anon_sym_LT_LT] = ACTIONS(6183),
    [anon_sym_GT_GT] = ACTIONS(6183),
    [anon_sym_COLON] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_RBRACE] = ACTIONS(6185),
    [anon_sym_LBRACK] = ACTIONS(6185),
    [anon_sym_RBRACK] = ACTIONS(6185),
    [anon_sym_EQ] = ACTIONS(6183),
    [anon_sym_QMARK] = ACTIONS(6185),
    [anon_sym_STAR_EQ] = ACTIONS(6185),
    [anon_sym_SLASH_EQ] = ACTIONS(6185),
    [anon_sym_PERCENT_EQ] = ACTIONS(6185),
    [anon_sym_PLUS_EQ] = ACTIONS(6185),
    [anon_sym_DASH_EQ] = ACTIONS(6185),
    [anon_sym_LT_LT_EQ] = ACTIONS(6185),
    [anon_sym_GT_GT_EQ] = ACTIONS(6185),
    [anon_sym_AMP_EQ] = ACTIONS(6185),
    [anon_sym_CARET_EQ] = ACTIONS(6185),
    [anon_sym_PIPE_EQ] = ACTIONS(6185),
    [anon_sym_and_eq] = ACTIONS(6183),
    [anon_sym_or_eq] = ACTIONS(6183),
    [anon_sym_xor_eq] = ACTIONS(6183),
    [anon_sym_LT_EQ_GT] = ACTIONS(6185),
    [anon_sym_or] = ACTIONS(6183),
    [anon_sym_and] = ACTIONS(6183),
    [anon_sym_bitor] = ACTIONS(6183),
    [anon_sym_xor] = ACTIONS(6183),
    [anon_sym_bitand] = ACTIONS(6183),
    [anon_sym_not_eq] = ACTIONS(6183),
    [anon_sym_DASH_DASH] = ACTIONS(6185),
    [anon_sym_PLUS_PLUS] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6183),
    [anon_sym_DOT_STAR] = ACTIONS(6185),
    [anon_sym_DASH_GT] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6183),
    [anon_sym_decltype] = ACTIONS(6183),
  },
  [2682] = {
    [sym_attribute_specifier] = STATE(2785),
    [sym_identifier] = ACTIONS(6195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6197),
    [anon_sym_COMMA] = ACTIONS(6197),
    [anon_sym_RPAREN] = ACTIONS(6197),
    [aux_sym_preproc_if_token2] = ACTIONS(6197),
    [aux_sym_preproc_else_token1] = ACTIONS(6197),
    [aux_sym_preproc_elif_token1] = ACTIONS(6195),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6197),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6197),
    [anon_sym_LPAREN2] = ACTIONS(6197),
    [anon_sym_DASH] = ACTIONS(6195),
    [anon_sym_PLUS] = ACTIONS(6195),
    [anon_sym_STAR] = ACTIONS(6195),
    [anon_sym_SLASH] = ACTIONS(6195),
    [anon_sym_PERCENT] = ACTIONS(6195),
    [anon_sym_PIPE_PIPE] = ACTIONS(6197),
    [anon_sym_AMP_AMP] = ACTIONS(6197),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_CARET] = ACTIONS(6195),
    [anon_sym_AMP] = ACTIONS(6195),
    [anon_sym_EQ_EQ] = ACTIONS(6197),
    [anon_sym_BANG_EQ] = ACTIONS(6197),
    [anon_sym_GT] = ACTIONS(6195),
    [anon_sym_GT_EQ] = ACTIONS(6197),
    [anon_sym_LT_EQ] = ACTIONS(6195),
    [anon_sym_LT] = ACTIONS(6195),
    [anon_sym_LT_LT] = ACTIONS(6195),
    [anon_sym_GT_GT] = ACTIONS(6195),
    [anon_sym_COLON] = ACTIONS(6197),
    [anon_sym_SEMI] = ACTIONS(6197),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6197),
    [anon_sym_RBRACE] = ACTIONS(6197),
    [anon_sym_LBRACK] = ACTIONS(6197),
    [anon_sym_RBRACK] = ACTIONS(6197),
    [anon_sym_EQ] = ACTIONS(6195),
    [anon_sym_QMARK] = ACTIONS(6197),
    [anon_sym_STAR_EQ] = ACTIONS(6197),
    [anon_sym_SLASH_EQ] = ACTIONS(6197),
    [anon_sym_PERCENT_EQ] = ACTIONS(6197),
    [anon_sym_PLUS_EQ] = ACTIONS(6197),
    [anon_sym_DASH_EQ] = ACTIONS(6197),
    [anon_sym_LT_LT_EQ] = ACTIONS(6197),
    [anon_sym_GT_GT_EQ] = ACTIONS(6197),
    [anon_sym_AMP_EQ] = ACTIONS(6197),
    [anon_sym_CARET_EQ] = ACTIONS(6197),
    [anon_sym_PIPE_EQ] = ACTIONS(6197),
    [anon_sym_and_eq] = ACTIONS(6195),
    [anon_sym_or_eq] = ACTIONS(6195),
    [anon_sym_xor_eq] = ACTIONS(6195),
    [anon_sym_LT_EQ_GT] = ACTIONS(6197),
    [anon_sym_or] = ACTIONS(6195),
    [anon_sym_and] = ACTIONS(6195),
    [anon_sym_bitor] = ACTIONS(6195),
    [anon_sym_xor] = ACTIONS(6195),
    [anon_sym_bitand] = ACTIONS(6195),
    [anon_sym_not_eq] = ACTIONS(6195),
    [anon_sym_DASH_DASH] = ACTIONS(6197),
    [anon_sym_PLUS_PLUS] = ACTIONS(6197),
    [anon_sym_DOT] = ACTIONS(6195),
    [anon_sym_DOT_STAR] = ACTIONS(6197),
    [anon_sym_DASH_GT] = ACTIONS(6197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6195),
    [anon_sym_decltype] = ACTIONS(6195),
  },
  [2683] = {
    [sym_identifier] = ACTIONS(2246),
    [anon_sym___extension__] = ACTIONS(2246),
    [anon_sym_in] = ACTIONS(2246),
    [anon_sym_out] = ACTIONS(2246),
    [anon_sym_inout] = ACTIONS(2246),
    [anon_sym_virtual] = ACTIONS(2246),
    [anon_sym_extern] = ACTIONS(2246),
    [anon_sym___attribute__] = ACTIONS(2246),
    [anon_sym___attribute] = ACTIONS(2246),
    [anon_sym_COLON_COLON] = ACTIONS(2248),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2248),
    [anon_sym___declspec] = ACTIONS(2246),
    [anon_sym_signed] = ACTIONS(2246),
    [anon_sym_unsigned] = ACTIONS(2246),
    [anon_sym_long] = ACTIONS(2246),
    [anon_sym_short] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_register] = ACTIONS(2246),
    [anon_sym_inline] = ACTIONS(2246),
    [anon_sym___inline] = ACTIONS(2246),
    [anon_sym___inline__] = ACTIONS(2246),
    [anon_sym___forceinline] = ACTIONS(2246),
    [anon_sym_thread_local] = ACTIONS(2246),
    [anon_sym___thread] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_constexpr] = ACTIONS(2246),
    [anon_sym_volatile] = ACTIONS(2246),
    [anon_sym_restrict] = ACTIONS(2246),
    [anon_sym___restrict__] = ACTIONS(2246),
    [anon_sym__Atomic] = ACTIONS(2246),
    [anon_sym__Noreturn] = ACTIONS(2246),
    [anon_sym_noreturn] = ACTIONS(2246),
    [anon_sym__Nonnull] = ACTIONS(2246),
    [anon_sym_mutable] = ACTIONS(2246),
    [anon_sym_constinit] = ACTIONS(2246),
    [anon_sym_consteval] = ACTIONS(2246),
    [anon_sym_alignas] = ACTIONS(2246),
    [anon_sym__Alignas] = ACTIONS(2246),
    [sym_primitive_type] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_class] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2246),
    [anon_sym_decltype] = ACTIONS(2246),
    [anon_sym_typename] = ACTIONS(2246),
    [anon_sym_template] = ACTIONS(2246),
    [anon_sym_precise] = ACTIONS(2246),
    [anon_sym_shared] = ACTIONS(2246),
    [anon_sym_groupshared] = ACTIONS(2246),
    [anon_sym_uniform] = ACTIONS(2246),
    [anon_sym_row_major] = ACTIONS(2246),
    [anon_sym_column_major] = ACTIONS(2246),
    [anon_sym_globallycoherent] = ACTIONS(2246),
    [anon_sym_centroid] = ACTIONS(2246),
    [anon_sym_noperspective] = ACTIONS(2246),
    [anon_sym_nointerpolation] = ACTIONS(2246),
    [anon_sym_sample] = ACTIONS(2246),
    [anon_sym_linear] = ACTIONS(2246),
    [anon_sym_snorm] = ACTIONS(2246),
    [anon_sym_unorm] = ACTIONS(2246),
    [anon_sym_point] = ACTIONS(2246),
    [anon_sym_line] = ACTIONS(2246),
    [anon_sym_triangleadj] = ACTIONS(2246),
    [anon_sym_lineadj] = ACTIONS(2246),
    [anon_sym_triangle] = ACTIONS(2246),
  },
  [2684] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym___extension__] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_out] = ACTIONS(2596),
    [anon_sym_inout] = ACTIONS(2596),
    [anon_sym_virtual] = ACTIONS(2596),
    [anon_sym_extern] = ACTIONS(2596),
    [anon_sym___attribute__] = ACTIONS(2596),
    [anon_sym___attribute] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2598),
    [anon_sym___declspec] = ACTIONS(2596),
    [anon_sym_signed] = ACTIONS(2596),
    [anon_sym_unsigned] = ACTIONS(2596),
    [anon_sym_long] = ACTIONS(2596),
    [anon_sym_short] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2596),
    [anon_sym_register] = ACTIONS(2596),
    [anon_sym_inline] = ACTIONS(2596),
    [anon_sym___inline] = ACTIONS(2596),
    [anon_sym___inline__] = ACTIONS(2596),
    [anon_sym___forceinline] = ACTIONS(2596),
    [anon_sym_thread_local] = ACTIONS(2596),
    [anon_sym___thread] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_constexpr] = ACTIONS(2596),
    [anon_sym_volatile] = ACTIONS(2596),
    [anon_sym_restrict] = ACTIONS(2596),
    [anon_sym___restrict__] = ACTIONS(2596),
    [anon_sym__Atomic] = ACTIONS(2596),
    [anon_sym__Noreturn] = ACTIONS(2596),
    [anon_sym_noreturn] = ACTIONS(2596),
    [anon_sym__Nonnull] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_constinit] = ACTIONS(2596),
    [anon_sym_consteval] = ACTIONS(2596),
    [anon_sym_alignas] = ACTIONS(2596),
    [anon_sym__Alignas] = ACTIONS(2596),
    [sym_primitive_type] = ACTIONS(2596),
    [anon_sym_enum] = ACTIONS(2596),
    [anon_sym_class] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_union] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2596),
    [anon_sym_decltype] = ACTIONS(2596),
    [anon_sym_typename] = ACTIONS(2596),
    [anon_sym_template] = ACTIONS(2596),
    [anon_sym_precise] = ACTIONS(2596),
    [anon_sym_shared] = ACTIONS(2596),
    [anon_sym_groupshared] = ACTIONS(2596),
    [anon_sym_uniform] = ACTIONS(2596),
    [anon_sym_row_major] = ACTIONS(2596),
    [anon_sym_column_major] = ACTIONS(2596),
    [anon_sym_globallycoherent] = ACTIONS(2596),
    [anon_sym_centroid] = ACTIONS(2596),
    [anon_sym_noperspective] = ACTIONS(2596),
    [anon_sym_nointerpolation] = ACTIONS(2596),
    [anon_sym_sample] = ACTIONS(2596),
    [anon_sym_linear] = ACTIONS(2596),
    [anon_sym_snorm] = ACTIONS(2596),
    [anon_sym_unorm] = ACTIONS(2596),
    [anon_sym_point] = ACTIONS(2596),
    [anon_sym_line] = ACTIONS(2596),
    [anon_sym_triangleadj] = ACTIONS(2596),
    [anon_sym_lineadj] = ACTIONS(2596),
    [anon_sym_triangle] = ACTIONS(2596),
  },
  [2685] = {
    [sym_attribute_declaration] = STATE(2751),
    [sym_parameter_list] = STATE(2776),
    [aux_sym_attributed_declarator_repeat1] = STATE(2751),
    [sym_identifier] = ACTIONS(6731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6733),
    [anon_sym_COMMA] = ACTIONS(6733),
    [anon_sym_RPAREN] = ACTIONS(6733),
    [aux_sym_preproc_if_token2] = ACTIONS(6733),
    [aux_sym_preproc_else_token1] = ACTIONS(6733),
    [aux_sym_preproc_elif_token1] = ACTIONS(6731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6733),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6733),
    [anon_sym_LPAREN2] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6731),
    [anon_sym_PLUS] = ACTIONS(6731),
    [anon_sym_STAR] = ACTIONS(6731),
    [anon_sym_SLASH] = ACTIONS(6731),
    [anon_sym_PERCENT] = ACTIONS(6731),
    [anon_sym_PIPE_PIPE] = ACTIONS(6733),
    [anon_sym_AMP_AMP] = ACTIONS(6733),
    [anon_sym_PIPE] = ACTIONS(6731),
    [anon_sym_CARET] = ACTIONS(6731),
    [anon_sym_AMP] = ACTIONS(6731),
    [anon_sym_EQ_EQ] = ACTIONS(6733),
    [anon_sym_BANG_EQ] = ACTIONS(6733),
    [anon_sym_GT] = ACTIONS(6731),
    [anon_sym_GT_EQ] = ACTIONS(6733),
    [anon_sym_LT_EQ] = ACTIONS(6731),
    [anon_sym_LT] = ACTIONS(6731),
    [anon_sym_LT_LT] = ACTIONS(6731),
    [anon_sym_GT_GT] = ACTIONS(6731),
    [anon_sym_COLON] = ACTIONS(6733),
    [anon_sym_SEMI] = ACTIONS(6733),
    [anon_sym___attribute__] = ACTIONS(6731),
    [anon_sym___attribute] = ACTIONS(6731),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6733),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6733),
    [anon_sym_EQ] = ACTIONS(6731),
    [anon_sym_QMARK] = ACTIONS(6733),
    [anon_sym_STAR_EQ] = ACTIONS(6733),
    [anon_sym_SLASH_EQ] = ACTIONS(6733),
    [anon_sym_PERCENT_EQ] = ACTIONS(6733),
    [anon_sym_PLUS_EQ] = ACTIONS(6733),
    [anon_sym_DASH_EQ] = ACTIONS(6733),
    [anon_sym_LT_LT_EQ] = ACTIONS(6733),
    [anon_sym_GT_GT_EQ] = ACTIONS(6733),
    [anon_sym_AMP_EQ] = ACTIONS(6733),
    [anon_sym_CARET_EQ] = ACTIONS(6733),
    [anon_sym_PIPE_EQ] = ACTIONS(6733),
    [anon_sym_and_eq] = ACTIONS(6731),
    [anon_sym_or_eq] = ACTIONS(6731),
    [anon_sym_xor_eq] = ACTIONS(6731),
    [anon_sym_LT_EQ_GT] = ACTIONS(6733),
    [anon_sym_or] = ACTIONS(6731),
    [anon_sym_and] = ACTIONS(6731),
    [anon_sym_bitor] = ACTIONS(6731),
    [anon_sym_xor] = ACTIONS(6731),
    [anon_sym_bitand] = ACTIONS(6731),
    [anon_sym_not_eq] = ACTIONS(6731),
    [anon_sym_DASH_DASH] = ACTIONS(6733),
    [anon_sym_PLUS_PLUS] = ACTIONS(6733),
    [anon_sym_DOT] = ACTIONS(6731),
    [anon_sym_DOT_STAR] = ACTIONS(6733),
    [anon_sym_DASH_GT] = ACTIONS(6733),
    [sym_comment] = ACTIONS(3),
  },
  [2686] = {
    [sym_decltype_auto] = STATE(2729),
    [sym_identifier] = ACTIONS(5985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5987),
    [anon_sym_COMMA] = ACTIONS(5987),
    [anon_sym_RPAREN] = ACTIONS(5987),
    [aux_sym_preproc_if_token2] = ACTIONS(5987),
    [aux_sym_preproc_else_token1] = ACTIONS(5987),
    [aux_sym_preproc_elif_token1] = ACTIONS(5985),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5987),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5987),
    [anon_sym_LPAREN2] = ACTIONS(5987),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5985),
    [anon_sym_PIPE_PIPE] = ACTIONS(5987),
    [anon_sym_AMP_AMP] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_AMP] = ACTIONS(5985),
    [anon_sym_EQ_EQ] = ACTIONS(5987),
    [anon_sym_BANG_EQ] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5985),
    [anon_sym_GT_EQ] = ACTIONS(5987),
    [anon_sym_LT_EQ] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5985),
    [anon_sym_LT_LT] = ACTIONS(5985),
    [anon_sym_GT_GT] = ACTIONS(5985),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SEMI] = ACTIONS(5987),
    [anon_sym___attribute__] = ACTIONS(5985),
    [anon_sym___attribute] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(5987),
    [anon_sym_RBRACE] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5987),
    [anon_sym_RBRACK] = ACTIONS(5987),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_QMARK] = ACTIONS(5987),
    [anon_sym_STAR_EQ] = ACTIONS(5987),
    [anon_sym_SLASH_EQ] = ACTIONS(5987),
    [anon_sym_PERCENT_EQ] = ACTIONS(5987),
    [anon_sym_PLUS_EQ] = ACTIONS(5987),
    [anon_sym_DASH_EQ] = ACTIONS(5987),
    [anon_sym_LT_LT_EQ] = ACTIONS(5987),
    [anon_sym_GT_GT_EQ] = ACTIONS(5987),
    [anon_sym_AMP_EQ] = ACTIONS(5987),
    [anon_sym_CARET_EQ] = ACTIONS(5987),
    [anon_sym_PIPE_EQ] = ACTIONS(5987),
    [anon_sym_and_eq] = ACTIONS(5985),
    [anon_sym_or_eq] = ACTIONS(5985),
    [anon_sym_xor_eq] = ACTIONS(5985),
    [anon_sym_LT_EQ_GT] = ACTIONS(5987),
    [anon_sym_or] = ACTIONS(5985),
    [anon_sym_and] = ACTIONS(5985),
    [anon_sym_bitor] = ACTIONS(5985),
    [anon_sym_xor] = ACTIONS(5985),
    [anon_sym_bitand] = ACTIONS(5985),
    [anon_sym_not_eq] = ACTIONS(5985),
    [anon_sym_DASH_DASH] = ACTIONS(5987),
    [anon_sym_PLUS_PLUS] = ACTIONS(5987),
    [anon_sym_DOT] = ACTIONS(5985),
    [anon_sym_DOT_STAR] = ACTIONS(5987),
    [anon_sym_DASH_GT] = ACTIONS(5987),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6553),
    [anon_sym_decltype] = ACTIONS(6555),
  },
  [2687] = {
    [sym_type_qualifier] = STATE(2707),
    [sym_alignas_qualifier] = STATE(2654),
    [aux_sym__type_definition_type_repeat1] = STATE(2707),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2736),
    [sym_identifier] = ACTIONS(6735),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5753),
    [anon_sym_COMMA] = ACTIONS(5753),
    [anon_sym_LPAREN2] = ACTIONS(5753),
    [anon_sym_DASH] = ACTIONS(5755),
    [anon_sym_PLUS] = ACTIONS(5755),
    [anon_sym_STAR] = ACTIONS(5753),
    [anon_sym_SLASH] = ACTIONS(5755),
    [anon_sym_PERCENT] = ACTIONS(5753),
    [anon_sym_PIPE_PIPE] = ACTIONS(5753),
    [anon_sym_AMP_AMP] = ACTIONS(5753),
    [anon_sym_PIPE] = ACTIONS(5755),
    [anon_sym_CARET] = ACTIONS(5753),
    [anon_sym_AMP] = ACTIONS(5755),
    [anon_sym_EQ_EQ] = ACTIONS(5753),
    [anon_sym_BANG_EQ] = ACTIONS(5753),
    [anon_sym_GT] = ACTIONS(5755),
    [anon_sym_GT_EQ] = ACTIONS(5755),
    [anon_sym_LT_EQ] = ACTIONS(5755),
    [anon_sym_LT] = ACTIONS(5755),
    [anon_sym_LT_LT] = ACTIONS(5753),
    [anon_sym_GT_GT] = ACTIONS(5755),
    [anon_sym___extension__] = ACTIONS(6719),
    [anon_sym___attribute__] = ACTIONS(5755),
    [anon_sym___attribute] = ACTIONS(5755),
    [anon_sym_LBRACE] = ACTIONS(5753),
    [anon_sym_signed] = ACTIONS(6737),
    [anon_sym_unsigned] = ACTIONS(6737),
    [anon_sym_long] = ACTIONS(6737),
    [anon_sym_short] = ACTIONS(6737),
    [anon_sym_LBRACK] = ACTIONS(5753),
    [anon_sym_const] = ACTIONS(6719),
    [anon_sym_constexpr] = ACTIONS(6719),
    [anon_sym_volatile] = ACTIONS(6719),
    [anon_sym_restrict] = ACTIONS(6719),
    [anon_sym___restrict__] = ACTIONS(6719),
    [anon_sym__Atomic] = ACTIONS(6719),
    [anon_sym__Noreturn] = ACTIONS(6719),
    [anon_sym_noreturn] = ACTIONS(6719),
    [anon_sym__Nonnull] = ACTIONS(6719),
    [anon_sym_mutable] = ACTIONS(6719),
    [anon_sym_constinit] = ACTIONS(6719),
    [anon_sym_consteval] = ACTIONS(6719),
    [anon_sym_alignas] = ACTIONS(6723),
    [anon_sym__Alignas] = ACTIONS(6723),
    [sym_primitive_type] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(5753),
    [anon_sym_LT_EQ_GT] = ACTIONS(5753),
    [anon_sym_or] = ACTIONS(5755),
    [anon_sym_and] = ACTIONS(5755),
    [anon_sym_bitor] = ACTIONS(5755),
    [anon_sym_xor] = ACTIONS(5755),
    [anon_sym_bitand] = ACTIONS(5755),
    [anon_sym_not_eq] = ACTIONS(5755),
    [anon_sym_DASH_DASH] = ACTIONS(5753),
    [anon_sym_PLUS_PLUS] = ACTIONS(5753),
    [anon_sym_DOT] = ACTIONS(5755),
    [anon_sym_DOT_STAR] = ACTIONS(5753),
    [anon_sym_DASH_GT] = ACTIONS(5753),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5755),
    [anon_sym_decltype] = ACTIONS(5755),
    [anon_sym_GT2] = ACTIONS(5753),
  },
  [2688] = {
    [sym_attribute_specifier] = STATE(2699),
    [sym_identifier] = ACTIONS(6187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6189),
    [anon_sym_COMMA] = ACTIONS(6189),
    [anon_sym_RPAREN] = ACTIONS(6189),
    [aux_sym_preproc_if_token2] = ACTIONS(6189),
    [aux_sym_preproc_else_token1] = ACTIONS(6189),
    [aux_sym_preproc_elif_token1] = ACTIONS(6187),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6189),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6189),
    [anon_sym_LPAREN2] = ACTIONS(6189),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_PLUS] = ACTIONS(6187),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_SLASH] = ACTIONS(6187),
    [anon_sym_PERCENT] = ACTIONS(6187),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_AMP_AMP] = ACTIONS(6189),
    [anon_sym_PIPE] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6187),
    [anon_sym_AMP] = ACTIONS(6187),
    [anon_sym_EQ_EQ] = ACTIONS(6189),
    [anon_sym_BANG_EQ] = ACTIONS(6189),
    [anon_sym_GT] = ACTIONS(6187),
    [anon_sym_GT_EQ] = ACTIONS(6189),
    [anon_sym_LT_EQ] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(6187),
    [anon_sym_LT_LT] = ACTIONS(6187),
    [anon_sym_GT_GT] = ACTIONS(6187),
    [anon_sym_COLON] = ACTIONS(6189),
    [anon_sym_SEMI] = ACTIONS(6189),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6189),
    [anon_sym_RBRACE] = ACTIONS(6189),
    [anon_sym_LBRACK] = ACTIONS(6189),
    [anon_sym_RBRACK] = ACTIONS(6189),
    [anon_sym_EQ] = ACTIONS(6187),
    [anon_sym_QMARK] = ACTIONS(6189),
    [anon_sym_STAR_EQ] = ACTIONS(6189),
    [anon_sym_SLASH_EQ] = ACTIONS(6189),
    [anon_sym_PERCENT_EQ] = ACTIONS(6189),
    [anon_sym_PLUS_EQ] = ACTIONS(6189),
    [anon_sym_DASH_EQ] = ACTIONS(6189),
    [anon_sym_LT_LT_EQ] = ACTIONS(6189),
    [anon_sym_GT_GT_EQ] = ACTIONS(6189),
    [anon_sym_AMP_EQ] = ACTIONS(6189),
    [anon_sym_CARET_EQ] = ACTIONS(6189),
    [anon_sym_PIPE_EQ] = ACTIONS(6189),
    [anon_sym_and_eq] = ACTIONS(6187),
    [anon_sym_or_eq] = ACTIONS(6187),
    [anon_sym_xor_eq] = ACTIONS(6187),
    [anon_sym_LT_EQ_GT] = ACTIONS(6189),
    [anon_sym_or] = ACTIONS(6187),
    [anon_sym_and] = ACTIONS(6187),
    [anon_sym_bitor] = ACTIONS(6187),
    [anon_sym_xor] = ACTIONS(6187),
    [anon_sym_bitand] = ACTIONS(6187),
    [anon_sym_not_eq] = ACTIONS(6187),
    [anon_sym_DASH_DASH] = ACTIONS(6189),
    [anon_sym_PLUS_PLUS] = ACTIONS(6189),
    [anon_sym_DOT] = ACTIONS(6187),
    [anon_sym_DOT_STAR] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6187),
    [anon_sym_decltype] = ACTIONS(6187),
  },
  [2689] = {
    [sym_attribute_specifier] = STATE(2766),
    [sym_identifier] = ACTIONS(6219),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6221),
    [anon_sym_COMMA] = ACTIONS(6221),
    [anon_sym_RPAREN] = ACTIONS(6221),
    [aux_sym_preproc_if_token2] = ACTIONS(6221),
    [aux_sym_preproc_else_token1] = ACTIONS(6221),
    [aux_sym_preproc_elif_token1] = ACTIONS(6219),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6221),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6221),
    [anon_sym_LPAREN2] = ACTIONS(6221),
    [anon_sym_DASH] = ACTIONS(6219),
    [anon_sym_PLUS] = ACTIONS(6219),
    [anon_sym_STAR] = ACTIONS(6219),
    [anon_sym_SLASH] = ACTIONS(6219),
    [anon_sym_PERCENT] = ACTIONS(6219),
    [anon_sym_PIPE_PIPE] = ACTIONS(6221),
    [anon_sym_AMP_AMP] = ACTIONS(6221),
    [anon_sym_PIPE] = ACTIONS(6219),
    [anon_sym_CARET] = ACTIONS(6219),
    [anon_sym_AMP] = ACTIONS(6219),
    [anon_sym_EQ_EQ] = ACTIONS(6221),
    [anon_sym_BANG_EQ] = ACTIONS(6221),
    [anon_sym_GT] = ACTIONS(6219),
    [anon_sym_GT_EQ] = ACTIONS(6221),
    [anon_sym_LT_EQ] = ACTIONS(6219),
    [anon_sym_LT] = ACTIONS(6219),
    [anon_sym_LT_LT] = ACTIONS(6219),
    [anon_sym_GT_GT] = ACTIONS(6219),
    [anon_sym_COLON] = ACTIONS(6221),
    [anon_sym_SEMI] = ACTIONS(6221),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6221),
    [anon_sym_RBRACE] = ACTIONS(6221),
    [anon_sym_LBRACK] = ACTIONS(6221),
    [anon_sym_RBRACK] = ACTIONS(6221),
    [anon_sym_EQ] = ACTIONS(6219),
    [anon_sym_QMARK] = ACTIONS(6221),
    [anon_sym_STAR_EQ] = ACTIONS(6221),
    [anon_sym_SLASH_EQ] = ACTIONS(6221),
    [anon_sym_PERCENT_EQ] = ACTIONS(6221),
    [anon_sym_PLUS_EQ] = ACTIONS(6221),
    [anon_sym_DASH_EQ] = ACTIONS(6221),
    [anon_sym_LT_LT_EQ] = ACTIONS(6221),
    [anon_sym_GT_GT_EQ] = ACTIONS(6221),
    [anon_sym_AMP_EQ] = ACTIONS(6221),
    [anon_sym_CARET_EQ] = ACTIONS(6221),
    [anon_sym_PIPE_EQ] = ACTIONS(6221),
    [anon_sym_and_eq] = ACTIONS(6219),
    [anon_sym_or_eq] = ACTIONS(6219),
    [anon_sym_xor_eq] = ACTIONS(6219),
    [anon_sym_LT_EQ_GT] = ACTIONS(6221),
    [anon_sym_or] = ACTIONS(6219),
    [anon_sym_and] = ACTIONS(6219),
    [anon_sym_bitor] = ACTIONS(6219),
    [anon_sym_xor] = ACTIONS(6219),
    [anon_sym_bitand] = ACTIONS(6219),
    [anon_sym_not_eq] = ACTIONS(6219),
    [anon_sym_DASH_DASH] = ACTIONS(6221),
    [anon_sym_PLUS_PLUS] = ACTIONS(6221),
    [anon_sym_DOT] = ACTIONS(6219),
    [anon_sym_DOT_STAR] = ACTIONS(6221),
    [anon_sym_DASH_GT] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6219),
    [anon_sym_decltype] = ACTIONS(6219),
  },
  [2690] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4269),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2691] = {
    [sym_attribute_specifier] = STATE(2767),
    [sym_identifier] = ACTIONS(6235),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6237),
    [anon_sym_COMMA] = ACTIONS(6237),
    [anon_sym_RPAREN] = ACTIONS(6237),
    [aux_sym_preproc_if_token2] = ACTIONS(6237),
    [aux_sym_preproc_else_token1] = ACTIONS(6237),
    [aux_sym_preproc_elif_token1] = ACTIONS(6235),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6237),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6237),
    [anon_sym_LPAREN2] = ACTIONS(6237),
    [anon_sym_DASH] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6235),
    [anon_sym_STAR] = ACTIONS(6235),
    [anon_sym_SLASH] = ACTIONS(6235),
    [anon_sym_PERCENT] = ACTIONS(6235),
    [anon_sym_PIPE_PIPE] = ACTIONS(6237),
    [anon_sym_AMP_AMP] = ACTIONS(6237),
    [anon_sym_PIPE] = ACTIONS(6235),
    [anon_sym_CARET] = ACTIONS(6235),
    [anon_sym_AMP] = ACTIONS(6235),
    [anon_sym_EQ_EQ] = ACTIONS(6237),
    [anon_sym_BANG_EQ] = ACTIONS(6237),
    [anon_sym_GT] = ACTIONS(6235),
    [anon_sym_GT_EQ] = ACTIONS(6237),
    [anon_sym_LT_EQ] = ACTIONS(6235),
    [anon_sym_LT] = ACTIONS(6235),
    [anon_sym_LT_LT] = ACTIONS(6235),
    [anon_sym_GT_GT] = ACTIONS(6235),
    [anon_sym_COLON] = ACTIONS(6237),
    [anon_sym_SEMI] = ACTIONS(6237),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6237),
    [anon_sym_RBRACE] = ACTIONS(6237),
    [anon_sym_LBRACK] = ACTIONS(6237),
    [anon_sym_RBRACK] = ACTIONS(6237),
    [anon_sym_EQ] = ACTIONS(6235),
    [anon_sym_QMARK] = ACTIONS(6237),
    [anon_sym_STAR_EQ] = ACTIONS(6237),
    [anon_sym_SLASH_EQ] = ACTIONS(6237),
    [anon_sym_PERCENT_EQ] = ACTIONS(6237),
    [anon_sym_PLUS_EQ] = ACTIONS(6237),
    [anon_sym_DASH_EQ] = ACTIONS(6237),
    [anon_sym_LT_LT_EQ] = ACTIONS(6237),
    [anon_sym_GT_GT_EQ] = ACTIONS(6237),
    [anon_sym_AMP_EQ] = ACTIONS(6237),
    [anon_sym_CARET_EQ] = ACTIONS(6237),
    [anon_sym_PIPE_EQ] = ACTIONS(6237),
    [anon_sym_and_eq] = ACTIONS(6235),
    [anon_sym_or_eq] = ACTIONS(6235),
    [anon_sym_xor_eq] = ACTIONS(6235),
    [anon_sym_LT_EQ_GT] = ACTIONS(6237),
    [anon_sym_or] = ACTIONS(6235),
    [anon_sym_and] = ACTIONS(6235),
    [anon_sym_bitor] = ACTIONS(6235),
    [anon_sym_xor] = ACTIONS(6235),
    [anon_sym_bitand] = ACTIONS(6235),
    [anon_sym_not_eq] = ACTIONS(6235),
    [anon_sym_DASH_DASH] = ACTIONS(6237),
    [anon_sym_PLUS_PLUS] = ACTIONS(6237),
    [anon_sym_DOT] = ACTIONS(6235),
    [anon_sym_DOT_STAR] = ACTIONS(6237),
    [anon_sym_DASH_GT] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6235),
    [anon_sym_decltype] = ACTIONS(6235),
  },
  [2692] = {
    [sym_attribute_specifier] = STATE(2772),
    [sym_identifier] = ACTIONS(6239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6241),
    [anon_sym_COMMA] = ACTIONS(6241),
    [anon_sym_RPAREN] = ACTIONS(6241),
    [aux_sym_preproc_if_token2] = ACTIONS(6241),
    [aux_sym_preproc_else_token1] = ACTIONS(6241),
    [aux_sym_preproc_elif_token1] = ACTIONS(6239),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6241),
    [anon_sym_LPAREN2] = ACTIONS(6241),
    [anon_sym_DASH] = ACTIONS(6239),
    [anon_sym_PLUS] = ACTIONS(6239),
    [anon_sym_STAR] = ACTIONS(6239),
    [anon_sym_SLASH] = ACTIONS(6239),
    [anon_sym_PERCENT] = ACTIONS(6239),
    [anon_sym_PIPE_PIPE] = ACTIONS(6241),
    [anon_sym_AMP_AMP] = ACTIONS(6241),
    [anon_sym_PIPE] = ACTIONS(6239),
    [anon_sym_CARET] = ACTIONS(6239),
    [anon_sym_AMP] = ACTIONS(6239),
    [anon_sym_EQ_EQ] = ACTIONS(6241),
    [anon_sym_BANG_EQ] = ACTIONS(6241),
    [anon_sym_GT] = ACTIONS(6239),
    [anon_sym_GT_EQ] = ACTIONS(6241),
    [anon_sym_LT_EQ] = ACTIONS(6239),
    [anon_sym_LT] = ACTIONS(6239),
    [anon_sym_LT_LT] = ACTIONS(6239),
    [anon_sym_GT_GT] = ACTIONS(6239),
    [anon_sym_COLON] = ACTIONS(6241),
    [anon_sym_SEMI] = ACTIONS(6241),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6241),
    [anon_sym_RBRACE] = ACTIONS(6241),
    [anon_sym_LBRACK] = ACTIONS(6241),
    [anon_sym_RBRACK] = ACTIONS(6241),
    [anon_sym_EQ] = ACTIONS(6239),
    [anon_sym_QMARK] = ACTIONS(6241),
    [anon_sym_STAR_EQ] = ACTIONS(6241),
    [anon_sym_SLASH_EQ] = ACTIONS(6241),
    [anon_sym_PERCENT_EQ] = ACTIONS(6241),
    [anon_sym_PLUS_EQ] = ACTIONS(6241),
    [anon_sym_DASH_EQ] = ACTIONS(6241),
    [anon_sym_LT_LT_EQ] = ACTIONS(6241),
    [anon_sym_GT_GT_EQ] = ACTIONS(6241),
    [anon_sym_AMP_EQ] = ACTIONS(6241),
    [anon_sym_CARET_EQ] = ACTIONS(6241),
    [anon_sym_PIPE_EQ] = ACTIONS(6241),
    [anon_sym_and_eq] = ACTIONS(6239),
    [anon_sym_or_eq] = ACTIONS(6239),
    [anon_sym_xor_eq] = ACTIONS(6239),
    [anon_sym_LT_EQ_GT] = ACTIONS(6241),
    [anon_sym_or] = ACTIONS(6239),
    [anon_sym_and] = ACTIONS(6239),
    [anon_sym_bitor] = ACTIONS(6239),
    [anon_sym_xor] = ACTIONS(6239),
    [anon_sym_bitand] = ACTIONS(6239),
    [anon_sym_not_eq] = ACTIONS(6239),
    [anon_sym_DASH_DASH] = ACTIONS(6241),
    [anon_sym_PLUS_PLUS] = ACTIONS(6241),
    [anon_sym_DOT] = ACTIONS(6239),
    [anon_sym_DOT_STAR] = ACTIONS(6241),
    [anon_sym_DASH_GT] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6239),
    [anon_sym_decltype] = ACTIONS(6239),
  },
  [2693] = {
    [sym_identifier] = ACTIONS(5945),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5947),
    [anon_sym_COMMA] = ACTIONS(5947),
    [anon_sym_RPAREN] = ACTIONS(5947),
    [aux_sym_preproc_if_token2] = ACTIONS(5947),
    [aux_sym_preproc_else_token1] = ACTIONS(5947),
    [aux_sym_preproc_elif_token1] = ACTIONS(5945),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5947),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5947),
    [anon_sym_LPAREN2] = ACTIONS(5947),
    [anon_sym_DASH] = ACTIONS(5945),
    [anon_sym_PLUS] = ACTIONS(5945),
    [anon_sym_STAR] = ACTIONS(5945),
    [anon_sym_SLASH] = ACTIONS(5945),
    [anon_sym_PERCENT] = ACTIONS(5945),
    [anon_sym_PIPE_PIPE] = ACTIONS(5947),
    [anon_sym_AMP_AMP] = ACTIONS(5947),
    [anon_sym_PIPE] = ACTIONS(5945),
    [anon_sym_CARET] = ACTIONS(5945),
    [anon_sym_AMP] = ACTIONS(5945),
    [anon_sym_EQ_EQ] = ACTIONS(5947),
    [anon_sym_BANG_EQ] = ACTIONS(5947),
    [anon_sym_GT] = ACTIONS(5945),
    [anon_sym_GT_EQ] = ACTIONS(5947),
    [anon_sym_LT_EQ] = ACTIONS(5945),
    [anon_sym_LT] = ACTIONS(5945),
    [anon_sym_LT_LT] = ACTIONS(5945),
    [anon_sym_GT_GT] = ACTIONS(5945),
    [anon_sym_COLON] = ACTIONS(5945),
    [anon_sym_SEMI] = ACTIONS(5947),
    [anon_sym___attribute__] = ACTIONS(5945),
    [anon_sym___attribute] = ACTIONS(5945),
    [anon_sym_COLON_COLON] = ACTIONS(5947),
    [anon_sym_LBRACE] = ACTIONS(5947),
    [anon_sym_RBRACE] = ACTIONS(5947),
    [anon_sym_LBRACK] = ACTIONS(5947),
    [anon_sym_RBRACK] = ACTIONS(5947),
    [anon_sym_EQ] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5947),
    [anon_sym_STAR_EQ] = ACTIONS(5947),
    [anon_sym_SLASH_EQ] = ACTIONS(5947),
    [anon_sym_PERCENT_EQ] = ACTIONS(5947),
    [anon_sym_PLUS_EQ] = ACTIONS(5947),
    [anon_sym_DASH_EQ] = ACTIONS(5947),
    [anon_sym_LT_LT_EQ] = ACTIONS(5947),
    [anon_sym_GT_GT_EQ] = ACTIONS(5947),
    [anon_sym_AMP_EQ] = ACTIONS(5947),
    [anon_sym_CARET_EQ] = ACTIONS(5947),
    [anon_sym_PIPE_EQ] = ACTIONS(5947),
    [anon_sym_and_eq] = ACTIONS(5945),
    [anon_sym_or_eq] = ACTIONS(5945),
    [anon_sym_xor_eq] = ACTIONS(5945),
    [anon_sym_LT_EQ_GT] = ACTIONS(5947),
    [anon_sym_or] = ACTIONS(5945),
    [anon_sym_and] = ACTIONS(5945),
    [anon_sym_bitor] = ACTIONS(5945),
    [anon_sym_xor] = ACTIONS(5945),
    [anon_sym_bitand] = ACTIONS(5945),
    [anon_sym_not_eq] = ACTIONS(5945),
    [anon_sym_DASH_DASH] = ACTIONS(5947),
    [anon_sym_PLUS_PLUS] = ACTIONS(5947),
    [anon_sym_DOT] = ACTIONS(5945),
    [anon_sym_DOT_STAR] = ACTIONS(5947),
    [anon_sym_DASH_GT] = ACTIONS(5947),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5945),
    [anon_sym_decltype] = ACTIONS(5945),
  },
  [2694] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4261),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2695] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(6741),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(6743),
    [anon_sym_EQ] = ACTIONS(6746),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6700),
    [anon_sym_SLASH_EQ] = ACTIONS(6700),
    [anon_sym_PERCENT_EQ] = ACTIONS(6700),
    [anon_sym_PLUS_EQ] = ACTIONS(6700),
    [anon_sym_DASH_EQ] = ACTIONS(6700),
    [anon_sym_LT_LT_EQ] = ACTIONS(6700),
    [anon_sym_GT_GT_EQ] = ACTIONS(6700),
    [anon_sym_AMP_EQ] = ACTIONS(6700),
    [anon_sym_CARET_EQ] = ACTIONS(6700),
    [anon_sym_PIPE_EQ] = ACTIONS(6700),
    [anon_sym_and_eq] = ACTIONS(6700),
    [anon_sym_or_eq] = ACTIONS(6700),
    [anon_sym_xor_eq] = ACTIONS(6700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2696] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4217),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4249),
    [anon_sym_SLASH_EQ] = ACTIONS(4249),
    [anon_sym_PERCENT_EQ] = ACTIONS(4249),
    [anon_sym_PLUS_EQ] = ACTIONS(4249),
    [anon_sym_DASH_EQ] = ACTIONS(4249),
    [anon_sym_LT_LT_EQ] = ACTIONS(4249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4249),
    [anon_sym_AMP_EQ] = ACTIONS(4249),
    [anon_sym_CARET_EQ] = ACTIONS(4249),
    [anon_sym_PIPE_EQ] = ACTIONS(4249),
    [anon_sym_and_eq] = ACTIONS(4249),
    [anon_sym_or_eq] = ACTIONS(4249),
    [anon_sym_xor_eq] = ACTIONS(4249),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2697] = {
    [sym_attribute_specifier] = STATE(2737),
    [sym_identifier] = ACTIONS(6223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6225),
    [anon_sym_COMMA] = ACTIONS(6225),
    [anon_sym_RPAREN] = ACTIONS(6225),
    [aux_sym_preproc_if_token2] = ACTIONS(6225),
    [aux_sym_preproc_else_token1] = ACTIONS(6225),
    [aux_sym_preproc_elif_token1] = ACTIONS(6223),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6225),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6225),
    [anon_sym_LPAREN2] = ACTIONS(6225),
    [anon_sym_DASH] = ACTIONS(6223),
    [anon_sym_PLUS] = ACTIONS(6223),
    [anon_sym_STAR] = ACTIONS(6223),
    [anon_sym_SLASH] = ACTIONS(6223),
    [anon_sym_PERCENT] = ACTIONS(6223),
    [anon_sym_PIPE_PIPE] = ACTIONS(6225),
    [anon_sym_AMP_AMP] = ACTIONS(6225),
    [anon_sym_PIPE] = ACTIONS(6223),
    [anon_sym_CARET] = ACTIONS(6223),
    [anon_sym_AMP] = ACTIONS(6223),
    [anon_sym_EQ_EQ] = ACTIONS(6225),
    [anon_sym_BANG_EQ] = ACTIONS(6225),
    [anon_sym_GT] = ACTIONS(6223),
    [anon_sym_GT_EQ] = ACTIONS(6225),
    [anon_sym_LT_EQ] = ACTIONS(6223),
    [anon_sym_LT] = ACTIONS(6223),
    [anon_sym_LT_LT] = ACTIONS(6223),
    [anon_sym_GT_GT] = ACTIONS(6223),
    [anon_sym_COLON] = ACTIONS(6225),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6225),
    [anon_sym_RBRACE] = ACTIONS(6225),
    [anon_sym_LBRACK] = ACTIONS(6225),
    [anon_sym_RBRACK] = ACTIONS(6225),
    [anon_sym_EQ] = ACTIONS(6223),
    [anon_sym_QMARK] = ACTIONS(6225),
    [anon_sym_STAR_EQ] = ACTIONS(6225),
    [anon_sym_SLASH_EQ] = ACTIONS(6225),
    [anon_sym_PERCENT_EQ] = ACTIONS(6225),
    [anon_sym_PLUS_EQ] = ACTIONS(6225),
    [anon_sym_DASH_EQ] = ACTIONS(6225),
    [anon_sym_LT_LT_EQ] = ACTIONS(6225),
    [anon_sym_GT_GT_EQ] = ACTIONS(6225),
    [anon_sym_AMP_EQ] = ACTIONS(6225),
    [anon_sym_CARET_EQ] = ACTIONS(6225),
    [anon_sym_PIPE_EQ] = ACTIONS(6225),
    [anon_sym_and_eq] = ACTIONS(6223),
    [anon_sym_or_eq] = ACTIONS(6223),
    [anon_sym_xor_eq] = ACTIONS(6223),
    [anon_sym_LT_EQ_GT] = ACTIONS(6225),
    [anon_sym_or] = ACTIONS(6223),
    [anon_sym_and] = ACTIONS(6223),
    [anon_sym_bitor] = ACTIONS(6223),
    [anon_sym_xor] = ACTIONS(6223),
    [anon_sym_bitand] = ACTIONS(6223),
    [anon_sym_not_eq] = ACTIONS(6223),
    [anon_sym_DASH_DASH] = ACTIONS(6225),
    [anon_sym_PLUS_PLUS] = ACTIONS(6225),
    [anon_sym_DOT] = ACTIONS(6223),
    [anon_sym_DOT_STAR] = ACTIONS(6225),
    [anon_sym_DASH_GT] = ACTIONS(6225),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6223),
    [anon_sym_decltype] = ACTIONS(6223),
  },
  [2698] = {
    [sym_identifier] = ACTIONS(2163),
    [anon_sym___extension__] = ACTIONS(2163),
    [anon_sym_in] = ACTIONS(2163),
    [anon_sym_out] = ACTIONS(2163),
    [anon_sym_inout] = ACTIONS(2163),
    [anon_sym_virtual] = ACTIONS(2163),
    [anon_sym_extern] = ACTIONS(2163),
    [anon_sym___attribute__] = ACTIONS(2163),
    [anon_sym___attribute] = ACTIONS(2163),
    [anon_sym_COLON_COLON] = ACTIONS(2165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2165),
    [anon_sym___declspec] = ACTIONS(2163),
    [anon_sym_signed] = ACTIONS(2163),
    [anon_sym_unsigned] = ACTIONS(2163),
    [anon_sym_long] = ACTIONS(2163),
    [anon_sym_short] = ACTIONS(2163),
    [anon_sym_static] = ACTIONS(2163),
    [anon_sym_register] = ACTIONS(2163),
    [anon_sym_inline] = ACTIONS(2163),
    [anon_sym___inline] = ACTIONS(2163),
    [anon_sym___inline__] = ACTIONS(2163),
    [anon_sym___forceinline] = ACTIONS(2163),
    [anon_sym_thread_local] = ACTIONS(2163),
    [anon_sym___thread] = ACTIONS(2163),
    [anon_sym_const] = ACTIONS(2163),
    [anon_sym_constexpr] = ACTIONS(2163),
    [anon_sym_volatile] = ACTIONS(2163),
    [anon_sym_restrict] = ACTIONS(2163),
    [anon_sym___restrict__] = ACTIONS(2163),
    [anon_sym__Atomic] = ACTIONS(2163),
    [anon_sym__Noreturn] = ACTIONS(2163),
    [anon_sym_noreturn] = ACTIONS(2163),
    [anon_sym__Nonnull] = ACTIONS(2163),
    [anon_sym_mutable] = ACTIONS(2163),
    [anon_sym_constinit] = ACTIONS(2163),
    [anon_sym_consteval] = ACTIONS(2163),
    [anon_sym_alignas] = ACTIONS(2163),
    [anon_sym__Alignas] = ACTIONS(2163),
    [sym_primitive_type] = ACTIONS(2163),
    [anon_sym_enum] = ACTIONS(2163),
    [anon_sym_class] = ACTIONS(2163),
    [anon_sym_struct] = ACTIONS(2163),
    [anon_sym_union] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2163),
    [anon_sym_decltype] = ACTIONS(2163),
    [anon_sym_typename] = ACTIONS(2163),
    [anon_sym_template] = ACTIONS(2163),
    [anon_sym_precise] = ACTIONS(2163),
    [anon_sym_shared] = ACTIONS(2163),
    [anon_sym_groupshared] = ACTIONS(2163),
    [anon_sym_uniform] = ACTIONS(2163),
    [anon_sym_row_major] = ACTIONS(2163),
    [anon_sym_column_major] = ACTIONS(2163),
    [anon_sym_globallycoherent] = ACTIONS(2163),
    [anon_sym_centroid] = ACTIONS(2163),
    [anon_sym_noperspective] = ACTIONS(2163),
    [anon_sym_nointerpolation] = ACTIONS(2163),
    [anon_sym_sample] = ACTIONS(2163),
    [anon_sym_linear] = ACTIONS(2163),
    [anon_sym_snorm] = ACTIONS(2163),
    [anon_sym_unorm] = ACTIONS(2163),
    [anon_sym_point] = ACTIONS(2163),
    [anon_sym_line] = ACTIONS(2163),
    [anon_sym_triangleadj] = ACTIONS(2163),
    [anon_sym_lineadj] = ACTIONS(2163),
    [anon_sym_triangle] = ACTIONS(2163),
  },
  [2699] = {
    [sym_identifier] = ACTIONS(6015),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6017),
    [anon_sym_COMMA] = ACTIONS(6017),
    [anon_sym_RPAREN] = ACTIONS(6017),
    [aux_sym_preproc_if_token2] = ACTIONS(6017),
    [aux_sym_preproc_else_token1] = ACTIONS(6017),
    [aux_sym_preproc_elif_token1] = ACTIONS(6015),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6017),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6017),
    [anon_sym_LPAREN2] = ACTIONS(6017),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_PLUS] = ACTIONS(6015),
    [anon_sym_STAR] = ACTIONS(6015),
    [anon_sym_SLASH] = ACTIONS(6015),
    [anon_sym_PERCENT] = ACTIONS(6015),
    [anon_sym_PIPE_PIPE] = ACTIONS(6017),
    [anon_sym_AMP_AMP] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6015),
    [anon_sym_CARET] = ACTIONS(6015),
    [anon_sym_AMP] = ACTIONS(6015),
    [anon_sym_EQ_EQ] = ACTIONS(6017),
    [anon_sym_BANG_EQ] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6015),
    [anon_sym_GT_EQ] = ACTIONS(6017),
    [anon_sym_LT_EQ] = ACTIONS(6015),
    [anon_sym_LT] = ACTIONS(6015),
    [anon_sym_LT_LT] = ACTIONS(6015),
    [anon_sym_GT_GT] = ACTIONS(6015),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6017),
    [anon_sym___attribute__] = ACTIONS(6015),
    [anon_sym___attribute] = ACTIONS(6015),
    [anon_sym_LBRACE] = ACTIONS(6017),
    [anon_sym_RBRACE] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6017),
    [anon_sym_RBRACK] = ACTIONS(6017),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_QMARK] = ACTIONS(6017),
    [anon_sym_STAR_EQ] = ACTIONS(6017),
    [anon_sym_SLASH_EQ] = ACTIONS(6017),
    [anon_sym_PERCENT_EQ] = ACTIONS(6017),
    [anon_sym_PLUS_EQ] = ACTIONS(6017),
    [anon_sym_DASH_EQ] = ACTIONS(6017),
    [anon_sym_LT_LT_EQ] = ACTIONS(6017),
    [anon_sym_GT_GT_EQ] = ACTIONS(6017),
    [anon_sym_AMP_EQ] = ACTIONS(6017),
    [anon_sym_CARET_EQ] = ACTIONS(6017),
    [anon_sym_PIPE_EQ] = ACTIONS(6017),
    [anon_sym_and_eq] = ACTIONS(6015),
    [anon_sym_or_eq] = ACTIONS(6015),
    [anon_sym_xor_eq] = ACTIONS(6015),
    [anon_sym_LT_EQ_GT] = ACTIONS(6017),
    [anon_sym_or] = ACTIONS(6015),
    [anon_sym_and] = ACTIONS(6015),
    [anon_sym_bitor] = ACTIONS(6015),
    [anon_sym_xor] = ACTIONS(6015),
    [anon_sym_bitand] = ACTIONS(6015),
    [anon_sym_not_eq] = ACTIONS(6015),
    [anon_sym_DASH_DASH] = ACTIONS(6017),
    [anon_sym_PLUS_PLUS] = ACTIONS(6017),
    [anon_sym_DOT] = ACTIONS(6015),
    [anon_sym_DOT_STAR] = ACTIONS(6017),
    [anon_sym_DASH_GT] = ACTIONS(6017),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6015),
    [anon_sym_decltype] = ACTIONS(6015),
  },
  [2700] = {
    [sym_identifier] = ACTIONS(6041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6043),
    [anon_sym_COMMA] = ACTIONS(6043),
    [anon_sym_RPAREN] = ACTIONS(6043),
    [aux_sym_preproc_if_token2] = ACTIONS(6043),
    [aux_sym_preproc_else_token1] = ACTIONS(6043),
    [aux_sym_preproc_elif_token1] = ACTIONS(6041),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6043),
    [anon_sym_LPAREN2] = ACTIONS(6043),
    [anon_sym_DASH] = ACTIONS(6041),
    [anon_sym_PLUS] = ACTIONS(6041),
    [anon_sym_STAR] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6041),
    [anon_sym_PIPE_PIPE] = ACTIONS(6043),
    [anon_sym_AMP_AMP] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6041),
    [anon_sym_CARET] = ACTIONS(6041),
    [anon_sym_AMP] = ACTIONS(6041),
    [anon_sym_EQ_EQ] = ACTIONS(6043),
    [anon_sym_BANG_EQ] = ACTIONS(6043),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_LT_LT] = ACTIONS(6041),
    [anon_sym_GT_GT] = ACTIONS(6041),
    [anon_sym_COLON] = ACTIONS(6043),
    [anon_sym_SEMI] = ACTIONS(6043),
    [anon_sym___attribute__] = ACTIONS(6041),
    [anon_sym___attribute] = ACTIONS(6041),
    [anon_sym_LBRACE] = ACTIONS(6043),
    [anon_sym_RBRACE] = ACTIONS(6043),
    [anon_sym_LBRACK] = ACTIONS(6043),
    [anon_sym_RBRACK] = ACTIONS(6043),
    [anon_sym_EQ] = ACTIONS(6041),
    [anon_sym_QMARK] = ACTIONS(6043),
    [anon_sym_STAR_EQ] = ACTIONS(6043),
    [anon_sym_SLASH_EQ] = ACTIONS(6043),
    [anon_sym_PERCENT_EQ] = ACTIONS(6043),
    [anon_sym_PLUS_EQ] = ACTIONS(6043),
    [anon_sym_DASH_EQ] = ACTIONS(6043),
    [anon_sym_LT_LT_EQ] = ACTIONS(6043),
    [anon_sym_GT_GT_EQ] = ACTIONS(6043),
    [anon_sym_AMP_EQ] = ACTIONS(6043),
    [anon_sym_CARET_EQ] = ACTIONS(6043),
    [anon_sym_PIPE_EQ] = ACTIONS(6043),
    [anon_sym_and_eq] = ACTIONS(6041),
    [anon_sym_or_eq] = ACTIONS(6041),
    [anon_sym_xor_eq] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6043),
    [anon_sym_or] = ACTIONS(6041),
    [anon_sym_and] = ACTIONS(6041),
    [anon_sym_bitor] = ACTIONS(6041),
    [anon_sym_xor] = ACTIONS(6041),
    [anon_sym_bitand] = ACTIONS(6041),
    [anon_sym_not_eq] = ACTIONS(6041),
    [anon_sym_DASH_DASH] = ACTIONS(6043),
    [anon_sym_PLUS_PLUS] = ACTIONS(6043),
    [anon_sym_DOT] = ACTIONS(6041),
    [anon_sym_DOT_STAR] = ACTIONS(6043),
    [anon_sym_DASH_GT] = ACTIONS(6043),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6041),
    [anon_sym_decltype] = ACTIONS(6041),
  },
  [2701] = {
    [sym_identifier] = ACTIONS(6029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6031),
    [anon_sym_COMMA] = ACTIONS(6031),
    [anon_sym_RPAREN] = ACTIONS(6031),
    [aux_sym_preproc_if_token2] = ACTIONS(6031),
    [aux_sym_preproc_else_token1] = ACTIONS(6031),
    [aux_sym_preproc_elif_token1] = ACTIONS(6029),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6031),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6031),
    [anon_sym_LPAREN2] = ACTIONS(6031),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_PERCENT] = ACTIONS(6029),
    [anon_sym_PIPE_PIPE] = ACTIONS(6031),
    [anon_sym_AMP_AMP] = ACTIONS(6031),
    [anon_sym_PIPE] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_AMP] = ACTIONS(6029),
    [anon_sym_EQ_EQ] = ACTIONS(6031),
    [anon_sym_BANG_EQ] = ACTIONS(6031),
    [anon_sym_GT] = ACTIONS(6029),
    [anon_sym_GT_EQ] = ACTIONS(6031),
    [anon_sym_LT_EQ] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6029),
    [anon_sym_LT_LT] = ACTIONS(6029),
    [anon_sym_GT_GT] = ACTIONS(6029),
    [anon_sym_COLON] = ACTIONS(6031),
    [anon_sym_SEMI] = ACTIONS(6031),
    [anon_sym___attribute__] = ACTIONS(6029),
    [anon_sym___attribute] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6031),
    [anon_sym_RBRACE] = ACTIONS(6031),
    [anon_sym_LBRACK] = ACTIONS(6031),
    [anon_sym_RBRACK] = ACTIONS(6031),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_QMARK] = ACTIONS(6031),
    [anon_sym_STAR_EQ] = ACTIONS(6031),
    [anon_sym_SLASH_EQ] = ACTIONS(6031),
    [anon_sym_PERCENT_EQ] = ACTIONS(6031),
    [anon_sym_PLUS_EQ] = ACTIONS(6031),
    [anon_sym_DASH_EQ] = ACTIONS(6031),
    [anon_sym_LT_LT_EQ] = ACTIONS(6031),
    [anon_sym_GT_GT_EQ] = ACTIONS(6031),
    [anon_sym_AMP_EQ] = ACTIONS(6031),
    [anon_sym_CARET_EQ] = ACTIONS(6031),
    [anon_sym_PIPE_EQ] = ACTIONS(6031),
    [anon_sym_and_eq] = ACTIONS(6029),
    [anon_sym_or_eq] = ACTIONS(6029),
    [anon_sym_xor_eq] = ACTIONS(6029),
    [anon_sym_LT_EQ_GT] = ACTIONS(6031),
    [anon_sym_or] = ACTIONS(6029),
    [anon_sym_and] = ACTIONS(6029),
    [anon_sym_bitor] = ACTIONS(6029),
    [anon_sym_xor] = ACTIONS(6029),
    [anon_sym_bitand] = ACTIONS(6029),
    [anon_sym_not_eq] = ACTIONS(6029),
    [anon_sym_DASH_DASH] = ACTIONS(6031),
    [anon_sym_PLUS_PLUS] = ACTIONS(6031),
    [anon_sym_DOT] = ACTIONS(6029),
    [anon_sym_DOT_STAR] = ACTIONS(6031),
    [anon_sym_DASH_GT] = ACTIONS(6031),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6029),
    [anon_sym_decltype] = ACTIONS(6029),
  },
  [2702] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [aux_sym_preproc_if_token2] = ACTIONS(6013),
    [aux_sym_preproc_else_token1] = ACTIONS(6013),
    [aux_sym_preproc_elif_token1] = ACTIONS(6011),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_DASH] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(6011),
    [anon_sym_PERCENT] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_PIPE] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6011),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6013),
    [anon_sym_BANG_EQ] = ACTIONS(6013),
    [anon_sym_GT] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6013),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6011),
    [anon_sym_GT_GT] = ACTIONS(6011),
    [anon_sym_COLON] = ACTIONS(6013),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_LBRACK] = ACTIONS(6013),
    [anon_sym_RBRACK] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6013),
    [anon_sym_STAR_EQ] = ACTIONS(6013),
    [anon_sym_SLASH_EQ] = ACTIONS(6013),
    [anon_sym_PERCENT_EQ] = ACTIONS(6013),
    [anon_sym_PLUS_EQ] = ACTIONS(6013),
    [anon_sym_DASH_EQ] = ACTIONS(6013),
    [anon_sym_LT_LT_EQ] = ACTIONS(6013),
    [anon_sym_GT_GT_EQ] = ACTIONS(6013),
    [anon_sym_AMP_EQ] = ACTIONS(6013),
    [anon_sym_CARET_EQ] = ACTIONS(6013),
    [anon_sym_PIPE_EQ] = ACTIONS(6013),
    [anon_sym_and_eq] = ACTIONS(6011),
    [anon_sym_or_eq] = ACTIONS(6011),
    [anon_sym_xor_eq] = ACTIONS(6011),
    [anon_sym_LT_EQ_GT] = ACTIONS(6013),
    [anon_sym_or] = ACTIONS(6011),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_bitor] = ACTIONS(6011),
    [anon_sym_xor] = ACTIONS(6011),
    [anon_sym_bitand] = ACTIONS(6011),
    [anon_sym_not_eq] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6013),
    [anon_sym_PLUS_PLUS] = ACTIONS(6013),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_DOT_STAR] = ACTIONS(6013),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
  },
  [2703] = {
    [sym_identifier] = ACTIONS(6087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6089),
    [anon_sym_COMMA] = ACTIONS(6089),
    [anon_sym_RPAREN] = ACTIONS(6089),
    [aux_sym_preproc_if_token2] = ACTIONS(6089),
    [aux_sym_preproc_else_token1] = ACTIONS(6089),
    [aux_sym_preproc_elif_token1] = ACTIONS(6087),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6089),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6089),
    [anon_sym_LPAREN2] = ACTIONS(6089),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_PERCENT] = ACTIONS(6087),
    [anon_sym_PIPE_PIPE] = ACTIONS(6089),
    [anon_sym_AMP_AMP] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_AMP] = ACTIONS(6087),
    [anon_sym_EQ_EQ] = ACTIONS(6089),
    [anon_sym_BANG_EQ] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6087),
    [anon_sym_GT_EQ] = ACTIONS(6089),
    [anon_sym_LT_EQ] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6087),
    [anon_sym_LT_LT] = ACTIONS(6087),
    [anon_sym_GT_GT] = ACTIONS(6087),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SEMI] = ACTIONS(6089),
    [anon_sym___attribute__] = ACTIONS(6087),
    [anon_sym___attribute] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6089),
    [anon_sym_RBRACE] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6089),
    [anon_sym_RBRACK] = ACTIONS(6089),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_QMARK] = ACTIONS(6089),
    [anon_sym_STAR_EQ] = ACTIONS(6089),
    [anon_sym_SLASH_EQ] = ACTIONS(6089),
    [anon_sym_PERCENT_EQ] = ACTIONS(6089),
    [anon_sym_PLUS_EQ] = ACTIONS(6089),
    [anon_sym_DASH_EQ] = ACTIONS(6089),
    [anon_sym_LT_LT_EQ] = ACTIONS(6089),
    [anon_sym_GT_GT_EQ] = ACTIONS(6089),
    [anon_sym_AMP_EQ] = ACTIONS(6089),
    [anon_sym_CARET_EQ] = ACTIONS(6089),
    [anon_sym_PIPE_EQ] = ACTIONS(6089),
    [anon_sym_and_eq] = ACTIONS(6087),
    [anon_sym_or_eq] = ACTIONS(6087),
    [anon_sym_xor_eq] = ACTIONS(6087),
    [anon_sym_LT_EQ_GT] = ACTIONS(6089),
    [anon_sym_or] = ACTIONS(6087),
    [anon_sym_and] = ACTIONS(6087),
    [anon_sym_bitor] = ACTIONS(6087),
    [anon_sym_xor] = ACTIONS(6087),
    [anon_sym_bitand] = ACTIONS(6087),
    [anon_sym_not_eq] = ACTIONS(6087),
    [anon_sym_DASH_DASH] = ACTIONS(6089),
    [anon_sym_PLUS_PLUS] = ACTIONS(6089),
    [anon_sym_DOT] = ACTIONS(6087),
    [anon_sym_DOT_STAR] = ACTIONS(6089),
    [anon_sym_DASH_GT] = ACTIONS(6089),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6087),
    [anon_sym_decltype] = ACTIONS(6087),
  },
  [2704] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [aux_sym_preproc_if_token2] = ACTIONS(5859),
    [aux_sym_preproc_else_token1] = ACTIONS(5859),
    [aux_sym_preproc_elif_token1] = ACTIONS(5857),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5857),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5857),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5857),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5857),
    [anon_sym_GT_GT] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_EQ] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_STAR_EQ] = ACTIONS(5859),
    [anon_sym_SLASH_EQ] = ACTIONS(5859),
    [anon_sym_PERCENT_EQ] = ACTIONS(5859),
    [anon_sym_PLUS_EQ] = ACTIONS(5859),
    [anon_sym_DASH_EQ] = ACTIONS(5859),
    [anon_sym_LT_LT_EQ] = ACTIONS(5859),
    [anon_sym_GT_GT_EQ] = ACTIONS(5859),
    [anon_sym_AMP_EQ] = ACTIONS(5859),
    [anon_sym_CARET_EQ] = ACTIONS(5859),
    [anon_sym_PIPE_EQ] = ACTIONS(5859),
    [anon_sym_and_eq] = ACTIONS(5857),
    [anon_sym_or_eq] = ACTIONS(5857),
    [anon_sym_xor_eq] = ACTIONS(5857),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
  },
  [2705] = {
    [sym_identifier] = ACTIONS(6748),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6750),
    [anon_sym_COMMA] = ACTIONS(6750),
    [anon_sym_RPAREN] = ACTIONS(6750),
    [aux_sym_preproc_if_token2] = ACTIONS(6750),
    [aux_sym_preproc_else_token1] = ACTIONS(6750),
    [aux_sym_preproc_elif_token1] = ACTIONS(6748),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6750),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6750),
    [anon_sym_LPAREN2] = ACTIONS(6750),
    [anon_sym_DASH] = ACTIONS(6748),
    [anon_sym_PLUS] = ACTIONS(6748),
    [anon_sym_STAR] = ACTIONS(6748),
    [anon_sym_SLASH] = ACTIONS(6748),
    [anon_sym_PERCENT] = ACTIONS(6748),
    [anon_sym_PIPE_PIPE] = ACTIONS(6750),
    [anon_sym_AMP_AMP] = ACTIONS(6750),
    [anon_sym_PIPE] = ACTIONS(6748),
    [anon_sym_CARET] = ACTIONS(6748),
    [anon_sym_AMP] = ACTIONS(6748),
    [anon_sym_EQ_EQ] = ACTIONS(6750),
    [anon_sym_BANG_EQ] = ACTIONS(6750),
    [anon_sym_GT] = ACTIONS(6748),
    [anon_sym_GT_EQ] = ACTIONS(6750),
    [anon_sym_LT_EQ] = ACTIONS(6748),
    [anon_sym_LT] = ACTIONS(6748),
    [anon_sym_LT_LT] = ACTIONS(6748),
    [anon_sym_GT_GT] = ACTIONS(6748),
    [anon_sym_COLON] = ACTIONS(6750),
    [anon_sym_SEMI] = ACTIONS(6750),
    [anon_sym___attribute__] = ACTIONS(6748),
    [anon_sym___attribute] = ACTIONS(6748),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6750),
    [anon_sym_LBRACE] = ACTIONS(6750),
    [anon_sym_RBRACE] = ACTIONS(6750),
    [anon_sym_LBRACK] = ACTIONS(6748),
    [anon_sym_RBRACK] = ACTIONS(6750),
    [anon_sym_EQ] = ACTIONS(6748),
    [anon_sym_QMARK] = ACTIONS(6750),
    [anon_sym_STAR_EQ] = ACTIONS(6750),
    [anon_sym_SLASH_EQ] = ACTIONS(6750),
    [anon_sym_PERCENT_EQ] = ACTIONS(6750),
    [anon_sym_PLUS_EQ] = ACTIONS(6750),
    [anon_sym_DASH_EQ] = ACTIONS(6750),
    [anon_sym_LT_LT_EQ] = ACTIONS(6750),
    [anon_sym_GT_GT_EQ] = ACTIONS(6750),
    [anon_sym_AMP_EQ] = ACTIONS(6750),
    [anon_sym_CARET_EQ] = ACTIONS(6750),
    [anon_sym_PIPE_EQ] = ACTIONS(6750),
    [anon_sym_and_eq] = ACTIONS(6748),
    [anon_sym_or_eq] = ACTIONS(6748),
    [anon_sym_xor_eq] = ACTIONS(6748),
    [anon_sym_LT_EQ_GT] = ACTIONS(6750),
    [anon_sym_or] = ACTIONS(6748),
    [anon_sym_and] = ACTIONS(6748),
    [anon_sym_bitor] = ACTIONS(6748),
    [anon_sym_xor] = ACTIONS(6748),
    [anon_sym_bitand] = ACTIONS(6748),
    [anon_sym_not_eq] = ACTIONS(6748),
    [anon_sym_DASH_DASH] = ACTIONS(6750),
    [anon_sym_PLUS_PLUS] = ACTIONS(6750),
    [anon_sym_DOT] = ACTIONS(6748),
    [anon_sym_DOT_STAR] = ACTIONS(6750),
    [anon_sym_DASH_GT] = ACTIONS(6750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6748),
  },
  [2706] = {
    [sym_string_literal] = STATE(3771),
    [sym_template_argument_list] = STATE(4763),
    [sym_raw_string_literal] = STATE(3771),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5713),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(5720),
    [anon_sym_SLASH_EQ] = ACTIONS(5720),
    [anon_sym_PERCENT_EQ] = ACTIONS(5720),
    [anon_sym_PLUS_EQ] = ACTIONS(5720),
    [anon_sym_DASH_EQ] = ACTIONS(5720),
    [anon_sym_LT_LT_EQ] = ACTIONS(5720),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5720),
    [anon_sym_CARET_EQ] = ACTIONS(5720),
    [anon_sym_PIPE_EQ] = ACTIONS(5720),
    [anon_sym_and_eq] = ACTIONS(5720),
    [anon_sym_or_eq] = ACTIONS(5720),
    [anon_sym_xor_eq] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(5722),
    [anon_sym_u_DQUOTE] = ACTIONS(5722),
    [anon_sym_U_DQUOTE] = ACTIONS(5722),
    [anon_sym_u8_DQUOTE] = ACTIONS(5722),
    [anon_sym_DQUOTE] = ACTIONS(5722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4217),
    [anon_sym_R_DQUOTE] = ACTIONS(5724),
    [anon_sym_LR_DQUOTE] = ACTIONS(5724),
    [anon_sym_uR_DQUOTE] = ACTIONS(5724),
    [anon_sym_UR_DQUOTE] = ACTIONS(5724),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5724),
  },
  [2707] = {
    [sym_type_qualifier] = STATE(2707),
    [sym_alignas_qualifier] = STATE(2654),
    [aux_sym__type_definition_type_repeat1] = STATE(2707),
    [sym_identifier] = ACTIONS(5024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5026),
    [anon_sym_COMMA] = ACTIONS(5026),
    [anon_sym_LPAREN2] = ACTIONS(5026),
    [anon_sym_DASH] = ACTIONS(5024),
    [anon_sym_PLUS] = ACTIONS(5024),
    [anon_sym_STAR] = ACTIONS(5026),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5026),
    [anon_sym_PIPE_PIPE] = ACTIONS(5026),
    [anon_sym_AMP_AMP] = ACTIONS(5026),
    [anon_sym_PIPE] = ACTIONS(5024),
    [anon_sym_CARET] = ACTIONS(5026),
    [anon_sym_AMP] = ACTIONS(5024),
    [anon_sym_EQ_EQ] = ACTIONS(5026),
    [anon_sym_BANG_EQ] = ACTIONS(5026),
    [anon_sym_GT] = ACTIONS(5024),
    [anon_sym_GT_EQ] = ACTIONS(5024),
    [anon_sym_LT_EQ] = ACTIONS(5024),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_LT_LT] = ACTIONS(5026),
    [anon_sym_GT_GT] = ACTIONS(5024),
    [anon_sym___extension__] = ACTIONS(6752),
    [anon_sym___attribute__] = ACTIONS(5024),
    [anon_sym___attribute] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(5026),
    [anon_sym_signed] = ACTIONS(5024),
    [anon_sym_unsigned] = ACTIONS(5024),
    [anon_sym_long] = ACTIONS(5024),
    [anon_sym_short] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(5026),
    [anon_sym_const] = ACTIONS(6752),
    [anon_sym_constexpr] = ACTIONS(6752),
    [anon_sym_volatile] = ACTIONS(6752),
    [anon_sym_restrict] = ACTIONS(6752),
    [anon_sym___restrict__] = ACTIONS(6752),
    [anon_sym__Atomic] = ACTIONS(6752),
    [anon_sym__Noreturn] = ACTIONS(6752),
    [anon_sym_noreturn] = ACTIONS(6752),
    [anon_sym__Nonnull] = ACTIONS(6752),
    [anon_sym_mutable] = ACTIONS(6752),
    [anon_sym_constinit] = ACTIONS(6752),
    [anon_sym_consteval] = ACTIONS(6752),
    [anon_sym_alignas] = ACTIONS(6755),
    [anon_sym__Alignas] = ACTIONS(6755),
    [sym_primitive_type] = ACTIONS(5024),
    [anon_sym_QMARK] = ACTIONS(5026),
    [anon_sym_LT_EQ_GT] = ACTIONS(5026),
    [anon_sym_or] = ACTIONS(5024),
    [anon_sym_and] = ACTIONS(5024),
    [anon_sym_bitor] = ACTIONS(5024),
    [anon_sym_xor] = ACTIONS(5024),
    [anon_sym_bitand] = ACTIONS(5024),
    [anon_sym_not_eq] = ACTIONS(5024),
    [anon_sym_DASH_DASH] = ACTIONS(5026),
    [anon_sym_PLUS_PLUS] = ACTIONS(5026),
    [anon_sym_DOT] = ACTIONS(5024),
    [anon_sym_DOT_STAR] = ACTIONS(5026),
    [anon_sym_DASH_GT] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5024),
    [anon_sym_decltype] = ACTIONS(5024),
    [anon_sym_GT2] = ACTIONS(5026),
  },
  [2708] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [aux_sym_preproc_if_token2] = ACTIONS(5859),
    [aux_sym_preproc_else_token1] = ACTIONS(5859),
    [aux_sym_preproc_elif_token1] = ACTIONS(5857),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5859),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5857),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5857),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5857),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5857),
    [anon_sym_GT_GT] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_EQ] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_STAR_EQ] = ACTIONS(5859),
    [anon_sym_SLASH_EQ] = ACTIONS(5859),
    [anon_sym_PERCENT_EQ] = ACTIONS(5859),
    [anon_sym_PLUS_EQ] = ACTIONS(5859),
    [anon_sym_DASH_EQ] = ACTIONS(5859),
    [anon_sym_LT_LT_EQ] = ACTIONS(5859),
    [anon_sym_GT_GT_EQ] = ACTIONS(5859),
    [anon_sym_AMP_EQ] = ACTIONS(5859),
    [anon_sym_CARET_EQ] = ACTIONS(5859),
    [anon_sym_PIPE_EQ] = ACTIONS(5859),
    [anon_sym_and_eq] = ACTIONS(5857),
    [anon_sym_or_eq] = ACTIONS(5857),
    [anon_sym_xor_eq] = ACTIONS(5857),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5857),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5857),
    [anon_sym_not_eq] = ACTIONS(5857),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
  },
  [2709] = {
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6055),
    [anon_sym_COMMA] = ACTIONS(6055),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [aux_sym_preproc_if_token2] = ACTIONS(6055),
    [aux_sym_preproc_else_token1] = ACTIONS(6055),
    [aux_sym_preproc_elif_token1] = ACTIONS(6053),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6055),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6055),
    [anon_sym_LPAREN2] = ACTIONS(6055),
    [anon_sym_DASH] = ACTIONS(6053),
    [anon_sym_PLUS] = ACTIONS(6053),
    [anon_sym_STAR] = ACTIONS(6053),
    [anon_sym_SLASH] = ACTIONS(6053),
    [anon_sym_PERCENT] = ACTIONS(6053),
    [anon_sym_PIPE_PIPE] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(6055),
    [anon_sym_PIPE] = ACTIONS(6053),
    [anon_sym_CARET] = ACTIONS(6053),
    [anon_sym_AMP] = ACTIONS(6053),
    [anon_sym_EQ_EQ] = ACTIONS(6055),
    [anon_sym_BANG_EQ] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6053),
    [anon_sym_GT_EQ] = ACTIONS(6055),
    [anon_sym_LT_EQ] = ACTIONS(6053),
    [anon_sym_LT] = ACTIONS(6053),
    [anon_sym_LT_LT] = ACTIONS(6053),
    [anon_sym_GT_GT] = ACTIONS(6053),
    [anon_sym_COLON] = ACTIONS(6055),
    [anon_sym_SEMI] = ACTIONS(6055),
    [anon_sym___attribute__] = ACTIONS(6053),
    [anon_sym___attribute] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(6055),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(6055),
    [anon_sym_RBRACK] = ACTIONS(6055),
    [anon_sym_EQ] = ACTIONS(6053),
    [anon_sym_QMARK] = ACTIONS(6055),
    [anon_sym_STAR_EQ] = ACTIONS(6055),
    [anon_sym_SLASH_EQ] = ACTIONS(6055),
    [anon_sym_PERCENT_EQ] = ACTIONS(6055),
    [anon_sym_PLUS_EQ] = ACTIONS(6055),
    [anon_sym_DASH_EQ] = ACTIONS(6055),
    [anon_sym_LT_LT_EQ] = ACTIONS(6055),
    [anon_sym_GT_GT_EQ] = ACTIONS(6055),
    [anon_sym_AMP_EQ] = ACTIONS(6055),
    [anon_sym_CARET_EQ] = ACTIONS(6055),
    [anon_sym_PIPE_EQ] = ACTIONS(6055),
    [anon_sym_and_eq] = ACTIONS(6053),
    [anon_sym_or_eq] = ACTIONS(6053),
    [anon_sym_xor_eq] = ACTIONS(6053),
    [anon_sym_LT_EQ_GT] = ACTIONS(6055),
    [anon_sym_or] = ACTIONS(6053),
    [anon_sym_and] = ACTIONS(6053),
    [anon_sym_bitor] = ACTIONS(6053),
    [anon_sym_xor] = ACTIONS(6053),
    [anon_sym_bitand] = ACTIONS(6053),
    [anon_sym_not_eq] = ACTIONS(6053),
    [anon_sym_DASH_DASH] = ACTIONS(6055),
    [anon_sym_PLUS_PLUS] = ACTIONS(6055),
    [anon_sym_DOT] = ACTIONS(6053),
    [anon_sym_DOT_STAR] = ACTIONS(6055),
    [anon_sym_DASH_GT] = ACTIONS(6055),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6053),
    [anon_sym_decltype] = ACTIONS(6053),
  },
  [2710] = {
    [sym_identifier] = ACTIONS(5997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [aux_sym_preproc_if_token2] = ACTIONS(5999),
    [aux_sym_preproc_else_token1] = ACTIONS(5999),
    [aux_sym_preproc_elif_token1] = ACTIONS(5997),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5999),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5999),
    [anon_sym_LPAREN2] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5997),
    [anon_sym_PLUS] = ACTIONS(5997),
    [anon_sym_STAR] = ACTIONS(5997),
    [anon_sym_SLASH] = ACTIONS(5997),
    [anon_sym_PERCENT] = ACTIONS(5997),
    [anon_sym_PIPE_PIPE] = ACTIONS(5999),
    [anon_sym_AMP_AMP] = ACTIONS(5999),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_CARET] = ACTIONS(5997),
    [anon_sym_AMP] = ACTIONS(5997),
    [anon_sym_EQ_EQ] = ACTIONS(5999),
    [anon_sym_BANG_EQ] = ACTIONS(5999),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_GT_EQ] = ACTIONS(5999),
    [anon_sym_LT_EQ] = ACTIONS(5997),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_LT_LT] = ACTIONS(5997),
    [anon_sym_GT_GT] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5999),
    [anon_sym_SEMI] = ACTIONS(5999),
    [anon_sym___attribute__] = ACTIONS(5997),
    [anon_sym___attribute] = ACTIONS(5997),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5997),
    [anon_sym_QMARK] = ACTIONS(5999),
    [anon_sym_STAR_EQ] = ACTIONS(5999),
    [anon_sym_SLASH_EQ] = ACTIONS(5999),
    [anon_sym_PERCENT_EQ] = ACTIONS(5999),
    [anon_sym_PLUS_EQ] = ACTIONS(5999),
    [anon_sym_DASH_EQ] = ACTIONS(5999),
    [anon_sym_LT_LT_EQ] = ACTIONS(5999),
    [anon_sym_GT_GT_EQ] = ACTIONS(5999),
    [anon_sym_AMP_EQ] = ACTIONS(5999),
    [anon_sym_CARET_EQ] = ACTIONS(5999),
    [anon_sym_PIPE_EQ] = ACTIONS(5999),
    [anon_sym_and_eq] = ACTIONS(5997),
    [anon_sym_or_eq] = ACTIONS(5997),
    [anon_sym_xor_eq] = ACTIONS(5997),
    [anon_sym_LT_EQ_GT] = ACTIONS(5999),
    [anon_sym_or] = ACTIONS(5997),
    [anon_sym_and] = ACTIONS(5997),
    [anon_sym_bitor] = ACTIONS(5997),
    [anon_sym_xor] = ACTIONS(5997),
    [anon_sym_bitand] = ACTIONS(5997),
    [anon_sym_not_eq] = ACTIONS(5997),
    [anon_sym_DASH_DASH] = ACTIONS(5999),
    [anon_sym_PLUS_PLUS] = ACTIONS(5999),
    [anon_sym_DOT] = ACTIONS(5997),
    [anon_sym_DOT_STAR] = ACTIONS(5999),
    [anon_sym_DASH_GT] = ACTIONS(5999),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5997),
    [anon_sym_decltype] = ACTIONS(5997),
  },
  [2711] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5859),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5857),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5859),
    [anon_sym_GT_GT] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym___extension__] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(6758),
    [anon_sym_unsigned] = ACTIONS(6758),
    [anon_sym_long] = ACTIONS(6758),
    [anon_sym_short] = ACTIONS(6758),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5859),
    [anon_sym_volatile] = ACTIONS(5859),
    [anon_sym_restrict] = ACTIONS(5859),
    [anon_sym___restrict__] = ACTIONS(5859),
    [anon_sym__Atomic] = ACTIONS(5859),
    [anon_sym__Noreturn] = ACTIONS(5859),
    [anon_sym_noreturn] = ACTIONS(5859),
    [anon_sym__Nonnull] = ACTIONS(5859),
    [anon_sym_mutable] = ACTIONS(5859),
    [anon_sym_constinit] = ACTIONS(5859),
    [anon_sym_consteval] = ACTIONS(5859),
    [anon_sym_alignas] = ACTIONS(5859),
    [anon_sym__Alignas] = ACTIONS(5859),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5859),
    [anon_sym_and] = ACTIONS(5859),
    [anon_sym_bitor] = ACTIONS(5859),
    [anon_sym_xor] = ACTIONS(5859),
    [anon_sym_bitand] = ACTIONS(5859),
    [anon_sym_not_eq] = ACTIONS(5859),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5859),
    [anon_sym_decltype] = ACTIONS(5859),
    [anon_sym_final] = ACTIONS(5859),
    [anon_sym_override] = ACTIONS(5859),
    [anon_sym_GT2] = ACTIONS(5859),
    [anon_sym_requires] = ACTIONS(5859),
  },
  [2712] = {
    [sym_identifier] = ACTIONS(6760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6762),
    [anon_sym_COMMA] = ACTIONS(6762),
    [anon_sym_RPAREN] = ACTIONS(6762),
    [aux_sym_preproc_if_token2] = ACTIONS(6762),
    [aux_sym_preproc_else_token1] = ACTIONS(6762),
    [aux_sym_preproc_elif_token1] = ACTIONS(6760),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6762),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6762),
    [anon_sym_LPAREN2] = ACTIONS(6762),
    [anon_sym_DASH] = ACTIONS(6760),
    [anon_sym_PLUS] = ACTIONS(6760),
    [anon_sym_STAR] = ACTIONS(6760),
    [anon_sym_SLASH] = ACTIONS(6760),
    [anon_sym_PERCENT] = ACTIONS(6760),
    [anon_sym_PIPE_PIPE] = ACTIONS(6762),
    [anon_sym_AMP_AMP] = ACTIONS(6762),
    [anon_sym_PIPE] = ACTIONS(6760),
    [anon_sym_CARET] = ACTIONS(6760),
    [anon_sym_AMP] = ACTIONS(6760),
    [anon_sym_EQ_EQ] = ACTIONS(6762),
    [anon_sym_BANG_EQ] = ACTIONS(6762),
    [anon_sym_GT] = ACTIONS(6760),
    [anon_sym_GT_EQ] = ACTIONS(6762),
    [anon_sym_LT_EQ] = ACTIONS(6760),
    [anon_sym_LT] = ACTIONS(6760),
    [anon_sym_LT_LT] = ACTIONS(6760),
    [anon_sym_GT_GT] = ACTIONS(6760),
    [anon_sym_COLON] = ACTIONS(6762),
    [anon_sym_SEMI] = ACTIONS(6762),
    [anon_sym___attribute__] = ACTIONS(6760),
    [anon_sym___attribute] = ACTIONS(6760),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6762),
    [anon_sym_LBRACE] = ACTIONS(6762),
    [anon_sym_RBRACE] = ACTIONS(6762),
    [anon_sym_LBRACK] = ACTIONS(6760),
    [anon_sym_RBRACK] = ACTIONS(6762),
    [anon_sym_EQ] = ACTIONS(6760),
    [anon_sym_QMARK] = ACTIONS(6762),
    [anon_sym_STAR_EQ] = ACTIONS(6762),
    [anon_sym_SLASH_EQ] = ACTIONS(6762),
    [anon_sym_PERCENT_EQ] = ACTIONS(6762),
    [anon_sym_PLUS_EQ] = ACTIONS(6762),
    [anon_sym_DASH_EQ] = ACTIONS(6762),
    [anon_sym_LT_LT_EQ] = ACTIONS(6762),
    [anon_sym_GT_GT_EQ] = ACTIONS(6762),
    [anon_sym_AMP_EQ] = ACTIONS(6762),
    [anon_sym_CARET_EQ] = ACTIONS(6762),
    [anon_sym_PIPE_EQ] = ACTIONS(6762),
    [anon_sym_and_eq] = ACTIONS(6760),
    [anon_sym_or_eq] = ACTIONS(6760),
    [anon_sym_xor_eq] = ACTIONS(6760),
    [anon_sym_LT_EQ_GT] = ACTIONS(6762),
    [anon_sym_or] = ACTIONS(6760),
    [anon_sym_and] = ACTIONS(6760),
    [anon_sym_bitor] = ACTIONS(6760),
    [anon_sym_xor] = ACTIONS(6760),
    [anon_sym_bitand] = ACTIONS(6760),
    [anon_sym_not_eq] = ACTIONS(6760),
    [anon_sym_DASH_DASH] = ACTIONS(6762),
    [anon_sym_PLUS_PLUS] = ACTIONS(6762),
    [anon_sym_DOT] = ACTIONS(6760),
    [anon_sym_DOT_STAR] = ACTIONS(6762),
    [anon_sym_DASH_GT] = ACTIONS(6762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6760),
  },
  [2713] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_LPAREN2] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5892),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5892),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5892),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5892),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5890),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5892),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5892),
    [anon_sym___extension__] = ACTIONS(5892),
    [anon_sym___attribute__] = ACTIONS(5892),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_const] = ACTIONS(5890),
    [anon_sym_constexpr] = ACTIONS(5892),
    [anon_sym_volatile] = ACTIONS(5892),
    [anon_sym_restrict] = ACTIONS(5892),
    [anon_sym___restrict__] = ACTIONS(5892),
    [anon_sym__Atomic] = ACTIONS(5892),
    [anon_sym__Noreturn] = ACTIONS(5892),
    [anon_sym_noreturn] = ACTIONS(5892),
    [anon_sym__Nonnull] = ACTIONS(5892),
    [anon_sym_mutable] = ACTIONS(5892),
    [anon_sym_constinit] = ACTIONS(5892),
    [anon_sym_consteval] = ACTIONS(5892),
    [anon_sym_alignas] = ACTIONS(5892),
    [anon_sym__Alignas] = ACTIONS(5892),
    [anon_sym_QMARK] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5892),
    [anon_sym_and] = ACTIONS(5892),
    [anon_sym_bitor] = ACTIONS(5892),
    [anon_sym_xor] = ACTIONS(5892),
    [anon_sym_bitand] = ACTIONS(5892),
    [anon_sym_not_eq] = ACTIONS(5892),
    [anon_sym_DASH_DASH] = ACTIONS(5892),
    [anon_sym_PLUS_PLUS] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5892),
    [anon_sym_decltype] = ACTIONS(5892),
    [anon_sym_final] = ACTIONS(5892),
    [anon_sym_override] = ACTIONS(5892),
    [anon_sym_GT2] = ACTIONS(5892),
    [anon_sym_requires] = ACTIONS(5892),
  },
  [2714] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5913),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym___extension__] = ACTIONS(5915),
    [anon_sym___attribute__] = ACTIONS(5915),
    [anon_sym___attribute] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_const] = ACTIONS(5913),
    [anon_sym_constexpr] = ACTIONS(5915),
    [anon_sym_volatile] = ACTIONS(5915),
    [anon_sym_restrict] = ACTIONS(5915),
    [anon_sym___restrict__] = ACTIONS(5915),
    [anon_sym__Atomic] = ACTIONS(5915),
    [anon_sym__Noreturn] = ACTIONS(5915),
    [anon_sym_noreturn] = ACTIONS(5915),
    [anon_sym__Nonnull] = ACTIONS(5915),
    [anon_sym_mutable] = ACTIONS(5915),
    [anon_sym_constinit] = ACTIONS(5915),
    [anon_sym_consteval] = ACTIONS(5915),
    [anon_sym_alignas] = ACTIONS(5915),
    [anon_sym__Alignas] = ACTIONS(5915),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5915),
    [anon_sym_and] = ACTIONS(5915),
    [anon_sym_bitor] = ACTIONS(5915),
    [anon_sym_xor] = ACTIONS(5915),
    [anon_sym_bitand] = ACTIONS(5915),
    [anon_sym_not_eq] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5915),
    [anon_sym_decltype] = ACTIONS(5915),
    [anon_sym_final] = ACTIONS(5915),
    [anon_sym_override] = ACTIONS(5915),
    [anon_sym_GT2] = ACTIONS(5915),
    [anon_sym_requires] = ACTIONS(5915),
  },
  [2715] = {
    [sym_identifier] = ACTIONS(6091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6093),
    [anon_sym_COMMA] = ACTIONS(6093),
    [anon_sym_RPAREN] = ACTIONS(6093),
    [aux_sym_preproc_if_token2] = ACTIONS(6093),
    [aux_sym_preproc_else_token1] = ACTIONS(6093),
    [aux_sym_preproc_elif_token1] = ACTIONS(6091),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6093),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6093),
    [anon_sym_LPAREN2] = ACTIONS(6093),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_PERCENT] = ACTIONS(6091),
    [anon_sym_PIPE_PIPE] = ACTIONS(6093),
    [anon_sym_AMP_AMP] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_AMP] = ACTIONS(6091),
    [anon_sym_EQ_EQ] = ACTIONS(6093),
    [anon_sym_BANG_EQ] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6091),
    [anon_sym_GT_EQ] = ACTIONS(6093),
    [anon_sym_LT_EQ] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6091),
    [anon_sym_LT_LT] = ACTIONS(6091),
    [anon_sym_GT_GT] = ACTIONS(6091),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SEMI] = ACTIONS(6093),
    [anon_sym___attribute__] = ACTIONS(6091),
    [anon_sym___attribute] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6093),
    [anon_sym_RBRACE] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6093),
    [anon_sym_RBRACK] = ACTIONS(6093),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_QMARK] = ACTIONS(6093),
    [anon_sym_STAR_EQ] = ACTIONS(6093),
    [anon_sym_SLASH_EQ] = ACTIONS(6093),
    [anon_sym_PERCENT_EQ] = ACTIONS(6093),
    [anon_sym_PLUS_EQ] = ACTIONS(6093),
    [anon_sym_DASH_EQ] = ACTIONS(6093),
    [anon_sym_LT_LT_EQ] = ACTIONS(6093),
    [anon_sym_GT_GT_EQ] = ACTIONS(6093),
    [anon_sym_AMP_EQ] = ACTIONS(6093),
    [anon_sym_CARET_EQ] = ACTIONS(6093),
    [anon_sym_PIPE_EQ] = ACTIONS(6093),
    [anon_sym_and_eq] = ACTIONS(6091),
    [anon_sym_or_eq] = ACTIONS(6091),
    [anon_sym_xor_eq] = ACTIONS(6091),
    [anon_sym_LT_EQ_GT] = ACTIONS(6093),
    [anon_sym_or] = ACTIONS(6091),
    [anon_sym_and] = ACTIONS(6091),
    [anon_sym_bitor] = ACTIONS(6091),
    [anon_sym_xor] = ACTIONS(6091),
    [anon_sym_bitand] = ACTIONS(6091),
    [anon_sym_not_eq] = ACTIONS(6091),
    [anon_sym_DASH_DASH] = ACTIONS(6093),
    [anon_sym_PLUS_PLUS] = ACTIONS(6093),
    [anon_sym_DOT] = ACTIONS(6091),
    [anon_sym_DOT_STAR] = ACTIONS(6093),
    [anon_sym_DASH_GT] = ACTIONS(6093),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6091),
    [anon_sym_decltype] = ACTIONS(6091),
  },
  [2716] = {
    [sym_identifier] = ACTIONS(6095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6097),
    [anon_sym_COMMA] = ACTIONS(6097),
    [anon_sym_RPAREN] = ACTIONS(6097),
    [aux_sym_preproc_if_token2] = ACTIONS(6097),
    [aux_sym_preproc_else_token1] = ACTIONS(6097),
    [aux_sym_preproc_elif_token1] = ACTIONS(6095),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6097),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6097),
    [anon_sym_LPAREN2] = ACTIONS(6097),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_PERCENT] = ACTIONS(6095),
    [anon_sym_PIPE_PIPE] = ACTIONS(6097),
    [anon_sym_AMP_AMP] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_AMP] = ACTIONS(6095),
    [anon_sym_EQ_EQ] = ACTIONS(6097),
    [anon_sym_BANG_EQ] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6095),
    [anon_sym_GT_EQ] = ACTIONS(6097),
    [anon_sym_LT_EQ] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6095),
    [anon_sym_LT_LT] = ACTIONS(6095),
    [anon_sym_GT_GT] = ACTIONS(6095),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SEMI] = ACTIONS(6097),
    [anon_sym___attribute__] = ACTIONS(6095),
    [anon_sym___attribute] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6097),
    [anon_sym_RBRACE] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6097),
    [anon_sym_RBRACK] = ACTIONS(6097),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_QMARK] = ACTIONS(6097),
    [anon_sym_STAR_EQ] = ACTIONS(6097),
    [anon_sym_SLASH_EQ] = ACTIONS(6097),
    [anon_sym_PERCENT_EQ] = ACTIONS(6097),
    [anon_sym_PLUS_EQ] = ACTIONS(6097),
    [anon_sym_DASH_EQ] = ACTIONS(6097),
    [anon_sym_LT_LT_EQ] = ACTIONS(6097),
    [anon_sym_GT_GT_EQ] = ACTIONS(6097),
    [anon_sym_AMP_EQ] = ACTIONS(6097),
    [anon_sym_CARET_EQ] = ACTIONS(6097),
    [anon_sym_PIPE_EQ] = ACTIONS(6097),
    [anon_sym_and_eq] = ACTIONS(6095),
    [anon_sym_or_eq] = ACTIONS(6095),
    [anon_sym_xor_eq] = ACTIONS(6095),
    [anon_sym_LT_EQ_GT] = ACTIONS(6097),
    [anon_sym_or] = ACTIONS(6095),
    [anon_sym_and] = ACTIONS(6095),
    [anon_sym_bitor] = ACTIONS(6095),
    [anon_sym_xor] = ACTIONS(6095),
    [anon_sym_bitand] = ACTIONS(6095),
    [anon_sym_not_eq] = ACTIONS(6095),
    [anon_sym_DASH_DASH] = ACTIONS(6097),
    [anon_sym_PLUS_PLUS] = ACTIONS(6097),
    [anon_sym_DOT] = ACTIONS(6095),
    [anon_sym_DOT_STAR] = ACTIONS(6097),
    [anon_sym_DASH_GT] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6095),
    [anon_sym_decltype] = ACTIONS(6095),
  },
  [2717] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6394),
    [anon_sym_COMMA] = ACTIONS(6394),
    [anon_sym_RPAREN] = ACTIONS(6394),
    [anon_sym_LPAREN2] = ACTIONS(6394),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_PERCENT] = ACTIONS(6392),
    [anon_sym_PIPE_PIPE] = ACTIONS(6394),
    [anon_sym_AMP_AMP] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_EQ_EQ] = ACTIONS(6394),
    [anon_sym_BANG_EQ] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6392),
    [anon_sym_GT_EQ] = ACTIONS(6394),
    [anon_sym_LT_EQ] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6392),
    [anon_sym_LT_LT] = ACTIONS(6392),
    [anon_sym_GT_GT] = ACTIONS(6392),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SEMI] = ACTIONS(6394),
    [anon_sym_RBRACE] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6394),
    [anon_sym_RBRACK] = ACTIONS(6394),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_QMARK] = ACTIONS(6394),
    [anon_sym_STAR_EQ] = ACTIONS(6394),
    [anon_sym_SLASH_EQ] = ACTIONS(6394),
    [anon_sym_PERCENT_EQ] = ACTIONS(6394),
    [anon_sym_PLUS_EQ] = ACTIONS(6394),
    [anon_sym_DASH_EQ] = ACTIONS(6394),
    [anon_sym_LT_LT_EQ] = ACTIONS(6394),
    [anon_sym_GT_GT_EQ] = ACTIONS(6394),
    [anon_sym_AMP_EQ] = ACTIONS(6394),
    [anon_sym_CARET_EQ] = ACTIONS(6394),
    [anon_sym_PIPE_EQ] = ACTIONS(6394),
    [anon_sym_and_eq] = ACTIONS(6392),
    [anon_sym_or_eq] = ACTIONS(6392),
    [anon_sym_xor_eq] = ACTIONS(6392),
    [anon_sym_LT_EQ_GT] = ACTIONS(6394),
    [anon_sym_or] = ACTIONS(6392),
    [anon_sym_and] = ACTIONS(6392),
    [anon_sym_bitor] = ACTIONS(6392),
    [anon_sym_xor] = ACTIONS(6392),
    [anon_sym_bitand] = ACTIONS(6392),
    [anon_sym_not_eq] = ACTIONS(6392),
    [anon_sym_DASH_DASH] = ACTIONS(6394),
    [anon_sym_PLUS_PLUS] = ACTIONS(6394),
    [anon_sym_DOT] = ACTIONS(6392),
    [anon_sym_DOT_STAR] = ACTIONS(6394),
    [anon_sym_DASH_GT] = ACTIONS(6394),
    [anon_sym_L_DQUOTE] = ACTIONS(6394),
    [anon_sym_u_DQUOTE] = ACTIONS(6394),
    [anon_sym_U_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8_DQUOTE] = ACTIONS(6394),
    [anon_sym_DQUOTE] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6394),
    [anon_sym_LR_DQUOTE] = ACTIONS(6394),
    [anon_sym_uR_DQUOTE] = ACTIONS(6394),
    [anon_sym_UR_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6394),
    [sym_literal_suffix] = ACTIONS(6392),
  },
  [2718] = {
    [sym_identifier] = ACTIONS(6766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6768),
    [anon_sym_COMMA] = ACTIONS(6768),
    [anon_sym_RPAREN] = ACTIONS(6768),
    [aux_sym_preproc_if_token2] = ACTIONS(6768),
    [aux_sym_preproc_else_token1] = ACTIONS(6768),
    [aux_sym_preproc_elif_token1] = ACTIONS(6766),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6768),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6768),
    [anon_sym_LPAREN2] = ACTIONS(6768),
    [anon_sym_DASH] = ACTIONS(6766),
    [anon_sym_PLUS] = ACTIONS(6766),
    [anon_sym_STAR] = ACTIONS(6766),
    [anon_sym_SLASH] = ACTIONS(6766),
    [anon_sym_PERCENT] = ACTIONS(6766),
    [anon_sym_PIPE_PIPE] = ACTIONS(6768),
    [anon_sym_AMP_AMP] = ACTIONS(6768),
    [anon_sym_PIPE] = ACTIONS(6766),
    [anon_sym_CARET] = ACTIONS(6766),
    [anon_sym_AMP] = ACTIONS(6766),
    [anon_sym_EQ_EQ] = ACTIONS(6768),
    [anon_sym_BANG_EQ] = ACTIONS(6768),
    [anon_sym_GT] = ACTIONS(6766),
    [anon_sym_GT_EQ] = ACTIONS(6768),
    [anon_sym_LT_EQ] = ACTIONS(6766),
    [anon_sym_LT] = ACTIONS(6766),
    [anon_sym_LT_LT] = ACTIONS(6766),
    [anon_sym_GT_GT] = ACTIONS(6766),
    [anon_sym_COLON] = ACTIONS(6768),
    [anon_sym_SEMI] = ACTIONS(6768),
    [anon_sym___attribute__] = ACTIONS(6766),
    [anon_sym___attribute] = ACTIONS(6766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6768),
    [anon_sym_LBRACE] = ACTIONS(6768),
    [anon_sym_RBRACE] = ACTIONS(6768),
    [anon_sym_LBRACK] = ACTIONS(6766),
    [anon_sym_RBRACK] = ACTIONS(6768),
    [anon_sym_EQ] = ACTIONS(6766),
    [anon_sym_QMARK] = ACTIONS(6768),
    [anon_sym_STAR_EQ] = ACTIONS(6768),
    [anon_sym_SLASH_EQ] = ACTIONS(6768),
    [anon_sym_PERCENT_EQ] = ACTIONS(6768),
    [anon_sym_PLUS_EQ] = ACTIONS(6768),
    [anon_sym_DASH_EQ] = ACTIONS(6768),
    [anon_sym_LT_LT_EQ] = ACTIONS(6768),
    [anon_sym_GT_GT_EQ] = ACTIONS(6768),
    [anon_sym_AMP_EQ] = ACTIONS(6768),
    [anon_sym_CARET_EQ] = ACTIONS(6768),
    [anon_sym_PIPE_EQ] = ACTIONS(6768),
    [anon_sym_and_eq] = ACTIONS(6766),
    [anon_sym_or_eq] = ACTIONS(6766),
    [anon_sym_xor_eq] = ACTIONS(6766),
    [anon_sym_LT_EQ_GT] = ACTIONS(6768),
    [anon_sym_or] = ACTIONS(6766),
    [anon_sym_and] = ACTIONS(6766),
    [anon_sym_bitor] = ACTIONS(6766),
    [anon_sym_xor] = ACTIONS(6766),
    [anon_sym_bitand] = ACTIONS(6766),
    [anon_sym_not_eq] = ACTIONS(6766),
    [anon_sym_DASH_DASH] = ACTIONS(6768),
    [anon_sym_PLUS_PLUS] = ACTIONS(6768),
    [anon_sym_DOT] = ACTIONS(6766),
    [anon_sym_DOT_STAR] = ACTIONS(6768),
    [anon_sym_DASH_GT] = ACTIONS(6768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6766),
  },
  [2719] = {
    [sym_identifier] = ACTIONS(6037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [aux_sym_preproc_if_token2] = ACTIONS(6039),
    [aux_sym_preproc_else_token1] = ACTIONS(6039),
    [aux_sym_preproc_elif_token1] = ACTIONS(6037),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6039),
    [anon_sym_LPAREN2] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6037),
    [anon_sym_PLUS] = ACTIONS(6037),
    [anon_sym_STAR] = ACTIONS(6037),
    [anon_sym_SLASH] = ACTIONS(6037),
    [anon_sym_PERCENT] = ACTIONS(6037),
    [anon_sym_PIPE_PIPE] = ACTIONS(6039),
    [anon_sym_AMP_AMP] = ACTIONS(6039),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_CARET] = ACTIONS(6037),
    [anon_sym_AMP] = ACTIONS(6037),
    [anon_sym_EQ_EQ] = ACTIONS(6039),
    [anon_sym_BANG_EQ] = ACTIONS(6039),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_GT_EQ] = ACTIONS(6039),
    [anon_sym_LT_EQ] = ACTIONS(6037),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6037),
    [anon_sym_GT_GT] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6039),
    [anon_sym_SEMI] = ACTIONS(6039),
    [anon_sym___attribute__] = ACTIONS(6037),
    [anon_sym___attribute] = ACTIONS(6037),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6037),
    [anon_sym_QMARK] = ACTIONS(6039),
    [anon_sym_STAR_EQ] = ACTIONS(6039),
    [anon_sym_SLASH_EQ] = ACTIONS(6039),
    [anon_sym_PERCENT_EQ] = ACTIONS(6039),
    [anon_sym_PLUS_EQ] = ACTIONS(6039),
    [anon_sym_DASH_EQ] = ACTIONS(6039),
    [anon_sym_LT_LT_EQ] = ACTIONS(6039),
    [anon_sym_GT_GT_EQ] = ACTIONS(6039),
    [anon_sym_AMP_EQ] = ACTIONS(6039),
    [anon_sym_CARET_EQ] = ACTIONS(6039),
    [anon_sym_PIPE_EQ] = ACTIONS(6039),
    [anon_sym_and_eq] = ACTIONS(6037),
    [anon_sym_or_eq] = ACTIONS(6037),
    [anon_sym_xor_eq] = ACTIONS(6037),
    [anon_sym_LT_EQ_GT] = ACTIONS(6039),
    [anon_sym_or] = ACTIONS(6037),
    [anon_sym_and] = ACTIONS(6037),
    [anon_sym_bitor] = ACTIONS(6037),
    [anon_sym_xor] = ACTIONS(6037),
    [anon_sym_bitand] = ACTIONS(6037),
    [anon_sym_not_eq] = ACTIONS(6037),
    [anon_sym_DASH_DASH] = ACTIONS(6039),
    [anon_sym_PLUS_PLUS] = ACTIONS(6039),
    [anon_sym_DOT] = ACTIONS(6037),
    [anon_sym_DOT_STAR] = ACTIONS(6039),
    [anon_sym_DASH_GT] = ACTIONS(6039),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6037),
    [anon_sym_decltype] = ACTIONS(6037),
  },
  [2720] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5743),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5745),
    [anon_sym_COMMA] = ACTIONS(5745),
    [aux_sym_preproc_if_token2] = ACTIONS(5745),
    [aux_sym_preproc_else_token1] = ACTIONS(5745),
    [aux_sym_preproc_elif_token1] = ACTIONS(5743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5745),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5745),
    [anon_sym_LPAREN2] = ACTIONS(5745),
    [anon_sym_DASH] = ACTIONS(5743),
    [anon_sym_PLUS] = ACTIONS(5743),
    [anon_sym_STAR] = ACTIONS(5743),
    [anon_sym_SLASH] = ACTIONS(5743),
    [anon_sym_PERCENT] = ACTIONS(5743),
    [anon_sym_PIPE_PIPE] = ACTIONS(5745),
    [anon_sym_AMP_AMP] = ACTIONS(5745),
    [anon_sym_PIPE] = ACTIONS(5743),
    [anon_sym_CARET] = ACTIONS(5743),
    [anon_sym_AMP] = ACTIONS(5743),
    [anon_sym_EQ_EQ] = ACTIONS(5745),
    [anon_sym_BANG_EQ] = ACTIONS(5745),
    [anon_sym_GT] = ACTIONS(5743),
    [anon_sym_GT_EQ] = ACTIONS(5745),
    [anon_sym_LT_EQ] = ACTIONS(5743),
    [anon_sym_LT] = ACTIONS(5743),
    [anon_sym_LT_LT] = ACTIONS(5743),
    [anon_sym_GT_GT] = ACTIONS(5743),
    [anon_sym___attribute__] = ACTIONS(5743),
    [anon_sym___attribute] = ACTIONS(5743),
    [anon_sym_LBRACE] = ACTIONS(5745),
    [anon_sym_signed] = ACTIONS(6770),
    [anon_sym_unsigned] = ACTIONS(6770),
    [anon_sym_long] = ACTIONS(6770),
    [anon_sym_short] = ACTIONS(6770),
    [anon_sym_LBRACK] = ACTIONS(5745),
    [anon_sym_EQ] = ACTIONS(5743),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_STAR_EQ] = ACTIONS(5745),
    [anon_sym_SLASH_EQ] = ACTIONS(5745),
    [anon_sym_PERCENT_EQ] = ACTIONS(5745),
    [anon_sym_PLUS_EQ] = ACTIONS(5745),
    [anon_sym_DASH_EQ] = ACTIONS(5745),
    [anon_sym_LT_LT_EQ] = ACTIONS(5745),
    [anon_sym_GT_GT_EQ] = ACTIONS(5745),
    [anon_sym_AMP_EQ] = ACTIONS(5745),
    [anon_sym_CARET_EQ] = ACTIONS(5745),
    [anon_sym_PIPE_EQ] = ACTIONS(5745),
    [anon_sym_and_eq] = ACTIONS(5743),
    [anon_sym_or_eq] = ACTIONS(5743),
    [anon_sym_xor_eq] = ACTIONS(5743),
    [anon_sym_LT_EQ_GT] = ACTIONS(5745),
    [anon_sym_or] = ACTIONS(5743),
    [anon_sym_and] = ACTIONS(5743),
    [anon_sym_bitor] = ACTIONS(5743),
    [anon_sym_xor] = ACTIONS(5743),
    [anon_sym_bitand] = ACTIONS(5743),
    [anon_sym_not_eq] = ACTIONS(5743),
    [anon_sym_DASH_DASH] = ACTIONS(5745),
    [anon_sym_PLUS_PLUS] = ACTIONS(5745),
    [anon_sym_DOT] = ACTIONS(5743),
    [anon_sym_DOT_STAR] = ACTIONS(5745),
    [anon_sym_DASH_GT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5743),
    [anon_sym_decltype] = ACTIONS(5743),
  },
  [2721] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_DASH] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5941),
    [anon_sym_SLASH] = ACTIONS(5939),
    [anon_sym_PERCENT] = ACTIONS(5941),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_PIPE] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5941),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5939),
    [anon_sym_GT_EQ] = ACTIONS(5939),
    [anon_sym_LT_EQ] = ACTIONS(5939),
    [anon_sym_LT] = ACTIONS(5939),
    [anon_sym_LT_LT] = ACTIONS(5941),
    [anon_sym_GT_GT] = ACTIONS(5939),
    [anon_sym_COLON] = ACTIONS(5941),
    [anon_sym___extension__] = ACTIONS(5941),
    [anon_sym___attribute__] = ACTIONS(5941),
    [anon_sym___attribute] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(6773),
    [anon_sym_unsigned] = ACTIONS(6773),
    [anon_sym_long] = ACTIONS(6773),
    [anon_sym_short] = ACTIONS(6773),
    [anon_sym_LBRACK] = ACTIONS(5941),
    [anon_sym_const] = ACTIONS(5939),
    [anon_sym_constexpr] = ACTIONS(5941),
    [anon_sym_volatile] = ACTIONS(5941),
    [anon_sym_restrict] = ACTIONS(5941),
    [anon_sym___restrict__] = ACTIONS(5941),
    [anon_sym__Atomic] = ACTIONS(5941),
    [anon_sym__Noreturn] = ACTIONS(5941),
    [anon_sym_noreturn] = ACTIONS(5941),
    [anon_sym__Nonnull] = ACTIONS(5941),
    [anon_sym_mutable] = ACTIONS(5941),
    [anon_sym_constinit] = ACTIONS(5941),
    [anon_sym_consteval] = ACTIONS(5941),
    [anon_sym_alignas] = ACTIONS(5941),
    [anon_sym__Alignas] = ACTIONS(5941),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5941),
    [anon_sym_and] = ACTIONS(5941),
    [anon_sym_bitor] = ACTIONS(5941),
    [anon_sym_xor] = ACTIONS(5941),
    [anon_sym_bitand] = ACTIONS(5941),
    [anon_sym_not_eq] = ACTIONS(5941),
    [anon_sym_DASH_DASH] = ACTIONS(5941),
    [anon_sym_PLUS_PLUS] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_DOT_STAR] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5941),
    [anon_sym_decltype] = ACTIONS(5941),
    [anon_sym_final] = ACTIONS(5941),
    [anon_sym_override] = ACTIONS(5941),
    [anon_sym_GT2] = ACTIONS(5941),
    [anon_sym_requires] = ACTIONS(5941),
  },
  [2722] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2733),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5898),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5898),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5898),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5896),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5898),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym___extension__] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6775),
    [anon_sym_unsigned] = ACTIONS(6775),
    [anon_sym_long] = ACTIONS(6775),
    [anon_sym_short] = ACTIONS(6775),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_const] = ACTIONS(5896),
    [anon_sym_constexpr] = ACTIONS(5898),
    [anon_sym_volatile] = ACTIONS(5898),
    [anon_sym_restrict] = ACTIONS(5898),
    [anon_sym___restrict__] = ACTIONS(5898),
    [anon_sym__Atomic] = ACTIONS(5898),
    [anon_sym__Noreturn] = ACTIONS(5898),
    [anon_sym_noreturn] = ACTIONS(5898),
    [anon_sym__Nonnull] = ACTIONS(5898),
    [anon_sym_mutable] = ACTIONS(5898),
    [anon_sym_constinit] = ACTIONS(5898),
    [anon_sym_consteval] = ACTIONS(5898),
    [anon_sym_alignas] = ACTIONS(5898),
    [anon_sym__Alignas] = ACTIONS(5898),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5898),
    [anon_sym_and] = ACTIONS(5898),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5898),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
    [anon_sym_final] = ACTIONS(5898),
    [anon_sym_override] = ACTIONS(5898),
    [anon_sym_GT2] = ACTIONS(5898),
    [anon_sym_requires] = ACTIONS(5898),
  },
  [2723] = {
    [sym_identifier] = ACTIONS(6137),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6139),
    [anon_sym_COMMA] = ACTIONS(6139),
    [anon_sym_RPAREN] = ACTIONS(6139),
    [aux_sym_preproc_if_token2] = ACTIONS(6139),
    [aux_sym_preproc_else_token1] = ACTIONS(6139),
    [aux_sym_preproc_elif_token1] = ACTIONS(6137),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6139),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6139),
    [anon_sym_LPAREN2] = ACTIONS(6139),
    [anon_sym_DASH] = ACTIONS(6137),
    [anon_sym_PLUS] = ACTIONS(6137),
    [anon_sym_STAR] = ACTIONS(6137),
    [anon_sym_SLASH] = ACTIONS(6137),
    [anon_sym_PERCENT] = ACTIONS(6137),
    [anon_sym_PIPE_PIPE] = ACTIONS(6139),
    [anon_sym_AMP_AMP] = ACTIONS(6139),
    [anon_sym_PIPE] = ACTIONS(6137),
    [anon_sym_CARET] = ACTIONS(6137),
    [anon_sym_AMP] = ACTIONS(6137),
    [anon_sym_EQ_EQ] = ACTIONS(6139),
    [anon_sym_BANG_EQ] = ACTIONS(6139),
    [anon_sym_GT] = ACTIONS(6137),
    [anon_sym_GT_EQ] = ACTIONS(6139),
    [anon_sym_LT_EQ] = ACTIONS(6137),
    [anon_sym_LT] = ACTIONS(6137),
    [anon_sym_LT_LT] = ACTIONS(6137),
    [anon_sym_GT_GT] = ACTIONS(6137),
    [anon_sym_COLON] = ACTIONS(6139),
    [anon_sym_SEMI] = ACTIONS(6139),
    [anon_sym___attribute__] = ACTIONS(6137),
    [anon_sym___attribute] = ACTIONS(6137),
    [anon_sym_LBRACE] = ACTIONS(6139),
    [anon_sym_RBRACE] = ACTIONS(6139),
    [anon_sym_LBRACK] = ACTIONS(6139),
    [anon_sym_RBRACK] = ACTIONS(6139),
    [anon_sym_EQ] = ACTIONS(6137),
    [anon_sym_QMARK] = ACTIONS(6139),
    [anon_sym_STAR_EQ] = ACTIONS(6139),
    [anon_sym_SLASH_EQ] = ACTIONS(6139),
    [anon_sym_PERCENT_EQ] = ACTIONS(6139),
    [anon_sym_PLUS_EQ] = ACTIONS(6139),
    [anon_sym_DASH_EQ] = ACTIONS(6139),
    [anon_sym_LT_LT_EQ] = ACTIONS(6139),
    [anon_sym_GT_GT_EQ] = ACTIONS(6139),
    [anon_sym_AMP_EQ] = ACTIONS(6139),
    [anon_sym_CARET_EQ] = ACTIONS(6139),
    [anon_sym_PIPE_EQ] = ACTIONS(6139),
    [anon_sym_and_eq] = ACTIONS(6137),
    [anon_sym_or_eq] = ACTIONS(6137),
    [anon_sym_xor_eq] = ACTIONS(6137),
    [anon_sym_LT_EQ_GT] = ACTIONS(6139),
    [anon_sym_or] = ACTIONS(6137),
    [anon_sym_and] = ACTIONS(6137),
    [anon_sym_bitor] = ACTIONS(6137),
    [anon_sym_xor] = ACTIONS(6137),
    [anon_sym_bitand] = ACTIONS(6137),
    [anon_sym_not_eq] = ACTIONS(6137),
    [anon_sym_DASH_DASH] = ACTIONS(6139),
    [anon_sym_PLUS_PLUS] = ACTIONS(6139),
    [anon_sym_DOT] = ACTIONS(6137),
    [anon_sym_DOT_STAR] = ACTIONS(6139),
    [anon_sym_DASH_GT] = ACTIONS(6139),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6137),
    [anon_sym_decltype] = ACTIONS(6137),
  },
  [2724] = {
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6131),
    [anon_sym_COMMA] = ACTIONS(6131),
    [anon_sym_RPAREN] = ACTIONS(6131),
    [aux_sym_preproc_if_token2] = ACTIONS(6131),
    [aux_sym_preproc_else_token1] = ACTIONS(6131),
    [aux_sym_preproc_elif_token1] = ACTIONS(6129),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6131),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6131),
    [anon_sym_LPAREN2] = ACTIONS(6131),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_PERCENT] = ACTIONS(6129),
    [anon_sym_PIPE_PIPE] = ACTIONS(6131),
    [anon_sym_AMP_AMP] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_AMP] = ACTIONS(6129),
    [anon_sym_EQ_EQ] = ACTIONS(6131),
    [anon_sym_BANG_EQ] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6129),
    [anon_sym_GT_EQ] = ACTIONS(6131),
    [anon_sym_LT_EQ] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6129),
    [anon_sym_LT_LT] = ACTIONS(6129),
    [anon_sym_GT_GT] = ACTIONS(6129),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SEMI] = ACTIONS(6131),
    [anon_sym___attribute__] = ACTIONS(6129),
    [anon_sym___attribute] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(6131),
    [anon_sym_RBRACE] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6131),
    [anon_sym_RBRACK] = ACTIONS(6131),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_QMARK] = ACTIONS(6131),
    [anon_sym_STAR_EQ] = ACTIONS(6131),
    [anon_sym_SLASH_EQ] = ACTIONS(6131),
    [anon_sym_PERCENT_EQ] = ACTIONS(6131),
    [anon_sym_PLUS_EQ] = ACTIONS(6131),
    [anon_sym_DASH_EQ] = ACTIONS(6131),
    [anon_sym_LT_LT_EQ] = ACTIONS(6131),
    [anon_sym_GT_GT_EQ] = ACTIONS(6131),
    [anon_sym_AMP_EQ] = ACTIONS(6131),
    [anon_sym_CARET_EQ] = ACTIONS(6131),
    [anon_sym_PIPE_EQ] = ACTIONS(6131),
    [anon_sym_and_eq] = ACTIONS(6129),
    [anon_sym_or_eq] = ACTIONS(6129),
    [anon_sym_xor_eq] = ACTIONS(6129),
    [anon_sym_LT_EQ_GT] = ACTIONS(6131),
    [anon_sym_or] = ACTIONS(6129),
    [anon_sym_and] = ACTIONS(6129),
    [anon_sym_bitor] = ACTIONS(6129),
    [anon_sym_xor] = ACTIONS(6129),
    [anon_sym_bitand] = ACTIONS(6129),
    [anon_sym_not_eq] = ACTIONS(6129),
    [anon_sym_DASH_DASH] = ACTIONS(6131),
    [anon_sym_PLUS_PLUS] = ACTIONS(6131),
    [anon_sym_DOT] = ACTIONS(6129),
    [anon_sym_DOT_STAR] = ACTIONS(6131),
    [anon_sym_DASH_GT] = ACTIONS(6131),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6129),
    [anon_sym_decltype] = ACTIONS(6129),
  },
  [2725] = {
    [sym_identifier] = ACTIONS(5989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5991),
    [anon_sym_COMMA] = ACTIONS(5991),
    [anon_sym_RPAREN] = ACTIONS(5991),
    [aux_sym_preproc_if_token2] = ACTIONS(5991),
    [aux_sym_preproc_else_token1] = ACTIONS(5991),
    [aux_sym_preproc_elif_token1] = ACTIONS(5989),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5991),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5991),
    [anon_sym_LPAREN2] = ACTIONS(5991),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_PERCENT] = ACTIONS(5989),
    [anon_sym_PIPE_PIPE] = ACTIONS(5991),
    [anon_sym_AMP_AMP] = ACTIONS(5991),
    [anon_sym_PIPE] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_AMP] = ACTIONS(5989),
    [anon_sym_EQ_EQ] = ACTIONS(5991),
    [anon_sym_BANG_EQ] = ACTIONS(5991),
    [anon_sym_GT] = ACTIONS(5989),
    [anon_sym_GT_EQ] = ACTIONS(5991),
    [anon_sym_LT_EQ] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5989),
    [anon_sym_LT_LT] = ACTIONS(5989),
    [anon_sym_GT_GT] = ACTIONS(5989),
    [anon_sym_COLON] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(5991),
    [anon_sym___attribute__] = ACTIONS(5989),
    [anon_sym___attribute] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5991),
    [anon_sym_RBRACE] = ACTIONS(5991),
    [anon_sym_LBRACK] = ACTIONS(5991),
    [anon_sym_RBRACK] = ACTIONS(5991),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_QMARK] = ACTIONS(5991),
    [anon_sym_STAR_EQ] = ACTIONS(5991),
    [anon_sym_SLASH_EQ] = ACTIONS(5991),
    [anon_sym_PERCENT_EQ] = ACTIONS(5991),
    [anon_sym_PLUS_EQ] = ACTIONS(5991),
    [anon_sym_DASH_EQ] = ACTIONS(5991),
    [anon_sym_LT_LT_EQ] = ACTIONS(5991),
    [anon_sym_GT_GT_EQ] = ACTIONS(5991),
    [anon_sym_AMP_EQ] = ACTIONS(5991),
    [anon_sym_CARET_EQ] = ACTIONS(5991),
    [anon_sym_PIPE_EQ] = ACTIONS(5991),
    [anon_sym_and_eq] = ACTIONS(5989),
    [anon_sym_or_eq] = ACTIONS(5989),
    [anon_sym_xor_eq] = ACTIONS(5989),
    [anon_sym_LT_EQ_GT] = ACTIONS(5991),
    [anon_sym_or] = ACTIONS(5989),
    [anon_sym_and] = ACTIONS(5989),
    [anon_sym_bitor] = ACTIONS(5989),
    [anon_sym_xor] = ACTIONS(5989),
    [anon_sym_bitand] = ACTIONS(5989),
    [anon_sym_not_eq] = ACTIONS(5989),
    [anon_sym_DASH_DASH] = ACTIONS(5991),
    [anon_sym_PLUS_PLUS] = ACTIONS(5991),
    [anon_sym_DOT] = ACTIONS(5989),
    [anon_sym_DOT_STAR] = ACTIONS(5991),
    [anon_sym_DASH_GT] = ACTIONS(5991),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5989),
    [anon_sym_decltype] = ACTIONS(5989),
  },
  [2726] = {
    [sym_string_literal] = STATE(2779),
    [sym_template_argument_list] = STATE(3526),
    [sym_raw_string_literal] = STATE(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4225),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6777),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4225),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(6780),
    [anon_sym_u_DQUOTE] = ACTIONS(6780),
    [anon_sym_U_DQUOTE] = ACTIONS(6780),
    [anon_sym_u8_DQUOTE] = ACTIONS(6780),
    [anon_sym_DQUOTE] = ACTIONS(6780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4217),
    [anon_sym_R_DQUOTE] = ACTIONS(6782),
    [anon_sym_LR_DQUOTE] = ACTIONS(6782),
    [anon_sym_uR_DQUOTE] = ACTIONS(6782),
    [anon_sym_UR_DQUOTE] = ACTIONS(6782),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6782),
  },
  [2727] = {
    [sym_identifier] = ACTIONS(6019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6021),
    [anon_sym_COMMA] = ACTIONS(6021),
    [anon_sym_RPAREN] = ACTIONS(6021),
    [aux_sym_preproc_if_token2] = ACTIONS(6021),
    [aux_sym_preproc_else_token1] = ACTIONS(6021),
    [aux_sym_preproc_elif_token1] = ACTIONS(6019),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6021),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6021),
    [anon_sym_LPAREN2] = ACTIONS(6021),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_PERCENT] = ACTIONS(6019),
    [anon_sym_PIPE_PIPE] = ACTIONS(6021),
    [anon_sym_AMP_AMP] = ACTIONS(6021),
    [anon_sym_PIPE] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_AMP] = ACTIONS(6019),
    [anon_sym_EQ_EQ] = ACTIONS(6021),
    [anon_sym_BANG_EQ] = ACTIONS(6021),
    [anon_sym_GT] = ACTIONS(6019),
    [anon_sym_GT_EQ] = ACTIONS(6021),
    [anon_sym_LT_EQ] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6019),
    [anon_sym_LT_LT] = ACTIONS(6019),
    [anon_sym_GT_GT] = ACTIONS(6019),
    [anon_sym_COLON] = ACTIONS(6021),
    [anon_sym_SEMI] = ACTIONS(6021),
    [anon_sym___attribute__] = ACTIONS(6019),
    [anon_sym___attribute] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6021),
    [anon_sym_RBRACE] = ACTIONS(6021),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_RBRACK] = ACTIONS(6021),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_QMARK] = ACTIONS(6021),
    [anon_sym_STAR_EQ] = ACTIONS(6021),
    [anon_sym_SLASH_EQ] = ACTIONS(6021),
    [anon_sym_PERCENT_EQ] = ACTIONS(6021),
    [anon_sym_PLUS_EQ] = ACTIONS(6021),
    [anon_sym_DASH_EQ] = ACTIONS(6021),
    [anon_sym_LT_LT_EQ] = ACTIONS(6021),
    [anon_sym_GT_GT_EQ] = ACTIONS(6021),
    [anon_sym_AMP_EQ] = ACTIONS(6021),
    [anon_sym_CARET_EQ] = ACTIONS(6021),
    [anon_sym_PIPE_EQ] = ACTIONS(6021),
    [anon_sym_and_eq] = ACTIONS(6019),
    [anon_sym_or_eq] = ACTIONS(6019),
    [anon_sym_xor_eq] = ACTIONS(6019),
    [anon_sym_LT_EQ_GT] = ACTIONS(6021),
    [anon_sym_or] = ACTIONS(6019),
    [anon_sym_and] = ACTIONS(6019),
    [anon_sym_bitor] = ACTIONS(6019),
    [anon_sym_xor] = ACTIONS(6019),
    [anon_sym_bitand] = ACTIONS(6019),
    [anon_sym_not_eq] = ACTIONS(6019),
    [anon_sym_DASH_DASH] = ACTIONS(6021),
    [anon_sym_PLUS_PLUS] = ACTIONS(6021),
    [anon_sym_DOT] = ACTIONS(6019),
    [anon_sym_DOT_STAR] = ACTIONS(6021),
    [anon_sym_DASH_GT] = ACTIONS(6021),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6019),
    [anon_sym_decltype] = ACTIONS(6019),
  },
  [2728] = {
    [sym_attribute_specifier] = STATE(2561),
    [sym_enumerator_list] = STATE(2824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6085),
    [anon_sym_COMMA] = ACTIONS(6085),
    [anon_sym_RPAREN] = ACTIONS(6085),
    [anon_sym_LPAREN2] = ACTIONS(6085),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6085),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_PERCENT] = ACTIONS(6085),
    [anon_sym_PIPE_PIPE] = ACTIONS(6085),
    [anon_sym_AMP_AMP] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6085),
    [anon_sym_AMP] = ACTIONS(6083),
    [anon_sym_EQ_EQ] = ACTIONS(6085),
    [anon_sym_BANG_EQ] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6083),
    [anon_sym_GT_EQ] = ACTIONS(6085),
    [anon_sym_LT_EQ] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6083),
    [anon_sym_LT_LT] = ACTIONS(6085),
    [anon_sym_GT_GT] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SEMI] = ACTIONS(6085),
    [anon_sym___extension__] = ACTIONS(6085),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6784),
    [anon_sym_RBRACE] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6085),
    [anon_sym_RBRACK] = ACTIONS(6085),
    [anon_sym_const] = ACTIONS(6083),
    [anon_sym_constexpr] = ACTIONS(6085),
    [anon_sym_volatile] = ACTIONS(6085),
    [anon_sym_restrict] = ACTIONS(6085),
    [anon_sym___restrict__] = ACTIONS(6085),
    [anon_sym__Atomic] = ACTIONS(6085),
    [anon_sym__Noreturn] = ACTIONS(6085),
    [anon_sym_noreturn] = ACTIONS(6085),
    [anon_sym__Nonnull] = ACTIONS(6085),
    [anon_sym_mutable] = ACTIONS(6085),
    [anon_sym_constinit] = ACTIONS(6085),
    [anon_sym_consteval] = ACTIONS(6085),
    [anon_sym_alignas] = ACTIONS(6085),
    [anon_sym__Alignas] = ACTIONS(6085),
    [anon_sym_QMARK] = ACTIONS(6085),
    [anon_sym_LT_EQ_GT] = ACTIONS(6085),
    [anon_sym_or] = ACTIONS(6085),
    [anon_sym_and] = ACTIONS(6085),
    [anon_sym_bitor] = ACTIONS(6085),
    [anon_sym_xor] = ACTIONS(6085),
    [anon_sym_bitand] = ACTIONS(6085),
    [anon_sym_not_eq] = ACTIONS(6085),
    [anon_sym_DASH_DASH] = ACTIONS(6085),
    [anon_sym_PLUS_PLUS] = ACTIONS(6085),
    [anon_sym_DOT] = ACTIONS(6083),
    [anon_sym_DOT_STAR] = ACTIONS(6085),
    [anon_sym_DASH_GT] = ACTIONS(6085),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6085),
    [anon_sym_decltype] = ACTIONS(6085),
    [anon_sym_final] = ACTIONS(6085),
    [anon_sym_override] = ACTIONS(6085),
    [anon_sym_requires] = ACTIONS(6085),
  },
  [2729] = {
    [sym_identifier] = ACTIONS(6061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [aux_sym_preproc_if_token2] = ACTIONS(6063),
    [aux_sym_preproc_else_token1] = ACTIONS(6063),
    [aux_sym_preproc_elif_token1] = ACTIONS(6061),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6063),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6063),
    [anon_sym_LPAREN2] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6061),
    [anon_sym_PLUS] = ACTIONS(6061),
    [anon_sym_STAR] = ACTIONS(6061),
    [anon_sym_SLASH] = ACTIONS(6061),
    [anon_sym_PERCENT] = ACTIONS(6061),
    [anon_sym_PIPE_PIPE] = ACTIONS(6063),
    [anon_sym_AMP_AMP] = ACTIONS(6063),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_CARET] = ACTIONS(6061),
    [anon_sym_AMP] = ACTIONS(6061),
    [anon_sym_EQ_EQ] = ACTIONS(6063),
    [anon_sym_BANG_EQ] = ACTIONS(6063),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_GT_EQ] = ACTIONS(6063),
    [anon_sym_LT_EQ] = ACTIONS(6061),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_LT_LT] = ACTIONS(6061),
    [anon_sym_GT_GT] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6063),
    [anon_sym_SEMI] = ACTIONS(6063),
    [anon_sym___attribute__] = ACTIONS(6061),
    [anon_sym___attribute] = ACTIONS(6061),
    [anon_sym_LBRACE] = ACTIONS(6063),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [anon_sym_LBRACK] = ACTIONS(6063),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6061),
    [anon_sym_QMARK] = ACTIONS(6063),
    [anon_sym_STAR_EQ] = ACTIONS(6063),
    [anon_sym_SLASH_EQ] = ACTIONS(6063),
    [anon_sym_PERCENT_EQ] = ACTIONS(6063),
    [anon_sym_PLUS_EQ] = ACTIONS(6063),
    [anon_sym_DASH_EQ] = ACTIONS(6063),
    [anon_sym_LT_LT_EQ] = ACTIONS(6063),
    [anon_sym_GT_GT_EQ] = ACTIONS(6063),
    [anon_sym_AMP_EQ] = ACTIONS(6063),
    [anon_sym_CARET_EQ] = ACTIONS(6063),
    [anon_sym_PIPE_EQ] = ACTIONS(6063),
    [anon_sym_and_eq] = ACTIONS(6061),
    [anon_sym_or_eq] = ACTIONS(6061),
    [anon_sym_xor_eq] = ACTIONS(6061),
    [anon_sym_LT_EQ_GT] = ACTIONS(6063),
    [anon_sym_or] = ACTIONS(6061),
    [anon_sym_and] = ACTIONS(6061),
    [anon_sym_bitor] = ACTIONS(6061),
    [anon_sym_xor] = ACTIONS(6061),
    [anon_sym_bitand] = ACTIONS(6061),
    [anon_sym_not_eq] = ACTIONS(6061),
    [anon_sym_DASH_DASH] = ACTIONS(6063),
    [anon_sym_PLUS_PLUS] = ACTIONS(6063),
    [anon_sym_DOT] = ACTIONS(6061),
    [anon_sym_DOT_STAR] = ACTIONS(6063),
    [anon_sym_DASH_GT] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6061),
    [anon_sym_decltype] = ACTIONS(6061),
  },
  [2730] = {
    [sym_identifier] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6081),
    [anon_sym_RPAREN] = ACTIONS(6081),
    [aux_sym_preproc_if_token2] = ACTIONS(6081),
    [aux_sym_preproc_else_token1] = ACTIONS(6081),
    [aux_sym_preproc_elif_token1] = ACTIONS(6079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6081),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_PERCENT] = ACTIONS(6079),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_AMP] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6079),
    [anon_sym_GT_EQ] = ACTIONS(6081),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6079),
    [anon_sym_LT_LT] = ACTIONS(6079),
    [anon_sym_GT_GT] = ACTIONS(6079),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(6081),
    [anon_sym___attribute__] = ACTIONS(6079),
    [anon_sym___attribute] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6081),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6081),
    [anon_sym_RBRACK] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_QMARK] = ACTIONS(6081),
    [anon_sym_STAR_EQ] = ACTIONS(6081),
    [anon_sym_SLASH_EQ] = ACTIONS(6081),
    [anon_sym_PERCENT_EQ] = ACTIONS(6081),
    [anon_sym_PLUS_EQ] = ACTIONS(6081),
    [anon_sym_DASH_EQ] = ACTIONS(6081),
    [anon_sym_LT_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT_GT_EQ] = ACTIONS(6081),
    [anon_sym_AMP_EQ] = ACTIONS(6081),
    [anon_sym_CARET_EQ] = ACTIONS(6081),
    [anon_sym_PIPE_EQ] = ACTIONS(6081),
    [anon_sym_and_eq] = ACTIONS(6079),
    [anon_sym_or_eq] = ACTIONS(6079),
    [anon_sym_xor_eq] = ACTIONS(6079),
    [anon_sym_LT_EQ_GT] = ACTIONS(6081),
    [anon_sym_or] = ACTIONS(6079),
    [anon_sym_and] = ACTIONS(6079),
    [anon_sym_bitor] = ACTIONS(6079),
    [anon_sym_xor] = ACTIONS(6079),
    [anon_sym_bitand] = ACTIONS(6079),
    [anon_sym_not_eq] = ACTIONS(6079),
    [anon_sym_DASH_DASH] = ACTIONS(6081),
    [anon_sym_PLUS_PLUS] = ACTIONS(6081),
    [anon_sym_DOT] = ACTIONS(6079),
    [anon_sym_DOT_STAR] = ACTIONS(6081),
    [anon_sym_DASH_GT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6079),
    [anon_sym_decltype] = ACTIONS(6079),
  },
  [2731] = {
    [sym_string_literal] = STATE(2491),
    [sym_template_argument_list] = STATE(2841),
    [sym_raw_string_literal] = STATE(2491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6688),
    [anon_sym_COMMA] = ACTIONS(6786),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(6788),
    [anon_sym_EQ] = ACTIONS(4225),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(4217),
    [anon_sym_SLASH_EQ] = ACTIONS(4217),
    [anon_sym_PERCENT_EQ] = ACTIONS(4217),
    [anon_sym_PLUS_EQ] = ACTIONS(4217),
    [anon_sym_DASH_EQ] = ACTIONS(4217),
    [anon_sym_LT_LT_EQ] = ACTIONS(4217),
    [anon_sym_GT_GT_EQ] = ACTIONS(4217),
    [anon_sym_AMP_EQ] = ACTIONS(4217),
    [anon_sym_CARET_EQ] = ACTIONS(4217),
    [anon_sym_PIPE_EQ] = ACTIONS(4217),
    [anon_sym_and_eq] = ACTIONS(4217),
    [anon_sym_or_eq] = ACTIONS(4217),
    [anon_sym_xor_eq] = ACTIONS(4217),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(3830),
    [anon_sym_u_DQUOTE] = ACTIONS(3830),
    [anon_sym_U_DQUOTE] = ACTIONS(3830),
    [anon_sym_u8_DQUOTE] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3838),
    [anon_sym_LR_DQUOTE] = ACTIONS(3838),
    [anon_sym_uR_DQUOTE] = ACTIONS(3838),
    [anon_sym_UR_DQUOTE] = ACTIONS(3838),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3838),
  },
  [2732] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5919),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5919),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5919),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5917),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5919),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym_COLON] = ACTIONS(5919),
    [anon_sym___extension__] = ACTIONS(5919),
    [anon_sym___attribute__] = ACTIONS(5919),
    [anon_sym___attribute] = ACTIONS(5917),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_const] = ACTIONS(5917),
    [anon_sym_constexpr] = ACTIONS(5919),
    [anon_sym_volatile] = ACTIONS(5919),
    [anon_sym_restrict] = ACTIONS(5919),
    [anon_sym___restrict__] = ACTIONS(5919),
    [anon_sym__Atomic] = ACTIONS(5919),
    [anon_sym__Noreturn] = ACTIONS(5919),
    [anon_sym_noreturn] = ACTIONS(5919),
    [anon_sym__Nonnull] = ACTIONS(5919),
    [anon_sym_mutable] = ACTIONS(5919),
    [anon_sym_constinit] = ACTIONS(5919),
    [anon_sym_consteval] = ACTIONS(5919),
    [anon_sym_alignas] = ACTIONS(5919),
    [anon_sym__Alignas] = ACTIONS(5919),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5919),
    [anon_sym_and] = ACTIONS(5919),
    [anon_sym_bitor] = ACTIONS(5919),
    [anon_sym_xor] = ACTIONS(5919),
    [anon_sym_bitand] = ACTIONS(5919),
    [anon_sym_not_eq] = ACTIONS(5919),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5919),
    [anon_sym_decltype] = ACTIONS(5919),
    [anon_sym_final] = ACTIONS(5919),
    [anon_sym_override] = ACTIONS(5919),
    [anon_sym_GT2] = ACTIONS(5919),
    [anon_sym_requires] = ACTIONS(5919),
  },
  [2733] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5927),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5927),
    [anon_sym_PIPE_PIPE] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(5927),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_EQ_EQ] = ACTIONS(5927),
    [anon_sym_BANG_EQ] = ACTIONS(5927),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_GT_EQ] = ACTIONS(5925),
    [anon_sym_LT_EQ] = ACTIONS(5925),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5927),
    [anon_sym_GT_GT] = ACTIONS(5925),
    [anon_sym_COLON] = ACTIONS(5927),
    [anon_sym___extension__] = ACTIONS(5927),
    [anon_sym___attribute__] = ACTIONS(5927),
    [anon_sym___attribute] = ACTIONS(5925),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_const] = ACTIONS(5925),
    [anon_sym_constexpr] = ACTIONS(5927),
    [anon_sym_volatile] = ACTIONS(5927),
    [anon_sym_restrict] = ACTIONS(5927),
    [anon_sym___restrict__] = ACTIONS(5927),
    [anon_sym__Atomic] = ACTIONS(5927),
    [anon_sym__Noreturn] = ACTIONS(5927),
    [anon_sym_noreturn] = ACTIONS(5927),
    [anon_sym__Nonnull] = ACTIONS(5927),
    [anon_sym_mutable] = ACTIONS(5927),
    [anon_sym_constinit] = ACTIONS(5927),
    [anon_sym_consteval] = ACTIONS(5927),
    [anon_sym_alignas] = ACTIONS(5927),
    [anon_sym__Alignas] = ACTIONS(5927),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_LT_EQ_GT] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5927),
    [anon_sym_and] = ACTIONS(5927),
    [anon_sym_bitor] = ACTIONS(5927),
    [anon_sym_xor] = ACTIONS(5927),
    [anon_sym_bitand] = ACTIONS(5927),
    [anon_sym_not_eq] = ACTIONS(5927),
    [anon_sym_DASH_DASH] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_DOT_STAR] = ACTIONS(5927),
    [anon_sym_DASH_GT] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5927),
    [anon_sym_decltype] = ACTIONS(5927),
    [anon_sym_final] = ACTIONS(5927),
    [anon_sym_override] = ACTIONS(5927),
    [anon_sym_GT2] = ACTIONS(5927),
    [anon_sym_requires] = ACTIONS(5927),
  },
  [2734] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5931),
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5929),
    [anon_sym_STAR] = ACTIONS(5931),
    [anon_sym_SLASH] = ACTIONS(5929),
    [anon_sym_PERCENT] = ACTIONS(5931),
    [anon_sym_PIPE_PIPE] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5931),
    [anon_sym_PIPE] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5931),
    [anon_sym_AMP] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5931),
    [anon_sym_BANG_EQ] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5929),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5929),
    [anon_sym_LT_LT] = ACTIONS(5931),
    [anon_sym_GT_GT] = ACTIONS(5929),
    [anon_sym_COLON] = ACTIONS(5931),
    [anon_sym___extension__] = ACTIONS(5931),
    [anon_sym___attribute__] = ACTIONS(5931),
    [anon_sym___attribute] = ACTIONS(5929),
    [anon_sym_LBRACE] = ACTIONS(5931),
    [anon_sym_signed] = ACTIONS(6791),
    [anon_sym_unsigned] = ACTIONS(6791),
    [anon_sym_long] = ACTIONS(6791),
    [anon_sym_short] = ACTIONS(6791),
    [anon_sym_LBRACK] = ACTIONS(5931),
    [anon_sym_const] = ACTIONS(5929),
    [anon_sym_constexpr] = ACTIONS(5931),
    [anon_sym_volatile] = ACTIONS(5931),
    [anon_sym_restrict] = ACTIONS(5931),
    [anon_sym___restrict__] = ACTIONS(5931),
    [anon_sym__Atomic] = ACTIONS(5931),
    [anon_sym__Noreturn] = ACTIONS(5931),
    [anon_sym_noreturn] = ACTIONS(5931),
    [anon_sym__Nonnull] = ACTIONS(5931),
    [anon_sym_mutable] = ACTIONS(5931),
    [anon_sym_constinit] = ACTIONS(5931),
    [anon_sym_consteval] = ACTIONS(5931),
    [anon_sym_alignas] = ACTIONS(5931),
    [anon_sym__Alignas] = ACTIONS(5931),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_LT_EQ_GT] = ACTIONS(5931),
    [anon_sym_or] = ACTIONS(5931),
    [anon_sym_and] = ACTIONS(5931),
    [anon_sym_bitor] = ACTIONS(5931),
    [anon_sym_xor] = ACTIONS(5931),
    [anon_sym_bitand] = ACTIONS(5931),
    [anon_sym_not_eq] = ACTIONS(5931),
    [anon_sym_DASH_DASH] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5931),
    [anon_sym_DOT] = ACTIONS(5929),
    [anon_sym_DOT_STAR] = ACTIONS(5931),
    [anon_sym_DASH_GT] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5931),
    [anon_sym_decltype] = ACTIONS(5931),
    [anon_sym_final] = ACTIONS(5931),
    [anon_sym_override] = ACTIONS(5931),
    [anon_sym_GT2] = ACTIONS(5931),
    [anon_sym_requires] = ACTIONS(5931),
  },
  [2735] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_LPAREN2] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5886),
    [anon_sym_SLASH] = ACTIONS(5884),
    [anon_sym_PERCENT] = ACTIONS(5886),
    [anon_sym_PIPE_PIPE] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_PIPE] = ACTIONS(5884),
    [anon_sym_CARET] = ACTIONS(5886),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_EQ_EQ] = ACTIONS(5886),
    [anon_sym_BANG_EQ] = ACTIONS(5886),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5884),
    [anon_sym_LT_EQ] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(5886),
    [anon_sym_GT_GT] = ACTIONS(5884),
    [anon_sym_COLON] = ACTIONS(5886),
    [anon_sym___extension__] = ACTIONS(5886),
    [anon_sym___attribute__] = ACTIONS(5886),
    [anon_sym___attribute] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(6793),
    [anon_sym_unsigned] = ACTIONS(6793),
    [anon_sym_long] = ACTIONS(6793),
    [anon_sym_short] = ACTIONS(6793),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_const] = ACTIONS(5884),
    [anon_sym_constexpr] = ACTIONS(5886),
    [anon_sym_volatile] = ACTIONS(5886),
    [anon_sym_restrict] = ACTIONS(5886),
    [anon_sym___restrict__] = ACTIONS(5886),
    [anon_sym__Atomic] = ACTIONS(5886),
    [anon_sym__Noreturn] = ACTIONS(5886),
    [anon_sym_noreturn] = ACTIONS(5886),
    [anon_sym__Nonnull] = ACTIONS(5886),
    [anon_sym_mutable] = ACTIONS(5886),
    [anon_sym_constinit] = ACTIONS(5886),
    [anon_sym_consteval] = ACTIONS(5886),
    [anon_sym_alignas] = ACTIONS(5886),
    [anon_sym__Alignas] = ACTIONS(5886),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_LT_EQ_GT] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5886),
    [anon_sym_and] = ACTIONS(5886),
    [anon_sym_bitor] = ACTIONS(5886),
    [anon_sym_xor] = ACTIONS(5886),
    [anon_sym_bitand] = ACTIONS(5886),
    [anon_sym_not_eq] = ACTIONS(5886),
    [anon_sym_DASH_DASH] = ACTIONS(5886),
    [anon_sym_PLUS_PLUS] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5884),
    [anon_sym_DOT_STAR] = ACTIONS(5886),
    [anon_sym_DASH_GT] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5886),
    [anon_sym_decltype] = ACTIONS(5886),
    [anon_sym_final] = ACTIONS(5886),
    [anon_sym_override] = ACTIONS(5886),
    [anon_sym_GT2] = ACTIONS(5886),
    [anon_sym_requires] = ACTIONS(5886),
  },
  [2736] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5937),
    [anon_sym_LPAREN2] = ACTIONS(5937),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5937),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5937),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5937),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_GT_EQ] = ACTIONS(5935),
    [anon_sym_LT_EQ] = ACTIONS(5935),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5937),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_COLON] = ACTIONS(5937),
    [anon_sym___extension__] = ACTIONS(5937),
    [anon_sym___attribute__] = ACTIONS(5937),
    [anon_sym___attribute] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5937),
    [anon_sym_const] = ACTIONS(5935),
    [anon_sym_constexpr] = ACTIONS(5937),
    [anon_sym_volatile] = ACTIONS(5937),
    [anon_sym_restrict] = ACTIONS(5937),
    [anon_sym___restrict__] = ACTIONS(5937),
    [anon_sym__Atomic] = ACTIONS(5937),
    [anon_sym__Noreturn] = ACTIONS(5937),
    [anon_sym_noreturn] = ACTIONS(5937),
    [anon_sym__Nonnull] = ACTIONS(5937),
    [anon_sym_mutable] = ACTIONS(5937),
    [anon_sym_constinit] = ACTIONS(5937),
    [anon_sym_consteval] = ACTIONS(5937),
    [anon_sym_alignas] = ACTIONS(5937),
    [anon_sym__Alignas] = ACTIONS(5937),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_LT_EQ_GT] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5937),
    [anon_sym_and] = ACTIONS(5937),
    [anon_sym_bitor] = ACTIONS(5937),
    [anon_sym_xor] = ACTIONS(5937),
    [anon_sym_bitand] = ACTIONS(5937),
    [anon_sym_not_eq] = ACTIONS(5937),
    [anon_sym_DASH_DASH] = ACTIONS(5937),
    [anon_sym_PLUS_PLUS] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_DOT_STAR] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5937),
    [anon_sym_decltype] = ACTIONS(5937),
    [anon_sym_final] = ACTIONS(5937),
    [anon_sym_override] = ACTIONS(5937),
    [anon_sym_GT2] = ACTIONS(5937),
    [anon_sym_requires] = ACTIONS(5937),
  },
  [2737] = {
    [sym_identifier] = ACTIONS(6065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [aux_sym_preproc_if_token2] = ACTIONS(6067),
    [aux_sym_preproc_else_token1] = ACTIONS(6067),
    [aux_sym_preproc_elif_token1] = ACTIONS(6065),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6067),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6067),
    [anon_sym_LPAREN2] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6065),
    [anon_sym_PLUS] = ACTIONS(6065),
    [anon_sym_STAR] = ACTIONS(6065),
    [anon_sym_SLASH] = ACTIONS(6065),
    [anon_sym_PERCENT] = ACTIONS(6065),
    [anon_sym_PIPE_PIPE] = ACTIONS(6067),
    [anon_sym_AMP_AMP] = ACTIONS(6067),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_CARET] = ACTIONS(6065),
    [anon_sym_AMP] = ACTIONS(6065),
    [anon_sym_EQ_EQ] = ACTIONS(6067),
    [anon_sym_BANG_EQ] = ACTIONS(6067),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_GT_EQ] = ACTIONS(6067),
    [anon_sym_LT_EQ] = ACTIONS(6065),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_LT_LT] = ACTIONS(6065),
    [anon_sym_GT_GT] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6067),
    [anon_sym_SEMI] = ACTIONS(6067),
    [anon_sym___attribute__] = ACTIONS(6065),
    [anon_sym___attribute] = ACTIONS(6065),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6065),
    [anon_sym_QMARK] = ACTIONS(6067),
    [anon_sym_STAR_EQ] = ACTIONS(6067),
    [anon_sym_SLASH_EQ] = ACTIONS(6067),
    [anon_sym_PERCENT_EQ] = ACTIONS(6067),
    [anon_sym_PLUS_EQ] = ACTIONS(6067),
    [anon_sym_DASH_EQ] = ACTIONS(6067),
    [anon_sym_LT_LT_EQ] = ACTIONS(6067),
    [anon_sym_GT_GT_EQ] = ACTIONS(6067),
    [anon_sym_AMP_EQ] = ACTIONS(6067),
    [anon_sym_CARET_EQ] = ACTIONS(6067),
    [anon_sym_PIPE_EQ] = ACTIONS(6067),
    [anon_sym_and_eq] = ACTIONS(6065),
    [anon_sym_or_eq] = ACTIONS(6065),
    [anon_sym_xor_eq] = ACTIONS(6065),
    [anon_sym_LT_EQ_GT] = ACTIONS(6067),
    [anon_sym_or] = ACTIONS(6065),
    [anon_sym_and] = ACTIONS(6065),
    [anon_sym_bitor] = ACTIONS(6065),
    [anon_sym_xor] = ACTIONS(6065),
    [anon_sym_bitand] = ACTIONS(6065),
    [anon_sym_not_eq] = ACTIONS(6065),
    [anon_sym_DASH_DASH] = ACTIONS(6067),
    [anon_sym_PLUS_PLUS] = ACTIONS(6067),
    [anon_sym_DOT] = ACTIONS(6065),
    [anon_sym_DOT_STAR] = ACTIONS(6067),
    [anon_sym_DASH_GT] = ACTIONS(6067),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6065),
    [anon_sym_decltype] = ACTIONS(6065),
  },
  [2738] = {
    [sym_identifier] = ACTIONS(6795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6797),
    [anon_sym_COMMA] = ACTIONS(6797),
    [anon_sym_RPAREN] = ACTIONS(6797),
    [aux_sym_preproc_if_token2] = ACTIONS(6797),
    [aux_sym_preproc_else_token1] = ACTIONS(6797),
    [aux_sym_preproc_elif_token1] = ACTIONS(6795),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6797),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6797),
    [anon_sym_LPAREN2] = ACTIONS(6797),
    [anon_sym_DASH] = ACTIONS(6795),
    [anon_sym_PLUS] = ACTIONS(6795),
    [anon_sym_STAR] = ACTIONS(6795),
    [anon_sym_SLASH] = ACTIONS(6795),
    [anon_sym_PERCENT] = ACTIONS(6795),
    [anon_sym_PIPE_PIPE] = ACTIONS(6797),
    [anon_sym_AMP_AMP] = ACTIONS(6797),
    [anon_sym_PIPE] = ACTIONS(6795),
    [anon_sym_CARET] = ACTIONS(6795),
    [anon_sym_AMP] = ACTIONS(6795),
    [anon_sym_EQ_EQ] = ACTIONS(6797),
    [anon_sym_BANG_EQ] = ACTIONS(6797),
    [anon_sym_GT] = ACTIONS(6795),
    [anon_sym_GT_EQ] = ACTIONS(6797),
    [anon_sym_LT_EQ] = ACTIONS(6795),
    [anon_sym_LT] = ACTIONS(6795),
    [anon_sym_LT_LT] = ACTIONS(6795),
    [anon_sym_GT_GT] = ACTIONS(6795),
    [anon_sym_COLON] = ACTIONS(6797),
    [anon_sym_SEMI] = ACTIONS(6797),
    [anon_sym___attribute__] = ACTIONS(6795),
    [anon_sym___attribute] = ACTIONS(6795),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6797),
    [anon_sym_LBRACE] = ACTIONS(6797),
    [anon_sym_RBRACE] = ACTIONS(6797),
    [anon_sym_LBRACK] = ACTIONS(6795),
    [anon_sym_RBRACK] = ACTIONS(6797),
    [anon_sym_EQ] = ACTIONS(6795),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_STAR_EQ] = ACTIONS(6797),
    [anon_sym_SLASH_EQ] = ACTIONS(6797),
    [anon_sym_PERCENT_EQ] = ACTIONS(6797),
    [anon_sym_PLUS_EQ] = ACTIONS(6797),
    [anon_sym_DASH_EQ] = ACTIONS(6797),
    [anon_sym_LT_LT_EQ] = ACTIONS(6797),
    [anon_sym_GT_GT_EQ] = ACTIONS(6797),
    [anon_sym_AMP_EQ] = ACTIONS(6797),
    [anon_sym_CARET_EQ] = ACTIONS(6797),
    [anon_sym_PIPE_EQ] = ACTIONS(6797),
    [anon_sym_and_eq] = ACTIONS(6795),
    [anon_sym_or_eq] = ACTIONS(6795),
    [anon_sym_xor_eq] = ACTIONS(6795),
    [anon_sym_LT_EQ_GT] = ACTIONS(6797),
    [anon_sym_or] = ACTIONS(6795),
    [anon_sym_and] = ACTIONS(6795),
    [anon_sym_bitor] = ACTIONS(6795),
    [anon_sym_xor] = ACTIONS(6795),
    [anon_sym_bitand] = ACTIONS(6795),
    [anon_sym_not_eq] = ACTIONS(6795),
    [anon_sym_DASH_DASH] = ACTIONS(6797),
    [anon_sym_PLUS_PLUS] = ACTIONS(6797),
    [anon_sym_DOT] = ACTIONS(6795),
    [anon_sym_DOT_STAR] = ACTIONS(6797),
    [anon_sym_DASH_GT] = ACTIONS(6797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6795),
  },
  [2739] = {
    [sym_identifier] = ACTIONS(6141),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6143),
    [anon_sym_COMMA] = ACTIONS(6143),
    [anon_sym_RPAREN] = ACTIONS(6143),
    [aux_sym_preproc_if_token2] = ACTIONS(6143),
    [aux_sym_preproc_else_token1] = ACTIONS(6143),
    [aux_sym_preproc_elif_token1] = ACTIONS(6141),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6143),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6141),
    [anon_sym_PLUS] = ACTIONS(6141),
    [anon_sym_STAR] = ACTIONS(6141),
    [anon_sym_SLASH] = ACTIONS(6141),
    [anon_sym_PERCENT] = ACTIONS(6141),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_PIPE] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [anon_sym_AMP] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6143),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_GT] = ACTIONS(6141),
    [anon_sym_GT_EQ] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6141),
    [anon_sym_LT] = ACTIONS(6141),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6141),
    [anon_sym_COLON] = ACTIONS(6143),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym___attribute__] = ACTIONS(6141),
    [anon_sym___attribute] = ACTIONS(6141),
    [anon_sym_LBRACE] = ACTIONS(6143),
    [anon_sym_RBRACE] = ACTIONS(6143),
    [anon_sym_LBRACK] = ACTIONS(6143),
    [anon_sym_RBRACK] = ACTIONS(6143),
    [anon_sym_EQ] = ACTIONS(6141),
    [anon_sym_QMARK] = ACTIONS(6143),
    [anon_sym_STAR_EQ] = ACTIONS(6143),
    [anon_sym_SLASH_EQ] = ACTIONS(6143),
    [anon_sym_PERCENT_EQ] = ACTIONS(6143),
    [anon_sym_PLUS_EQ] = ACTIONS(6143),
    [anon_sym_DASH_EQ] = ACTIONS(6143),
    [anon_sym_LT_LT_EQ] = ACTIONS(6143),
    [anon_sym_GT_GT_EQ] = ACTIONS(6143),
    [anon_sym_AMP_EQ] = ACTIONS(6143),
    [anon_sym_CARET_EQ] = ACTIONS(6143),
    [anon_sym_PIPE_EQ] = ACTIONS(6143),
    [anon_sym_and_eq] = ACTIONS(6141),
    [anon_sym_or_eq] = ACTIONS(6141),
    [anon_sym_xor_eq] = ACTIONS(6141),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_or] = ACTIONS(6141),
    [anon_sym_and] = ACTIONS(6141),
    [anon_sym_bitor] = ACTIONS(6141),
    [anon_sym_xor] = ACTIONS(6141),
    [anon_sym_bitand] = ACTIONS(6141),
    [anon_sym_not_eq] = ACTIONS(6141),
    [anon_sym_DASH_DASH] = ACTIONS(6143),
    [anon_sym_PLUS_PLUS] = ACTIONS(6143),
    [anon_sym_DOT] = ACTIONS(6141),
    [anon_sym_DOT_STAR] = ACTIONS(6143),
    [anon_sym_DASH_GT] = ACTIONS(6143),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6141),
    [anon_sym_decltype] = ACTIONS(6141),
  },
  [2740] = {
    [sym_identifier] = ACTIONS(5654),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5656),
    [anon_sym_COMMA] = ACTIONS(5656),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [aux_sym_preproc_if_token2] = ACTIONS(5656),
    [aux_sym_preproc_else_token1] = ACTIONS(5656),
    [aux_sym_preproc_elif_token1] = ACTIONS(5654),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5656),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5656),
    [anon_sym_LPAREN2] = ACTIONS(5656),
    [anon_sym_DASH] = ACTIONS(5654),
    [anon_sym_PLUS] = ACTIONS(5654),
    [anon_sym_STAR] = ACTIONS(5654),
    [anon_sym_SLASH] = ACTIONS(5654),
    [anon_sym_PERCENT] = ACTIONS(5654),
    [anon_sym_PIPE_PIPE] = ACTIONS(5656),
    [anon_sym_AMP_AMP] = ACTIONS(5656),
    [anon_sym_PIPE] = ACTIONS(5654),
    [anon_sym_CARET] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5654),
    [anon_sym_EQ_EQ] = ACTIONS(5656),
    [anon_sym_BANG_EQ] = ACTIONS(5656),
    [anon_sym_GT] = ACTIONS(5654),
    [anon_sym_GT_EQ] = ACTIONS(5656),
    [anon_sym_LT_EQ] = ACTIONS(5654),
    [anon_sym_LT] = ACTIONS(5654),
    [anon_sym_LT_LT] = ACTIONS(5654),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_COLON] = ACTIONS(5656),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym___attribute__] = ACTIONS(5654),
    [anon_sym___attribute] = ACTIONS(5654),
    [anon_sym_LBRACE] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5656),
    [anon_sym_RBRACK] = ACTIONS(5656),
    [anon_sym_EQ] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5656),
    [anon_sym_STAR_EQ] = ACTIONS(5656),
    [anon_sym_SLASH_EQ] = ACTIONS(5656),
    [anon_sym_PERCENT_EQ] = ACTIONS(5656),
    [anon_sym_PLUS_EQ] = ACTIONS(5656),
    [anon_sym_DASH_EQ] = ACTIONS(5656),
    [anon_sym_LT_LT_EQ] = ACTIONS(5656),
    [anon_sym_GT_GT_EQ] = ACTIONS(5656),
    [anon_sym_AMP_EQ] = ACTIONS(5656),
    [anon_sym_CARET_EQ] = ACTIONS(5656),
    [anon_sym_PIPE_EQ] = ACTIONS(5656),
    [anon_sym_and_eq] = ACTIONS(5654),
    [anon_sym_or_eq] = ACTIONS(5654),
    [anon_sym_xor_eq] = ACTIONS(5654),
    [anon_sym_LT_EQ_GT] = ACTIONS(5656),
    [anon_sym_or] = ACTIONS(5654),
    [anon_sym_and] = ACTIONS(5654),
    [anon_sym_bitor] = ACTIONS(5654),
    [anon_sym_xor] = ACTIONS(5654),
    [anon_sym_bitand] = ACTIONS(5654),
    [anon_sym_not_eq] = ACTIONS(5654),
    [anon_sym_DASH_DASH] = ACTIONS(5656),
    [anon_sym_PLUS_PLUS] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(5654),
    [anon_sym_DOT_STAR] = ACTIONS(5656),
    [anon_sym_DASH_GT] = ACTIONS(5656),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5654),
    [anon_sym_decltype] = ACTIONS(5654),
  },
  [2741] = {
    [sym_template_argument_list] = STATE(2624),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2745),
    [sym_identifier] = ACTIONS(4215),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(4223),
    [aux_sym_preproc_if_token2] = ACTIONS(4223),
    [aux_sym_preproc_else_token1] = ACTIONS(4223),
    [aux_sym_preproc_elif_token1] = ACTIONS(4215),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4223),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4223),
    [anon_sym_LPAREN2] = ACTIONS(4223),
    [anon_sym_DASH] = ACTIONS(4215),
    [anon_sym_PLUS] = ACTIONS(4215),
    [anon_sym_STAR] = ACTIONS(4215),
    [anon_sym_SLASH] = ACTIONS(4215),
    [anon_sym_PERCENT] = ACTIONS(4215),
    [anon_sym_PIPE_PIPE] = ACTIONS(4223),
    [anon_sym_AMP_AMP] = ACTIONS(4223),
    [anon_sym_PIPE] = ACTIONS(4215),
    [anon_sym_CARET] = ACTIONS(4215),
    [anon_sym_AMP] = ACTIONS(4215),
    [anon_sym_EQ_EQ] = ACTIONS(4223),
    [anon_sym_BANG_EQ] = ACTIONS(4223),
    [anon_sym_GT] = ACTIONS(4215),
    [anon_sym_GT_EQ] = ACTIONS(4223),
    [anon_sym_LT_EQ] = ACTIONS(4215),
    [anon_sym_LT] = ACTIONS(6575),
    [anon_sym_LT_LT] = ACTIONS(4215),
    [anon_sym_GT_GT] = ACTIONS(4215),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(4223),
    [anon_sym_signed] = ACTIONS(6623),
    [anon_sym_unsigned] = ACTIONS(6623),
    [anon_sym_long] = ACTIONS(6623),
    [anon_sym_short] = ACTIONS(6623),
    [anon_sym_LBRACK] = ACTIONS(4223),
    [anon_sym_EQ] = ACTIONS(4215),
    [anon_sym_QMARK] = ACTIONS(4223),
    [anon_sym_STAR_EQ] = ACTIONS(4223),
    [anon_sym_SLASH_EQ] = ACTIONS(4223),
    [anon_sym_PERCENT_EQ] = ACTIONS(4223),
    [anon_sym_PLUS_EQ] = ACTIONS(4223),
    [anon_sym_DASH_EQ] = ACTIONS(4223),
    [anon_sym_LT_LT_EQ] = ACTIONS(4223),
    [anon_sym_GT_GT_EQ] = ACTIONS(4223),
    [anon_sym_AMP_EQ] = ACTIONS(4223),
    [anon_sym_CARET_EQ] = ACTIONS(4223),
    [anon_sym_PIPE_EQ] = ACTIONS(4223),
    [anon_sym_and_eq] = ACTIONS(4215),
    [anon_sym_or_eq] = ACTIONS(4215),
    [anon_sym_xor_eq] = ACTIONS(4215),
    [anon_sym_LT_EQ_GT] = ACTIONS(4223),
    [anon_sym_or] = ACTIONS(4215),
    [anon_sym_and] = ACTIONS(4215),
    [anon_sym_bitor] = ACTIONS(4215),
    [anon_sym_xor] = ACTIONS(4215),
    [anon_sym_bitand] = ACTIONS(4215),
    [anon_sym_not_eq] = ACTIONS(4215),
    [anon_sym_DASH_DASH] = ACTIONS(4223),
    [anon_sym_PLUS_PLUS] = ACTIONS(4223),
    [anon_sym_DOT] = ACTIONS(4215),
    [anon_sym_DOT_STAR] = ACTIONS(4223),
    [anon_sym_DASH_GT] = ACTIONS(4223),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4215),
    [anon_sym_decltype] = ACTIONS(4215),
  },
  [2742] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5890),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [aux_sym_preproc_if_token2] = ACTIONS(5892),
    [aux_sym_preproc_else_token1] = ACTIONS(5892),
    [aux_sym_preproc_elif_token1] = ACTIONS(5890),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5892),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5892),
    [anon_sym_LPAREN2] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5890),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5890),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5892),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym___attribute__] = ACTIONS(5890),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_QMARK] = ACTIONS(5892),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_and_eq] = ACTIONS(5890),
    [anon_sym_or_eq] = ACTIONS(5890),
    [anon_sym_xor_eq] = ACTIONS(5890),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5890),
    [anon_sym_and] = ACTIONS(5890),
    [anon_sym_bitor] = ACTIONS(5890),
    [anon_sym_xor] = ACTIONS(5890),
    [anon_sym_bitand] = ACTIONS(5890),
    [anon_sym_not_eq] = ACTIONS(5890),
    [anon_sym_DASH_DASH] = ACTIONS(5892),
    [anon_sym_PLUS_PLUS] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5890),
    [anon_sym_decltype] = ACTIONS(5890),
  },
  [2743] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2713),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5904),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5904),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5904),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5902),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5904),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym___extension__] = ACTIONS(5904),
    [anon_sym___attribute__] = ACTIONS(5904),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(6758),
    [anon_sym_unsigned] = ACTIONS(6758),
    [anon_sym_long] = ACTIONS(6758),
    [anon_sym_short] = ACTIONS(6758),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_const] = ACTIONS(5902),
    [anon_sym_constexpr] = ACTIONS(5904),
    [anon_sym_volatile] = ACTIONS(5904),
    [anon_sym_restrict] = ACTIONS(5904),
    [anon_sym___restrict__] = ACTIONS(5904),
    [anon_sym__Atomic] = ACTIONS(5904),
    [anon_sym__Noreturn] = ACTIONS(5904),
    [anon_sym_noreturn] = ACTIONS(5904),
    [anon_sym__Nonnull] = ACTIONS(5904),
    [anon_sym_mutable] = ACTIONS(5904),
    [anon_sym_constinit] = ACTIONS(5904),
    [anon_sym_consteval] = ACTIONS(5904),
    [anon_sym_alignas] = ACTIONS(5904),
    [anon_sym__Alignas] = ACTIONS(5904),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5904),
    [anon_sym_and] = ACTIONS(5904),
    [anon_sym_bitor] = ACTIONS(5904),
    [anon_sym_xor] = ACTIONS(5904),
    [anon_sym_bitand] = ACTIONS(5904),
    [anon_sym_not_eq] = ACTIONS(5904),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5904),
    [anon_sym_decltype] = ACTIONS(5904),
    [anon_sym_final] = ACTIONS(5904),
    [anon_sym_override] = ACTIONS(5904),
    [anon_sym_GT2] = ACTIONS(5904),
    [anon_sym_requires] = ACTIONS(5904),
  },
  [2744] = {
    [sym_attribute_specifier] = STATE(2590),
    [sym_enumerator_list] = STATE(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_LPAREN2] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6069),
    [anon_sym_PLUS] = ACTIONS(6069),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6069),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_PIPE_PIPE] = ACTIONS(6071),
    [anon_sym_AMP_AMP] = ACTIONS(6071),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_AMP] = ACTIONS(6069),
    [anon_sym_EQ_EQ] = ACTIONS(6071),
    [anon_sym_BANG_EQ] = ACTIONS(6071),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_GT_EQ] = ACTIONS(6071),
    [anon_sym_LT_EQ] = ACTIONS(6069),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_LT_LT] = ACTIONS(6071),
    [anon_sym_GT_GT] = ACTIONS(6071),
    [anon_sym_COLON] = ACTIONS(6071),
    [anon_sym_SEMI] = ACTIONS(6071),
    [anon_sym___extension__] = ACTIONS(6071),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6784),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_const] = ACTIONS(6069),
    [anon_sym_constexpr] = ACTIONS(6071),
    [anon_sym_volatile] = ACTIONS(6071),
    [anon_sym_restrict] = ACTIONS(6071),
    [anon_sym___restrict__] = ACTIONS(6071),
    [anon_sym__Atomic] = ACTIONS(6071),
    [anon_sym__Noreturn] = ACTIONS(6071),
    [anon_sym_noreturn] = ACTIONS(6071),
    [anon_sym__Nonnull] = ACTIONS(6071),
    [anon_sym_mutable] = ACTIONS(6071),
    [anon_sym_constinit] = ACTIONS(6071),
    [anon_sym_consteval] = ACTIONS(6071),
    [anon_sym_alignas] = ACTIONS(6071),
    [anon_sym__Alignas] = ACTIONS(6071),
    [anon_sym_QMARK] = ACTIONS(6071),
    [anon_sym_LT_EQ_GT] = ACTIONS(6071),
    [anon_sym_or] = ACTIONS(6071),
    [anon_sym_and] = ACTIONS(6071),
    [anon_sym_bitor] = ACTIONS(6071),
    [anon_sym_xor] = ACTIONS(6071),
    [anon_sym_bitand] = ACTIONS(6071),
    [anon_sym_not_eq] = ACTIONS(6071),
    [anon_sym_DASH_DASH] = ACTIONS(6071),
    [anon_sym_PLUS_PLUS] = ACTIONS(6071),
    [anon_sym_DOT] = ACTIONS(6069),
    [anon_sym_DOT_STAR] = ACTIONS(6071),
    [anon_sym_DASH_GT] = ACTIONS(6071),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6071),
    [anon_sym_decltype] = ACTIONS(6071),
    [anon_sym_final] = ACTIONS(6071),
    [anon_sym_override] = ACTIONS(6071),
    [anon_sym_requires] = ACTIONS(6071),
  },
  [2745] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [aux_sym_preproc_if_token2] = ACTIONS(5915),
    [aux_sym_preproc_else_token1] = ACTIONS(5915),
    [aux_sym_preproc_elif_token1] = ACTIONS(5913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5913),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5913),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5913),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym___attribute__] = ACTIONS(5913),
    [anon_sym___attribute] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_EQ] = ACTIONS(5913),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_STAR_EQ] = ACTIONS(5915),
    [anon_sym_SLASH_EQ] = ACTIONS(5915),
    [anon_sym_PERCENT_EQ] = ACTIONS(5915),
    [anon_sym_PLUS_EQ] = ACTIONS(5915),
    [anon_sym_DASH_EQ] = ACTIONS(5915),
    [anon_sym_LT_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT_GT_EQ] = ACTIONS(5915),
    [anon_sym_AMP_EQ] = ACTIONS(5915),
    [anon_sym_CARET_EQ] = ACTIONS(5915),
    [anon_sym_PIPE_EQ] = ACTIONS(5915),
    [anon_sym_and_eq] = ACTIONS(5913),
    [anon_sym_or_eq] = ACTIONS(5913),
    [anon_sym_xor_eq] = ACTIONS(5913),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5913),
    [anon_sym_and] = ACTIONS(5913),
    [anon_sym_bitor] = ACTIONS(5913),
    [anon_sym_xor] = ACTIONS(5913),
    [anon_sym_bitand] = ACTIONS(5913),
    [anon_sym_not_eq] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5913),
    [anon_sym_decltype] = ACTIONS(5913),
  },
  [2746] = {
    [sym_identifier] = ACTIONS(6121),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6123),
    [anon_sym_COMMA] = ACTIONS(6123),
    [anon_sym_RPAREN] = ACTIONS(6123),
    [aux_sym_preproc_if_token2] = ACTIONS(6123),
    [aux_sym_preproc_else_token1] = ACTIONS(6123),
    [aux_sym_preproc_elif_token1] = ACTIONS(6121),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6123),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6123),
    [anon_sym_LPAREN2] = ACTIONS(6123),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_PERCENT] = ACTIONS(6121),
    [anon_sym_PIPE_PIPE] = ACTIONS(6123),
    [anon_sym_AMP_AMP] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_AMP] = ACTIONS(6121),
    [anon_sym_EQ_EQ] = ACTIONS(6123),
    [anon_sym_BANG_EQ] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6121),
    [anon_sym_GT_EQ] = ACTIONS(6123),
    [anon_sym_LT_EQ] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6121),
    [anon_sym_LT_LT] = ACTIONS(6121),
    [anon_sym_GT_GT] = ACTIONS(6121),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SEMI] = ACTIONS(6123),
    [anon_sym___attribute__] = ACTIONS(6121),
    [anon_sym___attribute] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(6123),
    [anon_sym_RBRACE] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6123),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_QMARK] = ACTIONS(6123),
    [anon_sym_STAR_EQ] = ACTIONS(6123),
    [anon_sym_SLASH_EQ] = ACTIONS(6123),
    [anon_sym_PERCENT_EQ] = ACTIONS(6123),
    [anon_sym_PLUS_EQ] = ACTIONS(6123),
    [anon_sym_DASH_EQ] = ACTIONS(6123),
    [anon_sym_LT_LT_EQ] = ACTIONS(6123),
    [anon_sym_GT_GT_EQ] = ACTIONS(6123),
    [anon_sym_AMP_EQ] = ACTIONS(6123),
    [anon_sym_CARET_EQ] = ACTIONS(6123),
    [anon_sym_PIPE_EQ] = ACTIONS(6123),
    [anon_sym_and_eq] = ACTIONS(6121),
    [anon_sym_or_eq] = ACTIONS(6121),
    [anon_sym_xor_eq] = ACTIONS(6121),
    [anon_sym_LT_EQ_GT] = ACTIONS(6123),
    [anon_sym_or] = ACTIONS(6121),
    [anon_sym_and] = ACTIONS(6121),
    [anon_sym_bitor] = ACTIONS(6121),
    [anon_sym_xor] = ACTIONS(6121),
    [anon_sym_bitand] = ACTIONS(6121),
    [anon_sym_not_eq] = ACTIONS(6121),
    [anon_sym_DASH_DASH] = ACTIONS(6123),
    [anon_sym_PLUS_PLUS] = ACTIONS(6123),
    [anon_sym_DOT] = ACTIONS(6121),
    [anon_sym_DOT_STAR] = ACTIONS(6123),
    [anon_sym_DASH_GT] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6121),
    [anon_sym_decltype] = ACTIONS(6121),
  },
  [2747] = {
    [sym_identifier] = ACTIONS(6075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6077),
    [anon_sym_COMMA] = ACTIONS(6077),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [aux_sym_preproc_if_token2] = ACTIONS(6077),
    [aux_sym_preproc_else_token1] = ACTIONS(6077),
    [aux_sym_preproc_elif_token1] = ACTIONS(6075),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6077),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6077),
    [anon_sym_LPAREN2] = ACTIONS(6077),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_PERCENT] = ACTIONS(6075),
    [anon_sym_PIPE_PIPE] = ACTIONS(6077),
    [anon_sym_AMP_AMP] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_AMP] = ACTIONS(6075),
    [anon_sym_EQ_EQ] = ACTIONS(6077),
    [anon_sym_BANG_EQ] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6075),
    [anon_sym_GT_EQ] = ACTIONS(6077),
    [anon_sym_LT_EQ] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6075),
    [anon_sym_LT_LT] = ACTIONS(6075),
    [anon_sym_GT_GT] = ACTIONS(6075),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SEMI] = ACTIONS(6077),
    [anon_sym___attribute__] = ACTIONS(6075),
    [anon_sym___attribute] = ACTIONS(6075),
    [anon_sym_LBRACE] = ACTIONS(6077),
    [anon_sym_RBRACE] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6077),
    [anon_sym_RBRACK] = ACTIONS(6077),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_STAR_EQ] = ACTIONS(6077),
    [anon_sym_SLASH_EQ] = ACTIONS(6077),
    [anon_sym_PERCENT_EQ] = ACTIONS(6077),
    [anon_sym_PLUS_EQ] = ACTIONS(6077),
    [anon_sym_DASH_EQ] = ACTIONS(6077),
    [anon_sym_LT_LT_EQ] = ACTIONS(6077),
    [anon_sym_GT_GT_EQ] = ACTIONS(6077),
    [anon_sym_AMP_EQ] = ACTIONS(6077),
    [anon_sym_CARET_EQ] = ACTIONS(6077),
    [anon_sym_PIPE_EQ] = ACTIONS(6077),
    [anon_sym_and_eq] = ACTIONS(6075),
    [anon_sym_or_eq] = ACTIONS(6075),
    [anon_sym_xor_eq] = ACTIONS(6075),
    [anon_sym_LT_EQ_GT] = ACTIONS(6077),
    [anon_sym_or] = ACTIONS(6075),
    [anon_sym_and] = ACTIONS(6075),
    [anon_sym_bitor] = ACTIONS(6075),
    [anon_sym_xor] = ACTIONS(6075),
    [anon_sym_bitand] = ACTIONS(6075),
    [anon_sym_not_eq] = ACTIONS(6075),
    [anon_sym_DASH_DASH] = ACTIONS(6077),
    [anon_sym_PLUS_PLUS] = ACTIONS(6077),
    [anon_sym_DOT] = ACTIONS(6075),
    [anon_sym_DOT_STAR] = ACTIONS(6077),
    [anon_sym_DASH_GT] = ACTIONS(6077),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6075),
    [anon_sym_decltype] = ACTIONS(6075),
  },
  [2748] = {
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2290),
    [anon_sym_COMMA] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [aux_sym_preproc_if_token2] = ACTIONS(2290),
    [aux_sym_preproc_else_token1] = ACTIONS(2290),
    [aux_sym_preproc_elif_token1] = ACTIONS(2288),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2290),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2290),
    [anon_sym_LPAREN2] = ACTIONS(2290),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_PERCENT] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_CARET] = ACTIONS(2288),
    [anon_sym_AMP] = ACTIONS(2288),
    [anon_sym_EQ_EQ] = ACTIONS(2290),
    [anon_sym_BANG_EQ] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2288),
    [anon_sym_GT_EQ] = ACTIONS(2290),
    [anon_sym_LT_EQ] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(2288),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym___attribute__] = ACTIONS(2288),
    [anon_sym___attribute] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_RBRACK] = ACTIONS(2290),
    [anon_sym_EQ] = ACTIONS(2288),
    [anon_sym_QMARK] = ACTIONS(2290),
    [anon_sym_STAR_EQ] = ACTIONS(2290),
    [anon_sym_SLASH_EQ] = ACTIONS(2290),
    [anon_sym_PERCENT_EQ] = ACTIONS(2290),
    [anon_sym_PLUS_EQ] = ACTIONS(2290),
    [anon_sym_DASH_EQ] = ACTIONS(2290),
    [anon_sym_LT_LT_EQ] = ACTIONS(2290),
    [anon_sym_GT_GT_EQ] = ACTIONS(2290),
    [anon_sym_AMP_EQ] = ACTIONS(2290),
    [anon_sym_CARET_EQ] = ACTIONS(2290),
    [anon_sym_PIPE_EQ] = ACTIONS(2290),
    [anon_sym_and_eq] = ACTIONS(2288),
    [anon_sym_or_eq] = ACTIONS(2288),
    [anon_sym_xor_eq] = ACTIONS(2288),
    [anon_sym_LT_EQ_GT] = ACTIONS(2290),
    [anon_sym_or] = ACTIONS(2288),
    [anon_sym_and] = ACTIONS(2288),
    [anon_sym_bitor] = ACTIONS(2288),
    [anon_sym_xor] = ACTIONS(2288),
    [anon_sym_bitand] = ACTIONS(2288),
    [anon_sym_not_eq] = ACTIONS(2288),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DOT] = ACTIONS(2288),
    [anon_sym_DOT_STAR] = ACTIONS(2290),
    [anon_sym_DASH_GT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2288),
    [anon_sym_decltype] = ACTIONS(2288),
  },
  [2749] = {
    [sym_argument_list] = STATE(2943),
    [sym_initializer_list] = STATE(2943),
    [sym_identifier] = ACTIONS(6801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6803),
    [anon_sym_COMMA] = ACTIONS(6803),
    [anon_sym_RPAREN] = ACTIONS(6803),
    [aux_sym_preproc_if_token2] = ACTIONS(6803),
    [aux_sym_preproc_else_token1] = ACTIONS(6803),
    [aux_sym_preproc_elif_token1] = ACTIONS(6801),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6803),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6803),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6801),
    [anon_sym_PLUS] = ACTIONS(6801),
    [anon_sym_STAR] = ACTIONS(6801),
    [anon_sym_SLASH] = ACTIONS(6801),
    [anon_sym_PERCENT] = ACTIONS(6801),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_PIPE] = ACTIONS(6801),
    [anon_sym_CARET] = ACTIONS(6801),
    [anon_sym_AMP] = ACTIONS(6801),
    [anon_sym_EQ_EQ] = ACTIONS(6803),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_GT] = ACTIONS(6801),
    [anon_sym_GT_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6801),
    [anon_sym_LT] = ACTIONS(6801),
    [anon_sym_LT_LT] = ACTIONS(6801),
    [anon_sym_GT_GT] = ACTIONS(6801),
    [anon_sym_COLON] = ACTIONS(6803),
    [anon_sym_SEMI] = ACTIONS(6803),
    [anon_sym___attribute__] = ACTIONS(6801),
    [anon_sym___attribute] = ACTIONS(6801),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6803),
    [anon_sym_LBRACK] = ACTIONS(6803),
    [anon_sym_RBRACK] = ACTIONS(6803),
    [anon_sym_EQ] = ACTIONS(6801),
    [anon_sym_QMARK] = ACTIONS(6803),
    [anon_sym_STAR_EQ] = ACTIONS(6803),
    [anon_sym_SLASH_EQ] = ACTIONS(6803),
    [anon_sym_PERCENT_EQ] = ACTIONS(6803),
    [anon_sym_PLUS_EQ] = ACTIONS(6803),
    [anon_sym_DASH_EQ] = ACTIONS(6803),
    [anon_sym_LT_LT_EQ] = ACTIONS(6803),
    [anon_sym_GT_GT_EQ] = ACTIONS(6803),
    [anon_sym_AMP_EQ] = ACTIONS(6803),
    [anon_sym_CARET_EQ] = ACTIONS(6803),
    [anon_sym_PIPE_EQ] = ACTIONS(6803),
    [anon_sym_and_eq] = ACTIONS(6801),
    [anon_sym_or_eq] = ACTIONS(6801),
    [anon_sym_xor_eq] = ACTIONS(6801),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_or] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(6801),
    [anon_sym_bitor] = ACTIONS(6801),
    [anon_sym_xor] = ACTIONS(6801),
    [anon_sym_bitand] = ACTIONS(6801),
    [anon_sym_not_eq] = ACTIONS(6801),
    [anon_sym_DASH_DASH] = ACTIONS(6803),
    [anon_sym_PLUS_PLUS] = ACTIONS(6803),
    [anon_sym_DOT] = ACTIONS(6801),
    [anon_sym_DOT_STAR] = ACTIONS(6803),
    [anon_sym_DASH_GT] = ACTIONS(6803),
    [sym_comment] = ACTIONS(3),
  },
  [2750] = {
    [sym_argument_list] = STATE(2952),
    [sym_initializer_list] = STATE(2952),
    [sym_identifier] = ACTIONS(6805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6807),
    [anon_sym_COMMA] = ACTIONS(6807),
    [anon_sym_RPAREN] = ACTIONS(6807),
    [aux_sym_preproc_if_token2] = ACTIONS(6807),
    [aux_sym_preproc_else_token1] = ACTIONS(6807),
    [aux_sym_preproc_elif_token1] = ACTIONS(6805),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6807),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6807),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6805),
    [anon_sym_PLUS] = ACTIONS(6805),
    [anon_sym_STAR] = ACTIONS(6805),
    [anon_sym_SLASH] = ACTIONS(6805),
    [anon_sym_PERCENT] = ACTIONS(6805),
    [anon_sym_PIPE_PIPE] = ACTIONS(6807),
    [anon_sym_AMP_AMP] = ACTIONS(6807),
    [anon_sym_PIPE] = ACTIONS(6805),
    [anon_sym_CARET] = ACTIONS(6805),
    [anon_sym_AMP] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6807),
    [anon_sym_GT] = ACTIONS(6805),
    [anon_sym_GT_EQ] = ACTIONS(6807),
    [anon_sym_LT_EQ] = ACTIONS(6805),
    [anon_sym_LT] = ACTIONS(6805),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_COLON] = ACTIONS(6807),
    [anon_sym_SEMI] = ACTIONS(6807),
    [anon_sym___attribute__] = ACTIONS(6805),
    [anon_sym___attribute] = ACTIONS(6805),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6807),
    [anon_sym_LBRACK] = ACTIONS(6807),
    [anon_sym_RBRACK] = ACTIONS(6807),
    [anon_sym_EQ] = ACTIONS(6805),
    [anon_sym_QMARK] = ACTIONS(6807),
    [anon_sym_STAR_EQ] = ACTIONS(6807),
    [anon_sym_SLASH_EQ] = ACTIONS(6807),
    [anon_sym_PERCENT_EQ] = ACTIONS(6807),
    [anon_sym_PLUS_EQ] = ACTIONS(6807),
    [anon_sym_DASH_EQ] = ACTIONS(6807),
    [anon_sym_LT_LT_EQ] = ACTIONS(6807),
    [anon_sym_GT_GT_EQ] = ACTIONS(6807),
    [anon_sym_AMP_EQ] = ACTIONS(6807),
    [anon_sym_CARET_EQ] = ACTIONS(6807),
    [anon_sym_PIPE_EQ] = ACTIONS(6807),
    [anon_sym_and_eq] = ACTIONS(6805),
    [anon_sym_or_eq] = ACTIONS(6805),
    [anon_sym_xor_eq] = ACTIONS(6805),
    [anon_sym_LT_EQ_GT] = ACTIONS(6807),
    [anon_sym_or] = ACTIONS(6805),
    [anon_sym_and] = ACTIONS(6805),
    [anon_sym_bitor] = ACTIONS(6805),
    [anon_sym_xor] = ACTIONS(6805),
    [anon_sym_bitand] = ACTIONS(6805),
    [anon_sym_not_eq] = ACTIONS(6805),
    [anon_sym_DASH_DASH] = ACTIONS(6807),
    [anon_sym_PLUS_PLUS] = ACTIONS(6807),
    [anon_sym_DOT] = ACTIONS(6805),
    [anon_sym_DOT_STAR] = ACTIONS(6807),
    [anon_sym_DASH_GT] = ACTIONS(6807),
    [sym_comment] = ACTIONS(3),
  },
  [2751] = {
    [sym_attribute_declaration] = STATE(2796),
    [aux_sym_attributed_declarator_repeat1] = STATE(2796),
    [sym_identifier] = ACTIONS(6809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6811),
    [anon_sym_COMMA] = ACTIONS(6811),
    [anon_sym_RPAREN] = ACTIONS(6811),
    [aux_sym_preproc_if_token2] = ACTIONS(6811),
    [aux_sym_preproc_else_token1] = ACTIONS(6811),
    [aux_sym_preproc_elif_token1] = ACTIONS(6809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6811),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6811),
    [anon_sym_LPAREN2] = ACTIONS(6811),
    [anon_sym_DASH] = ACTIONS(6809),
    [anon_sym_PLUS] = ACTIONS(6809),
    [anon_sym_STAR] = ACTIONS(6809),
    [anon_sym_SLASH] = ACTIONS(6809),
    [anon_sym_PERCENT] = ACTIONS(6809),
    [anon_sym_PIPE_PIPE] = ACTIONS(6811),
    [anon_sym_AMP_AMP] = ACTIONS(6811),
    [anon_sym_PIPE] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6809),
    [anon_sym_AMP] = ACTIONS(6809),
    [anon_sym_EQ_EQ] = ACTIONS(6811),
    [anon_sym_BANG_EQ] = ACTIONS(6811),
    [anon_sym_GT] = ACTIONS(6809),
    [anon_sym_GT_EQ] = ACTIONS(6811),
    [anon_sym_LT_EQ] = ACTIONS(6809),
    [anon_sym_LT] = ACTIONS(6809),
    [anon_sym_LT_LT] = ACTIONS(6809),
    [anon_sym_GT_GT] = ACTIONS(6809),
    [anon_sym_COLON] = ACTIONS(6811),
    [anon_sym_SEMI] = ACTIONS(6811),
    [anon_sym___attribute__] = ACTIONS(6809),
    [anon_sym___attribute] = ACTIONS(6809),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6678),
    [anon_sym_RBRACE] = ACTIONS(6811),
    [anon_sym_LBRACK] = ACTIONS(6809),
    [anon_sym_RBRACK] = ACTIONS(6811),
    [anon_sym_EQ] = ACTIONS(6809),
    [anon_sym_QMARK] = ACTIONS(6811),
    [anon_sym_STAR_EQ] = ACTIONS(6811),
    [anon_sym_SLASH_EQ] = ACTIONS(6811),
    [anon_sym_PERCENT_EQ] = ACTIONS(6811),
    [anon_sym_PLUS_EQ] = ACTIONS(6811),
    [anon_sym_DASH_EQ] = ACTIONS(6811),
    [anon_sym_LT_LT_EQ] = ACTIONS(6811),
    [anon_sym_GT_GT_EQ] = ACTIONS(6811),
    [anon_sym_AMP_EQ] = ACTIONS(6811),
    [anon_sym_CARET_EQ] = ACTIONS(6811),
    [anon_sym_PIPE_EQ] = ACTIONS(6811),
    [anon_sym_and_eq] = ACTIONS(6809),
    [anon_sym_or_eq] = ACTIONS(6809),
    [anon_sym_xor_eq] = ACTIONS(6809),
    [anon_sym_LT_EQ_GT] = ACTIONS(6811),
    [anon_sym_or] = ACTIONS(6809),
    [anon_sym_and] = ACTIONS(6809),
    [anon_sym_bitor] = ACTIONS(6809),
    [anon_sym_xor] = ACTIONS(6809),
    [anon_sym_bitand] = ACTIONS(6809),
    [anon_sym_not_eq] = ACTIONS(6809),
    [anon_sym_DASH_DASH] = ACTIONS(6811),
    [anon_sym_PLUS_PLUS] = ACTIONS(6811),
    [anon_sym_DOT] = ACTIONS(6809),
    [anon_sym_DOT_STAR] = ACTIONS(6811),
    [anon_sym_DASH_GT] = ACTIONS(6811),
    [sym_comment] = ACTIONS(3),
  },
  [2752] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2756),
    [sym_identifier] = ACTIONS(5939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5941),
    [aux_sym_preproc_if_token2] = ACTIONS(5941),
    [aux_sym_preproc_else_token1] = ACTIONS(5941),
    [aux_sym_preproc_elif_token1] = ACTIONS(5939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_DASH] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5939),
    [anon_sym_SLASH] = ACTIONS(5939),
    [anon_sym_PERCENT] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_PIPE] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5939),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5939),
    [anon_sym_GT_EQ] = ACTIONS(5941),
    [anon_sym_LT_EQ] = ACTIONS(5939),
    [anon_sym_LT] = ACTIONS(5939),
    [anon_sym_LT_LT] = ACTIONS(5939),
    [anon_sym_GT_GT] = ACTIONS(5939),
    [anon_sym___attribute__] = ACTIONS(5939),
    [anon_sym___attribute] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(6813),
    [anon_sym_unsigned] = ACTIONS(6813),
    [anon_sym_long] = ACTIONS(6813),
    [anon_sym_short] = ACTIONS(6813),
    [anon_sym_LBRACK] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5939),
    [anon_sym_or_eq] = ACTIONS(5939),
    [anon_sym_xor_eq] = ACTIONS(5939),
    [anon_sym_LT_EQ_GT] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5939),
    [anon_sym_bitor] = ACTIONS(5939),
    [anon_sym_xor] = ACTIONS(5939),
    [anon_sym_bitand] = ACTIONS(5939),
    [anon_sym_not_eq] = ACTIONS(5939),
    [anon_sym_DASH_DASH] = ACTIONS(5941),
    [anon_sym_PLUS_PLUS] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_DOT_STAR] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5939),
    [anon_sym_decltype] = ACTIONS(5939),
  },
  [2753] = {
    [sym_string_literal] = STATE(2645),
    [sym_raw_string_literal] = STATE(2645),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6606),
    [anon_sym_COMMA] = ACTIONS(6606),
    [anon_sym_LPAREN2] = ACTIONS(6606),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_PERCENT] = ACTIONS(6604),
    [anon_sym_PIPE_PIPE] = ACTIONS(6606),
    [anon_sym_AMP_AMP] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_AMP] = ACTIONS(6604),
    [anon_sym_EQ_EQ] = ACTIONS(6606),
    [anon_sym_BANG_EQ] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6604),
    [anon_sym_GT_EQ] = ACTIONS(6606),
    [anon_sym_LT_EQ] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6604),
    [anon_sym_LT_LT] = ACTIONS(6604),
    [anon_sym_GT_GT] = ACTIONS(6604),
    [anon_sym_SEMI] = ACTIONS(6606),
    [anon_sym___attribute__] = ACTIONS(6604),
    [anon_sym___attribute] = ACTIONS(6604),
    [anon_sym_LBRACK] = ACTIONS(6606),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_QMARK] = ACTIONS(6606),
    [anon_sym_STAR_EQ] = ACTIONS(6606),
    [anon_sym_SLASH_EQ] = ACTIONS(6606),
    [anon_sym_PERCENT_EQ] = ACTIONS(6606),
    [anon_sym_PLUS_EQ] = ACTIONS(6606),
    [anon_sym_DASH_EQ] = ACTIONS(6606),
    [anon_sym_LT_LT_EQ] = ACTIONS(6606),
    [anon_sym_GT_GT_EQ] = ACTIONS(6606),
    [anon_sym_AMP_EQ] = ACTIONS(6606),
    [anon_sym_CARET_EQ] = ACTIONS(6606),
    [anon_sym_PIPE_EQ] = ACTIONS(6606),
    [anon_sym_and_eq] = ACTIONS(6604),
    [anon_sym_or_eq] = ACTIONS(6604),
    [anon_sym_xor_eq] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6604),
    [anon_sym_and] = ACTIONS(6604),
    [anon_sym_bitor] = ACTIONS(6604),
    [anon_sym_xor] = ACTIONS(6604),
    [anon_sym_bitand] = ACTIONS(6604),
    [anon_sym_not_eq] = ACTIONS(6604),
    [anon_sym_DASH_DASH] = ACTIONS(6606),
    [anon_sym_PLUS_PLUS] = ACTIONS(6606),
    [anon_sym_DOT] = ACTIONS(6604),
    [anon_sym_DOT_STAR] = ACTIONS(6606),
    [anon_sym_DASH_GT] = ACTIONS(6606),
    [anon_sym_L_DQUOTE] = ACTIONS(6619),
    [anon_sym_u_DQUOTE] = ACTIONS(6619),
    [anon_sym_U_DQUOTE] = ACTIONS(6619),
    [anon_sym_u8_DQUOTE] = ACTIONS(6619),
    [anon_sym_DQUOTE] = ACTIONS(6619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6621),
    [anon_sym_LR_DQUOTE] = ACTIONS(6621),
    [anon_sym_uR_DQUOTE] = ACTIONS(6621),
    [anon_sym_UR_DQUOTE] = ACTIONS(6621),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6621),
    [sym_literal_suffix] = ACTIONS(6604),
  },
  [2754] = {
    [sym_string_literal] = STATE(2754),
    [sym_raw_string_literal] = STATE(2754),
    [aux_sym_concatenated_string_repeat1] = STATE(2754),
    [sym_identifier] = ACTIONS(6815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_LPAREN2] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6434),
    [anon_sym_PLUS] = ACTIONS(6434),
    [anon_sym_STAR] = ACTIONS(6434),
    [anon_sym_SLASH] = ACTIONS(6434),
    [anon_sym_PERCENT] = ACTIONS(6434),
    [anon_sym_PIPE_PIPE] = ACTIONS(6432),
    [anon_sym_AMP_AMP] = ACTIONS(6432),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_CARET] = ACTIONS(6434),
    [anon_sym_AMP] = ACTIONS(6434),
    [anon_sym_EQ_EQ] = ACTIONS(6432),
    [anon_sym_BANG_EQ] = ACTIONS(6432),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_GT_EQ] = ACTIONS(6434),
    [anon_sym_LT_EQ] = ACTIONS(6434),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_LT_LT] = ACTIONS(6434),
    [anon_sym_GT_GT] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6434),
    [anon_sym_QMARK] = ACTIONS(6432),
    [anon_sym_STAR_EQ] = ACTIONS(6432),
    [anon_sym_SLASH_EQ] = ACTIONS(6432),
    [anon_sym_PERCENT_EQ] = ACTIONS(6432),
    [anon_sym_PLUS_EQ] = ACTIONS(6432),
    [anon_sym_DASH_EQ] = ACTIONS(6432),
    [anon_sym_LT_LT_EQ] = ACTIONS(6432),
    [anon_sym_GT_GT_EQ] = ACTIONS(6434),
    [anon_sym_AMP_EQ] = ACTIONS(6432),
    [anon_sym_CARET_EQ] = ACTIONS(6432),
    [anon_sym_PIPE_EQ] = ACTIONS(6432),
    [anon_sym_and_eq] = ACTIONS(6434),
    [anon_sym_or_eq] = ACTIONS(6434),
    [anon_sym_xor_eq] = ACTIONS(6434),
    [anon_sym_LT_EQ_GT] = ACTIONS(6432),
    [anon_sym_or] = ACTIONS(6434),
    [anon_sym_and] = ACTIONS(6434),
    [anon_sym_bitor] = ACTIONS(6434),
    [anon_sym_xor] = ACTIONS(6434),
    [anon_sym_bitand] = ACTIONS(6434),
    [anon_sym_not_eq] = ACTIONS(6434),
    [anon_sym_DASH_DASH] = ACTIONS(6432),
    [anon_sym_PLUS_PLUS] = ACTIONS(6432),
    [anon_sym_DOT] = ACTIONS(6434),
    [anon_sym_DOT_STAR] = ACTIONS(6432),
    [anon_sym_DASH_GT] = ACTIONS(6432),
    [anon_sym_L_DQUOTE] = ACTIONS(6818),
    [anon_sym_u_DQUOTE] = ACTIONS(6818),
    [anon_sym_U_DQUOTE] = ACTIONS(6818),
    [anon_sym_u8_DQUOTE] = ACTIONS(6818),
    [anon_sym_DQUOTE] = ACTIONS(6818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6432),
    [anon_sym_R_DQUOTE] = ACTIONS(6821),
    [anon_sym_LR_DQUOTE] = ACTIONS(6821),
    [anon_sym_uR_DQUOTE] = ACTIONS(6821),
    [anon_sym_UR_DQUOTE] = ACTIONS(6821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6821),
    [sym_literal_suffix] = ACTIONS(6434),
  },
  [2755] = {
    [sym_argument_list] = STATE(2919),
    [sym_initializer_list] = STATE(2919),
    [sym_identifier] = ACTIONS(6824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6826),
    [anon_sym_COMMA] = ACTIONS(6826),
    [anon_sym_RPAREN] = ACTIONS(6826),
    [aux_sym_preproc_if_token2] = ACTIONS(6826),
    [aux_sym_preproc_else_token1] = ACTIONS(6826),
    [aux_sym_preproc_elif_token1] = ACTIONS(6824),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6826),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6826),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6824),
    [anon_sym_PLUS] = ACTIONS(6824),
    [anon_sym_STAR] = ACTIONS(6824),
    [anon_sym_SLASH] = ACTIONS(6824),
    [anon_sym_PERCENT] = ACTIONS(6824),
    [anon_sym_PIPE_PIPE] = ACTIONS(6826),
    [anon_sym_AMP_AMP] = ACTIONS(6826),
    [anon_sym_PIPE] = ACTIONS(6824),
    [anon_sym_CARET] = ACTIONS(6824),
    [anon_sym_AMP] = ACTIONS(6824),
    [anon_sym_EQ_EQ] = ACTIONS(6826),
    [anon_sym_BANG_EQ] = ACTIONS(6826),
    [anon_sym_GT] = ACTIONS(6824),
    [anon_sym_GT_EQ] = ACTIONS(6826),
    [anon_sym_LT_EQ] = ACTIONS(6824),
    [anon_sym_LT] = ACTIONS(6824),
    [anon_sym_LT_LT] = ACTIONS(6824),
    [anon_sym_GT_GT] = ACTIONS(6824),
    [anon_sym_COLON] = ACTIONS(6826),
    [anon_sym_SEMI] = ACTIONS(6826),
    [anon_sym___attribute__] = ACTIONS(6824),
    [anon_sym___attribute] = ACTIONS(6824),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6826),
    [anon_sym_LBRACK] = ACTIONS(6826),
    [anon_sym_RBRACK] = ACTIONS(6826),
    [anon_sym_EQ] = ACTIONS(6824),
    [anon_sym_QMARK] = ACTIONS(6826),
    [anon_sym_STAR_EQ] = ACTIONS(6826),
    [anon_sym_SLASH_EQ] = ACTIONS(6826),
    [anon_sym_PERCENT_EQ] = ACTIONS(6826),
    [anon_sym_PLUS_EQ] = ACTIONS(6826),
    [anon_sym_DASH_EQ] = ACTIONS(6826),
    [anon_sym_LT_LT_EQ] = ACTIONS(6826),
    [anon_sym_GT_GT_EQ] = ACTIONS(6826),
    [anon_sym_AMP_EQ] = ACTIONS(6826),
    [anon_sym_CARET_EQ] = ACTIONS(6826),
    [anon_sym_PIPE_EQ] = ACTIONS(6826),
    [anon_sym_and_eq] = ACTIONS(6824),
    [anon_sym_or_eq] = ACTIONS(6824),
    [anon_sym_xor_eq] = ACTIONS(6824),
    [anon_sym_LT_EQ_GT] = ACTIONS(6826),
    [anon_sym_or] = ACTIONS(6824),
    [anon_sym_and] = ACTIONS(6824),
    [anon_sym_bitor] = ACTIONS(6824),
    [anon_sym_xor] = ACTIONS(6824),
    [anon_sym_bitand] = ACTIONS(6824),
    [anon_sym_not_eq] = ACTIONS(6824),
    [anon_sym_DASH_DASH] = ACTIONS(6826),
    [anon_sym_PLUS_PLUS] = ACTIONS(6826),
    [anon_sym_DOT] = ACTIONS(6824),
    [anon_sym_DOT_STAR] = ACTIONS(6826),
    [anon_sym_DASH_GT] = ACTIONS(6826),
    [sym_comment] = ACTIONS(3),
  },
  [2756] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [aux_sym_preproc_if_token2] = ACTIONS(5919),
    [aux_sym_preproc_else_token1] = ACTIONS(5919),
    [aux_sym_preproc_elif_token1] = ACTIONS(5917),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5917),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5919),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5917),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym___attribute__] = ACTIONS(5917),
    [anon_sym___attribute] = ACTIONS(5917),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_STAR_EQ] = ACTIONS(5919),
    [anon_sym_SLASH_EQ] = ACTIONS(5919),
    [anon_sym_PERCENT_EQ] = ACTIONS(5919),
    [anon_sym_PLUS_EQ] = ACTIONS(5919),
    [anon_sym_DASH_EQ] = ACTIONS(5919),
    [anon_sym_LT_LT_EQ] = ACTIONS(5919),
    [anon_sym_GT_GT_EQ] = ACTIONS(5919),
    [anon_sym_AMP_EQ] = ACTIONS(5919),
    [anon_sym_CARET_EQ] = ACTIONS(5919),
    [anon_sym_PIPE_EQ] = ACTIONS(5919),
    [anon_sym_and_eq] = ACTIONS(5917),
    [anon_sym_or_eq] = ACTIONS(5917),
    [anon_sym_xor_eq] = ACTIONS(5917),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5917),
    [anon_sym_and] = ACTIONS(5917),
    [anon_sym_bitor] = ACTIONS(5917),
    [anon_sym_xor] = ACTIONS(5917),
    [anon_sym_bitand] = ACTIONS(5917),
    [anon_sym_not_eq] = ACTIONS(5917),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5917),
    [anon_sym_decltype] = ACTIONS(5917),
  },
  [2757] = {
    [sym_argument_list] = STATE(2890),
    [sym_initializer_list] = STATE(2890),
    [sym_identifier] = ACTIONS(6828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6830),
    [anon_sym_COMMA] = ACTIONS(6830),
    [anon_sym_RPAREN] = ACTIONS(6830),
    [aux_sym_preproc_if_token2] = ACTIONS(6830),
    [aux_sym_preproc_else_token1] = ACTIONS(6830),
    [aux_sym_preproc_elif_token1] = ACTIONS(6828),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6830),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6830),
    [anon_sym_LPAREN2] = ACTIONS(6549),
    [anon_sym_DASH] = ACTIONS(6828),
    [anon_sym_PLUS] = ACTIONS(6828),
    [anon_sym_STAR] = ACTIONS(6828),
    [anon_sym_SLASH] = ACTIONS(6828),
    [anon_sym_PERCENT] = ACTIONS(6828),
    [anon_sym_PIPE_PIPE] = ACTIONS(6830),
    [anon_sym_AMP_AMP] = ACTIONS(6830),
    [anon_sym_PIPE] = ACTIONS(6828),
    [anon_sym_CARET] = ACTIONS(6828),
    [anon_sym_AMP] = ACTIONS(6828),
    [anon_sym_EQ_EQ] = ACTIONS(6830),
    [anon_sym_BANG_EQ] = ACTIONS(6830),
    [anon_sym_GT] = ACTIONS(6828),
    [anon_sym_GT_EQ] = ACTIONS(6830),
    [anon_sym_LT_EQ] = ACTIONS(6828),
    [anon_sym_LT] = ACTIONS(6828),
    [anon_sym_LT_LT] = ACTIONS(6828),
    [anon_sym_GT_GT] = ACTIONS(6828),
    [anon_sym_COLON] = ACTIONS(6830),
    [anon_sym_SEMI] = ACTIONS(6830),
    [anon_sym___attribute__] = ACTIONS(6828),
    [anon_sym___attribute] = ACTIONS(6828),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(6830),
    [anon_sym_LBRACK] = ACTIONS(6830),
    [anon_sym_RBRACK] = ACTIONS(6830),
    [anon_sym_EQ] = ACTIONS(6828),
    [anon_sym_QMARK] = ACTIONS(6830),
    [anon_sym_STAR_EQ] = ACTIONS(6830),
    [anon_sym_SLASH_EQ] = ACTIONS(6830),
    [anon_sym_PERCENT_EQ] = ACTIONS(6830),
    [anon_sym_PLUS_EQ] = ACTIONS(6830),
    [anon_sym_DASH_EQ] = ACTIONS(6830),
    [anon_sym_LT_LT_EQ] = ACTIONS(6830),
    [anon_sym_GT_GT_EQ] = ACTIONS(6830),
    [anon_sym_AMP_EQ] = ACTIONS(6830),
    [anon_sym_CARET_EQ] = ACTIONS(6830),
    [anon_sym_PIPE_EQ] = ACTIONS(6830),
    [anon_sym_and_eq] = ACTIONS(6828),
    [anon_sym_or_eq] = ACTIONS(6828),
    [anon_sym_xor_eq] = ACTIONS(6828),
    [anon_sym_LT_EQ_GT] = ACTIONS(6830),
    [anon_sym_or] = ACTIONS(6828),
    [anon_sym_and] = ACTIONS(6828),
    [anon_sym_bitor] = ACTIONS(6828),
    [anon_sym_xor] = ACTIONS(6828),
    [anon_sym_bitand] = ACTIONS(6828),
    [anon_sym_not_eq] = ACTIONS(6828),
    [anon_sym_DASH_DASH] = ACTIONS(6830),
    [anon_sym_PLUS_PLUS] = ACTIONS(6830),
    [anon_sym_DOT] = ACTIONS(6828),
    [anon_sym_DOT_STAR] = ACTIONS(6830),
    [anon_sym_DASH_GT] = ACTIONS(6830),
    [sym_comment] = ACTIONS(3),
  },
  [2758] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5923),
    [anon_sym_DASH] = ACTIONS(5921),
    [anon_sym_PLUS] = ACTIONS(5921),
    [anon_sym_STAR] = ACTIONS(5923),
    [anon_sym_SLASH] = ACTIONS(5921),
    [anon_sym_PERCENT] = ACTIONS(5923),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5923),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT] = ACTIONS(5921),
    [anon_sym_GT_EQ] = ACTIONS(5921),
    [anon_sym_LT_EQ] = ACTIONS(5921),
    [anon_sym_LT] = ACTIONS(5921),
    [anon_sym_LT_LT] = ACTIONS(5923),
    [anon_sym_GT_GT] = ACTIONS(5921),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym___extension__] = ACTIONS(5923),
    [anon_sym___attribute__] = ACTIONS(5923),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_LBRACE] = ACTIONS(5923),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_const] = ACTIONS(5921),
    [anon_sym_constexpr] = ACTIONS(5923),
    [anon_sym_volatile] = ACTIONS(5923),
    [anon_sym_restrict] = ACTIONS(5923),
    [anon_sym___restrict__] = ACTIONS(5923),
    [anon_sym__Atomic] = ACTIONS(5923),
    [anon_sym__Noreturn] = ACTIONS(5923),
    [anon_sym_noreturn] = ACTIONS(5923),
    [anon_sym__Nonnull] = ACTIONS(5923),
    [anon_sym_mutable] = ACTIONS(5923),
    [anon_sym_constinit] = ACTIONS(5923),
    [anon_sym_consteval] = ACTIONS(5923),
    [anon_sym_alignas] = ACTIONS(5923),
    [anon_sym__Alignas] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(5923),
    [anon_sym_LT_EQ_GT] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5923),
    [anon_sym_and] = ACTIONS(5923),
    [anon_sym_bitor] = ACTIONS(5923),
    [anon_sym_xor] = ACTIONS(5923),
    [anon_sym_bitand] = ACTIONS(5923),
    [anon_sym_not_eq] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_DOT_STAR] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5923),
    [anon_sym_decltype] = ACTIONS(5923),
    [anon_sym_final] = ACTIONS(5923),
    [anon_sym_override] = ACTIONS(5923),
    [anon_sym_GT2] = ACTIONS(5923),
    [anon_sym_requires] = ACTIONS(5923),
  },
  [2759] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_PLUS] = ACTIONS(5906),
    [anon_sym_STAR] = ACTIONS(5908),
    [anon_sym_SLASH] = ACTIONS(5906),
    [anon_sym_PERCENT] = ACTIONS(5908),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_CARET] = ACTIONS(5908),
    [anon_sym_AMP] = ACTIONS(5906),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5906),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_LT_LT] = ACTIONS(5908),
    [anon_sym_GT_GT] = ACTIONS(5906),
    [anon_sym_COLON] = ACTIONS(5908),
    [anon_sym___extension__] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6764),
    [anon_sym_unsigned] = ACTIONS(6764),
    [anon_sym_long] = ACTIONS(6764),
    [anon_sym_short] = ACTIONS(6764),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_const] = ACTIONS(5906),
    [anon_sym_constexpr] = ACTIONS(5908),
    [anon_sym_volatile] = ACTIONS(5908),
    [anon_sym_restrict] = ACTIONS(5908),
    [anon_sym___restrict__] = ACTIONS(5908),
    [anon_sym__Atomic] = ACTIONS(5908),
    [anon_sym__Noreturn] = ACTIONS(5908),
    [anon_sym_noreturn] = ACTIONS(5908),
    [anon_sym__Nonnull] = ACTIONS(5908),
    [anon_sym_mutable] = ACTIONS(5908),
    [anon_sym_constinit] = ACTIONS(5908),
    [anon_sym_consteval] = ACTIONS(5908),
    [anon_sym_alignas] = ACTIONS(5908),
    [anon_sym__Alignas] = ACTIONS(5908),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5908),
    [anon_sym_and] = ACTIONS(5908),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5908),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
    [anon_sym_final] = ACTIONS(5908),
    [anon_sym_override] = ACTIONS(5908),
    [anon_sym_GT2] = ACTIONS(5908),
    [anon_sym_requires] = ACTIONS(5908),
  },
  [2760] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [aux_sym_preproc_if_token2] = ACTIONS(5927),
    [aux_sym_preproc_else_token1] = ACTIONS(5927),
    [aux_sym_preproc_elif_token1] = ACTIONS(5925),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5927),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5925),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5925),
    [anon_sym_PIPE_PIPE] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(5925),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_EQ_EQ] = ACTIONS(5927),
    [anon_sym_BANG_EQ] = ACTIONS(5927),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_EQ] = ACTIONS(5925),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5925),
    [anon_sym_GT_GT] = ACTIONS(5925),
    [anon_sym___attribute__] = ACTIONS(5925),
    [anon_sym___attribute] = ACTIONS(5925),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_EQ] = ACTIONS(5925),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_and_eq] = ACTIONS(5925),
    [anon_sym_or_eq] = ACTIONS(5925),
    [anon_sym_xor_eq] = ACTIONS(5925),
    [anon_sym_LT_EQ_GT] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5925),
    [anon_sym_and] = ACTIONS(5925),
    [anon_sym_bitor] = ACTIONS(5925),
    [anon_sym_xor] = ACTIONS(5925),
    [anon_sym_bitand] = ACTIONS(5925),
    [anon_sym_not_eq] = ACTIONS(5925),
    [anon_sym_DASH_DASH] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_DOT_STAR] = ACTIONS(5927),
    [anon_sym_DASH_GT] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5925),
    [anon_sym_decltype] = ACTIONS(5925),
  },
  [2761] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2787),
    [sym_identifier] = ACTIONS(5929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5931),
    [anon_sym_COMMA] = ACTIONS(5931),
    [aux_sym_preproc_if_token2] = ACTIONS(5931),
    [aux_sym_preproc_else_token1] = ACTIONS(5931),
    [aux_sym_preproc_elif_token1] = ACTIONS(5929),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5931),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5931),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5929),
    [anon_sym_STAR] = ACTIONS(5929),
    [anon_sym_SLASH] = ACTIONS(5929),
    [anon_sym_PERCENT] = ACTIONS(5929),
    [anon_sym_PIPE_PIPE] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5931),
    [anon_sym_PIPE] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5929),
    [anon_sym_AMP] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5931),
    [anon_sym_BANG_EQ] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5931),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5929),
    [anon_sym_LT_LT] = ACTIONS(5929),
    [anon_sym_GT_GT] = ACTIONS(5929),
    [anon_sym___attribute__] = ACTIONS(5929),
    [anon_sym___attribute] = ACTIONS(5929),
    [anon_sym_LBRACE] = ACTIONS(5931),
    [anon_sym_signed] = ACTIONS(6832),
    [anon_sym_unsigned] = ACTIONS(6832),
    [anon_sym_long] = ACTIONS(6832),
    [anon_sym_short] = ACTIONS(6832),
    [anon_sym_LBRACK] = ACTIONS(5931),
    [anon_sym_EQ] = ACTIONS(5929),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_STAR_EQ] = ACTIONS(5931),
    [anon_sym_SLASH_EQ] = ACTIONS(5931),
    [anon_sym_PERCENT_EQ] = ACTIONS(5931),
    [anon_sym_PLUS_EQ] = ACTIONS(5931),
    [anon_sym_DASH_EQ] = ACTIONS(5931),
    [anon_sym_LT_LT_EQ] = ACTIONS(5931),
    [anon_sym_GT_GT_EQ] = ACTIONS(5931),
    [anon_sym_AMP_EQ] = ACTIONS(5931),
    [anon_sym_CARET_EQ] = ACTIONS(5931),
    [anon_sym_PIPE_EQ] = ACTIONS(5931),
    [anon_sym_and_eq] = ACTIONS(5929),
    [anon_sym_or_eq] = ACTIONS(5929),
    [anon_sym_xor_eq] = ACTIONS(5929),
    [anon_sym_LT_EQ_GT] = ACTIONS(5931),
    [anon_sym_or] = ACTIONS(5929),
    [anon_sym_and] = ACTIONS(5929),
    [anon_sym_bitor] = ACTIONS(5929),
    [anon_sym_xor] = ACTIONS(5929),
    [anon_sym_bitand] = ACTIONS(5929),
    [anon_sym_not_eq] = ACTIONS(5929),
    [anon_sym_DASH_DASH] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5931),
    [anon_sym_DOT] = ACTIONS(5929),
    [anon_sym_DOT_STAR] = ACTIONS(5931),
    [anon_sym_DASH_GT] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5929),
    [anon_sym_decltype] = ACTIONS(5929),
  },
  [2762] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2793),
    [sym_identifier] = ACTIONS(5884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5886),
    [aux_sym_preproc_if_token2] = ACTIONS(5886),
    [aux_sym_preproc_else_token1] = ACTIONS(5886),
    [aux_sym_preproc_elif_token1] = ACTIONS(5884),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5886),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5886),
    [anon_sym_LPAREN2] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_SLASH] = ACTIONS(5884),
    [anon_sym_PERCENT] = ACTIONS(5884),
    [anon_sym_PIPE_PIPE] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_PIPE] = ACTIONS(5884),
    [anon_sym_CARET] = ACTIONS(5884),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_EQ_EQ] = ACTIONS(5886),
    [anon_sym_BANG_EQ] = ACTIONS(5886),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(5884),
    [anon_sym_GT_GT] = ACTIONS(5884),
    [anon_sym___attribute__] = ACTIONS(5884),
    [anon_sym___attribute] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(6834),
    [anon_sym_unsigned] = ACTIONS(6834),
    [anon_sym_long] = ACTIONS(6834),
    [anon_sym_short] = ACTIONS(6834),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5884),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_STAR_EQ] = ACTIONS(5886),
    [anon_sym_SLASH_EQ] = ACTIONS(5886),
    [anon_sym_PERCENT_EQ] = ACTIONS(5886),
    [anon_sym_PLUS_EQ] = ACTIONS(5886),
    [anon_sym_DASH_EQ] = ACTIONS(5886),
    [anon_sym_LT_LT_EQ] = ACTIONS(5886),
    [anon_sym_GT_GT_EQ] = ACTIONS(5886),
    [anon_sym_AMP_EQ] = ACTIONS(5886),
    [anon_sym_CARET_EQ] = ACTIONS(5886),
    [anon_sym_PIPE_EQ] = ACTIONS(5886),
    [anon_sym_and_eq] = ACTIONS(5884),
    [anon_sym_or_eq] = ACTIONS(5884),
    [anon_sym_xor_eq] = ACTIONS(5884),
    [anon_sym_LT_EQ_GT] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5884),
    [anon_sym_and] = ACTIONS(5884),
    [anon_sym_bitor] = ACTIONS(5884),
    [anon_sym_xor] = ACTIONS(5884),
    [anon_sym_bitand] = ACTIONS(5884),
    [anon_sym_not_eq] = ACTIONS(5884),
    [anon_sym_DASH_DASH] = ACTIONS(5886),
    [anon_sym_PLUS_PLUS] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5884),
    [anon_sym_DOT_STAR] = ACTIONS(5886),
    [anon_sym_DASH_GT] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5884),
    [anon_sym_decltype] = ACTIONS(5884),
  },
  [2763] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6688),
    [anon_sym_COMMA] = ACTIONS(6836),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(6838),
    [anon_sym_EQ] = ACTIONS(6698),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6700),
    [anon_sym_SLASH_EQ] = ACTIONS(6700),
    [anon_sym_PERCENT_EQ] = ACTIONS(6700),
    [anon_sym_PLUS_EQ] = ACTIONS(6700),
    [anon_sym_DASH_EQ] = ACTIONS(6700),
    [anon_sym_LT_LT_EQ] = ACTIONS(6700),
    [anon_sym_GT_GT_EQ] = ACTIONS(6700),
    [anon_sym_AMP_EQ] = ACTIONS(6700),
    [anon_sym_CARET_EQ] = ACTIONS(6700),
    [anon_sym_PIPE_EQ] = ACTIONS(6700),
    [anon_sym_and_eq] = ACTIONS(6700),
    [anon_sym_or_eq] = ACTIONS(6700),
    [anon_sym_xor_eq] = ACTIONS(6700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2764] = {
    [sym_identifier] = ACTIONS(6033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6035),
    [anon_sym_COMMA] = ACTIONS(6035),
    [anon_sym_RPAREN] = ACTIONS(6035),
    [aux_sym_preproc_if_token2] = ACTIONS(6035),
    [aux_sym_preproc_else_token1] = ACTIONS(6035),
    [aux_sym_preproc_elif_token1] = ACTIONS(6033),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6035),
    [anon_sym_LPAREN2] = ACTIONS(6035),
    [anon_sym_DASH] = ACTIONS(6033),
    [anon_sym_PLUS] = ACTIONS(6033),
    [anon_sym_STAR] = ACTIONS(6033),
    [anon_sym_SLASH] = ACTIONS(6033),
    [anon_sym_PERCENT] = ACTIONS(6033),
    [anon_sym_PIPE_PIPE] = ACTIONS(6035),
    [anon_sym_AMP_AMP] = ACTIONS(6035),
    [anon_sym_PIPE] = ACTIONS(6033),
    [anon_sym_CARET] = ACTIONS(6033),
    [anon_sym_AMP] = ACTIONS(6033),
    [anon_sym_EQ_EQ] = ACTIONS(6035),
    [anon_sym_BANG_EQ] = ACTIONS(6035),
    [anon_sym_GT] = ACTIONS(6033),
    [anon_sym_GT_EQ] = ACTIONS(6035),
    [anon_sym_LT_EQ] = ACTIONS(6033),
    [anon_sym_LT] = ACTIONS(6033),
    [anon_sym_LT_LT] = ACTIONS(6033),
    [anon_sym_GT_GT] = ACTIONS(6033),
    [anon_sym_COLON] = ACTIONS(6035),
    [anon_sym_SEMI] = ACTIONS(6035),
    [anon_sym___attribute__] = ACTIONS(6033),
    [anon_sym___attribute] = ACTIONS(6033),
    [anon_sym_LBRACE] = ACTIONS(6035),
    [anon_sym_RBRACE] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(6035),
    [anon_sym_RBRACK] = ACTIONS(6035),
    [anon_sym_EQ] = ACTIONS(6033),
    [anon_sym_QMARK] = ACTIONS(6035),
    [anon_sym_STAR_EQ] = ACTIONS(6035),
    [anon_sym_SLASH_EQ] = ACTIONS(6035),
    [anon_sym_PERCENT_EQ] = ACTIONS(6035),
    [anon_sym_PLUS_EQ] = ACTIONS(6035),
    [anon_sym_DASH_EQ] = ACTIONS(6035),
    [anon_sym_LT_LT_EQ] = ACTIONS(6035),
    [anon_sym_GT_GT_EQ] = ACTIONS(6035),
    [anon_sym_AMP_EQ] = ACTIONS(6035),
    [anon_sym_CARET_EQ] = ACTIONS(6035),
    [anon_sym_PIPE_EQ] = ACTIONS(6035),
    [anon_sym_and_eq] = ACTIONS(6033),
    [anon_sym_or_eq] = ACTIONS(6033),
    [anon_sym_xor_eq] = ACTIONS(6033),
    [anon_sym_LT_EQ_GT] = ACTIONS(6035),
    [anon_sym_or] = ACTIONS(6033),
    [anon_sym_and] = ACTIONS(6033),
    [anon_sym_bitor] = ACTIONS(6033),
    [anon_sym_xor] = ACTIONS(6033),
    [anon_sym_bitand] = ACTIONS(6033),
    [anon_sym_not_eq] = ACTIONS(6033),
    [anon_sym_DASH_DASH] = ACTIONS(6035),
    [anon_sym_PLUS_PLUS] = ACTIONS(6035),
    [anon_sym_DOT] = ACTIONS(6033),
    [anon_sym_DOT_STAR] = ACTIONS(6035),
    [anon_sym_DASH_GT] = ACTIONS(6035),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6033),
    [anon_sym_decltype] = ACTIONS(6033),
  },
  [2765] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6465),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_RPAREN] = ACTIONS(6465),
    [anon_sym_LPAREN2] = ACTIONS(6465),
    [anon_sym_DASH] = ACTIONS(6463),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_STAR] = ACTIONS(6463),
    [anon_sym_SLASH] = ACTIONS(6463),
    [anon_sym_PERCENT] = ACTIONS(6463),
    [anon_sym_PIPE_PIPE] = ACTIONS(6465),
    [anon_sym_AMP_AMP] = ACTIONS(6465),
    [anon_sym_PIPE] = ACTIONS(6463),
    [anon_sym_CARET] = ACTIONS(6463),
    [anon_sym_AMP] = ACTIONS(6463),
    [anon_sym_EQ_EQ] = ACTIONS(6465),
    [anon_sym_BANG_EQ] = ACTIONS(6465),
    [anon_sym_GT] = ACTIONS(6463),
    [anon_sym_GT_EQ] = ACTIONS(6465),
    [anon_sym_LT_EQ] = ACTIONS(6463),
    [anon_sym_LT] = ACTIONS(6463),
    [anon_sym_LT_LT] = ACTIONS(6463),
    [anon_sym_GT_GT] = ACTIONS(6463),
    [anon_sym_COLON] = ACTIONS(6465),
    [anon_sym_SEMI] = ACTIONS(6465),
    [anon_sym_RBRACE] = ACTIONS(6465),
    [anon_sym_LBRACK] = ACTIONS(6465),
    [anon_sym_RBRACK] = ACTIONS(6465),
    [anon_sym_EQ] = ACTIONS(6463),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_STAR_EQ] = ACTIONS(6465),
    [anon_sym_SLASH_EQ] = ACTIONS(6465),
    [anon_sym_PERCENT_EQ] = ACTIONS(6465),
    [anon_sym_PLUS_EQ] = ACTIONS(6465),
    [anon_sym_DASH_EQ] = ACTIONS(6465),
    [anon_sym_LT_LT_EQ] = ACTIONS(6465),
    [anon_sym_GT_GT_EQ] = ACTIONS(6465),
    [anon_sym_AMP_EQ] = ACTIONS(6465),
    [anon_sym_CARET_EQ] = ACTIONS(6465),
    [anon_sym_PIPE_EQ] = ACTIONS(6465),
    [anon_sym_and_eq] = ACTIONS(6463),
    [anon_sym_or_eq] = ACTIONS(6463),
    [anon_sym_xor_eq] = ACTIONS(6463),
    [anon_sym_LT_EQ_GT] = ACTIONS(6465),
    [anon_sym_or] = ACTIONS(6463),
    [anon_sym_and] = ACTIONS(6463),
    [anon_sym_bitor] = ACTIONS(6463),
    [anon_sym_xor] = ACTIONS(6463),
    [anon_sym_bitand] = ACTIONS(6463),
    [anon_sym_not_eq] = ACTIONS(6463),
    [anon_sym_DASH_DASH] = ACTIONS(6465),
    [anon_sym_PLUS_PLUS] = ACTIONS(6465),
    [anon_sym_DOT] = ACTIONS(6463),
    [anon_sym_DOT_STAR] = ACTIONS(6465),
    [anon_sym_DASH_GT] = ACTIONS(6465),
    [anon_sym_L_DQUOTE] = ACTIONS(6465),
    [anon_sym_u_DQUOTE] = ACTIONS(6465),
    [anon_sym_U_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8_DQUOTE] = ACTIONS(6465),
    [anon_sym_DQUOTE] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6465),
    [anon_sym_LR_DQUOTE] = ACTIONS(6465),
    [anon_sym_uR_DQUOTE] = ACTIONS(6465),
    [anon_sym_UR_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6465),
    [sym_literal_suffix] = ACTIONS(6463),
  },
  [2766] = {
    [sym_identifier] = ACTIONS(5993),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5995),
    [anon_sym_COMMA] = ACTIONS(5995),
    [anon_sym_RPAREN] = ACTIONS(5995),
    [aux_sym_preproc_if_token2] = ACTIONS(5995),
    [aux_sym_preproc_else_token1] = ACTIONS(5995),
    [aux_sym_preproc_elif_token1] = ACTIONS(5993),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5995),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5995),
    [anon_sym_LPAREN2] = ACTIONS(5995),
    [anon_sym_DASH] = ACTIONS(5993),
    [anon_sym_PLUS] = ACTIONS(5993),
    [anon_sym_STAR] = ACTIONS(5993),
    [anon_sym_SLASH] = ACTIONS(5993),
    [anon_sym_PERCENT] = ACTIONS(5993),
    [anon_sym_PIPE_PIPE] = ACTIONS(5995),
    [anon_sym_AMP_AMP] = ACTIONS(5995),
    [anon_sym_PIPE] = ACTIONS(5993),
    [anon_sym_CARET] = ACTIONS(5993),
    [anon_sym_AMP] = ACTIONS(5993),
    [anon_sym_EQ_EQ] = ACTIONS(5995),
    [anon_sym_BANG_EQ] = ACTIONS(5995),
    [anon_sym_GT] = ACTIONS(5993),
    [anon_sym_GT_EQ] = ACTIONS(5995),
    [anon_sym_LT_EQ] = ACTIONS(5993),
    [anon_sym_LT] = ACTIONS(5993),
    [anon_sym_LT_LT] = ACTIONS(5993),
    [anon_sym_GT_GT] = ACTIONS(5993),
    [anon_sym_COLON] = ACTIONS(5995),
    [anon_sym_SEMI] = ACTIONS(5995),
    [anon_sym___attribute__] = ACTIONS(5993),
    [anon_sym___attribute] = ACTIONS(5993),
    [anon_sym_LBRACE] = ACTIONS(5995),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_LBRACK] = ACTIONS(5995),
    [anon_sym_RBRACK] = ACTIONS(5995),
    [anon_sym_EQ] = ACTIONS(5993),
    [anon_sym_QMARK] = ACTIONS(5995),
    [anon_sym_STAR_EQ] = ACTIONS(5995),
    [anon_sym_SLASH_EQ] = ACTIONS(5995),
    [anon_sym_PERCENT_EQ] = ACTIONS(5995),
    [anon_sym_PLUS_EQ] = ACTIONS(5995),
    [anon_sym_DASH_EQ] = ACTIONS(5995),
    [anon_sym_LT_LT_EQ] = ACTIONS(5995),
    [anon_sym_GT_GT_EQ] = ACTIONS(5995),
    [anon_sym_AMP_EQ] = ACTIONS(5995),
    [anon_sym_CARET_EQ] = ACTIONS(5995),
    [anon_sym_PIPE_EQ] = ACTIONS(5995),
    [anon_sym_and_eq] = ACTIONS(5993),
    [anon_sym_or_eq] = ACTIONS(5993),
    [anon_sym_xor_eq] = ACTIONS(5993),
    [anon_sym_LT_EQ_GT] = ACTIONS(5995),
    [anon_sym_or] = ACTIONS(5993),
    [anon_sym_and] = ACTIONS(5993),
    [anon_sym_bitor] = ACTIONS(5993),
    [anon_sym_xor] = ACTIONS(5993),
    [anon_sym_bitand] = ACTIONS(5993),
    [anon_sym_not_eq] = ACTIONS(5993),
    [anon_sym_DASH_DASH] = ACTIONS(5995),
    [anon_sym_PLUS_PLUS] = ACTIONS(5995),
    [anon_sym_DOT] = ACTIONS(5993),
    [anon_sym_DOT_STAR] = ACTIONS(5995),
    [anon_sym_DASH_GT] = ACTIONS(5995),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5993),
    [anon_sym_decltype] = ACTIONS(5993),
  },
  [2767] = {
    [sym_identifier] = ACTIONS(6049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [aux_sym_preproc_if_token2] = ACTIONS(6051),
    [aux_sym_preproc_else_token1] = ACTIONS(6051),
    [aux_sym_preproc_elif_token1] = ACTIONS(6049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6051),
    [anon_sym_LPAREN2] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_PERCENT] = ACTIONS(6049),
    [anon_sym_PIPE_PIPE] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(6051),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_AMP] = ACTIONS(6049),
    [anon_sym_EQ_EQ] = ACTIONS(6051),
    [anon_sym_BANG_EQ] = ACTIONS(6051),
    [anon_sym_GT] = ACTIONS(6049),
    [anon_sym_GT_EQ] = ACTIONS(6051),
    [anon_sym_LT_EQ] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6049),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_COLON] = ACTIONS(6051),
    [anon_sym_SEMI] = ACTIONS(6051),
    [anon_sym___attribute__] = ACTIONS(6049),
    [anon_sym___attribute] = ACTIONS(6049),
    [anon_sym_LBRACE] = ACTIONS(6051),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_LBRACK] = ACTIONS(6051),
    [anon_sym_RBRACK] = ACTIONS(6051),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_QMARK] = ACTIONS(6051),
    [anon_sym_STAR_EQ] = ACTIONS(6051),
    [anon_sym_SLASH_EQ] = ACTIONS(6051),
    [anon_sym_PERCENT_EQ] = ACTIONS(6051),
    [anon_sym_PLUS_EQ] = ACTIONS(6051),
    [anon_sym_DASH_EQ] = ACTIONS(6051),
    [anon_sym_LT_LT_EQ] = ACTIONS(6051),
    [anon_sym_GT_GT_EQ] = ACTIONS(6051),
    [anon_sym_AMP_EQ] = ACTIONS(6051),
    [anon_sym_CARET_EQ] = ACTIONS(6051),
    [anon_sym_PIPE_EQ] = ACTIONS(6051),
    [anon_sym_and_eq] = ACTIONS(6049),
    [anon_sym_or_eq] = ACTIONS(6049),
    [anon_sym_xor_eq] = ACTIONS(6049),
    [anon_sym_LT_EQ_GT] = ACTIONS(6051),
    [anon_sym_or] = ACTIONS(6049),
    [anon_sym_and] = ACTIONS(6049),
    [anon_sym_bitor] = ACTIONS(6049),
    [anon_sym_xor] = ACTIONS(6049),
    [anon_sym_bitand] = ACTIONS(6049),
    [anon_sym_not_eq] = ACTIONS(6049),
    [anon_sym_DASH_DASH] = ACTIONS(6051),
    [anon_sym_PLUS_PLUS] = ACTIONS(6051),
    [anon_sym_DOT] = ACTIONS(6049),
    [anon_sym_DOT_STAR] = ACTIONS(6051),
    [anon_sym_DASH_GT] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6049),
    [anon_sym_decltype] = ACTIONS(6049),
  },
  [2768] = {
    [sym_identifier] = ACTIONS(6057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [aux_sym_preproc_if_token2] = ACTIONS(6059),
    [aux_sym_preproc_else_token1] = ACTIONS(6059),
    [aux_sym_preproc_elif_token1] = ACTIONS(6057),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6059),
    [anon_sym_LPAREN2] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6057),
    [anon_sym_PLUS] = ACTIONS(6057),
    [anon_sym_STAR] = ACTIONS(6057),
    [anon_sym_SLASH] = ACTIONS(6057),
    [anon_sym_PERCENT] = ACTIONS(6057),
    [anon_sym_PIPE_PIPE] = ACTIONS(6059),
    [anon_sym_AMP_AMP] = ACTIONS(6059),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_CARET] = ACTIONS(6057),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym_EQ_EQ] = ACTIONS(6059),
    [anon_sym_BANG_EQ] = ACTIONS(6059),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_GT_EQ] = ACTIONS(6059),
    [anon_sym_LT_EQ] = ACTIONS(6057),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_LT_LT] = ACTIONS(6057),
    [anon_sym_GT_GT] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6059),
    [anon_sym_SEMI] = ACTIONS(6059),
    [anon_sym___attribute__] = ACTIONS(6057),
    [anon_sym___attribute] = ACTIONS(6057),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6057),
    [anon_sym_QMARK] = ACTIONS(6059),
    [anon_sym_STAR_EQ] = ACTIONS(6059),
    [anon_sym_SLASH_EQ] = ACTIONS(6059),
    [anon_sym_PERCENT_EQ] = ACTIONS(6059),
    [anon_sym_PLUS_EQ] = ACTIONS(6059),
    [anon_sym_DASH_EQ] = ACTIONS(6059),
    [anon_sym_LT_LT_EQ] = ACTIONS(6059),
    [anon_sym_GT_GT_EQ] = ACTIONS(6059),
    [anon_sym_AMP_EQ] = ACTIONS(6059),
    [anon_sym_CARET_EQ] = ACTIONS(6059),
    [anon_sym_PIPE_EQ] = ACTIONS(6059),
    [anon_sym_and_eq] = ACTIONS(6057),
    [anon_sym_or_eq] = ACTIONS(6057),
    [anon_sym_xor_eq] = ACTIONS(6057),
    [anon_sym_LT_EQ_GT] = ACTIONS(6059),
    [anon_sym_or] = ACTIONS(6057),
    [anon_sym_and] = ACTIONS(6057),
    [anon_sym_bitor] = ACTIONS(6057),
    [anon_sym_xor] = ACTIONS(6057),
    [anon_sym_bitand] = ACTIONS(6057),
    [anon_sym_not_eq] = ACTIONS(6057),
    [anon_sym_DASH_DASH] = ACTIONS(6059),
    [anon_sym_PLUS_PLUS] = ACTIONS(6059),
    [anon_sym_DOT] = ACTIONS(6057),
    [anon_sym_DOT_STAR] = ACTIONS(6059),
    [anon_sym_DASH_GT] = ACTIONS(6059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6057),
    [anon_sym_decltype] = ACTIONS(6057),
  },
  [2769] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5937),
    [aux_sym_preproc_if_token2] = ACTIONS(5937),
    [aux_sym_preproc_else_token1] = ACTIONS(5937),
    [aux_sym_preproc_elif_token1] = ACTIONS(5935),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5937),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5937),
    [anon_sym_LPAREN2] = ACTIONS(5937),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5935),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_GT_EQ] = ACTIONS(5937),
    [anon_sym_LT_EQ] = ACTIONS(5935),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5935),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym___attribute__] = ACTIONS(5935),
    [anon_sym___attribute] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_STAR_EQ] = ACTIONS(5937),
    [anon_sym_SLASH_EQ] = ACTIONS(5937),
    [anon_sym_PERCENT_EQ] = ACTIONS(5937),
    [anon_sym_PLUS_EQ] = ACTIONS(5937),
    [anon_sym_DASH_EQ] = ACTIONS(5937),
    [anon_sym_LT_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT_GT_EQ] = ACTIONS(5937),
    [anon_sym_AMP_EQ] = ACTIONS(5937),
    [anon_sym_CARET_EQ] = ACTIONS(5937),
    [anon_sym_PIPE_EQ] = ACTIONS(5937),
    [anon_sym_and_eq] = ACTIONS(5935),
    [anon_sym_or_eq] = ACTIONS(5935),
    [anon_sym_xor_eq] = ACTIONS(5935),
    [anon_sym_LT_EQ_GT] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5935),
    [anon_sym_bitor] = ACTIONS(5935),
    [anon_sym_xor] = ACTIONS(5935),
    [anon_sym_bitand] = ACTIONS(5935),
    [anon_sym_not_eq] = ACTIONS(5935),
    [anon_sym_DASH_DASH] = ACTIONS(5937),
    [anon_sym_PLUS_PLUS] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_DOT_STAR] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5935),
    [anon_sym_decltype] = ACTIONS(5935),
  },
  [2770] = {
    [sym_identifier] = ACTIONS(6011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6013),
    [anon_sym_COMMA] = ACTIONS(6013),
    [anon_sym_RPAREN] = ACTIONS(6013),
    [aux_sym_preproc_if_token2] = ACTIONS(6013),
    [aux_sym_preproc_else_token1] = ACTIONS(6013),
    [aux_sym_preproc_elif_token1] = ACTIONS(6011),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6013),
    [anon_sym_LPAREN2] = ACTIONS(6013),
    [anon_sym_DASH] = ACTIONS(6011),
    [anon_sym_PLUS] = ACTIONS(6011),
    [anon_sym_STAR] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(6011),
    [anon_sym_PERCENT] = ACTIONS(6011),
    [anon_sym_PIPE_PIPE] = ACTIONS(6013),
    [anon_sym_AMP_AMP] = ACTIONS(6013),
    [anon_sym_PIPE] = ACTIONS(6011),
    [anon_sym_CARET] = ACTIONS(6011),
    [anon_sym_AMP] = ACTIONS(6011),
    [anon_sym_EQ_EQ] = ACTIONS(6013),
    [anon_sym_BANG_EQ] = ACTIONS(6013),
    [anon_sym_GT] = ACTIONS(6011),
    [anon_sym_GT_EQ] = ACTIONS(6013),
    [anon_sym_LT_EQ] = ACTIONS(6011),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_LT_LT] = ACTIONS(6011),
    [anon_sym_GT_GT] = ACTIONS(6011),
    [anon_sym_COLON] = ACTIONS(6013),
    [anon_sym_SEMI] = ACTIONS(6013),
    [anon_sym___attribute__] = ACTIONS(6011),
    [anon_sym___attribute] = ACTIONS(6011),
    [anon_sym_LBRACE] = ACTIONS(6013),
    [anon_sym_RBRACE] = ACTIONS(6013),
    [anon_sym_LBRACK] = ACTIONS(6013),
    [anon_sym_RBRACK] = ACTIONS(6013),
    [anon_sym_EQ] = ACTIONS(6011),
    [anon_sym_QMARK] = ACTIONS(6013),
    [anon_sym_STAR_EQ] = ACTIONS(6013),
    [anon_sym_SLASH_EQ] = ACTIONS(6013),
    [anon_sym_PERCENT_EQ] = ACTIONS(6013),
    [anon_sym_PLUS_EQ] = ACTIONS(6013),
    [anon_sym_DASH_EQ] = ACTIONS(6013),
    [anon_sym_LT_LT_EQ] = ACTIONS(6013),
    [anon_sym_GT_GT_EQ] = ACTIONS(6013),
    [anon_sym_AMP_EQ] = ACTIONS(6013),
    [anon_sym_CARET_EQ] = ACTIONS(6013),
    [anon_sym_PIPE_EQ] = ACTIONS(6013),
    [anon_sym_and_eq] = ACTIONS(6011),
    [anon_sym_or_eq] = ACTIONS(6011),
    [anon_sym_xor_eq] = ACTIONS(6011),
    [anon_sym_LT_EQ_GT] = ACTIONS(6013),
    [anon_sym_or] = ACTIONS(6011),
    [anon_sym_and] = ACTIONS(6011),
    [anon_sym_bitor] = ACTIONS(6011),
    [anon_sym_xor] = ACTIONS(6011),
    [anon_sym_bitand] = ACTIONS(6011),
    [anon_sym_not_eq] = ACTIONS(6011),
    [anon_sym_DASH_DASH] = ACTIONS(6013),
    [anon_sym_PLUS_PLUS] = ACTIONS(6013),
    [anon_sym_DOT] = ACTIONS(6011),
    [anon_sym_DOT_STAR] = ACTIONS(6013),
    [anon_sym_DASH_GT] = ACTIONS(6013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6011),
    [anon_sym_decltype] = ACTIONS(6011),
  },
  [2771] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [aux_sym_preproc_if_token2] = ACTIONS(6047),
    [aux_sym_preproc_else_token1] = ACTIONS(6047),
    [aux_sym_preproc_elif_token1] = ACTIONS(6045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6045),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6045),
    [anon_sym_GT_GT] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_STAR_EQ] = ACTIONS(6047),
    [anon_sym_SLASH_EQ] = ACTIONS(6047),
    [anon_sym_PERCENT_EQ] = ACTIONS(6047),
    [anon_sym_PLUS_EQ] = ACTIONS(6047),
    [anon_sym_DASH_EQ] = ACTIONS(6047),
    [anon_sym_LT_LT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_AMP_EQ] = ACTIONS(6047),
    [anon_sym_CARET_EQ] = ACTIONS(6047),
    [anon_sym_PIPE_EQ] = ACTIONS(6047),
    [anon_sym_and_eq] = ACTIONS(6045),
    [anon_sym_or_eq] = ACTIONS(6045),
    [anon_sym_xor_eq] = ACTIONS(6045),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
  },
  [2772] = {
    [sym_identifier] = ACTIONS(6107),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [aux_sym_preproc_if_token2] = ACTIONS(6109),
    [aux_sym_preproc_else_token1] = ACTIONS(6109),
    [aux_sym_preproc_elif_token1] = ACTIONS(6107),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6109),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6109),
    [anon_sym_LPAREN2] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6107),
    [anon_sym_PLUS] = ACTIONS(6107),
    [anon_sym_STAR] = ACTIONS(6107),
    [anon_sym_SLASH] = ACTIONS(6107),
    [anon_sym_PERCENT] = ACTIONS(6107),
    [anon_sym_PIPE_PIPE] = ACTIONS(6109),
    [anon_sym_AMP_AMP] = ACTIONS(6109),
    [anon_sym_PIPE] = ACTIONS(6107),
    [anon_sym_CARET] = ACTIONS(6107),
    [anon_sym_AMP] = ACTIONS(6107),
    [anon_sym_EQ_EQ] = ACTIONS(6109),
    [anon_sym_BANG_EQ] = ACTIONS(6109),
    [anon_sym_GT] = ACTIONS(6107),
    [anon_sym_GT_EQ] = ACTIONS(6109),
    [anon_sym_LT_EQ] = ACTIONS(6107),
    [anon_sym_LT] = ACTIONS(6107),
    [anon_sym_LT_LT] = ACTIONS(6107),
    [anon_sym_GT_GT] = ACTIONS(6107),
    [anon_sym_COLON] = ACTIONS(6109),
    [anon_sym_SEMI] = ACTIONS(6109),
    [anon_sym___attribute__] = ACTIONS(6107),
    [anon_sym___attribute] = ACTIONS(6107),
    [anon_sym_LBRACE] = ACTIONS(6109),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [anon_sym_LBRACK] = ACTIONS(6109),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6107),
    [anon_sym_QMARK] = ACTIONS(6109),
    [anon_sym_STAR_EQ] = ACTIONS(6109),
    [anon_sym_SLASH_EQ] = ACTIONS(6109),
    [anon_sym_PERCENT_EQ] = ACTIONS(6109),
    [anon_sym_PLUS_EQ] = ACTIONS(6109),
    [anon_sym_DASH_EQ] = ACTIONS(6109),
    [anon_sym_LT_LT_EQ] = ACTIONS(6109),
    [anon_sym_GT_GT_EQ] = ACTIONS(6109),
    [anon_sym_AMP_EQ] = ACTIONS(6109),
    [anon_sym_CARET_EQ] = ACTIONS(6109),
    [anon_sym_PIPE_EQ] = ACTIONS(6109),
    [anon_sym_and_eq] = ACTIONS(6107),
    [anon_sym_or_eq] = ACTIONS(6107),
    [anon_sym_xor_eq] = ACTIONS(6107),
    [anon_sym_LT_EQ_GT] = ACTIONS(6109),
    [anon_sym_or] = ACTIONS(6107),
    [anon_sym_and] = ACTIONS(6107),
    [anon_sym_bitor] = ACTIONS(6107),
    [anon_sym_xor] = ACTIONS(6107),
    [anon_sym_bitand] = ACTIONS(6107),
    [anon_sym_not_eq] = ACTIONS(6107),
    [anon_sym_DASH_DASH] = ACTIONS(6109),
    [anon_sym_PLUS_PLUS] = ACTIONS(6109),
    [anon_sym_DOT] = ACTIONS(6107),
    [anon_sym_DOT_STAR] = ACTIONS(6109),
    [anon_sym_DASH_GT] = ACTIONS(6109),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6107),
    [anon_sym_decltype] = ACTIONS(6107),
  },
  [2773] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2742),
    [sym_identifier] = ACTIONS(5902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [aux_sym_preproc_if_token2] = ACTIONS(5904),
    [aux_sym_preproc_else_token1] = ACTIONS(5904),
    [aux_sym_preproc_elif_token1] = ACTIONS(5902),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5904),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5902),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(6841),
    [anon_sym_unsigned] = ACTIONS(6841),
    [anon_sym_long] = ACTIONS(6841),
    [anon_sym_short] = ACTIONS(6841),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_STAR_EQ] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_PERCENT_EQ] = ACTIONS(5904),
    [anon_sym_PLUS_EQ] = ACTIONS(5904),
    [anon_sym_DASH_EQ] = ACTIONS(5904),
    [anon_sym_LT_LT_EQ] = ACTIONS(5904),
    [anon_sym_GT_GT_EQ] = ACTIONS(5904),
    [anon_sym_AMP_EQ] = ACTIONS(5904),
    [anon_sym_CARET_EQ] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_and_eq] = ACTIONS(5902),
    [anon_sym_or_eq] = ACTIONS(5902),
    [anon_sym_xor_eq] = ACTIONS(5902),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
  },
  [2774] = {
    [sym_identifier] = ACTIONS(6843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6845),
    [anon_sym_COMMA] = ACTIONS(6845),
    [anon_sym_RPAREN] = ACTIONS(6845),
    [aux_sym_preproc_if_token2] = ACTIONS(6845),
    [aux_sym_preproc_else_token1] = ACTIONS(6845),
    [aux_sym_preproc_elif_token1] = ACTIONS(6843),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6845),
    [anon_sym_LPAREN2] = ACTIONS(6845),
    [anon_sym_DASH] = ACTIONS(6843),
    [anon_sym_PLUS] = ACTIONS(6843),
    [anon_sym_STAR] = ACTIONS(6843),
    [anon_sym_SLASH] = ACTIONS(6843),
    [anon_sym_PERCENT] = ACTIONS(6843),
    [anon_sym_PIPE_PIPE] = ACTIONS(6845),
    [anon_sym_AMP_AMP] = ACTIONS(6845),
    [anon_sym_PIPE] = ACTIONS(6843),
    [anon_sym_CARET] = ACTIONS(6843),
    [anon_sym_AMP] = ACTIONS(6843),
    [anon_sym_EQ_EQ] = ACTIONS(6845),
    [anon_sym_BANG_EQ] = ACTIONS(6845),
    [anon_sym_GT] = ACTIONS(6843),
    [anon_sym_GT_EQ] = ACTIONS(6845),
    [anon_sym_LT_EQ] = ACTIONS(6843),
    [anon_sym_LT] = ACTIONS(6843),
    [anon_sym_LT_LT] = ACTIONS(6843),
    [anon_sym_GT_GT] = ACTIONS(6843),
    [anon_sym_COLON] = ACTIONS(6845),
    [anon_sym_SEMI] = ACTIONS(6845),
    [anon_sym___attribute__] = ACTIONS(6843),
    [anon_sym___attribute] = ACTIONS(6843),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6845),
    [anon_sym_RBRACE] = ACTIONS(6845),
    [anon_sym_LBRACK] = ACTIONS(6843),
    [anon_sym_RBRACK] = ACTIONS(6845),
    [anon_sym_EQ] = ACTIONS(6843),
    [anon_sym_QMARK] = ACTIONS(6845),
    [anon_sym_STAR_EQ] = ACTIONS(6845),
    [anon_sym_SLASH_EQ] = ACTIONS(6845),
    [anon_sym_PERCENT_EQ] = ACTIONS(6845),
    [anon_sym_PLUS_EQ] = ACTIONS(6845),
    [anon_sym_DASH_EQ] = ACTIONS(6845),
    [anon_sym_LT_LT_EQ] = ACTIONS(6845),
    [anon_sym_GT_GT_EQ] = ACTIONS(6845),
    [anon_sym_AMP_EQ] = ACTIONS(6845),
    [anon_sym_CARET_EQ] = ACTIONS(6845),
    [anon_sym_PIPE_EQ] = ACTIONS(6845),
    [anon_sym_and_eq] = ACTIONS(6843),
    [anon_sym_or_eq] = ACTIONS(6843),
    [anon_sym_xor_eq] = ACTIONS(6843),
    [anon_sym_LT_EQ_GT] = ACTIONS(6845),
    [anon_sym_or] = ACTIONS(6843),
    [anon_sym_and] = ACTIONS(6843),
    [anon_sym_bitor] = ACTIONS(6843),
    [anon_sym_xor] = ACTIONS(6843),
    [anon_sym_bitand] = ACTIONS(6843),
    [anon_sym_not_eq] = ACTIONS(6843),
    [anon_sym_DASH_DASH] = ACTIONS(6845),
    [anon_sym_PLUS_PLUS] = ACTIONS(6845),
    [anon_sym_DOT] = ACTIONS(6843),
    [anon_sym_DOT_STAR] = ACTIONS(6845),
    [anon_sym_DASH_GT] = ACTIONS(6845),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6843),
  },
  [2775] = {
    [sym_identifier] = ACTIONS(6111),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6113),
    [anon_sym_COMMA] = ACTIONS(6113),
    [anon_sym_RPAREN] = ACTIONS(6113),
    [aux_sym_preproc_if_token2] = ACTIONS(6113),
    [aux_sym_preproc_else_token1] = ACTIONS(6113),
    [aux_sym_preproc_elif_token1] = ACTIONS(6111),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6113),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6113),
    [anon_sym_LPAREN2] = ACTIONS(6113),
    [anon_sym_DASH] = ACTIONS(6111),
    [anon_sym_PLUS] = ACTIONS(6111),
    [anon_sym_STAR] = ACTIONS(6111),
    [anon_sym_SLASH] = ACTIONS(6111),
    [anon_sym_PERCENT] = ACTIONS(6111),
    [anon_sym_PIPE_PIPE] = ACTIONS(6113),
    [anon_sym_AMP_AMP] = ACTIONS(6113),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_CARET] = ACTIONS(6111),
    [anon_sym_AMP] = ACTIONS(6111),
    [anon_sym_EQ_EQ] = ACTIONS(6113),
    [anon_sym_BANG_EQ] = ACTIONS(6113),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_GT_EQ] = ACTIONS(6113),
    [anon_sym_LT_EQ] = ACTIONS(6111),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_LT_LT] = ACTIONS(6111),
    [anon_sym_GT_GT] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6113),
    [anon_sym_SEMI] = ACTIONS(6113),
    [anon_sym___attribute__] = ACTIONS(6111),
    [anon_sym___attribute] = ACTIONS(6111),
    [anon_sym_LBRACE] = ACTIONS(6113),
    [anon_sym_RBRACE] = ACTIONS(6113),
    [anon_sym_LBRACK] = ACTIONS(6113),
    [anon_sym_RBRACK] = ACTIONS(6113),
    [anon_sym_EQ] = ACTIONS(6111),
    [anon_sym_QMARK] = ACTIONS(6113),
    [anon_sym_STAR_EQ] = ACTIONS(6113),
    [anon_sym_SLASH_EQ] = ACTIONS(6113),
    [anon_sym_PERCENT_EQ] = ACTIONS(6113),
    [anon_sym_PLUS_EQ] = ACTIONS(6113),
    [anon_sym_DASH_EQ] = ACTIONS(6113),
    [anon_sym_LT_LT_EQ] = ACTIONS(6113),
    [anon_sym_GT_GT_EQ] = ACTIONS(6113),
    [anon_sym_AMP_EQ] = ACTIONS(6113),
    [anon_sym_CARET_EQ] = ACTIONS(6113),
    [anon_sym_PIPE_EQ] = ACTIONS(6113),
    [anon_sym_and_eq] = ACTIONS(6111),
    [anon_sym_or_eq] = ACTIONS(6111),
    [anon_sym_xor_eq] = ACTIONS(6111),
    [anon_sym_LT_EQ_GT] = ACTIONS(6113),
    [anon_sym_or] = ACTIONS(6111),
    [anon_sym_and] = ACTIONS(6111),
    [anon_sym_bitor] = ACTIONS(6111),
    [anon_sym_xor] = ACTIONS(6111),
    [anon_sym_bitand] = ACTIONS(6111),
    [anon_sym_not_eq] = ACTIONS(6111),
    [anon_sym_DASH_DASH] = ACTIONS(6113),
    [anon_sym_PLUS_PLUS] = ACTIONS(6113),
    [anon_sym_DOT] = ACTIONS(6111),
    [anon_sym_DOT_STAR] = ACTIONS(6113),
    [anon_sym_DASH_GT] = ACTIONS(6113),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6111),
    [anon_sym_decltype] = ACTIONS(6111),
  },
  [2776] = {
    [sym_identifier] = ACTIONS(6847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6849),
    [anon_sym_COMMA] = ACTIONS(6849),
    [anon_sym_RPAREN] = ACTIONS(6849),
    [aux_sym_preproc_if_token2] = ACTIONS(6849),
    [aux_sym_preproc_else_token1] = ACTIONS(6849),
    [aux_sym_preproc_elif_token1] = ACTIONS(6847),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6849),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6849),
    [anon_sym_LPAREN2] = ACTIONS(6849),
    [anon_sym_DASH] = ACTIONS(6847),
    [anon_sym_PLUS] = ACTIONS(6847),
    [anon_sym_STAR] = ACTIONS(6847),
    [anon_sym_SLASH] = ACTIONS(6847),
    [anon_sym_PERCENT] = ACTIONS(6847),
    [anon_sym_PIPE_PIPE] = ACTIONS(6849),
    [anon_sym_AMP_AMP] = ACTIONS(6849),
    [anon_sym_PIPE] = ACTIONS(6847),
    [anon_sym_CARET] = ACTIONS(6847),
    [anon_sym_AMP] = ACTIONS(6847),
    [anon_sym_EQ_EQ] = ACTIONS(6849),
    [anon_sym_BANG_EQ] = ACTIONS(6849),
    [anon_sym_GT] = ACTIONS(6847),
    [anon_sym_GT_EQ] = ACTIONS(6849),
    [anon_sym_LT_EQ] = ACTIONS(6847),
    [anon_sym_LT] = ACTIONS(6847),
    [anon_sym_LT_LT] = ACTIONS(6847),
    [anon_sym_GT_GT] = ACTIONS(6847),
    [anon_sym_COLON] = ACTIONS(6849),
    [anon_sym_SEMI] = ACTIONS(6849),
    [anon_sym___attribute__] = ACTIONS(6847),
    [anon_sym___attribute] = ACTIONS(6847),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6849),
    [anon_sym_LBRACE] = ACTIONS(6849),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_LBRACK] = ACTIONS(6847),
    [anon_sym_RBRACK] = ACTIONS(6849),
    [anon_sym_EQ] = ACTIONS(6847),
    [anon_sym_QMARK] = ACTIONS(6849),
    [anon_sym_STAR_EQ] = ACTIONS(6849),
    [anon_sym_SLASH_EQ] = ACTIONS(6849),
    [anon_sym_PERCENT_EQ] = ACTIONS(6849),
    [anon_sym_PLUS_EQ] = ACTIONS(6849),
    [anon_sym_DASH_EQ] = ACTIONS(6849),
    [anon_sym_LT_LT_EQ] = ACTIONS(6849),
    [anon_sym_GT_GT_EQ] = ACTIONS(6849),
    [anon_sym_AMP_EQ] = ACTIONS(6849),
    [anon_sym_CARET_EQ] = ACTIONS(6849),
    [anon_sym_PIPE_EQ] = ACTIONS(6849),
    [anon_sym_and_eq] = ACTIONS(6847),
    [anon_sym_or_eq] = ACTIONS(6847),
    [anon_sym_xor_eq] = ACTIONS(6847),
    [anon_sym_LT_EQ_GT] = ACTIONS(6849),
    [anon_sym_or] = ACTIONS(6847),
    [anon_sym_and] = ACTIONS(6847),
    [anon_sym_bitor] = ACTIONS(6847),
    [anon_sym_xor] = ACTIONS(6847),
    [anon_sym_bitand] = ACTIONS(6847),
    [anon_sym_not_eq] = ACTIONS(6847),
    [anon_sym_DASH_DASH] = ACTIONS(6849),
    [anon_sym_PLUS_PLUS] = ACTIONS(6849),
    [anon_sym_DOT] = ACTIONS(6847),
    [anon_sym_DOT_STAR] = ACTIONS(6849),
    [anon_sym_DASH_GT] = ACTIONS(6849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6847),
  },
  [2777] = {
    [sym_identifier] = ACTIONS(6851),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6853),
    [anon_sym_COMMA] = ACTIONS(6853),
    [anon_sym_RPAREN] = ACTIONS(6853),
    [aux_sym_preproc_if_token2] = ACTIONS(6853),
    [aux_sym_preproc_else_token1] = ACTIONS(6853),
    [aux_sym_preproc_elif_token1] = ACTIONS(6851),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6853),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6853),
    [anon_sym_LPAREN2] = ACTIONS(6853),
    [anon_sym_DASH] = ACTIONS(6851),
    [anon_sym_PLUS] = ACTIONS(6851),
    [anon_sym_STAR] = ACTIONS(6851),
    [anon_sym_SLASH] = ACTIONS(6851),
    [anon_sym_PERCENT] = ACTIONS(6851),
    [anon_sym_PIPE_PIPE] = ACTIONS(6853),
    [anon_sym_AMP_AMP] = ACTIONS(6853),
    [anon_sym_PIPE] = ACTIONS(6851),
    [anon_sym_CARET] = ACTIONS(6851),
    [anon_sym_AMP] = ACTIONS(6851),
    [anon_sym_EQ_EQ] = ACTIONS(6853),
    [anon_sym_BANG_EQ] = ACTIONS(6853),
    [anon_sym_GT] = ACTIONS(6851),
    [anon_sym_GT_EQ] = ACTIONS(6853),
    [anon_sym_LT_EQ] = ACTIONS(6851),
    [anon_sym_LT] = ACTIONS(6851),
    [anon_sym_LT_LT] = ACTIONS(6851),
    [anon_sym_GT_GT] = ACTIONS(6851),
    [anon_sym_COLON] = ACTIONS(6853),
    [anon_sym_SEMI] = ACTIONS(6853),
    [anon_sym___attribute__] = ACTIONS(6851),
    [anon_sym___attribute] = ACTIONS(6851),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6853),
    [anon_sym_LBRACE] = ACTIONS(6853),
    [anon_sym_RBRACE] = ACTIONS(6853),
    [anon_sym_LBRACK] = ACTIONS(6851),
    [anon_sym_RBRACK] = ACTIONS(6853),
    [anon_sym_EQ] = ACTIONS(6851),
    [anon_sym_QMARK] = ACTIONS(6853),
    [anon_sym_STAR_EQ] = ACTIONS(6853),
    [anon_sym_SLASH_EQ] = ACTIONS(6853),
    [anon_sym_PERCENT_EQ] = ACTIONS(6853),
    [anon_sym_PLUS_EQ] = ACTIONS(6853),
    [anon_sym_DASH_EQ] = ACTIONS(6853),
    [anon_sym_LT_LT_EQ] = ACTIONS(6853),
    [anon_sym_GT_GT_EQ] = ACTIONS(6853),
    [anon_sym_AMP_EQ] = ACTIONS(6853),
    [anon_sym_CARET_EQ] = ACTIONS(6853),
    [anon_sym_PIPE_EQ] = ACTIONS(6853),
    [anon_sym_and_eq] = ACTIONS(6851),
    [anon_sym_or_eq] = ACTIONS(6851),
    [anon_sym_xor_eq] = ACTIONS(6851),
    [anon_sym_LT_EQ_GT] = ACTIONS(6853),
    [anon_sym_or] = ACTIONS(6851),
    [anon_sym_and] = ACTIONS(6851),
    [anon_sym_bitor] = ACTIONS(6851),
    [anon_sym_xor] = ACTIONS(6851),
    [anon_sym_bitand] = ACTIONS(6851),
    [anon_sym_not_eq] = ACTIONS(6851),
    [anon_sym_DASH_DASH] = ACTIONS(6853),
    [anon_sym_PLUS_PLUS] = ACTIONS(6853),
    [anon_sym_DOT] = ACTIONS(6851),
    [anon_sym_DOT_STAR] = ACTIONS(6853),
    [anon_sym_DASH_GT] = ACTIONS(6853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6851),
  },
  [2778] = {
    [sym_identifier] = ACTIONS(5902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [aux_sym_preproc_if_token2] = ACTIONS(5904),
    [aux_sym_preproc_else_token1] = ACTIONS(5904),
    [aux_sym_preproc_elif_token1] = ACTIONS(5902),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5904),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5902),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___attribute__] = ACTIONS(5902),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_STAR_EQ] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_PERCENT_EQ] = ACTIONS(5904),
    [anon_sym_PLUS_EQ] = ACTIONS(5904),
    [anon_sym_DASH_EQ] = ACTIONS(5904),
    [anon_sym_LT_LT_EQ] = ACTIONS(5904),
    [anon_sym_GT_GT_EQ] = ACTIONS(5904),
    [anon_sym_AMP_EQ] = ACTIONS(5904),
    [anon_sym_CARET_EQ] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_and_eq] = ACTIONS(5902),
    [anon_sym_or_eq] = ACTIONS(5902),
    [anon_sym_xor_eq] = ACTIONS(5902),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5902),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5902),
    [anon_sym_not_eq] = ACTIONS(5902),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5902),
    [anon_sym_decltype] = ACTIONS(5902),
  },
  [2779] = {
    [sym_string_literal] = STATE(2795),
    [sym_raw_string_literal] = STATE(2795),
    [aux_sym_concatenated_string_repeat1] = STATE(2795),
    [sym_identifier] = ACTIONS(6855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6423),
    [anon_sym_COMMA] = ACTIONS(6423),
    [anon_sym_LPAREN2] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6425),
    [anon_sym_PLUS] = ACTIONS(6425),
    [anon_sym_STAR] = ACTIONS(6425),
    [anon_sym_SLASH] = ACTIONS(6425),
    [anon_sym_PERCENT] = ACTIONS(6425),
    [anon_sym_PIPE_PIPE] = ACTIONS(6423),
    [anon_sym_AMP_AMP] = ACTIONS(6423),
    [anon_sym_PIPE] = ACTIONS(6425),
    [anon_sym_CARET] = ACTIONS(6425),
    [anon_sym_AMP] = ACTIONS(6425),
    [anon_sym_EQ_EQ] = ACTIONS(6423),
    [anon_sym_BANG_EQ] = ACTIONS(6423),
    [anon_sym_GT] = ACTIONS(6425),
    [anon_sym_GT_EQ] = ACTIONS(6425),
    [anon_sym_LT_EQ] = ACTIONS(6425),
    [anon_sym_LT] = ACTIONS(6425),
    [anon_sym_LT_LT] = ACTIONS(6425),
    [anon_sym_GT_GT] = ACTIONS(6425),
    [anon_sym_LBRACK] = ACTIONS(6423),
    [anon_sym_EQ] = ACTIONS(6425),
    [anon_sym_QMARK] = ACTIONS(6423),
    [anon_sym_STAR_EQ] = ACTIONS(6423),
    [anon_sym_SLASH_EQ] = ACTIONS(6423),
    [anon_sym_PERCENT_EQ] = ACTIONS(6423),
    [anon_sym_PLUS_EQ] = ACTIONS(6423),
    [anon_sym_DASH_EQ] = ACTIONS(6423),
    [anon_sym_LT_LT_EQ] = ACTIONS(6423),
    [anon_sym_GT_GT_EQ] = ACTIONS(6425),
    [anon_sym_AMP_EQ] = ACTIONS(6423),
    [anon_sym_CARET_EQ] = ACTIONS(6423),
    [anon_sym_PIPE_EQ] = ACTIONS(6423),
    [anon_sym_and_eq] = ACTIONS(6425),
    [anon_sym_or_eq] = ACTIONS(6425),
    [anon_sym_xor_eq] = ACTIONS(6425),
    [anon_sym_LT_EQ_GT] = ACTIONS(6423),
    [anon_sym_or] = ACTIONS(6425),
    [anon_sym_and] = ACTIONS(6425),
    [anon_sym_bitor] = ACTIONS(6425),
    [anon_sym_xor] = ACTIONS(6425),
    [anon_sym_bitand] = ACTIONS(6425),
    [anon_sym_not_eq] = ACTIONS(6425),
    [anon_sym_DASH_DASH] = ACTIONS(6423),
    [anon_sym_PLUS_PLUS] = ACTIONS(6423),
    [anon_sym_DOT] = ACTIONS(6425),
    [anon_sym_DOT_STAR] = ACTIONS(6423),
    [anon_sym_DASH_GT] = ACTIONS(6423),
    [anon_sym_L_DQUOTE] = ACTIONS(6780),
    [anon_sym_u_DQUOTE] = ACTIONS(6780),
    [anon_sym_U_DQUOTE] = ACTIONS(6780),
    [anon_sym_u8_DQUOTE] = ACTIONS(6780),
    [anon_sym_DQUOTE] = ACTIONS(6780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6423),
    [anon_sym_R_DQUOTE] = ACTIONS(6782),
    [anon_sym_LR_DQUOTE] = ACTIONS(6782),
    [anon_sym_uR_DQUOTE] = ACTIONS(6782),
    [anon_sym_UR_DQUOTE] = ACTIONS(6782),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6782),
    [sym_literal_suffix] = ACTIONS(6425),
  },
  [2780] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [aux_sym_preproc_if_token2] = ACTIONS(6047),
    [aux_sym_preproc_else_token1] = ACTIONS(6047),
    [aux_sym_preproc_elif_token1] = ACTIONS(6045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6045),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6045),
    [anon_sym_GT_GT] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_STAR_EQ] = ACTIONS(6047),
    [anon_sym_SLASH_EQ] = ACTIONS(6047),
    [anon_sym_PERCENT_EQ] = ACTIONS(6047),
    [anon_sym_PLUS_EQ] = ACTIONS(6047),
    [anon_sym_DASH_EQ] = ACTIONS(6047),
    [anon_sym_LT_LT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_AMP_EQ] = ACTIONS(6047),
    [anon_sym_CARET_EQ] = ACTIONS(6047),
    [anon_sym_PIPE_EQ] = ACTIONS(6047),
    [anon_sym_and_eq] = ACTIONS(6045),
    [anon_sym_or_eq] = ACTIONS(6045),
    [anon_sym_xor_eq] = ACTIONS(6045),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
  },
  [2781] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(6857),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6859),
    [anon_sym_SLASH_EQ] = ACTIONS(6859),
    [anon_sym_PERCENT_EQ] = ACTIONS(6859),
    [anon_sym_PLUS_EQ] = ACTIONS(6859),
    [anon_sym_DASH_EQ] = ACTIONS(6859),
    [anon_sym_LT_LT_EQ] = ACTIONS(6859),
    [anon_sym_GT_GT_EQ] = ACTIONS(6859),
    [anon_sym_AMP_EQ] = ACTIONS(6859),
    [anon_sym_CARET_EQ] = ACTIONS(6859),
    [anon_sym_PIPE_EQ] = ACTIONS(6859),
    [anon_sym_and_eq] = ACTIONS(6859),
    [anon_sym_or_eq] = ACTIONS(6859),
    [anon_sym_xor_eq] = ACTIONS(6859),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2782] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6461),
    [anon_sym_COMMA] = ACTIONS(6461),
    [anon_sym_RPAREN] = ACTIONS(6461),
    [anon_sym_LPAREN2] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(6459),
    [anon_sym_PLUS] = ACTIONS(6459),
    [anon_sym_STAR] = ACTIONS(6459),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_PERCENT] = ACTIONS(6459),
    [anon_sym_PIPE_PIPE] = ACTIONS(6461),
    [anon_sym_AMP_AMP] = ACTIONS(6461),
    [anon_sym_PIPE] = ACTIONS(6459),
    [anon_sym_CARET] = ACTIONS(6459),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ_EQ] = ACTIONS(6461),
    [anon_sym_BANG_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6459),
    [anon_sym_GT_EQ] = ACTIONS(6461),
    [anon_sym_LT_EQ] = ACTIONS(6459),
    [anon_sym_LT] = ACTIONS(6459),
    [anon_sym_LT_LT] = ACTIONS(6459),
    [anon_sym_GT_GT] = ACTIONS(6459),
    [anon_sym_COLON] = ACTIONS(6461),
    [anon_sym_SEMI] = ACTIONS(6461),
    [anon_sym_RBRACE] = ACTIONS(6461),
    [anon_sym_LBRACK] = ACTIONS(6461),
    [anon_sym_RBRACK] = ACTIONS(6461),
    [anon_sym_EQ] = ACTIONS(6459),
    [anon_sym_QMARK] = ACTIONS(6461),
    [anon_sym_STAR_EQ] = ACTIONS(6461),
    [anon_sym_SLASH_EQ] = ACTIONS(6461),
    [anon_sym_PERCENT_EQ] = ACTIONS(6461),
    [anon_sym_PLUS_EQ] = ACTIONS(6461),
    [anon_sym_DASH_EQ] = ACTIONS(6461),
    [anon_sym_LT_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT_GT_EQ] = ACTIONS(6461),
    [anon_sym_AMP_EQ] = ACTIONS(6461),
    [anon_sym_CARET_EQ] = ACTIONS(6461),
    [anon_sym_PIPE_EQ] = ACTIONS(6461),
    [anon_sym_and_eq] = ACTIONS(6459),
    [anon_sym_or_eq] = ACTIONS(6459),
    [anon_sym_xor_eq] = ACTIONS(6459),
    [anon_sym_LT_EQ_GT] = ACTIONS(6461),
    [anon_sym_or] = ACTIONS(6459),
    [anon_sym_and] = ACTIONS(6459),
    [anon_sym_bitor] = ACTIONS(6459),
    [anon_sym_xor] = ACTIONS(6459),
    [anon_sym_bitand] = ACTIONS(6459),
    [anon_sym_not_eq] = ACTIONS(6459),
    [anon_sym_DASH_DASH] = ACTIONS(6461),
    [anon_sym_PLUS_PLUS] = ACTIONS(6461),
    [anon_sym_DOT] = ACTIONS(6459),
    [anon_sym_DOT_STAR] = ACTIONS(6461),
    [anon_sym_DASH_GT] = ACTIONS(6461),
    [anon_sym_L_DQUOTE] = ACTIONS(6461),
    [anon_sym_u_DQUOTE] = ACTIONS(6461),
    [anon_sym_U_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8_DQUOTE] = ACTIONS(6461),
    [anon_sym_DQUOTE] = ACTIONS(6461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6461),
    [anon_sym_LR_DQUOTE] = ACTIONS(6461),
    [anon_sym_uR_DQUOTE] = ACTIONS(6461),
    [anon_sym_UR_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6461),
    [sym_literal_suffix] = ACTIONS(6459),
  },
  [2783] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [aux_sym_preproc_if_token2] = ACTIONS(6047),
    [aux_sym_preproc_else_token1] = ACTIONS(6047),
    [aux_sym_preproc_elif_token1] = ACTIONS(6045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6045),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6045),
    [anon_sym_GT_GT] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6047),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_STAR_EQ] = ACTIONS(6047),
    [anon_sym_SLASH_EQ] = ACTIONS(6047),
    [anon_sym_PERCENT_EQ] = ACTIONS(6047),
    [anon_sym_PLUS_EQ] = ACTIONS(6047),
    [anon_sym_DASH_EQ] = ACTIONS(6047),
    [anon_sym_LT_LT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_AMP_EQ] = ACTIONS(6047),
    [anon_sym_CARET_EQ] = ACTIONS(6047),
    [anon_sym_PIPE_EQ] = ACTIONS(6047),
    [anon_sym_and_eq] = ACTIONS(6045),
    [anon_sym_or_eq] = ACTIONS(6045),
    [anon_sym_xor_eq] = ACTIONS(6045),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6045),
    [anon_sym_decltype] = ACTIONS(6045),
  },
  [2784] = {
    [sym_identifier] = ACTIONS(6861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6863),
    [anon_sym_COMMA] = ACTIONS(6863),
    [anon_sym_RPAREN] = ACTIONS(6863),
    [aux_sym_preproc_if_token2] = ACTIONS(6863),
    [aux_sym_preproc_else_token1] = ACTIONS(6863),
    [aux_sym_preproc_elif_token1] = ACTIONS(6861),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6863),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6863),
    [anon_sym_LPAREN2] = ACTIONS(6863),
    [anon_sym_DASH] = ACTIONS(6861),
    [anon_sym_PLUS] = ACTIONS(6861),
    [anon_sym_STAR] = ACTIONS(6861),
    [anon_sym_SLASH] = ACTIONS(6861),
    [anon_sym_PERCENT] = ACTIONS(6861),
    [anon_sym_PIPE_PIPE] = ACTIONS(6863),
    [anon_sym_AMP_AMP] = ACTIONS(6863),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_CARET] = ACTIONS(6861),
    [anon_sym_AMP] = ACTIONS(6861),
    [anon_sym_EQ_EQ] = ACTIONS(6863),
    [anon_sym_BANG_EQ] = ACTIONS(6863),
    [anon_sym_GT] = ACTIONS(6861),
    [anon_sym_GT_EQ] = ACTIONS(6863),
    [anon_sym_LT_EQ] = ACTIONS(6861),
    [anon_sym_LT] = ACTIONS(6861),
    [anon_sym_LT_LT] = ACTIONS(6861),
    [anon_sym_GT_GT] = ACTIONS(6861),
    [anon_sym_COLON] = ACTIONS(6863),
    [anon_sym_SEMI] = ACTIONS(6863),
    [anon_sym___attribute__] = ACTIONS(6861),
    [anon_sym___attribute] = ACTIONS(6861),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6863),
    [anon_sym_LBRACE] = ACTIONS(6863),
    [anon_sym_RBRACE] = ACTIONS(6863),
    [anon_sym_LBRACK] = ACTIONS(6861),
    [anon_sym_RBRACK] = ACTIONS(6863),
    [anon_sym_EQ] = ACTIONS(6861),
    [anon_sym_QMARK] = ACTIONS(6863),
    [anon_sym_STAR_EQ] = ACTIONS(6863),
    [anon_sym_SLASH_EQ] = ACTIONS(6863),
    [anon_sym_PERCENT_EQ] = ACTIONS(6863),
    [anon_sym_PLUS_EQ] = ACTIONS(6863),
    [anon_sym_DASH_EQ] = ACTIONS(6863),
    [anon_sym_LT_LT_EQ] = ACTIONS(6863),
    [anon_sym_GT_GT_EQ] = ACTIONS(6863),
    [anon_sym_AMP_EQ] = ACTIONS(6863),
    [anon_sym_CARET_EQ] = ACTIONS(6863),
    [anon_sym_PIPE_EQ] = ACTIONS(6863),
    [anon_sym_and_eq] = ACTIONS(6861),
    [anon_sym_or_eq] = ACTIONS(6861),
    [anon_sym_xor_eq] = ACTIONS(6861),
    [anon_sym_LT_EQ_GT] = ACTIONS(6863),
    [anon_sym_or] = ACTIONS(6861),
    [anon_sym_and] = ACTIONS(6861),
    [anon_sym_bitor] = ACTIONS(6861),
    [anon_sym_xor] = ACTIONS(6861),
    [anon_sym_bitand] = ACTIONS(6861),
    [anon_sym_not_eq] = ACTIONS(6861),
    [anon_sym_DASH_DASH] = ACTIONS(6863),
    [anon_sym_PLUS_PLUS] = ACTIONS(6863),
    [anon_sym_DOT] = ACTIONS(6861),
    [anon_sym_DOT_STAR] = ACTIONS(6863),
    [anon_sym_DASH_GT] = ACTIONS(6863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6861),
  },
  [2785] = {
    [sym_identifier] = ACTIONS(6103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6105),
    [anon_sym_COMMA] = ACTIONS(6105),
    [anon_sym_RPAREN] = ACTIONS(6105),
    [aux_sym_preproc_if_token2] = ACTIONS(6105),
    [aux_sym_preproc_else_token1] = ACTIONS(6105),
    [aux_sym_preproc_elif_token1] = ACTIONS(6103),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6105),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6105),
    [anon_sym_LPAREN2] = ACTIONS(6105),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_PERCENT] = ACTIONS(6103),
    [anon_sym_PIPE_PIPE] = ACTIONS(6105),
    [anon_sym_AMP_AMP] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_AMP] = ACTIONS(6103),
    [anon_sym_EQ_EQ] = ACTIONS(6105),
    [anon_sym_BANG_EQ] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6103),
    [anon_sym_GT_EQ] = ACTIONS(6105),
    [anon_sym_LT_EQ] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6103),
    [anon_sym_LT_LT] = ACTIONS(6103),
    [anon_sym_GT_GT] = ACTIONS(6103),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SEMI] = ACTIONS(6105),
    [anon_sym___attribute__] = ACTIONS(6103),
    [anon_sym___attribute] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(6105),
    [anon_sym_RBRACE] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6105),
    [anon_sym_RBRACK] = ACTIONS(6105),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_QMARK] = ACTIONS(6105),
    [anon_sym_STAR_EQ] = ACTIONS(6105),
    [anon_sym_SLASH_EQ] = ACTIONS(6105),
    [anon_sym_PERCENT_EQ] = ACTIONS(6105),
    [anon_sym_PLUS_EQ] = ACTIONS(6105),
    [anon_sym_DASH_EQ] = ACTIONS(6105),
    [anon_sym_LT_LT_EQ] = ACTIONS(6105),
    [anon_sym_GT_GT_EQ] = ACTIONS(6105),
    [anon_sym_AMP_EQ] = ACTIONS(6105),
    [anon_sym_CARET_EQ] = ACTIONS(6105),
    [anon_sym_PIPE_EQ] = ACTIONS(6105),
    [anon_sym_and_eq] = ACTIONS(6103),
    [anon_sym_or_eq] = ACTIONS(6103),
    [anon_sym_xor_eq] = ACTIONS(6103),
    [anon_sym_LT_EQ_GT] = ACTIONS(6105),
    [anon_sym_or] = ACTIONS(6103),
    [anon_sym_and] = ACTIONS(6103),
    [anon_sym_bitor] = ACTIONS(6103),
    [anon_sym_xor] = ACTIONS(6103),
    [anon_sym_bitand] = ACTIONS(6103),
    [anon_sym_not_eq] = ACTIONS(6103),
    [anon_sym_DASH_DASH] = ACTIONS(6105),
    [anon_sym_PLUS_PLUS] = ACTIONS(6105),
    [anon_sym_DOT] = ACTIONS(6103),
    [anon_sym_DOT_STAR] = ACTIONS(6105),
    [anon_sym_DASH_GT] = ACTIONS(6105),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6103),
    [anon_sym_decltype] = ACTIONS(6103),
  },
  [2786] = {
    [sym_identifier] = ACTIONS(6865),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6867),
    [anon_sym_COMMA] = ACTIONS(6867),
    [anon_sym_RPAREN] = ACTIONS(6867),
    [aux_sym_preproc_if_token2] = ACTIONS(6867),
    [aux_sym_preproc_else_token1] = ACTIONS(6867),
    [aux_sym_preproc_elif_token1] = ACTIONS(6865),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6867),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6867),
    [anon_sym_LPAREN2] = ACTIONS(6867),
    [anon_sym_DASH] = ACTIONS(6865),
    [anon_sym_PLUS] = ACTIONS(6865),
    [anon_sym_STAR] = ACTIONS(6865),
    [anon_sym_SLASH] = ACTIONS(6865),
    [anon_sym_PERCENT] = ACTIONS(6865),
    [anon_sym_PIPE_PIPE] = ACTIONS(6867),
    [anon_sym_AMP_AMP] = ACTIONS(6867),
    [anon_sym_PIPE] = ACTIONS(6865),
    [anon_sym_CARET] = ACTIONS(6865),
    [anon_sym_AMP] = ACTIONS(6865),
    [anon_sym_EQ_EQ] = ACTIONS(6867),
    [anon_sym_BANG_EQ] = ACTIONS(6867),
    [anon_sym_GT] = ACTIONS(6865),
    [anon_sym_GT_EQ] = ACTIONS(6867),
    [anon_sym_LT_EQ] = ACTIONS(6865),
    [anon_sym_LT] = ACTIONS(6865),
    [anon_sym_LT_LT] = ACTIONS(6865),
    [anon_sym_GT_GT] = ACTIONS(6865),
    [anon_sym_COLON] = ACTIONS(6867),
    [anon_sym_SEMI] = ACTIONS(6867),
    [anon_sym___attribute__] = ACTIONS(6865),
    [anon_sym___attribute] = ACTIONS(6865),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6867),
    [anon_sym_LBRACE] = ACTIONS(6867),
    [anon_sym_RBRACE] = ACTIONS(6867),
    [anon_sym_LBRACK] = ACTIONS(6865),
    [anon_sym_RBRACK] = ACTIONS(6867),
    [anon_sym_EQ] = ACTIONS(6865),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_STAR_EQ] = ACTIONS(6867),
    [anon_sym_SLASH_EQ] = ACTIONS(6867),
    [anon_sym_PERCENT_EQ] = ACTIONS(6867),
    [anon_sym_PLUS_EQ] = ACTIONS(6867),
    [anon_sym_DASH_EQ] = ACTIONS(6867),
    [anon_sym_LT_LT_EQ] = ACTIONS(6867),
    [anon_sym_GT_GT_EQ] = ACTIONS(6867),
    [anon_sym_AMP_EQ] = ACTIONS(6867),
    [anon_sym_CARET_EQ] = ACTIONS(6867),
    [anon_sym_PIPE_EQ] = ACTIONS(6867),
    [anon_sym_and_eq] = ACTIONS(6865),
    [anon_sym_or_eq] = ACTIONS(6865),
    [anon_sym_xor_eq] = ACTIONS(6865),
    [anon_sym_LT_EQ_GT] = ACTIONS(6867),
    [anon_sym_or] = ACTIONS(6865),
    [anon_sym_and] = ACTIONS(6865),
    [anon_sym_bitor] = ACTIONS(6865),
    [anon_sym_xor] = ACTIONS(6865),
    [anon_sym_bitand] = ACTIONS(6865),
    [anon_sym_not_eq] = ACTIONS(6865),
    [anon_sym_DASH_DASH] = ACTIONS(6867),
    [anon_sym_PLUS_PLUS] = ACTIONS(6867),
    [anon_sym_DOT] = ACTIONS(6865),
    [anon_sym_DOT_STAR] = ACTIONS(6867),
    [anon_sym_DASH_GT] = ACTIONS(6867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6865),
  },
  [2787] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [aux_sym_preproc_if_token2] = ACTIONS(5923),
    [aux_sym_preproc_else_token1] = ACTIONS(5923),
    [aux_sym_preproc_elif_token1] = ACTIONS(5921),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5923),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5923),
    [anon_sym_DASH] = ACTIONS(5921),
    [anon_sym_PLUS] = ACTIONS(5921),
    [anon_sym_STAR] = ACTIONS(5921),
    [anon_sym_SLASH] = ACTIONS(5921),
    [anon_sym_PERCENT] = ACTIONS(5921),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT] = ACTIONS(5921),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5921),
    [anon_sym_LT] = ACTIONS(5921),
    [anon_sym_LT_LT] = ACTIONS(5921),
    [anon_sym_GT_GT] = ACTIONS(5921),
    [anon_sym___attribute__] = ACTIONS(5921),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_LBRACE] = ACTIONS(5923),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_EQ] = ACTIONS(5921),
    [anon_sym_QMARK] = ACTIONS(5923),
    [anon_sym_STAR_EQ] = ACTIONS(5923),
    [anon_sym_SLASH_EQ] = ACTIONS(5923),
    [anon_sym_PERCENT_EQ] = ACTIONS(5923),
    [anon_sym_PLUS_EQ] = ACTIONS(5923),
    [anon_sym_DASH_EQ] = ACTIONS(5923),
    [anon_sym_LT_LT_EQ] = ACTIONS(5923),
    [anon_sym_GT_GT_EQ] = ACTIONS(5923),
    [anon_sym_AMP_EQ] = ACTIONS(5923),
    [anon_sym_CARET_EQ] = ACTIONS(5923),
    [anon_sym_PIPE_EQ] = ACTIONS(5923),
    [anon_sym_and_eq] = ACTIONS(5921),
    [anon_sym_or_eq] = ACTIONS(5921),
    [anon_sym_xor_eq] = ACTIONS(5921),
    [anon_sym_LT_EQ_GT] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5921),
    [anon_sym_and] = ACTIONS(5921),
    [anon_sym_bitor] = ACTIONS(5921),
    [anon_sym_xor] = ACTIONS(5921),
    [anon_sym_bitand] = ACTIONS(5921),
    [anon_sym_not_eq] = ACTIONS(5921),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_DOT_STAR] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5921),
    [anon_sym_decltype] = ACTIONS(5921),
  },
  [2788] = {
    [sym_identifier] = ACTIONS(6869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6871),
    [anon_sym_COMMA] = ACTIONS(6871),
    [anon_sym_RPAREN] = ACTIONS(6871),
    [aux_sym_preproc_if_token2] = ACTIONS(6871),
    [aux_sym_preproc_else_token1] = ACTIONS(6871),
    [aux_sym_preproc_elif_token1] = ACTIONS(6869),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6871),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6871),
    [anon_sym_LPAREN2] = ACTIONS(6871),
    [anon_sym_DASH] = ACTIONS(6869),
    [anon_sym_PLUS] = ACTIONS(6869),
    [anon_sym_STAR] = ACTIONS(6869),
    [anon_sym_SLASH] = ACTIONS(6869),
    [anon_sym_PERCENT] = ACTIONS(6869),
    [anon_sym_PIPE_PIPE] = ACTIONS(6871),
    [anon_sym_AMP_AMP] = ACTIONS(6871),
    [anon_sym_PIPE] = ACTIONS(6869),
    [anon_sym_CARET] = ACTIONS(6869),
    [anon_sym_AMP] = ACTIONS(6869),
    [anon_sym_EQ_EQ] = ACTIONS(6871),
    [anon_sym_BANG_EQ] = ACTIONS(6871),
    [anon_sym_GT] = ACTIONS(6869),
    [anon_sym_GT_EQ] = ACTIONS(6871),
    [anon_sym_LT_EQ] = ACTIONS(6869),
    [anon_sym_LT] = ACTIONS(6869),
    [anon_sym_LT_LT] = ACTIONS(6869),
    [anon_sym_GT_GT] = ACTIONS(6869),
    [anon_sym_COLON] = ACTIONS(6871),
    [anon_sym_SEMI] = ACTIONS(6871),
    [anon_sym___attribute__] = ACTIONS(6869),
    [anon_sym___attribute] = ACTIONS(6869),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6871),
    [anon_sym_LBRACE] = ACTIONS(6871),
    [anon_sym_RBRACE] = ACTIONS(6871),
    [anon_sym_LBRACK] = ACTIONS(6869),
    [anon_sym_RBRACK] = ACTIONS(6871),
    [anon_sym_EQ] = ACTIONS(6869),
    [anon_sym_QMARK] = ACTIONS(6871),
    [anon_sym_STAR_EQ] = ACTIONS(6871),
    [anon_sym_SLASH_EQ] = ACTIONS(6871),
    [anon_sym_PERCENT_EQ] = ACTIONS(6871),
    [anon_sym_PLUS_EQ] = ACTIONS(6871),
    [anon_sym_DASH_EQ] = ACTIONS(6871),
    [anon_sym_LT_LT_EQ] = ACTIONS(6871),
    [anon_sym_GT_GT_EQ] = ACTIONS(6871),
    [anon_sym_AMP_EQ] = ACTIONS(6871),
    [anon_sym_CARET_EQ] = ACTIONS(6871),
    [anon_sym_PIPE_EQ] = ACTIONS(6871),
    [anon_sym_and_eq] = ACTIONS(6869),
    [anon_sym_or_eq] = ACTIONS(6869),
    [anon_sym_xor_eq] = ACTIONS(6869),
    [anon_sym_LT_EQ_GT] = ACTIONS(6871),
    [anon_sym_or] = ACTIONS(6869),
    [anon_sym_and] = ACTIONS(6869),
    [anon_sym_bitor] = ACTIONS(6869),
    [anon_sym_xor] = ACTIONS(6869),
    [anon_sym_bitand] = ACTIONS(6869),
    [anon_sym_not_eq] = ACTIONS(6869),
    [anon_sym_DASH_DASH] = ACTIONS(6871),
    [anon_sym_PLUS_PLUS] = ACTIONS(6871),
    [anon_sym_DOT] = ACTIONS(6869),
    [anon_sym_DOT_STAR] = ACTIONS(6871),
    [anon_sym_DASH_GT] = ACTIONS(6871),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6869),
  },
  [2789] = {
    [sym_identifier] = ACTIONS(6873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6875),
    [anon_sym_COMMA] = ACTIONS(6875),
    [anon_sym_RPAREN] = ACTIONS(6875),
    [aux_sym_preproc_if_token2] = ACTIONS(6875),
    [aux_sym_preproc_else_token1] = ACTIONS(6875),
    [aux_sym_preproc_elif_token1] = ACTIONS(6873),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6875),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6875),
    [anon_sym_LPAREN2] = ACTIONS(6875),
    [anon_sym_DASH] = ACTIONS(6873),
    [anon_sym_PLUS] = ACTIONS(6873),
    [anon_sym_STAR] = ACTIONS(6873),
    [anon_sym_SLASH] = ACTIONS(6873),
    [anon_sym_PERCENT] = ACTIONS(6873),
    [anon_sym_PIPE_PIPE] = ACTIONS(6875),
    [anon_sym_AMP_AMP] = ACTIONS(6875),
    [anon_sym_PIPE] = ACTIONS(6873),
    [anon_sym_CARET] = ACTIONS(6873),
    [anon_sym_AMP] = ACTIONS(6873),
    [anon_sym_EQ_EQ] = ACTIONS(6875),
    [anon_sym_BANG_EQ] = ACTIONS(6875),
    [anon_sym_GT] = ACTIONS(6873),
    [anon_sym_GT_EQ] = ACTIONS(6875),
    [anon_sym_LT_EQ] = ACTIONS(6873),
    [anon_sym_LT] = ACTIONS(6873),
    [anon_sym_LT_LT] = ACTIONS(6873),
    [anon_sym_GT_GT] = ACTIONS(6873),
    [anon_sym_COLON] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(6875),
    [anon_sym___attribute__] = ACTIONS(6873),
    [anon_sym___attribute] = ACTIONS(6873),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6875),
    [anon_sym_LBRACE] = ACTIONS(6875),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_LBRACK] = ACTIONS(6873),
    [anon_sym_RBRACK] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(6873),
    [anon_sym_QMARK] = ACTIONS(6875),
    [anon_sym_STAR_EQ] = ACTIONS(6875),
    [anon_sym_SLASH_EQ] = ACTIONS(6875),
    [anon_sym_PERCENT_EQ] = ACTIONS(6875),
    [anon_sym_PLUS_EQ] = ACTIONS(6875),
    [anon_sym_DASH_EQ] = ACTIONS(6875),
    [anon_sym_LT_LT_EQ] = ACTIONS(6875),
    [anon_sym_GT_GT_EQ] = ACTIONS(6875),
    [anon_sym_AMP_EQ] = ACTIONS(6875),
    [anon_sym_CARET_EQ] = ACTIONS(6875),
    [anon_sym_PIPE_EQ] = ACTIONS(6875),
    [anon_sym_and_eq] = ACTIONS(6873),
    [anon_sym_or_eq] = ACTIONS(6873),
    [anon_sym_xor_eq] = ACTIONS(6873),
    [anon_sym_LT_EQ_GT] = ACTIONS(6875),
    [anon_sym_or] = ACTIONS(6873),
    [anon_sym_and] = ACTIONS(6873),
    [anon_sym_bitor] = ACTIONS(6873),
    [anon_sym_xor] = ACTIONS(6873),
    [anon_sym_bitand] = ACTIONS(6873),
    [anon_sym_not_eq] = ACTIONS(6873),
    [anon_sym_DASH_DASH] = ACTIONS(6875),
    [anon_sym_PLUS_PLUS] = ACTIONS(6875),
    [anon_sym_DOT] = ACTIONS(6873),
    [anon_sym_DOT_STAR] = ACTIONS(6875),
    [anon_sym_DASH_GT] = ACTIONS(6875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6873),
  },
  [2790] = {
    [sym_identifier] = ACTIONS(6125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6127),
    [anon_sym_COMMA] = ACTIONS(6127),
    [anon_sym_RPAREN] = ACTIONS(6127),
    [aux_sym_preproc_if_token2] = ACTIONS(6127),
    [aux_sym_preproc_else_token1] = ACTIONS(6127),
    [aux_sym_preproc_elif_token1] = ACTIONS(6125),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6127),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6127),
    [anon_sym_LPAREN2] = ACTIONS(6127),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_PERCENT] = ACTIONS(6125),
    [anon_sym_PIPE_PIPE] = ACTIONS(6127),
    [anon_sym_AMP_AMP] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_AMP] = ACTIONS(6125),
    [anon_sym_EQ_EQ] = ACTIONS(6127),
    [anon_sym_BANG_EQ] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6125),
    [anon_sym_GT_EQ] = ACTIONS(6127),
    [anon_sym_LT_EQ] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6125),
    [anon_sym_LT_LT] = ACTIONS(6125),
    [anon_sym_GT_GT] = ACTIONS(6125),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SEMI] = ACTIONS(6127),
    [anon_sym___attribute__] = ACTIONS(6125),
    [anon_sym___attribute] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(6127),
    [anon_sym_RBRACE] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_RBRACK] = ACTIONS(6127),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_QMARK] = ACTIONS(6127),
    [anon_sym_STAR_EQ] = ACTIONS(6127),
    [anon_sym_SLASH_EQ] = ACTIONS(6127),
    [anon_sym_PERCENT_EQ] = ACTIONS(6127),
    [anon_sym_PLUS_EQ] = ACTIONS(6127),
    [anon_sym_DASH_EQ] = ACTIONS(6127),
    [anon_sym_LT_LT_EQ] = ACTIONS(6127),
    [anon_sym_GT_GT_EQ] = ACTIONS(6127),
    [anon_sym_AMP_EQ] = ACTIONS(6127),
    [anon_sym_CARET_EQ] = ACTIONS(6127),
    [anon_sym_PIPE_EQ] = ACTIONS(6127),
    [anon_sym_and_eq] = ACTIONS(6125),
    [anon_sym_or_eq] = ACTIONS(6125),
    [anon_sym_xor_eq] = ACTIONS(6125),
    [anon_sym_LT_EQ_GT] = ACTIONS(6127),
    [anon_sym_or] = ACTIONS(6125),
    [anon_sym_and] = ACTIONS(6125),
    [anon_sym_bitor] = ACTIONS(6125),
    [anon_sym_xor] = ACTIONS(6125),
    [anon_sym_bitand] = ACTIONS(6125),
    [anon_sym_not_eq] = ACTIONS(6125),
    [anon_sym_DASH_DASH] = ACTIONS(6127),
    [anon_sym_PLUS_PLUS] = ACTIONS(6127),
    [anon_sym_DOT] = ACTIONS(6125),
    [anon_sym_DOT_STAR] = ACTIONS(6127),
    [anon_sym_DASH_GT] = ACTIONS(6127),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6125),
    [anon_sym_decltype] = ACTIONS(6125),
  },
  [2791] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6410),
    [anon_sym_COMMA] = ACTIONS(6410),
    [anon_sym_RPAREN] = ACTIONS(6410),
    [anon_sym_LPAREN2] = ACTIONS(6410),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_PERCENT] = ACTIONS(6408),
    [anon_sym_PIPE_PIPE] = ACTIONS(6410),
    [anon_sym_AMP_AMP] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_AMP] = ACTIONS(6408),
    [anon_sym_EQ_EQ] = ACTIONS(6410),
    [anon_sym_BANG_EQ] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6408),
    [anon_sym_GT_EQ] = ACTIONS(6410),
    [anon_sym_LT_EQ] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6408),
    [anon_sym_LT_LT] = ACTIONS(6408),
    [anon_sym_GT_GT] = ACTIONS(6408),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SEMI] = ACTIONS(6410),
    [anon_sym_RBRACE] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_RBRACK] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_QMARK] = ACTIONS(6410),
    [anon_sym_STAR_EQ] = ACTIONS(6410),
    [anon_sym_SLASH_EQ] = ACTIONS(6410),
    [anon_sym_PERCENT_EQ] = ACTIONS(6410),
    [anon_sym_PLUS_EQ] = ACTIONS(6410),
    [anon_sym_DASH_EQ] = ACTIONS(6410),
    [anon_sym_LT_LT_EQ] = ACTIONS(6410),
    [anon_sym_GT_GT_EQ] = ACTIONS(6410),
    [anon_sym_AMP_EQ] = ACTIONS(6410),
    [anon_sym_CARET_EQ] = ACTIONS(6410),
    [anon_sym_PIPE_EQ] = ACTIONS(6410),
    [anon_sym_and_eq] = ACTIONS(6408),
    [anon_sym_or_eq] = ACTIONS(6408),
    [anon_sym_xor_eq] = ACTIONS(6408),
    [anon_sym_LT_EQ_GT] = ACTIONS(6410),
    [anon_sym_or] = ACTIONS(6408),
    [anon_sym_and] = ACTIONS(6408),
    [anon_sym_bitor] = ACTIONS(6408),
    [anon_sym_xor] = ACTIONS(6408),
    [anon_sym_bitand] = ACTIONS(6408),
    [anon_sym_not_eq] = ACTIONS(6408),
    [anon_sym_DASH_DASH] = ACTIONS(6410),
    [anon_sym_PLUS_PLUS] = ACTIONS(6410),
    [anon_sym_DOT] = ACTIONS(6408),
    [anon_sym_DOT_STAR] = ACTIONS(6410),
    [anon_sym_DASH_GT] = ACTIONS(6410),
    [anon_sym_L_DQUOTE] = ACTIONS(6410),
    [anon_sym_u_DQUOTE] = ACTIONS(6410),
    [anon_sym_U_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8_DQUOTE] = ACTIONS(6410),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6410),
    [anon_sym_LR_DQUOTE] = ACTIONS(6410),
    [anon_sym_uR_DQUOTE] = ACTIONS(6410),
    [anon_sym_UR_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6410),
    [sym_literal_suffix] = ACTIONS(6408),
  },
  [2792] = {
    [sym_template_argument_list] = STATE(2841),
    [sym_identifier] = ACTIONS(4433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4428),
    [anon_sym_COMMA] = ACTIONS(4428),
    [anon_sym_RPAREN] = ACTIONS(4428),
    [aux_sym_preproc_if_token2] = ACTIONS(4428),
    [aux_sym_preproc_else_token1] = ACTIONS(4428),
    [aux_sym_preproc_elif_token1] = ACTIONS(4433),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4428),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4428),
    [anon_sym_LPAREN2] = ACTIONS(4428),
    [anon_sym_DASH] = ACTIONS(4433),
    [anon_sym_PLUS] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(4433),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_PERCENT] = ACTIONS(4433),
    [anon_sym_PIPE_PIPE] = ACTIONS(4428),
    [anon_sym_AMP_AMP] = ACTIONS(4428),
    [anon_sym_PIPE] = ACTIONS(4433),
    [anon_sym_CARET] = ACTIONS(4433),
    [anon_sym_AMP] = ACTIONS(4433),
    [anon_sym_EQ_EQ] = ACTIONS(4428),
    [anon_sym_BANG_EQ] = ACTIONS(4428),
    [anon_sym_GT] = ACTIONS(4433),
    [anon_sym_GT_EQ] = ACTIONS(4428),
    [anon_sym_LT_EQ] = ACTIONS(4433),
    [anon_sym_LT] = ACTIONS(6577),
    [anon_sym_LT_LT] = ACTIONS(4433),
    [anon_sym_GT_GT] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4433),
    [anon_sym_SEMI] = ACTIONS(4428),
    [anon_sym___attribute__] = ACTIONS(4433),
    [anon_sym___attribute] = ACTIONS(4433),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(1999),
    [anon_sym_RBRACE] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4428),
    [anon_sym_RBRACK] = ACTIONS(4428),
    [anon_sym_EQ] = ACTIONS(4433),
    [anon_sym_QMARK] = ACTIONS(4428),
    [anon_sym_STAR_EQ] = ACTIONS(4428),
    [anon_sym_SLASH_EQ] = ACTIONS(4428),
    [anon_sym_PERCENT_EQ] = ACTIONS(4428),
    [anon_sym_PLUS_EQ] = ACTIONS(4428),
    [anon_sym_DASH_EQ] = ACTIONS(4428),
    [anon_sym_LT_LT_EQ] = ACTIONS(4428),
    [anon_sym_GT_GT_EQ] = ACTIONS(4428),
    [anon_sym_AMP_EQ] = ACTIONS(4428),
    [anon_sym_CARET_EQ] = ACTIONS(4428),
    [anon_sym_PIPE_EQ] = ACTIONS(4428),
    [anon_sym_and_eq] = ACTIONS(4433),
    [anon_sym_or_eq] = ACTIONS(4433),
    [anon_sym_xor_eq] = ACTIONS(4433),
    [anon_sym_LT_EQ_GT] = ACTIONS(4428),
    [anon_sym_or] = ACTIONS(4433),
    [anon_sym_and] = ACTIONS(4433),
    [anon_sym_bitor] = ACTIONS(4433),
    [anon_sym_xor] = ACTIONS(4433),
    [anon_sym_bitand] = ACTIONS(4433),
    [anon_sym_not_eq] = ACTIONS(4433),
    [anon_sym_DASH_DASH] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4428),
    [anon_sym_DOT] = ACTIONS(4433),
    [anon_sym_DOT_STAR] = ACTIONS(4428),
    [anon_sym_DASH_GT] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
  },
  [2793] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2720),
    [sym_identifier] = ACTIONS(5906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [aux_sym_preproc_if_token2] = ACTIONS(5908),
    [aux_sym_preproc_else_token1] = ACTIONS(5908),
    [aux_sym_preproc_elif_token1] = ACTIONS(5906),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5908),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_PLUS] = ACTIONS(5906),
    [anon_sym_STAR] = ACTIONS(5906),
    [anon_sym_SLASH] = ACTIONS(5906),
    [anon_sym_PERCENT] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_CARET] = ACTIONS(5906),
    [anon_sym_AMP] = ACTIONS(5906),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_LT_LT] = ACTIONS(5906),
    [anon_sym_GT_GT] = ACTIONS(5906),
    [anon_sym___attribute__] = ACTIONS(5906),
    [anon_sym___attribute] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6799),
    [anon_sym_unsigned] = ACTIONS(6799),
    [anon_sym_long] = ACTIONS(6799),
    [anon_sym_short] = ACTIONS(6799),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_STAR_EQ] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_PERCENT_EQ] = ACTIONS(5908),
    [anon_sym_PLUS_EQ] = ACTIONS(5908),
    [anon_sym_DASH_EQ] = ACTIONS(5908),
    [anon_sym_LT_LT_EQ] = ACTIONS(5908),
    [anon_sym_GT_GT_EQ] = ACTIONS(5908),
    [anon_sym_AMP_EQ] = ACTIONS(5908),
    [anon_sym_CARET_EQ] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_and_eq] = ACTIONS(5906),
    [anon_sym_or_eq] = ACTIONS(5906),
    [anon_sym_xor_eq] = ACTIONS(5906),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(5906),
    [anon_sym_bitor] = ACTIONS(5906),
    [anon_sym_xor] = ACTIONS(5906),
    [anon_sym_bitand] = ACTIONS(5906),
    [anon_sym_not_eq] = ACTIONS(5906),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5906),
    [anon_sym_decltype] = ACTIONS(5906),
  },
  [2794] = {
    [sym_identifier] = ACTIONS(2284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2286),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_RPAREN] = ACTIONS(2286),
    [aux_sym_preproc_if_token2] = ACTIONS(2286),
    [aux_sym_preproc_else_token1] = ACTIONS(2286),
    [aux_sym_preproc_elif_token1] = ACTIONS(2284),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2286),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2286),
    [anon_sym_LPAREN2] = ACTIONS(2286),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(2284),
    [anon_sym_PERCENT] = ACTIONS(2284),
    [anon_sym_PIPE_PIPE] = ACTIONS(2286),
    [anon_sym_AMP_AMP] = ACTIONS(2286),
    [anon_sym_PIPE] = ACTIONS(2284),
    [anon_sym_CARET] = ACTIONS(2284),
    [anon_sym_AMP] = ACTIONS(2284),
    [anon_sym_EQ_EQ] = ACTIONS(2286),
    [anon_sym_BANG_EQ] = ACTIONS(2286),
    [anon_sym_GT] = ACTIONS(2284),
    [anon_sym_GT_EQ] = ACTIONS(2286),
    [anon_sym_LT_EQ] = ACTIONS(2284),
    [anon_sym_LT] = ACTIONS(2284),
    [anon_sym_LT_LT] = ACTIONS(2284),
    [anon_sym_GT_GT] = ACTIONS(2284),
    [anon_sym_COLON] = ACTIONS(2286),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym___attribute__] = ACTIONS(2284),
    [anon_sym___attribute] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_RBRACK] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_QMARK] = ACTIONS(2286),
    [anon_sym_STAR_EQ] = ACTIONS(2286),
    [anon_sym_SLASH_EQ] = ACTIONS(2286),
    [anon_sym_PERCENT_EQ] = ACTIONS(2286),
    [anon_sym_PLUS_EQ] = ACTIONS(2286),
    [anon_sym_DASH_EQ] = ACTIONS(2286),
    [anon_sym_LT_LT_EQ] = ACTIONS(2286),
    [anon_sym_GT_GT_EQ] = ACTIONS(2286),
    [anon_sym_AMP_EQ] = ACTIONS(2286),
    [anon_sym_CARET_EQ] = ACTIONS(2286),
    [anon_sym_PIPE_EQ] = ACTIONS(2286),
    [anon_sym_and_eq] = ACTIONS(2284),
    [anon_sym_or_eq] = ACTIONS(2284),
    [anon_sym_xor_eq] = ACTIONS(2284),
    [anon_sym_LT_EQ_GT] = ACTIONS(2286),
    [anon_sym_or] = ACTIONS(2284),
    [anon_sym_and] = ACTIONS(2284),
    [anon_sym_bitor] = ACTIONS(2284),
    [anon_sym_xor] = ACTIONS(2284),
    [anon_sym_bitand] = ACTIONS(2284),
    [anon_sym_not_eq] = ACTIONS(2284),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DOT] = ACTIONS(2284),
    [anon_sym_DOT_STAR] = ACTIONS(2286),
    [anon_sym_DASH_GT] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2284),
    [anon_sym_decltype] = ACTIONS(2284),
  },
  [2795] = {
    [sym_string_literal] = STATE(2754),
    [sym_raw_string_literal] = STATE(2754),
    [aux_sym_concatenated_string_repeat1] = STATE(2754),
    [sym_identifier] = ACTIONS(6877),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6417),
    [anon_sym_COMMA] = ACTIONS(6417),
    [anon_sym_LPAREN2] = ACTIONS(6417),
    [anon_sym_DASH] = ACTIONS(6419),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_SLASH] = ACTIONS(6419),
    [anon_sym_PERCENT] = ACTIONS(6419),
    [anon_sym_PIPE_PIPE] = ACTIONS(6417),
    [anon_sym_AMP_AMP] = ACTIONS(6417),
    [anon_sym_PIPE] = ACTIONS(6419),
    [anon_sym_CARET] = ACTIONS(6419),
    [anon_sym_AMP] = ACTIONS(6419),
    [anon_sym_EQ_EQ] = ACTIONS(6417),
    [anon_sym_BANG_EQ] = ACTIONS(6417),
    [anon_sym_GT] = ACTIONS(6419),
    [anon_sym_GT_EQ] = ACTIONS(6419),
    [anon_sym_LT_EQ] = ACTIONS(6419),
    [anon_sym_LT] = ACTIONS(6419),
    [anon_sym_LT_LT] = ACTIONS(6419),
    [anon_sym_GT_GT] = ACTIONS(6419),
    [anon_sym_LBRACK] = ACTIONS(6417),
    [anon_sym_EQ] = ACTIONS(6419),
    [anon_sym_QMARK] = ACTIONS(6417),
    [anon_sym_STAR_EQ] = ACTIONS(6417),
    [anon_sym_SLASH_EQ] = ACTIONS(6417),
    [anon_sym_PERCENT_EQ] = ACTIONS(6417),
    [anon_sym_PLUS_EQ] = ACTIONS(6417),
    [anon_sym_DASH_EQ] = ACTIONS(6417),
    [anon_sym_LT_LT_EQ] = ACTIONS(6417),
    [anon_sym_GT_GT_EQ] = ACTIONS(6419),
    [anon_sym_AMP_EQ] = ACTIONS(6417),
    [anon_sym_CARET_EQ] = ACTIONS(6417),
    [anon_sym_PIPE_EQ] = ACTIONS(6417),
    [anon_sym_and_eq] = ACTIONS(6419),
    [anon_sym_or_eq] = ACTIONS(6419),
    [anon_sym_xor_eq] = ACTIONS(6419),
    [anon_sym_LT_EQ_GT] = ACTIONS(6417),
    [anon_sym_or] = ACTIONS(6419),
    [anon_sym_and] = ACTIONS(6419),
    [anon_sym_bitor] = ACTIONS(6419),
    [anon_sym_xor] = ACTIONS(6419),
    [anon_sym_bitand] = ACTIONS(6419),
    [anon_sym_not_eq] = ACTIONS(6419),
    [anon_sym_DASH_DASH] = ACTIONS(6417),
    [anon_sym_PLUS_PLUS] = ACTIONS(6417),
    [anon_sym_DOT] = ACTIONS(6419),
    [anon_sym_DOT_STAR] = ACTIONS(6417),
    [anon_sym_DASH_GT] = ACTIONS(6417),
    [anon_sym_L_DQUOTE] = ACTIONS(6780),
    [anon_sym_u_DQUOTE] = ACTIONS(6780),
    [anon_sym_U_DQUOTE] = ACTIONS(6780),
    [anon_sym_u8_DQUOTE] = ACTIONS(6780),
    [anon_sym_DQUOTE] = ACTIONS(6780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(6417),
    [anon_sym_R_DQUOTE] = ACTIONS(6782),
    [anon_sym_LR_DQUOTE] = ACTIONS(6782),
    [anon_sym_uR_DQUOTE] = ACTIONS(6782),
    [anon_sym_UR_DQUOTE] = ACTIONS(6782),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6782),
    [sym_literal_suffix] = ACTIONS(6419),
  },
  [2796] = {
    [sym_attribute_declaration] = STATE(2796),
    [aux_sym_attributed_declarator_repeat1] = STATE(2796),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6879),
    [anon_sym_COMMA] = ACTIONS(6879),
    [anon_sym_RPAREN] = ACTIONS(6879),
    [aux_sym_preproc_if_token2] = ACTIONS(6879),
    [aux_sym_preproc_else_token1] = ACTIONS(6879),
    [aux_sym_preproc_elif_token1] = ACTIONS(3364),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6879),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6879),
    [anon_sym_LPAREN2] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_PERCENT] = ACTIONS(3364),
    [anon_sym_PIPE_PIPE] = ACTIONS(6879),
    [anon_sym_AMP_AMP] = ACTIONS(6879),
    [anon_sym_PIPE] = ACTIONS(3364),
    [anon_sym_CARET] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3364),
    [anon_sym_EQ_EQ] = ACTIONS(6879),
    [anon_sym_BANG_EQ] = ACTIONS(6879),
    [anon_sym_GT] = ACTIONS(3364),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_LT_EQ] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_LT_LT] = ACTIONS(3364),
    [anon_sym_GT_GT] = ACTIONS(3364),
    [anon_sym_COLON] = ACTIONS(6879),
    [anon_sym_SEMI] = ACTIONS(6879),
    [anon_sym___attribute__] = ACTIONS(3364),
    [anon_sym___attribute] = ACTIONS(3364),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6881),
    [anon_sym_RBRACE] = ACTIONS(6879),
    [anon_sym_LBRACK] = ACTIONS(3364),
    [anon_sym_RBRACK] = ACTIONS(6879),
    [anon_sym_EQ] = ACTIONS(3364),
    [anon_sym_QMARK] = ACTIONS(6879),
    [anon_sym_STAR_EQ] = ACTIONS(6879),
    [anon_sym_SLASH_EQ] = ACTIONS(6879),
    [anon_sym_PERCENT_EQ] = ACTIONS(6879),
    [anon_sym_PLUS_EQ] = ACTIONS(6879),
    [anon_sym_DASH_EQ] = ACTIONS(6879),
    [anon_sym_LT_LT_EQ] = ACTIONS(6879),
    [anon_sym_GT_GT_EQ] = ACTIONS(6879),
    [anon_sym_AMP_EQ] = ACTIONS(6879),
    [anon_sym_CARET_EQ] = ACTIONS(6879),
    [anon_sym_PIPE_EQ] = ACTIONS(6879),
    [anon_sym_and_eq] = ACTIONS(3364),
    [anon_sym_or_eq] = ACTIONS(3364),
    [anon_sym_xor_eq] = ACTIONS(3364),
    [anon_sym_LT_EQ_GT] = ACTIONS(6879),
    [anon_sym_or] = ACTIONS(3364),
    [anon_sym_and] = ACTIONS(3364),
    [anon_sym_bitor] = ACTIONS(3364),
    [anon_sym_xor] = ACTIONS(3364),
    [anon_sym_bitand] = ACTIONS(3364),
    [anon_sym_not_eq] = ACTIONS(3364),
    [anon_sym_DASH_DASH] = ACTIONS(6879),
    [anon_sym_PLUS_PLUS] = ACTIONS(6879),
    [anon_sym_DOT] = ACTIONS(3364),
    [anon_sym_DOT_STAR] = ACTIONS(6879),
    [anon_sym_DASH_GT] = ACTIONS(6879),
    [sym_comment] = ACTIONS(3),
  },
  [2797] = {
    [sym_string_literal] = STATE(3035),
    [sym_template_argument_list] = STATE(3968),
    [sym_raw_string_literal] = STATE(3035),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4217),
    [anon_sym_COMMA] = ACTIONS(4217),
    [anon_sym_LPAREN2] = ACTIONS(4217),
    [anon_sym_DASH] = ACTIONS(4225),
    [anon_sym_PLUS] = ACTIONS(4225),
    [anon_sym_STAR] = ACTIONS(4225),
    [anon_sym_SLASH] = ACTIONS(4225),
    [anon_sym_PERCENT] = ACTIONS(4225),
    [anon_sym_PIPE_PIPE] = ACTIONS(4217),
    [anon_sym_AMP_AMP] = ACTIONS(4217),
    [anon_sym_PIPE] = ACTIONS(4225),
    [anon_sym_CARET] = ACTIONS(4225),
    [anon_sym_AMP] = ACTIONS(4225),
    [anon_sym_EQ_EQ] = ACTIONS(4217),
    [anon_sym_BANG_EQ] = ACTIONS(4217),
    [anon_sym_GT] = ACTIONS(4225),
    [anon_sym_GT_EQ] = ACTIONS(4217),
    [anon_sym_LT_EQ] = ACTIONS(4225),
    [anon_sym_LT] = ACTIONS(5785),
    [anon_sym_LT_LT] = ACTIONS(4225),
    [anon_sym_GT_GT] = ACTIONS(4225),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(4217),
    [anon_sym_RBRACK] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(6746),
    [anon_sym_QMARK] = ACTIONS(4217),
    [anon_sym_STAR_EQ] = ACTIONS(6700),
    [anon_sym_SLASH_EQ] = ACTIONS(6700),
    [anon_sym_PERCENT_EQ] = ACTIONS(6700),
    [anon_sym_PLUS_EQ] = ACTIONS(6700),
    [anon_sym_DASH_EQ] = ACTIONS(6700),
    [anon_sym_LT_LT_EQ] = ACTIONS(6700),
    [anon_sym_GT_GT_EQ] = ACTIONS(6700),
    [anon_sym_AMP_EQ] = ACTIONS(6700),
    [anon_sym_CARET_EQ] = ACTIONS(6700),
    [anon_sym_PIPE_EQ] = ACTIONS(6700),
    [anon_sym_and_eq] = ACTIONS(6700),
    [anon_sym_or_eq] = ACTIONS(6700),
    [anon_sym_xor_eq] = ACTIONS(6700),
    [anon_sym_LT_EQ_GT] = ACTIONS(4217),
    [anon_sym_or] = ACTIONS(4225),
    [anon_sym_and] = ACTIONS(4225),
    [anon_sym_bitor] = ACTIONS(4217),
    [anon_sym_xor] = ACTIONS(4225),
    [anon_sym_bitand] = ACTIONS(4217),
    [anon_sym_not_eq] = ACTIONS(4217),
    [anon_sym_DASH_DASH] = ACTIONS(4217),
    [anon_sym_PLUS_PLUS] = ACTIONS(4217),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_DOT_STAR] = ACTIONS(4217),
    [anon_sym_DASH_GT] = ACTIONS(4217),
    [anon_sym_L_DQUOTE] = ACTIONS(4251),
    [anon_sym_u_DQUOTE] = ACTIONS(4251),
    [anon_sym_U_DQUOTE] = ACTIONS(4251),
    [anon_sym_u8_DQUOTE] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(4251),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4253),
    [anon_sym_LR_DQUOTE] = ACTIONS(4253),
    [anon_sym_uR_DQUOTE] = ACTIONS(4253),
    [anon_sym_UR_DQUOTE] = ACTIONS(4253),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4253),
  },
  [2798] = {
    [sym_identifier] = ACTIONS(6133),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6135),
    [anon_sym_COMMA] = ACTIONS(6135),
    [anon_sym_RPAREN] = ACTIONS(6135),
    [aux_sym_preproc_if_token2] = ACTIONS(6135),
    [aux_sym_preproc_else_token1] = ACTIONS(6135),
    [aux_sym_preproc_elif_token1] = ACTIONS(6133),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6135),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6135),
    [anon_sym_LPAREN2] = ACTIONS(6135),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_PERCENT] = ACTIONS(6133),
    [anon_sym_PIPE_PIPE] = ACTIONS(6135),
    [anon_sym_AMP_AMP] = ACTIONS(6135),
    [anon_sym_PIPE] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_AMP] = ACTIONS(6133),
    [anon_sym_EQ_EQ] = ACTIONS(6135),
    [anon_sym_BANG_EQ] = ACTIONS(6135),
    [anon_sym_GT] = ACTIONS(6133),
    [anon_sym_GT_EQ] = ACTIONS(6135),
    [anon_sym_LT_EQ] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6133),
    [anon_sym_LT_LT] = ACTIONS(6133),
    [anon_sym_GT_GT] = ACTIONS(6133),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_SEMI] = ACTIONS(6135),
    [anon_sym___attribute__] = ACTIONS(6133),
    [anon_sym___attribute] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [anon_sym_RBRACE] = ACTIONS(6135),
    [anon_sym_LBRACK] = ACTIONS(6135),
    [anon_sym_RBRACK] = ACTIONS(6135),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_QMARK] = ACTIONS(6135),
    [anon_sym_STAR_EQ] = ACTIONS(6135),
    [anon_sym_SLASH_EQ] = ACTIONS(6135),
    [anon_sym_PERCENT_EQ] = ACTIONS(6135),
    [anon_sym_PLUS_EQ] = ACTIONS(6135),
    [anon_sym_DASH_EQ] = ACTIONS(6135),
    [anon_sym_LT_LT_EQ] = ACTIONS(6135),
    [anon_sym_GT_GT_EQ] = ACTIONS(6135),
    [anon_sym_AMP_EQ] = ACTIONS(6135),
    [anon_sym_CARET_EQ] = ACTIONS(6135),
    [anon_sym_PIPE_EQ] = ACTIONS(6135),
    [anon_sym_and_eq] = ACTIONS(6133),
    [anon_sym_or_eq] = ACTIONS(6133),
    [anon_sym_xor_eq] = ACTIONS(6133),
    [anon_sym_LT_EQ_GT] = ACTIONS(6135),
    [anon_sym_or] = ACTIONS(6133),
    [anon_sym_and] = ACTIONS(6133),
    [anon_sym_bitor] = ACTIONS(6133),
    [anon_sym_xor] = ACTIONS(6133),
    [anon_sym_bitand] = ACTIONS(6133),
    [anon_sym_not_eq] = ACTIONS(6133),
    [anon_sym_DASH_DASH] = ACTIONS(6135),
    [anon_sym_PLUS_PLUS] = ACTIONS(6135),
    [anon_sym_DOT] = ACTIONS(6133),
    [anon_sym_DOT_STAR] = ACTIONS(6135),
    [anon_sym_DASH_GT] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6133),
    [anon_sym_decltype] = ACTIONS(6133),
  },
  [2799] = {
    [sym_template_argument_list] = STATE(2878),
    [sym_identifier] = ACTIONS(1997),
    [anon_sym_LPAREN2] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(5783),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym___extension__] = ACTIONS(1997),
    [anon_sym_in] = ACTIONS(1997),
    [anon_sym_out] = ACTIONS(1997),
    [anon_sym_inout] = ACTIONS(1997),
    [anon_sym_virtual] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1997),
    [anon_sym___attribute__] = ACTIONS(1997),
    [anon_sym___attribute] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4430),
    [anon_sym___declspec] = ACTIONS(1997),
    [anon_sym___based] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4433),
    [anon_sym_static] = ACTIONS(1997),
    [anon_sym_register] = ACTIONS(1997),
    [anon_sym_inline] = ACTIONS(1997),
    [anon_sym___inline] = ACTIONS(1997),
    [anon_sym___inline__] = ACTIONS(1997),
    [anon_sym___forceinline] = ACTIONS(1997),
    [anon_sym_thread_local] = ACTIONS(1997),
    [anon_sym___thread] = ACTIONS(1997),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_constexpr] = ACTIONS(1997),
    [anon_sym_volatile] = ACTIONS(1997),
    [anon_sym_restrict] = ACTIONS(1997),
    [anon_sym___restrict__] = ACTIONS(1997),
    [anon_sym__Atomic] = ACTIONS(1997),
    [anon_sym__Noreturn] = ACTIONS(1997),
    [anon_sym_noreturn] = ACTIONS(1997),
    [anon_sym__Nonnull] = ACTIONS(1997),
    [anon_sym_mutable] = ACTIONS(1997),
    [anon_sym_constinit] = ACTIONS(1997),
    [anon_sym_consteval] = ACTIONS(1997),
    [anon_sym_alignas] = ACTIONS(1997),
    [anon_sym__Alignas] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1997),
    [anon_sym_decltype] = ACTIONS(1997),
    [anon_sym_operator] = ACTIONS(1997),
    [anon_sym_precise] = ACTIONS(1997),
    [anon_sym_shared] = ACTIONS(1997),
    [anon_sym_groupshared] = ACTIONS(1997),
    [anon_sym_uniform] = ACTIONS(1997),
    [anon_sym_row_major] = ACTIONS(1997),
    [anon_sym_column_major] = ACTIONS(1997),
    [anon_sym_globallycoherent] = ACTIONS(1997),
    [anon_sym_centroid] = ACTIONS(1997),
    [anon_sym_noperspective] = ACTIONS(1997),
    [anon_sym_nointerpolation] = ACTIONS(1997),
    [anon_sym_sample] = ACTIONS(1997),
    [anon_sym_linear] = ACTIONS(1997),
    [anon_sym_snorm] = ACTIONS(1997),
    [anon_sym_unorm] = ACTIONS(1997),
    [anon_sym_point] = ACTIONS(1997),
    [anon_sym_line] = ACTIONS(1997),
    [anon_sym_triangleadj] = ACTIONS(1997),
    [anon_sym_lineadj] = ACTIONS(1997),
    [anon_sym_triangle] = ACTIONS(1997),
  },
  [2800] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2760),
    [sym_identifier] = ACTIONS(5896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [aux_sym_preproc_if_token2] = ACTIONS(5898),
    [aux_sym_preproc_else_token1] = ACTIONS(5898),
    [aux_sym_preproc_elif_token1] = ACTIONS(5896),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5898),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5896),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym___attribute__] = ACTIONS(5896),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6884),
    [anon_sym_unsigned] = ACTIONS(6884),
    [anon_sym_long] = ACTIONS(6884),
    [anon_sym_short] = ACTIONS(6884),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5896),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_STAR_EQ] = ACTIONS(5898),
    [anon_sym_SLASH_EQ] = ACTIONS(5898),
    [anon_sym_PERCENT_EQ] = ACTIONS(5898),
    [anon_sym_PLUS_EQ] = ACTIONS(5898),
    [anon_sym_DASH_EQ] = ACTIONS(5898),
    [anon_sym_LT_LT_EQ] = ACTIONS(5898),
    [anon_sym_GT_GT_EQ] = ACTIONS(5898),
    [anon_sym_AMP_EQ] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5898),
    [anon_sym_PIPE_EQ] = ACTIONS(5898),
    [anon_sym_and_eq] = ACTIONS(5896),
    [anon_sym_or_eq] = ACTIONS(5896),
    [anon_sym_xor_eq] = ACTIONS(5896),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5896),
    [anon_sym_and] = ACTIONS(5896),
    [anon_sym_bitor] = ACTIONS(5896),
    [anon_sym_xor] = ACTIONS(5896),
    [anon_sym_bitand] = ACTIONS(5896),
    [anon_sym_not_eq] = ACTIONS(5896),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5896),
    [anon_sym_decltype] = ACTIONS(5896),
  },
  [2801] = {
    [sym_attribute_specifier] = STATE(2560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6197),
    [anon_sym_COMMA] = ACTIONS(6197),
    [anon_sym_RPAREN] = ACTIONS(6197),
    [anon_sym_LPAREN2] = ACTIONS(6197),
    [anon_sym_DASH] = ACTIONS(6195),
    [anon_sym_PLUS] = ACTIONS(6195),
    [anon_sym_STAR] = ACTIONS(6197),
    [anon_sym_SLASH] = ACTIONS(6195),
    [anon_sym_PERCENT] = ACTIONS(6197),
    [anon_sym_PIPE_PIPE] = ACTIONS(6197),
    [anon_sym_AMP_AMP] = ACTIONS(6197),
    [anon_sym_PIPE] = ACTIONS(6195),
    [anon_sym_CARET] = ACTIONS(6197),
    [anon_sym_AMP] = ACTIONS(6195),
    [anon_sym_EQ_EQ] = ACTIONS(6197),
    [anon_sym_BANG_EQ] = ACTIONS(6197),
    [anon_sym_GT] = ACTIONS(6195),
    [anon_sym_GT_EQ] = ACTIONS(6197),
    [anon_sym_LT_EQ] = ACTIONS(6195),
    [anon_sym_LT] = ACTIONS(6195),
    [anon_sym_LT_LT] = ACTIONS(6197),
    [anon_sym_GT_GT] = ACTIONS(6197),
    [anon_sym_COLON] = ACTIONS(6197),
    [anon_sym_SEMI] = ACTIONS(6197),
    [anon_sym___extension__] = ACTIONS(6197),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6197),
    [anon_sym_RBRACE] = ACTIONS(6197),
    [anon_sym_LBRACK] = ACTIONS(6197),
    [anon_sym_RBRACK] = ACTIONS(6197),
    [anon_sym_const] = ACTIONS(6195),
    [anon_sym_constexpr] = ACTIONS(6197),
    [anon_sym_volatile] = ACTIONS(6197),
    [anon_sym_restrict] = ACTIONS(6197),
    [anon_sym___restrict__] = ACTIONS(6197),
    [anon_sym__Atomic] = ACTIONS(6197),
    [anon_sym__Noreturn] = ACTIONS(6197),
    [anon_sym_noreturn] = ACTIONS(6197),
    [anon_sym__Nonnull] = ACTIONS(6197),
    [anon_sym_mutable] = ACTIONS(6197),
    [anon_sym_constinit] = ACTIONS(6197),
    [anon_sym_consteval] = ACTIONS(6197),
    [anon_sym_alignas] = ACTIONS(6197),
    [anon_sym__Alignas] = ACTIONS(6197),
    [anon_sym_QMARK] = ACTIONS(6197),
    [anon_sym_LT_EQ_GT] = ACTIONS(6197),
    [anon_sym_or] = ACTIONS(6197),
    [anon_sym_and] = ACTIONS(6197),
    [anon_sym_bitor] = ACTIONS(6197),
    [anon_sym_xor] = ACTIONS(6197),
    [anon_sym_bitand] = ACTIONS(6197),
    [anon_sym_not_eq] = ACTIONS(6197),
    [anon_sym_DASH_DASH] = ACTIONS(6197),
    [anon_sym_PLUS_PLUS] = ACTIONS(6197),
    [anon_sym_DOT] = ACTIONS(6195),
    [anon_sym_DOT_STAR] = ACTIONS(6197),
    [anon_sym_DASH_GT] = ACTIONS(6197),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6197),
    [anon_sym_decltype] = ACTIONS(6197),
    [anon_sym_final] = ACTIONS(6197),
    [anon_sym_override] = ACTIONS(6197),
    [anon_sym_requires] = ACTIONS(6197),
  },
  [2802] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5859),
    [anon_sym_COMMA] = ACTIONS(5859),
    [anon_sym_RPAREN] = ACTIONS(5859),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_DASH] = ACTIONS(5857),
    [anon_sym_PLUS] = ACTIONS(5857),
    [anon_sym_STAR] = ACTIONS(5857),
    [anon_sym_SLASH] = ACTIONS(5857),
    [anon_sym_PERCENT] = ACTIONS(5857),
    [anon_sym_PIPE_PIPE] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_PIPE] = ACTIONS(5857),
    [anon_sym_CARET] = ACTIONS(5857),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym_EQ_EQ] = ACTIONS(5859),
    [anon_sym_BANG_EQ] = ACTIONS(5859),
    [anon_sym_GT] = ACTIONS(5857),
    [anon_sym_GT_EQ] = ACTIONS(5859),
    [anon_sym_LT_EQ] = ACTIONS(5857),
    [anon_sym_LT] = ACTIONS(5857),
    [anon_sym_LT_LT] = ACTIONS(5857),
    [anon_sym_GT_GT] = ACTIONS(5857),
    [anon_sym_COLON] = ACTIONS(5859),
    [anon_sym_SEMI] = ACTIONS(5859),
    [anon_sym___attribute__] = ACTIONS(5859),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_LBRACE] = ACTIONS(5859),
    [anon_sym_RBRACE] = ACTIONS(5859),
    [anon_sym_signed] = ACTIONS(6886),
    [anon_sym_unsigned] = ACTIONS(6886),
    [anon_sym_long] = ACTIONS(6886),
    [anon_sym_short] = ACTIONS(6886),
    [anon_sym_LBRACK] = ACTIONS(5859),
    [anon_sym_RBRACK] = ACTIONS(5859),
    [anon_sym_EQ] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5859),
    [anon_sym_STAR_EQ] = ACTIONS(5859),
    [anon_sym_SLASH_EQ] = ACTIONS(5859),
    [anon_sym_PERCENT_EQ] = ACTIONS(5859),
    [anon_sym_PLUS_EQ] = ACTIONS(5859),
    [anon_sym_DASH_EQ] = ACTIONS(5859),
    [anon_sym_LT_LT_EQ] = ACTIONS(5859),
    [anon_sym_GT_GT_EQ] = ACTIONS(5859),
    [anon_sym_AMP_EQ] = ACTIONS(5859),
    [anon_sym_CARET_EQ] = ACTIONS(5859),
    [anon_sym_PIPE_EQ] = ACTIONS(5859),
    [anon_sym_and_eq] = ACTIONS(5859),
    [anon_sym_or_eq] = ACTIONS(5859),
    [anon_sym_xor_eq] = ACTIONS(5859),
    [anon_sym_LT_EQ_GT] = ACTIONS(5859),
    [anon_sym_or] = ACTIONS(5857),
    [anon_sym_and] = ACTIONS(5857),
    [anon_sym_bitor] = ACTIONS(5859),
    [anon_sym_xor] = ACTIONS(5857),
    [anon_sym_bitand] = ACTIONS(5859),
    [anon_sym_not_eq] = ACTIONS(5859),
    [anon_sym_DASH_DASH] = ACTIONS(5859),
    [anon_sym_PLUS_PLUS] = ACTIONS(5859),
    [anon_sym_DOT] = ACTIONS(5857),
    [anon_sym_DOT_STAR] = ACTIONS(5859),
    [anon_sym_DASH_GT] = ACTIONS(5859),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5859),
    [anon_sym_decltype] = ACTIONS(5859),
  },
  [2803] = {
    [sym_attribute_specifier] = STATE(2585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6217),
    [anon_sym_COMMA] = ACTIONS(6217),
    [anon_sym_RPAREN] = ACTIONS(6217),
    [anon_sym_LPAREN2] = ACTIONS(6217),
    [anon_sym_DASH] = ACTIONS(6215),
    [anon_sym_PLUS] = ACTIONS(6215),
    [anon_sym_STAR] = ACTIONS(6217),
    [anon_sym_SLASH] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6217),
    [anon_sym_PIPE_PIPE] = ACTIONS(6217),
    [anon_sym_AMP_AMP] = ACTIONS(6217),
    [anon_sym_PIPE] = ACTIONS(6215),
    [anon_sym_CARET] = ACTIONS(6217),
    [anon_sym_AMP] = ACTIONS(6215),
    [anon_sym_EQ_EQ] = ACTIONS(6217),
    [anon_sym_BANG_EQ] = ACTIONS(6217),
    [anon_sym_GT] = ACTIONS(6215),
    [anon_sym_GT_EQ] = ACTIONS(6217),
    [anon_sym_LT_EQ] = ACTIONS(6215),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_LT_LT] = ACTIONS(6217),
    [anon_sym_GT_GT] = ACTIONS(6217),
    [anon_sym_COLON] = ACTIONS(6217),
    [anon_sym_SEMI] = ACTIONS(6217),
    [anon_sym___extension__] = ACTIONS(6217),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6217),
    [anon_sym_RBRACE] = ACTIONS(6217),
    [anon_sym_LBRACK] = ACTIONS(6217),
    [anon_sym_RBRACK] = ACTIONS(6217),
    [anon_sym_const] = ACTIONS(6215),
    [anon_sym_constexpr] = ACTIONS(6217),
    [anon_sym_volatile] = ACTIONS(6217),
    [anon_sym_restrict] = ACTIONS(6217),
    [anon_sym___restrict__] = ACTIONS(6217),
    [anon_sym__Atomic] = ACTIONS(6217),
    [anon_sym__Noreturn] = ACTIONS(6217),
    [anon_sym_noreturn] = ACTIONS(6217),
    [anon_sym__Nonnull] = ACTIONS(6217),
    [anon_sym_mutable] = ACTIONS(6217),
    [anon_sym_constinit] = ACTIONS(6217),
    [anon_sym_consteval] = ACTIONS(6217),
    [anon_sym_alignas] = ACTIONS(6217),
    [anon_sym__Alignas] = ACTIONS(6217),
    [anon_sym_QMARK] = ACTIONS(6217),
    [anon_sym_LT_EQ_GT] = ACTIONS(6217),
    [anon_sym_or] = ACTIONS(6217),
    [anon_sym_and] = ACTIONS(6217),
    [anon_sym_bitor] = ACTIONS(6217),
    [anon_sym_xor] = ACTIONS(6217),
    [anon_sym_bitand] = ACTIONS(6217),
    [anon_sym_not_eq] = ACTIONS(6217),
    [anon_sym_DASH_DASH] = ACTIONS(6217),
    [anon_sym_PLUS_PLUS] = ACTIONS(6217),
    [anon_sym_DOT] = ACTIONS(6215),
    [anon_sym_DOT_STAR] = ACTIONS(6217),
    [anon_sym_DASH_GT] = ACTIONS(6217),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6217),
    [anon_sym_decltype] = ACTIONS(6217),
    [anon_sym_final] = ACTIONS(6217),
    [anon_sym_override] = ACTIONS(6217),
    [anon_sym_requires] = ACTIONS(6217),
  },
  [2804] = {
    [sym_attribute_specifier] = STATE(2768),
    [sym_enumerator_list] = STATE(2682),
    [sym__enum_base_clause] = STATE(2629),
    [sym_identifier] = ACTIONS(6303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6305),
    [anon_sym_COMMA] = ACTIONS(6305),
    [aux_sym_preproc_if_token2] = ACTIONS(6305),
    [aux_sym_preproc_else_token1] = ACTIONS(6305),
    [aux_sym_preproc_elif_token1] = ACTIONS(6303),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6305),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6305),
    [anon_sym_LPAREN2] = ACTIONS(6305),
    [anon_sym_DASH] = ACTIONS(6303),
    [anon_sym_PLUS] = ACTIONS(6303),
    [anon_sym_STAR] = ACTIONS(6303),
    [anon_sym_SLASH] = ACTIONS(6303),
    [anon_sym_PERCENT] = ACTIONS(6303),
    [anon_sym_PIPE_PIPE] = ACTIONS(6305),
    [anon_sym_AMP_AMP] = ACTIONS(6305),
    [anon_sym_PIPE] = ACTIONS(6303),
    [anon_sym_CARET] = ACTIONS(6303),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_EQ_EQ] = ACTIONS(6305),
    [anon_sym_BANG_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6303),
    [anon_sym_GT_EQ] = ACTIONS(6305),
    [anon_sym_LT_EQ] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6303),
    [anon_sym_LT_LT] = ACTIONS(6303),
    [anon_sym_GT_GT] = ACTIONS(6303),
    [anon_sym_COLON] = ACTIONS(6888),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [anon_sym_LBRACK] = ACTIONS(6305),
    [anon_sym_EQ] = ACTIONS(6303),
    [anon_sym_QMARK] = ACTIONS(6305),
    [anon_sym_STAR_EQ] = ACTIONS(6305),
    [anon_sym_SLASH_EQ] = ACTIONS(6305),
    [anon_sym_PERCENT_EQ] = ACTIONS(6305),
    [anon_sym_PLUS_EQ] = ACTIONS(6305),
    [anon_sym_DASH_EQ] = ACTIONS(6305),
    [anon_sym_LT_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT_GT_EQ] = ACTIONS(6305),
    [anon_sym_AMP_EQ] = ACTIONS(6305),
    [anon_sym_CARET_EQ] = ACTIONS(6305),
    [anon_sym_PIPE_EQ] = ACTIONS(6305),
    [anon_sym_and_eq] = ACTIONS(6303),
    [anon_sym_or_eq] = ACTIONS(6303),
    [anon_sym_xor_eq] = ACTIONS(6303),
    [anon_sym_LT_EQ_GT] = ACTIONS(6305),
    [anon_sym_or] = ACTIONS(6303),
    [anon_sym_and] = ACTIONS(6303),
    [anon_sym_bitor] = ACTIONS(6303),
    [anon_sym_xor] = ACTIONS(6303),
    [anon_sym_bitand] = ACTIONS(6303),
    [anon_sym_not_eq] = ACTIONS(6303),
    [anon_sym_DASH_DASH] = ACTIONS(6305),
    [anon_sym_PLUS_PLUS] = ACTIONS(6305),
    [anon_sym_DOT] = ACTIONS(6303),
    [anon_sym_DOT_STAR] = ACTIONS(6305),
    [anon_sym_DASH_GT] = ACTIONS(6305),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6303),
    [anon_sym_decltype] = ACTIONS(6303),
  },
  [2805] = {
    [sym_attribute_specifier] = STATE(2701),
    [sym_enumerator_list] = STATE(2669),
    [sym__enum_base_clause] = STATE(2640),
    [sym_identifier] = ACTIONS(6293),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6295),
    [anon_sym_COMMA] = ACTIONS(6295),
    [aux_sym_preproc_if_token2] = ACTIONS(6295),
    [aux_sym_preproc_else_token1] = ACTIONS(6295),
    [aux_sym_preproc_elif_token1] = ACTIONS(6293),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6295),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6295),
    [anon_sym_LPAREN2] = ACTIONS(6295),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_PLUS] = ACTIONS(6293),
    [anon_sym_STAR] = ACTIONS(6293),
    [anon_sym_SLASH] = ACTIONS(6293),
    [anon_sym_PERCENT] = ACTIONS(6293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6295),
    [anon_sym_AMP_AMP] = ACTIONS(6295),
    [anon_sym_PIPE] = ACTIONS(6293),
    [anon_sym_CARET] = ACTIONS(6293),
    [anon_sym_AMP] = ACTIONS(6293),
    [anon_sym_EQ_EQ] = ACTIONS(6295),
    [anon_sym_BANG_EQ] = ACTIONS(6295),
    [anon_sym_GT] = ACTIONS(6293),
    [anon_sym_GT_EQ] = ACTIONS(6295),
    [anon_sym_LT_EQ] = ACTIONS(6293),
    [anon_sym_LT] = ACTIONS(6293),
    [anon_sym_LT_LT] = ACTIONS(6293),
    [anon_sym_GT_GT] = ACTIONS(6293),
    [anon_sym_COLON] = ACTIONS(6888),
    [anon_sym___attribute__] = ACTIONS(6472),
    [anon_sym___attribute] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [anon_sym_LBRACK] = ACTIONS(6295),
    [anon_sym_EQ] = ACTIONS(6293),
    [anon_sym_QMARK] = ACTIONS(6295),
    [anon_sym_STAR_EQ] = ACTIONS(6295),
    [anon_sym_SLASH_EQ] = ACTIONS(6295),
    [anon_sym_PERCENT_EQ] = ACTIONS(6295),
    [anon_sym_PLUS_EQ] = ACTIONS(6295),
    [anon_sym_DASH_EQ] = ACTIONS(6295),
    [anon_sym_LT_LT_EQ] = ACTIONS(6295),
    [anon_sym_GT_GT_EQ] = ACTIONS(6295),
    [anon_sym_AMP_EQ] = ACTIONS(6295),
    [anon_sym_CARET_EQ] = ACTIONS(6295),
    [anon_sym_PIPE_EQ] = ACTIONS(6295),
    [anon_sym_and_eq] = ACTIONS(6293),
    [anon_sym_or_eq] = ACTIONS(6293),
    [anon_sym_xor_eq] = ACTIONS(6293),
    [anon_sym_LT_EQ_GT] = ACTIONS(6295),
    [anon_sym_or] = ACTIONS(6293),
    [anon_sym_and] = ACTIONS(6293),
    [anon_sym_bitor] = ACTIONS(6293),
    [anon_sym_xor] = ACTIONS(6293),
    [anon_sym_bitand] = ACTIONS(6293),
    [anon_sym_not_eq] = ACTIONS(6293),
    [anon_sym_DASH_DASH] = ACTIONS(6295),
    [anon_sym_PLUS_PLUS] = ACTIONS(6295),
    [anon_sym_DOT] = ACTIONS(6293),
    [anon_sym_DOT_STAR] = ACTIONS(6295),
    [anon_sym_DASH_GT] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6293),
    [anon_sym_decltype] = ACTIONS(6293),
  },
  [2806] = {
    [sym_identifier] = ACTIONS(6392),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6394),
    [anon_sym_COMMA] = ACTIONS(6394),
    [anon_sym_LPAREN2] = ACTIONS(6394),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_PERCENT] = ACTIONS(6392),
    [anon_sym_PIPE_PIPE] = ACTIONS(6394),
    [anon_sym_AMP_AMP] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_EQ_EQ] = ACTIONS(6394),
    [anon_sym_BANG_EQ] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6392),
    [anon_sym_GT_EQ] = ACTIONS(6394),
    [anon_sym_LT_EQ] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6392),
    [anon_sym_LT_LT] = ACTIONS(6392),
    [anon_sym_GT_GT] = ACTIONS(6392),
    [anon_sym_SEMI] = ACTIONS(6394),
    [anon_sym___attribute__] = ACTIONS(6392),
    [anon_sym___attribute] = ACTIONS(6392),
    [anon_sym_LBRACK] = ACTIONS(6394),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_QMARK] = ACTIONS(6394),
    [anon_sym_STAR_EQ] = ACTIONS(6394),
    [anon_sym_SLASH_EQ] = ACTIONS(6394),
    [anon_sym_PERCENT_EQ] = ACTIONS(6394),
    [anon_sym_PLUS_EQ] = ACTIONS(6394),
    [anon_sym_DASH_EQ] = ACTIONS(6394),
    [anon_sym_LT_LT_EQ] = ACTIONS(6394),
    [anon_sym_GT_GT_EQ] = ACTIONS(6394),
    [anon_sym_AMP_EQ] = ACTIONS(6394),
    [anon_sym_CARET_EQ] = ACTIONS(6394),
    [anon_sym_PIPE_EQ] = ACTIONS(6394),
    [anon_sym_and_eq] = ACTIONS(6392),
    [anon_sym_or_eq] = ACTIONS(6392),
    [anon_sym_xor_eq] = ACTIONS(6392),
    [anon_sym_LT_EQ_GT] = ACTIONS(6394),
    [anon_sym_or] = ACTIONS(6392),
    [anon_sym_and] = ACTIONS(6392),
    [anon_sym_bitor] = ACTIONS(6392),
    [anon_sym_xor] = ACTIONS(6392),
    [anon_sym_bitand] = ACTIONS(6392),
    [anon_sym_not_eq] = ACTIONS(6392),
    [anon_sym_DASH_DASH] = ACTIONS(6394),
    [anon_sym_PLUS_PLUS] = ACTIONS(6394),
    [anon_sym_DOT] = ACTIONS(6392),
    [anon_sym_DOT_STAR] = ACTIONS(6394),
    [anon_sym_DASH_GT] = ACTIONS(6394),
    [anon_sym_L_DQUOTE] = ACTIONS(6394),
    [anon_sym_u_DQUOTE] = ACTIONS(6394),
    [anon_sym_U_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8_DQUOTE] = ACTIONS(6394),
    [anon_sym_DQUOTE] = ACTIONS(6394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6394),
    [anon_sym_LR_DQUOTE] = ACTIONS(6394),
    [anon_sym_uR_DQUOTE] = ACTIONS(6394),
    [anon_sym_UR_DQUOTE] = ACTIONS(6394),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6394),
    [sym_literal_suffix] = ACTIONS(6392),
  },
  [2807] = {
    [sym_identifier] = ACTIONS(6408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6410),
    [anon_sym_COMMA] = ACTIONS(6410),
    [anon_sym_LPAREN2] = ACTIONS(6410),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_PERCENT] = ACTIONS(6408),
    [anon_sym_PIPE_PIPE] = ACTIONS(6410),
    [anon_sym_AMP_AMP] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_AMP] = ACTIONS(6408),
    [anon_sym_EQ_EQ] = ACTIONS(6410),
    [anon_sym_BANG_EQ] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6408),
    [anon_sym_GT_EQ] = ACTIONS(6410),
    [anon_sym_LT_EQ] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6408),
    [anon_sym_LT_LT] = ACTIONS(6408),
    [anon_sym_GT_GT] = ACTIONS(6408),
    [anon_sym_SEMI] = ACTIONS(6410),
    [anon_sym___attribute__] = ACTIONS(6408),
    [anon_sym___attribute] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_QMARK] = ACTIONS(6410),
    [anon_sym_STAR_EQ] = ACTIONS(6410),
    [anon_sym_SLASH_EQ] = ACTIONS(6410),
    [anon_sym_PERCENT_EQ] = ACTIONS(6410),
    [anon_sym_PLUS_EQ] = ACTIONS(6410),
    [anon_sym_DASH_EQ] = ACTIONS(6410),
    [anon_sym_LT_LT_EQ] = ACTIONS(6410),
    [anon_sym_GT_GT_EQ] = ACTIONS(6410),
    [anon_sym_AMP_EQ] = ACTIONS(6410),
    [anon_sym_CARET_EQ] = ACTIONS(6410),
    [anon_sym_PIPE_EQ] = ACTIONS(6410),
    [anon_sym_and_eq] = ACTIONS(6408),
    [anon_sym_or_eq] = ACTIONS(6408),
    [anon_sym_xor_eq] = ACTIONS(6408),
    [anon_sym_LT_EQ_GT] = ACTIONS(6410),
    [anon_sym_or] = ACTIONS(6408),
    [anon_sym_and] = ACTIONS(6408),
    [anon_sym_bitor] = ACTIONS(6408),
    [anon_sym_xor] = ACTIONS(6408),
    [anon_sym_bitand] = ACTIONS(6408),
    [anon_sym_not_eq] = ACTIONS(6408),
    [anon_sym_DASH_DASH] = ACTIONS(6410),
    [anon_sym_PLUS_PLUS] = ACTIONS(6410),
    [anon_sym_DOT] = ACTIONS(6408),
    [anon_sym_DOT_STAR] = ACTIONS(6410),
    [anon_sym_DASH_GT] = ACTIONS(6410),
    [anon_sym_L_DQUOTE] = ACTIONS(6410),
    [anon_sym_u_DQUOTE] = ACTIONS(6410),
    [anon_sym_U_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8_DQUOTE] = ACTIONS(6410),
    [anon_sym_DQUOTE] = ACTIONS(6410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6410),
    [anon_sym_LR_DQUOTE] = ACTIONS(6410),
    [anon_sym_uR_DQUOTE] = ACTIONS(6410),
    [anon_sym_UR_DQUOTE] = ACTIONS(6410),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6410),
    [sym_literal_suffix] = ACTIONS(6408),
  },
  [2808] = {
    [sym_attribute_specifier] = STATE(2587),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6237),
    [anon_sym_COMMA] = ACTIONS(6237),
    [anon_sym_RPAREN] = ACTIONS(6237),
    [anon_sym_LPAREN2] = ACTIONS(6237),
    [anon_sym_DASH] = ACTIONS(6235),
    [anon_sym_PLUS] = ACTIONS(6235),
    [anon_sym_STAR] = ACTIONS(6237),
    [anon_sym_SLASH] = ACTIONS(6235),
    [anon_sym_PERCENT] = ACTIONS(6237),
    [anon_sym_PIPE_PIPE] = ACTIONS(6237),
    [anon_sym_AMP_AMP] = ACTIONS(6237),
    [anon_sym_PIPE] = ACTIONS(6235),
    [anon_sym_CARET] = ACTIONS(6237),
    [anon_sym_AMP] = ACTIONS(6235),
    [anon_sym_EQ_EQ] = ACTIONS(6237),
    [anon_sym_BANG_EQ] = ACTIONS(6237),
    [anon_sym_GT] = ACTIONS(6235),
    [anon_sym_GT_EQ] = ACTIONS(6237),
    [anon_sym_LT_EQ] = ACTIONS(6235),
    [anon_sym_LT] = ACTIONS(6235),
    [anon_sym_LT_LT] = ACTIONS(6237),
    [anon_sym_GT_GT] = ACTIONS(6237),
    [anon_sym_COLON] = ACTIONS(6237),
    [anon_sym_SEMI] = ACTIONS(6237),
    [anon_sym___extension__] = ACTIONS(6237),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6237),
    [anon_sym_RBRACE] = ACTIONS(6237),
    [anon_sym_LBRACK] = ACTIONS(6237),
    [anon_sym_RBRACK] = ACTIONS(6237),
    [anon_sym_const] = ACTIONS(6235),
    [anon_sym_constexpr] = ACTIONS(6237),
    [anon_sym_volatile] = ACTIONS(6237),
    [anon_sym_restrict] = ACTIONS(6237),
    [anon_sym___restrict__] = ACTIONS(6237),
    [anon_sym__Atomic] = ACTIONS(6237),
    [anon_sym__Noreturn] = ACTIONS(6237),
    [anon_sym_noreturn] = ACTIONS(6237),
    [anon_sym__Nonnull] = ACTIONS(6237),
    [anon_sym_mutable] = ACTIONS(6237),
    [anon_sym_constinit] = ACTIONS(6237),
    [anon_sym_consteval] = ACTIONS(6237),
    [anon_sym_alignas] = ACTIONS(6237),
    [anon_sym__Alignas] = ACTIONS(6237),
    [anon_sym_QMARK] = ACTIONS(6237),
    [anon_sym_LT_EQ_GT] = ACTIONS(6237),
    [anon_sym_or] = ACTIONS(6237),
    [anon_sym_and] = ACTIONS(6237),
    [anon_sym_bitor] = ACTIONS(6237),
    [anon_sym_xor] = ACTIONS(6237),
    [anon_sym_bitand] = ACTIONS(6237),
    [anon_sym_not_eq] = ACTIONS(6237),
    [anon_sym_DASH_DASH] = ACTIONS(6237),
    [anon_sym_PLUS_PLUS] = ACTIONS(6237),
    [anon_sym_DOT] = ACTIONS(6235),
    [anon_sym_DOT_STAR] = ACTIONS(6237),
    [anon_sym_DASH_GT] = ACTIONS(6237),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6237),
    [anon_sym_decltype] = ACTIONS(6237),
    [anon_sym_final] = ACTIONS(6237),
    [anon_sym_override] = ACTIONS(6237),
    [anon_sym_requires] = ACTIONS(6237),
  },
  [2809] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5892),
    [anon_sym_COMMA] = ACTIONS(5892),
    [anon_sym_RPAREN] = ACTIONS(5892),
    [anon_sym_LPAREN2] = ACTIONS(5892),
    [anon_sym_DASH] = ACTIONS(5890),
    [anon_sym_PLUS] = ACTIONS(5890),
    [anon_sym_STAR] = ACTIONS(5890),
    [anon_sym_SLASH] = ACTIONS(5890),
    [anon_sym_PERCENT] = ACTIONS(5890),
    [anon_sym_PIPE_PIPE] = ACTIONS(5892),
    [anon_sym_AMP_AMP] = ACTIONS(5892),
    [anon_sym_PIPE] = ACTIONS(5890),
    [anon_sym_CARET] = ACTIONS(5890),
    [anon_sym_AMP] = ACTIONS(5890),
    [anon_sym_EQ_EQ] = ACTIONS(5892),
    [anon_sym_BANG_EQ] = ACTIONS(5892),
    [anon_sym_GT] = ACTIONS(5890),
    [anon_sym_GT_EQ] = ACTIONS(5892),
    [anon_sym_LT_EQ] = ACTIONS(5890),
    [anon_sym_LT] = ACTIONS(5890),
    [anon_sym_LT_LT] = ACTIONS(5890),
    [anon_sym_GT_GT] = ACTIONS(5890),
    [anon_sym_COLON] = ACTIONS(5892),
    [anon_sym_SEMI] = ACTIONS(5892),
    [anon_sym___attribute__] = ACTIONS(5892),
    [anon_sym___attribute] = ACTIONS(5890),
    [anon_sym_LBRACE] = ACTIONS(5892),
    [anon_sym_RBRACE] = ACTIONS(5892),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5892),
    [anon_sym_RBRACK] = ACTIONS(5892),
    [anon_sym_EQ] = ACTIONS(5890),
    [anon_sym_QMARK] = ACTIONS(5892),
    [anon_sym_STAR_EQ] = ACTIONS(5892),
    [anon_sym_SLASH_EQ] = ACTIONS(5892),
    [anon_sym_PERCENT_EQ] = ACTIONS(5892),
    [anon_sym_PLUS_EQ] = ACTIONS(5892),
    [anon_sym_DASH_EQ] = ACTIONS(5892),
    [anon_sym_LT_LT_EQ] = ACTIONS(5892),
    [anon_sym_GT_GT_EQ] = ACTIONS(5892),
    [anon_sym_AMP_EQ] = ACTIONS(5892),
    [anon_sym_CARET_EQ] = ACTIONS(5892),
    [anon_sym_PIPE_EQ] = ACTIONS(5892),
    [anon_sym_and_eq] = ACTIONS(5892),
    [anon_sym_or_eq] = ACTIONS(5892),
    [anon_sym_xor_eq] = ACTIONS(5892),
    [anon_sym_LT_EQ_GT] = ACTIONS(5892),
    [anon_sym_or] = ACTIONS(5890),
    [anon_sym_and] = ACTIONS(5890),
    [anon_sym_bitor] = ACTIONS(5892),
    [anon_sym_xor] = ACTIONS(5890),
    [anon_sym_bitand] = ACTIONS(5892),
    [anon_sym_not_eq] = ACTIONS(5892),
    [anon_sym_DASH_DASH] = ACTIONS(5892),
    [anon_sym_PLUS_PLUS] = ACTIONS(5892),
    [anon_sym_DOT] = ACTIONS(5890),
    [anon_sym_DOT_STAR] = ACTIONS(5892),
    [anon_sym_DASH_GT] = ACTIONS(5892),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5892),
    [anon_sym_decltype] = ACTIONS(5892),
  },
  [2810] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(2815),
    [sym__declarator] = STATE(6609),
    [sym__abstract_declarator] = STATE(6915),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3230),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3376),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6030),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3230),
    [aux_sym_pointer_declarator_repeat1] = STATE(2815),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_RPAREN] = ACTIONS(6482),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym_COLON_COLON] = ACTIONS(6892),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2811] = {
    [sym_attribute_specifier] = STATE(3034),
    [sym_field_declaration_list] = STATE(2976),
    [sym_virtual_specifier] = STATE(7182),
    [sym_base_class_clause] = STATE(8166),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5868),
    [anon_sym_COMMA] = ACTIONS(5868),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5866),
    [anon_sym_PLUS] = ACTIONS(5866),
    [anon_sym_STAR] = ACTIONS(5868),
    [anon_sym_SLASH] = ACTIONS(5866),
    [anon_sym_PERCENT] = ACTIONS(5868),
    [anon_sym_PIPE_PIPE] = ACTIONS(5868),
    [anon_sym_AMP_AMP] = ACTIONS(5868),
    [anon_sym_PIPE] = ACTIONS(5866),
    [anon_sym_CARET] = ACTIONS(5868),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym_EQ_EQ] = ACTIONS(5868),
    [anon_sym_BANG_EQ] = ACTIONS(5868),
    [anon_sym_GT] = ACTIONS(5866),
    [anon_sym_GT_EQ] = ACTIONS(5866),
    [anon_sym_LT_EQ] = ACTIONS(5866),
    [anon_sym_LT] = ACTIONS(5866),
    [anon_sym_LT_LT] = ACTIONS(5868),
    [anon_sym_GT_GT] = ACTIONS(5866),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym___extension__] = ACTIONS(5868),
    [anon_sym___attribute__] = ACTIONS(6894),
    [anon_sym___attribute] = ACTIONS(6896),
    [anon_sym_LBRACE] = ACTIONS(6898),
    [anon_sym_LBRACK] = ACTIONS(5868),
    [anon_sym_const] = ACTIONS(5866),
    [anon_sym_constexpr] = ACTIONS(5868),
    [anon_sym_volatile] = ACTIONS(5868),
    [anon_sym_restrict] = ACTIONS(5868),
    [anon_sym___restrict__] = ACTIONS(5868),
    [anon_sym__Atomic] = ACTIONS(5868),
    [anon_sym__Noreturn] = ACTIONS(5868),
    [anon_sym_noreturn] = ACTIONS(5868),
    [anon_sym__Nonnull] = ACTIONS(5868),
    [anon_sym_mutable] = ACTIONS(5868),
    [anon_sym_constinit] = ACTIONS(5868),
    [anon_sym_consteval] = ACTIONS(5868),
    [anon_sym_alignas] = ACTIONS(5868),
    [anon_sym__Alignas] = ACTIONS(5868),
    [anon_sym_QMARK] = ACTIONS(5868),
    [anon_sym_LT_EQ_GT] = ACTIONS(5868),
    [anon_sym_or] = ACTIONS(5868),
    [anon_sym_and] = ACTIONS(5868),
    [anon_sym_bitor] = ACTIONS(5868),
    [anon_sym_xor] = ACTIONS(5868),
    [anon_sym_bitand] = ACTIONS(5868),
    [anon_sym_not_eq] = ACTIONS(5868),
    [anon_sym_DASH_DASH] = ACTIONS(5868),
    [anon_sym_PLUS_PLUS] = ACTIONS(5868),
    [anon_sym_DOT] = ACTIONS(5866),
    [anon_sym_DOT_STAR] = ACTIONS(5868),
    [anon_sym_DASH_GT] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5868),
    [anon_sym_decltype] = ACTIONS(5868),
    [anon_sym_final] = ACTIONS(6638),
    [anon_sym_override] = ACTIONS(6638),
    [anon_sym_GT2] = ACTIONS(5868),
    [anon_sym_requires] = ACTIONS(5868),
  },
  [2812] = {
    [sym_identifier] = ACTIONS(5857),
    [anon_sym_LPAREN2] = ACTIONS(5859),
    [anon_sym_TILDE] = ACTIONS(5859),
    [anon_sym_STAR] = ACTIONS(5859),
    [anon_sym_AMP_AMP] = ACTIONS(5859),
    [anon_sym_AMP] = ACTIONS(5857),
    [anon_sym___extension__] = ACTIONS(5857),
    [anon_sym_in] = ACTIONS(5857),
    [anon_sym_out] = ACTIONS(5857),
    [anon_sym_inout] = ACTIONS(5857),
    [anon_sym_virtual] = ACTIONS(5857),
    [anon_sym_extern] = ACTIONS(5857),
    [anon_sym___attribute__] = ACTIONS(5857),
    [anon_sym___attribute] = ACTIONS(5857),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5859),
    [anon_sym___declspec] = ACTIONS(5857),
    [anon_sym___based] = ACTIONS(5857),
    [anon_sym_LBRACK] = ACTIONS(5857),
    [anon_sym_static] = ACTIONS(5857),
    [anon_sym_register] = ACTIONS(5857),
    [anon_sym_inline] = ACTIONS(5857),
    [anon_sym___inline] = ACTIONS(5857),
    [anon_sym___inline__] = ACTIONS(5857),
    [anon_sym___forceinline] = ACTIONS(5857),
    [anon_sym_thread_local] = ACTIONS(5857),
    [anon_sym___thread] = ACTIONS(5857),
    [anon_sym_const] = ACTIONS(5857),
    [anon_sym_constexpr] = ACTIONS(5857),
    [anon_sym_volatile] = ACTIONS(5857),
    [anon_sym_restrict] = ACTIONS(5857),
    [anon_sym___restrict__] = ACTIONS(5857),
    [anon_sym__Atomic] = ACTIONS(5857),
    [anon_sym__Noreturn] = ACTIONS(5857),
    [anon_sym_noreturn] = ACTIONS(5857),
    [anon_sym__Nonnull] = ACTIONS(5857),
    [anon_sym_mutable] = ACTIONS(5857),
    [anon_sym_constinit] = ACTIONS(5857),
    [anon_sym_consteval] = ACTIONS(5857),
    [anon_sym_alignas] = ACTIONS(5857),
    [anon_sym__Alignas] = ACTIONS(5857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5857),
    [anon_sym_decltype] = ACTIONS(5857),
    [anon_sym_template] = ACTIONS(5857),
    [anon_sym_operator] = ACTIONS(5857),
    [anon_sym_precise] = ACTIONS(5857),
    [anon_sym_shared] = ACTIONS(5857),
    [anon_sym_groupshared] = ACTIONS(5857),
    [anon_sym_uniform] = ACTIONS(5857),
    [anon_sym_row_major] = ACTIONS(5857),
    [anon_sym_column_major] = ACTIONS(5857),
    [anon_sym_globallycoherent] = ACTIONS(5857),
    [anon_sym_centroid] = ACTIONS(5857),
    [anon_sym_noperspective] = ACTIONS(5857),
    [anon_sym_nointerpolation] = ACTIONS(5857),
    [anon_sym_sample] = ACTIONS(5857),
    [anon_sym_linear] = ACTIONS(5857),
    [anon_sym_snorm] = ACTIONS(5857),
    [anon_sym_unorm] = ACTIONS(5857),
    [anon_sym_point] = ACTIONS(5857),
    [anon_sym_line] = ACTIONS(5857),
    [anon_sym_triangleadj] = ACTIONS(5857),
    [anon_sym_lineadj] = ACTIONS(5857),
    [anon_sym_triangle] = ACTIONS(5857),
  },
  [2813] = {
    [sym_template_argument_list] = STATE(2839),
    [sym_identifier] = ACTIONS(6900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6902),
    [anon_sym_COMMA] = ACTIONS(6902),
    [anon_sym_RPAREN] = ACTIONS(6902),
    [aux_sym_preproc_if_token2] = ACTIONS(6902),
    [aux_sym_preproc_else_token1] = ACTIONS(6902),
    [aux_sym_preproc_elif_token1] = ACTIONS(6900),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6902),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6902),
    [anon_sym_LPAREN2] = ACTIONS(6902),
    [anon_sym_DASH] = ACTIONS(6900),
    [anon_sym_PLUS] = ACTIONS(6900),
    [anon_sym_STAR] = ACTIONS(6900),
    [anon_sym_SLASH] = ACTIONS(6900),
    [anon_sym_PERCENT] = ACTIONS(6900),
    [anon_sym_PIPE_PIPE] = ACTIONS(6902),
    [anon_sym_AMP_AMP] = ACTIONS(6902),
    [anon_sym_PIPE] = ACTIONS(6900),
    [anon_sym_CARET] = ACTIONS(6900),
    [anon_sym_AMP] = ACTIONS(6900),
    [anon_sym_EQ_EQ] = ACTIONS(6902),
    [anon_sym_BANG_EQ] = ACTIONS(6902),
    [anon_sym_GT] = ACTIONS(6900),
    [anon_sym_GT_EQ] = ACTIONS(6902),
    [anon_sym_LT_EQ] = ACTIONS(6900),
    [anon_sym_LT] = ACTIONS(6904),
    [anon_sym_LT_LT] = ACTIONS(6900),
    [anon_sym_GT_GT] = ACTIONS(6900),
    [anon_sym_COLON] = ACTIONS(6900),
    [anon_sym_SEMI] = ACTIONS(6902),
    [anon_sym___attribute__] = ACTIONS(6900),
    [anon_sym___attribute] = ACTIONS(6900),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_RBRACE] = ACTIONS(6902),
    [anon_sym_LBRACK] = ACTIONS(6902),
    [anon_sym_RBRACK] = ACTIONS(6902),
    [anon_sym_EQ] = ACTIONS(6900),
    [anon_sym_QMARK] = ACTIONS(6902),
    [anon_sym_STAR_EQ] = ACTIONS(6902),
    [anon_sym_SLASH_EQ] = ACTIONS(6902),
    [anon_sym_PERCENT_EQ] = ACTIONS(6902),
    [anon_sym_PLUS_EQ] = ACTIONS(6902),
    [anon_sym_DASH_EQ] = ACTIONS(6902),
    [anon_sym_LT_LT_EQ] = ACTIONS(6902),
    [anon_sym_GT_GT_EQ] = ACTIONS(6902),
    [anon_sym_AMP_EQ] = ACTIONS(6902),
    [anon_sym_CARET_EQ] = ACTIONS(6902),
    [anon_sym_PIPE_EQ] = ACTIONS(6902),
    [anon_sym_and_eq] = ACTIONS(6900),
    [anon_sym_or_eq] = ACTIONS(6900),
    [anon_sym_xor_eq] = ACTIONS(6900),
    [anon_sym_LT_EQ_GT] = ACTIONS(6902),
    [anon_sym_or] = ACTIONS(6900),
    [anon_sym_and] = ACTIONS(6900),
    [anon_sym_bitor] = ACTIONS(6900),
    [anon_sym_xor] = ACTIONS(6900),
    [anon_sym_bitand] = ACTIONS(6900),
    [anon_sym_not_eq] = ACTIONS(6900),
    [anon_sym_DASH_DASH] = ACTIONS(6902),
    [anon_sym_PLUS_PLUS] = ACTIONS(6902),
    [anon_sym_DOT] = ACTIONS(6900),
    [anon_sym_DOT_STAR] = ACTIONS(6902),
    [anon_sym_DASH_GT] = ACTIONS(6902),
    [sym_comment] = ACTIONS(3),
  },
  [2814] = {
    [sym_attribute_specifier] = STATE(2547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6229),
    [anon_sym_COMMA] = ACTIONS(6229),
    [anon_sym_RPAREN] = ACTIONS(6229),
    [anon_sym_LPAREN2] = ACTIONS(6229),
    [anon_sym_DASH] = ACTIONS(6227),
    [anon_sym_PLUS] = ACTIONS(6227),
    [anon_sym_STAR] = ACTIONS(6229),
    [anon_sym_SLASH] = ACTIONS(6227),
    [anon_sym_PERCENT] = ACTIONS(6229),
    [anon_sym_PIPE_PIPE] = ACTIONS(6229),
    [anon_sym_AMP_AMP] = ACTIONS(6229),
    [anon_sym_PIPE] = ACTIONS(6227),
    [anon_sym_CARET] = ACTIONS(6229),
    [anon_sym_AMP] = ACTIONS(6227),
    [anon_sym_EQ_EQ] = ACTIONS(6229),
    [anon_sym_BANG_EQ] = ACTIONS(6229),
    [anon_sym_GT] = ACTIONS(6227),
    [anon_sym_GT_EQ] = ACTIONS(6229),
    [anon_sym_LT_EQ] = ACTIONS(6227),
    [anon_sym_LT] = ACTIONS(6227),
    [anon_sym_LT_LT] = ACTIONS(6229),
    [anon_sym_GT_GT] = ACTIONS(6229),
    [anon_sym_COLON] = ACTIONS(6229),
    [anon_sym_SEMI] = ACTIONS(6229),
    [anon_sym___extension__] = ACTIONS(6229),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6229),
    [anon_sym_RBRACE] = ACTIONS(6229),
    [anon_sym_LBRACK] = ACTIONS(6229),
    [anon_sym_RBRACK] = ACTIONS(6229),
    [anon_sym_const] = ACTIONS(6227),
    [anon_sym_constexpr] = ACTIONS(6229),
    [anon_sym_volatile] = ACTIONS(6229),
    [anon_sym_restrict] = ACTIONS(6229),
    [anon_sym___restrict__] = ACTIONS(6229),
    [anon_sym__Atomic] = ACTIONS(6229),
    [anon_sym__Noreturn] = ACTIONS(6229),
    [anon_sym_noreturn] = ACTIONS(6229),
    [anon_sym__Nonnull] = ACTIONS(6229),
    [anon_sym_mutable] = ACTIONS(6229),
    [anon_sym_constinit] = ACTIONS(6229),
    [anon_sym_consteval] = ACTIONS(6229),
    [anon_sym_alignas] = ACTIONS(6229),
    [anon_sym__Alignas] = ACTIONS(6229),
    [anon_sym_QMARK] = ACTIONS(6229),
    [anon_sym_LT_EQ_GT] = ACTIONS(6229),
    [anon_sym_or] = ACTIONS(6229),
    [anon_sym_and] = ACTIONS(6229),
    [anon_sym_bitor] = ACTIONS(6229),
    [anon_sym_xor] = ACTIONS(6229),
    [anon_sym_bitand] = ACTIONS(6229),
    [anon_sym_not_eq] = ACTIONS(6229),
    [anon_sym_DASH_DASH] = ACTIONS(6229),
    [anon_sym_PLUS_PLUS] = ACTIONS(6229),
    [anon_sym_DOT] = ACTIONS(6227),
    [anon_sym_DOT_STAR] = ACTIONS(6229),
    [anon_sym_DASH_GT] = ACTIONS(6229),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6229),
    [anon_sym_decltype] = ACTIONS(6229),
    [anon_sym_final] = ACTIONS(6229),
    [anon_sym_override] = ACTIONS(6229),
    [anon_sym_requires] = ACTIONS(6229),
  },
  [2815] = {
    [sym_ms_based_modifier] = STATE(9120),
    [sym_ms_unaligned_ptr_modifier] = STATE(4244),
    [sym_ms_pointer_modifier] = STATE(4029),
    [sym__declarator] = STATE(6689),
    [sym__abstract_declarator] = STATE(6853),
    [sym_parenthesized_declarator] = STATE(6529),
    [sym_abstract_parenthesized_declarator] = STATE(6166),
    [sym_attributed_declarator] = STATE(6529),
    [sym_pointer_declarator] = STATE(6529),
    [sym_abstract_pointer_declarator] = STATE(6166),
    [sym_function_declarator] = STATE(6529),
    [sym_abstract_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(6529),
    [sym_abstract_array_declarator] = STATE(6166),
    [sym_type_qualifier] = STATE(3235),
    [sym_alignas_qualifier] = STATE(4478),
    [sym_parameter_list] = STATE(3376),
    [sym_decltype] = STATE(8681),
    [sym_reference_declarator] = STATE(6529),
    [sym_abstract_reference_declarator] = STATE(6166),
    [sym_structured_binding_declarator] = STATE(6529),
    [sym__function_declarator_seq] = STATE(6174),
    [sym_template_type] = STATE(8681),
    [sym_template_function] = STATE(6529),
    [sym_destructor_name] = STATE(6529),
    [sym_dependent_type_identifier] = STATE(8681),
    [sym__scope_resolution] = STATE(6030),
    [sym_qualified_identifier] = STATE(6529),
    [sym_operator_name] = STATE(6529),
    [aux_sym__type_definition_type_repeat1] = STATE(3235),
    [aux_sym_pointer_declarator_repeat1] = STATE(4029),
    [sym_identifier] = ACTIONS(5513),
    [anon_sym_RPAREN] = ACTIONS(6536),
    [anon_sym_LPAREN2] = ACTIONS(4279),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(4281),
    [anon_sym_AMP_AMP] = ACTIONS(4283),
    [anon_sym_AMP] = ACTIONS(4285),
    [anon_sym___extension__] = ACTIONS(4209),
    [anon_sym_COLON_COLON] = ACTIONS(6892),
    [anon_sym___based] = ACTIONS(53),
    [sym_ms_restrict_modifier] = ACTIONS(4205),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(4205),
    [sym_ms_signed_ptr_modifier] = ACTIONS(4205),
    [anon_sym__unaligned] = ACTIONS(4207),
    [anon_sym___unaligned] = ACTIONS(4207),
    [anon_sym_LBRACK] = ACTIONS(6494),
    [anon_sym_const] = ACTIONS(4209),
    [anon_sym_constexpr] = ACTIONS(4209),
    [anon_sym_volatile] = ACTIONS(4209),
    [anon_sym_restrict] = ACTIONS(4209),
    [anon_sym___restrict__] = ACTIONS(4209),
    [anon_sym__Atomic] = ACTIONS(4209),
    [anon_sym__Noreturn] = ACTIONS(4209),
    [anon_sym_noreturn] = ACTIONS(4209),
    [anon_sym__Nonnull] = ACTIONS(4209),
    [anon_sym_mutable] = ACTIONS(4209),
    [anon_sym_constinit] = ACTIONS(4209),
    [anon_sym_consteval] = ACTIONS(4209),
    [anon_sym_alignas] = ACTIONS(4211),
    [anon_sym__Alignas] = ACTIONS(4211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3566),
    [anon_sym_template] = ACTIONS(1310),
    [anon_sym_operator] = ACTIONS(2104),
  },
  [2816] = {
    [sym_identifier] = ACTIONS(6907),
    [anon_sym_LPAREN2] = ACTIONS(6909),
    [anon_sym_TILDE] = ACTIONS(6911),
    [anon_sym_STAR] = ACTIONS(6911),
    [anon_sym_AMP_AMP] = ACTIONS(6911),
    [anon_sym_AMP] = ACTIONS(6907),
    [anon_sym___extension__] = ACTIONS(6907),
    [anon_sym_in] = ACTIONS(6907),
    [anon_sym_out] = ACTIONS(6907),
    [anon_sym_inout] = ACTIONS(6907),
    [anon_sym_virtual] = ACTIONS(6907),
    [anon_sym_extern] = ACTIONS(6907),
    [anon_sym___attribute__] = ACTIONS(6907),
    [anon_sym___attribute] = ACTIONS(6907),
    [anon_sym_COLON_COLON] = ACTIONS(6911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6911),
    [anon_sym___declspec] = ACTIONS(6907),
    [anon_sym___based] = ACTIONS(6907),
    [anon_sym_LBRACK] = ACTIONS(6907),
    [anon_sym_static] = ACTIONS(6907),
    [anon_sym_register] = ACTIONS(6907),
    [anon_sym_inline] = ACTIONS(6907),
    [anon_sym___inline] = ACTIONS(6907),
    [anon_sym___inline__] = ACTIONS(6907),
    [anon_sym___forceinline] = ACTIONS(6907),
    [anon_sym_thread_local] = ACTIONS(6907),
    [anon_sym___thread] = ACTIONS(6907),
    [anon_sym_const] = ACTIONS(6907),
    [anon_sym_constexpr] = ACTIONS(6907),
    [anon_sym_volatile] = ACTIONS(6907),
    [anon_sym_restrict] = ACTIONS(6907),
    [anon_sym___restrict__] = ACTIONS(6907),
    [anon_sym__Atomic] = ACTIONS(6907),
    [anon_sym__Noreturn] = ACTIONS(6907),
    [anon_sym_noreturn] = ACTIONS(6907),
    [anon_sym__Nonnull] = ACTIONS(6907),
    [anon_sym_mutable] = ACTIONS(6907),
    [anon_sym_constinit] = ACTIONS(6907),
    [anon_sym_consteval] = ACTIONS(6907),
    [anon_sym_alignas] = ACTIONS(6907),
    [anon_sym__Alignas] = ACTIONS(6907),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6907),
    [anon_sym_explicit] = ACTIONS(6907),
    [anon_sym_template] = ACTIONS(6907),
    [anon_sym_operator] = ACTIONS(6907),
    [anon_sym_precise] = ACTIONS(6907),
    [anon_sym_shared] = ACTIONS(6907),
    [anon_sym_groupshared] = ACTIONS(6907),
    [anon_sym_uniform] = ACTIONS(6907),
    [anon_sym_row_major] = ACTIONS(6907),
    [anon_sym_column_major] = ACTIONS(6907),
    [anon_sym_globallycoherent] = ACTIONS(6907),
    [anon_sym_centroid] = ACTIONS(6907),
    [anon_sym_noperspective] = ACTIONS(6907),
    [anon_sym_nointerpolation] = ACTIONS(6907),
    [anon_sym_sample] = ACTIONS(6907),
    [anon_sym_linear] = ACTIONS(6907),
    [anon_sym_snorm] = ACTIONS(6907),
    [anon_sym_unorm] = ACTIONS(6907),
    [anon_sym_point] = ACTIONS(6907),
    [anon_sym_line] = ACTIONS(6907),
    [anon_sym_triangleadj] = ACTIONS(6907),
    [anon_sym_lineadj] = ACTIONS(6907),
    [anon_sym_triangle] = ACTIONS(6907),
  },
  [2817] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_RPAREN] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5917),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5919),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5917),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym_COLON] = ACTIONS(5919),
    [anon_sym_SEMI] = ACTIONS(5919),
    [anon_sym___attribute__] = ACTIONS(5919),
    [anon_sym___attribute] = ACTIONS(5917),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_RBRACE] = ACTIONS(5919),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_RBRACK] = ACTIONS(5919),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_STAR_EQ] = ACTIONS(5919),
    [anon_sym_SLASH_EQ] = ACTIONS(5919),
    [anon_sym_PERCENT_EQ] = ACTIONS(5919),
    [anon_sym_PLUS_EQ] = ACTIONS(5919),
    [anon_sym_DASH_EQ] = ACTIONS(5919),
    [anon_sym_LT_LT_EQ] = ACTIONS(5919),
    [anon_sym_GT_GT_EQ] = ACTIONS(5919),
    [anon_sym_AMP_EQ] = ACTIONS(5919),
    [anon_sym_CARET_EQ] = ACTIONS(5919),
    [anon_sym_PIPE_EQ] = ACTIONS(5919),
    [anon_sym_and_eq] = ACTIONS(5919),
    [anon_sym_or_eq] = ACTIONS(5919),
    [anon_sym_xor_eq] = ACTIONS(5919),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5917),
    [anon_sym_and] = ACTIONS(5917),
    [anon_sym_bitor] = ACTIONS(5919),
    [anon_sym_xor] = ACTIONS(5917),
    [anon_sym_bitand] = ACTIONS(5919),
    [anon_sym_not_eq] = ACTIONS(5919),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5919),
    [anon_sym_decltype] = ACTIONS(5919),
  },
  [2818] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5923),
    [anon_sym_DASH] = ACTIONS(5921),
    [anon_sym_PLUS] = ACTIONS(5921),
    [anon_sym_STAR] = ACTIONS(5921),
    [anon_sym_SLASH] = ACTIONS(5921),
    [anon_sym_PERCENT] = ACTIONS(5921),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT] = ACTIONS(5921),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5921),
    [anon_sym_LT] = ACTIONS(5921),
    [anon_sym_LT_LT] = ACTIONS(5921),
    [anon_sym_GT_GT] = ACTIONS(5921),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym___attribute__] = ACTIONS(5923),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_LBRACE] = ACTIONS(5923),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5923),
    [anon_sym_RBRACK] = ACTIONS(5923),
    [anon_sym_EQ] = ACTIONS(5921),
    [anon_sym_QMARK] = ACTIONS(5923),
    [anon_sym_STAR_EQ] = ACTIONS(5923),
    [anon_sym_SLASH_EQ] = ACTIONS(5923),
    [anon_sym_PERCENT_EQ] = ACTIONS(5923),
    [anon_sym_PLUS_EQ] = ACTIONS(5923),
    [anon_sym_DASH_EQ] = ACTIONS(5923),
    [anon_sym_LT_LT_EQ] = ACTIONS(5923),
    [anon_sym_GT_GT_EQ] = ACTIONS(5923),
    [anon_sym_AMP_EQ] = ACTIONS(5923),
    [anon_sym_CARET_EQ] = ACTIONS(5923),
    [anon_sym_PIPE_EQ] = ACTIONS(5923),
    [anon_sym_and_eq] = ACTIONS(5923),
    [anon_sym_or_eq] = ACTIONS(5923),
    [anon_sym_xor_eq] = ACTIONS(5923),
    [anon_sym_LT_EQ_GT] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5921),
    [anon_sym_and] = ACTIONS(5921),
    [anon_sym_bitor] = ACTIONS(5923),
    [anon_sym_xor] = ACTIONS(5921),
    [anon_sym_bitand] = ACTIONS(5923),
    [anon_sym_not_eq] = ACTIONS(5923),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_DOT_STAR] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5923),
    [anon_sym_decltype] = ACTIONS(5923),
  },
  [2819] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5908),
    [anon_sym_COMMA] = ACTIONS(5908),
    [anon_sym_RPAREN] = ACTIONS(5908),
    [anon_sym_LPAREN2] = ACTIONS(5908),
    [anon_sym_DASH] = ACTIONS(5906),
    [anon_sym_PLUS] = ACTIONS(5906),
    [anon_sym_STAR] = ACTIONS(5906),
    [anon_sym_SLASH] = ACTIONS(5906),
    [anon_sym_PERCENT] = ACTIONS(5906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5908),
    [anon_sym_AMP_AMP] = ACTIONS(5908),
    [anon_sym_PIPE] = ACTIONS(5906),
    [anon_sym_CARET] = ACTIONS(5906),
    [anon_sym_AMP] = ACTIONS(5906),
    [anon_sym_EQ_EQ] = ACTIONS(5908),
    [anon_sym_BANG_EQ] = ACTIONS(5908),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5908),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_LT_LT] = ACTIONS(5906),
    [anon_sym_GT_GT] = ACTIONS(5906),
    [anon_sym_COLON] = ACTIONS(5908),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym___attribute__] = ACTIONS(5908),
    [anon_sym___attribute] = ACTIONS(5906),
    [anon_sym_LBRACE] = ACTIONS(5908),
    [anon_sym_RBRACE] = ACTIONS(5908),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5908),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_EQ] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_STAR_EQ] = ACTIONS(5908),
    [anon_sym_SLASH_EQ] = ACTIONS(5908),
    [anon_sym_PERCENT_EQ] = ACTIONS(5908),
    [anon_sym_PLUS_EQ] = ACTIONS(5908),
    [anon_sym_DASH_EQ] = ACTIONS(5908),
    [anon_sym_LT_LT_EQ] = ACTIONS(5908),
    [anon_sym_GT_GT_EQ] = ACTIONS(5908),
    [anon_sym_AMP_EQ] = ACTIONS(5908),
    [anon_sym_CARET_EQ] = ACTIONS(5908),
    [anon_sym_PIPE_EQ] = ACTIONS(5908),
    [anon_sym_and_eq] = ACTIONS(5908),
    [anon_sym_or_eq] = ACTIONS(5908),
    [anon_sym_xor_eq] = ACTIONS(5908),
    [anon_sym_LT_EQ_GT] = ACTIONS(5908),
    [anon_sym_or] = ACTIONS(5906),
    [anon_sym_and] = ACTIONS(5906),
    [anon_sym_bitor] = ACTIONS(5908),
    [anon_sym_xor] = ACTIONS(5906),
    [anon_sym_bitand] = ACTIONS(5908),
    [anon_sym_not_eq] = ACTIONS(5908),
    [anon_sym_DASH_DASH] = ACTIONS(5908),
    [anon_sym_PLUS_PLUS] = ACTIONS(5908),
    [anon_sym_DOT] = ACTIONS(5906),
    [anon_sym_DOT_STAR] = ACTIONS(5908),
    [anon_sym_DASH_GT] = ACTIONS(5908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5908),
    [anon_sym_decltype] = ACTIONS(5908),
  },
  [2820] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5913),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5913),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5913),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym___attribute__] = ACTIONS(5915),
    [anon_sym___attribute] = ACTIONS(5913),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_EQ] = ACTIONS(5913),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_STAR_EQ] = ACTIONS(5915),
    [anon_sym_SLASH_EQ] = ACTIONS(5915),
    [anon_sym_PERCENT_EQ] = ACTIONS(5915),
    [anon_sym_PLUS_EQ] = ACTIONS(5915),
    [anon_sym_DASH_EQ] = ACTIONS(5915),
    [anon_sym_LT_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT_GT_EQ] = ACTIONS(5915),
    [anon_sym_AMP_EQ] = ACTIONS(5915),
    [anon_sym_CARET_EQ] = ACTIONS(5915),
    [anon_sym_PIPE_EQ] = ACTIONS(5915),
    [anon_sym_and_eq] = ACTIONS(5915),
    [anon_sym_or_eq] = ACTIONS(5915),
    [anon_sym_xor_eq] = ACTIONS(5915),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5913),
    [anon_sym_and] = ACTIONS(5913),
    [anon_sym_bitor] = ACTIONS(5915),
    [anon_sym_xor] = ACTIONS(5913),
    [anon_sym_bitand] = ACTIONS(5915),
    [anon_sym_not_eq] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5915),
    [anon_sym_decltype] = ACTIONS(5915),
  },
  [2821] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5937),
    [anon_sym_COMMA] = ACTIONS(5937),
    [anon_sym_RPAREN] = ACTIONS(5937),
    [anon_sym_LPAREN2] = ACTIONS(5937),
    [anon_sym_DASH] = ACTIONS(5935),
    [anon_sym_PLUS] = ACTIONS(5935),
    [anon_sym_STAR] = ACTIONS(5935),
    [anon_sym_SLASH] = ACTIONS(5935),
    [anon_sym_PERCENT] = ACTIONS(5935),
    [anon_sym_PIPE_PIPE] = ACTIONS(5937),
    [anon_sym_AMP_AMP] = ACTIONS(5937),
    [anon_sym_PIPE] = ACTIONS(5935),
    [anon_sym_CARET] = ACTIONS(5935),
    [anon_sym_AMP] = ACTIONS(5935),
    [anon_sym_EQ_EQ] = ACTIONS(5937),
    [anon_sym_BANG_EQ] = ACTIONS(5937),
    [anon_sym_GT] = ACTIONS(5935),
    [anon_sym_GT_EQ] = ACTIONS(5937),
    [anon_sym_LT_EQ] = ACTIONS(5935),
    [anon_sym_LT] = ACTIONS(5935),
    [anon_sym_LT_LT] = ACTIONS(5935),
    [anon_sym_GT_GT] = ACTIONS(5935),
    [anon_sym_COLON] = ACTIONS(5937),
    [anon_sym_SEMI] = ACTIONS(5937),
    [anon_sym___attribute__] = ACTIONS(5937),
    [anon_sym___attribute] = ACTIONS(5935),
    [anon_sym_LBRACE] = ACTIONS(5937),
    [anon_sym_RBRACE] = ACTIONS(5937),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5937),
    [anon_sym_RBRACK] = ACTIONS(5937),
    [anon_sym_EQ] = ACTIONS(5935),
    [anon_sym_QMARK] = ACTIONS(5937),
    [anon_sym_STAR_EQ] = ACTIONS(5937),
    [anon_sym_SLASH_EQ] = ACTIONS(5937),
    [anon_sym_PERCENT_EQ] = ACTIONS(5937),
    [anon_sym_PLUS_EQ] = ACTIONS(5937),
    [anon_sym_DASH_EQ] = ACTIONS(5937),
    [anon_sym_LT_LT_EQ] = ACTIONS(5937),
    [anon_sym_GT_GT_EQ] = ACTIONS(5937),
    [anon_sym_AMP_EQ] = ACTIONS(5937),
    [anon_sym_CARET_EQ] = ACTIONS(5937),
    [anon_sym_PIPE_EQ] = ACTIONS(5937),
    [anon_sym_and_eq] = ACTIONS(5937),
    [anon_sym_or_eq] = ACTIONS(5937),
    [anon_sym_xor_eq] = ACTIONS(5937),
    [anon_sym_LT_EQ_GT] = ACTIONS(5937),
    [anon_sym_or] = ACTIONS(5935),
    [anon_sym_and] = ACTIONS(5935),
    [anon_sym_bitor] = ACTIONS(5937),
    [anon_sym_xor] = ACTIONS(5935),
    [anon_sym_bitand] = ACTIONS(5937),
    [anon_sym_not_eq] = ACTIONS(5937),
    [anon_sym_DASH_DASH] = ACTIONS(5937),
    [anon_sym_PLUS_PLUS] = ACTIONS(5937),
    [anon_sym_DOT] = ACTIONS(5935),
    [anon_sym_DOT_STAR] = ACTIONS(5937),
    [anon_sym_DASH_GT] = ACTIONS(5937),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5937),
    [anon_sym_decltype] = ACTIONS(5937),
  },
  [2822] = {
    [sym_attribute_specifier] = STATE(2548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6233),
    [anon_sym_COMMA] = ACTIONS(6233),
    [anon_sym_RPAREN] = ACTIONS(6233),
    [anon_sym_LPAREN2] = ACTIONS(6233),
    [anon_sym_DASH] = ACTIONS(6231),
    [anon_sym_PLUS] = ACTIONS(6231),
    [anon_sym_STAR] = ACTIONS(6233),
    [anon_sym_SLASH] = ACTIONS(6231),
    [anon_sym_PERCENT] = ACTIONS(6233),
    [anon_sym_PIPE_PIPE] = ACTIONS(6233),
    [anon_sym_AMP_AMP] = ACTIONS(6233),
    [anon_sym_PIPE] = ACTIONS(6231),
    [anon_sym_CARET] = ACTIONS(6233),
    [anon_sym_AMP] = ACTIONS(6231),
    [anon_sym_EQ_EQ] = ACTIONS(6233),
    [anon_sym_BANG_EQ] = ACTIONS(6233),
    [anon_sym_GT] = ACTIONS(6231),
    [anon_sym_GT_EQ] = ACTIONS(6233),
    [anon_sym_LT_EQ] = ACTIONS(6231),
    [anon_sym_LT] = ACTIONS(6231),
    [anon_sym_LT_LT] = ACTIONS(6233),
    [anon_sym_GT_GT] = ACTIONS(6233),
    [anon_sym_COLON] = ACTIONS(6233),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym___extension__] = ACTIONS(6233),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6233),
    [anon_sym_RBRACE] = ACTIONS(6233),
    [anon_sym_LBRACK] = ACTIONS(6233),
    [anon_sym_RBRACK] = ACTIONS(6233),
    [anon_sym_const] = ACTIONS(6231),
    [anon_sym_constexpr] = ACTIONS(6233),
    [anon_sym_volatile] = ACTIONS(6233),
    [anon_sym_restrict] = ACTIONS(6233),
    [anon_sym___restrict__] = ACTIONS(6233),
    [anon_sym__Atomic] = ACTIONS(6233),
    [anon_sym__Noreturn] = ACTIONS(6233),
    [anon_sym_noreturn] = ACTIONS(6233),
    [anon_sym__Nonnull] = ACTIONS(6233),
    [anon_sym_mutable] = ACTIONS(6233),
    [anon_sym_constinit] = ACTIONS(6233),
    [anon_sym_consteval] = ACTIONS(6233),
    [anon_sym_alignas] = ACTIONS(6233),
    [anon_sym__Alignas] = ACTIONS(6233),
    [anon_sym_QMARK] = ACTIONS(6233),
    [anon_sym_LT_EQ_GT] = ACTIONS(6233),
    [anon_sym_or] = ACTIONS(6233),
    [anon_sym_and] = ACTIONS(6233),
    [anon_sym_bitor] = ACTIONS(6233),
    [anon_sym_xor] = ACTIONS(6233),
    [anon_sym_bitand] = ACTIONS(6233),
    [anon_sym_not_eq] = ACTIONS(6233),
    [anon_sym_DASH_DASH] = ACTIONS(6233),
    [anon_sym_PLUS_PLUS] = ACTIONS(6233),
    [anon_sym_DOT] = ACTIONS(6231),
    [anon_sym_DOT_STAR] = ACTIONS(6233),
    [anon_sym_DASH_GT] = ACTIONS(6233),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6233),
    [anon_sym_decltype] = ACTIONS(6233),
    [anon_sym_final] = ACTIONS(6233),
    [anon_sym_override] = ACTIONS(6233),
    [anon_sym_requires] = ACTIONS(6233),
  },
  [2823] = {
    [sym_identifier] = ACTIONS(6913),
    [anon_sym_LPAREN2] = ACTIONS(6915),
    [anon_sym_TILDE] = ACTIONS(6915),
    [anon_sym_STAR] = ACTIONS(6915),
    [anon_sym_AMP_AMP] = ACTIONS(6915),
    [anon_sym_AMP] = ACTIONS(6913),
    [anon_sym___extension__] = ACTIONS(6913),
    [anon_sym_in] = ACTIONS(6913),
    [anon_sym_out] = ACTIONS(6913),
    [anon_sym_inout] = ACTIONS(6913),
    [anon_sym_virtual] = ACTIONS(6913),
    [anon_sym_extern] = ACTIONS(6913),
    [anon_sym___attribute__] = ACTIONS(6913),
    [anon_sym___attribute] = ACTIONS(6913),
    [anon_sym_COLON_COLON] = ACTIONS(6915),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6915),
    [anon_sym___declspec] = ACTIONS(6913),
    [anon_sym___based] = ACTIONS(6913),
    [anon_sym_LBRACK] = ACTIONS(6913),
    [anon_sym_static] = ACTIONS(6913),
    [anon_sym_register] = ACTIONS(6913),
    [anon_sym_inline] = ACTIONS(6913),
    [anon_sym___inline] = ACTIONS(6913),
    [anon_sym___inline__] = ACTIONS(6913),
    [anon_sym___forceinline] = ACTIONS(6913),
    [anon_sym_thread_local] = ACTIONS(6913),
    [anon_sym___thread] = ACTIONS(6913),
    [anon_sym_const] = ACTIONS(6913),
    [anon_sym_constexpr] = ACTIONS(6913),
    [anon_sym_volatile] = ACTIONS(6913),
    [anon_sym_restrict] = ACTIONS(6913),
    [anon_sym___restrict__] = ACTIONS(6913),
    [anon_sym__Atomic] = ACTIONS(6913),
    [anon_sym__Noreturn] = ACTIONS(6913),
    [anon_sym_noreturn] = ACTIONS(6913),
    [anon_sym__Nonnull] = ACTIONS(6913),
    [anon_sym_mutable] = ACTIONS(6913),
    [anon_sym_constinit] = ACTIONS(6913),
    [anon_sym_consteval] = ACTIONS(6913),
    [anon_sym_alignas] = ACTIONS(6913),
    [anon_sym__Alignas] = ACTIONS(6913),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(6913),
    [anon_sym_explicit] = ACTIONS(6913),
    [anon_sym_template] = ACTIONS(6913),
    [anon_sym_operator] = ACTIONS(6913),
    [anon_sym_precise] = ACTIONS(6913),
    [anon_sym_shared] = ACTIONS(6913),
    [anon_sym_groupshared] = ACTIONS(6913),
    [anon_sym_uniform] = ACTIONS(6913),
    [anon_sym_row_major] = ACTIONS(6913),
    [anon_sym_column_major] = ACTIONS(6913),
    [anon_sym_globallycoherent] = ACTIONS(6913),
    [anon_sym_centroid] = ACTIONS(6913),
    [anon_sym_noperspective] = ACTIONS(6913),
    [anon_sym_nointerpolation] = ACTIONS(6913),
    [anon_sym_sample] = ACTIONS(6913),
    [anon_sym_linear] = ACTIONS(6913),
    [anon_sym_snorm] = ACTIONS(6913),
    [anon_sym_unorm] = ACTIONS(6913),
    [anon_sym_point] = ACTIONS(6913),
    [anon_sym_line] = ACTIONS(6913),
    [anon_sym_triangleadj] = ACTIONS(6913),
    [anon_sym_lineadj] = ACTIONS(6913),
    [anon_sym_triangle] = ACTIONS(6913),
  },
  [2824] = {
    [sym_attribute_specifier] = STATE(2544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6225),
    [anon_sym_COMMA] = ACTIONS(6225),
    [anon_sym_RPAREN] = ACTIONS(6225),
    [anon_sym_LPAREN2] = ACTIONS(6225),
    [anon_sym_DASH] = ACTIONS(6223),
    [anon_sym_PLUS] = ACTIONS(6223),
    [anon_sym_STAR] = ACTIONS(6225),
    [anon_sym_SLASH] = ACTIONS(6223),
    [anon_sym_PERCENT] = ACTIONS(6225),
    [anon_sym_PIPE_PIPE] = ACTIONS(6225),
    [anon_sym_AMP_AMP] = ACTIONS(6225),
    [anon_sym_PIPE] = ACTIONS(6223),
    [anon_sym_CARET] = ACTIONS(6225),
    [anon_sym_AMP] = ACTIONS(6223),
    [anon_sym_EQ_EQ] = ACTIONS(6225),
    [anon_sym_BANG_EQ] = ACTIONS(6225),
    [anon_sym_GT] = ACTIONS(6223),
    [anon_sym_GT_EQ] = ACTIONS(6225),
    [anon_sym_LT_EQ] = ACTIONS(6223),
    [anon_sym_LT] = ACTIONS(6223),
    [anon_sym_LT_LT] = ACTIONS(6225),
    [anon_sym_GT_GT] = ACTIONS(6225),
    [anon_sym_COLON] = ACTIONS(6225),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym___extension__] = ACTIONS(6225),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6225),
    [anon_sym_RBRACE] = ACTIONS(6225),
    [anon_sym_LBRACK] = ACTIONS(6225),
    [anon_sym_RBRACK] = ACTIONS(6225),
    [anon_sym_const] = ACTIONS(6223),
    [anon_sym_constexpr] = ACTIONS(6225),
    [anon_sym_volatile] = ACTIONS(6225),
    [anon_sym_restrict] = ACTIONS(6225),
    [anon_sym___restrict__] = ACTIONS(6225),
    [anon_sym__Atomic] = ACTIONS(6225),
    [anon_sym__Noreturn] = ACTIONS(6225),
    [anon_sym_noreturn] = ACTIONS(6225),
    [anon_sym__Nonnull] = ACTIONS(6225),
    [anon_sym_mutable] = ACTIONS(6225),
    [anon_sym_constinit] = ACTIONS(6225),
    [anon_sym_consteval] = ACTIONS(6225),
    [anon_sym_alignas] = ACTIONS(6225),
    [anon_sym__Alignas] = ACTIONS(6225),
    [anon_sym_QMARK] = ACTIONS(6225),
    [anon_sym_LT_EQ_GT] = ACTIONS(6225),
    [anon_sym_or] = ACTIONS(6225),
    [anon_sym_and] = ACTIONS(6225),
    [anon_sym_bitor] = ACTIONS(6225),
    [anon_sym_xor] = ACTIONS(6225),
    [anon_sym_bitand] = ACTIONS(6225),
    [anon_sym_not_eq] = ACTIONS(6225),
    [anon_sym_DASH_DASH] = ACTIONS(6225),
    [anon_sym_PLUS_PLUS] = ACTIONS(6225),
    [anon_sym_DOT] = ACTIONS(6223),
    [anon_sym_DOT_STAR] = ACTIONS(6225),
    [anon_sym_DASH_GT] = ACTIONS(6225),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6225),
    [anon_sym_decltype] = ACTIONS(6225),
    [anon_sym_final] = ACTIONS(6225),
    [anon_sym_override] = ACTIONS(6225),
    [anon_sym_requires] = ACTIONS(6225),
  },
  [2825] = {
    [sym_attribute_specifier] = STATE(2543),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6193),
    [anon_sym_COMMA] = ACTIONS(6193),
    [anon_sym_RPAREN] = ACTIONS(6193),
    [anon_sym_LPAREN2] = ACTIONS(6193),
    [anon_sym_DASH] = ACTIONS(6191),
    [anon_sym_PLUS] = ACTIONS(6191),
    [anon_sym_STAR] = ACTIONS(6193),
    [anon_sym_SLASH] = ACTIONS(6191),
    [anon_sym_PERCENT] = ACTIONS(6193),
    [anon_sym_PIPE_PIPE] = ACTIONS(6193),
    [anon_sym_AMP_AMP] = ACTIONS(6193),
    [anon_sym_PIPE] = ACTIONS(6191),
    [anon_sym_CARET] = ACTIONS(6193),
    [anon_sym_AMP] = ACTIONS(6191),
    [anon_sym_EQ_EQ] = ACTIONS(6193),
    [anon_sym_BANG_EQ] = ACTIONS(6193),
    [anon_sym_GT] = ACTIONS(6191),
    [anon_sym_GT_EQ] = ACTIONS(6193),
    [anon_sym_LT_EQ] = ACTIONS(6191),
    [anon_sym_LT] = ACTIONS(6191),
    [anon_sym_LT_LT] = ACTIONS(6193),
    [anon_sym_GT_GT] = ACTIONS(6193),
    [anon_sym_COLON] = ACTIONS(6193),
    [anon_sym_SEMI] = ACTIONS(6193),
    [anon_sym___extension__] = ACTIONS(6193),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6193),
    [anon_sym_RBRACE] = ACTIONS(6193),
    [anon_sym_LBRACK] = ACTIONS(6193),
    [anon_sym_RBRACK] = ACTIONS(6193),
    [anon_sym_const] = ACTIONS(6191),
    [anon_sym_constexpr] = ACTIONS(6193),
    [anon_sym_volatile] = ACTIONS(6193),
    [anon_sym_restrict] = ACTIONS(6193),
    [anon_sym___restrict__] = ACTIONS(6193),
    [anon_sym__Atomic] = ACTIONS(6193),
    [anon_sym__Noreturn] = ACTIONS(6193),
    [anon_sym_noreturn] = ACTIONS(6193),
    [anon_sym__Nonnull] = ACTIONS(6193),
    [anon_sym_mutable] = ACTIONS(6193),
    [anon_sym_constinit] = ACTIONS(6193),
    [anon_sym_consteval] = ACTIONS(6193),
    [anon_sym_alignas] = ACTIONS(6193),
    [anon_sym__Alignas] = ACTIONS(6193),
    [anon_sym_QMARK] = ACTIONS(6193),
    [anon_sym_LT_EQ_GT] = ACTIONS(6193),
    [anon_sym_or] = ACTIONS(6193),
    [anon_sym_and] = ACTIONS(6193),
    [anon_sym_bitor] = ACTIONS(6193),
    [anon_sym_xor] = ACTIONS(6193),
    [anon_sym_bitand] = ACTIONS(6193),
    [anon_sym_not_eq] = ACTIONS(6193),
    [anon_sym_DASH_DASH] = ACTIONS(6193),
    [anon_sym_PLUS_PLUS] = ACTIONS(6193),
    [anon_sym_DOT] = ACTIONS(6191),
    [anon_sym_DOT_STAR] = ACTIONS(6193),
    [anon_sym_DASH_GT] = ACTIONS(6193),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6193),
    [anon_sym_decltype] = ACTIONS(6193),
    [anon_sym_final] = ACTIONS(6193),
    [anon_sym_override] = ACTIONS(6193),
    [anon_sym_requires] = ACTIONS(6193),
  },
  [2826] = {
    [sym_template_argument_list] = STATE(2839),
    [sym_identifier] = ACTIONS(6917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6919),
    [anon_sym_COMMA] = ACTIONS(6919),
    [anon_sym_RPAREN] = ACTIONS(6919),
    [aux_sym_preproc_if_token2] = ACTIONS(6919),
    [aux_sym_preproc_else_token1] = ACTIONS(6919),
    [aux_sym_preproc_elif_token1] = ACTIONS(6917),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6919),
    [anon_sym_LPAREN2] = ACTIONS(6919),
    [anon_sym_DASH] = ACTIONS(6917),
    [anon_sym_PLUS] = ACTIONS(6917),
    [anon_sym_STAR] = ACTIONS(6917),
    [anon_sym_SLASH] = ACTIONS(6917),
    [anon_sym_PERCENT] = ACTIONS(6917),
    [anon_sym_PIPE_PIPE] = ACTIONS(6919),
    [anon_sym_AMP_AMP] = ACTIONS(6919),
    [anon_sym_PIPE] = ACTIONS(6917),
    [anon_sym_CARET] = ACTIONS(6917),
    [anon_sym_AMP] = ACTIONS(6917),
    [anon_sym_EQ_EQ] = ACTIONS(6919),
    [anon_sym_BANG_EQ] = ACTIONS(6919),
    [anon_sym_GT] = ACTIONS(6917),
    [anon_sym_GT_EQ] = ACTIONS(6919),
    [anon_sym_LT_EQ] = ACTIONS(6917),
    [anon_sym_LT] = ACTIONS(6921),
    [anon_sym_LT_LT] = ACTIONS(6917),
    [anon_sym_GT_GT] = ACTIONS(6917),
    [anon_sym_COLON] = ACTIONS(6917),
    [anon_sym_SEMI] = ACTIONS(6919),
    [anon_sym___attribute__] = ACTIONS(6917),
    [anon_sym___attribute] = ACTIONS(6917),
    [anon_sym_COLON_COLON] = ACTIONS(2003),
    [anon_sym_RBRACE] = ACTIONS(6919),
    [anon_sym_LBRACK] = ACTIONS(6919),
    [anon_sym_RBRACK] = ACTIONS(6919),
    [anon_sym_EQ] = ACTIONS(6917),
    [anon_sym_QMARK] = ACTIONS(6919),
    [anon_sym_STAR_EQ] = ACTIONS(6919),
    [anon_sym_SLASH_EQ] = ACTIONS(6919),
    [anon_sym_PERCENT_EQ] = ACTIONS(6919),
    [anon_sym_PLUS_EQ] = ACTIONS(6919),
    [anon_sym_DASH_EQ] = ACTIONS(6919),
    [anon_sym_LT_LT_EQ] = ACTIONS(6919),
    [anon_sym_GT_GT_EQ] = ACTIONS(6919),
    [anon_sym_AMP_EQ] = ACTIONS(6919),
    [anon_sym_CARET_EQ] = ACTIONS(6919),
    [anon_sym_PIPE_EQ] = ACTIONS(6919),
    [anon_sym_and_eq] = ACTIONS(6917),
    [anon_sym_or_eq] = ACTIONS(6917),
    [anon_sym_xor_eq] = ACTIONS(6917),
    [anon_sym_LT_EQ_GT] = ACTIONS(6919),
    [anon_sym_or] = ACTIONS(6917),
    [anon_sym_and] = ACTIONS(6917),
    [anon_sym_bitor] = ACTIONS(6917),
    [anon_sym_xor] = ACTIONS(6917),
    [anon_sym_bitand] = ACTIONS(6917),
    [anon_sym_not_eq] = ACTIONS(6917),
    [anon_sym_DASH_DASH] = ACTIONS(6919),
    [anon_sym_PLUS_PLUS] = ACTIONS(6919),
    [anon_sym_DOT] = ACTIONS(6917),
    [anon_sym_DOT_STAR] = ACTIONS(6919),
    [anon_sym_DASH_GT] = ACTIONS(6919),
    [sym_comment] = ACTIONS(3),
  },
  [2827] = {
    [sym_attribute_specifier] = STATE(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6189),
    [anon_sym_COMMA] = ACTIONS(6189),
    [anon_sym_RPAREN] = ACTIONS(6189),
    [anon_sym_LPAREN2] = ACTIONS(6189),
    [anon_sym_DASH] = ACTIONS(6187),
    [anon_sym_PLUS] = ACTIONS(6187),
    [anon_sym_STAR] = ACTIONS(6189),
    [anon_sym_SLASH] = ACTIONS(6187),
    [anon_sym_PERCENT] = ACTIONS(6189),
    [anon_sym_PIPE_PIPE] = ACTIONS(6189),
    [anon_sym_AMP_AMP] = ACTIONS(6189),
    [anon_sym_PIPE] = ACTIONS(6187),
    [anon_sym_CARET] = ACTIONS(6189),
    [anon_sym_AMP] = ACTIONS(6187),
    [anon_sym_EQ_EQ] = ACTIONS(6189),
    [anon_sym_BANG_EQ] = ACTIONS(6189),
    [anon_sym_GT] = ACTIONS(6187),
    [anon_sym_GT_EQ] = ACTIONS(6189),
    [anon_sym_LT_EQ] = ACTIONS(6187),
    [anon_sym_LT] = ACTIONS(6187),
    [anon_sym_LT_LT] = ACTIONS(6189),
    [anon_sym_GT_GT] = ACTIONS(6189),
    [anon_sym_COLON] = ACTIONS(6189),
    [anon_sym_SEMI] = ACTIONS(6189),
    [anon_sym___extension__] = ACTIONS(6189),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6189),
    [anon_sym_RBRACE] = ACTIONS(6189),
    [anon_sym_LBRACK] = ACTIONS(6189),
    [anon_sym_RBRACK] = ACTIONS(6189),
    [anon_sym_const] = ACTIONS(6187),
    [anon_sym_constexpr] = ACTIONS(6189),
    [anon_sym_volatile] = ACTIONS(6189),
    [anon_sym_restrict] = ACTIONS(6189),
    [anon_sym___restrict__] = ACTIONS(6189),
    [anon_sym__Atomic] = ACTIONS(6189),
    [anon_sym__Noreturn] = ACTIONS(6189),
    [anon_sym_noreturn] = ACTIONS(6189),
    [anon_sym__Nonnull] = ACTIONS(6189),
    [anon_sym_mutable] = ACTIONS(6189),
    [anon_sym_constinit] = ACTIONS(6189),
    [anon_sym_consteval] = ACTIONS(6189),
    [anon_sym_alignas] = ACTIONS(6189),
    [anon_sym__Alignas] = ACTIONS(6189),
    [anon_sym_QMARK] = ACTIONS(6189),
    [anon_sym_LT_EQ_GT] = ACTIONS(6189),
    [anon_sym_or] = ACTIONS(6189),
    [anon_sym_and] = ACTIONS(6189),
    [anon_sym_bitor] = ACTIONS(6189),
    [anon_sym_xor] = ACTIONS(6189),
    [anon_sym_bitand] = ACTIONS(6189),
    [anon_sym_not_eq] = ACTIONS(6189),
    [anon_sym_DASH_DASH] = ACTIONS(6189),
    [anon_sym_PLUS_PLUS] = ACTIONS(6189),
    [anon_sym_DOT] = ACTIONS(6187),
    [anon_sym_DOT_STAR] = ACTIONS(6189),
    [anon_sym_DASH_GT] = ACTIONS(6189),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6189),
    [anon_sym_decltype] = ACTIONS(6189),
    [anon_sym_final] = ACTIONS(6189),
    [anon_sym_override] = ACTIONS(6189),
    [anon_sym_requires] = ACTIONS(6189),
  },
  [2828] = {
    [sym_attribute_specifier] = STATE(2552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6241),
    [anon_sym_COMMA] = ACTIONS(6241),
    [anon_sym_RPAREN] = ACTIONS(6241),
    [anon_sym_LPAREN2] = ACTIONS(6241),
    [anon_sym_DASH] = ACTIONS(6239),
    [anon_sym_PLUS] = ACTIONS(6239),
    [anon_sym_STAR] = ACTIONS(6241),
    [anon_sym_SLASH] = ACTIONS(6239),
    [anon_sym_PERCENT] = ACTIONS(6241),
    [anon_sym_PIPE_PIPE] = ACTIONS(6241),
    [anon_sym_AMP_AMP] = ACTIONS(6241),
    [anon_sym_PIPE] = ACTIONS(6239),
    [anon_sym_CARET] = ACTIONS(6241),
    [anon_sym_AMP] = ACTIONS(6239),
    [anon_sym_EQ_EQ] = ACTIONS(6241),
    [anon_sym_BANG_EQ] = ACTIONS(6241),
    [anon_sym_GT] = ACTIONS(6239),
    [anon_sym_GT_EQ] = ACTIONS(6241),
    [anon_sym_LT_EQ] = ACTIONS(6239),
    [anon_sym_LT] = ACTIONS(6239),
    [anon_sym_LT_LT] = ACTIONS(6241),
    [anon_sym_GT_GT] = ACTIONS(6241),
    [anon_sym_COLON] = ACTIONS(6241),
    [anon_sym_SEMI] = ACTIONS(6241),
    [anon_sym___extension__] = ACTIONS(6241),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6241),
    [anon_sym_RBRACE] = ACTIONS(6241),
    [anon_sym_LBRACK] = ACTIONS(6241),
    [anon_sym_RBRACK] = ACTIONS(6241),
    [anon_sym_const] = ACTIONS(6239),
    [anon_sym_constexpr] = ACTIONS(6241),
    [anon_sym_volatile] = ACTIONS(6241),
    [anon_sym_restrict] = ACTIONS(6241),
    [anon_sym___restrict__] = ACTIONS(6241),
    [anon_sym__Atomic] = ACTIONS(6241),
    [anon_sym__Noreturn] = ACTIONS(6241),
    [anon_sym_noreturn] = ACTIONS(6241),
    [anon_sym__Nonnull] = ACTIONS(6241),
    [anon_sym_mutable] = ACTIONS(6241),
    [anon_sym_constinit] = ACTIONS(6241),
    [anon_sym_consteval] = ACTIONS(6241),
    [anon_sym_alignas] = ACTIONS(6241),
    [anon_sym__Alignas] = ACTIONS(6241),
    [anon_sym_QMARK] = ACTIONS(6241),
    [anon_sym_LT_EQ_GT] = ACTIONS(6241),
    [anon_sym_or] = ACTIONS(6241),
    [anon_sym_and] = ACTIONS(6241),
    [anon_sym_bitor] = ACTIONS(6241),
    [anon_sym_xor] = ACTIONS(6241),
    [anon_sym_bitand] = ACTIONS(6241),
    [anon_sym_not_eq] = ACTIONS(6241),
    [anon_sym_DASH_DASH] = ACTIONS(6241),
    [anon_sym_PLUS_PLUS] = ACTIONS(6241),
    [anon_sym_DOT] = ACTIONS(6239),
    [anon_sym_DOT_STAR] = ACTIONS(6241),
    [anon_sym_DASH_GT] = ACTIONS(6241),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6241),
    [anon_sym_decltype] = ACTIONS(6241),
    [anon_sym_final] = ACTIONS(6241),
    [anon_sym_override] = ACTIONS(6241),
    [anon_sym_requires] = ACTIONS(6241),
  },
  [2829] = {
    [sym_attribute_specifier] = STATE(2567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6221),
    [anon_sym_COMMA] = ACTIONS(6221),
    [anon_sym_RPAREN] = ACTIONS(6221),
    [anon_sym_LPAREN2] = ACTIONS(6221),
    [anon_sym_DASH] = ACTIONS(6219),
    [anon_sym_PLUS] = ACTIONS(6219),
    [anon_sym_STAR] = ACTIONS(6221),
    [anon_sym_SLASH] = ACTIONS(6219),
    [anon_sym_PERCENT] = ACTIONS(6221),
    [anon_sym_PIPE_PIPE] = ACTIONS(6221),
    [anon_sym_AMP_AMP] = ACTIONS(6221),
    [anon_sym_PIPE] = ACTIONS(6219),
    [anon_sym_CARET] = ACTIONS(6221),
    [anon_sym_AMP] = ACTIONS(6219),
    [anon_sym_EQ_EQ] = ACTIONS(6221),
    [anon_sym_BANG_EQ] = ACTIONS(6221),
    [anon_sym_GT] = ACTIONS(6219),
    [anon_sym_GT_EQ] = ACTIONS(6221),
    [anon_sym_LT_EQ] = ACTIONS(6219),
    [anon_sym_LT] = ACTIONS(6219),
    [anon_sym_LT_LT] = ACTIONS(6221),
    [anon_sym_GT_GT] = ACTIONS(6221),
    [anon_sym_COLON] = ACTIONS(6221),
    [anon_sym_SEMI] = ACTIONS(6221),
    [anon_sym___extension__] = ACTIONS(6221),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6221),
    [anon_sym_RBRACE] = ACTIONS(6221),
    [anon_sym_LBRACK] = ACTIONS(6221),
    [anon_sym_RBRACK] = ACTIONS(6221),
    [anon_sym_const] = ACTIONS(6219),
    [anon_sym_constexpr] = ACTIONS(6221),
    [anon_sym_volatile] = ACTIONS(6221),
    [anon_sym_restrict] = ACTIONS(6221),
    [anon_sym___restrict__] = ACTIONS(6221),
    [anon_sym__Atomic] = ACTIONS(6221),
    [anon_sym__Noreturn] = ACTIONS(6221),
    [anon_sym_noreturn] = ACTIONS(6221),
    [anon_sym__Nonnull] = ACTIONS(6221),
    [anon_sym_mutable] = ACTIONS(6221),
    [anon_sym_constinit] = ACTIONS(6221),
    [anon_sym_consteval] = ACTIONS(6221),
    [anon_sym_alignas] = ACTIONS(6221),
    [anon_sym__Alignas] = ACTIONS(6221),
    [anon_sym_QMARK] = ACTIONS(6221),
    [anon_sym_LT_EQ_GT] = ACTIONS(6221),
    [anon_sym_or] = ACTIONS(6221),
    [anon_sym_and] = ACTIONS(6221),
    [anon_sym_bitor] = ACTIONS(6221),
    [anon_sym_xor] = ACTIONS(6221),
    [anon_sym_bitand] = ACTIONS(6221),
    [anon_sym_not_eq] = ACTIONS(6221),
    [anon_sym_DASH_DASH] = ACTIONS(6221),
    [anon_sym_PLUS_PLUS] = ACTIONS(6221),
    [anon_sym_DOT] = ACTIONS(6219),
    [anon_sym_DOT_STAR] = ACTIONS(6221),
    [anon_sym_DASH_GT] = ACTIONS(6221),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6221),
    [anon_sym_decltype] = ACTIONS(6221),
    [anon_sym_final] = ACTIONS(6221),
    [anon_sym_override] = ACTIONS(6221),
    [anon_sym_requires] = ACTIONS(6221),
  },
  [2830] = {
    [sym_string_literal] = STATE(2670),
    [sym_raw_string_literal] = STATE(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6606),
    [anon_sym_COMMA] = ACTIONS(6606),
    [anon_sym_RPAREN] = ACTIONS(6606),
    [anon_sym_LPAREN2] = ACTIONS(6606),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_PERCENT] = ACTIONS(6604),
    [anon_sym_PIPE_PIPE] = ACTIONS(6606),
    [anon_sym_AMP_AMP] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_AMP] = ACTIONS(6604),
    [anon_sym_EQ_EQ] = ACTIONS(6606),
    [anon_sym_BANG_EQ] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6604),
    [anon_sym_GT_EQ] = ACTIONS(6606),
    [anon_sym_LT_EQ] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6604),
    [anon_sym_LT_LT] = ACTIONS(6604),
    [anon_sym_GT_GT] = ACTIONS(6604),
    [anon_sym_LBRACK] = ACTIONS(6606),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_QMARK] = ACTIONS(6606),
    [anon_sym_STAR_EQ] = ACTIONS(6606),
    [anon_sym_SLASH_EQ] = ACTIONS(6606),
    [anon_sym_PERCENT_EQ] = ACTIONS(6606),
    [anon_sym_PLUS_EQ] = ACTIONS(6606),
    [anon_sym_DASH_EQ] = ACTIONS(6606),
    [anon_sym_LT_LT_EQ] = ACTIONS(6606),
    [anon_sym_GT_GT_EQ] = ACTIONS(6606),
    [anon_sym_AMP_EQ] = ACTIONS(6606),
    [anon_sym_CARET_EQ] = ACTIONS(6606),
    [anon_sym_PIPE_EQ] = ACTIONS(6606),
    [anon_sym_and_eq] = ACTIONS(6604),
    [anon_sym_or_eq] = ACTIONS(6604),
    [anon_sym_xor_eq] = ACTIONS(6604),
    [anon_sym_LT_EQ_GT] = ACTIONS(6606),
    [anon_sym_or] = ACTIONS(6604),
    [anon_sym_and] = ACTIONS(6604),
    [anon_sym_bitor] = ACTIONS(6604),
    [anon_sym_xor] = ACTIONS(6604),
    [anon_sym_bitand] = ACTIONS(6604),
    [anon_sym_not_eq] = ACTIONS(6604),
    [anon_sym_DASH_DASH] = ACTIONS(6606),
    [anon_sym_PLUS_PLUS] = ACTIONS(6606),
    [anon_sym_DOT] = ACTIONS(6604),
    [anon_sym_DOT_STAR] = ACTIONS(6606),
    [anon_sym_DASH_GT] = ACTIONS(6604),
    [anon_sym_L_DQUOTE] = ACTIONS(5670),
    [anon_sym_u_DQUOTE] = ACTIONS(5670),
    [anon_sym_U_DQUOTE] = ACTIONS(5670),
    [anon_sym_u8_DQUOTE] = ACTIONS(5670),
    [anon_sym_DQUOTE] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5672),
    [anon_sym_LR_DQUOTE] = ACTIONS(5672),
    [anon_sym_uR_DQUOTE] = ACTIONS(5672),
    [anon_sym_UR_DQUOTE] = ACTIONS(5672),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5672),
    [anon_sym_DASH_GT_STAR] = ACTIONS(6606),
    [sym_literal_suffix] = ACTIONS(6604),
  },
  [2831] = {
    [sym_identifier] = ACTIONS(6459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6461),
    [anon_sym_COMMA] = ACTIONS(6461),
    [anon_sym_LPAREN2] = ACTIONS(6461),
    [anon_sym_DASH] = ACTIONS(6459),
    [anon_sym_PLUS] = ACTIONS(6459),
    [anon_sym_STAR] = ACTIONS(6459),
    [anon_sym_SLASH] = ACTIONS(6459),
    [anon_sym_PERCENT] = ACTIONS(6459),
    [anon_sym_PIPE_PIPE] = ACTIONS(6461),
    [anon_sym_AMP_AMP] = ACTIONS(6461),
    [anon_sym_PIPE] = ACTIONS(6459),
    [anon_sym_CARET] = ACTIONS(6459),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ_EQ] = ACTIONS(6461),
    [anon_sym_BANG_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6459),
    [anon_sym_GT_EQ] = ACTIONS(6461),
    [anon_sym_LT_EQ] = ACTIONS(6459),
    [anon_sym_LT] = ACTIONS(6459),
    [anon_sym_LT_LT] = ACTIONS(6459),
    [anon_sym_GT_GT] = ACTIONS(6459),
    [anon_sym_SEMI] = ACTIONS(6461),
    [anon_sym___attribute__] = ACTIONS(6459),
    [anon_sym___attribute] = ACTIONS(6459),
    [anon_sym_LBRACK] = ACTIONS(6461),
    [anon_sym_EQ] = ACTIONS(6459),
    [anon_sym_QMARK] = ACTIONS(6461),
    [anon_sym_STAR_EQ] = ACTIONS(6461),
    [anon_sym_SLASH_EQ] = ACTIONS(6461),
    [anon_sym_PERCENT_EQ] = ACTIONS(6461),
    [anon_sym_PLUS_EQ] = ACTIONS(6461),
    [anon_sym_DASH_EQ] = ACTIONS(6461),
    [anon_sym_LT_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT_GT_EQ] = ACTIONS(6461),
    [anon_sym_AMP_EQ] = ACTIONS(6461),
    [anon_sym_CARET_EQ] = ACTIONS(6461),
    [anon_sym_PIPE_EQ] = ACTIONS(6461),
    [anon_sym_and_eq] = ACTIONS(6459),
    [anon_sym_or_eq] = ACTIONS(6459),
    [anon_sym_xor_eq] = ACTIONS(6459),
    [anon_sym_LT_EQ_GT] = ACTIONS(6461),
    [anon_sym_or] = ACTIONS(6459),
    [anon_sym_and] = ACTIONS(6459),
    [anon_sym_bitor] = ACTIONS(6459),
    [anon_sym_xor] = ACTIONS(6459),
    [anon_sym_bitand] = ACTIONS(6459),
    [anon_sym_not_eq] = ACTIONS(6459),
    [anon_sym_DASH_DASH] = ACTIONS(6461),
    [anon_sym_PLUS_PLUS] = ACTIONS(6461),
    [anon_sym_DOT] = ACTIONS(6459),
    [anon_sym_DOT_STAR] = ACTIONS(6461),
    [anon_sym_DASH_GT] = ACTIONS(6461),
    [anon_sym_L_DQUOTE] = ACTIONS(6461),
    [anon_sym_u_DQUOTE] = ACTIONS(6461),
    [anon_sym_U_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8_DQUOTE] = ACTIONS(6461),
    [anon_sym_DQUOTE] = ACTIONS(6461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6461),
    [anon_sym_LR_DQUOTE] = ACTIONS(6461),
    [anon_sym_uR_DQUOTE] = ACTIONS(6461),
    [anon_sym_UR_DQUOTE] = ACTIONS(6461),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6461),
    [sym_literal_suffix] = ACTIONS(6459),
  },
  [2832] = {
    [sym_new_declarator] = STATE(2871),
    [sym_identifier] = ACTIONS(6924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6926),
    [anon_sym_COMMA] = ACTIONS(6926),
    [anon_sym_RPAREN] = ACTIONS(6926),
    [aux_sym_preproc_if_token2] = ACTIONS(6926),
    [aux_sym_preproc_else_token1] = ACTIONS(6926),
    [aux_sym_preproc_elif_token1] = ACTIONS(6924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6926),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6926),
    [anon_sym_LPAREN2] = ACTIONS(6926),
    [anon_sym_DASH] = ACTIONS(6924),
    [anon_sym_PLUS] = ACTIONS(6924),
    [anon_sym_STAR] = ACTIONS(6924),
    [anon_sym_SLASH] = ACTIONS(6924),
    [anon_sym_PERCENT] = ACTIONS(6924),
    [anon_sym_PIPE_PIPE] = ACTIONS(6926),
    [anon_sym_AMP_AMP] = ACTIONS(6926),
    [anon_sym_PIPE] = ACTIONS(6924),
    [anon_sym_CARET] = ACTIONS(6924),
    [anon_sym_AMP] = ACTIONS(6924),
    [anon_sym_EQ_EQ] = ACTIONS(6926),
    [anon_sym_BANG_EQ] = ACTIONS(6926),
    [anon_sym_GT] = ACTIONS(6924),
    [anon_sym_GT_EQ] = ACTIONS(6926),
    [anon_sym_LT_EQ] = ACTIONS(6924),
    [anon_sym_LT] = ACTIONS(6924),
    [anon_sym_LT_LT] = ACTIONS(6924),
    [anon_sym_GT_GT] = ACTIONS(6924),
    [anon_sym_COLON] = ACTIONS(6926),
    [anon_sym_SEMI] = ACTIONS(6926),
    [anon_sym___attribute__] = ACTIONS(6924),
    [anon_sym___attribute] = ACTIONS(6924),
    [anon_sym_LBRACE] = ACTIONS(6926),
    [anon_sym_RBRACE] = ACTIONS(6926),
    [anon_sym_LBRACK] = ACTIONS(6551),
    [anon_sym_RBRACK] = ACTIONS(6926),
    [anon_sym_EQ] = ACTIONS(6924),
    [anon_sym_QMARK] = ACTIONS(6926),
    [anon_sym_STAR_EQ] = ACTIONS(6926),
    [anon_sym_SLASH_EQ] = ACTIONS(6926),
    [anon_sym_PERCENT_EQ] = ACTIONS(6926),
    [anon_sym_PLUS_EQ] = ACTIONS(6926),
    [anon_sym_DASH_EQ] = ACTIONS(6926),
    [anon_sym_LT_LT_EQ] = ACTIONS(6926),
    [anon_sym_GT_GT_EQ] = ACTIONS(6926),
    [anon_sym_AMP_EQ] = ACTIONS(6926),
    [anon_sym_CARET_EQ] = ACTIONS(6926),
    [anon_sym_PIPE_EQ] = ACTIONS(6926),
    [anon_sym_and_eq] = ACTIONS(6924),
    [anon_sym_or_eq] = ACTIONS(6924),
    [anon_sym_xor_eq] = ACTIONS(6924),
    [anon_sym_LT_EQ_GT] = ACTIONS(6926),
    [anon_sym_or] = ACTIONS(6924),
    [anon_sym_and] = ACTIONS(6924),
    [anon_sym_bitor] = ACTIONS(6924),
    [anon_sym_xor] = ACTIONS(6924),
    [anon_sym_bitand] = ACTIONS(6924),
    [anon_sym_not_eq] = ACTIONS(6924),
    [anon_sym_DASH_DASH] = ACTIONS(6926),
    [anon_sym_PLUS_PLUS] = ACTIONS(6926),
    [anon_sym_DOT] = ACTIONS(6924),
    [anon_sym_DOT_STAR] = ACTIONS(6926),
    [anon_sym_DASH_GT] = ACTIONS(6926),
    [sym_comment] = ACTIONS(3),
  },
  [2833] = {
    [sym_identifier] = ACTIONS(6463),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6465),
    [anon_sym_COMMA] = ACTIONS(6465),
    [anon_sym_LPAREN2] = ACTIONS(6465),
    [anon_sym_DASH] = ACTIONS(6463),
    [anon_sym_PLUS] = ACTIONS(6463),
    [anon_sym_STAR] = ACTIONS(6463),
    [anon_sym_SLASH] = ACTIONS(6463),
    [anon_sym_PERCENT] = ACTIONS(6463),
    [anon_sym_PIPE_PIPE] = ACTIONS(6465),
    [anon_sym_AMP_AMP] = ACTIONS(6465),
    [anon_sym_PIPE] = ACTIONS(6463),
    [anon_sym_CARET] = ACTIONS(6463),
    [anon_sym_AMP] = ACTIONS(6463),
    [anon_sym_EQ_EQ] = ACTIONS(6465),
    [anon_sym_BANG_EQ] = ACTIONS(6465),
    [anon_sym_GT] = ACTIONS(6463),
    [anon_sym_GT_EQ] = ACTIONS(6465),
    [anon_sym_LT_EQ] = ACTIONS(6463),
    [anon_sym_LT] = ACTIONS(6463),
    [anon_sym_LT_LT] = ACTIONS(6463),
    [anon_sym_GT_GT] = ACTIONS(6463),
    [anon_sym_SEMI] = ACTIONS(6465),
    [anon_sym___attribute__] = ACTIONS(6463),
    [anon_sym___attribute] = ACTIONS(6463),
    [anon_sym_LBRACK] = ACTIONS(6465),
    [anon_sym_EQ] = ACTIONS(6463),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_STAR_EQ] = ACTIONS(6465),
    [anon_sym_SLASH_EQ] = ACTIONS(6465),
    [anon_sym_PERCENT_EQ] = ACTIONS(6465),
    [anon_sym_PLUS_EQ] = ACTIONS(6465),
    [anon_sym_DASH_EQ] = ACTIONS(6465),
    [anon_sym_LT_LT_EQ] = ACTIONS(6465),
    [anon_sym_GT_GT_EQ] = ACTIONS(6465),
    [anon_sym_AMP_EQ] = ACTIONS(6465),
    [anon_sym_CARET_EQ] = ACTIONS(6465),
    [anon_sym_PIPE_EQ] = ACTIONS(6465),
    [anon_sym_and_eq] = ACTIONS(6463),
    [anon_sym_or_eq] = ACTIONS(6463),
    [anon_sym_xor_eq] = ACTIONS(6463),
    [anon_sym_LT_EQ_GT] = ACTIONS(6465),
    [anon_sym_or] = ACTIONS(6463),
    [anon_sym_and] = ACTIONS(6463),
    [anon_sym_bitor] = ACTIONS(6463),
    [anon_sym_xor] = ACTIONS(6463),
    [anon_sym_bitand] = ACTIONS(6463),
    [anon_sym_not_eq] = ACTIONS(6463),
    [anon_sym_DASH_DASH] = ACTIONS(6465),
    [anon_sym_PLUS_PLUS] = ACTIONS(6465),
    [anon_sym_DOT] = ACTIONS(6463),
    [anon_sym_DOT_STAR] = ACTIONS(6465),
    [anon_sym_DASH_GT] = ACTIONS(6465),
    [anon_sym_L_DQUOTE] = ACTIONS(6465),
    [anon_sym_u_DQUOTE] = ACTIONS(6465),
    [anon_sym_U_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8_DQUOTE] = ACTIONS(6465),
    [anon_sym_DQUOTE] = ACTIONS(6465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(6465),
    [anon_sym_LR_DQUOTE] = ACTIONS(6465),
    [anon_sym_uR_DQUOTE] = ACTIONS(6465),
    [anon_sym_UR_DQUOTE] = ACTIONS(6465),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6465),
    [sym_literal_suffix] = ACTIONS(6463),
  },
  [2834] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5931),
    [anon_sym_COMMA] = ACTIONS(5931),
    [anon_sym_RPAREN] = ACTIONS(5931),
    [anon_sym_LPAREN2] = ACTIONS(5931),
    [anon_sym_DASH] = ACTIONS(5929),
    [anon_sym_PLUS] = ACTIONS(5929),
    [anon_sym_STAR] = ACTIONS(5929),
    [anon_sym_SLASH] = ACTIONS(5929),
    [anon_sym_PERCENT] = ACTIONS(5929),
    [anon_sym_PIPE_PIPE] = ACTIONS(5931),
    [anon_sym_AMP_AMP] = ACTIONS(5931),
    [anon_sym_PIPE] = ACTIONS(5929),
    [anon_sym_CARET] = ACTIONS(5929),
    [anon_sym_AMP] = ACTIONS(5929),
    [anon_sym_EQ_EQ] = ACTIONS(5931),
    [anon_sym_BANG_EQ] = ACTIONS(5931),
    [anon_sym_GT] = ACTIONS(5929),
    [anon_sym_GT_EQ] = ACTIONS(5931),
    [anon_sym_LT_EQ] = ACTIONS(5929),
    [anon_sym_LT] = ACTIONS(5929),
    [anon_sym_LT_LT] = ACTIONS(5929),
    [anon_sym_GT_GT] = ACTIONS(5929),
    [anon_sym_COLON] = ACTIONS(5931),
    [anon_sym_SEMI] = ACTIONS(5931),
    [anon_sym___attribute__] = ACTIONS(5931),
    [anon_sym___attribute] = ACTIONS(5929),
    [anon_sym_LBRACE] = ACTIONS(5931),
    [anon_sym_RBRACE] = ACTIONS(5931),
    [anon_sym_signed] = ACTIONS(6928),
    [anon_sym_unsigned] = ACTIONS(6928),
    [anon_sym_long] = ACTIONS(6928),
    [anon_sym_short] = ACTIONS(6928),
    [anon_sym_LBRACK] = ACTIONS(5931),
    [anon_sym_RBRACK] = ACTIONS(5931),
    [anon_sym_EQ] = ACTIONS(5929),
    [anon_sym_QMARK] = ACTIONS(5931),
    [anon_sym_STAR_EQ] = ACTIONS(5931),
    [anon_sym_SLASH_EQ] = ACTIONS(5931),
    [anon_sym_PERCENT_EQ] = ACTIONS(5931),
    [anon_sym_PLUS_EQ] = ACTIONS(5931),
    [anon_sym_DASH_EQ] = ACTIONS(5931),
    [anon_sym_LT_LT_EQ] = ACTIONS(5931),
    [anon_sym_GT_GT_EQ] = ACTIONS(5931),
    [anon_sym_AMP_EQ] = ACTIONS(5931),
    [anon_sym_CARET_EQ] = ACTIONS(5931),
    [anon_sym_PIPE_EQ] = ACTIONS(5931),
    [anon_sym_and_eq] = ACTIONS(5931),
    [anon_sym_or_eq] = ACTIONS(5931),
    [anon_sym_xor_eq] = ACTIONS(5931),
    [anon_sym_LT_EQ_GT] = ACTIONS(5931),
    [anon_sym_or] = ACTIONS(5929),
    [anon_sym_and] = ACTIONS(5929),
    [anon_sym_bitor] = ACTIONS(5931),
    [anon_sym_xor] = ACTIONS(5929),
    [anon_sym_bitand] = ACTIONS(5931),
    [anon_sym_not_eq] = ACTIONS(5931),
    [anon_sym_DASH_DASH] = ACTIONS(5931),
    [anon_sym_PLUS_PLUS] = ACTIONS(5931),
    [anon_sym_DOT] = ACTIONS(5929),
    [anon_sym_DOT_STAR] = ACTIONS(5931),
    [anon_sym_DASH_GT] = ACTIONS(5931),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5931),
    [anon_sym_decltype] = ACTIONS(5931),
  },
  [2835] = {
    [sym_attribute_specifier] = STATE(2553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6185),
    [anon_sym_COMMA] = ACTIONS(6185),
    [anon_sym_RPAREN] = ACTIONS(6185),
    [anon_sym_LPAREN2] = ACTIONS(6185),
    [anon_sym_DASH] = ACTIONS(6183),
    [anon_sym_PLUS] = ACTIONS(6183),
    [anon_sym_STAR] = ACTIONS(6185),
    [anon_sym_SLASH] = ACTIONS(6183),
    [anon_sym_PERCENT] = ACTIONS(6185),
    [anon_sym_PIPE_PIPE] = ACTIONS(6185),
    [anon_sym_AMP_AMP] = ACTIONS(6185),
    [anon_sym_PIPE] = ACTIONS(6183),
    [anon_sym_CARET] = ACTIONS(6185),
    [anon_sym_AMP] = ACTIONS(6183),
    [anon_sym_EQ_EQ] = ACTIONS(6185),
    [anon_sym_BANG_EQ] = ACTIONS(6185),
    [anon_sym_GT] = ACTIONS(6183),
    [anon_sym_GT_EQ] = ACTIONS(6185),
    [anon_sym_LT_EQ] = ACTIONS(6183),
    [anon_sym_LT] = ACTIONS(6183),
    [anon_sym_LT_LT] = ACTIONS(6185),
    [anon_sym_GT_GT] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym___extension__] = ACTIONS(6185),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_RBRACE] = ACTIONS(6185),
    [anon_sym_LBRACK] = ACTIONS(6185),
    [anon_sym_RBRACK] = ACTIONS(6185),
    [anon_sym_const] = ACTIONS(6183),
    [anon_sym_constexpr] = ACTIONS(6185),
    [anon_sym_volatile] = ACTIONS(6185),
    [anon_sym_restrict] = ACTIONS(6185),
    [anon_sym___restrict__] = ACTIONS(6185),
    [anon_sym__Atomic] = ACTIONS(6185),
    [anon_sym__Noreturn] = ACTIONS(6185),
    [anon_sym_noreturn] = ACTIONS(6185),
    [anon_sym__Nonnull] = ACTIONS(6185),
    [anon_sym_mutable] = ACTIONS(6185),
    [anon_sym_constinit] = ACTIONS(6185),
    [anon_sym_consteval] = ACTIONS(6185),
    [anon_sym_alignas] = ACTIONS(6185),
    [anon_sym__Alignas] = ACTIONS(6185),
    [anon_sym_QMARK] = ACTIONS(6185),
    [anon_sym_LT_EQ_GT] = ACTIONS(6185),
    [anon_sym_or] = ACTIONS(6185),
    [anon_sym_and] = ACTIONS(6185),
    [anon_sym_bitor] = ACTIONS(6185),
    [anon_sym_xor] = ACTIONS(6185),
    [anon_sym_bitand] = ACTIONS(6185),
    [anon_sym_not_eq] = ACTIONS(6185),
    [anon_sym_DASH_DASH] = ACTIONS(6185),
    [anon_sym_PLUS_PLUS] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6183),
    [anon_sym_DOT_STAR] = ACTIONS(6185),
    [anon_sym_DASH_GT] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6185),
    [anon_sym_decltype] = ACTIONS(6185),
    [anon_sym_final] = ACTIONS(6185),
    [anon_sym_override] = ACTIONS(6185),
    [anon_sym_requires] = ACTIONS(6185),
  },
  [2836] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2819),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5886),
    [anon_sym_COMMA] = ACTIONS(5886),
    [anon_sym_RPAREN] = ACTIONS(5886),
    [anon_sym_LPAREN2] = ACTIONS(5886),
    [anon_sym_DASH] = ACTIONS(5884),
    [anon_sym_PLUS] = ACTIONS(5884),
    [anon_sym_STAR] = ACTIONS(5884),
    [anon_sym_SLASH] = ACTIONS(5884),
    [anon_sym_PERCENT] = ACTIONS(5884),
    [anon_sym_PIPE_PIPE] = ACTIONS(5886),
    [anon_sym_AMP_AMP] = ACTIONS(5886),
    [anon_sym_PIPE] = ACTIONS(5884),
    [anon_sym_CARET] = ACTIONS(5884),
    [anon_sym_AMP] = ACTIONS(5884),
    [anon_sym_EQ_EQ] = ACTIONS(5886),
    [anon_sym_BANG_EQ] = ACTIONS(5886),
    [anon_sym_GT] = ACTIONS(5884),
    [anon_sym_GT_EQ] = ACTIONS(5886),
    [anon_sym_LT_EQ] = ACTIONS(5884),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(5884),
    [anon_sym_GT_GT] = ACTIONS(5884),
    [anon_sym_COLON] = ACTIONS(5886),
    [anon_sym_SEMI] = ACTIONS(5886),
    [anon_sym___attribute__] = ACTIONS(5886),
    [anon_sym___attribute] = ACTIONS(5884),
    [anon_sym_LBRACE] = ACTIONS(5886),
    [anon_sym_RBRACE] = ACTIONS(5886),
    [anon_sym_signed] = ACTIONS(6930),
    [anon_sym_unsigned] = ACTIONS(6930),
    [anon_sym_long] = ACTIONS(6930),
    [anon_sym_short] = ACTIONS(6930),
    [anon_sym_LBRACK] = ACTIONS(5886),
    [anon_sym_RBRACK] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(5884),
    [anon_sym_QMARK] = ACTIONS(5886),
    [anon_sym_STAR_EQ] = ACTIONS(5886),
    [anon_sym_SLASH_EQ] = ACTIONS(5886),
    [anon_sym_PERCENT_EQ] = ACTIONS(5886),
    [anon_sym_PLUS_EQ] = ACTIONS(5886),
    [anon_sym_DASH_EQ] = ACTIONS(5886),
    [anon_sym_LT_LT_EQ] = ACTIONS(5886),
    [anon_sym_GT_GT_EQ] = ACTIONS(5886),
    [anon_sym_AMP_EQ] = ACTIONS(5886),
    [anon_sym_CARET_EQ] = ACTIONS(5886),
    [anon_sym_PIPE_EQ] = ACTIONS(5886),
    [anon_sym_and_eq] = ACTIONS(5886),
    [anon_sym_or_eq] = ACTIONS(5886),
    [anon_sym_xor_eq] = ACTIONS(5886),
    [anon_sym_LT_EQ_GT] = ACTIONS(5886),
    [anon_sym_or] = ACTIONS(5884),
    [anon_sym_and] = ACTIONS(5884),
    [anon_sym_bitor] = ACTIONS(5886),
    [anon_sym_xor] = ACTIONS(5884),
    [anon_sym_bitand] = ACTIONS(5886),
    [anon_sym_not_eq] = ACTIONS(5886),
    [anon_sym_DASH_DASH] = ACTIONS(5886),
    [anon_sym_PLUS_PLUS] = ACTIONS(5886),
    [anon_sym_DOT] = ACTIONS(5884),
    [anon_sym_DOT_STAR] = ACTIONS(5886),
    [anon_sym_DASH_GT] = ACTIONS(5886),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5886),
    [anon_sym_decltype] = ACTIONS(5886),
  },
  [2837] = {
    [sym_attribute_specifier] = STATE(2565),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6181),
    [anon_sym_COMMA] = ACTIONS(6181),
    [anon_sym_RPAREN] = ACTIONS(6181),
    [anon_sym_LPAREN2] = ACTIONS(6181),
    [anon_sym_DASH] = ACTIONS(6179),
    [anon_sym_PLUS] = ACTIONS(6179),
    [anon_sym_STAR] = ACTIONS(6181),
    [anon_sym_SLASH] = ACTIONS(6179),
    [anon_sym_PERCENT] = ACTIONS(6181),
    [anon_sym_PIPE_PIPE] = ACTIONS(6181),
    [anon_sym_AMP_AMP] = ACTIONS(6181),
    [anon_sym_PIPE] = ACTIONS(6179),
    [anon_sym_CARET] = ACTIONS(6181),
    [anon_sym_AMP] = ACTIONS(6179),
    [anon_sym_EQ_EQ] = ACTIONS(6181),
    [anon_sym_BANG_EQ] = ACTIONS(6181),
    [anon_sym_GT] = ACTIONS(6179),
    [anon_sym_GT_EQ] = ACTIONS(6181),
    [anon_sym_LT_EQ] = ACTIONS(6179),
    [anon_sym_LT] = ACTIONS(6179),
    [anon_sym_LT_LT] = ACTIONS(6181),
    [anon_sym_GT_GT] = ACTIONS(6181),
    [anon_sym_COLON] = ACTIONS(6181),
    [anon_sym_SEMI] = ACTIONS(6181),
    [anon_sym___extension__] = ACTIONS(6181),
    [anon_sym___attribute__] = ACTIONS(6632),
    [anon_sym___attribute] = ACTIONS(6634),
    [anon_sym_LBRACE] = ACTIONS(6181),
    [anon_sym_RBRACE] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6181),
    [anon_sym_RBRACK] = ACTIONS(6181),
    [anon_sym_const] = ACTIONS(6179),
    [anon_sym_constexpr] = ACTIONS(6181),
    [anon_sym_volatile] = ACTIONS(6181),
    [anon_sym_restrict] = ACTIONS(6181),
    [anon_sym___restrict__] = ACTIONS(6181),
    [anon_sym__Atomic] = ACTIONS(6181),
    [anon_sym__Noreturn] = ACTIONS(6181),
    [anon_sym_noreturn] = ACTIONS(6181),
    [anon_sym__Nonnull] = ACTIONS(6181),
    [anon_sym_mutable] = ACTIONS(6181),
    [anon_sym_constinit] = ACTIONS(6181),
    [anon_sym_consteval] = ACTIONS(6181),
    [anon_sym_alignas] = ACTIONS(6181),
    [anon_sym__Alignas] = ACTIONS(6181),
    [anon_sym_QMARK] = ACTIONS(6181),
    [anon_sym_LT_EQ_GT] = ACTIONS(6181),
    [anon_sym_or] = ACTIONS(6181),
    [anon_sym_and] = ACTIONS(6181),
    [anon_sym_bitor] = ACTIONS(6181),
    [anon_sym_xor] = ACTIONS(6181),
    [anon_sym_bitand] = ACTIONS(6181),
    [anon_sym_not_eq] = ACTIONS(6181),
    [anon_sym_DASH_DASH] = ACTIONS(6181),
    [anon_sym_PLUS_PLUS] = ACTIONS(6181),
    [anon_sym_DOT] = ACTIONS(6179),
    [anon_sym_DOT_STAR] = ACTIONS(6181),
    [anon_sym_DASH_GT] = ACTIONS(6181),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6181),
    [anon_sym_decltype] = ACTIONS(6181),
    [anon_sym_final] = ACTIONS(6181),
    [anon_sym_override] = ACTIONS(6181),
    [anon_sym_requires] = ACTIONS(6181),
  },
  [2838] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5941),
    [anon_sym_COMMA] = ACTIONS(5941),
    [anon_sym_RPAREN] = ACTIONS(5941),
    [anon_sym_LPAREN2] = ACTIONS(5941),
    [anon_sym_DASH] = ACTIONS(5939),
    [anon_sym_PLUS] = ACTIONS(5939),
    [anon_sym_STAR] = ACTIONS(5939),
    [anon_sym_SLASH] = ACTIONS(5939),
    [anon_sym_PERCENT] = ACTIONS(5939),
    [anon_sym_PIPE_PIPE] = ACTIONS(5941),
    [anon_sym_AMP_AMP] = ACTIONS(5941),
    [anon_sym_PIPE] = ACTIONS(5939),
    [anon_sym_CARET] = ACTIONS(5939),
    [anon_sym_AMP] = ACTIONS(5939),
    [anon_sym_EQ_EQ] = ACTIONS(5941),
    [anon_sym_BANG_EQ] = ACTIONS(5941),
    [anon_sym_GT] = ACTIONS(5939),
    [anon_sym_GT_EQ] = ACTIONS(5941),
    [anon_sym_LT_EQ] = ACTIONS(5939),
    [anon_sym_LT] = ACTIONS(5939),
    [anon_sym_LT_LT] = ACTIONS(5939),
    [anon_sym_GT_GT] = ACTIONS(5939),
    [anon_sym_COLON] = ACTIONS(5941),
    [anon_sym_SEMI] = ACTIONS(5941),
    [anon_sym___attribute__] = ACTIONS(5941),
    [anon_sym___attribute] = ACTIONS(5939),
    [anon_sym_LBRACE] = ACTIONS(5941),
    [anon_sym_RBRACE] = ACTIONS(5941),
    [anon_sym_signed] = ACTIONS(6932),
    [anon_sym_unsigned] = ACTIONS(6932),
    [anon_sym_long] = ACTIONS(6932),
    [anon_sym_short] = ACTIONS(6932),
    [anon_sym_LBRACK] = ACTIONS(5941),
    [anon_sym_RBRACK] = ACTIONS(5941),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(5941),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(5941),
    [anon_sym_or] = ACTIONS(5939),
    [anon_sym_and] = ACTIONS(5939),
    [anon_sym_bitor] = ACTIONS(5941),
    [anon_sym_xor] = ACTIONS(5939),
    [anon_sym_bitand] = ACTIONS(5941),
    [anon_sym_not_eq] = ACTIONS(5941),
    [anon_sym_DASH_DASH] = ACTIONS(5941),
    [anon_sym_PLUS_PLUS] = ACTIONS(5941),
    [anon_sym_DOT] = ACTIONS(5939),
    [anon_sym_DOT_STAR] = ACTIONS(5941),
    [anon_sym_DASH_GT] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5941),
    [anon_sym_decltype] = ACTIONS(5941),
  },
  [2839] = {
    [sym_identifier] = ACTIONS(6934),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6936),
    [anon_sym_COMMA] = ACTIONS(6936),
    [anon_sym_RPAREN] = ACTIONS(6936),
    [aux_sym_preproc_if_token2] = ACTIONS(6936),
    [aux_sym_preproc_else_token1] = ACTIONS(6936),
    [aux_sym_preproc_elif_token1] = ACTIONS(6934),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6936),
    [anon_sym_LPAREN2] = ACTIONS(6936),
    [anon_sym_DASH] = ACTIONS(6934),
    [anon_sym_PLUS] = ACTIONS(6934),
    [anon_sym_STAR] = ACTIONS(6934),
    [anon_sym_SLASH] = ACTIONS(6934),
    [anon_sym_PERCENT] = ACTIONS(6934),
    [anon_sym_PIPE_PIPE] = ACTIONS(6936),
    [anon_sym_AMP_AMP] = ACTIONS(6936),
    [anon_sym_PIPE] = ACTIONS(6934),
    [anon_sym_CARET] = ACTIONS(6934),
    [anon_sym_AMP] = ACTIONS(6934),
    [anon_sym_EQ_EQ] = ACTIONS(6936),
    [anon_sym_BANG_EQ] = ACTIONS(6936),
    [anon_sym_GT] = ACTIONS(6934),
    [anon_sym_GT_EQ] = ACTIONS(6936),
    [anon_sym_LT_EQ] = ACTIONS(6934),
    [anon_sym_LT] = ACTIONS(6934),
    [anon_sym_LT_LT] = ACTIONS(6934),
    [anon_sym_GT_GT] = ACTIONS(6934),
    [anon_sym_COLON] = ACTIONS(6934),
    [anon_sym_SEMI] = ACTIONS(6936),
    [anon_sym___attribute__] = ACTIONS(6934),
    [anon_sym___attribute] = ACTIONS(6934),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(6936),
    [anon_sym_RBRACE] = ACTIONS(6936),
    [anon_sym_LBRACK] = ACTIONS(6936),
    [anon_sym_RBRACK] = ACTIONS(6936),
    [anon_sym_EQ] = ACTIONS(6934),
    [anon_sym_QMARK] = ACTIONS(6936),
    [anon_sym_STAR_EQ] = ACTIONS(6936),
    [anon_sym_SLASH_EQ] = ACTIONS(6936),
    [anon_sym_PERCENT_EQ] = ACTIONS(6936),
    [anon_sym_PLUS_EQ] = ACTIONS(6936),
    [anon_sym_DASH_EQ] = ACTIONS(6936),
    [anon_sym_LT_LT_EQ] = ACTIONS(6936),
    [anon_sym_GT_GT_EQ] = ACTIONS(6936),
    [anon_sym_AMP_EQ] = ACTIONS(6936),
    [anon_sym_CARET_EQ] = ACTIONS(6936),
    [anon_sym_PIPE_EQ] = ACTIONS(6936),
    [anon_sym_and_eq] = ACTIONS(6934),
    [anon_sym_or_eq] = ACTIONS(6934),
    [anon_sym_xor_eq] = ACTIONS(6934),
    [anon_sym_LT_EQ_GT] = ACTIONS(6936),
    [anon_sym_or] = ACTIONS(6934),
    [anon_sym_and] = ACTIONS(6934),
    [anon_sym_bitor] = ACTIONS(6934),
    [anon_sym_xor] = ACTIONS(6934),
    [anon_sym_bitand] = ACTIONS(6934),
    [anon_sym_not_eq] = ACTIONS(6934),
    [anon_sym_DASH_DASH] = ACTIONS(6936),
    [anon_sym_PLUS_PLUS] = ACTIONS(6936),
    [anon_sym_DOT] = ACTIONS(6934),
    [anon_sym_DOT_STAR] = ACTIONS(6936),
    [anon_sym_DASH_GT] = ACTIONS(6936),
    [sym_comment] = ACTIONS(3),
  },
  [2840] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5898),
    [anon_sym_COMMA] = ACTIONS(5898),
    [anon_sym_RPAREN] = ACTIONS(5898),
    [anon_sym_LPAREN2] = ACTIONS(5898),
    [anon_sym_DASH] = ACTIONS(5896),
    [anon_sym_PLUS] = ACTIONS(5896),
    [anon_sym_STAR] = ACTIONS(5896),
    [anon_sym_SLASH] = ACTIONS(5896),
    [anon_sym_PERCENT] = ACTIONS(5896),
    [anon_sym_PIPE_PIPE] = ACTIONS(5898),
    [anon_sym_AMP_AMP] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5896),
    [anon_sym_CARET] = ACTIONS(5896),
    [anon_sym_AMP] = ACTIONS(5896),
    [anon_sym_EQ_EQ] = ACTIONS(5898),
    [anon_sym_BANG_EQ] = ACTIONS(5898),
    [anon_sym_GT] = ACTIONS(5896),
    [anon_sym_GT_EQ] = ACTIONS(5898),
    [anon_sym_LT_EQ] = ACTIONS(5896),
    [anon_sym_LT] = ACTIONS(5896),
    [anon_sym_LT_LT] = ACTIONS(5896),
    [anon_sym_GT_GT] = ACTIONS(5896),
    [anon_sym_COLON] = ACTIONS(5898),
    [anon_sym_SEMI] = ACTIONS(5898),
    [anon_sym___attribute__] = ACTIONS(5898),
    [anon_sym___attribute] = ACTIONS(5896),
    [anon_sym_LBRACE] = ACTIONS(5898),
    [anon_sym_RBRACE] = ACTIONS(5898),
    [anon_sym_signed] = ACTIONS(6938),
    [anon_sym_unsigned] = ACTIONS(6938),
    [anon_sym_long] = ACTIONS(6938),
    [anon_sym_short] = ACTIONS(6938),
    [anon_sym_LBRACK] = ACTIONS(5898),
    [anon_sym_RBRACK] = ACTIONS(5898),
    [anon_sym_EQ] = ACTIONS(5896),
    [anon_sym_QMARK] = ACTIONS(5898),
    [anon_sym_STAR_EQ] = ACTIONS(5898),
    [anon_sym_SLASH_EQ] = ACTIONS(5898),
    [anon_sym_PERCENT_EQ] = ACTIONS(5898),
    [anon_sym_PLUS_EQ] = ACTIONS(5898),
    [anon_sym_DASH_EQ] = ACTIONS(5898),
    [anon_sym_LT_LT_EQ] = ACTIONS(5898),
    [anon_sym_GT_GT_EQ] = ACTIONS(5898),
    [anon_sym_AMP_EQ] = ACTIONS(5898),
    [anon_sym_CARET_EQ] = ACTIONS(5898),
    [anon_sym_PIPE_EQ] = ACTIONS(5898),
    [anon_sym_and_eq] = ACTIONS(5898),
    [anon_sym_or_eq] = ACTIONS(5898),
    [anon_sym_xor_eq] = ACTIONS(5898),
    [anon_sym_LT_EQ_GT] = ACTIONS(5898),
    [anon_sym_or] = ACTIONS(5896),
    [anon_sym_and] = ACTIONS(5896),
    [anon_sym_bitor] = ACTIONS(5898),
    [anon_sym_xor] = ACTIONS(5896),
    [anon_sym_bitand] = ACTIONS(5898),
    [anon_sym_not_eq] = ACTIONS(5898),
    [anon_sym_DASH_DASH] = ACTIONS(5898),
    [anon_sym_PLUS_PLUS] = ACTIONS(5898),
    [anon_sym_DOT] = ACTIONS(5896),
    [anon_sym_DOT_STAR] = ACTIONS(5898),
    [anon_sym_DASH_GT] = ACTIONS(5898),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5898),
    [anon_sym_decltype] = ACTIONS(5898),
  },
  [2841] = {
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4451),
    [anon_sym_COMMA] = ACTIONS(4451),
    [anon_sym_RPAREN] = ACTIONS(4451),
    [aux_sym_preproc_if_token2] = ACTIONS(4451),
    [aux_sym_preproc_else_token1] = ACTIONS(4451),
    [aux_sym_preproc_elif_token1] = ACTIONS(4456),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4451),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4451),
    [anon_sym_LPAREN2] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_STAR] = ACTIONS(4456),
    [anon_sym_SLASH] = ACTIONS(4456),
    [anon_sym_PERCENT] = ACTIONS(4456),
    [anon_sym_PIPE_PIPE] = ACTIONS(4451),
    [anon_sym_AMP_AMP] = ACTIONS(4451),
    [anon_sym_PIPE] = ACTIONS(4456),
    [anon_sym_CARET] = ACTIONS(4456),
    [anon_sym_AMP] = ACTIONS(4456),
    [anon_sym_EQ_EQ] = ACTIONS(4451),
    [anon_sym_BANG_EQ] = ACTIONS(4451),
    [anon_sym_GT] = ACTIONS(4456),
    [anon_sym_GT_EQ] = ACTIONS(4451),
    [anon_sym_LT_EQ] = ACTIONS(4456),
    [anon_sym_LT] = ACTIONS(4456),
    [anon_sym_LT_LT] = ACTIONS(4456),
    [anon_sym_GT_GT] = ACTIONS(4456),
    [anon_sym_COLON] = ACTIONS(4456),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym___attribute__] = ACTIONS(4456),
    [anon_sym___attribute] = ACTIONS(4456),
    [anon_sym_COLON_COLON] = ACTIONS(2040),
    [anon_sym_LBRACE] = ACTIONS(2040),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_LBRACK] = ACTIONS(4451),
    [anon_sym_RBRACK] = ACTIONS(4451),
    [anon_sym_EQ] = ACTIONS(4456),
    [anon_sym_QMARK] = ACTIONS(4451),
    [anon_sym_STAR_EQ] = ACTIONS(4451),
    [anon_sym_SLASH_EQ] = ACTIONS(4451),
    [anon_sym_PERCENT_EQ] = ACTIONS(4451),
    [anon_sym_PLUS_EQ] = ACTIONS(4451),
    [anon_sym_DASH_EQ] = ACTIONS(4451),
    [anon_sym_LT_LT_EQ] = ACTIONS(4451),
    [anon_sym_GT_GT_EQ] = ACTIONS(4451),
    [anon_sym_AMP_EQ] = ACTIONS(4451),
    [anon_sym_CARET_EQ] = ACTIONS(4451),
    [anon_sym_PIPE_EQ] = ACTIONS(4451),
    [anon_sym_and_eq] = ACTIONS(4456),
    [anon_sym_or_eq] = ACTIONS(4456),
    [anon_sym_xor_eq] = ACTIONS(4456),
    [anon_sym_LT_EQ_GT] = ACTIONS(4451),
    [anon_sym_or] = ACTIONS(4456),
    [anon_sym_and] = ACTIONS(4456),
    [anon_sym_bitor] = ACTIONS(4456),
    [anon_sym_xor] = ACTIONS(4456),
    [anon_sym_bitand] = ACTIONS(4456),
    [anon_sym_not_eq] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4451),
    [anon_sym_PLUS_PLUS] = ACTIONS(4451),
    [anon_sym_DOT] = ACTIONS(4456),
    [anon_sym_DOT_STAR] = ACTIONS(4451),
    [anon_sym_DASH_GT] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
  },
  [2842] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5904),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_RPAREN] = ACTIONS(5904),
    [anon_sym_LPAREN2] = ACTIONS(5904),
    [anon_sym_DASH] = ACTIONS(5902),
    [anon_sym_PLUS] = ACTIONS(5902),
    [anon_sym_STAR] = ACTIONS(5902),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [anon_sym_PIPE_PIPE] = ACTIONS(5904),
    [anon_sym_AMP_AMP] = ACTIONS(5904),
    [anon_sym_PIPE] = ACTIONS(5902),
    [anon_sym_CARET] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5902),
    [anon_sym_EQ_EQ] = ACTIONS(5904),
    [anon_sym_BANG_EQ] = ACTIONS(5904),
    [anon_sym_GT] = ACTIONS(5902),
    [anon_sym_GT_EQ] = ACTIONS(5904),
    [anon_sym_LT_EQ] = ACTIONS(5902),
    [anon_sym_LT] = ACTIONS(5902),
    [anon_sym_LT_LT] = ACTIONS(5902),
    [anon_sym_GT_GT] = ACTIONS(5902),
    [anon_sym_COLON] = ACTIONS(5904),
    [anon_sym_SEMI] = ACTIONS(5904),
    [anon_sym___attribute__] = ACTIONS(5904),
    [anon_sym___attribute] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(5904),
    [anon_sym_RBRACE] = ACTIONS(5904),
    [anon_sym_signed] = ACTIONS(6886),
    [anon_sym_unsigned] = ACTIONS(6886),
    [anon_sym_long] = ACTIONS(6886),
    [anon_sym_short] = ACTIONS(6886),
    [anon_sym_LBRACK] = ACTIONS(5904),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_EQ] = ACTIONS(5902),
    [anon_sym_QMARK] = ACTIONS(5904),
    [anon_sym_STAR_EQ] = ACTIONS(5904),
    [anon_sym_SLASH_EQ] = ACTIONS(5904),
    [anon_sym_PERCENT_EQ] = ACTIONS(5904),
    [anon_sym_PLUS_EQ] = ACTIONS(5904),
    [anon_sym_DASH_EQ] = ACTIONS(5904),
    [anon_sym_LT_LT_EQ] = ACTIONS(5904),
    [anon_sym_GT_GT_EQ] = ACTIONS(5904),
    [anon_sym_AMP_EQ] = ACTIONS(5904),
    [anon_sym_CARET_EQ] = ACTIONS(5904),
    [anon_sym_PIPE_EQ] = ACTIONS(5904),
    [anon_sym_and_eq] = ACTIONS(5904),
    [anon_sym_or_eq] = ACTIONS(5904),
    [anon_sym_xor_eq] = ACTIONS(5904),
    [anon_sym_LT_EQ_GT] = ACTIONS(5904),
    [anon_sym_or] = ACTIONS(5902),
    [anon_sym_and] = ACTIONS(5902),
    [anon_sym_bitor] = ACTIONS(5904),
    [anon_sym_xor] = ACTIONS(5902),
    [anon_sym_bitand] = ACTIONS(5904),
    [anon_sym_not_eq] = ACTIONS(5904),
    [anon_sym_DASH_DASH] = ACTIONS(5904),
    [anon_sym_PLUS_PLUS] = ACTIONS(5904),
    [anon_sym_DOT] = ACTIONS(5902),
    [anon_sym_DOT_STAR] = ACTIONS(5904),
    [anon_sym_DASH_GT] = ACTIONS(5904),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5904),
    [anon_sym_decltype] = ACTIONS(5904),
  },
  [2843] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5927),
    [anon_sym_COMMA] = ACTIONS(5927),
    [anon_sym_RPAREN] = ACTIONS(5927),
    [anon_sym_LPAREN2] = ACTIONS(5927),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_PLUS] = ACTIONS(5925),
    [anon_sym_STAR] = ACTIONS(5925),
    [anon_sym_SLASH] = ACTIONS(5925),
    [anon_sym_PERCENT] = ACTIONS(5925),
    [anon_sym_PIPE_PIPE] = ACTIONS(5927),
    [anon_sym_AMP_AMP] = ACTIONS(5927),
    [anon_sym_PIPE] = ACTIONS(5925),
    [anon_sym_CARET] = ACTIONS(5925),
    [anon_sym_AMP] = ACTIONS(5925),
    [anon_sym_EQ_EQ] = ACTIONS(5927),
    [anon_sym_BANG_EQ] = ACTIONS(5927),
    [anon_sym_GT] = ACTIONS(5925),
    [anon_sym_GT_EQ] = ACTIONS(5927),
    [anon_sym_LT_EQ] = ACTIONS(5925),
    [anon_sym_LT] = ACTIONS(5925),
    [anon_sym_LT_LT] = ACTIONS(5925),
    [anon_sym_GT_GT] = ACTIONS(5925),
    [anon_sym_COLON] = ACTIONS(5927),
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym___attribute__] = ACTIONS(5927),
    [anon_sym___attribute] = ACTIONS(5925),
    [anon_sym_LBRACE] = ACTIONS(5927),
    [anon_sym_RBRACE] = ACTIONS(5927),
    [anon_sym_signed] = ACTIONS(6890),
    [anon_sym_unsigned] = ACTIONS(6890),
    [anon_sym_long] = ACTIONS(6890),
    [anon_sym_short] = ACTIONS(6890),
    [anon_sym_LBRACK] = ACTIONS(5927),
    [anon_sym_RBRACK] = ACTIONS(5927),
    [anon_sym_EQ] = ACTIONS(5925),
    [anon_sym_QMARK] = ACTIONS(5927),
    [anon_sym_STAR_EQ] = ACTIONS(5927),
    [anon_sym_SLASH_EQ] = ACTIONS(5927),
    [anon_sym_PERCENT_EQ] = ACTIONS(5927),
    [anon_sym_PLUS_EQ] = ACTIONS(5927),
    [anon_sym_DASH_EQ] = ACTIONS(5927),
    [anon_sym_LT_LT_EQ] = ACTIONS(5927),
    [anon_sym_GT_GT_EQ] = ACTIONS(5927),
    [anon_sym_AMP_EQ] = ACTIONS(5927),
    [anon_sym_CARET_EQ] = ACTIONS(5927),
    [anon_sym_PIPE_EQ] = ACTIONS(5927),
    [anon_sym_and_eq] = ACTIONS(5927),
    [anon_sym_or_eq] = ACTIONS(5927),
    [anon_sym_xor_eq] = ACTIONS(5927),
    [anon_sym_LT_EQ_GT] = ACTIONS(5927),
    [anon_sym_or] = ACTIONS(5925),
    [anon_sym_and] = ACTIONS(5925),
    [anon_sym_bitor] = ACTIONS(5927),
    [anon_sym_xor] = ACTIONS(5925),
    [anon_sym_bitand] = ACTIONS(5927),
    [anon_sym_not_eq] = ACTIONS(5927),
    [anon_sym_DASH_DASH] = ACTIONS(5927),
    [anon_sym_PLUS_PLUS] = ACTIONS(5927),
    [anon_sym_DOT] = ACTIONS(5925),
    [anon_sym_DOT_STAR] = ACTIONS(5927),
    [anon_sym_DASH_GT] = ACTIONS(5927),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5927),
    [anon_sym_decltype] = ACTIONS(5927),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6942), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6948), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6952), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2742), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5859), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6954), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6956), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6948), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2636), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6629), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5743), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5875), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5872), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6958), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6960), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6962), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6964), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [651] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6968), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6978), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [888] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3200), 1,
      sym_field_declaration_list,
    STATE(3388), 1,
      sym_attribute_specifier,
    STATE(7164), 1,
      sym_virtual_specifier,
    STATE(8033), 1,
      sym_base_class_clause,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5866), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5868), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6988), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6410), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3880), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6992), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1261] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(6994), 1,
      anon_sym_COLON,
    ACTIONS(6996), 1,
      anon_sym___attribute__,
    STATE(2356), 1,
      sym_attribute_specifier,
    STATE(2367), 1,
      sym__enum_base_clause,
    STATE(2412), 1,
      sym_enumerator_list,
    ACTIONS(6293), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(6295), 49,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [1346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6948), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1488] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7000), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [1644] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5521), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(6994), 1,
      anon_sym_COLON,
    ACTIONS(6996), 1,
      anon_sym___attribute__,
    STATE(2364), 1,
      sym_attribute_specifier,
    STATE(2372), 1,
      sym__enum_base_clause,
    STATE(2408), 1,
      sym_enumerator_list,
    ACTIONS(6303), 7,
      anon_sym_AMP,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_line,
      anon_sym_triangle,
    ACTIONS(6305), 49,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_triangleadj,
      anon_sym_lineadj,
  [1729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7004), 1,
      sym_identifier,
    STATE(2875), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4320), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4322), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6419), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6417), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [1808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3876), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1879] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7008), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7012), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [2049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7016), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2120] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7018), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7020), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [2205] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [2290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7028), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7030), 1,
      sym_identifier,
    STATE(2875), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7033), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7036), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6434), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6432), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [2440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6461), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_LBRACK,
    ACTIONS(4453), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2040), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(2038), 56,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_in,
      anon_sym_out,
      anon_sym_inout,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
      anon_sym_precise,
      anon_sym_shared,
      anon_sym_groupshared,
      anon_sym_uniform,
      anon_sym_row_major,
      anon_sym_column_major,
      anon_sym_globallycoherent,
      anon_sym_centroid,
      anon_sym_noperspective,
      anon_sym_nointerpolation,
      anon_sym_sample,
      anon_sym_linear,
      anon_sym_snorm,
      anon_sym_unorm,
      anon_sym_point,
      anon_sym_line,
      anon_sym_triangleadj,
      anon_sym_lineadj,
      anon_sym_triangle,
  [2657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2728] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2987), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7039), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5793), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [2807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6465), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [2878] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2779), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6780), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6782), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6606), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6604), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [2955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym_LT,
    STATE(2841), 1,
      sym_template_argument_list,
    ACTIONS(7041), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7043), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3030] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7048), 1,
      sym_identifier,
    STATE(2867), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4320), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4322), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6425), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6423), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [3109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7052), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5489), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5493), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5505), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    STATE(2993), 1,
      sym_enumerator_list,
    STATE(3052), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6085), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [3469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7058), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7062), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6410), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [3679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7066), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7070), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3819] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    STATE(3022), 1,
      sym_enumerator_list,
    STATE(3084), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6071), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [3899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7074), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7078), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6625), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7082), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7086), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7090), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7094), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7098), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7102), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7106), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7110), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7114), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2282), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7118), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(3074), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7120), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5793), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [4957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7124), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7128), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6942), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7132), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7136), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7140), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7144), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7148), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7156), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7160), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5509), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1949), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7164), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5937] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6472), 1,
      anon_sym___attribute,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(7166), 1,
      anon_sym_COLON,
    ACTIONS(7168), 1,
      anon_sym___attribute__,
    STATE(2629), 1,
      sym__enum_base_clause,
    STATE(2682), 1,
      sym_enumerator_list,
    STATE(2768), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6305), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [6021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6461), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1945), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5501), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6371] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6472), 1,
      anon_sym___attribute,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(7166), 1,
      anon_sym_COLON,
    ACTIONS(7168), 1,
      anon_sym___attribute__,
    STATE(2640), 1,
      sym__enum_base_clause,
    STATE(2669), 1,
      sym_enumerator_list,
    STATE(2701), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6295), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [6455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [6525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7180), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7184), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6465), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [6735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7188), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4217), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [6945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7192), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4217), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [7225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7196), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7200), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7204), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5477), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5461), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5481), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7208), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5497), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7212), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7216), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_and,
    ACTIONS(5779), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5781), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [8069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7224), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8139] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3246), 1,
      sym_field_declaration_list,
    STATE(3467), 1,
      sym_attribute_specifier,
    STATE(7190), 1,
      sym_virtual_specifier,
    STATE(8025), 1,
      sym_base_class_clause,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5866), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5868), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [8227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5465), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_and,
    ACTIONS(7232), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(5767), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5769), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4396), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5485), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7238), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8585] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6484), 1,
      anon_sym_STAR,
    ACTIONS(6486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6488), 1,
      anon_sym_AMP,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6372), 1,
      sym__declarator,
    STATE(6720), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6538), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6536), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [8705] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6484), 1,
      anon_sym_STAR,
    ACTIONS(6486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6488), 1,
      anon_sym_AMP,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6363), 1,
      sym__declarator,
    STATE(6721), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7242), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7240), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [8825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7244), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7246), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5469), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4428), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5473), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5473), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5473), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [9665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3058), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6189), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [9740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1993), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [9809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1989), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [9878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5921), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5923), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [9951] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3087), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6229), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10026] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7250), 1,
      anon_sym_LT,
    STATE(2987), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3088), 1,
      sym_template_argument_list,
    ACTIONS(7039), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4223), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [10105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3091), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6233), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1973), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3083), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6217), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10324] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3060), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6221), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7252), 1,
      anon_sym_LT,
    STATE(3088), 1,
      sym_template_argument_list,
    ACTIONS(1997), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1999), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [10474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5913), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5915), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [10547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3095), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6237), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5906), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5908), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [10695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3033), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6241), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1977), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3051), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6197), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3085), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6225), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [10989] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    STATE(3076), 1,
      sym_decltype_auto,
    ACTIONS(5985), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5987), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3009), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7259), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5939), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5941), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [11137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3010), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7261), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [11210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1955), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1981), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6461), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [11417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5859), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5947), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2040), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6394), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [11695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3098), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6193), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2013), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3039), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6185), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [11916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5892), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [11989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2019), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5917), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5919), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5925), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5927), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2979), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7263), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5929), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5931), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2989), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7265), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5884), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5886), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7250), 1,
      anon_sym_LT,
    STATE(3088), 1,
      sym_template_argument_list,
    ACTIONS(2005), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2007), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [12427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2019), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12498] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7248), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5935), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5937), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6465), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2029), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12709] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2884), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4320), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4322), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6604), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6606), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [12784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6410), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [12853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3007), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7267), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5904), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [12926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(1985), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    STATE(3096), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6181), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6059), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13138] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7269), 1,
      anon_sym_LT,
    STATE(3074), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3106), 1,
      sym_template_argument_list,
    ACTIONS(7120), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4223), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [13216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3075), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7271), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5929), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5931), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [13288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3077), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7273), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5884), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5886), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [13360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5935), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5937), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [13432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5656), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13500] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7277), 1,
      anon_sym_COLON,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    STATE(3132), 1,
      sym__enum_base_clause,
    STATE(3216), 1,
      sym_enumerator_list,
    STATE(3407), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7281), 1,
      anon_sym_LT,
    STATE(3144), 1,
      sym_template_argument_list,
    ACTIONS(1999), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1997), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [13656] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_STAR,
    ACTIONS(6598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6600), 1,
      anon_sym_AMP,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6372), 1,
      sym__declarator,
    STATE(6800), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6536), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6538), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [13774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7281), 1,
      anon_sym_LT,
    STATE(3144), 1,
      sym_template_argument_list,
    ACTIONS(2007), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2005), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [13848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6109), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6113), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13984] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7283), 1,
      sym_identifier,
    STATE(3086), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4251), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4253), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6425), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6423), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5859), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14128] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_STAR,
    ACTIONS(6598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6600), 1,
      anon_sym_AMP,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6363), 1,
      sym__declarator,
    STATE(6781), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7240), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7242), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [14246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6135), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6043), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14382] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3336), 1,
      sym_field_declaration_list,
    STATE(3787), 1,
      sym_attribute_specifier,
    STATE(7158), 1,
      sym_virtual_specifier,
    STATE(7868), 1,
      sym_base_class_clause,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5866), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5868), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6031), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7291), 1,
      sym_identifier,
    STATE(3042), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7294), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7297), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6434), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6432), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [14612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [14680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [14748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6047), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6047), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5904), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [14956] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(3140), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7302), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5793), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5904), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6105), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6127), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7304), 1,
      anon_sym_LT,
    STATE(3106), 1,
      sym_template_argument_list,
    ACTIONS(1997), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1999), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [15378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2286), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [15514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2290), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6013), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6017), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15718] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6580), 1,
      anon_sym_STAR,
    ACTIONS(6582), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6584), 1,
      anon_sym_AMP,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6363), 1,
      sym__declarator,
    STATE(6786), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7240), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7242), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [15836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5995), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6013), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15972] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6580), 1,
      anon_sym_STAR,
    ACTIONS(6582), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6584), 1,
      anon_sym_AMP,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6372), 1,
      sym__declarator,
    STATE(6813), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6536), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6538), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [16090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(2019), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2013), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6039), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6089), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5859), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5892), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6055), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5999), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6093), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6097), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16776] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7277), 1,
      anon_sym_COLON,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    STATE(3115), 1,
      sym__enum_base_clause,
    STATE(3219), 1,
      sym_enumerator_list,
    STATE(3402), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6305), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5913), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5915), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [16930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5921), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5923), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6063), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5906), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5908), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17142] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5917), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5919), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2424), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5925), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5927), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3078), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7307), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5939), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5941), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3079), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7309), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5898), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6139), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5991), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6021), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6067), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17702] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 1,
      sym_identifier,
    STATE(3042), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4251), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4253), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6419), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6417), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [17778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6143), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2040), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6035), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6047), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6123), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [18188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6077), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [18326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6051), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6131), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2029), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [18530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(6081), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7269), 1,
      anon_sym_LT,
    STATE(3106), 1,
      sym_template_argument_list,
    ACTIONS(2005), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2007), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [18672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6410), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [18739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2029), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [18806] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    ACTIONS(7313), 1,
      anon_sym_COLON,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    STATE(3203), 1,
      sym__enum_base_clause,
    STATE(3245), 1,
      sym_enumerator_list,
    STATE(3456), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6305), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6394), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [18954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3007), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7267), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [19025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2013), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2040), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2019), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19297] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    ACTIONS(7313), 1,
      anon_sym_COLON,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    STATE(3198), 1,
      sym__enum_base_clause,
    STATE(3222), 1,
      sym_enumerator_list,
    STATE(3488), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6295), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6461), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6465), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [19512] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2019), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7317), 1,
      anon_sym_LT,
    STATE(3165), 1,
      sym_template_argument_list,
    ACTIONS(1997), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1999), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1981), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1979), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19719] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    STATE(3207), 1,
      sym_enumerator_list,
    STATE(3335), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6085), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [19795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1985), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1983), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1991), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1987), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [19993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2013), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2011), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7320), 1,
      anon_sym_LT,
    STATE(3165), 1,
      sym_template_argument_list,
    ACTIONS(2005), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2007), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [20133] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7358), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4612), 1,
      sym__function_attributes_start,
    STATE(5109), 1,
      sym_ref_qualifier,
    STATE(5684), 1,
      sym__function_attributes_end,
    STATE(5987), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7351), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5362), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [20253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5921), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5923), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [20323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5906), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5908), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [20393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7365), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7363), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20459] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7369), 1,
      anon_sym_LBRACK,
    ACTIONS(7371), 1,
      sym_auto,
    ACTIONS(7373), 1,
      anon_sym_decltype,
    STATE(3373), 1,
      sym_decltype_auto,
    STATE(3389), 1,
      sym_new_declarator,
    STATE(3685), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6559), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [20541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2017), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2300), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2298), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20673] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4574), 1,
      sym__function_attributes_start,
    STATE(5063), 1,
      sym_ref_qualifier,
    STATE(5714), 1,
      sym__function_attributes_end,
    STATE(5880), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5357), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [20793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7379), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7377), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3068), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7300), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5859), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20929] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7320), 1,
      anon_sym_LT,
    STATE(3140), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3165), 1,
      sym_template_argument_list,
    ACTIONS(7302), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4223), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21005] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    STATE(3196), 1,
      sym_enumerator_list,
    STATE(3394), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6071), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1955), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1953), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21147] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7369), 1,
      anon_sym_LBRACK,
    ACTIONS(7371), 1,
      sym_auto,
    ACTIONS(7373), 1,
      anon_sym_decltype,
    STATE(3367), 1,
      sym_new_declarator,
    STATE(3373), 1,
      sym_decltype_auto,
    STATE(3722), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7383), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7381), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2029), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2027), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21361] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7369), 1,
      anon_sym_LBRACK,
    ACTIONS(7371), 1,
      sym_auto,
    ACTIONS(7373), 1,
      anon_sym_decltype,
    STATE(3332), 1,
      sym_new_declarator,
    STATE(3373), 1,
      sym_decltype_auto,
    STATE(3823), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6547), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7387), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7385), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5892), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5913), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5915), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7369), 1,
      anon_sym_LBRACK,
    ACTIONS(7371), 1,
      sym_auto,
    ACTIONS(7373), 1,
      anon_sym_decltype,
    STATE(3373), 1,
      sym_decltype_auto,
    STATE(3403), 1,
      sym_new_declarator,
    STATE(3786), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [21731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3150), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7389), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5939), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5941), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3151), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7391), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5898), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [21871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2038), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [21937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2019), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2017), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2019), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [22071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2344), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2342), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2019), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2017), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1973), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1971), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5917), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5919), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5925), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5927), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3122), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7393), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5929), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5931), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3123), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7395), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5884), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5886), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2483), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5935), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5937), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7399), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7397), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1977), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(1975), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [22753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7401), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5904), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [22823] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7403), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7405), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [22932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7439), 1,
      anon_sym_LBRACK,
    ACTIONS(7441), 1,
      sym_auto,
    ACTIONS(7443), 1,
      anon_sym_decltype,
    STATE(3424), 1,
      sym_decltype_auto,
    STATE(3437), 1,
      sym_new_declarator,
    STATE(3844), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6573), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [23013] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7445), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7447), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [23187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7064), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [23252] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(7024), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [23422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2040), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [23487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1973), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [23552] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7455), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7449), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7453), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [23730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [23795] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [23896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [23961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2013), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24028] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7455), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7457), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7459), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24141] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1977), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [24370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [24435] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [24532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24599] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    ACTIONS(7461), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    STATE(3270), 1,
      sym__enum_base_clause,
    STATE(3363), 1,
      sym_enumerator_list,
    STATE(3701), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6305), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [24678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1955), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1981), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1985), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [24940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7062), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [25005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [25070] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7439), 1,
      anon_sym_LBRACK,
    ACTIONS(7441), 1,
      sym_auto,
    ACTIONS(7443), 1,
      anon_sym_decltype,
    STATE(3424), 1,
      sym_decltype_auto,
    STATE(3429), 1,
      sym_new_declarator,
    STATE(3893), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6559), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [25151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1993), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [25216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3365), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6229), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1989), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [25352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [25417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2029), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [25482] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7465), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7467), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [25591] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [25672] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [25755] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3377), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6181), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25826] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [25911] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    STATE(3228), 1,
      sym_enumerator_list,
    STATE(3519), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6071), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7146), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [26051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3382), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6189), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26122] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    ACTIONS(7461), 1,
      anon_sym_COLON,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    STATE(3284), 1,
      sym__enum_base_clause,
    STATE(3400), 1,
      sym_enumerator_list,
    STATE(3679), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6295), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26201] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7439), 1,
      anon_sym_LBRACK,
    ACTIONS(7441), 1,
      sym_auto,
    ACTIONS(7443), 1,
      anon_sym_decltype,
    STATE(3424), 1,
      sym_decltype_auto,
    STATE(3479), 1,
      sym_new_declarator,
    STATE(3909), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6569), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [26282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    STATE(3233), 1,
      sym_enumerator_list,
    STATE(3495), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6085), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [26357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3371), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6233), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26428] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7469), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7471), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26537] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7473), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7475), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3395), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6225), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26717] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [26808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7136), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7134), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [26873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3378), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6185), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26944] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3390), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6237), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3380), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6221), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3387), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6241), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27157] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7439), 1,
      anon_sym_LBRACK,
    ACTIONS(7441), 1,
      sym_auto,
    ACTIONS(7443), 1,
      anon_sym_decltype,
    STATE(3424), 1,
      sym_decltype_auto,
    STATE(3449), 1,
      sym_new_declarator,
    STATE(3940), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6547), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [27238] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7411), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7413), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7431), 1,
      anon_sym_or,
    ACTIONS(7433), 1,
      anon_sym_and,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7455), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7415), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7417), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7419), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7210), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(7212), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3386), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6217), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27422] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [27574] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3405), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6197), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(3340), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6193), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27716] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7425), 1,
      anon_sym_GT_EQ,
    ACTIONS(7429), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7435), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7407), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7421), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7427), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7409), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7423), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [27811] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3478), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6217), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [27881] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3443), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6229), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [27951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2286), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5904), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2290), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3432), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6233), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [28213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3431), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6181), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [28283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7479), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [28347] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4283), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4285), 1,
      anon_sym_AMP,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6536), 1,
      anon_sym_RPAREN,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6689), 1,
      sym__declarator,
    STATE(6853), 1,
      sym__abstract_declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28459] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4945), 1,
      sym__function_attributes_start,
    STATE(5211), 1,
      sym_ref_qualifier,
    STATE(5880), 1,
      sym_trailing_return_type,
    STATE(6101), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5554), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6139), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3480), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6225), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [28711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6035), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28775] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4283), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4285), 1,
      anon_sym_AMP,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7240), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6683), 1,
      sym__declarator,
    STATE(6881), 1,
      sym__abstract_declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7401), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3455), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6237), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3466), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6241), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6135), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29159] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7358), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4942), 1,
      sym__function_attributes_start,
    STATE(5210), 1,
      sym_ref_qualifier,
    STATE(5987), 1,
      sym_trailing_return_type,
    STATE(6099), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7351), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5585), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [29277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3485), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6193), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2019), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3515), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6185), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4451), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [29547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3514), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6197), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3486), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6189), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 1,
      anon_sym___attribute__,
    ACTIONS(7228), 1,
      anon_sym___attribute,
    STATE(3513), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6221), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [29823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2290), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [29886] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [29977] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7465), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [30086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6139), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [30149] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5052), 1,
      sym__function_attributes_start,
    STATE(5242), 1,
      sym_ref_qualifier,
    STATE(6005), 1,
      sym_trailing_return_type,
    STATE(6091), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5601), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30266] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7531), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5054), 1,
      sym__function_attributes_start,
    STATE(5253), 1,
      sym_ref_qualifier,
    STATE(6132), 1,
      sym__function_attributes_end,
    STATE(6350), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7351), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5599), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30383] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7537), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4986), 1,
      sym__function_attributes_start,
    STATE(5245), 1,
      sym_ref_qualifier,
    STATE(6010), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5594), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30500] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [30597] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4200), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30706] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6609), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3257), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4219), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_LPAREN2,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7546), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_parameter_list,
    STATE(3404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6672), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6674), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [30888] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6683), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4216), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [30997] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4206), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31106] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6789), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3273), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4208), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2159), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [31278] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7457), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    ACTIONS(7566), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [31391] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_LPAREN2,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7546), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_parameter_list,
    STATE(3404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6684), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6686), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [31464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2286), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [31527] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6372), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3279), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4231), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [31636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2159), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [31699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5947), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [31762] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    STATE(3349), 1,
      sym_enumerator_list,
    STATE(3689), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6085), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [31835] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_COMMA,
    ACTIONS(7578), 1,
      anon_sym_RPAREN,
    ACTIONS(7580), 1,
      anon_sym_DASH,
    ACTIONS(7582), 1,
      anon_sym_PLUS,
    ACTIONS(7584), 1,
      anon_sym_STAR,
    ACTIONS(7586), 1,
      anon_sym_SLASH,
    ACTIONS(7588), 1,
      anon_sym_PERCENT,
    ACTIONS(7590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7594), 1,
      anon_sym_PIPE,
    ACTIONS(7596), 1,
      anon_sym_CARET,
    ACTIONS(7598), 1,
      anon_sym_AMP,
    ACTIONS(7600), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7602), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7604), 1,
      anon_sym_GT,
    ACTIONS(7606), 1,
      anon_sym_GT_EQ,
    ACTIONS(7608), 1,
      anon_sym_LT_EQ,
    ACTIONS(7610), 1,
      anon_sym_LT,
    ACTIONS(7612), 1,
      anon_sym_LT_LT,
    ACTIONS(7614), 1,
      anon_sym_GT_GT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_EQ,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7622), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7624), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7626), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7628), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7630), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7632), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7634), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7636), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7638), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7640), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7646), 1,
      anon_sym_or,
    ACTIONS(7648), 1,
      anon_sym_and,
    ACTIONS(7650), 1,
      anon_sym_bitor,
    ACTIONS(7652), 1,
      anon_sym_xor,
    ACTIONS(7654), 1,
      anon_sym_bitand,
    ACTIONS(7656), 1,
      anon_sym_not_eq,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7642), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [31996] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6828), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3274), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4211), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32105] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6828), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4211), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32214] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6771), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4195), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32323] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7403), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [32432] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [32521] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6907), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4232), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32630] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7445), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [32739] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6363), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4222), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [32848] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [32943] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [33028] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7473), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [33137] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6372), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4231), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    STATE(3334), 1,
      sym_enumerator_list,
    STATE(3744), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6071), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33384] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6683), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4215), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [33493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(6519), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(4217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4225), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [33560] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_LPAREN2,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7546), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_parameter_list,
    STATE(3404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6713), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6715), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [33633] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7371), 1,
      sym_auto,
    ACTIONS(7373), 1,
      anon_sym_decltype,
    STATE(3373), 1,
      sym_decltype_auto,
    ACTIONS(5985), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5987), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [33702] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_const,
    ACTIONS(4458), 1,
      anon_sym_AMP,
    ACTIONS(4453), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4456), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2040), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4451), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [33773] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7469), 1,
      anon_sym_EQ,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [33882] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [33963] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    ACTIONS(7676), 1,
      anon_sym_LBRACK,
    ACTIONS(7678), 1,
      sym_auto,
    ACTIONS(7680), 1,
      anon_sym_decltype,
    STATE(3721), 1,
      sym_new_declarator,
    STATE(3778), 1,
      sym_decltype_auto,
    STATE(4109), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [34042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6135), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [34105] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6378), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3283), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4210), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_LPAREN2,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7546), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_parameter_list,
    STATE(3404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6731), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6733), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [34287] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    ACTIONS(7676), 1,
      anon_sym_LBRACK,
    ACTIONS(7678), 1,
      sym_auto,
    ACTIONS(7680), 1,
      anon_sym_decltype,
    STATE(3731), 1,
      sym_new_declarator,
    STATE(3778), 1,
      sym_decltype_auto,
    STATE(4073), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [34366] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7336), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5096), 1,
      sym__function_attributes_start,
    STATE(5243), 1,
      sym_ref_qualifier,
    STATE(6131), 1,
      sym__function_attributes_end,
    STATE(6311), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5600), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34483] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6482), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4228), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6482), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3301), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4228), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34701] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6528), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4197), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [34810] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [34893] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_COMMA,
    ACTIONS(7580), 1,
      anon_sym_DASH,
    ACTIONS(7582), 1,
      anon_sym_PLUS,
    ACTIONS(7584), 1,
      anon_sym_STAR,
    ACTIONS(7586), 1,
      anon_sym_SLASH,
    ACTIONS(7588), 1,
      anon_sym_PERCENT,
    ACTIONS(7590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7594), 1,
      anon_sym_PIPE,
    ACTIONS(7596), 1,
      anon_sym_CARET,
    ACTIONS(7598), 1,
      anon_sym_AMP,
    ACTIONS(7600), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7602), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7604), 1,
      anon_sym_GT,
    ACTIONS(7606), 1,
      anon_sym_GT_EQ,
    ACTIONS(7608), 1,
      anon_sym_LT_EQ,
    ACTIONS(7610), 1,
      anon_sym_LT,
    ACTIONS(7612), 1,
      anon_sym_LT_LT,
    ACTIONS(7614), 1,
      anon_sym_GT_GT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_EQ,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7622), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7624), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7626), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7628), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7630), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7632), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7634), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7636), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7638), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7640), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7646), 1,
      anon_sym_or,
    ACTIONS(7648), 1,
      anon_sym_and,
    ACTIONS(7650), 1,
      anon_sym_bitor,
    ACTIONS(7652), 1,
      anon_sym_xor,
    ACTIONS(7654), 1,
      anon_sym_bitand,
    ACTIONS(7656), 1,
      anon_sym_not_eq,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7690), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7642), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [35054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7479), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACE,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4637), 1,
      anon_sym_LT,
    STATE(3351), 1,
      sym_template_argument_list,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35188] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6609), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3261), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4202), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35297] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6907), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3311), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4232), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35406] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7210), 1,
      anon_sym_EQ,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    ACTIONS(7566), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [35519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      anon_sym_LPAREN2,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7546), 1,
      anon_sym_LBRACK,
    STATE(3536), 1,
      sym_parameter_list,
    STATE(3404), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6707), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6709), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [35592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6521), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3299), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35701] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6908), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4201), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6035), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4217), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5904), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36001] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [36080] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3286), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4206), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACE,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4438), 1,
      anon_sym_LT,
    STATE(3244), 1,
      sym_template_argument_list,
    ACTIONS(4433), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36260] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    ACTIONS(7676), 1,
      anon_sym_LBRACK,
    ACTIONS(7678), 1,
      sym_auto,
    ACTIONS(7680), 1,
      anon_sym_decltype,
    STATE(3665), 1,
      sym_new_declarator,
    STATE(3778), 1,
      sym_decltype_auto,
    STATE(4144), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6559), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [36339] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7576), 1,
      anon_sym_COMMA,
    ACTIONS(7580), 1,
      anon_sym_DASH,
    ACTIONS(7582), 1,
      anon_sym_PLUS,
    ACTIONS(7584), 1,
      anon_sym_STAR,
    ACTIONS(7586), 1,
      anon_sym_SLASH,
    ACTIONS(7588), 1,
      anon_sym_PERCENT,
    ACTIONS(7590), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7594), 1,
      anon_sym_PIPE,
    ACTIONS(7596), 1,
      anon_sym_CARET,
    ACTIONS(7598), 1,
      anon_sym_AMP,
    ACTIONS(7600), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7602), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7604), 1,
      anon_sym_GT,
    ACTIONS(7606), 1,
      anon_sym_GT_EQ,
    ACTIONS(7608), 1,
      anon_sym_LT_EQ,
    ACTIONS(7610), 1,
      anon_sym_LT,
    ACTIONS(7612), 1,
      anon_sym_LT_LT,
    ACTIONS(7614), 1,
      anon_sym_GT_GT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7618), 1,
      anon_sym_EQ,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7622), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7624), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7626), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7628), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7630), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7632), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7634), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7636), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7638), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7640), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7646), 1,
      anon_sym_or,
    ACTIONS(7648), 1,
      anon_sym_and,
    ACTIONS(7650), 1,
      anon_sym_bitor,
    ACTIONS(7652), 1,
      anon_sym_xor,
    ACTIONS(7654), 1,
      anon_sym_bitand,
    ACTIONS(7656), 1,
      anon_sym_not_eq,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7692), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7642), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [36500] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3260), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4200), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36609] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    ACTIONS(7676), 1,
      anon_sym_LBRACK,
    ACTIONS(7678), 1,
      sym_auto,
    ACTIONS(7680), 1,
      anon_sym_decltype,
    STATE(3737), 1,
      sym_new_declarator,
    STATE(3778), 1,
      sym_decltype_auto,
    STATE(4131), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6547), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [36688] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6904), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3277), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4209), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [36797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2244), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2242), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [36860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2378), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [36923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2268), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2266), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [36986] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7022), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 26,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2378), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [37150] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7449), 1,
      anon_sym_EQ,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    ACTIONS(7566), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37263] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37368] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7445), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37476] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_LPAREN2,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7730), 1,
      anon_sym_LBRACK,
    STATE(3711), 1,
      sym_parameter_list,
    STATE(3517), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6684), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6686), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [37548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3690), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6807), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [37616] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_LPAREN2,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7730), 1,
      anon_sym_LBRACK,
    STATE(3711), 1,
      sym_parameter_list,
    STATE(3517), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6731), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6733), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [37688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3654), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6181), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3694), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6189), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6089), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7738), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7736), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7734), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7732), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [38076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6081), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5999), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6077), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6093), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6097), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3698), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6221), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3655), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6193), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5859), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [38648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3750), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6225), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3035), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4251), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4253), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6604), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6606), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [38784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4451), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3700), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6237), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3752), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6241), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [38984] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7465), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6013), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39154] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7748), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5189), 1,
      sym__function_attributes_start,
    STATE(5319), 1,
      sym_ref_qualifier,
    STATE(6247), 1,
      sym_trailing_return_type,
    STATE(6275), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5609), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [39270] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3768), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6233), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39338] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7469), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39446] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39524] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 13,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39604] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5947), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [39748] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3687), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6197), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3678), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6185), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6143), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39946] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5170), 1,
      sym__function_attributes_start,
    STATE(5326), 1,
      sym_ref_qualifier,
    STATE(6005), 1,
      sym_trailing_return_type,
    STATE(6294), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5608), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40062] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3785), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6803), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [40130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7759), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7757), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7755), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7753), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [40196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7441), 1,
      sym_auto,
    ACTIONS(7443), 1,
      anon_sym_decltype,
    STATE(3424), 1,
      sym_decltype_auto,
    ACTIONS(5985), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5987), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [40264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_const,
    ACTIONS(4458), 1,
      anon_sym_AMP,
    ACTIONS(4453), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(4456), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(2040), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4451), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40396] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    ACTIONS(7761), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7449), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [40508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6063), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6013), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7763), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3375), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3364), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6879), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [40698] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5171), 1,
      sym__function_attributes_start,
    STATE(5264), 1,
      sym_ref_qualifier,
    STATE(6221), 1,
      sym_trailing_return_type,
    STATE(6282), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5604), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6043), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [40938] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7537), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5187), 1,
      sym__function_attributes_start,
    STATE(5316), 1,
      sym_ref_qualifier,
    STATE(6010), 1,
      sym_trailing_return_type,
    STATE(6305), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5605), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5995), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41116] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3753), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6229), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6017), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41246] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_LPAREN2,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7730), 1,
      anon_sym_LBRACK,
    STATE(3711), 1,
      sym_parameter_list,
    STATE(3517), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6672), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6674), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [41318] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7403), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5991), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6109), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6113), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3822), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6830), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [41742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6051), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [41804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_LPAREN2,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7730), 1,
      anon_sym_LBRACK,
    STATE(3711), 1,
      sym_parameter_list,
    STATE(3517), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6713), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6715), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [41876] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7473), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [41984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5656), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6021), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6067), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42232] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACE,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6467), 1,
      anon_sym_LT,
    STATE(3493), 1,
      sym_template_argument_list,
    ACTIONS(4433), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7772), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7770), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7768), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [42368] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    ACTIONS(7761), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7210), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [42480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym___attribute__,
    ACTIONS(7287), 1,
      anon_sym___attribute,
    STATE(3651), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6217), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42548] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      anon_sym_LPAREN2,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7730), 1,
      anon_sym_LBRACK,
    STATE(3711), 1,
      sym_parameter_list,
    STATE(3517), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6707), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6709), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [42620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42682] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3672), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6826), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7544), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3375), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6809), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6811), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6105), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7776), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3850), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3848), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [42944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6031), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43006] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43110] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43210] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [43306] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [43400] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [43490] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [43578] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [43662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6039), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [43786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7780), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7778), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [43848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3872), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7782), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3868), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3866), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [43914] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7698), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7700), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7702), 1,
      anon_sym_PIPE,
    ACTIONS(7706), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_GT_EQ,
    ACTIONS(7716), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7718), 1,
      anon_sym_or,
    ACTIONS(7720), 1,
      anon_sym_and,
    ACTIONS(7722), 1,
      anon_sym_bitor,
    ACTIONS(7724), 1,
      anon_sym_bitand,
    ACTIONS(7761), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7457), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7704), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7714), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7696), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7708), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7710), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [44088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7790), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7788), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7786), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7784), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [44154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5999), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44215] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5229), 1,
      sym__function_attributes_start,
    STATE(5425), 1,
      sym_ref_qualifier,
    STATE(6187), 1,
      sym__function_attributes_end,
    STATE(6221), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5623), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6063), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7369), 1,
      anon_sym_LBRACK,
    STATE(3575), 1,
      sym_new_declarator,
    ACTIONS(6924), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6926), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [44456] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7794), 1,
      sym_identifier,
    STATE(3426), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7797), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7800), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6434), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6432), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [44525] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_EQ,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [44636] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7835), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3428), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(3364), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6879), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [44701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3938), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6830), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [44768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6089), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6131), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6123), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44951] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7006), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7008), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [45026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5859), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45087] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LT,
    STATE(3244), 1,
      sym_template_argument_list,
    ACTIONS(7041), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [45152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7841), 1,
      anon_sym_LT,
    STATE(3554), 1,
      sym_template_argument_list,
    ACTIONS(6917), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6919), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45219] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3908), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6803), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [45286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6013), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6077), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45408] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7465), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [45515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      anon_sym_LT,
    STATE(3351), 1,
      sym_template_argument_list,
    ACTIONS(7041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45580] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7457), 1,
      anon_sym_EQ,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [45691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6143), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45752] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7018), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7020), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [45827] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7748), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5233), 1,
      sym__function_attributes_start,
    STATE(5346), 1,
      sym_ref_qualifier,
    STATE(6193), 1,
      sym__function_attributes_end,
    STATE(6247), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5634), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7010), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7012), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [46017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6976), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6978), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [46090] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7849), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5228), 1,
      sym__function_attributes_start,
    STATE(5372), 1,
      sym_ref_qualifier,
    STATE(6216), 1,
      sym__function_attributes_end,
    STATE(6265), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5622), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3956), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6807), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [46272] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6121), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4270), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6536), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [46371] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7868), 1,
      sym_identifier,
    STATE(3426), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6657), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6659), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6419), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6417), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7870), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6942), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46503] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 1,
      anon_sym___attribute,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6116), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3450), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4274), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6482), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [46602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6942), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [46665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6051), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6059), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46787] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [46894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5656), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [46955] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [47032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6055), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7473), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [47200] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7022), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [47275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LT,
    STATE(1159), 1,
      sym_template_argument_list,
    ACTIONS(7041), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [47340] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [47443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6047), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6109), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6113), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2290), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47687] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4223), 1,
      sym_field_declaration_list,
    STATE(4323), 1,
      sym_attribute_specifier,
    STATE(7263), 1,
      sym_virtual_specifier,
    STATE(8110), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5866), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5868), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [47764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6047), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6047), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47886] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [47985] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7403), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [48092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7479), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7477), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [48153] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [48248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5214), 1,
      sym__function_attributes_start,
    STATE(5380), 1,
      sym_ref_qualifier,
    STATE(6334), 1,
      sym_trailing_return_type,
    STATE(6409), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5636), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7880), 1,
      sym_identifier,
    STATE(3451), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6657), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6659), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6425), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6423), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [48432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5991), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3952), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6826), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [48560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6067), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6093), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6039), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48743] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7849), 1,
      anon_sym_requires,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5218), 1,
      sym__function_attributes_start,
    STATE(5386), 1,
      sym_ref_qualifier,
    STATE(6265), 1,
      sym_trailing_return_type,
    STATE(6400), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5633), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [48858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4217), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4225), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [48921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6081), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [48982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6017), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7882), 1,
      anon_sym_LT,
    STATE(3554), 1,
      sym_template_argument_list,
    ACTIONS(6900), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6902), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6031), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49171] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7469), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [49278] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6998), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7000), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [49353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6035), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6097), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4451), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49538] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [49619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6127), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_LBRACE,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6533), 1,
      anon_sym_LT,
    STATE(3526), 1,
      sym_template_argument_list,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [49749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6013), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [49810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(3748), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7885), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5793), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [49879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      anon_sym_LT,
    STATE(2512), 1,
      sym_template_argument_list,
    ACTIONS(7041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49944] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3035), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4251), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4253), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6604), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6606), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50011] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [50104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2286), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5859), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LT,
    STATE(1218), 1,
      sym_template_argument_list,
    ACTIONS(7041), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6135), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5904), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50413] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [50502] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [50589] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7330), 1,
      anon_sym___attribute__,
    ACTIONS(7333), 1,
      anon_sym___attribute,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5217), 1,
      sym__function_attributes_start,
    STATE(5432), 1,
      sym_ref_qualifier,
    STATE(6212), 1,
      sym__function_attributes_end,
    STATE(6334), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5637), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7322), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50704] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [50787] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6966), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6968), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [50860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6139), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5995), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [50982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6105), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6043), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51104] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7449), 1,
      anon_sym_EQ,
    ACTIONS(7574), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7620), 1,
      anon_sym_QMARK,
    ACTIONS(7644), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7807), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7811), 1,
      anon_sym_PIPE,
    ACTIONS(7815), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_GT_EQ,
    ACTIONS(7825), 1,
      anon_sym_or,
    ACTIONS(7827), 1,
      anon_sym_and,
    ACTIONS(7829), 1,
      anon_sym_bitor,
    ACTIONS(7831), 1,
      anon_sym_bitand,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7813), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7823), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7817), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7819), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [51215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7728), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3428), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6809), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6811), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [51280] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7658), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7803), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7805), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [51359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6021), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [51420] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7006), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7008), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51554] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7210), 1,
      anon_sym_EQ,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    ACTIONS(7566), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [51666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    ACTIONS(4249), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5469), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51790] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4451), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [51918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [51984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7224), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3876), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2609), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5793), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [52172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym_LT,
    STATE(3493), 1,
      sym_template_argument_list,
    ACTIONS(7041), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5501), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7062), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52356] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7900), 1,
      anon_sym_RPAREN,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [52512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3880), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6849), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5505), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6653), 1,
      anon_sym_EQ,
    ACTIONS(6655), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52756] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(7978), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [52912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5461), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [52972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5947), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5481), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7980), 1,
      anon_sym_LT,
    STATE(3782), 1,
      sym_template_argument_list,
    ACTIONS(6900), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6902), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5509), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7479), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5489), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7893), 1,
      anon_sym_LT,
    STATE(2574), 1,
      sym_template_argument_list,
    ACTIONS(7041), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5493), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1945), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [53522] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7497), 1,
      anon_sym_GT_EQ,
    ACTIONS(7501), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7503), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7507), 1,
      anon_sym_PIPE,
    ACTIONS(7511), 1,
      anon_sym_AMP,
    ACTIONS(7513), 1,
      anon_sym_or,
    ACTIONS(7515), 1,
      anon_sym_and,
    ACTIONS(7517), 1,
      anon_sym_bitor,
    ACTIONS(7519), 1,
      anon_sym_bitand,
    ACTIONS(7566), 1,
      anon_sym_QMARK,
    ACTIONS(7578), 1,
      anon_sym_RPAREN,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(7985), 1,
      anon_sym_EQ,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7499), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7509), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7491), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7493), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7495), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7642), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [53636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7028), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7987), 1,
      anon_sym_LT,
    STATE(3782), 1,
      sym_template_argument_list,
    ACTIONS(6917), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6919), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53762] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [53918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6934), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6936), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [53980] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      anon_sym_LT,
    STATE(1220), 1,
      sym_template_argument_list,
    ACTIONS(7041), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6750), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6768), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54164] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(7992), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [54320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6952), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54380] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(7994), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [54536] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6978), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [54608] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7465), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [54712] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(6642), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4225), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54778] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(8034), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [54934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7008), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [55068] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7012), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [55142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6942), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55202] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7469), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [55306] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6968), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [55378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6867), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6875), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55498] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(8036), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [55654] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(8038), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [55810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7016), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [55930] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7662), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7664), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7898), 1,
      anon_sym_COMMA,
    ACTIONS(7902), 1,
      anon_sym_DASH,
    ACTIONS(7904), 1,
      anon_sym_PLUS,
    ACTIONS(7906), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_SLASH,
    ACTIONS(7910), 1,
      anon_sym_PERCENT,
    ACTIONS(7912), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7914), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7916), 1,
      anon_sym_PIPE,
    ACTIONS(7918), 1,
      anon_sym_CARET,
    ACTIONS(7920), 1,
      anon_sym_AMP,
    ACTIONS(7922), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7924), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7926), 1,
      anon_sym_GT,
    ACTIONS(7928), 1,
      anon_sym_GT_EQ,
    ACTIONS(7930), 1,
      anon_sym_LT_EQ,
    ACTIONS(7932), 1,
      anon_sym_LT,
    ACTIONS(7934), 1,
      anon_sym_LT_LT,
    ACTIONS(7936), 1,
      anon_sym_GT_GT,
    ACTIONS(7938), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7942), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7944), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7946), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7948), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7950), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7952), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7954), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7956), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7958), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7960), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7964), 1,
      anon_sym_or,
    ACTIONS(7966), 1,
      anon_sym_and,
    ACTIONS(7968), 1,
      anon_sym_bitor,
    ACTIONS(7970), 1,
      anon_sym_xor,
    ACTIONS(7972), 1,
      anon_sym_bitand,
    ACTIONS(7974), 1,
      anon_sym_not_eq,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    STATE(1806), 1,
      sym__binary_fold_operator,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    STATE(8733), 1,
      sym__fold_operator,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [56086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6797), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6845), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6853), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6625), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56566] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7473), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [56670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6863), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6762), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56852] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    ACTIONS(8042), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8044), 1,
      anon_sym_QMARK,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7210), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [56960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [57020] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4249), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57090] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [57166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [57240] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [57340] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7022), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [57436] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [57528] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [57618] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [57704] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [57788] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [57870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7018), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7020), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [57944] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [58022] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [58102] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8046), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2609), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(4223), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [58172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(6642), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4225), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1949), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5477), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58358] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7000), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [58432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5497), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5485), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7678), 1,
      sym_auto,
    ACTIONS(7680), 1,
      anon_sym_decltype,
    STATE(3778), 1,
      sym_decltype_auto,
    ACTIONS(5985), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5987), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6942), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [58678] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7445), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [58782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8048), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6942), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [58844] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    ACTIONS(8042), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8044), 1,
      anon_sym_QMARK,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7449), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [58952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6978), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [59024] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7465), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59130] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7010), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7012), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [59204] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7469), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59310] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6968), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [59382] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7473), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59488] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7210), 1,
      anon_sym_EQ,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    ACTIONS(8082), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59598] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [59674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [59748] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59850] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [59948] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [60042] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [60134] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [60222] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [60308] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [60390] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [60468] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [60548] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6998), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7000), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [60622] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7445), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [60728] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7449), 1,
      anon_sym_EQ,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    ACTIONS(8082), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [60838] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7403), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [60944] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7451), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7457), 1,
      anon_sym_EQ,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8054), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8056), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8058), 1,
      anon_sym_PIPE,
    ACTIONS(8062), 1,
      anon_sym_AMP,
    ACTIONS(8068), 1,
      anon_sym_GT_EQ,
    ACTIONS(8072), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8074), 1,
      anon_sym_or,
    ACTIONS(8076), 1,
      anon_sym_and,
    ACTIONS(8078), 1,
      anon_sym_bitor,
    ACTIONS(8080), 1,
      anon_sym_bitand,
    ACTIONS(8082), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8050), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8060), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8070), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8052), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8064), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8066), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [61054] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7403), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [61158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61278] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7002), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7018), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(7020), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [61352] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7439), 1,
      anon_sym_LBRACK,
    STATE(3821), 1,
      sym_new_declarator,
    ACTIONS(6924), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6926), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [61416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8084), 1,
      sym_literal_suffix,
    ACTIONS(4225), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6958), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6960), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61538] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8006), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8008), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8010), 1,
      anon_sym_PIPE,
    ACTIONS(8014), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8024), 1,
      anon_sym_or,
    ACTIONS(8026), 1,
      anon_sym_and,
    ACTIONS(8028), 1,
      anon_sym_bitor,
    ACTIONS(8030), 1,
      anon_sym_bitand,
    ACTIONS(8042), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8044), 1,
      anon_sym_QMARK,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8002), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8012), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8020), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8032), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8004), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8016), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8018), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [61646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5465), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6625), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [61766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6871), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5991), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [61885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [61944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7110), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6131), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6081), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 1,
      anon_sym_LT,
    STATE(1227), 1,
      sym_template_argument_list,
    ACTIONS(7041), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7052), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7200), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6625), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8086), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6942), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7086), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7090), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7094), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    STATE(4130), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6830), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6988), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6952), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [62841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8088), 1,
      sym_literal_suffix,
    ACTIONS(4217), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4225), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [62902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [62961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5469), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7066), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7152), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5656), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5509), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7098), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6043), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6031), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6867), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6871), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6875), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63728] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7748), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5284), 1,
      sym__function_attributes_start,
    STATE(5561), 1,
      sym_ref_qualifier,
    STATE(6247), 1,
      sym_trailing_return_type,
    STATE(6541), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7322), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7534), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5652), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6394), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [63900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7114), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6465), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [64018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6105), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64077] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8092), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8097), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5320), 1,
      sym__function_attributes_start,
    STATE(5569), 1,
      sym_ref_qualifier,
    STATE(6484), 1,
      sym__function_attributes_end,
    STATE(6695), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7322), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7351), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5654), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [64190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6127), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7216), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6410), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [64367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6013), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7238), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6017), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7070), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7074), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5995), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6013), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6051), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7212), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6797), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [65075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8100), 1,
      anon_sym_LT,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(2005), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2007), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [65140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7148), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7118), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8102), 1,
      sym_identifier,
    STATE(3708), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(8105), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(8108), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6434), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6432), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [65384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6039), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [65443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8111), 1,
      sym_identifier,
    STATE(3708), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5722), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5724), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6419), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6417), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [65510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6849), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [65569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7128), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6089), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [65687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7132), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7140), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7144), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7156), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7160), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [66041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7028), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [66100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    STATE(4166), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6826), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7192), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5461), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6705), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66344] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8113), 1,
      anon_sym_LT,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(1997), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1999), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5481), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5859), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [66527] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8092), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5322), 1,
      sym__function_attributes_start,
    STATE(5555), 1,
      sym_ref_qualifier,
    STATE(6496), 1,
      sym__function_attributes_end,
    STATE(6620), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7322), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6172), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5665), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [66640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7106), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [66758] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    STATE(4107), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6803), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_LT,
    STATE(3526), 1,
      sym_template_argument_list,
    ACTIONS(7041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [66886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1945), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7224), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4092), 1,
      sym_alignas_qualifier,
    ACTIONS(8124), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5026), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(8121), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5024), 21,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [67071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8127), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5743), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5745), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7674), 1,
      anon_sym_LPAREN2,
    STATE(4071), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6807), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6750), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [67258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7244), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7246), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6768), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [67376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6461), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [67435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3477), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6657), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6659), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6604), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6606), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7208), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6021), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [67618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1949), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8100), 1,
      anon_sym_LT,
    STATE(3748), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3917), 1,
      sym_template_argument_list,
    ACTIONS(7885), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4223), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5892), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5913), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5915), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67872] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5266), 1,
      sym__function_attributes_start,
    STATE(5551), 1,
      sym_ref_qualifier,
    STATE(6221), 1,
      sym_trailing_return_type,
    STATE(6536), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7322), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4254), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4423), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5651), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [67985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6067), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6958), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6960), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [68103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6109), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6143), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3759), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8132), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5939), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5941), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3760), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8134), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5898), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5999), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6845), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [68524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5917), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5919), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5925), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5927), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3766), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8136), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5929), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5931), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3767), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8138), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5884), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5886), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5935), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5937), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6093), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [68898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3747), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8140), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5902), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5904), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68961] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5921), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5923), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8130), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5906), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5908), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6123), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [69146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6077), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [69205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6097), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [69264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8142), 1,
      sym_identifier,
    STATE(3710), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5722), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5724), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6425), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6423), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6853), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5465), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6942), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8144), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8148), 1,
      anon_sym_or,
    ACTIONS(8150), 1,
      anon_sym_and,
    ACTIONS(5767), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5769), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7180), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2282), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6063), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [69752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7184), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6863), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6762), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6934), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6936), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [69990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7062), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4396), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7196), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7204), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6113), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [70285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5477), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70344] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7339), 1,
      anon_sym_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7748), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5289), 1,
      sym__function_attributes_start,
    STATE(5545), 1,
      sym_ref_qualifier,
    STATE(6550), 1,
      sym__function_attributes_end,
    STATE(6747), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7322), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4258), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4411), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6220), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5659), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5497), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8146), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8150), 1,
      anon_sym_and,
    ACTIONS(5779), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5781), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5485), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6948), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6948), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6948), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6992), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3876), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7479), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(7477), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [71110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7164), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7188), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7102), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6954), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6956), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6962), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6964), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5505), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4428), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7136), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [71995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3880), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5489), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5493), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7016), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7058), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7082), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [72467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8118), 1,
      anon_sym_LT,
    STATE(2603), 1,
      sym_template_argument_list,
    ACTIONS(7041), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72530] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6976), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6978), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [72600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6992), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [72716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [72774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7244), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7246), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [72832] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7457), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [72938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [72996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7164), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1973), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      anon_sym_LT,
    STATE(2618), 1,
      sym_template_argument_list,
    ACTIONS(7041), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7043), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73174] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8182), 1,
      anon_sym_RPAREN,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7702), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [73280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7066), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73338] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_COMMA,
    ACTIONS(6788), 1,
      anon_sym_RBRACK,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2282), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73458] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7449), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [73564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8188), 1,
      anon_sym_COMMA,
    ACTIONS(8190), 1,
      anon_sym_RBRACK,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7090), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7212), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7094), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7192), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1977), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5461), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [73974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5481), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74032] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7465), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [74134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [74192] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7403), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [74294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7100), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7102), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5477), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5485), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6954), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6956), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1981), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6625), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5489), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8195), 1,
      anon_sym_and,
    ACTIONS(5779), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5781), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5493), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74820] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [74894] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [74966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7062), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_EQ,
    ACTIONS(6700), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75086] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_EQ,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [75186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    STATE(4017), 1,
      sym_new_declarator,
    ACTIONS(6924), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6926), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75248] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6746), 1,
      anon_sym_EQ,
    ACTIONS(6836), 1,
      anon_sym_COMMA,
    ACTIONS(6838), 1,
      anon_sym_RBRACK,
    ACTIONS(6700), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4217), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [75314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7148), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75372] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_EQ,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [75470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7074), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7078), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7188), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(5720), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4217), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4225), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [75764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [75822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1973), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75880] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [75974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76032] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [76122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7098), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76238] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [76324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1977), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1955), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1981), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7118), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7208), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1985), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1993), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1989), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76846] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    ACTIONS(4273), 1,
      anon_sym_SEMI,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4249), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4217), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [76916] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(7024), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [77000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7114), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1949), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77116] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7008), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [77188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7128), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77246] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7012), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [77318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7106), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7140), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7180), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1945), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7144), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7160), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1955), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [77724] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7469), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [77826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7024), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [77906] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [77982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7196), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7204), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7184), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5497), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78214] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6966), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6968), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [78284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6942), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78342] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(7024), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [78420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5501), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5505), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2040), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1985), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8199), 1,
      anon_sym_COLON,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    STATE(4178), 1,
      sym__enum_base_clause,
    STATE(4221), 1,
      sym_enumerator_list,
    STATE(4318), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6303), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6305), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6948), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5465), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78838] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8193), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8195), 1,
      anon_sym_and,
    ACTIONS(8203), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8205), 1,
      anon_sym_or,
    ACTIONS(5767), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5769), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1993), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78962] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_EQ,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7940), 1,
      anon_sym_QMARK,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [79068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4396), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7052), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5469), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4451), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79476] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8199), 1,
      anon_sym_COLON,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    STATE(4185), 1,
      sym__enum_base_clause,
    STATE(4227), 1,
      sym_enumerator_list,
    STATE(4336), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6293), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6295), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7676), 1,
      anon_sym_LBRACK,
    STATE(4002), 1,
      sym_new_declarator,
    ACTIONS(6924), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6926), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7200), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(1989), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7058), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6948), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7082), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7110), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80130] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [80232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7086), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80290] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(7000), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [80362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2019), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2019), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4428), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7224), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2029), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7136), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7152), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6946), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6948), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5509), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2013), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [80948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7216), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7238), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7070), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6857), 1,
      anon_sym_EQ,
    ACTIONS(6859), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81300] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    ACTIONS(7473), 1,
      anon_sym_EQ,
    ACTIONS(7616), 1,
      anon_sym_LBRACK,
    ACTIONS(7833), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7962), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8160), 1,
      anon_sym_PIPE,
    ACTIONS(8162), 1,
      anon_sym_CARET,
    ACTIONS(8164), 1,
      anon_sym_AMP,
    ACTIONS(8170), 1,
      anon_sym_GT_EQ,
    ACTIONS(8174), 1,
      anon_sym_bitor,
    ACTIONS(8176), 1,
      anon_sym_xor,
    ACTIONS(8178), 1,
      anon_sym_bitand,
    STATE(3658), 1,
      sym_argument_list,
    STATE(3659), 1,
      sym_subscript_argument_list,
    ACTIONS(7660), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7976), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8152), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8156), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8158), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8172), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8154), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(8166), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8168), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [81402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6962), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6964), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7132), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6988), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(7156), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4451), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [81752] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5852), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [81855] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_STAR,
    ACTIONS(8223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8229), 1,
      anon_sym_AMP,
    ACTIONS(8231), 1,
      anon_sym_COLON,
    ACTIONS(8233), 1,
      anon_sym_EQ,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6246), 1,
      sym__declarator,
    STATE(6552), 1,
      sym__abstract_declarator,
    STATE(6871), 1,
      sym_abstract_reference_declarator,
    STATE(7416), 1,
      sym_variadic_declarator,
    STATE(7433), 1,
      sym_variadic_reference_declarator,
    STATE(7437), 1,
      sym_semantics,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(7483), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8225), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6779), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [81970] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6361), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4458), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8241), 1,
      sym_identifier,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8249), 1,
      anon_sym_enum,
    ACTIONS(8251), 1,
      anon_sym_class,
    ACTIONS(8253), 1,
      anon_sym_struct,
    ACTIONS(8255), 1,
      anon_sym_union,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8261), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4368), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    STATE(4152), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82166] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8316), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82269] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5932), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82372] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82475] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6580), 1,
      anon_sym_STAR,
    ACTIONS(8223), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8229), 1,
      anon_sym_AMP,
    ACTIONS(8231), 1,
      anon_sym_COLON,
    ACTIONS(8263), 1,
      anon_sym_EQ,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6228), 1,
      sym__declarator,
    STATE(6593), 1,
      sym__abstract_declarator,
    STATE(6922), 1,
      sym_abstract_reference_declarator,
    STATE(7416), 1,
      sym_variadic_declarator,
    STATE(7433), 1,
      sym_variadic_reference_declarator,
    STATE(7437), 1,
      sym_semantics,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(7483), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8225), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6779), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [82590] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4408), 1,
      sym_type_specifier,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    STATE(4094), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82693] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8271), 1,
      sym_identifier,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      sym_primitive_type,
    ACTIONS(8279), 1,
      anon_sym_enum,
    ACTIONS(8281), 1,
      anon_sym_class,
    ACTIONS(8283), 1,
      anon_sym_struct,
    ACTIONS(8285), 1,
      anon_sym_union,
    ACTIONS(8287), 1,
      sym_auto,
    ACTIONS(8289), 1,
      anon_sym_decltype,
    ACTIONS(8291), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4445), 1,
      sym_type_specifier,
    STATE(5125), 1,
      sym_qualified_type_identifier,
    STATE(5194), 1,
      sym_decltype_auto,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4079), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5100), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5186), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82796] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(9062), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4500), 1,
      sym_type_specifier,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    STATE(4150), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7110), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [83059] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8318), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83162] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8046), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(2005), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2007), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [83225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6968), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [83294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    ACTIONS(4273), 1,
      anon_sym_SEMI,
    ACTIONS(4249), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4217), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [83357] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7927), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83460] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4403), 1,
      sym_type_specifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4103), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83563] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8435), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83666] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8848), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8084), 1,
      sym_literal_suffix,
    ACTIONS(4225), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83828] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8826), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [83931] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5989), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84034] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8938), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84137] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5906), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84240] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6490), 1,
      anon_sym___attribute,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6389), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4001), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4464), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84335] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7000), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [84406] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7008), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [84477] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5872), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84580] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(9046), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84683] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5904), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84786] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6393), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4465), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7016), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84938] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8248), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8315), 1,
      sym_identifier,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8319), 1,
      anon_sym_enum,
    ACTIONS(8321), 1,
      anon_sym_class,
    ACTIONS(8323), 1,
      anon_sym_struct,
    ACTIONS(8325), 1,
      anon_sym_union,
    ACTIONS(8327), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4093), 1,
      sym_type_specifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    STATE(4112), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85144] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8463), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85247] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5843), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85350] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8374), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85453] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5868), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8399), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85659] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5908), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85762] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5918), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7238), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [85922] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5958), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86025] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8704), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86128] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5971), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86231] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8477), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7016), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86391] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5848), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86494] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5849), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86597] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5912), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86700] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4990), 1,
      sym_type_specifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4135), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86803] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8636), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [86906] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8329), 1,
      sym_identifier,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(8335), 1,
      anon_sym_enum,
    ACTIONS(8337), 1,
      anon_sym_class,
    ACTIONS(8339), 1,
      anon_sym_struct,
    ACTIONS(8341), 1,
      anon_sym_union,
    ACTIONS(8343), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(4552), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4566), 1,
      sym_type_specifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    STATE(4106), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87009] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7012), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [87080] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8436), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87183] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8676), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87286] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(9143), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87389] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8705), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87492] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8352), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8349), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8347), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8345), 28,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [87557] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6427), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3971), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4487), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87650] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8962), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87753] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8400), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [87856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2282), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87913] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8287), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(7479), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [88073] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8271), 1,
      sym_identifier,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      sym_primitive_type,
    ACTIONS(8279), 1,
      anon_sym_enum,
    ACTIONS(8281), 1,
      anon_sym_class,
    ACTIONS(8283), 1,
      anon_sym_struct,
    ACTIONS(8285), 1,
      anon_sym_union,
    ACTIONS(8287), 1,
      sym_auto,
    ACTIONS(8289), 1,
      anon_sym_decltype,
    ACTIONS(8291), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4325), 1,
      sym_type_specifier,
    STATE(5125), 1,
      sym_qualified_type_identifier,
    STATE(5194), 1,
      sym_decltype_auto,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4115), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5100), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5186), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88176] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(8358), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8355), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8347), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8345), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [88241] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8900), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6461), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [88401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6465), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [88458] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8438), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88561] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8844), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88664] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8315), 1,
      sym_identifier,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8319), 1,
      anon_sym_enum,
    ACTIONS(8321), 1,
      anon_sym_class,
    ACTIONS(8323), 1,
      anon_sym_struct,
    ACTIONS(8325), 1,
      anon_sym_union,
    ACTIONS(8327), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4334), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6227), 1,
      sym_type_descriptor,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    STATE(4141), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88767] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8458), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [88870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(2019), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88927] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8570), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89030] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(9169), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89133] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4762), 1,
      sym_type_specifier,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4119), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89236] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8593), 1,
      sym_type_descriptor,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89339] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4482), 1,
      sym_type_specifier,
    STATE(6240), 1,
      sym_type_descriptor,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4155), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [89513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5860), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6394), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3771), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5722), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5724), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6604), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6606), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89736] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5887), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89839] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8858), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [89942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3747), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8140), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5859), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90003] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8863), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6978), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [90175] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8883), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90278] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8888), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90381] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8906), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90484] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8910), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8361), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(1997), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1999), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [90650] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4704), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8926), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90753] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5153), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(8930), 1,
      sym_type_descriptor,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4182), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [90856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7128), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6410), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [90970] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5290), 1,
      sym_type_specifier,
    STATE(5853), 1,
      sym__type_definition_type,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    STATE(4137), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [91073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7058), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7216), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7188), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7192), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7238), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7070), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7074), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7078), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7070), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91577] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8271), 1,
      sym_identifier,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      sym_primitive_type,
    ACTIONS(8279), 1,
      anon_sym_enum,
    ACTIONS(8281), 1,
      anon_sym_class,
    ACTIONS(8283), 1,
      anon_sym_struct,
    ACTIONS(8285), 1,
      anon_sym_union,
    ACTIONS(8287), 1,
      sym_auto,
    ACTIONS(8289), 1,
      anon_sym_decltype,
    ACTIONS(8291), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4483), 1,
      sym_type_specifier,
    STATE(5125), 1,
      sym_qualified_type_identifier,
    STATE(5194), 1,
      sym_decltype_auto,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5100), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5186), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [91677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7118), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7180), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5461), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5481), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [91957] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4836), 1,
      sym_type_specifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7184), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7132), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7140), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7144), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7156), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7160), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(2197), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [92449] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8366), 1,
      anon_sym___attribute,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6115), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4299), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8364), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [92539] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4414), 1,
      sym_type_specifier,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7208), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7118), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7124), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7074), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7180), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7184), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [92975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7078), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7136), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93087] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4407), 1,
      sym_type_specifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93187] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    ACTIONS(8374), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6120), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4287), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8372), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [93277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2282), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93333] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8329), 1,
      sym_identifier,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(8335), 1,
      anon_sym_enum,
    ACTIONS(8337), 1,
      anon_sym_class,
    ACTIONS(8339), 1,
      anon_sym_struct,
    ACTIONS(8341), 1,
      anon_sym_union,
    ACTIONS(8343), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(4552), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4620), 1,
      sym_type_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7196), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8376), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8378), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5767), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5769), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7204), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7086), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5497), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [93717] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8315), 1,
      sym_identifier,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8319), 1,
      anon_sym_enum,
    ACTIONS(8321), 1,
      anon_sym_class,
    ACTIONS(8323), 1,
      anon_sym_struct,
    ACTIONS(8325), 1,
      anon_sym_union,
    ACTIONS(8327), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4104), 1,
      sym_type_specifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [93817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7090), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7216), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93929] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8271), 1,
      sym_identifier,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      sym_primitive_type,
    ACTIONS(8279), 1,
      anon_sym_enum,
    ACTIONS(8281), 1,
      anon_sym_class,
    ACTIONS(8283), 1,
      anon_sym_struct,
    ACTIONS(8285), 1,
      anon_sym_union,
    ACTIONS(8287), 1,
      sym_auto,
    ACTIONS(8289), 1,
      anon_sym_decltype,
    ACTIONS(8291), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4329), 1,
      sym_type_specifier,
    STATE(5125), 1,
      sym_qualified_type_identifier,
    STATE(5194), 1,
      sym_decltype_auto,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5100), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5186), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [94029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5489), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4217), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7094), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94197] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4697), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [94297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5493), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5501), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5505), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7188), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7212), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4217), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7196), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7192), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7132), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7140), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7058), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7082), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [94969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7204), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7148), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95137] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5009), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [95237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7144), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95293] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5267), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [95393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7212), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7110), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7098), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95561] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8315), 1,
      sym_identifier,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8319), 1,
      anon_sym_enum,
    ACTIONS(8321), 1,
      anon_sym_class,
    ACTIONS(8323), 1,
      anon_sym_struct,
    ACTIONS(8325), 1,
      anon_sym_union,
    ACTIONS(8327), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4341), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [95661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7098), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7082), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7114), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [95829] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym___attribute__,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8380), 1,
      anon_sym_COLON,
    STATE(2588), 1,
      sym_attribute_specifier,
    STATE(2728), 1,
      sym__enum_base_clause,
    STATE(2801), 1,
      sym_enumerator_list,
    ACTIONS(6303), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6305), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [95899] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym___attribute__,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8380), 1,
      anon_sym_COLON,
    STATE(2555), 1,
      sym_attribute_specifier,
    STATE(2744), 1,
      sym__enum_base_clause,
    STATE(2803), 1,
      sym_enumerator_list,
    ACTIONS(6293), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6295), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [95969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1949), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96025] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8384), 1,
      sym_auto,
    ACTIONS(8386), 1,
      anon_sym_decltype,
    STATE(4235), 1,
      sym_new_declarator,
    STATE(4313), 1,
      sym_decltype_auto,
    STATE(4127), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7208), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96153] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4549), 1,
      sym_type_specifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7114), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96309] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8241), 1,
      sym_identifier,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8249), 1,
      anon_sym_enum,
    ACTIONS(8251), 1,
      anon_sym_class,
    ACTIONS(8253), 1,
      anon_sym_struct,
    ACTIONS(8255), 1,
      anon_sym_union,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8261), 1,
      anon_sym_typename,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4369), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7086), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7090), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96521] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4475), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7094), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1945), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [96733] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8384), 1,
      sym_auto,
    ACTIONS(8386), 1,
      anon_sym_decltype,
    STATE(4247), 1,
      sym_new_declarator,
    STATE(4313), 1,
      sym_decltype_auto,
    STATE(4151), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6559), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6461), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [96861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6465), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [96917] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8384), 1,
      sym_auto,
    ACTIONS(8386), 1,
      anon_sym_decltype,
    STATE(4257), 1,
      sym_new_declarator,
    STATE(4313), 1,
      sym_decltype_auto,
    STATE(4132), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7156), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5166), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [97101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7160), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97157] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8384), 1,
      sym_auto,
    ACTIONS(8386), 1,
      anon_sym_decltype,
    STATE(4256), 1,
      sym_new_declarator,
    STATE(4313), 1,
      sym_decltype_auto,
    STATE(4143), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6547), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7152), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5477), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8378), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5779), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5781), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5485), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5465), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6394), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [97567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7066), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4396), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7052), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97735] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6520), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4176), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4523), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97827] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6442), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4525), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6410), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [97975] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    STATE(4230), 1,
      sym_enumerator_list,
    STATE(4342), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6083), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6085), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5469), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5509), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7128), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98207] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5150), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4396), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    STATE(4191), 1,
      sym_enumerator_list,
    STATE(4308), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6069), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6071), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2714), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5716), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5793), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [98547] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4692), 1,
      sym_type_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5473), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [98759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7052), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4311), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6179), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6181), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4328), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6227), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6229), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98933] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6490), 1,
      anon_sym___attribute,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6567), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4196), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4616), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4338), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6231), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6233), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99085] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6792), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99178] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6569), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4619), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99271] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6527), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99364] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4312), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6191), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6193), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99423] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4377), 1,
      sym_new_declarator,
    STATE(4151), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6559), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99494] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6683), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99587] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6909), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99680] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99773] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4376), 1,
      sym_new_declarator,
    STATE(4127), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6573), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4317), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6235), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6237), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4348), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6239), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6241), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99962] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6683), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100055] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4390), 1,
      sym_new_declarator,
    STATE(4143), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6547), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100126] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6828), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100219] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6907), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100312] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6372), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100405] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6771), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6461), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [100553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6394), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [100608] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4388), 1,
      sym_new_declarator,
    STATE(4132), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6569), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100679] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6694), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100772] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6694), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100865] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6482), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6410), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [101013] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6689), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4335), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6183), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6185), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4340), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6195), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6197), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101224] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6376), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4346), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6187), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6189), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4347), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6219), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6221), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101435] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6490), 1,
      anon_sym___attribute,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6575), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4226), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4603), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101528] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6577), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4605), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4307), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6215), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6217), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101680] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6528), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6465), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [101828] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4320), 1,
      sym_attribute_specifier,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6223), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6225), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101887] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6363), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101980] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6908), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102073] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8420), 1,
      sym_identifier,
    ACTIONS(8430), 1,
      sym_primitive_type,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4349), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8427), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4240), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8425), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5731), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5729), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8422), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(2286), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    STATE(4126), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6803), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8434), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8432), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [102311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6035), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6680), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4806), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102455] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_LT,
    STATE(2714), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(5716), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4223), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [102519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8452), 1,
      sym_identifier,
    ACTIONS(8462), 1,
      sym_primitive_type,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(4486), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8459), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8457), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5755), 10,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5753), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8454), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(2290), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102643] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8464), 1,
      anon_sym_LT,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(1997), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1999), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [102703] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6626), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4245), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4752), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8475), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8473), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [102847] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6631), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4712), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8450), 1,
      anon_sym_LT,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(2005), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(2007), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [102997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    STATE(4070), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6830), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6135), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8434), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8432), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [103165] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6484), 1,
      anon_sym_STAR,
    ACTIONS(6486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6488), 1,
      anon_sym_AMP,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(8223), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6380), 1,
      sym__declarator,
    STATE(6606), 1,
      sym__abstract_declarator,
    STATE(7502), 1,
      sym_variadic_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(8479), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8477), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [103265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6139), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8475), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8473), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [103373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5904), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103427] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    STATE(4092), 1,
      sym_alignas_qualifier,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4438), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8483), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8481), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [103495] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6659), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4238), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4743), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    STATE(4114), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6807), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    STATE(4184), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6826), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103705] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1369), 1,
      sym_alignas_qualifier,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4420), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6151), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8483), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8481), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [103773] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6399), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4950), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103862] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(8501), 1,
      anon_sym_COLON,
    STATE(2895), 1,
      sym__enum_base_clause,
    STATE(2984), 1,
      sym_enumerator_list,
    STATE(3041), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6295), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [103929] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8384), 1,
      sym_auto,
    ACTIONS(8386), 1,
      anon_sym_decltype,
    STATE(4313), 1,
      sym_decltype_auto,
    ACTIONS(5985), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5987), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [103988] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2685), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4285), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4859), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104077] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6894), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4265), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4952), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104166] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6206), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4960), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104255] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6896), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4953), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104344] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6896), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4267), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4953), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104433] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6897), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4954), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5859), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [104577] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3288), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4280), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4830), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104666] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 1,
      anon_sym___attribute,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6123), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(7240), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [104747] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6354), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4951), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104836] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8543), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(2007), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(2005), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [104895] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6175), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4948), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104984] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6121), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6536), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [105065] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6934), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4293), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4961), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5947), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105207] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8551), 1,
      sym_identifier,
    ACTIONS(8561), 1,
      sym_primitive_type,
    STATE(4409), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4462), 1,
      sym_alignas_qualifier,
    ACTIONS(8558), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4281), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8556), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5731), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5729), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8553), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105276] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6761), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4291), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4956), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6482), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105365] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8543), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(1999), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(1997), 33,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [105424] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3296), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105513] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8569), 1,
      sym_identifier,
    ACTIONS(8579), 1,
      sym_primitive_type,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(4532), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8576), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8574), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5755), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5753), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8571), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105582] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3309), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4862), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105671] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6373), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4259), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4949), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105760] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6175), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4264), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4948), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105849] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2667), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4927), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105938] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6237), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4273), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4931), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106027] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8583), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6122), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8581), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [106108] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3296), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4282), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106197] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2671), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4301), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4974), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106286] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6399), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4271), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4950), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106375] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6763), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4958), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106464] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3333), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4826), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106553] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6940), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4962), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106642] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3391), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4292), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106731] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6940), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4297), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4962), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106820] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(8501), 1,
      anon_sym_COLON,
    STATE(2889), 1,
      sym__enum_base_clause,
    STATE(2992), 1,
      sym_enumerator_list,
    STATE(3023), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6305), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [106887] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6943), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4963), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106976] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3333), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4300), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4826), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107065] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8601), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6118), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8599), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [107146] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3401), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4828), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107235] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2685), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8495), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4859), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7860), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5999), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107376] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4478), 1,
      sym_alignas_qualifier,
    ACTIONS(8606), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5024), 13,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(5026), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8603), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6055), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4257), 1,
      sym_new_declarator,
    STATE(4132), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6569), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6093), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5991), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6021), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6097), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6039), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6131), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6081), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6063), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4462), 1,
      sym_alignas_qualifier,
    ACTIONS(8612), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5026), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8609), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5024), 15,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [108032] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4247), 1,
      sym_new_declarator,
    STATE(4151), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6559), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108100] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    STATE(4484), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(4223), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [108162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6051), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6059), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108266] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4235), 1,
      sym_new_declarator,
    STATE(4127), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6573), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6067), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6047), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6013), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6113), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6089), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108594] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    ACTIONS(8366), 1,
      anon_sym___attribute,
    ACTIONS(8617), 1,
      sym_auto,
    ACTIONS(8619), 1,
      anon_sym_decltype,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(5126), 1,
      sym_decltype_auto,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6383), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4461), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6047), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6047), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6143), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108836] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    ACTIONS(8374), 1,
      anon_sym___attribute,
    ACTIONS(8617), 1,
      sym_auto,
    ACTIONS(8619), 1,
      anon_sym_decltype,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(5126), 1,
      sym_decltype_auto,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6386), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4456), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [108922] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8197), 1,
      anon_sym_LBRACK,
    ACTIONS(8382), 1,
      anon_sym_LPAREN2,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(4256), 1,
      sym_new_declarator,
    STATE(4143), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6547), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108990] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(4484), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5793), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [109052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6797), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4343), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5034), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6482), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5859), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109192] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6397), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4466), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6043), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6031), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6484), 1,
      anon_sym_STAR,
    ACTIONS(6486), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6488), 1,
      anon_sym_AMP,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6380), 1,
      sym__declarator,
    STATE(6606), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(8479), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8477), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [109474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6123), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6077), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6105), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109630] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6362), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4459), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6127), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109766] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7860), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(4252), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6810), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7862), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7864), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4037), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5079), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5859), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6013), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6017), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5995), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6109), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5743), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8627), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5875), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5872), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [110171] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6899), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4357), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5162), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6482), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110258] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(7024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [110343] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(7024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [110426] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    ACTIONS(8658), 1,
      anon_sym_LBRACK,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(4560), 1,
      sym_new_declarator,
    STATE(5069), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6567), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6569), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110493] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [110572] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [110643] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [110716] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6901), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5164), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110803] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    ACTIONS(8658), 1,
      anon_sym_LBRACK,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(4626), 1,
      sym_new_declarator,
    STATE(5119), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6557), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6559), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [110870] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6297), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5183), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110955] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6320), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4392), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5134), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111040] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7445), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [111139] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8686), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7449), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [111242] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6893), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4371), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5185), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6482), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111329] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7403), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [111428] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    ACTIONS(8658), 1,
      anon_sym_LBRACK,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(4578), 1,
      sym_new_declarator,
    STATE(5092), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6545), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6547), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [111495] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8686), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8694), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8696), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [111598] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6326), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4359), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5174), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111683] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6515), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4521), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111766] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(5029), 1,
      sym_decltype_auto,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6438), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4555), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111849] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6853), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5123), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111936] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6903), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112023] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8686), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7457), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [112126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8627), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5745), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5743), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [112181] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6920), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4380), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5193), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(4515), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5791), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8706), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5793), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [112327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(4126), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6803), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112384] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(4070), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6830), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112441] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7465), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [112540] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6863), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5122), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112625] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6861), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5121), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112710] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7473), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [112809] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6861), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4379), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5121), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7148), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112945] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8708), 1,
      anon_sym_LT,
    STATE(4515), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4557), 1,
      sym_template_argument_list,
    ACTIONS(4215), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8706), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4223), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [113006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6915), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4370), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5192), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6482), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113093] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    ACTIONS(8658), 1,
      anon_sym_LBRACK,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(4558), 1,
      sym_new_declarator,
    STATE(5114), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6571), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6573), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [113160] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8686), 1,
      anon_sym_QMARK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7210), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [113263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(4184), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6826), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8710), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6879), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(3364), 30,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_private,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [113375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(4114), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6807), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113432] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [113501] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6326), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4207), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5174), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4205), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7066), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113637] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(7022), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [113732] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8670), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8678), 1,
      anon_sym_or,
    ACTIONS(8680), 1,
      anon_sym_and,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7469), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [113831] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8674), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [113922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(7136), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113973] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8648), 1,
      anon_sym_GT_EQ,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8654), 1,
      anon_sym_not_eq,
    ACTIONS(8676), 1,
      anon_sym_CARET,
    ACTIONS(8682), 1,
      anon_sym_xor,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8642), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8644), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8646), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7022), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [114062] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8640), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8636), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8638), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8650), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(7024), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [114137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1949), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [114187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5481), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [114237] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6596), 1,
      anon_sym_STAR,
    ACTIONS(6598), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6600), 1,
      anon_sym_AMP,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6380), 1,
      sym__declarator,
    STATE(6783), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(8477), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8479), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [114329] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8366), 1,
      anon_sym___attribute,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6558), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4602), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5497), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [114463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5509), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [114513] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8739), 1,
      anon_sym_SEMI,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7012), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9106), 1,
      sym_attribute_specifier,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [114619] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8374), 1,
      anon_sym___attribute,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6561), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4604), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114703] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8366), 1,
      anon_sym___attribute,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6533), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4608), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5743), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8749), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5875), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5872), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [114843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5489), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [114893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1369), 1,
      sym_alignas_qualifier,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8483), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8481), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [114953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5493), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [115003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    ACTIONS(2005), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2007), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [115059] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8374), 1,
      anon_sym___attribute,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6545), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4618), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115143] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6735), 1,
      sym_identifier,
    ACTIONS(6739), 1,
      sym_primitive_type,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(2736), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8755), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5755), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5753), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(8752), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5501), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [115259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5656), 37,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [115309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8758), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8760), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5767), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5769), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115363] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6580), 1,
      anon_sym_STAR,
    ACTIONS(6582), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6584), 1,
      anon_sym_AMP,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6380), 1,
      sym__declarator,
    STATE(6819), 1,
      sym__abstract_declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    ACTIONS(8477), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8479), 3,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [115455] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    STATE(1369), 1,
      sym_alignas_qualifier,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8764), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8762), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [115515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5505), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [115565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5477), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [115615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    STATE(4092), 1,
      sym_alignas_qualifier,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8483), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8481), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [115675] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6924), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4426), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5219), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6482), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8760), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5779), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5781), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115813] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6926), 1,
      sym__abstract_declarator,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5220), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115899] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(6992), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8454), 1,
      sym_attribute_specifier,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [116005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    ACTIONS(1997), 5,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(1999), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [116061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5485), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116111] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6717), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      sym_primitive_type,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(4577), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8779), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4415), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8777), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5731), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5729), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(8774), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4217), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116229] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7033), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8319), 1,
      sym_attribute_specifier,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [116335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5465), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6527), 1,
      sym_identifier,
    ACTIONS(6531), 1,
      sym_primitive_type,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2622), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8787), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6529), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5755), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5753), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8784), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5461), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116551] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 1,
      sym_identifier,
    ACTIONS(6525), 1,
      sym_primitive_type,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(4598), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8795), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4434), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8793), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5731), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5729), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8790), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116617] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    STATE(4092), 1,
      sym_alignas_qualifier,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8764), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8762), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [116677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(7479), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5473), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8749), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5745), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5743), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [116881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5469), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1945), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [116981] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    ACTIONS(8617), 1,
      sym_auto,
    ACTIONS(8619), 1,
      anon_sym_decltype,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(5126), 1,
      sym_decltype_auto,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6619), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4788), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5166), 28,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [117111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8800), 1,
      anon_sym_and,
    ACTIONS(5779), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5781), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117164] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2654), 1,
      sym_alignas_qualifier,
    ACTIONS(6755), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5026), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(6752), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(5024), 14,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [117221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5890), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5892), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5921), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5923), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8708), 1,
      anon_sym_LT,
    STATE(4557), 1,
      sym_template_argument_list,
    ACTIONS(2005), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2007), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5168), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5166), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [117431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6958), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6960), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [117480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6950), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6952), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [117529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4449), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5902), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8804), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117582] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    ACTIONS(8583), 1,
      anon_sym___attribute,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6388), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8708), 1,
      anon_sym_LT,
    STATE(4557), 1,
      sym_template_argument_list,
    ACTIONS(1997), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1999), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117714] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6375), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117789] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6385), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5906), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5908), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [117917] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    ACTIONS(8601), 1,
      anon_sym___attribute,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6384), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2197), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [118043] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7014), 1,
      sym__abstract_declarator,
    ACTIONS(6536), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4029), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5244), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118128] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6393), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118205] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(7242), 1,
      anon_sym___attribute,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8309), 1,
      anon_sym_const,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(4462), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6394), 1,
      sym__abstract_declarator,
    ACTIONS(8311), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4314), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8299), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118282] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6423), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4217), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5917), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5919), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [118461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym___attribute__,
    ACTIONS(8819), 1,
      anon_sym___attribute,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8814), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8812), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [118516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5925), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5927), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [118569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7026), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(7028), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [118618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4450), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5929), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8822), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5931), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [118671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4449), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5857), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8804), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [118724] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4205), 1,
      sym_ms_restrict_modifier,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4244), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6986), 1,
      sym__abstract_declarator,
    ACTIONS(6482), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8444), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8446), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4463), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5240), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118809] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6611), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4758), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8824), 1,
      anon_sym___attribute__,
    ACTIONS(8827), 1,
      anon_sym___attribute,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8814), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8812), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [118945] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4468), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5939), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8830), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5941), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [118998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2197), 28,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [119047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7479), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5884), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8832), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5886), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [119149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8798), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8800), 1,
      anon_sym_and,
    ACTIONS(8834), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8836), 1,
      anon_sym_or,
    ACTIONS(5767), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5769), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119206] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6724), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4777), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119287] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    ACTIONS(8617), 1,
      sym_auto,
    ACTIONS(8619), 1,
      anon_sym_decltype,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(5126), 1,
      sym_decltype_auto,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6663), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4776), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5913), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5915), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [119421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4470), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5896), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8838), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5898), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [119474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4373), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5935), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8802), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5937), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [119527] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6361), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119602] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [119668] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7403), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [119760] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7457), 1,
      anon_sym___attribute,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7459), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [119856] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7212), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [119950] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(4809), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5791), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5793), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [120008] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [120086] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [120168] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [120258] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [120346] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [120430] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [120512] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [120590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6754), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4955), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8364), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120670] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2714), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5716), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5793), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [120728] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(6536), 1,
      anon_sym_COLON,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7093), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5258), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120812] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7459), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [120906] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [120982] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [121054] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [121120] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7024), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [121188] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7465), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [121280] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7469), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [121372] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [121460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8543), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2609), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4215), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4223), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [121518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4513), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5857), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8880), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [121570] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5890), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5892), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [121622] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [121706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5913), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5915), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [121758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    ACTIONS(8886), 1,
      anon_sym___attribute,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8884), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [121854] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(7024), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [121924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4528), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5939), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8888), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5941), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [121976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4529), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5896), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8890), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5898), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122028] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    ACTIONS(8894), 1,
      anon_sym___attribute,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8892), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [122124] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6437), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122198] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [122274] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6442), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122348] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8896), 1,
      sym_identifier,
    ACTIONS(8900), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4817), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5762), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8898), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5753), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5755), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5757), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122412] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6446), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122486] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7473), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [122578] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [122668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5917), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5919), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5925), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5927), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4536), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5929), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8902), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5931), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4537), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5884), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8904), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5886), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122876] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5935), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5937), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4513), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5902), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8880), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122980] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [123048] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4886), 1,
      sym_field_declaration_list,
    STATE(5044), 1,
      sym_attribute_specifier,
    STATE(7138), 1,
      sym_virtual_specifier,
    STATE(7955), 1,
      sym_base_class_clause,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5866), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5868), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [123114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5921), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5923), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [123166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4442), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5906), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8882), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5908), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [123218] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(8910), 1,
      anon_sym_RPAREN,
    ACTIONS(8912), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7509), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [123318] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8914), 1,
      anon_sym_COMMA,
    ACTIONS(8916), 1,
      anon_sym_SEMI,
    ACTIONS(8918), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7810), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [123418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(2609), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5668), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5793), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [123476] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7453), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [123570] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7210), 1,
      anon_sym___attribute,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7212), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [123666] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [123756] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [123828] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [123898] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [123984] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7449), 1,
      anon_sym___attribute,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8741), 1,
      anon_sym_QMARK,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7453), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [124080] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [124170] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6757), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4957), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8372), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124250] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [124340] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [124430] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      sym_identifier,
    ACTIONS(8922), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2558), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5738), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4524), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6563), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5729), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5731), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5733), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124494] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7445), 1,
      anon_sym___attribute,
    ACTIONS(8719), 1,
      anon_sym_SLASH,
    ACTIONS(8725), 1,
      anon_sym_PIPE,
    ACTIONS(8729), 1,
      anon_sym_AMP,
    ACTIONS(8735), 1,
      anon_sym_GT_EQ,
    ACTIONS(8743), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8745), 1,
      anon_sym_bitor,
    ACTIONS(8747), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8715), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8717), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8723), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8727), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8737), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8731), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8733), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [124586] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6482), 1,
      anon_sym_COLON,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8301), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7122), 1,
      sym__abstract_declarator,
    ACTIONS(8303), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8305), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4502), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(5283), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124670] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7341), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(4092), 1,
      sym_alignas_qualifier,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6444), 1,
      sym__abstract_declarator,
    ACTIONS(7343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3735), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7328), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124744] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(8962), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7802), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [124841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2040), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [124888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    STATE(5068), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6801), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6803), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [124941] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(8966), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7645), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125038] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    STATE(4987), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6824), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6826), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [125091] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8994), 1,
      anon_sym_RBRACK,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7475), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125188] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9004), 1,
      anon_sym_COMMA,
    ACTIONS(9006), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7406), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125285] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9008), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7759), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125382] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9012), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7658), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7479), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125526] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    ACTIONS(9014), 1,
      sym_auto,
    ACTIONS(9016), 1,
      anon_sym_decltype,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2365), 1,
      sym_decltype_auto,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6780), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5105), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8364), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125605] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9018), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7744), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125702] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9020), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7483), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125799] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9022), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7778), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [125896] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5074), 1,
      sym_field_declaration_list,
    STATE(5172), 1,
      sym_attribute_specifier,
    STATE(7227), 1,
      sym_virtual_specifier,
    STATE(8076), 1,
      sym_base_class_clause,
    ACTIONS(5866), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5868), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [125961] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9030), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7424), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126058] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9032), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7550), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1665), 1,
      sym__fold_operator,
    ACTIONS(9036), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(9034), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [126204] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(4989), 1,
      sym_ref_qualifier,
    STATE(5718), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5424), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [126293] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9051), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7732), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126390] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9053), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2636), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5743), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6629), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5875), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(5872), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [126538] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    STATE(4992), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6805), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6807), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [126591] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9055), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7428), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126688] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9057), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7410), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126785] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9059), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7586), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126882] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9061), 1,
      anon_sym_COMMA,
    ACTIONS(9063), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7439), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [126979] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    STATE(4484), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4215), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8615), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4223), 27,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [127036] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9067), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9065), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127131] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9069), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7459), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127228] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9071), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7384), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127325] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8918), 1,
      anon_sym_RBRACE,
    ACTIONS(9073), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7810), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127422] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9075), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7397), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127519] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9077), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7526), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127616] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9079), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7534), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127713] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9081), 1,
      anon_sym_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    STATE(4716), 1,
      sym__enum_base_clause,
    STATE(4902), 1,
      sym_enumerator_list,
    STATE(5088), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6295), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [127774] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9085), 1,
      anon_sym_COMMA,
    ACTIONS(9087), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7646), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127871] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9089), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7782), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [127968] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9091), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7754), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128065] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9093), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7488), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128162] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9095), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7698), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128259] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9097), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7369), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2464), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5743), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(6355), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5875), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(5872), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [128409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4217), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128458] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9099), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7557), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128555] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9101), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7806), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [128652] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    ACTIONS(8601), 1,
      anon_sym___attribute,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6560), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128727] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6577), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128802] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    ACTIONS(8583), 1,
      anon_sym___attribute,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6562), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128877] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(7242), 1,
      anon_sym___attribute,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6578), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128952] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9103), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7396), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129049] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9105), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7783), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129146] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    ACTIONS(8601), 1,
      anon_sym___attribute,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6540), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129221] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9107), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7626), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129318] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9109), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7519), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129415] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9111), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7500), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129512] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5057), 1,
      sym_ref_qualifier,
    STATE(5685), 1,
      sym__function_attributes_end,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5373), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [129601] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9119), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7517), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129698] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9121), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7604), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129795] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9123), 1,
      anon_sym_RPAREN,
    ACTIONS(9125), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [129892] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6538), 1,
      anon_sym___attribute,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6569), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129967] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(8912), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7509), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [130064] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    ACTIONS(8583), 1,
      anon_sym___attribute,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6549), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130139] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6719), 1,
      anon_sym_const,
    ACTIONS(7242), 1,
      anon_sym___attribute,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    STATE(2654), 1,
      sym_alignas_qualifier,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6570), 1,
      sym__abstract_declarator,
    ACTIONS(8402), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4448), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8400), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130214] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    ACTIONS(9014), 1,
      sym_auto,
    ACTIONS(9016), 1,
      anon_sym_decltype,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2365), 1,
      sym_decltype_auto,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6809), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5047), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8372), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130293] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8916), 1,
      anon_sym_SEMI,
    ACTIONS(9127), 1,
      anon_sym_COMMA,
    ACTIONS(9130), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [130390] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9132), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7398), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [130487] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9134), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7574), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [130584] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9136), 1,
      anon_sym_LT,
    STATE(2714), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(4215), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5716), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4223), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [130641] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9138), 1,
      anon_sym_COMMA,
    ACTIONS(9140), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7408), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [130738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(8656), 1,
      anon_sym_LPAREN2,
    STATE(5080), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6828), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6830), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [130791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1973), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1977), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1955), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1981), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [130979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1985), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [131026] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9053), 1,
      anon_sym_SEMI,
    ACTIONS(9142), 1,
      anon_sym_COMMA,
    ACTIONS(9145), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1993), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [131170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1989), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [131217] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9147), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7777), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2011), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2013), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [131363] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9149), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7618), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131460] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9151), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7693), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131557] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9153), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7435), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131654] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9155), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7414), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131751] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9157), 1,
      anon_sym_COMMA,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7531), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131848] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9161), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7564), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [131945] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9163), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7615), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2019), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [132091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2017), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2019), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [132140] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    ACTIONS(9165), 1,
      anon_sym_GT2,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    STATE(7668), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132237] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(9167), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7474), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132334] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9081), 1,
      anon_sym_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    STATE(4675), 1,
      sym__enum_base_clause,
    STATE(4885), 1,
      sym_enumerator_list,
    STATE(5037), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6305), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [132395] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9169), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7445), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2027), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2029), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [132539] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9171), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    STATE(7401), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132636] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9199), 1,
      anon_sym_COLON,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132730] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132822] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9211), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132916] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9213), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133010] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [133078] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7212), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133170] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6968), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [133228] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9215), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133322] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9217), 1,
      anon_sym_COMMA,
    ACTIONS(9219), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133416] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9221), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133508] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [133590] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [133678] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7212), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133770] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [133834] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [133920] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [134004] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [134086] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [134166] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [134242] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134316] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134386] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134452] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [134520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    STATE(4903), 1,
      sym_enumerator_list,
    STATE(5097), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6085), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134576] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [134664] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7453), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [134756] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [134844] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7459), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [134936] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(8916), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135030] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9223), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135124] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9136), 1,
      anon_sym_LT,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(2005), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2007), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135268] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9053), 1,
      anon_sym_COLON,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135362] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9225), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135456] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [135544] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9227), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135638] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [135726] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9229), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135820] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9130), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [135912] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9145), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136004] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6877), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5190), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8372), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136082] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9231), 1,
      anon_sym_COMMA,
    ACTIONS(9233), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136176] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [136242] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7459), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136334] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [136406] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6888), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5163), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8372), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136484] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7447), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [136572] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8696), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136664] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7453), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136756] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7467), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [136844] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9235), 1,
      sym_ms_restrict_modifier,
    STATE(5131), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(9238), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9241), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4702), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(8345), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8347), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136900] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9244), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [136994] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6849), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5191), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8364), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137072] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137164] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7453), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137256] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7405), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [137344] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9248), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137438] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7012), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [137498] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9250), 1,
      anon_sym_COMMA,
    ACTIONS(9252), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137592] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7459), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137684] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6633), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137756] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7471), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [137844] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [137938] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9256), 1,
      anon_sym_COMMA,
    ACTIONS(9258), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    STATE(4917), 1,
      sym_enumerator_list,
    STATE(4998), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6071), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [138088] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9260), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138182] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9262), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138274] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9262), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138366] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [138446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9136), 1,
      anon_sym_LT,
    STATE(3002), 1,
      sym_template_argument_list,
    ACTIONS(1997), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(1999), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [138498] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9264), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138592] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6978), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [138650] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9266), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138744] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7008), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [138804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    ACTIONS(9268), 1,
      anon_sym_COLON,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    STATE(4812), 1,
      sym__enum_base_clause,
    STATE(5028), 1,
      sym_enumerator_list,
    STATE(5149), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6305), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [138864] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7010), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7012), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [138924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9272), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139018] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6966), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6968), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [139076] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4283), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4285), 1,
      anon_sym_AMP,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8477), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6706), 1,
      sym__declarator,
    STATE(6917), 1,
      sym__abstract_declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [139162] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9274), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139256] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6976), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6978), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [139314] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9276), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139408] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9262), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139594] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139660] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9280), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139752] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9282), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139846] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9284), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139938] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139998] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9286), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140092] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9288), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140186] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6680), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2019), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [140304] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9290), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140398] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9292), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140490] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9294), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140584] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9296), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140678] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7000), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140738] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9298), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140832] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9300), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [140926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6631), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140998] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9302), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141092] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9304), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141184] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9065), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141276] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9306), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141370] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7006), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7008), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [141430] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6616), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9308), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141594] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7447), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141682] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2556), 1,
      sym_attribute_specifier,
    STATE(5439), 1,
      sym_field_declaration_list,
    STATE(7289), 1,
      sym_virtual_specifier,
    STATE(8156), 1,
      sym_base_class_clause,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5868), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5866), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [141744] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6885), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5161), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8364), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4456), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4451), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [141870] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7475), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [141958] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7024), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [142022] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6998), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7000), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [142082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4225), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4217), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [142134] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9310), 1,
      anon_sym_COMMA,
    ACTIONS(9312), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142228] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9314), 1,
      anon_sym_COMMA,
    ACTIONS(9316), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142322] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9125), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142416] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [142502] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [142586] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7471), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142674] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7467), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142762] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7212), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142854] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6681), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6605), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142998] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9318), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143092] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9209), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143184] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9320), 1,
      anon_sym_COMMA,
    ACTIONS(9322), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143278] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9324), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143372] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9326), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143466] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9328), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143558] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9330), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143652] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7983), 1,
      anon_sym_COMMA,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143746] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7405), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143834] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7022), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [143898] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6662), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [143970] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [144046] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9304), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144138] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [144212] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(7024), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [144272] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [144358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [144442] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [144524] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7022), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [144594] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8924), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8952), 1,
      anon_sym_QMARK,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9262), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144686] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(7022), 1,
      anon_sym_PIPE,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [144766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    ACTIONS(9268), 1,
      anon_sym_COLON,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    STATE(4818), 1,
      sym__enum_base_clause,
    STATE(5066), 1,
      sym_enumerator_list,
    STATE(5137), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6295), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144826] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    ACTIONS(7996), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_DOT,
    ACTIONS(8932), 1,
      anon_sym_SLASH,
    ACTIONS(8938), 1,
      anon_sym_PIPE,
    ACTIONS(8942), 1,
      anon_sym_AMP,
    ACTIONS(8948), 1,
      anon_sym_LT_LT,
    ACTIONS(8950), 1,
      anon_sym_GT_GT,
    ACTIONS(8954), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8956), 1,
      anon_sym_bitor,
    ACTIONS(8958), 1,
      anon_sym_bitand,
    STATE(3934), 1,
      sym_argument_list,
    STATE(3936), 1,
      sym_subscript_argument_list,
    ACTIONS(8000), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8928), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8930), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8934), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8936), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8940), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8960), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8944), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7475), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8946), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144914] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9173), 1,
      anon_sym_COMMA,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9334), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145008] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [145084] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7022), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [145158] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7022), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7024), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [145228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8658), 1,
      anon_sym_LBRACK,
    STATE(4829), 1,
      sym_new_declarator,
    ACTIONS(6924), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6926), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [145278] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6685), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145350] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9336), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145441] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5890), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5892), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5913), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5915), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4813), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5939), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9340), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5941), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4814), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5896), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9342), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5898), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    STATE(5002), 1,
      sym_enumerator_list,
    STATE(5146), 1,
      sym_attribute_specifier,
    ACTIONS(6083), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6085), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5917), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5919), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5925), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5927), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4822), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5929), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9344), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5931), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145839] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4823), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5884), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5886), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5935), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5937), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145937] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    STATE(5030), 1,
      sym_enumerator_list,
    STATE(5169), 1,
      sym_attribute_specifier,
    ACTIONS(6069), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6071), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5902), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9348), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5904), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [146041] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9350), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146132] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3333), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5921), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5923), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [146254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5906), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9338), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5908), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [146303] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9352), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146394] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9354), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146485] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3401), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146558] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9356), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9358), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146649] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3383), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7014), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7016), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [146767] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3296), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146840] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6977), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5226), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8364), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [146917] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9360), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147008] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9362), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147099] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9364), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147190] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9366), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147281] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(7255), 1,
      sym_auto,
    ACTIONS(7257), 1,
      anon_sym_decltype,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3076), 1,
      sym_decltype_auto,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6923), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5230), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8372), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [147358] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147449] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9370), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147540] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9372), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147631] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9374), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147722] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9376), 1,
      anon_sym_RBRACE,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147813] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9378), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147904] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5286), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147995] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9380), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9382), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6958), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6960), 30,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [148133] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9385), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148224] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9387), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148315] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9389), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148406] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9391), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148497] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5342), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148588] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5346), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148679] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5355), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148770] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5213), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148861] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3309), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148934] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149025] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5367), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149116] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9393), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149207] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9395), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149298] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2667), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149371] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9397), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149462] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9399), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149553] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3259), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149626] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5328), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149717] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5288), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149808] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9401), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149899] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5236), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149990] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9403), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150081] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9405), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150172] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9407), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150263] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9356), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9409), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150354] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9411), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150445] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9413), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150536] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5536), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6112), 1,
      sym__declarator,
    STATE(7785), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [150617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5035), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6237), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [150668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5042), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6241), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [150719] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9415), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8368), 1,
      sym_auto,
    ACTIONS(8370), 1,
      anon_sym_decltype,
    STATE(5029), 1,
      sym_decltype_auto,
    ACTIONS(5985), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5987), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [150861] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9417), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150952] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9419), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9421), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151134] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5334), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5344), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151316] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9423), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151407] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5087), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6185), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151458] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5094), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6197), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5107), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6189), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151560] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5112), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6221), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [151611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(7479), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [151656] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9425), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151747] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9427), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151838] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9429), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9431), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152020] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9433), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9435), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152202] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9437), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152293] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9439), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152384] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9441), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152475] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9443), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152566] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9445), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152657] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152748] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5324), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(4997), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6217), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5000), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6225), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5001), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6229), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152992] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5003), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6233), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [153043] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(7887), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9179), 1,
      anon_sym_SLASH,
    ACTIONS(9185), 1,
      anon_sym_PIPE,
    ACTIONS(9189), 1,
      anon_sym_AMP,
    ACTIONS(9195), 1,
      anon_sym_GT_EQ,
    ACTIONS(9201), 1,
      anon_sym_QMARK,
    ACTIONS(9203), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9205), 1,
      anon_sym_bitor,
    ACTIONS(9207), 1,
      anon_sym_bitand,
    ACTIONS(9447), 1,
      anon_sym_COLON,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(7889), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(9175), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9177), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9181), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9183), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9187), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(9197), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(9191), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(9193), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153134] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9449), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153225] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9451), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153316] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9453), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153407] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4279), 1,
      anon_sym_LPAREN2,
    ACTIONS(4281), 1,
      anon_sym_STAR,
    ACTIONS(4283), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4285), 1,
      anon_sym_AMP,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6494), 1,
      anon_sym_LBRACK,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6913), 1,
      sym__declarator,
    STATE(7124), 1,
      sym__abstract_declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [153490] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9455), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153581] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9457), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153672] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9459), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153763] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9461), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153854] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9463), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153945] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9465), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5007), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6181), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [154087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    STATE(5008), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6193), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [154138] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9467), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9469), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154320] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9471), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154411] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9473), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154502] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9475), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154593] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9477), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154684] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9479), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9481), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154866] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2655), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154939] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9483), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155030] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9485), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155121] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9487), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155212] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6175), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155285] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9489), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155376] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9491), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155467] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9493), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155558] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9495), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155649] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5215), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155740] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5375), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155831] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9497), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155922] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9499), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156013] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9501), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156104] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9503), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156195] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5213), 1,
      sym_ref_qualifier,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6106), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5568), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [156282] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5562), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6090), 1,
      sym__declarator,
    STATE(7789), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [156363] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5267), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156454] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5215), 1,
      sym_ref_qualifier,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6088), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5583), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [156541] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5256), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156632] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    ACTIONS(9505), 1,
      anon_sym_RBRACK,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156723] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6206), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [156796] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6399), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [156869] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6354), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [156942] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6358), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157015] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6896), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157088] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6897), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157161] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6898), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157234] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6755), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8599), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157305] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6763), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6536), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157376] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6758), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8581), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157447] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6744), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7240), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157518] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5575), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6114), 1,
      sym__declarator,
    STATE(7811), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [157599] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6224), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157672] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6940), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157745] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6943), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157818] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6946), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [157891] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5533), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6124), 1,
      sym__declarator,
    STATE(7441), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [157972] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9507), 1,
      anon_sym_SEMI,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158063] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5535), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6089), 1,
      sym__declarator,
    STATE(7432), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [158144] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5222), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158235] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5542), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6104), 1,
      sym__declarator,
    STATE(7662), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [158316] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(5547), 1,
      sym_ms_call_modifier,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6110), 1,
      sym__declarator,
    STATE(7438), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [158397] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9067), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158488] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9509), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158579] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9511), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8088), 1,
      sym_literal_suffix,
    ACTIONS(4225), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [158717] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2685), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [158790] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2381), 1,
      sym_attribute_specifier,
    STATE(5301), 1,
      sym_field_declaration_list,
    STATE(7335), 1,
      sym_virtual_specifier,
    STATE(8197), 1,
      sym_base_class_clause,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5866), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5868), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_requires,
  [158853] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9513), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158944] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9515), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159035] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9517), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159126] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9519), 1,
      anon_sym_RPAREN,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159217] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5272), 1,
      anon_sym_RBRACK,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8974), 1,
      anon_sym_SLASH,
    ACTIONS(8980), 1,
      anon_sym_PIPE,
    ACTIONS(8984), 1,
      anon_sym_AMP,
    ACTIONS(8990), 1,
      anon_sym_GT_EQ,
    ACTIONS(8996), 1,
      anon_sym_QMARK,
    ACTIONS(8998), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(9000), 1,
      anon_sym_bitor,
    ACTIONS(9002), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8970), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8972), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8976), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8978), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8982), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8992), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8986), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8988), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159308] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9521), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159399] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9523), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159490] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9525), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159581] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9527), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159672] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    ACTIONS(9529), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159763] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(5248), 1,
      sym_ref_qualifier,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6096), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5591), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [159849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7152), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [159893] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(5565), 1,
      sym_ms_call_modifier,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6854), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [159971] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(5869), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5457), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [160051] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6980), 1,
      sym__abstract_declarator,
    ACTIONS(8364), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5251), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [160127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5166), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6241), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7216), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7238), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7070), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7074), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6139), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5991), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6021), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7078), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6067), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6143), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5175), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6225), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6123), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6077), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7118), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [160799] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5553), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6687), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [160877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6131), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6081), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [160965] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6984), 1,
      sym__abstract_declarator,
    ACTIONS(8372), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5252), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [161041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6089), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7124), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7132), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7140), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7144), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7156), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7160), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6055), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161437] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    ACTIONS(6970), 1,
      anon_sym_LBRACK,
    ACTIONS(6972), 1,
      anon_sym_DOT,
    ACTIONS(8684), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8844), 1,
      anon_sym_SLASH,
    ACTIONS(8850), 1,
      anon_sym_PIPE,
    ACTIONS(8854), 1,
      anon_sym_AMP,
    ACTIONS(8860), 1,
      anon_sym_GT_EQ,
    ACTIONS(8864), 1,
      anon_sym_QMARK,
    ACTIONS(8866), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8868), 1,
      anon_sym_bitor,
    ACTIONS(8870), 1,
      anon_sym_bitand,
    STATE(2939), 1,
      sym_argument_list,
    STATE(2944), 1,
      sym_subscript_argument_list,
    ACTIONS(6974), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8313), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8840), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8842), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8846), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8848), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8852), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8862), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8856), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8858), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5999), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6093), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6097), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5147), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6237), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5176), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6229), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5177), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6233), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5136), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6185), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7134), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7136), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [161901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5144), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6197), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6063), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [161995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5179), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6181), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162045] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5573), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6676), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5180), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6193), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6035), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162217] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6810), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [162287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6051), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7066), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [162375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6059), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162419] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5567), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6613), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7098), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [162541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9550), 1,
      anon_sym_COMMA,
    ACTIONS(9552), 1,
      anon_sym_RBRACK,
    ACTIONS(4225), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4217), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [162589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6109), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162677] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5570), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6664), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6113), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [162799] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5578), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6722), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7146), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7148), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [162921] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6817), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8581), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [162991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8617), 1,
      sym_auto,
    ACTIONS(8619), 1,
      anon_sym_decltype,
    STATE(5126), 1,
      sym_decltype_auto,
    ACTIONS(5985), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5987), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [163041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [163085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [163129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2286), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [163173] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5250), 1,
      sym_ref_qualifier,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5597), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [163259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_SEMI,
    ACTIONS(5666), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6642), 1,
      anon_sym_LPAREN2,
    ACTIONS(6645), 1,
      anon_sym_LBRACK,
    ACTIONS(4225), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4217), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [163311] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9555), 1,
      anon_sym_requires,
    STATE(5241), 1,
      sym_ref_qualifier,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6352), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5602), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [163397] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9558), 1,
      anon_sym_COLON,
    STATE(4675), 1,
      sym__enum_base_clause,
    STATE(4885), 1,
      sym_enumerator_list,
    STATE(5037), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6305), 26,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163455] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9558), 1,
      anon_sym_COLON,
    STATE(4716), 1,
      sym__enum_base_clause,
    STATE(4902), 1,
      sym_enumerator_list,
    STATE(5088), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6295), 26,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [163513] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5686), 1,
      sym__function_attributes_end,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5381), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [163593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7094), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(2290), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [163681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7126), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7128), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7178), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7180), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7184), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [163813] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5718), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5424), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [163893] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5576), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6717), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [163971] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5577), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6602), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164049] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5168), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6217), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [164099] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5579), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6630), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7196), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [164221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7202), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7204), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [164265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9566), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5779), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5781), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [164311] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5530), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6618), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164389] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5531), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6610), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164467] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5589), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6641), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5156), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6189), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [164595] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym___attribute__,
    ACTIONS(9026), 1,
      anon_sym___attribute,
    STATE(5158), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6221), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [164645] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5537), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6668), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164723] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5538), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6677), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164801] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5539), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6702), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [164879] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6818), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7240), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [164949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7058), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [164993] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5543), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6654), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165071] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5544), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6658), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165149] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5546), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6674), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6135), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165271] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5548), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6669), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165349] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5549), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6670), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6043), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6031), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165515] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5552), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6595), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [165593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7188), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4225), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4217), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7080), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7082), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5904), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6105), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7206), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7208), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [165857] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5239), 1,
      sym_ref_qualifier,
    STATE(6140), 1,
      sym__function_attributes_end,
    STATE(6314), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5593), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [165943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6127), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [165987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9566), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9568), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5767), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5769), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166035] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(5558), 1,
      sym_ms_call_modifier,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6714), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [166113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5859), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4400), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4396), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7108), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7110), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7050), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7052), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166335] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6808), 1,
      sym__abstract_declarator,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8599), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [166405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6013), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6017), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2282), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166537] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym__function_attributes_end,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5373), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [166617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 4,
      anon_sym_AMP,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5947), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7212), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(5995), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_SEMI,
    ACTIONS(7487), 1,
      sym_literal_suffix,
    ACTIONS(4225), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4217), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [166797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7190), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7192), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7084), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7086), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [166885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6013), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6039), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [166973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7090), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7112), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(7114), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [167061] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym___attribute__,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9570), 1,
      anon_sym_COLON,
    STATE(2588), 1,
      sym_attribute_specifier,
    STATE(2728), 1,
      sym__enum_base_clause,
    STATE(2801), 1,
      sym_enumerator_list,
    ACTIONS(6303), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6305), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [167118] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6863), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167187] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6866), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167256] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6881), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7240), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167325] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    STATE(4809), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4215), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(8872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4223), 24,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [167378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6063), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6053), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6055), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5656), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4273), 1,
      anon_sym_SEMI,
    ACTIONS(4225), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4217), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [167595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9572), 1,
      sym_identifier,
    ACTIONS(9578), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5312), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5738), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5142), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5729), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9575), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5731), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5733), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8473), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8475), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [167697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8432), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(8434), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym___extension__,
      anon_sym___attribute__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [167740] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9581), 1,
      anon_sym_COLON,
    STATE(2588), 1,
      sym_attribute_specifier,
    STATE(5246), 1,
      sym__enum_base_clause,
    STATE(5437), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6305), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6303), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [167795] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6326), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6133), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6135), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6043), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6029), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6031), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [167993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5997), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5999), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6033), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6035), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6091), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6093), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168122] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(9583), 1,
      anon_sym_COLON,
    STATE(2895), 1,
      sym__enum_base_clause,
    STATE(2984), 1,
      sym_enumerator_list,
    STATE(3041), 1,
      sym_attribute_specifier,
    ACTIONS(6293), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6295), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [168179] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9585), 1,
      sym_identifier,
    ACTIONS(9591), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5276), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5762), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5753), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9588), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5755), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5757), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5902), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5904), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6103), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6105), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168324] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9594), 1,
      sym_identifier,
    ACTIONS(9596), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9600), 1,
      anon_sym_EQ,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5729), 1,
      sym_ms_declspec_modifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(9598), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5786), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5513), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [168415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6127), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6051), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6632), 1,
      anon_sym___attribute__,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9570), 1,
      anon_sym_COLON,
    STATE(2555), 1,
      sym_attribute_specifier,
    STATE(2744), 1,
      sym__enum_base_clause,
    STATE(2803), 1,
      sym_enumerator_list,
    ACTIONS(6293), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6295), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [168558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6059), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168601] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8372), 1,
      anon_sym_COLON,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7091), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5285), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2286), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6013), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168762] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8364), 1,
      anon_sym_COLON,
    ACTIONS(8406), 1,
      sym_auto,
    ACTIONS(8408), 1,
      anon_sym_decltype,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7112), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5272), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [168837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(2290), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168880] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9581), 1,
      anon_sym_COLON,
    STATE(2555), 1,
      sym_attribute_specifier,
    STATE(5247), 1,
      sym__enum_base_clause,
    STATE(5441), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6295), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6293), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [168935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6017), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [168978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6095), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6097), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5993), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5995), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6011), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6013), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6039), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169150] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6887), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8599), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169219] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6901), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169288] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6890), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8581), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169357] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6902), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7240), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6107), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6109), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6137), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6139), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5989), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5991), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6019), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6021), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169641] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5294), 1,
      sym_ref_qualifier,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6301), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5610), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [169726] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5254), 1,
      sym_ref_qualifier,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5606), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [169811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6111), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6113), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [169854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(5315), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5793), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5791), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [169905] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6297), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6067), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6143), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6123), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6075), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6077), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6131), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6079), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6081), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170232] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym___attribute__,
    ACTIONS(6896), 1,
      anon_sym___attribute,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(9583), 1,
      anon_sym_COLON,
    STATE(2889), 1,
      sym__enum_base_clause,
    STATE(2992), 1,
      sym_enumerator_list,
    STATE(3023), 1,
      sym_attribute_specifier,
    ACTIONS(6303), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6305), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [170289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170332] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6324), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6047), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170444] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6903), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5857), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5859), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [170556] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(5328), 1,
      sym_ref_qualifier,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6309), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5611), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [170641] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6851), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7240), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170710] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(5324), 1,
      sym_ref_qualifier,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6346), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5614), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [170795] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6860), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8581), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170864] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6918), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8599), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170933] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6853), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171002] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6861), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(4211), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(4209), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6087), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(6089), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [171114] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4410), 1,
      sym_compound_statement,
    STATE(5303), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7984), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171190] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3927), 1,
      sym_compound_statement,
    STATE(5198), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7856), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171266] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3546), 1,
      sym_compound_statement,
    STATE(5292), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8087), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171342] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3857), 1,
      sym_compound_statement,
    STATE(5295), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7876), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2965), 1,
      sym_compound_statement,
    STATE(5227), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7952), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171494] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1881), 1,
      sym_compound_statement,
    STATE(5201), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7940), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171570] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1888), 1,
      sym_compound_statement,
    STATE(5265), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7967), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171646] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5203), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(5893), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8017), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171722] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5280), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(5959), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8035), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171798] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3524), 1,
      sym_compound_statement,
    STATE(5205), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8070), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171874] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3546), 1,
      sym_compound_statement,
    STATE(5288), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8084), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171950] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5207), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6057), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8107), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172026] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5300), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6064), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8112), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172102] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1881), 1,
      sym_compound_statement,
    STATE(5209), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8131), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172178] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1888), 1,
      sym_compound_statement,
    STATE(5313), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8137), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172254] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6106), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5568), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172332] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6088), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5583), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172410] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3670), 1,
      sym_compound_statement,
    STATE(5223), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7843), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172486] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6087), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5559), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172564] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5382), 1,
      sym_ref_qualifier,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6411), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5621), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [172648] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(5869), 1,
      sym_trailing_return_type,
    STATE(6125), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5581), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [172726] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3524), 1,
      sym_compound_statement,
    STATE(5197), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7872), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172802] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5433), 1,
      sym_ref_qualifier,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5631), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [172886] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(5387), 1,
      sym_ref_qualifier,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6407), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5638), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [172970] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6926), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6536), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173038] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6927), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7240), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_COLON,
    STATE(2364), 1,
      sym_attribute_specifier,
    STATE(5231), 1,
      sym__enum_base_clause,
    STATE(5299), 1,
      sym_enumerator_list,
    ACTIONS(6303), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6305), 24,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [173162] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_COLON,
    STATE(2356), 1,
      sym_attribute_specifier,
    STATE(5232), 1,
      sym__enum_base_clause,
    STATE(5304), 1,
      sym_enumerator_list,
    ACTIONS(6293), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6295), 24,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [173218] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3817), 1,
      sym_compound_statement,
    STATE(5291), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8118), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173294] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1881), 1,
      sym_compound_statement,
    STATE(5225), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7936), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173370] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1888), 1,
      sym_compound_statement,
    STATE(5282), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7938), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173446] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6974), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8599), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173514] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2886), 1,
      sym_compound_statement,
    STATE(5281), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8093), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173590] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(5423), 1,
      sym_ref_qualifier,
    STATE(6217), 1,
      sym__function_attributes_end,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5620), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [173674] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5390), 1,
      sym_ref_qualifier,
    STATE(6188), 1,
      sym__function_attributes_end,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5635), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [173758] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6956), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8581), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173826] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2384), 1,
      sym_attribute_specifier,
    STATE(5306), 1,
      sym_enumerator_list,
    ACTIONS(6083), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6085), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [173878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2354), 1,
      sym_attribute_specifier,
    STATE(5310), 1,
      sym_enumerator_list,
    ACTIONS(6069), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6071), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [173930] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(5348), 1,
      sym_ref_qualifier,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5627), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [174014] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4179), 1,
      sym_compound_statement,
    STATE(5235), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8144), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174090] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9611), 1,
      anon_sym_requires,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4116), 1,
      sym_compound_statement,
    STATE(5287), 1,
      sym_requires_clause,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8176), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4808), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5857), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(9348), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [174212] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4443), 1,
      sym_compound_statement,
    STATE(5195), 1,
      sym_template_parameter_list,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7919), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174288] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1893), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_class,
    ACTIONS(1897), 1,
      anon_sym_struct,
    ACTIONS(1899), 1,
      anon_sym_union,
    ACTIONS(1923), 1,
      anon_sym_typename,
    ACTIONS(2736), 1,
      sym_primitive_type,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9596), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9600), 1,
      anon_sym_EQ,
    ACTIONS(9636), 1,
      sym_identifier,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    ACTIONS(9598), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [174372] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6141), 1,
      sym__function_attributes_end,
    STATE(6317), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5592), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [174449] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7014), 1,
      sym__abstract_declarator,
    ACTIONS(6536), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174516] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      anon_sym_requires,
    STATE(6134), 1,
      sym__function_attributes_end,
    STATE(6262), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5590), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [174593] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5597), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [174670] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6140), 1,
      sym__function_attributes_end,
    STATE(6314), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5593), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [174747] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7016), 1,
      sym__abstract_declarator,
    ACTIONS(7240), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174814] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6096), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5591), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [174891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    STATE(2561), 1,
      sym_attribute_specifier,
    STATE(5443), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6085), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6083), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [174940] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    STATE(2590), 1,
      sym_attribute_specifier,
    STATE(5446), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6071), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6069), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [174989] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6097), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5598), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [175066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(9647), 1,
      anon_sym_LPAREN2,
    STATE(2713), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3871), 1,
      sym_argument_list,
    STATE(5095), 1,
      sym_initializer_list,
    ACTIONS(5857), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6758), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [175119] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6035), 1,
      sym_trailing_return_type,
    STATE(6093), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5595), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [175196] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6983), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8599), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175263] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4209), 1,
      anon_sym_const,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(4478), 1,
      sym_alignas_qualifier,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6997), 1,
      sym__abstract_declarator,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8581), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(4303), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8442), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175330] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9555), 1,
      anon_sym_requires,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6352), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5602), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [175407] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6273), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5615), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [175483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8543), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(5315), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4223), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4215), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [175533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5923), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9652), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5921), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [175577] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5908), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9655), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5906), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [175621] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(7240), 1,
      anon_sym_COLON,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7067), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5273), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5898), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9658), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5896), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [175731] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9661), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9667), 1,
      sym_primitive_type,
    ACTIONS(9669), 1,
      anon_sym_enum,
    ACTIONS(9671), 1,
      anon_sym_class,
    ACTIONS(9673), 1,
      anon_sym_struct,
    ACTIONS(9675), 1,
      anon_sym_union,
    ACTIONS(9677), 1,
      sym_auto,
    ACTIONS(9679), 1,
      anon_sym_decltype,
    ACTIONS(9681), 1,
      anon_sym_typename,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3159), 1,
      sym_type_specifier,
    STATE(3430), 1,
      sym_decltype_auto,
    STATE(3503), 1,
      sym_qualified_type_identifier,
    STATE(5523), 1,
      sym_argument_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3348), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3434), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175811] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9689), 1,
      sym_primitive_type,
    ACTIONS(9691), 1,
      anon_sym_enum,
    ACTIONS(9693), 1,
      anon_sym_class,
    ACTIONS(9695), 1,
      anon_sym_struct,
    ACTIONS(9697), 1,
      anon_sym_union,
    ACTIONS(9699), 1,
      sym_auto,
    ACTIONS(9701), 1,
      anon_sym_decltype,
    ACTIONS(9703), 1,
      anon_sym_typename,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3125), 1,
      sym_type_specifier,
    STATE(3337), 1,
      sym_decltype_auto,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(5506), 1,
      sym_argument_list,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3285), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3345), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175891] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9705), 1,
      sym_identifier,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9711), 1,
      sym_primitive_type,
    ACTIONS(9713), 1,
      anon_sym_enum,
    ACTIONS(9715), 1,
      anon_sym_class,
    ACTIONS(9717), 1,
      anon_sym_struct,
    ACTIONS(9719), 1,
      anon_sym_union,
    ACTIONS(9721), 1,
      sym_auto,
    ACTIONS(9723), 1,
      anon_sym_decltype,
    ACTIONS(9725), 1,
      anon_sym_typename,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4158), 1,
      sym_type_specifier,
    STATE(4324), 1,
      sym_decltype_auto,
    STATE(4344), 1,
      sym_qualified_type_identifier,
    STATE(5502), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(4268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4333), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [175971] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(8269), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9733), 1,
      anon_sym_enum,
    ACTIONS(9735), 1,
      anon_sym_class,
    ACTIONS(9737), 1,
      anon_sym_struct,
    ACTIONS(9739), 1,
      anon_sym_union,
    ACTIONS(9741), 1,
      anon_sym_typename,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4358), 1,
      sym_type_specifier,
    STATE(5461), 1,
      sym_argument_list,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176051] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5606), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [176127] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1891), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7982), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176197] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5564), 1,
      sym_ref_qualifier,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6537), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5657), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [176279] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6476), 1,
      sym_auto,
    ACTIONS(6478), 1,
      anon_sym_decltype,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5529), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9745), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9743), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176333] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9747), 1,
      sym_identifier,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      sym_primitive_type,
    ACTIONS(9755), 1,
      anon_sym_enum,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9767), 1,
      anon_sym_typename,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2601), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(5524), 1,
      sym_argument_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176413] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9773), 1,
      sym_primitive_type,
    ACTIONS(9775), 1,
      anon_sym_enum,
    ACTIONS(9777), 1,
      anon_sym_typename,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2601), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(5471), 1,
      sym_argument_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176493] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9747), 1,
      sym_identifier,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      sym_primitive_type,
    ACTIONS(9755), 1,
      anon_sym_enum,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9767), 1,
      anon_sym_typename,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2597), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(5462), 1,
      sym_argument_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5919), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9779), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5917), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [176617] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8599), 1,
      anon_sym_COLON,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7085), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5927), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9782), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5925), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [176727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5256), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5931), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9785), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5929), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [176771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5257), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5886), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9788), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5884), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [176815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5937), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9791), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5935), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [176859] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9661), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9667), 1,
      sym_primitive_type,
    ACTIONS(9669), 1,
      anon_sym_enum,
    ACTIONS(9671), 1,
      anon_sym_class,
    ACTIONS(9673), 1,
      anon_sym_struct,
    ACTIONS(9675), 1,
      anon_sym_union,
    ACTIONS(9677), 1,
      sym_auto,
    ACTIONS(9679), 1,
      anon_sym_decltype,
    ACTIONS(9681), 1,
      anon_sym_typename,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3187), 1,
      sym_type_specifier,
    STATE(3430), 1,
      sym_decltype_auto,
    STATE(3503), 1,
      sym_qualified_type_identifier,
    STATE(5525), 1,
      sym_argument_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3348), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3434), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [176939] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      sym_identifier,
    ACTIONS(8922), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5580), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5317), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5729), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5731), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(9794), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176995] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9773), 1,
      sym_primitive_type,
    ACTIONS(9775), 1,
      anon_sym_enum,
    ACTIONS(9777), 1,
      anon_sym_typename,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2597), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(5508), 1,
      sym_argument_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [177075] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(5877), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8048), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177145] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8164), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177215] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1891), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7939), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177285] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(6536), 1,
      anon_sym_COLON,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7093), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177351] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(5584), 1,
      sym_ref_qualifier,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6542), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5656), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [177433] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(6499), 1,
      anon_sym_const,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8581), 1,
      anon_sym_COLON,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(2486), 1,
      sym_alignas_qualifier,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7094), 1,
      sym__abstract_declarator,
    ACTIONS(8418), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2435), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8416), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5892), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9796), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5890), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [177543] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4121), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8206), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177613] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3532), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8092), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177683] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(5557), 1,
      sym_ref_qualifier,
    STATE(6572), 1,
      sym__function_attributes_end,
    STATE(6734), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5648), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [177765] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6476), 1,
      sym_auto,
    ACTIONS(6478), 1,
      anon_sym_decltype,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(2569), 1,
      sym_decltype_auto,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5566), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9801), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9799), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177819] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3809), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7846), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177889] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3532), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8119), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177959] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9803), 1,
      sym_identifier,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9809), 1,
      sym_primitive_type,
    ACTIONS(9811), 1,
      anon_sym_enum,
    ACTIONS(9813), 1,
      anon_sym_class,
    ACTIONS(9815), 1,
      anon_sym_struct,
    ACTIONS(9817), 1,
      anon_sym_union,
    ACTIONS(9819), 1,
      sym_auto,
    ACTIONS(9821), 1,
      anon_sym_decltype,
    ACTIONS(9823), 1,
      anon_sym_typename,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3297), 1,
      sym_type_specifier,
    STATE(3713), 1,
      sym_decltype_auto,
    STATE(3727), 1,
      sym_qualified_type_identifier,
    STATE(5460), 1,
      sym_argument_list,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3587), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3719), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178039] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6035), 1,
      sym_trailing_return_type,
    STATE(6280), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5616), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [178115] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(3915), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(7892), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2361), 1,
      sym_attribute_specifier,
    ACTIONS(6235), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6237), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178231] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2380), 1,
      sym_attribute_specifier,
    ACTIONS(6239), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6241), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178277] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2359), 1,
      sym_attribute_specifier,
    ACTIONS(6183), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6185), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2379), 1,
      sym_attribute_specifier,
    ACTIONS(6195), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6197), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178369] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6081), 1,
      sym_compound_statement,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8116), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178439] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2353), 1,
      sym_attribute_specifier,
    ACTIONS(6187), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6189), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2349), 1,
      sym_attribute_specifier,
    ACTIONS(6219), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6221), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178531] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4416), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8021), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [178601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2347), 1,
      sym_attribute_specifier,
    ACTIONS(6215), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6217), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178647] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4203), 1,
      sym_type_specifier,
    STATE(5491), 1,
      sym_argument_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [178727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2366), 1,
      sym_attribute_specifier,
    ACTIONS(6223), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6225), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2388), 1,
      sym_attribute_specifier,
    ACTIONS(6227), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6229), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2383), 1,
      sym_attribute_specifier,
    ACTIONS(6231), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6233), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5286), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5904), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5902), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [178907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2385), 1,
      sym_attribute_specifier,
    ACTIONS(6179), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6181), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(2369), 1,
      sym_attribute_specifier,
    ACTIONS(6191), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6193), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [178999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5875), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9841), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5872), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [179043] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(1891), 1,
      sym_compound_statement,
    STATE(5518), 1,
      sym_parameter_list,
    STATE(6725), 1,
      sym_type_qualifier,
    STATE(8140), 1,
      sym_lambda_declarator,
    STATE(8760), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7009), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [179113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5271), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5941), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9845), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5939), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [179157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5915), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9848), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5913), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [179201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6309), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5611), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [179277] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8896), 1,
      sym_identifier,
    ACTIONS(8900), 1,
      sym_primitive_type,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(4817), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5753), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5755), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(8898), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [179333] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9803), 1,
      sym_identifier,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9809), 1,
      sym_primitive_type,
    ACTIONS(9811), 1,
      anon_sym_enum,
    ACTIONS(9813), 1,
      anon_sym_class,
    ACTIONS(9815), 1,
      anon_sym_struct,
    ACTIONS(9817), 1,
      anon_sym_union,
    ACTIONS(9819), 1,
      sym_auto,
    ACTIONS(9821), 1,
      anon_sym_decltype,
    ACTIONS(9823), 1,
      anon_sym_typename,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3318), 1,
      sym_type_specifier,
    STATE(3713), 1,
      sym_decltype_auto,
    STATE(3727), 1,
      sym_qualified_type_identifier,
    STATE(5477), 1,
      sym_argument_list,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3587), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3719), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179413] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6346), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5614), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [179489] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9854), 1,
      anon_sym_requires,
    STATE(5550), 1,
      sym_ref_qualifier,
    STATE(6510), 1,
      sym__function_attributes_end,
    STATE(6697), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5664), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [179571] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4319), 1,
      sym_type_specifier,
    STATE(5516), 1,
      sym_argument_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179651] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7324), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7326), 1,
      anon_sym_AMP,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5563), 1,
      sym_ref_qualifier,
    STATE(6525), 1,
      sym__function_attributes_end,
    STATE(6643), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5658), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [179733] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9689), 1,
      sym_primitive_type,
    ACTIONS(9691), 1,
      anon_sym_enum,
    ACTIONS(9693), 1,
      anon_sym_class,
    ACTIONS(9695), 1,
      anon_sym_struct,
    ACTIONS(9697), 1,
      anon_sym_union,
    ACTIONS(9699), 1,
      sym_auto,
    ACTIONS(9701), 1,
      anon_sym_decltype,
    ACTIONS(9703), 1,
      anon_sym_typename,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3134), 1,
      sym_type_specifier,
    STATE(3337), 1,
      sym_decltype_auto,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(5499), 1,
      sym_argument_list,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3285), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3345), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179813] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6276), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5612), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [179889] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(8269), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9733), 1,
      anon_sym_enum,
    ACTIONS(9735), 1,
      anon_sym_class,
    ACTIONS(9737), 1,
      anon_sym_struct,
    ACTIONS(9739), 1,
      anon_sym_union,
    ACTIONS(9741), 1,
      anon_sym_typename,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4386), 1,
      sym_type_specifier,
    STATE(5479), 1,
      sym_argument_list,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [179969] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6301), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5610), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [180045] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9705), 1,
      sym_identifier,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9711), 1,
      sym_primitive_type,
    ACTIONS(9713), 1,
      anon_sym_enum,
    ACTIONS(9715), 1,
      anon_sym_class,
    ACTIONS(9717), 1,
      anon_sym_struct,
    ACTIONS(9719), 1,
      anon_sym_union,
    ACTIONS(9721), 1,
      sym_auto,
    ACTIONS(9723), 1,
      anon_sym_decltype,
    ACTIONS(9725), 1,
      anon_sym_typename,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4148), 1,
      sym_type_specifier,
    STATE(4324), 1,
      sym_decltype_auto,
    STATE(4344), 1,
      sym_qualified_type_identifier,
    STATE(5474), 1,
      sym_argument_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(4268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4333), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [180125] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6327), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5607), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [180201] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4315), 1,
      sym_type_specifier,
    STATE(5519), 1,
      sym_argument_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [180281] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4199), 1,
      sym_type_specifier,
    STATE(5481), 1,
      sym_argument_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [180361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2543), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6193), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6191), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [180404] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2393), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180485] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2573), 1,
      sym__class_declaration,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5733), 1,
      sym_ms_declspec_modifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5480), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180566] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3069), 1,
      sym__class_declaration,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5520), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180647] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(3071), 1,
      sym__class_declaration,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5520), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180728] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(3072), 1,
      sym__class_declaration,
    STATE(5827), 1,
      sym_ms_declspec_modifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5828), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5520), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180809] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2579), 1,
      sym__class_declaration,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5733), 1,
      sym_ms_declspec_modifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5480), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180890] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2580), 1,
      sym__class_declaration,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5733), 1,
      sym_ms_declspec_modifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5770), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5480), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [180971] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5822), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5469), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181052] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5822), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5469), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181133] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5822), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5826), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5469), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181214] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3069), 1,
      sym__class_declaration,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(5761), 1,
      sym_ms_declspec_modifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5762), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5489), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181295] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(3071), 1,
      sym__class_declaration,
    STATE(5761), 1,
      sym_ms_declspec_modifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5762), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5489), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181376] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3070), 1,
      sym__class_declaration_item,
    STATE(3072), 1,
      sym__class_declaration,
    STATE(5761), 1,
      sym_ms_declspec_modifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5762), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5489), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181457] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181538] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5627), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [181613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(5861), 1,
      anon_sym_LPAREN2,
    STATE(2607), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2926), 1,
      sym_argument_list,
    STATE(4095), 1,
      sym_initializer_list,
    ACTIONS(5857), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6602), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [181664] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6195), 1,
      sym__function_attributes_end,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5629), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [181739] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3756), 1,
      sym__class_declaration,
    STATE(3757), 1,
      sym__class_declaration_item,
    STATE(5815), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5820), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5517), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181820] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3757), 1,
      sym__class_declaration_item,
    STATE(3764), 1,
      sym__class_declaration,
    STATE(5815), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5820), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5517), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3757), 1,
      sym__class_declaration_item,
    STATE(3770), 1,
      sym__class_declaration,
    STATE(5815), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5820), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5517), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [181982] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2573), 1,
      sym__class_declaration,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5835), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5834), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5465), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182063] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5018), 1,
      sym__class_declaration,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5800), 1,
      sym_ms_declspec_modifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5805), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5485), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182144] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5021), 1,
      sym__class_declaration,
    STATE(5800), 1,
      sym_ms_declspec_modifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5805), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5485), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182225] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5022), 1,
      sym__class_declaration,
    STATE(5800), 1,
      sym_ms_declspec_modifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5805), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5485), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182306] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2579), 1,
      sym__class_declaration,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5835), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5834), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5465), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182387] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5718), 1,
      sym__function_attributes_end,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [182456] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2580), 1,
      sym__class_declaration,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5835), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5834), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5465), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3422), 1,
      sym__class_declaration_item,
    STATE(3460), 1,
      sym__class_declaration,
    STATE(5740), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5743), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5472), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182618] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3422), 1,
      sym__class_declaration_item,
    STATE(3481), 1,
      sym__class_declaration,
    STATE(5740), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5743), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5472), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182699] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3422), 1,
      sym__class_declaration_item,
    STATE(3492), 1,
      sym__class_declaration,
    STATE(5740), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5743), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5472), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182780] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5685), 1,
      sym__function_attributes_end,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [182849] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5127), 1,
      sym__class_declaration,
    STATE(5138), 1,
      sym__class_declaration_item,
    STATE(5731), 1,
      sym_ms_declspec_modifier,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5732), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5464), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [182930] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5138), 1,
      sym__class_declaration_item,
    STATE(5140), 1,
      sym__class_declaration,
    STATE(5731), 1,
      sym_ms_declspec_modifier,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5732), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5464), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183011] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5138), 1,
      sym__class_declaration_item,
    STATE(5157), 1,
      sym__class_declaration,
    STATE(5731), 1,
      sym_ms_declspec_modifier,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5732), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5464), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183092] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4302), 1,
      sym__class_declaration_item,
    STATE(4304), 1,
      sym__class_declaration,
    STATE(5768), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5790), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5470), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183173] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4302), 1,
      sym__class_declaration_item,
    STATE(4306), 1,
      sym__class_declaration,
    STATE(5768), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5790), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5470), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183254] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4302), 1,
      sym__class_declaration_item,
    STATE(4309), 1,
      sym__class_declaration,
    STATE(5768), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5790), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5470), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183335] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5729), 1,
      sym_ms_declspec_modifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5786), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5513), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183416] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5729), 1,
      sym_ms_declspec_modifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5786), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5513), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183497] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5729), 1,
      sym_ms_declspec_modifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5786), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5513), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183578] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6217), 1,
      sym__function_attributes_end,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5620), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [183653] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5686), 1,
      sym__function_attributes_end,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [183722] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2402), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183803] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2402), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183884] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2402), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183965] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2397), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184046] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2397), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184127] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2397), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184208] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6411), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5621), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [184283] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9898), 1,
      anon_sym_requires,
    STATE(5687), 1,
      sym__function_attributes_end,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [184352] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6341), 1,
      sym_trailing_return_type,
    STATE(6415), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5625), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [184427] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2389), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184508] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2389), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184589] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2389), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184670] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6407), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5638), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [184745] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6268), 1,
      sym_trailing_return_type,
    STATE(6408), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5619), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [184820] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3341), 1,
      sym__class_declaration_item,
    STATE(3343), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym_ms_declspec_modifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5794), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5492), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184901] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3341), 1,
      sym__class_declaration_item,
    STATE(3344), 1,
      sym__class_declaration,
    STATE(5752), 1,
      sym_ms_declspec_modifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5794), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5492), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [184982] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6189), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5624), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [185057] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym_ms_declspec_modifier,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5751), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5484), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185138] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym_ms_declspec_modifier,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5751), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5484), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185219] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5749), 1,
      sym_ms_declspec_modifier,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5751), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5484), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185300] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5018), 1,
      sym__class_declaration,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5779), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5498), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185381] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5021), 1,
      sym__class_declaration,
    STATE(5779), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5498), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185462] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5020), 1,
      sym__class_declaration_item,
    STATE(5022), 1,
      sym__class_declaration,
    STATE(5779), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5782), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5498), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185543] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185624] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185705] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2399), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185786] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2396), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185867] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2396), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [185948] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2396), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186029] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2390), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186110] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2390), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186191] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2390), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186272] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2400), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186353] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2400), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186434] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2400), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186515] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186596] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186677] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186758] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186839] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2403), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [186920] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2401), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187001] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2401), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187082] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2401), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187163] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2395), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187244] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2395), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187325] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2395), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187406] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2394), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187487] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2394), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187568] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2394), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187649] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6218), 1,
      sym__function_attributes_end,
    STATE(6268), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5630), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [187724] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(5869), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [187793] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6188), 1,
      sym__function_attributes_end,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5635), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [187868] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2392), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [187949] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2392), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188030] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2392), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188111] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2398), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188192] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2398), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188273] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2398), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188354] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5631), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [188429] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6214), 1,
      sym__function_attributes_end,
    STATE(6341), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5632), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [188504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2587), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6237), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6235), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2552), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6241), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6239), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2553), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6185), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6183), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2560), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6197), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6195), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188676] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2709), 1,
      sym__class_declaration,
    STATE(2710), 1,
      sym__class_declaration_item,
    STATE(5830), 1,
      sym_ms_declspec_modifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5510), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2566), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6189), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6187), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2567), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6221), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6219), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2585), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6217), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6215), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188886] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2710), 1,
      sym__class_declaration_item,
    STATE(2715), 1,
      sym__class_declaration,
    STATE(5830), 1,
      sym_ms_declspec_modifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5510), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [188967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2544), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6225), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6223), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2547), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6229), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6227), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2548), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6233), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6231), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2565), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6181), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6179), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189139] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2710), 1,
      sym__class_declaration_item,
    STATE(2716), 1,
      sym__class_declaration,
    STATE(5830), 1,
      sym_ms_declspec_modifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5789), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5510), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2573), 1,
      sym__class_declaration,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(5824), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5793), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5496), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189301] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2579), 1,
      sym__class_declaration,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(5824), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5793), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5496), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189382] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2575), 1,
      sym__class_declaration_item,
    STATE(2580), 1,
      sym__class_declaration,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(5824), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5793), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5496), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189463] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5808), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5809), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5514), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189544] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5808), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5809), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5514), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5808), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5809), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5514), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(6258), 1,
      anon_sym_LPAREN2,
    STATE(2607), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3743), 1,
      sym_initializer_list,
    STATE(3793), 1,
      sym_argument_list,
    ACTIONS(5857), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6602), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5859), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [189757] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2362), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2393), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189838] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2350), 1,
      sym__class_declaration_item,
    STATE(2374), 1,
      sym__class_declaration,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5831), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2393), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5778), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5493), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [189919] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(5719), 1,
      sym__function_attributes_end,
    STATE(5966), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [189988] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3338), 1,
      sym__class_declaration,
    STATE(3341), 1,
      sym__class_declaration_item,
    STATE(5752), 1,
      sym_ms_declspec_modifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5794), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5492), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [190069] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6295), 1,
      sym__declarator,
    STATE(7812), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190139] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9803), 1,
      sym_identifier,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9809), 1,
      sym_primitive_type,
    ACTIONS(9811), 1,
      anon_sym_enum,
    ACTIONS(9813), 1,
      anon_sym_class,
    ACTIONS(9815), 1,
      anon_sym_struct,
    ACTIONS(9817), 1,
      anon_sym_union,
    ACTIONS(9819), 1,
      sym_auto,
    ACTIONS(9821), 1,
      anon_sym_decltype,
    ACTIONS(9823), 1,
      anon_sym_typename,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3293), 1,
      sym_type_specifier,
    STATE(3713), 1,
      sym_decltype_auto,
    STATE(3727), 1,
      sym_qualified_type_identifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3587), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3719), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190213] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(8269), 1,
      sym_primitive_type,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9733), 1,
      anon_sym_enum,
    ACTIONS(9735), 1,
      anon_sym_class,
    ACTIONS(9737), 1,
      anon_sym_struct,
    ACTIONS(9739), 1,
      anon_sym_union,
    ACTIONS(9741), 1,
      anon_sym_typename,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4365), 1,
      sym_type_specifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190287] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9747), 1,
      sym_identifier,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      sym_primitive_type,
    ACTIONS(9755), 1,
      anon_sym_enum,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9767), 1,
      anon_sym_typename,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2596), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190361] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      anon_sym_enum,
    ACTIONS(75), 1,
      anon_sym_class,
    ACTIONS(77), 1,
      anon_sym_struct,
    ACTIONS(79), 1,
      anon_sym_union,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(131), 1,
      anon_sym_typename,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2736), 1,
      sym_primitive_type,
    ACTIONS(3846), 1,
      sym_identifier,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190435] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5184), 1,
      sym__class_declaration_item,
    STATE(5735), 1,
      sym_ms_declspec_modifier,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5734), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [190513] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2586), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5769), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5833), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [190591] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2540), 1,
      sym_type_specifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190665] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6348), 1,
      sym__declarator,
    STATE(7786), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [190735] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2736), 1,
      sym_primitive_type,
    ACTIONS(2740), 1,
      anon_sym_class,
    ACTIONS(2742), 1,
      anon_sym_struct,
    ACTIONS(2744), 1,
      anon_sym_union,
    ACTIONS(3846), 1,
      sym_identifier,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3858), 1,
      anon_sym_enum,
    ACTIONS(3860), 1,
      anon_sym_typename,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(2598), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3856), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190809] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2360), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5748), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5747), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [190887] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4327), 1,
      sym__class_declaration_item,
    STATE(5750), 1,
      sym_ms_declspec_modifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [190965] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9773), 1,
      sym_primitive_type,
    ACTIONS(9775), 1,
      anon_sym_enum,
    ACTIONS(9777), 1,
      anon_sym_typename,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2600), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191039] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3471), 1,
      sym__class_declaration_item,
    STATE(5745), 1,
      sym_ms_declspec_modifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5744), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [191117] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(9910), 1,
      sym_identifier,
    ACTIONS(9912), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9916), 1,
      anon_sym_enum,
    ACTIONS(9918), 1,
      anon_sym_class,
    ACTIONS(9920), 1,
      anon_sym_struct,
    ACTIONS(9922), 1,
      anon_sym_union,
    ACTIONS(9924), 1,
      anon_sym_typename,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(5278), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6824), 1,
      sym__scope_resolution,
    STATE(7077), 1,
      sym_type_specifier,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9914), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191191] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9705), 1,
      sym_identifier,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9711), 1,
      sym_primitive_type,
    ACTIONS(9713), 1,
      anon_sym_enum,
    ACTIONS(9715), 1,
      anon_sym_class,
    ACTIONS(9717), 1,
      anon_sym_struct,
    ACTIONS(9719), 1,
      anon_sym_union,
    ACTIONS(9721), 1,
      sym_auto,
    ACTIONS(9723), 1,
      anon_sym_decltype,
    ACTIONS(9725), 1,
      anon_sym_typename,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4161), 1,
      sym_type_specifier,
    STATE(4324), 1,
      sym_decltype_auto,
    STATE(4344), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(4268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4333), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191265] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8241), 1,
      sym_identifier,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8249), 1,
      anon_sym_enum,
    ACTIONS(8251), 1,
      anon_sym_class,
    ACTIONS(8253), 1,
      anon_sym_struct,
    ACTIONS(8255), 1,
      anon_sym_union,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8261), 1,
      anon_sym_typename,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4877), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191339] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8271), 1,
      sym_identifier,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8277), 1,
      sym_primitive_type,
    ACTIONS(8279), 1,
      anon_sym_enum,
    ACTIONS(8281), 1,
      anon_sym_class,
    ACTIONS(8283), 1,
      anon_sym_struct,
    ACTIONS(8285), 1,
      anon_sym_union,
    ACTIONS(8287), 1,
      sym_auto,
    ACTIONS(8289), 1,
      anon_sym_decltype,
    ACTIONS(8291), 1,
      anon_sym_typename,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(5048), 1,
      sym_type_specifier,
    STATE(5125), 1,
      sym_qualified_type_identifier,
    STATE(5194), 1,
      sym_decltype_auto,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(5100), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5186), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191413] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9803), 1,
      sym_identifier,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9809), 1,
      sym_primitive_type,
    ACTIONS(9811), 1,
      anon_sym_enum,
    ACTIONS(9813), 1,
      anon_sym_class,
    ACTIONS(9815), 1,
      anon_sym_struct,
    ACTIONS(9817), 1,
      anon_sym_union,
    ACTIONS(9819), 1,
      sym_auto,
    ACTIONS(9821), 1,
      anon_sym_decltype,
    ACTIONS(9823), 1,
      anon_sym_typename,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3321), 1,
      sym_type_specifier,
    STATE(3713), 1,
      sym_decltype_auto,
    STATE(3727), 1,
      sym_qualified_type_identifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3587), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3719), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191487] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9803), 1,
      sym_identifier,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9809), 1,
      sym_primitive_type,
    ACTIONS(9811), 1,
      anon_sym_enum,
    ACTIONS(9813), 1,
      anon_sym_class,
    ACTIONS(9815), 1,
      anon_sym_struct,
    ACTIONS(9817), 1,
      anon_sym_union,
    ACTIONS(9819), 1,
      sym_auto,
    ACTIONS(9821), 1,
      anon_sym_decltype,
    ACTIONS(9823), 1,
      anon_sym_typename,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3612), 1,
      sym_type_specifier,
    STATE(3713), 1,
      sym_decltype_auto,
    STATE(3727), 1,
      sym_qualified_type_identifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3587), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3719), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191561] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(8269), 1,
      sym_primitive_type,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9733), 1,
      anon_sym_enum,
    ACTIONS(9735), 1,
      anon_sym_class,
    ACTIONS(9737), 1,
      anon_sym_struct,
    ACTIONS(9739), 1,
      anon_sym_union,
    ACTIONS(9741), 1,
      anon_sym_typename,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4353), 1,
      sym_type_specifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191635] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2586), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(5760), 1,
      sym_ms_declspec_modifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5754), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [191713] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4207), 1,
      sym_type_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191787] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9689), 1,
      sym_primitive_type,
    ACTIONS(9691), 1,
      anon_sym_enum,
    ACTIONS(9693), 1,
      anon_sym_class,
    ACTIONS(9695), 1,
      anon_sym_struct,
    ACTIONS(9697), 1,
      anon_sym_union,
    ACTIONS(9699), 1,
      sym_auto,
    ACTIONS(9701), 1,
      anon_sym_decltype,
    ACTIONS(9703), 1,
      anon_sym_typename,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3289), 1,
      sym_type_specifier,
    STATE(3337), 1,
      sym_decltype_auto,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3285), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3345), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191861] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(9910), 1,
      sym_identifier,
    ACTIONS(9912), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9916), 1,
      anon_sym_enum,
    ACTIONS(9918), 1,
      anon_sym_class,
    ACTIONS(9920), 1,
      anon_sym_struct,
    ACTIONS(9922), 1,
      anon_sym_union,
    ACTIONS(9924), 1,
      anon_sym_typename,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(5278), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6824), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9914), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191935] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2360), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5758), 1,
      sym_ms_declspec_modifier,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192013] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5050), 1,
      sym__class_declaration_item,
    STATE(5741), 1,
      sym_ms_declspec_modifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5739), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192091] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6347), 1,
      sym__declarator,
    STATE(7811), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192161] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9926), 1,
      anon_sym_LBRACE,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6491), 1,
      sym_type_qualifier,
    STATE(7469), 1,
      sym_trailing_return_type,
    STATE(8772), 1,
      sym_requires_clause,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6892), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6886), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192225] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(8269), 1,
      sym_primitive_type,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9733), 1,
      anon_sym_enum,
    ACTIONS(9735), 1,
      anon_sym_class,
    ACTIONS(9737), 1,
      anon_sym_struct,
    ACTIONS(9739), 1,
      anon_sym_union,
    ACTIONS(9741), 1,
      anon_sym_typename,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2994), 1,
      sym_type_specifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192299] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3046), 1,
      sym__class_declaration_item,
    STATE(5773), 1,
      sym_ms_declspec_modifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5771), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192377] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8329), 1,
      sym_identifier,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(8335), 1,
      anon_sym_enum,
    ACTIONS(8337), 1,
      anon_sym_class,
    ACTIONS(8339), 1,
      anon_sym_struct,
    ACTIONS(8341), 1,
      anon_sym_union,
    ACTIONS(8343), 1,
      anon_sym_typename,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(4552), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192451] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4214), 1,
      sym_type_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192525] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3420), 1,
      sym__class_declaration_item,
    STATE(5792), 1,
      sym_ms_declspec_modifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5788), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192603] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2360), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5814), 1,
      sym_ms_declspec_modifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5738), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192681] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9932), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(5487), 1,
      sym_parameter_list,
    STATE(6637), 1,
      sym_type_qualifier,
    STATE(8440), 1,
      sym_trailing_return_type,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6987), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192745] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6343), 1,
      sym__declarator,
    STATE(7789), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [192815] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2586), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(5797), 1,
      sym_ms_declspec_modifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [192893] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2736), 1,
      sym_primitive_type,
    ACTIONS(2738), 1,
      anon_sym_enum,
    ACTIONS(2740), 1,
      anon_sym_class,
    ACTIONS(2742), 1,
      anon_sym_struct,
    ACTIONS(2744), 1,
      anon_sym_union,
    ACTIONS(2746), 1,
      anon_sym_typename,
    ACTIONS(3846), 1,
      sym_identifier,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192967] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5050), 1,
      sym__class_declaration_item,
    STATE(5787), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5785), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [193045] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9689), 1,
      sym_primitive_type,
    ACTIONS(9691), 1,
      anon_sym_enum,
    ACTIONS(9693), 1,
      anon_sym_class,
    ACTIONS(9695), 1,
      anon_sym_struct,
    ACTIONS(9697), 1,
      anon_sym_union,
    ACTIONS(9699), 1,
      sym_auto,
    ACTIONS(9701), 1,
      anon_sym_decltype,
    ACTIONS(9703), 1,
      anon_sym_typename,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3141), 1,
      sym_type_specifier,
    STATE(3337), 1,
      sym_decltype_auto,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3285), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3345), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193119] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8207), 1,
      sym_identifier,
    ACTIONS(8211), 1,
      sym_primitive_type,
    ACTIONS(8213), 1,
      anon_sym_enum,
    ACTIONS(8215), 1,
      anon_sym_class,
    ACTIONS(8217), 1,
      anon_sym_struct,
    ACTIONS(8219), 1,
      anon_sym_union,
    ACTIONS(8221), 1,
      anon_sym_typename,
    STATE(2540), 1,
      sym_type_specifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193193] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9747), 1,
      sym_identifier,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      sym_primitive_type,
    ACTIONS(9755), 1,
      anon_sym_enum,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9767), 1,
      anon_sym_typename,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2686), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193267] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9705), 1,
      sym_identifier,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9711), 1,
      sym_primitive_type,
    ACTIONS(9713), 1,
      anon_sym_enum,
    ACTIONS(9715), 1,
      anon_sym_class,
    ACTIONS(9717), 1,
      anon_sym_struct,
    ACTIONS(9719), 1,
      anon_sym_union,
    ACTIONS(9721), 1,
      sym_auto,
    ACTIONS(9723), 1,
      anon_sym_decltype,
    ACTIONS(9725), 1,
      anon_sym_typename,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4165), 1,
      sym_type_specifier,
    STATE(4324), 1,
      sym_decltype_auto,
    STATE(4344), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(4268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4333), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193341] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1893), 1,
      anon_sym_enum,
    ACTIONS(1895), 1,
      anon_sym_class,
    ACTIONS(1897), 1,
      anon_sym_struct,
    ACTIONS(1899), 1,
      anon_sym_union,
    ACTIONS(1923), 1,
      anon_sym_typename,
    ACTIONS(2736), 1,
      sym_primitive_type,
    ACTIONS(4521), 1,
      sym_identifier,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2346), 1,
      sym_type_specifier,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193415] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6279), 1,
      sym__declarator,
    STATE(7785), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [193485] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8247), 1,
      sym_primitive_type,
    ACTIONS(8257), 1,
      sym_auto,
    ACTIONS(8259), 1,
      anon_sym_decltype,
    ACTIONS(8315), 1,
      sym_identifier,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8319), 1,
      anon_sym_enum,
    ACTIONS(8321), 1,
      anon_sym_class,
    ACTIONS(8323), 1,
      anon_sym_struct,
    ACTIONS(8325), 1,
      anon_sym_union,
    ACTIONS(8327), 1,
      anon_sym_typename,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4877), 1,
      sym_type_specifier,
    STATE(5010), 1,
      sym_decltype_auto,
    STATE(5102), 1,
      sym_qualified_type_identifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5012), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193559] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9683), 1,
      sym_identifier,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9689), 1,
      sym_primitive_type,
    ACTIONS(9691), 1,
      anon_sym_enum,
    ACTIONS(9693), 1,
      anon_sym_class,
    ACTIONS(9695), 1,
      anon_sym_struct,
    ACTIONS(9697), 1,
      anon_sym_union,
    ACTIONS(9699), 1,
      sym_auto,
    ACTIONS(9701), 1,
      anon_sym_decltype,
    ACTIONS(9703), 1,
      anon_sym_typename,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3137), 1,
      sym_type_specifier,
    STATE(3337), 1,
      sym_decltype_auto,
    STATE(3396), 1,
      sym_qualified_type_identifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3285), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3345), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193633] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      sym_auto,
    ACTIONS(127), 1,
      anon_sym_decltype,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(8333), 1,
      sym_primitive_type,
    ACTIONS(9910), 1,
      sym_identifier,
    ACTIONS(9912), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9916), 1,
      anon_sym_enum,
    ACTIONS(9918), 1,
      anon_sym_class,
    ACTIONS(9920), 1,
      anon_sym_struct,
    ACTIONS(9922), 1,
      anon_sym_union,
    ACTIONS(9924), 1,
      anon_sym_typename,
    STATE(2363), 1,
      sym_qualified_type_identifier,
    STATE(2373), 1,
      sym_decltype_auto,
    STATE(5278), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6824), 1,
      sym__scope_resolution,
    STATE(7074), 1,
      sym_type_specifier,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2326), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9914), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2348), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193707] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9773), 1,
      sym_primitive_type,
    ACTIONS(9775), 1,
      anon_sym_enum,
    ACTIONS(9777), 1,
      anon_sym_typename,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2596), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193781] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9705), 1,
      sym_identifier,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9711), 1,
      sym_primitive_type,
    ACTIONS(9713), 1,
      anon_sym_enum,
    ACTIONS(9715), 1,
      anon_sym_class,
    ACTIONS(9717), 1,
      anon_sym_struct,
    ACTIONS(9719), 1,
      anon_sym_union,
    ACTIONS(9721), 1,
      sym_auto,
    ACTIONS(9723), 1,
      anon_sym_decltype,
    ACTIONS(9725), 1,
      anon_sym_typename,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4261), 1,
      sym_type_specifier,
    STATE(4324), 1,
      sym_decltype_auto,
    STATE(4344), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(4268), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4333), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193855] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2783), 1,
      sym__class_declaration_item,
    STATE(5763), 1,
      sym_ms_declspec_modifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5759), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [193933] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(4105), 1,
      anon_sym_enum,
    ACTIONS(4107), 1,
      anon_sym_class,
    ACTIONS(4109), 1,
      anon_sym_struct,
    ACTIONS(4111), 1,
      anon_sym_union,
    ACTIONS(4135), 1,
      sym_auto,
    ACTIONS(4137), 1,
      anon_sym_decltype,
    ACTIONS(4139), 1,
      anon_sym_typename,
    ACTIONS(8265), 1,
      sym_identifier,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8269), 1,
      sym_primitive_type,
    STATE(2994), 1,
      sym_type_specifier,
    STATE(3036), 1,
      sym_qualified_type_identifier,
    STATE(3066), 1,
      sym_decltype_auto,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3000), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3067), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194007] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9769), 1,
      sym_identifier,
    ACTIONS(9773), 1,
      sym_primitive_type,
    ACTIONS(9775), 1,
      anon_sym_enum,
    ACTIONS(9777), 1,
      anon_sym_typename,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2686), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194081] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2360), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(5798), 1,
      sym_ms_declspec_modifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194159] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2360), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(5811), 1,
      sym_ms_declspec_modifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194237] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6321), 1,
      sym__declarator,
    STATE(7812), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194307] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4305), 1,
      sym_type_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194381] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3676), 1,
      sym__class_declaration_item,
    STATE(5823), 1,
      sym_ms_declspec_modifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5821), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194459] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_const,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(9934), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_alignas_qualifier,
    STATE(6488), 1,
      sym_type_qualifier,
    STATE(7425), 1,
      sym_trailing_return_type,
    STATE(8499), 1,
      sym_requires_clause,
    ACTIONS(7744), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(6883), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6882), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7740), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [194523] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(8186), 1,
      sym_primitive_type,
    ACTIONS(9825), 1,
      sym_identifier,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9831), 1,
      anon_sym_enum,
    ACTIONS(9833), 1,
      anon_sym_class,
    ACTIONS(9835), 1,
      anon_sym_struct,
    ACTIONS(9837), 1,
      anon_sym_union,
    ACTIONS(9839), 1,
      anon_sym_typename,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4330), 1,
      sym_type_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194597] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5527), 1,
      anon_sym___declspec,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3046), 1,
      sym__class_declaration_item,
    STATE(5839), 1,
      sym_ms_declspec_modifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5521), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5529), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5837), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194675] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6310), 1,
      sym__declarator,
    STATE(7812), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [194745] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2068), 1,
      anon_sym_enum,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_struct,
    ACTIONS(2074), 1,
      anon_sym_union,
    ACTIONS(2098), 1,
      sym_auto,
    ACTIONS(2100), 1,
      anon_sym_decltype,
    ACTIONS(2102), 1,
      anon_sym_typename,
    ACTIONS(8180), 1,
      sym_identifier,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8186), 1,
      sym_primitive_type,
    STATE(2540), 1,
      sym_type_specifier,
    STATE(2545), 1,
      sym_decltype_auto,
    STATE(2563), 1,
      sym_qualified_type_identifier,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2521), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2581), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194819] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9661), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9667), 1,
      sym_primitive_type,
    ACTIONS(9669), 1,
      anon_sym_enum,
    ACTIONS(9671), 1,
      anon_sym_class,
    ACTIONS(9673), 1,
      anon_sym_struct,
    ACTIONS(9675), 1,
      anon_sym_union,
    ACTIONS(9677), 1,
      sym_auto,
    ACTIONS(9679), 1,
      anon_sym_decltype,
    ACTIONS(9681), 1,
      anon_sym_typename,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3202), 1,
      sym_type_specifier,
    STATE(3430), 1,
      sym_decltype_auto,
    STATE(3503), 1,
      sym_qualified_type_identifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3348), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3434), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194893] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9747), 1,
      sym_identifier,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9753), 1,
      sym_primitive_type,
    ACTIONS(9755), 1,
      anon_sym_enum,
    ACTIONS(9757), 1,
      anon_sym_class,
    ACTIONS(9759), 1,
      anon_sym_struct,
    ACTIONS(9761), 1,
      anon_sym_union,
    ACTIONS(9763), 1,
      sym_auto,
    ACTIONS(9765), 1,
      anon_sym_decltype,
    ACTIONS(9767), 1,
      anon_sym_typename,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2600), 1,
      sym_type_specifier,
    STATE(2703), 1,
      sym_decltype_auto,
    STATE(2708), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(2664), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2704), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [194967] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9661), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9667), 1,
      sym_primitive_type,
    ACTIONS(9669), 1,
      anon_sym_enum,
    ACTIONS(9671), 1,
      anon_sym_class,
    ACTIONS(9673), 1,
      anon_sym_struct,
    ACTIONS(9675), 1,
      anon_sym_union,
    ACTIONS(9677), 1,
      sym_auto,
    ACTIONS(9679), 1,
      anon_sym_decltype,
    ACTIONS(9681), 1,
      anon_sym_typename,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3214), 1,
      sym_type_specifier,
    STATE(3430), 1,
      sym_decltype_auto,
    STATE(3503), 1,
      sym_qualified_type_identifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3348), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3434), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [195041] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6325), 1,
      sym__declarator,
    STATE(7441), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195111] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(9661), 1,
      sym_identifier,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9667), 1,
      sym_primitive_type,
    ACTIONS(9669), 1,
      anon_sym_enum,
    ACTIONS(9671), 1,
      anon_sym_class,
    ACTIONS(9673), 1,
      anon_sym_struct,
    ACTIONS(9675), 1,
      anon_sym_union,
    ACTIONS(9677), 1,
      sym_auto,
    ACTIONS(9679), 1,
      anon_sym_decltype,
    ACTIONS(9681), 1,
      anon_sym_typename,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3369), 1,
      sym_type_specifier,
    STATE(3430), 1,
      sym_decltype_auto,
    STATE(3503), 1,
      sym_qualified_type_identifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_dependent_type_identifier,
    STATE(3348), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3434), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [195185] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6413), 1,
      sym__declarator,
    STATE(8204), 1,
      sym_init_declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1369), 1,
      sym_alignas_qualifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9938), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9936), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [195300] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6621), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195367] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6634), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195434] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7684), 1,
      anon_sym_STAR,
    ACTIONS(7686), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7688), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6481), 1,
      sym__declarator,
    STATE(8589), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195501] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6615), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195568] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6905), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195635] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6665), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195702] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6667), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195769] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6691), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195836] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6692), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195903] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6716), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [195970] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6921), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196037] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7568), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7572), 1,
      anon_sym_AMP,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6380), 1,
      sym__declarator,
    STATE(8320), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196104] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6644), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196171] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6671), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196238] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6672), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196305] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6572), 1,
      sym__function_attributes_end,
    STATE(6734), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5648), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [196378] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6684), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196445] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6639), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196512] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6709), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196579] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6666), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196646] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9943), 1,
      anon_sym_requires,
    STATE(6523), 1,
      sym__function_attributes_end,
    STATE(6699), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5666), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [196719] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6537), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5657), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [196792] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6600), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196859] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6708), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [196926] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5983), 1,
      sym_trailing_return_type,
    STATE(6088), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [196993] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6525), 1,
      sym__function_attributes_end,
    STATE(6643), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5658), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5286), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5859), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9946), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5857), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [197107] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6563), 1,
      sym__function_attributes_end,
    STATE(6742), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5653), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197180] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6601), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197247] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9898), 1,
      anon_sym_requires,
    STATE(5909), 1,
      sym_trailing_return_type,
    STATE(6102), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [197314] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6916), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197381] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6542), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5656), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197454] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6647), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197521] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6499), 1,
      sym__function_attributes_end,
    STATE(6649), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5663), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197594] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6538), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5650), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6913), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1369), 1,
      sym_alignas_qualifier,
    ACTIONS(69), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1312), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9951), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9949), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(67), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [197779] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6636), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [197846] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5979), 1,
      sym_trailing_return_type,
    STATE(6087), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [197913] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9854), 1,
      anon_sym_requires,
    STATE(6510), 1,
      sym__function_attributes_end,
    STATE(6697), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5664), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [197986] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6718), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198053] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6706), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198120] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6706), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198187] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6693), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6876), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198321] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6675), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6625), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198455] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6629), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198522] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6656), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198589] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6635), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2274), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5875), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(5747), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5872), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5743), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [198699] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(5966), 1,
      sym_trailing_return_type,
    STATE(6119), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [198766] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7666), 1,
      anon_sym_STAR,
    ACTIONS(7668), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7670), 1,
      anon_sym_AMP,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(6848), 1,
      sym__declarator,
    STATE(8469), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [198833] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(5869), 1,
      sym_trailing_return_type,
    STATE(6125), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [198900] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6543), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5655), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [198973] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6106), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [199040] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6764), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199107] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6480), 1,
      sym_identifier,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7558), 1,
      anon_sym_STAR,
    ACTIONS(7560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7562), 1,
      anon_sym_AMP,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6765), 1,
      sym__declarator,
    STATE(8408), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199174] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2718), 1,
      anon_sym_STAR,
    ACTIONS(2720), 1,
      anon_sym_AMP,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5513), 1,
      sym_identifier,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym__declarator,
    STATE(9120), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199241] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2714), 1,
      anon_sym_LPAREN2,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7540), 1,
      anon_sym_LBRACK,
    ACTIONS(7548), 1,
      sym_identifier,
    ACTIONS(7550), 1,
      anon_sym_STAR,
    ACTIONS(7552), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7554), 1,
      anon_sym_AMP,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(6614), 1,
      sym__declarator,
    STATE(8934), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(6529), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [199308] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9953), 1,
      anon_sym_requires,
    STATE(6136), 1,
      sym__function_attributes_end,
    STATE(6263), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [199374] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6097), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [199440] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9890), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6142), 1,
      sym__function_attributes_end,
    STATE(6318), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [199506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6141), 1,
      sym__function_attributes_end,
    STATE(6317), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [199572] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6096), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [199638] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6044), 1,
      sym_trailing_return_type,
    STATE(6094), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [199704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5857), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5859), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [199744] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6035), 1,
      sym_trailing_return_type,
    STATE(6093), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [199810] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6098), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [199876] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9555), 1,
      anon_sym_requires,
    STATE(6133), 1,
      sym__function_attributes_end,
    STATE(6352), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [199942] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9046), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6140), 1,
      sym__function_attributes_end,
    STATE(6314), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [200008] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
  [200074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9545), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      anon_sym_requires,
    STATE(6134), 1,
      sym__function_attributes_end,
    STATE(6262), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [200140] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7854), 1,
      anon_sym_STAR,
    ACTIONS(7856), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7858), 1,
      anon_sym_AMP,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8479), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6117), 1,
      sym__abstract_declarator,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [200193] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6333), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200258] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    STATE(6309), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200323] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6273), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    STATE(6329), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200453] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6017), 1,
      sym_trailing_return_type,
    STATE(6301), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200518] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6346), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200583] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6035), 1,
      sym_trailing_return_type,
    STATE(6280), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    STATE(6327), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [200713] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    STATE(6289), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2013), 1,
      anon_sym_LBRACE,
    ACTIONS(5857), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5859), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [200815] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6276), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200880] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6199), 1,
      sym_trailing_return_type,
    STATE(6272), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [200945] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6044), 1,
      sym_trailing_return_type,
    STATE(6293), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [201010] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(5996), 1,
      sym_ms_call_modifier,
    STATE(6930), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [201068] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6022), 1,
      sym_ms_call_modifier,
    STATE(6950), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [201126] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9965), 1,
      anon_sym_requires,
    STATE(6269), 1,
      sym_trailing_return_type,
    STATE(6410), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [201190] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6218), 1,
      sym__function_attributes_end,
    STATE(6268), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [201254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6341), 1,
      sym_trailing_return_type,
    STATE(6415), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [201318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6217), 1,
      sym__function_attributes_end,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [201382] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6188), 1,
      sym__function_attributes_end,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [201446] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6190), 1,
      sym__function_attributes_end,
    STATE(6199), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [201510] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6342), 1,
      sym_trailing_return_type,
    STATE(6417), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [201574] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6038), 1,
      sym_ms_call_modifier,
    STATE(6936), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [201632] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6195), 1,
      sym__function_attributes_end,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [201696] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6045), 1,
      sym_ms_call_modifier,
    STATE(6928), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(55), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [201754] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6196), 1,
      sym__function_attributes_end,
    STATE(6260), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [201818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9965), 1,
      anon_sym_requires,
    STATE(6219), 1,
      sym__function_attributes_end,
    STATE(6269), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [201882] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6214), 1,
      sym__function_attributes_end,
    STATE(6341), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [201946] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9884), 1,
      anon_sym___attribute__,
    ACTIONS(9887), 1,
      anon_sym___attribute,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6215), 1,
      sym__function_attributes_end,
    STATE(6342), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [202010] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6267), 1,
      sym_trailing_return_type,
    STATE(6407), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6194), 1,
      sym__function_attributes_end,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [202138] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9539), 1,
      anon_sym___attribute__,
    ACTIONS(9542), 1,
      anon_sym___attribute,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6189), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
  [202202] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6411), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202266] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9040), 1,
      anon_sym___attribute__,
    ACTIONS(9043), 1,
      anon_sym___attribute,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6213), 1,
      sym__function_attributes_end,
    STATE(6339), 1,
      sym_trailing_return_type,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_GT2,
  [202330] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6268), 1,
      sym_trailing_return_type,
    STATE(6408), 1,
      sym__function_attributes_end,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [202394] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    ACTIONS(9968), 1,
      anon_sym_LPAREN2,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    ACTIONS(9974), 1,
      anon_sym_requires,
    STATE(3172), 1,
      sym_template_type,
    STATE(4170), 1,
      sym_requirement_seq,
    STATE(5234), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8138), 1,
      sym_requires_parameter_list,
    ACTIONS(9972), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4108), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202455] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    ACTIONS(9976), 1,
      anon_sym_LPAREN2,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    ACTIONS(9982), 1,
      anon_sym_requires,
    STATE(3064), 1,
      sym_template_type,
    STATE(3773), 1,
      sym_requirement_seq,
    STATE(5212), 1,
      sym_lambda_capture_specifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8243), 1,
      sym_requires_parameter_list,
    ACTIONS(9980), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3775), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym_const,
    ACTIONS(9984), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9986), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5769), 20,
      anon_sym_LPAREN2,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [202553] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    ACTIONS(9988), 1,
      anon_sym_LPAREN2,
    ACTIONS(9990), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_requires,
    STATE(2614), 1,
      sym_template_type,
    STATE(2957), 1,
      sym_requirement_seq,
    STATE(5199), 1,
      sym_lambda_capture_specifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7924), 1,
      sym_requires_parameter_list,
    ACTIONS(9992), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2958), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202614] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    ACTIONS(9996), 1,
      anon_sym_LPAREN2,
    ACTIONS(9998), 1,
      anon_sym_LBRACE,
    ACTIONS(10002), 1,
      anon_sym_requires,
    STATE(3005), 1,
      sym_template_type,
    STATE(4433), 1,
      sym_requirement_seq,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7913), 1,
      sym_requires_parameter_list,
    ACTIONS(10000), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5098), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202675] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    ACTIONS(10004), 1,
      anon_sym_LPAREN2,
    ACTIONS(10006), 1,
      anon_sym_LBRACE,
    ACTIONS(10010), 1,
      anon_sym_requires,
    STATE(3648), 1,
      sym_requirement_seq,
    STATE(3955), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7905), 1,
      sym_requires_parameter_list,
    ACTIONS(10008), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4481), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202736] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    ACTIONS(10012), 1,
      anon_sym_LPAREN2,
    ACTIONS(10014), 1,
      anon_sym_LBRACE,
    ACTIONS(10018), 1,
      anon_sym_requires,
    STATE(3105), 1,
      sym_template_type,
    STATE(3921), 1,
      sym_requirement_seq,
    STATE(5196), 1,
      sym_lambda_capture_specifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7849), 1,
      sym_requires_parameter_list,
    ACTIONS(10016), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3922), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202797] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    ACTIONS(10004), 1,
      anon_sym_LPAREN2,
    ACTIONS(10006), 1,
      anon_sym_LBRACE,
    ACTIONS(10010), 1,
      anon_sym_requires,
    STATE(2526), 1,
      sym_template_type,
    STATE(3648), 1,
      sym_requirement_seq,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7905), 1,
      sym_requires_parameter_list,
    ACTIONS(10020), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4418), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [202858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_const,
    ACTIONS(9986), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 22,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [202893] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6563), 1,
      sym__function_attributes_end,
    STATE(6742), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
  [202955] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      anon_sym_COLON,
    ACTIONS(10024), 1,
      anon_sym_SEMI,
    ACTIONS(10026), 1,
      anon_sym_LBRACE,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(10030), 1,
      anon_sym_EQ,
    ACTIONS(10032), 1,
      anon_sym_try,
    STATE(2099), 1,
      sym_compound_statement,
    STATE(2108), 1,
      sym_default_method_clause,
    STATE(2109), 1,
      sym_delete_method_clause,
    STATE(2113), 1,
      sym_pure_virtual_clause,
    STATE(2127), 1,
      sym_try_statement,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7037), 1,
      sym_bitfield_clause,
    STATE(7038), 1,
      sym_initializer_list,
    STATE(7042), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8419), 1,
      sym_attribute_specifier,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [203029] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6199), 1,
      sym_trailing_return_type,
    STATE(6539), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9882), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203091] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6244), 1,
      sym_trailing_return_type,
    STATE(6537), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203153] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    STATE(6542), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203215] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6585), 1,
      sym__function_attributes_end,
    STATE(6746), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9882), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9854), 1,
      anon_sym_requires,
    STATE(6510), 1,
      sym__function_attributes_end,
    STATE(6697), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203339] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    STATE(6544), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9882), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203401] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    STATE(6543), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203463] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6162), 1,
      sym_trailing_return_type,
    STATE(6538), 1,
      sym__function_attributes_end,
    STATE(6948), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9537), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5838), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6019), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203525] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6499), 1,
      sym__function_attributes_end,
    STATE(6649), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203587] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6572), 1,
      sym__function_attributes_end,
    STATE(6734), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9038), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203649] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      anon_sym_COLON,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(10034), 1,
      anon_sym_SEMI,
    ACTIONS(10036), 1,
      anon_sym_LBRACE,
    ACTIONS(10038), 1,
      anon_sym_EQ,
    ACTIONS(10040), 1,
      anon_sym_try,
    STATE(2159), 1,
      sym_compound_statement,
    STATE(2160), 1,
      sym_default_method_clause,
    STATE(2186), 1,
      sym_delete_method_clause,
    STATE(2187), 1,
      sym_pure_virtual_clause,
    STATE(2218), 1,
      sym_try_statement,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6998), 1,
      sym_bitfield_clause,
    STATE(6999), 1,
      sym_initializer_list,
    STATE(7000), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8993), 1,
      sym_attribute_specifier,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [203723] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      anon_sym_COLON,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(10042), 1,
      anon_sym_SEMI,
    ACTIONS(10044), 1,
      anon_sym_LBRACE,
    ACTIONS(10046), 1,
      anon_sym_EQ,
    ACTIONS(10048), 1,
      anon_sym_try,
    STATE(1973), 1,
      sym_compound_statement,
    STATE(1974), 1,
      sym_default_method_clause,
    STATE(1975), 1,
      sym_delete_method_clause,
    STATE(1976), 1,
      sym_pure_virtual_clause,
    STATE(1977), 1,
      sym_try_statement,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6985), 1,
      sym_initializer_list,
    STATE(7005), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7045), 1,
      sym_bitfield_clause,
    STATE(8596), 1,
      sym_attribute_specifier,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [203797] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(6144), 1,
      sym_ms_call_modifier,
    STATE(6844), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    ACTIONS(2060), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [203851] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(10050), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6439), 1,
      sym__function_attributes_end,
    STATE(6650), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9882), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203913] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9940), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9943), 1,
      anon_sym_requires,
    STATE(6523), 1,
      sym__function_attributes_end,
    STATE(6699), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9537), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
  [203975] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9851), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(6525), 1,
      sym__function_attributes_end,
    STATE(6643), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9038), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
  [204037] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7347), 1,
      anon_sym___asm,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(10050), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    STATE(6526), 1,
      sym__function_attributes_end,
    STATE(6704), 1,
      sym_trailing_return_type,
    STATE(6975), 1,
      sym_gnu_asm_expression,
    ACTIONS(7345), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9882), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5817), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6152), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
  [204099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10058), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10056), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [204130] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8235), 1,
      anon_sym_STAR,
    ACTIONS(8237), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8239), 1,
      anon_sym_AMP,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6428), 1,
      sym__abstract_declarator,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [204177] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8293), 1,
      anon_sym_STAR,
    ACTIONS(8295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8297), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8479), 1,
      anon_sym___attribute,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6391), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [204226] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    STATE(5966), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9893), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [204268] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    ACTIONS(9982), 1,
      anon_sym_requires,
    ACTIONS(10060), 1,
      anon_sym_LPAREN2,
    STATE(3064), 1,
      sym_template_type,
    STATE(5212), 1,
      sym_lambda_capture_specifier,
    STATE(6778), 1,
      sym__scope_resolution,
    ACTIONS(10062), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3791), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204320] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5208), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10066), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6696), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204372] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5208), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10070), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1887), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204424] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    ACTIONS(9982), 1,
      anon_sym_requires,
    ACTIONS(10060), 1,
      anon_sym_LPAREN2,
    STATE(3064), 1,
      sym_template_type,
    STATE(5212), 1,
      sym_lambda_capture_specifier,
    STATE(6778), 1,
      sym__scope_resolution,
    ACTIONS(10072), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3792), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204476] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5224), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10074), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5641), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204528] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5208), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10076), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6713), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204580] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10078), 1,
      sym_identifier,
    ACTIONS(10080), 1,
      anon_sym_TILDE,
    ACTIONS(10082), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10084), 1,
      anon_sym_template,
    ACTIONS(10086), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5677), 1,
      sym__scope_resolution,
    STATE(7170), 1,
      sym_operator_cast,
    STATE(7255), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [204650] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    ACTIONS(10088), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      anon_sym_COLON_COLON,
    STATE(2270), 1,
      sym_template_type,
    STATE(5200), 1,
      sym_lambda_capture_specifier,
    STATE(6815), 1,
      sym__scope_resolution,
    ACTIONS(10092), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2285), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204702] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    ACTIONS(10002), 1,
      anon_sym_requires,
    ACTIONS(10094), 1,
      anon_sym_LPAREN2,
    STATE(3005), 1,
      sym_template_type,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6793), 1,
      sym__scope_resolution,
    ACTIONS(10096), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6283), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204754] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    ACTIONS(10100), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4425), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    ACTIONS(10002), 1,
      anon_sym_requires,
    ACTIONS(10094), 1,
      anon_sym_LPAREN2,
    STATE(3005), 1,
      sym_template_type,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6793), 1,
      sym__scope_resolution,
    ACTIONS(10102), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4429), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204858] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6767), 1,
      sym__scope_resolution,
    ACTIONS(10104), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3611), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [204910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10108), 1,
      anon_sym_const,
    ACTIONS(10106), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [204940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    ACTIONS(9049), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [204982] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5979), 1,
      sym_trailing_return_type,
    ACTIONS(9548), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [205024] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(9898), 1,
      anon_sym_requires,
    STATE(5909), 1,
      sym_trailing_return_type,
    ACTIONS(9893), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [205066] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(10117), 1,
      anon_sym_requires,
    STATE(5913), 1,
      sym_trailing_return_type,
    ACTIONS(10112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [205108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10122), 1,
      anon_sym_const,
    ACTIONS(10120), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [205138] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    ACTIONS(10002), 1,
      anon_sym_requires,
    ACTIONS(10094), 1,
      anon_sym_LPAREN2,
    STATE(3005), 1,
      sym_template_type,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6793), 1,
      sym__scope_resolution,
    ACTIONS(10124), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6349), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205190] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(3955), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(10126), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4447), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_const,
    ACTIONS(4441), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [205272] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(3955), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(10104), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3611), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205324] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9876), 1,
      sym_identifier,
    ACTIONS(10128), 1,
      anon_sym_LPAREN2,
    ACTIONS(10132), 1,
      anon_sym_requires,
    STATE(4636), 1,
      sym_template_type,
    STATE(5206), 1,
      sym_lambda_capture_specifier,
    STATE(6835), 1,
      sym__scope_resolution,
    ACTIONS(10130), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6056), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205376] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6806), 1,
      sym__scope_resolution,
    ACTIONS(10136), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5990), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10142), 1,
      anon_sym_const,
    ACTIONS(10140), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [205458] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    ACTIONS(9974), 1,
      anon_sym_requires,
    ACTIONS(10144), 1,
      anon_sym_LPAREN2,
    STATE(3172), 1,
      sym_template_type,
    STATE(5234), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(10146), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4168), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205510] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    ACTIONS(10148), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6163), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205562] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    ACTIONS(10002), 1,
      anon_sym_requires,
    ACTIONS(10094), 1,
      anon_sym_LPAREN2,
    STATE(3005), 1,
      sym_template_type,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6802), 1,
      sym__scope_resolution,
    ACTIONS(10102), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4429), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205614] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    ACTIONS(10088), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      anon_sym_COLON_COLON,
    STATE(2270), 1,
      sym_template_type,
    STATE(5200), 1,
      sym_lambda_capture_specifier,
    STATE(6815), 1,
      sym__scope_resolution,
    ACTIONS(10150), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2286), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205666] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(5204), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(10156), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7108), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205718] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(5204), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(10104), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3611), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205770] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    ACTIONS(10088), 1,
      sym_identifier,
    ACTIONS(10090), 1,
      anon_sym_COLON_COLON,
    STATE(2270), 1,
      sym_template_type,
    STATE(5200), 1,
      sym_lambda_capture_specifier,
    STATE(6815), 1,
      sym__scope_resolution,
    ACTIONS(10070), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1887), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205822] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6806), 1,
      sym__scope_resolution,
    ACTIONS(10158), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5897), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205874] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6806), 1,
      sym__scope_resolution,
    ACTIONS(10160), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5899), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205926] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    ACTIONS(10018), 1,
      anon_sym_requires,
    ACTIONS(10162), 1,
      anon_sym_LPAREN2,
    STATE(3105), 1,
      sym_template_type,
    STATE(5196), 1,
      sym_lambda_capture_specifier,
    STATE(6823), 1,
      sym__scope_resolution,
    ACTIONS(10164), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3858), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [205978] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    ACTIONS(9974), 1,
      anon_sym_requires,
    ACTIONS(10144), 1,
      anon_sym_LPAREN2,
    STATE(3172), 1,
      sym_template_type,
    STATE(5234), 1,
      sym_lambda_capture_specifier,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(10166), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4169), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206030] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3942), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10168), 1,
      sym_identifier,
    ACTIONS(10170), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5707), 1,
      sym__scope_resolution,
    STATE(7170), 1,
      sym_operator_cast,
    STATE(7255), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [206100] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    ACTIONS(10018), 1,
      anon_sym_requires,
    ACTIONS(10162), 1,
      anon_sym_LPAREN2,
    STATE(3105), 1,
      sym_template_type,
    STATE(5196), 1,
      sym_lambda_capture_specifier,
    STATE(6823), 1,
      sym__scope_resolution,
    ACTIONS(10172), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3853), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10176), 1,
      anon_sym_const,
    ACTIONS(10174), 21,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_DASH_GT,
      anon_sym_noexcept,
      anon_sym_throw,
  [206182] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(5204), 1,
      sym_lambda_capture_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    ACTIONS(10178), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(7080), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206234] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9876), 1,
      sym_identifier,
    ACTIONS(10128), 1,
      anon_sym_LPAREN2,
    ACTIONS(10132), 1,
      anon_sym_requires,
    STATE(4636), 1,
      sym_template_type,
    STATE(5206), 1,
      sym_lambda_capture_specifier,
    STATE(6835), 1,
      sym__scope_resolution,
    ACTIONS(10180), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6008), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206286] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(2730), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10182), 1,
      sym_identifier,
    ACTIONS(10184), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(7170), 1,
      sym_operator_cast,
    STATE(7255), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [206356] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8388), 1,
      anon_sym_STAR,
    ACTIONS(8390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8392), 1,
      anon_sym_AMP,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6436), 1,
      sym__abstract_declarator,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [206402] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    STATE(5983), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9049), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [206444] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_requires,
    ACTIONS(10186), 1,
      anon_sym_LPAREN2,
    STATE(2614), 1,
      sym_template_type,
    STATE(5199), 1,
      sym_lambda_capture_specifier,
    STATE(6840), 1,
      sym__scope_resolution,
    ACTIONS(10188), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2953), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206496] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    ACTIONS(9994), 1,
      anon_sym_requires,
    ACTIONS(10186), 1,
      anon_sym_LPAREN2,
    STATE(2614), 1,
      sym_template_type,
    STATE(5199), 1,
      sym_lambda_capture_specifier,
    STATE(6840), 1,
      sym__scope_resolution,
    ACTIONS(10190), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2960), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206548] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9876), 1,
      sym_identifier,
    ACTIONS(10128), 1,
      anon_sym_LPAREN2,
    ACTIONS(10132), 1,
      anon_sym_requires,
    STATE(4636), 1,
      sym_template_type,
    STATE(5206), 1,
      sym_lambda_capture_specifier,
    STATE(6835), 1,
      sym__scope_resolution,
    ACTIONS(10192), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6080), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206600] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    STATE(5869), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9548), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [206642] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DASH_GT,
    ACTIONS(7375), 1,
      anon_sym_requires,
    STATE(5859), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [206684] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(10194), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6330), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206736] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5224), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10196), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5647), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206788] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10064), 1,
      anon_sym_LPAREN2,
    ACTIONS(10068), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5224), 1,
      sym_lambda_capture_specifier,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(10070), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1887), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10200), 1,
      anon_sym_LPAREN2,
    STATE(5927), 1,
      sym_preproc_argument_list,
    ACTIONS(10202), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10198), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [206874] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    ACTIONS(10204), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6170), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206926] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(10206), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6266), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [206978] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    ACTIONS(10134), 1,
      anon_sym_LPAREN2,
    ACTIONS(10138), 1,
      anon_sym_requires,
    STATE(2039), 1,
      sym_template_type,
    STATE(5202), 1,
      sym_lambda_capture_specifier,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(10160), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5899), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207030] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    ACTIONS(10002), 1,
      anon_sym_requires,
    ACTIONS(10094), 1,
      anon_sym_LPAREN2,
    STATE(3005), 1,
      sym_template_type,
    STATE(5237), 1,
      sym_lambda_capture_specifier,
    STATE(6802), 1,
      sym__scope_resolution,
    ACTIONS(10208), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5070), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207082] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3912), 1,
      anon_sym_LBRACK,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    ACTIONS(10010), 1,
      anon_sym_requires,
    ACTIONS(10098), 1,
      anon_sym_LPAREN2,
    STATE(2526), 1,
      sym_template_type,
    STATE(5216), 1,
      sym_lambda_capture_specifier,
    STATE(6798), 1,
      sym__scope_resolution,
    ACTIONS(10104), 2,
      sym_true,
      sym_false,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3611), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [207134] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2377), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5796), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207193] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4345), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5165), 1,
      sym__class_declaration_item,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5734), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207311] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5182), 1,
      sym__class_declaration_item,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207370] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2577), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5754), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207429] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5152), 1,
      sym__class_declaration_item,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207488] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5159), 1,
      sym__class_declaration_item,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5736), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207547] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(4991), 1,
      sym_field_declaration_list,
    STATE(5178), 1,
      sym__class_declaration_item,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(7217), 1,
      sym_virtual_specifier,
    STATE(8065), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4570), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207606] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    ACTIONS(10210), 1,
      anon_sym_SEMI,
    STATE(5660), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    STATE(8742), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [207659] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2370), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207718] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5106), 1,
      sym__class_declaration_item,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207777] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3465), 1,
      sym__class_declaration_item,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5744), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207836] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5116), 1,
      sym__class_declaration_item,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5791), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [207895] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    ACTIONS(10212), 1,
      anon_sym_SEMI,
    STATE(5661), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    STATE(9055), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [207948] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3470), 1,
      sym__class_declaration_item,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3438), 1,
      sym__class_declaration_item,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208066] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3497), 1,
      sym__class_declaration_item,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5753), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208125] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2550), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208184] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2370), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208243] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2352), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5806), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208302] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2377), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5757), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208361] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4322), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5764), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208420] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2371), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208479] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3385), 1,
      sym__class_declaration_item,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5788), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208538] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3238), 1,
      sym_field_declaration_list,
    STATE(3439), 1,
      sym__class_declaration_item,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(7183), 1,
      sym_virtual_specifier,
    STATE(8008), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2956), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208597] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2593), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10216), 1,
      anon_sym_LPAREN2,
    ACTIONS(10218), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10214), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [208687] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(141), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5523), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10220), 1,
      sym_identifier,
    ACTIONS(10222), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5756), 1,
      sym__scope_resolution,
    STATE(7170), 1,
      sym_operator_cast,
    STATE(7255), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [208750] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2370), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208809] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2352), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5766), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208868] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2770), 1,
      sym__class_declaration_item,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208927] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2570), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5776), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [208986] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3090), 1,
      sym__class_declaration_item,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5771), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209045] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3045), 1,
      sym__class_declaration_item,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209104] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2702), 1,
      sym__class_declaration_item,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5767), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209163] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4339), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209222] = 5,
    ACTIONS(10198), 1,
      anon_sym_LF,
    ACTIONS(10224), 1,
      anon_sym_LPAREN2,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(6054), 1,
      sym_preproc_argument_list,
    ACTIONS(10202), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [209255] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(2368), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209314] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2747), 1,
      sym__class_declaration_item,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209373] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4321), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5730), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209432] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2570), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5746), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209491] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2578), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209550] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3057), 1,
      sym__class_declaration_item,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209609] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10230), 1,
      anon_sym_RPAREN,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10240), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5780), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [209652] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3061), 1,
      sym__class_declaration_item,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5774), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209711] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3093), 1,
      sym__class_declaration_item,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209770] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2368), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209829] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2550), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [209888] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(10246), 1,
      anon_sym_RPAREN,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    STATE(7613), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [209943] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2371), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210002] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5041), 1,
      sym__class_declaration_item,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5785), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210061] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10272), 1,
      anon_sym_RPAREN,
    STATE(7460), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [210116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10276), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10274), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [210145] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5049), 1,
      sym__class_declaration_item,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210204] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3342), 1,
      sym__class_declaration_item,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210263] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8410), 1,
      anon_sym_STAR,
    ACTIONS(8412), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8414), 1,
      anon_sym_AMP,
    ACTIONS(8479), 1,
      anon_sym___attribute,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6576), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [210310] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5106), 1,
      sym__class_declaration_item,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210369] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2371), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210428] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5116), 1,
      sym__class_declaration_item,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5841), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210487] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3374), 1,
      sym__class_declaration_item,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210546] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2780), 1,
      sym__class_declaration_item,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210605] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4205), 1,
      sym_field_declaration_list,
    STATE(4326), 1,
      sym__class_declaration_item,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(7258), 1,
      sym_virtual_specifier,
    STATE(8105), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3469), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210664] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5004), 1,
      sym__class_declaration_item,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210723] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3355), 1,
      sym__class_declaration_item,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210782] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2578), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210841] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3213), 1,
      sym_field_declaration_list,
    STATE(3415), 1,
      sym__class_declaration_item,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_virtual_specifier,
    STATE(7895), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2856), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210900] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2593), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [210959] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2370), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211018] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2570), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5802), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211077] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2352), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5807), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211136] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    ACTIONS(10278), 1,
      anon_sym_SEMI,
    STATE(5649), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8349), 1,
      sym_attribute_specifier,
    STATE(8359), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [211189] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5041), 1,
      sym__class_declaration_item,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5739), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10282), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10280), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [211277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2550), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211336] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10284), 1,
      anon_sym_RPAREN,
    ACTIONS(10286), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5777), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [211379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10290), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10288), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [211408] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5049), 1,
      sym__class_declaration_item,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211467] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2368), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211526] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2368), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211585] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2377), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5810), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211644] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2371), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211703] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2370), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211762] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2352), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5812), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211821] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2368), 1,
      sym__class_declaration_item,
    STATE(5297), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7332), 1,
      sym_virtual_specifier,
    STATE(8195), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4975), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10294), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10292), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [211909] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2352), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5775), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [211968] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3730), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5821), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212027] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(10298), 1,
      anon_sym_LBRACK,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6137), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10296), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [212066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(10302), 1,
      anon_sym_LBRACK,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6151), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10300), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [212105] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10304), 1,
      anon_sym_RPAREN,
    STATE(7608), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [212160] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8394), 1,
      anon_sym_STAR,
    ACTIONS(8396), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8398), 1,
      anon_sym_AMP,
    ACTIONS(8479), 1,
      anon_sym___attribute,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6568), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [212207] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3669), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212266] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3692), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212325] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2377), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5747), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212384] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3699), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5825), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212443] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2577), 1,
      sym__class_declaration_item,
    STATE(5435), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7287), 1,
      sym_virtual_specifier,
    STATE(8154), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4761), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5795), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212502] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3353), 1,
      sym_field_declaration_list,
    STATE(3769), 1,
      sym__class_declaration_item,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(7275), 1,
      sym_virtual_specifier,
    STATE(7841), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3040), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212561] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2371), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2568), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212620] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3090), 1,
      sym__class_declaration_item,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5837), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212679] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3045), 1,
      sym__class_declaration_item,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10308), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10306), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [212767] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2692), 1,
      sym_field_declaration_list,
    STATE(2771), 1,
      sym__class_declaration_item,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(7338), 1,
      sym_virtual_specifier,
    STATE(7894), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2539), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5759), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212826] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2377), 1,
      sym__class_declaration_item,
    STATE(2419), 1,
      sym_field_declaration_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(7141), 1,
      sym_virtual_specifier,
    STATE(7909), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2301), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5738), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212885] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10298), 1,
      anon_sym_LBRACK,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10296), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [212924] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2593), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [212983] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2578), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213042] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2577), 1,
      sym__class_declaration_item,
    STATE(2828), 1,
      sym_field_declaration_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(7137), 1,
      sym_virtual_specifier,
    STATE(8142), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2639), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5833), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213101] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10310), 1,
      anon_sym_RPAREN,
    ACTIONS(10312), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5818), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [213144] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3057), 1,
      sym__class_declaration_item,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213203] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10302), 1,
      anon_sym_LBRACK,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10300), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [213242] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3061), 1,
      sym__class_declaration_item,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5840), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213301] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2990), 1,
      sym_field_declaration_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(3093), 1,
      sym__class_declaration_item,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(7291), 1,
      sym_virtual_specifier,
    STATE(8120), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2811), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213360] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4875), 1,
      sym_field_declaration_list,
    STATE(5004), 1,
      sym__class_declaration_item,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(7339), 1,
      sym_virtual_specifier,
    STATE(7929), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(4535), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [213419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10316), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10314), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [213455] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7060), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [213505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10318), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5936), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [213545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10320), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6052), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [213585] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8436), 1,
      anon_sym_STAR,
    ACTIONS(8438), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8440), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6661), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [213629] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10316), 1,
      anon_sym_PIPE,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10314), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [213675] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7113), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [213725] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7105), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [213775] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10330), 1,
      anon_sym_RBRACK,
    ACTIONS(10332), 1,
      sym_this,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [213827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10336), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10334), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [213855] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7058), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [213905] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7092), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [213955] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10080), 1,
      anon_sym_TILDE,
    ACTIONS(10338), 1,
      sym_identifier,
    ACTIONS(10340), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10342), 1,
      anon_sym_template,
    ACTIONS(10344), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5854), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [214019] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10356), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6013), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214059] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10360), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5940), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10364), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10362), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [214127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10366), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6067), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10370), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [214203] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7055), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [214253] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(10372), 1,
      sym_identifier,
    ACTIONS(10374), 1,
      anon_sym_TILDE,
    ACTIONS(10376), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10378), 1,
      anon_sym_template,
    ACTIONS(10380), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3565), 1,
      sym_pointer_type_declarator,
    STATE(3576), 1,
      sym_template_function,
    STATE(3578), 1,
      sym_destructor_name,
    STATE(3580), 1,
      sym_dependent_identifier,
    STATE(3581), 1,
      sym_qualified_identifier,
    STATE(3585), 1,
      sym_operator_name,
    STATE(5861), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [214317] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10382), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6009), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5497), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214385] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10384), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [214437] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10386), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6000), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214477] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10388), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [214529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5465), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214557] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7102), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [214607] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9893), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [214643] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10390), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [214695] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10392), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6023), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214735] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7120), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [214785] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10394), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [214837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1945), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(10374), 1,
      anon_sym_TILDE,
    ACTIONS(10380), 1,
      anon_sym_operator,
    ACTIONS(10396), 1,
      sym_identifier,
    ACTIONS(10398), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10400), 1,
      anon_sym_template,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(2519), 1,
      sym_template_type,
    STATE(2520), 1,
      sym_dependent_type_identifier,
    STATE(3565), 1,
      sym_pointer_type_declarator,
    STATE(3576), 1,
      sym_template_function,
    STATE(3578), 1,
      sym_destructor_name,
    STATE(3580), 1,
      sym_dependent_identifier,
    STATE(3581), 1,
      sym_qualified_identifier,
    STATE(3585), 1,
      sym_operator_name,
    STATE(5875), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [214929] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10402), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6015), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [214969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5501), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [214997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5505), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215025] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10404), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5901), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [215065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9049), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [215101] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10316), 1,
      anon_sym_PIPE,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10314), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [215145] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10316), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10314), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [215187] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10406), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5968), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [215227] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10316), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10314), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [215267] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10408), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215319] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10410), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215371] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7063), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [215421] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10412), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215473] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(10414), 1,
      sym_identifier,
    ACTIONS(10416), 1,
      anon_sym_TILDE,
    ACTIONS(10418), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10420), 1,
      anon_sym_template,
    ACTIONS(10422), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3803), 1,
      sym_pointer_type_declarator,
    STATE(3805), 1,
      sym_template_function,
    STATE(3806), 1,
      sym_destructor_name,
    STATE(3810), 1,
      sym_dependent_identifier,
    STATE(3812), 1,
      sym_qualified_identifier,
    STATE(3814), 1,
      sym_operator_name,
    STATE(5889), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [215537] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10424), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215589] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10426), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5477), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5469), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215697] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10428), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6068), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [215737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10430), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5976), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [215777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10434), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10432), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [215805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215835] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10438), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6046), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [215875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5485), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [215903] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10440), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [215955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10316), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10314), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [215987] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10442), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6069), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216027] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10444), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6050), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216067] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7062), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [216117] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10446), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [216169] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7106), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [216219] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10448), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [216271] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7075), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [216321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10117), 1,
      anon_sym_requires,
    ACTIONS(10112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [216357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10316), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10314), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10450), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6070), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216431] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7081), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [216481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10455), 1,
      anon_sym_requires,
    ACTIONS(10370), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10452), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [216517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5509), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216545] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10458), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6071), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216585] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10460), 1,
      sym_identifier,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(10464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10466), 1,
      anon_sym_template,
    ACTIONS(10468), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(2966), 1,
      sym_pointer_type_declarator,
    STATE(2967), 1,
      sym_template_function,
    STATE(2968), 1,
      sym_destructor_name,
    STATE(2969), 1,
      sym_dependent_identifier,
    STATE(2970), 1,
      sym_qualified_identifier,
    STATE(2971), 1,
      sym_operator_name,
    STATE(5916), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [216649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10470), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5842), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216689] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7118), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [216739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10474), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10472), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [216767] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10476), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6072), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10478), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6011), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216847] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10480), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [216899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5461), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [216927] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10482), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5910), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [216967] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(10468), 1,
      anon_sym_operator,
    ACTIONS(10484), 1,
      sym_identifier,
    ACTIONS(10486), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10488), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(2966), 1,
      sym_pointer_type_declarator,
    STATE(2967), 1,
      sym_template_function,
    STATE(2968), 1,
      sym_destructor_name,
    STATE(2969), 1,
      sym_dependent_identifier,
    STATE(2970), 1,
      sym_qualified_identifier,
    STATE(2971), 1,
      sym_operator_name,
    STATE(5925), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [217031] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10490), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5847), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10494), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10492), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217127] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10496), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [217179] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10498), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5956), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5481), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [217247] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7131), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [217297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10500), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217325] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10504), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6027), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217365] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(10506), 1,
      sym_identifier,
    ACTIONS(10508), 1,
      anon_sym_TILDE,
    ACTIONS(10510), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10512), 1,
      anon_sym_template,
    ACTIONS(10514), 1,
      anon_sym_operator,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3928), 1,
      sym_pointer_type_declarator,
    STATE(3930), 1,
      sym_template_function,
    STATE(3931), 1,
      sym_destructor_name,
    STATE(3933), 1,
      sym_dependent_identifier,
    STATE(3941), 1,
      sym_qualified_identifier,
    STATE(3948), 1,
      sym_operator_name,
    STATE(5935), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [217429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10316), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10314), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [217457] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4898), 1,
      anon_sym_RBRACK,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [217509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10516), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6074), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10518), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6075), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217589] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10314), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [217637] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10520), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6076), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10522), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6033), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10524), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6039), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217757] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10526), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6042), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10528), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6077), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [217837] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4635), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10530), 1,
      sym_identifier,
    ACTIONS(10532), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5946), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [217901] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10534), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [217953] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(10416), 1,
      anon_sym_TILDE,
    ACTIONS(10422), 1,
      anon_sym_operator,
    ACTIONS(10536), 1,
      sym_identifier,
    ACTIONS(10538), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10540), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3803), 1,
      sym_pointer_type_declarator,
    STATE(3805), 1,
      sym_template_function,
    STATE(3806), 1,
      sym_destructor_name,
    STATE(3810), 1,
      sym_dependent_identifier,
    STATE(3812), 1,
      sym_qualified_identifier,
    STATE(3814), 1,
      sym_operator_name,
    STATE(5948), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [218017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218045] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4898), 1,
      anon_sym_RBRACK,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10542), 1,
      sym_identifier,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218097] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10544), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218149] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(10468), 1,
      anon_sym_operator,
    ACTIONS(10546), 1,
      sym_identifier,
    ACTIONS(10548), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10550), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(2966), 1,
      sym_pointer_type_declarator,
    STATE(2967), 1,
      sym_template_function,
    STATE(2968), 1,
      sym_destructor_name,
    STATE(2969), 1,
      sym_dependent_identifier,
    STATE(2970), 1,
      sym_qualified_identifier,
    STATE(2971), 1,
      sym_operator_name,
    STATE(5952), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [218213] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10552), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5881), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [218253] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4287), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10554), 1,
      sym_identifier,
    ACTIONS(10556), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(5954), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [218317] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(10468), 1,
      anon_sym_operator,
    ACTIONS(10558), 1,
      sym_identifier,
    ACTIONS(10560), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10562), 1,
      anon_sym_template,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(2519), 1,
      sym_template_type,
    STATE(2520), 1,
      sym_dependent_type_identifier,
    STATE(2966), 1,
      sym_pointer_type_declarator,
    STATE(2967), 1,
      sym_template_function,
    STATE(2968), 1,
      sym_destructor_name,
    STATE(2969), 1,
      sym_dependent_identifier,
    STATE(2970), 1,
      sym_qualified_identifier,
    STATE(2971), 1,
      sym_operator_name,
    STATE(5955), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [218381] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10564), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [218431] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10566), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5882), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [218471] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7126), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [218521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5489), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218549] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10568), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10570), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [218629] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10574), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218681] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10576), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5493), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218761] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10578), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6040), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [218801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [218837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9563), 1,
      anon_sym_requires,
    ACTIONS(9548), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [218873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10582), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10580), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [218901] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10584), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6014), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [218941] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10586), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [218993] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7069), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [219043] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10588), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [219095] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10590), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [219147] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10592), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [219199] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(10508), 1,
      anon_sym_TILDE,
    ACTIONS(10514), 1,
      anon_sym_operator,
    ACTIONS(10594), 1,
      sym_identifier,
    ACTIONS(10596), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10598), 1,
      anon_sym_template,
    STATE(3008), 1,
      sym_template_type,
    STATE(3014), 1,
      sym_dependent_type_identifier,
    STATE(3063), 1,
      sym_qualified_type_identifier,
    STATE(3928), 1,
      sym_pointer_type_declarator,
    STATE(3930), 1,
      sym_template_function,
    STATE(3931), 1,
      sym_destructor_name,
    STATE(3933), 1,
      sym_dependent_identifier,
    STATE(3941), 1,
      sym_qualified_identifier,
    STATE(3948), 1,
      sym_operator_name,
    STATE(5975), 1,
      sym__scope_resolution,
    STATE(8667), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [219263] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10314), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [219309] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(10416), 1,
      anon_sym_TILDE,
    ACTIONS(10422), 1,
      anon_sym_operator,
    ACTIONS(10600), 1,
      sym_identifier,
    ACTIONS(10602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10604), 1,
      anon_sym_template,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(2519), 1,
      sym_template_type,
    STATE(2520), 1,
      sym_dependent_type_identifier,
    STATE(3803), 1,
      sym_pointer_type_declarator,
    STATE(3805), 1,
      sym_template_function,
    STATE(3806), 1,
      sym_destructor_name,
    STATE(3810), 1,
      sym_dependent_identifier,
    STATE(3812), 1,
      sym_qualified_identifier,
    STATE(3814), 1,
      sym_operator_name,
    STATE(5977), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_ms_based_modifier,
    STATE(8681), 1,
      sym_decltype,
  [219373] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10228), 1,
      sym_identifier,
    ACTIONS(10232), 1,
      anon_sym_LPAREN2,
    ACTIONS(10234), 1,
      anon_sym_defined,
    ACTIONS(10606), 1,
      sym_number_literal,
    ACTIONS(10236), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10238), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10242), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5884), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [219413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9898), 1,
      anon_sym_requires,
    ACTIONS(9893), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [219449] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10608), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6041), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [219489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219517] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10610), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [219569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9548), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [219605] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8467), 1,
      anon_sym_STAR,
    ACTIONS(8469), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8471), 1,
      anon_sym_AMP,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6627), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [219649] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4900), 1,
      anon_sym_EQ,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10326), 1,
      anon_sym_AMP,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10332), 1,
      sym_this,
    ACTIONS(10612), 1,
      anon_sym_RBRACK,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7871), 1,
      sym_lambda_default_capture,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7527), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [219701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7477), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(7479), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [219729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9116), 1,
      anon_sym_requires,
    ACTIONS(9049), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [219765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1949), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219793] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6640), 1,
      sym__type_declarator,
    STATE(7061), 1,
      sym__type_definition_declarators,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [219843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10436), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10614), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219875] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10346), 1,
      sym_identifier,
    ACTIONS(10348), 1,
      anon_sym_LPAREN2,
    ACTIONS(10350), 1,
      anon_sym_defined,
    ACTIONS(10616), 1,
      sym_number_literal,
    ACTIONS(10352), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10358), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(6073), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [219915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 1,
      anon_sym___attribute,
    ACTIONS(5509), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219942] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8585), 1,
      sym_identifier,
    ACTIONS(8587), 1,
      anon_sym_LPAREN2,
    ACTIONS(8589), 1,
      anon_sym_STAR,
    ACTIONS(8591), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8593), 1,
      anon_sym_AMP,
    ACTIONS(8597), 1,
      sym_primitive_type,
    STATE(3331), 1,
      sym__type_declarator,
    STATE(3781), 1,
      sym_pointer_type_declarator,
    STATE(8667), 1,
      sym_ms_based_modifier,
    ACTIONS(8595), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3772), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [219989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym___attribute,
    ACTIONS(1945), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220016] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10618), 1,
      sym_identifier,
    ACTIONS(10620), 1,
      anon_sym_COLON_COLON,
    STATE(320), 1,
      sym_template_type,
    STATE(487), 1,
      sym_field_declaration_list,
    STATE(6150), 1,
      sym_attribute_declaration,
    STATE(6838), 1,
      sym__scope_resolution,
    STATE(7173), 1,
      sym_virtual_specifier,
    STATE(8158), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(184), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [220071] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6954), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [220118] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(8515), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8517), 1,
      anon_sym_AMP,
    ACTIONS(8521), 1,
      sym_primitive_type,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(6895), 1,
      sym__type_declarator,
    STATE(8715), 1,
      sym_ms_based_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [220165] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6733), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [220212] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6419), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [220259] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10622), 1,
      anon_sym_LF,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10298), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10296), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220335] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10644), 1,
      sym_identifier,
    ACTIONS(10646), 1,
      anon_sym_COLON_COLON,
    STATE(1014), 1,
      sym_template_type,
    STATE(1115), 1,
      sym_field_declaration_list,
    STATE(6138), 1,
      sym_attribute_declaration,
    STATE(6841), 1,
      sym__scope_resolution,
    STATE(7153), 1,
      sym_virtual_specifier,
    STATE(7863), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(986), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [220390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10650), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10648), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220421] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10432), 1,
      anon_sym_LF,
    ACTIONS(10434), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [220448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220483] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10652), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      anon_sym_COLON_COLON,
    STATE(285), 1,
      sym_template_type,
    STATE(468), 1,
      sym_field_declaration_list,
    STATE(6156), 1,
      sym_attribute_declaration,
    STATE(6766), 1,
      sym__scope_resolution,
    STATE(7201), 1,
      sym_virtual_specifier,
    STATE(7831), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(187), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [220538] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10500), 1,
      anon_sym_LF,
    ACTIONS(10502), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [220565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym___attribute,
    ACTIONS(10656), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220594] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10658), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220639] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9534), 1,
      anon_sym_requires,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220674] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10660), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220719] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10570), 1,
      anon_sym_LF,
    ACTIONS(10572), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [220746] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10662), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220791] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10664), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220836] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10666), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [220881] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10668), 1,
      sym_identifier,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10672), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [220938] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [220973] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10362), 1,
      anon_sym_LF,
    ACTIONS(10364), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10302), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10300), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221031] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8503), 1,
      anon_sym_STAR,
    ACTIONS(8505), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8507), 1,
      anon_sym_AMP,
    STATE(2660), 1,
      sym__type_declarator,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(8272), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [221078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9644), 1,
      anon_sym_requires,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221113] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6958), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [221160] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10674), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221205] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(10678), 1,
      anon_sym_template,
    STATE(6024), 1,
      sym__scope_resolution,
    STATE(6463), 1,
      sym_pointer_type_declarator,
    STATE(6466), 1,
      sym_template_function,
    STATE(6467), 1,
      sym_destructor_name,
    STATE(6469), 1,
      sym_dependent_identifier,
    STATE(6470), 1,
      sym_qualified_identifier,
    STATE(6471), 1,
      sym_operator_name,
    STATE(9006), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [221262] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10680), 1,
      sym_identifier,
    ACTIONS(10682), 1,
      anon_sym_COLON_COLON,
    STATE(191), 1,
      sym_template_type,
    STATE(310), 1,
      sym_field_declaration_list,
    STATE(6147), 1,
      sym_attribute_declaration,
    STATE(6768), 1,
      sym__scope_resolution,
    STATE(7156), 1,
      sym_virtual_specifier,
    STATE(8006), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(149), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221317] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10684), 1,
      anon_sym_COLON_COLON,
    STATE(468), 1,
      sym_field_declaration_list,
    STATE(2039), 1,
      sym_template_type,
    STATE(6153), 1,
      sym_attribute_declaration,
    STATE(6790), 1,
      sym__scope_resolution,
    STATE(7279), 1,
      sym_virtual_specifier,
    STATE(7926), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6812), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221372] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10686), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221417] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7564), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8513), 1,
      anon_sym_STAR,
    ACTIONS(10676), 1,
      sym_identifier,
    ACTIONS(10678), 1,
      anon_sym_template,
    STATE(6028), 1,
      sym__scope_resolution,
    STATE(6463), 1,
      sym_pointer_type_declarator,
    STATE(6466), 1,
      sym_template_function,
    STATE(6467), 1,
      sym_destructor_name,
    STATE(6469), 1,
      sym_dependent_identifier,
    STATE(6470), 1,
      sym_qualified_identifier,
    STATE(6471), 1,
      sym_operator_name,
    STATE(8715), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [221474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9959), 1,
      anon_sym_requires,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221509] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6892), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10220), 1,
      sym_identifier,
    ACTIONS(10222), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(6030), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [221566] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8509), 1,
      sym_identifier,
    ACTIONS(8511), 1,
      anon_sym_LPAREN2,
    ACTIONS(8521), 1,
      sym_primitive_type,
    ACTIONS(8523), 1,
      anon_sym_STAR,
    ACTIONS(8525), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8527), 1,
      anon_sym_AMP,
    STATE(6251), 1,
      sym__type_declarator,
    STATE(6465), 1,
      sym_pointer_type_declarator,
    STATE(9006), 1,
      sym_ms_based_modifier,
    ACTIONS(8519), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(6497), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [221613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8563), 1,
      anon_sym_STAR,
    ACTIONS(8565), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8567), 1,
      anon_sym_AMP,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6762), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8477), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [221656] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10688), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221701] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10693), 1,
      anon_sym_requires,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(10699), 1,
      anon_sym_requires,
    ACTIONS(10696), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [221806] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8499), 1,
      sym_primitive_type,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(8547), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8549), 1,
      anon_sym_AMP,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6938), 1,
      sym__type_declarator,
    STATE(8851), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [221853] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6942), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [221900] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10702), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221945] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10704), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [221990] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10706), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222035] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10708), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [222080] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7556), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10710), 1,
      sym_identifier,
    ACTIONS(10712), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(6043), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [222137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222172] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8485), 1,
      sym_identifier,
    ACTIONS(8487), 1,
      anon_sym_LPAREN2,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(8491), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8493), 1,
      anon_sym_AMP,
    ACTIONS(8499), 1,
      sym_primitive_type,
    STATE(2712), 1,
      sym_pointer_type_declarator,
    STATE(6932), 1,
      sym__type_declarator,
    STATE(8660), 1,
      sym_ms_based_modifier,
    ACTIONS(8497), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2777), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [222219] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10714), 1,
      anon_sym_RPAREN,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [222303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10716), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3364), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6879), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222334] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10472), 1,
      anon_sym_LF,
    ACTIONS(10474), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222361] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10580), 1,
      anon_sym_LF,
    ACTIONS(10582), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222388] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7672), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8545), 1,
      anon_sym_STAR,
    ACTIONS(10220), 1,
      sym_identifier,
    ACTIONS(10222), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(6051), 1,
      sym__scope_resolution,
    STATE(8851), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [222445] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10252), 1,
      anon_sym_SLASH,
    ACTIONS(10254), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10256), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10258), 1,
      anon_sym_PIPE,
    ACTIONS(10260), 1,
      anon_sym_CARET,
    ACTIONS(10262), 1,
      anon_sym_AMP,
    ACTIONS(10719), 1,
      anon_sym_RPAREN,
    ACTIONS(10248), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10250), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10264), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10268), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(10270), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222494] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(8529), 1,
      sym_identifier,
    ACTIONS(8531), 1,
      anon_sym_LPAREN2,
    ACTIONS(8533), 1,
      anon_sym_STAR,
    ACTIONS(8535), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8537), 1,
      anon_sym_AMP,
    ACTIONS(8541), 1,
      sym_primitive_type,
    STATE(3265), 1,
      sym__type_declarator,
    STATE(3589), 1,
      sym_pointer_type_declarator,
    STATE(8474), 1,
      sym_ms_based_modifier,
    ACTIONS(8539), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3583), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [222541] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10492), 1,
      anon_sym_LF,
    ACTIONS(10494), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5463), 1,
      anon_sym___attribute,
    ACTIONS(5465), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym___attribute,
    ACTIONS(10656), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10721), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5467), 1,
      anon_sym___attribute,
    ACTIONS(5469), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym___attribute,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym___attribute,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5471), 1,
      anon_sym___attribute,
    ACTIONS(5473), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5459), 1,
      anon_sym___attribute,
    ACTIONS(5461), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5479), 1,
      anon_sym___attribute,
    ACTIONS(5481), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222788] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10723), 1,
      sym_identifier,
    ACTIONS(10725), 1,
      anon_sym_COLON_COLON,
    STATE(155), 1,
      sym_template_type,
    STATE(245), 1,
      sym_field_declaration_list,
    STATE(6148), 1,
      sym_attribute_declaration,
    STATE(6774), 1,
      sym__scope_resolution,
    STATE(7268), 1,
      sym_virtual_specifier,
    STATE(7945), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(141), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5487), 1,
      anon_sym___attribute,
    ACTIONS(5489), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5491), 1,
      anon_sym___attribute,
    ACTIONS(5493), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222897] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10334), 1,
      anon_sym_LF,
    ACTIONS(10336), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222924] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10316), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222953] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10316), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [222980] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10316), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223025] = 11,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10316), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223068] = 10,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10316), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223109] = 9,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10316), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223148] = 8,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10316), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [223185] = 7,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10316), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [223220] = 6,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10316), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223253] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10314), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10316), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [223284] = 12,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10630), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10632), 1,
      anon_sym_PIPE,
    ACTIONS(10634), 1,
      anon_sym_CARET,
    ACTIONS(10636), 1,
      anon_sym_AMP,
    ACTIONS(10727), 1,
      anon_sym_LF,
    ACTIONS(10624), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10642), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10626), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10640), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [223329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5475), 1,
      anon_sym___attribute,
    ACTIONS(5477), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5495), 1,
      anon_sym___attribute,
    ACTIONS(5497), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5483), 1,
      anon_sym___attribute,
    ACTIONS(5485), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 1,
      anon_sym___attribute,
    ACTIONS(5501), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 1,
      anon_sym___attribute,
    ACTIONS(5505), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym___attribute,
    ACTIONS(1949), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223491] = 3,
    ACTIONS(7479), 1,
      anon_sym_LF,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(7477), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [223518] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(2716), 1,
      anon_sym_TILDE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8489), 1,
      anon_sym_STAR,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10729), 1,
      sym_identifier,
    ACTIONS(10731), 1,
      anon_sym_template,
    STATE(3164), 1,
      sym_pointer_type_declarator,
    STATE(3168), 1,
      sym_template_function,
    STATE(3169), 1,
      sym_destructor_name,
    STATE(3171), 1,
      sym_dependent_identifier,
    STATE(3176), 1,
      sym_qualified_identifier,
    STATE(3177), 1,
      sym_operator_name,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(8660), 1,
      sym_ms_based_modifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [223575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(10735), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6107), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10733), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9898), 1,
      anon_sym_requires,
    STATE(5909), 1,
      sym_trailing_return_type,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [223643] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(5869), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [223681] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10739), 1,
      anon_sym_COLON,
    ACTIONS(10741), 1,
      anon_sym_SEMI,
    ACTIONS(10743), 1,
      anon_sym_LBRACE,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    STATE(2085), 1,
      sym_try_statement,
    STATE(2248), 1,
      sym_compound_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7653), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [223735] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10749), 1,
      anon_sym_COLON,
    ACTIONS(10751), 1,
      anon_sym_SEMI,
    ACTIONS(10753), 1,
      anon_sym_LBRACE,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(598), 1,
      sym_compound_statement,
    STATE(599), 1,
      sym_try_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7819), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [223789] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    STATE(6017), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [223827] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    STATE(6035), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [223865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    STATE(6044), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [223903] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    STATE(6047), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [223941] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [223979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [224017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9959), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [224055] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10693), 1,
      anon_sym_requires,
    STATE(6036), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [224093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9116), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [224131] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10757), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6638), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(6103), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7506), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [224179] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(5983), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [224217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(10117), 1,
      anon_sym_requires,
    STATE(5913), 1,
      sym_trailing_return_type,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [224255] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10761), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6594), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7495), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [224303] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10763), 1,
      anon_sym_COLON,
    ACTIONS(10765), 1,
      anon_sym_SEMI,
    ACTIONS(10767), 1,
      anon_sym_LBRACE,
    STATE(1993), 1,
      sym_compound_statement,
    STATE(1994), 1,
      sym_try_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7727), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [224357] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10769), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6690), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7337), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [224405] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9563), 1,
      anon_sym_requires,
    STATE(5979), 1,
      sym_trailing_return_type,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [224443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10773), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10775), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6107), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10771), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10735), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6109), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10733), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10773), 1,
      anon_sym___attribute,
    ACTIONS(10778), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6109), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(10771), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224533] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10781), 1,
      anon_sym_COLON,
    ACTIONS(10783), 1,
      anon_sym_SEMI,
    ACTIONS(10785), 1,
      anon_sym_LBRACE,
    STATE(2161), 1,
      sym_compound_statement,
    STATE(2162), 1,
      sym_try_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7465), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [224587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      anon_sym_LPAREN2,
    ACTIONS(7866), 1,
      anon_sym_LBRACK,
    ACTIONS(8621), 1,
      anon_sym_STAR,
    ACTIONS(8623), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8625), 1,
      anon_sym_AMP,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6169), 1,
      sym__function_declarator_seq,
    STATE(6807), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6167), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [224629] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1941), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10787), 1,
      anon_sym_COLON,
    ACTIONS(10789), 1,
      anon_sym_SEMI,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(813), 1,
      sym_try_statement,
    STATE(836), 1,
      sym_compound_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7565), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [224683] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10793), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6646), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(6105), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7210), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [224731] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10795), 1,
      anon_sym_COLON,
    ACTIONS(10797), 1,
      anon_sym_SEMI,
    ACTIONS(10799), 1,
      anon_sym_LBRACE,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(389), 1,
      sym_compound_statement,
    STATE(390), 1,
      sym_try_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7643), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [224785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10805), 1,
      anon_sym___attribute,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224853] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224887] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10819), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    STATE(5859), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [224959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10823), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [224993] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225027] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10831), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    STATE(3121), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225095] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10837), 1,
      anon_sym_COLON,
    ACTIONS(10839), 1,
      anon_sym_SEMI,
    ACTIONS(10841), 1,
      anon_sym_LBRACE,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(669), 1,
      sym_compound_statement,
    STATE(676), 1,
      sym_try_statement,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7748), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [225149] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7375), 1,
      anon_sym_requires,
    ACTIONS(7485), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(5966), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [225187] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    ACTIONS(10847), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7244), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [225220] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8630), 1,
      anon_sym_STAR,
    ACTIONS(8632), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_AMP,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6900), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225261] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10849), 1,
      anon_sym_AMP,
    ACTIONS(10851), 1,
      sym_this,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(8115), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [225304] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4892), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10322), 1,
      sym_identifier,
    ACTIONS(10324), 1,
      anon_sym_STAR,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10849), 1,
      anon_sym_AMP,
    ACTIONS(10853), 1,
      sym_this,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7680), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [225347] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6911), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [225388] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6314), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225425] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9555), 1,
      anon_sym_requires,
    STATE(6352), 1,
      sym_trailing_return_type,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225462] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      anon_sym_requires,
    STATE(6262), 1,
      sym_trailing_return_type,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225499] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9953), 1,
      anon_sym_requires,
    STATE(6263), 1,
      sym_trailing_return_type,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(3876), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225561] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(10855), 1,
      anon_sym_requires,
    STATE(6264), 1,
      sym_trailing_return_type,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10650), 1,
      anon_sym_LBRACK,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10648), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225627] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(10644), 1,
      sym_identifier,
    ACTIONS(10646), 1,
      anon_sym_COLON_COLON,
    STATE(1014), 1,
      sym_template_type,
    STATE(1093), 1,
      sym_field_declaration_list,
    STATE(6841), 1,
      sym__scope_resolution,
    STATE(7212), 1,
      sym_virtual_specifier,
    STATE(7883), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(988), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225676] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10860), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10865), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(10863), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(6139), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(10858), 7,
      anon_sym_COLON,
      anon_sym___declspec,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [225707] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6317), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225744] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6318), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225781] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7529), 1,
      anon_sym_DASH_GT,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    STATE(6319), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [225818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(3880), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [225843] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(6850), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [225886] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10868), 1,
      sym_identifier,
    ACTIONS(6423), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6155), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10870), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10872), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [225917] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(6171), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [225960] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10680), 1,
      sym_identifier,
    ACTIONS(10682), 1,
      anon_sym_COLON_COLON,
    STATE(191), 1,
      sym_template_type,
    STATE(323), 1,
      sym_field_declaration_list,
    STATE(6768), 1,
      sym__scope_resolution,
    STATE(7214), 1,
      sym_virtual_specifier,
    STATE(8126), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(150), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226009] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10723), 1,
      sym_identifier,
    ACTIONS(10725), 1,
      anon_sym_COLON_COLON,
    STATE(155), 1,
      sym_template_type,
    STATE(259), 1,
      sym_field_declaration_list,
    STATE(6774), 1,
      sym__scope_resolution,
    STATE(7236), 1,
      sym_virtual_specifier,
    STATE(7995), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(142), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226058] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8660), 1,
      sym_identifier,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8664), 1,
      anon_sym_STAR,
    ACTIONS(8666), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8668), 1,
      anon_sym_AMP,
    STATE(6323), 1,
      sym__field_declarator,
    STATE(6524), 1,
      sym_operator_name,
    STATE(8359), 1,
      sym_ms_based_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [226101] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10618), 1,
      sym_identifier,
    ACTIONS(10620), 1,
      anon_sym_COLON_COLON,
    STATE(320), 1,
      sym_template_type,
    STATE(500), 1,
      sym_field_declaration_list,
    STATE(6838), 1,
      sym__scope_resolution,
    STATE(7216), 1,
      sym_virtual_specifier,
    STATE(8188), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(188), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10298), 1,
      anon_sym_LBRACK,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10296), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10302), 1,
      anon_sym_LBRACK,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10300), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226208] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10684), 1,
      anon_sym_COLON_COLON,
    STATE(520), 1,
      sym_field_declaration_list,
    STATE(2039), 1,
      sym_template_type,
    STATE(6790), 1,
      sym__scope_resolution,
    STATE(7178), 1,
      sym_virtual_specifier,
    STATE(8186), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6769), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226257] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym___based,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(8662), 1,
      anon_sym_LPAREN2,
    ACTIONS(8698), 1,
      sym_identifier,
    ACTIONS(8700), 1,
      anon_sym_STAR,
    ACTIONS(8702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8704), 1,
      anon_sym_AMP,
    STATE(6846), 1,
      sym__field_declarator,
    STATE(6982), 1,
      sym_operator_name,
    STATE(9024), 1,
      sym_ms_based_modifier,
    STATE(6583), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [226300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10874), 1,
      sym_identifier,
    ACTIONS(6417), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6157), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10870), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10872), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [226331] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(1961), 1,
      anon_sym_COLON,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10652), 1,
      sym_identifier,
    ACTIONS(10654), 1,
      anon_sym_COLON_COLON,
    STATE(285), 1,
      sym_template_type,
    STATE(520), 1,
      sym_field_declaration_list,
    STATE(6766), 1,
      sym__scope_resolution,
    STATE(7196), 1,
      sym_virtual_specifier,
    STATE(7966), 1,
      sym_base_class_clause,
    ACTIONS(1965), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(189), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10876), 1,
      sym_identifier,
    ACTIONS(6432), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6157), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10879), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10882), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [226411] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6917), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [226452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8766), 1,
      anon_sym_STAR,
    ACTIONS(8768), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8770), 1,
      anon_sym_AMP,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6925), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [226492] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9912), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10885), 1,
      sym_identifier,
    ACTIONS(10887), 1,
      sym_primitive_type,
    STATE(5278), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6824), 1,
      sym__scope_resolution,
    STATE(2345), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9914), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [226532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9882), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226556] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [226588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym___attribute,
    ACTIONS(10889), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [226614] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10885), 1,
      sym_identifier,
    ACTIONS(10887), 1,
      sym_primitive_type,
    STATE(4552), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(2345), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8331), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [226654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10891), 1,
      sym_identifier,
    ACTIONS(10893), 1,
      sym_primitive_type,
    STATE(2330), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(3225), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9687), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [226694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym___attribute,
    ACTIONS(10895), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10895), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226742] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10899), 1,
      sym_identifier,
    ACTIONS(10901), 1,
      sym_primitive_type,
    STATE(4437), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(2559), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2062), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [226782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10905), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10903), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym___attribute,
    ACTIONS(10889), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10907), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [226834] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10022), 1,
      anon_sym_COLON,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(10911), 1,
      anon_sym___attribute,
    ACTIONS(10913), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7207), 1,
      sym_bitfield_clause,
    STATE(7208), 1,
      sym_initializer_list,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10909), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [226880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9038), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10917), 1,
      anon_sym___attribute,
    ACTIONS(10915), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10905), 1,
      anon_sym___attribute,
    ACTIONS(10903), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [226952] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6731), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6733), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [226986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10923), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10921), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10927), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10925), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10931), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10929), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10935), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10933), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227082] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10937), 1,
      sym_identifier,
    ACTIONS(10939), 1,
      sym_primitive_type,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(2345), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [227122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10943), 1,
      anon_sym___attribute,
    ACTIONS(10941), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10947), 1,
      anon_sym___attribute,
    ACTIONS(10945), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10951), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10949), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227194] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(6540), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5666), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227224] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10953), 1,
      sym_identifier,
    ACTIONS(10955), 1,
      sym_primitive_type,
    STATE(2410), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(3506), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9807), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [227264] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10959), 1,
      anon_sym___attribute,
    ACTIONS(10957), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227288] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    STATE(6244), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227324] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    STATE(6162), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227360] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    STATE(6199), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227396] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    STATE(6210), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10963), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10961), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227456] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10965), 1,
      sym_identifier,
    ACTIONS(10967), 1,
      sym_primitive_type,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(5093), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [227496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227532] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227568] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227604] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7792), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10969), 1,
      anon_sym_requires,
    STATE(6225), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [227640] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10972), 1,
      sym_identifier,
    ACTIONS(10974), 1,
      sym_primitive_type,
    STATE(2672), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(3050), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9731), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [227680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10110), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227704] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [227736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9882), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10976), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9962), 1,
      anon_sym_requires,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [227816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10110), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(4433), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9537), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227894] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6707), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6709), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [227928] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10937), 1,
      sym_identifier,
    ACTIONS(10939), 1,
      sym_primitive_type,
    STATE(2598), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(2345), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3856), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [227968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10978), 1,
      anon_sym___attribute,
    ACTIONS(10976), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(10368), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228016] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9857), 1,
      anon_sym_requires,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228080] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    STATE(6339), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    STATE(6341), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228152] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    STATE(6342), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228188] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    STATE(6344), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6267), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6268), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9965), 1,
      anon_sym_requires,
    STATE(6269), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7847), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10980), 1,
      anon_sym_requires,
    STATE(6270), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [228368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9038), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10985), 1,
      anon_sym___attribute,
    ACTIONS(10983), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228448] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10987), 1,
      sym_identifier,
    ACTIONS(10989), 1,
      sym_primitive_type,
    STATE(2351), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(3314), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [228488] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6672), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6674), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [228522] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(10991), 1,
      anon_sym_requires,
    ACTIONS(10696), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [228554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10917), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10915), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10996), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10994), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228602] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11002), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7636), 1,
      sym_semantics,
    ACTIONS(10998), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6816), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [228648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10943), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10941), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11004), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6940), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6942), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [228698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10947), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10945), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10959), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10957), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10368), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228770] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11006), 1,
      sym_identifier,
    ACTIONS(11008), 1,
      sym_primitive_type,
    STATE(4277), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(5143), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8275), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [228810] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10937), 1,
      sym_identifier,
    ACTIONS(10939), 1,
      sym_primitive_type,
    STATE(2272), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(2345), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(59), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [228850] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11010), 1,
      sym_identifier,
    ACTIONS(11012), 1,
      sym_primitive_type,
    STATE(2542), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(4253), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9709), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [228890] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6713), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6715), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [228924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10901), 1,
      sym_primitive_type,
    ACTIONS(11014), 1,
      sym_identifier,
    STATE(2557), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(2559), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9829), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [228964] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10974), 1,
      sym_primitive_type,
    ACTIONS(11016), 1,
      sym_identifier,
    STATE(4430), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(3050), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(4101), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [229004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10996), 1,
      anon_sym___attribute,
    ACTIONS(10994), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229028] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11018), 1,
      sym_identifier,
    ACTIONS(11020), 1,
      sym_primitive_type,
    STATE(5130), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(2559), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [229068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10985), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10983), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9537), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229116] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11022), 1,
      sym_identifier,
    ACTIONS(11024), 1,
      sym_primitive_type,
    STATE(2297), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(2778), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9751), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [229188] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11026), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7636), 1,
      sym_semantics,
    ACTIONS(10998), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6816), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [229234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9602), 1,
      anon_sym_requires,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10923), 1,
      anon_sym___attribute,
    ACTIONS(10921), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10927), 1,
      anon_sym___attribute,
    ACTIONS(10925), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10931), 1,
      anon_sym___attribute,
    ACTIONS(10929), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229338] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6684), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    STATE(6345), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6686), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [229372] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10965), 1,
      sym_identifier,
    ACTIONS(10967), 1,
      sym_primitive_type,
    STATE(4233), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(5093), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8245), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [229412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10935), 1,
      anon_sym___attribute,
    ACTIONS(10933), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229436] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10416), 1,
      anon_sym_TILDE,
    ACTIONS(11028), 1,
      sym_identifier,
    ACTIONS(11030), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11033), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_template,
    STATE(6501), 1,
      sym__scope_resolution,
    STATE(8069), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3801), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [229478] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11037), 1,
      sym_identifier,
    ACTIONS(11039), 1,
      sym_primitive_type,
    STATE(2303), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(2778), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9771), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [229518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11041), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10951), 1,
      anon_sym___attribute,
    ACTIONS(10949), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10963), 1,
      anon_sym___attribute,
    ACTIONS(10961), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11043), 1,
      anon_sym___attribute,
    ACTIONS(11041), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [229614] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10969), 1,
      anon_sym_requires,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [229646] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8565), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [229675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(9953), 1,
      anon_sym_requires,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [229706] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(10855), 1,
      anon_sym_requires,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [229737] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym_LBRACK,
    ACTIONS(11045), 1,
      anon_sym_requires,
    ACTIONS(10452), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [229768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(9627), 1,
      anon_sym_requires,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [229799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    ACTIONS(11048), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 12,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [229824] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(9901), 1,
      anon_sym_requires,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [229855] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(9965), 1,
      anon_sym_requires,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [229886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(10980), 1,
      anon_sym_requires,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [229917] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(11050), 1,
      anon_sym_requires,
    ACTIONS(10696), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [229948] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2005), 1,
      anon_sym_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(2007), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
  [229977] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    STATE(6210), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230010] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    STATE(6199), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230043] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10508), 1,
      anon_sym_TILDE,
    ACTIONS(11053), 1,
      sym_identifier,
    ACTIONS(11055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      anon_sym_template,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(7981), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3832), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [230082] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8806), 1,
      anon_sym_STAR,
    ACTIONS(8808), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8810), 1,
      anon_sym_AMP,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6988), 1,
      sym__abstract_declarator,
    ACTIONS(8477), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [230187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(7041), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7043), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [230214] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10787), 1,
      anon_sym_COLON,
    ACTIONS(10789), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7565), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [230259] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(6044), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [230292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7556), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230321] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    STATE(6244), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym___attribute,
    ACTIONS(11059), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [230379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7426), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230408] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11063), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11065), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11067), 1,
      aux_sym_preproc_elif_token1,
    STATE(6648), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6651), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6939), 1,
      sym_enumerator,
    ACTIONS(11069), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8657), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8686), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [230447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11071), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3364), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6879), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_using,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [230474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7742), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6145), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6606), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(10870), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10872), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(10969), 1,
      anon_sym_requires,
    STATE(6225), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [230563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7555), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230592] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11065), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11067), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11074), 1,
      aux_sym_preproc_if_token2,
    STATE(6700), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6701), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6939), 1,
      sym_enumerator,
    ACTIONS(11069), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8774), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(9177), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [230631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7600), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230660] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(6047), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [230693] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(6017), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [230726] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11076), 1,
      anon_sym_COLON,
    ACTIONS(11078), 1,
      anon_sym_SEMI,
    ACTIONS(11080), 1,
      anon_sym_EQ,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7535), 1,
      aux_sym_declaration_repeat1,
    STATE(7817), 1,
      sym_initializer_list,
    STATE(8106), 1,
      sym_argument_list,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [230773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7665), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11084), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11082), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [230837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7455), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11088), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11086), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [230893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6940), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6942), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [230916] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_requires,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    STATE(6035), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [230949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7549), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [230978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7434), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231007] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10416), 1,
      anon_sym_TILDE,
    ACTIONS(11028), 1,
      sym_identifier,
    ACTIONS(11033), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_template,
    STATE(6501), 1,
      sym__scope_resolution,
    STATE(8069), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3801), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [231046] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9534), 1,
      anon_sym_requires,
    STATE(6021), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [231079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7719), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7745), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(11090), 1,
      sym_identifier,
    ACTIONS(11092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11094), 1,
      anon_sym_template,
    STATE(6457), 1,
      sym__scope_resolution,
    STATE(7914), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2924), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [231176] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9644), 1,
      anon_sym_requires,
    STATE(6029), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [231209] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(11078), 1,
      anon_sym_SEMI,
    ACTIONS(11096), 1,
      anon_sym_COLON,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7535), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [231254] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [231285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7666), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8275), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231343] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [231374] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 1,
      anon_sym_COLON,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(1999), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_else,
      anon_sym_while,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
  [231403] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10462), 1,
      anon_sym_TILDE,
    ACTIONS(11090), 1,
      sym_identifier,
    ACTIONS(11098), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11100), 1,
      anon_sym_template,
    STATE(6451), 1,
      sym__scope_resolution,
    STATE(8083), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2924), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [231442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [231473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [231504] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_requires,
    ACTIONS(10370), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [231535] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11104), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11102), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [231570] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(11076), 1,
      anon_sym_COLON,
    ACTIONS(11078), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7535), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [231615] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8956), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231644] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11106), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [231679] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11112), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [231714] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10837), 1,
      anon_sym_COLON,
    ACTIONS(10839), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7748), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [231759] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11116), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(6504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11114), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [231794] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(9959), 1,
      anon_sym_requires,
    STATE(6034), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [231827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7542), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      anon_sym_DASH_GT,
    ACTIONS(10693), 1,
      anon_sym_requires,
    STATE(6036), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [231889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym_LBRACK,
    ACTIONS(11048), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11118), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 10,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [231916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7670), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7689), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [231974] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(7766), 1,
      anon_sym_requires,
    STATE(6162), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [232007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [232038] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8277), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [232067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8386), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [232096] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8459), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [232125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 1,
      sym_identifier,
    STATE(6288), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8518), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(159), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [232154] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [232185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7224), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [232239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [232270] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10749), 1,
      anon_sym_COLON,
    ACTIONS(10751), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7819), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [232315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_requires,
    ACTIONS(10370), 1,
      anon_sym___attribute,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [232346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6809), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6811), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [232373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [232406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(10795), 1,
      anon_sym_COLON,
    ACTIONS(10797), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7643), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [232451] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(11120), 1,
      anon_sym_COLON,
    ACTIONS(11122), 1,
      anon_sym_SEMI,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(7529), 1,
      aux_sym_declaration_repeat1,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [232496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym___attribute,
    ACTIONS(11059), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11124), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [232523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9555), 1,
      anon_sym_requires,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232554] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11065), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11067), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11126), 1,
      aux_sym_preproc_if_token2,
    STATE(6623), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6624), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6939), 1,
      sym_enumerator,
    ACTIONS(11069), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8753), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8757), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [232593] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      anon_sym_requires,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [232624] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11065), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11067), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11128), 1,
      aux_sym_preproc_if_token2,
    STATE(6645), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6698), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6939), 1,
      sym_enumerator,
    ACTIONS(11069), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8270), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(8276), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [232663] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6707), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6709), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [232695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11132), 1,
      anon_sym_SEMI,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    ACTIONS(11136), 1,
      anon_sym_EQ,
    ACTIONS(11138), 1,
      anon_sym_try,
    STATE(1981), 1,
      sym_compound_statement,
    STATE(7851), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1982), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [232733] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2691), 1,
      sym_enumerator_list,
    STATE(6840), 1,
      sym__scope_resolution,
    ACTIONS(11140), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2925), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232773] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2418), 1,
      sym_enumerator_list,
    STATE(6822), 1,
      sym__scope_resolution,
    ACTIONS(11142), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2495), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6672), 1,
      anon_sym___attribute,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6674), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [232845] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(5023), 1,
      sym_enumerator_list,
    STATE(6835), 1,
      sym__scope_resolution,
    ACTIONS(11144), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4726), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232885] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3237), 1,
      sym_enumerator_list,
    STATE(6823), 1,
      sym__scope_resolution,
    ACTIONS(11146), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3102), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [232925] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232981] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11150), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11148), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [233015] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4204), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    ACTIONS(11152), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3919), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233055] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11154), 1,
      anon_sym_SEMI,
    ACTIONS(11156), 1,
      anon_sym_EQ,
    ACTIONS(11158), 1,
      anon_sym_try,
    STATE(355), 1,
      sym_compound_statement,
    STATE(7930), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(356), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233093] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11160), 1,
      anon_sym_SEMI,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    ACTIONS(11164), 1,
      anon_sym_EQ,
    ACTIONS(11166), 1,
      anon_sym_try,
    STATE(2143), 1,
      sym_compound_statement,
    STATE(7937), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2144), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11170), 1,
      anon_sym_COLON,
    STATE(6475), 1,
      sym_semantics,
    ACTIONS(11173), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11168), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233157] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(5296), 1,
      sym_enumerator_list,
    STATE(6775), 1,
      sym__scope_resolution,
    ACTIONS(11175), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6727), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11177), 1,
      anon_sym_SEMI,
    ACTIONS(11179), 1,
      anon_sym_EQ,
    ACTIONS(11181), 1,
      anon_sym_try,
    STATE(640), 1,
      sym_compound_statement,
    STATE(8134), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(683), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233235] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    ACTIONS(11136), 1,
      anon_sym_EQ,
    ACTIONS(11138), 1,
      anon_sym_try,
    ACTIONS(11183), 1,
      anon_sym_SEMI,
    STATE(2005), 1,
      sym_compound_statement,
    STATE(7877), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2006), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4456), 3,
      anon_sym_COLON,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4451), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233297] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11187), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11185), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [233331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6713), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6715), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [233363] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(5296), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(11189), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5221), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [233431] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11193), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11191), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [233465] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6743), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7495), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [233503] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11197), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11195), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [233537] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    ACTIONS(11164), 1,
      anon_sym_EQ,
    ACTIONS(11166), 1,
      anon_sym_try,
    ACTIONS(11199), 1,
      anon_sym_SEMI,
    STATE(2257), 1,
      sym_compound_statement,
    STATE(7968), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2166), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [233575] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11203), 1,
      anon_sym___attribute,
    STATE(3128), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11201), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [233609] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2418), 1,
      sym_enumerator_list,
    STATE(6773), 1,
      sym__scope_resolution,
    ACTIONS(11205), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2448), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233649] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2691), 1,
      sym_enumerator_list,
    STATE(6840), 1,
      sym__scope_resolution,
    ACTIONS(11207), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2804), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233689] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10805), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10819), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [233777] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10823), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233807] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2418), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(11211), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2676), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10831), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233877] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233907] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3211), 1,
      sym_enumerator_list,
    STATE(6778), 1,
      sym__scope_resolution,
    ACTIONS(11213), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3073), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [233947] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [233977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6625), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [233999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [234029] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [234059] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11215), 1,
      anon_sym_SEMI,
    ACTIONS(11217), 1,
      anon_sym_EQ,
    ACTIONS(11219), 1,
      anon_sym_try,
    STATE(609), 1,
      sym_compound_statement,
    STATE(8141), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(610), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234097] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6759), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7337), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [234135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [234163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      sym_identifier,
    ACTIONS(6465), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [234185] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6731), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6733), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [234217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6267), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234249] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11217), 1,
      anon_sym_EQ,
    ACTIONS(11219), 1,
      anon_sym_try,
    ACTIONS(11221), 1,
      anon_sym_SEMI,
    STATE(625), 1,
      sym_compound_statement,
    STATE(8177), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(626), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234287] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11223), 1,
      anon_sym_SEMI,
    ACTIONS(11225), 1,
      anon_sym_EQ,
    ACTIONS(11227), 1,
      anon_sym_try,
    STATE(2090), 1,
      sym_compound_statement,
    STATE(7915), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2092), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234325] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2418), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(11229), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2866), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [234365] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11179), 1,
      anon_sym_EQ,
    ACTIONS(11181), 1,
      anon_sym_try,
    ACTIONS(11231), 1,
      anon_sym_SEMI,
    STATE(594), 1,
      sym_compound_statement,
    STATE(7829), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(595), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6392), 1,
      sym_identifier,
    ACTIONS(6394), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [234425] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11233), 1,
      anon_sym_SEMI,
    ACTIONS(11235), 1,
      anon_sym_EQ,
    ACTIONS(11237), 1,
      anon_sym_try,
    STATE(838), 1,
      sym_compound_statement,
    STATE(8060), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(840), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9901), 1,
      anon_sym_requires,
    STATE(6268), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234495] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(9965), 1,
      anon_sym_requires,
    STATE(6269), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(6339), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234559] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(10980), 1,
      anon_sym_requires,
    STATE(6270), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(6341), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234623] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(2988), 1,
      sym_enumerator_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(6793), 1,
      sym__scope_resolution,
    ACTIONS(11239), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5181), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [234663] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10737), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10747), 1,
      anon_sym_EQ,
    ACTIONS(11243), 1,
      anon_sym_COLON,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    ACTIONS(11241), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8106), 2,
      sym_argument_list,
      sym_initializer_list,
  [234703] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(5434), 1,
      sym_enumerator_list,
    STATE(6798), 1,
      sym__scope_resolution,
    ACTIONS(11245), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5133), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [234743] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(6342), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234775] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11235), 1,
      anon_sym_EQ,
    ACTIONS(11237), 1,
      anon_sym_try,
    ACTIONS(11247), 1,
      anon_sym_SEMI,
    STATE(743), 1,
      sym_compound_statement,
    STATE(8172), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(750), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [234813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      anon_sym_DASH_GT,
    ACTIONS(7878), 1,
      anon_sym_requires,
    STATE(6344), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [234845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6408), 1,
      sym_identifier,
    ACTIONS(6410), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [234867] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6684), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6686), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [234899] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(2988), 1,
      sym_enumerator_list,
    STATE(3005), 1,
      sym_template_type,
    STATE(6802), 1,
      sym__scope_resolution,
    ACTIONS(11249), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4296), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [234939] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2808), 1,
      sym_enumerator_list,
    STATE(6798), 1,
      sym__scope_resolution,
    ACTIONS(11251), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5120), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [234979] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11156), 1,
      anon_sym_EQ,
    ACTIONS(11158), 1,
      anon_sym_try,
    ACTIONS(11253), 1,
      anon_sym_SEMI,
    STATE(393), 1,
      sym_compound_statement,
    STATE(8097), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(394), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235045] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6741), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7234), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [235083] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3352), 1,
      sym_enumerator_list,
    STATE(6832), 1,
      sym__scope_resolution,
    ACTIONS(11255), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3180), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235123] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11225), 1,
      anon_sym_EQ,
    ACTIONS(11227), 1,
      anon_sym_try,
    ACTIONS(11257), 1,
      anon_sym_SEMI,
    STATE(2114), 1,
      sym_compound_statement,
    STATE(7985), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2117), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3240), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 10,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8477), 1,
      anon_sym_COLON,
    ACTIONS(8874), 1,
      anon_sym_STAR,
    ACTIONS(8876), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8878), 1,
      anon_sym_AMP,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7059), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [235255] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4874), 1,
      sym_enumerator_list,
    STATE(6806), 1,
      sym__scope_resolution,
    ACTIONS(11259), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4648), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235295] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6752), 1,
      sym_access_specifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7735), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10759), 3,
      anon_sym_private,
      anon_sym_public,
      anon_sym_protected,
  [235333] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4874), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    ACTIONS(11261), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(5055), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 1,
      sym_identifier,
    ACTIONS(6461), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [235395] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2808), 1,
      sym_enumerator_list,
    STATE(6767), 1,
      sym__scope_resolution,
    ACTIONS(11263), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4145), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [235435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11271), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7866), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9016), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6505), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235468] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    STATE(6652), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [235582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11275), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11273), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [235603] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11179), 1,
      anon_sym_EQ,
    ACTIONS(11181), 1,
      anon_sym_try,
    STATE(594), 1,
      sym_compound_statement,
    STATE(7829), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(595), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235665] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11277), 1,
      sym_identifier,
    ACTIONS(11279), 1,
      anon_sym_COLON_COLON,
    STATE(6455), 1,
      sym__scope_resolution,
    STATE(7418), 1,
      sym_field_initializer,
    STATE(7861), 1,
      sym_operator_name,
    STATE(7220), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [235702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11283), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11281), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [235750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7073), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [235812] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11285), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7973), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8249), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235845] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11287), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8136), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8736), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235878] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11179), 1,
      anon_sym_EQ,
    ACTIONS(11181), 1,
      anon_sym_try,
    STATE(640), 1,
      sym_compound_statement,
    STATE(8134), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(683), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [235913] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11098), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11100), 1,
      anon_sym_template,
    ACTIONS(11289), 1,
      sym_identifier,
    STATE(2845), 1,
      sym_template_method,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2862), 1,
      sym_qualified_field_identifier,
    STATE(6451), 1,
      sym__scope_resolution,
    STATE(8083), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [235952] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11291), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8205), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(9028), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [235985] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11293), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8056), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8481), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6476), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11297), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11295), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236039] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11279), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11299), 1,
      sym_identifier,
    ACTIONS(11301), 1,
      anon_sym_template,
    STATE(2845), 1,
      sym_template_method,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2862), 1,
      sym_qualified_field_identifier,
    STATE(6455), 1,
      sym__scope_resolution,
    STATE(7861), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236078] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11217), 1,
      anon_sym_EQ,
    ACTIONS(11219), 1,
      anon_sym_try,
    STATE(609), 1,
      sym_compound_statement,
    STATE(8141), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(610), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [236113] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11094), 1,
      anon_sym_template,
    ACTIONS(11289), 1,
      sym_identifier,
    STATE(2845), 1,
      sym_template_method,
    STATE(2849), 1,
      sym_dependent_field_identifier,
    STATE(2862), 1,
      sym_qualified_field_identifier,
    STATE(6457), 1,
      sym__scope_resolution,
    STATE(7914), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11305), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11303), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6750), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6845), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11309), 1,
      anon_sym_LT,
    STATE(6571), 1,
      sym_template_argument_list,
    ACTIONS(11311), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11307), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [236240] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11156), 1,
      anon_sym_EQ,
    ACTIONS(11158), 1,
      anon_sym_try,
    STATE(393), 1,
      sym_compound_statement,
    STATE(8097), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(394), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [236275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236296] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11313), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8040), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8442), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6762), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236392] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11315), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8161), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8807), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6487), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4428), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11277), 1,
      sym_identifier,
    ACTIONS(11279), 1,
      anon_sym_COLON_COLON,
    STATE(6455), 1,
      sym__scope_resolution,
    STATE(7853), 1,
      sym_field_initializer,
    STATE(7861), 1,
      sym_operator_name,
    STATE(7220), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236525] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11317), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8019), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8390), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6449), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6768), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11321), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11319), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236600] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11323), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7891), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8516), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6865), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6867), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11327), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11325), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6869), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6871), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6873), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6875), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11201), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [236748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11185), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [236779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11331), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11329), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [236800] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9854), 1,
      anon_sym_requires,
    STATE(6697), 1,
      sym_trailing_return_type,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [236833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    ACTIONS(1997), 2,
      anon_sym_COLON,
      anon_sym___attribute,
    ACTIONS(1999), 8,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [236860] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11333), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8075), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8535), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6493), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236893] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11335), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8191), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8992), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236926] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11337), 1,
      anon_sym_LBRACE,
    STATE(7816), 1,
      sym_trailing_return_type,
    STATE(8682), 1,
      sym_requires_clause,
    STATE(6880), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6879), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [236963] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11339), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7953), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8960), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6498), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [236996] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5036), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11341), 1,
      sym_identifier,
    STATE(6085), 1,
      sym__scope_resolution,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7879), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237031] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(7492), 1,
      sym_trailing_return_type,
    STATE(8942), 1,
      sym_requires_clause,
    STATE(6869), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6868), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [237068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6847), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6849), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237089] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11345), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8088), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8575), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237122] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11235), 1,
      anon_sym_EQ,
    ACTIONS(11237), 1,
      anon_sym_try,
    STATE(743), 1,
      sym_compound_statement,
    STATE(8172), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(750), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [237157] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11347), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7948), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8920), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6448), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237190] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    STATE(6643), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [237223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6851), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6853), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237244] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11349), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8003), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8344), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237277] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    STATE(6650), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [237310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11235), 1,
      anon_sym_EQ,
    ACTIONS(11237), 1,
      anon_sym_try,
    STATE(838), 1,
      sym_compound_statement,
    STATE(8060), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(840), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [237345] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11033), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11035), 1,
      anon_sym_template,
    ACTIONS(11351), 1,
      sym_identifier,
    STATE(3794), 1,
      sym_template_method,
    STATE(3795), 1,
      sym_dependent_field_identifier,
    STATE(3796), 1,
      sym_qualified_field_identifier,
    STATE(6501), 1,
      sym__scope_resolution,
    STATE(8069), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6809), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6811), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [237409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11353), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8109), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8673), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6506), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11357), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11355), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237467] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11359), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7885), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8404), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237500] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11361), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8113), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8694), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6795), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6797), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11365), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11363), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11369), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11367), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237596] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9943), 1,
      anon_sym_requires,
    STATE(6699), 1,
      sym_trailing_return_type,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [237629] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11055), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11057), 1,
      anon_sym_template,
    ACTIONS(11371), 1,
      sym_identifier,
    STATE(3920), 1,
      sym_template_method,
    STATE(3939), 1,
      sym_dependent_field_identifier,
    STATE(3953), 1,
      sym_qualified_field_identifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(7981), 1,
      sym_operator_name,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237668] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11373), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7944), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8818), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6452), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237701] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(4525), 1,
      anon_sym_STAR,
    ACTIONS(4527), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4529), 1,
      anon_sym_AMP,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(7124), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [237736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(7062), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [237784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6861), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6863), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11377), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11375), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [237826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4523), 1,
      anon_sym_LPAREN2,
    ACTIONS(8307), 1,
      anon_sym_LBRACK,
    ACTIONS(8688), 1,
      anon_sym_STAR,
    ACTIONS(8690), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8692), 1,
      anon_sym_AMP,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6174), 1,
      sym__function_declarator_seq,
    STATE(6870), 1,
      sym__abstract_declarator,
    STATE(6166), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [237861] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11217), 1,
      anon_sym_EQ,
    ACTIONS(11219), 1,
      anon_sym_try,
    STATE(625), 1,
      sym_compound_statement,
    STATE(8177), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(626), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [237896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3254), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 9,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [237923] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11195), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [237954] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11267), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11379), 1,
      anon_sym_RBRACE,
    ACTIONS(11269), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8022), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8398), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6464), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [237987] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    STATE(6704), 1,
      sym_trailing_return_type,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [238020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11309), 1,
      anon_sym_LT,
    STATE(6548), 1,
      sym_template_argument_list,
    ACTIONS(11383), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11381), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238045] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    STATE(6649), 1,
      sym_trailing_return_type,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [238078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8095), 1,
      anon_sym_DASH_GT,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(11385), 1,
      anon_sym_requires,
    STATE(6705), 1,
      sym_trailing_return_type,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [238111] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11191), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11148), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(5666), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [238194] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    ACTIONS(11156), 1,
      anon_sym_EQ,
    ACTIONS(11158), 1,
      anon_sym_try,
    STATE(355), 1,
      sym_compound_statement,
    STATE(7930), 1,
      sym_field_initializer_list,
    ACTIONS(5666), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(356), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [238229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
    STATE(4809), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4223), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
    ACTIONS(8872), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [238257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(5298), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(5222), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238293] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10805), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [238321] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8201), 1,
      anon_sym_LBRACE,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3955), 1,
      sym_template_type,
    STATE(4220), 1,
      sym_enumerator_list,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(3932), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238357] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_enumerator_list,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(4146), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(6244), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(6162), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238453] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(6199), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      anon_sym_requires,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    STATE(6210), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10819), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [238541] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6211), 1,
      sym_trailing_return_type,
    ACTIONS(9531), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238571] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6202), 1,
      sym_trailing_return_type,
    ACTIONS(9641), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238601] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6260), 1,
      sym_trailing_return_type,
    ACTIONS(9956), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8090), 1,
      anon_sym_DASH_GT,
    ACTIONS(10969), 1,
      anon_sym_requires,
    STATE(6225), 1,
      sym_trailing_return_type,
    ACTIONS(10690), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_LBRACK,
  [238661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10823), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [238689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9880), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_enumerator_list,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(2496), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11390), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11388), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6992), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10831), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [238793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9602), 1,
      anon_sym_requires,
    STATE(6734), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [238823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11394), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11392), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238843] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    STATE(7814), 1,
      sym_semantics,
    ACTIONS(10998), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6770), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [238879] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7279), 1,
      anon_sym_LBRACE,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9904), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_template_type,
    STATE(3210), 1,
      sym_enumerator_list,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(3029), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [238915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11398), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11396), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11402), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11400), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11406), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11404), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [238975] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(2679), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10805), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239039] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2681), 1,
      sym_enumerator_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(2931), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10819), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239103] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10823), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239131] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10831), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239159] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9962), 1,
      anon_sym_requires,
    STATE(6746), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [239189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(6145), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10870), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10872), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [239211] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9864), 1,
      sym_identifier,
    STATE(3005), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_enumerator_list,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(5141), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239247] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(5436), 1,
      sym_enumerator_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(5155), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [239311] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [239339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [239367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3448), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [239395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6934), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6936), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [239415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(9857), 1,
      anon_sym_requires,
    STATE(6742), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [239445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11410), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11408), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [239465] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7054), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9866), 1,
      sym_identifier,
    STATE(3005), 1,
      sym_template_type,
    STATE(3006), 1,
      sym_enumerator_list,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(4260), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3445), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [239613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9868), 1,
      sym_identifier,
    STATE(3172), 1,
      sym_template_type,
    STATE(3364), 1,
      sym_enumerator_list,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(3201), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_enumerator_list,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(2445), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239685] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6784), 1,
      anon_sym_LBRACE,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9870), 1,
      sym_identifier,
    STATE(2526), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_enumerator_list,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(5148), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239721] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4884), 1,
      sym_enumerator_list,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(4591), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11383), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11381), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [239777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6457), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [239797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 1,
      anon_sym_DASH_GT,
    ACTIONS(10969), 1,
      anon_sym_requires,
    STATE(6749), 1,
      sym_trailing_return_type,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [239827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9083), 1,
      anon_sym_LBRACE,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(4884), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(5056), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239863] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9860), 1,
      sym_identifier,
    STATE(2039), 1,
      sym_template_type,
    STATE(2405), 1,
      sym_enumerator_list,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(2861), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239899] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(7315), 1,
      anon_sym_LBRACE,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(3105), 1,
      sym_template_type,
    STATE(3243), 1,
      sym_enumerator_list,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(3109), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11414), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(11412), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [239955] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(9872), 1,
      sym_identifier,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(5298), 1,
      sym_enumerator_list,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(6679), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [239991] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(6608), 1,
      anon_sym_LBRACE,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(2614), 1,
      sym_template_type,
    STATE(2681), 1,
      sym_enumerator_list,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(2805), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240027] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    ACTIONS(9876), 1,
      sym_identifier,
    STATE(4636), 1,
      sym_template_type,
    STATE(5026), 1,
      sym_enumerator_list,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(4799), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240063] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    STATE(7814), 1,
      sym_semantics,
    ACTIONS(10998), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6770), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [240099] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11416), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7735), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [240132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2206), 1,
      sym_compound_statement,
    STATE(2207), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11418), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8628), 1,
      sym_qualified_identifier,
    ACTIONS(11420), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1977), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [240217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11422), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8750), 1,
      sym_qualified_identifier,
    ACTIONS(11424), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240248] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11426), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8307), 1,
      sym_qualified_identifier,
    ACTIONS(11428), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240279] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2211), 1,
      sym_compound_statement,
    STATE(2212), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240314] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(837), 1,
      sym_compound_statement,
    STATE(841), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240349] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(314), 1,
      sym_compound_statement,
    STATE(321), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240384] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11430), 1,
      sym_identifier,
    ACTIONS(11433), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11439), 1,
      sym_preproc_directive,
    ACTIONS(11442), 1,
      anon_sym_RBRACE,
    ACTIONS(11436), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(8890), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(6603), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [240413] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11444), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8510), 1,
      sym_qualified_identifier,
    ACTIONS(11446), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [240496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11448), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8679), 1,
      sym_qualified_identifier,
    ACTIONS(11450), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240527] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11452), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8573), 1,
      sym_qualified_identifier,
    ACTIONS(11454), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240558] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11195), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [240587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(727), 1,
      sym_compound_statement,
    STATE(728), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240647] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11456), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8784), 1,
      sym_qualified_identifier,
    ACTIONS(11458), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240678] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(637), 1,
      sym_compound_statement,
    STATE(638), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240713] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(601), 1,
      sym_compound_statement,
    STATE(602), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(721), 1,
      sym_compound_statement,
    STATE(722), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [240808] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11460), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8262), 1,
      sym_qualified_identifier,
    ACTIONS(11462), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(723), 1,
      sym_compound_statement,
    STATE(726), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [240899] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [240926] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(586), 1,
      sym_compound_statement,
    STATE(587), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240961] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11464), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8743), 1,
      sym_qualified_identifier,
    ACTIONS(11466), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [240992] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11468), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8927), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [241023] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11476), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(9029), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [241052] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(360), 1,
      sym_compound_statement,
    STATE(367), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [241112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [241137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11484), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8713), 1,
      sym_qualified_identifier,
    ACTIONS(11486), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241168] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(370), 1,
      sym_compound_statement,
    STATE(374), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241203] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(376), 1,
      sym_compound_statement,
    STATE(377), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [241263] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11488), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8811), 1,
      sym_qualified_identifier,
    ACTIONS(11490), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [241319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(589), 1,
      sym_compound_statement,
    STATE(590), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241354] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(412), 1,
      sym_compound_statement,
    STATE(417), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241389] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(700), 1,
      sym_compound_statement,
    STATE(701), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11492), 1,
      anon_sym_LBRACE,
    STATE(8648), 1,
      sym_trailing_return_type,
    STATE(7049), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6994), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [241455] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11494), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7495), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241488] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2179), 1,
      sym_compound_statement,
    STATE(2180), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241523] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11496), 1,
      anon_sym_COMMA,
    ACTIONS(11500), 1,
      anon_sym___attribute,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(7128), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11498), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10843), 1,
      anon_sym_try,
    STATE(591), 1,
      sym_compound_statement,
    STATE(592), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241591] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11502), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8878), 1,
      sym_qualified_identifier,
    ACTIONS(11504), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [241622] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [241649] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1939), 1,
      sym_compound_statement,
    STATE(1940), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241684] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11506), 1,
      aux_sym_preproc_if_token2,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8702), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [241715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11508), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7337), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [241748] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(633), 1,
      sym_compound_statement,
    STATE(634), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241783] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11510), 1,
      aux_sym_preproc_if_token2,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8821), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [241814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [241841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [241868] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11512), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8828), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [241897] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8116), 1,
      anon_sym_requires,
    ACTIONS(10370), 1,
      anon_sym_LBRACK,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [241924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1953), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1955), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [241943] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1941), 1,
      sym_compound_statement,
    STATE(1942), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [241978] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11514), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8358), 1,
      sym_qualified_identifier,
    ACTIONS(11516), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242009] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(714), 1,
      sym_compound_statement,
    STATE(715), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242044] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11063), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    STATE(6648), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8657), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [242075] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1949), 1,
      sym_compound_statement,
    STATE(1950), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242110] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242135] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11518), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6651), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8686), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [242164] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [242214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [242239] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(659), 1,
      sym_compound_statement,
    STATE(735), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2057), 1,
      sym_compound_statement,
    STATE(2058), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242309] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2204), 1,
      sym_compound_statement,
    STATE(2205), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242344] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(767), 1,
      sym_compound_statement,
    STATE(768), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242379] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2059), 1,
      sym_compound_statement,
    STATE(2060), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242414] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2181), 1,
      sym_compound_statement,
    STATE(2182), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242449] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2191), 1,
      sym_compound_statement,
    STATE(2192), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242484] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1987), 1,
      sym_compound_statement,
    STATE(1996), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1914), 1,
      sym_compound_statement,
    STATE(1916), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242554] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(11522), 1,
      anon_sym_COLON,
    ACTIONS(11524), 1,
      sym_system_lib_string,
    STATE(7390), 1,
      sym_string_literal,
    STATE(7528), 1,
      sym_module_name,
    STATE(7558), 1,
      sym_module_partition,
    ACTIONS(5965), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [242583] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1917), 1,
      sym_compound_statement,
    STATE(1919), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242618] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(341), 1,
      sym_compound_statement,
    STATE(402), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242653] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(778), 1,
      sym_compound_statement,
    STATE(779), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242688] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2063), 1,
      sym_compound_statement,
    STATE(2064), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1981), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [242742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(11526), 1,
      anon_sym_COLON,
    STATE(2356), 1,
      sym_attribute_specifier,
    STATE(5232), 1,
      sym__enum_base_clause,
    STATE(5304), 1,
      sym_enumerator_list,
    ACTIONS(6295), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [242773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242798] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3379), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [242823] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11528), 1,
      aux_sym_preproc_if_token2,
    STATE(6623), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8753), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [242854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11148), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [242883] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_compound_statement,
    STATE(1925), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [242918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [242943] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(5036), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11341), 1,
      sym_identifier,
    STATE(6085), 1,
      sym__scope_resolution,
    STATE(7879), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [242974] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(771), 1,
      sym_compound_statement,
    STATE(772), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1983), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1985), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243028] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11185), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [243057] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11530), 1,
      anon_sym_virtual,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7234), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [243090] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2073), 1,
      sym_compound_statement,
    STATE(2074), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243125] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2078), 1,
      sym_compound_statement,
    STATE(2079), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243160] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(818), 1,
      sym_compound_statement,
    STATE(819), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11191), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [243224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym_LBRACK,
    ACTIONS(9854), 1,
      anon_sym_requires,
    ACTIONS(9113), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6205), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [243251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5779), 1,
      anon_sym_LBRACK,
    ACTIONS(11532), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 8,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243272] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9548), 1,
      anon_sym_LBRACK,
    ACTIONS(9943), 1,
      anon_sym_requires,
    ACTIONS(9560), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6200), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [243299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11534), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8706), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [243328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9893), 1,
      anon_sym_LBRACK,
    ACTIONS(10053), 1,
      anon_sym_requires,
    ACTIONS(9895), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6203), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [243355] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11536), 1,
      aux_sym_preproc_if_token2,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8255), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [243386] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11538), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8261), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [243415] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2080), 1,
      sym_compound_statement,
    STATE(2081), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243450] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11540), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8393), 1,
      sym_qualified_identifier,
    ACTIONS(11542), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [243481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10112), 1,
      anon_sym_LBRACK,
    ACTIONS(11385), 1,
      anon_sym_requires,
    ACTIONS(10114), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6233), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [243508] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10370), 1,
      anon_sym_LBRACK,
    ACTIONS(11544), 1,
      anon_sym_requires,
    ACTIONS(10452), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6086), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6242), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [243535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11201), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [243564] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11128), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    STATE(6645), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8270), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [243595] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(814), 1,
      sym_compound_statement,
    STATE(815), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243630] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2200), 1,
      sym_compound_statement,
    STATE(2201), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11520), 1,
      sym_identifier,
    ACTIONS(11522), 1,
      anon_sym_COLON,
    ACTIONS(11547), 1,
      sym_system_lib_string,
    STATE(7371), 1,
      sym_string_literal,
    STATE(7587), 1,
      sym_module_name,
    STATE(7648), 1,
      sym_module_partition,
    ACTIONS(5965), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [243694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(11478), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11480), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11549), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(11482), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6698), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8276), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [243723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1991), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1993), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5767), 1,
      anon_sym_LBRACK,
    ACTIONS(11532), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11551), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(5769), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243765] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10791), 1,
      anon_sym_try,
    STATE(820), 1,
      sym_compound_statement,
    STATE(821), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1987), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1989), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [243819] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(2087), 1,
      sym_compound_statement,
    STATE(2088), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243854] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10801), 1,
      anon_sym_try,
    STATE(404), 1,
      sym_compound_statement,
    STATE(406), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243889] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(702), 1,
      sym_compound_statement,
    STATE(703), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [243924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [243951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [243978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3253), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [244005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(10755), 1,
      anon_sym_try,
    STATE(704), 1,
      sym_compound_statement,
    STATE(705), 1,
      sym_try_statement,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [244040] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(11470), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11472), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11553), 1,
      aux_sym_preproc_if_token2,
    STATE(6700), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11474), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(9177), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [244071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [244096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_noexcept,
    ACTIONS(7356), 1,
      anon_sym_throw,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9932), 1,
      anon_sym_LBRACE,
    STATE(8440), 1,
      sym_trailing_return_type,
    STATE(6991), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6987), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [244127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(1973), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244146] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(11526), 1,
      anon_sym_COLON,
    STATE(2364), 1,
      sym_attribute_specifier,
    STATE(5231), 1,
      sym__enum_base_clause,
    STATE(5299), 1,
      sym_enumerator_list,
    ACTIONS(6305), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [244177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11088), 1,
      anon_sym_LBRACK,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11086), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    ACTIONS(11173), 1,
      anon_sym_LBRACK,
    STATE(6475), 1,
      sym_semantics,
    ACTIONS(11168), 7,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [244221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11559), 1,
      anon_sym_delete,
    ACTIONS(11561), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11563), 1,
      anon_sym_delete,
    ACTIONS(11565), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11569), 1,
      anon_sym_LBRACK,
    STATE(7248), 1,
      sym_gnu_asm_input_operand,
    STATE(8311), 1,
      sym_string_literal,
    ACTIONS(11567), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [244289] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11573), 1,
      anon_sym___attribute,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11571), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [244317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9857), 1,
      anon_sym_requires,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6161), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9537), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [244341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11577), 1,
      anon_sym_LBRACK,
    STATE(7253), 1,
      sym_gnu_asm_output_operand,
    STATE(8351), 1,
      sym_string_literal,
    ACTIONS(11575), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [244365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11579), 1,
      anon_sym_delete,
    ACTIONS(11581), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11583), 1,
      anon_sym_delete,
    ACTIONS(11585), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11587), 1,
      anon_sym_delete,
    ACTIONS(11589), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11591), 1,
      anon_sym_delete,
    ACTIONS(11593), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11593), 1,
      anon_sym_new,
    ACTIONS(11595), 1,
      anon_sym_delete,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244475] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7348), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9962), 1,
      anon_sym_requires,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6198), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9882), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [244529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7735), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244559] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11597), 1,
      anon_sym_delete,
    ACTIONS(11599), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10969), 1,
      anon_sym_requires,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6209), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10110), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [244629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9602), 1,
      anon_sym_requires,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6243), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9038), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [244653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11601), 1,
      anon_sym_delete,
    ACTIONS(11603), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10991), 1,
      anon_sym_requires,
    ACTIONS(7525), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(6108), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(6222), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(10368), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [244699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11603), 1,
      anon_sym_new,
    ACTIONS(11605), 1,
      anon_sym_delete,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11603), 1,
      anon_sym_new,
    ACTIONS(11607), 1,
      anon_sym_delete,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244743] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7576), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244773] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11609), 1,
      sym_identifier,
    ACTIONS(11611), 1,
      anon_sym_COLON_COLON,
    STATE(3119), 1,
      sym_template_type,
    STATE(6842), 1,
      sym__scope_resolution,
    STATE(3129), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244851] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11589), 1,
      anon_sym_new,
    ACTIONS(11613), 1,
      anon_sym_delete,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244921] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10152), 1,
      sym_identifier,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    STATE(2039), 1,
      sym_template_type,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(7234), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8681), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [244951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11615), 1,
      anon_sym_delete,
    ACTIONS(11617), 1,
      anon_sym_new,
    ACTIONS(11557), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11555), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [244973] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [244997] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [245021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3483), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [245045] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11619), 1,
      anon_sym_EQ,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(8761), 1,
      sym_initializer_list,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245077] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    ACTIONS(11201), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245104] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10654), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11621), 1,
      sym_identifier,
    ACTIONS(11623), 1,
      anon_sym_template,
    STATE(287), 1,
      sym_template_type,
    STATE(288), 1,
      sym_dependent_type_identifier,
    STATE(289), 1,
      sym_qualified_type_identifier,
    STATE(6766), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245135] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9827), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11625), 1,
      sym_identifier,
    ACTIONS(11627), 1,
      anon_sym_template,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(2519), 1,
      sym_template_type,
    STATE(2520), 1,
      sym_dependent_type_identifier,
    STATE(6767), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10682), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11629), 1,
      sym_identifier,
    ACTIONS(11631), 1,
      anon_sym_template,
    STATE(171), 1,
      sym_template_type,
    STATE(179), 1,
      sym_dependent_type_identifier,
    STATE(180), 1,
      sym_qualified_type_identifier,
    STATE(6768), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245197] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(558), 1,
      sym_field_declaration_list,
    STATE(7343), 1,
      sym_virtual_specifier,
    STATE(7893), 1,
      sym_base_class_clause,
    ACTIONS(1969), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
  [245224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    STATE(7790), 1,
      sym_semantics,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11633), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [245249] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    ACTIONS(11148), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245276] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11635), 1,
      sym_identifier,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    STATE(353), 1,
      sym_declaration_list,
    STATE(6973), 1,
      sym_attribute_declaration,
    STATE(7918), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [245307] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(3854), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11641), 1,
      sym_identifier,
    ACTIONS(11643), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(6773), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10725), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11645), 1,
      sym_identifier,
    ACTIONS(11647), 1,
      anon_sym_template,
    STATE(156), 1,
      sym_qualified_type_identifier,
    STATE(165), 1,
      sym_template_type,
    STATE(166), 1,
      sym_dependent_type_identifier,
    STATE(6774), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245369] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9906), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11649), 1,
      sym_identifier,
    ACTIONS(11651), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2482), 1,
      sym_qualified_type_identifier,
    STATE(6775), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245400] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11653), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8466), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11456), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8784), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245454] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9685), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11655), 1,
      sym_identifier,
    ACTIONS(11657), 1,
      anon_sym_template,
    STATE(3092), 1,
      sym_template_type,
    STATE(3094), 1,
      sym_dependent_type_identifier,
    STATE(3108), 1,
      sym_qualified_type_identifier,
    STATE(6778), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    STATE(7632), 1,
      sym_semantics,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11659), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [245510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [245533] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [245558] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11661), 1,
      sym_identifier,
    ACTIONS(11665), 1,
      sym_system_lib_string,
    STATE(8292), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11663), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [245579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [245604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11667), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(9037), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11426), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8307), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245658] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10835), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [245683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [245708] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11669), 1,
      sym_identifier,
    STATE(597), 1,
      sym_declaration_list,
    STATE(6972), 1,
      sym_attribute_declaration,
    STATE(7947), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [245739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    ACTIONS(11195), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10684), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11671), 1,
      sym_identifier,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(6790), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11422), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8750), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245824] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    ACTIONS(11191), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [245851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11673), 1,
      sym_identifier,
    ACTIONS(11675), 1,
      anon_sym_template,
    STATE(3008), 1,
      sym_template_type,
    STATE(3014), 1,
      sym_dependent_type_identifier,
    STATE(3063), 1,
      sym_qualified_type_identifier,
    STATE(6793), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [245882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(3244), 1,
      sym_template_argument_list,
    ACTIONS(6540), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(5666), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [245905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11677), 1,
      sym_identifier,
    ACTIONS(11679), 1,
      sym_system_lib_string,
    STATE(8717), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11663), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [245926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11681), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(9033), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [245953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [245976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8184), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11627), 1,
      anon_sym_template,
    ACTIONS(11683), 1,
      sym_identifier,
    STATE(2515), 1,
      sym_qualified_type_identifier,
    STATE(2519), 1,
      sym_template_type,
    STATE(2520), 1,
      sym_dependent_type_identifier,
    STATE(6798), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11488), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8811), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246034] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [246059] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11685), 1,
      sym_identifier,
    STATE(635), 1,
      sym_declaration_list,
    STATE(6933), 1,
      sym_attribute_declaration,
    STATE(8208), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [246090] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9729), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11675), 1,
      anon_sym_template,
    ACTIONS(11687), 1,
      sym_identifier,
    STATE(3008), 1,
      sym_template_type,
    STATE(3014), 1,
      sym_dependent_type_identifier,
    STATE(3063), 1,
      sym_qualified_type_identifier,
    STATE(6802), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246121] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11689), 1,
      sym_identifier,
    STATE(372), 1,
      sym_declaration_list,
    STATE(6929), 1,
      sym_attribute_declaration,
    STATE(8010), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [246152] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11691), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8838), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11693), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8282), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246206] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8317), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11651), 1,
      anon_sym_template,
    ACTIONS(11695), 1,
      sym_identifier,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2482), 1,
      sym_qualified_type_identifier,
    STATE(6806), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246260] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246283] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246306] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11697), 1,
      sym_identifier,
    ACTIONS(11699), 1,
      sym_system_lib_string,
    STATE(8467), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11663), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [246350] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(525), 1,
      sym_field_declaration_list,
    STATE(7179), 1,
      sym_virtual_specifier,
    STATE(8196), 1,
      sym_base_class_clause,
    ACTIONS(1959), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(6638), 2,
      anon_sym_final,
      anon_sym_override,
  [246377] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10827), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [246402] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11502), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8878), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246429] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10090), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11701), 1,
      sym_identifier,
    ACTIONS(11703), 1,
      anon_sym_template,
    STATE(2265), 1,
      sym_template_type,
    STATE(2266), 1,
      sym_dependent_type_identifier,
    STATE(2271), 1,
      sym_qualified_type_identifier,
    STATE(6815), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246460] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(11000), 1,
      anon_sym_COLON,
    STATE(7706), 1,
      sym_semantics,
    STATE(4476), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11633), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [246485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10807), 1,
      anon_sym_LBRACK,
    STATE(3688), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246531] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10815), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3509), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_GT2,
  [246556] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11705), 1,
      sym_identifier,
    STATE(740), 1,
      sym_declaration_list,
    STATE(6952), 1,
      sym_attribute_declaration,
    STATE(8209), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [246587] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11707), 1,
      sym_identifier,
    STATE(660), 1,
      sym_declaration_list,
    STATE(6976), 1,
      sym_attribute_declaration,
    STATE(7910), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [246618] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(4531), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11709), 1,
      sym_identifier,
    ACTIONS(11711), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(6822), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246649] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11713), 1,
      sym_identifier,
    ACTIONS(11715), 1,
      anon_sym_template,
    STATE(3107), 1,
      sym_template_type,
    STATE(3112), 1,
      sym_dependent_type_identifier,
    STATE(3146), 1,
      sym_qualified_type_identifier,
    STATE(6823), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246680] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9912), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11649), 1,
      sym_identifier,
    ACTIONS(11651), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(6824), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246711] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11452), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8573), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(3244), 1,
      sym_template_argument_list,
    ACTIONS(4433), 2,
      anon_sym_COLON,
      anon_sym_LBRACK,
    ACTIONS(4428), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [246761] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11717), 1,
      sym_identifier,
    STATE(824), 1,
      sym_declaration_list,
    STATE(6931), 1,
      sym_attribute_declaration,
    STATE(8061), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [246792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    ACTIONS(11185), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [246819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11719), 1,
      sym_identifier,
    ACTIONS(11721), 1,
      sym_system_lib_string,
    STATE(8301), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11663), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [246840] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11464), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8743), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246867] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11723), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8996), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [246894] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9805), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11725), 1,
      sym_identifier,
    ACTIONS(11727), 1,
      anon_sym_template,
    STATE(3179), 1,
      sym_template_type,
    STATE(3182), 1,
      sym_dependent_type_identifier,
    STATE(3242), 1,
      sym_qualified_type_identifier,
    STATE(6832), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246925] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10154), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11671), 1,
      sym_identifier,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2284), 1,
      sym_qualified_type_identifier,
    STATE(6833), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246956] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8243), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11641), 1,
      sym_identifier,
    ACTIONS(11643), 1,
      anon_sym_template,
    STATE(2036), 1,
      sym_dependent_type_identifier,
    STATE(2051), 1,
      sym_template_type,
    STATE(2482), 1,
      sym_qualified_type_identifier,
    STATE(6834), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [246987] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(8273), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11729), 1,
      sym_identifier,
    ACTIONS(11731), 1,
      anon_sym_template,
    STATE(4644), 1,
      sym_template_type,
    STATE(4645), 1,
      sym_dependent_type_identifier,
    STATE(4744), 1,
      sym_qualified_type_identifier,
    STATE(6835), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247018] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11733), 1,
      sym_identifier,
    STATE(588), 1,
      sym_declaration_list,
    STATE(6953), 1,
      sym_attribute_declaration,
    STATE(7932), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [247049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 1,
      anon_sym_template,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10670), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11735), 1,
      sym_identifier,
    STATE(6016), 1,
      sym__scope_resolution,
    STATE(8413), 1,
      sym_qualified_identifier,
    STATE(8681), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [247076] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10620), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11737), 1,
      sym_identifier,
    ACTIONS(11739), 1,
      anon_sym_template,
    STATE(265), 1,
      sym_qualified_type_identifier,
    STATE(317), 1,
      sym_template_type,
    STATE(318), 1,
      sym_dependent_type_identifier,
    STATE(6838), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247107] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9707), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11741), 1,
      sym_identifier,
    ACTIONS(11743), 1,
      anon_sym_template,
    STATE(3946), 1,
      sym_template_type,
    STATE(3947), 1,
      sym_dependent_type_identifier,
    STATE(4045), 1,
      sym_qualified_type_identifier,
    STATE(6839), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247138] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(9749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11745), 1,
      sym_identifier,
    ACTIONS(11747), 1,
      anon_sym_template,
    STATE(2619), 1,
      sym_template_type,
    STATE(2620), 1,
      sym_dependent_type_identifier,
    STATE(2638), 1,
      sym_qualified_type_identifier,
    STATE(6840), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247169] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(10646), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11749), 1,
      sym_identifier,
    ACTIONS(11751), 1,
      anon_sym_template,
    STATE(1001), 1,
      sym_qualified_type_identifier,
    STATE(1005), 1,
      sym_template_type,
    STATE(1006), 1,
      sym_dependent_type_identifier,
    STATE(6841), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247200] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3566), 1,
      anon_sym_decltype,
    ACTIONS(11611), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11753), 1,
      sym_identifier,
    ACTIONS(11755), 1,
      anon_sym_template,
    STATE(3126), 1,
      sym_qualified_type_identifier,
    STATE(3145), 1,
      sym_template_type,
    STATE(3148), 1,
      sym_dependent_type_identifier,
    STATE(6842), 1,
      sym__scope_resolution,
    STATE(8681), 1,
      sym_decltype,
  [247231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10811), 1,
      anon_sym___attribute,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3423), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym___attribute__,
  [247256] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11757), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11759), 1,
      anon_sym_SEMI,
    ACTIONS(11761), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7328), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247308] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11106), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247334] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11763), 1,
      sym_identifier,
    ACTIONS(11768), 1,
      aux_sym_preproc_elif_token1,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11766), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [247354] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11770), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [247402] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11772), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [247450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11776), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11778), 1,
      anon_sym_EQ,
    ACTIONS(11774), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [247468] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [247490] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11780), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11784), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11782), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [247532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(6540), 1,
      anon_sym_LBRACK,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(5666), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11577), 1,
      anon_sym_LBRACK,
    STATE(7490), 1,
      sym_gnu_asm_output_operand,
    STATE(8351), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [247574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11786), 1,
      anon_sym_SEMI,
    ACTIONS(11788), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7305), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247600] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11790), 1,
      anon_sym_SEMI,
    ACTIONS(11792), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247626] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [247648] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11114), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247674] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11794), 1,
      anon_sym_SEMI,
    ACTIONS(11796), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7250), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11082), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247726] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11798), 1,
      anon_sym_SEMI,
    ACTIONS(11800), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7330), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247752] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11802), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247778] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11110), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11804), 1,
      anon_sym_LBRACE,
    STATE(7400), 1,
      sym_trailing_return_type,
    STATE(8837), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247830] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11806), 1,
      anon_sym_LBRACE,
    STATE(7413), 1,
      sym_trailing_return_type,
    STATE(8928), 1,
      sym_requires_clause,
    STATE(6873), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247856] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11806), 1,
      anon_sym_LBRACE,
    STATE(7413), 1,
      sym_trailing_return_type,
    STATE(8928), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247882] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(11808), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [247904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym___attribute,
    ACTIONS(11810), 1,
      anon_sym_EQ,
    ACTIONS(10895), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [247922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(4428), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [247944] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11812), 1,
      anon_sym_LBRACE,
    STATE(7518), 1,
      sym_trailing_return_type,
    STATE(8641), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11814), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [247996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11816), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11818), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [248070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11820), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248096] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11822), 1,
      anon_sym_LBRACE,
    STATE(7610), 1,
      sym_trailing_return_type,
    STATE(8740), 1,
      sym_requires_clause,
    STATE(6867), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248122] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11822), 1,
      anon_sym_LBRACE,
    STATE(7610), 1,
      sym_trailing_return_type,
    STATE(8740), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [248170] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11337), 1,
      anon_sym_LBRACE,
    STATE(7816), 1,
      sym_trailing_return_type,
    STATE(8682), 1,
      sym_requires_clause,
    STATE(6880), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11337), 1,
      anon_sym_LBRACE,
    STATE(7816), 1,
      sym_trailing_return_type,
    STATE(8682), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11824), 1,
      sym_identifier,
    ACTIONS(11829), 1,
      aux_sym_preproc_elif_token1,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
    ACTIONS(11827), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [248244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(7492), 1,
      sym_trailing_return_type,
    STATE(8942), 1,
      sym_requires_clause,
    STATE(6869), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11569), 1,
      anon_sym_LBRACK,
    STATE(7652), 1,
      sym_gnu_asm_input_operand,
    STATE(8311), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [248356] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(3244), 1,
      sym_template_argument_list,
    ACTIONS(7043), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [248398] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9928), 1,
      anon_sym_DASH_GT,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(7492), 1,
      sym_trailing_return_type,
    STATE(8942), 1,
      sym_requires_clause,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [248446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    ACTIONS(6715), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6951), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    ACTIONS(6686), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6951), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    ACTIONS(6733), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6951), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248518] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    ACTIONS(6709), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6951), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248542] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10919), 1,
      anon_sym_LBRACK,
    STATE(6492), 1,
      sym_parameter_list,
    ACTIONS(6674), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(6951), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248566] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3683), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [248654] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [248676] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11195), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248702] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11201), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11833), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11831), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [248744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11185), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248770] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11148), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248796] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11191), 1,
      anon_sym_COLON,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6299), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248822] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11835), 1,
      anon_sym_SEMI,
    ACTIONS(11837), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7315), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [248870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(6691), 1,
      anon_sym_COMMA,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11841), 1,
      anon_sym_RBRACK,
    ACTIONS(11844), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7795), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [248898] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11846), 1,
      anon_sym_RPAREN,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248924] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11848), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [248972] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11850), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [248998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [249020] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [249042] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11852), 1,
      anon_sym_SEMI,
    ACTIONS(11854), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    STATE(7188), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10028), 1,
      anon_sym_LBRACK,
    ACTIONS(11102), 1,
      anon_sym_RPAREN,
    STATE(3728), 1,
      sym_parameter_list,
    STATE(6589), 1,
      sym__function_declarator_seq,
    STATE(7003), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    ACTIONS(11856), 1,
      anon_sym_SEMI,
    STATE(3298), 1,
      sym_parameter_list,
    STATE(6729), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10897), 1,
      anon_sym___attribute,
    ACTIONS(11858), 1,
      anon_sym_EQ,
    ACTIONS(10895), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_COLON,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249159] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249222] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11860), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249266] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11862), 1,
      sym_identifier,
    STATE(409), 1,
      sym_declaration_list,
    STATE(8132), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [249291] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11864), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249314] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11705), 1,
      sym_identifier,
    STATE(740), 1,
      sym_declaration_list,
    STATE(8209), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [249339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11866), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249362] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11733), 1,
      sym_identifier,
    STATE(588), 1,
      sym_declaration_list,
    STATE(7932), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [249387] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6715), 1,
      anon_sym_COLON,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6989), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(6371), 1,
      sym_template_argument_list,
    ACTIONS(7043), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [249429] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11868), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11870), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6686), 1,
      anon_sym_COLON,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6989), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249492] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11876), 1,
      anon_sym_COMMA,
    ACTIONS(11878), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11874), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [249509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6733), 1,
      anon_sym_COLON,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6989), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249532] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(2839), 1,
      sym_template_argument_list,
    STATE(7591), 2,
      sym_argument_list,
      sym_initializer_list,
  [249555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11880), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249578] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(6709), 1,
      anon_sym_COLON,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6989), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11882), 1,
      anon_sym_LPAREN2,
    STATE(6945), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11884), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6674), 1,
      anon_sym_COLON,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6989), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249658] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11844), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(6836), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [249681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7481), 1,
      anon_sym___attribute__,
    ACTIONS(7483), 1,
      anon_sym___attribute,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5832), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11886), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11888), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249719] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11891), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6809), 1,
      anon_sym_LBRACK,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6811), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [249761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11893), 1,
      sym_identifier,
    STATE(835), 1,
      sym_declaration_list,
    STATE(8168), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [249786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11895), 1,
      sym_identifier,
    STATE(607), 1,
      sym_declaration_list,
    STATE(8200), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [249811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11897), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11899), 1,
      anon_sym_LPAREN2,
    STATE(6957), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [249872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11901), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249889] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6680), 1,
      anon_sym_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11903), 1,
      anon_sym_RPAREN,
    STATE(2776), 1,
      sym_parameter_list,
    STATE(6502), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [249912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11905), 1,
      anon_sym_LPAREN2,
    STATE(6960), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11909), 1,
      anon_sym_LPAREN2,
    STATE(6962), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11911), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11913), 1,
      anon_sym_LPAREN2,
    STATE(6964), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [249997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11915), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [250014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11917), 1,
      anon_sym_LPAREN2,
    STATE(6967), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [250031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      anon_sym_LBRACK,
    ACTIONS(11922), 1,
      anon_sym_EQ,
    ACTIONS(11924), 1,
      anon_sym_DOT,
    STATE(6966), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [250050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11927), 1,
      anon_sym_LPAREN2,
    STATE(6949), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [250067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10745), 1,
      anon_sym_LBRACK,
    STATE(3231), 1,
      sym_parameter_list,
    STATE(6367), 1,
      sym__function_declarator_seq,
    STATE(6728), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11929), 1,
      anon_sym_LPAREN2,
    STATE(6937), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11872), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [250107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11931), 1,
      anon_sym_LBRACK,
    ACTIONS(11933), 1,
      anon_sym_EQ,
    ACTIONS(11935), 1,
      anon_sym_DOT,
    STATE(6966), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [250126] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11839), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11937), 1,
      anon_sym_EQ,
    STATE(2507), 1,
      sym_template_argument_list,
    ACTIONS(6786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [250149] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11939), 1,
      sym_identifier,
    STATE(691), 1,
      sym_declaration_list,
    STATE(7999), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [250174] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11689), 1,
      sym_identifier,
    STATE(372), 1,
      sym_declaration_list,
    STATE(8010), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [250199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [250220] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    STATE(5816), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(6151), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(11669), 1,
      sym_identifier,
    STATE(597), 1,
      sym_declaration_list,
    STATE(7947), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [250266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3476), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [250287] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11941), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9155), 1,
      sym_attribute_specifier,
  [250309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11943), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11945), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [250323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10803), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11947), 1,
      anon_sym_LBRACE,
    STATE(8907), 1,
      sym_trailing_return_type,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11383), 1,
      anon_sym_LBRACK,
    STATE(6548), 1,
      sym_template_argument_list,
    ACTIONS(11381), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [250381] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10817), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10821), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11949), 1,
      anon_sym_SEMI,
    STATE(7023), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8260), 1,
      sym_attribute_specifier,
  [250443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10809), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250463] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11492), 1,
      anon_sym_LBRACE,
    STATE(8648), 1,
      sym_trailing_return_type,
    STATE(7049), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250483] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10813), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6809), 1,
      anon_sym_LBRACK,
    ACTIONS(7521), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6811), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(6048), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250521] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(10843), 1,
      anon_sym_try,
    ACTIONS(11951), 1,
      anon_sym_SEMI,
    ACTIONS(11953), 1,
      anon_sym_EQ,
    STATE(612), 2,
      sym_compound_statement,
      sym_try_statement,
  [250541] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11492), 1,
      anon_sym_LBRACE,
    STATE(8648), 1,
      sym_trailing_return_type,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11955), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8763), 1,
      sym_attribute_specifier,
  [250583] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11957), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8767), 1,
      sym_attribute_specifier,
  [250605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11959), 1,
      anon_sym_LBRACE,
    STATE(8534), 1,
      sym_trailing_return_type,
    STATE(6981), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250625] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11961), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8538), 1,
      sym_attribute_specifier,
  [250647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    ACTIONS(10843), 1,
      anon_sym_try,
    ACTIONS(11963), 1,
      anon_sym_SEMI,
    ACTIONS(11965), 1,
      anon_sym_EQ,
    STATE(628), 2,
      sym_compound_statement,
      sym_try_statement,
  [250667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10829), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [250687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11967), 1,
      anon_sym_SEMI,
    STATE(7008), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9064), 1,
      sym_attribute_specifier,
  [250709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11969), 1,
      anon_sym_SEMI,
    STATE(6978), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9070), 1,
      sym_attribute_specifier,
  [250731] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11971), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9082), 1,
      sym_attribute_specifier,
  [250753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8777), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [250767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11442), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11973), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [250781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11357), 1,
      anon_sym_LBRACK,
    ACTIONS(11355), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(10755), 1,
      anon_sym_try,
    ACTIONS(11975), 1,
      anon_sym_SEMI,
    ACTIONS(11977), 1,
      anon_sym_EQ,
    STATE(693), 2,
      sym_compound_statement,
      sym_try_statement,
  [250819] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11979), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8280), 1,
      sym_attribute_specifier,
  [250841] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11981), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8489), 1,
      sym_attribute_specifier,
  [250863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11983), 1,
      anon_sym_SEMI,
    STATE(7013), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9114), 1,
      sym_attribute_specifier,
  [250885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11985), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(9152), 1,
      sym_attribute_specifier,
  [250907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(9932), 1,
      anon_sym_LBRACE,
    STATE(8440), 1,
      sym_trailing_return_type,
    STATE(6991), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [250927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11987), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11989), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [250941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(2592), 1,
      sym_template_argument_list,
    ACTIONS(7043), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [250959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11991), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8513), 1,
      sym_attribute_specifier,
  [250981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(11993), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8446), 1,
      sym_attribute_specifier,
  [251003] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10825), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [251023] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10791), 1,
      anon_sym_try,
    ACTIONS(11995), 1,
      anon_sym_SEMI,
    ACTIONS(11997), 1,
      anon_sym_EQ,
    STATE(770), 2,
      sym_compound_statement,
      sym_try_statement,
  [251043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3789), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
    ACTIONS(10833), 2,
      anon_sym_LBRACE,
      anon_sym_requires,
  [251063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11999), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12001), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251077] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    ACTIONS(10755), 1,
      anon_sym_try,
    ACTIONS(12003), 1,
      anon_sym_SEMI,
    ACTIONS(12005), 1,
      anon_sym_EQ,
    STATE(618), 2,
      sym_compound_statement,
      sym_try_statement,
  [251097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    ACTIONS(12007), 1,
      anon_sym_SEMI,
    ACTIONS(12009), 1,
      anon_sym_EQ,
    STATE(1933), 2,
      sym_compound_statement,
      sym_try_statement,
  [251117] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(2592), 1,
      sym_template_argument_list,
    ACTIONS(7043), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [251135] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12011), 1,
      anon_sym_SEMI,
    STATE(7035), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8326), 1,
      sym_attribute_specifier,
  [251157] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12013), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8335), 1,
      sym_attribute_specifier,
  [251179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12015), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8346), 1,
      sym_attribute_specifier,
  [251201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(12017), 1,
      anon_sym_SEMI,
    ACTIONS(12019), 1,
      anon_sym_EQ,
    STATE(2103), 2,
      sym_compound_statement,
      sym_try_statement,
  [251221] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    ACTIONS(12021), 1,
      anon_sym_SEMI,
    ACTIONS(12023), 1,
      anon_sym_EQ,
    STATE(2148), 2,
      sym_compound_statement,
      sym_try_statement,
  [251241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8872), 1,
      sym_string_literal,
    ACTIONS(119), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [251255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11999), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12001), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(10801), 1,
      anon_sym_try,
    ACTIONS(12025), 1,
      anon_sym_SEMI,
    ACTIONS(12027), 1,
      anon_sym_EQ,
    STATE(396), 2,
      sym_compound_statement,
      sym_try_statement,
  [251289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12029), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12031), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12033), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12035), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(11311), 1,
      anon_sym_LBRACK,
    STATE(6571), 1,
      sym_template_argument_list,
    ACTIONS(11307), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [251335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    ACTIONS(10801), 1,
      anon_sym_try,
    ACTIONS(12037), 1,
      anon_sym_SEMI,
    ACTIONS(12039), 1,
      anon_sym_EQ,
    STATE(359), 2,
      sym_compound_statement,
      sym_try_statement,
  [251355] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12041), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8383), 1,
      sym_attribute_specifier,
  [251377] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12043), 1,
      anon_sym_SEMI,
    STATE(6993), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8475), 1,
      sym_attribute_specifier,
  [251399] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12045), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8385), 1,
      sym_attribute_specifier,
  [251421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12047), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12049), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251435] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12051), 1,
      anon_sym_SEMI,
    STATE(7006), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8382), 1,
      sym_attribute_specifier,
  [251457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12053), 1,
      anon_sym_SEMI,
    STATE(6995), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8639), 1,
      sym_attribute_specifier,
  [251479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11827), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [251493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12055), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12057), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12059), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(12061), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12063), 1,
      anon_sym_SEMI,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8680), 1,
      sym_attribute_specifier,
  [251543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11943), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11945), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [251557] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    ACTIONS(10032), 1,
      anon_sym_try,
    ACTIONS(12065), 1,
      anon_sym_SEMI,
    ACTIONS(12067), 1,
      anon_sym_EQ,
    STATE(2119), 2,
      sym_compound_statement,
      sym_try_statement,
  [251577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(8713), 1,
      anon_sym_COMMA,
    ACTIONS(12069), 1,
      anon_sym_SEMI,
    STATE(7022), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8257), 1,
      sym_attribute_specifier,
  [251599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_try,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    ACTIONS(12071), 1,
      anon_sym_SEMI,
    ACTIONS(12073), 1,
      anon_sym_EQ,
    STATE(1986), 2,
      sym_compound_statement,
      sym_try_statement,
  [251619] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10040), 1,
      anon_sym_try,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    ACTIONS(12075), 1,
      anon_sym_SEMI,
    ACTIONS(12077), 1,
      anon_sym_EQ,
    STATE(2168), 2,
      sym_compound_statement,
      sym_try_statement,
  [251639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(10791), 1,
      anon_sym_try,
    ACTIONS(12079), 1,
      anon_sym_SEMI,
    ACTIONS(12081), 1,
      anon_sym_EQ,
    STATE(826), 2,
      sym_compound_statement,
      sym_try_statement,
  [251659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(11959), 1,
      anon_sym_LBRACE,
    STATE(8534), 1,
      sym_trailing_return_type,
    STATE(4389), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [251679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12083), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12085), 1,
      sym_identifier,
    STATE(8491), 1,
      sym__namespace_specifier,
    STATE(8729), 1,
      sym_nested_namespace_specifier,
  [251715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12087), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(12089), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2848), 1,
      sym_template_method,
    STATE(7914), 1,
      sym_operator_name,
  [251751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12091), 1,
      sym_identifier,
    STATE(8491), 1,
      sym__namespace_specifier,
    STATE(8590), 1,
      sym_nested_namespace_specifier,
  [251770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12093), 1,
      anon_sym_SEMI,
    STATE(7111), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12095), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12097), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12099), 1,
      anon_sym_SEMI,
    STATE(7050), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251838] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10813), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [251857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12101), 1,
      anon_sym_SEMI,
    STATE(7104), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12103), 1,
      anon_sym_SEMI,
    STATE(7064), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12105), 1,
      anon_sym_SEMI,
    STATE(7099), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12107), 1,
      anon_sym_SEMI,
    STATE(7088), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12109), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12111), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12113), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [251976] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10833), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [251995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12117), 1,
      anon_sym_DOT,
    STATE(7095), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(12115), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [252010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12119), 1,
      anon_sym_SEMI,
    STATE(7056), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2839), 1,
      sym_template_argument_list,
    ACTIONS(6902), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [252044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(1283), 1,
      sym_template_argument_list,
    ACTIONS(4428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [252061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(2878), 1,
      sym_template_argument_list,
    ACTIONS(7043), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [252078] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    ACTIONS(12121), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9014), 1,
      sym_auto,
    ACTIONS(9016), 1,
      anon_sym_decltype,
    STATE(2365), 1,
      sym_decltype_auto,
    ACTIONS(12123), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [252114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12125), 1,
      anon_sym_SEMI,
    STATE(7125), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252131] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(12127), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2848), 1,
      sym_template_method,
    STATE(7861), 1,
      sym_operator_name,
  [252150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9014), 1,
      sym_auto,
    ACTIONS(9016), 1,
      anon_sym_decltype,
    STATE(2365), 1,
      sym_decltype_auto,
    ACTIONS(12129), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [252167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12131), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12133), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 1,
      anon_sym_LBRACE,
    ACTIONS(12135), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(12137), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
  [252216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12139), 1,
      anon_sym_SEMI,
    STATE(7078), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12141), 1,
      sym_identifier,
    STATE(7585), 1,
      sym__namespace_specifier,
    STATE(7921), 1,
      sym_nested_namespace_specifier,
  [252252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12141), 1,
      sym_identifier,
    STATE(7383), 1,
      sym__namespace_specifier,
    STATE(8181), 1,
      sym_nested_namespace_specifier,
  [252271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12143), 1,
      anon_sym_COMMA,
    ACTIONS(12148), 1,
      anon_sym___attribute,
    STATE(7084), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(12146), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [252288] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10817), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12150), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7041), 1,
      anon_sym_LBRACK,
    STATE(2516), 1,
      sym_template_argument_list,
    ACTIONS(7043), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [252341] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12152), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12154), 1,
      sym_identifier,
    STATE(8491), 1,
      sym__namespace_specifier,
    STATE(8781), 1,
      sym_nested_namespace_specifier,
  [252377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(12158), 1,
      anon_sym_COLON_COLON,
    STATE(7840), 1,
      sym_argument_list,
    ACTIONS(12156), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [252394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10821), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12160), 1,
      anon_sym_SEMI,
    STATE(7103), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10825), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10829), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12164), 1,
      anon_sym_DOT,
    STATE(7095), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(12162), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [252483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12167), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(8127), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [252496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12117), 1,
      anon_sym_DOT,
    STATE(7068), 1,
      aux_sym_module_name_repeat1,
    ACTIONS(12169), 3,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [252511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12171), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12173), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252545] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(12175), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3808), 1,
      sym_template_method,
    STATE(8069), 1,
      sym_operator_name,
  [252564] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(12177), 1,
      aux_sym_preproc_if_token2,
    STATE(6939), 1,
      sym_enumerator,
    STATE(7317), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7323), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [252583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12179), 1,
      anon_sym_SEMI,
    STATE(7052), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12181), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12183), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12185), 1,
      anon_sym_SEMI,
    STATE(7098), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12187), 1,
      anon_sym_SEMI,
    STATE(7066), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11522), 1,
      anon_sym_COLON,
    ACTIONS(12189), 1,
      anon_sym_SEMI,
    STATE(7746), 1,
      sym_module_partition,
    STATE(9036), 1,
      sym_attribute_declaration,
  [252687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12137), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(5781), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_or,
  [252700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9596), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9600), 1,
      anon_sym_EQ,
    ACTIONS(12191), 1,
      sym_identifier,
    ACTIONS(9598), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [252717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12195), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12193), 4,
      anon_sym_virtual,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [252730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12197), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10803), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12199), 1,
      anon_sym_SEMI,
    STATE(7079), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    ACTIONS(12201), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12203), 1,
      anon_sym_COMMA,
    ACTIONS(12208), 1,
      anon_sym___attribute,
    STATE(7115), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(12206), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [252819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    ACTIONS(12210), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12212), 5,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [252849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12214), 1,
      anon_sym_SEMI,
    STATE(7057), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12216), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12218), 1,
      anon_sym_SEMI,
    STATE(7119), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252900] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(12220), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3854), 1,
      sym_template_method,
    STATE(7981), 1,
      sym_operator_name,
  [252919] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(10809), 1,
      anon_sym_COLON,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    STATE(3749), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11639), 1,
      anon_sym_inline,
    ACTIONS(12222), 1,
      sym_identifier,
    STATE(8376), 1,
      sym_nested_namespace_specifier,
    STATE(8491), 1,
      sym__namespace_specifier,
  [252957] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    ACTIONS(11209), 1,
      anon_sym_LBRACK,
    ACTIONS(12224), 1,
      anon_sym_RPAREN,
    STATE(3376), 1,
      sym_parameter_list,
    STATE(6258), 1,
      sym__function_declarator_seq,
  [252976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12226), 1,
      anon_sym_SEMI,
    STATE(4469), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [252993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12228), 1,
      anon_sym_SEMI,
    STATE(7086), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [253010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    ACTIONS(12232), 1,
      anon_sym_COLON_COLON,
    STATE(8104), 1,
      sym_argument_list,
    ACTIONS(12230), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [253027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11496), 1,
      anon_sym_COMMA,
    ACTIONS(12236), 1,
      anon_sym___attribute,
    STATE(7115), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(12234), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [253044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11522), 1,
      anon_sym_COLON,
    ACTIONS(12238), 1,
      anon_sym_SEMI,
    STATE(7614), 1,
      sym_module_partition,
    STATE(8367), 1,
      sym_attribute_declaration,
  [253063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_operator,
    ACTIONS(12089), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2848), 1,
      sym_template_method,
    STATE(8083), 1,
      sym_operator_name,
  [253082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7742), 1,
      anon_sym___attribute__,
    ACTIONS(12240), 1,
      anon_sym_SEMI,
    STATE(7065), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [253099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(982), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [253115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12162), 4,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_DOT,
  [253125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12244), 1,
      anon_sym_using,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [253139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(4170), 1,
      sym_requirement_seq,
    STATE(8138), 1,
      sym_requires_parameter_list,
  [253155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    ACTIONS(12248), 1,
      anon_sym_LBRACE,
    STATE(1880), 1,
      sym_requirement_seq,
    STATE(7935), 1,
      sym_requires_parameter_list,
  [253171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_field_declaration_list,
    STATE(7987), 1,
      sym_base_class_clause,
  [253187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4904), 1,
      sym_field_declaration_list,
    STATE(7977), 1,
      sym_base_class_clause,
  [253203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12252), 1,
      anon_sym_GT2,
    STATE(7514), 1,
      aux_sym_template_argument_list_repeat1,
  [253219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12254), 1,
      anon_sym_GT2,
    STATE(7762), 1,
      aux_sym_template_argument_list_repeat1,
  [253235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(2413), 1,
      sym_field_declaration_list,
    STATE(7887), 1,
      sym_base_class_clause,
  [253251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(566), 1,
      sym_field_declaration_list,
    STATE(8124), 1,
      sym_base_class_clause,
  [253267] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12256), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12260), 1,
      sym_preproc_arg,
    STATE(7873), 1,
      sym_preproc_params,
  [253283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12262), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253299] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12264), 1,
      anon_sym_DQUOTE,
    ACTIONS(12266), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12268), 1,
      sym_escape_sequence,
    STATE(7155), 1,
      aux_sym_string_literal_repeat1,
  [253315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12270), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    STATE(2926), 1,
      sym_argument_list,
    STATE(4095), 1,
      sym_initializer_list,
  [253347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10006), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(3648), 1,
      sym_requirement_seq,
    STATE(7905), 1,
      sym_requires_parameter_list,
  [253363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12272), 1,
      anon_sym_GT2,
    STATE(7470), 1,
      aux_sym_template_argument_list_repeat1,
  [253379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12274), 1,
      anon_sym___except,
    ACTIONS(12276), 1,
      anon_sym___finally,
    STATE(515), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [253393] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12278), 1,
      anon_sym_DQUOTE,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [253409] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12284), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(1093), 1,
      sym_field_declaration_list,
    STATE(7883), 1,
      sym_base_class_clause,
  [253441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12286), 1,
      anon_sym___except,
    ACTIONS(12288), 1,
      anon_sym___finally,
    STATE(258), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [253455] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12290), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [253471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(323), 1,
      sym_field_declaration_list,
    STATE(8126), 1,
      sym_base_class_clause,
  [253487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2680), 1,
      sym_field_declaration_list,
    STATE(8004), 1,
      sym_base_class_clause,
  [253503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3381), 1,
      sym_field_declaration_list,
    STATE(7886), 1,
      sym_base_class_clause,
  [253519] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12292), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [253533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12296), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253549] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12298), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [253565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7709), 1,
      sym_compound_statement,
    STATE(7974), 1,
      sym_field_initializer_list,
  [253581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12300), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3189), 1,
      sym_field_declaration_list,
    STATE(8139), 1,
      sym_base_class_clause,
  [253613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8103), 1,
      sym_argument_list,
    ACTIONS(12302), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [253627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7466), 1,
      sym_compound_statement,
    STATE(7867), 1,
      sym_field_initializer_list,
  [253643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(981), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [253659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12304), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7617), 1,
      sym_compound_statement,
    STATE(7859), 1,
      sym_field_initializer_list,
  [253691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12306), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [253701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12308), 1,
      anon_sym___except,
    ACTIONS(12310), 1,
      anon_sym___finally,
    STATE(1117), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [253715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12312), 1,
      anon_sym_GT2,
    STATE(7436), 1,
      aux_sym_template_argument_list_repeat1,
  [253731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(500), 1,
      sym_field_declaration_list,
    STATE(8188), 1,
      sym_base_class_clause,
  [253747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12314), 1,
      anon_sym_GT2,
    STATE(7429), 1,
      aux_sym_template_argument_list_repeat1,
  [253763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12316), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [253779] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12318), 1,
      anon_sym_DQUOTE,
    ACTIONS(12320), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12322), 1,
      sym_escape_sequence,
    STATE(7186), 1,
      aux_sym_string_literal_repeat1,
  [253795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12324), 1,
      anon_sym_GT2,
    STATE(7647), 1,
      aux_sym_template_argument_list_repeat1,
  [253811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(559), 1,
      sym_field_declaration_list,
    STATE(7897), 1,
      sym_base_class_clause,
  [253827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(560), 1,
      sym_field_declaration_list,
    STATE(7899), 1,
      sym_base_class_clause,
  [253843] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12326), 1,
      anon_sym_DQUOTE,
    ACTIONS(12328), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12330), 1,
      sym_escape_sequence,
    STATE(7311), 1,
      aux_sym_string_literal_repeat1,
  [253859] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12332), 1,
      anon_sym_GT2,
    STATE(7740), 1,
      aux_sym_template_argument_list_repeat1,
  [253875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(2980), 1,
      sym_field_declaration_list,
    STATE(8194), 1,
      sym_base_class_clause,
  [253891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3247), 1,
      sym_field_declaration_list,
    STATE(8027), 1,
      sym_base_class_clause,
  [253907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12336), 1,
      anon_sym_EQ,
    STATE(668), 1,
      sym_declaration_list,
  [253923] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12338), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [253937] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12340), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [253953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10014), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(3921), 1,
      sym_requirement_seq,
    STATE(7849), 1,
      sym_requires_parameter_list,
  [253969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12342), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [253983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12344), 1,
      anon_sym_GT2,
    STATE(7461), 1,
      aux_sym_template_argument_list_repeat1,
  [253999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3223), 1,
      sym_field_declaration_list,
    STATE(8042), 1,
      sym_base_class_clause,
  [254015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12346), 1,
      anon_sym_GT2,
    STATE(7788), 1,
      aux_sym_template_argument_list_repeat1,
  [254031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7784), 1,
      sym_compound_statement,
    STATE(8011), 1,
      sym_field_initializer_list,
  [254047] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12348), 1,
      anon_sym_DQUOTE,
    ACTIONS(12350), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12352), 1,
      sym_escape_sequence,
    STATE(7318), 1,
      aux_sym_string_literal_repeat1,
  [254063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 1,
      sym_identifier,
    ACTIONS(12356), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [254075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(221), 1,
      sym_field_declaration_list,
    STATE(8054), 1,
      sym_base_class_clause,
  [254091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(559), 1,
      sym_field_declaration_list,
    STATE(7986), 1,
      sym_base_class_clause,
  [254107] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(3773), 1,
      sym_requirement_seq,
    STATE(8243), 1,
      sym_requires_parameter_list,
  [254123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12358), 1,
      anon_sym___except,
    ACTIONS(12360), 1,
      anon_sym___finally,
    STATE(499), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [254137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12362), 1,
      anon_sym___except,
    ACTIONS(12364), 1,
      anon_sym___finally,
    STATE(515), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [254151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12366), 1,
      anon_sym_GT2,
    STATE(7379), 1,
      aux_sym_template_argument_list_repeat1,
  [254167] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(520), 1,
      sym_field_declaration_list,
    STATE(7966), 1,
      sym_base_class_clause,
  [254183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(985), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [254199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_LBRACE,
    ACTIONS(6549), 1,
      anon_sym_LPAREN2,
    STATE(2926), 1,
      sym_argument_list,
    STATE(2949), 1,
      sym_initializer_list,
  [254215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7797), 1,
      sym_compound_statement,
    STATE(8041), 1,
      sym_field_initializer_list,
  [254231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12368), 1,
      anon_sym_GT2,
    STATE(7405), 1,
      aux_sym_template_argument_list_repeat1,
  [254247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(980), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [254263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12372), 1,
      anon_sym___attribute,
    ACTIONS(12370), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [254275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12376), 1,
      anon_sym___attribute,
    ACTIONS(12374), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [254287] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12378), 1,
      anon_sym_DQUOTE,
    ACTIONS(12380), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12382), 1,
      sym_escape_sequence,
    STATE(7219), 1,
      aux_sym_string_literal_repeat1,
  [254303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12384), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12388), 1,
      anon_sym_LBRACE,
    STATE(7763), 1,
      aux_sym_base_class_clause_repeat1,
  [254319] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12390), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12392), 1,
      sym_preproc_arg,
    STATE(7969), 1,
      sym_preproc_params,
  [254335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(1066), 1,
      sym_field_declaration_list,
    STATE(7903), 1,
      sym_base_class_clause,
  [254351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(1067), 1,
      sym_field_declaration_list,
    STATE(7904), 1,
      sym_base_class_clause,
  [254367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(330), 1,
      sym_field_declaration_list,
    STATE(8183), 1,
      sym_base_class_clause,
  [254383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(331), 1,
      sym_field_declaration_list,
    STATE(8185), 1,
      sym_base_class_clause,
  [254399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(506), 1,
      sym_field_declaration_list,
    STATE(8215), 1,
      sym_base_class_clause,
  [254415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5075), 1,
      sym_field_declaration_list,
    STATE(8077), 1,
      sym_base_class_clause,
  [254431] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12394), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [254445] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12396), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [254461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(7472), 2,
      sym_argument_list,
      sym_initializer_list,
  [254475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7747), 1,
      sym_compound_statement,
    STATE(8062), 1,
      sym_field_initializer_list,
  [254491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(507), 1,
      sym_field_declaration_list,
    STATE(8216), 1,
      sym_base_class_clause,
  [254507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(978), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [254523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    ACTIONS(12398), 1,
      anon_sym_LBRACE,
    STATE(6055), 1,
      sym_requirement_seq,
    STATE(8067), 1,
      sym_requires_parameter_list,
  [254539] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(2416), 1,
      sym_field_declaration_list,
    STATE(7925), 1,
      sym_base_class_clause,
  [254555] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12400), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12402), 1,
      sym_preproc_arg,
    STATE(8146), 1,
      sym_preproc_params,
  [254571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5024), 1,
      sym_field_declaration_list,
    STATE(8089), 1,
      sym_base_class_clause,
  [254587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12404), 1,
      anon_sym_GT2,
    STATE(7503), 1,
      aux_sym_template_argument_list_repeat1,
  [254603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12406), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [254619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    ACTIONS(11130), 1,
      anon_sym_COLON,
    STATE(7543), 1,
      sym_compound_statement,
    STATE(8080), 1,
      sym_field_initializer_list,
  [254635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(340), 1,
      sym_field_declaration_list,
    STATE(8213), 1,
      sym_base_class_clause,
  [254651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12408), 1,
      anon_sym_EQ,
    STATE(7319), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [254665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3743), 1,
      sym_initializer_list,
    STATE(3793), 1,
      sym_argument_list,
  [254681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12410), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12412), 1,
      anon_sym_LBRACE,
    STATE(7386), 1,
      aux_sym_base_class_clause_repeat1,
  [254697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11854), 1,
      anon_sym_EQ,
    STATE(7188), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [254711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(211), 1,
      sym_field_declaration_list,
    STATE(8044), 1,
      sym_base_class_clause,
  [254727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12414), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [254743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(212), 1,
      sym_field_declaration_list,
    STATE(8047), 1,
      sym_base_class_clause,
  [254759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12416), 1,
      anon_sym_COMMA,
    STATE(7239), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12419), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254773] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3871), 1,
      sym_argument_list,
    STATE(3887), 1,
      sym_initializer_list,
  [254789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    STATE(7239), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12423), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12425), 1,
      anon_sym_COMMA,
    STATE(7294), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12427), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254817] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12429), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12431), 1,
      sym_preproc_arg,
    STATE(8009), 1,
      sym_preproc_params,
  [254833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12433), 1,
      anon_sym_COMMA,
    STATE(7296), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12435), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12437), 1,
      anon_sym_GT2,
    STATE(7547), 1,
      aux_sym_template_argument_list_repeat1,
  [254863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(1050), 1,
      sym_field_declaration_list,
    STATE(7908), 1,
      sym_base_class_clause,
  [254879] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12439), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [254895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12425), 1,
      anon_sym_COMMA,
    STATE(7242), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12441), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12443), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [254925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12445), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [254939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12447), 1,
      anon_sym_using,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [254953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(7933), 1,
      sym_argument_list,
    ACTIONS(12449), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [254967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12421), 1,
      anon_sym_COMMA,
    STATE(7241), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12451), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [254981] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12453), 1,
      anon_sym_DQUOTE,
    ACTIONS(12455), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12457), 1,
      sym_escape_sequence,
    STATE(7261), 1,
      aux_sym_string_literal_repeat1,
  [254997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12306), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [255007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(517), 1,
      sym_field_declaration_list,
    STATE(8219), 1,
      sym_base_class_clause,
  [255023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4428), 1,
      anon_sym_SEMI,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2512), 1,
      sym_template_argument_list,
  [255039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4224), 1,
      sym_field_declaration_list,
    STATE(8111), 1,
      sym_base_class_clause,
  [255055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12459), 1,
      anon_sym_EQ,
    STATE(7321), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(12461), 1,
      aux_sym_preproc_if_token2,
    STATE(7323), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [255083] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12463), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12465), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [255115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4192), 1,
      sym_field_declaration_list,
    STATE(8114), 1,
      sym_base_class_clause,
  [255131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12467), 1,
      anon_sym_GT2,
    STATE(7575), 1,
      aux_sym_template_argument_list_repeat1,
  [255147] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12469), 1,
      anon_sym_DQUOTE,
    ACTIONS(12471), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12473), 1,
      sym_escape_sequence,
    STATE(7270), 1,
      aux_sym_string_literal_repeat1,
  [255163] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12475), 1,
      anon_sym_DQUOTE,
    ACTIONS(12477), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12479), 1,
      sym_escape_sequence,
    STATE(7161), 1,
      aux_sym_string_literal_repeat1,
  [255179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12481), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [255195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(259), 1,
      sym_field_declaration_list,
    STATE(7995), 1,
      sym_base_class_clause,
  [255211] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12483), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255225] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12485), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255241] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12487), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12489), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(12492), 1,
      anon_sym_SEMI,
    ACTIONS(12494), 1,
      anon_sym_noexcept,
    STATE(8665), 1,
      sym_trailing_return_type,
  [255271] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(7096), 1,
      sym_template_parameter_list,
  [255287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12496), 1,
      anon_sym___except,
    ACTIONS(12498), 1,
      anon_sym___finally,
    STATE(322), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [255301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3346), 1,
      sym_field_declaration_list,
    STATE(7869), 1,
      sym_base_class_clause,
  [255317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8886), 1,
      anon_sym___attribute,
    ACTIONS(8884), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [255329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12500), 1,
      anon_sym_GT2,
    STATE(7820), 1,
      aux_sym_template_argument_list_repeat1,
  [255345] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12502), 1,
      anon_sym_DQUOTE,
    ACTIONS(12504), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12507), 1,
      sym_escape_sequence,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(520), 1,
      sym_field_declaration_list,
    STATE(8186), 1,
      sym_base_class_clause,
  [255377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3212), 1,
      sym_field_declaration_list,
    STATE(8034), 1,
      sym_base_class_clause,
  [255393] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12510), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255407] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12512), 1,
      anon_sym_DQUOTE,
    ACTIONS(12514), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12516), 1,
      sym_escape_sequence,
    STATE(7351), 1,
      aux_sym_string_literal_repeat1,
  [255423] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12518), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(983), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [255455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4633), 1,
      anon_sym_LT,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(984), 1,
      sym_template_parameter_list,
    STATE(2042), 1,
      sym_template_type,
  [255471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(560), 1,
      sym_field_declaration_list,
    STATE(7989), 1,
      sym_base_class_clause,
  [255487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5440), 1,
      sym_field_declaration_list,
    STATE(8157), 1,
      sym_base_class_clause,
  [255503] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12520), 1,
      anon_sym_DQUOTE,
    ACTIONS(12522), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12524), 1,
      sym_escape_sequence,
    STATE(7298), 1,
      aux_sym_string_literal_repeat1,
  [255519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5444), 1,
      sym_field_declaration_list,
    STATE(8159), 1,
      sym_base_class_clause,
  [255535] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12526), 1,
      anon_sym_DQUOTE,
    ACTIONS(12528), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12530), 1,
      sym_escape_sequence,
    STATE(7346), 1,
      aux_sym_string_literal_repeat1,
  [255551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_field_declaration_list,
    STATE(8167), 1,
      sym_base_class_clause,
  [255567] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12532), 1,
      anon_sym_DQUOTE,
    ACTIONS(12534), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12536), 1,
      sym_escape_sequence,
    STATE(7364), 1,
      aux_sym_string_literal_repeat1,
  [255583] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12538), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12540), 1,
      sym_preproc_arg,
    STATE(7922), 1,
      sym_preproc_params,
  [255599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12542), 1,
      anon_sym_COMMA,
    STATE(7294), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(12545), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2814), 1,
      sym_field_declaration_list,
    STATE(8220), 1,
      sym_base_class_clause,
  [255629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12433), 1,
      anon_sym_COMMA,
    STATE(7313), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12547), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255643] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12549), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255657] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12551), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12553), 1,
      anon_sym_EQ,
    STATE(828), 1,
      sym_declaration_list,
  [255689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12555), 1,
      anon_sym_GT2,
    STATE(7669), 1,
      aux_sym_template_argument_list_repeat1,
  [255705] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12557), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12559), 1,
      sym_preproc_arg,
    STATE(7941), 1,
      sym_preproc_params,
  [255721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    ACTIONS(7367), 1,
      anon_sym_LPAREN2,
    STATE(3793), 1,
      sym_argument_list,
    STATE(4149), 1,
      sym_initializer_list,
  [255737] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12561), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12563), 1,
      sym_identifier,
    ACTIONS(12565), 1,
      anon_sym_COLON,
    ACTIONS(12567), 1,
      anon_sym_SEMI,
    STATE(7107), 1,
      sym_module_name,
  [255767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12569), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12571), 1,
      anon_sym_using,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11796), 1,
      anon_sym_EQ,
    STATE(7250), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255809] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12573), 1,
      anon_sym_DQUOTE,
    ACTIONS(12575), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12577), 1,
      sym_escape_sequence,
    STATE(7324), 1,
      aux_sym_string_literal_repeat1,
  [255825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    ACTIONS(7437), 1,
      anon_sym_LPAREN2,
    STATE(3871), 1,
      sym_argument_list,
    STATE(5095), 1,
      sym_initializer_list,
  [255841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12579), 1,
      anon_sym_GT2,
    STATE(7794), 1,
      aux_sym_template_argument_list_repeat1,
  [255857] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12581), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255873] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12583), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12585), 1,
      anon_sym_COMMA,
    STATE(7313), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12588), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [255901] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12590), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [255915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12592), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11788), 1,
      anon_sym_EQ,
    STATE(7305), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(12594), 1,
      aux_sym_preproc_if_token2,
    STATE(6884), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
  [255959] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12596), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [255975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12598), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [255989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11837), 1,
      anon_sym_EQ,
    STATE(7315), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12600), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11792), 1,
      anon_sym_EQ,
    STATE(7325), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11061), 1,
      sym_identifier,
    ACTIONS(12602), 1,
      aux_sym_preproc_if_token2,
    STATE(6847), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [256045] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12604), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12606), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11761), 1,
      anon_sym_EQ,
    STATE(7328), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12608), 1,
      anon_sym_GT2,
    STATE(7793), 1,
      aux_sym_template_argument_list_repeat1,
  [256105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12610), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11800), 1,
      anon_sym_EQ,
    STATE(7330), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12612), 1,
      anon_sym_EQ,
    STATE(6286), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [256147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12614), 1,
      anon_sym_GT2,
    STATE(7733), 1,
      aux_sym_template_argument_list_repeat1,
  [256163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(5302), 1,
      sym_field_declaration_list,
    STATE(8198), 1,
      sym_base_class_clause,
  [256179] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12616), 1,
      anon_sym_DQUOTE,
    ACTIONS(12618), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12620), 1,
      sym_escape_sequence,
    STATE(7336), 1,
      aux_sym_string_literal_repeat1,
  [256195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(1283), 1,
      sym_template_argument_list,
    ACTIONS(7043), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [256209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(5307), 1,
      sym_field_declaration_list,
    STATE(8199), 1,
      sym_base_class_clause,
  [256225] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12622), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12624), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12626), 1,
      anon_sym_LBRACE,
    STATE(7481), 1,
      aux_sym_base_class_clause_repeat1,
  [256257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2689), 1,
      sym_field_declaration_list,
    STATE(7965), 1,
      sym_base_class_clause,
  [256273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4887), 1,
      sym_field_declaration_list,
    STATE(7956), 1,
      sym_base_class_clause,
  [256289] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12628), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11265), 1,
      sym_identifier,
    ACTIONS(12177), 1,
      aux_sym_preproc_if_token2,
    STATE(7317), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(8945), 1,
      sym_enumerator,
  [256319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12630), 1,
      anon_sym_GT2,
    STATE(7755), 1,
      aux_sym_template_argument_list_repeat1,
  [256335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    ACTIONS(6470), 1,
      anon_sym_COLON,
    STATE(566), 1,
      sym_field_declaration_list,
    STATE(7946), 1,
      sym_base_class_clause,
  [256351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12632), 1,
      anon_sym_EQ,
    STATE(384), 1,
      sym_declaration_list,
  [256367] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12634), 1,
      anon_sym_DQUOTE,
    ACTIONS(12636), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12638), 1,
      sym_escape_sequence,
    STATE(7349), 1,
      aux_sym_string_literal_repeat1,
  [256383] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12640), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12642), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [256415] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12644), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12646), 1,
      anon_sym_LBRACE,
    STATE(7701), 1,
      aux_sym_base_class_clause_repeat1,
  [256431] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12648), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256447] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12650), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256461] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12652), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256477] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12654), 1,
      anon_sym_DQUOTE,
    ACTIONS(12656), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12658), 1,
      sym_escape_sequence,
    STATE(7283), 1,
      aux_sym_string_literal_repeat1,
  [256493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12660), 1,
      anon_sym_GT2,
    STATE(7779), 1,
      aux_sym_template_argument_list_repeat1,
  [256509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    ACTIONS(12662), 1,
      anon_sym_LBRACE,
    STATE(5867), 1,
      sym_requirement_seq,
    STATE(8015), 1,
      sym_requires_parameter_list,
  [256525] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12664), 1,
      anon_sym_DQUOTE,
    ACTIONS(12666), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12668), 1,
      sym_escape_sequence,
    STATE(7358), 1,
      aux_sym_string_literal_repeat1,
  [256541] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12670), 1,
      anon_sym_DQUOTE,
    ACTIONS(12672), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12674), 1,
      sym_escape_sequence,
    STATE(7151), 1,
      aux_sym_string_literal_repeat1,
  [256557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12676), 1,
      anon_sym_EQ,
    STATE(656), 1,
      sym_declaration_list,
  [256573] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12678), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256589] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12258), 1,
      anon_sym_LPAREN,
    ACTIONS(12680), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12682), 1,
      sym_preproc_arg,
    STATE(7857), 1,
      sym_preproc_params,
  [256605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12684), 1,
      anon_sym_GT2,
    STATE(7804), 1,
      aux_sym_template_argument_list_repeat1,
  [256621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9990), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(2957), 1,
      sym_requirement_seq,
    STATE(7924), 1,
      sym_requires_parameter_list,
  [256637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9998), 1,
      anon_sym_LBRACE,
    ACTIONS(12246), 1,
      anon_sym_LPAREN2,
    STATE(4433), 1,
      sym_requirement_seq,
    STATE(7913), 1,
      sym_requires_parameter_list,
  [256653] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12686), 1,
      anon_sym_DQUOTE,
    ACTIONS(12688), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12690), 1,
      sym_escape_sequence,
    STATE(7247), 1,
      aux_sym_string_literal_repeat1,
  [256669] = 5,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12280), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12282), 1,
      sym_escape_sequence,
    ACTIONS(12692), 1,
      anon_sym_DQUOTE,
    STATE(7278), 1,
      aux_sym_string_literal_repeat1,
  [256685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2003), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(12694), 1,
      anon_sym_SEMI,
    STATE(2507), 1,
      sym_template_argument_list,
  [256701] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12696), 1,
      anon_sym_SQUOTE,
    STATE(7271), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12294), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12698), 1,
      anon_sym_RPAREN,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    STATE(9170), 1,
      sym_gnu_asm_goto_list,
  [256728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7536), 1,
      sym_attribute,
  [256741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12706), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [256754] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7312), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12708), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [256765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12710), 1,
      anon_sym_SEMI,
    STATE(8246), 1,
      sym_attribute_declaration,
  [256778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 1,
      anon_sym___attribute,
    ACTIONS(7184), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [256789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12712), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [256802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_catch,
    STATE(2016), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [256813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12716), 1,
      anon_sym_COMMA,
    ACTIONS(12719), 1,
      anon_sym_RBRACK,
    STATE(7375), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [256826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12721), 1,
      anon_sym_RPAREN,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    STATE(7573), 1,
      sym_gnu_asm_input_operand_list,
  [256839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12725), 1,
      anon_sym_RPAREN,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    STATE(7634), 1,
      sym_gnu_asm_clobber_list,
  [256852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12729), 1,
      anon_sym_GT2,
    STATE(7563), 1,
      aux_sym_template_argument_list_repeat1,
  [256865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12731), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [256878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12733), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [256891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12735), 1,
      anon_sym_default,
    ACTIONS(12737), 1,
      anon_sym_delete,
    ACTIONS(12739), 1,
      aux_sym_pure_virtual_clause_token1,
  [256904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9609), 1,
      anon_sym_DASH_GT,
    ACTIONS(12741), 1,
      anon_sym_SEMI,
    STATE(8634), 1,
      sym_trailing_return_type,
  [256917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12743), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [256928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12747), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [256941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12749), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [256954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12646), 1,
      anon_sym_LBRACE,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [256967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12751), 1,
      anon_sym_RPAREN,
    STATE(7635), 1,
      sym_gnu_asm_input_operand_list,
  [256980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12753), 1,
      anon_sym_GT2,
    STATE(7448), 1,
      aux_sym_template_argument_list_repeat1,
  [256993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12755), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [257006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12757), 1,
      anon_sym_SEMI,
    STATE(8410), 1,
      sym_attribute_declaration,
  [257019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_while,
    ACTIONS(12759), 1,
      anon_sym_else,
    STATE(302), 1,
      sym_else_clause,
  [257032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12761), 1,
      anon_sym_COMMA,
    ACTIONS(12764), 1,
      anon_sym_RPAREN,
    STATE(7392), 1,
      aux_sym_throw_specifier_repeat1,
  [257045] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12766), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12768), 1,
      anon_sym_LPAREN2,
    STATE(9019), 1,
      sym_preproc_argument_list,
  [257058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(408), 1,
      sym_declaration_list,
  [257071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9138), 1,
      anon_sym_COMMA,
    ACTIONS(9140), 1,
      anon_sym_RBRACE,
    STATE(7408), 1,
      aux_sym_initializer_list_repeat1,
  [257084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12770), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(12772), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [257110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(12774), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [257123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7525), 1,
      sym_attribute,
  [257136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(12776), 1,
      anon_sym_LBRACE,
    STATE(8638), 1,
      sym_requires_clause,
  [257149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(12778), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [257162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(12782), 1,
      anon_sym_constexpr,
    STATE(919), 1,
      sym_condition_clause,
  [257175] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7303), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12784), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [257186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(293), 1,
      sym_declaration_list,
  [257199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12786), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4880), 1,
      anon_sym_RBRACE,
    ACTIONS(12788), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [257225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(12790), 1,
      anon_sym_RPAREN,
    STATE(7588), 1,
      sym_gnu_asm_clobber_list,
  [257238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4872), 1,
      anon_sym_RBRACE,
    ACTIONS(12792), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [257251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      anon_sym___attribute,
    ACTIONS(7074), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [257262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(12794), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [257275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7758), 1,
      sym_attribute,
  [257288] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7281), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12796), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [257299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11812), 1,
      anon_sym_LBRACE,
    STATE(8641), 1,
      sym_requires_clause,
  [257312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(12798), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [257325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12800), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3862), 1,
      sym_template_function,
  [257338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12802), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [257347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9246), 1,
      anon_sym_RBRACK,
    ACTIONS(12804), 1,
      anon_sym_COMMA,
    STATE(7417), 1,
      aux_sym_subscript_argument_list_repeat1,
  [257360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12807), 1,
      anon_sym_COMMA,
    ACTIONS(12809), 1,
      anon_sym_LBRACE,
    STATE(7427), 1,
      aux_sym_field_initializer_list_repeat1,
  [257373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(12811), 1,
      anon_sym_RPAREN,
    STATE(7449), 1,
      sym_gnu_asm_clobber_list,
  [257386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12813), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      sym_gnu_asm_input_operand_list,
  [257399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12815), 1,
      anon_sym_RPAREN,
    STATE(7456), 1,
      sym_gnu_asm_input_operand_list,
  [257412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12817), 1,
      anon_sym_RPAREN,
    STATE(7478), 1,
      sym_gnu_asm_input_operand_list,
  [257425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12819), 1,
      anon_sym_default,
    ACTIONS(12821), 1,
      anon_sym_delete,
    ACTIONS(12823), 1,
      aux_sym_pure_virtual_clause_token1,
  [257438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12825), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [257451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11337), 1,
      anon_sym_LBRACE,
    STATE(8682), 1,
      sym_requires_clause,
  [257464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12827), 1,
      anon_sym_RPAREN,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    STATE(7479), 1,
      sym_gnu_asm_output_operand_list,
  [257477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12807), 1,
      anon_sym_COMMA,
    ACTIONS(12831), 1,
      anon_sym_LBRACE,
    STATE(7551), 1,
      aux_sym_field_initializer_list_repeat1,
  [257490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12833), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12835), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12837), 1,
      anon_sym_GT2,
    STATE(7765), 1,
      aux_sym_template_argument_list_repeat1,
  [257529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12839), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12841), 1,
      anon_sym_SEMI,
    STATE(7686), 1,
      aux_sym_declaration_repeat1,
  [257555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12802), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [257564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(12843), 1,
      anon_sym_RPAREN,
    STATE(7524), 1,
      sym_gnu_asm_output_operand_list,
  [257577] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12845), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12847), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11659), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [257612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12849), 1,
      anon_sym_SEMI,
    STATE(7467), 1,
      aux_sym_declaration_repeat1,
  [257625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4870), 1,
      anon_sym_RBRACE,
    ACTIONS(12851), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [257638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12853), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3533), 1,
      sym_template_function,
  [257651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12855), 1,
      anon_sym_SEMI,
    STATE(7750), 1,
      aux_sym_declaration_repeat1,
  [257664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12857), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(12861), 1,
      anon_sym_RPAREN,
    STATE(7766), 1,
      aux_sym_parameter_list_repeat1,
  [257690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12863), 1,
      anon_sym_catch,
    STATE(192), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [257701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(12865), 1,
      anon_sym_RBRACK,
    STATE(7417), 1,
      aux_sym_subscript_argument_list_repeat1,
  [257714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12867), 1,
      anon_sym_catch,
    STATE(439), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [257725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12869), 1,
      anon_sym_COMMA,
    ACTIONS(12871), 1,
      anon_sym_GT2,
    STATE(7760), 1,
      aux_sym_template_parameter_list_repeat1,
  [257738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12873), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(12875), 1,
      anon_sym_RPAREN,
    STATE(8300), 1,
      sym_gnu_asm_goto_list,
  [257764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12877), 1,
      anon_sym_RPAREN,
    STATE(7593), 1,
      sym_gnu_asm_input_operand_list,
  [257777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12879), 1,
      anon_sym_RPAREN,
    STATE(7559), 1,
      sym_gnu_asm_input_operand_list,
  [257790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7708), 1,
      sym_attribute,
  [257803] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7340), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12881), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [257814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9004), 1,
      anon_sym_COMMA,
    ACTIONS(9006), 1,
      anon_sym_RBRACE,
    STATE(7406), 1,
      aux_sym_initializer_list_repeat1,
  [257827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(12883), 1,
      anon_sym_RPAREN,
    STATE(7561), 1,
      sym_gnu_asm_output_operand_list,
  [257840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(12885), 1,
      anon_sym_RPAREN,
    STATE(7463), 1,
      sym_gnu_asm_clobber_list,
  [257853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(9099), 1,
      anon_sym_RBRACK,
    STATE(7557), 1,
      aux_sym_subscript_argument_list_repeat1,
  [257866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12887), 1,
      anon_sym_GT2,
    STATE(7507), 1,
      aux_sym_template_argument_list_repeat1,
  [257879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12889), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(12891), 1,
      anon_sym_RPAREN,
    STATE(7691), 1,
      aux_sym_preproc_argument_list_repeat1,
  [257905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12893), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12895), 1,
      anon_sym_default,
    ACTIONS(12897), 1,
      anon_sym_delete,
    ACTIONS(12899), 1,
      aux_sym_pure_virtual_clause_token1,
  [257931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(12901), 1,
      anon_sym_RPAREN,
    STATE(8302), 1,
      sym_gnu_asm_goto_list,
  [257944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12903), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [257957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12905), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [257970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12907), 1,
      anon_sym_catch,
    STATE(447), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [257981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12909), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [257994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 1,
      anon_sym___attribute,
    ACTIONS(7078), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [258005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
    STATE(8942), 1,
      sym_requires_clause,
  [258018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12911), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12913), 1,
      sym_identifier,
    STATE(2530), 1,
      sym_template_type,
    STATE(3533), 1,
      sym_template_function,
  [258044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12915), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12917), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [258055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(12919), 1,
      anon_sym_constexpr,
    STATE(886), 1,
      sym_condition_clause,
  [258068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12921), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(12923), 1,
      anon_sym_RBRACK,
    STATE(7417), 1,
      aux_sym_subscript_argument_list_repeat1,
  [258094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(12925), 1,
      anon_sym_constexpr,
    STATE(908), 1,
      sym_condition_clause,
  [258107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12927), 1,
      anon_sym_catch,
    STATE(1872), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [258118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(12929), 1,
      anon_sym_RPAREN,
    STATE(7367), 1,
      sym_gnu_asm_clobber_list,
  [258131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(12931), 1,
      anon_sym_RPAREN,
    STATE(7521), 1,
      sym_gnu_asm_input_operand_list,
  [258144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12412), 1,
      anon_sym_LBRACE,
    STATE(7386), 1,
      aux_sym_base_class_clause_repeat1,
  [258157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12412), 1,
      anon_sym_LBRACE,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [258170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12933), 1,
      anon_sym_EQ,
    ACTIONS(11774), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [258181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12935), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 1,
      anon_sym_while,
    ACTIONS(12759), 1,
      anon_sym_else,
    STATE(278), 1,
      sym_else_clause,
  [258207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7629), 1,
      sym_attribute,
  [258220] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7185), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12937), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [258231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12939), 1,
      anon_sym_default,
    ACTIONS(12941), 1,
      anon_sym_delete,
    ACTIONS(12943), 1,
      aux_sym_pure_virtual_clause_token1,
  [258244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12945), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12947), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [258266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12949), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [258275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12951), 1,
      anon_sym_default,
    ACTIONS(12953), 1,
      anon_sym_delete,
    ACTIONS(12955), 1,
      aux_sym_pure_virtual_clause_token1,
  [258288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11806), 1,
      anon_sym_LBRACE,
    STATE(8928), 1,
      sym_requires_clause,
  [258301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12646), 1,
      anon_sym_LBRACE,
    STATE(7701), 1,
      aux_sym_base_class_clause_repeat1,
  [258314] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7218), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12957), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [258325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12959), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12961), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [258336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(12965), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [258349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12969), 1,
      anon_sym_RPAREN,
    ACTIONS(12967), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [258360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(12971), 1,
      anon_sym_constexpr,
    STATE(921), 1,
      sym_condition_clause,
  [258373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12973), 1,
      anon_sym_GT2,
    STATE(7571), 1,
      aux_sym_template_argument_list_repeat1,
  [258386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12975), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258399] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7366), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12977), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [258410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12979), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [258419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12981), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258432] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7269), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12983), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [258443] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7297), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12985), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [258454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12987), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12989), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [258465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(12991), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(12993), 1,
      anon_sym_RPAREN,
    STATE(8816), 1,
      sym_gnu_asm_goto_list,
  [258491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(12995), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12997), 1,
      anon_sym_catch,
    STATE(420), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [258515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(661), 1,
      sym_declaration_list,
  [258528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12999), 1,
      sym_identifier,
    ACTIONS(13001), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [258539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12989), 1,
      anon_sym_LBRACE,
    ACTIONS(13003), 1,
      anon_sym_COMMA,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [258552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13006), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13008), 1,
      anon_sym_GT2,
    STATE(7553), 1,
      aux_sym_template_argument_list_repeat1,
  [258578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13010), 1,
      anon_sym_COMMA,
    ACTIONS(13012), 1,
      anon_sym_RPAREN,
    STATE(7392), 1,
      aux_sym_throw_specifier_repeat1,
  [258591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13014), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(13016), 1,
      anon_sym_LBRACE,
    STATE(8819), 1,
      sym_requires_clause,
  [258617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13018), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      anon_sym_default,
    ACTIONS(13022), 1,
      anon_sym_delete,
    ACTIONS(13024), 1,
      aux_sym_pure_virtual_clause_token1,
  [258643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13026), 1,
      anon_sym_RPAREN,
    STATE(7533), 1,
      sym_gnu_asm_clobber_list,
  [258656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9057), 1,
      anon_sym_RPAREN,
    STATE(7410), 1,
      aux_sym_argument_list_repeat1,
  [258669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13028), 1,
      anon_sym_RPAREN,
    STATE(7544), 1,
      sym_gnu_asm_clobber_list,
  [258682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13030), 1,
      anon_sym_RPAREN,
    STATE(7545), 1,
      sym_gnu_asm_input_operand_list,
  [258695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13032), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7633), 1,
      aux_sym_attribute_declaration_repeat1,
  [258708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13034), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_COMMA,
    ACTIONS(13038), 1,
      anon_sym_RBRACK,
    STATE(7621), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [258734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13040), 1,
      anon_sym_SEMI,
    STATE(8539), 1,
      sym_attribute_declaration,
  [258747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13042), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258760] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_LPAREN2,
    ACTIONS(13044), 1,
      aux_sym_preproc_include_token2,
    STATE(9019), 1,
      sym_preproc_argument_list,
  [258773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4878), 1,
      anon_sym_RBRACE,
    ACTIONS(13046), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [258786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13048), 1,
      anon_sym_RPAREN,
    STATE(8607), 1,
      sym_gnu_asm_goto_list,
  [258799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13050), 1,
      anon_sym_RPAREN,
    STATE(8480), 1,
      sym_gnu_asm_goto_list,
  [258812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13052), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [258825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13054), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13056), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7496), 1,
      aux_sym_attribute_declaration_repeat1,
  [258851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13058), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12907), 1,
      anon_sym_catch,
    STATE(185), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [258875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13060), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [258884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13062), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [258893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13064), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [258906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13066), 1,
      anon_sym_RPAREN,
    STATE(7656), 1,
      sym_gnu_asm_output_operand_list,
  [258919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_catch,
    STATE(2019), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [258930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(8541), 1,
      sym_gnu_asm_goto_list,
  [258943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13072), 1,
      anon_sym_RPAREN,
    STATE(7546), 1,
      sym_gnu_asm_clobber_list,
  [258956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(8551), 1,
      sym_gnu_asm_goto_list,
  [258969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13076), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [258982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13078), 1,
      anon_sym_COMMA,
    ACTIONS(13080), 1,
      anon_sym_RPAREN,
    STATE(7800), 1,
      aux_sym_requires_parameter_list_repeat1,
  [258995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13082), 1,
      anon_sym_RPAREN,
    STATE(7420), 1,
      sym_gnu_asm_output_operand_list,
  [259008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [259021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13086), 1,
      anon_sym_COMMA,
    ACTIONS(13089), 1,
      anon_sym_LBRACE,
    STATE(7551), 1,
      aux_sym_field_initializer_list_repeat1,
  [259034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12250), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13091), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [259045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13093), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12907), 1,
      anon_sym_catch,
    STATE(446), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [259069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13095), 1,
      anon_sym_RPAREN,
    STATE(7584), 1,
      sym_gnu_asm_output_operand_list,
  [259082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13097), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      sym_gnu_asm_output_operand_list,
  [259095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(13099), 1,
      anon_sym_RBRACK,
    STATE(7417), 1,
      aux_sym_subscript_argument_list_repeat1,
  [259108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13101), 1,
      anon_sym_SEMI,
    STATE(8669), 1,
      sym_attribute_declaration,
  [259121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13103), 1,
      anon_sym_RPAREN,
    STATE(7580), 1,
      sym_gnu_asm_clobber_list,
  [259134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13105), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [259147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13107), 1,
      anon_sym_RPAREN,
    STATE(7581), 1,
      sym_gnu_asm_input_operand_list,
  [259160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13109), 1,
      anon_sym_constexpr,
    STATE(938), 1,
      sym_condition_clause,
  [259173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13111), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13113), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [259199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13115), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [259212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13117), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [259225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13119), 1,
      anon_sym_constexpr,
    STATE(888), 1,
      sym_condition_clause,
  [259238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(8994), 1,
      anon_sym_RBRACK,
    STATE(7475), 1,
      aux_sym_subscript_argument_list_repeat1,
  [259251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13121), 1,
      anon_sym_GT2,
    STATE(7577), 1,
      aux_sym_template_argument_list_repeat1,
  [259264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7994), 1,
      sym_attribute,
  [259277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13123), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9157), 1,
      anon_sym_COMMA,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
    STATE(7531), 1,
      aux_sym_initializer_list_repeat1,
  [259303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13125), 1,
      anon_sym_RPAREN,
    STATE(7508), 1,
      sym_gnu_asm_clobber_list,
  [259316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13127), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13129), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13131), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13133), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [259353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13135), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13137), 1,
      anon_sym_COMMA,
    ACTIONS(13140), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [259379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(13142), 1,
      anon_sym_LBRACE,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [259392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13144), 1,
      anon_sym_RPAREN,
    STATE(9069), 1,
      sym_gnu_asm_goto_list,
  [259405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13146), 1,
      anon_sym_RPAREN,
    STATE(7583), 1,
      sym_gnu_asm_clobber_list,
  [259418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13148), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [259431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13150), 1,
      anon_sym_RPAREN,
    STATE(9073), 1,
      sym_gnu_asm_goto_list,
  [259444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13152), 1,
      anon_sym_RPAREN,
    STATE(7407), 1,
      sym_gnu_asm_input_operand_list,
  [259457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12745), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13154), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [259468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13156), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [259481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13158), 1,
      anon_sym_SEMI,
    STATE(8295), 1,
      sym_attribute_declaration,
  [259494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13160), 1,
      anon_sym_RPAREN,
    STATE(8487), 1,
      sym_gnu_asm_goto_list,
  [259507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13162), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [259520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9328), 1,
      anon_sym_RPAREN,
    ACTIONS(13164), 1,
      anon_sym_COMMA,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [259533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13167), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13169), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [259544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13171), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [259557] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13173), 1,
      anon_sym_RPAREN,
    STATE(7655), 1,
      sym_gnu_asm_clobber_list,
  [259570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 1,
      anon_sym_COMMA,
    ACTIONS(13175), 1,
      anon_sym_RBRACK,
    STATE(7795), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [259583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13177), 1,
      anon_sym_GT2,
    STATE(7431), 1,
      aux_sym_template_argument_list_repeat1,
  [259596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9075), 1,
      anon_sym_RPAREN,
    STATE(7397), 1,
      aux_sym_argument_list_repeat1,
  [259609] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13179), 1,
      anon_sym_GT2,
    STATE(7442), 1,
      aux_sym_template_argument_list_repeat1,
  [259622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12867), 1,
      anon_sym_catch,
    STATE(315), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [259633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13181), 1,
      anon_sym_COMMA,
    ACTIONS(13184), 1,
      anon_sym_RPAREN,
    STATE(7599), 1,
      aux_sym_requires_parameter_list_repeat1,
  [259646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13186), 1,
      anon_sym_RPAREN,
    STATE(7450), 1,
      sym_gnu_asm_output_operand_list,
  [259659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13188), 1,
      anon_sym_GT2,
    STATE(7619), 1,
      aux_sym_template_argument_list_repeat1,
  [259672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(8966), 1,
      anon_sym_RPAREN,
    STATE(7645), 1,
      aux_sym_argument_list_repeat1,
  [259685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      sym_identifier,
    STATE(2530), 1,
      sym_template_type,
    STATE(3783), 1,
      sym_template_function,
  [259698] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(13192), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [259711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13194), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3783), 1,
      sym_template_function,
  [259724] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_COMMA,
    ACTIONS(13196), 1,
      anon_sym_RBRACK,
    STATE(7375), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [259737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7660), 1,
      sym_attribute,
  [259750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(13198), 1,
      anon_sym_RPAREN,
    STATE(7691), 1,
      aux_sym_preproc_argument_list_repeat1,
  [259763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6279), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [259772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11804), 1,
      anon_sym_LBRACE,
    STATE(8837), 1,
      sym_requires_clause,
  [259785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9121), 1,
      anon_sym_RPAREN,
    STATE(7604), 1,
      aux_sym_argument_list_repeat1,
  [259798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13200), 1,
      anon_sym_GT2,
    STATE(7622), 1,
      aux_sym_template_argument_list_repeat1,
  [259811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10244), 1,
      anon_sym_COMMA,
    ACTIONS(13202), 1,
      anon_sym_RPAREN,
    STATE(7691), 1,
      aux_sym_preproc_argument_list_repeat1,
  [259824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13204), 1,
      anon_sym_SEMI,
    STATE(8549), 1,
      sym_attribute_declaration,
  [259837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13206), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9061), 1,
      anon_sym_COMMA,
    ACTIONS(9063), 1,
      anon_sym_RBRACE,
    STATE(7439), 1,
      aux_sym_initializer_list_repeat1,
  [259863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12867), 1,
      anon_sym_catch,
    STATE(432), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [259874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13208), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13210), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(604), 1,
      sym_declaration_list,
  [259913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_COMMA,
    ACTIONS(13212), 1,
      anon_sym_RBRACK,
    STATE(7375), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [259926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13214), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [259939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(679), 1,
      sym_declaration_list,
  [259952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9085), 1,
      anon_sym_COMMA,
    ACTIONS(9087), 1,
      anon_sym_RBRACE,
    STATE(7646), 1,
      aux_sym_initializer_list_repeat1,
  [259965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7639), 1,
      sym_attribute,
  [259978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13216), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [259991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13218), 1,
      anon_sym_RPAREN,
    STATE(7703), 1,
      aux_sym_parameter_list_repeat1,
  [260004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13220), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [260013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13222), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7690), 1,
      aux_sym_attribute_declaration_repeat1,
  [260026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [260039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6309), 1,
      anon_sym_EQ,
    ACTIONS(6307), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [260050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [260059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13228), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [260072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13230), 1,
      anon_sym_RPAREN,
    STATE(8362), 1,
      sym_gnu_asm_goto_list,
  [260085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13232), 1,
      anon_sym_RPAREN,
    STATE(7704), 1,
      sym_gnu_asm_clobber_list,
  [260098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11633), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [260107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13234), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2891), 1,
      sym_template_function,
  [260120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym___attribute,
    ACTIONS(7118), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13236), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7589), 1,
      aux_sym_attribute_declaration_repeat1,
  [260144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym___attribute,
    ACTIONS(7124), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [260155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13238), 1,
      anon_sym_GT2,
    STATE(7751), 1,
      aux_sym_template_argument_list_repeat1,
  [260168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13240), 1,
      anon_sym_constexpr,
    STATE(911), 1,
      sym_condition_clause,
  [260181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13242), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    ACTIONS(7043), 1,
      anon_sym_SEMI,
    STATE(2512), 1,
      sym_template_argument_list,
  [260207] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(13244), 1,
      anon_sym_RPAREN,
    STATE(7590), 1,
      aux_sym_argument_list_repeat1,
  [260220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4882), 1,
      anon_sym_RBRACE,
    ACTIONS(13246), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [260233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13248), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13250), 1,
      anon_sym_SEMI,
    STATE(8353), 1,
      sym_attribute_declaration,
  [260259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13252), 1,
      anon_sym_COMMA,
    ACTIONS(13255), 1,
      anon_sym_RBRACK,
    STATE(7649), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [260272] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_LPAREN2,
    ACTIONS(13257), 1,
      aux_sym_preproc_include_token2,
    STATE(9019), 1,
      sym_preproc_argument_list,
  [260285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_catch,
    STATE(2013), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [260296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13259), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [260305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13261), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 1,
      anon_sym_COMMA,
    ACTIONS(13266), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13268), 1,
      anon_sym_RPAREN,
    STATE(8497), 1,
      sym_gnu_asm_goto_list,
  [260344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13270), 1,
      anon_sym_RPAREN,
    STATE(7679), 1,
      sym_gnu_asm_input_operand_list,
  [260357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_COMMA,
    ACTIONS(13274), 1,
      anon_sym_RPAREN,
    STATE(7697), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [260370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13276), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [260383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_while,
    ACTIONS(12759), 1,
      anon_sym_else,
    STATE(411), 1,
      sym_else_clause,
  [260396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13278), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7768), 1,
      aux_sym_attribute_declaration_repeat1,
  [260409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13280), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [260422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13282), 1,
      anon_sym_SEMI,
    STATE(7737), 1,
      aux_sym_declaration_repeat1,
  [260435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13284), 1,
      sym_identifier,
    STATE(2530), 1,
      sym_template_type,
    STATE(2891), 1,
      sym_template_function,
  [260448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13286), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13288), 1,
      anon_sym_RPAREN,
    STATE(7451), 1,
      sym_gnu_asm_output_operand_list,
  [260474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13290), 1,
      anon_sym_RPAREN,
    STATE(7376), 1,
      sym_gnu_asm_output_operand_list,
  [260487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13292), 1,
      anon_sym_GT2,
    STATE(7671), 1,
      aux_sym_template_argument_list_repeat1,
  [260500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13294), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13296), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13298), 1,
      anon_sym_RPAREN,
    STATE(7675), 1,
      sym_gnu_asm_output_operand_list,
  [260539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13300), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13302), 1,
      anon_sym_catch,
    STATE(1012), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [260563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13304), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(690), 1,
      sym_declaration_list,
  [260589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13306), 1,
      anon_sym_RPAREN,
    STATE(7377), 1,
      sym_gnu_asm_input_operand_list,
  [260602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13308), 1,
      anon_sym_constexpr,
    STATE(898), 1,
      sym_condition_clause,
  [260615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13310), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3783), 1,
      sym_template_function,
  [260628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12702), 1,
      sym_identifier,
    ACTIONS(12704), 1,
      anon_sym_using,
    STATE(7722), 1,
      sym_attribute,
  [260641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12727), 1,
      anon_sym_COLON,
    ACTIONS(13312), 1,
      anon_sym_RPAREN,
    STATE(7532), 1,
      sym_gnu_asm_clobber_list,
  [260654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13036), 1,
      anon_sym_COMMA,
    ACTIONS(13314), 1,
      anon_sym_RBRACK,
    STATE(7606), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [260667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13316), 1,
      anon_sym_constexpr,
    STATE(927), 1,
      sym_condition_clause,
  [260680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13318), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [260693] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7350), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13320), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [260704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13322), 1,
      anon_sym_COMMA,
    ACTIONS(13325), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [260717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13327), 1,
      anon_sym_constexpr,
    STATE(902), 1,
      sym_condition_clause,
  [260730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13329), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [260743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13331), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [260756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13333), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [260765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13335), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [260774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13337), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [260787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10564), 1,
      anon_sym_RPAREN,
    ACTIONS(13339), 1,
      anon_sym_COMMA,
    STATE(7691), 1,
      aux_sym_preproc_argument_list_repeat1,
  [260800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13342), 1,
      anon_sym_RPAREN,
    STATE(7443), 1,
      aux_sym_parameter_list_repeat1,
  [260813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13344), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(794), 1,
      sym_declaration_list,
  [260839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13346), 1,
      anon_sym_GT2,
    STATE(7464), 1,
      aux_sym_template_argument_list_repeat1,
  [260852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9171), 1,
      anon_sym_RPAREN,
    STATE(7401), 1,
      aux_sym_argument_list_repeat1,
  [260865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      anon_sym_COMMA,
    ACTIONS(13348), 1,
      anon_sym_RPAREN,
    STATE(7705), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [260878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13350), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [260891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9155), 1,
      anon_sym_RPAREN,
    STATE(7414), 1,
      aux_sym_argument_list_repeat1,
  [260904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13352), 1,
      anon_sym_GT2,
    STATE(7813), 1,
      aux_sym_template_argument_list_repeat1,
  [260917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(13354), 1,
      anon_sym_LBRACE,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [260930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13010), 1,
      anon_sym_COMMA,
    ACTIONS(13356), 1,
      anon_sym_RPAREN,
    STATE(7516), 1,
      aux_sym_throw_specifier_repeat1,
  [260943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13358), 1,
      anon_sym_RPAREN,
    STATE(7766), 1,
      aux_sym_parameter_list_repeat1,
  [260956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12700), 1,
      anon_sym_COLON,
    ACTIONS(13360), 1,
      anon_sym_RPAREN,
    STATE(8392), 1,
      sym_gnu_asm_goto_list,
  [260969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13362), 1,
      anon_sym_COMMA,
    ACTIONS(13365), 1,
      anon_sym_RPAREN,
    STATE(7705), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [260982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [260991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13369), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [261000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13371), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7592), 1,
      aux_sym_attribute_declaration_repeat1,
  [261013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12863), 1,
      anon_sym_catch,
    STATE(190), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12723), 1,
      anon_sym_COLON,
    ACTIONS(13373), 1,
      anon_sym_RPAREN,
    STATE(7419), 1,
      sym_gnu_asm_input_operand_list,
  [261037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13375), 1,
      anon_sym_GT2,
    STATE(7792), 1,
      aux_sym_template_argument_list_repeat1,
  [261050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13377), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [261059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      anon_sym___attribute,
    ACTIONS(7140), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [261070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13379), 1,
      anon_sym_default,
    ACTIONS(13381), 1,
      anon_sym_delete,
    ACTIONS(13383), 1,
      aux_sym_pure_virtual_clause_token1,
  [261083] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7159), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13385), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [261094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12626), 1,
      anon_sym_LBRACE,
    STATE(7481), 1,
      aux_sym_base_class_clause_repeat1,
  [261107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13387), 1,
      anon_sym_COMMA,
    ACTIONS(13389), 1,
      anon_sym_RPAREN,
    STATE(7781), 1,
      aux_sym_preproc_params_repeat1,
  [261120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13391), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [261133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13393), 1,
      anon_sym_RPAREN,
    STATE(7710), 1,
      sym_gnu_asm_output_operand_list,
  [261146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9145), 1,
      anon_sym_RBRACE,
    ACTIONS(13395), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [261159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12863), 1,
      anon_sym_catch,
    STATE(157), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13398), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7761), 1,
      aux_sym_attribute_declaration_repeat1,
  [261183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13400), 1,
      anon_sym_constexpr,
    STATE(931), 1,
      sym_condition_clause,
  [261196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13402), 1,
      anon_sym_RPAREN,
    STATE(7766), 1,
      aux_sym_parameter_list_repeat1,
  [261209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13404), 1,
      anon_sym_COMMA,
    ACTIONS(13407), 1,
      anon_sym_RPAREN,
    STATE(7725), 1,
      aux_sym_preproc_params_repeat1,
  [261222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 1,
      anon_sym___attribute,
    ACTIONS(7144), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [261233] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13409), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [261246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_COMMA,
    ACTIONS(9169), 1,
      anon_sym_RBRACK,
    STATE(7445), 1,
      aux_sym_subscript_argument_list_repeat1,
  [261259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13411), 1,
      anon_sym_GT2,
    STATE(7373), 1,
      aux_sym_template_argument_list_repeat1,
  [261272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13413), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [261281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13415), 1,
      anon_sym_GT2,
    STATE(7734), 1,
      aux_sym_template_argument_list_repeat1,
  [261294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13417), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13419), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13421), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13423), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(13425), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [261344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_RBRACE,
    ACTIONS(9073), 1,
      anon_sym_COMMA,
    STATE(7810), 1,
      aux_sym_initializer_list_repeat1,
  [261357] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13427), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [261370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(13354), 1,
      anon_sym_LBRACE,
    STATE(7579), 1,
      aux_sym_base_class_clause_repeat1,
  [261383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_catch,
    STATE(2020), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13429), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13431), 1,
      anon_sym_RPAREN,
    STATE(7724), 1,
      aux_sym_parameter_list_repeat1,
  [261420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13433), 1,
      anon_sym_RPAREN,
    STATE(7387), 1,
      sym_gnu_asm_output_operand_list,
  [261433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13435), 1,
      anon_sym_COMMA,
    ACTIONS(13438), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13440), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [261459] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(13442), 1,
      anon_sym_RPAREN,
    STATE(7421), 1,
      sym_gnu_asm_output_operand_list,
  [261472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(13444), 1,
      anon_sym_SEMI,
    STATE(8790), 1,
      sym_attribute_declaration,
  [261485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12927), 1,
      anon_sym_catch,
    STATE(1871), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13446), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [261509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13448), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2891), 1,
      sym_template_function,
  [261522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13450), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [261535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13452), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261548] = 4,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12768), 1,
      anon_sym_LPAREN2,
    ACTIONS(13454), 1,
      aux_sym_preproc_include_token2,
    STATE(9019), 1,
      sym_preproc_argument_list,
  [261561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13456), 1,
      anon_sym_GT2,
    STATE(7756), 1,
      aux_sym_template_argument_list_repeat1,
  [261574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13458), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13460), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13462), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13464), 1,
      anon_sym_RPAREN,
    STATE(7774), 1,
      aux_sym_parameter_list_repeat1,
  [261626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13466), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7687), 1,
      aux_sym_attribute_declaration_repeat1,
  [261639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13468), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13470), 1,
      anon_sym_COMMA,
    ACTIONS(13473), 1,
      anon_sym_GT2,
    STATE(7760), 1,
      aux_sym_template_parameter_list_repeat1,
  [261665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13475), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [261678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13477), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12386), 1,
      anon_sym_COMMA,
    ACTIONS(12626), 1,
      anon_sym_LBRACE,
    STATE(7513), 1,
      aux_sym_base_class_clause_repeat1,
  [261704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 1,
      anon_sym___attribute,
    ACTIONS(7160), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [261715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13479), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13481), 1,
      anon_sym_COMMA,
    ACTIONS(13484), 1,
      anon_sym_RPAREN,
    STATE(7766), 1,
      aux_sym_parameter_list_repeat1,
  [261741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12927), 1,
      anon_sym_catch,
    STATE(1874), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12963), 1,
      anon_sym_COMMA,
    ACTIONS(13486), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7578), 1,
      aux_sym_attribute_declaration_repeat1,
  [261765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7088), 1,
      anon_sym___attribute,
    ACTIONS(7090), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [261776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13488), 1,
      sym_identifier,
    STATE(3017), 1,
      sym_template_type,
    STATE(3862), 1,
      sym_template_function,
  [261789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13490), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(2891), 1,
      sym_template_function,
  [261802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 1,
      anon_sym___attribute,
    ACTIONS(7094), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [261813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_COMMA,
    ACTIONS(9132), 1,
      anon_sym_RPAREN,
    STATE(7398), 1,
      aux_sym_argument_list_repeat1,
  [261826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12859), 1,
      anon_sym_COMMA,
    ACTIONS(13492), 1,
      anon_sym_RPAREN,
    STATE(7766), 1,
      aux_sym_parameter_list_repeat1,
  [261839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    STATE(832), 1,
      sym_declaration_list,
  [261852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13494), 1,
      anon_sym_GT2,
    STATE(7780), 1,
      aux_sym_template_argument_list_repeat1,
  [261865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(13496), 1,
      anon_sym_RPAREN,
    STATE(7684), 1,
      aux_sym_generic_expression_repeat1,
  [261878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13498), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13500), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13502), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13387), 1,
      anon_sym_COMMA,
    ACTIONS(13504), 1,
      anon_sym_RPAREN,
    STATE(7725), 1,
      aux_sym_preproc_params_repeat1,
  [261930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13506), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13508), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [261956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12714), 1,
      anon_sym_catch,
    STATE(2014), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [261967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13510), 1,
      anon_sym_SEMI,
    STATE(7582), 1,
      aux_sym_declaration_repeat1,
  [261980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13512), 1,
      anon_sym_SEMI,
    STATE(7537), 1,
      aux_sym_declaration_repeat1,
  [261993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12997), 1,
      anon_sym_catch,
    STATE(273), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [262004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13514), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13516), 1,
      anon_sym_SEMI,
    STATE(7541), 1,
      aux_sym_declaration_repeat1,
  [262030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [262039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12869), 1,
      anon_sym_COMMA,
    ACTIONS(13518), 1,
      anon_sym_GT2,
    STATE(7447), 1,
      aux_sym_template_parameter_list_repeat1,
  [262052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13520), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13522), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13524), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 1,
      anon_sym_COMMA,
    ACTIONS(13526), 1,
      anon_sym_RBRACK,
    STATE(7649), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [262104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13528), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [262117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12997), 1,
      anon_sym_catch,
    STATE(430), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [262128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13530), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(6514), 1,
      sym_template_function,
  [262141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12334), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [262150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13078), 1,
      anon_sym_COMMA,
    ACTIONS(13532), 1,
      anon_sym_RPAREN,
    STATE(7599), 1,
      aux_sym_requires_parameter_list_repeat1,
  [262163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13534), 1,
      anon_sym_GT2,
    STATE(7805), 1,
      aux_sym_template_argument_list_repeat1,
  [262176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13536), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      anon_sym_catch,
    STATE(2015), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [262200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13538), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13540), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13542), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [262239] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    STATE(7314), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(13544), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [262250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9053), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_SEMI,
  [262259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    ACTIONS(13546), 1,
      anon_sym_constexpr,
    STATE(890), 1,
      sym_condition_clause,
  [262272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4708), 1,
      anon_sym_RBRACE,
    ACTIONS(13548), 1,
      anon_sym_COMMA,
    STATE(7720), 1,
      aux_sym_initializer_list_repeat1,
  [262285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13550), 1,
      anon_sym_SEMI,
    STATE(7673), 1,
      aux_sym_declaration_repeat1,
  [262298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13552), 1,
      anon_sym_SEMI,
    STATE(7664), 1,
      aux_sym_declaration_repeat1,
  [262311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13554), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11633), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [262333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13556), 1,
      anon_sym_GT2,
    STATE(7380), 1,
      aux_sym_template_argument_list_repeat1,
  [262346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9930), 1,
      anon_sym_requires,
    ACTIONS(11822), 1,
      anon_sym_LBRACE,
    STATE(8740), 1,
      sym_requires_clause,
  [262359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13560), 1,
      anon_sym_RPAREN,
    ACTIONS(13558), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [262370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13562), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
    STATE(3185), 1,
      sym_template_function,
  [262383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(13564), 1,
      anon_sym_SEMI,
    STATE(7654), 1,
      aux_sym_declaration_repeat1,
  [262396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_COMMA,
    ACTIONS(13566), 1,
      anon_sym_GT2,
    STATE(7743), 1,
      aux_sym_template_argument_list_repeat1,
  [262409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13568), 1,
      sym_identifier,
    STATE(3017), 1,
      sym_template_type,
  [262419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13570), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
  [262429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12563), 1,
      sym_identifier,
    STATE(7972), 1,
      sym_module_name,
  [262439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12242), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
  [262449] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13572), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13574), 1,
      sym_preproc_arg,
  [262459] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13576), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13578), 1,
      sym_preproc_arg,
  [262469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8560), 1,
      sym_argument_list,
  [262479] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13580), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13582), 1,
      sym_preproc_arg,
  [262489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_compound_statement,
  [262499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7274), 1,
      sym_compound_statement,
  [262509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_field_declaration_list,
  [262519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_compound_statement,
  [262529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(902), 1,
      sym_condition_clause,
  [262539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_LBRACE,
    STATE(3887), 1,
      sym_initializer_list,
  [262549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13584), 1,
      anon_sym_if,
    ACTIONS(13586), 1,
      anon_sym_for,
  [262559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13588), 1,
      anon_sym_SEMI,
  [262569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13590), 1,
      sym_identifier,
    STATE(181), 1,
      sym_template_type,
  [262579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(909), 1,
      sym_condition_clause,
  [262589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13484), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [262597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13592), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [262605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3346), 1,
      sym_field_declaration_list,
  [262615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3812), 1,
      anon_sym_LBRACE,
    STATE(2949), 1,
      sym_initializer_list,
  [262625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(3818), 1,
      sym_compound_statement,
  [262635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(939), 1,
      sym_condition_clause,
  [262645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13594), 1,
      anon_sym_LT,
    STATE(3554), 1,
      sym_template_argument_list,
  [262655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(3675), 1,
      sym_compound_statement,
  [262665] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13596), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13598), 1,
      sym_preproc_arg,
  [262675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13600), 1,
      anon_sym_LPAREN2,
    ACTIONS(13602), 1,
      sym_raw_string_delimiter,
  [262685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10014), 1,
      anon_sym_LBRACE,
    STATE(3847), 1,
      sym_requirement_seq,
  [262695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13604), 1,
      sym_identifier,
    STATE(3097), 1,
      sym_template_type,
  [262705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1995), 1,
      sym_compound_statement,
  [262715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13606), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [262723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13089), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [262731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(9099), 1,
      sym_parenthesized_expression,
  [262741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(7832), 1,
      sym_parameter_list,
  [262751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(3859), 1,
      sym_compound_statement,
  [262761] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13610), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13612), 1,
      sym_preproc_arg,
  [262771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(291), 1,
      sym_template_argument_list,
  [262781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7446), 1,
      sym_compound_statement,
  [262791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13614), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [262799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2860), 1,
      sym_template_argument_list,
  [262809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(906), 1,
      sym_condition_clause,
  [262819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1093), 1,
      sym_field_declaration_list,
  [262829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(7890), 1,
      sym_parenthesized_expression,
  [262839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9246), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [262847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11359), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [262857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7554), 1,
      sym_compound_statement,
  [262867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3381), 1,
      sym_field_declaration_list,
  [262877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3357), 1,
      sym_field_declaration_list,
  [262887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4392), 1,
      anon_sym_LBRACE,
    STATE(5095), 1,
      sym_initializer_list,
  [262897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13038), 1,
      anon_sym_RBRACK,
    ACTIONS(13618), 1,
      anon_sym_COMMA,
  [262907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(3548), 1,
      sym_compound_statement,
  [262917] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13620), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13622), 1,
      sym_preproc_arg,
  [262927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13624), 1,
      sym_identifier,
    STATE(2605), 1,
      sym_template_type,
  [262937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(230), 1,
      sym_compound_statement,
  [262947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(3916), 1,
      sym_compound_statement,
  [262957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1954), 1,
      sym_compound_statement,
  [262967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8543), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
  [262977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [262985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(2416), 1,
      sym_field_declaration_list,
  [262995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(8203), 1,
      sym_condition_clause,
  [263005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_compound_statement,
  [263015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1066), 1,
      sym_field_declaration_list,
  [263025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1067), 1,
      sym_field_declaration_list,
  [263035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13626), 1,
      anon_sym_RBRACE,
  [263045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7289), 1,
      anon_sym_LBRACE,
    STATE(3347), 1,
      sym_field_declaration_list,
  [263055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(2417), 1,
      sym_field_declaration_list,
  [263065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_LBRACE,
    STATE(1049), 1,
      sym_compound_statement,
  [263075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13628), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [263083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_compound_statement,
  [263093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13630), 1,
      anon_sym_RBRACE,
  [263103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(3954), 1,
      sym_compound_statement,
  [263113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(566), 1,
      sym_field_declaration_list,
  [263123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2689), 1,
      sym_field_declaration_list,
  [263133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3212), 1,
      sym_field_declaration_list,
  [263143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(490), 1,
      sym_compound_statement,
  [263153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_field_declaration_list,
  [263163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8827), 1,
      sym_argument_list,
  [263173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_field_declaration_list,
  [263183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_LBRACE,
    STATE(1080), 1,
      sym_compound_statement,
  [263193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(911), 1,
      sym_condition_clause,
  [263203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1050), 1,
      sym_field_declaration_list,
  [263213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1082), 1,
      sym_field_declaration_list,
  [263223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1118), 1,
      sym_field_declaration_list,
  [263233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10006), 1,
      anon_sym_LBRACE,
    STATE(3542), 1,
      sym_requirement_seq,
  [263243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_compound_statement,
  [263253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13632), 1,
      anon_sym_SEMI,
  [263263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACE,
    STATE(1090), 1,
      sym_field_declaration_list,
  [263273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(2413), 1,
      sym_field_declaration_list,
  [263283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    STATE(573), 1,
      sym_declaration_list,
  [263293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_LBRACE,
    STATE(3743), 1,
      sym_initializer_list,
  [263303] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13634), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13636), 1,
      sym_preproc_arg,
  [263313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9998), 1,
      anon_sym_LBRACE,
    STATE(4401), 1,
      sym_requirement_seq,
  [263323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13638), 1,
      anon_sym_LT,
    STATE(2860), 1,
      sym_template_argument_list,
  [263333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(2112), 1,
      sym_compound_statement,
  [263343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(7957), 1,
      sym_parenthesized_expression,
  [263353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(557), 1,
      sym_compound_statement,
  [263363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    STATE(385), 1,
      sym_declaration_list,
  [263373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    STATE(4412), 1,
      sym_compound_statement,
  [263383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13640), 1,
      sym_identifier,
    STATE(167), 1,
      sym_template_type,
  [263393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13154), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [263401] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13642), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13644), 1,
      sym_preproc_arg,
  [263411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13594), 1,
      anon_sym_LT,
    STATE(3088), 1,
      sym_template_argument_list,
  [263421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9990), 1,
      anon_sym_LBRACE,
    STATE(2948), 1,
      sym_requirement_seq,
  [263431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(2407), 1,
      sym_field_declaration_list,
  [263441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(520), 1,
      sym_field_declaration_list,
  [263451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12764), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [263459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13646), 1,
      sym_identifier,
    ACTIONS(13648), 1,
      anon_sym_LPAREN2,
  [263469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4887), 1,
      sym_field_declaration_list,
  [263479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(392), 1,
      sym_compound_statement,
  [263489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9123), 1,
      anon_sym_RPAREN,
    ACTIONS(9125), 1,
      anon_sym_SEMI,
  [263499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    STATE(608), 1,
      sym_declaration_list,
  [263509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13650), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [263517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13652), 1,
      anon_sym_if,
    ACTIONS(13654), 1,
      anon_sym_for,
  [263527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12248), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym_requirement_seq,
  [263537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1889), 1,
      sym_compound_statement,
  [263547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_compound_statement,
  [263557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      sym_compound_statement,
  [263567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym_compound_statement,
  [263577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1889), 1,
      sym_compound_statement,
  [263587] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13656), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13658), 1,
      sym_preproc_arg,
  [263597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2009), 1,
      anon_sym_LT,
    STATE(182), 1,
      sym_template_argument_list,
  [263607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9328), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [263615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11291), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [263625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(259), 1,
      sym_field_declaration_list,
  [263635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(458), 1,
      sym_field_declaration_list,
  [263645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    STATE(692), 1,
      sym_declaration_list,
  [263655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [263665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(7906), 1,
      sym_condition_clause,
  [263675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(920), 1,
      sym_condition_clause,
  [263685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7721), 1,
      sym_compound_statement,
  [263695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(2887), 1,
      sym_compound_statement,
  [263705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11349), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [263715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13660), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
  [263725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4904), 1,
      sym_field_declaration_list,
  [263735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4905), 1,
      sym_field_declaration_list,
  [263745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(565), 1,
      sym_compound_statement,
  [263755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8305), 1,
      sym_argument_list,
  [263765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7154), 1,
      sym_compound_statement,
  [263775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13662), 1,
      sym_identifier,
    STATE(2530), 1,
      sym_template_type,
  [263785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(921), 1,
      sym_condition_clause,
  [263795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13664), 1,
      anon_sym_if,
    ACTIONS(13666), 1,
      anon_sym_for,
  [263805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8597), 1,
      sym_argument_list,
  [263815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2680), 1,
      sym_field_declaration_list,
  [263825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2677), 1,
      sym_field_declaration_list,
  [263835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_field_declaration_list,
  [263845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      sym_compound_statement,
  [263855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_compound_statement,
  [263865] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13668), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13670), 1,
      sym_preproc_arg,
  [263875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8755), 1,
      sym_parenthesized_expression,
  [263885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(8152), 1,
      sym_parameter_list,
  [263895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13672), 2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [263903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13674), 1,
      anon_sym_RBRACE,
  [263913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7444), 1,
      sym_compound_statement,
  [263923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
  [263933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(925), 1,
      sym_condition_clause,
  [263943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_LBRACE,
    STATE(4918), 1,
      sym_field_declaration_list,
  [263953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8180), 1,
      sym_parenthesized_expression,
  [263963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(566), 1,
      sym_field_declaration_list,
  [263973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_LBRACE,
    STATE(1901), 1,
      sym_compound_statement,
  [263983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_LT,
    STATE(3826), 1,
      sym_template_argument_list,
  [263993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9619), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym_compound_statement,
  [264003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2814), 1,
      sym_field_declaration_list,
  [264013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    STATE(4421), 1,
      sym_compound_statement,
  [264023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(2146), 1,
      sym_compound_statement,
  [264033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_field_declaration_list,
  [264043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_field_declaration_list,
  [264053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(7896), 1,
      sym_condition_clause,
  [264063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_field_declaration_list,
  [264073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(928), 1,
      sym_condition_clause,
  [264083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7787), 1,
      sym_compound_statement,
  [264093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_compound_statement,
  [264103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13678), 1,
      sym_identifier,
    STATE(2042), 1,
      sym_template_type,
  [264113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13140), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [264121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(211), 1,
      sym_field_declaration_list,
  [264131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_field_declaration_list,
  [264141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8748), 1,
      sym_argument_list,
  [264151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7198), 1,
      sym_compound_statement,
  [264161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4910), 1,
      anon_sym_LBRACE,
    STATE(574), 1,
      sym_declaration_list,
  [264171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(931), 1,
      sym_condition_clause,
  [264181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13680), 1,
      anon_sym_if,
    ACTIONS(13682), 1,
      anon_sym_for,
  [264191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13425), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [264199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13684), 1,
      anon_sym_RBRACE,
  [264209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6474), 1,
      anon_sym_LBRACE,
    STATE(2656), 1,
      sym_field_declaration_list,
  [264219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8352), 1,
      sym_parenthesized_expression,
  [264229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(323), 1,
      sym_field_declaration_list,
  [264239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(8013), 1,
      sym_parameter_list,
  [264249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3247), 1,
      sym_field_declaration_list,
  [264259] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13686), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13688), 1,
      sym_preproc_arg,
  [264269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    STATE(410), 1,
      sym_declaration_list,
  [264279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7374), 1,
      sym_compound_statement,
  [264289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(935), 1,
      sym_condition_clause,
  [264299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_compound_statement,
  [264309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13690), 1,
      anon_sym_SEMI,
  [264319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12662), 1,
      anon_sym_LBRACE,
    STATE(5931), 1,
      sym_requirement_seq,
  [264329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8039), 1,
      sym_parenthesized_expression,
  [264339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(5964), 1,
      sym_compound_statement,
  [264349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6265), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
  [264359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [264369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_LT,
    STATE(3782), 1,
      sym_template_argument_list,
  [264379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9607), 1,
      anon_sym_LBRACE,
    STATE(4405), 1,
      sym_compound_statement,
  [264389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [264399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13407), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [264407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(8121), 1,
      sym_condition_clause,
  [264417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3223), 1,
      sym_field_declaration_list,
  [264427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7739), 1,
      sym_compound_statement,
  [264437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3227), 1,
      sym_field_declaration_list,
  [264447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8780), 1,
      sym_argument_list,
  [264457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7171), 1,
      sym_compound_statement,
  [264467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13692), 1,
      anon_sym_if,
    ACTIONS(13694), 1,
      anon_sym_for,
  [264477] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13696), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13698), 1,
      sym_preproc_arg,
  [264487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(888), 1,
      sym_condition_clause,
  [264497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3189), 1,
      sym_field_declaration_list,
  [264507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3204), 1,
      sym_field_declaration_list,
  [264517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(5878), 1,
      sym_compound_statement,
  [264527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13700), 1,
      sym_identifier,
    ACTIONS(13702), 1,
      anon_sym_LPAREN2,
  [264537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8998), 1,
      sym_parenthesized_expression,
  [264547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(8201), 1,
      sym_parameter_list,
  [264557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(220), 1,
      sym_compound_statement,
  [264567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13704), 1,
      anon_sym_RBRACE,
  [264577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7510), 1,
      sym_compound_statement,
  [264587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7230), 1,
      anon_sym_LBRACE,
    STATE(3241), 1,
      sym_field_declaration_list,
  [264597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(221), 1,
      sym_field_declaration_list,
  [264607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(222), 1,
      sym_field_declaration_list,
  [264617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11162), 1,
      anon_sym_LBRACE,
    STATE(2046), 1,
      sym_compound_statement,
  [264627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8212), 1,
      sym_parenthesized_expression,
  [264637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(223), 1,
      sym_field_declaration_list,
  [264647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(5914), 1,
      sym_compound_statement,
  [264657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_field_declaration_list,
  [264667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7672), 1,
      sym_compound_statement,
  [264677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8732), 1,
      sym_argument_list,
  [264687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [264695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7598), 1,
      sym_compound_statement,
  [264705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_LBRACE,
    STATE(227), 1,
      sym_field_declaration_list,
  [264715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13706), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [264723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [264733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(8765), 1,
      sym_parenthesized_expression,
  [264743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13708), 1,
      sym_identifier,
    STATE(2267), 1,
      sym_template_type,
  [264753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(7888), 1,
      sym_parameter_list,
  [264763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(833), 1,
      sym_compound_statement,
  [264773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_declaration_list,
  [264783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7477), 1,
      sym_compound_statement,
  [264793] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13710), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13712), 1,
      sym_preproc_arg,
  [264803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      anon_sym_LPAREN2,
    STATE(7900), 1,
      sym_parenthesized_expression,
  [264813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5075), 1,
      sym_field_declaration_list,
  [264823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9130), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [264831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12398), 1,
      anon_sym_LBRACE,
    STATE(6062), 1,
      sym_requirement_seq,
  [264841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7538), 1,
      sym_compound_statement,
  [264851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13594), 1,
      anon_sym_LT,
    STATE(3797), 1,
      sym_template_argument_list,
  [264861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3548), 1,
      sym_compound_statement,
  [264871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7767), 1,
      sym_compound_statement,
  [264881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2001), 1,
      anon_sym_LT,
    STATE(169), 1,
      sym_template_argument_list,
  [264891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8806), 1,
      sym_argument_list,
  [264901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_LT,
    STATE(2839), 1,
      sym_template_argument_list,
  [264911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11345), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [264921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5024), 1,
      sym_field_declaration_list,
  [264931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5025), 1,
      sym_field_declaration_list,
  [264941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9145), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [264949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(7980), 1,
      sym_parameter_list,
  [264959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7803), 1,
      sym_compound_statement,
  [264969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9280), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [264977] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13716), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13718), 1,
      sym_preproc_arg,
  [264987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_LT,
    STATE(2860), 1,
      sym_template_argument_list,
  [264997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3537), 1,
      sym_compound_statement,
  [265007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7651), 1,
      sym_compound_statement,
  [265017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8389), 1,
      sym_argument_list,
  [265027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(3537), 1,
      sym_compound_statement,
  [265037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13720), 1,
      anon_sym_RBRACE,
  [265047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9028), 1,
      anon_sym_LBRACE,
    STATE(5032), 1,
      sym_field_declaration_list,
  [265057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(8045), 1,
      sym_parameter_list,
  [265067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8530), 1,
      sym_argument_list,
  [265077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(3544), 1,
      sym_compound_statement,
  [265087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(2888), 1,
      sym_compound_statement,
  [265097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(915), 1,
      sym_condition_clause,
  [265107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      anon_sym_LPAREN2,
    STATE(8668), 1,
      sym_argument_list,
  [265117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13722), 1,
      sym_identifier,
    ACTIONS(13724), 1,
      anon_sym_RPAREN,
  [265127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(345), 1,
      sym_compound_statement,
  [265137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LBRACE,
    STATE(4149), 1,
      sym_initializer_list,
  [265147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13726), 1,
      sym_identifier,
    STATE(3192), 1,
      sym_template_type,
  [265157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4299), 1,
      anon_sym_LBRACE,
    STATE(4095), 1,
      sym_initializer_list,
  [265167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13728), 1,
      sym_identifier,
    STATE(290), 1,
      sym_template_type,
  [265177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7199), 1,
      sym_compound_statement,
  [265187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13730), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [265195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13732), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [265203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4224), 1,
      sym_field_declaration_list,
  [265213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13558), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [265221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(6065), 1,
      sym_compound_statement,
  [265231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9136), 1,
      anon_sym_LT,
    STATE(3002), 1,
      sym_template_argument_list,
  [265241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11361), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [265251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4192), 1,
      sym_field_declaration_list,
  [265261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4194), 1,
      sym_field_declaration_list,
  [265271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(6082), 1,
      sym_compound_statement,
  [265281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13734), 1,
      anon_sym_RBRACE,
  [265291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7874), 1,
      anon_sym_LBRACE,
    STATE(4198), 1,
      sym_field_declaration_list,
  [265301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12719), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [265309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9623), 1,
      anon_sym_LBRACE,
    STATE(5992), 1,
      sym_compound_statement,
  [265319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13736), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9625), 1,
      anon_sym_LBRACE,
    STATE(3813), 1,
      sym_compound_statement,
  [265337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9615), 1,
      anon_sym_LBRACE,
    STATE(3544), 1,
      sym_compound_statement,
  [265347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_field_declaration_list,
  [265357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_LBRACE,
    STATE(1053), 1,
      sym_compound_statement,
  [265367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_compound_statement,
  [265377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13738), 1,
      sym_identifier,
    STATE(3136), 1,
      sym_template_type,
  [265387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LBRACE,
    STATE(458), 1,
      sym_field_declaration_list,
  [265397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13133), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [265405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(330), 1,
      sym_field_declaration_list,
  [265415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13740), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(896), 1,
      sym_condition_clause,
  [265433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(331), 1,
      sym_field_declaration_list,
  [265443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(891), 1,
      sym_condition_clause,
  [265453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1889), 1,
      sym_compound_statement,
  [265463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4906), 1,
      anon_sym_LBRACE,
    STATE(295), 1,
      sym_declaration_list,
  [265473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5686), 1,
      anon_sym_LT,
    STATE(2276), 1,
      sym_template_argument_list,
  [265483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(662), 1,
      sym_compound_statement,
  [265493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12563), 1,
      sym_identifier,
    STATE(7129), 1,
      sym_module_name,
  [265503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13742), 1,
      anon_sym_RBRACE,
  [265513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1892), 1,
      sym_compound_statement,
  [265523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    STATE(4084), 1,
      sym_requirement_seq,
  [265533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_LBRACE,
    STATE(3220), 1,
      sym_field_declaration_list,
  [265543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym_compound_statement,
  [265553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(624), 1,
      sym_compound_statement,
  [265563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_field_declaration_list,
  [265573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9605), 1,
      anon_sym_LPAREN2,
    STATE(7875), 1,
      sym_parameter_list,
  [265583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(4120), 1,
      sym_compound_statement,
  [265593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13744), 1,
      sym_identifier,
    STATE(319), 1,
      sym_template_type,
  [265603] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13746), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13748), 1,
      sym_preproc_arg,
  [265613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(889), 1,
      sym_condition_clause,
  [265623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_LT,
    STATE(2624), 1,
      sym_template_argument_list,
  [265633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(886), 1,
      sym_condition_clause,
  [265643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13750), 1,
      anon_sym_LT,
    STATE(3165), 1,
      sym_template_argument_list,
  [265653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(641), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_compound_statement,
  [265663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_LBRACE,
    STATE(199), 1,
      sym_compound_statement,
  [265673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13752), 1,
      anon_sym_SEMI,
  [265683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5440), 1,
      sym_field_declaration_list,
  [265693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13754), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_template_type,
  [265703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5444), 1,
      sym_field_declaration_list,
  [265713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5445), 1,
      sym_field_declaration_list,
  [265723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(500), 1,
      sym_field_declaration_list,
  [265733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(5331), 1,
      sym_field_declaration_list,
  [265743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7281), 1,
      anon_sym_LT,
    STATE(3144), 1,
      sym_template_argument_list,
  [265753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11335), 1,
      anon_sym_RBRACE,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [265763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2839), 1,
      sym_template_argument_list,
  [265773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(7150), 1,
      sym_compound_statement,
  [265783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9617), 1,
      anon_sym_LBRACE,
    STATE(2922), 1,
      sym_compound_statement,
  [265793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13756), 1,
      sym_identifier,
    STATE(3101), 1,
      sym_template_type,
  [265803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(2980), 1,
      sym_field_declaration_list,
  [265813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(2982), 1,
      sym_field_declaration_list,
  [265823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    STATE(795), 1,
      sym_declaration_list,
  [265833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_LT,
    STATE(2260), 1,
      sym_template_argument_list,
  [265843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13758), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [265851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13473), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(780), 1,
      sym_compound_statement,
  [265869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13760), 1,
      sym_identifier,
    STATE(4650), 1,
      sym_template_type,
  [265879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 1,
      anon_sym_LT,
    STATE(316), 1,
      sym_template_argument_list,
  [265889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(557), 1,
      sym_compound_statement,
  [265899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(4122), 1,
      sym_compound_statement,
  [265909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(647), 1,
      sym_compound_statement,
  [265919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13762), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [265927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13764), 1,
      sym_identifier,
    STATE(3950), 1,
      sym_template_type,
  [265937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(332), 1,
      sym_compound_statement,
  [265947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12743), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [265955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(340), 1,
      sym_field_declaration_list,
  [265965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(419), 1,
      sym_field_declaration_list,
  [265975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4058), 1,
      anon_sym_LT,
    STATE(1004), 1,
      sym_template_argument_list,
  [265985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(342), 1,
      sym_field_declaration_list,
  [265995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_field_declaration_list,
  [266005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(504), 1,
      sym_compound_statement,
  [266015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_field_declaration_list,
  [266025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_field_declaration_list,
  [266035] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13766), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13768), 1,
      sym_preproc_arg,
  [266045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13770), 1,
      anon_sym_RBRACE,
  [266055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      anon_sym_LPAREN2,
    ACTIONS(13774), 1,
      sym_raw_string_delimiter,
  [266065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_LT,
    STATE(3106), 1,
      sym_template_argument_list,
  [266075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6898), 1,
      anon_sym_LBRACE,
    STATE(3004), 1,
      sym_field_declaration_list,
  [266085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(5302), 1,
      sym_field_declaration_list,
  [266095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(560), 1,
      sym_field_declaration_list,
  [266105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(5307), 1,
      sym_field_declaration_list,
  [266115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(5308), 1,
      sym_field_declaration_list,
  [266125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      anon_sym_LBRACE,
    STATE(5311), 1,
      sym_field_declaration_list,
  [266135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    STATE(680), 1,
      sym_declaration_list,
  [266145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9632), 1,
      anon_sym_LBRACE,
    STATE(2040), 1,
      sym_compound_statement,
  [266155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8708), 1,
      anon_sym_LT,
    STATE(4557), 1,
      sym_template_argument_list,
  [266165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      anon_sym_LBRACE,
    STATE(348), 1,
      sym_compound_statement,
  [266175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11241), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [266183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
    ACTIONS(13776), 1,
      anon_sym_RBRACE,
  [266193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    STATE(4180), 1,
      sym_compound_statement,
  [266203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13778), 1,
      anon_sym_LT,
    STATE(3917), 1,
      sym_template_argument_list,
  [266213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4914), 1,
      anon_sym_LBRACE,
    STATE(685), 1,
      sym_declaration_list,
  [266223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4912), 1,
      anon_sym_LBRACE,
    STATE(739), 1,
      sym_declaration_list,
  [266233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 1,
      anon_sym_LT,
    STATE(2507), 1,
      sym_template_argument_list,
  [266243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8188), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [266251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(785), 1,
      anon_sym_LBRACE,
    STATE(516), 1,
      sym_compound_statement,
  [266261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_LBRACE,
    STATE(343), 1,
      sym_field_declaration_list,
  [266271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_field_declaration_list,
  [266281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(518), 1,
      sym_field_declaration_list,
  [266291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_field_declaration_list,
  [266301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5038), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [266309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13780), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [266317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LBRACE,
    STATE(523), 1,
      sym_field_declaration_list,
  [266327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6636), 1,
      anon_sym_LBRACE,
    STATE(2825), 1,
      sym_field_declaration_list,
  [266337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13184), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [266345] = 3,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13782), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13784), 1,
      sym_preproc_arg,
  [266355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13786), 1,
      anon_sym_LPAREN2,
    ACTIONS(13788), 1,
      sym_raw_string_delimiter,
  [266365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12961), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [266373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13790), 1,
      anon_sym_LPAREN2,
    ACTIONS(13792), 1,
      sym_raw_string_delimiter,
  [266383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9065), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [266391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13794), 1,
      anon_sym_LPAREN2,
    ACTIONS(13796), 1,
      sym_raw_string_delimiter,
  [266401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [266409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13800), 1,
      anon_sym_LPAREN2,
    ACTIONS(13802), 1,
      sym_raw_string_delimiter,
  [266419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(8151), 1,
      sym_condition_clause,
  [266429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13804), 1,
      anon_sym_LPAREN2,
    ACTIONS(13806), 1,
      sym_raw_string_delimiter,
  [266439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13808), 1,
      anon_sym_LPAREN2,
    ACTIONS(13810), 1,
      sym_raw_string_delimiter,
  [266449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13812), 1,
      anon_sym_LPAREN2,
    ACTIONS(13814), 1,
      sym_raw_string_delimiter,
  [266459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13816), 1,
      anon_sym_LPAREN2,
    ACTIONS(13818), 1,
      sym_raw_string_delimiter,
  [266469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13820), 1,
      anon_sym_LPAREN2,
    ACTIONS(13822), 1,
      sym_raw_string_delimiter,
  [266479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13824), 1,
      anon_sym_LPAREN2,
    ACTIONS(13826), 1,
      sym_raw_string_delimiter,
  [266489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13828), 1,
      anon_sym_LPAREN2,
    ACTIONS(13830), 1,
      sym_raw_string_delimiter,
  [266499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13832), 1,
      anon_sym_LPAREN2,
    ACTIONS(13834), 1,
      sym_raw_string_delimiter,
  [266509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13836), 1,
      anon_sym_LPAREN2,
    ACTIONS(13838), 1,
      sym_raw_string_delimiter,
  [266519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13840), 1,
      anon_sym_LPAREN2,
    ACTIONS(13842), 1,
      sym_raw_string_delimiter,
  [266529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13844), 1,
      anon_sym_LPAREN2,
    ACTIONS(13846), 1,
      sym_raw_string_delimiter,
  [266539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12780), 1,
      anon_sym_LPAREN2,
    STATE(899), 1,
      sym_condition_clause,
  [266549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9978), 1,
      anon_sym_LBRACE,
    STATE(3726), 1,
      sym_requirement_seq,
  [266559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13848), 1,
      anon_sym_if,
    ACTIONS(13850), 1,
      anon_sym_for,
  [266569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5096), 1,
      anon_sym_DOT_DOT_DOT,
  [266576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13852), 1,
      anon_sym_SEMI,
  [266583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13854), 1,
      anon_sym_RPAREN,
  [266590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13856), 1,
      anon_sym_RPAREN,
  [266597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_RBRACE,
  [266604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9298), 1,
      anon_sym_COLON,
  [266611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13858), 1,
      anon_sym_RPAREN,
  [266618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13860), 1,
      anon_sym_SEMI,
  [266625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_RPAREN,
  [266632] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13864), 1,
      aux_sym_preproc_include_token2,
  [266639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13866), 1,
      aux_sym_preproc_if_token2,
  [266646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13868), 1,
      anon_sym_DQUOTE,
  [266653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13870), 1,
      anon_sym_SEMI,
  [266660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13872), 1,
      anon_sym_RPAREN,
  [266667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13874), 1,
      anon_sym_RBRACE,
  [266674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13876), 1,
      anon_sym_SEMI,
  [266681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      aux_sym_preproc_if_token2,
  [266688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11759), 1,
      anon_sym_SEMI,
  [266695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13880), 1,
      anon_sym_RPAREN,
  [266702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13882), 1,
      sym_identifier,
  [266709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13884), 1,
      aux_sym_preproc_if_token2,
  [266716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13886), 1,
      anon_sym_SEMI,
  [266723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13888), 1,
      sym_identifier,
  [266730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13890), 1,
      sym_identifier,
  [266737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13892), 1,
      anon_sym_DQUOTE,
  [266744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13894), 1,
      aux_sym_preproc_if_token2,
  [266751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13896), 1,
      anon_sym_RPAREN,
  [266758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13898), 1,
      anon_sym_STAR,
  [266765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13900), 1,
      anon_sym_SEMI,
  [266772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5336), 1,
      anon_sym_SEMI,
  [266779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13902), 1,
      anon_sym_RPAREN,
  [266786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13904), 1,
      aux_sym_preproc_if_token2,
  [266793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13906), 1,
      anon_sym_RPAREN,
  [266800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13908), 1,
      sym_raw_string_delimiter,
  [266807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13910), 1,
      anon_sym_SEMI,
  [266814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13912), 1,
      anon_sym_SEMI,
  [266821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13914), 1,
      sym_auto,
  [266828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12284), 1,
      anon_sym_SEMI,
  [266835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9290), 1,
      anon_sym_SEMI,
  [266842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9334), 1,
      anon_sym_COLON,
  [266849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13916), 1,
      anon_sym_RPAREN,
  [266856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13918), 1,
      sym_raw_string_delimiter,
  [266863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13920), 1,
      anon_sym_SEMI,
  [266870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 1,
      anon_sym_SEMI,
  [266877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13922), 1,
      sym_identifier,
  [266884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13924), 1,
      anon_sym_RPAREN,
  [266891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13926), 1,
      anon_sym_SEMI,
  [266898] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13257), 1,
      aux_sym_preproc_include_token2,
  [266905] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13928), 1,
      aux_sym_preproc_include_token2,
  [266912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13930), 1,
      aux_sym_preproc_if_token2,
  [266919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13932), 1,
      anon_sym_SEMI,
  [266926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13934), 1,
      aux_sym_preproc_if_token2,
  [266933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13936), 1,
      anon_sym_DQUOTE,
  [266940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13938), 1,
      anon_sym_SEMI,
  [266947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13940), 1,
      anon_sym_DQUOTE,
  [266954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13942), 1,
      anon_sym_RPAREN,
  [266961] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13454), 1,
      aux_sym_preproc_include_token2,
  [266968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13944), 1,
      anon_sym_RPAREN,
  [266975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13946), 1,
      sym_identifier,
  [266982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13948), 1,
      sym_identifier,
  [266989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13950), 1,
      anon_sym_RPAREN,
  [266996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13952), 1,
      sym_identifier,
  [267003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12270), 1,
      anon_sym_SEMI,
  [267010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13954), 1,
      aux_sym_preproc_if_token2,
  [267017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13956), 1,
      anon_sym_RPAREN,
  [267024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13958), 1,
      anon_sym_RPAREN,
  [267031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13960), 1,
      anon_sym_LPAREN2,
  [267038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_bitand,
  [267045] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13964), 1,
      aux_sym_preproc_include_token2,
  [267052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13966), 1,
      sym_identifier,
  [267059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13968), 1,
      anon_sym_DQUOTE,
  [267066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13970), 1,
      anon_sym_COLON,
  [267073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6145), 1,
      anon_sym_SEMI,
  [267080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13972), 1,
      anon_sym_SEMI,
  [267087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13974), 1,
      anon_sym_SEMI,
  [267094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13976), 1,
      anon_sym_STAR,
  [267101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13978), 1,
      anon_sym_RBRACE,
  [267108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13980), 1,
      sym_identifier,
  [267115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13982), 1,
      aux_sym_preproc_if_token2,
  [267122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13984), 1,
      anon_sym_RPAREN,
  [267129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13986), 1,
      anon_sym_SEMI,
  [267136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13988), 1,
      anon_sym_SEMI,
  [267143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5369), 1,
      anon_sym_SEMI,
  [267150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13990), 1,
      anon_sym_SEMI,
  [267157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13992), 1,
      anon_sym_RPAREN,
  [267164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13994), 1,
      anon_sym_RPAREN,
  [267171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13996), 1,
      sym_auto,
  [267178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13998), 1,
      anon_sym_LPAREN2,
  [267185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14000), 1,
      anon_sym_RPAREN,
  [267192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14002), 1,
      sym_identifier,
  [267199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14004), 1,
      anon_sym_SEMI,
  [267206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9330), 1,
      anon_sym_COLON,
  [267213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PLUS,
  [267220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14006), 1,
      anon_sym_RPAREN,
  [267227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14008), 1,
      anon_sym_RPAREN,
  [267234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14010), 1,
      anon_sym_RPAREN,
  [267241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14012), 1,
      anon_sym_RPAREN,
  [267248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14014), 1,
      anon_sym_LPAREN2,
  [267255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14016), 1,
      anon_sym_RPAREN,
  [267262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13684), 1,
      anon_sym_RBRACE,
  [267269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14018), 1,
      anon_sym_SEMI,
  [267276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14020), 1,
      anon_sym_SEMI,
  [267283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14022), 1,
      anon_sym_SEMI,
  [267290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_AMP,
  [267297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14024), 1,
      anon_sym_SEMI,
  [267304] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10362), 1,
      aux_sym_preproc_include_token2,
  [267311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14026), 1,
      anon_sym_LPAREN2,
  [267318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14028), 1,
      anon_sym_SEMI,
  [267325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14030), 1,
      anon_sym_SEMI,
  [267332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PERCENT,
  [267339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14032), 1,
      anon_sym_RPAREN,
  [267346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14034), 1,
      anon_sym_RPAREN,
  [267353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14036), 1,
      sym_identifier,
  [267360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11786), 1,
      anon_sym_SEMI,
  [267367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14038), 1,
      anon_sym_STAR,
  [267374] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14040), 1,
      aux_sym_preproc_include_token2,
  [267381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14042), 1,
      anon_sym_RPAREN,
  [267388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14044), 1,
      anon_sym_RPAREN,
  [267395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14046), 1,
      anon_sym_RPAREN,
  [267402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14048), 1,
      anon_sym_RPAREN,
  [267409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9125), 1,
      anon_sym_SEMI,
  [267416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_RBRACE,
  [267423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14050), 1,
      anon_sym_SEMI,
  [267430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14052), 1,
      sym_identifier,
  [267437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14054), 1,
      anon_sym_RPAREN,
  [267444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9411), 1,
      anon_sym_RPAREN,
  [267451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_or,
  [267458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14056), 1,
      aux_sym_preproc_if_token2,
  [267465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14058), 1,
      anon_sym_SEMI,
  [267472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14060), 1,
      anon_sym_SEMI,
  [267479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14062), 1,
      sym_identifier,
  [267486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14064), 1,
      anon_sym_SEMI,
  [267493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14066), 1,
      anon_sym_SEMI,
  [267500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9006), 1,
      anon_sym_RBRACE,
  [267507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14068), 1,
      sym_identifier,
  [267514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14070), 1,
      anon_sym_DQUOTE,
  [267521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14072), 1,
      anon_sym_RPAREN,
  [267528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14074), 1,
      anon_sym_SEMI,
  [267535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14076), 1,
      anon_sym_SEMI,
  [267542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14078), 1,
      anon_sym_SEMI,
  [267549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14080), 1,
      anon_sym_SEMI,
  [267556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14082), 1,
      anon_sym_RPAREN,
  [267563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14084), 1,
      sym_raw_string_delimiter,
  [267570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11004), 1,
      sym_identifier,
  [267577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14086), 1,
      anon_sym_RPAREN,
  [267584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_RBRACE,
  [267591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14088), 1,
      anon_sym_RPAREN,
  [267598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14090), 1,
      anon_sym_RPAREN,
  [267605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11835), 1,
      anon_sym_SEMI,
  [267612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_and,
  [267619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9489), 1,
      anon_sym_RPAREN,
  [267626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14092), 1,
      anon_sym_RPAREN,
  [267633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14094), 1,
      sym_identifier,
  [267640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      anon_sym_RBRACE,
  [267647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14096), 1,
      anon_sym_RPAREN,
  [267654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14098), 1,
      anon_sym_SEMI,
  [267661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_bitor,
  [267668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_EQ_EQ,
  [267675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14100), 1,
      sym_identifier,
  [267682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13626), 1,
      anon_sym_RBRACE,
  [267689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9324), 1,
      anon_sym_SEMI,
  [267696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14102), 1,
      anon_sym_SEMI,
  [267703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14104), 1,
      anon_sym_RPAREN,
  [267710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14106), 1,
      anon_sym_STAR,
  [267717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14108), 1,
      aux_sym_preproc_if_token2,
  [267724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14110), 1,
      anon_sym_SEMI,
  [267731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14112), 1,
      anon_sym_COLON,
  [267738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14114), 1,
      anon_sym_SEMI,
  [267745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12304), 1,
      anon_sym_SEMI,
  [267752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11937), 1,
      anon_sym_EQ,
  [267759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14116), 1,
      anon_sym_RPAREN,
  [267766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14118), 1,
      anon_sym_RPAREN,
  [267773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14120), 1,
      sym_identifier,
  [267780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14122), 1,
      anon_sym_RPAREN,
  [267787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14124), 1,
      anon_sym_SEMI,
  [267794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14126), 1,
      aux_sym_preproc_if_token2,
  [267801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14128), 1,
      anon_sym_SEMI,
  [267808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14130), 1,
      sym_identifier,
  [267815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14132), 1,
      sym_auto,
  [267822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14134), 1,
      anon_sym_LPAREN2,
  [267829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14136), 1,
      sym_identifier,
  [267836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9229), 1,
      anon_sym_COLON,
  [267843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14138), 1,
      anon_sym_RPAREN,
  [267850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9274), 1,
      anon_sym_SEMI,
  [267857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14140), 1,
      anon_sym_RPAREN,
  [267864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_BANG_EQ,
  [267871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14142), 1,
      anon_sym_RPAREN,
  [267878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14144), 1,
      sym_identifier,
  [267885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14146), 1,
      anon_sym_SEMI,
  [267892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14148), 1,
      sym_identifier,
  [267899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14150), 1,
      anon_sym_SEMI,
  [267906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14152), 1,
      anon_sym_SEMI,
  [267913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14154), 1,
      anon_sym_DQUOTE,
  [267920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14156), 1,
      anon_sym_SEMI,
  [267927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14158), 1,
      anon_sym_RPAREN,
  [267934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      anon_sym_LBRACE,
  [267941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14160), 1,
      sym_identifier,
  [267948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13704), 1,
      anon_sym_RBRACE,
  [267955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_not_eq,
  [267962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14162), 1,
      anon_sym_COLON,
  [267969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14164), 1,
      anon_sym_RPAREN,
  [267976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14166), 1,
      anon_sym_SEMI,
  [267983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14168), 1,
      anon_sym_COLON,
  [267990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14170), 1,
      ts_builtin_sym_end,
  [267997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_xor,
  [268004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14172), 1,
      anon_sym_DQUOTE,
  [268011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8086), 1,
      sym_identifier,
  [268018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14174), 1,
      sym_identifier,
  [268025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14176), 1,
      sym_identifier,
  [268032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14178), 1,
      anon_sym_SEMI,
  [268039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14180), 1,
      anon_sym_RPAREN,
  [268046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6147), 1,
      anon_sym_SEMI,
  [268053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14182), 1,
      anon_sym_RPAREN,
  [268060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14184), 1,
      anon_sym_SEMI,
  [268067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14186), 1,
      anon_sym_RPAREN,
  [268074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14188), 1,
      sym_raw_string_delimiter,
  [268081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14190), 1,
      anon_sym_RPAREN,
  [268088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14192), 1,
      sym_identifier,
  [268095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14194), 1,
      anon_sym_RPAREN,
  [268102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14196), 1,
      anon_sym_DQUOTE,
  [268109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_GT,
  [268116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12414), 1,
      anon_sym_SEMI,
  [268123] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(12766), 1,
      aux_sym_preproc_include_token2,
  [268130] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14198), 1,
      aux_sym_preproc_include_token2,
  [268137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14200), 1,
      anon_sym_STAR,
  [268144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14202), 1,
      anon_sym_EQ,
  [268151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14204), 1,
      anon_sym_LBRACE,
  [268158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14206), 1,
      anon_sym_RPAREN,
  [268165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14208), 1,
      anon_sym_RPAREN,
  [268172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14210), 1,
      anon_sym_STAR,
  [268179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14212), 1,
      anon_sym_SEMI,
  [268186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14214), 1,
      anon_sym_COLON,
  [268193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14216), 1,
      anon_sym_SEMI,
  [268200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14218), 1,
      aux_sym_preproc_if_token2,
  [268207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14220), 1,
      sym_identifier,
  [268214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14222), 1,
      anon_sym_RPAREN,
  [268221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11323), 1,
      anon_sym_RBRACE,
  [268228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14224), 1,
      anon_sym_SEMI,
  [268235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14226), 1,
      anon_sym_DQUOTE,
  [268242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14228), 1,
      anon_sym_LPAREN2,
  [268249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14230), 1,
      aux_sym_preproc_if_token2,
  [268256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5129), 1,
      anon_sym_DOT_DOT_DOT,
  [268263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14232), 1,
      anon_sym_RPAREN,
  [268270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14234), 1,
      sym_identifier,
  [268277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14236), 1,
      anon_sym_SEMI,
  [268284] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14238), 1,
      aux_sym_preproc_include_token2,
  [268291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12745), 1,
      anon_sym_COLON_COLON,
  [268298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14240), 1,
      anon_sym_RPAREN,
  [268305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14242), 1,
      sym_identifier,
  [268312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14244), 1,
      anon_sym_RPAREN,
  [268319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14246), 1,
      aux_sym_preproc_if_token2,
  [268326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14248), 1,
      anon_sym_RPAREN,
  [268333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14250), 1,
      anon_sym_RPAREN,
  [268340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14252), 1,
      anon_sym_RPAREN,
  [268347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11337), 1,
      anon_sym_LBRACE,
  [268354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9288), 1,
      anon_sym_SEMI,
  [268361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6161), 1,
      anon_sym_SEMI,
  [268368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14254), 1,
      anon_sym_SEMI,
  [268375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9294), 1,
      anon_sym_RPAREN,
  [268382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14256), 1,
      anon_sym_RPAREN,
  [268389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_GT_EQ,
  [268396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14258), 1,
      anon_sym_EQ,
  [268403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14260), 1,
      sym_identifier,
  [268410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14262), 1,
      sym_identifier,
  [268417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_CARET_EQ,
  [268424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11794), 1,
      anon_sym_SEMI,
  [268431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_GT_GT,
  [268438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14264), 1,
      sym_identifier,
  [268445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14266), 1,
      anon_sym_SEMI,
  [268452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14268), 1,
      anon_sym_RPAREN,
  [268459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5075), 1,
      anon_sym_DOT_DOT_DOT,
  [268466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13630), 1,
      anon_sym_RBRACE,
  [268473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14270), 1,
      anon_sym_RPAREN,
  [268480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14272), 1,
      anon_sym_RPAREN,
  [268487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14274), 1,
      sym_raw_string_delimiter,
  [268494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8916), 1,
      anon_sym_SEMI,
  [268501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14276), 1,
      sym_identifier,
  [268508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9385), 1,
      anon_sym_RPAREN,
  [268515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14278), 1,
      sym_identifier,
  [268522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14280), 1,
      anon_sym_SEMI,
  [268529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14282), 1,
      aux_sym_preproc_if_token2,
  [268536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      sym_identifier,
  [268543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14284), 1,
      anon_sym_SEMI,
  [268550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14286), 1,
      anon_sym_SEMI,
  [268557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14288), 1,
      anon_sym_SEMI,
  [268564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14290), 1,
      anon_sym_RPAREN,
  [268571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14292), 1,
      anon_sym_DQUOTE,
  [268578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14294), 1,
      sym_auto,
  [268585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9493), 1,
      anon_sym_RPAREN,
  [268592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      anon_sym_LBRACE,
  [268599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11345), 1,
      anon_sym_RBRACE,
  [268606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14296), 1,
      anon_sym_RPAREN,
  [268613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14298), 1,
      anon_sym_LPAREN2,
  [268620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14300), 1,
      anon_sym_SEMI,
  [268627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14302), 1,
      anon_sym_SEMI,
  [268634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14304), 1,
      anon_sym_SEMI,
  [268641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14306), 1,
      anon_sym_RPAREN,
  [268648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9227), 1,
      anon_sym_SEMI,
  [268655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14308), 1,
      anon_sym_RPAREN,
  [268662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14310), 1,
      anon_sym_SEMI,
  [268669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14312), 1,
      anon_sym_SEMI,
  [268676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9264), 1,
      anon_sym_SEMI,
  [268683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9254), 1,
      anon_sym_RPAREN,
  [268690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14314), 1,
      anon_sym_RPAREN,
  [268697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14316), 1,
      anon_sym_SEMI,
  [268704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14318), 1,
      anon_sym_RPAREN,
  [268711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14320), 1,
      anon_sym_RPAREN,
  [268718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14322), 1,
      anon_sym_LPAREN2,
  [268725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14324), 1,
      anon_sym_RPAREN,
  [268732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_CARET,
  [268739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14326), 1,
      anon_sym_SEMI,
  [268746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9509), 1,
      anon_sym_RPAREN,
  [268753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6175), 1,
      anon_sym_SEMI,
  [268760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14328), 1,
      sym_auto,
  [268767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7578), 1,
      anon_sym_RPAREN,
  [268774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14330), 1,
      anon_sym_RPAREN,
  [268781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14332), 1,
      anon_sym_SEMI,
  [268788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14334), 1,
      anon_sym_SEMI,
  [268795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14336), 1,
      anon_sym_SEMI,
  [268802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9223), 1,
      anon_sym_COLON,
  [268809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14338), 1,
      anon_sym_RPAREN,
  [268816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14340), 1,
      sym_raw_string_delimiter,
  [268823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_EQ,
  [268830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14342), 1,
      sym_auto,
  [268837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14344), 1,
      anon_sym_DQUOTE,
  [268844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14346), 1,
      anon_sym_SEMI,
  [268851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14348), 1,
      anon_sym_RPAREN,
  [268858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_LT_EQ,
  [268865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12465), 1,
      anon_sym_SEMI,
  [268872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14350), 1,
      anon_sym_LPAREN2,
  [268879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13720), 1,
      anon_sym_RBRACE,
  [268886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14352), 1,
      anon_sym_RPAREN,
  [268893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14354), 1,
      sym_identifier,
  [268900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14356), 1,
      anon_sym_RPAREN,
  [268907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14358), 1,
      anon_sym_COLON,
  [268914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5070), 1,
      anon_sym_DOT_DOT_DOT,
  [268921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14360), 1,
      anon_sym_SEMI,
  [268928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14362), 1,
      sym_raw_string_delimiter,
  [268935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14364), 1,
      anon_sym_DQUOTE,
  [268942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14366), 1,
      anon_sym_SEMI,
  [268949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14368), 1,
      sym_identifier,
  [268956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14370), 1,
      anon_sym_RBRACK,
  [268963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7870), 1,
      sym_identifier,
  [268970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14372), 1,
      anon_sym_LPAREN2,
  [268977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14374), 1,
      anon_sym_STAR,
  [268984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14376), 1,
      anon_sym_SEMI,
  [268991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14378), 1,
      anon_sym_RPAREN,
  [268998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5067), 1,
      anon_sym_DOT_DOT_DOT,
  [269005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14380), 1,
      anon_sym_SEMI,
  [269012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14382), 1,
      sym_raw_string_delimiter,
  [269019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14384), 1,
      anon_sym_RPAREN,
  [269026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14386), 1,
      anon_sym_SEMI,
  [269033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14388), 1,
      anon_sym_STAR,
  [269040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14390), 1,
      anon_sym_DQUOTE,
  [269047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14392), 1,
      anon_sym_LPAREN2,
  [269054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14394), 1,
      anon_sym_RPAREN,
  [269061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14396), 1,
      sym_raw_string_delimiter,
  [269068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5080), 1,
      anon_sym_DOT_DOT_DOT,
  [269075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_DOT_STAR,
  [269082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14398), 1,
      anon_sym_RPAREN,
  [269089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14400), 1,
      sym_raw_string_delimiter,
  [269096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14402), 1,
      anon_sym_SEMI,
  [269103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14404), 1,
      anon_sym_RPAREN,
  [269110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14406), 1,
      anon_sym_RPAREN,
  [269117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14408), 1,
      sym_raw_string_delimiter,
  [269124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14410), 1,
      anon_sym_RPAREN,
  [269131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14412), 1,
      sym_raw_string_delimiter,
  [269138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14414), 1,
      anon_sym_RPAREN,
  [269145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14416), 1,
      sym_raw_string_delimiter,
  [269152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14418), 1,
      anon_sym_RPAREN,
  [269159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14420), 1,
      sym_raw_string_delimiter,
  [269166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14422), 1,
      anon_sym_RPAREN,
  [269173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14424), 1,
      sym_raw_string_delimiter,
  [269180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14426), 1,
      anon_sym_RPAREN,
  [269187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14428), 1,
      sym_raw_string_delimiter,
  [269194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14430), 1,
      sym_identifier,
  [269201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7692), 1,
      anon_sym_RPAREN,
  [269208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5090), 1,
      anon_sym_DOT_DOT_DOT,
  [269215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14432), 1,
      anon_sym_LPAREN2,
  [269222] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14434), 1,
      aux_sym_preproc_include_token2,
  [269229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14436), 1,
      anon_sym_LPAREN2,
  [269236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14438), 1,
      anon_sym_LPAREN2,
  [269243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14440), 1,
      anon_sym_LPAREN2,
  [269250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11852), 1,
      anon_sym_SEMI,
  [269257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14442), 1,
      sym_identifier,
  [269264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14444), 1,
      anon_sym_LPAREN2,
  [269271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14446), 1,
      aux_sym_preproc_if_token2,
  [269278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14448), 1,
      anon_sym_LPAREN2,
  [269285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5093), 1,
      anon_sym_DOT_DOT_DOT,
  [269292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14450), 1,
      anon_sym_SEMI,
  [269299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14452), 1,
      aux_sym_preproc_if_token2,
  [269306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14454), 1,
      anon_sym_SEMI,
  [269313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14456), 1,
      anon_sym_RPAREN,
  [269320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14458), 1,
      anon_sym_LBRACE,
  [269327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14460), 1,
      anon_sym_SEMI,
  [269334] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14462), 1,
      aux_sym_preproc_include_token2,
  [269341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13016), 1,
      anon_sym_LBRACE,
  [269348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14464), 1,
      anon_sym_COLON,
  [269355] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14466), 1,
      aux_sym_preproc_include_token2,
  [269362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5112), 1,
      anon_sym_DOT_DOT_DOT,
  [269369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14468), 1,
      anon_sym_RPAREN,
  [269376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14470), 1,
      sym_identifier,
  [269383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14472), 1,
      anon_sym_while,
  [269390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11959), 1,
      anon_sym_LBRACE,
  [269397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14474), 1,
      anon_sym_LPAREN2,
  [269404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14476), 1,
      anon_sym_RPAREN,
  [269411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14478), 1,
      anon_sym_SEMI,
  [269418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14480), 1,
      anon_sym_RPAREN,
  [269425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14482), 1,
      anon_sym_RPAREN,
  [269432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14484), 1,
      anon_sym_RBRACE,
  [269439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14486), 1,
      anon_sym_EQ,
  [269446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14488), 1,
      sym_raw_string_content,
  [269453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14490), 1,
      aux_sym_preproc_if_token2,
  [269460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14492), 1,
      anon_sym_RPAREN,
  [269467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14494), 1,
      anon_sym_RPAREN,
  [269474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14496), 1,
      anon_sym_STAR,
  [269481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14498), 1,
      anon_sym_LPAREN2,
  [269488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14500), 1,
      anon_sym_RPAREN,
  [269495] = 2,
    ACTIONS(6394), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10226), 1,
      sym_comment,
  [269502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9260), 1,
      anon_sym_SEMI,
  [269509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12741), 1,
      anon_sym_SEMI,
  [269516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5064), 1,
      anon_sym_DOT_DOT_DOT,
  [269523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14502), 1,
      anon_sym_STAR,
  [269530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14504), 1,
      anon_sym_RPAREN,
  [269537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14506), 1,
      anon_sym_SEMI,
  [269544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14508), 1,
      sym_identifier,
  [269551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9497), 1,
      anon_sym_RPAREN,
  [269558] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14510), 1,
      aux_sym_preproc_include_token2,
  [269565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11361), 1,
      anon_sym_RBRACE,
  [269572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14512), 1,
      sym_identifier,
  [269579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14514), 1,
      anon_sym_RPAREN,
  [269586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14516), 1,
      anon_sym_COMMA,
  [269593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5083), 1,
      anon_sym_DOT_DOT_DOT,
  [269600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5103), 1,
      anon_sym_DOT_DOT_DOT,
  [269607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11790), 1,
      anon_sym_SEMI,
  [269614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14518), 1,
      anon_sym_SEMI,
  [269621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_COLON_COLON,
  [269628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11822), 1,
      anon_sym_LBRACE,
  [269635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9282), 1,
      anon_sym_COLON,
  [269642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9286), 1,
      anon_sym_COLON,
  [269649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14520), 1,
      anon_sym_SLASH,
  [269656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14522), 1,
      aux_sym_preproc_if_token2,
  [269663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14524), 1,
      anon_sym_RPAREN,
  [269670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14526), 1,
      sym_auto,
  [269677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14528), 1,
      anon_sym_SEMI,
  [269684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14530), 1,
      anon_sym_RPAREN,
  [269691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14532), 1,
      anon_sym_SEMI,
  [269698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12195), 1,
      anon_sym_COLON,
  [269705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14534), 1,
      anon_sym_RPAREN,
  [269712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13734), 1,
      anon_sym_RBRACE,
  [269719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14536), 1,
      anon_sym_RPAREN,
  [269726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_LT,
  [269733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14538), 1,
      anon_sym_RPAREN,
  [269740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9300), 1,
      anon_sym_SEMI,
  [269747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14540), 1,
      anon_sym_RPAREN,
  [269754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14542), 1,
      anon_sym_DQUOTE,
  [269761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14544), 1,
      anon_sym_RPAREN,
  [269768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14546), 1,
      aux_sym_preproc_if_token2,
  [269775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_DASH_GT_STAR,
  [269782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14548), 1,
      anon_sym_SEMI,
  [269789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14550), 1,
      anon_sym_COLON,
  [269796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14552), 1,
      aux_sym_preproc_if_token2,
  [269803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14554), 1,
      anon_sym_DQUOTE,
  [269810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14556), 1,
      anon_sym_while,
  [269817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_LT_LT,
  [269824] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14558), 1,
      aux_sym_preproc_include_token2,
  [269831] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14560), 1,
      aux_sym_preproc_include_token2,
  [269838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14562), 1,
      sym_identifier,
  [269845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11798), 1,
      anon_sym_SEMI,
  [269852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9350), 1,
      anon_sym_RPAREN,
  [269859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14564), 1,
      anon_sym_STAR,
  [269866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14566), 1,
      aux_sym_preproc_if_token2,
  [269873] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(13044), 1,
      aux_sym_preproc_include_token2,
  [269880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14568), 1,
      aux_sym_preproc_if_token2,
  [269887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9302), 1,
      anon_sym_SEMI,
  [269894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14570), 1,
      anon_sym_LPAREN2,
  [269901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14572), 1,
      anon_sym_SEMI,
  [269908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14574), 1,
      anon_sym_RPAREN,
  [269915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14576), 1,
      anon_sym_DOT_DOT_DOT,
  [269922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      anon_sym_COLON,
  [269929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PIPE_PIPE,
  [269936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14581), 1,
      anon_sym_RPAREN,
  [269943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      aux_sym_preproc_if_token2,
  [269950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8048), 1,
      sym_identifier,
  [269957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      anon_sym_SEMI,
  [269964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      anon_sym_RPAREN,
  [269971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      anon_sym_SEMI,
  [269978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      anon_sym_RPAREN,
  [269985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      anon_sym_DOT_DOT_DOT,
  [269992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9501), 1,
      anon_sym_RPAREN,
  [269999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      anon_sym_SEMI,
  [270006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13742), 1,
      anon_sym_RBRACE,
  [270013] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14597), 1,
      aux_sym_preproc_include_token2,
  [270020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      sym_identifier,
  [270027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      anon_sym_SEMI,
  [270034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11804), 1,
      anon_sym_LBRACE,
  [270041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      aux_sym_preproc_if_token2,
  [270048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      anon_sym_SEMI,
  [270055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12262), 1,
      anon_sym_SEMI,
  [270062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      anon_sym_RPAREN,
  [270069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      aux_sym_preproc_if_token2,
  [270076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      anon_sym_RPAREN,
  [270083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      anon_sym_DQUOTE,
  [270090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_RPAREN,
  [270097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14617), 1,
      anon_sym_RPAREN,
  [270104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12300), 1,
      anon_sym_SEMI,
  [270111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14619), 1,
      anon_sym_DQUOTE,
  [270118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14621), 1,
      anon_sym_RPAREN,
  [270125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 1,
      aux_sym_preproc_if_token2,
  [270132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9368), 1,
      anon_sym_RPAREN,
  [270139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      anon_sym_SEMI,
  [270146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      aux_sym_preproc_if_token2,
  [270153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14629), 1,
      aux_sym_preproc_if_token2,
  [270160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9087), 1,
      anon_sym_RBRACE,
  [270167] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14631), 1,
      aux_sym_preproc_include_token2,
  [270174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9932), 1,
      anon_sym_LBRACE,
  [270181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13560), 1,
      anon_sym_RPAREN,
  [270188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14633), 1,
      anon_sym_SEMI,
  [270195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14635), 1,
      anon_sym_SEMI,
  [270202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14637), 1,
      anon_sym_RPAREN,
  [270209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      anon_sym_SEMI,
  [270216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_AMP_AMP,
  [270223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14641), 1,
      anon_sym_SEMI,
  [270230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14643), 1,
      anon_sym_RPAREN,
  [270237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      aux_sym_preproc_if_token2,
  [270244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_STAR_EQ,
  [270251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14647), 1,
      anon_sym_SEMI,
  [270258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11343), 1,
      anon_sym_LBRACE,
  [270265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9503), 1,
      anon_sym_RPAREN,
  [270272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14649), 1,
      aux_sym_preproc_if_token2,
  [270279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_SEMI,
  [270286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym_COLON,
  [270293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14653), 1,
      anon_sym_LPAREN2,
  [270300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9215), 1,
      anon_sym_SEMI,
  [270307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9332), 1,
      anon_sym_RPAREN,
  [270314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14655), 1,
      anon_sym_RPAREN,
  [270321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      anon_sym_SEMI,
  [270328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14659), 1,
      anon_sym_DQUOTE,
  [270335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      anon_sym_DQUOTE,
  [270342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12296), 1,
      anon_sym_SEMI,
  [270349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14663), 1,
      anon_sym_SEMI,
  [270356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9225), 1,
      anon_sym_SEMI,
  [270363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14665), 1,
      anon_sym_DQUOTE,
  [270370] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14667), 1,
      aux_sym_preproc_include_token2,
  [270377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_SLASH_EQ,
  [270384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14669), 1,
      anon_sym_SEMI,
  [270391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14671), 1,
      sym_identifier,
  [270398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PERCENT_EQ,
  [270405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9244), 1,
      anon_sym_SEMI,
  [270412] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14673), 1,
      aux_sym_preproc_include_token2,
  [270419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14675), 1,
      sym_identifier,
  [270426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 1,
      anon_sym_SEMI,
  [270433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9266), 1,
      anon_sym_SEMI,
  [270440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14679), 1,
      anon_sym_SEMI,
  [270447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9123), 1,
      anon_sym_RPAREN,
  [270454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 1,
      sym_identifier,
  [270461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9455), 1,
      anon_sym_RPAREN,
  [270468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9063), 1,
      anon_sym_RBRACE,
  [270475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9213), 1,
      anon_sym_RPAREN,
  [270482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PLUS_EQ,
  [270489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14683), 1,
      anon_sym_LPAREN2,
  [270496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14685), 1,
      anon_sym_RPAREN,
  [270503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11335), 1,
      anon_sym_RBRACE,
  [270510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      anon_sym_RPAREN,
  [270517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14689), 1,
      anon_sym_RPAREN,
  [270524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14691), 1,
      anon_sym_RPAREN,
  [270531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12694), 1,
      anon_sym_SEMI,
  [270538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14693), 1,
      anon_sym_DQUOTE,
  [270545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14695), 1,
      anon_sym_DQUOTE,
  [270552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14697), 1,
      anon_sym_RBRACE,
  [270559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14699), 1,
      anon_sym_SEMI,
  [270566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14701), 1,
      anon_sym_RPAREN,
  [270573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14703), 1,
      anon_sym_private,
  [270580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11291), 1,
      anon_sym_RBRACE,
  [270587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14705), 1,
      anon_sym_LBRACE,
  [270594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14707), 1,
      anon_sym_RPAREN,
  [270601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14709), 1,
      aux_sym_preproc_if_token2,
  [270608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14711), 1,
      sym_identifier,
  [270615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14713), 1,
      sym_identifier,
  [270622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14715), 1,
      anon_sym_RPAREN,
  [270629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14717), 1,
      anon_sym_RPAREN,
  [270636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14719), 1,
      anon_sym_RPAREN,
  [270643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14721), 1,
      anon_sym_RPAREN,
  [270650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14723), 1,
      aux_sym_preproc_if_token2,
  [270657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14725), 1,
      sym_raw_string_content,
  [270664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14727), 1,
      anon_sym_RPAREN,
  [270671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14729), 1,
      anon_sym_LPAREN2,
  [270678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14731), 1,
      anon_sym_LPAREN2,
  [270685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14733), 1,
      anon_sym_LPAREN2,
  [270692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14735), 1,
      anon_sym_LPAREN2,
  [270699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14737), 1,
      anon_sym_RPAREN,
  [270706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14739), 1,
      anon_sym_LPAREN2,
  [270713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12776), 1,
      anon_sym_LBRACE,
  [270720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12406), 1,
      anon_sym_SEMI,
  [270727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14741), 1,
      anon_sym_RPAREN,
  [270734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14743), 1,
      aux_sym_preproc_if_token2,
  [270741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14745), 1,
      anon_sym_RPAREN,
  [270748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14747), 1,
      anon_sym_LPAREN2,
  [270755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14749), 1,
      anon_sym_while,
  [270762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14751), 1,
      anon_sym_COLON,
  [270769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14753), 1,
      anon_sym_LPAREN2,
  [270776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14755), 1,
      sym_raw_string_content,
  [270783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14757), 1,
      aux_sym_preproc_if_token2,
  [270790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14759), 1,
      anon_sym_SEMI,
  [270797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14761), 1,
      anon_sym_EQ,
  [270804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14763), 1,
      sym_raw_string_content,
  [270811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14765), 1,
      anon_sym_STAR,
  [270818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14767), 1,
      anon_sym_LPAREN2,
  [270825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14769), 1,
      anon_sym_SEMI,
  [270832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14771), 1,
      anon_sym_DQUOTE,
  [270839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14773), 1,
      anon_sym_DQUOTE,
  [270846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14775), 1,
      aux_sym_preproc_if_token2,
  [270853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14777), 1,
      anon_sym_RPAREN,
  [270860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14779), 1,
      anon_sym_COMMA,
  [270867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9435), 1,
      anon_sym_RPAREN,
  [270874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_DASH_EQ,
  [270881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9318), 1,
      anon_sym_SEMI,
  [270888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14781), 1,
      anon_sym_RPAREN,
  [270895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14783), 1,
      anon_sym_COLON,
  [270902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9159), 1,
      anon_sym_RBRACE,
  [270909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14785), 1,
      anon_sym_LPAREN2,
  [270916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      sym_identifier,
  [270923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14787), 1,
      anon_sym_LPAREN2,
  [270930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14789), 1,
      anon_sym_LPAREN2,
  [270937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14791), 1,
      anon_sym_LPAREN2,
  [270944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14793), 1,
      anon_sym_SEMI,
  [270951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14795), 1,
      anon_sym_LPAREN2,
  [270958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14797), 1,
      anon_sym_LPAREN2,
  [270965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14799), 1,
      sym_identifier,
  [270972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14801), 1,
      anon_sym_while,
  [270979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14803), 1,
      anon_sym_SEMI,
  [270986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14805), 1,
      anon_sym_LPAREN2,
  [270993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14807), 1,
      anon_sym_SEMI,
  [271000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12316), 1,
      anon_sym_SEMI,
  [271007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14809), 1,
      anon_sym_EQ,
  [271014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14811), 1,
      sym_raw_string_content,
  [271021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9479), 1,
      anon_sym_RPAREN,
  [271028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14813), 1,
      sym_auto,
  [271035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14815), 1,
      anon_sym_COMMA,
  [271042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14817), 1,
      sym_identifier,
  [271049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9296), 1,
      anon_sym_COLON,
  [271056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14819), 1,
      anon_sym_RPAREN,
  [271063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14821), 1,
      anon_sym_RPAREN,
  [271070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14823), 1,
      anon_sym_COLON,
  [271077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14825), 1,
      sym_identifier,
  [271084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      anon_sym_COMMA,
  [271091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14827), 1,
      anon_sym_LPAREN2,
  [271098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14829), 1,
      anon_sym_LPAREN2,
  [271105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14831), 1,
      anon_sym_LPAREN2,
  [271112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8910), 1,
      anon_sym_RPAREN,
  [271119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14833), 1,
      anon_sym_LPAREN2,
  [271126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14835), 1,
      sym_identifier,
  [271133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14837), 1,
      aux_sym_preproc_if_token2,
  [271140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14839), 1,
      anon_sym_while,
  [271147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14841), 1,
      anon_sym_LPAREN2,
  [271154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14843), 1,
      anon_sym_SEMI,
  [271161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14845), 1,
      anon_sym_DQUOTE,
  [271168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14847), 1,
      anon_sym_EQ,
  [271175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14849), 1,
      sym_raw_string_content,
  [271182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14851), 1,
      anon_sym_LPAREN2,
  [271189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14853), 1,
      anon_sym_DQUOTE,
  [271196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14855), 1,
      anon_sym_COMMA,
  [271203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14857), 1,
      anon_sym_LBRACE,
  [271210] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(14859), 1,
      aux_sym_preproc_include_token2,
  [271217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14861), 1,
      anon_sym_RPAREN,
  [271224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14863), 1,
      anon_sym_COLON,
  [271231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14865), 1,
      anon_sym_SEMI,
  [271238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14867), 1,
      anon_sym_LPAREN2,
  [271245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14869), 1,
      anon_sym_LPAREN2,
  [271252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14871), 1,
      anon_sym_LPAREN2,
  [271259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14873), 1,
      anon_sym_LPAREN2,
  [271266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14875), 1,
      anon_sym_LPAREN2,
  [271273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14877), 1,
      sym_identifier,
  [271280] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10500), 1,
      aux_sym_preproc_include_token2,
  [271287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14879), 1,
      anon_sym_LPAREN2,
  [271294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_RBRACE,
  [271301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14881), 1,
      anon_sym_LPAREN2,
  [271308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14883), 1,
      anon_sym_EQ,
  [271315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14885), 1,
      sym_raw_string_content,
  [271322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14887), 1,
      sym_identifier,
  [271329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14889), 1,
      anon_sym_SEMI,
  [271336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14891), 1,
      anon_sym_COMMA,
  [271343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14893), 1,
      aux_sym_preproc_if_token2,
  [271350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11812), 1,
      anon_sym_LBRACE,
  [271357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14895), 1,
      anon_sym_RPAREN,
  [271364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14897), 1,
      anon_sym_COLON,
  [271371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9467), 1,
      anon_sym_RPAREN,
  [271378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14899), 1,
      anon_sym_LPAREN2,
  [271385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14901), 1,
      anon_sym_LPAREN2,
  [271392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14903), 1,
      anon_sym_STAR,
  [271399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14905), 1,
      anon_sym_LPAREN2,
  [271406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14907), 1,
      sym_identifier,
  [271413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9272), 1,
      anon_sym_RPAREN,
  [271420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14909), 1,
      anon_sym_SEMI,
  [271427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14911), 1,
      aux_sym_preproc_if_token2,
  [271434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14913), 1,
      anon_sym_EQ,
  [271441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14915), 1,
      sym_raw_string_content,
  [271448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11806), 1,
      anon_sym_LBRACE,
  [271455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14917), 1,
      anon_sym_DQUOTE,
  [271462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14919), 1,
      anon_sym_DQUOTE,
  [271469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11876), 1,
      anon_sym_COMMA,
  [271476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14921), 1,
      anon_sym_RPAREN,
  [271483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14923), 1,
      anon_sym_RPAREN,
  [271490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14925), 1,
      anon_sym_LPAREN2,
  [271497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14927), 1,
      anon_sym_LPAREN2,
  [271504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14929), 1,
      anon_sym_LPAREN2,
  [271511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9140), 1,
      anon_sym_RBRACE,
  [271518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14931), 1,
      sym_raw_string_content,
  [271525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6169), 1,
      anon_sym_SEMI,
  [271532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14933), 1,
      anon_sym_RPAREN,
  [271539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14935), 1,
      anon_sym_RPAREN,
  [271546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14937), 1,
      anon_sym_RPAREN,
  [271553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14939), 1,
      anon_sym_LPAREN2,
  [271560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14941), 1,
      anon_sym_LPAREN2,
  [271567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14943), 1,
      anon_sym_LPAREN2,
  [271574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11349), 1,
      anon_sym_RBRACE,
  [271581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14945), 1,
      sym_raw_string_content,
  [271588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14947), 1,
      anon_sym_RPAREN,
  [271595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14949), 1,
      anon_sym_RPAREN,
  [271602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14951), 1,
      anon_sym_LPAREN2,
  [271609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14953), 1,
      anon_sym_LPAREN2,
  [271616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14955), 1,
      anon_sym_LPAREN2,
  [271623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14957), 1,
      sym_raw_string_content,
  [271630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14959), 1,
      anon_sym_RPAREN,
  [271637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14961), 1,
      anon_sym_LPAREN2,
  [271644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14963), 1,
      sym_raw_string_content,
  [271651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14965), 1,
      anon_sym_RPAREN,
  [271658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14967), 1,
      anon_sym_LPAREN2,
  [271665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14969), 1,
      sym_raw_string_content,
  [271672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14971), 1,
      anon_sym_RPAREN,
  [271679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14973), 1,
      sym_raw_string_content,
  [271686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14975), 1,
      anon_sym_RPAREN,
  [271693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14977), 1,
      sym_raw_string_content,
  [271700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14979), 1,
      anon_sym_RPAREN,
  [271707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14981), 1,
      sym_raw_string_content,
  [271714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14983), 1,
      anon_sym_RPAREN,
  [271721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14985), 1,
      sym_raw_string_content,
  [271728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14987), 1,
      anon_sym_RPAREN,
  [271735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14989), 1,
      sym_raw_string_content,
  [271742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14991), 1,
      anon_sym_RPAREN,
  [271749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14993), 1,
      anon_sym_RBRACE,
  [271756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14995), 1,
      anon_sym_SEMI,
  [271763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14997), 1,
      anon_sym_LPAREN2,
  [271770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14999), 1,
      anon_sym_LPAREN2,
  [271777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15001), 1,
      sym_identifier,
  [271784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_STAR,
  [271791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15003), 1,
      anon_sym_RPAREN,
  [271798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13770), 1,
      anon_sym_RBRACE,
  [271805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15005), 1,
      anon_sym_SEMI,
  [271812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15007), 1,
      anon_sym_SEMI,
  [271819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15009), 1,
      anon_sym_LPAREN2,
  [271826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12481), 1,
      anon_sym_SEMI,
  [271833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15011), 1,
      aux_sym_preproc_if_token2,
  [271840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15013), 1,
      anon_sym_SEMI,
  [271847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15015), 1,
      anon_sym_DQUOTE,
  [271854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15017), 1,
      anon_sym_LPAREN2,
  [271861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15019), 1,
      anon_sym_DQUOTE,
  [271868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15021), 1,
      anon_sym_RPAREN,
  [271875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15023), 1,
      anon_sym_LPAREN2,
  [271882] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(15025), 1,
      aux_sym_preproc_include_token2,
  [271889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9248), 1,
      anon_sym_RPAREN,
  [271896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15027), 1,
      anon_sym_STAR,
  [271903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15029), 1,
      anon_sym_SEMI,
  [271910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15031), 1,
      sym_identifier,
  [271917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15033), 1,
      sym_raw_string_content,
  [271924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15035), 1,
      anon_sym_RPAREN,
  [271931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15037), 1,
      sym_identifier,
  [271938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15039), 1,
      anon_sym_RPAREN,
  [271945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15041), 1,
      sym_this,
  [271952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15043), 1,
      anon_sym_RPAREN,
  [271959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15045), 1,
      aux_sym_preproc_if_token2,
  [271966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11359), 1,
      anon_sym_RBRACE,
  [271973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15047), 1,
      anon_sym_SEMI,
  [271980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15049), 1,
      anon_sym_SEMI,
  [271987] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10492), 1,
      aux_sym_preproc_include_token2,
  [271994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15051), 1,
      sym_identifier,
  [272001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15053), 1,
      anon_sym_SEMI,
  [272008] = 2,
    ACTIONS(6410), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(10226), 1,
      sym_comment,
  [272015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15055), 1,
      anon_sym_DQUOTE,
  [272022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15057), 1,
      anon_sym_STAR,
  [272029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15059), 1,
      anon_sym_LPAREN2,
  [272036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15061), 1,
      sym_raw_string_delimiter,
  [272043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15063), 1,
      anon_sym_RPAREN,
  [272050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13776), 1,
      anon_sym_RBRACE,
  [272057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15065), 1,
      aux_sym_preproc_if_token2,
  [272064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15067), 1,
      sym_identifier,
  [272071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PIPE,
  [272078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15069), 1,
      anon_sym_LBRACE,
  [272085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12642), 1,
      anon_sym_SEMI,
  [272092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15071), 1,
      aux_sym_preproc_if_token2,
  [272099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15073), 1,
      anon_sym_RPAREN,
  [272106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15075), 1,
      anon_sym_SEMI,
  [272113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12443), 1,
      anon_sym_SEMI,
  [272120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_LT_LT_EQ,
  [272127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15077), 1,
      anon_sym_COLON,
  [272134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15079), 1,
      anon_sym_SEMI,
  [272141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15081), 1,
      aux_sym_preproc_if_token2,
  [272148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9306), 1,
      anon_sym_COLON,
  [272155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_GT_GT_EQ,
  [272162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7690), 1,
      anon_sym_RPAREN,
  [272169] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(10432), 1,
      aux_sym_preproc_include_token2,
  [272176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15083), 1,
      anon_sym_SEMI,
  [272183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9199), 1,
      anon_sym_COLON,
  [272190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15085), 1,
      anon_sym_RPAREN,
  [272197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15087), 1,
      anon_sym_SEMI,
  [272204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5227), 1,
      anon_sym_SEMI,
  [272211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15089), 1,
      anon_sym_SEMI,
  [272218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15091), 1,
      aux_sym_preproc_if_token2,
  [272225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15093), 1,
      anon_sym_LPAREN2,
  [272232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      anon_sym_SEMI,
  [272239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15095), 1,
      anon_sym_SEMI,
  [272246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15097), 1,
      anon_sym_RPAREN,
  [272253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15099), 1,
      aux_sym_preproc_if_token2,
  [272260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15101), 1,
      aux_sym_preproc_if_token2,
  [272267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15103), 1,
      sym_identifier,
  [272274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15105), 1,
      anon_sym_SEMI,
  [272281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15107), 1,
      anon_sym_LPAREN2,
  [272288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15109), 1,
      anon_sym_RPAREN,
  [272295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15111), 1,
      anon_sym_LPAREN2,
  [272302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15113), 1,
      anon_sym_SEMI,
  [272309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15115), 1,
      sym_auto,
  [272316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15117), 1,
      anon_sym_SEMI,
  [272323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15119), 1,
      anon_sym_DQUOTE,
  [272330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15121), 1,
      anon_sym_RPAREN,
  [272337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15123), 1,
      anon_sym_RPAREN,
  [272344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15125), 1,
      anon_sym_SEMI,
  [272351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9276), 1,
      anon_sym_COLON,
  [272358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9326), 1,
      anon_sym_COLON,
  [272365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15127), 1,
      anon_sym_RPAREN,
  [272372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15129), 1,
      sym_identifier,
  [272379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15131), 1,
      anon_sym_LPAREN2,
  [272386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15133), 1,
      anon_sym_LPAREN2,
  [272393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15135), 1,
      sym_identifier,
  [272400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9278), 1,
      anon_sym_RPAREN,
  [272407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15137), 1,
      sym_identifier,
  [272414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15139), 1,
      anon_sym_LBRACE,
  [272421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15141), 1,
      anon_sym_LPAREN2,
  [272428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15143), 1,
      anon_sym_SEMI,
  [272435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15145), 1,
      sym_identifier,
  [272442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15147), 1,
      sym_raw_string_content,
  [272449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_COMMA,
  [272456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15149), 1,
      sym_identifier,
  [272463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15151), 1,
      anon_sym_LPAREN2,
  [272470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_AMP_EQ,
  [272477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15153), 1,
      anon_sym_LPAREN2,
  [272484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15155), 1,
      anon_sym_LPAREN2,
  [272491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15157), 1,
      sym_identifier,
  [272498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15159), 1,
      sym_auto,
  [272505] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(15161), 1,
      aux_sym_preproc_include_token2,
  [272512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15163), 1,
      anon_sym_LPAREN2,
  [272519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15165), 1,
      sym_identifier,
  [272526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15167), 1,
      sym_raw_string_content,
  [272533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15169), 1,
      anon_sym_SEMI,
  [272540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15171), 1,
      anon_sym_DQUOTE,
  [272547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15173), 1,
      anon_sym_SEMI,
  [272554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15175), 1,
      anon_sym_LPAREN2,
  [272561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15177), 1,
      sym_identifier,
  [272568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15179), 1,
      anon_sym_RBRACK,
  [272575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15181), 1,
      aux_sym_preproc_if_token2,
  [272582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15183), 1,
      sym_identifier,
  [272589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15185), 1,
      sym_raw_string_content,
  [272596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15187), 1,
      anon_sym_SEMI,
  [272603] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(15189), 1,
      aux_sym_preproc_include_token2,
  [272610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15191), 1,
      anon_sym_LPAREN2,
  [272617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15193), 1,
      sym_identifier,
  [272624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15195), 1,
      anon_sym_RPAREN,
  [272631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15197), 1,
      sym_identifier,
  [272638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15199), 1,
      sym_identifier,
  [272645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15201), 1,
      sym_raw_string_content,
  [272652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15203), 1,
      anon_sym_SEMI,
  [272659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15205), 1,
      anon_sym_LPAREN2,
  [272666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15207), 1,
      sym_identifier,
  [272673] = 2,
    ACTIONS(10226), 1,
      sym_comment,
    ACTIONS(15209), 1,
      aux_sym_preproc_include_token2,
  [272680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15211), 1,
      sym_identifier,
  [272687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15213), 1,
      sym_raw_string_content,
  [272694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15215), 1,
      anon_sym_STAR,
  [272701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15217), 1,
      sym_identifier,
  [272708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15219), 1,
      sym_raw_string_content,
  [272715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15221), 1,
      anon_sym_COLON,
  [272722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15223), 1,
      sym_raw_string_content,
  [272729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15225), 1,
      anon_sym_LPAREN2,
  [272736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15227), 1,
      sym_raw_string_content,
  [272743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15229), 1,
      anon_sym_RPAREN,
  [272750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15231), 1,
      sym_raw_string_content,
  [272757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15233), 1,
      anon_sym_RPAREN,
  [272764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15235), 1,
      sym_raw_string_content,
  [272771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15237), 1,
      sym_identifier,
  [272778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15239), 1,
      sym_raw_string_content,
  [272785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15241), 1,
      aux_sym_preproc_if_token2,
  [272792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15243), 1,
      sym_raw_string_content,
  [272799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15245), 1,
      sym_identifier,
  [272806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15247), 1,
      sym_raw_string_content,
  [272813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_PIPE_EQ,
  [272820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15249), 1,
      sym_raw_string_content,
  [272827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15251), 1,
      sym_identifier,
  [272834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15253), 1,
      sym_raw_string_content,
  [272841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15255), 1,
      anon_sym_LPAREN2,
  [272848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15257), 1,
      anon_sym_LPAREN2,
  [272855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15259), 1,
      anon_sym_SEMI,
  [272862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15261), 1,
      anon_sym_LPAREN2,
  [272869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15263), 1,
      anon_sym_LPAREN2,
  [272876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15265), 1,
      sym_identifier,
  [272883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15267), 1,
      anon_sym_LPAREN2,
  [272890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15269), 1,
      anon_sym_LPAREN2,
  [272897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15271), 1,
      anon_sym_RPAREN,
  [272904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15273), 1,
      anon_sym_LPAREN2,
  [272911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15275), 1,
      anon_sym_LPAREN2,
  [272918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15277), 1,
      anon_sym_SEMI,
  [272925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15279), 1,
      anon_sym_LPAREN2,
  [272932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15281), 1,
      anon_sym_LPAREN2,
  [272939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15283), 1,
      anon_sym_SEMI,
  [272946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15285), 1,
      anon_sym_LPAREN2,
  [272953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15287), 1,
      anon_sym_LPAREN2,
  [272960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15289), 1,
      anon_sym_LPAREN2,
  [272967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15291), 1,
      anon_sym_LPAREN2,
  [272974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15293), 1,
      anon_sym_LPAREN2,
  [272981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15295), 1,
      anon_sym_LPAREN2,
  [272988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15297), 1,
      anon_sym_LPAREN2,
  [272995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15299), 1,
      anon_sym_LPAREN2,
  [273002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15301), 1,
      anon_sym_LPAREN2,
  [273009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15303), 1,
      anon_sym_LPAREN2,
  [273016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15305), 1,
      anon_sym_LPAREN2,
  [273023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13962), 1,
      anon_sym_DASH,
  [273030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15307), 1,
      anon_sym_RBRACE,
  [273037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15309), 1,
      anon_sym_COMMA,
  [273044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15311), 1,
      anon_sym_RPAREN,
  [273051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15313), 1,
      aux_sym_preproc_if_token2,
  [273058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15315), 1,
      anon_sym_LPAREN2,
  [273065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15317), 1,
      anon_sym_LPAREN2,
  [273072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15319), 1,
      anon_sym_LPAREN2,
  [273079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15321), 1,
      anon_sym_LPAREN2,
  [273086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15323), 1,
      anon_sym_LPAREN2,
  [273093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15325), 1,
      aux_sym_preproc_if_token2,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2844)] = 0,
  [SMALL_STATE(2845)] = 73,
  [SMALL_STATE(2846)] = 144,
  [SMALL_STATE(2847)] = 215,
  [SMALL_STATE(2848)] = 290,
  [SMALL_STATE(2849)] = 361,
  [SMALL_STATE(2850)] = 432,
  [SMALL_STATE(2851)] = 509,
  [SMALL_STATE(2852)] = 580,
  [SMALL_STATE(2853)] = 651,
  [SMALL_STATE(2854)] = 734,
  [SMALL_STATE(2855)] = 817,
  [SMALL_STATE(2856)] = 888,
  [SMALL_STATE(2857)] = 977,
  [SMALL_STATE(2858)] = 1048,
  [SMALL_STATE(2859)] = 1119,
  [SMALL_STATE(2860)] = 1190,
  [SMALL_STATE(2861)] = 1261,
  [SMALL_STATE(2862)] = 1346,
  [SMALL_STATE(2863)] = 1417,
  [SMALL_STATE(2864)] = 1488,
  [SMALL_STATE(2865)] = 1573,
  [SMALL_STATE(2866)] = 1644,
  [SMALL_STATE(2867)] = 1729,
  [SMALL_STATE(2868)] = 1808,
  [SMALL_STATE(2869)] = 1879,
  [SMALL_STATE(2870)] = 1964,
  [SMALL_STATE(2871)] = 2049,
  [SMALL_STATE(2872)] = 2120,
  [SMALL_STATE(2873)] = 2205,
  [SMALL_STATE(2874)] = 2290,
  [SMALL_STATE(2875)] = 2361,
  [SMALL_STATE(2876)] = 2440,
  [SMALL_STATE(2877)] = 2511,
  [SMALL_STATE(2878)] = 2582,
  [SMALL_STATE(2879)] = 2657,
  [SMALL_STATE(2880)] = 2728,
  [SMALL_STATE(2881)] = 2807,
  [SMALL_STATE(2882)] = 2878,
  [SMALL_STATE(2883)] = 2955,
  [SMALL_STATE(2884)] = 3030,
  [SMALL_STATE(2885)] = 3109,
  [SMALL_STATE(2886)] = 3179,
  [SMALL_STATE(2887)] = 3249,
  [SMALL_STATE(2888)] = 3319,
  [SMALL_STATE(2889)] = 3389,
  [SMALL_STATE(2890)] = 3469,
  [SMALL_STATE(2891)] = 3539,
  [SMALL_STATE(2892)] = 3609,
  [SMALL_STATE(2893)] = 3679,
  [SMALL_STATE(2894)] = 3749,
  [SMALL_STATE(2895)] = 3819,
  [SMALL_STATE(2896)] = 3899,
  [SMALL_STATE(2897)] = 3969,
  [SMALL_STATE(2898)] = 4039,
  [SMALL_STATE(2899)] = 4109,
  [SMALL_STATE(2900)] = 4179,
  [SMALL_STATE(2901)] = 4249,
  [SMALL_STATE(2902)] = 4319,
  [SMALL_STATE(2903)] = 4389,
  [SMALL_STATE(2904)] = 4459,
  [SMALL_STATE(2905)] = 4529,
  [SMALL_STATE(2906)] = 4599,
  [SMALL_STATE(2907)] = 4669,
  [SMALL_STATE(2908)] = 4739,
  [SMALL_STATE(2909)] = 4809,
  [SMALL_STATE(2910)] = 4879,
  [SMALL_STATE(2911)] = 4957,
  [SMALL_STATE(2912)] = 5027,
  [SMALL_STATE(2913)] = 5097,
  [SMALL_STATE(2914)] = 5167,
  [SMALL_STATE(2915)] = 5237,
  [SMALL_STATE(2916)] = 5307,
  [SMALL_STATE(2917)] = 5377,
  [SMALL_STATE(2918)] = 5447,
  [SMALL_STATE(2919)] = 5517,
  [SMALL_STATE(2920)] = 5587,
  [SMALL_STATE(2921)] = 5657,
  [SMALL_STATE(2922)] = 5727,
  [SMALL_STATE(2923)] = 5797,
  [SMALL_STATE(2924)] = 5867,
  [SMALL_STATE(2925)] = 5937,
  [SMALL_STATE(2926)] = 6021,
  [SMALL_STATE(2927)] = 6091,
  [SMALL_STATE(2928)] = 6161,
  [SMALL_STATE(2929)] = 6231,
  [SMALL_STATE(2930)] = 6301,
  [SMALL_STATE(2931)] = 6371,
  [SMALL_STATE(2932)] = 6455,
  [SMALL_STATE(2933)] = 6525,
  [SMALL_STATE(2934)] = 6595,
  [SMALL_STATE(2935)] = 6665,
  [SMALL_STATE(2936)] = 6735,
  [SMALL_STATE(2937)] = 6805,
  [SMALL_STATE(2938)] = 6875,
  [SMALL_STATE(2939)] = 6945,
  [SMALL_STATE(2940)] = 7015,
  [SMALL_STATE(2941)] = 7085,
  [SMALL_STATE(2942)] = 7155,
  [SMALL_STATE(2943)] = 7225,
  [SMALL_STATE(2944)] = 7295,
  [SMALL_STATE(2945)] = 7365,
  [SMALL_STATE(2946)] = 7435,
  [SMALL_STATE(2947)] = 7505,
  [SMALL_STATE(2948)] = 7575,
  [SMALL_STATE(2949)] = 7645,
  [SMALL_STATE(2950)] = 7715,
  [SMALL_STATE(2951)] = 7785,
  [SMALL_STATE(2952)] = 7855,
  [SMALL_STATE(2953)] = 7925,
  [SMALL_STATE(2954)] = 7999,
  [SMALL_STATE(2955)] = 8069,
  [SMALL_STATE(2956)] = 8139,
  [SMALL_STATE(2957)] = 8227,
  [SMALL_STATE(2958)] = 8297,
  [SMALL_STATE(2959)] = 8375,
  [SMALL_STATE(2960)] = 8445,
  [SMALL_STATE(2961)] = 8515,
  [SMALL_STATE(2962)] = 8585,
  [SMALL_STATE(2963)] = 8705,
  [SMALL_STATE(2964)] = 8825,
  [SMALL_STATE(2965)] = 8895,
  [SMALL_STATE(2966)] = 8965,
  [SMALL_STATE(2967)] = 9035,
  [SMALL_STATE(2968)] = 9105,
  [SMALL_STATE(2969)] = 9175,
  [SMALL_STATE(2970)] = 9245,
  [SMALL_STATE(2971)] = 9315,
  [SMALL_STATE(2972)] = 9385,
  [SMALL_STATE(2973)] = 9455,
  [SMALL_STATE(2974)] = 9525,
  [SMALL_STATE(2975)] = 9595,
  [SMALL_STATE(2976)] = 9665,
  [SMALL_STATE(2977)] = 9740,
  [SMALL_STATE(2978)] = 9809,
  [SMALL_STATE(2979)] = 9878,
  [SMALL_STATE(2980)] = 9951,
  [SMALL_STATE(2981)] = 10026,
  [SMALL_STATE(2982)] = 10105,
  [SMALL_STATE(2983)] = 10180,
  [SMALL_STATE(2984)] = 10249,
  [SMALL_STATE(2985)] = 10324,
  [SMALL_STATE(2986)] = 10399,
  [SMALL_STATE(2987)] = 10474,
  [SMALL_STATE(2988)] = 10547,
  [SMALL_STATE(2989)] = 10622,
  [SMALL_STATE(2990)] = 10695,
  [SMALL_STATE(2991)] = 10770,
  [SMALL_STATE(2992)] = 10839,
  [SMALL_STATE(2993)] = 10914,
  [SMALL_STATE(2994)] = 10989,
  [SMALL_STATE(2995)] = 11064,
  [SMALL_STATE(2996)] = 11137,
  [SMALL_STATE(2997)] = 11210,
  [SMALL_STATE(2998)] = 11279,
  [SMALL_STATE(2999)] = 11348,
  [SMALL_STATE(3000)] = 11417,
  [SMALL_STATE(3001)] = 11488,
  [SMALL_STATE(3002)] = 11557,
  [SMALL_STATE(3003)] = 11626,
  [SMALL_STATE(3004)] = 11695,
  [SMALL_STATE(3005)] = 11770,
  [SMALL_STATE(3006)] = 11841,
  [SMALL_STATE(3007)] = 11916,
  [SMALL_STATE(3008)] = 11989,
  [SMALL_STATE(3009)] = 12060,
  [SMALL_STATE(3010)] = 12133,
  [SMALL_STATE(3011)] = 12206,
  [SMALL_STATE(3012)] = 12279,
  [SMALL_STATE(3013)] = 12352,
  [SMALL_STATE(3014)] = 12427,
  [SMALL_STATE(3015)] = 12498,
  [SMALL_STATE(3016)] = 12571,
  [SMALL_STATE(3017)] = 12640,
  [SMALL_STATE(3018)] = 12709,
  [SMALL_STATE(3019)] = 12784,
  [SMALL_STATE(3020)] = 12853,
  [SMALL_STATE(3021)] = 12926,
  [SMALL_STATE(3022)] = 12995,
  [SMALL_STATE(3023)] = 13070,
  [SMALL_STATE(3024)] = 13138,
  [SMALL_STATE(3025)] = 13216,
  [SMALL_STATE(3026)] = 13288,
  [SMALL_STATE(3027)] = 13360,
  [SMALL_STATE(3028)] = 13432,
  [SMALL_STATE(3029)] = 13500,
  [SMALL_STATE(3030)] = 13582,
  [SMALL_STATE(3031)] = 13656,
  [SMALL_STATE(3032)] = 13774,
  [SMALL_STATE(3033)] = 13848,
  [SMALL_STATE(3034)] = 13916,
  [SMALL_STATE(3035)] = 13984,
  [SMALL_STATE(3036)] = 14060,
  [SMALL_STATE(3037)] = 14128,
  [SMALL_STATE(3038)] = 14246,
  [SMALL_STATE(3039)] = 14314,
  [SMALL_STATE(3040)] = 14382,
  [SMALL_STATE(3041)] = 14468,
  [SMALL_STATE(3042)] = 14536,
  [SMALL_STATE(3043)] = 14612,
  [SMALL_STATE(3044)] = 14680,
  [SMALL_STATE(3045)] = 14748,
  [SMALL_STATE(3046)] = 14816,
  [SMALL_STATE(3047)] = 14884,
  [SMALL_STATE(3048)] = 14956,
  [SMALL_STATE(3049)] = 15032,
  [SMALL_STATE(3050)] = 15100,
  [SMALL_STATE(3051)] = 15168,
  [SMALL_STATE(3052)] = 15236,
  [SMALL_STATE(3053)] = 15304,
  [SMALL_STATE(3054)] = 15378,
  [SMALL_STATE(3055)] = 15446,
  [SMALL_STATE(3056)] = 15514,
  [SMALL_STATE(3057)] = 15582,
  [SMALL_STATE(3058)] = 15650,
  [SMALL_STATE(3059)] = 15718,
  [SMALL_STATE(3060)] = 15836,
  [SMALL_STATE(3061)] = 15904,
  [SMALL_STATE(3062)] = 15972,
  [SMALL_STATE(3063)] = 16090,
  [SMALL_STATE(3064)] = 16158,
  [SMALL_STATE(3065)] = 16228,
  [SMALL_STATE(3066)] = 16296,
  [SMALL_STATE(3067)] = 16364,
  [SMALL_STATE(3068)] = 16432,
  [SMALL_STATE(3069)] = 16504,
  [SMALL_STATE(3070)] = 16572,
  [SMALL_STATE(3071)] = 16640,
  [SMALL_STATE(3072)] = 16708,
  [SMALL_STATE(3073)] = 16776,
  [SMALL_STATE(3074)] = 16858,
  [SMALL_STATE(3075)] = 16930,
  [SMALL_STATE(3076)] = 17002,
  [SMALL_STATE(3077)] = 17070,
  [SMALL_STATE(3078)] = 17142,
  [SMALL_STATE(3079)] = 17214,
  [SMALL_STATE(3080)] = 17286,
  [SMALL_STATE(3081)] = 17358,
  [SMALL_STATE(3082)] = 17430,
  [SMALL_STATE(3083)] = 17498,
  [SMALL_STATE(3084)] = 17566,
  [SMALL_STATE(3085)] = 17634,
  [SMALL_STATE(3086)] = 17702,
  [SMALL_STATE(3087)] = 17778,
  [SMALL_STATE(3088)] = 17846,
  [SMALL_STATE(3089)] = 17914,
  [SMALL_STATE(3090)] = 17982,
  [SMALL_STATE(3091)] = 18050,
  [SMALL_STATE(3092)] = 18118,
  [SMALL_STATE(3093)] = 18188,
  [SMALL_STATE(3094)] = 18256,
  [SMALL_STATE(3095)] = 18326,
  [SMALL_STATE(3096)] = 18394,
  [SMALL_STATE(3097)] = 18462,
  [SMALL_STATE(3098)] = 18530,
  [SMALL_STATE(3099)] = 18598,
  [SMALL_STATE(3100)] = 18672,
  [SMALL_STATE(3101)] = 18739,
  [SMALL_STATE(3102)] = 18806,
  [SMALL_STATE(3103)] = 18887,
  [SMALL_STATE(3104)] = 18954,
  [SMALL_STATE(3105)] = 19025,
  [SMALL_STATE(3106)] = 19094,
  [SMALL_STATE(3107)] = 19161,
  [SMALL_STATE(3108)] = 19230,
  [SMALL_STATE(3109)] = 19297,
  [SMALL_STATE(3110)] = 19378,
  [SMALL_STATE(3111)] = 19445,
  [SMALL_STATE(3112)] = 19512,
  [SMALL_STATE(3113)] = 19581,
  [SMALL_STATE(3114)] = 19653,
  [SMALL_STATE(3115)] = 19719,
  [SMALL_STATE(3116)] = 19795,
  [SMALL_STATE(3117)] = 19861,
  [SMALL_STATE(3118)] = 19927,
  [SMALL_STATE(3119)] = 19993,
  [SMALL_STATE(3120)] = 20061,
  [SMALL_STATE(3121)] = 20133,
  [SMALL_STATE(3122)] = 20253,
  [SMALL_STATE(3123)] = 20323,
  [SMALL_STATE(3124)] = 20393,
  [SMALL_STATE(3125)] = 20459,
  [SMALL_STATE(3126)] = 20541,
  [SMALL_STATE(3127)] = 20607,
  [SMALL_STATE(3128)] = 20673,
  [SMALL_STATE(3129)] = 20793,
  [SMALL_STATE(3130)] = 20859,
  [SMALL_STATE(3131)] = 20929,
  [SMALL_STATE(3132)] = 21005,
  [SMALL_STATE(3133)] = 21081,
  [SMALL_STATE(3134)] = 21147,
  [SMALL_STATE(3135)] = 21229,
  [SMALL_STATE(3136)] = 21295,
  [SMALL_STATE(3137)] = 21361,
  [SMALL_STATE(3138)] = 21443,
  [SMALL_STATE(3139)] = 21509,
  [SMALL_STATE(3140)] = 21579,
  [SMALL_STATE(3141)] = 21649,
  [SMALL_STATE(3142)] = 21731,
  [SMALL_STATE(3143)] = 21801,
  [SMALL_STATE(3144)] = 21871,
  [SMALL_STATE(3145)] = 21937,
  [SMALL_STATE(3146)] = 22005,
  [SMALL_STATE(3147)] = 22071,
  [SMALL_STATE(3148)] = 22137,
  [SMALL_STATE(3149)] = 22205,
  [SMALL_STATE(3150)] = 22271,
  [SMALL_STATE(3151)] = 22341,
  [SMALL_STATE(3152)] = 22411,
  [SMALL_STATE(3153)] = 22481,
  [SMALL_STATE(3154)] = 22551,
  [SMALL_STATE(3155)] = 22621,
  [SMALL_STATE(3156)] = 22687,
  [SMALL_STATE(3157)] = 22753,
  [SMALL_STATE(3158)] = 22823,
  [SMALL_STATE(3159)] = 22932,
  [SMALL_STATE(3160)] = 23013,
  [SMALL_STATE(3161)] = 23122,
  [SMALL_STATE(3162)] = 23187,
  [SMALL_STATE(3163)] = 23252,
  [SMALL_STATE(3164)] = 23357,
  [SMALL_STATE(3165)] = 23422,
  [SMALL_STATE(3166)] = 23487,
  [SMALL_STATE(3167)] = 23552,
  [SMALL_STATE(3168)] = 23665,
  [SMALL_STATE(3169)] = 23730,
  [SMALL_STATE(3170)] = 23795,
  [SMALL_STATE(3171)] = 23896,
  [SMALL_STATE(3172)] = 23961,
  [SMALL_STATE(3173)] = 24028,
  [SMALL_STATE(3174)] = 24141,
  [SMALL_STATE(3175)] = 24240,
  [SMALL_STATE(3176)] = 24305,
  [SMALL_STATE(3177)] = 24370,
  [SMALL_STATE(3178)] = 24435,
  [SMALL_STATE(3179)] = 24532,
  [SMALL_STATE(3180)] = 24599,
  [SMALL_STATE(3181)] = 24678,
  [SMALL_STATE(3182)] = 24743,
  [SMALL_STATE(3183)] = 24810,
  [SMALL_STATE(3184)] = 24875,
  [SMALL_STATE(3185)] = 24940,
  [SMALL_STATE(3186)] = 25005,
  [SMALL_STATE(3187)] = 25070,
  [SMALL_STATE(3188)] = 25151,
  [SMALL_STATE(3189)] = 25216,
  [SMALL_STATE(3190)] = 25287,
  [SMALL_STATE(3191)] = 25352,
  [SMALL_STATE(3192)] = 25417,
  [SMALL_STATE(3193)] = 25482,
  [SMALL_STATE(3194)] = 25591,
  [SMALL_STATE(3195)] = 25672,
  [SMALL_STATE(3196)] = 25755,
  [SMALL_STATE(3197)] = 25826,
  [SMALL_STATE(3198)] = 25911,
  [SMALL_STATE(3199)] = 25986,
  [SMALL_STATE(3200)] = 26051,
  [SMALL_STATE(3201)] = 26122,
  [SMALL_STATE(3202)] = 26201,
  [SMALL_STATE(3203)] = 26282,
  [SMALL_STATE(3204)] = 26357,
  [SMALL_STATE(3205)] = 26428,
  [SMALL_STATE(3206)] = 26537,
  [SMALL_STATE(3207)] = 26646,
  [SMALL_STATE(3208)] = 26717,
  [SMALL_STATE(3209)] = 26808,
  [SMALL_STATE(3210)] = 26873,
  [SMALL_STATE(3211)] = 26944,
  [SMALL_STATE(3212)] = 27015,
  [SMALL_STATE(3213)] = 27086,
  [SMALL_STATE(3214)] = 27157,
  [SMALL_STATE(3215)] = 27238,
  [SMALL_STATE(3216)] = 27351,
  [SMALL_STATE(3217)] = 27422,
  [SMALL_STATE(3218)] = 27509,
  [SMALL_STATE(3219)] = 27574,
  [SMALL_STATE(3220)] = 27645,
  [SMALL_STATE(3221)] = 27716,
  [SMALL_STATE(3222)] = 27811,
  [SMALL_STATE(3223)] = 27881,
  [SMALL_STATE(3224)] = 27951,
  [SMALL_STATE(3225)] = 28015,
  [SMALL_STATE(3226)] = 28079,
  [SMALL_STATE(3227)] = 28143,
  [SMALL_STATE(3228)] = 28213,
  [SMALL_STATE(3229)] = 28283,
  [SMALL_STATE(3230)] = 28347,
  [SMALL_STATE(3231)] = 28459,
  [SMALL_STATE(3232)] = 28577,
  [SMALL_STATE(3233)] = 28641,
  [SMALL_STATE(3234)] = 28711,
  [SMALL_STATE(3235)] = 28775,
  [SMALL_STATE(3236)] = 28887,
  [SMALL_STATE(3237)] = 28955,
  [SMALL_STATE(3238)] = 29025,
  [SMALL_STATE(3239)] = 29095,
  [SMALL_STATE(3240)] = 29159,
  [SMALL_STATE(3241)] = 29277,
  [SMALL_STATE(3242)] = 29347,
  [SMALL_STATE(3243)] = 29411,
  [SMALL_STATE(3244)] = 29481,
  [SMALL_STATE(3245)] = 29547,
  [SMALL_STATE(3246)] = 29617,
  [SMALL_STATE(3247)] = 29687,
  [SMALL_STATE(3248)] = 29757,
  [SMALL_STATE(3249)] = 29823,
  [SMALL_STATE(3250)] = 29886,
  [SMALL_STATE(3251)] = 29977,
  [SMALL_STATE(3252)] = 30086,
  [SMALL_STATE(3253)] = 30149,
  [SMALL_STATE(3254)] = 30266,
  [SMALL_STATE(3255)] = 30383,
  [SMALL_STATE(3256)] = 30500,
  [SMALL_STATE(3257)] = 30597,
  [SMALL_STATE(3258)] = 30706,
  [SMALL_STATE(3259)] = 30815,
  [SMALL_STATE(3260)] = 30888,
  [SMALL_STATE(3261)] = 30997,
  [SMALL_STATE(3262)] = 31106,
  [SMALL_STATE(3263)] = 31215,
  [SMALL_STATE(3264)] = 31278,
  [SMALL_STATE(3265)] = 31391,
  [SMALL_STATE(3266)] = 31464,
  [SMALL_STATE(3267)] = 31527,
  [SMALL_STATE(3268)] = 31636,
  [SMALL_STATE(3269)] = 31699,
  [SMALL_STATE(3270)] = 31762,
  [SMALL_STATE(3271)] = 31835,
  [SMALL_STATE(3272)] = 31996,
  [SMALL_STATE(3273)] = 32105,
  [SMALL_STATE(3274)] = 32214,
  [SMALL_STATE(3275)] = 32323,
  [SMALL_STATE(3276)] = 32432,
  [SMALL_STATE(3277)] = 32521,
  [SMALL_STATE(3278)] = 32630,
  [SMALL_STATE(3279)] = 32739,
  [SMALL_STATE(3280)] = 32848,
  [SMALL_STATE(3281)] = 32943,
  [SMALL_STATE(3282)] = 33028,
  [SMALL_STATE(3283)] = 33137,
  [SMALL_STATE(3284)] = 33246,
  [SMALL_STATE(3285)] = 33319,
  [SMALL_STATE(3286)] = 33384,
  [SMALL_STATE(3287)] = 33493,
  [SMALL_STATE(3288)] = 33560,
  [SMALL_STATE(3289)] = 33633,
  [SMALL_STATE(3290)] = 33702,
  [SMALL_STATE(3291)] = 33773,
  [SMALL_STATE(3292)] = 33882,
  [SMALL_STATE(3293)] = 33963,
  [SMALL_STATE(3294)] = 34042,
  [SMALL_STATE(3295)] = 34105,
  [SMALL_STATE(3296)] = 34214,
  [SMALL_STATE(3297)] = 34287,
  [SMALL_STATE(3298)] = 34366,
  [SMALL_STATE(3299)] = 34483,
  [SMALL_STATE(3300)] = 34592,
  [SMALL_STATE(3301)] = 34701,
  [SMALL_STATE(3302)] = 34810,
  [SMALL_STATE(3303)] = 34893,
  [SMALL_STATE(3304)] = 35054,
  [SMALL_STATE(3305)] = 35117,
  [SMALL_STATE(3306)] = 35188,
  [SMALL_STATE(3307)] = 35297,
  [SMALL_STATE(3308)] = 35406,
  [SMALL_STATE(3309)] = 35519,
  [SMALL_STATE(3310)] = 35592,
  [SMALL_STATE(3311)] = 35701,
  [SMALL_STATE(3312)] = 35810,
  [SMALL_STATE(3313)] = 35873,
  [SMALL_STATE(3314)] = 35938,
  [SMALL_STATE(3315)] = 36001,
  [SMALL_STATE(3316)] = 36080,
  [SMALL_STATE(3317)] = 36189,
  [SMALL_STATE(3318)] = 36260,
  [SMALL_STATE(3319)] = 36339,
  [SMALL_STATE(3320)] = 36500,
  [SMALL_STATE(3321)] = 36609,
  [SMALL_STATE(3322)] = 36688,
  [SMALL_STATE(3323)] = 36797,
  [SMALL_STATE(3324)] = 36860,
  [SMALL_STATE(3325)] = 36923,
  [SMALL_STATE(3326)] = 36986,
  [SMALL_STATE(3327)] = 37087,
  [SMALL_STATE(3328)] = 37150,
  [SMALL_STATE(3329)] = 37263,
  [SMALL_STATE(3330)] = 37368,
  [SMALL_STATE(3331)] = 37476,
  [SMALL_STATE(3332)] = 37548,
  [SMALL_STATE(3333)] = 37616,
  [SMALL_STATE(3334)] = 37688,
  [SMALL_STATE(3335)] = 37756,
  [SMALL_STATE(3336)] = 37818,
  [SMALL_STATE(3337)] = 37886,
  [SMALL_STATE(3338)] = 37948,
  [SMALL_STATE(3339)] = 38010,
  [SMALL_STATE(3340)] = 38076,
  [SMALL_STATE(3341)] = 38138,
  [SMALL_STATE(3342)] = 38200,
  [SMALL_STATE(3343)] = 38262,
  [SMALL_STATE(3344)] = 38324,
  [SMALL_STATE(3345)] = 38386,
  [SMALL_STATE(3346)] = 38448,
  [SMALL_STATE(3347)] = 38516,
  [SMALL_STATE(3348)] = 38584,
  [SMALL_STATE(3349)] = 38648,
  [SMALL_STATE(3350)] = 38716,
  [SMALL_STATE(3351)] = 38784,
  [SMALL_STATE(3352)] = 38848,
  [SMALL_STATE(3353)] = 38916,
  [SMALL_STATE(3354)] = 38984,
  [SMALL_STATE(3355)] = 39092,
  [SMALL_STATE(3356)] = 39154,
  [SMALL_STATE(3357)] = 39270,
  [SMALL_STATE(3358)] = 39338,
  [SMALL_STATE(3359)] = 39446,
  [SMALL_STATE(3360)] = 39524,
  [SMALL_STATE(3361)] = 39604,
  [SMALL_STATE(3362)] = 39686,
  [SMALL_STATE(3363)] = 39748,
  [SMALL_STATE(3364)] = 39816,
  [SMALL_STATE(3365)] = 39884,
  [SMALL_STATE(3366)] = 39946,
  [SMALL_STATE(3367)] = 40062,
  [SMALL_STATE(3368)] = 40130,
  [SMALL_STATE(3369)] = 40196,
  [SMALL_STATE(3370)] = 40264,
  [SMALL_STATE(3371)] = 40334,
  [SMALL_STATE(3372)] = 40396,
  [SMALL_STATE(3373)] = 40508,
  [SMALL_STATE(3374)] = 40570,
  [SMALL_STATE(3375)] = 40632,
  [SMALL_STATE(3376)] = 40698,
  [SMALL_STATE(3377)] = 40814,
  [SMALL_STATE(3378)] = 40876,
  [SMALL_STATE(3379)] = 40938,
  [SMALL_STATE(3380)] = 41054,
  [SMALL_STATE(3381)] = 41116,
  [SMALL_STATE(3382)] = 41184,
  [SMALL_STATE(3383)] = 41246,
  [SMALL_STATE(3384)] = 41318,
  [SMALL_STATE(3385)] = 41426,
  [SMALL_STATE(3386)] = 41488,
  [SMALL_STATE(3387)] = 41550,
  [SMALL_STATE(3388)] = 41612,
  [SMALL_STATE(3389)] = 41674,
  [SMALL_STATE(3390)] = 41742,
  [SMALL_STATE(3391)] = 41804,
  [SMALL_STATE(3392)] = 41876,
  [SMALL_STATE(3393)] = 41984,
  [SMALL_STATE(3394)] = 42046,
  [SMALL_STATE(3395)] = 42108,
  [SMALL_STATE(3396)] = 42170,
  [SMALL_STATE(3397)] = 42232,
  [SMALL_STATE(3398)] = 42302,
  [SMALL_STATE(3399)] = 42368,
  [SMALL_STATE(3400)] = 42480,
  [SMALL_STATE(3401)] = 42548,
  [SMALL_STATE(3402)] = 42620,
  [SMALL_STATE(3403)] = 42682,
  [SMALL_STATE(3404)] = 42750,
  [SMALL_STATE(3405)] = 42816,
  [SMALL_STATE(3406)] = 42878,
  [SMALL_STATE(3407)] = 42944,
  [SMALL_STATE(3408)] = 43006,
  [SMALL_STATE(3409)] = 43110,
  [SMALL_STATE(3410)] = 43210,
  [SMALL_STATE(3411)] = 43306,
  [SMALL_STATE(3412)] = 43400,
  [SMALL_STATE(3413)] = 43490,
  [SMALL_STATE(3414)] = 43578,
  [SMALL_STATE(3415)] = 43662,
  [SMALL_STATE(3416)] = 43724,
  [SMALL_STATE(3417)] = 43786,
  [SMALL_STATE(3418)] = 43848,
  [SMALL_STATE(3419)] = 43914,
  [SMALL_STATE(3420)] = 44026,
  [SMALL_STATE(3421)] = 44088,
  [SMALL_STATE(3422)] = 44154,
  [SMALL_STATE(3423)] = 44215,
  [SMALL_STATE(3424)] = 44330,
  [SMALL_STATE(3425)] = 44391,
  [SMALL_STATE(3426)] = 44456,
  [SMALL_STATE(3427)] = 44525,
  [SMALL_STATE(3428)] = 44636,
  [SMALL_STATE(3429)] = 44701,
  [SMALL_STATE(3430)] = 44768,
  [SMALL_STATE(3431)] = 44829,
  [SMALL_STATE(3432)] = 44890,
  [SMALL_STATE(3433)] = 44951,
  [SMALL_STATE(3434)] = 45026,
  [SMALL_STATE(3435)] = 45087,
  [SMALL_STATE(3436)] = 45152,
  [SMALL_STATE(3437)] = 45219,
  [SMALL_STATE(3438)] = 45286,
  [SMALL_STATE(3439)] = 45347,
  [SMALL_STATE(3440)] = 45408,
  [SMALL_STATE(3441)] = 45515,
  [SMALL_STATE(3442)] = 45580,
  [SMALL_STATE(3443)] = 45691,
  [SMALL_STATE(3444)] = 45752,
  [SMALL_STATE(3445)] = 45827,
  [SMALL_STATE(3446)] = 45942,
  [SMALL_STATE(3447)] = 46017,
  [SMALL_STATE(3448)] = 46090,
  [SMALL_STATE(3449)] = 46205,
  [SMALL_STATE(3450)] = 46272,
  [SMALL_STATE(3451)] = 46371,
  [SMALL_STATE(3452)] = 46440,
  [SMALL_STATE(3453)] = 46503,
  [SMALL_STATE(3454)] = 46602,
  [SMALL_STATE(3455)] = 46665,
  [SMALL_STATE(3456)] = 46726,
  [SMALL_STATE(3457)] = 46787,
  [SMALL_STATE(3458)] = 46894,
  [SMALL_STATE(3459)] = 46955,
  [SMALL_STATE(3460)] = 47032,
  [SMALL_STATE(3461)] = 47093,
  [SMALL_STATE(3462)] = 47200,
  [SMALL_STATE(3463)] = 47275,
  [SMALL_STATE(3464)] = 47340,
  [SMALL_STATE(3465)] = 47443,
  [SMALL_STATE(3466)] = 47504,
  [SMALL_STATE(3467)] = 47565,
  [SMALL_STATE(3468)] = 47626,
  [SMALL_STATE(3469)] = 47687,
  [SMALL_STATE(3470)] = 47764,
  [SMALL_STATE(3471)] = 47825,
  [SMALL_STATE(3472)] = 47886,
  [SMALL_STATE(3473)] = 47985,
  [SMALL_STATE(3474)] = 48092,
  [SMALL_STATE(3475)] = 48153,
  [SMALL_STATE(3476)] = 48248,
  [SMALL_STATE(3477)] = 48363,
  [SMALL_STATE(3478)] = 48432,
  [SMALL_STATE(3479)] = 48493,
  [SMALL_STATE(3480)] = 48560,
  [SMALL_STATE(3481)] = 48621,
  [SMALL_STATE(3482)] = 48682,
  [SMALL_STATE(3483)] = 48743,
  [SMALL_STATE(3484)] = 48858,
  [SMALL_STATE(3485)] = 48921,
  [SMALL_STATE(3486)] = 48982,
  [SMALL_STATE(3487)] = 49043,
  [SMALL_STATE(3488)] = 49110,
  [SMALL_STATE(3489)] = 49171,
  [SMALL_STATE(3490)] = 49278,
  [SMALL_STATE(3491)] = 49353,
  [SMALL_STATE(3492)] = 49414,
  [SMALL_STATE(3493)] = 49475,
  [SMALL_STATE(3494)] = 49538,
  [SMALL_STATE(3495)] = 49619,
  [SMALL_STATE(3496)] = 49680,
  [SMALL_STATE(3497)] = 49749,
  [SMALL_STATE(3498)] = 49810,
  [SMALL_STATE(3499)] = 49879,
  [SMALL_STATE(3500)] = 49944,
  [SMALL_STATE(3501)] = 50011,
  [SMALL_STATE(3502)] = 50104,
  [SMALL_STATE(3503)] = 50165,
  [SMALL_STATE(3504)] = 50226,
  [SMALL_STATE(3505)] = 50291,
  [SMALL_STATE(3506)] = 50352,
  [SMALL_STATE(3507)] = 50413,
  [SMALL_STATE(3508)] = 50502,
  [SMALL_STATE(3509)] = 50589,
  [SMALL_STATE(3510)] = 50704,
  [SMALL_STATE(3511)] = 50787,
  [SMALL_STATE(3512)] = 50860,
  [SMALL_STATE(3513)] = 50921,
  [SMALL_STATE(3514)] = 50982,
  [SMALL_STATE(3515)] = 51043,
  [SMALL_STATE(3516)] = 51104,
  [SMALL_STATE(3517)] = 51215,
  [SMALL_STATE(3518)] = 51280,
  [SMALL_STATE(3519)] = 51359,
  [SMALL_STATE(3520)] = 51420,
  [SMALL_STATE(3521)] = 51494,
  [SMALL_STATE(3522)] = 51554,
  [SMALL_STATE(3523)] = 51666,
  [SMALL_STATE(3524)] = 51730,
  [SMALL_STATE(3525)] = 51790,
  [SMALL_STATE(3526)] = 51856,
  [SMALL_STATE(3527)] = 51918,
  [SMALL_STATE(3528)] = 51984,
  [SMALL_STATE(3529)] = 52044,
  [SMALL_STATE(3530)] = 52104,
  [SMALL_STATE(3531)] = 52172,
  [SMALL_STATE(3532)] = 52236,
  [SMALL_STATE(3533)] = 52296,
  [SMALL_STATE(3534)] = 52356,
  [SMALL_STATE(3535)] = 52512,
  [SMALL_STATE(3536)] = 52572,
  [SMALL_STATE(3537)] = 52632,
  [SMALL_STATE(3538)] = 52692,
  [SMALL_STATE(3539)] = 52756,
  [SMALL_STATE(3540)] = 52912,
  [SMALL_STATE(3541)] = 52972,
  [SMALL_STATE(3542)] = 53032,
  [SMALL_STATE(3543)] = 53092,
  [SMALL_STATE(3544)] = 53158,
  [SMALL_STATE(3545)] = 53218,
  [SMALL_STATE(3546)] = 53278,
  [SMALL_STATE(3547)] = 53338,
  [SMALL_STATE(3548)] = 53402,
  [SMALL_STATE(3549)] = 53462,
  [SMALL_STATE(3550)] = 53522,
  [SMALL_STATE(3551)] = 53636,
  [SMALL_STATE(3552)] = 53696,
  [SMALL_STATE(3553)] = 53762,
  [SMALL_STATE(3554)] = 53918,
  [SMALL_STATE(3555)] = 53980,
  [SMALL_STATE(3556)] = 54044,
  [SMALL_STATE(3557)] = 54104,
  [SMALL_STATE(3558)] = 54164,
  [SMALL_STATE(3559)] = 54320,
  [SMALL_STATE(3560)] = 54380,
  [SMALL_STATE(3561)] = 54536,
  [SMALL_STATE(3562)] = 54608,
  [SMALL_STATE(3563)] = 54712,
  [SMALL_STATE(3564)] = 54778,
  [SMALL_STATE(3565)] = 54934,
  [SMALL_STATE(3566)] = 54994,
  [SMALL_STATE(3567)] = 55068,
  [SMALL_STATE(3568)] = 55142,
  [SMALL_STATE(3569)] = 55202,
  [SMALL_STATE(3570)] = 55306,
  [SMALL_STATE(3571)] = 55378,
  [SMALL_STATE(3572)] = 55438,
  [SMALL_STATE(3573)] = 55498,
  [SMALL_STATE(3574)] = 55654,
  [SMALL_STATE(3575)] = 55810,
  [SMALL_STATE(3576)] = 55870,
  [SMALL_STATE(3577)] = 55930,
  [SMALL_STATE(3578)] = 56086,
  [SMALL_STATE(3579)] = 56146,
  [SMALL_STATE(3580)] = 56206,
  [SMALL_STATE(3581)] = 56266,
  [SMALL_STATE(3582)] = 56326,
  [SMALL_STATE(3583)] = 56386,
  [SMALL_STATE(3584)] = 56446,
  [SMALL_STATE(3585)] = 56506,
  [SMALL_STATE(3586)] = 56566,
  [SMALL_STATE(3587)] = 56670,
  [SMALL_STATE(3588)] = 56732,
  [SMALL_STATE(3589)] = 56792,
  [SMALL_STATE(3590)] = 56852,
  [SMALL_STATE(3591)] = 56960,
  [SMALL_STATE(3592)] = 57020,
  [SMALL_STATE(3593)] = 57090,
  [SMALL_STATE(3594)] = 57166,
  [SMALL_STATE(3595)] = 57240,
  [SMALL_STATE(3596)] = 57340,
  [SMALL_STATE(3597)] = 57436,
  [SMALL_STATE(3598)] = 57528,
  [SMALL_STATE(3599)] = 57618,
  [SMALL_STATE(3600)] = 57704,
  [SMALL_STATE(3601)] = 57788,
  [SMALL_STATE(3602)] = 57870,
  [SMALL_STATE(3603)] = 57944,
  [SMALL_STATE(3604)] = 58022,
  [SMALL_STATE(3605)] = 58102,
  [SMALL_STATE(3606)] = 58172,
  [SMALL_STATE(3607)] = 58238,
  [SMALL_STATE(3608)] = 58298,
  [SMALL_STATE(3609)] = 58358,
  [SMALL_STATE(3610)] = 58432,
  [SMALL_STATE(3611)] = 58492,
  [SMALL_STATE(3612)] = 58552,
  [SMALL_STATE(3613)] = 58618,
  [SMALL_STATE(3614)] = 58678,
  [SMALL_STATE(3615)] = 58782,
  [SMALL_STATE(3616)] = 58844,
  [SMALL_STATE(3617)] = 58952,
  [SMALL_STATE(3618)] = 59024,
  [SMALL_STATE(3619)] = 59130,
  [SMALL_STATE(3620)] = 59204,
  [SMALL_STATE(3621)] = 59310,
  [SMALL_STATE(3622)] = 59382,
  [SMALL_STATE(3623)] = 59488,
  [SMALL_STATE(3624)] = 59598,
  [SMALL_STATE(3625)] = 59674,
  [SMALL_STATE(3626)] = 59748,
  [SMALL_STATE(3627)] = 59850,
  [SMALL_STATE(3628)] = 59948,
  [SMALL_STATE(3629)] = 60042,
  [SMALL_STATE(3630)] = 60134,
  [SMALL_STATE(3631)] = 60222,
  [SMALL_STATE(3632)] = 60308,
  [SMALL_STATE(3633)] = 60390,
  [SMALL_STATE(3634)] = 60468,
  [SMALL_STATE(3635)] = 60548,
  [SMALL_STATE(3636)] = 60622,
  [SMALL_STATE(3637)] = 60728,
  [SMALL_STATE(3638)] = 60838,
  [SMALL_STATE(3639)] = 60944,
  [SMALL_STATE(3640)] = 61054,
  [SMALL_STATE(3641)] = 61158,
  [SMALL_STATE(3642)] = 61218,
  [SMALL_STATE(3643)] = 61278,
  [SMALL_STATE(3644)] = 61352,
  [SMALL_STATE(3645)] = 61416,
  [SMALL_STATE(3646)] = 61478,
  [SMALL_STATE(3647)] = 61538,
  [SMALL_STATE(3648)] = 61646,
  [SMALL_STATE(3649)] = 61706,
  [SMALL_STATE(3650)] = 61766,
  [SMALL_STATE(3651)] = 61826,
  [SMALL_STATE(3652)] = 61885,
  [SMALL_STATE(3653)] = 61944,
  [SMALL_STATE(3654)] = 62003,
  [SMALL_STATE(3655)] = 62062,
  [SMALL_STATE(3656)] = 62121,
  [SMALL_STATE(3657)] = 62184,
  [SMALL_STATE(3658)] = 62243,
  [SMALL_STATE(3659)] = 62302,
  [SMALL_STATE(3660)] = 62361,
  [SMALL_STATE(3661)] = 62420,
  [SMALL_STATE(3662)] = 62481,
  [SMALL_STATE(3663)] = 62540,
  [SMALL_STATE(3664)] = 62599,
  [SMALL_STATE(3665)] = 62658,
  [SMALL_STATE(3666)] = 62723,
  [SMALL_STATE(3667)] = 62782,
  [SMALL_STATE(3668)] = 62841,
  [SMALL_STATE(3669)] = 62902,
  [SMALL_STATE(3670)] = 62961,
  [SMALL_STATE(3671)] = 63020,
  [SMALL_STATE(3672)] = 63079,
  [SMALL_STATE(3673)] = 63138,
  [SMALL_STATE(3674)] = 63197,
  [SMALL_STATE(3675)] = 63256,
  [SMALL_STATE(3676)] = 63315,
  [SMALL_STATE(3677)] = 63374,
  [SMALL_STATE(3678)] = 63433,
  [SMALL_STATE(3679)] = 63492,
  [SMALL_STATE(3680)] = 63551,
  [SMALL_STATE(3681)] = 63610,
  [SMALL_STATE(3682)] = 63669,
  [SMALL_STATE(3683)] = 63728,
  [SMALL_STATE(3684)] = 63841,
  [SMALL_STATE(3685)] = 63900,
  [SMALL_STATE(3686)] = 63959,
  [SMALL_STATE(3687)] = 64018,
  [SMALL_STATE(3688)] = 64077,
  [SMALL_STATE(3689)] = 64190,
  [SMALL_STATE(3690)] = 64249,
  [SMALL_STATE(3691)] = 64308,
  [SMALL_STATE(3692)] = 64367,
  [SMALL_STATE(3693)] = 64426,
  [SMALL_STATE(3694)] = 64485,
  [SMALL_STATE(3695)] = 64544,
  [SMALL_STATE(3696)] = 64603,
  [SMALL_STATE(3697)] = 64662,
  [SMALL_STATE(3698)] = 64721,
  [SMALL_STATE(3699)] = 64780,
  [SMALL_STATE(3700)] = 64839,
  [SMALL_STATE(3701)] = 64898,
  [SMALL_STATE(3702)] = 64957,
  [SMALL_STATE(3703)] = 65016,
  [SMALL_STATE(3704)] = 65075,
  [SMALL_STATE(3705)] = 65140,
  [SMALL_STATE(3706)] = 65199,
  [SMALL_STATE(3707)] = 65258,
  [SMALL_STATE(3708)] = 65317,
  [SMALL_STATE(3709)] = 65384,
  [SMALL_STATE(3710)] = 65443,
  [SMALL_STATE(3711)] = 65510,
  [SMALL_STATE(3712)] = 65569,
  [SMALL_STATE(3713)] = 65628,
  [SMALL_STATE(3714)] = 65687,
  [SMALL_STATE(3715)] = 65746,
  [SMALL_STATE(3716)] = 65805,
  [SMALL_STATE(3717)] = 65864,
  [SMALL_STATE(3718)] = 65923,
  [SMALL_STATE(3719)] = 65982,
  [SMALL_STATE(3720)] = 66041,
  [SMALL_STATE(3721)] = 66100,
  [SMALL_STATE(3722)] = 66165,
  [SMALL_STATE(3723)] = 66224,
  [SMALL_STATE(3724)] = 66283,
  [SMALL_STATE(3725)] = 66344,
  [SMALL_STATE(3726)] = 66409,
  [SMALL_STATE(3727)] = 66468,
  [SMALL_STATE(3728)] = 66527,
  [SMALL_STATE(3729)] = 66640,
  [SMALL_STATE(3730)] = 66699,
  [SMALL_STATE(3731)] = 66758,
  [SMALL_STATE(3732)] = 66823,
  [SMALL_STATE(3733)] = 66886,
  [SMALL_STATE(3734)] = 66945,
  [SMALL_STATE(3735)] = 67004,
  [SMALL_STATE(3736)] = 67071,
  [SMALL_STATE(3737)] = 67134,
  [SMALL_STATE(3738)] = 67199,
  [SMALL_STATE(3739)] = 67258,
  [SMALL_STATE(3740)] = 67317,
  [SMALL_STATE(3741)] = 67376,
  [SMALL_STATE(3742)] = 67435,
  [SMALL_STATE(3743)] = 67500,
  [SMALL_STATE(3744)] = 67559,
  [SMALL_STATE(3745)] = 67618,
  [SMALL_STATE(3746)] = 67677,
  [SMALL_STATE(3747)] = 67746,
  [SMALL_STATE(3748)] = 67809,
  [SMALL_STATE(3749)] = 67872,
  [SMALL_STATE(3750)] = 67985,
  [SMALL_STATE(3751)] = 68044,
  [SMALL_STATE(3752)] = 68103,
  [SMALL_STATE(3753)] = 68162,
  [SMALL_STATE(3754)] = 68221,
  [SMALL_STATE(3755)] = 68284,
  [SMALL_STATE(3756)] = 68347,
  [SMALL_STATE(3757)] = 68406,
  [SMALL_STATE(3758)] = 68465,
  [SMALL_STATE(3759)] = 68524,
  [SMALL_STATE(3760)] = 68587,
  [SMALL_STATE(3761)] = 68650,
  [SMALL_STATE(3762)] = 68713,
  [SMALL_STATE(3763)] = 68776,
  [SMALL_STATE(3764)] = 68839,
  [SMALL_STATE(3765)] = 68898,
  [SMALL_STATE(3766)] = 68961,
  [SMALL_STATE(3767)] = 69024,
  [SMALL_STATE(3768)] = 69087,
  [SMALL_STATE(3769)] = 69146,
  [SMALL_STATE(3770)] = 69205,
  [SMALL_STATE(3771)] = 69264,
  [SMALL_STATE(3772)] = 69331,
  [SMALL_STATE(3773)] = 69390,
  [SMALL_STATE(3774)] = 69449,
  [SMALL_STATE(3775)] = 69508,
  [SMALL_STATE(3776)] = 69575,
  [SMALL_STATE(3777)] = 69634,
  [SMALL_STATE(3778)] = 69693,
  [SMALL_STATE(3779)] = 69752,
  [SMALL_STATE(3780)] = 69811,
  [SMALL_STATE(3781)] = 69870,
  [SMALL_STATE(3782)] = 69929,
  [SMALL_STATE(3783)] = 69990,
  [SMALL_STATE(3784)] = 70049,
  [SMALL_STATE(3785)] = 70108,
  [SMALL_STATE(3786)] = 70167,
  [SMALL_STATE(3787)] = 70226,
  [SMALL_STATE(3788)] = 70285,
  [SMALL_STATE(3789)] = 70344,
  [SMALL_STATE(3790)] = 70457,
  [SMALL_STATE(3791)] = 70516,
  [SMALL_STATE(3792)] = 70579,
  [SMALL_STATE(3793)] = 70638,
  [SMALL_STATE(3794)] = 70697,
  [SMALL_STATE(3795)] = 70756,
  [SMALL_STATE(3796)] = 70815,
  [SMALL_STATE(3797)] = 70874,
  [SMALL_STATE(3798)] = 70933,
  [SMALL_STATE(3799)] = 70992,
  [SMALL_STATE(3800)] = 71051,
  [SMALL_STATE(3801)] = 71110,
  [SMALL_STATE(3802)] = 71169,
  [SMALL_STATE(3803)] = 71228,
  [SMALL_STATE(3804)] = 71287,
  [SMALL_STATE(3805)] = 71346,
  [SMALL_STATE(3806)] = 71405,
  [SMALL_STATE(3807)] = 71464,
  [SMALL_STATE(3808)] = 71523,
  [SMALL_STATE(3809)] = 71582,
  [SMALL_STATE(3810)] = 71641,
  [SMALL_STATE(3811)] = 71700,
  [SMALL_STATE(3812)] = 71759,
  [SMALL_STATE(3813)] = 71818,
  [SMALL_STATE(3814)] = 71877,
  [SMALL_STATE(3815)] = 71936,
  [SMALL_STATE(3816)] = 71995,
  [SMALL_STATE(3817)] = 72054,
  [SMALL_STATE(3818)] = 72113,
  [SMALL_STATE(3819)] = 72172,
  [SMALL_STATE(3820)] = 72231,
  [SMALL_STATE(3821)] = 72290,
  [SMALL_STATE(3822)] = 72349,
  [SMALL_STATE(3823)] = 72408,
  [SMALL_STATE(3824)] = 72467,
  [SMALL_STATE(3825)] = 72530,
  [SMALL_STATE(3826)] = 72600,
  [SMALL_STATE(3827)] = 72658,
  [SMALL_STATE(3828)] = 72716,
  [SMALL_STATE(3829)] = 72774,
  [SMALL_STATE(3830)] = 72832,
  [SMALL_STATE(3831)] = 72938,
  [SMALL_STATE(3832)] = 72996,
  [SMALL_STATE(3833)] = 73054,
  [SMALL_STATE(3834)] = 73112,
  [SMALL_STATE(3835)] = 73174,
  [SMALL_STATE(3836)] = 73280,
  [SMALL_STATE(3837)] = 73338,
  [SMALL_STATE(3838)] = 73400,
  [SMALL_STATE(3839)] = 73458,
  [SMALL_STATE(3840)] = 73564,
  [SMALL_STATE(3841)] = 73626,
  [SMALL_STATE(3842)] = 73684,
  [SMALL_STATE(3843)] = 73742,
  [SMALL_STATE(3844)] = 73800,
  [SMALL_STATE(3845)] = 73858,
  [SMALL_STATE(3846)] = 73916,
  [SMALL_STATE(3847)] = 73974,
  [SMALL_STATE(3848)] = 74032,
  [SMALL_STATE(3849)] = 74134,
  [SMALL_STATE(3850)] = 74192,
  [SMALL_STATE(3851)] = 74294,
  [SMALL_STATE(3852)] = 74352,
  [SMALL_STATE(3853)] = 74410,
  [SMALL_STATE(3854)] = 74468,
  [SMALL_STATE(3855)] = 74526,
  [SMALL_STATE(3856)] = 74584,
  [SMALL_STATE(3857)] = 74642,
  [SMALL_STATE(3858)] = 74700,
  [SMALL_STATE(3859)] = 74762,
  [SMALL_STATE(3860)] = 74820,
  [SMALL_STATE(3861)] = 74894,
  [SMALL_STATE(3862)] = 74966,
  [SMALL_STATE(3863)] = 75024,
  [SMALL_STATE(3864)] = 75086,
  [SMALL_STATE(3865)] = 75186,
  [SMALL_STATE(3866)] = 75248,
  [SMALL_STATE(3867)] = 75314,
  [SMALL_STATE(3868)] = 75372,
  [SMALL_STATE(3869)] = 75470,
  [SMALL_STATE(3870)] = 75528,
  [SMALL_STATE(3871)] = 75586,
  [SMALL_STATE(3872)] = 75644,
  [SMALL_STATE(3873)] = 75702,
  [SMALL_STATE(3874)] = 75764,
  [SMALL_STATE(3875)] = 75822,
  [SMALL_STATE(3876)] = 75880,
  [SMALL_STATE(3877)] = 75974,
  [SMALL_STATE(3878)] = 76032,
  [SMALL_STATE(3879)] = 76122,
  [SMALL_STATE(3880)] = 76180,
  [SMALL_STATE(3881)] = 76238,
  [SMALL_STATE(3882)] = 76324,
  [SMALL_STATE(3883)] = 76382,
  [SMALL_STATE(3884)] = 76440,
  [SMALL_STATE(3885)] = 76498,
  [SMALL_STATE(3886)] = 76556,
  [SMALL_STATE(3887)] = 76614,
  [SMALL_STATE(3888)] = 76672,
  [SMALL_STATE(3889)] = 76730,
  [SMALL_STATE(3890)] = 76788,
  [SMALL_STATE(3891)] = 76846,
  [SMALL_STATE(3892)] = 76916,
  [SMALL_STATE(3893)] = 77000,
  [SMALL_STATE(3894)] = 77058,
  [SMALL_STATE(3895)] = 77116,
  [SMALL_STATE(3896)] = 77188,
  [SMALL_STATE(3897)] = 77246,
  [SMALL_STATE(3898)] = 77318,
  [SMALL_STATE(3899)] = 77376,
  [SMALL_STATE(3900)] = 77434,
  [SMALL_STATE(3901)] = 77492,
  [SMALL_STATE(3902)] = 77550,
  [SMALL_STATE(3903)] = 77608,
  [SMALL_STATE(3904)] = 77666,
  [SMALL_STATE(3905)] = 77724,
  [SMALL_STATE(3906)] = 77826,
  [SMALL_STATE(3907)] = 77906,
  [SMALL_STATE(3908)] = 77982,
  [SMALL_STATE(3909)] = 78040,
  [SMALL_STATE(3910)] = 78098,
  [SMALL_STATE(3911)] = 78156,
  [SMALL_STATE(3912)] = 78214,
  [SMALL_STATE(3913)] = 78284,
  [SMALL_STATE(3914)] = 78342,
  [SMALL_STATE(3915)] = 78420,
  [SMALL_STATE(3916)] = 78478,
  [SMALL_STATE(3917)] = 78536,
  [SMALL_STATE(3918)] = 78594,
  [SMALL_STATE(3919)] = 78652,
  [SMALL_STATE(3920)] = 78722,
  [SMALL_STATE(3921)] = 78780,
  [SMALL_STATE(3922)] = 78838,
  [SMALL_STATE(3923)] = 78904,
  [SMALL_STATE(3924)] = 78962,
  [SMALL_STATE(3925)] = 79068,
  [SMALL_STATE(3926)] = 79126,
  [SMALL_STATE(3927)] = 79184,
  [SMALL_STATE(3928)] = 79242,
  [SMALL_STATE(3929)] = 79300,
  [SMALL_STATE(3930)] = 79360,
  [SMALL_STATE(3931)] = 79418,
  [SMALL_STATE(3932)] = 79476,
  [SMALL_STATE(3933)] = 79546,
  [SMALL_STATE(3934)] = 79604,
  [SMALL_STATE(3935)] = 79662,
  [SMALL_STATE(3936)] = 79724,
  [SMALL_STATE(3937)] = 79782,
  [SMALL_STATE(3938)] = 79840,
  [SMALL_STATE(3939)] = 79898,
  [SMALL_STATE(3940)] = 79956,
  [SMALL_STATE(3941)] = 80014,
  [SMALL_STATE(3942)] = 80072,
  [SMALL_STATE(3943)] = 80130,
  [SMALL_STATE(3944)] = 80232,
  [SMALL_STATE(3945)] = 80290,
  [SMALL_STATE(3946)] = 80362,
  [SMALL_STATE(3947)] = 80422,
  [SMALL_STATE(3948)] = 80482,
  [SMALL_STATE(3949)] = 80540,
  [SMALL_STATE(3950)] = 80598,
  [SMALL_STATE(3951)] = 80656,
  [SMALL_STATE(3952)] = 80714,
  [SMALL_STATE(3953)] = 80772,
  [SMALL_STATE(3954)] = 80830,
  [SMALL_STATE(3955)] = 80888,
  [SMALL_STATE(3956)] = 80948,
  [SMALL_STATE(3957)] = 81006,
  [SMALL_STATE(3958)] = 81064,
  [SMALL_STATE(3959)] = 81122,
  [SMALL_STATE(3960)] = 81180,
  [SMALL_STATE(3961)] = 81242,
  [SMALL_STATE(3962)] = 81300,
  [SMALL_STATE(3963)] = 81402,
  [SMALL_STATE(3964)] = 81460,
  [SMALL_STATE(3965)] = 81518,
  [SMALL_STATE(3966)] = 81576,
  [SMALL_STATE(3967)] = 81634,
  [SMALL_STATE(3968)] = 81692,
  [SMALL_STATE(3969)] = 81752,
  [SMALL_STATE(3970)] = 81855,
  [SMALL_STATE(3971)] = 81970,
  [SMALL_STATE(3972)] = 82063,
  [SMALL_STATE(3973)] = 82166,
  [SMALL_STATE(3974)] = 82269,
  [SMALL_STATE(3975)] = 82372,
  [SMALL_STATE(3976)] = 82475,
  [SMALL_STATE(3977)] = 82590,
  [SMALL_STATE(3978)] = 82693,
  [SMALL_STATE(3979)] = 82796,
  [SMALL_STATE(3980)] = 82899,
  [SMALL_STATE(3981)] = 83002,
  [SMALL_STATE(3982)] = 83059,
  [SMALL_STATE(3983)] = 83162,
  [SMALL_STATE(3984)] = 83225,
  [SMALL_STATE(3985)] = 83294,
  [SMALL_STATE(3986)] = 83357,
  [SMALL_STATE(3987)] = 83460,
  [SMALL_STATE(3988)] = 83563,
  [SMALL_STATE(3989)] = 83666,
  [SMALL_STATE(3990)] = 83769,
  [SMALL_STATE(3991)] = 83828,
  [SMALL_STATE(3992)] = 83931,
  [SMALL_STATE(3993)] = 84034,
  [SMALL_STATE(3994)] = 84137,
  [SMALL_STATE(3995)] = 84240,
  [SMALL_STATE(3996)] = 84335,
  [SMALL_STATE(3997)] = 84406,
  [SMALL_STATE(3998)] = 84477,
  [SMALL_STATE(3999)] = 84580,
  [SMALL_STATE(4000)] = 84683,
  [SMALL_STATE(4001)] = 84786,
  [SMALL_STATE(4002)] = 84881,
  [SMALL_STATE(4003)] = 84938,
  [SMALL_STATE(4004)] = 85041,
  [SMALL_STATE(4005)] = 85144,
  [SMALL_STATE(4006)] = 85247,
  [SMALL_STATE(4007)] = 85350,
  [SMALL_STATE(4008)] = 85453,
  [SMALL_STATE(4009)] = 85556,
  [SMALL_STATE(4010)] = 85659,
  [SMALL_STATE(4011)] = 85762,
  [SMALL_STATE(4012)] = 85865,
  [SMALL_STATE(4013)] = 85922,
  [SMALL_STATE(4014)] = 86025,
  [SMALL_STATE(4015)] = 86128,
  [SMALL_STATE(4016)] = 86231,
  [SMALL_STATE(4017)] = 86334,
  [SMALL_STATE(4018)] = 86391,
  [SMALL_STATE(4019)] = 86494,
  [SMALL_STATE(4020)] = 86597,
  [SMALL_STATE(4021)] = 86700,
  [SMALL_STATE(4022)] = 86803,
  [SMALL_STATE(4023)] = 86906,
  [SMALL_STATE(4024)] = 87009,
  [SMALL_STATE(4025)] = 87080,
  [SMALL_STATE(4026)] = 87183,
  [SMALL_STATE(4027)] = 87286,
  [SMALL_STATE(4028)] = 87389,
  [SMALL_STATE(4029)] = 87492,
  [SMALL_STATE(4030)] = 87557,
  [SMALL_STATE(4031)] = 87650,
  [SMALL_STATE(4032)] = 87753,
  [SMALL_STATE(4033)] = 87856,
  [SMALL_STATE(4034)] = 87913,
  [SMALL_STATE(4035)] = 88016,
  [SMALL_STATE(4036)] = 88073,
  [SMALL_STATE(4037)] = 88176,
  [SMALL_STATE(4038)] = 88241,
  [SMALL_STATE(4039)] = 88344,
  [SMALL_STATE(4040)] = 88401,
  [SMALL_STATE(4041)] = 88458,
  [SMALL_STATE(4042)] = 88561,
  [SMALL_STATE(4043)] = 88664,
  [SMALL_STATE(4044)] = 88767,
  [SMALL_STATE(4045)] = 88870,
  [SMALL_STATE(4046)] = 88927,
  [SMALL_STATE(4047)] = 89030,
  [SMALL_STATE(4048)] = 89133,
  [SMALL_STATE(4049)] = 89236,
  [SMALL_STATE(4050)] = 89339,
  [SMALL_STATE(4051)] = 89442,
  [SMALL_STATE(4052)] = 89513,
  [SMALL_STATE(4053)] = 89616,
  [SMALL_STATE(4054)] = 89673,
  [SMALL_STATE(4055)] = 89736,
  [SMALL_STATE(4056)] = 89839,
  [SMALL_STATE(4057)] = 89942,
  [SMALL_STATE(4058)] = 90003,
  [SMALL_STATE(4059)] = 90106,
  [SMALL_STATE(4060)] = 90175,
  [SMALL_STATE(4061)] = 90278,
  [SMALL_STATE(4062)] = 90381,
  [SMALL_STATE(4063)] = 90484,
  [SMALL_STATE(4064)] = 90587,
  [SMALL_STATE(4065)] = 90650,
  [SMALL_STATE(4066)] = 90753,
  [SMALL_STATE(4067)] = 90856,
  [SMALL_STATE(4068)] = 90913,
  [SMALL_STATE(4069)] = 90970,
  [SMALL_STATE(4070)] = 91073,
  [SMALL_STATE(4071)] = 91129,
  [SMALL_STATE(4072)] = 91185,
  [SMALL_STATE(4073)] = 91241,
  [SMALL_STATE(4074)] = 91297,
  [SMALL_STATE(4075)] = 91353,
  [SMALL_STATE(4076)] = 91409,
  [SMALL_STATE(4077)] = 91465,
  [SMALL_STATE(4078)] = 91521,
  [SMALL_STATE(4079)] = 91577,
  [SMALL_STATE(4080)] = 91677,
  [SMALL_STATE(4081)] = 91733,
  [SMALL_STATE(4082)] = 91789,
  [SMALL_STATE(4083)] = 91845,
  [SMALL_STATE(4084)] = 91901,
  [SMALL_STATE(4085)] = 91957,
  [SMALL_STATE(4086)] = 92057,
  [SMALL_STATE(4087)] = 92113,
  [SMALL_STATE(4088)] = 92169,
  [SMALL_STATE(4089)] = 92225,
  [SMALL_STATE(4090)] = 92281,
  [SMALL_STATE(4091)] = 92337,
  [SMALL_STATE(4092)] = 92393,
  [SMALL_STATE(4093)] = 92449,
  [SMALL_STATE(4094)] = 92539,
  [SMALL_STATE(4095)] = 92639,
  [SMALL_STATE(4096)] = 92695,
  [SMALL_STATE(4097)] = 92751,
  [SMALL_STATE(4098)] = 92807,
  [SMALL_STATE(4099)] = 92863,
  [SMALL_STATE(4100)] = 92919,
  [SMALL_STATE(4101)] = 92975,
  [SMALL_STATE(4102)] = 93031,
  [SMALL_STATE(4103)] = 93087,
  [SMALL_STATE(4104)] = 93187,
  [SMALL_STATE(4105)] = 93277,
  [SMALL_STATE(4106)] = 93333,
  [SMALL_STATE(4107)] = 93433,
  [SMALL_STATE(4108)] = 93489,
  [SMALL_STATE(4109)] = 93549,
  [SMALL_STATE(4110)] = 93605,
  [SMALL_STATE(4111)] = 93661,
  [SMALL_STATE(4112)] = 93717,
  [SMALL_STATE(4113)] = 93817,
  [SMALL_STATE(4114)] = 93873,
  [SMALL_STATE(4115)] = 93929,
  [SMALL_STATE(4116)] = 94029,
  [SMALL_STATE(4117)] = 94085,
  [SMALL_STATE(4118)] = 94141,
  [SMALL_STATE(4119)] = 94197,
  [SMALL_STATE(4120)] = 94297,
  [SMALL_STATE(4121)] = 94353,
  [SMALL_STATE(4122)] = 94409,
  [SMALL_STATE(4123)] = 94465,
  [SMALL_STATE(4124)] = 94521,
  [SMALL_STATE(4125)] = 94577,
  [SMALL_STATE(4126)] = 94633,
  [SMALL_STATE(4127)] = 94689,
  [SMALL_STATE(4128)] = 94745,
  [SMALL_STATE(4129)] = 94801,
  [SMALL_STATE(4130)] = 94857,
  [SMALL_STATE(4131)] = 94913,
  [SMALL_STATE(4132)] = 94969,
  [SMALL_STATE(4133)] = 95025,
  [SMALL_STATE(4134)] = 95081,
  [SMALL_STATE(4135)] = 95137,
  [SMALL_STATE(4136)] = 95237,
  [SMALL_STATE(4137)] = 95293,
  [SMALL_STATE(4138)] = 95393,
  [SMALL_STATE(4139)] = 95449,
  [SMALL_STATE(4140)] = 95505,
  [SMALL_STATE(4141)] = 95561,
  [SMALL_STATE(4142)] = 95661,
  [SMALL_STATE(4143)] = 95717,
  [SMALL_STATE(4144)] = 95773,
  [SMALL_STATE(4145)] = 95829,
  [SMALL_STATE(4146)] = 95899,
  [SMALL_STATE(4147)] = 95969,
  [SMALL_STATE(4148)] = 96025,
  [SMALL_STATE(4149)] = 96097,
  [SMALL_STATE(4150)] = 96153,
  [SMALL_STATE(4151)] = 96253,
  [SMALL_STATE(4152)] = 96309,
  [SMALL_STATE(4153)] = 96409,
  [SMALL_STATE(4154)] = 96465,
  [SMALL_STATE(4155)] = 96521,
  [SMALL_STATE(4156)] = 96621,
  [SMALL_STATE(4157)] = 96677,
  [SMALL_STATE(4158)] = 96733,
  [SMALL_STATE(4159)] = 96805,
  [SMALL_STATE(4160)] = 96861,
  [SMALL_STATE(4161)] = 96917,
  [SMALL_STATE(4162)] = 96989,
  [SMALL_STATE(4163)] = 97045,
  [SMALL_STATE(4164)] = 97101,
  [SMALL_STATE(4165)] = 97157,
  [SMALL_STATE(4166)] = 97229,
  [SMALL_STATE(4167)] = 97285,
  [SMALL_STATE(4168)] = 97341,
  [SMALL_STATE(4169)] = 97399,
  [SMALL_STATE(4170)] = 97455,
  [SMALL_STATE(4171)] = 97511,
  [SMALL_STATE(4172)] = 97567,
  [SMALL_STATE(4173)] = 97623,
  [SMALL_STATE(4174)] = 97679,
  [SMALL_STATE(4175)] = 97735,
  [SMALL_STATE(4176)] = 97827,
  [SMALL_STATE(4177)] = 97919,
  [SMALL_STATE(4178)] = 97975,
  [SMALL_STATE(4179)] = 98039,
  [SMALL_STATE(4180)] = 98095,
  [SMALL_STATE(4181)] = 98151,
  [SMALL_STATE(4182)] = 98207,
  [SMALL_STATE(4183)] = 98307,
  [SMALL_STATE(4184)] = 98363,
  [SMALL_STATE(4185)] = 98419,
  [SMALL_STATE(4186)] = 98483,
  [SMALL_STATE(4187)] = 98547,
  [SMALL_STATE(4188)] = 98647,
  [SMALL_STATE(4189)] = 98703,
  [SMALL_STATE(4190)] = 98759,
  [SMALL_STATE(4191)] = 98815,
  [SMALL_STATE(4192)] = 98874,
  [SMALL_STATE(4193)] = 98933,
  [SMALL_STATE(4194)] = 99026,
  [SMALL_STATE(4195)] = 99085,
  [SMALL_STATE(4196)] = 99178,
  [SMALL_STATE(4197)] = 99271,
  [SMALL_STATE(4198)] = 99364,
  [SMALL_STATE(4199)] = 99423,
  [SMALL_STATE(4200)] = 99494,
  [SMALL_STATE(4201)] = 99587,
  [SMALL_STATE(4202)] = 99680,
  [SMALL_STATE(4203)] = 99773,
  [SMALL_STATE(4204)] = 99844,
  [SMALL_STATE(4205)] = 99903,
  [SMALL_STATE(4206)] = 99962,
  [SMALL_STATE(4207)] = 100055,
  [SMALL_STATE(4208)] = 100126,
  [SMALL_STATE(4209)] = 100219,
  [SMALL_STATE(4210)] = 100312,
  [SMALL_STATE(4211)] = 100405,
  [SMALL_STATE(4212)] = 100498,
  [SMALL_STATE(4213)] = 100553,
  [SMALL_STATE(4214)] = 100608,
  [SMALL_STATE(4215)] = 100679,
  [SMALL_STATE(4216)] = 100772,
  [SMALL_STATE(4217)] = 100865,
  [SMALL_STATE(4218)] = 100958,
  [SMALL_STATE(4219)] = 101013,
  [SMALL_STATE(4220)] = 101106,
  [SMALL_STATE(4221)] = 101165,
  [SMALL_STATE(4222)] = 101224,
  [SMALL_STATE(4223)] = 101317,
  [SMALL_STATE(4224)] = 101376,
  [SMALL_STATE(4225)] = 101435,
  [SMALL_STATE(4226)] = 101528,
  [SMALL_STATE(4227)] = 101621,
  [SMALL_STATE(4228)] = 101680,
  [SMALL_STATE(4229)] = 101773,
  [SMALL_STATE(4230)] = 101828,
  [SMALL_STATE(4231)] = 101887,
  [SMALL_STATE(4232)] = 101980,
  [SMALL_STATE(4233)] = 102073,
  [SMALL_STATE(4234)] = 102143,
  [SMALL_STATE(4235)] = 102197,
  [SMALL_STATE(4236)] = 102257,
  [SMALL_STATE(4237)] = 102311,
  [SMALL_STATE(4238)] = 102365,
  [SMALL_STATE(4239)] = 102455,
  [SMALL_STATE(4240)] = 102519,
  [SMALL_STATE(4241)] = 102589,
  [SMALL_STATE(4242)] = 102643,
  [SMALL_STATE(4243)] = 102703,
  [SMALL_STATE(4244)] = 102793,
  [SMALL_STATE(4245)] = 102847,
  [SMALL_STATE(4246)] = 102937,
  [SMALL_STATE(4247)] = 102997,
  [SMALL_STATE(4248)] = 103057,
  [SMALL_STATE(4249)] = 103111,
  [SMALL_STATE(4250)] = 103165,
  [SMALL_STATE(4251)] = 103265,
  [SMALL_STATE(4252)] = 103319,
  [SMALL_STATE(4253)] = 103373,
  [SMALL_STATE(4254)] = 103427,
  [SMALL_STATE(4255)] = 103495,
  [SMALL_STATE(4256)] = 103585,
  [SMALL_STATE(4257)] = 103645,
  [SMALL_STATE(4258)] = 103705,
  [SMALL_STATE(4259)] = 103773,
  [SMALL_STATE(4260)] = 103862,
  [SMALL_STATE(4261)] = 103929,
  [SMALL_STATE(4262)] = 103988,
  [SMALL_STATE(4263)] = 104077,
  [SMALL_STATE(4264)] = 104166,
  [SMALL_STATE(4265)] = 104255,
  [SMALL_STATE(4266)] = 104344,
  [SMALL_STATE(4267)] = 104433,
  [SMALL_STATE(4268)] = 104522,
  [SMALL_STATE(4269)] = 104577,
  [SMALL_STATE(4270)] = 104666,
  [SMALL_STATE(4271)] = 104747,
  [SMALL_STATE(4272)] = 104836,
  [SMALL_STATE(4273)] = 104895,
  [SMALL_STATE(4274)] = 104984,
  [SMALL_STATE(4275)] = 105065,
  [SMALL_STATE(4276)] = 105154,
  [SMALL_STATE(4277)] = 105207,
  [SMALL_STATE(4278)] = 105276,
  [SMALL_STATE(4279)] = 105365,
  [SMALL_STATE(4280)] = 105424,
  [SMALL_STATE(4281)] = 105513,
  [SMALL_STATE(4282)] = 105582,
  [SMALL_STATE(4283)] = 105671,
  [SMALL_STATE(4284)] = 105760,
  [SMALL_STATE(4285)] = 105849,
  [SMALL_STATE(4286)] = 105938,
  [SMALL_STATE(4287)] = 106027,
  [SMALL_STATE(4288)] = 106108,
  [SMALL_STATE(4289)] = 106197,
  [SMALL_STATE(4290)] = 106286,
  [SMALL_STATE(4291)] = 106375,
  [SMALL_STATE(4292)] = 106464,
  [SMALL_STATE(4293)] = 106553,
  [SMALL_STATE(4294)] = 106642,
  [SMALL_STATE(4295)] = 106731,
  [SMALL_STATE(4296)] = 106820,
  [SMALL_STATE(4297)] = 106887,
  [SMALL_STATE(4298)] = 106976,
  [SMALL_STATE(4299)] = 107065,
  [SMALL_STATE(4300)] = 107146,
  [SMALL_STATE(4301)] = 107235,
  [SMALL_STATE(4302)] = 107324,
  [SMALL_STATE(4303)] = 107376,
  [SMALL_STATE(4304)] = 107436,
  [SMALL_STATE(4305)] = 107488,
  [SMALL_STATE(4306)] = 107556,
  [SMALL_STATE(4307)] = 107608,
  [SMALL_STATE(4308)] = 107660,
  [SMALL_STATE(4309)] = 107712,
  [SMALL_STATE(4310)] = 107764,
  [SMALL_STATE(4311)] = 107816,
  [SMALL_STATE(4312)] = 107868,
  [SMALL_STATE(4313)] = 107920,
  [SMALL_STATE(4314)] = 107972,
  [SMALL_STATE(4315)] = 108032,
  [SMALL_STATE(4316)] = 108100,
  [SMALL_STATE(4317)] = 108162,
  [SMALL_STATE(4318)] = 108214,
  [SMALL_STATE(4319)] = 108266,
  [SMALL_STATE(4320)] = 108334,
  [SMALL_STATE(4321)] = 108386,
  [SMALL_STATE(4322)] = 108438,
  [SMALL_STATE(4323)] = 108490,
  [SMALL_STATE(4324)] = 108542,
  [SMALL_STATE(4325)] = 108594,
  [SMALL_STATE(4326)] = 108680,
  [SMALL_STATE(4327)] = 108732,
  [SMALL_STATE(4328)] = 108784,
  [SMALL_STATE(4329)] = 108836,
  [SMALL_STATE(4330)] = 108922,
  [SMALL_STATE(4331)] = 108990,
  [SMALL_STATE(4332)] = 109052,
  [SMALL_STATE(4333)] = 109140,
  [SMALL_STATE(4334)] = 109192,
  [SMALL_STATE(4335)] = 109276,
  [SMALL_STATE(4336)] = 109328,
  [SMALL_STATE(4337)] = 109380,
  [SMALL_STATE(4338)] = 109474,
  [SMALL_STATE(4339)] = 109526,
  [SMALL_STATE(4340)] = 109578,
  [SMALL_STATE(4341)] = 109630,
  [SMALL_STATE(4342)] = 109714,
  [SMALL_STATE(4343)] = 109766,
  [SMALL_STATE(4344)] = 109854,
  [SMALL_STATE(4345)] = 109906,
  [SMALL_STATE(4346)] = 109958,
  [SMALL_STATE(4347)] = 110010,
  [SMALL_STATE(4348)] = 110062,
  [SMALL_STATE(4349)] = 110114,
  [SMALL_STATE(4350)] = 110171,
  [SMALL_STATE(4351)] = 110258,
  [SMALL_STATE(4352)] = 110343,
  [SMALL_STATE(4353)] = 110426,
  [SMALL_STATE(4354)] = 110493,
  [SMALL_STATE(4355)] = 110572,
  [SMALL_STATE(4356)] = 110643,
  [SMALL_STATE(4357)] = 110716,
  [SMALL_STATE(4358)] = 110803,
  [SMALL_STATE(4359)] = 110870,
  [SMALL_STATE(4360)] = 110955,
  [SMALL_STATE(4361)] = 111040,
  [SMALL_STATE(4362)] = 111139,
  [SMALL_STATE(4363)] = 111242,
  [SMALL_STATE(4364)] = 111329,
  [SMALL_STATE(4365)] = 111428,
  [SMALL_STATE(4366)] = 111495,
  [SMALL_STATE(4367)] = 111598,
  [SMALL_STATE(4368)] = 111683,
  [SMALL_STATE(4369)] = 111766,
  [SMALL_STATE(4370)] = 111849,
  [SMALL_STATE(4371)] = 111936,
  [SMALL_STATE(4372)] = 112023,
  [SMALL_STATE(4373)] = 112126,
  [SMALL_STATE(4374)] = 112181,
  [SMALL_STATE(4375)] = 112266,
  [SMALL_STATE(4376)] = 112327,
  [SMALL_STATE(4377)] = 112384,
  [SMALL_STATE(4378)] = 112441,
  [SMALL_STATE(4379)] = 112540,
  [SMALL_STATE(4380)] = 112625,
  [SMALL_STATE(4381)] = 112710,
  [SMALL_STATE(4382)] = 112809,
  [SMALL_STATE(4383)] = 112894,
  [SMALL_STATE(4384)] = 112945,
  [SMALL_STATE(4385)] = 113006,
  [SMALL_STATE(4386)] = 113093,
  [SMALL_STATE(4387)] = 113160,
  [SMALL_STATE(4388)] = 113263,
  [SMALL_STATE(4389)] = 113320,
  [SMALL_STATE(4390)] = 113375,
  [SMALL_STATE(4391)] = 113432,
  [SMALL_STATE(4392)] = 113501,
  [SMALL_STATE(4393)] = 113586,
  [SMALL_STATE(4394)] = 113637,
  [SMALL_STATE(4395)] = 113732,
  [SMALL_STATE(4396)] = 113831,
  [SMALL_STATE(4397)] = 113922,
  [SMALL_STATE(4398)] = 113973,
  [SMALL_STATE(4399)] = 114062,
  [SMALL_STATE(4400)] = 114137,
  [SMALL_STATE(4401)] = 114187,
  [SMALL_STATE(4402)] = 114237,
  [SMALL_STATE(4403)] = 114329,
  [SMALL_STATE(4404)] = 114413,
  [SMALL_STATE(4405)] = 114463,
  [SMALL_STATE(4406)] = 114513,
  [SMALL_STATE(4407)] = 114619,
  [SMALL_STATE(4408)] = 114703,
  [SMALL_STATE(4409)] = 114787,
  [SMALL_STATE(4410)] = 114843,
  [SMALL_STATE(4411)] = 114893,
  [SMALL_STATE(4412)] = 114953,
  [SMALL_STATE(4413)] = 115003,
  [SMALL_STATE(4414)] = 115059,
  [SMALL_STATE(4415)] = 115143,
  [SMALL_STATE(4416)] = 115209,
  [SMALL_STATE(4417)] = 115259,
  [SMALL_STATE(4418)] = 115309,
  [SMALL_STATE(4419)] = 115363,
  [SMALL_STATE(4420)] = 115455,
  [SMALL_STATE(4421)] = 115515,
  [SMALL_STATE(4422)] = 115565,
  [SMALL_STATE(4423)] = 115615,
  [SMALL_STATE(4424)] = 115675,
  [SMALL_STATE(4425)] = 115761,
  [SMALL_STATE(4426)] = 115813,
  [SMALL_STATE(4427)] = 115899,
  [SMALL_STATE(4428)] = 116005,
  [SMALL_STATE(4429)] = 116061,
  [SMALL_STATE(4430)] = 116111,
  [SMALL_STATE(4431)] = 116177,
  [SMALL_STATE(4432)] = 116229,
  [SMALL_STATE(4433)] = 116335,
  [SMALL_STATE(4434)] = 116385,
  [SMALL_STATE(4435)] = 116451,
  [SMALL_STATE(4436)] = 116501,
  [SMALL_STATE(4437)] = 116551,
  [SMALL_STATE(4438)] = 116617,
  [SMALL_STATE(4439)] = 116677,
  [SMALL_STATE(4440)] = 116727,
  [SMALL_STATE(4441)] = 116777,
  [SMALL_STATE(4442)] = 116827,
  [SMALL_STATE(4443)] = 116881,
  [SMALL_STATE(4444)] = 116931,
  [SMALL_STATE(4445)] = 116981,
  [SMALL_STATE(4446)] = 117062,
  [SMALL_STATE(4447)] = 117111,
  [SMALL_STATE(4448)] = 117164,
  [SMALL_STATE(4449)] = 117221,
  [SMALL_STATE(4450)] = 117274,
  [SMALL_STATE(4451)] = 117327,
  [SMALL_STATE(4452)] = 117382,
  [SMALL_STATE(4453)] = 117431,
  [SMALL_STATE(4454)] = 117480,
  [SMALL_STATE(4455)] = 117529,
  [SMALL_STATE(4456)] = 117582,
  [SMALL_STATE(4457)] = 117659,
  [SMALL_STATE(4458)] = 117714,
  [SMALL_STATE(4459)] = 117789,
  [SMALL_STATE(4460)] = 117864,
  [SMALL_STATE(4461)] = 117917,
  [SMALL_STATE(4462)] = 117994,
  [SMALL_STATE(4463)] = 118043,
  [SMALL_STATE(4464)] = 118128,
  [SMALL_STATE(4465)] = 118205,
  [SMALL_STATE(4466)] = 118282,
  [SMALL_STATE(4467)] = 118357,
  [SMALL_STATE(4468)] = 118408,
  [SMALL_STATE(4469)] = 118461,
  [SMALL_STATE(4470)] = 118516,
  [SMALL_STATE(4471)] = 118569,
  [SMALL_STATE(4472)] = 118618,
  [SMALL_STATE(4473)] = 118671,
  [SMALL_STATE(4474)] = 118724,
  [SMALL_STATE(4475)] = 118809,
  [SMALL_STATE(4476)] = 118890,
  [SMALL_STATE(4477)] = 118945,
  [SMALL_STATE(4478)] = 118998,
  [SMALL_STATE(4479)] = 119047,
  [SMALL_STATE(4480)] = 119096,
  [SMALL_STATE(4481)] = 119149,
  [SMALL_STATE(4482)] = 119206,
  [SMALL_STATE(4483)] = 119287,
  [SMALL_STATE(4484)] = 119368,
  [SMALL_STATE(4485)] = 119421,
  [SMALL_STATE(4486)] = 119474,
  [SMALL_STATE(4487)] = 119527,
  [SMALL_STATE(4488)] = 119602,
  [SMALL_STATE(4489)] = 119668,
  [SMALL_STATE(4490)] = 119760,
  [SMALL_STATE(4491)] = 119856,
  [SMALL_STATE(4492)] = 119950,
  [SMALL_STATE(4493)] = 120008,
  [SMALL_STATE(4494)] = 120086,
  [SMALL_STATE(4495)] = 120168,
  [SMALL_STATE(4496)] = 120258,
  [SMALL_STATE(4497)] = 120346,
  [SMALL_STATE(4498)] = 120430,
  [SMALL_STATE(4499)] = 120512,
  [SMALL_STATE(4500)] = 120590,
  [SMALL_STATE(4501)] = 120670,
  [SMALL_STATE(4502)] = 120728,
  [SMALL_STATE(4503)] = 120812,
  [SMALL_STATE(4504)] = 120906,
  [SMALL_STATE(4505)] = 120982,
  [SMALL_STATE(4506)] = 121054,
  [SMALL_STATE(4507)] = 121120,
  [SMALL_STATE(4508)] = 121188,
  [SMALL_STATE(4509)] = 121280,
  [SMALL_STATE(4510)] = 121372,
  [SMALL_STATE(4511)] = 121460,
  [SMALL_STATE(4512)] = 121518,
  [SMALL_STATE(4513)] = 121570,
  [SMALL_STATE(4514)] = 121622,
  [SMALL_STATE(4515)] = 121706,
  [SMALL_STATE(4516)] = 121758,
  [SMALL_STATE(4517)] = 121854,
  [SMALL_STATE(4518)] = 121924,
  [SMALL_STATE(4519)] = 121976,
  [SMALL_STATE(4520)] = 122028,
  [SMALL_STATE(4521)] = 122124,
  [SMALL_STATE(4522)] = 122198,
  [SMALL_STATE(4523)] = 122274,
  [SMALL_STATE(4524)] = 122348,
  [SMALL_STATE(4525)] = 122412,
  [SMALL_STATE(4526)] = 122486,
  [SMALL_STATE(4527)] = 122578,
  [SMALL_STATE(4528)] = 122668,
  [SMALL_STATE(4529)] = 122720,
  [SMALL_STATE(4530)] = 122772,
  [SMALL_STATE(4531)] = 122824,
  [SMALL_STATE(4532)] = 122876,
  [SMALL_STATE(4533)] = 122928,
  [SMALL_STATE(4534)] = 122980,
  [SMALL_STATE(4535)] = 123048,
  [SMALL_STATE(4536)] = 123114,
  [SMALL_STATE(4537)] = 123166,
  [SMALL_STATE(4538)] = 123218,
  [SMALL_STATE(4539)] = 123318,
  [SMALL_STATE(4540)] = 123418,
  [SMALL_STATE(4541)] = 123476,
  [SMALL_STATE(4542)] = 123570,
  [SMALL_STATE(4543)] = 123666,
  [SMALL_STATE(4544)] = 123756,
  [SMALL_STATE(4545)] = 123828,
  [SMALL_STATE(4546)] = 123898,
  [SMALL_STATE(4547)] = 123984,
  [SMALL_STATE(4548)] = 124080,
  [SMALL_STATE(4549)] = 124170,
  [SMALL_STATE(4550)] = 124250,
  [SMALL_STATE(4551)] = 124340,
  [SMALL_STATE(4552)] = 124430,
  [SMALL_STATE(4553)] = 124494,
  [SMALL_STATE(4554)] = 124586,
  [SMALL_STATE(4555)] = 124670,
  [SMALL_STATE(4556)] = 124744,
  [SMALL_STATE(4557)] = 124841,
  [SMALL_STATE(4558)] = 124888,
  [SMALL_STATE(4559)] = 124941,
  [SMALL_STATE(4560)] = 125038,
  [SMALL_STATE(4561)] = 125091,
  [SMALL_STATE(4562)] = 125188,
  [SMALL_STATE(4563)] = 125285,
  [SMALL_STATE(4564)] = 125382,
  [SMALL_STATE(4565)] = 125479,
  [SMALL_STATE(4566)] = 125526,
  [SMALL_STATE(4567)] = 125605,
  [SMALL_STATE(4568)] = 125702,
  [SMALL_STATE(4569)] = 125799,
  [SMALL_STATE(4570)] = 125896,
  [SMALL_STATE(4571)] = 125961,
  [SMALL_STATE(4572)] = 126058,
  [SMALL_STATE(4573)] = 126155,
  [SMALL_STATE(4574)] = 126204,
  [SMALL_STATE(4575)] = 126293,
  [SMALL_STATE(4576)] = 126390,
  [SMALL_STATE(4577)] = 126485,
  [SMALL_STATE(4578)] = 126538,
  [SMALL_STATE(4579)] = 126591,
  [SMALL_STATE(4580)] = 126688,
  [SMALL_STATE(4581)] = 126785,
  [SMALL_STATE(4582)] = 126882,
  [SMALL_STATE(4583)] = 126979,
  [SMALL_STATE(4584)] = 127036,
  [SMALL_STATE(4585)] = 127131,
  [SMALL_STATE(4586)] = 127228,
  [SMALL_STATE(4587)] = 127325,
  [SMALL_STATE(4588)] = 127422,
  [SMALL_STATE(4589)] = 127519,
  [SMALL_STATE(4590)] = 127616,
  [SMALL_STATE(4591)] = 127713,
  [SMALL_STATE(4592)] = 127774,
  [SMALL_STATE(4593)] = 127871,
  [SMALL_STATE(4594)] = 127968,
  [SMALL_STATE(4595)] = 128065,
  [SMALL_STATE(4596)] = 128162,
  [SMALL_STATE(4597)] = 128259,
  [SMALL_STATE(4598)] = 128356,
  [SMALL_STATE(4599)] = 128409,
  [SMALL_STATE(4600)] = 128458,
  [SMALL_STATE(4601)] = 128555,
  [SMALL_STATE(4602)] = 128652,
  [SMALL_STATE(4603)] = 128727,
  [SMALL_STATE(4604)] = 128802,
  [SMALL_STATE(4605)] = 128877,
  [SMALL_STATE(4606)] = 128952,
  [SMALL_STATE(4607)] = 129049,
  [SMALL_STATE(4608)] = 129146,
  [SMALL_STATE(4609)] = 129221,
  [SMALL_STATE(4610)] = 129318,
  [SMALL_STATE(4611)] = 129415,
  [SMALL_STATE(4612)] = 129512,
  [SMALL_STATE(4613)] = 129601,
  [SMALL_STATE(4614)] = 129698,
  [SMALL_STATE(4615)] = 129795,
  [SMALL_STATE(4616)] = 129892,
  [SMALL_STATE(4617)] = 129967,
  [SMALL_STATE(4618)] = 130064,
  [SMALL_STATE(4619)] = 130139,
  [SMALL_STATE(4620)] = 130214,
  [SMALL_STATE(4621)] = 130293,
  [SMALL_STATE(4622)] = 130390,
  [SMALL_STATE(4623)] = 130487,
  [SMALL_STATE(4624)] = 130584,
  [SMALL_STATE(4625)] = 130641,
  [SMALL_STATE(4626)] = 130738,
  [SMALL_STATE(4627)] = 130791,
  [SMALL_STATE(4628)] = 130838,
  [SMALL_STATE(4629)] = 130885,
  [SMALL_STATE(4630)] = 130932,
  [SMALL_STATE(4631)] = 130979,
  [SMALL_STATE(4632)] = 131026,
  [SMALL_STATE(4633)] = 131123,
  [SMALL_STATE(4634)] = 131170,
  [SMALL_STATE(4635)] = 131217,
  [SMALL_STATE(4636)] = 131314,
  [SMALL_STATE(4637)] = 131363,
  [SMALL_STATE(4638)] = 131460,
  [SMALL_STATE(4639)] = 131557,
  [SMALL_STATE(4640)] = 131654,
  [SMALL_STATE(4641)] = 131751,
  [SMALL_STATE(4642)] = 131848,
  [SMALL_STATE(4643)] = 131945,
  [SMALL_STATE(4644)] = 132042,
  [SMALL_STATE(4645)] = 132091,
  [SMALL_STATE(4646)] = 132140,
  [SMALL_STATE(4647)] = 132237,
  [SMALL_STATE(4648)] = 132334,
  [SMALL_STATE(4649)] = 132395,
  [SMALL_STATE(4650)] = 132492,
  [SMALL_STATE(4651)] = 132539,
  [SMALL_STATE(4652)] = 132636,
  [SMALL_STATE(4653)] = 132730,
  [SMALL_STATE(4654)] = 132822,
  [SMALL_STATE(4655)] = 132916,
  [SMALL_STATE(4656)] = 133010,
  [SMALL_STATE(4657)] = 133078,
  [SMALL_STATE(4658)] = 133170,
  [SMALL_STATE(4659)] = 133228,
  [SMALL_STATE(4660)] = 133322,
  [SMALL_STATE(4661)] = 133416,
  [SMALL_STATE(4662)] = 133508,
  [SMALL_STATE(4663)] = 133590,
  [SMALL_STATE(4664)] = 133678,
  [SMALL_STATE(4665)] = 133770,
  [SMALL_STATE(4666)] = 133834,
  [SMALL_STATE(4667)] = 133920,
  [SMALL_STATE(4668)] = 134004,
  [SMALL_STATE(4669)] = 134086,
  [SMALL_STATE(4670)] = 134166,
  [SMALL_STATE(4671)] = 134242,
  [SMALL_STATE(4672)] = 134316,
  [SMALL_STATE(4673)] = 134386,
  [SMALL_STATE(4674)] = 134452,
  [SMALL_STATE(4675)] = 134520,
  [SMALL_STATE(4676)] = 134576,
  [SMALL_STATE(4677)] = 134664,
  [SMALL_STATE(4678)] = 134756,
  [SMALL_STATE(4679)] = 134844,
  [SMALL_STATE(4680)] = 134936,
  [SMALL_STATE(4681)] = 135030,
  [SMALL_STATE(4682)] = 135124,
  [SMALL_STATE(4683)] = 135216,
  [SMALL_STATE(4684)] = 135268,
  [SMALL_STATE(4685)] = 135362,
  [SMALL_STATE(4686)] = 135456,
  [SMALL_STATE(4687)] = 135544,
  [SMALL_STATE(4688)] = 135638,
  [SMALL_STATE(4689)] = 135726,
  [SMALL_STATE(4690)] = 135820,
  [SMALL_STATE(4691)] = 135912,
  [SMALL_STATE(4692)] = 136004,
  [SMALL_STATE(4693)] = 136082,
  [SMALL_STATE(4694)] = 136176,
  [SMALL_STATE(4695)] = 136242,
  [SMALL_STATE(4696)] = 136334,
  [SMALL_STATE(4697)] = 136406,
  [SMALL_STATE(4698)] = 136484,
  [SMALL_STATE(4699)] = 136572,
  [SMALL_STATE(4700)] = 136664,
  [SMALL_STATE(4701)] = 136756,
  [SMALL_STATE(4702)] = 136844,
  [SMALL_STATE(4703)] = 136900,
  [SMALL_STATE(4704)] = 136994,
  [SMALL_STATE(4705)] = 137072,
  [SMALL_STATE(4706)] = 137164,
  [SMALL_STATE(4707)] = 137256,
  [SMALL_STATE(4708)] = 137344,
  [SMALL_STATE(4709)] = 137438,
  [SMALL_STATE(4710)] = 137498,
  [SMALL_STATE(4711)] = 137592,
  [SMALL_STATE(4712)] = 137684,
  [SMALL_STATE(4713)] = 137756,
  [SMALL_STATE(4714)] = 137844,
  [SMALL_STATE(4715)] = 137938,
  [SMALL_STATE(4716)] = 138032,
  [SMALL_STATE(4717)] = 138088,
  [SMALL_STATE(4718)] = 138182,
  [SMALL_STATE(4719)] = 138274,
  [SMALL_STATE(4720)] = 138366,
  [SMALL_STATE(4721)] = 138446,
  [SMALL_STATE(4722)] = 138498,
  [SMALL_STATE(4723)] = 138592,
  [SMALL_STATE(4724)] = 138650,
  [SMALL_STATE(4725)] = 138744,
  [SMALL_STATE(4726)] = 138804,
  [SMALL_STATE(4727)] = 138864,
  [SMALL_STATE(4728)] = 138924,
  [SMALL_STATE(4729)] = 139018,
  [SMALL_STATE(4730)] = 139076,
  [SMALL_STATE(4731)] = 139162,
  [SMALL_STATE(4732)] = 139256,
  [SMALL_STATE(4733)] = 139314,
  [SMALL_STATE(4734)] = 139408,
  [SMALL_STATE(4735)] = 139502,
  [SMALL_STATE(4736)] = 139594,
  [SMALL_STATE(4737)] = 139660,
  [SMALL_STATE(4738)] = 139752,
  [SMALL_STATE(4739)] = 139846,
  [SMALL_STATE(4740)] = 139938,
  [SMALL_STATE(4741)] = 139998,
  [SMALL_STATE(4742)] = 140092,
  [SMALL_STATE(4743)] = 140186,
  [SMALL_STATE(4744)] = 140258,
  [SMALL_STATE(4745)] = 140304,
  [SMALL_STATE(4746)] = 140398,
  [SMALL_STATE(4747)] = 140490,
  [SMALL_STATE(4748)] = 140584,
  [SMALL_STATE(4749)] = 140678,
  [SMALL_STATE(4750)] = 140738,
  [SMALL_STATE(4751)] = 140832,
  [SMALL_STATE(4752)] = 140926,
  [SMALL_STATE(4753)] = 140998,
  [SMALL_STATE(4754)] = 141092,
  [SMALL_STATE(4755)] = 141184,
  [SMALL_STATE(4756)] = 141276,
  [SMALL_STATE(4757)] = 141370,
  [SMALL_STATE(4758)] = 141430,
  [SMALL_STATE(4759)] = 141502,
  [SMALL_STATE(4760)] = 141594,
  [SMALL_STATE(4761)] = 141682,
  [SMALL_STATE(4762)] = 141744,
  [SMALL_STATE(4763)] = 141822,
  [SMALL_STATE(4764)] = 141870,
  [SMALL_STATE(4765)] = 141958,
  [SMALL_STATE(4766)] = 142022,
  [SMALL_STATE(4767)] = 142082,
  [SMALL_STATE(4768)] = 142134,
  [SMALL_STATE(4769)] = 142228,
  [SMALL_STATE(4770)] = 142322,
  [SMALL_STATE(4771)] = 142416,
  [SMALL_STATE(4772)] = 142502,
  [SMALL_STATE(4773)] = 142586,
  [SMALL_STATE(4774)] = 142674,
  [SMALL_STATE(4775)] = 142762,
  [SMALL_STATE(4776)] = 142854,
  [SMALL_STATE(4777)] = 142926,
  [SMALL_STATE(4778)] = 142998,
  [SMALL_STATE(4779)] = 143092,
  [SMALL_STATE(4780)] = 143184,
  [SMALL_STATE(4781)] = 143278,
  [SMALL_STATE(4782)] = 143372,
  [SMALL_STATE(4783)] = 143466,
  [SMALL_STATE(4784)] = 143558,
  [SMALL_STATE(4785)] = 143652,
  [SMALL_STATE(4786)] = 143746,
  [SMALL_STATE(4787)] = 143834,
  [SMALL_STATE(4788)] = 143898,
  [SMALL_STATE(4789)] = 143970,
  [SMALL_STATE(4790)] = 144046,
  [SMALL_STATE(4791)] = 144138,
  [SMALL_STATE(4792)] = 144212,
  [SMALL_STATE(4793)] = 144272,
  [SMALL_STATE(4794)] = 144358,
  [SMALL_STATE(4795)] = 144442,
  [SMALL_STATE(4796)] = 144524,
  [SMALL_STATE(4797)] = 144594,
  [SMALL_STATE(4798)] = 144686,
  [SMALL_STATE(4799)] = 144766,
  [SMALL_STATE(4800)] = 144826,
  [SMALL_STATE(4801)] = 144914,
  [SMALL_STATE(4802)] = 145008,
  [SMALL_STATE(4803)] = 145084,
  [SMALL_STATE(4804)] = 145158,
  [SMALL_STATE(4805)] = 145228,
  [SMALL_STATE(4806)] = 145278,
  [SMALL_STATE(4807)] = 145350,
  [SMALL_STATE(4808)] = 145441,
  [SMALL_STATE(4809)] = 145490,
  [SMALL_STATE(4810)] = 145539,
  [SMALL_STATE(4811)] = 145588,
  [SMALL_STATE(4812)] = 145637,
  [SMALL_STATE(4813)] = 145692,
  [SMALL_STATE(4814)] = 145741,
  [SMALL_STATE(4815)] = 145790,
  [SMALL_STATE(4816)] = 145839,
  [SMALL_STATE(4817)] = 145888,
  [SMALL_STATE(4818)] = 145937,
  [SMALL_STATE(4819)] = 145992,
  [SMALL_STATE(4820)] = 146041,
  [SMALL_STATE(4821)] = 146132,
  [SMALL_STATE(4822)] = 146205,
  [SMALL_STATE(4823)] = 146254,
  [SMALL_STATE(4824)] = 146303,
  [SMALL_STATE(4825)] = 146394,
  [SMALL_STATE(4826)] = 146485,
  [SMALL_STATE(4827)] = 146558,
  [SMALL_STATE(4828)] = 146649,
  [SMALL_STATE(4829)] = 146722,
  [SMALL_STATE(4830)] = 146767,
  [SMALL_STATE(4831)] = 146840,
  [SMALL_STATE(4832)] = 146917,
  [SMALL_STATE(4833)] = 147008,
  [SMALL_STATE(4834)] = 147099,
  [SMALL_STATE(4835)] = 147190,
  [SMALL_STATE(4836)] = 147281,
  [SMALL_STATE(4837)] = 147358,
  [SMALL_STATE(4838)] = 147449,
  [SMALL_STATE(4839)] = 147540,
  [SMALL_STATE(4840)] = 147631,
  [SMALL_STATE(4841)] = 147722,
  [SMALL_STATE(4842)] = 147813,
  [SMALL_STATE(4843)] = 147904,
  [SMALL_STATE(4844)] = 147995,
  [SMALL_STATE(4845)] = 148086,
  [SMALL_STATE(4846)] = 148133,
  [SMALL_STATE(4847)] = 148224,
  [SMALL_STATE(4848)] = 148315,
  [SMALL_STATE(4849)] = 148406,
  [SMALL_STATE(4850)] = 148497,
  [SMALL_STATE(4851)] = 148588,
  [SMALL_STATE(4852)] = 148679,
  [SMALL_STATE(4853)] = 148770,
  [SMALL_STATE(4854)] = 148861,
  [SMALL_STATE(4855)] = 148934,
  [SMALL_STATE(4856)] = 149025,
  [SMALL_STATE(4857)] = 149116,
  [SMALL_STATE(4858)] = 149207,
  [SMALL_STATE(4859)] = 149298,
  [SMALL_STATE(4860)] = 149371,
  [SMALL_STATE(4861)] = 149462,
  [SMALL_STATE(4862)] = 149553,
  [SMALL_STATE(4863)] = 149626,
  [SMALL_STATE(4864)] = 149717,
  [SMALL_STATE(4865)] = 149808,
  [SMALL_STATE(4866)] = 149899,
  [SMALL_STATE(4867)] = 149990,
  [SMALL_STATE(4868)] = 150081,
  [SMALL_STATE(4869)] = 150172,
  [SMALL_STATE(4870)] = 150263,
  [SMALL_STATE(4871)] = 150354,
  [SMALL_STATE(4872)] = 150445,
  [SMALL_STATE(4873)] = 150536,
  [SMALL_STATE(4874)] = 150617,
  [SMALL_STATE(4875)] = 150668,
  [SMALL_STATE(4876)] = 150719,
  [SMALL_STATE(4877)] = 150810,
  [SMALL_STATE(4878)] = 150861,
  [SMALL_STATE(4879)] = 150952,
  [SMALL_STATE(4880)] = 151043,
  [SMALL_STATE(4881)] = 151134,
  [SMALL_STATE(4882)] = 151225,
  [SMALL_STATE(4883)] = 151316,
  [SMALL_STATE(4884)] = 151407,
  [SMALL_STATE(4885)] = 151458,
  [SMALL_STATE(4886)] = 151509,
  [SMALL_STATE(4887)] = 151560,
  [SMALL_STATE(4888)] = 151611,
  [SMALL_STATE(4889)] = 151656,
  [SMALL_STATE(4890)] = 151747,
  [SMALL_STATE(4891)] = 151838,
  [SMALL_STATE(4892)] = 151929,
  [SMALL_STATE(4893)] = 152020,
  [SMALL_STATE(4894)] = 152111,
  [SMALL_STATE(4895)] = 152202,
  [SMALL_STATE(4896)] = 152293,
  [SMALL_STATE(4897)] = 152384,
  [SMALL_STATE(4898)] = 152475,
  [SMALL_STATE(4899)] = 152566,
  [SMALL_STATE(4900)] = 152657,
  [SMALL_STATE(4901)] = 152748,
  [SMALL_STATE(4902)] = 152839,
  [SMALL_STATE(4903)] = 152890,
  [SMALL_STATE(4904)] = 152941,
  [SMALL_STATE(4905)] = 152992,
  [SMALL_STATE(4906)] = 153043,
  [SMALL_STATE(4907)] = 153134,
  [SMALL_STATE(4908)] = 153225,
  [SMALL_STATE(4909)] = 153316,
  [SMALL_STATE(4910)] = 153407,
  [SMALL_STATE(4911)] = 153490,
  [SMALL_STATE(4912)] = 153581,
  [SMALL_STATE(4913)] = 153672,
  [SMALL_STATE(4914)] = 153763,
  [SMALL_STATE(4915)] = 153854,
  [SMALL_STATE(4916)] = 153945,
  [SMALL_STATE(4917)] = 154036,
  [SMALL_STATE(4918)] = 154087,
  [SMALL_STATE(4919)] = 154138,
  [SMALL_STATE(4920)] = 154229,
  [SMALL_STATE(4921)] = 154320,
  [SMALL_STATE(4922)] = 154411,
  [SMALL_STATE(4923)] = 154502,
  [SMALL_STATE(4924)] = 154593,
  [SMALL_STATE(4925)] = 154684,
  [SMALL_STATE(4926)] = 154775,
  [SMALL_STATE(4927)] = 154866,
  [SMALL_STATE(4928)] = 154939,
  [SMALL_STATE(4929)] = 155030,
  [SMALL_STATE(4930)] = 155121,
  [SMALL_STATE(4931)] = 155212,
  [SMALL_STATE(4932)] = 155285,
  [SMALL_STATE(4933)] = 155376,
  [SMALL_STATE(4934)] = 155467,
  [SMALL_STATE(4935)] = 155558,
  [SMALL_STATE(4936)] = 155649,
  [SMALL_STATE(4937)] = 155740,
  [SMALL_STATE(4938)] = 155831,
  [SMALL_STATE(4939)] = 155922,
  [SMALL_STATE(4940)] = 156013,
  [SMALL_STATE(4941)] = 156104,
  [SMALL_STATE(4942)] = 156195,
  [SMALL_STATE(4943)] = 156282,
  [SMALL_STATE(4944)] = 156363,
  [SMALL_STATE(4945)] = 156454,
  [SMALL_STATE(4946)] = 156541,
  [SMALL_STATE(4947)] = 156632,
  [SMALL_STATE(4948)] = 156723,
  [SMALL_STATE(4949)] = 156796,
  [SMALL_STATE(4950)] = 156869,
  [SMALL_STATE(4951)] = 156942,
  [SMALL_STATE(4952)] = 157015,
  [SMALL_STATE(4953)] = 157088,
  [SMALL_STATE(4954)] = 157161,
  [SMALL_STATE(4955)] = 157234,
  [SMALL_STATE(4956)] = 157305,
  [SMALL_STATE(4957)] = 157376,
  [SMALL_STATE(4958)] = 157447,
  [SMALL_STATE(4959)] = 157518,
  [SMALL_STATE(4960)] = 157599,
  [SMALL_STATE(4961)] = 157672,
  [SMALL_STATE(4962)] = 157745,
  [SMALL_STATE(4963)] = 157818,
  [SMALL_STATE(4964)] = 157891,
  [SMALL_STATE(4965)] = 157972,
  [SMALL_STATE(4966)] = 158063,
  [SMALL_STATE(4967)] = 158144,
  [SMALL_STATE(4968)] = 158235,
  [SMALL_STATE(4969)] = 158316,
  [SMALL_STATE(4970)] = 158397,
  [SMALL_STATE(4971)] = 158488,
  [SMALL_STATE(4972)] = 158579,
  [SMALL_STATE(4973)] = 158670,
  [SMALL_STATE(4974)] = 158717,
  [SMALL_STATE(4975)] = 158790,
  [SMALL_STATE(4976)] = 158853,
  [SMALL_STATE(4977)] = 158944,
  [SMALL_STATE(4978)] = 159035,
  [SMALL_STATE(4979)] = 159126,
  [SMALL_STATE(4980)] = 159217,
  [SMALL_STATE(4981)] = 159308,
  [SMALL_STATE(4982)] = 159399,
  [SMALL_STATE(4983)] = 159490,
  [SMALL_STATE(4984)] = 159581,
  [SMALL_STATE(4985)] = 159672,
  [SMALL_STATE(4986)] = 159763,
  [SMALL_STATE(4987)] = 159849,
  [SMALL_STATE(4988)] = 159893,
  [SMALL_STATE(4989)] = 159971,
  [SMALL_STATE(4990)] = 160051,
  [SMALL_STATE(4991)] = 160127,
  [SMALL_STATE(4992)] = 160177,
  [SMALL_STATE(4993)] = 160221,
  [SMALL_STATE(4994)] = 160265,
  [SMALL_STATE(4995)] = 160309,
  [SMALL_STATE(4996)] = 160353,
  [SMALL_STATE(4997)] = 160397,
  [SMALL_STATE(4998)] = 160441,
  [SMALL_STATE(4999)] = 160485,
  [SMALL_STATE(5000)] = 160529,
  [SMALL_STATE(5001)] = 160573,
  [SMALL_STATE(5002)] = 160617,
  [SMALL_STATE(5003)] = 160667,
  [SMALL_STATE(5004)] = 160711,
  [SMALL_STATE(5005)] = 160755,
  [SMALL_STATE(5006)] = 160799,
  [SMALL_STATE(5007)] = 160877,
  [SMALL_STATE(5008)] = 160921,
  [SMALL_STATE(5009)] = 160965,
  [SMALL_STATE(5010)] = 161041,
  [SMALL_STATE(5011)] = 161085,
  [SMALL_STATE(5012)] = 161129,
  [SMALL_STATE(5013)] = 161173,
  [SMALL_STATE(5014)] = 161217,
  [SMALL_STATE(5015)] = 161261,
  [SMALL_STATE(5016)] = 161305,
  [SMALL_STATE(5017)] = 161349,
  [SMALL_STATE(5018)] = 161393,
  [SMALL_STATE(5019)] = 161437,
  [SMALL_STATE(5020)] = 161525,
  [SMALL_STATE(5021)] = 161569,
  [SMALL_STATE(5022)] = 161613,
  [SMALL_STATE(5023)] = 161657,
  [SMALL_STATE(5024)] = 161707,
  [SMALL_STATE(5025)] = 161757,
  [SMALL_STATE(5026)] = 161807,
  [SMALL_STATE(5027)] = 161857,
  [SMALL_STATE(5028)] = 161901,
  [SMALL_STATE(5029)] = 161951,
  [SMALL_STATE(5030)] = 161995,
  [SMALL_STATE(5031)] = 162045,
  [SMALL_STATE(5032)] = 162123,
  [SMALL_STATE(5033)] = 162173,
  [SMALL_STATE(5034)] = 162217,
  [SMALL_STATE(5035)] = 162287,
  [SMALL_STATE(5036)] = 162331,
  [SMALL_STATE(5037)] = 162375,
  [SMALL_STATE(5038)] = 162419,
  [SMALL_STATE(5039)] = 162497,
  [SMALL_STATE(5040)] = 162541,
  [SMALL_STATE(5041)] = 162589,
  [SMALL_STATE(5042)] = 162633,
  [SMALL_STATE(5043)] = 162677,
  [SMALL_STATE(5044)] = 162755,
  [SMALL_STATE(5045)] = 162799,
  [SMALL_STATE(5046)] = 162877,
  [SMALL_STATE(5047)] = 162921,
  [SMALL_STATE(5048)] = 162991,
  [SMALL_STATE(5049)] = 163041,
  [SMALL_STATE(5050)] = 163085,
  [SMALL_STATE(5051)] = 163129,
  [SMALL_STATE(5052)] = 163173,
  [SMALL_STATE(5053)] = 163259,
  [SMALL_STATE(5054)] = 163311,
  [SMALL_STATE(5055)] = 163397,
  [SMALL_STATE(5056)] = 163455,
  [SMALL_STATE(5057)] = 163513,
  [SMALL_STATE(5058)] = 163593,
  [SMALL_STATE(5059)] = 163637,
  [SMALL_STATE(5060)] = 163681,
  [SMALL_STATE(5061)] = 163725,
  [SMALL_STATE(5062)] = 163769,
  [SMALL_STATE(5063)] = 163813,
  [SMALL_STATE(5064)] = 163893,
  [SMALL_STATE(5065)] = 163971,
  [SMALL_STATE(5066)] = 164049,
  [SMALL_STATE(5067)] = 164099,
  [SMALL_STATE(5068)] = 164177,
  [SMALL_STATE(5069)] = 164221,
  [SMALL_STATE(5070)] = 164265,
  [SMALL_STATE(5071)] = 164311,
  [SMALL_STATE(5072)] = 164389,
  [SMALL_STATE(5073)] = 164467,
  [SMALL_STATE(5074)] = 164545,
  [SMALL_STATE(5075)] = 164595,
  [SMALL_STATE(5076)] = 164645,
  [SMALL_STATE(5077)] = 164723,
  [SMALL_STATE(5078)] = 164801,
  [SMALL_STATE(5079)] = 164879,
  [SMALL_STATE(5080)] = 164949,
  [SMALL_STATE(5081)] = 164993,
  [SMALL_STATE(5082)] = 165071,
  [SMALL_STATE(5083)] = 165149,
  [SMALL_STATE(5084)] = 165227,
  [SMALL_STATE(5085)] = 165271,
  [SMALL_STATE(5086)] = 165349,
  [SMALL_STATE(5087)] = 165427,
  [SMALL_STATE(5088)] = 165471,
  [SMALL_STATE(5089)] = 165515,
  [SMALL_STATE(5090)] = 165593,
  [SMALL_STATE(5091)] = 165637,
  [SMALL_STATE(5092)] = 165681,
  [SMALL_STATE(5093)] = 165725,
  [SMALL_STATE(5094)] = 165769,
  [SMALL_STATE(5095)] = 165813,
  [SMALL_STATE(5096)] = 165857,
  [SMALL_STATE(5097)] = 165943,
  [SMALL_STATE(5098)] = 165987,
  [SMALL_STATE(5099)] = 166035,
  [SMALL_STATE(5100)] = 166113,
  [SMALL_STATE(5101)] = 166159,
  [SMALL_STATE(5102)] = 166203,
  [SMALL_STATE(5103)] = 166247,
  [SMALL_STATE(5104)] = 166291,
  [SMALL_STATE(5105)] = 166335,
  [SMALL_STATE(5106)] = 166405,
  [SMALL_STATE(5107)] = 166449,
  [SMALL_STATE(5108)] = 166493,
  [SMALL_STATE(5109)] = 166537,
  [SMALL_STATE(5110)] = 166617,
  [SMALL_STATE(5111)] = 166661,
  [SMALL_STATE(5112)] = 166705,
  [SMALL_STATE(5113)] = 166749,
  [SMALL_STATE(5114)] = 166797,
  [SMALL_STATE(5115)] = 166841,
  [SMALL_STATE(5116)] = 166885,
  [SMALL_STATE(5117)] = 166929,
  [SMALL_STATE(5118)] = 166973,
  [SMALL_STATE(5119)] = 167017,
  [SMALL_STATE(5120)] = 167061,
  [SMALL_STATE(5121)] = 167118,
  [SMALL_STATE(5122)] = 167187,
  [SMALL_STATE(5123)] = 167256,
  [SMALL_STATE(5124)] = 167325,
  [SMALL_STATE(5125)] = 167378,
  [SMALL_STATE(5126)] = 167421,
  [SMALL_STATE(5127)] = 167464,
  [SMALL_STATE(5128)] = 167507,
  [SMALL_STATE(5129)] = 167550,
  [SMALL_STATE(5130)] = 167595,
  [SMALL_STATE(5131)] = 167654,
  [SMALL_STATE(5132)] = 167697,
  [SMALL_STATE(5133)] = 167740,
  [SMALL_STATE(5134)] = 167795,
  [SMALL_STATE(5135)] = 167864,
  [SMALL_STATE(5136)] = 167907,
  [SMALL_STATE(5137)] = 167950,
  [SMALL_STATE(5138)] = 167993,
  [SMALL_STATE(5139)] = 168036,
  [SMALL_STATE(5140)] = 168079,
  [SMALL_STATE(5141)] = 168122,
  [SMALL_STATE(5142)] = 168179,
  [SMALL_STATE(5143)] = 168238,
  [SMALL_STATE(5144)] = 168281,
  [SMALL_STATE(5145)] = 168324,
  [SMALL_STATE(5146)] = 168415,
  [SMALL_STATE(5147)] = 168458,
  [SMALL_STATE(5148)] = 168501,
  [SMALL_STATE(5149)] = 168558,
  [SMALL_STATE(5150)] = 168601,
  [SMALL_STATE(5151)] = 168676,
  [SMALL_STATE(5152)] = 168719,
  [SMALL_STATE(5153)] = 168762,
  [SMALL_STATE(5154)] = 168837,
  [SMALL_STATE(5155)] = 168880,
  [SMALL_STATE(5156)] = 168935,
  [SMALL_STATE(5157)] = 168978,
  [SMALL_STATE(5158)] = 169021,
  [SMALL_STATE(5159)] = 169064,
  [SMALL_STATE(5160)] = 169107,
  [SMALL_STATE(5161)] = 169150,
  [SMALL_STATE(5162)] = 169219,
  [SMALL_STATE(5163)] = 169288,
  [SMALL_STATE(5164)] = 169357,
  [SMALL_STATE(5165)] = 169426,
  [SMALL_STATE(5166)] = 169469,
  [SMALL_STATE(5167)] = 169512,
  [SMALL_STATE(5168)] = 169555,
  [SMALL_STATE(5169)] = 169598,
  [SMALL_STATE(5170)] = 169641,
  [SMALL_STATE(5171)] = 169726,
  [SMALL_STATE(5172)] = 169811,
  [SMALL_STATE(5173)] = 169854,
  [SMALL_STATE(5174)] = 169905,
  [SMALL_STATE(5175)] = 169974,
  [SMALL_STATE(5176)] = 170017,
  [SMALL_STATE(5177)] = 170060,
  [SMALL_STATE(5178)] = 170103,
  [SMALL_STATE(5179)] = 170146,
  [SMALL_STATE(5180)] = 170189,
  [SMALL_STATE(5181)] = 170232,
  [SMALL_STATE(5182)] = 170289,
  [SMALL_STATE(5183)] = 170332,
  [SMALL_STATE(5184)] = 170401,
  [SMALL_STATE(5185)] = 170444,
  [SMALL_STATE(5186)] = 170513,
  [SMALL_STATE(5187)] = 170556,
  [SMALL_STATE(5188)] = 170641,
  [SMALL_STATE(5189)] = 170710,
  [SMALL_STATE(5190)] = 170795,
  [SMALL_STATE(5191)] = 170864,
  [SMALL_STATE(5192)] = 170933,
  [SMALL_STATE(5193)] = 171002,
  [SMALL_STATE(5194)] = 171071,
  [SMALL_STATE(5195)] = 171114,
  [SMALL_STATE(5196)] = 171190,
  [SMALL_STATE(5197)] = 171266,
  [SMALL_STATE(5198)] = 171342,
  [SMALL_STATE(5199)] = 171418,
  [SMALL_STATE(5200)] = 171494,
  [SMALL_STATE(5201)] = 171570,
  [SMALL_STATE(5202)] = 171646,
  [SMALL_STATE(5203)] = 171722,
  [SMALL_STATE(5204)] = 171798,
  [SMALL_STATE(5205)] = 171874,
  [SMALL_STATE(5206)] = 171950,
  [SMALL_STATE(5207)] = 172026,
  [SMALL_STATE(5208)] = 172102,
  [SMALL_STATE(5209)] = 172178,
  [SMALL_STATE(5210)] = 172254,
  [SMALL_STATE(5211)] = 172332,
  [SMALL_STATE(5212)] = 172410,
  [SMALL_STATE(5213)] = 172486,
  [SMALL_STATE(5214)] = 172564,
  [SMALL_STATE(5215)] = 172648,
  [SMALL_STATE(5216)] = 172726,
  [SMALL_STATE(5217)] = 172802,
  [SMALL_STATE(5218)] = 172886,
  [SMALL_STATE(5219)] = 172970,
  [SMALL_STATE(5220)] = 173038,
  [SMALL_STATE(5221)] = 173106,
  [SMALL_STATE(5222)] = 173162,
  [SMALL_STATE(5223)] = 173218,
  [SMALL_STATE(5224)] = 173294,
  [SMALL_STATE(5225)] = 173370,
  [SMALL_STATE(5226)] = 173446,
  [SMALL_STATE(5227)] = 173514,
  [SMALL_STATE(5228)] = 173590,
  [SMALL_STATE(5229)] = 173674,
  [SMALL_STATE(5230)] = 173758,
  [SMALL_STATE(5231)] = 173826,
  [SMALL_STATE(5232)] = 173878,
  [SMALL_STATE(5233)] = 173930,
  [SMALL_STATE(5234)] = 174014,
  [SMALL_STATE(5235)] = 174090,
  [SMALL_STATE(5236)] = 174166,
  [SMALL_STATE(5237)] = 174212,
  [SMALL_STATE(5238)] = 174288,
  [SMALL_STATE(5239)] = 174372,
  [SMALL_STATE(5240)] = 174449,
  [SMALL_STATE(5241)] = 174516,
  [SMALL_STATE(5242)] = 174593,
  [SMALL_STATE(5243)] = 174670,
  [SMALL_STATE(5244)] = 174747,
  [SMALL_STATE(5245)] = 174814,
  [SMALL_STATE(5246)] = 174891,
  [SMALL_STATE(5247)] = 174940,
  [SMALL_STATE(5248)] = 174989,
  [SMALL_STATE(5249)] = 175066,
  [SMALL_STATE(5250)] = 175119,
  [SMALL_STATE(5251)] = 175196,
  [SMALL_STATE(5252)] = 175263,
  [SMALL_STATE(5253)] = 175330,
  [SMALL_STATE(5254)] = 175407,
  [SMALL_STATE(5255)] = 175483,
  [SMALL_STATE(5256)] = 175533,
  [SMALL_STATE(5257)] = 175577,
  [SMALL_STATE(5258)] = 175621,
  [SMALL_STATE(5259)] = 175687,
  [SMALL_STATE(5260)] = 175731,
  [SMALL_STATE(5261)] = 175811,
  [SMALL_STATE(5262)] = 175891,
  [SMALL_STATE(5263)] = 175971,
  [SMALL_STATE(5264)] = 176051,
  [SMALL_STATE(5265)] = 176127,
  [SMALL_STATE(5266)] = 176197,
  [SMALL_STATE(5267)] = 176279,
  [SMALL_STATE(5268)] = 176333,
  [SMALL_STATE(5269)] = 176413,
  [SMALL_STATE(5270)] = 176493,
  [SMALL_STATE(5271)] = 176573,
  [SMALL_STATE(5272)] = 176617,
  [SMALL_STATE(5273)] = 176683,
  [SMALL_STATE(5274)] = 176727,
  [SMALL_STATE(5275)] = 176771,
  [SMALL_STATE(5276)] = 176815,
  [SMALL_STATE(5277)] = 176859,
  [SMALL_STATE(5278)] = 176939,
  [SMALL_STATE(5279)] = 176995,
  [SMALL_STATE(5280)] = 177075,
  [SMALL_STATE(5281)] = 177145,
  [SMALL_STATE(5282)] = 177215,
  [SMALL_STATE(5283)] = 177285,
  [SMALL_STATE(5284)] = 177351,
  [SMALL_STATE(5285)] = 177433,
  [SMALL_STATE(5286)] = 177499,
  [SMALL_STATE(5287)] = 177543,
  [SMALL_STATE(5288)] = 177613,
  [SMALL_STATE(5289)] = 177683,
  [SMALL_STATE(5290)] = 177765,
  [SMALL_STATE(5291)] = 177819,
  [SMALL_STATE(5292)] = 177889,
  [SMALL_STATE(5293)] = 177959,
  [SMALL_STATE(5294)] = 178039,
  [SMALL_STATE(5295)] = 178115,
  [SMALL_STATE(5296)] = 178185,
  [SMALL_STATE(5297)] = 178231,
  [SMALL_STATE(5298)] = 178277,
  [SMALL_STATE(5299)] = 178323,
  [SMALL_STATE(5300)] = 178369,
  [SMALL_STATE(5301)] = 178439,
  [SMALL_STATE(5302)] = 178485,
  [SMALL_STATE(5303)] = 178531,
  [SMALL_STATE(5304)] = 178601,
  [SMALL_STATE(5305)] = 178647,
  [SMALL_STATE(5306)] = 178727,
  [SMALL_STATE(5307)] = 178773,
  [SMALL_STATE(5308)] = 178819,
  [SMALL_STATE(5309)] = 178865,
  [SMALL_STATE(5310)] = 178907,
  [SMALL_STATE(5311)] = 178953,
  [SMALL_STATE(5312)] = 178999,
  [SMALL_STATE(5313)] = 179043,
  [SMALL_STATE(5314)] = 179113,
  [SMALL_STATE(5315)] = 179157,
  [SMALL_STATE(5316)] = 179201,
  [SMALL_STATE(5317)] = 179277,
  [SMALL_STATE(5318)] = 179333,
  [SMALL_STATE(5319)] = 179413,
  [SMALL_STATE(5320)] = 179489,
  [SMALL_STATE(5321)] = 179571,
  [SMALL_STATE(5322)] = 179651,
  [SMALL_STATE(5323)] = 179733,
  [SMALL_STATE(5324)] = 179813,
  [SMALL_STATE(5325)] = 179889,
  [SMALL_STATE(5326)] = 179969,
  [SMALL_STATE(5327)] = 180045,
  [SMALL_STATE(5328)] = 180125,
  [SMALL_STATE(5329)] = 180201,
  [SMALL_STATE(5330)] = 180281,
  [SMALL_STATE(5331)] = 180361,
  [SMALL_STATE(5332)] = 180404,
  [SMALL_STATE(5333)] = 180485,
  [SMALL_STATE(5334)] = 180566,
  [SMALL_STATE(5335)] = 180647,
  [SMALL_STATE(5336)] = 180728,
  [SMALL_STATE(5337)] = 180809,
  [SMALL_STATE(5338)] = 180890,
  [SMALL_STATE(5339)] = 180971,
  [SMALL_STATE(5340)] = 181052,
  [SMALL_STATE(5341)] = 181133,
  [SMALL_STATE(5342)] = 181214,
  [SMALL_STATE(5343)] = 181295,
  [SMALL_STATE(5344)] = 181376,
  [SMALL_STATE(5345)] = 181457,
  [SMALL_STATE(5346)] = 181538,
  [SMALL_STATE(5347)] = 181613,
  [SMALL_STATE(5348)] = 181664,
  [SMALL_STATE(5349)] = 181739,
  [SMALL_STATE(5350)] = 181820,
  [SMALL_STATE(5351)] = 181901,
  [SMALL_STATE(5352)] = 181982,
  [SMALL_STATE(5353)] = 182063,
  [SMALL_STATE(5354)] = 182144,
  [SMALL_STATE(5355)] = 182225,
  [SMALL_STATE(5356)] = 182306,
  [SMALL_STATE(5357)] = 182387,
  [SMALL_STATE(5358)] = 182456,
  [SMALL_STATE(5359)] = 182537,
  [SMALL_STATE(5360)] = 182618,
  [SMALL_STATE(5361)] = 182699,
  [SMALL_STATE(5362)] = 182780,
  [SMALL_STATE(5363)] = 182849,
  [SMALL_STATE(5364)] = 182930,
  [SMALL_STATE(5365)] = 183011,
  [SMALL_STATE(5366)] = 183092,
  [SMALL_STATE(5367)] = 183173,
  [SMALL_STATE(5368)] = 183254,
  [SMALL_STATE(5369)] = 183335,
  [SMALL_STATE(5370)] = 183416,
  [SMALL_STATE(5371)] = 183497,
  [SMALL_STATE(5372)] = 183578,
  [SMALL_STATE(5373)] = 183653,
  [SMALL_STATE(5374)] = 183722,
  [SMALL_STATE(5375)] = 183803,
  [SMALL_STATE(5376)] = 183884,
  [SMALL_STATE(5377)] = 183965,
  [SMALL_STATE(5378)] = 184046,
  [SMALL_STATE(5379)] = 184127,
  [SMALL_STATE(5380)] = 184208,
  [SMALL_STATE(5381)] = 184283,
  [SMALL_STATE(5382)] = 184352,
  [SMALL_STATE(5383)] = 184427,
  [SMALL_STATE(5384)] = 184508,
  [SMALL_STATE(5385)] = 184589,
  [SMALL_STATE(5386)] = 184670,
  [SMALL_STATE(5387)] = 184745,
  [SMALL_STATE(5388)] = 184820,
  [SMALL_STATE(5389)] = 184901,
  [SMALL_STATE(5390)] = 184982,
  [SMALL_STATE(5391)] = 185057,
  [SMALL_STATE(5392)] = 185138,
  [SMALL_STATE(5393)] = 185219,
  [SMALL_STATE(5394)] = 185300,
  [SMALL_STATE(5395)] = 185381,
  [SMALL_STATE(5396)] = 185462,
  [SMALL_STATE(5397)] = 185543,
  [SMALL_STATE(5398)] = 185624,
  [SMALL_STATE(5399)] = 185705,
  [SMALL_STATE(5400)] = 185786,
  [SMALL_STATE(5401)] = 185867,
  [SMALL_STATE(5402)] = 185948,
  [SMALL_STATE(5403)] = 186029,
  [SMALL_STATE(5404)] = 186110,
  [SMALL_STATE(5405)] = 186191,
  [SMALL_STATE(5406)] = 186272,
  [SMALL_STATE(5407)] = 186353,
  [SMALL_STATE(5408)] = 186434,
  [SMALL_STATE(5409)] = 186515,
  [SMALL_STATE(5410)] = 186596,
  [SMALL_STATE(5411)] = 186677,
  [SMALL_STATE(5412)] = 186758,
  [SMALL_STATE(5413)] = 186839,
  [SMALL_STATE(5414)] = 186920,
  [SMALL_STATE(5415)] = 187001,
  [SMALL_STATE(5416)] = 187082,
  [SMALL_STATE(5417)] = 187163,
  [SMALL_STATE(5418)] = 187244,
  [SMALL_STATE(5419)] = 187325,
  [SMALL_STATE(5420)] = 187406,
  [SMALL_STATE(5421)] = 187487,
  [SMALL_STATE(5422)] = 187568,
  [SMALL_STATE(5423)] = 187649,
  [SMALL_STATE(5424)] = 187724,
  [SMALL_STATE(5425)] = 187793,
  [SMALL_STATE(5426)] = 187868,
  [SMALL_STATE(5427)] = 187949,
  [SMALL_STATE(5428)] = 188030,
  [SMALL_STATE(5429)] = 188111,
  [SMALL_STATE(5430)] = 188192,
  [SMALL_STATE(5431)] = 188273,
  [SMALL_STATE(5432)] = 188354,
  [SMALL_STATE(5433)] = 188429,
  [SMALL_STATE(5434)] = 188504,
  [SMALL_STATE(5435)] = 188547,
  [SMALL_STATE(5436)] = 188590,
  [SMALL_STATE(5437)] = 188633,
  [SMALL_STATE(5438)] = 188676,
  [SMALL_STATE(5439)] = 188757,
  [SMALL_STATE(5440)] = 188800,
  [SMALL_STATE(5441)] = 188843,
  [SMALL_STATE(5442)] = 188886,
  [SMALL_STATE(5443)] = 188967,
  [SMALL_STATE(5444)] = 189010,
  [SMALL_STATE(5445)] = 189053,
  [SMALL_STATE(5446)] = 189096,
  [SMALL_STATE(5447)] = 189139,
  [SMALL_STATE(5448)] = 189220,
  [SMALL_STATE(5449)] = 189301,
  [SMALL_STATE(5450)] = 189382,
  [SMALL_STATE(5451)] = 189463,
  [SMALL_STATE(5452)] = 189544,
  [SMALL_STATE(5453)] = 189625,
  [SMALL_STATE(5454)] = 189706,
  [SMALL_STATE(5455)] = 189757,
  [SMALL_STATE(5456)] = 189838,
  [SMALL_STATE(5457)] = 189919,
  [SMALL_STATE(5458)] = 189988,
  [SMALL_STATE(5459)] = 190069,
  [SMALL_STATE(5460)] = 190139,
  [SMALL_STATE(5461)] = 190213,
  [SMALL_STATE(5462)] = 190287,
  [SMALL_STATE(5463)] = 190361,
  [SMALL_STATE(5464)] = 190435,
  [SMALL_STATE(5465)] = 190513,
  [SMALL_STATE(5466)] = 190591,
  [SMALL_STATE(5467)] = 190665,
  [SMALL_STATE(5468)] = 190735,
  [SMALL_STATE(5469)] = 190809,
  [SMALL_STATE(5470)] = 190887,
  [SMALL_STATE(5471)] = 190965,
  [SMALL_STATE(5472)] = 191039,
  [SMALL_STATE(5473)] = 191117,
  [SMALL_STATE(5474)] = 191191,
  [SMALL_STATE(5475)] = 191265,
  [SMALL_STATE(5476)] = 191339,
  [SMALL_STATE(5477)] = 191413,
  [SMALL_STATE(5478)] = 191487,
  [SMALL_STATE(5479)] = 191561,
  [SMALL_STATE(5480)] = 191635,
  [SMALL_STATE(5481)] = 191713,
  [SMALL_STATE(5482)] = 191787,
  [SMALL_STATE(5483)] = 191861,
  [SMALL_STATE(5484)] = 191935,
  [SMALL_STATE(5485)] = 192013,
  [SMALL_STATE(5486)] = 192091,
  [SMALL_STATE(5487)] = 192161,
  [SMALL_STATE(5488)] = 192225,
  [SMALL_STATE(5489)] = 192299,
  [SMALL_STATE(5490)] = 192377,
  [SMALL_STATE(5491)] = 192451,
  [SMALL_STATE(5492)] = 192525,
  [SMALL_STATE(5493)] = 192603,
  [SMALL_STATE(5494)] = 192681,
  [SMALL_STATE(5495)] = 192745,
  [SMALL_STATE(5496)] = 192815,
  [SMALL_STATE(5497)] = 192893,
  [SMALL_STATE(5498)] = 192967,
  [SMALL_STATE(5499)] = 193045,
  [SMALL_STATE(5500)] = 193119,
  [SMALL_STATE(5501)] = 193193,
  [SMALL_STATE(5502)] = 193267,
  [SMALL_STATE(5503)] = 193341,
  [SMALL_STATE(5504)] = 193415,
  [SMALL_STATE(5505)] = 193485,
  [SMALL_STATE(5506)] = 193559,
  [SMALL_STATE(5507)] = 193633,
  [SMALL_STATE(5508)] = 193707,
  [SMALL_STATE(5509)] = 193781,
  [SMALL_STATE(5510)] = 193855,
  [SMALL_STATE(5511)] = 193933,
  [SMALL_STATE(5512)] = 194007,
  [SMALL_STATE(5513)] = 194081,
  [SMALL_STATE(5514)] = 194159,
  [SMALL_STATE(5515)] = 194237,
  [SMALL_STATE(5516)] = 194307,
  [SMALL_STATE(5517)] = 194381,
  [SMALL_STATE(5518)] = 194459,
  [SMALL_STATE(5519)] = 194523,
  [SMALL_STATE(5520)] = 194597,
  [SMALL_STATE(5521)] = 194675,
  [SMALL_STATE(5522)] = 194745,
  [SMALL_STATE(5523)] = 194819,
  [SMALL_STATE(5524)] = 194893,
  [SMALL_STATE(5525)] = 194967,
  [SMALL_STATE(5526)] = 195041,
  [SMALL_STATE(5527)] = 195111,
  [SMALL_STATE(5528)] = 195185,
  [SMALL_STATE(5529)] = 195255,
  [SMALL_STATE(5530)] = 195300,
  [SMALL_STATE(5531)] = 195367,
  [SMALL_STATE(5532)] = 195434,
  [SMALL_STATE(5533)] = 195501,
  [SMALL_STATE(5534)] = 195568,
  [SMALL_STATE(5535)] = 195635,
  [SMALL_STATE(5536)] = 195702,
  [SMALL_STATE(5537)] = 195769,
  [SMALL_STATE(5538)] = 195836,
  [SMALL_STATE(5539)] = 195903,
  [SMALL_STATE(5540)] = 195970,
  [SMALL_STATE(5541)] = 196037,
  [SMALL_STATE(5542)] = 196104,
  [SMALL_STATE(5543)] = 196171,
  [SMALL_STATE(5544)] = 196238,
  [SMALL_STATE(5545)] = 196305,
  [SMALL_STATE(5546)] = 196378,
  [SMALL_STATE(5547)] = 196445,
  [SMALL_STATE(5548)] = 196512,
  [SMALL_STATE(5549)] = 196579,
  [SMALL_STATE(5550)] = 196646,
  [SMALL_STATE(5551)] = 196719,
  [SMALL_STATE(5552)] = 196792,
  [SMALL_STATE(5553)] = 196859,
  [SMALL_STATE(5554)] = 196926,
  [SMALL_STATE(5555)] = 196993,
  [SMALL_STATE(5556)] = 197066,
  [SMALL_STATE(5557)] = 197107,
  [SMALL_STATE(5558)] = 197180,
  [SMALL_STATE(5559)] = 197247,
  [SMALL_STATE(5560)] = 197314,
  [SMALL_STATE(5561)] = 197381,
  [SMALL_STATE(5562)] = 197454,
  [SMALL_STATE(5563)] = 197521,
  [SMALL_STATE(5564)] = 197594,
  [SMALL_STATE(5565)] = 197667,
  [SMALL_STATE(5566)] = 197734,
  [SMALL_STATE(5567)] = 197779,
  [SMALL_STATE(5568)] = 197846,
  [SMALL_STATE(5569)] = 197913,
  [SMALL_STATE(5570)] = 197986,
  [SMALL_STATE(5571)] = 198053,
  [SMALL_STATE(5572)] = 198120,
  [SMALL_STATE(5573)] = 198187,
  [SMALL_STATE(5574)] = 198254,
  [SMALL_STATE(5575)] = 198321,
  [SMALL_STATE(5576)] = 198388,
  [SMALL_STATE(5577)] = 198455,
  [SMALL_STATE(5578)] = 198522,
  [SMALL_STATE(5579)] = 198589,
  [SMALL_STATE(5580)] = 198656,
  [SMALL_STATE(5581)] = 198699,
  [SMALL_STATE(5582)] = 198766,
  [SMALL_STATE(5583)] = 198833,
  [SMALL_STATE(5584)] = 198900,
  [SMALL_STATE(5585)] = 198973,
  [SMALL_STATE(5586)] = 199040,
  [SMALL_STATE(5587)] = 199107,
  [SMALL_STATE(5588)] = 199174,
  [SMALL_STATE(5589)] = 199241,
  [SMALL_STATE(5590)] = 199308,
  [SMALL_STATE(5591)] = 199374,
  [SMALL_STATE(5592)] = 199440,
  [SMALL_STATE(5593)] = 199506,
  [SMALL_STATE(5594)] = 199572,
  [SMALL_STATE(5595)] = 199638,
  [SMALL_STATE(5596)] = 199704,
  [SMALL_STATE(5597)] = 199744,
  [SMALL_STATE(5598)] = 199810,
  [SMALL_STATE(5599)] = 199876,
  [SMALL_STATE(5600)] = 199942,
  [SMALL_STATE(5601)] = 200008,
  [SMALL_STATE(5602)] = 200074,
  [SMALL_STATE(5603)] = 200140,
  [SMALL_STATE(5604)] = 200193,
  [SMALL_STATE(5605)] = 200258,
  [SMALL_STATE(5606)] = 200323,
  [SMALL_STATE(5607)] = 200388,
  [SMALL_STATE(5608)] = 200453,
  [SMALL_STATE(5609)] = 200518,
  [SMALL_STATE(5610)] = 200583,
  [SMALL_STATE(5611)] = 200648,
  [SMALL_STATE(5612)] = 200713,
  [SMALL_STATE(5613)] = 200778,
  [SMALL_STATE(5614)] = 200815,
  [SMALL_STATE(5615)] = 200880,
  [SMALL_STATE(5616)] = 200945,
  [SMALL_STATE(5617)] = 201010,
  [SMALL_STATE(5618)] = 201068,
  [SMALL_STATE(5619)] = 201126,
  [SMALL_STATE(5620)] = 201190,
  [SMALL_STATE(5621)] = 201254,
  [SMALL_STATE(5622)] = 201318,
  [SMALL_STATE(5623)] = 201382,
  [SMALL_STATE(5624)] = 201446,
  [SMALL_STATE(5625)] = 201510,
  [SMALL_STATE(5626)] = 201574,
  [SMALL_STATE(5627)] = 201632,
  [SMALL_STATE(5628)] = 201696,
  [SMALL_STATE(5629)] = 201754,
  [SMALL_STATE(5630)] = 201818,
  [SMALL_STATE(5631)] = 201882,
  [SMALL_STATE(5632)] = 201946,
  [SMALL_STATE(5633)] = 202010,
  [SMALL_STATE(5634)] = 202074,
  [SMALL_STATE(5635)] = 202138,
  [SMALL_STATE(5636)] = 202202,
  [SMALL_STATE(5637)] = 202266,
  [SMALL_STATE(5638)] = 202330,
  [SMALL_STATE(5639)] = 202394,
  [SMALL_STATE(5640)] = 202455,
  [SMALL_STATE(5641)] = 202516,
  [SMALL_STATE(5642)] = 202553,
  [SMALL_STATE(5643)] = 202614,
  [SMALL_STATE(5644)] = 202675,
  [SMALL_STATE(5645)] = 202736,
  [SMALL_STATE(5646)] = 202797,
  [SMALL_STATE(5647)] = 202858,
  [SMALL_STATE(5648)] = 202893,
  [SMALL_STATE(5649)] = 202955,
  [SMALL_STATE(5650)] = 203029,
  [SMALL_STATE(5651)] = 203091,
  [SMALL_STATE(5652)] = 203153,
  [SMALL_STATE(5653)] = 203215,
  [SMALL_STATE(5654)] = 203277,
  [SMALL_STATE(5655)] = 203339,
  [SMALL_STATE(5656)] = 203401,
  [SMALL_STATE(5657)] = 203463,
  [SMALL_STATE(5658)] = 203525,
  [SMALL_STATE(5659)] = 203587,
  [SMALL_STATE(5660)] = 203649,
  [SMALL_STATE(5661)] = 203723,
  [SMALL_STATE(5662)] = 203797,
  [SMALL_STATE(5663)] = 203851,
  [SMALL_STATE(5664)] = 203913,
  [SMALL_STATE(5665)] = 203975,
  [SMALL_STATE(5666)] = 204037,
  [SMALL_STATE(5667)] = 204099,
  [SMALL_STATE(5668)] = 204130,
  [SMALL_STATE(5669)] = 204177,
  [SMALL_STATE(5670)] = 204226,
  [SMALL_STATE(5671)] = 204268,
  [SMALL_STATE(5672)] = 204320,
  [SMALL_STATE(5673)] = 204372,
  [SMALL_STATE(5674)] = 204424,
  [SMALL_STATE(5675)] = 204476,
  [SMALL_STATE(5676)] = 204528,
  [SMALL_STATE(5677)] = 204580,
  [SMALL_STATE(5678)] = 204650,
  [SMALL_STATE(5679)] = 204702,
  [SMALL_STATE(5680)] = 204754,
  [SMALL_STATE(5681)] = 204806,
  [SMALL_STATE(5682)] = 204858,
  [SMALL_STATE(5683)] = 204910,
  [SMALL_STATE(5684)] = 204940,
  [SMALL_STATE(5685)] = 204982,
  [SMALL_STATE(5686)] = 205024,
  [SMALL_STATE(5687)] = 205066,
  [SMALL_STATE(5688)] = 205108,
  [SMALL_STATE(5689)] = 205138,
  [SMALL_STATE(5690)] = 205190,
  [SMALL_STATE(5691)] = 205242,
  [SMALL_STATE(5692)] = 205272,
  [SMALL_STATE(5693)] = 205324,
  [SMALL_STATE(5694)] = 205376,
  [SMALL_STATE(5695)] = 205428,
  [SMALL_STATE(5696)] = 205458,
  [SMALL_STATE(5697)] = 205510,
  [SMALL_STATE(5698)] = 205562,
  [SMALL_STATE(5699)] = 205614,
  [SMALL_STATE(5700)] = 205666,
  [SMALL_STATE(5701)] = 205718,
  [SMALL_STATE(5702)] = 205770,
  [SMALL_STATE(5703)] = 205822,
  [SMALL_STATE(5704)] = 205874,
  [SMALL_STATE(5705)] = 205926,
  [SMALL_STATE(5706)] = 205978,
  [SMALL_STATE(5707)] = 206030,
  [SMALL_STATE(5708)] = 206100,
  [SMALL_STATE(5709)] = 206152,
  [SMALL_STATE(5710)] = 206182,
  [SMALL_STATE(5711)] = 206234,
  [SMALL_STATE(5712)] = 206286,
  [SMALL_STATE(5713)] = 206356,
  [SMALL_STATE(5714)] = 206402,
  [SMALL_STATE(5715)] = 206444,
  [SMALL_STATE(5716)] = 206496,
  [SMALL_STATE(5717)] = 206548,
  [SMALL_STATE(5718)] = 206600,
  [SMALL_STATE(5719)] = 206642,
  [SMALL_STATE(5720)] = 206684,
  [SMALL_STATE(5721)] = 206736,
  [SMALL_STATE(5722)] = 206788,
  [SMALL_STATE(5723)] = 206840,
  [SMALL_STATE(5724)] = 206874,
  [SMALL_STATE(5725)] = 206926,
  [SMALL_STATE(5726)] = 206978,
  [SMALL_STATE(5727)] = 207030,
  [SMALL_STATE(5728)] = 207082,
  [SMALL_STATE(5729)] = 207134,
  [SMALL_STATE(5730)] = 207193,
  [SMALL_STATE(5731)] = 207252,
  [SMALL_STATE(5732)] = 207311,
  [SMALL_STATE(5733)] = 207370,
  [SMALL_STATE(5734)] = 207429,
  [SMALL_STATE(5735)] = 207488,
  [SMALL_STATE(5736)] = 207547,
  [SMALL_STATE(5737)] = 207606,
  [SMALL_STATE(5738)] = 207659,
  [SMALL_STATE(5739)] = 207718,
  [SMALL_STATE(5740)] = 207777,
  [SMALL_STATE(5741)] = 207836,
  [SMALL_STATE(5742)] = 207895,
  [SMALL_STATE(5743)] = 207948,
  [SMALL_STATE(5744)] = 208007,
  [SMALL_STATE(5745)] = 208066,
  [SMALL_STATE(5746)] = 208125,
  [SMALL_STATE(5747)] = 208184,
  [SMALL_STATE(5748)] = 208243,
  [SMALL_STATE(5749)] = 208302,
  [SMALL_STATE(5750)] = 208361,
  [SMALL_STATE(5751)] = 208420,
  [SMALL_STATE(5752)] = 208479,
  [SMALL_STATE(5753)] = 208538,
  [SMALL_STATE(5754)] = 208597,
  [SMALL_STATE(5755)] = 208656,
  [SMALL_STATE(5756)] = 208687,
  [SMALL_STATE(5757)] = 208750,
  [SMALL_STATE(5758)] = 208809,
  [SMALL_STATE(5759)] = 208868,
  [SMALL_STATE(5760)] = 208927,
  [SMALL_STATE(5761)] = 208986,
  [SMALL_STATE(5762)] = 209045,
  [SMALL_STATE(5763)] = 209104,
  [SMALL_STATE(5764)] = 209163,
  [SMALL_STATE(5765)] = 209222,
  [SMALL_STATE(5766)] = 209255,
  [SMALL_STATE(5767)] = 209314,
  [SMALL_STATE(5768)] = 209373,
  [SMALL_STATE(5769)] = 209432,
  [SMALL_STATE(5770)] = 209491,
  [SMALL_STATE(5771)] = 209550,
  [SMALL_STATE(5772)] = 209609,
  [SMALL_STATE(5773)] = 209652,
  [SMALL_STATE(5774)] = 209711,
  [SMALL_STATE(5775)] = 209770,
  [SMALL_STATE(5776)] = 209829,
  [SMALL_STATE(5777)] = 209888,
  [SMALL_STATE(5778)] = 209943,
  [SMALL_STATE(5779)] = 210002,
  [SMALL_STATE(5780)] = 210061,
  [SMALL_STATE(5781)] = 210116,
  [SMALL_STATE(5782)] = 210145,
  [SMALL_STATE(5783)] = 210204,
  [SMALL_STATE(5784)] = 210263,
  [SMALL_STATE(5785)] = 210310,
  [SMALL_STATE(5786)] = 210369,
  [SMALL_STATE(5787)] = 210428,
  [SMALL_STATE(5788)] = 210487,
  [SMALL_STATE(5789)] = 210546,
  [SMALL_STATE(5790)] = 210605,
  [SMALL_STATE(5791)] = 210664,
  [SMALL_STATE(5792)] = 210723,
  [SMALL_STATE(5793)] = 210782,
  [SMALL_STATE(5794)] = 210841,
  [SMALL_STATE(5795)] = 210900,
  [SMALL_STATE(5796)] = 210959,
  [SMALL_STATE(5797)] = 211018,
  [SMALL_STATE(5798)] = 211077,
  [SMALL_STATE(5799)] = 211136,
  [SMALL_STATE(5800)] = 211189,
  [SMALL_STATE(5801)] = 211248,
  [SMALL_STATE(5802)] = 211277,
  [SMALL_STATE(5803)] = 211336,
  [SMALL_STATE(5804)] = 211379,
  [SMALL_STATE(5805)] = 211408,
  [SMALL_STATE(5806)] = 211467,
  [SMALL_STATE(5807)] = 211526,
  [SMALL_STATE(5808)] = 211585,
  [SMALL_STATE(5809)] = 211644,
  [SMALL_STATE(5810)] = 211703,
  [SMALL_STATE(5811)] = 211762,
  [SMALL_STATE(5812)] = 211821,
  [SMALL_STATE(5813)] = 211880,
  [SMALL_STATE(5814)] = 211909,
  [SMALL_STATE(5815)] = 211968,
  [SMALL_STATE(5816)] = 212027,
  [SMALL_STATE(5817)] = 212066,
  [SMALL_STATE(5818)] = 212105,
  [SMALL_STATE(5819)] = 212160,
  [SMALL_STATE(5820)] = 212207,
  [SMALL_STATE(5821)] = 212266,
  [SMALL_STATE(5822)] = 212325,
  [SMALL_STATE(5823)] = 212384,
  [SMALL_STATE(5824)] = 212443,
  [SMALL_STATE(5825)] = 212502,
  [SMALL_STATE(5826)] = 212561,
  [SMALL_STATE(5827)] = 212620,
  [SMALL_STATE(5828)] = 212679,
  [SMALL_STATE(5829)] = 212738,
  [SMALL_STATE(5830)] = 212767,
  [SMALL_STATE(5831)] = 212826,
  [SMALL_STATE(5832)] = 212885,
  [SMALL_STATE(5833)] = 212924,
  [SMALL_STATE(5834)] = 212983,
  [SMALL_STATE(5835)] = 213042,
  [SMALL_STATE(5836)] = 213101,
  [SMALL_STATE(5837)] = 213144,
  [SMALL_STATE(5838)] = 213203,
  [SMALL_STATE(5839)] = 213242,
  [SMALL_STATE(5840)] = 213301,
  [SMALL_STATE(5841)] = 213360,
  [SMALL_STATE(5842)] = 213419,
  [SMALL_STATE(5843)] = 213455,
  [SMALL_STATE(5844)] = 213505,
  [SMALL_STATE(5845)] = 213545,
  [SMALL_STATE(5846)] = 213585,
  [SMALL_STATE(5847)] = 213629,
  [SMALL_STATE(5848)] = 213675,
  [SMALL_STATE(5849)] = 213725,
  [SMALL_STATE(5850)] = 213775,
  [SMALL_STATE(5851)] = 213827,
  [SMALL_STATE(5852)] = 213855,
  [SMALL_STATE(5853)] = 213905,
  [SMALL_STATE(5854)] = 213955,
  [SMALL_STATE(5855)] = 214019,
  [SMALL_STATE(5856)] = 214059,
  [SMALL_STATE(5857)] = 214099,
  [SMALL_STATE(5858)] = 214127,
  [SMALL_STATE(5859)] = 214167,
  [SMALL_STATE(5860)] = 214203,
  [SMALL_STATE(5861)] = 214253,
  [SMALL_STATE(5862)] = 214317,
  [SMALL_STATE(5863)] = 214357,
  [SMALL_STATE(5864)] = 214385,
  [SMALL_STATE(5865)] = 214437,
  [SMALL_STATE(5866)] = 214477,
  [SMALL_STATE(5867)] = 214529,
  [SMALL_STATE(5868)] = 214557,
  [SMALL_STATE(5869)] = 214607,
  [SMALL_STATE(5870)] = 214643,
  [SMALL_STATE(5871)] = 214695,
  [SMALL_STATE(5872)] = 214735,
  [SMALL_STATE(5873)] = 214785,
  [SMALL_STATE(5874)] = 214837,
  [SMALL_STATE(5875)] = 214865,
  [SMALL_STATE(5876)] = 214929,
  [SMALL_STATE(5877)] = 214969,
  [SMALL_STATE(5878)] = 214997,
  [SMALL_STATE(5879)] = 215025,
  [SMALL_STATE(5880)] = 215065,
  [SMALL_STATE(5881)] = 215101,
  [SMALL_STATE(5882)] = 215145,
  [SMALL_STATE(5883)] = 215187,
  [SMALL_STATE(5884)] = 215227,
  [SMALL_STATE(5885)] = 215267,
  [SMALL_STATE(5886)] = 215319,
  [SMALL_STATE(5887)] = 215371,
  [SMALL_STATE(5888)] = 215421,
  [SMALL_STATE(5889)] = 215473,
  [SMALL_STATE(5890)] = 215537,
  [SMALL_STATE(5891)] = 215589,
  [SMALL_STATE(5892)] = 215641,
  [SMALL_STATE(5893)] = 215669,
  [SMALL_STATE(5894)] = 215697,
  [SMALL_STATE(5895)] = 215737,
  [SMALL_STATE(5896)] = 215777,
  [SMALL_STATE(5897)] = 215805,
  [SMALL_STATE(5898)] = 215835,
  [SMALL_STATE(5899)] = 215875,
  [SMALL_STATE(5900)] = 215903,
  [SMALL_STATE(5901)] = 215955,
  [SMALL_STATE(5902)] = 215987,
  [SMALL_STATE(5903)] = 216027,
  [SMALL_STATE(5904)] = 216067,
  [SMALL_STATE(5905)] = 216117,
  [SMALL_STATE(5906)] = 216169,
  [SMALL_STATE(5907)] = 216219,
  [SMALL_STATE(5908)] = 216271,
  [SMALL_STATE(5909)] = 216321,
  [SMALL_STATE(5910)] = 216357,
  [SMALL_STATE(5911)] = 216391,
  [SMALL_STATE(5912)] = 216431,
  [SMALL_STATE(5913)] = 216481,
  [SMALL_STATE(5914)] = 216517,
  [SMALL_STATE(5915)] = 216545,
  [SMALL_STATE(5916)] = 216585,
  [SMALL_STATE(5917)] = 216649,
  [SMALL_STATE(5918)] = 216689,
  [SMALL_STATE(5919)] = 216739,
  [SMALL_STATE(5920)] = 216767,
  [SMALL_STATE(5921)] = 216807,
  [SMALL_STATE(5922)] = 216847,
  [SMALL_STATE(5923)] = 216899,
  [SMALL_STATE(5924)] = 216927,
  [SMALL_STATE(5925)] = 216967,
  [SMALL_STATE(5926)] = 217031,
  [SMALL_STATE(5927)] = 217071,
  [SMALL_STATE(5928)] = 217099,
  [SMALL_STATE(5929)] = 217127,
  [SMALL_STATE(5930)] = 217179,
  [SMALL_STATE(5931)] = 217219,
  [SMALL_STATE(5932)] = 217247,
  [SMALL_STATE(5933)] = 217297,
  [SMALL_STATE(5934)] = 217325,
  [SMALL_STATE(5935)] = 217365,
  [SMALL_STATE(5936)] = 217429,
  [SMALL_STATE(5937)] = 217457,
  [SMALL_STATE(5938)] = 217509,
  [SMALL_STATE(5939)] = 217549,
  [SMALL_STATE(5940)] = 217589,
  [SMALL_STATE(5941)] = 217637,
  [SMALL_STATE(5942)] = 217677,
  [SMALL_STATE(5943)] = 217717,
  [SMALL_STATE(5944)] = 217757,
  [SMALL_STATE(5945)] = 217797,
  [SMALL_STATE(5946)] = 217837,
  [SMALL_STATE(5947)] = 217901,
  [SMALL_STATE(5948)] = 217953,
  [SMALL_STATE(5949)] = 218017,
  [SMALL_STATE(5950)] = 218045,
  [SMALL_STATE(5951)] = 218097,
  [SMALL_STATE(5952)] = 218149,
  [SMALL_STATE(5953)] = 218213,
  [SMALL_STATE(5954)] = 218253,
  [SMALL_STATE(5955)] = 218317,
  [SMALL_STATE(5956)] = 218381,
  [SMALL_STATE(5957)] = 218431,
  [SMALL_STATE(5958)] = 218471,
  [SMALL_STATE(5959)] = 218521,
  [SMALL_STATE(5960)] = 218549,
  [SMALL_STATE(5961)] = 218601,
  [SMALL_STATE(5962)] = 218629,
  [SMALL_STATE(5963)] = 218681,
  [SMALL_STATE(5964)] = 218733,
  [SMALL_STATE(5965)] = 218761,
  [SMALL_STATE(5966)] = 218801,
  [SMALL_STATE(5967)] = 218837,
  [SMALL_STATE(5968)] = 218873,
  [SMALL_STATE(5969)] = 218901,
  [SMALL_STATE(5970)] = 218941,
  [SMALL_STATE(5971)] = 218993,
  [SMALL_STATE(5972)] = 219043,
  [SMALL_STATE(5973)] = 219095,
  [SMALL_STATE(5974)] = 219147,
  [SMALL_STATE(5975)] = 219199,
  [SMALL_STATE(5976)] = 219263,
  [SMALL_STATE(5977)] = 219309,
  [SMALL_STATE(5978)] = 219373,
  [SMALL_STATE(5979)] = 219413,
  [SMALL_STATE(5980)] = 219449,
  [SMALL_STATE(5981)] = 219489,
  [SMALL_STATE(5982)] = 219517,
  [SMALL_STATE(5983)] = 219569,
  [SMALL_STATE(5984)] = 219605,
  [SMALL_STATE(5985)] = 219649,
  [SMALL_STATE(5986)] = 219701,
  [SMALL_STATE(5987)] = 219729,
  [SMALL_STATE(5988)] = 219765,
  [SMALL_STATE(5989)] = 219793,
  [SMALL_STATE(5990)] = 219843,
  [SMALL_STATE(5991)] = 219875,
  [SMALL_STATE(5992)] = 219915,
  [SMALL_STATE(5993)] = 219942,
  [SMALL_STATE(5994)] = 219989,
  [SMALL_STATE(5995)] = 220016,
  [SMALL_STATE(5996)] = 220071,
  [SMALL_STATE(5997)] = 220118,
  [SMALL_STATE(5998)] = 220165,
  [SMALL_STATE(5999)] = 220212,
  [SMALL_STATE(6000)] = 220259,
  [SMALL_STATE(6001)] = 220304,
  [SMALL_STATE(6002)] = 220335,
  [SMALL_STATE(6003)] = 220390,
  [SMALL_STATE(6004)] = 220421,
  [SMALL_STATE(6005)] = 220448,
  [SMALL_STATE(6006)] = 220483,
  [SMALL_STATE(6007)] = 220538,
  [SMALL_STATE(6008)] = 220565,
  [SMALL_STATE(6009)] = 220594,
  [SMALL_STATE(6010)] = 220639,
  [SMALL_STATE(6011)] = 220674,
  [SMALL_STATE(6012)] = 220719,
  [SMALL_STATE(6013)] = 220746,
  [SMALL_STATE(6014)] = 220791,
  [SMALL_STATE(6015)] = 220836,
  [SMALL_STATE(6016)] = 220881,
  [SMALL_STATE(6017)] = 220938,
  [SMALL_STATE(6018)] = 220973,
  [SMALL_STATE(6019)] = 221000,
  [SMALL_STATE(6020)] = 221031,
  [SMALL_STATE(6021)] = 221078,
  [SMALL_STATE(6022)] = 221113,
  [SMALL_STATE(6023)] = 221160,
  [SMALL_STATE(6024)] = 221205,
  [SMALL_STATE(6025)] = 221262,
  [SMALL_STATE(6026)] = 221317,
  [SMALL_STATE(6027)] = 221372,
  [SMALL_STATE(6028)] = 221417,
  [SMALL_STATE(6029)] = 221474,
  [SMALL_STATE(6030)] = 221509,
  [SMALL_STATE(6031)] = 221566,
  [SMALL_STATE(6032)] = 221613,
  [SMALL_STATE(6033)] = 221656,
  [SMALL_STATE(6034)] = 221701,
  [SMALL_STATE(6035)] = 221736,
  [SMALL_STATE(6036)] = 221771,
  [SMALL_STATE(6037)] = 221806,
  [SMALL_STATE(6038)] = 221853,
  [SMALL_STATE(6039)] = 221900,
  [SMALL_STATE(6040)] = 221945,
  [SMALL_STATE(6041)] = 221990,
  [SMALL_STATE(6042)] = 222035,
  [SMALL_STATE(6043)] = 222080,
  [SMALL_STATE(6044)] = 222137,
  [SMALL_STATE(6045)] = 222172,
  [SMALL_STATE(6046)] = 222219,
  [SMALL_STATE(6047)] = 222268,
  [SMALL_STATE(6048)] = 222303,
  [SMALL_STATE(6049)] = 222334,
  [SMALL_STATE(6050)] = 222361,
  [SMALL_STATE(6051)] = 222388,
  [SMALL_STATE(6052)] = 222445,
  [SMALL_STATE(6053)] = 222494,
  [SMALL_STATE(6054)] = 222541,
  [SMALL_STATE(6055)] = 222568,
  [SMALL_STATE(6056)] = 222595,
  [SMALL_STATE(6057)] = 222626,
  [SMALL_STATE(6058)] = 222653,
  [SMALL_STATE(6059)] = 222680,
  [SMALL_STATE(6060)] = 222707,
  [SMALL_STATE(6061)] = 222734,
  [SMALL_STATE(6062)] = 222761,
  [SMALL_STATE(6063)] = 222788,
  [SMALL_STATE(6064)] = 222843,
  [SMALL_STATE(6065)] = 222870,
  [SMALL_STATE(6066)] = 222897,
  [SMALL_STATE(6067)] = 222924,
  [SMALL_STATE(6068)] = 222953,
  [SMALL_STATE(6069)] = 222980,
  [SMALL_STATE(6070)] = 223025,
  [SMALL_STATE(6071)] = 223068,
  [SMALL_STATE(6072)] = 223109,
  [SMALL_STATE(6073)] = 223148,
  [SMALL_STATE(6074)] = 223185,
  [SMALL_STATE(6075)] = 223220,
  [SMALL_STATE(6076)] = 223253,
  [SMALL_STATE(6077)] = 223284,
  [SMALL_STATE(6078)] = 223329,
  [SMALL_STATE(6079)] = 223356,
  [SMALL_STATE(6080)] = 223383,
  [SMALL_STATE(6081)] = 223410,
  [SMALL_STATE(6082)] = 223437,
  [SMALL_STATE(6083)] = 223464,
  [SMALL_STATE(6084)] = 223491,
  [SMALL_STATE(6085)] = 223518,
  [SMALL_STATE(6086)] = 223575,
  [SMALL_STATE(6087)] = 223605,
  [SMALL_STATE(6088)] = 223643,
  [SMALL_STATE(6089)] = 223681,
  [SMALL_STATE(6090)] = 223735,
  [SMALL_STATE(6091)] = 223789,
  [SMALL_STATE(6092)] = 223827,
  [SMALL_STATE(6093)] = 223865,
  [SMALL_STATE(6094)] = 223903,
  [SMALL_STATE(6095)] = 223941,
  [SMALL_STATE(6096)] = 223979,
  [SMALL_STATE(6097)] = 224017,
  [SMALL_STATE(6098)] = 224055,
  [SMALL_STATE(6099)] = 224093,
  [SMALL_STATE(6100)] = 224131,
  [SMALL_STATE(6101)] = 224179,
  [SMALL_STATE(6102)] = 224217,
  [SMALL_STATE(6103)] = 224255,
  [SMALL_STATE(6104)] = 224303,
  [SMALL_STATE(6105)] = 224357,
  [SMALL_STATE(6106)] = 224405,
  [SMALL_STATE(6107)] = 224443,
  [SMALL_STATE(6108)] = 224473,
  [SMALL_STATE(6109)] = 224503,
  [SMALL_STATE(6110)] = 224533,
  [SMALL_STATE(6111)] = 224587,
  [SMALL_STATE(6112)] = 224629,
  [SMALL_STATE(6113)] = 224683,
  [SMALL_STATE(6114)] = 224731,
  [SMALL_STATE(6115)] = 224785,
  [SMALL_STATE(6116)] = 224819,
  [SMALL_STATE(6117)] = 224853,
  [SMALL_STATE(6118)] = 224887,
  [SMALL_STATE(6119)] = 224921,
  [SMALL_STATE(6120)] = 224959,
  [SMALL_STATE(6121)] = 224993,
  [SMALL_STATE(6122)] = 225027,
  [SMALL_STATE(6123)] = 225061,
  [SMALL_STATE(6124)] = 225095,
  [SMALL_STATE(6125)] = 225149,
  [SMALL_STATE(6126)] = 225187,
  [SMALL_STATE(6127)] = 225220,
  [SMALL_STATE(6128)] = 225261,
  [SMALL_STATE(6129)] = 225304,
  [SMALL_STATE(6130)] = 225347,
  [SMALL_STATE(6131)] = 225388,
  [SMALL_STATE(6132)] = 225425,
  [SMALL_STATE(6133)] = 225462,
  [SMALL_STATE(6134)] = 225499,
  [SMALL_STATE(6135)] = 225536,
  [SMALL_STATE(6136)] = 225561,
  [SMALL_STATE(6137)] = 225598,
  [SMALL_STATE(6138)] = 225627,
  [SMALL_STATE(6139)] = 225676,
  [SMALL_STATE(6140)] = 225707,
  [SMALL_STATE(6141)] = 225744,
  [SMALL_STATE(6142)] = 225781,
  [SMALL_STATE(6143)] = 225818,
  [SMALL_STATE(6144)] = 225843,
  [SMALL_STATE(6145)] = 225886,
  [SMALL_STATE(6146)] = 225917,
  [SMALL_STATE(6147)] = 225960,
  [SMALL_STATE(6148)] = 226009,
  [SMALL_STATE(6149)] = 226058,
  [SMALL_STATE(6150)] = 226101,
  [SMALL_STATE(6151)] = 226150,
  [SMALL_STATE(6152)] = 226179,
  [SMALL_STATE(6153)] = 226208,
  [SMALL_STATE(6154)] = 226257,
  [SMALL_STATE(6155)] = 226300,
  [SMALL_STATE(6156)] = 226331,
  [SMALL_STATE(6157)] = 226380,
  [SMALL_STATE(6158)] = 226411,
  [SMALL_STATE(6159)] = 226452,
  [SMALL_STATE(6160)] = 226492,
  [SMALL_STATE(6161)] = 226532,
  [SMALL_STATE(6162)] = 226556,
  [SMALL_STATE(6163)] = 226588,
  [SMALL_STATE(6164)] = 226614,
  [SMALL_STATE(6165)] = 226654,
  [SMALL_STATE(6166)] = 226694,
  [SMALL_STATE(6167)] = 226718,
  [SMALL_STATE(6168)] = 226742,
  [SMALL_STATE(6169)] = 226782,
  [SMALL_STATE(6170)] = 226806,
  [SMALL_STATE(6171)] = 226834,
  [SMALL_STATE(6172)] = 226880,
  [SMALL_STATE(6173)] = 226904,
  [SMALL_STATE(6174)] = 226928,
  [SMALL_STATE(6175)] = 226952,
  [SMALL_STATE(6176)] = 226986,
  [SMALL_STATE(6177)] = 227010,
  [SMALL_STATE(6178)] = 227034,
  [SMALL_STATE(6179)] = 227058,
  [SMALL_STATE(6180)] = 227082,
  [SMALL_STATE(6181)] = 227122,
  [SMALL_STATE(6182)] = 227146,
  [SMALL_STATE(6183)] = 227170,
  [SMALL_STATE(6184)] = 227194,
  [SMALL_STATE(6185)] = 227224,
  [SMALL_STATE(6186)] = 227264,
  [SMALL_STATE(6187)] = 227288,
  [SMALL_STATE(6188)] = 227324,
  [SMALL_STATE(6189)] = 227360,
  [SMALL_STATE(6190)] = 227396,
  [SMALL_STATE(6191)] = 227432,
  [SMALL_STATE(6192)] = 227456,
  [SMALL_STATE(6193)] = 227496,
  [SMALL_STATE(6194)] = 227532,
  [SMALL_STATE(6195)] = 227568,
  [SMALL_STATE(6196)] = 227604,
  [SMALL_STATE(6197)] = 227640,
  [SMALL_STATE(6198)] = 227680,
  [SMALL_STATE(6199)] = 227704,
  [SMALL_STATE(6200)] = 227736,
  [SMALL_STATE(6201)] = 227760,
  [SMALL_STATE(6202)] = 227784,
  [SMALL_STATE(6203)] = 227816,
  [SMALL_STATE(6204)] = 227840,
  [SMALL_STATE(6205)] = 227870,
  [SMALL_STATE(6206)] = 227894,
  [SMALL_STATE(6207)] = 227928,
  [SMALL_STATE(6208)] = 227968,
  [SMALL_STATE(6209)] = 227992,
  [SMALL_STATE(6210)] = 228016,
  [SMALL_STATE(6211)] = 228048,
  [SMALL_STATE(6212)] = 228080,
  [SMALL_STATE(6213)] = 228116,
  [SMALL_STATE(6214)] = 228152,
  [SMALL_STATE(6215)] = 228188,
  [SMALL_STATE(6216)] = 228224,
  [SMALL_STATE(6217)] = 228260,
  [SMALL_STATE(6218)] = 228296,
  [SMALL_STATE(6219)] = 228332,
  [SMALL_STATE(6220)] = 228368,
  [SMALL_STATE(6221)] = 228392,
  [SMALL_STATE(6222)] = 228424,
  [SMALL_STATE(6223)] = 228448,
  [SMALL_STATE(6224)] = 228488,
  [SMALL_STATE(6225)] = 228522,
  [SMALL_STATE(6226)] = 228554,
  [SMALL_STATE(6227)] = 228578,
  [SMALL_STATE(6228)] = 228602,
  [SMALL_STATE(6229)] = 228648,
  [SMALL_STATE(6230)] = 228672,
  [SMALL_STATE(6231)] = 228698,
  [SMALL_STATE(6232)] = 228722,
  [SMALL_STATE(6233)] = 228746,
  [SMALL_STATE(6234)] = 228770,
  [SMALL_STATE(6235)] = 228810,
  [SMALL_STATE(6236)] = 228850,
  [SMALL_STATE(6237)] = 228890,
  [SMALL_STATE(6238)] = 228924,
  [SMALL_STATE(6239)] = 228964,
  [SMALL_STATE(6240)] = 229004,
  [SMALL_STATE(6241)] = 229028,
  [SMALL_STATE(6242)] = 229068,
  [SMALL_STATE(6243)] = 229092,
  [SMALL_STATE(6244)] = 229116,
  [SMALL_STATE(6245)] = 229148,
  [SMALL_STATE(6246)] = 229188,
  [SMALL_STATE(6247)] = 229234,
  [SMALL_STATE(6248)] = 229266,
  [SMALL_STATE(6249)] = 229290,
  [SMALL_STATE(6250)] = 229314,
  [SMALL_STATE(6251)] = 229338,
  [SMALL_STATE(6252)] = 229372,
  [SMALL_STATE(6253)] = 229412,
  [SMALL_STATE(6254)] = 229436,
  [SMALL_STATE(6255)] = 229478,
  [SMALL_STATE(6256)] = 229518,
  [SMALL_STATE(6257)] = 229542,
  [SMALL_STATE(6258)] = 229566,
  [SMALL_STATE(6259)] = 229590,
  [SMALL_STATE(6260)] = 229614,
  [SMALL_STATE(6261)] = 229646,
  [SMALL_STATE(6262)] = 229675,
  [SMALL_STATE(6263)] = 229706,
  [SMALL_STATE(6264)] = 229737,
  [SMALL_STATE(6265)] = 229768,
  [SMALL_STATE(6266)] = 229799,
  [SMALL_STATE(6267)] = 229824,
  [SMALL_STATE(6268)] = 229855,
  [SMALL_STATE(6269)] = 229886,
  [SMALL_STATE(6270)] = 229917,
  [SMALL_STATE(6271)] = 229948,
  [SMALL_STATE(6272)] = 229977,
  [SMALL_STATE(6273)] = 230010,
  [SMALL_STATE(6274)] = 230043,
  [SMALL_STATE(6275)] = 230082,
  [SMALL_STATE(6276)] = 230115,
  [SMALL_STATE(6277)] = 230148,
  [SMALL_STATE(6278)] = 230187,
  [SMALL_STATE(6279)] = 230214,
  [SMALL_STATE(6280)] = 230259,
  [SMALL_STATE(6281)] = 230292,
  [SMALL_STATE(6282)] = 230321,
  [SMALL_STATE(6283)] = 230354,
  [SMALL_STATE(6284)] = 230379,
  [SMALL_STATE(6285)] = 230408,
  [SMALL_STATE(6286)] = 230447,
  [SMALL_STATE(6287)] = 230474,
  [SMALL_STATE(6288)] = 230503,
  [SMALL_STATE(6289)] = 230530,
  [SMALL_STATE(6290)] = 230563,
  [SMALL_STATE(6291)] = 230592,
  [SMALL_STATE(6292)] = 230631,
  [SMALL_STATE(6293)] = 230660,
  [SMALL_STATE(6294)] = 230693,
  [SMALL_STATE(6295)] = 230726,
  [SMALL_STATE(6296)] = 230773,
  [SMALL_STATE(6297)] = 230802,
  [SMALL_STATE(6298)] = 230837,
  [SMALL_STATE(6299)] = 230866,
  [SMALL_STATE(6300)] = 230893,
  [SMALL_STATE(6301)] = 230916,
  [SMALL_STATE(6302)] = 230949,
  [SMALL_STATE(6303)] = 230978,
  [SMALL_STATE(6304)] = 231007,
  [SMALL_STATE(6305)] = 231046,
  [SMALL_STATE(6306)] = 231079,
  [SMALL_STATE(6307)] = 231108,
  [SMALL_STATE(6308)] = 231137,
  [SMALL_STATE(6309)] = 231176,
  [SMALL_STATE(6310)] = 231209,
  [SMALL_STATE(6311)] = 231254,
  [SMALL_STATE(6312)] = 231285,
  [SMALL_STATE(6313)] = 231314,
  [SMALL_STATE(6314)] = 231343,
  [SMALL_STATE(6315)] = 231374,
  [SMALL_STATE(6316)] = 231403,
  [SMALL_STATE(6317)] = 231442,
  [SMALL_STATE(6318)] = 231473,
  [SMALL_STATE(6319)] = 231504,
  [SMALL_STATE(6320)] = 231535,
  [SMALL_STATE(6321)] = 231570,
  [SMALL_STATE(6322)] = 231615,
  [SMALL_STATE(6323)] = 231644,
  [SMALL_STATE(6324)] = 231679,
  [SMALL_STATE(6325)] = 231714,
  [SMALL_STATE(6326)] = 231759,
  [SMALL_STATE(6327)] = 231794,
  [SMALL_STATE(6328)] = 231827,
  [SMALL_STATE(6329)] = 231856,
  [SMALL_STATE(6330)] = 231889,
  [SMALL_STATE(6331)] = 231916,
  [SMALL_STATE(6332)] = 231945,
  [SMALL_STATE(6333)] = 231974,
  [SMALL_STATE(6334)] = 232007,
  [SMALL_STATE(6335)] = 232038,
  [SMALL_STATE(6336)] = 232067,
  [SMALL_STATE(6337)] = 232096,
  [SMALL_STATE(6338)] = 232125,
  [SMALL_STATE(6339)] = 232154,
  [SMALL_STATE(6340)] = 232185,
  [SMALL_STATE(6341)] = 232208,
  [SMALL_STATE(6342)] = 232239,
  [SMALL_STATE(6343)] = 232270,
  [SMALL_STATE(6344)] = 232315,
  [SMALL_STATE(6345)] = 232346,
  [SMALL_STATE(6346)] = 232373,
  [SMALL_STATE(6347)] = 232406,
  [SMALL_STATE(6348)] = 232451,
  [SMALL_STATE(6349)] = 232496,
  [SMALL_STATE(6350)] = 232523,
  [SMALL_STATE(6351)] = 232554,
  [SMALL_STATE(6352)] = 232593,
  [SMALL_STATE(6353)] = 232624,
  [SMALL_STATE(6354)] = 232663,
  [SMALL_STATE(6355)] = 232695,
  [SMALL_STATE(6356)] = 232733,
  [SMALL_STATE(6357)] = 232773,
  [SMALL_STATE(6358)] = 232813,
  [SMALL_STATE(6359)] = 232845,
  [SMALL_STATE(6360)] = 232885,
  [SMALL_STATE(6361)] = 232925,
  [SMALL_STATE(6362)] = 232953,
  [SMALL_STATE(6363)] = 232981,
  [SMALL_STATE(6364)] = 233015,
  [SMALL_STATE(6365)] = 233055,
  [SMALL_STATE(6366)] = 233093,
  [SMALL_STATE(6367)] = 233131,
  [SMALL_STATE(6368)] = 233157,
  [SMALL_STATE(6369)] = 233197,
  [SMALL_STATE(6370)] = 233235,
  [SMALL_STATE(6371)] = 233273,
  [SMALL_STATE(6372)] = 233297,
  [SMALL_STATE(6373)] = 233331,
  [SMALL_STATE(6374)] = 233363,
  [SMALL_STATE(6375)] = 233403,
  [SMALL_STATE(6376)] = 233431,
  [SMALL_STATE(6377)] = 233465,
  [SMALL_STATE(6378)] = 233503,
  [SMALL_STATE(6379)] = 233537,
  [SMALL_STATE(6380)] = 233575,
  [SMALL_STATE(6381)] = 233609,
  [SMALL_STATE(6382)] = 233649,
  [SMALL_STATE(6383)] = 233689,
  [SMALL_STATE(6384)] = 233719,
  [SMALL_STATE(6385)] = 233749,
  [SMALL_STATE(6386)] = 233777,
  [SMALL_STATE(6387)] = 233807,
  [SMALL_STATE(6388)] = 233847,
  [SMALL_STATE(6389)] = 233877,
  [SMALL_STATE(6390)] = 233907,
  [SMALL_STATE(6391)] = 233947,
  [SMALL_STATE(6392)] = 233977,
  [SMALL_STATE(6393)] = 233999,
  [SMALL_STATE(6394)] = 234029,
  [SMALL_STATE(6395)] = 234059,
  [SMALL_STATE(6396)] = 234097,
  [SMALL_STATE(6397)] = 234135,
  [SMALL_STATE(6398)] = 234163,
  [SMALL_STATE(6399)] = 234185,
  [SMALL_STATE(6400)] = 234217,
  [SMALL_STATE(6401)] = 234249,
  [SMALL_STATE(6402)] = 234287,
  [SMALL_STATE(6403)] = 234325,
  [SMALL_STATE(6404)] = 234365,
  [SMALL_STATE(6405)] = 234403,
  [SMALL_STATE(6406)] = 234425,
  [SMALL_STATE(6407)] = 234463,
  [SMALL_STATE(6408)] = 234495,
  [SMALL_STATE(6409)] = 234527,
  [SMALL_STATE(6410)] = 234559,
  [SMALL_STATE(6411)] = 234591,
  [SMALL_STATE(6412)] = 234623,
  [SMALL_STATE(6413)] = 234663,
  [SMALL_STATE(6414)] = 234703,
  [SMALL_STATE(6415)] = 234743,
  [SMALL_STATE(6416)] = 234775,
  [SMALL_STATE(6417)] = 234813,
  [SMALL_STATE(6418)] = 234845,
  [SMALL_STATE(6419)] = 234867,
  [SMALL_STATE(6420)] = 234899,
  [SMALL_STATE(6421)] = 234939,
  [SMALL_STATE(6422)] = 234979,
  [SMALL_STATE(6423)] = 235017,
  [SMALL_STATE(6424)] = 235045,
  [SMALL_STATE(6425)] = 235083,
  [SMALL_STATE(6426)] = 235123,
  [SMALL_STATE(6427)] = 235161,
  [SMALL_STATE(6428)] = 235189,
  [SMALL_STATE(6429)] = 235217,
  [SMALL_STATE(6430)] = 235255,
  [SMALL_STATE(6431)] = 235295,
  [SMALL_STATE(6432)] = 235333,
  [SMALL_STATE(6433)] = 235373,
  [SMALL_STATE(6434)] = 235395,
  [SMALL_STATE(6435)] = 235435,
  [SMALL_STATE(6436)] = 235468,
  [SMALL_STATE(6437)] = 235495,
  [SMALL_STATE(6438)] = 235522,
  [SMALL_STATE(6439)] = 235549,
  [SMALL_STATE(6440)] = 235582,
  [SMALL_STATE(6441)] = 235603,
  [SMALL_STATE(6442)] = 235638,
  [SMALL_STATE(6443)] = 235665,
  [SMALL_STATE(6444)] = 235702,
  [SMALL_STATE(6445)] = 235729,
  [SMALL_STATE(6446)] = 235750,
  [SMALL_STATE(6447)] = 235777,
  [SMALL_STATE(6448)] = 235812,
  [SMALL_STATE(6449)] = 235845,
  [SMALL_STATE(6450)] = 235878,
  [SMALL_STATE(6451)] = 235913,
  [SMALL_STATE(6452)] = 235952,
  [SMALL_STATE(6453)] = 235985,
  [SMALL_STATE(6454)] = 236018,
  [SMALL_STATE(6455)] = 236039,
  [SMALL_STATE(6456)] = 236078,
  [SMALL_STATE(6457)] = 236113,
  [SMALL_STATE(6458)] = 236152,
  [SMALL_STATE(6459)] = 236173,
  [SMALL_STATE(6460)] = 236194,
  [SMALL_STATE(6461)] = 236215,
  [SMALL_STATE(6462)] = 236240,
  [SMALL_STATE(6463)] = 236275,
  [SMALL_STATE(6464)] = 236296,
  [SMALL_STATE(6465)] = 236329,
  [SMALL_STATE(6466)] = 236350,
  [SMALL_STATE(6467)] = 236371,
  [SMALL_STATE(6468)] = 236392,
  [SMALL_STATE(6469)] = 236425,
  [SMALL_STATE(6470)] = 236446,
  [SMALL_STATE(6471)] = 236467,
  [SMALL_STATE(6472)] = 236488,
  [SMALL_STATE(6473)] = 236525,
  [SMALL_STATE(6474)] = 236558,
  [SMALL_STATE(6475)] = 236579,
  [SMALL_STATE(6476)] = 236600,
  [SMALL_STATE(6477)] = 236633,
  [SMALL_STATE(6478)] = 236654,
  [SMALL_STATE(6479)] = 236675,
  [SMALL_STATE(6480)] = 236696,
  [SMALL_STATE(6481)] = 236717,
  [SMALL_STATE(6482)] = 236748,
  [SMALL_STATE(6483)] = 236779,
  [SMALL_STATE(6484)] = 236800,
  [SMALL_STATE(6485)] = 236833,
  [SMALL_STATE(6486)] = 236860,
  [SMALL_STATE(6487)] = 236893,
  [SMALL_STATE(6488)] = 236926,
  [SMALL_STATE(6489)] = 236963,
  [SMALL_STATE(6490)] = 236996,
  [SMALL_STATE(6491)] = 237031,
  [SMALL_STATE(6492)] = 237068,
  [SMALL_STATE(6493)] = 237089,
  [SMALL_STATE(6494)] = 237122,
  [SMALL_STATE(6495)] = 237157,
  [SMALL_STATE(6496)] = 237190,
  [SMALL_STATE(6497)] = 237223,
  [SMALL_STATE(6498)] = 237244,
  [SMALL_STATE(6499)] = 237277,
  [SMALL_STATE(6500)] = 237310,
  [SMALL_STATE(6501)] = 237345,
  [SMALL_STATE(6502)] = 237384,
  [SMALL_STATE(6503)] = 237409,
  [SMALL_STATE(6504)] = 237442,
  [SMALL_STATE(6505)] = 237467,
  [SMALL_STATE(6506)] = 237500,
  [SMALL_STATE(6507)] = 237533,
  [SMALL_STATE(6508)] = 237554,
  [SMALL_STATE(6509)] = 237575,
  [SMALL_STATE(6510)] = 237596,
  [SMALL_STATE(6511)] = 237629,
  [SMALL_STATE(6512)] = 237668,
  [SMALL_STATE(6513)] = 237701,
  [SMALL_STATE(6514)] = 237736,
  [SMALL_STATE(6515)] = 237757,
  [SMALL_STATE(6516)] = 237784,
  [SMALL_STATE(6517)] = 237805,
  [SMALL_STATE(6518)] = 237826,
  [SMALL_STATE(6519)] = 237861,
  [SMALL_STATE(6520)] = 237896,
  [SMALL_STATE(6521)] = 237923,
  [SMALL_STATE(6522)] = 237954,
  [SMALL_STATE(6523)] = 237987,
  [SMALL_STATE(6524)] = 238020,
  [SMALL_STATE(6525)] = 238045,
  [SMALL_STATE(6526)] = 238078,
  [SMALL_STATE(6527)] = 238111,
  [SMALL_STATE(6528)] = 238142,
  [SMALL_STATE(6529)] = 238173,
  [SMALL_STATE(6530)] = 238194,
  [SMALL_STATE(6531)] = 238229,
  [SMALL_STATE(6532)] = 238257,
  [SMALL_STATE(6533)] = 238293,
  [SMALL_STATE(6534)] = 238321,
  [SMALL_STATE(6535)] = 238357,
  [SMALL_STATE(6536)] = 238393,
  [SMALL_STATE(6537)] = 238423,
  [SMALL_STATE(6538)] = 238453,
  [SMALL_STATE(6539)] = 238483,
  [SMALL_STATE(6540)] = 238513,
  [SMALL_STATE(6541)] = 238541,
  [SMALL_STATE(6542)] = 238571,
  [SMALL_STATE(6543)] = 238601,
  [SMALL_STATE(6544)] = 238631,
  [SMALL_STATE(6545)] = 238661,
  [SMALL_STATE(6546)] = 238689,
  [SMALL_STATE(6547)] = 238725,
  [SMALL_STATE(6548)] = 238745,
  [SMALL_STATE(6549)] = 238765,
  [SMALL_STATE(6550)] = 238793,
  [SMALL_STATE(6551)] = 238823,
  [SMALL_STATE(6552)] = 238843,
  [SMALL_STATE(6553)] = 238879,
  [SMALL_STATE(6554)] = 238915,
  [SMALL_STATE(6555)] = 238935,
  [SMALL_STATE(6556)] = 238955,
  [SMALL_STATE(6557)] = 238975,
  [SMALL_STATE(6558)] = 239011,
  [SMALL_STATE(6559)] = 239039,
  [SMALL_STATE(6560)] = 239075,
  [SMALL_STATE(6561)] = 239103,
  [SMALL_STATE(6562)] = 239131,
  [SMALL_STATE(6563)] = 239159,
  [SMALL_STATE(6564)] = 239189,
  [SMALL_STATE(6565)] = 239211,
  [SMALL_STATE(6566)] = 239247,
  [SMALL_STATE(6567)] = 239283,
  [SMALL_STATE(6568)] = 239311,
  [SMALL_STATE(6569)] = 239339,
  [SMALL_STATE(6570)] = 239367,
  [SMALL_STATE(6571)] = 239395,
  [SMALL_STATE(6572)] = 239415,
  [SMALL_STATE(6573)] = 239445,
  [SMALL_STATE(6574)] = 239465,
  [SMALL_STATE(6575)] = 239501,
  [SMALL_STATE(6576)] = 239529,
  [SMALL_STATE(6577)] = 239557,
  [SMALL_STATE(6578)] = 239585,
  [SMALL_STATE(6579)] = 239613,
  [SMALL_STATE(6580)] = 239649,
  [SMALL_STATE(6581)] = 239685,
  [SMALL_STATE(6582)] = 239721,
  [SMALL_STATE(6583)] = 239757,
  [SMALL_STATE(6584)] = 239777,
  [SMALL_STATE(6585)] = 239797,
  [SMALL_STATE(6586)] = 239827,
  [SMALL_STATE(6587)] = 239863,
  [SMALL_STATE(6588)] = 239899,
  [SMALL_STATE(6589)] = 239935,
  [SMALL_STATE(6590)] = 239955,
  [SMALL_STATE(6591)] = 239991,
  [SMALL_STATE(6592)] = 240027,
  [SMALL_STATE(6593)] = 240063,
  [SMALL_STATE(6594)] = 240099,
  [SMALL_STATE(6595)] = 240132,
  [SMALL_STATE(6596)] = 240167,
  [SMALL_STATE(6597)] = 240198,
  [SMALL_STATE(6598)] = 240217,
  [SMALL_STATE(6599)] = 240248,
  [SMALL_STATE(6600)] = 240279,
  [SMALL_STATE(6601)] = 240314,
  [SMALL_STATE(6602)] = 240349,
  [SMALL_STATE(6603)] = 240384,
  [SMALL_STATE(6604)] = 240413,
  [SMALL_STATE(6605)] = 240444,
  [SMALL_STATE(6606)] = 240469,
  [SMALL_STATE(6607)] = 240496,
  [SMALL_STATE(6608)] = 240527,
  [SMALL_STATE(6609)] = 240558,
  [SMALL_STATE(6610)] = 240587,
  [SMALL_STATE(6611)] = 240622,
  [SMALL_STATE(6612)] = 240647,
  [SMALL_STATE(6613)] = 240678,
  [SMALL_STATE(6614)] = 240713,
  [SMALL_STATE(6615)] = 240748,
  [SMALL_STATE(6616)] = 240783,
  [SMALL_STATE(6617)] = 240808,
  [SMALL_STATE(6618)] = 240839,
  [SMALL_STATE(6619)] = 240874,
  [SMALL_STATE(6620)] = 240899,
  [SMALL_STATE(6621)] = 240926,
  [SMALL_STATE(6622)] = 240961,
  [SMALL_STATE(6623)] = 240992,
  [SMALL_STATE(6624)] = 241023,
  [SMALL_STATE(6625)] = 241052,
  [SMALL_STATE(6626)] = 241087,
  [SMALL_STATE(6627)] = 241112,
  [SMALL_STATE(6628)] = 241137,
  [SMALL_STATE(6629)] = 241168,
  [SMALL_STATE(6630)] = 241203,
  [SMALL_STATE(6631)] = 241238,
  [SMALL_STATE(6632)] = 241263,
  [SMALL_STATE(6633)] = 241294,
  [SMALL_STATE(6634)] = 241319,
  [SMALL_STATE(6635)] = 241354,
  [SMALL_STATE(6636)] = 241389,
  [SMALL_STATE(6637)] = 241424,
  [SMALL_STATE(6638)] = 241455,
  [SMALL_STATE(6639)] = 241488,
  [SMALL_STATE(6640)] = 241523,
  [SMALL_STATE(6641)] = 241556,
  [SMALL_STATE(6642)] = 241591,
  [SMALL_STATE(6643)] = 241622,
  [SMALL_STATE(6644)] = 241649,
  [SMALL_STATE(6645)] = 241684,
  [SMALL_STATE(6646)] = 241715,
  [SMALL_STATE(6647)] = 241748,
  [SMALL_STATE(6648)] = 241783,
  [SMALL_STATE(6649)] = 241814,
  [SMALL_STATE(6650)] = 241841,
  [SMALL_STATE(6651)] = 241868,
  [SMALL_STATE(6652)] = 241897,
  [SMALL_STATE(6653)] = 241924,
  [SMALL_STATE(6654)] = 241943,
  [SMALL_STATE(6655)] = 241978,
  [SMALL_STATE(6656)] = 242009,
  [SMALL_STATE(6657)] = 242044,
  [SMALL_STATE(6658)] = 242075,
  [SMALL_STATE(6659)] = 242110,
  [SMALL_STATE(6660)] = 242135,
  [SMALL_STATE(6661)] = 242164,
  [SMALL_STATE(6662)] = 242189,
  [SMALL_STATE(6663)] = 242214,
  [SMALL_STATE(6664)] = 242239,
  [SMALL_STATE(6665)] = 242274,
  [SMALL_STATE(6666)] = 242309,
  [SMALL_STATE(6667)] = 242344,
  [SMALL_STATE(6668)] = 242379,
  [SMALL_STATE(6669)] = 242414,
  [SMALL_STATE(6670)] = 242449,
  [SMALL_STATE(6671)] = 242484,
  [SMALL_STATE(6672)] = 242519,
  [SMALL_STATE(6673)] = 242554,
  [SMALL_STATE(6674)] = 242583,
  [SMALL_STATE(6675)] = 242618,
  [SMALL_STATE(6676)] = 242653,
  [SMALL_STATE(6677)] = 242688,
  [SMALL_STATE(6678)] = 242723,
  [SMALL_STATE(6679)] = 242742,
  [SMALL_STATE(6680)] = 242773,
  [SMALL_STATE(6681)] = 242798,
  [SMALL_STATE(6682)] = 242823,
  [SMALL_STATE(6683)] = 242854,
  [SMALL_STATE(6684)] = 242883,
  [SMALL_STATE(6685)] = 242918,
  [SMALL_STATE(6686)] = 242943,
  [SMALL_STATE(6687)] = 242974,
  [SMALL_STATE(6688)] = 243009,
  [SMALL_STATE(6689)] = 243028,
  [SMALL_STATE(6690)] = 243057,
  [SMALL_STATE(6691)] = 243090,
  [SMALL_STATE(6692)] = 243125,
  [SMALL_STATE(6693)] = 243160,
  [SMALL_STATE(6694)] = 243195,
  [SMALL_STATE(6695)] = 243224,
  [SMALL_STATE(6696)] = 243251,
  [SMALL_STATE(6697)] = 243272,
  [SMALL_STATE(6698)] = 243299,
  [SMALL_STATE(6699)] = 243328,
  [SMALL_STATE(6700)] = 243355,
  [SMALL_STATE(6701)] = 243386,
  [SMALL_STATE(6702)] = 243415,
  [SMALL_STATE(6703)] = 243450,
  [SMALL_STATE(6704)] = 243481,
  [SMALL_STATE(6705)] = 243508,
  [SMALL_STATE(6706)] = 243535,
  [SMALL_STATE(6707)] = 243564,
  [SMALL_STATE(6708)] = 243595,
  [SMALL_STATE(6709)] = 243630,
  [SMALL_STATE(6710)] = 243665,
  [SMALL_STATE(6711)] = 243694,
  [SMALL_STATE(6712)] = 243723,
  [SMALL_STATE(6713)] = 243742,
  [SMALL_STATE(6714)] = 243765,
  [SMALL_STATE(6715)] = 243800,
  [SMALL_STATE(6716)] = 243819,
  [SMALL_STATE(6717)] = 243854,
  [SMALL_STATE(6718)] = 243889,
  [SMALL_STATE(6719)] = 243924,
  [SMALL_STATE(6720)] = 243951,
  [SMALL_STATE(6721)] = 243978,
  [SMALL_STATE(6722)] = 244005,
  [SMALL_STATE(6723)] = 244040,
  [SMALL_STATE(6724)] = 244071,
  [SMALL_STATE(6725)] = 244096,
  [SMALL_STATE(6726)] = 244127,
  [SMALL_STATE(6727)] = 244146,
  [SMALL_STATE(6728)] = 244177,
  [SMALL_STATE(6729)] = 244199,
  [SMALL_STATE(6730)] = 244221,
  [SMALL_STATE(6731)] = 244243,
  [SMALL_STATE(6732)] = 244265,
  [SMALL_STATE(6733)] = 244289,
  [SMALL_STATE(6734)] = 244317,
  [SMALL_STATE(6735)] = 244341,
  [SMALL_STATE(6736)] = 244365,
  [SMALL_STATE(6737)] = 244387,
  [SMALL_STATE(6738)] = 244409,
  [SMALL_STATE(6739)] = 244431,
  [SMALL_STATE(6740)] = 244453,
  [SMALL_STATE(6741)] = 244475,
  [SMALL_STATE(6742)] = 244505,
  [SMALL_STATE(6743)] = 244529,
  [SMALL_STATE(6744)] = 244559,
  [SMALL_STATE(6745)] = 244583,
  [SMALL_STATE(6746)] = 244605,
  [SMALL_STATE(6747)] = 244629,
  [SMALL_STATE(6748)] = 244653,
  [SMALL_STATE(6749)] = 244675,
  [SMALL_STATE(6750)] = 244699,
  [SMALL_STATE(6751)] = 244721,
  [SMALL_STATE(6752)] = 244743,
  [SMALL_STATE(6753)] = 244773,
  [SMALL_STATE(6754)] = 244803,
  [SMALL_STATE(6755)] = 244827,
  [SMALL_STATE(6756)] = 244851,
  [SMALL_STATE(6757)] = 244873,
  [SMALL_STATE(6758)] = 244897,
  [SMALL_STATE(6759)] = 244921,
  [SMALL_STATE(6760)] = 244951,
  [SMALL_STATE(6761)] = 244973,
  [SMALL_STATE(6762)] = 244997,
  [SMALL_STATE(6763)] = 245021,
  [SMALL_STATE(6764)] = 245045,
  [SMALL_STATE(6765)] = 245077,
  [SMALL_STATE(6766)] = 245104,
  [SMALL_STATE(6767)] = 245135,
  [SMALL_STATE(6768)] = 245166,
  [SMALL_STATE(6769)] = 245197,
  [SMALL_STATE(6770)] = 245224,
  [SMALL_STATE(6771)] = 245249,
  [SMALL_STATE(6772)] = 245276,
  [SMALL_STATE(6773)] = 245307,
  [SMALL_STATE(6774)] = 245338,
  [SMALL_STATE(6775)] = 245369,
  [SMALL_STATE(6776)] = 245400,
  [SMALL_STATE(6777)] = 245427,
  [SMALL_STATE(6778)] = 245454,
  [SMALL_STATE(6779)] = 245485,
  [SMALL_STATE(6780)] = 245510,
  [SMALL_STATE(6781)] = 245533,
  [SMALL_STATE(6782)] = 245558,
  [SMALL_STATE(6783)] = 245579,
  [SMALL_STATE(6784)] = 245604,
  [SMALL_STATE(6785)] = 245631,
  [SMALL_STATE(6786)] = 245658,
  [SMALL_STATE(6787)] = 245683,
  [SMALL_STATE(6788)] = 245708,
  [SMALL_STATE(6789)] = 245739,
  [SMALL_STATE(6790)] = 245766,
  [SMALL_STATE(6791)] = 245797,
  [SMALL_STATE(6792)] = 245824,
  [SMALL_STATE(6793)] = 245851,
  [SMALL_STATE(6794)] = 245882,
  [SMALL_STATE(6795)] = 245905,
  [SMALL_STATE(6796)] = 245926,
  [SMALL_STATE(6797)] = 245953,
  [SMALL_STATE(6798)] = 245976,
  [SMALL_STATE(6799)] = 246007,
  [SMALL_STATE(6800)] = 246034,
  [SMALL_STATE(6801)] = 246059,
  [SMALL_STATE(6802)] = 246090,
  [SMALL_STATE(6803)] = 246121,
  [SMALL_STATE(6804)] = 246152,
  [SMALL_STATE(6805)] = 246179,
  [SMALL_STATE(6806)] = 246206,
  [SMALL_STATE(6807)] = 246237,
  [SMALL_STATE(6808)] = 246260,
  [SMALL_STATE(6809)] = 246283,
  [SMALL_STATE(6810)] = 246306,
  [SMALL_STATE(6811)] = 246329,
  [SMALL_STATE(6812)] = 246350,
  [SMALL_STATE(6813)] = 246377,
  [SMALL_STATE(6814)] = 246402,
  [SMALL_STATE(6815)] = 246429,
  [SMALL_STATE(6816)] = 246460,
  [SMALL_STATE(6817)] = 246485,
  [SMALL_STATE(6818)] = 246508,
  [SMALL_STATE(6819)] = 246531,
  [SMALL_STATE(6820)] = 246556,
  [SMALL_STATE(6821)] = 246587,
  [SMALL_STATE(6822)] = 246618,
  [SMALL_STATE(6823)] = 246649,
  [SMALL_STATE(6824)] = 246680,
  [SMALL_STATE(6825)] = 246711,
  [SMALL_STATE(6826)] = 246738,
  [SMALL_STATE(6827)] = 246761,
  [SMALL_STATE(6828)] = 246792,
  [SMALL_STATE(6829)] = 246819,
  [SMALL_STATE(6830)] = 246840,
  [SMALL_STATE(6831)] = 246867,
  [SMALL_STATE(6832)] = 246894,
  [SMALL_STATE(6833)] = 246925,
  [SMALL_STATE(6834)] = 246956,
  [SMALL_STATE(6835)] = 246987,
  [SMALL_STATE(6836)] = 247018,
  [SMALL_STATE(6837)] = 247049,
  [SMALL_STATE(6838)] = 247076,
  [SMALL_STATE(6839)] = 247107,
  [SMALL_STATE(6840)] = 247138,
  [SMALL_STATE(6841)] = 247169,
  [SMALL_STATE(6842)] = 247200,
  [SMALL_STATE(6843)] = 247231,
  [SMALL_STATE(6844)] = 247256,
  [SMALL_STATE(6845)] = 247282,
  [SMALL_STATE(6846)] = 247308,
  [SMALL_STATE(6847)] = 247334,
  [SMALL_STATE(6848)] = 247354,
  [SMALL_STATE(6849)] = 247380,
  [SMALL_STATE(6850)] = 247402,
  [SMALL_STATE(6851)] = 247428,
  [SMALL_STATE(6852)] = 247450,
  [SMALL_STATE(6853)] = 247468,
  [SMALL_STATE(6854)] = 247490,
  [SMALL_STATE(6855)] = 247516,
  [SMALL_STATE(6856)] = 247532,
  [SMALL_STATE(6857)] = 247554,
  [SMALL_STATE(6858)] = 247574,
  [SMALL_STATE(6859)] = 247600,
  [SMALL_STATE(6860)] = 247626,
  [SMALL_STATE(6861)] = 247648,
  [SMALL_STATE(6862)] = 247674,
  [SMALL_STATE(6863)] = 247700,
  [SMALL_STATE(6864)] = 247726,
  [SMALL_STATE(6865)] = 247752,
  [SMALL_STATE(6866)] = 247778,
  [SMALL_STATE(6867)] = 247804,
  [SMALL_STATE(6868)] = 247830,
  [SMALL_STATE(6869)] = 247856,
  [SMALL_STATE(6870)] = 247882,
  [SMALL_STATE(6871)] = 247904,
  [SMALL_STATE(6872)] = 247922,
  [SMALL_STATE(6873)] = 247944,
  [SMALL_STATE(6874)] = 247970,
  [SMALL_STATE(6875)] = 247996,
  [SMALL_STATE(6876)] = 248022,
  [SMALL_STATE(6877)] = 248048,
  [SMALL_STATE(6878)] = 248070,
  [SMALL_STATE(6879)] = 248096,
  [SMALL_STATE(6880)] = 248122,
  [SMALL_STATE(6881)] = 248148,
  [SMALL_STATE(6882)] = 248170,
  [SMALL_STATE(6883)] = 248196,
  [SMALL_STATE(6884)] = 248222,
  [SMALL_STATE(6885)] = 248244,
  [SMALL_STATE(6886)] = 248266,
  [SMALL_STATE(6887)] = 248292,
  [SMALL_STATE(6888)] = 248314,
  [SMALL_STATE(6889)] = 248336,
  [SMALL_STATE(6890)] = 248356,
  [SMALL_STATE(6891)] = 248378,
  [SMALL_STATE(6892)] = 248398,
  [SMALL_STATE(6893)] = 248424,
  [SMALL_STATE(6894)] = 248446,
  [SMALL_STATE(6895)] = 248470,
  [SMALL_STATE(6896)] = 248494,
  [SMALL_STATE(6897)] = 248518,
  [SMALL_STATE(6898)] = 248542,
  [SMALL_STATE(6899)] = 248566,
  [SMALL_STATE(6900)] = 248588,
  [SMALL_STATE(6901)] = 248610,
  [SMALL_STATE(6902)] = 248632,
  [SMALL_STATE(6903)] = 248654,
  [SMALL_STATE(6904)] = 248676,
  [SMALL_STATE(6905)] = 248702,
  [SMALL_STATE(6906)] = 248728,
  [SMALL_STATE(6907)] = 248744,
  [SMALL_STATE(6908)] = 248770,
  [SMALL_STATE(6909)] = 248796,
  [SMALL_STATE(6910)] = 248822,
  [SMALL_STATE(6911)] = 248848,
  [SMALL_STATE(6912)] = 248870,
  [SMALL_STATE(6913)] = 248898,
  [SMALL_STATE(6914)] = 248924,
  [SMALL_STATE(6915)] = 248950,
  [SMALL_STATE(6916)] = 248972,
  [SMALL_STATE(6917)] = 248998,
  [SMALL_STATE(6918)] = 249020,
  [SMALL_STATE(6919)] = 249042,
  [SMALL_STATE(6920)] = 249068,
  [SMALL_STATE(6921)] = 249094,
  [SMALL_STATE(6922)] = 249120,
  [SMALL_STATE(6923)] = 249138,
  [SMALL_STATE(6924)] = 249159,
  [SMALL_STATE(6925)] = 249180,
  [SMALL_STATE(6926)] = 249201,
  [SMALL_STATE(6927)] = 249222,
  [SMALL_STATE(6928)] = 249243,
  [SMALL_STATE(6929)] = 249266,
  [SMALL_STATE(6930)] = 249291,
  [SMALL_STATE(6931)] = 249314,
  [SMALL_STATE(6932)] = 249339,
  [SMALL_STATE(6933)] = 249362,
  [SMALL_STATE(6934)] = 249387,
  [SMALL_STATE(6935)] = 249410,
  [SMALL_STATE(6936)] = 249429,
  [SMALL_STATE(6937)] = 249452,
  [SMALL_STATE(6938)] = 249469,
  [SMALL_STATE(6939)] = 249492,
  [SMALL_STATE(6940)] = 249509,
  [SMALL_STATE(6941)] = 249532,
  [SMALL_STATE(6942)] = 249555,
  [SMALL_STATE(6943)] = 249578,
  [SMALL_STATE(6944)] = 249601,
  [SMALL_STATE(6945)] = 249618,
  [SMALL_STATE(6946)] = 249635,
  [SMALL_STATE(6947)] = 249658,
  [SMALL_STATE(6948)] = 249681,
  [SMALL_STATE(6949)] = 249702,
  [SMALL_STATE(6950)] = 249719,
  [SMALL_STATE(6951)] = 249742,
  [SMALL_STATE(6952)] = 249761,
  [SMALL_STATE(6953)] = 249786,
  [SMALL_STATE(6954)] = 249811,
  [SMALL_STATE(6955)] = 249834,
  [SMALL_STATE(6956)] = 249851,
  [SMALL_STATE(6957)] = 249872,
  [SMALL_STATE(6958)] = 249889,
  [SMALL_STATE(6959)] = 249912,
  [SMALL_STATE(6960)] = 249929,
  [SMALL_STATE(6961)] = 249946,
  [SMALL_STATE(6962)] = 249963,
  [SMALL_STATE(6963)] = 249980,
  [SMALL_STATE(6964)] = 249997,
  [SMALL_STATE(6965)] = 250014,
  [SMALL_STATE(6966)] = 250031,
  [SMALL_STATE(6967)] = 250050,
  [SMALL_STATE(6968)] = 250067,
  [SMALL_STATE(6969)] = 250090,
  [SMALL_STATE(6970)] = 250107,
  [SMALL_STATE(6971)] = 250126,
  [SMALL_STATE(6972)] = 250149,
  [SMALL_STATE(6973)] = 250174,
  [SMALL_STATE(6974)] = 250199,
  [SMALL_STATE(6975)] = 250220,
  [SMALL_STATE(6976)] = 250241,
  [SMALL_STATE(6977)] = 250266,
  [SMALL_STATE(6978)] = 250287,
  [SMALL_STATE(6979)] = 250309,
  [SMALL_STATE(6980)] = 250323,
  [SMALL_STATE(6981)] = 250343,
  [SMALL_STATE(6982)] = 250363,
  [SMALL_STATE(6983)] = 250381,
  [SMALL_STATE(6984)] = 250401,
  [SMALL_STATE(6985)] = 250421,
  [SMALL_STATE(6986)] = 250443,
  [SMALL_STATE(6987)] = 250463,
  [SMALL_STATE(6988)] = 250483,
  [SMALL_STATE(6989)] = 250503,
  [SMALL_STATE(6990)] = 250521,
  [SMALL_STATE(6991)] = 250541,
  [SMALL_STATE(6992)] = 250561,
  [SMALL_STATE(6993)] = 250583,
  [SMALL_STATE(6994)] = 250605,
  [SMALL_STATE(6995)] = 250625,
  [SMALL_STATE(6996)] = 250647,
  [SMALL_STATE(6997)] = 250667,
  [SMALL_STATE(6998)] = 250687,
  [SMALL_STATE(6999)] = 250709,
  [SMALL_STATE(7000)] = 250731,
  [SMALL_STATE(7001)] = 250753,
  [SMALL_STATE(7002)] = 250767,
  [SMALL_STATE(7003)] = 250781,
  [SMALL_STATE(7004)] = 250799,
  [SMALL_STATE(7005)] = 250819,
  [SMALL_STATE(7006)] = 250841,
  [SMALL_STATE(7007)] = 250863,
  [SMALL_STATE(7008)] = 250885,
  [SMALL_STATE(7009)] = 250907,
  [SMALL_STATE(7010)] = 250927,
  [SMALL_STATE(7011)] = 250941,
  [SMALL_STATE(7012)] = 250959,
  [SMALL_STATE(7013)] = 250981,
  [SMALL_STATE(7014)] = 251003,
  [SMALL_STATE(7015)] = 251023,
  [SMALL_STATE(7016)] = 251043,
  [SMALL_STATE(7017)] = 251063,
  [SMALL_STATE(7018)] = 251077,
  [SMALL_STATE(7019)] = 251097,
  [SMALL_STATE(7020)] = 251117,
  [SMALL_STATE(7021)] = 251135,
  [SMALL_STATE(7022)] = 251157,
  [SMALL_STATE(7023)] = 251179,
  [SMALL_STATE(7024)] = 251201,
  [SMALL_STATE(7025)] = 251221,
  [SMALL_STATE(7026)] = 251241,
  [SMALL_STATE(7027)] = 251255,
  [SMALL_STATE(7028)] = 251269,
  [SMALL_STATE(7029)] = 251289,
  [SMALL_STATE(7030)] = 251303,
  [SMALL_STATE(7031)] = 251317,
  [SMALL_STATE(7032)] = 251335,
  [SMALL_STATE(7033)] = 251355,
  [SMALL_STATE(7034)] = 251377,
  [SMALL_STATE(7035)] = 251399,
  [SMALL_STATE(7036)] = 251421,
  [SMALL_STATE(7037)] = 251435,
  [SMALL_STATE(7038)] = 251457,
  [SMALL_STATE(7039)] = 251479,
  [SMALL_STATE(7040)] = 251493,
  [SMALL_STATE(7041)] = 251507,
  [SMALL_STATE(7042)] = 251521,
  [SMALL_STATE(7043)] = 251543,
  [SMALL_STATE(7044)] = 251557,
  [SMALL_STATE(7045)] = 251577,
  [SMALL_STATE(7046)] = 251599,
  [SMALL_STATE(7047)] = 251619,
  [SMALL_STATE(7048)] = 251639,
  [SMALL_STATE(7049)] = 251659,
  [SMALL_STATE(7050)] = 251679,
  [SMALL_STATE(7051)] = 251696,
  [SMALL_STATE(7052)] = 251715,
  [SMALL_STATE(7053)] = 251732,
  [SMALL_STATE(7054)] = 251751,
  [SMALL_STATE(7055)] = 251770,
  [SMALL_STATE(7056)] = 251787,
  [SMALL_STATE(7057)] = 251804,
  [SMALL_STATE(7058)] = 251821,
  [SMALL_STATE(7059)] = 251838,
  [SMALL_STATE(7060)] = 251857,
  [SMALL_STATE(7061)] = 251874,
  [SMALL_STATE(7062)] = 251891,
  [SMALL_STATE(7063)] = 251908,
  [SMALL_STATE(7064)] = 251925,
  [SMALL_STATE(7065)] = 251942,
  [SMALL_STATE(7066)] = 251959,
  [SMALL_STATE(7067)] = 251976,
  [SMALL_STATE(7068)] = 251995,
  [SMALL_STATE(7069)] = 252010,
  [SMALL_STATE(7070)] = 252027,
  [SMALL_STATE(7071)] = 252044,
  [SMALL_STATE(7072)] = 252061,
  [SMALL_STATE(7073)] = 252078,
  [SMALL_STATE(7074)] = 252097,
  [SMALL_STATE(7075)] = 252114,
  [SMALL_STATE(7076)] = 252131,
  [SMALL_STATE(7077)] = 252150,
  [SMALL_STATE(7078)] = 252167,
  [SMALL_STATE(7079)] = 252184,
  [SMALL_STATE(7080)] = 252201,
  [SMALL_STATE(7081)] = 252216,
  [SMALL_STATE(7082)] = 252233,
  [SMALL_STATE(7083)] = 252252,
  [SMALL_STATE(7084)] = 252271,
  [SMALL_STATE(7085)] = 252288,
  [SMALL_STATE(7086)] = 252307,
  [SMALL_STATE(7087)] = 252324,
  [SMALL_STATE(7088)] = 252341,
  [SMALL_STATE(7089)] = 252358,
  [SMALL_STATE(7090)] = 252377,
  [SMALL_STATE(7091)] = 252394,
  [SMALL_STATE(7092)] = 252413,
  [SMALL_STATE(7093)] = 252430,
  [SMALL_STATE(7094)] = 252449,
  [SMALL_STATE(7095)] = 252468,
  [SMALL_STATE(7096)] = 252483,
  [SMALL_STATE(7097)] = 252496,
  [SMALL_STATE(7098)] = 252511,
  [SMALL_STATE(7099)] = 252528,
  [SMALL_STATE(7100)] = 252545,
  [SMALL_STATE(7101)] = 252564,
  [SMALL_STATE(7102)] = 252583,
  [SMALL_STATE(7103)] = 252600,
  [SMALL_STATE(7104)] = 252617,
  [SMALL_STATE(7105)] = 252634,
  [SMALL_STATE(7106)] = 252651,
  [SMALL_STATE(7107)] = 252668,
  [SMALL_STATE(7108)] = 252687,
  [SMALL_STATE(7109)] = 252700,
  [SMALL_STATE(7110)] = 252717,
  [SMALL_STATE(7111)] = 252730,
  [SMALL_STATE(7112)] = 252747,
  [SMALL_STATE(7113)] = 252766,
  [SMALL_STATE(7114)] = 252783,
  [SMALL_STATE(7115)] = 252802,
  [SMALL_STATE(7116)] = 252819,
  [SMALL_STATE(7117)] = 252838,
  [SMALL_STATE(7118)] = 252849,
  [SMALL_STATE(7119)] = 252866,
  [SMALL_STATE(7120)] = 252883,
  [SMALL_STATE(7121)] = 252900,
  [SMALL_STATE(7122)] = 252919,
  [SMALL_STATE(7123)] = 252938,
  [SMALL_STATE(7124)] = 252957,
  [SMALL_STATE(7125)] = 252976,
  [SMALL_STATE(7126)] = 252993,
  [SMALL_STATE(7127)] = 253010,
  [SMALL_STATE(7128)] = 253027,
  [SMALL_STATE(7129)] = 253044,
  [SMALL_STATE(7130)] = 253063,
  [SMALL_STATE(7131)] = 253082,
  [SMALL_STATE(7132)] = 253099,
  [SMALL_STATE(7133)] = 253115,
  [SMALL_STATE(7134)] = 253125,
  [SMALL_STATE(7135)] = 253139,
  [SMALL_STATE(7136)] = 253155,
  [SMALL_STATE(7137)] = 253171,
  [SMALL_STATE(7138)] = 253187,
  [SMALL_STATE(7139)] = 253203,
  [SMALL_STATE(7140)] = 253219,
  [SMALL_STATE(7141)] = 253235,
  [SMALL_STATE(7142)] = 253251,
  [SMALL_STATE(7143)] = 253267,
  [SMALL_STATE(7144)] = 253283,
  [SMALL_STATE(7145)] = 253299,
  [SMALL_STATE(7146)] = 253315,
  [SMALL_STATE(7147)] = 253331,
  [SMALL_STATE(7148)] = 253347,
  [SMALL_STATE(7149)] = 253363,
  [SMALL_STATE(7150)] = 253379,
  [SMALL_STATE(7151)] = 253393,
  [SMALL_STATE(7152)] = 253409,
  [SMALL_STATE(7153)] = 253425,
  [SMALL_STATE(7154)] = 253441,
  [SMALL_STATE(7155)] = 253455,
  [SMALL_STATE(7156)] = 253471,
  [SMALL_STATE(7157)] = 253487,
  [SMALL_STATE(7158)] = 253503,
  [SMALL_STATE(7159)] = 253519,
  [SMALL_STATE(7160)] = 253533,
  [SMALL_STATE(7161)] = 253549,
  [SMALL_STATE(7162)] = 253565,
  [SMALL_STATE(7163)] = 253581,
  [SMALL_STATE(7164)] = 253597,
  [SMALL_STATE(7165)] = 253613,
  [SMALL_STATE(7166)] = 253627,
  [SMALL_STATE(7167)] = 253643,
  [SMALL_STATE(7168)] = 253659,
  [SMALL_STATE(7169)] = 253675,
  [SMALL_STATE(7170)] = 253691,
  [SMALL_STATE(7171)] = 253701,
  [SMALL_STATE(7172)] = 253715,
  [SMALL_STATE(7173)] = 253731,
  [SMALL_STATE(7174)] = 253747,
  [SMALL_STATE(7175)] = 253763,
  [SMALL_STATE(7176)] = 253779,
  [SMALL_STATE(7177)] = 253795,
  [SMALL_STATE(7178)] = 253811,
  [SMALL_STATE(7179)] = 253827,
  [SMALL_STATE(7180)] = 253843,
  [SMALL_STATE(7181)] = 253859,
  [SMALL_STATE(7182)] = 253875,
  [SMALL_STATE(7183)] = 253891,
  [SMALL_STATE(7184)] = 253907,
  [SMALL_STATE(7185)] = 253923,
  [SMALL_STATE(7186)] = 253937,
  [SMALL_STATE(7187)] = 253953,
  [SMALL_STATE(7188)] = 253969,
  [SMALL_STATE(7189)] = 253983,
  [SMALL_STATE(7190)] = 253999,
  [SMALL_STATE(7191)] = 254015,
  [SMALL_STATE(7192)] = 254031,
  [SMALL_STATE(7193)] = 254047,
  [SMALL_STATE(7194)] = 254063,
  [SMALL_STATE(7195)] = 254075,
  [SMALL_STATE(7196)] = 254091,
  [SMALL_STATE(7197)] = 254107,
  [SMALL_STATE(7198)] = 254123,
  [SMALL_STATE(7199)] = 254137,
  [SMALL_STATE(7200)] = 254151,
  [SMALL_STATE(7201)] = 254167,
  [SMALL_STATE(7202)] = 254183,
  [SMALL_STATE(7203)] = 254199,
  [SMALL_STATE(7204)] = 254215,
  [SMALL_STATE(7205)] = 254231,
  [SMALL_STATE(7206)] = 254247,
  [SMALL_STATE(7207)] = 254263,
  [SMALL_STATE(7208)] = 254275,
  [SMALL_STATE(7209)] = 254287,
  [SMALL_STATE(7210)] = 254303,
  [SMALL_STATE(7211)] = 254319,
  [SMALL_STATE(7212)] = 254335,
  [SMALL_STATE(7213)] = 254351,
  [SMALL_STATE(7214)] = 254367,
  [SMALL_STATE(7215)] = 254383,
  [SMALL_STATE(7216)] = 254399,
  [SMALL_STATE(7217)] = 254415,
  [SMALL_STATE(7218)] = 254431,
  [SMALL_STATE(7219)] = 254445,
  [SMALL_STATE(7220)] = 254461,
  [SMALL_STATE(7221)] = 254475,
  [SMALL_STATE(7222)] = 254491,
  [SMALL_STATE(7223)] = 254507,
  [SMALL_STATE(7224)] = 254523,
  [SMALL_STATE(7225)] = 254539,
  [SMALL_STATE(7226)] = 254555,
  [SMALL_STATE(7227)] = 254571,
  [SMALL_STATE(7228)] = 254587,
  [SMALL_STATE(7229)] = 254603,
  [SMALL_STATE(7230)] = 254619,
  [SMALL_STATE(7231)] = 254635,
  [SMALL_STATE(7232)] = 254651,
  [SMALL_STATE(7233)] = 254665,
  [SMALL_STATE(7234)] = 254681,
  [SMALL_STATE(7235)] = 254697,
  [SMALL_STATE(7236)] = 254711,
  [SMALL_STATE(7237)] = 254727,
  [SMALL_STATE(7238)] = 254743,
  [SMALL_STATE(7239)] = 254759,
  [SMALL_STATE(7240)] = 254773,
  [SMALL_STATE(7241)] = 254789,
  [SMALL_STATE(7242)] = 254803,
  [SMALL_STATE(7243)] = 254817,
  [SMALL_STATE(7244)] = 254833,
  [SMALL_STATE(7245)] = 254847,
  [SMALL_STATE(7246)] = 254863,
  [SMALL_STATE(7247)] = 254879,
  [SMALL_STATE(7248)] = 254895,
  [SMALL_STATE(7249)] = 254909,
  [SMALL_STATE(7250)] = 254925,
  [SMALL_STATE(7251)] = 254939,
  [SMALL_STATE(7252)] = 254953,
  [SMALL_STATE(7253)] = 254967,
  [SMALL_STATE(7254)] = 254981,
  [SMALL_STATE(7255)] = 254997,
  [SMALL_STATE(7256)] = 255007,
  [SMALL_STATE(7257)] = 255023,
  [SMALL_STATE(7258)] = 255039,
  [SMALL_STATE(7259)] = 255055,
  [SMALL_STATE(7260)] = 255069,
  [SMALL_STATE(7261)] = 255083,
  [SMALL_STATE(7262)] = 255099,
  [SMALL_STATE(7263)] = 255115,
  [SMALL_STATE(7264)] = 255131,
  [SMALL_STATE(7265)] = 255147,
  [SMALL_STATE(7266)] = 255163,
  [SMALL_STATE(7267)] = 255179,
  [SMALL_STATE(7268)] = 255195,
  [SMALL_STATE(7269)] = 255211,
  [SMALL_STATE(7270)] = 255225,
  [SMALL_STATE(7271)] = 255241,
  [SMALL_STATE(7272)] = 255255,
  [SMALL_STATE(7273)] = 255271,
  [SMALL_STATE(7274)] = 255287,
  [SMALL_STATE(7275)] = 255301,
  [SMALL_STATE(7276)] = 255317,
  [SMALL_STATE(7277)] = 255329,
  [SMALL_STATE(7278)] = 255345,
  [SMALL_STATE(7279)] = 255361,
  [SMALL_STATE(7280)] = 255377,
  [SMALL_STATE(7281)] = 255393,
  [SMALL_STATE(7282)] = 255407,
  [SMALL_STATE(7283)] = 255423,
  [SMALL_STATE(7284)] = 255439,
  [SMALL_STATE(7285)] = 255455,
  [SMALL_STATE(7286)] = 255471,
  [SMALL_STATE(7287)] = 255487,
  [SMALL_STATE(7288)] = 255503,
  [SMALL_STATE(7289)] = 255519,
  [SMALL_STATE(7290)] = 255535,
  [SMALL_STATE(7291)] = 255551,
  [SMALL_STATE(7292)] = 255567,
  [SMALL_STATE(7293)] = 255583,
  [SMALL_STATE(7294)] = 255599,
  [SMALL_STATE(7295)] = 255613,
  [SMALL_STATE(7296)] = 255629,
  [SMALL_STATE(7297)] = 255643,
  [SMALL_STATE(7298)] = 255657,
  [SMALL_STATE(7299)] = 255673,
  [SMALL_STATE(7300)] = 255689,
  [SMALL_STATE(7301)] = 255705,
  [SMALL_STATE(7302)] = 255721,
  [SMALL_STATE(7303)] = 255737,
  [SMALL_STATE(7304)] = 255751,
  [SMALL_STATE(7305)] = 255767,
  [SMALL_STATE(7306)] = 255781,
  [SMALL_STATE(7307)] = 255795,
  [SMALL_STATE(7308)] = 255809,
  [SMALL_STATE(7309)] = 255825,
  [SMALL_STATE(7310)] = 255841,
  [SMALL_STATE(7311)] = 255857,
  [SMALL_STATE(7312)] = 255873,
  [SMALL_STATE(7313)] = 255887,
  [SMALL_STATE(7314)] = 255901,
  [SMALL_STATE(7315)] = 255915,
  [SMALL_STATE(7316)] = 255929,
  [SMALL_STATE(7317)] = 255943,
  [SMALL_STATE(7318)] = 255959,
  [SMALL_STATE(7319)] = 255975,
  [SMALL_STATE(7320)] = 255989,
  [SMALL_STATE(7321)] = 256003,
  [SMALL_STATE(7322)] = 256017,
  [SMALL_STATE(7323)] = 256031,
  [SMALL_STATE(7324)] = 256045,
  [SMALL_STATE(7325)] = 256061,
  [SMALL_STATE(7326)] = 256075,
  [SMALL_STATE(7327)] = 256089,
  [SMALL_STATE(7328)] = 256105,
  [SMALL_STATE(7329)] = 256119,
  [SMALL_STATE(7330)] = 256133,
  [SMALL_STATE(7331)] = 256147,
  [SMALL_STATE(7332)] = 256163,
  [SMALL_STATE(7333)] = 256179,
  [SMALL_STATE(7334)] = 256195,
  [SMALL_STATE(7335)] = 256209,
  [SMALL_STATE(7336)] = 256225,
  [SMALL_STATE(7337)] = 256241,
  [SMALL_STATE(7338)] = 256257,
  [SMALL_STATE(7339)] = 256273,
  [SMALL_STATE(7340)] = 256289,
  [SMALL_STATE(7341)] = 256303,
  [SMALL_STATE(7342)] = 256319,
  [SMALL_STATE(7343)] = 256335,
  [SMALL_STATE(7344)] = 256351,
  [SMALL_STATE(7345)] = 256367,
  [SMALL_STATE(7346)] = 256383,
  [SMALL_STATE(7347)] = 256399,
  [SMALL_STATE(7348)] = 256415,
  [SMALL_STATE(7349)] = 256431,
  [SMALL_STATE(7350)] = 256447,
  [SMALL_STATE(7351)] = 256461,
  [SMALL_STATE(7352)] = 256477,
  [SMALL_STATE(7353)] = 256493,
  [SMALL_STATE(7354)] = 256509,
  [SMALL_STATE(7355)] = 256525,
  [SMALL_STATE(7356)] = 256541,
  [SMALL_STATE(7357)] = 256557,
  [SMALL_STATE(7358)] = 256573,
  [SMALL_STATE(7359)] = 256589,
  [SMALL_STATE(7360)] = 256605,
  [SMALL_STATE(7361)] = 256621,
  [SMALL_STATE(7362)] = 256637,
  [SMALL_STATE(7363)] = 256653,
  [SMALL_STATE(7364)] = 256669,
  [SMALL_STATE(7365)] = 256685,
  [SMALL_STATE(7366)] = 256701,
  [SMALL_STATE(7367)] = 256715,
  [SMALL_STATE(7368)] = 256728,
  [SMALL_STATE(7369)] = 256741,
  [SMALL_STATE(7370)] = 256754,
  [SMALL_STATE(7371)] = 256765,
  [SMALL_STATE(7372)] = 256778,
  [SMALL_STATE(7373)] = 256789,
  [SMALL_STATE(7374)] = 256802,
  [SMALL_STATE(7375)] = 256813,
  [SMALL_STATE(7376)] = 256826,
  [SMALL_STATE(7377)] = 256839,
  [SMALL_STATE(7378)] = 256852,
  [SMALL_STATE(7379)] = 256865,
  [SMALL_STATE(7380)] = 256878,
  [SMALL_STATE(7381)] = 256891,
  [SMALL_STATE(7382)] = 256904,
  [SMALL_STATE(7383)] = 256917,
  [SMALL_STATE(7384)] = 256928,
  [SMALL_STATE(7385)] = 256941,
  [SMALL_STATE(7386)] = 256954,
  [SMALL_STATE(7387)] = 256967,
  [SMALL_STATE(7388)] = 256980,
  [SMALL_STATE(7389)] = 256993,
  [SMALL_STATE(7390)] = 257006,
  [SMALL_STATE(7391)] = 257019,
  [SMALL_STATE(7392)] = 257032,
  [SMALL_STATE(7393)] = 257045,
  [SMALL_STATE(7394)] = 257058,
  [SMALL_STATE(7395)] = 257071,
  [SMALL_STATE(7396)] = 257084,
  [SMALL_STATE(7397)] = 257097,
  [SMALL_STATE(7398)] = 257110,
  [SMALL_STATE(7399)] = 257123,
  [SMALL_STATE(7400)] = 257136,
  [SMALL_STATE(7401)] = 257149,
  [SMALL_STATE(7402)] = 257162,
  [SMALL_STATE(7403)] = 257175,
  [SMALL_STATE(7404)] = 257186,
  [SMALL_STATE(7405)] = 257199,
  [SMALL_STATE(7406)] = 257212,
  [SMALL_STATE(7407)] = 257225,
  [SMALL_STATE(7408)] = 257238,
  [SMALL_STATE(7409)] = 257251,
  [SMALL_STATE(7410)] = 257262,
  [SMALL_STATE(7411)] = 257275,
  [SMALL_STATE(7412)] = 257288,
  [SMALL_STATE(7413)] = 257299,
  [SMALL_STATE(7414)] = 257312,
  [SMALL_STATE(7415)] = 257325,
  [SMALL_STATE(7416)] = 257338,
  [SMALL_STATE(7417)] = 257347,
  [SMALL_STATE(7418)] = 257360,
  [SMALL_STATE(7419)] = 257373,
  [SMALL_STATE(7420)] = 257386,
  [SMALL_STATE(7421)] = 257399,
  [SMALL_STATE(7422)] = 257412,
  [SMALL_STATE(7423)] = 257425,
  [SMALL_STATE(7424)] = 257438,
  [SMALL_STATE(7425)] = 257451,
  [SMALL_STATE(7426)] = 257464,
  [SMALL_STATE(7427)] = 257477,
  [SMALL_STATE(7428)] = 257490,
  [SMALL_STATE(7429)] = 257503,
  [SMALL_STATE(7430)] = 257516,
  [SMALL_STATE(7431)] = 257529,
  [SMALL_STATE(7432)] = 257542,
  [SMALL_STATE(7433)] = 257555,
  [SMALL_STATE(7434)] = 257564,
  [SMALL_STATE(7435)] = 257577,
  [SMALL_STATE(7436)] = 257590,
  [SMALL_STATE(7437)] = 257603,
  [SMALL_STATE(7438)] = 257612,
  [SMALL_STATE(7439)] = 257625,
  [SMALL_STATE(7440)] = 257638,
  [SMALL_STATE(7441)] = 257651,
  [SMALL_STATE(7442)] = 257664,
  [SMALL_STATE(7443)] = 257677,
  [SMALL_STATE(7444)] = 257690,
  [SMALL_STATE(7445)] = 257701,
  [SMALL_STATE(7446)] = 257714,
  [SMALL_STATE(7447)] = 257725,
  [SMALL_STATE(7448)] = 257738,
  [SMALL_STATE(7449)] = 257751,
  [SMALL_STATE(7450)] = 257764,
  [SMALL_STATE(7451)] = 257777,
  [SMALL_STATE(7452)] = 257790,
  [SMALL_STATE(7453)] = 257803,
  [SMALL_STATE(7454)] = 257814,
  [SMALL_STATE(7455)] = 257827,
  [SMALL_STATE(7456)] = 257840,
  [SMALL_STATE(7457)] = 257853,
  [SMALL_STATE(7458)] = 257866,
  [SMALL_STATE(7459)] = 257879,
  [SMALL_STATE(7460)] = 257892,
  [SMALL_STATE(7461)] = 257905,
  [SMALL_STATE(7462)] = 257918,
  [SMALL_STATE(7463)] = 257931,
  [SMALL_STATE(7464)] = 257944,
  [SMALL_STATE(7465)] = 257957,
  [SMALL_STATE(7466)] = 257970,
  [SMALL_STATE(7467)] = 257981,
  [SMALL_STATE(7468)] = 257994,
  [SMALL_STATE(7469)] = 258005,
  [SMALL_STATE(7470)] = 258018,
  [SMALL_STATE(7471)] = 258031,
  [SMALL_STATE(7472)] = 258044,
  [SMALL_STATE(7473)] = 258055,
  [SMALL_STATE(7474)] = 258068,
  [SMALL_STATE(7475)] = 258081,
  [SMALL_STATE(7476)] = 258094,
  [SMALL_STATE(7477)] = 258107,
  [SMALL_STATE(7478)] = 258118,
  [SMALL_STATE(7479)] = 258131,
  [SMALL_STATE(7480)] = 258144,
  [SMALL_STATE(7481)] = 258157,
  [SMALL_STATE(7482)] = 258170,
  [SMALL_STATE(7483)] = 258181,
  [SMALL_STATE(7484)] = 258194,
  [SMALL_STATE(7485)] = 258207,
  [SMALL_STATE(7486)] = 258220,
  [SMALL_STATE(7487)] = 258231,
  [SMALL_STATE(7488)] = 258244,
  [SMALL_STATE(7489)] = 258257,
  [SMALL_STATE(7490)] = 258266,
  [SMALL_STATE(7491)] = 258275,
  [SMALL_STATE(7492)] = 258288,
  [SMALL_STATE(7493)] = 258301,
  [SMALL_STATE(7494)] = 258314,
  [SMALL_STATE(7495)] = 258325,
  [SMALL_STATE(7496)] = 258336,
  [SMALL_STATE(7497)] = 258349,
  [SMALL_STATE(7498)] = 258360,
  [SMALL_STATE(7499)] = 258373,
  [SMALL_STATE(7500)] = 258386,
  [SMALL_STATE(7501)] = 258399,
  [SMALL_STATE(7502)] = 258410,
  [SMALL_STATE(7503)] = 258419,
  [SMALL_STATE(7504)] = 258432,
  [SMALL_STATE(7505)] = 258443,
  [SMALL_STATE(7506)] = 258454,
  [SMALL_STATE(7507)] = 258465,
  [SMALL_STATE(7508)] = 258478,
  [SMALL_STATE(7509)] = 258491,
  [SMALL_STATE(7510)] = 258504,
  [SMALL_STATE(7511)] = 258515,
  [SMALL_STATE(7512)] = 258528,
  [SMALL_STATE(7513)] = 258539,
  [SMALL_STATE(7514)] = 258552,
  [SMALL_STATE(7515)] = 258565,
  [SMALL_STATE(7516)] = 258578,
  [SMALL_STATE(7517)] = 258591,
  [SMALL_STATE(7518)] = 258604,
  [SMALL_STATE(7519)] = 258617,
  [SMALL_STATE(7520)] = 258630,
  [SMALL_STATE(7521)] = 258643,
  [SMALL_STATE(7522)] = 258656,
  [SMALL_STATE(7523)] = 258669,
  [SMALL_STATE(7524)] = 258682,
  [SMALL_STATE(7525)] = 258695,
  [SMALL_STATE(7526)] = 258708,
  [SMALL_STATE(7527)] = 258721,
  [SMALL_STATE(7528)] = 258734,
  [SMALL_STATE(7529)] = 258747,
  [SMALL_STATE(7530)] = 258760,
  [SMALL_STATE(7531)] = 258773,
  [SMALL_STATE(7532)] = 258786,
  [SMALL_STATE(7533)] = 258799,
  [SMALL_STATE(7534)] = 258812,
  [SMALL_STATE(7535)] = 258825,
  [SMALL_STATE(7536)] = 258838,
  [SMALL_STATE(7537)] = 258851,
  [SMALL_STATE(7538)] = 258864,
  [SMALL_STATE(7539)] = 258875,
  [SMALL_STATE(7540)] = 258884,
  [SMALL_STATE(7541)] = 258893,
  [SMALL_STATE(7542)] = 258906,
  [SMALL_STATE(7543)] = 258919,
  [SMALL_STATE(7544)] = 258930,
  [SMALL_STATE(7545)] = 258943,
  [SMALL_STATE(7546)] = 258956,
  [SMALL_STATE(7547)] = 258969,
  [SMALL_STATE(7548)] = 258982,
  [SMALL_STATE(7549)] = 258995,
  [SMALL_STATE(7550)] = 259008,
  [SMALL_STATE(7551)] = 259021,
  [SMALL_STATE(7552)] = 259034,
  [SMALL_STATE(7553)] = 259045,
  [SMALL_STATE(7554)] = 259058,
  [SMALL_STATE(7555)] = 259069,
  [SMALL_STATE(7556)] = 259082,
  [SMALL_STATE(7557)] = 259095,
  [SMALL_STATE(7558)] = 259108,
  [SMALL_STATE(7559)] = 259121,
  [SMALL_STATE(7560)] = 259134,
  [SMALL_STATE(7561)] = 259147,
  [SMALL_STATE(7562)] = 259160,
  [SMALL_STATE(7563)] = 259173,
  [SMALL_STATE(7564)] = 259186,
  [SMALL_STATE(7565)] = 259199,
  [SMALL_STATE(7566)] = 259212,
  [SMALL_STATE(7567)] = 259225,
  [SMALL_STATE(7568)] = 259238,
  [SMALL_STATE(7569)] = 259251,
  [SMALL_STATE(7570)] = 259264,
  [SMALL_STATE(7571)] = 259277,
  [SMALL_STATE(7572)] = 259290,
  [SMALL_STATE(7573)] = 259303,
  [SMALL_STATE(7574)] = 259316,
  [SMALL_STATE(7575)] = 259329,
  [SMALL_STATE(7576)] = 259342,
  [SMALL_STATE(7577)] = 259353,
  [SMALL_STATE(7578)] = 259366,
  [SMALL_STATE(7579)] = 259379,
  [SMALL_STATE(7580)] = 259392,
  [SMALL_STATE(7581)] = 259405,
  [SMALL_STATE(7582)] = 259418,
  [SMALL_STATE(7583)] = 259431,
  [SMALL_STATE(7584)] = 259444,
  [SMALL_STATE(7585)] = 259457,
  [SMALL_STATE(7586)] = 259468,
  [SMALL_STATE(7587)] = 259481,
  [SMALL_STATE(7588)] = 259494,
  [SMALL_STATE(7589)] = 259507,
  [SMALL_STATE(7590)] = 259520,
  [SMALL_STATE(7591)] = 259533,
  [SMALL_STATE(7592)] = 259544,
  [SMALL_STATE(7593)] = 259557,
  [SMALL_STATE(7594)] = 259570,
  [SMALL_STATE(7595)] = 259583,
  [SMALL_STATE(7596)] = 259596,
  [SMALL_STATE(7597)] = 259609,
  [SMALL_STATE(7598)] = 259622,
  [SMALL_STATE(7599)] = 259633,
  [SMALL_STATE(7600)] = 259646,
  [SMALL_STATE(7601)] = 259659,
  [SMALL_STATE(7602)] = 259672,
  [SMALL_STATE(7603)] = 259685,
  [SMALL_STATE(7604)] = 259698,
  [SMALL_STATE(7605)] = 259711,
  [SMALL_STATE(7606)] = 259724,
  [SMALL_STATE(7607)] = 259737,
  [SMALL_STATE(7608)] = 259750,
  [SMALL_STATE(7609)] = 259763,
  [SMALL_STATE(7610)] = 259772,
  [SMALL_STATE(7611)] = 259785,
  [SMALL_STATE(7612)] = 259798,
  [SMALL_STATE(7613)] = 259811,
  [SMALL_STATE(7614)] = 259824,
  [SMALL_STATE(7615)] = 259837,
  [SMALL_STATE(7616)] = 259850,
  [SMALL_STATE(7617)] = 259863,
  [SMALL_STATE(7618)] = 259874,
  [SMALL_STATE(7619)] = 259887,
  [SMALL_STATE(7620)] = 259900,
  [SMALL_STATE(7621)] = 259913,
  [SMALL_STATE(7622)] = 259926,
  [SMALL_STATE(7623)] = 259939,
  [SMALL_STATE(7624)] = 259952,
  [SMALL_STATE(7625)] = 259965,
  [SMALL_STATE(7626)] = 259978,
  [SMALL_STATE(7627)] = 259991,
  [SMALL_STATE(7628)] = 260004,
  [SMALL_STATE(7629)] = 260013,
  [SMALL_STATE(7630)] = 260026,
  [SMALL_STATE(7631)] = 260039,
  [SMALL_STATE(7632)] = 260050,
  [SMALL_STATE(7633)] = 260059,
  [SMALL_STATE(7634)] = 260072,
  [SMALL_STATE(7635)] = 260085,
  [SMALL_STATE(7636)] = 260098,
  [SMALL_STATE(7637)] = 260107,
  [SMALL_STATE(7638)] = 260120,
  [SMALL_STATE(7639)] = 260131,
  [SMALL_STATE(7640)] = 260144,
  [SMALL_STATE(7641)] = 260155,
  [SMALL_STATE(7642)] = 260168,
  [SMALL_STATE(7643)] = 260181,
  [SMALL_STATE(7644)] = 260194,
  [SMALL_STATE(7645)] = 260207,
  [SMALL_STATE(7646)] = 260220,
  [SMALL_STATE(7647)] = 260233,
  [SMALL_STATE(7648)] = 260246,
  [SMALL_STATE(7649)] = 260259,
  [SMALL_STATE(7650)] = 260272,
  [SMALL_STATE(7651)] = 260285,
  [SMALL_STATE(7652)] = 260296,
  [SMALL_STATE(7653)] = 260305,
  [SMALL_STATE(7654)] = 260318,
  [SMALL_STATE(7655)] = 260331,
  [SMALL_STATE(7656)] = 260344,
  [SMALL_STATE(7657)] = 260357,
  [SMALL_STATE(7658)] = 260370,
  [SMALL_STATE(7659)] = 260383,
  [SMALL_STATE(7660)] = 260396,
  [SMALL_STATE(7661)] = 260409,
  [SMALL_STATE(7662)] = 260422,
  [SMALL_STATE(7663)] = 260435,
  [SMALL_STATE(7664)] = 260448,
  [SMALL_STATE(7665)] = 260461,
  [SMALL_STATE(7666)] = 260474,
  [SMALL_STATE(7667)] = 260487,
  [SMALL_STATE(7668)] = 260500,
  [SMALL_STATE(7669)] = 260513,
  [SMALL_STATE(7670)] = 260526,
  [SMALL_STATE(7671)] = 260539,
  [SMALL_STATE(7672)] = 260552,
  [SMALL_STATE(7673)] = 260563,
  [SMALL_STATE(7674)] = 260576,
  [SMALL_STATE(7675)] = 260589,
  [SMALL_STATE(7676)] = 260602,
  [SMALL_STATE(7677)] = 260615,
  [SMALL_STATE(7678)] = 260628,
  [SMALL_STATE(7679)] = 260641,
  [SMALL_STATE(7680)] = 260654,
  [SMALL_STATE(7681)] = 260667,
  [SMALL_STATE(7682)] = 260680,
  [SMALL_STATE(7683)] = 260693,
  [SMALL_STATE(7684)] = 260704,
  [SMALL_STATE(7685)] = 260717,
  [SMALL_STATE(7686)] = 260730,
  [SMALL_STATE(7687)] = 260743,
  [SMALL_STATE(7688)] = 260756,
  [SMALL_STATE(7689)] = 260765,
  [SMALL_STATE(7690)] = 260774,
  [SMALL_STATE(7691)] = 260787,
  [SMALL_STATE(7692)] = 260800,
  [SMALL_STATE(7693)] = 260813,
  [SMALL_STATE(7694)] = 260826,
  [SMALL_STATE(7695)] = 260839,
  [SMALL_STATE(7696)] = 260852,
  [SMALL_STATE(7697)] = 260865,
  [SMALL_STATE(7698)] = 260878,
  [SMALL_STATE(7699)] = 260891,
  [SMALL_STATE(7700)] = 260904,
  [SMALL_STATE(7701)] = 260917,
  [SMALL_STATE(7702)] = 260930,
  [SMALL_STATE(7703)] = 260943,
  [SMALL_STATE(7704)] = 260956,
  [SMALL_STATE(7705)] = 260969,
  [SMALL_STATE(7706)] = 260982,
  [SMALL_STATE(7707)] = 260991,
  [SMALL_STATE(7708)] = 261000,
  [SMALL_STATE(7709)] = 261013,
  [SMALL_STATE(7710)] = 261024,
  [SMALL_STATE(7711)] = 261037,
  [SMALL_STATE(7712)] = 261050,
  [SMALL_STATE(7713)] = 261059,
  [SMALL_STATE(7714)] = 261070,
  [SMALL_STATE(7715)] = 261083,
  [SMALL_STATE(7716)] = 261094,
  [SMALL_STATE(7717)] = 261107,
  [SMALL_STATE(7718)] = 261120,
  [SMALL_STATE(7719)] = 261133,
  [SMALL_STATE(7720)] = 261146,
  [SMALL_STATE(7721)] = 261159,
  [SMALL_STATE(7722)] = 261170,
  [SMALL_STATE(7723)] = 261183,
  [SMALL_STATE(7724)] = 261196,
  [SMALL_STATE(7725)] = 261209,
  [SMALL_STATE(7726)] = 261222,
  [SMALL_STATE(7727)] = 261233,
  [SMALL_STATE(7728)] = 261246,
  [SMALL_STATE(7729)] = 261259,
  [SMALL_STATE(7730)] = 261272,
  [SMALL_STATE(7731)] = 261281,
  [SMALL_STATE(7732)] = 261294,
  [SMALL_STATE(7733)] = 261307,
  [SMALL_STATE(7734)] = 261320,
  [SMALL_STATE(7735)] = 261333,
  [SMALL_STATE(7736)] = 261344,
  [SMALL_STATE(7737)] = 261357,
  [SMALL_STATE(7738)] = 261370,
  [SMALL_STATE(7739)] = 261383,
  [SMALL_STATE(7740)] = 261394,
  [SMALL_STATE(7741)] = 261407,
  [SMALL_STATE(7742)] = 261420,
  [SMALL_STATE(7743)] = 261433,
  [SMALL_STATE(7744)] = 261446,
  [SMALL_STATE(7745)] = 261459,
  [SMALL_STATE(7746)] = 261472,
  [SMALL_STATE(7747)] = 261485,
  [SMALL_STATE(7748)] = 261496,
  [SMALL_STATE(7749)] = 261509,
  [SMALL_STATE(7750)] = 261522,
  [SMALL_STATE(7751)] = 261535,
  [SMALL_STATE(7752)] = 261548,
  [SMALL_STATE(7753)] = 261561,
  [SMALL_STATE(7754)] = 261574,
  [SMALL_STATE(7755)] = 261587,
  [SMALL_STATE(7756)] = 261600,
  [SMALL_STATE(7757)] = 261613,
  [SMALL_STATE(7758)] = 261626,
  [SMALL_STATE(7759)] = 261639,
  [SMALL_STATE(7760)] = 261652,
  [SMALL_STATE(7761)] = 261665,
  [SMALL_STATE(7762)] = 261678,
  [SMALL_STATE(7763)] = 261691,
  [SMALL_STATE(7764)] = 261704,
  [SMALL_STATE(7765)] = 261715,
  [SMALL_STATE(7766)] = 261728,
  [SMALL_STATE(7767)] = 261741,
  [SMALL_STATE(7768)] = 261752,
  [SMALL_STATE(7769)] = 261765,
  [SMALL_STATE(7770)] = 261776,
  [SMALL_STATE(7771)] = 261789,
  [SMALL_STATE(7772)] = 261802,
  [SMALL_STATE(7773)] = 261813,
  [SMALL_STATE(7774)] = 261826,
  [SMALL_STATE(7775)] = 261839,
  [SMALL_STATE(7776)] = 261852,
  [SMALL_STATE(7777)] = 261865,
  [SMALL_STATE(7778)] = 261878,
  [SMALL_STATE(7779)] = 261891,
  [SMALL_STATE(7780)] = 261904,
  [SMALL_STATE(7781)] = 261917,
  [SMALL_STATE(7782)] = 261930,
  [SMALL_STATE(7783)] = 261943,
  [SMALL_STATE(7784)] = 261956,
  [SMALL_STATE(7785)] = 261967,
  [SMALL_STATE(7786)] = 261980,
  [SMALL_STATE(7787)] = 261993,
  [SMALL_STATE(7788)] = 262004,
  [SMALL_STATE(7789)] = 262017,
  [SMALL_STATE(7790)] = 262030,
  [SMALL_STATE(7791)] = 262039,
  [SMALL_STATE(7792)] = 262052,
  [SMALL_STATE(7793)] = 262065,
  [SMALL_STATE(7794)] = 262078,
  [SMALL_STATE(7795)] = 262091,
  [SMALL_STATE(7796)] = 262104,
  [SMALL_STATE(7797)] = 262117,
  [SMALL_STATE(7798)] = 262128,
  [SMALL_STATE(7799)] = 262141,
  [SMALL_STATE(7800)] = 262150,
  [SMALL_STATE(7801)] = 262163,
  [SMALL_STATE(7802)] = 262176,
  [SMALL_STATE(7803)] = 262189,
  [SMALL_STATE(7804)] = 262200,
  [SMALL_STATE(7805)] = 262213,
  [SMALL_STATE(7806)] = 262226,
  [SMALL_STATE(7807)] = 262239,
  [SMALL_STATE(7808)] = 262250,
  [SMALL_STATE(7809)] = 262259,
  [SMALL_STATE(7810)] = 262272,
  [SMALL_STATE(7811)] = 262285,
  [SMALL_STATE(7812)] = 262298,
  [SMALL_STATE(7813)] = 262311,
  [SMALL_STATE(7814)] = 262324,
  [SMALL_STATE(7815)] = 262333,
  [SMALL_STATE(7816)] = 262346,
  [SMALL_STATE(7817)] = 262359,
  [SMALL_STATE(7818)] = 262370,
  [SMALL_STATE(7819)] = 262383,
  [SMALL_STATE(7820)] = 262396,
  [SMALL_STATE(7821)] = 262409,
  [SMALL_STATE(7822)] = 262419,
  [SMALL_STATE(7823)] = 262429,
  [SMALL_STATE(7824)] = 262439,
  [SMALL_STATE(7825)] = 262449,
  [SMALL_STATE(7826)] = 262459,
  [SMALL_STATE(7827)] = 262469,
  [SMALL_STATE(7828)] = 262479,
  [SMALL_STATE(7829)] = 262489,
  [SMALL_STATE(7830)] = 262499,
  [SMALL_STATE(7831)] = 262509,
  [SMALL_STATE(7832)] = 262519,
  [SMALL_STATE(7833)] = 262529,
  [SMALL_STATE(7834)] = 262539,
  [SMALL_STATE(7835)] = 262549,
  [SMALL_STATE(7836)] = 262559,
  [SMALL_STATE(7837)] = 262569,
  [SMALL_STATE(7838)] = 262579,
  [SMALL_STATE(7839)] = 262589,
  [SMALL_STATE(7840)] = 262597,
  [SMALL_STATE(7841)] = 262605,
  [SMALL_STATE(7842)] = 262615,
  [SMALL_STATE(7843)] = 262625,
  [SMALL_STATE(7844)] = 262635,
  [SMALL_STATE(7845)] = 262645,
  [SMALL_STATE(7846)] = 262655,
  [SMALL_STATE(7847)] = 262665,
  [SMALL_STATE(7848)] = 262675,
  [SMALL_STATE(7849)] = 262685,
  [SMALL_STATE(7850)] = 262695,
  [SMALL_STATE(7851)] = 262705,
  [SMALL_STATE(7852)] = 262715,
  [SMALL_STATE(7853)] = 262723,
  [SMALL_STATE(7854)] = 262731,
  [SMALL_STATE(7855)] = 262741,
  [SMALL_STATE(7856)] = 262751,
  [SMALL_STATE(7857)] = 262761,
  [SMALL_STATE(7858)] = 262771,
  [SMALL_STATE(7859)] = 262781,
  [SMALL_STATE(7860)] = 262791,
  [SMALL_STATE(7861)] = 262799,
  [SMALL_STATE(7862)] = 262809,
  [SMALL_STATE(7863)] = 262819,
  [SMALL_STATE(7864)] = 262829,
  [SMALL_STATE(7865)] = 262839,
  [SMALL_STATE(7866)] = 262847,
  [SMALL_STATE(7867)] = 262857,
  [SMALL_STATE(7868)] = 262867,
  [SMALL_STATE(7869)] = 262877,
  [SMALL_STATE(7870)] = 262887,
  [SMALL_STATE(7871)] = 262897,
  [SMALL_STATE(7872)] = 262907,
  [SMALL_STATE(7873)] = 262917,
  [SMALL_STATE(7874)] = 262927,
  [SMALL_STATE(7875)] = 262937,
  [SMALL_STATE(7876)] = 262947,
  [SMALL_STATE(7877)] = 262957,
  [SMALL_STATE(7878)] = 262967,
  [SMALL_STATE(7879)] = 262977,
  [SMALL_STATE(7880)] = 262985,
  [SMALL_STATE(7881)] = 262995,
  [SMALL_STATE(7882)] = 263005,
  [SMALL_STATE(7883)] = 263015,
  [SMALL_STATE(7884)] = 263025,
  [SMALL_STATE(7885)] = 263035,
  [SMALL_STATE(7886)] = 263045,
  [SMALL_STATE(7887)] = 263055,
  [SMALL_STATE(7888)] = 263065,
  [SMALL_STATE(7889)] = 263075,
  [SMALL_STATE(7890)] = 263083,
  [SMALL_STATE(7891)] = 263093,
  [SMALL_STATE(7892)] = 263103,
  [SMALL_STATE(7893)] = 263113,
  [SMALL_STATE(7894)] = 263123,
  [SMALL_STATE(7895)] = 263133,
  [SMALL_STATE(7896)] = 263143,
  [SMALL_STATE(7897)] = 263153,
  [SMALL_STATE(7898)] = 263163,
  [SMALL_STATE(7899)] = 263173,
  [SMALL_STATE(7900)] = 263183,
  [SMALL_STATE(7901)] = 263193,
  [SMALL_STATE(7902)] = 263203,
  [SMALL_STATE(7903)] = 263213,
  [SMALL_STATE(7904)] = 263223,
  [SMALL_STATE(7905)] = 263233,
  [SMALL_STATE(7906)] = 263243,
  [SMALL_STATE(7907)] = 263253,
  [SMALL_STATE(7908)] = 263263,
  [SMALL_STATE(7909)] = 263273,
  [SMALL_STATE(7910)] = 263283,
  [SMALL_STATE(7911)] = 263293,
  [SMALL_STATE(7912)] = 263303,
  [SMALL_STATE(7913)] = 263313,
  [SMALL_STATE(7914)] = 263323,
  [SMALL_STATE(7915)] = 263333,
  [SMALL_STATE(7916)] = 263343,
  [SMALL_STATE(7917)] = 263353,
  [SMALL_STATE(7918)] = 263363,
  [SMALL_STATE(7919)] = 263373,
  [SMALL_STATE(7920)] = 263383,
  [SMALL_STATE(7921)] = 263393,
  [SMALL_STATE(7922)] = 263401,
  [SMALL_STATE(7923)] = 263411,
  [SMALL_STATE(7924)] = 263421,
  [SMALL_STATE(7925)] = 263431,
  [SMALL_STATE(7926)] = 263441,
  [SMALL_STATE(7927)] = 263451,
  [SMALL_STATE(7928)] = 263459,
  [SMALL_STATE(7929)] = 263469,
  [SMALL_STATE(7930)] = 263479,
  [SMALL_STATE(7931)] = 263489,
  [SMALL_STATE(7932)] = 263499,
  [SMALL_STATE(7933)] = 263509,
  [SMALL_STATE(7934)] = 263517,
  [SMALL_STATE(7935)] = 263527,
  [SMALL_STATE(7936)] = 263537,
  [SMALL_STATE(7937)] = 263547,
  [SMALL_STATE(7938)] = 263557,
  [SMALL_STATE(7939)] = 263567,
  [SMALL_STATE(7940)] = 263577,
  [SMALL_STATE(7941)] = 263587,
  [SMALL_STATE(7942)] = 263597,
  [SMALL_STATE(7943)] = 263607,
  [SMALL_STATE(7944)] = 263615,
  [SMALL_STATE(7945)] = 263625,
  [SMALL_STATE(7946)] = 263635,
  [SMALL_STATE(7947)] = 263645,
  [SMALL_STATE(7948)] = 263655,
  [SMALL_STATE(7949)] = 263665,
  [SMALL_STATE(7950)] = 263675,
  [SMALL_STATE(7951)] = 263685,
  [SMALL_STATE(7952)] = 263695,
  [SMALL_STATE(7953)] = 263705,
  [SMALL_STATE(7954)] = 263715,
  [SMALL_STATE(7955)] = 263725,
  [SMALL_STATE(7956)] = 263735,
  [SMALL_STATE(7957)] = 263745,
  [SMALL_STATE(7958)] = 263755,
  [SMALL_STATE(7959)] = 263765,
  [SMALL_STATE(7960)] = 263775,
  [SMALL_STATE(7961)] = 263785,
  [SMALL_STATE(7962)] = 263795,
  [SMALL_STATE(7963)] = 263805,
  [SMALL_STATE(7964)] = 263815,
  [SMALL_STATE(7965)] = 263825,
  [SMALL_STATE(7966)] = 263835,
  [SMALL_STATE(7967)] = 263845,
  [SMALL_STATE(7968)] = 263855,
  [SMALL_STATE(7969)] = 263865,
  [SMALL_STATE(7970)] = 263875,
  [SMALL_STATE(7971)] = 263885,
  [SMALL_STATE(7972)] = 263895,
  [SMALL_STATE(7973)] = 263903,
  [SMALL_STATE(7974)] = 263913,
  [SMALL_STATE(7975)] = 263923,
  [SMALL_STATE(7976)] = 263933,
  [SMALL_STATE(7977)] = 263943,
  [SMALL_STATE(7978)] = 263953,
  [SMALL_STATE(7979)] = 263963,
  [SMALL_STATE(7980)] = 263973,
  [SMALL_STATE(7981)] = 263983,
  [SMALL_STATE(7982)] = 263993,
  [SMALL_STATE(7983)] = 264003,
  [SMALL_STATE(7984)] = 264013,
  [SMALL_STATE(7985)] = 264023,
  [SMALL_STATE(7986)] = 264033,
  [SMALL_STATE(7987)] = 264043,
  [SMALL_STATE(7988)] = 264053,
  [SMALL_STATE(7989)] = 264063,
  [SMALL_STATE(7990)] = 264073,
  [SMALL_STATE(7991)] = 264083,
  [SMALL_STATE(7992)] = 264093,
  [SMALL_STATE(7993)] = 264103,
  [SMALL_STATE(7994)] = 264113,
  [SMALL_STATE(7995)] = 264121,
  [SMALL_STATE(7996)] = 264131,
  [SMALL_STATE(7997)] = 264141,
  [SMALL_STATE(7998)] = 264151,
  [SMALL_STATE(7999)] = 264161,
  [SMALL_STATE(8000)] = 264171,
  [SMALL_STATE(8001)] = 264181,
  [SMALL_STATE(8002)] = 264191,
  [SMALL_STATE(8003)] = 264199,
  [SMALL_STATE(8004)] = 264209,
  [SMALL_STATE(8005)] = 264219,
  [SMALL_STATE(8006)] = 264229,
  [SMALL_STATE(8007)] = 264239,
  [SMALL_STATE(8008)] = 264249,
  [SMALL_STATE(8009)] = 264259,
  [SMALL_STATE(8010)] = 264269,
  [SMALL_STATE(8011)] = 264279,
  [SMALL_STATE(8012)] = 264289,
  [SMALL_STATE(8013)] = 264299,
  [SMALL_STATE(8014)] = 264309,
  [SMALL_STATE(8015)] = 264319,
  [SMALL_STATE(8016)] = 264329,
  [SMALL_STATE(8017)] = 264339,
  [SMALL_STATE(8018)] = 264349,
  [SMALL_STATE(8019)] = 264359,
  [SMALL_STATE(8020)] = 264369,
  [SMALL_STATE(8021)] = 264379,
  [SMALL_STATE(8022)] = 264389,
  [SMALL_STATE(8023)] = 264399,
  [SMALL_STATE(8024)] = 264407,
  [SMALL_STATE(8025)] = 264417,
  [SMALL_STATE(8026)] = 264427,
  [SMALL_STATE(8027)] = 264437,
  [SMALL_STATE(8028)] = 264447,
  [SMALL_STATE(8029)] = 264457,
  [SMALL_STATE(8030)] = 264467,
  [SMALL_STATE(8031)] = 264477,
  [SMALL_STATE(8032)] = 264487,
  [SMALL_STATE(8033)] = 264497,
  [SMALL_STATE(8034)] = 264507,
  [SMALL_STATE(8035)] = 264517,
  [SMALL_STATE(8036)] = 264527,
  [SMALL_STATE(8037)] = 264537,
  [SMALL_STATE(8038)] = 264547,
  [SMALL_STATE(8039)] = 264557,
  [SMALL_STATE(8040)] = 264567,
  [SMALL_STATE(8041)] = 264577,
  [SMALL_STATE(8042)] = 264587,
  [SMALL_STATE(8043)] = 264597,
  [SMALL_STATE(8044)] = 264607,
  [SMALL_STATE(8045)] = 264617,
  [SMALL_STATE(8046)] = 264627,
  [SMALL_STATE(8047)] = 264637,
  [SMALL_STATE(8048)] = 264647,
  [SMALL_STATE(8049)] = 264657,
  [SMALL_STATE(8050)] = 264667,
  [SMALL_STATE(8051)] = 264677,
  [SMALL_STATE(8052)] = 264687,
  [SMALL_STATE(8053)] = 264695,
  [SMALL_STATE(8054)] = 264705,
  [SMALL_STATE(8055)] = 264715,
  [SMALL_STATE(8056)] = 264723,
  [SMALL_STATE(8057)] = 264733,
  [SMALL_STATE(8058)] = 264743,
  [SMALL_STATE(8059)] = 264753,
  [SMALL_STATE(8060)] = 264763,
  [SMALL_STATE(8061)] = 264773,
  [SMALL_STATE(8062)] = 264783,
  [SMALL_STATE(8063)] = 264793,
  [SMALL_STATE(8064)] = 264803,
  [SMALL_STATE(8065)] = 264813,
  [SMALL_STATE(8066)] = 264823,
  [SMALL_STATE(8067)] = 264831,
  [SMALL_STATE(8068)] = 264841,
  [SMALL_STATE(8069)] = 264851,
  [SMALL_STATE(8070)] = 264861,
  [SMALL_STATE(8071)] = 264871,
  [SMALL_STATE(8072)] = 264881,
  [SMALL_STATE(8073)] = 264891,
  [SMALL_STATE(8074)] = 264901,
  [SMALL_STATE(8075)] = 264911,
  [SMALL_STATE(8076)] = 264921,
  [SMALL_STATE(8077)] = 264931,
  [SMALL_STATE(8078)] = 264941,
  [SMALL_STATE(8079)] = 264949,
  [SMALL_STATE(8080)] = 264959,
  [SMALL_STATE(8081)] = 264969,
  [SMALL_STATE(8082)] = 264977,
  [SMALL_STATE(8083)] = 264987,
  [SMALL_STATE(8084)] = 264997,
  [SMALL_STATE(8085)] = 265007,
  [SMALL_STATE(8086)] = 265017,
  [SMALL_STATE(8087)] = 265027,
  [SMALL_STATE(8088)] = 265037,
  [SMALL_STATE(8089)] = 265047,
  [SMALL_STATE(8090)] = 265057,
  [SMALL_STATE(8091)] = 265067,
  [SMALL_STATE(8092)] = 265077,
  [SMALL_STATE(8093)] = 265087,
  [SMALL_STATE(8094)] = 265097,
  [SMALL_STATE(8095)] = 265107,
  [SMALL_STATE(8096)] = 265117,
  [SMALL_STATE(8097)] = 265127,
  [SMALL_STATE(8098)] = 265137,
  [SMALL_STATE(8099)] = 265147,
  [SMALL_STATE(8100)] = 265157,
  [SMALL_STATE(8101)] = 265167,
  [SMALL_STATE(8102)] = 265177,
  [SMALL_STATE(8103)] = 265187,
  [SMALL_STATE(8104)] = 265195,
  [SMALL_STATE(8105)] = 265203,
  [SMALL_STATE(8106)] = 265213,
  [SMALL_STATE(8107)] = 265221,
  [SMALL_STATE(8108)] = 265231,
  [SMALL_STATE(8109)] = 265241,
  [SMALL_STATE(8110)] = 265251,
  [SMALL_STATE(8111)] = 265261,
  [SMALL_STATE(8112)] = 265271,
  [SMALL_STATE(8113)] = 265281,
  [SMALL_STATE(8114)] = 265291,
  [SMALL_STATE(8115)] = 265301,
  [SMALL_STATE(8116)] = 265309,
  [SMALL_STATE(8117)] = 265319,
  [SMALL_STATE(8118)] = 265327,
  [SMALL_STATE(8119)] = 265337,
  [SMALL_STATE(8120)] = 265347,
  [SMALL_STATE(8121)] = 265357,
  [SMALL_STATE(8122)] = 265367,
  [SMALL_STATE(8123)] = 265377,
  [SMALL_STATE(8124)] = 265387,
  [SMALL_STATE(8125)] = 265397,
  [SMALL_STATE(8126)] = 265405,
  [SMALL_STATE(8127)] = 265415,
  [SMALL_STATE(8128)] = 265423,
  [SMALL_STATE(8129)] = 265433,
  [SMALL_STATE(8130)] = 265443,
  [SMALL_STATE(8131)] = 265453,
  [SMALL_STATE(8132)] = 265463,
  [SMALL_STATE(8133)] = 265473,
  [SMALL_STATE(8134)] = 265483,
  [SMALL_STATE(8135)] = 265493,
  [SMALL_STATE(8136)] = 265503,
  [SMALL_STATE(8137)] = 265513,
  [SMALL_STATE(8138)] = 265523,
  [SMALL_STATE(8139)] = 265533,
  [SMALL_STATE(8140)] = 265543,
  [SMALL_STATE(8141)] = 265553,
  [SMALL_STATE(8142)] = 265563,
  [SMALL_STATE(8143)] = 265573,
  [SMALL_STATE(8144)] = 265583,
  [SMALL_STATE(8145)] = 265593,
  [SMALL_STATE(8146)] = 265603,
  [SMALL_STATE(8147)] = 265613,
  [SMALL_STATE(8148)] = 265623,
  [SMALL_STATE(8149)] = 265633,
  [SMALL_STATE(8150)] = 265643,
  [SMALL_STATE(8151)] = 265653,
  [SMALL_STATE(8152)] = 265663,
  [SMALL_STATE(8153)] = 265673,
  [SMALL_STATE(8154)] = 265683,
  [SMALL_STATE(8155)] = 265693,
  [SMALL_STATE(8156)] = 265703,
  [SMALL_STATE(8157)] = 265713,
  [SMALL_STATE(8158)] = 265723,
  [SMALL_STATE(8159)] = 265733,
  [SMALL_STATE(8160)] = 265743,
  [SMALL_STATE(8161)] = 265753,
  [SMALL_STATE(8162)] = 265763,
  [SMALL_STATE(8163)] = 265773,
  [SMALL_STATE(8164)] = 265783,
  [SMALL_STATE(8165)] = 265793,
  [SMALL_STATE(8166)] = 265803,
  [SMALL_STATE(8167)] = 265813,
  [SMALL_STATE(8168)] = 265823,
  [SMALL_STATE(8169)] = 265833,
  [SMALL_STATE(8170)] = 265843,
  [SMALL_STATE(8171)] = 265851,
  [SMALL_STATE(8172)] = 265859,
  [SMALL_STATE(8173)] = 265869,
  [SMALL_STATE(8174)] = 265879,
  [SMALL_STATE(8175)] = 265889,
  [SMALL_STATE(8176)] = 265899,
  [SMALL_STATE(8177)] = 265909,
  [SMALL_STATE(8178)] = 265919,
  [SMALL_STATE(8179)] = 265927,
  [SMALL_STATE(8180)] = 265937,
  [SMALL_STATE(8181)] = 265947,
  [SMALL_STATE(8182)] = 265955,
  [SMALL_STATE(8183)] = 265965,
  [SMALL_STATE(8184)] = 265975,
  [SMALL_STATE(8185)] = 265985,
  [SMALL_STATE(8186)] = 265995,
  [SMALL_STATE(8187)] = 266005,
  [SMALL_STATE(8188)] = 266015,
  [SMALL_STATE(8189)] = 266025,
  [SMALL_STATE(8190)] = 266035,
  [SMALL_STATE(8191)] = 266045,
  [SMALL_STATE(8192)] = 266055,
  [SMALL_STATE(8193)] = 266065,
  [SMALL_STATE(8194)] = 266075,
  [SMALL_STATE(8195)] = 266085,
  [SMALL_STATE(8196)] = 266095,
  [SMALL_STATE(8197)] = 266105,
  [SMALL_STATE(8198)] = 266115,
  [SMALL_STATE(8199)] = 266125,
  [SMALL_STATE(8200)] = 266135,
  [SMALL_STATE(8201)] = 266145,
  [SMALL_STATE(8202)] = 266155,
  [SMALL_STATE(8203)] = 266165,
  [SMALL_STATE(8204)] = 266175,
  [SMALL_STATE(8205)] = 266183,
  [SMALL_STATE(8206)] = 266193,
  [SMALL_STATE(8207)] = 266203,
  [SMALL_STATE(8208)] = 266213,
  [SMALL_STATE(8209)] = 266223,
  [SMALL_STATE(8210)] = 266233,
  [SMALL_STATE(8211)] = 266243,
  [SMALL_STATE(8212)] = 266251,
  [SMALL_STATE(8213)] = 266261,
  [SMALL_STATE(8214)] = 266271,
  [SMALL_STATE(8215)] = 266281,
  [SMALL_STATE(8216)] = 266291,
  [SMALL_STATE(8217)] = 266301,
  [SMALL_STATE(8218)] = 266309,
  [SMALL_STATE(8219)] = 266317,
  [SMALL_STATE(8220)] = 266327,
  [SMALL_STATE(8221)] = 266337,
  [SMALL_STATE(8222)] = 266345,
  [SMALL_STATE(8223)] = 266355,
  [SMALL_STATE(8224)] = 266365,
  [SMALL_STATE(8225)] = 266373,
  [SMALL_STATE(8226)] = 266383,
  [SMALL_STATE(8227)] = 266391,
  [SMALL_STATE(8228)] = 266401,
  [SMALL_STATE(8229)] = 266409,
  [SMALL_STATE(8230)] = 266419,
  [SMALL_STATE(8231)] = 266429,
  [SMALL_STATE(8232)] = 266439,
  [SMALL_STATE(8233)] = 266449,
  [SMALL_STATE(8234)] = 266459,
  [SMALL_STATE(8235)] = 266469,
  [SMALL_STATE(8236)] = 266479,
  [SMALL_STATE(8237)] = 266489,
  [SMALL_STATE(8238)] = 266499,
  [SMALL_STATE(8239)] = 266509,
  [SMALL_STATE(8240)] = 266519,
  [SMALL_STATE(8241)] = 266529,
  [SMALL_STATE(8242)] = 266539,
  [SMALL_STATE(8243)] = 266549,
  [SMALL_STATE(8244)] = 266559,
  [SMALL_STATE(8245)] = 266569,
  [SMALL_STATE(8246)] = 266576,
  [SMALL_STATE(8247)] = 266583,
  [SMALL_STATE(8248)] = 266590,
  [SMALL_STATE(8249)] = 266597,
  [SMALL_STATE(8250)] = 266604,
  [SMALL_STATE(8251)] = 266611,
  [SMALL_STATE(8252)] = 266618,
  [SMALL_STATE(8253)] = 266625,
  [SMALL_STATE(8254)] = 266632,
  [SMALL_STATE(8255)] = 266639,
  [SMALL_STATE(8256)] = 266646,
  [SMALL_STATE(8257)] = 266653,
  [SMALL_STATE(8258)] = 266660,
  [SMALL_STATE(8259)] = 266667,
  [SMALL_STATE(8260)] = 266674,
  [SMALL_STATE(8261)] = 266681,
  [SMALL_STATE(8262)] = 266688,
  [SMALL_STATE(8263)] = 266695,
  [SMALL_STATE(8264)] = 266702,
  [SMALL_STATE(8265)] = 266709,
  [SMALL_STATE(8266)] = 266716,
  [SMALL_STATE(8267)] = 266723,
  [SMALL_STATE(8268)] = 266730,
  [SMALL_STATE(8269)] = 266737,
  [SMALL_STATE(8270)] = 266744,
  [SMALL_STATE(8271)] = 266751,
  [SMALL_STATE(8272)] = 266758,
  [SMALL_STATE(8273)] = 266765,
  [SMALL_STATE(8274)] = 266772,
  [SMALL_STATE(8275)] = 266779,
  [SMALL_STATE(8276)] = 266786,
  [SMALL_STATE(8277)] = 266793,
  [SMALL_STATE(8278)] = 266800,
  [SMALL_STATE(8279)] = 266807,
  [SMALL_STATE(8280)] = 266814,
  [SMALL_STATE(8281)] = 266821,
  [SMALL_STATE(8282)] = 266828,
  [SMALL_STATE(8283)] = 266835,
  [SMALL_STATE(8284)] = 266842,
  [SMALL_STATE(8285)] = 266849,
  [SMALL_STATE(8286)] = 266856,
  [SMALL_STATE(8287)] = 266863,
  [SMALL_STATE(8288)] = 266870,
  [SMALL_STATE(8289)] = 266877,
  [SMALL_STATE(8290)] = 266884,
  [SMALL_STATE(8291)] = 266891,
  [SMALL_STATE(8292)] = 266898,
  [SMALL_STATE(8293)] = 266905,
  [SMALL_STATE(8294)] = 266912,
  [SMALL_STATE(8295)] = 266919,
  [SMALL_STATE(8296)] = 266926,
  [SMALL_STATE(8297)] = 266933,
  [SMALL_STATE(8298)] = 266940,
  [SMALL_STATE(8299)] = 266947,
  [SMALL_STATE(8300)] = 266954,
  [SMALL_STATE(8301)] = 266961,
  [SMALL_STATE(8302)] = 266968,
  [SMALL_STATE(8303)] = 266975,
  [SMALL_STATE(8304)] = 266982,
  [SMALL_STATE(8305)] = 266989,
  [SMALL_STATE(8306)] = 266996,
  [SMALL_STATE(8307)] = 267003,
  [SMALL_STATE(8308)] = 267010,
  [SMALL_STATE(8309)] = 267017,
  [SMALL_STATE(8310)] = 267024,
  [SMALL_STATE(8311)] = 267031,
  [SMALL_STATE(8312)] = 267038,
  [SMALL_STATE(8313)] = 267045,
  [SMALL_STATE(8314)] = 267052,
  [SMALL_STATE(8315)] = 267059,
  [SMALL_STATE(8316)] = 267066,
  [SMALL_STATE(8317)] = 267073,
  [SMALL_STATE(8318)] = 267080,
  [SMALL_STATE(8319)] = 267087,
  [SMALL_STATE(8320)] = 267094,
  [SMALL_STATE(8321)] = 267101,
  [SMALL_STATE(8322)] = 267108,
  [SMALL_STATE(8323)] = 267115,
  [SMALL_STATE(8324)] = 267122,
  [SMALL_STATE(8325)] = 267129,
  [SMALL_STATE(8326)] = 267136,
  [SMALL_STATE(8327)] = 267143,
  [SMALL_STATE(8328)] = 267150,
  [SMALL_STATE(8329)] = 267157,
  [SMALL_STATE(8330)] = 267164,
  [SMALL_STATE(8331)] = 267171,
  [SMALL_STATE(8332)] = 267178,
  [SMALL_STATE(8333)] = 267185,
  [SMALL_STATE(8334)] = 267192,
  [SMALL_STATE(8335)] = 267199,
  [SMALL_STATE(8336)] = 267206,
  [SMALL_STATE(8337)] = 267213,
  [SMALL_STATE(8338)] = 267220,
  [SMALL_STATE(8339)] = 267227,
  [SMALL_STATE(8340)] = 267234,
  [SMALL_STATE(8341)] = 267241,
  [SMALL_STATE(8342)] = 267248,
  [SMALL_STATE(8343)] = 267255,
  [SMALL_STATE(8344)] = 267262,
  [SMALL_STATE(8345)] = 267269,
  [SMALL_STATE(8346)] = 267276,
  [SMALL_STATE(8347)] = 267283,
  [SMALL_STATE(8348)] = 267290,
  [SMALL_STATE(8349)] = 267297,
  [SMALL_STATE(8350)] = 267304,
  [SMALL_STATE(8351)] = 267311,
  [SMALL_STATE(8352)] = 267318,
  [SMALL_STATE(8353)] = 267325,
  [SMALL_STATE(8354)] = 267332,
  [SMALL_STATE(8355)] = 267339,
  [SMALL_STATE(8356)] = 267346,
  [SMALL_STATE(8357)] = 267353,
  [SMALL_STATE(8358)] = 267360,
  [SMALL_STATE(8359)] = 267367,
  [SMALL_STATE(8360)] = 267374,
  [SMALL_STATE(8361)] = 267381,
  [SMALL_STATE(8362)] = 267388,
  [SMALL_STATE(8363)] = 267395,
  [SMALL_STATE(8364)] = 267402,
  [SMALL_STATE(8365)] = 267409,
  [SMALL_STATE(8366)] = 267416,
  [SMALL_STATE(8367)] = 267423,
  [SMALL_STATE(8368)] = 267430,
  [SMALL_STATE(8369)] = 267437,
  [SMALL_STATE(8370)] = 267444,
  [SMALL_STATE(8371)] = 267451,
  [SMALL_STATE(8372)] = 267458,
  [SMALL_STATE(8373)] = 267465,
  [SMALL_STATE(8374)] = 267472,
  [SMALL_STATE(8375)] = 267479,
  [SMALL_STATE(8376)] = 267486,
  [SMALL_STATE(8377)] = 267493,
  [SMALL_STATE(8378)] = 267500,
  [SMALL_STATE(8379)] = 267507,
  [SMALL_STATE(8380)] = 267514,
  [SMALL_STATE(8381)] = 267521,
  [SMALL_STATE(8382)] = 267528,
  [SMALL_STATE(8383)] = 267535,
  [SMALL_STATE(8384)] = 267542,
  [SMALL_STATE(8385)] = 267549,
  [SMALL_STATE(8386)] = 267556,
  [SMALL_STATE(8387)] = 267563,
  [SMALL_STATE(8388)] = 267570,
  [SMALL_STATE(8389)] = 267577,
  [SMALL_STATE(8390)] = 267584,
  [SMALL_STATE(8391)] = 267591,
  [SMALL_STATE(8392)] = 267598,
  [SMALL_STATE(8393)] = 267605,
  [SMALL_STATE(8394)] = 267612,
  [SMALL_STATE(8395)] = 267619,
  [SMALL_STATE(8396)] = 267626,
  [SMALL_STATE(8397)] = 267633,
  [SMALL_STATE(8398)] = 267640,
  [SMALL_STATE(8399)] = 267647,
  [SMALL_STATE(8400)] = 267654,
  [SMALL_STATE(8401)] = 267661,
  [SMALL_STATE(8402)] = 267668,
  [SMALL_STATE(8403)] = 267675,
  [SMALL_STATE(8404)] = 267682,
  [SMALL_STATE(8405)] = 267689,
  [SMALL_STATE(8406)] = 267696,
  [SMALL_STATE(8407)] = 267703,
  [SMALL_STATE(8408)] = 267710,
  [SMALL_STATE(8409)] = 267717,
  [SMALL_STATE(8410)] = 267724,
  [SMALL_STATE(8411)] = 267731,
  [SMALL_STATE(8412)] = 267738,
  [SMALL_STATE(8413)] = 267745,
  [SMALL_STATE(8414)] = 267752,
  [SMALL_STATE(8415)] = 267759,
  [SMALL_STATE(8416)] = 267766,
  [SMALL_STATE(8417)] = 267773,
  [SMALL_STATE(8418)] = 267780,
  [SMALL_STATE(8419)] = 267787,
  [SMALL_STATE(8420)] = 267794,
  [SMALL_STATE(8421)] = 267801,
  [SMALL_STATE(8422)] = 267808,
  [SMALL_STATE(8423)] = 267815,
  [SMALL_STATE(8424)] = 267822,
  [SMALL_STATE(8425)] = 267829,
  [SMALL_STATE(8426)] = 267836,
  [SMALL_STATE(8427)] = 267843,
  [SMALL_STATE(8428)] = 267850,
  [SMALL_STATE(8429)] = 267857,
  [SMALL_STATE(8430)] = 267864,
  [SMALL_STATE(8431)] = 267871,
  [SMALL_STATE(8432)] = 267878,
  [SMALL_STATE(8433)] = 267885,
  [SMALL_STATE(8434)] = 267892,
  [SMALL_STATE(8435)] = 267899,
  [SMALL_STATE(8436)] = 267906,
  [SMALL_STATE(8437)] = 267913,
  [SMALL_STATE(8438)] = 267920,
  [SMALL_STATE(8439)] = 267927,
  [SMALL_STATE(8440)] = 267934,
  [SMALL_STATE(8441)] = 267941,
  [SMALL_STATE(8442)] = 267948,
  [SMALL_STATE(8443)] = 267955,
  [SMALL_STATE(8444)] = 267962,
  [SMALL_STATE(8445)] = 267969,
  [SMALL_STATE(8446)] = 267976,
  [SMALL_STATE(8447)] = 267983,
  [SMALL_STATE(8448)] = 267990,
  [SMALL_STATE(8449)] = 267997,
  [SMALL_STATE(8450)] = 268004,
  [SMALL_STATE(8451)] = 268011,
  [SMALL_STATE(8452)] = 268018,
  [SMALL_STATE(8453)] = 268025,
  [SMALL_STATE(8454)] = 268032,
  [SMALL_STATE(8455)] = 268039,
  [SMALL_STATE(8456)] = 268046,
  [SMALL_STATE(8457)] = 268053,
  [SMALL_STATE(8458)] = 268060,
  [SMALL_STATE(8459)] = 268067,
  [SMALL_STATE(8460)] = 268074,
  [SMALL_STATE(8461)] = 268081,
  [SMALL_STATE(8462)] = 268088,
  [SMALL_STATE(8463)] = 268095,
  [SMALL_STATE(8464)] = 268102,
  [SMALL_STATE(8465)] = 268109,
  [SMALL_STATE(8466)] = 268116,
  [SMALL_STATE(8467)] = 268123,
  [SMALL_STATE(8468)] = 268130,
  [SMALL_STATE(8469)] = 268137,
  [SMALL_STATE(8470)] = 268144,
  [SMALL_STATE(8471)] = 268151,
  [SMALL_STATE(8472)] = 268158,
  [SMALL_STATE(8473)] = 268165,
  [SMALL_STATE(8474)] = 268172,
  [SMALL_STATE(8475)] = 268179,
  [SMALL_STATE(8476)] = 268186,
  [SMALL_STATE(8477)] = 268193,
  [SMALL_STATE(8478)] = 268200,
  [SMALL_STATE(8479)] = 268207,
  [SMALL_STATE(8480)] = 268214,
  [SMALL_STATE(8481)] = 268221,
  [SMALL_STATE(8482)] = 268228,
  [SMALL_STATE(8483)] = 268235,
  [SMALL_STATE(8484)] = 268242,
  [SMALL_STATE(8485)] = 268249,
  [SMALL_STATE(8486)] = 268256,
  [SMALL_STATE(8487)] = 268263,
  [SMALL_STATE(8488)] = 268270,
  [SMALL_STATE(8489)] = 268277,
  [SMALL_STATE(8490)] = 268284,
  [SMALL_STATE(8491)] = 268291,
  [SMALL_STATE(8492)] = 268298,
  [SMALL_STATE(8493)] = 268305,
  [SMALL_STATE(8494)] = 268312,
  [SMALL_STATE(8495)] = 268319,
  [SMALL_STATE(8496)] = 268326,
  [SMALL_STATE(8497)] = 268333,
  [SMALL_STATE(8498)] = 268340,
  [SMALL_STATE(8499)] = 268347,
  [SMALL_STATE(8500)] = 268354,
  [SMALL_STATE(8501)] = 268361,
  [SMALL_STATE(8502)] = 268368,
  [SMALL_STATE(8503)] = 268375,
  [SMALL_STATE(8504)] = 268382,
  [SMALL_STATE(8505)] = 268389,
  [SMALL_STATE(8506)] = 268396,
  [SMALL_STATE(8507)] = 268403,
  [SMALL_STATE(8508)] = 268410,
  [SMALL_STATE(8509)] = 268417,
  [SMALL_STATE(8510)] = 268424,
  [SMALL_STATE(8511)] = 268431,
  [SMALL_STATE(8512)] = 268438,
  [SMALL_STATE(8513)] = 268445,
  [SMALL_STATE(8514)] = 268452,
  [SMALL_STATE(8515)] = 268459,
  [SMALL_STATE(8516)] = 268466,
  [SMALL_STATE(8517)] = 268473,
  [SMALL_STATE(8518)] = 268480,
  [SMALL_STATE(8519)] = 268487,
  [SMALL_STATE(8520)] = 268494,
  [SMALL_STATE(8521)] = 268501,
  [SMALL_STATE(8522)] = 268508,
  [SMALL_STATE(8523)] = 268515,
  [SMALL_STATE(8524)] = 268522,
  [SMALL_STATE(8525)] = 268529,
  [SMALL_STATE(8526)] = 268536,
  [SMALL_STATE(8527)] = 268543,
  [SMALL_STATE(8528)] = 268550,
  [SMALL_STATE(8529)] = 268557,
  [SMALL_STATE(8530)] = 268564,
  [SMALL_STATE(8531)] = 268571,
  [SMALL_STATE(8532)] = 268578,
  [SMALL_STATE(8533)] = 268585,
  [SMALL_STATE(8534)] = 268592,
  [SMALL_STATE(8535)] = 268599,
  [SMALL_STATE(8536)] = 268606,
  [SMALL_STATE(8537)] = 268613,
  [SMALL_STATE(8538)] = 268620,
  [SMALL_STATE(8539)] = 268627,
  [SMALL_STATE(8540)] = 268634,
  [SMALL_STATE(8541)] = 268641,
  [SMALL_STATE(8542)] = 268648,
  [SMALL_STATE(8543)] = 268655,
  [SMALL_STATE(8544)] = 268662,
  [SMALL_STATE(8545)] = 268669,
  [SMALL_STATE(8546)] = 268676,
  [SMALL_STATE(8547)] = 268683,
  [SMALL_STATE(8548)] = 268690,
  [SMALL_STATE(8549)] = 268697,
  [SMALL_STATE(8550)] = 268704,
  [SMALL_STATE(8551)] = 268711,
  [SMALL_STATE(8552)] = 268718,
  [SMALL_STATE(8553)] = 268725,
  [SMALL_STATE(8554)] = 268732,
  [SMALL_STATE(8555)] = 268739,
  [SMALL_STATE(8556)] = 268746,
  [SMALL_STATE(8557)] = 268753,
  [SMALL_STATE(8558)] = 268760,
  [SMALL_STATE(8559)] = 268767,
  [SMALL_STATE(8560)] = 268774,
  [SMALL_STATE(8561)] = 268781,
  [SMALL_STATE(8562)] = 268788,
  [SMALL_STATE(8563)] = 268795,
  [SMALL_STATE(8564)] = 268802,
  [SMALL_STATE(8565)] = 268809,
  [SMALL_STATE(8566)] = 268816,
  [SMALL_STATE(8567)] = 268823,
  [SMALL_STATE(8568)] = 268830,
  [SMALL_STATE(8569)] = 268837,
  [SMALL_STATE(8570)] = 268844,
  [SMALL_STATE(8571)] = 268851,
  [SMALL_STATE(8572)] = 268858,
  [SMALL_STATE(8573)] = 268865,
  [SMALL_STATE(8574)] = 268872,
  [SMALL_STATE(8575)] = 268879,
  [SMALL_STATE(8576)] = 268886,
  [SMALL_STATE(8577)] = 268893,
  [SMALL_STATE(8578)] = 268900,
  [SMALL_STATE(8579)] = 268907,
  [SMALL_STATE(8580)] = 268914,
  [SMALL_STATE(8581)] = 268921,
  [SMALL_STATE(8582)] = 268928,
  [SMALL_STATE(8583)] = 268935,
  [SMALL_STATE(8584)] = 268942,
  [SMALL_STATE(8585)] = 268949,
  [SMALL_STATE(8586)] = 268956,
  [SMALL_STATE(8587)] = 268963,
  [SMALL_STATE(8588)] = 268970,
  [SMALL_STATE(8589)] = 268977,
  [SMALL_STATE(8590)] = 268984,
  [SMALL_STATE(8591)] = 268991,
  [SMALL_STATE(8592)] = 268998,
  [SMALL_STATE(8593)] = 269005,
  [SMALL_STATE(8594)] = 269012,
  [SMALL_STATE(8595)] = 269019,
  [SMALL_STATE(8596)] = 269026,
  [SMALL_STATE(8597)] = 269033,
  [SMALL_STATE(8598)] = 269040,
  [SMALL_STATE(8599)] = 269047,
  [SMALL_STATE(8600)] = 269054,
  [SMALL_STATE(8601)] = 269061,
  [SMALL_STATE(8602)] = 269068,
  [SMALL_STATE(8603)] = 269075,
  [SMALL_STATE(8604)] = 269082,
  [SMALL_STATE(8605)] = 269089,
  [SMALL_STATE(8606)] = 269096,
  [SMALL_STATE(8607)] = 269103,
  [SMALL_STATE(8608)] = 269110,
  [SMALL_STATE(8609)] = 269117,
  [SMALL_STATE(8610)] = 269124,
  [SMALL_STATE(8611)] = 269131,
  [SMALL_STATE(8612)] = 269138,
  [SMALL_STATE(8613)] = 269145,
  [SMALL_STATE(8614)] = 269152,
  [SMALL_STATE(8615)] = 269159,
  [SMALL_STATE(8616)] = 269166,
  [SMALL_STATE(8617)] = 269173,
  [SMALL_STATE(8618)] = 269180,
  [SMALL_STATE(8619)] = 269187,
  [SMALL_STATE(8620)] = 269194,
  [SMALL_STATE(8621)] = 269201,
  [SMALL_STATE(8622)] = 269208,
  [SMALL_STATE(8623)] = 269215,
  [SMALL_STATE(8624)] = 269222,
  [SMALL_STATE(8625)] = 269229,
  [SMALL_STATE(8626)] = 269236,
  [SMALL_STATE(8627)] = 269243,
  [SMALL_STATE(8628)] = 269250,
  [SMALL_STATE(8629)] = 269257,
  [SMALL_STATE(8630)] = 269264,
  [SMALL_STATE(8631)] = 269271,
  [SMALL_STATE(8632)] = 269278,
  [SMALL_STATE(8633)] = 269285,
  [SMALL_STATE(8634)] = 269292,
  [SMALL_STATE(8635)] = 269299,
  [SMALL_STATE(8636)] = 269306,
  [SMALL_STATE(8637)] = 269313,
  [SMALL_STATE(8638)] = 269320,
  [SMALL_STATE(8639)] = 269327,
  [SMALL_STATE(8640)] = 269334,
  [SMALL_STATE(8641)] = 269341,
  [SMALL_STATE(8642)] = 269348,
  [SMALL_STATE(8643)] = 269355,
  [SMALL_STATE(8644)] = 269362,
  [SMALL_STATE(8645)] = 269369,
  [SMALL_STATE(8646)] = 269376,
  [SMALL_STATE(8647)] = 269383,
  [SMALL_STATE(8648)] = 269390,
  [SMALL_STATE(8649)] = 269397,
  [SMALL_STATE(8650)] = 269404,
  [SMALL_STATE(8651)] = 269411,
  [SMALL_STATE(8652)] = 269418,
  [SMALL_STATE(8653)] = 269425,
  [SMALL_STATE(8654)] = 269432,
  [SMALL_STATE(8655)] = 269439,
  [SMALL_STATE(8656)] = 269446,
  [SMALL_STATE(8657)] = 269453,
  [SMALL_STATE(8658)] = 269460,
  [SMALL_STATE(8659)] = 269467,
  [SMALL_STATE(8660)] = 269474,
  [SMALL_STATE(8661)] = 269481,
  [SMALL_STATE(8662)] = 269488,
  [SMALL_STATE(8663)] = 269495,
  [SMALL_STATE(8664)] = 269502,
  [SMALL_STATE(8665)] = 269509,
  [SMALL_STATE(8666)] = 269516,
  [SMALL_STATE(8667)] = 269523,
  [SMALL_STATE(8668)] = 269530,
  [SMALL_STATE(8669)] = 269537,
  [SMALL_STATE(8670)] = 269544,
  [SMALL_STATE(8671)] = 269551,
  [SMALL_STATE(8672)] = 269558,
  [SMALL_STATE(8673)] = 269565,
  [SMALL_STATE(8674)] = 269572,
  [SMALL_STATE(8675)] = 269579,
  [SMALL_STATE(8676)] = 269586,
  [SMALL_STATE(8677)] = 269593,
  [SMALL_STATE(8678)] = 269600,
  [SMALL_STATE(8679)] = 269607,
  [SMALL_STATE(8680)] = 269614,
  [SMALL_STATE(8681)] = 269621,
  [SMALL_STATE(8682)] = 269628,
  [SMALL_STATE(8683)] = 269635,
  [SMALL_STATE(8684)] = 269642,
  [SMALL_STATE(8685)] = 269649,
  [SMALL_STATE(8686)] = 269656,
  [SMALL_STATE(8687)] = 269663,
  [SMALL_STATE(8688)] = 269670,
  [SMALL_STATE(8689)] = 269677,
  [SMALL_STATE(8690)] = 269684,
  [SMALL_STATE(8691)] = 269691,
  [SMALL_STATE(8692)] = 269698,
  [SMALL_STATE(8693)] = 269705,
  [SMALL_STATE(8694)] = 269712,
  [SMALL_STATE(8695)] = 269719,
  [SMALL_STATE(8696)] = 269726,
  [SMALL_STATE(8697)] = 269733,
  [SMALL_STATE(8698)] = 269740,
  [SMALL_STATE(8699)] = 269747,
  [SMALL_STATE(8700)] = 269754,
  [SMALL_STATE(8701)] = 269761,
  [SMALL_STATE(8702)] = 269768,
  [SMALL_STATE(8703)] = 269775,
  [SMALL_STATE(8704)] = 269782,
  [SMALL_STATE(8705)] = 269789,
  [SMALL_STATE(8706)] = 269796,
  [SMALL_STATE(8707)] = 269803,
  [SMALL_STATE(8708)] = 269810,
  [SMALL_STATE(8709)] = 269817,
  [SMALL_STATE(8710)] = 269824,
  [SMALL_STATE(8711)] = 269831,
  [SMALL_STATE(8712)] = 269838,
  [SMALL_STATE(8713)] = 269845,
  [SMALL_STATE(8714)] = 269852,
  [SMALL_STATE(8715)] = 269859,
  [SMALL_STATE(8716)] = 269866,
  [SMALL_STATE(8717)] = 269873,
  [SMALL_STATE(8718)] = 269880,
  [SMALL_STATE(8719)] = 269887,
  [SMALL_STATE(8720)] = 269894,
  [SMALL_STATE(8721)] = 269901,
  [SMALL_STATE(8722)] = 269908,
  [SMALL_STATE(8723)] = 269915,
  [SMALL_STATE(8724)] = 269922,
  [SMALL_STATE(8725)] = 269929,
  [SMALL_STATE(8726)] = 269936,
  [SMALL_STATE(8727)] = 269943,
  [SMALL_STATE(8728)] = 269950,
  [SMALL_STATE(8729)] = 269957,
  [SMALL_STATE(8730)] = 269964,
  [SMALL_STATE(8731)] = 269971,
  [SMALL_STATE(8732)] = 269978,
  [SMALL_STATE(8733)] = 269985,
  [SMALL_STATE(8734)] = 269992,
  [SMALL_STATE(8735)] = 269999,
  [SMALL_STATE(8736)] = 270006,
  [SMALL_STATE(8737)] = 270013,
  [SMALL_STATE(8738)] = 270020,
  [SMALL_STATE(8739)] = 270027,
  [SMALL_STATE(8740)] = 270034,
  [SMALL_STATE(8741)] = 270041,
  [SMALL_STATE(8742)] = 270048,
  [SMALL_STATE(8743)] = 270055,
  [SMALL_STATE(8744)] = 270062,
  [SMALL_STATE(8745)] = 270069,
  [SMALL_STATE(8746)] = 270076,
  [SMALL_STATE(8747)] = 270083,
  [SMALL_STATE(8748)] = 270090,
  [SMALL_STATE(8749)] = 270097,
  [SMALL_STATE(8750)] = 270104,
  [SMALL_STATE(8751)] = 270111,
  [SMALL_STATE(8752)] = 270118,
  [SMALL_STATE(8753)] = 270125,
  [SMALL_STATE(8754)] = 270132,
  [SMALL_STATE(8755)] = 270139,
  [SMALL_STATE(8756)] = 270146,
  [SMALL_STATE(8757)] = 270153,
  [SMALL_STATE(8758)] = 270160,
  [SMALL_STATE(8759)] = 270167,
  [SMALL_STATE(8760)] = 270174,
  [SMALL_STATE(8761)] = 270181,
  [SMALL_STATE(8762)] = 270188,
  [SMALL_STATE(8763)] = 270195,
  [SMALL_STATE(8764)] = 270202,
  [SMALL_STATE(8765)] = 270209,
  [SMALL_STATE(8766)] = 270216,
  [SMALL_STATE(8767)] = 270223,
  [SMALL_STATE(8768)] = 270230,
  [SMALL_STATE(8769)] = 270237,
  [SMALL_STATE(8770)] = 270244,
  [SMALL_STATE(8771)] = 270251,
  [SMALL_STATE(8772)] = 270258,
  [SMALL_STATE(8773)] = 270265,
  [SMALL_STATE(8774)] = 270272,
  [SMALL_STATE(8775)] = 270279,
  [SMALL_STATE(8776)] = 270286,
  [SMALL_STATE(8777)] = 270293,
  [SMALL_STATE(8778)] = 270300,
  [SMALL_STATE(8779)] = 270307,
  [SMALL_STATE(8780)] = 270314,
  [SMALL_STATE(8781)] = 270321,
  [SMALL_STATE(8782)] = 270328,
  [SMALL_STATE(8783)] = 270335,
  [SMALL_STATE(8784)] = 270342,
  [SMALL_STATE(8785)] = 270349,
  [SMALL_STATE(8786)] = 270356,
  [SMALL_STATE(8787)] = 270363,
  [SMALL_STATE(8788)] = 270370,
  [SMALL_STATE(8789)] = 270377,
  [SMALL_STATE(8790)] = 270384,
  [SMALL_STATE(8791)] = 270391,
  [SMALL_STATE(8792)] = 270398,
  [SMALL_STATE(8793)] = 270405,
  [SMALL_STATE(8794)] = 270412,
  [SMALL_STATE(8795)] = 270419,
  [SMALL_STATE(8796)] = 270426,
  [SMALL_STATE(8797)] = 270433,
  [SMALL_STATE(8798)] = 270440,
  [SMALL_STATE(8799)] = 270447,
  [SMALL_STATE(8800)] = 270454,
  [SMALL_STATE(8801)] = 270461,
  [SMALL_STATE(8802)] = 270468,
  [SMALL_STATE(8803)] = 270475,
  [SMALL_STATE(8804)] = 270482,
  [SMALL_STATE(8805)] = 270489,
  [SMALL_STATE(8806)] = 270496,
  [SMALL_STATE(8807)] = 270503,
  [SMALL_STATE(8808)] = 270510,
  [SMALL_STATE(8809)] = 270517,
  [SMALL_STATE(8810)] = 270524,
  [SMALL_STATE(8811)] = 270531,
  [SMALL_STATE(8812)] = 270538,
  [SMALL_STATE(8813)] = 270545,
  [SMALL_STATE(8814)] = 270552,
  [SMALL_STATE(8815)] = 270559,
  [SMALL_STATE(8816)] = 270566,
  [SMALL_STATE(8817)] = 270573,
  [SMALL_STATE(8818)] = 270580,
  [SMALL_STATE(8819)] = 270587,
  [SMALL_STATE(8820)] = 270594,
  [SMALL_STATE(8821)] = 270601,
  [SMALL_STATE(8822)] = 270608,
  [SMALL_STATE(8823)] = 270615,
  [SMALL_STATE(8824)] = 270622,
  [SMALL_STATE(8825)] = 270629,
  [SMALL_STATE(8826)] = 270636,
  [SMALL_STATE(8827)] = 270643,
  [SMALL_STATE(8828)] = 270650,
  [SMALL_STATE(8829)] = 270657,
  [SMALL_STATE(8830)] = 270664,
  [SMALL_STATE(8831)] = 270671,
  [SMALL_STATE(8832)] = 270678,
  [SMALL_STATE(8833)] = 270685,
  [SMALL_STATE(8834)] = 270692,
  [SMALL_STATE(8835)] = 270699,
  [SMALL_STATE(8836)] = 270706,
  [SMALL_STATE(8837)] = 270713,
  [SMALL_STATE(8838)] = 270720,
  [SMALL_STATE(8839)] = 270727,
  [SMALL_STATE(8840)] = 270734,
  [SMALL_STATE(8841)] = 270741,
  [SMALL_STATE(8842)] = 270748,
  [SMALL_STATE(8843)] = 270755,
  [SMALL_STATE(8844)] = 270762,
  [SMALL_STATE(8845)] = 270769,
  [SMALL_STATE(8846)] = 270776,
  [SMALL_STATE(8847)] = 270783,
  [SMALL_STATE(8848)] = 270790,
  [SMALL_STATE(8849)] = 270797,
  [SMALL_STATE(8850)] = 270804,
  [SMALL_STATE(8851)] = 270811,
  [SMALL_STATE(8852)] = 270818,
  [SMALL_STATE(8853)] = 270825,
  [SMALL_STATE(8854)] = 270832,
  [SMALL_STATE(8855)] = 270839,
  [SMALL_STATE(8856)] = 270846,
  [SMALL_STATE(8857)] = 270853,
  [SMALL_STATE(8858)] = 270860,
  [SMALL_STATE(8859)] = 270867,
  [SMALL_STATE(8860)] = 270874,
  [SMALL_STATE(8861)] = 270881,
  [SMALL_STATE(8862)] = 270888,
  [SMALL_STATE(8863)] = 270895,
  [SMALL_STATE(8864)] = 270902,
  [SMALL_STATE(8865)] = 270909,
  [SMALL_STATE(8866)] = 270916,
  [SMALL_STATE(8867)] = 270923,
  [SMALL_STATE(8868)] = 270930,
  [SMALL_STATE(8869)] = 270937,
  [SMALL_STATE(8870)] = 270944,
  [SMALL_STATE(8871)] = 270951,
  [SMALL_STATE(8872)] = 270958,
  [SMALL_STATE(8873)] = 270965,
  [SMALL_STATE(8874)] = 270972,
  [SMALL_STATE(8875)] = 270979,
  [SMALL_STATE(8876)] = 270986,
  [SMALL_STATE(8877)] = 270993,
  [SMALL_STATE(8878)] = 271000,
  [SMALL_STATE(8879)] = 271007,
  [SMALL_STATE(8880)] = 271014,
  [SMALL_STATE(8881)] = 271021,
  [SMALL_STATE(8882)] = 271028,
  [SMALL_STATE(8883)] = 271035,
  [SMALL_STATE(8884)] = 271042,
  [SMALL_STATE(8885)] = 271049,
  [SMALL_STATE(8886)] = 271056,
  [SMALL_STATE(8887)] = 271063,
  [SMALL_STATE(8888)] = 271070,
  [SMALL_STATE(8889)] = 271077,
  [SMALL_STATE(8890)] = 271084,
  [SMALL_STATE(8891)] = 271091,
  [SMALL_STATE(8892)] = 271098,
  [SMALL_STATE(8893)] = 271105,
  [SMALL_STATE(8894)] = 271112,
  [SMALL_STATE(8895)] = 271119,
  [SMALL_STATE(8896)] = 271126,
  [SMALL_STATE(8897)] = 271133,
  [SMALL_STATE(8898)] = 271140,
  [SMALL_STATE(8899)] = 271147,
  [SMALL_STATE(8900)] = 271154,
  [SMALL_STATE(8901)] = 271161,
  [SMALL_STATE(8902)] = 271168,
  [SMALL_STATE(8903)] = 271175,
  [SMALL_STATE(8904)] = 271182,
  [SMALL_STATE(8905)] = 271189,
  [SMALL_STATE(8906)] = 271196,
  [SMALL_STATE(8907)] = 271203,
  [SMALL_STATE(8908)] = 271210,
  [SMALL_STATE(8909)] = 271217,
  [SMALL_STATE(8910)] = 271224,
  [SMALL_STATE(8911)] = 271231,
  [SMALL_STATE(8912)] = 271238,
  [SMALL_STATE(8913)] = 271245,
  [SMALL_STATE(8914)] = 271252,
  [SMALL_STATE(8915)] = 271259,
  [SMALL_STATE(8916)] = 271266,
  [SMALL_STATE(8917)] = 271273,
  [SMALL_STATE(8918)] = 271280,
  [SMALL_STATE(8919)] = 271287,
  [SMALL_STATE(8920)] = 271294,
  [SMALL_STATE(8921)] = 271301,
  [SMALL_STATE(8922)] = 271308,
  [SMALL_STATE(8923)] = 271315,
  [SMALL_STATE(8924)] = 271322,
  [SMALL_STATE(8925)] = 271329,
  [SMALL_STATE(8926)] = 271336,
  [SMALL_STATE(8927)] = 271343,
  [SMALL_STATE(8928)] = 271350,
  [SMALL_STATE(8929)] = 271357,
  [SMALL_STATE(8930)] = 271364,
  [SMALL_STATE(8931)] = 271371,
  [SMALL_STATE(8932)] = 271378,
  [SMALL_STATE(8933)] = 271385,
  [SMALL_STATE(8934)] = 271392,
  [SMALL_STATE(8935)] = 271399,
  [SMALL_STATE(8936)] = 271406,
  [SMALL_STATE(8937)] = 271413,
  [SMALL_STATE(8938)] = 271420,
  [SMALL_STATE(8939)] = 271427,
  [SMALL_STATE(8940)] = 271434,
  [SMALL_STATE(8941)] = 271441,
  [SMALL_STATE(8942)] = 271448,
  [SMALL_STATE(8943)] = 271455,
  [SMALL_STATE(8944)] = 271462,
  [SMALL_STATE(8945)] = 271469,
  [SMALL_STATE(8946)] = 271476,
  [SMALL_STATE(8947)] = 271483,
  [SMALL_STATE(8948)] = 271490,
  [SMALL_STATE(8949)] = 271497,
  [SMALL_STATE(8950)] = 271504,
  [SMALL_STATE(8951)] = 271511,
  [SMALL_STATE(8952)] = 271518,
  [SMALL_STATE(8953)] = 271525,
  [SMALL_STATE(8954)] = 271532,
  [SMALL_STATE(8955)] = 271539,
  [SMALL_STATE(8956)] = 271546,
  [SMALL_STATE(8957)] = 271553,
  [SMALL_STATE(8958)] = 271560,
  [SMALL_STATE(8959)] = 271567,
  [SMALL_STATE(8960)] = 271574,
  [SMALL_STATE(8961)] = 271581,
  [SMALL_STATE(8962)] = 271588,
  [SMALL_STATE(8963)] = 271595,
  [SMALL_STATE(8964)] = 271602,
  [SMALL_STATE(8965)] = 271609,
  [SMALL_STATE(8966)] = 271616,
  [SMALL_STATE(8967)] = 271623,
  [SMALL_STATE(8968)] = 271630,
  [SMALL_STATE(8969)] = 271637,
  [SMALL_STATE(8970)] = 271644,
  [SMALL_STATE(8971)] = 271651,
  [SMALL_STATE(8972)] = 271658,
  [SMALL_STATE(8973)] = 271665,
  [SMALL_STATE(8974)] = 271672,
  [SMALL_STATE(8975)] = 271679,
  [SMALL_STATE(8976)] = 271686,
  [SMALL_STATE(8977)] = 271693,
  [SMALL_STATE(8978)] = 271700,
  [SMALL_STATE(8979)] = 271707,
  [SMALL_STATE(8980)] = 271714,
  [SMALL_STATE(8981)] = 271721,
  [SMALL_STATE(8982)] = 271728,
  [SMALL_STATE(8983)] = 271735,
  [SMALL_STATE(8984)] = 271742,
  [SMALL_STATE(8985)] = 271749,
  [SMALL_STATE(8986)] = 271756,
  [SMALL_STATE(8987)] = 271763,
  [SMALL_STATE(8988)] = 271770,
  [SMALL_STATE(8989)] = 271777,
  [SMALL_STATE(8990)] = 271784,
  [SMALL_STATE(8991)] = 271791,
  [SMALL_STATE(8992)] = 271798,
  [SMALL_STATE(8993)] = 271805,
  [SMALL_STATE(8994)] = 271812,
  [SMALL_STATE(8995)] = 271819,
  [SMALL_STATE(8996)] = 271826,
  [SMALL_STATE(8997)] = 271833,
  [SMALL_STATE(8998)] = 271840,
  [SMALL_STATE(8999)] = 271847,
  [SMALL_STATE(9000)] = 271854,
  [SMALL_STATE(9001)] = 271861,
  [SMALL_STATE(9002)] = 271868,
  [SMALL_STATE(9003)] = 271875,
  [SMALL_STATE(9004)] = 271882,
  [SMALL_STATE(9005)] = 271889,
  [SMALL_STATE(9006)] = 271896,
  [SMALL_STATE(9007)] = 271903,
  [SMALL_STATE(9008)] = 271910,
  [SMALL_STATE(9009)] = 271917,
  [SMALL_STATE(9010)] = 271924,
  [SMALL_STATE(9011)] = 271931,
  [SMALL_STATE(9012)] = 271938,
  [SMALL_STATE(9013)] = 271945,
  [SMALL_STATE(9014)] = 271952,
  [SMALL_STATE(9015)] = 271959,
  [SMALL_STATE(9016)] = 271966,
  [SMALL_STATE(9017)] = 271973,
  [SMALL_STATE(9018)] = 271980,
  [SMALL_STATE(9019)] = 271987,
  [SMALL_STATE(9020)] = 271994,
  [SMALL_STATE(9021)] = 272001,
  [SMALL_STATE(9022)] = 272008,
  [SMALL_STATE(9023)] = 272015,
  [SMALL_STATE(9024)] = 272022,
  [SMALL_STATE(9025)] = 272029,
  [SMALL_STATE(9026)] = 272036,
  [SMALL_STATE(9027)] = 272043,
  [SMALL_STATE(9028)] = 272050,
  [SMALL_STATE(9029)] = 272057,
  [SMALL_STATE(9030)] = 272064,
  [SMALL_STATE(9031)] = 272071,
  [SMALL_STATE(9032)] = 272078,
  [SMALL_STATE(9033)] = 272085,
  [SMALL_STATE(9034)] = 272092,
  [SMALL_STATE(9035)] = 272099,
  [SMALL_STATE(9036)] = 272106,
  [SMALL_STATE(9037)] = 272113,
  [SMALL_STATE(9038)] = 272120,
  [SMALL_STATE(9039)] = 272127,
  [SMALL_STATE(9040)] = 272134,
  [SMALL_STATE(9041)] = 272141,
  [SMALL_STATE(9042)] = 272148,
  [SMALL_STATE(9043)] = 272155,
  [SMALL_STATE(9044)] = 272162,
  [SMALL_STATE(9045)] = 272169,
  [SMALL_STATE(9046)] = 272176,
  [SMALL_STATE(9047)] = 272183,
  [SMALL_STATE(9048)] = 272190,
  [SMALL_STATE(9049)] = 272197,
  [SMALL_STATE(9050)] = 272204,
  [SMALL_STATE(9051)] = 272211,
  [SMALL_STATE(9052)] = 272218,
  [SMALL_STATE(9053)] = 272225,
  [SMALL_STATE(9054)] = 272232,
  [SMALL_STATE(9055)] = 272239,
  [SMALL_STATE(9056)] = 272246,
  [SMALL_STATE(9057)] = 272253,
  [SMALL_STATE(9058)] = 272260,
  [SMALL_STATE(9059)] = 272267,
  [SMALL_STATE(9060)] = 272274,
  [SMALL_STATE(9061)] = 272281,
  [SMALL_STATE(9062)] = 272288,
  [SMALL_STATE(9063)] = 272295,
  [SMALL_STATE(9064)] = 272302,
  [SMALL_STATE(9065)] = 272309,
  [SMALL_STATE(9066)] = 272316,
  [SMALL_STATE(9067)] = 272323,
  [SMALL_STATE(9068)] = 272330,
  [SMALL_STATE(9069)] = 272337,
  [SMALL_STATE(9070)] = 272344,
  [SMALL_STATE(9071)] = 272351,
  [SMALL_STATE(9072)] = 272358,
  [SMALL_STATE(9073)] = 272365,
  [SMALL_STATE(9074)] = 272372,
  [SMALL_STATE(9075)] = 272379,
  [SMALL_STATE(9076)] = 272386,
  [SMALL_STATE(9077)] = 272393,
  [SMALL_STATE(9078)] = 272400,
  [SMALL_STATE(9079)] = 272407,
  [SMALL_STATE(9080)] = 272414,
  [SMALL_STATE(9081)] = 272421,
  [SMALL_STATE(9082)] = 272428,
  [SMALL_STATE(9083)] = 272435,
  [SMALL_STATE(9084)] = 272442,
  [SMALL_STATE(9085)] = 272449,
  [SMALL_STATE(9086)] = 272456,
  [SMALL_STATE(9087)] = 272463,
  [SMALL_STATE(9088)] = 272470,
  [SMALL_STATE(9089)] = 272477,
  [SMALL_STATE(9090)] = 272484,
  [SMALL_STATE(9091)] = 272491,
  [SMALL_STATE(9092)] = 272498,
  [SMALL_STATE(9093)] = 272505,
  [SMALL_STATE(9094)] = 272512,
  [SMALL_STATE(9095)] = 272519,
  [SMALL_STATE(9096)] = 272526,
  [SMALL_STATE(9097)] = 272533,
  [SMALL_STATE(9098)] = 272540,
  [SMALL_STATE(9099)] = 272547,
  [SMALL_STATE(9100)] = 272554,
  [SMALL_STATE(9101)] = 272561,
  [SMALL_STATE(9102)] = 272568,
  [SMALL_STATE(9103)] = 272575,
  [SMALL_STATE(9104)] = 272582,
  [SMALL_STATE(9105)] = 272589,
  [SMALL_STATE(9106)] = 272596,
  [SMALL_STATE(9107)] = 272603,
  [SMALL_STATE(9108)] = 272610,
  [SMALL_STATE(9109)] = 272617,
  [SMALL_STATE(9110)] = 272624,
  [SMALL_STATE(9111)] = 272631,
  [SMALL_STATE(9112)] = 272638,
  [SMALL_STATE(9113)] = 272645,
  [SMALL_STATE(9114)] = 272652,
  [SMALL_STATE(9115)] = 272659,
  [SMALL_STATE(9116)] = 272666,
  [SMALL_STATE(9117)] = 272673,
  [SMALL_STATE(9118)] = 272680,
  [SMALL_STATE(9119)] = 272687,
  [SMALL_STATE(9120)] = 272694,
  [SMALL_STATE(9121)] = 272701,
  [SMALL_STATE(9122)] = 272708,
  [SMALL_STATE(9123)] = 272715,
  [SMALL_STATE(9124)] = 272722,
  [SMALL_STATE(9125)] = 272729,
  [SMALL_STATE(9126)] = 272736,
  [SMALL_STATE(9127)] = 272743,
  [SMALL_STATE(9128)] = 272750,
  [SMALL_STATE(9129)] = 272757,
  [SMALL_STATE(9130)] = 272764,
  [SMALL_STATE(9131)] = 272771,
  [SMALL_STATE(9132)] = 272778,
  [SMALL_STATE(9133)] = 272785,
  [SMALL_STATE(9134)] = 272792,
  [SMALL_STATE(9135)] = 272799,
  [SMALL_STATE(9136)] = 272806,
  [SMALL_STATE(9137)] = 272813,
  [SMALL_STATE(9138)] = 272820,
  [SMALL_STATE(9139)] = 272827,
  [SMALL_STATE(9140)] = 272834,
  [SMALL_STATE(9141)] = 272841,
  [SMALL_STATE(9142)] = 272848,
  [SMALL_STATE(9143)] = 272855,
  [SMALL_STATE(9144)] = 272862,
  [SMALL_STATE(9145)] = 272869,
  [SMALL_STATE(9146)] = 272876,
  [SMALL_STATE(9147)] = 272883,
  [SMALL_STATE(9148)] = 272890,
  [SMALL_STATE(9149)] = 272897,
  [SMALL_STATE(9150)] = 272904,
  [SMALL_STATE(9151)] = 272911,
  [SMALL_STATE(9152)] = 272918,
  [SMALL_STATE(9153)] = 272925,
  [SMALL_STATE(9154)] = 272932,
  [SMALL_STATE(9155)] = 272939,
  [SMALL_STATE(9156)] = 272946,
  [SMALL_STATE(9157)] = 272953,
  [SMALL_STATE(9158)] = 272960,
  [SMALL_STATE(9159)] = 272967,
  [SMALL_STATE(9160)] = 272974,
  [SMALL_STATE(9161)] = 272981,
  [SMALL_STATE(9162)] = 272988,
  [SMALL_STATE(9163)] = 272995,
  [SMALL_STATE(9164)] = 273002,
  [SMALL_STATE(9165)] = 273009,
  [SMALL_STATE(9166)] = 273016,
  [SMALL_STATE(9167)] = 273023,
  [SMALL_STATE(9168)] = 273030,
  [SMALL_STATE(9169)] = 273037,
  [SMALL_STATE(9170)] = 273044,
  [SMALL_STATE(9171)] = 273051,
  [SMALL_STATE(9172)] = 273058,
  [SMALL_STATE(9173)] = 273065,
  [SMALL_STATE(9174)] = 273072,
  [SMALL_STATE(9175)] = 273079,
  [SMALL_STATE(9176)] = 273086,
  [SMALL_STATE(9177)] = 273093,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9059),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5876),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9011),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8063),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8552),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6596),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8332),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7963),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2272),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8921),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6381),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7809),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7881),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8447),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8130),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9063),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8345),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8606),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8629),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8904),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9000),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6969),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7807),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7356),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8995),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5463),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7304),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6710),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8068),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8865),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8452),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5305),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5646),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6795),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9074),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9079),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7826),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4052),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6604),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7562),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8444),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7844),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8627),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8651),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8911),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9146),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8163),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8853),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8053),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6801),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8988),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8989),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8771),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6006),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8822),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5942),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8823),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8896),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7828),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7676),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7949),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8242),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8987),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8986),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8917),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7959),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8373),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7951),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9076),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9077),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8384),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 81),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 81),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1116),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6811),
  [397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8822),
  [400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5942),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8823),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7828),
  [411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(183),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1526),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1040),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5571),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1229),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(235),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(232),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3992),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2477),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2338),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6655),
  [453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6740),
  [456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7607),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7963),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2522),
  [468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2272),
  [474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1279),
  [477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2470),
  [480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2453),
  [483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2300),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6381),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5409),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5410),
  [501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5345),
  [504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7676),
  [507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1777),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8724),
  [516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8242),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(916),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8987),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1311),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8986),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8917),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7959),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8373),
  [543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1809),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8842),
  [552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8904),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9000),
  [558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6969),
  [561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4467),
  [564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7807),
  [567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4117),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4072),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2816),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5463),
  [588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1212),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7951),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1416),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6772),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9076),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9077),
  [612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1421),
  [615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1770),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5305),
  [627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5646),
  [630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8384),
  [633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6063),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1112),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6782),
  [653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8397),
  [656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5944),
  [659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8304),
  [662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8082),
  [665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(210),
  [671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4013),
  [674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6607),
  [680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2457),
  [686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7988),
  [692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1785),
  [695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8579),
  [698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(929),
  [704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9075),
  [707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1304),
  [710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8731),
  [713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8735),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8314),
  [719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7998),
  [722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8412),
  [725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1210),
  [728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7991),
  [731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1446),
  [734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6821),
  [737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9100),
  [740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9091),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1447),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1778),
  [749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8421),
  [752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5995),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6782),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8397),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5944),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8304),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8082),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4013),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7988),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8579),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9075),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8731),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8735),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8314),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7998),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8412),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7991),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6821),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9100),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9091),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8421),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1060),
  [842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6795),
  [845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9074),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5855),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9079),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7826),
  [857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(469),
  [860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(263),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4052),
  [866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2337),
  [869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6604),
  [872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2451),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7562),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8230),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1744),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8444),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7844),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(885),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8627),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1308),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8651),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8911),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(9146),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8163),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8853),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1211),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8053),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1453),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6801),
  [931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8988),
  [934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8989),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1461),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1745),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8771),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6006),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7830),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8540),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8135),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6673),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8555),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1119),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6829),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9059),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5876),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9011),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8063),
  [1063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(183),
  [1066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [1069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1526),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [1075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1040),
  [1078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5571),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1229),
  [1084] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(829),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(234),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4020),
  [1093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2477),
  [1096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2340),
  [1099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6596),
  [1105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6740),
  [1108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7607),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7963),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2522),
  [1120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [1123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2272),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1279),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2470),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2444),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2300),
  [1144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6381),
  [1147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5409),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5410),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5345),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7809),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7881),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1701),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8447),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8130),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9063),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1301),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8345),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8606),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8629),
  [1189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1809),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8842),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8904),
  [1201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(9000),
  [1204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6969),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5113),
  [1210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7807),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5129),
  [1219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4072),
  [1222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [1225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [1228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2816),
  [1231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5463),
  [1234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [1237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7304),
  [1240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6710),
  [1243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1209),
  [1246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [1249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8068),
  [1252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [1255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1508),
  [1258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6827),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8865),
  [1264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8452),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1406),
  [1270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1702),
  [1273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [1276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [1279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5305),
  [1282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5646),
  [1285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7824),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1132),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [1332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [1335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [1338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1556),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1556),
  [1346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(235),
  [1349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(572),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3992),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2043),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2470),
  [1361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6740),
  [1367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7399),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [1373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(50),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2272),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1276),
  [1382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [1385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2300),
  [1391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6381),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5409),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5410),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5345),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7676),
  [1406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8242),
  [1412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(916),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8987),
  [1418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1311),
  [1421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8986),
  [1424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9007),
  [1427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8917),
  [1430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7959),
  [1433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8373),
  [1436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1809),
  [1439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [1442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8842),
  [1445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8904),
  [1448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9000),
  [1451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6969),
  [1454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4467),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7807),
  [1460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [1463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4117),
  [1466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4072),
  [1469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [1472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [1475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5463),
  [1478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7824),
  [1481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7951),
  [1484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [1487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1416),
  [1490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1421),
  [1493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1770),
  [1496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [1499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [1502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5305),
  [1505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5646),
  [1508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8384),
  [1511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [1514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6063),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [1521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [1524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [1530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4020),
  [1533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(78),
  [1536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7809),
  [1539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7881),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8130),
  [1545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(884),
  [1548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9063),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1301),
  [1554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8345),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8606),
  [1560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8629),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7830),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8540),
  [1569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8068),
  [1572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1508),
  [1575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1406),
  [1578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1702),
  [1581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8555),
  [1584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6025),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1125),
  [1598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [1601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4013),
  [1607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(60),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7402),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7988),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(929),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9075),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1304),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8731),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8735),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8314),
  [1637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7998),
  [1640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8412),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7991),
  [1646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1446),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1447),
  [1652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1778),
  [1655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8421),
  [1658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5995),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1123),
  [1664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(469),
  [1667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(571),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4052),
  [1673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [1676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7562),
  [1679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8230),
  [1682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7844),
  [1685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(885),
  [1688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8627),
  [1691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1308),
  [1694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8651),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8911),
  [1700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9146),
  [1703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8163),
  [1706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8853),
  [1709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8053),
  [1712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1453),
  [1715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1461),
  [1718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1745),
  [1721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8771),
  [1724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6006),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1131),
  [1732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1065),
  [1735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(460),
  [1738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4006),
  [1741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [1744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7681),
  [1747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8024),
  [1750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7990),
  [1753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(887),
  [1756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(9089),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1323),
  [1762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8581),
  [1765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8584),
  [1768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8403),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8029),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8689),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8050),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1484),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1488),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1786),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8691),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6002),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7681),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8024),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7990),
  [1811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9089),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8581),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8584),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8403),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8029),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8050),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8691),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7476),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8642),
  [1847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7838),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8833),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8102),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6026),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9008),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8585),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9032),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5369),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8893),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9150),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9175),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4125),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4123),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5503),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8232),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5639),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7627),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 10),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 47),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 33),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7971),
  [2027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7971),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [2040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6760),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5352),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5356),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5358),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8630),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9141),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9172),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6944),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [2096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3804),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8632),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5522),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8192),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5640),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8143),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8143),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 106),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 106),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 169),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 169),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 181),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 181),
  [2155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 97),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 97),
  [2159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 119),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 119),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 136),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 136),
  [2167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 88),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 88),
  [2171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2634),
  [2178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(956),
  [2181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1523),
  [2184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1556),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1556),
  [2192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1557),
  [2195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4015),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6740),
  [2202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5937),
  [2205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7147),
  [2208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9061),
  [2211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7824),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 96),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 96),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 4, 0, 142),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 4, 0, 142),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 154),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 154),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 155),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 155),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 159),
  [2236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 159),
  [2238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 160),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 160),
  [2242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 175),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 175),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 136),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 136),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 188),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 188),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 189),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 189),
  [2258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 190),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 190),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 5, 0, 191),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 5, 0, 191),
  [2266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 6, 0, 209),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 6, 0, 209),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 210),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 210),
  [2274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 211),
  [2276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 211),
  [2278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 6, 0, 214),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 6, 0, 214),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [2336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_discard_statement, 2, 0, 0),
  [2338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [2340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 2, 0, 9),
  [2342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 54),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 68),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 68),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 88),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 88),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 46),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cbuffer_specifier, 3, 0, 48),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 107),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 107),
  [2402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 225),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 225),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8007),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8007),
  [2425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [2441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 144),
  [2445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 145),
  [2447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 145),
  [2449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 126),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 126),
  [2453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 121),
  [2455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 121),
  [2457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7855),
  [2459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7855),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 117),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 129),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 129),
  [2474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [2477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [2480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 170),
  [2484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 171),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 171),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 172),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 172),
  [2492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 130),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 130),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [2520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [2524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 177),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 177),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [2530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 36),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 37),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [2556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 182),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 182),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 5, 0, 0),
  [2564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 183),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 183),
  [2568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [2572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [2574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 59),
  [2576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 184),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 184),
  [2580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [2584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [2586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 62),
  [2588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 131),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 131),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 186),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 186),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 81),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 81),
  [2604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 69),
  [2606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 69),
  [2608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 132),
  [2610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 132),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 71),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 71),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 78),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 78),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 78),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 78),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 79),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 79),
  [2636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 80),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 80),
  [2640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 81),
  [2642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 81),
  [2644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 82),
  [2646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 82),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [2656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 137),
  [2658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 137),
  [2660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [2664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 96),
  [2672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 97),
  [2674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 97),
  [2676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 212),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 212),
  [2680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 60),
  [2684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 59),
  [2688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [2692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [2696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [2698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8462),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5871),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 81),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8488),
  [2706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5969),
  [2710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8523),
  [2712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7825),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5571),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6617),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8712),
  [2734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6387),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5340),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5497),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8692),
  [2750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7132),
  [2752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [2754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 81),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [2776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2010),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2634),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(1557),
  [2814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6740),
  [2817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7147),
  [2820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(9061),
  [2823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7824),
  [2826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2634),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(1557),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6740),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7147),
  [2844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(9061),
  [2847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7824),
  [2850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2634),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [2855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(1557),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6740),
  [2861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7147),
  [2864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(9061),
  [2867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7824),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4011),
  [2874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2591),
  [2877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8462),
  [2880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5871),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [2885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8488),
  [2888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7825),
  [2891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4988),
  [2894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8508),
  [2897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3258),
  [2900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5571),
  [2903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5571),
  [2906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(613),
  [2909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2455),
  [2912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4018),
  [2915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2477),
  [2918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2470),
  [2921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [2924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6617),
  [2927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5712),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7678),
  [2933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [2936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7963),
  [2939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2272),
  [2942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8712),
  [2945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [2948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2459),
  [2951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [2954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [2957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6387),
  [2960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5339),
  [2963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5340),
  [2966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5341),
  [2969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2373),
  [2972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8995),
  [2975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2816),
  [2978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5497),
  [2981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8692),
  [2984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7132),
  [2987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [2990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1297),
  [2993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9108),
  [2996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2666),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1535),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6730),
  [3008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7302),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 6, 0, 165),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 6, 0, 165),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 4, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 47),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 110),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [3029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 47),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 111),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 111),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [3037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_private_module_fragment_declaration, 4, 0, 0),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 10),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, 0, 112),
  [3045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, 0, 112),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 56),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [3053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 10),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, 0, 57),
  [3059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 3, 0, 0),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, 0, 10),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [3079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 56),
  [3081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [3083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 10),
  [3085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [3087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, 0, 57),
  [3089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [3091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 47),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 165),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 165),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 110),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 47),
  [3105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, 0, 111),
  [3107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, 0, 111),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, 0, 112),
  [3111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, 0, 112),
  [3113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [3115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_declaration, 2, 0, 0),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_module_fragment_declaration, 2, 0, 0),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8303),
  [3127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5934),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8800),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7847),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6703),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2439),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7285),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9090),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8521),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5943),
  [3173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9111),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7912),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2443),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6628),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [3237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8521),
  [3240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5943),
  [3243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9111),
  [3246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7912),
  [3249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(863),
  [3252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2443),
  [3255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3969),
  [3258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6628),
  [3261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2461),
  [3264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7223),
  [3267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1287),
  [3270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9115),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8303),
  [3286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5934),
  [3289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8800),
  [3292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7847),
  [3295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(868),
  [3298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2438),
  [3301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3998),
  [3304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6703),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2439),
  [3312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7285),
  [3315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1294),
  [3318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9090),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [3333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [3343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2663),
  [3346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(956),
  [3349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1523),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1523),
  [3355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1556),
  [3358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(235),
  [3361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1557),
  [3364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [3366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6740),
  [3369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7399),
  [3372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(50),
  [3375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1276),
  [3378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7147),
  [3381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7676),
  [3384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7949),
  [3387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1777),
  [3390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8724),
  [3393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8242),
  [3396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(916),
  [3399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8987),
  [3402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1311),
  [3405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8986),
  [3408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9007),
  [3411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8917),
  [3414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7959),
  [3417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8373),
  [3420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1809),
  [3423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1514),
  [3426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8842),
  [3429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8904),
  [3432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9000),
  [3435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6969),
  [3438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4467),
  [3441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7807),
  [3444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7356),
  [3447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4117),
  [3450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4072),
  [3453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9061),
  [3456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7824),
  [3459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7951),
  [3462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1700),
  [3465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1416),
  [3468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1421),
  [3471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1770),
  [3474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7848),
  [3477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1703),
  [3480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5305),
  [3483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5646),
  [3486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8384),
  [3489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6063),
  [3492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2659),
  [3495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(469),
  [3498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(37),
  [3501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7562),
  [3504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8230),
  [3507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1744),
  [3510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8444),
  [3513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7844),
  [3516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(885),
  [3519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8627),
  [3522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1308),
  [3525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8651),
  [3528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8911),
  [3531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9146),
  [3534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8163),
  [3537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8853),
  [3540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8053),
  [3543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1453),
  [3546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1461),
  [3549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1745),
  [3552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8771),
  [3555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6006),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2659),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6608),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7147),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [3568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2694),
  [3571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(304),
  [3574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(78),
  [3577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7809),
  [3580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7881),
  [3583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1701),
  [3586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8447),
  [3589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8130),
  [3592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(884),
  [3595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9063),
  [3598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1301),
  [3601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8345),
  [3604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8606),
  [3607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8629),
  [3610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7830),
  [3613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8540),
  [3616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8068),
  [3619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1508),
  [3622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1406),
  [3625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1702),
  [3628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8555),
  [3631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6025),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2690),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6599),
  [3646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2690),
  [3649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(534),
  [3652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(60),
  [3655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7402),
  [3658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7988),
  [3661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1785),
  [3664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8579),
  [3667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7950),
  [3670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(929),
  [3673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9075),
  [3676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1304),
  [3679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8731),
  [3682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8735),
  [3685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8314),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7998),
  [3691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8412),
  [3694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7991),
  [3697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1446),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1447),
  [3703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1778),
  [3706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8421),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5995),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [3714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2696),
  [3717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7476),
  [3720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1769),
  [3723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8642),
  [3726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7838),
  [3729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8833),
  [3732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8102),
  [3735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6026),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2662),
  [3743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1065),
  [3746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(65),
  [3749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7681),
  [3752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8024),
  [3755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7990),
  [3758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(887),
  [3761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(9089),
  [3764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1323),
  [3767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8581),
  [3770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8584),
  [3773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8403),
  [3776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8029),
  [3779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8689),
  [3782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8050),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1484),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1488),
  [3791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1786),
  [3794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8691),
  [3797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6002),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [3802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [3804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [3808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7203),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8834),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9144),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9173),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6955),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7176),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5268),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5642),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6300),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6403),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6230),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [3888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8223),
  [3904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5269),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2258),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5937),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [3932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9121),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1555),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9116),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5678),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2658),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7233),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9112),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7206),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9095),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2458),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7167),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9118),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8674),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7284),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9104),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9101),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9083),
  [3992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1843),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7240),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8914),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9153),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [4044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5260),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5645),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [4060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [4070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1535),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7302),
  [4082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8059),
  [4085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8059),
  [4087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [4093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1696),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [4101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4430),
  [4103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5249),
  [4105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6412),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5334),
  [4109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [4111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [4117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8869),
  [4119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9147),
  [4121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9174),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6959),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5091),
  [4133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [4135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8895),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5511),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [4147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5643),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [4179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [4197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [4211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8626),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [4215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [4219] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [4227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1034),
  [4236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [4238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [4243] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7352),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8225),
  [4255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [4267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [4271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [4289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [4291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [4295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [4301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [4307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1661),
  [4311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5644),
  [4315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1023),
  [4318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7494),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2797),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [4360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [4372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7309),
  [4396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [4404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2658),
  [4407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1758),
  [4410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6760),
  [4413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7233),
  [4416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2706),
  [4419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1640),
  [4422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6736),
  [4425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7309),
  [4428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [4430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33),
  [4435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [4438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1033),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [4458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [4463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [4471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [4473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [4481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [4485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2572),
  [4487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8892),
  [4489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [4493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [4499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [4505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [4521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [4529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6158),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [4539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [4557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [4585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [4601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(955),
  [4604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1616),
  [4607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1574),
  [4610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1574),
  [4613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5937),
  [4616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2469),
  [4619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(953),
  [4622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1657),
  [4625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1575),
  [4628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6751),
  [4631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [4637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1035),
  [4640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2797),
  [4643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(972),
  [4646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1804),
  [4649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1804),
  [4652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1746),
  [4655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6738),
  [4658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1805),
  [4661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1473),
  [4664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8842),
  [4667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8904),
  [4670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(9000),
  [4673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6969),
  [4676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4467),
  [4679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7807),
  [4682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7356),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4117),
  [4688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4072),
  [4691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1807),
  [4694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7848),
  [4697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1808),
  [4700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5321),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5646),
  [4706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [4718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [4722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [4726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [4728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [4734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8758),
  [4742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8378),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8951),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [4772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2634),
  [4775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(956),
  [4778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [4781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1523),
  [4784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1556),
  [4787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3127),
  [4790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1557),
  [4793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6740),
  [4796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1579),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [4801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5937),
  [4804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7147),
  [4807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1809),
  [4810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [4813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8842),
  [4816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8904),
  [4819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9000),
  [4822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6969),
  [4825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4467),
  [4828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7807),
  [4831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7356),
  [4834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4117),
  [4837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4072),
  [4840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(9061),
  [4843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6753),
  [4846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7824),
  [4849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1700),
  [4852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7848),
  [4855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1703),
  [4858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5305),
  [4861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5646),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [4866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [4868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [4872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [4874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [4878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [4880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [4886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2763),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5040),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [4908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [4914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [4918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [4920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5401),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5427),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5428),
  [4930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5377),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5378),
  [4934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [4936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [4938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [4940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5376),
  [4942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [4944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [4946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [4948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5418),
  [4952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5406),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [4958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5408),
  [4960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5429),
  [4962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5430),
  [4964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [4966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [4968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5384),
  [4970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [4972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5455),
  [4974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [4976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5332),
  [4978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [4980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5415),
  [4982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5416),
  [4984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [4986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5412),
  [4988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [4990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [4992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [4994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [4996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5397),
  [4998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5398),
  [5000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [5024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [5026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [5028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [5031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [5038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8325),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [5046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8328),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [5050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9051),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8273),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [5062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8279),
  [5064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9088),
  [5067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8792),
  [5070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8770),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [5075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8567),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [5080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8804),
  [5083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8509),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7567),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8720),
  [5090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8860),
  [5093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9038),
  [5096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8789),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7685),
  [5101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9003),
  [5103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9137),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7498),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9081),
  [5112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9043),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7473),
  [5117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8661),
  [5119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 201),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1655),
  [5129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9085),
  [5132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 108),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [5136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 158),
  [5138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 108),
  [5142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [5144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5145),
  [5146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5238),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7273),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [5152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [5166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [5170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 81),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [5188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8990),
  [5191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8685),
  [5194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8354),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [5199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8517),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8725),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8312),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [5217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8766),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [5224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8443),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [5231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9031),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [5238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8429),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [5244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(9167),
  [5247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8394),
  [5250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8401),
  [5253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8554),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8919),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8348),
  [5267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [5269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8465),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [5274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8505),
  [5277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8472),
  [5279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8402),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [5290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8337),
  [5293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9110),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8841),
  [5301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8290),
  [5307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8449),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [5312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8430),
  [5315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8572),
  [5318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8415),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [5322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8550),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [5326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8687),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [5350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8371),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [5359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8696),
  [5362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8709),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [5377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8511),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9010),
  [5384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5951),
  [5412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7741),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8079),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [5452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8079),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [5459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [5481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 67),
  [5483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 55),
  [5487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [5489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 74),
  [5491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 75),
  [5493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 75),
  [5495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 127),
  [5501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 127),
  [5503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 128),
  [5505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 128),
  [5507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 180),
  [5509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 180),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [5513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [5517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [5519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8623),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7625),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8625),
  [5529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [5531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [5533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [5535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 194),
  [5541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 194),
  [5543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 184),
  [5545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 184),
  [5547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 207),
  [5551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 227),
  [5553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 227),
  [5555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 217),
  [5557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 217),
  [5559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 218),
  [5561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 218),
  [5563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 227),
  [5565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 227),
  [5567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [5569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 207),
  [5571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [5573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 68),
  [5575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 217),
  [5577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 217),
  [5579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 132),
  [5581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 132),
  [5583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [5589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 58),
  [5591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [5593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 68),
  [5595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [5597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 69),
  [5599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [5601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 68),
  [5603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 81),
  [5605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 81),
  [5607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 82),
  [5609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 82),
  [5611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [5617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 68),
  [5619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [5621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 58),
  [5623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 193),
  [5625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 193),
  [5627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 194),
  [5629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 194),
  [5631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 218),
  [5633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 218),
  [5635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 131),
  [5637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 131),
  [5639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 81),
  [5641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 81),
  [5643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [5645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 193),
  [5647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8090),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8090),
  [5652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8038),
  [5654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8038),
  [5661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [5663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1035),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7290),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [5674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [5678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [5682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1024),
  [5691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2292),
  [5694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8949),
  [5697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [5699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [5703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [5705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8915),
  [5707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [5711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [5713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1018),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7308),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [5726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2307),
  [5729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [5733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1369),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [5738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8921),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [5743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2274),
  [5750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2304),
  [5753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [5755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [5757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(1369),
  [5760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8921),
  [5765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [5767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [5769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5699),
  [5777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5702),
  [5779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [5781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 55),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [5785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1029),
  [5788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [5791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 101),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 101),
  [5795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [5797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [5801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [5803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [5805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [5807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [5809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2431),
  [5812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2296),
  [5815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2428),
  [5818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8623),
  [5821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7625),
  [5824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8625),
  [5827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8832),
  [5830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2429),
  [5833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2800),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8949),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [5848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [5850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2762),
  [5853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [5855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [5857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1300),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [5866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [5872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [5878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [5880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [5884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 77),
  [5886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 77),
  [5888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [5890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2313),
  [5896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [5898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 35),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [5902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [5904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 100),
  [5906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 77),
  [5908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, -1, 77),
  [5910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2313),
  [5913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [5927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 35),
  [5929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [5935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [5945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [5947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [5949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [5951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [5953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [5955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [5957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8933),
  [5959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [5961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [5963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [5971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [5973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [5975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [5977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [5979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [5981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [5983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [6001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [6003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [6005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [6007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8969),
  [6009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [6011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 104),
  [6013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 104),
  [6015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [6017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [6019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 99),
  [6021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 99),
  [6023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [6029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [6031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [6033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [6035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [6037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [6039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [6041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [6043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [6045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [6047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [6049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [6051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [6061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [6063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [6065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 102),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 102),
  [6069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 99),
  [6071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 99),
  [6073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [6075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 151),
  [6077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 151),
  [6079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 150),
  [6081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 150),
  [6083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [6085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [6087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [6089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [6091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [6095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [6097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [6099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [6105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [6107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [6109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [6111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [6113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [6115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2433),
  [6118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8933),
  [6121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [6123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [6125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [6127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [6129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 149),
  [6131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 149),
  [6133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [6135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [6137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [6139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [6141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 105),
  [6143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 105),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [6149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2446),
  [6152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8969),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [6179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 149),
  [6181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 149),
  [6183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [6185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [6187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [6189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [6191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 150),
  [6193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 150),
  [6195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [6197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [6199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3153),
  [6201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [6203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8965),
  [6207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [6209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [6211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [6213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [6215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [6217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [6219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [6221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [6223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 102),
  [6225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 102),
  [6227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 105),
  [6229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 105),
  [6231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [6233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [6235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [6237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [6239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [6243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2421),
  [6246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [6249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2489),
  [6252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8965),
  [6255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2424),
  [6258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1307),
  [6261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [6263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifiers, 1, 0, 0),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [6267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2486),
  [6270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8868),
  [6273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [6275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hlsl_attribute, 3, 0, 0),
  [6277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [6279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [6281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 153),
  [6283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 153),
  [6285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [6287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [6293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6235),
  [6299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [6301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [6303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 113),
  [6309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [6311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6803),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4019),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [6325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [6329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [6331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1369),
  [6334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2463),
  [6337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2470),
  [6340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [6343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7678),
  [6346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8332),
  [6349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8921),
  [6352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [6355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2464),
  [6358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1030),
  [6361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [6365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2431),
  [6368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2472),
  [6371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2428),
  [6374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8623),
  [6377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7625),
  [6380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8625),
  [6383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8832),
  [6386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2816),
  [6389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(2429),
  [6392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [6396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [6403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [6408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [6410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [6412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2483),
  [6415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2498),
  [6417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [6419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [6421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2487),
  [6423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [6425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [6427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [6429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2498),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [6434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [6436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7176),
  [6439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8229),
  [6442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [6444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [6446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2572),
  [6449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(2511),
  [6452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8892),
  [6455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [6461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [6463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 226),
  [6465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 226),
  [6467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1024),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [6472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8912),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [6478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9125),
  [6480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6184),
  [6482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [6488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [6490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [6496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3755),
  [6499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [6501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3754),
  [6507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3762),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [6512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [6514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1022),
  [6517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [6523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [6525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [6527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [6529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2622),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [6533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1032),
  [6536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [6538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [6540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [6542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1030),
  [6545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 93),
  [6547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 93),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [6553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [6555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [6557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [6559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [6561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [6563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2558),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [6567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 65),
  [6569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 65),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [6575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 33), SHIFT(1030),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [6584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4419),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [6600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [6604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [6606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [6610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2630),
  [6613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7145),
  [6616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8241),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [6625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [6627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [6629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2636),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [6634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8867),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6256),
  [6640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [6642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [6645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [6648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2649),
  [6650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1033),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [6663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2651),
  [6666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7290),
  [6669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8227),
  [6672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 176),
  [6674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 176),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [6680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [6684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(7889),
  [6691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(8422),
  [6694] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6517),
  [6698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [6702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1017),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 87),
  [6709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 87),
  [6711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [6713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2850),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8958),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [6729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [6731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [6735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [6737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [6741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [6743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(6517),
  [6746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [6748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2654),
  [6755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8958),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [6760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [6766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2720),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [6777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(1032),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [6786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [6793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [6795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 178),
  [6797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 178),
  [6799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [6801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 64),
  [6803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 64),
  [6805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 140),
  [6807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 140),
  [6809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [6815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2754),
  [6818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7345),
  [6821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8237),
  [6824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 116),
  [6826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 116),
  [6828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 92),
  [6830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 92),
  [6832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [6834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [6836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2742),
  [6843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 89),
  [6849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 89),
  [6851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [6857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [6859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [6861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 122),
  [6871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 122),
  [6873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [6879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7411),
  [6884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8932),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 124),
  [6902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 124),
  [6904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 124), SHIFT(1030),
  [6907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [6911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [6913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [6915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [6917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72),
  [6919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 72),
  [6921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(1030),
  [6924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 173),
  [6926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 173),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [6934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 123),
  [6936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 123),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [6940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [6946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [6948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 33),
  [6950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [6976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8891),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8891),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [6986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [6992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [6998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 86),
  [7000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 86),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [7006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [7010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [7014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 173),
  [7016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 173),
  [7018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [7022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 55),
  [7026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [7030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2875),
  [7033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7333),
  [7036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8236),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [7041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76),
  [7043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 76),
  [7045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(1030),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [7050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [7052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6468),
  [7056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 138),
  [7058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 138),
  [7060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [7062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [7064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [7066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [7068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 202),
  [7070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 202),
  [7072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 204),
  [7074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 204),
  [7076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 205),
  [7078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 205),
  [7080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 139),
  [7082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 139),
  [7084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 161),
  [7086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 161),
  [7088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 163),
  [7092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 164),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 164),
  [7096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 86),
  [7098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 86),
  [7100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [7104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [7108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [7112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 91),
  [7114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 91),
  [7116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 223),
  [7118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 223),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [7122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 224),
  [7124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 224),
  [7126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [7130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [7134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [7138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 231),
  [7140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 231),
  [7142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 232),
  [7144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 232),
  [7146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [7150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 174),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 174),
  [7154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [7158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 235),
  [7160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 235),
  [7162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 73),
  [7164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 73),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8912),
  [7170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [7174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [7176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [7178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [7182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 109),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 109),
  [7186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [7188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [7190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [7192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [7194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 114),
  [7196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 114),
  [7198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [7202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 115),
  [7204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 115),
  [7206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [7210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 55),
  [7214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 187),
  [7216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 187),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [7220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5716),
  [7222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [7228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8957),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [7234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [7236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [7238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [7242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [7244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [7252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1024),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8424),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [7269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [7283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8948),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8948),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [7291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [7294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7352),
  [7297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8225),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [7304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1032),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [7311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [7317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1017),
  [7320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [7322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5667),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [7330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8831),
  [7333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8831),
  [7336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7368),
  [7339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8913),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [7347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [7351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6256),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9025),
  [7358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5694),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [7363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [7377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [7381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [7385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [7397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 66),
  [7399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 66),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [7403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [7407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [7409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [7417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [7423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [7427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [7431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [7433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [7445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [7449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 125),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [7453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 125),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [7457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 179),
  [7459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 179),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [7465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [7467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [7469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [7471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [7473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [7475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [7477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [7483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8831),
  [7485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [7487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [7489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [7491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [7495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [7499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1596),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [7507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [7509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [7511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [7513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [7515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [7531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5720),
  [7534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6259),
  [7537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5693),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [7546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [7548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6856),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5572),
  [7554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5572),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [7562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5587),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [7572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [7580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [7584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [7586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [7588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [7594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [7596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [7598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [7604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [7608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [7610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [7612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [7646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [7648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [7660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [7670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5534),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [7688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [7694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [7702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [7704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [7706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [7710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [7714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [7718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [7720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [7730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [7734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8728),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8552),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [7748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5724),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [7755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3913),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8451),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [7763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7452),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [7770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [7778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 134),
  [7780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 134),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [7786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [7794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3426),
  [7797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7292),
  [7800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8240),
  [7803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1812),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [7813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [7815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [7819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [7823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [7825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1813),
  [7827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1814),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [7835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7485),
  [7838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(1033),
  [7841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(1024),
  [7844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(1035),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [7849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5689),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [7858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5603),
  [7860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4252),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [7866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [7868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [7880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [7882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 124), SHIFT(1024),
  [7885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3748),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [7891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 4, 0, 143),
  [7893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(1024),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [7902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [7908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [7910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [7916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [7918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [7920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [7926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [7930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [7936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8515),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8602),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8644),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [7980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 124), SHIFT(1032),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [7985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [7987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 72), SHIFT(1032),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [7998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6274),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6274),
  [8002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [8004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [8010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [8012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [8014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [8018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [8020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [8026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [8046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [8050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [8052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [8058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [8060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [8062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [8066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [8070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1841),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [8074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [8076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [8084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [8088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3898),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [8092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7625),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [8097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5676),
  [8100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [8102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3708),
  [8105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7308),
  [8108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8235),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3708),
  [8113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1022),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [8118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 76), SHIFT(1032),
  [8121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4092),
  [8124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8913),
  [8127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3736),
  [8130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [8132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [8134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [8136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [8138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [8140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [8142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [8148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5671),
  [8150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5674),
  [8152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [8154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [8160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [8162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [8164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [8168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [8172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [8180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [8186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [8188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 2, 0, 0),
  [8190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 2, 0, 0),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [8195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [8205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5705),
  [8207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [8209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5130),
  [8211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [8213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [8215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5448),
  [8217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5449),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5450),
  [8221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [8225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 58),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [8229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [8231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8375),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [8239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5668),
  [8241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4583),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [8245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4233),
  [8247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [8249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [8253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [8255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [8257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [8259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8935),
  [8261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [8265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4624),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [8269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [8271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [8275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [8277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4512),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6359),
  [8281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5363),
  [8283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5364),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5365),
  [8287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5194),
  [8289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8959),
  [8291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [8297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [8301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [8309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [8315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6806),
  [8319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6430),
  [8321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [8323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5354),
  [8325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5355),
  [8327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [8329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5124),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4552),
  [8333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5236),
  [8335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6374),
  [8337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5451),
  [8339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5452),
  [8341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [8345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [8347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [8349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4244),
  [8352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4249),
  [8355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4252),
  [8358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4236),
  [8361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1029),
  [8364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [8372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6238),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [8384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4313),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8599),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [8392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5713),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5819),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [8414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5784),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [8420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [8422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4092),
  [8425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4349),
  [8427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8913),
  [8430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4477),
  [8432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [8440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5846),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [8450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [8452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [8454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4092),
  [8457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [8459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8913),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [8464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34), SHIFT(1018),
  [8467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [8469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [8471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [8473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [8477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5999),
  [8495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4236),
  [8497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [8499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [8507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6020),
  [8509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [8515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [8517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5997),
  [8519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6497),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6031),
  [8529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [8537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6053),
  [8539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [8541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3583),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [8549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6037),
  [8551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4519),
  [8553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4462),
  [8556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4409),
  [8558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8972),
  [8561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4518),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [8567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6032),
  [8569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4531),
  [8571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4462),
  [8574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4532),
  [8576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8972),
  [8579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [8581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [8593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5993),
  [8595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3758),
  [8597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [8599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4478),
  [8606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8626),
  [8609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4462),
  [8612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8972),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [8619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6111),
  [8625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6111),
  [8627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4373),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [8634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6127),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [8640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [8642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1674),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1676),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [8668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6149),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [8674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [8678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [8680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [8682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [8692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6130),
  [8694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 148),
  [8696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 148),
  [8698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7031),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [8704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6154),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [8710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7625),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [8715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [8719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1626),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [8725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [8729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [8733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [8749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4442),
  [8752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2654),
  [8755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8958),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [8762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [8770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [8774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2654),
  [8777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [8779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8958),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [8784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2486),
  [8787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8868),
  [8790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2486),
  [8793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4598),
  [8795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8868),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [8800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5692),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [8810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6277),
  [8812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [8819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8552),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [8824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8831),
  [8827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8831),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [8836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5690),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [8840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1558),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [8844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [8850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [8854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [8858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [8878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6429),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [8884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 183),
  [8886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 183),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [8892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [8898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [8900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [8910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 199),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [8920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [8922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [8928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [8932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [8942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [8946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [8950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [8970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [8974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [8980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [8988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8915),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8964),
  [9026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8964),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [9036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [9038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8831),
  [9043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8831),
  [9046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7368),
  [9049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [9053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 84),
  [9055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [9057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [9059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [9061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [9063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [9065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 118),
  [9067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 196),
  [9069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [9071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [9073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [9089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [9101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [9103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [9105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [9107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [9109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [9111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [9113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6256),
  [9116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5694),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [9121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [9127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 146), SHIFT(1457),
  [9130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 146),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [9142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1457),
  [9145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [9147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [9149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [9151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [9153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [9155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [9157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [9159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [9161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [9163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [9165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [9167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [9175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [9177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [9179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [9185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [9189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [9193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [9209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 3, 0, 84),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [9213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 198),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8266),
  [9221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8762),
  [9235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5131),
  [9238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5131),
  [9241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5132),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [9246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [9248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 156),
  [9250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9021),
  [9254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 219),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8433),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [9262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 207),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [9272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 200),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [9278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 157),
  [9280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 147),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [9284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 5, 0, 192),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [9292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [9298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [9304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 168),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [9308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 4, 0, 208),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [9322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [9324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [9326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [9328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [9330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [9332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 197),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [9336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [9350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 55),
  [9352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 85),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [9356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [9358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [9360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [9362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [9364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [9366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [9368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [9370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [9372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [9374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [9376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [9378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [9380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [9382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [9413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [9415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [9425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [9427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [9429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [9433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [9435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [9441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [9445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [9449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [9459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [9461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [9493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [9501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [9503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [9509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 220),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7688),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7707),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [9519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 55),
  [9521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [9525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [9531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6259),
  [9534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5693),
  [9537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8831),
  [9542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8831),
  [9545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7368),
  [9548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 1, 0, 0),
  [9552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 1, 0, 0),
  [9555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5720),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [9560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6256),
  [9563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5694),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [9572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5259),
  [9575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5312),
  [9578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(5314),
  [9581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [9585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5275),
  [9588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5276),
  [9591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(5274),
  [9594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [9598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [9602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5724),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [9607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [9617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [9623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [9625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [9627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5689),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [9638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5720),
  [9641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6259),
  [9644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5693),
  [9647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(1325),
  [9650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [9652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(2274),
  [9655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 77), SHIFT(2274),
  [9658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 35), SHIFT(5273),
  [9661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [9667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3130),
  [9669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [9671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5359),
  [9673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [9675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5361),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [9679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8950),
  [9681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5527),
  [9683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [9687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [9689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [9691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6390),
  [9693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5458),
  [9695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [9697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [9699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8836),
  [9703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [9709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [9711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [9713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [9715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5366),
  [9717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5367),
  [9719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5368),
  [9721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [9723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8966),
  [9725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [9727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [9731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6420),
  [9735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5343),
  [9739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5344),
  [9741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [9743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [9751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [9753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [9755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [9757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [9759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [9761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5447),
  [9763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [9765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8871),
  [9767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5501),
  [9769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2668),
  [9771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [9773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [9775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6356),
  [9777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5512),
  [9779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(2274),
  [9782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 35), SHIFT(2274),
  [9785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(5256),
  [9788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 77), SHIFT(5257),
  [9791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(2274),
  [9794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5580),
  [9796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(2274),
  [9799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [9805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [9807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [9811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5349),
  [9815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [9817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8916),
  [9823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [9825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3605),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [9829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [9831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [9833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5333),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5337),
  [9837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [9839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5466),
  [9841] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(2274),
  [9845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(5271),
  [9848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(2274),
  [9851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7625),
  [9854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5676),
  [9857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5724),
  [9860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [9862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [9864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [9866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [9868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [9870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [9872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4413),
  [9874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3099),
  [9876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4451),
  [9878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [9880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [9882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8831),
  [9887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8831),
  [9890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7368),
  [9893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6256),
  [9898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5694),
  [9901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5689),
  [9904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [9908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [9910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [9914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [9916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6368),
  [9918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [9920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5392),
  [9922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [9924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5483),
  [9926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 59),
  [9928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [9932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 0),
  [9934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 1, 0, 23),
  [9936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7625),
  [9943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5676),
  [9946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(5286),
  [9949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5720),
  [9956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6259),
  [9959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5693),
  [9962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5724),
  [9965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5689),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [9972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4108),
  [9974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7135),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [9980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [9982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7197),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [9990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [9992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [9994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7361),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [10000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7362),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [10010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7148),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [10016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [10018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7187),
  [10020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [10022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [10024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [10028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [10030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [10032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [10034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [10036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [10038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [10040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [10042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [10044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [10046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [10048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8071),
  [10050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7625),
  [10053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5676),
  [10056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [10058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [10060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [10068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7136),
  [10070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [10072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3792),
  [10074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5641),
  [10076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6713),
  [10078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [10084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7661),
  [10086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [10088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [10092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [10096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [10100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [10102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [10104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [10106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [10108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [10110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [10114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6256),
  [10117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5694),
  [10120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [10122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [10124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6349),
  [10126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [10128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [10130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6056),
  [10132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7224),
  [10134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [10136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5990),
  [10138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7354),
  [10140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [10142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [10144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [10146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4168),
  [10148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [10150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [10152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [10154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [10156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7108),
  [10158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5897),
  [10160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5899),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [10164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4169),
  [10168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [10170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7796),
  [10172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3853),
  [10174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [10176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [10178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7080),
  [10180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [10182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [10184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7718),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [10188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [10190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [10192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6080),
  [10194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6330),
  [10196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5647),
  [10198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [10202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [10204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6170),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6266),
  [10208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [10212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [10214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [10218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [10220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [10222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7818),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5803),
  [10226] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [10228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5723),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [10234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7928),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [10238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5883),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [10252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5844),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [10258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [10262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5957),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [10266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5917),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [10274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [10280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [10288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [10292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [10296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [10298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [10300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [10302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [10306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [10314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 55),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [10322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [10324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [10326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [10328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [10332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7527),
  [10334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [10340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [10342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7682),
  [10344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [10346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5765),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [10350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8036),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [10354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5903),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7715),
  [10360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [10362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [10368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [10372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [10374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [10378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7440),
  [10380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [10382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [10396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [10400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7471),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [10406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5968),
  [10408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [10410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [10412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [10414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [10416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8670),
  [10418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [10420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7605),
  [10422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [10424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [10426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [10428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [10430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [10432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [10438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6069),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [10450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [10452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6256),
  [10455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5694),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [10460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8368),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [10466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7749),
  [10468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [10472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [10484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [10488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7637),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [10492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [10498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [10500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [10506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [10508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9135),
  [10510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [10512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7415),
  [10514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [10516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [10524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [10530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [10532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7389),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [10536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [10540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7677),
  [10542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [10544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [10546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [10548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [10550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7771),
  [10552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [10554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [10556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7385),
  [10558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [10560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [10562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7663),
  [10564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [10566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [10568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [10570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [10576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [10580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [10594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [10598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7770),
  [10600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7603),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [10618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [10620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6838),
  [10622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5858),
  [10626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5894),
  [10628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5902),
  [10630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [10632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [10634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5920),
  [10636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5991),
  [10638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5938),
  [10640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5939),
  [10642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [10644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [10648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [10652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [10668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [10670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [10672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7566),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [10676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6204),
  [10678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7798),
  [10680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [10682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [10690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(6259),
  [10693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5693),
  [10696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(6259),
  [10699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5693),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [10710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6872),
  [10712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7630),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [10716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7368),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [10723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6774),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7071),
  [10731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7560),
  [10733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [10745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [10749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [10751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [10757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6377),
  [10759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7110),
  [10761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [10769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6424),
  [10771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [10775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(6256),
  [10778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(6259),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [10793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6396),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [10803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [10805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 38),
  [10807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [10809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 83),
  [10819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 83),
  [10821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [10823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 64),
  [10825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 135),
  [10831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 4, 0, 135),
  [10833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 87),
  [10835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 87),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [10839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [10841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [10843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [10845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [10847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [10849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [10851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8115),
  [10853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7680),
  [10855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5720),
  [10858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8623),
  [10863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8832),
  [10868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6155),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [10874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6157),
  [10876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6157),
  [10879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7265),
  [10882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(8233),
  [10885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4492),
  [10887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4819),
  [10889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [10891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [10893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [10895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [10901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2628),
  [10903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [10905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 39),
  [10907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [10909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [10915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [10921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 185),
  [10927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 185),
  [10929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 122),
  [10931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 122),
  [10933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [10939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [10941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 133),
  [10943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 133),
  [10945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [10955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [10957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4331),
  [10967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [10969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5724),
  [10972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4186),
  [10974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [10976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 178),
  [10978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 178),
  [10980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5689),
  [10983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [10991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5724),
  [10994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 68),
  [11000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [11004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [11006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [11008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4533),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [11012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [11014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [11016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [11018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [11020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [11022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [11024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [11026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [11028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [11030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8603),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2657),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2842),
  [11041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [11043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [11045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5720),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [11050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5689),
  [11053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7121),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [11063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 81),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [11067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [11071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7607),
  [11074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [11076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [11078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [11082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 87),
  [11084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 4, 1, 87),
  [11086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [11088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [11094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7053),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7130),
  [11102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [11104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [11106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [11108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [11110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 176),
  [11112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 5, 1, 176),
  [11114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [11116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [11128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [11140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [11142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6546),
  [11144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [11146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6588),
  [11148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 87),
  [11150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 4, 1, 87),
  [11152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6534),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [11168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [11170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24), SHIFT(8375),
  [11173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [11175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6590),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [11185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [11187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [11189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6532),
  [11191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 176),
  [11193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 5, 1, 176),
  [11195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [11197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [11201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [11203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6580),
  [11207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6591),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [11211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6557),
  [11213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6553),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [11223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7714),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6587),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [11239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [11241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [11245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6566),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [11249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [11251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6581),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [11255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6579),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [11259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6582),
  [11261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6535),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [11267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5865),
  [11269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8289),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [11273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [11275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [11277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [11281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [11283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [11289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [11295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 178),
  [11297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 178),
  [11299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [11301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [11303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [11305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [11307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 103),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [11311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 103),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [11319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [11321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 3, 1, 24),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [11325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 122),
  [11327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 122),
  [11329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_semantics, 2, 0, 0),
  [11331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_semantics, 2, 0, 0),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [11337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 23),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [11341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [11343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 59),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [11351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [11355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [11357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [11363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [11365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [11367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [11369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [11371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [11375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [11377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [11381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [11383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [11385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5676),
  [11388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [11390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [11392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [11394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [11396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [11398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [11400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 122),
  [11402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 122),
  [11404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [11406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [11408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 178),
  [11410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 178),
  [11412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [11414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [11416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6752),
  [11418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6919),
  [11420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6814),
  [11422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7163),
  [11424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [11426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7146),
  [11428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6804),
  [11430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7482),
  [11433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5921),
  [11436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8884),
  [11439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8063),
  [11442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6862),
  [11446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6825),
  [11448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [11450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6777),
  [11452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7262),
  [11454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6831),
  [11456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [11458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [11460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6845),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [11464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7144),
  [11466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7341),
  [11472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5965),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8985),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [11480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5980),
  [11482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9020),
  [11484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [11486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [11488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [11490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6805),
  [11492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 2, 0, 0),
  [11494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [11498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7175),
  [11504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [11506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [11508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6759),
  [11510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 81),
  [11512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 81),
  [11514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [11516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6785),
  [11518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 81),
  [11520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7097),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7043),
  [11530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6741),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [11534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7030),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [11540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [11542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6791),
  [11544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5676),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [11549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [11555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [11561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5318),
  [11563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [11565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5277),
  [11567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [11571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [11579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [11581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [11583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [11585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5270),
  [11587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [11589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [11591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [11593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [11595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1681),
  [11597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [11599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5262),
  [11601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [11603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [11605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1844),
  [11607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1767),
  [11609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [11613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [11615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [11617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [11621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [11623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8101),
  [11625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [11627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7960),
  [11629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [11631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7837),
  [11633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 68),
  [11635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7344),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [11639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8322),
  [11641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [11643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7822),
  [11645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [11647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7920),
  [11649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [11651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [11653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7237),
  [11655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [11657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7850),
  [11659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 58),
  [11661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7650),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [11667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7249),
  [11669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7674),
  [11671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [11673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [11675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7821),
  [11677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7530),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8717),
  [11681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7347),
  [11683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [11685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7184),
  [11687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4242),
  [11689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7394),
  [11691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7229),
  [11693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7152),
  [11695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [11697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8467),
  [11701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [11703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8058),
  [11705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7775),
  [11707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7357),
  [11709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [11711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7954),
  [11713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [11715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8165),
  [11717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7299),
  [11719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7752),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8301),
  [11723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [11725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [11727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8099),
  [11729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4457),
  [11731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8173),
  [11733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7620),
  [11735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [11737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [11739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8145),
  [11741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [11743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8179),
  [11745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [11747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7874),
  [11749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [11751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8155),
  [11753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [11755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8123),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [11763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(6852),
  [11766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [11772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [11774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [11780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [11782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [11788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [11790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [11792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [11794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [11796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [11798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [11800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [11802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [11804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 23),
  [11806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 59),
  [11808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 60),
  [11810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [11812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 59),
  [11814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [11816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [11818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [11820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [11822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 23),
  [11824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7482),
  [11827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7889),
  [11841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6517),
  [11844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [11846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [11848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [11850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [11852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [11854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [11856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [11860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [11862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7404),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [11874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [11878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [11882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [11884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [11886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [11888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(7117),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [11893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7694),
  [11895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [11919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1666),
  [11922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [11924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(8306),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [11939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7511),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [11943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 4, 0, 0),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [11959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 3, 0, 0),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [11973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [11979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [11987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 184),
  [11989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 184),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [11999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 81),
  [12001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 81),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [12011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [12029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 131),
  [12031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 131),
  [12033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 81),
  [12035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 81),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [12047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 82),
  [12049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 82),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [12055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [12057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [12059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 132),
  [12061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 132),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [12085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7836),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [12089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8074),
  [12091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7907),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [12115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 2, 0, 0),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [12123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 206),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [12127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [12129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 167),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [12141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7799),
  [12143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195), SHIFT_REPEAT(6146),
  [12146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195),
  [12148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 195),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [12154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [12156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8479),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [12162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0),
  [12164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_name_repeat1, 2, 0, 0), SHIFT_REPEAT(8791),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [12169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_name, 1, 0, 0),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [12175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7845),
  [12177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [12193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [12195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [12203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 120), SHIFT_REPEAT(5998),
  [12206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 120),
  [12208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 120),
  [12210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [12212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [12214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [12216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [12218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [12220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8020),
  [12222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8014),
  [12224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [12226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [12228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [12230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 141),
  [12232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [12234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 90),
  [12236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 2, 0, 90),
  [12238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [12240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [12242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [12244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [12246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [12248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [12250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [12252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [12254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [12256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [12258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [12260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8254),
  [12262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [12264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [12266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7155),
  [12268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7155),
  [12270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [12272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [12274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [12276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [12278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3691),
  [12280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [12282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7278),
  [12284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8016),
  [12288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [12290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [12292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [12294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7271),
  [12296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [12298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9022),
  [12300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [12302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 6, 0, 213),
  [12304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [12306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 33),
  [12308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [12310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [12312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [12314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [12316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [12318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [12320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [12322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7186),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [12326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [12330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7311),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [12334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7051),
  [12338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3800),
  [12340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [12348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [12352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7318),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [12356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7864),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8175),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [12370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 216),
  [12376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 216),
  [12378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4213),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [12382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7219),
  [12384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [12388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [12392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9093),
  [12394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [12396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4218),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [12402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8759),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [12412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [12416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 221), SHIFT_REPEAT(6857),
  [12419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 221),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [12423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 203),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [12427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 203),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [12431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9117),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [12435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 222),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [12439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2858),
  [12441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 162),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [12449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 94),
  [12451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 162),
  [12453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [12457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [12461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [12463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [12469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [12473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [12475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8663),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [12479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [12483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [12485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6418),
  [12487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [12489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7271),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7978),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [12502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [12504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7278),
  [12507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7278),
  [12510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4888),
  [12512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [12514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [12516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7351),
  [12518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [12520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7298),
  [12524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7298),
  [12526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7346),
  [12530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7346),
  [12532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [12536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7364),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [12540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [12542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 221), SHIFT_REPEAT(6889),
  [12545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 221),
  [12547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 229),
  [12549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [12551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [12559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8794),
  [12561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7097),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [12573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4171),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [12577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7324),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [12581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [12583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5986),
  [12585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 233), SHIFT_REPEAT(6332),
  [12588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 233),
  [12590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4479),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [12594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [12596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2478),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [12602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [12604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [12614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [12616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [12620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7336),
  [12622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7480),
  [12626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [12628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [12634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [12636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [12638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7349),
  [12640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [12646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [12648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [12650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [12652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [12654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3186),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [12658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [12664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [12666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [12668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [12670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [12674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7151),
  [12676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [12678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [12680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [12682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8711),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [12686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [12690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7247),
  [12692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [12696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4440),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8096),
  [12702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [12704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [12708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7312),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [12716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(6128),
  [12719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [12743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [12761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3986),
  [12764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [12768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5046),
  [12776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 23),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [12784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7303),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4633),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [12796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7281),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [12802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 68),
  [12804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1379),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [12809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8327),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8328),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [12831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7772),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [12881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7340),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9049),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9050),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9051),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [12917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8079),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [12937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [12947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 98),
  [12949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 162),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8524),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8529),
  [12957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7218),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [12961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7717),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [12977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [12979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [12985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [12989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8007),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [13001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [13003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6100),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [13016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 59),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8562),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [13060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 61),
  [13062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 215),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7726),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [13086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6472),
  [13089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [13091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [13093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [13101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [13105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [13107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [13111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [13115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [13119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [13123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [13127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [13129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [13133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [13135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [13137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7570),
  [13140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [13142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [13154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [13164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1333),
  [13167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [13169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 103),
  [13171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [13173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [13175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [13177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [13179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [13181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1896),
  [13184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [13220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 228),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [13226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 58),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [13252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8422),
  [13255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [13259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 162),
  [13261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [13263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 120), SHIFT_REPEAT(5528),
  [13266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 120),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8889),
  [13274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 230),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7833),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [13320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7350),
  [13322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(4042),
  [13325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [13327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [13329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [13331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [13333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 228),
  [13335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 222),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [13339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5930),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [13348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 234),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [13354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [13362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 236), SHIFT_REPEAT(8889),
  [13365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 236),
  [13367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 4, 0, 68),
  [13369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 237),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [13377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 237),
  [13379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [13381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [13385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [13395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1278),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [13404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(8218),
  [13407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [13413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [13417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [13419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [13425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [13431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [13433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [13435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1047),
  [13438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [13470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1409),
  [13473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [13481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [13484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8031),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [13516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [13534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [13540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [13542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [13544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7314),
  [13546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [13550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [13556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [13558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, 0, 70),
  [13560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 152),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [13566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [13568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8108),
  [13570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [13572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [13574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8643),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [13578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8788),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [13582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8490),
  [13584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [13590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [13592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [13594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [13596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [13598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8313),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8846),
  [13602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7923),
  [13606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 103),
  [13608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [13612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8360),
  [13614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [13622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8737),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [13628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_parameter_pack_expansion, 2, 0, 28),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [13636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8672),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [13644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8293),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [13650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 94),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7642),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [13656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [13658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9107),
  [13660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [13662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7473),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [13670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8624),
  [13672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_partition, 2, 0, 0),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9003),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [13688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9004),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7723),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9094),
  [13696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [13706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [13712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8468),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [13718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8640),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [13724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8150),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7858),
  [13730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 7, 0, 213),
  [13732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 5, 0, 141),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [13736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 166),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [13740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 59),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8174),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [13748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8908),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [13758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [13762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 230),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [13766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9142),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [13782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9148),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8903),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9151),
  [13798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [13802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9154),
  [13804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8941),
  [13806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9156),
  [13808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [13810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [13812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8961),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9158),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [13818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9159),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9160),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8973),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9161),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9162),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9163),
  [13836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8979),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9164),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [13842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9165),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9166),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [13850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9081),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9026),
  [13874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 81),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [13884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 82),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9014),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [13894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 82),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [13904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 82),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9097),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9098),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9110),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [13940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [13944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [13956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [13972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [13974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [13976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [13978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 132),
  [13980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [13982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [13986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [13988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [13990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [13992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [13994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8290),
  [13998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [14000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9102),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [14006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [14008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [14014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [14018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [14020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8361),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [14040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [14042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [14050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [14052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [14054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [14056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [14058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [14060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [14062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [14066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [14068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [14070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [14072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [14074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [14076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8483),
  [14086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [14096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [14108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 82),
  [14110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [14114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [14124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [14132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8744),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [14140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [14142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [14144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [14148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9002),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9023),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [14162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [14168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [14170] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [14174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8506),
  [14176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9056),
  [14178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [14182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [14184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [14186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9066),
  [14188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [14190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [14192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [14194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [14196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [14198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [14200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [14202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [14204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [14206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [14208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [14210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [14212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [14214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [14216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [14218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 131),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [14228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [14230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 132),
  [14232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [14234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [14240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [14242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [14244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [14246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [14248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [14250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [14254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [14256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [14258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8418),
  [14262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [14264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [14266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [14270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [14272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [14274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [14276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [14280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [14282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [14288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [14290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [14292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [14296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [14298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9065),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [14302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [14304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [14306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [14308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [14312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [14314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [14316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [14320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [14322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [14324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [14328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [14330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [14332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [14334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8298),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [14342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8429),
  [14344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [14346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8423),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [14354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [14356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [14358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [14362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8558),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [14388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8747),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8751),
  [14402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8782),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8813),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8905),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8944),
  [14426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9001),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7827),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9017),
  [14444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [14458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 6, 0, 23),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [14462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [14466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [14468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [14472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [14478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [14484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 184),
  [14486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8690),
  [14490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 131),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9086),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [14520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [14522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 131),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [14526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [14532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [14534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [14538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [14546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 132),
  [14548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [14550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [14552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 132),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [14558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [14576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8703),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [14583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 131),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [14603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 132),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8814),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8829),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [14691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [14693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [14695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [14697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 82),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [14703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [14705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 7, 0, 59),
  [14707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [14709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 184),
  [14711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [14713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [14715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [14717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [14719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [14721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [14723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 184),
  [14725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [14727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [14729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [14739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [14743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 184),
  [14745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [14747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [14753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9131),
  [14755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [14757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [14759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [14761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [14763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9149),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [14781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8278),
  [14783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [14785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [14787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [14789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [14791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [14793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [14795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [14797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [14799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [14801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8005),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [14805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8357),
  [14807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [14809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [14811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [14813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8841),
  [14815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [14817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [14819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [14823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [14825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8178),
  [14827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8028),
  [14829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [14831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [14833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [14837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [14839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [14849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [14857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_declarator, 5, 0, 0),
  [14859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [14861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8460),
  [14863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [14869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9092),
  [14875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8545),
  [14879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [14881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [14883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7041),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [14915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [14925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [14927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [14931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [14933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8544),
  [14939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [14941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [14943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [14949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [14951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [14953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [14959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [14961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [14963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8605),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [14971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8609),
  [14973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [14975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [14977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [14983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [14993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [14999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [15001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [15027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [15029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6012),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8569),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [15069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [15073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [15077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [15081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [15087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [15089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [15093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [15095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [15099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [15101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 184),
  [15103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [15107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [15109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [15111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [15119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [15121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 55),
  [15123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [15125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [15127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [15139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [15141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [15143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [15145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [15147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [15149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [15151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8936),
  [15153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [15155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [15161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [15165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8887),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [15175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8902),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7320),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8909),
  [15187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [15191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8922),
  [15195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [15201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [15203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7326),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [15215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [15219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [15223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [15227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [15231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [15233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [15235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [15237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [15239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [15241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [15243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8978),
  [15245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [15247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8980),
  [15249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8982),
  [15251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [15253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8984),
  [15255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [15257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9009),
  [15259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [15263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9084),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8796),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [15269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8787),
  [15273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9105),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9122),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9124),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9126),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9128),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9130),
  [15297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [15301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9136),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [15305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [15307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 131),
  [15309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [15315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [15325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_hlsl_external_scanner_create(void);
void tree_sitter_hlsl_external_scanner_destroy(void *);
bool tree_sitter_hlsl_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_hlsl_external_scanner_serialize(void *, char *);
void tree_sitter_hlsl_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_hlsl(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_hlsl_external_scanner_create,
      tree_sitter_hlsl_external_scanner_destroy,
      tree_sitter_hlsl_external_scanner_scan,
      tree_sitter_hlsl_external_scanner_serialize,
      tree_sitter_hlsl_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
